/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayerDescription } from "./AnnotationLayerDescription";
import { markType } from "./type";
/**
 * @hidden
 */
export let CalloutLayerDescription = /*@__PURE__*/ (() => {
    class CalloutLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.dz = null;
            this.d3 = null;
            this.d4 = null;
            this.dy = null;
            this.cz = false;
            this.dx = null;
            this.d0 = null;
            this.d1 = null;
            this.dw = null;
            this.cy = false;
            this.c1 = false;
            this.c0 = false;
            this.di = 0;
            this.dv = null;
            this.dm = null;
            this.dj = 0;
            this.ds = null;
            this.dr = null;
            this.c7 = 0;
            this.c9 = 0;
            this.c8 = 0;
            this.c6 = 0;
            this.dn = null;
            this.da = 0;
            this.db = 0;
            this.d2 = null;
            this.du = null;
            this.dp = null;
            this.dq = null;
            this.dt = null;
        }
        get_type() {
            return "CalloutLayer";
        }
        get labelMemberPath() {
            return this.dz;
        }
        set labelMemberPath(a) {
            this.dz = a;
            this.e("LabelMemberPath");
        }
        get xMemberPath() {
            return this.d3;
        }
        set xMemberPath(a) {
            this.d3 = a;
            this.e("XMemberPath");
        }
        get yMemberPath() {
            return this.d4;
        }
        set yMemberPath(a) {
            this.d4 = a;
            this.e("YMemberPath");
        }
        get keyMemberPath() {
            return this.dy;
        }
        set keyMemberPath(a) {
            this.dy = a;
            this.e("KeyMemberPath");
        }
        get isCalloutOffsettingEnabled() {
            return this.cz;
        }
        set isCalloutOffsettingEnabled(a) {
            this.cz = a;
            this.e("IsCalloutOffsettingEnabled");
        }
        get contentMemberPath() {
            return this.dx;
        }
        set contentMemberPath(a) {
            this.dx = a;
            this.e("ContentMemberPath");
        }
        get targetSeriesName() {
            return this.d0;
        }
        set targetSeriesName(a) {
            this.d0 = a;
            this.e("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.d1;
        }
        set targetSeriesRef(a) {
            this.d1 = a;
            this.e("TargetSeriesRef");
        }
        get collisionChannel() {
            return this.dw;
        }
        set collisionChannel(a) {
            this.dw = a;
            this.e("CollisionChannel");
        }
        get isAutoCalloutBehaviorEnabled() {
            return this.cy;
        }
        set isAutoCalloutBehaviorEnabled(a) {
            this.cy = a;
            this.e("IsAutoCalloutBehaviorEnabled");
        }
        get useValueForAutoCalloutLabels() {
            return this.c1;
        }
        set useValueForAutoCalloutLabels(a) {
            this.c1 = a;
            this.e("UseValueForAutoCalloutLabels");
        }
        get isCustomCalloutStyleEnabled() {
            return this.c0;
        }
        set isCustomCalloutStyleEnabled(a) {
            this.c0 = a;
            this.e("IsCustomCalloutStyleEnabled");
        }
        get autoCalloutLabelPrecision() {
            return this.di;
        }
        set autoCalloutLabelPrecision(a) {
            this.di = a;
            this.e("AutoCalloutLabelPrecision");
        }
        get calloutTextColor() {
            return this.dv;
        }
        set calloutTextColor(a) {
            this.dv = a;
            this.e("CalloutTextColor");
        }
        get calloutBackground() {
            return this.dm;
        }
        set calloutBackground(a) {
            this.dm = a;
            this.e("CalloutBackground");
        }
        get calloutInterpolatedValuePrecision() {
            return this.dj;
        }
        set calloutInterpolatedValuePrecision(a) {
            this.dj = a;
            this.e("CalloutInterpolatedValuePrecision");
        }
        get calloutOutline() {
            return this.ds;
        }
        set calloutOutline(a) {
            this.ds = a;
            this.e("CalloutOutline");
        }
        get calloutLeaderBrush() {
            return this.dr;
        }
        set calloutLeaderBrush(a) {
            this.dr = a;
            this.e("CalloutLeaderBrush");
        }
        get calloutPaddingLeft() {
            return this.c7;
        }
        set calloutPaddingLeft(a) {
            this.c7 = a;
            this.e("CalloutPaddingLeft");
        }
        get calloutPaddingTop() {
            return this.c9;
        }
        set calloutPaddingTop(a) {
            this.c9 = a;
            this.e("CalloutPaddingTop");
        }
        get calloutPaddingRight() {
            return this.c8;
        }
        set calloutPaddingRight(a) {
            this.c8 = a;
            this.e("CalloutPaddingRight");
        }
        get calloutPaddingBottom() {
            return this.c6;
        }
        set calloutPaddingBottom(a) {
            this.c6 = a;
            this.e("CalloutPaddingBottom");
        }
        get calloutCollisionMode() {
            return this.dn;
        }
        set calloutCollisionMode(a) {
            this.dn = a;
            this.e("CalloutCollisionMode");
        }
        get calloutPositionPadding() {
            return this.da;
        }
        set calloutPositionPadding(a) {
            this.da = a;
            this.e("CalloutPositionPadding");
        }
        get calloutStrokeThickness() {
            return this.db;
        }
        set calloutStrokeThickness(a) {
            this.db = a;
            this.e("CalloutStrokeThickness");
        }
        get textStyle() {
            return this.d2;
        }
        set textStyle(a) {
            this.d2 = a;
            this.e("TextStyle");
        }
        get calloutStyleUpdatingRef() {
            return this.du;
        }
        set calloutStyleUpdatingRef(a) {
            this.du = a;
            this.e("CalloutStyleUpdatingRef");
        }
        get calloutContentUpdatingRef() {
            return this.dp;
        }
        set calloutContentUpdatingRef(a) {
            this.dp = a;
            this.e("CalloutContentUpdatingRef");
        }
        get calloutLabelUpdatingRef() {
            return this.dq;
        }
        set calloutLabelUpdatingRef(a) {
            this.dq = a;
            this.e("CalloutLabelUpdatingRef");
        }
        get calloutSeriesSelectingRef() {
            return this.dt;
        }
        set calloutSeriesSelectingRef(a) {
            this.dt = a;
            this.e("CalloutSeriesSelectingRef");
        }
    }
    CalloutLayerDescription.$t = /*@__PURE__*/ markType(CalloutLayerDescription, 'CalloutLayerDescription', AnnotationLayerDescription.$);
    return CalloutLayerDescription;
})();
//# sourceMappingURL=CalloutLayerDescription.js.map
