/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayerDescription } from "./AnnotationLayerDescription";
import { markType } from "./type";
/**
 * @hidden
 */
export let CrosshairLayerDescription = /*@__PURE__*/ (() => {
    class CrosshairLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.dt = null;
            this.dx = null;
            this.dv = null;
            this.dw = null;
            this.c0 = false;
            this.cy = false;
            this.d1 = null;
            this.dz = null;
            this.dp = 0;
            this.d0 = null;
            this.c5 = 0;
            this.c7 = 0;
            this.c6 = 0;
            this.c4 = 0;
            this.da = 0;
            this.dc = 0;
            this.db = 0;
            this.c9 = 0;
            this.c8 = 0;
            this.d4 = null;
            this.d2 = null;
            this.dq = 0;
            this.d3 = null;
            this.dd = 0;
            this.dy = null;
            this.du = null;
            this.cz = false;
        }
        get_type() {
            return "CrosshairLayer";
        }
        get horizontalLineStroke() {
            return this.dt;
        }
        set horizontalLineStroke(a) {
            this.dt = a;
            this.e("HorizontalLineStroke");
        }
        get verticalLineStroke() {
            return this.dx;
        }
        set verticalLineStroke(a) {
            this.dx = a;
            this.e("VerticalLineStroke");
        }
        get targetSeriesName() {
            return this.dv;
        }
        set targetSeriesName(a) {
            this.dv = a;
            this.e("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.dw;
        }
        set targetSeriesRef(a) {
            this.dw = a;
            this.e("TargetSeriesRef");
        }
        get useInterpolation() {
            return this.c0;
        }
        set useInterpolation(a) {
            this.c0 = a;
            this.e("UseInterpolation");
        }
        get isAxisAnnotationEnabled() {
            return this.cy;
        }
        set isAxisAnnotationEnabled(a) {
            this.cy = a;
            this.e("IsAxisAnnotationEnabled");
        }
        get xAxisAnnotationTextColor() {
            return this.d1;
        }
        set xAxisAnnotationTextColor(a) {
            this.d1 = a;
            this.e("XAxisAnnotationTextColor");
        }
        get xAxisAnnotationBackground() {
            return this.dz;
        }
        set xAxisAnnotationBackground(a) {
            this.dz = a;
            this.e("XAxisAnnotationBackground");
        }
        get xAxisAnnotationInterpolatedValuePrecision() {
            return this.dp;
        }
        set xAxisAnnotationInterpolatedValuePrecision(a) {
            this.dp = a;
            this.e("XAxisAnnotationInterpolatedValuePrecision");
        }
        get xAxisAnnotationOutline() {
            return this.d0;
        }
        set xAxisAnnotationOutline(a) {
            this.d0 = a;
            this.e("XAxisAnnotationOutline");
        }
        get xAxisAnnotationPaddingLeft() {
            return this.c5;
        }
        set xAxisAnnotationPaddingLeft(a) {
            this.c5 = a;
            this.e("XAxisAnnotationPaddingLeft");
        }
        get xAxisAnnotationPaddingTop() {
            return this.c7;
        }
        set xAxisAnnotationPaddingTop(a) {
            this.c7 = a;
            this.e("XAxisAnnotationPaddingTop");
        }
        get xAxisAnnotationPaddingRight() {
            return this.c6;
        }
        set xAxisAnnotationPaddingRight(a) {
            this.c6 = a;
            this.e("XAxisAnnotationPaddingRight");
        }
        get xAxisAnnotationPaddingBottom() {
            return this.c4;
        }
        set xAxisAnnotationPaddingBottom(a) {
            this.c4 = a;
            this.e("XAxisAnnotationPaddingBottom");
        }
        get yAxisAnnotationPaddingLeft() {
            return this.da;
        }
        set yAxisAnnotationPaddingLeft(a) {
            this.da = a;
            this.e("YAxisAnnotationPaddingLeft");
        }
        get yAxisAnnotationPaddingTop() {
            return this.dc;
        }
        set yAxisAnnotationPaddingTop(a) {
            this.dc = a;
            this.e("YAxisAnnotationPaddingTop");
        }
        get yAxisAnnotationPaddingRight() {
            return this.db;
        }
        set yAxisAnnotationPaddingRight(a) {
            this.db = a;
            this.e("YAxisAnnotationPaddingRight");
        }
        get yAxisAnnotationPaddingBottom() {
            return this.c9;
        }
        set yAxisAnnotationPaddingBottom(a) {
            this.c9 = a;
            this.e("YAxisAnnotationPaddingBottom");
        }
        get xAxisAnnotationStrokeThickness() {
            return this.c8;
        }
        set xAxisAnnotationStrokeThickness(a) {
            this.c8 = a;
            this.e("XAxisAnnotationStrokeThickness");
        }
        get yAxisAnnotationTextColor() {
            return this.d4;
        }
        set yAxisAnnotationTextColor(a) {
            this.d4 = a;
            this.e("YAxisAnnotationTextColor");
        }
        get yAxisAnnotationBackground() {
            return this.d2;
        }
        set yAxisAnnotationBackground(a) {
            this.d2 = a;
            this.e("YAxisAnnotationBackground");
        }
        get yAxisAnnotationInterpolatedValuePrecision() {
            return this.dq;
        }
        set yAxisAnnotationInterpolatedValuePrecision(a) {
            this.dq = a;
            this.e("YAxisAnnotationInterpolatedValuePrecision");
        }
        get yAxisAnnotationOutline() {
            return this.d3;
        }
        set yAxisAnnotationOutline(a) {
            this.d3 = a;
            this.e("YAxisAnnotationOutline");
        }
        get yAxisAnnotationStrokeThickness() {
            return this.dd;
        }
        set yAxisAnnotationStrokeThickness(a) {
            this.dd = a;
            this.e("YAxisAnnotationStrokeThickness");
        }
        get verticalLineVisibility() {
            return this.dy;
        }
        set verticalLineVisibility(a) {
            this.dy = a;
            this.e("VerticalLineVisibility");
        }
        get horizontalLineVisibility() {
            return this.du;
        }
        set horizontalLineVisibility(a) {
            this.du = a;
            this.e("HorizontalLineVisibility");
        }
        get skipUnknownValues() {
            return this.cz;
        }
        set skipUnknownValues(a) {
            this.cz = a;
            this.e("SkipUnknownValues");
        }
    }
    CrosshairLayerDescription.$t = /*@__PURE__*/ markType(CrosshairLayerDescription, 'CrosshairLayerDescription', AnnotationLayerDescription.$);
    return CrosshairLayerDescription;
})();
//# sourceMappingURL=CrosshairLayerDescription.js.map
