/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, Array_$type, Number_$type, fromEnum, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
import { TransactionType, TransactionType_$type } from "./TransactionType";
import { ISupportsExpansionChangeNotifications_$type } from "./ISupportsExpansionChangeNotifications";
/**
 * @hidden
 */
export let LocalDataSource = /*@__PURE__*/ (() => {
    class LocalDataSource extends BaseDataSource {
        constructor() {
            super();
            this.cv = null;
            this.cu = null;
            this.dv = null;
            this.c0 = null;
            this.c4 = null;
            this.c6 = null;
            this.c2 = null;
            this.dg = new List$1(Array_$type, 0);
            this.c7 = false;
            this.ct = null;
            this.dp = -1;
            this.dh = -1;
            this.dr = -1;
            this.dj = -1;
            this.ds = -1;
            this.dk = -1;
            this.dq = -1;
            this.di = -1;
            this.du = -1;
            this.dt = -1;
            this.dm = -1;
            this.dl = -1;
            this.dn = -1;
            this.executionContext = new DataSourceExecutionContext();
            this.u.l = false;
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cv;
        }
        set dataProvider(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.onPropertyUpdated("DataProvider", b, this.cv);
            }
        }
        get actualDataProvider() {
            if (this.cu == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.cu;
        }
        set actualDataProvider(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.onPropertyUpdated("ActualDataProvider", b, this.cu);
            }
        }
        get dataSource() {
            return this.dv;
        }
        set dataSource(a) {
            let b = this.dv;
            this.dv = a;
            if (b != this.dv) {
                this.onPropertyUpdated("ItemsSource", b, this.dv);
            }
        }
        canInitialize() {
            let a = super.canInitialize();
            if (!a) {
                return false;
            }
            return this.dataSource != null;
        }
        get c1() {
            return this.c0;
        }
        set c1(a) {
            this.c0 = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            let provider_ = new DataSourceLocalDataProvider();
            provider_.executionContext = new DataSourceExecutionContext();
            return provider_;
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    break;
                case "ActualDataProvider":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
                case "ItemsSource":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        getItemAtIndex(a) {
            if (this.c4 != null && this.c4.a6 != null) {
                return this.c4.a6.item(a);
            }
            else {
                return this.actualDataProvider.getItemAtIndex(a);
            }
        }
        getItemFromKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return a[0];
            }
            let c = this.c3();
            let d;
            if (this.c4 != null) {
                let e = this.c4.a6.count;
                for (let f = 0; f < e; f++) {
                    d = this.c4.a6.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return d;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return d;
                    }
                }
                return null;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                let h = this.actualDataProvider.indexOfKey(a);
                return this.actualDataProvider.getItemAtIndex(h);
            }
            if (this.actualDataProvider != null) {
                let i = this.actualDataProvider.actualCount;
                for (let j = 0; j < i; j++) {
                    d = this.actualDataProvider.getItemAtIndex(j);
                    if (c.i(d, a) == 0) {
                        return d;
                    }
                }
            }
            return null;
        }
        getItemPropertyAtIndex(a, b) {
            let c;
            if (this.c4 != null) {
                c = this.c4.a6.item(a);
            }
            else {
                c = this.actualDataProvider.getItemAtIndex(a);
            }
            let item_ = c;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return this.getSpecialRowItemValue(c, b);
            }
            if (this.ap()) {
                let d = this.am(c, b);
                if (d) {
                    let e = this.a0(c, b);
                    return e;
                }
            }
            return this.actualDataProvider.getItemValue(c, b);
        }
        cz() {
            return this.actualDataProvider;
        }
        c9() {
            return this.dg != null && this.dg.count > 0;
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            if (this.actualDataProvider != null) {
                if (this.da() || this.db() || this.dc() || this.dd() || this.c9()) {
                    if (this.c4 == null) {
                        if (this.c6 == null) {
                            this.c6 = new LocalDataSourceViewUpdateNotifier(this);
                        }
                        this.c4 = new RearrangedListView(this.actualDataProvider);
                        this.c4.ab = this.c6;
                        this.c4.ad = new LocalDataSourceViewExpansionNotifier(this);
                    }
                    this.ensureComparables(this.actualDataProvider.actualSchema);
                    this.c4.av = this.shouldEmitSectionHeaders && this.ao;
                    this.c4.au = this.shouldEmitSectionFooters && this.ao;
                    this.c4.aw = this.shouldEmitShiftedRows;
                    this.c4.cb(this.dg);
                    this.c4.a2 = this.df();
                    this.c4.a1 = this.de();
                    this.c4.p = this.c3();
                    this.c4.ae = this.groupDescriptions;
                    this.c4.af = this.sortDescriptions;
                    this.c4.ag = this.summaryDescriptions;
                    this.c4.l = this.summaryScope;
                    this.c4.am = this.includeSummaryRowsInSection;
                    this.c4.as = this.isSectionSummaryRowsAtBottom;
                    this.c4.j = this.sectionHeaderDisplayMode;
                    this.c4.m = this;
                    this.c4.ap = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                    this.c4.t = this.c5();
                    this.c4.b6();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.c4.a6.count;
                }
                else {
                    let a = this.cz();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    if (a != null) {
                        this.actualCount = a.actualCount;
                    }
                    else {
                        this.actualCount = 0;
                    }
                    if (this.c4 != null) {
                        this.c4.ab = null;
                        this.c4 = null;
                        this.onBroadcastClearItems();
                    }
                }
            }
            else {
                this.actualCount = 0;
                this.actualSchema = null;
            }
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            if (this.c4 != null) {
                return this.c4.a6.indexOf(a);
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            if (this.actualDataProvider != null) {
                let b = this.actualDataProvider.actualCount;
                let c;
                for (let d = 0; d < b; d++) {
                    c = this.actualDataProvider.getItemAtIndex(d);
                    if (this.c8(c, a)) {
                        return d;
                    }
                }
            }
            return -1;
        }
        c8(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return this.indexOfItem(a[0]);
            }
            let c = this.c3();
            let d;
            if (this.c4 != null) {
                let e = this.c4.a6.count;
                for (let f = 0; f < e; f++) {
                    d = this.c4.a6.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return f;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return f;
                    }
                }
                return -1;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            if (this.actualDataProvider != null) {
                let h = this.actualDataProvider.actualCount;
                for (let i = 0; i < h; i++) {
                    d = this.actualDataProvider.getItemAtIndex(i);
                    if (c.i(d, a) == 0) {
                        return i;
                    }
                }
            }
            return -1;
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
            super.onActualPrimaryKeyChangedOverrride(a, b);
            this.c2 = null;
        }
        c3() {
            if (this.c2 != null) {
                return this.c2;
            }
            if (this.actualPrimaryKey == null) {
                this.c2 = new DataSourcePropertiesComparer(null, null, null, this);
                return this.c2;
            }
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            this.c2 = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
            return this.c2;
        }
        c5() {
            if (this.filterExpressions.j.count == 0) {
                return null;
            }
            let a = this.actualDataProvider;
            let b = this.actualDataProvider.actualSchema;
            let c = this.filterExpressions.j;
            let d = (e) => {
                for (let f = 0; f < c.count; f++) {
                    if (!c.item(f).match(e, a, b)) {
                        return false;
                    }
                }
                return true;
            };
            return d;
        }
        df() {
            let a = 0;
            if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
                return null;
            }
            a = this.sortDescriptions.k.count;
            if (this.groupDescriptions != null) {
                a += this.groupDescriptions.k.count;
            }
            let b = new Array(a);
            let c = new Array(a);
            let d = 0;
            if (this.groupDescriptions != null) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    b[e] = this.groupDescriptions.k.item(e).propertyName;
                    c[e] = this.groupDescriptions.k.item(e).direction;
                    d++;
                }
            }
            for (let f = 0; f < this.sortDescriptions.k.count; f++) {
                b[f + d] = this.sortDescriptions.k.item(f).propertyName;
                c[f + d] = this.sortDescriptions.k.item(f).direction;
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        de() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return null;
            }
            let a = 0;
            a = this.groupDescriptions.k.count;
            let b = new Array(a);
            let c = new Array(a);
            if (this.groupDescriptions != null) {
                for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                    b[d] = this.groupDescriptions.k.item(d).propertyName;
                    c[d] = this.groupDescriptions.k.item(d).direction;
                }
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        db() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isGroupingSupported) {
                return false;
            }
            return true;
        }
        dc() {
            if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isSortingSupported) {
                return false;
            }
            return true;
        }
        da() {
            return this.filterExpressions != null && this.filterExpressions.j.count > 0;
        }
        dd() {
            if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
                return false;
            }
            return true;
        }
        onClearItemsOverride() {
            if (this.c4 != null) {
                this.c4.notifyClearItems();
                this.queueAutoRefresh();
            }
            else {
                super.onClearItemsOverride();
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.c4 != null) {
                this.c4.notifySetItem(a, b, c);
            }
            else {
                super.onSetItemOverride(a, b, c);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.c4 != null) {
                this.c4.notifyInsertItem(a, b);
            }
            else {
                super.onInsertItemOverride(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.c4 != null) {
                this.c4.notifyRemoveItem(a, b);
            }
            else {
                super.onRemoveItemOverride(a, b);
            }
        }
        d0() {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastClearItems();
        }
        d3(a, b, c) {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastSetItem(a, b, c);
        }
        d1(a, b) {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastInsertItem(a, b);
        }
        d2(a, b) {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastRemoveItem(a, b);
        }
        pinRow(a) {
            super.pinRow(a);
            this.dp = -1;
            this.dh = -1;
            if (this.c4 != null) {
                this.dg.add(a);
                this.c4.b5(a);
            }
            else {
                this.dg.add(a);
                this.queueAutoRefresh();
            }
        }
        unpinRow(a) {
            super.unpinRow(a);
            let b = this.c3();
            if (this.c4 != null) {
                for (let c = this.dg.count - 1; c >= 0; c--) {
                    let d = this.dg._inner[c];
                    if (d.length != a.length) {
                        continue;
                    }
                    if (b.h(d, a) == 0) {
                        this.dg.removeAt(c);
                        this.c4.cc(d);
                    }
                }
            }
            else {
                for (let e = this.dg.count - 1; e >= 0; e--) {
                    let f = this.dg._inner[e];
                    if (f.length != a.length) {
                        continue;
                    }
                    if (b.h(f, a) == 0) {
                        this.dg.removeAt(e);
                    }
                }
                this.queueAutoRefresh();
            }
            this.dp = -1;
            this.dh = -1;
        }
        clearPinnedRows() {
            for (let a = this.dg.count - 1; a >= 0; a--) {
                this.unpinRow(this.dg._inner[a]);
            }
        }
        isRowPinned(a) {
            if (this.c4 == null) {
                return false;
            }
            let b = this.getItemAtIndex(a);
            if (b == null) {
                return false;
            }
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                if (item_.rowType == 3) {
                    return true;
                }
            }
            let c = this.c3();
            let d;
            if (this.actualPrimaryKey == null) {
                d = new Array(1);
                d[0] = b;
            }
            else {
                let e = this.actualPrimaryKey;
                let f = e.length;
                d = new Array(f);
                for (let g = 0; g < f; g++) {
                    d[g] = this.getItemProperty(b, e[g]);
                }
            }
            for (let h = 0; h < this.dg.count; h++) {
                if (c.h(this.dg._inner[h], d) == 0) {
                    return true;
                }
            }
            return false;
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.c7) {
                this.c7 = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.c7 = false;
                return a;
            }
            return true;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.c7) {
                this.c7 = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.c7 = false;
                return a;
            }
            return true;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.c7) {
                this.c7 = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.c7 = false;
                return a;
            }
            return true;
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        getStickyRowsInRange(a, b) {
            if (this.c4 == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.c9())) {
                return null;
            }
            let c = null;
            let d = null;
            if (this.c4.a5.count == 1) {
                c = this.c4.a5._inner[0];
                d = this.c4.a5._inner[0];
            }
            else {
                c = this.c4.w(a);
                if (c != null) {
                    while (c.z != -1) {
                        c = this.c4.a5._inner[c.z];
                    }
                }
                d = this.c4.w(b);
                if (b >= this.c4.a6.count - this.c4.bk) {
                    d = this.c4.v();
                }
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.dp && c.aa == this.dr && c.af == this.ds && c.ad == this.dq && c.ah == this.du && c.ag == this.dt && d.ae == this.dh && d.aa == this.dj && d.af == this.dk && d.ad == this.di && d.ah == this.dm && d.ag == this.dl && this.c4.bk == this.dn) {
                return this.ct;
            }
            this.dp = c.ae;
            this.dh = d.ae;
            this.dr = c.aa;
            this.dj = d.aa;
            this.ds = c.af;
            this.dk = d.af;
            this.dq = c.ad;
            this.di = d.ad;
            this.du = c.ah;
            this.dt = c.ag;
            this.dm = d.ah;
            this.dl = d.ag;
            this.dn = this.c4.bk;
            if (this.c4.a5.count == 1) {
                this.dh = d.ad;
            }
            let e = 0;
            if (this.shouldEmitSectionHeaders && this.ao) {
                e = 1;
            }
            let f = this.c4.ba();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.c4.a5._inner[h];
                let j = this.c4.a5._inner[h].c.length;
                let k = this.c4.a5._inner[h].v();
                if (this.shouldEmitSectionHeaders && this.ao) {
                    for (let l = 0; l < j; l++) {
                        if (this.c4.a5._inner[h].a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                            if (this.summaryScope == 0 || this.summaryScope == 2) {
                                if (i.c[l] && this.includeSummaryRowsInSection && !this.isSectionSummaryRowsAtBottom) {
                                    for (let n = 0; n < f; n++) {
                                        g.add(m + 1 + n);
                                    }
                                }
                            }
                        }
                        if (!this.c4.a5._inner[h].c[l]) {
                            break;
                        }
                    }
                }
                if (this.c4.a5._inner[h].p) {
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < this.c4.a5._inner[h].aa; o++) {
                            g.add(this.c4.a5._inner[h].af + this.c4.a5._inner[h].ah + o + k);
                        }
                    }
                }
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                        for (let p = this.c4.a5._inner[h].ag - 1; p >= 0; p--) {
                            if (this.shouldEmitSectionFooters) {
                                g.add(this.c4.a5._inner[h].ad - k - p);
                            }
                            else {
                                g.add(this.c4.a5._inner[h].ad - p);
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.ao) {
                    for (let q = j - 1; q >= 0; q--) {
                        if (!this.c4.a5._inner[h].c[q]) {
                            break;
                        }
                        g.add(this.c4.a5._inner[h].ad - q);
                    }
                }
            }
            for (let r = this.c4.a6.count - this.c4.bk; r < this.c4.a6.count; r++) {
                g.add(r);
            }
            this.ct = g.toArray();
            return this.ct;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        setIsRowExpandedAtIndex(a, b) {
            if (this.isSectionCollapsable && this.c4 != null && this.c4.a6.count > 0 && this.c4.a6.count > a) {
                this.c4.ca(a, b);
            }
        }
        getIsRowExpandedAtIndex(a) {
            if (this.c4 != null && this.c4.a6.count > 0 && this.c4.a6.count > a) {
                return this.c4.ak(a);
            }
            return true;
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            if (this.c4 != null) {
                return this.c4.bk;
            }
            return 0;
        }
        getRootSummaryResults() {
            if (this.c4 != null) {
                return this.c4.i;
            }
            return null;
        }
        getSectionSummaryResults(a) {
            if (this.c4 != null && this.c4.a5.count > 0 && a >= 0 && a < this.c4.a5.count) {
                return this.c4.a5._inner[a].i;
            }
            return null;
        }
        clone() {
            let a = new LocalDataSource();
            a.dataSource = this.dataSource;
            super.cloneProperties(a);
            return a;
        }
        ap() {
            return !this.isReadOnly && this.actualBaseDataProvider != null && this.u != null;
        }
        cm(a, b) {
            if (a == 5) {
                let c = new List$1(TransactionType_$type, 0);
                let d = new List$1(Base.$, 0);
                let e = b;
                let f = e.a;
                for (let g = 0; g < f.length; g++) {
                    if (f[g].transactionType == 1) {
                        let h = f[g].id;
                        let i = this.getItemFromKey(h);
                        if (i != null) {
                            let j = f[g].value;
                            let k = this.indexOfItem(i);
                            let l = null;
                            if (this.c4 != null && k > -1) {
                                l = this.c4.w(k);
                                for (let m = 0; m < this.summaryDescriptions.k.count; m++) {
                                    let n = this.summaryDescriptions.k.item(m);
                                    if (n.operand == 5 || j.containsKey(n.propertyName)) {
                                        this.c4.cl(m, k, i, false, l);
                                    }
                                }
                            }
                            for (let o of fromEnum(j)) {
                                this.actualDataProvider.setItemValue(i, o.key, o.value);
                            }
                            if (l != null && this.c4 != null && k > -1) {
                                for (let p = 0; p < this.summaryDescriptions.k.count; p++) {
                                    let q = this.summaryDescriptions.k.item(p);
                                    if (q.operand == 5 || j.containsKey(q.propertyName)) {
                                        this.c4.cl(p, k, i, true, l);
                                    }
                                }
                            }
                            if (k > -1) {
                                this.onBroadcastSetItem(k, i, i);
                            }
                            d.add1(i);
                            c.add(1);
                            if (this.dg.count > 0) {
                                let r = this.c3();
                                for (let s = 0; s < this.dg.count; s++) {
                                    if (r.h(this.dg._inner[s], h) == 0) {
                                        let t = this.getStickyRows();
                                        for (let u = 0; u < t.length; u++) {
                                            let v = t[u];
                                            let w = typeCast(DataSourceSpecialRow.$, this.c4.a6.item(v));
                                            if (w != null && w.rowType == 3 && w.targetRow == i) {
                                                this.onBroadcastSetItem(v, w, w);
                                                break;
                                            }
                                        }
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    else if (f[g].transactionType == TransactionType.Delete) {
                        let x = f[g].id;
                        let y = this.indexOfKey(x);
                        if (y > -1) {
                            let z = this.getItemAtIndex(y);
                            this.actualDataProvider.removeItem(z);
                            this.notifyRemoveItem(y, z);
                            d.add1(z);
                            c.add(TransactionType.Delete);
                        }
                    }
                    else if (f[g].transactionType == 0) {
                        let aa = f[g].id[0];
                        if (f[g].value != null) {
                            let ab = f[g].value;
                            for (let ac of fromEnum(ab)) {
                                this.actualDataProvider.setItemValue(aa, ac.key, ac.value);
                            }
                        }
                        this.actualDataProvider.addItem(aa);
                        d.add1(aa);
                        c.add(0);
                    }
                }
                if (f.length > 0) {
                    this.by(e.id, this.getAggregatedChanges(e.id));
                }
            }
        }
    }
    LocalDataSource.$t = /*@__PURE__*/ markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewUpdateNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewUpdateNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyClearItems() {
            this.a.d0();
        }
        notifyInsertItem(a, b) {
            this.a.d1(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.d2(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.d3(a, b, c);
        }
    }
    LocalDataSourceViewUpdateNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewExpansionNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewExpansionNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyRowExpansionChanged(a, b, c) {
            this.a.onRowExpansionChanged(a, b, c);
        }
    }
    LocalDataSourceViewExpansionNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
})();
//# sourceMappingURL=LocalDataSource_combined.js.map
