/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, String_$type, typeCast, fromEnum, markType } from "./type";
import { ICodeGenerationRendererTemplate_$type } from "./ICodeGenerationRendererTemplate";
import { List$1 } from "./List$1";
import { StringBuilder } from "./StringBuilder";
import { JsonDictionaryParser } from "./JsonDictionaryParser";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { JsonDictionaryArray } from "./JsonDictionaryArray";
import { HashSet$1 } from "./HashSet$1";
import { stringReplace, stringStartsWith } from "./string";
/**
 * @hidden
 */
var CodeGenerationFolderTemplate = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(CodeGenerationFolderTemplate, _super);
    function CodeGenerationFolderTemplate() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = new List$1(String_$type, 0);
        _this.b = new List$1(String_$type, 0);
        _this.c = new List$1(String_$type, 0);
        return _this;
    }
    CodeGenerationFolderTemplate.prototype.i = function (a, b) {
        this.d.add(a);
        this.b.add(b);
    };
    CodeGenerationFolderTemplate.prototype.a = function () {
        return this.d.toArray();
    };
    CodeGenerationFolderTemplate.prototype.e = function (a) {
        for (var b = 0; b < this.d.count; b++) {
            if (this.d._inner[b] == a) {
                return this.c._inner[b];
            }
        }
        return null;
    };
    CodeGenerationFolderTemplate.prototype.h = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("\"files\": [");
        for (var b = 0; b < this.d.count; b++) {
            if (b >= 1) {
                a.u(",");
            }
            a.u("{");
            a.l("\"path\": \"");
            a.l(this.d._inner[b]);
            a.u("\"");
            a.l("\"content\": \"");
            a.l(stringReplace(this.b._inner[b], "\"", "\\\""));
            a.u("\"");
            a.u("}");
        }
        a.u("]");
        a.u("}");
        return a.toString();
    };
    CodeGenerationFolderTemplate.prototype.j = function (a) {
        var b = new JsonDictionaryParser();
        var c = b.parse(a);
        if (typeCast(JsonDictionaryObject.$, c) !== null) {
            var d = c;
            if (d.g("files")) {
                var e = d.item("Files");
                if (typeCast(JsonDictionaryArray.$, e) !== null) {
                    var f = e;
                    for (var g = 0; g < f.items.length; g++) {
                        var h = f.items[g];
                        if (typeCast(JsonDictionaryObject.$, h) !== null) {
                            var i = h;
                            if (i.g("path") && i.g("content")) {
                                this.d.add(i.item("path").value.toString());
                                this.b.add(i.item("content").value.toString());
                            }
                        }
                    }
                }
            }
        }
    };
    CodeGenerationFolderTemplate.prototype.execute = function (a) {
        var e_1, _a, e_2, _b;
        this.c.clear();
        for (var b = 0; b < this.b.count; b++) {
            this.c.add(this.b._inner[b]);
        }
        var c = a.getKeys();
        var d = new HashSet$1(String_$type, 0);
        for (var e = 0; e < c.length; e++) {
            d.add_1(c[e]);
        }
        for (var f = 0; f < this.b.count; f++) {
            var g = this.c._inner[f];
            g = this.f(g, d);
            this.c._inner[f] = g;
        }
        var j = a.getKeys();
        for (var i = 0; i < j.length; i++) {
            var h = j[i];
            for (var k = 0; k < this.b.count; k++) {
                var l = this.c._inner[k];
                var m = a.getContentForKey(h);
                l = this.g(l, h, m);
                this.c._inner[k] = l;
            }
        }
        var p = a.getStringNames();
        for (var o = 0; o < p.length; o++) {
            var n = p[o];
            for (var q = 0; q < this.b.count; q++) {
                var r = this.c._inner[q];
                r = stringReplace(r, "$$" + n, a.getString(n));
                this.c._inner[q] = r;
            }
        }
        try {
            for (var _c = tslib_1.__values(fromEnum(a.getNewFiles())), _d = _c.next(); !_d.done; _d = _c.next()) {
                var s = _d.value;
                var t = a.getNewFileContent(s);
                var u = "";
                try {
                    for (var _e = (e_2 = void 0, tslib_1.__values(fromEnum(this.d))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var v = _f.value;
                        if (stringStartsWith(v, "src")) {
                            u = "src/";
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                this.d.add(u + s);
                this.c.add(t);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    CodeGenerationFolderTemplate.prototype.f = function (a, b) {
        return a;
    };
    CodeGenerationFolderTemplate.prototype.g = function (a, b, c) {
        var d = new RegExp("(?:(<!--)|(\\/\\/))\\s*insert " + b + "(?:(\\s*-->)?)[\\w\\W\\r\\n]*?(?:(<!--)|(\\/\\/))\\s*end " + b + "(?:(\\s*-->)?)\r?\n?");
        return a.replace(d, c);
    };
    CodeGenerationFolderTemplate.$t = markType(CodeGenerationFolderTemplate, 'CodeGenerationFolderTemplate', Base.$, [ICodeGenerationRendererTemplate_$type]);
    return CodeGenerationFolderTemplate;
}(Base));
export { CodeGenerationFolderTemplate };
//# sourceMappingURL=CodeGenerationFolderTemplate.js.map
