import { Description } from "./Description";
import { Type } from "./type";
import { AxisAnnotationDescription } from "./AxisAnnotationDescription";
import { FormatSpecifierDescription } from "./FormatSpecifierDescription";
/**
 * @hidden
 */
export declare abstract class AxisDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private bg;
    formatLabelRef: string;
    private by;
    title: string;
    private bw;
    stroke: string;
    private bd;
    actualStroke: string;
    private ae;
    strokeThickness: number;
    private bv;
    strip: string;
    private br;
    majorStroke: string;
    private bb;
    actualMajorStroke: string;
    private ac;
    majorStrokeThickness: number;
    private bs;
    minorStroke: string;
    private bc;
    actualMinorStroke: string;
    private ad;
    minorStrokeThickness: number;
    private bx;
    tickStroke: string;
    private ag;
    tickStrokeThickness: number;
    private af;
    tickLength: number;
    private k;
    isDisabled: boolean;
    private l;
    isInverted: boolean;
    private o;
    useEnhancedIntervalManagement: boolean;
    private a7;
    enhancedIntervalMinimumCharacters: number;
    private bo;
    labelTextColor: string;
    private bn;
    labelLocation: string;
    private m;
    labelShowFirstLabel: boolean;
    private v;
    labelAngle: number;
    private x;
    labelExtent: number;
    private z;
    labelLeftMargin: number;
    private aa;
    labelRightMargin: number;
    private ab;
    labelTopMargin: number;
    private w;
    labelBottomMargin: number;
    private bm;
    labelHorizontalAlignment: string;
    private bp;
    labelVerticalAlignment: string;
    private bf;
    crossingAxisRef: string;
    private a9;
    crossingValue: any;
    private b4;
    titlePosition: string;
    private b5;
    titleTextColor: string;
    private b3;
    titleLocation: string;
    private n;
    titleShowFirstLabel: boolean;
    private ah;
    titleAngle: number;
    private aj;
    titleExtent: number;
    private al;
    titleLeftMargin: number;
    private am;
    titleRightMargin: number;
    private an;
    titleTopMargin: number;
    private ai;
    titleBottomMargin: number;
    private b2;
    titleHorizontalAlignment: string;
    private b6;
    titleVerticalAlignment: string;
    private f;
    annotations: AxisAnnotationDescription[];
    private be;
    coercionMethodsRef: string;
    private j;
    expectFunctions: boolean;
    private bl;
    labelFormat: string;
    private g;
    labelFormatSpecifiers: FormatSpecifierDescription[];
    private bt;
    rangeChangedRef: string;
    private bu;
    renderRequestedRef: string;
    private bh;
    label: string;
    private bi;
    labelFontFamily: string;
    private y;
    labelFontSize: number;
    private bk;
    labelFontWeight: string;
    private bj;
    labelFontStyle: string;
    private bz;
    titleFontFamily: string;
    private ak;
    titleFontSize: number;
    private b1;
    titleFontWeight: string;
    private b0;
    titleFontStyle: string;
    private bq;
    labelVisibility: string;
}
