import { Base, Type } from "./type";
import { CodeGeneratingRendererResult } from "./CodeGeneratingRendererResult";
import { CodeGeneratingCodeWriter } from "./CodeGeneratingCodeWriter";
import { CodeGenerationItemBuilderPropertyInfo } from "./CodeGenerationItemBuilderPropertyInfo";
import { CodeGenerationRendererOptions } from "./CodeGenerationRendererOptions";
import { List$1 } from "./List$1";
import { TypeDescriptionMetadata } from "./TypeDescriptionMetadata";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { DescriptionRef } from "./DescriptionRef";
import { StringBuilder } from "./StringBuilder";
import { CodeGeneratingComponentRendererDataEmitter } from "./CodeGeneratingComponentRendererDataEmitter";
import { CodeGeneratingComponentRendererDataEmitterPropertyType } from "./CodeGeneratingComponentRendererDataEmitterPropertyType";
import { CodeGeneratingComponentRendererDataEmitterItemType } from "./CodeGeneratingComponentRendererDataEmitterItemType";
import { JsonDictionaryValue } from "./JsonDictionaryValue";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { JsonDictionaryItem } from "./JsonDictionaryItem";
import { ComponentRenderer } from "./ComponentRenderer";
import { CodeGenerationTargetPlatforms } from "./CodeGenerationTargetPlatforms";
import { CodeGeneratingComponentRendererHandlerEmitter } from "./CodeGeneratingComponentRendererHandlerEmitter";
import { CodeGeneratingComponentRendererModuleEmitter } from "./CodeGeneratingComponentRendererModuleEmitter";
import { ICodeGenerationRendererTemplate } from "./ICodeGenerationRendererTemplate";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRendererCodeEmitter extends Base {
    static $t: Type;
    private k;
    private i;
    private p;
    protected ax(a: CodeGenerationItemBuilderPropertyInfo): void;
    protected readonly j: CodeGeneratingRendererResult;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    private d;
    protected readonly h: CodeGeneratingCodeWriter;
    private a;
    protected readonly e: CodeGeneratingCodeWriter;
    private c;
    protected readonly g: CodeGeneratingCodeWriter;
    private b;
    protected readonly f: CodeGeneratingCodeWriter;
    private q;
    protected ak(a: string): void;
    protected m(a: CodeGenerationItemBuilderPropertyInfo): boolean;
    private s;
    protected readonly x: string;
    al(a: string): void;
    aw(): void;
    at(a: string): void;
    ar(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    as(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    toString(): string;
    protected ad(): string;
    protected ag(a: CodeGenerationItemBuilderPropertyInfo, b: boolean): string;
    protected t(a: CodeGenerationItemBuilderPropertyInfo): any;
    private af;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): string;
    private ab;
    protected z(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ac(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected aa(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected get_o(): boolean;
    protected readonly o: boolean;
    protected v(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected u(a: CodeGenerationItemBuilderPropertyInfo): string;
    private r;
    av(a: string): void;
    protected get_ai(): string;
    protected readonly ai: string;
    protected readonly w: string;
    protected readonly n: boolean;
    protected readonly l: boolean;
    ah: string;
    au(): void;
    an(a: StringBuilder): void;
    aq(a: StringBuilder): void;
    am(a: StringBuilder): void;
    ao(a: StringBuilder): void;
    protected ap(a: List$1<string>, b: StringBuilder): void;
}
/**
 * @hidden
 */
export declare class ReactMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_o(): boolean;
    protected get_ai(): string;
    private ay;
    private az;
    al(a: string): void;
    private a1;
    aw(): void;
    private a0;
    protected aa(a: CodeGenerationItemBuilderPropertyInfo): string;
    at(a: string): void;
    ar(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    protected t(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ad(): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): string;
    as(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    protected ap(a: List$1<string>, b: StringBuilder): void;
}
/**
 * @hidden
 */
export declare class ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_o(): boolean;
    al(a: string): void;
    private a1;
    aw(): void;
    at(a: string): void;
    private a0;
    private ay;
    private az;
    protected get_ai(): string;
    protected ap(a: List$1<string>, b: StringBuilder): void;
    ar(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    protected t(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ad(): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected aa(a: CodeGenerationItemBuilderPropertyInfo): string;
    as(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class TSCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected r(a: string, b?: boolean): string;
    protected q(a: string): string;
    protected aj(a: string): string;
    protected get_o(): string;
    private af;
    protected ae(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter, e: CodeGeneratingCodeWriter): void;
    protected aa(a: string): void;
    protected ab(a: string, b: JsonDictionaryValue): void;
    protected ac(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected t(a: string, b: CodeGeneratingCodeWriter): void;
    protected u(a: string, b: CodeGeneratingCodeWriter): void;
    protected w(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingCodeWriter): void;
    private ag;
    private ai;
    protected ad(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter): void;
    protected s(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryItem, e: number, f: CodeGeneratingCodeWriter): void;
    private ak;
    protected p(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected ah(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class AngularTemplateCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected get_o(): boolean;
    protected get_ai(): string;
    al(a: string): void;
    private ay;
    aw(): void;
    at(a: string): void;
    ar(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    protected aa(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected t(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ad(): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): string;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): string;
    as(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
}
/**
 * @hidden
 */
export declare class AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class DotNetCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    protected u(a: string, b: CodeGeneratingCodeWriter): void;
    protected y(a: CodeGeneratingCodeWriter): void;
    private af;
    protected x(a: CodeGeneratingCodeWriter): void;
    protected r(a: string, b?: boolean): string;
    protected q(a: string): string;
    protected aj(a: string): string;
    protected ae(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter, e: CodeGeneratingCodeWriter): void;
    protected aa(a: string): void;
    protected ab(a: string, b: JsonDictionaryValue): void;
    protected ac(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryObject): void;
    protected get_o(): string;
    protected w(a: CodeGeneratingComponentRendererDataEmitterItemType, b: CodeGeneratingCodeWriter, c: CodeGeneratingCodeWriter): void;
    private ag;
    private ai;
    protected ad(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: CodeGeneratingCodeWriter): void;
    protected s(a: string, b: string[], c: CodeGeneratingComponentRendererDataEmitterPropertyType[], d: JsonDictionaryItem, e: number, f: CodeGeneratingCodeWriter): void;
    private ak;
    protected p(a: CodeGeneratingComponentRendererDataEmitterPropertyType, b: JsonDictionaryValue): string;
    protected ah(a: JsonDictionaryValue): string;
}
/**
 * @hidden
 */
export declare class WPFXamlCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
    al(a: string): void;
    aw(): void;
    at(a: string): void;
    ar(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    protected t(a: CodeGenerationItemBuilderPropertyInfo): any;
    protected ad(): string;
    protected y(a: CodeGenerationItemBuilderPropertyInfo): string;
    private ay;
    protected ae(a: CodeGenerationItemBuilderPropertyInfo): string;
    as(a: string, b: CodeGenerationItemBuilderPropertyInfo, c: TypeDescriptionContext): void;
    protected get_ai(): string;
}
/**
 * @hidden
 */
export declare class WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
    static $t: Type;
    constructor(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult);
}
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRenderer extends ComponentRenderer {
    static $t: Type;
    loadCodeJson(a: string): void;
    static dm(a: string): string;
    static dn(a: string): string;
    static dp(a: string): string;
    protected aj(): boolean;
    y(a: JsonDictionaryItem): boolean;
    ad(a: JsonDictionaryItem): boolean;
    z(a: JsonDictionaryItem): boolean;
    db(a: CodeGenerationItemBuilder, b: CodeGenerationRendererOptions, c: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    dc(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererDataEmitter;
    dd(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererHandlerEmitter;
    de(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererModuleEmitter;
    emitCode(a: ICodeGenerationRendererTemplate): CodeGeneratingRendererResult;
    private dt;
    protected a3(): (arg1: string) => string;
    private dq;
    private dr;
    private dg;
    private dh;
    private di;
    private dj;
    private dk;
    constructor(a: CodeGenerationTargetPlatforms, b: CodeGenerationRendererOptions);
    private dl;
}
/**
 * @hidden
 */
export declare class CodeGenerationContainer extends Base {
    static $t: Type;
    private _id;
    id: string;
    constructor();
    a: List$1<CodeGenerationItemBuilder>;
    c(a: CodeGeneratingRendererResult, b: CodeGeneratingComponentRenderer, c: CodeGenerationRendererOptions): void;
}
/**
 * @hidden
 */
export declare class CodeGenerationItemBuilder extends Base {
    static $t: Type;
    private e;
    private c;
    private b;
    private h;
    private f;
    constructor(a: CodeGenerationTargetPlatforms, b: string, c: TypeDescriptionContext, d: any);
    a(a: string): CodeGenerationItemBuilder;
    private m;
    q(a: string, b: TypeDescriptionMetadata, c: any, d: DescriptionRef): void;
    o(a: string, b: TypeDescriptionMetadata, c: DescriptionRef): void;
    p(a: string, b: TypeDescriptionMetadata): void;
    g(a: string): any;
    n(a: CodeGeneratingComponentRendererCodeEmitter, b: boolean): void;
    private d;
    private k;
    private l;
    protected get_i(): string;
    protected readonly i: string;
    protected get_j(): string;
    protected readonly j: string;
}
/**
 * @hidden
 */
export declare class CodeGenerationRendererAdapter extends Base implements IComponentRendererAdapter {
    static $t: Type;
    private a;
    private b;
    constructor(a: CodeGenerationTargetPlatforms, b: IComponentRendererAdapter);
    createColorCollection(a: any[]): any;
    createBrushCollection(a: any[]): any;
    createObject(a: string, b: any, c: TypeDescriptionContext): any;
    coerceToEnum(a: string, b: TypeDescriptionContext, c: string): any;
    onUIThread(a: any, b: () => void): void;
    setOrUpdateCollectionOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: TypeDescriptionContext, e: any, f: any): void;
    private c;
    onPendingRef(a: any, b: string, c: TypeDescriptionMetadata, d: DescriptionRef): void;
    setPropertyValue(a: any, b: string, c: TypeDescriptionMetadata, d: any, e: any, f: DescriptionRef): void;
    getPropertyValue(a: any, b: string): any;
    getRootObject(a: any): any;
    clearContainer(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    forPropertyValueItem(a: any, b: string, c: (arg1: any) => void): void;
    clearCollection(a: any, b: string, c: TypeDescriptionMetadata): void;
    addItemToCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    resetPropertyOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: any): void;
    replaceItemInCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    replaceRootItem(a: any, b: string, c: TypeDescriptionContext, d: (arg1: boolean) => void): void;
    removeItemFromCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number): void;
    removeRootItem(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    flushChanges(a: any): void;
}
