import { Description } from "./Description";
import { SectionHeaderDescription } from "./SectionHeaderDescription";
import { SummaryRowRootDescription } from "./SummaryRowRootDescription";
import { SummaryRowSectionDescription } from "./SummaryRowSectionDescription";
import { RowSeparatorDescription } from "./RowSeparatorDescription";
import { HeaderRowSeparatorDescription } from "./HeaderRowSeparatorDescription";
import { HeaderSeparatorDescription } from "./HeaderSeparatorDescription";
import { ColumnResizingSeparatorDescription } from "./ColumnResizingSeparatorDescription";
import { ColumnMovingSeparatorDescription } from "./ColumnMovingSeparatorDescription";
import { PinnedAreaSeparatorDescription } from "./PinnedAreaSeparatorDescription";
import { BaseDataSourceDescription } from "./BaseDataSourceDescription";
import { GridAnimationSettingsDescription } from "./GridAnimationSettingsDescription";
import { Type } from "./type";
import { PrimaryKeyValueDescription } from "./PrimaryKeyValueDescription";
import { CellKeyDescription } from "./CellKeyDescription";
import { CellRangeDescription } from "./CellRangeDescription";
import { GridCellPositionDescription } from "./GridCellPositionDescription";
import { ResponsiveStateDescription } from "./ResponsiveStateDescription";
import { ColumnSortDescriptionDescription } from "./ColumnSortDescriptionDescription";
import { ColumnGroupDescriptionDescription } from "./ColumnGroupDescriptionDescription";
import { FilterExpressionDescription } from "./FilterExpressionDescription";
import { ColumnSummaryDescriptionDescription } from "./ColumnSummaryDescriptionDescription";
import { ColumnDescription } from "./ColumnDescription";
/**
 * @hidden
 */
export declare class DataGridDescription extends Description {
    static $t: Type;
    private hb;
    width: string;
    private fy;
    height: string;
    private d6;
    background: string;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private e1;
    columnResizingMode: string;
    private et;
    columnMovingMode: string;
    private bm;
    isRowHoverEnabled: boolean;
    private f4;
    rowHoverBackground: string;
    private f5;
    rowHoverTextColor: string;
    private fg;
    editRowBorder: string;
    private cl;
    editRowBorderWidthBottom: number;
    private cm;
    editRowBorderWidthLeft: number;
    private cn;
    editRowBorderWidthRight: number;
    private co;
    editRowBorderWidthTop: number;
    private a5;
    sectionHeader: SectionHeaderDescription;
    private a7;
    summaryRowRoot: SummaryRowRootDescription;
    private a9;
    summaryRowSection: SummaryRowSectionDescription;
    private a3;
    rowSeparator: RowSeparatorDescription;
    private ax;
    headerRowSeparator: HeaderRowSeparatorDescription;
    private az;
    headerSeparator: HeaderSeparatorDescription;
    private ar;
    columnResizingSeparator: ColumnResizingSeparatorDescription;
    private ap;
    columnMovingSeparator: ColumnMovingSeparatorDescription;
    private a1;
    pinnedAreaSeparator: PinnedAreaSeparatorDescription;
    private h;
    autoGenerateDesiredProperties: string[];
    private j;
    dataSourceDesiredProperties: string[];
    private fa;
    density: string;
    private dk;
    actualRowHeight: number;
    private dr;
    rowHeight: number;
    private ci;
    defaultColumnMinWidth: number;
    private dj;
    actualHeaderHeight: number;
    private dn;
    headerHeight: number;
    private e8;
    dataSourceRef: string;
    private an;
    dataSource: BaseDataSourceDescription;
    private fp;
    headerClickAction: string;
    private fe;
    editMode: string;
    private ff;
    editModeClickAction: string;
    private bd;
    editOnKeyPress: boolean;
    private bc;
    autoGenerateColumns: boolean;
    private ds;
    rowSeparatorHeight: number;
    private bl;
    isPlaceholderRenderingEnabled: boolean;
    private eo;
    columnAddingAnimationMode: string;
    private ez;
    columnPropertyUpdatingAnimationMode: string;
    private ea;
    cellDataLoadedAnimationMode: string;
    private f6;
    rowSelectionAnimationMode: string;
    private f3;
    rowHoverAnimationMode: string;
    private el;
    cellSelectionAnimationMode: string;
    private at;
    animationSettings: GridAnimationSettingsDescription;
    private e0;
    columnResizingAnimationMode: string;
    private e4;
    columnShowingAnimationMode: string;
    private es;
    columnMovingAnimationMode: string;
    private er;
    columnHidingAnimationMode: string;
    private ep;
    columnExchangingAnimationMode: string;
    private gm;
    selectionMode: string;
    private d2;
    activationMode: string;
    private gl;
    selectionBehavior: string;
    private s;
    selectedItems: any[];
    private t;
    selectedKeys: PrimaryKeyValueDescription[];
    private r;
    selectedCells: CellKeyDescription[];
    private q;
    selectedCellRanges: CellRangeDescription[];
    private m;
    pinnedItems: any[];
    private n;
    pinnedKeys: PrimaryKeyValueDescription[];
    private bf;
    isColumnOptionsEnabled: boolean;
    private bj;
    isGroupRowSticky: boolean;
    private bk;
    isHeaderSeparatorVisible: boolean;
    private ek;
    cellSelectedBackground: string;
    private gf;
    sectionHeaderSelectedBackground: string;
    private gq;
    summaryRootBackground: string;
    private g1;
    summarySectionBackground: string;
    private cq;
    pinnedRowOpacity: number;
    private fb;
    editFontFamily: string;
    private cj;
    editFontSize: number;
    private fc;
    editFontStyle: string;
    private fd;
    editFontWeight: string;
    private ck;
    editOpacity: number;
    private e9;
    deletedTextColor: string;
    private gp;
    stickyRowBackground: string;
    private f0;
    pinnedRowBackground: string;
    private fz;
    lastStickyRowBackground: string;
    private av;
    activeCell: GridCellPositionDescription;
    private d8;
    cellBackground: string;
    private em;
    cellTextColor: string;
    private fv;
    headerSortIndicatorColor: string;
    private fw;
    headerSortIndicatorStyle: string;
    private ed;
    cellFontFamily: string;
    private cd;
    cellFontSize: number;
    private ee;
    cellFontStyle: string;
    private ef;
    cellFontWeight: string;
    private gb;
    sectionHeaderBackground: string;
    private gg;
    sectionHeaderTextColor: string;
    private gc;
    sectionHeaderFontFamily: string;
    private cr;
    sectionHeaderFontSize: number;
    private gd;
    sectionHeaderFontStyle: string;
    private ge;
    sectionHeaderFontWeight: string;
    private gr;
    summaryRootLabelFontFamily: string;
    private cs;
    summaryRootLabelFontSize: number;
    private gs;
    summaryRootLabelFontStyle: string;
    private gt;
    summaryRootLabelFontWeight: string;
    private g2;
    summarySectionLabelFontFamily: string;
    private cu;
    summarySectionLabelFontSize: number;
    private g3;
    summarySectionLabelFontStyle: string;
    private g4;
    summarySectionLabelFontWeight: string;
    private gz;
    summaryRootValueTextColor: string;
    private gw;
    summaryRootValueFontFamily: string;
    private ct;
    summaryRootValueFontSize: number;
    private gx;
    summaryRootValueFontStyle: string;
    private gy;
    summaryRootValueFontWeight: string;
    private g7;
    summarySectionValueFontFamily: string;
    private cv;
    summarySectionValueFontSize: number;
    private g8;
    summarySectionValueFontStyle: string;
    private g9;
    summarySectionValueFontWeight: string;
    private ha;
    summarySectionValueTextColor: string;
    private gu;
    summaryRootLabelTextColor: string;
    private g5;
    summarySectionLabelTextColor: string;
    private gv;
    summaryRootSelectedBackground: string;
    private g6;
    summarySectionSelectedBackground: string;
    private dq;
    pinnedAreaSeparatorWidth: number;
    private dp;
    headerSeparatorWidth: number;
    private fu;
    headerSeparatorBackground: string;
    private fo;
    headerBackground: string;
    private fx;
    headerTextColor: string;
    private fq;
    headerFontFamily: string;
    private cp;
    headerFontSize: number;
    private fr;
    headerFontStyle: string;
    private fs;
    headerFontWeight: string;
    private f7;
    rowSeparatorBackground: string;
    private ft;
    headerRowSeparatorBackground: string;
    private ga;
    rowSeparatorStickyRowBackground: string;
    private f8;
    rowSeparatorLastStickyRowBackground: string;
    private f9;
    rowSeparatorPinnedRowBackground: string;
    private dm;
    columnResizingSeparatorWidth: number;
    private dl;
    columnMovingSeparatorWidth: number;
    private e2;
    columnResizingSeparatorBackground: string;
    private eu;
    columnMovingSeparatorBackground: string;
    private br;
    shiftSectionContent: boolean;
    private ev;
    columnOptionsIconAlignment: string;
    private ex;
    columnOptionsIconColor: string;
    private ew;
    columnOptionsIconBehavior: string;
    private d7;
    border: string;
    private b9;
    borderWidthBottom: number;
    private ca;
    borderWidthLeft: number;
    private cb;
    borderWidthRight: number;
    private cc;
    borderWidthTop: number;
    private bn;
    notifyOnAllSelectionChanges: boolean;
    private cf;
    cornerRadiusBottomRight: number;
    private ce;
    cornerRadiusBottomLeft: number;
    private cg;
    cornerRadiusTopLeft: number;
    private ch;
    cornerRadiusTopRight: number;
    private be;
    isActiveCellStyleEnabled: boolean;
    private p;
    responsiveStates: ResponsiveStateDescription[];
    private u;
    sortDescriptions: ColumnSortDescriptionDescription[];
    private l;
    groupDescriptions: ColumnGroupDescriptionDescription[];
    private k;
    filterExpressions: FilterExpressionDescription[];
    private v;
    summaryDescriptions: ColumnSummaryDescriptionDescription[];
    private g0;
    summaryScope: string;
    private bh;
    isGroupCollapsable: boolean;
    private fm;
    groupHeaderDisplayMode: string;
    private bi;
    isGroupExpandedDefault: boolean;
    private fn;
    groupSummaryDisplayMode: string;
    private bb;
    autoAcceptEdits: boolean;
    private o;
    primaryKey: string[];
    private g;
    actualPrimaryKey: string[];
    private f;
    actualColumns: ColumnDescription[];
    private i;
    columns: ColumnDescription[];
    private bq;
    reactsToSortChanges: boolean;
    private bp;
    reactsToGroupChanges: boolean;
    private bo;
    reactsToFilterChanges: boolean;
    private fh;
    enterBehavior: string;
    private fi;
    enterBehaviorAfterEdit: string;
    private bg;
    isColumnOptionsSummariesEnabled: boolean;
    private fk;
    filterExpressionsChangingRef: string;
    private fj;
    filterExpressionsChangedRef: string;
    private ei;
    cellPreviewPointerDownRef: string;
    private ej;
    cellPreviewPointerUpRef: string;
    private eg;
    cellPointerDownRef: string;
    private eh;
    cellPointerUpRef: string;
    private d9;
    cellClickedRef: string;
    private go;
    sortDescriptionsChangedRef: string;
    private fl;
    groupDescriptionsChangedRef: string;
    private eq;
    columnHiddenChangedRef: string;
    private ey;
    columnPinnedChangedRef: string;
    private en;
    cellValueChangingRef: string;
    private e6;
    dataCommittedRef: string;
    private e7;
    dataCommittingRef: string;
    private gn;
    sizeChangedRef: string;
    private d4;
    actualColumnsChangedRef: string;
    private e3;
    columnsAutoGeneratedRef: string;
    private gj;
    selectedItemsChangedRef: string;
    private gk;
    selectedKeysChangedRef: string;
    private gi;
    selectedCellsChangedRef: string;
    private d3;
    activeCellChangedRef: string;
    private gh;
    selectedCellRangesChangedRef: string;
    private e5;
    columnWidthChangedRef: string;
    private ec;
    cellEditStartedRef: string;
    private eb;
    cellEditEndedRef: string;
    private f2;
    rowEditStartedRef: string;
    private f1;
    rowEditEndedRef: string;
    private d5;
    actualPrimaryKeyChangeRef: string;
}
