import { Base, IList, Type } from "./type";
import { IDataSourceLocalDataProvider } from "./IDataSourceLocalDataProvider";
import { IDataSourceSchema } from "./IDataSourceSchema";
import { DataSourceSchemaPropertyType } from "./DataSourceSchemaPropertyType";
import { IDataSourceExecutionContext } from "./IDataSourceExecutionContext";
import { IDataSourceDataProviderUpdateNotifier } from "./IDataSourceDataProviderUpdateNotifier";
import { SortDescriptionCollection } from "./SortDescriptionCollection";
import { FilterExpressionCollection } from "./FilterExpressionCollection";
import { SummaryDescriptionCollection } from "./SummaryDescriptionCollection";
import { DataSourceSummaryScope } from "./DataSourceSummaryScope";
import { DataSourceDataProviderSchemaChangedEventArgs } from "./DataSourceDataProviderSchemaChangedEventArgs";
/**
 * @hidden
 */
export declare class DataSourceLocalDataProvider extends Base implements IDataSourceLocalDataProvider {
    static $t: Type;
    constructor();
    private ai;
    private k;
    private j;
    private e;
    private l;
    private d;
    private v;
    dataSource: any;
    schemaChanged: (sender: any, args: DataSourceDataProviderSchemaChangedEventArgs) => void;
    getItemAtIndex(a: number): any;
    private q;
    getItemValue(a: any, b: string): any;
    setItemValue(a: any, b: string, c: any): void;
    removeItem(a: any): void;
    addItem(a: any): void;
    private ab;
    readonly actualCount: number;
    private h;
    readonly actualSchema: IDataSourceSchema;
    private i;
    resolveSchemaPropertyType(a: string): DataSourceSchemaPropertyType;
    private r;
    private ad;
    private ac;
    private s;
    private b;
    private static c;
    private w;
    protected ae(a: string, b: any, c: any): void;
    private t;
    protected readonly u: IList;
    private o;
    protected af(a: string, b: any, c: any): void;
    private g;
    executionContext: IDataSourceExecutionContext;
    protected readonly p: boolean;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    private f;
    updateNotifier: IDataSourceDataProviderUpdateNotifier;
    private n;
    deferAutoRefresh: boolean;
    readonly isSortingSupported: boolean;
    readonly isFilteringSupported: boolean;
    readonly sortDescriptions: SortDescriptionCollection;
    readonly filterExpressions: FilterExpressionCollection;
    readonly summaryDescriptions: SummaryDescriptionCollection;
    summaryScope: DataSourceSummaryScope;
    readonly notifyUsingSourceIndexes: boolean;
    private a;
    propertiesRequested: string[];
    readonly isItemIndexLookupSupported: boolean;
    readonly isKeyIndexLookupSupported: boolean;
    readonly isGroupingSupported: boolean;
    readonly groupDescriptions: SortDescriptionCollection;
    m: boolean;
    queueAutoRefresh(): void;
    aa(): void;
    ag(): void;
    protected ah(): void;
    flushAutoRefresh(): void;
    refresh(): void;
    indexOfItem(a: any): number;
    indexOfKey(a: any[]): number;
}
