import { Type } from "./type";
import { Brush } from "./Brush";
/**
 * @hidden
 */
export interface IScrollerView {
    requestWork(a: () => void): void;
    getInitialScrollLeft(): number;
    getInitialScrollTop(): number;
    getDefaultScrollbarBrush(): Brush;
    updateVScrollbar(a: number, b: number): void;
    updateScrollTop(a: number): void;
    updateScrollLeft(a: number): void;
    updateScrollbarStatus(a: boolean): void;
    updateHScrollbar(a: number, b: number): void;
    provideContent(a: any): void;
    provideContainer(a: any): void;
    onViewportHeightChanged(a: number): void;
    onViewportWidthChanged(a: number): void;
    onContentHeightChanged(a: number): void;
    onContentWidthChanged(a: number): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    hideVScrollbar(): void;
    hideHScrollbar(): void;
    focus(): void;
    cancelInertia(): void;
    detachNativeScroll(): void;
    attachNativeScroll(): void;
}
/**
 * @hidden
 */
export declare let IScrollerView_$type: Type;
