import { BaseDataSource } from "./BaseDataSource";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceLocalDataProvider } from "./IDataSourceLocalDataProvider";
import { Base, Type } from "./type";
import { IExternalLocalDataSource } from "./IExternalLocalDataSource";
import { ISupportsDataChangeNotifications } from "./ISupportsDataChangeNotifications";
import { DataSourceRowType } from "./DataSourceRowType";
import { ISummaryResult } from "./ISummaryResult";
import { IDataSource } from "./IDataSource";
import { TransactionEvent } from "./TransactionEvent";
import { ISupportsExpansionChangeNotifications } from "./ISupportsExpansionChangeNotifications";
/**
 * @hidden
 */
export declare class LocalDataSource extends BaseDataSource {
    static $t: Type;
    protected get_actualBaseDataProvider(): IDataSourceDataProvider;
    protected readonly actualBaseDataProvider: IDataSourceDataProvider;
    private cv;
    dataProvider: IDataSourceLocalDataProvider;
    private cu;
    actualDataProvider: IDataSourceLocalDataProvider;
    private dv;
    dataSource: any;
    protected canInitialize(): boolean;
    private c0;
    c1: IExternalLocalDataSource;
    constructor();
    protected resolveDataProvider(): IDataSourceLocalDataProvider;
    protected propertyUpdatedOverride(a: string, b: any, c: any): void;
    getItemAtIndex(a: number): any;
    getItemFromKey(a: any[]): any;
    getItemPropertyAtIndex(a: number, b: string): any;
    private c4;
    private c6;
    private cz;
    private c9;
    protected refreshInternalOverride(): void;
    protected get_isItemIndexLookupSupported(): boolean;
    protected get_isKeyIndexLookupSupported(): boolean;
    indexOfItem(a: any): number;
    private c8;
    indexOfKey(a: any[]): number;
    protected onActualPrimaryKeyChangedOverrride(a: string[], b: string[]): void;
    private c2;
    private c3;
    private c5;
    private df;
    private de;
    private db;
    private dc;
    private da;
    private dd;
    onClearItemsOverride(): void;
    onSetItemOverride(a: number, b: any, c: any): void;
    onInsertItemOverride(a: number, b: any): void;
    onRemoveItemOverride(a: number, b: any): void;
    d0(): void;
    d3(a: number, b: any, c: any): void;
    d1(a: number, b: any): void;
    d2(a: number, b: any): void;
    private dg;
    pinRow(a: any[]): void;
    unpinRow(a: any[]): void;
    clearPinnedRows(): void;
    isRowPinned(a: number): boolean;
    private c7;
    protected get_isSortingSupported(): boolean;
    protected get_isFilteringSupported(): boolean;
    protected get_isGroupingSupported(): boolean;
    getStickyRowPriority(a: number): number;
    private ct;
    private dp;
    private dh;
    private dr;
    private dj;
    private ds;
    private dk;
    private dq;
    private di;
    private du;
    private dt;
    private dm;
    private dl;
    private dn;
    getStickyRowsInRange(a: number, b: number): number[];
    isExclusivelySticky(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    setIsRowExpandedAtIndex(a: number, b: boolean): void;
    getIsRowExpandedAtIndex(a: number): boolean;
    getRowLevel(a: number): number;
    getRootSummaryRowCount(): number;
    getRootSummaryResults(): ISummaryResult[];
    getSectionSummaryResults(a: number): ISummaryResult[][];
    clone(): IDataSource;
    protected ap(): boolean;
    protected cm(a: TransactionEvent, b: any): void;
}
/**
 * @hidden
 */
export declare class LocalDataSourceViewUpdateNotifier extends Base implements ISupportsDataChangeNotifications {
    static $t: Type;
    private a;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    notifySetItem(a: number, b: any, c: any): void;
    constructor(a: LocalDataSource);
}
/**
 * @hidden
 */
export declare class LocalDataSourceViewExpansionNotifier extends Base implements ISupportsExpansionChangeNotifications {
    static $t: Type;
    private a;
    notifyRowExpansionChanged(a: number, b: boolean, c: boolean): void;
    constructor(a: LocalDataSource);
}
