import { Description } from "./Description";
import { SeriesDescription } from "./SeriesDescription";
import { PointDescription } from "./PointDescription";
import { RectDescription } from "./RectDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare abstract class SeriesViewerDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private f;
    series: SeriesDescription[];
    private h;
    crosshairPoint: PointDescription;
    private cb;
    legendRef: string;
    private r;
    animateSeriesWhenAxisRangeChanges: boolean;
    private v;
    isWindowSyncedToVisibleRange: boolean;
    private x;
    shouldSimulateHoverMoveCrosshairPoint: boolean;
    private b9;
    highlightingMode: string;
    private b8;
    highlightingBehavior: string;
    private ca;
    legendHighlightingMode: string;
    private k;
    effectiveViewport: RectDescription;
    private m;
    windowRect: RectDescription;
    private y;
    useTiledZooming: boolean;
    private w;
    preferHigherResolutionTiles: boolean;
    private bw;
    zoomTileCacheSize: number;
    private bv;
    highlightingTransitionDuration: number;
    private t;
    isPagePanningAllowed: boolean;
    private b3;
    contentHitTestMode: string;
    private bz;
    actualContentHitTestMode: string;
    private u;
    isSurfaceInteractionDisabled: boolean;
    private c9;
    windowResponse: string;
    private a5;
    windowRectMinWidth: number;
    private b4;
    crosshairVisibility: string;
    private da;
    zoomCoercionMode: string;
    private cd;
    plotAreaBackground: string;
    private b5;
    defaultInteraction: string;
    private cl;
    rightButtonDefaultInteraction: string;
    private b6;
    dragModifier: string;
    private cc;
    panModifier: string;
    private l;
    previewRect: RectDescription;
    private a3;
    windowPositionHorizontal: number;
    private a4;
    windowPositionVertical: number;
    private b2;
    chartTitle: string;
    private c3;
    titleHorizontalAlignment: string;
    private cx;
    subtitleHorizontalAlignment: string;
    private c5;
    titleTextStyle: string;
    private cz;
    subtitleTextStyle: string;
    private c4;
    titleTextColor: string;
    private cy;
    subtitleTextColor: string;
    private a1;
    titleTopMargin: number;
    private az;
    titleLeftMargin: number;
    private a0;
    titleRightMargin: number;
    private ax;
    titleBottomMargin: number;
    private aw;
    subtitleTopMargin: number;
    private au;
    subtitleLeftMargin: number;
    private av;
    subtitleRightMargin: number;
    private as;
    subtitleBottomMargin: number;
    private ct;
    subtitle: string;
    private a2;
    topMargin: number;
    private ap;
    leftMargin: number;
    private ar;
    rightMargin: number;
    private an;
    bottomMargin: number;
    private am;
    autoMarginWidth: number;
    private al;
    autoMarginHeight: number;
    private s;
    isAntiAliasingEnabledDuringInteraction: boolean;
    private aq;
    pixelScalingRatio: number;
    private ao;
    interactionPixelScalingRatio: number;
    private ai;
    actualPixelScalingRatio: number;
    private ah;
    actualInteractionPixelScalingRatio: number;
    private j;
    actualWindowRect: RectDescription;
    private aj;
    actualWindowPositionHorizontal: number;
    private ak;
    actualWindowPositionVertical: number;
    private ch;
    plotAreaMouseLeftButtonDownRef: string;
    private ci;
    plotAreaMouseLeftButtonUpRef: string;
    private ce;
    plotAreaClickedRef: string;
    private cf;
    plotAreaMouseEnterRef: string;
    private cg;
    plotAreaMouseLeaveRef: string;
    private cj;
    plotAreaMouseOverRef: string;
    private cm;
    seriesCursorMouseMoveRef: string;
    private cp;
    seriesMouseLeftButtonDownRef: string;
    private cq;
    seriesMouseLeftButtonUpRef: string;
    private cr;
    seriesMouseMoveRef: string;
    private cn;
    seriesMouseEnterRef: string;
    private co;
    seriesMouseLeaveRef: string;
    private c7;
    viewerManipulationStartingRef: string;
    private c6;
    viewerManipulationEndingRef: string;
    private c8;
    windowRectChangedRef: string;
    private cs;
    sizeChangedRef: string;
    private b0;
    actualWindowRectChangedRef: string;
    private b7;
    gridAreaRectChangedRef: string;
    private ck;
    refreshCompletedRef: string;
    private b1;
    background: string;
    private c0;
    titleFontFamily: string;
    private ay;
    titleFontSize: number;
    private c2;
    titleFontWeight: string;
    private c1;
    titleFontStyle: string;
    private cu;
    subtitleFontFamily: string;
    private at;
    subtitleFontSize: number;
    private cw;
    subtitleFontWeight: string;
    private cv;
    subtitleFontStyle: string;
}
