import { Children, cloneElement, Component, createElement, Fragment } from 'react';
import { createPortal } from 'react-dom';

/*!
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let _typeIdentifierCache = {};
let _nextTypeIdentifier = 0;
// interface Function {
//     $type?: Type;
// }
function getInstanceType(obj) {
    if (obj.$type) {
        return obj.$type;
    }
    else if (typeof obj === 'number') {
        return Number_$type;
    }
    else if (typeof obj === 'string') {
        return String_$type;
    }
    else if (typeof obj === 'boolean') {
        return Boolean_$type;
    }
    else if (obj instanceof Date) {
        return Date_$type;
    }
    return Base.prototype.$type;
}
let Base = /*@__PURE__*/ (() => {
    class Base {
        constructor() {
        }
        equals(other) {
            return this === other;
        }
        static equalsStatic(a, b) {
            var aIsNull = (a == null) || (!!a.isNullable && !a.hasValue);
            var bIsNull = (b == null) || (!!b.isNullable && !b.hasValue);
            if (aIsNull || bIsNull) {
                return aIsNull && bIsNull;
            }
            if (a.equals) {
                return a.equals(b);
            }
            if (b.equals) {
                return b.equals(a);
            }
            if (Number.isNaN(a) && Number.isNaN(b)) {
                return true;
            }
            if (a instanceof Date) {
                return b instanceof Date && +a === +b;
            }
            return a == b && typeof a == typeof b;
        }
        static equalsSimple(item1, item2) {
            return item1 == item2;
        }
        ;
        static compareSimple(item1, item2) {
            if (item1 == item2) {
                return 0;
            }
            if (item1 < item2) {
                return -1;
            }
            return 1;
        }
        ;
        static compare(item1, item2) {
            if (item1 === item2) {
                return 0;
            }
            var xComparable = typeCast(IComparable_$type, item1);
            if (xComparable !== null && xComparable.compareToObject) {
                return xComparable.compareToObject(item2);
            }
            var yComparable = typeCast(IComparable_$type, item2);
            if (yComparable !== null && yComparable.compareToObject) {
                return -yComparable.compareToObject(item1);
            }
            return Base.compareSimple(item1, item2);
        }
        ;
        getHashCode() {
            if (this.$hashCode === undefined) {
                this.$hashCode = Base.nextHashCode++;
            }
            return this.$hashCode;
        }
        static getHashCodeStatic(obj) {
            if (obj.getHashCode) {
                return obj.getHashCode();
            }
            if (obj.$hashCode !== undefined) {
                return obj.$hashCode;
            }
            if (!(typeof obj == "object")) {
                return Type.getPrimitiveHashCode(obj);
            }
            else {
                obj.$hashCode = Base.nextHashCode++;
                return obj.$hashCode;
            }
        }
        memberwiseClone() {
            var clone;
            try {
                clone = Object.create(this.$type.InstanceConstructor.prototype);
            }
            catch (e) {
                class Cons {
                }
                Cons.prototype = this.$type.InstanceConstructor.prototype;
                clone = new Cons();
            }
            for (var prop in this) {
                if (this.hasOwnProperty(prop)) {
                    clone[prop] = this[prop];
                }
            }
            return clone;
        }
        static referenceEquals(a, b) {
            return a === b || (a == null && b == null);
        }
        static getArrayOfValues(obj) {
            var result = [];
            for (var i in obj) {
                if (obj.hasOwnProperty(i)) {
                    result.push(obj[i]);
                }
            }
            return result;
        }
        static getArrayOfProperties(obj) {
            var result = [];
            for (var i in obj) {
                if (obj.hasOwnProperty(i)) {
                    result.push(i);
                }
            }
            return result;
        }
        ;
    }
    Base.nextHashCode = 0;
    return Base;
})();
class Type extends Base {
    constructor(instanceConstructor, identifier, baseType = Base.prototype.$type, interfaces = null, staticInitializer = null) {
        super();
        this.specializationCache = null;
        this._staticInitializer = null;
        this.name = null;
        this.typeArguments = null;
        this.baseType = null;
        this.interfaces = null;
        this.isEnumType = false;
        this._isGenericType = undefined;
        this._staticFields = null;
        this.isNullable = false;
        this._$nullNullable = null;
        this.enumInfo = null;
        this.specializationCache = {};
        this._staticInitializer = staticInitializer;
        this._fullName = identifier;
        this.name = identifier;
        this.InstanceConstructor = instanceConstructor;
        var lastDotIndex = this.name.lastIndexOf(".");
        if (lastDotIndex >= 0) {
            this.name = this.name.substr(lastDotIndex + 1);
        }
        this.typeArguments = null;
        this.baseType = null;
        this.interfaces = null;
        if (baseType) {
            this.baseType = baseType;
        }
        if (interfaces) {
            this.interfaces = interfaces;
        }
        if (_typeIdentifierCache[identifier]) {
            this.identifier = _typeIdentifierCache[identifier];
        }
        else {
            this.identifier = _nextTypeIdentifier++;
            _typeIdentifierCache[identifier] = this.identifier;
        }
        // rather than always evaluating a function on a type to see if it is an enum
        // we can just cache it once on the type
        // if (baseType && Enum && baseType == Enum.prototype.$type) {
        //     this.isEnumType = true;
        // }
    }
    get typeName() {
        return this.name;
    }
    get fullName() {
        return this._fullName;
    }
    getSpecId(types) {
        if (types.length === 1) {
            if (!types[0]) {
                return "undef";
            }
            else if (types[0] === -1) {
                return undefined;
            }
            else if (!types[0].typeName) {
                return types[0].toString();
            }
            else if (types[0].stringId) {
                return types[0].stringId;
            }
            else {
                return types[0].identifier.toString();
            }
        }
        var ret = "";
        for (var i = 0; i < types.length; i++) {
            var type = types[i];
            if (!type) {
                ret += "undef";
            }
            else if (type == -1) {
                return undefined;
            }
            else if (!type.typeName) {
                ret += type.toString();
            }
            else if (type.stringId) {
                ret += type.stringId;
            }
            else {
                ret += type.identifier.toString();
            }
        }
        return ret;
    }
    get isGenericType() {
        if (this._isGenericType === undefined) {
            this._isGenericType = this.name.indexOf("$") >= 0;
        }
        return this._isGenericType;
    }
    get isGenericTypeDefinition() {
        return this.typeArguments === null && this.isGenericType;
    }
    get genericTypeArguments() {
        return this.typeArguments;
    }
    getStaticFields(type) {
        if (type === undefined) {
            type = this;
        }
        var t = this;
        while (t != null) {
            if (t === type || t._fullName == type._fullName) {
                if (t._staticFields == null && t._staticInitializer) {
                    t._staticFields = {};
                    t._staticInitializer.apply(t._staticFields, t.typeArguments);
                }
                return t._staticFields;
            }
            t = t.baseType;
        }
        return null;
    }
    initSelfReferences(replacement) {
        var i, j;
        if (replacement) {
            if (this.typeArguments) {
                var updateCache = false;
                for (j = 0; j < this.typeArguments.length; j++) {
                    var typeArg = this.typeArguments[j];
                    if (typeArg == -1) {
                        updateCache = true;
                        this.typeArguments[j] = replacement;
                    }
                    else if (typeArg &&
                        typeArg instanceof Type &&
                        typeArg.initSelfReferences) {
                        typeArg.initSelfReferences(replacement);
                    }
                }
                if (updateCache) {
                    var specId = this.getSpecId(this.typeArguments);
                    var ret = this.specializationCache[specId];
                    if (!ret) {
                        this.specializationCache[specId] = this;
                    }
                }
            }
        }
        else {
            if (this.baseType) {
                this.baseType.initSelfReferences(this);
            }
            if (this.interfaces) {
                for (i = 0; i < this.interfaces.length; i++) {
                    this.interfaces[i].initSelfReferences(this);
                }
            }
        }
        return this;
    }
    specialize(...rest) {
        var i;
        if (!this.isGenericType) {
            return this;
        }
        var specId = this.getSpecId(Array.from(arguments));
        var ret = this.specializationCache[specId];
        if (ret) {
            return ret;
        }
        ret = new Type(this.InstanceConstructor, this._fullName, this.baseType, this.interfaces, this._staticInitializer);
        ret.specializationCache = this.specializationCache;
        var placeholders = this.typeArguments;
        var hasPlaceholders = false;
        // Make sure the placeholders are actually numbers. If they are types, we are re-specializing an
        // already specialized type.
        if (placeholders && placeholders.length) {
            /* going back to how it used to be. we shouldn't assume that the number/order of the arguments
                relates to the typearguments. this may be an interface that has its type information already
                and either has placeholders or is a closed type
            // you can have a mixed bag where some are placeholders and others are not and the
            // placeholder doesn't have to be the first slot
            for (i = 0; i < placeholders.length; i++) {
                if (isFinite(placeholders[ i ])) {
                    hasPlaceholders = true;
                    break;
                }
            }*/
            hasPlaceholders = true;
        }
        ret.typeArguments = [];
        if (hasPlaceholders) {
            for (i = 0; i < placeholders.length; i++) {
                // if the argument being provided is a placeholder index and we already have
                // a placeholder then keep the index we have. otherwise we're taking the index
                // of the parent type
                if (typeof placeholders[i] === "number" &&
                    isFinite(placeholders[i]) && !isFinite(arguments[placeholders[i]])) {
                    ret.typeArguments[i] = arguments[placeholders[i]];
                }
                else {
                    ret.typeArguments[i] = placeholders[i];
                }
            }
        }
        else {
            for (i = 0; i < arguments.length; i++) {
                ret.typeArguments[i] = arguments[i];
            }
        }
        // since the placeholder indexes for the basetype and interfaces implemented are based
        // on the order of the type arguments for the defining types we should pass its typeargs
        // and not the outermost type's type arguments which may be different in number and order
        // than the base type of the base types and interfaces implemented
        if (this.baseType && this.baseType.typeArguments) {
            ret.baseType = this.specialize.apply(this.baseType, ret.typeArguments);
        }
        if (this.interfaces) {
            ret.interfaces = [];
            for (i = 0; i < this.interfaces.length; i++) {
                ret.interfaces[i] = this.specialize.apply(this.interfaces[i], ret.typeArguments);
            }
        }
        // rather than doing this check in various places we could just cache a field on the type
        if (this._fullName == "Nullable$1" && ret.typeArguments.length == 1) {
            ret.isNullable = true;
        }
        // if this was a self referencing type (e.g. IEquatable<Int32> for Int32 then we won't have the
        // specId yet because we don't know the type argument. we'll update the cache when we update
        // the self references. otherwise other types that use self references (but for a different type)
        // will get and use the wrong type arguments
        if (specId) {
            this.specializationCache[specId] = ret;
            ret.stringId = ret.generateString();
        }
        else {
            // the self referencing type needs to be able to put itself into the specialization cache
            // of the original type
            //ret.specializationCache = this.specializationCache;
        }
        if (this.InstanceConstructor != null) {
            var _self = this;
            ret.InstanceConstructor = function () {
                _self.InstanceConstructor.apply(this, ret.typeArguments.concat(Array.prototype.slice.call(arguments, 0)));
                return this;
            };
            ret.InstanceConstructor.prototype = this.InstanceConstructor.prototype;
        }
        return ret;
    }
    equals(other) {
        if (!(other instanceof Type)) {
            return false;
        }
        if (this.identifier !== other.identifier) {
            return false;
        }
        if (this.typeArguments === null && other.typeArguments === null) {
            return true;
        }
        if (this.typeArguments === null && other.typeArguments !== null) {
            return false;
        }
        if (this.typeArguments !== null && other.typeArguments === null) {
            return false;
        }
        if (this.typeArguments.length !== other.typeArguments.length) {
            return false;
        }
        for (var i = 0; i < this.typeArguments.length; i++) {
            //TODO: handle covariance case here.
            //if (!$.ig.util.canAssign(this.typeArguments[ i ], other.typeArguments[ i ])) {
            //    return false;
            //}
            if (!Type.checkEquals(this.typeArguments[i], other.typeArguments[i])) {
                return false;
            }
        }
        return true;
    }
    static checkEquals(type1, type2) {
        if (type1 instanceof Type) {
            return type1.equals(type2);
        }
        else if (type2 instanceof Type) {
            return type2.equals(type1);
        }
        else {
            return type1 === type2;
        }
    }
    static op_Equality(type1, type2) {
        return type1.equals(type2);
    }
    static op_Inequality(type1, type2) {
        return !type1.equals(type2);
    }
    generateString() {
        if (!this.typeArguments || !this.typeArguments.length) {
            return this.identifier.toString();
        }
        else {
            var ret = this.identifier.toString() + "[";
            var first = true;
            for (var i = 0; i < this.typeArguments.length; i++) {
                if (this.typeArguments[i] == undefined) {
                    continue;
                }
                if (first) {
                    first = false;
                }
                else {
                    ret += ",";
                }
                if (this.typeArguments[i].toString) {
                    ret += this.typeArguments[i].toString();
                }
                else {
                    ret += this.typeArguments[i].identifier.toString();
                }
            }
            ret += "]";
            return ret;
        }
    }
    get isValueType() {
        return this.baseType === ValueType.prototype.$type;
    }
    isAssignableFrom(tOther) {
        // TODO: Unit test and make sure this is right (especially with generics
        if (this === tOther) {
            return true;
        }
        if (tOther.baseType && this.isAssignableFrom(tOther.baseType)) {
            return true;
        }
        if (tOther.interfaces) {
            for (var i = 0; i < tOther.interfaces.length; i++) {
                if (this.isAssignableFrom(tOther.interfaces[i])) {
                    return true;
                }
            }
        }
        return false;
    }
    isInstanceOfType(value) {
        return typeCast(this, value) !== null;
    }
    get isPrimitive() {
        return this === Number_$type ||
            this === Boolean_$type;
    }
    static canAssign(targetType, type) {
        if (targetType.name === 'Nullable$1' && type.name !== 'Nullable$1') {
            targetType = Nullable.getUnderlyingType(targetType);
        }
        return Type.canAssignSimple(targetType, type);
    }
    static canAssignSimple(targetType, type) {
        if (targetType === type || Type.checkEquals(targetType, type)) {
            return true;
        }
        if (type.interfaces) {
            for (var i = 0; i < type.interfaces.length; i++) {
                if (Type.canAssignSimple(targetType, type.interfaces[i])) {
                    return true;
                }
            }
        }
        if (type.baseType) {
            return Type.canAssignSimple(targetType, type.baseType);
        }
        return false;
    }
    static createInstance($t) {
        if ($t === Number || $t == Number_$type ||
            $t.isEnumType) {
            return 0;
        }
        if ($t == Boolean || $t == Boolean_$type) {
            return false;
        }
        if ($t.InstanceConstructor) {
            var result;
            //result = Object.create((<Type>$t).InstanceConstructor.prototype);
            let C = $t.InstanceConstructor;
            //(<Type>$t).InstanceConstructor.apply(result, Array.prototype.slice.call(arguments, 1));
            result = new C(...Array.prototype.slice.call(arguments, 1));
            return result;
        }
        throw new Error("Cannot find instance constructor for the type parameter");
    }
    ;
    static getDefaultValue($t) {
        if ($t === Number_$type ||
            $t.isEnumType) {
            return 0;
        }
        if ($t == Boolean_$type) {
            return false;
        }
        if ($t.baseType === ValueType.$type) {
            return Type.createInstance($t);
        }
        return null;
    }
    ;
    static getPrimitiveHashCode(v) {
        var val = typeof v;
        if (val === "string" || v instanceof String) {
            var hash = 0, i, chr, len;
            if (v.length === 0) {
                return hash;
            }
            for (i = 0, len = this.length; i < len; i++) {
                chr = v.charCodeAt(i);
                /*jslint bitwise: true */
                hash = ((hash << 5) - hash) + chr;
                hash |= 0; // Convert to 32bit integer
            }
            return hash;
        }
        else if (val === "boolean" || v instanceof Boolean) {
            return +v;
        }
        else {
            return v;
        }
    }
    // static mark(t: Function, name: string,
    //     baseType: Type = Base.prototype.$type, 
    //     interfaces: Type[] = null, 
    //     staticInitializer: () => void = null) {
    //     t.prototype.$type = new Type(t, name, baseType, interfaces, staticInitializer);
    //     (<any>t).$type = t.prototype.$type;
    // }
    static decodePropType(val) {
        if (val === 0) {
            return Boolean_$type;
        }
        else if (val === 1) {
            return Number_$type;
        }
        else if (val === 2) {
            return String_$type;
        }
        else if (val === 3) {
            return Date_$type;
        }
        else {
            return val;
        }
    }
}
function markDep(depProp, PropMeta, t, changedFunction, props) {
    let names = [];
    let currName = "";
    let currOpts = [];
    let hasDefaultValue = false;
    let defaultValue = null;
    let propType = null;
    let changeHandler = null;
    let setterFunc = null;
    let getterFunc = null;
    let aliasName = null;
    let propertyAlias = null;
    //debugger;
    for (var i = 0; i < props.length; i++) {
        if (i % 2 == 0) {
            currName = props[i];
            if (currName.indexOf(":") >= 0) {
                let parts = currName.split(':');
                if (parts.length == 2) {
                    currName = parts[0];
                    aliasName = parts[1];
                    propertyAlias = currName.substring(0, 1).toLowerCase() + currName.substring(1) + "Property";
                }
                else {
                    currName = parts[0];
                    aliasName = parts[1];
                    if (aliasName.length == 0) {
                        aliasName = currName.substring(0, 1).toLowerCase() + currName.substring(1);
                    }
                    propertyAlias = parts[2];
                }
            }
            else {
                aliasName = currName.substring(0, 1).toLowerCase() + currName.substring(1);
                propertyAlias = aliasName + "Property";
            }
            names.push(currName);
        }
        else {
            currOpts = props[i];
            if (currOpts.length == 2) {
                hasDefaultValue = true;
                defaultValue = currOpts[1];
                propType = Type.decodePropType(currOpts[0]);
            }
            else {
                hasDefaultValue = false;
                propType = Type.decodePropType(currOpts[0]);
            }
            let changedName = currName;
            changeHandler = (o, a) => {
                o[changedFunction].call(o, changedName, a.oldValue, a.newValue);
            };
            let meta = null;
            if (hasDefaultValue) {
                meta = PropMeta.createWithDefaultAndCallback(defaultValue, changeHandler);
            }
            else {
                meta = PropMeta.createWithCallback(changeHandler);
            }
            let dp = depProp.registerAlt(currName, propType, t.$type, meta);
            setterFunc = function (v) {
                this.setValueAlt(dp, v);
            };
            if (propType.isEnumType) {
                getterFunc = function () {
                    return typeGetValue(this.getValueAlt(dp));
                };
            }
            else {
                getterFunc = function () {
                    return this.getValueAlt(dp);
                };
            }
            Object.defineProperty(t.prototype, aliasName, {
                set: setterFunc,
                get: getterFunc,
                configurable: true
            });
            t[propertyAlias] = dp;
        }
    }
    // let superClass = (<any>t).$type.baseType;
    // if (superClass !== null && superClass !== undefined) {
    //     let superNames = superClass.InstanceConstructor.$$p;
    //     if (superNames) {
    //         for (var j = superNames.length - 1; j >= 0; j--) {
    //             names.unshift(superNames[j]);
    //         }
    //     }
    // }
    //(<any>t).$$p = names;
    return names;
}
function typeGetValue(v) {
    if (v !== null && v.$type && v.$type.isEnumType) {
        return v.value;
    }
    return v;
}
function typeCast(targetType, obj) {
    if (obj === undefined || obj === null) {
        return null;
    }
    if (targetType === Array) {
        return ((obj instanceof Array) ? obj : null);
    }
    if (targetType === String) {
        targetType = String_$type;
    }
    if (targetType === Number) {
        targetType = Number_$type;
    }
    if (targetType === Boolean) {
        targetType = Boolean_$type;
    }
    if (targetType === Date) {
        targetType = Date_$type;
    }
    var type = obj;
    if (obj.$type) {
        type = obj.$type;
    }
    else if (typeof obj === 'number') {
        type = targetType === Number ? Number : Number_$type;
    }
    else if (typeof obj === 'string') {
        type = String_$type;
    }
    else if (typeof obj === 'boolean') {
        type = Boolean_$type;
    }
    else if (obj instanceof Date) {
        type = Date_$type;
    }
    else if (obj instanceof Array) {
        type = Array_$type;
    }
    if (Type.canAssignSimple(targetType, type)) {
        return obj;
    }
    if (targetType.name === 'Nullable$1' && type.name !== 'Nullable$1') {
        targetType = Nullable.getUnderlyingType(targetType);
        if (Type.canAssignSimple(targetType, type)) {
            return toNullable(targetType, obj);
        }
        return toNullable(targetType, null);
    }
    return null;
}
function typeCastObjTo$t($t, v) {
    var shouldWrap = false;
    if ($t.isNullable) {
        $t = $t.typeArguments[0];
        shouldWrap = true;
    }
    if (v !== null && $t.isEnumType) {
        v = v.value;
    }
    return shouldWrap ? toNullable($t, v) : v;
}
let pendingStaticCtors = /*@__PURE__*/ new Array();
function markStruct(t, name, baseType = ValueType.prototype.$type, interfaces = null, staticInitializer = null) {
    t.prototype.$type = new Type(t, name, baseType, interfaces, staticInitializer);
    //TODO: do we need/want a flag on the function like we have in js?
    if (typeof t.staticInit === "function") {
        pendingStaticCtors.push(t);
    }
    t.$type = t.prototype.$type;
    t.$ = t.prototype.$type;
    return t.prototype.$type;
}
function markEnum(name, encodedDef) {
    let t = new Type(null, name, Base.prototype.$type, [IConvertible_$type]);
    t.isEnumType = true;
    let parts = encodedDef.split("|");
    let names = [];
    let actualNames = [];
    let namesValuesMap = {};
    let actualNamesValuesMap = {};
    for (var i = 0; i < parts.length; i++) {
        let subParts = parts[i].split(",");
        let nameParts = subParts[0].split(":");
        let name = nameParts[0];
        let actualName = nameParts[0];
        if (nameParts.length > 1) {
            actualName = nameParts[1];
        }
        names.push(name);
        actualNames.push(actualName);
        //TODO: did we support string enums??
        namesValuesMap[name] = parseInt(subParts[1]);
        actualNamesValuesMap[actualName] = parseInt(subParts[1]);
    }
    let info = {
        names: names,
        actualNames: actualNames,
        namesValuesMap: namesValuesMap,
        actualNamesValuesMap: actualNamesValuesMap
    };
    t.enumInfo = info;
    return t;
}
let markTypeInitialized = false;
function markType(t, name, baseType = Base.prototype.$type, interfaces = null, staticInitializer = null) {
    t.prototype.$type = new Type(t, name, baseType, interfaces, staticInitializer);
    if (!markTypeInitialized) {
        markTypeInitialized = true;
        markType(Type, "Type");
        markType(Base, "Base", null);
    }
    //TODO: do we need/want a flag on the function like we have in js?
    if (typeof t.staticInit === "function") {
        pendingStaticCtors.push(t);
    }
    //t.prototype.$ = t.prototype.$type;
    t.$type = t.prototype.$type;
    t.$ = t.prototype.$type;
    return t.prototype.$type;
}
function callStaticConstructors() {
    if (pendingStaticCtors.length > 0) {
        //TODO: is the copy of the array needed? 
        let classes = Array.from(pendingStaticCtors);
        pendingStaticCtors.length = 0;
        for (let c of classes) {
            c.staticInit();
        }
    }
}
let IConvertible_$type = /*@__PURE__*/ new Type(null, "IConvertible");
let Enum = /*@__PURE__*/ (() => {
    class Enum extends Base {
    }
    Enum.$t = /*@__PURE__*/ markType(Enum, "Enum");
    return Enum;
})();
class EnumBox extends Enum {
    constructor(value, type) {
        super();
        this.value = value;
        this.$type = type;
    }
    getHashCode() {
        return this.value;
    }
    // TODO: Fill out remaining IConvertible implementation
    toDouble(provider) {
        return this.value;
    }
    toString() {
        return EnumUtil.getName(this.$type, this.value);
    }
}
function getBoxIfEnum($t, v) {
    if (v !== null && $t) { // TODO: Remove the $t check here and fix the null ref issue
        if ($t.isNullable) {
            $t = $t.typeArguments[0];
        }
        if ($t.isEnumType) {
            return enumGetBox($t, v);
        }
    }
    return v;
}
;
function enumGetBox($t, v) {
    if (!$t._boxes) {
        $t._boxes = {};
    }
    if (!$t._boxes[v]) {
        $t._boxes[v] = new EnumBox(v, $t);
    }
    return $t._boxes[v];
}
class EnumUtil {
    static getValueFromName(values, enumType, value, ignoreCase) {
        if (values.hasOwnProperty(value)) {
            return enumGetBox(enumType, values[value]);
        }
        else if (ignoreCase) {
            var upper = value.toUpperCase();
            for (var x in values) {
                if (x.toUpperCase() === upper) {
                    return enumGetBox(enumType, values[x]);
                }
            }
        }
        else {
            // A.S. Nov 4, 2016 Adjusted to handle case where leading char is _.
            var firstChar = value.charAt(0);
            if (firstChar != "_") {
                value = firstChar.toLowerCase() + value.substr(1);
            }
            else {
                value = "_" + value.charAt(1).toLowerCase() + value.substr(2);
            }
            if (values.hasOwnProperty(value)) {
                return enumGetBox(enumType, values[value]);
            }
        }
        return null;
    }
    static parse(enumType, value, ignoreCase) {
        //var info = Type.getDefinedNameAndNamespace(enumType.fullName);
        //if (Type.canAssign(this.$type, enumType)) 
        {
            //var p = info.namespace[ info.name ].prototype;
            var values = enumType.isEnumType ? enumType.enumInfo.actualNamesValuesMap : enumType.InstanceConstructor.prototype;
            let val = EnumUtil.getValueFromName(values, enumType, value, ignoreCase);
            if (val !== null) {
                return val;
            }
            if (enumType.isEnumType) {
                values = enumType.enumInfo.namesValuesMap;
                let val = EnumUtil.getValueFromName(values, enumType, value, ignoreCase);
                if (val !== null) {
                    return val;
                }
            }
        }
        throw new Error("Invalid " + enumType.name + " value: " + value);
    }
    // static $getName(value: number): string {
    // }
    // static $value(): number {
    // }
    //private _v: number;
    static enumHasFlag(value, flag) {
        /*jslint bitwise: true */
        return (value & flag) === flag;
    }
    static toString(enumType, value) {
        return EnumUtil.getName(enumType, value);
    }
    static getName(enumType, v) {
        if (enumType._nameMap == undefined) {
            let vals = EnumUtil.getValues(enumType);
            let names = enumType.isEnumType ? enumType.enumInfo.names : EnumUtil.getNames(enumType);
            let map = {};
            for (let i = 0; i < vals.length; i++) {
                map[vals[i]] = names[i];
            }
            enumType._nameMap = map;
        }
        let lookup = enumType._nameMap;
        return lookup[v];
    }
    static getFlaggedName(enumType, v, getName) {
        var names = [];
        var original = v;
        var zeroValueName;
        var value;
        var values = [];
        for (var p in this) {
            if (this.hasOwnProperty(p)) {
                value = enumType[p];
                if (typeof enumType[p] == "number") {
                    values.push(p);
                }
            }
        }
        values.sort((a, b) => { return this[a] - this[b]; });
        for (var i = values.length - 1; i >= 0; i--) {
            value = this[values[i]];
            if (value === 0) {
                zeroValueName = getName(0);
            }
            /*jslint bitwise: true */
            else if ((v & value) === value) {
                v -= value;
                names.unshift(getName(value));
            }
        }
        if (v !== 0) {
            return original.toString();
        }
        if (original !== 0) {
            return names.join(", ");
        }
        return zeroValueName || "0";
    }
    static getValues($t) {
        var result = [];
        if ($t.isEnumType) {
            for (let i = 0; i < $t.enumInfo.actualNames.length; i++) {
                result.push($t.enumInfo.actualNamesValuesMap[$t.enumInfo.actualNames[i]]);
            }
            return result;
        }
        var p = $t.isEnumType ?
            $t.enumInfo.actualNames : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (typeof p[member] === "number") {
                    result.push(p[member]);
                }
            }
        }
        return result;
    }
    static getNames($t) {
        var result = [];
        if ($t.isEnumType) {
            for (let i = 0; i < $t.enumInfo.actualNames.length; i++) {
                result.push($t.enumInfo.actualNames[i]);
            }
            return result;
        }
        var p = $t.isEnumType ?
            $t.enumInfo.actualNames : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (typeof p[member] === "number") {
                    result.push(member);
                }
            }
        }
        return result;
    }
    static getEnumValue($t, v) {
        if (v !== null) {
            if (typeof v === "number") {
                return v;
            }
            else {
                return v.value;
            }
        }
        return 0;
    }
    static isDefined($t, value) {
        value = typeGetValue(value);
        var p = $t.isEnumType ?
            $t.enumInfo.actualNamesValuesMap : $t.InstanceConstructor.prototype;
        for (var member in p) {
            if (p.hasOwnProperty(member)) {
                if (p[member] === value) {
                    return true;
                }
            }
        }
        return false;
    }
    // TODO: Fill out remaining IConvertible implementation
    static toDouble(enumType, value, provider) {
        return value.value;
    }
    static toObject($t, value) {
        return value;
    }
    static tryParse$1($tEnum, value, ignoreCase, result) {
        try {
            return {
                ret: true,
                p2: typeGetValue(EnumUtil.parse($tEnum, value, ignoreCase))
            };
        }
        catch (e) {
            result = Type.createInstance($tEnum);
            return {
                ret: false,
                p2: result
            };
        }
    }
}
let ValueType = /*@__PURE__*/ (() => {
    class ValueType extends Base {
    }
    ValueType.$t = /*@__PURE__*/ markType(ValueType, "ValueType");
    return ValueType;
})();
let Nullable = /*@__PURE__*/ (() => {
    class Nullable extends Base {
        static getUnderlyingType(nullableType) {
            if (nullableType.isGenericType !== undefined && nullableType.isGenericType &&
                !nullableType.isGenericTypeDefinition &&
                Nullable$1.prototype.$type.typeName == nullableType.typeName) {
                return nullableType.genericTypeArguments[0];
            }
            return null;
        }
    }
    Nullable.$t = /*@__PURE__*/ markType(Nullable, "Nullable");
    return Nullable;
})();
let Nullable$1 = /*@__PURE__*/ (() => {
    class Nullable$1 extends Base {
        constructor($t, value) {
            super();
            this.$t = null;
            this._value = null;
            this.isNullable = true;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            if (value !== undefined) {
                this._value = value;
            }
        }
        static nullableEquals(v1, v2) {
            /*jshint eqnull:true */
            var v1IsNull = (v1 == null) || (!!v1.isNullable && !v1.hasValue);
            var v2IsNull = (v2 == null) || (!!v2.isNullable && !v2.hasValue);
            if (v1IsNull && v2IsNull) {
                return true;
            }
            if (v1IsNull != v2IsNull) {
                return false;
            }
            var val1 = v1;
            var val2 = v2;
            if (v1.isNullable) {
                val1 = v1.value;
            }
            if (v2.isNullable) {
                val2 = v2.value;
            }
            return val1 == val2;
        }
        equals(value) {
            return Nullable$1.nullableEquals(this, value);
        }
        getHashCode() {
            if (this._value === null) {
                return 0;
            }
            if (this._value["getHashCode"] !== undefined) {
                return this._value.getHashCode();
            }
            return Type.getPrimitiveHashCode(this._value);
        }
        get hasValue() {
            return this._value !== null;
        }
        toString() {
            return this._value === null ? "" : this._value.toString();
        }
        get value() {
            return this._value;
        }
        set value(value) {
            this._value = value;
        }
        getValueOrDefault() {
            if (this.hasValue) {
                return this._value;
            }
            else {
                return this.getDefaultValue();
            }
        }
        getDefaultValue() {
            if (Type.canAssign(Number_$type, this.$t)) {
                return 0;
            }
            else if (Type.canAssign(Boolean_$type, this.$t)) {
                return false;
            }
            else if (this.$t.baseType == ValueType.prototype.$type) {
                return Type.createInstance(this.$t);
            }
            else {
                return null;
            }
        }
        getValueOrDefault1(defaultValue) {
            if (this.hasValue) {
                return this._value;
            }
            else {
                return defaultValue;
            }
        }
        preIncrement() {
            if (!this.hasValue) {
                return this;
            }
            this._value = (this._value + 1);
            return this;
        }
        preDecrement() {
            if (!this.hasValue) {
                return this;
            }
            this._value = (this._value - 1);
            return this;
        }
        postIncrement() {
            if (!this.hasValue) {
                return this;
            }
            var originalValue = this._value;
            this._value = (this._value + 1);
            return new Nullable$1(this.$t, originalValue);
        }
        postDecrement() {
            if (!this.hasValue) {
                return this;
            }
            var originalValue = this._value;
            this._value = (this._value - 1);
            return new Nullable$1(this.$t, originalValue);
        }
    }
    Nullable$1.$t = /*@__PURE__*/ markType(Nullable$1, "Nullable$1");
    return Nullable$1;
})();
function toNullable(t, value) {
    if (value == null) {
        return t._$nullNullable || (t._$nullNullable = new Nullable$1(t, null));
    }
    else if (value.isNullable) {
        return value;
    }
    return new Nullable$1(t, value);
}
let IComparable_$type = /*@__PURE__*/ new Type(null, "IComparable");
let IComparable$1_$type = /*@__PURE__*/ new Type(null, "IComparable$1");
let IEquatable$1_$type = /*@__PURE__*/ new Type(null, "IEquatable$1");
let INotifyPropertyChanged_$type = /*@__PURE__*/ new Type(null, "INotifyPropertyChanged");
let PropertyChangedEventArgs = /*@__PURE__*/ (() => {
    class PropertyChangedEventArgs extends Base {
        constructor(propertyName) {
            super();
            this._propertyName = null;
            this._propertyName = propertyName;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(value) {
            this._propertyName = value;
        }
    }
    PropertyChangedEventArgs.$t = /*@__PURE__*/ markType(PropertyChangedEventArgs, "PropertyChangedEventArgs");
    return PropertyChangedEventArgs;
})();
class IteratorWrapper {
    constructor(inner, getNew) {
        this._inner = null;
        this._getNew = null;
        this._hasNext = true;
        this._current = null;
        this._inner = inner;
        this._getNew = getNew;
    }
    moveNext() {
        let next = this._inner.next();
        this._hasNext = !next.done;
        this._current = next.value;
        return this._hasNext;
    }
    get current() {
        return this._current;
    }
    get currentObject() {
        return this._current;
    }
    dispose() {
    }
    reset() {
        this._inner = this._getNew();
        this._current = null;
        this._hasNext = true;
    }
}
class IterableWrapper {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    getEnumerator() {
        return new IteratorWrapper(this._inner()[Symbol.iterator](), () => this._inner()[Symbol.iterator]());
    }
    getEnumeratorObject() {
        return new IteratorWrapper(this._inner()[Symbol.iterator](), () => this._inner()[Symbol.iterator]());
    }
}
class EnumeratorWrapper {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    next() {
        let done = !this._inner.moveNext();
        let value = null;
        if (!done) {
            value = this._inner.current;
        }
        return {
            done: done,
            value: value
        };
    }
}
class EnumeratorWrapperObject {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    next() {
        let done = !this._inner.moveNext();
        let value = null;
        if (!done) {
            value = this._inner.currentObject;
        }
        return {
            done: done,
            value: value
        };
    }
}
function* getEn(arr) {
    for (let item of arr) {
        yield item;
    }
}
function getEnumeratorObject(en) {
    if ((en instanceof Array || Array.isArray(en))) {
        let arr = en;
        return new IteratorWrapper(getEn(arr), () => getEn(arr));
    }
    return en.getEnumeratorObject();
}
function getEnumerator(en) {
    if ((en instanceof Array || Array.isArray(en))) {
        let arr = en;
        return new IteratorWrapper(getEn(arr), () => getEn(arr));
    }
    return en.getEnumerator();
}
class EnumerableWrapper {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    [Symbol.iterator]() {
        return new EnumeratorWrapper(getEnumerator(this._inner));
    }
}
class EnumerableWrapperObject {
    constructor(inner) {
        this._inner = null;
        this._inner = inner;
    }
    [Symbol.iterator]() {
        return new EnumeratorWrapperObject(getEnumeratorObject(this._inner));
    }
}
function toEnum(v) {
    return new IterableWrapper(v);
}
function fromEnum(v) {
    return new EnumerableWrapper(v);
}
function toEn(v) {
    return new IterableWrapper(v);
}
function fromEn(v) {
    return new EnumerableWrapperObject(v);
}
function* fromDict(v) {
    for (let item of v) {
        let [key, value] = item;
        yield { key: key, value: value };
    }
}
let Number_$type = /*@__PURE__*/ new Type(Number, "Number", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let String_$type = /*@__PURE__*/ new Type(String, "String", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let Date_$type = /*@__PURE__*/ new Type(Date, "Date", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let Boolean_$type = /*@__PURE__*/ new Type(Boolean, "Boolean", Base.prototype.$type, [IComparable_$type, IConvertible_$type]);
let Void_$type = /*@__PURE__*/ new Type(null, "Void", Base.prototype.$type);
let n$ = Number_$type;
let s$ = String_$type;
let d$ = Date_$type;
let b$ = Boolean_$type;
let v$ = Void_$type;
let Delegate_$type = /*@__PURE__*/ new Type(null, "Delegate");
function runOn(target, func) {
    var self = func;
    var ret = function () {
        return self.apply(target, arguments);
    };
    ret.original = self;
    ret.target = target;
    return ret;
}
function delegateCombine(del1, del2) {
    if (!del1) {
        return del2;
    }
    if (!del2) {
        return del1;
    }
    var ret = function () {
        del1.apply(null, arguments);
        return del2.apply(null, arguments);
    };
    ret.enumerate = function (arr) {
        if (del1) {
            if (del1.enumerate) {
                del1.enumerate(arr);
            }
            else {
                arr.push(del1);
            }
        }
        if (del2) {
            if (del2.enumerate) {
                del2.enumerate(arr);
            }
            else {
                arr.push(del2);
            }
        }
    };
    return ret;
}
;
function delegateRemove(del1, del2) {
    if (!del1) {
        return null;
    }
    if (!del2) {
        return del1;
    }
    var arr = [];
    var del = null;
    if (del1.enumerate) {
        del1.enumerate(arr);
    }
    else {
        arr.push(del1);
    }
    for (var i = 0; i < arr.length; i++) {
        if (del2.original) {
            if (arr[i].original == del2.original &&
                arr[i].target == del2.target) {
                continue;
            }
        }
        if (arr[i] == del2) {
            continue;
        }
        del = delegateCombine(del, arr[i]);
    }
    return del;
}
;
let IDisposable_$type = /*@__PURE__*/ new Type(null, 'IDisposable');
let IEnumerable_$type = /*@__PURE__*/ new Type(null, "IEnumerable");
let IEnumerator_$type = /*@__PURE__*/ new Type(null, "IEnumerator");
let IEqualityComparer$1_$type = /*@__PURE__*/ new Type(null, "IEqualityComparer$1");
let IEqualityComparer_$type = /*@__PURE__*/ new Type(null, "IEqualityComparer");
let ICollection_$type = /*@__PURE__*/ new Type(null, "ICollection", null, [IEnumerable_$type]);
let IList_$type = /*@__PURE__*/ new Type(null, "IList", null, [IEnumerable_$type, ICollection_$type]);
let IEnumerable$1_$type = /*@__PURE__*/ new Type(null, "IEnumerable$1", null, [IEnumerable_$type]);
let ICollection$1_$type = /*@__PURE__*/ new Type(null, "ICollection$1", null, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0), IEnumerable_$type]);
let IList$1_$type = /*@__PURE__*/ new Type(null, "IList$1", null, [
    /*@__PURE__*/ ICollection$1_$type.specialize(0),
    /*@__PURE__*/ IEnumerable$1_$type.specialize(0),
    IEnumerable_$type
]);
let IEnumerator$1_$type = /*@__PURE__*/ new Type(null, "IEnumerator$1", null, [IEnumerator_$type, IDisposable_$type]);
let IDictionary_$type = /*@__PURE__*/ new Type(null, "IDictionary");
let BaseError = /*@__PURE__*/ (() => {
    class BaseError extends Base {
        constructor(initNumber = -1, ...rest) {
            super();
            this._message = null;
            this._innerException = null;
            if (initNumber >= 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
            }
            return;
        }
        get_message() {
            return this._message;
        }
        get message() {
            return this.get_message();
        }
        get innerException() {
            return this._innerException;
        }
        init1(initNumber, message) {
            this._message = message;
        }
        init2(initNumber, message, innerException) {
            this._message = message;
            this._innerException = innerException;
        }
        toString() {
            return this._message;
        }
    }
    BaseError.$t = /*@__PURE__*/ markType(BaseError, "BaseError");
    return BaseError;
})();
let SystemException = /*@__PURE__*/ (() => {
    class SystemException extends BaseError {
        constructor(initNumber, ...rest) {
            super(0);
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }
            //super(0);
        }
        init1(initNumber, message) {
            super.init1(1, message);
        }
        init2(initNumber, message, innerException) {
            super.init2(2, message, innerException);
        }
    }
    SystemException.$t = /*@__PURE__*/ markType(SystemException, "SystemException", BaseError.prototype.$type);
    return SystemException;
})();
let NotSupportedException = /*@__PURE__*/ (() => {
    class NotSupportedException extends SystemException {
        constructor(initNumber, ...rest) {
            super(0);
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }
        }
        init1(initNumber, message) {
            super.init1(1, message);
        }
        init2(initNumber, message, innerException) {
            super.init2(2, message, innerException);
        }
    }
    NotSupportedException.$t = /*@__PURE__*/ markType(NotSupportedException, "NotSupportedException", SystemException.prototype.$type);
    return NotSupportedException;
})();
let FormatException = /*@__PURE__*/ (() => {
    class FormatException extends SystemException {
        constructor(initNumber, ...rest) {
            super(0);
            if (initNumber > 0) {
                switch (initNumber) {
                    case 1:
                        this.init1.apply(this, arguments);
                        break;
                    case 2:
                        this.init2.apply(this, arguments);
                        break;
                }
                return;
            }
        }
        init1(initNumber, message) {
            super.init1(1, message);
        }
        init2(initNumber, message, innerException) {
            super.init2(2, message, innerException);
        }
    }
    FormatException.$t = /*@__PURE__*/ markType(FormatException, "FormatException", SystemException.prototype.$type);
    return FormatException;
})();
class PointUtil {
    static equals(p1, p2) {
        if (p1 == null && p2 == null) {
            return true;
        }
        if (p1 == null && p2 != null) {
            return false;
        }
        if (p1 != null && p2 == null) {
            return false;
        }
        return p1.x == p2.x && p1.y == p2.y;
    }
    static notEquals(p1, p2) {
        return !PointUtil.equals(p1, p2);
    }
    static create() {
        return { x: 0, y: 0, $type: Point_$type };
    }
    static createXY(x, y) {
        return { x: x, y: y, $type: Point_$type };
    }
}
let Point_$type = /*@__PURE__*/ new Type(null, "Point");
var SeekOrigin = /*@__PURE__*/ (function (SeekOrigin) {
    SeekOrigin[SeekOrigin["Begin"] = 0] = "Begin";
    SeekOrigin[SeekOrigin["Current"] = 1] = "Current";
    SeekOrigin[SeekOrigin["End"] = 2] = "End";
    return SeekOrigin;
})({});
let Stream = /*@__PURE__*/ (() => {
    class Stream extends Base {
        close() {
            this.disposeCore(true);
        }
        dispose() {
            this.close();
        }
        disposeCore(disposing) {
        }
        readByte() {
            var bytes = [0];
            var count = this.read(bytes, 0, 1);
            if (count === 0) {
                return -1;
            }
            return bytes[0];
        }
        writeByte(value) {
            this.write([value], 0, 1);
        }
    }
    Stream.$t = /*@__PURE__*/ markType(Stream, "Stream");
    return Stream;
})();
let EventArgs = /*@__PURE__*/ (() => {
    class EventArgs extends Base {
        static get empty() {
            if (EventArgs._empty) {
                return EventArgs._empty;
            }
            EventArgs._empty = new EventArgs;
            return EventArgs._empty;
        }
    }
    EventArgs.$t = /*@__PURE__*/ markType(EventArgs, "EventArgs");
    return EventArgs;
})();
let IFormatProvider_$type = /*@__PURE__*/ new Type(null, 'IFormatProvider');
let Array_$type = /*@__PURE__*/ new Type(Array, "Array", Base.prototype.$type, [IEnumerable_$type, ICollection_$type]);
let a$ = Array_$type;
let TypeRegistrar = /*@__PURE__*/ (() => {
    class TypeRegistrar {
        static create(typeName, ...rest) {
            if (TypeRegistrar.isRegistered(typeName)) {
                let C = TypeRegistrar.get(typeName);
                if (C.htmlTagName) {
                    return document.createElement(C.htmlTagName);
                }
                else {
                    return new C(...rest);
                }
            }
            else {
                return null;
            }
        }
        static register(typeName, type) {
            TypeRegistrar._registrar.set(typeName, type.InstanceConstructor);
        }
        static registerCons(typeName, type) {
            TypeRegistrar._registrar.set(typeName, type);
        }
        static callRegister(typeName) {
            let type = TypeRegistrar.get(typeName);
            if (type !== undefined && type !== null &&
                type["register"] !== undefined) {
                type["register"]();
            }
        }
        static isRegistered(typeName) {
            return TypeRegistrar.get(typeName) !== null;
        }
        static get(typeName) {
            if (TypeRegistrar._registrar.has(typeName)) {
                return TypeRegistrar._registrar.get(typeName);
            }
            if (typeName.indexOf("Igx") == 0) {
                let igc = typeName.replace("Igx", "Igc");
                if (TypeRegistrar._registrar.has(igc)) {
                    return TypeRegistrar._registrar.get(igc);
                }
                let igr = typeName.replace("Igx", "Igr");
                if (igr.indexOf("Component") == igr.length - 9) {
                    igr = igr.substring(0, igr.length - 9);
                }
                if (TypeRegistrar._registrar.has(igr)) {
                    return TypeRegistrar._registrar.get(igr);
                }
            }
            return null;
        }
        static createFromInternal(internal, prefix, postfix) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            let name = internal.$type.name;
            let externalName = prefix + name + postfix;
            if (!TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return TypeRegistrar.create(externalName);
        }
    }
    TypeRegistrar._registrar = /*@__PURE__*/ new Map();
    return TypeRegistrar;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IArray_$type = /*@__PURE__*/ new Type(null, 'IArray');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IArrayList_$type = /*@__PURE__*/ new Type(null, 'IArrayList');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function arrayCopyTo(source, dest, index) {
    for (var i = 0; i < source.length; i++) {
        dest[index++] = source[i];
    }
}
function arrayCopy(source, sourceIndex, dest, destIndex, count) {
    for (var i = 0; i < count; i++) {
        dest[destIndex + i] = source[sourceIndex + i];
    }
}
function arrayInsert(target, index, item) {
    target.splice(index, 0, item);
}
function arrayRemoveAt(target, index) {
    target.splice(index, 1);
}
function arrayRemoveItem(target, item) {
    var index = target.indexOf(item);
    if (index >= 0) {
        target.splice(index, 1);
        return true;
    }
    return false;
}
function arrayGetValue(target, index) {
    return target[index];
}
function arrayGetLength(target, dimension) {
    // TODO: Is there a better way to do this? Maybe attach the rank values to the array?
    var array = target;
    var dim = dimension;
    while (array) {
        if (dim === 0) {
            return array.length;
        }
        dim--;
        array = array[0];
    }
    return -1;
}
function arrayGetRank(target) {
    return 1;
}
function arrayResize(target, length) {
    target.length = 0;
}
function arrayInsertRange(target, index, items) {
    var i = 0;
    if (target.length === 0) {
        for (i = 0; i < items.length; i++) {
            target[index++] = items[i];
        }
    }
    else {
        for (i = 0; i < items.length; i++) {
            target.splice(index++, 0, items[i]);
        }
    }
}
function arrayInsertRange1(target, index, items) {
    //TODO: adjust this later, but this is the safest change to make right now.
    var i = 0;
    if (target.length === 0) {
        for (i = 0; i < items.length; i++) {
            target[index++] = items[i];
        }
    }
    else {
        for (i = 0; i < items.length; i++) {
            target.splice(index++, 0, items[i]);
        }
    }
}
function arrayShallowClone(arr) {
    var newArr = [];
    for (var i = 0; i < arr.length; i++) {
        newArr[i] = arr[i];
    }
    return newArr;
}
function arrayClear(arr) {
    arr.length = 0;
}
//   export function listItem(list: any, index: number, item?: any): void {
//       if ((<any>list).$type === undefined) {
//           let arr = <any[]>list;
//           if (item !== undefined) {
//               arr[index] = item;
//               return item;
//           } else {
//               return arr[index];
//           }
//       }
//       if (item !== undefined) {
//           list.item(index, item);
//           return item;
//       }
//       return list.item(index);
//   }
//export function  listAdd(list: any, item: any): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					arrayInsert(arr, arr.length, item);
//					return;
//			}
//			list.add(item);
//	}
//export function  listClear(list: any): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					arrayClear(arr);
//					return;
//			}
//			list.clear();
//	}
//export function listContains(list: any, item: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return arr.indexOf(item) > -1;
//			}
//			return list.contains(item);
//	}
//export function listIndexOf(list: any, item: any): number {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return arr.indexOf(item);
//			}
//			return list.indexOf(item);
//	}
//export function listInsert(list: any, index: number, item: any): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					arrayInsert(arr, index, item);
//					return;
//			}
//			list.contains(item);
//	}
//export function listRemove(list: any, item: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//                       arrayRemoveItem(arr, item);
//                       return true;
//			}
//			return list.remove(item);
//	}
//export function listRemoveAt(list: any, index: number): void {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//                       arrayRemoveAt(arr, index);
//                       return;
//			}
//			list.removeAt(index);
//	}
//export function listIsFixedSize(list: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return false;
//			}
//			return list.isFixedSize;
//	}
//export function listIsReadOnly(list: any): boolean {
//			if ((<any>list).$type === undefined) {
//					let arr = <any[]>list;
//					return false;
//			}
//			return list.isReadOnly;
//	}
//export function collectionCount(collection: any): number {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					return arr.length;
//			}
//			return collection.count;
//	}
//export function collectionCopyTo(collection: any, array: any[], index: number): void {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					arrayCopy(arr, 0, array, index, arr.length);
//					return;
//			}
//			return collection.copyTo(array, index);
//	}
//export function collectionIsSynchronized(collection: any): boolean {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					return false;
//			}
//			return collection.isSynchronized;
//	}
//export function collectionSyncRoot(collection: any): any {
//			if ((<any>collection).$type === undefined) {
//					let arr = <any[]>collection;
//					return arr;
//			}
//			return collection.syncRoot;
//   }
function boxArray$1(array) {
    return new ArrayBox$1(array);
}
function unboxArray(box) {
    if (box.$arrayWrapper) {
        return box._target;
    }
    return box;
}
function arrayListCreate() {
    return new ArrayBox$1([]);
}
class ArrayBox$1 {
    constructor(target) {
        this.isFixedSize = false;
        this.isSynchronized = false;
        this.syncRoot = null;
        this.isReadOnly = false;
        this.$arrayWrapper = true;
        this._target = target;
    }
    item(index, value) {
        if (arguments.length === 2) {
            this._target[index] = value;
            return value;
        }
        else {
            return this._target[index];
        }
    }
    indexOf(item) {
        return this._target.indexOf(item);
    }
    insert(index, item) {
        this._target.splice(index, 0, item);
    }
    insertRange(index, items) {
        arrayInsertRange(this._target, index, items);
    }
    removeRange(index, count) {
        this._target.splice(index, count);
    }
    removeAt(index) {
        this._target.splice(index, 1);
    }
    get count() {
        return this._target.length;
    }
    add(item) {
        this._target.push(item);
    }
    clear() {
        this._target.length = 0;
    }
    contains(item) {
        return this._target.indexOf(item) >= 0;
    }
    copyTo(array, arrayIndex) {
        for (let i = 0; i < this._target.length; i++) {
            array[i + arrayIndex] = this._target[i];
        }
    }
    remove(item) {
        let index = this._target.indexOf(item);
        if (index < 0) {
            return false;
        }
        this._target.splice(index, 1);
        return true;
    }
    getEnumerator() {
        return getEnumerator(this._target);
    }
    getEnumeratorObject() {
        return getEnumeratorObject(this._target);
    }
    getHashCode() {
        return Base.getHashCodeStatic(this._target);
    }
    equals(other) {
        if (other.$arrayWrapper) {
            other = other._target;
        }
        return this._target === other;
    }
    get $type() {
        return Array_$type;
    }
    reverse() {
        let len = this._target.length;
        for (let i = 0; i < len / 2.0; i++) {
            let swap = this._target[(len - 1) - i];
            this._target[(len - 1) - i] = this._target[i];
            this._target[i] = swap;
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IComparer_$type = /*@__PURE__*/ new Type(null, 'IComparer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IComparer$1_$type = /*@__PURE__*/ new Type(null, 'IComparer$1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class CompareUtil {
    static compareToObject(obj1, obj2) {
        if (obj1.compareToObject) {
            return obj1.compareToObject(obj2);
        }
        return Base.compare(obj1, obj2);
    }
    static compareTo(obj1, obj2) {
        if (obj1.compareTo) {
            return obj1.compareTo(obj2);
        }
        return Base.compare(obj1, obj2);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Comparer$1 = /*@__PURE__*/ (() => {
    class Comparer$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        static defaultComparerValue($t) {
            return new DefaultComparer$1($t);
        }
        static a($t, a) {
            return null;
        }
        compareObject(a, b) {
            return this.compare(typeCastObjTo$t(this.$t, a), typeCastObjTo$t(this.$t, b));
        }
    }
    Comparer$1.$t = /*@__PURE__*/ markType(Comparer$1, 'Comparer$1', Base.$, [IComparer_$type, /*@__PURE__*/ IComparer$1_$type.specialize(0)]);
    return Comparer$1;
})();
/**
 * @hidden
 */
let DefaultComparer$1 = /*@__PURE__*/ (() => {
    class DefaultComparer$1 extends Comparer$1 {
        constructor($t) {
            super($t);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        compare(a, b) {
            let c = typeCast(IComparable$1_$type.specialize(this.$t), a);
            if (c != null) {
                return CompareUtil.compareTo(c, b);
            }
            let d = typeCast(IComparable$1_$type.specialize(this.$t), b);
            if (d != null) {
                return -CompareUtil.compareTo(d, a);
            }
            return (Base.compare(a, b));
        }
    }
    DefaultComparer$1.$t = /*@__PURE__*/ markType(DefaultComparer$1, 'DefaultComparer$1', /*@__PURE__*/ Comparer$1.$.specialize(0));
    return DefaultComparer$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ReadOnlyCollection$1 = /*@__PURE__*/ (() => {
    class ReadOnlyCollection$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this.a = null;
            this.c = {};
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.a = c;
                    }
                    break;
            }
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.a.item(a, b);
                return b;
            }
            else {
                return this.a.item(a);
            }
        }
        indexOf(a) {
            return this.a.indexOf(a);
        }
        insert(a, b) {
        }
        removeAt(a) {
        }
        get count() {
            return this.a.count;
        }
        get isReadOnly() {
            return true;
        }
        add(a) {
        }
        clear() {
        }
        contains(a) {
            return this.a.contains(a);
        }
        copyTo(a, b) {
            this.a.copyTo(a, b);
        }
        remove(a) {
            return false;
        }
        getEnumerator() {
            return getEnumerator(this.a);
        }
        getEnumeratorObject() {
            return getEnumerator(this.a);
        }
        get isFixedSize() {
            return true;
        }
        add1(a) {
            return -1;
        }
        contains1(a) {
            return this.a.contains(typeCastObjTo$t(this.$t, a));
        }
        indexOf1(a) {
            return this.a.indexOf(typeCastObjTo$t(this.$t, a));
        }
        insert1(a, b) {
        }
        remove1(a) {
        }
        copyTo1(a, b) {
            this.a.copyTo(a, b);
        }
        get b() {
            return this.a;
        }
        get isSynchronized() {
            return true;
        }
        get syncRoot() {
            return this.c;
        }
    }
    ReadOnlyCollection$1.$t = /*@__PURE__*/ markType(ReadOnlyCollection$1, 'ReadOnlyCollection$1', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(0), IList_$type]);
    return ReadOnlyCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NotImplementedException = /*@__PURE__*/ (() => {
    class NotImplementedException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "not implemented");
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
    }
    NotImplementedException.$t = /*@__PURE__*/ markType(NotImplementedException, 'NotImplementedException', BaseError.$);
    return NotImplementedException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function log10(value) {
    return Math.log(value) / Math.log(10);
}
function toDouble(value) {
    return +value;
}
let toDecimal = toDouble;
function compareTo(value, other) {
    if (value == other) {
        return 0;
    }
    if (value < other) {
        return -1;
    }
    return 1;
}
function isInfinity(value) {
    return !isFinite(value) && !isNaN_(value);
}
function intDivide(value, divisor) {
    var result = value / divisor;
    return truncate(result);
}
function truncate(val) {
    if (val >= 0) {
        return Math.floor(val);
    }
    else {
        return Math.ceil(val);
    }
}
function logBase(n, n2) {
    return Math.log(n) / Math.log(n2);
}
function tryParseNumber(s, v) {
    var value = Number(s);
    if (value !== null && isFinite(value) && s.trim().length !== 0) {
        return {
            p1: value,
            ret: true
        };
    }
    else {
        return {
            p1: 0,
            ret: false
        };
    }
}
function isNegativeInfinity(v) {
    return v == Number.NEGATIVE_INFINITY;
}
function isPositiveInfinity(v) {
    return v == Number.POSITIVE_INFINITY;
}
function isNaN_(v) {
    return v !== v; // http://us6.campaign-archive1.com/?u=2cc20705b76fa66ab84a6634f&id=43bf7f05e9
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function stringStartsWith(str, check) {
    return str.indexOf(check) == 0;
}
function stringEndsWith(str, check) {
    let ind = str.lastIndexOf(check);
    return ind >= 0 && ind == str.length - check.length;
}
function stringContains(str, check) {
    return str.indexOf(check) != -1;
}
function stringCreateFromCharArray(charArray) {
    return charArray.join("");
}
function stringCreateFromChar(char, count) {
    var ret = "";
    for (var i = 0; i < count; i++) {
        ret = ret + char;
    }
    return ret;
}
function stringCreateFromCharArraySlice(charArray, start, length) {
    var ret = "";
    for (var i = 0; i < length; i++) {
        ret = ret + charArray[start + i];
    }
    return ret;
}
;
function stringToCharArray(target) {
    return target.split("");
}
function stringCopyToCharArray(source, sourceIndex, destination, destinationIndex, count) {
    for (var i = destinationIndex; i < destinationIndex + count; i++) {
        destination[i] = source.charAt(sourceIndex + i - destinationIndex);
    }
}
;
function stringIsDigit(str, index) {
    index = index || 0;
    var ch = str.charAt(index);
    if (ch >= "0" && ch <= "9") {
        return true;
    }
    return false;
}
;
function charMaxValue() {
    return "\uffff";
}
function charMinValue() {
    return "\u0000";
}
// static toDateTime(target: string) {
// 	var result = new Date(target);
// 	if (!isNaN(+result)) {
// 		return result;
// 	}
// 	// TODO: Cache this regex?
// 	if (/^((([0-9]{1,4})\s*(\s+((a|p)m?)\s*))|(([0-9]{1,4})\s*:\s*([0-9]?[0-9])\s*(:\s*([0-9]?[0-9])\s*(.\s*([0-9]{0,4})[0-9]*\s*)?)?(\s+((a|p)m?)\s*)?)|(\s*([0-9]?[0-9])\s*:\s*([0-9]?[0-9])\s*.\s*([0-9]{0,4})[0-9]*\s*(\s+((a|p)m?)\s*)?))$/i.test(target)) {
// 		// The string can be a time string only, in which case we should return today at that time.
// 		return new Date(new Date().toDateString() + " " + target);
// 	}
// 	throw new FormatException(1, "The string cannot be converted to a date");
// }
// static toDecimal(target: string) {
// 	var result = +target;
// 	if (isNaN(result)) {
// 		new FormatException(1, "The string cannot be converted to a number");
// 	}
// 	return result;
// }
function stringToString1(target) {
    return target.toString();
}
function stringRemove(target, index, count) {
    if (!count || ((index + count) > target.length)) {
        return target.substr(0, index);
    }
    return target.substr(0, index) + target.substr(index + count);
}
function stringCompareTo(target, other) {
    if (target == other) {
        return 0;
    }
    if (target < other) {
        return -1;
    }
    return 1;
}
let stringCompare = stringCompareTo;
function stringIsNullOrEmpty(target) { return !target || target.length < 1; }
function stringIsNullOrWhiteSpace(target) { return !target || target.trim().length < 1; }
function stringEmpty() { return ""; }
function stringEquals(target, other) { return target == other; }
function stringEscapeRegExp(str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
}
function createGuid() {
    /*jslint bitwise: true */
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (S4() + S4() + "-" + S4() + "-4" + S4().substr(0, 3) + "-" + S4() + "-" + S4() +
        S4() + S4()).toLowerCase();
}
function stringConcat(...s) {
    return String.prototype.concat(...s);
}
function stringReplace(str, oldValue, newValue) {
    return str.replace(new RegExp(stringEscapeRegExp(oldValue), "g"), newValue);
}
function stringJoin(sep, ...vals) {
    return vals.join(sep);
}
function stringJoin1($t, sep, vals) {
    var result;
    var en = getEnumerator(vals);
    while (en.moveNext()) {
        var v = en.current.toString();
        if (result === undefined) {
            result = v;
        }
        else {
            result += sep + v;
        }
    }
    return result;
}
function stringToString$1($t, v) {
    if (v !== null && $t) {
        if ($t.isNullable) {
            $t = $t.typeArguments[0];
        }
        if ($t.isEnumType) {
            return EnumUtil.getName($t, v);
        }
    }
    return v.toString();
}
function stringToLocaleLower(str, locale) {
    if (locale == null || locale.name == null)
        return str.toLocaleLowerCase();
    return str.toLocaleLowerCase(locale.name);
}
function stringToLocaleUpper(str, locale) {
    if (locale == null || locale.name == null)
        return str.toLocaleUpperCase();
    return str.toLocaleUpperCase(locale.name);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let List$1 = /*@__PURE__*/ (() => {
    class List$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this._inner = null;
            this.c = false;
            this.h = 0;
            this.m = {};
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this._inner = ([]);
                        this.c = (this.$t.InstanceConstructor && this.$t.InstanceConstructor.prototype.equals === Base.prototype.equals);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this._inner = ([]);
                            this.c = (this.$t.InstanceConstructor && this.$t.InstanceConstructor.prototype.equals === Base.prototype.equals);
                        }
                        if (this.d(0, c, true)) {
                            return;
                        }
                        for (let d of fromEnum(c)) {
                            this.add(d);
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        {
                            this._inner = ([]);
                            this.c = (this.$t.InstanceConstructor && this.$t.InstanceConstructor.prototype.equals === Base.prototype.equals);
                        }
                    }
                    break;
            }
        }
        x(a, b) {
            this._inner[a] = b;
        }
        r(a, b) {
            this._inner.splice(a, 0, b);
        }
        n(a) {
            this._inner.push(a);
        }
        u(a) {
            if (a == 0) {
                this._inner.shift();
                return;
            }
            this._inner.splice(a, 1);
        }
        p() {
            this._inner = ([]);
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.x(a, b);
                return b;
            }
            else {
                return this._inner[a];
            }
        }
        indexOf(a) {
            if (this.c) {
                return (this._inner.indexOf(a));
            }
            for (let b = 0; b < this._inner.length; b++) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, this._inner[b]))) {
                    return b;
                }
            }
            return -1;
        }
        indexOf2(a, b) {
            if (this.c) {
                return (this._inner.indexOf(a, b));
            }
            for (; b < this._inner.length; b++) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, this._inner[b]))) {
                    return b;
                }
            }
            return -1;
        }
        k(a) {
            if (this.c) {
                return (this._inner.lastIndexOf(a));
            }
            for (let b = this._inner.length - 1; b >= 0; b--) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, this._inner[b]))) {
                    return b;
                }
            }
            return -1;
        }
        insert(a, b) {
            this.r(a, b);
        }
        removeAt(a) {
            this.u(a);
        }
        get count() {
            return this._inner.length;
        }
        get isReadOnly() {
            return false;
        }
        add(a) {
            this.n(a);
        }
        clear() {
            this.p();
        }
        contains(a) {
            return this.indexOf(a) >= 0;
        }
        copyTo(a, b) {
            for (let c = 0; c < this._inner.length; c++) {
                a[b + c] = this._inner[c];
            }
        }
        remove(a) {
            let b = this.indexOf(a);
            if (b < 0) {
                return false;
            }
            this.u(b);
            return true;
        }
        getEnumerator() {
            return getEnumeratorObject(this._inner);
        }
        getEnumeratorObject() {
            return getEnumeratorObject(this._inner);
        }
        asArray() {
            return this._inner;
        }
        d(index_, collection_, a) {
            let b = typeCast(IArrayList_$type, collection_);
            if (b != null) {
                let a_ = b.asArrayList();
                Array.prototype.splice.apply(this._inner, Array.prototype.concat.apply([index_, 0], a_));
                return true;
            }
            let c = typeCast(IArray_$type, collection_);
            if (c != null) {
                let a_ = c.asArray();
                Array.prototype.splice.apply(this._inner, Array.prototype.concat.apply([index_, 0], a_));
                return true;
            }
            let asList_ = typeCast(IList$1_$type.specialize(this.$t), collection_);
            if (asList_ != null) {
                for (let i_ = 0; i_ < asList_.count; i_++) {
                    let item_ = asList_.item(i_);
                    this._inner.splice(index_ + i_, 0, item_);
                }
                return true;
            }
            let arr_ = (Array.isArray(collection_) ? collection_ : null);
            if (arr_ != null) {
                let inn_ = this._inner;
                if (this._inner.length == 0) {
                    if (a) {
                        let parr_ = arr_;
                        let d = arr_.length;
                        for (let i_ = 0; i_ < d; i_++) {
                            inn_[index_++] = parr_[i_];
                        }
                    }
                    else {
                        let e = arr_.length;
                        for (let i_ = 0; i_ < e; i_++) {
                            inn_[index_++] = typeCastObjTo$t(this.$t, arr_[i_]);
                        }
                    }
                }
                else {
                    for (let i_ = 0; i_ < arr_.length; i_++) {
                        inn_.splice(index_++, 0, arr_[i_]);
                    }
                }
                return true;
            }
            return false;
        }
        t(a, b) {
            if (this.d(a, b, false)) {
                return;
            }
            let j_ = a;
            for (let item_ of fromEn(b)) {
                this._inner.splice(j_, 0, item_);
                j_++;
            }
        }
        s(a, b) {
            if (this.d(a, b, true)) {
                return;
            }
            let j_ = a;
            for (let item_ of fromEnum(b)) {
                this._inner.splice(j_, 0, item_);
                j_++;
            }
        }
        v(index_, numToRemove_) {
            if (index_ == 0 && numToRemove_ == 1) {
                this._inner.shift();
                return;
            }
            this._inner.splice(index_, numToRemove_);
        }
        copyTo1(a, b) {
            arrayCopyTo(this._inner, a, b);
        }
        get isFixedSize() {
            return false;
        }
        add1(a) {
            this.n(typeCastObjTo$t(this.$t, a));
            return this._inner.length - 1;
        }
        contains1(a) {
            return this.indexOf1(a) >= 0;
        }
        indexOf1(a) {
            return this.indexOf(typeCastObjTo$t(this.$t, a));
        }
        insert1(a, b) {
            this.r(a, typeCastObjTo$t(this.$t, b));
        }
        remove1(a) {
            let b = this.indexOf1(a);
            if (b < 0) {
                return;
            }
            this.u(b);
        }
        y() {
            let a = null;
            if (this.$t == Number_$type) {
                a = (b, c) => {
                    let d = b;
                    let e = c;
                    if (d < e) {
                        return -1;
                    }
                    if (d == e) {
                        return 0;
                    }
                    return 1;
                };
            }
            else if (this.$t == Number_$type) {
                a = (b, c) => {
                    let d = b;
                    let e = c;
                    if (d < e) {
                        return -1;
                    }
                    if (d == e) {
                        return 0;
                    }
                    return 1;
                };
            }
            else if (this.$t == Number_$type) {
                a = (b, c) => {
                    let d = typeGetValue(b);
                    let e = typeGetValue(c);
                    if (d < e) {
                        return -1;
                    }
                    if (d == e) {
                        return 0;
                    }
                    return 1;
                };
            }
            else if (this.$t == Date_$type) {
                a = (b, c) => {
                    let d = b;
                    let e = c;
                    if (d.getTime() < e.getTime()) {
                        return -1;
                    }
                    if (d.getTime() == e.getTime()) {
                        return 0;
                    }
                    return 1;
                };
            }
            else {
                a = (b, c) => stringCompareTo(b, c);
            }
            this.ab(a);
        }
        ab(compare_) {
            this._inner.sort(compare_);
        }
        aa(compare_) {
            this._inner.sort(compare_);
        }
        o(a) {
            for (let item_ of fromEnum(a)) {
                this._inner.push(item_);
            }
        }
        toArray() {
            return this._inner;
        }
        q(a) {
            for (let b = 0; b < this._inner.length; b++) {
                a(this._inner[b]);
            }
        }
        get isSynchronized() {
            return true;
        }
        get syncRoot() {
            return this.m;
        }
        f(a) {
            return this.g(a, Comparer$1.defaultComparerValue(this.$t));
        }
        g(a, b) {
            let c = 0;
            let d = this.count - 1;
            while (c <= d) {
                let e = c + (intDivide((d - c), 2));
                let f = this._inner[e];
                let g = b.compare(f, a);
                if (g == 0) {
                    return e;
                }
                if (g < 0) {
                    c = e + 1;
                }
                else {
                    d = e - 1;
                }
            }
            return ~c;
        }
        e() {
            return new ReadOnlyCollection$1(this.$t, 1, this);
        }
        w() {
            for (let a = 0; a < intDivide(this.count, 2); a++) {
                let b = this.count - a - 1;
                let c = this._inner[a];
                this._inner[a] = this._inner[b];
                this._inner[b] = c;
            }
        }
        z(a) {
            this.aa(runOn(a, a.compare));
        }
        i(a) {
            for (let b = 0; b < this._inner.length; b++) {
                if (a(this._inner[b])) {
                    return b;
                }
            }
            return -1;
        }
        l(a) {
            throw new NotImplementedException(0);
        }
    }
    List$1.$t = /*@__PURE__*/ markType(List$1, 'List$1', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(0), IArray_$type, IList_$type]);
    return List$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockInfo = /*@__PURE__*/ (() => {
    class StockInfo extends Base {
        constructor() {
            super(...arguments);
            this._company = null;
            this._symbol = null;
            this._sector = null;
        }
        get company() {
            return this._company;
        }
        set company(a) {
            this._company = a;
        }
        get symbol() {
            return this._symbol;
        }
        set symbol(a) {
            this._symbol = a;
        }
        get sector() {
            return this._sector;
        }
        set sector(a) {
            this._sector = a;
        }
    }
    StockInfo.$t = /*@__PURE__*/ markType(StockInfo, 'StockInfo');
    return StockInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPricePoint = /*@__PURE__*/ (() => {
    class StockPricePoint extends StockInfo {
        constructor() {
            super();
            this._open = 0;
            this._high = 0;
            this._low = 0;
            this._close = 0;
            this._volume = 0;
            this._date = new Date();
        }
        get open() {
            return this._open;
        }
        set open(a) {
            this._open = a;
        }
        get high() {
            return this._high;
        }
        set high(a) {
            this._high = a;
        }
        get low() {
            return this._low;
        }
        set low(a) {
            this._low = a;
        }
        get close() {
            return this._close;
        }
        set close(a) {
            this._close = a;
        }
        get volume() {
            return this._volume;
        }
        set volume(a) {
            this._volume = a;
        }
        get date() {
            return this._date;
        }
        set date(a) {
            this._date = a;
        }
    }
    StockPricePoint.$t = /*@__PURE__*/ markType(StockPricePoint, 'StockPricePoint', StockInfo.$);
    return StockPricePoint;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPriceHistory = /*@__PURE__*/ (() => {
    class StockPriceHistory extends List$1 {
        constructor() {
            super(StockPricePoint.$, 0);
            this._symbol = null;
            this._company = null;
            this.symbol = "";
            this.company = "";
        }
        get title() {
            let a = stringIsNullOrEmpty(this.company) ? "" : " - " + this.company;
            return this.symbol + a;
        }
        get symbol() {
            return this._symbol;
        }
        set symbol(a) {
            this._symbol = a;
        }
        get company() {
            return this._company;
        }
        set company(a) {
            this._company = a;
        }
        toString() {
            return this.symbol;
        }
    }
    StockPriceHistory.$t = /*@__PURE__*/ markType(StockPriceHistory, 'StockPriceHistory', /*@__PURE__*/ List$1.$.specialize(StockPricePoint.$));
    return StockPriceHistory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPosition = /*@__PURE__*/ (() => {
    class StockPosition extends StockInfo {
        constructor() {
            super(...arguments);
            this._index = 0;
            this._tradeDate = new Date();
            this._shares = 0;
            this._costPerShare = 0;
            this._marketPrice = 0;
            this._data = null;
            this._action = null;
        }
        get index() {
            return this._index;
        }
        set index(a) {
            this._index = a;
        }
        get tradeDate() {
            return this._tradeDate;
        }
        set tradeDate(a) {
            this._tradeDate = a;
        }
        get shares() {
            return this._shares;
        }
        set shares(a) {
            this._shares = a;
        }
        get costPerShare() {
            return this._costPerShare;
        }
        set costPerShare(a) {
            this._costPerShare = a;
        }
        get costTotal() {
            return Math.round(this.shares * this.costPerShare);
        }
        get marketValue() {
            return Math.round(this.shares * this.marketPrice);
        }
        get marketPrice() {
            return this._marketPrice;
        }
        set marketPrice(a) {
            this._marketPrice = a;
        }
        get gainValue() {
            return Math.round(this.marketValue - this.costTotal);
        }
        get gainPercentage() {
            return this.gainValue / this.costTotal * 100;
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
        get action() {
            return this._action;
        }
        set action(a) {
            this._action = a;
        }
    }
    StockPosition.$t = /*@__PURE__*/ markType(StockPosition, 'StockPosition', StockInfo.$);
    return StockPosition;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockChangedEventArgs = /*@__PURE__*/ (() => {
    class StockChangedEventArgs extends Base {
        constructor(a, b) {
            super();
            this._addedSymbols = null;
            this._removedSymbols = null;
            this.addedSymbols = a;
            this.removedSymbols = b;
        }
        get addedSymbols() {
            return this._addedSymbols;
        }
        set addedSymbols(a) {
            this._addedSymbols = a;
        }
        get removedSymbols() {
            return this._removedSymbols;
        }
        set removedSymbols(a) {
            this._removedSymbols = a;
        }
    }
    StockChangedEventArgs.$t = /*@__PURE__*/ markType(StockChangedEventArgs, 'StockChangedEventArgs');
    return StockChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyValuePair$2 = /*@__PURE__*/ (() => {
    class KeyValuePair$2 extends ValueType {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.a = null;
            this.c = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.a = c;
                        this.c = d;
                    }
                    break;
            }
        }
        get key() {
            return this.a;
        }
        get value() {
            return this.c;
        }
    }
    KeyValuePair$2.$t = /*@__PURE__*/ markStruct(KeyValuePair$2, 'KeyValuePair$2');
    return KeyValuePair$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDictionary$2_$type = /*@__PURE__*/ new Type(null, 'IDictionary$2', null, [/*@__PURE__*/ ICollection$1_$type.specialize(/*@__PURE__*/ KeyValuePair$2.$.specialize(0, 1)), /*@__PURE__*/ IEnumerable$1_$type.specialize(/*@__PURE__*/ KeyValuePair$2.$.specialize(0, 1)), IEnumerable_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EqualityComparer$1 = /*@__PURE__*/ (() => {
    class EqualityComparer$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        static defaultEqualityComparerValue($t) {
            return new DefaultEqualityComparer$1($t);
        }
        equalsC(a, b) {
            return this.equalsC(typeCastObjTo$t(this.$t, a), typeCastObjTo$t(this.$t, b));
        }
        getHashCodeC(a) {
            return this.getHashCodeC(typeCastObjTo$t(this.$t, a));
        }
    }
    EqualityComparer$1.$t = /*@__PURE__*/ markType(EqualityComparer$1, 'EqualityComparer$1', Base.$, [IEqualityComparer_$type, /*@__PURE__*/ IEqualityComparer$1_$type.specialize(0)]);
    return EqualityComparer$1;
})();
/**
 * @hidden
 */
let DefaultEqualityComparer$1 = /*@__PURE__*/ (() => {
    class DefaultEqualityComparer$1 extends EqualityComparer$1 {
        constructor($t) {
            super($t);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        equalsC(a, b) {
            return Base.equalsStatic(getBoxIfEnum(this.$t, a), getBoxIfEnum(this.$t, b));
        }
        getHashCodeC(a) {
            return Base.getHashCodeStatic(a);
        }
    }
    DefaultEqualityComparer$1.$t = /*@__PURE__*/ markType(DefaultEqualityComparer$1, 'DefaultEqualityComparer$1', /*@__PURE__*/ EqualityComparer$1.$.specialize(0));
    return DefaultEqualityComparer$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InvalidOperationException = /*@__PURE__*/ (() => {
    class InvalidOperationException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "Invalid operation");
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
    }
    InvalidOperationException.$t = /*@__PURE__*/ markType(InvalidOperationException, 'InvalidOperationException', BaseError.$);
    return InvalidOperationException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Dictionary_EnumerableCollection$3 = /*@__PURE__*/ (() => {
    class Dictionary_EnumerableCollection$3 extends Base {
        constructor($tKey, $tValue, $t, a, b, c) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.$t = null;
            this.c = null;
            this.b = null;
            this.a = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue, this.$t);
            this.c = b;
            this.b = c;
            this.a = a;
        }
        get count() {
            return this.a.count;
        }
        get isReadOnly() {
            return true;
        }
        add(a) {
            throw new InvalidOperationException(0);
        }
        clear() {
            throw new InvalidOperationException(0);
        }
        contains(a) {
            for (let b of fromEn(this.c)) {
                if (Base.equalsStatic(getBoxIfEnum(this.$t, b), getBoxIfEnum(this.$t, a))) {
                    return true;
                }
            }
            return false;
        }
        copyTo(a, b) {
            for (let c of fromEn(this.c)) {
                a[b++] = c;
            }
        }
        remove(a) {
            throw new InvalidOperationException(0);
        }
        getEnumerator() {
            return getEnumeratorObject(this.c);
        }
        getEnumeratorObject() {
            return getEnumeratorObject(this.c);
        }
    }
    Dictionary_EnumerableCollection$3.$t = /*@__PURE__*/ markType(Dictionary_EnumerableCollection$3, 'Dictionary_EnumerableCollection$3', Base.$, [/*@__PURE__*/ ICollection$1_$type.specialize(2)]);
    return Dictionary_EnumerableCollection$3;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArgumentException = /*@__PURE__*/ (() => {
    class ArgumentException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                    }
                    break;
            }
        }
    }
    ArgumentException.$t = /*@__PURE__*/ markType(ArgumentException, 'ArgumentException', BaseError.$);
    return ArgumentException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Dictionary$2 = /*@__PURE__*/ (() => {
    class Dictionary$2 extends Base {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.j = null;
            this.k = 0;
            this.e = false;
            this.d = false;
            this.c = false;
            this.a = null;
            this.b = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [0, null];
                        {
                            let e = c[0];
                            let f = c[1];
                            this.a = ({});
                            this.b = ({});
                            this.j = f || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                            this.e = f == null && (($tKey === String_$type));
                            this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                            this.c = f == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.a = ({});
                            this.b = ({});
                            this.j = g || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                            this.e = g == null && (($tKey === String_$type));
                            this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                            this.c = g == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [0, c];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.a = ({});
                            this.b = ({});
                            this.j = g || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                            this.e = g == null && (($tKey === String_$type));
                            this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                            this.c = g == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = [c.count];
                        {
                            let f = d[0];
                            let g = [f, null];
                            {
                                let i = g[0];
                                let j = g[1];
                                this.a = ({});
                                this.b = ({});
                                this.j = j || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                                this.e = j == null && (($tKey === String_$type));
                                this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                                this.c = j == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                            }
                        }
                        for (let e of fromEnum(c)) {
                            this.item(e.key, e.value);
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.a = ({});
                        this.b = ({});
                        this.j = d || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey);
                        this.e = d == null && (($tKey === String_$type));
                        this.d = ($tKey === Base.$type || ($tKey.InstanceConstructor && !$tKey.InstanceConstructor.prototype.getHashCode));
                        this.c = d == null && (this.e || this.d || ($tKey.InstanceConstructor && $tKey.InstanceConstructor.prototype.getHashCode == Base.prototype.getHashCode));
                    }
                    break;
            }
        }
        get count() {
            return this.k;
        }
        item(key_, a) {
            if (arguments.length === 2) {
                this.o(key_, a, false);
                return a;
            }
            else {
                let result_ = this.f(key_);
                let a = (result_ !== undefined);
                return a ? result_ : Type.getDefaultValue(this.$tValue);
            }
        }
        get m() {
            return this.k;
        }
        containsKey(a) {
            if (this.c) {
                let b = this.n(a);
                return (this.a.hasOwnProperty(b));
            }
            else {
                let c = this.l(a);
                let d = this.b[c];
                if (d) {
                    if ((d.$isHashSetBucket)) {
                        let g = (d);
                        for (let f = 0; f < g.length; f++) {
                            let e = g[f];
                            if (this.j.equalsC((e.key), a)) {
                                return true;
                            }
                        }
                    }
                    else {
                        return this.j.equalsC((d.key), a);
                    }
                }
            }
            return false;
        }
        removeItem(a) {
            if (this.c) {
                let b = this.n(a);
                if ((!this.a.hasOwnProperty(b))) {
                    return false;
                }
                delete this.a[b];
                delete this.b[b];
                this.k--;
                return true;
            }
            let c = this.l(a);
            let d = this.b[c];
            if (d) {
                if ((d.$isHashSetBucket)) {
                    let g = (d);
                    for (let f = 0; f < g.length; f++) {
                        let e = g[f];
                        if (this.j.equalsC((e.key), a)) {
                            arrayRemoveItem(d, e);
                            if ((d.length) == 1) {
                                this.b[c] = (d[0]);
                            }
                            this.k--;
                            return true;
                        }
                    }
                }
                else {
                    if (this.j.equalsC((d.key), a)) {
                        delete this.b[c];
                        this.k--;
                        return true;
                    }
                }
            }
            return false;
        }
        clear() {
            this.k = 0;
            this.a = ({});
            this.b = ({});
        }
        n(a) {
            if (this.e) {
                return stringToString$1(this.$tKey, a);
            }
            else {
                return Base.getHashCodeStatic(a).toString();
            }
        }
        l(a) {
            return this.j.getHashCodeC(a);
        }
        addItem(a, b) {
            this.o(a, b, true);
        }
        o(a, b, c) {
            if (this.c) {
                let d = this.n(a);
                if ((!this.a.hasOwnProperty(d))) {
                    this.k++;
                }
                else if (c) {
                    throw new ArgumentException(1, "Duplicate key added to the dictionary");
                }
                this.a[d] = a;
                this.b[d] = b;
            }
            else {
                let e = this.l(a);
                let f = this.b[e];
                if (f) {
                    if ((f.$isHashSetBucket)) {
                        let i = (f);
                        for (let h = 0; h < i.length; h++) {
                            let g = i[h];
                            if (this.j.equalsC((g.key), a)) {
                                if (c) {
                                    throw new ArgumentException(1, "Duplicate key added to the dictionary");
                                }
                                g.value = b;
                                return;
                            }
                        }
                        f.push({ key: a, value: b });
                        this.k++;
                    }
                    else {
                        if (this.j.equalsC((f.key), a)) {
                            if (c) {
                                throw new ArgumentException(1, "Duplicate key added to the dictionary");
                            }
                            f.value = b;
                        }
                        else {
                            let j = typeCastObjTo$t(this.$tValue, ([f, { key: a, value: b }]));
                            j.$isHashSetBucket = true;
                            ;
                            this.b[e] = j;
                            this.k++;
                        }
                    }
                }
                else {
                    this.b[e] = { key: a, value: b };
                    this.k++;
                }
            }
        }
        f(a) {
            if (this.c) {
                let b = this.n(a);
                if ((this.a.hasOwnProperty(b))) {
                    let c = (this.b[b]);
                    return c;
                }
            }
            else {
                let d = this.l(a);
                let e = this.b[d];
                if (e) {
                    if ((e.$isHashSetBucket)) {
                        let h = (e);
                        for (let g = 0; g < h.length; g++) {
                            let f = h[g];
                            if (this.j.equalsC((f.key), a)) {
                                let i = (f.value);
                                return i;
                            }
                        }
                    }
                    else {
                        if (this.j.equalsC((e.key), a)) {
                            let j = (e.value);
                            return j;
                        }
                    }
                }
            }
            return typeCastObjTo$t(this.$tValue, (undefined));
        }
        tryGetValue(a, b) {
            if (this.c) {
                let c = this.n(a);
                if ((this.a.hasOwnProperty(c))) {
                    b = (this.b[c]);
                    return {
                        ret: true,
                        p1: b
                    };
                }
            }
            else {
                let d = this.l(a);
                let e = this.b[d];
                if (e) {
                    if ((e.$isHashSetBucket)) {
                        let h = (e);
                        for (let g = 0; g < h.length; g++) {
                            let f = h[g];
                            if (this.j.equalsC((f.key), a)) {
                                b = (f.value);
                                return {
                                    ret: true,
                                    p1: b
                                };
                            }
                        }
                    }
                    else {
                        if (this.j.equalsC((e.key), a)) {
                            b = (e.value);
                            return {
                                ret: true,
                                p1: b
                            };
                        }
                    }
                }
            }
            b = Type.getDefaultValue(this.$tValue);
            return {
                ret: false,
                p1: b
            };
        }
        get isReadOnly() {
            return false;
        }
        add(a) {
            this.addItem(a.key, a.value);
        }
        contains(a) {
            let b;
            return ((() => { let c = this.tryGetValue(a.key, b); b = c.p1; return c.ret; })()) && Base.equalsStatic(getBoxIfEnum(this.$tValue, b), getBoxIfEnum(this.$tValue, a.value));
        }
        copyTo(a, b) {
            throw new NotImplementedException(0);
        }
        remove(a) {
            this.removeItem(a.key);
            return true;
        }
        getEnumerator() {
            return getEnumerator(this.g());
        }
        *_g() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this.a));
                for (let b = 0; b < a.length; b++) {
                    yield new KeyValuePair$2(this.$tKey, this.$tValue, 1, this.a[a[b]], this.b[a[b]]);
                }
            }
            else {
                let c = (Base.getArrayOfProperties(this.b));
                for (let d = 0; d < c.length; d++) {
                    let e = this.b[c[d]];
                    if ((e.$isHashSetBucket)) {
                        let f = (e);
                        for (let g = 0; g < f.length; g++) {
                            let subItem_ = f[g];
                            yield new KeyValuePair$2(this.$tKey, this.$tValue, 1, (subItem_.key), (subItem_.value));
                        }
                    }
                    else {
                        yield new KeyValuePair$2(this.$tKey, this.$tValue, 1, (e.key), (e.value));
                    }
                }
            }
        }
        g() {
            return toEnum(() => this._g());
        }
        *_h() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this.a));
                for (let b = 0; b < a.length; b++) {
                    yield this.a[a[b]];
                }
            }
            else {
                let c = (Base.getArrayOfProperties(this.b));
                for (let d = 0; d < c.length; d++) {
                    let e = this.b[c[d]];
                    if ((e.$isHashSetBucket)) {
                        let f = (e);
                        for (let g = 0; g < f.length; g++) {
                            let subItem_ = f[g];
                            yield (subItem_.key);
                        }
                    }
                    else {
                        yield (e.key);
                    }
                }
            }
        }
        h() {
            return toEnum(() => this._h());
        }
        *_i() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this.a));
                for (let b = 0; b < a.length; b++) {
                    yield this.b[a[b]];
                }
            }
            else {
                let c = (Base.getArrayOfProperties(this.b));
                for (let d = 0; d < c.length; d++) {
                    let e = this.b[c[d]];
                    if ((e.$isHashSetBucket)) {
                        let f = (e);
                        for (let g = 0; g < f.length; g++) {
                            let subItem_ = f[g];
                            yield (subItem_.value);
                        }
                    }
                    else {
                        yield (e.value);
                    }
                }
            }
        }
        i() {
            return toEnum(() => this._i());
        }
        getEnumeratorObject() {
            return getEnumerator(this.g());
        }
        get keys() {
            return new Dictionary_EnumerableCollection$3(this.$tKey, this.$tValue, this.$tKey, this, this.h(), this.j || EqualityComparer$1.defaultEqualityComparerValue(this.$tKey));
        }
        get values() {
            return new Dictionary_EnumerableCollection$3(this.$tKey, this.$tValue, this.$tValue, this, this.i(), EqualityComparer$1.defaultEqualityComparerValue(this.$tValue));
        }
    }
    Dictionary$2.$t = /*@__PURE__*/ markType(Dictionary$2, 'Dictionary$2', Base.$, [/*@__PURE__*/ IDictionary$2_$type.specialize(0, 1), IDictionary_$type]);
    return Dictionary$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Random = /*@__PURE__*/ (() => {
    class Random extends Base {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                    }
                    break;
            }
        }
        nextDouble() {
            return Math.random();
        }
        next() {
            return this.next1(0x7FFFFFFF);
        }
        next1(a) {
            return truncate(Math.round(this.nextDouble() * (a - 1)));
        }
        next2(a, b) {
            return a + truncate(Math.round(this.nextDouble() * ((b - a) - 1)));
        }
    }
    Random.$t = /*@__PURE__*/ markType(Random, 'Random');
    return Random;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let DateTimeKind_$type = /*@__PURE__*/ markEnum("DateTimeKind", "Unspecified,0|Utc,1|Local,2");
function dateKind() {
    return 2 /* Local */;
}
;
function defaultDVDateParse(str) {
    return new Date(parseInt(str.replace("/Date(", "").replace(")/", ""), 10));
}
function dateNow() {
    return new Date();
}
;
function dateMinValue() {
    return new Date(1, 0, 1, 0, 0, 0, 0);
}
;
function dateMaxValue() {
    return new Date(9999, 12, 31, 23, 59, 59, 0.9999999);
}
;
function dateFromMilliseconds(value) {
    return new Date(value);
}
;
function dateStdTimezoneOffset(date) {
    var jan, jul, janOffset, julOffset;
    jan = new Date(date.getFullYear(), 0, 1);
    jul = new Date(date.getFullYear(), 6, 1);
    julOffset = jul.getTimezoneOffset();
    janOffset = jan.getTimezoneOffset();
    return Math.max(janOffset, julOffset);
}
;
function dateIsDST(date) {
    return date.getTimezoneOffset() < dateStdTimezoneOffset(date);
}
;
function dateFromValues(year, month, day, hour, minute, second, millisecond) {
    return new Date(year, month - 1, day, hour, minute, second, millisecond);
}
function dateFromTicks(ticks) {
    return new Date(ticks);
}
function dateAddSeconds(value, seconds) {
    return dateAddDays(value, seconds / 86400);
}
function dateAddMinutes(value, minutes) {
    return dateAddDays(value, minutes / 1440);
}
function dateAddHours(value, hours) {
    return dateAddDays(value, hours / 24);
}
function dateAddDays(value, days) {
    var result = new Date(+value + (days * 86400000));
    // Correct for any daylight saving time shifts
    if (!dateIsDST(value)) {
        if (dateIsDST(result)) {
            result = new Date(+result - 3600000);
        }
    }
    else {
        if (!dateIsDST(result)) {
            result = new Date(+result + 3600000);
        }
    }
    return result;
}
function dateAddMonths(value, num) {
    var result = new Date(value.getTime());
    var currentMonth = result.getMonth() + result.getFullYear() * 12;
    result.setMonth(result.getMonth() + num);
    var diff = result.getMonth() + result.getFullYear() * 12 - currentMonth;
    // If don't get the right number, set date to
    // last day of previous month
    if (diff != num) {
        result.setDate(0);
    }
    return result;
}
function dateAddYears(value, num) {
    var result = new Date(value.getTime());
    result.setFullYear(result.getFullYear() + num);
    return result;
}
function dateIsLeapYear(year) {
    return year % 4 === 0 && (year % 100 !== 0 || year % 400 == 0);
}
function dateToFileTime(value) {
    return (+value - +new Date(1600, 11, 31, 19, 0, 0, 0)) * 10000;
}
function dateFromFileTime(value) {
    // TODO: Test this
    return +(value / 10000) + +new Date(1600, 11, 31, 19, 0, 0, 0);
}
function dateFromFileTimeUtc(value) {
    return new Date(+(value / 10000) + +Date.UTC(1600, 12, 1, 0, 0, 0, 0));
}
function dateGetMonth(value) {
    return value.getMonth() + 1;
}
function dateToday() {
    var r = new Date();
    r.setHours(0, 0, 0, 0);
    return r;
}
function dateGetTimeOfDay(value) {
    return (value.getHours() * 3600000) +
        (value.getMinutes() * 60000) +
        (value.getSeconds() * 1000) +
        value.getMilliseconds();
}
function dateGetDate(value) {
    return new Date(+value - dateGetTimeOfDay(value));
}
function dateEquals(d1, d2) {
    return d2 instanceof Date && +d1 === +d2;
}
function dateAdd(d, t) { return new Date(+d + t); }
;
function dateSubtract(d, t) { return new Date(+d - t); }
;
function daysInMonth(year, month) {
    switch (month) {
        case 1: return 31; // Jan
        case 2: return dateIsLeapYear(year) ? 29 : 28; // Feb
        case 3: return 31; // Mar
        case 4: return 30; // Apr
        case 5: return 31; // May
        case 6: return 30; // Jun
        case 7: return 31; // Jul
        case 8: return 31; // Aug
        case 9: return 30; // Sep
        case 10: return 31; // Oct
        case 11: return 30; // Nov
        case 12: return 31; // Dec
    }
    // TODO: throw error here?
    return 0;
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockDataLookup = /*@__PURE__*/ (() => {
    class StockDataLookup extends Base {
        static d(a, b, c, d, e) {
            if (StockDataLookup.b.containsKey(a)) {
            }
            else {
                let f = new StockPricePoint();
                f.symbol = a;
                f.company = b;
                f.open = c;
                f.close = c;
                f.volume = d;
                f.sector = e;
                StockDataLookup.b.addItem(a, f);
            }
        }
        static get(a) {
            if (StockDataLookup.b.containsKey(a)) {
                return StockDataLookup.b.item(a);
            }
            else {
                let b = new StockPricePoint();
                b.symbol = a;
                b.open = StockDataLookup.c.next2(100, 500);
                b.volume = StockDataLookup.c.next2(100000, 500000);
                StockDataLookup.b.addItem(a, b);
                return b;
            }
        }
        static staticInit() {
            let a = dateNow();
            StockDataLookup.b = new Dictionary$2(String_$type, StockPricePoint.$, 0);
            StockDataLookup.d("TSLA", "Tesla Inc", 332.01, 10834796, "Transportation");
            StockDataLookup.d("UBER", "Uber Technologies Inc", 38.79, 79442420, "Transportation");
            StockDataLookup.d("NVDA", "Nvidia Corp", 163.5, 16422819, "Technology");
            StockDataLookup.d("GOOG", "Alphabet Inc", 1204.11, 43944923, "Technology");
            StockDataLookup.d("QCOM", "Qualcomm Inc", 83.24, 16689039, "Technology");
            StockDataLookup.d("ROKU", "Roku Inc", 80.76, 22878291, "Technology");
            StockDataLookup.d("CSCO", "Cisco Systems Inc", 51.83, 28869931, "Technology");
            StockDataLookup.d("INTC", "Intel Corp", 45.33, 39091928, "Technology");
            StockDataLookup.d("ADBE", "Adobe Systems Inc", 270.565, 2698322, "Technology");
            StockDataLookup.d("AVGO", "Broadcom Inc", 293.82, 3786434, "Technology");
            StockDataLookup.d("LYFT", "Lyft Inc", 50, 10007408, "Transportation");
            StockDataLookup.d("PYPL", "PayPal Holdings Inc", 107.6, 5657900, "Financial");
            StockDataLookup.d("ORCL", "Oracle Corp", 53.72, 10664674, "Technology");
            StockDataLookup.d("SBUX", "Starbucks Corp", 77.25, 9778829, "Consumer Goods");
            StockDataLookup.d("TWTR", "Twitter Inc", 37.5, 16829698, "Communication");
            StockDataLookup.d("AMAT", "Applied Materials Inc", 39.26, 10725058, "Materials");
            StockDataLookup.d("ATVI", "Activision Blizzard Inc", 44.73, 9803138, "Technology");
            StockDataLookup.d("SNAP", "Snap Inc", 10.05, 15911862, "Communication");
            StockDataLookup.d("TMUS", "T-Mobile US Inc", 74.38, 3477107, "Communication");
            StockDataLookup.d("AMZN", "Amazon.com Inc", 1836.56, 5783410, "Technology");
            StockDataLookup.d("AAPL", "Apple Inc", 223.55, 957369, "Technology");
            StockDataLookup.d("MSFT", "Microsoft Corp", 124.11, 33944923, "Technology");
            StockDataLookup.d("NFLX", "Netflix Inc", 361.95, 16833347, "Communication");
            StockDataLookup.d("BABA", "Alibaba Group Holding Ltd", 169.79, 22330737, "Technology");
            StockDataLookup.d("BAC", "Bank of America Corp", 28.53, 5783410, "Financial");
            StockDataLookup.d("AMJ", "JP Morgan Chase & Co", 25.34, 1350492, "Financial");
            StockDataLookup.d("TXN", "Texas Instruments Inc", 109.17, 7867589, "Technology");
            StockDataLookup.d("CAT", "Caterpillar Inc", 127.51, 8580682, "Industrial");
            StockDataLookup.d("MMM", "3M Co", 173.935, 5916911, "Materials");
            StockDataLookup.d("DIS", "Walt Disney Co", 131.5, 11389896, "Communication");
            StockDataLookup.d("AMD", "Advanced Micro Devices Inc", 26.98, 99017893, "Technology");
            StockDataLookup.d("HON", "Honeywell Intl. Inc", 168.48, 3705165, "Materials");
            StockDataLookup.d("IBM", "Intl. Business Machines", 133.28, 4958021, "Technology");
            StockDataLookup.d("UTX", "United Technologies Corp", 134.03, 4119212, "Technology");
            StockDataLookup.d("CVS", "CVS Health Corp", 54.3, 11183821, "Consumer Goods");
            StockDataLookup.d("DAL", "Delta Air Lines Inc", 55.44, 5223811, "Transportation");
            StockDataLookup.d("CCZ", "Comcast Corp", 55.5, 410, "Communication");
            StockDataLookup.d("BBY", "Best Buy Co Inc", 70.3, 5408468, "Consumer Goods");
            StockDataLookup.d("AAL", "American Airlines Group Inc", 33.16, 7040853, "Transportation");
            StockDataLookup.d("CRM", "Salesforce.Com Inc", 154.92, 5694582, "Financial");
            StockDataLookup.d("C", "Citigroup Inc", 66.13, 23494395, "Financial");
            StockDataLookup.d("F", "Ford Motor Co", 10.17, 51102054, "Transportation");
            StockDataLookup.d("T", "AT&T Inc", 30.35, 27713285, "Communication");
            StockDataLookup.d("V", "Visa Inc", 157.19, 9729964, "Financial");
            StockDataLookup.d("GE", "General Electric Co", 9.85, 60136022, "Energy");
            StockDataLookup.d("MU", "Micron Technology Inc", 37.36, 33092081, "Technology");
            StockDataLookup.d("MA", "Mastercard Inc", 241.51, 4137245, "Financial");
            StockDataLookup.d("HD", "Home Depot Inc", 191, 3326028, "Materials");
            StockDataLookup.d("VZ", "Verizon Comm Inc", 56.72, 13759350, "Communication");
            StockDataLookup.d("EA", "Electronic Arts Inc", 92.01, 3685460, "Communication");
            StockDataLookup.d("FB", "Facebook Inc", 183.5, 16833347, "Technology");
            StockDataLookup.d("GM", "General Motors Company", 36.85, 19454839, "Transportation");
        }
    }
    StockDataLookup.$t = /*@__PURE__*/ markType(StockDataLookup, 'StockDataLookup');
    StockDataLookup.b = null;
    StockDataLookup.c = /*@__PURE__*/ new Random(0);
    return StockDataLookup;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let CalendarWeekRule_$type = /*@__PURE__*/ markEnum("CalendarWeekRule", "FirstDay,0|FirstFullWeek,1|FirstFourDayWeek,2");
let Calendar = /*@__PURE__*/ (() => {
    class Calendar extends Base {
        eras() {
            // TODO: Base this on the culture
            return [1];
        }
        getEra(time) {
            // TODO: Base this on the culture
            return 1;
        }
        getDayOfMonth(time) {
            // TODO: Base this on the culture
            return time.getDate();
        }
        getDaysInMonth(year, month, era) {
            // TODO: Base this on the culture
            return daysInMonth(year, month);
        }
        getDaysInYear(year, era) {
            // TODO: Base this on the culture
            return dateIsLeapYear(year) ? 366 : 365;
        }
        getMonth(time) {
            // TODO: Base this on the culture
            return dateGetMonth(time);
        }
        getYear(time) {
            // TODO: Base this on the culture
            return time.getFullYear();
        }
        toDateTime(year, month, day, hour, minute, second, millisecond, era) {
            // TODO: Base this on the culture
            return dateFromValues(year, month, day, hour, minute, second, millisecond);
        }
        addMonths(time, months) {
            return dateAddMonths(time, months);
        }
        addYears(time, years) {
            return dateAddYears(time, years);
        }
    }
    Calendar.$t = /*@__PURE__*/ markType(Calendar, "Calendar");
    return Calendar;
})();
let CompareInfo = /*@__PURE__*/ (() => {
    class CompareInfo extends Base {
        compare1(string1, offset1, length1, string2, offset2, length2, options) {
            var v1 = string1.substr(offset1, length1);
            var v2 = string2.substr(offset2, length2);
            // TODO: Handle other compare options
            /*jslint bitwise: true */
            if ((options & 1 /* IgnoreCase */) !== 0) {
                v1 = v1.toLowerCase();
                v2 = v2.toLowerCase();
            }
            return Base.compare(v1, v2);
        }
        compare4(string1, string2) {
            return this.compare5(string1, string2, 0 /* None */);
        }
        compare5(string1, string2, options) {
            return this.compare1(string1, 0, string1.length, string2, 0, string2.length, options);
        }
        indexOf1(source, value) {
            return this.indexOf6(source, value, 0, 0 /* None */);
        }
        indexOf3(source, value, options) {
            return this.indexOf6(source, value, 0, options);
        }
        indexOf6(source, value, startIndex, options) {
            // TODO: Handle other compare options
            /*jslint bitwise: true */
            if ((options & 1 /* IgnoreCase */) !== 0) {
                source = source.toLowerCase();
                value = value.toLowerCase();
            }
            return source.indexOf(value, startIndex);
        }
        indexOf5(source, value, options) {
            // TODO: Use options
            return source.indexOf(value);
        }
        referenceEquals(a, b) {
            return a === b;
        }
    }
    CompareInfo.$t = /*@__PURE__*/ markType(CompareInfo, "CompareInfo");
    return CompareInfo;
})();
let DateTimeFormat = /*@__PURE__*/ (() => {
    class DateTimeFormat extends Base {
        constructor(cultureName, isInvariant) {
            super();
            this._cultureName = null;
            this._isInvariant = false;
            this._dateSeparator = "/";
            this._timeSeparator = ":";
            this._longDatePattern = "dddd, MMMM d, yyyy";
            this._shortDatePattern = null;
            this._shortTimePattern = "h:mm tt";
            this._cultureName = cultureName;
            this._isInvariant = isInvariant;
        }
        clone() {
            var copy = new DateTimeFormat(this._cultureName, this._isInvariant);
            for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                    copy[attr] = this[attr];
                }
            }
            return copy;
        }
        get dateSeparator() {
            return this._dateSeparator;
        }
        set dateSeparator(value) {
            this._dateSeparator = value;
        }
        get timeSeparator() {
            return this._timeSeparator;
        }
        set timeSeparator(value) {
            this._timeSeparator = value;
        }
        get longDatePattern() {
            return this._longDatePattern;
        }
        set longDatePattern(value) {
            this._longDatePattern = value;
        }
        get shortDatePattern() {
            if (!this._shortDatePattern) {
                var g = globalInfo[this._isInvariant ? "invariant" : this._cultureName];
                if (g) {
                    this._shortDatePattern = g.d;
                }
                else {
                    this._shortDatePattern = "M/d/yyyy";
                }
            }
            return this._shortDatePattern;
        }
        set shortDatePattern(value) {
            this._shortDatePattern = value;
        }
        get shortTimePattern() {
            return this._shortTimePattern;
        }
        set shortTimePattern(value) {
            this._shortTimePattern = value;
        }
    }
    DateTimeFormat.$t = /*@__PURE__*/ markType(DateTimeFormat, "DateTimeFormat");
    return DateTimeFormat;
})();
let NumberFormatInfo = /*@__PURE__*/ (() => {
    class NumberFormatInfo extends Base {
        constructor(cultureName, isInvariant) {
            super();
            this._cultureName = null;
            this._isInvariant = false;
            this._currencySymbol = null;
            this._nativeDigits = null;
            this._negativeSign = "-";
            this._percentSymbol = null;
            this._positiveSign = "+";
            this._numberDecimalSeparator = null;
            this._numberGroupSizes = null;
            this._cultureName = cultureName;
            this._isInvariant = isInvariant;
        }
        clone() {
            var copy = new NumberFormatInfo(this._cultureName, this._isInvariant);
            for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                    copy[attr] = this[attr];
                }
            }
            return copy;
        }
        get currencySymbol() {
            if (!this._currencySymbol) {
                var g = globalInfo[this._isInvariant ? "invariant" : this._cultureName];
                if (g) {
                    this._currencySymbol = g.c;
                }
                else {
                    this._currencySymbol = "$";
                }
            }
            return this._currencySymbol;
        }
        set currencySymbol(value) {
            this._currencySymbol = value;
        }
        get nativeDigits() {
            if (!this._nativeDigits) {
                var g = globalInfo[this._isInvariant ? "invariant" : this._cultureName];
                if (g && g.n) {
                    this._nativeDigits = Array.from(g.n);
                }
                else {
                    this._nativeDigits = Array.from("0123456789");
                }
            }
            return this._nativeDigits;
        }
        get negativeSign() {
            return this._negativeSign;
        }
        set negativeSign(value) {
            this._negativeSign = value;
        }
        set percentSymbol(value) {
            this._percentSymbol = value;
        }
        get percentSymbol() {
            if (!this._percentSymbol) {
                var temp = (1).toLocaleString(this._cultureName, { style: "percent" });
                this._percentSymbol = temp[temp.length - 1];
            }
            return this._percentSymbol;
        }
        get positiveSign() {
            return this._positiveSign;
        }
        set positiveSign(value) {
            this._positiveSign = value;
        }
        set numberDecimalSeparator(value) {
            this._numberDecimalSeparator = value;
        }
        get numberDecimalSeparator() {
            if (!this._numberDecimalSeparator) {
                this._numberDecimalSeparator = (1.1).toLocaleString(this._cultureName)
                    .substring(1, 2);
            }
            return this._numberDecimalSeparator;
        }
        set numberGroupSeparator(value) {
            this._numberGroupSeparator = value;
        }
        get numberGroupSeparator() {
            if (!this._numberGroupSeparator) {
                var s = (123456789.0).toLocaleString(this._cultureName);
                var result = /\D/.exec(s);
                if (result === null || result.length === 0) {
                    this._numberGroupSeparator = ",";
                }
                else {
                    this._numberGroupSeparator = result[0];
                }
            }
            return this._numberGroupSeparator;
        }
        set numberGroupSizes(value) {
            this._numberGroupSizes = value;
        }
        get numberGroupSizes() {
            if (!this._numberGroupSizes) {
                var s = (123456789.0).toLocaleString(this._cultureName);
                var result = /\D(\d+)\D/.exec(s);
                if (result === null || result.length === 0) {
                    this._numberGroupSizes = [3];
                }
                else {
                    this._numberGroupSizes = [result[1].length];
                }
            }
            return this._numberGroupSizes;
        }
    }
    NumberFormatInfo.$t = /*@__PURE__*/ markType(NumberFormatInfo, "NumberFormatInfo");
    return NumberFormatInfo;
})();
let Thread = /*@__PURE__*/ (() => {
    class Thread extends Base {
        constructor() {
            super(...arguments);
            this._currentCulture = null;
        }
        static get currentThread() {
            if (!this._currentThread) {
                this._currentThread = new Thread();
            }
            return this._currentThread;
        }
        get currentCulture() {
            if (!this._currentCulture) {
                var currentLocale = navigator.language || navigator.userLanguage;
                this._currentCulture = new CultureInfo(currentLocale);
            }
            return this._currentCulture;
        }
        set currentCulture(value) {
            this._currentCulture = value;
        }
    }
    Thread._currentThread = null;
    Thread.$t = /*@__PURE__*/ markType(Thread, "Thread");
    return Thread;
})();
let globalInfo = { "invariant": { c: "¤", d: "MM/dd/yyyy" }, 127: "invariant",
    "af": { c: "R", d: "yyyy/MM/dd" },
    54: "af", "af-ZA": { c: "R", d: "yyyy/MM/dd" },
    1078: "af-ZA", "am": { c: "ETB", d: "d/M/yyyy" },
    94: "am", "am-ET": { c: "ETB", d: "d/M/yyyy" },
    1118: "am-ET", "ar": { c: "ر.س.‏", d: "dd/MM/yy", n: "٠١٢٣٤٥٦٧٨٩" },
    1: "ar", "ar-AE": { c: "د.إ.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    14337: "ar-AE", "ar-BH": { c: "د.ب.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    15361: "ar-BH", "ar-DZ": { c: "د.ج.‏", d: "dd-MM-yyyy" },
    5121: "ar-DZ", "ar-EG": { c: "ج.م.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    3073: "ar-EG", "ar-IQ": { c: "د.ع.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    2049: "ar-IQ", "ar-JO": { c: "د.ا.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    11265: "ar-JO", "ar-KW": { c: "د.ك.‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    13313: "ar-KW", "ar-LB": { c: "ل.ل.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    12289: "ar-LB", "ar-LY": { c: "د.ل.‏‏", d: "dd/MM/yyyy" },
    4097: "ar-LY", "ar-MA": { c: "د.م.‏‏", d: "dd-MM-yyyy" },
    6145: "ar-MA", "arn": { c: "$", d: "dd-MM-yyyy" },
    122: "arn", "arn-CL": { c: "$", d: "dd-MM-yyyy" },
    1146: "arn-CL", "ar-OM": { c: "ر.ع.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    8193: "ar-OM", "ar-QA": { c: "ر.ق.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    16385: "ar-QA", "ar-SA": { c: "ر.س.‏", d: "dd/MM/yy", n: "٠١٢٣٤٥٦٧٨٩" },
    1025: "ar-SA", "ar-SY": { c: "ل.س.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    10241: "ar-SY", "ar-TN": { c: "د.ت.‏‏", d: "dd-MM-yyyy" },
    7169: "ar-TN", "ar-YE": { c: "ر.ي.‏‏", d: "dd/MM/yyyy", n: "٠١٢٣٤٥٦٧٨٩" },
    9217: "ar-YE", "as": { c: "₹", d: "dd-MM-yyyy", n: "০১২৩৪৫৬৭৮৯" },
    77: "as", "as-IN": { c: "₹", d: "dd-MM-yyyy", n: "০১২৩৪৫৬৭৮৯" },
    1101: "as-IN", "az": { c: "man.", d: "dd.MM.yyyy" },
    44: "az", "az-Cyrl": { c: "ман.", d: "dd.MM.yyyy" },
    29740: "az-Cyrl", "az-Cyrl-AZ": { c: "ман.", d: "dd.MM.yyyy" },
    2092: "az-Cyrl-AZ", "az-Latn": { c: "man.", d: "dd.MM.yyyy" },
    30764: "az-Latn", "az-Latn-AZ": { c: "man.", d: "dd.MM.yyyy" },
    1068: "az-Latn-AZ", "ba": { c: "₽", d: "dd.MM.yy" },
    109: "ba", "ba-RU": { c: "₽", d: "dd.MM.yy" },
    1133: "ba-RU", "be": { c: "Br", d: "dd.MM.yy" },
    35: "be", "be-BY": { c: "Br", d: "dd.MM.yy" },
    1059: "be-BY", "bg": { c: "лв.", d: "d.M.yyyy \"г.\"" },
    2: "bg", "bg-BG": { c: "лв.", d: "d.M.yyyy \"г.\"" },
    1026: "bg-BG", "bn": { c: "₹", d: "dd-MM-yy", n: "০১২৩৪৫৬৭৮৯" },
    69: "bn", "bn-BD": { c: "৳", d: "dd-MM-yy", n: "০১২৩৪৫৬৭৮৯" },
    2117: "bn-BD", "bn-IN": { c: "₹", d: "dd-MM-yy", n: "০১২৩৪৫৬৭৮৯" },
    1093: "bn-IN", "bo": { c: "¥", d: "yyyy/M/d", n: "༠༡༢༣༤༥༦༧༨༩" },
    81: "bo", "bo-CN": { c: "¥", d: "yyyy/M/d", n: "༠༡༢༣༤༥༦༧༨༩" },
    1105: "bo-CN", "br": { c: "€", d: "dd/MM/yyyy" },
    126: "br", "br-FR": { c: "€", d: "dd/MM/yyyy" },
    1150: "br-FR", "bs": { c: "KM", d: "d.M.yyyy" },
    30746: "bs", "bs-Cyrl": { c: "КМ", d: "d.M.yyyy" },
    25626: "bs-Cyrl", "bs-Cyrl-BA": { c: "КМ", d: "d.M.yyyy" },
    8218: "bs-Cyrl-BA", "bs-Latn": { c: "KM", d: "d.M.yyyy" },
    26650: "bs-Latn", "bs-Latn-BA": { c: "KM", d: "d.M.yyyy" },
    5146: "bs-Latn-BA", "ca": { c: "€", d: "dd/MM/yyyy" },
    3: "ca", "ca-ES": { c: "€", d: "dd/MM/yyyy" },
    1027: "ca-ES", "ca-ES-valencia": { c: "€", d: "dd/MM/yy" },
    2051: "ca-ES-valencia", "chr": { c: "$", d: "M/d/yyyy" },
    92: "chr", "chr-Cher": { c: "$", d: "M/d/yyyy" },
    31836: "chr-Cher", "chr-Cher-US": { c: "$", d: "M/d/yyyy" },
    1116: "chr-Cher-US", "co": { c: "€", d: "dd/MM/yyyy" },
    131: "co", "co-FR": { c: "€", d: "dd/MM/yyyy" },
    1155: "co-FR", "cs": { c: "Kč", d: "d. M. yyyy" },
    5: "cs", "cs-CZ": { c: "Kč", d: "d. M. yyyy" },
    1029: "cs-CZ", "cy": { c: "£", d: "dd/MM/yy" },
    82: "cy", "cy-GB": { c: "£", d: "dd/MM/yy" },
    1106: "cy-GB", "da": { c: "kr.", d: "dd-MM-yyyy" },
    6: "da", "da-DK": { c: "kr.", d: "dd-MM-yyyy" },
    1030: "da-DK", "de": { c: "€", d: "dd.MM.yyyy" },
    7: "de", "de-AT": { c: "€", d: "dd.MM.yyyy" },
    3079: "de-AT", "de-CH": { c: "Fr.", d: "dd.MM.yyyy" },
    2055: "de-CH", "de-DE": { c: "€", d: "dd.MM.yyyy" },
    1031: "de-DE", "de-LI": { c: "CHF", d: "dd.MM.yyyy" },
    5127: "de-LI", "de-LU": { c: "€", d: "dd.MM.yyyy" },
    4103: "de-LU", "dsb": { c: "€", d: "d. M. yyyy" },
    31790: "dsb", "dsb-DE": { c: "€", d: "d. M. yyyy" },
    2094: "dsb-DE", "dv": { c: "ރ.", d: "dd/MM/yy" },
    101: "dv", "dv-MV": { c: "ރ.", d: "dd/MM/yy" },
    1125: "dv-MV", "el": { c: "€", d: "d/M/yyyy" },
    8: "el", "el-GR": { c: "€", d: "d/M/yyyy" },
    1032: "el-GR", "en": { c: "$", d: "M/d/yyyy" },
    9: "en", "en-029": { c: "EC$", d: "dd/MM/yyyy" },
    9225: "en-029", "en-AU": { c: "$", d: "d/MM/yyyy" },
    3081: "en-AU", "en-BZ": { c: "BZ$", d: "dd/MM/yyyy" },
    10249: "en-BZ", "en-CA": { c: "$", d: "yyyy-MM-dd" },
    4105: "en-CA", "en-GB": { c: "£", d: "dd/MM/yyyy" },
    2057: "en-GB", "en-HK": { c: "$", d: "d/M/yy" },
    15369: "en-HK", "en-IE": { c: "€", d: "dd/MM/yyyy" },
    6153: "en-IE", "en-IN": { c: "₹", d: "dd-MM-yyyy" },
    16393: "en-IN", "en-JM": { c: "J$", d: "dd/MM/yyyy" },
    8201: "en-JM", "en-MY": { c: "RM", d: "d/M/yyyy" },
    17417: "en-MY", "en-NZ": { c: "$", d: "d/MM/yyyy" },
    5129: "en-NZ", "en-PH": { c: "₱", d: "M/d/yyyy" },
    13321: "en-PH", "en-SG": { c: "$", d: "d/M/yyyy" },
    18441: "en-SG", "en-TT": { c: "TT$", d: "dd/MM/yyyy" },
    11273: "en-TT", "en-US": { c: "$", d: "M/d/yyyy" },
    1033: "en-US", "en-ZA": { c: "R", d: "yyyy-MM-dd" },
    7177: "en-ZA", "en-ZW": { c: "$", d: "dd/MM/yyyy" },
    12297: "en-ZW", "es": { c: "€", d: "dd/MM/yyyy" },
    10: "es", "es-419": { c: "US$", d: "dd/MM/yy" },
    22538: "es-419", "es-AR": { c: "$", d: "dd/MM/yyyy" },
    11274: "es-AR", "es-BO": { c: "Bs.", d: "dd/MM/yyyy" },
    16394: "es-BO", "es-CL": { c: "$", d: "dd-MM-yyyy" },
    13322: "es-CL", "es-CO": { c: "$", d: "dd/MM/yyyy" },
    9226: "es-CO", "es-CR": { c: "₡", d: "dd/MM/yyyy" },
    5130: "es-CR", "es-DO": { c: "RD$", d: "d/M/yy" },
    7178: "es-DO", "es-EC": { c: "$", d: "dd/MM/yyyy" },
    12298: "es-EC", "es-ES": { c: "€", d: "dd/MM/yyyy" },
    3082: "es-ES", "es-GT": { c: "Q", d: "dd/MM/yyyy" },
    4106: "es-GT", "es-HN": { c: "L.", d: "dd/MM/yyyy" },
    18442: "es-HN", "es-MX": { c: "$", d: "dd/MM/yyyy" },
    2058: "es-MX", "es-NI": { c: "C$", d: "dd/MM/yyyy" },
    19466: "es-NI", "es-PA": { c: "B/.", d: "d/M/yy" },
    6154: "es-PA", "es-PE": { c: "S/.", d: "dd/MM/yyyy" },
    10250: "es-PE", "es-PR": { c: "$", d: "dd/MM/yyyy" },
    20490: "es-PR", "es-PY": { c: "₲", d: "dd/MM/yyyy" },
    15370: "es-PY", "es-SV": { c: "$", d: "dd/MM/yyyy" }, 17418: "es-SV", "es-US": { c: "$", d: "M/d/yyyy" }, 21514: "es-US", "es-UY": { c: "$U", d: "dd/MM/yyyy" }, 14346: "es-UY", "es-VE": { c: "Bs.F.", d: "dd-MM-yyyy" }, 8202: "es-VE", "et": { c: "€", d: "d.MM.yyyy" }, 37: "et", "et-EE": { c: "€", d: "d.MM.yyyy" }, 1061: "et-EE", "eu": { c: "€", d: "yyyy/MM/dd" }, 45: "eu", "eu-ES": { c: "€", d: "yyyy/MM/dd" }, 1069: "eu-ES", "fa": { c: "ريال", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 41: "fa", "fa-IR": { c: "ريال", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 1065: "fa-IR", "ff": { c: "CFA", d: "dd/MM/yyyy" }, 103: "ff", "ff-Latn": { c: "CFA", d: "dd/MM/yyyy" }, 31847: "ff-Latn", "ff-Latn-SN": { c: "CFA", d: "dd/MM/yyyy" }, 2151: "ff-Latn-SN", "fi": { c: "€", d: "d.M.yyyy" }, 11: "fi", "fi-FI": { c: "€", d: "d.M.yyyy" }, 1035: "fi-FI", "fil": { c: "₱", d: "M/d/yyyy" }, 100: "fil", "fil-PH": { c: "₱", d: "M/d/yyyy" }, 1124: "fil-PH", "fo": { c: "kr.", d: "dd-MM-yyyy" }, 56: "fo", "fo-FO": { c: "kr.", d: "dd-MM-yyyy" }, 1080: "fo-FO", "fr": { c: "€", d: "dd/MM/yyyy" }, 12: "fr", "fr-BE": { c: "€", d: "dd-MM-yy" }, 2060: "fr-BE", "fr-CA": { c: "$", d: "yyyy-MM-dd" }, 3084: "fr-CA", "fr-CD": { c: "FC", d: "dd/MM/yyyy" }, 9228: "fr-CD", "fr-CH": { c: "fr.", d: "dd.MM.yyyy" }, 4108: "fr-CH", "fr-CI": { c: "CFA", d: "dd/MM/yyyy" }, 12300: "fr-CI", "fr-CM": { c: "FCFA", d: "dd/MM/yyyy" }, 11276: "fr-CM", "fr-FR": { c: "€", d: "dd/MM/yyyy" }, 1036: "fr-FR", "fr-HT": { c: "G", d: "dd/MM/yyyy" }, 15372: "fr-HT", "fr-LU": { c: "€", d: "dd/MM/yyyy" }, 5132: "fr-LU", "fr-MA": { c: "DH", d: "dd/MM/yyyy" }, 14348: "fr-MA", "fr-MC": { c: "€", d: "dd/MM/yyyy" }, 6156: "fr-MC", "fr-ML": { c: "CFA", d: "dd/MM/yyyy" }, 13324: "fr-ML", "fr-RE": { c: "€", d: "dd/MM/yyyy" }, 8204: "fr-RE", "fr-SN": { c: "CFA", d: "dd/MM/yyyy" }, 10252: "fr-SN", "fy": { c: "€", d: "d-M-yyyy" }, 98: "fy", "fy-NL": { c: "€", d: "d-M-yyyy" }, 1122: "fy-NL", "ga": { c: "€", d: "dd/MM/yyyy" }, 60: "ga", "ga-IE": { c: "€", d: "dd/MM/yyyy" }, 2108: "ga-IE", "gd": { c: "£", d: "dd/MM/yyyy" }, 145: "gd", "gd-GB": { c: "£", d: "dd/MM/yyyy" }, 1169: "gd-GB", "gl": { c: "€", d: "dd/MM/yyyy" }, 86: "gl", "gl-ES": { c: "€", d: "dd/MM/yyyy" }, 1110: "gl-ES", "gn": { c: "₲", d: "dd/MM/yyyy" }, 116: "gn", "gn-PY": { c: "₲", d: "dd/MM/yyyy" }, 1140: "gn-PY", "gsw": { c: "€", d: "dd/MM/yyyy" }, 132: "gsw", "gsw-FR": { c: "€", d: "dd/MM/yyyy" }, 1156: "gsw-FR", "gu": { c: "₹", d: "dd-MM-yy", n: "૦૧૨૩૪૫૬૭૮૯" }, 71: "gu", "gu-IN": { c: "₹", d: "dd-MM-yy", n: "૦૧૨૩૪૫૬૭૮૯" }, 1095: "gu-IN", "ha": { c: "₦", d: "d/M/yyyy" }, 104: "ha", "ha-Latn": { c: "₦", d: "d/M/yyyy" }, 31848: "ha-Latn", "ha-Latn-NG": { c: "₦", d: "d/M/yyyy" }, 1128: "ha-Latn-NG", "haw": { c: "$", d: "M/d/yyyy" }, 117: "haw", "haw-US": { c: "$", d: "M/d/yyyy" }, 1141: "haw-US", "he": { c: "₪", d: "dd/MM/yyyy" }, 13: "he", "he-IL": { c: "₪", d: "dd/MM/yyyy" }, 1037: "he-IL", "hi": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 57: "hi", "hi-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1081: "hi-IN", "hr": { c: "kn", d: "d.M.yyyy." }, 26: "hr", "hr-BA": { c: "KM", d: "d.M.yyyy." }, 4122: "hr-BA", "hr-HR": { c: "kn", d: "d.M.yyyy." }, 1050: "hr-HR", "hsb": { c: "€", d: "d. M. yyyy" }, 46: "hsb", "hsb-DE": { c: "€", d: "d. M. yyyy" }, 1070: "hsb-DE", "hu": { c: "Ft", d: "yyyy.MM.dd." }, 14: "hu", "hu-HU": { c: "Ft", d: "yyyy.MM.dd." }, 1038: "hu-HU", "hy": { c: "֏", d: "dd.MM.yyyy" }, 43: "hy", "hy-AM": { c: "֏", d: "dd.MM.yyyy" }, 1067: "hy-AM", "id": { c: "Rp", d: "dd/MM/yyyy" }, 33: "id", "id-ID": { c: "Rp", d: "dd/MM/yyyy" }, 1057: "id-ID", "ig": { c: "₦", d: "d/M/yyyy" }, 112: "ig", "ig-NG": { c: "₦", d: "d/M/yyyy" }, 1136: "ig-NG", "ii": { c: "¥", d: "yyyy/M/d" }, 120: "ii", "ii-CN": { c: "¥", d: "yyyy/M/d" }, 1144: "ii-CN", "is": { c: "kr.", d: "d.M.yyyy" }, 15: "is", "is-IS": { c: "kr.", d: "d.M.yyyy" }, 1039: "is-IS", "it": { c: "€", d: "dd/MM/yyyy" }, 16: "it", "it-CH": { c: "fr.", d: "dd.MM.yyyy" }, 2064: "it-CH", "it-IT": { c: "€", d: "dd/MM/yyyy" }, 1040: "it-IT", "iu": { c: "$", d: "d/MM/yyyy" }, 93: "iu", "iu-Cans": { c: "$", d: "d/M/yyyy" }, 30813: "iu-Cans", "iu-Cans-CA": { c: "$", d: "d/M/yyyy" }, 1117: "iu-Cans-CA", "iu-Latn": { c: "$", d: "d/MM/yyyy" }, 31837: "iu-Latn", "iu-Latn-CA": { c: "$", d: "d/MM/yyyy" }, 2141: "iu-Latn-CA", "ja": { c: "¥", d: "yyyy/MM/dd" }, 17: "ja", "ja-JP": { c: "¥", d: "yyyy/MM/dd" }, 1041: "ja-JP", "jv": { c: "Rp", d: "dd/MM/yyyy" }, 4096: "jv", "jv-Latn": { c: "Rp", d: "dd/MM/yyyy" }, "jv-Latn-ID": { c: "Rp", d: "dd/MM/yyyy" }, "ka": { c: "ლ.", d: "dd.MM.yyyy" }, 55: "ka", "ka-GE": { c: "ლ.", d: "dd.MM.yyyy" }, 1079: "ka-GE", "kk": { c: "₸", d: "d-MMM-yy" }, 63: "kk", "kk-KZ": { c: "₸", d: "d-MMM-yy" }, 1087: "kk-KZ", "kl": { c: "kr.", d: "dd-MM-yyyy" }, 111: "kl", "kl-GL": { c: "kr.", d: "dd-MM-yyyy" }, 1135: "kl-GL", "km": { c: "៛", d: "dd/MM/yy", n: "០១២៣៤៥៦៧៨៩" }, 83: "km", "km-KH": { c: "៛", d: "dd/MM/yy", n: "០១២៣៤៥៦៧៨៩" }, 1107: "km-KH", "kn": { c: "₹", d: "dd-MM-yy", n: "೦೧೨೩೪೫೬೭೮೯" }, 75: "kn", "kn-IN": { c: "₹", d: "dd-MM-yy", n: "೦೧೨೩೪೫೬೭೮೯" }, 1099: "kn-IN", "ko": { c: "₩", d: "yyyy-MM-dd" }, 18: "ko", "kok": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 87: "kok", "kok-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1111: "kok-IN", "ko-KR": { c: "₩", d: "yyyy-MM-dd" }, 1042: "ko-KR", "ku": { c: "د.ع.‏", d: "yyyy/MM/dd", n: "٠١٢٣٤٥٦٧٨٩" }, 146: "ku", "ku-Arab": { c: "د.ع.‏", d: "yyyy/MM/dd", n: "٠١٢٣٤٥٦٧٨٩" }, 31890: "ku-Arab", "ku-Arab-IQ": { c: "د.ع.‏", d: "yyyy/MM/dd", n: "٠١٢٣٤٥٦٧٨٩" }, 1170: "ku-Arab-IQ", "ky": { c: "сом", d: "d-MMM yy" }, 64: "ky", "ky-KG": { c: "сом", d: "d-MMM yy" }, 1088: "ky-KG", "lb": { c: "€", d: "dd.MM.yy" }, 110: "lb", "lb-LU": { c: "€", d: "dd.MM.yy" }, 1134: "lb-LU", "lo": { c: "₭", d: "dd/MM/yyyy", n: "໐໑໒໓໔໕໖໗໘໙" }, 84: "lo", "lo-LA": { c: "₭", d: "dd/MM/yyyy", n: "໐໑໒໓໔໕໖໗໘໙" }, 1108: "lo-LA", "lt": { c: "Lt", d: "yyyy-MM-dd" }, 39: "lt", "lt-LT": { c: "Lt", d: "yyyy-MM-dd" }, 1063: "lt-LT", "lv": { c: "€", d: "dd.MM.yyyy." }, 38: "lv", "lv-LV": { c: "€", d: "dd.MM.yyyy." }, 1062: "lv-LV", "mg": { c: "Ar", d: "d/M/yyyy" }, "mg-MG": { c: "Ar", d: "d/M/yyyy" }, "mi": { c: "$", d: "dd/MM/yyyy" }, 129: "mi", "mi-NZ": { c: "$", d: "dd/MM/yyyy" }, 1153: "mi-NZ", "mk": { c: "ден.", d: "dd.MM.yyyy" }, 47: "mk", "mk-MK": { c: "ден.", d: "dd.MM.yyyy" }, 1071: "mk-MK", "ml": { c: "₹", d: "dd-MM-yy", n: "൦൧൨൩൪൫൬൭൮൯" }, 76: "ml", "ml-IN": { c: "₹", d: "dd-MM-yy", n: "൦൧൨൩൪൫൬൭൮൯" }, 1100: "ml-IN", "mn": { c: "₮", d: "yyyy-MM-dd" }, 80: "mn", "mn-Cyrl": { c: "₮", d: "yyyy-MM-dd" }, 30800: "mn-Cyrl", "mn-MN": { c: "₮", d: "yyyy-MM-dd" }, 1104: "mn-MN", "mn-Mong": { c: "¥", d: "yyyy/M/d" }, 31824: "mn-Mong", "mn-Mong-CN": { c: "¥", d: "yyyy/M/d" }, 2128: "mn-Mong-CN", "mn-Mong-MN": { c: "₮", d: "yyyy/M/d" }, 3152: "mn-Mong-MN", "moh": { c: "$", d: "M/d/yyyy" }, 124: "moh", "moh-CA": { c: "$", d: "M/d/yyyy" }, 1148: "moh-CA", "mr": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 78: "mr", "mr-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1102: "mr-IN", "ms": { c: "RM", d: "dd/MM/yyyy" }, 62: "ms", "ms-BN": { c: "$", d: "dd/MM/yyyy" }, 2110: "ms-BN", "ms-MY": { c: "RM", d: "dd/MM/yyyy" }, 1086: "ms-MY", "mt": { c: "€", d: "dd/MM/yyyy" }, 58: "mt", "mt-MT": { c: "€", d: "dd/MM/yyyy" }, 1082: "mt-MT", "my": { c: "K", d: "dd-MM-yyyy", n: "၀၁၂၃၄၅၆၇၈၉" }, 85: "my", "my-MM": { c: "K", d: "dd-MM-yyyy", n: "၀၁၂၃၄၅၆၇၈၉" }, 1109: "my-MM", "nb": { c: "kr", d: "dd.MM.yyyy" }, 31764: "nb", "nb-NO": { c: "kr", d: "dd.MM.yyyy" }, 1044: "nb-NO", "ne": { c: "रु", d: "M/d/yyyy", n: "०१२३४५६७८९" }, 97: "ne", "ne-IN": { c: "₹", d: "yyyy-MM-dd", n: "०१२३४५६७८९" }, 2145: "ne-IN", "ne-NP": { c: "रु", d: "M/d/yyyy", n: "०१२३४५६७८९" }, 1121: "ne-NP", "nl": { c: "€", d: "d-M-yyyy" }, 19: "nl", "nl-BE": { c: "€", d: "d/MM/yyyy" }, 2067: "nl-BE", "nl-NL": { c: "€", d: "d-M-yyyy" }, 1043: "nl-NL", "nn": { c: "kr", d: "dd.MM.yyyy" }, 30740: "nn", "nn-NO": { c: "kr", d: "dd.MM.yyyy" }, 2068: "nn-NO", "no": { c: "kr", d: "dd.MM.yyyy" }, 20: "no", "nqo": { c: "ߖߕ.", d: "dd/MM/yyyy", n: "߀߁߂߃߄߅߆߇߈߉" }, "nqo-GN": { c: "ߖߕ.", d: "dd/MM/yyyy", n: "߀߁߂߃߄߅߆߇߈߉" }, "nso": { c: "R", d: "dd/MM/yy" }, 108: "nso", "nso-ZA": { c: "R", d: "dd/MM/yy" }, 1132: "nso-ZA", "oc": { c: "€", d: "dd/MM/yyyy" }, 130: "oc", "oc-FR": { c: "€", d: "dd/MM/yyyy" }, 1154: "oc-FR", "om": { c: "Br", d: "dd/MM/yy" }, 114: "om", "om-ET": { c: "Br", d: "dd/MM/yy" }, 1138: "om-ET", "or": { c: "₹", d: "dd-MM-yy", n: "୦୧୨୩୪୫୬୭୮୯" }, 72: "or", "or-IN": { c: "₹", d: "dd-MM-yy", n: "୦୧୨୩୪୫୬୭୮୯" }, 1096: "or-IN", "pa": { c: "₹", d: "dd-MM-yy", n: "੦੧੨੩੪੫੬੭੮੯" }, 70: "pa", "pa-Arab": { c: "Rs", d: "dd-MM-yy", n: "۰۱۲۳۴۵۶۷۸۹" }, 31814: "pa-Arab", "pa-Arab-PK": { c: "Rs", d: "dd-MM-yy", n: "۰۱۲۳۴۵۶۷۸۹" }, 2118: "pa-Arab-PK", "pa-IN": { c: "₹", d: "dd-MM-yy", n: "੦੧੨੩੪੫੬੭੮੯" }, 1094: "pa-IN", "pl": { c: "zł", d: "yyyy-MM-dd" }, 21: "pl", "pl-PL": { c: "zł", d: "yyyy-MM-dd" }, 1045: "pl-PL", "prs": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 140: "prs", "prs-AF": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 1164: "prs-AF", "ps": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 99: "ps", "ps-AF": { c: "؋", d: "yyyy/M/d", n: "٠١٢٣٤٥٦٧٨٩" }, 1123: "ps-AF", "pt": { c: "R$", d: "dd/MM/yyyy" }, 22: "pt", "pt-AO": { c: "Kz", d: "dd/MM/yy" }, "pt-BR": { c: "R$", d: "dd/MM/yyyy" }, 1046: "pt-BR", "pt-PT": { c: "€", d: "dd/MM/yyyy" }, 2070: "pt-PT", "qut": { c: "Q", d: "dd/MM/yyyy" }, 134: "qut", "qut-GT": { c: "Q", d: "dd/MM/yyyy" }, 1158: "qut-GT", "quz": { c: "Bs.", d: "dd/MM/yyyy" }, 107: "quz", "quz-BO": { c: "Bs.", d: "dd/MM/yyyy" }, 1131: "quz-BO", "quz-EC": { c: "$", d: "dd/MM/yyyy" }, 2155: "quz-EC", "quz-PE": { c: "S/.", d: "dd/MM/yyyy" }, 3179: "quz-PE", "rm": { c: "fr.", d: "dd-MM-yyyy" }, 23: "rm", "rm-CH": { c: "fr.", d: "dd-MM-yyyy" }, 1047: "rm-CH", "ro": { c: "lei", d: "dd.MM.yyyy" }, 24: "ro", "ro-MD": { c: "L", d: "dd.MM.yyyy" }, 2072: "ro-MD", "ro-RO": { c: "lei", d: "dd.MM.yyyy" }, 1048: "ro-RO", "ru": { c: "₽", d: "dd.MM.yyyy" }, 25: "ru", "ru-RU": { c: "₽", d: "dd.MM.yyyy" }, 1049: "ru-RU", "rw": { c: "RWF", d: "d/MM/yyyy" }, 135: "rw", "rw-RW": { c: "RWF", d: "d/MM/yyyy" }, 1159: "rw-RW", "sa": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 79: "sa", "sah": { c: "₽", d: "dd.MM.yyyy" }, 133: "sah", "sah-RU": { c: "₽", d: "dd.MM.yyyy" }, 1157: "sah-RU", "sa-IN": { c: "₹", d: "dd-MM-yyyy", n: "०१२३४५६७८९" }, 1103: "sa-IN", "sd": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 89: "sd", "sd-Arab": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 31833: "sd-Arab", "sd-Arab-PK": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 2137: "sd-Arab-PK", "se": { c: "kr", d: "dd.MM.yyyy" }, 59: "se", "se-FI": { c: "€", d: "d.M.yyyy" }, 3131: "se-FI", "se-NO": { c: "kr", d: "dd.MM.yyyy" }, 1083: "se-NO", "se-SE": { c: "kr", d: "yyyy-MM-dd" }, 2107: "se-SE", "si": { c: "රු.", d: "yyyy-MM-dd" }, 91: "si", "si-LK": { c: "රු.", d: "yyyy-MM-dd" }, 1115: "si-LK", "sk": { c: "EUR", d: "d.M.yyyy" }, 27: "sk", "sk-SK": { c: "EUR", d: "d.M.yyyy" }, 1051: "sk-SK", "sl": { c: "€", d: "d.M.yyyy" }, 36: "sl", "sl-SI": { c: "€", d: "d.M.yyyy" }, 1060: "sl-SI", "sma": { c: "kr", d: "yyyy-MM-dd" }, 30779: "sma", "sma-NO": { c: "kr", d: "dd.MM.yyyy" }, 6203: "sma-NO", "sma-SE": { c: "kr", d: "yyyy-MM-dd" }, 7227: "sma-SE", "smj": { c: "kr", d: "yyyy-MM-dd" }, 31803: "smj", "smj-NO": { c: "kr", d: "dd.MM.yyyy" }, 4155: "smj-NO", "smj-SE": { c: "kr", d: "yyyy-MM-dd" }, 5179: "smj-SE", "smn": { c: "€", d: "d.M.yyyy" }, 28731: "smn", "smn-FI": { c: "€", d: "d.M.yyyy" }, 9275: "smn-FI", "sms": { c: "€", d: "d.M.yyyy" }, 29755: "sms", "sms-FI": { c: "€", d: "d.M.yyyy" }, 8251: "sms-FI", "sn": { c: "US$", d: "dd/MM/yyyy" }, "sn-Latn": { c: "US$", d: "dd/MM/yyyy" }, "sn-Latn-ZW": { c: "US$", d: "dd/MM/yyyy" }, "so": { c: "S", d: "dd/MM/yy" }, 119: "so", "so-SO": { c: "S", d: "dd/MM/yy" }, 1143: "so-SO", "sq": { c: "Lek", d: "d.M.yyyy" }, 28: "sq", "sq-AL": { c: "Lek", d: "d.M.yyyy" }, 1052: "sq-AL", "sr": { c: "din.", d: "d.M.yyyy." }, 31770: "sr", "sr-Cyrl": { c: "дин.", d: "d.M.yyyy." }, 27674: "sr-Cyrl", "sr-Cyrl-BA": { c: "КМ", d: "d.M.yyyy." }, 7194: "sr-Cyrl-BA", "sr-Cyrl-CS": { c: "дин.", d: "d.M.yyyy." }, 3098: "sr-Cyrl-CS", "sr-Cyrl-ME": { c: "€", d: "d.M.yyyy." }, 12314: "sr-Cyrl-ME", "sr-Cyrl-RS": { c: "дин.", d: "d.M.yyyy." }, 10266: "sr-Cyrl-RS", "sr-Latn": { c: "din.", d: "d.M.yyyy." }, 28698: "sr-Latn", "sr-Latn-BA": { c: "KM", d: "d.M.yyyy." }, 6170: "sr-Latn-BA", "sr-Latn-CS": { c: "din.", d: "d.M.yyyy." }, 2074: "sr-Latn-CS", "sr-Latn-ME": { c: "€", d: "d.M.yyyy." }, 11290: "sr-Latn-ME", "sr-Latn-RS": { c: "din.", d: "d.M.yyyy." }, 9242: "sr-Latn-RS", "st": { c: "R", d: "yyyy-MM-dd" }, 48: "st", "st-ZA": { c: "R", d: "yyyy-MM-dd" }, 1072: "st-ZA", "sv": { c: "kr", d: "yyyy-MM-dd" }, 29: "sv", "sv-FI": { c: "€", d: "d.M.yyyy" }, 2077: "sv-FI", "sv-SE": { c: "kr", d: "yyyy-MM-dd" }, 1053: "sv-SE", "sw": { c: "KSh", d: "M/d/yyyy" }, 65: "sw", "sw-KE": { c: "KSh", d: "M/d/yyyy" }, 1089: "sw-KE", "syr": { c: "ܠ.ܣ.‏", d: "dd/MM/yyyy" }, 90: "syr", "syr-SY": { c: "ܠ.ܣ.‏", d: "dd/MM/yyyy" }, 1114: "syr-SY", "ta": { c: "₹", d: "dd-MM-yyyy", n: "௦௧௨௩௪௫௬௭௮௯" }, 73: "ta", "ta-IN": { c: "₹", d: "dd-MM-yyyy", n: "௦௧௨௩௪௫௬௭௮௯" }, 1097: "ta-IN", "ta-LK": { c: "Rs", d: "dd-MM-yyyy", n: "௦௧௨௩௪௫௬௭௮௯" }, 2121: "ta-LK", "te": { c: "₹", d: "dd-MM-yy", n: "౦౧౨౩౪౫౬౭౮౯" }, 74: "te", "te-IN": { c: "₹", d: "dd-MM-yy", n: "౦౧౨౩౪౫౬౭౮౯" }, 1098: "te-IN", "tg": { c: "смн", d: "dd.MM.yyyy" }, 40: "tg", "tg-Cyrl": { c: "смн", d: "dd.MM.yyyy" }, 31784: "tg-Cyrl", "tg-Cyrl-TJ": { c: "смн", d: "dd.MM.yyyy" }, 1064: "tg-Cyrl-TJ", "th": { c: "฿", d: "d/M/yyyy", n: "๐๑๒๓๔๕๖๗๘๙" }, 30: "th", "th-TH": { c: "฿", d: "d/M/yyyy", n: "๐๑๒๓๔๕๖๗๘๙" }, 1054: "th-TH", "ti": { c: "ERN", d: "d/M/yyyy" }, 115: "ti", "ti-ER": { c: "ERN", d: "d/M/yyyy" }, 2163: "ti-ER", "ti-ET": { c: "ብር", d: "d/M/yyyy" }, 1139: "ti-ET", "tk": { c: "m.", d: "dd.MM.yy \"ý.\"" }, 66: "tk", "tk-TM": { c: "m.", d: "dd.MM.yy \"ý.\"" }, 1090: "tk-TM", "tn": { c: "R", d: "dd/MM/yy" }, 50: "tn", "tn-BW": { c: "P", d: "dd/MM/yy" }, 2098: "tn-BW", "tn-ZA": { c: "R", d: "dd/MM/yy" }, 1074: "tn-ZA", "tr": { c: "₺", d: "d.M.yyyy" }, 31: "tr", "tr-TR": { c: "₺", d: "d.M.yyyy" }, 1055: "tr-TR", "ts": { c: "R", d: "yyyy-MM-dd" }, 49: "ts", "ts-ZA": { c: "R", d: "yyyy-MM-dd" }, 1073: "ts-ZA", "tt": { c: "₽", d: "dd.MM.yyyy" }, 68: "tt", "tt-RU": { c: "₽", d: "dd.MM.yyyy" }, 1092: "tt-RU", "tzm": { c: "DA", d: "dd-MM-yyyy" }, 95: "tzm", "tzm-Latn": { c: "DA", d: "dd-MM-yyyy" }, 31839: "tzm-Latn", "tzm-Latn-DZ": { c: "DA", d: "dd-MM-yyyy" }, 2143: "tzm-Latn-DZ", "tzm-Tfng": { c: "ⴷⵔ", d: "dd-MM-yyyy" }, 30815: "tzm-Tfng", "tzm-Tfng-MA": { c: "ⴷⵔ", d: "dd-MM-yyyy" }, 4191: "tzm-Tfng-MA", "ug": { c: "¥", d: "yyyy-M-d" }, 128: "ug", "ug-CN": { c: "¥", d: "yyyy-M-d" }, 1152: "ug-CN", "uk": { c: "₴", d: "dd.MM.yyyy" }, 34: "uk", "uk-UA": { c: "₴", d: "dd.MM.yyyy" }, 1058: "uk-UA", "ur": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 32: "ur", "ur-IN": { c: "₹", d: "d/M/yy", n: "۰۱۲۳۴۵۶۷۸۹" }, 2080: "ur-IN", "ur-PK": { c: "Rs", d: "dd/MM/yyyy", n: "۰۱۲۳۴۵۶۷۸۹" }, 1056: "ur-PK", "uz": { c: "so\"m", d: "dd.MM.yyyy" }, 67: "uz", "uz-Cyrl": { c: "сўм", d: "dd.MM.yyyy" }, 30787: "uz-Cyrl", "uz-Cyrl-UZ": { c: "сўм", d: "dd.MM.yyyy" }, 2115: "uz-Cyrl-UZ", "uz-Latn": { c: "so\"m", d: "dd.MM.yyyy" }, 31811: "uz-Latn", "uz-Latn-UZ": { c: "so\"m", d: "dd.MM.yyyy" }, 1091: "uz-Latn-UZ", "vi": { c: "₫", d: "dd/MM/yyyy" }, 42: "vi", "vi-VN": { c: "₫", d: "dd/MM/yyyy" }, 1066: "vi-VN", "wo": { c: "CFA", d: "dd/MM/yyyy" }, 136: "wo", "wo-SN": { c: "CFA", d: "dd/MM/yyyy" }, 1160: "wo-SN", "xh": { c: "R", d: "yyyy/MM/dd" }, 52: "xh", "xh-ZA": { c: "R", d: "yyyy/MM/dd" }, 1076: "xh-ZA", "yo": { c: "₦", d: "d/M/yyyy" }, 106: "yo", "yo-NG": { c: "₦", d: "d/M/yyyy" }, 1130: "yo-NG", "zgh": { c: "ⴷⵔⵎ", d: "dd-MM-yyyy" }, "zgh-Tfng": { c: "ⴷⵔⵎ", d: "dd-MM-yyyy" }, "zgh-Tfng-MA": { c: "ⴷⵔⵎ", d: "dd-MM-yyyy" }, "zh": { c: "¥", d: "yyyy/M/d" }, 30724: "zh", "zh-CHS": { c: "¥", d: "yyyy/M/d" }, 4: "zh-CHS", "zh-CHT": { c: "HK$", d: "d/M/yyyy" }, 31748: "zh-CHT", "zh-CN": { c: "¥", d: "yyyy/M/d" }, 2052: "zh-CN", "zh-Hans": { c: "¥", d: "yyyy/M/d" }, "zh-Hant": { c: "HK$", d: "d/M/yyyy" }, "zh-HK": { c: "HK$", d: "d/M/yyyy" }, 3076: "zh-HK", "zh-MO": { c: "MOP", d: "d/M/yyyy" }, 5124: "zh-MO", "zh-SG": { c: "$", d: "d/M/yyyy" }, 4100: "zh-SG", "zh-TW": { c: "NT$", d: "yyyy/M/d" }, 1028: "zh-TW", "zu": { c: "R", d: "dd-MM-yyyy" }, 53: "zu", "zu-ZA": { c: "R", d: "dd-MM-yyyy" }, 1077: "zu-ZA" };
let CultureInfo = /*@__PURE__*/ (() => {
    class CultureInfo extends Base {
        constructor(name) {
            super();
            this._name = null;
            this._isInvariant = false;
            this._dateTimeFormat = null;
            this._numberFormat = null;
            this._name = name;
        }
        clone() {
            var copy = new CultureInfo(this._name);
            for (var attr in this) {
                if (this.hasOwnProperty(attr)) {
                    copy[attr] = this[attr];
                }
            }
            if (this._dateTimeFormat) {
                copy._dateTimeFormat = this._dateTimeFormat.clone();
            }
            if (this._numberFormat) {
                copy._numberFormat = this._numberFormat.clone();
            }
            return copy;
        }
        get compareInfo() {
            // TODO:
            return new CompareInfo();
        }
        getFormat($t) {
            if ($t === NumberFormatInfo.prototype.$type) {
                return this.numberFormat;
            }
            if ($t === DateTimeFormat.prototype.$type) {
                return this.dateTimeFormat;
            }
            throw new Error("Unknown format type");
        }
        get name() {
            return this._name;
        }
        get calendar() {
            // TODO
            return new Calendar();
        }
        get dateTimeFormat() {
            if (!this._dateTimeFormat) {
                this._dateTimeFormat = new DateTimeFormat(this._name, this._isInvariant);
            }
            return this._dateTimeFormat;
        }
        set dateTimeFormat(value) {
            this._dateTimeFormat = value;
        }
        get numberFormat() {
            if (!this._numberFormat) {
                this._numberFormat = new NumberFormatInfo(this._name, this._isInvariant);
            }
            return this._numberFormat;
        }
        set numberFormat(value) {
            this._numberFormat = value;
        }
        get twoLetterISOLanguageName() {
            if (this._name.length > 2 && this._name[2] == "-") {
                return this._name.substr(0, 2);
            }
            // TODO
            return "";
        }
        static getCultureInfo(lcid) {
            var name = globalInfo[lcid];
            if (name) {
                if (name === "invariant") {
                    return CultureInfo.invariantCulture;
                }
                return new CultureInfo(name);
            }
            // TODO: throw error here?
            return CultureInfo.invariantCulture;
        }
        static get currentCulture() {
            return Thread.currentThread.currentCulture;
        }
        static get invariantCulture() {
            if (this._cachedInvariant) {
                return this._cachedInvariant;
            }
            // TODO: Make a true invariant culture
            /*jshint -W093 */
            this._cachedInvariant = new CultureInfo("en-US");
            this._cachedInvariant._isInvariant = true;
            return this._cachedInvariant;
        }
    }
    CultureInfo._cachedInvariant = null;
    CultureInfo.$t = /*@__PURE__*/ markType(CultureInfo, "CultureInfo");
    return CultureInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function ieeeRemainder(a, b) {
    var r = Math.abs(a % b);
    if (isNaN(r) || r == b || r <= Math.abs(b) / 2.0) {
        return r;
    }
    else {
        return Math.sign(a) * (r - b);
    }
}
;
function numberToString1(value, provider) {
    return value.toLocaleString(provider.name, { useGrouping: false }); // TODO: Figure out how to use the provider correctly here
}
function tryParseNumber1(s, style, provider, v) {
    // TODO: had to change the provider from CultureInfo to any but that's not ideal. see what we should do here
    var value, i, currentCharCode;
    provider = provider || CultureInfo.currentCulture;
    /*jslint bitwise: true */
    if ((style & 1 /* AllowLeadingWhite */) !== 0) {
        var index = 0;
        while (index < s.length && s[index] === ' ') {
            index++;
        }
        s = s.substring(index);
    }
    if ((style & 2 /* AllowTrailingWhite */) !== 0) {
        var index = s.length - 1;
        while (index >= 0 && s[index] === ' ') {
            index--;
        }
        s = s.substring(0, index + 1);
    }
    if (s.length != s.trim().length) {
        return {
            p3: 0,
            ret: false
        };
    }
    var numberFormat = provider.numberFormat;
    if (style & 256 /* AllowCurrencySymbol */) {
        // TODO: Use the locale specific symbol from the provider here
        if (s[0] == "$") {
            s = s.slice(1);
        }
    }
    var multiplier = 1;
    var hadParentheses = false;
    if (style & 16 /* AllowParentheses */) {
        if (s[0] == "(" && s[s.length - 1] == ")") {
            hadParentheses = true;
            multiplier *= -1;
            s = s.slice(1, -1);
        }
    }
    if (style & 256 /* AllowCurrencySymbol */) {
        // TODO: Use the locale specific symbol from the provider here
        if (s[0] == "$") {
            s = s.slice(1);
        }
    }
    if (style & 4 /* AllowLeadingSign */) {
        var positiveSign = numberFormat.positiveSign;
        var negativeSign = numberFormat.negativeSign;
        if (s[0] == positiveSign || s[0] == negativeSign) {
            if (hadParentheses) {
                return {
                    p3: 0,
                    ret: false
                };
            }
            if (s[0] == negativeSign) {
                multiplier *= -1;
            }
            s = s.slice(1);
        }
    }
    if (style & 8 /* AllowTrailingSign */) {
        // TODO
    }
    if (style & 32 /* AllowDecimalPoint */) {
        if (style & 128 /* AllowExponent */) {
            // TODO
        }
        if (style & 64 /* AllowThousands */) {
            var decimalSeparator = numberFormat.numberDecimalSeparator;
            var groupSeparator = numberFormat.numberGroupSeparator;
            var hitDecimalSeparator = false;
            for (i = 0; i < s.length; i++) {
                switch (s[i]) {
                    case groupSeparator:
                        if (hitDecimalSeparator) {
                            return {
                                p3: 0,
                                ret: false
                            };
                        }
                        s = s.slice(0, i) + s.slice(i + 1);
                        i--;
                        break;
                    case decimalSeparator:
                        hitDecimalSeparator = true;
                        if (decimalSeparator != ".") {
                            s = s.slice(0, i) + "." + s.slice(i + 1);
                        }
                        break;
                }
            }
        }
        value = Number(s);
        if (value !== null && isFinite(value) && s.trim().length !== 0) {
            return {
                p3: value * multiplier,
                ret: true
            };
        }
    }
    else {
        var zeroCharCode = "0".charCodeAt(0);
        var nineCharCode = "9".charCodeAt(0);
        value = 0;
        if (style & 512 /* AllowHexSpecifier */) {
            var aCharCode = "a".charCodeAt(0);
            var fCharCode = "f".charCodeAt(0);
            var ACharCode = "A".charCodeAt(0);
            var FCharCode = "F".charCodeAt(0);
            for (i = 0; i < s.length; i++) {
                value *= 16;
                currentCharCode = s[i].charCodeAt(0);
                if (zeroCharCode <= currentCharCode && currentCharCode <= nineCharCode) {
                    value += (currentCharCode - zeroCharCode);
                }
                else if (aCharCode <= currentCharCode && currentCharCode <= fCharCode) {
                    value += (currentCharCode - aCharCode) + 10;
                }
                else if (ACharCode <= currentCharCode && currentCharCode <= FCharCode) {
                    value += (currentCharCode - ACharCode) + 10;
                }
                else {
                    return {
                        p3: 0,
                        ret: false
                    };
                }
            }
        }
        else {
            for (i = 0; i < s.length; i++) {
                value *= 10;
                currentCharCode = s[i].charCodeAt(0);
                if (zeroCharCode <= currentCharCode && currentCharCode <= nineCharCode) {
                    value += (currentCharCode - zeroCharCode);
                }
                else {
                    return {
                        p3: 0,
                        ret: false
                    };
                }
            }
        }
        return {
            p3: value * multiplier,
            ret: true
        };
    }
    return {
        p3: 0,
        ret: false
    };
}
function parseNumber(s, provider) {
    return parseNumber1(s, 231, provider);
}
function parseNumber1(s, style, provider) {
    var r = tryParseNumber1(s, style, provider);
    if (!r.ret) {
        throw new FormatException(1, "Incorrect number format");
    }
    return r.p3;
}
function parseInt8_1(s, provider) {
    return parseIntCore(s, provider, -128, 127);
}
;
function parseInt8_2(s, style, provider) {
    return parseIntCore(s, provider, -128, 127, style);
}
;
function parseInt16_1(s, provider) {
    return parseIntCore(s, provider, -32768, 32767);
}
;
function parseInt16_2(s, style, provider) {
    return parseIntCore(s, provider, -32768, 32767, style);
}
;
function parseInt32_1(s, provider) {
    return parseIntCore(s, provider, -2147483648, 2147483647);
}
;
function parseInt32_2(s, style, provider) {
    return parseIntCore(s, provider, -2147483648, 2147483647, style);
}
;
function parseInt64_1(s, provider) {
    return parseIntCore(s, provider, -9223372036854775808, 9223372036854775807);
}
;
function parseInt64_2(s, style, provider) {
    return parseIntCore(s, provider, -9223372036854775808, 9223372036854775807, style);
}
;
function parseUInt8_1(s, provider) {
    return parseIntCore(s, provider, 0, 255);
}
;
function parseUInt8_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 255, style);
}
;
function parseUInt16_1(s, provider) {
    return parseIntCore(s, provider, 0, 65535);
}
;
function parseUInt16_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 65535, style);
}
;
function parseUInt32_1(s, provider) {
    return parseIntCore(s, provider, 0, 4294967295);
}
;
function parseUInt32_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 4294967295, style);
}
;
function parseUInt64_1(s, provider) {
    return parseIntCore(s, provider, 0, 18446744073709551615);
}
;
function parseUInt64_2(s, style, provider) {
    return parseIntCore(s, provider, 0, 18446744073709551615, style);
}
;
function parseIntCore(s, provider, min, max, style = 7 /* Integer */) {
    var r = tryParseIntCore(s, provider, min, max, style);
    if (!r.ret) {
        throw new FormatException(1, "Incorrect number format");
    }
    return r.p3;
}
;
function tryParseInt8_1(s, value) {
    return tryParseIntCore(s, null, -128, 127);
}
;
function tryParseInt8_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -128, 127, style);
}
;
function tryParseInt16_1(s, value) {
    return tryParseIntCore(s, null, -32768, 32767);
}
;
function tryParseInt16_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -32768, 32767, style);
}
;
function tryParseInt32_1(s, value) {
    return tryParseIntCore(s, null, -2147483648, 2147483647);
}
;
function tryParseInt32_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -2147483648, 2147483647, style);
}
;
function tryParseInt64_1(s, value) {
    return tryParseIntCore(s, null, -9223372036854775808, 9223372036854775807);
}
;
function tryParseInt64_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, -9223372036854775808, 9223372036854775807, style);
}
;
function tryParseUInt8_1(s, value) {
    return tryParseIntCore(s, null, 0, 255);
}
;
function tryParseUInt8_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 255, style);
}
;
function tryParseUInt16_1(s, value) {
    return tryParseIntCore(s, null, 0, 65535);
}
;
function tryParseUInt16_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 65535, style);
}
;
function tryParseUInt32_1(s, value) {
    return tryParseIntCore(s, null, 0, 4294967295);
}
;
function tryParseUInt32_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 4294967295, style);
}
;
function tryParseUInt64_1(s, value) {
    return tryParseIntCore(s, null, 0, 18446744073709551615);
}
;
function tryParseUInt64_2(s, style, provider, value) {
    return tryParseIntCore(s, provider, 0, 18446744073709551615, style);
}
;
function tryParseIntCore(s, provider, min, max, style = 7 /* Integer */) {
    /*jshint eqnull:true */
    /*jslint bitwise: true */
    //style = style != null ? style : NumberStyles.integer; // Don't use || here, because 0 could be a valid style
    provider = provider || CultureInfo.currentCulture;
    var r = tryParseNumber1(s, style, provider);
    if ((style & 512 /* AllowHexSpecifier */) && max < r.p3) {
        r.p3 -= (-min * 2);
    }
    if (!r.ret || r.p3 < min || max < r.p3 || r.p3 % 1 !== 0) {
        return {
            p1: 0,
            p3: 0,
            ret: false
        };
    }
    let ret = {
        p1: r.p3,
        p3: r.p3,
        ret: r.ret
    };
    return ret;
}
function numberToString(number, provider) {
    return numberToString2(number, "G", provider);
}
;
let gFormatOptions = { useGrouping: false, maximumSignificantDigits: 15 };
let zeroFormatOptions = {
    useGrouping: false,
    maximumSignificantDigits: 15,
    maximumFractionDigits: 0
};
function numberToString2(number, format, provider) {
    // TODO: had to change the provider from CultureInfo to any but that's not ideal. see what we should do here
    provider = provider || CultureInfo.currentCulture;
    switch (format) {
        case "G":
            return number.toLocaleString(provider.name, gFormatOptions);
        case "R":
        case "r":
            return number.toString()
                .replace(".", provider.numberFormat.numberDecimalSeparator);
    }
    if (format.match(/[0\#\.]+/)) {
        var isValid = true;
        var formatIndexOfDecimalSeparator = format.indexOf(".");
        var decimalFormat = formatIndexOfDecimalSeparator == -1 ? "" :
            format.substring(formatIndexOfDecimalSeparator + 1);
        var numberString = number.toFixed(decimalFormat.length).toString();
        var numberIndexOfDecimalSeparator = numberString.indexOf(".");
        var integralPart = numberIndexOfDecimalSeparator == -1 ? numberString :
            numberString.substring(0, numberIndexOfDecimalSeparator);
        var integralFormat = formatIndexOfDecimalSeparator == -1 ? format :
            format.substring(0, formatIndexOfDecimalSeparator);
        while (integralFormat.length < integralPart.length) {
            integralFormat = "0" + integralFormat;
        }
        while (integralPart.length < integralFormat.length) {
            integralPart = "0" + integralPart;
        }
        var formattedIntegralPart = "";
        var digit;
        for (var ii = integralFormat.length - 1; ii >= 0; ii--) {
            if (integralFormat[ii] == "0") {
                formattedIntegralPart = integralPart[ii] + formattedIntegralPart;
            }
            else if (integralFormat[ii] == "#") {
                digit = integralPart.substring(0, ii + 1).match(/[1-9]/) ?
                    integralPart[ii] : "";
                formattedIntegralPart = digit + formattedIntegralPart;
            }
            else {
                isValid = false;
            }
        }
        var decimalPart = numberIndexOfDecimalSeparator == -1 ? "" :
            numberString.substring(numberIndexOfDecimalSeparator + 1);
        var formattedDecimalPart = "";
        for (var jj = 0; jj < decimalFormat.length; jj++) {
            if (decimalFormat[jj] == "0") {
                formattedDecimalPart += decimalPart[jj];
            }
            else if (decimalFormat[jj] == "#") {
                digit = decimalPart.length > jj && (decimalPart[jj] != "0" || decimalPart.substring(jj).match(/[1-9]/)) ?
                    decimalPart[jj] : "";
                formattedDecimalPart += digit;
            }
            else {
                isValid = false;
            }
        }
        if (isValid) {
            return formattedIntegralPart +
                (formattedDecimalPart.length > 0 ? "." + formattedDecimalPart : "");
        }
    }
    throw new FormatException(1, "Unsupported format code: " + format);
}
function intToString(number, provider) {
    return intToString1(number, "G", provider);
}
;
function intToString1(number, format, provider) {
    provider = provider || CultureInfo.currentCulture;
    if (format && format.length) {
        if (format[0] == "X") {
            number = intSToU(number);
            var result = number.toString(16).toUpperCase();
            if (format.length !== 1) {
                var digits = +format.substr(1);
                if (!isFinite(digits)) {
                    throw new Error("Unsupported format code: " + format);
                }
                while (result.length < digits) {
                    result = "0" + result;
                }
            }
            return result;
        }
    }
    switch (format) {
        case "G":
            return number.toLocaleString(provider.name, gFormatOptions);
    }
    throw new Error("Unsupported format code: " + format);
}
function intSToU(number) {
    if (number < 0) {
        number = number + 1 + 0xFFFFFFFF;
    }
    return number;
}
function u32BitwiseAnd(a, b) {
    var r = a & b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function u32BitwiseOr(a, b) {
    var r = a | b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function u32BitwiseXor(a, b) {
    var r = a ^ b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function u32LS(a, b) {
    var r = a << b;
    if (r < 0) {
        r += 4294967296;
    }
    return r;
}
function decimalAdjust(type, value, exp) {
    // If the exp is undefined or zero...
    if (typeof exp === "undefined" || +exp === 0) {
        return Math[type](value);
    }
    value = +value;
    exp = +exp;
    // If the value is not a number or the exp is not an integer...
    if (isNaN(value) || !(typeof exp === "number" && exp % 1 === 0)) {
        return NaN;
    }
    // Shift
    value = value.toString().split("e");
    value = Math[type](+(value[0] + "e" + (value[1] ? (+value[1] - exp) : -exp)));
    // Shift back
    value = value.toString().split("e");
    return +(value[0] + "e" + (value[1] ? (+value[1] + exp) : exp));
}
function round10(value, exp) {
    return decimalAdjust("round", value, exp);
}
function round10N(value, exp) {
    return decimalAdjust("round", value, -exp);
}
function floor10(value, exp) {
    return decimalAdjust("floor", value, exp);
}
function ceil10(value, exp) {
    return decimalAdjust("ceil", value, exp);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockDetails = /*@__PURE__*/ (() => {
    class StockDetails extends StockInfo {
        constructor() {
            super(...arguments);
            this._annualLow = 0;
            this._annualHigh = 0;
            this._marketPrice = 0;
            this._marketShares = 0;
            this._volatility = 0;
        }
        get annualLow() {
            return this._annualLow;
        }
        set annualLow(a) {
            this._annualLow = a;
        }
        get annualHigh() {
            return this._annualHigh;
        }
        set annualHigh(a) {
            this._annualHigh = a;
        }
        get marketPrice() {
            return this._marketPrice;
        }
        set marketPrice(a) {
            this._marketPrice = a;
        }
        get marketShares() {
            return this._marketShares;
        }
        set marketShares(a) {
            this._marketShares = a;
        }
        get marketCap() {
            return round10N(this.marketPrice * this.marketShares / 1000, 1);
        }
        get volatility() {
            return this._volatility;
        }
        set volatility(a) {
            this._volatility = a;
        }
    }
    StockDetails.$t = /*@__PURE__*/ markType(StockDetails, 'StockDetails', StockInfo.$);
    return StockDetails;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function timeSpanInit1(h, m, s) {
    return (h * 3600000) + (m * 60000) + (s * 1000);
}
;
function timeSpanInit2(d, h, m, s, ms) {
    return (d * 86400000) + (h * 3600000) + (m * 60000) + (s * 1000) + ms;
}
;
function timeSpanInit3(d, h, m, s) {
    return (d * 86400000) + (h * 3600000) + (m * 60000) + (s * 1000);
}
;
function timeSpanTotalDays(t) { return t / 86400000; }
;
function timeSpanTotalHours(t) { return t / 3600000; }
;
function timeSpanTotalMilliseconds(t) { return t; }
;
function timeSpanTotalMinutes(t) { return t / 60000; }
;
function timeSpanTotalSeconds(t) { return t / 1000; }
;
function timeSpanFromDays(v) { return v * 86400000; }
;
function timeSpanFromHours(v) { return v * 3600000; }
;
function timeSpanFromMilliseconds(v) { return v; }
;
function timeSpanFromMinutes(v) { return v * 60000; }
;
function timeSpanFromSeconds(v) { return v * 1000; }
;
function timeSpanFromTicks(v) { return v / 10000; }
;
function timeSpanDays(t) { return truncate(t / 86400000); }
;
function timeSpanHours(t) { return truncate((t / 3600000) % 24); }
;
function timeSpanMilliseconds(t) { return t % 1000; }
;
function timeSpanMinutes(t) { return truncate((t / 60000) % 60); }
;
function timeSpanSeconds(t) { return truncate((t / 1000) % 60); }
;
function timeSpanTicks(t) { return truncate(t * 10000); }
;
function timeSpanNegate(t) { return -t; }
;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockDataGenerator = /*@__PURE__*/ (() => {
    class StockDataGenerator extends Base {
        constructor() {
            super();
            this._priceStart = 0;
            this._priceRange = 0;
            this._priceMinimum = 0;
            this._priceMaximum = 0;
            this._volumeStart = 0;
            this._volumeRange = 0;
            this._dateRange = 0;
            this._dateInterval = 0;
            this._stockInterval = 0;
            this._skipAfterHours = false;
            this.g = new Date();
            this.h = new Date();
            this.q = new Random(0);
            this.skipAfterHours = false;
            this.priceStart = 0;
            this.priceRange = NaN;
            this.priceMinimum = NaN;
            this.priceMaximum = NaN;
            this.volumeStart = 0;
            this.volumeRange = NaN;
            this.dateRange = 12;
            this.dateInterval = 24 * 60;
        }
        get priceStart() {
            return this._priceStart;
        }
        set priceStart(a) {
            this._priceStart = a;
        }
        get priceRange() {
            return this._priceRange;
        }
        set priceRange(a) {
            this._priceRange = a;
        }
        get priceMinimum() {
            return this._priceMinimum;
        }
        set priceMinimum(a) {
            this._priceMinimum = a;
        }
        get priceMaximum() {
            return this._priceMaximum;
        }
        set priceMaximum(a) {
            this._priceMaximum = a;
        }
        get volumeStart() {
            return this._volumeStart;
        }
        set volumeStart(a) {
            this._volumeStart = a;
        }
        get volumeRange() {
            return this._volumeRange;
        }
        set volumeRange(a) {
            this._volumeRange = a;
        }
        get dateRange() {
            return this._dateRange;
        }
        set dateRange(a) {
            this._dateRange = a;
        }
        get dateInterval() {
            return this._dateInterval;
        }
        set dateInterval(a) {
            this._dateInterval = a;
        }
        get stockInterval() {
            return this._stockInterval;
        }
        set stockInterval(a) {
            this._stockInterval = a;
        }
        get skipAfterHours() {
            return this._skipAfterHours;
        }
        set skipAfterHours(a) {
            this._skipAfterHours = a;
        }
        generatePosition(a, b = "") {
            let c = StockDataLookup.get(a);
            let d = (intDivide(this.q.next2(1, 10), 100));
            let e = new StockPosition();
            e.symbol = c.symbol;
            e.company = c.company;
            e.sector = c.sector;
            e.costPerShare = c.close - (c.open * d);
            e.marketPrice = c.close;
            e.tradeDate = dateNow();
            return e;
        }
        generateDetails() {
            let a = new List$1(StockDetails.$, 0);
            for (let b of fromEnum(StockDataLookup.b.values)) {
                let c = (intDivide(this.q.next2(10, 30), 100));
                let d = new StockDetails();
                d.company = b.company;
                d.symbol = b.symbol;
                d.sector = b.sector;
                d.marketPrice = b.close;
                d.marketShares = intDivide((b.volume * this.q.next2(15, 20)), 1000000);
                d.annualLow = b.close - (b.open * c);
                d.annualHigh = b.close + (b.open * c);
                a.add(d);
            }
            return a.toArray();
        }
        generateStockPrices(a, b = "") {
            let c = dateNow();
            this.g = dateFromValues(c.getFullYear(), dateGetMonth(c), c.getDate(), 16, 30, 0, 0);
            this.h = dateAddMonths(this.g, -this.dateRange);
            let d = Math.ceil(timeSpanTotalMinutes((+(this.g) - +(this.h))) / this.dateInterval);
            let e = d * this.dateInterval;
            this.s(d + " steps, " + e + " range");
            if (d > 100000) {
                d = 100000;
                e = d * this.dateInterval;
                this.s(d + "^steps, " + e + " range");
            }
            let f = dateAddMinutes(this.g, -e);
            if (this.h.getTime() > f.getTime()) {
                this.h = f;
            }
            let g = StockDataLookup.get(a);
            g.date = this.h;
            let h = g.sector;
            if (this.priceStart > 0) {
                g.open = this.priceStart;
            }
            if (this.volumeStart > 0) {
                g.volume = this.volumeStart;
            }
            this.volumeRange = g.volume * 0.05;
            this.priceRange = g.open * 0.025;
            this.priceMinimum = g.open - (g.open * 0.75);
            this.priceMaximum = g.open + (g.open * 0.75);
            g.high = g.open + (g.open * 0.02);
            g.low = g.open - (g.open * 0.02);
            g.close = g.open + ((this.q.nextDouble() - 0.5) * this.priceRange);
            let i = new StockPriceHistory();
            i.symbol = a;
            if (!stringIsNullOrEmpty(b)) {
                g.company = b;
                i.company = b;
            }
            else if (!stringIsNullOrEmpty(g.company)) {
                i.company = g.company;
            }
            do {
                if (this.skipAfterHours) {
                    if (!this.e(g.date)) {
                        i.add(g);
                    }
                }
                else {
                    i.add(g);
                }
                g = this.generateStockPricePoint(g);
            } while (g.date.getTime() <= this.g.getTime());
            this.s(" " + i.count + " items");
            return i;
        }
        e(a) {
            if (a.getDay() == 6) {
                return true;
            }
            if (a.getDay() == 0) {
                return true;
            }
            let b = timeSpanInit1(9, 30, 0);
            let c = timeSpanInit1(16, 30, 0);
            let d = dateGetTimeOfDay(a);
            if (d < b || d > c) {
                return true;
            }
            return false;
        }
        generateStockPricePoint(a) {
            let b = (this.q.nextDouble() - 0.499) * this.priceRange;
            let c = a.close;
            let d = a.close + b;
            if (d < this.priceMinimum) {
                d = this.priceMinimum + b;
            }
            if (d > this.priceMaximum) {
                d = this.priceMaximum - b;
            }
            let e = (this.q.nextDouble() * 1.5 * Math.abs(b));
            let f = (this.q.nextDouble() * 1.5 * Math.abs(b));
            if (d > c) {
                e = d + e;
                f = c - f;
            }
            else {
                e = c + e;
                f = d - f;
            }
            let g = (this.q.nextDouble() - 0.49) * this.volumeRange;
            let h = truncate(Math.abs(a.volume + g));
            let i = dateAddMinutes(a.date, this.dateInterval);
            if (i.getTime() > this.g.getTime()) {
                i = this.g;
            }
            let j = ((() => {
                let $ret = new StockPricePoint();
                $ret.date = dateAddMinutes(a.date, this.dateInterval);
                $ret.symbol = a.symbol;
                $ret.company = a.company;
                $ret.sector = a.sector;
                $ret.close = round10N(d, 2);
                $ret.open = round10N(c, 2);
                $ret.high = round10N(e, 2);
                $ret.low = round10N(f, 2);
                $ret.volume = h;
                return $ret;
            })());
            return j;
        }
        s(message_) {
        }
    }
    StockDataGenerator.$t = /*@__PURE__*/ markType(StockDataGenerator, 'StockDataGenerator');
    return StockDataGenerator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialDataAdapter = /*@__PURE__*/ (() => {
    class FinancialDataAdapter extends Base {
        constructor() {
            super();
            this.e = new Array(0);
            this.c = new Array(0);
            this.d = ["*.open", "*.high", "*.low", "*.close", "*.volume", "*.date"];
            this.b = new Array(0);
            this.a = null;
            this.aa = 6;
            this.z = 10;
            this.r = true;
            this.propertyChanged = null;
            this.populateStockPosition = null;
            this.populateStockPrices = null;
            this.stockSymbolsChanged = null;
            this.v = new Dictionary$2(String_$type, StockPriceHistory.$, 0);
            this.x = new List$1(StockPosition.$, 0);
            this.w = new Dictionary$2(String_$type, String_$type, 0);
            this.o = new StockDataGenerator();
            this.o = new StockDataGenerator();
            this.a = this.o.generateDetails();
        }
        get stockSymbols() {
            return this.e;
        }
        set stockSymbols(a) {
            this.a1(this.e, a);
        }
        get stockPrices() {
            return this.c;
        }
        set stockPrices(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ap("StockPrices", b, this.c);
            }
        }
        get stockPricesMemberPaths() {
            return this.d;
        }
        get stockPositions() {
            return this.b;
        }
        set stockPositions(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.ap("StockPositions", b, this.b);
            }
        }
        get stockDetails() {
            return this.a;
        }
        set stockDetails(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ap("StockDetails", b, this.a);
            }
        }
        get ac() {
            return this.aa;
        }
        set ac(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.ap("StockPricesTimeRange", b, this.aa);
            }
        }
        get ab() {
            return this.z;
        }
        set ab(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ap("StockPricesTimeInterval", b, this.z);
            }
        }
        get u() {
            return this.r;
        }
        set u(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ap("StockPricesTradeAfterHours", b, this.r);
            }
        }
        ap(a, b, c) {
            this.aq(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        aq(a, b, c) {
            switch (a) {
                case "StockPricesTimeRange":
                case "StockPricesTimeInterval":
                case "StockPricesTradeAfterHours":
                    this.az();
                    break;
                case "StockSymbols":
                    this.ay(b, c);
                    break;
            }
        }
        au(a, b) {
            if (a == null) {
                a = new Array(0);
            }
            if (b == null) {
                b = new Array(0);
            }
            this.log("OnStockChanged " + a.length + " -> " + b.length);
            if (this.stockSymbolsChanged != null) {
                this.stockSymbolsChanged(this, new StockChangedEventArgs(a, b));
            }
        }
        log(message_) {
        }
        clearData() {
            this.e = new Array(0);
            this.v.clear();
            this.x.clear();
            arrayClear(this.stockPrices);
            arrayClear(this.stockPositions);
        }
        removeStockPosition(a) {
            this.ar(a);
        }
        removeStockPrices(a) {
            this.as(a, 0);
        }
        ax(a, b = "") {
            let e = this.stockSymbols;
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (!this.w.containsKey(c)) {
                    this.w.addItem(c, "");
                }
            }
            if (this.w.containsKey(a)) {
                this.w.item(a, b);
            }
            else {
                this.w.addItem(a, b);
            }
            let f = this.y(String_$type, this.stockSymbols);
            if (!f.contains(a)) {
                f.add(a);
            }
            this.stockSymbols = this.f(String_$type, f);
        }
        a0(a) {
            if (this.v.containsKey(a)) {
                let b = this.y(String_$type, this.stockSymbols);
                if (this.w.containsKey(a)) {
                    this.w.removeItem(a);
                }
                let c = this.y(String_$type, this.stockSymbols);
                if (c.contains(a)) {
                    c.remove(a);
                }
                this.e = this.f(String_$type, c);
                this.ay(this.f(String_$type, b), this.f(String_$type, c));
            }
        }
        ad(a) {
            if (stringIsNullOrEmpty(a)) {
                return "";
            }
            if (this.w.containsKey(a)) {
                return this.w.item(a);
            }
            return "";
        }
        q(a) {
            this.o.dateRange = this.ac;
            this.o.dateInterval = this.ab;
            this.o.skipAfterHours = !this.u;
            let b = this.ad(a);
            let c;
            if (this.populateStockPrices == null) {
                this.log("OnGeneratingPrices " + a);
                c = this.o.generateStockPrices(a, b);
            }
            else {
                this.log("OnPopulatePrices " + a);
                c = this.populateStockPrices(a);
            }
            return c;
        }
        p(a) {
            this.o.dateRange = this.ac;
            this.o.dateInterval = this.ab;
            this.o.skipAfterHours = !this.u;
            let b = this.ad(a);
            let c;
            if (this.populateStockPosition == null) {
                this.log("OnGeneratingPosition " + a);
                c = this.o.generatePosition(a, b);
            }
            else {
                this.log("OnPopulatePosition " + a);
                c = this.populateStockPosition(a);
            }
            return c;
        }
        an(a, b) {
            if (stringIsNullOrEmpty(a)) {
                return;
            }
            if (b == null) {
                return;
            }
            b.index = this.x.count;
            this.x.add(b);
            this.stockPositions = this.f(StockPosition.$, this.x);
        }
        ao(a, b) {
            if (stringIsNullOrEmpty(a)) {
                return;
            }
            if (b == null) {
                return;
            }
            this.log("OnAddingPrices " + a);
            if (!this.v.containsKey(a)) {
                this.v.addItem(a, b);
            }
            else {
                return;
            }
            this.stockPrices = this.f(StockPriceHistory.$, this.v.values);
        }
        as(a, b) {
            if (stringIsNullOrEmpty(a)) {
                return;
            }
            this.log("OnRemovingPrices " + a);
            if (this.v.containsKey(a)) {
                this.v.removeItem(a);
            }
            else {
                return;
            }
            this.stockPrices = this.f(StockPriceHistory.$, this.v.values);
        }
        ar(a) {
            this.log("OnRemovingPosition " + a);
            if (this.x.count > a) {
                this.x.removeAt(a);
            }
            else {
                return;
            }
            for (let b = 0; b < this.x.count; b++) {
                this.x._inner[b].index = b;
            }
            this.stockPositions = this.f(StockPosition.$, this.x);
        }
        at() {
            this.log("OnStockClearing ");
            this.a1(this.stockSymbols, new Array(0), true);
        }
        a1(a, b, c = false) {
            if (this.t(a, b)) {
                return;
            }
            let d = this.y(String_$type, a);
            for (let f = 0; f < b.length; f++) {
                let e = b[f];
                if (!d.contains(e)) {
                    d.add(e);
                }
            }
            this.e = this.f(String_$type, d);
            this.ap("StockSymbols", null, this.e);
            this.au(a, this.e);
        }
        ay(a, b) {
            if (a == b) {
                return;
            }
            this.log("StockGenerate ");
            if (a != null && a.length != 0) {
                for (let c = a.length - 1; c >= 0; c--) {
                    let d = a[c];
                    if (this.v.containsKey(d)) {
                        this.as(d, c);
                    }
                }
            }
            if (b != null && b.length != 0) {
                for (let e = 0; e < b.length; e++) {
                    let f = b[e];
                    if (!this.v.containsKey(f)) {
                        let g = this.p(f);
                        let h = this.q(f);
                        this.ao(f, h);
                        this.an(f, g);
                    }
                }
            }
        }
        az() {
            this.o.dateRange = this.ac;
            this.o.dateInterval = this.ab;
            this.o.skipAfterHours = !this.u;
            if (this.stockSymbols == null || this.stockSymbols.length == 0) {
                this.v.clear();
                this.x.clear();
                arrayClear(this.stockPrices);
                arrayClear(this.stockPositions);
            }
            else {
                this.v.clear();
                this.x.clear();
                arrayClear(this.stockPrices);
                arrayClear(this.stockPositions);
                for (let a = 0; a < this.stockSymbols.length; a++) {
                    let b = this.stockSymbols[a];
                    let c = this.p(b);
                    let d = this.q(b);
                    this.ao(b, d);
                    this.an(b, c);
                }
            }
        }
        s(a, b) {
            if (a == null || a.length == 0) {
                return false;
            }
            for (let d = 0; d < a.length; d++) {
                let c = a[d];
                if (b == c) {
                    return true;
                }
            }
            return false;
        }
        f($t, a) {
            if (a == null || a.count == 0) {
                return new Array(0);
            }
            let b = new Array(a.count);
            let c = 0;
            for (let d of fromEnum(a)) {
                b[c] = d;
                c++;
            }
            return b;
        }
        y($t, a) {
            if (a == null || a.length == 0) {
                return new List$1($t, 0);
            }
            let b = new List$1($t, 0);
            for (let c = 0; c < a.length; c++) {
                b.add(a[c]);
            }
            return b;
        }
        t(a, b) {
            if (a == null || b == null) {
                return false;
            }
            if (a.length != b.length) {
                return false;
            }
            for (let c = 0; c < a.length; c++) {
                if (a[c] != b[c]) {
                    return false;
                }
            }
            return true;
        }
    }
    FinancialDataAdapter.$t = /*@__PURE__*/ markType(FinancialDataAdapter, 'FinancialDataAdapter', Base.$, [INotifyPropertyChanged_$type]);
    return FinancialDataAdapter;
})();

/**
 * Represents event arguments for FDC3 MessageRecived
*/
class IgrStockChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets array of added stock symbols
    */
    get addedSymbols() {
        return this.i.addedSymbols;
    }
    set addedSymbols(v) {
        this.i.addedSymbols = v;
    }
    /**
     * Gets array of removed stock symbols
    */
    get removedSymbols() {
        return this.i.removedSymbols;
    }
    set removedSymbols(v) {
        this.i.removedSymbols = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsDataChangeNotifications_$type = /*@__PURE__*/ new Type(null, 'ISupportsDataChangeNotifications');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceSupportsCount_$type = /*@__PURE__*/ new Type(null, 'IDataSourceSupportsCount');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceDataProviderUpdateNotifier_$type = /*@__PURE__*/ new Type(null, 'IDataSourceDataProviderUpdateNotifier', null, [ISupportsDataChangeNotifications_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INotifyCollectionChanged_$type = /*@__PURE__*/ new Type(null, 'INotifyCollectionChanged');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NotifyCollectionChangedEventArgs = /*@__PURE__*/ (() => {
    class NotifyCollectionChangedEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super();
                        this.f = 0;
                        this.b = null;
                        this.h = 0;
                        this.c = null;
                        this.i = 0;
                        this.f = c;
                        this.c = new List$1(Base.$, 0);
                        this.b = new List$1(Base.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super();
                        this.f = 0;
                        this.b = null;
                        this.h = 0;
                        this.c = null;
                        this.i = 0;
                        this.f = c;
                        this.c = new List$1(Base.$, 0);
                        if (this.f == 1 || this.f == 2) {
                            this.c.add(d);
                            this.i = e;
                        }
                        if (this.f != 1) {
                            this.b = ((() => {
                                let $ret = new List$1(Base.$, 0);
                                $ret.add1(d);
                                return $ret;
                            })());
                        }
                        else {
                            this.b = new List$1(Base.$, 0);
                        }
                        this.h = e;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        super();
                        this.f = 0;
                        this.b = null;
                        this.h = 0;
                        this.c = null;
                        this.i = 0;
                        this.f = c;
                        this.h = f;
                        this.i = f;
                        this.b = ((() => {
                            let $ret = new List$1(Base.$, 0);
                            $ret.add1(d);
                            return $ret;
                        })());
                        this.c = ((() => {
                            let $ret = new List$1(Base.$, 0);
                            $ret.add1(e);
                            return $ret;
                        })());
                    }
                    break;
            }
        }
        get action() {
            return this.f;
        }
        get newItems() {
            return this.b;
        }
        get newStartingIndex() {
            return this.h;
        }
        get oldItems() {
            return this.c;
        }
        get oldStartingIndex() {
            return this.i;
        }
    }
    NotifyCollectionChangedEventArgs.$t = /*@__PURE__*/ markType(NotifyCollectionChangedEventArgs, 'NotifyCollectionChangedEventArgs', EventArgs.$);
    return NotifyCollectionChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObservableCollection$1 = /*@__PURE__*/ (() => {
    class ObservableCollection$1 extends List$1 {
        constructor($t, a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super($t, 0);
                        this.$t = $t;
                        this.$type = this.$type.specialize(this.$t);
                        this.collectionChanged = null;
                        this.propertyChanged = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super($t, 1, c);
                        this.$t = $t;
                        this.$type = this.$type.specialize(this.$t);
                        this.collectionChanged = null;
                        this.propertyChanged = null;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        super($t, 2, c);
                        this.$t = $t;
                        this.$type = this.$type.specialize(this.$t);
                        this.collectionChanged = null;
                        this.propertyChanged = null;
                    }
                    break;
            }
        }
        x(a, b) {
            let c = this._inner[a];
            super.x(a, b);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let d = new NotifyCollectionChangedEventArgs(2, 2, getBoxIfEnum(this.$t, b), getBoxIfEnum(this.$t, c), a);
                this.ac(d);
            }
        }
        p() {
            super.p();
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let a = new NotifyCollectionChangedEventArgs(0, 4);
                this.ac(a);
            }
        }
        r(a, b) {
            super.r(a, b);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let c = new NotifyCollectionChangedEventArgs(1, 0, getBoxIfEnum(this.$t, b), a);
                this.ac(c);
            }
        }
        n(a) {
            super.n(a);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let b = new NotifyCollectionChangedEventArgs(1, 0, getBoxIfEnum(this.$t, a), this.count - 1);
                this.ac(b);
            }
        }
        u(a) {
            let b = this._inner[a];
            super.u(a);
            if (this.propertyChanged != null) {
                this.ad(new PropertyChangedEventArgs("Count"));
                this.ad(new PropertyChangedEventArgs("Item[]"));
            }
            if (this.collectionChanged != null) {
                let c = new NotifyCollectionChangedEventArgs(1, 1, getBoxIfEnum(this.$t, b), a);
                this.ac(c);
            }
        }
        ad(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, a);
            }
        }
        ac(a) {
            if (this.collectionChanged != null) {
                this.collectionChanged(this, a);
            }
        }
    }
    ObservableCollection$1.$t = /*@__PURE__*/ markType(ObservableCollection$1, 'ObservableCollection$1', /*@__PURE__*/ List$1.$.specialize(0), [INotifyCollectionChanged_$type, INotifyPropertyChanged_$type]);
    return ObservableCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HashSet$1 = /*@__PURE__*/ (() => {
    class HashSet$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this.k = null;
            this.n = 0;
            this._values = null;
            this.c = false;
            this._stringPlaceholder = null;
            this.b = false;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            this._values = ({});
                            this.k = e || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                            this.c = e == null && (($t === String_$type));
                            this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                            this._stringPlaceholder = ({});
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = [g];
                            {
                                let j = h[0];
                                this._values = ({});
                                this.k = j || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                                this.c = j == null && (($t === String_$type));
                                this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                                this._stringPlaceholder = ({});
                            }
                            for (let i of fromEnum(f)) {
                                this.add_1(i);
                            }
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        this._values = ({});
                        this.k = c || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                        this.c = c == null && (($t === String_$type));
                        this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                        this._stringPlaceholder = ({});
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [d];
                        {
                            let g = e[0];
                            this._values = ({});
                            this.k = g || EqualityComparer$1.defaultEqualityComparerValue(this.$t);
                            this.c = g == null && (($t === String_$type));
                            this.b = ($t === Base.$type || ($t.InstanceConstructor && !$t.InstanceConstructor.prototype.getHashCode));
                            this._stringPlaceholder = ({});
                        }
                        for (let f of fromEnum(c)) {
                            this.add_1(f);
                        }
                    }
                    break;
            }
        }
        add(a) {
            this.add_1(a);
        }
        get isReadOnly() {
            return false;
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        get l() {
            return this.k;
        }
        get count() {
            return this.n;
        }
        add_1(item_) {
            if (this.c) {
                if ((this._values[item_])) {
                    return false;
                }
                this._values[item_] = this._stringPlaceholder;
                this.n++;
                return true;
            }
            let a = this.k.getHashCodeC(item_);
            let current_ = this._values[a];
            if ((current_)) {
                if ((current_.$isHashSetBucket)) {
                    let b = (current_);
                    for (let d = 0; d < b.length; d++) {
                        let c = b[d];
                        if (this.k.equalsC(c, item_)) {
                            return false;
                        }
                    }
                    current_.push(item_);
                }
                else {
                    if (this.k.equalsC(current_, item_)) {
                        return false;
                    }
                    let bucket_ = typeCastObjTo$t(this.$t, ([current_, item_]));
                    bucket_.$isHashSetBucket = true;
                    ;
                    this._values[a] = bucket_;
                }
            }
            else {
                this._values[a] = item_;
            }
            this.n++;
            return true;
        }
        clear() {
            this.n = 0;
            this._values = ({});
        }
        contains(item_) {
            if (this.c) {
                return (!!this._values[item_]);
            }
            let a = this.k.getHashCodeC(item_);
            let current_ = this._values[a];
            if ((current_ !== undefined)) {
                if ((current_.$isHashSetBucket)) {
                    let b = (current_);
                    for (let d = 0; d < b.length; d++) {
                        let c = b[d];
                        if (this.k.equalsC(c, item_)) {
                            return true;
                        }
                    }
                }
                else {
                    if (this.k.equalsC(current_, item_)) {
                        return true;
                    }
                }
            }
            return false;
        }
        copyTo1(a) {
            throw new NotImplementedException(0);
        }
        copyTo(a, b) {
            throw new NotImplementedException(0);
        }
        copyTo2(a, b, c) {
            throw new NotImplementedException(0);
        }
        static m($t) {
            throw new NotImplementedException(0);
        }
        r(a) {
            throw new NotImplementedException(0);
        }
        getEnumerator() {
            if (this.c) {
                let a = (Base.getArrayOfProperties(this._values));
                return getEnumeratorObject(a);
            }
            let result_ = new Array(0);
            let b = (Base.getArrayOfValues(this._values));
            for (let c = 0; c < b.length; c++) {
                let item_ = b[c];
                if ((item_.$isHashSetBucket)) {
                    let d = (item_);
                    for (let e = 0; e < d.length; e++) {
                        let subItem_ = d[e];
                        result_.push(subItem_);
                    }
                }
                else {
                    result_.push(item_);
                }
            }
            return getEnumeratorObject(result_);
        }
        s(a) {
            throw new NotImplementedException(0);
        }
        e(a) {
            throw new NotImplementedException(0);
        }
        f(a) {
            throw new NotImplementedException(0);
        }
        g(a) {
            throw new NotImplementedException(0);
        }
        h(a) {
            throw new NotImplementedException(0);
        }
        t(a) {
            throw new NotImplementedException(0);
        }
        i(a) {
            if (this.count > 0) {
                for (let b of fromEnum(a)) {
                    if (this.contains(b)) {
                        return true;
                    }
                }
            }
            return false;
        }
        remove(item_) {
            if (this.c) {
                if ((this._values[item_])) {
                    return false;
                }
                delete this._values[item_];
                this.n--;
                return true;
            }
            let hashCode_ = this.k.getHashCodeC(item_);
            let current_ = this._values[hashCode_];
            if ((current_)) {
                if ((current_.$isHashSetBucket)) {
                    let a = (current_);
                    for (let b = 0; b < a.length; b++) {
                        let currentItem_ = a[b];
                        if (this.k.equalsC(currentItem_, item_)) {
                            arrayRemoveItem(current_, currentItem_);
                            if ((current_.length) == 1) {
                                this._values[hashCode_] = (current_[0]);
                            }
                            this.n--;
                            return true;
                        }
                    }
                }
                else {
                    if (this.k.equalsC(current_, item_)) {
                        delete this._values[hashCode_];
                        this.n--;
                        return true;
                    }
                }
            }
            return false;
        }
        j(a) {
            throw new NotImplementedException(0);
        }
        u(a) {
            throw new NotImplementedException(0);
        }
        v() {
        }
        w(a) {
            for (let b of fromEnum(a)) {
                this.add_1(b);
            }
        }
    }
    HashSet$1.$t = /*@__PURE__*/ markType(HashSet$1, 'HashSet$1', Base.$, [/*@__PURE__*/ ICollection$1_$type.specialize(0), /*@__PURE__*/ IEnumerable$1_$type.specialize(0), IEnumerable_$type]);
    return HashSet$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SyncableObservableCollectionChangedListener_$type = /*@__PURE__*/ new Type(null, 'SyncableObservableCollectionChangedListener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SyncableObservableCollection$2 = /*@__PURE__*/ (() => {
    class SyncableObservableCollection$2 extends Base {
        constructor($t1, $t2, a, ..._rest) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.a = null;
            this._compare = null;
            this._createTo = null;
            this._createFrom = null;
            this.h = false;
            this.i = false;
            this.g = false;
            this._inner = null;
            this.o = new List$1(SyncableObservableCollectionChangedListener_$type, 0);
            this.f = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$type = this.$type.specialize(this.$t1, this.$t2);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this._inner = new ObservableCollection$1(this.$t1, 0);
                        this.addListener(runOn(this, this.af));
                        let c = this._inner;
                        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.v));
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this._inner = c;
                    }
                    break;
            }
        }
        get syncTarget() {
            return this.a;
        }
        set syncTarget(a) {
            let b = this.a;
            this.a = a;
            this.ac(b, this.a);
        }
        get compare() {
            return this._compare;
        }
        set compare(a) {
            this._compare = a;
        }
        get createTo() {
            return this._createTo;
        }
        set createTo(a) {
            this._createTo = a;
        }
        get createFrom() {
            return this._createFrom;
        }
        set createFrom(a) {
            this._createFrom = a;
        }
        ac(a, b) {
            if (a != null) {
                a.removeListener(runOn(this, this.ak));
            }
            this.ah();
            if (b != null) {
                b.addListener(runOn(this, this.ak));
            }
        }
        ah() {
            if (this.a == null) {
                return;
            }
            this.h = true;
            let a = new List$1(this.$t1, 0);
            let b = new HashSet$1(this.$t1, 0);
            for (let c = 0; c < this.all.count; c++) {
                if (!b.contains(this.all.item(c))) {
                    a.add(this.all.item(c));
                    b.add_1(this.all.item(c));
                }
            }
            for (let d = 0; d < this.a.all.count; d++) {
                if (!this.l(b, this.a.all.item(d))) {
                    let e = this.createFrom(this.a.all.item(d));
                    a.add(e);
                    b.add_1(e);
                }
            }
            this.ai(a, this.all);
            this.aj(a, this.a.all);
            this.h = false;
        }
        l(a, b) {
            if (this.compare == null) {
                throw new InvalidOperationException(1, "SyncableObservableCollection has no Compare function provided.");
            }
            for (let c of fromEnum(a)) {
                if (this.compare(c, b)) {
                    return true;
                }
            }
            return false;
        }
        ai(a, b) {
            let c = new List$1(Number_$type, 0);
            let d = 0;
            for (let e = 0; e < b.count; e++) {
                if (getBoxIfEnum(this.$t1, b.item(e)) == null) {
                    c.add(e);
                    continue;
                }
                if (d > a.count - 1) {
                    c.add(e);
                    continue;
                }
                if (Base.equalsStatic(b.item(e), getBoxIfEnum(this.$t1, a._inner[d]))) {
                    d++;
                    continue;
                }
                b.insert(e, a._inner[d]);
                d++;
            }
            for (let f = c.count - 1; f >= 0; f--) {
                b.removeAt(f);
            }
            for (; d < a.count; d++) {
                b.add(a._inner[d]);
            }
        }
        aj(a, b) {
            let c = new List$1(Number_$type, 0);
            let d = 0;
            for (let e = 0; e < b.count; e++) {
                if (getBoxIfEnum(this.$t2, b.item(e)) == null) {
                    c.add(e);
                    continue;
                }
                if (d > a.count - 1) {
                    c.add(e);
                    continue;
                }
                if (Base.equalsStatic(b.item(e), getBoxIfEnum(this.$t1, a._inner[d]))) {
                    d++;
                    continue;
                }
                b.insert(e, this.createTo(a._inner[d]));
                d++;
            }
            for (let f = c.count - 1; f >= 0; f--) {
                b.removeAt(f);
            }
            for (; d < a.count; d++) {
                b.add(this.createTo(a._inner[d]));
            }
        }
        ak(a, b) {
            if (this.a == null) {
                return;
            }
            if (this.h) {
                return;
            }
            if (this.g) {
                return;
            }
            let c = this.a.all;
            this.i = true;
            this.ag(this.$t1, this.$t2, b, this.all, c);
            this.i = false;
        }
        ab(a) {
        }
        af(a, b) {
            this.ab(b);
            if (this.a == null) {
                return;
            }
            if (this.h) {
                return;
            }
            if (this.i) {
                return;
            }
            let c = this.a.all;
            this.g = true;
            this.ag(this.$t2, this.$t1, b, c, this.all);
            this.g = false;
        }
        ag($t, $f, a, b, c) {
            switch (a.action) {
                case 0:
                    if (a.newItems != null) {
                        for (let d = 0; d < a.newItems.count; d++) {
                            let e = a.newItems.item(d);
                            if ($f != $t) {
                                if ($f == this.$t1) {
                                    e = getBoxIfEnum(this.$t2, this.createTo(typeCastObjTo$t(this.$t1, a.newItems.item(d))));
                                }
                                if ($f == this.$t2) {
                                    e = getBoxIfEnum(this.$t1, this.createFrom(typeCastObjTo$t(this.$t2, a.newItems.item(d))));
                                }
                            }
                            b.insert(d + a.newStartingIndex, typeCastObjTo$t($t, e));
                        }
                    }
                    break;
                case 1:
                    if (a.oldItems != null) {
                        for (let f = 0; f < a.oldItems.count; f++) {
                            b.removeAt(a.oldStartingIndex);
                        }
                    }
                    break;
                case 2:
                    if (a.oldItems != null) {
                        for (let g = 0; g < a.oldItems.count; g++) {
                            b.removeAt(a.oldStartingIndex);
                        }
                    }
                    if (a.newItems != null) {
                        for (let h = 0; h < a.newItems.count; h++) {
                            let i = a.newItems.item(h);
                            if ($f != $t) {
                                if ($f == this.$t1) {
                                    i = getBoxIfEnum(this.$t2, this.createTo(typeCastObjTo$t(this.$t1, a.newItems.item(h))));
                                }
                                if ($f == this.$t2) {
                                    i = getBoxIfEnum(this.$t1, this.createFrom(typeCastObjTo$t(this.$t2, a.newItems.item(h))));
                                }
                            }
                            b.insert(h + a.newStartingIndex, typeCastObjTo$t($t, a.newItems.item(h)));
                        }
                    }
                    break;
                case 4:
                    b.clear();
                    for (let j of fromEnum(c)) {
                        let k = getBoxIfEnum($f, j);
                        if ($f != $t) {
                            if ($f == this.$t1) {
                                k = getBoxIfEnum(this.$t2, this.createTo(typeCastObjTo$t(this.$t1, k)));
                            }
                            if ($f == this.$t2) {
                                k = getBoxIfEnum(this.$t1, this.createFrom(typeCastObjTo$t(this.$t2, k)));
                            }
                        }
                        b.add(typeCastObjTo$t($t, k));
                    }
                    break;
            }
        }
        z(a) {
            if (this._inner != null) {
                let b = this._inner;
                b.collectionChanged = delegateRemove(b.collectionChanged, runOn(this, this.v));
            }
            this._inner = a;
            if (this._inner != null) {
                let c = this._inner;
                c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.v));
            }
        }
        v(a, b) {
            if (this.f != null) {
                this.f();
            }
            for (let c of fromEnum(this.o)) {
                c.onChanged(this);
            }
        }
        add(a) {
            this._inner.add(a);
            return true;
        }
        add1(a, b) {
            this._inner.insert(a, b);
        }
        clear() {
            this._inner.clear();
        }
        get(a) {
            return this._inner._inner[a];
        }
        indexOf(a) {
            return this._inner.indexOf(a);
        }
        remove1(a) {
            let b = this._inner.contains(a);
            this._inner.remove(a);
            return b;
        }
        contains(a) {
            return this._inner.contains(a);
        }
        remove(a) {
            let b = this._inner._inner[a];
            this._inner.removeAt(a);
            return b;
        }
        set(a, b) {
            this._inner.item(a, b);
            return b;
        }
        size() {
            return this._inner.count;
        }
        addChangedListener(a) {
            this.o.add(a);
        }
        removeChangedListener(a) {
            this.o.remove(a);
        }
        addListener(a) {
            let b = this._inner;
            b.collectionChanged = delegateCombine(b.collectionChanged, a);
        }
        removeListener(a) {
            let b = this._inner;
            b.collectionChanged = delegateRemove(b.collectionChanged, a);
        }
        get all() {
            return this._inner;
        }
    }
    SyncableObservableCollection$2.$t = /*@__PURE__*/ markType(SyncableObservableCollection$2, 'SyncableObservableCollection$2');
    return SyncableObservableCollection$2;
})();
/**
 * @hidden
 */
let SyncableObservableCollection$1 = /*@__PURE__*/ (() => {
    class SyncableObservableCollection$1 extends SyncableObservableCollection$2 {
        constructor($t) {
            super($t, $t, 0);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.compare = (a, b) => Base.equalsStatic(a, getBoxIfEnum(this.$t, b));
            this.createFrom = (a) => a;
            this.createTo = (a) => a;
        }
    }
    SyncableObservableCollection$1.$t = /*@__PURE__*/ markType(SyncableObservableCollection$1, 'SyncableObservableCollection$1', /*@__PURE__*/ SyncableObservableCollection$2.$.specialize(0, 0));
    return SyncableObservableCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortDescription = /*@__PURE__*/ (() => {
    class SortDescription extends Base {
        constructor() {
            super();
            this.b = false;
            this.g = null;
            this.d = 0;
        }
        get propertyName() {
            return this.g;
        }
        set propertyName(a) {
            this.g = a;
        }
        get direction() {
            return this.d;
        }
        set direction(a) {
            this.d = a;
        }
        equals(a) {
            let b = a;
            if (b == null) {
                return super.equals(a);
            }
            return b.propertyName == this.propertyName && b.direction == this.direction;
        }
        getHashCode() {
            return Base.getHashCodeStatic(this.propertyName) * 17 + this.direction;
        }
        i() {
            this.b = true;
        }
        static create(a, b) {
            let c = new SortDescription();
            c.propertyName = a;
            c.direction = b;
            return c;
        }
    }
    SortDescription.$t = /*@__PURE__*/ markType(SortDescription, 'SortDescription');
    return SortDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortDescriptionCollection = /*@__PURE__*/ (() => {
    class SortDescriptionCollection extends Base {
        constructor() {
            super();
            this.d = null;
            this.f = null;
            this.f = new SyncableObservableCollection$1(SortDescription.$);
        }
        getInner() {
            return this.f;
        }
        get syncTarget() {
            return this.d;
        }
        set syncTarget(a) {
            if (a == null) {
                this.f.syncTarget = null;
                this.d = null;
                return;
            }
            this.d = a;
            this.f.syncTarget = this.d.f;
        }
        add(a) {
            return this.f.add(a);
        }
        insert(a, b) {
            this.f.add1(a, b);
        }
        clear() {
            this.f.clear();
        }
        get(a) {
            return this.f.get(a);
        }
        indexOf(a) {
            return this.f.indexOf(a);
        }
        remove(a) {
            return this.f.remove1(a);
        }
        removeAt(a) {
            return this.f.remove(a);
        }
        set(a, b) {
            return this.f.set(a, b);
        }
        size() {
            return this.f.size();
        }
        n(a) {
            this.f.addListener(a);
        }
        q(a) {
            this.f.removeListener(a);
        }
        get onChanged() {
            return this.f.f;
        }
        set onChanged(a) {
            this.f.f = a;
        }
        get k() {
            return this.f.all;
        }
    }
    SortDescriptionCollection.$t = /*@__PURE__*/ markType(SortDescriptionCollection, 'SortDescriptionCollection');
    return SortDescriptionCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates different calculation modes for summaries in the data source.
 */
var DataSourceSummaryScope = /*@__PURE__*/ (function (DataSourceSummaryScope) {
    /**
     * Summaries are calculated for both the root and section level.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["Both"] = 0] = "Both";
    /**
     * Summaries are only calculated at the root level.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["Root"] = 1] = "Root";
    /**
     * Summaries are only calculated at the group level.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["Groups"] = 2] = "Groups";
    /**
     * Summaries are not calculated at all.
     */
    DataSourceSummaryScope[DataSourceSummaryScope["None"] = 3] = "None";
    return DataSourceSummaryScope;
})({});
/**
 * @hidden
 */
let DataSourceSummaryScope_$type = /*@__PURE__*/ markEnum('DataSourceSummaryScope', 'Both,0|Root,1|Groups,2|None,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceSupportsIndexedAccess_$type = /*@__PURE__*/ new Type(null, 'IDataSourceSupportsIndexedAccess', null, [IDataSourceSupportsCount_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates possible display modes for section headers.
 */
var DataSourceSectionHeaderDisplayMode = /*@__PURE__*/ (function (DataSourceSectionHeaderDisplayMode) {
    /**
     * Each group is preceded by a single section header that combines multiple groups into one.
     */
    DataSourceSectionHeaderDisplayMode[DataSourceSectionHeaderDisplayMode["Combined"] = 0] = "Combined";
    /**
     * Each group may be preceded by multiple section headers, one for each group.
     */
    DataSourceSectionHeaderDisplayMode[DataSourceSectionHeaderDisplayMode["Split"] = 1] = "Split";
    return DataSourceSectionHeaderDisplayMode;
})({});
/**
 * @hidden
 */
let DataSourceSectionHeaderDisplayMode_$type = /*@__PURE__*/ markEnum('DataSourceSectionHeaderDisplayMode', 'Combined,0|Split,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSchemaChangedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceSchemaChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this.d = 0;
            this.b = null;
            this.b = a;
            this.d = b;
        }
        get schema() {
            return this.b;
        }
        get count() {
            return this.d;
        }
    }
    DataSourceSchemaChangedEventArgs.$t = /*@__PURE__*/ markType(DataSourceSchemaChangedEventArgs, 'DataSourceSchemaChangedEventArgs', EventArgs.$);
    return DataSourceSchemaChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceRowExpansionChangedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceRowExpansionChangedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this.f = -1;
            this.c = false;
            this.b = false;
            this.f = a;
            this.c = b;
            this.b = c;
        }
        get rowIndex() {
            return this.f;
        }
        get oldState() {
            return this.c;
        }
        get newState() {
            return this.b;
        }
    }
    DataSourceRowExpansionChangedEventArgs.$t = /*@__PURE__*/ markType(DataSourceRowExpansionChangedEventArgs, 'DataSourceRowExpansionChangedEventArgs', EventArgs.$);
    return DataSourceRowExpansionChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function nullableConcat(v1, v2) {
    if (v1 == null) {
        v1 = "";
    }
    else if (!!v1.isNullable) {
        v1 = v1.getValueOrDefault1("");
    }
    if (v2 == null) {
        v2 = "";
    }
    else if (!!v2.isNullable) {
        v2 = v2.getValueOrDefault1("");
    }
    return v1.toString() + v2.toString();
}
function nullableAdd(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 + val2);
}
function nullableSubtract(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 - val2);
}
function nullableMultiply(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 * val2);
}
function nullableDivide(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 / val2);
}
function nullableModulus(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return null;
    }
    if (v2.isNullable && !v2.hasValue) {
        return null;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return toNullable(Number_$type, val1 % val2);
}
function nullableGreaterThan(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 > val2;
}
function nullableGreaterThanOrEqual(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 >= val2;
}
function nullableLessThan(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 < val2;
}
function nullableLessThanOrEqual(v1, v2) {
    if (v1.isNullable && !v1.hasValue) {
        return false;
    }
    if (v2.isNullable && !v2.hasValue) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 <= val2;
}
function nullableIsNull(v) {
    /*jshint eqnull:true */
    return v == null || (!!v.isNullable && !v.hasValue);
}
function nullableEquals(v1, v2) {
    /*jshint eqnull:true */
    var v1IsNull = (v1 == null) || (!!v1.isNullable && !v1.hasValue);
    var v2IsNull = (v2 == null) || (!!v2.isNullable && !v2.hasValue);
    if (v1IsNull && v2IsNull) {
        return true;
    }
    if (v1IsNull != v2IsNull) {
        return false;
    }
    var val1 = v1;
    var val2 = v2;
    if (v1.isNullable) {
        val1 = v1.value;
    }
    if (v2.isNullable) {
        val2 = v2.value;
    }
    return val1 == val2;
}
function nullableNotEquals(v1, v2) {
    return !nullableEquals(v1, v2);
}
function unwrapNullable(v) {
    /*jshint eqnull:true */
    if (v == null || !v.isNullable) {
        return v;
    }
    if (!v.hasValue) {
        return null;
    }
    return v.value;
}
function wrapNullable($t, v) {
    /*jshint eqnull:true */
    if (v != null && v.isNullable) {
        return v;
    }
    return toNullable($t, v);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function startsWith1(target, s, comparisonType) {
    if (target.length < s.length) {
        return false;
    }
    return stringCompare1(target.slice(0, s.length), s, comparisonType || 0) === 0;
}
;
function endsWith1(target, s, comparisonType) {
    if (target.length < s.length) {
        return false;
    }
    return stringCompare1(target.slice(-s.length), s, comparisonType || 0) === 0;
}
;
function isLower(target) {
    return target.toLowerCase() === target;
}
function isLetterOrDigit(target) {
    var charCode = target.charCodeAt(0);
    // "a" <= c && c <= "z"
    if (97 <= charCode && charCode <= 122) {
        return true;
    }
    // "A" <= c && c <= "Z"
    if (65 <= charCode && charCode <= 90) {
        return true;
    }
    // "0" <= c && c <= "9"
    if (48 <= charCode && charCode <= 57) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("(\\p{L}|\\p{Nd})").test(target); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function isLetter(c) {
    var charCode = c.charCodeAt(0);
    // "a" <= c && c <= "z"
    if (97 <= charCode && charCode <= 122) {
        return true;
    }
    // "A" <= c && c <= "Z"
    if (65 <= charCode && charCode <= 90) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("\\p{L}").test(c); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function isDigit1(c, index) {
    return isDigit(c[index]);
}
function isDigit(c) {
    var charCode = c.charCodeAt(0);
    // "0" <= c && c <= "9"
    if (48 <= charCode && charCode <= 57) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("\\p{Nd}").test(c); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function isNumber(c) {
    var charCode = c.charCodeAt(0);
    // "0" <= c && c <= "9"
    if (48 <= charCode && charCode <= 57) {
        return true;
    }
    if (charCode <= 0x7F) {
        return false;
    }
    return unicode_hack_impl("\\p{N}").test(c); // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers
}
function padLeft(target, len, c) {
    var s = target;
    c = c || " ";
    while (s.length < len) {
        s = c + s;
    }
    return s;
}
function reverse(target) {
    /* Inverts the order of the characters in a string.
        returnType="string" Returns a new inverted string.
    */
    var s = "";
    for (var i = target.length - 1; i >= 0; i--) {
        s += target[i];
    }
    return s;
}
;
function padRight(target, len, c) {
    var s = target;
    c = c || " ";
    while (s.length < len) {
        s += c;
    }
    return s;
}
;
function indexOfAny(target, chars) {
    var s = target.toString();
    for (var i = 0; i < s.length; i++) {
        if (chars.indexOf(s[i]) > -1) {
            return i;
        }
    }
    return -1;
}
function lastIndexOfAny(target, chars) {
    var s = target.toString();
    for (var i = s.length - 1; i >= 0; i--) {
        if (chars.indexOf(s[i]) > -1) {
            return i;
        }
    }
    return -1;
}
function stringFormat(format, ...rest) {
    return stringFormat1(format, ...rest);
}
;
function stringFormat1(format, ...args) {
    return stringFormat2(CultureInfo.currentCulture, format, ...args);
}
;
function stringFormat2(provider, format, ...args) {
    // TODO: what is going on with provider here??
    // TODO: Use the provider somehow
    return format.replace(/{(\d+)(?::)?([^}]*)?}/g, function (match, number, format) {
        var arg = args[number];
        if (arg === void 0) {
            return match;
        }
        if (arg === null) {
            return "";
        }
        if (format) {
            if (format[0] === "X") {
                return intToString1(arg, format, provider);
            }
            else {
                return numberToString2(arg, format, provider);
            }
        }
        return arg;
    });
}
;
function stringCompare1(strA, strB, comparisonType) {
    if (!strA) {
        return !strB ? 0 : -1;
    }
    else if (!strB) {
        return 1;
    }
    // TODO: Make sure this is right
    switch (comparisonType) {
        case 0 /* CurrentCulture */:
            return CultureInfo.currentCulture
                .compareInfo.compare4(strA, strB);
        case 1 /* CurrentCultureIgnoreCase */:
            return CultureInfo.currentCulture.compareInfo
                .compare4(strA.toLowerCase(), strB.toLowerCase());
        case 2 /* InvariantCulture */:
        case 4 /* Ordinal */:
            return stringCompareTo(strA, strB);
        case 3 /* InvariantCultureIgnoreCase */:
        case 5 /* OrdinalIgnoreCase */:
            return stringCompareTo(strA.toLowerCase(), strB.toLowerCase());
        default:
            break;
    }
    return 0;
}
;
function stringCompare2(strA, strB, culture, options) {
    return culture.compareInfo.compare5(strA, strB, options);
}
;
function stringCompare3(strA, indexA, strB, indexB, length) {
    var v1 = strA.substr(indexA, length);
    var v2 = strB.substr(indexB, length);
    return stringCompare1(v1, v2, 0 /* CurrentCulture */);
}
;
function stringCompareOrdinal(strA, indexA, strB, indexB, length) {
    var v1 = strA.substr(indexA, length);
    var v2 = strB.substr(indexB, length);
    return stringCompare1(v1, v2, 4 /* Ordinal */);
}
;
function stringEquals1(strA, strB, comparisonType) {
    return stringCompare1(strA, strB, comparisonType) == 0;
}
;
function stringInsert(str, index, value) {
    return str.substr(0, index) + value + str.substr(index);
}
;
// https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding
function b64toUint8Array(b64Data, nBlocksSize) {
    /*jslint bitwise: true */
    function b64ToUint6(nChr) {
        return nChr > 64 && nChr < 91 ?
            nChr - 65
            : nChr > 96 && nChr < 123 ?
                nChr - 71
                : nChr > 47 && nChr < 58 ?
                    nChr + 4
                    : nChr === 43 ?
                        62
                        : nChr === 47 ?
                            63
                            :
                                0;
    }
    var sB64Enc = b64Data.replace(/[^A-Za-z0-9\+\/]/g, ""), nInLen = sB64Enc.length, nOutLen = nBlocksSize ?
        Math.ceil((nInLen * 3 + 1 >> 2) / nBlocksSize) * nBlocksSize :
        nInLen * 3 + 1 >> 2, taBytes;
    if (typeof window.Uint8Array === "function") {
        taBytes = new Uint8Array(nOutLen);
    }
    else {
        taBytes = new Array(nOutLen);
    }
    for (var nMod3, nMod4, nUint24 = 0, nOutIdx = 0, nInIdx = 0; nInIdx < nInLen; nInIdx++) {
        nMod4 = nInIdx & 3;
        nUint24 |= b64ToUint6(sB64Enc.charCodeAt(nInIdx)) << 18 - 6 * nMod4;
        if (nMod4 === 3 || nInLen - nInIdx === 1) {
            for (nMod3 = 0; nMod3 < 3 && nOutIdx < nOutLen; nMod3++, nOutIdx++) {
                taBytes[nOutIdx] = nUint24 >>> (16 >>> nMod3 & 24) & 255;
            }
            nUint24 = 0;
        }
    }
    return taBytes;
}
;
// https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding
function uint8ArraytoB64(aBytes) {
    /*jslint bitwise: true */
    function uint6ToB64(nUint6) {
        return nUint6 < 26 ?
            nUint6 + 65
            : nUint6 < 52 ?
                nUint6 + 71
                : nUint6 < 62 ?
                    nUint6 - 4
                    : nUint6 === 62 ?
                        43
                        : nUint6 === 63 ?
                            47
                            :
                                65;
    }
    var nMod3 = 2, sB64Enc = "";
    for (var nLen = aBytes.length, nUint24 = 0, nIdx = 0; nIdx < nLen; nIdx++) {
        nMod3 = nIdx % 3;
        if (nIdx > 0 && (nIdx * 4 / 3) % 76 === 0) {
            sB64Enc += "\r\n";
        }
        nUint24 |= aBytes[nIdx] << (16 >>> nMod3 & 24);
        if (nMod3 === 2 || aBytes.length - nIdx === 1) {
            sB64Enc += String.fromCharCode(uint6ToB64(nUint24 >>> 18 & 63), uint6ToB64(nUint24 >>> 12 & 63), uint6ToB64(nUint24 >>> 6 & 63), uint6ToB64(nUint24 & 63));
            nUint24 = 0;
        }
    }
    return sB64Enc.substr(0, sB64Enc.length - 2 + nMod3) +
        (nMod3 === 2 ? "" : nMod3 === 1 ? "=" : "==");
}
function stringSplit(value, separators, options) {
    var r = "", i;
    for (i = 0; i < separators.length; i++) {
        if (i !== 0) {
            r += "|";
        }
        r += stringEscapeRegExp(separators[i]);
    }
    var result = value.split(new RegExp(r));
    for (i = result.length - 1; i >= 0; i--) {
        /*jslint bitwise: true */
        if ((result[i].length === 0 &&
            (options & 1 /* RemoveEmptyEntries */)) ||
            separators.indexOf(result[i]) > -1) {
            result.splice(i, 1);
        }
    }
    return result;
}
;
/*! unicode_hack.js
Copyright (C) 2010-2012,2014  Marcelo Gibson de Castro GonÃ§alves. All rights reserved.

Copying and distribution of this file, with or without modification,
are permitted in any medium without royalty provided the copyright
notice and this notice are preserved.  This file is offered as-is,
without any warranty.
*/
// jscs:disable
var unicodeCategories = {
    Cn: "[\u0378\u0379\u037f-\u0383\u038b\u038d\u03a2\u0528-\u0530\u0557\u0558\u0560\u0588\u058b-\u0590\u05c8-\u05cf\u05eb-\u05ef\u05f5-\u05ff\u0604\u0605\u061c\u061d\u070e\u074b\u074c\u07b2-\u07bf\u07fb-\u07ff\u082e\u082f\u083f\u085c\u085d\u085f-\u08ff\u0978\u0980\u0984\u098d\u098e\u0991\u0992\u09a9\u09b1\u09b3-\u09b5\u09ba\u09bb\u09c5\u09c6\u09c9\u09ca\u09cf-\u09d6\u09d8-\u09db\u09de\u09e4\u09e5\u09fc-\u0a00\u0a04\u0a0b-\u0a0e\u0a11\u0a12\u0a29\u0a31\u0a34\u0a37\u0a3a\u0a3b\u0a3d\u0a43-\u0a46\u0a49\u0a4a\u0a4e-\u0a50\u0a52-\u0a58\u0a5d\u0a5f-\u0a65\u0a76-\u0a80\u0a84\u0a8e\u0a92\u0aa9\u0ab1\u0ab4\u0aba\u0abb\u0ac6\u0aca\u0ace\u0acf\u0ad1-\u0adf\u0ae4\u0ae5\u0af0\u0af2-\u0b00\u0b04\u0b0d\u0b0e\u0b11\u0b12\u0b29\u0b31\u0b34\u0b3a\u0b3b\u0b45\u0b46\u0b49\u0b4a\u0b4e-\u0b55\u0b58-\u0b5b\u0b5e\u0b64\u0b65\u0b78-\u0b81\u0b84\u0b8b-\u0b8d\u0b91\u0b96-\u0b98\u0b9b\u0b9d\u0ba0-\u0ba2\u0ba5-\u0ba7\u0bab-\u0bad\u0bba-\u0bbd\u0bc3-\u0bc5\u0bc9\u0bce\u0bcf\u0bd1-\u0bd6\u0bd8-\u0be5\u0bfb-\u0c00\u0c04\u0c0d\u0c11\u0c29\u0c34\u0c3a-\u0c3c\u0c45\u0c49\u0c4e-\u0c54\u0c57\u0c5a-\u0c5f\u0c64\u0c65\u0c70-\u0c77\u0c80\u0c81\u0c84\u0c8d\u0c91\u0ca9\u0cb4\u0cba\u0cbb\u0cc5\u0cc9\u0cce-\u0cd4\u0cd7-\u0cdd\u0cdf\u0ce4\u0ce5\u0cf0\u0cf3-\u0d01\u0d04\u0d0d\u0d11\u0d3b\u0d3c\u0d45\u0d49\u0d4f-\u0d56\u0d58-\u0d5f\u0d64\u0d65\u0d76-\u0d78\u0d80\u0d81\u0d84\u0d97-\u0d99\u0db2\u0dbc\u0dbe\u0dbf\u0dc7-\u0dc9\u0dcb-\u0dce\u0dd5\u0dd7\u0de0-\u0df1\u0df5-\u0e00\u0e3b-\u0e3e\u0e5c-\u0e80\u0e83\u0e85\u0e86\u0e89\u0e8b\u0e8c\u0e8e-\u0e93\u0e98\u0ea0\u0ea4\u0ea6\u0ea8\u0ea9\u0eac\u0eba\u0ebe\u0ebf\u0ec5\u0ec7\u0ece\u0ecf\u0eda\u0edb\u0ede-\u0eff\u0f48\u0f6d-\u0f70\u0f98\u0fbd\u0fcd\u0fdb-\u0fff\u10c6-\u10cf\u10fd-\u10ff\u1249\u124e\u124f\u1257\u1259\u125e\u125f\u1289\u128e\u128f\u12b1\u12b6\u12b7\u12bf\u12c1\u12c6\u12c7\u12d7\u1311\u1316\u1317\u135b\u135c\u137d-\u137f\u139a-\u139f\u13f5-\u13ff\u169d-\u169f\u16f1-\u16ff\u170d\u1715-\u171f\u1737-\u173f\u1754-\u175f\u176d\u1771\u1774-\u177f\u17de\u17df\u17ea-\u17ef\u17fa-\u17ff\u180f\u181a-\u181f\u1878-\u187f\u18ab-\u18af\u18f6-\u18ff\u191d-\u191f\u192c-\u192f\u193c-\u193f\u1941-\u1943\u196e\u196f\u1975-\u197f\u19ac-\u19af\u19ca-\u19cf\u19db-\u19dd\u1a1c\u1a1d\u1a5f\u1a7d\u1a7e\u1a8a-\u1a8f\u1a9a-\u1a9f\u1aae-\u1aff\u1b4c-\u1b4f\u1b7d-\u1b7f\u1bab-\u1bad\u1bba-\u1bbf\u1bf4-\u1bfb\u1c38-\u1c3a\u1c4a-\u1c4c\u1c80-\u1ccf\u1cf3-\u1cff\u1de7-\u1dfb\u1f16\u1f17\u1f1e\u1f1f\u1f46\u1f47\u1f4e\u1f4f\u1f58\u1f5a\u1f5c\u1f5e\u1f7e\u1f7f\u1fb5\u1fc5\u1fd4\u1fd5\u1fdc\u1ff0\u1ff1\u1ff5\u1fff\u2065-\u2069\u2072\u2073\u208f\u209d-\u209f\u20ba-\u20cf\u20f1-\u20ff\u218a-\u218f\u23f4-\u23ff\u2427-\u243f\u244b-\u245f\u2700\u27cb\u27cd\u2b4d-\u2b4f\u2b5a-\u2bff\u2c2f\u2c5f\u2cf2-\u2cf8\u2d26-\u2d2f\u2d66-\u2d6e\u2d71-\u2d7e\u2d97-\u2d9f\u2da7\u2daf\u2db7\u2dbf\u2dc7\u2dcf\u2dd7\u2ddf\u2e32-\u2e7f\u2e9a\u2ef4-\u2eff\u2fd6-\u2fef\u2ffc-\u2fff\u3040\u3097\u3098\u3100-\u3104\u312e-\u3130\u318f\u31bb-\u31bf\u31e4-\u31ef\u321f\u32ff\u4db6-\u4dbf\u9fcc-\u9fff\ua48d-\ua48f\ua4c7-\ua4cf\ua62c-\ua63f\ua674-\ua67b\ua698-\ua69f\ua6f8-\ua6ff\ua78f\ua792-\ua79f\ua7aa-\ua7f9\ua82c-\ua82f\ua83a-\ua83f\ua878-\ua87f\ua8c5-\ua8cd\ua8da-\ua8df\ua8fc-\ua8ff\ua954-\ua95e\ua97d-\ua97f\ua9ce\ua9da-\ua9dd\ua9e0-\ua9ff\uaa37-\uaa3f\uaa4e\uaa4f\uaa5a\uaa5b\uaa7c-\uaa7f\uaac3-\uaada\uaae0-\uab00\uab07\uab08\uab0f\uab10\uab17-\uab1f\uab27\uab2f-\uabbf\uabee\uabef\uabfa-\uabff\ud7a4-\ud7af\ud7c7-\ud7ca\ud7fc-\ud7ff\ufa2e\ufa2f\ufa6e\ufa6f\ufada-\ufaff\ufb07-\ufb12\ufb18-\ufb1c\ufb37\ufb3d\ufb3f\ufb42\ufb45\ufbc2-\ufbd2\ufd40-\ufd4f\ufd90\ufd91\ufdc8-\ufdef\ufdfe\ufdff\ufe1a-\ufe1f\ufe27-\ufe2f\ufe53\ufe67\ufe6c-\ufe6f\ufe75\ufefd\ufefe\uff00\uffbf-\uffc1\uffc8\uffc9\uffd0\uffd1\uffd8\uffd9\uffdd-\uffdf\uffe7\uffef-\ufff8\ufffe\uffff]",
    Lu: "[\u0041-\u005a\u00c0-\u00d6\u00d8-\u00de\u0100\u0102\u0104\u0106\u0108\u010a\u010c\u010e\u0110\u0112\u0114\u0116\u0118\u011a\u011c\u011e\u0120\u0122\u0124\u0126\u0128\u012a\u012c\u012e\u0130\u0132\u0134\u0136\u0139\u013b\u013d\u013f\u0141\u0143\u0145\u0147\u014a\u014c\u014e\u0150\u0152\u0154\u0156\u0158\u015a\u015c\u015e\u0160\u0162\u0164\u0166\u0168\u016a\u016c\u016e\u0170\u0172\u0174\u0176\u0178\u0179\u017b\u017d\u0181\u0182\u0184\u0186\u0187\u0189-\u018b\u018e-\u0191\u0193\u0194\u0196-\u0198\u019c\u019d\u019f\u01a0\u01a2\u01a4\u01a6\u01a7\u01a9\u01ac\u01ae\u01af\u01b1-\u01b3\u01b5\u01b7\u01b8\u01bc\u01c4\u01c7\u01ca\u01cd\u01cf\u01d1\u01d3\u01d5\u01d7\u01d9\u01db\u01de\u01e0\u01e2\u01e4\u01e6\u01e8\u01ea\u01ec\u01ee\u01f1\u01f4\u01f6-\u01f8\u01fa\u01fc\u01fe\u0200\u0202\u0204\u0206\u0208\u020a\u020c\u020e\u0210\u0212\u0214\u0216\u0218\u021a\u021c\u021e\u0220\u0222\u0224\u0226\u0228\u022a\u022c\u022e\u0230\u0232\u023a\u023b\u023d\u023e\u0241\u0243-\u0246\u0248\u024a\u024c\u024e\u0370\u0372\u0376\u0386\u0388-\u038a\u038c\u038e\u038f\u0391-\u03a1\u03a3-\u03ab\u03cf\u03d2-\u03d4\u03d8\u03da\u03dc\u03de\u03e0\u03e2\u03e4\u03e6\u03e8\u03ea\u03ec\u03ee\u03f4\u03f7\u03f9\u03fa\u03fd-\u042f\u0460\u0462\u0464\u0466\u0468\u046a\u046c\u046e\u0470\u0472\u0474\u0476\u0478\u047a\u047c\u047e\u0480\u048a\u048c\u048e\u0490\u0492\u0494\u0496\u0498\u049a\u049c\u049e\u04a0\u04a2\u04a4\u04a6\u04a8\u04aa\u04ac\u04ae\u04b0\u04b2\u04b4\u04b6\u04b8\u04ba\u04bc\u04be\u04c0\u04c1\u04c3\u04c5\u04c7\u04c9\u04cb\u04cd\u04d0\u04d2\u04d4\u04d6\u04d8\u04da\u04dc\u04de\u04e0\u04e2\u04e4\u04e6\u04e8\u04ea\u04ec\u04ee\u04f0\u04f2\u04f4\u04f6\u04f8\u04fa\u04fc\u04fe\u0500\u0502\u0504\u0506\u0508\u050a\u050c\u050e\u0510\u0512\u0514\u0516\u0518\u051a\u051c\u051e\u0520\u0522\u0524\u0526\u0531-\u0556\u10a0-\u10c5\u1e00\u1e02\u1e04\u1e06\u1e08\u1e0a\u1e0c\u1e0e\u1e10\u1e12\u1e14\u1e16\u1e18\u1e1a\u1e1c\u1e1e\u1e20\u1e22\u1e24\u1e26\u1e28\u1e2a\u1e2c\u1e2e\u1e30\u1e32\u1e34\u1e36\u1e38\u1e3a\u1e3c\u1e3e\u1e40\u1e42\u1e44\u1e46\u1e48\u1e4a\u1e4c\u1e4e\u1e50\u1e52\u1e54\u1e56\u1e58\u1e5a\u1e5c\u1e5e\u1e60\u1e62\u1e64\u1e66\u1e68\u1e6a\u1e6c\u1e6e\u1e70\u1e72\u1e74\u1e76\u1e78\u1e7a\u1e7c\u1e7e\u1e80\u1e82\u1e84\u1e86\u1e88\u1e8a\u1e8c\u1e8e\u1e90\u1e92\u1e94\u1e9e\u1ea0\u1ea2\u1ea4\u1ea6\u1ea8\u1eaa\u1eac\u1eae\u1eb0\u1eb2\u1eb4\u1eb6\u1eb8\u1eba\u1ebc\u1ebe\u1ec0\u1ec2\u1ec4\u1ec6\u1ec8\u1eca\u1ecc\u1ece\u1ed0\u1ed2\u1ed4\u1ed6\u1ed8\u1eda\u1edc\u1ede\u1ee0\u1ee2\u1ee4\u1ee6\u1ee8\u1eea\u1eec\u1eee\u1ef0\u1ef2\u1ef4\u1ef6\u1ef8\u1efa\u1efc\u1efe\u1f08-\u1f0f\u1f18-\u1f1d\u1f28-\u1f2f\u1f38-\u1f3f\u1f48-\u1f4d\u1f59\u1f5b\u1f5d\u1f5f\u1f68-\u1f6f\u1fb8-\u1fbb\u1fc8-\u1fcb\u1fd8-\u1fdb\u1fe8-\u1fec\u1ff8-\u1ffb\u2102\u2107\u210b-\u210d\u2110-\u2112\u2115\u2119-\u211d\u2124\u2126\u2128\u212a-\u212d\u2130-\u2133\u213e\u213f\u2145\u2183\u2c00-\u2c2e\u2c60\u2c62-\u2c64\u2c67\u2c69\u2c6b\u2c6d-\u2c70\u2c72\u2c75\u2c7e-\u2c80\u2c82\u2c84\u2c86\u2c88\u2c8a\u2c8c\u2c8e\u2c90\u2c92\u2c94\u2c96\u2c98\u2c9a\u2c9c\u2c9e\u2ca0\u2ca2\u2ca4\u2ca6\u2ca8\u2caa\u2cac\u2cae\u2cb0\u2cb2\u2cb4\u2cb6\u2cb8\u2cba\u2cbc\u2cbe\u2cc0\u2cc2\u2cc4\u2cc6\u2cc8\u2cca\u2ccc\u2cce\u2cd0\u2cd2\u2cd4\u2cd6\u2cd8\u2cda\u2cdc\u2cde\u2ce0\u2ce2\u2ceb\u2ced\ua640\ua642\ua644\ua646\ua648\ua64a\ua64c\ua64e\ua650\ua652\ua654\ua656\ua658\ua65a\ua65c\ua65e\ua660\ua662\ua664\ua666\ua668\ua66a\ua66c\ua680\ua682\ua684\ua686\ua688\ua68a\ua68c\ua68e\ua690\ua692\ua694\ua696\ua722\ua724\ua726\ua728\ua72a\ua72c\ua72e\ua732\ua734\ua736\ua738\ua73a\ua73c\ua73e\ua740\ua742\ua744\ua746\ua748\ua74a\ua74c\ua74e\ua750\ua752\ua754\ua756\ua758\ua75a\ua75c\ua75e\ua760\ua762\ua764\ua766\ua768\ua76a\ua76c\ua76e\ua779\ua77b\ua77d\ua77e\ua780\ua782\ua784\ua786\ua78b\ua78d\ua790\ua7a0\ua7a2\ua7a4\ua7a6\ua7a8\uff21-\uff3a]",
    Ll: "[\u0061-\u007a\u00aa\u00b5\u00ba\u00df-\u00f6\u00f8-\u00ff\u0101\u0103\u0105\u0107\u0109\u010b\u010d\u010f\u0111\u0113\u0115\u0117\u0119\u011b\u011d\u011f\u0121\u0123\u0125\u0127\u0129\u012b\u012d\u012f\u0131\u0133\u0135\u0137\u0138\u013a\u013c\u013e\u0140\u0142\u0144\u0146\u0148\u0149\u014b\u014d\u014f\u0151\u0153\u0155\u0157\u0159\u015b\u015d\u015f\u0161\u0163\u0165\u0167\u0169\u016b\u016d\u016f\u0171\u0173\u0175\u0177\u017a\u017c\u017e-\u0180\u0183\u0185\u0188\u018c\u018d\u0192\u0195\u0199-\u019b\u019e\u01a1\u01a3\u01a5\u01a8\u01aa\u01ab\u01ad\u01b0\u01b4\u01b6\u01b9\u01ba\u01bd-\u01bf\u01c6\u01c9\u01cc\u01ce\u01d0\u01d2\u01d4\u01d6\u01d8\u01da\u01dc\u01dd\u01df\u01e1\u01e3\u01e5\u01e7\u01e9\u01eb\u01ed\u01ef\u01f0\u01f3\u01f5\u01f9\u01fb\u01fd\u01ff\u0201\u0203\u0205\u0207\u0209\u020b\u020d\u020f\u0211\u0213\u0215\u0217\u0219\u021b\u021d\u021f\u0221\u0223\u0225\u0227\u0229\u022b\u022d\u022f\u0231\u0233-\u0239\u023c\u023f\u0240\u0242\u0247\u0249\u024b\u024d\u024f-\u0293\u0295-\u02af\u0371\u0373\u0377\u037b-\u037d\u0390\u03ac-\u03ce\u03d0\u03d1\u03d5-\u03d7\u03d9\u03db\u03dd\u03df\u03e1\u03e3\u03e5\u03e7\u03e9\u03eb\u03ed\u03ef-\u03f3\u03f5\u03f8\u03fb\u03fc\u0430-\u045f\u0461\u0463\u0465\u0467\u0469\u046b\u046d\u046f\u0471\u0473\u0475\u0477\u0479\u047b\u047d\u047f\u0481\u048b\u048d\u048f\u0491\u0493\u0495\u0497\u0499\u049b\u049d\u049f\u04a1\u04a3\u04a5\u04a7\u04a9\u04ab\u04ad\u04af\u04b1\u04b3\u04b5\u04b7\u04b9\u04bb\u04bd\u04bf\u04c2\u04c4\u04c6\u04c8\u04ca\u04cc\u04ce\u04cf\u04d1\u04d3\u04d5\u04d7\u04d9\u04db\u04dd\u04df\u04e1\u04e3\u04e5\u04e7\u04e9\u04eb\u04ed\u04ef\u04f1\u04f3\u04f5\u04f7\u04f9\u04fb\u04fd\u04ff\u0501\u0503\u0505\u0507\u0509\u050b\u050d\u050f\u0511\u0513\u0515\u0517\u0519\u051b\u051d\u051f\u0521\u0523\u0525\u0527\u0561-\u0587\u1d00-\u1d2b\u1d62-\u1d77\u1d79-\u1d9a\u1e01\u1e03\u1e05\u1e07\u1e09\u1e0b\u1e0d\u1e0f\u1e11\u1e13\u1e15\u1e17\u1e19\u1e1b\u1e1d\u1e1f\u1e21\u1e23\u1e25\u1e27\u1e29\u1e2b\u1e2d\u1e2f\u1e31\u1e33\u1e35\u1e37\u1e39\u1e3b\u1e3d\u1e3f\u1e41\u1e43\u1e45\u1e47\u1e49\u1e4b\u1e4d\u1e4f\u1e51\u1e53\u1e55\u1e57\u1e59\u1e5b\u1e5d\u1e5f\u1e61\u1e63\u1e65\u1e67\u1e69\u1e6b\u1e6d\u1e6f\u1e71\u1e73\u1e75\u1e77\u1e79\u1e7b\u1e7d\u1e7f\u1e81\u1e83\u1e85\u1e87\u1e89\u1e8b\u1e8d\u1e8f\u1e91\u1e93\u1e95-\u1e9d\u1e9f\u1ea1\u1ea3\u1ea5\u1ea7\u1ea9\u1eab\u1ead\u1eaf\u1eb1\u1eb3\u1eb5\u1eb7\u1eb9\u1ebb\u1ebd\u1ebf\u1ec1\u1ec3\u1ec5\u1ec7\u1ec9\u1ecb\u1ecd\u1ecf\u1ed1\u1ed3\u1ed5\u1ed7\u1ed9\u1edb\u1edd\u1edf\u1ee1\u1ee3\u1ee5\u1ee7\u1ee9\u1eeb\u1eed\u1eef\u1ef1\u1ef3\u1ef5\u1ef7\u1ef9\u1efb\u1efd\u1eff-\u1f07\u1f10-\u1f15\u1f20-\u1f27\u1f30-\u1f37\u1f40-\u1f45\u1f50-\u1f57\u1f60-\u1f67\u1f70-\u1f7d\u1f80-\u1f87\u1f90-\u1f97\u1fa0-\u1fa7\u1fb0-\u1fb4\u1fb6\u1fb7\u1fbe\u1fc2-\u1fc4\u1fc6\u1fc7\u1fd0-\u1fd3\u1fd6\u1fd7\u1fe0-\u1fe7\u1ff2-\u1ff4\u1ff6\u1ff7\u210a\u210e\u210f\u2113\u212f\u2134\u2139\u213c\u213d\u2146-\u2149\u214e\u2184\u2c30-\u2c5e\u2c61\u2c65\u2c66\u2c68\u2c6a\u2c6c\u2c71\u2c73\u2c74\u2c76-\u2c7c\u2c81\u2c83\u2c85\u2c87\u2c89\u2c8b\u2c8d\u2c8f\u2c91\u2c93\u2c95\u2c97\u2c99\u2c9b\u2c9d\u2c9f\u2ca1\u2ca3\u2ca5\u2ca7\u2ca9\u2cab\u2cad\u2caf\u2cb1\u2cb3\u2cb5\u2cb7\u2cb9\u2cbb\u2cbd\u2cbf\u2cc1\u2cc3\u2cc5\u2cc7\u2cc9\u2ccb\u2ccd\u2ccf\u2cd1\u2cd3\u2cd5\u2cd7\u2cd9\u2cdb\u2cdd\u2cdf\u2ce1\u2ce3\u2ce4\u2cec\u2cee\u2d00-\u2d25\ua641\ua643\ua645\ua647\ua649\ua64b\ua64d\ua64f\ua651\ua653\ua655\ua657\ua659\ua65b\ua65d\ua65f\ua661\ua663\ua665\ua667\ua669\ua66b\ua66d\ua681\ua683\ua685\ua687\ua689\ua68b\ua68d\ua68f\ua691\ua693\ua695\ua697\ua723\ua725\ua727\ua729\ua72b\ua72d\ua72f-\ua731\ua733\ua735\ua737\ua739\ua73b\ua73d\ua73f\ua741\ua743\ua745\ua747\ua749\ua74b\ua74d\ua74f\ua751\ua753\ua755\ua757\ua759\ua75b\ua75d\ua75f\ua761\ua763\ua765\ua767\ua769\ua76b\ua76d\ua76f\ua771-\ua778\ua77a\ua77c\ua77f\ua781\ua783\ua785\ua787\ua78c\ua78e\ua791\ua7a1\ua7a3\ua7a5\ua7a7\ua7a9\ua7fa\ufb00-\ufb06\ufb13-\ufb17\uff41-\uff5a]",
    Lt: "[\u01c5\u01c8\u01cb\u01f2\u1f88-\u1f8f\u1f98-\u1f9f\u1fa8-\u1faf\u1fbc\u1fcc\u1ffc]",
    Lm: "[\u02b0-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0374\u037a\u0559\u0640\u06e5\u06e6\u07f4\u07f5\u07fa\u081a\u0824\u0828\u0971\u0e46\u0ec6\u10fc\u17d7\u1843\u1aa7\u1c78-\u1c7d\u1d2c-\u1d61\u1d78\u1d9b-\u1dbf\u2071\u207f\u2090-\u209c\u2c7d\u2d6f\u2e2f\u3005\u3031-\u3035\u303b\u309d\u309e\u30fc-\u30fe\ua015\ua4f8-\ua4fd\ua60c\ua67f\ua717-\ua71f\ua770\ua788\ua9cf\uaa70\uaadd\uff70\uff9e\uff9f]",
    Lo: "[\u01bb\u01c0-\u01c3\u0294\u05d0-\u05ea\u05f0-\u05f2\u0620-\u063f\u0641-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u0800-\u0815\u0840-\u0858\u0904-\u0939\u093d\u0950\u0958-\u0961\u0972-\u0977\u0979-\u097f\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c33\u0c35-\u0c39\u0c3d\u0c58\u0c59\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e45\u0e81\u0e82\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0edc\u0edd\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10d0-\u10fa\u1100-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17dc\u1820-\u1842\u1844-\u1877\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191c\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16\u1a20-\u1a54\u1b05-\u1b33\u1b45-\u1b4b\u1b83-\u1ba0\u1bae\u1baf\u1bc0-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c77\u1ce9-\u1cec\u1cee-\u1cf1\u2135-\u2138\u2d30-\u2d65\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3006\u303c\u3041-\u3096\u309f\u30a1-\u30fa\u30ff\u3105-\u312d\u3131-\u318e\u31a0-\u31ba\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcb\ua000-\ua014\ua016-\ua48c\ua4d0-\ua4f7\ua500-\ua60b\ua610-\ua61f\ua62a\ua62b\ua66e\ua6a0-\ua6e5\ua7fb-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa6f\uaa71-\uaa76\uaa7a\uaa80-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb\uaadc\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa2d\ufa30-\ufa6d\ufa70-\ufad9\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff66-\uff6f\uff71-\uff9d\uffa0-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc]",
    Mn: "[\u0300-\u036f\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u065f\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u0711\u0730-\u074a\u07a6-\u07b0\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u0900-\u0902\u093a\u093c\u0941-\u0948\u094d\u0951-\u0957\u0962\u0963\u0981\u09bc\u09c1-\u09c4\u09cd\u09e2\u09e3\u0a01\u0a02\u0a3c\u0a41\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a70\u0a71\u0a75\u0a81\u0a82\u0abc\u0ac1-\u0ac5\u0ac7\u0ac8\u0acd\u0ae2\u0ae3\u0b01\u0b3c\u0b3f\u0b41-\u0b44\u0b4d\u0b56\u0b62\u0b63\u0b82\u0bc0\u0bcd\u0c3e-\u0c40\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0cbc\u0cbf\u0cc6\u0ccc\u0ccd\u0ce2\u0ce3\u0d41-\u0d44\u0d4d\u0d62\u0d63\u0dca\u0dd2-\u0dd4\u0dd6\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0f18\u0f19\u0f35\u0f37\u0f39\u0f71-\u0f7e\u0f80-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102d-\u1030\u1032-\u1037\u1039\u103a\u103d\u103e\u1058\u1059\u105e-\u1060\u1071-\u1074\u1082\u1085\u1086\u108d\u109d\u135d-\u135f\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b7-\u17bd\u17c6\u17c9-\u17d3\u17dd\u180b-\u180d\u18a9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193b\u1a17\u1a18\u1a56\u1a58-\u1a5e\u1a60\u1a62\u1a65-\u1a6c\u1a73-\u1a7c\u1a7f\u1b00-\u1b03\u1b34\u1b36-\u1b3a\u1b3c\u1b42\u1b6b-\u1b73\u1b80\u1b81\u1ba2-\u1ba5\u1ba8\u1ba9\u1be6\u1be8\u1be9\u1bed\u1bef-\u1bf1\u1c2c-\u1c33\u1c36\u1c37\u1cd0-\u1cd2\u1cd4-\u1ce0\u1ce2-\u1ce8\u1ced\u1dc0-\u1de6\u1dfc-\u1dff\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua66f\ua67c\ua67d\ua6f0\ua6f1\ua802\ua806\ua80b\ua825\ua826\ua8c4\ua8e0-\ua8f1\ua926-\ua92d\ua947-\ua951\ua980-\ua982\ua9b3\ua9b6-\ua9b9\ua9bc\uaa29-\uaa2e\uaa31\uaa32\uaa35\uaa36\uaa43\uaa4c\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uabe5\uabe8\uabed\ufb1e\ufe00-\ufe0f\ufe20-\ufe26]",
    Me: "[\u0488\u0489\u20dd-\u20e0\u20e2-\u20e4\ua670-\ua672]",
    Mc: "[\u0903\u093b\u093e-\u0940\u0949-\u094c\u094e\u094f\u0982\u0983\u09be-\u09c0\u09c7\u09c8\u09cb\u09cc\u09d7\u0a03\u0a3e-\u0a40\u0a83\u0abe-\u0ac0\u0ac9\u0acb\u0acc\u0b02\u0b03\u0b3e\u0b40\u0b47\u0b48\u0b4b\u0b4c\u0b57\u0bbe\u0bbf\u0bc1\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcc\u0bd7\u0c01-\u0c03\u0c41-\u0c44\u0c82\u0c83\u0cbe\u0cc0-\u0cc4\u0cc7\u0cc8\u0cca\u0ccb\u0cd5\u0cd6\u0d02\u0d03\u0d3e-\u0d40\u0d46-\u0d48\u0d4a-\u0d4c\u0d57\u0d82\u0d83\u0dcf-\u0dd1\u0dd8-\u0ddf\u0df2\u0df3\u0f3e\u0f3f\u0f7f\u102b\u102c\u1031\u1038\u103b\u103c\u1056\u1057\u1062-\u1064\u1067-\u106d\u1083\u1084\u1087-\u108c\u108f\u109a-\u109c\u17b6\u17be-\u17c5\u17c7\u17c8\u1923-\u1926\u1929-\u192b\u1930\u1931\u1933-\u1938\u19b0-\u19c0\u19c8\u19c9\u1a19-\u1a1b\u1a55\u1a57\u1a61\u1a63\u1a64\u1a6d-\u1a72\u1b04\u1b35\u1b3b\u1b3d-\u1b41\u1b43\u1b44\u1b82\u1ba1\u1ba6\u1ba7\u1baa\u1be7\u1bea-\u1bec\u1bee\u1bf2\u1bf3\u1c24-\u1c2b\u1c34\u1c35\u1ce1\u1cf2\ua823\ua824\ua827\ua880\ua881\ua8b4-\ua8c3\ua952\ua953\ua983\ua9b4\ua9b5\ua9ba\ua9bb\ua9bd-\ua9c0\uaa2f\uaa30\uaa33\uaa34\uaa4d\uaa7b\uabe3\uabe4\uabe6\uabe7\uabe9\uabea\uabec]",
    Nd: "[\u0030-\u0039\u0660-\u0669\u06f0-\u06f9\u07c0-\u07c9\u0966-\u096f\u09e6-\u09ef\u0a66-\u0a6f\u0ae6-\u0aef\u0b66-\u0b6f\u0be6-\u0bef\u0c66-\u0c6f\u0ce6-\u0cef\u0d66-\u0d6f\u0e50-\u0e59\u0ed0-\u0ed9\u0f20-\u0f29\u1040-\u1049\u1090-\u1099\u17e0-\u17e9\u1810-\u1819\u1946-\u194f\u19d0-\u19d9\u1a80-\u1a89\u1a90-\u1a99\u1b50-\u1b59\u1bb0-\u1bb9\u1c40-\u1c49\u1c50-\u1c59\ua620-\ua629\ua8d0-\ua8d9\ua900-\ua909\ua9d0-\ua9d9\uaa50-\uaa59\uabf0-\uabf9\uff10-\uff19]",
    Nl: "[\u16ee-\u16f0\u2160-\u2182\u2185-\u2188\u3007\u3021-\u3029\u3038-\u303a\ua6e6-\ua6ef]",
    No: "[\u00b2\u00b3\u00b9\u00bc-\u00be\u09f4-\u09f9\u0b72-\u0b77\u0bf0-\u0bf2\u0c78-\u0c7e\u0d70-\u0d75\u0f2a-\u0f33\u1369-\u137c\u17f0-\u17f9\u19da\u2070\u2074-\u2079\u2080-\u2089\u2150-\u215f\u2189\u2460-\u249b\u24ea-\u24ff\u2776-\u2793\u2cfd\u3192-\u3195\u3220-\u3229\u3251-\u325f\u3280-\u3289\u32b1-\u32bf\ua830-\ua835]",
    Zs: "[\u0020\u00a0\u1680\u180e\u2000-\u200a\u202f\u205f\u3000]",
    Zl: "[\u2028]",
    Zp: "[\u2029]",
    Cc: "[\u0000-\u001f\u007f-\u009f]",
    Cf: "[\u00ad\u0600-\u0603\u06dd\u070f\u17b4\u17b5\u200b-\u200f\u202a-\u202e\u2060-\u2064\u206a-\u206f\ufeff\ufff9-\ufffb]",
    Cs: "[\ud800-\udfff]",
    Co: "[\ue000-\uf8ff]",
    Ps: "[\u0028\u005b\u007b\u0f3a\u0f3c\u169b\u201a\u201e\u2045\u207d\u208d\u2329\u2768\u276a\u276c\u276e\u2770\u2772\u2774\u27c5\u27e6\u27e8\u27ea\u27ec\u27ee\u2983\u2985\u2987\u2989\u298b\u298d\u298f\u2991\u2993\u2995\u2997\u29d8\u29da\u29fc\u2e22\u2e24\u2e26\u2e28\u3008\u300a\u300c\u300e\u3010\u3014\u3016\u3018\u301a\u301d\ufd3e\ufe17\ufe35\ufe37\ufe39\ufe3b\ufe3d\ufe3f\ufe41\ufe43\ufe47\ufe59\ufe5b\ufe5d\uff08\uff3b\uff5b\uff5f\uff62]",
    Pd: "[\u002d\u058a\u05be\u1400\u1806\u2010-\u2015\u2e17\u2e1a\u301c\u3030\u30a0\ufe31\ufe32\ufe58\ufe63\uff0d]",
    Pc: "[\u005f\u203f\u2040\u2054\ufe33\ufe34\ufe4d-\ufe4f\uff3f]",
    Pe: "[\u0029\\\u005d\u007d\u0f3b\u0f3d\u169c\u2046\u207e\u208e\u232a\u2769\u276b\u276d\u276f\u2771\u2773\u2775\u27c6\u27e7\u27e9\u27eb\u27ed\u27ef\u2984\u2986\u2988\u298a\u298c\u298e\u2990\u2992\u2994\u2996\u2998\u29d9\u29db\u29fd\u2e23\u2e25\u2e27\u2e29\u3009\u300b\u300d\u300f\u3011\u3015\u3017\u3019\u301b\u301e\u301f\ufd3f\ufe18\ufe36\ufe38\ufe3a\ufe3c\ufe3e\ufe40\ufe42\ufe44\ufe48\ufe5a\ufe5c\ufe5e\uff09\uff3d\uff5d\uff60\uff63]",
    Sm: "[\u002b\u003c-\u003e\u007c\u007e\u00ac\u00b1\u00d7\u00f7\u03f6\u0606-\u0608\u2044\u2052\u207a-\u207c\u208a-\u208c\u2118\u2140-\u2144\u214b\u2190-\u2194\u219a\u219b\u21a0\u21a3\u21a6\u21ae\u21ce\u21cf\u21d2\u21d4\u21f4-\u22ff\u2308-\u230b\u2320\u2321\u237c\u239b-\u23b3\u23dc-\u23e1\u25b7\u25c1\u25f8-\u25ff\u266f\u27c0-\u27c4\u27c7-\u27ca\u27cc\u27ce-\u27e5\u27f0-\u27ff\u2900-\u2982\u2999-\u29d7\u29dc-\u29fb\u29fe-\u2aff\u2b30-\u2b44\u2b47-\u2b4c\ufb29\ufe62\ufe64-\ufe66\uff0b\uff1c-\uff1e\uff5c\uff5e\uffe2\uffe9-\uffec]",
    Po: "[\u0021-\u0023\u0025-\u0027\u002a\u002c\u002e\u002f\u003a\u003b\u003f\u0040\u005c\u00a1\u00b7\u00bf\u037e\u0387\u055a-\u055f\u0589\u05c0\u05c3\u05c6\u05f3\u05f4\u0609\u060a\u060c\u060d\u061b\u061e\u061f\u066a-\u066d\u06d4\u0700-\u070d\u07f7-\u07f9\u0830-\u083e\u085e\u0964\u0965\u0970\u0df4\u0e4f\u0e5a\u0e5b\u0f04-\u0f12\u0f85\u0fd0-\u0fd4\u0fd9\u0fda\u104a-\u104f\u10fb\u1361-\u1368\u166d\u166e\u16eb-\u16ed\u1735\u1736\u17d4-\u17d6\u17d8-\u17da\u1800-\u1805\u1807-\u180a\u1944\u1945\u1a1e\u1a1f\u1aa0-\u1aa6\u1aa8-\u1aad\u1b5a-\u1b60\u1bfc-\u1bff\u1c3b-\u1c3f\u1c7e\u1c7f\u1cd3\u2016\u2017\u2020-\u2027\u2030-\u2038\u203b-\u203e\u2041-\u2043\u2047-\u2051\u2053\u2055-\u205e\u2cf9-\u2cfc\u2cfe\u2cff\u2d70\u2e00\u2e01\u2e06-\u2e08\u2e0b\u2e0e-\u2e16\u2e18\u2e19\u2e1b\u2e1e\u2e1f\u2e2a-\u2e2e\u2e30\u2e31\u3001-\u3003\u303d\u30fb\ua4fe\ua4ff\ua60d-\ua60f\ua673\ua67e\ua6f2-\ua6f7\ua874-\ua877\ua8ce\ua8cf\ua8f8-\ua8fa\ua92e\ua92f\ua95f\ua9c1-\ua9cd\ua9de\ua9df\uaa5c-\uaa5f\uaade\uaadf\uabeb\ufe10-\ufe16\ufe19\ufe30\ufe45\ufe46\ufe49-\ufe4c\ufe50-\ufe52\ufe54-\ufe57\ufe5f-\ufe61\ufe68\ufe6a\ufe6b\uff01-\uff03\uff05-\uff07\uff0a\uff0c\uff0e\uff0f\uff1a\uff1b\uff1f\uff20\uff3c\uff61\uff64\uff65]",
    Sk: "[\u005e\u0060\u00a8\u00af\u00b4\u00b8\u02c2-\u02c5\u02d2-\u02df\u02e5-\u02eb\u02ed\u02ef-\u02ff\u0375\u0384\u0385\u1fbd\u1fbf-\u1fc1\u1fcd-\u1fcf\u1fdd-\u1fdf\u1fed-\u1fef\u1ffd\u1ffe\u309b\u309c\ua700-\ua716\ua720\ua721\ua789\ua78a\ufbb2-\ufbc1\uff3e\uff40\uffe3]",
    Sc: "[\u0024\u00a2-\u00a5\u060b\u09f2\u09f3\u09fb\u0af1\u0bf9\u0e3f\u17db\u20a0-\u20b9\ua838\ufdfc\ufe69\uff04\uffe0\uffe1\uffe5\uffe6]",
    Pi: "[\u00ab\u2018\u201b\u201c\u201f\u2039\u2e02\u2e04\u2e09\u2e0c\u2e1c\u2e20]",
    So: "[\u00a6\u00a7\u00a9\u00ae\u00b0\u00b6\u0482\u060e\u060f\u06de\u06e9\u06fd\u06fe\u07f6\u09fa\u0b70\u0bf3-\u0bf8\u0bfa\u0c7f\u0d79\u0f01-\u0f03\u0f13-\u0f17\u0f1a-\u0f1f\u0f34\u0f36\u0f38\u0fbe-\u0fc5\u0fc7-\u0fcc\u0fce\u0fcf\u0fd5-\u0fd8\u109e\u109f\u1360\u1390-\u1399\u1940\u19de-\u19ff\u1b61-\u1b6a\u1b74-\u1b7c\u2100\u2101\u2103-\u2106\u2108\u2109\u2114\u2116\u2117\u211e-\u2123\u2125\u2127\u2129\u212e\u213a\u213b\u214a\u214c\u214d\u214f\u2195-\u2199\u219c-\u219f\u21a1\u21a2\u21a4\u21a5\u21a7-\u21ad\u21af-\u21cd\u21d0\u21d1\u21d3\u21d5-\u21f3\u2300-\u2307\u230c-\u231f\u2322-\u2328\u232b-\u237b\u237d-\u239a\u23b4-\u23db\u23e2-\u23f3\u2400-\u2426\u2440-\u244a\u249c-\u24e9\u2500-\u25b6\u25b8-\u25c0\u25c2-\u25f7\u2600-\u266e\u2670-\u26ff\u2701-\u2767\u2794-\u27bf\u2800-\u28ff\u2b00-\u2b2f\u2b45\u2b46\u2b50-\u2b59\u2ce5-\u2cea\u2e80-\u2e99\u2e9b-\u2ef3\u2f00-\u2fd5\u2ff0-\u2ffb\u3004\u3012\u3013\u3020\u3036\u3037\u303e\u303f\u3190\u3191\u3196-\u319f\u31c0-\u31e3\u3200-\u321e\u322a-\u3250\u3260-\u327f\u328a-\u32b0\u32c0-\u32fe\u3300-\u33ff\u4dc0-\u4dff\ua490-\ua4c6\ua828-\ua82b\ua836\ua837\ua839\uaa77-\uaa79\ufdfd\uffe4\uffe8\uffed\uffee\ufffc\ufffd]",
    Pf: "[\u00bb\u2019\u201d\u203a\u2e03\u2e05\u2e0a\u2e0d\u2e1d\u2e21]"
};
let unicode_hack_impl = /*@__PURE__*/ (function () {
    /* Regexps to match characters in the BMP according to their Unicode category.
        Extracted from running all characters (code units) against Java's
        Character.getType. Source:
        https://ideone.com/04llh4
    */
    /* Also supports the general category (only the first letter) */
    var firstLetters = {}, p;
    for (p in unicodeCategories) {
        if (firstLetters[p[0]]) {
            firstLetters[p[0]] = unicodeCategories[p]
                .substring(0, unicodeCategories[p].length - 1) + firstLetters[p[0]].substring(1);
        }
        else {
            firstLetters[p[0]] = unicodeCategories[p];
        }
    }
    for (p in firstLetters) {
        unicodeCategories[p] = firstLetters[p];
    }
    /* Gets a regex written in a dialect that supports unicode categories and
        translates it to a dialect supported by JavaScript. */
    return function (regexpString) {
        var modifiers = "";
        if (regexpString instanceof RegExp) {
            modifiers = (regexpString.global ? "g" : "") +
                (regexpString.ignoreCase ? "i" : "") +
                (regexpString.multiline ? "m" : "");
            regexpString = regexpString.source;
        }
        regexpString = regexpString.replace(/\\p\{(..?)\}/g, function (match, group) {
            return unicodeCategories[group] || match;
        });
        return new RegExp(regexpString, modifiers);
    };
})();
function unicode_hack(regexpString) {
    return unicode_hack_impl(regexpString);
}
//jscs:enable
function netRegexToJS(netPattern) {
    var jsPattern = "";
    var nextNETGroupIndex = 1;
    var nextJSGroupIndex = 1;
    var namedGroups = [];
    var nameToJSGroupIndexMap = {};
    var netToJSGroupIndexMap = [[0]];
    var matchMustStartAtCurrentPosition = false;
    var name;
    var i = 0;
    if (netPattern.startsWith("\\G")) {
        i += 2;
        matchMustStartAtCurrentPosition = true;
    }
    var isInClass = false;
    for (; i < netPattern.length; i++) {
        var current = netPattern.charAt(i);
        switch (current) {
            case "\\":
                switch (netPattern.charAt(i + 1)) {
                    case "A":
                        jsPattern = jsPattern.concat("^");
                        i++;
                        break;
                    case "z":
                    case "Z":
                        jsPattern = jsPattern.concat("$");
                        i++;
                        break;
                    case "G":
                        throw new Error("\\G .NET Regex escape is only supported at the start of the pattern.");
                    case "p":
                        if (netPattern.charAt(i + 2) !== "{") {
                            throw new Error("\\p should be followed by braces.");
                        }
                        var endBraceIndex = netPattern.indexOf("}", i + 3);
                        if (endBraceIndex < 0) {
                            throw new Error("Could not find the close brace of the \\p pattern.");
                        }
                        var pattern = netPattern.substring(i + 3, endBraceIndex);
                        i = endBraceIndex;
                        var content = unicodeCategories[pattern];
                        if (content === void 0) {
                            throw new Error("Unknown \\p pattern: " + pattern);
                        }
                        if (isInClass) {
                            jsPattern = jsPattern.concat(content.substr(1, content.length - 2));
                        }
                        else {
                            jsPattern = jsPattern.concat(content);
                        }
                        break;
                    default:
                        jsPattern = jsPattern.concat(netPattern.substr(i, 2));
                        i++;
                        break;
                }
                break;
            case "/":
                jsPattern = jsPattern.concat("\\/");
                break;
            case "[":
                isInClass = true;
                jsPattern = jsPattern.concat("[");
                break;
            case "]":
                isInClass = false;
                jsPattern = jsPattern.concat("]");
                break;
            case "(":
                jsPattern = jsPattern.concat("(");
                var next = netPattern[i + 1];
                name = "";
                if (next === "?") {
                    i++;
                    next = netPattern[i + 1];
                    if (next === "<" || next === "\"") {
                        if (netPattern[i + 2] === "=" || netPattern[i + 2] === "!") {
                            throw new Error("Lookbehind assertions are not supported in JavaScript: " + pattern);
                        }
                        i++;
                        var end = next === "<" ? ">" : "\"";
                        var start = ++i;
                        for (; i < netPattern.length && netPattern[i] != end; i++) {
                        }
                        name = netPattern.slice(start, i);
                    }
                    else {
                        jsPattern = jsPattern.concat("?");
                        // Non-capturing group
                        if (next === ":") {
                            continue;
                        }
                    }
                }
                var currentJSGroupIndex = nextJSGroupIndex++;
                if (name.length !== 0) {
                    if (!(namedGroups.indexOf(name) > -1)) {
                        namedGroups.push(name);
                    }
                    var jsGroups = nameToJSGroupIndexMap[name];
                    if (!jsGroups) {
                        nameToJSGroupIndexMap[name] = jsGroups = [];
                    }
                    jsGroups.push(currentJSGroupIndex);
                }
                else {
                    netToJSGroupIndexMap[nextNETGroupIndex++] = [currentJSGroupIndex];
                }
                break;
            default:
                jsPattern = jsPattern.concat(netPattern.substr(i, 1));
                break;
        }
    }
    var nameToNetGroupIndexMap = {};
    for (i = 0; i < namedGroups.length; i++) {
        var currentNETGroupIndex = nextNETGroupIndex++;
        name = namedGroups[i];
        netToJSGroupIndexMap[currentNETGroupIndex] = nameToJSGroupIndexMap[name];
        nameToNetGroupIndexMap[name] = currentNETGroupIndex;
    }
    return {
        pattern: jsPattern,
        nameToNetGroupIndexMap: nameToNetGroupIndexMap,
        netToJSGroupIndexMap: netToJSGroupIndexMap,
        matchMustStartAtCurrentPosition: matchMustStartAtCurrentPosition
    };
}
function trim(target, ...rest) {
    if (rest.length == 0)
        return target.trim();
    var parts = stringSplit(target, rest, 0 /* None */);
    return parts.join("");
}
function trimStart(target, ...rest) {
    if (target.length === 0) {
        return target;
    }
    var args;
    if (rest.length == 0)
        args = [" "];
    else if (rest.length == 1 && Array.isArray(rest[0])) {
        args = rest[0];
    }
    else {
        args = rest;
    }
    var i = 0;
    for (; i < target.length && args.indexOf(target.charAt(i)) > -1; i++) { }
    return target.substring(i);
}
function trimEnd(target, ...rest) {
    if (target.length === 0) {
        return target;
    }
    var args;
    if (rest.length == 0)
        args = [" "];
    else if (rest.length == 1 && Array.isArray(rest[0])) {
        args = rest[0];
    }
    else {
        args = rest;
    }
    var i = target.length - 1;
    for (; i >= 0 && args.indexOf(target.charAt(i)) > -1; i--) { }
    return target.substring(0, i + 1);
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class ConvertUtil {
    static toBoolean(v, provider) {
        if (v.toBoolean) {
            return v.toBoolean(provider);
        }
        if (typeof v === 'string' || v instanceof String) {
            if (v.toLowerCase().trim() == "true") {
                return true;
            }
            return false;
        }
        return !!v;
    }
    static toString1(v, provider) {
        if (v.toString1) {
            return v.toString1(provider);
        }
        if (typeof v === 'string' || v instanceof String) {
            return v;
        }
        return v.toString();
    }
    static toChar(v, provider) {
        if (v.toChar) {
            return v.toChar(provider);
        }
        if (typeof v === 'string' || v instanceof String) {
            return v[0];
        }
        return String.fromCharCode(+v);
    }
    static toDateTime(v, provider) {
        if (v.toDateTime) {
            return v.toDateTime(provider);
        }
        if (v == null) {
            return dateMinValue();
        }
        var str = v.toString();
        if (/^\s*([0-9]{1,4}\s*((\s+[ap]m?)|(((:\s*[0-9]{1,2}\s*){1,2}(\.\s*[0-9]+)?)(\s+[ap]m?)?)))\s*$/i.test(str)) {
            // The string can be a time string only, in which case we should return today at that time.
            str = new Date().toDateString() + " " + str;
        }
        var dt = new Date(Date.parse(str));
        if (isNaN(+dt))
            throw new FormatException(0, "");
        return dt;
    }
    static convertToNumber(meth, v, minValue, maxValue, trunc, provider, throwOnNaN) {
        if (v[meth]) {
            return v[meth](provider);
        }
        let numberVal = 0;
        if (typeof v === 'string' || v instanceof String) {
            numberVal = parseFloat(v);
            if (throwOnNaN === true && isNaN(numberVal)) {
                throw new FormatException(0, "The string cannot be converted to a number");
            }
        }
        else {
            numberVal = +v;
        }
        if (numberVal < minValue) {
            numberVal = minValue;
        }
        if (numberVal > maxValue) {
            numberVal = maxValue;
        }
        if (trunc) {
            numberVal = truncate(numberVal);
        }
        return numberVal;
    }
    static toByte(v, provider) {
        return ConvertUtil.convertToNumber("toByte", v, 0, 255, true, provider, true);
    }
    static toDecimal(v, provider) {
        return ConvertUtil.convertToNumber("toDecimal", v, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, false, provider, true);
    }
    static toDouble(v, provider) {
        return ConvertUtil.convertToNumber("toDouble", v, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, false, provider);
    }
    static toInt16(v, provider) {
        return ConvertUtil.convertToNumber("toInt16", v, -32768, 32767, true, provider, true);
    }
    static toInt32(v, provider) {
        return ConvertUtil.convertToNumber("toInt32", v, -2147483648, 2147483647, true, provider, true);
    }
    static toInt64(v, provider) {
        return ConvertUtil.convertToNumber("toInt64", v, -9223372036854775808, 9223372036854775807, true, provider, true);
    }
    static toSByte(v, provider) {
        return ConvertUtil.convertToNumber("toSByte", v, -128, 127, true, provider, true);
    }
    static toUInt16(v, provider) {
        return ConvertUtil.convertToNumber("toUInt16", v, 0, 65535, true, provider, true);
    }
    static toUInt32(v, provider) {
        return ConvertUtil.convertToNumber("toUInt32", v, 0, 4294967295, true, provider, true);
    }
    static toUInt64(v, provider) {
        return ConvertUtil.convertToNumber("toUInt64", v, 0, 18446744073709551615, true, provider, true);
    }
    static toSingle(v, provider) {
        return ConvertUtil.convertToNumber("toSingle", v, Number.NEGATIVE_INFINITY, Number.POSITIVE_INFINITY, false, provider);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function dateToString(value, provider) {
    return dateToStringFormat(value, "s", provider);
}
;
function fromOADate(value) {
    var days = Math.floor(value);
    var result = new Date(1899, 11, 30 + days);
    if (value !== days) {
        result = new Date(+result + Math.round((value - days) * 86400000));
    }
    return result;
}
function toOADate(value) {
    var u1 = Date.UTC(value.getFullYear(), value.getMonth(), value.getDate(), value.getHours(), value.getMinutes(), value.getSeconds(), value.getMilliseconds());
    var u2 = Date.UTC(1899, 11, 30);
    return (u1 - u2) / 86400000;
}
class IntlCache {
}
let intlCache = /*@__PURE__*/ new IntlCache();
function dateToStringFormat(value, format, provider) {
    var result;
    provider = provider || CultureInfo.currentCulture; // TODO: Use the provider below
    var mmm = function (value, provider) {
        // On some browsers, the ja-JP month short formatting seems to not match .NET"s "MMM" formatting
        var cultureName = provider.name;
        if (cultureName == "ja-JP") {
            if (window.Intl) {
                if (!intlCache.monthShortJP) {
                    intlCache.monthShortJP = new Intl.DateTimeFormat("en-US", { month: "numeric" });
                }
                result = intlCache.monthShortJP.format(value).replace(/\u200E/g, "");
            }
            else {
                result = value.toLocaleString("en-US", { month: "numeric" })
                    .replace(/\u200E/g, "");
            }
        }
        else {
            if (window.Intl) {
                if (!intlCache['mmm_' + provider.name]) {
                    intlCache['mmm_' + provider.name] = new Intl.DateTimeFormat(provider.name, { month: "short" });
                }
                result = intlCache['mmm_' + provider.name].format(value)
                    .replace(/\u200E/g, "");
            }
            else {
                result = value.toLocaleString(provider.name, { month: "short" })
                    .replace(/\u200E/g, "");
            }
        }
        if (result.indexOf(" ") >= 0) {
            // Date.toLocaleString is not supported fully
            // TODO: Handle other cultures?
            return ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
                "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"][value.getMonth()];
        }
        return result;
    };
    var tt = function (value, abbr) {
        var h = value.getHours();
        var designator = h <= 11 ? "AM" : "PM";
        if (window.Intl) {
            var d = new Date(+value);
            d.setHours(h, 0, 0, 0);
            var culture = provider.name;
            // account for left-to-right marker ie/edge inject
            var r = /\d|[\u200E]/g;
            var withAmPm = applyFormat("tt:" + abbr, { hour12: true, hour: "2-digit" }, d)
                .replace(r, "");
            var nonAmPm = applyFormat("tt:" + abbr, { hour12: false, hour: "2-digit" }, d)
                .replace(r, "");
            var pattern = stringEscapeRegExp(nonAmPm);
            var amPm = withAmPm.replace(new RegExp("\\s*" + pattern + "\\s*"), "").trim();
            // ie & edge will not include the culture's am/pm designator
            // and they instead include some erroneous extra characters.
            // if that's the case then we'll just use the previous fallback
            if (amPm.replace(/[.,:;]/g, "").length > 0) {
                designator = amPm;
            }
        }
        if (abbr && designator) {
            designator = designator.charAt(0);
        }
        return designator;
    };
    var applyFormat = function (format, options, otherVal) {
        let val = value;
        if (otherVal) {
            val = otherVal;
        }
        if (window.Intl) {
            if (!intlCache[format + "_" + provider.name]) {
                intlCache[format + "_" + provider.name] = new Intl.DateTimeFormat(provider.name, options);
            }
            var formatter = intlCache[format + "_" + provider.name];
            return formatter.format(val);
        }
        return val.toLocaleString(provider.name, options);
    };
    switch (format) {
        case "s":
            {
                var s = new Date(Date.UTC(value.getFullYear(), value.getMonth(), value.getDate(), value.getHours(), value.getMinutes(), value.getSeconds())).toISOString();
                var d = s.lastIndexOf(".");
                if (d < 0) {
                    return s;
                }
                return s.slice(0, d);
            }
        case "MMMM":
            return applyFormat(format, { month: "long" })
                .replace(/\u200E/g, "");
        case "ddd":
            return applyFormat(format, { weekday: "short" })
                .replace(/\u200E/g, "");
        case "dddd":
            result = applyFormat(format, { weekday: "long" })
                .replace(/\u200E/g, "");
            if (result.indexOf(" ") >= 0) {
                // Date.toLocaleString is not supported fully
                // TODO: Handle other cultures?
                return ["Sunday", "Monday", "Tuesday", "Wednesday",
                    "Thursday", "Friday", "Saturday"][value.getDay()];
            }
            return result;
        case "%h":
            return value.getHours();
            ;
        case "%m":
            return value.getMinutes();
        case "%s":
            return value.getSeconds();
        case "%t":
            return tt(value, true);
        case "d": // short date
            return applyFormat(format, {});
        case "D": // long date
            return applyFormat(format, { weekday: "long", month: "long", day: "numeric", year: "numeric" });
        case "f": // full datetime (short time)
            return applyFormat(format, {
                weekday: "long", month: "long", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric"
            });
        case "F": // full datetime (long time)
            return applyFormat(format, {
                weekday: "long", month: "long", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric", second: "numeric"
            });
        case "g": // general (short time)
            return applyFormat(format, {
                month: "numeric", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric"
            });
        case "G": // general (long time)
            return applyFormat(format, {
                month: "numeric", day: "numeric", year: "numeric",
                hour: "numeric", minute: "numeric", second: "numeric"
            });
        case "M": // month/day
        case "m":
            return applyFormat(format, { month: "long", day: "numeric" });
        case "t": // short time
            return applyFormat(format, { hour: "numeric", minute: "numeric" });
        case "T": // long time
            return applyFormat(format, { hour: "numeric", minute: "numeric", second: "numeric" });
        //return value.toLocaleTimeString();
        case "Y": // year/month
        case "y":
            return applyFormat(format, { year: "numeric", month: "long" });
    }
    result = format;
    var year = value.getFullYear().toString();
    result = result.replace("yyyy", year);
    result = result.replace("yy", year.substr(-2));
    result = result.replace("MMM", mmm(value, provider));
    result = result.replace("MM", (value.getMonth() + 1).toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("dd", value.getDate().toString().replace(/^(\d)$/, "0$1"));
    var hours = value.getHours();
    result = result.replace("HH", hours.toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("hh", (hours % 12 == 0 ? 12 : hours % 12).toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("tt", tt(value, false));
    result = result.replace("mm", value.getMinutes().toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("ss", value.getSeconds().toString().replace(/^(\d)$/, "0$1"));
    result = result.replace("ff", Math.round(value.getMilliseconds() / 10).toString().replace(/^(\d)$/, "0$1")); // hundredths of a second
    return result;
}
function dateTryParse(s, result) {
    var date = new Date(s);
    if (date == null || isNaN(+date)) {
        // IE8 does not support this format, so parse it manually
        var r = /(\d{4})-(\d{2})-(\d{2})(?:T(\d{2}):(\d{2}):(\d{2}))?/.exec(s);
        if (r) {
            if (r[4]) {
                return {
                    p1: new Date(+r[1], +r[2] - 1, +r[3], +r[4], +r[5], +r[6]), ret: true
                };
            }
            else {
                return { p1: new Date(+r[1], +r[2] - 1, +r[3]), ret: true };
            }
        }
        return { p1: null, ret: false };
    }
    // TODO: Use the current date separator/date format here here?
    if (date.getFullYear() < 1930 && /\d+\/\d+\/\d\d(?!\d)/.test(s)) {
        date.setFullYear(date.getFullYear() + 100);
    }
    return { p1: date, ret: true };
}
function dateParseExact(s, format = null, provider = null) {
    // TODO: Use the format and provider
    var r = dateTryParse(s);
    if (!r.ret) {
        throw new FormatException(1, "Unknown date format");
    }
    return r.p1;
}
function toLocalTime(value) {
    // TODO: Implement
    return value;
}
function toUniversalTime(value) {
    // TODO: Implement
    return value;
}
let _requiresISOCorrection = !/*@__PURE__*/ isNaN(+/*@__PURE__*/ new Date("2000-01-01T00:00:00")) &&
    /*@__PURE__*/ /*@__PURE__*/ new Date("2000-01-01T00:00:00").getHours() !== 0;
let _requiresISODateCorrection = !/*@__PURE__*/ isNaN(+/*@__PURE__*/ new Date("2000-01-01")) &&
    /*@__PURE__*/ /*@__PURE__*/ new Date("2000-01-01").getHours() !== 0;
function dateParse(s, provider) {
    provider = provider || CultureInfo.currentCulture; // TODO: Use the provider below
    var result;
    var isoTest = /(\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2})(?:\.| )?(\d*)?/.exec(s);
    if (isoTest) {
        result = dateParseExact(isoTest[1]);
        if (isoTest[2]) {
            var ms = Number("0." + isoTest[2]) * 1000;
            result = new Date(+result + ms);
        }
        if (!_requiresISOCorrection) {
            return result;
        }
    }
    else {
        result = dateParseExact(s);
        if (!_requiresISODateCorrection) {
            return result;
        }
    }
    return new Date(result.getUTCFullYear(), result.getUTCMonth(), result.getUTCDate(), result.getUTCHours(), result.getUTCMinutes(), result.getUTCSeconds(), result.getUTCMilliseconds());
}
let _longDateFormatOptions = {
    weekday: "long",
    year: "numeric",
    month: "long",
    day: "numeric"
};
function toLongDateString(value) {
    return value.toLocaleString(CultureInfo.currentCulture.name, _longDateFormatOptions).replace(/\u200E/g, "");
}
let _longTimeFormatOptions;
function toLongTimeString(value) {
    return value.toLocaleString(CultureInfo.currentCulture.name, _longTimeFormatOptions).replace(/\u200E/g, "");
}
var DayOfWeek = /*@__PURE__*/ (function (DayOfWeek) {
    DayOfWeek[DayOfWeek["Sunday"] = 0] = "Sunday";
    DayOfWeek[DayOfWeek["Monday"] = 1] = "Monday";
    DayOfWeek[DayOfWeek["Tuesday"] = 2] = "Tuesday";
    DayOfWeek[DayOfWeek["Wednesday"] = 3] = "Wednesday";
    DayOfWeek[DayOfWeek["Thursday"] = 4] = "Thursday";
    DayOfWeek[DayOfWeek["Friday"] = 5] = "Friday";
    DayOfWeek[DayOfWeek["Saturday"] = 6] = "Saturday";
    return DayOfWeek;
})({});
let DayOfWeek_$type = /*@__PURE__*/ markEnum("DayOfWeek", "Sunday,0|Monday,1|Tuesday,2|Wednesday,3|Thursday,4|Friday,5|Saturday,6");

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Convert = /*@__PURE__*/ (() => {
    class Convert extends Base {
        static toDouble5(a) {
            return a;
        }
        static toDouble1(a) {
            return a;
        }
        static toDouble(a) {
            return a;
        }
        static toDouble2(a) {
            return a;
        }
        static toDecimal(a) {
            return a;
        }
        static toDecimal3(a) {
            return a;
        }
        static toDecimal1(a) {
            return a;
        }
        static toInt32(a) {
            if (a >= 0) {
                let b = truncate(Math.floor(a));
                if (b != a) {
                    let c = a - b;
                    let d = Math.ceil(a) - a;
                    if (c > d || ((c == d) && (b & 1) > 0)) {
                        b++;
                    }
                }
                return b;
            }
            else {
                let e = truncate(Math.ceil(a));
                if (e != a) {
                    let f = e - a;
                    let g = a - Math.floor(a);
                    if (f > g || ((f == g) && (e & 1) > 0)) {
                        e--;
                    }
                }
                return e;
            }
        }
        static toInt322(a) {
            return parseInt(a);
        }
        static toDouble3(a) {
            return Convert.toDouble4(a, CultureInfo.currentCulture);
        }
        static toDouble4(a, b) {
            let c = (typeGetValue(unwrapNullable(a)));
            if (c == null) {
                return 0;
            }
            let d = (+c);
            if (isNaN_(d)) {
                return ConvertUtil.toDouble(c, b);
            }
            return d;
        }
        static toInt321(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toInt32(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toInt64(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toInt64(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toDecimal2(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toDecimal(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toByte(a) {
            return (a ? 1 : 0);
        }
        static toByte1(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return 0;
            }
            let c = (+b);
            if (isNaN_(c)) {
                return ConvertUtil.toByte(b, CultureInfo.currentCulture);
            }
            return c;
        }
        static toBoolean(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return false;
            }
            return (!!b);
        }
        static toDateTime(a) {
            let b = (typeGetValue(unwrapNullable(a)));
            if (b == null) {
                return dateMinValue();
            }
            if (typeCast(Date_$type, b) !== null) {
                return b;
            }
            let c = (+b);
            if (!isNaN_(c)) {
                return dateFromTicks(c);
            }
            return dateParse(b.toString());
        }
        static toChar(a) {
            return String.fromCharCode(a);
        }
        static toChar1(a) {
            return String.fromCharCode(a);
        }
        static toDouble6(a, b) {
            return parseNumber(a, b);
        }
        static toUInt16(a) {
            return (a ? 1 : 0);
        }
        static toBoolean1(a) {
            return a != 0;
        }
        static toUInt32(a) {
            return a;
        }
        static fromBase64String(a) {
            return (b64toUint8Array(a));
        }
        static toBase64String(a) {
            return (uint8ArraytoB64(a));
        }
        static toByte2(a, b) {
            throw new NotImplementedException(0);
        }
    }
    Convert.$t = /*@__PURE__*/ markType(Convert, 'Convert');
    return Convert;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISummaryResult_$type = /*@__PURE__*/ new Type(null, 'ISummaryResult');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultSummaryResult = /*@__PURE__*/ (() => {
    class DefaultSummaryResult extends Base {
        constructor(a, b, c) {
            super();
            this.d = null;
            this.c = null;
            this.a = 0;
            this.b = 0;
            this.d = a;
            this.a = b;
            this.c = c;
        }
        get propertyName() {
            return this.d;
        }
        get operand() {
            return this.a;
        }
        get value() {
            return this.c;
        }
        get summaryIndex() {
            return this.b;
        }
        set summaryIndex(a) {
            this.b = a;
        }
    }
    DefaultSummaryResult.$t = /*@__PURE__*/ markType(DefaultSummaryResult, 'DefaultSummaryResult', Base.$, [ISummaryResult_$type]);
    return DefaultSummaryResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArgumentNullException = /*@__PURE__*/ (() => {
    class ArgumentNullException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(1, c + " cannot be null.");
                    }
                    break;
                case 1:
                    {
                        super(0);
                        throw new NotImplementedException(0);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, d);
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
    }
    ArgumentNullException.$t = /*@__PURE__*/ markType(ArgumentNullException, 'ArgumentNullException', BaseError.$);
    return ArgumentNullException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IEditableDataSource_$type = /*@__PURE__*/ new Type(null, 'IEditableDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Transaction = /*@__PURE__*/ (() => {
    class Transaction extends Base {
        constructor() {
            super(...arguments);
            this._id = null;
            this._transactionID = 0;
            this._type = 0;
            this._value = null;
            this._error = null;
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        get transactionID() {
            return this._transactionID;
        }
        set transactionID(a) {
            this._transactionID = a;
        }
        get type() {
            return this._type;
        }
        set type(a) {
            this._type = a;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        get error() {
            return this._error;
        }
        set error(a) {
            this._error = a;
        }
    }
    Transaction.$t = /*@__PURE__*/ markType(Transaction, 'Transaction');
    return Transaction;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionState = /*@__PURE__*/ (() => {
    class TransactionState extends Base {
        constructor(a, b, c) {
            super();
            this._id = null;
            this._transactionType = 0;
            this._value = null;
            this._version = null;
            this.id = a;
            this.transactionType = b;
            this.value = c;
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        get transactionType() {
            return this._transactionType;
        }
        set transactionType(a) {
            this._transactionType = a;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        get version() {
            return this._version;
        }
        set version(a) {
            this._version = a;
        }
    }
    TransactionState.$t = /*@__PURE__*/ markType(TransactionState, 'TransactionState');
    return TransactionState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseTransactionService = /*@__PURE__*/ (() => {
    class BaseTransactionService extends Base {
        constructor(a, b, c) {
            super();
            this.i = false;
            this.p = new List$1(Transaction.$, 0);
            this.n = null;
            this.h = null;
            this.r = null;
            this.stateChanged = null;
            if (a == null || b == null) {
                throw new ArgumentNullException(1);
            }
            this.h = a;
            this.r = b;
            if (c != null) {
                this.n = new Dictionary$2(Base.$, TransactionState.$, 2, c);
            }
            else {
                this.n = new Dictionary$2(Base.$, TransactionState.$, 0);
            }
        }
        get m() {
            return this.i;
        }
        set m(a) {
            this.i = a;
        }
        get q() {
            return this.p;
        }
        get o() {
            return this.n;
        }
        get_l() {
            return this.i;
        }
        set_l(a) {
        }
        get l() {
            return this.get_l();
        }
        set l(a) {
            this.set_l(a);
        }
        get_k() {
            return false;
        }
        get k() {
            return this.get_k();
        }
        get_j() {
            return false;
        }
        get j() {
            return this.get_j();
        }
        af(a, b) {
            if (a.containsKey(b.id)) {
                if (this.h != null) {
                    this.h(a.item(b.id), b.value);
                }
                else {
                    a.item(b.id).value = b.value;
                }
            }
            else {
                a.addItem(b.id, new TransactionState(b.id, b.type, this.r(b.value)));
            }
        }
        aa(a, b) {
            if (this.stateChanged != null) {
                this.stateChanged(a, b);
            }
        }
        z(a, b, c) {
        }
        v(a, b = false) {
            if (this.m) {
                this.af(this.o, a);
                this.q.add(a);
            }
        }
        w(a, b = null) {
            if (a) {
                this.n.clear();
                this.p.clear();
            }
        }
        g(a) {
            if (this.o.count > 0 && this.o.containsKey(a)) {
                return this.o.item(a);
            }
            return null;
        }
        ad() {
            this.i = true;
        }
        y(a) {
            this.i = false;
            this.x();
        }
        x(a = -1) {
            if (a > -1) {
                for (let b = 0; b < this.q.count; b++) {
                    let c = this.q._inner[b];
                    if (c.transactionID == a) {
                        this.q.removeAt(b);
                        this.o.clear();
                        for (let d = 0; d < this.q.count; d++) {
                            this.af(this.o, this.q._inner[d]);
                        }
                        break;
                    }
                }
            }
            else {
                this.n.clear();
                this.p.clear();
            }
        }
        d(a) {
            for (let b = 0; b < this.q.count; b++) {
                if (this.q._inner[b].transactionID == a) {
                    return this.q._inner[b];
                }
            }
            return null;
        }
        e(a) {
            return null;
        }
        s(a, b) {
            return -1;
        }
        u(a) {
        }
        ac(a) {
        }
        ae() {
        }
        ab() {
        }
        a(a = -1) {
            let b = new List$1(TransactionState.$, 0);
            for (let c of fromEnum(this.o.values)) {
                b.add(c);
            }
            return b.toArray();
        }
        c(a = null) {
            if (a != null) {
                let b = new List$1(Transaction.$, 0);
                for (let c = 0; c < this.q.count; c++) {
                    if (this.q._inner[c].id == a) {
                        b.add(this.q._inner[c]);
                    }
                }
                return b.toArray();
            }
            return this.q.toArray();
        }
        b() {
            let a = new List$1(Transaction.$, 0);
            for (let b = 0; b < this.q.count; b++) {
                if (!stringIsNullOrWhiteSpace(this.q._inner[b].error)) {
                    a.add(this.q._inner[b]);
                }
            }
            return a.toArray();
        }
    }
    BaseTransactionService.$t = /*@__PURE__*/ markType(BaseTransactionService, 'BaseTransactionService');
    return BaseTransactionService;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionHistory = /*@__PURE__*/ (() => {
    class TransactionHistory extends Base {
        constructor() {
            super(...arguments);
            this.a = new List$1(Transaction.$, 0);
        }
        get transactions() {
            return this.a;
        }
    }
    TransactionHistory.$t = /*@__PURE__*/ markType(TransactionHistory, 'TransactionHistory');
    return TransactionHistory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionCommit = /*@__PURE__*/ (() => {
    class TransactionCommit extends Base {
        constructor() {
            super(...arguments);
            this._id = 0;
            this.a = null;
            this.b = null;
            this.d = 0;
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
    }
    TransactionCommit.$t = /*@__PURE__*/ markType(TransactionCommit, 'TransactionCommit');
    return TransactionCommit;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enumeration for the different transaction types.
 */
var TransactionType = /*@__PURE__*/ (function (TransactionType) {
    /**
     * An add transaction.
     */
    TransactionType[TransactionType["Add"] = 0] = "Add";
    /**
     * An update transaction.
     */
    TransactionType[TransactionType["Update"] = 1] = "Update";
    /**
     * A delete transaction.
     */
    TransactionType[TransactionType["Delete"] = 2] = "Delete";
    return TransactionType;
})({});
/**
 * @hidden
 */
let TransactionType_$type = /*@__PURE__*/ markEnum('TransactionType', 'Add,0|Update,1|Delete,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionService = /*@__PURE__*/ (() => {
    class TransactionService extends BaseTransactionService {
        constructor(a, b, c) {
            super(a, b, c);
            this.am = new List$1(Transaction.$, 0);
            this.ak = new List$1(TransactionCommit.$, 0);
            this.ai = null;
            this.an = new List$1(TransactionHistory.$, 0);
            this.al = new List$1(TransactionHistory.$, 0);
            this.aj = null;
            this.aj = c;
            if (this.aj != null) {
                this.ai = new Dictionary$2(Base.$, TransactionState.$, 2, this.aj);
            }
            else {
                this.ai = new Dictionary$2(Base.$, TransactionState.$, 0);
            }
        }
        get_l() {
            return true;
        }
        set_l(a) {
            super.set_l(a);
        }
        get_k() {
            return this.an.count > 0;
        }
        get_j() {
            return this.al.count > 0;
        }
        af(a, b) {
            let c = null;
            if (a.containsKey(b.id)) {
                c = a.item(b.id);
            }
            if (c != null) {
                switch (b.type) {
                    case TransactionType.Delete:
                        if (c.transactionType == 0) {
                            a.removeItem(b.id);
                        }
                        else if (c.transactionType == 1) {
                            c.value = null;
                            c.transactionType = TransactionType.Delete;
                        }
                        break;
                    case 1:
                        if (c.transactionType == 0 || c.transactionType == 1) {
                            this.h(c.value, b.value);
                        }
                        break;
                }
            }
            else {
                a.addItem(b.id, new TransactionState(b.id, b.type, this.r(b.value)));
            }
        }
        aq(a, b) {
            let c = null;
            if (a.containsKey(b.id)) {
                c = a.item(b.id);
            }
            switch (b.type) {
                case 0:
                    if (c != null) {
                        throw new InvalidOperationException(1, "Cannot add this transaction. A transaction with this ID already exists.");
                    }
                    break;
                case 1:
                case TransactionType.Delete:
                    if (c != null && c.transactionType == TransactionType.Delete) {
                        throw new InvalidOperationException(1, "Cannot add this transaction. A transaction with this ID has already been deleted.");
                    }
                    break;
            }
        }
        z(a, b, c) {
            super.z(a, b, c);
            switch (a) {
                case "IsEnabled":
                    this.w(true, null);
                    break;
            }
        }
        v(a, b = false) {
            let c = (this.m || b) ? this.o : this.ai;
            let d = (this.m || b) ? this.q : this.am;
            this.aq(c, a);
            this.af(c, a);
            d.add(a);
            a.transactionID = TransactionService.ao++;
            if (!this.m && !b) {
                let e = new TransactionHistory();
                e.transactions.add(a);
                this.an.insert(0, e);
                this.al.clear();
                this.aa(3, e);
            }
        }
        w(a, b = null) {
            if (b != null) {
                for (let c = 0; c < this.am.count; c++) {
                    if (this.am._inner[c].id == b) {
                        this.am.removeAt(c);
                        c--;
                    }
                }
                this.ai.removeItem(b);
                for (let d = 0; d < this.an.count; d++) {
                    for (let e = 0; e < this.an._inner[d].transactions.count; e++) {
                        if (this.an._inner[d].transactions._inner[e].id == b) {
                            this.an._inner[d].transactions.removeAt(e);
                            e--;
                        }
                    }
                    if (this.an._inner[d].transactions.count == 0) {
                        this.an.removeAt(d);
                        d--;
                    }
                }
            }
            else {
                if (this.aj != null) {
                    this.ai = new Dictionary$2(Base.$, TransactionState.$, 2, this.aj);
                }
                else {
                    this.ai = new Dictionary$2(Base.$, TransactionState.$, 0);
                }
                this.am.clear();
                this.an.clear();
            }
            this.al.clear();
            super.w(a, b);
        }
        g(a) {
            let b = this.m ? this.o : this.ai;
            if (b.count > 0 && b.containsKey(a)) {
                return b.item(a);
            }
            return null;
        }
        ah(a) {
            return super.g(a);
        }
        ag(a) {
            for (let b = this.ak.count - 1; b >= 0; b--) {
                if (this.ak._inner[b].b.containsKey(a)) {
                    return this.ak._inner[b].b.item(a);
                }
            }
            return null;
        }
        y(a) {
            this.m = false;
            if (a) {
                let b = new TransactionHistory();
                for (let c = 0; c < this.q.count; c++) {
                    let d = this.q._inner[c];
                    let e = this.o.item(d.id);
                    this.am.add(d);
                    this.af(this.ai, d);
                    b.transactions.add(d);
                }
                this.an.insert(0, b);
                this.al.clear();
            }
            super.y(a);
        }
        ap(a) {
            for (let b = 0; b < this.q.count; b++) {
                let c = this.q._inner[b];
                if (c.transactionID == a) {
                    this.am.add(c);
                    this.af(this.ai, c);
                    this.q.removeAt(b);
                    this.o.clear();
                    for (let d = 0; d < this.q.count; d++) {
                        this.af(this.o, this.q._inner[d]);
                    }
                    let e = new TransactionHistory();
                    e.transactions.add(c);
                    this.an.insert(0, e);
                    this.al.clear();
                    break;
                }
            }
        }
        s(a, b) {
            let c = -1;
            if (this.ai.count > 0) {
                let d = new TransactionCommit();
                d.id = TransactionService.ao++;
                d.a = this.a(-1);
                d.b = this.ai;
                d.d = -1;
                if (a) {
                    d.d = this.ak.count;
                    this.ak.add(d);
                }
                else {
                    this.aa(5, d);
                }
                c = d.id;
            }
            this.w(b, null);
            return c;
        }
        u(a) {
            let b = this.e(a);
            if (b != null) {
                this.aa(5, b);
                this.ak.removeAt(b.d);
            }
        }
        ac(a) {
            let b = this.e(a);
            if (b != null) {
                this.ak.removeAt(b.d);
            }
        }
        ae() {
            if (this.k) {
                let a = this.an._inner[0];
                this.an.removeAt(0);
                let b = this.am.count - a.transactions.count;
                this.am.v(b, a.transactions.count);
                this.al.insert(0, a);
                this.ai.clear();
                for (let c = 0; c < this.an.count; c++) {
                    for (let d = 0; d < this.an._inner[c].transactions.count; d++) {
                        this.af(this.ai, this.an._inner[c].transactions._inner[d]);
                    }
                }
                this.aa(0, a);
            }
        }
        ab() {
            if (this.j) {
                let a = this.al._inner[0];
                this.al.removeAt(0);
                for (let b = 0; b < a.transactions.count; b++) {
                    this.af(this.ai, a.transactions._inner[b]);
                    this.am.add(a.transactions._inner[b]);
                }
                this.an.insert(0, a);
                this.aa(1, a);
            }
        }
        a(a = -1) {
            let b = new List$1(TransactionState.$, 0);
            if (a > -1) {
                let c = this.e(a);
                if (c != null) {
                    for (let d of fromEnum(c.b.values)) {
                        b.add(d);
                    }
                }
            }
            else {
                for (let e of fromEnum(this.ai.values)) {
                    b.add(e);
                }
            }
            return b.toArray();
        }
        e(a) {
            for (let b = 0; b < this.ak.count; b++) {
                if (this.ak._inner[b].id == a) {
                    return this.ak._inner[b];
                }
            }
            return null;
        }
        c(a = null) {
            if (a != null) {
                let b = new List$1(Transaction.$, 0);
                for (let c = 0; c < this.q.count; c++) {
                    if (this.q._inner[c].id == a || this.aj.equalsC(this.q._inner[c].id, a)) {
                        b.add(this.q._inner[c]);
                    }
                }
                return b.toArray();
            }
            return this.q.toArray();
        }
    }
    TransactionService.$t = /*@__PURE__*/ markType(TransactionService, 'TransactionService', BaseTransactionService.$);
    TransactionService.ao = 0;
    return TransactionService;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionKeyEqualityComparer = /*@__PURE__*/ (() => {
    class TransactionKeyEqualityComparer extends Base {
        equalsC(a, b) {
            let c = a;
            let d = b;
            if (c.length != d.length) {
                return false;
            }
            for (let e = 0; e < c.length; e++) {
                if (c[e] == null && d[e] != null) {
                    return false;
                }
                if (c[e] != null && d[e] == null) {
                    return false;
                }
                if (c[e] != d[e]) {
                    if (!Base.equalsStatic(c[e], d[e])) {
                        return false;
                    }
                }
            }
            return true;
        }
        getHashCodeC(a) {
            let b = 0;
            let c = a;
            for (let d = 0; d < c.length; d++) {
                if (c[d] != null) {
                    b += Base.getHashCodeStatic(c[d]);
                }
            }
            return b;
        }
    }
    TransactionKeyEqualityComparer.$t = /*@__PURE__*/ markType(TransactionKeyEqualityComparer, 'TransactionKeyEqualityComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(Base.$)]);
    return TransactionKeyEqualityComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastIterationDictionary$2 = /*@__PURE__*/ (() => {
    class FastIterationDictionary$2 extends Base {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.k = null;
            this.o = null;
            this.q = null;
            this.p = null;
            this.l = null;
            this.c = false;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            this.k = new Dictionary$2(this.$tKey, this.$tValue, 2, e);
                            this.o = new List$1(this.$tKey, 0);
                            this.q = new List$1(this.$tValue, 0);
                            this.l = new Dictionary$2(this.$tKey, Number_$type, 0);
                            this.p = new List$1(Boolean_$type, 0);
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.k = new Dictionary$2(this.$tKey, this.$tValue, 2, c);
                        this.o = new List$1(this.$tKey, 0);
                        this.q = new List$1(this.$tValue, 0);
                        this.l = new Dictionary$2(this.$tKey, Number_$type, 0);
                        this.p = new List$1(Boolean_$type, 0);
                    }
                    break;
            }
        }
        s(a, b) {
            this.k.addItem(a, b);
            this.o.add(a);
            this.q.add(b);
            this.l.addItem(a, this.o.count - 1);
            this.p.add(false);
        }
        i() {
            for (let a = 0; a < this.o.count; a++) {
                if (this.p._inner[a]) {
                    continue;
                }
                if (this.item(this.o._inner[a]) != this.q._inner[a]) {
                    return false;
                }
            }
            return true;
        }
        e() {
            let a = new HashSet$1(this.$tValue, 0);
            for (let b = 0; b < this.q.count; b++) {
                if (this.p._inner[b]) {
                    continue;
                }
                if (a.contains(this.q._inner[b])) {
                    return true;
                }
                a.add_1(this.q._inner[b]);
            }
            return false;
        }
        j(a) {
            for (let b = 0; b < this.q.count; b++) {
                if (this.p._inner[b]) {
                    continue;
                }
                let c = a(this.q._inner[b]);
                if (!Base.equalsStatic(c, getBoxIfEnum(this.$tKey, this.o._inner[b]))) {
                    return false;
                }
            }
            return true;
        }
        u() {
            this.k.clear();
            this.o.clear();
            this.q.clear();
            this.l.clear();
            this.p.clear();
        }
        d(a) {
            return this.k.containsKey(a);
        }
        get r() {
            return this.k.count;
        }
        get m() {
            return this.k.keys;
        }
        get g() {
            return this.c;
        }
        set g(a) {
            this.c = a;
            if (this.p.count > (this.l.count * 3)) {
                this.t();
            }
        }
        f(a) {
            let b = this.k.removeItem(a);
            if (b) {
                let c = this.l.item(a);
                this.p._inner[c] = true;
                this.l.removeItem(a);
                if (this.p.count > (this.l.count * 3)) {
                    this.t();
                }
                return b;
            }
            return b;
        }
        t() {
            if (this.g) {
                return;
            }
            let a = this.p.count;
            let b = 0;
            let c = new List$1(this.$tKey, 0);
            let d = new List$1(this.$tValue, 0);
            let e = new List$1(Boolean_$type, 0);
            for (let f = 0; f < a; f++) {
                if (this.p._inner[f]) {
                    continue;
                }
                else {
                    this.l.removeItem(this.o._inner[f]);
                    this.l.addItem(this.o._inner[f], b);
                    c.add(this.o._inner[f]);
                    d.add(this.q._inner[f]);
                    e.add(false);
                    b++;
                }
            }
            this.o = c;
            this.q = d;
            this.p = e;
        }
        h(a, b) {
            return {
                ret: ((() => { let c = this.k.tryGetValue(a, b); b = c.p1; return c.ret; })()),
                p1: b
            };
        }
        b(a) {
            return this.k.f(a);
        }
        get n() {
            return this.k.values;
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (!this.d(a)) {
                    this.s(a, b);
                }
                else {
                    this.k.item(a, b);
                    let c = this.l.item(a);
                    this.q._inner[c] = b;
                    this.p._inner[c] = false;
                }
                return b;
            }
            else {
                return this.k.item(a);
            }
        }
    }
    FastIterationDictionary$2.$t = /*@__PURE__*/ markType(FastIterationDictionary$2, 'FastIterationDictionary$2');
    return FastIterationDictionary$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSpecialRow = /*@__PURE__*/ (() => {
    class DataSourceSpecialRow extends Base {
        constructor() {
            super(...arguments);
            this.$$isSpecialRow = true;
            this.j = new FastIterationDictionary$2(String_$type, Base.$, 0);
            this.i = new FastIterationDictionary$2(String_$type, Base.$, 0);
            this._rowType = 0;
            this._targetRow = null;
            this._level = 0;
            this._summaryResults = null;
        }
        get rowType() {
            return this._rowType;
        }
        set rowType(a) {
            this._rowType = a;
        }
        get keys() {
            let a = new List$1(String_$type, 0);
            for (let b = 0; b < this.j.o.count; b++) {
                if (this.j.p._inner[b]) {
                    continue;
                }
                a.add(this.j.o._inner[b]);
            }
            return a.toArray();
        }
        get values() {
            let a = new List$1(Base.$, 0);
            for (let b = 0; b < this.j.q.count; b++) {
                if (this.j.p._inner[b]) {
                    continue;
                }
                a.add1(this.j.q._inner[b]);
            }
            return a.toArray();
        }
        get sectionKeys() {
            let a = new List$1(String_$type, 0);
            for (let b = 0; b < this.i.o.count; b++) {
                if (this.i.p._inner[b]) {
                    continue;
                }
                a.add(this.i.o._inner[b]);
            }
            return a.toArray();
        }
        get sectionValues() {
            let a = new List$1(Base.$, 0);
            for (let b = 0; b < this.i.q.count; b++) {
                if (this.i.p._inner[b]) {
                    continue;
                }
                a.add1(this.i.q._inner[b]);
            }
            return a.toArray();
        }
        get targetRow() {
            return this._targetRow;
        }
        set targetRow(a) {
            this._targetRow = a;
        }
        get level() {
            return this._level;
        }
        set level(a) {
            this._level = a;
        }
        get summaryResults() {
            return this._summaryResults;
        }
        set summaryResults(a) {
            this._summaryResults = a;
        }
        getValue(a) {
            if (a == "SectionInformation") {
                return this.i;
            }
            let b = null;
            if (((() => { let c = this.j.h(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            b = this.getSummaryValue(a);
            return b;
        }
        getSectionValue(a) {
            if (a == "SectionInformation") {
                return this.i;
            }
            let b = null;
            if (((() => { let c = this.i.h(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            b = this.getSummaryValue(a);
            return b;
        }
        setValue(a, b) {
            this.j.item(a, b);
        }
        setSectionValue(a, b) {
            this.i.item(a, b);
        }
        getSectionKeys() {
            let a = new Array(this.i.r);
            let b = 0;
            for (let c of fromEnum(this.i.m)) {
                a[b] = c;
                b++;
            }
            return a;
        }
        getSummaryValue(a) {
            if (this.summaryResults != null) {
                for (let b = 0; b < this.summaryResults.length; b++) {
                    if (this.summaryResults[b] != null && this.summaryResults[b].propertyName == a) {
                        return this.summaryResults[b].value;
                    }
                }
            }
            return null;
        }
        getSummaryResults(a) {
            if (stringIsNullOrWhiteSpace(a)) {
                return this.summaryResults;
            }
            let b = new List$1(ISummaryResult_$type, 0);
            for (let c = 0; c < this.summaryResults.length; c++) {
                if (this.summaryResults[c] != null && this.summaryResults[c].propertyName == a) {
                    b.add(this.summaryResults[c]);
                }
            }
            return b.toArray();
        }
        l(a) {
            if (a.rowType != 1) {
                return false;
            }
            if (a.i.r != this.i.r) {
                return false;
            }
            for (let b = 0; b < a.i.o.count; b++) {
                let c = a.i.o._inner[b];
                let d = a.i.q._inner[b];
                if (!this.i.d(c)) {
                    return false;
                }
                if (this.i.item(c) == null) {
                    if (this.i.item(c) != d) {
                        return false;
                    }
                    continue;
                }
                if (!Base.equalsStatic(this.i.item(c), d)) {
                    return false;
                }
            }
            return true;
        }
        equals(a) {
            let b = a;
            if (this.rowType == 1 && b.rowType == 1) {
                return this.l(b);
            }
            else if (this.rowType == 3 && b.rowType == 3) {
                return this.targetRow == b.targetRow;
            }
            return super.equals(a);
        }
        getHashCode() {
            if (this.rowType == 1) {
                let a = 0;
                for (let b = 0; b < this.i.q.count; b++) {
                    a = a * 17 + this.o(this.i.o._inner[b]);
                    a = a * 17 + this.o(this.i.q._inner[b]);
                }
                return a;
            }
            return super.getHashCode();
        }
        o(val_) {
            if (val_ == null) {
                return 0;
            }
            return Base.getHashCodeStatic(val_);
        }
    }
    DataSourceSpecialRow.$t = /*@__PURE__*/ markType(DataSourceSpecialRow, 'DataSourceSpecialRow');
    return DataSourceSpecialRow;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceAggregatedResult = /*@__PURE__*/ (() => {
    class DataSourceAggregatedResult extends Base {
        constructor() {
            super(...arguments);
            this._item = null;
            this._transactionType = 0;
            this._keys = null;
            this._values = null;
        }
        get item() {
            return this._item;
        }
        set item(a) {
            this._item = a;
        }
        get transactionType() {
            return this._transactionType;
        }
        set transactionType(a) {
            this._transactionType = a;
        }
        get keys() {
            return this._keys;
        }
        set keys(a) {
            this._keys = a;
        }
        get values() {
            return this._values;
        }
        set values(a) {
            this._values = a;
        }
    }
    DataSourceAggregatedResult.$t = /*@__PURE__*/ markType(DataSourceAggregatedResult, 'DataSourceAggregatedResult');
    return DataSourceAggregatedResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataCommittedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceDataCommittedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this._commitID = 0;
            this._changes = null;
            this.commitID = a;
            this.changes = b;
        }
        get commitID() {
            return this._commitID;
        }
        set commitID(a) {
            this._commitID = a;
        }
        get changes() {
            return this._changes;
        }
        set changes(a) {
            this._changes = a;
        }
    }
    DataSourceDataCommittedEventArgs.$t = /*@__PURE__*/ markType(DataSourceDataCommittedEventArgs, 'DataSourceDataCommittedEventArgs', EventArgs.$);
    return DataSourceDataCommittedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Localization = /*@__PURE__*/ (() => {
    class Localization extends Base {
        static register(a, b) {
            if (Localization.c == null) {
                Localization.c = {};
            }
            Localization.c[a] = b;
        }
        static getString(a, b, ...c) {
            let d;
            if (Localization.b != null) {
                d = Localization.b(a, b);
            }
            else {
                let e = null;
                if (Localization.c != null) {
                    e = Localization.c[a];
                }
                if (e != null) {
                    d = (e[b]);
                }
                else {
                    throw new NotSupportedException(1, "string override must be specified for localization");
                }
            }
            if (stringIsNullOrEmpty(d)) {
                d = "";
            }
            else if (c != null && c.length > 0) {
                d = stringFormat1(d, ...c);
            }
            return d;
        }
        static isRegistered(a) {
            return (Localization.c && Localization.c[a] !== undefined);
        }
        static d(a) {
            let b = (navigator.language ? navigator.language.toLowerCase() : "");
            if (stringStartsWith(b, "de") && Localization.isRegistered(stringFormat("{0}-de", a))) {
                return "de";
            }
            else if (stringStartsWith(b, "es") && Localization.isRegistered(stringFormat("{0}-es", a))) {
                return "es";
            }
            else if (stringStartsWith(b, "fr") && Localization.isRegistered(stringFormat("{0}-fr", a))) {
                return "fr";
            }
            else if (stringStartsWith(b, "ja") && Localization.isRegistered(stringFormat("{0}-ja", a))) {
                return "ja";
            }
            else if (stringStartsWith(b, "zh-hk") && Localization.isRegistered(stringFormat("{0}-zh-Hant", a))) {
                return "zh-hant";
            }
            else if (stringStartsWith(b, "zh-tw") && Localization.isRegistered(stringFormat("{0}-zh-Hant", a))) {
                return "zh-hant";
            }
            else if (stringStartsWith(b, "zh-mo") && Localization.isRegistered(stringFormat("{0}-zh-Hant", a))) {
                return "zh-hant";
            }
            else if (stringStartsWith(b, "zh-hant") && Localization.isRegistered(stringFormat("{0}-zh-Hant", a))) {
                return "zh-hant";
            }
            else if (stringStartsWith(b, "zh-cn") && Localization.isRegistered(stringFormat("{0}-zh-Hans", a))) {
                return "zh-hans";
            }
            else if (stringStartsWith(b, "zh-sg") && Localization.isRegistered(stringFormat("{0}-zh-Hans", a))) {
                return "zh-hans";
            }
            else if (stringStartsWith(b, "zh") && Localization.isRegistered(stringFormat("{0}-zh-Hans", a))) {
                return "zh-hans";
            }
            else if (stringStartsWith(b, "it") && Localization.isRegistered(stringFormat("{0}-it", a))) {
                return "it";
            }
            else if (stringStartsWith(b, "bg") && Localization.isRegistered(stringFormat("{0}-bg", a))) {
                return "bg";
            }
            else if (stringStartsWith(b, "ru") && Localization.isRegistered(stringFormat("{0}-ru", a))) {
                return "ru";
            }
            else if (stringStartsWith(b, "ko") && Localization.isRegistered(stringFormat("{0}-ko", a))) {
                return "ko";
            }
            return "en";
        }
    }
    Localization.$t = /*@__PURE__*/ markType(Localization, 'Localization');
    Localization.b = null;
    Localization.c = null;
    return Localization;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceDataProvider', null, [ISupportsDataChangeNotifications_$type, IDataSourceSupportsCount_$type]);
/**
 * @hidden
 */
let IFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IFilterExpression');
/**
 * @hidden
 */
let FilterExpressionCollection = /*@__PURE__*/ (() => {
    class FilterExpressionCollection extends Base {
        constructor() {
            super();
            this.a = null;
            this.f = null;
            this.f = new SyncableObservableCollection$1(IFilterExpression_$type);
        }
        get syncTarget() {
            return this.a;
        }
        set syncTarget(a) {
            if (a == null) {
                this.f.syncTarget = null;
                this.a = null;
                return;
            }
            this.a = a;
            this.f.syncTarget = this.a.f;
        }
        add(a) {
            return this.f.add(a);
        }
        insert(a, b) {
            this.f.add1(a, b);
        }
        clear() {
            this.f.clear();
        }
        get(a) {
            return this.f.get(a);
        }
        indexOf(a) {
            return this.f.indexOf(a);
        }
        remove(a) {
            return this.f.remove1(a);
        }
        removeAt(a) {
            return this.f.remove(a);
        }
        set(a, b) {
            return this.f.set(a, b);
        }
        size() {
            return this.f.size();
        }
        get onChanged() {
            return this.f.f;
        }
        set onChanged(a) {
            this.f.f = a;
        }
        m(a) {
            this.f.addListener(a);
        }
        p(a) {
            this.f.removeListener(a);
        }
        get j() {
            return this.f.all;
        }
    }
    FilterExpressionCollection.$t = /*@__PURE__*/ markType(FilterExpressionCollection, 'FilterExpressionCollection');
    return FilterExpressionCollection;
})();
/**
 * @hidden
 */
let IDataSource_$type = /*@__PURE__*/ new Type(null, 'IDataSource', null, [ISupportsDataChangeNotifications_$type, IDataSourceSupportsIndexedAccess_$type]);
/**
 * @hidden
 */
let SummaryCalculator = /*@__PURE__*/ (() => {
    class SummaryCalculator extends Base {
        constructor() {
            super(...arguments);
            this._propertyName = null;
            this._propertyType = 0;
            this._dataSource = null;
            this._isSummaryDirty = false;
            this.f = 5;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get propertyType() {
            return this._propertyType;
        }
        set propertyType(a) {
            this._propertyType = a;
        }
        get dataSource() {
            return this._dataSource;
        }
        set dataSource(a) {
            this._dataSource = a;
        }
        get isSummaryDirty() {
            return this._isSummaryDirty;
        }
        set isSummaryDirty(a) {
            this._isSummaryDirty = a;
        }
        get_operand() {
            return this.f;
        }
        get operand() {
            return this.get_operand();
        }
        beginCalculation(a, b) {
            this.dataSource = a;
            this.propertyName = b;
            if (this.propertyName != null) {
                this.propertyType = a.resolveSchemaPropertyType(this.propertyName);
            }
            this.isSummaryDirty = false;
        }
        endCalculation() {
            return null;
        }
        aggregate(a) {
        }
        itemAdded(a, b, c) {
            return b;
        }
        itemRemoved(a, b, c) {
            return b;
        }
        i(a) {
            if (this.dataSource == null) {
                return NaN;
            }
            let b = this.dataSource.getItemProperty(a, this.propertyName);
            if (b == null) {
                return NaN;
            }
            return this.j(b);
        }
        j(a) {
            if (a == null) {
                return NaN;
            }
            switch (this.propertyType) {
                case 6: return a;
                case 5: return a;
                case 1: return typeGetValue(a);
                case 3: return typeGetValue(a);
                case 4: return typeGetValue(a);
                case 7: return a;
                case 8: return toOADate(a);
                case 11: try {
                    return Convert.toDouble3(a);
                }
                catch (b) {
                    return NaN;
                }
            }
            return 0;
        }
        k(a) {
            switch (this.propertyType) {
                case 6: return a;
                case 5: return a;
                case 1: return truncate(a);
                case 3: return truncate(a);
                case 4: return truncate(a);
                case 7: return a;
                case 8: return fromOADate(a);
                default: return a;
            }
        }
    }
    SummaryCalculator.$t = /*@__PURE__*/ markType(SummaryCalculator, 'SummaryCalculator');
    return SummaryCalculator;
})();
/**
 * @hidden
 */
let SumSummaryCalculator = /*@__PURE__*/ (() => {
    class SumSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = 0;
        }
        get_displayName() {
            let a = BaseDataSource.a9("DataSource_Summary_Sum");
            return a != null ? a : "Sum";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 2;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = 0;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 2, this.k(this.p));
        }
        aggregate(a) {
            let b = this.i(a);
            if (!isNaN_(b)) {
                this.p += b;
            }
        }
        itemAdded(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 2, this.k(d));
            }
            let e = this.j(b.value) + d;
            return new DefaultSummaryResult(this.propertyName, 2, this.k(e));
        }
        itemRemoved(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            let e = this.j(b.value) - d;
            return new DefaultSummaryResult(this.propertyName, 2, this.k(e));
        }
    }
    SumSummaryCalculator.$t = /*@__PURE__*/ markType(SumSummaryCalculator, 'SumSummaryCalculator', SummaryCalculator.$);
    return SumSummaryCalculator;
})();
/**
 * @hidden
 */
let CountSummaryCalculator = /*@__PURE__*/ (() => {
    class CountSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = 0;
        }
        get_displayName() {
            let a = BaseDataSource.a9("DataSource_Summary_Count");
            return a != null ? a : "Count";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 4;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.propertyType = 1;
            this.p = 0;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 4, this.p);
        }
        aggregate(a) {
            this.p++;
        }
        itemAdded(a, b, c) {
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 4, 1);
            }
            return new DefaultSummaryResult(this.propertyName, 4, typeGetValue(b.value) + 1);
        }
        itemRemoved(a, b, c) {
            return new DefaultSummaryResult(this.propertyName, 4, typeGetValue(b.value) - 1);
        }
    }
    CountSummaryCalculator.$t = /*@__PURE__*/ markType(CountSummaryCalculator, 'CountSummaryCalculator', SummaryCalculator.$);
    return CountSummaryCalculator;
})();
/**
 * @hidden
 */
let AverageSummaryCalculator = /*@__PURE__*/ (() => {
    class AverageSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = 0;
            this.q = 0;
        }
        get_displayName() {
            let a = BaseDataSource.a9("DataSource_Summary_Avg");
            return a != null ? a : "Avg";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 3;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = 0;
            this.q = 0;
        }
        endCalculation() {
            let a = this.q > 0 ? this.p / this.q : 0;
            return new DefaultSummaryResult(this.propertyName, 3, this.k(a));
        }
        aggregate(a) {
            let b = this.i(a);
            if (!isNaN_(b)) {
                this.p += b;
                this.q++;
            }
        }
        itemAdded(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 3, this.k(d));
            }
            let e = this.j(b.value) * (c - 1);
            let f = (e + d) / c;
            return new DefaultSummaryResult(this.propertyName, 3, this.k(f));
        }
        itemRemoved(a, b, c) {
            let d = this.i(a);
            if (isNaN_(d)) {
                d = 0;
            }
            let e = this.j(b.value) * (c + 1);
            let f = (e - d) / c;
            return new DefaultSummaryResult(this.propertyName, 3, this.k(f));
        }
    }
    AverageSummaryCalculator.$t = /*@__PURE__*/ markType(AverageSummaryCalculator, 'AverageSummaryCalculator', SummaryCalculator.$);
    return AverageSummaryCalculator;
})();
/**
 * @hidden
 */
let MaxSummaryCalculator = /*@__PURE__*/ (() => {
    class MaxSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = null;
        }
        get_displayName() {
            let a = BaseDataSource.a9("DataSource_Summary_Max");
            return a != null ? a : "Max";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 1;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = null;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 1, this.p);
        }
        aggregate(a) {
            this.p = this.q(a, this.p);
        }
        itemAdded(a, b, c) {
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 1, this.q(a, null));
            }
            let d = this.q(a, b.value);
            return new DefaultSummaryResult(this.propertyName, 1, d);
        }
        itemRemoved(a, b, c) {
            let d = this.dataSource.getItemProperty(a, this.propertyName);
            if (Base.equalsStatic(d, b.value)) {
                this.isSummaryDirty = true;
            }
            return b;
        }
        q(a, b) {
            let c = this.dataSource.getItemProperty(a, this.propertyName);
            if (b == null) {
                return c;
            }
            if (c == null) {
                return b;
            }
            switch (this.propertyType) {
                case 0:
                    b = stringCompare(c, b) > 0 ? c : b;
                    break;
                case 6:
                    b = c > b ? c : b;
                    break;
                case 5:
                    b = c > b ? c : b;
                    break;
                case 1:
                    b = typeGetValue(c) > typeGetValue(b) ? c : b;
                    break;
                case 3:
                    b = typeGetValue(c) > typeGetValue(b) ? c : b;
                    break;
                case 4:
                    b = typeGetValue(c) > typeGetValue(b) ? c : b;
                    break;
                case 7:
                    b = c > b ? c : b;
                    break;
                case 2:
                    b = c ? c : b;
                    break;
                case 10:
                    b = typeGetValue(c) > typeGetValue(b) ? c : b;
                    break;
                case 8:
                    let xVal_ = c;
                    let yVal_ = b;
                    xVal_ = +xVal_;
                    yVal_ = +yVal_;
                    let d = typeGetValue(xVal_);
                    let e = typeGetValue(yVal_);
                    b = Base.compareSimple(d, e) > 0 ? c : b;
                    break;
            }
            return b;
        }
    }
    MaxSummaryCalculator.$t = /*@__PURE__*/ markType(MaxSummaryCalculator, 'MaxSummaryCalculator', SummaryCalculator.$);
    return MaxSummaryCalculator;
})();
/**
 * @hidden
 */
let MinSummaryCalculator = /*@__PURE__*/ (() => {
    class MinSummaryCalculator extends SummaryCalculator {
        constructor() {
            super(...arguments);
            this.p = null;
        }
        get_displayName() {
            let a = BaseDataSource.a9("DataSource_Summary_Min");
            return a != null ? a : "Min";
        }
        get displayName() {
            return this.get_displayName();
        }
        get_operand() {
            return 0;
        }
        beginCalculation(a, b) {
            super.beginCalculation(a, b);
            this.p = null;
        }
        endCalculation() {
            return new DefaultSummaryResult(this.propertyName, 0, this.p);
        }
        aggregate(a) {
            this.p = this.q(a, this.p);
        }
        itemAdded(a, b, c) {
            if (b == null) {
                return new DefaultSummaryResult(this.propertyName, 0, this.q(a, null));
            }
            let d = this.q(a, b.value);
            return new DefaultSummaryResult(this.propertyName, 0, d);
        }
        itemRemoved(a, b, c) {
            let d = this.dataSource.getItemProperty(a, this.propertyName);
            if (Base.equalsStatic(d, b.value)) {
                this.isSummaryDirty = true;
            }
            return b;
        }
        q(a, b) {
            let c = this.dataSource.getItemProperty(a, this.propertyName);
            if (b == null) {
                return c;
            }
            if (c == null) {
                return b;
            }
            switch (this.propertyType) {
                case 0:
                    b = stringCompare(c, b) < 0 ? c : b;
                    break;
                case 6:
                    b = c < b ? c : b;
                    break;
                case 5:
                    b = c < b ? c : b;
                    break;
                case 1:
                    b = typeGetValue(c) < typeGetValue(b) ? c : b;
                    break;
                case 3:
                    b = typeGetValue(c) < typeGetValue(b) ? c : b;
                    break;
                case 4:
                    b = typeGetValue(c) < typeGetValue(b) ? c : b;
                    break;
                case 7:
                    b = c < b ? c : b;
                    break;
                case 2:
                    b = !c ? c : b;
                    break;
                case 10:
                    b = typeGetValue(c) < typeGetValue(b) ? c : b;
                    break;
                case 8:
                    let xVal_ = c;
                    let yVal_ = b;
                    xVal_ = +xVal_;
                    yVal_ = +yVal_;
                    let d = typeGetValue(xVal_);
                    let e = typeGetValue(yVal_);
                    b = Base.compareSimple(d, e) < 0 ? c : b;
                    break;
            }
            return b;
        }
    }
    MinSummaryCalculator.$t = /*@__PURE__*/ markType(MinSummaryCalculator, 'MinSummaryCalculator', SummaryCalculator.$);
    return MinSummaryCalculator;
})();
/**
 * @hidden
 */
let SummaryDescription = /*@__PURE__*/ (() => {
    class SummaryDescription extends Base {
        constructor(a, ..._rest) {
            super();
            this.h = false;
            this.k = null;
            this.f = 0;
            this.b = null;
            this.provideCalculator = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.propertyName = c;
                        this.operand = 4;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.propertyName = c;
                        this.operand = d;
                    }
                    break;
            }
        }
        get propertyName() {
            return this.k;
        }
        set propertyName(a) {
            this.k = a;
        }
        get operand() {
            return this.f;
        }
        set operand(a) {
            this.f = a;
            switch (this.f) {
                case 0:
                    this.calculator = new MinSummaryCalculator();
                    break;
                case 1:
                    this.calculator = new MaxSummaryCalculator();
                    break;
                case 2:
                    this.calculator = new SumSummaryCalculator();
                    break;
                case 3:
                    this.calculator = new AverageSummaryCalculator();
                    break;
                case 4:
                    this.calculator = new CountSummaryCalculator();
                    break;
            }
        }
        get calculator() {
            return this.b;
        }
        set calculator(a) {
            this.b = a;
        }
        equals(a) {
            let b = a;
            if (b == null) {
                return super.equals(a);
            }
            return b.propertyName == this.propertyName && b.operand == this.operand;
        }
        getHashCode() {
            return Base.getHashCodeStatic(this.propertyName) * 17 + this.operand;
        }
        m() {
            this.h = true;
        }
        e() {
            if (this.provideCalculator != null) {
                let a = new ProvideCalculatorEventArgs();
                this.provideCalculator(this, a);
                return a.a;
            }
            return null;
        }
        d() {
            switch (this.f) {
                case 0: return new MinSummaryCalculator();
                case 1: return new MaxSummaryCalculator();
                case 2: return new SumSummaryCalculator();
                case 3: return new AverageSummaryCalculator();
                case 4: return new CountSummaryCalculator();
                case 5:
                    let a = this.e();
                    if (a == null) {
                        throw new ArgumentNullException(2, "Calculator", "No custom calculator was provided.");
                    }
                    return a;
            }
            return null;
        }
    }
    SummaryDescription.$t = /*@__PURE__*/ markType(SummaryDescription, 'SummaryDescription');
    return SummaryDescription;
})();
/**
 * @hidden
 */
let SummaryDescriptionCollection = /*@__PURE__*/ (() => {
    class SummaryDescriptionCollection extends Base {
        constructor() {
            super();
            this.d = null;
            this.f = null;
            this.f = new SyncableObservableCollection$1(SummaryDescription.$);
        }
        g() {
            return this.f;
        }
        get syncTarget() {
            return this.d;
        }
        set syncTarget(a) {
            if (a == null) {
                this.f.syncTarget = null;
                this.d = null;
                return;
            }
            this.d = a;
            this.f.syncTarget = this.d.f;
        }
        add(a) {
            return this.f.add(a);
        }
        insert(a, b) {
            this.f.add1(a, b);
        }
        clear() {
            this.f.clear();
        }
        get(a) {
            return this.f.get(a);
        }
        indexOf(a) {
            return this.f.indexOf(a);
        }
        remove(a) {
            return this.f.remove1(a);
        }
        removeAt(a) {
            return this.f.remove(a);
        }
        set(a, b) {
            return this.f.set(a, b);
        }
        size() {
            return this.f.size();
        }
        n(a) {
            this.f.addListener(a);
        }
        q(a) {
            this.f.removeListener(a);
        }
        get onChanged() {
            return this.f.f;
        }
        set onChanged(a) {
            this.f.f = a;
        }
        get k() {
            return this.f.all;
        }
    }
    SummaryDescriptionCollection.$t = /*@__PURE__*/ markType(SummaryDescriptionCollection, 'SummaryDescriptionCollection');
    return SummaryDescriptionCollection;
})();
/**
 * @hidden
 */
let ProvideCalculatorEventArgs = /*@__PURE__*/ (() => {
    class ProvideCalculatorEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    ProvideCalculatorEventArgs.$t = /*@__PURE__*/ markType(ProvideCalculatorEventArgs, 'ProvideCalculatorEventArgs');
    return ProvideCalculatorEventArgs;
})();
/**
 * @hidden
 */
let BaseDataSource = /*@__PURE__*/ (() => {
    class BaseDataSource extends Base {
        constructor() {
            super();
            this.u = null;
            this._isReadOnly = false;
            this.z = false;
            this.dataCommitted = null;
            this.ao = false;
            this.ay = null;
            this._externalDataSource = null;
            this.s = null;
            this.r = null;
            this.i = null;
            this.t = null;
            this.j = null;
            this.o = null;
            this.as = 0;
            this.at = 0;
            this.au = 0;
            this.p = null;
            this.propertyChanged = null;
            this.l = null;
            this.n = null;
            this.schemaChanged = null;
            this.rowExpansionChanged = null;
            this.aa = false;
            this.h = 0;
            this.x = false;
            this.b = null;
            this.a = null;
            this.c = null;
            this.ag = false;
            this.ah = false;
            this.v = false;
            this.g = 0;
            this.ab = false;
            this.ad = true;
            this.y = false;
            this.af = false;
            this.ae = false;
            this.ac = true;
            this.aj = true;
            this.ai = false;
            this.ak = true;
            this.w = false;
            this.d = null;
            this.l = new DefaultDataSourceDataProviderUpdateNotifier(this);
            this.s = new SortDescriptionCollection();
            this.r = new SortDescriptionCollection();
            this.t = new SummaryDescriptionCollection();
            this.s.n(runOn(this, this.cr));
            this.r.n(runOn(this, this.bv));
            this.t.n(runOn(this, this.cs));
            this.i = new FilterExpressionCollection();
            this.i.m(runOn(this, this.bt));
            this.u = new TransactionService(runOn(this, this.bx), runOn(this, this.clone1), new TransactionKeyEqualityComparer());
            let a = this.u;
            a.stateChanged = delegateCombine(a.stateChanged, runOn(this, this.cn));
        }
        cn(a, b) {
            if (a == 0 || a == 1) {
                if (this.updateNotifier != null) {
                    let c = b;
                    let d = c.transactions._inner[0];
                    if (d.type == 1 || d.type == TransactionType.Delete) {
                        let e = d.id;
                        let f = this.indexOfKey(e);
                        if (f > -1) {
                            let g = this.getItemAtIndex(f);
                            this.updateNotifier.notifySetItem(f, g, g);
                            let h = this.getStickyRows();
                            if (h != null) {
                                for (let i = 0; i < h.length; i++) {
                                    let j = h[i];
                                    let k = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(j));
                                    if (k != null && k.rowType == 3 && k.targetRow == g) {
                                        this.updateNotifier.notifySetItem(j, k, k);
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    else if (d.type == 0) {
                    }
                }
            }
            this.cm(a, b);
        }
        cm(a, b) {
        }
        ap() {
            return !this.isReadOnly && this.actualPrimaryKey != null && this.actualBaseDataProvider != null && this.u != null;
        }
        bx(a, b) {
            if (a != null && b != null) {
                let c = a;
                let d = b;
                for (let e of fromEnum(d)) {
                    if (c.containsKey(e.key)) {
                        c.item(e.key, e.value);
                    }
                    else {
                        c.addItem(e.key, e.value);
                    }
                }
            }
        }
        clone1(a) {
            if (a != null) {
                let b = a;
                let c = new Dictionary$2(String_$type, Base.$, 0);
                for (let d of fromEnum(b)) {
                    c.addItem(d.key, d.value);
                }
                return c;
            }
            return null;
        }
        get isReadOnly() {
            return this._isReadOnly;
        }
        set isReadOnly(a) {
            this._isReadOnly = a;
        }
        get_isBatchingEnabled() {
            return this.z;
        }
        set_isBatchingEnabled(a) {
            this.z = a;
        }
        get isBatchingEnabled() {
            return this.get_isBatchingEnabled();
        }
        set isBatchingEnabled(a) {
            this.set_isBatchingEnabled(a);
        }
        get canUndo() {
            return this.u.k;
        }
        get canRedo() {
            return this.u.j;
        }
        get canCommit() {
            return this.u.a(-1).length > 0;
        }
        updatePropertyAtKey(a, b, c, d = false) {
            if (this.ap()) {
                let e = null;
                if (a.length == 1 && typeCast(DataSourceSpecialRow.$, a[0]) !== null) {
                    let f = typeCast(DataSourceSpecialRow.$, a[0]);
                    if (f.rowType == 3) {
                        e = f;
                        if (this.actualPrimaryKey != null) {
                            a = new Array(this.actualPrimaryKey.length);
                            this.getPrimaryKeyValue(e.targetRow, a);
                        }
                        else {
                            a = [e.targetRow];
                        }
                    }
                }
                let g = new Dictionary$2(String_$type, Base.$, 0);
                g.addItem(b, c);
                let h = new Transaction();
                h.id = a;
                h.value = g;
                h.type = 1;
                this.u.v(h, d);
                if (this.isBatchingEnabled || d) {
                    if (this.updateNotifier != null) {
                        let i = this.indexOfKey(a);
                        if (i > -1) {
                            let j = this.getItemAtIndex(i);
                            this.updateNotifier.notifySetItem(i, j, j);
                        }
                        if (this.isRowPinned(i)) {
                            let k = -1;
                            if (e != null) {
                                k = this.indexOfItem(e);
                            }
                            else {
                                let l = this.getStickyRows();
                                if (l != null) {
                                    for (let m = 0; m < l.length; m++) {
                                        let n = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(l[m]));
                                        if (n != null && n.rowType == 3) {
                                            e = n;
                                            k = l[m];
                                            break;
                                        }
                                    }
                                }
                            }
                            if (k > -1) {
                                this.updateNotifier.notifySetItem(k, e, e);
                            }
                        }
                    }
                }
                return h.transactionID;
            }
            return -1;
        }
        removeItemByKey(a) {
            if (this.ap()) {
                let b = null;
                if (a.length == 1 && typeCast(DataSourceSpecialRow.$, a[0]) !== null) {
                    let c = typeCast(DataSourceSpecialRow.$, a[0]);
                    if (c.rowType == 3) {
                        b = c;
                        if (this.actualPrimaryKey != null) {
                            a = new Array(this.actualPrimaryKey.length);
                            this.getPrimaryKeyValue(b.targetRow, a);
                        }
                        else {
                            a = [b.targetRow];
                        }
                    }
                }
                let d = new Transaction();
                d.id = a;
                d.type = TransactionType.Delete;
                this.u.v(d, false);
                if (this.isBatchingEnabled) {
                    if (this.updateNotifier != null) {
                        let e = this.indexOfKey(a);
                        if (e > -1) {
                            let f = this.getItemAtIndex(e);
                            this.updateNotifier.notifySetItem(e, f, f);
                        }
                        if (this.isRowPinned(e)) {
                            let g = -1;
                            if (b != null) {
                                g = this.indexOfItem(b);
                            }
                            else {
                                let h = this.getStickyRows();
                                if (h != null) {
                                    for (let i = 0; i < h.length; i++) {
                                        let j = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(h[i]));
                                        if (j != null && j.rowType == 3) {
                                            b = j;
                                            g = h[i];
                                            break;
                                        }
                                    }
                                }
                            }
                            if (g > -1) {
                                this.updateNotifier.notifySetItem(g, b, b);
                            }
                        }
                    }
                }
            }
        }
        removeItem(a) {
            if (this.ap()) {
                let b;
                if (typeCast(DataSourceSpecialRow.$, a) !== null) {
                    b = [a];
                }
                else if (this.actualPrimaryKey == null || this.actualPrimaryKey.length < 1) {
                    b = [a];
                }
                else {
                    b = new Array(this.actualPrimaryKey.length);
                    this.getPrimaryKeyValue(a, b);
                }
                this.removeItemByKey(b);
            }
        }
        addItem(a) {
            if (this.ap()) {
                if (typeCast(DataSourceSpecialRow.$, a) !== null) {
                    return;
                }
                let b = new Transaction();
                b.id = [a];
                b.type = 0;
                this.u.v(b, false);
            }
        }
        acceptPendingTransaction(a) {
            if (this.ap()) {
                let b = this.u.d(a);
                if (b != null) {
                    this.u.ap(a);
                }
            }
        }
        rejectPendingTransaction(a) {
            if (this.ap()) {
                let b = this.u.d(a);
                if (b != null) {
                    this.u.x(a);
                    if (this.updateNotifier != null) {
                        if (b.type != 0) {
                            let c = b.id;
                            let d = this.indexOfKey(c);
                            if (d > -1) {
                                let e = this.getItemAtIndex(d);
                                this.updateNotifier.notifySetItem(d, e, e);
                                let f = this.getStickyRows();
                                if (f != null) {
                                    for (let g = 0; g < f.length; g++) {
                                        let h = typeCast(DataSourceSpecialRow.$, this.getItemAtIndex(f[g]));
                                        if (h != null && h.rowType == 3) {
                                            if (h.targetRow == e) {
                                                this.updateNotifier.notifySetItem(f[g], h, h);
                                                break;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        commitEdits(a) {
            if (this.ap()) {
                let b = this.u.c(null).length > 0;
                let c = this.u.s(a, this.isBatchingEnabled);
                if (c == -1 && b) {
                    if (this.updateNotifier != null) {
                        this.updateNotifier.notifyClearItems();
                    }
                }
                return c;
            }
            return -1;
        }
        cancelEdits() {
            if (this.ap()) {
                this.u.w(true, null);
                if (this.updateNotifier != null) {
                    this.updateNotifier.notifyClearItems();
                }
            }
        }
        acceptPendingCommit(a) {
            if (this.ap()) {
                let b = this.u.e(a);
                if (b != null) {
                    this.u.u(a);
                    if (this.updateNotifier != null) {
                        for (let c = 0; c < b.a.length; c++) {
                            if (b.a[c].transactionType != 0) {
                                let d = b.a[c].id;
                                let e = this.indexOfKey(d);
                                if (e > -1) {
                                    let f = this.getItemAtIndex(e);
                                    this.updateNotifier.notifySetItem(e, f, f);
                                }
                            }
                        }
                    }
                }
            }
        }
        rejectPendingCommit(a) {
            if (this.ap()) {
                let b = this.u.e(a);
                if (b != null) {
                    this.u.ac(a);
                    if (this.updateNotifier != null) {
                        for (let c = 0; c < b.a.length; c++) {
                            if (b.a[c].transactionType != 0) {
                                let d = b.a[c].id;
                                let e = this.indexOfKey(d);
                                if (e > -1) {
                                    let f = this.getItemAtIndex(e);
                                    this.updateNotifier.notifySetItem(e, f, f);
                                }
                            }
                        }
                    }
                }
            }
        }
        undo() {
            if (this.ap()) {
                this.u.ae();
            }
        }
        redo() {
            if (this.ap()) {
                this.u.ab();
            }
        }
        hasEdit(a, b) {
            if (this.ap()) {
                a = this.f(a);
                let c = this.u.g(a);
                if (c != null) {
                    let d = typeCast(Dictionary$2.$.specialize(String_$type, Base.$), c.value);
                    if (d != null && d.containsKey(b)) {
                        return true;
                    }
                }
                c = this.u.ah(a);
                if (c != null) {
                    let e = typeCast(Dictionary$2.$.specialize(String_$type, Base.$), c.value);
                    if (e != null && e.containsKey(b)) {
                        return true;
                    }
                }
                c = this.u.ag(a);
                if (c != null) {
                    let f = typeCast(Dictionary$2.$.specialize(String_$type, Base.$), c.value);
                    if (f != null && f.containsKey(b)) {
                        return true;
                    }
                }
            }
            return false;
        }
        hasDelete(a) {
            if (this.ap()) {
                a = this.f(a);
                let b = this.u.g(a);
                if (b != null && b.transactionType == TransactionType.Delete) {
                    return true;
                }
                b = this.u.ah(a);
                if (b != null && b.transactionType == TransactionType.Delete) {
                    return true;
                }
                b = this.u.ag(a);
                if (b != null && b.transactionType == TransactionType.Delete) {
                    return true;
                }
            }
            return false;
        }
        hasAdd(a) {
            if (this.ap()) {
                let b = this.u.g(a);
                if (b != null && b.transactionType == 0) {
                    return true;
                }
                b = this.u.ah(a);
                if (b != null && b.transactionType == 0) {
                    return true;
                }
            }
            return false;
        }
        getAggregatedChanges(a) {
            if (this.ap()) {
                let b = this.u.a(a);
                let c = new List$1(DataSourceAggregatedResult.$, 0);
                for (let d = 0; d < b.length; d++) {
                    let e = b[d].id;
                    let f = new DataSourceAggregatedResult();
                    if (b[d].transactionType == 0) {
                        f.transactionType = 0;
                        f.item = e[0];
                    }
                    else if (b[d].transactionType == TransactionType.Delete) {
                        f.transactionType = TransactionType.Delete;
                        let g = this.indexOfKey(e);
                        if (g > -1) {
                            f.item = this.getItemAtIndex(g);
                        }
                        else {
                            f.item = e;
                        }
                    }
                    else if (b[d].transactionType == 1) {
                        f.transactionType = 1;
                        let h = b[d].value;
                        f.keys = new Array(h.count);
                        f.values = new Array(h.count);
                        let i = 0;
                        for (let j of fromEnum(h)) {
                            f.keys[i] = j.key;
                            f.values[i] = j.value;
                            i++;
                        }
                        let k = this.getItemFromKey(e);
                        if (k != null) {
                            f.item = k;
                        }
                        else {
                            f.item = e;
                        }
                    }
                    c.add(f);
                }
                return c.toArray();
            }
            return new Array(0);
        }
        isPendingTransaction(a) {
            return this.u.d(a) != null;
        }
        isPendingCommit(a) {
            return this.u.e(a) != null;
        }
        setTransactionError(a, b) {
            let c = this.u.d(a);
            if (c != null) {
                c.error = b;
                if (this.updateNotifier != null) {
                    let d = c.id;
                    let e = this.indexOfKey(d);
                    if (e > -1) {
                        let f = this.getItemAtIndex(e);
                        this.updateNotifier.notifySetItem(e, f, f);
                    }
                }
            }
        }
        getTransactionErrorByKey(a, b) {
            a = this.f(a);
            let c = this.u.c(a);
            for (let d = 0; d < c.length; d++) {
                if (c[d].error != null) {
                    if (c[d].type == 1) {
                        let e = c[d].value;
                        if (e.containsKey(b)) {
                            return c[d].error;
                        }
                    }
                }
            }
            return null;
        }
        getTransactionErrorByID(a) {
            let b = this.u.d(a);
            if (b != null) {
                return b.error;
            }
            return null;
        }
        getTransactionID(a, b) {
            a = this.f(a);
            let c = this.u.c(a);
            for (let d = 0; d < c.length; d++) {
                if (c[d].type == 1) {
                    let e = c[d].value;
                    if (e.containsKey(b)) {
                        return c[d].transactionID;
                    }
                }
            }
            return -1;
        }
        f(a) {
            if (a.length == 1 && typeCast(DataSourceSpecialRow.$, a[0]) !== null) {
                let b = typeCast(DataSourceSpecialRow.$, a[0]);
                if (b.rowType == 3) {
                    if (this.actualPrimaryKey != null) {
                        a = new Array(this.actualPrimaryKey.length);
                        this.getPrimaryKeyValue(b.targetRow, a);
                    }
                    else {
                        a = [b.targetRow];
                    }
                }
            }
            return a;
        }
        by(a, b) {
            if (this.dataCommitted != null) {
                this.dataCommitted(this, new DataSourceDataCommittedEventArgs(a, b));
            }
        }
        static a9(a) {
            let b = Localization.d("DataVisualization");
            let c = stringFormat("DataVisualization-{0}", b);
            return Localization.isRegistered(c) ? Localization.getString(c, a) : null;
        }
        cr(a, b) {
            this.onSortDescriptionsChanged(b);
        }
        bv(a, b) {
            this.onGroupDescriptionsChanged(b);
        }
        cs(a, b) {
            this.onSummaryDescriptionsChanged(b);
        }
        bt(a, b) {
            this.onFilterExpressionsChanged(b);
        }
        onSortDescriptionsChanged(a) {
            this.queueAutoRefresh();
        }
        onGroupDescriptionsChanged(a) {
            if (this.isGroupingSupported) {
                if (this.groupDescriptions != null && this.groupDescriptions.k.count > 0) {
                    this.ao = true;
                }
                else {
                    this.ao = false;
                }
                this.queueAutoRefresh();
            }
        }
        onSummaryDescriptionsChanged(a) {
            this.queueAutoRefresh();
        }
        onFilterExpressionsChanged(a) {
            this.queueAutoRefresh();
        }
        onRowExpansionChanged(a, b, c) {
            if (this.rowExpansionChanged != null) {
                this.rowExpansionChanged(this, new DataSourceRowExpansionChangedEventArgs(a, b, c));
            }
        }
        isPlaceholderItem(a) {
            return false;
        }
        get externalDataSource() {
            return this._externalDataSource;
        }
        set externalDataSource(a) {
            this._externalDataSource = a;
        }
        get actualSchema() {
            return this.o;
        }
        set actualSchema(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.onPropertyUpdated("ActualSchema", b, this.o);
            }
        }
        get actualCount() {
            return this.as;
        }
        set actualCount(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.onPropertyUpdated("ActualCount", b, this.as);
            }
        }
        get firstVisibleIndexRequested() {
            return this.at;
        }
        set firstVisibleIndexRequested(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.onPropertyUpdated("FirstVisibleIndexRequested", b, this.at);
            }
        }
        get lastVisibleIndexRequested() {
            return this.au;
        }
        set lastVisibleIndexRequested(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.onPropertyUpdated("LastVisibleIndexRequested", b, this.au);
            }
        }
        get updateNotifier() {
            return this.p;
        }
        set updateNotifier(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.onPropertyUpdated("UpdateNotifier", b, this.p);
            }
        }
        getItemAtIndex(a) {
            return null;
        }
        getItemFromKey(a) {
            return null;
        }
        getItemProperty(a, b) {
            if (this.actualBaseDataProvider != null) {
                let item_ = a;
                if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                    return this.getSpecialRowItemValue(a, b);
                }
                return this.actualBaseDataProvider.getItemValue(a, b);
            }
            return null;
        }
        getSpecialRowItemValue(a, b) {
            if (a.rowType == 3) {
                if (this.ap()) {
                    let c = this.a0(a.targetRow, b);
                    if (c != null) {
                        return c;
                    }
                }
                return this.getItemProperty(a.targetRow, b);
            }
            return a.getSectionValue(b);
        }
        a0(a, b) {
            let c;
            if (this.actualPrimaryKey == null || this.actualPrimaryKey.length < 1) {
                c = [a];
            }
            else {
                c = new Array(this.actualPrimaryKey.length);
                this.getPrimaryKeyValue(a, c);
            }
            let d = this.u.g(c);
            if (d != null && d.transactionType == 1) {
                let e = d.value;
                if (e.containsKey(b)) {
                    return e.item(b);
                }
            }
            d = this.u.ah(c);
            if (d != null && d.transactionType == 1) {
                let f = d.value;
                if (f.containsKey(b)) {
                    return f.item(b);
                }
            }
            d = this.u.ag(c);
            if (d != null && d.transactionType == 1) {
                let g = d.value;
                if (g.containsKey(b)) {
                    return g.item(b);
                }
            }
            return null;
        }
        am(a, b) {
            let c;
            if (this.actualPrimaryKey == null || this.actualPrimaryKey.length < 1) {
                c = [a];
            }
            else {
                c = new Array(this.actualPrimaryKey.length);
                this.getPrimaryKeyValue(a, c);
            }
            let d = this.u.g(c);
            if (d != null && d.transactionType == 1) {
                let e = d.value;
                if (e.containsKey(b)) {
                    return true;
                }
            }
            d = this.u.ah(c);
            if (d != null && d.transactionType == 1) {
                let f = d.value;
                if (f.containsKey(b)) {
                    return true;
                }
            }
            d = this.u.ag(c);
            if (d != null && d.transactionType == 1) {
                let g = d.value;
                if (g.containsKey(b)) {
                    return true;
                }
            }
            return false;
        }
        getItemPropertyAtIndex(a, b) {
            return null;
        }
        get_fullSectionInformationWillForceLoad() {
            return false;
        }
        get fullSectionInformationWillForceLoad() {
            return this.get_fullSectionInformationWillForceLoad();
        }
        onPropertyUpdated(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.propertyUpdatedOverride(a, b, c);
        }
        propertyUpdatedOverride(a, b, c) {
            switch (a) {
                case "PrimaryKey":
                    this.actualPrimaryKey = this.primaryKey;
                    break;
                case "ActualPrimaryKey":
                    this.onActualPrimaryKeyChanged(b, c);
                    break;
                case "ExecutionContext":
                    if (this.actualBaseDataProvider != null) {
                        this.actualBaseDataProvider.executionContext = this.executionContext;
                    }
                    this.queueAutoRefresh();
                    break;
                case "LastVisibleIndexRequested":
                case "FirstVisibleIndexRequested":
                    this.onRequestedVisibleRangeChanged();
                    break;
                case "ActualDataProvider":
                    this.onActualDataProviderChanged(b, c);
                    break;
                case "DeferAutoRefresh":
                    if (this.actualBaseDataProvider != null) {
                        this.actualBaseDataProvider.deferAutoRefresh = this.deferAutoRefresh;
                    }
                    if (!c) {
                        this.queueAutoRefresh();
                    }
                    break;
                case "PropertiesRequested":
                    if (this.actualBaseDataProvider != null) {
                        this.actualBaseDataProvider.propertiesRequested = this.propertiesRequested;
                    }
                    break;
                case "ShouldEmitSectionFooters":
                case "ShouldEmitSectionHeaders":
                case "ShouldEmitShiftedRows":
                case "SectionHeaderDisplayMode":
                case "IsSectionCollapsable":
                case "IncludeSummaryRowsInSection":
                case "IsSectionSummaryRowsAtBottom":
                case "IsSectionContentVisible":
                    this.queueAutoRefresh();
                    break;
                case "SummaryScope":
                    if (this.actualBaseDataProvider != null) {
                        this.actualBaseDataProvider.summaryScope = this.summaryScope;
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        onActualPrimaryKeyChanged(a, b) {
            this.onActualPrimaryKeyChangedOverrride(a, b);
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
        }
        get_isVirtual() {
            return false;
        }
        get isVirtual() {
            return this.get_isVirtual();
        }
        get dataProviderUpdateNotifier() {
            return this.l;
        }
        onActualDataProviderChanged(a, b) {
            let c = a;
            let d = b;
            if (c != null) {
                c.updateNotifier = null;
            }
            if (d != null) {
                d.updateNotifier = this.l;
            }
            if (c != null) {
                c.schemaChanged = delegateRemove(c.schemaChanged, runOn(this, this.bp));
            }
            if (d != null) {
                d.schemaChanged = delegateCombine(d.schemaChanged, runOn(this, this.bp));
                d.executionContext = this.executionContext;
                this.notifyUsingSourceIndexes = this.actualBaseDataProvider.notifyUsingSourceIndexes;
            }
            else {
                this.notifyUsingSourceIndexes = false;
            }
            if (c != null) {
                this.sortDescriptions.syncTarget = null;
                this.groupDescriptions.syncTarget = null;
                this.filterExpressions.syncTarget = null;
                this.summaryDescriptions.syncTarget = null;
            }
            if (d != null) {
                this.sortDescriptions.syncTarget = d.sortDescriptions;
                this.groupDescriptions.syncTarget = d.groupDescriptions;
                this.filterExpressions.syncTarget = d.filterExpressions;
                this.summaryDescriptions.syncTarget = d.summaryDescriptions;
                if (this.propertiesRequested != null) {
                    d.propertiesRequested = this.propertiesRequested;
                }
                d.summaryScope = this.summaryScope;
            }
            this.queueAutoRefresh();
        }
        onRequestedVisibleRangeChanged() {
        }
        get executionContext() {
            return this.n;
        }
        set executionContext(a) {
            let b = this.n;
            this.n = a;
            if (this.n != b) {
                this.onPropertyUpdated("ExecutionContext", b, this.n);
            }
        }
        canInitialize() {
            if (this.n != null && this.actualBaseDataProvider != null) {
                return true;
            }
            return false;
        }
        get isInitializing() {
            return this.aa;
        }
        get_isSortingSupported() {
            return false;
        }
        get isSortingSupported() {
            return this.get_isSortingSupported();
        }
        get_isFilteringSupported() {
            return false;
        }
        get isFilteringSupported() {
            return this.get_isFilteringSupported();
        }
        get sortDescriptions() {
            return this.s;
        }
        get groupDescriptions() {
            return this.r;
        }
        get filterExpressions() {
            return this.i;
        }
        get summaryDescriptions() {
            return this.t;
        }
        get summaryScope() {
            return this.h;
        }
        set summaryScope(a) {
            let b = this.h;
            this.h = a;
            if (this.h != b) {
                this.onPropertyUpdated("SummaryScope", enumGetBox(DataSourceSummaryScope_$type, b), enumGetBox(DataSourceSummaryScope_$type, this.h));
            }
        }
        get deferAutoRefresh() {
            return this.x;
        }
        set deferAutoRefresh(a) {
            let b = this.x;
            this.x = a;
            if (this.x != b) {
                this.onPropertyUpdated("DeferAutoRefresh", b, this.x);
            }
        }
        get primaryKey() {
            return this.b;
        }
        set primaryKey(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.onPropertyUpdated("PrimaryKey", b, this.b);
            }
        }
        get actualPrimaryKey() {
            return this.a;
        }
        set actualPrimaryKey(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.onPropertyUpdated("ActualPrimaryKey", b, this.a);
            }
        }
        get propertiesRequested() {
            return this.c;
        }
        set propertiesRequested(a) {
            let b = this.c;
            this.c = a;
            if (this.c != b) {
                this.onPropertyUpdated("PropertiesRequested", b, this.c);
            }
        }
        get notifyUsingSourceIndexes() {
            return this.ag;
        }
        set notifyUsingSourceIndexes(a) {
            let b = this.ag;
            this.ag = a;
            if (this.ag != b) {
                this.onPropertyUpdated("NotifyUsingSourceIndexes", b, this.ag);
            }
        }
        get_isItemIndexLookupSupported() {
            return false;
        }
        get isItemIndexLookupSupported() {
            return this.get_isItemIndexLookupSupported();
        }
        get_isKeyIndexLookupSupported() {
            return false;
        }
        get isKeyIndexLookupSupported() {
            return this.get_isKeyIndexLookupSupported();
        }
        initializeOverride() {
        }
        resolveFullCount(a) {
            return a;
        }
        bp(a, b) {
            let c = this.executionContext;
            c.execute(() => {
                this.ah = true;
                this.w = true;
                this.queueAutoRefresh();
                if (this.deferAutoRefresh) {
                    this.actualSchema = b.schema;
                    this.actualCount = this.resolveFullCount(b.count);
                    this.bz();
                }
            });
        }
        bz() {
            if (this.schemaChanged != null) {
                this.schemaChanged(this, new DataSourceSchemaChangedEventArgs(this.actualSchema, this.actualCount));
            }
        }
        onSetItem(a, b, c) {
            this.onSetItemOverride(a, b, c);
        }
        onBroadcastSetItem(a, b, c) {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifySetItem(a, b, c);
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastSetItem(a, b, c);
        }
        onClearItems() {
            this.onClearItemsOverride();
        }
        onBroadcastClearItems() {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyClearItems();
            }
        }
        onClearItemsOverride() {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastClearItems();
        }
        onInsertItem(a, b) {
            this.onInsertItemOverride(a, b);
        }
        onBroadcastInsertItem(a, b) {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyInsertItem(a, b);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastInsertItem(a, b);
        }
        onRemoveItem(a, b) {
            this.onRemoveItemOverride(a, b);
        }
        onBroadcastRemoveItem(a, b) {
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyRemoveItem(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            this.onBroadcastRemoveItem(a, b);
        }
        notifySetItem(a, b, c) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifySetItem(a, b, c);
            }
        }
        notifyClearItems() {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifyInsertItem(a, b);
            }
            ;
        }
        notifyRemoveItem(a, b) {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.notifyRemoveItem(a, b);
            }
            ;
        }
        queueAutoRefresh() {
            if (this.deferAutoRefresh) {
                return;
            }
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.queueAutoRefresh();
            }
            if (this.v) {
                return;
            }
            if (this.executionContext != null) {
                this.v = true;
                this.executionContext.enqueueAction(runOn(this, this.br));
            }
        }
        br() {
            if (this.deferAutoRefresh) {
                this.v = false;
                return;
            }
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.flushAutoRefresh();
            }
            if (!this.v) {
                return;
            }
            this.v = false;
            this.cp();
        }
        cp() {
            if (this.actualBaseDataProvider != null) {
                this.actualSchema = this.actualBaseDataProvider.actualSchema;
                this.actualCount = this.resolveFullCount(this.actualBaseDataProvider.actualCount);
            }
            if (this.actualSchema != null && this.primaryKey == null) {
                this.actualPrimaryKey = this.actualSchema.primaryKey;
            }
            this.refreshInternalOverride();
            if (this.ah) {
                this.ah = false;
                this.bz();
            }
        }
        refreshInternalOverride() {
        }
        flushAutoRefresh() {
            this.br();
        }
        refresh() {
            if (this.actualBaseDataProvider != null) {
                this.actualBaseDataProvider.refresh();
            }
            this.cp();
        }
        indexOfItem(a) {
            return -1;
        }
        indexOfKey(a) {
            return -1;
        }
        getPrimaryKeyValue(a, b) {
            let c = this.actualPrimaryKey;
            if (c == null || c.length < 1 || this.actualBaseDataProvider == null) {
                return;
            }
            for (let d = 0; d < c.length; d++) {
                b[d] = this.actualBaseDataProvider.getItemValue(a, c[d]);
            }
        }
        getRowType(a) {
            return 0;
        }
        getMainValuePath(a) {
            return "SectionInformation";
        }
        getStickyRows() {
            return this.getStickyRowsInRange(this.firstVisibleIndexRequested, this.lastVisibleIndexRequested);
        }
        getStickyRowsInRange(a, b) {
            return null;
        }
        isRowSpanning(a) {
            return a == 1 || a == 2;
        }
        getStickyRowPriority(a) {
            return -1;
        }
        isExclusivelySticky(a) {
            return false;
        }
        pinRow(a) {
        }
        unpinRow(a) {
        }
        clearPinnedRows() {
        }
        isRowPinned(a) {
            return false;
        }
        get_isGroupingSupported() {
            return false;
        }
        get isGroupingSupported() {
            return this.get_isGroupingSupported();
        }
        get_sectionHeaderDisplayMode() {
            return this.g;
        }
        set_sectionHeaderDisplayMode(a) {
            let b = this.g;
            this.g = a;
            if (b != this.g) {
                this.onPropertyUpdated("SectionHeaderDisplayMode", enumGetBox(DataSourceSectionHeaderDisplayMode_$type, b), enumGetBox(DataSourceSectionHeaderDisplayMode_$type, this.g));
            }
        }
        get sectionHeaderDisplayMode() {
            return this.get_sectionHeaderDisplayMode();
        }
        set sectionHeaderDisplayMode(a) {
            this.set_sectionHeaderDisplayMode(a);
        }
        get_isSectionCollapsable() {
            return this.ab;
        }
        set_isSectionCollapsable(a) {
            let b = this.ab;
            this.ab = a;
            if (this.ab != b) {
                this.onPropertyUpdated("IsSectionCollapsable", b, this.ab);
            }
        }
        get isSectionCollapsable() {
            return this.get_isSectionCollapsable();
        }
        set isSectionCollapsable(a) {
            this.set_isSectionCollapsable(a);
        }
        get_isSectionExpandedDefault() {
            return this.ad;
        }
        set_isSectionExpandedDefault(a) {
            this.ad = a;
        }
        get isSectionExpandedDefault() {
            return this.get_isSectionExpandedDefault();
        }
        set isSectionExpandedDefault(a) {
            this.set_isSectionExpandedDefault(a);
        }
        get_includeSummaryRowsInSection() {
            return this.y;
        }
        set_includeSummaryRowsInSection(a) {
            let b = this.y;
            this.y = a;
            if (this.y != b) {
                this.onPropertyUpdated("IncludeSummaryRowsInSection", b, this.y);
            }
        }
        get includeSummaryRowsInSection() {
            return this.get_includeSummaryRowsInSection();
        }
        set includeSummaryRowsInSection(a) {
            this.set_includeSummaryRowsInSection(a);
        }
        get_isSectionSummaryRowsAtBottom() {
            return this.af;
        }
        set_isSectionSummaryRowsAtBottom(a) {
            let b = this.af;
            this.af = a;
            if (this.af != b) {
                this.onPropertyUpdated("IsSectionSummaryRowsAtBottom", b, this.af);
            }
        }
        get isSectionSummaryRowsAtBottom() {
            return this.get_isSectionSummaryRowsAtBottom();
        }
        set isSectionSummaryRowsAtBottom(a) {
            this.set_isSectionSummaryRowsAtBottom(a);
        }
        get_isSectionHeaderNormalRow() {
            return this.ae;
        }
        set_isSectionHeaderNormalRow(a) {
            let b = this.ae;
            this.ae = a;
            if (this.ae != b) {
                this.onPropertyUpdated("IsSectionHeaderNormalRow", b, this.ae);
            }
        }
        get isSectionHeaderNormalRow() {
            return this.get_isSectionHeaderNormalRow();
        }
        set isSectionHeaderNormalRow(a) {
            this.set_isSectionHeaderNormalRow(a);
        }
        get_isSectionContentVisible() {
            return this.ac;
        }
        set_isSectionContentVisible(a) {
            let b = this.ac;
            this.ac = a;
            if (this.ac != b) {
                this.onPropertyUpdated("IsSectionContentVisible", b, this.ac);
            }
        }
        get isSectionContentVisible() {
            return this.get_isSectionContentVisible();
        }
        set isSectionContentVisible(a) {
            this.set_isSectionContentVisible(a);
        }
        get shouldEmitSectionHeaders() {
            return this.aj;
        }
        set shouldEmitSectionHeaders(a) {
            let b = this.aj;
            this.aj = a;
            if (this.aj != b) {
                this.onPropertyUpdated("ShouldEmitSectionHeaders", b, this.aj);
            }
        }
        get shouldEmitSectionFooters() {
            return this.ai;
        }
        set shouldEmitSectionFooters(a) {
            let b = this.ai;
            this.ai = a;
            if (this.ai != b) {
                this.onPropertyUpdated("ShouldEmitSectionFooters", b, this.ai);
            }
        }
        get shouldEmitShiftedRows() {
            return this.ak;
        }
        set shouldEmitShiftedRows(a) {
            let b = this.ak;
            this.ak = a;
            if (this.ak != b) {
                this.onPropertyUpdated("ShouldEmitShiftedRows", b, this.ak);
            }
        }
        ensureComparables(a) {
            if (this.w && this.actualCount > 0 && this.actualBaseDataProvider != null) {
                let b = null;
                this.d = this.e(a, b);
                this.w = false;
            }
        }
        e(a, b) {
            let c = new Array(a.propertyNames.length);
            return c;
        }
        resolveSchemaPropertyType(a) {
            return this.actualBaseDataProvider.resolveSchemaPropertyType(a);
        }
        setIsRowExpandedAtIndex(a, b) {
        }
        getIsRowExpandedAtIndex(a) {
            return true;
        }
        getRowLevel(a) {
            return 0;
        }
        getRootSummaryRowCount() {
            return 0;
        }
        getRootSummaryResults() {
            return null;
        }
        getSectionSummaryResults(a) {
            return null;
        }
        clone() {
            return null;
        }
        cloneProperties(a) {
            let b = typeCast(BaseDataSource.$, a);
            if (b != null) {
                b.executionContext = this.executionContext;
                b.includeSummaryRowsInSection = this.includeSummaryRowsInSection;
                b.isSectionCollapsable = this.isSectionCollapsable;
                b.isSectionExpandedDefault = this.isSectionExpandedDefault;
                b.isSectionHeaderNormalRow = this.isSectionHeaderNormalRow;
                b.isSectionSummaryRowsAtBottom = this.isSectionSummaryRowsAtBottom;
                b.isSectionContentVisible = this.isSectionContentVisible;
                b.primaryKey = this.primaryKey;
                b.propertiesRequested = this.propertiesRequested;
                b.sectionHeaderDisplayMode = this.sectionHeaderDisplayMode;
                b.shouldEmitSectionFooters = this.shouldEmitSectionFooters;
                b.shouldEmitSectionHeaders = this.shouldEmitSectionHeaders;
                b.shouldEmitShiftedRows = this.shouldEmitShiftedRows;
                b.summaryScope = this.summaryScope;
                for (let c = 0; c < this.groupDescriptions.k.count; c++) {
                    b.groupDescriptions.add(this.groupDescriptions.k.item(c));
                }
                for (let d = 0; d < this.sortDescriptions.k.count; d++) {
                    b.sortDescriptions.add(this.sortDescriptions.k.item(d));
                }
                for (let e = 0; e < this.filterExpressions.j.count; e++) {
                    b.filterExpressions.add(this.filterExpressions.j.item(e));
                }
                for (let f = 0; f < this.summaryDescriptions.k.count; f++) {
                    b.summaryDescriptions.add(this.summaryDescriptions.k.item(f));
                }
            }
        }
        getRowCount() {
            return this.actualCount;
        }
    }
    BaseDataSource.$t = /*@__PURE__*/ markType(BaseDataSource, 'BaseDataSource', Base.$, [IDataSource_$type, IEditableDataSource_$type]);
    return BaseDataSource;
})();
/**
 * @hidden
 */
let DefaultDataSourceDataProviderUpdateNotifier = /*@__PURE__*/ (() => {
    class DefaultDataSourceDataProviderUpdateNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifySetItem(a, b, c) {
            this.a.onSetItem(a, b, c);
        }
        notifyClearItems() {
            this.a.onClearItems();
        }
        notifyInsertItem(a, b) {
            this.a.onInsertItem(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.onRemoveItem(a, b);
        }
    }
    DefaultDataSourceDataProviderUpdateNotifier.$t = /*@__PURE__*/ markType(DefaultDataSourceDataProviderUpdateNotifier, 'DefaultDataSourceDataProviderUpdateNotifier', Base.$, [IDataSourceDataProviderUpdateNotifier_$type]);
    return DefaultDataSourceDataProviderUpdateNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function arrayClear1(array, index, length) {
    for (var i = index; i < index + length; i++) {
        array[i] = null;
    }
}
function arrayCopy1(source, sourceIndex, dest, destIndex, count) {
    var i;
    if (source == dest && sourceIndex < destIndex) {
        for (i = count - 1; i >= 0; i--) {
            dest[i + destIndex] = source[i + sourceIndex];
        }
    }
    else {
        for (i = 0; i < count; i++) {
            dest[i + destIndex] = source[i + sourceIndex];
        }
    }
}
function arrayCopy2(source, dest, count) {
    for (var i = 0; i < count; i++) {
        dest[i] = source[i];
    }
}
function arrayIndexOf1($t, array, value) {
    return array.indexOf(value);
}
function arrayContains(array, value) {
    for (var i = 0; i < array.length; i++) {
        if (Type.equalsStatic(array[i], value))
            return true;
    }
    return false;
}
function arrayLast(array) {
    return array[array.length - 1];
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class BinaryUtil {
    static isResponseTypeSupported(responseType) {
        var xhr = null;
        try {
            xhr = new XMLHttpRequest();
            xhr.open("GET", "/");
            xhr.responseType = responseType;
        }
        catch (e) {
            return false;
        }
        if (xhr === null) {
            return false;
        }
        return xhr.responseType === responseType;
    }
    static getBinary(url, callback, error) {
        var data, ret, req, useVbArray = false, arrayBufferSupported = BinaryUtil.isResponseTypeSupported("arraybuffer") &&
            typeof Uint8Array != "undefined";
        if (typeof XMLHttpRequest == "undefined") {
            try {
                req = new ActiveXObject("Msxml2.XMLHTTP.6.0");
            }
            catch (e) { }
            try {
                req = new ActiveXObject("Msxml2.XMLHTTP.3.0");
            }
            catch (e) { }
            req = new ActiveXObject("Microsoft.XMLHTTP");
        }
        else {
            req = new XMLHttpRequest();
        }
        if (!arrayBufferSupported) {
            if (req.overrideMimeType) {
                req.overrideMimeType("text/plain; charset=x-user-defined");
            }
        }
        if (typeof VBArray != "undefined") {
            useVbArray = true;
        }
        req.onreadystatechange = function () {
            if (req.readyState == 4) {
                let isFileSchemeDownload = false;
                if (req.status == 0) {
                    isFileSchemeDownload = new URL(url).protocol == "file:" ||
                        new URL(url).protocol == "igfile:";
                }
                if (req.status == 200 || isFileSchemeDownload) {
                    if (arrayBufferSupported && typeof this.response != "undefined") {
                        callback(new Uint8Array(this.response));
                    }
                    else {
                        if (useVbArray) {
                            data = new VBArray(req.responseBody).toArray();
                            for (var i = 0; i < data.length; i++) {
                                data[i] = String.fromCharCode(data[i]);
                            }
                            ret = data.join("");
                            callback(ret);
                        }
                        else {
                            callback(req.responseText);
                        }
                    }
                }
                else {
                    error(req.error);
                }
            }
        };
        req.open("GET", url, true);
        if (arrayBufferSupported) {
            req.responseType = "arraybuffer";
        }
        req.send(null);
    }
    ;
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function boolCompare(value, other) {
    if (value == other) {
        return 0;
    }
    return value ? 1 : -1;
}
function parseBool(s) {
    var r = tryParseBool(s);
    if (!r.ret) {
        throw new FormatException(1, "Incorrect boolean format");
    }
    return r.p1;
}
;
function tryParseBool(s, v) {
    switch (s == null ? "" : s.trim().toLowerCase()) {
        case "true":
            return {
                p1: true,
                ret: true
            };
        case "false":
            return {
                p1: false,
                ret: true
            };
        default:
            return {
                p1: false,
                ret: false
            };
    }
}
;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function boolToString(value, provider) {
    return value.toString();
}
;
function boolToInt16(value, provider) {
    return +value;
}
let boolToUInt16 = boolToInt16;
let boolToInt32 = boolToInt16;
let boolToInt64 = boolToInt16;
let boolToUInt64 = boolToInt16;
let boolToUInt32 = boolToInt16;
let boolToSingle = boolToInt16;
let boolToDouble = boolToInt16;
let boolToDecimal = boolToInt16;
function toBoolean(value, provider) {
    /*jshint -W018 */
    return !!+value;
}
function toString1(value, provider) {
    return value.toString();
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function getColorStringSafe(v) {
    /*jshint eqnull:true */
    return v == null ? null : v.colorString();
}
;
const wellKnownColors = {
    aliceblue: "f0f8ff",
    antiquewhite: "faebd7",
    aqua: "00ffff",
    aquamarine: "7fffd4",
    azure: "f0ffff",
    beige: "f5f5dc",
    bisque: "ffe4c4",
    black: "000000",
    blanchedalmond: "ffebcd",
    blue: "0000ff",
    blueviolet: "8a2be2",
    brown: "a52a2a",
    burlywood: "deb887",
    cadetblue: "5f9ea0",
    chartreuse: "7fff00",
    chocolate: "d2691e",
    coral: "ff7f50",
    cornflowerblue: "6495ed",
    cornsilk: "fff8dc",
    crimson: "dc143c",
    cyan: "00ffff",
    darkblue: "00008b",
    darkcyan: "008b8b",
    darkgoldenrod: "b8860b",
    darkgray: "a9a9a9",
    darkgreen: "006400",
    darkkhaki: "bdb76b",
    darkmagenta: "8b008b",
    darkolivegreen: "556b2f",
    darkorange: "ff8c00",
    darkorchid: "9932cc",
    darkred: "8b0000",
    darksalmon: "e9967a",
    darkseagreen: "8fbc8f",
    darkslateblue: "483d8b",
    darkslategray: "2f4f4f",
    darkturquoise: "00ced1",
    darkviolet: "9400d3",
    deeppink: "ff1493",
    deepskyblue: "00bfff",
    dimgray: "696969",
    dodgerblue: "1e90ff",
    feldspar: "d19275",
    firebrick: "b22222",
    floralwhite: "fffaf0",
    forestgreen: "228b22",
    fuchsia: "ff00ff",
    gainsboro: "dcdcdc",
    ghostwhite: "f8f8ff",
    gold: "ffd700",
    goldenrod: "daa520",
    gray: "808080",
    green: "008000",
    greenyellow: "adff2f",
    honeydew: "f0fff0",
    hotpink: "ff69b4",
    indianred: "cd5c5c",
    indigo: "4b0082",
    ivory: "fffff0",
    khaki: "f0e68c",
    lavender: "e6e6fa",
    lavenderblush: "fff0f5",
    lawngreen: "7cfc00",
    lemonchiffon: "fffacd",
    lightblue: "add8e6",
    lightcoral: "f08080",
    lightcyan: "e0ffff",
    lightgoldenrodyellow: "fafad2",
    lightgrey: "d3d3d3",
    lightgreen: "90ee90",
    lightpink: "ffb6c1",
    lightsalmon: "ffa07a",
    lightseagreen: "20b2aa",
    lightskyblue: "87cefa",
    lightslateblue: "8470ff",
    lightslategray: "778899",
    lightsteelblue: "b0c4de",
    lightyellow: "ffffe0",
    lime: "00ff00",
    limegreen: "32cd32",
    linen: "faf0e6",
    magenta: "ff00ff",
    maroon: "800000",
    mediumaquamarine: "66cdaa",
    mediumblue: "0000cd",
    mediumorchid: "ba55d3",
    mediumpurple: "9370d8",
    mediumseagreen: "3cb371",
    mediumslateblue: "7b68ee",
    mediumspringgreen: "00fa9a",
    mediumturquoise: "48d1cc",
    mediumvioletred: "c71585",
    midnightblue: "191970",
    mintcream: "f5fffa",
    mistyrose: "ffe4e1",
    moccasin: "ffe4b5",
    navajowhite: "ffdead",
    navy: "000080",
    oldlace: "fdf5e6",
    olive: "808000",
    olivedrab: "6b8e23",
    orange: "ffa500",
    orangered: "ff4500",
    orchid: "da70d6",
    palegoldenrod: "eee8aa",
    palegreen: "98fb98",
    paleturquoise: "afeeee",
    palevioletred: "d87093",
    papayawhip: "ffefd5",
    peachpuff: "ffdab9",
    peru: "cd853f",
    pink: "ffc0cb",
    plum: "dda0dd",
    powderblue: "b0e0e6",
    purple: "800080",
    red: "ff0000",
    rosybrown: "bc8f8f",
    royalblue: "4169e1",
    saddlebrown: "8b4513",
    salmon: "fa8072",
    sandybrown: "f4a460",
    seagreen: "2e8b57",
    seashell: "fff5ee",
    sienna: "a0522d",
    silver: "c0c0c0",
    skyblue: "87ceeb",
    slateblue: "6a5acd",
    slategray: "708090",
    snow: "fffafa",
    springgreen: "00ff7f",
    steelblue: "4682b4",
    tan: "d2b48c",
    teal: "008080",
    thistle: "d8bfd8",
    tomato: "ff6347",
    turquoise: "40e0d0",
    violet: "ee82ee",
    violetred: "d02090",
    wheat: "f5deb3",
    white: "ffffff",
    whitesmoke: "f5f5f5",
    yellow: "ffff00",
    yellowgreen: "9acd32"
};
function strToColor(str) {
    var ret = {
        a: 255,
        r: 0,
        g: 0,
        b: 0
    };
    var asColorName = str.replace(" ", "").toLowerCase();
    if (asColorName === "transparent") {
        return { a: 0, r: 0, g: 0, b: 0 };
    }
    if (wellKnownColors[asColorName] !== undefined) {
        str = wellKnownColors[asColorName];
    }
    var parts;
    if (str.lastIndexOf("rgba", 0) === 0) {
        str = str.replace("rgba", "").replace(" ", "").replace("(", "").replace(")", "");
        parts = str.split(",");
        ret.r = parseInt(parts[0], 10);
        ret.g = parseInt(parts[1], 10);
        ret.b = parseInt(parts[2], 10);
        ret.a = parseFloat(parts[3]) * 255.0;
    }
    else if (str.lastIndexOf("rgb", 0) === 0) {
        str = str.replace("rgb", "").replace(" ", "").replace("(", "").replace(")", "");
        parts = str.split(",");
        ret.r = parseInt(parts[0], 10);
        ret.g = parseInt(parts[1], 10);
        ret.b = parseInt(parts[2], 10);
    }
    else {
        str = str.replace("#", "").replace(" ", "");
        if (str.length === 8) {
            ret.r = parseInt(str.substr(0, 2), 16);
            ret.g = parseInt(str.substr(2, 2), 16);
            ret.b = parseInt(str.substr(4, 2), 16);
            ret.a = parseInt(str.substr(6, 2), 16);
        }
        else if (str.length === 6) {
            ret.r = parseInt(str.substr(0, 2), 16);
            ret.g = parseInt(str.substr(2, 2), 16);
            ret.b = parseInt(str.substr(4, 2), 16);
        }
        else if (str.length === 3) {
            ret.r = parseInt(str.substr(0, 1) + str.substr(0, 1), 16);
            ret.g = parseInt(str.substr(1, 1) + str.substr(1, 1), 16);
            ret.b = parseInt(str.substr(2, 1) + str.substr(2, 1), 16);
        }
    }
    return ret;
}
;
function rgbToHex(color) {
    /* Convert color from RGB to HEX format. null if non-rgb color is provided.
        paramType="string" optional="false" Color in RGB format.
        returnType="string|null" Returns converted color from RGB to HEX format. null if non-rgb color is provided.
    */
    var r, g, b, colHex = null;
    if (color.charAt(0) === "r") {
        let colorArr = color.replace("rgb(", "").replace(")", "").split(",");
        r = parseInt(colorArr[0], 10).toString(16);
        g = parseInt(colorArr[1], 10).toString(16);
        b = parseInt(colorArr[2], 10).toString(16);
        r = r.length === 1 ? "0" + r : r;
        g = g.length === 1 ? "0" + g : g;
        b = b.length === 1 ? "0" + b : b;
        colHex = "#" + r + g + b;
    }
    return colHex;
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Color = /*@__PURE__*/ (() => {
    class Color extends ValueType {
        constructor() {
            super();
            this._a = 0;
            this._r = 0;
            this._g = 0;
            this._b = 0;
            this._colorString = null;
            this.a = false;
        }
        get l() {
            return this._a;
        }
        set l(a) {
            this._a = truncate(Math.round(a));
            this.a = true;
        }
        get o() {
            return this._r;
        }
        set o(a) {
            this._r = truncate(Math.round(a));
            this.a = true;
        }
        get n() {
            return this._g;
        }
        set n(a) {
            this._g = truncate(Math.round(a));
            this.a = true;
        }
        get m() {
            return this._b;
        }
        set m(a) {
            this._b = truncate(Math.round(a));
            this.a = true;
        }
        get colorString() {
            if (this.a || this._colorString == null) {
                this.a = false;
                this.s();
            }
            return this._colorString;
        }
        set colorString(a) {
            this._colorString = a;
            this.r();
        }
        static create(a) {
            if (typeCast(Color.$, a) !== null) {
                return a;
            }
            let b = new Color();
            if (typeof a === 'string') {
                b.colorString = a;
            }
            else if (a != null) {
                throw new ArgumentException(1, "Unknown color type");
            }
            return b;
        }
        s() {
            this._colorString = "rgba(" + this._r + "," + this._g + "," + this._b + "," + this._a / 255 + ")";
        }
        r() {
            if (this.colorString == null) {
                this.l = this.o = this.n = this.m = 0;
                return;
            }
            let obj_ = strToColor(this._colorString);
            this._a = typeof obj_.a != 'undefined' ? Math.round(obj_.a) : 0;
            this._r = typeof obj_.r != 'undefined' ? Math.round(obj_.r) : 0;
            this._g = typeof obj_.g != 'undefined' ? Math.round(obj_.g) : 0;
            this._b = typeof obj_.b != 'undefined' ? Math.round(obj_.b) : 0;
            if (stringStartsWith(this._colorString, "#") && this._colorString.length == 9) {
                this.s();
            }
        }
        static u(a_, r_, g_, b_) {
            let a = new Color();
            a._a = (a_ | 0);
            a._r = (r_ | 0);
            a._g = (g_ | 0);
            a._b = (b_ | 0);
            a.a = true;
            return a;
        }
        equals(a) {
            if ((typeCast(Color.$, a) !== null) == false) {
                return false;
            }
            let b = a;
            return this._a == b._a && this._r == b._r && this._g == b._g && this._b == b._b;
        }
        getHashCode() {
            return (this._a << 24) | (this._r << 16) | (this._g << 8) | this._b;
        }
        static d(a, b) {
            return !(Color.b(a, b));
        }
        static e(a, b) {
            if (!a.hasValue) {
                return b.hasValue;
            }
            else if (!b.hasValue) {
                return true;
            }
            return Color.d(a.value, b.value);
        }
        static b(a, b) {
            return a._a == b._a && a._r == b._r && a._g == b._g && a._b == b._b;
        }
        static c(a, b) {
            if (!a.hasValue) {
                return !b.hasValue;
            }
            else if (!b.hasValue) {
                return false;
            }
            return Color.b(a.value, b.value);
        }
    }
    Color.$t = /*@__PURE__*/ markStruct(Color, 'Color');
    return Color;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GradientStop = /*@__PURE__*/ (() => {
    class GradientStop extends Base {
        constructor() {
            super();
            this.offset = 0;
            this._fill = null;
            this.d = null;
            this.g = new Color();
            this.offset = 0;
        }
        clone() {
            let a = new GradientStop();
            a.offset = this.offset;
            a._fill = this._fill;
            return a;
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get color() {
            if (this._fill == this.d) {
                return this.g;
            }
            let a = new Color();
            if (this._fill != null) {
                a.colorString = this._fill;
                this.g = a;
                this.d = this._fill;
            }
            return a;
        }
        set color(a) {
            this.g = a;
            this.d = this.g.colorString;
            this._fill = this.d;
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            return this.offset == b.offset && this.color.equals(b.color) && Base.equalsStatic(this._fill, b._fill);
        }
        getHashCode() {
            let a = (this.offset);
            if (Color.e(toNullable(Color.$, this.g), toNullable(Color.$, null))) {
                a ^= this.g.getHashCode();
            }
            return a;
        }
    }
    GradientStop.$t = /*@__PURE__*/ markType(GradientStop, 'GradientStop');
    return GradientStop;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Brush = /*@__PURE__*/ (() => {
    class Brush extends Base {
        constructor() {
            super(...arguments);
            this.isGradient = false;
            this.isRadialGradient = false;
            this.isImageFill = false;
            this._fill = null;
            this.f = null;
            this.k = new Color();
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get color() {
            if (this._fill == null && (this.isGradient || this.isRadialGradient)) {
                this._fill = this.i();
            }
            if (this._fill == this.f) {
                return this.k;
            }
            let a = new Color();
            if (this._fill != null) {
                a.colorString = this._fill;
                this.k = a;
                this.f = this._fill;
                if (this._fill.length == 9) {
                    this._fill = this.k.colorString;
                    this.f = this._fill;
                }
            }
            return a;
        }
        set color(a) {
            this.k = a;
            this.f = this.k.colorString;
            this._fill = this.f;
        }
        i() {
            return null;
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            return Base.equalsStatic(this._fill, b._fill) && this.color.equals(b.color) && this.isGradient == b.isGradient && this.isImageFill == b.isImageFill && this.isRadialGradient == b.isRadialGradient;
        }
        getHashCode() {
            let a = Base.getHashCodeStatic(this.isGradient) ^ Base.getHashCodeStatic(this.isRadialGradient) ^ Base.getHashCodeStatic(this.isImageFill);
            if (this.f != null) {
                a ^= Base.getHashCodeStatic(this.f);
            }
            if (Color.e(toNullable(Color.$, this.k), toNullable(Color.$, null))) {
                a ^= this.k.getHashCode();
            }
            return a;
        }
        static create(val_) {
            CssGradientUtil.touch();
            let b_ = new Brush();
            if (!val_) {
                return null;
            }
            if (typeof val_ == 'string') {
                if (CssGradientUtil.isGradient(val_)) {
                    b_ = CssGradientUtil.brushFromGradientString(val_);
                }
                else {
                    b_ = new Brush();
                    b_.fill = val_;
                }
            }
            else if (val_.type == 'linearGradient') {
                b_ = new LinearGradientBrush();
                if (val_.startPoint && val_.endPoint) {
                    b_.useCustomDirection = true;
                    b_.startX = val_.startPoint.x;
                    b_.startY = val_.startPoint.y;
                    b_.endX = val_.endPoint.x;
                    b_.endY = val_.endPoint.y;
                }
                if (val_.colorStops) {
                    let stops = [];
                    for (var i = 0; i < val_.colorStops.length; i++) {
                        let colorStop = new GradientStop();
                        colorStop.offset = val_.colorStops[i].offset;
                        colorStop.fill = val_.colorStops[i].color;
                        stops.push(colorStop);
                    }
                    b_.gradientStops = stops;
                }
            }
            ;
            return b_;
        }
    }
    Brush.$t = /*@__PURE__*/ markType(Brush, 'Brush');
    return Brush;
})();
/**
 * @hidden
 */
let LinearGradientBrush = /*@__PURE__*/ (() => {
    class LinearGradientBrush extends Brush {
        constructor() {
            super();
            this.useCustomDirection = false;
            this.startX = 0;
            this.startY = 0;
            this.endX = 0;
            this.endY = 0;
            this.isAbsolute = false;
            this.gradientStops = null;
            this.useCustomDirection = false;
            this.startX = 0;
            this.startY = 0;
            this.endX = 0;
            this.endY = 1;
            this.isAbsolute = false;
            this.gradientStops = new Array(0);
            this.isGradient = true;
        }
        clone() {
            let a = new LinearGradientBrush();
            a.startX = this.startX;
            a.startY = this.startY;
            a.endX = this.endX;
            a.endY = this.endY;
            a.useCustomDirection = this.useCustomDirection;
            a.isAbsolute = this.isAbsolute;
            if (this.gradientStops != null) {
                a.gradientStops = new Array(this.gradientStops.length);
                for (let b = 0; b < this.gradientStops.length; b++) {
                    a.gradientStops[b] = this.gradientStops[b].clone();
                }
            }
            return a;
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = typeCast(LinearGradientBrush.$, a);
            if (b == null) {
                return false;
            }
            let c = super.equals(a) && this.startX == b.startX && this.startY == b.startY && this.endX == b.endX && this.endY == b.endY && this.isAbsolute == b.isAbsolute && this.useCustomDirection == b.useCustomDirection;
            if (c == false) {
                return false;
            }
            if (this.gradientStops.length != b.gradientStops.length) {
                return false;
            }
            for (let d = 0, e = this.gradientStops.length; d < e; d++) {
                if (!this.gradientStops[d].equals(b.gradientStops[d])) {
                    return false;
                }
            }
            return true;
        }
        getHashCode() {
            return super.getHashCode() ^ (this.startX) ^ (this.startY) ^ (this.endX) ^ (this.endY);
        }
        i() {
            if (this.gradientStops != null && this.gradientStops.length > 0) {
                return this.gradientStops[0].color.colorString;
            }
            return super.i();
        }
    }
    LinearGradientBrush.$t = /*@__PURE__*/ markType(LinearGradientBrush, 'LinearGradientBrush', Brush.$);
    return LinearGradientBrush;
})();
/**
 * @hidden
 */
let CssGradientUtil = /*@__PURE__*/ (() => {
    class CssGradientUtil extends Base {
        static touch() {
        }
        static isGradient(a) {
            return stringContains(a, "linear-gradient") || stringContains(a, "radial-gradient");
        }
        static brushFromGradientString(a) {
            let b = (/hsl\([\s\S]+?\)[\s\S]*?[,\)]|rgba?\([\s\S]+?\)[\s\S]*?[,\)]|[^\(\)]*?[,\)]/gim), c = (/\s*\d*%\s*$/), d = (/^\s\s*/), e = (/\s\s*$/), f = (/[,\)]?$/);
            let g;
            let h, i = 1, j = 0, k, l;
            let m = false;
            let n;
            let o = a.match(b);
            if (o == null || o.length <= 1) {
                return null;
            }
            let p = new LinearGradientBrush();
            k = o.length;
            g = o[0];
            if (stringContains(g, "to") || stringContains(g, "deg")) {
                h = CssGradientUtil.c(g);
                p.useCustomDirection = true;
                let q = CssGradientUtil.a(h);
                p.startX = q[0].x;
                p.startY = q[0].y;
                p.endX = q[1].x;
                p.endY = q[1].y;
                n = new Array(k - 1);
            }
            else {
                n = new Array(k);
                i = 0;
            }
            for (; i < k; i++) {
                let r = new GradientStop();
                g = o[i];
                g = g.replace(d, "").replace(e, "").replace(f, "");
                l = g.search(c);
                if (l != -1) {
                    r._fill = g.substr(0, l);
                    r.offset = parseFloat(g.substr(l + 1)) / 100;
                }
                else {
                    r._fill = g;
                    r.offset = -1;
                    m = true;
                }
                n[j] = r;
                j++;
            }
            if (m) {
                if (n[0].offset == -1) {
                    n[0].offset = 0;
                }
                if (n[n.length - 1].offset == -1) {
                    n[n.length - 1].offset = 1;
                }
                CssGradientUtil.f(n);
            }
            p.gradientStops = n;
            return p;
        }
        static f(a) {
            let b, c, d, e, f = -1, g = -1, h = 0;
            let i = false;
            for (b = g + 1; b < a.length; b++) {
                let j = a[b];
                if (j.offset != -1) {
                    f = Math.max(f, j.offset);
                    j.offset = f;
                    if (i) {
                        d = 1;
                        e = intDivide((f - h), (b - g));
                        for (c = g + 1; c < b; c++) {
                            a[c].offset = h + e * d;
                            d++;
                        }
                        i = false;
                    }
                    g = b;
                    h = f;
                }
                else {
                    i = true;
                }
            }
        }
        static c(a) {
            let b = (/to\s*top\s*/i), c = (/to\s*right\s*top\s*/i), d = (/to\s*right\s*/i), e = (/to\s*right\s*bottom\s*/i), f = (/to\s*bottom\s*/i), g = (/to\s*left\s*bottom\s*/i), h = (/to\s*left\s*/i), i = (/to\s*left\s*top\s*/i);
            if (stringContains(a, "deg")) {
                return parseFloat(a);
            }
            if (b.test(a)) {
                return 0;
            }
            if (c.test(a)) {
                return 45;
            }
            if (d.test(a)) {
                return 90;
            }
            if (e.test(a)) {
                return 135;
            }
            if (f.test(a)) {
                return 180;
            }
            if (g.test(a)) {
                return 225;
            }
            if (h.test(a)) {
                return 270;
            }
            return i.test(a) ? 315 : 180;
        }
        static d(a) {
            return Math.PI * a / 180;
        }
        static e(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static a(a) {
            let b = new Array(2);
            let c = PointUtil.create();
            let d = PointUtil.create();
            let e = CssGradientUtil.e(a);
            if (e >= 0 && e <= 45) {
                let f = Math.tan(CssGradientUtil.d(e));
                c.x = 0.5 - 0.5 * f;
                c.y = 1;
                d.x = 0.5 + 0.5 * f;
                d.y = 0;
            }
            else if (e > 180 && e <= 225) {
                let g = Math.tan(CssGradientUtil.d(e - 180));
                c.x = 0.5 + 0.5 * g;
                c.y = 0;
                d.x = 0.5 - 0.5 * g;
                d.y = 1;
            }
            else if (e > 135 && e <= 180) {
                let h = Math.tan(CssGradientUtil.d(180 - e));
                c.x = 0.5 - 0.5 * h;
                c.y = 0;
                d.x = 0.5 + 0.5 * h;
                d.y = 1;
            }
            else if (e > 315 && e < 360) {
                let i = Math.tan(CssGradientUtil.d(360 - e));
                c.x = 0.5 + 0.5 * i;
                c.y = 1;
                d.x = 0.5 - 0.5 * i;
                d.y = 0;
            }
            else if (e > 45 && e <= 90) {
                let j = Math.tan(CssGradientUtil.d(90 - e));
                d.y = 0.5 - 0.5 * j;
                d.x = 1;
                c.y = 0.5 + 0.5 * j;
                c.x = 0;
            }
            else if (e > 90 && e <= 135) {
                let k = Math.tan(CssGradientUtil.d(e - 90));
                d.y = 0.5 + 0.5 * k;
                d.x = 1;
                c.y = 0.5 - 0.5 * k;
                c.x = 0;
            }
            else if (e > 225 && e <= 270) {
                let l = Math.tan(CssGradientUtil.d(270 - e));
                c.y = 0.5 - 0.5 * l;
                c.x = 1;
                d.y = 0.5 + 0.5 * l;
                d.x = 0;
            }
            else if (e > 270 && e <= 315) {
                let m = Math.tan(CssGradientUtil.d(e - 270));
                c.y = 0.5 + 0.5 * m;
                c.x = 1;
                d.y = 0.5 - 0.5 * m;
                d.x = 0;
            }
            b[0] = c;
            b[1] = d;
            return b;
        }
    }
    CssGradientUtil.$t = /*@__PURE__*/ markType(CssGradientUtil, 'CssGradientUtil');
    return CssGradientUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Size = /*@__PURE__*/ (() => {
    class Size extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.i = 0;
            this.h = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.i = c;
                        this.h = d;
                    }
                    break;
            }
        }
        equals(a) {
            if (a == null) {
                return super.equals(a);
            }
            let b = a;
            return b.i == this.i && b.h == this.h;
        }
        getHashCode() {
            return (this.i) ^ (this.h);
        }
        get width() {
            return this.i;
        }
        set width(a) {
            this.i = a;
        }
        get height() {
            return this.h;
        }
        set height(a) {
            this.h = a;
        }
        get isEmpty() {
            return this.i < 0;
        }
        static get empty() {
            let a = new Size(0);
            a.i = Number.NEGATIVE_INFINITY;
            a.h = Number.NEGATIVE_INFINITY;
            return a;
        }
        static l_op_Inequality(a, b) {
            return !(Size.l_op_Equality(a, b));
        }
        static l_op_Inequality_Lifted(a, b) {
            if (!a.hasValue) {
                return b.hasValue;
            }
            else if (!b.hasValue) {
                return true;
            }
            return Size.l_op_Inequality(a.value, b.value);
        }
        static l_op_Equality(a, b) {
            return a.i == b.i && a.h == b.h;
        }
        static l_op_Equality_Lifted(a, b) {
            if (!a.hasValue) {
                return !b.hasValue;
            }
            else if (!b.hasValue) {
                return false;
            }
            return Size.l_op_Equality(a.value, b.value);
        }
    }
    Size.$t = /*@__PURE__*/ markStruct(Size, 'Size');
    return Size;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Rect = /*@__PURE__*/ (() => {
    class Rect extends Base {
        constructor(a, ..._rest) {
            super();
            this.s = 0;
            this.t = 0;
            this.r = 0;
            this.n = 0;
            this.q = 0;
            this.o = 0;
            this.p = 0;
            this.m = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.top = d;
                        this.left = c;
                        this.width = e;
                        this.height = f;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.top = d;
                        this.left = c;
                        this.width = e.width;
                        this.height = e.height;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.top = Math.min(c.y, d.y);
                        this.left = Math.min(c.x, d.x);
                        this.width = Math.max(Math.max(c.x, d.x) - this.left, 0);
                        this.height = Math.max(Math.max(c.y, d.y) - this.top, 0);
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.top = c.y;
                        this.left = c.x;
                        this.width = d.width;
                        this.height = d.height;
                    }
                    break;
                case 4:
                    {
                        this.top = 0;
                        this.left = 0;
                        this.width = 0;
                        this.height = 0;
                    }
                    break;
            }
        }
        get x() {
            return this.s;
        }
        set x(a) {
            this.s = a;
            this.o = this.s;
            this.p = this.o + this.r;
        }
        get y() {
            return this.t;
        }
        set y(a) {
            this.t = a;
            this.q = this.t;
            this.m = this.q + this.n;
        }
        get width() {
            return this.r;
        }
        set width(a) {
            this.r = a;
            this.p = this.o + this.r;
        }
        get height() {
            return this.n;
        }
        set height(a) {
            this.n = a;
            this.m = this.q + this.n;
        }
        get top() {
            return this.q;
        }
        set top(a) {
            this.q = a;
            this.y = this.q;
        }
        get left() {
            return this.o;
        }
        set left(a) {
            this.o = a;
            this.x = this.o;
        }
        get right() {
            return this.p;
        }
        set right(a) {
            this.p = a;
            this.r = this.p - this.o;
        }
        get bottom() {
            return this.m;
        }
        set bottom(a) {
            this.m = a;
            this.n = this.m - this.q;
        }
        get isEmpty() {
            return this.r < 0;
        }
        static get empty() {
            return new Rect(0, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY);
        }
        equals1(a) {
            if (Rect.l_op_Equality(a, null)) {
                return false;
            }
            if (a.x == this.x && a.y == this.y && a.width == this.width && a.height == this.height) {
                return true;
            }
            return false;
        }
        d(a, b) {
            return a >= this.s && a - this.r <= this.s && b >= this.t && b - this.n <= this.t;
        }
        containsLocation(a, b) {
            return !this.isEmpty && this.d(a, b);
        }
        containsPoint(a) {
            return this.containsLocation(a.x, a.y);
        }
        containsRect(a) {
            return !this.isEmpty && !a.isEmpty && (this.s <= a.s && this.t <= a.t && this.s + this.r >= a.s + a.r) && this.t + this.n >= a.t + a.n;
        }
        inflate(a, b) {
            this.x -= a;
            this.y -= b;
            this.width += a * 2;
            this.height += b * 2;
            if (this.r < 0 || this.n < 0) {
                this.af();
            }
        }
        af() {
            this.top = Number.POSITIVE_INFINITY;
            this.left = Number.POSITIVE_INFINITY;
            this.width = Number.NEGATIVE_INFINITY;
            this.height = Number.NEGATIVE_INFINITY;
        }
        intersectsWith(a) {
            if (this.isEmpty || a.isEmpty) {
                return false;
            }
            return a.left < this.right && this.left < a.right && a.top < this.bottom && this.top < a.bottom;
        }
        intersect(a) {
            if (!this.intersectsWith(a)) {
                this.af();
            }
            else {
                let b = Math.max(this.x, a.x);
                let c = Math.max(this.y, a.y);
                let d = Math.min(this.x + this.width, a.x + a.width) - b;
                let e = Math.min(this.y + this.height, a.y + a.height) - c;
                if (d < 0) {
                    d = 0;
                }
                if (e < 0) {
                    e = 0;
                }
                this.r = d;
                this.n = e;
                this.s = b;
                this.t = c;
                this.o = this.s;
                this.q = this.t;
                this.p = this.o + this.r;
                this.m = this.q + this.n;
            }
        }
        union(a) {
            if (this.isEmpty) {
                this.s = a.x;
                this.t = a.y;
                this.r = a.width;
                this.n = a.height;
                this.o = this.s;
                this.q = this.t;
                this.p = this.o + this.r;
                this.m = this.q + this.n;
                return;
            }
            if (!a.isEmpty) {
                let b = Math.min(this.x, a.x);
                let c = Math.min(this.y, a.y);
                let d = this.width;
                let e = this.height;
                if (a.width == Number.POSITIVE_INFINITY || this.width == Number.POSITIVE_INFINITY) {
                    d = Number.POSITIVE_INFINITY;
                }
                else {
                    let f = Math.max(this.right, a.right);
                    d = f - b;
                }
                if (a.height == Number.POSITIVE_INFINITY || this.height == Number.POSITIVE_INFINITY) {
                    e = Number.POSITIVE_INFINITY;
                }
                else {
                    let g = Math.max(this.bottom, a.bottom);
                    e = g - c;
                }
                this.s = b;
                this.t = c;
                this.r = d;
                this.n = e;
                this.o = this.s;
                this.q = this.t;
                this.p = this.o + this.r;
                this.m = this.q + this.n;
            }
        }
        equals(a) {
            if (a == null) {
                return super.equals(a);
            }
            let b = a;
            return b.left == this.left && b.top == this.top && b.width == this.width && b.height == this.height;
        }
        getHashCode() {
            return (this.s) ^ (this.t) ^ (this.r) ^ (this.n);
        }
        copy() {
            return new Rect(0, this.x, this.y, this.width, this.height);
        }
        static l_op_Equality(a, b) {
            if (a == null) {
                return b == null;
            }
            else if (b == null) {
                return false;
            }
            return a.s == b.s && a.t == b.t && a.r == b.r && a.n == b.n;
        }
        static l_op_Inequality(a, b) {
            if (a == null) {
                return b != null;
            }
            else if (b == null) {
                return true;
            }
            return a.s != b.s || a.t != b.t || a.r != b.r || a.n != b.n;
        }
    }
    Rect.$t = /*@__PURE__*/ markType(Rect, 'Rect');
    return Rect;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushCollection = /*@__PURE__*/ (() => {
    class BrushCollection extends ObservableCollection$1 {
        constructor() {
            super(Brush.$, 0);
            this.ae = 0;
        }
        ai() {
            return this.item(BrushCollection.ag.next1(this.count));
        }
        get af() {
            return this.ae;
        }
        set af(a) {
            if (this.ae != a) {
                this.ae = a;
                this.ac(new NotifyCollectionChangedEventArgs(0, 4));
            }
        }
        item(a, b) {
            if (arguments.length === 2) {
                super.item(a, b);
                return b;
            }
            else {
                if (a < 0 || a >= this.count) {
                    return null;
                }
                return super.item(a);
            }
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            if (b.count != this.count) {
                return false;
            }
            for (let c = 0; c < b.count; c++) {
                if (!b.item(c).equals(this.item(c))) {
                    return false;
                }
            }
            return true;
        }
    }
    BrushCollection.$t = /*@__PURE__*/ markType(BrushCollection, 'BrushCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Brush.$));
    BrushCollection.ag = /*@__PURE__*/ new Random(0);
    return BrushCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObservableColorCollection = /*@__PURE__*/ (() => {
    class ObservableColorCollection extends ObservableCollection$1 {
        constructor() {
            super(Color.$, 0);
            this.ae = 0;
        }
        get af() {
            return this.ae;
        }
        set af(a) {
            if (this.ae != a) {
                this.ae = a;
                this.ac(new NotifyCollectionChangedEventArgs(0, 4));
            }
        }
        equals(a) {
            if (a == null) {
                return false;
            }
            let b = a;
            if (b.count != this.count) {
                return false;
            }
            for (let c = 0; c < b.count; c++) {
                if (!b._inner[c].equals(this._inner[c])) {
                    return false;
                }
            }
            return true;
        }
        static ag(a) {
            let b = new ObservableColorCollection();
            for (let c of fromEnum(a)) {
                let d = new Color();
                d.colorString = c;
                b.add(d);
            }
            return b;
        }
    }
    ObservableColorCollection.$t = /*@__PURE__*/ markType(ObservableColorCollection, 'ObservableColorCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Color.$));
    return ObservableColorCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function brushToString(v) {
    if (v == null) {
        return null;
    }
    return v.fill;
}
function stringToBrush(v) {
    if (v == null) {
        return null;
    }
    let brush = Brush.create(v);
    return brush;
}
function ensureEnum($t, v) {
    if (v == null) {
        return 0;
    }
    if (typeof v == "number") {
        let n = v;
        if (EnumUtil.getName($t, n) == undefined) {
            return 0;
        }
        return v;
    }
    let ret = typeGetValue(EnumUtil.parse($t, v, true));
    return ret;
}
function enumToString($t, v) {
    return EnumUtil.toString($t, v);
}
function ensureBool(v) {
    if (v == null) {
        return false;
    }
    if (typeof v == "boolean") {
        return v;
    }
    return v.toString().toLowerCase() == "true";
}
function colorToString(v) {
    if (v == null) {
        return null;
    }
    return v.colorString;
}
function stringToColor(v) {
    if (v == null) {
        return null;
    }
    let brush = Brush.create(v);
    return brush.color;
}
function fromSize(v) {
    if (v == null) {
        return null;
    }
    return {
        width: v.width,
        height: v.height
    };
}
function sizeToString(v) {
    if (!v) {
        return null;
    }
    return v.width + " " + v.height;
}
function toSize(v) {
    if (v == null) {
        return Size.empty;
    }
    let size = null;
    if (typeof v == "string") {
        v = v.trim();
        let parts = v.split(" ");
        if (parts.length != 2) {
            parts = v.split(",");
        }
        if (parts.length != 2) {
            return Size.empty;
        }
        parts[0] = parts[0].trim();
        parts[1] = parts[1].trim();
        let width = parseFloat(parts[0]);
        let height = parseFloat(parts[1]);
        return new Size(0, width, height);
    }
    else {
        if (v != null) {
            size = new Size(0, v.width, v.height);
        }
    }
    return size;
}
function fromPoint(v) {
    return v;
}
function pointToString(v) {
    if (!v) {
        return null;
    }
    return v.x + " " + v.y;
}
function toPoint(v) {
    if (v == null) {
        return PointUtil.createXY(NaN, NaN);
    }
    let point = null;
    if (typeof v == "string") {
        v = v.trim();
        let parts = v.split(" ");
        if (parts.length != 2) {
            parts = v.split(",");
        }
        if (parts.length != 2) {
            return PointUtil.createXY(NaN, NaN);
        }
        parts[0] = parts[0].trim();
        parts[1] = parts[1].trim();
        let x = parseFloat(parts[0]);
        let y = parseFloat(parts[1]);
        return PointUtil.createXY(x, y);
    }
    else {
        if (v != null) {
            point = PointUtil.createXY(v.x, v.y);
        }
    }
    return point;
}
function fromRect(v) {
    if (v == null) {
        return null;
    }
    return {
        top: v.top,
        left: v.left,
        width: v.width,
        height: v.height
    };
}
function rectToString(v) {
    if (!v) {
        return null;
    }
    return v.left + " " + v.top + " " + v.width + " " + v.height;
}
function toRect(v) {
    if (v == null) {
        return Rect.empty;
    }
    let size = null;
    if (typeof v == "string") {
        let parts = v.split(" ");
        if (parts.length != 4) {
            parts = v.split(",");
        }
        if (parts.length != 4) {
            return Rect.empty;
        }
        parts[0] = parts[0].trim();
        parts[1] = parts[1].trim();
        parts[2] = parts[2].trim();
        parts[3] = parts[3].trim();
        let left = parseFloat(parts[0]);
        let top = parseFloat(parts[1]);
        let width = parseFloat(parts[2]);
        let height = parseFloat(parts[3]);
        return new Rect(0, left, top, width, height);
    }
    else {
        if (v != null) {
            size = new Rect(0, v.left, v.top, v.width, v.height);
        }
    }
    return size;
}
function brushCollectionToString(v) {
    let bArray = fromBrushCollection(v);
    if (bArray == null) {
        return null;
    }
    return bArray.join(" ");
}
function toBrushCollection(v) {
    if (v == null) {
        return null;
    }
    let isRGB = true;
    if (typeof v == "string") {
        v = v.trim();
        v = v.split(/[\s,]+(?![^(]*\))/gm);
        for (let i = 0; i < v.length; i++) {
            v[i] = v[i].trim();
        }
    }
    let val = v ? v[0] : null;
    if (typeof val == 'string' && val == 'HSV' || val == 'RGB') {
        if (v[0] == 'HSV') {
            isRGB = false;
        }
        v = v.slice(1);
    }
    let brushCollection = new BrushCollection();
    for (var i = 0; v && i < v.length; i++) {
        let brush = Brush.create(v[i]);
        brushCollection.add(brush);
    }
    return brushCollection;
}
function fromBrushCollection(v) {
    if (v == null) {
        return null;
    }
    let internalCollection = v;
    let ret = [];
    for (let i = 0; i < internalCollection.count; i++) {
        ret.push(internalCollection.item(i).fill);
    }
    return ret;
}
function colorCollectionToString(v) {
    let bArray = fromColorCollection(v);
    if (bArray == null) {
        return null;
    }
    return bArray.join(" ");
}
function toColorCollection(v) {
    if (v == null) {
        return null;
    }
    let isRGB = true;
    if (typeof v == "string") {
        v = v.trim();
        v = v.split(/[\s,]+(?![^(]*\))/gm);
        for (let i = 0; i < v.length; i++) {
            v[i] = v[i].trim();
        }
    }
    let val = v ? v[0] : null;
    if (typeof val == 'string' && val == 'HSV' || val == 'RGB') {
        if (v[0] == 'HSV') {
            isRGB = false;
        }
        v = v.slice(1);
    }
    let colorCollection = new ObservableColorCollection();
    for (var i = 0; v && i < v.length; i++) {
        let color = stringToColor(v[i]);
        colorCollection.add(color);
    }
    return colorCollection;
}
function fromColorCollection(v) {
    if (v == null) {
        return null;
    }
    let internalCollection = v;
    let ret = [];
    for (let i = 0; i < internalCollection.count; i++) {
        ret.push(internalCollection.item(i).colorString);
    }
    return ret;
}
function arrayFindByName(arr, name) {
    for (let i = 0; i < arr.length; i++) {
        if (arr[i].findByName && arr[i].findByName(name)) {
            return arr[i].findByName(name);
        }
    }
}
class CollectionAdapter {
    constructor(query, target, allList, toTarget, onItemAdded, onItemRemoved, collisionChecker) {
        this._manualItems = [];
        this._collisionChecker = null;
        this.actualContent = [];
        this._removedManualKeys = new Set();
        if (collisionChecker) {
            this._collisionChecker = collisionChecker;
        }
        this._query = query;
        this._target = target;
        this._toTarget = toTarget;
        this._allList = allList;
        this._onItemAdded = onItemAdded;
        this._onItemRemoved = onItemRemoved;
        this.syncItems();
        if (this._query.changes) {
            this._query.changes.subscribe((v) => this.onQueryChanged(v));
        }
    }
    get collisionChecker() {
        return this._collisionChecker;
    }
    set collisionChecker(v) {
        this._collisionChecker = v;
    }
    updateQuery(q) {
        this._query = q;
        if (this._query.changes) {
            this._query.changes.subscribe((v) => this.onQueryChanged(v));
        }
        this.notifyContentChanged();
    }
    shiftContentToManual(manualCollection, onMoving) {
        let queryArray = null;
        if (this._query.toArray) {
            queryArray = this._query.toArray();
        }
        else {
            queryArray = this._query;
        }
        let item = null;
        let manualSet = new Set();
        if (this.collisionChecker) {
            for (var i = 0; i < this._manualItems.length; i++) {
                item = this._manualItems[i];
                if (item) {
                    let key = this.collisionChecker(item);
                    if (key) {
                        if (!manualSet.has(key)) {
                            manualSet.add(key);
                        }
                    }
                }
            }
        }
        let mapWasEmpty = manualSet.size == 0;
        for (var i = 0; i < queryArray.length; i++) {
            item = queryArray[i];
            if (!this._hasShiftedOnceAlready) {
                this._manualItems.splice(i, 0, item);
                manualCollection.insert(i, item);
                onMoving(item);
            }
            else {
                let key = this.collisionChecker(item);
                if (!key) {
                    this._manualItems.splice(i, 0, item);
                    manualCollection.insert(i, item);
                    onMoving(item);
                }
                else {
                    if (!manualSet.has(key)) {
                        this._manualItems.splice(manualCollection.count, 0, item);
                        manualCollection.insert(manualCollection.count, item);
                        onMoving(item);
                    }
                }
            }
        }
        this.syncItems();
        this._hasShiftedOnceAlready = true;
    }
    syncItems() {
        let targetMap = new Map();
        let queryMap = new Map();
        let manualMap = new Map();
        let item = null;
        for (var i = 0; i < this._allList.length; i++) {
            item = this._allList[i];
            targetMap.set(item, true);
        }
        let queryArray = null;
        if (this._query.toArray) {
            queryArray = this._query.toArray();
        }
        else {
            queryArray = this._query;
        }
        this.actualContent = queryArray;
        if (this.collisionChecker) {
            queryArray = queryArray.slice(0);
            this.actualContent = queryArray;
            let manualKeySet = new Set();
            for (let i = 0; i < this._manualItems.length; i++) {
                item = this._manualItems[i];
                if (item) {
                    let key = this.collisionChecker(item);
                    if (key) {
                        if (!manualKeySet.has(key)) {
                            manualKeySet.add(key);
                        }
                    }
                }
            }
            for (let i = queryArray.length - 1; i >= 0; i--) {
                item = queryArray[i];
                if (!item) {
                    queryArray.splice(i, 1);
                }
                else {
                    let key = this.collisionChecker(item);
                    if (key && (manualKeySet.has(key) || this._removedManualKeys.has(key))) {
                        queryArray.splice(i, 1);
                    }
                }
            }
        }
        for (var i = 0; i < queryArray.length; i++) {
            item = queryArray[i];
            queryMap.set(item, true);
        }
        for (var i = 0; i < this._manualItems.length; i++) {
            item = this._manualItems[i];
            manualMap.set(item, true);
        }
        for (var i = this._allList.length - 1; i >= 0; i--) {
            item = this._allList[i];
            if (!queryMap.has(item) && !manualMap.has(item)) {
                this._allList.splice(i, 1);
                this._target.removeAt(i);
                this._onItemRemoved(item);
            }
        }
        let ind = 0;
        let ins = 0;
        let insItem = null;
        let maxLen = queryArray.length + this._manualItems.length;
        while (ind < maxLen) {
            if (ind < queryArray.length) {
                insItem = queryArray[ind];
            }
            else if ((ind - queryArray.length) < this._manualItems.length) {
                insItem = this._manualItems[ind - queryArray.length];
            }
            else {
                break;
            }
            if (ins < this._allList.length) {
                item = this._allList[ins];
                if (item === insItem) {
                    ins++;
                    ind++;
                }
                else {
                    this._allList.splice(ins, 0, insItem);
                    this._target.insert(ins, this._toTarget(insItem));
                    this._onItemAdded(insItem);
                    ind++;
                    ins++;
                }
            }
            else {
                this._allList.push(insItem);
                this._target.add(this._toTarget(insItem));
                this._onItemAdded(insItem);
                ind++;
                ins++;
            }
        }
    }
    notifyContentChanged() {
        this.onQueryChanged(this._query);
    }
    onQueryChanged(currentItems) {
        this.syncItems();
    }
    addManualItem(item) {
        if (this.collisionChecker) {
            let key = this.collisionChecker(item);
            if (key) {
                if (this._removedManualKeys.has(key)) {
                    this._removedManualKeys.delete(key);
                }
            }
        }
        this._manualItems.push(item);
        this.syncItems();
    }
    removeManualItem(item) {
        let ind = this._manualItems.indexOf(item);
        if (ind >= 0) {
            if (this.collisionChecker) {
                let key = this.collisionChecker(item);
                if (key) {
                    if (!this._removedManualKeys.has(key)) {
                        this._removedManualKeys.add(key);
                    }
                }
            }
            this._manualItems.splice(ind, 1);
            this.syncItems();
            return true;
        }
        return false;
    }
    removeManualItemAt(index) {
        if (index < this._manualItems.length) {
            let item = this._manualItems[index];
            if (this.collisionChecker) {
                let key = this.collisionChecker(item);
                if (key) {
                    if (!this._removedManualKeys.has(key)) {
                        this._removedManualKeys.add(key);
                    }
                }
            }
        }
        this._manualItems.splice(index, 1);
        this.syncItems();
    }
    clearManualItems() {
        if (this.collisionChecker) {
            this._removedManualKeys.clear();
        }
        this._manualItems.length = 0;
        this.syncItems();
    }
    insertManualItem(index, item) {
        if (this.collisionChecker) {
            let key = this.collisionChecker(item);
            if (key) {
                if (this._removedManualKeys.has(key)) {
                    this._removedManualKeys.delete(key);
                }
            }
        }
        this._manualItems.splice(index, 0, item);
        this.syncItems();
    }
}
function addPaletteThemeEntry(theme, clss, background, border, foreground) {
    if (theme[clss] === undefined) {
        theme[clss] = {};
    }
    if (background !== null) {
        theme[clss]["background-color"] = background;
    }
    if (border !== null && border !== undefined) {
        theme[clss]["border-top-color"] = border;
        theme[clss]["border-left-color"] = border;
        theme[clss]["border-right-color"] = border;
        theme[clss]["border-bottom-color"] = border;
    }
    if (foreground !== null && foreground !== undefined) {
        theme[clss]["color"] = foreground;
    }
}
function addTextThemeEntry(theme, clss, fontFamily, fontSize, textColor, leftMargin, topMargin, rightMargin, bottomMargin, horizontalAlignment, verticalAlignment) {
    if (theme[clss] === undefined) {
        theme[clss] = {};
    }
    let t = theme[clss];
    if (fontFamily !== null && fontFamily !== undefined) {
        t["font-family"] = fontFamily;
        t["font-weight"] = "";
        t["font-style"] = "";
        t["font-variant"] = "";
        t["line-height"] = "";
    }
    if (fontSize !== null && fontSize !== undefined) {
        t["font-size"] = fontSize;
        t["font-weight"] = "";
        t["font-style"] = "";
        t["font-variant"] = "";
        t["line-height"] = "";
    }
    if (textColor !== null && textColor !== undefined) {
        t["color"] = textColor;
    }
    if (leftMargin !== null && leftMargin !== undefined) {
        t["margin-left"] = leftMargin;
    }
    if (topMargin !== null && topMargin !== undefined) {
        t["margin-top"] = topMargin;
    }
    if (rightMargin !== null && rightMargin !== undefined) {
        t["margin-right"] = rightMargin;
    }
    if (bottomMargin !== null && bottomMargin !== undefined) {
        t["margin-bottom"] = bottomMargin;
    }
    if (horizontalAlignment !== null && horizontalAlignment !== undefined) {
        t["text-align"] = horizontalAlignment;
    }
    if (verticalAlignment !== null && verticalAlignment !== undefined) {
        t["vertical-align"] = verticalAlignment;
    }
}
function isStylableProperty(name) {
    // using lower case to prevent issGrues with matching case of properties (e.g. chart.brushes)
    let propName = name.toLowerCase();
    // skip non-stylable properties
    if (propName == "height" ||
        propName == "width") {
        return false;
    }
    // check for all stylable properties
    if (stringEndsWith(propName, "height") || // grid.rowHeight
        stringEndsWith(propName, "width") || // zoomSlider.HigherThumbWidth
        stringEndsWith(propName, "width") || // zoomSlider.HigherCalloutOutline
        stringEndsWith(propName, "inset") || // zoomSlider.EndInset
        stringEndsWith(propName, "orientation") || // zoomSlider.Orientation
        stringEndsWith(propName, "duration") || // zoomSlider.PanTransitionDuration
        stringEndsWith(propName, "outline") || // zoomSlider.BarOutline
        stringEndsWith(propName, "brush") ||
        stringEndsWith(propName, "background") ||
        stringEndsWith(propName, "opacity") ||
        stringEndsWith(propName, "textstyle") ||
        stringEndsWith(propName, "brushes") || // chart.brushes  || chart.negativeBrushes
        stringEndsWith(propName, "outlines") || // chart.outlines || chart.negativeOutlines
        stringEndsWith(propName, "thickness") || // chart.AxisStrokeThickness
        stringEndsWith(propName, "colors") || //
        stringEndsWith(propName, "color") || // chart.AxisLabelTextColor
        stringEndsWith(propName, "margin") || // chart.AxisLabelTopMargin
        stringEndsWith(propName, "location") || // chart.AxisLabelLocation
        stringEndsWith(propName, "style") || // chart.AxisLabelTextStyle
        stringEndsWith(propName, "alignment") || // chart.AxisLabelHorizontalAlignment
        stringEndsWith(propName, "visibility") || // chart.AxisLabelVisibility
        stringEndsWith(propName, "extent") || // chart.AxisExtent
        stringEndsWith(propName, "length") || // chart.AxisTickLength
        stringEndsWith(propName, "strip") || // chart.AxisStrip
        stringEndsWith(propName, "stroke") || // chart.AxisStroke
        stringEndsWith(propName, "fill") || // piechart.OthersCategoryFill
        stringEndsWith(propName, "visible") ||
        stringEndsWith(propName, "radius") ||
        stringStartsWith(propName, "padding") ||
        propName === "usecanvas" ||
        propName === "useaccessibility") { // chart.isToolbarVisible
        return true;
    }
    return false;
}
function resolveUnits(val) {
    // TODO convert "em, px, pt, cm, in" units to "px"?
    // https://www.w3.org/Style/Examples/007/units.en.html
    let value = val.toLowerCase();
    if (stringEndsWith(value, "px")) { // 20px
        value = value.replace("px", "");
        value = value.replace(" ", "");
    }
    return value;
}
function toSpinal(value) {
    if (value == null) {
        return null;
    }
    let output = [];
    let upperRun = 0;
    for (let i = 0; i < value.length; i++) {
        var curr = value[i];
        var upperChar = curr.toUpperCase();
        var lowerChar = curr.toLowerCase();
        let charIsNewWord = (upperRun == 0 && output.length > 0);
        let previousCharWasNewWord = (upperRun > 1);
        if (upperChar == curr) {
            if (charIsNewWord) {
                output.push('-');
            }
            upperRun++;
        }
        else if (lowerChar == curr) {
            if (previousCharWasNewWord) {
                output.splice(output.length - 1, 0, '-');
            }
            upperRun = 0;
        }
        else {
            upperRun = 0;
        }
        output.push(lowerChar);
    }
    let sb = "";
    for (let i = 0; i < output.length; i++) {
        sb += output[i];
    }
    return sb;
}
function fromSpinal(value) {
    if (value == null) {
        return value;
    }
    let parts = value.split('-');
    for (let j = 1; j < parts.length; j++) {
        parts[j] = parts[j].substr(0, 1).toUpperCase() + parts[j].substr(1);
    }
    let ret = "";
    for (let j = 0; j < parts.length; j++) {
        ret += parts[j];
    }
    return ret;
}
function toCssPropertyName(value) {
    let sb = toSpinal(value);
    return sb;
}
// get all property names for specified component and its base classes
function getAllPropertyNames(comp) {
    let members = [];
    while (comp = (comp.prototype || Object.getPrototypeOf(comp))) {
        if (comp == HTMLElement.prototype) {
            break;
        }
        let props = Object.getOwnPropertyNames(comp.constructor.prototype);
        for (let i = 0; i < props.length; i++) {
            members.push(props[i]);
        }
    }
    return members;
}
let stylableMap = /*@__PURE__*/ new Map();
function initializePropertiesFromCss(ele, comp, cssPrefix, ignoredProperties, prefixRequired, additionalPrefixes) {
    let styles = getComputedStyle(ele);
    let props = getAllPropertyNames(comp);
    let filtered = false;
    let stylableProperties = [];
    if (stylableMap.has(comp.prototype || Object.getPrototypeOf(comp))) {
        stylableProperties = stylableMap.get(comp.prototype || Object.getPrototypeOf(comp));
        props = stylableProperties;
        filtered = true;
    }
    let compName = comp.constructor.name;
    for (let prop of props) {
        let cssPropName = null;
        if (filtered) {
            cssPropName = prop[1];
            prop = prop[0];
        }
        if (ignoredProperties && ignoredProperties.has(prop)) {
            if (!filtered && isStylableProperty(prop)) {
                let cssName = toCssPropertyName(prop);
                stylableProperties.push([prop, cssName]);
            }
            continue;
        }
        if (filtered || isStylableProperty(prop)) {
            let cssName = "";
            if (cssPropName) {
                cssName = cssPropName;
            }
            else {
                cssName = toCssPropertyName(prop);
            }
            // check if custom property is set with a prefix
            let cssValue = styles.getPropertyValue("--" + cssPrefix + cssName);
            if (cssValue && cssValue.length && cssValue.length > 0) {
                comp[prop] = resolveUnits(cssValue.trim());
            }
            if (additionalPrefixes) {
                for (let i = 0; i < additionalPrefixes.length; i++) {
                    let p = additionalPrefixes[i];
                    cssValue = styles.getPropertyValue("--" + p + cssName);
                    if (cssValue && cssValue.length && cssValue.length > 0) {
                        comp[prop] = resolveUnits(cssValue.trim());
                    }
                }
            }
            if (!prefixRequired) {
                // check if custom property is set without a prefix
                cssValue = styles.getPropertyValue("--" + cssName);
                if (cssValue && cssValue.length && cssValue.length > 0) {
                    comp[prop] = resolveUnits(cssValue.trim());
                }
            }
            if (!filtered) {
                stylableProperties.push([prop, cssName]);
            }
        }
    }
    if (!filtered) {
        stylableMap.set(comp.prototype || Object.getPrototypeOf(comp), stylableProperties);
    }
}
function addBrushPaletteThemeEntry(theme, clss, backgrounds, outlines) {
    if (outlines == null) {
        outlines = backgrounds;
    }
    let t = theme;
    for (let i = 0; i < Math.max(backgrounds.length, outlines.length); i++) {
        let pName = clss + "-" + (i + 1);
        if (t[pName] === undefined) {
            t[pName] = {};
        }
        if (backgrounds[i] !== undefined) {
            t[pName]["background-color"] = backgrounds[i];
        }
        if (outlines[i] !== undefined) {
            t[pName]["border-top-color"] = outlines[i];
            t[pName]["border-left-color"] = outlines[i];
            t[pName]["border-right-color"] = outlines[i];
            t[pName]["border-bottom-color"] = outlines[i];
        }
    }
}
function getModifiedProps(prevProps, nextProps) {
    let mod = {};
    for (let p of Object.keys(nextProps)) {
        if (prevProps[p] == undefined ||
            prevProps[p] !== nextProps[p]) {
            mod[p] = nextProps[p];
        }
    }
    return mod;
}
function isValidProp(owner, prop) {
    while (owner = (owner.prototype || Object.getPrototypeOf(owner))) {
        if (owner == HTMLElement.prototype) {
            break;
        }
        if (owner.hasOwnProperty(prop)) {
            return true;
        }
    }
    return false;
}
let NamePatcher = /*@__PURE__*/ (() => {
    class NamePatcher {
        static ensureStylablePatched(prot) {
            this.ensurePatched(prot, isStylableProperty);
        }
        static ensurePatched(prot, nameFilter) {
            if (!prot) {
                return;
            }
            if (prot === Object.prototype || prot === HTMLElement.prototype) {
                return;
            }
            if (this._patched.has(prot)) {
                return;
            }
            this._patched.add(prot);
            for (const key of Object.keys(prot)) {
                if (nameFilter && !nameFilter(key)) {
                    continue;
                }
                let p = Object.getOwnPropertyDescriptor(prot, key);
                if (!p) {
                    continue;
                }
                const set = p.set;
                let name = key;
                if (set !== undefined) {
                    let newSet = function (v) {
                        this.__p = name;
                        if (this.__m) {
                            this.__m(name);
                        }
                        set.call(this, v);
                    };
                    Object.defineProperty(prot, key, Object.assign({}, p, { set: newSet }));
                }
            }
            let base = Object.getPrototypeOf(prot);
            if (base) {
                this.ensurePatched(base, nameFilter);
            }
        }
    }
    NamePatcher._patched = /*@__PURE__*/ new Set();
    return NamePatcher;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DictionaryUtil {
    static dictionaryCreate(capacity) {
        return new Map();
    }
    static *en(map) {
        for (let item of map) {
            let [key, value] = item;
            yield { key: key, value: value };
        }
    }
    static dictionaryGetEnumerator(map) {
        return new IteratorWrapper(DictionaryUtil.en(map), () => DictionaryUtil.en(map));
    }
    static dictionaryGetKeys(map) {
        return new IteratorWrapper(map.keys(), () => map.keys());
    }
    static dictionaryGetValues(map) {
        return new IteratorWrapper(map.values(), () => map.values());
    }
    static dictionaryGetDictionary(obj) {
        let map = new Map();
        for (var p in obj) {
            map.set(p.toString(), obj[p]);
        }
        return map;
    }
}

let DomRenderer_$type = /*@__PURE__*/ new Type(null, "DomRenderer");
let DomWrapper_$type = /*@__PURE__*/ new Type(null, "DomWrapper");
let DomPortal_$type = /*@__PURE__*/ new Type(null, "DomPortal");
let DomWrapperPosition_$type = /*@__PURE__*/ new Type(null, "DomWrapperPosition");
let NormalizedEvent_$type = /*@__PURE__*/ new Type(null, "NormalizedEvent");

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class HttpRequestUtil {
    static submit(url, callback, error) {
        var data, ret, req;
        if (typeof XMLHttpRequest == "undefined") {
            try {
                req = new ActiveXObject("Msxml2.XMLHTTP.6.0");
            }
            catch (e) { }
            try {
                req = new ActiveXObject("Msxml2.XMLHTTP.3.0");
            }
            catch (e) { }
            req = new ActiveXObject("Microsoft.XMLHTTP");
        }
        else {
            req = new XMLHttpRequest();
        }
        if (req.overrideMimeType) {
            req.overrideMimeType("text/plain; charset=x-user-defined");
        }
        req.onreadystatechange = function () {
            if (req.readyState == 4) {
                if (req.status == 200) {
                    if (callback) {
                        callback(req.responseText, req);
                    }
                }
                else {
                    if (error) {
                        error(req.error, req);
                    }
                }
            }
        };
        req.open("GET", url, true);
        req.send(null);
        return req;
    }
    ;
}

class IgCollection {
    constructor() {
        this._isIgxCollection = true;
        this._inner = null;
        this._innerColl = null;
        this._innerColl = this._createInnerColl();
    }
    item(index, value) {
        if (this._innerColl != null) {
            return this._innerColl.get(index);
        }
        else {
            if (value) {
                value = this._ensureOuter(value);
                let innerValue = null;
                if (value._implementation) {
                    innerValue = value._implementation;
                }
                else {
                    innerValue = value;
                }
                this._inner.item(index, innerValue);
                return value;
            }
            else {
                let item = this._inner.item(index);
                item = this._toExternal(item);
                return item;
            }
        }
    }
    indexOf(item) {
        if (this._innerColl != null) {
            return this._innerColl.indexOf(this._ensureOuter(item));
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            return this._inner.indexOf(actualItem);
        }
    }
    insert(index, item) {
        if (this._innerColl != null) {
            this._innerColl.add1(index, item);
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            this._inner.insert(index, actualItem);
        }
    }
    removeAt(index) {
        if (this._innerColl != null) {
            this._innerColl.remove(index);
        }
        else {
            this._inner.removeAt(index);
        }
    }
    get count() {
        if (this._innerColl != null) {
            return this._innerColl.size();
        }
        else {
            return this._inner.count;
        }
    }
    add(item) {
        if (this._innerColl != null) {
            this._innerColl.add(item);
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            this._inner.add(actualItem);
        }
    }
    clear() {
        if (this._innerColl != null) {
            this._innerColl.clear();
        }
        else {
            this._inner.clear();
        }
    }
    contains(item) {
        if (this._innerColl != null) {
            return this._innerColl.all.contains(item);
        }
        else {
            let actualItem = item;
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            return this._inner.contains(actualItem);
        }
    }
    remove(item) {
        if (this._innerColl != null) {
            return this._innerColl.remove1(item);
        }
        else {
            let actualItem = this._ensureOuter(item);
            if (actualItem._implementation) {
                actualItem = actualItem._implementation;
            }
            return this._inner.remove(actualItem);
        }
    }
    findByName(name) {
        for (let i = 0; i < this.count; i++) {
            var curr = this.item(i);
            if (curr && curr.name) {
                if (curr.name == name) {
                    return curr;
                }
            }
            if (curr) {
                if (curr.findByName) {
                    let found = curr.findByName(name);
                    if (found) {
                        return found;
                    }
                }
            }
        }
        return null;
    }
    hasName(name) {
        return this.findByName(name) != null;
    }
    toArray() {
        let arr = [];
        for (let i = 0; i < this.count; i++) {
            arr[i] = this.item(i);
        }
        return arr;
    }
    *[Symbol.iterator]() {
        for (let i = 0; i < this.count; i++) {
            let item = this.item(i);
            yield item;
        }
    }
    _setSyncTarget(list) {
        if (this._innerColl != null) {
            this._innerColl.syncTarget = list;
        }
    }
    _fromInner(inner) {
        this._inner = inner;
        if (this._innerColl) {
            this._createFrom = this._innerColl.createFrom;
            this._createTo = this._innerColl.createTo;
        }
        this._innerColl = null;
        return this;
    }
    _toExternal(item) {
        if (!item) {
            return null;
        }
        let ext = item.externalObject;
        if (ext) {
            return ext;
        }
        if (this._createFrom) {
            ext = this._createFrom(item);
        }
        if (!ext) {
            return item;
        }
        return ext;
    }
    _ensureOuter(item) {
        return item;
    }
    _splitOuter(item) {
        if (item == null) {
            return [];
        }
        if (item.indexOf(",") == -1) {
            return [item];
        }
        let parts = item.split(",");
        for (let i = 0; i < parts.length; i++) {
            if (parts[i]) {
                parts[i] = parts[i].trim();
            }
        }
        return parts;
    }
    _fromOuter(outer) {
        if (outer._isIgxCollection) {
            return outer;
        }
        if (Array.isArray(outer)) {
            for (let i = 0; i < outer.length; i++) {
                this.add(this._ensureOuter(outer[i]));
            }
            return this;
        }
        let split = this._splitOuter(outer);
        for (let i = 0; i < split.length; i++) {
            this.add(this._ensureOuter(split[i]));
        }
        return this;
    }
}

class IgEvent {
    constructor() {
        this._callbacks = [];
    }
    emit(sender, args) {
        for (let i = 0; i < this._callbacks.length; i++) {
            this._callbacks[i](sender, args);
        }
    }
    add(callback) {
        this._callbacks.push(callback);
    }
    remove(callback) {
        let ind = this._callbacks.indexOf(callback);
        if (ind >= 0) {
            this._callbacks.splice(ind, 1);
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function isPoint(p) {
    if (p == null)
        return false;
    if (typeCast(Point_$type, p) != null)
        return true;
    if (typeof p.x === "number" && typeof p.y === "number")
        return true;
    return false;
}
function pointFromLiteral(p) {
    if (p == null)
        return PointUtil.create();
    var cast = typeCast(Point_$type, p);
    if (cast != null)
        return cast;
    return PointUtil.createXY(p.x, p.y);
}
function pointToLiteral(p) {
    if (p == null)
        return null;
    return { x: p.x, y: p.y };
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function isRect(r) {
    if (r == null)
        return false;
    if (typeCast(Rect.$t, r) != null)
        return true;
    if (typeof r.x === "number" && typeof r.y === "number" &&
        typeof r.width === "number" && typeof r.height === "number")
        return true;
    //if (typeof r.left === "number" && typeof r.top === "number" &&
    //    typeof r.right === "number" && typeof r.bottom === "number")
    //    return true;
    return false;
}
function rectFromLiteral(r) {
    if (r == null)
        return new Rect(0, 0, 0, 0, 0);
    var cast = typeCast(Rect.$t, r);
    if (cast != null)
        return cast;
    return new Rect(0, r.left, r.top, r.width, r.height);
}
function rectToLiteral(r) {
    if (r == null)
        return null;
    return { left: r.left, top: r.top, width: r.width, height: r.height };
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function isSize(s) {
    if (s == null)
        return false;
    if (typeCast(Size.$t, s) != null)
        return true;
    if (typeof s.width === "number" && typeof s.height === "number")
        return true;
    return false;
}
function sizeFromLiteral(s) {
    if (s == null)
        return new Size(1, 0, 0);
    var cast = typeCast(Size.$t, s);
    if (cast != null)
        return cast;
    return new Size(1, s.width, s.height);
}
function sizeToLiteral(s) {
    if (s == null)
        return null;
    return { width: s.width, height: s.height };
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class PromiseWrapper {
    constructor(inner) {
        this._state = "pending";
        this._resolvedValue = null;
        this._rejectedError = null;
        this._then = [];
        this._fail = [];
        this._always = [];
        this._promise = inner;
        this._promise
            .then((v) => {
            this._state = "resolved";
            this._resolvedValue = v;
            for (var i = 0; i < this._then.length; i++) {
                this._then[i](v);
            }
            for (var i = 0; i < this._always.length; i++) {
                this._always[i](v);
            }
        })
            .catch((e) => {
            this._state = "rejected";
            this._rejectedError = e;
            for (var i = 0; i < this._fail.length; i++) {
                this._fail[i](e);
            }
            for (var i = 0; i < this._always.length; i++) {
                this._always[i](e);
            }
        });
    }
    state() {
        return this._state;
    }
    then(pass, fail) {
        this.done(pass);
        this.fail(fail);
        return this;
    }
    done(continuation) {
        this._then.push(continuation);
        if (this._state == "resolved") {
            continuation(this._resolvedValue);
        }
        return this;
    }
    fail(continuation) {
        this._fail.push(continuation);
        if (this._state == "failed") {
            continuation(this._rejectedError);
        }
        return this;
    }
    always(continuation) {
        this._always.push(continuation);
        if (this._state == "resolved") {
            continuation(this._resolvedValue);
        }
        if (this._state == "failed") {
            continuation(this._rejectedError);
        }
        return this;
    }
}
class PromiseFactory {
    constructor() {
        this._wrapper = null;
    }
    resolve(result) {
        if (this._resolve) {
            this._resolve(result);
        }
    }
    reject(error) {
        if (this._reject) {
            this._reject(error);
        }
    }
    promise() {
        this._promise = new Promise((resolve, reject) => {
            this._resolve = resolve;
            this._reject = reject;
        });
        this._wrapper = new PromiseWrapper(this._promise);
        return this._wrapper;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let ReflectionUtil = /*@__PURE__*/ (() => {
    class ReflectionUtil {
    }
    ReflectionUtil.getPropertyGetter = function (type, propertyName) {
        if (typeof type.prototype[propertyName] === "function") {
            return function (instance) {
                return type.prototype[propertyName].apply(instance, arguments);
            };
        }
        return function (instance) {
            return instance[propertyName];
        };
    };
    return ReflectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function sleep(milliseconds) {
    var start = new Date().getTime();
    for (var i = 0; i < 1e7; i++) {
        if ((new Date().getTime() - start) > milliseconds) {
            break;
        }
    }
}
;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let XmlDocument_$type = /*@__PURE__*/ new Type(null, 'XmlDocument');
let XmlElement_$type = /*@__PURE__*/ new Type(null, 'XmlElement');
let XmlNode_$type = /*@__PURE__*/ new Type(null, 'XmlNode');
let XmlAttribute_$type = /*@__PURE__*/ new Type(null, 'XmlAttribute');
let XmlLinkedNode_$type = /*@__PURE__*/ new Type(null, 'XmlLinkedNode');
let XmlNodeList_$type = /*@__PURE__*/ new Type(null, 'XmlNodeList');
let XmlNamedNodeMap_$type = /*@__PURE__*/ new Type(null, 'XmlNamedNodeMap');
var XmlNodeType = /*@__PURE__*/ (function (XmlNodeType) {
    XmlNodeType[XmlNodeType["None"] = 0] = "None";
    XmlNodeType[XmlNodeType["Element"] = 1] = "Element";
    XmlNodeType[XmlNodeType["Attribute"] = 2] = "Attribute";
    XmlNodeType[XmlNodeType["Text"] = 3] = "Text";
    XmlNodeType[XmlNodeType["CDATA"] = 4] = "CDATA";
    XmlNodeType[XmlNodeType["EntityReference"] = 5] = "EntityReference";
    XmlNodeType[XmlNodeType["Entity"] = 6] = "Entity";
    XmlNodeType[XmlNodeType["ProcessingInstruction"] = 7] = "ProcessingInstruction";
    XmlNodeType[XmlNodeType["Comment"] = 8] = "Comment";
    XmlNodeType[XmlNodeType["Document"] = 9] = "Document";
    XmlNodeType[XmlNodeType["DocumentType"] = 10] = "DocumentType";
    XmlNodeType[XmlNodeType["DocumentFragment"] = 11] = "DocumentFragment";
    XmlNodeType[XmlNodeType["Notation"] = 12] = "Notation";
    XmlNodeType[XmlNodeType["Whitespace"] = 13] = "Whitespace";
    XmlNodeType[XmlNodeType["SignificantWhitespace"] = 14] = "SignificantWhitespace";
    XmlNodeType[XmlNodeType["EndElement"] = 15] = "EndElement";
    XmlNodeType[XmlNodeType["EndEntity"] = 16] = "EndEntity";
    XmlNodeType[XmlNodeType["XmlDeclaration"] = 17] = "XmlDeclaration";
    return XmlNodeType;
})({});
let XmlNodeType_$type = /*@__PURE__*/ markEnum("XmlNodeType", "Node,0;Element,1;Attribute,2;Text,3;CData,4;EntityReference,5;Entity,6;ProcessingInstruction,7;Comment,8;Document,9;DocumentType,10;DocumentFragment,11;Notation,12;Whitespace,13;SignificantWhitespace,14;EndElement,15;EndEntity,16;XmlDeclaration,17");

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendContext_$type = /*@__PURE__*/ new Type(null, 'ILegendContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataContext = /*@__PURE__*/ (() => {
    class DataContext extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.g = null;
            this.d = null;
            this.j = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.a = 0;
            this.f = null;
            this.propertyChanged = null;
        }
        get series() {
            return this.g;
        }
        set series(a) {
            this.g = a;
        }
        get item() {
            return this.d;
        }
        set item(a) {
            if (a != this.d) {
                this.d = a;
                this.i("Item");
            }
        }
        get actualItemBrush() {
            return this.j;
        }
        set actualItemBrush(a) {
            if (a != this.j) {
                this.j = a;
                this.i("ActualItemBrush");
            }
        }
        get outline() {
            return this.l;
        }
        set outline(a) {
            if (a != this.l) {
                this.l = a;
                this.i("Outline");
            }
        }
        get itemLabel() {
            return this.e;
        }
        set itemLabel(a) {
            if (a != this.e) {
                this.e = a;
                this.i("ItemLabel");
            }
        }
        get itemBrush() {
            return this.k;
        }
        set itemBrush(a) {
            if (a != this.k) {
                this.k = a;
                this.i("ItemBrush");
            }
        }
        get thickness() {
            return this.a;
        }
        set thickness(a) {
            if (a != this.a) {
                this.a = a;
                this.i("Thickness");
            }
        }
        get legendLabel() {
            return this.f;
        }
        set legendLabel(a) {
            if (a != this.f) {
                this.f = a;
                this.i("LegendLabel");
            }
        }
        i(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        flatten() {
            let series_ = this.series;
            let item_ = this.item;
            let actualItemBrush_ = this.actualItemBrush;
            let outline_ = this.outline;
            let itemLabel_ = this.itemLabel;
            let itemBrush_ = this.itemBrush;
            let thickness_ = this.thickness;
            return { item: item_, itemBrush: actualItemBrush_, outline: outline_, itemLabel: itemLabel_, thickness: thickness_ };
        }
    }
    DataContext.$t = /*@__PURE__*/ markType(DataContext, 'DataContext', Base.$, [ILegendContext_$type, INotifyPropertyChanged_$type]);
    return DataContext;
})();

class IgrDataContext {
    createImplementation() {
        return new DataContext();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get series() {
        return this.i.series.externalObject;
    }
    set series(v) {
        if (v == null) {
            this.i.series = null;
            return;
        }
        this.i.series = v.i;
    }
    /**
 * Gets the item that is in context.
*/
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the actual resolved brush in use for the item that is in context.
    */
    get actualItemBrush() {
        return brushToString(this.i.actualItemBrush);
    }
    set actualItemBrush(v) {
        this.i.actualItemBrush = stringToBrush(v);
    }
    /**
     * Gets the outline in use for the item in context.
    */
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    /**
     * Gets the label in use for the item in context, if available.
    */
    get itemLabel() {
        return this.i.itemLabel;
    }
    set itemLabel(v) {
        this.i.itemLabel = v;
    }
    /**
     * Gets the potential brush in usage for the item in context.
    */
    get itemBrush() {
        return brushToString(this.i.itemBrush);
    }
    set itemBrush(v) {
        this.i.itemBrush = stringToBrush(v);
    }
    /**
     * Gets the thickness of the item in context.
    */
    get thickness() {
        return this.i.thickness;
    }
    set thickness(v) {
        this.i.thickness = +v;
    }
    /**
     * Gets the legend label to use for the item in context, if available.
    */
    get legendLabel() {
        return this.i.legendLabel;
    }
    set legendLabel(v) {
        this.i.legendLabel = v;
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleDe {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll kann nicht geladen werden. Stellen Sie sicher, dass diese Assembly im für Windows Phone bereitgestellten XAP enthalten ist; fügen Sie ihr hierzu beispielsweise einen Verweis von einem Ihrer Projekte hinzu.";
        this["BreakEvenTitle_BreakEven"] = "Break-Even";
        this["BreakEvenTitle_FixedCost"] = "Fixkosten";
        this["BreakEvenTitle_LossArea"] = "Verlustbereich";
        this["BreakEvenTitle_MarginalProfit"] = "Grenzertrag";
        this["BreakEvenTitle_ProfitArea"] = "Gewinnbereich";
        this["BreakEvenTitle_SafetyMargin"] = "Sicherheitsmarge";
        this["BreakEvenTitle_SalesRevenue"] = "Umsatzerlös";
        this["BreakEvenTitle_TotalCost"] = "Gesamtkosten";
        this["BreakEvenTitle_VariableCost"] = "Variable Kosten";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Es wurde auf die Interaktivitätsfunktion zugegriffen, aber das Modul für die Diagramminteraktion wurde nicht geladen.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Number abbreviation functionality was used, but the number abbreviator module has not been loaded.";
        this["DataChart_VisualDataNotLoaded"] = "Es wurde auf die VisualData-Funktion zugegriffen, aber das Modul für die Diagramminteraktion wurde nicht geladen.";
        this["DataProviderNotInitialized"] = "Der Datenanbieter wurde ohne vorherige Initialisierung verwendet. Der Datenanbieter muss vor der Verwendung initialisiert werden.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Reihentitel";
        this["FinancialChart_IndicatorMenu_Header"] = "Anzeigen";
        this["FinancialChart_IndicatorMenu_Header1"] = "Anzeigen";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Eigenständige Anzeigen";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader1"] = "Eigenständige Anzeigen";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Überlagerungen";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader1"] = "Überlagerungen";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlinien";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader1"] = "Trendlinien";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumen";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader1"] = "Volumen";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oszillator absolute Menge";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Akkumulationsverteilung";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Durchschnittlicher Richtungsindex";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Durchschnittlicher wahrer Bereich";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Breite des Bollinger-Bands";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin-Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin-Volatilität";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oszillator trendbereinigter Preis";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Bewegungsleichtigkeit";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Schneller stochastischer Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Kraftindex";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Vollständiger stochastischer Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Massenindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Durchschnittlicher Preis";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Geldflussindex";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negativer Volumenindex";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "On Balance Volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Percentage Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Percentage Volume Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "On-Balance-Volumen";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Langsamer stochastischer Oszillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standardabweichung";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stochastik Relative-Stärke-Index";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typischer Preis";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimate Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Gewichtetes Mittel";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams-Prozentbereich";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger-Bänder";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Preiskanal";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Kubische Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Kumulativer Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponentieller Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponentielle Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Lineare Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logarithmische Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Modifizierter Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Potenzgesetz-Entsprechung";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Quadratische Anpassung";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Anpassung vierten Grades";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Anpassung fünften Grades";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Einfacher Durchschnitt";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Gewichteter Durchschnitt";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Bereich";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Spalte";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Linie";
        this["FinancialChart_RangeSelector_All"] = "Alle";
        this["FinancialChart_RangeSelector_From"] = "From";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "To";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Schließen";
        this["FinancialSeries_High"] = "Hoch";
        this["FinancialSeries_Low"] = "Niedrig";
        this["FinancialSeries_Open"] = "Öffnen";
        this["FinancialSeries_Volume"] = "Lautstärke";
        this["NoEncodingsLoaded"] = "Es wurden keine Codierungen gefunden! Laden Sie die Infragistics.Encoding Assembly oder lesen Sie in der Dokumentation nach, wie Sie benutzerdefinierte Codierungen erstellen.";
        this["NotSupportedEncoding"] = "Die Codierung entsprechend {0} {1} wird nicht unterstützt.";
        this["Object_Sealed"] = "Modifications are not permitted after the object has been sealed.";
        this["OPD_DefaultInteraction"] = "Standardmäßige Interaktion für Ziehen mit Maustaste auswählen";
        this["OPD_DragPan"] = "Die Oberfläche schwenken";
        this["OPD_DragZoom"] = "Auswahlbereich vergrößern";
        this["OPD_ScaleToFit"] = "An Bildschirm anpassen";
        this["OPD_ScaleToFit_SeriesViewer"] = "Zoom zurücksetzen (100%)";
        this["OPD_ZoomIn"] = "Vergrößern";
        this["OPD_ZoomOut"] = "Verkleinern";
        this["OPD_ZoomTo100"] = "Zoommodus 100%";
        this["PieChart_Others"] = "Andere";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Bereichsbasierte Änderungen an der Datenquelle werden aktuell nicht unterstützt";
        this["ScatterSeries_Value"] = "Wert";
        this["TRIAL_VERSION"] = "NICHT LIZENZIERTER TEST Zu kaufen auf Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleDeModule {
    static register() {
        Localization.register("DataVisualization-de", new DataVisualizationLocaleDe());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleEs {
    constructor() {
        this["AssemblyNotIncluded"] = "No se puede cargar {0}.dll. Asegúrese de que este conjunto esté incluido en el XAP que se ejecuta en el Windows Phone, por ejemplo añadiendo una referencia al mismo desde cualquiera de sus proyectos.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Fixed Cost";
        this["BreakEvenTitle_LossArea"] = "Loss Area";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal Profit";
        this["BreakEvenTitle_ProfitArea"] = "Profit Area";
        this["BreakEvenTitle_SafetyMargin"] = "Safety Margin";
        this["BreakEvenTitle_SalesRevenue"] = "Sales Revenue";
        this["BreakEvenTitle_TotalCost"] = "Total Cost";
        this["BreakEvenTitle_VariableCost"] = "Variable Cost";
        this["BubbleSeries_Radius"] = "Radio";
        this["DataChart_InteractivityNotLoaded"] = "Se ha accedido a la función de interactividad, pero no se ha cargado el módulo de interacción de gráficos.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Se ha utilizado la función de abreviatura de número, pero el módulo abreviador de número no se ha cargado.";
        this["DataChart_VisualDataNotLoaded"] = "Se ha accedido a la función Datos visuales, pero no se ha cargado el módulo de interacción de gráficos.";
        this["DataProviderNotInitialized"] = "El proveedor de datos se ha utilizado sin inicializarlo primero. El proveedor de datos debe inicializarse antes de utilizarlo.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Título de la serie";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicadores";
        this["FinancialChart_IndicatorMenu_Header1"] = "Indicadores";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicadores independientes";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader1"] = "Indicadores independientes";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Superposiciones";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader1"] = "Superposiciones";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Líneas de tendencia";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader1"] = "Líneas de tendencia";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumen";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader1"] = "Volúmenes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscilador de volumen absoluto";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Acumulación/Distribución";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Índice direccional promedio";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Rango medio verdadero";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Ancho de la Banda de Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscilador de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilidad de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oscilador de precio sin tendencia";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Facilidad de movimiento";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscilador estocástico rápido";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscilador estocástico total";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Índice de facilitación del mercado";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Índice de masa";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Precio medio";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Índice de flujo monetario";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Índice de volumen negativo";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Balance de volúmenes";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscilador de precios en porcentaje";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscilador de volumen en porcentaje";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Índice de volumen positivo";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Price Volume Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscilador estocástico lento";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Desviación estándar";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "RSI estocástico";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Precio típico";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscilador final";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Cierre ponderado";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bandas de Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Canal de precios";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Ajuste cúbico";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Promedio acumulativo";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Promedio exponencial";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Ajuste exponencial";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Ajuste lineal";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logarithmic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Ajuste logarítmico";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Ajuste de ley de potencia";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Ajuste cuadrático";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Ajuste cuártico";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Ajuste quíntico";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Promedio simple";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Promedio ponderado";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Área";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Columna";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Línea";
        this["FinancialChart_RangeSelector_All"] = "Todo";
        this["FinancialChart_RangeSelector_From"] = "De";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "A";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Cerrar";
        this["FinancialSeries_High"] = "Alto";
        this["FinancialSeries_Low"] = "Bajo";
        this["FinancialSeries_Open"] = "Abrir";
        this["FinancialSeries_Volume"] = "Volumen";
        this["NoEncodingsLoaded"] = "No se han encontrado codificaciones. Cargue el conjunto Infragistics.Encoding o consulte la documentación para saber cómo crear codificaciones personalizadas.";
        this["NotSupportedEncoding"] = "La codificación correspondiente bajo {0} {1} no se admite.";
        this["Object_Sealed"] = "No se permiten modificaciones después de haber sellado el objeto.";
        this["OPD_DefaultInteraction"] = "Seleccione la interacción predeterminada de arrastre del ratón";
        this["OPD_DragPan"] = "Aplicar panorámica a la superficie";
        this["OPD_DragZoom"] = "Zoom en el área de selección";
        this["OPD_ScaleToFit"] = "Ajustar a la pantalla";
        this["OPD_ScaleToFit_SeriesViewer"] = "Restablecer zoom (100%)";
        this["OPD_ZoomIn"] = "Acercar";
        this["OPD_ZoomOut"] = "Alejar";
        this["OPD_ZoomTo100"] = "Zoom al 100%";
        this["PieChart_Others"] = "Otros";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Las modificaciones de la fuente de datos basadas en intervalos no son compatibles";
        this["ScatterSeries_Value"] = "Valor";
        this["TRIAL_VERSION"] = "Compre la VERSIÓN DE PRUEBA SIN LICENCIA en Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleEsModule {
    static register() {
        Localization.register("DataVisualization-es", new DataVisualizationLocaleEs());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleFr {
    constructor() {
        this["AssemblyNotIncluded"] = "Impossible de charger {0}.dll. Vous devez vous assurer que cet ensemble est inclus dans le XAP qui est déployé sur le Windows Phone, par exemple, en lui ajoutant une référence depuis l'un de vos projets.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Fixed Cost";
        this["BreakEvenTitle_LossArea"] = "Loss Area";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal Profit";
        this["BreakEvenTitle_ProfitArea"] = "Profit Area";
        this["BreakEvenTitle_SafetyMargin"] = "Safety Margin";
        this["BreakEvenTitle_SalesRevenue"] = "Sales Revenue";
        this["BreakEvenTitle_TotalCost"] = "Total Cost";
        this["BreakEvenTitle_VariableCost"] = "Variable Cost";
        this["BubbleSeries_Radius"] = "Rayon";
        this["DataChart_InteractivityNotLoaded"] = "L’accès aux fonctionnalités d’interactivité a été possible mais le module d’interaction de graphiques n’a pas été chargé.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Les fonctionnalités d’abréviation numérique ont été utilisées, mais le module d’abréviation numérique n’a pas été chargé.";
        this["DataChart_VisualDataNotLoaded"] = "L’accès aux fonctionnalités de données visuelles a été possible mais le module d’interaction de graphiques n’a pas été chargé.";
        this["DataProviderNotInitialized"] = "Le fournisseur de données a été utilisé sans avoir été initialisé au préalable. Le fournisseur de données doit être initialisé avant toute utilisation.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Titre de série";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicateurs";
        this["FinancialChart_IndicatorMenu_Header1"] = "Indicateurs";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicateurs autonomes";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader1"] = "Indicateurs autonomes";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Superpositions";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader1"] = "Superpositions";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Lignes de tendance";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader1"] = "Lignes de tendance";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volume";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader1"] = "Volumes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscillateur de volume absolu";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Accumulation-distribution";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Index directionnel moyen";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Average True Range";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Largeur de la bande de Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Oscillateur de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilité de Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Ease Of Movement";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscillateur stochastique rapide";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscillateur stochastique complet";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Mass Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Prix médian";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Money Flow Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negative Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Graphique du volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscillateur du pourcentage de prix";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscillateur du pourcentage de volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Price Volume Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscillateur stochastique lent";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Écart type";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Prix typique";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscillateur ultime";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Clôture pondérée";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bandes de Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Price Channel";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Ajustement cubique";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Moyenne cumulée";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Moyenne exponentielle";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Ajustement exponentiel";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Ajustement linéaire";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Ajustement logarithmique";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Moyenne modifiée";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "Ajustement de loi de puissance";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Ajustement quadratique";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Ajustement quartique";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Ajustement quintique";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Ajustement quintique";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Moyenne pondérée";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Zone";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Colonne";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Ligne";
        this["FinancialChart_RangeSelector_All"] = "Tous";
        this["FinancialChart_RangeSelector_From"] = "De";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1A";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "To";
        this["FinancialChart_RangeSelector_YearToDate"] = "AAJ";
        this["FinancialSeries_Close"] = "Fermer";
        this["FinancialSeries_High"] = "Haut";
        this["FinancialSeries_Low"] = "Bas";
        this["FinancialSeries_Open"] = "Ouvrir";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "Aucun encodage n'a été trouvé! Veuillez charger l'ensemble Infragistics.Encoding ou consultez la documentation concernant la création d'encodages personnalisés.";
        this["NotSupportedEncoding"] = "L'encodage correspondant sous la plage {0} {1} n'est pas pris en charge.";
        this["Object_Sealed"] = "Une fois que l’objet a été scellé, les modifications ne sont pas autorisées.";
        this["OPD_DefaultInteraction"] = "Sélectionner l'interaction de glissement de la souris par défaut";
        this["OPD_DragPan"] = "Faire un panoramique de la surface";
        this["OPD_DragZoom"] = "Faire un zoom avant sur la zone de sélection";
        this["OPD_ScaleToFit"] = "Adapter à l'écran";
        this["OPD_ScaleToFit_SeriesViewer"] = "Rétablir le zoom (à 100%)";
        this["OPD_ZoomIn"] = "Zoom avant";
        this["OPD_ZoomOut"] = "Zoom arrière";
        this["OPD_ZoomTo100"] = "Zoom à 100%";
        this["PieChart_Others"] = "Autres";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Les modifications basées sur la plage ne sont actuellement pas prises en charge pour la source des données";
        this["ScatterSeries_Value"] = "Valeur";
        this["TRIAL_VERSION"] = "Achat de la VERSION D’ESSAI SANS LICENCE sur Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleFrModule {
    static register() {
        Localization.register("DataVisualization-fr", new DataVisualizationLocaleFr());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleIt {
    constructor() {
        this["AssemblyNotIncluded"] = "Impossibile caricare {0}.dll. È necessario assicurarsi che questo assembly sia incluso nell’XAP distribuito su Windows Phone, ad esempio aggiungendo un riferimento ad esso da uno qualsiasi dei progetti.";
        this["BreakEvenTitle_BreakEven"] = "Pareggio finanziario";
        this["BreakEvenTitle_FixedCost"] = "Costo fisso";
        this["BreakEvenTitle_LossArea"] = "Area perdite";
        this["BreakEvenTitle_MarginalProfit"] = "Profitto marginale";
        this["BreakEvenTitle_ProfitArea"] = "Area di profitto";
        this["BreakEvenTitle_SafetyMargin"] = "Margine di sicurezza";
        this["BreakEvenTitle_SalesRevenue"] = "Entrate di vendita";
        this["BreakEvenTitle_TotalCost"] = "Costo totale";
        this["BreakEvenTitle_VariableCost"] = "Costo variabile";
        this["BubbleSeries_Radius"] = "Raggio";
        this["DataChart_InteractivityNotLoaded"] = "Accesso alla funzionalità di interattività ma il modulo di interazione grafico non è stato caricato.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "È stata utilizzata la funzionalità di abbreviazione numerica, ma il modulo di abbreviazione numerica non è stato caricato.";
        this["DataChart_VisualDataNotLoaded"] = "Accesso alla funzionalità VisualData ma il modulo di interazione grafico non è stato caricato.";
        this["DataProviderNotInitialized"] = "Il provider di dati è stato utilizzato senza prima inizializzare. Il provider di dati deve essere inizializzato prima dell'uso.";
        this["DataSource_Summary_Avg"] = "Media";
        this["DataSource_Summary_Count"] = "Conteggio";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Somma";
        this["Default_Series_Title"] = "Titolo serie";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicatori";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Indicatori autonomi";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Sovrapposizioni";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Linee di tendenza";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumi";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Oscillatore di volume assoluto";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Distribuzione accumulo";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Indice direzionale medio";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Intervallo medio vero";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Larghezza della banda di Bollinger";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Volatilità del Chaikin";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Indice dei canali merceologici";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Oscillatore a prezzo differenziato";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Facilità di movimento";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Oscillatore stocastico veloce";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Oscillatore stocastico completo";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Indice di facilitazione del mercato";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Indice di massa";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Prezzo medio";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Indice del flusso di denaro";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "Convergenza/divergenza media mobile";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Indice di volume negativo";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "Volume del saldo";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Oscillatore prezzo percentuale";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Oscillatore volume percentuale";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Indice di volume positivo";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Andamento volume prezzo";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "Indice di forza relativa (RSI)";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Oscillatore stocastico lento";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Deviazione standard";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Prezzo tipico";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Oscillatore Ultimate";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Chiusura ponderata";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bande di Bollinger";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Canale di prezzo";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Adattamento a terzo grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Media cumulativa";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Media esponenziale";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Adattamento esponenziale";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Adattamento lineare";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Adattamento logaritmico";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Media modificata";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Adattamento a secondo grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Adattamento a quarto grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Adattamento a quinto grado";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Media semplice";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Media ponderata";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Area";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Colonna";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Riga";
        this["FinancialChart_RangeSelector_All"] = "Tutto";
        this["FinancialChart_RangeSelector_From"] = "Da";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 mese";
        this["FinancialChart_RangeSelector_OneYear"] = "1 anno";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 mesi";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 mesi";
        this["FinancialChart_RangeSelector_To"] = "A";
        this["FinancialChart_RangeSelector_YearToDate"] = "Da inizio anno";
        this["FinancialSeries_Close"] = "Chiudi";
        this["FinancialSeries_High"] = "Alto";
        this["FinancialSeries_Low"] = "Basso";
        this["FinancialSeries_Open"] = "Aperto";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "Nessuna codifica trovata! Caricare l’assembly Infragistics.Encoding o consultare la documentazione su come creare codifiche personalizzate.";
        this["NotSupportedEncoding"] = "La codifica corrispondente in {0} {1} non è supportata.";
        this["Object_Sealed"] = "Modifiche non sono consentite dopo che l'oggetto è stato sigillato.";
        this["OPD_DefaultInteraction"] = "Selezionare l’interazione di trascinamento del mouse predefinita";
        this["OPD_DragPan"] = "Panoramica della superficie";
        this["OPD_DragZoom"] = "Zoom l'area di selezione";
        this["OPD_ScaleToFit"] = "Adatta allo schermo";
        this["OPD_ScaleToFit_SeriesViewer"] = "Reimposta zoom (100%)";
        this["OPD_ZoomIn"] = "Zoom avanti";
        this["OPD_ZoomOut"] = "Zoom indietro";
        this["OPD_ZoomTo100"] = "Zoom 100%";
        this["PieChart_Others"] = "Altri";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Modifiche dell’origine dati basate sull’intervallo non sono attualmente supportate";
        this["ScatterSeries_Value"] = "Valore";
        this["TRIAL_VERSION"] = "PROVA SENZA LICENZA Per acquistare: Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleItModule {
    static register() {
        Localization.register("DataVisualization-it", new DataVisualizationLocaleIt());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleJa {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll を読み込めません。このアセンブリが Windows Phone にデプロイされる XAP に含まれることを確認してください (プロジェクトから参照を追加など)。";
        this["BreakEvenTitle_BreakEven"] = "損益分岐点";
        this["BreakEvenTitle_FixedCost"] = "固定費";
        this["BreakEvenTitle_LossArea"] = "損失領域";
        this["BreakEvenTitle_MarginalProfit"] = "限界利益";
        this["BreakEvenTitle_ProfitArea"] = "利益領域";
        this["BreakEvenTitle_SafetyMargin"] = "安全余裕率";
        this["BreakEvenTitle_SalesRevenue"] = "売上収益";
        this["BreakEvenTitle_TotalCost"] = "総費用";
        this["BreakEvenTitle_VariableCost"] = "変動費";
        this["BubbleSeries_Radius"] = "半径";
        this["DataChart_InteractivityNotLoaded"] = "インタラクティブ機能にアクセスがありましたがインタラクション モジュールが読み込まれていません。";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "数値省略機能が使用されましたが、数値省略モジュールが読み込まれていません。";
        this["DataChart_VisualDataNotLoaded"] = "VisualData 機能にアクセスがありましたがインタラクション モジュールが読み込まれていません。";
        this["DataProviderNotInitialized"] = "初期化されていないデータ プロバイダーが使用されました。データ プロバイダーは使用前に初期化する必要があります。";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "シリーズ タイトル";
        this["FinancialChart_IndicatorMenu_Header"] = "インジケーター";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "スタンドアロン インジケーター";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "オーバーレイ";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "トレンドライン";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "ボリューム";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "絶対出来高オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "蓄積/分配";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "平均方向性指数";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "ATR (アベレージ トゥルー レンジ)";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "ボリンジャー バンド幅";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "チャイキン オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "チャイキン ボラティリティ";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "商品チャネル指数 (CCI)";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "トレンド除去価格オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "イーズ オブ ムーブメント";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "ファスト スト キャスティクス オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "フォース インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "フル ストキャスティクス オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "マーケット ファシリテーション インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "マス インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "メディアンプライス";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "マネー フロー インデックス";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "負出来高指数 (NVI)";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "OBV (オン バランス ボリューム) インジケーター";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "パーセンテージ価格オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "パーセンテージ出来高オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "PVI (ポジティブ ボリューム インデックス)";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "価格出来高トレンド";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "スロー ストキャスティクス オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "標準偏差";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "ストキャスティクス RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "代表価格";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "アルティメット オシレーター";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "加重終値";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "ウィリアム パーセント";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "ボリンジャー バンド";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "プライス チャネル";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "キュービック フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "累加平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "指数平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "指数フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "リニア フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "対数フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "修正平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "二次フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "四次フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "五次フィット";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "単純平均";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "加重平均";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "エリア";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "柱状";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "折れ線";
        this["FinancialChart_RangeSelector_All"] = "すべて";
        this["FinancialChart_RangeSelector_From"] = "開始:";
        this["FinancialChart_RangeSelector_OneMonth"] = "1か月";
        this["FinancialChart_RangeSelector_OneYear"] = "1年";
        this["FinancialChart_RangeSelector_SixMonths"] = "6か月";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3か月";
        this["FinancialChart_RangeSelector_To"] = "終了:";
        this["FinancialChart_RangeSelector_YearToDate"] = "累計";
        this["FinancialSeries_Close"] = "終値";
        this["FinancialSeries_High"] = "高値";
        this["FinancialSeries_Low"] = "安値";
        this["FinancialSeries_Open"] = "始値";
        this["FinancialSeries_Volume"] = "ボリューム";
        this["NoEncodingsLoaded"] = "Infragistics.Encoding アセンブリを読み込むか、ヘルプのカスタム エンコーティングを作成する方法を参照してください。";
        this["NotSupportedEncoding"] = "{0} {1} に対するエンコード化はサポートされていません。";
        this["Object_Sealed"] = "オブジェクトがシールドされた後は変更できません。";
        this["OPD_DefaultInteraction"] = "マウス ドラッグ操作";
        this["OPD_DragPan"] = "サーフェスのパン";
        this["OPD_DragZoom"] = "選択領域にズーム";
        this["OPD_ScaleToFit"] = "画面に合わせる";
        this["OPD_ScaleToFit_SeriesViewer"] = "ズームのリセット (100%)";
        this["OPD_ZoomIn"] = "拡大";
        this["OPD_ZoomOut"] = "縮小";
        this["OPD_ZoomTo100"] = "100% にズーム";
        this["PieChart_Others"] = "その他";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "データ ソースの範囲を基にした変更は現在サポートされていません。";
        this["ScatterSeries_Value"] = "値";
        this["TRIAL_VERSION"] = "トライアル版 (購入は jp.infragistics.com)";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleJaModule {
    static register() {
        Localization.register("DataVisualization-ja", new DataVisualizationLocaleJa());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleKo {
    constructor() {
        this["AssemblyNotIncluded"] = "{0}.dll 을 로딩할 수 없습니다. 예를 들면, 프로젝트에서 참조를 추가하여 이 어셈블리가 Windows Phone 에 배포된 XAP 에 포함되어 있는지 확인해야 합니다.";
        this["BreakEvenTitle_BreakEven"] = "손익분기점";
        this["BreakEvenTitle_FixedCost"] = "고정 비용";
        this["BreakEvenTitle_LossArea"] = "손실 영역";
        this["BreakEvenTitle_MarginalProfit"] = "한계 수익";
        this["BreakEvenTitle_ProfitArea"] = "수익 영역";
        this["BreakEvenTitle_SafetyMargin"] = "안전 여유";
        this["BreakEvenTitle_SalesRevenue"] = "매출 수입";
        this["BreakEvenTitle_TotalCost"] = "총 비용";
        this["BreakEvenTitle_VariableCost"] = "가변 비용";
        this["BubbleSeries_Radius"] = "범위";
        this["DataChart_InteractivityNotLoaded"] = "상호 작용 기능에 접속했지만 차트 상호 작용 모듈이 로딩되지 않았습니다.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "숫자 약어 기능을 사용했지만 숫자 약어 모듈이 로딩되지 않았습니다.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData 기능에 접속했지만 차트 상호 작용 모듈이 로딩되지 않았습니다.";
        this["DataProviderNotInitialized"] = "데이터 제공자를 먼저 초기화하지 않고 사용했습니다. 사용하기 전에 데이터 제공자를 초기화해야 합니다.";
        this["DataSource_Summary_Avg"] = "평균";
        this["DataSource_Summary_Count"] = "총계";
        this["DataSource_Summary_Max"] = "최대";
        this["DataSource_Summary_Min"] = "최소";
        this["DataSource_Summary_Sum"] = "합계";
        this["Default_Series_Title"] = "시리즈 타이틀";
        this["FinancialChart_IndicatorMenu_Header"] = "인디케이터";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "독립형 인디케이터";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "오버레이";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "추세선";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "거래량";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "절대 거래량 지표";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "누적/분포";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "평균 지향 지수";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "평균 참 범위";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "볼린저 밴드 폭";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "차이킨 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "차이킨 변동성";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "커머더티 채널 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "디트렌드 프라이스 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "이지 오브 무브먼트";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "패스트 스토캐스틱 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "강도 지수";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "풀 스토캐스틱 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "시장 촉진 지수";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "매스 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "메디안 프라이스";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "자금 흐름 지표";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "네거티브 볼륨 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "온 밸런스 볼륨";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "퍼센티지 프라이스 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "퍼센티지 볼륨 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "포지티브 볼륨 인덱스";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "프라이스 볼륨 트렌드";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "슬로 스토캐스틱 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "표준 편차";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "스토캐스틱 RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "티피컬 프라이스";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "얼티미트 오실레이터";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "웨이티드 클로즈";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "윌리엄스 %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "볼린저 밴드";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "프라이스 채널";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "큐빅 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "누적 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "지수 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "지수 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "선형 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "대수 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "수정된 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "멱법칙 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "2 차 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "4 차 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "5 차 피팅";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "단순 평균";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "가중 평균";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "영역";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "열";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "선";
        this["FinancialChart_RangeSelector_All"] = "모두";
        this["FinancialChart_RangeSelector_From"] = "부터";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 개월";
        this["FinancialChart_RangeSelector_OneYear"] = "1 년";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 개월";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 개월";
        this["FinancialChart_RangeSelector_To"] = "에";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD (연간 누계)";
        this["FinancialSeries_Close"] = "닫기";
        this["FinancialSeries_High"] = "고";
        this["FinancialSeries_Low"] = "저";
        this["FinancialSeries_Open"] = "열기";
        this["FinancialSeries_Volume"] = "거래량";
        this["NoEncodingsLoaded"] = "인코딩을 찾을 수 없습니다! Infragistics 를 로딩해 주십시오. 어셈블리를 인코딩하거나 사용자 인코딩 작성 방법에 대한 설명서를 참조해 주십시오.";
        this["NotSupportedEncoding"] = "{0} {1} 에 해당하는 인코딩은 지원되지 않습니다.";
        this["Object_Sealed"] = "개체가 확정된 후에는 수정할 수 없습니다.";
        this["OPD_DefaultInteraction"] = "기본 마우스 드래그 상호 작용 선택";
        this["OPD_DragPan"] = "표면 패닝";
        this["OPD_DragZoom"] = "선택 영역 확대";
        this["OPD_ScaleToFit"] = "화면에 맞춤";
        this["OPD_ScaleToFit_SeriesViewer"] = "줌 재설정 (100%)";
        this["OPD_ZoomIn"] = "확대";
        this["OPD_ZoomOut"] = "축소";
        this["OPD_ZoomTo100"] = "줌 100%";
        this["PieChart_Others"] = "기타";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "데이터 소스의 범위를 기반으로 한 수정은 현재 지원되지 않습니다.";
        this["ScatterSeries_Value"] = "값";
        this["TRIAL_VERSION"] = "Infragistics.com 에서 라이선스가 없는 평가판 구입";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleKoModule {
    static register() {
        Localization.register("DataVisualization-ko", new DataVisualizationLocaleKo());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleZhHans {
    constructor() {
        this["AssemblyNotIncluded"] = "无法加载 {0}.dll。您需要确保该程序集包含在部署到 Windows Phone 的 XAP 中，例如，通过在您的任何项目中添加对该程序集的引用。";
        this["BreakEvenTitle_BreakEven"] = "收支平衡";
        this["BreakEvenTitle_FixedCost"] = "固定成本";
        this["BreakEvenTitle_LossArea"] = "损失区";
        this["BreakEvenTitle_MarginalProfit"] = "边际利润";
        this["BreakEvenTitle_ProfitArea"] = "利润区";
        this["BreakEvenTitle_SafetyMargin"] = "安全边际";
        this["BreakEvenTitle_SalesRevenue"] = "销售收入";
        this["BreakEvenTitle_TotalCost"] = "总成本";
        this["BreakEvenTitle_VariableCost"] = "可变成本";
        this["BubbleSeries_Radius"] = "半径";
        this["DataChart_InteractivityNotLoaded"] = "已访问交互功能，但尚未加载图表交互模块。";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "已使用数字缩写功能，但尚未加载数字缩写模块。";
        this["DataChart_VisualDataNotLoaded"] = "已访问 VisualData 功能，但尚未加载图表交互模块。";
        this["DataProviderNotInitialized"] = "使用数据提供者时未先初始化。数据提供者必须在使用前初始化。";
        this["DataSource_Summary_Avg"] = "平均";
        this["DataSource_Summary_Count"] = "计算";
        this["DataSource_Summary_Max"] = "最大";
        this["DataSource_Summary_Min"] = "最小";
        this["DataSource_Summary_Sum"] = "合计";
        this["Default_Series_Title"] = "系列标题";
        this["FinancialChart_IndicatorMenu_Header"] = "指标";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "独立指标";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "叠加";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "趋势线";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "成交量";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "绝对交易量震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "累积分配";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "平均方向指数";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "平均真实范围";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "布林带宽度";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "佳庆摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "佳庆波动性指标";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "商品渠道指数";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "去趋势价格震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "轻松移动";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "快速随机摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "力指数";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "全随机摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "市场促进指数";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "质量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "中位数价格";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "资金流量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "平滑移动平均线 (MACD)";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "负成交量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "平衡交易量指标";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "百分比价格震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "百分比交易量震荡指标";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "正成交量指数";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "价量趋势";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "变动率 (ROC)";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "相对强弱指数 (RSI)";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "慢速随机摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "标准偏差";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "随机相对强弱指数";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "三重指数平滑平均线 (TRIX)";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "典型价格";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "终极摆动指标";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "加权收盘价";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "威廉指标";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "布林带";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "价格通道";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "三次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "累积平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "指数平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "指数拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "线性拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "对数拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "修正平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "幂律拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "二次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "四次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "五次拟合";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "简单平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "加权平均值";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "面积图";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "列";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "线";
        this["FinancialChart_RangeSelector_All"] = "全部";
        this["FinancialChart_RangeSelector_From"] = "自";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 个月";
        this["FinancialChart_RangeSelector_OneYear"] = "1 年";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 个月";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 个月";
        this["FinancialChart_RangeSelector_To"] = "至";
        this["FinancialChart_RangeSelector_YearToDate"] = "年初至今";
        this["FinancialSeries_Close"] = "关闭";
        this["FinancialSeries_High"] = "盘高";
        this["FinancialSeries_Low"] = "盘点";
        this["FinancialSeries_Open"] = "打开";
        this["FinancialSeries_Volume"] = "成交量";
        this["NoEncodingsLoaded"] = "未找到编码！请加载 Infragistics.Encoding 程序集或查看文档中如何创建自定义编码。";
        this["NotSupportedEncoding"] = "不支持 {0} {1} 下的编码。";
        this["Object_Sealed"] = "密封物体后，不允许修改。";
        this["OPD_DefaultInteraction"] = "选择默认的鼠标拖动交互";
        this["OPD_DragPan"] = "平移表面";
        this["OPD_DragZoom"] = "缩放到所选区域";
        this["OPD_ScaleToFit"] = "适应屏幕";
        this["OPD_ScaleToFit_SeriesViewer"] = "重置缩放 (100%)";
        this["OPD_ZoomIn"] = "放大";
        this["OPD_ZoomOut"] = "缩小";
        this["OPD_ZoomTo100"] = "缩放至 100%";
        this["PieChart_Others"] = "其他";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "当前不支持基于范围的数据源修改";
        this["ScatterSeries_Value"] = "数值";
        this["TRIAL_VERSION"] = "未经许可的试用版，通过 Infragistics.com 购买";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleZhHansModule {
    static register() {
        Localization.register("DataVisualization-zh-Hans", new DataVisualizationLocaleZhHans());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleZhHant {
    constructor() {
        this["AssemblyNotIncluded"] = "無法載入 {0}.dll。您需要確保此程序集包含在已部署至 Windows Phone 的 XAP 中，例如，從您的任何專案中添加對該程序集的引用。";
        this["BreakEvenTitle_BreakEven"] = "收支平衡";
        this["BreakEvenTitle_FixedCost"] = "固定成本";
        this["BreakEvenTitle_LossArea"] = "損失面積";
        this["BreakEvenTitle_MarginalProfit"] = "邊際利潤";
        this["BreakEvenTitle_ProfitArea"] = "利潤範圍";
        this["BreakEvenTitle_SafetyMargin"] = "安全寬限期";
        this["BreakEvenTitle_SalesRevenue"] = "銷售收入";
        this["BreakEvenTitle_TotalCost"] = "總費用";
        this["BreakEvenTitle_VariableCost"] = "變動成本";
        this["BubbleSeries_Radius"] = "半徑";
        this["DataChart_InteractivityNotLoaded"] = "已存取互動功能，但尚未載入圖表互動模組。";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "已使用數字縮寫功能，但尚未加載數字縮寫模組。";
        this["DataChart_VisualDataNotLoaded"] = "已存取 VisualData 功能，但尚未載入圖表互動模組。";
        this["DataProviderNotInitialized"] = "未先初始化就使用了資料提供者。資料提供者必須在使用前初始化。";
        this["DataSource_Summary_Avg"] = "平均";
        this["DataSource_Summary_Count"] = "計數";
        this["DataSource_Summary_Max"] = "最大";
        this["DataSource_Summary_Min"] = "最小";
        this["DataSource_Summary_Sum"] = "總和";
        this["Default_Series_Title"] = "數列標題";
        this["FinancialChart_IndicatorMenu_Header"] = "指標";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "獨立指標";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "疊加";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "趨勢線";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "成交量";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "絕對成交量震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "累積分佈";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "平均方向指數";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "平均真實範圍";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "布林帶寬度";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "柴金震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "柴金波動率";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "商品通道指數";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "去趨勢價格震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "輕鬆移動";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "快速隨機震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "力指數";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "全隨機震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "市場促進指數";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "質量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "中位數價格";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "資金流量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "負成交量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "平衡成交量指標";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "百分比價格震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "百分比成交量震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "正成交量指數";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "價格量趨勢";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "變動率 (Rate of Change)";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "相對強弱指標 (Relative Strength Index)";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "慢速隨機震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "標準差";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "随機相對强弱指數";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "典型價格";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "終極震盪指標";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "加權關閉";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "威廉指數";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "布林帶";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "價格頻道";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "立方體調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "累計平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "指數平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "指數調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "線性調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "对数調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "修正平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "幂律擬合";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "二次方調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "四次方調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "五次方調整";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "簡單平均值";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "加權平均值";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "區域";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "列";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "線";
        this["FinancialChart_RangeSelector_All"] = "全部";
        this["FinancialChart_RangeSelector_From"] = "自";
        this["FinancialChart_RangeSelector_OneMonth"] = "1 個月";
        this["FinancialChart_RangeSelector_OneYear"] = "1 年";
        this["FinancialChart_RangeSelector_SixMonths"] = "6 個月";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3 個月";
        this["FinancialChart_RangeSelector_To"] = "至";
        this["FinancialChart_RangeSelector_YearToDate"] = "年初至今";
        this["FinancialSeries_Close"] = "關閉";
        this["FinancialSeries_High"] = "高";
        this["FinancialSeries_Low"] = "低";
        this["FinancialSeries_Open"] = "開啟";
        this["FinancialSeries_Volume"] = "成交量";
        this["NoEncodingsLoaded"] = "未找到任何編碼！請加載 Infragistics.Encoding 程序集或查看文檔，了解如何創建自定義編碼。";
        this["NotSupportedEncoding"] = "不支援 {0} {1} 下的對應編碼。";
        this["Object_Sealed"] = "密封物體後，不允許修改。";
        this["OPD_DefaultInteraction"] = "選擇默認的鼠標拖曳互動";
        this["OPD_DragPan"] = "平移表面";
        this["OPD_DragZoom"] = "縮放選取範圍";
        this["OPD_ScaleToFit"] = "全螢幕";
        this["OPD_ScaleToFit_SeriesViewer"] = "重設縮放 (100%)";
        this["OPD_ZoomIn"] = "放大";
        this["OPD_ZoomOut"] = "縮小";
        this["OPD_ZoomTo100"] = "縮放成 100%";
        this["PieChart_Others"] = "其他";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "當前不支持基於範圍的數據源修改";
        this["ScatterSeries_Value"] = "數值";
        this["TRIAL_VERSION"] = "未授權的試用版，在 Infragistics.com 購買";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleZhHantModule {
    static register() {
        Localization.register("DataVisualization-zh-Hant", new DataVisualizationLocaleZhHant());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class DataVisualizationLocaleEn {
    constructor() {
        this["AssemblyNotIncluded"] = "Cannot load {0}.dll. You need to make sure that this assembly is included in the XAP that is deployed to the Windows Phone, for example, by adding a reference to it from any of your projects.";
        this["BreakEvenTitle_BreakEven"] = "Break Even";
        this["BreakEvenTitle_FixedCost"] = "Fixed Cost";
        this["BreakEvenTitle_LossArea"] = "Loss Area";
        this["BreakEvenTitle_MarginalProfit"] = "Marginal Profit";
        this["BreakEvenTitle_ProfitArea"] = "Profit Area";
        this["BreakEvenTitle_SafetyMargin"] = "Safety Margin";
        this["BreakEvenTitle_SalesRevenue"] = "Sales Revenue";
        this["BreakEvenTitle_TotalCost"] = "Total Cost";
        this["BreakEvenTitle_VariableCost"] = "Variable Cost";
        this["BubbleSeries_Radius"] = "Radius";
        this["DataChart_InteractivityNotLoaded"] = "Interactivity functionality was accessed but chart interaction module has not been loaded.";
        this["DataChart_NumberAbbreviatorNotLoaded"] = "Number abbreviation functionality was used, but the number abbreviator module has not been loaded.";
        this["DataChart_VisualDataNotLoaded"] = "VisualData functionality was accessed but chart interaction module has not been loaded.";
        this["DataProviderNotInitialized"] = "Data provider was used without initializing first. Data provider must be initialized before use.";
        this["DataSource_Summary_Avg"] = "Avg";
        this["DataSource_Summary_Count"] = "Count";
        this["DataSource_Summary_Max"] = "Max";
        this["DataSource_Summary_Min"] = "Min";
        this["DataSource_Summary_Sum"] = "Sum";
        this["Default_Series_Title"] = "Series Title";
        this["FinancialChart_IndicatorMenu_Header"] = "Indicators";
        this["FinancialChart_IndicatorMenu_IndicatorsCategoryHeader"] = "Standalone Indicators";
        this["FinancialChart_IndicatorMenu_OverlaysCategoryHeader"] = "Overlays";
        this["FinancialChart_IndicatorMenu_TrendlinesCategoryHeader"] = "Trendlines";
        this["FinancialChart_IndicatorMenu_VolumeCategoryHeader"] = "Volumes";
        this["FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator"] = "Absolute Volume Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution"] = "Accumulation/Distribution";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex"] = "Average Directional Index";
        this["FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange"] = "Average True Range";
        this["FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth"] = "Bollinger Band Width";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator"] = "Chaikin Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility"] = "Chaikin Volatility";
        this["FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex"] = "Commodity Channel Index";
        this["FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator"] = "Detrended Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement"] = "Ease Of Movement";
        this["FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator"] = "Fast Stochastic Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_ForceIndex"] = "Force Index";
        this["FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator"] = "Full Stochastic Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex"] = "Market Facilitation Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MassIndex"] = "Mass Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MedianPrice"] = "Median Price";
        this["FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex"] = "Money Flow Index";
        this["FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence"] = "MACD";
        this["FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex"] = "Negative Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume"] = "On Balance Volume";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator"] = "Percentage Price Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator"] = "Percentage Volume Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex"] = "Positive Volume Index";
        this["FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend"] = "Price Volume Trend";
        this["FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum"] = "ROC";
        this["FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex"] = "RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator"] = "Slow Stochastic Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_StandardDeviation"] = "Standard Deviation";
        this["FinancialChart_IndicatorsMenu_Indicator_StochRSI"] = "Stoch RSI";
        this["FinancialChart_IndicatorsMenu_Indicator_TRIX"] = "TRIX";
        this["FinancialChart_IndicatorsMenu_Indicator_TypicalPrice"] = "Typical Price";
        this["FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator"] = "Ultimate Oscillator";
        this["FinancialChart_IndicatorsMenu_Indicator_WeightedClose"] = "Weighted Close";
        this["FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR"] = "Williams %R";
        this["FinancialChart_IndicatorsMenu_Overlay_BollingerBands"] = "Bollinger Bands";
        this["FinancialChart_IndicatorsMenu_Overlay_PriceChannel"] = "Price Channel";
        this["FinancialChart_IndicatorsMenu_TrendLine_CubicFit"] = "Cubic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage"] = "Cumulative Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage"] = "Exponential Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit"] = "Exponential Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_LinearFit"] = "Linear Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit"] = "Logarithmic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage"] = "Modified Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit"] = "PowerLaw Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit"] = "Quadratic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuarticFit"] = "Quartic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_QuinticFit"] = "Quintic Fit";
        this["FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage"] = "Simple Average";
        this["FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage"] = "Weighted Average";
        this["FinancialChart_IndicatorsMenu_Volume_Area"] = "Area";
        this["FinancialChart_IndicatorsMenu_Volume_Column"] = "Column";
        this["FinancialChart_IndicatorsMenu_Volume_Line"] = "Line";
        this["FinancialChart_RangeSelector_All"] = "All";
        this["FinancialChart_RangeSelector_From"] = "From";
        this["FinancialChart_RangeSelector_OneMonth"] = "1M";
        this["FinancialChart_RangeSelector_OneYear"] = "1Y";
        this["FinancialChart_RangeSelector_SixMonths"] = "6M";
        this["FinancialChart_RangeSelector_ThreeMonths"] = "3M";
        this["FinancialChart_RangeSelector_To"] = "To";
        this["FinancialChart_RangeSelector_YearToDate"] = "YTD";
        this["FinancialSeries_Close"] = "Close";
        this["FinancialSeries_High"] = "High";
        this["FinancialSeries_Low"] = "Low";
        this["FinancialSeries_Open"] = "Open";
        this["FinancialSeries_Volume"] = "Volume";
        this["NoEncodingsLoaded"] = "No Encodings are found! Please load the Infragistics.Encoding assembly or look at the documentation how to create custom encodings.";
        this["NotSupportedEncoding"] = "The encoding corresponding under the {0} {1} is not supported.";
        this["Object_Sealed"] = "Modifications are not permitted after the object has been sealed.";
        this["OPD_DefaultInteraction"] = "Select the default mouse drag interaction";
        this["OPD_DragPan"] = "Pan the surface";
        this["OPD_DragZoom"] = "Zoom in to selection area";
        this["OPD_ScaleToFit"] = "Fit to Screen";
        this["OPD_ScaleToFit_SeriesViewer"] = "Reset Zoom (100%)";
        this["OPD_ZoomIn"] = "Zoom in";
        this["OPD_ZoomOut"] = "Zoom out";
        this["OPD_ZoomTo100"] = "Zoom to 100%";
        this["PieChart_Others"] = "Others";
        this["RangeModificationsNotSupportRangeModificationsNotSupported"] = "Range based modifications of the data source are not currently supported";
        this["ScatterSeries_Value"] = "Value";
        this["TRIAL_VERSION"] = "UNLICENSED TRIAL Buy at Infragistics.com";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDataVisualizationLocaleEnModule {
    static register() {
        Localization.register("DataVisualization-en", new DataVisualizationLocaleEn());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinkedListNode$1 = /*@__PURE__*/ (() => {
    class LinkedListNode$1 extends Base {
        constructor($t, a, ..._rest) {
            super();
            this.$t = null;
            this.c = null;
            this.b = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.c = c;
                    }
                    break;
            }
        }
    }
    LinkedListNode$1.$t = /*@__PURE__*/ markType(LinkedListNode$1, 'LinkedListNode$1');
    return LinkedListNode$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinkedList$1 = /*@__PURE__*/ (() => {
    class LinkedList$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.a = null;
            this.b = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        get c() {
            return this.a;
        }
        get d() {
            return this.b;
        }
        e(a) {
            if (this.a == null) {
                this.a = new LinkedListNode$1(this.$t, 1, a);
                this.b = this.a;
            }
            else {
                let b = this.a;
                this.a = new LinkedListNode$1(this.$t, 1, a);
                this.a.a = b;
                b.b = this.a;
            }
        }
        f(a) {
            if (this.b == null) {
                this.a = new LinkedListNode$1(this.$t, 1, a);
                this.b = this.a;
            }
            else {
                let b = this.b;
                this.b = new LinkedListNode$1(this.$t, 1, a);
                this.b.b = b;
                b.a = this.b;
            }
        }
        i() {
            this.h(this.c);
        }
        g() {
            this.a = null;
            this.b = null;
        }
        h(a) {
            if (this.a == a) {
                this.a = a.a;
                if (a.a != null) {
                    a.a.b = null;
                }
            }
            if (this.b == a) {
                this.b = a.b;
                if (a.b != null) {
                    a.b.a = null;
                }
            }
            if (a.b != null) {
                a.b.a = a.a;
            }
            if (a.a != null) {
                a.a.b = a.b;
            }
            a.a = null;
            a.b = null;
        }
    }
    LinkedList$1.$t = /*@__PURE__*/ markType(LinkedList$1, 'LinkedList$1');
    return LinkedList$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LRUCacheItem$2 = /*@__PURE__*/ (() => {
    class LRUCacheItem$2 extends Base {
        constructor($tKey, $tValue) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.a = null;
            this.b = null;
            this.c = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
        }
    }
    LRUCacheItem$2.$t = /*@__PURE__*/ markType(LRUCacheItem$2, 'LRUCacheItem$2');
    return LRUCacheItem$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LRUCache$2 = /*@__PURE__*/ (() => {
    class LRUCache$2 extends Base {
        constructor($tKey, $tValue, a, ..._rest) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.f = 0;
            this.e = null;
            this.a = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.e = new LinkedList$1(LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue));
                            this.a = new FastIterationDictionary$2(this.$tKey, LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue), 1, g);
                            this.f = f;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.e = new LinkedList$1(LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue));
                        this.a = new FastIterationDictionary$2(this.$tKey, LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue), 1, d);
                        this.f = c;
                    }
                    break;
            }
        }
        get h() {
            return this.f;
        }
        set h(a) {
            this.f = a;
            while (this.a.r > this.f) {
                this.j(this.e.d.c.a);
            }
        }
        get b() {
            return this.a;
        }
        d(a) {
            return this.a.d(a);
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (!this.a.d(a)) {
                    let c = new LRUCacheItem$2(this.$tKey, this.$tValue);
                    c.b = b;
                    c.a = a;
                    this.e.e(c);
                    c.c = this.e.c;
                    this.a.s(a, c);
                }
                else {
                    let d = this.item(a);
                    this.a.item(a).b = b;
                }
                while (this.a.r > this.f) {
                    this.j(this.e.d.c.a);
                }
                return b;
            }
            else {
                if (!this.a.d(a)) {
                    return Type.getDefaultValue(this.$tValue);
                }
                let b = this.a.item(a);
                let c = b.c;
                this.e.h(c);
                this.e.e(c.c);
                b.c = this.e.c;
                return b.b;
            }
        }
        j(a) {
            if (!this.a.d(a)) {
                return;
            }
            let b = this.a.item(a);
            this.e.h(b.c);
            this.a.f(b.a);
        }
        i() {
            this.a.u();
            this.e = new LinkedList$1(LRUCacheItem$2.$.specialize(this.$tKey, this.$tValue));
        }
        get g() {
            return this.a.r;
        }
    }
    LRUCache$2.$t = /*@__PURE__*/ markType(LRUCache$2, 'LRUCache$2');
    return LRUCache$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationState = /*@__PURE__*/ (() => {
    class AnimationState extends Base {
        constructor() {
            super(...arguments);
            this.e = 0;
            this.d = 0;
            this.i = null;
            this.g = 0;
            this.c = new Date();
            this.a = null;
            this.f = null;
            this.j = null;
            this.h = 0;
            this.b = false;
        }
    }
    AnimationState.$t = /*@__PURE__*/ markType(AnimationState, 'AnimationState');
    return AnimationState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationManager = /*@__PURE__*/ (() => {
    class AnimationManager extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.c = new Dictionary$2(String_$type, AnimationState.$, 0);
            this.b = false;
            this.e = -1;
            this.a = a;
        }
        d() {
            return dateNow();
        }
        h(a, b, c, d, e, f, g) {
            let h = new AnimationState();
            h.d = f;
            h.e = g;
            h.i = b;
            h.g = c;
            h.c = this.d();
            h.a = d;
            h.f = e;
            this.f(h);
        }
        g(a, b, c, d, e) {
            let f = new AnimationState();
            f.j = a;
            f.i = b;
            f.g = c;
            f.c = this.d();
            f.a = d;
            f.f = e;
            this.f(f);
        }
        f(a) {
            if (this.c.containsKey(a.j)) {
                this.i(a.j, 0);
            }
            this.c.addItem(a.j, a);
            this.j();
            this.a.requestFrame(this.e);
        }
        i(a, b) {
            if (!this.c.containsKey(a)) {
                return;
            }
            let c = this.c.item(a);
            let d = c.a;
            if (b == 2) {
                c.a(c.f(0), c);
            }
            if (b == 1) {
                c.a(c.f(1), c);
            }
            this.c.removeItem(a);
            this.j();
        }
        j() {
            if (this.c.count == 0) {
                this.m();
            }
            else {
                this.l();
            }
        }
        l() {
            if (this.b) {
                return;
            }
            this.b = true;
            this.e = this.a.setupTicking(runOn(this, this.n));
        }
        m() {
            if (this.b) {
                this.a.teardownTicking(this.e);
                this.e = -1;
            }
            this.b = false;
        }
        n() {
            let a = dateNow();
            let b = new List$1(String_$type, 0);
            for (let c of fromEnum(this.c.values)) {
                let d = false;
                let e = (a.getTime() - c.c.getTime());
                if (e >= c.g) {
                    e = c.g;
                    d = true;
                }
                if ((e - c.h < 16 && e != c.g)) {
                    continue;
                }
                c.h = e;
                c.b = d;
                let f = (e / c.g);
                f = c.f(f);
                c.a(f, c);
                if (d) {
                    b.add(c.j);
                }
            }
            for (let g of fromEnum(b)) {
                this.c.removeItem(g);
            }
            this.j();
            if (this.b) {
                this.a.requestFrame(this.e);
            }
        }
        k() {
            this.c.clear();
            this.m();
        }
    }
    AnimationManager.$t = /*@__PURE__*/ markType(AnimationManager, 'AnimationManager');
    return AnimationManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CancelBehavior = /*@__PURE__*/ (function (CancelBehavior) {
    CancelBehavior[CancelBehavior["KeepCurrent"] = 0] = "KeepCurrent";
    CancelBehavior[CancelBehavior["ToEnd"] = 1] = "ToEnd";
    CancelBehavior[CancelBehavior["ToBeginning"] = 2] = "ToBeginning";
    return CancelBehavior;
})({});
/**
 * @hidden
 */
let CancelBehavior_$type = /*@__PURE__*/ markEnum('CancelBehavior', 'KeepCurrent,0|ToEnd,1|ToBeginning,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITickProvider_$type = /*@__PURE__*/ new Type(null, 'ITickProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ErrorMessageDisplayingEventArgs = /*@__PURE__*/ (() => {
    class ErrorMessageDisplayingEventArgs extends EventArgs {
        constructor(a) {
            super();
            this.b = null;
            this.errorMessage = a;
        }
        get errorMessage() {
            return this.b;
        }
        set errorMessage(a) {
            this.b = a;
        }
    }
    ErrorMessageDisplayingEventArgs.$t = /*@__PURE__*/ markType(ErrorMessageDisplayingEventArgs, 'ErrorMessageDisplayingEventArgs', EventArgs.$);
    return ErrorMessageDisplayingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemColumnInternal_$type = /*@__PURE__*/ new Type(null, 'IFastItemColumnInternal');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemColumnPropertyName_$type = /*@__PURE__*/ new Type(null, 'IFastItemColumnPropertyName');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IGetItemAtIndex_$type = /*@__PURE__*/ new Type(null, 'IGetItemAtIndex');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemColumn$1_$type = /*@__PURE__*/ new Type(null, 'IFastItemColumn$1', null, [/*@__PURE__*/ IList$1_$type.specialize(0), IFastItemColumnPropertyName_$type, IGetItemAtIndex_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastReflectionHelper = /*@__PURE__*/ (() => {
    class FastReflectionHelper extends Base {
        constructor(a, b) {
            super();
            this.c = false;
            this._propertyName = null;
            this.a = null;
            this.b = false;
            this.d = false;
            this._index = -1;
            this.k = null;
            this._useTraditionalReflection = false;
            this.useTraditionalReflection = a;
            this.o(b);
        }
        static needsHelper(a) {
            if (a == null) {
                return false;
            }
            if (a != "." && a != null && stringContains(a, ".") || stringContains(a, "[")) {
                return true;
            }
            return false;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            if (a != this.k) {
                this.o(a);
            }
        }
        o(a) {
            this.k = a;
            this._propertyName = a;
            this.c = false;
            if (this._propertyName == ".") {
                this.c = true;
                return;
            }
            if (this._propertyName == null) {
                return;
            }
            let b = false;
            if (stringStartsWith(a, "[")) {
                b = true;
            }
            while (stringStartsWith(a, ".")) {
                a = a.substr(1);
            }
            while (stringStartsWith(a, "[")) {
                a = a.substr(1);
            }
            let c = a.indexOf("[");
            let d = a.indexOf(".");
            let e = -1;
            if (c < 0) {
                e = d;
            }
            else if (d < 0) {
                e = c;
            }
            else {
                e = Math.min(d, c);
            }
            if (e > 0) {
                if (a.charAt(e) == '[' || !b) {
                    let f = a.substr(e, a.length - e);
                    this.a = new FastReflectionHelper(this.useTraditionalReflection, f);
                    this.o(a.substr(0, e));
                    return;
                }
            }
            let g = a.indexOf("]");
            if (g > 0) {
                let h = a.substr(g + 1, a.length - g - 1);
                if (h.length > 0) {
                    this.a = new FastReflectionHelper(this.useTraditionalReflection, h);
                }
                a = a.substr(0, g);
                if (this.f(a)) {
                    this.b = true;
                    this._index = parseInt(a);
                }
                else {
                    this.d = true;
                }
            }
            else {
                this.b = false;
                this.d = false;
            }
            this._propertyName = a;
        }
        f(a) {
            if (a == null) {
                return false;
            }
            let b = a.trim();
            if (b.length == 0) {
                return false;
            }
            for (let c = 0; c < b.length; c++) {
                let d = b.charAt(c);
                let e = d.charCodeAt(0);
                if (48 <= e && e <= 57) {
                    continue;
                }
                return false;
            }
            return true;
        }
        get useTraditionalReflection() {
            return this._useTraditionalReflection;
        }
        set useTraditionalReflection(a) {
            this._useTraditionalReflection = a;
        }
        getPropertyValue(a) {
            let from_ = a;
            if (this.c) {
                return from_;
            }
            let b = null;
            if (this.b) {
                b = from_[this._index];
            }
            else {
                b = from_[this._propertyName];
            }
            if (this.a != null) {
                return this.a.getPropertyValue(b);
            }
            return b;
        }
        setPropertyValue(a, b) {
            let from_ = a;
            let value_ = b;
            if (this.c) {
                return;
            }
            let c = null;
            if (this.b) {
                from_[this._index] = value_;
            }
            else {
                from_[this._propertyName] = value_;
            }
            if (this.a != null) {
                this.a.setPropertyValue(a, b);
            }
        }
        get invalid() {
            return false;
        }
    }
    FastReflectionHelper.$t = /*@__PURE__*/ markType(FastReflectionHelper, 'FastReflectionHelper');
    return FastReflectionHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemColumn = /*@__PURE__*/ (() => {
    class FastItemColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.l = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.j = 0;
            this.i = 0;
            this.h = null;
            this.m = 0;
            this.l = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            if (isNaN_(this.j) && this.h != null) {
                this.j = Number.POSITIVE_INFINITY;
                for (let a of fromEnum(this.h)) {
                    if (!isNaN_(a)) {
                        this.j = Math.min(this.j, a);
                    }
                }
            }
            return this.j;
        }
        set minimum(a) {
            this.j = a;
        }
        get maximum() {
            if (isNaN_(this.i) && this.h != null) {
                this.i = Number.NEGATIVE_INFINITY;
                for (let a of fromEnum(this.h)) {
                    if (!isNaN_(a)) {
                        this.i = Math.max(this.i, a);
                    }
                }
            }
            return this.i;
        }
        set maximum(a) {
            this.i = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.h._inner[a] = b;
                return b;
            }
            else {
                return this.h._inner[a];
            }
        }
        getEnumerator() {
            return this.h.getEnumerator();
        }
        getEnumeratorObject() {
            return this.h.getEnumerator();
        }
        contains(a) {
            return this.h.contains(a);
        }
        copyTo(a, b) {
            this.h.copyTo(a, b);
        }
        get count() {
            return this.h.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.h.indexOf(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.h = null;
            this.minimum = NaN;
            this.maximum = NaN;
            this.m = 0;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = new Array(b);
            let source_ = this.b.asArray();
            let item_;
            let d = this.minimum;
            let e = this.maximum;
            let f = isNaN_(this.minimum);
            let g = isNaN_(this.maximum);
            let h = 0;
            let i;
            let j = this.l;
            let sourceItem_ = null;
            let propertyName_ = this._propertyName;
            if (this.e) {
                for (let i_ = a; i_ < a + b; ++i_) {
                    sourceItem_ = source_[i_];
                    if (sourceItem_ == null) {
                        item_ = NaN;
                    }
                    else {
                        item_ = this.a.getPropertyValue(sourceItem_);
                    }
                    if (this.d) {
                        if ((typeof (item_) == 'function')) {
                            item_ = item_.apply(sourceItem_);
                        }
                    }
                    if (j != null) {
                        item_ = j(item_);
                    }
                    i = item_ == null ? NaN : item_;
                    let k = (i != i);
                    if (k) {
                        this.m++;
                    }
                    if (f || i < d) {
                        d = i;
                        f = k;
                    }
                    if (g || i > e) {
                        e = i;
                        g = k;
                    }
                    c[h] = i;
                    h++;
                }
            }
            else {
                if (this.l != null || this.d) {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        if (sourceItem_ == null) {
                            item_ = NaN;
                        }
                        else {
                            item_ = (sourceItem_[propertyName_]);
                        }
                        if (this.d) {
                            if ((typeof (item_) == 'function')) {
                                item_ = item_.apply(sourceItem_);
                            }
                        }
                        if (j != null) {
                            item_ = j(item_);
                        }
                        i = item_ == null ? NaN : item_;
                        let l = (i != i);
                        if (l) {
                            this.m++;
                        }
                        if (f || i < d) {
                            d = i;
                            f = l;
                        }
                        if (g || i > e) {
                            e = i;
                            g = l;
                        }
                        c[h] = i;
                        h++;
                    }
                }
                else {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        if (sourceItem_ == null) {
                            item_ = NaN;
                        }
                        else {
                            item_ = (sourceItem_[propertyName_]);
                        }
                        i = item_ == null ? NaN : item_;
                        let m = (i != i);
                        if (m) {
                            this.m++;
                        }
                        if (f || i < d) {
                            d = i;
                            f = m;
                        }
                        if (g || i > e) {
                            e = i;
                            g = m;
                        }
                        c[h] = i;
                        h++;
                    }
                }
            }
            this.minimum = d;
            this.maximum = e;
            if (this.h == null) {
                this.h = new List$1(Number_$type, 1, c);
            }
            else {
                this.h.t(a, c);
            }
            return true;
        }
        removeRange(a, b) {
            for (let c = a; c < a + b && !isNaN_(this.minimum) && !isNaN_(this.maximum); ++c) {
                if (this.item(c) == this.minimum) {
                    this.minimum = NaN;
                }
                if (this.item(c) == this.maximum) {
                    this.maximum = NaN;
                }
                if (isNaN_(this.item(c))) {
                    this.m--;
                }
            }
            this.h.v(a, b);
            return true;
        }
        r(a, b) {
            if (isNaN_(a)) {
                if (!isNaN_(b)) {
                    if (!isNaN_(this.minimum)) {
                        this.minimum = Math.min(b, this.minimum);
                    }
                    if (!isNaN_(this.maximum)) {
                        this.maximum = Math.max(b, this.maximum);
                    }
                }
                return;
            }
            if (isNaN_(b)) {
                this.minimum = !isNaN_(this.minimum) && a == this.minimum ? NaN : this.minimum;
                this.maximum = !isNaN_(this.maximum) && a == this.maximum ? NaN : this.maximum;
                return;
            }
            if (!isNaN_(this.minimum)) {
                if (a == this.minimum && b > this.minimum) {
                    this.minimum = NaN;
                }
                else {
                    this.minimum = Math.min(b, this.minimum);
                }
            }
            if (!isNaN_(this.maximum)) {
                if (a == this.maximum && b < this.maximum) {
                    this.maximum = NaN;
                }
                else {
                    this.maximum = Math.max(b, this.maximum);
                }
            }
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.h._inner[a + d];
                let f = this.k(this.c.item(a + d));
                if (isNaN_(e)) {
                    this.m--;
                }
                if (isNaN_(f)) {
                    this.m++;
                }
                if (e != f) {
                    this.h._inner[a + d] = f;
                    c = true;
                    this.r(e, f);
                }
            }
            return c;
        }
        k(a) {
            if (a == null) {
                return NaN;
            }
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.l != null) {
                a = this.l(a);
            }
            if (a == null) {
                return NaN;
            }
            return a;
        }
        get mayContainUnknowns() {
            return this.m > 0;
        }
        static p(a, b) {
            FastItemColumn.q(a, 0, a.count - 1, b);
        }
        static q(a, b, c, d) {
            if (b < c) {
                let e = FastItemColumn.n(a, b, c, d);
                FastItemColumn.q(a, b, e - 1, d);
                FastItemColumn.q(a, e + 1, c, d);
            }
        }
        static n(a, b, c, d) {
            let e = a.item(c);
            let f = b;
            for (let g = b; g < c; g++) {
                if (d(a.item(g), e) <= 0) {
                    let h = a.item(f);
                    a.item(f, a.item(g));
                    a.item(g, h);
                    f++;
                }
            }
            let i = a.item(f);
            a.item(f, a.item(c));
            a.item(c, i);
            return f;
        }
        static g(a, b) {
            let c = new List$1(Number_$type, 2, a.count);
            for (let d = 0; d < a.count; d++) {
                c.add(d);
            }
            if (a.count < 22) {
                FastItemColumn.p(c, (e, f) => {
                    let g = a.item(typeGetValue(e));
                    let h = a.item(typeGetValue(f));
                    return b(g, h);
                });
            }
            else {
                c.aa((e, f) => {
                    let g = a.item(e);
                    let h = a.item(f);
                    return b(g, h);
                });
            }
            return c;
        }
        f() {
            return FastItemColumn.g(this.h, (a, b) => {
                let c = a;
                let d = b;
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.h.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
    }
    FastItemColumn.$t = /*@__PURE__*/ markType(FastItemColumn, 'FastItemColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Number_$type)]);
    return FastItemColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemDateTimeColumn = /*@__PURE__*/ (() => {
    class FastItemDateTimeColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.m = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.g = false;
            this.f = false;
            this.k = new Date();
            this.j = new Date();
            this.i = null;
            this.m = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            if (!this.g && this.i != null) {
                for (let a of fromEnum(this.i)) {
                    if (a < this.k) {
                        this.k = a;
                    }
                }
                if (this.i.count > 0) {
                    this.g = true;
                }
            }
            return this.k;
        }
        set minimum(a) {
            this.k = a;
        }
        get maximum() {
            if (!this.f && this.i != null) {
                for (let a of fromEnum(this.i)) {
                    if (a > this.j) {
                        this.j = a;
                    }
                }
                if (this.i.count > 0) {
                    this.f = true;
                }
            }
            return this.j;
        }
        set maximum(a) {
            this.j = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.i._inner[a];
            }
        }
        getEnumerator() {
            return this.i.getEnumerator();
        }
        getEnumeratorObject() {
            return this.i.getEnumerator();
        }
        contains(a) {
            return this.i.contains(a);
        }
        copyTo(a, b) {
            this.i.copyTo(a, b);
        }
        get count() {
            return this.i.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.i.indexOf(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.i = null;
            this.g = false;
            this.f = false;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = new Array(b);
            let source_ = this.b.asArray();
            let item_;
            let d = this.minimum;
            let e = this.maximum;
            let f;
            let g = 0;
            let h = this.m;
            let propertyName_ = this._propertyName;
            let sourceItem_ = null;
            if (this.e) {
                for (let i_ = a; i_ < a + b; ++i_) {
                    sourceItem_ = source_[i_];
                    item_ = this.a.getPropertyValue(sourceItem_);
                    if (this.d) {
                        if ((typeof (item_) == 'function')) {
                            item_ = item_.apply(sourceItem_);
                        }
                    }
                    if (h != null) {
                        item_ = h(item_);
                    }
                    f = item_ == null ? (new Date()) : item_;
                    if (!this.g) {
                        d = f;
                        this.g = true;
                    }
                    else if (f < d) {
                        d = f;
                    }
                    if (!this.f) {
                        e = f;
                        this.f = true;
                    }
                    else if (f > e) {
                        e = f;
                    }
                    c[g] = f;
                    g++;
                }
            }
            else {
                if (this.m != null || this.d) {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        item_ = (source_[i_][propertyName_]);
                        if (this.d) {
                            if ((typeof (item_) == 'function')) {
                                item_ = item_.apply(sourceItem_);
                            }
                        }
                        if (h != null) {
                            item_ = h(item_);
                        }
                        f = item_ == null ? (new Date()) : item_;
                        if (!this.g) {
                            d = f;
                            this.g = true;
                        }
                        else if (f < d) {
                            d = f;
                        }
                        if (!this.f) {
                            e = f;
                            this.f = true;
                        }
                        else if (f > e) {
                            e = f;
                        }
                        c[g] = f;
                        g++;
                    }
                }
                else {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        item_ = (source_[i_][propertyName_]);
                        f = item_ == null ? (new Date()) : item_;
                        if (!this.g) {
                            d = f;
                            this.g = true;
                        }
                        else if (f < d) {
                            d = f;
                        }
                        if (!this.f) {
                            e = f;
                            this.f = true;
                        }
                        else if (f > e) {
                            e = f;
                        }
                        c[g] = f;
                        g++;
                    }
                }
            }
            this.minimum = d;
            this.maximum = e;
            if (this.i == null) {
                this.i = new List$1(Date_$type, 1, c);
            }
            else {
                this.i.t(a, c);
            }
            return true;
        }
        removeRange(a, b) {
            for (let c = a; c < a + b; ++c) {
                if (+(this.item(c)) == +(this.minimum)) {
                    this.g = false;
                }
                if (+(this.item(c)) == +(this.maximum)) {
                    this.f = false;
                }
            }
            this.i.v(a, b);
            return true;
        }
        p(a, b) {
            if (+a != +(dateMinValue())) {
                if (+b != +(dateMinValue())) {
                    this.minimum = b < this.minimum ? b : this.minimum;
                    this.maximum = b > this.maximum ? b : this.maximum;
                }
                return;
            }
            this.minimum = b < this.minimum ? b : this.minimum;
            this.maximum = b > this.maximum ? b : this.maximum;
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.i._inner[a + d];
                let f = this.l(this.c.item(a + d));
                if (+e != +f) {
                    this.i._inner[a + d] = f;
                    c = true;
                    this.p(e, f);
                }
            }
            return c;
        }
        l(a) {
            if (a == null) {
                return dateMinValue();
            }
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.m != null) {
                a = this.m(a);
            }
            if (a == null) {
                return dateMinValue();
            }
            return a;
        }
        get mayContainUnknowns() {
            return true;
        }
        h() {
            return FastItemColumn.g(this.i, (a, b) => {
                let c = a;
                let d = b;
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.i.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
        static o() {
            TypeRegistrar.register("FastItemDateTimeColumn", FastItemDateTimeColumn.$);
        }
    }
    FastItemDateTimeColumn.$t = /*@__PURE__*/ markType(FastItemDateTimeColumn, 'FastItemDateTimeColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Date_$type)]);
    return FastItemDateTimeColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemObjectColumn = /*@__PURE__*/ (() => {
    class FastItemObjectColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.h = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.j = null;
            this.i = null;
            this.g = null;
            this.h = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            return this.j;
        }
        set minimum(a) {
            this.j = a;
        }
        get maximum() {
            return this.i;
        }
        set maximum(a) {
            this.i = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.g._inner[a];
            }
        }
        getEnumerator() {
            return this.g.getEnumerator();
        }
        getEnumeratorObject() {
            return this.g.getEnumerator();
        }
        contains(a) {
            return this.g.contains1(a);
        }
        copyTo(a, b) {
            this.g.copyTo(a, b);
        }
        get count() {
            return this.g.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.g.indexOf1(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.g = null;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = ((() => {
                let $ret = new List$1(Base.$, 0);
                $ret.h = b;
                return $ret;
            })());
            for (let d = a; d < a + b; ++d) {
                let e = this.k(this.c.item(d));
                c.add1(e);
            }
            if (this.g == null) {
                this.g = c;
            }
            else {
                this.g.t(a, (c));
            }
            return true;
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.g._inner[a + d];
                let f = this.k(this.c.item(a + d));
                if (e != f) {
                    this.g._inner[a + d] = f;
                    c = true;
                }
            }
            return c;
        }
        removeRange(a, b) {
            this.g.v(a, b);
            return true;
        }
        k(a) {
            if (a == null) {
                return null;
            }
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.h != null) {
                a = this.h(a);
            }
            return a;
        }
        get mayContainUnknowns() {
            return true;
        }
        f() {
            return FastItemColumn.g(this.g, (a, b) => {
                let c = parseFloat(a);
                let d = parseFloat(b);
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.g.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
        static m() {
            TypeRegistrar.register("FastItemObjectColumn", FastItemObjectColumn.$);
        }
    }
    FastItemObjectColumn.$t = /*@__PURE__*/ markType(FastItemObjectColumn, 'FastItemObjectColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Base.$)]);
    return FastItemObjectColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemIntColumn = /*@__PURE__*/ (() => {
    class FastItemIntColumn extends Base {
        constructor(a, b, c, d) {
            super();
            this.h = null;
            this.d = false;
            this.e = false;
            this.a = null;
            this.b = null;
            this._propertyName = null;
            this.j = 0;
            this.i = 0;
            this.g = null;
            this.h = c;
            this.d = d;
            this.propertyName = b;
            this.e = FastReflectionHelper.needsHelper(b);
            if (this.e) {
                this.a = new FastReflectionHelper(true, this.propertyName);
            }
            this.c = a;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
            this.reset();
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get minimum() {
            return this.j;
        }
        set minimum(a) {
            this.j = a;
        }
        get maximum() {
            return this.i;
        }
        set maximum(a) {
            this.i = a;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.g._inner[a];
            }
        }
        getEnumerator() {
            return this.g.getEnumerator();
        }
        getEnumeratorObject() {
            return this.g.getEnumerator();
        }
        contains(a) {
            return this.g.contains(a);
        }
        copyTo(a, b) {
            this.g.copyTo(a, b);
        }
        get count() {
            return this.g.count;
        }
        get isReadOnly() {
            return true;
        }
        indexOf(a) {
            return this.g.indexOf(a);
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            throw new NotImplementedException(0);
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        reset() {
            this.g = null;
            return this.c != null ? this.insertRange(0, this.c.count) : true;
        }
        insertRange(a, b) {
            let c = new Array(b);
            let source_ = this.b.asArray();
            let item_;
            let d = this.minimum;
            let e = this.maximum;
            let f = 0;
            let g = this.h;
            let propertyName_ = this._propertyName;
            let sourceItem_;
            if (this.e) {
                for (let i_ = a; i_ < a + b; ++i_) {
                    sourceItem_ = source_[i_];
                    item_ = typeGetValue(this.a.getPropertyValue(sourceItem_));
                    if (this.d) {
                        if ((typeof (item_) == 'function')) {
                            item_ = item_.apply(sourceItem_);
                        }
                    }
                    if (g != null) {
                        item_ = g(item_);
                    }
                    let h = item_ == null ? 0 : typeGetValue(item_);
                    c[f] = h;
                    f++;
                }
            }
            else {
                if (this.h != null || this.d) {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        sourceItem_ = source_[i_];
                        item_ = (source_[i_][propertyName_]);
                        if (this.d) {
                            if ((typeof (item_) == 'function')) {
                                item_ = item_.apply(sourceItem_);
                            }
                        }
                        if (g != null) {
                            item_ = g(item_);
                        }
                        let i = item_ == null ? 0 : typeGetValue(item_);
                        c[f] = i;
                        f++;
                    }
                }
                else {
                    for (let i_ = a; i_ < a + b; ++i_) {
                        item_ = (source_[i_][propertyName_]);
                        let j = item_ == null ? 0 : typeGetValue(item_);
                        c[f] = j;
                        f++;
                    }
                }
            }
            if (this.g == null) {
                this.g = new List$1(Number_$type, 1, c);
            }
            else {
                this.g.t(a, c);
            }
            return true;
        }
        replaceRange(a, b) {
            let c = false;
            for (let d = 0; d < b; ++d) {
                let e = this.g._inner[a + d];
                let f = this.k(this.c.item(a + d));
                if (e != f) {
                    this.g._inner[a + d] = f;
                    c = true;
                }
            }
            return c;
        }
        removeRange(a, b) {
            this.g.v(a, b);
            return true;
        }
        k(a) {
            let sourceItem_ = a;
            let from_ = a;
            let propertyName_ = this._propertyName;
            if (this.e) {
                a = this.a.getPropertyValue(from_);
            }
            else {
                a = from_[propertyName_];
            }
            if (this.d) {
                from_ = a;
                if ((typeof (from_) == 'function')) {
                    a = from_.apply(sourceItem_);
                }
            }
            if (this.h != null) {
                a = this.h(a);
            }
            if (a == null) {
                return 0;
            }
            return typeGetValue(a);
        }
        get mayContainUnknowns() {
            return true;
        }
        f() {
            return FastItemColumn.g(this.g, (a, b) => {
                let c = typeGetValue(a);
                let d = typeGetValue(b);
                if (c < d) {
                    return -1;
                }
                if (c > d) {
                    return 1;
                }
                return 0;
            });
        }
        asArray() {
            return this.g.asArray();
        }
        getItem(a) {
            return this.item(a);
        }
        static m() {
            TypeRegistrar.register("FastItemIntColumn", FastItemIntColumn.$);
        }
    }
    FastItemIntColumn.$t = /*@__PURE__*/ markType(FastItemIntColumn, 'FastItemIntColumn', Base.$, [IFastItemColumnInternal_$type, /*@__PURE__*/ IFastItemColumn$1_$type.specialize(Number_$type)]);
    return FastItemIntColumn;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemsSource_$type = /*@__PURE__*/ new Type(null, 'IFastItemsSource', null, [IGetItemAtIndex_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnReference = /*@__PURE__*/ (() => {
    class ColumnReference extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.b = 0;
            this.a = a;
            this.b = 0;
        }
    }
    ColumnReference.$t = /*@__PURE__*/ markType(ColumnReference, 'ColumnReference');
    return ColumnReference;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemsSourceEventArgs = /*@__PURE__*/ (() => {
    class FastItemsSourceEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super();
                        this._action = 0;
                        this._position = 0;
                        this._count = 0;
                        this._propertyName = null;
                        this.action = c;
                        this.position = d;
                        this.count = e;
                        this.propertyName = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super();
                        this._action = 0;
                        this._position = 0;
                        this._count = 0;
                        this._propertyName = null;
                        this.action = 3;
                        this.position = c;
                        this.count = 1;
                        this.propertyName = d;
                    }
                    break;
            }
        }
        get action() {
            return this._action;
        }
        set action(a) {
            this._action = a;
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
    }
    FastItemsSourceEventArgs.$t = /*@__PURE__*/ markType(FastItemsSourceEventArgs, 'FastItemsSourceEventArgs', EventArgs.$);
    return FastItemsSourceEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tuple$2 = /*@__PURE__*/ (() => {
    class Tuple$2 extends Base {
        constructor($t1, $t2, a, b) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.c = null;
            this.d = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$type = this.$type.specialize(this.$t1, this.$t2);
            this.c = a;
            this.d = b;
        }
        equals(a) {
            let b = typeCast(Tuple$2.$.specialize(this.$t1, this.$t2), a);
            return b != null && Base.equalsStatic(getBoxIfEnum(this.$t1, this.c), getBoxIfEnum(this.$t1, b.c)) && Base.equalsStatic(getBoxIfEnum(this.$t2, this.d), getBoxIfEnum(this.$t2, b.d));
        }
        getHashCode() {
            let a = 0;
            if (getBoxIfEnum(this.$t1, this.c) != null) {
                a = Base.getHashCodeStatic(this.c);
            }
            if (getBoxIfEnum(this.$t2, this.d) != null) {
                a = a ^ Base.getHashCodeStatic(this.d) << 16;
            }
            return a;
        }
    }
    Tuple$2.$t = /*@__PURE__*/ markType(Tuple$2, 'Tuple$2');
    return Tuple$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemsSource = /*@__PURE__*/ (() => {
    class FastItemsSource extends Base {
        constructor() {
            super();
            this.event = null;
            this.a = new Dictionary$2(String_$type, ColumnReference.$, 0);
            this.d = null;
            this.c = new List$1(Base.$, 0);
            this.b = null;
        }
        o(a, b, c) {
            if (this.event != null) {
                this.event(this, new FastItemsSourceEventArgs(0, a, b, c));
            }
        }
        p(a, b) {
            if (this.event != null) {
                this.event(this, new FastItemsSourceEventArgs(1, a, b));
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            if (this.d == a) {
                return;
            }
            this.m();
            this.d = a;
            this.c.clear();
            this.b = null;
            this.g();
            for (let b of fromEnum(this.a.values)) {
                b.a.reset();
            }
            this.o(1, 0, this.c.count);
        }
        m() {
        }
        n(a, b, c) {
            let d = a;
            switch (c.action) {
                case 0:
                    d.h(c.newStartingIndex, c.newItems);
                    break;
                case 1:
                    d.j(c.oldStartingIndex, c.oldItems);
                    break;
                case 2:
                    d.k(c.newStartingIndex, c.oldItems, c.newItems);
                    break;
                case 4:
                    d.l();
                    break;
            }
        }
        g() {
            this.c.t(this.c.count, this.d);
        }
        h(a, b) {
            if (this.b != null) {
                for (let c = 0; c < b.count; ++c) {
                    this.b.addItem(b.item(c), a + c);
                }
                for (let d = a; d < this.c.count; ++d) {
                    this.b.item(this.c._inner[d], d + b.count);
                }
            }
            this.c.t(a, b);
            for (let e of fromEnum(this.a.values)) {
                e.a.insertRange(a, b.count);
            }
            this.o(1, a, b.count);
        }
        j(a, b) {
            this.c.v(a, b.count);
            if (this.b != null) {
                for (let c of fromEn(b)) {
                    this.b.removeItem(c);
                }
                for (let d = a; d < this.c.count; ++d) {
                    this.b.item(this.c._inner[d], d);
                }
            }
            for (let e of fromEnum(this.a.values)) {
                e.a.removeRange(a, b.count);
            }
            this.o(0, a, b.count);
        }
        k(a, b, c) {
            for (let d = 0; d < c.count; ++d) {
                this.c._inner[a + d] = c.item(d);
            }
            if (this.b != null) {
                for (let e of fromEn(b)) {
                    this.b.removeItem(e);
                }
                for (let f = 0; f < c.count; ++f) {
                    this.b.addItem(c.item(f), a + f);
                }
            }
            for (let g of fromEnum(this.a.values)) {
                g.a.replaceRange(a, c.count);
            }
            this.o(2, a, b.count);
        }
        l() {
            this.c.clear();
            this.b = null;
            this.c.t(0, this.d);
            for (let a of fromEnum(this.a.values)) {
                a.a.reset();
            }
            this.o(4, 0, this.c.count);
        }
        i(a, b) {
            let c = null;
            let d = this.indexOf(a);
            if (d == -1) {
                throw new ArgumentException(1, "item");
            }
            if (stringIsNullOrEmpty(b)) {
                for (let e of fromEnum(this.a)) {
                    e.value.a.replaceRange(d, 1);
                    this.p(d, e.value.a.propertyName);
                }
            }
            else if (b == "Item[]") {
                for (let f of fromEnum(this.a)) {
                    if (f.key != null && stringStartsWith(f.key, "[") && stringEndsWith(f.key, "]")) {
                        f.value.a.replaceRange(d, 1);
                        this.p(d, f.value.a.propertyName);
                    }
                }
            }
            else {
                if (((() => { let g = this.a.tryGetValue(b, c); c = g.p1; return g.ret; })())) {
                    c.a.replaceRange(d, 1);
                }
                if (((() => { let g = this.a.tryGetValue(b + "_object", c); c = g.p1; return g.ret; })())) {
                    c.a.replaceRange(d, 1);
                }
                this.p(d, b);
            }
        }
        get count() {
            return this.c.count;
        }
        item(a) {
            return this.c._inner[a];
        }
        getEnumeratorObject() {
            return this.c.getEnumerator();
        }
        indexOf(a) {
            let b;
            if (this.b == null && this.c.count > 0) {
                this.b = new Dictionary$2(Base.$, Number_$type, 0);
                let contents_ = this.c;
                let index_ = this.b;
                for (let j_ = 0; j_ < this.c.count; j_++) {
                    let c = contents_._inner[j_];
                    if (!this.b.containsKey(c)) {
                        this.b.addItem(c, j_);
                    }
                }
            }
            if (this.b != null && ((() => { let d = this.b.tryGetValue(a, b); b = d.p1; return d.ret; })())) {
                return b;
            }
            else {
                return -1;
            }
        }
        registerColumnDateTime(a, b, c) {
            let d = null;
            if (a != null) {
                let e = null;
                if (!((() => { let f = this.a.tryGetValue(a, e); e = f.p1; return f.ret; })())) {
                    let f = FastItemsSource.f(a).c;
                    e = new ColumnReference(TypeRegistrar.create("FastItemDateTimeColumn", this, f, b, c));
                    this.a.addItem(a, e);
                }
                e.b = e.b + 1;
                d = typeCast(IFastItemColumn$1_$type.specialize(Date_$type), e.a);
            }
            return d;
        }
        registerColumnObject(a, b, c) {
            let d = null;
            let e = a + "_object";
            if (a != null) {
                let f = null;
                if (!((() => { let g = this.a.tryGetValue(e, f); f = g.p1; return g.ret; })())) {
                    let g = FastItemsSource.f(a).c;
                    f = new ColumnReference(TypeRegistrar.create("FastItemObjectColumn", this, g, b, c));
                    this.a.addItem(e, f);
                }
                f.b = f.b + 1;
                d = typeCast(IFastItemColumn$1_$type.specialize(Base.$), f.a);
            }
            return d;
        }
        registerColumnInt(a, b, c) {
            let d = null;
            if (a == null) {
                a = "";
            }
            let e = null;
            if (!((() => { let f = this.a.tryGetValue(a, e); e = f.p1; return f.ret; })())) {
                let f = FastItemsSource.f(a).c;
                e = new ColumnReference(TypeRegistrar.create("FastItemIntColumn", this, f, b, c));
                this.a.addItem(a, e);
            }
            e.b = e.b + 1;
            d = typeCast(IFastItemColumn$1_$type.specialize(Number_$type), e.a);
            return d;
        }
        registerColumn(a, b, c) {
            let d = null;
            if (a == null) {
                a = "";
            }
            let e = null;
            if (!((() => { let f = this.a.tryGetValue(a, e); e = f.p1; return f.ret; })())) {
                let f = FastItemsSource.f(a).c;
                e = new ColumnReference(new FastItemColumn(this, f, b, c));
                this.a.addItem(a, e);
            }
            e.b = e.b + 1;
            d = typeCast(IFastItemColumn$1_$type.specialize(Number_$type), e.a);
            return d;
        }
        deregisterColumn(a) {
            let b = a != null ? a.propertyName : null;
            let c = b;
            if (typeCast(IFastItemColumn$1_$type.specialize(Base.$), a) !== null) {
                c += "_object";
            }
            if (b != null) {
                let d = null;
                if (((() => { let e = this.a.tryGetValue(b, d); d = e.p1; return e.ret; })())) {
                    d.b = d.b - 1;
                    if (d.b == 0) {
                        this.a.removeItem(c);
                    }
                }
            }
        }
        asArray() {
            return this.c.asArray();
        }
        handleCollectionChanged(a) {
            switch (a.action) {
                case 0:
                    this.h(a.newStartingIndex, a.newItems);
                    break;
                case 1:
                    this.j(a.oldStartingIndex, a.oldItems);
                    break;
                case 2:
                    this.k(a.newStartingIndex, a.oldItems, a.newItems);
                    break;
                case 4:
                    this.l();
                    break;
            }
        }
        static f(a) {
            let b = a.split('!');
            if (b.length == 2) {
                return new Tuple$2(String_$type, String_$type, b[0], b[1]);
            }
            else {
                return new Tuple$2(String_$type, String_$type, a, null);
            }
        }
        getItem(a) {
            return this.item(a);
        }
    }
    FastItemsSource.$t = /*@__PURE__*/ markType(FastItemsSource, 'FastItemsSource', Base.$, [IEnumerable_$type, IFastItemsSource_$type]);
    return FastItemsSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastItemsSourceReference = /*@__PURE__*/ (() => {
    class FastItemsSourceReference extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.b = 0;
            this.a = a;
            this.b = 0;
        }
    }
    FastItemsSourceReference.$t = /*@__PURE__*/ markType(FastItemsSourceReference, 'FastItemsSourceReference');
    return FastItemsSourceReference;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFastItemsSourceProvider_$type = /*@__PURE__*/ new Type(null, 'IFastItemsSourceProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IRenderer_$type = /*@__PURE__*/ new Type(null, 'IRenderer');
/**
 * @hidden
 */
let FontInfo = /*@__PURE__*/ (() => {
    class FontInfo extends Base {
        constructor() {
            super();
            this.f = 0;
            this.k = null;
            this.l = null;
            this.m = null;
            this.b = 0;
            this.c = 0;
            this.h = null;
            this.i = null;
            this.j = null;
            this.d = NaN;
            this.e = NaN;
        }
        t(a) {
            if (isNaN_(this.d)) {
                let b = FontUtil.getFontInfoFromString(a, this.fontString);
                this.h = b.n;
                this.b = b.d;
                this.i = b.o;
                this.k = b.q;
                this.l = b.r;
                this.m = b.s;
            }
        }
        get g() {
            return this.f;
        }
        get q() {
            return this.k;
        }
        set q(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.u("FontStyle");
            }
        }
        u(a) {
            if (a != "FontString") {
                this.j = null;
            }
            if (this.f < 100000) {
                this.f++;
            }
            else {
                this.f = 0;
            }
        }
        get r() {
            return this.l;
        }
        set r(a) {
            let b = this.l;
            this.l = a;
            if (this.l != b) {
                this.u("FontVariant");
            }
        }
        get s() {
            return this.m;
        }
        set s(a) {
            let b = this.m;
            this.m = a;
            if (this.m != b) {
                this.u("FontWeight");
            }
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.u("FontSize");
            }
        }
        get e() {
            return this.c;
        }
        set e(a) {
            let b = this.c;
            this.c = a;
            if (this.c != b) {
                this.u("LineHeight");
            }
        }
        get n() {
            return this.h;
        }
        set n(a) {
            let b = this.h;
            this.h = a;
            if (this.h != b) {
                this.u("FontFamily");
            }
        }
        get o() {
            return this.i;
        }
        set o(a) {
            let b = this.i;
            this.i = a;
            if (this.i != b) {
                this.u("FontStretch");
            }
        }
        get fontString() {
            if (this.j == null) {
                FontUtil.updateFontString(this);
            }
            return this.j;
        }
        set fontString(a) {
            let b = this.j;
            this.j = a;
            if (this.j != b) {
                this.u("FontString");
            }
        }
        a() {
            return ((() => {
                let $ret = new FontInfo();
                $ret.q = this.q;
                $ret.r = this.r;
                $ret.s = this.s;
                $ret.d = this.d;
                $ret.e = this.e;
                $ret.n = this.n;
                $ret.o = this.o;
                $ret.fontString = this.fontString;
                return $ret;
            })());
        }
    }
    FontInfo.$t = /*@__PURE__*/ markType(FontInfo, 'FontInfo');
    return FontInfo;
})();
/**
 * @hidden
 */
let FontUtil = /*@__PURE__*/ (() => {
    class FontUtil extends Base {
        static getCurrentFontHeight(a, b) {
            if (a == null) {
                return 14;
            }
            let c = null;
            if (b != null) {
                c = b.fontString;
            }
            return a.getHeightForFontString(c, "M", true);
        }
        static measureStringHeight(a, b, c) {
            let d = a.getHeightForFontString(c.fontString, b, false);
            return d;
        }
        static measureStringWidth1(a, b, c) {
            c.z();
            c.ab(b);
            let d = c.f(a);
            c.y();
            return d;
        }
        static measureStringWidth(a, b, c) {
            c.z();
            c.ac(b);
            let d = c.f(a);
            c.y();
            return d;
        }
        static getDefaultFont(a) {
            if (FontUtil.a == null) {
                FontUtil.a = FontUtil.getFontInfoFromString(a, "12px Verdana");
            }
            return FontUtil.a;
        }
        static getFontSize(a) {
            return a.d;
        }
        static getFontWithNewFontSize(a, b) {
            let c = a.a();
            c.d = b;
            c.fontString = b + "px " + a.n;
            return c;
        }
        static getFontInfoFromString(a, b) {
            a.startCSSQuery();
            a.setCssQueryFontString(b);
            let c = a.getCssDefaultPropertyValue("", "font-style");
            let d = a.getCssDefaultPropertyValue("", "font-variant");
            let e = a.getCssDefaultPropertyValue("", "font-weight");
            e = FontUtil.o(e);
            let f = a.getCssDefaultPropertyValue("", "font-size");
            let g = a.getCssDefaultPropertyValue("", "line-height");
            let h = a.getCssDefaultPropertyValue("", "font-family");
            a.endCSSQuery();
            let i = new FontInfo();
            let j = true;
            b = "";
            if (c.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += c;
            }
            if (d.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += d;
            }
            if (e.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += e;
            }
            if (f.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += f;
            }
            if (g.length > 0) {
                if (!j) {
                    b += "/";
                }
                else {
                    j = false;
                }
                b += g;
            }
            if (h.length > 0) {
                if (!j) {
                    b += " ";
                }
                else {
                    j = false;
                }
                b += h;
            }
            let k = new FontInfo();
            k.n = h;
            k.d = parseFloat(f);
            k.o = "Normal";
            k.q = c;
            k.r = d;
            k.s = e;
            k.fontString = b;
            return k;
        }
        static getFontForClass(a, b) {
            let c = stringEmpty();
            a.startCSSQuery();
            let d = a.getCssDefaultPropertyValue(b, "font-style");
            let e = a.getCssDefaultPropertyValue(b, "font-variant");
            let f = a.getCssDefaultPropertyValue(b, "font-weight");
            f = FontUtil.o(f);
            let g = a.getCssDefaultPropertyValue(b, "font-size");
            let h = a.getCssDefaultPropertyValue(b, "line-height");
            let i = a.getCssDefaultPropertyValue(b, "font-family");
            a.endCSSQuery();
            let j = true;
            if (d.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += d;
            }
            if (e.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += e;
            }
            if (f.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += f;
            }
            if (g.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += g;
            }
            if (h.length > 0) {
                if (!j) {
                    c += "/";
                }
                else {
                    j = false;
                }
                c += h;
            }
            if (i.length > 0) {
                if (!j) {
                    c += " ";
                }
                else {
                    j = false;
                }
                c += i;
            }
            let k = new FontInfo();
            k.n = i;
            k.d = parseFloat(g);
            k.o = "Normal";
            k.q = d;
            k.r = e;
            k.s = f;
            k.fontString = c;
            return k;
        }
        static getFont(a) {
            return FontUtil.getFontForClass(a, "");
        }
        static updateFontString(a) {
            let b = stringEmpty();
            let c = a.q;
            let d = a.r;
            let e = a.s;
            let f = a.d.toString();
            let g = "normal";
            let h = a.n;
            let i = true;
            if (c != null && c.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += c;
            }
            if (d != null && d.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += d;
            }
            if (e != null && e.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += e;
            }
            if (f.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += f + "px";
            }
            if (g != null && g.length > 0) {
                if (!i) {
                    b += "/";
                }
                else {
                    i = false;
                }
                b += g;
            }
            if (h != null && h.length > 0) {
                if (!i) {
                    b += " ";
                }
                else {
                    i = false;
                }
                b += h;
            }
            a.fontString = b;
        }
        static getFontInfo(a, b, c) {
            if (c == null) {
                let d = new FontInfo();
                a.startCSSQuery();
                let e = a.getCssDefaultPropertyValue("", "font-style");
                let f = a.getCssDefaultPropertyValue("", "font-variant");
                let g = a.getCssDefaultPropertyValue("", "font-weight");
                g = FontUtil.o(g);
                let h = a.getCssDefaultPropertyValue("", "font-size");
                let i = a.getCssDefaultPropertyValue("", "line-height");
                let j = a.getCssDefaultPropertyValue("", "font-family");
                d.n = stringReplace(j, "'", "");
                d.q = FontUtil.p(e);
                d.s = FontUtil.p(g.toString());
                d.r = f;
                d.e = parseFloat(i);
                d.d = parseFloat(h);
                a.endCSSQuery();
                return d;
            }
            return c;
        }
        static p(a) {
            if (stringIsNullOrEmpty(a)) {
                return stringEmpty();
            }
            let b = a.substr(0, 1).toUpperCase();
            if (a.length > 1) {
                b += a.substr(1);
            }
            return b;
        }
        static toFontInfo(a, b) {
            if (b == null) {
                return null;
            }
            return FontUtil.getFontInfoFromString(a, b);
        }
        static interpolateFont(a, b, c, d) {
            if (c == null) {
                c = d;
            }
            if (d == null) {
                d = c;
            }
            if (c == null && d == null) {
                return;
            }
            if (b > 0.5) {
                a.n = d.n;
                a.o = d.o;
                a.q = d.q;
                a.r = d.r;
                a.s = d.s;
                a.e = d.e;
                a.d = d.d;
            }
            else {
                a.n = c.n;
                a.o = c.o;
                a.q = c.q;
                a.r = c.r;
                a.s = c.s;
                a.e = c.e;
                a.d = c.d;
            }
            if (!isNaN_(c.d) && !isNaN_(d.d)) {
                a.d = c.d + (d.d - c.d) * b;
            }
            FontUtil.updateFontString(a);
        }
        static charsEqual(a, b, c, d) {
            return Base.equalsStatic(a.charAt(b), c[d]);
        }
        static o(a) {
            switch (a) {
                case "400":
                    a = "normal";
                    break;
                case "700":
                case "800":
                    a = "bold";
                    break;
            }
            return a;
        }
    }
    FontUtil.$t = /*@__PURE__*/ markType(FontUtil, 'FontUtil');
    FontUtil.a = null;
    return FontUtil;
})();
/**
 * @hidden
 */
let RenderingContext = /*@__PURE__*/ (() => {
    class RenderingContext extends Base {
        constructor(a, b) {
            super();
            this.c = null;
            this.c = a;
            if (this.c != null) {
                this.c.h$d = b;
            }
        }
        g() {
            if (this.c == null) {
                return null;
            }
            return this.c.h$e();
        }
        get d() {
            if (this.c == null) {
                return false;
            }
            return true;
        }
        v(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$t(a);
        }
        s(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$q(a);
        }
        q(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$o(a);
        }
        w(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$u(a);
        }
        x(a, b, c) {
            if (this.c == null) {
                return;
            }
            this.c.h$v(a, b, c);
        }
        t(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$r(a);
        }
        u(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$s(a);
        }
        p(a, b) {
            if (this.c == null) {
                return;
            }
            this.c.h$n(a, b);
        }
        j(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$h(a);
        }
        r(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$p(a);
        }
        z() {
            if (this.c == null) {
                return;
            }
            this.c.h$x();
        }
        y() {
            if (this.c == null) {
                return;
            }
            this.c.h$w();
        }
        ae(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$ac(a);
        }
        aa(a, b) {
            if (this.c == null) {
                return;
            }
            this.c.h$y(a, b);
        }
        af(a, b) {
            if (this.c == null) {
                return;
            }
            this.c.h$ad(a, b);
        }
        k(a, b, c, d) {
            if (this.c == null) {
                return;
            }
            this.c.h$i(a, b, c, d);
        }
        n(a, b, c, d, e, f, g, h, i, j) {
            if (this.c == null) {
                return;
            }
            this.c.h$l(a, b, c, d, e, f, g, h, i, j);
        }
        m(a, b, c, d, e, f) {
            if (this.c == null) {
                return;
            }
            this.c.h$k(a, b, c, d, e, f);
        }
        a(a, b) {
            if (this.c == null) {
                return null;
            }
            return this.c.h$a(a, b);
        }
        h() {
            if (this.c == null) {
                return null;
            }
            return this.c.h$f();
        }
        b() {
            if (this.c == null) {
                return null;
            }
            return this.c.h$b();
        }
        ab(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$z(a);
        }
        ac(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$aa(a);
        }
        f(a) {
            if (this.c == null) {
                return NaN;
            }
            return this.c.h$c(a);
        }
        e(a) {
            if (this.c == null) {
                return NaN;
            }
            let b = this.c.h$b();
            let c = 0;
            if (b == null) {
                b = this.c.h$f();
            }
            else {
                c = b.g;
            }
            let d = a.ag(b, c);
            if (d >= 0) {
                return d;
            }
            let e = this.c.h$c(a.ak);
            a.al(b, c, e);
            return e;
        }
        ad(a) {
            if (this.c == null) {
                return;
            }
            this.c.h$ab(a);
        }
        i(a, b) {
            if (this.c == null || b == null) {
                return;
            }
            this.c.h$g(a, b);
        }
        o(a, b, c, d) {
            if (this.c == null) {
                return;
            }
            this.c.h$m(a, b, c, d);
        }
        l() {
            if (this.c == null) {
                return;
            }
            this.c.h$j();
        }
    }
    RenderingContext.$t = /*@__PURE__*/ markType(RenderingContext, 'RenderingContext');
    return RenderingContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MathUtil = /*@__PURE__*/ (() => {
    class MathUtil extends Base {
        static a(a) {
            return Math.log(a + Math.sqrt(a * a + 1));
        }
        static n(number_) {
            return number_.toString();
        }
        static e(a, b) {
            return Math.sqrt(a * a + b * b);
        }
        static l(a) {
            return a * a;
        }
        static b(a, b, c) {
            return Math.min(c, Math.max(b, a));
        }
        static k(a) {
            return Math.PI * a / 180;
        }
        static d(a) {
            return 180 * a / Math.PI;
        }
        static i(a, b, c) {
            return Math.min(a, Math.min(b, c));
        }
        static g(a, b, c) {
            return Math.max(a, Math.max(b, c));
        }
        static h(...a) {
            let b = a[0];
            for (let c = 1; c < a.length; ++c) {
                b = Math.min(b, a[c]);
            }
            return b;
        }
        static f(...a) {
            let b = a[0];
            for (let c = 1; c < a.length; ++c) {
                b = Math.max(b, a[c]);
            }
            return b;
        }
    }
    MathUtil.$t = /*@__PURE__*/ markType(MathUtil, 'MathUtil');
    MathUtil.j = (1 + /*@__PURE__*/ Math.sqrt(5)) / 2;
    MathUtil.m = /*@__PURE__*/ Math.sqrt(2);
    return MathUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorUtil = /*@__PURE__*/ (() => {
    class ColorUtil extends Base {
        static w(a) {
            return Color.u(a, ColorUtil.h.next2(0, 255), ColorUtil.h.next2(0, 255), ColorUtil.h.next2(0, 255));
        }
        static x(a) {
            let b = ColorUtil.b(a);
            return ColorUtil.p(b[0], ColorUtil.h.next2(0, 359), b[2], b[3]);
        }
        static u(a, interpolation_, maximum_, b) {
            let min_ = a;
            switch (b) {
                case 1:
                    {
                        let c = ColorUtil.b(a);
                        let d = ColorUtil.b(maximum_);
                        let e = c[1] >= 0 ? c[1] : d[1];
                        let f = d[1] >= 0 ? d[1] : c[1];
                        if (e >= 0 && f >= 0 && Math.abs(f - e) > 180) {
                            if (f > e) {
                                e += 360;
                            }
                            else {
                                f += 360;
                            }
                        }
                        interpolation_ = Math.max(0, Math.min(1, interpolation_));
                        return ColorUtil.p(c[0] + interpolation_ * (d[0] - c[0]), e + interpolation_ * (f - e), c[2] + interpolation_ * (d[2] - c[2]), c[3] + interpolation_ * (d[3] - c[3]));
                    }
                case 0: return Color.u((min_._a + interpolation_ * (maximum_._a - min_._a)), (min_._r + interpolation_ * (maximum_._r - min_._r)), (min_._g + interpolation_ * (maximum_._g - min_._g)), (min_._b + interpolation_ * (maximum_._b - min_._b)));
            }
            return a;
        }
        static s(a, b, c) {
            let d = a[1] >= 0 ? a[1] : c[1];
            let e = c[1] >= 0 ? c[1] : a[1];
            if (d >= 0 && e >= 0 && Math.abs(e - d) > 180) {
                if (e > d) {
                    d += 360;
                }
                else {
                    e += 360;
                }
            }
            b = Math.max(0, Math.min(1, b));
            return ColorUtil.p(a[0] + b * (c[0] - a[0]), d + b * (e - d), a[2] + b * (c[2] - a[2]), a[3] + b * (c[3] - a[3]));
        }
        static v(a, b) {
            let c = ColorUtil.a(a);
            if (b < 0) {
                return ColorUtil.o(c[0], c[1], c[2], c[3] * (1 - MathUtil.b(-b, 0, 1)));
            }
            else {
                return ColorUtil.o(c[0], c[1], c[2], c[3] + MathUtil.b(b, 0, 1) * (1 - c[3]));
            }
        }
        static a(a) {
            let b = new Array(4);
            let c = a.o / 255;
            let d = a.n / 255;
            let e = a.m / 255;
            let f = Math.min(Math.min(c, d), e);
            let g = Math.max(Math.max(c, d), e);
            let h = g - f;
            b[0] = a.l / 255;
            b[3] = (g + f) / 2;
            if (h == 0) {
                b[1] = -1;
                b[2] = 0;
            }
            else {
                b[1] = ColorUtil.f(g, h, c, d, e);
                b[2] = b[3] < 0.5 ? h / (g + f) : h / (2 - g - f);
            }
            return b;
        }
        static b(a) {
            let b = a.l / 255;
            let c = a.o / 255;
            let d = a.n / 255;
            let e = a.m / 255;
            let f = Math.min(c, Math.min(d, e));
            let g = Math.max(c, Math.max(d, e));
            let h = g - f;
            let i = new Array(4);
            i[0] = b;
            i[3] = g;
            if (h == 0) {
                i[1] = -1;
                i[2] = 0;
            }
            else {
                i[1] = ColorUtil.f(g, h, c, d, e);
                i[2] = h / g;
            }
            return i;
        }
        static o(a, b, c, d) {
            let e;
            let f;
            let g;
            if (c == 0) {
                e = d;
                f = d;
                g = d;
            }
            else {
                let h = d < 0.5 ? d * (1 + c) : d + c - (d * c);
                let i = 2 * d - h;
                let j = b / 360;
                e = ColorUtil.e(i, h, j + 1 / 3);
                f = ColorUtil.e(i, h, j);
                g = ColorUtil.e(i, h, j - 1 / 3);
            }
            return Color.u(truncate((a * 255)), truncate((e * 255)), truncate((f * 255)), truncate((g * 255)));
        }
        static p(a, b, c, d) {
            let e;
            let f;
            let g;
            while (b >= 360) {
                b -= 360;
            }
            if (c == 0) {
                e = d;
                f = d;
                g = d;
            }
            else {
                b /= 60;
                let h = Math.floor(b);
                let i = b - h;
                let j = d * (1 - c);
                let k = d * (1 - c * i);
                let l = d * (1 - c * (1 - i));
                switch (truncate(h)) {
                    case 0:
                        e = d;
                        f = l;
                        g = j;
                        break;
                    case 1:
                        e = k;
                        f = d;
                        g = j;
                        break;
                    case 2:
                        e = j;
                        f = d;
                        g = l;
                        break;
                    case 3:
                        e = j;
                        f = k;
                        g = d;
                        break;
                    case 4:
                        e = l;
                        f = j;
                        g = d;
                        break;
                    default:
                        e = d;
                        f = j;
                        g = k;
                        break;
                }
            }
            return Color.u(truncate((a * 255)), truncate((e * 255)), truncate((f * 255)), truncate((g * 255)));
        }
        static f(a, b, c, d, e) {
            let f = c == a ? (d - e) / b : d == a ? 2 + (e - c) / b : 4 + (c - d) / b;
            f *= 60;
            if (f < 0) {
                f += 360;
            }
            return f;
        }
        static e(a, b, c) {
            c = c < 0 ? c + 1 : c > 1 ? c - 1 : c;
            if (c < 1 / 6) {
                return a + ((b - a) * 6 * c);
            }
            if (c < 1 / 2) {
                return b;
            }
            if (c < 2 / 3) {
                return a + ((b - a) * 6 * (2 / 3 - c));
            }
            return a;
        }
        static g(a) {
            let b = a.l / 255;
            let c = truncate((a.o * b));
            let d = truncate((a.n * b));
            let e = truncate((a.m * b));
            return a.l << 24 | c << 16 | d << 8 | e;
        }
        static t(a) {
            return a.color;
        }
        static i(a, b) {
            if (ColorUtil.d == null) {
                ColorUtil.d = new Dictionary$2(String_$type, String_$type, 0);
                for (let c of fromEnum(ColorUtil.c.keys)) {
                    let d = ColorUtil.c.item(c);
                    ColorUtil.d.item(d, c);
                }
            }
            let e = ColorUtil.k(a);
            if (ColorUtil.d.containsKey(e.toLowerCase())) {
                return ColorUtil.d.item(e.toLowerCase());
            }
            if (b) {
                e = ColorUtil.m(a);
            }
            return e;
        }
        static m(a) {
            return "rgba(" + a.o + ", " + a.n + ", " + a.m + ", " + (a.l / 255) + ")";
        }
        static k(a) {
            if (a.l == 255) {
                return "#" + ColorUtil.j(a.o) + ColorUtil.j(a.n) + ColorUtil.j(a.m);
            }
            else {
                return "#" + ColorUtil.j(a.l) + ColorUtil.j(a.o) + ColorUtil.j(a.n) + ColorUtil.j(a.m);
            }
        }
        static j(a) {
            let b = intDivide(a, 16);
            let c = a % 16;
            return ColorUtil.l(b) + ColorUtil.l(c);
        }
        static l(a) {
            switch (a) {
                case 0: return "0";
                case 1: return "1";
                case 2: return "2";
                case 3: return "3";
                case 4: return "4";
                case 5: return "5";
                case 6: return "6";
                case 7: return "7";
                case 8: return "8";
                case 9: return "9";
                case 10: return "a";
                case 11: return "b";
                case 12: return "c";
                case 13: return "d";
                case 14: return "e";
                case 15: return "f";
            }
            return "0";
        }
        static r(a) {
            let b = new Color();
            b.colorString = a;
            return b;
        }
        static q(a) {
            let b = ((() => {
                let $ret = new Color();
                $ret.l = 255;
                return $ret;
            })());
            b = ColorUtil.r(a._fill);
            return b;
        }
        static n(a) {
            let b = null;
            let c = a.colorString;
            b = ((() => {
                let $ret = new Brush();
                $ret.fill = c;
                return $ret;
            })());
            return b;
        }
    }
    ColorUtil.$t = /*@__PURE__*/ markType(ColorUtil, 'ColorUtil');
    ColorUtil.h = /*@__PURE__*/ new Random(0);
    ColorUtil.d = null;
    ColorUtil.c = /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, String_$type, 0);
        $ret.addItem("transparent", "#000000");
        $ret.addItem("aliceblue", "#f0f8ff");
        $ret.addItem("antiquewhite", "#faebd7");
        $ret.addItem("aqua", "#00ffff");
        $ret.addItem("aquamarine", "#7fffd4");
        $ret.addItem("azure", "#f0ffff");
        $ret.addItem("beige", "#f5f5dc");
        $ret.addItem("bisque", "#ffe4c4");
        $ret.addItem("black", "#000000");
        $ret.addItem("blanchedalmond", "#ffebcd");
        $ret.addItem("blue", "#0000ff");
        $ret.addItem("blueviolet", "#8a2be2");
        $ret.addItem("brown", "#a52a2a");
        $ret.addItem("burlywood", "#deb887");
        $ret.addItem("cadetblue", "#5f9ea0");
        $ret.addItem("chartreuse", "#7fff00");
        $ret.addItem("chocolate", "#d2691e");
        $ret.addItem("coral", "#ff7f50");
        $ret.addItem("cornflowerblue", "#6495ed");
        $ret.addItem("cornsilk", "#fff8dc");
        $ret.addItem("crimson", "#dc143c");
        $ret.addItem("cyan", "#00ffff");
        $ret.addItem("darkblue", "#00008b");
        $ret.addItem("darkcyan", "#008b8b");
        $ret.addItem("darkgoldenrod", "#b8860b");
        $ret.addItem("darkgray", "#a9a9a9");
        $ret.addItem("darkgreen", "#006400");
        $ret.addItem("darkkhaki", "#bdb76b");
        $ret.addItem("darkmagenta", "#8b008b");
        $ret.addItem("darkolivegreen", "#556b2f");
        $ret.addItem("darkorange", "#ff8c00");
        $ret.addItem("darkorchid", "#9932cc");
        $ret.addItem("darkred", "#8b0000");
        $ret.addItem("darksalmon", "#e9967a");
        $ret.addItem("darkseagreen", "#8fbc8f");
        $ret.addItem("darkslateblue", "#483d8b");
        $ret.addItem("darkslategray", "#2f4f4f");
        $ret.addItem("darkturquoise", "#00ced1");
        $ret.addItem("darkviolet", "#9400d3");
        $ret.addItem("deeppink", "#ff1493");
        $ret.addItem("deepskyblue", "#00bfff");
        $ret.addItem("dimgray", "#696969");
        $ret.addItem("dodgerblue", "#1e90ff");
        $ret.addItem("feldspar", "#d19275");
        $ret.addItem("firebrick", "#b22222");
        $ret.addItem("floralwhite", "#fffaf0");
        $ret.addItem("forestgreen", "#228b22");
        $ret.addItem("fuchsia", "#ff00ff");
        $ret.addItem("gainsboro", "#dcdcdc");
        $ret.addItem("ghostwhite", "#f8f8ff");
        $ret.addItem("gold", "#ffd700");
        $ret.addItem("goldenrod", "#daa520");
        $ret.addItem("gray", "#808080");
        $ret.addItem("green", "#008000");
        $ret.addItem("greenyellow", "#adff2f");
        $ret.addItem("honeydew", "#f0fff0");
        $ret.addItem("hotpink", "#ff69b4");
        $ret.addItem("indianred", "#cd5c5c");
        $ret.addItem("indigo", "#4b0082");
        $ret.addItem("ivory", "#fffff0");
        $ret.addItem("khaki", "#f0e68c");
        $ret.addItem("lavender", "#e6e6fa");
        $ret.addItem("lavenderblush", "#fff0f5");
        $ret.addItem("lawngreen", "#7cfc00");
        $ret.addItem("lemonchiffon", "#fffacd");
        $ret.addItem("lightblue", "#add8e6");
        $ret.addItem("lightcoral", "#f08080");
        $ret.addItem("lightcyan", "#e0ffff");
        $ret.addItem("lightgoldenrodyellow", "#fafad2");
        $ret.addItem("lightgray", "#d3d3d3");
        $ret.addItem("lightgreen", "#90ee90");
        $ret.addItem("lightpink", "#ffb6c1");
        $ret.addItem("lightsalmon", "#ffa07a");
        $ret.addItem("lightseagreen", "#20b2aa");
        $ret.addItem("lightskyblue", "#87cefa");
        $ret.addItem("lightslateblue", "#8470ff");
        $ret.addItem("lightslategray", "#778899");
        $ret.addItem("lightsteelblue", "#b0c4de");
        $ret.addItem("lightyellow", "#ffffe0");
        $ret.addItem("lime", "#00ff00");
        $ret.addItem("limegreen", "#32cd32");
        $ret.addItem("linen", "#faf0e6");
        $ret.addItem("magenta", "#ff00ff");
        $ret.addItem("maroon", "#800000");
        $ret.addItem("mediumaquamarine", "#66cdaa");
        $ret.addItem("mediumblue", "#0000cd");
        $ret.addItem("mediumorchid", "#ba55d3");
        $ret.addItem("mediumpurple", "#9370d8");
        $ret.addItem("mediumseagreen", "#3cb371");
        $ret.addItem("mediumslateblue", "#7b68ee");
        $ret.addItem("mediumspringgreen", "#00fa9a");
        $ret.addItem("mediumturquoise", "#48d1cc");
        $ret.addItem("mediumvioletred", "#c71585");
        $ret.addItem("midnightblue", "#191970");
        $ret.addItem("mintcream", "#f5fffa");
        $ret.addItem("mistyrose", "#ffe4e1");
        $ret.addItem("moccasin", "#ffe4b5");
        $ret.addItem("navajowhite", "#ffdead");
        $ret.addItem("navy", "#000080");
        $ret.addItem("oldlace", "#fdf5e6");
        $ret.addItem("olive", "#808000");
        $ret.addItem("olivedrab", "#6b8e23");
        $ret.addItem("orange", "#ffa500");
        $ret.addItem("orangered", "#ff4500");
        $ret.addItem("orchid", "#da70d6");
        $ret.addItem("palegoldenrod", "#eee8aa");
        $ret.addItem("palegreen", "#98fb98");
        $ret.addItem("paleturquoise", "#afeeee");
        $ret.addItem("palevioletred", "#d87093");
        $ret.addItem("papayawhip", "#ffefd5");
        $ret.addItem("peachpuff", "#ffdab9");
        $ret.addItem("peru", "#cd853f");
        $ret.addItem("pink", "#ffc0cb");
        $ret.addItem("plum", "#dda0dd");
        $ret.addItem("powderblue", "#b0e0e6");
        $ret.addItem("purple", "#800080");
        $ret.addItem("red", "#ff0000");
        $ret.addItem("rosybrown", "#bc8f8f");
        $ret.addItem("royalblue", "#4169e1");
        $ret.addItem("saddlebrown", "#8b4513");
        $ret.addItem("salmon", "#fa8072");
        $ret.addItem("sandybrown", "#f4a460");
        $ret.addItem("seagreen", "#2e8b57");
        $ret.addItem("seashell", "#fff5ee");
        $ret.addItem("sienna", "#a0522d");
        $ret.addItem("silver", "#c0c0c0");
        $ret.addItem("skyblue", "#87ceeb");
        $ret.addItem("slateblue", "#6a5acd");
        $ret.addItem("slategray", "#708090");
        $ret.addItem("snow", "#fffafa");
        $ret.addItem("springgreen", "#00ff7f");
        $ret.addItem("steelblue", "#4682b4");
        $ret.addItem("tan", "#d2b48c");
        $ret.addItem("teal", "#008080");
        $ret.addItem("thistle", "#d8bfd8");
        $ret.addItem("tomato", "#ff6347");
        $ret.addItem("turquoise", "#40e0d0");
        $ret.addItem("violet", "#ee82ee");
        $ret.addItem("violetred", "#d02090");
        $ret.addItem("wheat", "#f5deb3");
        $ret.addItem("white", "#ffffff");
        $ret.addItem("whitesmoke", "#f5f5f5");
        $ret.addItem("yellow", "#ffff00");
        $ret.addItem("yellowgreen", "#9acd32");
        return $ret;
    })());
    return ColorUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorCollectionUtil = /*@__PURE__*/ (() => {
    class ColorCollectionUtil extends Base {
        static b(a, b) {
            b = MathUtil.b(b, 0, a.count - 1);
            let c = truncate(Math.floor(b));
            if (c == b) {
                return a._inner[c];
            }
            return ColorCollectionUtil.c(b - c, a._inner[c], a._inner[c + 1], a.af);
        }
        static c(a, b, c, d) {
            return ColorUtil.u(b, a, c, d);
        }
        static a(a) {
            let b = new ObservableColorCollection();
            b.o(a);
            return b;
        }
    }
    ColorCollectionUtil.$t = /*@__PURE__*/ markType(ColorCollectionUtil, 'ColorCollectionUtil');
    return ColorCollectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DVSR = /*@__PURE__*/ (() => {
    class DVSR extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
            this.setBundleId("DataVisualization");
        }
        get container() {
            return this.a;
        }
        set container(a) {
            this.a = a;
        }
        getString(resourceName_) {
            let a = stringEmpty();
            resourceName_ = resourceName_.charAt(0).toUpperCase() + resourceName_.substr(1);
            a = this.a.getResourceString(resourceName_);
            return a;
        }
        setBundleId(a) {
            if (this.a != null) {
                this.a.setResourceBundleId(a);
                this.a.setCultureId(Localization.d(a));
            }
        }
    }
    DVSR.$t = /*@__PURE__*/ markType(DVSR, 'DVSR');
    return DVSR;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UnsetValue = /*@__PURE__*/ (() => {
    class UnsetValue extends Base {
    }
    UnsetValue.$t = /*@__PURE__*/ markType(UnsetValue, 'UnsetValue');
    return UnsetValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DependencyObject = /*@__PURE__*/ (() => {
    class DependencyObject extends Base {
        constructor() {
            super();
            this.localValues = null;
            this.a = null;
            this.localValues = DictionaryUtil.dictionaryCreate();
            this.a = DictionaryUtil.dictionaryCreate();
        }
        c(a) {
            if (this.localValues.has(a.name)) {
                return this.localValues.get(a.name);
            }
            return a.l.b;
        }
        h(dp_, a) {
            if (dp_.b) {
                let oldValue_ = null;
                if (this.localValues.has(dp_._name)) {
                    oldValue_ = this.localValues.get(dp_._name);
                }
                ;
                this.localValues.set(dp_._name, a);
                dp_.l.d(this, new DependencyPropertyChangedEventArgs(dp_, a, oldValue_));
            }
            else {
                this.localValues.set(dp_._name, a);
            }
        }
        f(a) {
            this.localValues.delete(a._name);
        }
        e(a) {
            if (this.localValues.has(a._name)) {
                return this.localValues.get(a.name);
            }
            return DependencyProperty.c;
        }
        g(a, b) {
            if (a == null) {
                return;
            }
            this.a.set(a.name, b);
        }
        getValueAlt(a) {
            return this.c(a);
        }
        setValueAlt(dp_, a) {
            this.h(dp_, a);
        }
    }
    DependencyObject.$t = /*@__PURE__*/ markType(DependencyObject, 'DependencyObject');
    return DependencyObject;
})();
/**
 * @hidden
 */
let DependencyProperty = /*@__PURE__*/ (() => {
    class DependencyProperty extends Base {
        constructor(a, b, c) {
            super();
            this._name = null;
            this.f = null;
            this.k = null;
            this.a = false;
            this._name = a;
            this.f = b;
            this.k = c;
            if (this.k != null && this.k.d != null) {
                this.a = true;
            }
            else {
                this.a = false;
            }
        }
        get b() {
            return this.a;
        }
        get l() {
            return this.k;
        }
        get propertyType() {
            return this.f;
        }
        get name() {
            return this._name;
        }
        static i(a, b, c, d) {
            return DependencyPropertiesCollection.c.e(a, b, c, d);
        }
        static h(a, b) {
            if (b == null) {
                return null;
            }
            let c = DependencyPropertiesCollection.c.d(b.typeName + a);
            if (c != null) {
                return c;
            }
            return DependencyProperty.h(a, b.baseType);
        }
        static registerAlt(a, b, c, d) {
            return DependencyProperty.i(a, b, c, d);
        }
    }
    DependencyProperty.$t = /*@__PURE__*/ markType(DependencyProperty, 'DependencyProperty');
    DependencyProperty.c = /*@__PURE__*/ new UnsetValue();
    return DependencyProperty;
})();
/**
 * @hidden
 */
let DependencyPropertiesCollection = /*@__PURE__*/ (() => {
    class DependencyPropertiesCollection extends Base {
        constructor() {
            super();
            this.a = null;
            if (this.a == null) {
                this.a = DictionaryUtil.dictionaryCreate();
            }
        }
        static get c() {
            if (DependencyPropertiesCollection.b == null) {
                DependencyPropertiesCollection.b = new DependencyPropertiesCollection();
            }
            return DependencyPropertiesCollection.b;
        }
        d(a) {
            return this.a.get(a);
        }
        e(a, b, c, d) {
            let e = new DependencyProperty(a, b, d);
            this.a.set(c.typeName + a, e);
            return e;
        }
    }
    DependencyPropertiesCollection.$t = /*@__PURE__*/ markType(DependencyPropertiesCollection, 'DependencyPropertiesCollection');
    DependencyPropertiesCollection.b = null;
    return DependencyPropertiesCollection;
})();
/**
 * @hidden
 */
let DependencyPropertyChangedEventArgs = /*@__PURE__*/ (() => {
    class DependencyPropertyChangedEventArgs extends Base {
        constructor(a, b, c) {
            super();
            this.a = null;
            this.b = null;
            this.e = null;
            this.a = b;
            this.b = c;
            this.e = a;
        }
        get f() {
            return this.e;
        }
        set f(a) {
            this.e = a;
        }
        get newValue() {
            return this.a;
        }
        get oldValue() {
            return this.b;
        }
    }
    DependencyPropertyChangedEventArgs.$t = /*@__PURE__*/ markType(DependencyPropertyChangedEventArgs, 'DependencyPropertyChangedEventArgs');
    return DependencyPropertyChangedEventArgs;
})();
/**
 * @hidden
 */
let PropertyMetadata = /*@__PURE__*/ (() => {
    class PropertyMetadata extends Base {
        constructor(a, ..._rest) {
            super();
            this.a = null;
            this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.b = c;
                        this.d = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.b = null;
                        this.d = c;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.b = c;
                        this.d = d;
                    }
                    break;
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a;
        }
        static createWithCallback(a) {
            return new PropertyMetadata(1, a);
        }
        static createWithDefaultAndCallback(a, b) {
            return new PropertyMetadata(2, a, b);
        }
    }
    PropertyMetadata.$t = /*@__PURE__*/ markType(PropertyMetadata, 'PropertyMetadata');
    return PropertyMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SRProvider = /*@__PURE__*/ (() => {
    class SRProvider extends DependencyObject {
        constructor(a) {
            super();
            this.j = null;
            this.k = null;
            super.toString();
            this.k = a;
            this.j = new DVSR(a);
        }
        get l() {
            return this.k;
        }
        set l(a) {
            this.k = a;
            this.j.container = this.k;
        }
        cb(a) {
            this.j.setBundleId(a);
        }
        get b3() {
            return this.j.getString("OPD_DefaultInteraction");
        }
        get b4() {
            return this.j.getString("OPD_ScaleToFit");
        }
        get b6() {
            return this.j.getString("OPD_ZoomTo100");
        }
        get b5() {
            return this.j.getString("OPD_ScaleToFit_SeriesViewer");
        }
        get b7() {
            return this.j.getString("PieChart_Others");
        }
        get bz() {
            return this.j.getString("FinancialSeries_Open");
        }
        get bw() {
            return this.j.getString("FinancialSeries_Close");
        }
        get by() {
            return this.j.getString("FinancialSeries_Low");
        }
        get bx() {
            return this.j.getString("FinancialSeries_High");
        }
        get b0() {
            return this.j.getString("FinancialSeries_Volume");
        }
        get m() {
            return this.j.getString("BubbleSeries_Radius");
        }
        get r() {
            return this.j.getString("DataProviderNotInitialized");
        }
        get b2() {
            return this.j.getString("Object_Sealed");
        }
        get b8() {
            return this.j.getString("RangeModificationsNotSupported");
        }
        get s() {
            return this.j.getString("Default_Series_Title");
        }
        get n() {
            return this.j.getString("DataChart_InteractivityNotLoaded");
        }
        get p() {
            return this.j.getString("DataChart_TrendLinesNotLoaded");
        }
        get o() {
            return this.j.getString("DataChart_NumberAbbreviatorNotLoaded");
        }
        get q() {
            return this.j.getString("DataChart_VisualDataNotLoaded");
        }
        get ca() {
            return this.j.getString("TRIAL_VERSION");
        }
        get b9() {
            return this.j.getString("ScatterSeries_Value");
        }
        b1(a) {
            return this.j.getString(a);
        }
        get bq() {
            return this.j.getString("FinancialChart_RangeSelector_OneMonth");
        }
        get bt() {
            return this.j.getString("FinancialChart_RangeSelector_ThreeMonths");
        }
        get bs() {
            return this.j.getString("FinancialChart_RangeSelector_SixMonths");
        }
        get bv() {
            return this.j.getString("FinancialChart_RangeSelector_YearToDate");
        }
        get br() {
            return this.j.getString("FinancialChart_RangeSelector_OneYear");
        }
        get bo() {
            return this.j.getString("FinancialChart_RangeSelector_All");
        }
        get bp() {
            return this.j.getString("FinancialChart_RangeSelector_From");
        }
        get bu() {
            return this.j.getString("FinancialChart_RangeSelector_To");
        }
        get t() {
            return this.j.getString("FinancialChart_IndicatorMenu_Header");
        }
        get v() {
            return this.j.getString("FinancialChart_IndicatorMenu_OverlaysCategoryHeader");
        }
        get w() {
            return this.j.getString("FinancialChart_IndicatorMenu_TrendlinesCategoryHeader");
        }
        get x() {
            return this.j.getString("FinancialChart_IndicatorMenu_VolumeCategoryHeader");
        }
        get u() {
            return this.j.getString("FinancialChart_IndicatorMenu_IndicatorsCategoryHeader");
        }
        get a6() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Overlay_BollingerBands");
        }
        get a7() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Overlay_PriceChannel");
        }
        get y() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator");
        }
        get z() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution");
        }
        get aa() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex");
        }
        get ab() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange");
        }
        get ac() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth");
        }
        get ad() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator");
        }
        get ae() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility");
        }
        get af() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex");
        }
        get ag() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator");
        }
        get ah() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement");
        }
        get ai() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator");
        }
        get aj() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_ForceIndex");
        }
        get ak() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator");
        }
        get al() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex");
        }
        get am() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MassIndex");
        }
        get an() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MedianPrice");
        }
        get ao() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex");
        }
        get ap() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence");
        }
        get aq() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex");
        }
        get ar() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume");
        }
        get as() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator");
        }
        get at() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator");
        }
        get au() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex");
        }
        get av() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend");
        }
        get aw() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum");
        }
        get ax() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex");
        }
        get ay() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator");
        }
        get az() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_StandardDeviation");
        }
        get a0() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_StochRSI");
        }
        get a1() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_TRIX");
        }
        get a2() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_TypicalPrice");
        }
        get a3() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator");
        }
        get a4() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_WeightedClose");
        }
        get a5() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR");
        }
        get a8() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_CubicFit");
        }
        get a9() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage");
        }
        get ba() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage");
        }
        get bb() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit");
        }
        get bc() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_LinearFit");
        }
        get bd() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit");
        }
        get be() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage");
        }
        get bf() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit");
        }
        get bg() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit");
        }
        get bh() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_QuarticFit");
        }
        get bi() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_QuinticFit");
        }
        get bj() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage");
        }
        get bk() {
            return this.j.getString("FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage");
        }
        get bl() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Volume_Area");
        }
        get bm() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Volume_Column");
        }
        get bn() {
            return this.j.getString("FinancialChart_IndicatorsMenu_Volume_Line");
        }
    }
    SRProvider.$t = /*@__PURE__*/ markType(SRProvider, 'SRProvider', DependencyObject.$);
    return SRProvider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushUtil = /*@__PURE__*/ (() => {
    class BrushUtil extends Base {
        static l(a, b) {
            if (a == null) {
                return a;
            }
            if (a.isGradient) {
                let c = a.clone();
                for (let d = 0; d < c.gradientStops.length; d++) {
                    let e = c.gradientStops[d];
                    e.color = ColorUtil.v(e.color, b);
                }
                return c;
            }
            else {
                let f = ColorUtil.v(a.color, b);
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = f;
                    return $ret;
                })());
            }
        }
        static d(a) {
            let b = Color.u(0, 0, 0, 0);
            if (a == null) {
                return new Tuple$2(Boolean_$type, Color.$, true, b);
            }
            if (typeCast(LinearGradientBrush.$, a) !== null) {
                if (a.gradientStops == null || a.gradientStops.length < 1) {
                    return new Tuple$2(Boolean_$type, Color.$, false, b);
                }
                b = a.gradientStops[0].color;
            }
            else {
                b = a.color;
            }
            return new Tuple$2(Boolean_$type, Color.$, true, b);
        }
        static i(a, b, c) {
            let d = BrushUtil.d(a);
            let e = new Color();
            if (!d.c) {
                return b;
            }
            else {
                e = d.d;
            }
            let f = new Color();
            let g = new Color();
            let h = BrushUtil.d(b);
            if (!h.c) {
                return b;
            }
            g = h.d;
            let i = BrushUtil.d(c);
            if (!i.c) {
                return b;
            }
            f = i.d;
            let j = ColorUtil.a(e);
            let k = ColorUtil.a(f);
            let l = ColorUtil.a(g);
            let m = (j[3] + 0.05) / (l[3] + 0.05);
            let n = (k[3] + 0.05) / (j[3] + 0.05);
            if (m > n) {
                return b;
            }
            return c;
        }
        static h(a, b, c) {
            let d = new Color();
            if (typeCast(LinearGradientBrush.$, a) !== null) {
                if (a.gradientStops == null || a.gradientStops.length < 1) {
                    let e = new Brush();
                    e.color = b;
                    return e;
                }
                d = a.gradientStops[0].color;
            }
            else {
                d = a.color;
            }
            let f = ColorUtil.a(d);
            let g = ColorUtil.a(c);
            let h = ColorUtil.a(b);
            let i = (f[3] + 0.05) / (h[3] + 0.05);
            let j = (g[3] + 0.05) / (f[3] + 0.05);
            if (i > j) {
                let k = new Brush();
                k.color = b;
            }
            let l = new Brush();
            l.color = c;
            return l;
        }
        static n(a, b) {
            if (a == null) {
                return a;
            }
            if (a.isGradient) {
                let c = a.clone();
                for (let d = 0; d < c.gradientStops.length; d++) {
                    let e = c.gradientStops[d];
                    e.color = Color.u(truncate(Math.round(e.color.l * b)), e.color.o, e.color.n, e.color.m);
                }
                return c;
            }
            else {
                let f = Color.u(truncate(Math.round(a.color.l * b)), a.color.o, a.color.n, a.color.m);
                return ((() => {
                    let $ret = new Brush();
                    $ret.color = f;
                    return $ret;
                })());
            }
        }
        static k(a, b, c, d) {
            let e = new Brush();
            if (a == null && c == null) {
                e._fill = "transparent";
                return e;
            }
            let f = null, g = null;
            let h = null, i = null;
            if (a == null) {
                let j = c.isGradient ? ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = 255;
                    $ret.n = 255;
                    $ret.m = 255;
                    return $ret;
                })()) : ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = c.color.o;
                    $ret.n = c.color.n;
                    $ret.m = c.color.m;
                    return $ret;
                })());
                f = ((() => {
                    let $ret = new Brush();
                    $ret.color = j;
                    return $ret;
                })());
            }
            else {
                if (a.isGradient) {
                    h = a;
                }
                else {
                    f = a;
                }
            }
            if (c == null) {
                let k = a.isGradient ? ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = 255;
                    $ret.n = 255;
                    $ret.m = 255;
                    return $ret;
                })()) : ((() => {
                    let $ret = new Color();
                    $ret.l = 0;
                    $ret.o = a.color.o;
                    $ret.n = a.color.n;
                    $ret.m = a.color.m;
                    return $ret;
                })());
                g = ((() => {
                    let $ret = new Brush();
                    $ret.color = k;
                    return $ret;
                })());
            }
            else {
                if (c.isGradient) {
                    i = c;
                }
                else {
                    g = c;
                }
            }
            if (f != null && g != null) {
                return BrushUtil.p(f, b, g, d);
            }
            if (f != null && i != null) {
                return BrushUtil.o(f, b, i, d);
            }
            if (h != null && g != null) {
                return BrushUtil.o(g, 1 - b, h, d);
            }
            if (h != null && i != null) {
                return BrushUtil.m(h, b, i, d);
            }
            return e;
        }
        static g(a, b, c, d) {
            let e = new Brush();
            e.color = Color.u(a, b, c, d);
            return e;
        }
        static p(a, b, c, d) {
            let e = new Brush();
            e.color = ColorUtil.u(a.color, b, c.color, d);
            return e;
        }
        static o(a, b, c, d) {
            let e = new LinearGradientBrush();
            e.gradientStops = BrushUtil.c(a.color, b, c.gradientStops, d);
            if (c.useCustomDirection) {
                e.useCustomDirection = true;
                e.startX = c.startX;
                e.startY = c.startY;
                e.endX = c.endX;
                e.endY = c.endY;
            }
            return e;
        }
        static m(a, b, c, d) {
            let e = new LinearGradientBrush();
            e.gradientStops = BrushUtil.b(a.gradientStops, b, c.gradientStops, d);
            if (a.useCustomDirection || c.useCustomDirection) {
                e.useCustomDirection = true;
                e.startX = a.startX + b * (c.startX - a.startX);
                e.startY = a.startY + b * (c.startY - a.startY);
                e.endX = (1 - b) * a.endX + b * c.endX;
                e.endY = (1 - b) * a.endY + b * c.endY;
            }
            return e;
        }
        static c(a, b, c, d) {
            let e = new Array(c.length);
            for (let f = 0; f < c.length; ++f) {
                e[f] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = c[f].offset;
                    $ret.color = ColorUtil.u(a, b, c[f].color, d);
                    return $ret;
                })());
            }
            return e;
        }
        static b(a, b, c, d) {
            let e = Math.min(a.length, c.length);
            let f = Math.max(a.length, c.length);
            let g = new Array(f);
            let h = 0;
            for (; h < e; ++h) {
                g[h] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = (1 - b) * a[h].offset + b * c[h].offset;
                    $ret.color = ColorUtil.u(a[h].color, b, c[h].color, d);
                    return $ret;
                })());
            }
            for (; h < a.length; ++h) {
                g[h] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = (1 - b) * a[h].offset + b * c[c.length - 1].offset;
                    $ret.color = ColorUtil.u(a[h].color, b, c[c.length - 1].color, d);
                    return $ret;
                })());
            }
            for (; h < c.length; ++h) {
                g[h] = ((() => {
                    let $ret = new GradientStop();
                    $ret.offset = (1 - b) * a[a.length - 1].offset + b * c[h].offset;
                    $ret.color = ColorUtil.u(a[a.length - 1].color, b, c[h].color, d);
                    return $ret;
                })());
            }
            return g;
        }
        static a(a, b) {
            let c = new Array(2);
            b.addClass(a);
            let d = new Brush();
            d._fill = b.getStyleProperty("background-color");
            let e = new Brush();
            e._fill = b.getStyleProperty("border-top-color");
            b.removeClass(a);
            c[0] = d;
            c[1] = e;
            return c;
        }
        static e(palleteName_, container_, a, b, c = null) {
            a = new BrushCollection();
            b = new BrushCollection();
            let d;
            let e = new List$1(String_$type, 0);
            e.add("background-color");
            e.add("border-top-color");
            container_.startCSSQuery();
            let f = container_.getCssDefaultValuesForClassCollection("ui-" + palleteName_ + "-palette-", e.toArray());
            let g = f.length;
            if (g == 0) {
                if (c == null) {
                    c = ["#B1BFC9", "#50a8be", "#798995", "#fc6754", "#4F606C", "#fec33c", "#374650", "#3c6399", "#162C3B", "#91af49"];
                }
                for (let h = 0; h < c.length - 1; h += 2) {
                    d = new Brush();
                    d._fill = c[h];
                    b.add(d);
                    d = new Brush();
                    d._fill = c[h + 1];
                    a.add(d);
                }
            }
            for (let i = 0; i < g; i++) {
                let j = new Brush();
                j._fill = f[i][0];
                let k = new Brush();
                k._fill = f[i][1];
                a.add(j);
                b.add(k);
            }
            container_.endCSSQuery();
            return {
                p2: a,
                p3: b
            };
        }
        static f(a, b, c, container_, d, e, f = null) {
            d = new BrushCollection();
            e = new BrushCollection();
            if (f == null) {
                f = ["#B1BFC9", "#50a8be", "#798995", "#fc6754", "#4F606C", "#fec33c", "#374650", "#3c6399", "#162C3B", "#91af49"];
            }
            container_.startCSSQuery();
            let g = new List$1(String_$type, 0);
            g.add("background-image");
            let h = container_.getCssDefaultValuesForClassCollection(a, g.toArray());
            let i = h.length;
            let j = container_.getCssDefaultValuesForClassCollection(b, g.toArray());
            let k = j.length;
            for (let l = 0; l < i; l++) {
                d.add(CssGradientUtil.brushFromGradientString(h[l][0]));
            }
            for (let m = 0; m < k; m++) {
                e.add(CssGradientUtil.brushFromGradientString(j[m][0]));
            }
            g.clear();
            let n = 0;
            let o = 0;
            let p = Math.min(i, k);
            let q = null;
            if (i == 0) {
                g.add("background-color");
            }
            if (k == 0) {
                g.add("border-top-color");
                o = i == 0 ? 1 : 0;
            }
            if (g.count > 0) {
                q = container_.getCssDefaultValuesForClassCollection(c, g.toArray());
                p = q.length;
            }
            if (i == 0) {
                if (p > 0) {
                    for (let r = 0; r < p; r++) {
                        let s = new Brush();
                        s._fill = q[r][n];
                        d.add(s);
                    }
                }
                else {
                    for (let t = 0; t < f.length - 1; t += 2) {
                        let u = new Brush();
                        u = new Brush();
                        u._fill = f[t + 1];
                        d.add(u);
                    }
                }
            }
            if (k == 0) {
                if (p > 0) {
                    for (let v = 0; v < p; v++) {
                        let w = new Brush();
                        w._fill = q[v][o];
                        e.add(w);
                    }
                }
                else {
                    for (let x = 0; x < f.length - 1; x += 2) {
                        let y = new Brush();
                        y._fill = f[x];
                        e.add(y);
                    }
                }
            }
            container_.endCSSQuery();
            return {
                p4: d,
                p5: e
            };
        }
        static j(a, b, c, container_, d) {
            let e = null;
            container_.startCSSQuery();
            let f = container_.getCssDefaultPropertyValue(a, "background-image");
            if (f != null) {
                e = CssGradientUtil.brushFromGradientString(f);
            }
            if (e == null) {
                e = new Brush();
                let g = container_.getCssDefaultPropertyValue(b, c);
                e._fill = g != null ? g : d;
            }
            container_.endCSSQuery();
            return e;
        }
    }
    BrushUtil.$t = /*@__PURE__*/ markType(BrushUtil, 'BrushUtil');
    return BrushUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushUtilCore = /*@__PURE__*/ (() => {
    class BrushUtilCore extends Base {
        static a(a) {
            let b = typeCast(LinearGradientBrush.$, a);
            if (b != null) {
                return BrushUtilCore.c(b);
            }
            if (a.color.l == 0) {
                return true;
            }
            return false;
        }
        static c(a) {
            let d = a.gradientStops;
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (!BrushUtilCore.b(b)) {
                    return false;
                }
            }
            return true;
        }
        static b(a) {
            if (a.color.l == 0) {
                return true;
            }
            return false;
        }
    }
    BrushUtilCore.$t = /*@__PURE__*/ markType(BrushUtilCore, 'BrushUtilCore');
    return BrushUtilCore;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes for color interpolation.
 */
var InterpolationMode = /*@__PURE__*/ (function (InterpolationMode) {
    /**
     * Interpolation in RGB space.
     */
    InterpolationMode[InterpolationMode["RGB"] = 0] = "RGB";
    /**
     * Interpolation in HSV space.
     */
    InterpolationMode[InterpolationMode["HSV"] = 1] = "HSV";
    return InterpolationMode;
})({});
/**
 * @hidden
 */
let InterpolationMode_$type = /*@__PURE__*/ markEnum('InterpolationMode', 'RGB,0|HSV,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssHelper = /*@__PURE__*/ (() => {
    class CssHelper extends Base {
        static getDisoveryElement(a) {
            let b = a.createElement("fakediscoveryelement");
            b.setStyleProperty("box-sizing", "content-box");
            return b;
        }
        static getDefaultValue(a) {
            if (a == "color" || a == "border-color" || a == "border-top-color" || a == "border-left-color" || a == "border-right-color" || a == "border-bottom-color" || a == "background-color" || a == "outline-color") {
                return "rgb(3, 2, 1)";
            }
            else if (a == "margin-left" || a == "margin-top" || a == "margin-right" || a == "margin-bottom") {
                return "-4321px";
            }
            else if (a == "vertical-align") {
                return "baseline";
            }
            else if (a == "opacity") {
                return "0.888";
            }
            else if (a == "background-image") {
                return "none";
            }
            else if (a == "text-align") {
                return "justify";
            }
            else if (a == "visibility") {
                return "hidden";
            }
            else if (CssHelper.c(a)) {
                return "4321px";
            }
            return "DEFAULT";
        }
        static numberOfClasses(a, b, c) {
            let d = CssHelper.getDefaultValue(c);
            let e = 1;
            let f = false;
            while (!f && e < 500) {
                let g = b + e.toString();
                a.addClass(g);
                let h = a.getStyleProperty(c);
                if (h == d) {
                    break;
                }
                e++;
            }
            return e;
        }
        static getPropertyValue1(a, b, c) {
            if (b != null) {
                a.addClass(b);
            }
            let ret_ = a.getStyleProperty(c);
            if (b != null) {
                a.removeClass(b);
            }
            if (c == "opacity") {
                ret_ = (Math.round(1000.0 * +ret_) / 1000.0).toString();
            }
            if (CssHelper.a(ret_, CssHelper.getDefaultValue(c), c)) {
                return null;
            }
            return ret_;
        }
        static getPropertyValue(a, b) {
            return CssHelper.getPropertyValue1(a, null, b);
        }
        static a(a, b, c) {
            if (a == b) {
                return true;
            }
            if (CssHelper.c(c) && a != null && stringContains(a, "px")) {
                let d = stringReplace(a, "px", "");
                let e = parseFloat(d);
                if (Math.abs(Math.round(e) - 4321) < 2) {
                    return true;
                }
                return false;
            }
            else if (CssHelper.b(c) && a != null && stringContains(a, "px")) {
                let f = stringReplace(a, "px", "");
                let g = parseFloat(f);
                if (Math.abs(Math.round(g) + 4321) < 2) {
                    return true;
                }
                return false;
            }
            else {
                return a == b;
            }
        }
        static c(a) {
            return a == "width" || a == "height" || a == "border-top-width" || a == "border-left-width" || a == "border-right-width" || a == "border-bottom-width" || a == "border-width" || a == "border-radius" || a == "padding" || a == "padding-top" || a == "padding-left" || a == "padding-bottom" || a == "padding-right" || a == "border-top-left-radius";
        }
        static b(a) {
            return a == "margin-top" || a == "margin-left" || a == "margin-right" || a == "margin-bottom";
        }
        static getValuesForClassCollection(a, b, c) {
            let d = new List$1(List$1.$.specialize(String_$type), 0);
            let e = 1;
            let f = false;
            while (!f && e < 500) {
                let g = b + e.toString();
                a.addClass(g);
                let h = new List$1(String_$type, 0);
                for (let i = 0; i < c.count; i++) {
                    let j = c._inner[i];
                    let k = CssHelper.getDefaultValue(j);
                    let l = a.getStyleProperty(j);
                    if (CssHelper.a(l, k, j)) {
                        f = true;
                        break;
                    }
                    h.add(l);
                }
                a.removeClass(g);
                if (!f) {
                    d.add(h);
                }
                e++;
            }
            return d;
        }
    }
    CssHelper.$t = /*@__PURE__*/ markType(CssHelper, 'CssHelper');
    CssHelper.defaultMarginValue = "-4321px";
    CssHelper.defaultColorValue = "rgb(3, 2, 1)";
    CssHelper.defaultBackgroundImageValue = "none";
    CssHelper.defaultTextAlignValue = "justify";
    CssHelper.defaultVerticalAlignValue = "baseline";
    CssHelper.defaultOpacityValue = "0.888";
    CssHelper.defaultVisibilityValue = "hidden";
    CssHelper.defaultWidthHeightValue = "4321px";
    CssHelper.maxClasses = 500;
    return CssHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleAnimator = /*@__PURE__*/ (() => {
    class DoubleAnimator extends Base {
        constructor(a, b, c) {
            super();
            this.k = 0;
            this.p = 0;
            this.a = null;
            this.i = 0;
            this.j = 0;
            this._requestAnimationFrame = null;
            this.d = false;
            this.h = new Date();
            this.q = 0;
            this.propertyChanged = null;
            this.i = a;
            this.j = b;
            this.p = c;
            this.s();
        }
        get_g() {
            return this.o == 0;
        }
        get g() {
            return this.get_g();
        }
        u(a) {
            if (a == null) {
                this.s();
            }
            else if (a.supportsAnimation()) {
                this.requestAnimationFrame = a.getRequestAnimationFrame();
            }
        }
        t() {
            this.y(true);
        }
        get o() {
            return this.k;
        }
        set o(a) {
            this.k = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("TransitionProgress"));
            }
        }
        get r() {
            return this.p;
        }
        set r(a) {
            this.p = a;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
        get l() {
            return this.i;
        }
        set l(a) {
            this.i = a;
        }
        get n() {
            return this.j;
        }
        set n(a) {
            this.j = a;
        }
        s() {
            this.requestAnimationFrame = (window.requestAnimationFrame ||
                window.webkitRequestAnimationFrame ||
                window.mozRequestAnimationFrame ||
                window.oRequestAnimationFrame ||
                window.msRequestAnimationFrame ||
                function (callback) {
                    window.setTimeout(callback, 1000 / 60);
                });
        }
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        get e() {
            return this.d;
        }
        set e(a) {
            this.d = a;
        }
        v() {
            this.k = 0;
            this.q = 0;
            this.h = dateNow();
            if (!this.d) {
                this.d = true;
                this.requestAnimationFrame(runOn(this, this.x));
            }
        }
        w() {
            this.d = false;
            this.k = 0;
            this.q = 0;
        }
        x() {
            this.y(false);
        }
        y(a) {
            if (!this.d) {
                this.w();
                return;
            }
            let b = dateNow();
            let c = b.getTime() - this.h.getTime();
            if (c > this.p) {
                c = this.p;
            }
            if ((c - this.q < 16 && c != this.p) && !a) {
                this.requestAnimationFrame(runOn(this, this.x));
                return;
            }
            this.q = c;
            let d = (c / this.p);
            if (this.a != null) {
                d = this.a(d);
            }
            let e = this.i + ((this.j - this.i) * d);
            if (!a) {
                if (c == this.p) {
                    this.w();
                }
                else {
                    this.requestAnimationFrame(runOn(this, this.x));
                }
            }
            this.o = e;
        }
        m() {
            return this.d ? dateNow().getTime() - this.h.getTime() : 0;
        }
        f() {
            return this.d;
        }
    }
    DoubleAnimator.$t = /*@__PURE__*/ markType(DoubleAnimator, 'DoubleAnimator', Base.$, [INotifyPropertyChanged_$type]);
    return DoubleAnimator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AggregateException = /*@__PURE__*/ (() => {
    class AggregateException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                    }
                    break;
            }
        }
    }
    AggregateException.$t = /*@__PURE__*/ markType(AggregateException, 'AggregateException', BaseError.$);
    return AggregateException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Task = /*@__PURE__*/ (() => {
    class Task extends Base {
        constructor(a, ..._rest) {
            super();
            this.d = null;
            this.b = false;
            this.a = null;
            this.e = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = () => {
                            };
                            let i = (j) => {
                                if (j == null) {
                                    this.b = true;
                                }
                                else {
                                    this.a = new AggregateException(2, "Exception occurred during task execution", j);
                                }
                            };
                            this.d = f.done(h).fail(i);
                            this.e = g;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = () => {
                        };
                        let f = (g) => {
                            if (g == null) {
                                this.b = true;
                            }
                            else {
                                this.a = new AggregateException(2, "Exception occurred during task execution", g);
                            }
                        };
                        this.d = c.done(e).fail(f);
                        this.e = d;
                    }
                    break;
            }
        }
        get c() {
            return this.h == 5 || this.h == 7 || this.h == 6;
        }
        get h() {
            if (this.b) {
                return 6;
            }
            switch (this.d.state()) {
                case "pending": return 0;
                case "resolved": return 5;
                case "rejected": return 7;
                default: return 0;
            }
        }
        f(a) {
            let b = () => a(this);
            let c = (d) => a(this);
            let d = this.d.done(b).fail(c);
            return new Task(0, d);
        }
        g($tNewResult, a) {
            let b = new TaskCompletionSource$1($tNewResult, 0);
            let c = () => {
                try {
                    let d = a(this);
                    b.e(d);
                }
                catch (e) {
                    b.d((e));
                }
            };
            let d = (e) => c();
            let e = (f) => c();
            this.d.done(d).fail(e);
            return b.b;
        }
    }
    Task.$t = /*@__PURE__*/ markType(Task, 'Task');
    return Task;
})();
/**
 * @hidden
 */
let Task$1 = /*@__PURE__*/ (() => {
    class Task$1 extends Task {
        constructor($tResult, a, b) {
            super(1, a, b);
            this.$tResult = null;
            this.i = false;
            this.m = null;
            this.$tResult = $tResult;
            this.$type = this.$type.specialize(this.$tResult);
            let c = (d) => {
                let e = typeCastObjTo$t(this.$tResult, d);
                this.m = e;
                this.i = true;
            };
            let d = (e) => this.i = true;
            this.d.done(c).fail(d);
        }
        get n() {
            if (!this.i) {
                throw 'Result is not ready yet';
            }
            if (this.a != null) {
                throw this.a;
            }
            return this.m;
        }
        j(a) {
            return super.f((b) => a(b));
        }
        k($tNewResult, a) {
            let b = (c) => getBoxIfEnum($tNewResult, a(c));
            return this.l(Base.$, b).l($tNewResult, (c) => typeCastObjTo$t($tNewResult, c.n));
        }
        l($tNewResult, a) {
            return super.g($tNewResult, a);
        }
    }
    Task$1.$t = /*@__PURE__*/ markType(Task$1, 'Task$1', Task.$);
    return Task$1;
})();
/**
 * @hidden
 */
let TaskCompletionSource$1 = /*@__PURE__*/ (() => {
    class TaskCompletionSource$1 extends Base {
        constructor($tResult, a, ..._rest) {
            super();
            this.$tResult = null;
            this.a = null;
            this.b = null;
            this.$tResult = $tResult;
            this.$type = this.$type.specialize(this.$tResult);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            this.a = new PromiseFactory();
                            this.b = new Task$1(this.$tResult, this.a.promise(), e);
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.a = new PromiseFactory();
                        this.b = new Task$1(this.$tResult, this.a.promise(), c);
                    }
                    break;
            }
        }
        c() {
            this.a.reject(null);
        }
        d(a) {
            this.a.reject(a);
        }
        e(a) {
            this.a.resolve(getBoxIfEnum(this.$tResult, a));
        }
    }
    TaskCompletionSource$1.$t = /*@__PURE__*/ markType(TaskCompletionSource$1, 'TaskCompletionSource$1');
    return TaskCompletionSource$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Transform = /*@__PURE__*/ (() => {
    class Transform extends DependencyObject {
    }
    Transform.$t = /*@__PURE__*/ markType(Transform, 'Transform', DependencyObject.$);
    return Transform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MatrixTransform = /*@__PURE__*/ (() => {
    class MatrixTransform extends Transform {
        constructor() {
            super(...arguments);
            this.j = null;
        }
    }
    MatrixTransform.$t = /*@__PURE__*/ markType(MatrixTransform, 'MatrixTransform', Transform.$);
    return MatrixTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Matrix = /*@__PURE__*/ (() => {
    class Matrix extends Transform {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.k = 0;
            this.l = 0;
            this.m = 0;
            this.n = 0;
            this.o = 0;
        }
    }
    Matrix.$t = /*@__PURE__*/ markType(Matrix, 'Matrix', Transform.$);
    return Matrix;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleTransform = /*@__PURE__*/ (() => {
    class ScaleTransform extends Transform {
        constructor() {
            super(...arguments);
            this.l = 0;
            this.m = 0;
            this.j = 0;
            this.k = 0;
        }
    }
    ScaleTransform.$t = /*@__PURE__*/ markType(ScaleTransform, 'ScaleTransform', Transform.$);
    return ScaleTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RotateTransform = /*@__PURE__*/ (() => {
    class RotateTransform extends Transform {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.k = 0;
            this.l = 0;
        }
    }
    RotateTransform.$t = /*@__PURE__*/ markType(RotateTransform, 'RotateTransform', Transform.$);
    return RotateTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TranslateTransform = /*@__PURE__*/ (() => {
    class TranslateTransform extends Transform {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.k = 0;
        }
    }
    TranslateTransform.$t = /*@__PURE__*/ markType(TranslateTransform, 'TranslateTransform', Transform.$);
    return TranslateTransform;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransformCollection = /*@__PURE__*/ (() => {
    class TransformCollection extends List$1 {
        constructor() {
            super(Transform.$, 0);
        }
    }
    TransformCollection.$t = /*@__PURE__*/ markType(TransformCollection, 'TransformCollection', /*@__PURE__*/ List$1.$.specialize(Transform.$));
    return TransformCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransformGroup = /*@__PURE__*/ (() => {
    class TransformGroup extends Transform {
        constructor() {
            super();
            this.j = null;
            this.j = new TransformCollection();
        }
    }
    TransformGroup.$t = /*@__PURE__*/ markType(TransformGroup, 'TransformGroup', Transform.$);
    return TransformGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransformMatrixHelpler = /*@__PURE__*/ (() => {
    class TransformMatrixHelpler extends Base {
        static f(a) {
            if (typeCast(MatrixTransform.$, a) !== null) {
                return a.j;
            }
            if (typeCast(ScaleTransform.$, a) !== null) {
                let b = a;
                return TransformMatrixHelpler.g(0, b.l, b.m, { $type: Point_$type, x: 0, y: 0 });
            }
            if (typeCast(RotateTransform.$, a) !== null) {
                let c = a;
                return TransformMatrixHelpler.g(c.j, 1, 1, { $type: Point_$type, x: 0, y: 0 });
            }
            if (typeCast(TranslateTransform.$, a) !== null) {
                let d = a;
                return TransformMatrixHelpler.g(0, 1, 1, { $type: Point_$type, x: d.j, y: d.k });
            }
            if (typeCast(TransformGroup.$, a) !== null) {
                let e = a;
                let f = new Matrix();
                f.j = 1;
                f.m = 1;
                for (let g = e.j.count - 1; g >= 0; g--) {
                    let h = TransformMatrixHelpler.f(e.j._inner[g]);
                    f = TransformMatrixHelpler.e(f, h);
                }
                return f;
            }
            return a;
        }
        static a(a) {
            return Math.atan2(a.k, a.j) * 180 / Math.PI;
        }
        static b(a) {
            let b = Math.sqrt((a.j * a.j) + (a.k * a.k));
            return b;
        }
        static c(a) {
            let b = Math.sqrt((a.l * a.l) + (a.m * a.m));
            return b;
        }
        static h(a) {
            return { $type: Point_$type, x: a.n, y: a.o };
        }
        static e(a, b) {
            let c = new Matrix();
            c.j = a.j * b.j + a.k * b.l;
            c.k = a.j * b.k + a.k * b.m;
            c.n = a.n * b.j + a.o * b.l + b.n;
            c.l = a.l * b.j + a.m * b.l;
            c.m = a.l * b.k + a.m * b.m;
            c.o = a.n * b.k + a.o * b.m + b.o;
            return c;
        }
        static d(a, b, c) {
            let d = TransformMatrixHelpler.a(b);
            let e = TransformMatrixHelpler.a(c);
            let f = TransformMatrixHelpler.b(b);
            let g = TransformMatrixHelpler.b(c);
            let h = TransformMatrixHelpler.c(b);
            let i = TransformMatrixHelpler.c(c);
            let j = TransformMatrixHelpler.h(b);
            let k = TransformMatrixHelpler.h(c);
            let l = d + (e - d) * a;
            let m = f + (g - f) * a;
            let n = h + (i - h) * a;
            let o = { $type: Point_$type, x: j.x + (k.x - j.x) * a, y: j.y + (k.y - j.y) * a };
            return TransformMatrixHelpler.g(l, m, n, o);
        }
        static g(a, b, c, d) {
            a = a % 360;
            let e = a * Math.PI / 180;
            let f = new Matrix();
            let g = Math.cos(e);
            let h = Math.sin(e);
            f.j = b * g;
            f.k = b * h;
            f.l = -c * h;
            f.m = c * g;
            f.n = d.x;
            f.o = d.y;
            return f;
        }
    }
    TransformMatrixHelpler.$t = /*@__PURE__*/ markType(TransformMatrixHelpler, 'TransformMatrixHelpler');
    return TransformMatrixHelpler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrameProperty = /*@__PURE__*/ (() => {
    class AnimationKeyFrameProperty extends Base {
        constructor(a, b) {
            super();
            this.a = 0;
            this.b = null;
            this.a = a;
            this.d = b;
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.c(a);
            this.b = b;
        }
        c(a) {
            if (this.a == 0) {
                return a;
            }
            switch (this.a) {
                case 14:
                    let b = TransformMatrixHelpler.f(a);
                    let c = new MatrixTransform();
                    c.j = b;
                    return c;
            }
            return a;
        }
    }
    AnimationKeyFrameProperty.$t = /*@__PURE__*/ markType(AnimationKeyFrameProperty, 'AnimationKeyFrameProperty');
    return AnimationKeyFrameProperty;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementPropertyId_$type = /*@__PURE__*/ markEnum('UIElementPropertyId', 'Unset,0|Opacity,1|BackgroundColor,2|BorderColor,3|BorderWidth,4|BorderRadius,5|Padding,6|Color,7|FontSize,8|Width,9|Height,10|Left,11|Top,12|Margin,13|Transform,14|Stroke,15|Fill,16|StrokeWidth,17|StrokeDashArray,18|StrokeDashOffset,19');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrame = /*@__PURE__*/ (() => {
    class AnimationKeyFrame extends Base {
        constructor(a, ..._rest) {
            super();
            this.j = 0;
            this.i = new List$1(AnimationKeyFrameProperty.$, 0);
            this.a = null;
            this.h = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.j = NaN;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.j = c;
                    }
                    break;
            }
        }
        get b() {
            if (this.a == null) {
                this.a = this.i.toArray();
            }
            return this.a;
        }
        g(a) {
            if (this.h == null) {
                this.h = new Dictionary$2(UIElementPropertyId_$type, AnimationKeyFrameProperty.$, 0);
                for (let b = 0; b < this.b.length; b++) {
                    this.h.item(this.b[b].a, this.b[b]);
                }
            }
            if (this.h.containsKey(a)) {
                return this.h.item(a);
            }
            return null;
        }
        static d() {
            return new AnimationKeyFrame(0);
        }
        static e(a) {
            let b = new AnimationKeyFrame(0);
            b.j = a;
            return b;
        }
        static f(a, b) {
            let c = new AnimationKeyFrame(0);
            c.j = a;
            c.i.o(b);
            return c;
        }
        c(a) {
            this.i.add(a);
            this.a = null;
            this.h = null;
            return this;
        }
    }
    AnimationKeyFrame.$t = /*@__PURE__*/ markType(AnimationKeyFrame, 'AnimationKeyFrame');
    return AnimationKeyFrame;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementPropertyAccessor = /*@__PURE__*/ (() => {
    class UIElementPropertyAccessor extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
        }
    }
    UIElementPropertyAccessor.$t = /*@__PURE__*/ markType(UIElementPropertyAccessor, 'UIElementPropertyAccessor');
    return UIElementPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EasingFunctions = /*@__PURE__*/ (() => {
    class EasingFunctions extends Base {
        static c(a) {
            return a * a * a;
        }
        static g(a) {
            return (Math.exp(2 * a) - 1) / (Math.exp(2) - 1);
        }
        static a(a) {
            return 1 - Math.sqrt(1 - a * a);
        }
        static e(a, b) {
            let c = a * 2;
            return 0.5 * b(c);
        }
        static f(a, b) {
            let c = (1 - a) * 2;
            let d = 1 - b(c);
            return 0.5 * d + 0.5;
        }
        static cubicEase(a) {
            if (a < 0.5) {
                let b = a * 2;
                return 0.5 * EasingFunctions.c(b);
            }
            let c = (1 - a) * 2;
            let d = 1 - EasingFunctions.c(c);
            return 0.5 * d + 0.5;
        }
        static exponentialEase(a) {
            if (a < 0.5) {
                return EasingFunctions.e(a, EasingFunctions.g);
            }
            return EasingFunctions.f(a, EasingFunctions.g);
        }
        static circleEase(a) {
            if (a < 0.5) {
                return EasingFunctions.e(a, EasingFunctions.a);
            }
            return EasingFunctions.f(a, EasingFunctions.a);
        }
    }
    EasingFunctions.$t = /*@__PURE__*/ markType(EasingFunctions, 'EasingFunctions');
    return EasingFunctions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Thickness = /*@__PURE__*/ (() => {
    class Thickness extends Base {
        constructor(a, ..._rest) {
            super();
            this.b = 0;
            this.c = 0;
            this.d = 0;
            this.e = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.b = this.c = this.d = this.e = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.c = c;
                        this.e = d;
                        this.d = e;
                        this.b = f;
                    }
                    break;
                case 2:
                    {
                        this.b = NaN;
                        this.c = NaN;
                        this.d = NaN;
                        this.e = NaN;
                    }
                    break;
            }
        }
        a(a) {
            return this.b == a.b && this.e == a.e && this.c == a.c && this.d == a.d;
        }
        toString() {
            let a = this.c.toString() + "," + this.e.toString() + "," + this.d.toString() + "," + this.b.toString();
            return a;
        }
    }
    Thickness.$t = /*@__PURE__*/ markType(Thickness, 'Thickness');
    return Thickness;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CornerRadius = /*@__PURE__*/ (() => {
    class CornerRadius extends Base {
        constructor(a, ..._rest) {
            super();
            this.b = 0;
            this.a = 0;
            this.c = 0;
            this.d = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.a = this.b = this.c = this.d = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.c = c;
                        this.d = d;
                        this.b = e;
                        this.a = f;
                    }
                    break;
                case 2:
                    {
                        this.a = NaN;
                        this.b = NaN;
                        this.c = NaN;
                        this.d = NaN;
                    }
                    break;
            }
        }
    }
    CornerRadius.$t = /*@__PURE__*/ markType(CornerRadius, 'CornerRadius');
    return CornerRadius;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InterpolationUtil = /*@__PURE__*/ (() => {
    class InterpolationUtil extends Base {
        static f(a, b, c) {
            return new Thickness(1, b.c + a * (c.c - b.c), b.e + a * (c.e - b.e), b.d + a * (c.d - b.d), b.b + a * (c.b - b.b));
        }
        static d(a, b, c) {
            return new CornerRadius(1, b.c + a * (c.c - b.c), b.d + a * (c.d - b.d), b.b + a * (c.b - b.b), b.a + a * (c.a - b.a));
        }
        static e(a, b, c) {
            return new Rect(0, b.left + a * (c.left - b.left), b.top + a * (c.top - b.top), b.width + a * (c.width - b.width), b.height + a * (c.height - b.height));
        }
        static b(a, b, c, d) {
            let e = 1 - b;
            if (a == null) {
                a = new List$1(Point_$type, 0);
            }
            if (c == null) {
                c = new List$1(Point_$type, 0);
            }
            let f = c.count;
            let g = d.count;
            let h = Math.max(f, g);
            let i = a.count;
            if (i < h) {
                a.s(i, new Array(h - i));
            }
            if (i > h) {
                a.v(h, i - h);
            }
            for (let j = 0; j < Math.min(f, g); ++j) {
                a._inner[j] = { $type: Point_$type, x: (c._inner[j].x * e) + (d._inner[j].x * b), y: (c._inner[j].y * e) + (d._inner[j].y * b) };
            }
            if (f < g) {
                let k = f > 0 ? c._inner[f - 1] : { $type: Point_$type, x: 0, y: 0 };
                for (let l = f; l < g; ++l) {
                    a._inner[l] = { $type: Point_$type, x: (k.x * e) + (d._inner[l].x * b), y: (k.y * e) + (d._inner[l].y * b) };
                }
            }
            if (f > g) {
                let m = g > 0 ? d._inner[g - 1] : { $type: Point_$type, x: 0, y: 0 };
                for (let n = g; n < f; ++n) {
                    a._inner[n] = { $type: Point_$type, x: (c._inner[n].x * e) + (m.x * b), y: (c._inner[n].y * e) + (m.y * b) };
                }
            }
            return a;
        }
        static c($t, a, b, c, d, e, f) {
            let g = 1 - b;
            if (a == null) {
                a = new List$1($t, 0);
            }
            if (c == null) {
                c = new List$1($t, 0);
            }
            let h = c.count;
            let i = d.count;
            let j = Math.max(h, i);
            if (a.count < j) {
                let k = j - a.count;
                let l = new Array(k);
                a.s(a.count, l);
            }
            if (a.count > j) {
                a.v(j, a.count - j);
            }
            for (let m = 0; m < Math.min(h, i); ++m) {
                a._inner[m] = f(b, g, c._inner[m], d._inner[m]);
            }
            if (h < i) {
                let n = h > 0 ? c._inner[h - 1] : e();
                for (let o = h; o < i; ++o) {
                    a._inner[o] = f(b, g, n, d._inner[o]);
                }
            }
            if (h > i) {
                let p = i > 0 ? d._inner[i - 1] : e();
                for (let q = i; q < h; ++q) {
                    a._inner[q] = f(b, g, c._inner[q], p);
                }
            }
            return a;
        }
        static a(a, b, c) {
            let d = 1 - a;
            if (b == null) {
                b = new Array(0);
            }
            let e = b.length;
            let f = c.length;
            let g = Math.max(e, f);
            let h = new Array(g);
            for (let i = 0; i < Math.min(e, f); i++) {
                h[i] = b[i] + a * (c[i] - b[i]);
            }
            if (e < f) {
                let j = e > 0 ? b[e - 1] : 0;
                for (let k = e; k < f; ++k) {
                    h[k] = j + a * (c[k] - j);
                }
            }
            if (e > f) {
                let l = f > 0 ? c[f - 1] : 0;
                for (let m = f; m < e; ++m) {
                    h[m] = b[m] + a * (l - b[m]);
                }
            }
            return h;
        }
    }
    InterpolationUtil.$t = /*@__PURE__*/ markType(InterpolationUtil, 'InterpolationUtil');
    return InterpolationUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssColorPropertyAccessor = /*@__PURE__*/ (() => {
    class CssColorPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            return Brush.create(c);
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d._fill;
            c.setStyleProperty(this.d, e);
        }
    }
    CssColorPropertyAccessor.$t = /*@__PURE__*/ markType(CssColorPropertyAccessor, 'CssColorPropertyAccessor', UIElementPropertyAccessor.$);
    return CssColorPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssThicknessPropertyAccessor = /*@__PURE__*/ (() => {
    class CssThicknessPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.e = null;
            this.g = null;
            this.f = null;
            this.d = null;
            this.h = null;
            this.h = a;
            if (this.h == "border-width") {
                this.e = "border-left-width";
                this.g = "border-top-width";
                this.f = "border-right-width";
                this.d = "border-bottom-width";
            }
            else {
                this.e = this.h + "-left";
                this.g = this.h + "-top";
                this.f = this.h + "-right";
                this.d = this.h + "-bottom";
            }
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.e);
            let d = b.getStyleProperty(this.g);
            let e = b.getStyleProperty(this.f);
            let f = b.getStyleProperty(this.d);
            let g = parseFloat(stringReplace(c, "px", ""));
            let h = parseFloat(stringReplace(c, "px", ""));
            let i = parseFloat(stringReplace(c, "px", ""));
            let j = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(g)) {
                g = 0;
            }
            if (isNaN_(h)) {
                h = 0;
            }
            if (isNaN_(i)) {
                i = 0;
            }
            if (isNaN_(j)) {
                j = 0;
            }
            return new Thickness(1, g, h, i, j);
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d.e + "px " + d.d + "px " + d.b + "px " + d.c + "px";
            c.setStyleProperty(this.h, e);
        }
    }
    CssThicknessPropertyAccessor.$t = /*@__PURE__*/ markType(CssThicknessPropertyAccessor, 'CssThicknessPropertyAccessor', UIElementPropertyAccessor.$);
    return CssThicknessPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssPixelsPropertyAccessor = /*@__PURE__*/ (() => {
    class CssPixelsPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            let d = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(d)) {
                d = 0;
            }
            return d;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d + "px";
            c.setStyleProperty(this.d, e);
        }
    }
    CssPixelsPropertyAccessor.$t = /*@__PURE__*/ markType(CssPixelsPropertyAccessor, 'CssPixelsPropertyAccessor', UIElementPropertyAccessor.$);
    return CssPixelsPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssLengthPropertyAccessor = /*@__PURE__*/ (() => {
    class CssLengthPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            let d = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(d)) {
                d = 0;
            }
            return d;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d + "";
            c.setStyleProperty(this.d, e);
        }
    }
    CssLengthPropertyAccessor.$t = /*@__PURE__*/ markType(CssLengthPropertyAccessor, 'CssLengthPropertyAccessor', UIElementPropertyAccessor.$);
    return CssLengthPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleCollection = /*@__PURE__*/ (() => {
    class DoubleCollection extends List$1 {
        constructor() {
            super(Number_$type, 0);
        }
    }
    DoubleCollection.$t = /*@__PURE__*/ markType(DoubleCollection, 'DoubleCollection', /*@__PURE__*/ List$1.$.specialize(Number_$type));
    return DoubleCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssLengthArrayPropertyAccessor = /*@__PURE__*/ (() => {
    class CssLengthArrayPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = new DoubleCollection();
            let c = a;
            let d = c.getStyleProperty(this.d);
            let e = d.split(' ');
            for (let f = 0; f < e.length; f++) {
                let g = parseFloat(stringReplace(e[f], "px", ""));
                if (isNaN_(g)) {
                    g = 0;
                }
                b.add(g);
            }
            return b;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = new Array(d.count);
            for (let f = 0; f < d.count; f++) {
                e[f] = d._inner[f].toString();
            }
            let g = stringJoin1(Number_$type, " ", d);
            c.setStyleProperty(this.d, g);
        }
    }
    CssLengthArrayPropertyAccessor.$t = /*@__PURE__*/ markType(CssLengthArrayPropertyAccessor, 'CssLengthArrayPropertyAccessor', UIElementPropertyAccessor.$);
    return CssLengthArrayPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssFloatPropertyAccessor = /*@__PURE__*/ (() => {
    class CssFloatPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            let d = parseFloat(stringReplace(c, "px", ""));
            if (isNaN_(d)) {
                d = 0;
            }
            return d;
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d.toString();
            c.setStyleProperty(this.d, e);
        }
    }
    CssFloatPropertyAccessor.$t = /*@__PURE__*/ markType(CssFloatPropertyAccessor, 'CssFloatPropertyAccessor', UIElementPropertyAccessor.$);
    return CssFloatPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssCornerRadiusPropertyAccessor = /*@__PURE__*/ (() => {
    class CssCornerRadiusPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.f = null;
            this.g = null;
            this.e = null;
            this.d = null;
            this.h = null;
            this.h = a;
            this.f = "top-left-border-radius";
            this.g = "top-right-border-radius";
            this.e = "bottom-right-border-radius";
            this.d = "bottom-left-border-radius";
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.f);
            let d = b.getStyleProperty(this.g);
            let e = b.getStyleProperty(this.e);
            let f = b.getStyleProperty(this.d);
            let g = parseFloat(stringReplace(c, "px", ""));
            let h = parseFloat(stringReplace(d, "px", ""));
            let i = parseFloat(stringReplace(e, "px", ""));
            let j = parseFloat(stringReplace(f, "px", ""));
            if (isNaN_(g)) {
                g = 0;
            }
            if (isNaN_(h)) {
                h = 0;
            }
            if (isNaN_(i)) {
                i = 0;
            }
            if (isNaN_(j)) {
                j = 0;
            }
            return new CornerRadius(1, g, h, i, j);
        }
        c(a, b) {
            let c = a;
            let d = b;
            let e = d.c + "px " + d.d + "px " + d.b + "px " + d.a + "px";
            c.setStyleProperty(this.h, e);
        }
    }
    CssCornerRadiusPropertyAccessor.$t = /*@__PURE__*/ markType(CssCornerRadiusPropertyAccessor, 'CssCornerRadiusPropertyAccessor', UIElementPropertyAccessor.$);
    return CssCornerRadiusPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CssTransformPropertyAccessor = /*@__PURE__*/ (() => {
    class CssTransformPropertyAccessor extends UIElementPropertyAccessor {
        constructor(a) {
            super();
            this.d = null;
            this.d = a;
        }
        b(a) {
            let b = a;
            let c = b.getStyleProperty(this.d);
            if (c == null || c.length == 0) {
                return null;
            }
            c = stringReplace(stringReplace(c, "matrix(", ""), ")", "");
            let d = c.split(',');
            if (d.length != 6) {
                let e = new Matrix();
                e.k = 0;
                e.j = 1;
                e.l = 0;
                e.m = 1;
                e.n = 0;
                e.o = 0;
                return e;
            }
            let f = parseFloat(d[0].trim());
            let g = parseFloat(d[1].trim());
            let h = parseFloat(d[2].trim());
            let i = parseFloat(d[3].trim());
            let j = parseFloat(d[4].trim());
            let k = parseFloat(d[5].trim());
            let l = new MatrixTransform();
            let m = new Matrix();
            m.j = f;
            m.k = g;
            m.l = h;
            m.m = i;
            m.n = j;
            m.o = k;
            return l;
        }
        c(a, b) {
            let c = b;
            let d = a;
            if (c == null || c.j == null) {
                d.setStyleProperty(this.d, "");
                return;
            }
            let e = c.j;
            let f = "matrix(" + e.j + ", " + e.k + ", " + e.l + ", " + e.m + ", " + e.n + ", " + e.o + ")";
            d.setStyleProperty(this.d, f);
        }
    }
    CssTransformPropertyAccessor.$t = /*@__PURE__*/ markType(CssTransformPropertyAccessor, 'CssTransformPropertyAccessor', UIElementPropertyAccessor.$);
    return CssTransformPropertyAccessor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementPropertyAccessorFactory = /*@__PURE__*/ (() => {
    class UIElementPropertyAccessorFactory extends Base {
        static get c() {
            if (UIElementPropertyAccessorFactory.b == null) {
                UIElementPropertyAccessorFactory.b = new PlatformUIElementPropertyAccessorFactory();
            }
            return UIElementPropertyAccessorFactory.b;
        }
    }
    UIElementPropertyAccessorFactory.$t = /*@__PURE__*/ markType(UIElementPropertyAccessorFactory, 'UIElementPropertyAccessorFactory');
    UIElementPropertyAccessorFactory.b = null;
    return UIElementPropertyAccessorFactory;
})();
/**
 * @hidden
 */
let PlatformUIElementPropertyAccessorFactory = /*@__PURE__*/ (() => {
    class PlatformUIElementPropertyAccessorFactory extends UIElementPropertyAccessorFactory {
        constructor() {
            super();
        }
        a(a) {
            switch (a) {
                case 2:
                case 3:
                case 7:
                case 15:
                case 16: return new CssColorPropertyAccessor(this.d(a));
                case 4:
                case 13:
                case 6: return new CssThicknessPropertyAccessor(this.d(a));
                case 11:
                case 10:
                case 12:
                case 8:
                case 9: return new CssPixelsPropertyAccessor(this.d(a));
                case 17:
                case 19: return new CssLengthPropertyAccessor(this.d(a));
                case 18: return new CssLengthArrayPropertyAccessor(this.d(a));
                case 1: return new CssFloatPropertyAccessor(this.d(a));
                case 5: return new CssCornerRadiusPropertyAccessor(this.d(a));
                case 14: return new CssTransformPropertyAccessor(this.d(a));
            }
            return null;
        }
        d(a) {
            switch (a) {
                case 2: return "background-color";
                case 3: return "border-color";
                case 7: return "color";
                case 4: return "border-width";
                case 13: return "margin";
                case 6: return "padding";
                case 11: return "left";
                case 10: return "height";
                case 12: return "top";
                case 9: return "width";
                case 5: return "border-radius";
                case 8: return "font-size";
                case 1: return "opacity";
                case 14: return "transform";
                case 15: return "stroke";
                case 16: return "fill";
                case 18: return "stroke-dasharray";
                case 19: return "stroke-dashoffset";
                case 17: return "stroke-width";
            }
            return "";
        }
    }
    PlatformUIElementPropertyAccessorFactory.$t = /*@__PURE__*/ markType(PlatformUIElementPropertyAccessorFactory, 'PlatformUIElementPropertyAccessorFactory', UIElementPropertyAccessorFactory.$);
    return PlatformUIElementPropertyAccessorFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationTimeline = /*@__PURE__*/ (() => {
    class KeyFrameAnimationTimeline extends Base {
        constructor(a, b) {
            super();
            this.c = null;
            this.a = null;
            this.h = new Date();
            this.g = new LinkedList$1(IKeyFrameAnimation_$type);
            this.f = new Dictionary$2(String_$type, IKeyFrameAnimation_$type, 0);
            this.e = new Dictionary$2(IKeyFrameAnimation_$type, LinkedListNode$1.$.specialize(IKeyFrameAnimation_$type), 0);
            this.k = 0;
            this.d = false;
            this.i = 0;
            this.l = -1;
            this.c = a;
            this.a = b;
            this.h = dateNow();
        }
        get b() {
            return this.a;
        }
        get j() {
            if (this.d) {
                return this.i;
            }
            return timeSpanTotalMilliseconds((+(dateNow()) - +(this.h)));
        }
        m(a) {
            if (this.f.containsKey(a.id)) {
                return;
            }
            this.g.f(a);
            let b = this.g.d;
            this.e.addItem(a, b);
            this.f.addItem(a.id, a);
            let c = false;
            if (this.k == 0) {
                c = true;
            }
            this.k++;
            if (c) {
                this.n();
            }
        }
        o(a) {
            if (!this.e.containsKey(a)) {
                return;
            }
            let b = this.e.item(a);
            this.g.h(b);
            this.f.removeItem(a.id);
            this.e.removeItem(a);
            let c = false;
            this.k--;
            if (this.k == 0) {
                c = true;
            }
            if (c) {
                this.p();
            }
        }
        p() {
            if (this.l >= 0) {
                this.c.teardownTicking(this.l);
                this.l = -1;
            }
        }
        n() {
            this.l = this.c.setupTicking(runOn(this, this.q));
            this.c.requestFrame(this.l);
        }
        q() {
            let a = this.j;
            this.i = a;
            try {
                this.d = true;
                let b = this.g.c;
                if (b == null) {
                    this.p();
                    this.d = false;
                    return;
                }
                while (b != null) {
                    let c = b.c;
                    if (c.playState == 1) {
                        c.aq();
                    }
                    else {
                        c.aq();
                        this.o(b.c);
                    }
                    b = b.a;
                }
                this.c.requestFrame(this.l);
            }
            finally {
                this.d = false;
            }
        }
    }
    KeyFrameAnimationTimeline.$t = /*@__PURE__*/ markType(KeyFrameAnimationTimeline, 'KeyFrameAnimationTimeline');
    return KeyFrameAnimationTimeline;
})();
/**
 * @hidden
 */
let IKeyFrameAnimation_$type = /*@__PURE__*/ new Type(null, 'IKeyFrameAnimation');
/**
 * @hidden
 */
let KeyFrameAnimationDirect = /*@__PURE__*/ (() => {
    class KeyFrameAnimationDirect extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.m = NaN;
            this.d = false;
            this.p = NaN;
            this.i = false;
            this.u = null;
            this.n = NaN;
            this.g = false;
            this.o = 1;
            this.q = NaN;
            this.j = false;
            this.b = null;
            this.onFinished = null;
            this.onCanceled = null;
            this.h = false;
            this.f = false;
            this.e = false;
            this.w = null;
            this.v = null;
            this.u = "AUTO_ID_" + KeyFrameAnimationDirect.t.toString();
            KeyFrameAnimationDirect.t++;
            this.effect = a;
            this.effect.r = this;
            this.b = b;
        }
        get effect() {
            return this.a;
        }
        set effect(a) {
            this.a = a;
        }
        get l() {
            if (this.d) {
                return true;
            }
            if (this.j) {
                return true;
            }
            return false;
        }
        get currentTime() {
            if (this.d) {
                return this.m;
            }
            return (this.c.j - this.startTime) * this.playbackRate;
        }
        set currentTime(a) {
            this.ar(a);
            this.as(true, false);
        }
        as(a, b) {
            let c;
            let d = false;
            if (!a) {
                let e = this.d;
                this.d = false;
                c = this.currentTime;
                d = this.l;
                this.d = e;
            }
            else {
                c = this.currentTime;
                d = this.l;
            }
            if (d && this.j && !this.f && !this.h) {
                if (this.playbackRate > 0 && c >= this.r) {
                    if (a) {
                        this.m = c;
                        this.d = true;
                    }
                    else {
                        if (this.i) {
                            this.m = Math.max(this.p, this.r);
                        }
                        else {
                            this.m = this.r;
                        }
                    }
                }
                else if (this.playbackRate < 0 && c <= 0) {
                    if (a) {
                        this.m = c;
                    }
                    else {
                        if (this.i) {
                            this.m = Math.min(this.p, 0);
                        }
                        else {
                            this.m = 0;
                        }
                    }
                }
                if (this.playbackRate != 0) {
                    if (a && this.d) {
                        this.q = this.c.j - (this.m / this.playbackRate);
                        this.j = true;
                        this.d = false;
                    }
                }
            }
            this.p = this.currentTime;
            this.i = true;
            let f = this.playState == 3;
            if (!b && f && !this.k()) {
                this.an(() => this.ad());
            }
            if (f && !this.k()) {
                if (b) {
                    this.aa();
                    this.ad();
                }
            }
            if (!f && this.k()) {
                this.v = this.x();
            }
        }
        x() {
            return new TaskCompletionSource$1(IKeyFrameAnimation_$type, 0);
        }
        aa() {
            this.e = false;
        }
        ad() {
            if (!this.e) {
                return;
            }
            this.e = false;
            if (this.playState != 3) {
                return;
            }
            this.al(this);
            this.ah();
        }
        ah() {
        }
        al(a) {
            this.v.e(a);
        }
        an(a) {
            if (!this.e) {
                this.e = true;
                this.c.b.enqueueAction(() => a());
            }
        }
        k() {
            return this.v == null || this.v.b.c;
        }
        ar(a) {
            if (this.d || !this.j || this.playbackRate == 0) {
                this.m = a;
                this.d = true;
            }
            else {
                this.q = this.c.j - (a / this.playbackRate);
            }
        }
        get finished() {
            return this.v.b;
        }
        get ready() {
            return this.w.b;
        }
        get id() {
            return this.u;
        }
        set id(a) {
            this.u = a;
        }
        get r() {
            return this.effect != null ? this.effect.as : 0;
        }
        get playState() {
            if (!this.l && !this.f && !this.h) {
                return 0;
            }
            else if (this.f || (!this.j && !this.h)) {
                return 2;
            }
            else if (this.l && (this.s > 0 && this.currentTime >= this.r || this.s < 0 && this.currentTime <= 0)) {
                return 3;
            }
            return 1;
        }
        get s() {
            if (this.g) {
                return this.n;
            }
            return this.o;
        }
        get playbackRate() {
            return this.o;
        }
        set playbackRate(a) {
            this.o = a;
        }
        get startTime() {
            return this.q;
        }
        set startTime(a) {
            let b = this.c.j;
            let c = this.p;
            this.q = a;
            this.j = true;
            if (this.playbackRate != 0) {
                this.d = false;
            }
            this.as(true, false);
        }
        get c() {
            return this.b;
        }
        cancel() {
            if (this.playState != 0) {
                this.ak();
                this.ai("AbortError");
                this.v = this.x();
                this.ag();
                this.d = false;
                this.j = false;
            }
        }
        ai(a) {
            if (this.v != null) {
                this.v.d(new BaseError(1, a));
            }
        }
        aj(a) {
            if (this.w != null) {
                this.w.d(new BaseError(1, a));
            }
        }
        ag() {
        }
        ak() {
            if (this.h) {
                this.h = false;
            }
            if (this.f) {
                this.f = false;
            }
            this.z();
            this.aj("AbortError");
        }
        finish() {
            if (this.s == 0 || (this.s > 0 && isInfinity(this.r))) {
                return;
            }
            this.z();
            let a;
            if (this.playbackRate > 0) {
                a = this.r;
            }
            else {
                a = 0;
            }
            this.ar(a);
            if (!this.j) {
                this.q = this.c.j - (a / this.playbackRate);
                this.j = true;
            }
            if (this.f && this.j) {
                this.d = false;
                this.ab();
                this.am(this);
            }
            if (this.h && this.j) {
                this.ac();
                this.am(this);
            }
            this.as(true, true);
        }
        pause() {
            this.ae();
        }
        ae() {
            if (this.f) {
                return;
            }
            if (this.playState == 2) {
                return;
            }
            if (!this.l) {
                if (this.playbackRate >= 0) {
                    this.d = true;
                    this.m = 0;
                }
                if (isInfinity(this.r)) {
                    return;
                }
                this.m = this.r;
                this.d = true;
            }
            let a = false;
            if (this.h) {
                a = true;
            }
            if (!a) {
                this.w = this.y();
            }
            this.ao(() => {
                if (!this.f) {
                    return;
                }
                this.f = false;
                let b = this.c.j;
                if (this.j && !this.d) {
                    this.m = (b - this.q) * this.playbackRate;
                }
                this.z();
                this.j = false;
                this.am(this);
                this.as(false, false);
            });
            this.as(false, false);
        }
        y() {
            return new TaskCompletionSource$1(IKeyFrameAnimation_$type, 0);
        }
        ao(a) {
            if (!this.f) {
                this.f = true;
                this.c.b.enqueueAction(() => a());
            }
        }
        play() {
            this.af(true);
        }
        af(a) {
            let b = this.f;
            if (this.s > 0 && a && (!this.l || this.currentTime < 0 || this.currentTime >= this.r)) {
                this.m = 0;
                this.d = true;
            }
            else if (this.s < 0 && a && (!this.l || this.currentTime <= 0 || this.currentTime > this.r)) {
                if (isInfinity(this.r)) {
                    return;
                }
                this.m = this.r;
                this.d = true;
            }
            else if (this.s == 0 && !this.l) {
                this.m = 0;
                this.d = true;
            }
            let c = false;
            if (this.f) {
                this.ab();
                c = true;
            }
            if (this.h) {
                this.ac();
                c = true;
            }
            if (!this.d && !b && !this.g) {
                return;
            }
            if (this.d) {
                this.j = false;
            }
            if (!c) {
                this.w = this.y();
            }
            this.ap(() => {
                if (!this.h) {
                    return;
                }
                this.h = false;
                if (!this.j && !this.d) {
                    return;
                }
                let d = this.c.j;
                if (this.d) {
                    this.z();
                    let e = d;
                    if (this.playbackRate != 0) {
                        e = d - this.m / this.playbackRate;
                    }
                    this.q = e;
                    this.j = true;
                    if (this.playbackRate != 0) {
                        this.d = false;
                    }
                }
                else if (this.j && this.g) {
                    let f = (d - this.q) * this.playbackRate;
                    this.z();
                    if (this.playbackRate == 0) {
                        this.m = f;
                        this.d = true;
                    }
                    let g = d;
                    if (this.playbackRate != 0) {
                        g = d - f / this.playbackRate;
                    }
                    this.q = g;
                    this.j = true;
                }
                this.am(this);
                this.as(false, false);
                this.c.m(this);
            });
            this.as(false, false);
        }
        am(a) {
            if (this.w != null) {
                this.w.e(a);
            }
        }
        ab() {
            this.f = false;
        }
        ac() {
            this.h = false;
        }
        ap(a) {
            if (!this.h) {
                this.h = true;
                this.c.b.enqueueAction(() => a());
            }
        }
        reverse() {
            let a = this.n;
            this.n = -this.s;
            this.g = true;
            this.af(true);
        }
        updatePlaybackRate(a) {
            let b = this.playState;
            this.n = a;
            this.g = true;
            if (b == 0 || b == 2) {
                this.z();
            }
            else if (b == 3) {
                let c = this.d;
                this.d = false;
                let d = this.currentTime;
                this.d = c;
                if (this.n == 0) {
                    this.q = this.c.j;
                }
                else {
                    this.q = this.c.j - (d / this.n);
                }
                this.z();
            }
            else {
                this.af(false);
            }
        }
        z() {
            if (this.g) {
                this.o = this.n;
                this.g = false;
            }
        }
        commitStyles() {
            this.effect.a6();
        }
        aq() {
            this.effect.a7();
            this.as(false, false);
        }
    }
    KeyFrameAnimationDirect.$t = /*@__PURE__*/ markType(KeyFrameAnimationDirect, 'KeyFrameAnimationDirect', Base.$, [IKeyFrameAnimation_$type]);
    KeyFrameAnimationDirect.t = 0;
    return KeyFrameAnimationDirect;
})();
/**
 * @hidden
 */
let AnimationKeyFrameEffect = /*@__PURE__*/ (() => {
    class AnimationKeyFrameEffect extends Base {
        constructor(a, ..._rest) {
            super();
            this.r = null;
            this.a4 = null;
            this.o = 0;
            this.q = null;
            this.ag = new List$1(AnimationKeyFrame.$, 0);
            this.c = null;
            this.al = 0;
            this.ah = 0;
            this.az = null;
            this.t = 0;
            this.ai = 0;
            this.aj = 0;
            this.v = 0;
            this.ak = 0;
            this.u = 0;
            this.d = null;
            this.a = null;
            this.b = null;
            this.p = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.a4 = c;
                        this.o = d;
                        this.p = f;
                        this.a8();
                        this.q = e;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        this.a4 = c;
                        this.o = d;
                        this.q = e;
                        this.p = f;
                        this.a8();
                        this.ag.o(g);
                    }
                    break;
            }
        }
        get an() {
            return this.aj * this.ai;
        }
        get as() {
            return Math.max(this.al + this.an + this.ah, 0);
        }
        a8() {
            this.al = this.p.f;
            this.ah = this.p.h;
            this.t = this.p.a;
            this.ai = this.p.i;
            this.aj = this.p.g;
            this.v = this.p.c;
            this.ak = this.p.j;
            this.u = this.p.b;
            this.az = this.a0(this.u);
        }
        a0(a) {
            switch (a) {
                case 3: return (b) => b;
                case 1: return EasingFunctions.exponentialEase;
                case 2: return EasingFunctions.circleEase;
                case 0: return EasingFunctions.cubicEase;
            }
            return (b) => b;
        }
        get k() {
            if (this.d == null) {
                this.d = this.e();
            }
            return this.d;
        }
        e() {
            let a = this.h;
            if (a.length <= 1) {
                return [0];
            }
            let b = new Array(a.length);
            let c = 1 / (a.length - 1);
            let d = 0;
            for (let e = 0; e < a.length; e++) {
                if (isNaN_(a[e].j)) {
                    b[e] = d;
                }
                else {
                    b[e] = a[e].j;
                    d = a[e].j;
                    if (((a.length - 1) - e) > 0) {
                        c = (1 - d) / ((a.length - 1) - e);
                    }
                }
                d += c;
            }
            return b;
        }
        l(a) {
            this.ag.add(a);
            this.c = null;
            this.a = null;
            return this;
        }
        m(...a) {
            let b = new AnimationKeyFrame(0);
            if (a != null) {
                for (let c = 0; c < a.length; c++) {
                    b.c(a[c]);
                }
            }
            this.l(b);
            return this;
        }
        n(a, ...b) {
            let c = new AnimationKeyFrame(1, a);
            if (b != null) {
                for (let d = 0; d < b.length; d++) {
                    c.c(b[d]);
                }
            }
            this.l(c);
            return this;
        }
        get au() {
            if (this.r != null) {
                return this.r.currentTime;
            }
            return NaN;
        }
        get ac() {
            if (this.r != null) {
                return this.r.l;
            }
            return false;
        }
        get ap() {
            return Math.max(Math.min(this.al, this.as), 0);
        }
        get am() {
            return Math.max(Math.min(this.al + this.an, this.as), 0);
        }
        get w() {
            if (this.r != null && this.r.playbackRate < 0) {
                return false;
            }
            return true;
        }
        get s() {
            if (this.ac && (this.au < this.ap || !this.w && this.au == this.ap)) {
                return 0;
            }
            if (this.ac && (this.au > this.am || this.w && this.au == this.am)) {
                return 2;
            }
            if (this.ac) {
                return 1;
            }
            return 3;
        }
        get ao() {
            let a = this.s;
            switch (a) {
                case 0: if (this.t == 3 || this.t == 4) {
                    return Math.max(this.au - this.al, 0);
                }
                else {
                    return NaN;
                }
                case 1: return this.au - this.al;
                case 2: if (this.t == 2 || this.t == 4) {
                    return Math.max(Math.min(this.au - this.al, this.an), 0);
                }
                else {
                    return NaN;
                }
                default: return NaN;
            }
        }
        get y() {
            if (!this.ac) {
                return false;
            }
            let a = this.s;
            switch (a) {
                case 0: if (this.t == 3 || this.t == 4) {
                    return true;
                }
                else {
                    return false;
                }
                case 1: return true;
                case 2: if (this.t == 2 || this.t == 4) {
                    return true;
                }
                else {
                    return false;
                }
                default: return false;
            }
            return false;
        }
        get ad() {
            if (!this.y) {
                return false;
            }
            return true;
        }
        get av() {
            if (!this.y) {
                return NaN;
            }
            let a = 0;
            if (this.aj == 0) {
                if (this.s == 0) {
                    a = 0;
                }
                else {
                    a = this.ai;
                }
            }
            else {
                a = this.ao / this.aj;
            }
            return a + this.ak;
        }
        get ae() {
            if (!this.ad) {
                return false;
            }
            return true;
        }
        get aw() {
            if (!this.ad) {
                return NaN;
            }
            let a = 1;
            if (isInfinity(this.av)) {
                a = this.ak % 1;
            }
            else {
                a = this.av % 1;
            }
            if (a == 0 && (this.s == 1 || this.s == 2) && this.ao == this.an && this.ai != 0) {
                a = 1;
            }
            return a;
        }
        get z() {
            if (!this.y) {
                return false;
            }
            return true;
        }
        get aq() {
            if (!this.y) {
                return NaN;
            }
            if (this.s == 2 && isInfinity(this.ai)) {
                return Number.POSITIVE_INFINITY;
            }
            if (this.aw == 1) {
                return Math.floor(this.av) - 1;
            }
            return Math.floor(this.av);
        }
        get aa() {
            return this.ae;
        }
        get ar() {
            if (!this.ae) {
                return NaN;
            }
            let a = this.x();
            if (a) {
                return this.aw;
            }
            else {
                return 1 - this.aw;
            }
        }
        x() {
            let a = true;
            if (this.v == 0) {
                a = true;
            }
            else if (this.v == 1) {
                a = false;
            }
            else {
                let b = this.aq;
                if (this.v == 3) {
                    b++;
                }
                if (isInfinity(b)) {
                    a = true;
                }
                else {
                    if (b % 2 == 0) {
                        a = true;
                    }
                    else {
                        a = false;
                    }
                }
            }
            return a;
        }
        get af() {
            return this.aa;
        }
        get ay() {
            if (!this.aa) {
                return NaN;
            }
            let a = false;
            let b = this.x();
            if (b && this.s == 0) {
                a = true;
            }
            if (!b && this.s == 2) {
                a = true;
            }
            return this.ax(this.ar, a);
        }
        get at() {
            return this.ay;
        }
        get ab() {
            return this.af;
        }
        ax(a, b) {
            return this.az(a);
        }
        a7() {
            if (!this.af) {
                return;
            }
            let a = this.ay;
            for (let b = 0; b < this.f.length; b++) {
                let c = this.a1(this.f[b], this.g[b]);
                this.a5(this.f[b], this.g[b], c);
            }
        }
        a5(a, b, c) {
            b.c(this.a4, c);
        }
        a1(a, b) {
            if (!this.ab) {
                return null;
            }
            let c = a;
            let d = this.at;
            if (this.a4 == null) {
                return null;
            }
            let e = this.a2(c, b);
            let f = new List$1(AnimationKeyFrame.$, 0);
            let g = new List$1(Number_$type, 0);
            for (let h = 0; h < this.h.length; h++) {
                for (let i = 0; i < this.h[h].b.length; i++) {
                    if (this.h[h].b[i].a == c) {
                        f.add(this.h[h]);
                        g.add(this.k[h]);
                    }
                }
            }
            if (f.count == 0) {
                return e;
            }
            if (g._inner[0] != 0) {
                f.insert(0, new AnimationKeyFrame(1, 0).c(new AnimationKeyFrameProperty(c, e)));
                g.insert(0, 0);
            }
            if (g._inner[f.count - 1] != 1) {
                f.add(new AnimationKeyFrame(1, 1).c(new AnimationKeyFrameProperty(c, e)));
                g.add(1);
            }
            let j = false;
            let k = new List$1(AnimationKeyFrame.$, 0);
            let l = new List$1(Number_$type, 0);
            if (d < 0) {
                let m = 0;
                for (let n = 0; n < f.count; n++) {
                    if (g._inner[n] == 0) {
                        m++;
                    }
                    else {
                        break;
                    }
                }
                if (m > 1) {
                    j = true;
                    k.add(f._inner[0]);
                    l.add(g._inner[0]);
                }
            }
            if (d >= 1) {
                let o = 0;
                for (let p = f.count - 1; p >= 0; p--) {
                    if (g._inner[p] == 1) {
                        o++;
                    }
                    else {
                        break;
                    }
                }
                if (o > 1) {
                    j = true;
                    k.add(f._inner[f.count - 1]);
                    l.add(g._inner[f.count - 1]);
                }
            }
            if (!j) {
                let q = null;
                let r = -1;
                for (let s = 0; s < f.count; s++) {
                    if (g._inner[s] <= d) {
                        q = f._inner[s];
                        r = s;
                    }
                    else {
                        break;
                    }
                }
                if (r == -1) {
                    for (let t = 0; t < f.count; t++) {
                        if (g._inner[t] == 0) {
                            q = f._inner[t];
                            r = t;
                        }
                        else {
                            break;
                        }
                    }
                }
                k.add(q);
                l.add(g._inner[r]);
                if (r < g.count - 1) {
                    k.add(f._inner[r + 1]);
                    l.add(g._inner[r + 1]);
                }
            }
            if (k.count == 1) {
                for (let u = 0; u < k._inner[0].b.length; u++) {
                    if (k._inner[0].b[u].a == c) {
                        return k._inner[0].b[u].d;
                    }
                }
                return null;
            }
            let v = l._inner[0];
            let w = l._inner[k.count - 1];
            let x = k._inner[0].g(c).d;
            let y = k._inner[1].g(c).d;
            let z = (d - v) / (w - v);
            return this.a3(c, z, x, y);
        }
        a3(a, b, c, d) {
            switch (a) {
                case 2:
                case 3:
                case 7:
                case 15:
                case 16: return BrushUtil.k(c, b, d, 0);
                case 4:
                case 13:
                case 6: return InterpolationUtil.f(b, c, d);
                case 11:
                case 10:
                case 12:
                case 8:
                case 9:
                case 17:
                case 19: return c + b * (d - c);
                case 1: return c + b * (d - c);
                case 5: return InterpolationUtil.d(b, c, d);
                case 14: return this.a9(b, c, d);
                case 18: return InterpolationUtil.a(b, c, d);
                default: if (b < 0.5) {
                    return c;
                }
                else {
                    return d;
                }
            }
            return null;
        }
        a9(a, b, c) {
            let d = TransformMatrixHelpler.d(a, b.j, c.j);
            let e = new MatrixTransform();
            e.j = d;
            return e;
        }
        a2(a, b) {
            return b.b(this.a4);
        }
        get h() {
            if (this.c == null) {
                this.c = this.ag.toArray();
                this.a = this.i();
                this.b = this.j();
            }
            return this.c;
        }
        get f() {
            if (this.c == null) {
                this.c = this.ag.toArray();
                this.a = this.i();
                this.b = this.j();
            }
            return this.a;
        }
        get g() {
            if (this.c == null) {
                this.c = this.ag.toArray();
                this.a = this.i();
                this.b = this.j();
            }
            return this.b;
        }
        j() {
            let a = new List$1(UIElementPropertyAccessor.$, 0);
            for (let b = 0; b < this.f.length; b++) {
                a.add(UIElementPropertyAccessorFactory.c.a(this.f[b]));
            }
            return a.toArray();
        }
        i() {
            let a = new List$1(UIElementPropertyId_$type, 0);
            let b = new HashSet$1(UIElementPropertyId_$type, 0);
            for (let c = 0; c < this.h.length; c++) {
                for (let d = 0; d < this.h[c].b.length; d++) {
                    if (!b.contains(this.h[c].b[d].a)) {
                        b.add_1(this.h[c].b[d].a);
                        a.add(this.h[c].b[d].a);
                    }
                }
            }
            return a.toArray();
        }
        a6() {
            let a = this.t;
            this.t = 4;
            this.a7();
            this.t = a;
        }
    }
    AnimationKeyFrameEffect.$t = /*@__PURE__*/ markType(AnimationKeyFrameEffect, 'AnimationKeyFrameEffect');
    return AnimationKeyFrameEffect;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationBrowserTickProvider = /*@__PURE__*/ (() => {
    class AnimationBrowserTickProvider extends Base {
        constructor(a) {
            super();
            this.e = 0;
            this.c = null;
            this._requestAnimationFrame = null;
            this.d = new List$1(Delegate_$type, 0);
            this.b = false;
            this.requestAnimationFrame = a.getRequestAnimationFrame();
            this.c = new Dictionary$2(Number_$type, Delegate_$type, 0);
        }
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        f() {
            this.b = false;
            this.d.clear();
            for (let a of fromEnum(this.c.values)) {
                this.d.add(a);
            }
            for (let b = 0; b < this.d.count; b++) {
                this.d._inner[b]();
            }
            this.d.clear();
        }
        setupTicking(a) {
            let b = this.e;
            this.e++;
            this.c.item(b, a);
            return b;
        }
        requestFrame(a) {
            if (this.b) {
                return;
            }
            this.b = true;
            this.requestAnimationFrame(runOn(this, this.f));
        }
        teardownTicking(a) {
            if (this.c.containsKey(a)) {
                this.c.removeItem(a);
            }
        }
    }
    AnimationBrowserTickProvider.$t = /*@__PURE__*/ markType(AnimationBrowserTickProvider, 'AnimationBrowserTickProvider', Base.$, [ITickProvider_$type]);
    return AnimationBrowserTickProvider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExecutionContext_$type = /*@__PURE__*/ new Type(null, 'IExecutionContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DOMExecutionContext = /*@__PURE__*/ (() => {
    class DOMExecutionContext extends Base {
        constructor(a) {
            super();
            this.c = 0;
            this.b = null;
            this._requestAnimationFrame = null;
            this.b = a;
            this.requestAnimationFrame = a.getRequestAnimationFrame();
            this.c = dateNow().getTime();
        }
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        execute(a) {
            a();
        }
        enqueueAction(a) {
            this.b.setTimeout(a, 0);
        }
        enqueueAnimationAction(a) {
            this.requestAnimationFrame(a);
        }
        executeDelayed(a, b) {
            this.b.setTimeout(a, b);
        }
        getCurrentRelativeTime() {
            return dateNow().getTime() - this.c;
        }
    }
    DOMExecutionContext.$t = /*@__PURE__*/ markType(DOMExecutionContext, 'DOMExecutionContext', Base.$, [IExecutionContext_$type]);
    return DOMExecutionContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationFactory = /*@__PURE__*/ (() => {
    class KeyFrameAnimationFactory extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.g = null;
        }
        static get f() {
            if (KeyFrameAnimationFactory.e == null) {
                KeyFrameAnimationFactory.e = new PlatformKeyFrameAnimationFactory(KeyFrameAnimationFactory.h);
                KeyFrameAnimationFactory.e.g = new KeyFrameAnimationTimeline(KeyFrameAnimationFactory.e.d, KeyFrameAnimationFactory.e.b);
            }
            return KeyFrameAnimationFactory.e;
        }
        c(a) {
            return new KeyFrameAnimationDirect(a, this.g);
        }
    }
    KeyFrameAnimationFactory.$t = /*@__PURE__*/ markType(KeyFrameAnimationFactory, 'KeyFrameAnimationFactory');
    KeyFrameAnimationFactory.e = null;
    KeyFrameAnimationFactory.h = null;
    return KeyFrameAnimationFactory;
})();
/**
 * @hidden
 */
let PlatformKeyFrameAnimationFactory = /*@__PURE__*/ (() => {
    class PlatformKeyFrameAnimationFactory extends KeyFrameAnimationFactory {
        constructor(a) {
            super();
            this.j = null;
            this.i = null;
            this.j = new AnimationBrowserTickProvider(a);
            this.i = new DOMExecutionContext(a);
        }
        get_d() {
            return this.j;
        }
        get d() {
            return this.get_d();
        }
        get_b() {
            return this.i;
        }
        get b() {
            return this.get_b();
        }
    }
    PlatformKeyFrameAnimationFactory.$t = /*@__PURE__*/ markType(PlatformKeyFrameAnimationFactory, 'PlatformKeyFrameAnimationFactory', KeyFrameAnimationFactory.$);
    return PlatformKeyFrameAnimationFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ElevationHelper = /*@__PURE__*/ (() => {
    class ElevationHelper extends Base {
        static g(a, b) {
            if (ElevationHelper.c == null) {
                ElevationHelper.c = ["0 1px 3px 0 ", "0 1px 5px 0 ", "0 1px 8px 0 ", "0 2px 4px -1px ", "0 3px 5px -1px ", "0 3px 5px -1px ", "0 4px 5px -2px ", "0 5px 5px -3px ", "0 5px 6px -3px ", "0 6px 6px -3px ", "0 6px 7px -4px ", "0 7px 8px -4px ", "0 7px 8px -4px ", "0 7px 9px -4px ", "0 8px 9px -5px ", "0 8px 10px -5px ", "0 8px 11px -5px ", "0 9px 11px -5px ", "0 9px 12px -6px ", "0 10px 13px -6px ", "0 10px 13px -6px ", "0 10px 14px -6px ", "0 11px 14px -7px ", "0 11px 15px -7px "];
            }
            a--;
            if (a < 0) {
                return "";
            }
            if (a > ElevationHelper.c.length - 1) {
                a = ElevationHelper.c.length - 1;
            }
            return ElevationHelper.c[a] + b;
        }
        static f(a, b) {
            if (ElevationHelper.b == null) {
                ElevationHelper.b = ["0 1px 1px 0 ", "0 2px 2px 0 ", "0 3px 4px 0 ", "0 4px 5px 0 ", "0 5px 8px 0 ", "0 6px 10px 0 ", "0 7px 10px 1px ", "0 8px 10px 1px ", "0 9px 12px 1px ", "0 10px 14px 1px ", "0 11px 15px 1px ", "0 12px 17px 2px ", "0 13px 19px 2px ", "0 14px 21px 2px ", "0 15px 22px 2px ", "0 16px 24px 2px ", "0 17px 26px 2px ", "0 18px 28px 2px ", "0 19px 29px 2px ", "0 20px 31px 3px ", "0 21px 33px 3px ", "0 22px 35px 3px ", "0 23px 36px 3px ", "0 24px 38px 3px "];
            }
            a--;
            if (a < 0) {
                return "";
            }
            if (a > ElevationHelper.b.length - 1) {
                a = ElevationHelper.b.length - 1;
            }
            return ElevationHelper.b[a] + b;
        }
        static d(a, b) {
            if (ElevationHelper.a == null) {
                ElevationHelper.a = ["0 2px 1px -1px ", "0 3px 1px -2px ", "0 3px 3px -2px ", "0 1px 10px 0 ", "0 1px 14px 0 ", "0 1px 18px 0 ", "0 2px 16px 1px ", "0 3px 14px 2px ", "0 3px 16px 2px ", "0 4px 18px 3px ", "0 4px 20px 3px ", "0 5px 22px 4px ", "0 5px 24px 4px ", "0 5px 26px 4px ", "0 6px 28px 5px ", "0 6px 30px 5px ", "0 6px 32px 5px ", "0 7px 34px 6px ", "0 7px 36px 6px ", "0 8px 38px 7px ", "0 8px 40px 7px ", "0 8px 42px 7px ", "0 9px 44px 8px ", "0 9px 46px 8px "];
            }
            a--;
            if (a < 0) {
                return "";
            }
            if (a > ElevationHelper.a.length - 1) {
                a = ElevationHelper.a.length - 1;
            }
            return ElevationHelper.a[a] + b;
        }
        static e(a, b, c, d) {
            if (a == 0) {
                return "";
            }
            return ElevationHelper.g(a, b._fill) + ", " + ElevationHelper.f(a, c._fill) + ", " + ElevationHelper.d(a, d._fill);
        }
    }
    ElevationHelper.$t = /*@__PURE__*/ markType(ElevationHelper, 'ElevationHelper');
    ElevationHelper.c = null;
    ElevationHelper.b = null;
    ElevationHelper.a = null;
    return ElevationHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for setting direction of linear gradient brush or a radial gradient brush
 */
var GradientDirection = /*@__PURE__*/ (function (GradientDirection) {
    /**
     * Specifies from top to bottom direction of gradient brush
     */
    GradientDirection[GradientDirection["TopBottom"] = 0] = "TopBottom";
    /**
     * Specifies from bottom to top direction of gradient brush
     */
    GradientDirection[GradientDirection["BottomTop"] = 1] = "BottomTop";
    /**
     * Specifies from left to right direction of gradient brush
     */
    GradientDirection[GradientDirection["LeftRight"] = 2] = "LeftRight";
    /**
     * Specifies from right to left direction of gradient brush
     */
    GradientDirection[GradientDirection["RightLeft"] = 3] = "RightLeft";
    /**
     * Specifies radial gradient brush
     */
    GradientDirection[GradientDirection["Radial"] = 4] = "Radial";
    return GradientDirection;
})({});
/**
 * @hidden
 */
let GradientDirection_$type = /*@__PURE__*/ markEnum('GradientDirection', 'TopBottom,0|BottomTop,1|LeftRight,2|RightLeft,3|Radial,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationPlayState_$type = /*@__PURE__*/ markEnum('KeyFrameAnimationPlayState', 'Idle,0|Running,1|Paused,2|Finished,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrameEffectTiming = /*@__PURE__*/ (() => {
    class AnimationKeyFrameEffectTiming extends Base {
        constructor() {
            super();
            this.f = 0;
            this.c = 0;
            this.g = 0;
            this.b = 0;
            this.h = 0;
            this.a = 0;
            this.j = 0;
            this.i = 0;
            this.onFinished = null;
            this.onCanceled = null;
            this.f = 0;
            this.c = 0;
            this.b = 3;
            this.h = 0;
            this.a = 0;
            this.j = 0;
            this.i = 1;
        }
    }
    AnimationKeyFrameEffectTiming.$t = /*@__PURE__*/ markType(AnimationKeyFrameEffectTiming, 'AnimationKeyFrameEffectTiming');
    return AnimationKeyFrameEffectTiming;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationFill_$type = /*@__PURE__*/ markEnum('KeyFrameAnimationFill', 'Auto,0|None,1|Forwards,2|Backwards,3|Both,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameEffectEasing_$type = /*@__PURE__*/ markEnum('KeyFrameEffectEasing', 'CubicInOut,0|ExponentialInOut,1|CircleInOut,2|Linear,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameEffectTimingDirection_$type = /*@__PURE__*/ markEnum('KeyFrameEffectTimingDirection', 'Normal,0|Reverse,1|Alternate,2|AlternateReverse,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnimationKeyFrameEffectTargetType_$type = /*@__PURE__*/ markEnum('AnimationKeyFrameEffectTargetType', 'NativeView,0|FrameworkElement,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDependentRenderer_$type = /*@__PURE__*/ new Type(null, 'IDependentRenderer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyFrameAnimationEffectPhase_$type = /*@__PURE__*/ markEnum('KeyFrameAnimationEffectPhase', 'Before,0|Active,1|After,2|Idle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushCollectionUtil = /*@__PURE__*/ (() => {
    class BrushCollectionUtil extends Base {
        static b(a, b) {
            if (isNaN_(b)) {
                return null;
            }
            b = MathUtil.b(b, 0, a.count - 1);
            let c = truncate(Math.floor(b));
            if (c == b) {
                return a.item(c);
            }
            return BrushCollectionUtil.c(b - c, a.item(c), a.item(c + 1), a.af);
        }
        static c(a, b, c, d) {
            let e = b.color;
            let f = c.color;
            let g = ColorUtil.u(e, a, f, d);
            let h = new Brush();
            h.color = g;
            return h;
        }
        static a(a) {
            let b = new BrushCollection();
            for (let c of fromEnum(a)) {
                let d = ColorUtil.n(c);
                if (d != null) {
                    b.add(d);
                }
            }
            return b;
        }
    }
    BrushCollectionUtil.$t = /*@__PURE__*/ markType(BrushCollectionUtil, 'BrushCollectionUtil');
    return BrushCollectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleValueChangedEventArgs = /*@__PURE__*/ (() => {
    class DoubleValueChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this._oldValue = 0;
            this._newValue = 0;
            this.oldValue = a;
            this.newValue = b;
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    DoubleValueChangedEventArgs.$t = /*@__PURE__*/ markType(DoubleValueChangedEventArgs, 'DoubleValueChangedEventArgs', EventArgs.$);
    return DoubleValueChangedEventArgs;
})();

/**
 * Provides data for double value change events.
*/
class IgrDoubleValueChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the value before the change.
    */
    get oldValue() {
        return this.i.oldValue;
    }
    set oldValue(v) {
        this.i.oldValue = +v;
    }
    /**
     * Gets the new value.
    */
    get newValue() {
        return this.i.newValue;
    }
    set newValue(v) {
        this.i.newValue = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for choosing the direction of error bars calculation in scatter series.
 */
var ErrorBarCalculatorReference = /*@__PURE__*/ (function (ErrorBarCalculatorReference) {
    /**
     * Variable X.
     */
    ErrorBarCalculatorReference[ErrorBarCalculatorReference["X"] = 0] = "X";
    /**
     * Variable Y.
     */
    ErrorBarCalculatorReference[ErrorBarCalculatorReference["Y"] = 1] = "Y";
    return ErrorBarCalculatorReference;
})({});
/**
 * @hidden
 */
let ErrorBarCalculatorReference_$type = /*@__PURE__*/ markEnum('ErrorBarCalculatorReference', 'X,0|Y,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of error bar calculators.
 */
var ErrorBarCalculatorType = /*@__PURE__*/ (function (ErrorBarCalculatorType) {
    /**
     * A calculator type that provides a fixed value.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["Fixed"] = 0] = "Fixed";
    /**
     * A calculator type that provides a fixed percentage of each input value
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["Percentage"] = 1] = "Percentage";
    /**
     * A calculator type that provides the input values directly.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["Data"] = 2] = "Data";
    /**
     * A calculator type that provides the standard deviation of the input values.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["StandardDeviation"] = 3] = "StandardDeviation";
    /**
     * A calculator type that provides the standard error of the input values.
     */
    ErrorBarCalculatorType[ErrorBarCalculatorType["StandardError"] = 4] = "StandardError";
    return ErrorBarCalculatorType;
})({});
/**
 * @hidden
 */
let ErrorBarCalculatorType_$type = /*@__PURE__*/ markEnum('ErrorBarCalculatorType', 'Fixed,0|Percentage,1|Data,2|StandardDeviation,3|StandardError,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IErrorBarCalculator_$type = /*@__PURE__*/ new Type(null, 'IErrorBarCalculator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available actions that can cause a DataSource event.
 */
var FastItemsSourceEventAction = /*@__PURE__*/ (function (FastItemsSourceEventAction) {
    /**
     * One or more rows were removed from the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Remove"] = 0] = "Remove";
    /**
     * One or more rows were added to the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Insert"] = 1] = "Insert";
    /**
     * One or more rows were replaced in the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Replace"] = 2] = "Replace";
    /**
     * An item property value changed in the data source.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Change"] = 3] = "Change";
    /**
     * The entire data source contents were reset.
     */
    FastItemsSourceEventAction[FastItemsSourceEventAction["Reset"] = 4] = "Reset";
    return FastItemsSourceEventAction;
})({});
/**
 * @hidden
 */
let FastItemsSourceEventAction_$type = /*@__PURE__*/ markEnum('FastItemsSourceEventAction', 'Remove,0|Insert,1|Replace,2|Change,3|Reset,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NativeUI = /*@__PURE__*/ (() => {
    class NativeUI extends Base {
        static aa(a, b, c) {
            let d = UIElementPropertyAccessorFactory.c.a(a);
            d.c(b, c);
        }
        static i(a, b) {
            let c = UIElementPropertyAccessorFactory.c.a(a);
            return c.b(b);
        }
        static t(a, b) {
            NativeUI.aa(1, a, b);
        }
        static e(a) {
            return NativeUI.i(1, a);
        }
        static j(a, b) {
            NativeUI.aa(2, a, b);
        }
        static ad(a) {
            return NativeUI.i(2, a);
        }
        static k(a, b) {
            NativeUI.aa(3, a, b);
        }
        static ae(a) {
            return NativeUI.i(3, a);
        }
        static m(a, b) {
            NativeUI.aa(4, a, b);
        }
        static ai(a) {
            return NativeUI.i(4, a);
        }
        static l(a, b) {
            NativeUI.aa(5, a, b);
        }
        static u(a, b) {
            NativeUI.aa(6, a, b);
        }
        static ak(a) {
            return NativeUI.i(6, a);
        }
        static ac(a) {
            return NativeUI.i(5, a);
        }
        static n(a, b) {
            NativeUI.aa(7, a, b);
        }
        static af(a) {
            return NativeUI.i(7, a);
        }
        static p(a, b) {
            NativeUI.aa(8, a, b);
        }
        static b(a) {
            return NativeUI.i(8, a);
        }
        static ab(a, b) {
            NativeUI.aa(9, a, b);
        }
        static h(a) {
            return NativeUI.i(9, a);
        }
        static q(a, b) {
            NativeUI.aa(10, a, b);
        }
        static c(a) {
            return NativeUI.i(10, a);
        }
        static r(a, b) {
            NativeUI.aa(11, a, b);
        }
        static d(a) {
            return NativeUI.i(11, a);
        }
        static s(a, b) {
            NativeUI.aa(13, a, b);
        }
        static aj(a) {
            return NativeUI.i(13, a);
        }
        static z(a, b) {
            let c = TransformMatrixHelpler.f(b);
            let d = new MatrixTransform();
            d.j = c;
            NativeUI.aa(14, a, d);
        }
        static ah(a) {
            return NativeUI.i(14, a);
        }
        static v(a, b) {
            NativeUI.aa(15, a, b);
        }
        static o(a, b) {
            NativeUI.aa(16, a, b);
        }
        static ag(a) {
            return NativeUI.i(15, a);
        }
        static y(a, b) {
            NativeUI.aa(17, a, b);
        }
        static g(a) {
            return NativeUI.i(17, a);
        }
        static w(a, b) {
            NativeUI.aa(18, a, b);
        }
        static a(a) {
            return NativeUI.i(18, a);
        }
        static x(a, b) {
            NativeUI.aa(19, a, b);
        }
        static f(a) {
            return NativeUI.i(19, a);
        }
    }
    NativeUI.$t = /*@__PURE__*/ markType(NativeUI, 'NativeUI');
    return NativeUI;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectChangedEventArgs = /*@__PURE__*/ (() => {
    class RectChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this._oldRect = null;
            this._newRect = null;
            this.oldRect = a;
            this.newRect = b;
        }
        get oldRect() {
            return this._oldRect;
        }
        set oldRect(a) {
            this._oldRect = a;
        }
        get newRect() {
            return this._newRect;
        }
        set newRect(a) {
            this._newRect = a;
        }
    }
    RectChangedEventArgs.$t = /*@__PURE__*/ markType(RectChangedEventArgs, 'RectChangedEventArgs', EventArgs.$);
    return RectChangedEventArgs;
})();

/**
 * Provides data for rectangle changed events.
*/
class IgrRectChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the rectangle before the change.
    */
    get oldRect() {
        return fromRect(this.i.oldRect);
    }
    set oldRect(v) {
        this.i.oldRect = toRect(v);
    }
    /**
     * Gets the new rectangle.
    */
    get newRect() {
        return fromRect(this.i.newRect);
    }
    set newRect(v) {
        this.i.newRect = toRect(v);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArrayExtension = /*@__PURE__*/ (() => {
    class ArrayExtension extends Base {
        static shuffle$1($t, a) {
            if (a != null) {
                let b = new Random(0);
                for (let c = a.count - 1; c > 0; --c) {
                    let d = b.next1(c);
                    let e = a.item(c);
                    a.item(c, a.item(d));
                    a.item(d, e);
                }
            }
        }
        static insertionIndex$1($t, a, b) {
            let c = -1;
            let d = 0;
            let e = a.count;
            while (c == -1) {
                if (e <= d) {
                    c = d;
                }
                else {
                    let f = intDivide((d + e), 2);
                    switch (Math.sign(CompareUtil.compareToObject(b, getBoxIfEnum($t, a.item(f))))) {
                        case -1:
                            e = f;
                            break;
                        case 0:
                            c = f;
                            break;
                        case 1:
                            d = f + 1;
                            break;
                    }
                }
            }
            return c;
        }
        static insertionIndex$11($t, a, b, c) {
            let d = -1;
            let e = 0;
            let f = a.count;
            while (d == -1) {
                if (f <= e) {
                    d = e;
                }
                else {
                    let g = intDivide((e + f), 2);
                    switch (Math.sign(b(c, a.item(g)))) {
                        case -1:
                            f = g;
                            break;
                        case 0:
                            d = g;
                            break;
                        case 1:
                            e = g + 1;
                            break;
                    }
                }
            }
            return d;
        }
        static binarySearch$11($t, a, b) {
            let c = 0;
            let d = a.count - 1;
            while (c <= d) {
                let e = (c + ((d - c) >> 1));
                let f = b(a.item(e));
                if (f < 0) {
                    d = e - 1;
                }
                else if (f > 0) {
                    c = e + 1;
                }
                else {
                    return e;
                }
            }
            return ~c;
        }
        static binarySearch$1($t, a, b) {
            let c = 0;
            let d = a.count - 1;
            while (c <= d) {
                let e = (c + ((d - c) >> 1));
                let f = b(a.item(e));
                if (f < 0) {
                    d = e - 1;
                }
                else if (f > 0) {
                    c = e + 1;
                }
                else {
                    return e;
                }
            }
            return ~c;
        }
        static getModulus$1($t, a, b) {
            if (a == null) {
                return Type.getDefaultValue($t);
            }
            if (a.count == 0) {
                return Type.getDefaultValue($t);
            }
            return a.item(b % a.count);
        }
    }
    ArrayExtension.$t = /*@__PURE__*/ markType(ArrayExtension, 'ArrayExtension');
    return ArrayExtension;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CoreGeometryUtil = /*@__PURE__*/ (() => {
    class CoreGeometryUtil extends Base {
        static a(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static b(a, b, c, d, e) {
            let f = { $type: Point_$type, x: (a.x + b.x) / 2, y: (a.y + b.y) / 2 };
            let g = b.x - a.x;
            let h = b.y - a.y;
            let i = Math.sqrt(g * g + h * h);
            let j = h;
            let k = g * -1;
            if (e == d) {
                j = h * -1;
                k = g;
            }
            let l = Math.max(Math.abs(j), Math.abs(k));
            j = j / l;
            k = k / l;
            let m = Math.sqrt(j * j + k * k);
            let n = j / m;
            let o = k / m;
            let p = i / 2;
            let q = Math.sqrt(c * c - p * p);
            if (isNaN_(q)) {
                q = 0;
            }
            let r = q * n;
            let s = q * o;
            let t = { $type: Point_$type, x: f.x + r, y: f.y + s };
            return t;
        }
    }
    CoreGeometryUtil.$t = /*@__PURE__*/ markType(CoreGeometryUtil, 'CoreGeometryUtil');
    return CoreGeometryUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DeviceUtils = /*@__PURE__*/ (() => {
    class DeviceUtils extends Base {
        static g(a) {
            return a;
        }
        static f(a) {
            return a;
        }
        static a(a) {
            if (isNaN_(a)) {
                return NaN;
            }
            if (a <= 0) {
                return NaN;
            }
            return a;
        }
        static c(a) {
            return a * DeviceUtils.d();
        }
        static b(a) {
            return a * DeviceUtils.e();
        }
        static d() {
            let a = DeviceUtils.g(2);
            return 2 / a;
        }
        static e() {
            let a = DeviceUtils.f(2);
            return 2 / a;
        }
    }
    DeviceUtils.$t = /*@__PURE__*/ markType(DeviceUtils, 'DeviceUtils');
    return DeviceUtils;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathSegment = /*@__PURE__*/ (() => {
    class PathSegment extends Base {
    }
    PathSegment.$t = /*@__PURE__*/ markType(PathSegment, 'PathSegment');
    return PathSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathSegmentCollection = /*@__PURE__*/ (() => {
    class PathSegmentCollection extends List$1 {
        constructor() {
            super(PathSegment.$, 0);
        }
    }
    PathSegmentCollection.$t = /*@__PURE__*/ markType(PathSegmentCollection, 'PathSegmentCollection', /*@__PURE__*/ List$1.$.specialize(PathSegment.$));
    return PathSegmentCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigure = /*@__PURE__*/ (() => {
    class PathFigure extends Base {
        constructor() {
            super();
            this._segments = null;
            this._startPoint = null;
            this._isFilled = false;
            this._isClosed = false;
            this._segments = new PathSegmentCollection();
            this._isClosed = false;
            this._isFilled = true;
        }
        get segments() {
            return this._segments;
        }
        set segments(a) {
            this._segments = a;
        }
        get startPoint() {
            return this._startPoint;
        }
        set startPoint(a) {
            this._startPoint = a;
        }
        get isFilled() {
            return this._isFilled;
        }
        set isFilled(a) {
            this._isFilled = a;
        }
        get isClosed() {
            return this._isClosed;
        }
        set isClosed(a) {
            this._isClosed = a;
        }
    }
    PathFigure.$t = /*@__PURE__*/ markType(PathFigure, 'PathFigure');
    return PathFigure;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigureCollection = /*@__PURE__*/ (() => {
    class PathFigureCollection extends List$1 {
        constructor() {
            super(PathFigure.$, 0);
        }
    }
    PathFigureCollection.$t = /*@__PURE__*/ markType(PathFigureCollection, 'PathFigureCollection', /*@__PURE__*/ List$1.$.specialize(PathFigure.$));
    return PathFigureCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathMarkupToken = /*@__PURE__*/ (() => {
    class PathMarkupToken extends Base {
        constructor(a, b) {
            super();
            this.c = 0;
            this.a = false;
            this.b = 0;
            this.c = a;
            this.a = b;
        }
    }
    PathMarkupToken.$t = /*@__PURE__*/ markType(PathMarkupToken, 'PathMarkupToken');
    return PathMarkupToken;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcSegment = /*@__PURE__*/ (() => {
    class ArcSegment extends PathSegment {
        constructor() {
            super();
            this.e = null;
            this.b = false;
            this.d = 0;
            this.f = new Size();
            this.c = 0;
            this.b = false;
            this.d = 0;
        }
        get_a() {
            return 4;
        }
        get a() {
            return this.get_a();
        }
    }
    ArcSegment.$t = /*@__PURE__*/ markType(ArcSegment, 'ArcSegment', PathSegment.$);
    return ArcSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSegment = /*@__PURE__*/ (() => {
    class LineSegment extends PathSegment {
        constructor(a, ..._rest) {
            super();
            this.b = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        this.c = c;
                    }
                    break;
                case 1: break;
            }
        }
        get c() {
            return this.b;
        }
        set c(a) {
            this.b = a;
        }
        get_a() {
            return 0;
        }
        get a() {
            return this.get_a();
        }
    }
    LineSegment.$t = /*@__PURE__*/ markType(LineSegment, 'LineSegment', PathSegment.$);
    return LineSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BezierSegment = /*@__PURE__*/ (() => {
    class BezierSegment extends PathSegment {
        constructor(a, ..._rest) {
            super();
            this.b = null;
            this.c = null;
            this.d = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.e = this.f = this.g = { $type: Point_$type, x: 0, y: 0 };
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.e = c;
                        this.f = d;
                        this.g = e;
                    }
                    break;
            }
        }
        get e() {
            return this.b;
        }
        set e(a) {
            this.b = a;
        }
        get f() {
            return this.c;
        }
        set f(a) {
            this.c = a;
        }
        get g() {
            return this.d;
        }
        set g(a) {
            this.d = a;
        }
        get_a() {
            return 1;
        }
        get a() {
            return this.get_a();
        }
    }
    BezierSegment.$t = /*@__PURE__*/ markType(BezierSegment, 'BezierSegment', PathSegment.$);
    return BezierSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Geometry = /*@__PURE__*/ (() => {
    class Geometry extends Base {
        constructor() {
            super();
        }
        static a(a) {
            if (a != null) {
                let b = new PathMarkupParser();
                return b.k(a);
            }
            return null;
        }
    }
    Geometry.$t = /*@__PURE__*/ markType(Geometry, 'Geometry');
    return Geometry;
})();
/**
 * @hidden
 */
let PathGeometry = /*@__PURE__*/ (() => {
    class PathGeometry extends Geometry {
        constructor() {
            super();
            this.c = null;
            this.c = new PathFigureCollection();
        }
        get_b() {
            return 4;
        }
        get b() {
            return this.get_b();
        }
    }
    PathGeometry.$t = /*@__PURE__*/ markType(PathGeometry, 'PathGeometry', Geometry.$);
    return PathGeometry;
})();
/**
 * @hidden
 */
let PathMarkupParser = /*@__PURE__*/ (() => {
    class PathMarkupParser extends Base {
        constructor() {
            super(...arguments);
            this.e = '\0';
            this.h = 0;
            this.l = { $type: Point_$type, x: 0, y: 0 };
            this.f = null;
            this.i = null;
        }
        k(a) {
            this.f = new List$1(PathMarkupToken.$, 0);
            this.h = 0;
            while (this.d(a)) {
                switch (this.e) {
                    case 'M':
                    case 'm':
                        this.f.add(new PathMarkupToken(0, this.e.charCodeAt(0) < 'm'.charCodeAt(0)));
                        break;
                    case 'L':
                    case 'l':
                        this.f.add(new PathMarkupToken(1, this.e.charCodeAt(0) < 'l'.charCodeAt(0)));
                        break;
                    case 'H':
                    case 'h':
                        this.f.add(new PathMarkupToken(2, this.e.charCodeAt(0) < 'h'.charCodeAt(0)));
                        break;
                    case 'V':
                    case 'v':
                        this.f.add(new PathMarkupToken(3, this.e.charCodeAt(0) < 'v'.charCodeAt(0)));
                        break;
                    case 'C':
                    case 'c':
                        this.f.add(new PathMarkupToken(4, this.e.charCodeAt(0) < 'c'.charCodeAt(0)));
                        break;
                    case 'Q':
                    case 'q':
                        this.f.add(new PathMarkupToken(5, this.e.charCodeAt(0) < 'q'.charCodeAt(0)));
                        break;
                    case 'S':
                    case 's':
                        this.f.add(new PathMarkupToken(6, this.e.charCodeAt(0) < 's'.charCodeAt(0)));
                        break;
                    case 'T':
                    case 't':
                        this.f.add(new PathMarkupToken(7, this.e.charCodeAt(0) < 't'.charCodeAt(0)));
                        break;
                    case 'A':
                    case 'a':
                        this.f.add(new PathMarkupToken(8, this.e.charCodeAt(0) < 'a'.charCodeAt(0)));
                        break;
                    case 'Z':
                    case 'z':
                        this.f.add(new PathMarkupToken(9, this.e.charCodeAt(0) < 'z'.charCodeAt(0)));
                        break;
                }
                if (this.a(this.e)) {
                    let b = true;
                    let c = false;
                    let d = false;
                    let e = stringEmpty();
                    let f = false;
                    this.h = this.h - 1;
                    while (this.h < a.length) {
                        let g = a.charAt(this.h);
                        if (d) {
                            if (!this.a(g)) {
                                f = true;
                                break;
                            }
                            else {
                                e += g;
                                this.h++;
                                if (this.h >= a.length) {
                                    f = true;
                                    break;
                                }
                            }
                        }
                        else if (c) {
                            if (g == 'e' || g == 'E') {
                                d = true;
                                e += g;
                                this.h++;
                                continue;
                            }
                            if (!this.a(g)) {
                                f = true;
                                break;
                            }
                            else {
                                e += g;
                                this.h++;
                                if (this.h >= a.length) {
                                    f = true;
                                    break;
                                }
                            }
                        }
                        else if (b) {
                            if (g == '.') {
                                c = true;
                                e += g;
                                this.h++;
                                continue;
                            }
                            if (g == 'e' || g == 'E') {
                                d = true;
                                e += g;
                                this.h++;
                                continue;
                            }
                            if (!this.a(g)) {
                                f = true;
                                break;
                            }
                            else {
                                e += g;
                                this.h++;
                                if (this.h >= a.length) {
                                    f = true;
                                    break;
                                }
                            }
                        }
                    }
                    if (f) {
                        this.f.add(((() => {
                            let $ret = new PathMarkupToken(10, false);
                            $ret.b = parseFloat(e);
                            return $ret;
                        })()));
                    }
                }
            }
            return this.j();
        }
        a(a) {
            return a == '.' || a == '-' || a == '+' || (a.charCodeAt(0) >= '0'.charCodeAt(0) && a.charCodeAt(0) <= '9'.charCodeAt(0));
        }
        j() {
            this.h = 0;
            let a = true;
            let b = new PathGeometry();
            let c = null;
            let d = 11;
            let e = null;
            let f = null;
            let g = null;
            while (this.h < this.f.count) {
                let h = this.f._inner[this.h++];
                if (a && h.c != 0) {
                    return null;
                }
                switch (h.c) {
                    case 0:
                        c = new PathFigure();
                        b.c.add(c);
                        this.l = this.m(h.a);
                        c._startPoint = this.l;
                        while (this.b()) {
                            this.l = this.m(h.a);
                            c._segments.add(new LineSegment(0, this.l));
                        }
                        d = 0;
                        break;
                    case 1:
                    case 2:
                    case 3:
                        if (c == null) {
                            return null;
                        }
                        do {
                            switch (h.c) {
                                case 1:
                                    this.l = this.m(h.a);
                                    break;
                                case 2:
                                    this.l.x = h.a ? this.g() : this.l.x + this.g();
                                    break;
                                case 3:
                                    this.l.y = h.a ? this.g() : this.l.y + this.g();
                                    break;
                            }
                            c._segments.add(new LineSegment(0, this.l));
                        } while (this.b());
                        d = 1;
                        break;
                    case 4:
                    case 6:
                        if (c == null) {
                            return null;
                        }
                        do {
                            if (h.c == 6) {
                                if (d == 4) {
                                    e = { $type: Point_$type, x: 2 * this.l.x - f.x, y: 2 * this.l.y - f.y };
                                }
                                else {
                                    e = this.l;
                                }
                            }
                            else {
                                e = this.m(h.a);
                            }
                            f = this.m(h.a);
                            g = this.m(h.a);
                            c._segments.add(new BezierSegment(1, e, f, g));
                            this.l = g;
                            d = 4;
                        } while (this.b());
                        break;
                    case 5:
                    case 7: break;
                    case 8:
                        if (c == null) {
                            return null;
                        }
                        do {
                            let i = this.g();
                            let j = this.g();
                            let k = this.g();
                            let l = this.g();
                            let m = this.g();
                            this.l = this.m(h.a);
                            c._segments.add(((() => {
                                let $ret = new ArcSegment();
                                $ret.e = this.l;
                                $ret.f = new Size(1, i, j);
                                $ret.c = k;
                                $ret.b = l == 1;
                                $ret.d = m == 1 ? 1 : 0;
                                return $ret;
                            })()));
                        } while (this.b());
                        d = 8;
                        break;
                    case 9:
                        if (c == null) {
                            return null;
                        }
                        c._isClosed = true;
                        break;
                }
                a = false;
            }
            return b;
        }
        m(a) {
            let b = this.g();
            let c = this.g();
            if (!a) {
                b += this.l.x;
                c += this.l.y;
            }
            return { $type: Point_$type, x: b, y: c };
        }
        g() {
            let a = this.f._inner[this.h++];
            if (a.c != 10) {
                throw new InvalidOperationException(0);
            }
            return a.b;
        }
        b() {
            if (this.h >= this.f.count) {
                return false;
            }
            return this.f._inner[this.h].c == 10;
        }
        d(a) {
            while (this.h < a.length && this.c(a.charAt(this.h))) {
                this.h++;
            }
            if (this.h < a.length) {
                this.e = a.charAt(this.h);
                this.h++;
                return true;
            }
            return false;
        }
        c(a) {
            return a == '\r' || a == '\n' || a == ' ' || a == '\t';
        }
    }
    PathMarkupParser.$t = /*@__PURE__*/ markType(PathMarkupParser, 'PathMarkupParser');
    return PathMarkupParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElement = /*@__PURE__*/ (() => {
    class UIElement extends DependencyObject {
        constructor() {
            super(...arguments);
            this.j = null;
        }
    }
    UIElement.$t = /*@__PURE__*/ markType(UIElement, 'UIElement', DependencyObject.$);
    return UIElement;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FrameworkElement = /*@__PURE__*/ (() => {
    class FrameworkElement extends UIElement {
        constructor() {
            super();
            this._name = null;
            this.m = 0;
            this.l = 0;
            this._visibility = 0;
            this._width = 0;
            this._height = 0;
            this.o = 0;
            this.n = 0;
            this.s = 0;
            this.x = null;
            this._dataContext = null;
            this._opacity = 1;
            this.y = null;
            this._opacity = 1;
            this.s = 0;
            this._visibility = 0;
            this.width = NaN;
            this.height = NaN;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get visibility() {
            return this._visibility;
        }
        set visibility(a) {
            if (this._visibility != a) {
                let b = this._visibility;
                this._visibility = a;
                this.w(b, this._visibility);
            }
        }
        w(a, b) {
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        get dataContext() {
            return this._dataContext;
        }
        set dataContext(a) {
            this._dataContext = a;
        }
        get opacity() {
            return this._opacity;
        }
        set opacity(a) {
            if (this._opacity != a) {
                this._opacity = a;
                this.v();
            }
        }
        v() {
        }
    }
    FrameworkElement.$t = /*@__PURE__*/ markType(FrameworkElement, 'FrameworkElement', UIElement.$);
    return FrameworkElement;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UIElementCollection = /*@__PURE__*/ (() => {
    class UIElementCollection extends ObservableCollection$1 {
        constructor(a) {
            super(UIElement.$, 0);
            this.ae = null;
            this.ae = a;
        }
        ac(a) {
            super.ac(a);
            if (a.oldItems != null) {
                for (let b of fromEn(a.oldItems)) {
                    b.x = null;
                }
            }
            if (a.newItems != null) {
                for (let c of fromEn(a.newItems)) {
                    c.x = this.ae;
                }
            }
        }
        p() {
            for (let a of fromEnum(this)) {
                a.x = null;
            }
            super.p();
        }
    }
    UIElementCollection.$t = /*@__PURE__*/ markType(UIElementCollection, 'UIElementCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(UIElement.$));
    return UIElementCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Panel = /*@__PURE__*/ (() => {
    class Panel extends FrameworkElement {
        constructor() {
            super();
            this.ab = null;
            this.ab = new UIElementCollection(this);
        }
    }
    Panel.$t = /*@__PURE__*/ markType(Panel, 'Panel', FrameworkElement.$);
    return Panel;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Control = /*@__PURE__*/ (() => {
    class Control extends FrameworkElement {
        constructor() {
            super();
            this.ab = null;
            this.ae = null;
            this.ad = 0;
            this.af = 0;
        }
        ac() {
        }
    }
    Control.$t = /*@__PURE__*/ markType(Control, 'Control', FrameworkElement.$);
    return Control;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContentControl = /*@__PURE__*/ (() => {
    class ContentControl extends Control {
        constructor() {
            super(...arguments);
            this._content = null;
            this.ah = null;
        }
        get content() {
            return this._content;
        }
        set content(a) {
            this._content = a;
        }
    }
    ContentControl.$t = /*@__PURE__*/ markType(ContentControl, 'ContentControl', Control.$);
    return ContentControl;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Extensions = /*@__PURE__*/ (() => {
    class Extensions extends Base {
        static e(a) {
            a.c.clear();
            a.c.add(new PathFigure());
            a.c.removeAt(0);
        }
        static d(a) {
            a.d.clear();
            a.d.add(new PathGeometry());
            a.d.removeAt(0);
        }
        static c(a) {
            if (a == null) {
                return;
            }
            let b = typeCast(Panel.$, a.x);
            if (b != null) {
                b.ab.remove(a);
                return;
            }
            let c = typeCast(ContentControl.$, a.x);
            if (c != null) {
                c.content = null;
                return;
            }
        }
        static f(a, b) {
            let c = new List$1(UIElement.$, 0);
            for (let d of fromEnum(a.ab)) {
                if (typeCast(UIElement.$, d) !== null) {
                    c.add(d);
                }
            }
            for (let e of fromEnum(c)) {
                a.ab.remove(e);
                b.ab.add(e);
            }
        }
        static a(a) {
            return !isNaN_(a.x) && !isNaN_(a.y) && !isInfinity(a.x) && !isInfinity(a.y);
        }
        static b(a) {
            return !isNaN_(a.left) && !isNaN_(a.right) && !isNaN_(a.top) && !isNaN_(a.bottom) && !isInfinity(a.left) && !isInfinity(a.right) && !isInfinity(a.top) && !isInfinity(a.bottom);
        }
    }
    Extensions.$t = /*@__PURE__*/ markType(Extensions, 'Extensions');
    return Extensions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FrameworkElementExtensions = /*@__PURE__*/ (() => {
    class FrameworkElementExtensions extends Base {
        static a(a, b) {
            return a.x != null;
        }
    }
    FrameworkElementExtensions.$t = /*@__PURE__*/ markType(FrameworkElementExtensions, 'FrameworkElementExtensions');
    return FrameworkElementExtensions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MathUtilExtended = /*@__PURE__*/ (() => {
    class MathUtilExtended extends Base {
        static d(a) {
            if (a <= 0) {
                return NaN;
            }
            let b = [57.156235665862923, -59.597960355475493, 14.136097974741746, -0.49191381609762019, 3.3994649984811891E-05, 4.6523628927048578E-05, -9.8374475304879565E-05, 0.00015808870322491249, -0.00021026444172410488, 0.00021743961811521265, -0.00016431810653676389, 8.441822398385275E-05, -2.6190838401581408E-05, 3.6899182659531625E-06];
            let c = a;
            let d = (a + 0.5) * Math.log(a + 5.2421875) - (a + 5.2421875);
            let e = 0.99999999999999711;
            for (let f = 0; f < 14; f++) {
                e += b[f] / ++c;
            }
            return d + Math.log(2.5066282746310007 * e / a);
        }
        static j(a, b, c) {
            let d = truncate(Math.floor(a)) & 255;
            let e = truncate(Math.floor(b)) & 255;
            let f = truncate(Math.floor(c)) & 255;
            a -= Math.floor(a);
            b -= Math.floor(b);
            c -= Math.floor(c);
            let g = MathUtilExtended.c(a);
            let h = MathUtilExtended.c(b);
            let i = MathUtilExtended.c(c);
            let j = MathUtilExtended.a[d] + e;
            let k = MathUtilExtended.a[j] + f;
            let l = MathUtilExtended.a[j + 1] + f;
            let m = MathUtilExtended.a[d + 1] + e;
            let n = MathUtilExtended.a[m] + f;
            let o = MathUtilExtended.a[m + 1] + f;
            return MathUtilExtended.f(i, MathUtilExtended.f(h, MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[k], a, b, c), MathUtilExtended.e(MathUtilExtended.a[n], a - 1, b, c)), MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[l], a, b - 1, c), MathUtilExtended.e(MathUtilExtended.a[o], a - 1, b - 1, c))), MathUtilExtended.f(h, MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[k + 1], a, b, c - 1), MathUtilExtended.e(MathUtilExtended.a[n + 1], a - 1, b, c - 1)), MathUtilExtended.f(g, MathUtilExtended.e(MathUtilExtended.a[l + 1], a, b - 1, c - 1), MathUtilExtended.e(MathUtilExtended.a[o + 1], a - 1, b - 1, c - 1))));
        }
        static c(a) {
            return a * a * a * (a * (a * 6 - 15) + 10);
        }
        static f(a, b, c) {
            return b + a * (c - b);
        }
        static e(a, b, c, d) {
            let e = a & 15;
            let f = e < 8 ? b : c;
            let g = e < 4 ? c : e == 12 || e == 14 ? b : d;
            return ((e & 1) == 0 ? f : -f) + ((e & 2) == 0 ? g : -g);
        }
        static h(a) {
            if (a == 0) {
                return 0;
            }
            if (a < 0) {
                return -MathUtilExtended.g(-a);
            }
            let b = truncate(Math.floor(log10(a)));
            let c = a / MathUtilExtended.b(10, b);
            let d = c < 2 ? 1 : (c < 5 ? 2 : (c < 10 ? 5 : 10));
            return d * MathUtilExtended.b(10, b);
        }
        static i(a) {
            if (a == 0) {
                return 0;
            }
            if (a < 0) {
                return -MathUtilExtended.i(-a);
            }
            let b = truncate(Math.floor(log10(a)));
            let c = a / MathUtilExtended.b(10, b);
            let d = c < 1 ? 1 : (c < 3 ? 2 : (c < 7 ? 5 : 10));
            return d * MathUtilExtended.b(10, b);
        }
        static g(a) {
            if (a == 0) {
                return 0;
            }
            if (a < 0) {
                return -MathUtilExtended.h(-a);
            }
            let b = truncate(Math.floor(log10(a)));
            let c = a / MathUtilExtended.b(10, b);
            let d = c <= 1 ? 1 : (c <= 2 ? 2 : (c <= 5 ? 5 : 10));
            return d * MathUtilExtended.b(10, b);
        }
        static b(a, b) {
            let c = 1;
            for (; b > 0; --b) {
                c *= a;
            }
            for (; b < 0; ++b) {
                c /= a;
            }
            return c;
        }
    }
    MathUtilExtended.$t = /*@__PURE__*/ markType(MathUtilExtended, 'MathUtilExtended');
    MathUtilExtended.a = [151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180, 151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9, 129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180];
    return MathUtilExtended;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPool$1_$type = /*@__PURE__*/ new Type(null, 'IPool$1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IIndexedPool$1_$type = /*@__PURE__*/ new Type(null, 'IIndexedPool$1', null, [/*@__PURE__*/ IPool$1_$type.specialize(0)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Pool$1 = /*@__PURE__*/ (() => {
    class Pool$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this._create = null;
            this._disactivate = null;
            this._activate = null;
            this._destroy = null;
            this.a = null;
            this.b = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = new List$1(this.$t, 0);
            this.b = new List$1(this.$t, 0);
        }
        get create() {
            return this._create;
        }
        set create(a) {
            this._create = a;
        }
        get disactivate() {
            return this._disactivate;
        }
        set disactivate(a) {
            this._disactivate = a;
        }
        get activate() {
            return this._activate;
        }
        set activate(a) {
            this._activate = a;
        }
        get destroy() {
            return this._destroy;
        }
        set destroy(a) {
            this._destroy = a;
        }
        item(a) {
            if (a >= this.count) {
                this.count = a + 1;
            }
            return this.a._inner[a];
        }
        clear() {
            this.count = 0;
        }
        get count() {
            return this.a.count;
        }
        set count(a) {
            let b = this.a.count;
            while (a > this.a.count && this.b.count > 0) {
                let c = this.b._inner[this.b.count - 1];
                this.a.add(c);
                this.b.removeAt(this.b.count - 1);
                if (this.activate != null) {
                    this.activate(c);
                }
            }
            while (a > this.a.count && this.b.count == 0) {
                let d = this.create();
                this.a.add(d);
                if (this.activate != null) {
                    this.activate(d);
                }
            }
            let e = 2;
            while (b != 0) {
                b >>= 1;
                e <<= 1;
            }
            while (a < this.a.count) {
                let f = this.a._inner[this.a.count - 1];
                this.a.removeAt(this.a.count - 1);
                if (this.disactivate != null) {
                    this.disactivate(f);
                }
                if (this.b.count < e) {
                    this.b.add(f);
                }
                else {
                    if (this.destroy != null) {
                        this.destroy(f);
                    }
                }
            }
            if (e < this.b.count) {
                for (let g = e; g < this.b.count; ++g) {
                    this.destroy(this.b._inner[g]);
                }
                this.b.v(e, this.b.count - e);
            }
        }
        c(a) {
            for (let b = 0; b < this.b.count; b++) {
                a(this.b._inner[b]);
            }
            for (let c = 0; c < this.a.count; c++) {
                a(this.a._inner[c]);
            }
        }
    }
    Pool$1.$t = /*@__PURE__*/ markType(Pool$1, 'Pool$1', Base.$, [/*@__PURE__*/ IIndexedPool$1_$type.specialize(0)]);
    return Pool$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHashPool$2_$type = /*@__PURE__*/ new Type(null, 'IHashPool$2', null, [/*@__PURE__*/ IPool$1_$type.specialize(1)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HashPool$2 = /*@__PURE__*/ (() => {
    class HashPool$2 extends Base {
        constructor($tKey, $tValue) {
            super();
            this.$tKey = null;
            this.$tValue = null;
            this.d = null;
            this.b = null;
            this._create = null;
            this._disactivate = null;
            this._activate = null;
            this._destroy = null;
            this.$tKey = $tKey;
            this.$tValue = $tValue;
            this.$type = this.$type.specialize(this.$tKey, this.$tValue);
            this.d = new List$1(this.$tValue, 0);
            this.b = new Dictionary$2(this.$tKey, this.$tValue, 0);
        }
        get create() {
            return this._create;
        }
        set create(a) {
            this._create = a;
        }
        get disactivate() {
            return this._disactivate;
        }
        set disactivate(a) {
            this._disactivate = a;
        }
        get activate() {
            return this._activate;
        }
        set activate(a) {
            this._activate = a;
        }
        get destroy() {
            return this._destroy;
        }
        set destroy(a) {
            this._destroy = a;
        }
        item(a) {
            let b;
            if (!((() => { let c = this.b.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                if (this.d.count > 0) {
                    b = this.d._inner[this.d.count - 1];
                    this.d.removeAt(this.d.count - 1);
                }
                else {
                    b = this.create();
                }
                if (this.activate != null) {
                    this.activate(b);
                }
                this.b.item(a, b);
            }
            return b;
        }
        get c() {
            return this.b.keys;
        }
        a(a) {
            return this.b.containsKey(a);
        }
        h(a) {
            let b;
            if (((() => { let c = this.b.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                this.b.removeItem(a);
                if (this.disactivate != null) {
                    this.disactivate(b);
                }
                this.d.add(b);
                let c = this.b.count;
                let d = 2;
                while (c != 0) {
                    c >>= 1;
                    d <<= 1;
                }
                if (d < this.d.count) {
                    for (let e = d; e < this.d.count; ++e) {
                        this.destroy(this.d._inner[e]);
                    }
                    this.d.v(d, this.d.count - d);
                }
            }
        }
        clear() {
            let a = new List$1(this.$tKey, 0);
            for (let b of fromEnum(this.b.keys)) {
                a.add(b);
            }
            for (let c of fromEnum(a)) {
                this.h(c);
            }
        }
        get e() {
            return this.b.count;
        }
        f(a) {
            for (let b = 0; b < this.d.count; b++) {
                a(this.d._inner[b]);
            }
            for (let c of fromEnum(this.b.values)) {
                a(c);
            }
        }
        g(a) {
            for (let b = 0; b < this.d.count; b++) {
                a(this.d._inner[b]);
            }
            for (let c of fromEnum(this.b.values)) {
                a(c);
            }
        }
    }
    HashPool$2.$t = /*@__PURE__*/ markType(HashPool$2, 'HashPool$2', Base.$, [/*@__PURE__*/ IHashPool$2_$type.specialize(0, 1)]);
    return HashPool$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RearrangedList$1 = /*@__PURE__*/ (() => {
    class RearrangedList$1 extends Base {
        constructor($t, a, b) {
            super();
            this.$t = null;
            this.b = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.b = a;
            this.a = b;
        }
        indexOf(a) {
            let b = this.b.indexOf(a);
            if (b == -1) {
                return -1;
            }
            return this.a.indexOf(b);
        }
        insert(a, b) {
            throw new NotImplementedException(0);
        }
        removeAt(a) {
            throw new NotImplementedException(0);
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return this.b.item(this.a.item(a));
            }
        }
        add(a) {
            throw new NotImplementedException(0);
        }
        clear() {
            this.a.clear();
        }
        contains(a) {
            return this.b.contains(a);
        }
        copyTo(a, b) {
            throw new NotImplementedException(0);
        }
        get count() {
            return this.a.count;
        }
        get isReadOnly() {
            return true;
        }
        remove(a) {
            throw new NotImplementedException(0);
        }
        *_getEnumerator() {
            for (let a of fromEnum(this.a)) {
                yield this.b.item(a);
            }
        }
        getEnumerator() {
            return toEnum(() => this._getEnumerator()).getEnumerator();
        }
        *_getEnumeratorObject() {
            for (let a of fromEnum(this.a)) {
                yield getBoxIfEnum(this.$t, this.b.item(a));
            }
        }
        getEnumeratorObject() {
            return toEnum(() => this._getEnumeratorObject()).getEnumeratorObject();
        }
    }
    RearrangedList$1.$t = /*@__PURE__*/ markType(RearrangedList$1, 'RearrangedList$1', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(0)]);
    return RearrangedList$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectUtil = /*@__PURE__*/ (() => {
    class RectUtil extends Base {
        static l(a) {
            if (a.isEmpty) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            return { $type: Point_$type, x: 0.5 * (a.left + a.right), y: 0.5 * (a.bottom + a.top) };
        }
        static e(a) {
            if (a.isEmpty) {
                return 0;
            }
            return a.width * a.height;
        }
        static p(a) {
            if (a.isEmpty) {
                return a;
            }
            return new Rect(0, a.left, a.top, a.width, a.height);
        }
        static m(a, b) {
            if (a.containsPoint(b)) {
                return b;
            }
            let c = { $type: Point_$type, x: a.left + 0.5 * a.width, y: a.top + 0.5 * a.height };
            let d = { $type: Point_$type, x: b.x - c.x, y: b.y - c.y };
            let e;
            if (d.x != 0) {
                e = (a.left - c.x) / d.x;
                let f = c.y + e * d.y;
                if (f > a.top && f < a.bottom) {
                    return e > 0 ? { $type: Point_$type, x: a.left, y: f } : { $type: Point_$type, x: a.right, y: c.y - e * d.y };
                }
            }
            e = (a.top - c.y) / d.y;
            let g = c.x + e * d.x;
            return e > 0 ? { $type: Point_$type, x: g, y: a.top } : { $type: Point_$type, x: c.x - e * d.x, y: a.bottom };
        }
        static g(a, b) {
            if (a.isEmpty) {
                return NaN;
            }
            return RectUtil.f(a, b.x, b.y);
        }
        static h(a, b) {
            if (a.isEmpty) {
                return Number.POSITIVE_INFINITY;
            }
            let c = RectUtil.f(a, b.left, b.top);
            if (c > 0) {
                c = Math.min(c, RectUtil.f(a, b.left, b.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(a, b.right, b.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(a, b.right, b.top));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.left, a.top));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.left, a.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.right, a.bottom));
            }
            if (c > 0) {
                c = Math.min(c, RectUtil.f(b, a.right, a.top));
            }
            return c;
        }
        static f(a, b, c) {
            let d = b - a.left;
            let e = c - a.top;
            let f = a.width * d;
            let g = a.height * e;
            if (f > 0) {
                let h = a.width * a.width;
                if (f < h) {
                    d -= (f / h) * a.width;
                }
                else {
                    d -= a.width;
                }
            }
            if (g > 0) {
                let i = a.height * a.height;
                if (g < i) {
                    e -= (g / i) * a.height;
                }
                else {
                    e -= a.height;
                }
            }
            return d * d + e * e;
        }
        static a(a, b) {
            if (a.isEmpty || b.isEmpty) {
                return false;
            }
            if (a.left > b.left) {
                return false;
            }
            if (a.right < b.right) {
                return false;
            }
            if (a.top > b.top) {
                return false;
            }
            if (a.bottom < b.bottom) {
                return false;
            }
            return true;
        }
        static b(a, b) {
            if (a.isEmpty || b.isEmpty) {
                return false;
            }
            if (a.right < b.left) {
                return false;
            }
            if (a.left > b.right) {
                return false;
            }
            if (a.top > b.bottom) {
                return false;
            }
            if (a.bottom < b.top) {
                return false;
            }
            return true;
        }
        static i(a, b) {
            if (a.isEmpty || b.isEmpty) {
                return 0;
            }
            let c = Math.min(a.right, b.right) - Math.max(a.left, b.left);
            if (c <= 0) {
                return 0;
            }
            let d = Math.min(a.bottom, b.bottom) - Math.max(a.top, b.top);
            if (d <= 0) {
                return 0;
            }
            return c * d;
        }
        static q(a, b, c) {
            if (a.isEmpty) {
                return a;
            }
            return new Rect(0, a.x - b, a.y - c, Math.max(0, a.width + 2 * b), Math.max(0, a.height + 2 * c));
        }
        static t(a, b, c) {
            a.x = a.x - b;
            a.y = a.y - c;
            let d = a.width + 2 * b;
            let e = a.height + 2 * c;
            a.width = d > 1 ? d : 1;
            a.height = e > 1 ? e : 1;
            return a;
        }
        static s(a, b, c) {
            a.x = a.x - b;
            a.y = a.y - c;
            let d = a.width + 2 * b;
            let e = a.height + 2 * c;
            a.width = d > 1 ? d : 1;
            a.height = e > 1 ? e : 1;
            return a;
        }
        static r(a, b) {
            let c = a.x - b;
            let d = a.y - b;
            let e = a.width + b + b;
            let f = a.height + b + b;
            let g = e > 0 ? e : 0;
            let h = f > 0 ? f : 0;
            return new Rect(0, c, d, g, h);
        }
        static y(a) {
            a.x = Math.round(a.x);
            a.y = Math.round(a.y);
            a.width = Math.round(a.width);
            a.height = Math.round(a.height);
            return a;
        }
        static c(a) {
            return a.x == 0 && a.y == 0 && a.width == 0 && a.height == 0;
        }
        static z(a) {
            let b = new Size(1, a.width, a.height);
            return b;
        }
        static u(a, b) {
            let c = RectUtil.v(a, RectUtil.z(b));
            return c;
        }
        static v(a, b) {
            let c = a;
            c.x = a.x / b.width;
            c.y = a.y / b.height;
            c.width = a.width / b.width;
            c.height = a.height / b.height;
            return c;
        }
        static n(a) {
            let b = { $type: Point_$type, x: a.x, y: a.y };
            return b;
        }
        static o(a) {
            let b = { $type: Point_$type, x: a.x + a.width, y: a.y };
            return b;
        }
        static j(a) {
            let b = { $type: Point_$type, x: a.x, y: a.y + a.height };
            return b;
        }
        static k(a) {
            let b = { $type: Point_$type, x: a.x + a.width, y: a.y + a.height };
            return b;
        }
        static d(a) {
            let b = ((() => {
                let $ret = new List$1(Point_$type, 0);
                $ret.add(RectUtil.n(a));
                $ret.add(RectUtil.o(a));
                $ret.add(RectUtil.k(a));
                $ret.add(RectUtil.j(a));
                return $ret;
            })());
            return b;
        }
        static w(a, b) {
            b = CoreGeometryUtil.a(b);
            if (b == 0 || b == 180) {
                return new Rect(0, a.left, a.top, a.width, a.height);
            }
            let c = RectUtil.l(a);
            if (b == 90 || b == 270) {
                let d = a.height / 2;
                let e = a.width / 2;
                return new Rect(0, c.x - d, c.y - e, a.height, a.width);
            }
            return RectUtil.x(a, c.x, c.y, b);
        }
        static x(a, b, c, d) {
            let e = RectUtil.d(a);
            let f = MathUtil.k(d);
            let g = Math.cos(f);
            let h = Math.sin(f);
            let i = 1.7976931348623157E+308;
            let j = 1.7976931348623157E+308;
            let k = -1.7976931348623157E+308;
            let l = -1.7976931348623157E+308;
            let m;
            for (let n = 0; n < e.count; n++) {
                m = e._inner[n];
                let o = (g * (m.x - b) - h * (m.y - c) + b);
                let p = (h * (m.x - b) + g * (m.y - c) + c);
                i = Math.min(i, p);
                j = Math.min(j, o);
                k = Math.max(k, o);
                l = Math.max(l, p);
            }
            let q = new Rect(0, j, i, k - j, l - i);
            return q;
        }
    }
    RectUtil.$t = /*@__PURE__*/ markType(RectUtil, 'RectUtil');
    return RectUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ReverseArrayEnumerator$1 = /*@__PURE__*/ (() => {
    class ReverseArrayEnumerator$1 extends Base {
        constructor($t, a) {
            super();
            this.$t = null;
            this.b = 0;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = a;
            this.b = a.count;
        }
        get current() {
            return typeCastObjTo$t(this.$t, this.a.item(this.b));
        }
        get currentObject() {
            return this.a.item(this.b);
        }
        moveNext() {
            this.b--;
            return this.b >= 0;
        }
        reset() {
            this.b = this.a.count;
        }
        dispose() {
            throw new NotImplementedException(0);
        }
    }
    ReverseArrayEnumerator$1.$t = /*@__PURE__*/ markType(ReverseArrayEnumerator$1, 'ReverseArrayEnumerator$1', Base.$, [/*@__PURE__*/ IEnumerator$1_$type.specialize(0)]);
    return ReverseArrayEnumerator$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stack$1 = /*@__PURE__*/ (() => {
    class Stack$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.c = arrayListCreate();
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        h(a) {
            this.c.add(getBoxIfEnum(this.$t, a));
        }
        d() {
            if (this.c.count < 1) {
                return Type.getDefaultValue(this.$t);
            }
            return typeCastObjTo$t(this.$t, this.c.item(this.c.count - 1));
        }
        e() {
            let a = this.c.item(this.c.count - 1);
            this.c.removeAt(this.c.count - 1);
            return typeCastObjTo$t(this.$t, a);
        }
        get f() {
            return this.c.count;
        }
        g() {
            this.c.clear();
        }
        b(a) {
            return this.c.contains(getBoxIfEnum(this.$t, a));
        }
        getEnumeratorObject() {
            return new ReverseArrayEnumerator$1(this.$t, this.c);
        }
        getEnumerator() {
            return new ReverseArrayEnumerator$1(this.$t, this.c);
        }
        a() {
            let a = this.c.count;
            let b = new Array(a);
            for (let c = 0; c < a; c++) {
                b[c] = typeCastObjTo$t(this.$t, this.c.item(a - (c + 1)));
            }
            return b;
        }
    }
    Stack$1.$t = /*@__PURE__*/ markType(Stack$1, 'Stack$1', Base.$, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0)]);
    return Stack$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackPool$1 = /*@__PURE__*/ (() => {
    class StackPool$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.e = false;
            this.j = null;
            this.c = null;
            this.b = null;
            this.d = null;
            this.g = null;
            this.i = null;
            this.h = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.g = new Dictionary$2(this.$t, Base.$, 0);
            this.i = new Stack$1(this.$t);
            this.h = new Stack$1(this.$t);
        }
        a() {
            let a;
            if (this.i.f != 0) {
                a = this.i.e();
            }
            else {
                a = this.h.f != 0 ? this.h.e() : this.j();
                this.b(a);
            }
            this.g.addItem(a, null);
            return a;
        }
        n(a) {
            this.g.removeItem(a);
            if (this.f) {
                this.i.h(a);
            }
            else {
                this.c(a);
                let b = StackPool$1.m(this.$t, this.g.count);
                if (this.h.f < b) {
                    this.d(a);
                }
                else {
                    this.h.h(a);
                }
            }
        }
        get f() {
            return this.e;
        }
        set f(a) {
            if (this.e != a) {
                this.e = a;
                if (!this.e) {
                    let b = StackPool$1.m(this.$t, this.g.count);
                    while (this.i.f > 0 && this.h.f <= b) {
                        let c = this.i.e();
                        this.c(c);
                        this.h.h(c);
                    }
                    while (this.i.f > 0) {
                        let d = this.i.e();
                        this.c(d);
                        this.d(d);
                    }
                    while (this.h.f > b) {
                        this.d(this.h.e());
                    }
                }
            }
        }
        get k() {
            return this.g.count;
        }
        get l() {
            return this.h.f;
        }
        static m($t, a) {
            let b = 2;
            while (a > b) {
                b = b << 1;
            }
            return b;
        }
    }
    StackPool$1.$t = /*@__PURE__*/ markType(StackPool$1, 'StackPool$1');
    return StackPool$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISchedulableRender_$type = /*@__PURE__*/ new Type(null, 'ISchedulableRender');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CanvasRenderScheduler = /*@__PURE__*/ (() => {
    class CanvasRenderScheduler extends Base {
        constructor() {
            super();
            this.b = true;
            this.f = null;
            this.e = null;
            this.a = false;
            this.h = -1;
            this.g = null;
            this.c = false;
            this.f = new List$1(ISchedulableRender_$type, 0);
            this.e = new List$1(CanvasRenderScheduler.$, 0);
        }
        l(a) {
            this.b = true;
            this.f.add(a);
        }
        r(a) {
            this.b = true;
            this.f.remove(a);
        }
        p() {
            this.b = true;
            this.n();
        }
        get d() {
            return this.a;
        }
        j(a) {
            let b = this.g;
            this.g = a;
            if (this.a && this.g != null && b == null) {
                this.g.setTimeout(runOn(this, this.k), 0);
            }
        }
        n() {
            if (!this.a) {
                this.a = true;
                if (this.g != null) {
                    this.g.setTimeout(runOn(this, this.k), 0);
                }
                else {
                    window.setTimeout(runOn(this, this.k), 0);
                }
            }
        }
        o(a, b) {
            this.n();
        }
        i() {
            if (this.h != -1) {
                window.clearTimeout(this.h);
                this.h = -1;
            }
            if (this.a) {
                this.k();
            }
        }
        k() {
            this.h = -1;
            if (this.a) {
                this.a = false;
                if (this.e.count > 0) {
                    for (let a = 0; a < this.e.count; a++) {
                        this.e._inner[a].i();
                    }
                }
                if (this.b) {
                    this.q();
                }
                this.m();
            }
        }
        m() {
            if (this.c) {
                return;
            }
            let a = true;
            for (let b = 0; b < this.f.count; b++) {
                let c = this.f._inner[b];
                c.preRender();
            }
            for (let d = 0; d < this.f.count; d++) {
                let e = this.f._inner[d];
                e.undirty(a);
                a = false;
            }
            for (let f = 0; f < this.f.count; f++) {
                let g = this.f._inner[f];
                g.postRender();
            }
        }
        q() {
            this.f.aa((a, b) => {
                let c = a;
                let d = b;
                if (c.index < d.index) {
                    return -1;
                }
                if (c.index > d.index) {
                    return 1;
                }
                return 0;
            });
            this.b = false;
        }
    }
    CanvasRenderScheduler.$t = /*@__PURE__*/ markType(CanvasRenderScheduler, 'CanvasRenderScheduler');
    return CanvasRenderScheduler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CanvasViewRenderer = /*@__PURE__*/ (() => {
    class CanvasViewRenderer extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.g = 0;
            this.e = 0;
            this.h = 0;
            this.f = 0;
            this.b = false;
            this.c = false;
            this.z = null;
            this.l = "left";
            this.a = null;
            this.d = 1;
        }
        h$e() {
            return this.i;
        }
        get h$d() {
            return this.i;
        }
        set h$d(a) {
            this.i = a;
        }
        k(a, b, c, d, e, f, g) {
            return CanvasViewRenderer.j(this.i, a, b, c, d, e, f, g);
        }
        static j(a, b, c, d, e, f, g, h) {
            let i;
            if (b.useCustomDirection) {
                let j, k, l, m, n;
                n = e - c;
                j = c + b.startX * n;
                l = c + b.endX * n;
                n = f - d;
                k = d + b.startY * n;
                m = d + b.endY * n;
                if (h) {
                    let o = g / 2;
                    j -= o;
                    l += o;
                    k -= o;
                    m += o;
                }
                i = a.createLinearGradient(j, k, l, m);
            }
            else {
                if (h) {
                    let p = g / 2;
                    c -= p;
                    e += p;
                    d -= p;
                    f += p;
                }
                i = a.createLinearGradient(c, d, c, f);
            }
            for (let q = 0; q < b.gradientStops.length; q++) {
                let r = b.gradientStops[q];
                i.addColorStop(r.offset, r._fill);
            }
            return i;
        }
        h$t(a) {
            if (a._visibility != 0) {
                return;
            }
            let b = a.n;
            let c = a.o;
            let d = a.width;
            let e = a.height;
            let f = a.am;
            let g = a.an;
            this.i.beginPath();
            this.i.globalAlpha = (a._opacity * this.d);
            if (f > 0 || g > 0) {
                if (f > d / 2) {
                    f = (d / 2);
                }
                if (g > e / 2) {
                    g = (e / 2);
                }
                let h = Math.min(f, g);
                this.i.beginPath();
                this.i.moveTo(b + h, c);
                this.i.lineTo(b + d - h, c);
                this.i.arc(b + d - h, c + h, h, (3 / 2 * Math.PI), 0, false);
                this.i.lineTo(b + d, c + e - h);
                this.i.arc(b + d - h, c + e - h, h, 0, (Math.PI / 2), false);
                this.i.lineTo(b + h, c + e);
                this.i.arc(b + h, c + e - h, h, (Math.PI / 2), Math.PI, false);
                this.i.lineTo(b, c + h);
                this.i.arc(b + h, c + h, h, Math.PI, (3 / 2 * Math.PI), false);
                this.i.closePath();
            }
            else {
                this.i.rect(b, c, d, e);
            }
            let i = a._fill;
            let j = a._stroke;
            if (i != null) {
                if (i.isGradient && c == c && b == b) {
                    this.i.fillStyle = this.k(i, b, c, b + d, c + e, a.ac, false);
                }
                else {
                    this.i.fillStyle = i._fill;
                }
                this.i.fill();
            }
            if (j != null) {
                if (j.isGradient && c == c && b == b) {
                    this.i.strokeStyle = this.k(j, b, c, b + d, c + e, a.ac, true);
                }
                else {
                    this.i.strokeStyle = j._fill;
                }
                this.i.lineWidth = a.ac;
                this.i.stroke();
            }
            this.i.globalAlpha = 1;
        }
        h$q(a) {
            if (a._visibility != 0) {
                return;
            }
            this.i.beginPath();
            if (a._opacity < 1 || this.d < 1) {
                this.i.globalAlpha = (a._opacity * this.d);
            }
            let b = a._fill;
            let c = a._stroke;
            this.b = (b != null && b.isGradient) || (c != null && c.isGradient);
            if (this.b) {
                this.e = -1.7976931348623157E+308;
                this.f = -1.7976931348623157E+308;
                this.g = 1.7976931348623157E+308;
                this.h = 1.7976931348623157E+308;
                this.c = false;
            }
            switch (a.aj) {
                case 0:
                    this.i.lineJoin = "miter";
                    break;
                case 1:
                    this.i.lineJoin = "bevel";
                    break;
                case 2:
                    this.i.lineJoin = "round";
                    break;
            }
            this.h$o(a.ak);
            if (b != null) {
                if (b.isGradient && this.c) {
                    this.i.fillStyle = this.k(b, this.g, this.h, this.e, this.f, a.ac, false);
                }
                else {
                    this.i.fillStyle = a._fill._fill;
                }
                this.i.fill();
            }
            if (c != null) {
                if (c.isGradient && this.c) {
                    this.i.strokeStyle = this.k(c, this.g, this.h, this.e, this.f, a.ac, true);
                }
                else {
                    this.i.strokeStyle = a._stroke._fill;
                }
                this.i.lineWidth = a.ac;
                if (a.ac > 0) {
                    this.i.stroke();
                }
            }
            if (a._opacity < 1 || this.d < 1) {
                this.i.globalAlpha = 1;
            }
        }
        h$o(a) {
            if (a == null) {
                return;
            }
            let b = a.b;
            switch (b) {
                case 0:
                    for (let c = 0; c < a.d.count; c++) {
                        this.h$o(a.d._inner[c]);
                    }
                    break;
                case 4:
                    this.s(a);
                    break;
                case 1:
                    this.q(a);
                    break;
                case 2:
                    this.v(a);
                    break;
                case 3:
                    this.o(a);
                    break;
            }
        }
        o(a) {
            this.i.moveTo(a.e.x, (a.e.y - a.d));
            this.z = { $type: Point_$type, x: a.e.x, y: a.e.y - a.d };
            let b = ((() => {
                let $ret = new ArcSegment();
                $ret.e = { $type: Point_$type, x: a.e.x, y: a.e.y + a.d };
                $ret.b = false;
                $ret.f = new Size(1, a.c, a.d);
                return $ret;
            })());
            let c = ((() => {
                let $ret = new ArcSegment();
                $ret.e = { $type: Point_$type, x: a.e.x, y: a.e.y - a.d };
                $ret.b = false;
                $ret.f = new Size(1, a.c, a.d);
                return $ret;
            })());
            let d = this.b;
            this.b = false;
            this.m(b);
            this.m(c);
            this.b = d;
            if (!this.b) {
                return;
            }
            let e = a.e.x - a.c;
            let f = a.e.y + a.c;
            let g = a.e.x - a.d;
            let h = a.e.y + a.d;
            let i = this.e;
            let j = this.f;
            let k = this.g;
            let l = this.h;
            this.g = e < k ? e : k;
            this.h = g < l ? g : l;
            this.e = f > i ? f : i;
            this.f = h > j ? h : j;
            this.c = true;
        }
        s(a) {
            let b = a.c;
            let c = b.count;
            for (let d = 0; d < c; d++) {
                this.p(b._inner[d]);
            }
        }
        p(a) {
            let b = a == null ? null : a._startPoint;
            if (PointUtil.equals(b, null)) {
                return;
            }
            let c = b.x;
            let d = b.y;
            this.i.moveTo(c, d);
            if (this.b) {
                let e = this.e;
                let f = this.f;
                let g = this.g;
                let h = this.h;
                this.g = c < g ? c : g;
                this.h = d < h ? d : h;
                this.e = c > e ? c : e;
                this.f = d > f ? d : f;
                this.c = true;
            }
            this.z = b;
            let i = a._segments;
            let j = i.count;
            for (let k = 0; k < j; k++) {
                this.w(i._inner[k]);
            }
            if (a._isClosed) {
                this.i.closePath();
            }
        }
        w(a) {
            let b = a.a;
            switch (b) {
                case 0:
                    this.r(a);
                    break;
                case 3:
                    this.u(a);
                    break;
                case 4:
                    this.m(a);
                    break;
                case 1:
                    this.n(a);
                    break;
                case 2:
                    this.t(a);
                    break;
            }
        }
        y(a, b, c, d, e, f, g, h) {
            let i = 1 / 50;
            let j;
            let k;
            let l;
            let m;
            let n;
            let o;
            let p;
            let q = this.g;
            let r = this.h;
            let s = this.e;
            let t = this.f;
            for (let u = 0; u <= 1; u += i) {
                j = 1 - u;
                k = j * j;
                l = k * j;
                m = u * u;
                n = m * u;
                o = l * a + 3 * k * u * c + 3 * j * m * e + n * g;
                p = l * b + 3 * k * u * d + 3 * j * m * f + n * h;
                q = o < q ? o : q;
                r = p < r ? p : r;
                s = o > s ? o : s;
                t = p > t ? p : t;
            }
            this.g = q;
            this.h = r;
            this.e = s;
            this.f = t;
            this.c = true;
        }
        n(a) {
            this.i.bezierCurveTo(a.e.x, a.e.y, a.f.x, a.f.y, a.g.x, a.g.y);
            if (this.b) {
                this.y(this.z.x, this.z.y, a.e.x, a.e.y, a.f.x, a.f.y, a.g.x, a.g.y);
            }
        }
        t(a) {
            let b = 0;
            let c = a.b.count;
            let d = a.b;
            let e = this.z;
            let f = this.z;
            let g = this.z;
            let h = this.b;
            while (b < c) {
                if (b + 1 < c && b + 2 < c) {
                    e = d._inner[b];
                    f = d._inner[b + 1];
                    g = d._inner[b + 2];
                    this.i.bezierCurveTo(e.x, e.y, f.x, f.y, g.x, g.y);
                    if (h) {
                        this.y(this.z.x, this.z.y, e.x, e.y, f.x, f.y, g.x, g.y);
                        this.z = g;
                    }
                }
                b = b + 3;
            }
            this.z = g;
        }
        x(a, b, c, d, e) {
            let f = new List$1(Point_$type, 0);
            f.add(a);
            f.add({ $type: Point_$type, x: a.x + Math.cos(b) * d, y: a.y + Math.sin(b) * d });
            f.add({ $type: Point_$type, x: a.x + Math.cos(c) * d, y: a.y + Math.sin(c) * d });
            let g = Math.PI * 2;
            let h = Math.PI / 2;
            let i = Math.PI;
            let j = Math.PI * 3 / 2;
            while (b < 0) {
                b += g;
            }
            while (b > g) {
                b -= g;
            }
            while (c < 0) {
                c += g;
            }
            while (c > g) {
                c -= g;
            }
            if (e) {
                if ((0 > c && 0 < b) || (g > c && g < b) || (b < c)) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(0) * d, y: a.y + Math.sin(0) * d });
                }
                if (h > c && h < b) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(h) * d, y: a.y + Math.sin(h) * d });
                }
                if (i > c && i < b) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(i) * d, y: a.y + Math.sin(i) * d });
                }
                if (j > c && j < b) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(j) * d, y: a.y + Math.sin(j) * d });
                }
            }
            else {
                if ((0 > b && 0 < c) || (g > b && g < c) || (c < b)) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(0) * d, y: a.y + Math.sin(0) * d });
                }
                if (h > b && h < c) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(h) * d, y: a.y + Math.sin(h) * d });
                }
                if (i > b && i < c) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(i) * d, y: a.y + Math.sin(i) * d });
                }
                if (j > b && j < c) {
                    f.add({ $type: Point_$type, x: a.x + Math.cos(j) * d, y: a.y + Math.sin(j) * d });
                }
            }
            let k = 1.7976931348623157E+308;
            let l = 1.7976931348623157E+308;
            let m = -1.7976931348623157E+308;
            let n = -1.7976931348623157E+308;
            for (let o = 0; o < f.count; o++) {
                let p = f._inner[o];
                k = Math.min(k, p.x);
                l = Math.min(l, p.y);
                m = Math.max(m, p.x);
                n = Math.max(n, p.y);
            }
            this.g = Math.min(this.g, k);
            this.h = Math.min(this.h, l);
            this.e = Math.max(this.e, m);
            this.f = Math.max(this.f, n);
            this.c = true;
        }
        m(a) {
            let b = this.z;
            let c = a.e;
            if (a.f.width != a.f.height) {
                this.i.save();
                this.i.scale(a.f.width / a.f.height, 1);
                b = { $type: Point_$type, x: b.x * (a.f.height / a.f.width), y: b.y };
                c = { $type: Point_$type, x: c.x * (a.f.height / a.f.width), y: c.y };
            }
            let d = a.d == 0;
            let e = CoreGeometryUtil.b(b, c, a.f.height, d, a.b);
            let f = Math.atan2(b.y - e.y, b.x - e.x);
            let g = Math.atan2(c.y - e.y, c.x - e.x);
            let h = (Math.abs(g - f) < Math.PI);
            if (a.b == h) {
                if (f < g) {
                    f += 2 * Math.PI;
                }
                else {
                    g += 2 * Math.PI;
                }
            }
            if (!isNaN_(e.x) && !isNaN_(e.y) && !isNaN_(a.f.height) && !isNaN_(f) && !isNaN_(g)) {
                this.i.arc(e.x, e.y, a.f.height, f, g, d);
                if (this.b) {
                    this.x(e, f, g, a.f.height, d);
                }
            }
            this.z = a.e;
            if (a.f.width != a.f.height) {
                this.i.restore();
            }
        }
        r(a) {
            let b = a.c.x;
            let c = a.c.y;
            this.i.lineTo(b, c);
            this.z = a.c;
            if (this.b) {
                let d = this.e;
                let e = this.f;
                let f = this.g;
                let g = this.h;
                this.g = b < f ? b : f;
                this.h = c < g ? c : g;
                this.e = b > d ? b : d;
                this.f = c > e ? c : e;
                this.c = true;
            }
        }
        u(a) {
            let b = a._points;
            let c = b.count;
            if (this.b) {
                let d = this.g;
                let e = this.h;
                let f = this.e;
                let g = this.f;
                let h;
                let i;
                for (let j = 0; j < c; j++) {
                    h = b._inner[j].x;
                    i = b._inner[j].y;
                    this.i.lineTo(h, i);
                    d = h < d ? h : d;
                    e = i < e ? i : e;
                    f = h > f ? h : f;
                    g = i > g ? i : g;
                }
                this.g = d;
                this.h = e;
                this.e = f;
                this.f = g;
                this.c = true;
            }
            else {
                for (let k = 0; k < c; k++) {
                    this.i.lineTo(b._inner[k].x, b._inner[k].y);
                }
            }
            this.z = a._points._inner[c - 1];
        }
        v(a) {
            this.i.rect(a.e.left, a.e.top, a.e.width, a.e.height);
            if (this.b) {
                let b = a.e;
                let c = this.g;
                let d = this.h;
                let e = this.e;
                let f = this.f;
                let g = b.left;
                let h = b.right;
                let i = b.top;
                let j = b.bottom;
                this.g = g < c ? g : c;
                this.h = i < d ? i : d;
                this.e = h > e ? h : e;
                this.f = j > f ? j : f;
                this.c = true;
            }
        }
        q(a) {
            this.i.moveTo(a.d.x, a.d.y);
            this.i.lineTo(a.c.x, a.c.y);
            if (this.b) {
                let b = a.d;
                let c = a.c;
                let d = this.g;
                let e = this.h;
                let f = this.e;
                let g = this.f;
                let h = b.x < c.x ? b.x : c.x;
                let i = b.x > c.x ? b.x : c.x;
                let j = b.y < c.y ? b.y : c.y;
                let k = b.y > c.y ? b.y : c.y;
                this.g = h < d ? h : d;
                this.h = j < e ? j : e;
                this.e = i > f ? i : f;
                this.f = k > g ? k : g;
                this.c = true;
            }
        }
        h$u(a) {
            if (a._visibility == 0 && a.ak != null) {
                if (a._opacity < 1 || this.d < 1) {
                    this.i.globalAlpha = (a._opacity * this.d);
                }
                let def_ = this.l;
                let con_ = this.i;
                con_.textAlign = def_;
                this.i.fillStyle = a.am != null ? a.am._fill : null;
                this.i.textBaseline = "top";
                this.i.fillText(a.ak, a.n, a.o);
                if (a._opacity < 1 || this.d < 1) {
                    this.i.globalAlpha = 1;
                }
            }
        }
        h$v(a, b, c) {
            if (a._visibility == 0) {
                if (a._opacity < 1 || this.d < 1) {
                    this.i.globalAlpha = (a._opacity * this.d);
                }
                let d = b.left + b.width / 2;
                let e = a.ak.split(' ');
                this.i.fillStyle = a.am._fill;
                this.i.textBaseline = "top";
                this.i.textAlign = "center";
                let f = b.width;
                let g = b.height;
                let h = b.top;
                let i = "";
                for (let j = 0; j < e.length; j++) {
                    let k = i + e[j];
                    let l = this.i.measureText(k);
                    if (l.width > f) {
                        if (i != null) {
                            this.i.fillText(i, d, h);
                        }
                        i = "";
                        h = h + c;
                    }
                    i = i + e[j] + " ";
                }
                if (i != null) {
                    this.i.fillText(i, d, h);
                }
                if (a._opacity < 1 || this.d < 1) {
                    this.i.globalAlpha = 1;
                }
            }
        }
        h$r(a) {
            if (a.ak == null || a.ak.count < 1) {
                return;
            }
            this.i.beginPath();
            this.i.globalAlpha = (a._opacity * this.d);
            let b = a.ak;
            let c = b._inner[0];
            let d = a._fill;
            let e = a._stroke;
            this.b = (d != null && d.isGradient) || (e != null && e.isGradient);
            if (this.b) {
                let f = 1.7976931348623157E+308;
                let g = -1.7976931348623157E+308;
                let h = 1.7976931348623157E+308;
                let i = -1.7976931348623157E+308;
                let j = c.x;
                let k = c.y;
                f = j < f ? j : f;
                h = k < h ? k : h;
                g = j > g ? j : g;
                i = k > i ? k : i;
                this.i.moveTo(j, k);
                for (let l = 1; l < b.count; l++) {
                    j = b._inner[l].x;
                    k = b._inner[l].y;
                    this.i.lineTo(j, k);
                    f = j < f ? j : f;
                    h = k < h ? k : h;
                    g = j > g ? j : g;
                    i = k > i ? k : i;
                }
                this.i.closePath();
                this.g = f;
                this.h = h;
                this.e = g;
                this.f = i;
            }
            else {
                this.i.moveTo(c.x, c.y);
                for (let m = 1; m < b.count; m++) {
                    this.i.lineTo(b._inner[m].x, b._inner[m].y);
                }
                this.i.closePath();
            }
            if (d != null) {
                if (d.isGradient) {
                    this.i.fillStyle = this.k(d, this.g, this.h, this.e, this.f, a.ac, false);
                }
                else {
                    this.i.fillStyle = d._fill;
                }
                this.i.fill();
            }
            if (e != null) {
                if (e.isGradient) {
                    this.i.strokeStyle = this.k(e, this.g, this.h, this.e, this.f, a.ac, true);
                }
                else {
                    this.i.strokeStyle = e._fill;
                }
                this.i.lineWidth = a.ac;
                this.i.stroke();
            }
            this.i.globalAlpha = 1;
        }
        h$s(a) {
            if (a.ak == null || a.ak.count < 1) {
                return;
            }
            this.i.beginPath();
            this.i.globalAlpha = (a._opacity * this.d);
            let b = a.ak;
            let c = b._inner[0];
            let d = a._fill;
            let e = a._stroke;
            this.b = (d != null && d.isGradient) || (e != null && e.isGradient);
            if (this.b) {
                let f = 1.7976931348623157E+308;
                let g = -1.7976931348623157E+308;
                let h = 1.7976931348623157E+308;
                let i = -1.7976931348623157E+308;
                let j = c.x;
                let k = c.y;
                f = j < f ? j : f;
                h = k < h ? k : h;
                g = j > g ? j : g;
                i = k > i ? k : i;
                this.i.moveTo(j, k);
                for (let l = 1; l < b.count; l++) {
                    j = b._inner[l].x;
                    k = b._inner[l].y;
                    this.i.lineTo(j, k);
                    f = j < f ? j : f;
                    h = k < h ? k : h;
                    g = j > g ? j : g;
                    i = k > i ? k : i;
                }
                this.g = f;
                this.h = h;
                this.e = g;
                this.f = i;
            }
            else {
                this.i.moveTo(c.x, c.y);
                for (let m = 1; m < b.count; m++) {
                    this.i.lineTo(b._inner[m].x, b._inner[m].y);
                }
            }
            if (d != null) {
                if (d.isGradient) {
                    this.i.fillStyle = this.k(d, this.g, this.h, this.e, this.f, a.ac, false);
                }
                else {
                    this.i.fillStyle = d._fill;
                }
                this.i.fill();
            }
            if (e != null) {
                if (e.isGradient) {
                    this.i.strokeStyle = this.k(e, this.g, this.h, this.e, this.f, a.ac, true);
                }
                else {
                    this.i.strokeStyle = e._fill;
                }
                this.i.lineWidth = a.ac;
                this.i.stroke();
            }
            this.i.globalAlpha = 1;
        }
        h$n(a, b) {
            if (b._visibility == 1) {
                return;
            }
            if ((b._opacity != 1 || this.d != 1) && !a.isHitTestRender) {
                this.i.globalAlpha = (b._opacity * this.d);
            }
            let c = b.ah;
            if (c != null && c.render != null) {
                a.context = this.i;
                a.xPosition = b.n;
                a.yPosition = b.o;
                a.data = b.content;
                c.render(a);
            }
            this.i.globalAlpha = 1;
        }
        h$h(a) {
            if (typeCast(TransformGroup.$, a) !== null) {
                let b = a;
                for (let c = b.j.count - 1; c >= 0; c--) {
                    let d = b.j._inner[c];
                    this.h$h(d);
                }
            }
            else if (typeCast(TranslateTransform.$, a) !== null) {
                let e = a;
                this.i.translate(e.j, e.k);
            }
            else if (typeCast(RotateTransform.$, a) !== null) {
                let f = a;
                let g = f.j * Math.PI / 180;
                let h = Math.cos(g);
                let i = Math.sin(g);
                let j = f.k * (1 - h) + f.l * i;
                let k = f.l * (1 - h) - f.k * i;
                this.i.transform(h, i, i * -1, h, j, k);
            }
            else if (typeCast(ScaleTransform.$, a) !== null) {
                let l = a;
                this.i.transform(l.l, 0, 0, l.m, l.j - l.l * l.j, l.k - l.m * l.k);
            }
        }
        h$p(a) {
            if (a._visibility != 0) {
                return;
            }
            this.i.beginPath();
            this.i.globalAlpha = (a._opacity * this.d);
            this.i.moveTo(a.ak, a.am);
            this.i.lineTo(a.al, a.an);
            if (this.b) {
                this.g = 1.7976931348623157E+308;
                this.e = -1.7976931348623157E+308;
                this.h = 1.7976931348623157E+308;
                this.f = -1.7976931348623157E+308;
                let b = this.g;
                let c = this.h;
                let d = this.e;
                let e = this.f;
                let f = a.ak < a.al ? a.ak : a.al;
                let g = a.ak > a.al ? a.ak : a.al;
                let h = a.am < a.an ? a.am : a.an;
                let i = a.am > a.an ? a.am : a.an;
                this.g = f < b ? f : b;
                this.h = h < c ? h : c;
                this.e = g > d ? g : d;
                this.f = i > e ? i : e;
            }
            let j = a._fill;
            let k = a._stroke;
            if (j != null) {
                if (j.isGradient) {
                    this.i.fillStyle = this.k(j, this.g, this.h, this.e, this.e, a.ac, false);
                }
                else {
                    this.i.fillStyle = j._fill;
                }
                this.i.fill();
            }
            if (k != null) {
                if (k.isGradient) {
                    this.i.strokeStyle = this.k(k, this.g, this.h, this.e, this.e, a.ac, true);
                }
                else {
                    this.i.strokeStyle = a._stroke._fill;
                }
                this.i.lineWidth = a.ac;
                this.i.stroke();
            }
            this.i.globalAlpha = 1;
        }
        h$ac(a) {
            this.i.beginPath();
            this.i.rect(a.left, a.top, a.width, a.height);
            this.i.clip();
        }
        h$x() {
            this.i.save();
        }
        h$w() {
            this.i.restore();
        }
        h$y(a, b) {
            this.i.scale(a, b);
        }
        h$ad(a, b) {
            this.i.translate(a, b);
        }
        h$i(a, b, c, d) {
            this.i.clearRect(a, b, c, d);
        }
        h$k(a, b, c, d, e, f) {
            if (b != 1) {
                this.i.globalAlpha = (b * this.d);
            }
            this.i.drawImage(a, c, d, e, f);
            if (b != 1) {
                this.i.globalAlpha = 1;
            }
        }
        h$l(a, b, c, d, e, f, g, h, i, j) {
            if (b != 1) {
                this.i.globalAlpha = (b * this.d);
            }
            this.i.drawImage(a, c, d, e, f, g, h, i, j);
            if (b != 1) {
                this.i.globalAlpha = 1;
            }
        }
        h$a(a, b) {
            let c = this.i.getImageData(a, b, 1, 1);
            let d = new Array(4);
            d[0] = c.data[0];
            d[1] = c.data[1];
            d[2] = c.data[2];
            d[3] = c.data[3];
            return d;
        }
        h$f() {
            return this.i.font;
        }
        h$b() {
            return this.a;
        }
        h$z(a) {
            if (this.i.font != a) {
                this.i.font = a;
            }
        }
        h$aa(a) {
            this.a = a;
            let b = a != null ? a.fontString : null;
            if (this.i.font != b) {
                this.i.font = b;
            }
        }
        h$c(a) {
            let b = this.i.measureText(a);
            return b.width;
        }
        h$ab(a) {
            this.d = a;
        }
        h$g(shape_, style_) {
            if (style_ == null) {
                return;
            }
            let fillColor_ = null;
            let strokeColor_ = null;
            let strokeThickness_ = NaN;
            let opacity_ = NaN;
            let s_ = style_;
            if (s_.fill) {
                fillColor_ = s_.fill;
            }
            ;
            if (s_.stroke) {
                strokeColor_ = s_.stroke;
            }
            ;
            if (s_.strokeThickness) {
                strokeThickness_ = s_.strokeThickness;
            }
            ;
            if (s_.opacity) {
                opacity_ = s_.opacity;
            }
            ;
            if (fillColor_ != null) {
                shape_._fill = ((() => {
                    let $ret = new Brush();
                    $ret.fill = fillColor_;
                    return $ret;
                })());
            }
            if (strokeColor_ != null) {
                shape_._stroke = ((() => {
                    let $ret = new Brush();
                    $ret.fill = strokeColor_;
                    return $ret;
                })());
            }
            if (strokeThickness_ != undefined && !isNaN_(strokeThickness_)) {
                shape_.ac = strokeThickness_;
            }
            if (!isNaN_(opacity_)) {
                shape_._opacity = opacity_;
            }
        }
        h$m(a, b, c, d) {
            this.i.shadowColor = a;
            this.i.shadowBlur = b;
            this.i.shadowOffsetX = c;
            this.i.shadowOffsetY = d;
        }
        h$j() {
            this.i.shadowColor = "rgba(0,0,0,0)";
            this.i.shadowBlur = 0;
            this.i.shadowOffsetX = 0;
            this.i.shadowOffsetY = 0;
        }
    }
    CanvasViewRenderer.$t = /*@__PURE__*/ markType(CanvasViewRenderer, 'CanvasViewRenderer', Base.$, [IRenderer_$type]);
    return CanvasViewRenderer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DependencyObjectNotifier = /*@__PURE__*/ (() => {
    class DependencyObjectNotifier extends DependencyObject {
        constructor() {
            super(...arguments);
            this.propertyChanged = null;
        }
        j(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
    }
    DependencyObjectNotifier.$t = /*@__PURE__*/ markType(DependencyObjectNotifier, 'DependencyObjectNotifier', DependencyObject.$, [INotifyPropertyChanged_$type]);
    return DependencyObjectNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOverviewPlusDetailControl_$type = /*@__PURE__*/ new Type(null, 'IOverviewPlusDetailControl');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOverviewPlusDetailPane_$type = /*@__PURE__*/ new Type(null, 'IOverviewPlusDetailPane');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyChangedEventArgs$1 = /*@__PURE__*/ (() => {
    class PropertyChangedEventArgs$1 extends PropertyChangedEventArgs {
        constructor($t, a, b, c) {
            super(a);
            this.$t = null;
            this._oldValue = null;
            this._newValue = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.oldValue = b;
            this.newValue = c;
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    PropertyChangedEventArgs$1.$t = /*@__PURE__*/ markType(PropertyChangedEventArgs$1, 'PropertyChangedEventArgs$1', PropertyChangedEventArgs.$);
    return PropertyChangedEventArgs$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EventProxy = /*@__PURE__*/ (() => {
    class EventProxy extends Base {
        constructor() {
            super(...arguments);
            this.onMouseWheel = null;
            this.onMouseWheelHorizontal = null;
            this.onPinchStarted = null;
            this.onPinchDelta = null;
            this.onGestureCompleted = null;
            this.onZoomStarted = null;
            this.onZoomDelta = null;
            this.onZoomCompleted = null;
            this.onFlingStarted = null;
            this.onContactStarted = null;
            this.onDragStarted = null;
            this.onContactMoved = null;
            this.onDragDelta = null;
            this.onContactCompleted = null;
            this.onDragCompleted = null;
            this.onMouseLeave = null;
            this.onMouseOver = null;
            this.onMouseEnter = null;
            this.onMouseDown = null;
            this.onMouseUp = null;
            this.onDoubleTap = null;
            this.onHold = null;
            this.onKeyDown = null;
            this.onKeyUp = null;
            this.bg = null;
            this.bd = 0;
            this.ai = false;
            this.aj = false;
            this.al = null;
            this.an = null;
            this.ao = null;
            this.ap = null;
            this.z = false;
            this.aa = false;
            this.am = null;
        }
        ab(a, b, c) {
            if (this.an != null) {
                return this.an(a, b, c);
            }
            return this.al(a);
        }
        get_ak() {
            return false;
        }
        get ak() {
            return this.get_ak();
        }
        ag(a, b) {
            if (this.onMouseWheel != null && !this.ac) {
                return this.onMouseWheel(a, b);
            }
            return false;
        }
        ah(a, b) {
            if (this.onMouseWheelHorizontal != null && !this.ac) {
                return this.onMouseWheelHorizontal(a, b);
            }
            return false;
        }
        a8(a, b) {
            if (this.onPinchStarted != null && !this.ac) {
                this.onPinchStarted(a, b);
            }
        }
        bb(a, b, c, d) {
            if (this.onZoomStarted != null && !this.ac) {
                this.onZoomStarted(a, b, c, d);
            }
        }
        ad(a, b, c) {
            if (this.onFlingStarted != null && !this.ac) {
                return this.onFlingStarted(a, b, c);
            }
            return true;
        }
        a7(a, b) {
            if (this.onPinchDelta != null && !this.ac) {
                this.onPinchDelta(a, b);
            }
        }
        ba(a, b, c, d) {
            if (this.onZoomDelta != null && !this.ac) {
                this.onZoomDelta(a, b, c, d);
            }
        }
        a9(a, b, c, d) {
            if (this.onZoomCompleted != null && !this.ac) {
                this.onZoomCompleted(a, b, c, d);
            }
        }
        a0(a, b) {
            if (this.onGestureCompleted != null && !this.ac) {
                this.onGestureCompleted(a, b);
            }
        }
        av(a, b) {
            if (this.onContactStarted != null && !this.ac) {
                this.onContactStarted(a, b);
            }
        }
        az(a) {
            if (this.onDragStarted != null && !this.ac) {
                this.onDragStarted(a);
            }
        }
        au(a, b) {
            if (this.onContactMoved != null && !this.ac) {
                this.onContactMoved(a, b);
            }
        }
        ay(a) {
            if (this.onDragDelta != null && !this.ac) {
                this.onDragDelta(a);
            }
        }
        at(a, b, c) {
            if (this.onContactCompleted != null && !this.ac) {
                this.aj = c;
                this.onContactCompleted(a, b);
                this.aj = false;
            }
        }
        ax(a) {
            if (this.onDragCompleted != null && !this.ac) {
                this.onDragCompleted(a);
            }
        }
        a4(a) {
            if (this.onMouseLeave != null && !this.ac) {
                this.onMouseLeave(a);
            }
        }
        a5(a, b, c) {
            if (this.onMouseOver != null && !this.ac) {
                this.onMouseOver(a, b, c);
            }
        }
        a3(a) {
            if (this.onMouseEnter != null && !this.ac) {
                this.onMouseEnter(a);
            }
        }
        a2(a) {
            if (this.onMouseDown != null && !this.ac) {
                this.onMouseDown(a);
            }
        }
        a6(a) {
            if (this.onMouseUp != null && !this.ac) {
                this.onMouseUp(a);
            }
        }
        ae(a) {
            if (this.onKeyDown != null && !this.ac) {
                return this.onKeyDown(a);
            }
            return false;
        }
        af(a) {
            if (this.onKeyUp != null && !this.ac) {
                return this.onKeyUp(a);
            }
            return false;
        }
        aw(a) {
            if (this.onDoubleTap != null && !this.ac) {
                this.onDoubleTap(a);
            }
        }
        a1(a) {
            if (this.onHold != null && !this.ac) {
                this.onHold(a);
            }
        }
        get ac() {
            return this.z;
        }
        set ac(a) {
            this.z = a;
            this.as();
        }
        as() {
        }
    }
    EventProxy.$t = /*@__PURE__*/ markType(EventProxy, 'EventProxy');
    return EventProxy;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DVContainer = /*@__PURE__*/ (() => {
    class DVContainer extends Base {
        constructor() {
            super();
            this.d = new Dictionary$2(String_$type, Delegate_$type, 0);
        }
        static get instance() {
            if (DVContainer.a == null) {
                DVContainer.a = new DVContainer();
            }
            return DVContainer.a;
        }
        registerFactory(a, b) {
            this.d.addItem(a.typeName, b);
        }
        createInstance(a, b) {
            if (this.d.containsKey(a.typeName)) {
                return this.d.item(a.typeName)();
            }
            throw new BaseError(1, b());
        }
        registerIfLoaded(typeName_) {
            if (TypeRegistrar.isRegistered(typeName_)) {
                TypeRegistrar.callRegister(typeName_);
            }
        }
        checkLoaded(typeName_) {
            if (TypeRegistrar.isRegistered(typeName_)) {
                return true;
            }
            return false;
        }
    }
    DVContainer.$t = /*@__PURE__*/ markType(DVContainer, 'DVContainer');
    DVContainer.a = null;
    return DVContainer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available interaction states of the chart or geographic map control.
 */
var InteractionState = /*@__PURE__*/ (function (InteractionState) {
    /**
     * User gesture will not change the state of the chart.
     */
    InteractionState[InteractionState["None"] = 0] = "None";
    /**
     * User gesture will start a drag rectangle to zoom the chart.
     */
    InteractionState[InteractionState["DragZoom"] = 1] = "DragZoom";
    /**
     * User gesture will start a pan action to move the chart's window.
     */
    InteractionState[InteractionState["DragPan"] = 2] = "DragPan";
    /**
     * User gesture will start a pan action in a touch environment and a drag rectangle in a mouse environment.
     */
    InteractionState[InteractionState["Auto"] = 3] = "Auto";
    return InteractionState;
})({});
/**
 * @hidden
 */
let InteractionState_$type = /*@__PURE__*/ markEnum('InteractionState', 'None,0|DragZoom,1|DragPan,2|Auto,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifier = /*@__PURE__*/ (() => {
    class FormatSpecifier extends Base {
        a() {
            return null;
        }
    }
    FormatSpecifier.$t = /*@__PURE__*/ markType(FormatSpecifier, 'FormatSpecifier');
    return FormatSpecifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifier = /*@__PURE__*/ (() => {
    class NumberFormatSpecifier extends FormatSpecifier {
        constructor() {
            super();
            this.l = null;
            this.h = null;
            this.i = null;
            this.j = null;
            this.k = null;
            this.m = null;
            this.n = null;
            this.o = null;
            this.p = null;
            this.q = null;
            this.r = null;
            this.s = null;
            this.b = false;
            this.f = 0;
            this.e = 0;
            this.c = 0;
            this.g = 0;
            this.d = 0;
            this.b = true;
            this.f = -1;
            this.e = -1;
            this.g = -1;
            this.c = -1;
            this.d = -1;
        }
        a() {
            let a = {};
            if (this.h != null) {
                this.t(a, "compactDisplay", this.h);
            }
            if (this.i != null) {
                this.t(a, "currency", this.i);
            }
            if (this.j != null) {
                this.t(a, "currencyDisplay", this.j);
            }
            if (this.k != null) {
                this.t(a, "currencySign", this.k);
            }
            if (this.m != null) {
                this.t(a, "localeMatcher", this.m);
            }
            if (this.n != null) {
                this.t(a, "notation", this.n);
            }
            if (this.o != null) {
                this.t(a, "numberingSystem", this.o);
            }
            if (this.p != null) {
                this.t(a, "signDisplay", this.p);
            }
            if (this.q != null) {
                this.t(a, "style", this.q);
            }
            if (this.r != null) {
                this.t(a, "unit", this.r);
            }
            if (this.s != null) {
                this.t(a, "unitDisplay", this.s);
            }
            if (this.b != true) {
                this.t(a, "useGrouping", this.b);
            }
            if (this.f != -1) {
                this.t(a, "minimumIntegerDigits", this.f);
            }
            if (this.e != -1) {
                this.t(a, "minimumFractionDigits", this.e);
            }
            if (this.c != -1) {
                this.t(a, "maximumFractionDigits", this.c);
            }
            if (this.g != -1) {
                this.t(a, "minimumSignificantDigits", this.g);
            }
            if (this.d != -1) {
                this.t(a, "maximumSignificantDigits", this.d);
            }
            let locale_ = this.l;
            let options_ = a;
            return new Intl.NumberFormat(locale_, options_);
        }
        t(options_, propertyName_, value_) {
            options_[propertyName_] = value_;
        }
    }
    NumberFormatSpecifier.$t = /*@__PURE__*/ markType(NumberFormatSpecifier, 'NumberFormatSpecifier', FormatSpecifier.$);
    return NumberFormatSpecifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifier = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifier extends FormatSpecifier {
        constructor() {
            super();
            this.l = null;
            this.d = null;
            this.r = null;
            this.b = 0;
            this.c = null;
            this.f = null;
            this.p = null;
            this.m = null;
            this.s = null;
            this.j = null;
            this.k = null;
            this.h = null;
            this.u = null;
            this.g = null;
            this.v = null;
            this.o = null;
            this.e = null;
            this.i = null;
            this.n = null;
            this.q = null;
            this.t = null;
            this.b = -1;
        }
        a() {
            let a = {};
            if (this.d != null) {
                this.w(a, "dateStyle", this.d);
            }
            if (this.r != null) {
                this.w(a, "timeStyle", this.r);
            }
            if (this.b != -1) {
                this.w(a, "fractionalSecondDigits", this.b);
            }
            if (this.c != null) {
                this.w(a, "calendar", this.c);
            }
            if (this.f != null) {
                this.w(a, "dayPeriod", this.f);
            }
            if (this.p != null) {
                this.w(a, "numberingSystem", this.p);
            }
            if (this.m != null) {
                this.w(a, "localeMatcher", this.m);
            }
            if (this.s != null) {
                this.w(a, "timeZone", this.s);
            }
            if (this.j != null) {
                this.w(a, "hour12", this.j.toLowerCase() == "true" ? true : false);
            }
            if (this.k != null) {
                this.w(a, "hourCycle", this.k);
            }
            if (this.h != null) {
                this.w(a, "formatMatcher", this.h);
            }
            if (this.u != null) {
                this.w(a, "weekday", this.u);
            }
            if (this.g != null) {
                this.w(a, "era", this.g);
            }
            if (this.v != null) {
                this.w(a, "year", this.v);
            }
            if (this.o != null) {
                this.w(a, "month", this.o);
            }
            if (this.e != null) {
                this.w(a, "day", this.e);
            }
            if (this.i != null) {
                this.w(a, "hour", this.i);
            }
            if (this.n != null) {
                this.w(a, "minute", this.n);
            }
            if (this.q != null) {
                this.w(a, "second", this.q);
            }
            if (this.t != null) {
                this.w(a, "timeZoneName", this.t);
            }
            let locale_ = this.l;
            let options_ = a;
            return new Intl.DateTimeFormat(locale_, options_);
        }
        w(options_, propertyName_, value_) {
            options_[propertyName_] = value_;
        }
    }
    DateTimeFormatSpecifier.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifier, 'DateTimeFormatSpecifier', FormatSpecifier.$);
    return DateTimeFormatSpecifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BindingFormatter = /*@__PURE__*/ (() => {
    class BindingFormatter extends Base {
        constructor() {
            super();
            this.h = null;
            this.a = null;
            this.f = null;
            this.g = null;
            this.b = null;
            this.c = null;
        }
        get j() {
            return this.h;
        }
        set j(a) {
            this.h = a;
            this.l();
        }
        l() {
            let a = this.j;
            if (a == null) {
                return;
            }
            let b = 0;
            let c = new List$1(String_$type, 0);
            let d = new List$1(FastReflectionHelper.$, 0);
            let e = new List$1(String_$type, 0);
            for (let f = a.indexOf('{', b); f >= b; f = a.indexOf('{', b)) {
                e.add(a.substr(b, f - b));
                let g = a.indexOf('}', f);
                if (g <= f) {
                    return;
                }
                let h = a.substr(f + 1, g - f - 1).trim();
                let i = h.indexOf(':');
                if (i == -1) {
                    c.add(h);
                    if (h == "0" || h == ".") {
                        d.add(null);
                    }
                    else {
                        d.add(new FastReflectionHelper(false, h));
                    }
                }
                else {
                    let j = h.substr(0, i).trim();
                    d.add(new FastReflectionHelper(false, j));
                    c.add(j);
                    if (j == "0" || j == ".") {
                        d.add(null);
                    }
                    else {
                        d.add(new FastReflectionHelper(false, h));
                    }
                }
                b = g + 1;
            }
            e.add(a.substr(b));
            this.f = e;
            this.g = d;
        }
        get d() {
            return this.a;
        }
        set d(a) {
            this.a = a;
            this.k();
        }
        k() {
            if (this.a == null) {
                this.b = null;
                this.c = null;
                return;
            }
            this.b = new Array(this.a.length);
            this.c = new Array(this.a.length);
            for (let a = 0; a < this.a.length; a++) {
                let spec_ = this.a[a];
                if ((spec_._implementation)) {
                    spec_ = (spec_._implementation);
                }
                let b = this.e(spec_);
                this.c[a] = b;
                if (b != 0) {
                    if (typeCast(FormatSpecifier.$, spec_) !== null) {
                        this.b[a] = spec_.a();
                    }
                    else {
                        this.b[a] = spec_;
                    }
                }
            }
        }
        e(a) {
            if (a == null) {
                return 0;
            }
            let v_ = a;
            if ((v_ instanceof Intl.NumberFormat) || typeCast(NumberFormatSpecifier.$, v_) !== null) {
                return 1;
            }
            if ((v_ instanceof Intl.DateTimeFormat) || typeCast(DateTimeFormatSpecifier.$, v_) !== null) {
                return 2;
            }
            return 0;
        }
        i(a) {
            let b = "";
            if (this.f == null) {
                return b;
            }
            for (let c = 0; c < this.f.count; c++) {
                b += this.f._inner[c];
                if (c < this.g.count) {
                    let obj_ = a;
                    let d = this.g._inner[c];
                    if (d != null) {
                        obj_ = d.getPropertyValue(obj_);
                    }
                    if (this.b != null && c < this.b.length && this.b[c] != null) {
                        let platformSpecifier_ = this.b[c];
                        let e = this.c[c];
                        let intlSpecifier_ = platformSpecifier_;
                        b += intlSpecifier_.format(obj_);
                    }
                    else {
                        b += obj_ != null ? obj_.toString() : "";
                    }
                }
            }
            return b;
        }
    }
    BindingFormatter.$t = /*@__PURE__*/ markType(BindingFormatter, 'BindingFormatter');
    return BindingFormatter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlatformSpecifierType_$type = /*@__PURE__*/ markEnum('PlatformSpecifierType', 'None,0|Number,1|Date,2|Generic,3');

class IgrFormatSpecifier {
    createImplementation() {
        return new FormatSpecifier();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrFormatSpecifierModule {
    static register() {
        TypeRegistrar.registerCons("IgrFormatSpecifier", IgrFormatSpecifier);
        TypeRegistrar.register("FormatSpecifier", FormatSpecifier.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrFormatSpecifierCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrFormatSpecifier.$type) {
            IgrFormatSpecifier.$type = markType(IgrFormatSpecifier, "IgrFormatSpecifier");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrFormatSpecifier.$type) {
            IgrFormatSpecifier.$type = markType(IgrFormatSpecifier, "IgrFormatSpecifier");
        }
        let coll = new SyncableObservableCollection$2(IgrFormatSpecifier.$type, FormatSpecifier.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrFormatSpecifier();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierCollection = /*@__PURE__*/ (() => {
    class FormatSpecifierCollection extends ObservableCollection$1 {
        constructor() {
            super(FormatSpecifier.$, 0);
        }
    }
    FormatSpecifierCollection.$t = /*@__PURE__*/ markType(FormatSpecifierCollection, 'FormatSpecifierCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(FormatSpecifier.$));
    return FormatSpecifierCollection;
})();

class IgrNumberFormatSpecifier extends IgrFormatSpecifier {
    createImplementation() {
        return new NumberFormatSpecifier();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get locale() {
        return this.i.l;
    }
    set locale(v) {
        this.i.l = v;
    }
    get compactDisplay() {
        return this.i.h;
    }
    set compactDisplay(v) {
        this.i.h = v;
    }
    get currency() {
        return this.i.i;
    }
    set currency(v) {
        this.i.i = v;
    }
    get currencyDisplay() {
        return this.i.j;
    }
    set currencyDisplay(v) {
        this.i.j = v;
    }
    get currencySign() {
        return this.i.k;
    }
    set currencySign(v) {
        this.i.k = v;
    }
    get localeMatcher() {
        return this.i.m;
    }
    set localeMatcher(v) {
        this.i.m = v;
    }
    get notation() {
        return this.i.n;
    }
    set notation(v) {
        this.i.n = v;
    }
    get numberingSystem() {
        return this.i.o;
    }
    set numberingSystem(v) {
        this.i.o = v;
    }
    get signDisplay() {
        return this.i.p;
    }
    set signDisplay(v) {
        this.i.p = v;
    }
    get style() {
        return this.i.q;
    }
    set style(v) {
        this.i.q = v;
    }
    get unit() {
        return this.i.r;
    }
    set unit(v) {
        this.i.r = v;
    }
    get unitDisplay() {
        return this.i.s;
    }
    set unitDisplay(v) {
        this.i.s = v;
    }
    get useGrouping() {
        return this.i.b;
    }
    set useGrouping(v) {
        this.i.b = ensureBool(v);
    }
    get minimumIntegerDigits() {
        return this.i.f;
    }
    set minimumIntegerDigits(v) {
        this.i.f = +v;
    }
    get minimumFractionDigits() {
        return this.i.e;
    }
    set minimumFractionDigits(v) {
        this.i.e = +v;
    }
    get maximumFractionDigits() {
        return this.i.c;
    }
    set maximumFractionDigits(v) {
        this.i.c = +v;
    }
    get minimumSignificantDigits() {
        return this.i.g;
    }
    set minimumSignificantDigits(v) {
        this.i.g = +v;
    }
    get maximumSignificantDigits() {
        return this.i.d;
    }
    set maximumSignificantDigits(v) {
        this.i.d = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrNumberFormatSpecifierModule {
    static register() {
        TypeRegistrar.registerCons("IgrNumberFormatSpecifier", IgrNumberFormatSpecifier);
        TypeRegistrar.register("NumberFormatSpecifier", NumberFormatSpecifier.$type);
    }
}

class IgrDateTimeFormatSpecifier extends IgrFormatSpecifier {
    createImplementation() {
        return new DateTimeFormatSpecifier();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get locale() {
        return this.i.l;
    }
    set locale(v) {
        this.i.l = v;
    }
    get dateStyle() {
        return this.i.d;
    }
    set dateStyle(v) {
        this.i.d = v;
    }
    get timeStyle() {
        return this.i.r;
    }
    set timeStyle(v) {
        this.i.r = v;
    }
    get fractionalSecondDigits() {
        return this.i.b;
    }
    set fractionalSecondDigits(v) {
        this.i.b = +v;
    }
    get calendar() {
        return this.i.c;
    }
    set calendar(v) {
        this.i.c = v;
    }
    get dayPeriod() {
        return this.i.f;
    }
    set dayPeriod(v) {
        this.i.f = v;
    }
    get numberingSystem() {
        return this.i.p;
    }
    set numberingSystem(v) {
        this.i.p = v;
    }
    get localeMatcher() {
        return this.i.m;
    }
    set localeMatcher(v) {
        this.i.m = v;
    }
    get timeZone() {
        return this.i.s;
    }
    set timeZone(v) {
        this.i.s = v;
    }
    get hour12() {
        return this.i.j;
    }
    set hour12(v) {
        this.i.j = v;
    }
    get hourCycle() {
        return this.i.k;
    }
    set hourCycle(v) {
        this.i.k = v;
    }
    get formatMatcher() {
        return this.i.h;
    }
    set formatMatcher(v) {
        this.i.h = v;
    }
    get weekDay() {
        return this.i.u;
    }
    set weekDay(v) {
        this.i.u = v;
    }
    get era() {
        return this.i.g;
    }
    set era(v) {
        this.i.g = v;
    }
    get year() {
        return this.i.v;
    }
    set year(v) {
        this.i.v = v;
    }
    get month() {
        return this.i.o;
    }
    set month(v) {
        this.i.o = v;
    }
    get day() {
        return this.i.e;
    }
    set day(v) {
        this.i.e = v;
    }
    get hour() {
        return this.i.i;
    }
    set hour(v) {
        this.i.i = v;
    }
    get minute() {
        return this.i.n;
    }
    set minute(v) {
        this.i.n = v;
    }
    get second() {
        return this.i.q;
    }
    set second(v) {
        this.i.q = v;
    }
    get timeZoneName() {
        return this.i.t;
    }
    set timeZoneName(v) {
        this.i.t = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDateTimeFormatSpecifierModule {
    static register() {
        TypeRegistrar.registerCons("IgrDateTimeFormatSpecifier", IgrDateTimeFormatSpecifier);
        TypeRegistrar.register("DateTimeFormatSpecifier", DateTimeFormatSpecifier.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArrayAccessHelper = /*@__PURE__*/ (() => {
    class ArrayAccessHelper extends Base {
        static b(values_) {
            let a = (Array.isArray(values_) ? values_ : null);
            return a;
        }
        static c(values_) {
            let a = (Array.isArray(values_) ? values_ : null);
            return a;
        }
        static a(a) {
            if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        }
    }
    ArrayAccessHelper.$t = /*@__PURE__*/ markType(ArrayAccessHelper, 'ArrayAccessHelper');
    return ArrayAccessHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IZoomSlider_$type = /*@__PURE__*/ new Type(null, 'IZoomSlider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplateMeasureInfo = /*@__PURE__*/ (() => {
    class DataTemplateMeasureInfo extends Base {
        constructor() {
            super(...arguments);
            this.renderContext = null;
            this.context = null;
            this.width = 0;
            this.height = 0;
            this.isConstant = false;
            this.data = null;
            this.passInfo = null;
            this.renderOffsetX = 0;
            this.renderOffsetY = 0;
        }
    }
    DataTemplateMeasureInfo.$t = /*@__PURE__*/ markType(DataTemplateMeasureInfo, 'DataTemplateMeasureInfo');
    return DataTemplateMeasureInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplateRenderInfo = /*@__PURE__*/ (() => {
    class DataTemplateRenderInfo extends Base {
        constructor() {
            super(...arguments);
            this.renderContext = null;
            this.context = null;
            this.xPosition = 0;
            this.yPosition = 0;
            this.availableWidth = 0;
            this.availableHeight = 0;
            this.data = null;
            this.isHitTestRender = false;
            this.passInfo = null;
            this.renderOffsetX = 0;
            this.renderOffsetY = 0;
        }
    }
    DataTemplateRenderInfo.$t = /*@__PURE__*/ markType(DataTemplateRenderInfo, 'DataTemplateRenderInfo');
    return DataTemplateRenderInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendItemHelper = /*@__PURE__*/ (() => {
    class LegendItemHelper extends Base {
        static get b() {
            if (isNaN_(LegendItemHelper.a)) {
                LegendItemHelper.a = window.devicePixelRatio == undefined ? 1 : window.devicePixelRatio;
            }
            return LegendItemHelper.a;
        }
        static set b(a) {
            LegendItemHelper.a = a;
        }
        static c(a, b, c, d, e, f, g, h, i) {
            LegendItemHelper.d(a, b, c, d, e, f, g, h, i, false);
        }
        static d(a, b, c, d, e, f, g, h, i, j, ...k) {
            let l = a;
            let m = f;
            if (m != null && m.series != null) {
                if (h != null) {
                    let n = 18, o = 16;
                    let p = l.createElement("canvas");
                    if (j) {
                        p.setStyleProperty("vertical-align", "middle");
                    }
                    p.setAttribute("width", (n * LegendItemHelper.b).toString());
                    p.setAttribute("height", (o * LegendItemHelper.b).toString());
                    p.setStyleProperty("width", n.toString() + "px");
                    p.setStyleProperty("height", o.toString() + "px");
                    let q = j ? l.createElement("span") : l.createElement("td");
                    q.addClass("ui-legend-item-badge");
                    q.append(p);
                    let r = l.get2DCanvasContext(p);
                    let s = new DataTemplateMeasureInfo();
                    s.passInfo = i;
                    s.context = r;
                    s.width = n;
                    s.height = o;
                    s.data = m;
                    h.measure(s);
                    let t = new DataTemplateRenderInfo();
                    t.availableWidth = (isNaN_(s.width) ? n : Math.min(s.width, n));
                    t.availableHeight = (isNaN_(s.height) ? o : Math.min(s.height, o));
                    t.passInfo = i;
                    t.context = r;
                    t.data = m;
                    t.xPosition = 0;
                    t.yPosition = 0;
                    if (LegendItemHelper.b != 1) {
                        r.save();
                        r.scale(LegendItemHelper.b, LegendItemHelper.b);
                    }
                    h.render(t);
                    if (LegendItemHelper.b != 1) {
                        r.restore();
                    }
                    l.append(q);
                }
                if (j) {
                    let u = l.createElement("label");
                    u.addClass("ui-legend-item-text");
                    u.setText(g);
                    l.append(u);
                    let v = k[0];
                    let w = k[1];
                    let x = stringEndsWith(getInstanceType(m.series).typeName, "Overlay");
                    if (!isNaN_(v) && !x) {
                        u.setText(u.getText() + ": ");
                        let y = l.createElement("label");
                        y.setStyleProperty("font-weight", "bold");
                        y.setText(numberToString2(v, "0.00") + (isNaN_(w) ? "" : " "));
                        l.append(y);
                    }
                    if (!isNaN_(w) && !x) {
                        let z = l.createElement("label");
                        z.setText("(" + numberToString2(w, "0.00") + "%)");
                        l.append(z);
                    }
                }
                else {
                    let aa = l.createElement("td");
                    let ab = l.createElement("span");
                    ab.setText(g);
                    aa.append(ab);
                    aa.addClass("ui-legend-item-text");
                    l.append(aa);
                }
            }
        }
    }
    LegendItemHelper.$t = /*@__PURE__*/ markType(LegendItemHelper, 'LegendItemHelper');
    LegendItemHelper.a = NaN;
    return LegendItemHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TrendCalculators = /*@__PURE__*/ (() => {
    class TrendCalculators extends Base {
        static *_g(a, b) {
            let c = new Array(b);
            let d = 0;
            for (d = 0; d < b; d++) {
                c[d] = 0;
            }
            let e = NaN;
            let f = NaN;
            let g = NaN;
            let h = NaN;
            d = 0;
            for (let i of fromEnum(a)) {
                if (!isNaN_(i)) {
                    let j = d % b;
                    if (d == 0) {
                        g = 1;
                        h = i;
                        f = i;
                        e = i;
                    }
                    else if (d < b) {
                        g += (d + 1);
                        e += i;
                        f += (d + 1) * i;
                        h = f / g;
                    }
                    else {
                        f = f + (b * i) - e;
                        h = f / g;
                        e = e + i - c[j];
                    }
                    c[j] = i;
                    ++d;
                }
                yield h;
            }
        }
        static g(a, b) {
            return toEnum(() => TrendCalculators._g(a, b));
        }
        static *_b(a, b) {
            let c = 0;
            let d = NaN;
            let e = 2 / (1 + b);
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    if (c < b) {
                        d = isNaN_(d) ? f : (d * c + f) / (c + 1);
                    }
                    else {
                        d = (f - d) * e + d;
                    }
                    ++c;
                }
                yield d;
            }
        }
        static b(a, b) {
            return toEnum(() => TrendCalculators._b(a, b));
        }
        static *_c(a, b) {
            let c = 0;
            let d = NaN;
            let e = 1 / b;
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    if (c < b) {
                        d = isNaN_(d) ? f : (d * c + f) / (c + 1);
                    }
                    else {
                        d = (f - d) * e + d;
                    }
                    ++c;
                }
                yield d;
            }
        }
        static c(a, b) {
            return toEnum(() => TrendCalculators._c(a, b));
        }
        static *_a(a) {
            let b = NaN;
            let c = 0;
            for (let d of fromEnum(a)) {
                if (!isNaN_(d)) {
                    b = isNaN_(b) ? d : (b * c + d) / (c + 1);
                    ++c;
                }
                yield b;
            }
        }
        static a(a) {
            return toEnum(() => TrendCalculators._a(a));
        }
        static *_e(a, b) {
            let c = new Array(b);
            let d = 0;
            for (d = 0; d < b; d++) {
                c[d] = 0;
            }
            d = 0;
            let e = NaN;
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    let g = f / b;
                    let h = d % b;
                    if (d < b) {
                        e = isNaN_(e) ? f : (e * d + f) / (d + 1);
                    }
                    else {
                        e = e + g - c[h];
                    }
                    c[h] = g;
                    ++d;
                }
                yield e;
            }
        }
        static e(a, b) {
            return toEnum(() => TrendCalculators._e(a, b));
        }
        static *_d(a, b) {
            let c = new Array(b);
            let d = 0;
            for (d = 0; d < b; d++) {
                c[d] = 0;
            }
            d = 0;
            let e = NaN;
            for (let f of fromEnum(a)) {
                if (!isNaN_(f)) {
                    let g = f;
                    let h = d % b;
                    if (d < b) {
                        e = isNaN_(e) ? g : e + g;
                    }
                    else {
                        e = e + g - c[h];
                    }
                    c[h] = g;
                    ++d;
                }
                yield e;
            }
        }
        static d(a, b) {
            return toEnum(() => TrendCalculators._d(a, b));
        }
        static *_f(a, b) {
            let c = getEnumerator(TrendCalculators.e(a, b));
            let d = getEnumerator(a);
            let e = new Array(b);
            let f = 0;
            for (f = 0; f < b; f++) {
                e[f] = 0;
            }
            f = 0;
            while (d.moveNext() && c.moveNext()) {
                e[(f++) % b] = d.current;
                let g = 0;
                if (f < b) {
                    let h = 0;
                    for (let i = 0; i < f; i++) {
                        let j = (c.current - e[i]);
                        g += j * j;
                        h++;
                    }
                    yield Math.sqrt(g / h);
                }
                else {
                    for (let k = 0; k < b; ++k) {
                        let l = (c.current - e[k]);
                        g += l * l;
                    }
                    yield Math.sqrt(g / b);
                }
            }
        }
        static f(a, b) {
            return toEnum(() => TrendCalculators._f(a, b));
        }
    }
    TrendCalculators.$t = /*@__PURE__*/ markType(TrendCalculators, 'TrendCalculators');
    return TrendCalculators;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of trend lines supported by series.
 */
var TrendLineType = /*@__PURE__*/ (function (TrendLineType) {
    /**
     * No trend line will be displayed.
     */
    TrendLineType[TrendLineType["None"] = 0] = "None";
    /**
     * Linear fit.
     */
    TrendLineType[TrendLineType["LinearFit"] = 1] = "LinearFit";
    /**
     * Quadratic polynomial fit.
     */
    TrendLineType[TrendLineType["QuadraticFit"] = 2] = "QuadraticFit";
    /**
     * Cubic polynomial fit.
     */
    TrendLineType[TrendLineType["CubicFit"] = 3] = "CubicFit";
    /**
     * Quartic polynomial fit.
     */
    TrendLineType[TrendLineType["QuarticFit"] = 4] = "QuarticFit";
    /**
     * Quintic polynomial fit.
     */
    TrendLineType[TrendLineType["QuinticFit"] = 5] = "QuinticFit";
    /**
     * Logarithmic fit.
     */
    TrendLineType[TrendLineType["LogarithmicFit"] = 6] = "LogarithmicFit";
    /**
     * Exponential fit.
     */
    TrendLineType[TrendLineType["ExponentialFit"] = 7] = "ExponentialFit";
    /**
     * Powerlaw fit.
     */
    TrendLineType[TrendLineType["PowerLawFit"] = 8] = "PowerLawFit";
    /**
     * Simple moving average.
     */
    TrendLineType[TrendLineType["SimpleAverage"] = 9] = "SimpleAverage";
    /**
     * Exponential moving average.
     */
    TrendLineType[TrendLineType["ExponentialAverage"] = 10] = "ExponentialAverage";
    /**
     * Modified moving average.
     */
    TrendLineType[TrendLineType["ModifiedAverage"] = 11] = "ModifiedAverage";
    /**
     * Cumulative moving average.
     */
    TrendLineType[TrendLineType["CumulativeAverage"] = 12] = "CumulativeAverage";
    /**
     * Weighted moving average.
     */
    TrendLineType[TrendLineType["WeightedAverage"] = 13] = "WeightedAverage";
    return TrendLineType;
})({});
/**
 * @hidden
 */
let TrendLineType_$type = /*@__PURE__*/ markEnum('TrendLineType', 'None,0|LinearFit,1|QuadraticFit,2|CubicFit,3|QuarticFit,4|QuinticFit,5|LogarithmicFit,6|ExponentialFit,7|PowerLawFit,8|SimpleAverage,9|ExponentialAverage,10|ModifiedAverage,11|CumulativeAverage,12|WeightedAverage,13');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available methods of plotting data with unknown values in a series.
 * <para>Double.NaN and null are examples of unknown values.</para>
 */
var UnknownValuePlotting = /*@__PURE__*/ (function (UnknownValuePlotting) {
    /**
     * Plot the unknown value as the midpoint between surrounding known values using linear interpolation.
     */
    UnknownValuePlotting[UnknownValuePlotting["LinearInterpolate"] = 0] = "LinearInterpolate";
    /**
     * Do not plot the unknown value on the chart.
     */
    UnknownValuePlotting[UnknownValuePlotting["DontPlot"] = 1] = "DontPlot";
    return UnknownValuePlotting;
})({});
/**
 * @hidden
 */
let UnknownValuePlotting_$type = /*@__PURE__*/ markEnum('UnknownValuePlotting', 'LinearInterpolate,0|DontPlot,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IUnknownValuePlotting_$type = /*@__PURE__*/ new Type(null, 'IUnknownValuePlotting');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyUpdatedEventArgs = /*@__PURE__*/ (() => {
    class PropertyUpdatedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this._propertyName = null;
            this._oldValue = null;
            this._newValue = null;
            this.propertyName = a;
            this.oldValue = b;
            this.newValue = c;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    PropertyUpdatedEventArgs.$t = /*@__PURE__*/ markType(PropertyUpdatedEventArgs, 'PropertyUpdatedEventArgs', EventArgs.$);
    return PropertyUpdatedEventArgs;
})();

/**
 * EventArgs class for property updated events.
*/
class IgrPropertyUpdatedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Name of the property being updated.
    */
    get propertyName() {
        return this.i.propertyName;
    }
    set propertyName(v) {
        this.i.propertyName = v;
    }
    /**
     * Old or previous value of the property being updated.
    */
    get oldValue() {
        return this.i.oldValue;
    }
    set oldValue(v) {
        this.i.oldValue = v;
    }
    /**
     * New or current value of the property being updated.
    */
    get newValue() {
        return this.i.newValue;
    }
    set newValue(v) {
        this.i.newValue = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendSeries_$type = /*@__PURE__*/ new Type(null, 'ILegendSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendSeriesInternal_$type = /*@__PURE__*/ new Type(null, 'ILegendSeriesInternal');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardLegendBadges_$type = /*@__PURE__*/ markEnum('StandardLegendBadges', 'Line,0|Rect,1|MarkerlessRect,2|MarkerlessLine,3|Point,4|PositiveNegative,5|Financial,6|FinancialIndicator,7|ScatterPolygon,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardLegendItems_$type = /*@__PURE__*/ markEnum('StandardLegendItems', 'Default,0|Discrete,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScaleLegendSeries_$type = /*@__PURE__*/ new Type(null, 'IScaleLegendSeries', null, [ILegendSeries_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendOwner_$type = /*@__PURE__*/ new Type(null, 'ILegendOwner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IInternalLegendOwner_$type = /*@__PURE__*/ new Type(null, 'IInternalLegendOwner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILegendTemplateProvider_$type = /*@__PURE__*/ new Type(null, 'ILegendTemplateProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IChartLegend_$type = /*@__PURE__*/ new Type(null, 'IChartLegend');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IChartItemLegend_$type = /*@__PURE__*/ new Type(null, 'IChartItemLegend', null, [IChartLegend_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IChartScaleLegend_$type = /*@__PURE__*/ new Type(null, 'IChartScaleLegend', null, [IChartLegend_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointCollection = /*@__PURE__*/ (() => {
    class PointCollection extends List$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(Point_$type, 0);
                    }
                    break;
                case 1:
                    {
                        let source_ = _rest[0];
                        super(Point_$type, 0);
                        this._inner = source_._inner;
                    }
                    break;
            }
        }
    }
    PointCollection.$t = /*@__PURE__*/ markType(PointCollection, 'PointCollection', /*@__PURE__*/ List$1.$.specialize(Point_$type));
    return PointCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyBezierSegment = /*@__PURE__*/ (() => {
    class PolyBezierSegment extends PathSegment {
        constructor() {
            super();
            this.b = null;
            this.b = new PointCollection(0);
        }
        get_a() {
            return 2;
        }
        get a() {
            return this.get_a();
        }
    }
    PolyBezierSegment.$t = /*@__PURE__*/ markType(PolyBezierSegment, 'PolyBezierSegment', PathSegment.$);
    return PolyBezierSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Numeric = /*@__PURE__*/ (() => {
    class Numeric extends Base {
        constructor() {
            super();
        }
        static e(a, b, c, d, e) {
            let f;
            let g = a.count;
            let h = new Array(g);
            if (b._inner[0] == 0) {
                return false;
            }
            let i = b._inner[0];
            e._inner[0] = d._inner[0] / (i);
            for (f = 1; f < g; f++) {
                h[f] = c._inner[f - 1] / i;
                i = b._inner[f] - a._inner[f] * h[f];
                if (i == 0) {
                    return false;
                }
                e._inner[f] = (d._inner[f] - a._inner[f] * e._inner[f - 1]) / i;
            }
            for (f = (g - 2); f >= 0; f--) {
                e._inner[f] -= h[f + 1] * e._inner[f + 1];
            }
            return true;
        }
        static d(a, b) {
            let c = arrayGetLength(a, 0);
            let d = new Array(c);
            let e = new Array(c);
            let f = new Array(c);
            for (let g = 0; g < c; g++) {
                f[g] = 0;
            }
            for (let h = 0; h < c; h++) {
                let i = 0;
                let j = 0;
                let k = 0;
                for (let l = 0; l < c; l++) {
                    if (f[l] != 1) {
                        for (let m = 0; m < c; m++) {
                            if (f[m] == 0) {
                                if (Math.abs(a[l][m]) >= i) {
                                    i = Math.abs(a[l][m]);
                                    j = l;
                                    k = m;
                                }
                            }
                        }
                    }
                }
                ++(f[k]);
                if (j != k) {
                    for (let n = 0; n < c; n++) {
                        let o = a[j][n];
                        a[j][n] = a[k][n];
                        a[k][n] = o;
                    }
                    {
                        let p = b[j];
                        b[j] = b[k];
                        b[k] = p;
                    }
                }
                e[h] = j;
                d[h] = k;
                if (a[k][k] == 0) {
                    return false;
                }
                let q = 1 / a[k][k];
                a[k][k] = 1;
                for (let r = 0; r < c; r++) {
                    a[k][r] *= q;
                }
                b[k] *= q;
                for (let s = 0; s < c; s++) {
                    if (s != k) {
                        let t = a[s][k];
                        a[s][k] = 0;
                        for (let u = 0; u < c; u++) {
                            a[s][u] -= a[k][u] * t;
                        }
                        b[s] -= b[k] * t;
                    }
                }
            }
            for (let v = c - 1; v >= 0; v--) {
                if (e[v] != d[v]) {
                    for (let w = 0; w < c; w++) {
                        let x = a[w][e[v]];
                        a[w][e[v]] = a[w][d[v]];
                        a[w][d[v]] = x;
                    }
                }
            }
            return true;
        }
        static c(a, b, c, d, e) {
            let f = new List$1(Number_$type, 0);
            for (let g = 0; g < a; ++g) {
                while (g < a && (isNaN_(b(g)) || isNaN_(c(g)))) {
                    f.add(NaN);
                    ++g;
                }
                let h = g;
                while (g < a && !isNaN_(b(g)) && !isNaN_(c(g))) {
                    ++g;
                }
                --g;
                if (g - h > 0) {
                    f.o(Numeric.b(h, g - h + 1, b, c, d, e));
                }
                else {
                    for (; h <= g; ++h) {
                        f.add(NaN);
                    }
                }
            }
            return f.toArray();
        }
        static b(a, b, c, d, e, f) {
            return Numeric.a(b, (g) => c(g + a), (g) => d(g + a), e, f);
        }
        static a(a, b, c, d, e) {
            let f = new Array(a - 1);
            let g = new Array(a);
            g[0] = isNaN_(d) ? 0 : -0.5;
            f[0] = isNaN_(d) ? 0 : (3 / (b(1) - b(0))) * ((c(1) - c(0)) / (b(1) - b(0)) - d);
            for (let h = 1; h < a - 1; h++) {
                let i = (b(h) - b(h - 1)) / (b(h + 1) - b(h - 1));
                let j = i * g[h - 1] + 2;
                g[h] = (i - 1) / j;
                f[h] = (c(h + 1) - c(h)) / (b(h + 1) - b(h)) - (c(h) - c(h - 1)) / (b(h) - b(h - 1));
                f[h] = (6 * f[h] / (b(h + 1) - b(h - 1)) - i * f[h - 1]) / j;
            }
            let k = isNaN_(e) ? 0 : 0.5;
            let l = isNaN_(e) ? 0 : (3 / (b(a - 1) - b(a - 2))) * (e - (c(a - 1) - c(a - 2)) / (b(a - 1) - b(a - 2)));
            g[a - 1] = (l - k * f[a - 2]) / (k * g[a - 2] + 1);
            for (let m = a - 2; m >= 0; m--) {
                g[m] = g[m] * g[m + 1] + f[m];
            }
            return g;
        }
        f(a, b, c, d, e, f, g) {
            let h = d - b;
            let i = (d - a) / h;
            let j = (a - b) / h;
            return i * c + j * e + ((i * i * i - i) * f + (j * j * j - j) * g) * (h * h) / 6;
        }
        static h(a, b, c, d) {
            let e = new PathFigureCollection();
            let f = 0;
            let g = -1;
            let h = NaN;
            let i = NaN;
            for (let j = 0; j < a; j++) {
                h = b(j);
                i = c(j);
                if (isNaN_(h) || isNaN_(i)) {
                    g = j - 1;
                    if (g - f > 0) {
                        e.add(Numeric.g(f, g, b, c, d));
                    }
                    f = j + 1;
                }
            }
            if (!isNaN_(h) && !isNaN_(i)) {
                g = a - 1;
            }
            if (g - f > 0) {
                e.add(Numeric.g(f, g, b, c, d));
            }
            return e;
        }
        static g(a, b, c, d, e) {
            e = 0.5 * MathUtil.b(isNaN_(e) ? 0.5 : e, 0, 1);
            let f = new PathFigure();
            let g = b - a + 1;
            if (g < 2) {
                return f;
            }
            if (g == 2) {
                f._startPoint = { $type: Point_$type, x: c(a), y: d(a) };
                let h = ((() => {
                    let $ret = new LineSegment(1);
                    $ret.c = { $type: Point_$type, x: c(a + 1), y: d(a + 1) };
                    return $ret;
                })());
                f._segments.add(h);
                return f;
            }
            let i = new PolyBezierSegment();
            let j = c(a);
            let k = d(a);
            let l = c(a + 1);
            let m = d(a + 1);
            while (l == j && m == k && a + 1 <= b) {
                a++;
                l = c(a + 1);
                m = d(a + 1);
            }
            let n = l - j;
            let o = m - k;
            let p = Math.sqrt(n * n + o * o);
            for (let q = a + 1; q < b; ++q) {
                let r = c(q);
                let s = d(q);
                if (r == j && s == k) {
                    continue;
                }
                let t = c(q + 1) - c(q - 1);
                let u = d(q + 1) - d(q - 1);
                let v = t * t + u * u;
                if (v < 0.01) {
                    t = -(d(q + 1) - d(q));
                    u = c(q + 1) - c(q);
                    v = t * t + u * u;
                }
                v = Math.sqrt(v);
                let w = e * Math.sqrt((r - j) * (r - j) + (s - k) * (s - k));
                if (v > 0.01) {
                    i.b.add({ $type: Point_$type, x: j + n * w / p, y: k + o * w / p });
                    i.b.add({ $type: Point_$type, x: r - t * w / v, y: s - u * w / v });
                    i.b.add({ $type: Point_$type, x: r, y: s });
                    j = r;
                    k = s;
                    n = t;
                    o = u;
                    p = v;
                }
            }
            {
                let x = b;
                let y = c(x);
                let z = d(x);
                if (!(y == j && z == k)) {
                    let aa = c(x) - c(x - 1);
                    let ab = d(x) - d(x - 1);
                    let ac = aa * aa + ab * ab;
                    let ad = e * Math.sqrt((y - j) * (y - j) + (z - k) * (z - k));
                    i.b.add({ $type: Point_$type, x: j + n * ad / p, y: k + o * ad / p });
                    i.b.add({ $type: Point_$type, x: y - aa * ad / ac, y: z - ab * ad / ac });
                    i.b.add({ $type: Point_$type, x: y, y: z });
                }
            }
            f._startPoint = { $type: Point_$type, x: c(a), y: d(a) };
            f._segments.add(i);
            return f;
        }
    }
    Numeric.$t = /*@__PURE__*/ markType(Numeric, 'Numeric');
    return Numeric;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LeastSquaresFit = /*@__PURE__*/ (() => {
    class LeastSquaresFit extends Numeric {
        constructor() {
            super();
        }
        static aa() {
            return LeastSquaresFit.t() && LeastSquaresFit.u() && LeastSquaresFit.s() && LeastSquaresFit.w() && LeastSquaresFit.x() && LeastSquaresFit.r() && LeastSquaresFit.y() && LeastSquaresFit.z();
        }
        static k(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            for (let i = 0; i < a; ++i) {
                let j = b(i);
                let k = c(i);
                if (!isNaN_(j) && !isNaN_(k)) {
                    d += k;
                    e += j * j;
                    f += j;
                    g += j * k;
                    ++h;
                }
            }
            if (h < 2) {
                return null;
            }
            let l = (d * e - f * g) / (h * e - f * f);
            let m = (h * g - f * d) / (h * e - f * f);
            return [l, m];
        }
        static ad(a, b) {
            if (a.length != 2) {
                return NaN;
            }
            return a[0] + a[1] * b;
        }
        static t() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 10 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = -100; f < 100; ++f) {
                let g = f;
                let h = LeastSquaresFit.ad(b, g);
                if (!isNaN_(h)) {
                    d.add(g);
                    e.add(h);
                }
            }
            let i = LeastSquaresFit.k(d.count, (j) => d._inner[j], (j) => e._inner[j]);
            for (let j = 0; j < b.length; ++j) {
                if (Math.abs(b[j] - i[j]) > 0.0001) {
                }
            }
            return true;
        }
        static l(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            for (let i = 0; i < a; ++i) {
                let j = b(i);
                let k = c(i);
                if (!isNaN_(j) && !isNaN_(k) && j > 0) {
                    let l = Math.log(j);
                    d += k * l;
                    e += k;
                    f += l;
                    g += l * l;
                    ++h;
                }
            }
            if (h < 2) {
                return null;
            }
            let m = (h * d - e * f) / (h * g - f * f);
            let n = (e - m * f) / h;
            return [n, m];
        }
        static ae(a, b) {
            if (a.length != 2 || b < 0 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            return a[0] + a[1] * Math.log(b);
        }
        static u() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 10 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = 1; f < 100; ++f) {
                let g = f;
                let h = LeastSquaresFit.ae(b, g);
                if (!isNaN_(h)) {
                    d.add(g);
                    e.add(h);
                }
            }
            let i = LeastSquaresFit.l(d.count, (j) => d._inner[j], (j) => e._inner[j]);
            for (let j = 0; j < b.length; ++j) {
                if (Math.abs(b[j] - i[j]) > 0.0001) {
                }
            }
            return true;
        }
        static j(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            for (let j = 0; j < a; ++j) {
                let k = b(j);
                let l = c(j);
                if (!isNaN_(k) && !isNaN_(l) && l > 0) {
                    let m = Math.log(l);
                    d += k * k * l;
                    e += l * m;
                    f += k * l;
                    g += k * l * m;
                    h += l;
                    ++i;
                }
            }
            if (i < 2) {
                return null;
            }
            let n = (d * e - f * g) / (h * d - f * f);
            let o = (h * g - f * e) / (h * d - f * f);
            return [Math.exp(n), o];
        }
        static ac(a, b) {
            if (a.length != 2 || b < 0 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            return a[0] * Math.exp(a[1] * b);
        }
        static s() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 2 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = 1; f < 100; ++f) {
                let g = f;
                let h = LeastSquaresFit.ac(b, g);
                if (!isNaN_(h)) {
                    d.add(g);
                    e.add(h);
                }
            }
            let i = LeastSquaresFit.j(d.count, (j) => d._inner[j], (j) => e._inner[j]);
            for (let j = 0; j < b.length; ++j) {
                if (Math.abs(b[j] - i[j]) > 0.0001) {
                    return false;
                }
            }
            return true;
        }
        static n(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            let g = 0;
            let h = 0;
            for (let i = 0; i < a; ++i) {
                let j = b(i);
                let k = c(i);
                if (!isNaN_(j) && !isNaN_(k) && j > 0 && k > 0) {
                    let l = Math.log(b(i));
                    let m = Math.log(c(i));
                    d += l * m;
                    e += l;
                    f += m;
                    g += l * l;
                    ++h;
                }
            }
            if (h < 2) {
                return null;
            }
            let n = (h * d - e * f) / (h * g - e * e);
            let o = Math.exp((f - n * e) / h);
            return [o, n];
        }
        static ag(a, b) {
            if (a.length != 2 || b < 0 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            return a[0] * Math.pow(b, a[1]);
        }
        static w() {
            let a = new Random(0);
            let b = new Array(2);
            for (let c = 0; c < b.length; ++c) {
                b[c] = 10 * a.nextDouble();
            }
            let d = new List$1(Number_$type, 0);
            let e = new List$1(Number_$type, 0);
            for (let f = -100; f < 100; ++f) {
                d.add(f);
                e.add(LeastSquaresFit.ag(b, f));
            }
            let g = LeastSquaresFit.n(d.count, (h) => d._inner[h], (h) => e._inner[h]);
            for (let h = 0; h < b.length; ++h) {
                if (Math.abs(b[h] - g[h]) > 0.0001) {
                    return false;
                }
            }
            return true;
        }
        static o(a, b, c) {
            return LeastSquaresFit.m(a, 2, b, c);
        }
        static ah(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static x() {
            return LeastSquaresFit.v(2);
        }
        static i(a, b, c) {
            return LeastSquaresFit.m(a, 3, b, c);
        }
        static ab(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static r() {
            return LeastSquaresFit.v(3);
        }
        static p(a, b, c) {
            return LeastSquaresFit.m(a, 4, b, c);
        }
        static ai(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static y() {
            return LeastSquaresFit.v(4);
        }
        static q(a, b, c) {
            return LeastSquaresFit.m(a, 5, b, c);
        }
        static aj(a, b) {
            return LeastSquaresFit.af(a, b);
        }
        static z() {
            return LeastSquaresFit.v(5);
        }
        static m(a, b, c, d) {
            let e = new Array(1 + 2 * b);
            for (let f = 0; f < e.length; f++) {
                e[f] = 0;
            }
            let g = ((() => {
                let $firstRank;
                let $ret = new Array($firstRank = b + 1);
                let $currRet = $ret;
                for (let $rankInit = 0; $rankInit < $firstRank; $rankInit++) {
                    $currRet[$rankInit] = new Array(b + 1);
                }
                return $ret;
            })());
            let h = new Array(b + 1);
            for (let i = 0; i < h.length; i++) {
                h[i] = 0;
            }
            let j = 0;
            for (let k = 0; k < a; ++k) {
                let l = 1;
                let m = c(k);
                if (!isNaN_(m) && !isNaN_(d(k))) {
                    for (let n = 0; n < e.length; ++n) {
                        e[n] += l;
                        l *= m;
                        ++j;
                    }
                }
            }
            if (j < b) {
                return null;
            }
            for (let o = 0; o <= b; ++o) {
                for (let p = 0; p <= b; ++p) {
                    g[o][p] = e[o + p];
                }
            }
            for (let q = 0; q < a; ++q) {
                let r = c(q);
                let s = d(q);
                if (!isNaN_(r) && !isNaN_(s)) {
                    for (let t = 0; t <= b; ++t) {
                        h[t] += (Math.pow(r, t) * s);
                    }
                }
            }
            return Numeric.d(g, h) ? h : null;
        }
        static af(a, b) {
            if (a.length < 1 || isInfinity(b) || isNaN_(b)) {
                return NaN;
            }
            let c = 0;
            for (let d = 0; d < a.length; ++d) {
                c += a[d] * Math.pow(b, d);
            }
            return c;
        }
        static v(a) {
            let b = new Random(0);
            let c = new Array(a + 1);
            for (let d = 0; d < c.length; ++d) {
                c[d] = 2 * b.nextDouble();
            }
            let e = new List$1(Number_$type, 0);
            let f = new List$1(Number_$type, 0);
            for (let g = -100; g < 100; ++g) {
                let h = g;
                let i = LeastSquaresFit.af(c, h);
                if (!isNaN_(i)) {
                    e.add(h);
                    f.add(i);
                }
            }
            let j = LeastSquaresFit.m(e.count, a, (k) => e._inner[k], (k) => f._inner[k]);
            for (let k = 0; k < a; ++k) {
                if (Math.abs(c[k] - j[k]) > 0.0001) {
                    return false;
                }
            }
            return true;
        }
    }
    LeastSquaresFit.$t = /*@__PURE__*/ markType(LeastSquaresFit, 'LeastSquaresFit', Numeric.$);
    return LeastSquaresFit;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var BaseControlTheme = /*@__PURE__*/ (function (BaseControlTheme) {
    BaseControlTheme[BaseControlTheme["Default"] = 0] = "Default";
    BaseControlTheme[BaseControlTheme["DenaliLight"] = 1] = "DenaliLight";
    BaseControlTheme[BaseControlTheme["MaterialLight"] = 2] = "MaterialLight";
    return BaseControlTheme;
})({});
/**
 * @hidden
 */
let BaseControlTheme_$type = /*@__PURE__*/ markEnum('BaseControlTheme', 'Default,0|DenaliLight,1|MaterialLight,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ElevationMode = /*@__PURE__*/ (function (ElevationMode) {
    ElevationMode[ElevationMode["Auto"] = 0] = "Auto";
    ElevationMode[ElevationMode["MaterialShadow"] = 1] = "MaterialShadow";
    ElevationMode[ElevationMode["HaloShadow"] = 2] = "HaloShadow";
    return ElevationMode;
})({});
/**
 * @hidden
 */
let ElevationMode_$type = /*@__PURE__*/ markEnum('ElevationMode', 'Auto,0|MaterialShadow,1|HaloShadow,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ControlDisplayDensity = /*@__PURE__*/ (function (ControlDisplayDensity) {
    ControlDisplayDensity[ControlDisplayDensity["Auto"] = 0] = "Auto";
    ControlDisplayDensity[ControlDisplayDensity["Comfortable"] = 1] = "Comfortable";
    ControlDisplayDensity[ControlDisplayDensity["Cosy"] = 2] = "Cosy";
    ControlDisplayDensity[ControlDisplayDensity["Compact"] = 3] = "Compact";
    return ControlDisplayDensity;
})({});
/**
 * @hidden
 */
let ControlDisplayDensity_$type = /*@__PURE__*/ markEnum('ControlDisplayDensity', 'Auto,0|Comfortable,1|Cosy,2|Compact,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IIcon_$type = /*@__PURE__*/ new Type(null, 'IIcon');

class ContentChildrenManager {
    constructor(getPropsKey, getKey, updateContentChildren) {
        this._contentChildren = null;
        this._contentChildrenActual = null;
        this._contentChildrenMap = null;
        this._contentChildrenUnresolvedSet = null;
        this._contentChildrenUnresolved = 0;
        this.getChildRef = this.getChildRef.bind(this);
        this._getPropsKey = getPropsKey;
        this._getKey = getKey;
        this._updateContentChildren = updateContentChildren;
        this._contentChildrenUnresolvedSet = new Set();
    }
    getChildren(propChildren) {
        let children = [];
        Children.forEach(propChildren, (ch) => {
            let key = this._getPropsKey(ch);
            if (key === undefined) {
                throw new Error("each child must have a unique key or name property");
            }
            children.push(cloneElement(ch, {
                key: key,
                ref: this.getChildRef
            }));
        });
        this._contentChildren = children;
        let prevActual = this._contentChildrenActual;
        this._contentChildrenActual = [];
        let prevMap = this._contentChildrenMap;
        let prevUnresolved = this._contentChildrenUnresolvedSet;
        this._contentChildrenUnresolvedSet = new Set();
        this._contentChildrenMap = new Map();
        this._contentChildrenUnresolved = 0;
        if (this._contentChildren) {
            this._contentChildren.map((ch, i) => {
                let key = this._getPropsKey(ch);
                var unresolved = prevUnresolved.has(key);
                if (prevMap && prevMap.has(key) && !unresolved) {
                    this._contentChildrenActual[i] = prevActual[prevMap.get(key)];
                }
                else {
                    this._contentChildrenActual[i] = null;
                    this._contentChildrenUnresolvedSet.add(key);
                    this._contentChildrenUnresolved++;
                }
                this._contentChildrenMap.set(key, i);
            });
        }
        return children;
    }
    getChildRef(child) {
        //console.log(child);
        this.trackChild(child);
    }
    get contentChildrenActual() {
        return this._contentChildrenActual;
    }
    trackChild(child) {
        if (child === null) {
            return;
        }
        let name = this._getKey(child);
        let index = this._contentChildrenMap.get(name);
        if (this._contentChildrenActual[index] === null) {
            this._contentChildrenActual[index] = child;
            this._contentChildrenUnresolvedSet.delete(name);
            this._contentChildrenUnresolved--;
            if (this._contentChildrenUnresolved <= 0) {
                this._updateContentChildren();
            }
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateView extends Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (!this.props.template) {
            return null;
        }
        let ele = createElement(this.props.template, { dataContext: this.props.dataContext });
        return ele;
    }
}
class IgrTemplateContainer extends Component {
    constructor(props) {
        super(props);
        this._template = null;
        this._containerTemplate = null;
        this._dataContext = null;
        if (props.owner) {
            this._currentOwner = props.owner;
        }
    }
    componentDidUpdate() {
        if (this.contentReady) {
            this.contentReady();
        }
    }
    render() {
        if (!this._template) {
            return null;
        }
        let ele = createElement(IgrTemplateView, { dataContext: this._dataContext, template: this._template });
        if (this._containerTemplate !== null) {
        }
        else {
            if (this.props.omitContainer) {
                return (createElement(Fragment, null, ele));
            }
            else {
                return (createElement("div", { className: 'ui-template-container' }, ele));
            }
        }
        return ele;
    }
    get currentOwner() {
        return this._currentOwner;
    }
    shouldComponentUpdate(nextProps, nextState) {
        if (nextProps.owner !== undefined) {
            this._currentOwner = nextProps.owner;
        }
        return true;
    }
    set template(value) {
        this._template = value;
        this.setState({ template: this._template });
    }
    get template() {
        return this._template;
    }
    set containerTemplate(value) {
        this._containerTemplate = value;
        this.setState({ containerTemplate: this._containerTemplate });
    }
    get containerTemplate() {
        return this._containerTemplate;
    }
    set dataContext(value) {
        if (this._dataContext == null && value == null) {
            return;
        }
        this._dataContext = value;
        this.setState({ dataContext: this._dataContext });
    }
    get dataContext() {
        return this._dataContext;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateContainerModule {
    static register() {
        TypeRegistrar.registerCons("IgrTemplateContainer", IgrTemplateContainer);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateContent extends Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (!this.props.template) {
            return null;
        }
        let ele = createElement(this.props.template, { dataContext: this.props.dataContext });
        return ele;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTemplateContentModule {
    static register() {
        TypeRegistrar.registerCons("IgrTemplateContent", IgrTemplateContent);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrChildContent extends Component {
    constructor(props) {
        super(props);
    }
    render() {
        if (this.props.children) {
            return this.props.children;
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrChildContentModule {
    static register() {
        TypeRegistrar.registerCons("IgrChildContent", IgrChildContent);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let requiredStyle = `
    .ig-tooltip-container {
        padding: 5px; 
        padding: var(--tooltip-container-padding, 5px);
        background-color: white; 
        background-color: var(--tooltip-container-background-color, white);
        border-style: solid; 
        border-style: var(--tooltip-container-border-style, solid);
        border-width: 1px; 
        border-width: var(--tooltip-container-border-width, 1px);
        color: inherit; 
        color: var(--tooltip-container-text-color, inherit);
        pointer-events: none;
        white-space: nowrap;
        border-color: #666;
        border-color: var(--tooltip-container-border-color, #666);
    }
`;
let checked = /*@__PURE__*/ new WeakMap();
function ensureCss() {
    if (!document) {
        return;
    }
    if (checked.has(document)) {
        return;
    }
    for (let i = document.head.children.length - 1; i >= 0; i--) {
        let child = document.head.children[i];
        if (child.tagName == "link" && child.hasAttribute("data-ig-tooltip-style")) {
            return;
        }
    }
    let link = document.createElement("link");
    link.setAttribute('rel', 'stylesheet');
    link.setAttribute('type', 'text/css');
    link.setAttribute('href', 'data:text/css;charset=UTF-8,' + encodeURIComponent(requiredStyle));
    link.setAttribute('data-ig-tooltip-style', 'true');
    document.head.appendChild(link);
    checked.set(document, true);
}
class IgrTooltipContainer extends Component {
    constructor(props) {
        super(props);
        this._template = null;
        this._containerTemplate = null;
        this._dataContext = null;
        ensureCss();
        if (props.owner) {
            this._currentOwner = props.owner;
        }
    }
    render() {
        if (!this._template || !this._dataContext || !this.dataContext.item) {
            return null;
        }
        let ele = createElement(IgrTemplateContent, { dataContext: this._dataContext, template: this._template });
        if (this._containerTemplate !== null) {
        }
        else {
            return (createElement("div", { className: 'ig-tooltip-container igr-tooltip-container ig-tooltip-container-background', style: {} }, ele));
        }
        return ele;
    }
    get currentOwner() {
        return this._currentOwner;
    }
    shouldComponentUpdate(nextProps, nextState) {
        if (nextProps.owner !== undefined) {
            this._currentOwner = nextProps.owner;
        }
        return true;
    }
    set template(value) {
        this._template = value;
        this.setState({ template: this._template });
    }
    get template() {
        return this._template;
    }
    set containerTemplate(value) {
        this._containerTemplate = value;
        this.setState({ containerTemplate: this._containerTemplate });
    }
    get containerTemplate() {
        return this._containerTemplate;
    }
    set dataContext(value) {
        if (this._dataContext == null && value == null) {
            return;
        }
        this._dataContext = value;
        this.setState({ dataContext: this._dataContext });
    }
    get dataContext() {
        return this._dataContext;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrTooltipContainerModule {
    static register() {
        TypeRegistrar.registerCons("IgrTooltipContainer", IgrTooltipContainer);
        IgrTemplateContentModule.register();
    }
}

let PlatformConstants = /*@__PURE__*/ (() => {
    class PlatformConstants {
    }
    PlatformConstants.Prefix = "Igr";
    PlatformConstants.Postfix = "";
    return PlatformConstants;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class ReactRenderer {
    constructor(container, document, useDefaultsSource, defaultsSource, portalManager = null) {
        this.container = container;
        this._useDefaultsSource = false;
        this._checkResized = null;
        this._resizeListener = null;
        this._resizeTicking = false;
        this._portalManager = null;
        this._resizeTickId = -1;
        this._discStack = [];
        this._toUnbind = [];
        this._currentFontQuery = null;
        this._document = document;
        this._container = container;
        this._rootElement = container;
        this._rootWrapper = new ReactWrapper(this._rootElement, this);
        this._cssHelper = new ReactCssHelper(this, this._document);
        this._useDefaultsSource = useDefaultsSource;
        this._defaultsSource = defaultsSource;
        this._portalManager = portalManager;
        if (this._portalManager) {
            this._portalManager.renderer = this;
        }
    }
    addSizeWatcher(onResized) {
        let previousWidth = this._rootElement.offsetWidth;
        let previousHeight = this._rootElement.offsetHeight;
        let previousRatio = window.devicePixelRatio;
        if (this._checkResized == null) {
            this._checkResized = () => {
                let currWidth = this._rootElement.offsetWidth;
                let currHeight = this._rootElement.offsetHeight;
                let currRatio = window.devicePixelRatio;
                let changed = false;
                if (previousWidth != currWidth ||
                    previousHeight != currHeight ||
                    previousRatio != currRatio) {
                    changed = true;
                }
                previousWidth = currWidth;
                previousHeight = currHeight;
                previousRatio = currRatio;
                if (changed) {
                    onResized();
                }
            };
        }
        this._resizeListener = this.globalListen("window", "resize", (ev) => this._checkResized());
        let self = this;
        this._resizeTicking = true;
        function resizeTick() {
            self._resizeTickId = -1;
            if (self._resizeTicking) {
                self._checkResized();
                self._resizeTickId = self.setTimeout(resizeTick, 100);
            }
        }
        this._resizeTickId = this.setTimeout(resizeTick, 100);
    }
    destroy() {
        for (let i = 0; i < this._toUnbind.length; i++) {
            this._toUnbind[i]();
        }
        this._toUnbind = [];
        this.removeSizeWatcher();
        this._rootWrapper.destroy();
        this._rootWrapper = null;
        this._rootElement = null;
    }
    removeSizeWatcher() {
        this._resizeTicking = false;
        if (this._resizeTickId != -1) {
            window.clearTimeout(this._resizeTickId);
            this._resizeTickId = -1;
        }
        if (this._resizeListener != null) {
            this._resizeListener();
            this._resizeListener = null;
        }
    }
    updateRoot(root) {
        this._rootWrapper = root;
        this._rootElement = root.getNativeElement();
    }
    withRenderer(act) {
        act(this);
    }
    supportsAnimation() {
        return true;
    }
    getRequestAnimationFrame() {
        let ret = (act) => {
            requestAnimationFrame(act);
        };
        return ret;
    }
    setTimeout(act, millisecondsDelay) {
        let val;
        val = window.setTimeout(act, millisecondsDelay);
        return val;
    }
    clearTimeout(timerId) {
        window.clearTimeout(timerId);
    }
    get rootWrapper() {
        return this._rootWrapper;
    }
    querySelector(selector) {
        let wrapper = null;
        this.withRenderer((ren) => {
            let ele = this.rootWrapper.getNativeElement().querySelector(selector);
            if (ele === null) {
                return null;
            }
            wrapper = new ReactWrapper(ele, ren);
        });
        return wrapper;
    }
    getWrapper(ele) {
        if (!ele) {
            return null;
        }
        let wrapper = null;
        this.withRenderer((ren) => {
            wrapper = new ReactWrapper(ele, ren);
        });
        return wrapper;
    }
    getResourceString(resourceId) {
        // check if the resource culture is available.  It is a combination of the bundle ID and culture ID
        let grouping = this._resourceBundleId + "-" + this._cultureId;
        let isRegistered = Localization.isRegistered(grouping);
        if (isRegistered) {
            return Localization.getString(grouping, resourceId);
        }
        else {
            return "";
        }
    }
    setResourceBundleId(bundle) {
        this._resourceBundleId = bundle;
    }
    setCultureId(culture) {
        this._cultureId = culture;
    }
    append(child) {
        this._rootWrapper.append(child);
        return this;
    }
    appendToBody(element) {
        if (this._document !== null && this._document.body !== null) {
            this._document.body.appendChild(element.getNativeElement());
        }
    }
    createElement(elementName) {
        let ele;
        this.withRenderer((ren) => {
            ele = this._document.createElement(elementName);
        });
        let wrap = new ReactWrapper(ele, this);
        return wrap;
    }
    createElementNS(elementName, ns) {
        let ele;
        this.withRenderer((ren) => {
            ele = this._document.createElementNS(ns, elementName);
        });
        let wrap = new ReactWrapper(ele, this);
        return wrap;
    }
    endCSSQuery() {
        this._currentFontQuery = null;
        if (!this.hasBody()) {
            return;
        }
        if (this._discStack.length > 0) {
            var toRemove = this._discStack.pop();
            toRemove.remove();
        }
    }
    expandTemplate(template, args) {
        throw new Error("not implemented");
    }
    get2DCanvasContext(canvas) {
        let context = null;
        this.withRenderer((ren) => {
            var canv = (canvas.getNativeElement());
            context = canv.getContext("2d");
        });
        return context;
    }
    get isComputedFontQuery() {
        return this._currentFontQuery != null &&
            this.hasBody();
    }
    getCssDefaultPropertyValue(className, propertyName) {
        if (this._useDefaultsSource && !this.isComputedFontQuery) {
            let c = this._defaultsSource[className];
            if (className == "" || className == null) {
                c = this._defaultsSource;
            }
            if (c === undefined) {
                return null;
            }
            let v = c[propertyName];
            if (v === undefined) {
                return null;
            }
            return v;
        }
        return this._cssHelper.getPropertyValue(this.getCurrentDiscovery(), className, propertyName);
    }
    getCssDefaultValuesForClassCollection(classPrefix, propertyNames) {
        if (this._useDefaultsSource) {
            let ret = [];
            for (let k in this._defaultsSource) {
                if (k.indexOf(classPrefix) === 0) {
                    let subRet = [];
                    ret.push(subRet);
                    for (let i = 0; i < propertyNames.length; i++) {
                        let v = this._defaultsSource[k][propertyNames[i]];
                        if (v === undefined) {
                            subRet.push(null);
                        }
                        else {
                            subRet.push(v);
                        }
                    }
                }
            }
            return ret;
        }
        return this._cssHelper.getValuesForClassCollection(this.getCurrentDiscovery(), classPrefix, propertyNames);
    }
    getDefaultFontHeight() {
        if (this._defaultsSource["default-font-height"] !== undefined) {
            return +this._defaultsSource["default-font-height"];
        }
        return 16;
    }
    getHeightForFontString(fontString, text, useOffsetHeight) {
        if (this._rootWrapper.getNativeElement() == null) {
            //TODO: some voodoo here.
            return 12;
        }
        this.startCSSQuery();
        let disc = this.getCurrentDiscovery();
        if (disc == null || !this.hasWindow) {
            return this.getDefaultFontHeight();
        }
        if (disc.getNativeElement().parentElement) {
            disc.getNativeElement().parentElement.removeChild(disc.getNativeElement());
        }
        disc.setStyleProperty("position", "absolute");
        disc.setStyleProperty("visibility", "hidden");
        disc.setStyleProperty("font", fontString);
        document.body.appendChild(disc.getNativeElement());
        let span;
        this.withRenderer((ren) => {
            span = ren.createElement("span");
        });
        var spanWrap = new ReactWrapper(span, this);
        this.getCurrentDiscovery().append(spanWrap);
        spanWrap.setText(text);
        var height;
        if (useOffsetHeight) {
            var offHeight = spanWrap.getNativeElement().offsetHeight;
            height = offHeight;
        }
        else {
            height = spanWrap.getNativeElement().height();
        }
        if (height == 0) {
            //HACK: HACK! HACK! HACK!
            height = this.getDefaultFontHeight();
        }
        //console.log("font height: " + height);
        document.body.removeChild(disc.getNativeElement());
        this.endCSSQuery();
        return height;
    }
    getSubRenderer(root) {
        var elem = root;
        elem = elem.getNativeElement();
        return new ReactRenderer(elem, this._document, this._useDefaultsSource, this._defaultsSource, this._portalManager);
    }
    listen(element, eventName, handler) {
        let retVal = null;
        if (element == "window") {
            element = window;
        }
        if (element == "document") {
            element = document;
        }
        var $self = this;
        var ret = element.addEventListener(eventName, handler);
        var self = this;
        retVal = function () {
            var ind = self._toUnbind.indexOf(retVal);
            if (ind >= 0) {
                self._toUnbind.splice(ind, 1);
            }
            element.removeEventListener(eventName, handler);
            handler = null;
        };
        this._toUnbind.push(retVal);
        return retVal;
    }
    runInMainZone(action) {
        action();
    }
    globalListen(element, eventName, handler) {
        let retVal = null;
        //this._ngZone.runOutsideAngular(() => {
        var $self = this;
        var a = function (e) {
            var inner = {};
            //TODO: normalize here?
            inner.originalEvent = e;
            inner.altKey = e.altKey;
            inner.button = e.button;
            inner.ctrlKey = e.ctrlKey;
            inner.offsetX = e.offsetX;
            inner.offsetY = e.offsetY;
            inner.pageX = e.pageX;
            inner.pageY = e.pageY;
            if (e.touches && e.touches.length > 0) {
                inner.pageX = e.touches[0].pageX;
                inner.pageY = e.touches[0].pageY;
            }
            inner.shiftKey = e.shiftKey;
            inner.which = e.which;
            inner.preventDefault = function () {
                e.preventDefault();
            };
            inner.stopPropagation = function () {
                e.stopPropagation();
            };
            //console.log(e);
            handler(inner);
        };
        var ret = this.listen(element, eventName, a);
        var self = this;
        retVal = function () {
            var ind = self._toUnbind.indexOf(retVal);
            if (ind >= 0) {
                self._toUnbind.splice(ind, 1);
            }
            ret();
            a = null;
        };
        this._toUnbind.push(retVal);
        //});
        return retVal;
    }
    hasBody() {
        return this._document !== null && this._document.body !== null;
    }
    hasWindow() {
        //todo: hmmm
        return true;
    }
    getCurrentDiscovery() {
        if (this._discStack.length <= 0) {
            return null;
        }
        return this._discStack[this._discStack.length - 1];
    }
    setCssQueryFontString(fontString) {
        if (this._useDefaultsSource) {
            this._currentFontQuery = fontString;
        }
        this.getCurrentDiscovery().setStyleProperty("font", fontString);
    }
    startCSSQuery() {
        if (!this.hasBody()) {
            return;
        }
        var disc = this._cssHelper.getDiscoveryElement(this._rootElement);
        this._discStack.push(disc);
        this._rootWrapper.append(disc);
    }
    supportsDOMEvents() {
        //todo: hmmm.
        return true;
    }
    getPortal(hostElement, elementTag, portalCallback, isContentPortal) {
        if (this._portalManager) {
            this._portalManager.getPortal(hostElement, elementTag, portalCallback, isContentPortal);
        }
    }
    getExternal(internalComponent, styleSourceElement, optionalParent = null) {
        if (internalComponent.externalObject) {
            return internalComponent.externalObject;
        }
        let ext = null;
        if (!internalComponent.$type) {
            return null;
        }
        let name = internalComponent.$type.name;
        let externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        ext = TypeRegistrar.create(externalName);
        if (ext) {
            ext._implementation = internalComponent;
            internalComponent.externalObject = ext;
        }
        if (styleSourceElement) {
            if (ext._styling) {
                ext._styling(styleSourceElement.getNativeElement(), ext, optionalParent);
            }
        }
        return ext;
    }
}
class ReactWrapper {
    constructor(element, renderer) {
        this.renderer = renderer;
        this._toUnbind = [];
        this._attrCache = new Map();
        this._styleCache = new Map();
        this._innerText = undefined;
        if (element.getNativeElement) {
            element = element.getNativeElement();
        }
        this.ele = element;
        this._toUnbind = [];
    }
    destroy() {
        this.unlistenAll();
        this.ele = null;
    }
    withRenderer(act) {
        act(this.renderer);
    }
    addClass(className) {
        if (className == null || className.length == 0) {
            return this;
        }
        this.withRenderer((ren) => {
            className.split(" ").forEach((item) => this.ele.classList.add(item));
        });
        return this;
    }
    append(child) {
        this.withRenderer((ren) => {
            this.ele.appendChild(child.getNativeElement());
        });
        return this;
    }
    getAttribute(propertyName) {
        if (this._attrCache.has(propertyName)) {
            return this._attrCache.get(propertyName);
        }
        return null;
    }
    setAttribute(propertyName, value) {
        this._attrCache.set(propertyName, value);
        this.withRenderer((ren) => {
            this.ele.setAttribute(propertyName, value);
        });
        return this;
    }
    before(child) {
        if (this.ele.parentElement) {
            this.ele.parentElement.insertBefore(child.getNativeElement(), this.ele);
            // this.insertBefore(child.getNativeElement());
        }
        return this;
    }
    clone() {
        return new ReactWrapper(this.getNativeElement().cloneNode(true), this.renderer);
    }
    getStyleProperty(propertyName) {
        if (this.getNativeElement() !== null) {
            if (getComputedStyle !== undefined) {
                var computed = getComputedStyle(this.getNativeElement());
                //console.log("getting computed value for: " + propertyName + ": " + computed[propertyName]);
                return computed[propertyName];
            }
        }
        if (this._styleCache.has(propertyName)) {
            return this._styleCache.get(propertyName);
        }
        return null;
    }
    setStyleProperty(propertyName, value) {
        this._styleCache.set(propertyName, value);
        this.withRenderer((ren) => {
            this.ele.style[propertyName] = value;
        });
        return this;
    }
    findByClass(className) {
        if (className.substring(0, 1) == '.') {
            className = className.substring(1);
        }
        let ret = this.ele.getElementsByClassName(className);
        let retVal = [];
        retVal.length = ret.length;
        for (var i = 0; i < ret.length; i++) {
            retVal[i] = new ReactWrapper(ret[i], this.renderer);
        }
        return retVal;
    }
    focus(preventScroll) {
        if (this.getNativeElement() !== null && this.getNativeElement().focus !== undefined) {
            if (preventScroll) {
                this.getNativeElement().focus({ preventScroll: true });
            }
            else {
                this.getNativeElement().focus();
            }
        }
        return this;
    }
    getChildAt(i) {
        let child = this.ele.children[i];
        return new ReactWrapper(child, this.renderer);
    }
    getChildCount() {
        return this.ele.children.length;
    }
    getNativeElement() {
        let nativeElement = null;
        this.withRenderer((ren) => {
            if (this.ele == null) {
                nativeElement = null;
                return;
            }
            if (this.ele.getNativeElement == undefined) {
                nativeElement = this.ele;
                return nativeElement;
            }
            nativeElement = (this.ele.getNativeElement());
        });
        return nativeElement;
    }
    height() {
        var ret = this.getStyleProperty("height");
        if (ret == null) {
            //todo: some voodoo here.
            return 500;
        }
        let val = parseFloat(ret.replace("px", ""));
        if (isNaN(val)) {
            return 0;
        }
        return val;
    }
    hide() {
        this.setStyleProperty("display", "none");
        return this;
    }
    listen(eventName, handler) {
        let retVal = null;
        //this.ngZone.runOutsideAngular(() => {
        var $self = this;
        var a = function (e) {
            var inner = {};
            //TODO: normalize here?
            inner.originalEvent = e;
            inner.altKey = e.altKey;
            inner.button = e.button;
            inner.ctrlKey = e.ctrlKey;
            inner.offsetX = e.offsetX;
            inner.offsetY = e.offsetY;
            inner.pageX = e.pageX;
            inner.pageY = e.pageY;
            if (e.touches && e.touches.length > 0) {
                inner.pageX = e.touches[0].pageX;
                inner.pageY = e.touches[0].pageY;
            }
            inner.shiftKey = e.shiftKey;
            inner.which = e.which;
            inner.preventDefault = function () {
                e.preventDefault();
            };
            inner.stopPropagation = function () {
                e.stopPropagation();
            };
            //console.log(e);
            handler(inner);
        };
        var ret = this.renderer.listen(this.ele, eventName, a);
        var self = this;
        retVal = function () {
            var ind = self._toUnbind.indexOf(retVal);
            if (ind >= 0) {
                self._toUnbind.splice(ind, 1);
            }
            ret();
            a = null;
        };
        this._toUnbind.push(retVal);
        //});
        return retVal;
    }
    getOffsetHelper(ele) {
        var clientRect = ele.getBoundingClientRect();
        return {
            top: clientRect.top + window.pageYOffset,
            left: clientRect.left + window.pageXOffset
        };
    }
    getOffset() {
        return this.getOffsetHelper(this.getNativeElement());
    }
    setOffset(x, y) {
        let par = this.getNativeElement().offsetParent || this.getNativeElement().parentElement;
        let parentOffset = this.getOffsetHelper(par);
        return this.setRawPosition(x - parentOffset.left, y - parentOffset.top);
        //return this;
    }
    outerHeight() {
        return this.getProperty("offsetHeight");
    }
    outerHeightWithMargin() {
        let height = this.outerHeight();
        height += parseInt(this.getStyleProperty("marginTop"));
        height += parseInt(this.getStyleProperty("marginBottom"));
        return height;
    }
    outerWidth() {
        return this.getProperty("offsetWidth");
    }
    outerWidthWithMargin() {
        let width = this.outerWidth();
        width += parseInt(this.getStyleProperty("marginLeft"));
        width += parseInt(this.getStyleProperty("marginRight"));
        return width;
    }
    getProperty(propertyName) {
        let native = this.getNativeElement();
        return native[propertyName];
    }
    setProperty(propertyName, value) {
        this.withRenderer((ren) => {
            this.ele[propertyName] = value;
        });
        return this;
    }
    remove() {
        this.withRenderer((ren) => {
            let ele = this.getNativeElement();
            if (ele.parentElement != null) {
                this.ele.parentElement.removeChild(ele);
            }
            //ren.detachView([this.getNativeElement()]);
        });
        return this;
    }
    removeChild(child) {
        this.withRenderer((ren) => {
            this.ele.removeChild(child.getNativeElement());
            //ren.detachView([child.getNativeElement()]);
        });
        return this;
    }
    removeChildren() {
        for (let i = this.getChildCount() - 1; i >= 0; i--) {
            this.removeChild(this.getChildAt(i));
        }
        return this;
    }
    removeClass(className) {
        if (className == null || className.length == 0) {
            return this;
        }
        this.withRenderer((ren) => {
            className.split(" ").forEach((item) => this.ele.classList.remove(item));
        });
        return this;
    }
    setRawStyleProperty(propertyName, value) {
        //this.withRenderer((ren) => {
        this.ele.style[propertyName] = value;
        //})
        return this;
    }
    setRawPosition(x, y) {
        this.ele.style.left = x + "px";
        this.ele.style.top = y + "px";
        return this;
    }
    setRawXPosition(x) {
        this.ele.style.left = x + "px";
        return this;
    }
    setRawYPosition(y) {
        this.ele.style.top = y + "px";
        return this;
    }
    setRawSize(width, height) {
        this.ele.style.width = width + "px";
        this.ele.style.height = height + "px";
        return this;
    }
    show() {
        this.setStyleProperty("display", "");
        return this;
    }
    getText() {
        if (this._innerText != undefined) {
            return this._innerText;
        }
        return this.getNativeElement().innerText;
    }
    setText(value) {
        this._innerText = value;
        this.withRenderer((ren) => {
            //workaround warning:
            this.getNativeElement().innerText = value;
            //ren.setText(this.ele, value);
        });
        return this;
    }
    setRawText(value) {
        this._innerText = value;
        this.ele.textContent = value;
        return this;
    }
    unlistenAll() {
        var toUnbind = [];
        for (var i = 0; i < this._toUnbind.length; i++) {
            toUnbind.push(this._toUnbind[i]);
        }
        for (var i = 0; i < toUnbind.length; i++) {
            toUnbind[i]();
        }
        this._toUnbind.length = 0;
        return this;
    }
    width() {
        var ret = this.getStyleProperty("width");
        if (ret == null) {
            //todo: some voodoo here.
            return 500;
        }
        let val = parseFloat(ret.replace("px", ""));
        if (isNaN(val)) {
            return 0;
        }
        return val;
    }
    parent() {
        return this.ele == null || this.ele.parentElement == null ? null :
            new ReactWrapper(this.ele.parentElement, this.renderer);
    }
    querySelectorAll(selector) {
        let elements = this.ele.querySelectorAll(selector);
        let result = [];
        for (let ii = 0; ii < elements.length; ii++) {
            result.push(new ReactWrapper(elements[ii], this.renderer));
        }
        return result;
    }
}
class ReactCssHelper {
    constructor(renderer, document) {
        this.renderer = renderer;
        this.document = document;
    }
    getDiscoveryElement(container) {
        //console.log(container);
        var ele = this.renderer.createElement("fakediscoveryelement");
        var wrapper = new ReactWrapper(ele, this.renderer);
        wrapper.setStyleProperty("box-sizing", "content-box");
        return wrapper;
    }
    getPropertyValue(discoveryElement, className, propertyName) {
        //console.log("fetching: " + className + ", prop: " + propertyName);
        var ret = CssHelper.getPropertyValue1(discoveryElement, className, propertyName);
        //console.log("for: " + className + ", prop: " + propertyName + " value: " + ret);
        return ret;
    }
    getValuesForClassCollection(discoveryElement, classPrefix, propertyNames) {
        var prop = new List$1(String_$type, 0);
        for (var i = 0; i < propertyNames.length; i++) {
            prop.add(propertyNames[i]);
        }
        var ret = CssHelper.getValuesForClassCollection(discoveryElement, classPrefix, prop);
        var retVal = new Array(ret.count);
        for (var i1 = 0; i1 < ret.count; i1++) {
            retVal[i1] = new Array(ret._inner[i1].count);
            for (var j = 0; j < ret._inner[i1].count; j++) {
                retVal[i1][j] = ret._inner[i1]._inner[j];
            }
        }
        return retVal;
    }
}
class PortalManager {
    constructor(id, requestRender) {
        this.disableContentPortal = false;
        this._portals = [];
        this._portalsMap = new Map();
        this._id = null;
        this._currId = 0;
        this._requestRender = requestRender;
        this._onPortalRef = this._onPortalRef.bind(this);
        this._id = id;
    }
    onRender(children) {
        if (this._portals && this._portals.length > 0) {
            //children = React.Children.toArray(this.props.children);
            for (let i = 0; i < this._portals.length; i++) {
                let p = this._portals[i];
                if (p.isContentPortal && !this.disableContentPortal) {
                    var mine = children.slice(0);
                    children.length = 0;
                    var n = p._createPortal(mine);
                    p._nativePortal = n;
                }
                else {
                    var n = p._createPortal(null);
                    p._nativePortal = n;
                }
                children.push(p._nativePortal);
            }
        }
    }
    getId() {
        return this._id + "__" + (this._currId++).toString();
    }
    getPortal(hostElement, elementTag, portalCallback, isContentPortal) {
        let portal = new ReactDomPortal(this, hostElement, elementTag, portalCallback, this.getId(), this._onPortalRef, isContentPortal);
        this._portals.push(portal);
        this._portalsMap.set(portal._portalId, portal);
        this._requestRender();
    }
    _onPortalRef(ele) {
        if (ele != null) {
            var key = ele.props.id;
            if (this._portalsMap.has(key)) {
                var p = this._portalsMap.get(key);
                p._onComponentProvided(ele);
            }
        }
    }
    _destroy(portal) {
        let ind = this._portals.indexOf(portal);
        this._portalsMap.delete(portal._portalId);
        this._portals.splice(ind, 1);
        this._requestRender();
    }
}
class ReactDomPortal {
    constructor(portalManager, hostElement, elementTag, portalCallback, portalId, portalRef, isContentPortal) {
        this._portalRef = null;
        this.portalContainer = hostElement;
        this._elementTag = elementTag;
        this._portalCallback = portalCallback;
        this._portalId = portalId;
        this.isContentPortal = isContentPortal;
        this._portalRef = portalRef;
        this._owner = portalManager;
    }
    destroy() {
        this._owner._destroy(this);
    }
    _onComponentProvided(ele) {
        var oldValue = this.componentRef;
        this.componentRef = ele;
        if (oldValue !== this.componentRef) {
            this._portalCallback(this);
        }
    }
    toPascal(name) {
        var val = fromSpinal(name);
        return val.substr(0, 1).toUpperCase() + val.substr(1);
    }
    createElementFromTag(elementTag, portalId, portalRef, children) {
        if (elementTag.indexOf("-") >= 0) {
            elementTag = this.toPascal(elementTag);
        }
        var name = "Igr" + elementTag;
        var ele = TypeRegistrar.get(name);
        var rEle = createElement(ele, {
            ref: portalRef,
            key: portalId,
            id: portalId,
            children: children
        });
        return rEle;
    }
    _createPortal(children) {
        var reactEle = this.createElementFromTag(this._elementTag, this._portalId, this._portalRef, children);
        this._nativePortal = createPortal(reactEle, this.portalContainer.getNativeElement(), this._portalId);
        return this._nativePortal;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalDataSeriesAdapter_$type = /*@__PURE__*/ new Type(null, 'IExternalDataSeriesAdapter');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies which type of series is suggested for a data series.
 */
var DataSeriesType = /*@__PURE__*/ (function (DataSeriesType) {
    /**
     * Used when a line series is suggested.
     */
    DataSeriesType[DataSeriesType["Line"] = 0] = "Line";
    /**
     * Used when a column series is suggested.
     */
    DataSeriesType[DataSeriesType["Column"] = 1] = "Column";
    /**
     * Used when an area series is suggested.
     */
    DataSeriesType[DataSeriesType["Area"] = 2] = "Area";
    /**
     * Used when a bar series is suggested.
     */
    DataSeriesType[DataSeriesType["Bar"] = 3] = "Bar";
    /**
     * Used when a step line series is suggested.
     */
    DataSeriesType[DataSeriesType["StepLine"] = 4] = "StepLine";
    /**
     * Used when a step area series is suggested.
     */
    DataSeriesType[DataSeriesType["StepArea"] = 5] = "StepArea";
    /**
     * Used when a spline series is suggested.
     */
    DataSeriesType[DataSeriesType["Spline"] = 6] = "Spline";
    /**
     * Used when a spline area series is suggested.
     */
    DataSeriesType[DataSeriesType["SplineArea"] = 7] = "SplineArea";
    /**
     * Used when a waterfall series is suggested.
     */
    DataSeriesType[DataSeriesType["Waterfall"] = 8] = "Waterfall";
    /**
     * Used when a stacked series is suggested.
     */
    DataSeriesType[DataSeriesType["Stacked"] = 9] = "Stacked";
    /**
     * Used when a point series is suggested.
     */
    DataSeriesType[DataSeriesType["Point"] = 10] = "Point";
    /**
     * Used when a scatter point series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterPoint"] = 11] = "ScatterPoint";
    /**
     * Used when a scatter line series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterLine"] = 12] = "ScatterLine";
    /**
     * Used when a scatter spline series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterSpline"] = 13] = "ScatterSpline";
    /**
     * Used when a scatter area series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterArea"] = 14] = "ScatterArea";
    /**
     * Used when a scatter contour series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterContour"] = 15] = "ScatterContour";
    /**
     * Used when a high density scatter series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterHighDensity"] = 16] = "ScatterHighDensity";
    /**
     * Used when a bubble series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterBubble"] = 17] = "ScatterBubble";
    /**
     * Used when a polygon series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterPolygon"] = 18] = "ScatterPolygon";
    /**
     * Used when a polyline series is suggested.
     */
    DataSeriesType[DataSeriesType["ScatterPolyline"] = 19] = "ScatterPolyline";
    /**
     * Used when a financial price series is suggested.
     */
    DataSeriesType[DataSeriesType["FinancialPrice"] = 20] = "FinancialPrice";
    /**
     * Used when an financial indicator series is suggested.
     */
    DataSeriesType[DataSeriesType["FinancialIndicator"] = 21] = "FinancialIndicator";
    /**
     * Used when a financial overlay series is suggested.
     */
    DataSeriesType[DataSeriesType["FinancialOverlay"] = 22] = "FinancialOverlay";
    /**
     * Used when a value overlay is suggested.
     */
    DataSeriesType[DataSeriesType["ValueOverlay"] = 23] = "ValueOverlay";
    /**
     * Specifies unknown series type
     */
    DataSeriesType[DataSeriesType["Unknown"] = 24] = "Unknown";
    /**
     * Used when an item tooltip layer is suggested.
     */
    DataSeriesType[DataSeriesType["ItemToolTipLayer"] = 25] = "ItemToolTipLayer";
    /**
     * Used when a category tooltip layer is suggested.
     */
    DataSeriesType[DataSeriesType["CategoryToolTipLayer"] = 26] = "CategoryToolTipLayer";
    /**
     * Used when a crosshair layer is suggested.
     */
    DataSeriesType[DataSeriesType["CrosshairLayer"] = 27] = "CrosshairLayer";
    /**
     * Used when a callout layer is suggested.
     */
    DataSeriesType[DataSeriesType["CalloutLayer"] = 28] = "CalloutLayer";
    /**
     * Used when a final value layer is suggested.
     */
    DataSeriesType[DataSeriesType["FinalValueLayer"] = 29] = "FinalValueLayer";
    /**
     * Used when a category highlight layer is suggested.
     */
    DataSeriesType[DataSeriesType["CategoryHighlightLayer"] = 30] = "CategoryHighlightLayer";
    /**
     * Used when a category item highlight layer is suggested.
     */
    DataSeriesType[DataSeriesType["CategoryItemHighlightLayer"] = 31] = "CategoryItemHighlightLayer";
    return DataSeriesType;
})({});
/**
 * @hidden
 */
let DataSeriesType_$type = /*@__PURE__*/ markEnum('DataSeriesType', 'Line,0|Column,1|Area,2|Bar,3|StepLine,4|StepArea,5|Spline,6|SplineArea,7|Waterfall,8|Stacked,9|Point,10|ScatterPoint,11|ScatterLine,12|ScatterSpline,13|ScatterArea,14|ScatterContour,15|ScatterHighDensity,16|ScatterBubble,17|ScatterPolygon,18|ScatterPolyline,19|FinancialPrice,20|FinancialIndicator,21|FinancialOverlay,22|ValueOverlay,23|Unknown,24|ItemToolTipLayer,25|CategoryToolTipLayer,26|CrosshairLayer,27|CalloutLayer,28|FinalValueLayer,29|CategoryHighlightLayer,30|CategoryItemHighlightLayer,31');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies various intents for the sub properties of the data being bound to a data series.
 */
var DataSeriesIntent = /*@__PURE__*/ (function (DataSeriesIntent) {
    /**
     * Identifies the primary values to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["PrimarySeriesValue"] = 0] = "PrimarySeriesValue";
    /**
     * Identifies the x axis values to use for a scatter series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesX"] = 1] = "SeriesX";
    /**
     * Identifies the y axis values to use for a scatter series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesY"] = 2] = "SeriesY";
    /**
     * Identifies the fill scale values to use for a bubble series or scatter area series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesFill"] = 3] = "SeriesFill";
    /**
     * Identifies the legend label values to use for a bubble series in item-wize legends.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesLabel"] = 4] = "SeriesLabel";
    /**
     * Identifies the radius values to use for a bubble, polar, or radial series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesRadius"] = 5] = "SeriesRadius";
    /**
     * Identifies the angle values to use for a polar or radial series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesAngle"] = 6] = "SeriesAngle";
    /**
     * Identifies the shape values to use for a scatter polyline or polygon series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesShape"] = 7] = "SeriesShape";
    /**
     * Identifies the item-wize values to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesValue"] = 8] = "SeriesValue";
    /**
     * Identifies a grouping identifier to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesGroup"] = 9] = "SeriesGroup";
    /**
     * Identifies a title to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["SeriesTitle"] = 10] = "SeriesTitle";
    /**
     * Identifies an open value to use for a financial series.
     */
    DataSeriesIntent[DataSeriesIntent["OpenSeriesValue"] = 11] = "OpenSeriesValue";
    /**
     * Identifies a high value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["HighSeriesValue"] = 12] = "HighSeriesValue";
    /**
     * Identifies a low value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["LowSeriesValue"] = 13] = "LowSeriesValue";
    /**
     * Identifies a close value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["CloseSeriesValue"] = 14] = "CloseSeriesValue";
    /**
     * Identifies a volume value to use for a financial series or range series.
     */
    DataSeriesIntent[DataSeriesIntent["VolumeSeriesValue"] = 15] = "VolumeSeriesValue";
    /**
     * Identifies an axis label value to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["AxisLabelValue"] = 16] = "AxisLabelValue";
    /**
     * Identifies an axis date value to use for a series.
     */
    DataSeriesIntent[DataSeriesIntent["AxisDateValue"] = 17] = "AxisDateValue";
    /**
     * Identifies that a value should be ignored when considering values for a series.
     */
    DataSeriesIntent[DataSeriesIntent["DontPlot"] = 18] = "DontPlot";
    /**
     * Identifies a sales units value to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesUnit"] = 19] = "SalesUnit";
    /**
     * Identifies a sales fixed cost to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesFixedCost"] = 20] = "SalesFixedCost";
    /**
     * Identifies a sales variable cost to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesVariableCost"] = 21] = "SalesVariableCost";
    /**
     * Identifies a sales total cost to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesTotalCost"] = 22] = "SalesTotalCost";
    /**
     * Identifies a sales revenue to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesRevenue"] = 23] = "SalesRevenue";
    /**
     * Identifies a sales marginal profit to use for a break-even series
     */
    DataSeriesIntent[DataSeriesIntent["SalesMarginalProfit"] = 24] = "SalesMarginalProfit";
    /**
     * Identifes a value that has been used to generate other data to bind against.
     */
    DataSeriesIntent[DataSeriesIntent["GenerationInput"] = 25] = "GenerationInput";
    return DataSeriesIntent;
})({});
/**
 * @hidden
 */
let DataSeriesIntent_$type = /*@__PURE__*/ markEnum('DataSeriesIntent', 'PrimarySeriesValue,0|SeriesX,1|SeriesY,2|SeriesFill,3|SeriesLabel,4|SeriesRadius,5|SeriesAngle,6|SeriesShape,7|SeriesValue,8|SeriesGroup,9|SeriesTitle,10|OpenSeriesValue,11|HighSeriesValue,12|LowSeriesValue,13|CloseSeriesValue,14|VolumeSeriesValue,15|AxisLabelValue,16|AxisDateValue,17|DontPlot,18|SalesUnit,19|SalesFixedCost,20|SalesVariableCost,21|SalesTotalCost,22|SalesRevenue,23|SalesMarginalProfit,24|GenerationInput,25');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesMemberPathHint = /*@__PURE__*/ (() => {
    class DataSeriesMemberPathHint extends Base {
        constructor() {
            super(...arguments);
            this._path = null;
            this._intent = 0;
        }
        get path() {
            return this._path;
        }
        set path(a) {
            this._path = a;
        }
        get intent() {
            return this._intent;
        }
        set intent(a) {
            this._intent = a;
        }
        equals(a) {
            let b = typeCast(DataSeriesMemberPathHint.$, a);
            if (b == null) {
                return false;
            }
            if (!Base.equalsStatic(this.path, b.path)) {
                return false;
            }
            if (this.intent != b.intent) {
                return false;
            }
            return true;
        }
        toString() {
            return enumGetBox(DataSeriesIntent_$type, this.intent) + " Path = '" + this.path + "'";
        }
        update1(a, b = null) {
            this.path = stringIsNullOrEmpty(b) ? a : stringReplace(b, "NAME", a);
        }
        update(a, b = null) {
            if (a.count == 0) {
                return;
            }
            this.update1(a._inner[0], b);
        }
        hasPath() {
            return !stringIsNullOrEmpty(this.path);
        }
        clone() {
            return ((() => {
                let $ret = new DataSeriesMemberPathHint();
                $ret.intent = this.intent;
                $ret.path = this.path;
                return $ret;
            })());
        }
    }
    DataSeriesMemberPathHint.$t = /*@__PURE__*/ markType(DataSeriesMemberPathHint, 'DataSeriesMemberPathHint');
    return DataSeriesMemberPathHint;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeries = /*@__PURE__*/ (() => {
    class DataSeries extends Base {
        constructor() {
            super();
            this.j = null;
            this._name = null;
            this._title = null;
            this._data = null;
            this._priority = 0;
            this._index = 0;
            this._suggestedPrimaryAxis = 0;
            this._suggestedSecondaryAxis = 0;
            this._suggestedSeries = 0;
            this._dataPath = null;
            this._suggestedMarker = 0;
            this.j = new List$1(DataSeriesMemberPathHint.$, 0);
            this.suggestedMarker = 0;
            this.index = -1;
            this.priority = -1;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get title() {
            return this._title;
        }
        set title(a) {
            this._title = a;
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get index() {
            return this._index;
        }
        set index(a) {
            this._index = a;
        }
        get suggestedPrimaryAxis() {
            return this._suggestedPrimaryAxis;
        }
        set suggestedPrimaryAxis(a) {
            this._suggestedPrimaryAxis = a;
        }
        get suggestedSecondaryAxis() {
            return this._suggestedSecondaryAxis;
        }
        set suggestedSecondaryAxis(a) {
            this._suggestedSecondaryAxis = a;
        }
        get suggestedSeries() {
            return this._suggestedSeries;
        }
        set suggestedSeries(a) {
            this._suggestedSeries = a;
        }
        get dataPath() {
            return this._dataPath;
        }
        set dataPath(a) {
            this._dataPath = a;
        }
        get suggestedMarker() {
            return this._suggestedMarker;
        }
        set suggestedMarker(a) {
            this._suggestedMarker = a;
        }
        addMemberPathHint(a) {
            this.j.add(a);
        }
        addMemberPathHint1(a, b) {
            let c = a.clone();
            c.intent = b;
            this.j.add(c);
        }
        addMemberPathHint2(a, b) {
            let c = new DataSeriesMemberPathHint();
            c.intent = b;
            c.path = a;
            this.j.add(c);
        }
        removeMemberPathHint(a) {
            this.j.remove(a);
        }
        clearMemberPathHints() {
            this.j.clear();
        }
        getMemberPathHintCount() {
            return this.j.count;
        }
        getMemberPathHintAt(a) {
            return this.j._inner[a];
        }
        findMatchingHint(a) {
            for (let b = 0; b < this.j.count; b++) {
                if (this.j._inner[b].intent == a) {
                    return this.j._inner[b];
                }
            }
            return null;
        }
        getMemberPathFor(a) {
            let b = this.findMatchingHint(a);
            if (b == null) {
                return "";
            }
            return b.path;
        }
        hasMatchingHint(a) {
            let b = this.findMatchingHint(a);
            if (b == null) {
                return false;
            }
            if (stringIsNullOrEmpty(b.path)) {
                return false;
            }
            return true;
        }
        i() {
            return this.j;
        }
        equals(a) {
            let b = typeCast(DataSeries.$, a);
            if (b == null) {
                return false;
            }
            if (!Base.equalsStatic(this.name, b.name)) {
                return false;
            }
            if (!Base.equalsStatic(this.title, b.title)) {
                return false;
            }
            if (this.data != b.data) {
                return false;
            }
            if (this.priority != b.priority) {
                return false;
            }
            if (this.suggestedPrimaryAxis != b.suggestedPrimaryAxis) {
                return false;
            }
            if (this.suggestedSecondaryAxis != b.suggestedSecondaryAxis) {
                return false;
            }
            if (this.suggestedSeries != b.suggestedSeries) {
                return false;
            }
            if (this.suggestedMarker != b.suggestedMarker) {
                return false;
            }
            if (!Base.equalsStatic(this.dataPath, b.dataPath)) {
                return false;
            }
            let c = this.i();
            let d = b.i();
            if (c.count != d.count) {
                return false;
            }
            for (let e = 0; e < c.count; e++) {
                if (!c.item(e).equals(d.item(e))) {
                    return false;
                }
            }
            return true;
        }
        toString() {
            let a = enumGetBox(DataSeriesType_$type, this.suggestedSeries) + " hints: ";
            for (let b of fromEnum(this.j)) {
                a += " {" + b.toString() + "}, ";
            }
            return a;
        }
    }
    DataSeries.$t = /*@__PURE__*/ markType(DataSeries, 'DataSeries');
    return DataSeries;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesCollection = /*@__PURE__*/ (() => {
    class DataSeriesCollection extends ObservableCollection$1 {
        constructor() {
            super(DataSeries.$, 0);
        }
    }
    DataSeriesCollection.$t = /*@__PURE__*/ markType(DataSeriesCollection, 'DataSeriesCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(DataSeries.$));
    return DataSeriesCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceLocalDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceLocalDataProvider', null, [IDataSourceDataProvider_$type, IDataSourceSupportsIndexedAccess_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Matcher = /*@__PURE__*/ (() => {
    class Matcher extends Base {
        constructor(a) {
            super();
            this.c = null;
            let patt_ = Matcher.d(a);
            this.c = (new RegExp(patt_));
        }
        b(a) {
            return this.c.test(a);
        }
        static a(a) {
            return Matcher.d(a) != null;
        }
        static d(a) {
            if (a == null) {
                return null;
            }
            if (stringStartsWith(a, "/") && stringEndsWith(a, "/")) {
                return a.substr(1, a.length - 2);
            }
            if (stringStartsWith(a, "Regex(") && stringEndsWith(a, ")")) {
                return a.substr(6, a.length - 7);
            }
            if (stringStartsWith(a, "RegExp(") && stringEndsWith(a, ")")) {
                return a.substr(7, a.length - 8);
            }
            if (stringContains(a, "*") || stringContains(a, "#") || stringContains(a, "?")) {
                a = stringReplace(a, ".", "\\.");
                a = stringReplace(a, "*", ".*");
                a = stringReplace(a, "#", "\\d+");
                a = stringReplace(a, "?", ".+");
                a = stringReplace(a, "[", "\\[");
                a = stringReplace(a, "]", "\\]");
                return "^" + a + "$";
            }
            return null;
        }
    }
    Matcher.$t = /*@__PURE__*/ markType(Matcher, 'Matcher');
    return Matcher;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSeriesAdapterRule_$type = /*@__PURE__*/ new Type(null, 'IDataSeriesAdapterRule');
/**
 * @hidden
 */
let DataSeriesAdapterRunContext = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRunContext extends Base {
        constructor(a) {
            super();
            this.g = null;
            this._analyzer = null;
            this.h = null;
            this.m = null;
            this.o = null;
            this.n = null;
            this.b = null;
            this.a = null;
            this.l = null;
            this.g = a;
            this.analyzer = new DataSeriesDataProviderAnalyzer(this);
            this.analyzer.includedProperties = this.g.includedProperties;
            this.analyzer.excludedProperties = this.g.excludedProperties;
            this.h = new DataSeriesCollection();
            this.m = new Stack$1(IDataSourceLocalDataProvider_$type);
            this.o = new Stack$1(String_$type);
            this.n = new Stack$1(String_$type);
            this.b = this.g.includedProperties;
            this.a = this.g.excludedProperties;
            this.l = null;
            if (this.g.supportedSeriesTypes != null) {
                this.l = new HashSet$1(DataSeriesType_$type, 0);
                for (let b = 0; b < this.g.supportedSeriesTypes.length; b++) {
                    this.l.add_1(this.g.supportedSeriesTypes[b]);
                }
            }
        }
        get analyzer() {
            return this._analyzer;
        }
        set analyzer(a) {
            this._analyzer = a;
        }
        getSubProvider(a, b) {
            let c = this.g.l(a);
            this.pushDataSource(c);
            this.pushPath(b);
            return c;
        }
        popSubProvider() {
            this.popDataSource();
            this.popPath();
        }
        w(a, b) {
            return this.g.v(a, b);
        }
        recurseRules(a, b, c) {
            this.g.al(this, a, b, c);
        }
        get includedProperties() {
            return this.b;
        }
        get excludedProperties() {
            return this.a;
        }
        getCurrentDataSource() {
            return this.m.d();
        }
        pushDataSource(a) {
            this.m.h(a);
        }
        hasValidType(a) {
            if (this.l == null) {
                return true;
            }
            if (this.l.contains(a.suggestedSeries)) {
                return true;
            }
            return false;
        }
        popDataSource() {
            return this.m.e();
        }
        getCurrentPathSegment() {
            return this.o.d();
        }
        getCurrentPath() {
            let a = "";
            let b = true;
            for (let c of fromEnum(this.o)) {
                if (b) {
                    b = false;
                }
                else {
                    a += ".";
                }
                a += c;
            }
            return a;
        }
        getParentTitle() {
            if (this.n.f == 0) {
                return null;
            }
            return this.n.d();
        }
        pushPath(a) {
            this.o.h(a);
        }
        popPath() {
            return this.o.e();
        }
        pushParentTitle(a) {
            this.n.h(a);
        }
        popParentTitle() {
            return this.n.e();
        }
        ab(a, b) {
            if (a.priority == -1) {
                a.priority = b.priority;
            }
            if (a.dataPath == null) {
                a.dataPath = this.getCurrentPath();
            }
            if (a.data == null) {
                a.data = this.getCurrentDataSource().dataSource;
            }
        }
        addDataSeries(a, b) {
            this.ab(a, b);
            this.h.add(a);
        }
        removeDataSeries(a) {
            this.h.remove(a);
        }
        insertDataSeries(a, b, c) {
            this.ab(b, c);
            this.h.insert(a, b);
        }
        clearDataSeries() {
            this.h.clear();
        }
        getDataSeriesCount() {
            return this.h.count;
        }
        getDataSeriesAt(a) {
            return this.h._inner[a];
        }
    }
    DataSeriesAdapterRunContext.$t = /*@__PURE__*/ markType(DataSeriesAdapterRunContext, 'DataSeriesAdapterRunContext');
    return DataSeriesAdapterRunContext;
})();
/**
 * @hidden
 */
let DataSeriesDataProviderAnalyzer = /*@__PURE__*/ (() => {
    class DataSeriesDataProviderAnalyzer extends Base {
        constructor(a) {
            super();
            this.p = null;
            this.b = null;
            this.a = null;
            this.s = false;
            this.r = false;
            this.ak = new HashSet$1(String_$type, 0);
            this.am = new List$1(Matcher.$, 0);
            this.aj = new HashSet$1(String_$type, 0);
            this.al = new List$1(Matcher.$, 0);
            this.p = a;
        }
        get includedProperties() {
            return this.b;
        }
        set includedProperties(a) {
            this.b = a;
            this.ak.clear();
            if (this.b == null) {
                this.s = false;
            }
            else {
                this.s = true;
                let d = this.b;
                for (let c = 0; c < d.length; c++) {
                    let b = d[c];
                    if (Matcher.a(b)) {
                        this.am.add(new Matcher(b));
                    }
                    else {
                        this.ak.add_1(b);
                    }
                }
            }
        }
        get excludedProperties() {
            return this.a;
        }
        set excludedProperties(a) {
            this.a = a;
            this.aj.clear();
            if (this.a == null) {
                this.r = false;
            }
            else {
                this.r = true;
                let d = this.a;
                for (let c = 0; c < d.length; c++) {
                    let b = d[c];
                    if (Matcher.a(b)) {
                        this.al.add(new Matcher(b));
                    }
                    else {
                        this.aj.add_1(b);
                    }
                }
            }
        }
        getParentTitle() {
            return this.p.getParentTitle();
        }
        shouldIncludeProperty(a, b) {
            if (!stringIsNullOrEmpty(b)) {
                a = b + "." + a;
            }
            if (this.s && !this.ak.contains(a) && !this.y(a)) {
                return false;
            }
            if (this.r && (this.aj.contains(a) || this.u(a))) {
                return false;
            }
            return true;
        }
        u(a) {
            for (let b = 0; b < this.al.count; b++) {
                if (this.al._inner[b].b(a)) {
                    return true;
                }
            }
            return false;
        }
        y(a) {
            for (let b = 0; b < this.am.count; b++) {
                if (this.am._inner[b].b(a)) {
                    return true;
                }
            }
            return false;
        }
        expandCamelCasedWords(a) {
            if (a == null) {
                return null;
            }
            a = stringReplace(stringReplace(a, "[", ""), "]", "");
            let b = new List$1(String_$type, 0);
            let c = 0;
            for (let d = 0; d < a.length; d++) {
                let e = a.charAt(d);
                let f = e.toUpperCase();
                let g = e.toLowerCase();
                if (d == 0) {
                    e = f;
                }
                let h = (c == 0 && b.count > 0);
                let i = (c > 1);
                if (f == e) {
                    if (h) {
                        b.add(' ');
                    }
                    c++;
                }
                else if (g == e) {
                    if (i) {
                        b.insert(b.count - 1, ' ');
                    }
                    c = 0;
                }
                else {
                    c = 0;
                }
                b.add(e);
            }
            let j = stringEmpty();
            for (let k = 0; k < b.count; k++) {
                j += b._inner[k];
            }
            return j;
        }
        hasStringProperties() {
            return this.getAllStringProperties().length > 0;
        }
        getAllStringProperties() {
            return this.n((a) => a == 0, null);
        }
        isCollection(a) {
            if (typeCast(IEnumerable_$type, a) !== null || typeCast(Array_$type, a) !== null) {
                return true;
            }
            return false;
        }
        getAllPropertiesWithName(a) {
            return this.n(null, (b) => b == a);
        }
        getAllNumericProperties() {
            return this.n(runOn(this, this.ae), null);
        }
        getAllObjectProperties() {
            return this.n(runOn(this, this.af), null);
        }
        getAllCollectionProperties() {
            let a = this.getAllObjectProperties();
            if (a.length == 0) {
                return new Array(0);
            }
            let b = this.p.getCurrentDataSource();
            let c = new List$1(String_$type, 0);
            for (let d = 0; d < b.actualCount; d++) {
                if (this.isCollection(b.getItemAtIndex(d))) {
                    c.add(b.actualSchema.propertyNames[d]);
                }
            }
            return c.toArray();
        }
        getFirstNumericProperty() {
            let a = this.getAllNumericProperties();
            if (a.length == 0) {
                return null;
            }
            return a[0];
        }
        hasNumericProperties() {
            return this.getAllNumericProperties().length > 0;
        }
        ab(a) {
            if (a == 8 || a == 9) {
                return true;
            }
            return false;
        }
        q(a) {
            let b = this.p.getCurrentDataSource();
            if (b == null) {
                return 11;
            }
            let c = b.actualSchema;
            if (c == null) {
                return 11;
            }
            let d = -1;
            for (let e = 0; e < c.propertyNames.length; e++) {
                if (Base.equalsStatic(c.propertyNames[e], a)) {
                    d = e;
                    break;
                }
            }
            if (d == -1) {
                return 11;
            }
            return c.propertyTypes[d];
        }
        n(a, b) {
            let c = this.p.getCurrentDataSource();
            let d = c.actualSchema;
            if (d == null) {
                return new Array(0);
            }
            let e = this.p.getCurrentPath();
            let f = 0;
            for (let g = 0; g < d.propertyTypes.length; g++) {
                if ((a == null || a(d.propertyTypes[g])) && (b == null || b(d.propertyNames[g])) && this.ai(d.propertyDataIntents, g) && this.shouldIncludeProperty(d.propertyNames[g], e)) {
                    f++;
                }
            }
            let h = new Array(f);
            f = 0;
            for (let i = 0; i < d.propertyTypes.length; i++) {
                if ((a == null || a(d.propertyTypes[i])) && (b == null || b(d.propertyNames[i])) && this.ai(d.propertyDataIntents, i) && this.shouldIncludeProperty(d.propertyNames[i], e)) {
                    h[f] = d.propertyNames[i];
                    f++;
                }
            }
            return h;
        }
        ai(a, b) {
            if (a == null) {
                return true;
            }
            return !this.t(a, b, "DontPlot");
        }
        t(a, b, c) {
            if (a == null) {
                return false;
            }
            for (let d = 0; d < a[b].length; d++) {
                let e = a[b][d];
                if (Base.equalsStatic(e.toLowerCase(), c.toLowerCase())) {
                    return true;
                }
            }
            return false;
        }
        getAllPropertiesWithIntent(a) {
            return this.i(a, false, false);
        }
        getAllPropertiesWithValuelessIntent(a) {
            return this.i(a, true, false);
        }
        getPropertyIntentValue(a, b) {
            let c = this.p.getCurrentDataSource();
            if (c == null) {
                return null;
            }
            let d = c.actualSchema;
            if (d == null) {
                return null;
            }
            let e = d.propertyDataIntents;
            if (e == null || d.propertyNames == null) {
                return null;
            }
            for (let f = 0; f < d.propertyNames.length; f++) {
                if (d.propertyNames[f] != null && Base.equalsStatic(d.propertyNames[f], b)) {
                    for (let g = 0; g < e[f].length; g++) {
                        let h = e[f][g];
                        let i = h.split('/');
                        if (i.length == 2 && i[0] != null && Base.equalsStatic(i[0], a)) {
                            return i[1];
                        }
                    }
                }
            }
            return null;
        }
        getAllPropertiesWithValuedIntent(a) {
            return this.i(a, false, true);
        }
        i(a, b, c) {
            let d = this.p.getCurrentDataSource();
            if (d == null) {
                return new Array(0);
            }
            let e = d.actualSchema;
            if (e == null) {
                return new Array(0);
            }
            let f = e.propertyDataIntents;
            if (f == null || e.propertyNames == null) {
                return new Array(0);
            }
            let g = 0;
            for (let h = 0; h < e.propertyNames.length; h++) {
                for (let i = 0; i < f[h].length; i++) {
                    let j = f[h][i];
                    let k = j.split('/');
                    if (b && k.length > 1) {
                        continue;
                    }
                    if (c && k.length < 2) {
                        continue;
                    }
                    if (Base.equalsStatic(a.toLowerCase(), k[0].toLowerCase())) {
                        g++;
                    }
                }
            }
            let l = new Array(g);
            g = 0;
            for (let m = 0; m < e.propertyNames.length; m++) {
                for (let n = 0; n < f[m].length; n++) {
                    let o = f[m][n];
                    let p = o.split('/');
                    if (b && p.length > 1) {
                        continue;
                    }
                    if (c && p.length < 2) {
                        continue;
                    }
                    if (Base.equalsStatic(a.toLowerCase(), o.toLowerCase())) {
                        l[g] = e.propertyNames[m];
                        g++;
                    }
                }
            }
            return l;
        }
        getAllDateTimeProperties() {
            return this.n(runOn(this, this.ab), null);
        }
        getFirstDateTimeProperty() {
            let a = this.getAllDateTimeProperties();
            if (a.length == 0) {
                return null;
            }
            return a[0];
        }
        getFirstStringProperty() {
            let a = this.getAllStringProperties();
            if (a.length == 0) {
                return null;
            }
            return a[0];
        }
        hasDateTimeProperties() {
            return this.getAllDateTimeProperties().length > 0;
        }
        ae(a) {
            return a == 1 || a == 3 || a == 4 || a == 7 || a == 5 || a == 6 || a == 10;
        }
        af(a) {
            return a == 11;
        }
        isMonotonic(a, b, c) {
            if (a == null) {
                return false;
            }
            let d = false;
            let e = false;
            let f = a.actualCount;
            for (let g = 0; g < Math.min(f, c); g++) {
                if (g == 0) {
                    continue;
                }
                let h = this.an(a.getItemValue(a.getItemAtIndex(g - 1), b));
                let i = this.an(a.getItemValue(a.getItemAtIndex(g), b));
                if (!e && h != i) {
                    d = i > h;
                    e = true;
                }
                if (h == i) {
                    continue;
                }
                if (e) {
                    let j = i > h;
                    if (j != d) {
                        return false;
                    }
                }
            }
            return true;
        }
        aw(a, b, c) {
            let d = this.p.getCurrentDataSource();
            let e = d.actualSchema;
            if (e == null) {
                return null;
            }
            let f = this.n(b, null);
            if (f.length == 0) {
                return null;
            }
            if (d.actualCount > a) {
                return null;
            }
            for (let g = 0; g < f.length; g++) {
                if (c(f[g], this.q(f[g]))) {
                    return f[g];
                }
            }
            return null;
        }
        getFirstDistinctStringProperty(a) {
            return this.aw(a, (b) => b == 0, runOn(this, this.ag));
        }
        getFirstDistinctNumericProperty(a) {
            return this.aw(a, runOn(this, this.ae), runOn(this, this.ad));
        }
        getFirstDistinctMonotonicNumericProperty(a) {
            let b = this.p.getCurrentDataSource();
            return this.aw(a, runOn(this, this.ae), (c, d) => this.ad(c, d) && this.isMonotonic(b, c, a));
        }
        getFirstDistinctDateTimeProperty(a) {
            return this.aw(a, runOn(this, this.ab), runOn(this, this.aa));
        }
        getFirstStringPropertyPreferringDistinct(a) {
            let b = this.getFirstDistinctStringProperty(a);
            if (b != null) {
                return b;
            }
            let c = this.getAllStringProperties();
            if (c.length == 0) {
                return null;
            }
            return c[0];
        }
        getTitleString(a, b) {
            let c = this.p.getCurrentDataSource();
            let d = null;
            if (d == null && b != null) {
                let e = null;
                for (let f = 0; f < b.length; f++) {
                    let g = this.getPropertyIntentValue(EnumUtil.getName(DataSeriesIntent_$type, (10)), b[f]);
                    if (d == null) {
                        d = g;
                        e = g;
                    }
                    else {
                        if (g != null) {
                            if (g.trim().length > 0 && g != e) {
                                d += " - " + g;
                            }
                            e = g;
                        }
                    }
                }
            }
            if (d == null) {
                let h = this.getAllPropertiesWithValuelessIntent(EnumUtil.getName(DataSeriesIntent_$type, (10)));
                if (h != null && h.length > 0) {
                    d = h[0];
                    d = this.aq(a, c, d);
                }
            }
            if (d == null) {
                if (this.getParentTitle() != null) {
                    d = this.getParentTitle();
                }
            }
            if (d == null && a != null) {
                let i = this.getAllStringProperties();
                for (let k = 0; k < i.length; k++) {
                    let j = i[k];
                    if (j != null && (Base.equalsStatic(j.toLowerCase(), "label") || Base.equalsStatic(j.toLowerCase(), "title"))) {
                        d = j;
                    }
                }
                if (d != null) {
                    d = this.aq(a, c, d);
                }
            }
            return d;
        }
        aq(a, b, c) {
            if (a != null) {
                let d = b.getItemValue(a, c);
                if (d != null) {
                    c = d.toString();
                }
            }
            else {
                c = this.getNonNullPropertyValue(c).toString();
            }
            return c;
        }
        getNonNullPropertyValue(a) {
            let b = this.p.getCurrentDataSource();
            for (let c = 0; c < b.actualCount; c++) {
                let d = b.getItemValue(b.getItemAtIndex(c), a);
                if (d != null) {
                    return d;
                }
            }
            return null;
        }
        ag(a, b) {
            let c = this.p.getCurrentDataSource();
            let d = new HashSet$1(String_$type, 0);
            for (let e = 0; e < c.actualCount; e++) {
                let f = c.getItemValue(c.getItemAtIndex(e), a);
                let g = f;
                if (d.contains(g)) {
                    return false;
                }
                d.add_1(g);
            }
            return true;
        }
        aa(a, b) {
            let c = this.p.getCurrentDataSource();
            let d = new HashSet$1(Number_$type, 0);
            for (let e = 0; e < c.actualCount; e++) {
                let f;
                let g = c.getItemValue(c.getItemAtIndex(e), a);
                if (g == null) {
                    f = dateMinValue();
                }
                else {
                    f = g;
                }
                if (d.contains(f.getTime())) {
                    return false;
                }
                d.add_1(f.getTime());
            }
            return true;
        }
        an(value_) {
            return (+value_);
        }
        ad(a, b) {
            let c = this.p.getCurrentDataSource();
            if (b == 4 || b == 1 || b == 3) {
                let d = new HashSet$1(Number_$type, 0);
                for (let e = 0; e < c.actualCount; e++) {
                    let f;
                    let g = c.getItemValue(c.getItemAtIndex(e), a);
                    if (g == null) {
                        f = -9.2233720368547758E+18;
                    }
                    else {
                        f = typeGetValue(g);
                    }
                    if (d.contains(f)) {
                        return false;
                    }
                    d.add_1(f);
                }
                return true;
            }
            if (b == 7 || b == 5 || b == 6) {
                let h = new HashSet$1(Number_$type, 0);
                for (let i = 0; i < c.actualCount; i++) {
                    let j;
                    let k = c.getItemValue(c.getItemAtIndex(i), a);
                    if (k == null) {
                        j = NaN;
                    }
                    else {
                        j = this.an(k);
                    }
                    if (h.contains(j)) {
                        return false;
                    }
                    h.add_1(j);
                }
                return true;
            }
            return false;
        }
    }
    DataSeriesDataProviderAnalyzer.$t = /*@__PURE__*/ markType(DataSeriesDataProviderAnalyzer, 'DataSeriesDataProviderAnalyzer');
    return DataSeriesDataProviderAnalyzer;
})();
/**
 * @hidden
 */
let DataSeriesAdapterUpdateNotifier = /*@__PURE__*/ (() => {
    class DataSeriesAdapterUpdateNotifier extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        notifyClearItems() {
            this.a.ae(this.b);
        }
        notifyInsertItem(a, b) {
            this.a.af(this.b, a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.ag(this.b, a, b);
        }
        notifySetItem(a, b, c) {
            this.a.ah(this.b, a, b, c);
        }
    }
    DataSeriesAdapterUpdateNotifier.$t = /*@__PURE__*/ markType(DataSeriesAdapterUpdateNotifier, 'DataSeriesAdapterUpdateNotifier', Base.$, [IDataSourceDataProviderUpdateNotifier_$type]);
    return DataSeriesAdapterUpdateNotifier;
})();
/**
 * @hidden
 */
let DataSeriesAdapterRuleCollection = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRuleCollection extends ObservableCollection$1 {
        constructor() {
            super(IDataSeriesAdapterRule_$type, 0);
        }
    }
    DataSeriesAdapterRuleCollection.$t = /*@__PURE__*/ markType(DataSeriesAdapterRuleCollection, 'DataSeriesAdapterRuleCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(IDataSeriesAdapterRule_$type));
    return DataSeriesAdapterRuleCollection;
})();
/**
 * @hidden
 */
let DataSeriesAdapterRemovingDuplicatesEventArgs = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRemovingDuplicatesEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.d = null;
            this.e = null;
            this.a = null;
            this.c = false;
        }
    }
    DataSeriesAdapterRemovingDuplicatesEventArgs.$t = /*@__PURE__*/ markType(DataSeriesAdapterRemovingDuplicatesEventArgs, 'DataSeriesAdapterRemovingDuplicatesEventArgs');
    return DataSeriesAdapterRemovingDuplicatesEventArgs;
})();
/**
 * @hidden
 */
let DataSeriesAdapterRunEventArgs = /*@__PURE__*/ (() => {
    class DataSeriesAdapterRunEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = false;
        }
    }
    DataSeriesAdapterRunEventArgs.$t = /*@__PURE__*/ markType(DataSeriesAdapterRunEventArgs, 'DataSeriesAdapterRunEventArgs');
    return DataSeriesAdapterRunEventArgs;
})();
/**
 * @hidden
 */
let DataSeriesAdapterImplementation = /*@__PURE__*/ (() => {
    class DataSeriesAdapterImplementation extends Base {
        constructor() {
            super();
            this.q = null;
            this.r = null;
            this.n = new Dictionary$2(Base.$, IDataSourceLocalDataProvider_$type, 0);
            this.o = null;
            this.propertyChanged = null;
            this.c = null;
            this.b = null;
            this.a = null;
            this._rules = null;
            this._dataSeries = null;
            this.m = false;
            this.removingUnsupported = null;
            this.removingDuplicates = null;
            this.rules = new DataSeriesAdapterRuleCollection();
            this.dataSeries = new DataSeriesCollection();
            this.ai(this.rules);
            let a = this.rules;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.ap));
        }
        v(a, b) {
            let c = stringEmpty();
            if (this.q != null) {
                c = this.q(a);
            }
            if (stringIsNullOrEmpty(c)) {
                return b;
            }
            return c;
        }
        ai(a) {
        }
        ap(a, b) {
            this.refresh();
        }
        get g() {
            return this.r;
        }
        get itemsSource() {
            return this.o;
        }
        set itemsSource(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ad("ItemsSource", b, this.o);
            }
        }
        get supportedSeriesTypes() {
            return this.c;
        }
        set supportedSeriesTypes(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ad("SupportedSeriesTypes", b, this.c);
            }
        }
        get includedProperties() {
            return this.b;
        }
        set includedProperties(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.ad("IncludedProperties", b, this.b);
            }
        }
        get excludedProperties() {
            return this.a;
        }
        set excludedProperties(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ad("ExcludedProperties", b, this.a);
            }
        }
        get rules() {
            return this._rules;
        }
        set rules(a) {
            this._rules = a;
        }
        get dataSeries() {
            return this._dataSeries;
        }
        set dataSeries(a) {
            this._dataSeries = a;
        }
        ad(a, b, c) {
            this.aj(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        aj(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    this.refresh();
                    break;
                case "SupportedSeriesTypes":
                    this.refresh();
                    break;
                case "IncludedProperties":
                    this.refresh();
                    break;
                case "ExcludedProperties":
                    this.refresh();
                    break;
            }
        }
        refresh() {
            this.m = true;
            this.y();
            let a = new DataSeriesAdapterRunContext(this);
            let b = this.l(this.itemsSource);
            this.x(b, null, false);
            a.pushDataSource(b);
            this.ar(a);
            this.at(a);
            this.m = false;
        }
        y() {
            for (let a of fromEnum(this.n.keys)) {
                let b = this.n.item(a);
                b.updateNotifier = null;
                b.schemaChanged = delegateRemove(b.schemaChanged, runOn(this, this.ak));
            }
            this.n.clear();
        }
        at(a) {
            this.ao(a);
            this.an(a);
            this.as(a);
        }
        ao(a) {
            let b = true;
            if (this.removingUnsupported != null) {
                let c = ((() => {
                    let $ret = new DataSeriesAdapterRunEventArgs();
                    $ret.a = a;
                    return $ret;
                })());
                this.removingUnsupported(this, c);
                b = !c.b;
            }
            if (b) {
                if (this.supportedSeriesTypes == null) {
                    return;
                }
                let d = new HashSet$1(DataSeriesType_$type, 0);
                for (let e = 0; e < this.supportedSeriesTypes.length; e++) {
                    d.add_1(this.supportedSeriesTypes[e]);
                }
                for (let f = a.getDataSeriesCount() - 1; f >= 0; f--) {
                    let g = a.getDataSeriesAt(f);
                    if (!d.contains(g.suggestedSeries)) {
                        a.removeDataSeries(g);
                    }
                }
            }
        }
        as(a) {
            let b = 0;
            for (; b < Math.min(this.dataSeries.count, a.getDataSeriesCount()); b++) {
                if (!this.dataSeries._inner[b].equals(a.getDataSeriesAt(b))) {
                    this.dataSeries.removeAt(b);
                    b--;
                }
            }
            for (; b < a.getDataSeriesCount(); b++) {
                this.dataSeries.insert(b, a.getDataSeriesAt(b));
            }
            for (; b < this.dataSeries.count; b++) {
                this.dataSeries.removeAt(b);
                b--;
            }
        }
        an(a) {
            let b = new Dictionary$2(String_$type, List$1.$.specialize(DataSeries.$), 0);
            for (let c = 0; c < a.getDataSeriesCount(); c++) {
                let d = a.getDataSeriesAt(c);
                let e = d.i();
                for (let f = 0; f < e.count; f++) {
                    if (e.item(f).intent == 16 || e.item(f).intent == 17) {
                        continue;
                    }
                    let g = (d.dataPath != null ? (d.dataPath + ".") : "") + e.item(f).path;
                    if (e.item(f).intent == 25) {
                        g = e.item(f).path;
                    }
                    if (!b.containsKey(g)) {
                        b.item(g, new List$1(DataSeries.$, 0));
                    }
                    b.item(g).add(d);
                }
            }
            for (let h of fromEnum(b.keys)) {
                if (b.item(h).count > 1) {
                    let i = new Array(b.item(h).count);
                    let j = b.item(h);
                    let k = j.count;
                    for (let l = 0; l < k; l++) {
                        i[l] = j._inner[l];
                    }
                    let m = true;
                    if (this.removingDuplicates != null) {
                        let n = ((() => {
                            let $ret = new DataSeriesAdapterRemovingDuplicatesEventArgs();
                            $ret.e = h;
                            $ret.b = a;
                            $ret.a = i;
                            return $ret;
                        })());
                        m = !n.c;
                    }
                    if (m) {
                        let o = -1;
                        let p = null;
                        j = b.item(h);
                        k = j.count;
                        for (let q = 0; q < k; q++) {
                            let r = j._inner[q];
                            if (r.priority > o) {
                                o = r.priority;
                                p = r;
                            }
                        }
                        for (let s = 0; s < k; s++) {
                            let t = j._inner[s];
                            if (t != p) {
                                a.removeDataSeries(t);
                            }
                        }
                    }
                }
            }
        }
        ar(a) {
            for (let b = 0; b < this.rules.count; b++) {
                this.aq(a, this.rules._inner[b]);
            }
        }
        aq(a, b) {
            b.evaluate(a);
        }
        l(a) {
            if (a != null && this.n.containsKey(a)) {
                return this.n.item(a);
            }
            return this.g.getDataProvider(a);
        }
        al(a, b, c, d) {
            let e = this.l(b);
            this.x(e, a.getCurrentDataSource(), d);
            a.pushDataSource(e);
            a.pushPath(c);
            this.ar(a);
            a.popPath();
            a.popDataSource();
        }
        x(a, b, c) {
            if (a.dataSource != null) {
                this.n.addItem(a.dataSource, a);
            }
            a.schemaChanged = delegateCombine(a.schemaChanged, runOn(this, this.ak));
            if (b != null) {
                let d = new DataSeriesAdapterUpdateNotifier(this, a);
                b.updateNotifier = d;
            }
            if (c) {
                let e = new DataSeriesAdapterUpdateNotifier(this, a);
                a.updateNotifier = e;
            }
        }
        ak(a, b) {
            if (!this.m) {
                this.refresh();
            }
        }
        ae(a) {
            this.refresh();
        }
        af(a, b, c) {
            this.refresh();
        }
        ag(a, b, c) {
            this.refresh();
        }
        ah(a, b, c, d) {
            this.refresh();
        }
        notifyClearItems(a) {
            if (this.n.containsKey(a)) {
                this.n.item(a).notifyClearItems();
            }
        }
        notifyInsertItem(a, b, c) {
            if (this.n.containsKey(a)) {
                this.n.item(a).notifyInsertItem(b, c);
            }
        }
        notifyRemoveItem(a, b, c) {
            if (this.n.containsKey(a)) {
                this.n.item(a).notifyRemoveItem(b, c);
            }
        }
        notifySetItem(a, b, c, d) {
            if (this.n.containsKey(a)) {
                this.n.item(a).notifySetItem(b, c, d);
            }
        }
    }
    DataSeriesAdapterImplementation.$t = /*@__PURE__*/ markType(DataSeriesAdapterImplementation, 'DataSeriesAdapterImplementation', Base.$, [INotifyPropertyChanged_$type]);
    return DataSeriesAdapterImplementation;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumerates the available property types on a data source schema.
 */
var DataSourceSchemaPropertyType = /*@__PURE__*/ (function (DataSourceSchemaPropertyType) {
    /**
     * The property is of type string.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["StringValue"] = 0] = "StringValue";
    /**
     * The property is of type integer.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["IntValue"] = 1] = "IntValue";
    /**
     * The property is of type boolean.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["BooleanValue"] = 2] = "BooleanValue";
    /**
     * The property is of type long.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["LongValue"] = 3] = "LongValue";
    /**
     * The property if of type short.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["ShortValue"] = 4] = "ShortValue";
    /**
     * The property is of type double.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DoubleValue"] = 5] = "DoubleValue";
    /**
     * The property is of type decimal.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DecimalValue"] = 6] = "DecimalValue";
    /**
     * The property is of type single.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["SingleValue"] = 7] = "SingleValue";
    /**
     * The property is of type datetime.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DateTimeValue"] = 8] = "DateTimeValue";
    /**
     * The property is of type datetimeoffset.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["DateTimeOffsetValue"] = 9] = "DateTimeOffsetValue";
    /**
     * The property is of type byte.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["ByteValue"] = 10] = "ByteValue";
    /**
     * The property is of type object.
     */
    DataSourceSchemaPropertyType[DataSourceSchemaPropertyType["ObjectValue"] = 11] = "ObjectValue";
    return DataSourceSchemaPropertyType;
})({});
/**
 * @hidden
 */
let DataSourceSchemaPropertyType_$type = /*@__PURE__*/ markEnum('DataSourceSchemaPropertyType', 'StringValue,0|IntValue,1|BooleanValue,2|LongValue,3|ShortValue,4|DoubleValue,5|DecimalValue,6|SingleValue,7|DateTimeValue,8|DateTimeOffsetValue,9|ByteValue,10|ObjectValue,11');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceSchema_$type = /*@__PURE__*/ new Type(null, 'IDataSourceSchema');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultDataSourceSchema = /*@__PURE__*/ (() => {
    class DefaultDataSourceSchema extends Base {
        constructor(a, b, c, d) {
            super();
            this.c = null;
            this.d = null;
            this.a = null;
            this.b = null;
            this.c = a;
            this.d = b;
            this.a = c;
            this.b = d;
        }
        get primaryKey() {
            return this.a;
        }
        get propertyNames() {
            return this.c;
        }
        get propertyTypes() {
            return this.d;
        }
        get propertyDataIntents() {
            return this.b;
        }
    }
    DefaultDataSourceSchema.$t = /*@__PURE__*/ markType(DefaultDataSourceSchema, 'DefaultDataSourceSchema', Base.$, [IDataSourceSchema_$type]);
    return DefaultDataSourceSchema;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataProviderSchemaChangedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceDataProviderSchemaChangedEventArgs extends EventArgs {
        constructor(a, b) {
            super();
            this.d = 0;
            this.b = null;
            this.b = a;
            this.d = b;
        }
        get schema() {
            return this.b;
        }
        get count() {
            return this.d;
        }
    }
    DataSourceDataProviderSchemaChangedEventArgs.$t = /*@__PURE__*/ markType(DataSourceDataProviderSchemaChangedEventArgs, 'DataSourceDataProviderSchemaChangedEventArgs', EventArgs.$);
    return DataSourceDataProviderSchemaChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceLocalDataProvider = /*@__PURE__*/ (() => {
    class DataSourceLocalDataProvider extends Base {
        constructor() {
            super();
            this.k = null;
            this.j = null;
            this.e = null;
            this.l = null;
            this.d = 0;
            this.v = null;
            this.schemaChanged = null;
            this.q = new Dictionary$2(String_$type, FastReflectionHelper.$, 0);
            this.h = null;
            this.t = null;
            this.o = false;
            this.g = null;
            this.f = null;
            this.n = false;
            this.a = null;
            this.m = false;
            this.k = new SortDescriptionCollection();
            this.k.n(runOn(this, this.ai));
        }
        ai(a, b) {
            this.queueAutoRefresh();
        }
        get dataSource() {
            return this.v;
        }
        set dataSource(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.ae("ItemsSource", b, this.v);
            }
        }
        getItemAtIndex(a) {
            if (this.t == null) {
                return null;
            }
            if (this.o) {
                return this.t[a];
            }
            return this.t.item(a);
        }
        getItemValue(a, b) {
            this.ab();
            let c;
            let d = this.q.tryGetValue(b, c);
            c = d.p1;
            if (c == null) {
                return null;
            }
            let val_ = c.getPropertyValue(a);
            if ((val_ === undefined)) {
                return null;
            }
            return val_;
        }
        setItemValue(a, b, c) {
            this.ab();
            let d;
            let e = this.q.tryGetValue(b, d);
            d = e.p1;
            if (d == null) {
                return;
            }
            d.setPropertyValue(a, c);
        }
        removeItem(a) {
            if (this.t != null) {
                let b = this.t.indexOf(a);
                if (this.o) {
                    this.t.splice(b, 1);
                }
                else {
                    this.t.removeAt(b);
                }
                this.notifyRemoveItem(b, a);
            }
        }
        addItem(a) {
            if (this.t != null) {
                let b = this.actualCount;
                if (this.o) {
                    this.t.splice(b, 0, a);
                }
                else {
                    this.t.insert(b, a);
                }
                this.notifyInsertItem(this.actualCount - 1, a);
            }
        }
        ab() {
            if (this.h == null) {
                this.h = this.actualSchema;
                if (this.schemaChanged != null) {
                    this.schemaChanged(this, new DataSourceDataProviderSchemaChangedEventArgs(this.h, this.actualCount));
                }
            }
        }
        get actualCount() {
            if (this.t == null) {
                return 0;
            }
            if (this.o) {
                return (this.t.length);
            }
            return this.t.count;
        }
        get actualSchema() {
            if (this.h == null) {
                if (this.t == null) {
                    this.h = new DefaultDataSourceSchema([], [], null, null);
                }
                else {
                    this.h = this.i();
                }
            }
            return this.h;
        }
        i() {
            let a = this.w();
            if (a == null) {
                return new DefaultDataSourceSchema([], [], null, null);
            }
            this.q.clear();
            let b = new List$1(String_$type, 0);
            let c = new HashSet$1(String_$type, 0);
            let d = new List$1(DataSourceSchemaPropertyType_$type, 0);
            let e = new List$1(List$1.$.specialize(String_$type), 0);
            let f = this.r(a);
            for (let g = 0; g < f.count; g++) {
                let h = f._inner[g];
                if (stringStartsWith(h, "_")) {
                    continue;
                }
                if (h == "$hashCode") {
                    continue;
                }
                if (c.contains(h)) {
                    continue;
                }
                else {
                    b.add(h);
                    c.add_1(h);
                    this.q.addItem(h, new FastReflectionHelper(false, h));
                    d.add(this.b(a, h));
                    e.add(this.s(a, h));
                }
            }
            let i = new Array(e.count);
            for (let j = 0; j < e.count; j++) {
                i[j] = e._inner[j].toArray();
            }
            return new DefaultDataSourceSchema(b.toArray(), d.toArray(), null, i);
        }
        resolveSchemaPropertyType(a) {
            let b = a.split('.');
            if (b.length == 1) {
                for (let c = 0; c < this.actualSchema.propertyNames.length; c++) {
                    if (this.actualSchema.propertyNames[c] == b[0]) {
                        return this.actualSchema.propertyTypes[c];
                    }
                }
                return 11;
            }
            else {
                let d = this.w();
                let e = this.getItemValue(d, a);
                if (e == null) {
                    return 11;
                }
                else {
                    return DataSourceLocalDataProvider.c(e);
                }
            }
        }
        r(schemaItem_) {
            let propertyKey_ = null;
            let ret_ = new List$1(String_$type, 0);
            let exclusions_ = {};
            for (propertyKey_ in schemaItem_) {
                if (!isNaN(propertyKey_)) {
                    continue;
                }
                if (!exclusions_.hasOwnProperty(propertyKey_)) {
                    ret_.add(propertyKey_);
                }
            }
            ;
            return ret_;
        }
        ad(a, item_, propertyName_, b) {
            if ((item_.__dataIntents !== undefined)) {
                if ((item_.__dataIntents[propertyName_] !== undefined)) {
                    this.ac(a, item_, propertyName_);
                }
                let selfName_ = "self." + propertyName_;
                if (!b && (item_.__dataIntents[selfName_] !== undefined)) {
                    this.ac(a, item_, selfName_);
                }
                let selfName2_ = "self_" + propertyName_;
                if (!b && (item_.__dataIntents[selfName2_] !== undefined)) {
                    this.ac(a, item_, selfName2_);
                }
            }
        }
        ac(a, item_, propertyName_) {
            let val_ = item_.__dataIntents[propertyName_];
            let b = typeCast(Array_$type, val_) !== null;
            if (!b) {
                b = (Array.isArray(val_));
            }
            if (b) {
                let c = val_;
                for (let d = 0; d < c.length; d++) {
                    if (c[d] != null) {
                        a.add(c[d].toString());
                    }
                }
            }
        }
        s(item_, propertyName_) {
            let a = new List$1(String_$type, 0);
            let list_ = this.t;
            let dataIntents_ = null;
            this.ad(a, item_, propertyName_, false);
            this.ad(a, list_, propertyName_, true);
            return a;
        }
        b(item_, propertyName_) {
            if (item_ == null) {
                return 11;
            }
            if ((item_[propertyName_] == undefined)) {
                return 11;
            }
            let value_ = item_[propertyName_];
            return DataSourceLocalDataProvider.c(value_);
        }
        static c(value_) {
            if (value_ == null) {
                return 11;
            }
            if ((typeof value_ == 'number')) {
                return 5;
            }
            if ((typeof value_ == 'boolean')) {
                return 2;
            }
            if ((typeof value_ == 'string')) {
                return 0;
            }
            if ((typeof value_ == 'object')) {
                if ((value_ instanceof Date)) {
                    return 8;
                }
            }
            return 11;
        }
        w() {
            let a = 0;
            if (this.o) {
                a = (this.t.length);
            }
            else {
                a = this.t.count;
            }
            for (let b = 0; b < a; b++) {
                let c;
                if (this.o) {
                    c = this.t[b];
                }
                else {
                    c = this.t.item(b);
                }
                if (c != null) {
                    return c;
                }
            }
            return null;
        }
        ae(a, b, c) {
            this.af(a, b, c);
        }
        get u() {
            return this.t;
        }
        af(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    this.h = null;
                    if (this.dataSource != null) {
                        this.o = false;
                        if (typeCast(Array_$type, this.dataSource) !== null) {
                            this.o = true;
                            this.t = this.dataSource;
                        }
                        else if (typeCast(IList_$type, this.dataSource) !== null) {
                            this.t = this.dataSource;
                        }
                        if (!this.o && this.t == null) {
                            let source_ = this.dataSource;
                            this.o = (Array.isArray(source_));
                            if (this.o) {
                                this.t = this.dataSource;
                            }
                        }
                    }
                    else {
                        this.t = null;
                    }
                    this.ab();
                    break;
                case "DeferAutoRefresh":
                    if (!c) {
                        this.queueAutoRefresh();
                    }
                    break;
            }
        }
        get executionContext() {
            return this.g;
        }
        set executionContext(a) {
            this.g = a;
        }
        get p() {
            return false;
        }
        notifySetItem(a, b, c) {
            if (this.p) {
                if (this.o) {
                    this.t[a] = c;
                }
                else {
                    this.t.item(a, c);
                }
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifySetItem(a, b, c);
            }
        }
        notifyClearItems() {
            if (this.p) {
                if (this.o) {
                    this.t.length = 0;
                }
                else {
                    this.t.clear();
                }
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyClearItems();
            }
        }
        notifyInsertItem(a, b) {
            if (this.p) {
                if (this.o) {
                    this.t.splice(a, 0, b);
                }
                else {
                    this.t.insert(a, b);
                }
            }
            let c = 0;
            if (this.o) {
                c = (this.t.length);
            }
            else {
                c = this.t.count;
            }
            if (this.t != null && c == 1 && (this.actualSchema == null || this.actualSchema.propertyNames.length == 0)) {
                this.h = null;
                this.ab();
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyInsertItem(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (this.p) {
                if (this.o) {
                    this.t.splice(a, 1);
                }
                else {
                    this.t.remove(a);
                }
            }
            if (this.updateNotifier != null) {
                this.updateNotifier.notifyRemoveItem(a, b);
            }
        }
        get updateNotifier() {
            return this.f;
        }
        set updateNotifier(a) {
            this.f = a;
        }
        get deferAutoRefresh() {
            return this.n;
        }
        set deferAutoRefresh(a) {
            let b = this.n;
            this.n = a;
            if (this.n != b) {
                this.ae("DeferAutoRefresh", b, this.n);
            }
        }
        get isSortingSupported() {
            return false;
        }
        get isFilteringSupported() {
            return false;
        }
        get sortDescriptions() {
            return this.k;
        }
        get filterExpressions() {
            return this.e;
        }
        get summaryDescriptions() {
            return this.l;
        }
        get summaryScope() {
            return this.d;
        }
        set summaryScope(a) {
            this.d = a;
        }
        get notifyUsingSourceIndexes() {
            return true;
        }
        get propertiesRequested() {
            return this.a;
        }
        set propertiesRequested(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
            }
        }
        get isItemIndexLookupSupported() {
            return true;
        }
        get isKeyIndexLookupSupported() {
            return false;
        }
        get isGroupingSupported() {
            return false;
        }
        get groupDescriptions() {
            return this.j;
        }
        queueAutoRefresh() {
            if (this.deferAutoRefresh) {
                return;
            }
            if (this.m) {
                return;
            }
            if (this.executionContext != null) {
                this.m = true;
                this.executionContext.enqueueAction(runOn(this, this.aa));
            }
        }
        aa() {
            if (this.deferAutoRefresh) {
                this.m = false;
                return;
            }
            if (!this.m) {
                return;
            }
            this.m = false;
            this.ag();
        }
        ag() {
            this.ah();
        }
        ah() {
        }
        flushAutoRefresh() {
            this.aa();
        }
        refresh() {
            this.ag();
        }
        indexOfItem(a) {
            if (this.t == null) {
                return -1;
            }
            return this.t.indexOf(a);
        }
        indexOfKey(a) {
            return -1;
        }
    }
    DataSourceLocalDataProvider.$t = /*@__PURE__*/ markType(DataSourceLocalDataProvider, 'DataSourceLocalDataProvider', Base.$, [IDataSourceLocalDataProvider_$type]);
    return DataSourceLocalDataProvider;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSeriesAdapter = /*@__PURE__*/ (() => {
    class DataSeriesAdapter extends Base {
        constructor() {
            super();
            this.e = null;
            this.f = new List$1(Delegate_$type, 0);
            this.e = new DataSeriesAdapterImplementation();
            this.e.r = this;
            let a = this.e.dataSeries;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.j));
        }
        j(a, b) {
            for (let c = 0; c < this.f.count; c++) {
                this.f._inner[c](this, this.a());
            }
        }
        get i() {
            return this.e.itemsSource;
        }
        set i(a) {
            this.e.itemsSource = a;
        }
        getDataProvider(a) {
            return ((() => {
                let $ret = new DataSourceLocalDataProvider();
                $ret.dataSource = a;
                return $ret;
            })());
        }
        l(a) {
            this.f.add(a);
        }
        x(a) {
            this.f.remove(a);
        }
        k(a) {
            this.e.dataSeries.add(a);
        }
        v(a) {
            this.e.dataSeries.remove(a);
        }
        w(a) {
            this.e.dataSeries.removeAt(a);
        }
        c(a) {
            return this.e.dataSeries._inner[a];
        }
        a() {
            let a = new Array(this.e.dataSeries.count);
            for (let b = 0; b < this.e.dataSeries.count; b++) {
                a[b] = this.e.dataSeries._inner[b];
            }
            return a;
        }
        n() {
            this.e.dataSeries.clear();
        }
        p(a, b) {
            this.e.dataSeries.insert(a, b);
        }
        g() {
            return this.e.dataSeries.count;
        }
        m(a) {
            this.e.rules.add(a);
        }
        y(a) {
            this.e.rules.remove(a);
        }
        z(a) {
            this.e.rules.removeAt(a);
        }
        d(a) {
            return this.e.rules._inner[a];
        }
        o() {
            this.e.rules.clear();
        }
        q(a, b) {
            this.e.rules.insert(a, b);
        }
        h() {
            return this.e.rules.count;
        }
        b() {
            let a = new Array(this.e.rules.count);
            for (let b = 0; b < this.e.rules.count; b++) {
                a[b] = this.e.rules._inner[b];
            }
            return a;
        }
        r(a) {
            this.e.notifyClearItems(a);
        }
        s(a, b, c) {
            this.e.notifyInsertItem(a, b, c);
        }
        t(a, b, c) {
            this.e.notifyRemoveItem(a, b, c);
        }
        u(a, b, c, d) {
            this.e.notifySetItem(a, b, c, d);
        }
    }
    DataSeriesAdapter.$t = /*@__PURE__*/ markType(DataSeriesAdapter, 'DataSeriesAdapter', Base.$, [IExternalDataSeriesAdapter_$type]);
    return DataSeriesAdapter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates which axis type is suggested in a data series.
 */
var DataSeriesAxisType = /*@__PURE__*/ (function (DataSeriesAxisType) {
    /**
     * Used when a category axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["Category"] = 0] = "Category";
    /**
     * Used when a linear axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["Linear"] = 1] = "Linear";
    /**
     * Used when a logarithmic axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["Logarithmic"] = 2] = "Logarithmic";
    /**
     * Used when a continuous date time axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["ContinuousDateTime"] = 3] = "ContinuousDateTime";
    /**
     * Used when a discrete date time axis type is suggested.
     */
    DataSeriesAxisType[DataSeriesAxisType["DiscreteDateTime"] = 4] = "DiscreteDateTime";
    return DataSeriesAxisType;
})({});
/**
 * @hidden
 */
let DataSeriesAxisType_$type = /*@__PURE__*/ markEnum('DataSeriesAxisType', 'Category,0|Linear,1|Logarithmic,2|ContinuousDateTime,3|DiscreteDateTime,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies which type of marker is suggested for a data series.
 */
var DataSeriesMarker = /*@__PURE__*/ (function (DataSeriesMarker) {
    /**
     * Used when Automatic marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Automatic"] = 0] = "Automatic";
    /**
     * Used when no marker is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["None"] = 1] = "None";
    /**
     * Used when Circle marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Circle"] = 2] = "Circle";
    /**
     * Used when Flat-top triangle marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Triangle"] = 3] = "Triangle";
    /**
     * Used when Flat-base triangle marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Pyramid"] = 4] = "Pyramid";
    /**
     * Used when Square marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Square"] = 5] = "Square";
    /**
     * Used when Diamond marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Diamond"] = 6] = "Diamond";
    /**
     * Used when Pentagon marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Pentagon"] = 7] = "Pentagon";
    /**
     * Used when Hexagon marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Hexagon"] = 8] = "Hexagon";
    /**
     * Used when Four-pointed star marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Tetragram"] = 9] = "Tetragram";
    /**
     * Used when Five-pointed star marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Pentagram"] = 10] = "Pentagram";
    /**
     * Used when Six-pointed star marker shape is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Hexagram"] = 11] = "Hexagram";
    /**
     * Used when a hidden marker is suggested.
     */
    DataSeriesMarker[DataSeriesMarker["Hidden"] = 12] = "Hidden";
    return DataSeriesMarker;
})({});
/**
 * @hidden
 */
let DataSeriesMarker_$type = /*@__PURE__*/ markEnum('DataSeriesMarker', 'Automatic,0|None,1|Circle,2|Triangle,3|Pyramid,4|Square,5|Diamond,6|Pentagon,7|Hexagon,8|Tetragram,9|Pentagram,10|Hexagram,11|Hidden,12');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrDataSeriesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!DataSeries.$type) {
            DataSeries.$type = markType(DataSeries, "DataSeries");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!DataSeries.$type) {
            DataSeries.$type = markType(DataSeries, "DataSeries");
        }
        let coll = new SyncableObservableCollection$2(DataSeries.$type, DataSeries.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleFinancialPriceSeriesRule = /*@__PURE__*/ (() => {
    class SimpleFinancialPriceSeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._distinctCheckThreshold = 0;
            this.priority = 10;
            this.distinctCheckThreshold = 50000;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get distinctCheckThreshold() {
            return this._distinctCheckThreshold;
        }
        set distinctCheckThreshold(a) {
            this._distinctCheckThreshold = a;
        }
        e(a, b) {
            for (let c of fromEnum(b)) {
                if (a.contains(c)) {
                    a.remove(c);
                }
            }
        }
        static d(a, b) {
            let c = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (17)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : a.analyzer.getFirstDateTimeProperty())(a.analyzer.getFirstDistinctDateTimeProperty(b)));
        }
        static b(a, b) {
            let c = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (17)));
            if (c.length > 0) {
                return c[0];
            }
            c = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : (((e) => e != null ? e : (((f) => f != null ? f : a.analyzer.getFirstStringProperty())(a.analyzer.getFirstDistinctMonotonicNumericProperty(b))))(a.analyzer.getFirstDistinctStringProperty(b))))(a.analyzer.getFirstDistinctDateTimeProperty(b)));
        }
        evaluate(a) {
            let b = SimpleFinancialPriceSeriesRule.d(a, this.distinctCheckThreshold);
            let c = SimpleFinancialPriceSeriesRule.b(a, this.distinctCheckThreshold);
            let d = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (11))));
            let e = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (12))));
            let f = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (13))));
            let g = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (14))));
            let h = new List$1(String_$type, 1, a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (15))));
            let i = Math.min(d.count, Math.min(e.count, Math.min(f.count, g.count)));
            if (i == 0) {
                let j = new List$1(String_$type, 1, a.analyzer.getAllNumericProperties());
                for (let k of fromEnum(j)) {
                    if (Base.equalsStatic(k.toLowerCase(), "open")) {
                        d.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "high")) {
                        e.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "low")) {
                        f.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "close")) {
                        g.add(k);
                        continue;
                    }
                    if (Base.equalsStatic(k.toLowerCase(), "volume")) {
                        h.add(k);
                        continue;
                    }
                }
                this.e(j, d);
                this.e(j, e);
                this.e(j, f);
                this.e(j, g);
                this.e(j, h);
                let l = d.count + e.count + f.count + g.count + j.count;
                if (l == 0) {
                    return;
                }
                i = l <= 4 ? 1 : truncate(Math.floor(l / 5));
                let m = [d, e, f, g, h];
                let n = 0;
                while (j.count > 0) {
                    m[n++ % m.length].add(j._inner[0]);
                    j.removeAt(0);
                }
            }
            let o = this.c(a.getCurrentDataSource());
            for (let p = 0; p < i; p++) {
                a.pushParentTitle(i == 1 ? o : o + (p + 1));
                let q = d.count > p ? d._inner[p] : null;
                let r = e.count > p ? e._inner[p] : null;
                let s = f.count > p ? f._inner[p] : null;
                let t = g.count > p ? g._inner[p] : null;
                let u = ((() => {
                    let $ret = new DataSeries();
                    $ret.name = stringJoin("_", ...[q, r, s, t]);
                    $ret.title = a.analyzer.getTitleString(null, [q, r, s, t]);
                    $ret.suggestedSeries = 20;
                    $ret.suggestedPrimaryAxis = 0;
                    $ret.suggestedSecondaryAxis = 1;
                    return $ret;
                })());
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 11;
                    $ret.path = q;
                    return $ret;
                })()));
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 12;
                    $ret.path = r;
                    return $ret;
                })()));
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 13;
                    $ret.path = s;
                    return $ret;
                })()));
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 14;
                    $ret.path = t;
                    return $ret;
                })()));
                if (h.count > p) {
                    u.addMemberPathHint(((() => {
                        let $ret = new DataSeriesMemberPathHint();
                        $ret.intent = 15;
                        $ret.path = h._inner[p];
                        return $ret;
                    })()));
                }
                if (b != null) {
                    u.addMemberPathHint(((() => {
                        let $ret = new DataSeriesMemberPathHint();
                        $ret.intent = 17;
                        $ret.path = b;
                        return $ret;
                    })()));
                }
                u.addMemberPathHint(((() => {
                    let $ret = new DataSeriesMemberPathHint();
                    $ret.intent = 16;
                    $ret.path = c;
                    return $ret;
                })()));
                a.addDataSeries(u, this);
                a.popParentTitle();
            }
        }
        c(a) {
            let b = a == null ? null : a.dataSource;
            if (b == null) {
                return null;
            }
            let c = (typeof b.title === 'function');
            return c ? (b.title()) : (b.title) ? (b.title) : null;
        }
    }
    SimpleFinancialPriceSeriesRule.$t = /*@__PURE__*/ markType(SimpleFinancialPriceSeriesRule, 'SimpleFinancialPriceSeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimpleFinancialPriceSeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleScatterSeriesRule = /*@__PURE__*/ (() => {
    class SimpleScatterSeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._monotonicCheckAmount = 0;
            this.priority = 9;
            this.monotonicCheckAmount = 10000;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get monotonicCheckAmount() {
            return this._monotonicCheckAmount;
        }
        set monotonicCheckAmount(a) {
            this._monotonicCheckAmount = a;
        }
        evaluate(a) {
            let b = a.analyzer.getAllNumericProperties();
            if (b.length == 0) {
                return;
            }
            let c = a.getCurrentDataSource().actualCount;
            let d = new List$1(String_$type, 0);
            for (let e = 0; e < b.length; e++) {
                d.add(b[e]);
            }
            let f = this.c(d);
            let g = this.d(d);
            let h = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (1)));
            let i = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (2)));
            if (h.length > 0 && i.length > 0 && h.length == i.length) {
                f.clear();
                g.clear();
                d.clear();
                for (let j = 0; j < h.length; j++) {
                    f.add(h[j]);
                    g.add(i[j]);
                }
            }
            let k = 0;
            for (k = 0; k < Math.min(f.count, g.count); k++) {
                let l = new Array(2);
                l[0] = f._inner[k];
                l[1] = g._inner[k];
                let m = a.analyzer.getTitleString(null, l);
                this.f(a, f._inner[k], g._inner[k], m);
            }
            for (; k < f.count; k++) {
                d.add(f._inner[k]);
            }
            for (; k < g.count; k++) {
                d.add(g._inner[k]);
            }
            for (let n = 0; n < d.count; n += 2) {
                if (n + 1 >= d.count) {
                    continue;
                }
                let o = new Array(2);
                o[0] = d._inner[n];
                o[1] = d._inner[n + 1];
                let p = a.analyzer.getTitleString(null, o);
                this.f(a, d._inner[n], d._inner[n + 1], p);
            }
        }
        d(a) {
            let b = new List$1(String_$type, 0);
            for (let c = 0; c < a.count; c++) {
                if (this.b(a._inner[c])) {
                    b.add(a._inner[c]);
                    a.removeAt(c);
                    c--;
                }
            }
            return b;
        }
        b(a) {
            if (Base.equalsStatic(a.toLowerCase(), "y") || Base.equalsStatic(a.toLowerCase(), "yvalue")) {
                return true;
            }
            return false;
        }
        c(a) {
            let b = new List$1(String_$type, 0);
            for (let c = 0; c < a.count; c++) {
                if (this.a(a._inner[c])) {
                    b.add(a._inner[c]);
                    a.removeAt(c);
                    c--;
                }
            }
            return b;
        }
        a(a) {
            if (Base.equalsStatic(a.toLowerCase(), "x") || Base.equalsStatic(a.toLowerCase(), "xvalue")) {
                return true;
            }
            return false;
        }
        f(a, b, c, d) {
            let e = new DataSeries();
            e.name = b + "_" + c;
            if (d != null) {
                e.title = d;
            }
            else {
                e.title = b + " - " + c;
                e.title = a.analyzer.expandCamelCasedWords(e.title);
            }
            let f = new DataSeriesMemberPathHint();
            f.intent = 1;
            f.path = b;
            let g = new DataSeriesMemberPathHint();
            g.intent = 2;
            g.path = c;
            e.addMemberPathHint(f);
            e.addMemberPathHint(g);
            let h = a.getCurrentDataSource();
            let i = h.actualCount;
            if (i > this.monotonicCheckAmount) {
                e.suggestedSeries = 11;
            }
            else {
                if (a.analyzer.isMonotonic(h, b, this.monotonicCheckAmount)) {
                    e.suggestedSeries = 12;
                }
                else {
                    e.suggestedSeries = 11;
                }
            }
            e.suggestedPrimaryAxis = 1;
            e.suggestedSecondaryAxis = 1;
            a.addDataSeries(e, this);
        }
    }
    SimpleScatterSeriesRule.$t = /*@__PURE__*/ markType(SimpleScatterSeriesRule, 'SimpleScatterSeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimpleScatterSeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SubCollectionsRule = /*@__PURE__*/ (() => {
    class SubCollectionsRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._collectionTransformationThreshold = 0;
            this.priority = 0;
            this.collectionTransformationThreshold = 50;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get collectionTransformationThreshold() {
            return this._collectionTransformationThreshold;
        }
        set collectionTransformationThreshold(a) {
            this._collectionTransformationThreshold = a;
        }
        evaluate(a) {
            let b = a.getCurrentDataSource();
            if (b == null) {
                return;
            }
            if (b.actualCount == 0 || b.actualCount > this.collectionTransformationThreshold) {
                return;
            }
            let c = b.getItemAtIndex(0);
            if (a.analyzer.isCollection(c)) {
                for (let d = 0; d < b.actualCount; d++) {
                    if (a.analyzer.isCollection(b.getItemAtIndex(d))) {
                        let e = a.analyzer.getTitleString(b.getItemAtIndex(d), null);
                        if (e != null) {
                            a.pushParentTitle(e);
                        }
                        a.recurseRules(b.getItemAtIndex(d), "[" + d + "]", false);
                        if (e != null) {
                            a.popParentTitle();
                        }
                    }
                }
            }
        }
    }
    SubCollectionsRule.$t = /*@__PURE__*/ markType(SubCollectionsRule, 'SubCollectionsRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SubCollectionsRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleCategorySeriesRule = /*@__PURE__*/ (() => {
    class SimpleCategorySeriesRule extends Base {
        constructor() {
            super();
            this._priority = 0;
            this._useColumnThreshold = 0;
            this._distinctCheckThreshold = 0;
            this.priority = 10;
            this.distinctCheckThreshold = 50000;
            this.useColumnThreshold = 30;
        }
        get priority() {
            return this._priority;
        }
        set priority(a) {
            this._priority = a;
        }
        get useColumnThreshold() {
            return this._useColumnThreshold;
        }
        set useColumnThreshold(a) {
            this._useColumnThreshold = a;
        }
        get distinctCheckThreshold() {
            return this._distinctCheckThreshold;
        }
        set distinctCheckThreshold(a) {
            this._distinctCheckThreshold = a;
        }
        static c(a, b) {
            let c = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (16)));
            if (c.length > 0) {
                return c[0];
            }
            return (((d) => d != null ? d : (((e) => e != null ? e : (((f) => f != null ? f : a.analyzer.getFirstStringProperty())(a.analyzer.getFirstDistinctMonotonicNumericProperty(b))))(a.analyzer.getFirstDistinctDateTimeProperty(b))))(a.analyzer.getFirstDistinctStringProperty(b)));
        }
        evaluate(a) {
            let b = SimpleCategorySeriesRule.c(a, this.distinctCheckThreshold);
            let c = null;
            let d = a.analyzer.getAllPropertiesWithIntent(EnumUtil.getName(DataSeriesIntent_$type, (0)));
            if (d.length > 0) {
                c = d;
            }
            if (c == null) {
                c = a.analyzer.getAllNumericProperties();
            }
            if (c == null || c.length == 0) {
                return;
            }
            let e = a.getCurrentDataSource().actualCount;
            for (let f = 0; f < c.length; f++) {
                if (c[f] == b && c.length > 1) {
                    continue;
                }
                let g = new Array(1);
                g[0] = c[f];
                let h = a.analyzer.getTitleString(null, g);
                let i = new DataSeries();
                let j = new DataSeriesMemberPathHint();
                j.intent = 0;
                j.path = c[f];
                let k = new DataSeriesMemberPathHint();
                k.intent = 16;
                k.path = b;
                i.addMemberPathHint(j);
                i.addMemberPathHint(k);
                if (e > this.useColumnThreshold) {
                    i.suggestedSeries = 0;
                }
                else {
                    i.suggestedSeries = 1;
                }
                this.d(i, a);
                i.suggestedPrimaryAxis = 0;
                i.suggestedSecondaryAxis = 1;
                i.name = c[f];
                if (h != null) {
                    i.title = h;
                }
                else {
                    i.title = c[f];
                    i.title = a.analyzer.expandCamelCasedWords(i.title);
                }
                a.addDataSeries(i, this);
            }
        }
        d(a, b) {
            if (!b.hasValidType(a)) {
                a.suggestedSeries = 0;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 1;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 2;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 6;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 7;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 4;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 5;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 10;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 8;
                if (b.hasValidType(a)) {
                    return;
                }
                a.suggestedSeries = 0;
            }
        }
    }
    SimpleCategorySeriesRule.$t = /*@__PURE__*/ markType(SimpleCategorySeriesRule, 'SimpleCategorySeriesRule', Base.$, [IDataSeriesAdapterRule_$type]);
    return SimpleCategorySeriesRule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionData = /*@__PURE__*/ (() => {
    class SectionData extends Base {
        constructor() {
            super(...arguments);
            this.o = false;
            this.ae = 0;
            this.af = 0;
            this.ad = 0;
            this.e = null;
            this.f = null;
            this.i = null;
            this.h = null;
            this.g = null;
            this.aa = 0;
            this.ah = 0;
            this.ag = 0;
            this.t = 0;
            this.d = null;
            this.u = 0;
            this.b = null;
            this.s = -1;
            this.c = null;
            this.a = null;
            this.y = 0;
            this.l = true;
            this.k = null;
        }
        get z() {
            return this.s;
        }
        set z(a) {
            this.s = a;
        }
        get ac() {
            return this.af + this.y + this.ah - this.t;
        }
        get ab() {
            return this.ac + this.d[this.d.length - 1] - 1;
        }
        get p() {
            if (!this.q) {
                return false;
            }
            let a = this.w();
            for (let b = a; b < this.c.length; b++) {
                if (!this.c[b]) {
                    return false;
                }
            }
            return true;
        }
        get q() {
            return this.l;
        }
        set q(a) {
            this.l = a;
        }
        ai(a, b) {
            this.aj(a, b, this.e.length);
        }
        aj(a, b, c) {
            switch (a) {
                case 0:
                    this.c = new Array(1);
                    this.a = new Array(1);
                    break;
                case 1:
                    this.c = new Array(c);
                    this.a = new Array(c);
                    break;
            }
            for (let d = 0; d < this.c.length; d++) {
                this.c[d] = b;
            }
        }
        static r(a) {
            let b = new List$1(Dictionary$2.$.specialize(String_$type, ISummaryResult_$type), 0);
            if (a != null) {
                for (let c = 0; c < a.length; c++) {
                    if (a[c] == null) {
                        continue;
                    }
                    if (b.count == 0) {
                        b.add(new Dictionary$2(String_$type, ISummaryResult_$type, 0));
                    }
                    for (let d = 0; d < b.count; d++) {
                        if (!b._inner[d].containsKey(a[c].propertyName)) {
                            b._inner[d].addItem(a[c].propertyName, a[c]);
                            break;
                        }
                        else if (d == b.count - 1) {
                            b.add(new Dictionary$2(String_$type, ISummaryResult_$type, 0));
                        }
                    }
                }
            }
            return b;
        }
        j(a) {
            let b = this.v();
            if (a >= this.af && a < this.af + b) {
                return 1;
            }
            if (a >= this.af + b && a < this.af + b + this.ah) {
                return 5;
            }
            if (a > this.ad - this.u - this.ag && a <= this.ad - this.u) {
                return 5;
            }
            if (a > this.ad - this.u && a <= this.ad) {
                return 2;
            }
            return 0;
        }
        x(a) {
            let b = this.v();
            let c = -1;
            if (a >= this.af + b && a < this.af + b + this.ah) {
                c = a - (this.af + b);
            }
            if (a > this.ad - this.u - this.ag && a <= this.ad - this.u) {
                c = a - (this.ad - this.u - this.ag + 1);
            }
            return c;
        }
        v() {
            let a = 0;
            if (this.a != null) {
                for (let b = 0; b < this.a.length; b++) {
                    if (this.a[b] != null) {
                        a++;
                    }
                }
            }
            return a;
        }
        w() {
            if (this.a != null) {
                for (let a = 0; a < this.a.length; a++) {
                    if (this.a[a] != null) {
                        return a;
                    }
                }
            }
            return 0;
        }
        m() {
            return this.d[this.d.length - 1] > 0;
        }
        am(a) {
            for (let b = 0; b < this.g.length; b++) {
                if (this.g[b] == null) {
                    continue;
                }
                let c = this.i[b];
                let d = SectionData.r(c);
                for (let e = 0; e < d.count; e++) {
                    let f = new Array(d._inner[e].count);
                    d._inner[e].values.copyTo(f, 0);
                    this.g[b].a[e].summaryResults = f;
                    if (a != null) {
                        a(this.g[b].a[e]);
                    }
                }
            }
        }
        ak(a, b) {
            if (a == null || a.rowType != 5) {
                return;
            }
            if (b < 0 && b >= this.g[a.level - 1].a.length) {
                return;
            }
            this.g[a.level - 1].a[b] = a;
        }
        n() {
            for (let a = 0; a < this.g.length; a++) {
                if (this.g[a] != null) {
                    for (let b = 0; b < this.g[a].a.length; b++) {
                        if (this.g[a].a[b] != null) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        an(a, b, c) {
            c.summaryIndex = b;
            this.i[a][b] = c;
            if (this.o && this.k != null) {
                this.k.i[a][b] = c;
            }
        }
        al(a, b) {
            for (let c = a - 1; c >= 0; c--) {
                if (this.h[c] != -1) {
                    this.h[c] += b;
                }
            }
        }
    }
    SectionData.$t = /*@__PURE__*/ markType(SectionData, 'SectionData');
    return SectionData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionDataStartIndexComparer = /*@__PURE__*/ (() => {
    class SectionDataStartIndexComparer extends Base {
        compare(a, b) {
            return Base.compareSimple(a.af, b.af);
        }
    }
    SectionDataStartIndexComparer.$t = /*@__PURE__*/ markType(SectionDataStartIndexComparer, 'SectionDataStartIndexComparer', Base.$, [/*@__PURE__*/ IComparer$1_$type.specialize(SectionData.$)]);
    return SectionDataStartIndexComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionDataUndisplacedStartIndexComparer = /*@__PURE__*/ (() => {
    class SectionDataUndisplacedStartIndexComparer extends Base {
        compare(a, b) {
            return Base.compareSimple(a.ac, b.af);
        }
    }
    SectionDataUndisplacedStartIndexComparer.$t = /*@__PURE__*/ markType(SectionDataUndisplacedStartIndexComparer, 'SectionDataUndisplacedStartIndexComparer', Base.$, [/*@__PURE__*/ IComparer$1_$type.specialize(SectionData.$)]);
    return SectionDataUndisplacedStartIndexComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionSearchData = /*@__PURE__*/ (() => {
    class SectionSearchData extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = 0;
            this.b = null;
        }
    }
    SectionSearchData.$t = /*@__PURE__*/ markType(SectionSearchData, 'SectionSearchData');
    return SectionSearchData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionMap = /*@__PURE__*/ (() => {
    class SectionMap extends Base {
        constructor() {
            super();
            this.a = new SectionData();
            this.j = new SectionDataStartIndexComparer();
            this.k = new SectionDataUndisplacedStartIndexComparer();
            this.s = new List$1(SectionData.$, 0);
            this.m = new SectionSearchData();
            this.l = new SectionSearchData();
        }
        get t() {
            return this.s;
        }
        get u() {
            return this.s._inner[this.s.count - 1].ad + 1;
        }
        get q() {
            return this.t.count > 0;
        }
        n(a, b, c) {
            if (a >= 0 && a < this.s.count) {
                let d = this.s._inner[a];
                if (b >= d.af && b <= d.ad) {
                    c.c++;
                    if (c.c >= c.a.length) {
                        c.c = 0;
                    }
                    c.b[c.c] = a;
                    c.a[c.c] = d;
                    return true;
                }
            }
            return false;
        }
        o(a, b, c) {
            if (a >= 0 && a < this.s.count) {
                let d = this.s._inner[a];
                if ((b >= d.ac && b <= d.ab) || (!d.p && b >= d.ac)) {
                    c.c++;
                    if (c.c >= c.a.length) {
                        c.c = 0;
                    }
                    c.b[c.c] = a;
                    c.a[c.c] = d;
                    return true;
                }
            }
            return false;
        }
        e(a) {
            return this.f(a, this.j, this.m);
        }
        f(a, b, c) {
            if (c.a == null) {
                c.a = new Array(5);
                c.b = new Array(5);
                for (let d = 0; d < c.a.length; d++) {
                    c.a[d] = null;
                    c.b[d] = -1;
                }
            }
            if (c.a[c.c] != null) {
                if (a >= c.a[c.c].af && a <= c.a[c.c].ad) {
                    return c.a[c.c];
                }
                for (let e = 0; e < c.a.length; e++) {
                    if (c.a[e] != null) {
                        if (a >= c.a[e].af && a <= c.a[e].ad) {
                            c.c = e;
                            return c.a[c.c];
                        }
                    }
                }
                let f = c.b[c.c] + 1;
                if (this.n(f, a, c)) {
                    return c.a[c.c];
                }
                f = c.b[c.c] - 1;
                if (this.n(f, a, c)) {
                    return c.a[c.c];
                }
            }
            this.a.af = a;
            let g = this.s.g(this.a, b);
            if (g < 0) {
                g = ~g;
                g--;
            }
            if (this.n(g, a, c)) {
                return c.a[c.c];
            }
            if (this.n(g + 1, a, c)) {
                return c.a[c.c];
            }
            if (this.n(g - 1, a, c)) {
                return c.a[c.c];
            }
            return null;
        }
        h(a, b, c) {
            if (c.a == null) {
                c.a = new Array(5);
                c.b = new Array(5);
                for (let d = 0; d < c.a.length; d++) {
                    c.a[d] = null;
                    c.b[d] = -1;
                }
            }
            if (c.a[c.c] != null) {
                let e = c.a[c.c];
                if (a >= e.ac && a <= e.ab) {
                    return e;
                }
                for (let f = 0; f < c.a.length; f++) {
                    if (c.a[f] != null) {
                        if (a >= c.a[f].ac && a <= c.a[f].ab) {
                            c.c = f;
                            return c.a[c.c];
                        }
                    }
                }
                let g = c.b[c.c] + 1;
                if (this.o(g, a, c)) {
                    return c.a[c.c];
                }
                g = c.b[c.c] - 1;
                if (this.o(g, a, c)) {
                    return c.a[c.c];
                }
            }
            this.a.af = a;
            let h = this.s.g(this.a, b);
            if (h < 0) {
                h = ~h;
                h--;
            }
            if (this.o(h, a, c)) {
                return c.a[c.c];
            }
            if (this.o(h + 1, a, c)) {
                return c.a[c.c];
            }
            if (this.o(h - 1, a, c)) {
                return c.a[c.c];
            }
            return null;
        }
        v() {
            this.s.clear();
            this.m.a = null;
            this.l.a = null;
        }
        ac(a, b, c) {
            for (let d = a.ae + 1; d < this.s.count; d++) {
                let e = this.s._inner[d];
                e.t += c;
                e.af += b;
                e.ad += b;
                for (let f = 0; f < e.h.length; f++) {
                    if (e.h[f] != -1) {
                        e.h[f] += b;
                    }
                }
            }
        }
        ab(a, b, c) {
            for (let d = a.ae; d < this.s.count; d++) {
                let e = this.s._inner[d];
                e.t += c;
                e.af += b;
                e.ad += b;
                e.ae = d;
                if (e.z > a.ae) {
                    e.z -= 1;
                }
                for (let f = 0; f < e.h.length; f++) {
                    if (e.h[f] != -1) {
                        e.h[f] += b;
                    }
                }
            }
        }
        x(a) {
            if (this.s.count == 0) {
                return;
            }
            let b = this.s._inner[this.s.count - 1];
            b.ad = a;
        }
        i(a, b, c, d, e, f) {
            let g = this.b(b, c, d, e, f);
            g.af = a;
            g.ae = this.s.count;
            if (this.s.count > 0) {
                g.t = this.s._inner[this.s.count - 1].t;
            }
            this.s.add(g);
            return g;
        }
        b(a, b, c, d, e) {
            let f = new SectionData();
            f.e = c;
            f.d = new Array(c.length);
            let g = new Array(c.length);
            for (let h = 0; h < g.length; h++) {
                f.d[h] = 0;
                g[h] = a.getItemProperty(b, c[h]);
            }
            f.f = g;
            f.ai(d, e);
            let i = d == 1 ? c.length : 1;
            f.b = new Array(i);
            f.h = new Array(i);
            f.i = new Array(i);
            for (let j = 0; j < i; j++) {
                f.h[j] = -1;
                f.i[j] = new Array(a.summaryDescriptions.k.count);
            }
            f.g = new Array(c.length);
            return f;
        }
        ad(a, b, c) {
            for (let d = a.ae + 1; d < this.s.count; d++) {
                this.s._inner[d].ae = d;
                this.s._inner[d].t += c;
                this.s._inner[d].af += b;
                this.s._inner[d].ad += b;
                for (let e = 0; e < this.s._inner[d].h.length; e++) {
                    if (this.s._inner[d].h[e] != -1) {
                        this.s._inner[d].h[e] += b;
                    }
                }
            }
        }
        aa(a, b) {
            this.s.insert(a, b);
        }
        ae(a) {
            if (this.m != null) {
                let b = this.m;
                SectionMap.w(a, b);
            }
            if (this.l != null) {
                let c = this.l;
                SectionMap.w(a, c);
            }
            this.s._inner[a].o = true;
            this.s.removeAt(a);
        }
        static w(a, b) {
            if (b.a != null) {
                for (let c = 0; c < b.a.length; c++) {
                    if (b.a[c] != null) {
                        if (b.a[c].ae == a) {
                            b.a[c] = null;
                        }
                    }
                }
            }
        }
        d() {
            return this.s._inner[this.s.count - 1];
        }
        c() {
            return this.s._inner[0];
        }
        y() {
            this.s._inner[this.s.count - 1].t++;
        }
        g(a) {
            return this.h(a, this.k, this.l);
        }
        p(a) {
            for (let b = 0; b < this.t.count; b++) {
                if (b == a.ae) {
                    continue;
                }
                if (this.t._inner[b].z == a.ae) {
                    return true;
                }
            }
            return false;
        }
        z(a, b) {
            if (a.e == null) {
                a.d[0] += b;
                return;
            }
            if (a.z == -1) {
                for (let c = 0; c < a.e.length; c++) {
                    a.d[c] += b;
                }
            }
            else {
                let d = a.w();
                for (let e = a.w(); e < a.e.length; e++) {
                    a.d[e] += b;
                }
                let f = a.z;
                while (f >= 0) {
                    let g = this.t._inner[f];
                    let h = g.w();
                    g.d[h] += b;
                    f = g.z;
                }
            }
        }
        af(a, b) {
            for (let c = 0; c < a.ae; c++) {
                let d = this.s._inner[c];
                for (let e = 0; e < a.e.length; e++) {
                    if (d.a[e] != null && (d.f[e] == a.f[e] || Base.equalsStatic(d.f[e], a.f[e]))) {
                        a.z = c;
                        a.a[e] = null;
                    }
                }
            }
        }
        r(a) {
            let b = a.w();
            if (b == 0) {
                return true;
            }
            let c = this.s._inner[a.z];
            for (let d = b - 1; d >= 0; d--) {
                if (!c.c[d]) {
                    return false;
                }
            }
            return this.r(c);
        }
    }
    SectionMap.$t = /*@__PURE__*/ markType(SectionMap, 'SectionMap');
    return SectionMap;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryGroup = /*@__PURE__*/ (() => {
    class SummaryGroup extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    SummaryGroup.$t = /*@__PURE__*/ markType(SummaryGroup, 'SummaryGroup');
    return SummaryGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RemovedShiftedRowInfo = /*@__PURE__*/ (() => {
    class RemovedShiftedRowInfo extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this._item = null;
        }
        get item() {
            return this._item;
        }
        set item(a) {
            this._item = a;
        }
    }
    RemovedShiftedRowInfo.$t = /*@__PURE__*/ markType(RemovedShiftedRowInfo, 'RemovedShiftedRowInfo');
    return RemovedShiftedRowInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RearrangedListView = /*@__PURE__*/ (() => {
    class RearrangedListView extends Base {
        constructor(a) {
            super();
            this.n = null;
            this.a4 = null;
            this.z = new SectionMap();
            this.e = null;
            this.a = null;
            this.b = null;
            this.c = null;
            this.d = null;
            this.a8 = 0;
            this.a7 = 0;
            this.am = false;
            this.as = false;
            this.o = null;
            this.a0 = null;
            this.az = null;
            this.s = null;
            this.aa = null;
            this.ac = null;
            this.m = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.ap = false;
            this.k = 0;
            this.j = 0;
            this.av = false;
            this.au = false;
            this.aw = false;
            this.ah = false;
            this.a3 = new List$1(Array_$type, 0);
            this.ay = new Dictionary$2(String_$type, Boolean_$type, 0);
            this.n = a;
        }
        get bk() {
            return this.a7;
        }
        get i() {
            return this.e;
        }
        get a6() {
            return this.a4;
        }
        get aq() {
            if (!this.m.isSectionContentVisible) {
                return true;
            }
            return this.m.isSectionCollapsable;
        }
        w(a) {
            return this.z.e(a);
        }
        v() {
            return this.z.d();
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get a2() {
            return this.a0;
        }
        set a2(a) {
            this.a0 = a;
        }
        get a1() {
            return this.az;
        }
        set a1(a) {
            this.az = a;
        }
        get t() {
            return this.s;
        }
        set t(a) {
            this.s = a;
        }
        get ab() {
            return this.aa;
        }
        set ab(a) {
            this.aa = a;
        }
        get ad() {
            return this.ac;
        }
        set ad(a) {
            this.ac = a;
        }
        get l() {
            return this.k;
        }
        set l(a) {
            this.k = a;
        }
        get ar() {
            if (!this.m.isSectionContentVisible) {
                return false;
            }
            if (this.aq) {
                return this.m.isSectionExpandedDefault;
            }
            return true;
        }
        b6() {
            if (this.a4 == this.n || this.a4 == null) {
                this.a4 = new List$1(Base.$, 0);
            }
            this.a4.clear();
            if (!this.aq) {
                this.ay.clear();
            }
            if (this.n == null) {
                return;
            }
            let a = this.n.actualCount;
            this.a7 = 0;
            this.a8 = this.ba();
            this.br(null);
            let b = this.ag.k.count > 0 && this.l != 2 && this.l != 3;
            if (this.s == null) {
                for (let c = 0; c < a; c++) {
                    let d = this.n.getItemAtIndex(c);
                    this.a4.add1(d);
                    if (b) {
                        this.bq(null, d);
                    }
                }
            }
            else {
                for (let e = 0; e < a; e++) {
                    let f = this.n.getItemAtIndex(e);
                    if (this.s(f)) {
                        this.a4.add1(f);
                        if (b) {
                            this.bq(null, f);
                        }
                    }
                }
            }
            this.bu(null);
            if (this.a0 != null) {
                this.a4.z(this.a0);
            }
            this.ah = false;
            this.z.v();
            if (this.ae != null && this.ae.k.count > 0) {
                this.ah = true;
                this.b1();
            }
            else {
                this.z.t.add(((() => {
                    let $ret = new SectionData();
                    $ret.ae = 0;
                    $ret.e = null;
                    $ret.f = null;
                    $ret.af = 0;
                    $ret.ad = this.a4.count;
                    $ret.c = new Array(0);
                    $ret.d = new Array(1);
                    return $ret;
                })()));
            }
            if (b) {
                this.bw(this.e);
            }
            let g = this.p;
            let h = new List$1(Base.$, 0);
            if (this.a3.count > 0 && this.aw) {
                if (!this.ah) {
                    let i = this.z.t._inner[0];
                    for (let j = 0; j < this.a3.count; j++) {
                        let k = this.m.indexOfKey(this.a3._inner[j]);
                        if (k != -1) {
                            this.bj(i, this.a4._inner[k], j);
                        }
                    }
                }
                else {
                    for (let l = 0; l < this.a3.count; l++) {
                        let m = this.m.indexOfKey(this.a3._inner[l]);
                        if (m != -1) {
                            let n = this.z.e(m);
                            this.bj(n, this.a4._inner[m], l);
                        }
                    }
                }
            }
            if (this.ab != null) {
                this.ab.notifyClearItems();
            }
        }
        bl(a, b) {
            let c = null;
            if (a.p) {
                if (b) {
                    let d = a.af + a.v() + a.ah + a.aa;
                    c = this.a4._inner[d];
                }
                else {
                    let e = a.ad - a.u - a.ag;
                    c = this.a4._inner[e];
                }
            }
            return c;
        }
        get a5() {
            return this.z.t;
        }
        b1() {
            if (this.a4.count == 0) {
                return;
            }
            let a = dateNow();
            let b = this.f();
            let c = this.g();
            let d = this.j == 1 ? c.length : 1;
            if (this.b == null || this.b.length != c.length) {
                this.a = new Array(d);
                this.b = new Array(d);
            }
            this.c = new Array(d);
            for (let e = 0; e < d; e++) {
                this.c[e] = new Array(this.ag.k.count);
            }
            let f = this.l == 3 || this.l == 1;
            let g = new List$1(Base.$, 0);
            let h = null;
            let i = null;
            if (this.m.isSectionContentVisible || !this.av) {
                for (let j = 0; j < this.a4.count; j++) {
                    let k = this.a4._inner[j];
                    if (k == null) {
                        continue;
                    }
                    if (h == null) {
                        let l = this.x(j, k, c);
                        j += this.bc(l, j, b, c, true);
                        this.bs(l, true, f);
                        this.z.z(l, 1);
                        this.bq(l, k);
                        i = k;
                    }
                    else {
                        if (this.a1.compare(h, k) != 0) {
                            let m = this.z.t._inner[this.z.t.count - 1];
                            if (m.q) {
                                j += this.bb(j, i, b, c);
                            }
                            this.bt(j - 1, i, b);
                            let n = this.x(j, k, c);
                            this.bs(n, false, f);
                            let o = this.bc(n, j, b, c, true);
                            j += o;
                            n.q = this.z.r(n);
                            this.z.z(n, 1);
                            this.bq(n, k);
                            i = k;
                        }
                        else {
                            let p = this.z.t._inner[this.z.t.count - 1];
                            this.z.z(p, 1);
                            this.bq(p, k);
                        }
                    }
                    if (j == this.a4.count - 1) {
                        let q = this.z.t._inner[this.z.t.count - 1];
                        if (q.q) {
                            j += this.bb(j + 1, i, b, c);
                        }
                        this.bt(j, i, b);
                    }
                    h = k;
                }
                if (!f) {
                    if (this.j == 1) {
                        for (let r = 0; r < c.length; r++) {
                            for (let s = 0; s < this.ag.k.count; s++) {
                                this.b[r].i[r][s] = this.c[r][s].endCalculation();
                                this.b[r].i[r][s].summaryIndex = s;
                            }
                            for (let t = 0; t < this.b[r].h.length; t++) {
                                if (this.b[r].h[t] == -1) {
                                    this.b[r].h[t] = this.z.t._inner[this.z.t.count - 1].ad + 1;
                                }
                            }
                        }
                    }
                    else {
                        for (let u = 0; u < this.ag.k.count; u++) {
                            this.b[0].i[0][u] = this.c[0][u].endCalculation();
                            this.b[0].i[0][u].summaryIndex = u;
                        }
                        this.b[0].h[0] = this.z.t._inner[this.z.t.count - 1].ad + 1;
                    }
                }
                this.bx();
                for (let v = 0; v < this.z.t.count; v++) {
                    let w = this.z.t._inner[v];
                    if (this.av) {
                        if (!w.q) {
                            let x = w.ad - w.af + 1;
                            if (this.j == 1 && this.ae.k.count > 1 && this.am && this.as) {
                                let y = w.w();
                                let z = false;
                                if (v + 1 < this.z.t.count && this.z.t._inner[v + 1].w() == 0) {
                                    z = true;
                                }
                                if (z) {
                                    let aa = w.v();
                                    x = aa + w.d[w.d.length - 1];
                                }
                            }
                            this.a4.v(w.af, x);
                            this.z.ae(w.ae);
                            this.z.ab(w, -x, -x);
                            v--;
                        }
                        else if (!w.p) {
                            let ab = 0;
                            let ac = w.w();
                            for (let ad = ac; ad < w.c.length; ad++) {
                                ab = w.b[ad];
                                if (!w.c[ad]) {
                                    break;
                                }
                            }
                            let ae = w.af + ab + 1;
                            let af = w.d[w.d.length - 1];
                            this.a4.v(ae, af);
                            w.ad -= af;
                            this.z.ac(w, -af, -af);
                        }
                    }
                }
            }
            else {
                for (let ag = 0; ag < this.a4.count; ag++) {
                    let ah = this.a4._inner[ag];
                    if (ah == null) {
                        continue;
                    }
                    if (h == null) {
                        let ai = this.x(ag, ah, c);
                        this.bd(g, ai, ah, b, c, true);
                        this.bs(ai, true, f);
                        this.z.z(ai, 1);
                        this.bq(ai, ah);
                        i = ah;
                    }
                    else {
                        if (this.a1.compare(h, ah) != 0) {
                            let aj = this.z.t._inner[this.z.t.count - 1];
                            this.bt(g.count - 1, i, b);
                            let ak = this.x(ag, ah, c);
                            this.bs(ak, false, f);
                            this.bd(g, ak, ah, b, c, true);
                            ak.q = this.z.r(ak);
                            this.z.z(ak, 1);
                            this.bq(ak, ah);
                            i = ah;
                        }
                        else {
                            let al = this.z.t._inner[this.z.t.count - 1];
                            this.z.z(al, 1);
                            this.bq(al, ah);
                        }
                    }
                    if (ag == this.a4.count - 1) {
                        let am = this.z.t._inner[this.z.t.count - 1];
                        this.bt(ag, i, b);
                    }
                    h = ah;
                }
                this.a4 = g;
            }
            for (let an = 0; an < this.b.length; an++) {
                this.a[an] = null;
                this.b[an] = null;
            }
            this.c = null;
            let ao = dateNow();
        }
        bs(a, b, c) {
            if (b) {
                for (let d = 0; d < this.b.length; d++) {
                    this.b[d] = a;
                    if (!c) {
                        for (let e = 0; e < this.ag.k.count; e++) {
                            let f = this.ag.k.item(e);
                            this.c[d][e] = f.d();
                            this.c[d][e].beginCalculation(this.m, f.propertyName);
                        }
                    }
                }
            }
            if (this.j == 1) {
                let g = false;
                let h = a.e.length;
                for (let i = 0; i < h; i++) {
                    if (g) {
                        if (!c) {
                            for (let j = 0; j < this.ag.k.count; j++) {
                                this.b[i].i[i][j] = this.c[i][j].endCalculation();
                                this.b[i].i[i][j].summaryIndex = j;
                                this.c[i][j].beginCalculation(this.m, this.ag.k.item(j).propertyName);
                            }
                            this.b[i].h[i] = a.af;
                        }
                        this.b[i] = a;
                        continue;
                    }
                    let k = false;
                    if (this.b[i].f[i] == null) {
                        k = a.f[i] != null;
                    }
                    else {
                        k = !Base.equalsStatic(this.b[i].f[i], a.f[i]);
                    }
                    if (k) {
                        if (!c) {
                            for (let l = 0; l < this.ag.k.count; l++) {
                                this.b[i].i[i][l] = this.c[i][l].endCalculation();
                                this.b[i].i[i][l].summaryIndex = l;
                                this.c[i][l].beginCalculation(this.m, this.ag.k.item(l).propertyName);
                            }
                            this.b[i].h[i] = a.af;
                        }
                        this.b[i] = a;
                        if (i - 1 > -1) {
                            let m = i - 1;
                            while (m >= 0 && this.b[m].o) {
                                m = m - 1;
                            }
                            a.z = this.b[m].ae;
                        }
                        g = true;
                    }
                }
            }
            else {
                let n = false;
                for (let o = 0; o < a.e.length; o++) {
                    if (this.b[0].f[o] == null) {
                        if (this.b[0].f[o] != a.f[o]) {
                            n = true;
                            break;
                        }
                        continue;
                    }
                    if (!Base.equalsStatic(this.b[0].f[o], a.f[o])) {
                        n = true;
                        break;
                    }
                }
                if (n) {
                    if (!c) {
                        for (let p = 0; p < this.ag.k.count; p++) {
                            this.b[0].i[0][p] = this.c[0][p].endCalculation();
                            this.b[0].i[0][p].summaryIndex = p;
                            this.c[0][p].beginCalculation(this.m, this.ag.k.item(p).propertyName);
                        }
                        this.b[0].h[0] = a.af;
                    }
                    this.b[0] = a;
                }
            }
        }
        ba() {
            let a = 0;
            let b = new Dictionary$2(String_$type, Number_$type, 0);
            for (let c = 0; c < this.ag.k.count; c++) {
                let d = this.ag.k.item(c).propertyName;
                if (!b.containsKey(d)) {
                    b.addItem(d, 1);
                }
                else {
                    b.item(d, b.item(d) + 1);
                }
                if (b.item(d) > a) {
                    a = b.item(d);
                }
            }
            return a;
        }
        bd(a, b, c, d, e, f) {
            let g = 0;
            if (this.av) {
                if (this.m.sectionHeaderDisplayMode == 0) {
                    if (this.an(a, 0, c, d, e, f)) {
                        this.z.y();
                        g++;
                        if (b != null) {
                            let h = this.bm(b);
                            b.a[0] = h;
                            b.c[0] = this.al(h);
                            b.b[0] = (a.count - 1) - b.af;
                        }
                    }
                }
                else if (this.m.sectionHeaderDisplayMode == 1) {
                    for (let i = 0, j = 0; i < e.length; i++) {
                        let k = a.count + j;
                        if (this.an(a, i, c, d, [e[i]], f)) {
                            g++;
                            this.z.y();
                            if (b != null) {
                                let l = this.bn(b, i);
                                b.a[i] = l;
                                b.c[i] = this.al(l);
                                b.b[i] = k - b.af;
                                if (!b.c[i]) {
                                    break;
                                }
                            }
                            else if (!this.ar) {
                                break;
                            }
                            j++;
                        }
                    }
                }
            }
            return g;
        }
        bc(a, b, c, d, e) {
            let f = 0;
            if (this.av) {
                let g = this.a4._inner[b];
                if (this.m.sectionHeaderDisplayMode == 0) {
                    if (this.ao(b, 0, g, c, d, e)) {
                        this.z.y();
                        f++;
                        if (a != null) {
                            let h = this.bm(a);
                            a.a[0] = h;
                            a.c[0] = this.al(h);
                            a.b[0] = b - a.af;
                        }
                    }
                }
                else if (this.m.sectionHeaderDisplayMode == 1) {
                    for (let i = 0, j = 0; i < d.length; i++) {
                        let k = b + j;
                        if (this.ao(k, i, g, c, [d[i]], e)) {
                            f++;
                            this.z.y();
                            if (a != null) {
                                let l = this.bn(a, i);
                                a.a[i] = l;
                                a.c[i] = this.al(l);
                                a.b[i] = k - a.af;
                                if (!a.c[i]) {
                                    break;
                                }
                            }
                            else if (!this.ar) {
                                break;
                            }
                            j++;
                        }
                    }
                }
            }
            return f;
        }
        ao(a, b, c, d, e, f) {
            let g = new DataSourceSpecialRow();
            g.level = b;
            for (let h = 0; h < d.length; h++) {
                g.setValue(d[h], this.m.getItemProperty(c, d[h]));
                if (h < e.length) {
                    g.setSectionValue(e[h], this.m.getItemProperty(c, e[h]));
                }
            }
            g.rowType = 1;
            g.summaryResults = new Array(this.ag.k.count);
            if (f && this.a != null) {
                if (this.a[b] != null) {
                    if (this.a[b].l(g)) {
                        return false;
                    }
                    else {
                        this.a[b] = g;
                        for (let i = b + 1; i < this.a.length; i++) {
                            this.a[i] = null;
                        }
                    }
                }
                else {
                    this.a[b] = g;
                }
            }
            this.a4.insert1(a, g);
            return true;
        }
        an(a, b, c, d, e, f) {
            let g = new DataSourceSpecialRow();
            g.level = b;
            for (let h = 0; h < d.length; h++) {
                g.setValue(d[h], this.m.getItemProperty(c, d[h]));
                if (h < e.length) {
                    g.setSectionValue(e[h], this.m.getItemProperty(c, e[h]));
                }
            }
            g.rowType = 1;
            g.summaryResults = new Array(this.ag.k.count);
            if (f && this.a != null) {
                if (this.a[b] != null) {
                    if (this.a[b].l(g)) {
                        return false;
                    }
                    else {
                        this.a[b] = g;
                        for (let i = b + 1; i < this.a.length; i++) {
                            this.a[i] = null;
                        }
                    }
                }
                else {
                    this.a[b] = g;
                }
            }
            a.add1(g);
            return true;
        }
        bb(a, b, c, d) {
            let e = 0;
            if (this.au) {
                if (this.m.sectionHeaderDisplayMode == 0) {
                    this.bv(a, 0, b, c, d);
                    e++;
                }
                else if (this.m.sectionHeaderDisplayMode == 1) {
                    for (let f = d.length - 1; f >= 0; f--) {
                        if (this.z.t._inner[this.z.t.count - 1].c[f]) {
                            this.bv(a, f, b, c, [d[f]]);
                            a++;
                            e++;
                        }
                    }
                }
            }
            return e;
        }
        bv(a, b, c, d, e) {
            let f = new DataSourceSpecialRow();
            f.level = b;
            for (let g = 0; g < d.length; g++) {
                f.setValue(d[g], this.m.getItemProperty(c, d[g]));
                if (g < e.length) {
                    f.setSectionValue(e[g], this.m.getItemProperty(c, e[g]));
                }
            }
            f.rowType = 2;
            this.a4.insert1(a, f);
        }
        q(a, b, c) {
            let d = this.r(b, 0, c, 5);
            if (this.as) {
                a.ag++;
            }
            else {
                a.ah++;
            }
            a.ad++;
            this.z.ac(a, 1, 1);
            return d;
        }
        r(a, b, c, d) {
            let e = ((() => {
                let $ret = new DataSourceSpecialRow();
                $ret.level = b;
                $ret.rowType = d;
                $ret.summaryResults = c;
                return $ret;
            })());
            this.a4.insert1(a, e);
            return e;
        }
        bf(a, b, c) {
            let d = a.v();
            let e = a.af + a.ah + a.aa;
            if (this.av) {
                e += d;
            }
            this.bh(e, a.c.length, b);
            a.aa++;
            a.ad++;
            a.t++;
            if (c) {
                this.z.ac(a, 1, 1);
            }
            return e;
        }
        bg(a, b, c) {
            let d = a.v();
            if (this.av) {
                b += d;
            }
            this.bh(b, a.c.length, c);
            a.aa++;
            a.ad++;
            a.t++;
            this.z.ac(a, 1, 1);
            return b;
        }
        bh(a, b, c) {
            let d = new DataSourceSpecialRow();
            d.rowType = 3;
            d.targetRow = c;
            d.level = b;
            this.a4.insert1(a, d);
            return a + 1;
        }
        bi(a, b) {
            let c = -1;
            for (let d = 0; d < this.a3.count; d++) {
                if (this.p.i(b, this.a3._inner[d]) == 0) {
                    c = d;
                    break;
                }
            }
            return this.bj(a, b, c);
        }
        bj(a, b, c) {
            let d = -1;
            if (c != -1) {
                let e = a.af;
                let f = e + a.aa;
                let g = false;
                for (let h = e; h < f; h++) {
                    let i = this.av ? h + 1 : h;
                    let j = typeCast(DataSourceSpecialRow.$, this.a4._inner[i]);
                    if (j.targetRow != null) {
                        if (this.a0 != null) {
                            let k = this.a0.compare(b, j.targetRow);
                            if (k == 0 || k < 0) {
                                d = this.bg(a, h, b);
                                g = true;
                                break;
                            }
                        }
                        else {
                            let l = -1;
                            for (let m = 0; m < this.a3.count; m++) {
                                if (this.p.i(j.targetRow, this.a3._inner[m]) == 0) {
                                    l = m;
                                    break;
                                }
                            }
                            if (l > c) {
                                d = this.bg(a, h, b);
                                g = true;
                                break;
                            }
                        }
                    }
                }
                if (!g) {
                    d = this.bf(a, b, true);
                    g = true;
                }
            }
            return d;
        }
        bw(a) {
            let b = SectionData.r(a);
            this.a7 = b.count;
            for (let c = 0; c < b.count; c++) {
                let d = new Array(b._inner[c].count);
                b._inner[c].values.copyTo(d, 0);
                this.r(this.a4.count, 0, d, 4);
            }
        }
        bx() {
            if (this.l == 0 || this.l == 2) {
                for (let a = 0; a < this.z.t.count; a++) {
                    let b = this.z.t._inner[a];
                    if (!b.q) {
                        continue;
                    }
                    if (this.am) {
                        if (this.as) {
                            this.by(b, false);
                        }
                        else {
                            this.bz(b, false);
                        }
                    }
                    else {
                        for (let c = 0; c < b.i.length; c++) {
                            let d = this.a4._inner[b.af + b.b[c]];
                            if (d != null) {
                                d.summaryResults = b.i[c];
                            }
                            if (!b.c[c]) {
                                break;
                            }
                        }
                    }
                }
            }
        }
        bz(a, b) {
            let c = 0;
            let d = this.bl(a, !this.as);
            for (let e = 0; e < a.i.length; e++) {
                if (a.a[e] == null || !a.c[e]) {
                    continue;
                }
                let f = SectionData.r(a.i[e]);
                if (this.av) {
                    c += 1;
                }
                a.g[e] = new SummaryGroup();
                a.g[e].a = new Array(this.a8);
                for (let g = 0; g < f.count; g++) {
                    let h = new Array(f._inner[g].count);
                    f._inner[g].values.copyTo(h, 0);
                    let i = a.af + c + g;
                    let j = this.r(i, e + 1, h, 5);
                    a.ak(j, g);
                    for (let k = e + 1; k < a.b.length; k++) {
                        a.b[k]++;
                    }
                    a.ad++;
                    a.ah++;
                    this.z.ad(a, 1, 1);
                    if (d != null) {
                        let l = this.f();
                        for (let m = 0; m < l.length; m++) {
                            j.setValue(l[m], this.m.getItemProperty(d, l[m]));
                        }
                    }
                    if (b && this.ab != null) {
                        this.ab.notifyInsertItem(i, j);
                    }
                }
                c += f.count;
            }
        }
        be(a, b, c) {
            let d = a.h[b];
            let e = SectionData.r(a.i[b]);
            for (let f = 0; f < e.count; f++) {
                let g = new Array(e._inner[f].count);
                e._inner[f].values.copyTo(g, 0);
                let h = this.z.e(d - 1);
                let i = this.r(d + f, b + 1, g, 5);
                a.ak(i, f);
                h.ad++;
                h.ag++;
                this.z.ac(h, 1, 1);
                let j = null;
                let k = 0;
                for (let l = d + f - 1; l >= 0; l--) {
                    let m = this.m.getRowType(l);
                    if (m == 0 || m == 1) {
                        j = this.a4._inner[l];
                        k = m;
                        break;
                    }
                }
                if (j != null) {
                    let n = this.f();
                    if (k == 1) {
                        let o = typeCast(DataSourceSpecialRow.$, j);
                        for (let p = 0; p < n.length; p++) {
                            i.setValue(n[p], o.getValue(n[p]));
                        }
                    }
                    else {
                        for (let q = 0; q < n.length; q++) {
                            i.setValue(n[q], this.m.getItemProperty(j, n[q]));
                        }
                    }
                }
                if (c && this.ab != null) {
                    this.ab.notifyInsertItem(d + f, i);
                }
            }
            return e.count;
        }
        by(a, b) {
            for (let c = 0; c < a.i.length; c++) {
                if (!a.c[c]) {
                    break;
                }
                if (a.h[c] == -1) {
                    continue;
                }
                a.g[c] = new SummaryGroup();
                a.g[c].a = new Array(this.a8);
                let d = this.be(a, c, b);
            }
        }
        f() {
            let a = new Array(this.ae.k.count + this.af.k.count);
            let b = 0;
            for (let c = 0; c < this.ae.k.count; c++) {
                a[b] = this.ae.k.item(c).propertyName;
                b++;
            }
            for (let d = 0; d < this.af.k.count; d++) {
                a[b] = this.af.k.item(d).propertyName;
                b++;
            }
            return a;
        }
        g() {
            let a = new Array(this.ae.k.count);
            let b = 0;
            for (let c = 0; c < this.ae.k.count; c++) {
                a[b] = this.ae.k.item(c).propertyName;
                b++;
            }
            return a;
        }
        bt(a, b, c) {
            this.z.x(a);
        }
        x(a, b, c) {
            return this.z.i(a, this.m, b, c, this.m.sectionHeaderDisplayMode, this.ar);
        }
        cb(a) {
            this.a3 = new List$1(Array_$type, 0);
            for (let b = 0; b < a.count; b++) {
                this.a3.add(a._inner[b]);
            }
        }
        b2() {
            this.a4.clear();
            if (this.ab != null) {
                this.ab.notifyClearItems();
            }
        }
        notifySetItem(a, b, c) {
            if (this.a0 != null) {
                this.b8(b);
                this.bo(c);
            }
            else {
                this.b9(a, b);
                this.bp(a, c);
            }
        }
        bp(a, b) {
            if (!this.ax(b)) {
                return;
            }
            let c = this.a9(a);
            this.b3(c, b);
        }
        b3(a, b) {
            this.b0(a, b);
            this.ce(a, b);
            this.cj(a, b);
        }
        b0(a, b) {
            if (this.ah) {
                let c = this.z.e(a);
                if (c == null) {
                    c = this.z.d();
                }
                let d = c.v();
                let e = true;
                if (a >= c.af && a <= c.af + (d - 1) + c.ah + c.aa) {
                    if (!this.ai(c, b, this.a4._inner[c.af])) {
                        c = this.z.e(c.af - 1);
                        if (c == null) {
                            c = this.z.c();
                            c.af++;
                        }
                        e = false;
                    }
                    else {
                        a = c.af + d + c.ah + c.aa;
                    }
                }
                if (e && !c.p) {
                    return;
                }
                c.ad++;
                this.z.ac(c, 1, 0);
                if (this.ai(c, b, this.a4._inner[c.af])) {
                    if (!c.p) {
                        c.ad--;
                        this.z.ac(c, -1, 0);
                        return;
                    }
                    if (a >= c.ad - c.u - c.ag && a <= c.ad) {
                        a = c.ad - c.u - c.ag;
                    }
                }
            }
            this.a4.insert1(a, b);
            if (this.ab != null) {
                this.ab.notifyInsertItem(a, b);
            }
        }
        ce(a, b) {
            let c = null;
            if (this.ah) {
                c = this.z.e(a);
            }
            else {
                c = this.z.t._inner[0];
            }
            if (c == null) {
                if (this.ah && a == 0) {
                    c = this.z.c();
                }
                else {
                    c = this.z.d();
                }
            }
            if (this.ai(c, b, this.a4._inner[c.af])) {
                this.z.z(c, 1);
                if (this.aw && c.p) {
                    let d = this.bi(c, b);
                    if (d != -1 && this.ab != null) {
                        this.ab.notifyInsertItem(d, this.a4._inner[d]);
                    }
                }
            }
            else {
                let e = this.z.e(a - 1);
                if (e != null && this.ai(e, b, this.a4._inner[e.af])) {
                    this.z.z(e, 1);
                    if (this.aw && e.p) {
                        let f = this.bi(e, b);
                        if (f != -1 && this.ab != null) {
                            this.ab.notifyInsertItem(f, this.a4._inner[f]);
                        }
                    }
                }
                else {
                    let g = false;
                    if (a <= c.af) {
                        g = true;
                    }
                    let h = 0;
                    let i = null;
                    let j = null;
                    let k = this.f();
                    let l = this.g();
                    let m = this.z.b(this.m, b, l, this.j, this.ar);
                    m.af = a;
                    m.ad = a;
                    m.ae = g ? c.ae : c.ae + 1;
                    this.z.af(m, g);
                    for (let n = 0; n < c.f.length; n++) {
                        if (Base.equalsStatic(c.f[n], m.f[n]) && !c.c[n]) {
                            this.z.z(c, 1);
                            return;
                        }
                    }
                    this.z.aa(m.ae, m);
                    if (this.av) {
                        let o = this.bc(m, a, k, l, false);
                        m.ad += o;
                        h += o;
                        i = this.a4._inner[a];
                        if (!g) {
                            c.ad--;
                        }
                    }
                    if (m.p) {
                        if (this.aw) {
                            for (let p = 0; p < this.a3.count; p++) {
                                if (this.p.i(b, this.a3._inner[p]) == 0) {
                                    this.bf(m, b, false);
                                    h++;
                                    break;
                                }
                            }
                        }
                    }
                    else {
                        this.a4.removeAt(a + h);
                        m.ad--;
                        h--;
                    }
                    if (this.au) {
                        let q = this.bb(a + (h - 1), b, k, l);
                        if (q > 1) {
                            m.ad += q;
                        }
                        h += q;
                        j = this.a4._inner[a + (h - 1)];
                    }
                    this.z.ad(m, h, h);
                    this.b7(m);
                    if (m.p) {
                        this.z.z(m, 1);
                    }
                    if (this.ab != null) {
                        if (i != null) {
                            this.ab.notifyInsertItem(a, i);
                        }
                        if (j != null) {
                            this.ab.notifyInsertItem(a + (h - 1), j);
                        }
                    }
                }
            }
        }
        cm(a) {
            let b = this.a4.indexOf1(a);
            if (b >= 0) {
                let c = this.a4._inner[b - 1];
                let d = typeCast(DataSourceSpecialRow.$, c);
                let e = this.f();
                for (let f = 0; f < e.length; f++) {
                    if (d == null) {
                        a.setValue(e[f], this.m.getItemProperty(c, e[f]));
                    }
                    else {
                        a.setValue(e[f], d.getValue(e[f]));
                    }
                }
            }
        }
        b7(a) {
            let b = false;
            let c = false;
            if (a.ae > 0) {
                let d = this.z.t._inner[a.ae - 1];
                let e = 0;
                for (let f = 0, g = 0; f < a.e.length; f++, g++) {
                    if (!b && Base.equalsStatic(d.f[f], a.f[f])) {
                        this.a4.removeAt(a.af + g);
                        a.ad--;
                        this.z.ac(a, -1, -1);
                        if (this.am && (this.l == 2 || this.l == 0)) {
                            for (let h = 0; h < this.a8; h++) {
                                let i = typeCast(DataSourceSpecialRow.$, this.a4._inner[a.af - 1]);
                                if (i != null && i.rowType == 5 && i.level == f + 1) {
                                    this.a4.removeAt(a.af - 1);
                                    d.ad--;
                                    this.z.ac(d, -1, -1);
                                    this.a4.insert1(a.ad + 1, i);
                                    e++;
                                    this.cm(i);
                                }
                            }
                        }
                        a.a[f] = null;
                        a.b[f] = 0;
                        a.c[f] = true;
                        if (d.a[f] != null) {
                            a.z = d.ae;
                        }
                        g--;
                        c = true;
                    }
                    else {
                        b = true;
                        a.b[f] = g;
                        if (e > 0) {
                            a.ad += e;
                            this.z.ac(a, e, e);
                            a.h[f] = a.ad - (e - 1);
                        }
                        else {
                            a.h[f] = a.ad + 1;
                        }
                    }
                }
                if (a.z == -1 && c) {
                    a.z = d.z;
                }
            }
            if (a.ae < this.z.t.count - 1) {
                b = false;
                c = false;
                let j = this.z.t._inner[a.ae + 1];
                for (let k = 0, l = 0; k < a.e.length; k++, l++) {
                    if (!b && Base.equalsStatic(j.f[k], a.f[k])) {
                        if (j.a[k] != null) {
                            this.a4.removeAt(j.af + l);
                            j.ad--;
                            this.z.ac(j, -1, -1);
                            a.al(k, -1);
                            a.i[k] = j.i[k];
                            a.d[k] = j.d[k];
                            if (this.am && (this.l == 2 || this.l == 0)) {
                                let m = j.g[k].a[0];
                                let n = this.a4.indexOf1(m);
                                a.h[k] = n;
                                let o = this.z.e(n);
                                let p = j.g[k].a.length;
                                for (let q = 0; q < p; q++) {
                                    j.g[k].a[q] = null;
                                    this.a4.removeAt(n);
                                    o.ad--;
                                    if (this.as) {
                                        o.ag--;
                                    }
                                    else {
                                        o.ah--;
                                    }
                                }
                                this.z.ac(o, -p, -p);
                                a.al(k, -p);
                            }
                            j.h[k] = -1;
                            j.d[k] = 0;
                            j.i[k] = null;
                            j.g[k] = null;
                            j.a[k] = null;
                            j.b[k] = 0;
                            j.c[k] = true;
                            c = true;
                        }
                        l--;
                    }
                    else {
                        b = true;
                        j.b[k] = l;
                        if (a.a[k] != null && a.h[k] == -1) {
                            a.h[k] = a.ad + 1;
                        }
                    }
                }
            }
        }
        ai(a, b, c) {
            if (this.ae.k.count == 0) {
                return true;
            }
            if (this.a1.compare(b, c) == 0) {
                return true;
            }
            return false;
        }
        h(a, b) {
            let c = new Array(a.length);
            for (let d = 0; d < c.length; d++) {
                c[d] = this.m.getItemProperty(b, a[d]);
            }
            return c;
        }
        at(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null && b != null) {
                return false;
            }
            if (a != null && b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        a9(a) {
            if (this.ae.k.count == 0 && this.a3.count == 0 && this.s == null && this.n.actualCount == this.a4.count) {
                return a;
            }
            let b = 0;
            let c = 0;
            let d = this.a4.count;
            while (b < a && c < d) {
                while (c < d) {
                    let e = this.a4._inner[c];
                    let f = false;
                    let viewItem_ = e;
                    if ((viewItem_.$$isSpecialRow !== undefined)) {
                        f = true;
                    }
                    if (!f) {
                        break;
                    }
                    c++;
                }
                let g = this.n.getItemAtIndex(b);
                if (this.at(g, this.a4._inner[c])) {
                    c++;
                    b++;
                }
                else {
                    b++;
                }
            }
            return c;
        }
        b9(a, b) {
            let c = this.a9(a);
            if (c < this.a4.count) {
                if (this.at(b, this.a4._inner[c])) {
                    this.b4(c, b);
                }
            }
        }
        b4(a, b) {
            this.a4.removeAt(a);
            if (this.ab != null) {
                this.ab.notifyRemoveItem(a, b);
            }
            let c = this.y(a, b);
            this.ck(a, b, c);
        }
        y(a, b) {
            let c = null;
            if (this.ah) {
                c = this.z.e(a);
            }
            else {
                c = this.z.t._inner[0];
            }
            if (c != null) {
                this.z.z(c, -1);
                if (c.p) {
                    c.ad--;
                    this.z.ac(c, -1, 0);
                    if (this.aw) {
                        for (let d = 0; d < c.aa; d++) {
                            let e = 0;
                            if (this.av) {
                                e = 1;
                            }
                            e += c.ah;
                            let f = this.a4._inner[c.af + d + e];
                            let g = null;
                            let item_ = f;
                            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                                g = f;
                            }
                            if (g != null) {
                                if (g.targetRow == b) {
                                    this.a4.removeAt(c.af + d + e);
                                    c.ad--;
                                    c.aa--;
                                    c.t--;
                                    this.z.ac(c, -1, -1);
                                    if (this.ab != null) {
                                        this.ab.notifyRemoveItem(c.af + d + e, g);
                                    }
                                }
                            }
                        }
                    }
                }
                if (this.ah && !c.m() && this.aj(c)) {
                    let h = 0;
                    if (this.z.p(c)) {
                        let i = c.w();
                        let j = i;
                        let k = this.ae.k.count;
                        let l = this.g();
                        let m = this.z.t._inner[c.ae + 1];
                        for (let n = 0; n < c.f.length; n++) {
                            if (!Base.equalsStatic(c.f[n], m.f[n])) {
                                j = n;
                                break;
                            }
                        }
                        if (this.av) {
                            if (c.c[j - 1]) {
                                for (let o = j; o < k; o++) {
                                    if (c.g[o] != null) {
                                        for (let p = 0; p < c.g[o].a.length; p++) {
                                            let q = c.g[o].a[p];
                                            if (q != null) {
                                                let r = this.a4.indexOf1(q);
                                                if (r >= 0) {
                                                    this.a4.removeAt(r);
                                                    c.ad--;
                                                    h++;
                                                    if (this.ab != null) {
                                                        this.ab.notifyRemoveItem(r, q);
                                                    }
                                                    if (!this.as) {
                                                        for (let s = o + 1; s < c.b.length; s++) {
                                                            c.b[s]--;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    let t = c.af + c.b[o];
                                    let u = typeCast(DataSourceSpecialRow.$, this.a4._inner[t]);
                                    if (u != null && u.rowType == 1) {
                                        c.a[o] = null;
                                        this.a4.removeAt(t);
                                        c.ad--;
                                        h++;
                                        if (this.ab != null) {
                                            this.ab.notifyRemoveItem(t, u);
                                        }
                                        for (let v = o + 1; v < c.b.length; v++) {
                                            c.b[v]--;
                                        }
                                    }
                                    if (!c.c[o]) {
                                        break;
                                    }
                                }
                            }
                        }
                        c.k = m;
                        for (let w = 0; w < j; w++) {
                            if (this.am && !this.as && (this.l == 2 || this.l == 0)) {
                                m.af -= this.av ? this.a8 + 1 : this.a8;
                            }
                            else if (this.av) {
                                m.af--;
                            }
                        }
                        m.d[i] = c.d[i];
                        m.a[i] = c.a[i];
                        m.c[i] = c.c[i];
                        m.z = c.z;
                        for (let x = i; x < k; x++) {
                            m.g[x] = c.g[x];
                        }
                        m.b[i] = c.b[i];
                        for (let y = i, z = c.b[i]; y < k; y++) {
                            m.b[y] = z;
                            if (this.av) {
                                z++;
                            }
                            if (!this.as) {
                                if (m.g[y] != null) {
                                    z += m.g[y].a.length;
                                }
                            }
                            let aa = m.af - h + m.b[y];
                            let ab = typeCast(DataSourceSpecialRow.$, this.a4._inner[aa]);
                            if (ab != null && ab.rowType == 1) {
                                for (let ac = 0; ac < m.f.length; ac++) {
                                    ab.setValue(m.e[ac], m.f[ac]);
                                }
                            }
                        }
                    }
                    else {
                        if (this.av) {
                            for (let ad = c.af; ad <= c.ad; ad++) {
                                let ae = typeCast(DataSourceSpecialRow.$, this.a4._inner[ad]);
                                if (ae != null && ae.rowType == 1) {
                                    this.a4.removeAt(ad);
                                    c.ad--;
                                    h++;
                                    ad--;
                                    if (this.ab != null) {
                                        this.ab.notifyRemoveItem(ad, ae);
                                    }
                                }
                            }
                        }
                        for (let af = 0; af < c.g.length; af++) {
                            if (c.g[af] == null) {
                                continue;
                            }
                            for (let ag = 0; ag < c.g[af].a.length; ag++) {
                                let ah = c.g[af].a[ag];
                                if (ah != null) {
                                    let ai = this.a4.indexOf1(ah);
                                    this.a4.removeAt(ai);
                                    c.ad--;
                                    h++;
                                    if (this.ab != null) {
                                        this.ab.notifyRemoveItem(ai, ah);
                                    }
                                }
                            }
                        }
                        if (c.z >= 0) {
                            let aj = c.ad - c.af + 1;
                            if (aj > 0) {
                                let ak = this.a4._inner[c.af - 1];
                                let al = typeCast(DataSourceSpecialRow.$, ak);
                                let am = this.f();
                                for (let an = 0; an < aj; an++) {
                                    let ao = c.af + an;
                                    let ap = typeCast(DataSourceSpecialRow.$, this.a4._inner[ao]);
                                    if (ap != null) {
                                        for (let aq = 0; aq < am.length; aq++) {
                                            if (al == null) {
                                                ap.setValue(am[aq], this.m.getItemProperty(ak, am[aq]));
                                            }
                                            else {
                                                ap.setValue(am[aq], al.getValue(am[aq]));
                                            }
                                        }
                                    }
                                }
                                let ar = this.z.t._inner[c.ae - 1];
                                ar.ad += aj;
                            }
                        }
                    }
                    if (this.au) {
                        for (let as = 0; as < c.a.length; as++) {
                            if (!c.c[as]) {
                                break;
                            }
                            if (c.a[as] != null) {
                                let at = this.a4._inner[c.ad];
                                this.a4.removeAt(c.ad);
                                if (this.ab != null) {
                                    this.ab.notifyRemoveItem(c.ad, at);
                                }
                                h++;
                                c.ad--;
                            }
                        }
                    }
                    this.z.ae(c.ae);
                    this.z.ab(c, -h, -h);
                    c.o = true;
                }
            }
            return c;
        }
        aj(a) {
            for (let b = a.af; b <= a.ad; b++) {
                if (this.m.getRowType(b) == 0) {
                    return false;
                }
            }
            return true;
        }
        bo(a) {
            if (this.ax(a)) {
                let b = this.a4.g(a, this.a0);
                if (b < 0) {
                    b = ~b;
                }
                this.b3(b, a);
            }
        }
        b5(a) {
            this.a3.add(a);
            let b = this.m.indexOfKey(a);
            let c = this.m.getItemAtIndex(b);
            if (b == -1) {
                return;
            }
            if (this.aw) {
                let d = this.z.e(b);
                let e = this.bi(d, this.a4._inner[b]);
                if (this.ab != null) {
                    this.ab.notifyInsertItem(e, this.a4._inner[e]);
                }
            }
        }
        cc(a) {
            if (this.a3.remove(a)) {
                let b = this.m.indexOfKey(a);
                let c = this.m.getItemAtIndex(b);
                if (b == -1) {
                    return;
                }
                let d = this.z.e(b);
                let e = d.af;
                if (this.av) {
                    e += d.v();
                }
                if (this.aw) {
                    let f = this.u(e, this.a4._inner[b], d.aa, this.f());
                    if (f != null) {
                        d.ad--;
                        d.aa--;
                        d.t--;
                        this.z.ac(d, -1, -1);
                        if (this.ab != null) {
                            this.ab.notifyRemoveItem(f.a, f.item);
                        }
                    }
                }
            }
        }
        u(a, b, c, d) {
            for (let e = a + (c - 1); e >= a; e--) {
                if (typeCast(DataSourceSpecialRow.$, this.a4._inner[e]) !== null) {
                    let f = this.a4._inner[e];
                    if (f.rowType == 3) {
                        let g = f.targetRow;
                        if (g == b) {
                            this.a4.removeAt(e);
                            return ((() => {
                                let $ret = new RemovedShiftedRowInfo();
                                $ret.item = f;
                                $ret.a = e;
                                return $ret;
                            })());
                        }
                    }
                }
            }
            return null;
        }
        b8(a) {
            let b = this.a4.g(a, this.a0);
            if (b < 0) {
                b = ~b;
            }
            if (b >= 0) {
                let c = this.a4.count;
                let d = 0;
                while (d < c) {
                    let e = b - d;
                    let f = b + d;
                    if (e < 0 && f > c - 1) {
                        break;
                    }
                    if (e >= 0 && e < c) {
                        if (this.a4._inner[e] != null && Base.equalsStatic(this.a4._inner[e], a)) {
                            b = e;
                            break;
                        }
                    }
                    if (f < c) {
                        if (this.a4._inner[f] != null && Base.equalsStatic(this.a4._inner[f], a)) {
                            b = f;
                            break;
                        }
                    }
                    d++;
                }
                if (b < 0 || b > c - 1) {
                    return;
                }
                let g = this.a4._inner[b];
                if (g == null && a == null) {
                    this.a4.removeAt(b);
                    this.aa.notifyRemoveItem(b, a);
                    let h = this.y(b, a);
                    this.ci(b, a, false, h);
                    return;
                }
                if (g == null) {
                    return;
                }
                if (Base.equalsStatic(g, a)) {
                    this.a4.removeAt(b);
                    this.aa.notifyRemoveItem(b, a);
                    let i = this.y(b, a);
                    this.ci(b, a, false, i);
                }
                else {
                    if (b - 1 >= 0) {
                        let j = this.z.e(b - 1);
                        if (j != null && !j.p) {
                            b = b - 1;
                        }
                    }
                    this.y(b, a);
                }
            }
            else {
                let k = this.a4.count;
                for (let l = 0; l < k; l++) {
                    let m = this.a4._inner[l];
                    if (m == null && a == null) {
                        this.a4.removeAt(l);
                        break;
                    }
                    if (m == null) {
                        continue;
                    }
                    if (Base.equalsStatic(m, a)) {
                        this.a4.removeAt(l);
                        this.aa.notifyRemoveItem(l, a);
                        let n = this.y(l, a);
                        this.ck(l, a, n);
                        break;
                    }
                }
            }
        }
        ax(a) {
            if (this.s == null) {
                return true;
            }
            return this.s(a);
        }
        notifyClearItems() {
        }
        notifyInsertItem(a, b) {
            if (this.a0 != null) {
                this.bo(b);
            }
            else {
                this.bp(a, b);
            }
        }
        notifyRemoveItem(a, b) {
            if (this.a0 != null) {
                this.b8(b);
            }
            else {
                this.b9(a, b);
            }
        }
        ca(a, b) {
            let c = this.z.e(a);
            if (c == null) {
                c = this.z.d();
            }
            for (let d = 0, e = 0; d < c.a.length; d++) {
                if (c.a[d] != null) {
                    if (a == c.af + c.b[d]) {
                        let f = c.a[d];
                        if (this.ay.containsKey(f)) {
                            if (this.ay.item(f) != b) {
                                let g = this.ay.item(f);
                                if (b == this.ar) {
                                    this.ay.removeItem(f);
                                }
                                else {
                                    this.ay.item(f, b);
                                }
                                this.m.queueAutoRefresh();
                                if (this.ad != null) {
                                    this.ad.notifyRowExpansionChanged(a, g, b);
                                }
                            }
                        }
                        else if (b != this.ar) {
                            this.ay.addItem(f, b);
                            this.m.queueAutoRefresh();
                            if (this.ad != null) {
                                this.ad.notifyRowExpansionChanged(a, this.ar, b);
                            }
                        }
                    }
                    e++;
                }
            }
        }
        ak(a) {
            let b = this.z.e(a);
            if (b == null) {
                b = this.z.d();
            }
            for (let c = 0, d = 0; c < b.a.length; c++) {
                if (b.a[c] != null) {
                    if (a == b.af + b.b[c]) {
                        return b.c[c];
                    }
                    d++;
                }
            }
            return true;
        }
        al(a) {
            if (!this.aq) {
                return true;
            }
            return this.ay.containsKey(a) ? this.ay.item(a) : this.ar;
        }
        bm(a) {
            let b = "";
            for (let c = 0; c < a.e.length; c++) {
                b += a.e[c] + ":" + a.f[c];
            }
            return b;
        }
        bn(a, b) {
            if (this.m.sectionHeaderDisplayMode == 0) {
                return this.bm(a);
            }
            let c = "";
            for (let d = 0; d < b + 1; d++) {
                c += a.e[d] + ":" + a.f[d] + ":";
            }
            return c;
        }
        br(a) {
            if (this.l == 3 || (a != null && this.l == 1) || (a == null && this.l == 2)) {
                return;
            }
            if (a == null && (this.e == null || this.e.length != this.ag.k.count)) {
                this.e = new Array(this.ag.k.count);
            }
            if (a != null) {
                let b = a.v();
                for (let c = b - 1; c >= 0; c--) {
                    for (let d = 0; d < this.ag.k.count; d++) {
                        let e = this.ag.k.item(d);
                        this.c[c][d].beginCalculation(this.m, e.propertyName);
                    }
                }
            }
            else {
                if (this.d == null || this.d.length != this.ag.k.count) {
                    this.d = new Array(this.ag.k.count);
                }
                for (let f = 0; f < this.ag.k.count; f++) {
                    let g = this.ag.k.item(f);
                    if (this.d[f] == null || this.d[f].operand != g.operand) {
                        this.d[f] = g.d();
                    }
                    this.d[f].beginCalculation(this.m, g.propertyName);
                }
            }
        }
        bu(a) {
            if (this.l == 3 || (a != null && this.l == 1) || (a == null && this.l == 2)) {
                return;
            }
            if (a != null) {
                let b = a.v();
                for (let c = b - 1; c >= 0; c--) {
                    let d = this.a4._inner[a.af + c];
                    for (let e = 0; e < this.ag.k.count; e++) {
                        let f = this.ag.k.item(e);
                        let g = this.c[c][e].endCalculation();
                        g.summaryIndex = e;
                        if (d != null) {
                            d.summaryResults[c] = g;
                        }
                    }
                }
            }
            else {
                for (let h = 0; h < this.ag.k.count; h++) {
                    let i = this.d[h].endCalculation();
                    i.summaryIndex = h;
                    this.e[h] = i;
                }
            }
        }
        bq(a, b) {
            if (this.l == 3 || (a != null && this.l == 1) || (a == null && this.l == 2)) {
                return;
            }
            if (b != null) {
                if (a != null) {
                    for (let c = 0; c < this.c.length; c++) {
                        if (this.c[c] != null) {
                            for (let d = 0; d < this.c[c].length; d++) {
                                if (this.c[c][d] != null) {
                                    this.c[c][d].aggregate(b);
                                }
                            }
                        }
                    }
                }
                else {
                    for (let e = 0; e < this.ag.k.count; e++) {
                        this.d[e].aggregate(b);
                    }
                }
            }
        }
        cg(a, b, c, d, e) {
            let f = a.i[d][e];
            let g = b.itemAdded(c, f, a.d[d]);
            a.an(d, e, g);
            if (this.av) {
                if (a.a[d] != null) {
                    let h = typeCast(DataSourceSpecialRow.$, this.a4._inner[a.af + a.b[d]]);
                    if (h != null) {
                        h.summaryResults[e] = a.i[d][e];
                    }
                }
            }
        }
        cf(a, b, c, d, e, f) {
            let g = a.i[d][e];
            let h = a.d[d];
            let i = f ? b.itemAdded(c, g, h) : b.itemRemoved(c, g, h);
            a.an(d, e, i);
            if (this.av) {
                if (!a.o && a.a[d] != null) {
                    let j = typeCast(DataSourceSpecialRow.$, this.a4._inner[a.af + a.b[d]]);
                    if (j != null) {
                        j.summaryResults[e] = a.i[d][e];
                    }
                }
            }
        }
        ci(a, b, c, d) {
            if (this.ag.k.count == 0) {
                return;
            }
            if (d == null) {
                d = this.w(a);
                if (d == null) {
                    d = this.z.d();
                }
            }
            let e = false;
            let f = false;
            let g = false;
            for (let h = 0; h < this.ag.k.count; h++) {
                let i = this.ag.k.item(h);
                if (this.l == 0 || this.l == 1) {
                    let j = null;
                    if (c) {
                        j = this.d[h].itemAdded(b, this.e[h], this.n.actualCount);
                    }
                    else {
                        j = this.d[h].itemRemoved(b, this.e[h], this.n.actualCount);
                    }
                    j.summaryIndex = h;
                    this.e[h] = j;
                    if (this.d[h].isSummaryDirty) {
                        e = true;
                    }
                    else {
                        f = true;
                    }
                }
                if (this.l == 0 || this.l == 2) {
                    if (d != null && d.i != null) {
                        let k = i.d();
                        k.dataSource = this.m;
                        k.propertyName = i.propertyName;
                        k.propertyType = this.m.resolveSchemaPropertyType(i.propertyName);
                        let l = this.g();
                        let m = d.w();
                        for (let n = m; n < l.length; n++) {
                            this.cf(d, k, b, n, h, c);
                            if (k.isSummaryDirty) {
                                e = true;
                            }
                            g = true;
                        }
                        let o = d.z;
                        while (o != -1) {
                            let p = this.z.t._inner[o];
                            let q = p.w();
                            for (let r = q; r < m; r++) {
                                this.cf(p, k, b, r, h, c);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                            }
                            o = p.z;
                            m = m - 1;
                        }
                    }
                }
            }
            if (e) {
                this.m.queueAutoRefresh();
            }
            else {
                if (f) {
                    let s = SectionData.r(this.e);
                    this.cd(s);
                }
                if (g) {
                    this.ch(d, null);
                    let t = d.z;
                    while (t != -1) {
                        let u = this.z.t._inner[t];
                        this.ch(u, null);
                        t = u.z;
                    }
                }
            }
        }
        cl(a, b, c, d, e) {
            let f = a;
            let g = this.ag.k.item(a);
            if (g == null) {
                return;
            }
            if (e == null) {
                e = this.w(b);
                if (e == null) {
                    e = this.z.d();
                }
            }
            let h = false;
            let i = false;
            let j = false;
            if (this.l == 0 || this.l == 1) {
                let k = null;
                if (d) {
                    k = this.d[f].itemAdded(c, this.e[f], this.n.actualCount);
                }
                else {
                    k = this.d[f].itemRemoved(c, this.e[f], this.n.actualCount);
                }
                k.summaryIndex = f;
                this.e[f] = k;
                if (this.d[f].isSummaryDirty) {
                    h = true;
                }
                else {
                    i = true;
                }
            }
            if (this.l == 0 || this.l == 2) {
                if (e != null && e.i != null) {
                    let l = g.d();
                    l.dataSource = this.m;
                    l.propertyName = g.propertyName;
                    l.propertyType = this.m.resolveSchemaPropertyType(g.propertyName);
                    let m = this.g();
                    let n = e.w();
                    for (let o = n; o < m.length; o++) {
                        this.cf(e, l, c, o, f, d);
                        if (l.isSummaryDirty) {
                            h = true;
                        }
                        j = true;
                    }
                    let p = e.z;
                    while (p != -1) {
                        let q = this.z.t._inner[p];
                        let r = q.w();
                        for (let s = r; s < n; s++) {
                            this.cf(q, l, c, s, f, d);
                            if (l.isSummaryDirty) {
                                h = true;
                            }
                        }
                        p = q.z;
                        n = n - 1;
                    }
                }
            }
            if (h) {
                this.m.queueAutoRefresh();
            }
            else {
                if (i) {
                    let t = SectionData.r(this.e);
                    this.cd(t);
                }
                if (j) {
                    this.ch(e, null);
                    let u = e.z;
                    while (u != -1) {
                        let v = this.z.t._inner[u];
                        this.ch(v, null);
                        u = v.z;
                    }
                }
            }
        }
        cj(a, b) {
            if (this.ag.k.count == 0) {
                return;
            }
            let c = this.w(a);
            if (c == null) {
                c = this.z.d();
            }
            let d = null;
            if (c != null) {
                d = typeCast(DataSourceSpecialRow.$, this.a4._inner[c.af]);
            }
            let e = false;
            let f = false;
            let g = false;
            for (let h = 0; h < this.ag.k.count; h++) {
                let i = this.ag.k.item(h);
                if (this.l == 0 || this.l == 1) {
                    let j = this.d[h].itemAdded(b, this.e[h], this.n.actualCount);
                    j.summaryIndex = h;
                    this.e[h] = j;
                    if (this.d[h].isSummaryDirty) {
                        e = true;
                    }
                    else {
                        f = true;
                    }
                }
                if (this.l == 0 || this.l == 2) {
                    if (c != null && c.i != null) {
                        let k = i.d();
                        k.dataSource = this.m;
                        k.propertyName = i.propertyName;
                        k.propertyType = this.m.resolveSchemaPropertyType(i.propertyName);
                        let l = this.g();
                        let m = c.w();
                        for (let n = m; n < l.length; n++) {
                            this.cg(c, k, b, n, h);
                            if (k.isSummaryDirty) {
                                e = true;
                            }
                            g = true;
                        }
                        let o = c.z;
                        while (o != -1) {
                            let p = this.z.t._inner[o];
                            let q = p.w();
                            for (let r = q; r < m; r++) {
                                this.cg(p, k, b, r, h);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                            }
                            o = p.z;
                            m = m - 1;
                        }
                    }
                }
            }
            if (e) {
                this.m.queueAutoRefresh();
            }
            else {
                if (f) {
                    let s = SectionData.r(this.e);
                    this.cd(s);
                }
                if (g) {
                    this.ch(c, null);
                    let t = c.z;
                    while (t != -1) {
                        let u = this.z.t._inner[t];
                        this.ch(u, null);
                        t = u.z;
                    }
                }
            }
        }
        ck(a, b, c) {
            if (this.ag.k.count == 0) {
                return;
            }
            let d = null;
            if (c != null) {
                d = typeCast(DataSourceSpecialRow.$, this.a4._inner[c.af]);
            }
            let e = false;
            let f = false;
            let g = false;
            for (let h = 0; h < this.ag.k.count; h++) {
                let i = this.ag.k.item(h);
                if (this.l == 0 || this.l == 1) {
                    let j = this.d[h].itemRemoved(b, this.e[h], this.m.actualCount);
                    j.summaryIndex = h;
                    this.e[h] = j;
                    if (this.d[h].isSummaryDirty) {
                        e = true;
                    }
                    else {
                        f = true;
                    }
                }
                if (this.l == 0 || this.l == 2) {
                    if (c != null && c.i != null) {
                        let k = i.d();
                        k.dataSource = this.m;
                        k.propertyName = i.propertyName;
                        k.propertyType = this.m.resolveSchemaPropertyType(i.propertyName);
                        let l = this.g();
                        let m = c.w();
                        for (let n = m; n < l.length; n++) {
                            this.cf(c, k, b, n, h, false);
                            if (k.isSummaryDirty) {
                                e = true;
                            }
                            g = true;
                        }
                        let o = c.z;
                        while (o != -1) {
                            let p = this.z.t._inner[o];
                            let q = p.w();
                            for (let r = q; r < m; r++) {
                                this.cf(p, k, b, r, h, false);
                                if (k.isSummaryDirty) {
                                    e = true;
                                }
                            }
                            o = p.z;
                            m = m - 1;
                        }
                    }
                }
            }
            if (e) {
                this.m.queueAutoRefresh();
            }
            else {
                if (f) {
                    let s = SectionData.r(this.e);
                    this.cd(s);
                }
                if (g) {
                    this.ch(c, null);
                    let t = c.z;
                    while (t != -1) {
                        let u = this.z.t._inner[t];
                        this.ch(u, null);
                        t = u.z;
                    }
                }
            }
        }
        ch(a, b) {
            if (this.l == 2 || this.l == 0) {
                if (this.am) {
                    if (!a.o && !a.n()) {
                        if (this.as) {
                            this.by(a, true);
                        }
                        else {
                            this.bz(a, true);
                        }
                    }
                    else {
                        a.am((c) => {
                            if (this.ab != null) {
                                let d = this.a4.indexOf1(c);
                                this.ab.notifySetItem(d, c, c);
                            }
                        });
                    }
                }
                else {
                    for (let c = 0; c < a.i.length; c++) {
                        let d = a.af + a.b[c];
                        let e = this.a4._inner[d];
                        if (e != null) {
                            e.summaryResults = a.i[c];
                            if (this.ab != null) {
                                this.ab.notifySetItem(d, e, e);
                            }
                        }
                    }
                }
            }
        }
        cd(a) {
            for (let b = 0; b < a.count; b++) {
                let c = new Array(a._inner[b].count);
                a._inner[b].values.copyTo(c, 0);
                let d = this.a4.count - a.count + b;
                let e = typeCast(DataSourceSpecialRow.$, this.a4._inner[d]);
                e.summaryResults = c;
                if (this.ab != null) {
                    this.ab.notifySetItem(d, e, e);
                }
            }
        }
    }
    RearrangedListView.$t = /*@__PURE__*/ markType(RearrangedListView, 'RearrangedListView', Base.$, [ISupportsDataChangeNotifications_$type]);
    return RearrangedListView;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourcePropertiesComparer = /*@__PURE__*/ (() => {
    class DataSourcePropertiesComparer extends Base {
        constructor(a, b, c, d) {
            super();
            this.e = null;
            this.b = null;
            this.a = null;
            this.g = 0;
            this.f = null;
            this.d = null;
            this.c = null;
            this.b = a;
            if (this.b != null) {
                this.g = this.b.length;
            }
            this.a = b;
            this.e = d;
            this.f = d.actualSchema;
            if (this.b != null) {
                this.d = new Array(this.g);
            }
            this.c = c;
            if (this.c == null) {
                this.c = new Array(this.g);
            }
            let e = new Dictionary$2(String_$type, DataSourceSchemaPropertyType_$type, 0);
            for (let f = 0; f < this.f.propertyNames.length; f++) {
                e.item(this.f.propertyNames[f], this.f.propertyTypes[f]);
            }
            if (this.b != null) {
                for (let g = 0; g < this.b.length; g++) {
                    if (e.containsKey(this.b[g])) {
                        this.d[g] = e.item(this.b[g]);
                    }
                    else {
                        this.d[g] = d.resolveSchemaPropertyType(this.b[g]);
                    }
                }
            }
        }
        compare(a, b) {
            if (this.b == null) {
                if (a == b) {
                    return 0;
                }
                return -1;
            }
            let c = null;
            let d = null;
            let e = null;
            let f = null;
            let x_ = a;
            if ((x_ != null && x_.$$isSpecialRow !== undefined)) {
                e = x_;
            }
            let y_ = b;
            if ((y_ != null && y_.$$isSpecialRow !== undefined)) {
                f = y_;
            }
            let g = null;
            let h = false;
            let i = this.g;
            for (let j = 0; j < i; j++) {
                g = this.b[j];
                h = this.a[j] == 1;
                if (e != null && e.rowType == 4) {
                    return 1;
                }
                if (e != null) {
                    c = e.getValue(g);
                }
                else {
                    c = this.e.getItemProperty(a, g);
                }
                if (f != null) {
                    d = f.getValue(g);
                }
                else {
                    d = this.e.getItemProperty(b, g);
                }
                let k = this.j(c, d, h, this.d[j], this.c[j]);
                if (j == i - 1) {
                    if (e != null && e.rowType == 5 && k == 0) {
                        if (this.e.isSectionSummaryRowsAtBottom) {
                            k = h ? -1 : 1;
                        }
                        else {
                            k = h ? 1 : -1;
                        }
                    }
                }
                if (k != 0) {
                    return k;
                }
            }
            return 0;
        }
        h(a, b) {
            if (this.b == null) {
                for (let c = 0; c < a.length; c++) {
                    if (a[c] != b[c]) {
                        return -1;
                    }
                }
                return 0;
            }
            let d = null;
            let e = null;
            let f = false;
            let g = this.g;
            for (let h = 0; h < g; h++) {
                f = this.a[h] == 1;
                d = a[h];
                e = b[h];
                let i = this.j(d, e, f, this.d[h], this.c[h]);
                if (i != 0) {
                    return i;
                }
            }
            return 0;
        }
        i(a, b) {
            if (this.b == null) {
                if (b.length == 1) {
                    if (a == b[0]) {
                        return 0;
                    }
                }
                return -1;
            }
            let c = null;
            let d = null;
            let e = null;
            let f = false;
            let g = this.g;
            for (let h = 0; h < g; h++) {
                e = this.b[h];
                f = this.a[h] == 1;
                c = this.e.getItemProperty(a, e);
                d = b[h];
                let i = this.j(c, d, f, this.d[h], this.c[h]);
                if (i != 0) {
                    return i;
                }
            }
            return 0;
        }
        j(a, b, c, d, e) {
            if (c) {
                let f = a;
                a = b;
                b = f;
            }
            let g = 0;
            switch (d) {
                case 2:
                    a = a == null ? false : a;
                    b = b == null ? false : b;
                    g = boolCompare(a, b);
                    break;
                case 8:
                    a = a == null ? dateMinValue() : a;
                    b = b == null ? dateMinValue() : b;
                    let xVal_ = a;
                    let yVal_ = b;
                    xVal_ = +xVal_;
                    yVal_ = +yVal_;
                    let h = typeGetValue(xVal_);
                    let i = typeGetValue(yVal_);
                    g = Base.compareSimple(h, i);
                    break;
                case 5:
                    a = a == null ? -1.7976931348623157E+308 : a;
                    b = b == null ? -1.7976931348623157E+308 : b;
                    g = Base.compareSimple(a, b);
                    break;
                case 10:
                    a = a == null ? 0 : a;
                    b = b == null ? 0 : b;
                    g = Base.compareSimple(a, b);
                    break;
                case 6:
                    a = a == null ? -7.9228162514264338E+28 : a;
                    b = b == null ? -7.9228162514264338E+28 : b;
                    g = Base.compareSimple(a, b);
                    break;
                case 7:
                    a = a == null ? -3.4028230607370965E+38 : a;
                    b = b == null ? -3.4028230607370965E+38 : b;
                    g = Base.compareSimple(b, b);
                    break;
                case 1:
                    a = a == null ? -2147483648 : a;
                    b = b == null ? -2147483648 : b;
                    g = Base.compareSimple((typeGetValue(a)), typeGetValue(b));
                    break;
                case 3:
                    a = a == null ? -9.2233720368547758E+18 : a;
                    b = b == null ? -9.2233720368547758E+18 : b;
                    g = Base.compareSimple((typeGetValue(a)), typeGetValue(b));
                    break;
                case 11:
                    if (e) {
                        let j = a;
                        let k = b;
                        if (j != null) {
                            g = CompareUtil.compareToObject(j, k);
                        }
                        else if (k != null) {
                            g = -1;
                        }
                        else {
                            g = 0;
                        }
                    }
                    else {
                        a = a == null ? "" : a;
                        b = b == null ? "" : b;
                        g = stringCompare(a.toString(), b.toString());
                    }
                    break;
                case 4:
                    a = a == null ? -32768 : a;
                    b = b == null ? -32768 : b;
                    g = Base.compareSimple((typeGetValue(a)), typeGetValue(b));
                    break;
                case 0:
                    a = a == null ? "" : a;
                    b = b == null ? "" : b;
                    g = stringCompare(a, b);
                    break;
            }
            return g;
        }
    }
    DataSourcePropertiesComparer.$t = /*@__PURE__*/ markType(DataSourcePropertiesComparer, 'DataSourcePropertiesComparer', Base.$, [/*@__PURE__*/ IComparer$1_$type.specialize(Base.$)]);
    return DataSourcePropertiesComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceExecutionContext_$type = /*@__PURE__*/ new Type(null, 'IDataSourceExecutionContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceExecutionContext = /*@__PURE__*/ (() => {
    class DataSourceExecutionContext extends Base {
        constructor() {
            super();
            this._requestAnimationFrame = null;
            this.requestAnimationFrame = (window.requestAnimationFrame ||
                window.webkitRequestAnimationFrame ||
                window.mozRequestAnimationFrame ||
                window.oRequestAnimationFrame ||
                window.msRequestAnimationFrame ||
                function (callback) {
                    window.setTimeout(callback, 1000 / 60);
                });
        }
        get requestAnimationFrame() {
            return this._requestAnimationFrame;
        }
        set requestAnimationFrame(a) {
            this._requestAnimationFrame = a;
        }
        enqueueAction(a) {
            window.setTimeout(() => a(), 0);
        }
        execute(a) {
            window.setTimeout(() => a(), 0);
        }
        executeDelayed(a, b) {
            window.setTimeout(() => a(), b);
        }
    }
    DataSourceExecutionContext.$t = /*@__PURE__*/ markType(DataSourceExecutionContext, 'DataSourceExecutionContext', Base.$, [IDataSourceExecutionContext_$type]);
    return DataSourceExecutionContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsExpansionChangeNotifications_$type = /*@__PURE__*/ new Type(null, 'ISupportsExpansionChangeNotifications');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSource = /*@__PURE__*/ (() => {
    class LocalDataSource extends BaseDataSource {
        constructor() {
            super();
            this.cv = null;
            this.cu = null;
            this.dv = null;
            this.c0 = null;
            this.c4 = null;
            this.c6 = null;
            this.c2 = null;
            this.dg = new List$1(Array_$type, 0);
            this.c7 = false;
            this.ct = null;
            this.dp = -1;
            this.dh = -1;
            this.dr = -1;
            this.dj = -1;
            this.ds = -1;
            this.dk = -1;
            this.dq = -1;
            this.di = -1;
            this.du = -1;
            this.dt = -1;
            this.dm = -1;
            this.dl = -1;
            this.dn = -1;
            this.executionContext = new DataSourceExecutionContext();
            this.u.l = false;
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cv;
        }
        set dataProvider(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.onPropertyUpdated("DataProvider", b, this.cv);
            }
        }
        get actualDataProvider() {
            if (this.cu == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.cu;
        }
        set actualDataProvider(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.onPropertyUpdated("ActualDataProvider", b, this.cu);
            }
        }
        get dataSource() {
            return this.dv;
        }
        set dataSource(a) {
            let b = this.dv;
            this.dv = a;
            if (b != this.dv) {
                this.onPropertyUpdated("ItemsSource", b, this.dv);
            }
        }
        canInitialize() {
            let a = super.canInitialize();
            if (!a) {
                return false;
            }
            return this.dataSource != null;
        }
        get c1() {
            return this.c0;
        }
        set c1(a) {
            this.c0 = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            let provider_ = new DataSourceLocalDataProvider();
            provider_.executionContext = new DataSourceExecutionContext();
            return provider_;
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    break;
                case "ActualDataProvider":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
                case "ItemsSource":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        getItemAtIndex(a) {
            if (this.c4 != null && this.c4.a6 != null) {
                return this.c4.a6.item(a);
            }
            else {
                return this.actualDataProvider.getItemAtIndex(a);
            }
        }
        getItemFromKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return a[0];
            }
            let c = this.c3();
            let d;
            if (this.c4 != null) {
                let e = this.c4.a6.count;
                for (let f = 0; f < e; f++) {
                    d = this.c4.a6.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return d;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return d;
                    }
                }
                return null;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                let h = this.actualDataProvider.indexOfKey(a);
                return this.actualDataProvider.getItemAtIndex(h);
            }
            if (this.actualDataProvider != null) {
                let i = this.actualDataProvider.actualCount;
                for (let j = 0; j < i; j++) {
                    d = this.actualDataProvider.getItemAtIndex(j);
                    if (c.i(d, a) == 0) {
                        return d;
                    }
                }
            }
            return null;
        }
        getItemPropertyAtIndex(a, b) {
            let c;
            if (this.c4 != null) {
                c = this.c4.a6.item(a);
            }
            else {
                c = this.actualDataProvider.getItemAtIndex(a);
            }
            let item_ = c;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return this.getSpecialRowItemValue(c, b);
            }
            if (this.ap()) {
                let d = this.am(c, b);
                if (d) {
                    let e = this.a0(c, b);
                    return e;
                }
            }
            return this.actualDataProvider.getItemValue(c, b);
        }
        cz() {
            return this.actualDataProvider;
        }
        c9() {
            return this.dg != null && this.dg.count > 0;
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            if (this.actualDataProvider != null) {
                if (this.da() || this.db() || this.dc() || this.dd() || this.c9()) {
                    if (this.c4 == null) {
                        if (this.c6 == null) {
                            this.c6 = new LocalDataSourceViewUpdateNotifier(this);
                        }
                        this.c4 = new RearrangedListView(this.actualDataProvider);
                        this.c4.ab = this.c6;
                        this.c4.ad = new LocalDataSourceViewExpansionNotifier(this);
                    }
                    this.ensureComparables(this.actualDataProvider.actualSchema);
                    this.c4.av = this.shouldEmitSectionHeaders && this.ao;
                    this.c4.au = this.shouldEmitSectionFooters && this.ao;
                    this.c4.aw = this.shouldEmitShiftedRows;
                    this.c4.cb(this.dg);
                    this.c4.a2 = this.df();
                    this.c4.a1 = this.de();
                    this.c4.p = this.c3();
                    this.c4.ae = this.groupDescriptions;
                    this.c4.af = this.sortDescriptions;
                    this.c4.ag = this.summaryDescriptions;
                    this.c4.l = this.summaryScope;
                    this.c4.am = this.includeSummaryRowsInSection;
                    this.c4.as = this.isSectionSummaryRowsAtBottom;
                    this.c4.j = this.sectionHeaderDisplayMode;
                    this.c4.m = this;
                    this.c4.ap = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                    this.c4.t = this.c5();
                    this.c4.b6();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.c4.a6.count;
                }
                else {
                    let a = this.cz();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    if (a != null) {
                        this.actualCount = a.actualCount;
                    }
                    else {
                        this.actualCount = 0;
                    }
                    if (this.c4 != null) {
                        this.c4.ab = null;
                        this.c4 = null;
                        this.onBroadcastClearItems();
                    }
                }
            }
            else {
                this.actualCount = 0;
                this.actualSchema = null;
            }
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            if (this.c4 != null) {
                return this.c4.a6.indexOf(a);
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            if (this.actualDataProvider != null) {
                let b = this.actualDataProvider.actualCount;
                let c;
                for (let d = 0; d < b; d++) {
                    c = this.actualDataProvider.getItemAtIndex(d);
                    if (this.c8(c, a)) {
                        return d;
                    }
                }
            }
            return -1;
        }
        c8(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return this.indexOfItem(a[0]);
            }
            let c = this.c3();
            let d;
            if (this.c4 != null) {
                let e = this.c4.a6.count;
                for (let f = 0; f < e; f++) {
                    d = this.c4.a6.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return f;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return f;
                    }
                }
                return -1;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            if (this.actualDataProvider != null) {
                let h = this.actualDataProvider.actualCount;
                for (let i = 0; i < h; i++) {
                    d = this.actualDataProvider.getItemAtIndex(i);
                    if (c.i(d, a) == 0) {
                        return i;
                    }
                }
            }
            return -1;
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
            super.onActualPrimaryKeyChangedOverrride(a, b);
            this.c2 = null;
        }
        c3() {
            if (this.c2 != null) {
                return this.c2;
            }
            if (this.actualPrimaryKey == null) {
                this.c2 = new DataSourcePropertiesComparer(null, null, null, this);
                return this.c2;
            }
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            this.c2 = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
            return this.c2;
        }
        c5() {
            if (this.filterExpressions.j.count == 0) {
                return null;
            }
            let a = this.actualDataProvider;
            let b = this.actualDataProvider.actualSchema;
            let c = this.filterExpressions.j;
            let d = (e) => {
                for (let f = 0; f < c.count; f++) {
                    if (!c.item(f).match(e, a, b)) {
                        return false;
                    }
                }
                return true;
            };
            return d;
        }
        df() {
            let a = 0;
            if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
                return null;
            }
            a = this.sortDescriptions.k.count;
            if (this.groupDescriptions != null) {
                a += this.groupDescriptions.k.count;
            }
            let b = new Array(a);
            let c = new Array(a);
            let d = 0;
            if (this.groupDescriptions != null) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    b[e] = this.groupDescriptions.k.item(e).propertyName;
                    c[e] = this.groupDescriptions.k.item(e).direction;
                    d++;
                }
            }
            for (let f = 0; f < this.sortDescriptions.k.count; f++) {
                b[f + d] = this.sortDescriptions.k.item(f).propertyName;
                c[f + d] = this.sortDescriptions.k.item(f).direction;
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        de() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return null;
            }
            let a = 0;
            a = this.groupDescriptions.k.count;
            let b = new Array(a);
            let c = new Array(a);
            if (this.groupDescriptions != null) {
                for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                    b[d] = this.groupDescriptions.k.item(d).propertyName;
                    c[d] = this.groupDescriptions.k.item(d).direction;
                }
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        db() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isGroupingSupported) {
                return false;
            }
            return true;
        }
        dc() {
            if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isSortingSupported) {
                return false;
            }
            return true;
        }
        da() {
            return this.filterExpressions != null && this.filterExpressions.j.count > 0;
        }
        dd() {
            if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
                return false;
            }
            return true;
        }
        onClearItemsOverride() {
            if (this.c4 != null) {
                this.c4.notifyClearItems();
                this.queueAutoRefresh();
            }
            else {
                super.onClearItemsOverride();
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.c4 != null) {
                this.c4.notifySetItem(a, b, c);
            }
            else {
                super.onSetItemOverride(a, b, c);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.c4 != null) {
                this.c4.notifyInsertItem(a, b);
            }
            else {
                super.onInsertItemOverride(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.c4 != null) {
                this.c4.notifyRemoveItem(a, b);
            }
            else {
                super.onRemoveItemOverride(a, b);
            }
        }
        d0() {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastClearItems();
        }
        d3(a, b, c) {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastSetItem(a, b, c);
        }
        d1(a, b) {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastInsertItem(a, b);
        }
        d2(a, b) {
            this.actualCount = this.c4.a6.count;
            this.onBroadcastRemoveItem(a, b);
        }
        pinRow(a) {
            super.pinRow(a);
            this.dp = -1;
            this.dh = -1;
            if (this.c4 != null) {
                this.dg.add(a);
                this.c4.b5(a);
            }
            else {
                this.dg.add(a);
                this.queueAutoRefresh();
            }
        }
        unpinRow(a) {
            super.unpinRow(a);
            let b = this.c3();
            if (this.c4 != null) {
                for (let c = this.dg.count - 1; c >= 0; c--) {
                    let d = this.dg._inner[c];
                    if (d.length != a.length) {
                        continue;
                    }
                    if (b.h(d, a) == 0) {
                        this.dg.removeAt(c);
                        this.c4.cc(d);
                    }
                }
            }
            else {
                for (let e = this.dg.count - 1; e >= 0; e--) {
                    let f = this.dg._inner[e];
                    if (f.length != a.length) {
                        continue;
                    }
                    if (b.h(f, a) == 0) {
                        this.dg.removeAt(e);
                    }
                }
                this.queueAutoRefresh();
            }
            this.dp = -1;
            this.dh = -1;
        }
        clearPinnedRows() {
            for (let a = this.dg.count - 1; a >= 0; a--) {
                this.unpinRow(this.dg._inner[a]);
            }
        }
        isRowPinned(a) {
            if (this.c4 == null) {
                return false;
            }
            let b = this.getItemAtIndex(a);
            if (b == null) {
                return false;
            }
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                if (item_.rowType == 3) {
                    return true;
                }
            }
            let c = this.c3();
            let d;
            if (this.actualPrimaryKey == null) {
                d = new Array(1);
                d[0] = b;
            }
            else {
                let e = this.actualPrimaryKey;
                let f = e.length;
                d = new Array(f);
                for (let g = 0; g < f; g++) {
                    d[g] = this.getItemProperty(b, e[g]);
                }
            }
            for (let h = 0; h < this.dg.count; h++) {
                if (c.h(this.dg._inner[h], d) == 0) {
                    return true;
                }
            }
            return false;
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.c7) {
                this.c7 = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.c7 = false;
                return a;
            }
            return true;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.c7) {
                this.c7 = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.c7 = false;
                return a;
            }
            return true;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.c7) {
                this.c7 = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.c7 = false;
                return a;
            }
            return true;
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        getStickyRowsInRange(a, b) {
            if (this.c4 == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.c9())) {
                return null;
            }
            let c = null;
            let d = null;
            if (this.c4.a5.count == 1) {
                c = this.c4.a5._inner[0];
                d = this.c4.a5._inner[0];
            }
            else {
                c = this.c4.w(a);
                if (c != null) {
                    while (c.z != -1) {
                        c = this.c4.a5._inner[c.z];
                    }
                }
                d = this.c4.w(b);
                if (b >= this.c4.a6.count - this.c4.bk) {
                    d = this.c4.v();
                }
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.dp && c.aa == this.dr && c.af == this.ds && c.ad == this.dq && c.ah == this.du && c.ag == this.dt && d.ae == this.dh && d.aa == this.dj && d.af == this.dk && d.ad == this.di && d.ah == this.dm && d.ag == this.dl && this.c4.bk == this.dn) {
                return this.ct;
            }
            this.dp = c.ae;
            this.dh = d.ae;
            this.dr = c.aa;
            this.dj = d.aa;
            this.ds = c.af;
            this.dk = d.af;
            this.dq = c.ad;
            this.di = d.ad;
            this.du = c.ah;
            this.dt = c.ag;
            this.dm = d.ah;
            this.dl = d.ag;
            this.dn = this.c4.bk;
            if (this.c4.a5.count == 1) {
                this.dh = d.ad;
            }
            let e = 0;
            if (this.shouldEmitSectionHeaders && this.ao) {
                e = 1;
            }
            let f = this.c4.ba();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.c4.a5._inner[h];
                let j = this.c4.a5._inner[h].c.length;
                let k = this.c4.a5._inner[h].v();
                if (this.shouldEmitSectionHeaders && this.ao) {
                    for (let l = 0; l < j; l++) {
                        if (this.c4.a5._inner[h].a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                            if (this.summaryScope == 0 || this.summaryScope == 2) {
                                if (i.c[l] && this.includeSummaryRowsInSection && !this.isSectionSummaryRowsAtBottom) {
                                    for (let n = 0; n < f; n++) {
                                        g.add(m + 1 + n);
                                    }
                                }
                            }
                        }
                        if (!this.c4.a5._inner[h].c[l]) {
                            break;
                        }
                    }
                }
                if (this.c4.a5._inner[h].p) {
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < this.c4.a5._inner[h].aa; o++) {
                            g.add(this.c4.a5._inner[h].af + this.c4.a5._inner[h].ah + o + k);
                        }
                    }
                }
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                        for (let p = this.c4.a5._inner[h].ag - 1; p >= 0; p--) {
                            if (this.shouldEmitSectionFooters) {
                                g.add(this.c4.a5._inner[h].ad - k - p);
                            }
                            else {
                                g.add(this.c4.a5._inner[h].ad - p);
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.ao) {
                    for (let q = j - 1; q >= 0; q--) {
                        if (!this.c4.a5._inner[h].c[q]) {
                            break;
                        }
                        g.add(this.c4.a5._inner[h].ad - q);
                    }
                }
            }
            for (let r = this.c4.a6.count - this.c4.bk; r < this.c4.a6.count; r++) {
                g.add(r);
            }
            this.ct = g.toArray();
            return this.ct;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        setIsRowExpandedAtIndex(a, b) {
            if (this.isSectionCollapsable && this.c4 != null && this.c4.a6.count > 0 && this.c4.a6.count > a) {
                this.c4.ca(a, b);
            }
        }
        getIsRowExpandedAtIndex(a) {
            if (this.c4 != null && this.c4.a6.count > 0 && this.c4.a6.count > a) {
                return this.c4.ak(a);
            }
            return true;
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            if (this.c4 != null) {
                return this.c4.bk;
            }
            return 0;
        }
        getRootSummaryResults() {
            if (this.c4 != null) {
                return this.c4.i;
            }
            return null;
        }
        getSectionSummaryResults(a) {
            if (this.c4 != null && this.c4.a5.count > 0 && a >= 0 && a < this.c4.a5.count) {
                return this.c4.a5._inner[a].i;
            }
            return null;
        }
        clone() {
            let a = new LocalDataSource();
            a.dataSource = this.dataSource;
            super.cloneProperties(a);
            return a;
        }
        ap() {
            return !this.isReadOnly && this.actualBaseDataProvider != null && this.u != null;
        }
        cm(a, b) {
            if (a == 5) {
                let c = new List$1(TransactionType_$type, 0);
                let d = new List$1(Base.$, 0);
                let e = b;
                let f = e.a;
                for (let g = 0; g < f.length; g++) {
                    if (f[g].transactionType == 1) {
                        let h = f[g].id;
                        let i = this.getItemFromKey(h);
                        if (i != null) {
                            let j = f[g].value;
                            let k = this.indexOfItem(i);
                            let l = null;
                            if (this.c4 != null && k > -1) {
                                l = this.c4.w(k);
                                for (let m = 0; m < this.summaryDescriptions.k.count; m++) {
                                    let n = this.summaryDescriptions.k.item(m);
                                    if (n.operand == 5 || j.containsKey(n.propertyName)) {
                                        this.c4.cl(m, k, i, false, l);
                                    }
                                }
                            }
                            for (let o of fromEnum(j)) {
                                this.actualDataProvider.setItemValue(i, o.key, o.value);
                            }
                            if (l != null && this.c4 != null && k > -1) {
                                for (let p = 0; p < this.summaryDescriptions.k.count; p++) {
                                    let q = this.summaryDescriptions.k.item(p);
                                    if (q.operand == 5 || j.containsKey(q.propertyName)) {
                                        this.c4.cl(p, k, i, true, l);
                                    }
                                }
                            }
                            if (k > -1) {
                                this.onBroadcastSetItem(k, i, i);
                            }
                            d.add1(i);
                            c.add(1);
                            if (this.dg.count > 0) {
                                let r = this.c3();
                                for (let s = 0; s < this.dg.count; s++) {
                                    if (r.h(this.dg._inner[s], h) == 0) {
                                        let t = this.getStickyRows();
                                        for (let u = 0; u < t.length; u++) {
                                            let v = t[u];
                                            let w = typeCast(DataSourceSpecialRow.$, this.c4.a6.item(v));
                                            if (w != null && w.rowType == 3 && w.targetRow == i) {
                                                this.onBroadcastSetItem(v, w, w);
                                                break;
                                            }
                                        }
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    else if (f[g].transactionType == TransactionType.Delete) {
                        let x = f[g].id;
                        let y = this.indexOfKey(x);
                        if (y > -1) {
                            let z = this.getItemAtIndex(y);
                            this.actualDataProvider.removeItem(z);
                            this.notifyRemoveItem(y, z);
                            d.add1(z);
                            c.add(TransactionType.Delete);
                        }
                    }
                    else if (f[g].transactionType == 0) {
                        let aa = f[g].id[0];
                        if (f[g].value != null) {
                            let ab = f[g].value;
                            for (let ac of fromEnum(ab)) {
                                this.actualDataProvider.setItemValue(aa, ac.key, ac.value);
                            }
                        }
                        this.actualDataProvider.addItem(aa);
                        d.add1(aa);
                        c.add(0);
                    }
                }
                if (f.length > 0) {
                    this.by(e.id, this.getAggregatedChanges(e.id));
                }
            }
        }
    }
    LocalDataSource.$t = /*@__PURE__*/ markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
})();
/**
 * @hidden
 */
let LocalDataSourceViewUpdateNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewUpdateNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyClearItems() {
            this.a.d0();
        }
        notifyInsertItem(a, b) {
            this.a.d1(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.d2(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.d3(a, b, c);
        }
    }
    LocalDataSourceViewUpdateNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
})();
/**
 * @hidden
 */
let LocalDataSourceViewExpansionNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewExpansionNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyRowExpansionChanged(a, b, c) {
            this.a.onRowExpansionChanged(a, b, c);
        }
    }
    LocalDataSourceViewExpansionNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Identifies the operator type of an operator filter expression.
 */
var FilterExpressionOperatorType = /*@__PURE__*/ (function (FilterExpressionOperatorType) {
    /**
     * No operator type specified.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["None"] = 0] = "None";
    /**
     * Determines if two expressions are equal.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Equal"] = 1] = "Equal";
    /**
     * Determines if two expressions are not equal.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["NotEqual"] = 2] = "NotEqual";
    /**
     * Determines if an expression is greater than another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["GreaterThan"] = 3] = "GreaterThan";
    /**
     * Determines if an expression is greater than or equal to another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["GreaterThanOrEqual"] = 4] = "GreaterThanOrEqual";
    /**
     * Determines if an expression is less than another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["LessThan"] = 5] = "LessThan";
    /**
     * Determines if an expression is less than or equal to another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["LessThanOrEqual"] = 6] = "LessThanOrEqual";
    /**
     * Applies the And operator to two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["And"] = 7] = "And";
    /**
     * Applies the Or operator to two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Or"] = 8] = "Or";
    /**
     * Applies the Not operator to a single expression.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Not"] = 9] = "Not";
    /**
     * Adds two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Add"] = 10] = "Add";
    /**
     * Subtracts one expression from another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Subtract"] = 11] = "Subtract";
    /**
     * Multiplies two expressions.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Multiply"] = 12] = "Multiply";
    /**
     * Divides one expression by another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Divide"] = 13] = "Divide";
    /**
     * Performs the modulus of one expression by another.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Modulo"] = 14] = "Modulo";
    /**
     * Groups an expression.
     */
    FilterExpressionOperatorType[FilterExpressionOperatorType["Grouping"] = 15] = "Grouping";
    return FilterExpressionOperatorType;
})({});
/**
 * @hidden
 */
let FilterExpressionOperatorType_$type = /*@__PURE__*/ markEnum('FilterExpressionOperatorType', 'None,0|Equal,1|NotEqual,2|GreaterThan,3|GreaterThanOrEqual,4|LessThan,5|LessThanOrEqual,6|And,7|Or,8|Not,9|Add,10|Subtract,11|Multiply,12|Divide,13|Modulo,14|Grouping,15');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indentifies the function type for a filter function expression.
 */
var FilterExpressionFunctionType = /*@__PURE__*/ (function (FilterExpressionFunctionType) {
    /**
     * Determines if a string contains another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Contains"] = 0] = "Contains";
    /**
     * Determines if a string ends with another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["EndsWith"] = 1] = "EndsWith";
    /**
     * Determines if a string starts with another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["StartsWith"] = 2] = "StartsWith";
    /**
     * Gets the length of a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Length"] = 3] = "Length";
    /**
     * Gets the index of a string within another.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["IndexOf"] = 4] = "IndexOf";
    /**
     * Replaces instances of a string within another with a separate string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Replace"] = 5] = "Replace";
    /**
     * Gets the substring of a string based on start index and optionally length.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Substring"] = 6] = "Substring";
    /**
     * Gets the lowercase representation of a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["ToLower"] = 7] = "ToLower";
    /**
     * Gets the uppercase representation of a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["ToUpper"] = 8] = "ToUpper";
    /**
     * Trims the starting and ending whitespace from a string.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Trim"] = 9] = "Trim";
    /**
     * Concatenates strings together.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Concat"] = 10] = "Concat";
    /**
     * Gets the day from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Day"] = 11] = "Day";
    /**
     * Gets the hour from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Hour"] = 12] = "Hour";
    /**
     * Gets the minute from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Minute"] = 13] = "Minute";
    /**
     * Gets the month from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Month"] = 14] = "Month";
    /**
     * Gets teh second from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Second"] = 15] = "Second";
    /**
     * Gets the year from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Year"] = 16] = "Year";
    /**
     * Rounds a numeric value.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Round"] = 17] = "Round";
    /**
     * Floors a numeric value.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Floor"] = 18] = "Floor";
    /**
     * Ceilings a numeric value.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Ceiling"] = 19] = "Ceiling";
    /**
     * Gets the date from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Date"] = 20] = "Date";
    /**
     * Gets the time from a date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Time"] = 21] = "Time";
    /**
     * Gets the current date/time.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Now"] = 22] = "Now";
    /**
     * Gets whether the value matches a certain type.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["IsOf"] = 23] = "IsOf";
    /**
     * Gets a value cast to a specific type.
     */
    FilterExpressionFunctionType[FilterExpressionFunctionType["Cast"] = 24] = "Cast";
    return FilterExpressionFunctionType;
})({});
/**
 * @hidden
 */
let FilterExpressionFunctionType_$type = /*@__PURE__*/ markEnum('FilterExpressionFunctionType', 'Contains,0|EndsWith,1|StartsWith,2|Length,3|IndexOf,4|Replace,5|Substring,6|ToLower,7|ToUpper,8|Trim,9|Concat,10|Day,11|Hour,12|Minute,13|Month,14|Second,15|Year,16|Round,17|Floor,18|Ceiling,19|Date,20|Time,21|Now,22|IsOf,23|Cast,24');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOperationFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IOperationFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFunctionFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IFunctionFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPropertyReferenceFilterExpression_$type = /*@__PURE__*/ new Type(null, 'IPropertyReferenceFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ILiteralFilterExpression_$type = /*@__PURE__*/ new Type(null, 'ILiteralFilterExpression', null, [IFilterExpression_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpression = /*@__PURE__*/ (() => {
    class FilterExpression extends Base {
        constructor() {
            super(...arguments);
            this.ay = false;
            this.az = false;
        }
        markAutoGenerated() {
            this.az = true;
        }
        get isAutoGenerated() {
            return this.az;
        }
        static isFilterExpression(a) {
            return typeCast(IFilterExpression_$type, a) !== null;
        }
        static isSchemaType(a) {
            return typeCast(DataSourceSchemaPropertyType_$type, a) !== null;
        }
        static operation(a, b, c) {
            if (FilterExpression.isFilterExpression(a)) {
                let d = a;
                if (FilterExpression.isFilterExpression(c)) {
                    let e = c;
                    return new OperationFilterExpression(d, b, e);
                }
                else {
                    return new OperationFilterExpression(d, b, c);
                }
            }
            else {
                let f = a;
                if (FilterExpression.isFilterExpression(c)) {
                    let g = c;
                    return new OperationFilterExpression(f, b, g);
                }
                else {
                    return new OperationFilterExpression(f, b, c);
                }
            }
        }
        static func(a, ...b) {
            return new FunctionFilterExpression(a, ...b);
        }
        a5() {
            this.ay = this.a3();
        }
        static property(a) {
            if (a == null) {
                return null;
            }
            let b = new PropertyReferenceFilterExpression(null);
            b.propertyReference = a;
            return b;
        }
        static nullLiteral() {
            let a = new LiteralFilterExpression(null, false);
            return a;
        }
        static literal(a) {
            let b = new LiteralFilterExpression(a, false);
            return b;
        }
        static unquotedLiteral(a) {
            let b = new LiteralFilterExpression(a, true);
            return b;
        }
        match(a, b, c) {
            let d = this.evaluate(a, b, c);
            return this.a4(d, b, c);
        }
        a4(a, b, c) {
            if (!this.ay) {
                return this.a0(a, b, c);
            }
            return a;
        }
        a0(a, b, c) {
            return Convert.toBoolean(a);
        }
        get_isPropertyReference() {
            return false;
        }
        get isPropertyReference() {
            return this.get_isPropertyReference();
        }
        get_isOperation() {
            return false;
        }
        get isOperation() {
            return this.get_isOperation();
        }
        get_isFunction() {
            return false;
        }
        get isFunction() {
            return this.get_isFunction();
        }
        get_isLiteral() {
            return false;
        }
        get isLiteral() {
            return this.get_isLiteral();
        }
        get_isNull() {
            return false;
        }
        get isNull() {
            return this.get_isNull();
        }
        group() {
            return FilterExpression.operation(this, 15, null);
        }
        and(a) {
            return FilterExpression.operation(this, 7, a);
        }
        or(a) {
            return FilterExpression.operation(this, 8, a);
        }
        not() {
            return FilterExpression.operation(this, 9, null);
        }
        add(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 10, b);
            }
            else {
                return FilterExpression.operation(this, 10, a);
            }
        }
        plus(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 10, b);
            }
            else {
                return FilterExpression.operation(this, 10, a);
            }
        }
        divide(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 13, b);
            }
            else {
                return FilterExpression.operation(this, 13, a);
            }
        }
        divideBy(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 13, b);
            }
            else {
                return FilterExpression.operation(this, 13, a);
            }
        }
        isEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 1, b);
            }
            else {
                return FilterExpression.operation(this, 1, a);
            }
        }
        isGreaterThan(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 3, b);
            }
            else {
                return FilterExpression.operation(this, 3, a);
            }
        }
        isGreaterThanOrEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 4, b);
            }
            else {
                return FilterExpression.operation(this, 4, a);
            }
        }
        isLessThan(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 5, b);
            }
            else {
                return FilterExpression.operation(this, 5, a);
            }
        }
        isLessThanOrEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 6, b);
            }
            else {
                return FilterExpression.operation(this, 6, a);
            }
        }
        modulo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 14, b);
            }
            else {
                return FilterExpression.operation(this, 14, a);
            }
        }
        multiply(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 12, b);
            }
            else {
                return FilterExpression.operation(this, 12, a);
            }
        }
        times(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 12, b);
            }
            else {
                return FilterExpression.operation(this, 12, a);
            }
        }
        isNotEqualTo(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 2, b);
            }
            else {
                return FilterExpression.operation(this, 2, a);
            }
        }
        subtract(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 11, b);
            }
            else {
                return FilterExpression.operation(this, 11, a);
            }
        }
        minus(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.operation(this, 11, b);
            }
            else {
                return FilterExpression.operation(this, 11, a);
            }
        }
        ceiling() {
            return FilterExpression.func(19, this);
        }
        concat(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(10, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(10, this, FilterExpression.literal(c));
            }
        }
        contains(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(0, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(0, this, FilterExpression.literal(c));
            }
        }
        day() {
            return FilterExpression.func(11, this);
        }
        endsWith(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(1, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(1, this, FilterExpression.literal(c));
            }
        }
        floor() {
            return FilterExpression.func(18, this);
        }
        hour() {
            return FilterExpression.func(12, this);
        }
        indexOf(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(4, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(4, this, FilterExpression.literal(c));
            }
        }
        length() {
            return FilterExpression.func(FilterExpressionFunctionType.Length, this);
        }
        minute() {
            return FilterExpression.func(13, this);
        }
        month() {
            return FilterExpression.func(14, this);
        }
        replace(a, b) {
            if (FilterExpression.isFilterExpression(a)) {
                let c = a;
                if (FilterExpression.isFilterExpression(b)) {
                    let d = b;
                    return FilterExpression.func(5, this, c, d);
                }
                else {
                    let e = b;
                    return FilterExpression.func(5, this, c, FilterExpression.literal(e));
                }
            }
            else {
                let f = a;
                if (FilterExpression.isFilterExpression(b)) {
                    let g = b;
                    return FilterExpression.func(5, this, FilterExpression.literal(f), g);
                }
                else {
                    let h = b;
                    return FilterExpression.func(5, this, FilterExpression.literal(f), FilterExpression.literal(h));
                }
            }
        }
        round() {
            return FilterExpression.func(17, this);
        }
        second() {
            return FilterExpression.func(15, this);
        }
        startsWith(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(2, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(2, this, FilterExpression.literal(c));
            }
        }
        substring(a, b = null) {
            if (FilterExpression.isFilterExpression(a)) {
                let c = a;
                if (b == null) {
                    return FilterExpression.func(6, this, c);
                }
                else {
                    if (FilterExpression.isFilterExpression(b)) {
                        let d = b;
                        return FilterExpression.func(6, this, c, d);
                    }
                    else {
                        let e = typeGetValue(b);
                        return FilterExpression.func(6, this, c, FilterExpression.literal(e));
                    }
                }
            }
            else {
                let f = typeGetValue(a);
                if (b == null) {
                    return FilterExpression.func(6, this, FilterExpression.literal(f));
                }
                else {
                    if (FilterExpression.isFilterExpression(b)) {
                        let g = b;
                        return FilterExpression.func(6, this, FilterExpression.literal(f), g);
                    }
                    else {
                        let h = typeGetValue(b);
                        return FilterExpression.func(6, this, FilterExpression.literal(f), FilterExpression.literal(h));
                    }
                }
            }
        }
        toLower() {
            return FilterExpression.func(7, this);
        }
        toUpper() {
            return FilterExpression.func(8, this);
        }
        trim() {
            return FilterExpression.func(9, this);
        }
        year() {
            return FilterExpression.func(16, this);
        }
        date() {
            return FilterExpression.func(20, this);
        }
        time() {
            return FilterExpression.func(21, this);
        }
        now() {
            return FilterExpression.func(22);
        }
        isOf(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(23, this, b);
            }
            else {
                let c = a;
                return FilterExpression.func(23, this, FilterExpression.literal(a));
            }
        }
        cast(a) {
            if (FilterExpression.isFilterExpression(a)) {
                let b = a;
                return FilterExpression.func(24, this, b);
            }
            else if (FilterExpression.isSchemaType(a)) {
                let c = EnumUtil.getEnumValue(DataSourceSchemaPropertyType_$type, a);
                return FilterExpression.func(24, this, FilterExpression.literal(enumGetBox(DataSourceSchemaPropertyType_$type, c)));
            }
            else {
                let d = a;
                return FilterExpression.func(24, this, FilterExpression.literal(d));
            }
        }
    }
    FilterExpression.$t = /*@__PURE__*/ markType(FilterExpression, 'FilterExpression', Base.$, [IFilterExpression_$type]);
    return FilterExpression;
})();
/**
 * @hidden
 */
let OperationFilterExpression = /*@__PURE__*/ (() => {
    class OperationFilterExpression extends FilterExpression {
        constructor(a, b, c) {
            super();
            this.a7 = null;
            this.a9 = false;
            this.a8 = null;
            this.ba = false;
            this.a6 = 0;
            if (a != null) {
                if (FilterExpression.isFilterExpression(a)) {
                    this.a7 = a;
                }
                else {
                    this.propertyName = a;
                }
            }
            if (c != null) {
                if (FilterExpression.isFilterExpression(c)) {
                    this.a8 = c;
                }
                else {
                    this.value = c;
                }
            }
            this.a6 = b;
        }
        get_isOperation() {
            return true;
        }
        a3() {
            return this.bg;
        }
        get isComparisonOperation() {
            let a = this.operator;
            switch (a) {
                case 0:
                case 1:
                case 2:
                case 3:
                case 5:
                case 6:
                case 4: return true;
            }
            return false;
        }
        get propertyName() {
            if (this.a7 == null || !this.a7.isPropertyReference) {
                return null;
            }
            return this.a7.propertyReference;
        }
        set propertyName(a) {
            this.left = FilterExpression.property(a);
        }
        get hasPropertyName() {
            return this.a7 != null && this.a7.isPropertyReference;
        }
        get value() {
            if (this.a8 == null) {
                return null;
            }
            if (this.a8.isNull) {
                return null;
            }
            if (!this.a8.isLiteral) {
                return null;
            }
            return this.a8.literalValue;
        }
        set value(a) {
            if (a == null) {
                this.right = FilterExpression.nullLiteral();
                return;
            }
            this.right = FilterExpression.literal(a);
        }
        get hasValue() {
            return this.a8 != null;
        }
        get left() {
            return this.a7;
        }
        set left(a) {
            this.a7 = a;
            this.a9 = true;
            this.a5();
        }
        get hasLeft() {
            return this.a9;
        }
        get right() {
            return this.a8;
        }
        set right(a) {
            this.a8 = a;
            this.ba = true;
            this.a5();
        }
        get hasRight() {
            return this.ba;
        }
        get operator() {
            return this.a6;
        }
        set operator(a) {
            let b = enumGetBox(FilterExpressionOperatorType_$type, this.a6);
            let c = a;
            if (c == null) {
                a = 0;
            }
            if ((typeof c == "number")) {
                let d = typeGetValue(c);
                if ((EnumUtil.getName(FilterExpressionOperatorType_$type, d) == undefined)) {
                    a = 0;
                }
                a = d;
            }
            else {
                a = (typeGetValue(EnumUtil.parse(FilterExpressionOperatorType_$type, c, true)));
            }
            this.a6 = a;
            this.a5();
        }
        get hasOperator() {
            return this.a6 != 0;
        }
        get bg() {
            switch (this.operator) {
                case 7:
                case 1:
                case 3:
                case 4:
                case 5:
                case 6:
                case 9:
                case 2:
                case 8: return true;
            }
            return false;
        }
        get_precedence() {
            switch (this.operator) {
                case 15: return 0;
                case 9: return 4;
                case 12: return 6;
                case 13: return 7;
                case 14: return 8;
                case 10: return 9;
                case 11: return 10;
                case 5: return 11;
                case 3: return 12;
                case 6: return 13;
                case 4: return 14;
                case 1: return 16;
                case 2: return 17;
                case 7: return 18;
                case 8: return 19;
                case 0: return 99;
            }
            return 99;
        }
        get precedence() {
            return this.get_precedence();
        }
        evaluate(a, b, c) {
            switch (this.operator) {
                case 10:
                case 13:
                case 14:
                case 12:
                case 11: return this.bi(a, b, c);
                case 0:
                case 1:
                case 3:
                case 4:
                case 5:
                case 6:
                case 2: return this.bj(a, b, c);
                case 7:
                case 9:
                case 8: return this.bk(a, b, c);
                case 15: if (this.left != null) {
                    return this.left.evaluate(a, b, c);
                }
                else {
                    if (this.right == null) {
                        return null;
                    }
                    return this.right.evaluate(a, b, c);
                }
            }
            throw new NotImplementedException(0);
        }
        bj(a, b, c) {
            let d = null;
            let e = null;
            let f = -1;
            if (this.left != null) {
                d = this.left.evaluate(a, b, c);
            }
            if (this.right != null) {
                e = this.right.evaluate(a, b, c);
            }
            if (d == null && e == null) {
                f = 0;
            }
            let g = null;
            let h = null;
            if (typeCast(IComparable_$type, d) !== null) {
                g = d;
            }
            if (typeCast(IComparable_$type, e) !== null) {
                h = e;
            }
            if (typeof d === 'number' && isNaN_(d) || typeof e === 'number' && isNaN_(e) || typeof d === 'number' && isNaN_(d) || typeof e === 'number' && isNaN_(e)) {
                return false;
            }
            if (g != null) {
                if (e == null) {
                    f = CompareUtil.compareToObject(g, 0);
                    if (f == 0) {
                        f = -1;
                    }
                }
                else {
                    f = CompareUtil.compareToObject(g, e);
                }
            }
            else if (h != null) {
                if (d == null) {
                    let i = CompareUtil.compareToObject(h, 0);
                    if (i == 0) {
                        f = 1;
                    }
                    else {
                        f = 1;
                        if (i == 0) {
                            f = 0;
                        }
                        if (i > 0) {
                            f = -1;
                        }
                    }
                }
                else {
                    let j = CompareUtil.compareToObject(h, d);
                    f = 1;
                    if (j == 0) {
                        f = 0;
                    }
                    if (j > 0) {
                        f = -1;
                    }
                }
            }
            else {
                let k = null;
                let l = null;
                if (d != null) {
                    k = d.toString();
                }
                if (e != null) {
                    l = e.toString();
                }
                if (k != null) {
                    if (l == null) {
                        f = 1;
                    }
                    else {
                        f = stringCompareTo(k, l);
                    }
                }
                else if (l != null) {
                    if (k == null) {
                        f = -1;
                    }
                    else {
                        let m = stringCompareTo(l, k);
                        f = 1;
                        if (m == 0) {
                            f = 0;
                        }
                        if (m > 0) {
                            f = -1;
                        }
                    }
                }
                else {
                    f = 0;
                }
            }
            switch (this.operator) {
                case 0:
                case 1: return f == 0;
                case 3: return f > 0;
                case 4: return f >= 0;
                case 5: return f < 0;
                case 6: return f <= 0;
                case 2: return f != 0;
            }
            throw new InvalidOperationException(0);
        }
        bk(a, b, c) {
            let d = null;
            let e = null;
            if (this.left != null) {
                d = this.left.evaluate(a, b, c);
            }
            if (this.right != null) {
                e = this.right.evaluate(a, b, c);
            }
            if (e == null && d == null) {
                return false;
            }
            if (e == null) {
                e = false;
            }
            if (d == null) {
                d = false;
            }
            switch (this.operator) {
                case 7: return d && e;
                case 9: if (this.left == null) {
                    return !e;
                }
                else {
                    return !d;
                }
                case 8: return d || e;
            }
            return false;
        }
        bi(a, b, c) {
            let d = null;
            let e = null;
            if (this.left != null) {
                d = this.left.evaluate(a, b, c);
            }
            if (this.right != null) {
                e = this.right.evaluate(a, b, c);
            }
            if (d == null) {
                return e;
            }
            if (e == null) {
                return d;
            }
            if (d == null && e == null) {
                return 0;
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return d + e;
                    case 13: return d / e;
                    case 14: return d % e;
                    case 12: return d * e;
                    case 11: return d - e;
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return d + e;
                    case 13: return d / e;
                    case 14: return d % e;
                    case 12: return d * e;
                    case 11: return d - e;
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return d + e;
                    case 13: return d / e;
                    case 14: return d % e;
                    case 12: return d * e;
                    case 11: return d - e;
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            if (typeof d === 'number' || typeof e === 'number') {
                switch (this.operator) {
                    case 10: return typeGetValue(d) + typeGetValue(e);
                    case 13: return intDivide(typeGetValue(d), typeGetValue(e));
                    case 14: return typeGetValue(d) % typeGetValue(e);
                    case 12: return typeGetValue(d) * typeGetValue(e);
                    case 11: return typeGetValue(d) - typeGetValue(e);
                }
            }
            throw new NotImplementedException(0);
        }
    }
    OperationFilterExpression.$t = /*@__PURE__*/ markType(OperationFilterExpression, 'OperationFilterExpression', FilterExpression.$, [IOperationFilterExpression_$type]);
    return OperationFilterExpression;
})();
/**
 * @hidden
 */
let FunctionFilterExpression = /*@__PURE__*/ (() => {
    class FunctionFilterExpression extends FilterExpression {
        constructor(a, ...b) {
            super();
            this.a7 = 19;
            this.a6 = new FilterExpressionCollection();
            this.a7 = a;
            for (let c = 0; c < b.length; c++) {
                this.a6.add(b[c]);
            }
        }
        get_isFunction() {
            return true;
        }
        a3() {
            return this.a8;
        }
        get functionType() {
            return this.a7;
        }
        set functionType(a) {
            let b = enumGetBox(FilterExpressionFunctionType_$type, this.a7);
            let c = a;
            if (c == null) {
                a = 0;
            }
            if ((typeof c == "number")) {
                let d = typeGetValue(c);
                if ((EnumUtil.getName(FilterExpressionFunctionType_$type, d) == undefined)) {
                    a = 0;
                }
                a = d;
            }
            else {
                a = (typeGetValue(EnumUtil.parse(FilterExpressionFunctionType_$type, c, true)));
            }
            this.a7 = a;
            this.a5();
        }
        get a8() {
            switch (this.functionType) {
                case 1:
                case 2:
                case 0: return true;
            }
            return false;
        }
        get functionArguments() {
            return this.a6;
        }
        get hasFunctionArguments() {
            return this.a6.j.count > 0;
        }
        evaluate(a, b, c) {
            let d = null;
            let e = null;
            let f = null;
            let g = null;
            let h = this.functionArguments.j;
            if (h.count > 0) {
                for (let i = 0; i < h.count; i++) {
                    let j = null;
                    if (h.item(i) != null) {
                        j = h.item(i).evaluate(a, b, c);
                    }
                    switch (i) {
                        case 0:
                            d = j;
                            break;
                        case 1:
                            e = j;
                            break;
                        case 2:
                            f = j;
                            break;
                        case 3:
                            g = j;
                            break;
                    }
                    if (i > 3) {
                        break;
                    }
                }
            }
            switch (this.functionType) {
                case 19:
                    if (d == null) {
                        d = 0;
                    }
                    return Math.ceil(d);
                case 18:
                    if (d == null) {
                        d = 0;
                    }
                    return Math.floor(d);
                case 17:
                    if (d == null) {
                        d = 0;
                    }
                    if (typeof d === 'number') {
                        return Math.round(d);
                    }
                    return Math.round(d);
                case 11:
                    if (d == null) {
                        return 0;
                    }
                    return d.getDate();
                case 12:
                    if (d == null) {
                        return 0;
                    }
                    return d.getHours();
                case 13:
                    if (d == null) {
                        return 0;
                    }
                    return d.getMinutes();
                case 14:
                    if (d == null) {
                        return 0;
                    }
                    return dateGetMonth(d);
                case 16:
                    if (d == null) {
                        return 0;
                    }
                    return d.getFullYear();
                case 15:
                    if (d == null) {
                        return 0;
                    }
                    return d.getSeconds();
                case 20:
                    if (d == null) {
                        return 0;
                    }
                    return dateGetDate(d);
                case 21:
                    if (d == null) {
                        return 0;
                    }
                    return d;
                case 22: return dateNow();
                case 23:
                    let k = this.bb(e, f);
                    let l = d;
                    if (l == null) {
                        return true;
                    }
                    if (k == null) {
                        return false;
                    }
                    if (k.isAssignableFrom(getInstanceType(l))) {
                        return true;
                    }
                    return false;
                case 24:
                    let m = this.bb(e, d);
                    let n = d;
                    if (n == null) {
                        return null;
                    }
                    if (m == null) {
                        return null;
                    }
                    return this.a9(n, m);
                case 10:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringConcat(d, e);
                case 1:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringEndsWith(d, e);
                case 4:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return d.indexOf(e);
                case FilterExpressionFunctionType.Length:
                    if (d == null) {
                        d = "";
                    }
                    return d.length;
                case 5:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    if (f == null) {
                        f = "";
                    }
                    return stringReplace(d, e, f);
                case 2:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringStartsWith(d, e);
                case 6:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = 0;
                    }
                    if (f != null) {
                        return d.substr(typeGetValue(e), typeGetValue(f));
                    }
                    else {
                        return d.substr(typeGetValue(e));
                    }
                case 0:
                    if (d == null) {
                        d = "";
                    }
                    if (e == null) {
                        e = "";
                    }
                    return stringContains(d, e);
                case 7:
                    if (d == null) {
                        d = "";
                    }
                    return d.toLowerCase();
                case 8:
                    if (d == null) {
                        d = "";
                    }
                    return d.toUpperCase();
                case 9:
                    if (d == null) {
                        d = "";
                    }
                    return d.trim();
            }
            throw new NotImplementedException(0);
        }
        get_precedence() {
            switch (this.functionType) {
                case 23: return 15;
                case 24: return 5;
            }
            return 2;
        }
        get precedence() {
            return this.get_precedence();
        }
        a9(a, b) {
            if (b == String_$type) {
                if (a == null) {
                    return "";
                }
                return a.toString();
            }
            else if (b == Number_$type || b == Number_$type || b == Number_$type) {
                return Convert.toInt321(a);
            }
            else if (b == Boolean_$type) {
                return Convert.toBoolean(a);
            }
            else if (b == Number_$type) {
                return Convert.toByte1(a);
            }
            else if (b == Date_$type) {
                return Convert.toDateTime(a);
            }
            else if (b == Number_$type || b == Number_$type) {
                return Convert.toInt64(a);
            }
            else if (b == Number_$type) {
                return Convert.toDecimal2(a);
            }
            else {
                return a;
            }
        }
        bb(a, b) {
            if (typeCast(DataSourceSchemaPropertyType_$type, a) !== null || typeof a === 'number') {
                let c = typeGetValue(a);
                switch (c) {
                    case 2: return Boolean_$type;
                    case 10: return Number_$type;
                    case 9: return Date_$type;
                    case 8: return Date_$type;
                    case 6: return Number_$type;
                    case 5: return Number_$type;
                    case 1: return Number_$type;
                    case 3: return Number_$type;
                    case 11:
                        if (b != null && typeof b === 'string') {
                            return this.ba(b);
                        }
                        return Base.$;
                    case 4: return Number_$type;
                    case 7: return Number_$type;
                    case 0: return String_$type;
                }
            }
            if (typeof a === 'string') {
                return this.ba(b);
            }
            return Base.$;
        }
        ba(a) {
            switch (a) {
                case "Edm.Boolean":
                case "Boolean":
                case "bool":
                case "boolean": return Boolean_$type;
                case "Edm.Byte":
                case "Byte":
                case "byte":
                case "Edm.SByte":
                case "SByte": return Number_$type;
                case "Edm.DateTimeOffset":
                case "DateTimeOffset": return Date_$type;
                case "Edm.DateTime":
                case "DateTime":
                case "Calendar":
                case "datetime":
                case "calendar":
                case "Edm.Time":
                case "Time":
                case "time": return Date_$type;
                case "Edm.Decimal":
                case "Decimal":
                case "decimal": return Number_$type;
                case "Edm.Double":
                case "Double":
                case "double": return Number_$type;
                case "Edm.Float":
                case "Float":
                case "float":
                case "Edm.Single":
                case "Single":
                case "single": return Number_$type;
                case "Edm.Int16":
                case "Int16":
                case "Short":
                case "short": return Number_$type;
                case "Edm.Int32":
                case "Int32":
                case "int":
                case "Integer": return Number_$type;
                case "Edm.Int64":
                case "Int64":
                case "long":
                case "Long": return Number_$type;
                case "Edm.String":
                case "String":
                case "string": return String_$type;
            }
            return Base.$;
        }
    }
    FunctionFilterExpression.$t = /*@__PURE__*/ markType(FunctionFilterExpression, 'FunctionFilterExpression', FilterExpression.$, [IFunctionFilterExpression_$type]);
    return FunctionFilterExpression;
})();
/**
 * @hidden
 */
let PropertyReferenceFilterExpression = /*@__PURE__*/ (() => {
    class PropertyReferenceFilterExpression extends FilterExpression {
        constructor(a) {
            super();
            this.a6 = null;
            this.a6 = a;
        }
        get_isPropertyReference() {
            return true;
        }
        get_precedence() {
            return 99;
        }
        get precedence() {
            return this.get_precedence();
        }
        a3() {
            return false;
        }
        get propertyReference() {
            return this.a6;
        }
        set propertyReference(a) {
            this.a6 = a;
        }
        evaluate(a, b, c) {
            let d = b.getItemValue(a, this.propertyReference);
            return d;
        }
    }
    PropertyReferenceFilterExpression.$t = /*@__PURE__*/ markType(PropertyReferenceFilterExpression, 'PropertyReferenceFilterExpression', FilterExpression.$, [IPropertyReferenceFilterExpression_$type]);
    return PropertyReferenceFilterExpression;
})();
/**
 * @hidden
 */
let LiteralFilterExpression = /*@__PURE__*/ (() => {
    class LiteralFilterExpression extends FilterExpression {
        constructor(a, b) {
            super();
            this.a7 = null;
            this.a6 = false;
            this.a7 = a;
        }
        get_precedence() {
            return 99;
        }
        get precedence() {
            return this.get_precedence();
        }
        get_isLiteral() {
            return true;
        }
        get_isNull() {
            return this.literalValue == null;
        }
        get literalValue() {
            return this.a7;
        }
        set literalValue(a) {
            this.a7 = a;
        }
        get leaveUnquoted() {
            return this.a6;
        }
        set leaveUnquoted(a) {
            this.a6 = a;
        }
        a3() {
            return typeCast(Boolean_$type, this.literalValue) !== null;
        }
        evaluate(a, b, c) {
            return this.literalValue;
        }
    }
    LiteralFilterExpression.$t = /*@__PURE__*/ markType(LiteralFilterExpression, 'LiteralFilterExpression', FilterExpression.$, [ILiteralFilterExpression_$type]);
    return LiteralFilterExpression;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrLocalDataSourceModule {
    static register() {
        TypeRegistrar.register('LocalDataSource', LocalDataSource.$type);
        TypeRegistrar.register('LocalDataSource', LocalDataSource.$type);
        TypeRegistrar.register('LiteralFilterExpression', LiteralFilterExpression.$type);
        TypeRegistrar.register('LiteralFilterExpression', LiteralFilterExpression.$type);
        TypeRegistrar.register('PropertyReferenceFilterExpression', PropertyReferenceFilterExpression.$type);
        TypeRegistrar.register('PropertyReferenceFilterExpression', PropertyReferenceFilterExpression.$type);
        TypeRegistrar.register('OperationFilterExpression', OperationFilterExpression.$type);
        TypeRegistrar.register('OperationFilterExpression', OperationFilterExpression.$type);
        TypeRegistrar.register('FunctionFilterExpression', FunctionFilterExpression.$type);
        TypeRegistrar.register('FunctionFilterExpression', FunctionFilterExpression.$type);
    }
}

/**
 * Represents a colleciton of filter expressions.
*/
class IgrFilterExpressionCollection {
    createImplementation() {
        return new FilterExpressionCollection();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    item(index, value) {
        let filter = null;
        if (value !== undefined) {
            filter = this.set(index, value == null ? null : value);
        }
        else {
            filter = this.get(index);
        }
        return filter;
    }
    get count() {
        return this.i.size();
    }
    toArray() {
        let arr = [];
        for (let i = 0; i < this.count; i++) {
            arr[i] = this.item(i);
        }
        return arr;
    }
    *[Symbol.iterator]() {
        for (let i = 0; i < this.count; i++) {
            let item = this.item(i);
            if (item.externalObject) {
                item = item.externalObject;
            }
            yield item;
        }
    }
    get syncTarget() {
        if (this.i.syncTarget == null) {
            return null;
        }
        if (!this.i.syncTarget.externalObject) {
            let e = new IgrFilterExpressionCollection();
            e._implementation = this.i.syncTarget;
            this.i.syncTarget.externalObject = e;
        }
        return this.i.syncTarget.externalObject;
    }
    set syncTarget(v) {
        v == null ? this.i.syncTarget = null : this.i.syncTarget = v.i;
    }
    get onChanged() {
        return this.i.onChanged;
    }
    set onChanged(v) {
        this.i.onChanged = v;
    }
    findByName(name) {
        if (this.syncTarget != null && this.syncTarget.findByName && this.syncTarget.findByName(name)) {
            return this.syncTarget.findByName(name);
        }
        return null;
    }
    add(item) {
        let iv = this.i.add(item);
        return (iv);
    }
    insert(index, item) {
        this.i.insert(index, item);
    }
    clear() {
        this.i.clear();
    }
    get(index) {
        let iv = this.i.get(index);
        return (iv);
    }
    indexOf(item) {
        let iv = this.i.indexOf(item);
        return (iv);
    }
    remove(item) {
        let iv = this.i.remove(item);
        return (iv);
    }
    removeAt(index) {
        let iv = this.i.removeAt(index);
        return (iv);
    }
    set(index, value) {
        let iv = this.i.set(index, value);
        return (iv);
    }
    size() {
        let iv = this.i.size();
        return (iv);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataTask = /*@__PURE__*/ (() => {
    class AsyncVirtualDataTask extends Base {
        constructor() {
            super(...arguments);
            this._hasErrors = false;
            this._isRunning = false;
            this._isCancelled = false;
            this._isCompleted = false;
            this._result = null;
            this._run = null;
        }
        get hasErrors() {
            return this._hasErrors;
        }
        set hasErrors(a) {
            this._hasErrors = a;
        }
        get isRunning() {
            return this._isRunning;
        }
        set isRunning(a) {
            this._isRunning = a;
        }
        get isCancelled() {
            return this._isCancelled;
        }
        set isCancelled(a) {
            this._isCancelled = a;
        }
        get isCompleted() {
            return this._isCompleted;
        }
        set isCompleted(a) {
            this._isCompleted = a;
        }
        get result() {
            return this._result;
        }
        set result(a) {
            this._result = a;
        }
        get run() {
            return this._run;
        }
        set run(a) {
            this._run = a;
        }
    }
    AsyncVirtualDataTask.$t = /*@__PURE__*/ markType(AsyncVirtualDataTask, 'AsyncVirtualDataTask');
    return AsyncVirtualDataTask;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataSourceDataProviderWorkerSettings = /*@__PURE__*/ (() => {
    class AsyncVirtualDataSourceDataProviderWorkerSettings extends Base {
        constructor() {
            super(...arguments);
            this._pageSizeRequested = 0;
            this._timeoutMilliseconds = 0;
            this._pageLoaded = null;
            this._batchCompleted = null;
            this._executionContext = null;
        }
        get pageSizeRequested() {
            return this._pageSizeRequested;
        }
        set pageSizeRequested(a) {
            this._pageSizeRequested = a;
        }
        get timeoutMilliseconds() {
            return this._timeoutMilliseconds;
        }
        set timeoutMilliseconds(a) {
            this._timeoutMilliseconds = a;
        }
        get pageLoaded() {
            return this._pageLoaded;
        }
        set pageLoaded(a) {
            this._pageLoaded = a;
        }
        get batchCompleted() {
            return this._batchCompleted;
        }
        set batchCompleted(a) {
            this._batchCompleted = a;
        }
        get executionContext() {
            return this._executionContext;
        }
        set executionContext(a) {
            this._executionContext = a;
        }
    }
    AsyncVirtualDataSourceDataProviderWorkerSettings.$t = /*@__PURE__*/ markType(AsyncVirtualDataSourceDataProviderWorkerSettings, 'AsyncVirtualDataSourceDataProviderWorkerSettings');
    return AsyncVirtualDataSourceDataProviderWorkerSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataSourceProviderTaskDataHolder = /*@__PURE__*/ (() => {
    class AsyncVirtualDataSourceProviderTaskDataHolder extends Base {
    }
    AsyncVirtualDataSourceProviderTaskDataHolder.$t = /*@__PURE__*/ markType(AsyncVirtualDataSourceProviderTaskDataHolder, 'AsyncVirtualDataSourceProviderTaskDataHolder');
    return AsyncVirtualDataSourceProviderTaskDataHolder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncDataSourcePageTaskHolder = /*@__PURE__*/ (() => {
    class AsyncDataSourcePageTaskHolder extends Base {
        constructor() {
            super(...arguments);
            this._task = null;
        }
        get task() {
            return this._task;
        }
        set task(a) {
            this._task = a;
        }
    }
    AsyncDataSourcePageTaskHolder.$t = /*@__PURE__*/ markType(AsyncDataSourcePageTaskHolder, 'AsyncDataSourcePageTaskHolder');
    return AsyncDataSourcePageTaskHolder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncDataSourcePageRequest = /*@__PURE__*/ (() => {
    class AsyncDataSourcePageRequest extends Base {
        constructor(a, b) {
            super();
            this.e = 0;
            this.f = 0;
            this.a = null;
            this.c = false;
            this.e = a;
            this.f = b;
        }
        get index() {
            return this.e;
        }
        set index(a) {
            this.e = a;
        }
        get retryDelay() {
            return this.f;
        }
        set retryDelay(a) {
            this.f = a;
        }
        get taskHolder() {
            return this.a;
        }
        set taskHolder(a) {
            this.a = a;
        }
        get isDone() {
            return this.c;
        }
        set isDone(a) {
            this.c = a;
        }
    }
    AsyncDataSourcePageRequest.$t = /*@__PURE__*/ markType(AsyncDataSourcePageRequest, 'AsyncDataSourcePageRequest');
    return AsyncDataSourcePageRequest;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeakReference = /*@__PURE__*/ (() => {
    class WeakReference extends Base {
        constructor(a) {
            super();
            this.b = null;
            this.b = a;
        }
        get_a() {
            return true;
        }
        get a() {
            return this.get_a();
        }
        get_c() {
            return this.b;
        }
        set_c(a) {
            this.b = a;
        }
        get c() {
            return this.get_c();
        }
        set c(a) {
            this.set_c(a);
        }
    }
    WeakReference.$t = /*@__PURE__*/ markType(WeakReference, 'WeakReference');
    return WeakReference;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncVirtualDataSourceProviderWorker = /*@__PURE__*/ (() => {
    class AsyncVirtualDataSourceProviderWorker extends Base {
        constructor(a) {
            super();
            this.r = new LinkedList$1(AsyncDataSourcePageRequest.$);
            this.p = new List$1(AsyncDataSourcePageRequest.$, 0);
            this.ac = {};
            this.i = true;
            this.u = 0;
            this.t = 0;
            this.v = 0;
            this.e = null;
            this.s = -1;
            this.as = null;
            this.aq = null;
            this.ar = null;
            this.h = false;
            this._isShutdown = false;
            this.g = false;
            this.i = true;
            this.u = a.pageSizeRequested;
            this.t = this.u;
            this.v = a.timeoutMilliseconds;
            this.as = new WeakReference(a.pageLoaded);
            this.aq = new WeakReference(a.batchCompleted);
            this.ar = new WeakReference(a.executionContext);
        }
        get tasks() {
            return this.p;
        }
        get pageLoaded() {
            if (this.as == null) {
                return null;
            }
            return this.as.c;
        }
        get batchCompleted() {
            if (this.aq == null) {
                return null;
            }
            return this.aq.c;
        }
        get executionContext() {
            if (this.ar == null) {
                return null;
            }
            return this.ar.c;
        }
        get actualPageSize() {
            return this.t;
        }
        set actualPageSize(a) {
            this.t = a;
        }
        get actualCount() {
            return this.s;
        }
        set actualCount(a) {
            this.s = a;
        }
        get actualSchema() {
            return this.e;
        }
        set actualSchema(a) {
            this.e = a;
        }
        get populatedActualPageSize() {
            return this.h;
        }
        set populatedActualPageSize(a) {
            this.h = a;
        }
        get isRunning() {
            return this.i;
        }
        set isRunning(a) {
            this.i = a;
        }
        addPageRequest(a, b) {
            return this.addPageRequestWithRetry(a, b, 200);
        }
        addPageRequestWithRetry(a, b, c) {
            if (this.isShutdown) {
                return false;
            }
            if (b == 2) {
                this.r.e(new AsyncDataSourcePageRequest(a, c));
            }
            else {
                this.r.f(new AsyncDataSourcePageRequest(a, c));
            }
            return true;
        }
        removePageRequest(a) {
            let b = null;
            let c = this.r.c;
            while (c != null) {
                let d = c.c;
                if (d.index == a) {
                    b = c;
                    break;
                }
                c = c.a;
            }
            if (b != null) {
                this.r.h(b);
            }
        }
        get isShutdown() {
            return this._isShutdown;
        }
        set isShutdown(a) {
            this._isShutdown = a;
        }
        removeAllPageRequests() {
            this.r.g();
        }
        shutdown() {
            this.as = null;
            this.aq = null;
            this.ar = null;
            this.isShutdown = true;
            this.i = false;
        }
        initialize() {
        }
        getTaskDataHolder() {
            return null;
        }
        getTasksData(a) {
        }
        removeCompletedTaskData(a, b) {
        }
        getCompletedTaskData(a, b) {
        }
        runATask() {
            for (let a = 0; a < this.p.count; a++) {
                if (!this.p.item(a).taskHolder.task.isRunning && !this.p.item(a).isDone && !this.p.item(a).taskHolder.task.isCompleted && !this.p.item(a).taskHolder.task.isCancelled) {
                    this.p.item(a).taskHolder.task.isRunning = true;
                    this.p.item(a).taskHolder.task.run();
                    break;
                }
            }
        }
        checkAndPotentiallyWaitOnTasks(a) {
            this.runATask();
            for (let b = 0; b < a.length; b++) {
                if (a[b].isDone || a[b].taskHolder.task.isCompleted || a[b].taskHolder.task.isCancelled) {
                    return b;
                }
            }
            return -1;
        }
        doWork() {
            if (!this.g) {
                this.g = true;
                this.initialize();
            }
            {
                let a = null;
                let b = null;
                let c = this.p.count;
                if (this.r.c != null && c < 2) {
                    let d = this.r.c;
                    this.r.i();
                    this.makeTaskForRequest(d.c, d.c.retryDelay);
                    c = this.p.count;
                }
                if (c > 0) {
                    a = new Array(c);
                    for (let e = 0; e < c; e++) {
                        a[e] = this.p.item(e);
                    }
                    b = this.getTaskDataHolder();
                    this.getTasksData(b);
                }
                if (a != null && a.length > 0) {
                    let f = this.checkAndPotentiallyWaitOnTasks(a);
                    if (!this.i) {
                        return;
                    }
                    if (f >= 0) {
                        let g = a[f];
                        this.getCompletedTaskData(b, f);
                        this.p.remove(g);
                        this.removeCompletedTaskData(b, f);
                        this.processCompletedTask(g.taskHolder, g.retryDelay, g.index, b);
                    }
                }
                else {
                }
                if (!this.i) {
                    return;
                }
                if (this.i) {
                    window.setTimeout(runOn(this, this.doWork), 100);
                }
            }
        }
        makeTaskForRequest(a, b) {
        }
        processCompletedTask(a, b, c, d) {
        }
        retryIndex(a, b) {
            let c = b * 2;
            if (b > 20000) {
                this.removePageRequest(a);
            }
            if (this.ar == null) {
                this.shutdown();
                return;
            }
            let d = typeCast(IDataSourceExecutionContext_$type, this.ar.c);
            if (d == null) {
                this.shutdown();
                return;
            }
            d.executeDelayed(() => this.addPageRequestWithRetry(a, 0, c), b);
        }
        isLastPage(a) {
            if (this.s < 0) {
                return false;
            }
            if ((this.s - (a * this.t)) < this.t) {
                return true;
            }
            return false;
        }
        createBatchRequest(a) {
        }
    }
    AsyncVirtualDataSourceProviderWorker.$t = /*@__PURE__*/ markType(AsyncVirtualDataSourceProviderWorker, 'AsyncVirtualDataSourceProviderWorker');
    AsyncVirtualDataSourceProviderWorker.maxSimultaneousExecutingTasks = 2;
    AsyncVirtualDataSourceProviderWorker.maxRetryDelay = 20000;
    AsyncVirtualDataSourceProviderWorker.initialRetryDelay = 200;
    return AsyncVirtualDataSourceProviderWorker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterFactory = /*@__PURE__*/ (() => {
    class FilterFactory extends Base {
        static get instance() {
            if (FilterFactory.as == null) {
                FilterFactory.as = new FilterFactory();
            }
            return FilterFactory.as;
        }
        static build(a) {
            let b = FilterFactory.instance;
            return a(b);
        }
        property(a) {
            return FilterExpression.property(a);
        }
        literal(a) {
            return FilterExpression.literal(a);
        }
        group(a) {
            return FilterExpression.operation(a, 15, null);
        }
        and(a, b) {
            return FilterExpression.operation(a, 7, b);
        }
        or(a, b) {
            return FilterExpression.operation(a, 8, b);
        }
        not(a) {
            return FilterExpression.operation(a, 9, null);
        }
        add(a, b) {
            return FilterExpression.operation(a, 10, b);
        }
        divide(a, b) {
            return FilterExpression.operation(a, 13, b);
        }
        equal(a, b) {
            return FilterExpression.operation(a, 1, b);
        }
        greaterThan(a, b) {
            return FilterExpression.operation(a, 3, b);
        }
        greaterThanOrEqual(a, b) {
            return FilterExpression.operation(a, 4, b);
        }
        lessThan(a, b) {
            return FilterExpression.operation(a, 5, b);
        }
        lessThanOrEqual(a, b) {
            return FilterExpression.operation(a, 6, b);
        }
        modulus(a, b) {
            return FilterExpression.operation(a, 14, b);
        }
        multiply(a, b) {
            return FilterExpression.operation(a, 12, b);
        }
        notEqual(a, b) {
            return FilterExpression.operation(a, 2, b);
        }
        subtract(a, b) {
            return FilterExpression.operation(a, 11, b);
        }
        ceiling(a) {
            return FilterExpression.func(19, a);
        }
        concat(a, b) {
            return FilterExpression.func(10, a, b);
        }
        concat1(a, b) {
            return FilterExpression.func(10, a, FilterExpression.literal(b));
        }
        contains(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(0, a, b);
        }
        day(a) {
            return FilterExpression.func(11, a);
        }
        endsWith(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(1, a, b);
        }
        floor(a) {
            return FilterExpression.func(18, a);
        }
        hour(a) {
            return FilterExpression.func(12, a);
        }
        indexOf(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(4, a, b);
        }
        length(a) {
            return FilterExpression.func(FilterExpressionFunctionType.Length, a);
        }
        minute(a) {
            return FilterExpression.func(13, a);
        }
        month(a) {
            return FilterExpression.func(14, a);
        }
        replace(a, b, c) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            if (typeof c === 'string') {
                c = FilterExpression.literal(c);
            }
            return FilterExpression.func(5, a, b, c);
        }
        round(a) {
            return FilterExpression.func(17, a);
        }
        second(a) {
            return FilterExpression.func(15, a);
        }
        startsWith(a, b) {
            if (typeof b === 'string') {
                b = FilterExpression.literal(b);
            }
            return FilterExpression.func(2, a, b);
        }
        substring(a, b, c = null) {
            if (typeof b === 'number') {
                b = FilterExpression.literal(b);
            }
            if (c != null && typeof c === 'number') {
                c = FilterExpression.literal(c);
            }
            if (c != null) {
                return FilterExpression.func(6, a, b, c);
            }
            else {
                return FilterExpression.func(6, a, b);
            }
        }
        toLower(a) {
            return FilterExpression.func(7, a);
        }
        toUpper(a) {
            return FilterExpression.func(8, a);
        }
        trim(a) {
            return FilterExpression.func(9, a);
        }
        year(a) {
            return FilterExpression.func(16, a);
        }
        date(a) {
            return FilterExpression.func(20, a);
        }
        time(a) {
            return FilterExpression.func(21, a);
        }
        now() {
            return FilterExpression.func(16);
        }
        isOf(a, b) {
            return FilterExpression.func(16, a);
        }
        cast(a, b) {
            return FilterExpression.func(24, a);
        }
    }
    FilterFactory.$t = /*@__PURE__*/ markType(FilterFactory, 'FilterFactory');
    FilterFactory.as = null;
    return FilterFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionVisitor = /*@__PURE__*/ (() => {
    class FilterExpressionVisitor extends Base {
        visit(a) {
            if (a == null) {
                throw new InvalidOperationException(1, "Expected an expression but found none");
            }
            if (a.isOperation) {
                this.visitOperationExpression(a);
            }
            else if (a.isFunction) {
                this.visitFunctionExpression(a);
            }
            else if (a.isLiteral) {
                this.visitLiteralExpression(a);
            }
            else if (a.isPropertyReference) {
                this.visitPropertyReferenceExpression(a);
            }
        }
        visitOperationExpression(a) {
            if (a.left != null) {
                this.visit(a.left);
            }
            if (a.right != null) {
                this.visit(a.right);
            }
        }
        visitFunctionExpression(a) {
            for (let b = 0; b < a.functionArguments.j.count; b++) {
                this.visit(a.functionArguments.j.item(b));
            }
        }
        visitLiteralExpression(a) {
        }
        visitPropertyReferenceExpression(a) {
        }
    }
    FilterExpressionVisitor.$t = /*@__PURE__*/ markType(FilterExpressionVisitor, 'FilterExpressionVisitor');
    return FilterExpressionVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * The row type.
 */
var DataSourceRowType = /*@__PURE__*/ (function (DataSourceRowType) {
    /**
     * Normal row
     */
    DataSourceRowType[DataSourceRowType["Normal"] = 0] = "Normal";
    /**
     * Section header
     */
    DataSourceRowType[DataSourceRowType["SectionHeader"] = 1] = "SectionHeader";
    /**
     * Section footer
     */
    DataSourceRowType[DataSourceRowType["SectionFooter"] = 2] = "SectionFooter";
    /**
     * A shited row
     */
    DataSourceRowType[DataSourceRowType["ShiftedRow"] = 3] = "ShiftedRow";
    /**
     * A summary row at the root level
     */
    DataSourceRowType[DataSourceRowType["SummaryRowRoot"] = 4] = "SummaryRowRoot";
    /**
     * A summary row at the section level
     */
    DataSourceRowType[DataSourceRowType["SummaryRowSection"] = 5] = "SummaryRowSection";
    /**
     * Custom
     */
    DataSourceRowType[DataSourceRowType["Custom"] = 6] = "Custom";
    return DataSourceRowType;
})({});
/**
 * @hidden
 */
let DataSourceRowType_$type = /*@__PURE__*/ markEnum('DataSourceRowType', 'Normal,0|SectionHeader,1|SectionFooter,2|ShiftedRow,3|SummaryRowRoot,4|SummaryRowSection,5|Custom,6');

/**
 * Provides information about a schema change event that has occurred.
*/
class IgrDataSourceSchemaChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the new schema that has been provided.
    */
    get schema() {
        return this.i.schema;
    }
    /**
     * Gets the current full count of items in the data source.
    */
    get count() {
        return this.i.count;
    }
}

/**
 * Provides information about row expansion or collapse.
*/
class IgrDataSourceRowExpansionChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The index of the row being expanded or collapsed.
    */
    get rowIndex() {
        return this.i.rowIndex;
    }
    /**
     * The previous state of the row. True is expanded, False is collapsed.
    */
    get oldState() {
        return this.i.oldState;
    }
    /**
     * The new state of the row. True is expanded, False is collapsed.
    */
    get newState() {
        return this.i.newState;
    }
}

/**
 * Provides information about a schema change event.
*/
class IgrDataSourceDataProviderSchemaChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Represents the current schema for the data provider.
    */
    get schema() {
        return this.i.schema;
    }
    /**
     * Represents the current full count for the data provider. May be -1 if this information is not available yet.
    */
    get count() {
        return this.i.count;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourcePage_$type = /*@__PURE__*/ new Type(null, 'IDataSourcePage');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceUpdateNotifier_$type = /*@__PURE__*/ new Type(null, 'IDataSourceUpdateNotifier');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataSourceVirtualDataProvider_$type = /*@__PURE__*/ new Type(null, 'IDataSourceVirtualDataProvider', null, [IDataSourceDataProvider_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the priority for a page request.
 */
var DataSourcePageRequestPriority = /*@__PURE__*/ (function (DataSourcePageRequestPriority) {
    /**
     * Indicates a request with low priority.
     */
    DataSourcePageRequestPriority[DataSourcePageRequestPriority["Low"] = 0] = "Low";
    /**
     * Indicates a request with normal priority.
     */
    DataSourcePageRequestPriority[DataSourcePageRequestPriority["Normal"] = 1] = "Normal";
    /**
     * Indicates a request with high priority.
     */
    DataSourcePageRequestPriority[DataSourcePageRequestPriority["High"] = 2] = "High";
    return DataSourcePageRequestPriority;
})({});
/**
 * @hidden
 */
let DataSourcePageRequestPriority_$type = /*@__PURE__*/ markEnum('DataSourcePageRequestPriority', 'Low,0|Normal,1|High,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalDataSource_$type = /*@__PURE__*/ new Type(null, 'IExternalDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalLocalDataSource_$type = /*@__PURE__*/ new Type(null, 'IExternalLocalDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IExternalVirtualDataSource_$type = /*@__PURE__*/ new Type(null, 'IExternalVirtualDataSource');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISectionInformation_$type = /*@__PURE__*/ new Type(null, 'ISectionInformation');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultSectionInformation = /*@__PURE__*/ (() => {
    class DefaultSectionInformation extends Base {
        constructor(a, b, c, d, e) {
            super();
            this.e = 0;
            this.d = 0;
            this.a = null;
            this.b = null;
            this.c = null;
            this.e = a;
            this.d = b;
            this.a = c;
            this.b = d;
            this.c = e;
        }
        get startIndex() {
            return this.e;
        }
        get endIndex() {
            return this.d;
        }
        get groupKeyValues() {
            return this.b;
        }
        get groupKeyProperties() {
            return this.a;
        }
        get summaryResults() {
            return this.c;
        }
    }
    DefaultSectionInformation.$t = /*@__PURE__*/ markType(DefaultSectionInformation, 'DefaultSectionInformation', Base.$, [ISectionInformation_$type]);
    return DefaultSectionInformation;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ODataLiteralEmitter_$type = /*@__PURE__*/ new Type(null, 'ODataLiteralEmitter');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Environment = /*@__PURE__*/ (() => {
    class Environment extends Base {
        static get newLine() {
            return "\n";
        }
        static get b() {
            try {
                throw new Error();
            }
            catch (a) {
                return (a.stack);
            }
            return "";
        }
    }
    Environment.$t = /*@__PURE__*/ markType(Environment, 'Environment');
    return Environment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StringBuilder = /*@__PURE__*/ (() => {
    class StringBuilder extends Base {
        constructor(a, ..._rest) {
            super();
            this._internal = null;
            this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.internal = "";
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this.internal = "";
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        this.internal = c;
                    }
                    break;
            }
        }
        get internal() {
            return this._internal;
        }
        set internal(a) {
            this._internal = a;
        }
        k(a) {
            if (a != null) {
                this.l(a.toString());
            }
            return this;
        }
        l(str_) {
            if (str_ != null) {
                this.internal = this.internal.concat(str_);
            }
            ;
            return this;
        }
        n(a) {
            let str_ = a.toString();
            this.internal = this.internal.concat(str_);
            return this;
        }
        h(chr_) {
            this.internal = this.internal.concat(chr_);
            return this;
        }
        i(chr_, count_) {
            if (chr_.repeat) {
                this.internal = this.internal.concat(chr_.repeat(count_));
            }
            else {
                for (let a = 0; a < count_; a++) {
                    this.internal = this.internal.concat(chr_);
                }
            }
            return this;
        }
        j(value_) {
            this.internal = this.internal.concat(value_.toString());
            return this;
        }
        m(value_, startIndex_, count_) {
            this.internal = this.internal.concat(value_.substr(startIndex_, count_));
            return this;
        }
        g(value_, startIndex_, charCount_) {
            this.internal = this.internal.concat(value_.slice(startIndex_, startIndex_ + charCount_).join(''));
            return this;
        }
        t() {
            return this.u("");
        }
        u(str_) {
            if (str_ != null) {
                this.internal = this.internal.concat(str_);
            }
            this.internal = this.internal.concat(Environment.newLine);
            return this;
        }
        v() {
            this.internal = "";
            return this;
        }
        w(index_, chr_) {
            if (index_ == this.c) {
                this.h(chr_);
            }
            else {
                this.internal = this.internal.substring(0, index_).concat(chr_).concat(this.internal.substring(index_, this.internal.length));
            }
            return this;
        }
        x(index_, str_) {
            if (index_ == this.c) {
                this.l(str_);
            }
            else {
                this.internal = this.internal.substring(0, index_).concat(str_).concat(this.internal.substring(index_, this.internal.length));
            }
            return this;
        }
        y(startIndex_, length_) {
            this.internal = this.internal.substring(0, startIndex_).concat(this.internal.substring(startIndex_ + length_, this.internal.length));
            return this;
        }
        z(oldCh_, newCh_) {
            this.internal = this.internal.replace(oldCh_, newCh_);
            return this;
        }
        toString() {
            return this.internal;
        }
        f(a, b) {
            return this.internal.substr(a, b);
        }
        get c() {
            return this.internal.length;
        }
        set c(a) {
            if (a <= this.c) {
                this.internal = this.internal.substring(0, a);
            }
            else {
                throw new NotImplementedException(0);
            }
        }
        item(index_, a) {
            if (arguments.length === 2) {
                this.internal = this.internal.substring(0, index_).concat(a).concat(this.internal.substring(index_ + 1, this.internal.length));
                return a;
            }
            else {
                return this.internal.charAt(index_);
            }
        }
        q(a, b) {
            return this.l(stringFormat(a, b));
        }
        p(a, ...b) {
            return this.l(stringFormat1(a, ...b));
        }
        o(a, b, ...c) {
            return this.l(stringFormat2(a, b, ...c));
        }
        r(a, b, c) {
            return this.l(stringFormat(a, b, c));
        }
        s(a, b, c, d) {
            return this.l(stringFormat(a, b, c, d));
        }
    }
    StringBuilder.$t = /*@__PURE__*/ markType(StringBuilder, 'StringBuilder');
    return StringBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefaultODataLiteralEmitter = /*@__PURE__*/ (() => {
    class DefaultODataLiteralEmitter extends Base {
        emitLiteral(a, b) {
            if (a == null) {
                return "null";
            }
            if (typeCast(Boolean_$type, a) !== null) {
                return a ? "true" : "false";
            }
            else if (typeCast(Date_$type, a) !== null) {
                return this.a(a);
            }
            else if (typeof a === 'string') {
                let c = a.toString();
                if (!b) {
                    c = "'" + c + "'";
                }
                return c;
            }
            else {
                return a.toString();
            }
        }
        b(a) {
            let b = false;
            if (timeSpanTotalMilliseconds(a) < 0) {
                b = true;
                a = timeSpanNegate(a);
            }
            let c = new StringBuilder(0);
            c.l("duration'");
            if (b) {
                c.l("-");
            }
            c.l("P");
            if (timeSpanDays(a) > 0) {
                c.l(timeSpanDays(a).toString());
                c.l("D");
            }
            c.l("T");
            if (timeSpanHours(a) > 0) {
                c.j(timeSpanHours(a));
                c.l("H");
            }
            if (timeSpanMinutes(a) > 0 || timeSpanHours(a) > 0) {
                c.j(timeSpanMinutes(a));
                c.l("M");
            }
            if (timeSpanSeconds(a) > 0 || timeSpanMilliseconds(a) > 0 || timeSpanHours(a) > 0 || timeSpanMinutes(a) > 0) {
                c.j(timeSpanSeconds(a));
                if (timeSpanMilliseconds(a) > 0) {
                    c.l(".");
                    c.l((timeSpanMilliseconds(a) / 1000).toString());
                }
                c.l("S");
            }
            c.l("'");
            return c.toString();
        }
        a(a) {
            let b;
            if (a.getSeconds() == 0 && a.getMilliseconds() == 0) {
                b = dateToStringFormat(a, "yyyy-MM-ddTHH:mm");
            }
            else if (a.getMilliseconds() == 0) {
                b = dateToStringFormat(a, "yyyy-MM-ddTHH:mm:ss");
            }
            else {
                b = dateToStringFormat(a, "yyyy-MM-ddTHH:mm:ss.fffffff");
            }
            return "datetime'" + b + "'";
        }
    }
    DefaultODataLiteralEmitter.$t = /*@__PURE__*/ markType(DefaultODataLiteralEmitter, 'DefaultODataLiteralEmitter', Base.$, [ODataLiteralEmitter_$type]);
    return DefaultODataLiteralEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ODataDataSourceFilterExpressionVisitor = /*@__PURE__*/ (() => {
    class ODataDataSourceFilterExpressionVisitor extends FilterExpressionVisitor {
        constructor(a, ..._rest) {
            super();
            this.h = null;
            this.f = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.f = new DefaultODataLiteralEmitter();
                        this.h = new StringBuilder(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            this.f = new DefaultODataLiteralEmitter();
                            this.h = new StringBuilder(0);
                        }
                        this.f = c;
                    }
                    break;
            }
        }
        toString() {
            return this.h.toString();
        }
        visitOperationExpression(a) {
            let b = true;
            let c = "";
            switch (a.operator) {
                case 10:
                    c = "add";
                    break;
                case 7:
                    c = "and";
                    break;
                case 13:
                    c = "div";
                    break;
                case 0:
                case 1:
                    c = "eq";
                    break;
                case 3:
                    c = "gt";
                    break;
                case 4:
                    c = "ge";
                    break;
                case 15:
                    b = false;
                    break;
                case 5:
                    c = "lt";
                    break;
                case 6:
                    c = "le";
                    break;
                case 14:
                    c = "mod";
                    break;
                case 12:
                    c = "mul";
                    break;
                case 9:
                    c = "not";
                    b = false;
                    break;
                case 2:
                    c = "ne";
                    break;
                case 8:
                    c = "or";
                    break;
                case 11:
                    c = "sub";
                    break;
                default:
                    c = "eq";
                    break;
            }
            if (b) {
                if (this.g(a, a.left)) {
                    this.h.l("(");
                }
                this.visit(a.left);
                if (this.g(a, a.left)) {
                    this.h.l(")");
                }
                this.h.l(" ");
                this.h.l(c);
                this.h.l(" ");
                if (this.g(a, a.right)) {
                    this.h.l("(");
                }
                this.visit(a.right);
                if (this.g(a, a.right)) {
                    this.h.l(")");
                }
            }
            else {
                if (a.operator == 15) {
                    this.h.l("(");
                }
                else {
                    this.h.u(c + " ");
                }
                if (a.left != null) {
                    this.visit(a.left);
                }
                else {
                    this.visit(a.right);
                }
                if (a.operator == 15) {
                    this.h.l(")");
                }
            }
        }
        g(a, b) {
            let c = a.precedence;
            let d = b != null ? b.precedence : 0;
            if (b != null && b.isOperation && b.operator == 15) {
                return false;
            }
            return d < c;
        }
        visitFunctionExpression(a) {
            let b = "";
            switch (a.functionType) {
                case 19:
                    b = "ceiling";
                    break;
                case 10:
                    b = "concat";
                    break;
                case 0:
                    b = "contains";
                    break;
                case 11:
                    b = "day";
                    break;
                case 1:
                    b = "endswith";
                    break;
                case 18:
                    b = "floor";
                    break;
                case 12:
                    b = "hour";
                    break;
                case 4:
                    b = "indexof";
                    break;
                case FilterExpressionFunctionType.Length:
                    b = "length";
                    break;
                case 13:
                    b = "minute";
                    break;
                case 14:
                    b = "month";
                    break;
                case 5:
                    b = "replace";
                    break;
                case 17:
                    b = "round";
                    break;
                case 15:
                    b = "second";
                    break;
                case 2:
                    b = "startswith";
                    break;
                case 6:
                    b = "substring";
                    break;
                case 7:
                    b = "tolower";
                    break;
                case 8:
                    b = "toupper";
                    break;
                case 9:
                    b = "trim";
                    break;
                case 16:
                    b = "year";
                    break;
            }
            this.h.l(b);
            this.h.l("(");
            let c = true;
            for (let d = 0; d < a.functionArguments.j.count; d++) {
                if (c) {
                    c = false;
                }
                else {
                    this.h.l(", ");
                }
                this.visit(a.functionArguments.j.item(d));
            }
            this.h.l(")");
        }
        visitLiteralExpression(a) {
            this.i(a, a.literalValue);
        }
        i(a, b) {
            let c = this.f.emitLiteral(b, a.leaveUnquoted);
            this.h.l(c);
        }
        visitPropertyReferenceExpression(a) {
            this.j(a.propertyReference);
        }
        j(a) {
            this.h.l(a);
        }
    }
    ODataDataSourceFilterExpressionVisitor.$t = /*@__PURE__*/ markType(ODataDataSourceFilterExpressionVisitor, 'ODataDataSourceFilterExpressionVisitor', FilterExpressionVisitor.$);
    return ODataDataSourceFilterExpressionVisitor;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ODataDataSourceSchema = /*@__PURE__*/ (() => {
    class ODataDataSourceSchema extends Base {
        constructor(a, b, c) {
            super();
            this.a = null;
            this.c = null;
            this.d = null;
            this.b = null;
            this.c = a;
            this.d = b;
            this.a = c;
        }
        get propertyNames() {
            return this.c;
        }
        get primaryKey() {
            return this.a;
        }
        get propertyTypes() {
            return this.d;
        }
        get propertyDataIntents() {
            return this.b;
        }
    }
    ODataDataSourceSchema.$t = /*@__PURE__*/ markType(ODataDataSourceSchema, 'ODataDataSourceSchema', Base.$, [IDataSourceSchema_$type]);
    return ODataDataSourceSchema;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var SummaryOperand = /*@__PURE__*/ (function (SummaryOperand) {
    SummaryOperand[SummaryOperand["Min"] = 0] = "Min";
    SummaryOperand[SummaryOperand["Max"] = 1] = "Max";
    SummaryOperand[SummaryOperand["Sum"] = 2] = "Sum";
    SummaryOperand[SummaryOperand["Average"] = 3] = "Average";
    SummaryOperand[SummaryOperand["Count"] = 4] = "Count";
    SummaryOperand[SummaryOperand["Custom"] = 5] = "Custom";
    return SummaryOperand;
})({});
/**
 * @hidden
 */
let SummaryOperand_$type = /*@__PURE__*/ markEnum('SummaryOperand', 'Min,0|Max,1|Sum,2|Average,3|Count,4|Custom,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Event arguments for the ProvideCalculator event.
*/
class IgrProvideCalculatorEventArgs {
    createImplementation() {
        return new ProvideCalculatorEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the summary calculator to use for this summary.
    */
    get calculator() {
        return this.i.a;
    }
    set calculator(v) {
        this.i.a = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceVelocityReading = /*@__PURE__*/ (() => {
    class DataSourceVelocityReading extends Base {
        constructor(a, b) {
            super();
            this.b = null;
            this.a = 0;
            this.b = a;
            this.a = b;
        }
    }
    DataSourceVelocityReading.$t = /*@__PURE__*/ markType(DataSourceVelocityReading, 'DataSourceVelocityReading');
    return DataSourceVelocityReading;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceVelocityTracker = /*@__PURE__*/ (() => {
    class DataSourceVelocityTracker extends Base {
        constructor() {
            super();
            this.f = 0;
            this.d = 6;
            this.a = null;
            this.b = 0;
            this.c = 0;
            this.f = this.g();
            this.c = 0;
            this.a = new Array(this.d);
        }
        i(a) {
            let b = this.e();
            this.a[this.b] = new DataSourceVelocityReading(a, b);
            this.b++;
            if (this.b > (this.d - 1)) {
                this.b = 0;
            }
        }
        h() {
            for (let a = 0; a < this.d; a++) {
                this.a[a] = null;
            }
        }
        j() {
            let a = 0x7FFFFFFF;
            let b = -2147483648;
            let c = 0;
            let d = 0;
            let e = 0;
            let f = 0;
            let g = this.e();
            for (let h = 0; h < this.d; h++) {
                if (this.a[h] == null) {
                    continue;
                }
                if ((g - this.a[h].a) > 300) {
                    continue;
                }
                if (this.a[h].a < a) {
                    a = this.a[h].a;
                    c = this.a[h].b.x;
                    d = this.a[h].b.y;
                }
                if (this.a[h].a > b) {
                    b = this.a[h].a;
                    e = this.a[h].b.x;
                    f = this.a[h].b.y;
                }
            }
            let i = b - a;
            i = Math.max(i, 16);
            let j = (i) / 1000;
            if (j == 0) {
                return { $type: Point_$type, x: c, y: d };
            }
            return { $type: Point_$type, x: (e - c) / j, y: (f - d) / j };
        }
        g() {
            let a = dateNow();
            return a.getTime();
        }
        e() {
            let a = (this.g() - this.f);
            if (a == this.c) {
                a += 1;
            }
            this.c = a;
            return a;
        }
    }
    DataSourceVelocityTracker.$t = /*@__PURE__*/ markType(DataSourceVelocityTracker, 'DataSourceVelocityTracker');
    return DataSourceVelocityTracker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PagePredictionEngine = /*@__PURE__*/ (() => {
    class PagePredictionEngine extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.s = 0;
            this.u = 0;
            this.x = -1;
            this.t = -1;
            this.y = 500;
            this.r = 1000;
            this.v = 8;
            this.d = null;
            this.f = null;
            this.w = 0;
            this.propertyChanged = null;
            this.i = false;
            this.h = false;
            this.g = new FastIterationDictionary$2(Base.$, Number_$type, 0);
            this.p = new List$1(Number_$type, 0);
            this.o = new List$1(Number_$type, 0);
            this.c = new DataSourceVelocityTracker();
            this.q = 0;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ay("ExecutionContext", b, this.a);
            }
        }
        get aa() {
            return this.s;
        }
        set aa(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.ay("FirstVisibleIndexRequested", b, this.s);
            }
        }
        get ae() {
            return this.u;
        }
        set ae(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.ay("LastVisibleIndexRequested", b, this.u);
            }
        }
        get ag() {
            return this.x;
        }
        set ag(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.ay("PageSize", b, this.x);
            }
        }
        get ab() {
            return this.t;
        }
        set ab(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.ay("FullCount", b, this.t);
            }
        }
        get ah() {
            return this.y;
        }
        set ah(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.ay(PagePredictionEngine.aq, b, this.y);
            }
        }
        get z() {
            return this.r;
        }
        set z(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ay("FetchAheadMilliseconds", b, this.r);
            }
        }
        get af() {
            return this.v;
        }
        set af(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.ay("MaximumPageCandidates", b, this.v);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.ay("PageCandidatesSink", b, this.d);
            }
        }
        ay(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.az(a, b, c);
        }
        az(a, b, c) {
            switch (a) {
                case "FirstVisibleIndexRequested":
                case "LastVisibleIndexRequested":
                    this.aw();
                    break;
                case "ExecutionContext":
                    this.ax();
                    break;
                case "FullCount":
                    this.a2();
                    break;
                case "PageSize":
                    this.a2();
                    break;
            }
        }
        a2() {
            this.c.h();
            this.q = 0;
            let a = new List$1(Number_$type, 0);
            for (let b = 0; b < this.g.q.count; b++) {
                if (this.g.p._inner[b]) {
                    continue;
                }
                a.add(this.g.q._inner[b]);
            }
            for (let c = 0; c < a.count; c++) {
                this.a1(a._inner[c]);
            }
            if (this.ab > 0 && this.ag > 0) {
                this.w = truncate(Math.ceil(this.ab / this.ag));
            }
        }
        ax() {
            this.au();
        }
        au() {
            if (this.i) {
                return;
            }
            if (this.b != null) {
                this.i = true;
                this.b.enqueueAction(runOn(this, this.av));
            }
        }
        av() {
            this.i = false;
            this.a4();
        }
        a4() {
            if (this.t == -1 || this.x == -1) {
                return;
            }
            this.at();
            this.a5();
            this.a6();
            if (this.q != 0) {
                this.as();
            }
        }
        a3() {
            this.h = false;
            this.a4();
        }
        as() {
            if (this.h) {
                return;
            }
            if (this.b != null) {
                this.h = true;
                this.b.executeDelayed(runOn(this, this.a3), 0);
            }
        }
        a6() {
            let a = this.ac();
            let b = this.ad();
            let c = true;
            let d;
            for (let e = a; e <= b; e++) {
                d = e;
                c = this.j(d, 2);
            }
            if (this.q > 0) {
                d = b;
                while (c) {
                    d++;
                    c = this.j(d, 1);
                }
            }
            else if (this.q < 0) {
                d = a;
                while (c) {
                    d--;
                    c = this.j(d, 1);
                }
            }
            this.a0();
        }
        a0() {
            this.o.clear();
            let a = this.g.o;
            let b = this.g.o.count;
            let c = this.g.p;
            for (let d = 0; d < b; d++) {
                if (c._inner[d]) {
                    continue;
                }
                let e = typeGetValue(a._inner[d]);
                this.o.add(e);
            }
            for (let f = 0; f < this.o.count; f++) {
                this.j(this.o._inner[f], 1);
            }
        }
        j(a, b) {
            if (a < 0 || a > this.w) {
                return false;
            }
            if (this.l(a)) {
                this.a1(a);
                return false;
            }
            if (this.m(a, this.z)) {
                this.a1(a);
                return false;
            }
            if (this.n()) {
                this.a1(a);
                return false;
            }
            this.ar(a, b);
            return true;
        }
        ar(a, b) {
            if (!this.g.d(a)) {
                if (this.d != null) {
                    if (this.d.addCandidate(a, b)) {
                        this.g.s(a, a);
                    }
                }
            }
        }
        a1(a) {
            if (this.g.d(a)) {
                this.g.f(a);
                if (this.d != null) {
                    this.d.removeCandidate(a);
                }
            }
        }
        n() {
            return this.g.r >= this.af;
        }
        m(a, b) {
            let c = b / 1000;
            let d = c * this.q;
            if (this.k(a)) {
                return false;
            }
            if (d > 0) {
                let e = d + this.ae;
                if (e >= (a * this.ag)) {
                    return false;
                }
            }
            else {
                let f = this.aa + d;
                if (f <= ((a * this.ag) + this.ag)) {
                    return false;
                }
            }
            return true;
        }
        k(a) {
            let b = a * this.ag;
            let c = b + this.ag;
            if (this.ae < b || this.aa > c) {
                return false;
            }
            return true;
        }
        l(a) {
            let b = this.ah / 1000;
            let c = b * this.q;
            if (c > 0) {
                let d = c + this.aa;
                if (d > (a * this.ag) + this.ag) {
                    return true;
                }
            }
            else {
                let e = this.ae + c;
                if (e < (a * this.ag)) {
                    return true;
                }
            }
            return false;
        }
        ac() {
            return truncate(Math.floor(this.aa / this.ag));
        }
        ad() {
            return truncate(Math.floor(this.ae / this.ag));
        }
        a5() {
            this.q = this.c.j().y;
        }
        at() {
            this.c.i({ $type: Point_$type, x: 0, y: this.aa });
        }
        aw() {
            if (this.b != null) {
                this.b.enqueueAction(runOn(this, this.a4));
            }
        }
    }
    PagePredictionEngine.$t = /*@__PURE__*/ markType(PagePredictionEngine, 'PagePredictionEngine', Base.$, [INotifyPropertyChanged_$type]);
    PagePredictionEngine.aq = "PageVisibilityDisplayThresholdMilliseconds";
    return PagePredictionEngine;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PredictionEnginePageCandidate = /*@__PURE__*/ (() => {
    class PredictionEnginePageCandidate extends Base {
    }
    PredictionEnginePageCandidate.$t = /*@__PURE__*/ markType(PredictionEnginePageCandidate, 'PredictionEnginePageCandidate');
    return PredictionEnginePageCandidate;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPageCandidatesSink_$type = /*@__PURE__*/ new Type(null, 'IPageCandidatesSink');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceBatchStartedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceBatchStartedEventArgs extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    DataSourceBatchStartedEventArgs.$t = /*@__PURE__*/ markType(DataSourceBatchStartedEventArgs, 'DataSourceBatchStartedEventArgs');
    return DataSourceBatchStartedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceBatchCompletedEventArgs = /*@__PURE__*/ (() => {
    class DataSourceBatchCompletedEventArgs extends Base {
        constructor(a, b) {
            super();
            this.b = false;
            this.a = null;
            this.b = a;
            this.a = b;
        }
    }
    DataSourceBatchCompletedEventArgs.$t = /*@__PURE__*/ markType(DataSourceBatchCompletedEventArgs, 'DataSourceBatchCompletedEventArgs');
    return DataSourceBatchCompletedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VirtualDataSource = /*@__PURE__*/ (() => {
    class VirtualDataSource extends BaseDataSource {
        constructor() {
            super();
            this.cx = null;
            this.dg = false;
            this.d3 = 0;
            this.da = null;
            this.c1 = null;
            this.c0 = null;
            this.d2 = 50;
            this.d1 = 200;
            this.actualPageSizePopulated = false;
            this.dm = 50;
            this.de = false;
            this.c5 = null;
            this.cv = null;
            this.cw = null;
            this.dd = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
            this.dk = new Dictionary$2(Base.$, Array_$type, 0);
            this.dl = new Dictionary$2(Number_$type, Number_$type, 0);
            this.df = false;
            this.ct = null;
            this.cy = null;
            this.dc = new SectionMap();
            this.cu = null;
            this.dv = -1;
            this.dn = -1;
            this.dx = -1;
            this.dq = -1;
            this.dy = -1;
            this.dr = -1;
            this.dw = -1;
            this.dp = -1;
            this.d0 = -1;
            this.dz = -1;
            this.dt = -1;
            this.ds = -1;
            this.du = -1;
            this.dj = new Dictionary$2(String_$type, Boolean_$type, 0);
            this._concurrencyTag = null;
            this.batchStarted = null;
            this.batchCompleted = null;
            this.da = new PagePredictionEngine();
            this.da.e = this;
            this.da.ag = this.actualPageSize;
            this.da.f = this.dc;
            this.executionContext = new DataSourceExecutionContext();
            this.da.b = this.executionContext;
            this.isReadOnly = true;
        }
        get_isSectionCollapsable() {
            if (!this.isSectionContentVisible) {
                return true;
            }
            return super.get_isSectionCollapsable();
        }
        set_isSectionCollapsable(a) {
            super.set_isSectionCollapsable(a);
        }
        get_isSectionExpandedDefault() {
            if (!this.isSectionContentVisible) {
                return false;
            }
            if (this.isSectionCollapsable) {
                return super.get_isSectionExpandedDefault();
            }
            return true;
        }
        set_isSectionExpandedDefault(a) {
            super.set_isSectionExpandedDefault(a);
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.c1;
        }
        set dataProvider(a) {
            let b = this.c1;
            this.c1 = a;
            if (b != this.c1) {
                this.onPropertyUpdated("DataProvider", b, this.c1);
            }
        }
        get actualDataProvider() {
            if (this.c0 == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.c0;
        }
        set actualDataProvider(a) {
            let b = this.c0;
            this.c0 = a;
            if (b != this.c0) {
                this.onPropertyUpdated("ActualDataProvider", b, this.c0);
            }
        }
        get pageSizeRequested() {
            return this.d2;
        }
        set pageSizeRequested(a) {
            let b = this.d2;
            this.d2 = a;
            if (b != this.d2) {
                this.onPropertyUpdated("PageSizeRequested", b, this.d2);
            }
        }
        resetCache() {
            if (this.c6 != null) {
                this.c6.resetCache();
            }
            this.resetCacheOverride();
        }
        resetCacheOverride() {
            this.dd.i();
        }
        get maxCachedPages() {
            return this.d1;
        }
        set maxCachedPages(a) {
            let b = this.d1;
            this.d1 = a;
            if (b != this.d1) {
                this.onPropertyUpdated("MaxCachedPages", b, this.d1);
            }
        }
        get actualPageSize() {
            return this.dm;
        }
        set actualPageSize(a) {
            let b = this.dm;
            this.dm = a;
            if (b != this.dm) {
                this.onPropertyUpdated("ActualPageSize", b, this.dm);
            }
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.de) {
                this.de = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.de = false;
                return a;
            }
            return false;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.de) {
                this.de = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.de = false;
                return a;
            }
            return false;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.de) {
                this.de = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.de = false;
                return a;
            }
            return false;
        }
        get c6() {
            return this.c5;
        }
        set c6(a) {
            this.c5 = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            if (this.c6 == null) {
                return null;
            }
            return this.c6.resolveDataProvider();
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    this.queueAutoRefresh();
                    break;
                case "ExecutionContext":
                    this.da.b = this.executionContext;
                    break;
                case "ActualDataProvider":
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    this.actualDataProvider.pageLoaded = runOn(this, this.en);
                    this.actualDataProvider.batchCompleted = runOn(this, this.em);
                    this.queueAutoRefresh();
                    break;
                case "PageSizeRequested":
                    this.actualPageSize = this.pageSizeRequested;
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    }
                    this.queueAutoRefresh();
                    break;
                case "ActualPageSize":
                    this.da.ag = this.actualPageSize;
                    this.queueAutoRefresh();
                    break;
                case "FirstVisibleIndexRequested":
                    this.da.aa = this.firstVisibleIndexRequested;
                    break;
                case "LastVisibleIndexRequested":
                    this.da.ae = this.lastVisibleIndexRequested;
                    break;
                case "ActualCount":
                    if (this.actualDataProvider != null && !this.dc.q) {
                        this.da.ab = this.actualDataProvider.actualCount;
                    }
                    else {
                        this.da.ab = this.actualCount;
                    }
                    this.queueAutoRefresh();
                    break;
                case "MaxCachedPages":
                    this.dd.h = this.maxCachedPages;
                    break;
            }
        }
        d6(a) {
            if (this.ao && this.dc.q) {
                let b = this.db(a);
                if (b == null) {
                    b = this.dc.d();
                }
                return a - b.t;
            }
            return a;
        }
        en(a, b, c) {
            let d = this.executionContext;
            if (d != null) {
                d.execute(() => this.et(a, b, c));
            }
            else {
                this.et(a, b, c);
            }
        }
        et(a, b, c) {
            if (a == null) {
                b = this.resolveFullCount(b);
                if (this.actualCount != b) {
                    this.actualCount = b;
                }
                return;
            }
            if (c != this.actualPageSize && !this.actualPageSizePopulated) {
                this.actualPageSize = c;
            }
            this.actualPageSizePopulated = true;
            let d = a.pageIndex();
            this.eo(d);
            this.dd.item(d, a);
            let e = a.schema();
            if (e != null) {
                this.actualSchema = e;
            }
            let f = a.getSummaryInformation();
            if (this.summaryDescriptions.k.count > 0 && this.cy == null && f != null) {
                this.cy = f;
                for (let g = 0; g < this.summaryDescriptions.k.count; g++) {
                    this.cy[g].summaryIndex = g;
                }
                let h = SectionData.r(this.cy);
                this.d3 = h.count;
            }
            let i = a.getGroupInformation();
            if (this.groupDescriptions.k.count > 0 && this.ct == null && i != null) {
                this.ct = i;
                this.es();
                this.dg = false;
            }
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            this.er(a);
        }
        resolveFullCount(a) {
            if (this.ct != null) {
                return this.dc.u + this.d3;
            }
            return a + this.d3;
        }
        es() {
            let a = 0;
            let b = 0;
            let c = this.shouldEmitSectionHeaders;
            let d = this.shouldEmitSectionFooters;
            for (let e = 0; e < this.ct.length; e++) {
                let f = new SectionData();
                let g = b;
                let h = this.ct[e].endIndex - this.ct[e].startIndex;
                f.af = a;
                f.ae = e;
                f.d = new Array(this.groupDescriptions.k.count);
                for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                    f.d[i] = 0;
                }
                f.ad = a + h;
                f.t = 0;
                f.e = this.ct[e].groupKeyProperties;
                f.f = this.ct[e].groupKeyValues;
                f.h = new Array(0);
                f.ai(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
                this.el(f, e == 0);
                if (d) {
                    f.u = f.c.length;
                }
                let j = 0;
                f.i = new Array(this.groupDescriptions.k.count);
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.ct[e].summaryResults != null) {
                        f.i[this.groupDescriptions.k.count - 1] = this.ct[e].summaryResults;
                        if (f.i != null) {
                            for (let k = 0; k < f.i[this.groupDescriptions.k.count - 1].length; k++) {
                                f.i[this.groupDescriptions.k.count - 1][k].summaryIndex = k;
                            }
                            j = SectionData.r(f.i[this.groupDescriptions.k.count - 1]).count;
                        }
                    }
                }
                if (this.includeSummaryRowsInSection) {
                    if (this.isSectionSummaryRowsAtBottom) {
                        f.ag = j;
                    }
                    else {
                        f.ah = j;
                        g += j;
                    }
                    b += j;
                    f.ad += j;
                }
                if (d) {
                    b++;
                }
                let l = 0;
                f.b = new Array(f.c.length);
                if (f.z > -1) {
                    let m = this.dc.t._inner[f.z];
                    for (let n = 0; n < m.f.length; n++) {
                        l = n;
                        if (!Base.equalsStatic(m.f[n], f.f[n])) {
                            break;
                        }
                    }
                }
                for (let o = l; o < f.c.length; o++) {
                    b++;
                    g++;
                    f.ad++;
                    let p = this.ef(f, o);
                    f.a[o] = p;
                    f.b[o] = o - l;
                    if (this.dj.containsKey(p)) {
                        f.c[o] = this.dj.item(p);
                    }
                    else {
                        f.c[o] = this.isSectionExpandedDefault;
                    }
                    if (!f.c[o]) {
                        let q = 0;
                        let r = f.c.length - 1 - o;
                        f.ad -= q;
                        b -= q;
                        if (d) {
                            b--;
                            f.u--;
                        }
                        o += r;
                    }
                }
                f.y = f.v();
                f.t = g;
                this.dc.z(f, h + 1);
                if (!f.p) {
                    let s = f.w();
                    f.ad -= f.d[s] + j;
                    b -= f.d[s] + j;
                }
                a = f.ad + 1;
                this.dc.t.add(f);
                f.q = this.dc.r(f);
            }
            let t = 0;
            for (let u = 0; u < this.dc.t.count; u++) {
                let v = this.dc.t._inner[u];
                if (this.shouldEmitSectionHeaders) {
                    if (!v.q) {
                        let w = v.ad - v.af + 1;
                        this.dc.ae(v.ae);
                        this.dc.ab(v, -w, -w);
                        u--;
                        t++;
                        continue;
                    }
                }
                if (v.z > -1) {
                    v.z -= t;
                }
            }
        }
        el(a, b) {
            if (b) {
                this.cv = new Array(this.groupDescriptions.k.count);
                for (let c = 0; c < this.cv.length; c++) {
                    this.cv[c] = a;
                }
            }
            if (this.sectionHeaderDisplayMode == 1) {
                let d = false;
                let e = a.e.length;
                for (let f = 0; f < e; f++) {
                    if (d) {
                        this.cv[f] = a;
                        continue;
                    }
                    let g = false;
                    if (this.cv[f].f[f] == null) {
                        g = a.f[f] != null;
                    }
                    else {
                        g = !Base.equalsStatic(this.cv[f].f[f], a.f[f]);
                    }
                    if (g) {
                        this.cv[f] = a;
                        if (f - 1 > -1) {
                            let h = f - 1;
                            while (h >= 0 && this.cv[h].o) {
                                h = h - 1;
                            }
                            a.z = this.cv[h].ae;
                        }
                        d = true;
                    }
                }
            }
            else {
                let i = false;
                for (let j = 0; j < a.e.length; j++) {
                    if (this.cv[0].f[j] == null) {
                        if (this.cv[0].f[j] != a.f[j]) {
                            i = true;
                            break;
                        }
                        continue;
                    }
                    if (!Base.equalsStatic(this.cv[0].f[j], a.f[j])) {
                        i = true;
                        break;
                    }
                }
                if (i) {
                    this.cv[0] = a;
                }
            }
        }
        ek(a) {
        }
        er(a) {
            if (this.updateNotifier != null) {
                let b = a.pageIndex() * this.actualPageSize;
                if (this.actualDataProvider != null) {
                    if (b > this.actualDataProvider.actualCount) {
                        return;
                    }
                }
                let c = this.d5(b);
                let d = this.d5(b + a.count() - 1);
                if (c > 0 && this.getRowType(c - 1) == 1) {
                    c--;
                }
                if (this.actualCount == 0 && a.count() == 0) {
                    this.onClearItems();
                }
                else {
                    this.updateNotifier.rangeActualized(c, d);
                }
            }
        }
        d5(a) {
            if (this.ao && this.dc.q) {
                let b = this.dc.g(a);
                if (b == null) {
                    b = this.dc.d();
                }
                if (!b.p) {
                    return b.af;
                }
                return a + b.t;
            }
            return a;
        }
        ep(a) {
            a();
        }
        get_isVirtual() {
            return true;
        }
        isPlaceholderItem(a) {
            let b = this.cz(a);
            let c = b[0];
            if (!this.dd.d(c)) {
                if (b[1] == -1) {
                    return false;
                }
                return true;
            }
            return false;
        }
        getItemAtIndex(a) {
            if (a >= this.actualCount - this.d3) {
                return this.ea(a);
            }
            let b = this.cz(a);
            let c = b[0];
            if (!this.dd.d(c)) {
                if (b[1] == -1) {
                    return this.ea(a);
                }
                return null;
            }
            let d = this.dd.item(c);
            let e = b[1];
            if (e == -1) {
                return this.ea(a);
            }
            return d.getItemAtIndex(e);
        }
        getItemFromKey(a) {
            let b = this.indexOfKey(a);
            if (b >= 0) {
                return this.getItemAtIndex(b);
            }
            return null;
        }
        ea(a) {
            if (a >= this.actualCount - this.d3) {
                let b = new DataSourceSpecialRow();
                b.rowType = 4;
                b.level = 0;
                let c = a - (this.actualCount - this.d3);
                let d = SectionData.r(this.cy);
                let e = new Array(d._inner[c].count);
                d._inner[c].values.copyTo(e, 0);
                b.summaryResults = e;
                return b;
            }
            let f = this.db(a);
            if (f != null) {
                let g = f.j(a);
                if (g == 1 || g == 2) {
                    let h = new DataSourceSpecialRow();
                    h.rowType = g;
                    h.summaryResults = f.i[f.i.length - 1];
                    h.level = g == 1 ? f.w() + (a - f.af) : (f.u - 1) - (f.w() + (a - (f.ad - f.u + 1)));
                    if (this.sectionHeaderDisplayMode == 0) {
                        for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                            h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                            h.setValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                        }
                    }
                    else {
                        if (h.level >= 0 && h.level < this.groupDescriptions.k.count) {
                            h.setSectionValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                            h.setValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                        }
                    }
                    return h;
                }
                else if (g == 5) {
                    let j = new DataSourceSpecialRow();
                    j.rowType = 5;
                    j.level = f.c.length;
                    let k = f.x(a);
                    let l = SectionData.r(f.i[f.i.length - 1]);
                    let m = new Array(l._inner[k].count);
                    l._inner[k].values.copyTo(m, 0);
                    j.summaryResults = m;
                    return j;
                }
            }
            return null;
        }
        cz(a) {
            if (this.ao && this.dc.q) {
                let b = false;
                let c = this.db(a);
                if (c == null) {
                    c = this.dc.d();
                    if (this.cy.length > 0 && a > c.ad) {
                        b = true;
                    }
                }
                let d = c.af;
                if (this.shouldEmitSectionHeaders && a >= d && a < d + c.v()) {
                    b = true;
                }
                if (a - (d + c.v() - 1) <= c.aa + c.ah) {
                    b = true;
                }
                if (this.shouldEmitSectionFooters) {
                    if (a <= c.ad && a >= c.ad - c.c.length - c.ag) {
                        b = true;
                    }
                }
                else if (c.ag > 0) {
                    if (a > c.ad - c.ag && a <= c.ad) {
                        b = true;
                    }
                }
                let e = a - c.t;
                let f = truncate(Math.floor(e / this.actualPageSize));
                let g = e % this.actualPageSize;
                if (b) {
                    g = -1;
                }
                let h = new Array(2);
                h[0] = f;
                h[1] = g;
                return h;
            }
            else {
                let i = truncate(Math.floor(a / this.actualPageSize));
                let j = a % this.actualPageSize;
                let k = new Array(2);
                k[0] = i;
                k[1] = j;
                return k;
            }
        }
        db(a) {
            return this.dc.e(a);
        }
        getItemPropertyAtIndex(a, b) {
            if (a > (this.actualCount - 1) - this.d3) {
                return this.eb(a, b);
            }
            let c = this.cz(a);
            let d = c[0];
            if (!this.dd.d(d)) {
                if (c[1] == -1) {
                    return this.eb(a, b);
                }
                return null;
            }
            let e = this.dd.item(d);
            let f = c[1];
            if (f == -1) {
                return this.eb(a, b);
            }
            if (this.ap()) {
                let g = e.getItemAtIndex(f);
                let h = this.am(g, b);
                if (h) {
                    let i = this.a0(g, b);
                    return i;
                }
            }
            return e.getItemValueAtIndex(f, b);
        }
        eb(a, b) {
            let c = this.ea(a);
            if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                return c.getValue(b);
            }
            return null;
        }
        eq(a) {
            if (!this.dl.containsKey(a)) {
                this.dl.addItem(a, 1);
            }
            else {
                this.dl.item(a, this.dl.item(a) + 1);
            }
        }
        eo(a) {
            if (this.dl.containsKey(a)) {
                this.dl.item(a, this.dl.item(a) - 1);
                if (this.dl.item(a) <= 0) {
                    this.dl.removeItem(a);
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.removePageRequest(a);
                    }
                }
            }
        }
        addCandidate(a, b) {
            let c = false;
            if (!this.dk.containsKey(a)) {
                let d = new List$1(Number_$type, 0);
                let e = this.transformPage(a);
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    if (!this.dd.d(g)) {
                        d.add(g);
                        this.eq(g);
                        let h = this.dl.item(g);
                        if (h == 1 && this.actualDataProvider != null) {
                            this.actualDataProvider.addPageRequest(g, b);
                        }
                        c = true;
                    }
                }
                if (d.count > 0) {
                    this.dk.addItem(a, d.toArray());
                }
            }
            return c;
        }
        removeCandidate(a) {
            if (this.dk.containsKey(a)) {
                for (let b = 0; b < this.dk.item(a).length; b++) {
                    let c = this.dk.item(a)[b];
                    this.eo(c);
                }
                this.dk.removeItem(a);
            }
        }
        transformPage(a) {
            let b = [a];
            if (this.ao && this.dc.q) {
                let c = a * this.actualPageSize;
                let d = c + this.actualPageSize - 1;
                let e = this.db(c);
                let f = new List$1(Number_$type, 0);
                for (let g = c; g <= d; g++) {
                    if (e == null) {
                        break;
                    }
                    if (g > e.ad) {
                        if (e.ae < this.dc.t.count - 1) {
                            e = this.dc.t._inner[e.ae + 1];
                        }
                        else {
                            break;
                        }
                    }
                    if (!e.p || (g >= e.af && g <= e.af + (e.v() - 1) + e.aa)) {
                        continue;
                    }
                    let h = g - e.t;
                    let i = intDivide(h, this.actualPageSize);
                    if (!f.contains(i)) {
                        f.add(i);
                    }
                }
                b = f.toArray();
            }
            return b;
        }
        getUnrealizedCount() {
            let a = this.dd.g * this.actualPageSize;
            let b = this.actualCount - a;
            return b;
        }
        onSetItemOverride(a, b, c) {
            super.onSetItemOverride(a, b, c);
            let d = this.cz(a);
            let e = d[0];
            if (this.dd.d(e)) {
                this.dd.j(e);
            }
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            this.actualPageSizePopulated = false;
            let a = this.actualCount != 0;
            this.df = true;
            if (!this.dg) {
                this.resetCache();
                if (a) {
                    this.onClearItems();
                }
                this.ct = null;
                this.cy = null;
                this.d3 = 0;
                this.dc.v();
            }
            else {
                this.dg = false;
                if (a) {
                    this.onClearItems();
                }
            }
            this.eu();
            this.da.au();
            this.df = false;
        }
        eu() {
            if (this.actualDataProvider != null) {
                for (let a of fromEnum(this.dk.values)) {
                    for (let c = 0; c < a.length; c++) {
                        let b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
        }
        onClearItemsOverride() {
            super.onClearItemsOverride();
            if (!this.df) {
                this.queueAutoRefresh();
            }
        }
        onInsertItemOverride(a, b) {
            super.onInsertItemOverride(a, b);
            this.queueAutoRefresh();
        }
        onRemoveItemOverride(a, b) {
            super.onRemoveItemOverride(a, b);
            this.queueAutoRefresh();
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            let b = this.dd.b;
            let c = b.o;
            let d = b.q;
            let e = d.count;
            let f = b.p;
            for (let g = 0; g < e; g++) {
                if (f._inner[g]) {
                    continue;
                }
                let h = d._inner[g].b;
                let i = h.count();
                for (let j = 0; j < i; j++) {
                    if (this.di(h.getItemAtIndex(j), a)) {
                        let k = typeGetValue(c._inner[g]);
                        let l = k * this.actualPageSize;
                        return l + j;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            return -1;
        }
        di(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return -1;
            }
            this.ensureComparables(this.actualSchema);
            let c = this.c9();
            if (this.ao && this.shouldEmitSectionHeaders && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                if (this.dc.t.count > 0) {
                    for (let d = 0; d < this.dc.t.count; d++) {
                        let e = this.dc.t._inner[d];
                        let f = new DataSourceSpecialRow();
                        for (let g = 0; g < e.e.length; g++) {
                            let h = e.e[g];
                            let i = e.f[g];
                            f.setSectionValue(h, i);
                        }
                        if (c.i(f, a) == 0) {
                            return d;
                        }
                    }
                }
            }
            let j = this.dd.b;
            let k = j.o;
            let l = j.q;
            let m = l.count;
            let n = j.p;
            for (let o = 0; o < m; o++) {
                if (n._inner[o]) {
                    continue;
                }
                let p = l._inner[o].b;
                let q = p.count();
                for (let r = 0; r < q; r++) {
                    if (c.i(p.getItemAtIndex(r), a) == 0) {
                        let s = typeGetValue(k._inner[o]);
                        let t = s * this.actualPageSize;
                        return t + r;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            return -1;
        }
        c9() {
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.cx, this);
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        unpinRow(a) {
            super.unpinRow(a);
        }
        pinRow(a) {
            super.pinRow(a);
        }
        isRowPinned(a) {
            return super.isRowPinned(a);
        }
        getStickyRowsInRange(a, b) {
            if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
                return null;
            }
            let c = this.db(a);
            let d = this.db(b);
            if (this.dc.t.count > 0) {
                if (this.dc.t.count == 1) {
                    c = this.dc.t._inner[0];
                    d = this.dc.t._inner[0];
                }
                else {
                    c = this.dc.e(a);
                    if (c != null) {
                        while (c.z != -1) {
                            c = this.dc.t._inner[c.z];
                        }
                    }
                    d = this.dc.e(b);
                    if (b >= this.actualCount - this.d3) {
                        d = this.dc.d();
                    }
                }
            }
            else if (this.d3 > 0) {
                let e = new List$1(Number_$type, 0);
                for (let f = this.actualCount - this.d3; f < this.actualCount; f++) {
                    e.add(f);
                }
                return e.toArray();
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.dv && c.aa == this.dx && c.af == this.dy && c.ad == this.dw && c.ah == this.d0 && c.ag == this.dz && d.ae == this.dn && d.aa == this.dq && d.af == this.dr && d.ad == this.dp && d.ah == this.dt && d.ag == this.ds && this.d3 == this.du) {
                return this.cu;
            }
            this.dv = c.ae;
            this.dn = d.ae;
            this.dx = c.aa;
            this.dq = d.aa;
            this.dy = c.af;
            this.dr = d.af;
            this.dw = c.ad;
            this.dp = d.ad;
            this.dt = d.ah;
            this.ds = d.ag;
            this.d0 = c.ah;
            this.dz = c.ag;
            this.du = this.d3;
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.dc.t._inner[h];
                let j = i.c.length;
                let k = i.v();
                if (this.shouldEmitSectionHeaders && this.ao) {
                    for (let l = 0; l < i.c.length; l++) {
                        if (i.a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                        }
                        if (!i.c[l]) {
                            break;
                        }
                    }
                }
                if (i.p) {
                    for (let n = 0; n < i.ah; n++) {
                        g.add(i.af + n + k);
                    }
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < i.aa; o++) {
                            g.add(i.af + o + j);
                        }
                    }
                    if (this.summaryScope == 0 || this.summaryScope == 2) {
                        if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                            for (let p = i.ag - 1; p >= 0; p--) {
                                if (this.shouldEmitSectionFooters) {
                                    g.add(i.ad - k - p);
                                }
                                else {
                                    g.add(i.ad - p);
                                }
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.ao) {
                    for (let q = i.c.length - 1; q >= 0; q--) {
                        if (!i.c[q]) {
                            break;
                        }
                        g.add(i.ad - q);
                    }
                }
            }
            for (let r = this.actualCount - this.d3; r < this.actualCount; r++) {
                g.add(r);
            }
            this.cu = g.toArray();
            return this.cu;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        getIsRowExpandedAtIndex(a) {
            let b = this.dc.e(a);
            if (b == null) {
                b = this.dc.d();
            }
            for (let c = 0; c < b.a.length; c++) {
                if (b.a[c] != null) {
                    if (a == b.af + b.b[c]) {
                        return b.c[c];
                    }
                }
            }
            return super.getIsRowExpandedAtIndex(a);
        }
        setIsRowExpandedAtIndex(a, b) {
            let c = this.dc.e(a);
            if (c == null) {
                c = this.dc.d();
            }
            for (let d = 0; d < c.a.length; d++) {
                if (c.a[d] != null) {
                    if (a == c.af + c.b[d]) {
                        let e = false;
                        let f = c.a[d];
                        if (this.dj.containsKey(f) && this.dj.item(f) != b) {
                            let g = this.dj.item(f);
                            if (b == this.isSectionExpandedDefault) {
                                this.dj.removeItem(f);
                            }
                            else {
                                this.dj.item(f, b);
                            }
                            e = true;
                            this.onRowExpansionChanged(a, g, b);
                        }
                        else if (b != this.isSectionExpandedDefault) {
                            this.dj.addItem(f, b);
                            e = true;
                            this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                        }
                        if (e) {
                            this.dc.v();
                            this.es();
                            this.dg = true;
                            if (this.actualCount != this.dc.u) {
                                this.actualCount = this.dc.u + this.d3;
                            }
                            else {
                                this.queueAutoRefresh();
                            }
                        }
                        break;
                    }
                }
            }
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.isGroupingSupported) {
                if (this.sectionHeaderDisplayMode == 1) {
                    return this.groupDescriptions.k.count;
                }
                else if (this.groupDescriptions.k.count > 0) {
                    return 1;
                }
            }
            return 0;
        }
        getRootSummaryRowCount() {
            return this.d3;
        }
        ee(a) {
            let b = "";
            for (let c = 0; c < a.e.length; c++) {
                b += a.e[c] + ":" + a.f[c];
            }
            return b;
        }
        ef(a, b) {
            if (this.sectionHeaderDisplayMode == 0) {
                return this.ee(a);
            }
            let c = "";
            for (let d = 0; d < a.e.length; d++) {
                c += a.e[d] + ":" + a.f[d] + ":";
            }
            c += b;
            return c;
        }
        getRootSummaryResults() {
            return this.cy;
        }
        getSectionSummaryResults(a) {
            if (this.dc.t.count > 0 && a >= 0 && a < this.dc.t.count) {
                return this.dc.t._inner[a].i;
            }
            return null;
        }
        clone() {
            return null;
        }
        cloneProperties(a) {
            super.cloneProperties(a);
            let b = typeCast(VirtualDataSource.$, a);
            if (b != null) {
                b.pageSizeRequested = this.pageSizeRequested;
                b.maxCachedPages = this.maxCachedPages;
            }
        }
        get concurrencyTag() {
            return this._concurrencyTag;
        }
        set concurrencyTag(a) {
            this._concurrencyTag = a;
        }
        get_isBatchingEnabled() {
            return true;
        }
        set_isBatchingEnabled(a) {
            super.set_isBatchingEnabled(a);
        }
        updatePropertyAtKey(a, b, c, d = false) {
            let e = super.updatePropertyAtKey(a, b, c, d);
            if (this.concurrencyTag != null && this.ap()) {
                let f = this.indexOfKey(a);
                if (f > -1) {
                    let g = this.getItemAtIndex(f);
                    let h = this.actualDataProvider.getItemValue(g, this.concurrencyTag);
                    if (h != null) {
                        let i = this.u.g(a);
                        i.version = h;
                    }
                }
            }
            return e;
        }
        removeItemByKey(a) {
            super.removeItemByKey(a);
            if (this.concurrencyTag != null && this.ap()) {
                let b = this.indexOfKey(a);
                if (b > -1) {
                    let c = this.getItemAtIndex(b);
                    let d = this.actualDataProvider.getItemValue(c, this.concurrencyTag);
                    if (d != null) {
                        let e = this.u.g(a);
                        e.version = d;
                    }
                }
            }
        }
        cm(a, b) {
            if (a == 5) {
                let c = b;
                let d = c.a;
                let e = new List$1(TransactionState.$, 0);
                for (let f = 0; f < d.length; f++) {
                    let g = d[f].transactionType;
                    let h = null;
                    let i = null;
                    if (g == TransactionType.Delete || g == 1) {
                        let j = new Dictionary$2(String_$type, Base.$, 0);
                        let k = d[f].id;
                        for (let l = 0; l < this.actualPrimaryKey.length; l++) {
                            j.addItem(this.actualPrimaryKey[l], k[l]);
                        }
                        h = j;
                    }
                    if (g == 0) {
                        let m = new Dictionary$2(String_$type, Base.$, 0);
                        let n = d[f].id[0];
                        for (let o = 0; o < this.actualSchema.propertyNames.length; o++) {
                            let p = this.actualSchema.propertyNames[o];
                            m.addItem(p, this.actualDataProvider.getItemValue(n, p));
                        }
                        i = m;
                    }
                    else if (g == 1) {
                        i = d[f].value;
                    }
                    if (h != null) {
                        let q = {};
                        let r = h;
                        for (let s of fromEnum(r)) {
                            q[s.key] = s.value;
                        }
                        h = q;
                    }
                    if (i != null) {
                        let t = {};
                        let u = i;
                        for (let v of fromEnum(u)) {
                            t[v.key] = v.value;
                        }
                        i = t;
                    }
                    e.add(((() => {
                        let $ret = new TransactionState(h, g, i);
                        $ret.version = d[f].version;
                        return $ret;
                    })()));
                }
                let w = e.toArray();
                if (this.batchStarted != null) {
                    this.batchStarted(this, new DataSourceBatchStartedEventArgs(w));
                }
                this.actualDataProvider.createBatchRequest(w);
            }
        }
        em(a, b, c) {
            if (b) {
                this.queueAutoRefresh();
            }
            if (this.batchCompleted != null) {
                this.batchCompleted(this, new DataSourceBatchCompletedEventArgs(a, c));
            }
        }
    }
    VirtualDataSource.$t = /*@__PURE__*/ markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
})();

/**
 * Represents the final state of items with all transactions combined.
*/
class IgrTransactionState {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the ID for the state.  I.e. an items primary key.
    */
    get id() {
        return this.i.id;
    }
    set id(v) {
        this.i.id = v;
    }
    /**
     * Gets or sets how this state was created.
    */
    get transactionType() {
        return this.i.transactionType;
    }
    set transactionType(v) {
        this.i.transactionType = ensureEnum(TransactionType_$type, v);
    }
    /**
     * Gets or sets the final value with all transaction deltas combined.
    */
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = v;
    }
    /**
     * Gets or sets the version data for this item. Used for concurrency.
    */
    get version() {
        return this.i.version;
    }
    set version(v) {
        this.i.version = v;
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enumeration for the different transaction service events.
 */
var TransactionEvent = /*@__PURE__*/ (function (TransactionEvent) {
    /**
     * An undo action has occurred.
     */
    TransactionEvent[TransactionEvent["Undo"] = 0] = "Undo";
    /**
     * A redo action has occurred.
     */
    TransactionEvent[TransactionEvent["Redo"] = 1] = "Redo";
    /**
     * Transactions have been cleared from the service.
     */
    TransactionEvent[TransactionEvent["Clear"] = 2] = "Clear";
    /**
     * A transaction was added to the service.
     */
    TransactionEvent[TransactionEvent["Add"] = 3] = "Add";
    /**
     * Pending transactions have ended.
     */
    TransactionEvent[TransactionEvent["End"] = 4] = "End";
    /**
     * Transactions have been committed.
     */
    TransactionEvent[TransactionEvent["Commit"] = 5] = "Commit";
    return TransactionEvent;
})({});
/**
 * @hidden
 */
let TransactionEvent_$type = /*@__PURE__*/ markEnum('TransactionEvent', 'Undo,0|Redo,1|Clear,2|Add,3|End,4|Commit,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enumeration for the different pending states a transaction can be in.
 */
var TransactionPendingState = /*@__PURE__*/ (function (TransactionPendingState) {
    /**
     * The transaction will stay pending.
     */
    TransactionPendingState[TransactionPendingState["Pending"] = 0] = "Pending";
    /**
     * The transaction is to be accepted.
     */
    TransactionPendingState[TransactionPendingState["Accept"] = 1] = "Accept";
    /**
     * The transaction is to be rejected.
     */
    TransactionPendingState[TransactionPendingState["Reject"] = 2] = "Reject";
    return TransactionPendingState;
})({});
/**
 * @hidden
 */
let TransactionPendingState_$type = /*@__PURE__*/ markEnum('TransactionPendingState', 'Pending,0|Accept,1|Reject,2');

class IgrComponentRendererContainer extends Component {
    constructor(props) {
        super(props);
        this.listeners = [];
        this._currentRoot = null;
        this.rootCreated = this.rootCreated.bind(this);
        this.state = {};
    }
    rootCreated(rootRef) {
        this._currentRoot = rootRef;
        for (let i = 0; i < this.listeners.length; i++) {
            this.listeners[i](rootRef);
        }
        this.listeners.length = 0;
    }
    replaceRootItem(t, continueActions) {
        let act = (r) => {
            continueActions(true);
        };
        this.listeners.push(act);
        this.setState({ rootComponentType: t });
    }
    clearContainer(continueActions) {
        let act = (r) => {
            continueActions(true);
        };
        this.listeners.push(act);
        this.setState({ rootComponentType: null });
    }
    getRootObject() {
        return this._currentRoot;
    }
    render() {
        if (this.state.rootComponentType) {
            let ele = createElement(this.state.rootComponentType, { ref: this.rootCreated, width: "100%", height: "100%" });
            return createElement("div", { style: this.props.style ? this.props.style : { width: "100%", height: "100%" } }, ele);
        }
        else {
            return createElement("div", { style: this.props.style ? this.props.style : { width: "100%", height: "100%" } });
        }
    }
}

class ComponentRendererAdapter {
    constructor() {
        this._platform = "Igr";
    }
    createObject(type, container, context) {
        let typeName = "Igr" + type + "";
        if (TypeRegistrar.isRegistered(typeName)) {
            return TypeRegistrar.create(typeName);
        }
        let shortTypeName = "Igr" + type;
        if (TypeRegistrar.isRegistered(shortTypeName)) {
            return TypeRegistrar.create(shortTypeName);
        }
        if (TypeRegistrar.isRegistered(type)) {
            return TypeRegistrar.create(type);
        }
    }
    //createRootObject(type: string, container: any, context: TypeDescriptionContext, continueActions: (resumeRequired: boolean) => void) {
    //    let typeName = "Igr" + type;
    //    if (TypeRegistrar.isRegistered(typeName)) {
    //        let t = TypeRegistrar.get(typeName);
    //        let crc = container as IgrComponentRendererContainer;
    //        crc.createRootObject(t, continueActions);
    //    }
    //}
    createColorCollection(colors) {
        return colors;
    }
    createBrushCollection(brushes) {
        return brushes;
    }
    coerceToEnum(type, context, value) {
        return value;
    }
    onUIThread(container, action) {
        action();
    }
    setOrUpdateCollectionOnTarget(container, propertyName, propertyMetadata, context, target, value) {
        let coll = this.getPropertyValue(target, propertyName);
        if (coll instanceof IgCollection) {
            for (let i = 0; i < coll.count; i++) {
                if (coll.item(i) && coll.item(i)._implementation) {
                    coll.item(i).___parent = null;
                }
            }
            coll.clear();
            let newArr = value;
            for (let i = 0; i < newArr.length; i++) {
                if (newArr[i] && newArr[i]._implementation) {
                    newArr[i].___parent = target;
                }
            }
            for (let i = 0; i < newArr.length; i++) {
                coll.add(newArr[i]);
            }
        }
        else if (Array.isArray(coll) || coll == null || coll == undefined) {
            if (coll) {
                for (let i = 0; i < coll.length; i++) {
                    if (coll[i] && coll[i]._implementation) {
                        coll[i].___parent = null;
                    }
                }
            }
            let newArr = value;
            for (let i = 0; i < newArr.length; i++) {
                if (newArr[i] && newArr[i]._implementation) {
                    newArr[i].___parent = target;
                }
            }
            this.setPropertyValue(target, propertyName, propertyMetadata, value, coll, null);
        }
        else {
            if (coll.clear !== undefined) {
                if (coll.count && coll.item) {
                    for (let i = 0; i < coll.count; i++) {
                        if (coll.item(i) && coll.item(i)._implementation) {
                            coll.item(i).___parent = null;
                        }
                    }
                }
                coll.clear();
            }
            if (coll.add !== undefined) {
                let newArr = value;
                for (let i = 0; i < newArr.length; i++) {
                    if (newArr[i] && newArr[i]._implementation) {
                        newArr[i].___parent = target;
                    }
                }
                for (let i = 0; i < newArr.length; i++) {
                    coll.add(newArr[i]);
                }
            }
        }
    }
    onPendingRef(target, propertyName, propertyMetadata, sourceRef) {
    }
    setPropertyValue(target, propertyName, propertyMetadata, value, oldValue, sourceRef) {
        if (this._platform == "Igx" &&
            IgrComponentRendererContainer.isEvent &&
            IgrComponentRendererContainer.isEvent(target[propertyName])) {
            if (target["_" + propertyName + "Subscription"]) {
                target["_" + propertyName + "Subscription"]();
                target["_" + propertyName + "Subscription"] = null;
            }
            var fun = function (ev) {
                value(ev.sender, ev.args);
            };
            var sub = target[propertyName].subscribe(fun);
            target["_" + propertyName + "Subscription"] = sub;
            return;
        }
        if (oldValue && oldValue._implementation) {
            value.___parent = null;
        }
        if (value && value._implementation) {
            value.___parent = target;
        }
        target[propertyName] = value;
    }
    getPropertyValue(target, propertyName) {
        return target[propertyName];
    }
    clearContainer(container, context, continueActions) {
        if (this._platform === "Igc") {
            let crc = IgrComponentRendererContainer.fromElement(container);
            crc.clearContainer(continueActions);
            return;
        }
        let crc = container;
        crc.clearContainer(continueActions);
    }
    getRootObject(container) {
        if (this._platform === "Igc") {
            let crc = IgrComponentRendererContainer.fromElement(container);
            return crc.getRootObject();
        }
        let crc = container;
        return crc.getRootObject();
    }
    forPropertyValueItem(target, propertyName, forItem) {
        let coll = this.getPropertyValue(target, propertyName);
        if (coll instanceof IgCollection) {
            for (let i = 0; i < coll.count; i++) {
                forItem(coll.item(i));
            }
        }
        else if (Array.isArray(coll)) {
            for (let i = 0; i < coll.length; i++) {
                forItem(coll[i]);
            }
        }
        else {
            if (coll.clear !== undefined) {
                for (let i = 0; i < coll.count; i++) {
                    forItem(coll.item(i));
                }
            }
        }
    }
    clearCollection(target, propertyName, metadata) {
        let coll = this.getPropertyValue(target, propertyName);
        if (coll instanceof IgCollection) {
            for (let i = 0; i < coll.count; i++) {
                if (coll.item(i) && coll.item(i)._implementation) {
                    coll.item(i).___parent = null;
                }
            }
            coll.clear();
        }
        else if (Array.isArray(coll)) {
            for (let i = 0; i < coll.length; i++) {
                if (coll[i] && coll[i]._implementation) {
                    coll[i].___parent = null;
                }
            }
            this.setPropertyValue(target, propertyName, metadata, [], coll, null);
        }
        else {
            if (coll.clear !== undefined) {
                for (let i = 0; i < coll.count; i++) {
                    if (coll.item(i) && coll.item(i)._implementation) {
                        coll.item(i).___parent = null;
                    }
                }
                coll.clear();
            }
        }
    }
    addItemToCollection(propertyName, propertyMetadata, target, newIndex, item) {
        let coll = this.getPropertyValue(target, propertyName);
        if (item && item._implementation) {
            item.___parent = target;
        }
        if (coll instanceof IgCollection) {
            coll.insert(newIndex, item);
        }
        else if (Array.isArray(coll)) {
            let newArr = [];
            for (let i = 0; i < coll.length; i++) {
                newArr[i] = coll[i];
            }
            newArr.splice(newIndex, 0, item);
            this.setPropertyValue(target, propertyName, propertyMetadata, newArr, coll, null);
        }
        else {
            if (coll.insert !== undefined) {
                coll.insert(newIndex, item);
            }
        }
    }
    resetPropertyOnTarget(container, propertyName, propertyMetadata, target) {
        //TODO: anything we can do here? store default?
    }
    replaceItemInCollection(propertyName, propertyMetadata, target, newIndex, item) {
        let coll = this.getPropertyValue(target, propertyName);
        if (item && item._implementation) {
            item.___parent = target;
        }
        if (coll instanceof IgCollection) {
            let oldValue = coll.item(newIndex);
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            coll.item(newIndex, item);
        }
        else if (Array.isArray(coll)) {
            let newArr = [];
            for (let i = 0; i < coll.length; i++) {
                newArr[i] = coll[i];
            }
            let oldValue = newArr[newIndex];
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            newArr[newIndex] = item;
            this.setPropertyValue(target, propertyName, propertyMetadata, newArr, coll, null);
        }
        else {
            if (coll.item !== undefined) {
                let oldValue = coll.item(newIndex);
                if (oldValue && oldValue._implementation) {
                    oldValue.___parent = null;
                }
                coll.item(newIndex, item);
            }
        }
    }
    removeItemFromCollection(propertyName, propertyMetadata, target, oldIndex) {
        let coll = this.getPropertyValue(target, propertyName);
        if (coll instanceof IgCollection) {
            let oldValue = coll.item(oldIndex);
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            coll.removeAt(oldIndex);
        }
        else if (Array.isArray(coll)) {
            let newArr = [];
            for (let i = 0; i < coll.length; i++) {
                newArr[i] = coll[i];
            }
            let oldValue = newArr[oldIndex];
            if (oldValue && oldValue._implementation) {
                oldValue.___parent = null;
            }
            newArr.splice(oldIndex, 1);
            this.setPropertyValue(target, propertyName, propertyMetadata, newArr, coll, null);
        }
        else {
            if (coll.removeAt !== undefined) {
                let oldValue = coll.item(oldIndex);
                if (oldValue && oldValue._implementation) {
                    oldValue.___parent = null;
                }
                coll.removeAt(oldIndex);
            }
        }
    }
    replaceRootItem(container, type, context, continueActions) {
        let typeName = "Igr" + type + "";
        if (TypeRegistrar.isRegistered(typeName)) {
            let t = TypeRegistrar.get(typeName);
            if (this._platform === "Igc") {
                let crc = IgrComponentRendererContainer.fromElement(container);
                crc.replaceRootItem(t, continueActions);
                return;
            }
            let crc = container;
            crc.replaceRootItem(t, continueActions);
        }
        else {
            if (this._platform === "Igc") {
                let crc = IgrComponentRendererContainer.fromElement(container);
                crc.clearContainer(continueActions);
                return;
            }
            let crc = container;
            crc.clearContainer(continueActions);
        }
    }
    removeRootItem(container, context, continueActions) {
        this.clearContainer(container, context, continueActions);
    }
    flushChanges(container) {
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrComponentRendererContainerModule {
    static register() {
        TypeRegistrar.registerCons("IgrComponentRendererContainer", IgrComponentRendererContainer);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonWriter = /*@__PURE__*/ (() => {
    class JsonWriter extends Base {
        constructor() {
            super(...arguments);
            this.d = new StringBuilder(0);
            this.b = 0;
            this.a = true;
        }
        g() {
            this.b++;
        }
        e() {
            this.b--;
        }
        i(a) {
            this.f();
            this.d.l(a);
        }
        f() {
            if (this.a) {
                this.a = false;
                for (let a = 0; a < this.b; a++) {
                    this.d.l("\t");
                }
            }
        }
        j(a) {
            this.f();
            this.d.u(a);
            this.a = true;
        }
        h() {
            this.f();
            this.d.t();
            this.a = true;
        }
        toString() {
            return this.d.toString();
        }
    }
    JsonWriter.$t = /*@__PURE__*/ markType(JsonWriter, 'JsonWriter');
    return JsonWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryItem = /*@__PURE__*/ (() => {
    class JsonDictionaryItem extends Base {
        b() {
            let a = new JsonWriter();
            this.d(a);
            return a.toString();
        }
        d(a) {
        }
        a(a) {
            if (a == null) {
                return null;
            }
            return stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(a, "\\", "\\\\"), "\t", "\\t"), "\"", "\\\""), "\r", "\\r"), "\n", "\\n");
        }
        static c(a) {
            if (a == null) {
                return null;
            }
            let b = "";
            let c = -1;
            for (let d = 0; d < a.length; d++) {
                if (a.charAt(d) == '\\' && c == -1) {
                    c = d;
                }
                else {
                    if (c == -1) {
                        b += a.charAt(d);
                    }
                    else {
                        if (a.charAt(d) == 'n') {
                            b += "\n";
                            c = -1;
                        }
                        else if (a.charAt(d) == 'r') {
                            b += "\r";
                            c = -1;
                        }
                        else if (a.charAt(d) == 't') {
                            b += "\t";
                            c = -1;
                        }
                        else if (a.charAt(d) == '\"') {
                            b += "\"";
                            c = -1;
                        }
                        else if (a.charAt(d) == '\\') {
                            b += "\\";
                            c = -1;
                        }
                        else {
                            b += "\\" + a.charAt(d);
                            c = -1;
                        }
                    }
                }
            }
            return b;
        }
    }
    JsonDictionaryItem.$t = /*@__PURE__*/ markType(JsonDictionaryItem, 'JsonDictionaryItem');
    return JsonDictionaryItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryObject = /*@__PURE__*/ (() => {
    class JsonDictionaryObject extends JsonDictionaryItem {
        constructor() {
            super();
            this.h = new Dictionary$2(String_$type, JsonDictionaryItem.$, 0);
        }
        i(a, b) {
            this.h.item(a, b);
        }
        k(a) {
            this.h.removeItem(a);
        }
        j() {
            this.h.clear();
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.h.item(a, b);
                return b;
            }
            else {
                return this.h.item(a);
            }
        }
        g(a) {
            return this.h.containsKey(a);
        }
        e() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.h.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        d(a) {
            a.i("{");
            a.h();
            a.g();
            let b = this.e();
            if (b != null) {
                for (let c = 0; c < b.length; c++) {
                    if (c > 0) {
                        a.j(",");
                    }
                    let d = b[c];
                    let e = this.h.item(d);
                    a.i("\"" + this.a(d) + "\": ");
                    if (e == null) {
                        a.i("null");
                    }
                    else {
                        e.d(a);
                    }
                }
            }
            a.h();
            a.e();
            a.i("}");
        }
    }
    JsonDictionaryObject.$t = /*@__PURE__*/ markType(JsonDictionaryObject, 'JsonDictionaryObject', JsonDictionaryItem.$);
    return JsonDictionaryObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryArray = /*@__PURE__*/ (() => {
    class JsonDictionaryArray extends JsonDictionaryItem {
        constructor() {
            super(...arguments);
            this._items = null;
        }
        get items() {
            return this._items;
        }
        set items(a) {
            this._items = a;
        }
        d(a) {
            a.i("[");
            a.h();
            a.g();
            if (this.items != null) {
                for (let b = 0; b < this.items.length; b++) {
                    if (b > 0) {
                        a.j(",");
                    }
                    let c = this.items[b];
                    if (c == null) {
                        a.i("null");
                    }
                    else {
                        c.d(a);
                    }
                }
            }
            a.h();
            a.e();
            a.i("]");
        }
    }
    JsonDictionaryArray.$t = /*@__PURE__*/ markType(JsonDictionaryArray, 'JsonDictionaryArray', JsonDictionaryItem.$);
    return JsonDictionaryArray;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryValue = /*@__PURE__*/ (() => {
    class JsonDictionaryValue extends JsonDictionaryItem {
        constructor() {
            super();
            this._value = null;
            this.e = 0;
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        d(a) {
            switch (this.e) {
                case 1:
                    if (this.value) {
                        a.i("true");
                    }
                    else {
                        a.i("false");
                    }
                    break;
                case 3:
                    a.i("null");
                    break;
                case 0:
                    a.i(this.value.toString());
                    break;
                case 2:
                    a.i("\"" + this.a(this.value) + "\"");
                    break;
            }
        }
    }
    JsonDictionaryValue.$t = /*@__PURE__*/ markType(JsonDictionaryValue, 'JsonDictionaryValue', JsonDictionaryItem.$);
    return JsonDictionaryValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryParser = /*@__PURE__*/ (() => {
    class JsonDictionaryParser extends Base {
        parse(json_) {
            let a = JSON.parse(json_);
            return JsonDictionaryParser.b(a);
        }
        static d(item_) {
            let propertyKey_ = null;
            let ret_ = new List$1(String_$type, 0);
            let exclusions_ = {};
            for (propertyKey_ in item_) {
                if (!isNaN(propertyKey_)) {
                    continue;
                }
                if (!exclusions_.hasOwnProperty(propertyKey_)) {
                    ret_.add(propertyKey_);
                }
            }
            ;
            return ret_;
        }
        static b(obj_) {
            if (typeCast(Array_$type, obj_) !== null) {
                return JsonDictionaryParser.a(obj_);
            }
            if (typeof obj_ === 'number') {
                return JsonDictionaryParser.a(obj_);
            }
            if (typeof obj_ === 'string') {
                return JsonDictionaryParser.a(obj_);
            }
            if (typeCast(Boolean_$type, obj_) !== null) {
                return JsonDictionaryParser.a(obj_);
            }
            let a = new JsonDictionaryObject();
            let b = JsonDictionaryParser.d(obj_);
            for (let c = 0; c < b.count; c++) {
                let key_ = b._inner[c];
                let d = obj_[key_];
                d = JsonDictionaryParser.a(d);
                a.item(key_, d);
            }
            return a;
        }
        static a(a) {
            if (typeCast(Array_$type, a) !== null) {
                let b = a;
                let c = new Array(b.length);
                for (let d = 0; d < b.length; d++) {
                    c[d] = JsonDictionaryParser.a(b[d]);
                }
                return ((() => {
                    let $ret = new JsonDictionaryArray();
                    $ret.items = c;
                    return $ret;
                })());
            }
            else if (typeof a === 'number') {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 0;
                    return $ret;
                })());
            }
            else if (typeof a === 'string') {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 2;
                    return $ret;
                })());
            }
            else if (typeCast(Boolean_$type, a) !== null) {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 1;
                    return $ret;
                })());
            }
            else if (a == null) {
                return ((() => {
                    let $ret = new JsonDictionaryValue();
                    $ret.value = a;
                    $ret.e = 3;
                    return $ret;
                })());
            }
            else {
                return JsonDictionaryParser.b(a);
            }
        }
    }
    JsonDictionaryParser.$t = /*@__PURE__*/ markType(JsonDictionaryParser, 'JsonDictionaryParser');
    return JsonDictionaryParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationLibraryItemType = /*@__PURE__*/ (function (CodeGenerationLibraryItemType) {
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["Data"] = 0] = "Data";
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["EventHandler"] = 1] = "EventHandler";
    CodeGenerationLibraryItemType[CodeGenerationLibraryItemType["Unknown"] = 2] = "Unknown";
    return CodeGenerationLibraryItemType;
})({});
/**
 * @hidden
 */
let CodeGenerationLibraryItemType_$type = /*@__PURE__*/ markEnum('CodeGenerationLibraryItemType', 'Data,0|EventHandler,1|Unknown,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationLibraryItemPlatform = /*@__PURE__*/ (function (CodeGenerationLibraryItemPlatform) {
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Angular"] = 0] = "Angular";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["React"] = 1] = "React";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["WebComponents"] = 2] = "WebComponents";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["JQuery"] = 3] = "JQuery";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["WPF"] = 4] = "WPF";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["WindowsForms"] = 5] = "WindowsForms";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Web"] = 6] = "Web";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["AllWeb"] = 7] = "AllWeb";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Desktop"] = 8] = "Desktop";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Win"] = 9] = "Win";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["XPlat"] = 10] = "XPlat";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["All"] = 11] = "All";
    CodeGenerationLibraryItemPlatform[CodeGenerationLibraryItemPlatform["Unknown"] = 12] = "Unknown";
    return CodeGenerationLibraryItemPlatform;
})({});
/**
 * @hidden
 */
let CodeGenerationLibraryItemPlatform_$type = /*@__PURE__*/ markEnum('CodeGenerationLibraryItemPlatform', 'Angular,0|React,1|WebComponents,2|JQuery,3|WPF,4|WindowsForms,5|Web,6|AllWeb,7|Desktop,8|Win,9|XPlat,10|All,11|Unknown,12');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationLibraryItemContent = /*@__PURE__*/ (() => {
    class CodeGenerationLibraryItemContent extends Base {
        constructor() {
            super(...arguments);
            this._platform = 0;
            this._content = null;
            this._isJson = false;
        }
        get platform() {
            return this._platform;
        }
        set platform(a) {
            this._platform = a;
        }
        get content() {
            return this._content;
        }
        set content(a) {
            this._content = a;
        }
        get isJson() {
            return this._isJson;
        }
        set isJson(a) {
            this._isJson = a;
        }
        static a(a) {
            let b = new CodeGenerationLibraryItemContent();
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                if (c.g("platform")) {
                    let d = c.item("platform");
                    b.platform = CodeGenerationLibraryItemContent.b(d);
                }
                if (c.g("content")) {
                    let e = c.item("content");
                    b.content = e.value;
                }
                if (c.g("isJson")) {
                    let f = c.item("isJson");
                    b.isJson = f.value;
                }
            }
            return b;
        }
        d() {
            let a = new JsonDictionaryObject();
            a.item("platform", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(CodeGenerationLibraryItemPlatform_$type, this.platform);
                return $ret;
            })()));
            a.item("content", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = this.content;
                return $ret;
            })()));
            a.item("isJson", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 1;
                $ret.value = this.isJson;
                return $ret;
            })()));
            return a;
        }
        static b(a) {
            let b = a.value;
            let c;
            if (((() => { let d = EnumUtil.tryParse$1(CodeGenerationLibraryItemPlatform_$type, b, true, c); c = d.p2; return d.ret; })())) {
                return c;
            }
            return 12;
        }
    }
    CodeGenerationLibraryItemContent.$t = /*@__PURE__*/ markType(CodeGenerationLibraryItemContent, 'CodeGenerationLibraryItemContent');
    return CodeGenerationLibraryItemContent;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var CodeGenerationTargetPlatforms = /*@__PURE__*/ (function (CodeGenerationTargetPlatforms) {
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["WPF"] = 0] = "WPF";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["Angular"] = 1] = "Angular";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["React"] = 2] = "React";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["WebComponents"] = 3] = "WebComponents";
    CodeGenerationTargetPlatforms[CodeGenerationTargetPlatforms["WindowsForms"] = 4] = "WindowsForms";
    return CodeGenerationTargetPlatforms;
})({});
/**
 * @hidden
 */
let CodeGenerationTargetPlatforms_$type = /*@__PURE__*/ markEnum('CodeGenerationTargetPlatforms', 'WPF,0|Angular,1|React,2|WebComponents,3|WindowsForms,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationLibraryItem = /*@__PURE__*/ (() => {
    class CodeGenerationLibraryItem extends Base {
        constructor() {
            super(...arguments);
            this._name = null;
            this._type = 0;
            this.i = new Dictionary$2(CodeGenerationLibraryItemPlatform_$type, CodeGenerationLibraryItemContent.$, 0);
            this.j = new List$1(CodeGenerationLibraryItemContent.$, 0);
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get type() {
            return this._type;
        }
        set type(a) {
            this._type = a;
        }
        getContentForPlatformString(a) {
            let b;
            b = EnumUtil.getEnumValue(CodeGenerationTargetPlatforms_$type, EnumUtil.parse(CodeGenerationTargetPlatforms_$type, a, true));
            return this.getContentForPlatform(b);
        }
        getContentForPlatform(a) {
            for (let b of fromEnum(this.j)) {
                if (this.h(b, a)) {
                    return b;
                }
            }
            return null;
        }
        h(a, b) {
            switch (a.platform) {
                case 11: return true;
                case 7: return b == 1 || b == 2 || b == 3;
                case 0: return b == 1;
                case 8: return b == 0 || b == 4;
                case 3: return false;
                case 1: return b == 2;
                case 12: return false;
                case 6: return b == 1 || b == 2 || b == 3;
                case 2: return b == 3;
                case 9: return b == 0 || b == 4;
                case 5: return b == 4;
                case 4: return b == 0;
                case 10: return true;
            }
            return false;
        }
        addPlatformContent(a, b) {
            if (b == null) {
                return;
            }
            this.i.item(a, b);
            b.platform = a;
            this.j.add(b);
        }
        b(a) {
            if (a == null) {
                return null;
            }
            return ((() => {
                let $ret = new CodeGenerationLibraryItemContent();
                $ret.content = a;
                return $ret;
            })());
        }
        e(a) {
            if (a == null) {
                return null;
            }
            return ((() => {
                let $ret = new CodeGenerationLibraryItemContent();
                $ret.content = a;
                $ret.isJson = true;
                return $ret;
            })());
        }
        static a(a) {
            let b = new CodeGenerationLibraryItem();
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                if (c.g("name")) {
                    b.name = c.item("name").value.toString();
                }
                if (c.g("type")) {
                    let d = c.item("type").value.toString();
                    let e = EnumUtil.getEnumValue(CodeGenerationLibraryItemType_$type, EnumUtil.parse(CodeGenerationLibraryItemType_$type, d, true));
                    b.type = e;
                }
                if (c.g("content")) {
                    let f = c.item("content");
                    if (typeCast(JsonDictionaryArray.$, f) !== null) {
                        let g = f;
                        if (g.items != null && g.items.length > 0) {
                            for (let h = 0; h < g.items.length; h++) {
                                let i = CodeGenerationLibraryItemContent.a(g.items[h]);
                                b.j.add(i);
                                b.i.addItem(i.platform, i);
                            }
                        }
                    }
                }
            }
            return b;
        }
        g() {
            let a = new JsonDictionaryObject();
            a.item("name", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = this.name;
                return $ret;
            })()));
            let b = new JsonDictionaryArray();
            a.item("content", b);
            a.item("type", ((() => {
                let $ret = new JsonDictionaryValue();
                $ret.e = 2;
                $ret.value = EnumUtil.getName(CodeGenerationLibraryItemType_$type, this.type);
                return $ret;
            })()));
            let c = new List$1(JsonDictionaryItem.$, 0);
            for (let d of fromEnum(this.j)) {
                let e = d.d();
                c.add(e);
            }
            b.items = c.toArray();
            return a;
        }
    }
    CodeGenerationLibraryItem.$t = /*@__PURE__*/ markType(CodeGenerationLibraryItem, 'CodeGenerationLibraryItem');
    return CodeGenerationLibraryItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationLibrary = /*@__PURE__*/ (() => {
    class CodeGenerationLibrary extends Base {
        constructor() {
            super(...arguments);
            this.e = new List$1(CodeGenerationLibraryItem.$, 0);
            this.d = new Dictionary$2(String_$type, CodeGenerationLibraryItem.$, 0);
        }
        static fromJson(a) {
            let b = new JsonDictionaryParser();
            let c = b.parse(a);
            let d = new CodeGenerationLibrary();
            if (typeCast(JsonDictionaryObject.$, c) !== null) {
                let e = c;
                if (e.g("items")) {
                    let f = typeCast(JsonDictionaryArray.$, e.item("items"));
                    if (f != null) {
                        let i = f.items;
                        for (let h = 0; h < i.length; h++) {
                            let g = i[h];
                            let j = CodeGenerationLibraryItem.a(g);
                            d.e.add(j);
                            d.d.addItem(j.name, j);
                        }
                    }
                }
            }
            return d;
        }
        toJson() {
            let a = new JsonDictionaryObject();
            let b = new JsonDictionaryArray();
            a.item("items", b);
            let c = new List$1(JsonDictionaryItem.$, 0);
            for (let d of fromEnum(this.e)) {
                let e = d.g();
                c.add(e);
            }
            b.items = c.toArray();
            return a.b();
        }
        hasItem(a) {
            return this.d.containsKey(a);
        }
        getItem(a) {
            return this.d.item(a);
        }
    }
    CodeGenerationLibrary.$t = /*@__PURE__*/ markType(CodeGenerationLibrary, 'CodeGenerationLibrary');
    return CodeGenerationLibrary;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationItemBuilderPropertyInfo = /*@__PURE__*/ (() => {
    class CodeGenerationItemBuilderPropertyInfo extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.c = null;
            this.a = null;
        }
    }
    CodeGenerationItemBuilderPropertyInfo.$t = /*@__PURE__*/ markType(CodeGenerationItemBuilderPropertyInfo, 'CodeGenerationItemBuilderPropertyInfo');
    return CodeGenerationItemBuilderPropertyInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingRendererResult = /*@__PURE__*/ (() => {
    class CodeGeneratingRendererResult extends Base {
        constructor() {
            super(...arguments);
            this.h = new List$1(CodeGenerationItemBuilderPropertyInfo.$, 0);
            this._platform = 0;
            this.f = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.e = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.d = new Dictionary$2(String_$type, Number_$type, 0);
            this.g = new Dictionary$2(String_$type, String_$type, 0);
        }
        get j() {
            return this.h;
        }
        get platform() {
            return this._platform;
        }
        set platform(a) {
            this._platform = a;
        }
        addContainerResult(a, b) {
            if (!this.f.containsKey(a)) {
                this.f.addItem(a, new List$1(String_$type, 0));
            }
            let c = this.f.item(a);
            c.add(b);
        }
        addContainerNewFileResult(a, b) {
            if (!this.e.containsKey(a)) {
                this.e.addItem(a, new List$1(String_$type, 0));
            }
            let c = this.e.item(a);
            c.add(b);
        }
        getKeys() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.f.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        getContentForKey(a) {
            if (!this.f.containsKey(a)) {
                return "";
            }
            let b = this.f.item(a);
            if (b.count == 1) {
                return b._inner[0];
            }
            let c = "";
            for (let d of fromEnum(b)) {
                c += d;
            }
            return c;
        }
        k(a) {
            if (!this.d.containsKey(a)) {
                this.d.item(a, 1);
            }
            let b = this.d.item(a);
            let c = a + b;
            this.d.item(a, b + 1);
            return c;
        }
        r(a) {
            this.h.add(a);
        }
        getNewFiles() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.e.keys)) {
                a.add(b);
            }
            return a;
        }
        getNewFileContent(a) {
            let b = this.e.item(a);
            let c = "";
            for (let d of fromEnum(b)) {
                c += d;
            }
            return c;
        }
        defineString(a, b) {
            this.g.item(a, b);
        }
        getStringNames() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.g.keys)) {
                a.add(b);
            }
            return a.toArray();
        }
        getString(a) {
            return this.g.item(a);
        }
    }
    CodeGeneratingRendererResult.$t = /*@__PURE__*/ markType(CodeGeneratingRendererResult, 'CodeGeneratingRendererResult');
    return CodeGeneratingRendererResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingCodeWriter = /*@__PURE__*/ (() => {
    class CodeGeneratingCodeWriter extends Base {
        constructor() {
            super(...arguments);
            this.d = new StringBuilder(0);
            this.b = 0;
            this.a = true;
        }
        g() {
            this.b++;
        }
        e() {
            this.b--;
        }
        i(a) {
            this.f();
            this.d.l(a);
        }
        f() {
            if (this.a) {
                this.a = false;
                for (let a = 0; a < this.b; a++) {
                    this.d.l("\t");
                }
            }
        }
        j(a) {
            this.f();
            this.d.u(a);
            this.a = true;
        }
        h() {
            this.f();
            this.d.t();
            this.a = true;
        }
        toString() {
            return this.d.toString();
        }
    }
    CodeGeneratingCodeWriter.$t = /*@__PURE__*/ markType(CodeGeneratingCodeWriter, 'CodeGeneratingCodeWriter');
    return CodeGeneratingCodeWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TypeDescriptionPlatform = /*@__PURE__*/ (function (TypeDescriptionPlatform) {
    TypeDescriptionPlatform[TypeDescriptionPlatform["WPF"] = 0] = "WPF";
    TypeDescriptionPlatform[TypeDescriptionPlatform["JQuery"] = 1] = "JQuery";
    TypeDescriptionPlatform[TypeDescriptionPlatform["React"] = 2] = "React";
    TypeDescriptionPlatform[TypeDescriptionPlatform["Angular"] = 3] = "Angular";
    TypeDescriptionPlatform[TypeDescriptionPlatform["WebComponents"] = 4] = "WebComponents";
    TypeDescriptionPlatform[TypeDescriptionPlatform["XamarinForms"] = 5] = "XamarinForms";
    TypeDescriptionPlatform[TypeDescriptionPlatform["XamarinAndroid"] = 6] = "XamarinAndroid";
    TypeDescriptionPlatform[TypeDescriptionPlatform["XamariniOS"] = 7] = "XamariniOS";
    TypeDescriptionPlatform[TypeDescriptionPlatform["WindowsForms"] = 8] = "WindowsForms";
    return TypeDescriptionPlatform;
})({});
/**
 * @hidden
 */
let TypeDescriptionPlatform_$type = /*@__PURE__*/ markEnum('TypeDescriptionPlatform', 'WPF,0|JQuery,1|React,2|Angular,3|WebComponents,4|XamarinForms,5|XamarinAndroid,6|XamariniOS,7|WindowsForms,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypeDescriptionMetadata = /*@__PURE__*/ (() => {
    class TypeDescriptionMetadata extends Base {
        constructor() {
            super(...arguments);
            this._owningType = null;
            this._propertyName = null;
            this._knownType = 0;
            this._specificType = null;
            this._specificExternalType = null;
            this._collectionElementType = null;
            this.c = new Dictionary$2(TypeDescriptionPlatform_$type, String_$type, 0);
            this.d = new Dictionary$2(TypeDescriptionPlatform_$type, String_$type, 0);
        }
        get owningType() {
            return this._owningType;
        }
        set owningType(a) {
            this._owningType = a;
        }
        get propertyName() {
            return this._propertyName;
        }
        set propertyName(a) {
            this._propertyName = a;
        }
        get knownType() {
            return this._knownType;
        }
        set knownType(a) {
            this._knownType = a;
        }
        get specificType() {
            return this._specificType;
        }
        set specificType(a) {
            this._specificType = a;
        }
        get specificExternalType() {
            return this._specificExternalType;
        }
        set specificExternalType(a) {
            this._specificExternalType = a;
        }
        get collectionElementType() {
            return this._collectionElementType;
        }
        set collectionElementType(a) {
            this._collectionElementType = a;
        }
        m(a, b) {
            if (stringContains(b, "/")) {
                let c = b.split('/');
                this.d.item(a, c[1].trim());
                this.c.item(a, c[0].trim());
            }
            else {
                this.c.item(a, b.trim());
            }
        }
        static camelize(a) {
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        g(a) {
            let b = "";
            if (this.c.containsKey(a)) {
                b = this.c.item(a);
            }
            else {
                b = this.propertyName;
            }
            if (TypeDescriptionMetadata.shouldCamelize(a)) {
                return TypeDescriptionMetadata.camelize(b);
            }
            return b;
        }
        static shouldCamelize(a) {
            if (a == 3 || a == 1 || a == 4 || a == 2) {
                return true;
            }
            return false;
        }
        h(a) {
            if (this.d.containsKey(a)) {
                return this.d.item(a);
            }
            else {
                return null;
            }
        }
    }
    TypeDescriptionMetadata.$t = /*@__PURE__*/ markType(TypeDescriptionMetadata, 'TypeDescriptionMetadata');
    return TypeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TypeDescriptionWellKnownType = /*@__PURE__*/ (function (TypeDescriptionWellKnownType) {
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Void"] = 0] = "Void";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Number"] = 1] = "Number";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["string1"] = 2] = "string1";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Date"] = 3] = "Date";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Brush"] = 4] = "Brush";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Color"] = 5] = "Color";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["BrushCollection"] = 6] = "BrushCollection";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["boolean1"] = 7] = "boolean1";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["ExportedType"] = 8] = "ExportedType";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Collection"] = 9] = "Collection";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Array"] = 10] = "Array";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Point"] = 11] = "Point";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Size"] = 12] = "Size";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["IList"] = 13] = "IList";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Rect"] = 14] = "Rect";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["DataTemplate"] = 15] = "DataTemplate";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["ColorCollection"] = 16] = "ColorCollection";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["Unknown"] = 17] = "Unknown";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["MethodRef"] = 18] = "MethodRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["EventRef"] = 19] = "EventRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["DataRef"] = 20] = "DataRef";
    TypeDescriptionWellKnownType[TypeDescriptionWellKnownType["TimeSpan"] = 21] = "TimeSpan";
    return TypeDescriptionWellKnownType;
})({});
/**
 * @hidden
 */
let TypeDescriptionWellKnownType_$type = /*@__PURE__*/ markEnum('TypeDescriptionWellKnownType', 'Void,0|Number,1|String:string1,2|Date,3|Brush,4|Color,5|BrushCollection,6|Boolean:boolean1,7|ExportedType,8|Collection,9|Array,10|Point,11|Size,12|IList,13|Rect,14|DataTemplate,15|ColorCollection,16|Unknown,17|MethodRef,18|EventRef,19|DataRef,20|TimeSpan,21');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IComponentRendererAdapter_$type = /*@__PURE__*/ new Type(null, 'IComponentRendererAdapter');
/**
 * @hidden
 */
let TypeDescriptionContext = /*@__PURE__*/ (() => {
    class TypeDescriptionContext extends Base {
        constructor(a, b) {
            super();
            this.h = new Dictionary$2(String_$type, Base.$, 0);
            this.g = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.c = null;
            this.e = 0;
            this.c = a;
            this.e = b;
        }
        p(a, b) {
            this.h.item(a, b);
        }
        q(a, b) {
            this.g.item(a, b);
        }
        static o(key_) {
            if (key_ == null) {
                return null;
            }
            return key_.substr(0, 1).toUpperCase() + key_.substr(1);
        }
        static n(key_) {
            if (key_ == null) {
                return null;
            }
            return key_.substr(0, 1).toLowerCase() + key_.substr(1);
        }
        a(a) {
            if (this.h.containsKey(a)) {
                let b = this.h.item(a);
                return new List$1(String_$type, 1, b.keys).toArray();
            }
            else {
                return null;
            }
        }
        d(a, b) {
            if (this.h.containsKey(a + "@@" + b)) {
                return this.h.item(a + "@@" + b);
            }
            if (this.h.containsKey(a)) {
                let c = new TypeDescriptionMetadata();
                c.owningType = a;
                c.propertyName = b;
                let d = this.h.item(a);
                if (!d.containsKey(b)) {
                    this.h.item(a + "@@" + b, null);
                    return null;
                }
                let e = d.item(b);
                let f = "Unknown";
                let g = null;
                let h = null;
                let i = null;
                let j = e.split(')');
                if (j.length > 1) {
                    let k = j[0];
                    e = j[1];
                    k = stringReplace(k, "(", "");
                    let l = k.split(',');
                    for (let n = 0; n < l.length; n++) {
                        let m = l[n];
                        let o = m.split(':');
                        let p = o[0];
                        let q = o[1];
                        let r = 3;
                        switch (p) {
                            case "web":
                                c.m(3, q);
                                c.m(2, q);
                                c.m(4, q);
                                c.m(1, q);
                                continue;
                            case "w":
                                r = 0;
                                break;
                            case "a":
                                r = 3;
                                break;
                            case "r":
                                r = 2;
                                break;
                            case "j":
                                r = 1;
                                break;
                            case "wc":
                                r = 4;
                                break;
                            case "xf":
                                r = 5;
                                break;
                            case "xa":
                                r = 6;
                                break;
                            case "xi":
                                r = 7;
                                break;
                            case "wf":
                                r = 8;
                                break;
                        }
                        c.m(r, q);
                    }
                }
                let s = e.split(':');
                if (s.length >= 4) {
                    i = s[3];
                }
                if (s.length >= 3) {
                    g = s[2];
                }
                if (s.length >= 2) {
                    h = s[1];
                }
                if (s.length >= 1) {
                    f = s[0];
                }
                c.knownType = EnumUtil.getEnumValue(TypeDescriptionWellKnownType_$type, EnumUtil.parse(TypeDescriptionWellKnownType_$type, f, true));
                c.specificExternalType = h;
                c.specificType = g;
                c.collectionElementType = i;
                this.h.item(a + "@@" + b, c);
                return c;
            }
            return null;
        }
        l(a) {
            if (this.g.containsKey(a)) {
                return this.g.item(a)();
            }
            return null;
        }
        r(a, b, c, d) {
            if (TypeDescriptionMetadata.shouldCamelize(this.e)) {
                b = TypeDescriptionContext.n(b);
            }
            else {
                b = TypeDescriptionContext.o(b);
            }
            this.c.setPropertyValue(a, b, c, d, null, null);
        }
        s(a, b, c, d) {
            b = TypeDescriptionContext.o(b);
            this.c.setPropertyValue(a, b, c, d, null, null);
        }
        k(a) {
            return this.c.createColorCollection(a);
        }
        j(a) {
            return this.c.createBrushCollection(a);
        }
        m(a, b) {
            return this.c.createObject(a, b, this);
        }
        i(a, b) {
            return this.c.coerceToEnum(a, this, b);
        }
        b(a, b) {
            if (this.h.containsKey(a + "@@" + b + "@names")) {
                return this.h.item(a + "@@" + b + "@names");
            }
            if (this.h.containsKey(a)) {
                let c = this.h.item(a);
                if (!c.containsKey(b + "@names")) {
                    this.h.item(a + "@@" + b + "@names", null);
                    return null;
                }
                let d = c.item(b + "@names");
                let e = d.split(';');
                this.h.item(a + "@@" + b + "@names", e);
                return e;
            }
            else {
                return null;
            }
        }
        f(a, b) {
            if (this.h.containsKey(a + "@@" + b + "@nameBinding")) {
                return this.h.item(a + "@@" + b + "@nameBinding") == "true";
            }
            if (this.h.containsKey(a)) {
                let c = this.h.item(a);
                if (!c.containsKey(b + "@nameBinding")) {
                    this.h.item(a + "@@" + b + "@nameBinding", null);
                    return false;
                }
                let d = c.item(b + "@nameBinding");
                this.h.item(a + "@@" + b + "@names", d);
                return d == "true";
            }
            else {
                return false;
            }
        }
    }
    TypeDescriptionContext.$t = /*@__PURE__*/ markType(TypeDescriptionContext, 'TypeDescriptionContext');
    return TypeDescriptionContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationSpecialValue = /*@__PURE__*/ (() => {
    class CodeGenerationSpecialValue extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = null;
        }
    }
    CodeGenerationSpecialValue.$t = /*@__PURE__*/ markType(CodeGenerationSpecialValue, 'CodeGenerationSpecialValue');
    return CodeGenerationSpecialValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererDataEmitterPropertyType = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererDataEmitterPropertyType extends Base {
        constructor() {
            super(...arguments);
            this.c = 0;
            this.f = false;
            this.a = null;
            this.b = null;
            this.d = false;
        }
        e() {
            if (!this.f && !this.d) {
                return true;
            }
            if (this.a == null) {
                return false;
            }
            for (let a = 0; a < this.a.length; a++) {
                let b = this.b[a];
                if (b.f) {
                    if (!b.e()) {
                        return false;
                    }
                }
            }
            return true;
        }
    }
    CodeGeneratingComponentRendererDataEmitterPropertyType.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererDataEmitterPropertyType, 'CodeGeneratingComponentRendererDataEmitterPropertyType');
    return CodeGeneratingComponentRendererDataEmitterPropertyType;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererDataEmitterItemType = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererDataEmitterItemType extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = null;
            this.b = null;
        }
    }
    CodeGeneratingComponentRendererDataEmitterItemType.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererDataEmitterItemType, 'CodeGeneratingComponentRendererDataEmitterItemType');
    return CodeGeneratingComponentRendererDataEmitterItemType;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererDataEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererDataEmitter extends Base {
        constructor(a, b) {
            super();
            this.l = null;
            this.k = null;
            this.f = new CodeGeneratingCodeWriter();
            this.e = new CodeGeneratingCodeWriter();
            this.c = new CodeGeneratingCodeWriter();
            this.d = new CodeGeneratingCodeWriter();
            this.l = a;
            this.k = b;
        }
        r(a, b = false) {
            return a;
        }
        q(a) {
            return a;
        }
        get j() {
            return this.f;
        }
        get i() {
            return this.e;
        }
        get g() {
            return this.c;
        }
        get h() {
            return this.d;
        }
        p(a, b) {
            return null;
        }
        get_o() {
            return "";
        }
        get o() {
            return this.get_o();
        }
        v(a) {
            let b = a;
            let c = b.e();
            for (let d = 0; d < c.length; d++) {
                let e = c[d];
                let f = b.item(e);
                if (typeCast(JsonDictionaryValue.$, f) !== null) {
                    let g = f;
                    this.ab(e, g);
                }
                else if (typeCast(JsonDictionaryArray.$, f) !== null) {
                    let h = f;
                    this.z(e, h, this.j, this.g);
                    this.aa(e);
                }
                else {
                    let i = f;
                    let j = this.a(i);
                    let k = this.b(i);
                    let l = this.n(this.r(e, true), j, k);
                    for (let m of fromEnum(l)) {
                        this.w(m, this.j, this.g);
                    }
                    this.ac(e, j, k, i);
                }
            }
            let n = new HashSet$1(String_$type, 0);
            for (let o = 0; o < this.k.j.count; o++) {
                let p = this.k.j._inner[o];
                if (p.a != null && p.c == null) {
                    if (this.l.library != null && this.l.library.hasItem(p.a.e)) {
                        if (n.contains(p.a.e)) {
                            continue;
                        }
                        n.add_1(p.a.e);
                        let q = this.l.library.getItem(p.a.e);
                        if (q.type == 0) {
                            let r = new CodeGeneratingCodeWriter();
                            let s = new CodeGeneratingCodeWriter();
                            let t = q.name;
                            let u = q.getContentForPlatform(this.k.platform);
                            if (u.isJson) {
                                let v = new JsonDictionaryParser();
                                let w = v.parse(u.content);
                                this.y(r);
                                this.z(t, w, r, s);
                                this.x(r);
                                this.aa(t);
                            }
                            else {
                                let x = u.content;
                                this.t(t, s);
                                r.i(x);
                                this.aa(t);
                            }
                            this.u(t, s);
                            this.k.addContainerNewFileResult(t + this.o, r.toString());
                        }
                    }
                }
            }
            this.k.addContainerResult("vmProperties", this.i.toString());
            this.k.addContainerResult("vmImports", this.g.toString());
            this.k.addContainerResult("vmLibraryImports", this.h.toString());
            this.k.addContainerResult("vmData", this.j.toString());
        }
        x(a) {
        }
        y(a) {
        }
        u(a, b) {
        }
        t(a, b) {
        }
        ac(a, b, c, d) {
        }
        aa(a) {
        }
        ab(a, b) {
        }
        z(a, b, c, d) {
            if (typeCast(JsonDictionaryArray.$, b) !== null) {
                let e = b;
                if (e.items != null && e.items.length > 0) {
                    let f = this.m(e.items);
                    if (f != null) {
                        let g = this.a(f);
                        let h = this.b(f);
                        if (g != null) {
                            this.ae(a, g, h, c, d);
                            for (let i = 0; i < e.items.length; i++) {
                                this.s(a, g, h, e.items[i], i, c);
                            }
                            this.ad(a, g, h, c);
                        }
                    }
                }
            }
        }
        ad(a, b, c, d) {
        }
        w(a, b, c) {
        }
        n(a, b, c) {
            let d = new List$1(CodeGeneratingComponentRendererDataEmitterItemType.$, 0);
            let e = new CodeGeneratingComponentRendererDataEmitterItemType();
            e.c = a;
            e.a = b;
            e.b = c;
            d.add(e);
            for (let f = 0; f < b.length; f++) {
                let g = b[f];
                let h = c[f];
                if (h.f) {
                    let i = this.n(this.r(a) + "_" + g, h.a, h.b);
                    d.o(i);
                }
                else if (h.d) {
                    let j = this.n(this.r(a) + "_" + g + "Item", h.a, h.b);
                    d.o(j);
                }
            }
            return d;
        }
        s(a, b, c, d, e, f) {
        }
        ae(a, b, c, d, e) {
        }
        b(a) {
            let b = new List$1(CodeGeneratingComponentRendererDataEmitterPropertyType.$, 0);
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let c = a;
                let d = c.e();
                for (let f = 0; f < d.length; f++) {
                    let e = d[f];
                    let g = c.item(e);
                    let h = new CodeGeneratingComponentRendererDataEmitterPropertyType();
                    if (typeCast(JsonDictionaryObject.$, g) !== null) {
                        h.f = true;
                        let i = this.a(g);
                        let j = this.b(g);
                        h.a = i;
                        h.b = j;
                    }
                    else if (typeCast(JsonDictionaryArray.$, g) !== null) {
                        h.d = true;
                        let k = g;
                        if (k.items != null && k.items.length > 0) {
                            let l = this.m(k.items);
                            let m = this.a(l);
                            let n = this.b(l);
                            h.a = m;
                            h.b = n;
                        }
                    }
                    else {
                        let o = g;
                        h.c = o.e;
                    }
                    b.add(h);
                }
                return b.toArray();
            }
            return null;
        }
        a(a) {
            if (typeCast(JsonDictionaryObject.$, a) !== null) {
                let b = a;
                return b.e();
            }
            return null;
        }
        m(a) {
            for (let b = 0; b < a.length; b++) {
                if (a[b] != null) {
                    let c = this.b(a[b]);
                    if (c == null) {
                        continue;
                    }
                    for (let d = 0; d < c.length; d++) {
                        if (!c[d].e()) {
                            continue;
                        }
                    }
                    return a[b];
                }
            }
            return null;
        }
    }
    CodeGeneratingComponentRendererDataEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererDataEmitter, 'CodeGeneratingComponentRendererDataEmitter');
    return CodeGeneratingComponentRendererDataEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypeDescriptionCleanups = /*@__PURE__*/ (() => {
    class TypeDescriptionCleanups extends Base {
        constructor() {
            super();
            this.a = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.a.item("Series", (a) => {
                let s_ = a;
                if (s_.removeAxes)
                    s_.removeAxes();
            });
        }
        b(a, b) {
            if (b == null) {
                return;
            }
            let c = "";
            let d;
            let obj_ = b;
            let impl_ = obj_.i;
            let e = (impl_);
            if (e) {
                d = getInstanceType(impl_);
            }
            else {
                impl_ = obj_._chart || obj_._map || obj_._gauge;
                e = (impl_);
                if (e) {
                    d = getInstanceType(impl_);
                }
                else {
                    return;
                }
            }
            while (d != null) {
                c = d.typeName;
                c = stringReplace(stringReplace(c, "Ultra", ""), "Xam", "");
                if (this.a.containsKey(c)) {
                    this.a.item(c)(b);
                }
                d = d.baseType;
                if (d != null && (d.typeName == "Object" || d.typeName == "Base")) {
                    return;
                }
            }
        }
    }
    TypeDescriptionCleanups.$t = /*@__PURE__*/ markType(TypeDescriptionCleanups, 'TypeDescriptionCleanups');
    return TypeDescriptionCleanups;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Description = /*@__PURE__*/ (() => {
    class Description extends Base {
        constructor() {
            super(...arguments);
            this.b = new Dictionary$2(String_$type, Boolean_$type, 0);
            this.c = null;
        }
        e(a) {
            this.b.item(a, true);
        }
        a(a) {
            if (this.b.containsKey(a)) {
                return this.b.item(a);
            }
            return false;
        }
        get name() {
            return this.c;
        }
        set name(a) {
            this.c = a;
            this.e("Name");
        }
    }
    Description.$t = /*@__PURE__*/ markType(Description, 'Description');
    return Description;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionPropertyValue = /*@__PURE__*/ (() => {
    class DescriptionPropertyValue extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.b = null;
            this.a = null;
        }
    }
    DescriptionPropertyValue.$t = /*@__PURE__*/ markType(DescriptionPropertyValue, 'DescriptionPropertyValue');
    return DescriptionPropertyValue;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeNode = /*@__PURE__*/ (() => {
    class DescriptionTreeNode extends Base {
        constructor() {
            super();
            this.f = 0;
            this.d = new List$1(DescriptionPropertyValue.$, 0);
            this.c = new Dictionary$2(String_$type, DescriptionPropertyValue.$, 0);
            this.h = null;
            this.f = DescriptionTreeNode.g;
            DescriptionTreeNode.g++;
            if (DescriptionTreeNode.g >= 0x7FFFFFFFFFFFFFFF) {
                DescriptionTreeNode.g = 0;
            }
        }
        i(a, b) {
            let c = new DescriptionPropertyValue();
            c.c = a;
            c.b = b;
            this.c.addItem(a.toLowerCase(), c);
            this.d.add(c);
        }
        j(a, b, c) {
            let d = new DescriptionPropertyValue();
            d.c = a;
            d.b = b;
            d.a = c;
            this.c.addItem(a.toLowerCase(), d);
            this.d.add(d);
        }
        m(a, b) {
            if (this.c.containsKey(a.toLowerCase())) {
                let c = this.c.item(a.toLowerCase());
                c.b = b;
            }
            else {
                this.i(a, b);
            }
        }
        n(a, b, c) {
            if (this.c.containsKey(a.toLowerCase())) {
                let d = this.c.item(a.toLowerCase());
                d.b = b;
            }
            else {
                this.j(a, b, c);
            }
        }
        a(a) {
            return this.c.item(a.toLowerCase());
        }
        b(a) {
            return this.c.containsKey(a.toLowerCase());
        }
        l(a) {
            if (this.c.containsKey(a.toLowerCase())) {
                let b = this.c.item(a.toLowerCase());
                this.c.removeItem(a.toLowerCase());
                this.d.remove(b);
            }
        }
        k() {
            this.c.clear();
            this.d.clear();
        }
        e() {
            return this.d;
        }
    }
    DescriptionTreeNode.$t = /*@__PURE__*/ markType(DescriptionTreeNode, 'DescriptionTreeNode');
    DescriptionTreeNode.g = 0;
    return DescriptionTreeNode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Queue$1 = /*@__PURE__*/ (() => {
    class Queue$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.d = 0;
            this.e = 0;
            this.f = 0;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = new Array(4);
        }
        get count() {
            return this.d;
        }
        copyTo(a, b) {
            if (this.e < this.f) {
                for (let c = this.e; c < this.f; c++) {
                    a[b++] = getBoxIfEnum(this.$t, this.a[c]);
                }
            }
            else {
                for (let d = this.e; d < this.a.length; d++) {
                    a[b++] = getBoxIfEnum(this.$t, this.a[d]);
                }
                for (let e = 0; e < this.f; e++) {
                    a[b++] = getBoxIfEnum(this.$t, this.a[e]);
                }
            }
        }
        get isSynchronized() {
            return false;
        }
        get syncRoot() {
            return null;
        }
        *_getEnumerator() {
            if (this.e < this.f) {
                for (let a = this.e; a < this.f; a++) {
                    yield this.a[a];
                }
            }
            else {
                for (let b = this.e; b < this.a.length; b++) {
                    yield this.a[b];
                }
                for (let c = 0; c < this.f; c++) {
                    yield this.a[c];
                }
            }
        }
        getEnumerator() {
            return toEnum(() => this._getEnumerator()).getEnumerator();
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        g(a) {
            if (this.d == this.a.length) {
                let b = new Array(Math.max(2, this.a.length * 2));
                this.copyTo(b, 0);
                this.e = 0;
                this.f = this.a.length;
                this.a = b;
            }
            this.a[this.f] = a;
            this.f = (this.f + 1) % this.a.length;
            this.d++;
        }
        b() {
            if (this.d == 0) {
                throw new InvalidOperationException(1, "The Queue is empty.");
            }
            let a = this.a[this.e];
            this.a[this.e] = (null);
            this.e = (this.e + 1) % this.a.length;
            this.d--;
            return a;
        }
        c() {
            if (this.d == 0) {
                throw new InvalidOperationException(1, "The Queue is empty.");
            }
            return this.a[this.e];
        }
    }
    Queue$1.$t = /*@__PURE__*/ markType(Queue$1, 'Queue$1', Base.$, [ICollection_$type, /*@__PURE__*/ IEnumerable$1_$type.specialize(0)]);
    return Queue$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeAction = /*@__PURE__*/ (() => {
    class DescriptionTreeAction extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = null;
            this.c = null;
            this.i = null;
            this.g = null;
            this.f = null;
            this.e = 0;
            this.d = 0;
        }
        h(a) {
            let b = this.i;
            if (this.c != null) {
                b = this.c.g(a);
            }
            else {
                if (TypeDescriptionMetadata.shouldCamelize(a)) {
                    b = TypeDescriptionMetadata.camelize(this.i);
                }
            }
            if (stringEndsWith(b, "Ref")) {
                b = b.substr(0, b.length - ("Ref").length);
            }
            return b;
        }
    }
    DescriptionTreeAction.$t = /*@__PURE__*/ markType(DescriptionTreeAction, 'DescriptionTreeAction');
    return DescriptionTreeAction;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RefValueChangedTarget = /*@__PURE__*/ (() => {
    class RefValueChangedTarget extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.d = null;
            this.a = null;
            this.b = null;
        }
    }
    RefValueChangedTarget.$t = /*@__PURE__*/ markType(RefValueChangedTarget, 'RefValueChangedTarget');
    return RefValueChangedTarget;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionRefValueChangedEventArgs = /*@__PURE__*/ (() => {
    class DescriptionRefValueChangedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.a = null;
        }
    }
    DescriptionRefValueChangedEventArgs.$t = /*@__PURE__*/ markType(DescriptionRefValueChangedEventArgs, 'DescriptionRefValueChangedEventArgs');
    return DescriptionRefValueChangedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionRef = /*@__PURE__*/ (() => {
    class DescriptionRef extends Base {
        constructor(a) {
            super();
            this.d = null;
            this.b = null;
            this.a = false;
            this.d = a;
            this.b = new List$1(RefValueChangedTarget.$, 0);
        }
        get e() {
            return this.d;
        }
        get c() {
            return this.b.count;
        }
        g(a, b, c, d) {
            this.b.add(((() => {
                let $ret = new RefValueChangedTarget();
                $ret.b = a;
                $ret.c = b;
                $ret.d = c;
                $ret.a = d;
                return $ret;
            })()));
        }
        j(a, b, c) {
            for (let d = this.b.count - 1; d >= 0; d--) {
                if (this.b._inner[d].c == b && this.b._inner[d].d == c) {
                    this.b.removeAt(d);
                }
            }
        }
        l(a) {
            for (let b = this.b.count - 1; b >= 0; b--) {
                if (this.b._inner[b].c == a) {
                    this.b.removeAt(b);
                }
            }
        }
        k(a) {
            for (let b = this.b.count - 1; b >= 0; b--) {
                if (this.b._inner[b].b == a) {
                    this.b.removeAt(b);
                }
            }
        }
        h() {
            this.b.clear();
        }
        i(a) {
            for (let b = this.b.count - 1; b >= 0; b--) {
                if (this.b._inner[b].c == a) {
                    this.b.removeAt(b);
                }
            }
        }
        f(a, b) {
            for (let c = 0; c < this.b.count; c++) {
                this.b._inner[c].a(this, ((() => {
                    let $ret = new DescriptionRefValueChangedEventArgs();
                    $ret.b = a;
                    $ret.a = b;
                    return $ret;
                })()));
            }
        }
    }
    DescriptionRef.$t = /*@__PURE__*/ markType(DescriptionRef, 'DescriptionRef');
    return DescriptionRef;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITypeDescriptionPropertyTransforms_$type = /*@__PURE__*/ new Type(null, 'ITypeDescriptionPropertyTransforms');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypeDescriptionPropretyTransforms = /*@__PURE__*/ (() => {
    class TypeDescriptionPropretyTransforms extends Base {
        constructor() {
            super();
            this.a = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.a.item("VisibilityToBooleanTransform", (a, b) => {
                if (a.toString().toLowerCase() == "visible") {
                    return true;
                }
                return false;
            });
            this.a.item("FontFamilyTransform", (a, b) => {
                let c = this.d(b);
                let d = this.c(b);
                let e = this.e(b);
                let f = a;
                if (f == null) {
                    f = "Verdana";
                }
                return c + " " + e + " " + d + " " + f;
            });
            this.a.item("FontStyleTransform", (a, b) => {
                let c = this.b(b);
                let d = this.c(b);
                let e = this.e(b);
                let f = a;
                if (f == null) {
                    f = "normal";
                }
                return f + " " + e + " " + d + " " + c;
            });
            this.a.item("FontSizeTransform", (a, b) => {
                let c = this.b(b);
                let d = this.d(b);
                let e = this.e(b);
                let f = a != null ? a.toString() + "px" : null;
                if (f == null) {
                    f = "14px";
                }
                return d + " " + e + " " + f + " " + c;
            });
            this.a.item("FontWeightTransform", (a, b) => {
                let c = this.b(b);
                let d = this.c(b);
                let e = this.d(b);
                let f = a;
                if (f == null) {
                    f = "normal";
                }
                f = f.toLowerCase();
                return e + " " + f + " " + d + " " + c;
            });
        }
        b(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Style", "Family"), "Weight", "Family"), "Size", "Family");
            let c = "Verdana";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "Verdana";
                }
            }
            return c;
        }
        d(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Family", "Style"), "Weight", "Style"), "Size", "Style");
            let c = "normal";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "normal";
                }
            }
            return c;
        }
        c(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Family", "Size"), "Weight", "Size"), "Style", "Size");
            let c = "14px";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "14px";
                }
                else {
                    c = c.toString() + "px";
                }
            }
            return c;
        }
        e(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Family", "Weight"), "Size", "Weight"), "Style", "Weight");
            let c = "normal";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "normal";
                }
                c = c.toLowerCase();
            }
            return c;
        }
        transform(a, b, c) {
            let d = c.c;
            if (d == null) {
                return b;
            }
            let e = d.h(a);
            if (e != null && this.a.containsKey(e)) {
                let f = this.a.item(e);
                return f(b, c);
            }
            return b;
        }
    }
    TypeDescriptionPropretyTransforms.$t = /*@__PURE__*/ markType(TypeDescriptionPropretyTransforms, 'TypeDescriptionPropretyTransforms', Base.$, [ITypeDescriptionPropertyTransforms_$type]);
    return TypeDescriptionPropretyTransforms;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionSerializerBuilder = /*@__PURE__*/ (() => {
    class DescriptionSerializerBuilder extends Base {
        constructor() {
            super();
            this.d = null;
            this.b = 0;
            this.a = false;
            this.d = new StringBuilder(0);
        }
        toString() {
            return this.d.toString();
        }
        e(a) {
            this.g();
            this.d.l(a);
        }
        f(a) {
            this.g();
            this.d.u(a);
            this.a = true;
        }
        g() {
            if (this.a) {
                for (let a = 0; a < this.b; a++) {
                    this.d.l("\t");
                }
                this.a = false;
            }
        }
        i() {
            this.b++;
        }
        h() {
            this.b--;
        }
    }
    DescriptionSerializerBuilder.$t = /*@__PURE__*/ markType(DescriptionSerializerBuilder, 'DescriptionSerializerBuilder');
    return DescriptionSerializerBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeBuilder = /*@__PURE__*/ (() => {
    class DescriptionTreeBuilder extends Base {
        static b(item_) {
            let propertyKey_ = null;
            let ret_ = new List$1(String_$type, 0);
            let seen_ = new HashSet$1(String_$type, 0);
            let exclusions_ = {};
            let seen = new Set();
            let comp = item_;
            while (comp = (comp.prototype || Object.getPrototypeOf(comp))) {
                if (comp == Base.prototype) {
                    break;
                }
                let props = Object.getOwnPropertyNames(comp.constructor.prototype);
                for (let i = 0; i < props.length; i++) {
                    if (!seen.has(props[i])) {
                        seen.add(props[i]);
                        ret_.add(props[i]);
                    }
                }
            }
            ;
            return ret_;
        }
        static createTree(a, description_) {
            let b = new DescriptionTreeNode();
            if (description_ == null) {
                return null;
            }
            let c = DescriptionTreeBuilder.b(description_);
            for (let d = 0; d < c.count; d++) {
                let key_ = c._inner[d];
                if (key_.toLowerCase() != "type" && !description_.a(DescriptionTreeBuilder.c(key_))) {
                    continue;
                }
                let e = description_[key_];
                if (typeCast(Description.$, e) !== null) {
                    let f = DescriptionTreeBuilder.createTree(a, e);
                    e = f;
                }
                if (typeCast(Array_$type, e) !== null) {
                    let g = e;
                    let h = new Array(g.length);
                    for (let i = 0; i < h.length; i++) {
                        let j = g[i];
                        if (typeCast(Description.$, j) !== null) {
                            let k = DescriptionTreeBuilder.createTree(a, j);
                            h[i] = k;
                        }
                        else {
                            h[i] = j;
                        }
                    }
                    e = h;
                }
                if (key_.toLowerCase() == "type") {
                    b.h = e;
                }
                b.i(DescriptionTreeBuilder.c(key_), e);
            }
            if (b.b("type")) {
                let l = b.a("type").b;
                let m = b.e();
                for (let n = 0; n < m.count; n++) {
                    let o = m._inner[n];
                    o.a = a.d(l, o.c);
                }
            }
            return b;
        }
        static c(key_) {
            if (key_ == null) {
                return null;
            }
            return key_.substr(0, 1).toUpperCase() + key_.substr(1);
        }
    }
    DescriptionTreeBuilder.$t = /*@__PURE__*/ markType(DescriptionTreeBuilder, 'DescriptionTreeBuilder');
    return DescriptionTreeBuilder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionResult = /*@__PURE__*/ (() => {
    class DescriptionResult extends Base {
        constructor() {
            super();
            this.c = new List$1(String_$type, 0);
            this._result = null;
        }
        d(a) {
            this.c.add(a);
        }
        e(a) {
            for (let b = 0; b < a.c.count; b++) {
                this.c.add(a.c._inner[b]);
            }
        }
        get result() {
            return this._result;
        }
        set result(a) {
            this._result = a;
        }
        get warnings() {
            return this.c.toArray();
        }
    }
    DescriptionResult.$t = /*@__PURE__*/ markType(DescriptionResult, 'DescriptionResult');
    return DescriptionResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EmbeddedRefDescription = /*@__PURE__*/ (() => {
    class EmbeddedRefDescription extends Description {
        constructor() {
            super(...arguments);
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "EmbeddedRef";
        }
        get type() {
            return this.get_type();
        }
        get refType() {
            return this.f;
        }
        set refType(a) {
            this.f = a;
            this.e("RefType");
        }
        get value() {
            return this.g;
        }
        set value(a) {
            this.g = a;
            this.e("Value");
        }
    }
    EmbeddedRefDescription.$t = /*@__PURE__*/ markType(EmbeddedRefDescription, 'EmbeddedRefDescription', Description.$);
    return EmbeddedRefDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointDescription = /*@__PURE__*/ (() => {
    class PointDescription extends Base {
        constructor() {
            super(...arguments);
            this._x = 0;
            this._y = 0;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
    }
    PointDescription.$t = /*@__PURE__*/ markType(PointDescription, 'PointDescription');
    return PointDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeDescription = /*@__PURE__*/ (() => {
    class SizeDescription extends Base {
        constructor() {
            super(...arguments);
            this._width = 0;
            this._height = 0;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
    }
    SizeDescription.$t = /*@__PURE__*/ markType(SizeDescription, 'SizeDescription');
    return SizeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectDescription = /*@__PURE__*/ (() => {
    class RectDescription extends Base {
        constructor() {
            super(...arguments);
            this._left = 0;
            this._top = 0;
            this._width = 0;
            this._height = 0;
        }
        get left() {
            return this._left;
        }
        set left(a) {
            this._left = a;
        }
        get top() {
            return this._top;
        }
        set top(a) {
            this._top = a;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
    }
    RectDescription.$t = /*@__PURE__*/ markType(RectDescription, 'RectDescription');
    return RectDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionSerializer = /*@__PURE__*/ (() => {
    class DescriptionSerializer extends Base {
        constructor() {
            super();
            this.h = false;
            this.g = false;
            this.f = false;
            this.i = null;
            this.e = false;
        }
        o(a, b) {
            let c = DescriptionTreeBuilder.createTree(a, b);
            let d = new DescriptionSerializerBuilder();
            this.p(a, c, d);
            return d.toString();
        }
        s(a, b, c) {
            this.p(a, b, c);
        }
        c(a, b) {
            let c = new JsonDictionaryParser();
            let d = c.parse(b);
            return this.d(a, d, false, null, false);
        }
        d(a, b, c, d, e) {
            if (!(typeCast(JsonDictionaryObject.$, b) !== null)) {
                throw new NotSupportedException(1, "expected an object at the root of the json");
            }
            let f = b;
            if (c) {
                this.f = true;
                this.i = d;
            }
            if (e) {
                this.e = true;
            }
            let g = this.b(a, f);
            this.f = false;
            this.i = null;
            this.e = false;
            return g;
        }
        u(a, b, c, d, e) {
            if (this.g) {
                a.s(b, c, d, e);
            }
            else {
                a.r(b, c, d, e);
            }
        }
        b(a, b, c = 8) {
            if (!b.g("type")) {
                if (b.g("refType")) {
                    let d = new EmbeddedRefDescription();
                    d.refType = b.item("refType").value;
                    d.value = b.item("id").value;
                    let e = new DescriptionResult();
                    e.result = d;
                    return e;
                }
                else {
                    throw new NotSupportedException(1, "expected type to be defined for the json object");
                }
            }
            let f = new DescriptionResult();
            let g = b.item("type").value;
            let h = a.l(g);
            f.result = h;
            if (h == null) {
                if (this.h) {
                    throw new NotSupportedException(1, "missing description for type: " + g);
                }
                f.d("couldn't find registered description for type: " + g);
                return f;
            }
            let i = b.e();
            for (let j = 0; j < i.length; j++) {
                let k = i[j];
                let l = a.d(g, TypeDescriptionContext.o(k));
                if (l == null) {
                    if (TypeDescriptionContext.o(k) == "Name") {
                        let m = "string";
                        let n = b.item(k);
                        let o = this.j(f, a, n, m);
                        h.name = o;
                    }
                    continue;
                }
                let p = b.item(k);
                if (l.knownType == 14 || l.knownType == 11 || l.knownType == 12) {
                    let q = p;
                    switch (l.knownType) {
                        case 14:
                            q = this.l(a, p);
                            break;
                        case 12:
                            q = this.m(a, p);
                            break;
                        case 11:
                            q = this.k(a, p);
                            break;
                    }
                    if (!this.e) {
                        this.u(a, h, k, l, q);
                    }
                }
                else if (typeCast(JsonDictionaryObject.$, p) !== null) {
                    let r = p;
                    let s = this.b(a, r, l.knownType);
                    f.e(s);
                    this.u(a, h, k, l, s.result);
                }
                else if (typeCast(JsonDictionaryArray.$, p) !== null) {
                    let t = p;
                    let u = "string";
                    let v = false;
                    if (l.knownType == 10) {
                        u = l.specificExternalType;
                    }
                    if (l.knownType == 9) {
                        v = true;
                        u = l.collectionElementType;
                    }
                    let w = this.a(f, a, t, u);
                    if (!this.e || v) {
                        this.u(a, h, k, l, w);
                    }
                }
                else {
                    let x = l.specificExternalType;
                    if (x == null && l.knownType == 3) {
                        x = "DateTime";
                    }
                    if (x == null) {
                        x = "String";
                    }
                    let y = p;
                    let z = this.j(f, a, y, x);
                    if (this.f) {
                        if (stringEndsWith(l.propertyName, "MemberPath") || (g != null && stringEndsWith(g, "Axis") && l.propertyName.toLowerCase() == "label")) {
                            let aa = z.toString();
                            if (this.i != null) {
                                z = this.i(aa);
                            }
                            else {
                                if (stringStartsWith(aa, "{")) {
                                    if (!stringStartsWith(aa, "{[")) {
                                        aa = aa.substr(1, aa.length - 2);
                                        aa = "{[" + aa + "]}";
                                        z = aa;
                                    }
                                }
                                else {
                                    if (!stringStartsWith(aa, "[")) {
                                        aa = "[" + aa + "]";
                                        z = aa;
                                    }
                                }
                            }
                        }
                    }
                    if (!this.e) {
                        this.u(a, h, k, l, z);
                    }
                }
            }
            return f;
        }
        k(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            if (b.g("x")) {
                c = b.item("x").value;
            }
            if (b.g("y")) {
                d = b.item("y").value;
            }
            return ((() => {
                let $ret = new PointDescription();
                $ret.x = c;
                $ret.y = d;
                return $ret;
            })());
        }
        m(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            if (b.g("width")) {
                c = b.item("width").value;
            }
            if (b.g("height")) {
                d = b.item("height").value;
            }
            return ((() => {
                let $ret = new SizeDescription();
                $ret.width = c;
                $ret.height = d;
                return $ret;
            })());
        }
        l(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            let e = NaN;
            let f = NaN;
            if (b.g("left")) {
                c = b.item("left").value;
            }
            if (b.g("top")) {
                d = b.item("top").value;
            }
            if (b.g("width")) {
                e = b.item("width").value;
            }
            if (b.g("height")) {
                f = b.item("height").value;
            }
            return ((() => {
                let $ret = new RectDescription();
                $ret.left = c;
                $ret.top = d;
                $ret.width = e;
                $ret.height = f;
                return $ret;
            })());
        }
        a(a, b, c, d) {
            let e = new Array(c.items.length);
            for (let f = 0; f < c.items.length; f++) {
                let g = c.items[f];
                if (typeCast(JsonDictionaryObject.$, g) !== null) {
                    let h = g;
                    let i = this.b(b, h);
                    a.e(i);
                    e[f] = i.result;
                }
                else if (typeCast(JsonDictionaryArray.$, g) !== null) {
                    let j = g;
                    let k = this.a(a, b, j, d);
                    e[f] = k;
                }
                else {
                    let l = g;
                    let m = this.j(a, b, l, d);
                    e[f] = m;
                }
            }
            return e;
        }
        j(a, b, c, d) {
            switch (c.e) {
                case 1: return c.value;
                case 3: return c.value;
                case 0: switch (d.toLowerCase()) {
                    case "int": return typeGetValue(c.value);
                    case "double": return c.value;
                    case "timespan": return c.value;
                    case "short": return typeGetValue(c.value);
                    case "long": return typeGetValue(c.value);
                    case "float": return c.value;
                    case "byte": return typeGetValue(c.value);
                    default:
                        a.d("unexpected target type for number: " + d);
                        return c.value;
                }
                case 2:
                    if (d.toLowerCase() == "datetime") {
                        let val_ = c.value;
                        let e = (new Date(val_));
                        return e;
                    }
                    return c.value;
                default:
                    a.d("unexpected value type");
                    return c.value;
            }
        }
        p(a, b, c) {
            c.f("{");
            c.i();
            c.f("\"type\": \"" + b.h + "\"");
            let d = b.e();
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e];
                if (e >= 0) {
                    c.f(",");
                }
                this.q(a, b, f, c);
            }
            c.h();
            c.f("}");
        }
        n(a) {
            if (a == null) {
                return null;
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        q(a, b, c, d) {
            if (c.c.toLowerCase() == "type") {
                return;
            }
            d.e("\"" + this.n(c.c) + "\": ");
            this.t(a, b, c, c.b, d);
        }
        t(a, b, c, d, e) {
            let f = 2;
            if (c.a != null) {
                f = c.a.knownType;
            }
            switch (f) {
                case 6:
                case 16:
                case 10:
                    {
                        e.e("[");
                        let g = c.b;
                        let h = c.a.specificType;
                        if (c.a.knownType == 6 || c.a.knownType == 16) {
                            h = "String";
                        }
                        for (let i = 0; i < g.length; i++) {
                            if (i > 0) {
                                e.e(", ");
                            }
                            let j = h;
                            if (typeCast(DescriptionTreeNode.$, g[i]) !== null) {
                                this.p(a, g[i], e);
                            }
                            else {
                                this.r(a, h, g[i], e);
                            }
                        }
                        e.e("]");
                    }
                    break;
                case 7:
                    this.r(a, "Boolean", d, e);
                    break;
                case 9:
                    {
                        e.e("[");
                        let k = c.b;
                        let l = c.a.collectionElementType;
                        for (let m = 0; m < k.length; m++) {
                            if (m > 0) {
                                e.e(", ");
                            }
                            let n = l;
                            if (typeCast(DescriptionTreeNode.$, k[m]) !== null) {
                                this.p(a, k[m], e);
                            }
                            else {
                                this.r(a, l, k[m], e);
                            }
                        }
                        e.e("]");
                    }
                    break;
                case 4:
                case 18:
                case 19:
                case 20:
                case 5:
                case 2:
                    this.r(a, "String", d, e);
                    break;
                case 3:
                    this.r(a, "DateTime", d, e);
                    break;
                case 8:
                    if (c.a.specificExternalType.toLowerCase() == "string") {
                        this.r(a, "String", d, e);
                    }
                    else {
                        this.p(a, d, e);
                    }
                    break;
                case 1:
                    this.r(a, "Double", d, e);
                    break;
                case 14:
                case 12:
                case 11:
                    this.p(a, d, e);
                    break;
                case 21:
                    this.r(a, "TimeSpan", d, e);
                    break;
                case 17:
                case 0:
                case 15:
                case 13: throw new NotImplementedException(0);
            }
        }
        r(a, b, c, d) {
            switch (b.toLowerCase()) {
                case "string":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e("\"" + stringReplace(c, "\"", "\\\"") + "\"");
                    }
                    break;
                case "number":
                case "double":
                    d.e(c.toString());
                    break;
                case "int":
                    d.e(c.toString());
                    break;
                case "float":
                    d.e(c.toString());
                    break;
                case "long":
                    d.e(c.toString());
                    break;
                case "decimal":
                    d.e(c.toString());
                    break;
                case "timespan":
                    d.e(c.toString());
                    break;
                case "boolean":
                    d.e(c == null ? "false" : c.toString().toLowerCase());
                    break;
                case "datetime":
                    let v_ = c;
                    d.e("\"" + (v_.toJSON()) + "\"");
                    break;
            }
        }
    }
    DescriptionSerializer.$t = /*@__PURE__*/ markType(DescriptionSerializer, 'DescriptionSerializer');
    return DescriptionSerializer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DiffApplyInfo = /*@__PURE__*/ (() => {
    class DiffApplyInfo extends Base {
        constructor() {
            super();
            this.a = null;
            this.c = null;
            this.b = null;
            this.d = null;
            this.a = new HashSet$1(Number_$type, 0);
            this.c = new List$1(DescriptionTreeAction.$, 0);
            this.b = new List$1(DescriptionTreeAction.$, 0);
            this.d = new List$1(DescriptionTreeAction.$, 0);
        }
    }
    DiffApplyInfo.$t = /*@__PURE__*/ markType(DiffApplyInfo, 'DiffApplyInfo');
    return DiffApplyInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeReconciler_TreeModeData = /*@__PURE__*/ (() => {
    class DescriptionTreeReconciler_TreeModeData extends Base {
        constructor() {
            super(...arguments);
            this.f = null;
            this.a = null;
            this.d = 0;
            this.c = false;
            this.e = 0;
            this.b = false;
        }
    }
    DescriptionTreeReconciler_TreeModeData.$t = /*@__PURE__*/ markType(DescriptionTreeReconciler_TreeModeData, 'DescriptionTreeReconciler_TreeModeData');
    return DescriptionTreeReconciler_TreeModeData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeReconciler = /*@__PURE__*/ (() => {
    class DescriptionTreeReconciler extends Base {
        static a(a, b) {
            let c = new DiffApplyInfo();
            for (let d = 0; d < b.count; d++) {
                let e = b._inner[d];
                switch (e.a) {
                    case 0:
                        if (typeCast(DescriptionTreeNode.$, e.g) !== null) {
                            let f = e.g.f;
                            c.a.add_1(f);
                        }
                        e.b.m(e.i, e.f);
                        if (typeCast(DescriptionTreeNode.$, e.f) !== null) {
                            let g = e.f.f;
                            if (c.a.contains(g)) {
                                c.a.remove(g);
                            }
                            c.c.add(e);
                        }
                        break;
                    case 1:
                        if (typeCast(DescriptionTreeNode.$, e.g) !== null) {
                            let h = e.g.f;
                            c.a.add_1(h);
                        }
                        e.b.l(e.i);
                        break;
                    case 3:
                        {
                            let i = e.b.a(e.i).b;
                            let j = i[e.e];
                            if (typeCast(DescriptionTreeNode.$, j) !== null) {
                                let k = j.f;
                                c.a.add_1(k);
                            }
                            i[e.e] = e.f;
                            if (typeCast(DescriptionTreeNode.$, e.f) !== null) {
                                let l = e.f.f;
                                if (c.a.contains(l)) {
                                    c.a.remove(l);
                                }
                                c.b.add(e);
                            }
                        }
                        break;
                    case 4:
                        {
                            let m = e.b.a(e.i).b;
                            let n = m[e.e];
                            if (typeCast(DescriptionTreeNode.$, n) !== null) {
                                let o = n.f;
                                c.a.add_1(o);
                            }
                            let p = new Array(m.length - 1);
                            let q = 0;
                            for (let r = 0; r < m.length; r++) {
                                if (r != e.e) {
                                    p[q] = m[r];
                                    q++;
                                }
                            }
                            e.b.m(e.i, p);
                        }
                        break;
                    case 2:
                        {
                            if (e.b == null && a == null) {
                                c.d.add(e);
                            }
                            else {
                                let s = e.b.a(e.i).b;
                                let t = new Array(s.length + 1);
                                let u = 0;
                                for (let v = 0; v < t.length; v++) {
                                    if (v == e.d) {
                                        t[v] = e.f;
                                    }
                                    else {
                                        t[v] = s[u];
                                        u++;
                                    }
                                }
                                e.b.m(e.i, t);
                                if (typeCast(DescriptionTreeNode.$, e.f) !== null) {
                                    let w = e.f.f;
                                    if (c.a.contains(w)) {
                                        c.a.remove(w);
                                    }
                                    c.b.add(e);
                                }
                            }
                        }
                        break;
                    case 5:
                        {
                            let x = e.b.a(e.i).b;
                            for (let y = 0; y < x.length; y++) {
                                let z = x[y];
                                if (typeCast(DescriptionTreeNode.$, z) !== null) {
                                    let aa = z.f;
                                    c.a.add_1(aa);
                                }
                            }
                            e.b.m(e.i, []);
                        }
                        break;
                }
            }
            return c;
        }
        static c(a, b, c) {
            let d = new List$1(DescriptionTreeAction.$, 0);
            if (a == null && b == null) {
                return d;
            }
            if (a != null && b == null) {
                let e = new DescriptionTreeAction();
                e.a = 4;
                e.e = 0;
                e.g = a;
                e.c = null;
                e.i = null;
                d.add(e);
                return d;
            }
            if (a == null && b != null) {
                let f = new DescriptionTreeAction();
                f.a = 2;
                f.e = 0;
                f.f = b;
                f.c = null;
                f.i = null;
                d.add(f);
                return d;
            }
            if (b.h != a.h) {
                let g = new DescriptionTreeAction();
                g.a = 3;
                g.e = 0;
                g.g = a;
                g.f = b;
                g.c = null;
                g.i = null;
                d.add(g);
                return d;
            }
            DescriptionTreeReconciler.g(d, a, b, c);
            return d;
        }
        static g(a, b, c, d) {
            c.f = b.f;
            let e = DescriptionTreeReconciler.e(b);
            let f = DescriptionTreeReconciler.e(c);
            let g = new List$1(DescriptionPropertyValue.$, 0);
            let h = new List$1(DescriptionPropertyValue.$, 0);
            let i = new List$1(DescriptionPropertyValue.$, 0);
            for (let j = 0; j < e.count; j++) {
                let k = e._inner[j];
                if (c.b(k.c)) {
                    if (!Base.equalsStatic(k, c.a(k.c))) {
                        let l = c.a(k.c);
                        if (typeCast(DescriptionTreeNode.$, k.b) !== null && typeCast(DescriptionTreeNode.$, l.b) !== null) {
                            let m = k.b;
                            let n = l.b;
                            if (m.h == n.h) {
                                if ((!m.b("Name") && !n.b("Name")) || (m.b("Name") && n.b("Name") && (m.a("Name").b == n.a("Name").b))) {
                                    DescriptionTreeReconciler.g(a, m, n, d);
                                }
                                else {
                                    i.add(c.a(k.c));
                                }
                            }
                            else {
                                i.add(c.a(k.c));
                            }
                        }
                        else {
                            i.add(c.a(k.c));
                        }
                    }
                }
                else {
                    if (!d) {
                        g.add(k);
                    }
                }
            }
            for (let o = 0; o < f.count; o++) {
                let p = f._inner[o];
                if (!b.b(p.c)) {
                    h.add(p);
                }
            }
            for (let q = 0; q < g.count; q++) {
                let r = g._inner[q];
                let s = new DescriptionTreeAction();
                s.b = b;
                s.a = 1;
                s.i = r.c;
                s.c = r.a;
                s.g = r.b;
                a.add(s);
            }
            for (let t = 0; t < h.count; t++) {
                let u = h._inner[t];
                let v = new DescriptionTreeAction();
                v.b = b;
                v.a = 0;
                v.i = u.c;
                v.c = u.a;
                v.f = u.b;
                v.g = null;
                a.add(v);
            }
            for (let w = 0; w < i.count; w++) {
                let x = i._inner[w];
                let y = b.a(x.c).b;
                let z = x.b;
                if (!Base.equalsStatic(z, y)) {
                    let aa = new DescriptionTreeAction();
                    aa.b = b;
                    aa.a = 0;
                    aa.i = x.c;
                    aa.c = x.a;
                    aa.f = x.b;
                    aa.g = b.a(x.c).b;
                    a.add(aa);
                }
            }
            let ab = DescriptionTreeReconciler.d(b);
            let ac = DescriptionTreeReconciler.d(c);
            let ad = new List$1(DescriptionPropertyValue.$, 0);
            let ae = new List$1(DescriptionPropertyValue.$, 0);
            let af = new List$1(DescriptionPropertyValue.$, 0);
            for (let ag = 0; ag < ab.count; ag++) {
                let ah = ab._inner[ag];
                if (c.b(ah.c)) {
                    if (!DescriptionTreeReconciler.b(ah.b, c.a(ah.c).b)) {
                        af.add(c.a(ah.c));
                    }
                    else {
                        let ai = ah.b;
                        let aj = c.a(ah.c).b;
                        for (let ak = 0; ak < ai.length; ak++) {
                            let al = ai[ak];
                            let am = aj[ak];
                            if (typeCast(DescriptionTreeNode.$, al) !== null && typeCast(DescriptionTreeNode.$, am) !== null) {
                                let an = al;
                                let ao = am;
                                if (an.h == ao.h) {
                                    DescriptionTreeReconciler.g(a, an, ao, d);
                                }
                                else {
                                    let ap = new DescriptionTreeAction();
                                    ap.i = ah.c;
                                    ap.c = ah.a;
                                    ap.b = b;
                                    ap.a = 3;
                                    ap.e = ak;
                                    ap.d = ak;
                                    ap.g = an;
                                    ap.f = ao;
                                    a.add(ap);
                                }
                            }
                            else {
                                if (!Base.equalsStatic(al, am)) {
                                    let aq = new DescriptionTreeAction();
                                    aq.i = ah.c;
                                    aq.c = ah.a;
                                    aq.b = b;
                                    aq.a = 3;
                                    aq.e = ak;
                                    aq.d = ak;
                                    aq.g = al;
                                    aq.f = am;
                                    a.add(aq);
                                }
                            }
                        }
                    }
                }
                else {
                    if (!d) {
                        ad.add(ah);
                    }
                }
            }
            for (let ar = 0; ar < ac.count; ar++) {
                let as = ac._inner[ar];
                if (!b.b(as.c)) {
                    ae.add(as);
                }
            }
            for (let at = 0; at < ad.count; at++) {
                let au = ad._inner[at];
                let av = new DescriptionTreeAction();
                av.b = b;
                av.i = au.c;
                av.c = au.a;
                av.a = 5;
                av.g = au.b;
                a.add(av);
            }
            for (let aw = 0; aw < ae.count; aw++) {
                let ax = ae._inner[aw];
                let ay = new DescriptionTreeAction();
                ay.b = b;
                ay.i = ax.c;
                ay.c = ax.a;
                ay.a = 0;
                ay.g = null;
                ay.f = ax.b;
                a.add(ay);
            }
            for (let az = 0; az < af.count; az++) {
                DescriptionTreeReconciler.h(a, b, c, b.a(af._inner[az].c), af._inner[az], d);
            }
        }
        static f(a) {
            if (a == null) {
                return "UNKOWN";
            }
            if (!a.b("Type")) {
                return "UNKOWN";
            }
            return a.a("Type").b;
        }
        static h(a, b, c, d, e, f) {
            let g = false;
            let h = d.b;
            let i = e.b;
            if (h.length > 0) {
                if (typeCast(DescriptionTreeNode.$, h[0]) !== null) {
                    let j = h[0];
                    if (j.b("Name") && j.a("Name") != null) {
                        g = true;
                    }
                    if (j.b("RefType") && j.a("RefType").b == "uuid") {
                        g = true;
                    }
                }
            }
            if (i.length > 0) {
                if (typeCast(DescriptionTreeNode.$, i[0]) !== null) {
                    let k = i[0];
                    if (k.b("Name") && k.a("Name") != null) {
                        g = true;
                    }
                    if (k.b("RefType") && k.a("RefType").b == "uuid") {
                        g = true;
                    }
                }
            }
            if (g) {
                let l = new Dictionary$2(String_$type, DescriptionTreeReconciler_TreeModeData.$, 0);
                let m = new List$1(DescriptionTreeReconciler_TreeModeData.$, 0);
                let n = new Dictionary$2(String_$type, DescriptionTreeReconciler_TreeModeData.$, 0);
                let o = new List$1(DescriptionTreeReconciler_TreeModeData.$, 0);
                let p = 0;
                for (let q = 0; q < h.length; q++) {
                    let r = new DescriptionTreeReconciler_TreeModeData();
                    r.a = h[q];
                    r.d = q;
                    r.f = r.a.b("Name") ? r.a.a("Name").b : r.a.b("RefType") ? r.a.a("Value").b : null;
                    if (r.f == null) {
                        r.f = "BADKEY_" + p.toString();
                        p++;
                    }
                    m.add(r);
                    l.addItem(r.f, r);
                }
                for (let s = 0; s < i.length; s++) {
                    let t = new DescriptionTreeReconciler_TreeModeData();
                    t.a = i[s];
                    t.d = s;
                    t.f = t.a.b("Name") ? t.a.a("Name").b : t.a.b("RefType") ? t.a.a("Value").b : null;
                    if (t.f == null) {
                        t.f = "BADKEY_" + p.toString();
                        p++;
                    }
                    o.add(t);
                    n.addItem(t.f, t);
                }
                for (let u = 0; u < m.count; u++) {
                    let v = m._inner[u];
                    if (!n.containsKey(v.f) || (n.containsKey(v.f) && DescriptionTreeReconciler.f(v.a) != DescriptionTreeReconciler.f(n.item(v.f).a))) {
                        v.c = true;
                    }
                }
                for (let w = 0; w < o.count; w++) {
                    let x = o._inner[w];
                    if (!l.containsKey(x.f) || (l.containsKey(x.f) && DescriptionTreeReconciler.f(x.a) != DescriptionTreeReconciler.f(l.item(x.f).a))) {
                        x.b = true;
                    }
                    else {
                        l.item(x.f).e = w;
                    }
                }
                for (let y = 0; y < m.count; y++) {
                    let z = m._inner[y];
                    if (z.c) {
                        let aa = new DescriptionTreeAction();
                        aa.i = e.c;
                        aa.b = b;
                        aa.c = e.a;
                        aa.e = z.d;
                        aa.a = 4;
                        aa.g = z.a;
                        a.add(aa);
                        for (let ab = y + 1; ab < m.count; ab++) {
                            let ac = m._inner[ab];
                            ac.d--;
                        }
                    }
                }
                for (let ad = 0; ad < o.count; ad++) {
                    let ae = o._inner[ad];
                    if (ae.b) {
                        let af = new DescriptionTreeAction();
                        af.i = e.c;
                        af.b = b;
                        af.c = e.a;
                        af.d = ad;
                        af.a = 2;
                        af.f = i[ad];
                        a.add(af);
                        for (let ag = 0; ag < m.count; ag++) {
                            let ah = m._inner[ag];
                            if (!ah.c && ah.d >= ad) {
                                ah.d++;
                            }
                        }
                    }
                    else {
                        let ai = l.item(ae.f);
                        if (ai.d == ai.e) {
                            DescriptionTreeReconciler.g(a, ai.a, ae.a, f);
                            continue;
                        }
                        let aj = new DescriptionTreeAction();
                        aj.i = e.c;
                        aj.b = b;
                        aj.c = e.a;
                        aj.e = ai.d;
                        aj.a = 4;
                        aj.g = ai.a;
                        a.add(aj);
                        for (let ak = 0; ak < m.count; ak++) {
                            let al = m._inner[ak];
                            if (!al.c && al.a != ai.a && al.d >= ai.d) {
                                al.d--;
                            }
                        }
                        aj = new DescriptionTreeAction();
                        aj.i = e.c;
                        aj.b = b;
                        aj.c = e.a;
                        aj.d = ai.e;
                        aj.a = 2;
                        aj.f = ai.a;
                        a.add(aj);
                        ai.d = ai.e;
                        for (let am = 0; am < m.count; am++) {
                            let an = m._inner[am];
                            if (!an.c && an.a != ai.a && an.d >= ai.d) {
                                an.d++;
                            }
                        }
                        DescriptionTreeReconciler.g(a, ai.a, ae.a, f);
                    }
                }
            }
            else {
                let ao = Math.max(h.length, i.length);
                for (let ap = 0; ap < ao; ap++) {
                    if (ap >= h.length) {
                        let aq = new DescriptionTreeAction();
                        aq.i = e.c;
                        aq.b = b;
                        aq.c = e.a;
                        aq.d = ap;
                        aq.a = 2;
                        aq.f = i[ap];
                        a.add(aq);
                    }
                    else if (ap >= i.length) {
                        let ar = new DescriptionTreeAction();
                        ar.i = e.c;
                        ar.b = b;
                        ar.c = e.a;
                        ar.e = i.length;
                        ar.a = 4;
                        ar.g = h[ap];
                        a.add(ar);
                    }
                    else {
                        let as = h[ap];
                        let at = i[ap];
                        if (typeCast(DescriptionTreeNode.$, as) !== null && typeCast(DescriptionTreeNode.$, at) !== null) {
                            let au = as;
                            let av = at;
                            if (au.h == av.h) {
                                DescriptionTreeReconciler.g(a, au, av, f);
                            }
                            else {
                                let aw = new DescriptionTreeAction();
                                aw.i = e.c;
                                aw.b = b;
                                aw.c = e.a;
                                aw.e = ap;
                                aw.a = 3;
                                aw.g = h[ap];
                                aw.f = i[ap];
                                a.add(aw);
                            }
                        }
                        else {
                            if (!Base.equalsStatic(as, at)) {
                                let ax = new DescriptionTreeAction();
                                ax.i = e.c;
                                ax.b = b;
                                ax.c = e.a;
                                ax.e = ap;
                                ax.a = 3;
                                ax.g = h[ap];
                                ax.f = i[ap];
                                a.add(ax);
                            }
                        }
                    }
                }
            }
        }
        static b(a, b) {
            let c = a;
            let d = b;
            if (c.length != d.length) {
                return false;
            }
            for (let e = 0; e < c.length; e++) {
                let f = c[e];
                let g = d[e];
                if (typeCast(DescriptionTreeNode.$, f) !== null && !(typeCast(DescriptionTreeNode.$, g) !== null)) {
                    return false;
                }
                if (!(typeCast(DescriptionTreeNode.$, f) !== null) && typeCast(DescriptionTreeNode.$, g) !== null) {
                    return false;
                }
                if (typeCast(DescriptionTreeNode.$, f) !== null) {
                    let h = f;
                    let i = g;
                    if (h.h != i.h) {
                        return false;
                    }
                    let j = h.b("Name") ? h.a("Name").b : null;
                    let k = i.b("Name") ? i.a("Name").b : null;
                    if (!Base.equalsStatic(j, k)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(f, g)) {
                        return false;
                    }
                }
            }
            return true;
        }
        static e(a) {
            let b = new List$1(DescriptionPropertyValue.$, 0);
            let c = a.e();
            for (let d = 0; d < c.count; d++) {
                let e = c._inner[d];
                if (e.a != null && e.a.knownType != 10 && e.a.knownType != 9) {
                    b.add(e);
                }
            }
            return b;
        }
        static d(a) {
            let b = new List$1(DescriptionPropertyValue.$, 0);
            let c = a.e();
            for (let d = 0; d < c.count; d++) {
                let e = c._inner[d];
                if (e.a != null && (e.a.knownType == 10 || e.a.knownType == 9)) {
                    b.add(e);
                }
            }
            return b;
        }
    }
    DescriptionTreeReconciler.$t = /*@__PURE__*/ markType(DescriptionTreeReconciler, 'DescriptionTreeReconciler');
    return DescriptionTreeReconciler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComponentRenderer = /*@__PURE__*/ (() => {
    class ComponentRenderer extends Base {
        constructor() {
            super();
            this.e = null;
            this._context = null;
            this._isProceedOnErrorEnabled = false;
            this.g = null;
            this.h = null;
            this.ap = new Dictionary$2(Base.$, Description.$, 0);
            this.aq = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.ar = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.ao = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.an = new Dictionary$2(Base.$, DescriptionTreeNode.$, 0);
            this.au = new Dictionary$2(Base.$, ContainerState.$, 0);
            this.as = new Dictionary$2(Base.$, Queue$1.$.specialize(Queue$1.$.specialize(DescriptionTreeAction.$)), 0);
            this.am = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.at = new Dictionary$2(String_$type, DescriptionRef.$, 0);
            this.av = new Dictionary$2(String_$type, Base.$, 0);
            this.ax = new Dictionary$2(String_$type, Base.$, 0);
            this.a1 = new List$1(Delegate_$type, 0);
            this.aw = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.az = new List$1(Delegate_$type, 0);
            this.a0 = new List$1(Delegate_$type, 0);
            this._shouldNamespaceSystemRefValues = false;
            let a = this.f();
            this.e = a;
            this.context = new TypeDescriptionContext(a, ComponentRenderer.platform);
            this.g = new TypeDescriptionPropretyTransforms();
            this.h = new TypeDescriptionCleanups();
        }
        get context() {
            return this._context;
        }
        set context(a) {
            this._context = a;
        }
        get isProceedOnErrorEnabled() {
            return this._isProceedOnErrorEnabled;
        }
        set isProceedOnErrorEnabled(a) {
            this._isProceedOnErrorEnabled = a;
        }
        f() {
            return (new ComponentRendererAdapter());
        }
        toJson(a) {
            let b = new DescriptionSerializerBuilder();
            let c = new DescriptionSerializer();
            b.f("{");
            b.i();
            b.f("\"descriptions\": {");
            b.i();
            let d = true;
            for (let e of fromEnum(this.an.keys)) {
                if (d) {
                    d = false;
                }
                else {
                    b.f(",");
                }
                let f = e;
                let g = this.an.item(e);
                let h = "root";
                h = a(f);
                if (stringIsNullOrEmpty(h)) {
                    h = "root";
                }
                b.e("\"" + h + "\"");
                b.e(": ");
                c.s(this.context, g, b);
            }
            b.f("");
            b.h();
            b.e("}");
            if (this.ax.count > 0) {
                b.e(",");
            }
            b.f("");
            if (this.ax.count > 0) {
                d = true;
                b.f("refs: {");
                b.i();
                for (let i of fromEnum(this.ax.keys)) {
                    if (!this.l(i, this.ax.item(i))) {
                        continue;
                    }
                    if (d) {
                        d = false;
                    }
                    else {
                        b.f(",");
                    }
                    this.c6(b, i, this.ax.item(i));
                }
                b.f("");
                b.h();
                b.f("}");
            }
            b.h();
            b.f("}");
            return b.toString();
        }
        c6(a, b, c) {
            a.e("\"" + b + "\": ");
            this.c7(a, c);
        }
        c7(a, b) {
            if (this.t(b)) {
                if (typeof b === 'string') {
                    a.e(b == null ? "null" : "\"" + b.toString() + "\"");
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeCast(Date_$type, b) !== null) {
                    let v_ = b;
                    a.e("\"" + (v_.toJSON()) + "\"");
                }
                else if (typeCast(Boolean_$type, b) !== null) {
                    a.e(b == null ? "null" : b.toString().toLowerCase());
                }
                else {
                    a.e("null");
                }
            }
            else {
                if (b == null) {
                    a.e("null");
                    return;
                }
                if (this.r(b)) {
                    a.f("[");
                    a.i();
                    let c = new DataSourceLocalDataProvider();
                    c.dataSource = b;
                    for (let d = 0; d < c.actualCount; d++) {
                        if (d > 0) {
                            a.f(",");
                        }
                        this.c5(a, c, d);
                    }
                    a.f("");
                    a.h();
                    a.e("]");
                }
                else {
                    let e = [b];
                    let f = new DataSourceLocalDataProvider();
                    f.dataSource = e;
                    this.c5(a, f, 0);
                }
            }
        }
        t(a) {
            if (typeof a === 'string') {
                return true;
            }
            if (typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number') {
                return true;
            }
            if (typeCast(Date_$type, a) !== null) {
                return true;
            }
            if (typeCast(Boolean_$type, a) !== null) {
                return true;
            }
            return false;
        }
        r(a) {
            if (typeCast(Array_$type, a) !== null) {
                return true;
            }
            if (typeCast(IEnumerable_$type, a) !== null) {
                return true;
            }
            return false;
        }
        c5(a, b, c) {
            a.f("{");
            a.i();
            let d = b.actualSchema;
            for (let e = 0; e < d.propertyNames.length; e++) {
                if (e > 0) {
                    a.f(",");
                }
                let f = d.propertyNames[e];
                if (stringStartsWith(f, "[")) {
                    f = f.substr(1, f.length - 2);
                }
                a.e("\"" + f + "\"");
                a.e(": ");
                let g = b.getItemValue(b.getItemAtIndex(c), d.propertyNames[e]);
                switch (d.propertyTypes[e]) {
                    case 0:
                        a.e(g == null ? "null" : "\"" + g.toString() + "\"");
                        break;
                    case 2:
                        a.e(g == null ? "null" : "\"" + g.toString() + "\"");
                        break;
                    case 10:
                    case 6:
                    case 5:
                    case 1:
                    case 3:
                    case 4:
                    case 7:
                        a.e(g == null ? "null" : g.toString());
                        break;
                    case 8:
                        let v_ = g;
                        a.e("\"" + (v_.toJSON()) + "\"");
                        break;
                    case 11:
                        this.c7(a, g);
                        break;
                }
            }
            a.h();
            a.f("}");
        }
        l(a, b) {
            if (b == null) {
                return true;
            }
            let v_ = b;
            if ((typeof v_ === 'function')) {
                return false;
            }
            return true;
        }
        createObjectFromJson(a, b) {
            let c = new JsonDictionaryParser();
            let d = c.parse(a);
            let e = new DescriptionSerializer();
            let f = false;
            let g = e.d(this.context, d, f, null, false);
            if (g.result == null) {
                return null;
            }
            let h = DescriptionTreeBuilder.createTree(this.context, g.result);
            let i = this.au.item(b);
            if (h.b("Type")) {
                let j = h.a("Type").b;
                return this.bm(j, h, b, i, true, -1);
            }
            else {
                return this.bl(typeCast(JsonDictionaryObject.$, d));
            }
        }
        loadJson(a, b) {
            this.cj(a, b, null, false, false, false);
        }
        loadJsonOverlay(a, b, c) {
            this.cj(a, b, c, true, false, true);
        }
        loadJsonDelta(a, b, c) {
            this.cj(a, b, null, true, c, false);
        }
        aj() {
            return false;
        }
        cj(a, b, c, d, e, f) {
            let g = new JsonDictionaryParser();
            let h = g.parse(a);
            let i = new DescriptionSerializer();
            i.h = this.isProceedOnErrorEnabled;
            i.g = this.aj();
            let j = null;
            if (typeCast(JsonDictionaryObject.$, h) !== null) {
                let k = h;
                if (k.g("descriptions")) {
                    let l = k.item("descriptions");
                    if (typeCast(JsonDictionaryObject.$, l) !== null) {
                        let m = l;
                        let n = m.e();
                        for (let o = 0; o < n.length; o++) {
                            let p = n[o];
                            let q = m.item(p);
                            let r = b(p);
                            if (r == null) {
                                continue;
                            }
                            j = r;
                            let s = false;
                            let t = this.a3();
                            if (t != null) {
                                s = true;
                            }
                            let u = null;
                            if (this.isProceedOnErrorEnabled) {
                                try {
                                    u = i.d(this.context, q, s, t, false);
                                }
                                catch (v) {
                                    return;
                                }
                            }
                            else {
                                u = i.d(this.context, q, s, t, false);
                            }
                            if (u.result == null) {
                                continue;
                            }
                            if (f) {
                                if (!this.ay.containsKey(r)) {
                                    let w = null;
                                    if (this.isProceedOnErrorEnabled) {
                                        try {
                                            w = i.d(this.context, q, s, t, true);
                                        }
                                        catch (x) {
                                            return;
                                        }
                                    }
                                    else {
                                        w = i.d(this.context, q, s, t, true);
                                    }
                                    this.c2(w.result, r, d, true, false);
                                    let y = c(p);
                                    let z = this.ay.item(r);
                                    this.cf(this.an.item(r), y, z, r);
                                }
                            }
                            this.c2(u.result, r, d, e, false);
                        }
                    }
                }
                if (k.g("refs") && j != null) {
                    let aa = k.item("refs");
                    let ab = this.z(aa);
                    if (!ab && typeCast(JsonDictionaryObject.$, aa) !== null) {
                        let ac = aa;
                        let ad = ac.e();
                        for (let ae = 0; ae < ad.length; ae++) {
                            let af = ad[ae];
                            let ag = ac.item(af);
                            if (typeCast(JsonDictionaryValue.$, ag) !== null) {
                                let ah = ag;
                                this.provideRefValue(j, af, ah.value);
                            }
                            else if (typeCast(JsonDictionaryArray.$, ag) !== null) {
                                let ai = ag;
                                let aj = this.a(ai);
                                this.provideRefValue(j, af, aj);
                            }
                            else {
                                let ak = this.bl(ag);
                                this.provideRefValue(j, af, ak);
                            }
                        }
                    }
                }
                if (k.g("modules") && j != null) {
                    let al = k.item("modules");
                    this.y(al);
                }
                if (k.g("strings") && j != null) {
                    let am = k.item("strings");
                    this.ad(am);
                }
            }
        }
        provideRefValueFromJson(a, b, c) {
            let d = b;
            let e = new JsonDictionaryParser();
            let f = e.parse(c);
            if (typeCast(JsonDictionaryValue.$, f) !== null) {
                let g = f;
                this.provideRefValue(a, d, g.value);
            }
            else if (typeCast(JsonDictionaryArray.$, f) !== null) {
                let h = f;
                let i = this.a(h);
                this.provideRefValue(a, d, i);
            }
            else {
                let j = this.bl(f);
                this.provideRefValue(a, d, j);
            }
        }
        a3() {
            return null;
        }
        z(a) {
            return false;
        }
        y(a) {
            return false;
        }
        ad(a) {
            return false;
        }
        by(a, b, c) {
            let d = a;
            if (c != null) {
                d = c.g(b);
            }
            else {
                if (TypeDescriptionMetadata.shouldCamelize(b)) {
                    d = TypeDescriptionMetadata.camelize(d);
                }
            }
            if (stringEndsWith(d, "Ref")) {
                d = d.substr(0, d.length - ("Ref").length);
            }
            return d;
        }
        cf(a, b, c, d) {
            if (!c.b(b)) {
                c.k(d, this.an.item(d).f, b, this.an.item(d), runOn(this, this.cp), -1);
            }
            for (let e of fromEnum(a.e())) {
                this.cg(this.by(e.c, ComponentRenderer.platform, e.a), e.b, b, c, d, a.f);
            }
        }
        cg(a, b, c, d, e, f) {
            if (typeCast(DescriptionTreeNode.$, b) !== null) {
                let g = b;
                let h = this.e.getPropertyValue(c, a);
                if (!d.b(h) && !d.a(g.f)) {
                    d.k(e, g.f, h, g, runOn(this, this.cp), f);
                }
                for (let i of fromEnum(g.e())) {
                    this.cg(a + "." + this.by(i.c, ComponentRenderer.platform, i.a), i.b, c, d, e, g.f);
                }
            }
            if (typeCast(Array_$type, b) !== null) {
                let j = new Dictionary$2(Number_$type, DescriptionTreeNode.$, 0);
                let k = 0;
                let l = b.length;
                let o = b;
                for (let n = 0; n < o.length; n++) {
                    let m = o[n];
                    if (typeCast(DescriptionTreeNode.$, m) !== null) {
                        let p = m;
                        j.item(k, p);
                    }
                    k++;
                }
                let q = this.e.getPropertyValue(c, a);
                k = 0;
                this.e.forPropertyValueItem(c, a, (r) => {
                    if (j.containsKey(k)) {
                        let s = j.item(k);
                        if (!d.b(r) && !d.a(s.f)) {
                            d.k(e, s.f, r, s, runOn(this, this.cp), f);
                        }
                        for (let t of fromEnum(s.e())) {
                            this.cg(a + "." + t.c, t.b, c, d, e, s.f);
                        }
                    }
                    k++;
                });
                if (l > 0 && k == 0) {
                    let r = this.b2(a);
                    this.e.forPropertyValueItem(c, r, (s) => {
                        if (j.containsKey(k)) {
                            let t = j.item(k);
                            if (!d.b(s) && !d.a(t.f)) {
                                d.k(e, t.f, s, t, runOn(this, this.cp), f);
                            }
                            for (let u of fromEnum(t.e())) {
                                this.cg(r + "." + u.c, u.b, c, d, e, t.f);
                            }
                        }
                        k++;
                    });
                }
            }
        }
        b2(a) {
            let b = a.lastIndexOf('.');
            let c = null;
            let d = a;
            if (b > 0) {
                c = a.substr(0, b);
                d = a.substr(b + 1);
            }
            d = "actual" + this.b0(d);
            if (c != null) {
                return c + "." + d;
            }
            return d;
        }
        b0(a) {
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        a(a) {
            let b = new Array(a.items.length);
            for (let c = 0; c < a.items.length; c++) {
                let d = this.bl(a.items[c]);
                b[c] = d;
            }
            return b;
        }
        bl(a) {
            if (a == null) {
                return null;
            }
            let b = {};
            let dict_ = b;
            let c = a.e();
            for (let d = 0; d < c.length; d++) {
                let key_ = c[d];
                if (typeCast(JsonDictionaryObject.$, a.item(key_)) !== null) {
                    let val_ = this.bl(a.item(key_));
                    dict_[key_] = val_;
                }
                else if (typeCast(JsonDictionaryArray.$, a.item(key_)) !== null) {
                    let val_ = this.a(a.item(key_));
                    dict_[key_] = val_;
                }
                else {
                    let val_ = a.item(key_).value;
                    dict_[key_] = val_;
                }
            }
            return dict_;
        }
        get ay() {
            return this.au;
        }
        cleanup(a, b) {
            this.c2(null, a, false, false, b);
        }
        render(a, b) {
            this.c2(a, b, false, false, false);
        }
        c2(a, b, c, d, e) {
            if (!this.au.containsKey(b)) {
                this.au.item(b, new ContainerState());
                this.au.item(b).i = b;
            }
            this.ap.item(b, a);
            this.aq.item(b, c);
            this.ar.item(b, d);
            this.ao.item(b, e);
            this.cl(b, () => this.c0(b));
        }
        cl(a, b) {
            this.e.onUIThread(a, b);
        }
        c0(a) {
            if (this.ap.containsKey(a)) {
                let b = this.aq.containsKey(a) ? this.aq.item(a) : false;
                let c = this.ar.containsKey(a) ? this.ar.item(a) : false;
                let d = this.ap.item(a);
                this.ap.removeItem(a);
                let e = DescriptionTreeBuilder.createTree(this.context, d);
                let f = null;
                if (this.an.containsKey(a)) {
                    f = this.an.item(a);
                }
                let g = DescriptionTreeReconciler.c(f, e, b);
                if (c) {
                    let h = DescriptionTreeReconciler.a(f, g);
                    if (!this.au.containsKey(a)) {
                        this.au.addItem(a, ((() => {
                            let $ret = new ContainerState();
                            $ret.i = a;
                            return $ret;
                        })()));
                    }
                    let i = this.au.item(a);
                    if (h.a.count > 0) {
                        for (let j of fromEnum(h.a)) {
                            if (i.a(j)) {
                                let k = i.j(j);
                                this.cd(a, k, i);
                            }
                        }
                    }
                    if (h.c.count > 0) {
                        for (let l of fromEnum(h.c)) {
                            let m = this.br(a, i, l);
                            let n = this.e.getPropertyValue(m, l.i);
                            if (n != null) {
                                if (!i.b(n)) {
                                    let o = l.f;
                                    if (typeCast(DescriptionTreeNode.$, o) !== null) {
                                        let p = o.f;
                                        i.k(a, p, n, o, runOn(this, this.cp), l.b.f);
                                    }
                                }
                            }
                        }
                    }
                    if (h.d.count > 0) {
                        for (let q of fromEnum(h.d)) {
                            let r = q.f;
                            if (r != null) {
                                if (!i.b(r)) {
                                    let s = q.f;
                                    if (typeCast(DescriptionTreeNode.$, s) !== null) {
                                        let t = s.f;
                                        this.an.item(a, s);
                                    }
                                }
                            }
                        }
                    }
                    if (h.b.count > 0) {
                        for (let u of fromEnum(h.b)) {
                            let v = u.b.a(u.i).b;
                            if (v == null) {
                                continue;
                            }
                            let w = new Dictionary$2(String_$type, DescriptionTreeNode.$, 0);
                            for (let x = 0; x < v.length; x++) {
                                let y = v[x];
                                if (typeCast(DescriptionTreeNode.$, y) !== null) {
                                    let z = y;
                                    if (z.b("Name")) {
                                        w.item(z.a("Name").b, z);
                                    }
                                }
                            }
                            if (w.count == 0) {
                                continue;
                            }
                            let aa = this.br(a, i, u);
                            let ab = this.e.getPropertyValue(aa, u.i);
                            if (ab != null) {
                                let ac = 0;
                                this.e.forPropertyValueItem(aa, u.i, (ad) => {
                                    if (w.containsKey(this.e.getPropertyValue(ad, "Name").toString())) {
                                        if (!i.b(ad)) {
                                            let ae = w.item(this.e.getPropertyValue(ad, "Name").toString());
                                            if (typeCast(DescriptionTreeNode.$, ae) !== null) {
                                                let af = ae.f;
                                                i.k(a, af, ad, ae, runOn(this, this.cp), u.b.f);
                                            }
                                        }
                                    }
                                    ac++;
                                });
                            }
                        }
                    }
                }
                else {
                    this.an.item(a, e);
                }
                if (!c) {
                    this.c1(a, g);
                }
                if (this.ao.item(a)) {
                    this.cy(a);
                    if (this.au.containsKey(a)) {
                        this.au.removeItem(a);
                    }
                }
            }
        }
        provideRefValue(a, b, c) {
            this.cl(a, () => {
                if (!this.au.containsKey(a)) {
                    this.au.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let d = this.au.item(a);
                this.cp(a, b, c, true);
            });
        }
        removeRefValue(a, b) {
            this.cl(a, () => {
                if (!this.au.containsKey(a)) {
                    this.au.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let c = this.au.item(a);
                this.removeRefValueCore(a, b, true);
            });
        }
        cy(a) {
            let b = this.au.item(a);
            let c = new List$1(String_$type, 0);
            for (let d of fromEnum(this.at.keys)) {
                if (this.at.item(d).c == 0) {
                    c.add(d);
                }
            }
            for (let e = 0; e < c.count; e++) {
                let f = this.shouldNamespaceSystemRefValues;
                this.shouldNamespaceSystemRefValues = false;
                this.removeRefValueCore(a, c._inner[e], this.ax.containsKey(c._inner[e]));
                this.shouldNamespaceSystemRefValues = f;
            }
        }
        clearRefValues(a) {
            this.cl(a, () => {
                if (!this.au.containsKey(a)) {
                    this.au.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let b = this.au.item(a);
                this.clearUserRefValues();
            });
        }
        c1(a, b) {
            let c = this.au.item(a);
            this.cm(a, c, b);
        }
        c4(a, b) {
            if (this.isProceedOnErrorEnabled) {
                try {
                    this.ce(a, b, true);
                }
                catch (c) {
                    this.am.item(a, false);
                }
            }
            else {
                this.ce(a, b, true);
            }
        }
        da(a, b) {
            if (this.isProceedOnErrorEnabled) {
                try {
                    this.ce(a, b, false);
                }
                catch (c) {
                    this.am.item(a, false);
                }
            }
            else {
                this.ce(a, b, false);
            }
        }
        ce(a, b, c) {
            if (!c) {
                if (this.am.containsKey(a) && this.am.item(a)) {
                    return;
                }
            }
            this.am.item(a, true);
            let d = true;
            while (d && this.as.item(a).count > 0) {
                while (this.as.item(a).count > 0 && this.as.item(a).c().count < 1) {
                    this.as.item(a).b();
                }
                if (this.as.item(a).count < 1) {
                    break;
                }
                let e = this.as.item(a).c();
                while (e.count > 0) {
                    let f = e.b();
                    d = this.v(a, b, f);
                    if (!d) {
                        break;
                    }
                }
            }
            if (d) {
                this.am.item(a, false);
            }
        }
        cm(a, b, c) {
            let d = new Queue$1(DescriptionTreeAction.$);
            for (let e = 0; e < c.count; e++) {
                d.g(c._inner[e]);
            }
            if (!this.as.containsKey(a)) {
                this.as.addItem(a, new Queue$1(Queue$1.$.specialize(DescriptionTreeAction.$)));
            }
            this.as.item(a).g(d);
            this.da(a, b);
        }
        cn(a, b, c) {
            for (let d = 0; d < c.count; d++) {
                this.v(a, b, c._inner[d]);
            }
        }
        v(a, b, c) {
            switch (c.a) {
                case 5: return this.w(a, b, c);
                case 2: return this.x(a, b, c);
                case 4: return this.aa(a, b, c);
                case 3: return this.ab(a, b, c);
                case 1: return this.ac(a, b, c);
                case 0: return this.ae(a, b, c);
            }
            return true;
        }
        ae(a, b, c) {
            let d = this.br(a, b, c);
            this.al(a, b, c, d);
            return true;
        }
        al(a, b, c, d) {
            let e = this.bo(c, a, b);
            e = this.g.transform(ComponentRenderer.platform, e, c);
            let f = false;
            if (this.a1 != null && this.a1.count > 0) {
                for (let g = 0; g < this.a1.count; g++) {
                    let h = this.a1._inner[g];
                    let i = this.bz(a, c);
                    if (h(i, d, e)) {
                        f = true;
                    }
                }
            }
            if (f) {
                return true;
            }
            if (c.c != null && c.c.knownType == 9) {
                this.ai(a, b, c.h(ComponentRenderer.platform), c.c, e, d);
            }
            else {
                this.c8(a, b, c.h(ComponentRenderer.platform), c.c, e, c.g, d);
            }
            return true;
        }
        bz(a, b) {
            let c = b.b;
            let d = "";
            if (c != this.an.item(a)) {
                let e = this.bx(a, c);
                d = e;
            }
            if (d.length > 0) {
                d += ".";
            }
            d += b.i;
            return d;
        }
        bx(a, b) {
            if (b == null) {
                return "";
            }
            let c = this.b3("", this.an.item(a), b);
            if (c.c) {
                return c.d;
            }
            return "";
        }
        b3(a, b, c) {
            if (b == c) {
                return new Tuple$2(Boolean_$type, String_$type, true, a);
            }
            if (a.length > 0) {
                a += ".";
            }
            let d = b.e();
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e];
                if (typeCast(DescriptionTreeNode.$, f.b) !== null) {
                    if (f.b.f == c.f) {
                        a += f.c;
                        return new Tuple$2(Boolean_$type, String_$type, true, a);
                    }
                    else {
                        let g = a + f.c;
                        let h = this.b3(g, f.b, c);
                        if (h.c) {
                            return h;
                        }
                    }
                }
                if (f.a != null && f.a.knownType == 9) {
                    let i = f.b;
                    for (let j = 0; j < i.length; j++) {
                        if (typeCast(DescriptionTreeNode.$, i[j]) !== null) {
                            let k = i[j];
                            if (k.f == c.f) {
                                a += f.c + "[" + j + "]";
                                return new Tuple$2(Boolean_$type, String_$type, true, a);
                            }
                            else {
                                let l = a + f.c + "[" + j + "]";
                                let m = this.b3(l, k, c);
                                if (m.c) {
                                    return m;
                                }
                            }
                        }
                    }
                }
            }
            return new Tuple$2(Boolean_$type, String_$type, false, a);
        }
        ai(a, b, c, d, e, f) {
            if (this.aw.containsKey(c)) {
                for (let g of fromEnum(this.aw.item(c))) {
                    g(c, f, e);
                }
            }
            this.e.setOrUpdateCollectionOnTarget(a, c, d, this.context, f, e);
            return true;
        }
        bo(a, b, c) {
            if (a.c == null) {
                return a.f;
            }
            switch (a.c.knownType) {
                case 10: return this.a5(a, b, c);
                case 7: return this.a6(a);
                case 4: return this.a7(a);
                case 6: return this.a8(a);
                case 9: return this.a5(a, b, c);
                case 5: return this.a9(a);
                case 16: return this.ba(a);
                case 20: return this.bs(a, c);
                case 15: return null;
                case 3: return this.bb(a);
                case 19: return this.bt(a, c);
                case 8: return this.bd(a, b, c);
                case 13: return null;
                case 18: return this.bu(a, c);
                case 1: return this.be(a);
                case 11: return this.bf(a);
                case 14: return this.bg(a);
                case 12: return this.bh(a);
                case 2: return this.bi(a);
                case 21: return this.bj(a);
                case 17: return this.bk(a, b, c);
                case 0: return null;
            }
            return null;
        }
        bk(a, b, c) {
            if (typeCast(DescriptionTreeNode.$, a.f) !== null) {
                let d = a.f;
                if (d.h == "EmbeddedRef") {
                    return this.bm(d.h, a.f, b, c, false, a.b.f);
                }
            }
            return a.f;
        }
        bj(a) {
            return a.f;
        }
        bi(a) {
            return a.f != null ? a.f.toString() : null;
        }
        bh(a) {
            let b = a.f;
            let width_ = b.width;
            let height_ = b.height;
            let c = { width: width_, height: height_ };
            return c;
        }
        bg(a) {
            let b = a.f;
            let top_ = b.top;
            let left_ = b.left;
            let width_ = b.width;
            let height_ = b.height;
            let c = { left: left_, top: top_, width: width_, height: height_ };
            return c;
        }
        bf(a) {
            let b = a.f;
            let x_ = b.x;
            let y_ = b.y;
            let c = { x: x_, y: y_ };
            return c;
        }
        be(a) {
            if (a.f == null) {
                if (a.c != null && (a.c.specificType == "double" || a.c.specificType == "float")) {
                    return NaN;
                }
                return 0;
            }
            return a.f;
        }
        c(a, b) {
            if (this.at.containsKey(a)) {
                let c = this.at.item(a);
                return c;
            }
            let d = new DescriptionRef(a);
            this.at.addItem(a, d);
            return d;
        }
        bu(a, b) {
            return a.f == null ? null : this.c(a.f, b);
        }
        bd(a, b, c) {
            let d = a.c.specificType;
            if (d == null) {
                d = a.c.specificExternalType;
            }
            if (typeCast(DescriptionTreeNode.$, a.f) !== null) {
                let e = a.f;
                if (e.b("Type")) {
                    d = e.a("Type").b;
                }
            }
            let f = this.bm(d, a.f, b, c, false, a.b.f);
            return f;
        }
        bt(a, b) {
            return a.f == null ? null : this.c(a.f, b);
        }
        bb(a) {
            return a.f;
        }
        bs(a, b) {
            return a.f == null ? null : this.c(a.f, b);
        }
        bw(a) {
            return a;
        }
        ba(a) {
            let b = a.f;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = this.bw(b[d]);
            }
            return c;
        }
        a9(a) {
            return this.bw(a.f);
        }
        a8(a) {
            let b = a.f;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = this.bv(b[d]);
            }
            return c;
        }
        bv(a) {
            return a;
        }
        a7(a) {
            return this.bv(a.f);
        }
        a6(a) {
            return a.f;
        }
        addTargetPropertyUpdatingListener(a) {
            this.a1.add(a);
        }
        removeTargetPropertyUpdatingListener(a) {
            this.a1.remove(a);
        }
        addPropertyUpdatingListener(a, b) {
            if (!this.aw.containsKey(a)) {
                this.aw.addItem(a, new List$1(Delegate_$type, 0));
            }
            this.aw.item(a).add(b);
        }
        addReferenceLookupListener(a) {
            this.az.add(a);
        }
        removeReferenceLookupListener(a) {
            this.az.remove(a);
        }
        removePropertyUpdatingListener(a, b) {
            if (this.aw.containsKey(a)) {
                this.aw.item(a).remove(b);
                if (this.aw.item(a).count == 0) {
                    this.aw.removeItem(a);
                }
            }
        }
        addNamespaceLookupListener(a) {
            this.a0.add(a);
        }
        removeNamespaceLookupListener(a) {
            this.a0.remove(a);
        }
        a5(a, b, c) {
            if (a.f == null) {
                return null;
            }
            let d = a.f;
            let e = new List$1(Base.$, 0);
            let f = a.c.specificType;
            if (f == null) {
                f = a.c.specificExternalType;
            }
            if (a.c.knownType == 9) {
                f = a.c.collectionElementType;
                if (f == null) {
                    f = a.c.specificExternalType;
                }
            }
            for (let g = 0; g < d.length; g++) {
                let h = f;
                if (typeCast(DescriptionTreeNode.$, d[g]) !== null) {
                    let i = d[g];
                    if (i.b("Type")) {
                        h = i.a("Type").b;
                    }
                }
                let j = this.bm(h, d[g], b, c, false, a.b.f);
                e.add1(j);
            }
            return e.toArray();
        }
        c8(a, b, c, d, e, f, g) {
            if (typeCast(DescriptionRef.$, e) !== null) {
                let h = e;
                let i = false;
                if (f != null && typeof f === 'string') {
                    if (this.o(f)) {
                        let j = this.d(f);
                        if (Base.equalsStatic(j, e)) {
                            i = true;
                        }
                        else {
                            j.j(a, g, c);
                        }
                    }
                }
                if (this.p(e)) {
                    let k = e;
                    if (k.e != null && k.e.length > 0 && this.av.containsKey(k.e)) {
                        k.a = true;
                    }
                    e = this.bq(e);
                    this.c9(g, c, d, e, f, k);
                }
                else {
                    this.e.onPendingRef(g, c, d, e);
                }
                let l = null;
                l = (m, n) => {
                    let o = m;
                    if (o.e != null && o.e.length > 0 && this.av.containsKey(o.e)) {
                        o.a = true;
                    }
                    let p = this.bq(m);
                    this.c9(g, c, d, p, f, o);
                };
                if (!i) {
                    h.g(a, g, c, l);
                }
                return;
            }
            this.c9(g, c, d, e, f, null);
        }
        hasUserRef(a) {
            return this.ax.containsKey(a);
        }
        get shouldNamespaceSystemRefValues() {
            return this._shouldNamespaceSystemRefValues;
        }
        set shouldNamespaceSystemRefValues(a) {
            this._shouldNamespaceSystemRefValues = a;
        }
        cp(a, b, c, d) {
            let e = null;
            if (d) {
                if (this.ax.containsKey(b)) {
                    e = this.ax.item(b);
                }
                this.ax.item(b, c);
            }
            else {
                if (this.shouldNamespaceSystemRefValues) {
                    let f = "";
                    if (this.a0 != null && this.a0.count > 0) {
                        for (let g = 0; g < this.a0.count; g++) {
                            f = this.a0._inner[g](a);
                        }
                    }
                    if (!stringIsNullOrEmpty(f)) {
                        b = f + "/" + b;
                    }
                }
                if (this.av.containsKey(b)) {
                    e = this.av.item(b);
                }
                this.av.item(b, c);
                if (this.at.containsKey(b)) {
                    this.at.item(b).a = true;
                }
            }
            if (this.at.containsKey(b)) {
                this.at.item(b).f(e, c);
            }
        }
        removeRefValueCore(a, b, c) {
            let d = null;
            if (c) {
                if (this.ax.containsKey(b)) {
                    d = this.ax.item(b);
                }
                this.ax.removeItem(b);
            }
            else {
                if (this.shouldNamespaceSystemRefValues) {
                    let e = "";
                    if (this.a0 != null && this.a0.count > 0) {
                        for (let f = 0; f < this.a0.count; f++) {
                            e = this.a0._inner[f](a);
                        }
                    }
                    if (!stringIsNullOrEmpty(e)) {
                        b = e + "/" + b;
                    }
                }
                if (this.av.containsKey(b)) {
                    d = this.av.item(b);
                }
                this.av.removeItem(b);
            }
            if (this.at.containsKey(b)) {
                this.at.item(b).f(d, this.bq(this.at.item(b)));
                if (this.at.item(b).c <= 0) {
                    this.at.item(b).h();
                    this.at.removeItem(b);
                }
            }
        }
        clearUserRefValues() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.ax.keys)) {
                a.add(b);
            }
            for (let c of fromEnum(a)) {
                this.removeRefValueCore(null, c, true);
            }
        }
        p(a) {
            return this.ax.containsKey(a.e) || this.av.containsKey(a.e);
        }
        bq(a) {
            if (this.ax.containsKey(a.e)) {
                return this.ax.item(a.e);
            }
            if (this.av.containsKey(a.e)) {
                return this.av.item(a.e);
            }
            return null;
        }
        o(a) {
            return this.at.containsKey(a);
        }
        d(a) {
            return this.at.item(a);
        }
        getMissingRefs() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.at.keys)) {
                if (!this.p(this.at.item(b))) {
                    a.add(b);
                }
            }
            return a.toArray();
        }
        br(a, b, c) {
            return b.j(c.b.f);
        }
        ac(a, b, c) {
            let d = this.br(a, b, c);
            this.ah(a, b, c, d);
            return true;
        }
        ah(a, b, c, d) {
            this.e.resetPropertyOnTarget(a, c.h(ComponentRenderer.platform), c.c, d);
            return true;
        }
        ab(a, b, c) {
            if (c.b == null) {
                return this.ag(a, b, c);
            }
            else {
                let d = this.br(a, b, c);
                this.c3(a, b, c, d);
            }
            return true;
        }
        c3(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            let f = c.c.collectionElementType;
            if (f == null) {
                f = c.c.specificExternalType;
            }
            let g = this.bm(f, c.f, a, b, false, c.b.f);
            this.e.replaceItemInCollection(e, c.c, d, c.d, g);
            if (c.g != null && typeCast(DescriptionTreeNode.$, c.g) !== null) {
                let h = c.g.f;
                if (h >= 0) {
                    let i = b.j(h);
                    if (i != null) {
                        this.cd(a, i, b);
                    }
                }
            }
        }
        ag(a, b, c) {
            let d = this.e.getRootObject(a);
            if (d != null) {
                this.cd(a, d, b);
            }
            if (!(typeCast(DescriptionTreeNode.$, c.f) !== null)) {
                throw new NotImplementedException(0);
            }
            let e = c.f;
            let f = false;
            this.e.replaceRootItem(a, e.h, this.context, (g) => {
                let h = this.e.getRootObject(a);
                b.k(a, e.f, h, e, runOn(this, this.cp), -1);
                let i = this.a2(e);
                this.cn(a, b, i);
                f = true;
                if (g) {
                    this.c4(a, b);
                }
            });
            return f;
        }
        cd(a, b, c) {
            let d = this.a4(a, b, c);
            for (let e of fromEnum(this.at.values)) {
                e.i(b);
            }
            if (d != -1) {
                c.l(this, a, d, runOn(this, this.removeRefValueCore));
            }
            this.h.b(ComponentRenderer.platform, b);
        }
        a4(a, b, c) {
            return c.h(b);
        }
        aa(a, b, c) {
            if (c.b == null) {
                return this.af(a, b, c);
            }
            else {
                let d = this.br(a, b, c);
                this.cr(a, b, c, d);
            }
            return true;
        }
        cr(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            this.e.removeItemFromCollection(e, c.c, d, c.e);
            if (c.g != null && typeCast(DescriptionTreeNode.$, c.g) !== null) {
                let f = c.g.f;
                if (f >= 0) {
                    let g = b.j(f);
                    if (g != null) {
                        this.cd(a, g, b);
                    }
                }
            }
        }
        af(a, b, c) {
            let d = this.e.getRootObject(a);
            if (d != null) {
                this.cd(a, d, b);
            }
            let e = false;
            this.e.removeRootItem(a, this.context, (f) => {
                e = true;
                if (f) {
                    this.c4(a, b);
                }
            });
            return e;
        }
        x(a, b, c) {
            if (c.b == null) {
                return this.k(a, b, c);
            }
            else {
                let d = this.br(a, b, c);
                this.b4(a, b, c, d);
            }
            return true;
        }
        k(a, b, c) {
            if (!(typeCast(DescriptionTreeNode.$, c.f) !== null)) {
                throw new NotImplementedException(0);
            }
            let d = c.f;
            let e = false;
            this.e.replaceRootItem(a, d.h, this.context, (f) => {
                let g = this.e.getRootObject(a);
                b.k(a, d.f, g, d, runOn(this, this.cp), -1);
                let h = this.a2(d);
                this.cn(a, b, h);
                e = true;
                if (f) {
                    this.c4(a, b);
                }
            });
            return e;
        }
        b4(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            let f = c.c.collectionElementType;
            if (typeCast(DescriptionTreeNode.$, c.f) !== null) {
                let g = c.f;
                if (g.b("Type")) {
                    f = g.a("Type").b;
                }
            }
            if (f == null) {
                f = c.c.specificExternalType;
            }
            let h = this.bm(f, c.f, a, b, false, c.b.f);
            this.e.addItemToCollection(e, c.c, d, c.d, h);
        }
        bm(a, b, c, d, e, f) {
            if (this.s(a)) {
                return b;
            }
            let g = null;
            if (b != null && typeCast(DescriptionTreeNode.$, b) !== null) {
                let h = b;
                if (h.b("Name")) {
                    let i = h.a("Name").b;
                    if (!stringIsNullOrEmpty(i)) {
                        if (this.shouldNamespaceSystemRefValues) {
                            let j = "";
                            if (this.a0 != null && this.a0.count > 0) {
                                for (let k = 0; k < this.a0.count; k++) {
                                    j = this.a0._inner[k](c);
                                }
                            }
                            if (!stringIsNullOrEmpty(j)) {
                                i = j + "/" + i;
                            }
                        }
                        if (this.av.containsKey(i)) {
                            let l = this.av.item(i);
                            g = l;
                        }
                    }
                }
                if (g == null) {
                    g = this.context.m(a, c);
                }
            }
            else {
                g = this.context.m(a, c);
            }
            if (b == null) {
                return g;
            }
            if (typeCast(DescriptionTreeNode.$, b) !== null) {
                let m = b;
                if (m.h == "EmbeddedRef") {
                    let n = "uuid";
                    let o = null;
                    for (let p = 0; p < m.e().count; p++) {
                        if (m.e()._inner[p].c == "RefType") {
                            n = m.e()._inner[p].b;
                        }
                        if (m.e()._inner[p].c == "Value") {
                            o = m.e()._inner[p].b;
                        }
                    }
                    if (o != null) {
                        for (let q = 0; q < this.az.count; q++) {
                            let r = this.az._inner[q](c, n, o);
                            if (r != null) {
                                return r;
                            }
                        }
                        return null;
                    }
                }
                else {
                    d.k(c, m.f, g, m, runOn(this, this.cp), f);
                    let s = this.a2(m);
                    this.cn(c, d, s);
                    if (e) {
                        d.l(this, c, m.f, runOn(this, this.removeRefValueCore));
                    }
                }
            }
            if (typeof b === 'string' && a.toLowerCase() != "string") {
                return this.bc(a, b);
            }
            if (a == "object" || a == "Object") {
                return b;
            }
            return g;
        }
        s(a) {
            return a == "int" || a == "Int32" || a == "short" || a == "Int16" || a == "double" || a == "Double" || a == "float" || a == "Float" || a == "Single" || a == "single" || a == "DateTime" || a == "decimal" || a == "Decimal" || a == "long" || a == "Int64" || a == "byte" || a == "bool" || a == "string" || a == "String";
        }
        bc(a, b) {
            return this.context.i(a, b);
        }
        a2(a) {
            let b = a.e();
            let c = new List$1(DescriptionTreeAction.$, 0);
            for (let d = 0; d < b.count; d++) {
                let e = new DescriptionTreeAction();
                e.a = 0;
                e.i = b._inner[d].c;
                e.c = b._inner[d].a;
                e.b = a;
                e.f = b._inner[d].b;
                c.add(e);
            }
            return c;
        }
        w(a, b, c) {
            if (c.b == null) {
                return this.n(a, b, c);
            }
            else {
                let d = this.br(a, b, c);
                this.ca(a, b, c, d);
            }
            return true;
        }
        ca(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            this.e.clearCollection(d, e, c.c);
            if (c.g != null && typeCast(Array_$type, c.g) !== null) {
                let f = c.g;
                for (let g = 0; g < f.length; g++) {
                    let h = f[g];
                    if (h != null && typeCast(DescriptionTreeNode.$, h) !== null) {
                        let i = h.f;
                        if (i >= 0) {
                            let j = b.j(i);
                            if (j != null) {
                                this.cd(a, j, b);
                            }
                        }
                    }
                }
            }
        }
        c9(a, b, c, d, e, f) {
            if (this.aw.containsKey(b)) {
                for (let g of fromEnum(this.aw.item(b))) {
                    g(b, a, d);
                }
            }
            this.e.setPropertyValue(a, b, c, d, e, f);
        }
        bp(a, b) {
            return this.e.getPropertyValue(a, b);
        }
        n(a, b, c) {
            return this.m(a, b);
        }
        m(a, b) {
            let c = this.e.getRootObject(a);
            if (c != null) {
                this.cd(a, c, b);
            }
            let d = false;
            this.e.clearContainer(a, this.context, (e) => {
                d = true;
                if (e) {
                    this.c4(a, b);
                }
            });
            return d;
        }
    }
    ComponentRenderer.$t = /*@__PURE__*/ markType(ComponentRenderer, 'ComponentRenderer');
    ComponentRenderer.platform = 3;
    return ComponentRenderer;
})();
/**
 * @hidden
 */
let ContainerState = /*@__PURE__*/ (() => {
    class ContainerState extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.e = new Dictionary$2(Number_$type, Base.$, 0);
            this.f = new Dictionary$2(Base.$, Number_$type, 0);
            this.d = new Dictionary$2(Number_$type, String_$type, 0);
            this.g = new Dictionary$2(Number_$type, HashSet$1.$.specialize(Number_$type), 0);
            this.c = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
        }
        k(a, b, c, d, e, f) {
            if (d.b("Name")) {
                this.d.item(b, d.a("Name").b);
                e(a, this.d.item(b), c, false);
            }
            this.e.item(b, c);
            this.f.item(c, b);
            if (!this.g.containsKey(b)) {
                this.g.item(b, new HashSet$1(Number_$type, 0));
            }
            this.g.item(b).add_1(f);
            if (f >= 0) {
                if (!this.c.containsKey(f)) {
                    this.c.item(f, new List$1(Number_$type, 0));
                }
                this.c.item(f).add(b);
            }
        }
        a(a) {
            return this.e.containsKey(a);
        }
        b(a) {
            return this.f.containsKey(a);
        }
        j(a) {
            return this.e.item(a);
        }
        l(a, b, c, d) {
            if (this.c.containsKey(c)) {
                let e = this.c.item(c);
                for (let f = 0; f < e.count; f++) {
                    if (!this.g.containsKey(e._inner[f]) || this.g.item(e._inner[f]).count < 1 || (this.g.item(e._inner[f]).count == 1 && this.g.item(e._inner[f]).contains(c))) {
                        if (this.e.containsKey(e._inner[f])) {
                            a.cd(b, this.e.item(e._inner[f]), this);
                        }
                    }
                }
                this.c.removeItem(c);
            }
            let g = this.e.item(c);
            this.f.removeItem(g);
            this.e.removeItem(c);
            if (this.g.containsKey(c)) {
                this.g.removeItem(c);
            }
            if (this.d.containsKey(c)) {
                let h = this.d.item(c);
                this.d.removeItem(c);
                d(b, h, false);
            }
        }
        h(a) {
            if (this.f.containsKey(a)) {
                return this.f.item(a);
            }
            return -1;
        }
    }
    ContainerState.$t = /*@__PURE__*/ markType(ContainerState, 'ContainerState');
    return ContainerState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererHandlerEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererHandlerEmitter extends Base {
        constructor(a, b) {
            super();
            this.f = null;
            this.e = null;
            this.b = new CodeGeneratingCodeWriter();
            this.a = new CodeGeneratingCodeWriter();
            this.g = new HashSet$1(String_$type, 0);
            this.f = a;
            this.e = b;
        }
        get d() {
            return this.b;
        }
        get c() {
            return this.a;
        }
        h() {
            let a = new HashSet$1(String_$type, 0);
            for (let b = 0; b < this.e.j.count; b++) {
                let c = this.e.j._inner[b];
                if (c.a != null && c.c == null) {
                    if (this.f.library != null && this.f.library.hasItem(c.a.e)) {
                        if (a.contains(c.a.e)) {
                            continue;
                        }
                        a.add_1(c.a.e);
                        let d = this.f.library.getItem(c.a.e);
                        if (d.type == 1) {
                            let e = d.getContentForPlatform(this.e.platform);
                            if (e != null) {
                                if (e.isJson) {
                                    let f = new JsonDictionaryParser();
                                    let g = f.parse(e.content);
                                    if (g.g("imports")) {
                                        let h = g.item("imports").value;
                                        let i = stringSplit(h, ["\n", "\r\n"], 0);
                                        for (let k = 0; k < i.length; k++) {
                                            let j = i[k];
                                            if (!this.g.contains(j)) {
                                                this.g.add_1(j);
                                                this.c.j(h);
                                            }
                                        }
                                    }
                                    if (g.g("handler")) {
                                        let l = g.item("handler").value;
                                        this.d.j(l);
                                    }
                                }
                                else {
                                    let m = e.content;
                                    this.d.j(m);
                                }
                            }
                        }
                    }
                }
            }
            this.e.addContainerResult("eventHandlers", this.d.toString());
            this.e.addContainerResult("handlersImports", this.c.toString());
        }
    }
    CodeGeneratingComponentRendererHandlerEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererHandlerEmitter, 'CodeGeneratingComponentRendererHandlerEmitter');
    return CodeGeneratingComponentRendererHandlerEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererHandlerEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererHandlerEmitter extends CodeGeneratingComponentRendererHandlerEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    TSCodeGeneratingComponentRendererHandlerEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererHandlerEmitter, 'TSCodeGeneratingComponentRendererHandlerEmitter', CodeGeneratingComponentRendererHandlerEmitter.$);
    return TSCodeGeneratingComponentRendererHandlerEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererHandlerEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererHandlerEmitter extends CodeGeneratingComponentRendererHandlerEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    DotNetCodeGeneratingComponentRendererHandlerEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererHandlerEmitter, 'DotNetCodeGeneratingComponentRendererHandlerEmitter', CodeGeneratingComponentRendererHandlerEmitter.$);
    return DotNetCodeGeneratingComponentRendererHandlerEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererModuleEmitter extends Base {
        constructor(a, b) {
            super();
            this.j = null;
            this.i = null;
            this.d = new CodeGeneratingCodeWriter();
            this.c = new CodeGeneratingCodeWriter();
            this.a = new CodeGeneratingCodeWriter();
            this.b = new CodeGeneratingCodeWriter();
            this.j = a;
            this.i = b;
        }
        get h() {
            return this.d;
        }
        get g() {
            return this.c;
        }
        get e() {
            return this.a;
        }
        get f() {
            return this.b;
        }
        l(a) {
            this.n();
            if (typeCast(JsonDictionaryArray.$, a) !== null) {
                let b = a;
                for (let c = 0; c < b.items.length; c++) {
                    let d = b.items[c];
                    if (typeCast(JsonDictionaryValue.$, d) !== null) {
                        let e = d;
                        if (e != null) {
                            let f = e.value.toString();
                            this.k(f);
                        }
                    }
                }
            }
            this.m();
            this.i.addContainerResult("modulesImports", this.g.toString());
            this.i.addContainerResult("modulesRegister", this.h.toString());
            this.i.addContainerResult("descriptionImports", this.e.toString());
            this.i.addContainerResult("descriptionRegister", this.f.toString());
        }
        m() {
        }
        k(a) {
        }
        n() {
        }
    }
    CodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererModuleEmitter, 'CodeGeneratingComponentRendererModuleEmitter');
    return CodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererModuleEmitter extends CodeGeneratingComponentRendererModuleEmitter {
        constructor(a, b, c) {
            super(b, c);
            this.o = 0;
            this.r = 0;
            this.p = false;
            this.q = new Dictionary$2(String_$type, List$1.$.specialize(String_$type), 0);
            this.o = a;
        }
        n() {
            super.n();
            this.r = 0;
            this.h.g();
        }
        get t() {
            switch (this.o) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
            }
            return "";
        }
        get s() {
            switch (this.o) {
                case 1: return "angular";
                case 2: return "react";
                case 3: return "webcomponents";
            }
            return "";
        }
        k(a) {
            super.k(a);
            if (a == "withDescriptions") {
                this.p = true;
                return;
            }
            let b = "igniteui-" + this.s + "-core";
            let c = "";
            let d = a.split('/');
            if (d.length == 1) {
                c = d[0];
            }
            else {
                b = d[0];
                b = "igniteui-" + this.s + "-" + b;
                c = d[1];
            }
            if (!this.q.containsKey(b)) {
                this.q.addItem(b, new List$1(String_$type, 0));
            }
            let e = this.q.item(b);
            if (this.r > 0) {
                this.h.j(",");
            }
            this.h.i(this.t + c);
            e.add(this.t + c);
            if (this.p) {
                if (this.r == 0) {
                    this.f.g();
                    this.f.g();
                    this.f.j("private _componentRenderer: ComponentRenderer = null;");
                    this.f.j("public get renderer(): ComponentRenderer {");
                    this.f.g();
                    this.f.j("if (this._componentRenderer == null) {");
                    this.f.g();
                    this.f.j("this._componentRenderer = new ComponentRenderer();");
                    this.f.j("var context = this._componentRenderer.context;");
                    this.e.i("import { ");
                    this.e.i("ComponentRenderer, ");
                }
                let f = c;
                if (stringEndsWith(f, "Module")) {
                    f = f.substr(0, f.length - ("Module").length);
                    f += "DescriptionModule";
                }
                if (this.r > 0) {
                    this.e.i(", ");
                }
                this.e.i(f);
                this.f.j(f + ".register(context);");
            }
            this.r++;
        }
        m() {
            super.m();
            for (let a of fromEnum(this.q.keys)) {
                let b = a;
                let c = this.q.item(a);
                let d = stringJoin1(String_$type, ", ", c);
                this.g.i("import { ");
                this.g.i(d);
                this.g.i(" } from '");
                this.g.i(b);
                this.g.j("';");
            }
            if (this.p) {
                this.f.e();
                this.f.j("}");
                this.f.e();
                this.f.j("return this._componentRenderer");
                this.f.j("}");
                this.e.j("} from 'igniteui-" + this.s + "-core';");
            }
        }
    }
    TSCodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererModuleEmitter, 'TSCodeGeneratingComponentRendererModuleEmitter', CodeGeneratingComponentRendererModuleEmitter.$);
    return TSCodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererModuleEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererModuleEmitter extends CodeGeneratingComponentRendererModuleEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    DotNetCodeGeneratingComponentRendererModuleEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererModuleEmitter, 'DotNetCodeGeneratingComponentRendererModuleEmitter', CodeGeneratingComponentRendererModuleEmitter.$);
    return DotNetCodeGeneratingComponentRendererModuleEmitter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationTransformer = /*@__PURE__*/ (() => {
    class CodeGenerationTransformer extends Base {
        constructor(a) {
            super();
            this.a = 0;
            this.b = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.a = a;
            this.b.item("VisibilityToBooleanTransform", (b, c) => {
                if (b.toString().toLowerCase() == "visible") {
                    return true;
                }
                return false;
            });
            if (a == 0) {
                this.b.item("AxisLabelTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return null;
                    }
                    if (!stringContains(d, "{")) {
                        return "{" + d + "}";
                    }
                    return d;
                });
                this.b.item("FontFamilyTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return null;
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 0;
                        $ret.b = d;
                        return $ret;
                    })());
                });
                this.b.item("FontStyleTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                        case "italic": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Italic";
                            return $ret;
                        })());
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 1;
                        $ret.b = "Normal";
                        return $ret;
                    })());
                });
                this.b.item("FontWeightTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 2;
                            $ret.b = "Normal";
                            return $ret;
                        })());
                        case "bold": return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 2;
                            $ret.b = "Bold";
                            return $ret;
                        })());
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 1;
                        $ret.b = "Normal";
                        return $ret;
                    })());
                });
            }
            if (a == 4) {
                this.b.item("ColorTransform", (b, c) => ((() => {
                    let $ret = new CodeGenerationSpecialValue();
                    $ret.a = 3;
                    $ret.b = b;
                    return $ret;
                })()));
                this.b.item("FontFamilyTransform", (b, c) => {
                    let d = b;
                    if (d == null) {
                        return null;
                    }
                    return ((() => {
                        let $ret = new CodeGenerationSpecialValue();
                        $ret.a = 0;
                        $ret.b = d;
                        return $ret;
                    })());
                });
                this.b.item("FontStyleTransform", (b, c) => {
                    let d = b;
                    let e = c.i;
                    let f = stringReplace(e, "Style", "Weight");
                    let g = false;
                    if (c.b.b(f)) {
                        let h = c.b.a(f);
                        let i = h.b;
                        if (i != null && i.toLowerCase() == "bold") {
                            g = true;
                        }
                    }
                    if (d == null) {
                        if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Bold";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Bold";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                        case "italic": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "BoldItalic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Italic";
                                return $ret;
                            })());
                        }
                    }
                    if (g) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Bold";
                            return $ret;
                        })());
                    }
                    else {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Regular";
                            return $ret;
                        })());
                    }
                });
                this.b.item("FontWeightTransform", (b, c) => {
                    let d = b;
                    let e = c.i;
                    let f = stringReplace(e, "Weight", "Style");
                    let g = false;
                    if (c.b.b(f)) {
                        let h = c.b.a(f);
                        let i = h.b;
                        if (i != null && i.toLowerCase() == "italic") {
                            g = true;
                        }
                    }
                    if (d == null) {
                        if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Italic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                    }
                    d = d.toLowerCase();
                    switch (d) {
                        case "normal": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Italic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Regular";
                                return $ret;
                            })());
                        }
                        case "bold": if (g) {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "BoldItalic";
                                return $ret;
                            })());
                        }
                        else {
                            return ((() => {
                                let $ret = new CodeGenerationSpecialValue();
                                $ret.a = 1;
                                $ret.b = "Bold";
                                return $ret;
                            })());
                        }
                    }
                    if (g) {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Italic";
                            return $ret;
                        })());
                    }
                    else {
                        return ((() => {
                            let $ret = new CodeGenerationSpecialValue();
                            $ret.a = 1;
                            $ret.b = "Regular";
                            return $ret;
                        })());
                    }
                });
            }
            if (a == 1 || a == 2 || a == 3) {
                this.b.item("FontFamilyTransform", (b, c) => {
                    let d = this.e(c);
                    let e = this.d(c);
                    let f = this.f(c);
                    let g = b;
                    if (g == null) {
                        g = "Verdana";
                    }
                    return d + " " + f + " " + e + " " + g;
                });
                this.b.item("FontStyleTransform", (b, c) => {
                    let d = this.c(c);
                    let e = this.d(c);
                    let f = this.f(c);
                    let g = b;
                    if (g == null) {
                        g = "normal";
                    }
                    return g + " " + f + " " + e + " " + d;
                });
                this.b.item("FontSizeTransform", (b, c) => {
                    let d = this.c(c);
                    let e = this.e(c);
                    let f = this.f(c);
                    let g = b != null ? b.toString() + "px" : null;
                    if (g == null) {
                        g = "14px";
                    }
                    return e + " " + f + " " + g + " " + d;
                });
                this.b.item("FontWeightTransform", (b, c) => {
                    let d = this.c(c);
                    let e = this.d(c);
                    let f = this.e(c);
                    let g = b != null ? b.toString() : null;
                    if (g == null) {
                        g = "normal";
                    }
                    g = g.toLowerCase();
                    return f + " " + g + " " + e + " " + d;
                });
            }
        }
        c(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Style", "Family"), "Weight", "Family"), "Size", "Family");
            let c = "Verdana";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "Verdana";
                }
            }
            return c;
        }
        e(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Family", "Style"), "Weight", "Style"), "Size", "Style");
            let c = "normal";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "normal";
                }
            }
            return c;
        }
        d(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Family", "Size"), "Weight", "Size"), "Style", "Size");
            let c = "14px";
            if (a.b.b(b)) {
                c = a.b.a(b).b.toString();
                if (c == null) {
                    c = "14px";
                }
                else {
                    c = c.toString() + "px";
                }
            }
            return c;
        }
        f(a) {
            let b = stringReplace(stringReplace(stringReplace(a.i, "Family", "Weight"), "Size", "Weight"), "Style", "Weight");
            let c = "normal";
            if (a.b.b(b)) {
                c = a.b.a(b).b;
                if (c == null) {
                    c = "normal";
                }
                c = c.toLowerCase();
            }
            return c;
        }
        transform(a, b, c) {
            let d = c.c;
            if (d == null) {
                return b;
            }
            let e = d.h(a);
            if (e != null && this.b.containsKey(e)) {
                let f = this.b.item(e);
                return f(b, c);
            }
            return b;
        }
    }
    CodeGenerationTransformer.$t = /*@__PURE__*/ markType(CodeGenerationTransformer, 'CodeGenerationTransformer', Base.$, [ITypeDescriptionPropertyTransforms_$type]);
    return CodeGenerationTransformer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRendererCodeEmitter extends Base {
        constructor(a, b) {
            super();
            this.k = null;
            this.i = null;
            this.p = new List$1(CodeGenerationItemBuilderPropertyInfo.$, 0);
            this.d = new CodeGeneratingCodeWriter();
            this.a = new CodeGeneratingCodeWriter();
            this.c = new CodeGeneratingCodeWriter();
            this.b = new CodeGeneratingCodeWriter();
            this.q = new List$1(String_$type, 0);
            this.s = new Stack$1(String_$type);
            this.r = new Stack$1(String_$type);
            this.ah = null;
            this.k = a;
            this.i = b;
            this.f.g();
            this.e.g();
            this.e.g();
            this.g.g();
            this.g.g();
        }
        ax(a) {
            this.i.r(a);
        }
        get j() {
            return this.i;
        }
        get h() {
            return this.d;
        }
        get e() {
            return this.a;
        }
        get g() {
            return this.c;
        }
        get f() {
            return this.b;
        }
        ak(a) {
            this.q.add(a);
        }
        m(a) {
            if (a.b != null && (a.b.knownType == 20 || a.b.knownType == 19 || a.b.knownType == 18)) {
                if (a.a != null) {
                    return true;
                }
            }
            return false;
        }
        get x() {
            return this.s.d();
        }
        al(a) {
            this.s.h(a);
        }
        aw() {
        }
        at(a) {
            this.s.e();
        }
        ar(a, b, c) {
        }
        as(a, b, c) {
            this.ar(a, b, c);
        }
        toString() {
            return this.d.toString();
        }
        ad() {
            return "null";
        }
        ag(a, b) {
            if (a.b == null) {
                return a.c;
            }
            if (typeCast(CodeGenerationSpecialValue.$, a.c) !== null) {
                a.c = this.t(a);
            }
            switch (a.b.knownType) {
                case 10:
                case 7: return a.c ? "true" : "false";
                case 4: return this.u(a);
                case 6:
                    {
                        let c = "";
                        let d = a.c;
                        for (let e = 0; e < d.count; e++) {
                            if (e >= 1) {
                                c += " ";
                            }
                            c += this.u(a);
                        }
                    }
                    break;
                case 9: throw new NotSupportedException(1, "shouldn't get here");
                case 5: return this.v(a);
                case 16:
                    {
                        let f = "";
                        let g = a.c;
                        for (let h = 0; h < g.count; h++) {
                            if (h >= 1) {
                                f += " ";
                            }
                            f += this.v(a);
                        }
                    }
                    break;
                case 20:
                    if (a.a != null) {
                        return this.af(a);
                    }
                    if (a.c == null) {
                        return this.ad();
                    }
                    break;
                case 15: throw new NotSupportedException(1, "need to figure this out");
                case 3: throw new NotSupportedException(1, "need to figure this out");
                case 19:
                    if (a.a != null) {
                        return this.aa(a);
                    }
                    else {
                        return this.ad();
                    }
                    break;
                case 8:
                    if (a.b.specificExternalType == "string") {
                        return this.z(a);
                    }
                    if (a.a != null) {
                        return this.ab(a);
                    }
                    throw new NotSupportedException(1, "shouldn't get here");
                case 13: throw new NotSupportedException(1, "shouldn't get here");
                case 18:
                    if (a.a != null) {
                        return this.ac(a);
                    }
                    else {
                        return this.ad();
                    }
                    break;
                case 1: return a.c.toString();
                case 11:
                    {
                        let i = a.c;
                        return i.x + ", " + i.y;
                    }
                case 14:
                    {
                        let j = a.c;
                        return j.left + ", " + j.top + ", " + j.width + ", " + j.height;
                    }
                case 12:
                    {
                        let k = a.c;
                        return k.width + ", " + k.height;
                    }
                case 2: return a.c != null ? a.c.toString() : this.ad();
                case 21: return a.c.toString();
                case 17:
                    if (a.c == null) {
                        return "null";
                    }
                    if (typeof a.c === 'string') {
                        return "\"" + a.c.toString() + "\"";
                    }
                    return a.c.toString();
                case 0: throw new NotSupportedException(1, "shouldn't get here");
            }
            return "";
        }
        t(a) {
            return a.c;
        }
        af(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                if (a.a.a) {
                    return this.y(a);
                }
                else {
                    return this.ae(a);
                }
            }
            return this.ad();
        }
        ae(a) {
            return "";
        }
        y(a) {
            return "";
        }
        ab(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                return a.a.e;
            }
            return this.ad();
        }
        z(a) {
            return a.c != null ? a.c.toString() : "";
        }
        ac(a) {
            return this.aa(a);
        }
        aa(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.ax(a);
                return a.a.e;
            }
            return this.ad();
        }
        get_o() {
            return false;
        }
        get o() {
            return this.get_o();
        }
        v(a) {
            let b = a.c;
            return ColorUtil.i(b, this.o);
        }
        u(a) {
            if (a.c == null) {
                return "";
            }
            let b = a.c;
            return ColorUtil.i(b.color, this.o);
        }
        av(a) {
            this.r.h(a);
        }
        get_ai() {
            return "";
        }
        get ai() {
            return this.get_ai();
        }
        get w() {
            if (this.r.f > 0) {
                return this.r.d();
            }
            let a = stringReplace(stringReplace(this.x, this.ai, ""), "Component", "");
            return CodeGeneratingComponentRenderer.dm(a);
        }
        get n() {
            return this.s.f == 1;
        }
        get l() {
            if (this.r.f > 0) {
                return true;
            }
            return false;
        }
        au() {
            this.r.e();
        }
        an(a) {
            a.u(this.f.toString());
        }
        aq(a) {
            a.u(this.g.toString());
        }
        am(a) {
            a.u(this.e.toString());
        }
        ao(a) {
            if (this.q.count > 0) {
                this.ap(this.q, a);
            }
        }
        ap(a, b) {
        }
    }
    CodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRendererCodeEmitter, 'CodeGeneratingComponentRendererCodeEmitter');
    return CodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let ReactMarkupCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class ReactMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
            this.ay = new HashSet$1(String_$type, 0);
            this.az = new HashSet$1(String_$type, 0);
        }
        get_o() {
            return true;
        }
        get_ai() {
            return "Igr";
        }
        al(a) {
            super.al(a);
            this.h.j("<" + this.a1(a) + "");
            if (!this.ay.contains(this.w)) {
                this.ay.add_1(this.w);
                if (!this.az.contains(this.x)) {
                    this.az.add_1(this.x);
                    this.ak(this.x);
                }
                this.f.j("private " + CodeGeneratingComponentRenderer.dm(this.w) + ": " + this.x);
                if (this.n) {
                    this.f.j("private " + CodeGeneratingComponentRenderer.dm(this.w) + "Ref(r: " + this.x + ") {");
                    this.f.g();
                    this.f.j("this." + CodeGeneratingComponentRenderer.dm(this.w) + " = r;");
                    this.f.j("this.setState({});");
                    this.f.e();
                    this.f.j("}");
                    this.g.j("this." + CodeGeneratingComponentRenderer.dm(this.w) + "Ref = " + "this." + CodeGeneratingComponentRenderer.dm(this.w) + "Ref.bind(this);");
                }
            }
        }
        a1(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.dn(a);
        }
        aw() {
            if (!this.n && !this.l) {
                let a = this.a0();
                this.h.j("name=\"" + a + "\"");
            }
            this.h.j(">");
            this.h.g();
        }
        a0() {
            let a = CodeGeneratingComponentRenderer.dm(stringReplace(stringReplace(this.x, this.ai, ""), "Component", ""));
            a = this.j.k(a);
            return a;
        }
        aa(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.ax(a);
                if (!this.ay.contains(a.a.e)) {
                    this.g.j("this." + CodeGeneratingComponentRenderer.dm(a.a.e) + " = " + "this." + CodeGeneratingComponentRenderer.dm(a.a.e) + ".bind(this);");
                }
                return "this." + CodeGeneratingComponentRenderer.dm(a.a.e);
            }
            return this.ad();
        }
        at(a) {
            this.h.e();
            this.h.j("</" + this.a1(a) + ">");
            super.at(a);
        }
        ar(a, b, c) {
            let d = CodeGeneratingComponentRenderer.dm(a);
            let e = this.ag(b, true);
            if (b.b != null && c.f(b.b.owningType, CodeGeneratingComponentRenderer.dn(b.b.propertyName)) && this.m(b)) {
                this.ax(b);
                if (b.a == null || b.a.e == null) {
                    this.h.j(d + "Name={null}");
                }
                else {
                    this.h.j(d + "Name=\"" + b.a.e + "\"");
                }
                return;
            }
            if (!(d == "name") || !this.n) {
                if (this.m(b)) {
                    this.ax(b);
                    e = "{" + e + "}";
                }
                this.h.i(d);
                this.h.i("=");
                if (!this.m(b)) {
                    this.h.i("\"");
                }
                this.h.i(e);
                if (!this.m(b)) {
                    this.h.i("\"");
                }
                this.h.h();
            }
            if (d == "name") {
                if (this.n) {
                    this.h.j("ref={this." + this.ag(b, true) + "Ref}");
                }
            }
        }
        t(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        ad() {
            return "null";
        }
        y(a) {
            return "this." + CodeGeneratingComponentRenderer.dm(a.a.e);
        }
        ae(a) {
            return "this." + CodeGeneratingComponentRenderer.dm(a.a.e);
        }
        as(a, b, c) {
            if (b.b.knownType == 9) {
                let d = typeCast(IList_$type, b.c);
                if (d != null) {
                    for (let e of fromEn(d)) {
                        if (typeCast(CodeGenerationItemBuilder.$, e) !== null) {
                            let f = e;
                            f.n(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, b.c) !== null) {
                    let g = b.c;
                    g.n(this, false);
                }
            }
        }
        ap(a, b) {
            super.ap(a, b);
            b.u("import { " + stringJoin1(String_$type, ", ", a) + " } from 'igniteui-react-" + this.ah + "'");
        }
    }
    ReactMarkupCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(ReactMarkupCodeGeneratingComponentRendererCodeEmitter, 'ReactMarkupCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return ReactMarkupCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
            this.a0 = 0;
            this.ay = new HashSet$1(String_$type, 0);
            this.az = new HashSet$1(String_$type, 0);
        }
        get_o() {
            return true;
        }
        al(a) {
            super.al(a);
            this.h.j("<" + this.a1(a) + "");
            if (!this.ay.contains(this.w)) {
                this.ay.add_1(this.w);
                if (!this.az.contains(this.x)) {
                    this.az.add_1(this.x);
                    this.ak(this.x);
                }
                this.f.j("private " + CodeGeneratingComponentRenderer.dm(this.w) + ": " + this.x);
                if (!this.l) {
                    if (this.n) {
                        this.g.j("var " + CodeGeneratingComponentRenderer.dm(this.w) + " = this." + CodeGeneratingComponentRenderer.dm(this.w) + " = document.querySelector('" + CodeGeneratingComponentRenderer.dp(stringReplace(this.x, "Component", "")) + "') as " + this.x + ";");
                    }
                }
                else {
                    this.g.j("var " + CodeGeneratingComponentRenderer.dm(this.w) + " = this." + CodeGeneratingComponentRenderer.dm(this.w) + " = document.getElementById('" + this.w + "') as " + this.x + ";");
                }
            }
        }
        a1(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.dp(a);
        }
        aw() {
            this.h.j(">");
            this.h.g();
        }
        at(a) {
            this.h.e();
            this.h.j("</" + this.a1(a) + ">");
            super.at(a);
        }
        get_ai() {
            return "Igc";
        }
        ap(a, b) {
            super.ap(a, b);
            b.u("import { " + stringJoin1(String_$type, ", ", a) + " } from 'igniteui-webcomponents-" + this.ah + "'");
        }
        ar(a, b, c) {
            let d = CodeGeneratingComponentRenderer.dm(a);
            if (this.m(b)) {
                this.ax(b);
                if (!this.ay.contains(this.w)) {
                    this.ay.add_1(this.w);
                    if (!this.az.contains(this.x)) {
                        this.az.add_1(this.x);
                        this.ak(this.x);
                    }
                    this.f.j("private " + CodeGeneratingComponentRenderer.dm(this.w) + ": " + this.x);
                    if (!this.l) {
                        if (this.n) {
                            this.g.j("var " + CodeGeneratingComponentRenderer.dm(this.w) + " = this." + CodeGeneratingComponentRenderer.dm(this.w) + " = document.querySelector('" + CodeGeneratingComponentRenderer.dp(stringReplace(this.x, "Component", "")) + "') as " + this.x + ";");
                        }
                    }
                    else {
                        this.g.j("var " + CodeGeneratingComponentRenderer.dm(this.w) + " = this." + CodeGeneratingComponentRenderer.dm(this.w) + " = document.getElementById('" + this.w + "') as " + this.x + ";");
                    }
                }
                let e = CodeGeneratingComponentRenderer.dm(this.ag(b, true));
                this.e.j(CodeGeneratingComponentRenderer.dm(this.w) + "." + d + " = " + (e == "null" ? "null" : ("this." + e)));
                return;
            }
            this.h.i(CodeGeneratingComponentRenderer.dp(d));
            this.h.i("=");
            this.h.i("\"");
            this.h.i(this.ag(b, true));
            this.h.i("\"");
            this.h.h();
            if (d == "name") {
                this.h.j("id =\"" + this.ag(b, true) + "\"");
            }
        }
        t(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        ad() {
            return "null";
        }
        y(a) {
            return CodeGeneratingComponentRenderer.dm(a.a.e);
        }
        ae(a) {
            return CodeGeneratingComponentRenderer.dm(a.a.e);
        }
        aa(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.ax(a);
                if (!this.ay.contains(a.a.e)) {
                    this.g.j("this." + CodeGeneratingComponentRenderer.dm(a.a.e) + " = " + "this." + CodeGeneratingComponentRenderer.dm(a.a.e) + ".bind(this);");
                }
                return "this." + CodeGeneratingComponentRenderer.dm(a.a.e);
            }
            return this.ad();
        }
        as(a, b, c) {
            if (b.b.knownType == 9) {
                let d = typeCast(IList_$type, b.c);
                if (d != null) {
                    for (let e of fromEn(d)) {
                        if (typeCast(CodeGenerationItemBuilder.$, e) !== null) {
                            let f = e;
                            f.n(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, b.c) !== null) {
                    let g = b.c;
                    g.n(this, false);
                }
            }
        }
    }
    WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter, 'WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let TSCodeGeneratingComponentRendererDataEmitter = /*@__PURE__*/ (() => {
    class TSCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
        constructor(a, b) {
            super(a, b);
            this.af = new Dictionary$2(CodeGeneratingCodeWriter.$, Number_$type, 0);
            this.i.g();
        }
        r(a, b = false) {
            a = CodeGeneratingComponentRenderer.dn(a);
            a = stringReplace(a, "-", "_");
            if (b) {
                a += "Item";
            }
            return a;
        }
        q(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.dm(a);
        }
        aj(a) {
            a = stringReplace(a, "-", "_");
            return "_" + CodeGeneratingComponentRenderer.dm(a);
        }
        get_o() {
            return ".ts";
        }
        ae(a, b, c, d, e) {
            super.ae(a, b, c, d, e);
            let f = this.n(this.r(a, true), b, c);
            for (let g of fromEnum(f)) {
                this.w(g, d, e);
            }
            let h = 0;
            let i = this.af.tryGetValue(e, h);
            h = i.p1;
            if (h > 0) {
                e.i(", ");
            }
            h++;
            this.af.item(e, h);
            e.i(this.r(a, false));
            d.j("export class " + this.r(a, false) + " extends Array<" + this.r(a, true) + "> {");
            d.g();
            d.j("public constructor() {");
            d.g();
            d.j("super();");
        }
        aa(a) {
            super.aa(a);
            this.i.j("private " + this.aj(a) + ": " + this.r(a, false) + " = null;");
            this.i.j("public get " + this.q(a) + "(): " + this.r(a, false) + " {");
            this.i.g();
            this.i.j("if (this." + this.aj(a) + " == null)");
            this.i.j("{");
            this.i.g();
            this.i.j("this." + this.aj(a) + " = new " + this.r(a, false) + "();");
            this.i.e();
            this.i.j("}");
            this.i.j("return this." + this.aj(a) + ";");
            this.i.e();
            this.i.j("}");
            this.i.j("");
        }
        ab(a, b) {
            super.ab(a, b);
            this.i.j("private " + this.aj(a) + ": " + this.ag(b.e) + " = " + this.ah(b) + ";");
            this.i.j("public get " + this.q(a) + "(): " + this.ag(b.e) + " {");
            this.i.g();
            this.i.j("return this." + this.aj(a) + ";");
            this.i.e();
            this.i.j("}");
            this.i.j("");
        }
        ac(a, b, c, d) {
            super.ac(a, b, c, d);
            this.i.j("private " + this.aj(a) + ": " + this.r(a, false) + "Item = null;");
            this.i.j("public get " + this.q(a) + "(): " + this.r(a, false) + "Item {");
            this.i.g();
            this.i.j("if (this." + this.aj(a) + " == null)");
            this.i.j("{");
            this.i.g();
            this.i.j("this." + this.aj(a) + " = ");
            this.ak(this.r(a, true), b, c, d, this.i);
            this.i.j("}");
            this.i.j("return this." + this.aj(a) + ";");
            this.i.e();
            this.i.j("}");
            this.i.j("");
        }
        t(a, b) {
            b.i(a + ", " + a + "Item");
        }
        u(a, b) {
            this.h.j("import { " + b + " } from './" + a + "'");
        }
        w(a, b, c) {
            let d = 0;
            let e = this.af.tryGetValue(c, d);
            d = e.p1;
            if (d > 0) {
                c.i(", ");
            }
            d++;
            this.af.item(c, d);
            c.i(a.c);
            b.j("export class " + a.c + " {");
            b.g();
            b.j("public constructor(init: Partial<" + a.c + ">) {");
            b.g();
            b.j("Object.assign(this, init);");
            b.e();
            b.j("}");
            b.j("");
            for (let f = 0; f < a.a.length; f++) {
                let g = a.a[f];
                let h = a.b[f];
                b.j("public " + this.q(g) + ": " + this.ai(a, g, h) + ";");
            }
            b.e();
            b.j("");
            b.j("}");
        }
        ag(a) {
            switch (a) {
                case 1: return "boolean";
                case 0: return "number";
                case 2: return "string";
                case 3: return "any";
            }
            return "any";
        }
        ai(a, b, c) {
            if (c.d) {
                return a.c + "_" + this.q(b) + "[]";
            }
            else if (c.f) {
                return a.c + "_" + this.q(b);
            }
            else {
                switch (c.c) {
                    case 1: return "boolean";
                    case 0: return "number";
                    case 2: return "string";
                    case 3: return "any";
                }
            }
            return "any";
        }
        ad(a, b, c, d) {
            super.ad(a, b, c, d);
            d.e();
            d.j("}");
            d.e();
            d.j("}");
        }
        s(a, b, c, d, e, f) {
            super.s(a, b, c, d, e, f);
            f.i("this.push(");
            this.ak(this.r(a, true), b, c, d, f);
            f.j(");");
        }
        ak(a, b, c, d, e) {
            if (d == null) {
                e.i("null");
                return;
            }
            if (typeCast(JsonDictionaryArray.$, d) !== null) {
                let f = d;
                e.j("[");
                e.g();
                if (f.items != null && f.items.length > 0) {
                    for (let g = 0; g < f.items.length; g++) {
                        if (g > 0) {
                            e.j(",");
                        }
                        this.ak(a, b, c, f.items[g], e);
                    }
                }
                e.e();
                e.j("]");
            }
            else if (typeCast(JsonDictionaryObject.$, d) !== null) {
                let h = d;
                e.j("new " + a + "(");
                e.j("{");
                e.g();
                for (let i = 0; i < b.length; i++) {
                    let j = b[i];
                    let k = c[i];
                    if (i > 0) {
                        e.j(",");
                    }
                    e.i(this.q(j) + ": ");
                    if (k.d) {
                        let l = a + "_" + this.q(j) + "Item";
                        this.ak(l, k.a, k.b, h.item(j), e);
                    }
                    else if (k.f) {
                        let m = a + "_" + this.q(j);
                        this.ak(m, k.a, k.b, h.item(j), e);
                    }
                    else {
                        let n = h.item(j);
                        e.i(this.p(k, n));
                    }
                }
                e.j("");
                e.e();
                e.i("})");
            }
        }
        p(a, b) {
            switch (a.c) {
                case 1: return (b.value ? "true" : "false");
                case 0: return (b.value.toString());
                case 2: return ("`" + b.value + "`");
                case 3: return ("null");
            }
            return "";
        }
        ah(a) {
            switch (a.e) {
                case 1: return (a.value ? "true" : "false");
                case 0: return (a.value.toString());
                case 2: return ("`" + a.value + "`");
                case 3: return "null";
            }
            return "";
        }
    }
    TSCodeGeneratingComponentRendererDataEmitter.$t = /*@__PURE__*/ markType(TSCodeGeneratingComponentRendererDataEmitter, 'TSCodeGeneratingComponentRendererDataEmitter', CodeGeneratingComponentRendererDataEmitter.$);
    return TSCodeGeneratingComponentRendererDataEmitter;
})();
/**
 * @hidden
 */
let AngularTemplateCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class AngularTemplateCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
        }
        get_o() {
            return true;
        }
        get_ai() {
            return "Igx";
        }
        al(a) {
            super.al(a);
            this.h.j("<" + this.ay(a) + "");
        }
        ay(a) {
            if (stringEndsWith(a, "Component")) {
                a = a.substr(0, a.length - ("Component").length);
            }
            return CodeGeneratingComponentRenderer.dp(a);
        }
        aw() {
            this.h.j(">");
            this.h.g();
        }
        at(a) {
            this.h.e();
            this.h.j("</" + this.ay(a) + ">");
            super.at(a);
        }
        ar(a, b, c) {
            let d = CodeGeneratingComponentRenderer.dm(a);
            if (this.m(b)) {
                this.ax(b);
                d = "[" + d + "]";
            }
            this.h.i(d);
            this.h.i("=");
            this.h.i("\"");
            this.h.i(this.ag(b, true));
            this.h.i("\"");
            this.h.h();
            if (d == "name") {
                this.h.j("#" + CodeGeneratingComponentRenderer.dm(this.ag(b, true)));
            }
        }
        aa(a) {
            if (!stringIsNullOrEmpty(a.a.e)) {
                this.ax(a);
                return "this." + CodeGeneratingComponentRenderer.dm(a.a.e) + "($event)";
            }
            return this.ad();
        }
        t(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        ad() {
            return "null";
        }
        y(a) {
            return CodeGeneratingComponentRenderer.dm(a.a.e);
        }
        ae(a) {
            return CodeGeneratingComponentRenderer.dm(a.a.e);
        }
        as(a, b, c) {
            if (b.b.knownType == 9) {
                let d = typeCast(IList_$type, b.c);
                if (d != null) {
                    for (let e of fromEn(d)) {
                        if (typeCast(CodeGenerationItemBuilder.$, e) !== null) {
                            let f = e;
                            f.n(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, b.c) !== null) {
                    let g = b.c;
                    g.n(this, false);
                }
            }
        }
    }
    AngularTemplateCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(AngularTemplateCodeGeneratingComponentRendererCodeEmitter, 'AngularTemplateCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return AngularTemplateCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let DotNetCodeGeneratingComponentRendererDataEmitter = /*@__PURE__*/ (() => {
    class DotNetCodeGeneratingComponentRendererDataEmitter extends CodeGeneratingComponentRendererDataEmitter {
        constructor(a, b) {
            super(a, b);
            this.af = false;
            this.i.g();
            this.i.g();
        }
        u(a, b) {
            super.u(a, b);
            this.h.j("<Compile Include=\"" + a + ".cs\">");
            this.h.g();
            this.h.j("<SubType>Code</SubType>");
            this.h.e();
            this.h.j("</Compile>");
        }
        y(a) {
            a.j("using System;");
            a.j("using System.Collections.Generic;");
            if (!this.af) {
                this.af = true;
                this.g.j("using Data;");
            }
            a.j("namespace Data");
            a.j("{");
            a.g();
            super.y(a);
        }
        x(a) {
            a.e();
            a.j("}");
            super.x(a);
        }
        r(a, b = false) {
            a = CodeGeneratingComponentRenderer.dn(a);
            a = stringReplace(a, "-", "_");
            if (b) {
                a += "Item";
            }
            return a;
        }
        q(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.dn(a);
        }
        aj(a) {
            a = stringReplace(a, "-", "_");
            return "_" + CodeGeneratingComponentRenderer.dm(a);
        }
        ae(a, b, c, d, e) {
            super.ae(a, b, c, d, e);
            let f = this.n(this.r(a, true), b, c);
            for (let g of fromEnum(f)) {
                this.w(g, d, e);
            }
            d.j("public class " + this.r(a, false));
            d.g();
            d.j(": List<" + this.r(a, true) + ">");
            d.e();
            d.j("{");
            d.g();
            d.j("public " + this.r(a, false) + "()");
            d.j("{");
            d.g();
        }
        aa(a) {
            super.aa(a);
            this.i.j("private " + this.r(a, false) + " " + this.aj(a) + " = null;");
            this.i.j("public " + this.r(a, false) + " " + this.q(a));
            this.i.j("{");
            this.i.g();
            this.i.j("get");
            this.i.j("{");
            this.i.g();
            this.i.j("if (" + this.aj(a) + " == null)");
            this.i.j("{");
            this.i.g();
            this.i.j(this.aj(a) + " = new " + this.r(a, false) + "();");
            this.i.e();
            this.i.j("}");
            this.i.j("return " + this.aj(a) + ";");
            this.i.e();
            this.i.j("}");
            this.i.e();
            this.i.j("}");
            this.i.j("");
        }
        ab(a, b) {
            super.ab(a, b);
            this.i.j("private " + this.ag(b.e) + " " + this.aj(a) + " = " + this.ah(b) + ";");
            this.i.j("public " + this.ag(b.e) + " " + this.q(a));
            this.i.j("{");
            this.i.g();
            this.i.j("get");
            this.i.j("{");
            this.i.g();
            this.i.j("return " + this.aj(a) + ";");
            this.i.e();
            this.i.j("}");
            this.i.e();
            this.i.j("}");
            this.i.j("");
        }
        ac(a, b, c, d) {
            super.ac(a, b, c, d);
            this.i.j("private " + this.r(a, false) + "Item " + this.aj(a) + " = null;");
            this.i.j("public " + this.r(a, false) + "Item " + this.q(a));
            this.i.j("{");
            this.i.g();
            this.i.j("get");
            this.i.j("{");
            this.i.g();
            this.i.j("if (" + this.aj(a) + " == null)");
            this.i.j("{");
            this.i.g();
            this.i.j("_" + a + " = ");
            this.ak(this.r(a, true), b, c, d, this.i);
            this.i.j("}");
            this.i.j("return " + this.aj(a) + ";");
            this.i.e();
            this.i.j("}");
            this.i.e();
            this.i.j("}");
            this.i.j("");
        }
        get_o() {
            return ".cs";
        }
        w(a, b, c) {
            b.j("public class " + a.c);
            b.j("{");
            b.g();
            for (let d = 0; d < a.a.length; d++) {
                let e = a.a[d];
                let f = a.b[d];
                b.j("public " + this.ai(a, e, f) + " " + this.q(e) + "{ get; set; }");
            }
            b.e();
            b.j("}");
        }
        ag(a) {
            switch (a) {
                case 1: return "bool";
                case 0: return "double";
                case 2: return "string";
                case 3: return "object";
            }
            return "object";
        }
        ai(a, b, c) {
            if (c.d) {
                return "List<" + a.c + "_" + this.q(b) + "Item>";
            }
            else if (c.f) {
                return a.c + "_" + this.q(b);
            }
            else {
                switch (c.c) {
                    case 1: return "bool";
                    case 0: return "double";
                    case 2: return "string";
                    case 3: return "object";
                }
            }
            return "object";
        }
        ad(a, b, c, d) {
            super.ad(a, b, c, d);
            d.e();
            d.j("}");
            d.e();
            d.j("}");
        }
        s(a, b, c, d, e, f) {
            super.s(a, b, c, d, e, f);
            f.i("this.Add(");
            this.ak(this.r(a, true), b, c, d, f);
            f.j(");");
        }
        ak(a, b, c, d, e) {
            if (d == null) {
                e.i("null");
                return;
            }
            if (typeCast(JsonDictionaryArray.$, d) !== null) {
                let f = d;
                e.j("new List<" + a + ">()");
                e.j("{");
                e.g();
                if (f.items != null && f.items.length > 0) {
                    for (let g = 0; g < f.items.length; g++) {
                        if (g > 0) {
                            e.j(",");
                        }
                        this.ak(a, b, c, f.items[g], e);
                    }
                }
                e.e();
                e.j("}");
            }
            else if (typeCast(JsonDictionaryObject.$, d) !== null) {
                let h = d;
                e.j("new " + a + "()");
                e.j("{");
                e.g();
                for (let i = 0; i < b.length; i++) {
                    let j = b[i];
                    let k = c[i];
                    if (i > 0) {
                        e.j(",");
                    }
                    e.i(j + " = ");
                    if (k.d) {
                        let l = a + "_" + this.q(j) + "Item";
                        this.ak(l, k.a, k.b, h.item(j), e);
                    }
                    else if (k.f) {
                        let m = a + "_" + this.q(j);
                        this.ak(m, k.a, k.b, h.item(j), e);
                    }
                    else {
                        let n = h.item(j);
                        e.i(this.p(k, n));
                    }
                }
                e.j("");
                e.e();
                e.i("}");
            }
        }
        p(a, b) {
            switch (a.c) {
                case 1: return (b.value ? "true" : "false");
                case 0: return (b.value.toString());
                case 2: return ("@\"" + stringReplace(b.value, "\"", "\"\"") + "\"");
                case 3: return ("null");
            }
            return "";
        }
        ah(a) {
            switch (a.e) {
                case 1: return (a.value ? "true" : "false");
                case 0: return (a.value.toString());
                case 2: return ("@\"" + stringReplace(a.value, "\"", "\"\"") + "\"");
                case 3: return "null";
            }
            return "";
        }
    }
    DotNetCodeGeneratingComponentRendererDataEmitter.$t = /*@__PURE__*/ markType(DotNetCodeGeneratingComponentRendererDataEmitter, 'DotNetCodeGeneratingComponentRendererDataEmitter', CodeGeneratingComponentRendererDataEmitter.$);
    return DotNetCodeGeneratingComponentRendererDataEmitter;
})();
/**
 * @hidden
 */
let WPFXamlCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WPFXamlCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
        }
        al(a) {
            super.al(a);
            this.h.j("<ig:" + a + "");
        }
        aw() {
            this.h.j(">");
            this.h.g();
        }
        at(a) {
            this.h.e();
            this.h.j("</ig:" + a + ">");
            super.at(a);
        }
        ar(a, b, c) {
            if (a == "Label" && b.b != null && stringContains(b.b.owningType, "Axis")) {
                if (b.c != null && stringContains(b.c, "{")) {
                    this.h.i(a);
                    this.h.i("=");
                    this.h.i("\"");
                    this.h.i("{}" + this.ag(b, true));
                    this.h.i("\"");
                    this.h.h();
                    return;
                }
            }
            this.h.i(a);
            this.h.i("=");
            this.h.i("\"");
            this.h.i(this.ag(b, true));
            this.h.i("\"");
            this.h.h();
        }
        t(a) {
            let b = a.c;
            switch (b.a) {
                case 3: return b.b;
                case 0: return b.b;
                case 1: return b.b;
                case 2: return b.b;
            }
            return b.b;
        }
        ad() {
            return "{x:Null}";
        }
        y(a) {
            return "{Binding ElementName=" + this.ay(a.a.e) + "}";
        }
        ay(a) {
            a = stringReplace(a, "-", "_");
            return CodeGeneratingComponentRenderer.dn(a);
        }
        ae(a) {
            this.ax(a);
            return "{Binding " + this.ay(a.a.e) + "}";
        }
        as(a, b, c) {
            this.h.i("<ig:");
            {
                this.h.i(this.x);
                this.h.i(".");
            }
            this.h.i(a);
            this.h.j(">");
            this.h.g();
            if (b.b.knownType == 9) {
                let d = typeCast(IList_$type, b.c);
                if (d != null) {
                    for (let e of fromEn(d)) {
                        if (typeCast(CodeGenerationItemBuilder.$, e) !== null) {
                            let f = e;
                            f.n(this, false);
                        }
                    }
                }
            }
            else {
                if (typeCast(CodeGenerationItemBuilder.$, b.c) !== null) {
                    let g = b.c;
                    g.n(this, false);
                }
            }
            this.h.e();
            this.h.i("</ig:");
            {
                this.h.i(this.x);
                this.h.i(".");
            }
            this.h.i(a);
            this.h.j(">");
        }
        get_ai() {
            return "Xam";
        }
    }
    WPFXamlCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WPFXamlCodeGeneratingComponentRendererCodeEmitter, 'WPFXamlCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WPFXamlCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter = /*@__PURE__*/ (() => {
    class WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter extends CodeGeneratingComponentRendererCodeEmitter {
        constructor(a, b) {
            super(a, b);
        }
    }
    WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter.$t = /*@__PURE__*/ markType(WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter, 'WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter', CodeGeneratingComponentRendererCodeEmitter.$);
    return WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter;
})();
/**
 * @hidden
 */
let CodeGeneratingComponentRenderer = /*@__PURE__*/ (() => {
    class CodeGeneratingComponentRenderer extends ComponentRenderer {
        constructor(a, b) {
            super();
            this.dg = null;
            this.dh = 0;
            this.di = null;
            this.dj = null;
            this.dk = null;
            this.dg = b;
            this.dh = a;
            ComponentRenderer.platform = this.dl(a);
            this.e = new CodeGenerationRendererAdapter(a, this.e);
            this.context = new TypeDescriptionContext(this.e, ComponentRenderer.platform);
            this.g = new CodeGenerationTransformer(a);
        }
        loadCodeJson(a) {
            this.loadJson(a, (b) => ((() => {
                let $ret = new CodeGenerationContainer();
                $ret.id = b;
                return $ret;
            })()));
        }
        static dm(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toLowerCase();
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        static dn(a) {
            if (a == null) {
                return null;
            }
            if (a.length == 1) {
                return a.toUpperCase();
            }
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        static dp(a) {
            if (a == null) {
                return null;
            }
            let b = new List$1(String_$type, 0);
            let c = 0;
            for (let d = 0; d < a.length; d++) {
                let e = a.charAt(d);
                let f = e.toUpperCase();
                let g = e.toLowerCase();
                let h = (c == 0 && b.count > 0);
                let i = (c > 1);
                if (f == e) {
                    if (h) {
                        b.add('-');
                    }
                    c++;
                }
                else if (g == e) {
                    if (i) {
                        b.insert(b.count - 1, '-');
                    }
                    c = 0;
                }
                else {
                    c = 0;
                }
                b.add(g);
            }
            let j = new StringBuilder(0);
            for (let k = 0; k < b.count; k++) {
                j.h(b._inner[k]);
            }
            return j.toString();
        }
        aj() {
            return true;
        }
        y(a) {
            super.y(a);
            this.di = a;
            return true;
        }
        ad(a) {
            super.ad(a);
            this.dk = a;
            return true;
        }
        z(a) {
            super.z(a);
            this.dj = a;
            return true;
        }
        db(a, b, c) {
            switch (this.dh) {
                case 1: if (b.forceCodeBehind) {
                    return new AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new AngularTemplateCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 2: if (b.forceCodeBehind) {
                    return new ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new ReactMarkupCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 3: if (b.forceCodeBehind) {
                    return new WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                case 4: break;
                case 0: if (b.forceCodeBehind) {
                    return new WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
                else {
                    return new WPFXamlCodeGeneratingComponentRendererCodeEmitter(b, c);
                }
            }
            return null;
        }
        dc(a, b) {
            switch (this.dh) {
                case 1: return new TSCodeGeneratingComponentRendererDataEmitter(a, b);
                case 2: return new TSCodeGeneratingComponentRendererDataEmitter(a, b);
                case 3: return new TSCodeGeneratingComponentRendererDataEmitter(a, b);
                case 4: break;
                case 0: return new DotNetCodeGeneratingComponentRendererDataEmitter(a, b);
            }
            return null;
        }
        dd(a, b) {
            switch (this.dh) {
                case 1: return new TSCodeGeneratingComponentRendererHandlerEmitter(a, b);
                case 2: return new TSCodeGeneratingComponentRendererHandlerEmitter(a, b);
                case 3: return new TSCodeGeneratingComponentRendererHandlerEmitter(a, b);
                case 4: break;
                case 0: return new DotNetCodeGeneratingComponentRendererHandlerEmitter(a, b);
            }
            return null;
        }
        de(a, b) {
            switch (this.dh) {
                case 1: return new TSCodeGeneratingComponentRendererModuleEmitter(this.dh, a, b);
                case 2: return new TSCodeGeneratingComponentRendererModuleEmitter(this.dh, a, b);
                case 3: return new TSCodeGeneratingComponentRendererModuleEmitter(this.dh, a, b);
                case 4: break;
                case 0: return new DotNetCodeGeneratingComponentRendererModuleEmitter(a, b);
            }
            return null;
        }
        emitCode(a) {
            let b = new CodeGeneratingRendererResult();
            b.platform = this.dh;
            for (let c of fromEnum(this.ay.keys)) {
                let d = c;
                d.c(b, this, this.dg);
            }
            if (this.di != null) {
                let e = this.de(this.dg, b);
                e.l(this.di);
            }
            if (this.dk != null) {
                if (typeCast(JsonDictionaryObject.$, this.dk) !== null) {
                    let f = this.dk;
                    let i = f.e();
                    for (let h = 0; h < i.length; h++) {
                        let g = i[h];
                        b.defineString(g, f.item(g).value);
                    }
                }
            }
            if (this.dj != null) {
                let j = this.dc(this.dg, b);
                j.v(this.dj);
            }
            let k = this.dd(this.dg, b);
            k.h();
            this.dt(b, a);
            return b;
        }
        dt(a, b) {
            b.execute(a);
        }
        a3() {
            return runOn(this, this.dr);
        }
        dq(a) {
            a = stringReplace(a, "-", "_");
            switch (this.dh) {
                case 1:
                case 2:
                case 3: return CodeGeneratingComponentRenderer.dm(a);
                case 4:
                case 0: return CodeGeneratingComponentRenderer.dn(a);
            }
            return a;
        }
        dr(a) {
            let b = a;
            if (stringStartsWith(a, "{")) {
                if (!stringStartsWith(a, "{[")) {
                    a = a.substr(1, a.length - 2);
                    a = "{" + this.dq(a) + "}";
                    b = a;
                }
            }
            else {
                b = this.dq(a);
            }
            return b;
        }
        dl(a) {
            switch (a) {
                case 1: return 3;
                case 2: return 2;
                case 3: return 4;
                case 4: return 8;
                case 0: return 0;
            }
            return 0;
        }
    }
    CodeGeneratingComponentRenderer.$t = /*@__PURE__*/ markType(CodeGeneratingComponentRenderer, 'CodeGeneratingComponentRenderer', ComponentRenderer.$);
    return CodeGeneratingComponentRenderer;
})();
/**
 * @hidden
 */
let CodeGenerationContainer = /*@__PURE__*/ (() => {
    class CodeGenerationContainer extends Base {
        constructor() {
            super();
            this._id = null;
            this.a = null;
            this.a = new List$1(CodeGenerationItemBuilder.$, 0);
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        c(a, b, c) {
            let d = new StringBuilder(0);
            let e = new StringBuilder(0);
            let f = new StringBuilder(0);
            let g = new StringBuilder(0);
            for (let h of fromEnum(this.a)) {
                let i = b.db(h, c, a);
                h.n(i, true);
                let j = i.toString();
                a.addContainerResult(this.id, j);
                i.an(d);
                i.aq(e);
                i.am(f);
                i.ao(g);
            }
            a.addContainerResult("bindingFields", d.toString());
            a.addContainerResult("bindingInit", e.toString());
            a.addContainerResult("bindingCode", f.toString());
            a.addContainerResult("bindingImports", g.toString());
        }
    }
    CodeGenerationContainer.$t = /*@__PURE__*/ markType(CodeGenerationContainer, 'CodeGenerationContainer');
    return CodeGenerationContainer;
})();
/**
 * @hidden
 */
let CodeGenerationItemBuilder = /*@__PURE__*/ (() => {
    class CodeGenerationItemBuilder extends Base {
        constructor(a, b, c, d) {
            super();
            this.e = new Dictionary$2(String_$type, CodeGenerationItemBuilderPropertyInfo.$, 0);
            this.c = null;
            this.b = 0;
            this.h = null;
            this.f = null;
            this.b = a;
            this.h = b;
            this.c = c;
            this.f = d;
        }
        a(a) {
            let b = this.c.d(this.h, a);
            return new CodeGenerationItemBuilder(this.b, this.m(b), this.c, this.f);
        }
        m(a) {
            return a.specificExternalType != null ? a.specificExternalType : a.specificType;
        }
        q(a, b, c, d) {
            this.e.item(a, ((() => {
                let $ret = new CodeGenerationItemBuilderPropertyInfo();
                $ret.b = b;
                $ret.c = c;
                $ret.a = d;
                return $ret;
            })()));
        }
        o(a, b, c) {
            let d = null;
            if (this.e.containsKey(a)) {
                let e = this.e.item(a);
                d = e.c;
            }
            this.e.item(a, ((() => {
                let $ret = new CodeGenerationItemBuilderPropertyInfo();
                $ret.b = b;
                $ret.c = d;
                $ret.a = c;
                return $ret;
            })()));
        }
        p(a, b) {
            if (this.e.containsKey(a)) {
                this.e.removeItem(a);
            }
        }
        g(a) {
            if (this.e.containsKey(a)) {
                return this.e.item(a).c;
            }
            return null;
        }
        n(a, b) {
            let c = this.k();
            if (b) {
                let d = this.l();
                a.ah = d;
            }
            let e = false;
            if (this.e.containsKey("Name")) {
                e = true;
                a.av(this.e.item("Name").c);
            }
            if (this.e.containsKey("name")) {
                e = true;
                a.av(this.e.item("name").c);
            }
            a.al(c);
            for (let f of fromEnum(this.e.keys)) {
                let g = this.e.item(f);
                if (g.b == null && f.toLowerCase() == "type") {
                    continue;
                }
                if (this.d(f, g)) {
                    a.ar(f, g, this.c);
                }
            }
            a.aw();
            for (let h of fromEnum(this.e.keys)) {
                let i = this.e.item(h);
                if (i.b == null && h.toLowerCase() == "type") {
                    continue;
                }
                if (!this.d(h, i)) {
                    a.as(h, i, this.c);
                }
            }
            a.at(c);
            if (e) {
                a.au();
            }
        }
        d(a, b) {
            if (b.b == null) {
                if (a.toLowerCase() == "name") {
                    return true;
                }
            }
            switch (b.b.knownType) {
                case 10:
                case 7: return true;
                case 4: return b.c == null || !(typeCast(LinearGradientBrush.$, b.c) !== null);
                case 6:
                    return true;
                    break;
                case 9: return false;
                case 5: return true;
                case 16: return true;
                case 20: return true;
                case 15: return false;
                case 3: return true;
                case 19: return true;
                case 8:
                    if (b.b.specificExternalType == "string") {
                        return true;
                    }
                    if (b.a != null) {
                        return true;
                    }
                    return false;
                case 13: return false;
                case 18: return true;
                case 1: return true;
                case 11: return true;
                case 14: return true;
                case 12: return true;
                case 2: return true;
                case 21: return true;
                case 17: return true;
                case 0: return false;
            }
            return false;
        }
        k() {
            if (this.b == 0 || this.b == 4) {
                let a = this.c.d(this.h, "_qualifiedName");
                if (a != null) {
                    let b = a.specificExternalType;
                    let c = b.lastIndexOf('.');
                    if (c >= 0) {
                        return b.substr(c + 1);
                    }
                    else {
                        return b;
                    }
                }
                return this.h;
            }
            else {
                return this.i + this.h + this.j;
            }
        }
        l() {
            let a = this.c.d(this.h, "_qualifiedName");
            if (a != null) {
                let b = a.specificExternalType;
                let c = b.split('.');
                if (c.length > 2) {
                    return c[c.length - 2].toLowerCase();
                }
            }
            if (this.h == "Legend" || this.h == "ItemLegend") {
                return "charts";
            }
            return "core";
        }
        get_i() {
            switch (this.b) {
                case 1: return "Igx";
                case 2: return "Igr";
                case 3: return "Igc";
                case 4: return "Ultra";
                case 0: return "Xam";
            }
            return "";
        }
        get i() {
            return this.get_i();
        }
        get_j() {
            switch (this.b) {
                case 1: return "Component";
                case 2: return "";
                case 3: return "Component";
                case 4: return "";
                case 0: return "";
            }
            return "";
        }
        get j() {
            return this.get_j();
        }
    }
    CodeGenerationItemBuilder.$t = /*@__PURE__*/ markType(CodeGenerationItemBuilder, 'CodeGenerationItemBuilder');
    return CodeGenerationItemBuilder;
})();
/**
 * @hidden
 */
let CodeGenerationRendererAdapter = /*@__PURE__*/ (() => {
    class CodeGenerationRendererAdapter extends Base {
        constructor(a, b) {
            super();
            this.a = 0;
            this.b = null;
            this.b = b;
            this.a = a;
        }
        createColorCollection(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.length; c++) {
                b.add1(a[c]);
            }
            return b;
        }
        createBrushCollection(a) {
            let b = new List$1(Base.$, 0);
            for (let c = 0; c < a.length; c++) {
                b.add1(a[c]);
            }
            return b;
        }
        createObject(a, b, c) {
            let d = new CodeGenerationItemBuilder(this.a, a, c, b);
            return d;
        }
        coerceToEnum(a, b, c) {
            return c;
        }
        onUIThread(a, b) {
            b();
        }
        setOrUpdateCollectionOnTarget(a, b, c, d, e, f) {
            let g = this.getPropertyValue(e, b);
            if (g == null) {
                let h = new List$1(Base.$, 0);
                let i = f;
                for (let j = 0; j < i.count; j++) {
                    h.add1(i.item(j));
                }
                this.setPropertyValue(e, b, c, h, null, null);
            }
            else {
                let k = f;
                let l = g;
                l.clear();
                for (let m = 0; m < k.count; m++) {
                    l.add(k.item(m));
                }
            }
        }
        c(a) {
            if (a == null) {
                return false;
            }
            return false;
        }
        onPendingRef(a, b, c, d) {
            let e = a;
            e.o(b, c, d);
        }
        setPropertyValue(a, b, c, d, e, f) {
            if (!(typeCast(CodeGenerationItemBuilder.$, a) !== null)) {
                this.b.setPropertyValue(a, b, c, d, e, f);
                return;
            }
            while (stringContains(b, ".")) {
                let g = b.split('.');
                let h = this.getPropertyValue(a, g[0]);
                if (h != null && !this.c(h)) {
                    b = "";
                    for (let i = 1; i < g.length; i++) {
                        if (i > 1) {
                            b += ".";
                        }
                        b += g[i];
                    }
                    a = h;
                }
                else {
                    let j = a;
                    let k = j.a(g[0]);
                    h = k;
                    this.setPropertyValue(a, g[0], c, h, null, f);
                    b = "";
                    for (let l = 1; l < g.length; l++) {
                        if (l > 1) {
                            b += ".";
                        }
                        b += g[l];
                    }
                    a = h;
                }
            }
            let m = a;
            m.q(b, c, d, f);
        }
        getPropertyValue(a, b) {
            while (stringContains(b, ".")) {
                let c = b.split('.');
                let d = this.getPropertyValue(a, c[0]);
                if (d != null) {
                    b = "";
                    for (let e = 1; e < c.length; e++) {
                        if (e > 1) {
                            b += ".";
                        }
                        b += c[e];
                    }
                    a = d;
                }
                else {
                    let f = a;
                    let g = f.a(c[0]);
                    d = g;
                    for (let h = 1; h < c.length; h++) {
                        if (h > 1) {
                            b += ".";
                        }
                        b += c[h];
                    }
                    a = d;
                }
            }
            let i = a;
            return i.g(b);
        }
        getRootObject(a) {
            let b = a;
            let c = b.a.count > 0 ? b.a._inner[0] : null;
            return c;
        }
        clearContainer(a, b, c) {
            let d = a;
            let e = d.a.count > 0 ? d.a._inner[0] : null;
            d.a.clear();
            c(false);
        }
        forPropertyValueItem(a, b, c) {
            let d = this.getPropertyValue(a, b);
            if (typeCast(IList_$type, d) !== null) {
                let e = d;
                for (let f = 0; f < e.count; f++) {
                    c(e.item(f));
                }
            }
            else if (typeCast(Array_$type, d) !== null) {
                let g = d;
                for (let h = 0; h < g.length; h++) {
                    c(g[h]);
                }
            }
        }
        clearCollection(a, b, c) {
            let d = this.getPropertyValue(a, b);
            if (typeCast(IList_$type, d) !== null) {
                d.clear();
            }
            else if (typeCast(Array_$type, d) !== null) {
                this.setPropertyValue(a, b, c, null, d, null);
            }
        }
        addItemToCollection(a, b, c, d, e) {
            let f = this.getPropertyValue(c, a);
            if (typeCast(IList_$type, f) !== null) {
                f.insert(d, e);
            }
            else if (typeCast(Array_$type, f) !== null) {
                let g = f;
                let h = new List$1(Base.$, 0);
                for (let i = 0; i < g.count; i++) {
                    h.add1(g.item(i));
                }
                h.insert1(d, e);
                let j = [g.count + 1];
                for (let k = 0; k < j.length; k++) {
                    j[k] = h._inner[k];
                }
                this.setPropertyValue(c, a, b, j, f, null);
            }
        }
        resetPropertyOnTarget(a, b, c, d) {
            while (stringContains(b, ".")) {
                let e = b.split('.');
                let f = this.getPropertyValue(d, e[0]);
                if (f != null && !this.c(f)) {
                    b = "";
                    for (let g = 1; g < e.length; g++) {
                        if (g > 1) {
                            b += ".";
                        }
                        b += e[g];
                    }
                    d = f;
                }
                else {
                    let h = d;
                    let i = h.a(e[0]);
                    f = i;
                    this.setPropertyValue(d, e[0], c, f, null, null);
                    b = "";
                    for (let j = 1; j < e.length; j++) {
                        if (j > 1) {
                            b += ".";
                        }
                        b += e[j];
                    }
                    d = f;
                }
            }
            let k = d;
            k.p(b, c);
        }
        replaceItemInCollection(a, b, c, d, e) {
            let f = this.getPropertyValue(c, a);
            if (typeCast(IList_$type, f) !== null) {
                f.item(d, e);
            }
            else if (typeCast(Array_$type, f) !== null) {
                let g = f;
                let h = new List$1(Base.$, 0);
                for (let i = 0; i < g.count; i++) {
                    h.add1(g.item(i));
                }
                h._inner[d] = e;
                let j = [g.count + 1];
                for (let k = 0; k < j.length; k++) {
                    j[k] = h._inner[k];
                }
                this.setPropertyValue(c, a, b, j, f, null);
            }
        }
        replaceRootItem(a, b, c, d) {
            let e = this.createObject(b, a, c);
            let f = a;
            let g = f.a.count > 0 ? f.a._inner[0] : null;
            f.a.clear();
            {
                f.a.add(e);
            }
            d(false);
        }
        removeItemFromCollection(a, b, c, d) {
            let e = this.getPropertyValue(c, a);
            if (typeCast(IList_$type, e) !== null) {
                e.removeAt(d);
            }
            else if (typeCast(Array_$type, e) !== null) {
                let f = e;
                let g = new List$1(Base.$, 0);
                for (let h = 0; h < f.count; h++) {
                    g.add1(f.item(h));
                }
                g.removeAt(d);
                let i = [f.count - 1];
                for (let j = 0; j < i.length; j++) {
                    i[j] = g._inner[j];
                }
                this.setPropertyValue(c, a, b, i, e, null);
            }
        }
        removeRootItem(a, b, c) {
            let d = a;
            let e = d.a.count > 0 ? d.a._inner[0] : null;
            d.a.clear();
            c(false);
        }
        flushChanges(a) {
        }
    }
    CodeGenerationRendererAdapter.$t = /*@__PURE__*/ markType(CodeGenerationRendererAdapter, 'CodeGenerationRendererAdapter', Base.$, [IComponentRendererAdapter_$type]);
    return CodeGenerationRendererAdapter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICodeGenerationRendererTemplate_$type = /*@__PURE__*/ new Type(null, 'ICodeGenerationRendererTemplate');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationFolderTemplate = /*@__PURE__*/ (() => {
    class CodeGenerationFolderTemplate extends Base {
        constructor() {
            super(...arguments);
            this.d = new List$1(String_$type, 0);
            this.b = new List$1(String_$type, 0);
            this.c = new List$1(String_$type, 0);
        }
        i(a, b) {
            this.d.add(a);
            this.b.add(b);
        }
        a() {
            return this.d.toArray();
        }
        e(a) {
            for (let b = 0; b < this.d.count; b++) {
                if (this.d._inner[b] == a) {
                    return this.c._inner[b];
                }
            }
            return null;
        }
        h() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("\"files\": [");
            for (let b = 0; b < this.d.count; b++) {
                if (b >= 1) {
                    a.u(",");
                }
                a.u("{");
                a.l("\"path\": \"");
                a.l(this.d._inner[b]);
                a.u("\"");
                a.l("\"content\": \"");
                a.l(stringReplace(this.b._inner[b], "\"", "\\\""));
                a.u("\"");
                a.u("}");
            }
            a.u("]");
            a.u("}");
            return a.toString();
        }
        j(a) {
            let b = new JsonDictionaryParser();
            let c = b.parse(a);
            if (typeCast(JsonDictionaryObject.$, c) !== null) {
                let d = c;
                if (d.g("files")) {
                    let e = d.item("Files");
                    if (typeCast(JsonDictionaryArray.$, e) !== null) {
                        let f = e;
                        for (let g = 0; g < f.items.length; g++) {
                            let h = f.items[g];
                            if (typeCast(JsonDictionaryObject.$, h) !== null) {
                                let i = h;
                                if (i.g("path") && i.g("content")) {
                                    this.d.add(i.item("path").value.toString());
                                    this.b.add(i.item("content").value.toString());
                                }
                            }
                        }
                    }
                }
            }
        }
        execute(a) {
            this.c.clear();
            for (let b = 0; b < this.b.count; b++) {
                this.c.add(this.b._inner[b]);
            }
            let c = a.getKeys();
            let d = new HashSet$1(String_$type, 0);
            for (let e = 0; e < c.length; e++) {
                d.add_1(c[e]);
            }
            for (let f = 0; f < this.b.count; f++) {
                let g = this.c._inner[f];
                g = this.f(g, d);
                this.c._inner[f] = g;
            }
            let j = a.getKeys();
            for (let i = 0; i < j.length; i++) {
                let h = j[i];
                for (let k = 0; k < this.b.count; k++) {
                    let l = this.c._inner[k];
                    let m = a.getContentForKey(h);
                    l = this.g(l, h, m);
                    this.c._inner[k] = l;
                }
            }
            let p = a.getStringNames();
            for (let o = 0; o < p.length; o++) {
                let n = p[o];
                for (let q = 0; q < this.b.count; q++) {
                    let r = this.c._inner[q];
                    r = stringReplace(r, "$$" + n, a.getString(n));
                    this.c._inner[q] = r;
                }
            }
            for (let s of fromEnum(a.getNewFiles())) {
                let t = a.getNewFileContent(s);
                let u = "";
                for (let v of fromEnum(this.d)) {
                    if (stringStartsWith(v, "src")) {
                        u = "src/";
                    }
                }
                this.d.add(u + s);
                this.c.add(t);
            }
        }
        f(a, b) {
            return a;
        }
        g(a, b, c) {
            let d = new RegExp("(?:(<!--)|(\\/\\/))\\s*insert " + b + "(?:(\\s*-->)?)[\\w\\W\\r\\n]*?(?:(<!--)|(\\/\\/))\\s*end " + b + "(?:(\\s*-->)?)\r?\n?");
            return a.replace(d, c);
        }
    }
    CodeGenerationFolderTemplate.$t = /*@__PURE__*/ markType(CodeGenerationFolderTemplate, 'CodeGenerationFolderTemplate', Base.$, [ICodeGenerationRendererTemplate_$type]);
    return CodeGenerationFolderTemplate;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationRendererOptions = /*@__PURE__*/ (() => {
    class CodeGenerationRendererOptions extends Base {
        constructor() {
            super(...arguments);
            this._generateFullProject = false;
            this._forceCodeBehind = false;
            this._library = null;
        }
        get generateFullProject() {
            return this._generateFullProject;
        }
        set generateFullProject(a) {
            this._generateFullProject = a;
        }
        get forceCodeBehind() {
            return this._forceCodeBehind;
        }
        set forceCodeBehind(a) {
            this._forceCodeBehind = a;
        }
        get library() {
            return this._library;
        }
        set library(a) {
            this._library = a;
        }
    }
    CodeGenerationRendererOptions.$t = /*@__PURE__*/ markType(CodeGenerationRendererOptions, 'CodeGenerationRendererOptions');
    return CodeGenerationRendererOptions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CodeGenerationSpecialValueType_$type = /*@__PURE__*/ markEnum('CodeGenerationSpecialValueType', 'FontFamily,0|FontStyles,1|FontWeights,2|Color,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnnotationLayerProxyDescriptionModule = /*@__PURE__*/ (() => {
    class AnnotationLayerProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    AnnotationLayerProxyDescriptionModule.$t = /*@__PURE__*/ markType(AnnotationLayerProxyDescriptionModule, 'AnnotationLayerProxyDescriptionModule');
    return AnnotationLayerProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerDescription = /*@__PURE__*/ (() => {
    class SeriesViewerDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
            this.cb = null;
            this.r = false;
            this.v = false;
            this.x = false;
            this.b9 = null;
            this.b8 = null;
            this.ca = null;
            this.k = null;
            this.m = null;
            this.y = false;
            this.w = false;
            this.bw = 0;
            this.bv = 0;
            this.t = false;
            this.b3 = null;
            this.bz = null;
            this.u = false;
            this.c9 = null;
            this.a5 = 0;
            this.b4 = null;
            this.da = null;
            this.cd = null;
            this.b5 = null;
            this.cl = null;
            this.b6 = null;
            this.cc = null;
            this.l = null;
            this.a3 = 0;
            this.a4 = 0;
            this.b2 = null;
            this.c3 = null;
            this.cx = null;
            this.c5 = null;
            this.cz = null;
            this.c4 = null;
            this.cy = null;
            this.a1 = 0;
            this.az = 0;
            this.a0 = 0;
            this.ax = 0;
            this.aw = 0;
            this.au = 0;
            this.av = 0;
            this.as = 0;
            this.ct = null;
            this.a2 = 0;
            this.ap = 0;
            this.ar = 0;
            this.an = 0;
            this.am = 0;
            this.al = 0;
            this.s = false;
            this.aq = 0;
            this.ao = 0;
            this.ai = 0;
            this.ah = 0;
            this.j = null;
            this.aj = 0;
            this.ak = 0;
            this.ch = null;
            this.ci = null;
            this.ce = null;
            this.cf = null;
            this.cg = null;
            this.cj = null;
            this.cm = null;
            this.cp = null;
            this.cq = null;
            this.cr = null;
            this.cn = null;
            this.co = null;
            this.c7 = null;
            this.c6 = null;
            this.c8 = null;
            this.cs = null;
            this.b0 = null;
            this.b7 = null;
            this.ck = null;
            this.b1 = null;
            this.c0 = null;
            this.ay = 0;
            this.c2 = null;
            this.c1 = null;
            this.cu = null;
            this.at = 0;
            this.cw = null;
            this.cv = null;
        }
        get_type() {
            return "SeriesViewer";
        }
        get type() {
            return this.get_type();
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get crosshairPoint() {
            return this.h;
        }
        set crosshairPoint(a) {
            this.h = a;
            this.e("CrosshairPoint");
        }
        get legendRef() {
            return this.cb;
        }
        set legendRef(a) {
            this.cb = a;
            this.e("LegendRef");
        }
        get animateSeriesWhenAxisRangeChanges() {
            return this.r;
        }
        set animateSeriesWhenAxisRangeChanges(a) {
            this.r = a;
            this.e("AnimateSeriesWhenAxisRangeChanges");
        }
        get isWindowSyncedToVisibleRange() {
            return this.v;
        }
        set isWindowSyncedToVisibleRange(a) {
            this.v = a;
            this.e("IsWindowSyncedToVisibleRange");
        }
        get shouldSimulateHoverMoveCrosshairPoint() {
            return this.x;
        }
        set shouldSimulateHoverMoveCrosshairPoint(a) {
            this.x = a;
            this.e("ShouldSimulateHoverMoveCrosshairPoint");
        }
        get highlightingMode() {
            return this.b9;
        }
        set highlightingMode(a) {
            this.b9 = a;
            this.e("HighlightingMode");
        }
        get highlightingBehavior() {
            return this.b8;
        }
        set highlightingBehavior(a) {
            this.b8 = a;
            this.e("HighlightingBehavior");
        }
        get legendHighlightingMode() {
            return this.ca;
        }
        set legendHighlightingMode(a) {
            this.ca = a;
            this.e("LegendHighlightingMode");
        }
        get effectiveViewport() {
            return this.k;
        }
        set effectiveViewport(a) {
            this.k = a;
            this.e("EffectiveViewport");
        }
        get windowRect() {
            return this.m;
        }
        set windowRect(a) {
            this.m = a;
            this.e("WindowRect");
        }
        get useTiledZooming() {
            return this.y;
        }
        set useTiledZooming(a) {
            this.y = a;
            this.e("UseTiledZooming");
        }
        get preferHigherResolutionTiles() {
            return this.w;
        }
        set preferHigherResolutionTiles(a) {
            this.w = a;
            this.e("PreferHigherResolutionTiles");
        }
        get zoomTileCacheSize() {
            return this.bw;
        }
        set zoomTileCacheSize(a) {
            this.bw = a;
            this.e("ZoomTileCacheSize");
        }
        get highlightingTransitionDuration() {
            return this.bv;
        }
        set highlightingTransitionDuration(a) {
            this.bv = a;
            this.e("HighlightingTransitionDuration");
        }
        get isPagePanningAllowed() {
            return this.t;
        }
        set isPagePanningAllowed(a) {
            this.t = a;
            this.e("IsPagePanningAllowed");
        }
        get contentHitTestMode() {
            return this.b3;
        }
        set contentHitTestMode(a) {
            this.b3 = a;
            this.e("ContentHitTestMode");
        }
        get actualContentHitTestMode() {
            return this.bz;
        }
        set actualContentHitTestMode(a) {
            this.bz = a;
            this.e("ActualContentHitTestMode");
        }
        get isSurfaceInteractionDisabled() {
            return this.u;
        }
        set isSurfaceInteractionDisabled(a) {
            this.u = a;
            this.e("IsSurfaceInteractionDisabled");
        }
        get windowResponse() {
            return this.c9;
        }
        set windowResponse(a) {
            this.c9 = a;
            this.e("WindowResponse");
        }
        get windowRectMinWidth() {
            return this.a5;
        }
        set windowRectMinWidth(a) {
            this.a5 = a;
            this.e("WindowRectMinWidth");
        }
        get crosshairVisibility() {
            return this.b4;
        }
        set crosshairVisibility(a) {
            this.b4 = a;
            this.e("CrosshairVisibility");
        }
        get zoomCoercionMode() {
            return this.da;
        }
        set zoomCoercionMode(a) {
            this.da = a;
            this.e("ZoomCoercionMode");
        }
        get plotAreaBackground() {
            return this.cd;
        }
        set plotAreaBackground(a) {
            this.cd = a;
            this.e("PlotAreaBackground");
        }
        get defaultInteraction() {
            return this.b5;
        }
        set defaultInteraction(a) {
            this.b5 = a;
            this.e("DefaultInteraction");
        }
        get rightButtonDefaultInteraction() {
            return this.cl;
        }
        set rightButtonDefaultInteraction(a) {
            this.cl = a;
            this.e("RightButtonDefaultInteraction");
        }
        get dragModifier() {
            return this.b6;
        }
        set dragModifier(a) {
            this.b6 = a;
            this.e("DragModifier");
        }
        get panModifier() {
            return this.cc;
        }
        set panModifier(a) {
            this.cc = a;
            this.e("PanModifier");
        }
        get previewRect() {
            return this.l;
        }
        set previewRect(a) {
            this.l = a;
            this.e("PreviewRect");
        }
        get windowPositionHorizontal() {
            return this.a3;
        }
        set windowPositionHorizontal(a) {
            this.a3 = a;
            this.e("WindowPositionHorizontal");
        }
        get windowPositionVertical() {
            return this.a4;
        }
        set windowPositionVertical(a) {
            this.a4 = a;
            this.e("WindowPositionVertical");
        }
        get chartTitle() {
            return this.b2;
        }
        set chartTitle(a) {
            this.b2 = a;
            this.e("ChartTitle");
        }
        get titleHorizontalAlignment() {
            return this.c3;
        }
        set titleHorizontalAlignment(a) {
            this.c3 = a;
            this.e("TitleHorizontalAlignment");
        }
        get subtitleHorizontalAlignment() {
            return this.cx;
        }
        set subtitleHorizontalAlignment(a) {
            this.cx = a;
            this.e("SubtitleHorizontalAlignment");
        }
        get titleTextStyle() {
            return this.c5;
        }
        set titleTextStyle(a) {
            this.c5 = a;
            this.e("TitleTextStyle");
        }
        get subtitleTextStyle() {
            return this.cz;
        }
        set subtitleTextStyle(a) {
            this.cz = a;
            this.e("SubtitleTextStyle");
        }
        get titleTextColor() {
            return this.c4;
        }
        set titleTextColor(a) {
            this.c4 = a;
            this.e("TitleTextColor");
        }
        get subtitleTextColor() {
            return this.cy;
        }
        set subtitleTextColor(a) {
            this.cy = a;
            this.e("SubtitleTextColor");
        }
        get titleTopMargin() {
            return this.a1;
        }
        set titleTopMargin(a) {
            this.a1 = a;
            this.e("TitleTopMargin");
        }
        get titleLeftMargin() {
            return this.az;
        }
        set titleLeftMargin(a) {
            this.az = a;
            this.e("TitleLeftMargin");
        }
        get titleRightMargin() {
            return this.a0;
        }
        set titleRightMargin(a) {
            this.a0 = a;
            this.e("TitleRightMargin");
        }
        get titleBottomMargin() {
            return this.ax;
        }
        set titleBottomMargin(a) {
            this.ax = a;
            this.e("TitleBottomMargin");
        }
        get subtitleTopMargin() {
            return this.aw;
        }
        set subtitleTopMargin(a) {
            this.aw = a;
            this.e("SubtitleTopMargin");
        }
        get subtitleLeftMargin() {
            return this.au;
        }
        set subtitleLeftMargin(a) {
            this.au = a;
            this.e("SubtitleLeftMargin");
        }
        get subtitleRightMargin() {
            return this.av;
        }
        set subtitleRightMargin(a) {
            this.av = a;
            this.e("SubtitleRightMargin");
        }
        get subtitleBottomMargin() {
            return this.as;
        }
        set subtitleBottomMargin(a) {
            this.as = a;
            this.e("SubtitleBottomMargin");
        }
        get subtitle() {
            return this.ct;
        }
        set subtitle(a) {
            this.ct = a;
            this.e("Subtitle");
        }
        get topMargin() {
            return this.a2;
        }
        set topMargin(a) {
            this.a2 = a;
            this.e("TopMargin");
        }
        get leftMargin() {
            return this.ap;
        }
        set leftMargin(a) {
            this.ap = a;
            this.e("LeftMargin");
        }
        get rightMargin() {
            return this.ar;
        }
        set rightMargin(a) {
            this.ar = a;
            this.e("RightMargin");
        }
        get bottomMargin() {
            return this.an;
        }
        set bottomMargin(a) {
            this.an = a;
            this.e("BottomMargin");
        }
        get autoMarginWidth() {
            return this.am;
        }
        set autoMarginWidth(a) {
            this.am = a;
            this.e("AutoMarginWidth");
        }
        get autoMarginHeight() {
            return this.al;
        }
        set autoMarginHeight(a) {
            this.al = a;
            this.e("AutoMarginHeight");
        }
        get isAntiAliasingEnabledDuringInteraction() {
            return this.s;
        }
        set isAntiAliasingEnabledDuringInteraction(a) {
            this.s = a;
            this.e("IsAntiAliasingEnabledDuringInteraction");
        }
        get pixelScalingRatio() {
            return this.aq;
        }
        set pixelScalingRatio(a) {
            this.aq = a;
            this.e("PixelScalingRatio");
        }
        get interactionPixelScalingRatio() {
            return this.ao;
        }
        set interactionPixelScalingRatio(a) {
            this.ao = a;
            this.e("InteractionPixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.ai;
        }
        set actualPixelScalingRatio(a) {
            this.ai = a;
            this.e("ActualPixelScalingRatio");
        }
        get actualInteractionPixelScalingRatio() {
            return this.ah;
        }
        set actualInteractionPixelScalingRatio(a) {
            this.ah = a;
            this.e("ActualInteractionPixelScalingRatio");
        }
        get actualWindowRect() {
            return this.j;
        }
        set actualWindowRect(a) {
            this.j = a;
            this.e("ActualWindowRect");
        }
        get actualWindowPositionHorizontal() {
            return this.aj;
        }
        set actualWindowPositionHorizontal(a) {
            this.aj = a;
            this.e("ActualWindowPositionHorizontal");
        }
        get actualWindowPositionVertical() {
            return this.ak;
        }
        set actualWindowPositionVertical(a) {
            this.ak = a;
            this.e("ActualWindowPositionVertical");
        }
        get plotAreaMouseLeftButtonDownRef() {
            return this.ch;
        }
        set plotAreaMouseLeftButtonDownRef(a) {
            this.ch = a;
            this.e("PlotAreaMouseLeftButtonDownRef");
        }
        get plotAreaMouseLeftButtonUpRef() {
            return this.ci;
        }
        set plotAreaMouseLeftButtonUpRef(a) {
            this.ci = a;
            this.e("PlotAreaMouseLeftButtonUpRef");
        }
        get plotAreaClickedRef() {
            return this.ce;
        }
        set plotAreaClickedRef(a) {
            this.ce = a;
            this.e("PlotAreaClickedRef");
        }
        get plotAreaMouseEnterRef() {
            return this.cf;
        }
        set plotAreaMouseEnterRef(a) {
            this.cf = a;
            this.e("PlotAreaMouseEnterRef");
        }
        get plotAreaMouseLeaveRef() {
            return this.cg;
        }
        set plotAreaMouseLeaveRef(a) {
            this.cg = a;
            this.e("PlotAreaMouseLeaveRef");
        }
        get plotAreaMouseOverRef() {
            return this.cj;
        }
        set plotAreaMouseOverRef(a) {
            this.cj = a;
            this.e("PlotAreaMouseOverRef");
        }
        get seriesCursorMouseMoveRef() {
            return this.cm;
        }
        set seriesCursorMouseMoveRef(a) {
            this.cm = a;
            this.e("SeriesCursorMouseMoveRef");
        }
        get seriesMouseLeftButtonDownRef() {
            return this.cp;
        }
        set seriesMouseLeftButtonDownRef(a) {
            this.cp = a;
            this.e("SeriesMouseLeftButtonDownRef");
        }
        get seriesMouseLeftButtonUpRef() {
            return this.cq;
        }
        set seriesMouseLeftButtonUpRef(a) {
            this.cq = a;
            this.e("SeriesMouseLeftButtonUpRef");
        }
        get seriesMouseMoveRef() {
            return this.cr;
        }
        set seriesMouseMoveRef(a) {
            this.cr = a;
            this.e("SeriesMouseMoveRef");
        }
        get seriesMouseEnterRef() {
            return this.cn;
        }
        set seriesMouseEnterRef(a) {
            this.cn = a;
            this.e("SeriesMouseEnterRef");
        }
        get seriesMouseLeaveRef() {
            return this.co;
        }
        set seriesMouseLeaveRef(a) {
            this.co = a;
            this.e("SeriesMouseLeaveRef");
        }
        get viewerManipulationStartingRef() {
            return this.c7;
        }
        set viewerManipulationStartingRef(a) {
            this.c7 = a;
            this.e("ViewerManipulationStartingRef");
        }
        get viewerManipulationEndingRef() {
            return this.c6;
        }
        set viewerManipulationEndingRef(a) {
            this.c6 = a;
            this.e("ViewerManipulationEndingRef");
        }
        get windowRectChangedRef() {
            return this.c8;
        }
        set windowRectChangedRef(a) {
            this.c8 = a;
            this.e("WindowRectChangedRef");
        }
        get sizeChangedRef() {
            return this.cs;
        }
        set sizeChangedRef(a) {
            this.cs = a;
            this.e("SizeChangedRef");
        }
        get actualWindowRectChangedRef() {
            return this.b0;
        }
        set actualWindowRectChangedRef(a) {
            this.b0 = a;
            this.e("ActualWindowRectChangedRef");
        }
        get gridAreaRectChangedRef() {
            return this.b7;
        }
        set gridAreaRectChangedRef(a) {
            this.b7 = a;
            this.e("GridAreaRectChangedRef");
        }
        get refreshCompletedRef() {
            return this.ck;
        }
        set refreshCompletedRef(a) {
            this.ck = a;
            this.e("RefreshCompletedRef");
        }
        get background() {
            return this.b1;
        }
        set background(a) {
            this.b1 = a;
            this.e("Background");
        }
        get titleFontFamily() {
            return this.c0;
        }
        set titleFontFamily(a) {
            this.c0 = a;
            this.e("TitleFontFamily");
        }
        get titleFontSize() {
            return this.ay;
        }
        set titleFontSize(a) {
            this.ay = a;
            this.e("TitleFontSize");
        }
        get titleFontWeight() {
            return this.c2;
        }
        set titleFontWeight(a) {
            this.c2 = a;
            this.e("TitleFontWeight");
        }
        get titleFontStyle() {
            return this.c1;
        }
        set titleFontStyle(a) {
            this.c1 = a;
            this.e("TitleFontStyle");
        }
        get subtitleFontFamily() {
            return this.cu;
        }
        set subtitleFontFamily(a) {
            this.cu = a;
            this.e("SubtitleFontFamily");
        }
        get subtitleFontSize() {
            return this.at;
        }
        set subtitleFontSize(a) {
            this.at = a;
            this.e("SubtitleFontSize");
        }
        get subtitleFontWeight() {
            return this.cw;
        }
        set subtitleFontWeight(a) {
            this.cw = a;
            this.e("SubtitleFontWeight");
        }
        get subtitleFontStyle() {
            return this.cv;
        }
        set subtitleFontStyle(a) {
            this.cv = a;
            this.e("SubtitleFontStyle");
        }
    }
    SeriesViewerDescription.$t = /*@__PURE__*/ markType(SeriesViewerDescription, 'SeriesViewerDescription', Description.$);
    return SeriesViewerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapImageryDescription = /*@__PURE__*/ (() => {
    class GeographicMapImageryDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.f = null;
            this.r = null;
            this.j = false;
            this.s = null;
            this.l = 0;
            this.q = null;
            this.p = null;
            this.n = null;
            this.o = null;
        }
        get_type() {
            return "GeographicMapImagery";
        }
        get type() {
            return this.get_type();
        }
        get windowRect() {
            return this.h;
        }
        set windowRect(a) {
            this.h = a;
            this.e("WindowRect");
        }
        get geographicMap() {
            return this.f;
        }
        set geographicMap(a) {
            this.f = a;
            this.e("GeographicMap");
        }
        get referer() {
            return this.r;
        }
        set referer(a) {
            this.r = a;
            this.e("Referer");
        }
        get isHorizontalWrappingEnabled() {
            return this.j;
        }
        set isHorizontalWrappingEnabled(a) {
            this.j = a;
            this.e("IsHorizontalWrappingEnabled");
        }
        get userAgent() {
            return this.s;
        }
        set userAgent(a) {
            this.s = a;
            this.e("UserAgent");
        }
        get opacity() {
            return this.l;
        }
        set opacity(a) {
            this.l = a;
            this.e("Opacity");
        }
        get imageTilesReadyRef() {
            return this.q;
        }
        set imageTilesReadyRef(a) {
            this.q = a;
            this.e("ImageTilesReadyRef");
        }
        get imagesChangedRef() {
            return this.p;
        }
        set imagesChangedRef(a) {
            this.p = a;
            this.e("ImagesChangedRef");
        }
        get cancellingImageRef() {
            return this.n;
        }
        set cancellingImageRef(a) {
            this.n = a;
            this.e("CancellingImageRef");
        }
        get downloadingImageRef() {
            return this.o;
        }
        set downloadingImageRef(a) {
            this.o = a;
            this.e("DownloadingImageRef");
        }
    }
    GeographicMapImageryDescription.$t = /*@__PURE__*/ markType(GeographicMapImageryDescription, 'GeographicMapImageryDescription', Description.$);
    return GeographicMapImageryDescription;
})();
/**
 * @hidden
 */
let GeographicMapDescription = /*@__PURE__*/ (() => {
    class GeographicMapDescription extends SeriesViewerDescription {
        constructor() {
            super();
            this.ey = false;
            this.fa = null;
            this.ev = false;
            this.e7 = null;
            this.ex = false;
            this.ew = false;
            this.es = null;
            this.er = null;
            this.ep = null;
            this.e4 = 0;
            this.e3 = 0;
            this.e9 = null;
            this.fb = null;
            this.e8 = null;
        }
        get_type() {
            return "GeographicMap";
        }
        get zoomable() {
            return this.ey;
        }
        set zoomable(a) {
            this.ey = a;
            this.e("Zoomable");
        }
        get resizeBehavior() {
            return this.fa;
        }
        set resizeBehavior(a) {
            this.fa = a;
            this.e("ResizeBehavior");
        }
        get isHorizontalWrappingEnabled() {
            return this.ev;
        }
        set isHorizontalWrappingEnabled(a) {
            this.ev = a;
            this.e("IsHorizontalWrappingEnabled");
        }
        get backgroundTilingMode() {
            return this.e7;
        }
        set backgroundTilingMode(a) {
            this.e7 = a;
            this.e("BackgroundTilingMode");
        }
        get useWorldRectForZoomBounds() {
            return this.ex;
        }
        set useWorldRectForZoomBounds(a) {
            this.ex = a;
            this.e("UseWorldRectForZoomBounds");
        }
        get suppressZoomResetOnWorldRectChange() {
            return this.ew;
        }
        set suppressZoomResetOnWorldRectChange(a) {
            this.ew = a;
            this.e("SuppressZoomResetOnWorldRectChange");
        }
        get worldRect() {
            return this.es;
        }
        set worldRect(a) {
            this.es = a;
            this.e("WorldRect");
        }
        get actualWorldRect() {
            return this.er;
        }
        set actualWorldRect(a) {
            this.er = a;
            this.e("ActualWorldRect");
        }
        get backgroundContent() {
            return this.ep;
        }
        set backgroundContent(a) {
            this.ep = a;
            this.e("BackgroundContent");
        }
        get windowScale() {
            return this.e4;
        }
        set windowScale(a) {
            this.e4 = a;
            this.e("WindowScale");
        }
        get actualWindowScale() {
            return this.e3;
        }
        set actualWindowScale(a) {
            this.e3 = a;
            this.e("ActualWindowScale");
        }
        get imageTilesReadyRef() {
            return this.e9;
        }
        set imageTilesReadyRef(a) {
            this.e9 = a;
            this.e("ImageTilesReadyRef");
        }
        get width() {
            return this.fb;
        }
        set width(a) {
            this.fb = a;
            this.e("Width");
        }
        get height() {
            return this.e8;
        }
        set height(a) {
            this.e8 = a;
            this.e("Height");
        }
    }
    GeographicMapDescription.$t = /*@__PURE__*/ markType(GeographicMapDescription, 'GeographicMapDescription', SeriesViewerDescription.$);
    return GeographicMapDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineMapImageryDescription = /*@__PURE__*/ (() => {
    class ArcGISOnlineMapImageryDescription extends GeographicMapImageryDescription {
        constructor() {
            super();
            this.ae = null;
            this.ai = null;
            this.af = null;
            this.aj = null;
            this.aa = false;
            this.ac = 0;
            this.ah = null;
            this.ag = null;
        }
        get_type() {
            return "ArcGISOnlineMapImagery";
        }
        get mapServerUri() {
            return this.ae;
        }
        set mapServerUri(a) {
            this.ae = a;
            this.e("MapServerUri");
        }
        get userName() {
            return this.ai;
        }
        set userName(a) {
            this.ai = a;
            this.e("UserName");
        }
        get password() {
            return this.af;
        }
        set password(a) {
            this.af = a;
            this.e("Password");
        }
        get userToken() {
            return this.aj;
        }
        set userToken(a) {
            this.aj = a;
            this.e("UserToken");
        }
        get isMapPublic() {
            return this.aa;
        }
        set isMapPublic(a) {
            this.aa = a;
            this.e("IsMapPublic");
        }
        get defaultTokenTimeout() {
            return this.ac;
        }
        set defaultTokenTimeout(a) {
            this.ac = a;
            this.e("DefaultTokenTimeout");
        }
        get tokenGenerationEndPoint() {
            return this.ah;
        }
        set tokenGenerationEndPoint(a) {
            this.ah = a;
            this.e("TokenGenerationEndPoint");
        }
        get refererUri() {
            return this.ag;
        }
        set refererUri(a) {
            this.ag = a;
            this.e("RefererUri");
        }
    }
    ArcGISOnlineMapImageryDescription.$t = /*@__PURE__*/ markType(ArcGISOnlineMapImageryDescription, 'ArcGISOnlineMapImageryDescription', GeographicMapImageryDescription.$);
    return ArcGISOnlineMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageTilesReadyEventArgsDescription = /*@__PURE__*/ (() => {
    class ImageTilesReadyEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ImageTilesReadyEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ImageTilesReadyEventArgsDescription.$t = /*@__PURE__*/ markType(ImageTilesReadyEventArgsDescription, 'ImageTilesReadyEventArgsDescription', Description.$);
    return ImageTilesReadyEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageTilesReadyEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageTilesReadyEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ImageTilesReadyEventArgsDescriptionMetadata.a == null) {
                ImageTilesReadyEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageTilesReadyEventArgsDescriptionMetadata.c(a, ImageTilesReadyEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ImageTilesReadyEventArgsDescriptionMetadata.b(a);
            a.q("ImageTilesReadyEventArgs", () => new ImageTilesReadyEventArgsDescription());
            a.p("ImageTilesReadyEventArgs", ImageTilesReadyEventArgsDescriptionMetadata.a);
        }
    }
    ImageTilesReadyEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageTilesReadyEventArgsDescriptionMetadata, 'ImageTilesReadyEventArgsDescriptionMetadata');
    ImageTilesReadyEventArgsDescriptionMetadata.a = null;
    return ImageTilesReadyEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlotAreaMouseButtonEventArgsDescription = /*@__PURE__*/ (() => {
    class PlotAreaMouseButtonEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
            this.l = false;
            this.j = null;
        }
        get_type() {
            return "PlotAreaMouseButtonEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get chartPosition() {
            return this.f;
        }
        set chartPosition(a) {
            this.f = a;
            this.e("ChartPosition");
        }
        get plotAreaPosition() {
            return this.g;
        }
        set plotAreaPosition(a) {
            this.g = a;
            this.e("PlotAreaPosition");
        }
        get manipulationOccurred() {
            return this.l;
        }
        set manipulationOccurred(a) {
            this.l = a;
            this.e("ManipulationOccurred");
        }
        get viewer() {
            return this.j;
        }
        set viewer(a) {
            this.j = a;
            this.e("Viewer");
        }
    }
    PlotAreaMouseButtonEventArgsDescription.$t = /*@__PURE__*/ markType(PlotAreaMouseButtonEventArgsDescription, 'PlotAreaMouseButtonEventArgsDescription', Description.$);
    return PlotAreaMouseButtonEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlotAreaMouseEventArgsDescription = /*@__PURE__*/ (() => {
    class PlotAreaMouseEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
            this.l = false;
            this.j = null;
        }
        get_type() {
            return "PlotAreaMouseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get chartPosition() {
            return this.f;
        }
        set chartPosition(a) {
            this.f = a;
            this.e("ChartPosition");
        }
        get plotAreaPosition() {
            return this.g;
        }
        set plotAreaPosition(a) {
            this.g = a;
            this.e("PlotAreaPosition");
        }
        get isDuringManipulation() {
            return this.l;
        }
        set isDuringManipulation(a) {
            this.l = a;
            this.e("IsDuringManipulation");
        }
        get viewer() {
            return this.j;
        }
        set viewer(a) {
            this.j = a;
            this.e("Viewer");
        }
    }
    PlotAreaMouseEventArgsDescription.$t = /*@__PURE__*/ markType(PlotAreaMouseEventArgsDescription, 'PlotAreaMouseEventArgsDescription', Description.$);
    return PlotAreaMouseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RenderRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class RenderRequestedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = false;
        }
        get_type() {
            return "RenderRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get animate() {
            return this.f;
        }
        set animate(a) {
            this.f = a;
            this.e("Animate");
        }
    }
    RenderRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(RenderRequestedEventArgsDescription, 'RenderRequestedEventArgsDescription', Description.$);
    return RenderRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RenderRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class RenderRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (RenderRequestedEventArgsDescriptionMetadata.a == null) {
                RenderRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RenderRequestedEventArgsDescriptionMetadata.c(a, RenderRequestedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Animate", "Boolean");
        }
        static d(a) {
            RenderRequestedEventArgsDescriptionMetadata.b(a);
            a.q("RenderRequestedEventArgs", () => new RenderRequestedEventArgsDescription());
            a.p("RenderRequestedEventArgs", RenderRequestedEventArgsDescriptionMetadata.a);
        }
    }
    RenderRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(RenderRequestedEventArgsDescriptionMetadata, 'RenderRequestedEventArgsDescriptionMetadata');
    RenderRequestedEventArgsDescriptionMetadata.a = null;
    return RenderRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesDescriptionMetadata.a == null) {
                SeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesDescriptionMetadata.c(a, SeriesDescriptionMetadata.a);
                RenderRequestedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            b.item("LegendItemVisibility", "ExportedType:string:Visibility");
            b.item("LegendItemVisibility@names", "Visible;Collapsed");
            b.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            b.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            b.item("DiscreteLegendItemTemplateRef", "(w:DiscreteLegendItemTemplate,wf:DiscreteLegendItemTemplate)DataRef::object");
            b.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            b.item("TransitionInEasingFunctionRef", "(w:TransitionInEasingFunction,wf:TransitionInEasingFunction)MethodRef");
            b.item("TransitionDuration", "Number:int");
            b.item("Resolution", "Number:double");
            b.item("VisibleRangeMarginTop", "Number:double");
            b.item("VisibleRangeMarginBottom", "Number:double");
            b.item("VisibleRangeMarginLeft", "Number:double");
            b.item("VisibleRangeMarginRight", "Number:double");
            b.item("Brush", "Brush");
            b.item("ActualBrush", "Brush");
            b.item("Outline", "Brush");
            b.item("ActualOutline", "Brush");
            b.item("Thickness", "Number:double");
            b.item("ActualThickness", "Number:double");
            b.item("ActualHighlightingMode", "ExportedType:string:SeriesHighlightingMode");
            b.item("ActualHighlightingMode@names", "Auto;None;BrightenSpecific;Brighten;FadeOthersSpecific;FadeOthers");
            b.item("ActualHighlightingFadeOpacity", "Number:double");
            b.item("HighlightingFadeOpacity", "Number:double");
            b.item("IsComponentHighlightingModeIgnored", "Boolean");
            b.item("IsHighlightingEnabled", "Boolean");
            b.item("IsDropShadowEnabled", "Boolean");
            b.item("ShadowBlur", "Number:double");
            b.item("ShadowColor", "Color");
            b.item("UseSingleShadow", "Boolean");
            b.item("ShadowOffsetX", "Number:double");
            b.item("ShadowOffsetY", "Number:double");
            b.item("AreaFillOpacity", "Number:double");
            b.item("ActualAreaFillOpacity", "Number:double");
            b.item("MarkerFillOpacity", "Number:double");
            b.item("ActualMarkerFillOpacity", "Number:double");
            b.item("IsDefaultToolTipSelected", "Boolean");
            b.item("ShowDefaultTooltip", "Boolean");
            b.item("VisibleRangeMode", "ExportedType:string:SeriesVisibleRangeMode");
            b.item("VisibleRangeMode@names", "Auto;ValuesOnly;IncludeReferenceValue");
            b.item("OutlineMode", "ExportedType:string:SeriesOutlineMode");
            b.item("OutlineMode@names", "Auto;Visible;Collapsed");
            b.item("TransitionInDuration", "Number:int");
            b.item("TransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            b.item("TransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            b.item("MouseOverEnabled", "Boolean");
            b.item("CoercionMethodsRef", "(w:CoercionMethods,wf:CoercionMethods)DataRef");
            b.item("ExpectFunctions", "Boolean");
            b.item("HitTestMode", "ExportedType:string:SeriesHitTestMode");
            b.item("HitTestMode@names", "Auto;Computational;ColorEncoded");
            b.item("ActualHitTestMode", "ExportedType:string:SeriesHitTestMode");
            b.item("ActualHitTestMode@names", "Auto;Computational;ColorEncoded");
            b.item("FinalValue", "Number:double");
            b.item("PercentChange", "Number:double");
            b.item("Opacity", "Number:double");
            b.item("Visibility", "ExportedType:string:Visibility");
            b.item("Visibility@names", "Visible;Collapsed");
            b.item("RenderRequestedRef", "EventRef::renderRequested");
            SeriesDescriptionMetadata.e(a, b);
        }
        static d(a) {
            SeriesDescriptionMetadata.b(a);
            a.p("Series", SeriesDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
            b.item("Title", "String");
            b.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
        }
    }
    SeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesDescriptionMetadata, 'SeriesDescriptionMetadata');
    SeriesDescriptionMetadata.a = null;
    return SeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartCursorEventArgsDescription = /*@__PURE__*/ (() => {
    class ChartCursorEventArgsDescription extends Description {
        constructor() {
            super();
            this.j = null;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "ChartCursorEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.e("ItemRef");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get seriesViewer() {
            return this.h;
        }
        set seriesViewer(a) {
            this.h = a;
            this.e("SeriesViewer");
        }
    }
    ChartCursorEventArgsDescription.$t = /*@__PURE__*/ markType(ChartCursorEventArgsDescription, 'ChartCursorEventArgsDescription', Description.$);
    return ChartCursorEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartMouseEventArgsDescription = /*@__PURE__*/ (() => {
    class ChartMouseEventArgsDescription extends Description {
        constructor() {
            super();
            this.j = null;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "ChartMouseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.e("ItemRef");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get chart() {
            return this.h;
        }
        set chart(a) {
            this.h = a;
            this.e("Chart");
        }
    }
    ChartMouseEventArgsDescription.$t = /*@__PURE__*/ markType(ChartMouseEventArgsDescription, 'ChartMouseEventArgsDescription', Description.$);
    return ChartMouseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartMouseButtonEventArgsDescription = /*@__PURE__*/ (() => {
    class DataChartMouseButtonEventArgsDescription extends Description {
        constructor() {
            super();
            this.j = false;
            this.l = null;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "DataChartMouseButtonEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get handled() {
            return this.j;
        }
        set handled(a) {
            this.j = a;
            this.e("Handled");
        }
        get itemRef() {
            return this.l;
        }
        set itemRef(a) {
            this.l = a;
            this.e("ItemRef");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get chart() {
            return this.h;
        }
        set chart(a) {
            this.h = a;
            this.e("Chart");
        }
    }
    DataChartMouseButtonEventArgsDescription.$t = /*@__PURE__*/ markType(DataChartMouseButtonEventArgsDescription, 'DataChartMouseButtonEventArgsDescription', Description.$);
    return DataChartMouseButtonEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerManipulationEventArgsDescription = /*@__PURE__*/ (() => {
    class SeriesViewerManipulationEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = false;
            this.f = false;
        }
        get_type() {
            return "SeriesViewerManipulationEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get isZoomPan() {
            return this.g;
        }
        set isZoomPan(a) {
            this.g = a;
            this.e("IsZoomPan");
        }
        get isDragZoom() {
            return this.f;
        }
        set isDragZoom(a) {
            this.f = a;
            this.e("IsDragZoom");
        }
    }
    SeriesViewerManipulationEventArgsDescription.$t = /*@__PURE__*/ markType(SeriesViewerManipulationEventArgsDescription, 'SeriesViewerManipulationEventArgsDescription', Description.$);
    return SeriesViewerManipulationEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesViewerManipulationEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesViewerManipulationEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesViewerManipulationEventArgsDescriptionMetadata.a == null) {
                SeriesViewerManipulationEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesViewerManipulationEventArgsDescriptionMetadata.c(a, SeriesViewerManipulationEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsZoomPan", "Boolean");
            b.item("IsDragZoom", "Boolean");
        }
        static d(a) {
            SeriesViewerManipulationEventArgsDescriptionMetadata.b(a);
            a.q("SeriesViewerManipulationEventArgs", () => new SeriesViewerManipulationEventArgsDescription());
            a.p("SeriesViewerManipulationEventArgs", SeriesViewerManipulationEventArgsDescriptionMetadata.a);
        }
    }
    SeriesViewerManipulationEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesViewerManipulationEventArgsDescriptionMetadata, 'SeriesViewerManipulationEventArgsDescriptionMetadata');
    SeriesViewerManipulationEventArgsDescriptionMetadata.a = null;
    return SeriesViewerManipulationEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class RectChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "RectChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get oldRect() {
            return this.g;
        }
        set oldRect(a) {
            this.g = a;
            this.e("OldRect");
        }
        get newRect() {
            return this.f;
        }
        set newRect(a) {
            this.f = a;
            this.e("NewRect");
        }
    }
    RectChangedEventArgsDescription.$t = /*@__PURE__*/ markType(RectChangedEventArgsDescription, 'RectChangedEventArgsDescription', Description.$);
    return RectChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class RectChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (RectChangedEventArgsDescriptionMetadata.a == null) {
                RectChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RectChangedEventArgsDescriptionMetadata.c(a, RectChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("OldRect", "Rect");
            b.item("NewRect", "Rect");
        }
        static d(a) {
            RectChangedEventArgsDescriptionMetadata.b(a);
            a.q("RectChangedEventArgs", () => new RectChangedEventArgsDescription());
            a.p("RectChangedEventArgs", RectChangedEventArgsDescriptionMetadata.a);
        }
    }
    RectChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(RectChangedEventArgsDescriptionMetadata, 'RectChangedEventArgsDescriptionMetadata');
    RectChangedEventArgsDescriptionMetadata.a = null;
    return RectChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RefreshCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class RefreshCompletedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "RefreshCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    RefreshCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(RefreshCompletedEventArgsDescription, 'RefreshCompletedEventArgsDescription', Description.$);
    return RefreshCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RefreshCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class RefreshCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (RefreshCompletedEventArgsDescriptionMetadata.a == null) {
                RefreshCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RefreshCompletedEventArgsDescriptionMetadata.c(a, RefreshCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            RefreshCompletedEventArgsDescriptionMetadata.b(a);
            a.q("RefreshCompletedEventArgs", () => new RefreshCompletedEventArgsDescription());
            a.p("RefreshCompletedEventArgs", RefreshCompletedEventArgsDescriptionMetadata.a);
        }
    }
    RefreshCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(RefreshCompletedEventArgsDescriptionMetadata, 'RefreshCompletedEventArgsDescriptionMetadata');
    RefreshCompletedEventArgsDescriptionMetadata.a = null;
    return RefreshCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PlotAreaMouseButtonEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PlotAreaMouseButtonEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PlotAreaMouseButtonEventArgsDescriptionMetadata.a == null) {
                PlotAreaMouseButtonEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PlotAreaMouseButtonEventArgsDescriptionMetadata.c(a, PlotAreaMouseButtonEventArgsDescriptionMetadata.a);
                SeriesViewerDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ChartPosition", "Point");
            b.item("PlotAreaPosition", "Point");
            b.item("ManipulationOccurred", "Boolean");
            b.item("Viewer", "ExportedType:SeriesViewer");
        }
        static d(a) {
            PlotAreaMouseButtonEventArgsDescriptionMetadata.b(a);
            a.q("PlotAreaMouseButtonEventArgs", () => new PlotAreaMouseButtonEventArgsDescription());
            a.p("PlotAreaMouseButtonEventArgs", PlotAreaMouseButtonEventArgsDescriptionMetadata.a);
        }
    }
    PlotAreaMouseButtonEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PlotAreaMouseButtonEventArgsDescriptionMetadata, 'PlotAreaMouseButtonEventArgsDescriptionMetadata');
    PlotAreaMouseButtonEventArgsDescriptionMetadata.a = null;
    return PlotAreaMouseButtonEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let PlotAreaMouseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PlotAreaMouseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PlotAreaMouseEventArgsDescriptionMetadata.a == null) {
                PlotAreaMouseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PlotAreaMouseEventArgsDescriptionMetadata.c(a, PlotAreaMouseEventArgsDescriptionMetadata.a);
                SeriesViewerDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ChartPosition", "Point");
            b.item("PlotAreaPosition", "Point");
            b.item("IsDuringManipulation", "Boolean");
            b.item("Viewer", "ExportedType:SeriesViewer");
        }
        static d(a) {
            PlotAreaMouseEventArgsDescriptionMetadata.b(a);
            a.q("PlotAreaMouseEventArgs", () => new PlotAreaMouseEventArgsDescription());
            a.p("PlotAreaMouseEventArgs", PlotAreaMouseEventArgsDescriptionMetadata.a);
        }
    }
    PlotAreaMouseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PlotAreaMouseEventArgsDescriptionMetadata, 'PlotAreaMouseEventArgsDescriptionMetadata');
    PlotAreaMouseEventArgsDescriptionMetadata.a = null;
    return PlotAreaMouseEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let ChartCursorEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartCursorEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ChartCursorEventArgsDescriptionMetadata.a == null) {
                ChartCursorEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartCursorEventArgsDescriptionMetadata.c(a, ChartCursorEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
                SeriesViewerDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("Series", "ExportedType:Series");
            b.item("SeriesViewer", "ExportedType:SeriesViewer");
        }
        static d(a) {
            ChartCursorEventArgsDescriptionMetadata.b(a);
            a.q("ChartCursorEventArgs", () => new ChartCursorEventArgsDescription());
            a.p("ChartCursorEventArgs", ChartCursorEventArgsDescriptionMetadata.a);
        }
    }
    ChartCursorEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartCursorEventArgsDescriptionMetadata, 'ChartCursorEventArgsDescriptionMetadata');
    ChartCursorEventArgsDescriptionMetadata.a = null;
    return ChartCursorEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let ChartMouseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartMouseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ChartMouseEventArgsDescriptionMetadata.a == null) {
                ChartMouseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartMouseEventArgsDescriptionMetadata.c(a, ChartMouseEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
                SeriesViewerDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("Series", "ExportedType:Series");
            b.item("Chart", "ExportedType:SeriesViewer");
        }
        static d(a) {
            ChartMouseEventArgsDescriptionMetadata.b(a);
            a.q("ChartMouseEventArgs", () => new ChartMouseEventArgsDescription());
            a.p("ChartMouseEventArgs", ChartMouseEventArgsDescriptionMetadata.a);
        }
    }
    ChartMouseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartMouseEventArgsDescriptionMetadata, 'ChartMouseEventArgsDescriptionMetadata');
    ChartMouseEventArgsDescriptionMetadata.a = null;
    return ChartMouseEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let DataChartMouseButtonEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartMouseButtonEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataChartMouseButtonEventArgsDescriptionMetadata.a == null) {
                DataChartMouseButtonEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataChartMouseButtonEventArgsDescriptionMetadata.c(a, DataChartMouseButtonEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
                SeriesViewerDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Handled", "Boolean");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("Series", "ExportedType:Series");
            b.item("Chart", "ExportedType:SeriesViewer");
        }
        static d(a) {
            DataChartMouseButtonEventArgsDescriptionMetadata.b(a);
            a.q("DataChartMouseButtonEventArgs", () => new DataChartMouseButtonEventArgsDescription());
            a.p("DataChartMouseButtonEventArgs", DataChartMouseButtonEventArgsDescriptionMetadata.a);
        }
    }
    DataChartMouseButtonEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartMouseButtonEventArgsDescriptionMetadata, 'DataChartMouseButtonEventArgsDescriptionMetadata');
    DataChartMouseButtonEventArgsDescriptionMetadata.a = null;
    return DataChartMouseButtonEventArgsDescriptionMetadata;
})();
/**
 * @hidden
 */
let SeriesViewerDescriptionMetadata = /*@__PURE__*/ (() => {
    class SeriesViewerDescriptionMetadata extends Base {
        static b(a) {
            if (SeriesViewerDescriptionMetadata.a == null) {
                SeriesViewerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SeriesViewerDescriptionMetadata.c(a, SeriesViewerDescriptionMetadata.a);
                PlotAreaMouseButtonEventArgsDescriptionMetadata.d(a);
                PlotAreaMouseEventArgsDescriptionMetadata.d(a);
                ChartCursorEventArgsDescriptionMetadata.d(a);
                DataChartMouseButtonEventArgsDescriptionMetadata.d(a);
                ChartMouseEventArgsDescriptionMetadata.d(a);
                SeriesViewerManipulationEventArgsDescriptionMetadata.d(a);
                RectChangedEventArgsDescriptionMetadata.d(a);
                RefreshCompletedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Series", "Collection:Series:SeriesCollection:Series");
            b.item("CrosshairPoint", "Point");
            b.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            b.item("AnimateSeriesWhenAxisRangeChanges", "Boolean");
            b.item("IsWindowSyncedToVisibleRange", "Boolean");
            b.item("ShouldSimulateHoverMoveCrosshairPoint", "Boolean");
            b.item("HighlightingMode", "ExportedType:string:SeriesHighlightingMode");
            b.item("HighlightingMode@names", "Auto;None;BrightenSpecific;Brighten;FadeOthersSpecific;FadeOthers");
            b.item("HighlightingBehavior", "ExportedType:string:SeriesHighlightingBehavior");
            b.item("HighlightingBehavior@names", "Auto;DirectlyOver;NearestItems;NearestItemsRetainMainShapes;NearestItemsAndSeries");
            b.item("LegendHighlightingMode", "ExportedType:string:LegendHighlightingMode");
            b.item("LegendHighlightingMode@names", "Auto;None;MatchSeries");
            b.item("EffectiveViewport", "Rect");
            b.item("WindowRect", "Rect");
            b.item("UseTiledZooming", "Boolean");
            b.item("PreferHigherResolutionTiles", "Boolean");
            b.item("ZoomTileCacheSize", "Number:int");
            b.item("HighlightingTransitionDuration", "Number:int");
            b.item("IsPagePanningAllowed", "Boolean");
            b.item("ContentHitTestMode", "ExportedType:string:ChartHitTestMode");
            b.item("ContentHitTestMode@names", "Auto;Computational;ColorEncoded;Mixed;MixedFavoringComputational");
            b.item("ActualContentHitTestMode", "ExportedType:string:ChartHitTestMode");
            b.item("ActualContentHitTestMode@names", "Auto;Computational;ColorEncoded;Mixed;MixedFavoringComputational");
            b.item("IsSurfaceInteractionDisabled", "Boolean");
            b.item("WindowResponse", "ExportedType:string:WindowResponse");
            b.item("WindowResponse@names", "Deferred;Immediate");
            b.item("WindowRectMinWidth", "Number:double");
            b.item("CrosshairVisibility", "ExportedType:string:Visibility");
            b.item("CrosshairVisibility@names", "Visible;Collapsed");
            b.item("ZoomCoercionMode", "ExportedType:string:ZoomCoercionMode");
            b.item("ZoomCoercionMode@names", "Auto;AxisConstrained;Unconstrained");
            b.item("PlotAreaBackground", "Brush");
            b.item("DefaultInteraction", "ExportedType:string:InteractionState");
            b.item("DefaultInteraction@names", "None;DragZoom;DragPan;Auto");
            b.item("RightButtonDefaultInteraction", "ExportedType:string:InteractionState");
            b.item("RightButtonDefaultInteraction@names", "None;DragZoom;DragPan;Auto");
            b.item("DragModifier", "ExportedType:string:ModifierKeys");
            b.item("DragModifier@names", "None;Alt;Control;Shift;Windows;Apple");
            b.item("PanModifier", "ExportedType:string:ModifierKeys");
            b.item("PanModifier@names", "None;Alt;Control;Shift;Windows;Apple");
            b.item("PreviewRect", "Rect");
            b.item("WindowPositionHorizontal", "Number:double");
            b.item("WindowPositionVertical", "Number:double");
            b.item("ChartTitle", "(w:Title,wf:Title)String");
            b.item("TitleHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("TitleHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("SubtitleHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("SubtitleHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("TitleTextStyle", "String");
            b.item("SubtitleTextStyle", "String");
            b.item("TitleTextColor", "Brush");
            b.item("SubtitleTextColor", "Brush");
            b.item("TitleTopMargin", "Number:double");
            b.item("TitleLeftMargin", "Number:double");
            b.item("TitleRightMargin", "Number:double");
            b.item("TitleBottomMargin", "Number:double");
            b.item("SubtitleTopMargin", "Number:double");
            b.item("SubtitleLeftMargin", "Number:double");
            b.item("SubtitleRightMargin", "Number:double");
            b.item("SubtitleBottomMargin", "Number:double");
            b.item("Subtitle", "String");
            b.item("TopMargin", "Number:double");
            b.item("LeftMargin", "Number:double");
            b.item("RightMargin", "Number:double");
            b.item("BottomMargin", "Number:double");
            b.item("AutoMarginWidth", "Number:double");
            b.item("AutoMarginHeight", "Number:double");
            b.item("IsAntiAliasingEnabledDuringInteraction", "Boolean");
            b.item("PixelScalingRatio", "Number:double");
            b.item("InteractionPixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("ActualInteractionPixelScalingRatio", "Number:double");
            b.item("ActualWindowRect", "Rect");
            b.item("ActualWindowPositionHorizontal", "Number:double");
            b.item("ActualWindowPositionVertical", "Number:double");
            b.item("PlotAreaMouseLeftButtonDownRef", "EventRef::plotAreaMouseLeftButtonDown");
            b.item("PlotAreaMouseLeftButtonUpRef", "EventRef::plotAreaMouseLeftButtonUp");
            b.item("PlotAreaClickedRef", "EventRef::plotAreaClicked");
            b.item("PlotAreaMouseEnterRef", "EventRef::plotAreaMouseEnter");
            b.item("PlotAreaMouseLeaveRef", "EventRef::plotAreaMouseLeave");
            b.item("PlotAreaMouseOverRef", "EventRef::plotAreaMouseOver");
            b.item("SeriesCursorMouseMoveRef", "EventRef::seriesCursorMouseMove");
            b.item("SeriesMouseLeftButtonDownRef", "EventRef::seriesMouseLeftButtonDown");
            b.item("SeriesMouseLeftButtonUpRef", "EventRef::seriesMouseLeftButtonUp");
            b.item("SeriesMouseMoveRef", "EventRef::seriesMouseMove");
            b.item("SeriesMouseEnterRef", "EventRef::seriesMouseEnter");
            b.item("SeriesMouseLeaveRef", "EventRef::seriesMouseLeave");
            b.item("ViewerManipulationStartingRef", "EventRef::viewerManipulationStarting");
            b.item("ViewerManipulationEndingRef", "EventRef::viewerManipulationEnding");
            b.item("WindowRectChangedRef", "EventRef::windowRectChanged");
            b.item("SizeChangedRef", "EventRef::sizeChanged");
            b.item("ActualWindowRectChangedRef", "EventRef::actualWindowRectChanged");
            b.item("GridAreaRectChangedRef", "EventRef::gridAreaRectChanged");
            b.item("RefreshCompletedRef", "EventRef::refreshCompleted");
            SeriesViewerDescriptionMetadata.e(a, b);
        }
        static d(a) {
            SeriesViewerDescriptionMetadata.b(a);
            a.p("SeriesViewer", SeriesViewerDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
            b.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,wf:TitleFontFamily,web:TitleTextStyle/FontFamilyTransform)String");
            b.item("TitleFontSize", "(w:TitleFontSize,wf:TitleFontSize,web:TitleTextStyle/FontSizeTransform)Number:double");
            b.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,wf:TitleTextStyle/FontStyleTransform,web:TitleTextStyle/FontStyleTransform)String");
            b.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,wf:TitleTextStyle/FontWeightTransform,web:TitleTextStyle/FontWeightTransform)String");
            b.item("SubtitleFontFamily", "(w:SubtitleFontFamily/FontFamilyTransform,wf:SubtitleFontFamily,web:SubtitleTextStyle/FontFamilyTransform)String");
            b.item("SubtitleFontSize", "(w:SubtitleFontSize,wf:SubtitleFontSize,web:SubtitleTextStyle/FontSizeTransform)Number:double");
            b.item("SubtitleFontStyle", "(w:SubtitleFontStyle/FontStyleTransform,wf:SubtitleTextStyle/FontStyleTransform,web:SubtitleTextStyle/FontStyleTransform)String");
            b.item("SubtitleFontWeight", "(w:SubtitleFontWeight/FontWeightTransform,wf:SubtitleTextStyle/FontWeightTransform,web:SubtitleTextStyle/FontWeightTransform)String");
        }
    }
    SeriesViewerDescriptionMetadata.$t = /*@__PURE__*/ markType(SeriesViewerDescriptionMetadata, 'SeriesViewerDescriptionMetadata');
    SeriesViewerDescriptionMetadata.a = null;
    return SeriesViewerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImagesChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ImagesChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ImagesChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ImagesChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ImagesChangedEventArgsDescription, 'ImagesChangedEventArgsDescription', Description.$);
    return ImagesChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImagesChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImagesChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ImagesChangedEventArgsDescriptionMetadata.a == null) {
                ImagesChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImagesChangedEventArgsDescriptionMetadata.c(a, ImagesChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ImagesChangedEventArgsDescriptionMetadata.b(a);
            a.q("ImagesChangedEventArgs", () => new ImagesChangedEventArgsDescription());
            a.p("ImagesChangedEventArgs", ImagesChangedEventArgsDescriptionMetadata.a);
        }
    }
    ImagesChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ImagesChangedEventArgsDescriptionMetadata, 'ImagesChangedEventArgsDescriptionMetadata');
    ImagesChangedEventArgsDescriptionMetadata.a = null;
    return ImagesChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancellingMultiScaleImageEventArgsDescription = /*@__PURE__*/ (() => {
    class CancellingMultiScaleImageEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "CancellingMultiScaleImageEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get uri() {
            return this.f;
        }
        set uri(a) {
            this.f = a;
            this.e("Uri");
        }
    }
    CancellingMultiScaleImageEventArgsDescription.$t = /*@__PURE__*/ markType(CancellingMultiScaleImageEventArgsDescription, 'CancellingMultiScaleImageEventArgsDescription', Description.$);
    return CancellingMultiScaleImageEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancellingMultiScaleImageEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CancellingMultiScaleImageEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CancellingMultiScaleImageEventArgsDescriptionMetadata.a == null) {
                CancellingMultiScaleImageEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CancellingMultiScaleImageEventArgsDescriptionMetadata.c(a, CancellingMultiScaleImageEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Uri", "String");
        }
        static d(a) {
            CancellingMultiScaleImageEventArgsDescriptionMetadata.b(a);
            a.q("CancellingMultiScaleImageEventArgs", () => new CancellingMultiScaleImageEventArgsDescription());
            a.p("CancellingMultiScaleImageEventArgs", CancellingMultiScaleImageEventArgsDescriptionMetadata.a);
        }
    }
    CancellingMultiScaleImageEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CancellingMultiScaleImageEventArgsDescriptionMetadata, 'CancellingMultiScaleImageEventArgsDescriptionMetadata');
    CancellingMultiScaleImageEventArgsDescriptionMetadata.a = null;
    return CancellingMultiScaleImageEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DownloadingMultiScaleImageEventArgsDescription = /*@__PURE__*/ (() => {
    class DownloadingMultiScaleImageEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "DownloadingMultiScaleImageEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get uri() {
            return this.f;
        }
        set uri(a) {
            this.f = a;
            this.e("Uri");
        }
    }
    DownloadingMultiScaleImageEventArgsDescription.$t = /*@__PURE__*/ markType(DownloadingMultiScaleImageEventArgsDescription, 'DownloadingMultiScaleImageEventArgsDescription', Description.$);
    return DownloadingMultiScaleImageEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DownloadingMultiScaleImageEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DownloadingMultiScaleImageEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DownloadingMultiScaleImageEventArgsDescriptionMetadata.a == null) {
                DownloadingMultiScaleImageEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DownloadingMultiScaleImageEventArgsDescriptionMetadata.c(a, DownloadingMultiScaleImageEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Uri", "String");
        }
        static d(a) {
            DownloadingMultiScaleImageEventArgsDescriptionMetadata.b(a);
            a.q("DownloadingMultiScaleImageEventArgs", () => new DownloadingMultiScaleImageEventArgsDescription());
            a.p("DownloadingMultiScaleImageEventArgs", DownloadingMultiScaleImageEventArgsDescriptionMetadata.a);
        }
    }
    DownloadingMultiScaleImageEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DownloadingMultiScaleImageEventArgsDescriptionMetadata, 'DownloadingMultiScaleImageEventArgsDescriptionMetadata');
    DownloadingMultiScaleImageEventArgsDescriptionMetadata.a = null;
    return DownloadingMultiScaleImageEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMapDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMapDescriptionMetadata.a == null) {
                GeographicMapDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMapDescriptionMetadata.c(a, GeographicMapDescriptionMetadata.a);
                GeographicMapImageryDescriptionMetadata.d(a);
                ImageTilesReadyEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            SeriesViewerDescriptionMetadata.c(a, b);
            b.item("Zoomable", "Boolean");
            b.item("ResizeBehavior", "ExportedType:string:MapResizeBehavior");
            b.item("ResizeBehavior@names", "Auto;MaintainTopLeftPosition;MaintainCenterPosition");
            b.item("IsHorizontalWrappingEnabled", "Boolean");
            b.item("BackgroundTilingMode", "ExportedType:string:MapBackgroundTilingMode");
            b.item("BackgroundTilingMode@names", "Auto;NonWrapped;Wrapped");
            b.item("UseWorldRectForZoomBounds", "Boolean");
            b.item("SuppressZoomResetOnWorldRectChange", "Boolean");
            b.item("WorldRect", "Rect");
            b.item("ActualWorldRect", "Rect");
            b.item("BackgroundContent", "ExportedType:GeographicMapImagery");
            b.item("WindowScale", "Number:double");
            b.item("ActualWindowScale", "Number:double");
            b.item("ImageTilesReadyRef", "EventRef::imageTilesReady");
            GeographicMapDescriptionMetadata.e(a, b);
        }
        static d(a) {
            GeographicMapDescriptionMetadata.b(a);
            a.q("GeographicMap", () => new GeographicMapDescription());
            a.p("GeographicMap", GeographicMapDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamGeogrpahicMap");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
        }
    }
    GeographicMapDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMapDescriptionMetadata, 'GeographicMapDescriptionMetadata');
    GeographicMapDescriptionMetadata.a = null;
    return GeographicMapDescriptionMetadata;
})();
/**
 * @hidden
 */
let GeographicMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMapImageryDescriptionMetadata.a == null) {
                GeographicMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMapImageryDescriptionMetadata.c(a, GeographicMapImageryDescriptionMetadata.a);
                GeographicMapDescriptionMetadata.d(a);
                ImageTilesReadyEventArgsDescriptionMetadata.d(a);
                ImagesChangedEventArgsDescriptionMetadata.d(a);
                CancellingMultiScaleImageEventArgsDescriptionMetadata.d(a);
                DownloadingMultiScaleImageEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("WindowRect", "Rect");
            b.item("GeographicMap", "ExportedType:XamGeographicMap");
            b.item("Referer", "String");
            b.item("IsHorizontalWrappingEnabled", "Boolean");
            b.item("UserAgent", "String");
            b.item("Opacity", "Number:double");
            b.item("ImageTilesReadyRef", "EventRef::imageTilesReady");
            b.item("ImagesChangedRef", "EventRef::imagesChanged");
            b.item("CancellingImageRef", "EventRef::cancellingImage");
            b.item("DownloadingImageRef", "EventRef::downloadingImage");
        }
        static d(a) {
            GeographicMapImageryDescriptionMetadata.b(a);
            a.p("GeographicMapImagery", GeographicMapImageryDescriptionMetadata.a);
        }
    }
    GeographicMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMapImageryDescriptionMetadata, 'GeographicMapImageryDescriptionMetadata');
    GeographicMapImageryDescriptionMetadata.a = null;
    return GeographicMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class ArcGISOnlineMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (ArcGISOnlineMapImageryDescriptionMetadata.a == null) {
                ArcGISOnlineMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ArcGISOnlineMapImageryDescriptionMetadata.c(a, ArcGISOnlineMapImageryDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapImageryDescriptionMetadata.c(a, b);
            b.item("MapServerUri", "String");
            b.item("UserName", "String");
            b.item("Password", "String");
            b.item("UserToken", "String");
            b.item("IsMapPublic", "Boolean");
            b.item("DefaultTokenTimeout", "Number:int");
            b.item("TokenGenerationEndPoint", "String");
            b.item("RefererUri", "String");
        }
        static d(a) {
            ArcGISOnlineMapImageryDescriptionMetadata.b(a);
            a.q("ArcGISOnlineMapImagery", () => new ArcGISOnlineMapImageryDescription());
            a.p("ArcGISOnlineMapImagery", ArcGISOnlineMapImageryDescriptionMetadata.a);
        }
    }
    ArcGISOnlineMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(ArcGISOnlineMapImageryDescriptionMetadata, 'ArcGISOnlineMapImageryDescriptionMetadata');
    ArcGISOnlineMapImageryDescriptionMetadata.a = null;
    return ArcGISOnlineMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class ArcGISOnlineMapImageryDescriptionModule extends Base {
        static register(a) {
            ArcGISOnlineMapImageryDescriptionMetadata.d(a);
        }
    }
    ArcGISOnlineMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(ArcGISOnlineMapImageryDescriptionModule, 'ArcGISOnlineMapImageryDescriptionModule');
    return ArcGISOnlineMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningSeriesStyleEventArgsBaseDescription extends Description {
        constructor() {
            super();
            this.ae = 0;
            this.ad = 0;
            this.q = new Date();
            this.p = new Date();
            this.ai = null;
            this.ah = null;
            this.aj = null;
            this.v = 0;
            this.t = 0;
            this.f = null;
            this.u = 0;
            this.w = 0;
            this.x = 0;
            this.i = false;
            this.h = false;
            this.j = false;
            this.k = false;
        }
        get_type() {
            return "AssigningSeriesStyleEventArgsBase";
        }
        get type() {
            return this.get_type();
        }
        get startIndex() {
            return this.ae;
        }
        set startIndex(a) {
            this.ae = a;
            this.e("StartIndex");
        }
        get endIndex() {
            return this.ad;
        }
        set endIndex(a) {
            this.ad = a;
            this.e("EndIndex");
        }
        get startDate() {
            return this.q;
        }
        set startDate(a) {
            this.q = a;
            this.e("StartDate");
        }
        get endDate() {
            return this.p;
        }
        set endDate(a) {
            this.p = a;
            this.e("EndDate");
        }
        get getItemsRef() {
            return this.ai;
        }
        set getItemsRef(a) {
            this.ai = a;
            this.e("GetItemsRef");
        }
        get fill() {
            return this.ah;
        }
        set fill(a) {
            this.ah = a;
            this.e("Fill");
        }
        get stroke() {
            return this.aj;
        }
        set stroke(a) {
            this.aj = a;
            this.e("Stroke");
        }
        get opacity() {
            return this.v;
        }
        set opacity(a) {
            this.v = a;
            this.e("Opacity");
        }
        get fadeOpacity() {
            return this.t;
        }
        set fadeOpacity(a) {
            this.t = a;
            this.e("FadeOpacity");
        }
        get highlightingInfo() {
            return this.f;
        }
        set highlightingInfo(a) {
            this.f = a;
            this.e("HighlightingInfo");
        }
        get maxAllSeriesHighlightingProgress() {
            return this.u;
        }
        set maxAllSeriesHighlightingProgress(a) {
            this.u = a;
            this.e("MaxAllSeriesHighlightingProgress");
        }
        get sumAllSeriesHighlightingProgress() {
            return this.w;
        }
        set sumAllSeriesHighlightingProgress(a) {
            this.w = a;
            this.e("SumAllSeriesHighlightingProgress");
        }
        get totalAllSeriesHighlightingProgress() {
            return this.x;
        }
        set totalAllSeriesHighlightingProgress(a) {
            this.x = a;
            this.e("TotalAllSeriesHighlightingProgress");
        }
        get highlightingHandled() {
            return this.i;
        }
        set highlightingHandled(a) {
            this.i = a;
            this.e("HighlightingHandled");
        }
        get hasDateRange() {
            return this.h;
        }
        set hasDateRange(a) {
            this.h = a;
            this.e("HasDateRange");
        }
        get isNegativeShape() {
            return this.j;
        }
        set isNegativeShape(a) {
            this.j = a;
            this.e("IsNegativeShape");
        }
        get isThumbnail() {
            return this.k;
        }
        set isThumbnail(a) {
            this.k = a;
            this.e("IsThumbnail");
        }
    }
    AssigningSeriesStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningSeriesStyleEventArgsBaseDescription, 'AssigningSeriesStyleEventArgsBaseDescription', Description.$);
    return AssigningSeriesStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningPolarStyleEventArgsBase";
        }
    }
    AssigningPolarStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsBaseDescription, 'AssigningPolarStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningPolarStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningPolarMarkerStyleEventArgsDescription extends AssigningPolarStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningPolarMarkerStyleEventArgs";
        }
    }
    AssigningPolarMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningPolarMarkerStyleEventArgsDescription, 'AssigningPolarMarkerStyleEventArgsDescription', AssigningPolarStyleEventArgsBaseDescription.$);
    return AssigningPolarMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingInfoDescription = /*@__PURE__*/ (() => {
    class HighlightingInfoDescription extends Description {
        constructor() {
            super();
            this.q = 0;
            this.p = 0;
            this.t = null;
            this.n = 0;
            this.j = false;
            this.i = false;
            this.h = false;
            this.f = null;
        }
        get_type() {
            return "HighlightingInfo";
        }
        get type() {
            return this.get_type();
        }
        get startIndex() {
            return this.q;
        }
        set startIndex(a) {
            this.q = a;
            this.e("StartIndex");
        }
        get endIndex() {
            return this.p;
        }
        set endIndex(a) {
            this.p = a;
            this.e("EndIndex");
        }
        get state() {
            return this.t;
        }
        set state(a) {
            this.t = a;
            this.e("State");
        }
        get progress() {
            return this.n;
        }
        set progress(a) {
            this.n = a;
            this.e("Progress");
        }
        get isMarker() {
            return this.j;
        }
        set isMarker(a) {
            this.j = a;
            this.e("IsMarker");
        }
        get isFullRange() {
            return this.i;
        }
        set isFullRange(a) {
            this.i = a;
            this.e("IsFullRange");
        }
        get isExclusive() {
            return this.h;
        }
        set isExclusive(a) {
            this.h = a;
            this.e("IsExclusive");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
    }
    HighlightingInfoDescription.$t = /*@__PURE__*/ markType(HighlightingInfoDescription, 'HighlightingInfoDescription', Description.$);
    return HighlightingInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighlightingInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class HighlightingInfoDescriptionMetadata extends Base {
        static b(a) {
            if (HighlightingInfoDescriptionMetadata.a == null) {
                HighlightingInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HighlightingInfoDescriptionMetadata.c(a, HighlightingInfoDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("StartIndex", "Number:int");
            b.item("EndIndex", "Number:int");
            b.item("State", "ExportedType:string:HighlightingState");
            b.item("State@names", "Outward;Inward;Static");
            b.item("Progress", "Number:double");
            b.item("IsMarker", "Boolean");
            b.item("IsFullRange", "Boolean");
            b.item("IsExclusive", "Boolean");
            b.item("Series", "ExportedType:Series");
        }
        static d(a) {
            HighlightingInfoDescriptionMetadata.b(a);
            a.q("HighlightingInfo", () => new HighlightingInfoDescription());
            a.p("HighlightingInfo", HighlightingInfoDescriptionMetadata.a);
        }
    }
    HighlightingInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(HighlightingInfoDescriptionMetadata, 'HighlightingInfoDescriptionMetadata');
    HighlightingInfoDescriptionMetadata.a = null;
    return HighlightingInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningSeriesStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a);
                HighlightingInfoDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("StartIndex", "Number:int");
            b.item("EndIndex", "Number:int");
            b.item("StartDate", "Date");
            b.item("EndDate", "Date");
            b.item("GetItemsRef", "(w:GetItems,wf:GetItems)MethodRef");
            b.item("Fill", "Brush");
            b.item("Stroke", "Brush");
            b.item("Opacity", "Number:double");
            b.item("FadeOpacity", "Number:double");
            b.item("HighlightingInfo", "ExportedType:HighlightingInfo");
            b.item("MaxAllSeriesHighlightingProgress", "Number:double");
            b.item("SumAllSeriesHighlightingProgress", "Number:double");
            b.item("TotalAllSeriesHighlightingProgress", "Number:double");
            b.item("HighlightingHandled", "Boolean");
            b.item("HasDateRange", "Boolean");
            b.item("IsNegativeShape", "Boolean");
            b.item("IsThumbnail", "Boolean");
        }
        static d(a) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningSeriesStyleEventArgsBase", AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningSeriesStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningSeriesStyleEventArgsBaseDescriptionMetadata, 'AssigningSeriesStyleEventArgsBaseDescriptionMetadata');
    AssigningSeriesStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningSeriesStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningPolarStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningPolarStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningPolarStyleEventArgsBaseDescriptionMetadata.c(a, AssigningPolarStyleEventArgsBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningPolarStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningPolarStyleEventArgsBase", AssigningPolarStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningPolarStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsBaseDescriptionMetadata, 'AssigningPolarStyleEventArgsBaseDescriptionMetadata');
    AssigningPolarStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningPolarStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningPolarMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningPolarMarkerStyleEventArgsDescriptionMetadata.c(a, AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningPolarStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningPolarMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningPolarMarkerStyleEventArgs", () => new AssigningPolarMarkerStyleEventArgsDescription());
            a.p("AssigningPolarMarkerStyleEventArgs", AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningPolarMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningPolarMarkerStyleEventArgsDescriptionMetadata, 'AssigningPolarMarkerStyleEventArgsDescriptionMetadata');
    AssigningPolarMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningPolarMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesShapeStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningSeriesShapeStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        constructor() {
            super();
            this.aq = 0;
            this.ao = 0;
            this.ap = 0;
        }
        get_type() {
            return "AssigningSeriesShapeStyleEventArgsBase";
        }
        get strokeThickness() {
            return this.aq;
        }
        set strokeThickness(a) {
            this.aq = a;
            this.e("StrokeThickness");
        }
        get radiusX() {
            return this.ao;
        }
        set radiusX(a) {
            this.ao = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.ap;
        }
        set radiusY(a) {
            this.ap = a;
            this.e("RadiusY");
        }
    }
    AssigningSeriesShapeStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningSeriesShapeStyleEventArgsBaseDescription, 'AssigningSeriesShapeStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningSeriesShapeStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningPolarStyleEventArgs";
        }
    }
    AssigningPolarStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsDescription, 'AssigningPolarStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningPolarStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a, AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, b);
            b.item("StrokeThickness", "Number:double");
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningSeriesShapeStyleEventArgsBase", AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata, 'AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata');
    AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningPolarStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningPolarStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningPolarStyleEventArgsDescriptionMetadata.a == null) {
                AssigningPolarStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningPolarStyleEventArgsDescriptionMetadata.c(a, AssigningPolarStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningPolarStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningPolarStyleEventArgs", () => new AssigningPolarStyleEventArgsDescription());
            a.p("AssigningPolarStyleEventArgs", AssigningPolarStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningPolarStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningPolarStyleEventArgsDescriptionMetadata, 'AssigningPolarStyleEventArgsDescriptionMetadata');
    AssigningPolarStyleEventArgsDescriptionMetadata.a = null;
    return AssigningPolarStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningRadialStyleEventArgsBase";
        }
    }
    AssigningRadialStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsBaseDescription, 'AssigningRadialStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningRadialStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningRadialMarkerStyleEventArgsDescription extends AssigningRadialStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningRadialMarkerStyleEventArgs";
        }
    }
    AssigningRadialMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningRadialMarkerStyleEventArgsDescription, 'AssigningRadialMarkerStyleEventArgsDescription', AssigningRadialStyleEventArgsBaseDescription.$);
    return AssigningRadialMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningRadialStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningRadialStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningRadialStyleEventArgsBaseDescriptionMetadata.c(a, AssigningRadialStyleEventArgsBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningRadialStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningRadialStyleEventArgsBase", AssigningRadialStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningRadialStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsBaseDescriptionMetadata, 'AssigningRadialStyleEventArgsBaseDescriptionMetadata');
    AssigningRadialStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningRadialStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningRadialMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningRadialMarkerStyleEventArgsDescriptionMetadata.c(a, AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningRadialStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningRadialMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningRadialMarkerStyleEventArgs", () => new AssigningRadialMarkerStyleEventArgsDescription());
            a.p("AssigningRadialMarkerStyleEventArgs", AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningRadialMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningRadialMarkerStyleEventArgsDescriptionMetadata, 'AssigningRadialMarkerStyleEventArgsDescriptionMetadata');
    AssigningRadialMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningRadialMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningRadialStyleEventArgs";
        }
    }
    AssigningRadialStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsDescription, 'AssigningRadialStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningRadialStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningRadialStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningRadialStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningRadialStyleEventArgsDescriptionMetadata.a == null) {
                AssigningRadialStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningRadialStyleEventArgsDescriptionMetadata.c(a, AssigningRadialStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningRadialStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningRadialStyleEventArgs", () => new AssigningRadialStyleEventArgsDescription());
            a.p("AssigningRadialStyleEventArgs", AssigningRadialStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningRadialStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningRadialStyleEventArgsDescriptionMetadata, 'AssigningRadialStyleEventArgsDescriptionMetadata');
    AssigningRadialStyleEventArgsDescriptionMetadata.a = null;
    return AssigningRadialStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningScatterStyleEventArgsBase";
        }
    }
    AssigningScatterStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsBaseDescription, 'AssigningScatterStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningScatterStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningScatterMarkerStyleEventArgsDescription extends AssigningScatterStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningScatterMarkerStyleEventArgs";
        }
    }
    AssigningScatterMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningScatterMarkerStyleEventArgsDescription, 'AssigningScatterMarkerStyleEventArgsDescription', AssigningScatterStyleEventArgsBaseDescription.$);
    return AssigningScatterMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningScatterStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningScatterStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningScatterStyleEventArgsBaseDescriptionMetadata.c(a, AssigningScatterStyleEventArgsBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningScatterStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningScatterStyleEventArgsBase", AssigningScatterStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningScatterStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsBaseDescriptionMetadata, 'AssigningScatterStyleEventArgsBaseDescriptionMetadata');
    AssigningScatterStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningScatterStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningScatterMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.c(a, AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningScatterStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningScatterMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningScatterMarkerStyleEventArgs", () => new AssigningScatterMarkerStyleEventArgsDescription());
            a.p("AssigningScatterMarkerStyleEventArgs", AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningScatterMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningScatterMarkerStyleEventArgsDescriptionMetadata, 'AssigningScatterMarkerStyleEventArgsDescriptionMetadata');
    AssigningScatterMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningScatterMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningScatterStyleEventArgs";
        }
    }
    AssigningScatterStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsDescription, 'AssigningScatterStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningScatterStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningScatterStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningScatterStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningScatterStyleEventArgsDescriptionMetadata.a == null) {
                AssigningScatterStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningScatterStyleEventArgsDescriptionMetadata.c(a, AssigningScatterStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningScatterStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningScatterStyleEventArgs", () => new AssigningScatterStyleEventArgsDescription());
            a.p("AssigningScatterStyleEventArgs", AssigningScatterStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningScatterStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningScatterStyleEventArgsDescriptionMetadata, 'AssigningScatterStyleEventArgsDescriptionMetadata');
    AssigningScatterStyleEventArgsDescriptionMetadata.a = null;
    return AssigningScatterStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningShapeStyleEventArgsBase";
        }
    }
    AssigningShapeStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsBaseDescription, 'AssigningShapeStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningShapeStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningShapeMarkerStyleEventArgsDescription extends AssigningShapeStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningShapeMarkerStyleEventArgs";
        }
    }
    AssigningShapeMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningShapeMarkerStyleEventArgsDescription, 'AssigningShapeMarkerStyleEventArgsDescription', AssigningShapeStyleEventArgsBaseDescription.$);
    return AssigningShapeMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningShapeStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningShapeStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningShapeStyleEventArgsBaseDescriptionMetadata.c(a, AssigningShapeStyleEventArgsBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningShapeStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningShapeStyleEventArgsBase", AssigningShapeStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningShapeStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsBaseDescriptionMetadata, 'AssigningShapeStyleEventArgsBaseDescriptionMetadata');
    AssigningShapeStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningShapeStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningShapeMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningShapeMarkerStyleEventArgsDescriptionMetadata.c(a, AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningShapeStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningShapeMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningShapeMarkerStyleEventArgs", () => new AssigningShapeMarkerStyleEventArgsDescription());
            a.p("AssigningShapeMarkerStyleEventArgs", AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningShapeMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningShapeMarkerStyleEventArgsDescriptionMetadata, 'AssigningShapeMarkerStyleEventArgsDescriptionMetadata');
    AssigningShapeMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningShapeMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningShapeStyleEventArgs";
        }
    }
    AssigningShapeStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsDescription, 'AssigningShapeStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningShapeStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningShapeStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningShapeStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningShapeStyleEventArgsDescriptionMetadata.a == null) {
                AssigningShapeStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningShapeStyleEventArgsDescriptionMetadata.c(a, AssigningShapeStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningShapeStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningShapeStyleEventArgs", () => new AssigningShapeStyleEventArgsDescription());
            a.p("AssigningShapeStyleEventArgs", AssigningShapeStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningShapeStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningShapeStyleEventArgsDescriptionMetadata, 'AssigningShapeStyleEventArgsDescriptionMetadata');
    AssigningShapeStyleEventArgsDescriptionMetadata.a = null;
    return AssigningShapeStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class AsyncCompletedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "AsyncCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    AsyncCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(AsyncCompletedEventArgsDescription, 'AsyncCompletedEventArgsDescription', Description.$);
    return AsyncCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AsyncCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AsyncCompletedEventArgsDescriptionMetadata.a == null) {
                AsyncCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AsyncCompletedEventArgsDescriptionMetadata.c(a, AsyncCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            AsyncCompletedEventArgsDescriptionMetadata.b(a);
            a.q("AsyncCompletedEventArgs", () => new AsyncCompletedEventArgsDescription());
            a.p("AsyncCompletedEventArgs", AsyncCompletedEventArgsDescriptionMetadata.a);
        }
    }
    AsyncCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AsyncCompletedEventArgsDescriptionMetadata, 'AsyncCompletedEventArgsDescriptionMetadata');
    AsyncCompletedEventArgsDescriptionMetadata.a = null;
    return AsyncCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseDataSourceDescription = /*@__PURE__*/ (() => {
    class BaseDataSourceDescription extends Description {
        constructor() {
            super();
            this.m = false;
            this.l = false;
            this.ah = 0;
            this.ai = 0;
            this.aj = 0;
            this.j = false;
            this.f = null;
            this.g = null;
            this.ap = null;
            this.n = false;
            this.p = false;
            this.k = false;
            this.r = false;
            this.q = false;
            this.o = false;
            this.t = false;
            this.s = false;
            this.u = false;
            this.ao = null;
            this.an = null;
        }
        get_type() {
            return "BaseDataSource";
        }
        get type() {
            return this.get_type();
        }
        get isReadOnly() {
            return this.m;
        }
        set isReadOnly(a) {
            this.m = a;
            this.e("IsReadOnly");
        }
        get isBatchingEnabled() {
            return this.l;
        }
        set isBatchingEnabled(a) {
            this.l = a;
            this.e("IsBatchingEnabled");
        }
        get actualCount() {
            return this.ah;
        }
        set actualCount(a) {
            this.ah = a;
            this.e("ActualCount");
        }
        get firstVisibleIndexRequested() {
            return this.ai;
        }
        set firstVisibleIndexRequested(a) {
            this.ai = a;
            this.e("FirstVisibleIndexRequested");
        }
        get lastVisibleIndexRequested() {
            return this.aj;
        }
        set lastVisibleIndexRequested(a) {
            this.aj = a;
            this.e("LastVisibleIndexRequested");
        }
        get deferAutoRefresh() {
            return this.j;
        }
        set deferAutoRefresh(a) {
            this.j = a;
            this.e("DeferAutoRefresh");
        }
        get primaryKey() {
            return this.f;
        }
        set primaryKey(a) {
            this.f = a;
            this.e("PrimaryKey");
        }
        get propertiesRequested() {
            return this.g;
        }
        set propertiesRequested(a) {
            this.g = a;
            this.e("PropertiesRequested");
        }
        get sectionHeaderDisplayMode() {
            return this.ap;
        }
        set sectionHeaderDisplayMode(a) {
            this.ap = a;
            this.e("SectionHeaderDisplayMode");
        }
        get isSectionCollapsable() {
            return this.n;
        }
        set isSectionCollapsable(a) {
            this.n = a;
            this.e("IsSectionCollapsable");
        }
        get isSectionExpandedDefault() {
            return this.p;
        }
        set isSectionExpandedDefault(a) {
            this.p = a;
            this.e("IsSectionExpandedDefault");
        }
        get includeSummaryRowsInSection() {
            return this.k;
        }
        set includeSummaryRowsInSection(a) {
            this.k = a;
            this.e("IncludeSummaryRowsInSection");
        }
        get isSectionSummaryRowsAtBottom() {
            return this.r;
        }
        set isSectionSummaryRowsAtBottom(a) {
            this.r = a;
            this.e("IsSectionSummaryRowsAtBottom");
        }
        get isSectionHeaderNormalRow() {
            return this.q;
        }
        set isSectionHeaderNormalRow(a) {
            this.q = a;
            this.e("IsSectionHeaderNormalRow");
        }
        get isSectionContentVisible() {
            return this.o;
        }
        set isSectionContentVisible(a) {
            this.o = a;
            this.e("IsSectionContentVisible");
        }
        get shouldEmitSectionHeaders() {
            return this.t;
        }
        set shouldEmitSectionHeaders(a) {
            this.t = a;
            this.e("ShouldEmitSectionHeaders");
        }
        get shouldEmitSectionFooters() {
            return this.s;
        }
        set shouldEmitSectionFooters(a) {
            this.s = a;
            this.e("ShouldEmitSectionFooters");
        }
        get shouldEmitShiftedRows() {
            return this.u;
        }
        set shouldEmitShiftedRows(a) {
            this.u = a;
            this.e("ShouldEmitShiftedRows");
        }
        get schemaChangedRef() {
            return this.ao;
        }
        set schemaChangedRef(a) {
            this.ao = a;
            this.e("SchemaChangedRef");
        }
        get rowExpansionChangedRef() {
            return this.an;
        }
        set rowExpansionChangedRef(a) {
            this.an = a;
            this.e("RowExpansionChangedRef");
        }
    }
    BaseDataSourceDescription.$t = /*@__PURE__*/ markType(BaseDataSourceDescription, 'BaseDataSourceDescription', Description.$);
    return BaseDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSchemaChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DataSourceSchemaChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "DataSourceSchemaChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    DataSourceSchemaChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DataSourceSchemaChangedEventArgsDescription, 'DataSourceSchemaChangedEventArgsDescription', Description.$);
    return DataSourceSchemaChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSchemaChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceSchemaChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceSchemaChangedEventArgsDescriptionMetadata.a == null) {
                DataSourceSchemaChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceSchemaChangedEventArgsDescriptionMetadata.c(a, DataSourceSchemaChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            DataSourceSchemaChangedEventArgsDescriptionMetadata.b(a);
            a.q("DataSourceSchemaChangedEventArgs", () => new DataSourceSchemaChangedEventArgsDescription());
            a.p("DataSourceSchemaChangedEventArgs", DataSourceSchemaChangedEventArgsDescriptionMetadata.a);
        }
    }
    DataSourceSchemaChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceSchemaChangedEventArgsDescriptionMetadata, 'DataSourceSchemaChangedEventArgsDescriptionMetadata');
    DataSourceSchemaChangedEventArgsDescriptionMetadata.a = null;
    return DataSourceSchemaChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceRowExpansionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DataSourceRowExpansionChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "DataSourceRowExpansionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    DataSourceRowExpansionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DataSourceRowExpansionChangedEventArgsDescription, 'DataSourceRowExpansionChangedEventArgsDescription', Description.$);
    return DataSourceRowExpansionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceRowExpansionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceRowExpansionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a == null) {
                DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceRowExpansionChangedEventArgsDescriptionMetadata.c(a, DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            DataSourceRowExpansionChangedEventArgsDescriptionMetadata.b(a);
            a.q("DataSourceRowExpansionChangedEventArgs", () => new DataSourceRowExpansionChangedEventArgsDescription());
            a.p("DataSourceRowExpansionChangedEventArgs", DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a);
        }
    }
    DataSourceRowExpansionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceRowExpansionChangedEventArgsDescriptionMetadata, 'DataSourceRowExpansionChangedEventArgsDescriptionMetadata');
    DataSourceRowExpansionChangedEventArgsDescriptionMetadata.a = null;
    return DataSourceRowExpansionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class BaseDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (BaseDataSourceDescriptionMetadata.a == null) {
                BaseDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BaseDataSourceDescriptionMetadata.c(a, BaseDataSourceDescriptionMetadata.a);
                DataSourceSchemaChangedEventArgsDescriptionMetadata.d(a);
                DataSourceRowExpansionChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("IsReadOnly", "Boolean");
            b.item("IsBatchingEnabled", "Boolean");
            b.item("ActualCount", "Number:int");
            b.item("FirstVisibleIndexRequested", "Number:int");
            b.item("LastVisibleIndexRequested", "Number:int");
            b.item("DeferAutoRefresh", "Boolean");
            b.item("PrimaryKey", "Array:string");
            b.item("PropertiesRequested", "Array:string");
            b.item("SectionHeaderDisplayMode", "ExportedType:string:DataSourceSectionHeaderDisplayMode");
            b.item("SectionHeaderDisplayMode@names", "Combined;Split");
            b.item("IsSectionCollapsable", "Boolean");
            b.item("IsSectionExpandedDefault", "Boolean");
            b.item("IncludeSummaryRowsInSection", "Boolean");
            b.item("IsSectionSummaryRowsAtBottom", "Boolean");
            b.item("IsSectionHeaderNormalRow", "Boolean");
            b.item("IsSectionContentVisible", "Boolean");
            b.item("ShouldEmitSectionHeaders", "Boolean");
            b.item("ShouldEmitSectionFooters", "Boolean");
            b.item("ShouldEmitShiftedRows", "Boolean");
            b.item("SchemaChangedRef", "EventRef::schemaChanged");
            b.item("RowExpansionChangedRef", "EventRef::rowExpansionChanged");
        }
        static d(a) {
            BaseDataSourceDescriptionMetadata.b(a);
            a.p("BaseDataSource", BaseDataSourceDescriptionMetadata.a);
        }
    }
    BaseDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(BaseDataSourceDescriptionMetadata, 'BaseDataSourceDescriptionMetadata');
    BaseDataSourceDescriptionMetadata.a = null;
    return BaseDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsMapImageryDescription = /*@__PURE__*/ (() => {
    class BingMapsMapImageryDescription extends GeographicMapImageryDescription {
        constructor() {
            super();
            this.af = false;
            this.ae = false;
            this.ao = null;
            this.aj = null;
            this.ab = null;
            this.aa = null;
            this.al = null;
            this.ai = null;
            this.am = null;
            this.ak = null;
            this.an = null;
        }
        get_type() {
            return "BingMapsMapImagery";
        }
        get isInitialized() {
            return this.af;
        }
        set isInitialized(a) {
            this.af = a;
            this.e("IsInitialized");
        }
        get isDeferredLoad() {
            return this.ae;
        }
        set isDeferredLoad(a) {
            this.ae = a;
            this.e("IsDeferredLoad");
        }
        get tilePath() {
            return this.ao;
        }
        set tilePath(a) {
            this.ao = a;
            this.e("TilePath");
        }
        get actualTilePath() {
            return this.aj;
        }
        set actualTilePath(a) {
            this.aj = a;
            this.e("ActualTilePath");
        }
        get subDomains() {
            return this.ab;
        }
        set subDomains(a) {
            this.ab = a;
            this.e("SubDomains");
        }
        get actualSubDomains() {
            return this.aa;
        }
        set actualSubDomains(a) {
            this.aa = a;
            this.e("ActualSubDomains");
        }
        get bingImageryRestUri() {
            return this.al;
        }
        set bingImageryRestUri(a) {
            this.al = a;
            this.e("BingImageryRestUri");
        }
        get actualBingImageryRestUri() {
            return this.ai;
        }
        set actualBingImageryRestUri(a) {
            this.ai = a;
            this.e("ActualBingImageryRestUri");
        }
        get cultureName() {
            return this.am;
        }
        set cultureName(a) {
            this.am = a;
            this.e("CultureName");
        }
        get apiKey() {
            return this.ak;
        }
        set apiKey(a) {
            this.ak = a;
            this.e("ApiKey");
        }
        get imageryStyle() {
            return this.an;
        }
        set imageryStyle(a) {
            this.an = a;
            this.e("ImageryStyle");
        }
    }
    BingMapsMapImageryDescription.$t = /*@__PURE__*/ markType(BingMapsMapImageryDescription, 'BingMapsMapImageryDescription', GeographicMapImageryDescription.$);
    return BingMapsMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class BingMapsMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (BingMapsMapImageryDescriptionMetadata.a == null) {
                BingMapsMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BingMapsMapImageryDescriptionMetadata.c(a, BingMapsMapImageryDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapImageryDescriptionMetadata.c(a, b);
            b.item("IsInitialized", "Boolean");
            b.item("IsDeferredLoad", "Boolean");
            b.item("TilePath", "String");
            b.item("ActualTilePath", "String");
            b.item("SubDomains", "Collection:String:SubDomainsCollection:String");
            b.item("ActualSubDomains", "Collection:String:SubDomainsCollection:String");
            b.item("BingImageryRestUri", "String");
            b.item("ActualBingImageryRestUri", "String");
            b.item("CultureName", "String");
            b.item("ApiKey", "String");
            b.item("ImageryStyle", "ExportedType:string:BingMapsImageryStyle");
            b.item("ImageryStyle@names", "Aerial;AerialWithLabels;Road;CanvasDark;CanvasLight;CanvasGray");
        }
        static d(a) {
            BingMapsMapImageryDescriptionMetadata.b(a);
            a.q("BingMapsMapImagery", () => new BingMapsMapImageryDescription());
            a.p("BingMapsMapImagery", BingMapsMapImageryDescriptionMetadata.a);
        }
    }
    BingMapsMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(BingMapsMapImageryDescriptionMetadata, 'BingMapsMapImageryDescriptionMetadata');
    BingMapsMapImageryDescriptionMetadata.a = null;
    return BingMapsMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class BingMapsMapImageryDescriptionModule extends Base {
        static register(a) {
            BingMapsMapImageryDescriptionMetadata.d(a);
        }
    }
    BingMapsMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(BingMapsMapImageryDescriptionModule, 'BingMapsMapImageryDescriptionModule');
    return BingMapsMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatLinearGraphLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatLinearGraphLabelEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FormatLinearGraphLabelEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    FormatLinearGraphLabelEventArgsDescription.$t = /*@__PURE__*/ markType(FormatLinearGraphLabelEventArgsDescription, 'FormatLinearGraphLabelEventArgsDescription', Description.$);
    return FormatLinearGraphLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatLinearGraphLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatLinearGraphLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatLinearGraphLabelEventArgsDescriptionMetadata.a == null) {
                FormatLinearGraphLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatLinearGraphLabelEventArgsDescriptionMetadata.c(a, FormatLinearGraphLabelEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FormatLinearGraphLabelEventArgsDescriptionMetadata.b(a);
            a.q("FormatLinearGraphLabelEventArgs", () => new FormatLinearGraphLabelEventArgsDescription());
            a.p("FormatLinearGraphLabelEventArgs", FormatLinearGraphLabelEventArgsDescriptionMetadata.a);
        }
    }
    FormatLinearGraphLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatLinearGraphLabelEventArgsDescriptionMetadata, 'FormatLinearGraphLabelEventArgsDescriptionMetadata');
    FormatLinearGraphLabelEventArgsDescriptionMetadata.a = null;
    return FormatLinearGraphLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignLinearGraphLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class AlignLinearGraphLabelEventArgsDescription extends FormatLinearGraphLabelEventArgsDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AlignLinearGraphLabelEventArgs";
        }
    }
    AlignLinearGraphLabelEventArgsDescription.$t = /*@__PURE__*/ markType(AlignLinearGraphLabelEventArgsDescription, 'AlignLinearGraphLabelEventArgsDescription', FormatLinearGraphLabelEventArgsDescription.$);
    return AlignLinearGraphLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignLinearGraphLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AlignLinearGraphLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AlignLinearGraphLabelEventArgsDescriptionMetadata.a == null) {
                AlignLinearGraphLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AlignLinearGraphLabelEventArgsDescriptionMetadata.c(a, AlignLinearGraphLabelEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FormatLinearGraphLabelEventArgsDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AlignLinearGraphLabelEventArgsDescriptionMetadata.b(a);
            a.q("AlignLinearGraphLabelEventArgs", () => new AlignLinearGraphLabelEventArgsDescription());
            a.p("AlignLinearGraphLabelEventArgs", AlignLinearGraphLabelEventArgsDescriptionMetadata.a);
        }
    }
    AlignLinearGraphLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AlignLinearGraphLabelEventArgsDescriptionMetadata, 'AlignLinearGraphLabelEventArgsDescriptionMetadata');
    AlignLinearGraphLabelEventArgsDescriptionMetadata.a = null;
    return AlignLinearGraphLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphDescription = /*@__PURE__*/ (() => {
    class BulletGraphDescription extends Description {
        constructor() {
            super();
            this.cj = null;
            this.x = 0;
            this.cl = null;
            this.ck = null;
            this.c0 = null;
            this.cn = null;
            this.ce = null;
            this.az = 0;
            this.cq = null;
            this.cr = null;
            this.cs = null;
            this.am = 0;
            this.i = null;
            this.g = null;
            this.h = null;
            this.ae = 0;
            this.s = 0;
            this.ad = 0;
            this.r = 0;
            this.ap = 0;
            this.cu = null;
            this.a0 = 0;
            this.cy = null;
            this.ak = 0;
            this.al = 0;
            this.a1 = 0;
            this.a2 = 0;
            this.y = 0;
            this.av = 0;
            this.aw = 0;
            this.aa = 0;
            this.z = 0;
            this.ab = 0;
            this.ac = 0;
            this.af = 0;
            this.ax = 0;
            this.au = 0;
            this.ay = 0;
            this.cw = null;
            this.ci = null;
            this.cx = null;
            this.cz = null;
            this.a3 = 0;
            this.ah = 0;
            this.ag = 0;
            this.ai = 0;
            this.cp = null;
            this.n = false;
            this.cf = null;
            this.cg = null;
            this.w = 0;
            this.u = 0;
            this.v = 0;
            this.ao = 0;
            this.an = 0;
            this.ct = null;
            this.aq = 0;
            this.ar = 0;
            this.as = 0;
            this.cv = null;
            this.at = 0;
            this.co = null;
            this.f = null;
            this.b8 = 0;
            this.b7 = 0;
            this.o = false;
            this.ch = null;
            this.aj = 0;
            this.t = 0;
            this.cm = null;
            this.cd = null;
            this.cc = null;
            this.cb = null;
        }
        get fontFamily() {
            return this.cj;
        }
        set fontFamily(a) {
            this.cj = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.x;
        }
        set fontSize(a) {
            this.x = a;
            this.e("FontSize");
        }
        get fontWeight() {
            return this.cl;
        }
        set fontWeight(a) {
            this.cl = a;
            this.e("FontWeight");
        }
        get fontStyle() {
            return this.ck;
        }
        set fontStyle(a) {
            this.ck = a;
            this.e("FontStyle");
        }
        get width() {
            return this.c0;
        }
        set width(a) {
            this.c0 = a;
            this.e("Width");
        }
        get height() {
            return this.cn;
        }
        set height(a) {
            this.cn = a;
            this.e("Height");
        }
        get background() {
            return this.ce;
        }
        set background(a) {
            this.ce = a;
            this.e("Background");
        }
        get_type() {
            return "BulletGraph";
        }
        get type() {
            return this.get_type();
        }
        get transitionProgress() {
            return this.az;
        }
        set transitionProgress(a) {
            this.az = a;
            this.e("TransitionProgress");
        }
        get orientation() {
            return this.cq;
        }
        set orientation(a) {
            this.cq = a;
            this.e("Orientation");
        }
        get scaleBackgroundBrush() {
            return this.cr;
        }
        set scaleBackgroundBrush(a) {
            this.cr = a;
            this.e("ScaleBackgroundBrush");
        }
        get scaleBackgroundOutline() {
            return this.cs;
        }
        set scaleBackgroundOutline(a) {
            this.cs = a;
            this.e("ScaleBackgroundOutline");
        }
        get scaleBackgroundThickness() {
            return this.am;
        }
        set scaleBackgroundThickness(a) {
            this.am = a;
            this.e("ScaleBackgroundThickness");
        }
        get ranges() {
            return this.i;
        }
        set ranges(a) {
            this.i = a;
            this.e("Ranges");
        }
        get rangeBrushes() {
            return this.g;
        }
        set rangeBrushes(a) {
            this.g = a;
            this.e("RangeBrushes");
        }
        get rangeOutlines() {
            return this.h;
        }
        set rangeOutlines(a) {
            this.h = a;
            this.e("RangeOutlines");
        }
        get minimumValue() {
            return this.ae;
        }
        set minimumValue(a) {
            this.ae = a;
            this.e("MinimumValue");
        }
        get actualMinimumValue() {
            return this.s;
        }
        set actualMinimumValue(a) {
            this.s = a;
            this.e("ActualMinimumValue");
        }
        get maximumValue() {
            return this.ad;
        }
        set maximumValue(a) {
            this.ad = a;
            this.e("MaximumValue");
        }
        get actualMaximumValue() {
            return this.r;
        }
        set actualMaximumValue(a) {
            this.r = a;
            this.e("ActualMaximumValue");
        }
        get targetValue() {
            return this.ap;
        }
        set targetValue(a) {
            this.ap = a;
            this.e("TargetValue");
        }
        get targetValueName() {
            return this.cu;
        }
        set targetValueName(a) {
            this.cu = a;
            this.e("TargetValueName");
        }
        get value() {
            return this.a0;
        }
        set value(a) {
            this.a0 = a;
            this.e("Value");
        }
        get valueName() {
            return this.cy;
        }
        set valueName(a) {
            this.cy = a;
            this.e("ValueName");
        }
        get rangeInnerExtent() {
            return this.ak;
        }
        set rangeInnerExtent(a) {
            this.ak = a;
            this.e("RangeInnerExtent");
        }
        get rangeOuterExtent() {
            return this.al;
        }
        set rangeOuterExtent(a) {
            this.al = a;
            this.e("RangeOuterExtent");
        }
        get valueInnerExtent() {
            return this.a1;
        }
        set valueInnerExtent(a) {
            this.a1 = a;
            this.e("ValueInnerExtent");
        }
        get valueOuterExtent() {
            return this.a2;
        }
        set valueOuterExtent(a) {
            this.a2 = a;
            this.e("ValueOuterExtent");
        }
        get interval() {
            return this.y;
        }
        set interval(a) {
            this.y = a;
            this.e("Interval");
        }
        get ticksPostInitial() {
            return this.av;
        }
        set ticksPostInitial(a) {
            this.av = a;
            this.e("TicksPostInitial");
        }
        get ticksPreTerminal() {
            return this.aw;
        }
        set ticksPreTerminal(a) {
            this.aw = a;
            this.e("TicksPreTerminal");
        }
        get labelInterval() {
            return this.aa;
        }
        set labelInterval(a) {
            this.aa = a;
            this.e("LabelInterval");
        }
        get labelExtent() {
            return this.z;
        }
        set labelExtent(a) {
            this.z = a;
            this.e("LabelExtent");
        }
        get labelsPostInitial() {
            return this.ab;
        }
        set labelsPostInitial(a) {
            this.ab = a;
            this.e("LabelsPostInitial");
        }
        get labelsPreTerminal() {
            return this.ac;
        }
        set labelsPreTerminal(a) {
            this.ac = a;
            this.e("LabelsPreTerminal");
        }
        get minorTickCount() {
            return this.af;
        }
        set minorTickCount(a) {
            this.af = a;
            this.e("MinorTickCount");
        }
        get tickStartExtent() {
            return this.ax;
        }
        set tickStartExtent(a) {
            this.ax = a;
            this.e("TickStartExtent");
        }
        get tickEndExtent() {
            return this.au;
        }
        set tickEndExtent(a) {
            this.au = a;
            this.e("TickEndExtent");
        }
        get tickStrokeThickness() {
            return this.ay;
        }
        set tickStrokeThickness(a) {
            this.ay = a;
            this.e("TickStrokeThickness");
        }
        get tickBrush() {
            return this.cw;
        }
        set tickBrush(a) {
            this.cw = a;
            this.e("TickBrush");
        }
        get fontBrush() {
            return this.ci;
        }
        set fontBrush(a) {
            this.ci = a;
            this.e("FontBrush");
        }
        get valueBrush() {
            return this.cx;
        }
        set valueBrush(a) {
            this.cx = a;
            this.e("ValueBrush");
        }
        get valueOutline() {
            return this.cz;
        }
        set valueOutline(a) {
            this.cz = a;
            this.e("ValueOutline");
        }
        get valueStrokeThickness() {
            return this.a3;
        }
        set valueStrokeThickness(a) {
            this.a3 = a;
            this.e("ValueStrokeThickness");
        }
        get minorTickStartExtent() {
            return this.ah;
        }
        set minorTickStartExtent(a) {
            this.ah = a;
            this.e("MinorTickStartExtent");
        }
        get minorTickEndExtent() {
            return this.ag;
        }
        set minorTickEndExtent(a) {
            this.ag = a;
            this.e("MinorTickEndExtent");
        }
        get minorTickStrokeThickness() {
            return this.ai;
        }
        set minorTickStrokeThickness(a) {
            this.ai = a;
            this.e("MinorTickStrokeThickness");
        }
        get minorTickBrush() {
            return this.cp;
        }
        set minorTickBrush(a) {
            this.cp = a;
            this.e("MinorTickBrush");
        }
        get isScaleInverted() {
            return this.n;
        }
        set isScaleInverted(a) {
            this.n = a;
            this.e("IsScaleInverted");
        }
        get backingBrush() {
            return this.cf;
        }
        set backingBrush(a) {
            this.cf = a;
            this.e("BackingBrush");
        }
        get backingOutline() {
            return this.cg;
        }
        set backingOutline(a) {
            this.cg = a;
            this.e("BackingOutline");
        }
        get backingStrokeThickness() {
            return this.w;
        }
        set backingStrokeThickness(a) {
            this.w = a;
            this.e("BackingStrokeThickness");
        }
        get backingInnerExtent() {
            return this.u;
        }
        set backingInnerExtent(a) {
            this.u = a;
            this.e("BackingInnerExtent");
        }
        get backingOuterExtent() {
            return this.v;
        }
        set backingOuterExtent(a) {
            this.v = a;
            this.e("BackingOuterExtent");
        }
        get scaleStartExtent() {
            return this.ao;
        }
        set scaleStartExtent(a) {
            this.ao = a;
            this.e("ScaleStartExtent");
        }
        get scaleEndExtent() {
            return this.an;
        }
        set scaleEndExtent(a) {
            this.an = a;
            this.e("ScaleEndExtent");
        }
        get targetValueBrush() {
            return this.ct;
        }
        set targetValueBrush(a) {
            this.ct = a;
            this.e("TargetValueBrush");
        }
        get targetValueBreadth() {
            return this.aq;
        }
        set targetValueBreadth(a) {
            this.aq = a;
            this.e("TargetValueBreadth");
        }
        get targetValueInnerExtent() {
            return this.ar;
        }
        set targetValueInnerExtent(a) {
            this.ar = a;
            this.e("TargetValueInnerExtent");
        }
        get targetValueOuterExtent() {
            return this.as;
        }
        set targetValueOuterExtent(a) {
            this.as = a;
            this.e("TargetValueOuterExtent");
        }
        get targetValueOutline() {
            return this.cv;
        }
        set targetValueOutline(a) {
            this.cv = a;
            this.e("TargetValueOutline");
        }
        get targetValueStrokeThickness() {
            return this.at;
        }
        set targetValueStrokeThickness(a) {
            this.at = a;
            this.e("TargetValueStrokeThickness");
        }
        get labelFormat() {
            return this.co;
        }
        set labelFormat(a) {
            this.co = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.f;
        }
        set labelFormatSpecifiers(a) {
            this.f = a;
            this.e("LabelFormatSpecifiers");
        }
        get transitionDuration() {
            return this.b8;
        }
        set transitionDuration(a) {
            this.b8 = a;
            this.e("TransitionDuration");
        }
        get showToolTipTimeout() {
            return this.b7;
        }
        set showToolTipTimeout(a) {
            this.b7 = a;
            this.e("ShowToolTipTimeout");
        }
        get showToolTip() {
            return this.o;
        }
        set showToolTip(a) {
            this.o = a;
            this.e("ShowToolTip");
        }
        get font() {
            return this.ch;
        }
        set font(a) {
            this.ch = a;
            this.e("Font");
        }
        get pixelScalingRatio() {
            return this.aj;
        }
        set pixelScalingRatio(a) {
            this.aj = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.t;
        }
        set actualPixelScalingRatio(a) {
            this.t = a;
            this.e("ActualPixelScalingRatio");
        }
        get formatLabelRef() {
            return this.cm;
        }
        set formatLabelRef(a) {
            this.cm = a;
            this.e("FormatLabelRef");
        }
        get alignLabelRef() {
            return this.cd;
        }
        set alignLabelRef(a) {
            this.cd = a;
            this.e("AlignLabelRef");
        }
        get actualMinimumValueChangeRef() {
            return this.cc;
        }
        set actualMinimumValueChangeRef(a) {
            this.cc = a;
            this.e("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.cb;
        }
        set actualMaximumValueChangeRef(a) {
            this.cb = a;
            this.e("ActualMaximumValueChangeRef");
        }
    }
    BulletGraphDescription.$t = /*@__PURE__*/ markType(BulletGraphDescription, 'BulletGraphDescription', Description.$);
    return BulletGraphDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphDescriptionMetadata = /*@__PURE__*/ (() => {
    class BulletGraphDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
            b.item("_qualifiedName", "String:Infragistics.Controls.Gauges.XamBulletGraph");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("LegendRef", "(w:Legend)DataRef:String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (BulletGraphDescriptionMetadata.a == null) {
                BulletGraphDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BulletGraphDescriptionMetadata.c(a, BulletGraphDescriptionMetadata.a);
                FormatLinearGraphLabelEventArgsDescriptionMetadata.d(a);
                AlignLinearGraphLabelEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("TransitionProgress", "Number:double");
            b.item("Orientation", "ExportedType:string:LinearScaleOrientation");
            b.item("Orientation@names", "Horizontal;Vertical");
            b.item("ScaleBackgroundBrush", "Brush");
            b.item("ScaleBackgroundOutline", "Brush");
            b.item("ScaleBackgroundThickness", "Number:double");
            b.item("Ranges", "Collection:LinearGraphRange:LinearGraphRangeCollection:LinearGraphRange");
            b.item("RangeBrushes", "BrushCollection:string");
            b.item("RangeOutlines", "BrushCollection:string");
            b.item("MinimumValue", "Number:double");
            b.item("ActualMinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("ActualMaximumValue", "Number:double");
            b.item("TargetValue", "Number:double");
            b.item("TargetValueName", "String");
            b.item("Value", "Number:double");
            b.item("ValueName", "String");
            b.item("RangeInnerExtent", "Number:double");
            b.item("RangeOuterExtent", "Number:double");
            b.item("ValueInnerExtent", "Number:double");
            b.item("ValueOuterExtent", "Number:double");
            b.item("Interval", "Number:double");
            b.item("TicksPostInitial", "Number:double");
            b.item("TicksPreTerminal", "Number:double");
            b.item("LabelInterval", "Number:double");
            b.item("LabelExtent", "Number:double");
            b.item("LabelsPostInitial", "Number:double");
            b.item("LabelsPreTerminal", "Number:double");
            b.item("MinorTickCount", "Number:double");
            b.item("TickStartExtent", "Number:double");
            b.item("TickEndExtent", "Number:double");
            b.item("TickStrokeThickness", "Number:double");
            b.item("TickBrush", "Brush");
            b.item("FontBrush", "Brush");
            b.item("ValueBrush", "Brush");
            b.item("ValueOutline", "Brush");
            b.item("ValueStrokeThickness", "Number:double");
            b.item("MinorTickStartExtent", "Number:double");
            b.item("MinorTickEndExtent", "Number:double");
            b.item("MinorTickStrokeThickness", "Number:double");
            b.item("MinorTickBrush", "Brush");
            b.item("IsScaleInverted", "Boolean");
            b.item("BackingBrush", "Brush");
            b.item("BackingOutline", "Brush");
            b.item("BackingStrokeThickness", "Number:double");
            b.item("BackingInnerExtent", "Number:double");
            b.item("BackingOuterExtent", "Number:double");
            b.item("ScaleStartExtent", "Number:double");
            b.item("ScaleEndExtent", "Number:double");
            b.item("TargetValueBrush", "Brush");
            b.item("TargetValueBreadth", "Number:double");
            b.item("TargetValueInnerExtent", "Number:double");
            b.item("TargetValueOuterExtent", "Number:double");
            b.item("TargetValueOutline", "Brush");
            b.item("TargetValueStrokeThickness", "Number:double");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("TransitionDuration", "Number:int");
            b.item("ShowToolTipTimeout", "Number:int");
            b.item("ShowToolTip", "Boolean");
            b.item("Font", "String");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("FormatLabelRef", "EventRef::formatLabel");
            b.item("AlignLabelRef", "EventRef::alignLabel");
            b.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            b.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            BulletGraphDescriptionMetadata.e(a, b);
        }
        static d(a) {
            BulletGraphDescriptionMetadata.b(a);
            a.q("BulletGraph", () => new BulletGraphDescription());
            a.p("BulletGraph", BulletGraphDescriptionMetadata.a);
        }
    }
    BulletGraphDescriptionMetadata.$t = /*@__PURE__*/ markType(BulletGraphDescriptionMetadata, 'BulletGraphDescriptionMetadata');
    BulletGraphDescriptionMetadata.a = null;
    return BulletGraphDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGraphRangeDescription = /*@__PURE__*/ (() => {
    class LinearGraphRangeDescription extends Description {
        constructor() {
            super();
            this.u = null;
            this.t = null;
            this.v = null;
            this.k = 0;
            this.f = 0;
            this.h = 0;
            this.g = 0;
            this.j = 0;
            this.i = 0;
            this.l = 0;
        }
        get_type() {
            return "LinearGraphRange";
        }
        get type() {
            return this.get_type();
        }
        get name() {
            return this.u;
        }
        set name(a) {
            this.u = a;
            this.e("Name");
        }
        get brush() {
            return this.t;
        }
        set brush(a) {
            this.t = a;
            this.e("Brush");
        }
        get outline() {
            return this.v;
        }
        set outline(a) {
            this.v = a;
            this.e("Outline");
        }
        get startValue() {
            return this.k;
        }
        set startValue(a) {
            this.k = a;
            this.e("StartValue");
        }
        get endValue() {
            return this.f;
        }
        set endValue(a) {
            this.f = a;
            this.e("EndValue");
        }
        get innerStartExtent() {
            return this.h;
        }
        set innerStartExtent(a) {
            this.h = a;
            this.e("InnerStartExtent");
        }
        get innerEndExtent() {
            return this.g;
        }
        set innerEndExtent(a) {
            this.g = a;
            this.e("InnerEndExtent");
        }
        get outerStartExtent() {
            return this.j;
        }
        set outerStartExtent(a) {
            this.j = a;
            this.e("OuterStartExtent");
        }
        get outerEndExtent() {
            return this.i;
        }
        set outerEndExtent(a) {
            this.i = a;
            this.e("OuterEndExtent");
        }
        get strokeThickness() {
            return this.l;
        }
        set strokeThickness(a) {
            this.l = a;
            this.e("StrokeThickness");
        }
    }
    LinearGraphRangeDescription.$t = /*@__PURE__*/ markType(LinearGraphRangeDescription, 'LinearGraphRangeDescription', Description.$);
    return LinearGraphRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGraphRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class LinearGraphRangeDescriptionMetadata extends Base {
        static b(a) {
            if (LinearGraphRangeDescriptionMetadata.a == null) {
                LinearGraphRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LinearGraphRangeDescriptionMetadata.c(a, LinearGraphRangeDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Name", "String");
            b.item("Brush", "Brush");
            b.item("Outline", "Brush");
            b.item("StartValue", "Number:double");
            b.item("EndValue", "Number:double");
            b.item("InnerStartExtent", "Number:double");
            b.item("InnerEndExtent", "Number:double");
            b.item("OuterStartExtent", "Number:double");
            b.item("OuterEndExtent", "Number:double");
            b.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            LinearGraphRangeDescriptionMetadata.b(a);
            a.q("LinearGraphRange", () => new LinearGraphRangeDescription());
            a.p("LinearGraphRange", LinearGraphRangeDescriptionMetadata.a);
        }
    }
    LinearGraphRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(LinearGraphRangeDescriptionMetadata, 'LinearGraphRangeDescriptionMetadata');
    LinearGraphRangeDescriptionMetadata.a = null;
    return LinearGraphRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGraphRangeDescriptionModule = /*@__PURE__*/ (() => {
    class LinearGraphRangeDescriptionModule extends Base {
        static register(a) {
            LinearGraphRangeDescriptionMetadata.d(a);
        }
    }
    LinearGraphRangeDescriptionModule.$t = /*@__PURE__*/ markType(LinearGraphRangeDescriptionModule, 'LinearGraphRangeDescriptionModule');
    return LinearGraphRangeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierDescription = /*@__PURE__*/ (() => {
    class FormatSpecifierDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FormatSpecifier";
        }
        get type() {
            return this.get_type();
        }
    }
    FormatSpecifierDescription.$t = /*@__PURE__*/ markType(FormatSpecifierDescription, 'FormatSpecifierDescription', Description.$);
    FormatSpecifierDescription.__marshalByValue = true;
    FormatSpecifierDescription.__marshalByValueAlias = "FormatSpecifier";
    return FormatSpecifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatSpecifierDescriptionMetadata extends Base {
        static b(a) {
            if (FormatSpecifierDescriptionMetadata.a == null) {
                FormatSpecifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatSpecifierDescriptionMetadata.c(a, FormatSpecifierDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FormatSpecifierDescriptionMetadata.b(a);
            a.q("FormatSpecifier", () => new FormatSpecifierDescription());
            a.p("FormatSpecifier", FormatSpecifierDescriptionMetadata.a);
        }
    }
    FormatSpecifierDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatSpecifierDescriptionMetadata, 'FormatSpecifierDescriptionMetadata');
    FormatSpecifierDescriptionMetadata.a = null;
    return FormatSpecifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifierDescription = /*@__PURE__*/ (() => {
    class NumberFormatSpecifierDescription extends FormatSpecifierDescription {
        constructor() {
            super();
            this.aa = null;
            this.w = null;
            this.x = null;
            this.y = null;
            this.z = null;
            this.ab = null;
            this.ac = null;
            this.ad = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.ah = null;
            this.j = false;
            this.o = 0;
            this.n = 0;
            this.l = 0;
            this.p = 0;
            this.m = 0;
        }
        get_type() {
            return "NumberFormatSpecifier";
        }
        get locale() {
            return this.aa;
        }
        set locale(a) {
            this.aa = a;
            this.e("Locale");
        }
        get compactDisplay() {
            return this.w;
        }
        set compactDisplay(a) {
            this.w = a;
            this.e("CompactDisplay");
        }
        get currency() {
            return this.x;
        }
        set currency(a) {
            this.x = a;
            this.e("Currency");
        }
        get currencyDisplay() {
            return this.y;
        }
        set currencyDisplay(a) {
            this.y = a;
            this.e("CurrencyDisplay");
        }
        get currencySign() {
            return this.z;
        }
        set currencySign(a) {
            this.z = a;
            this.e("CurrencySign");
        }
        get localeMatcher() {
            return this.ab;
        }
        set localeMatcher(a) {
            this.ab = a;
            this.e("LocaleMatcher");
        }
        get notation() {
            return this.ac;
        }
        set notation(a) {
            this.ac = a;
            this.e("Notation");
        }
        get numberingSystem() {
            return this.ad;
        }
        set numberingSystem(a) {
            this.ad = a;
            this.e("NumberingSystem");
        }
        get signDisplay() {
            return this.ae;
        }
        set signDisplay(a) {
            this.ae = a;
            this.e("SignDisplay");
        }
        get style() {
            return this.af;
        }
        set style(a) {
            this.af = a;
            this.e("Style");
        }
        get unit() {
            return this.ag;
        }
        set unit(a) {
            this.ag = a;
            this.e("Unit");
        }
        get unitDisplay() {
            return this.ah;
        }
        set unitDisplay(a) {
            this.ah = a;
            this.e("UnitDisplay");
        }
        get useGrouping() {
            return this.j;
        }
        set useGrouping(a) {
            this.j = a;
            this.e("UseGrouping");
        }
        get minimumIntegerDigits() {
            return this.o;
        }
        set minimumIntegerDigits(a) {
            this.o = a;
            this.e("MinimumIntegerDigits");
        }
        get minimumFractionDigits() {
            return this.n;
        }
        set minimumFractionDigits(a) {
            this.n = a;
            this.e("MinimumFractionDigits");
        }
        get maximumFractionDigits() {
            return this.l;
        }
        set maximumFractionDigits(a) {
            this.l = a;
            this.e("MaximumFractionDigits");
        }
        get minimumSignificantDigits() {
            return this.p;
        }
        set minimumSignificantDigits(a) {
            this.p = a;
            this.e("MinimumSignificantDigits");
        }
        get maximumSignificantDigits() {
            return this.m;
        }
        set maximumSignificantDigits(a) {
            this.m = a;
            this.e("MaximumSignificantDigits");
        }
    }
    NumberFormatSpecifierDescription.$t = /*@__PURE__*/ markType(NumberFormatSpecifierDescription, 'NumberFormatSpecifierDescription', FormatSpecifierDescription.$);
    NumberFormatSpecifierDescription.__marshalByValue1 = true;
    NumberFormatSpecifierDescription.__marshalByValueAlias1 = "NumberFormatSpecifier";
    return NumberFormatSpecifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumberFormatSpecifierDescriptionMetadata extends Base {
        static b(a) {
            if (NumberFormatSpecifierDescriptionMetadata.a == null) {
                NumberFormatSpecifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumberFormatSpecifierDescriptionMetadata.c(a, NumberFormatSpecifierDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FormatSpecifierDescriptionMetadata.c(a, b);
            b.item("Locale", "String");
            b.item("CompactDisplay", "String");
            b.item("Currency", "String");
            b.item("CurrencyDisplay", "String");
            b.item("CurrencySign", "String");
            b.item("LocaleMatcher", "String");
            b.item("Notation", "String");
            b.item("NumberingSystem", "String");
            b.item("SignDisplay", "String");
            b.item("Style", "String");
            b.item("Unit", "String");
            b.item("UnitDisplay", "String");
            b.item("UseGrouping", "Boolean");
            b.item("MinimumIntegerDigits", "Number:int");
            b.item("MinimumFractionDigits", "Number:int");
            b.item("MaximumFractionDigits", "Number:int");
            b.item("MinimumSignificantDigits", "Number:int");
            b.item("MaximumSignificantDigits", "Number:int");
        }
        static d(a) {
            NumberFormatSpecifierDescriptionMetadata.b(a);
            a.q("NumberFormatSpecifier", () => new NumberFormatSpecifierDescription());
            a.p("NumberFormatSpecifier", NumberFormatSpecifierDescriptionMetadata.a);
        }
    }
    NumberFormatSpecifierDescriptionMetadata.$t = /*@__PURE__*/ markType(NumberFormatSpecifierDescriptionMetadata, 'NumberFormatSpecifierDescriptionMetadata');
    NumberFormatSpecifierDescriptionMetadata.a = null;
    return NumberFormatSpecifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberFormatSpecifierDescriptionModule = /*@__PURE__*/ (() => {
    class NumberFormatSpecifierDescriptionModule extends Base {
        static register(a) {
            NumberFormatSpecifierDescriptionMetadata.d(a);
        }
    }
    NumberFormatSpecifierDescriptionModule.$t = /*@__PURE__*/ markType(NumberFormatSpecifierDescriptionModule, 'NumberFormatSpecifierDescriptionModule');
    return NumberFormatSpecifierDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphCoreDescriptionModule = /*@__PURE__*/ (() => {
    class BulletGraphCoreDescriptionModule extends Base {
        static register(a) {
            BulletGraphDescriptionMetadata.d(a);
            LinearGraphRangeDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
        }
    }
    BulletGraphCoreDescriptionModule.$t = /*@__PURE__*/ markType(BulletGraphCoreDescriptionModule, 'BulletGraphCoreDescriptionModule');
    return BulletGraphCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TooltipContainerDescriptionModule = /*@__PURE__*/ (() => {
    class TooltipContainerDescriptionModule extends Base {
        static register(a) {
        }
    }
    TooltipContainerDescriptionModule.$t = /*@__PURE__*/ markType(TooltipContainerDescriptionModule, 'TooltipContainerDescriptionModule');
    return TooltipContainerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleDefaultTooltipDescriptionMetadata = /*@__PURE__*/ (() => {
    class SimpleDefaultTooltipDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    SimpleDefaultTooltipDescriptionMetadata.$t = /*@__PURE__*/ markType(SimpleDefaultTooltipDescriptionMetadata, 'SimpleDefaultTooltipDescriptionMetadata');
    return SimpleDefaultTooltipDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DVInteractivityDescriptionModule = /*@__PURE__*/ (() => {
    class DVInteractivityDescriptionModule extends Base {
        static register(a) {
            TooltipContainerDescriptionModule.register(a);
            SimpleDefaultTooltipDescriptionMetadata.register(a);
        }
    }
    DVInteractivityDescriptionModule.$t = /*@__PURE__*/ markType(DVInteractivityDescriptionModule, 'DVInteractivityDescriptionModule');
    return DVInteractivityDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BulletGraphDescriptionModule = /*@__PURE__*/ (() => {
    class BulletGraphDescriptionModule extends Base {
        static register(a) {
            BulletGraphCoreDescriptionModule.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    BulletGraphDescriptionModule.$t = /*@__PURE__*/ markType(BulletGraphDescriptionModule, 'BulletGraphDescriptionModule');
    return BulletGraphDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonDescription = /*@__PURE__*/ (() => {
    class ButtonDescription extends Description {
        constructor() {
            super();
            this.au = 0;
            this.at = 0;
            this.el = null;
            this.eg = null;
            this.ed = null;
            this.dx = null;
            this.dw = null;
            this.d9 = null;
            this.d6 = null;
            this.du = null;
            this.ca = 0;
            this.b8 = 0;
            this.b9 = 0;
            this.d7 = null;
            this.v = 0;
            this.u = 0;
            this.w = 0;
            this.x = 0;
            this.dv = null;
            this.dy = null;
            this.dz = null;
            this.d0 = null;
            this.b7 = 0;
            this.d1 = null;
            this.d8 = null;
            this.d5 = null;
            this.d2 = null;
            this.d3 = null;
            this.d4 = null;
            this.t = 0;
            this.f7 = null;
            this.f9 = null;
            this.ga = null;
            this.gb = null;
            this.cu = 0;
            this.ge = null;
            this.f8 = null;
            this.cx = 0;
            this.cw = 0;
            this.cv = 0;
            this.a0 = 0;
            this.a2 = 0;
            this.a1 = 0;
            this.a3 = 0;
            this.a4 = 0;
            this.gg = null;
            this.ey = null;
            this.e0 = null;
            this.e1 = null;
            this.e2 = null;
            this.cg = 0;
            this.e5 = null;
            this.ez = null;
            this.cj = 0;
            this.ci = 0;
            this.ch = 0;
            this.e7 = null;
            this.e8 = null;
            this.e6 = null;
            this.e3 = null;
            this.e4 = null;
            this.ai = 0;
            this.ak = 0;
            this.aj = 0;
            this.al = 0;
            this.am = 0;
            this.ec = null;
            this.eh = null;
            this.ei = null;
            this.ej = null;
            this.cb = 0;
            this.em = null;
            this.fg = null;
            this.ee = null;
            this.cy = 0;
            this.cl = 0;
            this.ck = 0;
            this.fd = null;
            this.an = 0;
            this.fe = null;
            this.ff = null;
            this.gj = null;
            this.fh = null;
            this.gi = null;
            this.gh = null;
            this.gf = null;
            this.gc = null;
            this.gd = null;
            this.fb = null;
            this.fc = null;
            this.y = 0;
            this.aa = 0;
            this.z = 0;
            this.ab = 0;
            this.ac = 0;
            this.fw = null;
            this.fy = null;
            this.fz = null;
            this.f0 = null;
            this.cq = 0;
            this.f3 = null;
            this.fx = null;
            this.ct = 0;
            this.cs = 0;
            this.cr = 0;
            this.av = 0;
            this.ax = 0;
            this.aw = 0;
            this.ay = 0;
            this.az = 0;
            this.f5 = null;
            this.f6 = null;
            this.f4 = null;
            this.f1 = null;
            this.f2 = null;
            this.en = null;
            this.ep = null;
            this.eq = null;
            this.er = null;
            this.cc = 0;
            this.eu = null;
            this.eo = null;
            this.cf = 0;
            this.ce = 0;
            this.cd = 0;
            this.ad = 0;
            this.af = 0;
            this.ae = 0;
            this.ag = 0;
            this.ah = 0;
            this.ew = null;
            this.ex = null;
            this.ev = null;
            this.es = null;
            this.et = null;
            this.fi = null;
            this.fk = null;
            this.fl = null;
            this.fm = null;
            this.cm = 0;
            this.fp = null;
            this.fj = null;
            this.cp = 0;
            this.co = 0;
            this.cn = 0;
            this.ao = 0;
            this.aq = 0;
            this.ap = 0;
            this.ar = 0;
            this.as = 0;
            this.fr = null;
            this.fs = null;
            this.fq = null;
            this.fn = null;
            this.fo = null;
            this.fu = null;
            this.ft = null;
            this.ek = null;
            this.e9 = null;
            this.fa = null;
            this.ea = null;
            this.gk = null;
            this.fv = null;
            this.cz = 0;
            this.eb = null;
            this.j = false;
            this.k = false;
            this.h = false;
            this.f = false;
            this.l = false;
            this.g = false;
            this.i = false;
            this.ef = null;
        }
        get_type() {
            return "Button";
        }
        get type() {
            return this.get_type();
        }
        get minWidth() {
            return this.au;
        }
        set minWidth(a) {
            this.au = a;
            this.e("MinWidth");
        }
        get minHeight() {
            return this.at;
        }
        set minHeight(a) {
            this.at = a;
            this.e("MinHeight");
        }
        get displayType() {
            return this.el;
        }
        set displayType(a) {
            this.el = a;
            this.e("DisplayType");
        }
        get density() {
            return this.eg;
        }
        set density(a) {
            this.eg = a;
            this.e("Density");
        }
        get baseTheme() {
            return this.ed;
        }
        set baseTheme(a) {
            this.ed = a;
            this.e("BaseTheme");
        }
        get actualDensity() {
            return this.dx;
        }
        set actualDensity(a) {
            this.dx = a;
            this.e("ActualDensity");
        }
        get actualBorderColor() {
            return this.dw;
        }
        set actualBorderColor(a) {
            this.dw = a;
            this.e("ActualBorderColor");
        }
        get actualUmbraShadowColor() {
            return this.d9;
        }
        set actualUmbraShadowColor(a) {
            this.d9 = a;
            this.e("ActualUmbraShadowColor");
        }
        get actualPenumbraShadowColor() {
            return this.d6;
        }
        set actualPenumbraShadowColor(a) {
            this.d6 = a;
            this.e("ActualPenumbraShadowColor");
        }
        get actualAmbientShadowColor() {
            return this.du;
        }
        set actualAmbientShadowColor(a) {
            this.du = a;
            this.e("ActualAmbientShadowColor");
        }
        get actualRestingElevation() {
            return this.ca;
        }
        set actualRestingElevation(a) {
            this.ca = a;
            this.e("ActualRestingElevation");
        }
        get actualFocusElevation() {
            return this.b8;
        }
        set actualFocusElevation(a) {
            this.b8 = a;
            this.e("ActualFocusElevation");
        }
        get actualHoverElevation() {
            return this.b9;
        }
        set actualHoverElevation(a) {
            this.b9 = a;
            this.e("ActualHoverElevation");
        }
        get actualRippleColor() {
            return this.d7;
        }
        set actualRippleColor(a) {
            this.d7 = a;
            this.e("ActualRippleColor");
        }
        get actualCornerRadiusBottomRight() {
            return this.v;
        }
        set actualCornerRadiusBottomRight(a) {
            this.v = a;
            this.e("ActualCornerRadiusBottomRight");
        }
        get actualCornerRadiusBottomLeft() {
            return this.u;
        }
        set actualCornerRadiusBottomLeft(a) {
            this.u = a;
            this.e("ActualCornerRadiusBottomLeft");
        }
        get actualCornerRadiusTopLeft() {
            return this.w;
        }
        set actualCornerRadiusTopLeft(a) {
            this.w = a;
            this.e("ActualCornerRadiusTopLeft");
        }
        get actualCornerRadiusTopRight() {
            return this.x;
        }
        set actualCornerRadiusTopRight(a) {
            this.x = a;
            this.e("ActualCornerRadiusTopRight");
        }
        get actualBackgroundColor() {
            return this.dv;
        }
        set actualBackgroundColor(a) {
            this.dv = a;
            this.e("ActualBackgroundColor");
        }
        get actualDisabledBackgroundColor() {
            return this.dy;
        }
        set actualDisabledBackgroundColor(a) {
            this.dy = a;
            this.e("ActualDisabledBackgroundColor");
        }
        get actualDisabledBorderColor() {
            return this.dz;
        }
        set actualDisabledBorderColor(a) {
            this.dz = a;
            this.e("ActualDisabledBorderColor");
        }
        get actualDisabledTextColor() {
            return this.d0;
        }
        set actualDisabledTextColor(a) {
            this.d0 = a;
            this.e("ActualDisabledTextColor");
        }
        get actualDisabledElevation() {
            return this.b7;
        }
        set actualDisabledElevation(a) {
            this.b7 = a;
            this.e("ActualDisabledElevation");
        }
        get actualElevationMode() {
            return this.d1;
        }
        set actualElevationMode(a) {
            this.d1 = a;
            this.e("ActualElevationMode");
        }
        get actualTextColor() {
            return this.d8;
        }
        set actualTextColor(a) {
            this.d8 = a;
            this.e("ActualTextColor");
        }
        get actualHoverTextColor() {
            return this.d5;
        }
        set actualHoverTextColor(a) {
            this.d5 = a;
            this.e("ActualHoverTextColor");
        }
        get actualFocusBackgroundColor() {
            return this.d2;
        }
        set actualFocusBackgroundColor(a) {
            this.d2 = a;
            this.e("ActualFocusBackgroundColor");
        }
        get actualFocusTextColor() {
            return this.d3;
        }
        set actualFocusTextColor(a) {
            this.d3 = a;
            this.e("ActualFocusTextColor");
        }
        get actualHoverBackgroundColor() {
            return this.d4;
        }
        set actualHoverBackgroundColor(a) {
            this.d4 = a;
            this.e("ActualHoverBackgroundColor");
        }
        get actualBorderWidth() {
            return this.t;
        }
        set actualBorderWidth(a) {
            this.t = a;
            this.e("ActualBorderWidth");
        }
        get raisedBackgroundColor() {
            return this.f7;
        }
        set raisedBackgroundColor(a) {
            this.f7 = a;
            this.e("RaisedBackgroundColor");
        }
        get raisedDisabledBackgroundColor() {
            return this.f9;
        }
        set raisedDisabledBackgroundColor(a) {
            this.f9 = a;
            this.e("RaisedDisabledBackgroundColor");
        }
        get raisedDisabledBorderColor() {
            return this.ga;
        }
        set raisedDisabledBorderColor(a) {
            this.ga = a;
            this.e("RaisedDisabledBorderColor");
        }
        get raisedDisabledTextColor() {
            return this.gb;
        }
        set raisedDisabledTextColor(a) {
            this.gb = a;
            this.e("RaisedDisabledTextColor");
        }
        get raisedDisabledElevation() {
            return this.cu;
        }
        set raisedDisabledElevation(a) {
            this.cu = a;
            this.e("RaisedDisabledElevation");
        }
        get raisedHoverBackgroundColor() {
            return this.ge;
        }
        set raisedHoverBackgroundColor(a) {
            this.ge = a;
            this.e("RaisedHoverBackgroundColor");
        }
        get raisedBorderColor() {
            return this.f8;
        }
        set raisedBorderColor(a) {
            this.f8 = a;
            this.e("RaisedBorderColor");
        }
        get raisedRestingElevation() {
            return this.cx;
        }
        set raisedRestingElevation(a) {
            this.cx = a;
            this.e("RaisedRestingElevation");
        }
        get raisedHoverElevation() {
            return this.cw;
        }
        set raisedHoverElevation(a) {
            this.cw = a;
            this.e("RaisedHoverElevation");
        }
        get raisedFocusElevation() {
            return this.cv;
        }
        set raisedFocusElevation(a) {
            this.cv = a;
            this.e("RaisedFocusElevation");
        }
        get raisedBorderWidth() {
            return this.a0;
        }
        set raisedBorderWidth(a) {
            this.a0 = a;
            this.e("RaisedBorderWidth");
        }
        get raisedCornerRadiusBottomRight() {
            return this.a2;
        }
        set raisedCornerRadiusBottomRight(a) {
            this.a2 = a;
            this.e("RaisedCornerRadiusBottomRight");
        }
        get raisedCornerRadiusBottomLeft() {
            return this.a1;
        }
        set raisedCornerRadiusBottomLeft(a) {
            this.a1 = a;
            this.e("RaisedCornerRadiusBottomLeft");
        }
        get raisedCornerRadiusTopLeft() {
            return this.a3;
        }
        set raisedCornerRadiusTopLeft(a) {
            this.a3 = a;
            this.e("RaisedCornerRadiusTopLeft");
        }
        get raisedCornerRadiusTopRight() {
            return this.a4;
        }
        set raisedCornerRadiusTopRight(a) {
            this.a4 = a;
            this.e("RaisedCornerRadiusTopRight");
        }
        get raisedRippleColor() {
            return this.gg;
        }
        set raisedRippleColor(a) {
            this.gg = a;
            this.e("RaisedRippleColor");
        }
        get flatBackgroundColor() {
            return this.ey;
        }
        set flatBackgroundColor(a) {
            this.ey = a;
            this.e("FlatBackgroundColor");
        }
        get flatDisabledBackgroundColor() {
            return this.e0;
        }
        set flatDisabledBackgroundColor(a) {
            this.e0 = a;
            this.e("FlatDisabledBackgroundColor");
        }
        get flatDisabledBorderColor() {
            return this.e1;
        }
        set flatDisabledBorderColor(a) {
            this.e1 = a;
            this.e("FlatDisabledBorderColor");
        }
        get flatDisabledTextColor() {
            return this.e2;
        }
        set flatDisabledTextColor(a) {
            this.e2 = a;
            this.e("FlatDisabledTextColor");
        }
        get flatDisabledElevation() {
            return this.cg;
        }
        set flatDisabledElevation(a) {
            this.cg = a;
            this.e("FlatDisabledElevation");
        }
        get flatHoverBackgroundColor() {
            return this.e5;
        }
        set flatHoverBackgroundColor(a) {
            this.e5 = a;
            this.e("FlatHoverBackgroundColor");
        }
        get flatBorderColor() {
            return this.ez;
        }
        set flatBorderColor(a) {
            this.ez = a;
            this.e("FlatBorderColor");
        }
        get flatRestingElevation() {
            return this.cj;
        }
        set flatRestingElevation(a) {
            this.cj = a;
            this.e("FlatRestingElevation");
        }
        get flatHoverElevation() {
            return this.ci;
        }
        set flatHoverElevation(a) {
            this.ci = a;
            this.e("FlatHoverElevation");
        }
        get flatFocusElevation() {
            return this.ch;
        }
        set flatFocusElevation(a) {
            this.ch = a;
            this.e("FlatFocusElevation");
        }
        get flatRippleColor() {
            return this.e7;
        }
        set flatRippleColor(a) {
            this.e7 = a;
            this.e("FlatRippleColor");
        }
        get flatTextColor() {
            return this.e8;
        }
        set flatTextColor(a) {
            this.e8 = a;
            this.e("FlatTextColor");
        }
        get flatHoverTextColor() {
            return this.e6;
        }
        set flatHoverTextColor(a) {
            this.e6 = a;
            this.e("FlatHoverTextColor");
        }
        get flatFocusBackgroundColor() {
            return this.e3;
        }
        set flatFocusBackgroundColor(a) {
            this.e3 = a;
            this.e("FlatFocusBackgroundColor");
        }
        get flatFocusTextColor() {
            return this.e4;
        }
        set flatFocusTextColor(a) {
            this.e4 = a;
            this.e("FlatFocusTextColor");
        }
        get flatBorderWidth() {
            return this.ai;
        }
        set flatBorderWidth(a) {
            this.ai = a;
            this.e("FlatBorderWidth");
        }
        get flatCornerRadiusBottomRight() {
            return this.ak;
        }
        set flatCornerRadiusBottomRight(a) {
            this.ak = a;
            this.e("FlatCornerRadiusBottomRight");
        }
        get flatCornerRadiusBottomLeft() {
            return this.aj;
        }
        set flatCornerRadiusBottomLeft(a) {
            this.aj = a;
            this.e("FlatCornerRadiusBottomLeft");
        }
        get flatCornerRadiusTopLeft() {
            return this.al;
        }
        set flatCornerRadiusTopLeft(a) {
            this.al = a;
            this.e("FlatCornerRadiusTopLeft");
        }
        get flatCornerRadiusTopRight() {
            return this.am;
        }
        set flatCornerRadiusTopRight(a) {
            this.am = a;
            this.e("FlatCornerRadiusTopRight");
        }
        get backgroundColor() {
            return this.ec;
        }
        set backgroundColor(a) {
            this.ec = a;
            this.e("BackgroundColor");
        }
        get disabledBackgroundColor() {
            return this.eh;
        }
        set disabledBackgroundColor(a) {
            this.eh = a;
            this.e("DisabledBackgroundColor");
        }
        get disabledBorderColor() {
            return this.ei;
        }
        set disabledBorderColor(a) {
            this.ei = a;
            this.e("DisabledBorderColor");
        }
        get disabledTextColor() {
            return this.ej;
        }
        set disabledTextColor(a) {
            this.ej = a;
            this.e("DisabledTextColor");
        }
        get disabledElevation() {
            return this.cb;
        }
        set disabledElevation(a) {
            this.cb = a;
            this.e("DisabledElevation");
        }
        get elevationMode() {
            return this.em;
        }
        set elevationMode(a) {
            this.em = a;
            this.e("ElevationMode");
        }
        get hoverBackgroundColor() {
            return this.fg;
        }
        set hoverBackgroundColor(a) {
            this.fg = a;
            this.e("HoverBackgroundColor");
        }
        get borderColor() {
            return this.ee;
        }
        set borderColor(a) {
            this.ee = a;
            this.e("BorderColor");
        }
        get restingElevation() {
            return this.cy;
        }
        set restingElevation(a) {
            this.cy = a;
            this.e("RestingElevation");
        }
        get hoverElevation() {
            return this.cl;
        }
        set hoverElevation(a) {
            this.cl = a;
            this.e("HoverElevation");
        }
        get focusElevation() {
            return this.ck;
        }
        set focusElevation(a) {
            this.ck = a;
            this.e("FocusElevation");
        }
        get fontFamily() {
            return this.fd;
        }
        set fontFamily(a) {
            this.fd = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.an;
        }
        set fontSize(a) {
            this.an = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.fe;
        }
        set fontStyle(a) {
            this.fe = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.ff;
        }
        set fontWeight(a) {
            this.ff = a;
            this.e("FontWeight");
        }
        get textColor() {
            return this.gj;
        }
        set textColor(a) {
            this.gj = a;
            this.e("TextColor");
        }
        get hoverTextColor() {
            return this.fh;
        }
        set hoverTextColor(a) {
            this.fh = a;
            this.e("HoverTextColor");
        }
        get rippleColor() {
            return this.gi;
        }
        set rippleColor(a) {
            this.gi = a;
            this.e("RippleColor");
        }
        get raisedTextColor() {
            return this.gh;
        }
        set raisedTextColor(a) {
            this.gh = a;
            this.e("RaisedTextColor");
        }
        get raisedHoverTextColor() {
            return this.gf;
        }
        set raisedHoverTextColor(a) {
            this.gf = a;
            this.e("RaisedHoverTextColor");
        }
        get raisedFocusBackgroundColor() {
            return this.gc;
        }
        set raisedFocusBackgroundColor(a) {
            this.gc = a;
            this.e("RaisedFocusBackgroundColor");
        }
        get raisedFocusTextColor() {
            return this.gd;
        }
        set raisedFocusTextColor(a) {
            this.gd = a;
            this.e("RaisedFocusTextColor");
        }
        get focusBackgroundColor() {
            return this.fb;
        }
        set focusBackgroundColor(a) {
            this.fb = a;
            this.e("FocusBackgroundColor");
        }
        get focusTextColor() {
            return this.fc;
        }
        set focusTextColor(a) {
            this.fc = a;
            this.e("FocusTextColor");
        }
        get borderWidth() {
            return this.y;
        }
        set borderWidth(a) {
            this.y = a;
            this.e("BorderWidth");
        }
        get cornerRadiusBottomRight() {
            return this.aa;
        }
        set cornerRadiusBottomRight(a) {
            this.aa = a;
            this.e("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.z;
        }
        set cornerRadiusBottomLeft(a) {
            this.z = a;
            this.e("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.ab;
        }
        set cornerRadiusTopLeft(a) {
            this.ab = a;
            this.e("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.ac;
        }
        set cornerRadiusTopRight(a) {
            this.ac = a;
            this.e("CornerRadiusTopRight");
        }
        get outlinedBackgroundColor() {
            return this.fw;
        }
        set outlinedBackgroundColor(a) {
            this.fw = a;
            this.e("OutlinedBackgroundColor");
        }
        get outlinedDisabledBackgroundColor() {
            return this.fy;
        }
        set outlinedDisabledBackgroundColor(a) {
            this.fy = a;
            this.e("OutlinedDisabledBackgroundColor");
        }
        get outlinedDisabledBorderColor() {
            return this.fz;
        }
        set outlinedDisabledBorderColor(a) {
            this.fz = a;
            this.e("OutlinedDisabledBorderColor");
        }
        get outlinedDisabledTextColor() {
            return this.f0;
        }
        set outlinedDisabledTextColor(a) {
            this.f0 = a;
            this.e("OutlinedDisabledTextColor");
        }
        get outlinedDisabledElevation() {
            return this.cq;
        }
        set outlinedDisabledElevation(a) {
            this.cq = a;
            this.e("OutlinedDisabledElevation");
        }
        get outlinedHoverBackgroundColor() {
            return this.f3;
        }
        set outlinedHoverBackgroundColor(a) {
            this.f3 = a;
            this.e("OutlinedHoverBackgroundColor");
        }
        get outlinedBorderColor() {
            return this.fx;
        }
        set outlinedBorderColor(a) {
            this.fx = a;
            this.e("OutlinedBorderColor");
        }
        get outlinedRestingElevation() {
            return this.ct;
        }
        set outlinedRestingElevation(a) {
            this.ct = a;
            this.e("OutlinedRestingElevation");
        }
        get outlinedHoverElevation() {
            return this.cs;
        }
        set outlinedHoverElevation(a) {
            this.cs = a;
            this.e("OutlinedHoverElevation");
        }
        get outlinedFocusElevation() {
            return this.cr;
        }
        set outlinedFocusElevation(a) {
            this.cr = a;
            this.e("OutlinedFocusElevation");
        }
        get outlinedBorderWidth() {
            return this.av;
        }
        set outlinedBorderWidth(a) {
            this.av = a;
            this.e("OutlinedBorderWidth");
        }
        get outlinedCornerRadiusBottomRight() {
            return this.ax;
        }
        set outlinedCornerRadiusBottomRight(a) {
            this.ax = a;
            this.e("OutlinedCornerRadiusBottomRight");
        }
        get outlinedCornerRadiusBottomLeft() {
            return this.aw;
        }
        set outlinedCornerRadiusBottomLeft(a) {
            this.aw = a;
            this.e("OutlinedCornerRadiusBottomLeft");
        }
        get outlinedCornerRadiusTopLeft() {
            return this.ay;
        }
        set outlinedCornerRadiusTopLeft(a) {
            this.ay = a;
            this.e("OutlinedCornerRadiusTopLeft");
        }
        get outlinedCornerRadiusTopRight() {
            return this.az;
        }
        set outlinedCornerRadiusTopRight(a) {
            this.az = a;
            this.e("OutlinedCornerRadiusTopRight");
        }
        get outlinedRippleColor() {
            return this.f5;
        }
        set outlinedRippleColor(a) {
            this.f5 = a;
            this.e("OutlinedRippleColor");
        }
        get outlinedTextColor() {
            return this.f6;
        }
        set outlinedTextColor(a) {
            this.f6 = a;
            this.e("OutlinedTextColor");
        }
        get outlinedHoverTextColor() {
            return this.f4;
        }
        set outlinedHoverTextColor(a) {
            this.f4 = a;
            this.e("OutlinedHoverTextColor");
        }
        get outlinedFocusBackgroundColor() {
            return this.f1;
        }
        set outlinedFocusBackgroundColor(a) {
            this.f1 = a;
            this.e("OutlinedFocusBackgroundColor");
        }
        get outlinedFocusTextColor() {
            return this.f2;
        }
        set outlinedFocusTextColor(a) {
            this.f2 = a;
            this.e("OutlinedFocusTextColor");
        }
        get fabBackgroundColor() {
            return this.en;
        }
        set fabBackgroundColor(a) {
            this.en = a;
            this.e("FabBackgroundColor");
        }
        get fabDisabledBackgroundColor() {
            return this.ep;
        }
        set fabDisabledBackgroundColor(a) {
            this.ep = a;
            this.e("FabDisabledBackgroundColor");
        }
        get fabDisabledBorderColor() {
            return this.eq;
        }
        set fabDisabledBorderColor(a) {
            this.eq = a;
            this.e("FabDisabledBorderColor");
        }
        get fabDisabledTextColor() {
            return this.er;
        }
        set fabDisabledTextColor(a) {
            this.er = a;
            this.e("FabDisabledTextColor");
        }
        get fabDisabledElevation() {
            return this.cc;
        }
        set fabDisabledElevation(a) {
            this.cc = a;
            this.e("FabDisabledElevation");
        }
        get fabHoverBackgroundColor() {
            return this.eu;
        }
        set fabHoverBackgroundColor(a) {
            this.eu = a;
            this.e("FabHoverBackgroundColor");
        }
        get fabBorderColor() {
            return this.eo;
        }
        set fabBorderColor(a) {
            this.eo = a;
            this.e("FabBorderColor");
        }
        get fabRestingElevation() {
            return this.cf;
        }
        set fabRestingElevation(a) {
            this.cf = a;
            this.e("FabRestingElevation");
        }
        get fabHoverElevation() {
            return this.ce;
        }
        set fabHoverElevation(a) {
            this.ce = a;
            this.e("FabHoverElevation");
        }
        get fabFocusElevation() {
            return this.cd;
        }
        set fabFocusElevation(a) {
            this.cd = a;
            this.e("FabFocusElevation");
        }
        get fabBorderWidth() {
            return this.ad;
        }
        set fabBorderWidth(a) {
            this.ad = a;
            this.e("FabBorderWidth");
        }
        get fabCornerRadiusBottomRight() {
            return this.af;
        }
        set fabCornerRadiusBottomRight(a) {
            this.af = a;
            this.e("FabCornerRadiusBottomRight");
        }
        get fabCornerRadiusBottomLeft() {
            return this.ae;
        }
        set fabCornerRadiusBottomLeft(a) {
            this.ae = a;
            this.e("FabCornerRadiusBottomLeft");
        }
        get fabCornerRadiusTopLeft() {
            return this.ag;
        }
        set fabCornerRadiusTopLeft(a) {
            this.ag = a;
            this.e("FabCornerRadiusTopLeft");
        }
        get fabCornerRadiusTopRight() {
            return this.ah;
        }
        set fabCornerRadiusTopRight(a) {
            this.ah = a;
            this.e("FabCornerRadiusTopRight");
        }
        get fabRippleColor() {
            return this.ew;
        }
        set fabRippleColor(a) {
            this.ew = a;
            this.e("FabRippleColor");
        }
        get fabTextColor() {
            return this.ex;
        }
        set fabTextColor(a) {
            this.ex = a;
            this.e("FabTextColor");
        }
        get fabHoverTextColor() {
            return this.ev;
        }
        set fabHoverTextColor(a) {
            this.ev = a;
            this.e("FabHoverTextColor");
        }
        get fabFocusBackgroundColor() {
            return this.es;
        }
        set fabFocusBackgroundColor(a) {
            this.es = a;
            this.e("FabFocusBackgroundColor");
        }
        get fabFocusTextColor() {
            return this.et;
        }
        set fabFocusTextColor(a) {
            this.et = a;
            this.e("FabFocusTextColor");
        }
        get iconBackgroundColor() {
            return this.fi;
        }
        set iconBackgroundColor(a) {
            this.fi = a;
            this.e("IconBackgroundColor");
        }
        get iconDisabledBackgroundColor() {
            return this.fk;
        }
        set iconDisabledBackgroundColor(a) {
            this.fk = a;
            this.e("IconDisabledBackgroundColor");
        }
        get iconDisabledBorderColor() {
            return this.fl;
        }
        set iconDisabledBorderColor(a) {
            this.fl = a;
            this.e("IconDisabledBorderColor");
        }
        get iconDisabledTextColor() {
            return this.fm;
        }
        set iconDisabledTextColor(a) {
            this.fm = a;
            this.e("IconDisabledTextColor");
        }
        get iconDisabledElevation() {
            return this.cm;
        }
        set iconDisabledElevation(a) {
            this.cm = a;
            this.e("IconDisabledElevation");
        }
        get iconHoverBackgroundColor() {
            return this.fp;
        }
        set iconHoverBackgroundColor(a) {
            this.fp = a;
            this.e("IconHoverBackgroundColor");
        }
        get iconBorderColor() {
            return this.fj;
        }
        set iconBorderColor(a) {
            this.fj = a;
            this.e("IconBorderColor");
        }
        get iconRestingElevation() {
            return this.cp;
        }
        set iconRestingElevation(a) {
            this.cp = a;
            this.e("IconRestingElevation");
        }
        get iconHoverElevation() {
            return this.co;
        }
        set iconHoverElevation(a) {
            this.co = a;
            this.e("IconHoverElevation");
        }
        get iconFocusElevation() {
            return this.cn;
        }
        set iconFocusElevation(a) {
            this.cn = a;
            this.e("IconFocusElevation");
        }
        get iconBorderWidth() {
            return this.ao;
        }
        set iconBorderWidth(a) {
            this.ao = a;
            this.e("IconBorderWidth");
        }
        get iconCornerRadiusBottomRight() {
            return this.aq;
        }
        set iconCornerRadiusBottomRight(a) {
            this.aq = a;
            this.e("IconCornerRadiusBottomRight");
        }
        get iconCornerRadiusBottomLeft() {
            return this.ap;
        }
        set iconCornerRadiusBottomLeft(a) {
            this.ap = a;
            this.e("IconCornerRadiusBottomLeft");
        }
        get iconCornerRadiusTopLeft() {
            return this.ar;
        }
        set iconCornerRadiusTopLeft(a) {
            this.ar = a;
            this.e("IconCornerRadiusTopLeft");
        }
        get iconCornerRadiusTopRight() {
            return this.as;
        }
        set iconCornerRadiusTopRight(a) {
            this.as = a;
            this.e("IconCornerRadiusTopRight");
        }
        get iconRippleColor() {
            return this.fr;
        }
        set iconRippleColor(a) {
            this.fr = a;
            this.e("IconRippleColor");
        }
        get iconTextColor() {
            return this.fs;
        }
        set iconTextColor(a) {
            this.fs = a;
            this.e("IconTextColor");
        }
        get iconHoverTextColor() {
            return this.fq;
        }
        set iconHoverTextColor(a) {
            this.fq = a;
            this.e("IconHoverTextColor");
        }
        get iconFocusBackgroundColor() {
            return this.fn;
        }
        set iconFocusBackgroundColor(a) {
            this.fn = a;
            this.e("IconFocusBackgroundColor");
        }
        get iconFocusTextColor() {
            return this.fo;
        }
        set iconFocusTextColor(a) {
            this.fo = a;
            this.e("IconFocusTextColor");
        }
        get inputId() {
            return this.fu;
        }
        set inputId(a) {
            this.fu = a;
            this.e("InputId");
        }
        get id() {
            return this.ft;
        }
        set id(a) {
            this.ft = a;
            this.e("Id");
        }
        get display() {
            return this.ek;
        }
        set display(a) {
            this.ek = a;
            this.e("Display");
        }
        get flexDirection() {
            return this.e9;
        }
        set flexDirection(a) {
            this.e9 = a;
            this.e("FlexDirection");
        }
        get flexGrow() {
            return this.fa;
        }
        set flexGrow(a) {
            this.fa = a;
            this.e("FlexGrow");
        }
        get alignItems() {
            return this.ea;
        }
        set alignItems(a) {
            this.ea = a;
            this.e("AlignItems");
        }
        get valueRef() {
            return this.gk;
        }
        set valueRef(a) {
            this.gk = a;
            this.e("ValueRef");
        }
        get name() {
            return this.fv;
        }
        set name(a) {
            this.fv = a;
            this.e("Name");
        }
        get tabIndex() {
            return this.cz;
        }
        set tabIndex(a) {
            this.cz = a;
            this.e("TabIndex");
        }
        get ariaLabel() {
            return this.eb;
        }
        set ariaLabel(a) {
            this.eb = a;
            this.e("AriaLabel");
        }
        get focused() {
            return this.j;
        }
        set focused(a) {
            this.j = a;
            this.e("Focused");
        }
        get isFocusStyleEnabled() {
            return this.k;
        }
        set isFocusStyleEnabled(a) {
            this.k = a;
            this.e("IsFocusStyleEnabled");
        }
        get disableRipple() {
            return this.h;
        }
        set disableRipple(a) {
            this.h = a;
            this.e("DisableRipple");
        }
        get actualDisableRipple() {
            return this.f;
        }
        set actualDisableRipple(a) {
            this.f = a;
            this.e("ActualDisableRipple");
        }
        get isHover() {
            return this.l;
        }
        set isHover(a) {
            this.l = a;
            this.e("IsHover");
        }
        get disabled() {
            return this.g;
        }
        set disabled(a) {
            this.g = a;
            this.e("Disabled");
        }
        get disableTransitions() {
            return this.i;
        }
        set disableTransitions(a) {
            this.i = a;
            this.e("DisableTransitions");
        }
        get clickedRef() {
            return this.ef;
        }
        set clickedRef(a) {
            this.ef = a;
            this.e("ClickedRef");
        }
    }
    ButtonDescription.$t = /*@__PURE__*/ markType(ButtonDescription, 'ButtonDescription', Description.$);
    return ButtonDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class ButtonClickEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(ButtonClickEventArgsDescription, 'ButtonClickEventArgsDescription', Description.$);
    return ButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonClickEventArgsDescriptionMetadata.a == null) {
                ButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonClickEventArgsDescriptionMetadata.c(a, ButtonClickEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ButtonClickEventArgsDescriptionMetadata.b(a);
            a.q("ButtonClickEventArgs", () => new ButtonClickEventArgsDescription());
            a.p("ButtonClickEventArgs", ButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    ButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonClickEventArgsDescriptionMetadata, 'ButtonClickEventArgsDescriptionMetadata');
    ButtonClickEventArgsDescriptionMetadata.a = null;
    return ButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonDescriptionMetadata.a == null) {
                ButtonDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonDescriptionMetadata.c(a, ButtonDescriptionMetadata.a);
                ButtonClickEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("MinWidth", "Number:double");
            b.item("MinHeight", "Number:double");
            b.item("DisplayType", "ExportedType:string:ButtonDisplayStyle");
            b.item("DisplayType@names", "Raised;Flat;Outlined;Fab;Icon");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualBorderColor", "Brush");
            b.item("ActualUmbraShadowColor", "Brush");
            b.item("ActualPenumbraShadowColor", "Brush");
            b.item("ActualAmbientShadowColor", "Brush");
            b.item("ActualRestingElevation", "Number:int");
            b.item("ActualFocusElevation", "Number:int");
            b.item("ActualHoverElevation", "Number:int");
            b.item("ActualRippleColor", "Brush");
            b.item("ActualCornerRadiusBottomRight", "(w:ActualCornerRadius.BottomRight,wf:ActualCornerRadiusBottomRight)Number:double");
            b.item("ActualCornerRadiusBottomLeft", "(w:ActualCornerRadius.BottomLeft,wf:ActualCornerRadiusBottomLeft)Number:double");
            b.item("ActualCornerRadiusTopLeft", "(w:ActualCornerRadius.TopLeft,wf:ActualCornerRadiusTopLeft)Number:double");
            b.item("ActualCornerRadiusTopRight", "(w:ActualCornerRadius.TopRight,wf:ActualCornerRadiusTopRight)Number:double");
            b.item("ActualBackgroundColor", "Brush");
            b.item("ActualDisabledBackgroundColor", "Brush");
            b.item("ActualDisabledBorderColor", "Brush");
            b.item("ActualDisabledTextColor", "Brush");
            b.item("ActualDisabledElevation", "Number:int");
            b.item("ActualElevationMode", "ExportedType:string:ElevationMode");
            b.item("ActualElevationMode@names", "Auto;MaterialShadow;HaloShadow");
            b.item("ActualTextColor", "Brush");
            b.item("ActualHoverTextColor", "Brush");
            b.item("ActualFocusBackgroundColor", "Brush");
            b.item("ActualFocusTextColor", "Brush");
            b.item("ActualHoverBackgroundColor", "Brush");
            b.item("ActualBorderWidth", "Number:double");
            b.item("RaisedBackgroundColor", "Brush");
            b.item("RaisedDisabledBackgroundColor", "Brush");
            b.item("RaisedDisabledBorderColor", "Brush");
            b.item("RaisedDisabledTextColor", "Brush");
            b.item("RaisedDisabledElevation", "Number:int");
            b.item("RaisedHoverBackgroundColor", "Brush");
            b.item("RaisedBorderColor", "Brush");
            b.item("RaisedRestingElevation", "Number:int");
            b.item("RaisedHoverElevation", "Number:int");
            b.item("RaisedFocusElevation", "Number:int");
            b.item("RaisedBorderWidth", "Number:double");
            b.item("RaisedCornerRadiusBottomRight", "(w:RaisedCornerRadius.BottomRight,wf:RaisedCornerRadiusBottomRight)Number:double");
            b.item("RaisedCornerRadiusBottomLeft", "(w:RaisedCornerRadius.BottomLeft,wf:RaisedCornerRadiusBottomLeft)Number:double");
            b.item("RaisedCornerRadiusTopLeft", "(w:RaisedCornerRadius.TopLeft,wf:RaisedCornerRadiusTopLeft)Number:double");
            b.item("RaisedCornerRadiusTopRight", "(w:RaisedCornerRadius.TopRight,wf:RaisedCornerRadiusTopRight)Number:double");
            b.item("RaisedRippleColor", "Brush");
            b.item("FlatBackgroundColor", "Brush");
            b.item("FlatDisabledBackgroundColor", "Brush");
            b.item("FlatDisabledBorderColor", "Brush");
            b.item("FlatDisabledTextColor", "Brush");
            b.item("FlatDisabledElevation", "Number:int");
            b.item("FlatHoverBackgroundColor", "Brush");
            b.item("FlatBorderColor", "Brush");
            b.item("FlatRestingElevation", "Number:int");
            b.item("FlatHoverElevation", "Number:int");
            b.item("FlatFocusElevation", "Number:int");
            b.item("FlatRippleColor", "Brush");
            b.item("FlatTextColor", "Brush");
            b.item("FlatHoverTextColor", "Brush");
            b.item("FlatFocusBackgroundColor", "Brush");
            b.item("FlatFocusTextColor", "Brush");
            b.item("FlatBorderWidth", "Number:double");
            b.item("FlatCornerRadiusBottomRight", "(w:FlatCornerRadius.BottomRight,wf:FlatCornerRadiusBottomRight)Number:double");
            b.item("FlatCornerRadiusBottomLeft", "(w:FlatCornerRadius.BottomLeft,wf:FlatCornerRadiusBottomLeft)Number:double");
            b.item("FlatCornerRadiusTopLeft", "(w:FlatCornerRadius.TopLeft,wf:FlatCornerRadiusTopLeft)Number:double");
            b.item("FlatCornerRadiusTopRight", "(w:FlatCornerRadius.TopRight,wf:FlatCornerRadiusTopRight)Number:double");
            b.item("BackgroundColor", "Brush");
            b.item("DisabledBackgroundColor", "Brush");
            b.item("DisabledBorderColor", "Brush");
            b.item("DisabledTextColor", "Brush");
            b.item("DisabledElevation", "Number:int");
            b.item("ElevationMode", "ExportedType:string:ElevationMode");
            b.item("ElevationMode@names", "Auto;MaterialShadow;HaloShadow");
            b.item("HoverBackgroundColor", "Brush");
            b.item("BorderColor", "Brush");
            b.item("RestingElevation", "Number:int");
            b.item("HoverElevation", "Number:int");
            b.item("FocusElevation", "Number:int");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("TextColor", "Brush");
            b.item("HoverTextColor", "Brush");
            b.item("RippleColor", "Brush");
            b.item("RaisedTextColor", "Brush");
            b.item("RaisedHoverTextColor", "Brush");
            b.item("RaisedFocusBackgroundColor", "Brush");
            b.item("RaisedFocusTextColor", "Brush");
            b.item("FocusBackgroundColor", "Brush");
            b.item("FocusTextColor", "Brush");
            b.item("BorderWidth", "Number:double");
            b.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            b.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            b.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            b.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            b.item("OutlinedBackgroundColor", "Brush");
            b.item("OutlinedDisabledBackgroundColor", "Brush");
            b.item("OutlinedDisabledBorderColor", "Brush");
            b.item("OutlinedDisabledTextColor", "Brush");
            b.item("OutlinedDisabledElevation", "Number:int");
            b.item("OutlinedHoverBackgroundColor", "Brush");
            b.item("OutlinedBorderColor", "Brush");
            b.item("OutlinedRestingElevation", "Number:int");
            b.item("OutlinedHoverElevation", "Number:int");
            b.item("OutlinedFocusElevation", "Number:int");
            b.item("OutlinedBorderWidth", "Number:double");
            b.item("OutlinedCornerRadiusBottomRight", "(w:OutlinedCornerRadius.BottomRight,wf:OutlinedCornerRadiusBottomRight)Number:double");
            b.item("OutlinedCornerRadiusBottomLeft", "(w:OutlinedCornerRadius.BottomLeft,wf:OutlinedCornerRadiusBottomLeft)Number:double");
            b.item("OutlinedCornerRadiusTopLeft", "(w:OutlinedCornerRadius.TopLeft,wf:OutlinedCornerRadiusTopLeft)Number:double");
            b.item("OutlinedCornerRadiusTopRight", "(w:OutlinedCornerRadius.TopRight,wf:OutlinedCornerRadiusTopRight)Number:double");
            b.item("OutlinedRippleColor", "Brush");
            b.item("OutlinedTextColor", "Brush");
            b.item("OutlinedHoverTextColor", "Brush");
            b.item("OutlinedFocusBackgroundColor", "Brush");
            b.item("OutlinedFocusTextColor", "Brush");
            b.item("FabBackgroundColor", "Brush");
            b.item("FabDisabledBackgroundColor", "Brush");
            b.item("FabDisabledBorderColor", "Brush");
            b.item("FabDisabledTextColor", "Brush");
            b.item("FabDisabledElevation", "Number:int");
            b.item("FabHoverBackgroundColor", "Brush");
            b.item("FabBorderColor", "Brush");
            b.item("FabRestingElevation", "Number:int");
            b.item("FabHoverElevation", "Number:int");
            b.item("FabFocusElevation", "Number:int");
            b.item("FabBorderWidth", "Number:double");
            b.item("FabCornerRadiusBottomRight", "(w:FabCornerRadius.BottomRight,wf:FabCornerRadiusBottomRight)Number:double");
            b.item("FabCornerRadiusBottomLeft", "(w:FabCornerRadius.BottomLeft,wf:FabCornerRadiusBottomLeft)Number:double");
            b.item("FabCornerRadiusTopLeft", "(w:FabCornerRadius.TopLeft,wf:FabCornerRadiusTopLeft)Number:double");
            b.item("FabCornerRadiusTopRight", "(w:FabCornerRadius.TopRight,wf:FabCornerRadiusTopRight)Number:double");
            b.item("FabRippleColor", "Brush");
            b.item("FabTextColor", "Brush");
            b.item("FabHoverTextColor", "Brush");
            b.item("FabFocusBackgroundColor", "Brush");
            b.item("FabFocusTextColor", "Brush");
            b.item("IconBackgroundColor", "Brush");
            b.item("IconDisabledBackgroundColor", "Brush");
            b.item("IconDisabledBorderColor", "Brush");
            b.item("IconDisabledTextColor", "Brush");
            b.item("IconDisabledElevation", "Number:int");
            b.item("IconHoverBackgroundColor", "Brush");
            b.item("IconBorderColor", "Brush");
            b.item("IconRestingElevation", "Number:int");
            b.item("IconHoverElevation", "Number:int");
            b.item("IconFocusElevation", "Number:int");
            b.item("IconBorderWidth", "Number:double");
            b.item("IconCornerRadiusBottomRight", "(w:IconCornerRadius.BottomRight,wf:IconCornerRadiusBottomRight)Number:double");
            b.item("IconCornerRadiusBottomLeft", "(w:IconCornerRadius.BottomLeft,wf:IconCornerRadiusBottomLeft)Number:double");
            b.item("IconCornerRadiusTopLeft", "(w:IconCornerRadius.TopLeft,wf:IconCornerRadiusTopLeft)Number:double");
            b.item("IconCornerRadiusTopRight", "(w:IconCornerRadius.TopRight,wf:IconCornerRadiusTopRight)Number:double");
            b.item("IconRippleColor", "Brush");
            b.item("IconTextColor", "Brush");
            b.item("IconHoverTextColor", "Brush");
            b.item("IconFocusBackgroundColor", "Brush");
            b.item("IconFocusTextColor", "Brush");
            b.item("InputId", "String");
            b.item("Id", "String");
            b.item("Display", "String");
            b.item("FlexDirection", "String");
            b.item("FlexGrow", "String");
            b.item("AlignItems", "String");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("Name", "String");
            b.item("TabIndex", "Number:int");
            b.item("AriaLabel", "String");
            b.item("Focused", "(w:IsFocused,wf:IsFocused)Boolean");
            b.item("IsFocusStyleEnabled", "Boolean");
            b.item("DisableRipple", "Boolean");
            b.item("ActualDisableRipple", "Boolean");
            b.item("IsHover", "Boolean");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
            b.item("DisableTransitions", "Boolean");
            b.item("ClickedRef", "EventRef::clicked");
        }
        static d(a) {
            ButtonDescriptionMetadata.b(a);
            a.q("Button", () => new ButtonDescription());
            a.p("Button", ButtonDescriptionMetadata.a);
        }
    }
    ButtonDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonDescriptionMetadata, 'ButtonDescriptionMetadata');
    ButtonDescriptionMetadata.a = null;
    return ButtonDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupDescription = /*@__PURE__*/ (() => {
    class ButtonGroupDescription extends Description {
        constructor() {
            super();
            this.as = null;
            this.aq = null;
            this.ar = null;
            this.ad = null;
            this.g = null;
            this.o = 0;
            this.ae = null;
            this.ag = null;
            this.al = null;
            this.ai = null;
            this.af = null;
            this.ah = null;
            this.n = 0;
            this.am = null;
            this.ap = null;
            this.aj = null;
            this.ak = null;
            this.an = null;
            this.ao = null;
            this.s = 0;
            this.a6 = null;
            this.a8 = null;
            this.bd = null;
            this.ba = null;
            this.bb = null;
            this.a7 = null;
            this.a9 = null;
            this.r = 0;
            this.bc = null;
            this.br = null;
            this.bu = null;
            this.bs = null;
            this.bt = null;
            this.u = 0;
            this.bf = null;
            this.bh = null;
            this.bm = null;
            this.bj = null;
            this.bk = null;
            this.bg = null;
            this.bi = null;
            this.t = 0;
            this.bl = null;
            this.bn = null;
            this.bq = null;
            this.bo = null;
            this.bp = null;
            this.q = 0;
            this.at = null;
            this.av = null;
            this.a0 = null;
            this.ax = null;
            this.ay = null;
            this.au = null;
            this.aw = null;
            this.p = 0;
            this.az = null;
            this.a1 = null;
            this.a4 = null;
            this.a2 = null;
            this.a3 = null;
            this.be = null;
            this.a5 = null;
            this.j = false;
            this.k = false;
            this.f = null;
            this.bv = null;
        }
        get_type() {
            return "ButtonGroup";
        }
        get type() {
            return this.get_type();
        }
        get displayType() {
            return this.as;
        }
        set displayType(a) {
            this.as = a;
            this.e("DisplayType");
        }
        get baseTheme() {
            return this.aq;
        }
        set baseTheme(a) {
            this.aq = a;
            this.e("BaseTheme");
        }
        get density() {
            return this.ar;
        }
        set density(a) {
            this.ar = a;
            this.e("Density");
        }
        get actualDensity() {
            return this.ad;
        }
        set actualDensity(a) {
            this.ad = a;
            this.e("ActualDensity");
        }
        get selectedIndices() {
            return this.g;
        }
        set selectedIndices(a) {
            this.g = a;
            this.e("SelectedIndices");
        }
        get actualItemCornerRadius() {
            return this.o;
        }
        set actualItemCornerRadius(a) {
            this.o = a;
            this.e("ActualItemCornerRadius");
        }
        get actualItemBackgroundColor() {
            return this.ae;
        }
        set actualItemBackgroundColor(a) {
            this.ae = a;
            this.e("ActualItemBackgroundColor");
        }
        get actualItemDisabledBackgroundColor() {
            return this.ag;
        }
        set actualItemDisabledBackgroundColor(a) {
            this.ag = a;
            this.e("ActualItemDisabledBackgroundColor");
        }
        get actualItemTextColor() {
            return this.al;
        }
        set actualItemTextColor(a) {
            this.al = a;
            this.e("ActualItemTextColor");
        }
        get actualItemDisabledTextColor() {
            return this.ai;
        }
        set actualItemDisabledTextColor(a) {
            this.ai = a;
            this.e("ActualItemDisabledTextColor");
        }
        get actualItemBorderColor() {
            return this.af;
        }
        set actualItemBorderColor(a) {
            this.af = a;
            this.e("ActualItemBorderColor");
        }
        get actualItemDisabledBorderColor() {
            return this.ah;
        }
        set actualItemDisabledBorderColor(a) {
            this.ah = a;
            this.e("ActualItemDisabledBorderColor");
        }
        get actualItemBorderWidth() {
            return this.n;
        }
        set actualItemBorderWidth(a) {
            this.n = a;
            this.e("ActualItemBorderWidth");
        }
        get actualSelectedItemBackgroundColor() {
            return this.am;
        }
        set actualSelectedItemBackgroundColor(a) {
            this.am = a;
            this.e("ActualSelectedItemBackgroundColor");
        }
        get actualSelectedItemTextColor() {
            return this.ap;
        }
        set actualSelectedItemTextColor(a) {
            this.ap = a;
            this.e("ActualSelectedItemTextColor");
        }
        get actualItemHoverBackgroundColor() {
            return this.aj;
        }
        set actualItemHoverBackgroundColor(a) {
            this.aj = a;
            this.e("ActualItemHoverBackgroundColor");
        }
        get actualItemHoverTextColor() {
            return this.ak;
        }
        set actualItemHoverTextColor(a) {
            this.ak = a;
            this.e("ActualItemHoverTextColor");
        }
        get actualSelectedItemHoverBackgroundColor() {
            return this.an;
        }
        set actualSelectedItemHoverBackgroundColor(a) {
            this.an = a;
            this.e("ActualSelectedItemHoverBackgroundColor");
        }
        get actualSelectedItemHoverTextColor() {
            return this.ao;
        }
        set actualSelectedItemHoverTextColor(a) {
            this.ao = a;
            this.e("ActualSelectedItemHoverTextColor");
        }
        get itemCornerRadius() {
            return this.s;
        }
        set itemCornerRadius(a) {
            this.s = a;
            this.e("ItemCornerRadius");
        }
        get itemBackgroundColor() {
            return this.a6;
        }
        set itemBackgroundColor(a) {
            this.a6 = a;
            this.e("ItemBackgroundColor");
        }
        get itemDisabledBackgroundColor() {
            return this.a8;
        }
        set itemDisabledBackgroundColor(a) {
            this.a8 = a;
            this.e("ItemDisabledBackgroundColor");
        }
        get itemTextColor() {
            return this.bd;
        }
        set itemTextColor(a) {
            this.bd = a;
            this.e("ItemTextColor");
        }
        get itemDisabledTextColor() {
            return this.ba;
        }
        set itemDisabledTextColor(a) {
            this.ba = a;
            this.e("ItemDisabledTextColor");
        }
        get itemHoverBackgroundColor() {
            return this.bb;
        }
        set itemHoverBackgroundColor(a) {
            this.bb = a;
            this.e("ItemHoverBackgroundColor");
        }
        get itemBorderColor() {
            return this.a7;
        }
        set itemBorderColor(a) {
            this.a7 = a;
            this.e("ItemBorderColor");
        }
        get itemDisabledBorderColor() {
            return this.a9;
        }
        set itemDisabledBorderColor(a) {
            this.a9 = a;
            this.e("ItemDisabledBorderColor");
        }
        get itemBorderWidth() {
            return this.r;
        }
        set itemBorderWidth(a) {
            this.r = a;
            this.e("ItemBorderWidth");
        }
        get itemHoverTextColor() {
            return this.bc;
        }
        set itemHoverTextColor(a) {
            this.bc = a;
            this.e("ItemHoverTextColor");
        }
        get selectedItemBackgroundColor() {
            return this.br;
        }
        set selectedItemBackgroundColor(a) {
            this.br = a;
            this.e("SelectedItemBackgroundColor");
        }
        get selectedItemTextColor() {
            return this.bu;
        }
        set selectedItemTextColor(a) {
            this.bu = a;
            this.e("SelectedItemTextColor");
        }
        get selectedItemHoverBackgroundColor() {
            return this.bs;
        }
        set selectedItemHoverBackgroundColor(a) {
            this.bs = a;
            this.e("SelectedItemHoverBackgroundColor");
        }
        get selectedItemHoverTextColor() {
            return this.bt;
        }
        set selectedItemHoverTextColor(a) {
            this.bt = a;
            this.e("SelectedItemHoverTextColor");
        }
        get outlinedItemCornerRadius() {
            return this.u;
        }
        set outlinedItemCornerRadius(a) {
            this.u = a;
            this.e("OutlinedItemCornerRadius");
        }
        get outlinedItemBackgroundColor() {
            return this.bf;
        }
        set outlinedItemBackgroundColor(a) {
            this.bf = a;
            this.e("OutlinedItemBackgroundColor");
        }
        get outlinedItemDisabledBackgroundColor() {
            return this.bh;
        }
        set outlinedItemDisabledBackgroundColor(a) {
            this.bh = a;
            this.e("OutlinedItemDisabledBackgroundColor");
        }
        get outlinedItemTextColor() {
            return this.bm;
        }
        set outlinedItemTextColor(a) {
            this.bm = a;
            this.e("OutlinedItemTextColor");
        }
        get outlinedItemDisabledTextColor() {
            return this.bj;
        }
        set outlinedItemDisabledTextColor(a) {
            this.bj = a;
            this.e("OutlinedItemDisabledTextColor");
        }
        get outlinedItemHoverBackgroundColor() {
            return this.bk;
        }
        set outlinedItemHoverBackgroundColor(a) {
            this.bk = a;
            this.e("OutlinedItemHoverBackgroundColor");
        }
        get outlinedItemBorderColor() {
            return this.bg;
        }
        set outlinedItemBorderColor(a) {
            this.bg = a;
            this.e("OutlinedItemBorderColor");
        }
        get outlinedItemDisabledBorderColor() {
            return this.bi;
        }
        set outlinedItemDisabledBorderColor(a) {
            this.bi = a;
            this.e("OutlinedItemDisabledBorderColor");
        }
        get outlinedItemBorderWidth() {
            return this.t;
        }
        set outlinedItemBorderWidth(a) {
            this.t = a;
            this.e("OutlinedItemBorderWidth");
        }
        get outlinedItemHoverTextColor() {
            return this.bl;
        }
        set outlinedItemHoverTextColor(a) {
            this.bl = a;
            this.e("OutlinedItemHoverTextColor");
        }
        get outlinedSelectedItemBackgroundColor() {
            return this.bn;
        }
        set outlinedSelectedItemBackgroundColor(a) {
            this.bn = a;
            this.e("OutlinedSelectedItemBackgroundColor");
        }
        get outlinedSelectedItemTextColor() {
            return this.bq;
        }
        set outlinedSelectedItemTextColor(a) {
            this.bq = a;
            this.e("OutlinedSelectedItemTextColor");
        }
        get outlinedSelectedItemHoverBackgroundColor() {
            return this.bo;
        }
        set outlinedSelectedItemHoverBackgroundColor(a) {
            this.bo = a;
            this.e("OutlinedSelectedItemHoverBackgroundColor");
        }
        get outlinedSelectedItemHoverTextColor() {
            return this.bp;
        }
        set outlinedSelectedItemHoverTextColor(a) {
            this.bp = a;
            this.e("OutlinedSelectedItemHoverTextColor");
        }
        get flatItemCornerRadius() {
            return this.q;
        }
        set flatItemCornerRadius(a) {
            this.q = a;
            this.e("FlatItemCornerRadius");
        }
        get flatItemBackgroundColor() {
            return this.at;
        }
        set flatItemBackgroundColor(a) {
            this.at = a;
            this.e("FlatItemBackgroundColor");
        }
        get flatItemDisabledBackgroundColor() {
            return this.av;
        }
        set flatItemDisabledBackgroundColor(a) {
            this.av = a;
            this.e("FlatItemDisabledBackgroundColor");
        }
        get flatItemTextColor() {
            return this.a0;
        }
        set flatItemTextColor(a) {
            this.a0 = a;
            this.e("FlatItemTextColor");
        }
        get flatItemDisabledTextColor() {
            return this.ax;
        }
        set flatItemDisabledTextColor(a) {
            this.ax = a;
            this.e("FlatItemDisabledTextColor");
        }
        get flatItemHoverBackgroundColor() {
            return this.ay;
        }
        set flatItemHoverBackgroundColor(a) {
            this.ay = a;
            this.e("FlatItemHoverBackgroundColor");
        }
        get flatItemBorderColor() {
            return this.au;
        }
        set flatItemBorderColor(a) {
            this.au = a;
            this.e("FlatItemBorderColor");
        }
        get flatItemDisabledBorderColor() {
            return this.aw;
        }
        set flatItemDisabledBorderColor(a) {
            this.aw = a;
            this.e("FlatItemDisabledBorderColor");
        }
        get flatItemBorderWidth() {
            return this.p;
        }
        set flatItemBorderWidth(a) {
            this.p = a;
            this.e("FlatItemBorderWidth");
        }
        get flatItemHoverTextColor() {
            return this.az;
        }
        set flatItemHoverTextColor(a) {
            this.az = a;
            this.e("FlatItemHoverTextColor");
        }
        get flatSelectedItemBackgroundColor() {
            return this.a1;
        }
        set flatSelectedItemBackgroundColor(a) {
            this.a1 = a;
            this.e("FlatSelectedItemBackgroundColor");
        }
        get flatSelectedItemTextColor() {
            return this.a4;
        }
        set flatSelectedItemTextColor(a) {
            this.a4 = a;
            this.e("FlatSelectedItemTextColor");
        }
        get flatSelectedItemHoverBackgroundColor() {
            return this.a2;
        }
        set flatSelectedItemHoverBackgroundColor(a) {
            this.a2 = a;
            this.e("FlatSelectedItemHoverBackgroundColor");
        }
        get flatSelectedItemHoverTextColor() {
            return this.a3;
        }
        set flatSelectedItemHoverTextColor(a) {
            this.a3 = a;
            this.e("FlatSelectedItemHoverTextColor");
        }
        get orientation() {
            return this.be;
        }
        set orientation(a) {
            this.be = a;
            this.e("Orientation");
        }
        get id() {
            return this.a5;
        }
        set id(a) {
            this.a5 = a;
            this.e("Id");
        }
        get disabled() {
            return this.j;
        }
        set disabled(a) {
            this.j = a;
            this.e("Disabled");
        }
        get isMultiSelect() {
            return this.k;
        }
        set isMultiSelect(a) {
            this.k = a;
            this.e("IsMultiSelect");
        }
        get buttons() {
            return this.f;
        }
        set buttons(a) {
            this.f = a;
            this.e("Buttons");
        }
        get selectionChangedRef() {
            return this.bv;
        }
        set selectionChangedRef(a) {
            this.bv = a;
            this.e("SelectionChangedRef");
        }
    }
    ButtonGroupDescription.$t = /*@__PURE__*/ markType(ButtonGroupDescription, 'ButtonGroupDescription', Description.$);
    return ButtonGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupSelectionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ButtonGroupSelectionChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ButtonGroupSelectionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ButtonGroupSelectionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ButtonGroupSelectionChangedEventArgsDescription, 'ButtonGroupSelectionChangedEventArgsDescription', Description.$);
    return ButtonGroupSelectionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupSelectionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonGroupSelectionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a == null) {
                ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonGroupSelectionChangedEventArgsDescriptionMetadata.c(a, ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ButtonGroupSelectionChangedEventArgsDescriptionMetadata.b(a);
            a.q("ButtonGroupSelectionChangedEventArgs", () => new ButtonGroupSelectionChangedEventArgsDescription());
            a.p("ButtonGroupSelectionChangedEventArgs", ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a);
        }
    }
    ButtonGroupSelectionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonGroupSelectionChangedEventArgsDescriptionMetadata, 'ButtonGroupSelectionChangedEventArgsDescriptionMetadata');
    ButtonGroupSelectionChangedEventArgsDescriptionMetadata.a = null;
    return ButtonGroupSelectionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class ButtonGroupDescriptionMetadata extends Base {
        static b(a) {
            if (ButtonGroupDescriptionMetadata.a == null) {
                ButtonGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ButtonGroupDescriptionMetadata.c(a, ButtonGroupDescriptionMetadata.a);
                ButtonGroupSelectionChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("DisplayType", "ExportedType:string:ButtonGroupDisplayStyle");
            b.item("DisplayType@names", "Flat;Outlined");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("SelectedIndices", "Array:int");
            b.item("ActualItemCornerRadius", "Number:double");
            b.item("ActualItemBackgroundColor", "Brush");
            b.item("ActualItemDisabledBackgroundColor", "Brush");
            b.item("ActualItemTextColor", "Brush");
            b.item("ActualItemDisabledTextColor", "Brush");
            b.item("ActualItemBorderColor", "Brush");
            b.item("ActualItemDisabledBorderColor", "Brush");
            b.item("ActualItemBorderWidth", "Number:double");
            b.item("ActualSelectedItemBackgroundColor", "Brush");
            b.item("ActualSelectedItemTextColor", "Brush");
            b.item("ActualItemHoverBackgroundColor", "Brush");
            b.item("ActualItemHoverTextColor", "Brush");
            b.item("ActualSelectedItemHoverBackgroundColor", "Brush");
            b.item("ActualSelectedItemHoverTextColor", "Brush");
            b.item("ItemCornerRadius", "Number:double");
            b.item("ItemBackgroundColor", "Brush");
            b.item("ItemDisabledBackgroundColor", "Brush");
            b.item("ItemTextColor", "Brush");
            b.item("ItemDisabledTextColor", "Brush");
            b.item("ItemHoverBackgroundColor", "Brush");
            b.item("ItemBorderColor", "Brush");
            b.item("ItemDisabledBorderColor", "Brush");
            b.item("ItemBorderWidth", "Number:double");
            b.item("ItemHoverTextColor", "Brush");
            b.item("SelectedItemBackgroundColor", "Brush");
            b.item("SelectedItemTextColor", "Brush");
            b.item("SelectedItemHoverBackgroundColor", "Brush");
            b.item("SelectedItemHoverTextColor", "Brush");
            b.item("OutlinedItemCornerRadius", "Number:double");
            b.item("OutlinedItemBackgroundColor", "Brush");
            b.item("OutlinedItemDisabledBackgroundColor", "Brush");
            b.item("OutlinedItemTextColor", "Brush");
            b.item("OutlinedItemDisabledTextColor", "Brush");
            b.item("OutlinedItemHoverBackgroundColor", "Brush");
            b.item("OutlinedItemBorderColor", "Brush");
            b.item("OutlinedItemDisabledBorderColor", "Brush");
            b.item("OutlinedItemBorderWidth", "Number:double");
            b.item("OutlinedItemHoverTextColor", "Brush");
            b.item("OutlinedSelectedItemBackgroundColor", "Brush");
            b.item("OutlinedSelectedItemTextColor", "Brush");
            b.item("OutlinedSelectedItemHoverBackgroundColor", "Brush");
            b.item("OutlinedSelectedItemHoverTextColor", "Brush");
            b.item("FlatItemCornerRadius", "Number:double");
            b.item("FlatItemBackgroundColor", "Brush");
            b.item("FlatItemDisabledBackgroundColor", "Brush");
            b.item("FlatItemTextColor", "Brush");
            b.item("FlatItemDisabledTextColor", "Brush");
            b.item("FlatItemHoverBackgroundColor", "Brush");
            b.item("FlatItemBorderColor", "Brush");
            b.item("FlatItemDisabledBorderColor", "Brush");
            b.item("FlatItemBorderWidth", "Number:double");
            b.item("FlatItemHoverTextColor", "Brush");
            b.item("FlatSelectedItemBackgroundColor", "Brush");
            b.item("FlatSelectedItemTextColor", "Brush");
            b.item("FlatSelectedItemHoverBackgroundColor", "Brush");
            b.item("FlatSelectedItemHoverTextColor", "Brush");
            b.item("Orientation", "ExportedType:string:ButtonGroupOrientation");
            b.item("Orientation@names", "Horizontal;Vertical");
            b.item("Id", "String");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
            b.item("IsMultiSelect", "Boolean");
            b.item("Buttons", "Collection:Button:ButtonGroupButtonCollection:Button");
            b.item("SelectionChangedRef", "EventRef::selectionChanged");
        }
        static d(a) {
            ButtonGroupDescriptionMetadata.b(a);
            a.q("ButtonGroup", () => new ButtonGroupDescription());
            a.p("ButtonGroup", ButtonGroupDescriptionMetadata.a);
        }
    }
    ButtonGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(ButtonGroupDescriptionMetadata, 'ButtonGroupDescriptionMetadata');
    ButtonGroupDescriptionMetadata.a = null;
    return ButtonGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChildContentDescriptionModule = /*@__PURE__*/ (() => {
    class ChildContentDescriptionModule extends Base {
        static register(a) {
        }
    }
    ChildContentDescriptionModule.$t = /*@__PURE__*/ markType(ChildContentDescriptionModule, 'ChildContentDescriptionModule');
    return ChildContentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RippleDescription = /*@__PURE__*/ (() => {
    class RippleDescription extends Description {
        constructor() {
            super();
            this.p = null;
            this.r = null;
            this.q = null;
            this.n = null;
            this.o = null;
            this.l = 0;
            this.g = false;
            this.f = false;
            this.h = false;
        }
        get_type() {
            return "Ripple";
        }
        get type() {
            return this.get_type();
        }
        get eventSourceRef() {
            return this.p;
        }
        set eventSourceRef(a) {
            this.p = a;
            this.e("EventSourceRef");
        }
        get rippleColor() {
            return this.r;
        }
        set rippleColor(a) {
            this.r = a;
            this.e("RippleColor");
        }
        get hoverColor() {
            return this.q;
        }
        set hoverColor(a) {
            this.q = a;
            this.e("HoverColor");
        }
        get actualHoverColor() {
            return this.n;
        }
        set actualHoverColor(a) {
            this.n = a;
            this.e("ActualHoverColor");
        }
        get actualRippleColor() {
            return this.o;
        }
        set actualRippleColor(a) {
            this.o = a;
            this.e("ActualRippleColor");
        }
        get rippleDuration() {
            return this.l;
        }
        set rippleDuration(a) {
            this.l = a;
            this.e("RippleDuration");
        }
        get isDisabled() {
            return this.g;
        }
        set isDisabled(a) {
            this.g = a;
            this.e("IsDisabled");
        }
        get isCentered() {
            return this.f;
        }
        set isCentered(a) {
            this.f = a;
            this.e("IsCentered");
        }
        get isHoverEnabled() {
            return this.h;
        }
        set isHoverEnabled(a) {
            this.h = a;
            this.e("IsHoverEnabled");
        }
    }
    RippleDescription.$t = /*@__PURE__*/ markType(RippleDescription, 'RippleDescription', Description.$);
    return RippleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RippleDescriptionMetadata = /*@__PURE__*/ (() => {
    class RippleDescriptionMetadata extends Base {
        static b(a) {
            if (RippleDescriptionMetadata.a == null) {
                RippleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RippleDescriptionMetadata.c(a, RippleDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("EventSourceRef", "(w:EventSource,wf:EventSource)DataRef");
            b.item("RippleColor", "Brush");
            b.item("HoverColor", "Brush");
            b.item("ActualHoverColor", "Brush");
            b.item("ActualRippleColor", "Brush");
            b.item("RippleDuration", "Number:double");
            b.item("IsDisabled", "Boolean");
            b.item("IsCentered", "Boolean");
            b.item("IsHoverEnabled", "Boolean");
        }
        static d(a) {
            RippleDescriptionMetadata.b(a);
            a.q("Ripple", () => new RippleDescription());
            a.p("Ripple", RippleDescriptionMetadata.a);
        }
    }
    RippleDescriptionMetadata.$t = /*@__PURE__*/ markType(RippleDescriptionMetadata, 'RippleDescriptionMetadata');
    RippleDescriptionMetadata.a = null;
    return RippleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RippleDescriptionModule = /*@__PURE__*/ (() => {
    class RippleDescriptionModule extends Base {
        static register(a) {
            RippleDescriptionMetadata.d(a);
        }
    }
    RippleDescriptionModule.$t = /*@__PURE__*/ markType(RippleDescriptionModule, 'RippleDescriptionModule');
    return RippleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonDescriptionModule = /*@__PURE__*/ (() => {
    class ButtonDescriptionModule extends Base {
        static register(a) {
            RippleDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
            ButtonDescriptionMetadata.d(a);
        }
    }
    ButtonDescriptionModule.$t = /*@__PURE__*/ markType(ButtonDescriptionModule, 'ButtonDescriptionModule');
    return ButtonDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ButtonGroupDescriptionModule = /*@__PURE__*/ (() => {
    class ButtonGroupDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            ButtonGroupDescriptionMetadata.d(a);
        }
    }
    ButtonGroupDescriptionModule.$t = /*@__PURE__*/ markType(ButtonGroupDescriptionModule, 'ButtonGroupDescriptionModule');
    return ButtonGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDescription = /*@__PURE__*/ (() => {
    class CalendarDescription extends Description {
        constructor() {
            super();
            this.m = new Date();
            this.l = new Date();
            this.k = new Date();
            this.j = new Date();
            this.x = null;
            this.u = null;
            this.t = null;
            this.ag = null;
            this.ai = null;
            this.aa = null;
            this.af = null;
            this.aj = null;
            this.ah = null;
            this.ab = null;
            this.w = null;
            this.v = null;
            this.f = false;
            this.ac = null;
            this.r = 0;
            this.ad = null;
            this.ae = null;
            this.y = null;
            this.z = null;
            this.g = false;
            this.ak = null;
        }
        get_type() {
            return "Calendar";
        }
        get type() {
            return this.get_type();
        }
        get value() {
            return this.m;
        }
        set value(a) {
            this.m = a;
            this.e("Value");
        }
        get today() {
            return this.l;
        }
        set today(a) {
            this.l = a;
            this.e("Today");
        }
        get minDate() {
            return this.k;
        }
        set minDate(a) {
            this.k = a;
            this.e("MinDate");
        }
        get maxDate() {
            return this.j;
        }
        set maxDate(a) {
            this.j = a;
            this.e("MaxDate");
        }
        get density() {
            return this.x;
        }
        set density(a) {
            this.x = a;
            this.e("Density");
        }
        get baseTheme() {
            return this.u;
        }
        set baseTheme(a) {
            this.u = a;
            this.e("BaseTheme");
        }
        get backgroundColor() {
            return this.t;
        }
        set backgroundColor(a) {
            this.t = a;
            this.e("BackgroundColor");
        }
        get selectedDateBackgroundColor() {
            return this.ag;
        }
        set selectedDateBackgroundColor(a) {
            this.ag = a;
            this.e("SelectedDateBackgroundColor");
        }
        get selectedFocusDateBackgroundColor() {
            return this.ai;
        }
        set selectedFocusDateBackgroundColor(a) {
            this.ai = a;
            this.e("SelectedFocusDateBackgroundColor");
        }
        get focusDateBackgroundColor() {
            return this.aa;
        }
        set focusDateBackgroundColor(a) {
            this.aa = a;
            this.e("FocusDateBackgroundColor");
        }
        get hoverBackgroundColor() {
            return this.af;
        }
        set hoverBackgroundColor(a) {
            this.af = a;
            this.e("HoverBackgroundColor");
        }
        get textColor() {
            return this.aj;
        }
        set textColor(a) {
            this.aj = a;
            this.e("TextColor");
        }
        get selectedDateTextColor() {
            return this.ah;
        }
        set selectedDateTextColor(a) {
            this.ah = a;
            this.e("SelectedDateTextColor");
        }
        get focusDateTextColor() {
            return this.ab;
        }
        set focusDateTextColor(a) {
            this.ab = a;
            this.e("FocusDateTextColor");
        }
        get currentDateTextColor() {
            return this.w;
        }
        set currentDateTextColor(a) {
            this.w = a;
            this.e("CurrentDateTextColor");
        }
        get currentDateBorderColor() {
            return this.v;
        }
        set currentDateBorderColor(a) {
            this.v = a;
            this.e("CurrentDateBorderColor");
        }
        get showTodayButton() {
            return this.f;
        }
        set showTodayButton(a) {
            this.f = a;
            this.e("ShowTodayButton");
        }
        get fontFamily() {
            return this.ac;
        }
        set fontFamily(a) {
            this.ac = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.r;
        }
        set fontSize(a) {
            this.r = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.ad;
        }
        set fontStyle(a) {
            this.ad = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.ae;
        }
        set fontWeight(a) {
            this.ae = a;
            this.e("FontWeight");
        }
        get firstDayOfWeek() {
            return this.y;
        }
        set firstDayOfWeek(a) {
            this.y = a;
            this.e("FirstDayOfWeek");
        }
        get firstWeekOfYear() {
            return this.z;
        }
        set firstWeekOfYear(a) {
            this.z = a;
            this.e("FirstWeekOfYear");
        }
        get showWeekNumbers() {
            return this.g;
        }
        set showWeekNumbers(a) {
            this.g = a;
            this.e("ShowWeekNumbers");
        }
        get valueChangedRef() {
            return this.ak;
        }
        set valueChangedRef(a) {
            this.ak = a;
            this.e("ValueChangedRef");
        }
    }
    CalendarDescription.$t = /*@__PURE__*/ markType(CalendarDescription, 'CalendarDescription', Description.$);
    return CalendarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ValueChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = new Date();
            this.f = new Date();
        }
        get_type() {
            return "ValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get oldValue() {
            return this.g;
        }
        set oldValue(a) {
            this.g = a;
            this.e("OldValue");
        }
        get newValue() {
            return this.f;
        }
        set newValue(a) {
            this.f = a;
            this.e("NewValue");
        }
    }
    ValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ValueChangedEventArgsDescription, 'ValueChangedEventArgsDescription', Description.$);
    return ValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ValueChangedEventArgsDescriptionMetadata.a == null) {
                ValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ValueChangedEventArgsDescriptionMetadata.c(a, ValueChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("OldValue", "Date");
            b.item("NewValue", "Date");
        }
        static d(a) {
            ValueChangedEventArgsDescriptionMetadata.b(a);
            a.q("ValueChangedEventArgs", () => new ValueChangedEventArgsDescription());
            a.p("ValueChangedEventArgs", ValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    ValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ValueChangedEventArgsDescriptionMetadata, 'ValueChangedEventArgsDescriptionMetadata');
    ValueChangedEventArgsDescriptionMetadata.a = null;
    return ValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalendarDescriptionMetadata extends Base {
        static b(a) {
            if (CalendarDescriptionMetadata.a == null) {
                CalendarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalendarDescriptionMetadata.c(a, CalendarDescriptionMetadata.a);
                ValueChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Value", "Date");
            b.item("Today", "Date");
            b.item("MinDate", "Date");
            b.item("MaxDate", "Date");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("BackgroundColor", "Brush");
            b.item("SelectedDateBackgroundColor", "Brush");
            b.item("SelectedFocusDateBackgroundColor", "Brush");
            b.item("FocusDateBackgroundColor", "Brush");
            b.item("HoverBackgroundColor", "Brush");
            b.item("TextColor", "Brush");
            b.item("SelectedDateTextColor", "Brush");
            b.item("FocusDateTextColor", "Brush");
            b.item("CurrentDateTextColor", "Brush");
            b.item("CurrentDateBorderColor", "Brush");
            b.item("ShowTodayButton", "Boolean");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("FirstDayOfWeek", "ExportedType:string:DayOfWeek");
            b.item("FirstDayOfWeek@names", "Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday");
            b.item("FirstWeekOfYear", "ExportedType:string:FirstWeek");
            b.item("FirstWeekOfYear@names", "FirstDay;FirstFullWeek;FirstFourDayWeek");
            b.item("ShowWeekNumbers", "Boolean");
            b.item("ValueChangedRef", "EventRef::valueChanged");
        }
        static d(a) {
            CalendarDescriptionMetadata.b(a);
            a.q("Calendar", () => new CalendarDescription());
            a.p("Calendar", CalendarDescriptionMetadata.a);
        }
    }
    CalendarDescriptionMetadata.$t = /*@__PURE__*/ markType(CalendarDescriptionMetadata, 'CalendarDescriptionMetadata');
    CalendarDescriptionMetadata.a = null;
    return CalendarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IconDescription = /*@__PURE__*/ (() => {
    class IconDescription extends Description {
        constructor() {
            super();
            this.v = null;
            this.z = null;
            this.w = null;
            this.x = null;
            this.y = null;
            this.j = 0;
            this.k = 0;
            this.ab = null;
            this.al = null;
            this.ak = null;
            this.af = null;
            this.ag = null;
            this.aj = null;
            this.m = 0;
            this.n = 0;
            this.ac = null;
            this.l = 0;
            this.ad = null;
            this.ae = null;
            this.ah = null;
            this.ai = null;
            this.t = 0;
            this.aa = null;
            this.g = false;
            this.f = false;
        }
        get_type() {
            return "Icon";
        }
        get type() {
            return this.get_type();
        }
        get actualFill() {
            return this.v;
        }
        set actualFill(a) {
            this.v = a;
            this.e("ActualFill");
        }
        get actualTextColor() {
            return this.z;
        }
        set actualTextColor(a) {
            this.z = a;
            this.e("ActualTextColor");
        }
        get actualHoverFill() {
            return this.w;
        }
        set actualHoverFill(a) {
            this.w = a;
            this.e("ActualHoverFill");
        }
        get actualHoverStroke() {
            return this.x;
        }
        set actualHoverStroke(a) {
            this.x = a;
            this.e("ActualHoverStroke");
        }
        get actualStroke() {
            return this.y;
        }
        set actualStroke(a) {
            this.y = a;
            this.e("ActualStroke");
        }
        get actualHoverStrokeThickness() {
            return this.j;
        }
        set actualHoverStrokeThickness(a) {
            this.j = a;
            this.e("ActualHoverStrokeThickness");
        }
        get actualStrokeThickness() {
            return this.k;
        }
        set actualStrokeThickness(a) {
            this.k = a;
            this.e("ActualStrokeThickness");
        }
        get fill() {
            return this.ab;
        }
        set fill(a) {
            this.ab = a;
            this.e("Fill");
        }
        get textColor() {
            return this.al;
        }
        set textColor(a) {
            this.al = a;
            this.e("TextColor");
        }
        get svgPath() {
            return this.ak;
        }
        set svgPath(a) {
            this.ak = a;
            this.e("SvgPath");
        }
        get hoverFill() {
            return this.af;
        }
        set hoverFill(a) {
            this.af = a;
            this.e("HoverFill");
        }
        get hoverStroke() {
            return this.ag;
        }
        set hoverStroke(a) {
            this.ag = a;
            this.e("HoverStroke");
        }
        get stroke() {
            return this.aj;
        }
        set stroke(a) {
            this.aj = a;
            this.e("Stroke");
        }
        get hoverStrokeThickness() {
            return this.m;
        }
        set hoverStrokeThickness(a) {
            this.m = a;
            this.e("HoverStrokeThickness");
        }
        get strokeThickness() {
            return this.n;
        }
        set strokeThickness(a) {
            this.n = a;
            this.e("StrokeThickness");
        }
        get fontFamily() {
            return this.ac;
        }
        set fontFamily(a) {
            this.ac = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.l;
        }
        set fontSize(a) {
            this.l = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.ad;
        }
        set fontStyle(a) {
            this.ad = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.ae;
        }
        set fontWeight(a) {
            this.ae = a;
            this.e("FontWeight");
        }
        get hoverTextColor() {
            return this.ah;
        }
        set hoverTextColor(a) {
            this.ah = a;
            this.e("HoverTextColor");
        }
        get id() {
            return this.ai;
        }
        set id(a) {
            this.ai = a;
            this.e("Id");
        }
        get tabIndex() {
            return this.t;
        }
        set tabIndex(a) {
            this.t = a;
            this.e("TabIndex");
        }
        get ariaLabel() {
            return this.aa;
        }
        set ariaLabel(a) {
            this.aa = a;
            this.e("AriaLabel");
        }
        get isHover() {
            return this.g;
        }
        set isHover(a) {
            this.g = a;
            this.e("IsHover");
        }
        get disabled() {
            return this.f;
        }
        set disabled(a) {
            this.f = a;
            this.e("Disabled");
        }
    }
    IconDescription.$t = /*@__PURE__*/ markType(IconDescription, 'IconDescription', Description.$);
    return IconDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IconDescriptionMetadata = /*@__PURE__*/ (() => {
    class IconDescriptionMetadata extends Base {
        static b(a) {
            if (IconDescriptionMetadata.a == null) {
                IconDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                IconDescriptionMetadata.c(a, IconDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ActualFill", "Brush");
            b.item("ActualTextColor", "Brush");
            b.item("ActualHoverFill", "Brush");
            b.item("ActualHoverStroke", "Brush");
            b.item("ActualStroke", "Brush");
            b.item("ActualHoverStrokeThickness", "Number:double");
            b.item("ActualStrokeThickness", "Number:double");
            b.item("Fill", "Brush");
            b.item("TextColor", "Brush");
            b.item("SvgPath", "(w:SVGPath,wf:SVGPath)String");
            b.item("HoverFill", "Brush");
            b.item("HoverStroke", "Brush");
            b.item("Stroke", "Brush");
            b.item("HoverStrokeThickness", "Number:double");
            b.item("StrokeThickness", "Number:double");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("HoverTextColor", "Brush");
            b.item("Id", "String");
            b.item("TabIndex", "Number:int");
            b.item("AriaLabel", "String");
            b.item("IsHover", "Boolean");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            IconDescriptionMetadata.b(a);
            a.q("Icon", () => new IconDescription());
            a.p("Icon", IconDescriptionMetadata.a);
        }
    }
    IconDescriptionMetadata.$t = /*@__PURE__*/ markType(IconDescriptionMetadata, 'IconDescriptionMetadata');
    IconDescriptionMetadata.a = null;
    return IconDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IconDescriptionModule = /*@__PURE__*/ (() => {
    class IconDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            IconDescriptionMetadata.d(a);
        }
    }
    IconDescriptionModule.$t = /*@__PURE__*/ markType(IconDescriptionModule, 'IconDescriptionModule');
    return IconDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalendarDescriptionModule = /*@__PURE__*/ (() => {
    class CalendarDescriptionModule extends Base {
        static register(a) {
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            CalendarDescriptionMetadata.d(a);
        }
    }
    CalendarDescriptionModule.$t = /*@__PURE__*/ markType(CalendarDescriptionModule, 'CalendarDescriptionModule');
    return CalendarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSeriesEventArgsDescription = /*@__PURE__*/ (() => {
    class ChartSeriesEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "ChartSeriesEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
    }
    ChartSeriesEventArgsDescription.$t = /*@__PURE__*/ markType(ChartSeriesEventArgsDescription, 'ChartSeriesEventArgsDescription', Description.$);
    return ChartSeriesEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSeriesEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChartSeriesEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ChartSeriesEventArgsDescriptionMetadata.a == null) {
                ChartSeriesEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChartSeriesEventArgsDescriptionMetadata.c(a, ChartSeriesEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Series", "ExportedType:Series");
        }
        static d(a) {
            ChartSeriesEventArgsDescriptionMetadata.b(a);
            a.q("ChartSeriesEventArgs", () => new ChartSeriesEventArgsDescription());
            a.p("ChartSeriesEventArgs", ChartSeriesEventArgsDescriptionMetadata.a);
        }
    }
    ChartSeriesEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ChartSeriesEventArgsDescriptionMetadata, 'ChartSeriesEventArgsDescriptionMetadata');
    ChartSeriesEventArgsDescriptionMetadata.a = null;
    return ChartSeriesEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartSeriesPointerEventArgsDescription = /*@__PURE__*/ (() => {
    class DomainChartSeriesPointerEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "DomainChartSeriesPointerEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get itemRef() {
            return this.h;
        }
        set itemRef(a) {
            this.h = a;
            this.e("ItemRef");
        }
    }
    DomainChartSeriesPointerEventArgsDescription.$t = /*@__PURE__*/ markType(DomainChartSeriesPointerEventArgsDescription, 'DomainChartSeriesPointerEventArgsDescription', Description.$);
    return DomainChartSeriesPointerEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartSeriesPointerEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DomainChartSeriesPointerEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DomainChartSeriesPointerEventArgsDescriptionMetadata.a == null) {
                DomainChartSeriesPointerEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DomainChartSeriesPointerEventArgsDescriptionMetadata.c(a, DomainChartSeriesPointerEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Series", "ExportedType:Series");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            DomainChartSeriesPointerEventArgsDescriptionMetadata.b(a);
            a.q("DomainChartSeriesPointerEventArgs", () => new DomainChartSeriesPointerEventArgsDescription());
            a.p("DomainChartSeriesPointerEventArgs", DomainChartSeriesPointerEventArgsDescriptionMetadata.a);
        }
    }
    DomainChartSeriesPointerEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DomainChartSeriesPointerEventArgsDescriptionMetadata, 'DomainChartSeriesPointerEventArgsDescriptionMetadata');
    DomainChartSeriesPointerEventArgsDescriptionMetadata.a = null;
    return DomainChartSeriesPointerEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutStyleUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutStyleUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
            this.o = null;
            this.p = null;
            this.k = null;
            this.f = null;
            this.j = null;
            this.n = null;
            this.m = null;
            this.l = null;
            this.h = 0;
        }
        get_type() {
            return "CalloutStyleUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get xValueRef() {
            return this.o;
        }
        set xValueRef(a) {
            this.o = a;
            this.e("XValueRef");
        }
        get yValueRef() {
            return this.p;
        }
        set yValueRef(a) {
            this.p = a;
            this.e("YValueRef");
        }
        get itemRef() {
            return this.k;
        }
        set itemRef(a) {
            this.k = a;
            this.e("ItemRef");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get background() {
            return this.j;
        }
        set background(a) {
            this.j = a;
            this.e("Background");
        }
        get textColor() {
            return this.n;
        }
        set textColor(a) {
            this.n = a;
            this.e("TextColor");
        }
        get outline() {
            return this.m;
        }
        set outline(a) {
            this.m = a;
            this.e("Outline");
        }
        get leaderBrush() {
            return this.l;
        }
        set leaderBrush(a) {
            this.l = a;
            this.e("LeaderBrush");
        }
        get strokeThickness() {
            return this.h;
        }
        set strokeThickness(a) {
            this.h = a;
            this.e("StrokeThickness");
        }
    }
    CalloutStyleUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutStyleUpdatingEventArgsDescription, 'CalloutStyleUpdatingEventArgsDescription', Description.$);
    return CalloutStyleUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutStyleUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutStyleUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutStyleUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutStyleUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutStyleUpdatingEventArgsDescriptionMetadata.c(a, CalloutStyleUpdatingEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("XValueRef", "(w:XValue,wf:XValue)DataRef");
            b.item("YValueRef", "(w:YValue,wf:YValue)DataRef");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("Series", "ExportedType:Series");
            b.item("Background", "Brush");
            b.item("TextColor", "Brush");
            b.item("Outline", "Brush");
            b.item("LeaderBrush", "Brush");
            b.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            CalloutStyleUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("CalloutStyleUpdatingEventArgs", () => new CalloutStyleUpdatingEventArgsDescription());
            a.p("CalloutStyleUpdatingEventArgs", CalloutStyleUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutStyleUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutStyleUpdatingEventArgsDescriptionMetadata, 'CalloutStyleUpdatingEventArgsDescriptionMetadata');
    CalloutStyleUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutStyleUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DomainChartDescriptionMetadata extends Base {
        static b(a) {
            if (DomainChartDescriptionMetadata.a == null) {
                DomainChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DomainChartDescriptionMetadata.c(a, DomainChartDescriptionMetadata.a);
                ChartSeriesEventArgsDescriptionMetadata.d(a);
                DomainChartSeriesPointerEventArgsDescriptionMetadata.d(a);
                CalloutStyleUpdatingEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("PixelScalingRatio", "Number:double");
            b.item("TitleLeftMargin", "Number:double");
            b.item("TitleRightMargin", "Number:double");
            b.item("TitleTopMargin", "Number:double");
            b.item("TitleBottomMargin", "Number:double");
            b.item("SubtitleLeftMargin", "Number:double");
            b.item("SubtitleTopMargin", "Number:double");
            b.item("SubtitleRightMargin", "Number:double");
            b.item("SubtitleBottomMargin", "Number:double");
            b.item("SubtitleTextColor", "Brush");
            b.item("TitleTextColor", "Brush");
            b.item("LeftMargin", "Number:double");
            b.item("TopMargin", "Number:double");
            b.item("RightMargin", "Number:double");
            b.item("BottomMargin", "Number:double");
            b.item("TransitionDuration", "Number:int");
            b.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            b.item("SubtitleTextStyle", "String");
            b.item("TitleTextStyle", "String");
            b.item("DataSourceRef", "(w:ItemsSource,wf:DataSource)DataRef::object");
            b.item("IncludedProperties", "Array:string");
            b.item("ExcludedProperties", "Array:string");
            b.item("Brushes", "BrushCollection:string");
            b.item("Outlines", "BrushCollection:string");
            b.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            b.item("IsHorizontalZoomEnabled", "Boolean");
            b.item("IsVerticalZoomEnabled", "Boolean");
            b.item("IsSeriesHighlightingEnabled", "Boolean");
            b.item("WindowRect", "Rect");
            b.item("ChartTitle", "(w:Title,wf:Title)String");
            b.item("Subtitle", "String");
            b.item("TitleAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("TitleAlignment@names", "Left;Center;Right;Stretch");
            b.item("SubtitleAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("SubtitleAlignment@names", "Left;Center;Right;Stretch");
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
            b.item("Resolution", "Number:double");
            b.item("Thickness", "Number:double");
            b.item("OutlineMode", "ExportedType:string:SeriesOutlineMode");
            b.item("OutlineMode@names", "Auto;Visible;Collapsed");
            b.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            b.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            b.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            b.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            b.item("MarkerFillOpacity", "Number:double");
            b.item("MarkerTypes", "Collection:string:MarkerTypeCollection:MarkerType");
            b.item("MarkerTypes@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerBrushes", "BrushCollection:string");
            b.item("MarkerOutlines", "BrushCollection:string");
            b.item("MarkerMaxCount", "Number:int");
            b.item("AnimateSeriesWhenAxisRangeChanges", "Boolean");
            b.item("TrendLineBrushes", "BrushCollection:string");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineThickness", "Number:double");
            b.item("AlignsGridLinesToPixels", "Boolean");
            b.item("PlotAreaMarginLeft", "Number:double");
            b.item("PlotAreaMarginTop", "Number:double");
            b.item("PlotAreaMarginRight", "Number:double");
            b.item("PlotAreaMarginBottom", "Number:double");
            b.item("ComputedPlotAreaMarginMode", "ExportedType:string:ComputedPlotAreaMarginMode");
            b.item("ComputedPlotAreaMarginMode@names", "Auto;Series;None");
            b.item("HighlightingMode", "ExportedType:string:SeriesHighlightingMode");
            b.item("HighlightingMode@names", "Auto;None;BrightenSpecific;Brighten;FadeOthersSpecific;FadeOthers");
            b.item("HighlightingBehavior", "ExportedType:string:SeriesHighlightingBehavior");
            b.item("HighlightingBehavior@names", "Auto;DirectlyOver;NearestItems;NearestItemsRetainMainShapes;NearestItemsAndSeries");
            b.item("LegendHighlightingMode", "ExportedType:string:LegendHighlightingMode");
            b.item("LegendHighlightingMode@names", "Auto;None;MatchSeries");
            b.item("ShouldAutoExpandMarginForInitialLabels", "Boolean");
            b.item("AutoExpandMarginExtraPadding", "Number:double");
            b.item("AutoExpandMarginMaximumValue", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
            b.item("ToolTipType", "ExportedType:string:ToolTipType");
            b.item("ToolTipType@names", "Default;Item;Category;None");
            b.item("CrosshairsDisplayMode", "ExportedType:string:CrosshairsDisplayMode");
            b.item("CrosshairsDisplayMode@names", "Default;None;Horizontal;Vertical;Both");
            b.item("CrosshairsSnapToData", "Boolean");
            b.item("CrosshairsAnnotationEnabled", "Boolean");
            b.item("FinalValueAnnotationsVisible", "Boolean");
            b.item("CalloutsVisible", "Boolean");
            b.item("CalloutStyleUpdatingEventEnabled", "Boolean");
            b.item("CalloutsDataSourceRef", "(w:CalloutsItemsSource,wf:CalloutsDataSource)DataRef::object");
            b.item("CalloutsXMemberPath", "String");
            b.item("CalloutsYMemberPath", "String");
            b.item("CalloutsLabelMemberPath", "String");
            b.item("CalloutsContentMemberPath", "String");
            b.item("SeriesAddedRef", "EventRef::seriesAdded");
            b.item("SeriesRemovedRef", "EventRef::seriesRemoved");
            b.item("SeriesPointerEnterRef", "EventRef::seriesPointerEnter");
            b.item("SeriesPointerLeaveRef", "EventRef::seriesPointerLeave");
            b.item("SeriesPointerMoveRef", "EventRef::seriesPointerMove");
            b.item("SeriesPointerDownRef", "EventRef::seriesPointerDown");
            b.item("SeriesPointerUpRef", "EventRef::seriesPointerUp");
            b.item("CalloutStyleUpdatingRef", "EventRef::calloutStyleUpdating");
        }
        static d(a) {
            DomainChartDescriptionMetadata.b(a);
            a.p("DomainChart", DomainChartDescriptionMetadata.a);
        }
    }
    DomainChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DomainChartDescriptionMetadata, 'DomainChartDescriptionMetadata');
    DomainChartDescriptionMetadata.a = null;
    return DomainChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XYChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class XYChartDescriptionMetadata extends Base {
        static b(a) {
            if (XYChartDescriptionMetadata.a == null) {
                XYChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                XYChartDescriptionMetadata.c(a, XYChartDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DomainChartDescriptionMetadata.c(a, b);
            b.item("XAxisFormatLabelRef", "(w:XAxisFormatLabel,wf:XAxisFormatLabel)MethodRef");
            b.item("YAxisFormatLabelRef", "(w:YAxisFormatLabel,wf:YAxisFormatLabel)MethodRef");
            b.item("XAxisLabelLeftMargin", "Number:double");
            b.item("XAxisLabelTopMargin", "Number:double");
            b.item("XAxisLabelRightMargin", "Number:double");
            b.item("XAxisLabelBottomMargin", "Number:double");
            b.item("YAxisLabelLeftMargin", "Number:double");
            b.item("YAxisLabelTopMargin", "Number:double");
            b.item("YAxisLabelRightMargin", "Number:double");
            b.item("YAxisLabelBottomMargin", "Number:double");
            b.item("XAxisLabelTextColor", "Brush");
            b.item("YAxisLabelTextColor", "Brush");
            b.item("XAxisTitleMargin", "Number:double");
            b.item("YAxisTitleMargin", "Number:double");
            b.item("XAxisTitleLeftMargin", "Number:double");
            b.item("YAxisTitleLeftMargin", "Number:double");
            b.item("XAxisTitleTopMargin", "Number:double");
            b.item("YAxisTitleTopMargin", "Number:double");
            b.item("XAxisTitleRightMargin", "Number:double");
            b.item("YAxisTitleRightMargin", "Number:double");
            b.item("XAxisTitleBottomMargin", "Number:double");
            b.item("YAxisTitleBottomMargin", "Number:double");
            b.item("XAxisTitleTextColor", "Brush");
            b.item("YAxisTitleTextColor", "Brush");
            b.item("XAxisLabelTextStyle", "String");
            b.item("YAxisLabelTextStyle", "String");
            b.item("XAxisTitleTextStyle", "String");
            b.item("YAxisTitleTextStyle", "String");
            b.item("XAxisLabelRef", "(w:XAxisLabel,wf:XAxisLabel)DataRef");
            b.item("YAxisLabelRef", "(w:YAxisLabel,wf:YAxisLabel)DataRef");
            b.item("XAxisMajorStroke", "Brush");
            b.item("YAxisMajorStroke", "Brush");
            b.item("XAxisMajorStrokeThickness", "Number:double");
            b.item("YAxisMajorStrokeThickness", "Number:double");
            b.item("XAxisMinorStrokeThickness", "Number:double");
            b.item("YAxisMinorStrokeThickness", "Number:double");
            b.item("XAxisStrip", "Brush");
            b.item("YAxisStrip", "Brush");
            b.item("XAxisStroke", "Brush");
            b.item("YAxisStroke", "Brush");
            b.item("XAxisStrokeThickness", "Number:double");
            b.item("YAxisStrokeThickness", "Number:double");
            b.item("XAxisTickLength", "Number:double");
            b.item("YAxisTickLength", "Number:double");
            b.item("XAxisTickStroke", "Brush");
            b.item("YAxisTickStroke", "Brush");
            b.item("XAxisTickStrokeThickness", "Number:double");
            b.item("YAxisTickStrokeThickness", "Number:double");
            b.item("XAxisTitle", "String");
            b.item("YAxisTitle", "String");
            b.item("XAxisMinorStroke", "Brush");
            b.item("YAxisMinorStroke", "Brush");
            b.item("XAxisLabelAngle", "Number:double");
            b.item("YAxisLabelAngle", "Number:double");
            b.item("XAxisExtent", "Number:double");
            b.item("YAxisExtent", "Number:double");
            b.item("XAxisTitleAngle", "Number:double");
            b.item("YAxisTitleAngle", "Number:double");
            b.item("XAxisInverted", "Boolean");
            b.item("YAxisInverted", "Boolean");
            b.item("XAxisTitleAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("XAxisTitleAlignment@names", "Left;Center;Right;Stretch");
            b.item("YAxisTitleAlignment", "ExportedType:string:VerticalAlignment");
            b.item("YAxisTitleAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("XAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("XAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("YAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("YAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("XAxisLabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            b.item("XAxisLabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("YAxisLabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            b.item("YAxisLabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("XAxisLabelVisibility", "ExportedType:string:Visibility");
            b.item("XAxisLabelVisibility@names", "Visible;Collapsed");
            b.item("YAxisLabelVisibility", "ExportedType:string:Visibility");
            b.item("YAxisLabelVisibility@names", "Visible;Collapsed");
            b.item("YAxisLabelLocation", "ExportedType:string:AxisLabelsLocation");
            b.item("YAxisLabelLocation@names", "OutsideTop;OutsideBottom;OutsideLeft;OutsideRight;InsideTop;InsideBottom;InsideLeft;InsideRight");
            b.item("XAxisLabelFormat", "String");
            b.item("XAxisLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("YAxisLabelFormat", "String");
            b.item("YAxisLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
        }
        static d(a) {
            XYChartDescriptionMetadata.b(a);
            a.p("XYChart", XYChartDescriptionMetadata.a);
        }
    }
    XYChartDescriptionMetadata.$t = /*@__PURE__*/ markType(XYChartDescriptionMetadata, 'XYChartDescriptionMetadata');
    XYChartDescriptionMetadata.a = null;
    return XYChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DomainChartDescription = /*@__PURE__*/ (() => {
    class DomainChartDescription extends Description {
        constructor() {
            super();
            this.ay = 0;
            this.bb = 0;
            this.bc = 0;
            this.bd = 0;
            this.ba = 0;
            this.a6 = 0;
            this.a8 = 0;
            this.a7 = 0;
            this.a5 = 0;
            this.cz = null;
            this.c2 = null;
            this.aw = 0;
            this.be = 0;
            this.a4 = 0;
            this.av = 0;
            this.b4 = 0;
            this.c5 = null;
            this.c0 = null;
            this.c3 = null;
            this.ci = null;
            this.h = null;
            this.g = null;
            this.f = null;
            this.l = null;
            this.cm = null;
            this.ae = false;
            this.ag = false;
            this.af = false;
            this.v = null;
            this.cf = null;
            this.cx = null;
            this.c1 = null;
            this.cy = null;
            this.c7 = null;
            this.a3 = 0;
            this.a9 = 0;
            this.cp = null;
            this.co = null;
            this.cn = null;
            this.ax = 0;
            this.k = null;
            this.i = null;
            this.j = null;
            this.b3 = 0;
            this.y = false;
            this.m = null;
            this.c6 = null;
            this.bf = 0;
            this.x = false;
            this.a0 = 0;
            this.a2 = 0;
            this.a1 = 0;
            this.az = 0;
            this.cg = null;
            this.ck = null;
            this.cj = null;
            this.cl = null;
            this.ah = false;
            this.at = 0;
            this.au = 0;
            this.b5 = 0;
            this.c4 = null;
            this.ch = null;
            this.ac = false;
            this.ab = false;
            this.ad = false;
            this.aa = false;
            this.z = false;
            this.ca = null;
            this.cd = null;
            this.ce = null;
            this.cb = null;
            this.b9 = null;
            this.cq = null;
            this.cw = null;
            this.cs = null;
            this.ct = null;
            this.cu = null;
            this.cr = null;
            this.cv = null;
            this.cc = null;
        }
        get_type() {
            return "DomainChart";
        }
        get type() {
            return this.get_type();
        }
        get pixelScalingRatio() {
            return this.ay;
        }
        set pixelScalingRatio(a) {
            this.ay = a;
            this.e("PixelScalingRatio");
        }
        get titleLeftMargin() {
            return this.bb;
        }
        set titleLeftMargin(a) {
            this.bb = a;
            this.e("TitleLeftMargin");
        }
        get titleRightMargin() {
            return this.bc;
        }
        set titleRightMargin(a) {
            this.bc = a;
            this.e("TitleRightMargin");
        }
        get titleTopMargin() {
            return this.bd;
        }
        set titleTopMargin(a) {
            this.bd = a;
            this.e("TitleTopMargin");
        }
        get titleBottomMargin() {
            return this.ba;
        }
        set titleBottomMargin(a) {
            this.ba = a;
            this.e("TitleBottomMargin");
        }
        get subtitleLeftMargin() {
            return this.a6;
        }
        set subtitleLeftMargin(a) {
            this.a6 = a;
            this.e("SubtitleLeftMargin");
        }
        get subtitleTopMargin() {
            return this.a8;
        }
        set subtitleTopMargin(a) {
            this.a8 = a;
            this.e("SubtitleTopMargin");
        }
        get subtitleRightMargin() {
            return this.a7;
        }
        set subtitleRightMargin(a) {
            this.a7 = a;
            this.e("SubtitleRightMargin");
        }
        get subtitleBottomMargin() {
            return this.a5;
        }
        set subtitleBottomMargin(a) {
            this.a5 = a;
            this.e("SubtitleBottomMargin");
        }
        get subtitleTextColor() {
            return this.cz;
        }
        set subtitleTextColor(a) {
            this.cz = a;
            this.e("SubtitleTextColor");
        }
        get titleTextColor() {
            return this.c2;
        }
        set titleTextColor(a) {
            this.c2 = a;
            this.e("TitleTextColor");
        }
        get leftMargin() {
            return this.aw;
        }
        set leftMargin(a) {
            this.aw = a;
            this.e("LeftMargin");
        }
        get topMargin() {
            return this.be;
        }
        set topMargin(a) {
            this.be = a;
            this.e("TopMargin");
        }
        get rightMargin() {
            return this.a4;
        }
        set rightMargin(a) {
            this.a4 = a;
            this.e("RightMargin");
        }
        get bottomMargin() {
            return this.av;
        }
        set bottomMargin(a) {
            this.av = a;
            this.e("BottomMargin");
        }
        get transitionDuration() {
            return this.b4;
        }
        set transitionDuration(a) {
            this.b4 = a;
            this.e("TransitionDuration");
        }
        get transitionEasingFunctionRef() {
            return this.c5;
        }
        set transitionEasingFunctionRef(a) {
            this.c5 = a;
            this.e("TransitionEasingFunctionRef");
        }
        get subtitleTextStyle() {
            return this.c0;
        }
        set subtitleTextStyle(a) {
            this.c0 = a;
            this.e("SubtitleTextStyle");
        }
        get titleTextStyle() {
            return this.c3;
        }
        set titleTextStyle(a) {
            this.c3 = a;
            this.e("TitleTextStyle");
        }
        get dataSourceRef() {
            return this.ci;
        }
        set dataSourceRef(a) {
            this.ci = a;
            this.e("DataSourceRef");
        }
        get includedProperties() {
            return this.h;
        }
        set includedProperties(a) {
            this.h = a;
            this.e("IncludedProperties");
        }
        get excludedProperties() {
            return this.g;
        }
        set excludedProperties(a) {
            this.g = a;
            this.e("ExcludedProperties");
        }
        get brushes() {
            return this.f;
        }
        set brushes(a) {
            this.f = a;
            this.e("Brushes");
        }
        get outlines() {
            return this.l;
        }
        set outlines(a) {
            this.l = a;
            this.e("Outlines");
        }
        get legendRef() {
            return this.cm;
        }
        set legendRef(a) {
            this.cm = a;
            this.e("LegendRef");
        }
        get isHorizontalZoomEnabled() {
            return this.ae;
        }
        set isHorizontalZoomEnabled(a) {
            this.ae = a;
            this.e("IsHorizontalZoomEnabled");
        }
        get isVerticalZoomEnabled() {
            return this.ag;
        }
        set isVerticalZoomEnabled(a) {
            this.ag = a;
            this.e("IsVerticalZoomEnabled");
        }
        get isSeriesHighlightingEnabled() {
            return this.af;
        }
        set isSeriesHighlightingEnabled(a) {
            this.af = a;
            this.e("IsSeriesHighlightingEnabled");
        }
        get windowRect() {
            return this.v;
        }
        set windowRect(a) {
            this.v = a;
            this.e("WindowRect");
        }
        get chartTitle() {
            return this.cf;
        }
        set chartTitle(a) {
            this.cf = a;
            this.e("ChartTitle");
        }
        get subtitle() {
            return this.cx;
        }
        set subtitle(a) {
            this.cx = a;
            this.e("Subtitle");
        }
        get titleAlignment() {
            return this.c1;
        }
        set titleAlignment(a) {
            this.c1 = a;
            this.e("TitleAlignment");
        }
        get subtitleAlignment() {
            return this.cy;
        }
        set subtitleAlignment(a) {
            this.cy = a;
            this.e("SubtitleAlignment");
        }
        get unknownValuePlotting() {
            return this.c7;
        }
        set unknownValuePlotting(a) {
            this.c7 = a;
            this.e("UnknownValuePlotting");
        }
        get resolution() {
            return this.a3;
        }
        set resolution(a) {
            this.a3 = a;
            this.e("Resolution");
        }
        get thickness() {
            return this.a9;
        }
        set thickness(a) {
            this.a9 = a;
            this.e("Thickness");
        }
        get outlineMode() {
            return this.cp;
        }
        set outlineMode(a) {
            this.cp = a;
            this.e("OutlineMode");
        }
        get markerOutlineMode() {
            return this.co;
        }
        set markerOutlineMode(a) {
            this.co = a;
            this.e("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.cn;
        }
        set markerFillMode(a) {
            this.cn = a;
            this.e("MarkerFillMode");
        }
        get markerFillOpacity() {
            return this.ax;
        }
        set markerFillOpacity(a) {
            this.ax = a;
            this.e("MarkerFillOpacity");
        }
        get markerTypes() {
            return this.k;
        }
        set markerTypes(a) {
            this.k = a;
            this.e("MarkerTypes");
        }
        get markerBrushes() {
            return this.i;
        }
        set markerBrushes(a) {
            this.i = a;
            this.e("MarkerBrushes");
        }
        get markerOutlines() {
            return this.j;
        }
        set markerOutlines(a) {
            this.j = a;
            this.e("MarkerOutlines");
        }
        get markerMaxCount() {
            return this.b3;
        }
        set markerMaxCount(a) {
            this.b3 = a;
            this.e("MarkerMaxCount");
        }
        get animateSeriesWhenAxisRangeChanges() {
            return this.y;
        }
        set animateSeriesWhenAxisRangeChanges(a) {
            this.y = a;
            this.e("AnimateSeriesWhenAxisRangeChanges");
        }
        get trendLineBrushes() {
            return this.m;
        }
        set trendLineBrushes(a) {
            this.m = a;
            this.e("TrendLineBrushes");
        }
        get trendLineType() {
            return this.c6;
        }
        set trendLineType(a) {
            this.c6 = a;
            this.e("TrendLineType");
        }
        get trendLineThickness() {
            return this.bf;
        }
        set trendLineThickness(a) {
            this.bf = a;
            this.e("TrendLineThickness");
        }
        get alignsGridLinesToPixels() {
            return this.x;
        }
        set alignsGridLinesToPixels(a) {
            this.x = a;
            this.e("AlignsGridLinesToPixels");
        }
        get plotAreaMarginLeft() {
            return this.a0;
        }
        set plotAreaMarginLeft(a) {
            this.a0 = a;
            this.e("PlotAreaMarginLeft");
        }
        get plotAreaMarginTop() {
            return this.a2;
        }
        set plotAreaMarginTop(a) {
            this.a2 = a;
            this.e("PlotAreaMarginTop");
        }
        get plotAreaMarginRight() {
            return this.a1;
        }
        set plotAreaMarginRight(a) {
            this.a1 = a;
            this.e("PlotAreaMarginRight");
        }
        get plotAreaMarginBottom() {
            return this.az;
        }
        set plotAreaMarginBottom(a) {
            this.az = a;
            this.e("PlotAreaMarginBottom");
        }
        get computedPlotAreaMarginMode() {
            return this.cg;
        }
        set computedPlotAreaMarginMode(a) {
            this.cg = a;
            this.e("ComputedPlotAreaMarginMode");
        }
        get highlightingMode() {
            return this.ck;
        }
        set highlightingMode(a) {
            this.ck = a;
            this.e("HighlightingMode");
        }
        get highlightingBehavior() {
            return this.cj;
        }
        set highlightingBehavior(a) {
            this.cj = a;
            this.e("HighlightingBehavior");
        }
        get legendHighlightingMode() {
            return this.cl;
        }
        set legendHighlightingMode(a) {
            this.cl = a;
            this.e("LegendHighlightingMode");
        }
        get shouldAutoExpandMarginForInitialLabels() {
            return this.ah;
        }
        set shouldAutoExpandMarginForInitialLabels(a) {
            this.ah = a;
            this.e("ShouldAutoExpandMarginForInitialLabels");
        }
        get autoExpandMarginExtraPadding() {
            return this.at;
        }
        set autoExpandMarginExtraPadding(a) {
            this.at = a;
            this.e("AutoExpandMarginExtraPadding");
        }
        get autoExpandMarginMaximumValue() {
            return this.au;
        }
        set autoExpandMarginMaximumValue(a) {
            this.au = a;
            this.e("AutoExpandMarginMaximumValue");
        }
        get trendLinePeriod() {
            return this.b5;
        }
        set trendLinePeriod(a) {
            this.b5 = a;
            this.e("TrendLinePeriod");
        }
        get toolTipType() {
            return this.c4;
        }
        set toolTipType(a) {
            this.c4 = a;
            this.e("ToolTipType");
        }
        get crosshairsDisplayMode() {
            return this.ch;
        }
        set crosshairsDisplayMode(a) {
            this.ch = a;
            this.e("CrosshairsDisplayMode");
        }
        get crosshairsSnapToData() {
            return this.ac;
        }
        set crosshairsSnapToData(a) {
            this.ac = a;
            this.e("CrosshairsSnapToData");
        }
        get crosshairsAnnotationEnabled() {
            return this.ab;
        }
        set crosshairsAnnotationEnabled(a) {
            this.ab = a;
            this.e("CrosshairsAnnotationEnabled");
        }
        get finalValueAnnotationsVisible() {
            return this.ad;
        }
        set finalValueAnnotationsVisible(a) {
            this.ad = a;
            this.e("FinalValueAnnotationsVisible");
        }
        get calloutsVisible() {
            return this.aa;
        }
        set calloutsVisible(a) {
            this.aa = a;
            this.e("CalloutsVisible");
        }
        get calloutStyleUpdatingEventEnabled() {
            return this.z;
        }
        set calloutStyleUpdatingEventEnabled(a) {
            this.z = a;
            this.e("CalloutStyleUpdatingEventEnabled");
        }
        get calloutsDataSourceRef() {
            return this.ca;
        }
        set calloutsDataSourceRef(a) {
            this.ca = a;
            this.e("CalloutsDataSourceRef");
        }
        get calloutsXMemberPath() {
            return this.cd;
        }
        set calloutsXMemberPath(a) {
            this.cd = a;
            this.e("CalloutsXMemberPath");
        }
        get calloutsYMemberPath() {
            return this.ce;
        }
        set calloutsYMemberPath(a) {
            this.ce = a;
            this.e("CalloutsYMemberPath");
        }
        get calloutsLabelMemberPath() {
            return this.cb;
        }
        set calloutsLabelMemberPath(a) {
            this.cb = a;
            this.e("CalloutsLabelMemberPath");
        }
        get calloutsContentMemberPath() {
            return this.b9;
        }
        set calloutsContentMemberPath(a) {
            this.b9 = a;
            this.e("CalloutsContentMemberPath");
        }
        get seriesAddedRef() {
            return this.cq;
        }
        set seriesAddedRef(a) {
            this.cq = a;
            this.e("SeriesAddedRef");
        }
        get seriesRemovedRef() {
            return this.cw;
        }
        set seriesRemovedRef(a) {
            this.cw = a;
            this.e("SeriesRemovedRef");
        }
        get seriesPointerEnterRef() {
            return this.cs;
        }
        set seriesPointerEnterRef(a) {
            this.cs = a;
            this.e("SeriesPointerEnterRef");
        }
        get seriesPointerLeaveRef() {
            return this.ct;
        }
        set seriesPointerLeaveRef(a) {
            this.ct = a;
            this.e("SeriesPointerLeaveRef");
        }
        get seriesPointerMoveRef() {
            return this.cu;
        }
        set seriesPointerMoveRef(a) {
            this.cu = a;
            this.e("SeriesPointerMoveRef");
        }
        get seriesPointerDownRef() {
            return this.cr;
        }
        set seriesPointerDownRef(a) {
            this.cr = a;
            this.e("SeriesPointerDownRef");
        }
        get seriesPointerUpRef() {
            return this.cv;
        }
        set seriesPointerUpRef(a) {
            this.cv = a;
            this.e("SeriesPointerUpRef");
        }
        get calloutStyleUpdatingRef() {
            return this.cc;
        }
        set calloutStyleUpdatingRef(a) {
            this.cc = a;
            this.e("CalloutStyleUpdatingRef");
        }
    }
    DomainChartDescription.$t = /*@__PURE__*/ markType(DomainChartDescription, 'DomainChartDescription', Description.$);
    return DomainChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XYChartDescription = /*@__PURE__*/ (() => {
    class XYChartDescription extends DomainChartDescription {
        constructor() {
            super();
            this.gd = null;
            this.gu = null;
            this.ek = 0;
            this.em = 0;
            this.el = 0;
            this.ej = 0;
            this.e1 = 0;
            this.e3 = 0;
            this.e2 = 0;
            this.e0 = 0;
            this.gh = null;
            this.gz = null;
            this.ev = 0;
            this.fc = 0;
            this.eu = 0;
            this.fb = 0;
            this.ex = 0;
            this.fe = 0;
            this.ew = 0;
            this.fd = 0;
            this.et = 0;
            this.fa = 0;
            this.gs = null;
            this.ha = null;
            this.gi = null;
            this.g0 = null;
            this.gt = null;
            this.hb = null;
            this.gg = null;
            this.gy = null;
            this.gl = null;
            this.g3 = null;
            this.en = 0;
            this.e4 = 0;
            this.eo = 0;
            this.e5 = 0;
            this.gn = null;
            this.g5 = null;
            this.go = null;
            this.g6 = null;
            this.ep = 0;
            this.e6 = 0;
            this.eq = 0;
            this.e7 = 0;
            this.gp = null;
            this.g7 = null;
            this.er = 0;
            this.e8 = 0;
            this.gq = null;
            this.g8 = null;
            this.gm = null;
            this.g4 = null;
            this.ei = 0;
            this.ez = 0;
            this.eh = 0;
            this.ey = 0;
            this.es = 0;
            this.e9 = 0;
            this.ed = false;
            this.ee = false;
            this.gr = null;
            this.g9 = null;
            this.gf = null;
            this.gw = null;
            this.gj = null;
            this.g1 = null;
            this.gk = null;
            this.g2 = null;
            this.gx = null;
            this.ge = null;
            this.d9 = null;
            this.gv = null;
            this.ea = null;
        }
        get_type() {
            return "XYChart";
        }
        get xAxisFormatLabelRef() {
            return this.gd;
        }
        set xAxisFormatLabelRef(a) {
            this.gd = a;
            this.e("XAxisFormatLabelRef");
        }
        get yAxisFormatLabelRef() {
            return this.gu;
        }
        set yAxisFormatLabelRef(a) {
            this.gu = a;
            this.e("YAxisFormatLabelRef");
        }
        get xAxisLabelLeftMargin() {
            return this.ek;
        }
        set xAxisLabelLeftMargin(a) {
            this.ek = a;
            this.e("XAxisLabelLeftMargin");
        }
        get xAxisLabelTopMargin() {
            return this.em;
        }
        set xAxisLabelTopMargin(a) {
            this.em = a;
            this.e("XAxisLabelTopMargin");
        }
        get xAxisLabelRightMargin() {
            return this.el;
        }
        set xAxisLabelRightMargin(a) {
            this.el = a;
            this.e("XAxisLabelRightMargin");
        }
        get xAxisLabelBottomMargin() {
            return this.ej;
        }
        set xAxisLabelBottomMargin(a) {
            this.ej = a;
            this.e("XAxisLabelBottomMargin");
        }
        get yAxisLabelLeftMargin() {
            return this.e1;
        }
        set yAxisLabelLeftMargin(a) {
            this.e1 = a;
            this.e("YAxisLabelLeftMargin");
        }
        get yAxisLabelTopMargin() {
            return this.e3;
        }
        set yAxisLabelTopMargin(a) {
            this.e3 = a;
            this.e("YAxisLabelTopMargin");
        }
        get yAxisLabelRightMargin() {
            return this.e2;
        }
        set yAxisLabelRightMargin(a) {
            this.e2 = a;
            this.e("YAxisLabelRightMargin");
        }
        get yAxisLabelBottomMargin() {
            return this.e0;
        }
        set yAxisLabelBottomMargin(a) {
            this.e0 = a;
            this.e("YAxisLabelBottomMargin");
        }
        get xAxisLabelTextColor() {
            return this.gh;
        }
        set xAxisLabelTextColor(a) {
            this.gh = a;
            this.e("XAxisLabelTextColor");
        }
        get yAxisLabelTextColor() {
            return this.gz;
        }
        set yAxisLabelTextColor(a) {
            this.gz = a;
            this.e("YAxisLabelTextColor");
        }
        get xAxisTitleMargin() {
            return this.ev;
        }
        set xAxisTitleMargin(a) {
            this.ev = a;
            this.e("XAxisTitleMargin");
        }
        get yAxisTitleMargin() {
            return this.fc;
        }
        set yAxisTitleMargin(a) {
            this.fc = a;
            this.e("YAxisTitleMargin");
        }
        get xAxisTitleLeftMargin() {
            return this.eu;
        }
        set xAxisTitleLeftMargin(a) {
            this.eu = a;
            this.e("XAxisTitleLeftMargin");
        }
        get yAxisTitleLeftMargin() {
            return this.fb;
        }
        set yAxisTitleLeftMargin(a) {
            this.fb = a;
            this.e("YAxisTitleLeftMargin");
        }
        get xAxisTitleTopMargin() {
            return this.ex;
        }
        set xAxisTitleTopMargin(a) {
            this.ex = a;
            this.e("XAxisTitleTopMargin");
        }
        get yAxisTitleTopMargin() {
            return this.fe;
        }
        set yAxisTitleTopMargin(a) {
            this.fe = a;
            this.e("YAxisTitleTopMargin");
        }
        get xAxisTitleRightMargin() {
            return this.ew;
        }
        set xAxisTitleRightMargin(a) {
            this.ew = a;
            this.e("XAxisTitleRightMargin");
        }
        get yAxisTitleRightMargin() {
            return this.fd;
        }
        set yAxisTitleRightMargin(a) {
            this.fd = a;
            this.e("YAxisTitleRightMargin");
        }
        get xAxisTitleBottomMargin() {
            return this.et;
        }
        set xAxisTitleBottomMargin(a) {
            this.et = a;
            this.e("XAxisTitleBottomMargin");
        }
        get yAxisTitleBottomMargin() {
            return this.fa;
        }
        set yAxisTitleBottomMargin(a) {
            this.fa = a;
            this.e("YAxisTitleBottomMargin");
        }
        get xAxisTitleTextColor() {
            return this.gs;
        }
        set xAxisTitleTextColor(a) {
            this.gs = a;
            this.e("XAxisTitleTextColor");
        }
        get yAxisTitleTextColor() {
            return this.ha;
        }
        set yAxisTitleTextColor(a) {
            this.ha = a;
            this.e("YAxisTitleTextColor");
        }
        get xAxisLabelTextStyle() {
            return this.gi;
        }
        set xAxisLabelTextStyle(a) {
            this.gi = a;
            this.e("XAxisLabelTextStyle");
        }
        get yAxisLabelTextStyle() {
            return this.g0;
        }
        set yAxisLabelTextStyle(a) {
            this.g0 = a;
            this.e("YAxisLabelTextStyle");
        }
        get xAxisTitleTextStyle() {
            return this.gt;
        }
        set xAxisTitleTextStyle(a) {
            this.gt = a;
            this.e("XAxisTitleTextStyle");
        }
        get yAxisTitleTextStyle() {
            return this.hb;
        }
        set yAxisTitleTextStyle(a) {
            this.hb = a;
            this.e("YAxisTitleTextStyle");
        }
        get xAxisLabelRef() {
            return this.gg;
        }
        set xAxisLabelRef(a) {
            this.gg = a;
            this.e("XAxisLabelRef");
        }
        get yAxisLabelRef() {
            return this.gy;
        }
        set yAxisLabelRef(a) {
            this.gy = a;
            this.e("YAxisLabelRef");
        }
        get xAxisMajorStroke() {
            return this.gl;
        }
        set xAxisMajorStroke(a) {
            this.gl = a;
            this.e("XAxisMajorStroke");
        }
        get yAxisMajorStroke() {
            return this.g3;
        }
        set yAxisMajorStroke(a) {
            this.g3 = a;
            this.e("YAxisMajorStroke");
        }
        get xAxisMajorStrokeThickness() {
            return this.en;
        }
        set xAxisMajorStrokeThickness(a) {
            this.en = a;
            this.e("XAxisMajorStrokeThickness");
        }
        get yAxisMajorStrokeThickness() {
            return this.e4;
        }
        set yAxisMajorStrokeThickness(a) {
            this.e4 = a;
            this.e("YAxisMajorStrokeThickness");
        }
        get xAxisMinorStrokeThickness() {
            return this.eo;
        }
        set xAxisMinorStrokeThickness(a) {
            this.eo = a;
            this.e("XAxisMinorStrokeThickness");
        }
        get yAxisMinorStrokeThickness() {
            return this.e5;
        }
        set yAxisMinorStrokeThickness(a) {
            this.e5 = a;
            this.e("YAxisMinorStrokeThickness");
        }
        get xAxisStrip() {
            return this.gn;
        }
        set xAxisStrip(a) {
            this.gn = a;
            this.e("XAxisStrip");
        }
        get yAxisStrip() {
            return this.g5;
        }
        set yAxisStrip(a) {
            this.g5 = a;
            this.e("YAxisStrip");
        }
        get xAxisStroke() {
            return this.go;
        }
        set xAxisStroke(a) {
            this.go = a;
            this.e("XAxisStroke");
        }
        get yAxisStroke() {
            return this.g6;
        }
        set yAxisStroke(a) {
            this.g6 = a;
            this.e("YAxisStroke");
        }
        get xAxisStrokeThickness() {
            return this.ep;
        }
        set xAxisStrokeThickness(a) {
            this.ep = a;
            this.e("XAxisStrokeThickness");
        }
        get yAxisStrokeThickness() {
            return this.e6;
        }
        set yAxisStrokeThickness(a) {
            this.e6 = a;
            this.e("YAxisStrokeThickness");
        }
        get xAxisTickLength() {
            return this.eq;
        }
        set xAxisTickLength(a) {
            this.eq = a;
            this.e("XAxisTickLength");
        }
        get yAxisTickLength() {
            return this.e7;
        }
        set yAxisTickLength(a) {
            this.e7 = a;
            this.e("YAxisTickLength");
        }
        get xAxisTickStroke() {
            return this.gp;
        }
        set xAxisTickStroke(a) {
            this.gp = a;
            this.e("XAxisTickStroke");
        }
        get yAxisTickStroke() {
            return this.g7;
        }
        set yAxisTickStroke(a) {
            this.g7 = a;
            this.e("YAxisTickStroke");
        }
        get xAxisTickStrokeThickness() {
            return this.er;
        }
        set xAxisTickStrokeThickness(a) {
            this.er = a;
            this.e("XAxisTickStrokeThickness");
        }
        get yAxisTickStrokeThickness() {
            return this.e8;
        }
        set yAxisTickStrokeThickness(a) {
            this.e8 = a;
            this.e("YAxisTickStrokeThickness");
        }
        get xAxisTitle() {
            return this.gq;
        }
        set xAxisTitle(a) {
            this.gq = a;
            this.e("XAxisTitle");
        }
        get yAxisTitle() {
            return this.g8;
        }
        set yAxisTitle(a) {
            this.g8 = a;
            this.e("YAxisTitle");
        }
        get xAxisMinorStroke() {
            return this.gm;
        }
        set xAxisMinorStroke(a) {
            this.gm = a;
            this.e("XAxisMinorStroke");
        }
        get yAxisMinorStroke() {
            return this.g4;
        }
        set yAxisMinorStroke(a) {
            this.g4 = a;
            this.e("YAxisMinorStroke");
        }
        get xAxisLabelAngle() {
            return this.ei;
        }
        set xAxisLabelAngle(a) {
            this.ei = a;
            this.e("XAxisLabelAngle");
        }
        get yAxisLabelAngle() {
            return this.ez;
        }
        set yAxisLabelAngle(a) {
            this.ez = a;
            this.e("YAxisLabelAngle");
        }
        get xAxisExtent() {
            return this.eh;
        }
        set xAxisExtent(a) {
            this.eh = a;
            this.e("XAxisExtent");
        }
        get yAxisExtent() {
            return this.ey;
        }
        set yAxisExtent(a) {
            this.ey = a;
            this.e("YAxisExtent");
        }
        get xAxisTitleAngle() {
            return this.es;
        }
        set xAxisTitleAngle(a) {
            this.es = a;
            this.e("XAxisTitleAngle");
        }
        get yAxisTitleAngle() {
            return this.e9;
        }
        set yAxisTitleAngle(a) {
            this.e9 = a;
            this.e("YAxisTitleAngle");
        }
        get xAxisInverted() {
            return this.ed;
        }
        set xAxisInverted(a) {
            this.ed = a;
            this.e("XAxisInverted");
        }
        get yAxisInverted() {
            return this.ee;
        }
        set yAxisInverted(a) {
            this.ee = a;
            this.e("YAxisInverted");
        }
        get xAxisTitleAlignment() {
            return this.gr;
        }
        set xAxisTitleAlignment(a) {
            this.gr = a;
            this.e("XAxisTitleAlignment");
        }
        get yAxisTitleAlignment() {
            return this.g9;
        }
        set yAxisTitleAlignment(a) {
            this.g9 = a;
            this.e("YAxisTitleAlignment");
        }
        get xAxisLabelHorizontalAlignment() {
            return this.gf;
        }
        set xAxisLabelHorizontalAlignment(a) {
            this.gf = a;
            this.e("XAxisLabelHorizontalAlignment");
        }
        get yAxisLabelHorizontalAlignment() {
            return this.gw;
        }
        set yAxisLabelHorizontalAlignment(a) {
            this.gw = a;
            this.e("YAxisLabelHorizontalAlignment");
        }
        get xAxisLabelVerticalAlignment() {
            return this.gj;
        }
        set xAxisLabelVerticalAlignment(a) {
            this.gj = a;
            this.e("XAxisLabelVerticalAlignment");
        }
        get yAxisLabelVerticalAlignment() {
            return this.g1;
        }
        set yAxisLabelVerticalAlignment(a) {
            this.g1 = a;
            this.e("YAxisLabelVerticalAlignment");
        }
        get xAxisLabelVisibility() {
            return this.gk;
        }
        set xAxisLabelVisibility(a) {
            this.gk = a;
            this.e("XAxisLabelVisibility");
        }
        get yAxisLabelVisibility() {
            return this.g2;
        }
        set yAxisLabelVisibility(a) {
            this.g2 = a;
            this.e("YAxisLabelVisibility");
        }
        get yAxisLabelLocation() {
            return this.gx;
        }
        set yAxisLabelLocation(a) {
            this.gx = a;
            this.e("YAxisLabelLocation");
        }
        get xAxisLabelFormat() {
            return this.ge;
        }
        set xAxisLabelFormat(a) {
            this.ge = a;
            this.e("XAxisLabelFormat");
        }
        get xAxisLabelFormatSpecifiers() {
            return this.d9;
        }
        set xAxisLabelFormatSpecifiers(a) {
            this.d9 = a;
            this.e("XAxisLabelFormatSpecifiers");
        }
        get yAxisLabelFormat() {
            return this.gv;
        }
        set yAxisLabelFormat(a) {
            this.gv = a;
            this.e("YAxisLabelFormat");
        }
        get yAxisLabelFormatSpecifiers() {
            return this.ea;
        }
        set yAxisLabelFormatSpecifiers(a) {
            this.ea = a;
            this.e("YAxisLabelFormatSpecifiers");
        }
    }
    XYChartDescription.$t = /*@__PURE__*/ markType(XYChartDescription, 'XYChartDescription', DomainChartDescription.$);
    return XYChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartDescription = /*@__PURE__*/ (() => {
    class CategoryChartDescription extends XYChartDescription {
        constructor() {
            super();
            this.jf = null;
            this.jj = null;
            this.jd = null;
            this.jb = null;
            this.i7 = 0;
            this.jg = null;
            this.jc = null;
            this.je = null;
            this.ii = false;
            this.jh = null;
            this.ji = null;
            this.is = 0;
            this.it = 0;
            this.ir = 0;
            this.iu = 0;
            this.iv = 0;
            this.ik = false;
            this.i8 = 0;
            this.ix = 0;
            this.iw = 0;
            this.iy = 0;
            this.ib = null;
            this.ic = null;
            this.ij = false;
            this.ig = false;
            this.ih = false;
        }
        get tooltipTemplateRef() {
            return this.jf;
        }
        set tooltipTemplateRef(a) {
            this.jf = a;
            this.e("TooltipTemplateRef");
        }
        get width() {
            return this.jj;
        }
        set width(a) {
            this.jj = a;
            this.e("Width");
        }
        get height() {
            return this.jd;
        }
        set height(a) {
            this.jd = a;
            this.e("Height");
        }
        get background() {
            return this.jb;
        }
        set background(a) {
            this.jb = a;
            this.e("Background");
        }
        get_type() {
            return "CategoryChart";
        }
        get transitionInDuration() {
            return this.i7;
        }
        set transitionInDuration(a) {
            this.i7 = a;
            this.e("TransitionInDuration");
        }
        get transitionInEasingFunctionRef() {
            return this.jg;
        }
        set transitionInEasingFunctionRef(a) {
            this.jg = a;
            this.e("TransitionInEasingFunctionRef");
        }
        get chartType() {
            return this.jc;
        }
        set chartType(a) {
            this.jc = a;
            this.e("ChartType");
        }
        get markerCollisionAvoidance() {
            return this.je;
        }
        set markerCollisionAvoidance(a) {
            this.je = a;
            this.e("MarkerCollisionAvoidance");
        }
        get isTransitionInEnabled() {
            return this.ii;
        }
        set isTransitionInEnabled(a) {
            this.ii = a;
            this.e("IsTransitionInEnabled");
        }
        get transitionInMode() {
            return this.jh;
        }
        set transitionInMode(a) {
            this.jh = a;
            this.e("TransitionInMode");
        }
        get transitionInSpeedType() {
            return this.ji;
        }
        set transitionInSpeedType(a) {
            this.ji = a;
            this.e("TransitionInSpeedType");
        }
        get xAxisInterval() {
            return this.is;
        }
        set xAxisInterval(a) {
            this.is = a;
            this.e("XAxisInterval");
        }
        get xAxisMinorInterval() {
            return this.it;
        }
        set xAxisMinorInterval(a) {
            this.it = a;
            this.e("XAxisMinorInterval");
        }
        get xAxisGap() {
            return this.ir;
        }
        set xAxisGap(a) {
            this.ir = a;
            this.e("XAxisGap");
        }
        get xAxisOverlap() {
            return this.iu;
        }
        set xAxisOverlap(a) {
            this.iu = a;
            this.e("XAxisOverlap");
        }
        get yAxisInterval() {
            return this.iv;
        }
        set yAxisInterval(a) {
            this.iv = a;
            this.e("YAxisInterval");
        }
        get yAxisIsLogarithmic() {
            return this.ik;
        }
        set yAxisIsLogarithmic(a) {
            this.ik = a;
            this.e("YAxisIsLogarithmic");
        }
        get yAxisLogarithmBase() {
            return this.i8;
        }
        set yAxisLogarithmBase(a) {
            this.i8 = a;
            this.e("YAxisLogarithmBase");
        }
        get yAxisMinimumValue() {
            return this.ix;
        }
        set yAxisMinimumValue(a) {
            this.ix = a;
            this.e("YAxisMinimumValue");
        }
        get yAxisMaximumValue() {
            return this.iw;
        }
        set yAxisMaximumValue(a) {
            this.iw = a;
            this.e("YAxisMaximumValue");
        }
        get yAxisMinorInterval() {
            return this.iy;
        }
        set yAxisMinorInterval(a) {
            this.iy = a;
            this.e("YAxisMinorInterval");
        }
        get negativeBrushes() {
            return this.ib;
        }
        set negativeBrushes(a) {
            this.ib = a;
            this.e("NegativeBrushes");
        }
        get negativeOutlines() {
            return this.ic;
        }
        set negativeOutlines(a) {
            this.ic = a;
            this.e("NegativeOutlines");
        }
        get yAxisAbbreviateLargeNumbers() {
            return this.ij;
        }
        set yAxisAbbreviateLargeNumbers(a) {
            this.ij = a;
            this.e("YAxisAbbreviateLargeNumbers");
        }
        get isCategoryHighlightingEnabled() {
            return this.ig;
        }
        set isCategoryHighlightingEnabled(a) {
            this.ig = a;
            this.e("IsCategoryHighlightingEnabled");
        }
        get isItemHighlightingEnabled() {
            return this.ih;
        }
        set isItemHighlightingEnabled(a) {
            this.ih = a;
            this.e("IsItemHighlightingEnabled");
        }
    }
    CategoryChartDescription.$t = /*@__PURE__*/ markType(CategoryChartDescription, 'CategoryChartDescription', XYChartDescription.$);
    return CategoryChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryChartDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamCategoryChart");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (CategoryChartDescriptionMetadata.a == null) {
                CategoryChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryChartDescriptionMetadata.c(a, CategoryChartDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            XYChartDescriptionMetadata.c(a, b);
            b.item("TransitionInDuration", "Number:int");
            b.item("TransitionInEasingFunctionRef", "(w:TransitionInEasingFunction,wf:TransitionInEasingFunction)MethodRef");
            b.item("ChartType", "ExportedType:string:CategoryChartType");
            b.item("ChartType@names", "Line;Area;Column;Point;StepLine;StepArea;Spline;SplineArea;Waterfall;Auto");
            b.item("MarkerCollisionAvoidance", "ExportedType:string:CategorySeriesMarkerCollisionAvoidance");
            b.item("MarkerCollisionAvoidance@names", "None;Omit");
            b.item("IsTransitionInEnabled", "Boolean");
            b.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            b.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum");
            b.item("TransitionInSpeedType", "ExportedType:string:TransitionInSpeedType");
            b.item("TransitionInSpeedType@names", "Auto;Normal;ValueScaled;IndexScaled;Random");
            b.item("XAxisInterval", "Number:double");
            b.item("XAxisMinorInterval", "Number:double");
            b.item("XAxisGap", "Number:double");
            b.item("XAxisOverlap", "Number:double");
            b.item("YAxisInterval", "Number:double");
            b.item("YAxisIsLogarithmic", "Boolean");
            b.item("YAxisLogarithmBase", "Number:int");
            b.item("YAxisMinimumValue", "Number:double");
            b.item("YAxisMaximumValue", "Number:double");
            b.item("YAxisMinorInterval", "Number:double");
            b.item("NegativeBrushes", "BrushCollection:string");
            b.item("NegativeOutlines", "BrushCollection:string");
            b.item("YAxisAbbreviateLargeNumbers", "Boolean");
            b.item("IsCategoryHighlightingEnabled", "Boolean");
            b.item("IsItemHighlightingEnabled", "Boolean");
            CategoryChartDescriptionMetadata.e(a, b);
        }
        static d(a) {
            CategoryChartDescriptionMetadata.b(a);
            a.q("CategoryChart", () => new CategoryChartDescription());
            a.p("CategoryChart", CategoryChartDescriptionMetadata.a);
        }
    }
    CategoryChartDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryChartDescriptionMetadata, 'CategoryChartDescriptionMetadata');
    CategoryChartDescriptionMetadata.a = null;
    return CategoryChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisRangeChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class AxisRangeChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.i = 0;
            this.g = 0;
            this.h = 0;
            this.f = 0;
        }
        get_type() {
            return "AxisRangeChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get oldMinimumValue() {
            return this.i;
        }
        set oldMinimumValue(a) {
            this.i = a;
            this.e("OldMinimumValue");
        }
        get minimumValue() {
            return this.g;
        }
        set minimumValue(a) {
            this.g = a;
            this.e("MinimumValue");
        }
        get oldMaximumValue() {
            return this.h;
        }
        set oldMaximumValue(a) {
            this.h = a;
            this.e("OldMaximumValue");
        }
        get maximumValue() {
            return this.f;
        }
        set maximumValue(a) {
            this.f = a;
            this.e("MaximumValue");
        }
    }
    AxisRangeChangedEventArgsDescription.$t = /*@__PURE__*/ markType(AxisRangeChangedEventArgsDescription, 'AxisRangeChangedEventArgsDescription', Description.$);
    return AxisRangeChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisRangeChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AxisRangeChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AxisRangeChangedEventArgsDescriptionMetadata.a == null) {
                AxisRangeChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AxisRangeChangedEventArgsDescriptionMetadata.c(a, AxisRangeChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("OldMinimumValue", "Number:double");
            b.item("MinimumValue", "Number:double");
            b.item("OldMaximumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
        }
        static d(a) {
            AxisRangeChangedEventArgsDescriptionMetadata.b(a);
            a.q("AxisRangeChangedEventArgs", () => new AxisRangeChangedEventArgsDescription());
            a.p("AxisRangeChangedEventArgs", AxisRangeChangedEventArgsDescriptionMetadata.a);
        }
    }
    AxisRangeChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AxisRangeChangedEventArgsDescriptionMetadata, 'AxisRangeChangedEventArgsDescriptionMetadata');
    AxisRangeChangedEventArgsDescriptionMetadata.a = null;
    return AxisRangeChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class AxisDescriptionMetadata extends Base {
        static b(a) {
            if (AxisDescriptionMetadata.a == null) {
                AxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AxisDescriptionMetadata.c(a, AxisDescriptionMetadata.a);
                AxisRangeChangedEventArgsDescriptionMetadata.d(a);
                RenderRequestedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            b.item("Title", "String");
            b.item("Stroke", "Brush");
            b.item("ActualStroke", "Brush");
            b.item("StrokeThickness", "Number:double");
            b.item("Strip", "Brush");
            b.item("MajorStroke", "Brush");
            b.item("ActualMajorStroke", "Brush");
            b.item("MajorStrokeThickness", "Number:double");
            b.item("MinorStroke", "Brush");
            b.item("ActualMinorStroke", "Brush");
            b.item("MinorStrokeThickness", "Number:double");
            b.item("TickStroke", "Brush");
            b.item("TickStrokeThickness", "Number:double");
            b.item("TickLength", "Number:double");
            b.item("IsDisabled", "Boolean");
            b.item("IsInverted", "Boolean");
            b.item("UseEnhancedIntervalManagement", "Boolean");
            b.item("EnhancedIntervalMinimumCharacters", "Number:int");
            b.item("LabelTextColor", "(w:LabelSettings.TextColor,wf:LabelTextColor)Brush");
            b.item("LabelLocation", "(w:LabelSettings.Location,wf:LabelLocation)ExportedType:string:AxisLabelsLocation");
            b.item("LabelLocation@names", "OutsideTop;OutsideBottom;OutsideLeft;OutsideRight;InsideTop;InsideBottom;InsideLeft;InsideRight");
            b.item("LabelShowFirstLabel", "(w:LabelSettings.ShowFirstLabel,wf:LabelShowFirstLabel)Boolean");
            b.item("LabelAngle", "(w:LabelSettings.Angle,wf:LabelAngle)Number:double");
            b.item("LabelExtent", "(w:LabelSettings.Extent,wf:LabelExtent)Number:double");
            b.item("LabelLeftMargin", "(w:LabelSettings.LeftMargin,wf:LabelLeftMargin)Number:double");
            b.item("LabelRightMargin", "(w:LabelSettings.RightMargin,wf:LabelRightMargin)Number:double");
            b.item("LabelTopMargin", "(w:LabelSettings.TopMargin,wf:LabelTopMargin)Number:double");
            b.item("LabelBottomMargin", "(w:LabelSettings.BottomMargin,wf:LabelBottomMargin)Number:double");
            b.item("LabelHorizontalAlignment", "(w:LabelSettings.HorizontalAlignment,wf:LabelHorizontalAlignment)ExportedType:string:HorizontalAlignment");
            b.item("LabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("LabelVerticalAlignment", "(w:LabelSettings.VerticalAlignment,wf:LabelVerticalAlignment)ExportedType:string:VerticalAlignment");
            b.item("LabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("CrossingAxisRef", "(w:CrossingAxis,wf:CrossingAxis)DataRef::object");
            b.item("CrossingAxisRef@nameBinding", "true");
            b.item("CrossingValue", "Unknown");
            b.item("TitlePosition", "(w:TitleSettings.Position,wf:TitlePosition)ExportedType:string:AxisTitlePosition");
            b.item("TitlePosition@names", "Auto;Left;Right;Top;Bottom");
            b.item("TitleTextColor", "(w:TitleSettings.TextColor,wf:TitleTextColor)Brush");
            b.item("TitleLocation", "(w:TitleSettings.Location,wf:TitleLocation)ExportedType:string:AxisLabelsLocation");
            b.item("TitleLocation@names", "OutsideTop;OutsideBottom;OutsideLeft;OutsideRight;InsideTop;InsideBottom;InsideLeft;InsideRight");
            b.item("TitleShowFirstLabel", "(w:TitleSettings.ShowFirstLabel,wf:TitleShowFirstLabel)Boolean");
            b.item("TitleAngle", "(w:TitleSettings.Angle,wf:TitleAngle)Number:double");
            b.item("TitleExtent", "(w:TitleSettings.Extent,wf:TitleExtent)Number:double");
            b.item("TitleLeftMargin", "(w:TitleSettings.LeftMargin,wf:TitleLeftMargin)Number:double");
            b.item("TitleRightMargin", "(w:TitleSettings.RightMargin,wf:TitleRightMargin)Number:double");
            b.item("TitleTopMargin", "(w:TitleSettings.TopMargin,wf:TitleTopMargin)Number:double");
            b.item("TitleBottomMargin", "(w:TitleSettings.BottomMargin,wf:TitleBottomMargin)Number:double");
            b.item("TitleHorizontalAlignment", "(w:TitleSettings.HorizontalAlignment,wf:TitleHorizontalAlignment)ExportedType:string:HorizontalAlignment");
            b.item("TitleHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("TitleVerticalAlignment", "(w:TitleSettings.VerticalAlignment,wf:TitleVerticalAlignment)ExportedType:string:VerticalAlignment");
            b.item("TitleVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("Annotations", "Collection:AxisAnnotation:AxisAnnotationCollection:IAxisAnnotation");
            b.item("CoercionMethodsRef", "(w:CoercionMethods,wf:CoercionMethods)DataRef");
            b.item("ExpectFunctions", "Boolean");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("RangeChangedRef", "EventRef::rangeChanged");
            b.item("RenderRequestedRef", "EventRef::renderRequested");
            AxisDescriptionMetadata.e(a, b);
        }
        static d(a) {
            AxisDescriptionMetadata.b(a);
            a.p("Axis", AxisDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("Label", "(w:Label/AxisLabelTransform)String");
            b.item("LabelTextColor", "(w:LabelSettings.Foreground,wf:LabelTextColor,web:LabelTextColor)Brush");
            b.item("TitleTextColor", "(w:TitleSettings.Foreground,wf:TitleTextColor,web:TitleTextColor)Brush");
            b.item("LabelFontFamily", "(w:LabelSettings.FontFamily/FontFamilyTransform,wf:LabelFontFamily,web:LabelTextStyle/FontFamilyTransform)String");
            b.item("LabelFontSize", "(w:LabelSettings.FontSize,wf:LabelFontSize,web:LabelTextStyle/FontSizeTransform)Number:double");
            b.item("LabelFontStyle", "(w:LabelSettings.FontStyle/FontStyleTransform,wf:LabelTextStyle/FontStyleTransform,web:LabelTextStyle/FontStyleTransform)String");
            b.item("LabelFontWeight", "(w:LabelSettings.FontWeight/FontWeightTransform,wf:LabelTextStyle/FontWeightTransform,web:LabelTextStyle/FontWeightTransform)String");
            b.item("TitleFontFamily", "(w:TitleSettings.FontFamily/FontFamilyTransform,wf:TitleFontFamily,web:TitleTextStyle/FontFamilyTransform)String");
            b.item("TitleFontSize", "(w:TitleSettings.FontSize,wf:TitleFontSize,web:TitleTextStyle/FontSizeTransform)Number:double");
            b.item("TitleFontStyle", "(w:TitleSettings.FontStyle/FontStyleTransform,wf:TitleTextStyle/FontStyleTransform,web:TitleTextStyle/FontStyleTransform)String");
            b.item("TitleFontWeight", "(w:TitleSettings.FontWeight/FontWeightTransform,wf:TitleTextStyle/FontWeightTransform,web:TitleTextStyle/FontWeightTransform)String");
            b.item("LabelVisibility", "(w:LabelSettings.Visibility,wf:LabelsVisible/VisibilityToBooleanTransform)ExportedType:string:Visibility");
            b.item("LabelSettings", "ExportedType:AxisLabelSettings");
        }
    }
    AxisDescriptionMetadata.$t = /*@__PURE__*/ markType(AxisDescriptionMetadata, 'AxisDescriptionMetadata');
    AxisDescriptionMetadata.a = null;
    return AxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryAxisBaseDescriptionMetadata.a == null) {
                CategoryAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryAxisBaseDescriptionMetadata.c(a, CategoryAxisBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AxisDescriptionMetadata.c(a, b);
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("ItemsCount", "Number:int");
            b.item("Gap", "Number:double");
            b.item("Overlap", "Number:double");
            b.item("UseClusteringMode", "Boolean");
            b.item("ItemsCountChangeRef", "EventRef::itemsCountChange");
            CategoryAxisBaseDescriptionMetadata.e(a, b);
        }
        static d(a) {
            CategoryAxisBaseDescriptionMetadata.b(a);
            a.p("CategoryAxisBase", CategoryAxisBaseDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
        }
    }
    CategoryAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryAxisBaseDescriptionMetadata, 'CategoryAxisBaseDescriptionMetadata');
    CategoryAxisBaseDescriptionMetadata.a = null;
    return CategoryAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisDescription = /*@__PURE__*/ (() => {
    class AxisDescription extends Description {
        constructor() {
            super();
            this.bg = null;
            this.by = null;
            this.bw = null;
            this.bd = null;
            this.ae = 0;
            this.bv = null;
            this.br = null;
            this.bb = null;
            this.ac = 0;
            this.bs = null;
            this.bc = null;
            this.ad = 0;
            this.bx = null;
            this.ag = 0;
            this.af = 0;
            this.k = false;
            this.l = false;
            this.o = false;
            this.a7 = 0;
            this.bo = null;
            this.bn = null;
            this.m = false;
            this.v = 0;
            this.x = 0;
            this.z = 0;
            this.aa = 0;
            this.ab = 0;
            this.w = 0;
            this.bm = null;
            this.bp = null;
            this.bf = null;
            this.a9 = null;
            this.b4 = null;
            this.b5 = null;
            this.b3 = null;
            this.n = false;
            this.ah = 0;
            this.aj = 0;
            this.al = 0;
            this.am = 0;
            this.an = 0;
            this.ai = 0;
            this.b2 = null;
            this.b6 = null;
            this.f = null;
            this.be = null;
            this.j = false;
            this.bl = null;
            this.g = null;
            this.bt = null;
            this.bu = null;
            this.bh = null;
            this.bi = null;
            this.y = 0;
            this.bk = null;
            this.bj = null;
            this.bz = null;
            this.ak = 0;
            this.b1 = null;
            this.b0 = null;
            this.bq = null;
        }
        get_type() {
            return "Axis";
        }
        get type() {
            return this.get_type();
        }
        get formatLabelRef() {
            return this.bg;
        }
        set formatLabelRef(a) {
            this.bg = a;
            this.e("FormatLabelRef");
        }
        get title() {
            return this.by;
        }
        set title(a) {
            this.by = a;
            this.e("Title");
        }
        get stroke() {
            return this.bw;
        }
        set stroke(a) {
            this.bw = a;
            this.e("Stroke");
        }
        get actualStroke() {
            return this.bd;
        }
        set actualStroke(a) {
            this.bd = a;
            this.e("ActualStroke");
        }
        get strokeThickness() {
            return this.ae;
        }
        set strokeThickness(a) {
            this.ae = a;
            this.e("StrokeThickness");
        }
        get strip() {
            return this.bv;
        }
        set strip(a) {
            this.bv = a;
            this.e("Strip");
        }
        get majorStroke() {
            return this.br;
        }
        set majorStroke(a) {
            this.br = a;
            this.e("MajorStroke");
        }
        get actualMajorStroke() {
            return this.bb;
        }
        set actualMajorStroke(a) {
            this.bb = a;
            this.e("ActualMajorStroke");
        }
        get majorStrokeThickness() {
            return this.ac;
        }
        set majorStrokeThickness(a) {
            this.ac = a;
            this.e("MajorStrokeThickness");
        }
        get minorStroke() {
            return this.bs;
        }
        set minorStroke(a) {
            this.bs = a;
            this.e("MinorStroke");
        }
        get actualMinorStroke() {
            return this.bc;
        }
        set actualMinorStroke(a) {
            this.bc = a;
            this.e("ActualMinorStroke");
        }
        get minorStrokeThickness() {
            return this.ad;
        }
        set minorStrokeThickness(a) {
            this.ad = a;
            this.e("MinorStrokeThickness");
        }
        get tickStroke() {
            return this.bx;
        }
        set tickStroke(a) {
            this.bx = a;
            this.e("TickStroke");
        }
        get tickStrokeThickness() {
            return this.ag;
        }
        set tickStrokeThickness(a) {
            this.ag = a;
            this.e("TickStrokeThickness");
        }
        get tickLength() {
            return this.af;
        }
        set tickLength(a) {
            this.af = a;
            this.e("TickLength");
        }
        get isDisabled() {
            return this.k;
        }
        set isDisabled(a) {
            this.k = a;
            this.e("IsDisabled");
        }
        get isInverted() {
            return this.l;
        }
        set isInverted(a) {
            this.l = a;
            this.e("IsInverted");
        }
        get useEnhancedIntervalManagement() {
            return this.o;
        }
        set useEnhancedIntervalManagement(a) {
            this.o = a;
            this.e("UseEnhancedIntervalManagement");
        }
        get enhancedIntervalMinimumCharacters() {
            return this.a7;
        }
        set enhancedIntervalMinimumCharacters(a) {
            this.a7 = a;
            this.e("EnhancedIntervalMinimumCharacters");
        }
        get labelTextColor() {
            return this.bo;
        }
        set labelTextColor(a) {
            this.bo = a;
            this.e("LabelTextColor");
        }
        get labelLocation() {
            return this.bn;
        }
        set labelLocation(a) {
            this.bn = a;
            this.e("LabelLocation");
        }
        get labelShowFirstLabel() {
            return this.m;
        }
        set labelShowFirstLabel(a) {
            this.m = a;
            this.e("LabelShowFirstLabel");
        }
        get labelAngle() {
            return this.v;
        }
        set labelAngle(a) {
            this.v = a;
            this.e("LabelAngle");
        }
        get labelExtent() {
            return this.x;
        }
        set labelExtent(a) {
            this.x = a;
            this.e("LabelExtent");
        }
        get labelLeftMargin() {
            return this.z;
        }
        set labelLeftMargin(a) {
            this.z = a;
            this.e("LabelLeftMargin");
        }
        get labelRightMargin() {
            return this.aa;
        }
        set labelRightMargin(a) {
            this.aa = a;
            this.e("LabelRightMargin");
        }
        get labelTopMargin() {
            return this.ab;
        }
        set labelTopMargin(a) {
            this.ab = a;
            this.e("LabelTopMargin");
        }
        get labelBottomMargin() {
            return this.w;
        }
        set labelBottomMargin(a) {
            this.w = a;
            this.e("LabelBottomMargin");
        }
        get labelHorizontalAlignment() {
            return this.bm;
        }
        set labelHorizontalAlignment(a) {
            this.bm = a;
            this.e("LabelHorizontalAlignment");
        }
        get labelVerticalAlignment() {
            return this.bp;
        }
        set labelVerticalAlignment(a) {
            this.bp = a;
            this.e("LabelVerticalAlignment");
        }
        get crossingAxisRef() {
            return this.bf;
        }
        set crossingAxisRef(a) {
            this.bf = a;
            this.e("CrossingAxisRef");
        }
        get crossingValue() {
            return this.a9;
        }
        set crossingValue(a) {
            this.a9 = a;
            this.e("CrossingValue");
        }
        get titlePosition() {
            return this.b4;
        }
        set titlePosition(a) {
            this.b4 = a;
            this.e("TitlePosition");
        }
        get titleTextColor() {
            return this.b5;
        }
        set titleTextColor(a) {
            this.b5 = a;
            this.e("TitleTextColor");
        }
        get titleLocation() {
            return this.b3;
        }
        set titleLocation(a) {
            this.b3 = a;
            this.e("TitleLocation");
        }
        get titleShowFirstLabel() {
            return this.n;
        }
        set titleShowFirstLabel(a) {
            this.n = a;
            this.e("TitleShowFirstLabel");
        }
        get titleAngle() {
            return this.ah;
        }
        set titleAngle(a) {
            this.ah = a;
            this.e("TitleAngle");
        }
        get titleExtent() {
            return this.aj;
        }
        set titleExtent(a) {
            this.aj = a;
            this.e("TitleExtent");
        }
        get titleLeftMargin() {
            return this.al;
        }
        set titleLeftMargin(a) {
            this.al = a;
            this.e("TitleLeftMargin");
        }
        get titleRightMargin() {
            return this.am;
        }
        set titleRightMargin(a) {
            this.am = a;
            this.e("TitleRightMargin");
        }
        get titleTopMargin() {
            return this.an;
        }
        set titleTopMargin(a) {
            this.an = a;
            this.e("TitleTopMargin");
        }
        get titleBottomMargin() {
            return this.ai;
        }
        set titleBottomMargin(a) {
            this.ai = a;
            this.e("TitleBottomMargin");
        }
        get titleHorizontalAlignment() {
            return this.b2;
        }
        set titleHorizontalAlignment(a) {
            this.b2 = a;
            this.e("TitleHorizontalAlignment");
        }
        get titleVerticalAlignment() {
            return this.b6;
        }
        set titleVerticalAlignment(a) {
            this.b6 = a;
            this.e("TitleVerticalAlignment");
        }
        get annotations() {
            return this.f;
        }
        set annotations(a) {
            this.f = a;
            this.e("Annotations");
        }
        get coercionMethodsRef() {
            return this.be;
        }
        set coercionMethodsRef(a) {
            this.be = a;
            this.e("CoercionMethodsRef");
        }
        get expectFunctions() {
            return this.j;
        }
        set expectFunctions(a) {
            this.j = a;
            this.e("ExpectFunctions");
        }
        get labelFormat() {
            return this.bl;
        }
        set labelFormat(a) {
            this.bl = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.g;
        }
        set labelFormatSpecifiers(a) {
            this.g = a;
            this.e("LabelFormatSpecifiers");
        }
        get rangeChangedRef() {
            return this.bt;
        }
        set rangeChangedRef(a) {
            this.bt = a;
            this.e("RangeChangedRef");
        }
        get renderRequestedRef() {
            return this.bu;
        }
        set renderRequestedRef(a) {
            this.bu = a;
            this.e("RenderRequestedRef");
        }
        get label() {
            return this.bh;
        }
        set label(a) {
            this.bh = a;
            this.e("Label");
        }
        get labelFontFamily() {
            return this.bi;
        }
        set labelFontFamily(a) {
            this.bi = a;
            this.e("LabelFontFamily");
        }
        get labelFontSize() {
            return this.y;
        }
        set labelFontSize(a) {
            this.y = a;
            this.e("LabelFontSize");
        }
        get labelFontWeight() {
            return this.bk;
        }
        set labelFontWeight(a) {
            this.bk = a;
            this.e("LabelFontWeight");
        }
        get labelFontStyle() {
            return this.bj;
        }
        set labelFontStyle(a) {
            this.bj = a;
            this.e("LabelFontStyle");
        }
        get titleFontFamily() {
            return this.bz;
        }
        set titleFontFamily(a) {
            this.bz = a;
            this.e("TitleFontFamily");
        }
        get titleFontSize() {
            return this.ak;
        }
        set titleFontSize(a) {
            this.ak = a;
            this.e("TitleFontSize");
        }
        get titleFontWeight() {
            return this.b1;
        }
        set titleFontWeight(a) {
            this.b1 = a;
            this.e("TitleFontWeight");
        }
        get titleFontStyle() {
            return this.b0;
        }
        set titleFontStyle(a) {
            this.b0 = a;
            this.e("TitleFontStyle");
        }
        get labelVisibility() {
            return this.bq;
        }
        set labelVisibility(a) {
            this.bq = a;
            this.e("LabelVisibility");
        }
    }
    AxisDescription.$t = /*@__PURE__*/ markType(AxisDescription, 'AxisDescription', Description.$);
    return AxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAxisBaseDescription = /*@__PURE__*/ (() => {
    class CategoryAxisBaseDescription extends AxisDescription {
        constructor() {
            super();
            this.dc = null;
            this.da = 0;
            this.c6 = 0;
            this.c7 = 0;
            this.c4 = false;
            this.dd = null;
        }
        get_type() {
            return "CategoryAxisBase";
        }
        get dataSourceRef() {
            return this.dc;
        }
        set dataSourceRef(a) {
            this.dc = a;
            this.e("DataSourceRef");
        }
        get itemsCount() {
            return this.da;
        }
        set itemsCount(a) {
            this.da = a;
            this.e("ItemsCount");
        }
        get gap() {
            return this.c6;
        }
        set gap(a) {
            this.c6 = a;
            this.e("Gap");
        }
        get overlap() {
            return this.c7;
        }
        set overlap(a) {
            this.c7 = a;
            this.e("Overlap");
        }
        get useClusteringMode() {
            return this.c4;
        }
        set useClusteringMode(a) {
            this.c4 = a;
            this.e("UseClusteringMode");
        }
        get itemsCountChangeRef() {
            return this.dd;
        }
        set itemsCountChangeRef(a) {
            this.dd = a;
            this.e("ItemsCountChangeRef");
        }
    }
    CategoryAxisBaseDescription.$t = /*@__PURE__*/ markType(CategoryAxisBaseDescription, 'CategoryAxisBaseDescription', AxisDescription.$);
    return CategoryAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryXAxisDescription = /*@__PURE__*/ (() => {
    class CategoryXAxisDescription extends CategoryAxisBaseDescription {
        constructor() {
            super();
            this.di = 0;
            this.dg = 0;
            this.dj = 0;
            this.dh = 0;
            this.dp = null;
            this.dq = null;
        }
        get_type() {
            return "CategoryXAxis";
        }
        get interval() {
            return this.di;
        }
        set interval(a) {
            this.di = a;
            this.e("Interval");
        }
        get actualInterval() {
            return this.dg;
        }
        set actualInterval(a) {
            this.dg = a;
            this.e("ActualInterval");
        }
        get minorInterval() {
            return this.dj;
        }
        set minorInterval(a) {
            this.dj = a;
            this.e("MinorInterval");
        }
        get actualMinorInterval() {
            return this.dh;
        }
        set actualMinorInterval(a) {
            this.dh = a;
            this.e("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.dp;
        }
        set actualIntervalChangeRef(a) {
            this.dp = a;
            this.e("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.dq;
        }
        set actualMinorIntervalChangeRef(a) {
            this.dq = a;
            this.e("ActualMinorIntervalChangeRef");
        }
    }
    CategoryXAxisDescription.$t = /*@__PURE__*/ markType(CategoryXAxisDescription, 'CategoryXAxisDescription', CategoryAxisBaseDescription.$);
    return CategoryXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryXAxisDescriptionMetadata.a == null) {
                CategoryXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryXAxisDescriptionMetadata.c(a, CategoryXAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategoryAxisBaseDescriptionMetadata.c(a, b);
            b.item("Interval", "Number:double");
            b.item("ActualInterval", "Number:double");
            b.item("MinorInterval", "Number:double");
            b.item("ActualMinorInterval", "Number:double");
            b.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            b.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            CategoryXAxisDescriptionMetadata.b(a);
            a.q("CategoryXAxis", () => new CategoryXAxisDescription());
            a.p("CategoryXAxis", CategoryXAxisDescriptionMetadata.a);
        }
    }
    CategoryXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryXAxisDescriptionMetadata, 'CategoryXAxisDescriptionMetadata');
    CategoryXAxisDescriptionMetadata.a = null;
    return CategoryXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryXAxisDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionMetadata.d(a);
        }
    }
    CategoryXAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryXAxisDescriptionModule, 'CategoryXAxisDescriptionModule');
    return CategoryXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (NumericAxisBaseDescriptionMetadata.a == null) {
                NumericAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericAxisBaseDescriptionMetadata.c(a, NumericAxisBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AxisDescriptionMetadata.c(a, b);
            b.item("MinimumValue", "Number:double");
            b.item("ActualMinimumValue", "Number:double");
            b.item("ActualVisibleMinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("ActualMaximumValue", "Number:double");
            b.item("ActualVisibleMaximumValue", "Number:double");
            b.item("Interval", "Number:double");
            b.item("ActualInterval", "Number:double");
            b.item("MinorInterval", "Number:double");
            b.item("ActualMinorInterval", "Number:double");
            b.item("ReferenceValue", "Number:double");
            b.item("IsLogarithmic", "Boolean");
            b.item("ActualIsLogarithmic", "Boolean");
            b.item("LogarithmBase", "Number:int");
            b.item("AbbreviateLargeNumbers", "Boolean");
            b.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            b.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            b.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            b.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            NumericAxisBaseDescriptionMetadata.b(a);
            a.p("NumericAxisBase", NumericAxisBaseDescriptionMetadata.a);
        }
    }
    NumericAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericAxisBaseDescriptionMetadata, 'NumericAxisBaseDescriptionMetadata');
    NumericAxisBaseDescriptionMetadata.a = null;
    return NumericAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StraightNumericAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class StraightNumericAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (StraightNumericAxisBaseDescriptionMetadata.a == null) {
                StraightNumericAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StraightNumericAxisBaseDescriptionMetadata.c(a, StraightNumericAxisBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            NumericAxisBaseDescriptionMetadata.c(a, b);
            b.item("ScaleMode", "ExportedType:string:NumericScaleMode");
            b.item("ScaleMode@names", "Linear;Logarithmic");
        }
        static d(a) {
            StraightNumericAxisBaseDescriptionMetadata.b(a);
            a.p("StraightNumericAxisBase", StraightNumericAxisBaseDescriptionMetadata.a);
        }
    }
    StraightNumericAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(StraightNumericAxisBaseDescriptionMetadata, 'StraightNumericAxisBaseDescriptionMetadata');
    StraightNumericAxisBaseDescriptionMetadata.a = null;
    return StraightNumericAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAxisBaseDescription = /*@__PURE__*/ (() => {
    class NumericAxisBaseDescription extends AxisDescription {
        constructor() {
            super();
            this.di = 0;
            this.dc = 0;
            this.df = 0;
            this.dh = 0;
            this.db = 0;
            this.de = 0;
            this.dg = 0;
            this.da = 0;
            this.dj = 0;
            this.dd = 0;
            this.dk = 0;
            this.c6 = false;
            this.c5 = false;
            this.dx = 0;
            this.c4 = false;
            this.d1 = null;
            this.d0 = null;
            this.dz = null;
            this.d2 = null;
        }
        get_type() {
            return "NumericAxisBase";
        }
        get minimumValue() {
            return this.di;
        }
        set minimumValue(a) {
            this.di = a;
            this.e("MinimumValue");
        }
        get actualMinimumValue() {
            return this.dc;
        }
        set actualMinimumValue(a) {
            this.dc = a;
            this.e("ActualMinimumValue");
        }
        get actualVisibleMinimumValue() {
            return this.df;
        }
        set actualVisibleMinimumValue(a) {
            this.df = a;
            this.e("ActualVisibleMinimumValue");
        }
        get maximumValue() {
            return this.dh;
        }
        set maximumValue(a) {
            this.dh = a;
            this.e("MaximumValue");
        }
        get actualMaximumValue() {
            return this.db;
        }
        set actualMaximumValue(a) {
            this.db = a;
            this.e("ActualMaximumValue");
        }
        get actualVisibleMaximumValue() {
            return this.de;
        }
        set actualVisibleMaximumValue(a) {
            this.de = a;
            this.e("ActualVisibleMaximumValue");
        }
        get interval() {
            return this.dg;
        }
        set interval(a) {
            this.dg = a;
            this.e("Interval");
        }
        get actualInterval() {
            return this.da;
        }
        set actualInterval(a) {
            this.da = a;
            this.e("ActualInterval");
        }
        get minorInterval() {
            return this.dj;
        }
        set minorInterval(a) {
            this.dj = a;
            this.e("MinorInterval");
        }
        get actualMinorInterval() {
            return this.dd;
        }
        set actualMinorInterval(a) {
            this.dd = a;
            this.e("ActualMinorInterval");
        }
        get referenceValue() {
            return this.dk;
        }
        set referenceValue(a) {
            this.dk = a;
            this.e("ReferenceValue");
        }
        get isLogarithmic() {
            return this.c6;
        }
        set isLogarithmic(a) {
            this.c6 = a;
            this.e("IsLogarithmic");
        }
        get actualIsLogarithmic() {
            return this.c5;
        }
        set actualIsLogarithmic(a) {
            this.c5 = a;
            this.e("ActualIsLogarithmic");
        }
        get logarithmBase() {
            return this.dx;
        }
        set logarithmBase(a) {
            this.dx = a;
            this.e("LogarithmBase");
        }
        get abbreviateLargeNumbers() {
            return this.c4;
        }
        set abbreviateLargeNumbers(a) {
            this.c4 = a;
            this.e("AbbreviateLargeNumbers");
        }
        get actualMinimumValueChangeRef() {
            return this.d1;
        }
        set actualMinimumValueChangeRef(a) {
            this.d1 = a;
            this.e("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.d0;
        }
        set actualMaximumValueChangeRef(a) {
            this.d0 = a;
            this.e("ActualMaximumValueChangeRef");
        }
        get actualIntervalChangeRef() {
            return this.dz;
        }
        set actualIntervalChangeRef(a) {
            this.dz = a;
            this.e("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.d2;
        }
        set actualMinorIntervalChangeRef(a) {
            this.d2 = a;
            this.e("ActualMinorIntervalChangeRef");
        }
    }
    NumericAxisBaseDescription.$t = /*@__PURE__*/ markType(NumericAxisBaseDescription, 'NumericAxisBaseDescription', AxisDescription.$);
    return NumericAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StraightNumericAxisBaseDescription = /*@__PURE__*/ (() => {
    class StraightNumericAxisBaseDescription extends NumericAxisBaseDescription {
        constructor() {
            super();
            this.d7 = null;
        }
        get_type() {
            return "StraightNumericAxisBase";
        }
        get scaleMode() {
            return this.d7;
        }
        set scaleMode(a) {
            this.d7 = a;
            this.e("ScaleMode");
        }
    }
    StraightNumericAxisBaseDescription.$t = /*@__PURE__*/ markType(StraightNumericAxisBaseDescription, 'StraightNumericAxisBaseDescription', NumericAxisBaseDescription.$);
    return StraightNumericAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericYAxisDescription = /*@__PURE__*/ (() => {
    class NumericYAxisDescription extends StraightNumericAxisBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "NumericYAxis";
        }
    }
    NumericYAxisDescription.$t = /*@__PURE__*/ markType(NumericYAxisDescription, 'NumericYAxisDescription', StraightNumericAxisBaseDescription.$);
    return NumericYAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericYAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericYAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericYAxisDescriptionMetadata.a == null) {
                NumericYAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericYAxisDescriptionMetadata.c(a, NumericYAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StraightNumericAxisBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            NumericYAxisDescriptionMetadata.b(a);
            a.q("NumericYAxis", () => new NumericYAxisDescription());
            a.p("NumericYAxis", NumericYAxisDescriptionMetadata.a);
        }
    }
    NumericYAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericYAxisDescriptionMetadata, 'NumericYAxisDescriptionMetadata');
    NumericYAxisDescriptionMetadata.a = null;
    return NumericYAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericYAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericYAxisDescriptionModule extends Base {
        static register(a) {
            NumericYAxisDescriptionMetadata.d(a);
        }
    }
    NumericYAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericYAxisDescriptionModule, 'NumericYAxisDescriptionModule');
    return NumericYAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryChartCoreDescriptionModule extends Base {
        static register(a) {
            CategoryChartDescriptionMetadata.d(a);
            CategoryXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
        }
    }
    CategoryChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(CategoryChartCoreDescriptionModule, 'CategoryChartCoreDescriptionModule');
    return CategoryChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsDescription extends AssigningSeriesShapeStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningCategoryStyleEventArgs";
        }
    }
    AssigningCategoryStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsDescription, 'AssigningCategoryStyleEventArgsDescription', AssigningSeriesShapeStyleEventArgsBaseDescription.$);
    return AssigningCategoryStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningCategoryStyleEventArgsDescriptionMetadata.a == null) {
                AssigningCategoryStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningCategoryStyleEventArgsDescriptionMetadata.c(a, AssigningCategoryStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningCategoryStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningCategoryStyleEventArgs", () => new AssigningCategoryStyleEventArgsDescription());
            a.p("AssigningCategoryStyleEventArgs", AssigningCategoryStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningCategoryStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsDescriptionMetadata, 'AssigningCategoryStyleEventArgsDescriptionMetadata');
    AssigningCategoryStyleEventArgsDescriptionMetadata.a = null;
    return AssigningCategoryStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a == null) {
                AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningCategoryStyleEventArgsBaseDescriptionMetadata.c(a, AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningSeriesStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningCategoryStyleEventArgsBaseDescriptionMetadata.b(a);
            a.p("AssigningCategoryStyleEventArgsBase", AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a);
        }
    }
    AssigningCategoryStyleEventArgsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsBaseDescriptionMetadata, 'AssigningCategoryStyleEventArgsBaseDescriptionMetadata');
    AssigningCategoryStyleEventArgsBaseDescriptionMetadata.a = null;
    return AssigningCategoryStyleEventArgsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryStyleEventArgsBaseDescription = /*@__PURE__*/ (() => {
    class AssigningCategoryStyleEventArgsBaseDescription extends AssigningSeriesStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningCategoryStyleEventArgsBase";
        }
    }
    AssigningCategoryStyleEventArgsBaseDescription.$t = /*@__PURE__*/ markType(AssigningCategoryStyleEventArgsBaseDescription, 'AssigningCategoryStyleEventArgsBaseDescription', AssigningSeriesStyleEventArgsBaseDescription.$);
    return AssigningCategoryStyleEventArgsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryMarkerStyleEventArgsDescription = /*@__PURE__*/ (() => {
    class AssigningCategoryMarkerStyleEventArgsDescription extends AssigningCategoryStyleEventArgsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AssigningCategoryMarkerStyleEventArgs";
        }
    }
    AssigningCategoryMarkerStyleEventArgsDescription.$t = /*@__PURE__*/ markType(AssigningCategoryMarkerStyleEventArgsDescription, 'AssigningCategoryMarkerStyleEventArgsDescription', AssigningCategoryStyleEventArgsBaseDescription.$);
    return AssigningCategoryMarkerStyleEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AssigningCategoryMarkerStyleEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AssigningCategoryMarkerStyleEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a == null) {
                AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.c(a, AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AssigningCategoryStyleEventArgsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.b(a);
            a.q("AssigningCategoryMarkerStyleEventArgs", () => new AssigningCategoryMarkerStyleEventArgsDescription());
            a.p("AssigningCategoryMarkerStyleEventArgs", AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a);
        }
    }
    AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AssigningCategoryMarkerStyleEventArgsDescriptionMetadata, 'AssigningCategoryMarkerStyleEventArgsDescriptionMetadata');
    AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.a = null;
    return AssigningCategoryMarkerStyleEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarkerSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class MarkerSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (MarkerSeriesDescriptionMetadata.a == null) {
                MarkerSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MarkerSeriesDescriptionMetadata.c(a, MarkerSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            b.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            b.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            b.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("MarkerThickness", "Number:double");
            b.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            b.item("MarkerBrush", "Brush");
            b.item("ActualMarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("ActualMarkerOutline", "Brush");
        }
        static d(a) {
            MarkerSeriesDescriptionMetadata.b(a);
            a.p("MarkerSeries", MarkerSeriesDescriptionMetadata.a);
        }
    }
    MarkerSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(MarkerSeriesDescriptionMetadata, 'MarkerSeriesDescriptionMetadata');
    MarkerSeriesDescriptionMetadata.a = null;
    return MarkerSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (CategorySeriesDescriptionMetadata.a == null) {
                CategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategorySeriesDescriptionMetadata.c(a, CategorySeriesDescriptionMetadata.a);
                AssigningCategoryStyleEventArgsDescriptionMetadata.d(a);
                AssigningCategoryMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            MarkerSeriesDescriptionMetadata.c(a, b);
            b.item("IsCustomCategoryStyleAllowed", "Boolean");
            b.item("IsCustomCategoryMarkerStyleAllowed", "Boolean");
            b.item("UseHighMarkerFidelity", "Boolean");
            b.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            b.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum");
            b.item("IsTransitionInEnabled", "Boolean");
            b.item("AssigningCategoryStyleRef", "EventRef::assigningCategoryStyle");
            b.item("AssigningCategoryMarkerStyleRef", "EventRef::assigningCategoryMarkerStyle");
        }
        static d(a) {
            CategorySeriesDescriptionMetadata.b(a);
            a.p("CategorySeries", CategorySeriesDescriptionMetadata.a);
        }
    }
    CategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(CategorySeriesDescriptionMetadata, 'CategorySeriesDescriptionMetadata');
    CategorySeriesDescriptionMetadata.a = null;
    return CategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (AnchoredCategorySeriesDescriptionMetadata.a == null) {
                AnchoredCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnchoredCategorySeriesDescriptionMetadata.c(a, AnchoredCategorySeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategorySeriesDescriptionMetadata.c(a, b);
            b.item("ValueMemberPath", "String");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineBrush", "Brush");
            b.item("ActualTrendLineBrush", "Brush");
            b.item("TrendLineThickness", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
            b.item("MarkerCollisionAvoidance", "ExportedType:string:CategorySeriesMarkerCollisionAvoidance");
            b.item("MarkerCollisionAvoidance@names", "None;Omit");
            b.item("ConsolidatedItemHitTestBehavior", "ExportedType:string:ConsolidatedItemHitTestBehavior");
            b.item("ConsolidatedItemHitTestBehavior@names", "Basic;NearestY");
        }
        static d(a) {
            AnchoredCategorySeriesDescriptionMetadata.b(a);
            a.p("AnchoredCategorySeries", AnchoredCategorySeriesDescriptionMetadata.a);
        }
    }
    AnchoredCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesDescriptionMetadata, 'AnchoredCategorySeriesDescriptionMetadata');
    AnchoredCategorySeriesDescriptionMetadata.a = null;
    return AnchoredCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalAnchoredCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HorizontalAnchoredCategorySeriesDescriptionMetadata.a == null) {
                HorizontalAnchoredCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, HorizontalAnchoredCategorySeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.b(a);
            a.p("HorizontalAnchoredCategorySeries", HorizontalAnchoredCategorySeriesDescriptionMetadata.a);
        }
    }
    HorizontalAnchoredCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeriesDescriptionMetadata, 'HorizontalAnchoredCategorySeriesDescriptionMetadata');
    HorizontalAnchoredCategorySeriesDescriptionMetadata.a = null;
    return HorizontalAnchoredCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SeriesDescription = /*@__PURE__*/ (() => {
    class SeriesDescription extends Description {
        constructor() {
            super();
            this.bh = null;
            this.bn = null;
            this.bm = null;
            this.bk = null;
            this.bl = null;
            this.bi = null;
            this.bu = null;
            this.bv = null;
            this.a7 = 0;
            this.af = 0;
            this.an = 0;
            this.ak = 0;
            this.al = 0;
            this.am = 0;
            this.bf = null;
            this.bb = null;
            this.bo = null;
            this.be = null;
            this.aj = 0;
            this.y = 0;
            this.bc = null;
            this.w = 0;
            this.ab = 0;
            this.g = false;
            this.j = false;
            this.i = false;
            this.ag = 0;
            this.br = null;
            this.m = false;
            this.ah = 0;
            this.ai = 0;
            this.z = 0;
            this.v = 0;
            this.ac = 0;
            this.x = 0;
            this.h = false;
            this.l = false;
            this.by = null;
            this.bp = null;
            this.a8 = 0;
            this.bw = null;
            this.k = false;
            this.bg = null;
            this.f = false;
            this.bj = null;
            this.bd = null;
            this.aa = 0;
            this.ae = 0;
            this.ad = 0;
            this.bx = null;
            this.bq = null;
            this.bt = null;
            this.bs = null;
        }
        get_type() {
            return "Series";
        }
        get type() {
            return this.get_type();
        }
        get dataSourceRef() {
            return this.bh;
        }
        set dataSourceRef(a) {
            this.bh = a;
            this.e("DataSourceRef");
        }
        get legendRef() {
            return this.bn;
        }
        set legendRef(a) {
            this.bn = a;
            this.e("LegendRef");
        }
        get legendItemVisibility() {
            return this.bm;
        }
        set legendItemVisibility(a) {
            this.bm = a;
            this.e("LegendItemVisibility");
        }
        get legendItemBadgeTemplateRef() {
            return this.bk;
        }
        set legendItemBadgeTemplateRef(a) {
            this.bk = a;
            this.e("LegendItemBadgeTemplateRef");
        }
        get legendItemTemplateRef() {
            return this.bl;
        }
        set legendItemTemplateRef(a) {
            this.bl = a;
            this.e("LegendItemTemplateRef");
        }
        get discreteLegendItemTemplateRef() {
            return this.bi;
        }
        set discreteLegendItemTemplateRef(a) {
            this.bi = a;
            this.e("DiscreteLegendItemTemplateRef");
        }
        get transitionEasingFunctionRef() {
            return this.bu;
        }
        set transitionEasingFunctionRef(a) {
            this.bu = a;
            this.e("TransitionEasingFunctionRef");
        }
        get transitionInEasingFunctionRef() {
            return this.bv;
        }
        set transitionInEasingFunctionRef(a) {
            this.bv = a;
            this.e("TransitionInEasingFunctionRef");
        }
        get transitionDuration() {
            return this.a7;
        }
        set transitionDuration(a) {
            this.a7 = a;
            this.e("TransitionDuration");
        }
        get resolution() {
            return this.af;
        }
        set resolution(a) {
            this.af = a;
            this.e("Resolution");
        }
        get visibleRangeMarginTop() {
            return this.an;
        }
        set visibleRangeMarginTop(a) {
            this.an = a;
            this.e("VisibleRangeMarginTop");
        }
        get visibleRangeMarginBottom() {
            return this.ak;
        }
        set visibleRangeMarginBottom(a) {
            this.ak = a;
            this.e("VisibleRangeMarginBottom");
        }
        get visibleRangeMarginLeft() {
            return this.al;
        }
        set visibleRangeMarginLeft(a) {
            this.al = a;
            this.e("VisibleRangeMarginLeft");
        }
        get visibleRangeMarginRight() {
            return this.am;
        }
        set visibleRangeMarginRight(a) {
            this.am = a;
            this.e("VisibleRangeMarginRight");
        }
        get brush() {
            return this.bf;
        }
        set brush(a) {
            this.bf = a;
            this.e("Brush");
        }
        get actualBrush() {
            return this.bb;
        }
        set actualBrush(a) {
            this.bb = a;
            this.e("ActualBrush");
        }
        get outline() {
            return this.bo;
        }
        set outline(a) {
            this.bo = a;
            this.e("Outline");
        }
        get actualOutline() {
            return this.be;
        }
        set actualOutline(a) {
            this.be = a;
            this.e("ActualOutline");
        }
        get thickness() {
            return this.aj;
        }
        set thickness(a) {
            this.aj = a;
            this.e("Thickness");
        }
        get actualThickness() {
            return this.y;
        }
        set actualThickness(a) {
            this.y = a;
            this.e("ActualThickness");
        }
        get actualHighlightingMode() {
            return this.bc;
        }
        set actualHighlightingMode(a) {
            this.bc = a;
            this.e("ActualHighlightingMode");
        }
        get actualHighlightingFadeOpacity() {
            return this.w;
        }
        set actualHighlightingFadeOpacity(a) {
            this.w = a;
            this.e("ActualHighlightingFadeOpacity");
        }
        get highlightingFadeOpacity() {
            return this.ab;
        }
        set highlightingFadeOpacity(a) {
            this.ab = a;
            this.e("HighlightingFadeOpacity");
        }
        get isComponentHighlightingModeIgnored() {
            return this.g;
        }
        set isComponentHighlightingModeIgnored(a) {
            this.g = a;
            this.e("IsComponentHighlightingModeIgnored");
        }
        get isHighlightingEnabled() {
            return this.j;
        }
        set isHighlightingEnabled(a) {
            this.j = a;
            this.e("IsHighlightingEnabled");
        }
        get isDropShadowEnabled() {
            return this.i;
        }
        set isDropShadowEnabled(a) {
            this.i = a;
            this.e("IsDropShadowEnabled");
        }
        get shadowBlur() {
            return this.ag;
        }
        set shadowBlur(a) {
            this.ag = a;
            this.e("ShadowBlur");
        }
        get shadowColor() {
            return this.br;
        }
        set shadowColor(a) {
            this.br = a;
            this.e("ShadowColor");
        }
        get useSingleShadow() {
            return this.m;
        }
        set useSingleShadow(a) {
            this.m = a;
            this.e("UseSingleShadow");
        }
        get shadowOffsetX() {
            return this.ah;
        }
        set shadowOffsetX(a) {
            this.ah = a;
            this.e("ShadowOffsetX");
        }
        get shadowOffsetY() {
            return this.ai;
        }
        set shadowOffsetY(a) {
            this.ai = a;
            this.e("ShadowOffsetY");
        }
        get areaFillOpacity() {
            return this.z;
        }
        set areaFillOpacity(a) {
            this.z = a;
            this.e("AreaFillOpacity");
        }
        get actualAreaFillOpacity() {
            return this.v;
        }
        set actualAreaFillOpacity(a) {
            this.v = a;
            this.e("ActualAreaFillOpacity");
        }
        get markerFillOpacity() {
            return this.ac;
        }
        set markerFillOpacity(a) {
            this.ac = a;
            this.e("MarkerFillOpacity");
        }
        get actualMarkerFillOpacity() {
            return this.x;
        }
        set actualMarkerFillOpacity(a) {
            this.x = a;
            this.e("ActualMarkerFillOpacity");
        }
        get isDefaultToolTipSelected() {
            return this.h;
        }
        set isDefaultToolTipSelected(a) {
            this.h = a;
            this.e("IsDefaultToolTipSelected");
        }
        get showDefaultTooltip() {
            return this.l;
        }
        set showDefaultTooltip(a) {
            this.l = a;
            this.e("ShowDefaultTooltip");
        }
        get visibleRangeMode() {
            return this.by;
        }
        set visibleRangeMode(a) {
            this.by = a;
            this.e("VisibleRangeMode");
        }
        get outlineMode() {
            return this.bp;
        }
        set outlineMode(a) {
            this.bp = a;
            this.e("OutlineMode");
        }
        get transitionInDuration() {
            return this.a8;
        }
        set transitionInDuration(a) {
            this.a8 = a;
            this.e("TransitionInDuration");
        }
        get transitionInSpeedType() {
            return this.bw;
        }
        set transitionInSpeedType(a) {
            this.bw = a;
            this.e("TransitionInSpeedType");
        }
        get mouseOverEnabled() {
            return this.k;
        }
        set mouseOverEnabled(a) {
            this.k = a;
            this.e("MouseOverEnabled");
        }
        get coercionMethodsRef() {
            return this.bg;
        }
        set coercionMethodsRef(a) {
            this.bg = a;
            this.e("CoercionMethodsRef");
        }
        get expectFunctions() {
            return this.f;
        }
        set expectFunctions(a) {
            this.f = a;
            this.e("ExpectFunctions");
        }
        get hitTestMode() {
            return this.bj;
        }
        set hitTestMode(a) {
            this.bj = a;
            this.e("HitTestMode");
        }
        get actualHitTestMode() {
            return this.bd;
        }
        set actualHitTestMode(a) {
            this.bd = a;
            this.e("ActualHitTestMode");
        }
        get finalValue() {
            return this.aa;
        }
        set finalValue(a) {
            this.aa = a;
            this.e("FinalValue");
        }
        get percentChange() {
            return this.ae;
        }
        set percentChange(a) {
            this.ae = a;
            this.e("PercentChange");
        }
        get opacity() {
            return this.ad;
        }
        set opacity(a) {
            this.ad = a;
            this.e("Opacity");
        }
        get visibility() {
            return this.bx;
        }
        set visibility(a) {
            this.bx = a;
            this.e("Visibility");
        }
        get renderRequestedRef() {
            return this.bq;
        }
        set renderRequestedRef(a) {
            this.bq = a;
            this.e("RenderRequestedRef");
        }
        get tooltipTemplateRef() {
            return this.bt;
        }
        set tooltipTemplateRef(a) {
            this.bt = a;
            this.e("TooltipTemplateRef");
        }
        get title() {
            return this.bs;
        }
        set title(a) {
            this.bs = a;
            this.e("Title");
        }
    }
    SeriesDescription.$t = /*@__PURE__*/ markType(SeriesDescription, 'SeriesDescription', Description.$);
    return SeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarkerSeriesDescription = /*@__PURE__*/ (() => {
    class MarkerSeriesDescription extends SeriesDescription {
        constructor() {
            super();
            this.cy = null;
            this.cw = null;
            this.cu = null;
            this.cx = null;
            this.co = 0;
            this.cs = null;
            this.ct = null;
            this.cq = null;
            this.cv = null;
            this.cr = null;
        }
        get_type() {
            return "MarkerSeries";
        }
        get markerType() {
            return this.cy;
        }
        set markerType(a) {
            this.cy = a;
            this.e("MarkerType");
        }
        get markerOutlineMode() {
            return this.cw;
        }
        set markerOutlineMode(a) {
            this.cw = a;
            this.e("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.cu;
        }
        set markerFillMode(a) {
            this.cu = a;
            this.e("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.cx;
        }
        set markerTemplateRef(a) {
            this.cx = a;
            this.e("MarkerTemplateRef");
        }
        get markerThickness() {
            return this.co;
        }
        set markerThickness(a) {
            this.co = a;
            this.e("MarkerThickness");
        }
        get actualMarkerTemplateRef() {
            return this.cs;
        }
        set actualMarkerTemplateRef(a) {
            this.cs = a;
            this.e("ActualMarkerTemplateRef");
        }
        get markerBrush() {
            return this.ct;
        }
        set markerBrush(a) {
            this.ct = a;
            this.e("MarkerBrush");
        }
        get actualMarkerBrush() {
            return this.cq;
        }
        set actualMarkerBrush(a) {
            this.cq = a;
            this.e("ActualMarkerBrush");
        }
        get markerOutline() {
            return this.cv;
        }
        set markerOutline(a) {
            this.cv = a;
            this.e("MarkerOutline");
        }
        get actualMarkerOutline() {
            return this.cr;
        }
        set actualMarkerOutline(a) {
            this.cr = a;
            this.e("ActualMarkerOutline");
        }
    }
    MarkerSeriesDescription.$t = /*@__PURE__*/ markType(MarkerSeriesDescription, 'MarkerSeriesDescription', SeriesDescription.$);
    return MarkerSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategorySeriesDescription = /*@__PURE__*/ (() => {
    class CategorySeriesDescription extends MarkerSeriesDescription {
        constructor() {
            super();
            this.c9 = false;
            this.c8 = false;
            this.db = false;
            this.di = null;
            this.da = false;
            this.dh = null;
            this.dg = null;
        }
        get_type() {
            return "CategorySeries";
        }
        get isCustomCategoryStyleAllowed() {
            return this.c9;
        }
        set isCustomCategoryStyleAllowed(a) {
            this.c9 = a;
            this.e("IsCustomCategoryStyleAllowed");
        }
        get isCustomCategoryMarkerStyleAllowed() {
            return this.c8;
        }
        set isCustomCategoryMarkerStyleAllowed(a) {
            this.c8 = a;
            this.e("IsCustomCategoryMarkerStyleAllowed");
        }
        get useHighMarkerFidelity() {
            return this.db;
        }
        set useHighMarkerFidelity(a) {
            this.db = a;
            this.e("UseHighMarkerFidelity");
        }
        get transitionInMode() {
            return this.di;
        }
        set transitionInMode(a) {
            this.di = a;
            this.e("TransitionInMode");
        }
        get isTransitionInEnabled() {
            return this.da;
        }
        set isTransitionInEnabled(a) {
            this.da = a;
            this.e("IsTransitionInEnabled");
        }
        get assigningCategoryStyleRef() {
            return this.dh;
        }
        set assigningCategoryStyleRef(a) {
            this.dh = a;
            this.e("AssigningCategoryStyleRef");
        }
        get assigningCategoryMarkerStyleRef() {
            return this.dg;
        }
        set assigningCategoryMarkerStyleRef(a) {
            this.dg = a;
            this.e("AssigningCategoryMarkerStyleRef");
        }
    }
    CategorySeriesDescription.$t = /*@__PURE__*/ markType(CategorySeriesDescription, 'CategorySeriesDescription', MarkerSeriesDescription.$);
    return CategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredCategorySeriesDescription = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesDescription extends CategorySeriesDescription {
        constructor() {
            super();
            this.dw = null;
            this.dv = null;
            this.du = null;
            this.dr = null;
            this.dm = 0;
            this.dp = 0;
            this.dt = null;
            this.ds = null;
        }
        get_type() {
            return "AnchoredCategorySeries";
        }
        get valueMemberPath() {
            return this.dw;
        }
        set valueMemberPath(a) {
            this.dw = a;
            this.e("ValueMemberPath");
        }
        get trendLineType() {
            return this.dv;
        }
        set trendLineType(a) {
            this.dv = a;
            this.e("TrendLineType");
        }
        get trendLineBrush() {
            return this.du;
        }
        set trendLineBrush(a) {
            this.du = a;
            this.e("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.dr;
        }
        set actualTrendLineBrush(a) {
            this.dr = a;
            this.e("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.dm;
        }
        set trendLineThickness(a) {
            this.dm = a;
            this.e("TrendLineThickness");
        }
        get trendLinePeriod() {
            return this.dp;
        }
        set trendLinePeriod(a) {
            this.dp = a;
            this.e("TrendLinePeriod");
        }
        get markerCollisionAvoidance() {
            return this.dt;
        }
        set markerCollisionAvoidance(a) {
            this.dt = a;
            this.e("MarkerCollisionAvoidance");
        }
        get consolidatedItemHitTestBehavior() {
            return this.ds;
        }
        set consolidatedItemHitTestBehavior(a) {
            this.ds = a;
            this.e("ConsolidatedItemHitTestBehavior");
        }
    }
    AnchoredCategorySeriesDescription.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesDescription, 'AnchoredCategorySeriesDescription', CategorySeriesDescription.$);
    return AnchoredCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalAnchoredCategorySeriesDescription = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeriesDescription extends AnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d3 = null;
            this.d4 = null;
        }
        get_type() {
            return "HorizontalAnchoredCategorySeries";
        }
        get xAxisRef() {
            return this.d3;
        }
        set xAxisRef(a) {
            this.d3 = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.d4;
        }
        set yAxisRef(a) {
            this.d4 = a;
            this.e("YAxisRef");
        }
    }
    HorizontalAnchoredCategorySeriesDescription.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeriesDescription, 'HorizontalAnchoredCategorySeriesDescription', AnchoredCategorySeriesDescription.$);
    return HorizontalAnchoredCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSeriesDescription = /*@__PURE__*/ (() => {
    class LineSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d7 = null;
        }
        get_type() {
            return "LineSeries";
        }
        get unknownValuePlotting() {
            return this.d7;
        }
        set unknownValuePlotting(a) {
            this.d7 = a;
            this.e("UnknownValuePlotting");
        }
    }
    LineSeriesDescription.$t = /*@__PURE__*/ markType(LineSeriesDescription, 'LineSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return LineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class LineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (LineSeriesDescriptionMetadata.a == null) {
                LineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LineSeriesDescriptionMetadata.c(a, LineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            LineSeriesDescriptionMetadata.b(a);
            a.q("LineSeries", () => new LineSeriesDescription());
            a.p("LineSeries", LineSeriesDescriptionMetadata.a);
        }
    }
    LineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(LineSeriesDescriptionMetadata, 'LineSeriesDescriptionMetadata');
    LineSeriesDescriptionMetadata.a = null;
    return LineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class LineSeriesDescriptionModule extends Base {
        static register(a) {
            LineSeriesDescriptionMetadata.d(a);
        }
    }
    LineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(LineSeriesDescriptionModule, 'LineSeriesDescriptionModule');
    return LineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaSeriesDescription = /*@__PURE__*/ (() => {
    class AreaSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d7 = null;
        }
        get_type() {
            return "AreaSeries";
        }
        get unknownValuePlotting() {
            return this.d7;
        }
        set unknownValuePlotting(a) {
            this.d7 = a;
            this.e("UnknownValuePlotting");
        }
    }
    AreaSeriesDescription.$t = /*@__PURE__*/ markType(AreaSeriesDescription, 'AreaSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return AreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class AreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (AreaSeriesDescriptionMetadata.a == null) {
                AreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AreaSeriesDescriptionMetadata.c(a, AreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            AreaSeriesDescriptionMetadata.b(a);
            a.q("AreaSeries", () => new AreaSeriesDescription());
            a.p("AreaSeries", AreaSeriesDescriptionMetadata.a);
        }
    }
    AreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(AreaSeriesDescriptionMetadata, 'AreaSeriesDescriptionMetadata');
    AreaSeriesDescriptionMetadata.a = null;
    return AreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class AreaSeriesDescriptionModule extends Base {
        static register(a) {
            AreaSeriesDescriptionMetadata.d(a);
        }
    }
    AreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(AreaSeriesDescriptionModule, 'AreaSeriesDescriptionModule');
    return AreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSeriesDescription = /*@__PURE__*/ (() => {
    class ColumnSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d7 = 0;
            this.d8 = 0;
            this.eb = null;
        }
        get_type() {
            return "ColumnSeries";
        }
        get radiusX() {
            return this.d7;
        }
        set radiusX(a) {
            this.d7 = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d8;
        }
        set radiusY(a) {
            this.d8 = a;
            this.e("RadiusY");
        }
        get consolidatedColumnVerticalPosition() {
            return this.eb;
        }
        set consolidatedColumnVerticalPosition(a) {
            this.eb = a;
            this.e("ConsolidatedColumnVerticalPosition");
        }
    }
    ColumnSeriesDescription.$t = /*@__PURE__*/ markType(ColumnSeriesDescription, 'ColumnSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return ColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSeriesDescriptionMetadata.a == null) {
                ColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSeriesDescriptionMetadata.c(a, ColumnSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
            b.item("ConsolidatedColumnVerticalPosition", "ExportedType:string:ConsolidatedItemsPosition");
            b.item("ConsolidatedColumnVerticalPosition@names", "Minimum;Maximum;Median;RelativeMinimum;RelativeMaximum");
        }
        static d(a) {
            ColumnSeriesDescriptionMetadata.b(a);
            a.q("ColumnSeries", () => new ColumnSeriesDescription());
            a.p("ColumnSeries", ColumnSeriesDescriptionMetadata.a);
        }
    }
    ColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSeriesDescriptionMetadata, 'ColumnSeriesDescriptionMetadata');
    ColumnSeriesDescriptionMetadata.a = null;
    return ColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnSeriesDescriptionModule extends Base {
        static register(a) {
            ColumnSeriesDescriptionMetadata.d(a);
        }
    }
    ColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ColumnSeriesDescriptionModule, 'ColumnSeriesDescriptionModule');
    return ColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (SplineSeriesBaseDescriptionMetadata.a == null) {
                SplineSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineSeriesBaseDescriptionMetadata.c(a, SplineSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("SplineType", "ExportedType:string:SplineType");
            b.item("SplineType@names", "Natural;Clamped");
        }
        static d(a) {
            SplineSeriesBaseDescriptionMetadata.b(a);
            a.p("SplineSeriesBase", SplineSeriesBaseDescriptionMetadata.a);
        }
    }
    SplineSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineSeriesBaseDescriptionMetadata, 'SplineSeriesBaseDescriptionMetadata');
    SplineSeriesBaseDescriptionMetadata.a = null;
    return SplineSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesBaseDescription = /*@__PURE__*/ (() => {
    class SplineSeriesBaseDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d7 = null;
        }
        get_type() {
            return "SplineSeriesBase";
        }
        get splineType() {
            return this.d7;
        }
        set splineType(a) {
            this.d7 = a;
            this.e("SplineType");
        }
    }
    SplineSeriesBaseDescription.$t = /*@__PURE__*/ markType(SplineSeriesBaseDescription, 'SplineSeriesBaseDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return SplineSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesDescription = /*@__PURE__*/ (() => {
    class SplineSeriesDescription extends SplineSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SplineSeries";
        }
    }
    SplineSeriesDescription.$t = /*@__PURE__*/ markType(SplineSeriesDescription, 'SplineSeriesDescription', SplineSeriesBaseDescription.$);
    return SplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (SplineSeriesDescriptionMetadata.a == null) {
                SplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineSeriesDescriptionMetadata.c(a, SplineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SplineSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SplineSeriesDescriptionMetadata.b(a);
            a.q("SplineSeries", () => new SplineSeriesDescription());
            a.p("SplineSeries", SplineSeriesDescriptionMetadata.a);
        }
    }
    SplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineSeriesDescriptionMetadata, 'SplineSeriesDescriptionMetadata');
    SplineSeriesDescriptionMetadata.a = null;
    return SplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class SplineSeriesDescriptionModule extends Base {
        static register(a) {
            SplineSeriesDescriptionMetadata.d(a);
        }
    }
    SplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(SplineSeriesDescriptionModule, 'SplineSeriesDescriptionModule');
    return SplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class SplineAreaSeriesDescription extends SplineSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SplineAreaSeries";
        }
    }
    SplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(SplineAreaSeriesDescription, 'SplineAreaSeriesDescription', SplineSeriesBaseDescription.$);
    return SplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (SplineAreaSeriesDescriptionMetadata.a == null) {
                SplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineAreaSeriesDescriptionMetadata.c(a, SplineAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SplineSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SplineAreaSeriesDescriptionMetadata.b(a);
            a.q("SplineAreaSeries", () => new SplineAreaSeriesDescription());
            a.p("SplineAreaSeries", SplineAreaSeriesDescriptionMetadata.a);
        }
    }
    SplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineAreaSeriesDescriptionMetadata, 'SplineAreaSeriesDescriptionMetadata');
    SplineAreaSeriesDescriptionMetadata.a = null;
    return SplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class SplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            SplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    SplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(SplineAreaSeriesDescriptionModule, 'SplineAreaSeriesDescriptionModule');
    return SplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepLineSeriesDescription = /*@__PURE__*/ (() => {
    class StepLineSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StepLineSeries";
        }
    }
    StepLineSeriesDescription.$t = /*@__PURE__*/ markType(StepLineSeriesDescription, 'StepLineSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return StepLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StepLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StepLineSeriesDescriptionMetadata.a == null) {
                StepLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StepLineSeriesDescriptionMetadata.c(a, StepLineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StepLineSeriesDescriptionMetadata.b(a);
            a.q("StepLineSeries", () => new StepLineSeriesDescription());
            a.p("StepLineSeries", StepLineSeriesDescriptionMetadata.a);
        }
    }
    StepLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StepLineSeriesDescriptionMetadata, 'StepLineSeriesDescriptionMetadata');
    StepLineSeriesDescriptionMetadata.a = null;
    return StepLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StepLineSeriesDescriptionModule extends Base {
        static register(a) {
            StepLineSeriesDescriptionMetadata.d(a);
        }
    }
    StepLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StepLineSeriesDescriptionModule, 'StepLineSeriesDescriptionModule');
    return StepLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepAreaSeriesDescription = /*@__PURE__*/ (() => {
    class StepAreaSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StepAreaSeries";
        }
    }
    StepAreaSeriesDescription.$t = /*@__PURE__*/ markType(StepAreaSeriesDescription, 'StepAreaSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return StepAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StepAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StepAreaSeriesDescriptionMetadata.a == null) {
                StepAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StepAreaSeriesDescriptionMetadata.c(a, StepAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StepAreaSeriesDescriptionMetadata.b(a);
            a.q("StepAreaSeries", () => new StepAreaSeriesDescription());
            a.p("StepAreaSeries", StepAreaSeriesDescriptionMetadata.a);
        }
    }
    StepAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StepAreaSeriesDescriptionMetadata, 'StepAreaSeriesDescriptionMetadata');
    StepAreaSeriesDescriptionMetadata.a = null;
    return StepAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StepAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StepAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StepAreaSeriesDescriptionMetadata.d(a);
        }
    }
    StepAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StepAreaSeriesDescriptionModule, 'StepAreaSeriesDescriptionModule');
    return StepAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointSeriesDescription = /*@__PURE__*/ (() => {
    class PointSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PointSeries";
        }
    }
    PointSeriesDescription.$t = /*@__PURE__*/ markType(PointSeriesDescription, 'PointSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return PointSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PointSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PointSeriesDescriptionMetadata.a == null) {
                PointSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PointSeriesDescriptionMetadata.c(a, PointSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PointSeriesDescriptionMetadata.b(a);
            a.q("PointSeries", () => new PointSeriesDescription());
            a.p("PointSeries", PointSeriesDescriptionMetadata.a);
        }
    }
    PointSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PointSeriesDescriptionMetadata, 'PointSeriesDescriptionMetadata');
    PointSeriesDescriptionMetadata.a = null;
    return PointSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PointSeriesDescriptionModule extends Base {
        static register(a) {
            PointSeriesDescriptionMetadata.d(a);
        }
    }
    PointSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PointSeriesDescriptionModule, 'PointSeriesDescriptionModule');
    return PointSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WaterfallSeriesDescription = /*@__PURE__*/ (() => {
    class WaterfallSeriesDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.eb = null;
            this.d7 = 0;
            this.d8 = 0;
            this.ec = null;
        }
        get_type() {
            return "WaterfallSeries";
        }
        get negativeBrush() {
            return this.eb;
        }
        set negativeBrush(a) {
            this.eb = a;
            this.e("NegativeBrush");
        }
        get radiusX() {
            return this.d7;
        }
        set radiusX(a) {
            this.d7 = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d8;
        }
        set radiusY(a) {
            this.d8 = a;
            this.e("RadiusY");
        }
        get negativeOutline() {
            return this.ec;
        }
        set negativeOutline(a) {
            this.ec = a;
            this.e("NegativeOutline");
        }
    }
    WaterfallSeriesDescription.$t = /*@__PURE__*/ markType(WaterfallSeriesDescription, 'WaterfallSeriesDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return WaterfallSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WaterfallSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class WaterfallSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (WaterfallSeriesDescriptionMetadata.a == null) {
                WaterfallSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WaterfallSeriesDescriptionMetadata.c(a, WaterfallSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("NegativeBrush", "Brush");
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
            b.item("NegativeOutline", "Brush");
        }
        static d(a) {
            WaterfallSeriesDescriptionMetadata.b(a);
            a.q("WaterfallSeries", () => new WaterfallSeriesDescription());
            a.p("WaterfallSeries", WaterfallSeriesDescriptionMetadata.a);
        }
    }
    WaterfallSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(WaterfallSeriesDescriptionMetadata, 'WaterfallSeriesDescriptionMetadata');
    WaterfallSeriesDescriptionMetadata.a = null;
    return WaterfallSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WaterfallSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class WaterfallSeriesDescriptionModule extends Base {
        static register(a) {
            WaterfallSeriesDescriptionMetadata.d(a);
        }
    }
    WaterfallSeriesDescriptionModule.$t = /*@__PURE__*/ markType(WaterfallSeriesDescriptionModule, 'WaterfallSeriesDescriptionModule');
    return WaterfallSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnnotationLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnnotationLayerDescriptionMetadata extends Base {
        static b(a) {
            if (AnnotationLayerDescriptionMetadata.a == null) {
                AnnotationLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnnotationLayerDescriptionMetadata.c(a, AnnotationLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("UseIndex", "Boolean");
            b.item("UseLegend", "Boolean");
            b.item("CursorPosition", "Point");
            b.item("IsDefaultCrosshairDisabled", "Boolean");
            b.item("ShouldRenderAsOverlay", "Boolean");
        }
        static d(a) {
            AnnotationLayerDescriptionMetadata.b(a);
            a.p("AnnotationLayer", AnnotationLayerDescriptionMetadata.a);
        }
    }
    AnnotationLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(AnnotationLayerDescriptionMetadata, 'AnnotationLayerDescriptionMetadata');
    AnnotationLayerDescriptionMetadata.a = null;
    return AnnotationLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnnotationLayerDescription = /*@__PURE__*/ (() => {
    class AnnotationLayerDescription extends SeriesDescription {
        constructor() {
            super();
            this.cs = false;
            this.ct = false;
            this.co = null;
            this.cq = false;
            this.cr = false;
        }
        get_type() {
            return "AnnotationLayer";
        }
        get useIndex() {
            return this.cs;
        }
        set useIndex(a) {
            this.cs = a;
            this.e("UseIndex");
        }
        get useLegend() {
            return this.ct;
        }
        set useLegend(a) {
            this.ct = a;
            this.e("UseLegend");
        }
        get cursorPosition() {
            return this.co;
        }
        set cursorPosition(a) {
            this.co = a;
            this.e("CursorPosition");
        }
        get isDefaultCrosshairDisabled() {
            return this.cq;
        }
        set isDefaultCrosshairDisabled(a) {
            this.cq = a;
            this.e("IsDefaultCrosshairDisabled");
        }
        get shouldRenderAsOverlay() {
            return this.cr;
        }
        set shouldRenderAsOverlay(a) {
            this.cr = a;
            this.e("ShouldRenderAsOverlay");
        }
    }
    AnnotationLayerDescription.$t = /*@__PURE__*/ markType(AnnotationLayerDescription, 'AnnotationLayerDescription', SeriesDescription.$);
    return AnnotationLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CrosshairLayerDescription = /*@__PURE__*/ (() => {
    class CrosshairLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.dt = null;
            this.dx = null;
            this.dv = null;
            this.dw = null;
            this.c0 = false;
            this.cy = false;
            this.d1 = null;
            this.dz = null;
            this.dp = 0;
            this.d0 = null;
            this.c5 = 0;
            this.c7 = 0;
            this.c6 = 0;
            this.c4 = 0;
            this.da = 0;
            this.dc = 0;
            this.db = 0;
            this.c9 = 0;
            this.c8 = 0;
            this.d4 = null;
            this.d2 = null;
            this.dq = 0;
            this.d3 = null;
            this.dd = 0;
            this.dy = null;
            this.du = null;
            this.cz = false;
        }
        get_type() {
            return "CrosshairLayer";
        }
        get horizontalLineStroke() {
            return this.dt;
        }
        set horizontalLineStroke(a) {
            this.dt = a;
            this.e("HorizontalLineStroke");
        }
        get verticalLineStroke() {
            return this.dx;
        }
        set verticalLineStroke(a) {
            this.dx = a;
            this.e("VerticalLineStroke");
        }
        get targetSeriesName() {
            return this.dv;
        }
        set targetSeriesName(a) {
            this.dv = a;
            this.e("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.dw;
        }
        set targetSeriesRef(a) {
            this.dw = a;
            this.e("TargetSeriesRef");
        }
        get useInterpolation() {
            return this.c0;
        }
        set useInterpolation(a) {
            this.c0 = a;
            this.e("UseInterpolation");
        }
        get isAxisAnnotationEnabled() {
            return this.cy;
        }
        set isAxisAnnotationEnabled(a) {
            this.cy = a;
            this.e("IsAxisAnnotationEnabled");
        }
        get xAxisAnnotationTextColor() {
            return this.d1;
        }
        set xAxisAnnotationTextColor(a) {
            this.d1 = a;
            this.e("XAxisAnnotationTextColor");
        }
        get xAxisAnnotationBackground() {
            return this.dz;
        }
        set xAxisAnnotationBackground(a) {
            this.dz = a;
            this.e("XAxisAnnotationBackground");
        }
        get xAxisAnnotationInterpolatedValuePrecision() {
            return this.dp;
        }
        set xAxisAnnotationInterpolatedValuePrecision(a) {
            this.dp = a;
            this.e("XAxisAnnotationInterpolatedValuePrecision");
        }
        get xAxisAnnotationOutline() {
            return this.d0;
        }
        set xAxisAnnotationOutline(a) {
            this.d0 = a;
            this.e("XAxisAnnotationOutline");
        }
        get xAxisAnnotationPaddingLeft() {
            return this.c5;
        }
        set xAxisAnnotationPaddingLeft(a) {
            this.c5 = a;
            this.e("XAxisAnnotationPaddingLeft");
        }
        get xAxisAnnotationPaddingTop() {
            return this.c7;
        }
        set xAxisAnnotationPaddingTop(a) {
            this.c7 = a;
            this.e("XAxisAnnotationPaddingTop");
        }
        get xAxisAnnotationPaddingRight() {
            return this.c6;
        }
        set xAxisAnnotationPaddingRight(a) {
            this.c6 = a;
            this.e("XAxisAnnotationPaddingRight");
        }
        get xAxisAnnotationPaddingBottom() {
            return this.c4;
        }
        set xAxisAnnotationPaddingBottom(a) {
            this.c4 = a;
            this.e("XAxisAnnotationPaddingBottom");
        }
        get yAxisAnnotationPaddingLeft() {
            return this.da;
        }
        set yAxisAnnotationPaddingLeft(a) {
            this.da = a;
            this.e("YAxisAnnotationPaddingLeft");
        }
        get yAxisAnnotationPaddingTop() {
            return this.dc;
        }
        set yAxisAnnotationPaddingTop(a) {
            this.dc = a;
            this.e("YAxisAnnotationPaddingTop");
        }
        get yAxisAnnotationPaddingRight() {
            return this.db;
        }
        set yAxisAnnotationPaddingRight(a) {
            this.db = a;
            this.e("YAxisAnnotationPaddingRight");
        }
        get yAxisAnnotationPaddingBottom() {
            return this.c9;
        }
        set yAxisAnnotationPaddingBottom(a) {
            this.c9 = a;
            this.e("YAxisAnnotationPaddingBottom");
        }
        get xAxisAnnotationStrokeThickness() {
            return this.c8;
        }
        set xAxisAnnotationStrokeThickness(a) {
            this.c8 = a;
            this.e("XAxisAnnotationStrokeThickness");
        }
        get yAxisAnnotationTextColor() {
            return this.d4;
        }
        set yAxisAnnotationTextColor(a) {
            this.d4 = a;
            this.e("YAxisAnnotationTextColor");
        }
        get yAxisAnnotationBackground() {
            return this.d2;
        }
        set yAxisAnnotationBackground(a) {
            this.d2 = a;
            this.e("YAxisAnnotationBackground");
        }
        get yAxisAnnotationInterpolatedValuePrecision() {
            return this.dq;
        }
        set yAxisAnnotationInterpolatedValuePrecision(a) {
            this.dq = a;
            this.e("YAxisAnnotationInterpolatedValuePrecision");
        }
        get yAxisAnnotationOutline() {
            return this.d3;
        }
        set yAxisAnnotationOutline(a) {
            this.d3 = a;
            this.e("YAxisAnnotationOutline");
        }
        get yAxisAnnotationStrokeThickness() {
            return this.dd;
        }
        set yAxisAnnotationStrokeThickness(a) {
            this.dd = a;
            this.e("YAxisAnnotationStrokeThickness");
        }
        get verticalLineVisibility() {
            return this.dy;
        }
        set verticalLineVisibility(a) {
            this.dy = a;
            this.e("VerticalLineVisibility");
        }
        get horizontalLineVisibility() {
            return this.du;
        }
        set horizontalLineVisibility(a) {
            this.du = a;
            this.e("HorizontalLineVisibility");
        }
        get skipUnknownValues() {
            return this.cz;
        }
        set skipUnknownValues(a) {
            this.cz = a;
            this.e("SkipUnknownValues");
        }
    }
    CrosshairLayerDescription.$t = /*@__PURE__*/ markType(CrosshairLayerDescription, 'CrosshairLayerDescription', AnnotationLayerDescription.$);
    return CrosshairLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CrosshairLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CrosshairLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CrosshairLayerDescriptionMetadata.a == null) {
                CrosshairLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CrosshairLayerDescriptionMetadata.c(a, CrosshairLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("HorizontalLineStroke", "Brush");
            b.item("VerticalLineStroke", "Brush");
            b.item("TargetSeriesName", "String");
            b.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            b.item("UseInterpolation", "Boolean");
            b.item("IsAxisAnnotationEnabled", "Boolean");
            b.item("XAxisAnnotationTextColor", "Brush");
            b.item("XAxisAnnotationBackground", "Brush");
            b.item("XAxisAnnotationInterpolatedValuePrecision", "Number:int");
            b.item("XAxisAnnotationOutline", "Brush");
            b.item("XAxisAnnotationPaddingLeft", "Number:double");
            b.item("XAxisAnnotationPaddingTop", "Number:double");
            b.item("XAxisAnnotationPaddingRight", "Number:double");
            b.item("XAxisAnnotationPaddingBottom", "Number:double");
            b.item("YAxisAnnotationPaddingLeft", "Number:double");
            b.item("YAxisAnnotationPaddingTop", "Number:double");
            b.item("YAxisAnnotationPaddingRight", "Number:double");
            b.item("YAxisAnnotationPaddingBottom", "Number:double");
            b.item("XAxisAnnotationStrokeThickness", "Number:double");
            b.item("YAxisAnnotationTextColor", "Brush");
            b.item("YAxisAnnotationBackground", "Brush");
            b.item("YAxisAnnotationInterpolatedValuePrecision", "Number:int");
            b.item("YAxisAnnotationOutline", "Brush");
            b.item("YAxisAnnotationStrokeThickness", "Number:double");
            b.item("VerticalLineVisibility", "ExportedType:string:Visibility");
            b.item("VerticalLineVisibility@names", "Visible;Collapsed");
            b.item("HorizontalLineVisibility", "ExportedType:string:Visibility");
            b.item("HorizontalLineVisibility@names", "Visible;Collapsed");
            b.item("SkipUnknownValues", "Boolean");
        }
        static d(a) {
            CrosshairLayerDescriptionMetadata.b(a);
            a.q("CrosshairLayer", () => new CrosshairLayerDescription());
            a.p("CrosshairLayer", CrosshairLayerDescriptionMetadata.a);
        }
    }
    CrosshairLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CrosshairLayerDescriptionMetadata, 'CrosshairLayerDescriptionMetadata');
    CrosshairLayerDescriptionMetadata.a = null;
    return CrosshairLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CrosshairLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CrosshairLayerDescriptionModule extends Base {
        static register(a) {
            CrosshairLayerDescriptionMetadata.d(a);
        }
    }
    CrosshairLayerDescriptionModule.$t = /*@__PURE__*/ markType(CrosshairLayerDescriptionModule, 'CrosshairLayerDescriptionModule');
    return CrosshairLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutContentUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutContentUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "CalloutContentUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get xValueRef() {
            return this.h;
        }
        set xValueRef(a) {
            this.h = a;
            this.e("XValueRef");
        }
        get yValueRef() {
            return this.i;
        }
        set yValueRef(a) {
            this.i = a;
            this.e("YValueRef");
        }
        get itemRef() {
            return this.g;
        }
        set itemRef(a) {
            this.g = a;
            this.e("ItemRef");
        }
        get contentRef() {
            return this.f;
        }
        set contentRef(a) {
            this.f = a;
            this.e("ContentRef");
        }
    }
    CalloutContentUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutContentUpdatingEventArgsDescription, 'CalloutContentUpdatingEventArgsDescription', Description.$);
    return CalloutContentUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutContentUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutContentUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutContentUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutContentUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutContentUpdatingEventArgsDescriptionMetadata.c(a, CalloutContentUpdatingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("XValueRef", "(w:XValue,j:xValue,wf:XValue)DataRef");
            b.item("YValueRef", "(w:YValue,j:yValue,wf:YValue)DataRef");
            b.item("ItemRef", "(w:Item,j:item,wf:Item)DataRef");
            b.item("ContentRef", "(w:Content,j:content,wf:Content)DataRef");
        }
        static d(a) {
            CalloutContentUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("CalloutContentUpdatingEventArgs", () => new CalloutContentUpdatingEventArgsDescription());
            a.p("CalloutContentUpdatingEventArgs", CalloutContentUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutContentUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutContentUpdatingEventArgsDescriptionMetadata, 'CalloutContentUpdatingEventArgsDescriptionMetadata');
    CalloutContentUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutContentUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLabelUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutLabelUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "CalloutLabelUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get xValueRef() {
            return this.h;
        }
        set xValueRef(a) {
            this.h = a;
            this.e("XValueRef");
        }
        get yValueRef() {
            return this.i;
        }
        set yValueRef(a) {
            this.i = a;
            this.e("YValueRef");
        }
        get itemRef() {
            return this.f;
        }
        set itemRef(a) {
            this.f = a;
            this.e("ItemRef");
        }
        get labelRef() {
            return this.g;
        }
        set labelRef(a) {
            this.g = a;
            this.e("LabelRef");
        }
    }
    CalloutLabelUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutLabelUpdatingEventArgsDescription, 'CalloutLabelUpdatingEventArgsDescription', Description.$);
    return CalloutLabelUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLabelUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutLabelUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutLabelUpdatingEventArgsDescriptionMetadata.a == null) {
                CalloutLabelUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutLabelUpdatingEventArgsDescriptionMetadata.c(a, CalloutLabelUpdatingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("XValueRef", "(w:XValue,j:xValue,wf:XValue)DataRef");
            b.item("YValueRef", "(w:YValue,j:yValue,wf:YValue)DataRef");
            b.item("ItemRef", "(w:Item,j:item,wf:Item)DataRef");
            b.item("LabelRef", "(w:Label,j:label,wf:Label)DataRef");
        }
        static d(a) {
            CalloutLabelUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("CalloutLabelUpdatingEventArgs", () => new CalloutLabelUpdatingEventArgsDescription());
            a.p("CalloutLabelUpdatingEventArgs", CalloutLabelUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutLabelUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutLabelUpdatingEventArgsDescriptionMetadata, 'CalloutLabelUpdatingEventArgsDescriptionMetadata');
    CalloutLabelUpdatingEventArgsDescriptionMetadata.a = null;
    return CalloutLabelUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutSeriesSelectingEventArgsDescription = /*@__PURE__*/ (() => {
    class CalloutSeriesSelectingEventArgsDescription extends Description {
        constructor() {
            super();
            this.j = null;
            this.k = null;
            this.h = null;
            this.f = null;
            this.i = null;
        }
        get_type() {
            return "CalloutSeriesSelectingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get xValueRef() {
            return this.j;
        }
        set xValueRef(a) {
            this.j = a;
            this.e("XValueRef");
        }
        get yValueRef() {
            return this.k;
        }
        set yValueRef(a) {
            this.k = a;
            this.e("YValueRef");
        }
        get itemRef() {
            return this.h;
        }
        set itemRef(a) {
            this.h = a;
            this.e("ItemRef");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get seriesName() {
            return this.i;
        }
        set seriesName(a) {
            this.i = a;
            this.e("SeriesName");
        }
    }
    CalloutSeriesSelectingEventArgsDescription.$t = /*@__PURE__*/ markType(CalloutSeriesSelectingEventArgsDescription, 'CalloutSeriesSelectingEventArgsDescription', Description.$);
    return CalloutSeriesSelectingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutSeriesSelectingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutSeriesSelectingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutSeriesSelectingEventArgsDescriptionMetadata.a == null) {
                CalloutSeriesSelectingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutSeriesSelectingEventArgsDescriptionMetadata.c(a, CalloutSeriesSelectingEventArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("XValueRef", "(w:XValue,j:xValue,wf:XValue)DataRef");
            b.item("YValueRef", "(w:YValue,j:yValue,wf:YValue)DataRef");
            b.item("ItemRef", "(w:Item,j:item,wf:Item)DataRef");
            b.item("Series", "(j:_internalSeries)ExportedType:Series");
            b.item("SeriesName", "String");
        }
        static d(a) {
            CalloutSeriesSelectingEventArgsDescriptionMetadata.b(a);
            a.q("CalloutSeriesSelectingEventArgs", () => new CalloutSeriesSelectingEventArgsDescription());
            a.p("CalloutSeriesSelectingEventArgs", CalloutSeriesSelectingEventArgsDescriptionMetadata.a);
        }
    }
    CalloutSeriesSelectingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutSeriesSelectingEventArgsDescriptionMetadata, 'CalloutSeriesSelectingEventArgsDescriptionMetadata');
    CalloutSeriesSelectingEventArgsDescriptionMetadata.a = null;
    return CalloutSeriesSelectingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLayerDescription = /*@__PURE__*/ (() => {
    class CalloutLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.dz = null;
            this.d3 = null;
            this.d4 = null;
            this.dy = null;
            this.cz = false;
            this.dx = null;
            this.d0 = null;
            this.d1 = null;
            this.dw = null;
            this.cy = false;
            this.c1 = false;
            this.c0 = false;
            this.di = 0;
            this.dv = null;
            this.dm = null;
            this.dj = 0;
            this.ds = null;
            this.dr = null;
            this.c7 = 0;
            this.c9 = 0;
            this.c8 = 0;
            this.c6 = 0;
            this.dn = null;
            this.da = 0;
            this.db = 0;
            this.d2 = null;
            this.du = null;
            this.dp = null;
            this.dq = null;
            this.dt = null;
        }
        get_type() {
            return "CalloutLayer";
        }
        get labelMemberPath() {
            return this.dz;
        }
        set labelMemberPath(a) {
            this.dz = a;
            this.e("LabelMemberPath");
        }
        get xMemberPath() {
            return this.d3;
        }
        set xMemberPath(a) {
            this.d3 = a;
            this.e("XMemberPath");
        }
        get yMemberPath() {
            return this.d4;
        }
        set yMemberPath(a) {
            this.d4 = a;
            this.e("YMemberPath");
        }
        get keyMemberPath() {
            return this.dy;
        }
        set keyMemberPath(a) {
            this.dy = a;
            this.e("KeyMemberPath");
        }
        get isCalloutOffsettingEnabled() {
            return this.cz;
        }
        set isCalloutOffsettingEnabled(a) {
            this.cz = a;
            this.e("IsCalloutOffsettingEnabled");
        }
        get contentMemberPath() {
            return this.dx;
        }
        set contentMemberPath(a) {
            this.dx = a;
            this.e("ContentMemberPath");
        }
        get targetSeriesName() {
            return this.d0;
        }
        set targetSeriesName(a) {
            this.d0 = a;
            this.e("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.d1;
        }
        set targetSeriesRef(a) {
            this.d1 = a;
            this.e("TargetSeriesRef");
        }
        get collisionChannel() {
            return this.dw;
        }
        set collisionChannel(a) {
            this.dw = a;
            this.e("CollisionChannel");
        }
        get isAutoCalloutBehaviorEnabled() {
            return this.cy;
        }
        set isAutoCalloutBehaviorEnabled(a) {
            this.cy = a;
            this.e("IsAutoCalloutBehaviorEnabled");
        }
        get useValueForAutoCalloutLabels() {
            return this.c1;
        }
        set useValueForAutoCalloutLabels(a) {
            this.c1 = a;
            this.e("UseValueForAutoCalloutLabels");
        }
        get isCustomCalloutStyleEnabled() {
            return this.c0;
        }
        set isCustomCalloutStyleEnabled(a) {
            this.c0 = a;
            this.e("IsCustomCalloutStyleEnabled");
        }
        get autoCalloutLabelPrecision() {
            return this.di;
        }
        set autoCalloutLabelPrecision(a) {
            this.di = a;
            this.e("AutoCalloutLabelPrecision");
        }
        get calloutTextColor() {
            return this.dv;
        }
        set calloutTextColor(a) {
            this.dv = a;
            this.e("CalloutTextColor");
        }
        get calloutBackground() {
            return this.dm;
        }
        set calloutBackground(a) {
            this.dm = a;
            this.e("CalloutBackground");
        }
        get calloutInterpolatedValuePrecision() {
            return this.dj;
        }
        set calloutInterpolatedValuePrecision(a) {
            this.dj = a;
            this.e("CalloutInterpolatedValuePrecision");
        }
        get calloutOutline() {
            return this.ds;
        }
        set calloutOutline(a) {
            this.ds = a;
            this.e("CalloutOutline");
        }
        get calloutLeaderBrush() {
            return this.dr;
        }
        set calloutLeaderBrush(a) {
            this.dr = a;
            this.e("CalloutLeaderBrush");
        }
        get calloutPaddingLeft() {
            return this.c7;
        }
        set calloutPaddingLeft(a) {
            this.c7 = a;
            this.e("CalloutPaddingLeft");
        }
        get calloutPaddingTop() {
            return this.c9;
        }
        set calloutPaddingTop(a) {
            this.c9 = a;
            this.e("CalloutPaddingTop");
        }
        get calloutPaddingRight() {
            return this.c8;
        }
        set calloutPaddingRight(a) {
            this.c8 = a;
            this.e("CalloutPaddingRight");
        }
        get calloutPaddingBottom() {
            return this.c6;
        }
        set calloutPaddingBottom(a) {
            this.c6 = a;
            this.e("CalloutPaddingBottom");
        }
        get calloutCollisionMode() {
            return this.dn;
        }
        set calloutCollisionMode(a) {
            this.dn = a;
            this.e("CalloutCollisionMode");
        }
        get calloutPositionPadding() {
            return this.da;
        }
        set calloutPositionPadding(a) {
            this.da = a;
            this.e("CalloutPositionPadding");
        }
        get calloutStrokeThickness() {
            return this.db;
        }
        set calloutStrokeThickness(a) {
            this.db = a;
            this.e("CalloutStrokeThickness");
        }
        get textStyle() {
            return this.d2;
        }
        set textStyle(a) {
            this.d2 = a;
            this.e("TextStyle");
        }
        get calloutStyleUpdatingRef() {
            return this.du;
        }
        set calloutStyleUpdatingRef(a) {
            this.du = a;
            this.e("CalloutStyleUpdatingRef");
        }
        get calloutContentUpdatingRef() {
            return this.dp;
        }
        set calloutContentUpdatingRef(a) {
            this.dp = a;
            this.e("CalloutContentUpdatingRef");
        }
        get calloutLabelUpdatingRef() {
            return this.dq;
        }
        set calloutLabelUpdatingRef(a) {
            this.dq = a;
            this.e("CalloutLabelUpdatingRef");
        }
        get calloutSeriesSelectingRef() {
            return this.dt;
        }
        set calloutSeriesSelectingRef(a) {
            this.dt = a;
            this.e("CalloutSeriesSelectingRef");
        }
    }
    CalloutLayerDescription.$t = /*@__PURE__*/ markType(CalloutLayerDescription, 'CalloutLayerDescription', AnnotationLayerDescription.$);
    return CalloutLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutLayerDescriptionMetadata.a == null) {
                CalloutLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutLayerDescriptionMetadata.c(a, CalloutLayerDescriptionMetadata.a);
                CalloutStyleUpdatingEventArgsDescriptionMetadata.d(a);
                CalloutContentUpdatingEventArgsDescriptionMetadata.d(a);
                CalloutLabelUpdatingEventArgsDescriptionMetadata.d(a);
                CalloutSeriesSelectingEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("LabelMemberPath", "String");
            b.item("XMemberPath", "String");
            b.item("YMemberPath", "String");
            b.item("KeyMemberPath", "String");
            b.item("IsCalloutOffsettingEnabled", "Boolean");
            b.item("ContentMemberPath", "String");
            b.item("TargetSeriesName", "String");
            b.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            b.item("CollisionChannel", "String");
            b.item("IsAutoCalloutBehaviorEnabled", "Boolean");
            b.item("UseValueForAutoCalloutLabels", "Boolean");
            b.item("IsCustomCalloutStyleEnabled", "Boolean");
            b.item("AutoCalloutLabelPrecision", "Number:int");
            b.item("CalloutTextColor", "Brush");
            b.item("CalloutBackground", "Brush");
            b.item("CalloutInterpolatedValuePrecision", "Number:int");
            b.item("CalloutOutline", "Brush");
            b.item("CalloutLeaderBrush", "Brush");
            b.item("CalloutPaddingLeft", "Number:double");
            b.item("CalloutPaddingTop", "Number:double");
            b.item("CalloutPaddingRight", "Number:double");
            b.item("CalloutPaddingBottom", "Number:double");
            b.item("CalloutCollisionMode", "ExportedType:string:CalloutCollisionMode");
            b.item("CalloutCollisionMode@names", "Auto;SimulatedAnnealing;Greedy;GreedyCenterOfMass");
            b.item("CalloutPositionPadding", "Number:double");
            b.item("CalloutStrokeThickness", "Number:double");
            b.item("TextStyle", "String");
            b.item("CalloutStyleUpdatingRef", "EventRef::calloutStyleUpdating");
            b.item("CalloutContentUpdatingRef", "EventRef::calloutContentUpdating");
            b.item("CalloutLabelUpdatingRef", "EventRef::calloutLabelUpdating");
            b.item("CalloutSeriesSelectingRef", "EventRef::calloutSeriesSelecting");
        }
        static d(a) {
            CalloutLayerDescriptionMetadata.b(a);
            a.q("CalloutLayer", () => new CalloutLayerDescription());
            a.p("CalloutLayer", CalloutLayerDescriptionMetadata.a);
        }
    }
    CalloutLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutLayerDescriptionMetadata, 'CalloutLayerDescriptionMetadata');
    CalloutLayerDescriptionMetadata.a = null;
    return CalloutLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CalloutLayerDescriptionModule extends Base {
        static register(a) {
            CalloutLayerDescriptionMetadata.d(a);
        }
    }
    CalloutLayerDescriptionModule.$t = /*@__PURE__*/ markType(CalloutLayerDescriptionModule, 'CalloutLayerDescriptionModule');
    return CalloutLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemToolTipLayerDescription = /*@__PURE__*/ (() => {
    class ItemToolTipLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.c2 = null;
            this.c3 = null;
            this.cz = false;
            this.cy = false;
        }
        get_type() {
            return "ItemToolTipLayer";
        }
        get targetSeriesName() {
            return this.c2;
        }
        set targetSeriesName(a) {
            this.c2 = a;
            this.e("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.c3;
        }
        set targetSeriesRef(a) {
            this.c3 = a;
            this.e("TargetSeriesRef");
        }
        get useInterpolation() {
            return this.cz;
        }
        set useInterpolation(a) {
            this.cz = a;
            this.e("UseInterpolation");
        }
        get skipUnknownValues() {
            return this.cy;
        }
        set skipUnknownValues(a) {
            this.cy = a;
            this.e("SkipUnknownValues");
        }
    }
    ItemToolTipLayerDescription.$t = /*@__PURE__*/ markType(ItemToolTipLayerDescription, 'ItemToolTipLayerDescription', AnnotationLayerDescription.$);
    return ItemToolTipLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemToolTipLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class ItemToolTipLayerDescriptionMetadata extends Base {
        static b(a) {
            if (ItemToolTipLayerDescriptionMetadata.a == null) {
                ItemToolTipLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ItemToolTipLayerDescriptionMetadata.c(a, ItemToolTipLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("TargetSeriesName", "String");
            b.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            b.item("UseInterpolation", "Boolean");
            b.item("SkipUnknownValues", "Boolean");
        }
        static d(a) {
            ItemToolTipLayerDescriptionMetadata.b(a);
            a.q("ItemToolTipLayer", () => new ItemToolTipLayerDescription());
            a.p("ItemToolTipLayer", ItemToolTipLayerDescriptionMetadata.a);
        }
    }
    ItemToolTipLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(ItemToolTipLayerDescriptionMetadata, 'ItemToolTipLayerDescriptionMetadata');
    ItemToolTipLayerDescriptionMetadata.a = null;
    return ItemToolTipLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemToolTipLayerDescriptionModule = /*@__PURE__*/ (() => {
    class ItemToolTipLayerDescriptionModule extends Base {
        static register(a) {
            ItemToolTipLayerDescriptionMetadata.d(a);
        }
    }
    ItemToolTipLayerDescriptionModule.$t = /*@__PURE__*/ markType(ItemToolTipLayerDescriptionModule, 'ItemToolTipLayerDescriptionModule');
    return ItemToolTipLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryToolTipLayerDescription = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.c0 = null;
            this.cy = false;
        }
        get_type() {
            return "CategoryToolTipLayer";
        }
        get targetAxisRef() {
            return this.c0;
        }
        set targetAxisRef(a) {
            this.c0 = a;
            this.e("TargetAxisRef");
        }
        get useInterpolation() {
            return this.cy;
        }
        set useInterpolation(a) {
            this.cy = a;
            this.e("UseInterpolation");
        }
    }
    CategoryToolTipLayerDescription.$t = /*@__PURE__*/ markType(CategoryToolTipLayerDescription, 'CategoryToolTipLayerDescription', AnnotationLayerDescription.$);
    return CategoryToolTipLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryToolTipLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryToolTipLayerDescriptionMetadata.a == null) {
                CategoryToolTipLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryToolTipLayerDescriptionMetadata.c(a, CategoryToolTipLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("TargetAxisRef", "(w:TargetAxis,wf:TargetAxis)DataRef::object");
            b.item("UseInterpolation", "Boolean");
        }
        static d(a) {
            CategoryToolTipLayerDescriptionMetadata.b(a);
            a.q("CategoryToolTipLayer", () => new CategoryToolTipLayerDescription());
            a.p("CategoryToolTipLayer", CategoryToolTipLayerDescriptionMetadata.a);
        }
    }
    CategoryToolTipLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryToolTipLayerDescriptionMetadata, 'CategoryToolTipLayerDescriptionMetadata');
    CategoryToolTipLayerDescriptionMetadata.a = null;
    return CategoryToolTipLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryToolTipLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryToolTipLayerDescriptionModule extends Base {
        static register(a) {
            CategoryToolTipLayerDescriptionMetadata.d(a);
        }
    }
    CategoryToolTipLayerDescriptionModule.$t = /*@__PURE__*/ markType(CategoryToolTipLayerDescriptionModule, 'CategoryToolTipLayerDescriptionModule');
    return CategoryToolTipLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryHighlightLayerDescription = /*@__PURE__*/ (() => {
    class CategoryHighlightLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.c2 = null;
            this.cy = false;
            this.c0 = 0;
        }
        get_type() {
            return "CategoryHighlightLayer";
        }
        get targetAxisRef() {
            return this.c2;
        }
        set targetAxisRef(a) {
            this.c2 = a;
            this.e("TargetAxisRef");
        }
        get useInterpolation() {
            return this.cy;
        }
        set useInterpolation(a) {
            this.cy = a;
            this.e("UseInterpolation");
        }
        get bandHighlightWidth() {
            return this.c0;
        }
        set bandHighlightWidth(a) {
            this.c0 = a;
            this.e("BandHighlightWidth");
        }
    }
    CategoryHighlightLayerDescription.$t = /*@__PURE__*/ markType(CategoryHighlightLayerDescription, 'CategoryHighlightLayerDescription', AnnotationLayerDescription.$);
    return CategoryHighlightLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryHighlightLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryHighlightLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryHighlightLayerDescriptionMetadata.a == null) {
                CategoryHighlightLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryHighlightLayerDescriptionMetadata.c(a, CategoryHighlightLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("TargetAxisRef", "(w:TargetAxis,wf:TargetAxis)DataRef::object");
            b.item("UseInterpolation", "Boolean");
            b.item("BandHighlightWidth", "Number:double");
        }
        static d(a) {
            CategoryHighlightLayerDescriptionMetadata.b(a);
            a.q("CategoryHighlightLayer", () => new CategoryHighlightLayerDescription());
            a.p("CategoryHighlightLayer", CategoryHighlightLayerDescriptionMetadata.a);
        }
    }
    CategoryHighlightLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryHighlightLayerDescriptionMetadata, 'CategoryHighlightLayerDescriptionMetadata');
    CategoryHighlightLayerDescriptionMetadata.a = null;
    return CategoryHighlightLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryHighlightLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryHighlightLayerDescriptionModule extends Base {
        static register(a) {
            CategoryHighlightLayerDescriptionMetadata.d(a);
        }
    }
    CategoryHighlightLayerDescriptionModule.$t = /*@__PURE__*/ markType(CategoryHighlightLayerDescriptionModule, 'CategoryHighlightLayerDescriptionModule');
    return CategoryHighlightLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryItemHighlightLayerDescription = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.da = null;
            this.c9 = null;
            this.cz = false;
            this.c4 = null;
            this.c8 = null;
            this.c5 = null;
            this.c6 = null;
            this.c7 = null;
            this.c2 = 0;
            this.cy = false;
        }
        get_type() {
            return "CategoryItemHighlightLayer";
        }
        get targetSeriesRef() {
            return this.da;
        }
        set targetSeriesRef(a) {
            this.da = a;
            this.e("TargetSeriesRef");
        }
        get targetSeriesName() {
            return this.c9;
        }
        set targetSeriesName(a) {
            this.c9 = a;
            this.e("TargetSeriesName");
        }
        get useInterpolation() {
            return this.cz;
        }
        set useInterpolation(a) {
            this.cz = a;
            this.e("UseInterpolation");
        }
        get highlightType() {
            return this.c4;
        }
        set highlightType(a) {
            this.c4 = a;
            this.e("HighlightType");
        }
        get markerType() {
            return this.c8;
        }
        set markerType(a) {
            this.c8 = a;
            this.e("MarkerType");
        }
        get markerBrush() {
            return this.c5;
        }
        set markerBrush(a) {
            this.c5 = a;
            this.e("MarkerBrush");
        }
        get markerOutline() {
            return this.c6;
        }
        set markerOutline(a) {
            this.c6 = a;
            this.e("MarkerOutline");
        }
        get markerTemplateRef() {
            return this.c7;
        }
        set markerTemplateRef(a) {
            this.c7 = a;
            this.e("MarkerTemplateRef");
        }
        get bandHighlightWidth() {
            return this.c2;
        }
        set bandHighlightWidth(a) {
            this.c2 = a;
            this.e("BandHighlightWidth");
        }
        get skipUnknownValues() {
            return this.cy;
        }
        set skipUnknownValues(a) {
            this.cy = a;
            this.e("SkipUnknownValues");
        }
    }
    CategoryItemHighlightLayerDescription.$t = /*@__PURE__*/ markType(CategoryItemHighlightLayerDescription, 'CategoryItemHighlightLayerDescription', AnnotationLayerDescription.$);
    return CategoryItemHighlightLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryItemHighlightLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryItemHighlightLayerDescriptionMetadata.a == null) {
                CategoryItemHighlightLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryItemHighlightLayerDescriptionMetadata.c(a, CategoryItemHighlightLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            b.item("TargetSeriesName", "String");
            b.item("UseInterpolation", "Boolean");
            b.item("HighlightType", "ExportedType:string:CategoryItemHighlightType");
            b.item("HighlightType@names", "Auto;Marker;Shape");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("BandHighlightWidth", "Number:double");
            b.item("SkipUnknownValues", "Boolean");
        }
        static d(a) {
            CategoryItemHighlightLayerDescriptionMetadata.b(a);
            a.q("CategoryItemHighlightLayer", () => new CategoryItemHighlightLayerDescription());
            a.p("CategoryItemHighlightLayer", CategoryItemHighlightLayerDescriptionMetadata.a);
        }
    }
    CategoryItemHighlightLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryItemHighlightLayerDescriptionMetadata, 'CategoryItemHighlightLayerDescriptionMetadata');
    CategoryItemHighlightLayerDescriptionMetadata.a = null;
    return CategoryItemHighlightLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryItemHighlightLayerDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryItemHighlightLayerDescriptionModule extends Base {
        static register(a) {
            CategoryItemHighlightLayerDescriptionMetadata.d(a);
        }
    }
    CategoryItemHighlightLayerDescriptionModule.$t = /*@__PURE__*/ markType(CategoryItemHighlightLayerDescriptionModule, 'CategoryItemHighlightLayerDescriptionModule');
    return CategoryItemHighlightLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinalValueLayerDescription = /*@__PURE__*/ (() => {
    class FinalValueLayerDescription extends AnnotationLayerDescription {
        constructor() {
            super();
            this.de = null;
            this.df = null;
            this.dd = null;
            this.dc = null;
            this.da = null;
            this.c8 = 0;
            this.db = null;
            this.cz = 0;
            this.c1 = 0;
            this.c0 = 0;
            this.cy = 0;
            this.c2 = 0;
        }
        get_type() {
            return "FinalValueLayer";
        }
        get targetSeriesName() {
            return this.de;
        }
        set targetSeriesName(a) {
            this.de = a;
            this.e("TargetSeriesName");
        }
        get targetSeriesRef() {
            return this.df;
        }
        set targetSeriesRef(a) {
            this.df = a;
            this.e("TargetSeriesRef");
        }
        get finalValueSelectionMode() {
            return this.dd;
        }
        set finalValueSelectionMode(a) {
            this.dd = a;
            this.e("FinalValueSelectionMode");
        }
        get axisAnnotationTextColor() {
            return this.dc;
        }
        set axisAnnotationTextColor(a) {
            this.dc = a;
            this.e("AxisAnnotationTextColor");
        }
        get axisAnnotationBackground() {
            return this.da;
        }
        set axisAnnotationBackground(a) {
            this.da = a;
            this.e("AxisAnnotationBackground");
        }
        get axisAnnotationInterpolatedValuePrecision() {
            return this.c8;
        }
        set axisAnnotationInterpolatedValuePrecision(a) {
            this.c8 = a;
            this.e("AxisAnnotationInterpolatedValuePrecision");
        }
        get axisAnnotationOutline() {
            return this.db;
        }
        set axisAnnotationOutline(a) {
            this.db = a;
            this.e("AxisAnnotationOutline");
        }
        get axisAnnotationPaddingLeft() {
            return this.cz;
        }
        set axisAnnotationPaddingLeft(a) {
            this.cz = a;
            this.e("AxisAnnotationPaddingLeft");
        }
        get axisAnnotationPaddingTop() {
            return this.c1;
        }
        set axisAnnotationPaddingTop(a) {
            this.c1 = a;
            this.e("AxisAnnotationPaddingTop");
        }
        get axisAnnotationPaddingRight() {
            return this.c0;
        }
        set axisAnnotationPaddingRight(a) {
            this.c0 = a;
            this.e("AxisAnnotationPaddingRight");
        }
        get axisAnnotationPaddingBottom() {
            return this.cy;
        }
        set axisAnnotationPaddingBottom(a) {
            this.cy = a;
            this.e("AxisAnnotationPaddingBottom");
        }
        get axisAnnotationStrokeThickness() {
            return this.c2;
        }
        set axisAnnotationStrokeThickness(a) {
            this.c2 = a;
            this.e("AxisAnnotationStrokeThickness");
        }
    }
    FinalValueLayerDescription.$t = /*@__PURE__*/ markType(FinalValueLayerDescription, 'FinalValueLayerDescription', AnnotationLayerDescription.$);
    return FinalValueLayerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinalValueLayerDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinalValueLayerDescriptionMetadata extends Base {
        static b(a) {
            if (FinalValueLayerDescriptionMetadata.a == null) {
                FinalValueLayerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinalValueLayerDescriptionMetadata.c(a, FinalValueLayerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnnotationLayerDescriptionMetadata.c(a, b);
            b.item("TargetSeriesName", "String");
            b.item("TargetSeriesRef", "(w:TargetSeries,wf:TargetSeries)DataRef::object");
            b.item("FinalValueSelectionMode", "ExportedType:string:FinalValueSelectionMode");
            b.item("FinalValueSelectionMode@names", "Auto;FinalVisible;FinalVisibleInterpolated;Final");
            b.item("AxisAnnotationTextColor", "Brush");
            b.item("AxisAnnotationBackground", "Brush");
            b.item("AxisAnnotationInterpolatedValuePrecision", "Number:int");
            b.item("AxisAnnotationOutline", "Brush");
            b.item("AxisAnnotationPaddingLeft", "Number:double");
            b.item("AxisAnnotationPaddingTop", "Number:double");
            b.item("AxisAnnotationPaddingRight", "Number:double");
            b.item("AxisAnnotationPaddingBottom", "Number:double");
            b.item("AxisAnnotationStrokeThickness", "Number:double");
        }
        static d(a) {
            FinalValueLayerDescriptionMetadata.b(a);
            a.q("FinalValueLayer", () => new FinalValueLayerDescription());
            a.p("FinalValueLayer", FinalValueLayerDescriptionMetadata.a);
        }
    }
    FinalValueLayerDescriptionMetadata.$t = /*@__PURE__*/ markType(FinalValueLayerDescriptionMetadata, 'FinalValueLayerDescriptionMetadata');
    FinalValueLayerDescriptionMetadata.a = null;
    return FinalValueLayerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinalValueLayerDescriptionModule = /*@__PURE__*/ (() => {
    class FinalValueLayerDescriptionModule extends Base {
        static register(a) {
            FinalValueLayerDescriptionMetadata.d(a);
        }
    }
    FinalValueLayerDescriptionModule.$t = /*@__PURE__*/ markType(FinalValueLayerDescriptionModule, 'FinalValueLayerDescriptionModule');
    return FinalValueLayerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumberAbbreviatorDescriptionModule = /*@__PURE__*/ (() => {
    class NumberAbbreviatorDescriptionModule extends Base {
        static register(a) {
        }
    }
    NumberAbbreviatorDescriptionModule.$t = /*@__PURE__*/ markType(NumberAbbreviatorDescriptionModule, 'NumberAbbreviatorDescriptionModule');
    return NumberAbbreviatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDefaultTooltipsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartDefaultTooltipsDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DataChartDefaultTooltipsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartDefaultTooltipsDescriptionMetadata, 'DataChartDefaultTooltipsDescriptionMetadata');
    return DataChartDefaultTooltipsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartInteractivityDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartInteractivityDescriptionModule extends Base {
        static register(a) {
            DataChartDefaultTooltipsDescriptionMetadata.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    DataChartInteractivityDescriptionModule.$t = /*@__PURE__*/ markType(DataChartInteractivityDescriptionModule, 'DataChartInteractivityDescriptionModule');
    return DataChartInteractivityDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCategoryTrendLineDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCategoryTrendLineDescriptionModule extends Base {
        static register(a) {
        }
    }
    DataChartCategoryTrendLineDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCategoryTrendLineDescriptionModule, 'DataChartCategoryTrendLineDescriptionModule');
    return DataChartCategoryTrendLineDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartAnnotationDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartAnnotationDescriptionModule extends Base {
        static register(a) {
            CrosshairLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            FinalValueLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
        }
    }
    DataChartAnnotationDescriptionModule.$t = /*@__PURE__*/ markType(DataChartAnnotationDescriptionModule, 'DataChartAnnotationDescriptionModule');
    return DataChartAnnotationDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryChartDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryChartDescriptionModule extends Base {
        static register(a) {
            CategoryChartCoreDescriptionModule.register(a);
            LineSeriesDescriptionModule.register(a);
            AreaSeriesDescriptionModule.register(a);
            ColumnSeriesDescriptionModule.register(a);
            SplineSeriesDescriptionModule.register(a);
            SplineAreaSeriesDescriptionModule.register(a);
            StepLineSeriesDescriptionModule.register(a);
            StepAreaSeriesDescriptionModule.register(a);
            PointSeriesDescriptionModule.register(a);
            WaterfallSeriesDescriptionModule.register(a);
            CrosshairLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            FinalValueLayerDescriptionModule.register(a);
            NumberAbbreviatorDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
            DataChartCategoryTrendLineDescriptionModule.register(a);
            DataChartAnnotationDescriptionModule.register(a);
        }
    }
    CategoryChartDescriptionModule.$t = /*@__PURE__*/ markType(CategoryChartDescriptionModule, 'CategoryChartDescriptionModule');
    return CategoryChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellKeyDescription = /*@__PURE__*/ (() => {
    class CellKeyDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.i = null;
            this.l = null;
        }
        get_type() {
            return "CellKey";
        }
        get type() {
            return this.get_type();
        }
        get primaryKey() {
            return this.f;
        }
        set primaryKey(a) {
            this.f = a;
            this.e("PrimaryKey");
        }
        get rowItem() {
            return this.i;
        }
        set rowItem(a) {
            this.i = a;
            this.e("RowItem");
        }
        get columnUniqueKey() {
            return this.l;
        }
        set columnUniqueKey(a) {
            this.l = a;
            this.e("ColumnUniqueKey");
        }
    }
    CellKeyDescription.$t = /*@__PURE__*/ markType(CellKeyDescription, 'CellKeyDescription', Description.$);
    CellKeyDescription.__marshalByValue = true;
    CellKeyDescription.__marshalByValueAlias = "CellKey";
    return CellKeyDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimaryKeyValueDescription = /*@__PURE__*/ (() => {
    class PrimaryKeyValueDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "PrimaryKeyValue";
        }
        get type() {
            return this.get_type();
        }
        get key() {
            return this.f;
        }
        set key(a) {
            this.f = a;
            this.e("Key");
        }
        get value() {
            return this.g;
        }
        set value(a) {
            this.g = a;
            this.e("Value");
        }
    }
    PrimaryKeyValueDescription.$t = /*@__PURE__*/ markType(PrimaryKeyValueDescription, 'PrimaryKeyValueDescription', Description.$);
    PrimaryKeyValueDescription.__marshalByValue = true;
    PrimaryKeyValueDescription.__marshalByValueAlias = "PrimaryKeyValue";
    return PrimaryKeyValueDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimaryKeyValueDescriptionMetadata = /*@__PURE__*/ (() => {
    class PrimaryKeyValueDescriptionMetadata extends Base {
        static b(a) {
            if (PrimaryKeyValueDescriptionMetadata.a == null) {
                PrimaryKeyValueDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PrimaryKeyValueDescriptionMetadata.c(a, PrimaryKeyValueDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Key", "Array:string");
            b.item("Value", "Collection:object:Array:Object");
        }
        static d(a) {
            PrimaryKeyValueDescriptionMetadata.b(a);
            a.q("PrimaryKeyValue", () => new PrimaryKeyValueDescription());
            a.p("PrimaryKeyValue", PrimaryKeyValueDescriptionMetadata.a);
        }
    }
    PrimaryKeyValueDescriptionMetadata.$t = /*@__PURE__*/ markType(PrimaryKeyValueDescriptionMetadata, 'PrimaryKeyValueDescriptionMetadata');
    PrimaryKeyValueDescriptionMetadata.a = null;
    return PrimaryKeyValueDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellKeyDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellKeyDescriptionMetadata extends Base {
        static b(a) {
            if (CellKeyDescriptionMetadata.a == null) {
                CellKeyDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellKeyDescriptionMetadata.c(a, CellKeyDescriptionMetadata.a);
                PrimaryKeyValueDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("PrimaryKey", "ExportedType:PrimaryKeyValue");
            b.item("RowItem", "Unknown");
            b.item("ColumnUniqueKey", "String");
        }
        static d(a) {
            CellKeyDescriptionMetadata.b(a);
            a.q("CellKey", () => new CellKeyDescription());
            a.p("CellKey", CellKeyDescriptionMetadata.a);
        }
    }
    CellKeyDescriptionMetadata.$t = /*@__PURE__*/ markType(CellKeyDescriptionMetadata, 'CellKeyDescriptionMetadata');
    CellKeyDescriptionMetadata.a = null;
    return CellKeyDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellKeyDescriptionModule = /*@__PURE__*/ (() => {
    class CellKeyDescriptionModule extends Base {
        static register(a) {
            CellKeyDescriptionMetadata.d(a);
        }
    }
    CellKeyDescriptionModule.$t = /*@__PURE__*/ markType(CellKeyDescriptionModule, 'CellKeyDescriptionModule');
    return CellKeyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellRangeDescription = /*@__PURE__*/ (() => {
    class CellRangeDescription extends Description {
        constructor() {
            super();
            this.i = 0;
            this.g = 0;
            this.j = 0;
            this.h = 0;
        }
        get_type() {
            return "CellRange";
        }
        get type() {
            return this.get_type();
        }
        get startColumn() {
            return this.i;
        }
        set startColumn(a) {
            this.i = a;
            this.e("StartColumn");
        }
        get endColumn() {
            return this.g;
        }
        set endColumn(a) {
            this.g = a;
            this.e("EndColumn");
        }
        get startRow() {
            return this.j;
        }
        set startRow(a) {
            this.j = a;
            this.e("StartRow");
        }
        get endRow() {
            return this.h;
        }
        set endRow(a) {
            this.h = a;
            this.e("EndRow");
        }
    }
    CellRangeDescription.$t = /*@__PURE__*/ markType(CellRangeDescription, 'CellRangeDescription', Description.$);
    CellRangeDescription.__marshalByValue = true;
    CellRangeDescription.__marshalByValueAlias = "CellRange";
    return CellRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellRangeDescriptionMetadata extends Base {
        static b(a) {
            if (CellRangeDescriptionMetadata.a == null) {
                CellRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellRangeDescriptionMetadata.c(a, CellRangeDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("StartColumn", "Number:int");
            b.item("EndColumn", "Number:int");
            b.item("StartRow", "Number:int");
            b.item("EndRow", "Number:int");
        }
        static d(a) {
            CellRangeDescriptionMetadata.b(a);
            a.q("CellRange", () => new CellRangeDescription());
            a.p("CellRange", CellRangeDescriptionMetadata.a);
        }
    }
    CellRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(CellRangeDescriptionMetadata, 'CellRangeDescriptionMetadata');
    CellRangeDescriptionMetadata.a = null;
    return CellRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellRangeDescriptionModule = /*@__PURE__*/ (() => {
    class CellRangeDescriptionModule extends Base {
        static register(a) {
            CellRangeDescriptionMetadata.d(a);
        }
    }
    CellRangeDescriptionModule.$t = /*@__PURE__*/ markType(CellRangeDescriptionModule, 'CellRangeDescriptionModule');
    return CellRangeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxDescription = /*@__PURE__*/ (() => {
    class CheckboxDescription extends Description {
        constructor() {
            super();
            this.ao = null;
            this.ay = null;
            this.ak = null;
            this.aq = null;
            this.ax = null;
            this.aj = null;
            this.az = null;
            this.ar = null;
            this.al = null;
            this.ai = null;
            this.u = 0;
            this.r = 0;
            this.v = 0;
            this.w = 0;
            this.t = 0;
            this.s = 0;
            this.ah = null;
            this.at = null;
            this.as = null;
            this.au = null;
            this.aw = null;
            this.ae = 0;
            this.ad = 0;
            this.an = null;
            this.am = null;
            this.a0 = null;
            this.j = false;
            this.av = null;
            this.h = false;
            this.f = false;
            this.k = false;
            this.g = false;
            this.i = false;
            this.ap = null;
        }
        get_type() {
            return "Checkbox";
        }
        get type() {
            return this.get_type();
        }
        get baseTheme() {
            return this.ao;
        }
        set baseTheme(a) {
            this.ao = a;
            this.e("BaseTheme");
        }
        get uncheckedBackgroundColor() {
            return this.ay;
        }
        set uncheckedBackgroundColor(a) {
            this.ay = a;
            this.e("UncheckedBackgroundColor");
        }
        get actualUncheckedBackgroundColor() {
            return this.ak;
        }
        set actualUncheckedBackgroundColor(a) {
            this.ak = a;
            this.e("ActualUncheckedBackgroundColor");
        }
        get checkedBackgroundColor() {
            return this.aq;
        }
        set checkedBackgroundColor(a) {
            this.aq = a;
            this.e("CheckedBackgroundColor");
        }
        get tickColor() {
            return this.ax;
        }
        set tickColor(a) {
            this.ax = a;
            this.e("TickColor");
        }
        get actualTickColor() {
            return this.aj;
        }
        set actualTickColor(a) {
            this.aj = a;
            this.e("ActualTickColor");
        }
        get uncheckedBorderColor() {
            return this.az;
        }
        set uncheckedBorderColor(a) {
            this.az = a;
            this.e("UncheckedBorderColor");
        }
        get checkedBorderColor() {
            return this.ar;
        }
        set checkedBorderColor(a) {
            this.ar = a;
            this.e("CheckedBorderColor");
        }
        get actualUncheckedBorderColor() {
            return this.al;
        }
        set actualUncheckedBorderColor(a) {
            this.al = a;
            this.e("ActualUncheckedBorderColor");
        }
        get actualCheckedBorderColor() {
            return this.ai;
        }
        set actualCheckedBorderColor(a) {
            this.ai = a;
            this.e("ActualCheckedBorderColor");
        }
        get borderWidth() {
            return this.u;
        }
        set borderWidth(a) {
            this.u = a;
            this.e("BorderWidth");
        }
        get actualBorderWidth() {
            return this.r;
        }
        set actualBorderWidth(a) {
            this.r = a;
            this.e("ActualBorderWidth");
        }
        get cornerRadius() {
            return this.v;
        }
        set cornerRadius(a) {
            this.v = a;
            this.e("CornerRadius");
        }
        get tickStrokeWidth() {
            return this.w;
        }
        set tickStrokeWidth(a) {
            this.w = a;
            this.e("TickStrokeWidth");
        }
        get actualTickStrokeWidth() {
            return this.t;
        }
        set actualTickStrokeWidth(a) {
            this.t = a;
            this.e("ActualTickStrokeWidth");
        }
        get actualCornerRadius() {
            return this.s;
        }
        set actualCornerRadius(a) {
            this.s = a;
            this.e("ActualCornerRadius");
        }
        get actualCheckedBackgroundColor() {
            return this.ah;
        }
        set actualCheckedBackgroundColor(a) {
            this.ah = a;
            this.e("ActualCheckedBackgroundColor");
        }
        get inputId() {
            return this.at;
        }
        set inputId(a) {
            this.at = a;
            this.e("InputId");
        }
        get id() {
            return this.as;
        }
        set id(a) {
            this.as = a;
            this.e("Id");
        }
        get labelId() {
            return this.au;
        }
        set labelId(a) {
            this.au = a;
            this.e("LabelId");
        }
        get name() {
            return this.aw;
        }
        set name(a) {
            this.aw = a;
            this.e("Name");
        }
        get tabIndex() {
            return this.ae;
        }
        set tabIndex(a) {
            this.ae = a;
            this.e("TabIndex");
        }
        get required() {
            return this.ad;
        }
        set required(a) {
            this.ad = a;
            this.e("Required");
        }
        get ariaLabelledBy() {
            return this.an;
        }
        set ariaLabelledBy(a) {
            this.an = a;
            this.e("AriaLabelledBy");
        }
        get ariaLabel() {
            return this.am;
        }
        set ariaLabel(a) {
            this.am = a;
            this.e("AriaLabel");
        }
        get valueRef() {
            return this.a0;
        }
        set valueRef(a) {
            this.a0 = a;
            this.e("ValueRef");
        }
        get focused() {
            return this.j;
        }
        set focused(a) {
            this.j = a;
            this.e("Focused");
        }
        get labelPosition() {
            return this.av;
        }
        set labelPosition(a) {
            this.av = a;
            this.e("LabelPosition");
        }
        get disableRipple() {
            return this.h;
        }
        set disableRipple(a) {
            this.h = a;
            this.e("DisableRipple");
        }
        get checked() {
            return this.f;
        }
        set checked(a) {
            this.f = a;
            this.e("Checked");
        }
        get indeterminate() {
            return this.k;
        }
        set indeterminate(a) {
            this.k = a;
            this.e("Indeterminate");
        }
        get disabled() {
            return this.g;
        }
        set disabled(a) {
            this.g = a;
            this.e("Disabled");
        }
        get disableTransitions() {
            return this.i;
        }
        set disableTransitions(a) {
            this.i = a;
            this.e("DisableTransitions");
        }
        get changeRef() {
            return this.ap;
        }
        set changeRef(a) {
            this.ap = a;
            this.e("ChangeRef");
        }
    }
    CheckboxDescription.$t = /*@__PURE__*/ markType(CheckboxDescription, 'CheckboxDescription', Description.$);
    return CheckboxDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class CheckboxChangeEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = false;
            this.g = false;
        }
        get_type() {
            return "CheckboxChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get isChecked() {
            return this.f;
        }
        set isChecked(a) {
            this.f = a;
            this.e("IsChecked");
        }
        get isIndeterminate() {
            return this.g;
        }
        set isIndeterminate(a) {
            this.g = a;
            this.e("IsIndeterminate");
        }
    }
    CheckboxChangeEventArgsDescription.$t = /*@__PURE__*/ markType(CheckboxChangeEventArgsDescription, 'CheckboxChangeEventArgsDescription', Description.$);
    return CheckboxChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckboxChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CheckboxChangeEventArgsDescriptionMetadata.a == null) {
                CheckboxChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckboxChangeEventArgsDescriptionMetadata.c(a, CheckboxChangeEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsChecked", "Boolean");
            b.item("IsIndeterminate", "Boolean");
        }
        static d(a) {
            CheckboxChangeEventArgsDescriptionMetadata.b(a);
            a.q("CheckboxChangeEventArgs", () => new CheckboxChangeEventArgsDescription());
            a.p("CheckboxChangeEventArgs", CheckboxChangeEventArgsDescriptionMetadata.a);
        }
    }
    CheckboxChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckboxChangeEventArgsDescriptionMetadata, 'CheckboxChangeEventArgsDescriptionMetadata');
    CheckboxChangeEventArgsDescriptionMetadata.a = null;
    return CheckboxChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckboxDescriptionMetadata extends Base {
        static b(a) {
            if (CheckboxDescriptionMetadata.a == null) {
                CheckboxDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckboxDescriptionMetadata.c(a, CheckboxDescriptionMetadata.a);
                CheckboxChangeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("UncheckedBackgroundColor", "Brush");
            b.item("ActualUncheckedBackgroundColor", "Brush");
            b.item("CheckedBackgroundColor", "Brush");
            b.item("TickColor", "Brush");
            b.item("ActualTickColor", "Brush");
            b.item("UncheckedBorderColor", "Brush");
            b.item("CheckedBorderColor", "Brush");
            b.item("ActualUncheckedBorderColor", "Brush");
            b.item("ActualCheckedBorderColor", "Brush");
            b.item("BorderWidth", "Number:double");
            b.item("ActualBorderWidth", "Number:double");
            b.item("CornerRadius", "Number:double");
            b.item("TickStrokeWidth", "Number:double");
            b.item("ActualTickStrokeWidth", "Number:double");
            b.item("ActualCornerRadius", "Number:double");
            b.item("ActualCheckedBackgroundColor", "Brush");
            b.item("InputId", "String");
            b.item("Id", "String");
            b.item("LabelId", "String");
            b.item("Name", "String");
            b.item("TabIndex", "Number:int");
            b.item("Required", "Number:int");
            b.item("AriaLabelledBy", "String");
            b.item("AriaLabel", "String");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("Focused", "(w:IsFocused,wf:IsFocused)Boolean");
            b.item("LabelPosition", "ExportedType:string:CheckboxLabelPosition");
            b.item("LabelPosition@names", "After;Before");
            b.item("DisableRipple", "Boolean");
            b.item("Checked", "(w:IsChecked,wf:IsChecked)Boolean");
            b.item("Indeterminate", "(w:IsIndeterminate,wf:IsIndeterminate)Boolean");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
            b.item("DisableTransitions", "Boolean");
            b.item("ChangeRef", "EventRef::change");
        }
        static d(a) {
            CheckboxDescriptionMetadata.b(a);
            a.q("Checkbox", () => new CheckboxDescription());
            a.p("Checkbox", CheckboxDescriptionMetadata.a);
        }
    }
    CheckboxDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckboxDescriptionMetadata, 'CheckboxDescriptionMetadata');
    CheckboxDescriptionMetadata.a = null;
    return CheckboxDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxListDescription = /*@__PURE__*/ (() => {
    class CheckboxListDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
            this.ab = null;
            this.aa = null;
            this.aj = null;
            this.ad = null;
            this.af = null;
            this.r = 0;
            this.w = null;
            this.p = 0;
            this.x = null;
            this.y = null;
            this.ae = null;
            this.v = null;
            this.ac = null;
            this.ag = null;
            this.ah = null;
            this.t = null;
            this.l = false;
            this.u = null;
            this.ak = null;
            this.k = false;
            this.j = false;
            this.z = null;
            this.ai = null;
        }
        get_type() {
            return "CheckboxList";
        }
        get type() {
            return this.get_type();
        }
        get keys() {
            return this.f;
        }
        set keys(a) {
            this.f = a;
            this.e("Keys");
        }
        get primaryKey() {
            return this.g;
        }
        set primaryKey(a) {
            this.g = a;
            this.e("PrimaryKey");
        }
        get dataSourceRef() {
            return this.ab;
        }
        set dataSourceRef(a) {
            this.ab = a;
            this.e("DataSourceRef");
        }
        get dataMemberPath() {
            return this.aa;
        }
        set dataMemberPath(a) {
            this.aa = a;
            this.e("DataMemberPath");
        }
        get selectedMemberPath() {
            return this.aj;
        }
        set selectedMemberPath(a) {
            this.aj = a;
            this.e("SelectedMemberPath");
        }
        get filterPlaceholderText() {
            return this.ad;
        }
        set filterPlaceholderText(a) {
            this.ad = a;
            this.e("FilterPlaceholderText");
        }
        get searchInputType() {
            return this.af;
        }
        set searchInputType(a) {
            this.af = a;
            this.e("SearchInputType");
        }
        get rowHeight() {
            return this.r;
        }
        set rowHeight(a) {
            this.r = a;
            this.e("RowHeight");
        }
        get cellFontFamily() {
            return this.w;
        }
        set cellFontFamily(a) {
            this.w = a;
            this.e("CellFontFamily");
        }
        get cellFontSize() {
            return this.p;
        }
        set cellFontSize(a) {
            this.p = a;
            this.e("CellFontSize");
        }
        get cellFontStyle() {
            return this.x;
        }
        set cellFontStyle(a) {
            this.x = a;
            this.e("CellFontStyle");
        }
        get cellFontWeight() {
            return this.y;
        }
        set cellFontWeight(a) {
            this.y = a;
            this.e("CellFontWeight");
        }
        get indexType() {
            return this.ae;
        }
        set indexType(a) {
            this.ae = a;
            this.e("IndexType");
        }
        get baseTheme() {
            return this.v;
        }
        set baseTheme(a) {
            this.v = a;
            this.e("BaseTheme");
        }
        get density() {
            return this.ac;
        }
        set density(a) {
            this.ac = a;
            this.e("Density");
        }
        get selectAllCaption() {
            return this.ag;
        }
        set selectAllCaption(a) {
            this.ag = a;
            this.e("SelectAllCaption");
        }
        get selectAllCaptionTextColor() {
            return this.ah;
        }
        set selectAllCaptionTextColor(a) {
            this.ah = a;
            this.e("SelectAllCaptionTextColor");
        }
        get actualSelectAllCaptionTextColor() {
            return this.t;
        }
        set actualSelectAllCaptionTextColor(a) {
            this.t = a;
            this.e("ActualSelectAllCaptionTextColor");
        }
        get showSelectAll() {
            return this.l;
        }
        set showSelectAll(a) {
            this.l = a;
            this.e("ShowSelectAll");
        }
        get backgroundColor() {
            return this.u;
        }
        set backgroundColor(a) {
            this.u = a;
            this.e("BackgroundColor");
        }
        get textColor() {
            return this.ak;
        }
        set textColor(a) {
            this.ak = a;
            this.e("TextColor");
        }
        get showFilter() {
            return this.k;
        }
        set showFilter(a) {
            this.k = a;
            this.e("ShowFilter");
        }
        get isRowHoverEnabled() {
            return this.j;
        }
        set isRowHoverEnabled(a) {
            this.j = a;
            this.e("IsRowHoverEnabled");
        }
        get checkedChangedRef() {
            return this.z;
        }
        set checkedChangedRef(a) {
            this.z = a;
            this.e("CheckedChangedRef");
        }
        get selectAllCheckboxChangedRef() {
            return this.ai;
        }
        set selectAllCheckboxChangedRef(a) {
            this.ai = a;
            this.e("SelectAllCheckboxChangedRef");
        }
    }
    CheckboxListDescription.$t = /*@__PURE__*/ markType(CheckboxListDescription, 'CheckboxListDescription', Description.$);
    return CheckboxListDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckedChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class CheckedChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = 0;
            this.f = false;
        }
        get_type() {
            return "CheckedChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get index() {
            return this.h;
        }
        set index(a) {
            this.h = a;
            this.e("Index");
        }
        get isChecked() {
            return this.f;
        }
        set isChecked(a) {
            this.f = a;
            this.e("IsChecked");
        }
    }
    CheckedChangedEventArgsDescription.$t = /*@__PURE__*/ markType(CheckedChangedEventArgsDescription, 'CheckedChangedEventArgsDescription', Description.$);
    return CheckedChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckedChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckedChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CheckedChangedEventArgsDescriptionMetadata.a == null) {
                CheckedChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckedChangedEventArgsDescriptionMetadata.c(a, CheckedChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Index", "Number:int");
            b.item("IsChecked", "Boolean");
        }
        static d(a) {
            CheckedChangedEventArgsDescriptionMetadata.b(a);
            a.q("CheckedChangedEventArgs", () => new CheckedChangedEventArgsDescription());
            a.p("CheckedChangedEventArgs", CheckedChangedEventArgsDescriptionMetadata.a);
        }
    }
    CheckedChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckedChangedEventArgsDescriptionMetadata, 'CheckedChangedEventArgsDescriptionMetadata');
    CheckedChangedEventArgsDescriptionMetadata.a = null;
    return CheckedChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectAllCheckboxChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectAllCheckboxChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = false;
        }
        get_type() {
            return "SelectAllCheckboxChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get isChecked() {
            return this.f;
        }
        set isChecked(a) {
            this.f = a;
            this.e("IsChecked");
        }
    }
    SelectAllCheckboxChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectAllCheckboxChangedEventArgsDescription, 'SelectAllCheckboxChangedEventArgsDescription', Description.$);
    return SelectAllCheckboxChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectAllCheckboxChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectAllCheckboxChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectAllCheckboxChangedEventArgsDescriptionMetadata.a == null) {
                SelectAllCheckboxChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectAllCheckboxChangedEventArgsDescriptionMetadata.c(a, SelectAllCheckboxChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsChecked", "Boolean");
        }
        static d(a) {
            SelectAllCheckboxChangedEventArgsDescriptionMetadata.b(a);
            a.q("SelectAllCheckboxChangedEventArgs", () => new SelectAllCheckboxChangedEventArgsDescription());
            a.p("SelectAllCheckboxChangedEventArgs", SelectAllCheckboxChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectAllCheckboxChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectAllCheckboxChangedEventArgsDescriptionMetadata, 'SelectAllCheckboxChangedEventArgsDescriptionMetadata');
    SelectAllCheckboxChangedEventArgsDescriptionMetadata.a = null;
    return SelectAllCheckboxChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxListDescriptionMetadata = /*@__PURE__*/ (() => {
    class CheckboxListDescriptionMetadata extends Base {
        static b(a) {
            if (CheckboxListDescriptionMetadata.a == null) {
                CheckboxListDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CheckboxListDescriptionMetadata.c(a, CheckboxListDescriptionMetadata.a);
                CheckedChangedEventArgsDescriptionMetadata.d(a);
                SelectAllCheckboxChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Keys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            b.item("PrimaryKey", "Array:string");
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("DataMemberPath", "String");
            b.item("SelectedMemberPath", "String");
            b.item("FilterPlaceholderText", "String");
            b.item("SearchInputType", "ExportedType:string:InputGroupDisplayType");
            b.item("SearchInputType@names", "Line;Box;Border;Search");
            b.item("RowHeight", "Number:int");
            b.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            b.item("CellFontSize", "(w:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            b.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            b.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            b.item("IndexType", "ExportedType:string:CheckboxListIndexType");
            b.item("IndexType@names", "Selected;DeSelected");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("SelectAllCaption", "String");
            b.item("SelectAllCaptionTextColor", "Brush");
            b.item("ActualSelectAllCaptionTextColor", "Brush");
            b.item("ShowSelectAll", "Boolean");
            b.item("BackgroundColor", "Brush");
            b.item("TextColor", "Brush");
            b.item("ShowFilter", "Boolean");
            b.item("IsRowHoverEnabled", "Boolean");
            b.item("CheckedChangedRef", "EventRef::checkedChanged");
            b.item("SelectAllCheckboxChangedRef", "EventRef::selectAllCheckboxChanged");
        }
        static d(a) {
            CheckboxListDescriptionMetadata.b(a);
            a.q("CheckboxList", () => new CheckboxListDescription());
            a.p("CheckboxList", CheckboxListDescriptionMetadata.a);
        }
    }
    CheckboxListDescriptionMetadata.$t = /*@__PURE__*/ markType(CheckboxListDescriptionMetadata, 'CheckboxListDescriptionMetadata');
    CheckboxListDescriptionMetadata.a = null;
    return CheckboxListDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataBindingEventArgsDescription = /*@__PURE__*/ (() => {
    class DataBindingEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "DataBindingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get resolvedValueRef() {
            return this.f;
        }
        set resolvedValueRef(a) {
            this.f = a;
            this.e("ResolvedValueRef");
        }
        get rowObjectRef() {
            return this.g;
        }
        set rowObjectRef(a) {
            this.g = a;
            this.e("RowObjectRef");
        }
    }
    DataBindingEventArgsDescription.$t = /*@__PURE__*/ markType(DataBindingEventArgsDescription, 'DataBindingEventArgsDescription', Description.$);
    return DataBindingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataBindingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataBindingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataBindingEventArgsDescriptionMetadata.a == null) {
                DataBindingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataBindingEventArgsDescriptionMetadata.c(a, DataBindingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ResolvedValueRef", "(w:ResolvedValue,wf:ResolvedValue)DataRef");
            b.item("RowObjectRef", "(w:RowObject,wf:RowObject)DataRef");
        }
        static d(a) {
            DataBindingEventArgsDescriptionMetadata.b(a);
            a.q("DataBindingEventArgs", () => new DataBindingEventArgsDescription());
            a.p("DataBindingEventArgs", DataBindingEventArgsDescriptionMetadata.a);
        }
    }
    DataBindingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataBindingEventArgsDescriptionMetadata, 'DataBindingEventArgsDescriptionMetadata');
    DataBindingEventArgsDescriptionMetadata.a = null;
    return DataBindingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellStyleRequestedEventArgsDescription = /*@__PURE__*/ (() => {
    class CellStyleRequestedEventArgsDescription extends Description {
        constructor() {
            super();
            this.i = null;
            this.h = null;
            this.f = 0;
        }
        get_type() {
            return "CellStyleRequestedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get styleKey() {
            return this.i;
        }
        set styleKey(a) {
            this.i = a;
            this.e("StyleKey");
        }
        get resolvedValueRef() {
            return this.h;
        }
        set resolvedValueRef(a) {
            this.h = a;
            this.e("ResolvedValueRef");
        }
        get rowNumber() {
            return this.f;
        }
        set rowNumber(a) {
            this.f = a;
            this.e("RowNumber");
        }
    }
    CellStyleRequestedEventArgsDescription.$t = /*@__PURE__*/ markType(CellStyleRequestedEventArgsDescription, 'CellStyleRequestedEventArgsDescription', Description.$);
    return CellStyleRequestedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellStyleRequestedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellStyleRequestedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CellStyleRequestedEventArgsDescriptionMetadata.a == null) {
                CellStyleRequestedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellStyleRequestedEventArgsDescriptionMetadata.c(a, CellStyleRequestedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("StyleKey", "String");
            b.item("ResolvedValueRef", "(w:ResolvedValue,wf:ResolvedValue)DataRef");
            b.item("RowNumber", "Number:int");
        }
        static d(a) {
            CellStyleRequestedEventArgsDescriptionMetadata.b(a);
            a.q("CellStyleRequestedEventArgs", () => new CellStyleRequestedEventArgsDescription());
            a.p("CellStyleRequestedEventArgs", CellStyleRequestedEventArgsDescriptionMetadata.a);
        }
    }
    CellStyleRequestedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CellStyleRequestedEventArgsDescriptionMetadata, 'CellStyleRequestedEventArgsDescriptionMetadata');
    CellStyleRequestedEventArgsDescriptionMetadata.a = null;
    return CellStyleRequestedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefinitionBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class DefinitionBaseDescriptionMetadata extends Base {
        static b(a) {
            if (DefinitionBaseDescriptionMetadata.a == null) {
                DefinitionBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DefinitionBaseDescriptionMetadata.c(a, DefinitionBaseDescriptionMetadata.a);
                DataBindingEventArgsDescriptionMetadata.d(a);
                CellStyleRequestedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Background", "Brush");
            b.item("Border", "Brush");
            b.item("ActivationBorder", "Brush");
            b.item("ErrorBorder", "Brush");
            b.item("ActualBorder", "Brush");
            b.item("BorderLeftWidth", "Number:int");
            b.item("BorderTopWidth", "Number:int");
            b.item("BorderRightWidth", "Number:int");
            b.item("BorderBottomWidth", "Number:int");
            b.item("ActivationBorderLeftWidth", "Number:int");
            b.item("ActivationBorderTopWidth", "Number:int");
            b.item("ActivationBorderRightWidth", "Number:int");
            b.item("ActivationBorderBottomWidth", "Number:int");
            b.item("ErrorBorderLeftWidth", "Number:int");
            b.item("ErrorBorderTopWidth", "Number:int");
            b.item("ErrorBorderRightWidth", "Number:int");
            b.item("ErrorBorderBottomWidth", "Number:int");
            b.item("ActualBackground", "Brush");
            b.item("ActualActivationBorder", "Brush");
            b.item("ActualErrorBorder", "Brush");
            b.item("StickyRowBackground", "Brush");
            b.item("ActualStickyRowBackground", "Brush");
            b.item("PinnedRowBackground", "Brush");
            b.item("ActualPinnedRowBackground", "Brush");
            b.item("LastStickyRowBackground", "Brush");
            b.item("ActualLastStickyRowBackground", "Brush");
            b.item("ContentOpacity", "Number:double");
            b.item("HorizontalAlignment", "ExportedType:string:CellContentHorizontalAlignment");
            b.item("HorizontalAlignment@names", "Left;Center;Right;Stretch;Auto");
            b.item("VerticalAlignment", "ExportedType:string:CellContentVerticalAlignment");
            b.item("VerticalAlignment@names", "Top;Center;Bottom;Stretch;Auto");
            b.item("LineBreakMode", "ExportedType:string:TextCellLineBreakMode");
            b.item("LineBreakMode@names", "Ellipsis;NoWrap;WordWrap;CharacterWrap");
            b.item("ActualLineBreakMode", "ExportedType:string:TextCellLineBreakMode");
            b.item("ActualLineBreakMode@names", "Ellipsis;NoWrap;WordWrap;CharacterWrap");
            b.item("TextColor", "Brush");
            b.item("ActualTextColor", "Brush");
            b.item("PinnedRowOpacity", "Number:double");
            b.item("ActualPinnedRowOpacity", "Number:double");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("DataBindingRef", "EventRef::dataBinding");
            b.item("DataBoundRef", "EventRef::dataBound");
            b.item("CellStyleKeyRequestedRef", "EventRef::cellStyleKeyRequested");
        }
        static d(a) {
            DefinitionBaseDescriptionMetadata.b(a);
            a.p("DefinitionBase", DefinitionBaseDescriptionMetadata.a);
        }
    }
    DefinitionBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(DefinitionBaseDescriptionMetadata, 'DefinitionBaseDescriptionMetadata');
    DefinitionBaseDescriptionMetadata.a = null;
    return DefinitionBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeaderDescriptionMetadata extends Base {
        static b(a) {
            if (HeaderDescriptionMetadata.a == null) {
                HeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeaderDescriptionMetadata.c(a, HeaderDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
            b.item("SortIndicatorColor", "Brush");
            b.item("ActualSortIndicatorColor", "Brush");
            b.item("SortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            b.item("SortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            b.item("ActualSortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            b.item("ActualSortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            b.item("PaddingLeft", "Number:int");
            b.item("PaddingTop", "Number:int");
            b.item("PaddingRight", "Number:int");
            b.item("PaddingBottom", "Number:int");
        }
        static d(a) {
            HeaderDescriptionMetadata.b(a);
            a.p("Header", HeaderDescriptionMetadata.a);
        }
    }
    HeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(HeaderDescriptionMetadata, 'HeaderDescriptionMetadata');
    HeaderDescriptionMetadata.a = null;
    return HeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DefinitionBaseDescription = /*@__PURE__*/ (() => {
    class DefinitionBaseDescription extends Description {
        constructor() {
            super();
            this.av = null;
            this.aw = null;
            this.al = null;
            this.a0 = null;
            this.ao = null;
            this.s = 0;
            this.u = 0;
            this.t = 0;
            this.r = 0;
            this.o = 0;
            this.q = 0;
            this.p = 0;
            this.n = 0;
            this.w = 0;
            this.y = 0;
            this.x = 0;
            this.v = 0;
            this.an = null;
            this.am = null;
            this.ap = null;
            this.a8 = null;
            this.at = null;
            this.a7 = null;
            this.as = null;
            this.a5 = null;
            this.aq = null;
            this.g = 0;
            this.a4 = null;
            this.ba = null;
            this.a6 = null;
            this.ar = null;
            this.a9 = null;
            this.au = null;
            this.i = 0;
            this.f = 0;
            this.a1 = null;
            this.h = 0;
            this.a2 = null;
            this.a3 = null;
            this.ay = null;
            this.az = null;
            this.ax = null;
        }
        get_type() {
            return "DefinitionBase";
        }
        get type() {
            return this.get_type();
        }
        get background() {
            return this.av;
        }
        set background(a) {
            this.av = a;
            this.e("Background");
        }
        get border() {
            return this.aw;
        }
        set border(a) {
            this.aw = a;
            this.e("Border");
        }
        get activationBorder() {
            return this.al;
        }
        set activationBorder(a) {
            this.al = a;
            this.e("ActivationBorder");
        }
        get errorBorder() {
            return this.a0;
        }
        set errorBorder(a) {
            this.a0 = a;
            this.e("ErrorBorder");
        }
        get actualBorder() {
            return this.ao;
        }
        set actualBorder(a) {
            this.ao = a;
            this.e("ActualBorder");
        }
        get borderLeftWidth() {
            return this.s;
        }
        set borderLeftWidth(a) {
            this.s = a;
            this.e("BorderLeftWidth");
        }
        get borderTopWidth() {
            return this.u;
        }
        set borderTopWidth(a) {
            this.u = a;
            this.e("BorderTopWidth");
        }
        get borderRightWidth() {
            return this.t;
        }
        set borderRightWidth(a) {
            this.t = a;
            this.e("BorderRightWidth");
        }
        get borderBottomWidth() {
            return this.r;
        }
        set borderBottomWidth(a) {
            this.r = a;
            this.e("BorderBottomWidth");
        }
        get activationBorderLeftWidth() {
            return this.o;
        }
        set activationBorderLeftWidth(a) {
            this.o = a;
            this.e("ActivationBorderLeftWidth");
        }
        get activationBorderTopWidth() {
            return this.q;
        }
        set activationBorderTopWidth(a) {
            this.q = a;
            this.e("ActivationBorderTopWidth");
        }
        get activationBorderRightWidth() {
            return this.p;
        }
        set activationBorderRightWidth(a) {
            this.p = a;
            this.e("ActivationBorderRightWidth");
        }
        get activationBorderBottomWidth() {
            return this.n;
        }
        set activationBorderBottomWidth(a) {
            this.n = a;
            this.e("ActivationBorderBottomWidth");
        }
        get errorBorderLeftWidth() {
            return this.w;
        }
        set errorBorderLeftWidth(a) {
            this.w = a;
            this.e("ErrorBorderLeftWidth");
        }
        get errorBorderTopWidth() {
            return this.y;
        }
        set errorBorderTopWidth(a) {
            this.y = a;
            this.e("ErrorBorderTopWidth");
        }
        get errorBorderRightWidth() {
            return this.x;
        }
        set errorBorderRightWidth(a) {
            this.x = a;
            this.e("ErrorBorderRightWidth");
        }
        get errorBorderBottomWidth() {
            return this.v;
        }
        set errorBorderBottomWidth(a) {
            this.v = a;
            this.e("ErrorBorderBottomWidth");
        }
        get actualBackground() {
            return this.an;
        }
        set actualBackground(a) {
            this.an = a;
            this.e("ActualBackground");
        }
        get actualActivationBorder() {
            return this.am;
        }
        set actualActivationBorder(a) {
            this.am = a;
            this.e("ActualActivationBorder");
        }
        get actualErrorBorder() {
            return this.ap;
        }
        set actualErrorBorder(a) {
            this.ap = a;
            this.e("ActualErrorBorder");
        }
        get stickyRowBackground() {
            return this.a8;
        }
        set stickyRowBackground(a) {
            this.a8 = a;
            this.e("StickyRowBackground");
        }
        get actualStickyRowBackground() {
            return this.at;
        }
        set actualStickyRowBackground(a) {
            this.at = a;
            this.e("ActualStickyRowBackground");
        }
        get pinnedRowBackground() {
            return this.a7;
        }
        set pinnedRowBackground(a) {
            this.a7 = a;
            this.e("PinnedRowBackground");
        }
        get actualPinnedRowBackground() {
            return this.as;
        }
        set actualPinnedRowBackground(a) {
            this.as = a;
            this.e("ActualPinnedRowBackground");
        }
        get lastStickyRowBackground() {
            return this.a5;
        }
        set lastStickyRowBackground(a) {
            this.a5 = a;
            this.e("LastStickyRowBackground");
        }
        get actualLastStickyRowBackground() {
            return this.aq;
        }
        set actualLastStickyRowBackground(a) {
            this.aq = a;
            this.e("ActualLastStickyRowBackground");
        }
        get contentOpacity() {
            return this.g;
        }
        set contentOpacity(a) {
            this.g = a;
            this.e("ContentOpacity");
        }
        get horizontalAlignment() {
            return this.a4;
        }
        set horizontalAlignment(a) {
            this.a4 = a;
            this.e("HorizontalAlignment");
        }
        get verticalAlignment() {
            return this.ba;
        }
        set verticalAlignment(a) {
            this.ba = a;
            this.e("VerticalAlignment");
        }
        get lineBreakMode() {
            return this.a6;
        }
        set lineBreakMode(a) {
            this.a6 = a;
            this.e("LineBreakMode");
        }
        get actualLineBreakMode() {
            return this.ar;
        }
        set actualLineBreakMode(a) {
            this.ar = a;
            this.e("ActualLineBreakMode");
        }
        get textColor() {
            return this.a9;
        }
        set textColor(a) {
            this.a9 = a;
            this.e("TextColor");
        }
        get actualTextColor() {
            return this.au;
        }
        set actualTextColor(a) {
            this.au = a;
            this.e("ActualTextColor");
        }
        get pinnedRowOpacity() {
            return this.i;
        }
        set pinnedRowOpacity(a) {
            this.i = a;
            this.e("PinnedRowOpacity");
        }
        get actualPinnedRowOpacity() {
            return this.f;
        }
        set actualPinnedRowOpacity(a) {
            this.f = a;
            this.e("ActualPinnedRowOpacity");
        }
        get fontFamily() {
            return this.a1;
        }
        set fontFamily(a) {
            this.a1 = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.h;
        }
        set fontSize(a) {
            this.h = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.a2;
        }
        set fontStyle(a) {
            this.a2 = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.a3;
        }
        set fontWeight(a) {
            this.a3 = a;
            this.e("FontWeight");
        }
        get dataBindingRef() {
            return this.ay;
        }
        set dataBindingRef(a) {
            this.ay = a;
            this.e("DataBindingRef");
        }
        get dataBoundRef() {
            return this.az;
        }
        set dataBoundRef(a) {
            this.az = a;
            this.e("DataBoundRef");
        }
        get cellStyleKeyRequestedRef() {
            return this.ax;
        }
        set cellStyleKeyRequestedRef(a) {
            this.ax = a;
            this.e("CellStyleKeyRequestedRef");
        }
    }
    DefinitionBaseDescription.$t = /*@__PURE__*/ markType(DefinitionBaseDescription, 'DefinitionBaseDescription', Description.$);
    return DefinitionBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderDescription = /*@__PURE__*/ (() => {
    class HeaderDescription extends DefinitionBaseDescription {
        constructor() {
            super();
            this.cd = null;
            this.cb = null;
            this.ce = null;
            this.cc = null;
            this.b4 = 0;
            this.b6 = 0;
            this.b5 = 0;
            this.b3 = 0;
        }
        get_type() {
            return "Header";
        }
        get sortIndicatorColor() {
            return this.cd;
        }
        set sortIndicatorColor(a) {
            this.cd = a;
            this.e("SortIndicatorColor");
        }
        get actualSortIndicatorColor() {
            return this.cb;
        }
        set actualSortIndicatorColor(a) {
            this.cb = a;
            this.e("ActualSortIndicatorColor");
        }
        get sortIndicatorStyle() {
            return this.ce;
        }
        set sortIndicatorStyle(a) {
            this.ce = a;
            this.e("SortIndicatorStyle");
        }
        get actualSortIndicatorStyle() {
            return this.cc;
        }
        set actualSortIndicatorStyle(a) {
            this.cc = a;
            this.e("ActualSortIndicatorStyle");
        }
        get paddingLeft() {
            return this.b4;
        }
        set paddingLeft(a) {
            this.b4 = a;
            this.e("PaddingLeft");
        }
        get paddingTop() {
            return this.b6;
        }
        set paddingTop(a) {
            this.b6 = a;
            this.e("PaddingTop");
        }
        get paddingRight() {
            return this.b5;
        }
        set paddingRight(a) {
            this.b5 = a;
            this.e("PaddingRight");
        }
        get paddingBottom() {
            return this.b3;
        }
        set paddingBottom(a) {
            this.b3 = a;
            this.e("PaddingBottom");
        }
    }
    HeaderDescription.$t = /*@__PURE__*/ markType(HeaderDescription, 'HeaderDescription', DefinitionBaseDescription.$);
    HeaderDescription.__canMarshalByValue = true;
    return HeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderDescription = /*@__PURE__*/ (() => {
    class TextHeaderDescription extends HeaderDescription {
        constructor() {
            super();
        }
        get_type() {
            return "TextHeader";
        }
    }
    TextHeaderDescription.$t = /*@__PURE__*/ markType(TextHeaderDescription, 'TextHeaderDescription', HeaderDescription.$);
    TextHeaderDescription.__canMarshalByValue1 = true;
    return TextHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (TextHeaderDescriptionMetadata.a == null) {
                TextHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextHeaderDescriptionMetadata.c(a, TextHeaderDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HeaderDescriptionMetadata.c(a, b);
        }
        static d(a) {
            TextHeaderDescriptionMetadata.b(a);
            a.q("TextHeader", () => new TextHeaderDescription());
            a.p("TextHeader", TextHeaderDescriptionMetadata.a);
        }
    }
    TextHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(TextHeaderDescriptionMetadata, 'TextHeaderDescriptionMetadata');
    TextHeaderDescriptionMetadata.a = null;
    return TextHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class TextHeaderDescriptionModule extends Base {
        static register(a) {
            TextHeaderDescriptionMetadata.d(a);
        }
    }
    TextHeaderDescriptionModule.$t = /*@__PURE__*/ markType(TextHeaderDescriptionModule, 'TextHeaderDescriptionModule');
    return TextHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderDescription = /*@__PURE__*/ (() => {
    class SectionHeaderDescription extends DefinitionBaseDescription {
        constructor() {
            super();
            this.cd = null;
            this.cc = null;
            this.b5 = 0;
            this.b7 = 0;
            this.b6 = 0;
            this.b4 = 0;
            this.b2 = false;
            this.ce = null;
        }
        get_type() {
            return "SectionHeader";
        }
        get selectedBackground() {
            return this.cd;
        }
        set selectedBackground(a) {
            this.cd = a;
            this.e("SelectedBackground");
        }
        get actualSelectedBackground() {
            return this.cc;
        }
        set actualSelectedBackground(a) {
            this.cc = a;
            this.e("ActualSelectedBackground");
        }
        get paddingLeft() {
            return this.b5;
        }
        set paddingLeft(a) {
            this.b5 = a;
            this.e("PaddingLeft");
        }
        get paddingTop() {
            return this.b7;
        }
        set paddingTop(a) {
            this.b7 = a;
            this.e("PaddingTop");
        }
        get paddingRight() {
            return this.b6;
        }
        set paddingRight(a) {
            this.b6 = a;
            this.e("PaddingRight");
        }
        get paddingBottom() {
            return this.b4;
        }
        set paddingBottom(a) {
            this.b4 = a;
            this.e("PaddingBottom");
        }
        get isCollapsable() {
            return this.b2;
        }
        set isCollapsable(a) {
            this.b2 = a;
            this.e("IsCollapsable");
        }
        get summaryDisplayMode() {
            return this.ce;
        }
        set summaryDisplayMode(a) {
            this.ce = a;
            this.e("SummaryDisplayMode");
        }
    }
    SectionHeaderDescription.$t = /*@__PURE__*/ markType(SectionHeaderDescription, 'SectionHeaderDescription', DefinitionBaseDescription.$);
    return SectionHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (SectionHeaderDescriptionMetadata.a == null) {
                SectionHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionHeaderDescriptionMetadata.c(a, SectionHeaderDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
            b.item("SelectedBackground", "Brush");
            b.item("ActualSelectedBackground", "Brush");
            b.item("PaddingLeft", "Number:int");
            b.item("PaddingTop", "Number:int");
            b.item("PaddingRight", "Number:int");
            b.item("PaddingBottom", "Number:int");
            b.item("IsCollapsable", "Boolean");
            b.item("SummaryDisplayMode", "ExportedType:string:GroupSummaryDisplayMode");
            b.item("SummaryDisplayMode@names", "List;Cells;RowTop;RowBottom;None");
        }
        static d(a) {
            SectionHeaderDescriptionMetadata.b(a);
            a.q("SectionHeader", () => new SectionHeaderDescription());
            a.p("SectionHeader", SectionHeaderDescriptionMetadata.a);
        }
    }
    SectionHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionHeaderDescriptionMetadata, 'SectionHeaderDescriptionMetadata');
    SectionHeaderDescriptionMetadata.a = null;
    return SectionHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class SectionHeaderDescriptionModule extends Base {
        static register(a) {
            SectionHeaderDescriptionMetadata.d(a);
        }
    }
    SectionHeaderDescriptionModule.$t = /*@__PURE__*/ markType(SectionHeaderDescriptionModule, 'SectionHeaderDescriptionModule');
    return SectionHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorDescription = /*@__PURE__*/ (() => {
    class RowSeparatorDescription extends DefinitionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "RowSeparator";
        }
    }
    RowSeparatorDescription.$t = /*@__PURE__*/ markType(RowSeparatorDescription, 'RowSeparatorDescription', DefinitionBaseDescription.$);
    return RowSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class RowSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (RowSeparatorDescriptionMetadata.a == null) {
                RowSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RowSeparatorDescriptionMetadata.c(a, RowSeparatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            RowSeparatorDescriptionMetadata.b(a);
            a.q("RowSeparator", () => new RowSeparatorDescription());
            a.p("RowSeparator", RowSeparatorDescriptionMetadata.a);
        }
    }
    RowSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(RowSeparatorDescriptionMetadata, 'RowSeparatorDescriptionMetadata');
    RowSeparatorDescriptionMetadata.a = null;
    return RowSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class RowSeparatorDescriptionModule extends Base {
        static register(a) {
            RowSeparatorDescriptionMetadata.d(a);
        }
    }
    RowSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(RowSeparatorDescriptionModule, 'RowSeparatorDescriptionModule');
    return RowSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderSeparatorDescription = /*@__PURE__*/ (() => {
    class HeaderSeparatorDescription extends DefinitionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "HeaderSeparator";
        }
    }
    HeaderSeparatorDescription.$t = /*@__PURE__*/ markType(HeaderSeparatorDescription, 'HeaderSeparatorDescription', DefinitionBaseDescription.$);
    return HeaderSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeaderSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (HeaderSeparatorDescriptionMetadata.a == null) {
                HeaderSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeaderSeparatorDescriptionMetadata.c(a, HeaderSeparatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            HeaderSeparatorDescriptionMetadata.b(a);
            a.q("HeaderSeparator", () => new HeaderSeparatorDescription());
            a.p("HeaderSeparator", HeaderSeparatorDescriptionMetadata.a);
        }
    }
    HeaderSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(HeaderSeparatorDescriptionMetadata, 'HeaderSeparatorDescriptionMetadata');
    HeaderSeparatorDescriptionMetadata.a = null;
    return HeaderSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class HeaderSeparatorDescriptionModule extends Base {
        static register(a) {
            HeaderSeparatorDescriptionMetadata.d(a);
        }
    }
    HeaderSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(HeaderSeparatorDescriptionModule, 'HeaderSeparatorDescriptionModule');
    return HeaderSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnResizingSeparatorDescription = /*@__PURE__*/ (() => {
    class ColumnResizingSeparatorDescription extends DefinitionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "ColumnResizingSeparator";
        }
    }
    ColumnResizingSeparatorDescription.$t = /*@__PURE__*/ markType(ColumnResizingSeparatorDescription, 'ColumnResizingSeparatorDescription', DefinitionBaseDescription.$);
    return ColumnResizingSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnResizingSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnResizingSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnResizingSeparatorDescriptionMetadata.a == null) {
                ColumnResizingSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnResizingSeparatorDescriptionMetadata.c(a, ColumnResizingSeparatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            ColumnResizingSeparatorDescriptionMetadata.b(a);
            a.q("ColumnResizingSeparator", () => new ColumnResizingSeparatorDescription());
            a.p("ColumnResizingSeparator", ColumnResizingSeparatorDescriptionMetadata.a);
        }
    }
    ColumnResizingSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnResizingSeparatorDescriptionMetadata, 'ColumnResizingSeparatorDescriptionMetadata');
    ColumnResizingSeparatorDescriptionMetadata.a = null;
    return ColumnResizingSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnResizingSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnResizingSeparatorDescriptionModule extends Base {
        static register(a) {
            ColumnResizingSeparatorDescriptionMetadata.d(a);
        }
    }
    ColumnResizingSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(ColumnResizingSeparatorDescriptionModule, 'ColumnResizingSeparatorDescriptionModule');
    return ColumnResizingSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnMovingSeparatorDescription = /*@__PURE__*/ (() => {
    class ColumnMovingSeparatorDescription extends DefinitionBaseDescription {
        constructor() {
            super();
            this.b2 = 0;
        }
        get_type() {
            return "ColumnMovingSeparator";
        }
        get separatorWidth() {
            return this.b2;
        }
        set separatorWidth(a) {
            this.b2 = a;
            this.e("SeparatorWidth");
        }
    }
    ColumnMovingSeparatorDescription.$t = /*@__PURE__*/ markType(ColumnMovingSeparatorDescription, 'ColumnMovingSeparatorDescription', DefinitionBaseDescription.$);
    return ColumnMovingSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnMovingSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnMovingSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnMovingSeparatorDescriptionMetadata.a == null) {
                ColumnMovingSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnMovingSeparatorDescriptionMetadata.c(a, ColumnMovingSeparatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
            b.item("SeparatorWidth", "Number:int");
        }
        static d(a) {
            ColumnMovingSeparatorDescriptionMetadata.b(a);
            a.q("ColumnMovingSeparator", () => new ColumnMovingSeparatorDescription());
            a.p("ColumnMovingSeparator", ColumnMovingSeparatorDescriptionMetadata.a);
        }
    }
    ColumnMovingSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnMovingSeparatorDescriptionMetadata, 'ColumnMovingSeparatorDescriptionMetadata');
    ColumnMovingSeparatorDescriptionMetadata.a = null;
    return ColumnMovingSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnMovingSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnMovingSeparatorDescriptionModule extends Base {
        static register(a) {
            ColumnMovingSeparatorDescriptionMetadata.d(a);
        }
    }
    ColumnMovingSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(ColumnMovingSeparatorDescriptionModule, 'ColumnMovingSeparatorDescriptionModule');
    return ColumnMovingSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryRowDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryRowDescriptionMetadata.a == null) {
                SummaryRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryRowDescriptionMetadata.c(a, SummaryRowDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
            b.item("SelectedBackground", "Brush");
            b.item("ActualSelectedBackground", "Brush");
            b.item("SummaryLabelTextColor", "Brush");
            b.item("ActualSummaryLabelTextColor", "Brush");
            b.item("SummaryLabelFontFamily", "(w:SummaryLabelFontFamily/FontFamilyTransform,wf:SummaryLabelFontFamily,web:summaryNameTextStyle/FontFamilyTransform)String");
            b.item("SummaryLabelFontSize", "(w:SummaryLabelFontSize,wf:SummaryLabelFontSize,web:summaryNameTextStyle/FontSizeTransform)Number:double");
            b.item("SummaryLabelFontStyle", "(w:SummaryLabelFontStyle/FontStyleTransform,wf:SummaryLabelFontFamily/FontStyleTransform,web:summaryNameTextStyle/FontStyleTransform)String");
            b.item("SummaryLabelFontWeight", "(w:SummaryLabelFontWeight/FontWeightTransform,wf:SummaryLabelFontFamily/FontWeightTransform,web:summaryNameTextStyle/FontWeightTransform)String");
            b.item("PaddingLeft", "Number:int");
            b.item("PaddingTop", "Number:int");
            b.item("PaddingRight", "Number:int");
            b.item("PaddingBottom", "Number:int");
        }
        static d(a) {
            SummaryRowDescriptionMetadata.b(a);
            a.p("SummaryRow", SummaryRowDescriptionMetadata.a);
        }
    }
    SummaryRowDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryRowDescriptionMetadata, 'SummaryRowDescriptionMetadata');
    SummaryRowDescriptionMetadata.a = null;
    return SummaryRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowDescription = /*@__PURE__*/ (() => {
    class SummaryRowDescription extends DefinitionBaseDescription {
        constructor() {
            super();
            this.ce = null;
            this.cc = null;
            this.ci = null;
            this.cd = null;
            this.cf = null;
            this.b2 = 0;
            this.cg = null;
            this.ch = null;
            this.b5 = 0;
            this.b7 = 0;
            this.b6 = 0;
            this.b4 = 0;
        }
        get_type() {
            return "SummaryRow";
        }
        get selectedBackground() {
            return this.ce;
        }
        set selectedBackground(a) {
            this.ce = a;
            this.e("SelectedBackground");
        }
        get actualSelectedBackground() {
            return this.cc;
        }
        set actualSelectedBackground(a) {
            this.cc = a;
            this.e("ActualSelectedBackground");
        }
        get summaryLabelTextColor() {
            return this.ci;
        }
        set summaryLabelTextColor(a) {
            this.ci = a;
            this.e("SummaryLabelTextColor");
        }
        get actualSummaryLabelTextColor() {
            return this.cd;
        }
        set actualSummaryLabelTextColor(a) {
            this.cd = a;
            this.e("ActualSummaryLabelTextColor");
        }
        get summaryLabelFontFamily() {
            return this.cf;
        }
        set summaryLabelFontFamily(a) {
            this.cf = a;
            this.e("SummaryLabelFontFamily");
        }
        get summaryLabelFontSize() {
            return this.b2;
        }
        set summaryLabelFontSize(a) {
            this.b2 = a;
            this.e("SummaryLabelFontSize");
        }
        get summaryLabelFontStyle() {
            return this.cg;
        }
        set summaryLabelFontStyle(a) {
            this.cg = a;
            this.e("SummaryLabelFontStyle");
        }
        get summaryLabelFontWeight() {
            return this.ch;
        }
        set summaryLabelFontWeight(a) {
            this.ch = a;
            this.e("SummaryLabelFontWeight");
        }
        get paddingLeft() {
            return this.b5;
        }
        set paddingLeft(a) {
            this.b5 = a;
            this.e("PaddingLeft");
        }
        get paddingTop() {
            return this.b7;
        }
        set paddingTop(a) {
            this.b7 = a;
            this.e("PaddingTop");
        }
        get paddingRight() {
            return this.b6;
        }
        set paddingRight(a) {
            this.b6 = a;
            this.e("PaddingRight");
        }
        get paddingBottom() {
            return this.b4;
        }
        set paddingBottom(a) {
            this.b4 = a;
            this.e("PaddingBottom");
        }
    }
    SummaryRowDescription.$t = /*@__PURE__*/ markType(SummaryRowDescription, 'SummaryRowDescription', DefinitionBaseDescription.$);
    return SummaryRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowRootDescription = /*@__PURE__*/ (() => {
    class SummaryRowRootDescription extends SummaryRowDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SummaryRowRoot";
        }
    }
    SummaryRowRootDescription.$t = /*@__PURE__*/ markType(SummaryRowRootDescription, 'SummaryRowRootDescription', SummaryRowDescription.$);
    return SummaryRowRootDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowRootDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryRowRootDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryRowRootDescriptionMetadata.a == null) {
                SummaryRowRootDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryRowRootDescriptionMetadata.c(a, SummaryRowRootDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SummaryRowDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SummaryRowRootDescriptionMetadata.b(a);
            a.q("SummaryRowRoot", () => new SummaryRowRootDescription());
            a.p("SummaryRowRoot", SummaryRowRootDescriptionMetadata.a);
        }
    }
    SummaryRowRootDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryRowRootDescriptionMetadata, 'SummaryRowRootDescriptionMetadata');
    SummaryRowRootDescriptionMetadata.a = null;
    return SummaryRowRootDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowRootDescriptionModule = /*@__PURE__*/ (() => {
    class SummaryRowRootDescriptionModule extends Base {
        static register(a) {
            SummaryRowRootDescriptionMetadata.d(a);
        }
    }
    SummaryRowRootDescriptionModule.$t = /*@__PURE__*/ markType(SummaryRowRootDescriptionModule, 'SummaryRowRootDescriptionModule');
    return SummaryRowRootDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowSectionDescription = /*@__PURE__*/ (() => {
    class SummaryRowSectionDescription extends SummaryRowDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SummaryRowSection";
        }
    }
    SummaryRowSectionDescription.$t = /*@__PURE__*/ markType(SummaryRowSectionDescription, 'SummaryRowSectionDescription', SummaryRowDescription.$);
    return SummaryRowSectionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowSectionDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryRowSectionDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryRowSectionDescriptionMetadata.a == null) {
                SummaryRowSectionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryRowSectionDescriptionMetadata.c(a, SummaryRowSectionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SummaryRowDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SummaryRowSectionDescriptionMetadata.b(a);
            a.q("SummaryRowSection", () => new SummaryRowSectionDescription());
            a.p("SummaryRowSection", SummaryRowSectionDescriptionMetadata.a);
        }
    }
    SummaryRowSectionDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryRowSectionDescriptionMetadata, 'SummaryRowSectionDescriptionMetadata');
    SummaryRowSectionDescriptionMetadata.a = null;
    return SummaryRowSectionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryRowSectionDescriptionModule = /*@__PURE__*/ (() => {
    class SummaryRowSectionDescriptionModule extends Base {
        static register(a) {
            SummaryRowSectionDescriptionMetadata.d(a);
        }
    }
    SummaryRowSectionDescriptionModule.$t = /*@__PURE__*/ markType(SummaryRowSectionDescriptionModule, 'SummaryRowSectionDescriptionModule');
    return SummaryRowSectionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnWidthDescription = /*@__PURE__*/ (() => {
    class ColumnWidthDescription extends Description {
        constructor() {
            super();
            this.g = false;
            this.j = 0;
            this.i = 0;
        }
        get_type() {
            return "ColumnWidth";
        }
        get type() {
            return this.get_type();
        }
        get isStarSized() {
            return this.g;
        }
        set isStarSized(a) {
            this.g = a;
            this.e("IsStarSized");
        }
        get value() {
            return this.j;
        }
        set value(a) {
            this.j = a;
            this.e("Value");
        }
        get minimumWidth() {
            return this.i;
        }
        set minimumWidth(a) {
            this.i = a;
            this.e("MinimumWidth");
        }
    }
    ColumnWidthDescription.$t = /*@__PURE__*/ markType(ColumnWidthDescription, 'ColumnWidthDescription', Description.$);
    ColumnWidthDescription.__marshalByValue = true;
    ColumnWidthDescription.__marshalByValueAlias = "ColumnWidth";
    return ColumnWidthDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnWidthDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnWidthDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnWidthDescriptionMetadata.a == null) {
                ColumnWidthDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnWidthDescriptionMetadata.c(a, ColumnWidthDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsStarSized", "Boolean");
            b.item("Value", "Number:double");
            b.item("MinimumWidth", "Number:double");
        }
        static d(a) {
            ColumnWidthDescriptionMetadata.b(a);
            a.q("ColumnWidth", () => new ColumnWidthDescription());
            a.p("ColumnWidth", ColumnWidthDescriptionMetadata.a);
        }
    }
    ColumnWidthDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnWidthDescriptionMetadata, 'ColumnWidthDescriptionMetadata');
    ColumnWidthDescriptionMetadata.a = null;
    return ColumnWidthDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnWidthDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnWidthDescriptionModule extends Base {
        static register(a) {
            ColumnWidthDescriptionMetadata.d(a);
        }
    }
    ColumnWidthDescriptionModule.$t = /*@__PURE__*/ markType(ColumnWidthDescriptionModule, 'ColumnWidthDescriptionModule');
    return ColumnWidthDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSortDescriptionDescription = /*@__PURE__*/ (() => {
    class ColumnSortDescriptionDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.i = null;
        }
        get_type() {
            return "ColumnSortDescription";
        }
        get type() {
            return this.get_type();
        }
        get field() {
            return this.h;
        }
        set field(a) {
            this.h = a;
            this.e("Field");
        }
        get sortDirection() {
            return this.i;
        }
        set sortDirection(a) {
            this.i = a;
            this.e("SortDirection");
        }
    }
    ColumnSortDescriptionDescription.$t = /*@__PURE__*/ markType(ColumnSortDescriptionDescription, 'ColumnSortDescriptionDescription', Description.$);
    ColumnSortDescriptionDescription.__marshalByValue = true;
    ColumnSortDescriptionDescription.__marshalByValueAlias = "ColumnSortDescription";
    return ColumnSortDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSortDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSortDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSortDescriptionDescriptionMetadata.a == null) {
                ColumnSortDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSortDescriptionDescriptionMetadata.c(a, ColumnSortDescriptionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Field", "String");
            b.item("SortDirection", "ExportedType:string:ListSortDirection");
            b.item("SortDirection@names", "Ascending;Descending");
        }
        static d(a) {
            ColumnSortDescriptionDescriptionMetadata.b(a);
            a.q("ColumnSortDescription", () => new ColumnSortDescriptionDescription());
            a.p("ColumnSortDescription", ColumnSortDescriptionDescriptionMetadata.a);
        }
    }
    ColumnSortDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSortDescriptionDescriptionMetadata, 'ColumnSortDescriptionDescriptionMetadata');
    ColumnSortDescriptionDescriptionMetadata.a = null;
    return ColumnSortDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSortDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnSortDescriptionDescriptionModule extends Base {
        static register(a) {
            ColumnSortDescriptionDescriptionMetadata.d(a);
        }
    }
    ColumnSortDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ColumnSortDescriptionDescriptionModule, 'ColumnSortDescriptionDescriptionModule');
    return ColumnSortDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatGroupTextEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatGroupTextEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.i = null;
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "FormatGroupTextEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get groupName() {
            return this.h;
        }
        set groupName(a) {
            this.h = a;
            this.e("GroupName");
        }
        get groupValueRef() {
            return this.i;
        }
        set groupValueRef(a) {
            this.i = a;
            this.e("GroupValueRef");
        }
        get formattedValue() {
            return this.g;
        }
        set formattedValue(a) {
            this.g = a;
            this.e("FormattedValue");
        }
        get formattedText() {
            return this.f;
        }
        set formattedText(a) {
            this.f = a;
            this.e("FormattedText");
        }
    }
    FormatGroupTextEventArgsDescription.$t = /*@__PURE__*/ markType(FormatGroupTextEventArgsDescription, 'FormatGroupTextEventArgsDescription', Description.$);
    return FormatGroupTextEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatGroupTextEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatGroupTextEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatGroupTextEventArgsDescriptionMetadata.a == null) {
                FormatGroupTextEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatGroupTextEventArgsDescriptionMetadata.c(a, FormatGroupTextEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("GroupName", "String");
            b.item("GroupValueRef", "(w:GroupValue,wf:GroupValue)DataRef");
            b.item("FormattedValue", "String");
            b.item("FormattedText", "String");
        }
        static d(a) {
            FormatGroupTextEventArgsDescriptionMetadata.b(a);
            a.q("FormatGroupTextEventArgs", () => new FormatGroupTextEventArgsDescription());
            a.p("FormatGroupTextEventArgs", FormatGroupTextEventArgsDescriptionMetadata.a);
        }
    }
    FormatGroupTextEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatGroupTextEventArgsDescriptionMetadata, 'FormatGroupTextEventArgsDescriptionMetadata');
    FormatGroupTextEventArgsDescriptionMetadata.a = null;
    return FormatGroupTextEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupDescriptionDescription = /*@__PURE__*/ (() => {
    class ColumnGroupDescriptionDescription extends ColumnSortDescriptionDescription {
        constructor() {
            super();
            this.v = null;
            this.n = null;
            this.s = null;
            this.m = null;
            this.t = null;
            this.u = null;
        }
        get_type() {
            return "ColumnGroupDescription";
        }
        get valueFormat() {
            return this.v;
        }
        set valueFormat(a) {
            this.v = a;
            this.e("ValueFormat");
        }
        get valueFormatSpecifiers() {
            return this.n;
        }
        set valueFormatSpecifiers(a) {
            this.n = a;
            this.e("ValueFormatSpecifiers");
        }
        get displayFormat() {
            return this.s;
        }
        set displayFormat(a) {
            this.s = a;
            this.e("DisplayFormat");
        }
        get displayFormatSpecifiers() {
            return this.m;
        }
        set displayFormatSpecifiers(a) {
            this.m = a;
            this.e("DisplayFormatSpecifiers");
        }
        get displayName() {
            return this.t;
        }
        set displayName(a) {
            this.t = a;
            this.e("DisplayName");
        }
        get formatTextRef() {
            return this.u;
        }
        set formatTextRef(a) {
            this.u = a;
            this.e("FormatTextRef");
        }
    }
    ColumnGroupDescriptionDescription.$t = /*@__PURE__*/ markType(ColumnGroupDescriptionDescription, 'ColumnGroupDescriptionDescription', ColumnSortDescriptionDescription.$);
    ColumnGroupDescriptionDescription.__marshalByValue1 = true;
    ColumnGroupDescriptionDescription.__marshalByValueAlias1 = "ColumnGroupDescription";
    return ColumnGroupDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnGroupDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnGroupDescriptionDescriptionMetadata.a == null) {
                ColumnGroupDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnGroupDescriptionDescriptionMetadata.c(a, ColumnGroupDescriptionDescriptionMetadata.a);
                FormatGroupTextEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ColumnSortDescriptionDescriptionMetadata.c(a, b);
            b.item("ValueFormat", "String");
            b.item("ValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("DisplayFormat", "String");
            b.item("DisplayFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("DisplayName", "String");
            b.item("FormatTextRef", "EventRef::formatText");
        }
        static d(a) {
            ColumnGroupDescriptionDescriptionMetadata.b(a);
            a.q("ColumnGroupDescription", () => new ColumnGroupDescriptionDescription());
            a.p("ColumnGroupDescription", ColumnGroupDescriptionDescriptionMetadata.a);
        }
    }
    ColumnGroupDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnGroupDescriptionDescriptionMetadata, 'ColumnGroupDescriptionDescriptionMetadata');
    ColumnGroupDescriptionDescriptionMetadata.a = null;
    return ColumnGroupDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnGroupDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnGroupDescriptionDescriptionModule extends Base {
        static register(a) {
            ColumnGroupDescriptionDescriptionMetadata.d(a);
        }
    }
    ColumnGroupDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ColumnGroupDescriptionDescriptionModule, 'ColumnGroupDescriptionDescriptionModule');
    return ColumnGroupDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSummaryTextEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatSummaryTextEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
            this.j = null;
            this.h = null;
            this.i = null;
        }
        get_type() {
            return "FormatSummaryTextEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get field() {
            return this.g;
        }
        set field(a) {
            this.g = a;
            this.e("Field");
        }
        get displayName() {
            return this.f;
        }
        set displayName(a) {
            this.f = a;
            this.e("DisplayName");
        }
        get summaryResultRef() {
            return this.j;
        }
        set summaryResultRef(a) {
            this.j = a;
            this.e("SummaryResultRef");
        }
        get formattedResult() {
            return this.h;
        }
        set formattedResult(a) {
            this.h = a;
            this.e("FormattedResult");
        }
        get formattedText() {
            return this.i;
        }
        set formattedText(a) {
            this.i = a;
            this.e("FormattedText");
        }
    }
    FormatSummaryTextEventArgsDescription.$t = /*@__PURE__*/ markType(FormatSummaryTextEventArgsDescription, 'FormatSummaryTextEventArgsDescription', Description.$);
    return FormatSummaryTextEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSummaryTextEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatSummaryTextEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatSummaryTextEventArgsDescriptionMetadata.a == null) {
                FormatSummaryTextEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatSummaryTextEventArgsDescriptionMetadata.c(a, FormatSummaryTextEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Field", "String");
            b.item("DisplayName", "String");
            b.item("SummaryResultRef", "(w:SummaryResult,wf:SummaryResult)DataRef");
            b.item("FormattedResult", "String");
            b.item("FormattedText", "String");
        }
        static d(a) {
            FormatSummaryTextEventArgsDescriptionMetadata.b(a);
            a.q("FormatSummaryTextEventArgs", () => new FormatSummaryTextEventArgsDescription());
            a.p("FormatSummaryTextEventArgs", FormatSummaryTextEventArgsDescriptionMetadata.a);
        }
    }
    FormatSummaryTextEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatSummaryTextEventArgsDescriptionMetadata, 'FormatSummaryTextEventArgsDescriptionMetadata');
    FormatSummaryTextEventArgsDescriptionMetadata.a = null;
    return FormatSummaryTextEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProvideCalculatorEventArgsDescription = /*@__PURE__*/ (() => {
    class ProvideCalculatorEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ProvideCalculatorEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ProvideCalculatorEventArgsDescription.$t = /*@__PURE__*/ markType(ProvideCalculatorEventArgsDescription, 'ProvideCalculatorEventArgsDescription', Description.$);
    return ProvideCalculatorEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProvideCalculatorEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ProvideCalculatorEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ProvideCalculatorEventArgsDescriptionMetadata.a == null) {
                ProvideCalculatorEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ProvideCalculatorEventArgsDescriptionMetadata.c(a, ProvideCalculatorEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ProvideCalculatorEventArgsDescriptionMetadata.b(a);
            a.q("ProvideCalculatorEventArgs", () => new ProvideCalculatorEventArgsDescription());
            a.p("ProvideCalculatorEventArgs", ProvideCalculatorEventArgsDescriptionMetadata.a);
        }
    }
    ProvideCalculatorEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ProvideCalculatorEventArgsDescriptionMetadata, 'ProvideCalculatorEventArgsDescriptionMetadata');
    ProvideCalculatorEventArgsDescriptionMetadata.a = null;
    return ProvideCalculatorEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSummaryDescriptionDescription = /*@__PURE__*/ (() => {
    class ColumnSummaryDescriptionDescription extends Description {
        constructor() {
            super();
            this.o = null;
            this.q = null;
            this.l = null;
            this.n = null;
            this.s = null;
            this.g = null;
            this.m = null;
            this.f = null;
            this.j = 0;
            this.p = null;
            this.r = null;
        }
        get_type() {
            return "ColumnSummaryDescription";
        }
        get type() {
            return this.get_type();
        }
        get field() {
            return this.o;
        }
        set field(a) {
            this.o = a;
            this.e("Field");
        }
        get operand() {
            return this.q;
        }
        set operand(a) {
            this.q = a;
            this.e("Operand");
        }
        get calculatorDisplayName() {
            return this.l;
        }
        set calculatorDisplayName(a) {
            this.l = a;
            this.e("CalculatorDisplayName");
        }
        get displayName() {
            return this.n;
        }
        set displayName(a) {
            this.n = a;
            this.e("DisplayName");
        }
        get valueFormat() {
            return this.s;
        }
        set valueFormat(a) {
            this.s = a;
            this.e("ValueFormat");
        }
        get valueFormatSpecifiers() {
            return this.g;
        }
        set valueFormatSpecifiers(a) {
            this.g = a;
            this.e("ValueFormatSpecifiers");
        }
        get displayFormat() {
            return this.m;
        }
        set displayFormat(a) {
            this.m = a;
            this.e("DisplayFormat");
        }
        get displayFormatSpecifiers() {
            return this.f;
        }
        set displayFormatSpecifiers(a) {
            this.f = a;
            this.e("DisplayFormatSpecifiers");
        }
        get maxFractionDigits() {
            return this.j;
        }
        set maxFractionDigits(a) {
            this.j = a;
            this.e("MaxFractionDigits");
        }
        get formatTextRef() {
            return this.p;
        }
        set formatTextRef(a) {
            this.p = a;
            this.e("FormatTextRef");
        }
        get provideCalculatorRef() {
            return this.r;
        }
        set provideCalculatorRef(a) {
            this.r = a;
            this.e("ProvideCalculatorRef");
        }
    }
    ColumnSummaryDescriptionDescription.$t = /*@__PURE__*/ markType(ColumnSummaryDescriptionDescription, 'ColumnSummaryDescriptionDescription', Description.$);
    return ColumnSummaryDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSummaryDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSummaryDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSummaryDescriptionDescriptionMetadata.a == null) {
                ColumnSummaryDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSummaryDescriptionDescriptionMetadata.c(a, ColumnSummaryDescriptionDescriptionMetadata.a);
                FormatSummaryTextEventArgsDescriptionMetadata.d(a);
                ProvideCalculatorEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Field", "String");
            b.item("Operand", "ExportedType:string:SummaryOperand");
            b.item("Operand@names", "Min;Max;Sum;Average;Count;Custom");
            b.item("CalculatorDisplayName", "String");
            b.item("DisplayName", "String");
            b.item("ValueFormat", "String");
            b.item("ValueFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("DisplayFormat", "String");
            b.item("DisplayFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("MaxFractionDigits", "Number:int");
            b.item("FormatTextRef", "EventRef::formatText");
            b.item("ProvideCalculatorRef", "EventRef::provideCalculator");
        }
        static d(a) {
            ColumnSummaryDescriptionDescriptionMetadata.b(a);
            a.q("ColumnSummaryDescription", () => new ColumnSummaryDescriptionDescription());
            a.p("ColumnSummaryDescription", ColumnSummaryDescriptionDescriptionMetadata.a);
        }
    }
    ColumnSummaryDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSummaryDescriptionDescriptionMetadata, 'ColumnSummaryDescriptionDescriptionMetadata');
    ColumnSummaryDescriptionDescriptionMetadata.a = null;
    return ColumnSummaryDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSummaryDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnSummaryDescriptionDescriptionModule extends Base {
        static register(a) {
            ColumnSummaryDescriptionDescriptionMetadata.d(a);
        }
    }
    ColumnSummaryDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(ColumnSummaryDescriptionDescriptionModule, 'ColumnSummaryDescriptionDescriptionModule');
    return ColumnSummaryDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimaryKeyValueDescriptionModule = /*@__PURE__*/ (() => {
    class PrimaryKeyValueDescriptionModule extends Base {
        static register(a) {
            PrimaryKeyValueDescriptionMetadata.d(a);
        }
    }
    PrimaryKeyValueDescriptionModule.$t = /*@__PURE__*/ markType(PrimaryKeyValueDescriptionModule, 'PrimaryKeyValueDescriptionModule');
    return PrimaryKeyValueDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellPositionDescription = /*@__PURE__*/ (() => {
    class GridCellPositionDescription extends Description {
        constructor() {
            super();
            this.g = 0;
            this.j = null;
        }
        get_type() {
            return "GridCellPosition";
        }
        get type() {
            return this.get_type();
        }
        get rowIndex() {
            return this.g;
        }
        set rowIndex(a) {
            this.g = a;
            this.e("RowIndex");
        }
        get columnUniqueKey() {
            return this.j;
        }
        set columnUniqueKey(a) {
            this.j = a;
            this.e("ColumnUniqueKey");
        }
    }
    GridCellPositionDescription.$t = /*@__PURE__*/ markType(GridCellPositionDescription, 'GridCellPositionDescription', Description.$);
    GridCellPositionDescription.__marshalByValue = true;
    GridCellPositionDescription.__marshalByValueAlias = "GridCellPosition";
    return GridCellPositionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellPositionDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellPositionDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellPositionDescriptionMetadata.a == null) {
                GridCellPositionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellPositionDescriptionMetadata.c(a, GridCellPositionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("RowIndex", "Number:int");
            b.item("ColumnUniqueKey", "String");
        }
        static d(a) {
            GridCellPositionDescriptionMetadata.b(a);
            a.q("GridCellPosition", () => new GridCellPositionDescription());
            a.p("GridCellPosition", GridCellPositionDescriptionMetadata.a);
        }
    }
    GridCellPositionDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellPositionDescriptionMetadata, 'GridCellPositionDescriptionMetadata');
    GridCellPositionDescriptionMetadata.a = null;
    return GridCellPositionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellPositionDescriptionModule = /*@__PURE__*/ (() => {
    class GridCellPositionDescriptionModule extends Base {
        static register(a) {
            GridCellPositionDescriptionMetadata.d(a);
        }
    }
    GridCellPositionDescriptionModule.$t = /*@__PURE__*/ markType(GridCellPositionDescriptionModule, 'GridCellPositionDescriptionModule');
    return GridCellPositionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSourceDescription = /*@__PURE__*/ (() => {
    class LocalDataSourceDescription extends BaseDataSourceDescription {
        constructor() {
            super();
            this.au = null;
        }
        get_type() {
            return "LocalDataSource";
        }
        get dataSourceRef() {
            return this.au;
        }
        set dataSourceRef(a) {
            this.au = a;
            this.e("DataSourceRef");
        }
    }
    LocalDataSourceDescription.$t = /*@__PURE__*/ markType(LocalDataSourceDescription, 'LocalDataSourceDescription', BaseDataSourceDescription.$);
    return LocalDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class LocalDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (LocalDataSourceDescriptionMetadata.a == null) {
                LocalDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LocalDataSourceDescriptionMetadata.c(a, LocalDataSourceDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            BaseDataSourceDescriptionMetadata.c(a, b);
            b.item("DataSourceRef", "(w:ItemsSource,j:dataSource,wf:ItemsSource)DataRef::object");
        }
        static d(a) {
            LocalDataSourceDescriptionMetadata.b(a);
            a.q("LocalDataSource", () => new LocalDataSourceDescription());
            a.p("LocalDataSource", LocalDataSourceDescriptionMetadata.a);
        }
    }
    LocalDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(LocalDataSourceDescriptionMetadata, 'LocalDataSourceDescriptionMetadata');
    LocalDataSourceDescriptionMetadata.a = null;
    return LocalDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (FilterExpressionDescriptionMetadata.a == null) {
                FilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterExpressionDescriptionMetadata.c(a, FilterExpressionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FilterExpressionDescriptionMetadata.b(a);
            a.p("FilterExpression", FilterExpressionDescriptionMetadata.a);
        }
    }
    FilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterExpressionDescriptionMetadata, 'FilterExpressionDescriptionMetadata');
    FilterExpressionDescriptionMetadata.a = null;
    return FilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterExpressionDescription = /*@__PURE__*/ (() => {
    class FilterExpressionDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FilterExpression";
        }
        get type() {
            return this.get_type();
        }
    }
    FilterExpressionDescription.$t = /*@__PURE__*/ markType(FilterExpressionDescription, 'FilterExpressionDescription', Description.$);
    return FilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LiteralFilterExpressionDescription = /*@__PURE__*/ (() => {
    class LiteralFilterExpressionDescription extends FilterExpressionDescription {
        constructor() {
            super();
            this.i = null;
            this.g = false;
        }
        get_type() {
            return "LiteralFilterExpression";
        }
        get literalValue() {
            return this.i;
        }
        set literalValue(a) {
            this.i = a;
            this.e("LiteralValue");
        }
        get leaveUnquoted() {
            return this.g;
        }
        set leaveUnquoted(a) {
            this.g = a;
            this.e("LeaveUnquoted");
        }
    }
    LiteralFilterExpressionDescription.$t = /*@__PURE__*/ markType(LiteralFilterExpressionDescription, 'LiteralFilterExpressionDescription', FilterExpressionDescription.$);
    return LiteralFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LiteralFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class LiteralFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (LiteralFilterExpressionDescriptionMetadata.a == null) {
                LiteralFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LiteralFilterExpressionDescriptionMetadata.c(a, LiteralFilterExpressionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FilterExpressionDescriptionMetadata.c(a, b);
            b.item("LiteralValue", "Unknown");
            b.item("LeaveUnquoted", "Boolean");
        }
        static d(a) {
            LiteralFilterExpressionDescriptionMetadata.b(a);
            a.q("LiteralFilterExpression", () => new LiteralFilterExpressionDescription());
            a.p("LiteralFilterExpression", LiteralFilterExpressionDescriptionMetadata.a);
        }
    }
    LiteralFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(LiteralFilterExpressionDescriptionMetadata, 'LiteralFilterExpressionDescriptionMetadata');
    LiteralFilterExpressionDescriptionMetadata.a = null;
    return LiteralFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyReferenceFilterExpressionDescription = /*@__PURE__*/ (() => {
    class PropertyReferenceFilterExpressionDescription extends FilterExpressionDescription {
        constructor() {
            super();
            this.g = null;
        }
        get_type() {
            return "PropertyReferenceFilterExpression";
        }
        get propertyReference() {
            return this.g;
        }
        set propertyReference(a) {
            this.g = a;
            this.e("PropertyReference");
        }
    }
    PropertyReferenceFilterExpressionDescription.$t = /*@__PURE__*/ markType(PropertyReferenceFilterExpressionDescription, 'PropertyReferenceFilterExpressionDescription', FilterExpressionDescription.$);
    return PropertyReferenceFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyReferenceFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyReferenceFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyReferenceFilterExpressionDescriptionMetadata.a == null) {
                PropertyReferenceFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyReferenceFilterExpressionDescriptionMetadata.c(a, PropertyReferenceFilterExpressionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FilterExpressionDescriptionMetadata.c(a, b);
            b.item("PropertyReference", "String");
        }
        static d(a) {
            PropertyReferenceFilterExpressionDescriptionMetadata.b(a);
            a.q("PropertyReferenceFilterExpression", () => new PropertyReferenceFilterExpressionDescription());
            a.p("PropertyReferenceFilterExpression", PropertyReferenceFilterExpressionDescriptionMetadata.a);
        }
    }
    PropertyReferenceFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyReferenceFilterExpressionDescriptionMetadata, 'PropertyReferenceFilterExpressionDescriptionMetadata');
    PropertyReferenceFilterExpressionDescriptionMetadata.a = null;
    return PropertyReferenceFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperationFilterExpressionDescription = /*@__PURE__*/ (() => {
    class OperationFilterExpressionDescription extends FilterExpressionDescription {
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.g = null;
            this.h = null;
            this.k = null;
        }
        get_type() {
            return "OperationFilterExpression";
        }
        get propertyName() {
            return this.l;
        }
        set propertyName(a) {
            this.l = a;
            this.e("PropertyName");
        }
        get valueRef() {
            return this.m;
        }
        set valueRef(a) {
            this.m = a;
            this.e("ValueRef");
        }
        get left() {
            return this.g;
        }
        set left(a) {
            this.g = a;
            this.e("Left");
        }
        get right() {
            return this.h;
        }
        set right(a) {
            this.h = a;
            this.e("Right");
        }
        get operator() {
            return this.k;
        }
        set operator(a) {
            this.k = a;
            this.e("Operator");
        }
    }
    OperationFilterExpressionDescription.$t = /*@__PURE__*/ markType(OperationFilterExpressionDescription, 'OperationFilterExpressionDescription', FilterExpressionDescription.$);
    return OperationFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OperationFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class OperationFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (OperationFilterExpressionDescriptionMetadata.a == null) {
                OperationFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OperationFilterExpressionDescriptionMetadata.c(a, OperationFilterExpressionDescriptionMetadata.a);
                FilterExpressionDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            FilterExpressionDescriptionMetadata.c(a, b);
            b.item("PropertyName", "String");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("Left", "ExportedType:IFilterExpression");
            b.item("Right", "ExportedType:IFilterExpression");
            b.item("Operator", "ExportedType:string:FilterExpressionOperatorType");
            b.item("Operator@names", "None;Equal;NotEqual;GreaterThan;GreaterThanOrEqual;LessThan;LessThanOrEqual;And;Or;Not;Add;Subtract;Multiply;Divide;Modulo;Grouping");
        }
        static d(a) {
            OperationFilterExpressionDescriptionMetadata.b(a);
            a.q("OperationFilterExpression", () => new OperationFilterExpressionDescription());
            a.p("OperationFilterExpression", OperationFilterExpressionDescriptionMetadata.a);
        }
    }
    OperationFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(OperationFilterExpressionDescriptionMetadata, 'OperationFilterExpressionDescriptionMetadata');
    OperationFilterExpressionDescriptionMetadata.a = null;
    return OperationFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunctionFilterExpressionDescription = /*@__PURE__*/ (() => {
    class FunctionFilterExpressionDescription extends FilterExpressionDescription {
        constructor() {
            super();
            this.i = null;
            this.g = null;
        }
        get_type() {
            return "FunctionFilterExpression";
        }
        get functionType() {
            return this.i;
        }
        set functionType(a) {
            this.i = a;
            this.e("FunctionType");
        }
        get functionArguments() {
            return this.g;
        }
        set functionArguments(a) {
            this.g = a;
            this.e("FunctionArguments");
        }
    }
    FunctionFilterExpressionDescription.$t = /*@__PURE__*/ markType(FunctionFilterExpressionDescription, 'FunctionFilterExpressionDescription', FilterExpressionDescription.$);
    return FunctionFilterExpressionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FunctionFilterExpressionDescriptionMetadata = /*@__PURE__*/ (() => {
    class FunctionFilterExpressionDescriptionMetadata extends Base {
        static b(a) {
            if (FunctionFilterExpressionDescriptionMetadata.a == null) {
                FunctionFilterExpressionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FunctionFilterExpressionDescriptionMetadata.c(a, FunctionFilterExpressionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FilterExpressionDescriptionMetadata.c(a, b);
            b.item("FunctionType", "ExportedType:string:FilterExpressionFunctionType");
            b.item("FunctionType@names", "Contains;EndsWith;StartsWith;Length;IndexOf;Replace;Substring;ToLower;ToUpper;Trim;Concat;Day;Hour;Minute;Month;Second;Year;Round;Floor;Ceiling;Date;Time;Now;IsOf;Cast");
            b.item("FunctionArguments", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
        }
        static d(a) {
            FunctionFilterExpressionDescriptionMetadata.b(a);
            a.q("FunctionFilterExpression", () => new FunctionFilterExpressionDescription());
            a.p("FunctionFilterExpression", FunctionFilterExpressionDescriptionMetadata.a);
        }
    }
    FunctionFilterExpressionDescriptionMetadata.$t = /*@__PURE__*/ markType(FunctionFilterExpressionDescriptionMetadata, 'FunctionFilterExpressionDescriptionMetadata');
    FunctionFilterExpressionDescriptionMetadata.a = null;
    return FunctionFilterExpressionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LocalDataSourceDescriptionModule = /*@__PURE__*/ (() => {
    class LocalDataSourceDescriptionModule extends Base {
        static register(a) {
            LocalDataSourceDescriptionMetadata.d(a);
            LiteralFilterExpressionDescriptionMetadata.d(a);
            PropertyReferenceFilterExpressionDescriptionMetadata.d(a);
            OperationFilterExpressionDescriptionMetadata.d(a);
            FunctionFilterExpressionDescriptionMetadata.d(a);
        }
    }
    LocalDataSourceDescriptionModule.$t = /*@__PURE__*/ markType(LocalDataSourceDescriptionModule, 'LocalDataSourceDescriptionModule');
    return LocalDataSourceDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifierDescription = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifierDescription extends FormatSpecifierDescription {
        constructor() {
            super();
            this.v = null;
            this.n = null;
            this.ab = null;
            this.j = 0;
            this.m = null;
            this.p = null;
            this.z = null;
            this.w = null;
            this.ac = null;
            this.t = null;
            this.u = null;
            this.r = null;
            this.ae = null;
            this.q = null;
            this.af = null;
            this.y = null;
            this.o = null;
            this.s = null;
            this.x = null;
            this.aa = null;
            this.ad = null;
        }
        get_type() {
            return "DateTimeFormatSpecifier";
        }
        get locale() {
            return this.v;
        }
        set locale(a) {
            this.v = a;
            this.e("Locale");
        }
        get dateStyle() {
            return this.n;
        }
        set dateStyle(a) {
            this.n = a;
            this.e("DateStyle");
        }
        get timeStyle() {
            return this.ab;
        }
        set timeStyle(a) {
            this.ab = a;
            this.e("TimeStyle");
        }
        get fractionalSecondDigits() {
            return this.j;
        }
        set fractionalSecondDigits(a) {
            this.j = a;
            this.e("FractionalSecondDigits");
        }
        get calendar() {
            return this.m;
        }
        set calendar(a) {
            this.m = a;
            this.e("Calendar");
        }
        get dayPeriod() {
            return this.p;
        }
        set dayPeriod(a) {
            this.p = a;
            this.e("DayPeriod");
        }
        get numberingSystem() {
            return this.z;
        }
        set numberingSystem(a) {
            this.z = a;
            this.e("NumberingSystem");
        }
        get localeMatcher() {
            return this.w;
        }
        set localeMatcher(a) {
            this.w = a;
            this.e("LocaleMatcher");
        }
        get timeZone() {
            return this.ac;
        }
        set timeZone(a) {
            this.ac = a;
            this.e("TimeZone");
        }
        get hour12() {
            return this.t;
        }
        set hour12(a) {
            this.t = a;
            this.e("Hour12");
        }
        get hourCycle() {
            return this.u;
        }
        set hourCycle(a) {
            this.u = a;
            this.e("HourCycle");
        }
        get formatMatcher() {
            return this.r;
        }
        set formatMatcher(a) {
            this.r = a;
            this.e("FormatMatcher");
        }
        get weekDay() {
            return this.ae;
        }
        set weekDay(a) {
            this.ae = a;
            this.e("WeekDay");
        }
        get era() {
            return this.q;
        }
        set era(a) {
            this.q = a;
            this.e("Era");
        }
        get year() {
            return this.af;
        }
        set year(a) {
            this.af = a;
            this.e("Year");
        }
        get month() {
            return this.y;
        }
        set month(a) {
            this.y = a;
            this.e("Month");
        }
        get day() {
            return this.o;
        }
        set day(a) {
            this.o = a;
            this.e("Day");
        }
        get hour() {
            return this.s;
        }
        set hour(a) {
            this.s = a;
            this.e("Hour");
        }
        get minute() {
            return this.x;
        }
        set minute(a) {
            this.x = a;
            this.e("Minute");
        }
        get second() {
            return this.aa;
        }
        set second(a) {
            this.aa = a;
            this.e("Second");
        }
        get timeZoneName() {
            return this.ad;
        }
        set timeZoneName(a) {
            this.ad = a;
            this.e("TimeZoneName");
        }
    }
    DateTimeFormatSpecifierDescription.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifierDescription, 'DateTimeFormatSpecifierDescription', FormatSpecifierDescription.$);
    DateTimeFormatSpecifierDescription.__marshalByValue1 = true;
    DateTimeFormatSpecifierDescription.__marshalByValueAlias1 = "DateTimeFormatSpecifier";
    return DateTimeFormatSpecifierDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifierDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifierDescriptionMetadata extends Base {
        static b(a) {
            if (DateTimeFormatSpecifierDescriptionMetadata.a == null) {
                DateTimeFormatSpecifierDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateTimeFormatSpecifierDescriptionMetadata.c(a, DateTimeFormatSpecifierDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FormatSpecifierDescriptionMetadata.c(a, b);
            b.item("Locale", "String");
            b.item("DateStyle", "String");
            b.item("TimeStyle", "String");
            b.item("FractionalSecondDigits", "Number:int");
            b.item("Calendar", "String");
            b.item("DayPeriod", "String");
            b.item("NumberingSystem", "String");
            b.item("LocaleMatcher", "String");
            b.item("TimeZone", "String");
            b.item("Hour12", "String");
            b.item("HourCycle", "String");
            b.item("FormatMatcher", "String");
            b.item("WeekDay", "String");
            b.item("Era", "String");
            b.item("Year", "String");
            b.item("Month", "String");
            b.item("Day", "String");
            b.item("Hour", "String");
            b.item("Minute", "String");
            b.item("Second", "String");
            b.item("TimeZoneName", "String");
        }
        static d(a) {
            DateTimeFormatSpecifierDescriptionMetadata.b(a);
            a.q("DateTimeFormatSpecifier", () => new DateTimeFormatSpecifierDescription());
            a.p("DateTimeFormatSpecifier", DateTimeFormatSpecifierDescriptionMetadata.a);
        }
    }
    DateTimeFormatSpecifierDescriptionMetadata.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifierDescriptionMetadata, 'DateTimeFormatSpecifierDescriptionMetadata');
    DateTimeFormatSpecifierDescriptionMetadata.a = null;
    return DateTimeFormatSpecifierDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeFormatSpecifierDescriptionModule = /*@__PURE__*/ (() => {
    class DateTimeFormatSpecifierDescriptionModule extends Base {
        static register(a) {
            DateTimeFormatSpecifierDescriptionMetadata.d(a);
        }
    }
    DateTimeFormatSpecifierDescriptionModule.$t = /*@__PURE__*/ markType(DateTimeFormatSpecifierDescriptionModule, 'DateTimeFormatSpecifierDescriptionModule');
    return DateTimeFormatSpecifierDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderRowSeparatorDescription = /*@__PURE__*/ (() => {
    class HeaderRowSeparatorDescription extends DefinitionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "HeaderRowSeparator";
        }
    }
    HeaderRowSeparatorDescription.$t = /*@__PURE__*/ markType(HeaderRowSeparatorDescription, 'HeaderRowSeparatorDescription', DefinitionBaseDescription.$);
    return HeaderRowSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderRowSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeaderRowSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (HeaderRowSeparatorDescriptionMetadata.a == null) {
                HeaderRowSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeaderRowSeparatorDescriptionMetadata.c(a, HeaderRowSeparatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            HeaderRowSeparatorDescriptionMetadata.b(a);
            a.q("HeaderRowSeparator", () => new HeaderRowSeparatorDescription());
            a.p("HeaderRowSeparator", HeaderRowSeparatorDescriptionMetadata.a);
        }
    }
    HeaderRowSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(HeaderRowSeparatorDescriptionMetadata, 'HeaderRowSeparatorDescriptionMetadata');
    HeaderRowSeparatorDescriptionMetadata.a = null;
    return HeaderRowSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PinnedAreaSeparatorDescription = /*@__PURE__*/ (() => {
    class PinnedAreaSeparatorDescription extends DefinitionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PinnedAreaSeparator";
        }
    }
    PinnedAreaSeparatorDescription.$t = /*@__PURE__*/ markType(PinnedAreaSeparatorDescription, 'PinnedAreaSeparatorDescription', DefinitionBaseDescription.$);
    return PinnedAreaSeparatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PinnedAreaSeparatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PinnedAreaSeparatorDescriptionMetadata extends Base {
        static b(a) {
            if (PinnedAreaSeparatorDescriptionMetadata.a == null) {
                PinnedAreaSeparatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PinnedAreaSeparatorDescriptionMetadata.c(a, PinnedAreaSeparatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PinnedAreaSeparatorDescriptionMetadata.b(a);
            a.q("PinnedAreaSeparator", () => new PinnedAreaSeparatorDescription());
            a.p("PinnedAreaSeparator", PinnedAreaSeparatorDescriptionMetadata.a);
        }
    }
    PinnedAreaSeparatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PinnedAreaSeparatorDescriptionMetadata, 'PinnedAreaSeparatorDescriptionMetadata');
    PinnedAreaSeparatorDescriptionMetadata.a = null;
    return PinnedAreaSeparatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationSettingsDescription = /*@__PURE__*/ (() => {
    class GridAnimationSettingsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "GridAnimationSettings";
        }
        get type() {
            return this.get_type();
        }
    }
    GridAnimationSettingsDescription.$t = /*@__PURE__*/ markType(GridAnimationSettingsDescription, 'GridAnimationSettingsDescription', Description.$);
    return GridAnimationSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridAnimationSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (GridAnimationSettingsDescriptionMetadata.a == null) {
                GridAnimationSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridAnimationSettingsDescriptionMetadata.c(a, GridAnimationSettingsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            GridAnimationSettingsDescriptionMetadata.b(a);
            a.q("GridAnimationSettings", () => new GridAnimationSettingsDescription());
            a.p("GridAnimationSettings", GridAnimationSettingsDescriptionMetadata.a);
        }
    }
    GridAnimationSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridAnimationSettingsDescriptionMetadata, 'GridAnimationSettingsDescriptionMetadata');
    GridAnimationSettingsDescriptionMetadata.a = null;
    return GridAnimationSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterExpressionsEventArgsDescription = /*@__PURE__*/ (() => {
    class GridFilterExpressionsEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridFilterExpressionsEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get filterExpressions() {
            return this.f;
        }
        set filterExpressions(a) {
            this.f = a;
            this.e("FilterExpressions");
        }
    }
    GridFilterExpressionsEventArgsDescription.$t = /*@__PURE__*/ markType(GridFilterExpressionsEventArgsDescription, 'GridFilterExpressionsEventArgsDescription', Description.$);
    return GridFilterExpressionsEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterExpressionsEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterExpressionsEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterExpressionsEventArgsDescriptionMetadata.a == null) {
                GridFilterExpressionsEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterExpressionsEventArgsDescriptionMetadata.c(a, GridFilterExpressionsEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("FilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
        }
        static d(a) {
            GridFilterExpressionsEventArgsDescriptionMetadata.b(a);
            a.q("GridFilterExpressionsEventArgs", () => new GridFilterExpressionsEventArgsDescription());
            a.p("GridFilterExpressionsEventArgs", GridFilterExpressionsEventArgsDescriptionMetadata.a);
        }
    }
    GridFilterExpressionsEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterExpressionsEventArgsDescriptionMetadata, 'GridFilterExpressionsEventArgsDescriptionMetadata');
    GridFilterExpressionsEventArgsDescriptionMetadata.a = null;
    return GridFilterExpressionsEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSortDescriptionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSortDescriptionsChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridSortDescriptionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get sortDescriptions() {
            return this.f;
        }
        set sortDescriptions(a) {
            this.f = a;
            this.e("SortDescriptions");
        }
    }
    GridSortDescriptionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSortDescriptionsChangedEventArgsDescription, 'GridSortDescriptionsChangedEventArgsDescription', Description.$);
    return GridSortDescriptionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSortDescriptionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSortDescriptionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSortDescriptionsChangedEventArgsDescriptionMetadata.a == null) {
                GridSortDescriptionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSortDescriptionsChangedEventArgsDescriptionMetadata.c(a, GridSortDescriptionsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("SortDescriptions", "Collection:ColumnSortDescription:ColumnSortDescriptionCollection:ColumnSortDescription");
        }
        static d(a) {
            GridSortDescriptionsChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridSortDescriptionsChangedEventArgs", () => new GridSortDescriptionsChangedEventArgsDescription());
            a.p("GridSortDescriptionsChangedEventArgs", GridSortDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSortDescriptionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSortDescriptionsChangedEventArgsDescriptionMetadata, 'GridSortDescriptionsChangedEventArgsDescriptionMetadata');
    GridSortDescriptionsChangedEventArgsDescriptionMetadata.a = null;
    return GridSortDescriptionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridGroupDescriptionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridGroupDescriptionsChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridGroupDescriptionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get groupDescriptions() {
            return this.f;
        }
        set groupDescriptions(a) {
            this.f = a;
            this.e("GroupDescriptions");
        }
    }
    GridGroupDescriptionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridGroupDescriptionsChangedEventArgsDescription, 'GridGroupDescriptionsChangedEventArgsDescription', Description.$);
    return GridGroupDescriptionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridGroupDescriptionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridGroupDescriptionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a == null) {
                GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridGroupDescriptionsChangedEventArgsDescriptionMetadata.c(a, GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("GroupDescriptions", "Collection:ColumnGroupDescription:ColumnGroupDescriptionCollection:ColumnGroupDescription");
        }
        static d(a) {
            GridGroupDescriptionsChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridGroupDescriptionsChangedEventArgs", () => new GridGroupDescriptionsChangedEventArgsDescription());
            a.p("GridGroupDescriptionsChangedEventArgs", GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridGroupDescriptionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridGroupDescriptionsChangedEventArgsDescriptionMetadata, 'GridGroupDescriptionsChangedEventArgsDescriptionMetadata');
    GridGroupDescriptionsChangedEventArgsDescriptionMetadata.a = null;
    return GridGroupDescriptionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnAnimationSettingsDescription = /*@__PURE__*/ (() => {
    class GridColumnAnimationSettingsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "GridColumnAnimationSettings";
        }
        get type() {
            return this.get_type();
        }
    }
    GridColumnAnimationSettingsDescription.$t = /*@__PURE__*/ markType(GridColumnAnimationSettingsDescription, 'GridColumnAnimationSettingsDescription', Description.$);
    return GridColumnAnimationSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnAnimationSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnAnimationSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnAnimationSettingsDescriptionMetadata.a == null) {
                GridColumnAnimationSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnAnimationSettingsDescriptionMetadata.c(a, GridColumnAnimationSettingsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            GridColumnAnimationSettingsDescriptionMetadata.b(a);
            a.q("GridColumnAnimationSettings", () => new GridColumnAnimationSettingsDescription());
            a.p("GridColumnAnimationSettings", GridColumnAnimationSettingsDescriptionMetadata.a);
        }
    }
    GridColumnAnimationSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnAnimationSettingsDescriptionMetadata, 'GridColumnAnimationSettingsDescriptionMetadata');
    GridColumnAnimationSettingsDescriptionMetadata.a = null;
    return GridColumnAnimationSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnFilterConditionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnFilterConditionDescriptionMetadata.a == null) {
                ColumnFilterConditionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnFilterConditionDescriptionMetadata.c(a, ColumnFilterConditionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ColumnFilterConditionDescriptionMetadata.b(a);
            a.p("ColumnFilterCondition", ColumnFilterConditionDescriptionMetadata.a);
        }
    }
    ColumnFilterConditionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnFilterConditionDescriptionMetadata, 'ColumnFilterConditionDescriptionMetadata');
    ColumnFilterConditionDescriptionMetadata.a = null;
    return ColumnFilterConditionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnDescriptionMetadata.a == null) {
                ColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnDescriptionMetadata.c(a, ColumnDescriptionMetadata.a);
                GridColumnAnimationSettingsDescriptionMetadata.d(a);
                ColumnWidthDescriptionMetadata.d(a);
                ColumnFilterConditionDescriptionMetadata.d(a);
                HeaderDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
            b.item("PaddingLeft", "Number:int");
            b.item("PaddingTop", "Number:int");
            b.item("PaddingRight", "Number:int");
            b.item("PaddingBottom", "Number:int");
            b.item("Name", "String");
            b.item("Field", "String");
            b.item("HeaderText", "String");
            b.item("ActualHeaderText", "String");
            b.item("SelectedBackground", "Brush");
            b.item("ActualSelectedBackground", "Brush");
            b.item("RowHoverBackground", "Brush");
            b.item("ActualHoverBackground", "Brush");
            b.item("RowHoverTextColor", "Brush");
            b.item("ActualRowHoverTextColor", "Brush");
            b.item("AnimationSettings", "ExportedType:GridColumnAnimationSettings");
            b.item("Width", "ExportedType:ColumnWidth");
            b.item("MinWidth", "Number:double");
            b.item("IsFromMarkup", "Boolean");
            b.item("IsAutoGenerated", "Boolean");
            b.item("Filter", "ExportedType:ColumnFilterCondition");
            b.item("Header", "ExportedType:Header");
            b.item("IsFilteringEnabled", "Boolean");
            b.item("IsResizingEnabled", "Boolean");
            b.item("IsHidden", "Boolean");
            b.item("ShouldRemoveWhenHidden", "Boolean");
            b.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            b.item("SortDirection@names", "None;Ascending;Descending");
            b.item("Pinned", "ExportedType:string:PinnedPositions");
            b.item("Pinned@names", "None;Left;Right");
            b.item("ActualColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            b.item("ActualColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            b.item("ColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            b.item("ColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            b.item("ActualColumnOptionsIconColor", "Brush");
            b.item("ColumnOptionsIconColor", "Brush");
            b.item("ColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            b.item("ColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
            b.item("ActualColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            b.item("ActualColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
            b.item("ActualIsColumnOptionsEnabled", "Boolean");
            b.item("IsColumnOptionsEnabled", "Boolean");
            b.item("ActualIsColumnOptionsSummariesEnabled", "Boolean");
            b.item("IsColumnOptionsSummariesEnabled", "Boolean");
            b.item("IsEditable", "Boolean");
            b.item("DeletedTextColor", "Brush");
            b.item("ActualDeletedTextColor", "Brush");
            b.item("EditOpacity", "Number:double");
            b.item("ActualEditOpacity", "Number:double");
            b.item("EditFontFamily", "(w:EditFontFamily/FontFamilyTransform,wf:EditFontFamily,web:textEditStyle/FontFamilyTransform)String");
            b.item("EditFontSize", "(w:EditFontSize,wf:EditFontSize,web:textEditStyle/FontSizeTransform)Number:double");
            b.item("EditFontStyle", "(w:EditFontStyle/FontStyleTransform,wf:EditFontFamily/FontStyleTransform,web:textEditStyle/FontStyleTransform)String");
            b.item("EditFontWeight", "(w:EditFontWeight/FontWeightTransform,wf:EditFontFamily/FontWeightTransform,web:textEditStyle/FontWeightTransform)String");
            b.item("ActualHeaderTextChangeRef", "EventRef::actualHeaderTextChange");
        }
        static d(a) {
            ColumnDescriptionMetadata.b(a);
            a.p("Column", ColumnDescriptionMetadata.a);
        }
    }
    ColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnDescriptionMetadata, 'ColumnDescriptionMetadata');
    ColumnDescriptionMetadata.a = null;
    return ColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnHiddenChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ColumnHiddenChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = false;
        }
        get_type() {
            return "ColumnHiddenChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get isHidden() {
            return this.h;
        }
        set isHidden(a) {
            this.h = a;
            this.e("IsHidden");
        }
    }
    ColumnHiddenChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ColumnHiddenChangedEventArgsDescription, 'ColumnHiddenChangedEventArgsDescription', Description.$);
    return ColumnHiddenChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnHiddenChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnHiddenChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnHiddenChangedEventArgsDescriptionMetadata.a == null) {
                ColumnHiddenChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnHiddenChangedEventArgsDescriptionMetadata.c(a, ColumnHiddenChangedEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
            b.item("IsHidden", "Boolean");
        }
        static d(a) {
            ColumnHiddenChangedEventArgsDescriptionMetadata.b(a);
            a.q("ColumnHiddenChangedEventArgs", () => new ColumnHiddenChangedEventArgsDescription());
            a.p("ColumnHiddenChangedEventArgs", ColumnHiddenChangedEventArgsDescriptionMetadata.a);
        }
    }
    ColumnHiddenChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnHiddenChangedEventArgsDescriptionMetadata, 'ColumnHiddenChangedEventArgsDescriptionMetadata');
    ColumnHiddenChangedEventArgsDescriptionMetadata.a = null;
    return ColumnHiddenChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinnedChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class ColumnPinnedChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "ColumnPinnedChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get pinned() {
            return this.h;
        }
        set pinned(a) {
            this.h = a;
            this.e("Pinned");
        }
    }
    ColumnPinnedChangedEventArgsDescription.$t = /*@__PURE__*/ markType(ColumnPinnedChangedEventArgsDescription, 'ColumnPinnedChangedEventArgsDescription', Description.$);
    return ColumnPinnedChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinnedChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnPinnedChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnPinnedChangedEventArgsDescriptionMetadata.a == null) {
                ColumnPinnedChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnPinnedChangedEventArgsDescriptionMetadata.c(a, ColumnPinnedChangedEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
            b.item("Pinned", "ExportedType:string:PinnedPositions");
            b.item("Pinned@names", "None;Left;Right");
        }
        static d(a) {
            ColumnPinnedChangedEventArgsDescriptionMetadata.b(a);
            a.q("ColumnPinnedChangedEventArgs", () => new ColumnPinnedChangedEventArgsDescription());
            a.p("ColumnPinnedChangedEventArgs", ColumnPinnedChangedEventArgsDescriptionMetadata.a);
        }
    }
    ColumnPinnedChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnPinnedChangedEventArgsDescriptionMetadata, 'ColumnPinnedChangedEventArgsDescriptionMetadata');
    ColumnPinnedChangedEventArgsDescriptionMetadata.a = null;
    return ColumnPinnedChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (CellInfoDescriptionMetadata.a == null) {
                CellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellInfoDescriptionMetadata.c(a, CellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("StyleKey", "String");
            b.item("DataRow", "Number:int");
            b.item("IsPositionDirty", "Boolean");
            b.item("IsSizeDirty", "Boolean");
            b.item("IsContentDirty", "Boolean");
            b.item("IsBorderDirty", "Boolean");
            b.item("IsLayerDirty", "Boolean");
            b.item("IsStateDirty", "Boolean");
            b.item("IsDataDirty", "Boolean");
            b.item("IsPlaceholdContentNeeded", "Boolean");
            b.item("ActionManager", "ExportedType");
            b.item("IsRowPinned", "Boolean");
            b.item("IsRowSticky", "Boolean");
            b.item("IsLastStickyRow", "Boolean");
            b.item("Indent", "Number:int");
            b.item("RowItemRef", "(w:RowItem,wf:RowItem)DataRef");
            b.item("X", "Number:double");
            b.item("Y", "Number:double");
            b.item("SnappedX", "Number:int");
            b.item("SnappedY", "Number:int");
            b.item("EditOpacity", "Number:double");
            b.item("ContentOpacity", "Number:double");
            b.item("ActualContentOpacity", "Number:double");
            b.item("Opacity", "Number:double");
            b.item("ActualOpacity", "Number:double");
            b.item("Height", "Number:int");
            b.item("Width", "Number:int");
            b.item("IsSelected", "Boolean");
            b.item("SelectedStatus", "Number:double");
            b.item("ActivationStatus", "Number:double");
            b.item("HoverStatus", "Number:double");
            b.item("HorizontalAlignment", "ExportedType:string:CellContentHorizontalAlignment");
            b.item("HorizontalAlignment@names", "Left;Center;Right;Stretch;Auto");
            b.item("VerticalAlignment", "ExportedType:string:CellContentVerticalAlignment");
            b.item("VerticalAlignment@names", "Top;Center;Bottom;Stretch;Auto");
            b.item("Background", "Brush");
            b.item("Border", "Brush");
            b.item("ActualBackground", "Brush");
            b.item("ActualBorder", "Brush");
            b.item("ActivationBorder", "Brush");
            b.item("ErrorBorder", "Brush");
            b.item("SelectedBackground", "Brush");
            b.item("HoverBackground", "Brush");
            b.item("HoverTextColor", "Brush");
            b.item("SortIndicatorColor", "Brush");
            b.item("StickyRowBackground", "Brush");
            b.item("PinnedRowBackground", "Brush");
            b.item("LastStickyRowBackground", "Brush");
            b.item("PinnedRowOpacity", "Number:double");
            b.item("OriginalValueRef", "(w:OriginalValue,wf:OriginalValue)DataRef");
            b.item("RenderValue", "String");
            b.item("TextColor", "Brush");
            b.item("ActualTextColor", "Brush");
            b.item("DeletedTextColor", "Brush");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:font/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:font/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:font/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:font/FontWeightTransform)String");
            b.item("ActualFontFamily", "(w:ActualFontFamily/FontFamilyTransform,wf:ActualFontFamily,web:actualFont/FontFamilyTransform)String");
            b.item("ActualFontSize", "(w:ActualFontSize,wf:ActualFontSize,web:actualFont/FontSizeTransform)Number:double");
            b.item("ActualFontStyle", "(w:ActualFontStyle/FontStyleTransform,wf:ActualFontFamily/FontStyleTransform,web:actualFont/FontStyleTransform)String");
            b.item("ActualFontWeight", "(w:ActualFontWeight/FontWeightTransform,wf:ActualFontFamily/FontWeightTransform,web:actualFont/FontWeightTransform)String");
            b.item("LineBreakMode", "ExportedType:string:TextCellLineBreakMode");
            b.item("LineBreakMode@names", "Ellipsis;NoWrap;WordWrap;CharacterWrap");
            b.item("VirtualizationPercentage", "Number:double");
            b.item("PaddingLeft", "Number:int");
            b.item("PaddingTop", "Number:int");
            b.item("PaddingRight", "Number:int");
            b.item("PaddingBottom", "Number:int");
            b.item("ActualPaddingLeft", "Number:int");
            b.item("ActualPaddingTop", "Number:int");
            b.item("ActualPaddingRight", "Number:int");
            b.item("ActualPaddingBottom", "Number:int");
            b.item("BorderLeftWidth", "Number:int");
            b.item("BorderTopWidth", "Number:int");
            b.item("BorderRightWidth", "Number:int");
            b.item("BorderBottomWidth", "Number:int");
            b.item("ActivationBorderLeftWidth", "Number:int");
            b.item("ActivationBorderTopWidth", "Number:int");
            b.item("ActivationBorderRightWidth", "Number:int");
            b.item("ActivationBorderBottomWidth", "Number:int");
            b.item("ErrorBorderLeftWidth", "Number:int");
            b.item("ErrorBorderTopWidth", "Number:int");
            b.item("ErrorBorderRightWidth", "Number:int");
            b.item("ErrorBorderBottomWidth", "Number:int");
            b.item("ActualBorderLeftWidth", "Number:int");
            b.item("ActualBorderTopWidth", "Number:int");
            b.item("ActualBorderRightWidth", "Number:int");
            b.item("ActualBorderBottomWidth", "Number:int");
            b.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            b.item("SortDirection@names", "None;Ascending;Descending");
            b.item("IsExpanded", "Boolean");
            b.item("IsCollapsable", "Boolean");
            b.item("Pinned", "ExportedType:string:PinnedPositions");
            b.item("Pinned@names", "None;Left;Right");
            b.item("EditFontFamily", "(w:EditFontFamily/FontFamilyTransform,wf:EditFontFamily,web:editFont/FontFamilyTransform)String");
            b.item("EditFontSize", "(w:EditFontSize,wf:EditFontSize,web:editFont/FontSizeTransform)Number:double");
            b.item("EditFontStyle", "(w:EditFontStyle/FontStyleTransform,wf:EditFontFamily/FontStyleTransform,web:editFont/FontStyleTransform)String");
            b.item("EditFontWeight", "(w:EditFontWeight/FontWeightTransform,wf:EditFontFamily/FontWeightTransform,web:editFont/FontWeightTransform)String");
            b.item("IsEdited", "Boolean");
            b.item("IsDeleted", "Boolean");
            b.item("EditError", "String");
            b.item("IsInEditMode", "Boolean");
            b.item("EditID", "Number:int");
        }
        static d(a) {
            CellInfoDescriptionMetadata.b(a);
            a.p("CellInfo", CellInfoDescriptionMetadata.a);
        }
    }
    CellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(CellInfoDescriptionMetadata, 'CellInfoDescriptionMetadata');
    CellInfoDescriptionMetadata.a = null;
    return CellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellValueChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellValueChangingEventArgsDescription extends Description {
        constructor() {
            super();
            this.j = 0;
            this.f = null;
            this.h = null;
            this.p = null;
            this.m = null;
            this.l = null;
        }
        get_type() {
            return "GridCellValueChangingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get editID() {
            return this.j;
        }
        set editID(a) {
            this.j = a;
            this.e("EditID");
        }
        get cellInfo() {
            return this.f;
        }
        set cellInfo(a) {
            this.f = a;
            this.e("CellInfo");
        }
        get column() {
            return this.h;
        }
        set column(a) {
            this.h = a;
            this.e("Column");
        }
        get itemRef() {
            return this.p;
        }
        set itemRef(a) {
            this.p = a;
            this.e("ItemRef");
        }
        get oldValue() {
            return this.m;
        }
        set oldValue(a) {
            this.m = a;
            this.e("OldValue");
        }
        get newValue() {
            return this.l;
        }
        set newValue(a) {
            this.l = a;
            this.e("NewValue");
        }
    }
    GridCellValueChangingEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellValueChangingEventArgsDescription, 'GridCellValueChangingEventArgsDescription', Description.$);
    return GridCellValueChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellValueChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellValueChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellValueChangingEventArgsDescriptionMetadata.a == null) {
                GridCellValueChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellValueChangingEventArgsDescriptionMetadata.c(a, GridCellValueChangingEventArgsDescriptionMetadata.a);
                CellInfoDescriptionMetadata.d(a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("EditID", "Number:int");
            b.item("CellInfo", "ExportedType:CellModel");
            b.item("Column", "ExportedType:Column");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("OldValue", "Unknown");
            b.item("NewValue", "Unknown");
        }
        static d(a) {
            GridCellValueChangingEventArgsDescriptionMetadata.b(a);
            a.q("GridCellValueChangingEventArgs", () => new GridCellValueChangingEventArgsDescription());
            a.p("GridCellValueChangingEventArgs", GridCellValueChangingEventArgsDescriptionMetadata.a);
        }
    }
    GridCellValueChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellValueChangingEventArgsDescriptionMetadata, 'GridCellValueChangingEventArgsDescriptionMetadata');
    GridCellValueChangingEventArgsDescriptionMetadata.a = null;
    return GridCellValueChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceAggregatedResultDescription = /*@__PURE__*/ (() => {
    class DataSourceAggregatedResultDescription extends Description {
        constructor() {
            super();
            this.j = null;
            this.k = null;
            this.f = null;
            this.l = null;
        }
        get_type() {
            return "DataSourceAggregatedResult";
        }
        get type() {
            return this.get_type();
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.e("ItemRef");
        }
        get transactionType() {
            return this.k;
        }
        set transactionType(a) {
            this.k = a;
            this.e("TransactionType");
        }
        get keys() {
            return this.f;
        }
        set keys(a) {
            this.f = a;
            this.e("Keys");
        }
        get valuesRef() {
            return this.l;
        }
        set valuesRef(a) {
            this.l = a;
            this.e("ValuesRef");
        }
    }
    DataSourceAggregatedResultDescription.$t = /*@__PURE__*/ markType(DataSourceAggregatedResultDescription, 'DataSourceAggregatedResultDescription', Description.$);
    DataSourceAggregatedResultDescription.__marshalByValue = true;
    DataSourceAggregatedResultDescription.__marshalByValueAlias = "DataSourceAggregatedResult";
    return DataSourceAggregatedResultDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceAggregatedResultDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceAggregatedResultDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceAggregatedResultDescriptionMetadata.a == null) {
                DataSourceAggregatedResultDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceAggregatedResultDescriptionMetadata.c(a, DataSourceAggregatedResultDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("TransactionType", "ExportedType:string:TransactionType");
            b.item("TransactionType@names", "Add;Update;Delete");
            b.item("Keys", "Array:string");
            b.item("ValuesRef", "(w:Values,wf:Values)DataRef:object");
        }
        static d(a) {
            DataSourceAggregatedResultDescriptionMetadata.b(a);
            a.q("DataSourceAggregatedResult", () => new DataSourceAggregatedResultDescription());
            a.p("DataSourceAggregatedResult", DataSourceAggregatedResultDescriptionMetadata.a);
        }
    }
    DataSourceAggregatedResultDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceAggregatedResultDescriptionMetadata, 'DataSourceAggregatedResultDescriptionMetadata');
    DataSourceAggregatedResultDescriptionMetadata.a = null;
    return DataSourceAggregatedResultDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridDataCommittedEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = 0;
            this.f = null;
        }
        get_type() {
            return "GridDataCommittedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get commitID() {
            return this.h;
        }
        set commitID(a) {
            this.h = a;
            this.e("CommitID");
        }
        get changes() {
            return this.f;
        }
        set changes(a) {
            this.f = a;
            this.e("Changes");
        }
    }
    GridDataCommittedEventArgsDescription.$t = /*@__PURE__*/ markType(GridDataCommittedEventArgsDescription, 'GridDataCommittedEventArgsDescription', Description.$);
    return GridDataCommittedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridDataCommittedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridDataCommittedEventArgsDescriptionMetadata.a == null) {
                GridDataCommittedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridDataCommittedEventArgsDescriptionMetadata.c(a, GridDataCommittedEventArgsDescriptionMetadata.a);
                DataSourceAggregatedResultDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("CommitID", "Number:int");
            b.item("Changes", "Array:DataSourceAggregatedResultDescription:DataSourceAggregatedResult");
        }
        static d(a) {
            GridDataCommittedEventArgsDescriptionMetadata.b(a);
            a.q("GridDataCommittedEventArgs", () => new GridDataCommittedEventArgsDescription());
            a.p("GridDataCommittedEventArgs", GridDataCommittedEventArgsDescriptionMetadata.a);
        }
    }
    GridDataCommittedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridDataCommittedEventArgsDescriptionMetadata, 'GridDataCommittedEventArgsDescriptionMetadata');
    GridDataCommittedEventArgsDescriptionMetadata.a = null;
    return GridDataCommittedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittingEventArgsDescription = /*@__PURE__*/ (() => {
    class GridDataCommittingEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = 0;
        }
        get_type() {
            return "GridDataCommittingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get changes() {
            return this.f;
        }
        set changes(a) {
            this.f = a;
            this.e("Changes");
        }
        get commitID() {
            return this.h;
        }
        set commitID(a) {
            this.h = a;
            this.e("CommitID");
        }
    }
    GridDataCommittingEventArgsDescription.$t = /*@__PURE__*/ markType(GridDataCommittingEventArgsDescription, 'GridDataCommittingEventArgsDescription', Description.$);
    return GridDataCommittingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridDataCommittingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridDataCommittingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridDataCommittingEventArgsDescriptionMetadata.a == null) {
                GridDataCommittingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridDataCommittingEventArgsDescriptionMetadata.c(a, GridDataCommittingEventArgsDescriptionMetadata.a);
                DataSourceAggregatedResultDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Changes", "Array:DataSourceAggregatedResultDescription:DataSourceAggregatedResult");
            b.item("CommitID", "Number:int");
        }
        static d(a) {
            GridDataCommittingEventArgsDescriptionMetadata.b(a);
            a.q("GridDataCommittingEventArgs", () => new GridDataCommittingEventArgsDescription());
            a.p("GridDataCommittingEventArgs", GridDataCommittingEventArgsDescriptionMetadata.a);
        }
    }
    GridDataCommittingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridDataCommittingEventArgsDescriptionMetadata, 'GridDataCommittingEventArgsDescriptionMetadata');
    GridDataCommittingEventArgsDescriptionMetadata.a = null;
    return GridDataCommittingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSizeChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSizeChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = 0;
            this.f = 0;
        }
        get_type() {
            return "GridSizeChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get width() {
            return this.g;
        }
        set width(a) {
            this.g = a;
            this.e("Width");
        }
        get height() {
            return this.f;
        }
        set height(a) {
            this.f = a;
            this.e("Height");
        }
    }
    GridSizeChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSizeChangedEventArgsDescription, 'GridSizeChangedEventArgsDescription', Description.$);
    return GridSizeChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSizeChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSizeChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSizeChangedEventArgsDescriptionMetadata.a == null) {
                GridSizeChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSizeChangedEventArgsDescriptionMetadata.c(a, GridSizeChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Width", "Number:double");
            b.item("Height", "Number:double");
        }
        static d(a) {
            GridSizeChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridSizeChangedEventArgs", () => new GridSizeChangedEventArgsDescription());
            a.p("GridSizeChangedEventArgs", GridSizeChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSizeChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSizeChangedEventArgsDescriptionMetadata, 'GridSizeChangedEventArgsDescriptionMetadata');
    GridSizeChangedEventArgsDescriptionMetadata.a = null;
    return GridSizeChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridColumnsChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridColumnsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get columns() {
            return this.f;
        }
        set columns(a) {
            this.f = a;
            this.e("Columns");
        }
    }
    GridColumnsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridColumnsChangedEventArgsDescription, 'GridColumnsChangedEventArgsDescription', Description.$);
    return GridColumnsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnsChangedEventArgsDescriptionMetadata.a == null) {
                GridColumnsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnsChangedEventArgsDescriptionMetadata.c(a, GridColumnsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Columns", "Collection:Column:GridColumnCollection:Column");
        }
        static d(a) {
            GridColumnsChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridColumnsChangedEventArgs", () => new GridColumnsChangedEventArgsDescription());
            a.p("GridColumnsChangedEventArgs", GridColumnsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridColumnsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnsChangedEventArgsDescriptionMetadata, 'GridColumnsChangedEventArgsDescriptionMetadata');
    GridColumnsChangedEventArgsDescriptionMetadata.a = null;
    return GridColumnsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsAutoGeneratedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridColumnsAutoGeneratedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridColumnsAutoGeneratedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get columns() {
            return this.f;
        }
        set columns(a) {
            this.f = a;
            this.e("Columns");
        }
    }
    GridColumnsAutoGeneratedEventArgsDescription.$t = /*@__PURE__*/ markType(GridColumnsAutoGeneratedEventArgsDescription, 'GridColumnsAutoGeneratedEventArgsDescription', Description.$);
    return GridColumnsAutoGeneratedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnsAutoGeneratedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnsAutoGeneratedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a == null) {
                GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnsAutoGeneratedEventArgsDescriptionMetadata.c(a, GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Columns", "Collection:Column:GridColumnCollection:Column");
        }
        static d(a) {
            GridColumnsAutoGeneratedEventArgsDescriptionMetadata.b(a);
            a.q("GridColumnsAutoGeneratedEventArgs", () => new GridColumnsAutoGeneratedEventArgsDescription());
            a.p("GridColumnsAutoGeneratedEventArgs", GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a);
        }
    }
    GridColumnsAutoGeneratedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnsAutoGeneratedEventArgsDescriptionMetadata, 'GridColumnsAutoGeneratedEventArgsDescriptionMetadata');
    GridColumnsAutoGeneratedEventArgsDescriptionMetadata.a = null;
    return GridColumnsAutoGeneratedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedItemsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedItemsChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "GridSelectedItemsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get currentItems() {
            return this.g;
        }
        set currentItems(a) {
            this.g = a;
            this.e("CurrentItems");
        }
        get addedItems() {
            return this.f;
        }
        set addedItems(a) {
            this.f = a;
            this.e("AddedItems");
        }
        get removedItems() {
            return this.h;
        }
        set removedItems(a) {
            this.h = a;
            this.e("RemovedItems");
        }
    }
    GridSelectedItemsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedItemsChangedEventArgsDescription, 'GridSelectedItemsChangedEventArgsDescription', Description.$);
    return GridSelectedItemsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedItemsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedItemsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedItemsChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedItemsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedItemsChangedEventArgsDescriptionMetadata.c(a, GridSelectedItemsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("CurrentItems", "Collection:object:GridSelectedItemsCollection:Object");
            b.item("AddedItems", "Collection:object:GridSelectedItemsCollection:Object");
            b.item("RemovedItems", "Collection:object:GridSelectedItemsCollection:Object");
        }
        static d(a) {
            GridSelectedItemsChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridSelectedItemsChangedEventArgs", () => new GridSelectedItemsChangedEventArgsDescription());
            a.p("GridSelectedItemsChangedEventArgs", GridSelectedItemsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedItemsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedItemsChangedEventArgsDescriptionMetadata, 'GridSelectedItemsChangedEventArgsDescriptionMetadata');
    GridSelectedItemsChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedItemsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedKeysChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedKeysChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "GridSelectedKeysChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get currentKeys() {
            return this.g;
        }
        set currentKeys(a) {
            this.g = a;
            this.e("CurrentKeys");
        }
        get addedKeys() {
            return this.f;
        }
        set addedKeys(a) {
            this.f = a;
            this.e("AddedKeys");
        }
        get removedKeys() {
            return this.h;
        }
        set removedKeys(a) {
            this.h = a;
            this.e("RemovedKeys");
        }
    }
    GridSelectedKeysChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedKeysChangedEventArgsDescription, 'GridSelectedKeysChangedEventArgsDescription', Description.$);
    return GridSelectedKeysChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedKeysChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedKeysChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedKeysChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedKeysChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedKeysChangedEventArgsDescriptionMetadata.c(a, GridSelectedKeysChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("CurrentKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            b.item("AddedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            b.item("RemovedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
        }
        static d(a) {
            GridSelectedKeysChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridSelectedKeysChangedEventArgs", () => new GridSelectedKeysChangedEventArgsDescription());
            a.p("GridSelectedKeysChangedEventArgs", GridSelectedKeysChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedKeysChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedKeysChangedEventArgsDescriptionMetadata, 'GridSelectedKeysChangedEventArgsDescriptionMetadata');
    GridSelectedKeysChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedKeysChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedCellsChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "GridSelectedCellsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get currentCells() {
            return this.g;
        }
        set currentCells(a) {
            this.g = a;
            this.e("CurrentCells");
        }
        get addedCells() {
            return this.f;
        }
        set addedCells(a) {
            this.f = a;
            this.e("AddedCells");
        }
        get removedCells() {
            return this.h;
        }
        set removedCells(a) {
            this.h = a;
            this.e("RemovedCells");
        }
    }
    GridSelectedCellsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedCellsChangedEventArgsDescription, 'GridSelectedCellsChangedEventArgsDescription', Description.$);
    return GridSelectedCellsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedCellsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedCellsChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedCellsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedCellsChangedEventArgsDescriptionMetadata.c(a, GridSelectedCellsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("CurrentCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
            b.item("AddedCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
            b.item("RemovedCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
        }
        static d(a) {
            GridSelectedCellsChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridSelectedCellsChangedEventArgs", () => new GridSelectedCellsChangedEventArgsDescription());
            a.p("GridSelectedCellsChangedEventArgs", GridSelectedCellsChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedCellsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedCellsChangedEventArgsDescriptionMetadata, 'GridSelectedCellsChangedEventArgsDescriptionMetadata');
    GridSelectedCellsChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedCellsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridActiveCellChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridActiveCellChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "GridActiveCellChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get newActiveCell() {
            return this.f;
        }
        set newActiveCell(a) {
            this.f = a;
            this.e("NewActiveCell");
        }
        get oldActiveCell() {
            return this.g;
        }
        set oldActiveCell(a) {
            this.g = a;
            this.e("OldActiveCell");
        }
    }
    GridActiveCellChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridActiveCellChangedEventArgsDescription, 'GridActiveCellChangedEventArgsDescription', Description.$);
    return GridActiveCellChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridActiveCellChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridActiveCellChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridActiveCellChangedEventArgsDescriptionMetadata.a == null) {
                GridActiveCellChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridActiveCellChangedEventArgsDescriptionMetadata.c(a, GridActiveCellChangedEventArgsDescriptionMetadata.a);
                GridCellPositionDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("NewActiveCell", "ExportedType:GridCellPosition");
            b.item("OldActiveCell", "ExportedType:GridCellPosition");
        }
        static d(a) {
            GridActiveCellChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridActiveCellChangedEventArgs", () => new GridActiveCellChangedEventArgsDescription());
            a.p("GridActiveCellChangedEventArgs", GridActiveCellChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridActiveCellChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridActiveCellChangedEventArgsDescriptionMetadata, 'GridActiveCellChangedEventArgsDescriptionMetadata');
    GridActiveCellChangedEventArgsDescriptionMetadata.a = null;
    return GridActiveCellChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellRangesChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridSelectedCellRangesChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
            this.h = null;
            this.i = null;
        }
        get_type() {
            return "GridSelectedCellRangesChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get currentRanges() {
            return this.g;
        }
        set currentRanges(a) {
            this.g = a;
            this.e("CurrentRanges");
        }
        get addedRanges() {
            return this.f;
        }
        set addedRanges(a) {
            this.f = a;
            this.e("AddedRanges");
        }
        get removedRanges() {
            return this.h;
        }
        set removedRanges(a) {
            this.h = a;
            this.e("RemovedRanges");
        }
        get updatedRanges() {
            return this.i;
        }
        set updatedRanges(a) {
            this.i = a;
            this.e("UpdatedRanges");
        }
    }
    GridSelectedCellRangesChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridSelectedCellRangesChangedEventArgsDescription, 'GridSelectedCellRangesChangedEventArgsDescription', Description.$);
    return GridSelectedCellRangesChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridSelectedCellRangesChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridSelectedCellRangesChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a == null) {
                GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridSelectedCellRangesChangedEventArgsDescriptionMetadata.c(a, GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("CurrentRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            b.item("AddedRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            b.item("RemovedRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            b.item("UpdatedRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
        }
        static d(a) {
            GridSelectedCellRangesChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridSelectedCellRangesChangedEventArgs", () => new GridSelectedCellRangesChangedEventArgsDescription());
            a.p("GridSelectedCellRangesChangedEventArgs", GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridSelectedCellRangesChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridSelectedCellRangesChangedEventArgsDescriptionMetadata, 'GridSelectedCellRangesChangedEventArgsDescriptionMetadata');
    GridSelectedCellRangesChangedEventArgsDescriptionMetadata.a = null;
    return GridSelectedCellRangesChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnWidthChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridColumnWidthChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.i = null;
            this.h = null;
        }
        get_type() {
            return "GridColumnWidthChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get oldWidth() {
            return this.i;
        }
        set oldWidth(a) {
            this.i = a;
            this.e("OldWidth");
        }
        get newWidth() {
            return this.h;
        }
        set newWidth(a) {
            this.h = a;
            this.e("NewWidth");
        }
    }
    GridColumnWidthChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridColumnWidthChangedEventArgsDescription, 'GridColumnWidthChangedEventArgsDescription', Description.$);
    return GridColumnWidthChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnWidthChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnWidthChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnWidthChangedEventArgsDescriptionMetadata.a == null) {
                GridColumnWidthChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnWidthChangedEventArgsDescriptionMetadata.c(a, GridColumnWidthChangedEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
                ColumnWidthDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
            b.item("OldWidth", "ExportedType:ColumnWidth");
            b.item("NewWidth", "ExportedType:ColumnWidth");
        }
        static d(a) {
            GridColumnWidthChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridColumnWidthChangedEventArgs", () => new GridColumnWidthChangedEventArgsDescription());
            a.p("GridColumnWidthChangedEventArgs", GridColumnWidthChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridColumnWidthChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnWidthChangedEventArgsDescriptionMetadata, 'GridColumnWidthChangedEventArgsDescriptionMetadata');
    GridColumnWidthChangedEventArgsDescriptionMetadata.a = null;
    return GridColumnWidthChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditStartedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEditStartedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = 0;
            this.j = null;
        }
        get_type() {
            return "GridCellEditStartedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get row() {
            return this.h;
        }
        set row(a) {
            this.h = a;
            this.e("Row");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.e("ItemRef");
        }
    }
    GridCellEditStartedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEditStartedEventArgsDescription, 'GridCellEditStartedEventArgsDescription', Description.$);
    return GridCellEditStartedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditStartedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEditStartedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEditStartedEventArgsDescriptionMetadata.a == null) {
                GridCellEditStartedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEditStartedEventArgsDescriptionMetadata.c(a, GridCellEditStartedEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
            b.item("Row", "Number:int");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridCellEditStartedEventArgsDescriptionMetadata.b(a);
            a.q("GridCellEditStartedEventArgs", () => new GridCellEditStartedEventArgsDescription());
            a.p("GridCellEditStartedEventArgs", GridCellEditStartedEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEditStartedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEditStartedEventArgsDescriptionMetadata, 'GridCellEditStartedEventArgsDescriptionMetadata');
    GridCellEditStartedEventArgsDescriptionMetadata.a = null;
    return GridCellEditStartedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditEndedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEditEndedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = 0;
            this.j = null;
        }
        get_type() {
            return "GridCellEditEndedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get row() {
            return this.h;
        }
        set row(a) {
            this.h = a;
            this.e("Row");
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.e("ItemRef");
        }
    }
    GridCellEditEndedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEditEndedEventArgsDescription, 'GridCellEditEndedEventArgsDescription', Description.$);
    return GridCellEditEndedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditEndedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEditEndedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEditEndedEventArgsDescriptionMetadata.a == null) {
                GridCellEditEndedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEditEndedEventArgsDescriptionMetadata.c(a, GridCellEditEndedEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
            b.item("Row", "Number:int");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridCellEditEndedEventArgsDescriptionMetadata.b(a);
            a.q("GridCellEditEndedEventArgs", () => new GridCellEditEndedEventArgsDescription());
            a.p("GridCellEditEndedEventArgs", GridCellEditEndedEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEditEndedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEditEndedEventArgsDescriptionMetadata, 'GridCellEditEndedEventArgsDescriptionMetadata');
    GridCellEditEndedEventArgsDescriptionMetadata.a = null;
    return GridCellEditEndedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditStartedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridRowEditStartedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
            this.h = null;
        }
        get_type() {
            return "GridRowEditStartedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get row() {
            return this.f;
        }
        set row(a) {
            this.f = a;
            this.e("Row");
        }
        get itemRef() {
            return this.h;
        }
        set itemRef(a) {
            this.h = a;
            this.e("ItemRef");
        }
    }
    GridRowEditStartedEventArgsDescription.$t = /*@__PURE__*/ markType(GridRowEditStartedEventArgsDescription, 'GridRowEditStartedEventArgsDescription', Description.$);
    return GridRowEditStartedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditStartedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridRowEditStartedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridRowEditStartedEventArgsDescriptionMetadata.a == null) {
                GridRowEditStartedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridRowEditStartedEventArgsDescriptionMetadata.c(a, GridRowEditStartedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Row", "Number:int");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridRowEditStartedEventArgsDescriptionMetadata.b(a);
            a.q("GridRowEditStartedEventArgs", () => new GridRowEditStartedEventArgsDescription());
            a.p("GridRowEditStartedEventArgs", GridRowEditStartedEventArgsDescriptionMetadata.a);
        }
    }
    GridRowEditStartedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridRowEditStartedEventArgsDescriptionMetadata, 'GridRowEditStartedEventArgsDescriptionMetadata');
    GridRowEditStartedEventArgsDescriptionMetadata.a = null;
    return GridRowEditStartedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditEndedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridRowEditEndedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
            this.h = null;
        }
        get_type() {
            return "GridRowEditEndedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get row() {
            return this.f;
        }
        set row(a) {
            this.f = a;
            this.e("Row");
        }
        get itemRef() {
            return this.h;
        }
        set itemRef(a) {
            this.h = a;
            this.e("ItemRef");
        }
    }
    GridRowEditEndedEventArgsDescription.$t = /*@__PURE__*/ markType(GridRowEditEndedEventArgsDescription, 'GridRowEditEndedEventArgsDescription', Description.$);
    return GridRowEditEndedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridRowEditEndedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridRowEditEndedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridRowEditEndedEventArgsDescriptionMetadata.a == null) {
                GridRowEditEndedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridRowEditEndedEventArgsDescriptionMetadata.c(a, GridRowEditEndedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Row", "Number:int");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
        }
        static d(a) {
            GridRowEditEndedEventArgsDescriptionMetadata.b(a);
            a.q("GridRowEditEndedEventArgs", () => new GridRowEditEndedEventArgsDescription());
            a.p("GridRowEditEndedEventArgs", GridRowEditEndedEventArgsDescriptionMetadata.a);
        }
    }
    GridRowEditEndedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridRowEditEndedEventArgsDescriptionMetadata, 'GridRowEditEndedEventArgsDescriptionMetadata');
    GridRowEditEndedEventArgsDescriptionMetadata.a = null;
    return GridRowEditEndedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridDescription = /*@__PURE__*/ (() => {
    class DataGridDescription extends Description {
        constructor() {
            super();
            this.hb = null;
            this.fy = null;
            this.d6 = null;
            this.e1 = null;
            this.et = null;
            this.bm = false;
            this.f4 = null;
            this.f5 = null;
            this.fg = null;
            this.cl = 0;
            this.cm = 0;
            this.cn = 0;
            this.co = 0;
            this.a5 = null;
            this.a7 = null;
            this.a9 = null;
            this.a3 = null;
            this.ax = null;
            this.az = null;
            this.ar = null;
            this.ap = null;
            this.a1 = null;
            this.h = null;
            this.j = null;
            this.fa = null;
            this.dk = 0;
            this.dr = 0;
            this.ci = 0;
            this.dj = 0;
            this.dn = 0;
            this.e8 = null;
            this.an = null;
            this.fp = null;
            this.fe = null;
            this.ff = null;
            this.bd = false;
            this.bc = false;
            this.ds = 0;
            this.bl = false;
            this.eo = null;
            this.ez = null;
            this.ea = null;
            this.f6 = null;
            this.f3 = null;
            this.el = null;
            this.at = null;
            this.e0 = null;
            this.e4 = null;
            this.es = null;
            this.er = null;
            this.ep = null;
            this.gm = null;
            this.d2 = null;
            this.gl = null;
            this.s = null;
            this.t = null;
            this.r = null;
            this.q = null;
            this.m = null;
            this.n = null;
            this.bf = false;
            this.bj = false;
            this.bk = false;
            this.ek = null;
            this.gf = null;
            this.gq = null;
            this.g1 = null;
            this.cq = 0;
            this.fb = null;
            this.cj = 0;
            this.fc = null;
            this.fd = null;
            this.ck = 0;
            this.e9 = null;
            this.gp = null;
            this.f0 = null;
            this.fz = null;
            this.av = null;
            this.d8 = null;
            this.em = null;
            this.fv = null;
            this.fw = null;
            this.ed = null;
            this.cd = 0;
            this.ee = null;
            this.ef = null;
            this.gb = null;
            this.gg = null;
            this.gc = null;
            this.cr = 0;
            this.gd = null;
            this.ge = null;
            this.gr = null;
            this.cs = 0;
            this.gs = null;
            this.gt = null;
            this.g2 = null;
            this.cu = 0;
            this.g3 = null;
            this.g4 = null;
            this.gz = null;
            this.gw = null;
            this.ct = 0;
            this.gx = null;
            this.gy = null;
            this.g7 = null;
            this.cv = 0;
            this.g8 = null;
            this.g9 = null;
            this.ha = null;
            this.gu = null;
            this.g5 = null;
            this.gv = null;
            this.g6 = null;
            this.dq = 0;
            this.dp = 0;
            this.fu = null;
            this.fo = null;
            this.fx = null;
            this.fq = null;
            this.cp = 0;
            this.fr = null;
            this.fs = null;
            this.f7 = null;
            this.ft = null;
            this.ga = null;
            this.f8 = null;
            this.f9 = null;
            this.dm = 0;
            this.dl = 0;
            this.e2 = null;
            this.eu = null;
            this.br = false;
            this.ev = null;
            this.ex = null;
            this.ew = null;
            this.d7 = null;
            this.b9 = 0;
            this.ca = 0;
            this.cb = 0;
            this.cc = 0;
            this.bn = false;
            this.cf = 0;
            this.ce = 0;
            this.cg = 0;
            this.ch = 0;
            this.be = false;
            this.p = null;
            this.u = null;
            this.l = null;
            this.k = null;
            this.v = null;
            this.g0 = null;
            this.bh = false;
            this.fm = null;
            this.bi = false;
            this.fn = null;
            this.bb = false;
            this.o = null;
            this.g = null;
            this.f = null;
            this.i = null;
            this.bq = false;
            this.bp = false;
            this.bo = false;
            this.fh = null;
            this.fi = null;
            this.bg = false;
            this.fk = null;
            this.fj = null;
            this.ei = null;
            this.ej = null;
            this.eg = null;
            this.eh = null;
            this.d9 = null;
            this.go = null;
            this.fl = null;
            this.eq = null;
            this.ey = null;
            this.en = null;
            this.e6 = null;
            this.e7 = null;
            this.gn = null;
            this.d4 = null;
            this.e3 = null;
            this.gj = null;
            this.gk = null;
            this.gi = null;
            this.d3 = null;
            this.gh = null;
            this.e5 = null;
            this.ec = null;
            this.eb = null;
            this.f2 = null;
            this.f1 = null;
            this.d5 = null;
        }
        get width() {
            return this.hb;
        }
        set width(a) {
            this.hb = a;
            this.e("Width");
        }
        get height() {
            return this.fy;
        }
        set height(a) {
            this.fy = a;
            this.e("Height");
        }
        get background() {
            return this.d6;
        }
        set background(a) {
            this.d6 = a;
            this.e("Background");
        }
        get_type() {
            return "DataGrid";
        }
        get type() {
            return this.get_type();
        }
        get columnResizingMode() {
            return this.e1;
        }
        set columnResizingMode(a) {
            this.e1 = a;
            this.e("ColumnResizingMode");
        }
        get columnMovingMode() {
            return this.et;
        }
        set columnMovingMode(a) {
            this.et = a;
            this.e("ColumnMovingMode");
        }
        get isRowHoverEnabled() {
            return this.bm;
        }
        set isRowHoverEnabled(a) {
            this.bm = a;
            this.e("IsRowHoverEnabled");
        }
        get rowHoverBackground() {
            return this.f4;
        }
        set rowHoverBackground(a) {
            this.f4 = a;
            this.e("RowHoverBackground");
        }
        get rowHoverTextColor() {
            return this.f5;
        }
        set rowHoverTextColor(a) {
            this.f5 = a;
            this.e("RowHoverTextColor");
        }
        get editRowBorder() {
            return this.fg;
        }
        set editRowBorder(a) {
            this.fg = a;
            this.e("EditRowBorder");
        }
        get editRowBorderWidthBottom() {
            return this.cl;
        }
        set editRowBorderWidthBottom(a) {
            this.cl = a;
            this.e("EditRowBorderWidthBottom");
        }
        get editRowBorderWidthLeft() {
            return this.cm;
        }
        set editRowBorderWidthLeft(a) {
            this.cm = a;
            this.e("EditRowBorderWidthLeft");
        }
        get editRowBorderWidthRight() {
            return this.cn;
        }
        set editRowBorderWidthRight(a) {
            this.cn = a;
            this.e("EditRowBorderWidthRight");
        }
        get editRowBorderWidthTop() {
            return this.co;
        }
        set editRowBorderWidthTop(a) {
            this.co = a;
            this.e("EditRowBorderWidthTop");
        }
        get sectionHeader() {
            return this.a5;
        }
        set sectionHeader(a) {
            this.a5 = a;
            this.e("SectionHeader");
        }
        get summaryRowRoot() {
            return this.a7;
        }
        set summaryRowRoot(a) {
            this.a7 = a;
            this.e("SummaryRowRoot");
        }
        get summaryRowSection() {
            return this.a9;
        }
        set summaryRowSection(a) {
            this.a9 = a;
            this.e("SummaryRowSection");
        }
        get rowSeparator() {
            return this.a3;
        }
        set rowSeparator(a) {
            this.a3 = a;
            this.e("RowSeparator");
        }
        get headerRowSeparator() {
            return this.ax;
        }
        set headerRowSeparator(a) {
            this.ax = a;
            this.e("HeaderRowSeparator");
        }
        get headerSeparator() {
            return this.az;
        }
        set headerSeparator(a) {
            this.az = a;
            this.e("HeaderSeparator");
        }
        get columnResizingSeparator() {
            return this.ar;
        }
        set columnResizingSeparator(a) {
            this.ar = a;
            this.e("ColumnResizingSeparator");
        }
        get columnMovingSeparator() {
            return this.ap;
        }
        set columnMovingSeparator(a) {
            this.ap = a;
            this.e("ColumnMovingSeparator");
        }
        get pinnedAreaSeparator() {
            return this.a1;
        }
        set pinnedAreaSeparator(a) {
            this.a1 = a;
            this.e("PinnedAreaSeparator");
        }
        get autoGenerateDesiredProperties() {
            return this.h;
        }
        set autoGenerateDesiredProperties(a) {
            this.h = a;
            this.e("AutoGenerateDesiredProperties");
        }
        get dataSourceDesiredProperties() {
            return this.j;
        }
        set dataSourceDesiredProperties(a) {
            this.j = a;
            this.e("DataSourceDesiredProperties");
        }
        get density() {
            return this.fa;
        }
        set density(a) {
            this.fa = a;
            this.e("Density");
        }
        get actualRowHeight() {
            return this.dk;
        }
        set actualRowHeight(a) {
            this.dk = a;
            this.e("ActualRowHeight");
        }
        get rowHeight() {
            return this.dr;
        }
        set rowHeight(a) {
            this.dr = a;
            this.e("RowHeight");
        }
        get defaultColumnMinWidth() {
            return this.ci;
        }
        set defaultColumnMinWidth(a) {
            this.ci = a;
            this.e("DefaultColumnMinWidth");
        }
        get actualHeaderHeight() {
            return this.dj;
        }
        set actualHeaderHeight(a) {
            this.dj = a;
            this.e("ActualHeaderHeight");
        }
        get headerHeight() {
            return this.dn;
        }
        set headerHeight(a) {
            this.dn = a;
            this.e("HeaderHeight");
        }
        get dataSourceRef() {
            return this.e8;
        }
        set dataSourceRef(a) {
            this.e8 = a;
            this.e("DataSourceRef");
        }
        get dataSource() {
            return this.an;
        }
        set dataSource(a) {
            this.an = a;
            this.e("DataSource");
        }
        get headerClickAction() {
            return this.fp;
        }
        set headerClickAction(a) {
            this.fp = a;
            this.e("HeaderClickAction");
        }
        get editMode() {
            return this.fe;
        }
        set editMode(a) {
            this.fe = a;
            this.e("EditMode");
        }
        get editModeClickAction() {
            return this.ff;
        }
        set editModeClickAction(a) {
            this.ff = a;
            this.e("EditModeClickAction");
        }
        get editOnKeyPress() {
            return this.bd;
        }
        set editOnKeyPress(a) {
            this.bd = a;
            this.e("EditOnKeyPress");
        }
        get autoGenerateColumns() {
            return this.bc;
        }
        set autoGenerateColumns(a) {
            this.bc = a;
            this.e("AutoGenerateColumns");
        }
        get rowSeparatorHeight() {
            return this.ds;
        }
        set rowSeparatorHeight(a) {
            this.ds = a;
            this.e("RowSeparatorHeight");
        }
        get isPlaceholderRenderingEnabled() {
            return this.bl;
        }
        set isPlaceholderRenderingEnabled(a) {
            this.bl = a;
            this.e("IsPlaceholderRenderingEnabled");
        }
        get columnAddingAnimationMode() {
            return this.eo;
        }
        set columnAddingAnimationMode(a) {
            this.eo = a;
            this.e("ColumnAddingAnimationMode");
        }
        get columnPropertyUpdatingAnimationMode() {
            return this.ez;
        }
        set columnPropertyUpdatingAnimationMode(a) {
            this.ez = a;
            this.e("ColumnPropertyUpdatingAnimationMode");
        }
        get cellDataLoadedAnimationMode() {
            return this.ea;
        }
        set cellDataLoadedAnimationMode(a) {
            this.ea = a;
            this.e("CellDataLoadedAnimationMode");
        }
        get rowSelectionAnimationMode() {
            return this.f6;
        }
        set rowSelectionAnimationMode(a) {
            this.f6 = a;
            this.e("RowSelectionAnimationMode");
        }
        get rowHoverAnimationMode() {
            return this.f3;
        }
        set rowHoverAnimationMode(a) {
            this.f3 = a;
            this.e("RowHoverAnimationMode");
        }
        get cellSelectionAnimationMode() {
            return this.el;
        }
        set cellSelectionAnimationMode(a) {
            this.el = a;
            this.e("CellSelectionAnimationMode");
        }
        get animationSettings() {
            return this.at;
        }
        set animationSettings(a) {
            this.at = a;
            this.e("AnimationSettings");
        }
        get columnResizingAnimationMode() {
            return this.e0;
        }
        set columnResizingAnimationMode(a) {
            this.e0 = a;
            this.e("ColumnResizingAnimationMode");
        }
        get columnShowingAnimationMode() {
            return this.e4;
        }
        set columnShowingAnimationMode(a) {
            this.e4 = a;
            this.e("ColumnShowingAnimationMode");
        }
        get columnMovingAnimationMode() {
            return this.es;
        }
        set columnMovingAnimationMode(a) {
            this.es = a;
            this.e("ColumnMovingAnimationMode");
        }
        get columnHidingAnimationMode() {
            return this.er;
        }
        set columnHidingAnimationMode(a) {
            this.er = a;
            this.e("ColumnHidingAnimationMode");
        }
        get columnExchangingAnimationMode() {
            return this.ep;
        }
        set columnExchangingAnimationMode(a) {
            this.ep = a;
            this.e("ColumnExchangingAnimationMode");
        }
        get selectionMode() {
            return this.gm;
        }
        set selectionMode(a) {
            this.gm = a;
            this.e("SelectionMode");
        }
        get activationMode() {
            return this.d2;
        }
        set activationMode(a) {
            this.d2 = a;
            this.e("ActivationMode");
        }
        get selectionBehavior() {
            return this.gl;
        }
        set selectionBehavior(a) {
            this.gl = a;
            this.e("SelectionBehavior");
        }
        get selectedItems() {
            return this.s;
        }
        set selectedItems(a) {
            this.s = a;
            this.e("SelectedItems");
        }
        get selectedKeys() {
            return this.t;
        }
        set selectedKeys(a) {
            this.t = a;
            this.e("SelectedKeys");
        }
        get selectedCells() {
            return this.r;
        }
        set selectedCells(a) {
            this.r = a;
            this.e("SelectedCells");
        }
        get selectedCellRanges() {
            return this.q;
        }
        set selectedCellRanges(a) {
            this.q = a;
            this.e("SelectedCellRanges");
        }
        get pinnedItems() {
            return this.m;
        }
        set pinnedItems(a) {
            this.m = a;
            this.e("PinnedItems");
        }
        get pinnedKeys() {
            return this.n;
        }
        set pinnedKeys(a) {
            this.n = a;
            this.e("PinnedKeys");
        }
        get isColumnOptionsEnabled() {
            return this.bf;
        }
        set isColumnOptionsEnabled(a) {
            this.bf = a;
            this.e("IsColumnOptionsEnabled");
        }
        get isGroupRowSticky() {
            return this.bj;
        }
        set isGroupRowSticky(a) {
            this.bj = a;
            this.e("IsGroupRowSticky");
        }
        get isHeaderSeparatorVisible() {
            return this.bk;
        }
        set isHeaderSeparatorVisible(a) {
            this.bk = a;
            this.e("IsHeaderSeparatorVisible");
        }
        get cellSelectedBackground() {
            return this.ek;
        }
        set cellSelectedBackground(a) {
            this.ek = a;
            this.e("CellSelectedBackground");
        }
        get sectionHeaderSelectedBackground() {
            return this.gf;
        }
        set sectionHeaderSelectedBackground(a) {
            this.gf = a;
            this.e("SectionHeaderSelectedBackground");
        }
        get summaryRootBackground() {
            return this.gq;
        }
        set summaryRootBackground(a) {
            this.gq = a;
            this.e("SummaryRootBackground");
        }
        get summarySectionBackground() {
            return this.g1;
        }
        set summarySectionBackground(a) {
            this.g1 = a;
            this.e("SummarySectionBackground");
        }
        get pinnedRowOpacity() {
            return this.cq;
        }
        set pinnedRowOpacity(a) {
            this.cq = a;
            this.e("PinnedRowOpacity");
        }
        get editFontFamily() {
            return this.fb;
        }
        set editFontFamily(a) {
            this.fb = a;
            this.e("EditFontFamily");
        }
        get editFontSize() {
            return this.cj;
        }
        set editFontSize(a) {
            this.cj = a;
            this.e("EditFontSize");
        }
        get editFontStyle() {
            return this.fc;
        }
        set editFontStyle(a) {
            this.fc = a;
            this.e("EditFontStyle");
        }
        get editFontWeight() {
            return this.fd;
        }
        set editFontWeight(a) {
            this.fd = a;
            this.e("EditFontWeight");
        }
        get editOpacity() {
            return this.ck;
        }
        set editOpacity(a) {
            this.ck = a;
            this.e("EditOpacity");
        }
        get deletedTextColor() {
            return this.e9;
        }
        set deletedTextColor(a) {
            this.e9 = a;
            this.e("DeletedTextColor");
        }
        get stickyRowBackground() {
            return this.gp;
        }
        set stickyRowBackground(a) {
            this.gp = a;
            this.e("StickyRowBackground");
        }
        get pinnedRowBackground() {
            return this.f0;
        }
        set pinnedRowBackground(a) {
            this.f0 = a;
            this.e("PinnedRowBackground");
        }
        get lastStickyRowBackground() {
            return this.fz;
        }
        set lastStickyRowBackground(a) {
            this.fz = a;
            this.e("LastStickyRowBackground");
        }
        get activeCell() {
            return this.av;
        }
        set activeCell(a) {
            this.av = a;
            this.e("ActiveCell");
        }
        get cellBackground() {
            return this.d8;
        }
        set cellBackground(a) {
            this.d8 = a;
            this.e("CellBackground");
        }
        get cellTextColor() {
            return this.em;
        }
        set cellTextColor(a) {
            this.em = a;
            this.e("CellTextColor");
        }
        get headerSortIndicatorColor() {
            return this.fv;
        }
        set headerSortIndicatorColor(a) {
            this.fv = a;
            this.e("HeaderSortIndicatorColor");
        }
        get headerSortIndicatorStyle() {
            return this.fw;
        }
        set headerSortIndicatorStyle(a) {
            this.fw = a;
            this.e("HeaderSortIndicatorStyle");
        }
        get cellFontFamily() {
            return this.ed;
        }
        set cellFontFamily(a) {
            this.ed = a;
            this.e("CellFontFamily");
        }
        get cellFontSize() {
            return this.cd;
        }
        set cellFontSize(a) {
            this.cd = a;
            this.e("CellFontSize");
        }
        get cellFontStyle() {
            return this.ee;
        }
        set cellFontStyle(a) {
            this.ee = a;
            this.e("CellFontStyle");
        }
        get cellFontWeight() {
            return this.ef;
        }
        set cellFontWeight(a) {
            this.ef = a;
            this.e("CellFontWeight");
        }
        get sectionHeaderBackground() {
            return this.gb;
        }
        set sectionHeaderBackground(a) {
            this.gb = a;
            this.e("SectionHeaderBackground");
        }
        get sectionHeaderTextColor() {
            return this.gg;
        }
        set sectionHeaderTextColor(a) {
            this.gg = a;
            this.e("SectionHeaderTextColor");
        }
        get sectionHeaderFontFamily() {
            return this.gc;
        }
        set sectionHeaderFontFamily(a) {
            this.gc = a;
            this.e("SectionHeaderFontFamily");
        }
        get sectionHeaderFontSize() {
            return this.cr;
        }
        set sectionHeaderFontSize(a) {
            this.cr = a;
            this.e("SectionHeaderFontSize");
        }
        get sectionHeaderFontStyle() {
            return this.gd;
        }
        set sectionHeaderFontStyle(a) {
            this.gd = a;
            this.e("SectionHeaderFontStyle");
        }
        get sectionHeaderFontWeight() {
            return this.ge;
        }
        set sectionHeaderFontWeight(a) {
            this.ge = a;
            this.e("SectionHeaderFontWeight");
        }
        get summaryRootLabelFontFamily() {
            return this.gr;
        }
        set summaryRootLabelFontFamily(a) {
            this.gr = a;
            this.e("SummaryRootLabelFontFamily");
        }
        get summaryRootLabelFontSize() {
            return this.cs;
        }
        set summaryRootLabelFontSize(a) {
            this.cs = a;
            this.e("SummaryRootLabelFontSize");
        }
        get summaryRootLabelFontStyle() {
            return this.gs;
        }
        set summaryRootLabelFontStyle(a) {
            this.gs = a;
            this.e("SummaryRootLabelFontStyle");
        }
        get summaryRootLabelFontWeight() {
            return this.gt;
        }
        set summaryRootLabelFontWeight(a) {
            this.gt = a;
            this.e("SummaryRootLabelFontWeight");
        }
        get summarySectionLabelFontFamily() {
            return this.g2;
        }
        set summarySectionLabelFontFamily(a) {
            this.g2 = a;
            this.e("SummarySectionLabelFontFamily");
        }
        get summarySectionLabelFontSize() {
            return this.cu;
        }
        set summarySectionLabelFontSize(a) {
            this.cu = a;
            this.e("SummarySectionLabelFontSize");
        }
        get summarySectionLabelFontStyle() {
            return this.g3;
        }
        set summarySectionLabelFontStyle(a) {
            this.g3 = a;
            this.e("SummarySectionLabelFontStyle");
        }
        get summarySectionLabelFontWeight() {
            return this.g4;
        }
        set summarySectionLabelFontWeight(a) {
            this.g4 = a;
            this.e("SummarySectionLabelFontWeight");
        }
        get summaryRootValueTextColor() {
            return this.gz;
        }
        set summaryRootValueTextColor(a) {
            this.gz = a;
            this.e("SummaryRootValueTextColor");
        }
        get summaryRootValueFontFamily() {
            return this.gw;
        }
        set summaryRootValueFontFamily(a) {
            this.gw = a;
            this.e("SummaryRootValueFontFamily");
        }
        get summaryRootValueFontSize() {
            return this.ct;
        }
        set summaryRootValueFontSize(a) {
            this.ct = a;
            this.e("SummaryRootValueFontSize");
        }
        get summaryRootValueFontStyle() {
            return this.gx;
        }
        set summaryRootValueFontStyle(a) {
            this.gx = a;
            this.e("SummaryRootValueFontStyle");
        }
        get summaryRootValueFontWeight() {
            return this.gy;
        }
        set summaryRootValueFontWeight(a) {
            this.gy = a;
            this.e("SummaryRootValueFontWeight");
        }
        get summarySectionValueFontFamily() {
            return this.g7;
        }
        set summarySectionValueFontFamily(a) {
            this.g7 = a;
            this.e("SummarySectionValueFontFamily");
        }
        get summarySectionValueFontSize() {
            return this.cv;
        }
        set summarySectionValueFontSize(a) {
            this.cv = a;
            this.e("SummarySectionValueFontSize");
        }
        get summarySectionValueFontStyle() {
            return this.g8;
        }
        set summarySectionValueFontStyle(a) {
            this.g8 = a;
            this.e("SummarySectionValueFontStyle");
        }
        get summarySectionValueFontWeight() {
            return this.g9;
        }
        set summarySectionValueFontWeight(a) {
            this.g9 = a;
            this.e("SummarySectionValueFontWeight");
        }
        get summarySectionValueTextColor() {
            return this.ha;
        }
        set summarySectionValueTextColor(a) {
            this.ha = a;
            this.e("SummarySectionValueTextColor");
        }
        get summaryRootLabelTextColor() {
            return this.gu;
        }
        set summaryRootLabelTextColor(a) {
            this.gu = a;
            this.e("SummaryRootLabelTextColor");
        }
        get summarySectionLabelTextColor() {
            return this.g5;
        }
        set summarySectionLabelTextColor(a) {
            this.g5 = a;
            this.e("SummarySectionLabelTextColor");
        }
        get summaryRootSelectedBackground() {
            return this.gv;
        }
        set summaryRootSelectedBackground(a) {
            this.gv = a;
            this.e("SummaryRootSelectedBackground");
        }
        get summarySectionSelectedBackground() {
            return this.g6;
        }
        set summarySectionSelectedBackground(a) {
            this.g6 = a;
            this.e("SummarySectionSelectedBackground");
        }
        get pinnedAreaSeparatorWidth() {
            return this.dq;
        }
        set pinnedAreaSeparatorWidth(a) {
            this.dq = a;
            this.e("PinnedAreaSeparatorWidth");
        }
        get headerSeparatorWidth() {
            return this.dp;
        }
        set headerSeparatorWidth(a) {
            this.dp = a;
            this.e("HeaderSeparatorWidth");
        }
        get headerSeparatorBackground() {
            return this.fu;
        }
        set headerSeparatorBackground(a) {
            this.fu = a;
            this.e("HeaderSeparatorBackground");
        }
        get headerBackground() {
            return this.fo;
        }
        set headerBackground(a) {
            this.fo = a;
            this.e("HeaderBackground");
        }
        get headerTextColor() {
            return this.fx;
        }
        set headerTextColor(a) {
            this.fx = a;
            this.e("HeaderTextColor");
        }
        get headerFontFamily() {
            return this.fq;
        }
        set headerFontFamily(a) {
            this.fq = a;
            this.e("HeaderFontFamily");
        }
        get headerFontSize() {
            return this.cp;
        }
        set headerFontSize(a) {
            this.cp = a;
            this.e("HeaderFontSize");
        }
        get headerFontStyle() {
            return this.fr;
        }
        set headerFontStyle(a) {
            this.fr = a;
            this.e("HeaderFontStyle");
        }
        get headerFontWeight() {
            return this.fs;
        }
        set headerFontWeight(a) {
            this.fs = a;
            this.e("HeaderFontWeight");
        }
        get rowSeparatorBackground() {
            return this.f7;
        }
        set rowSeparatorBackground(a) {
            this.f7 = a;
            this.e("RowSeparatorBackground");
        }
        get headerRowSeparatorBackground() {
            return this.ft;
        }
        set headerRowSeparatorBackground(a) {
            this.ft = a;
            this.e("HeaderRowSeparatorBackground");
        }
        get rowSeparatorStickyRowBackground() {
            return this.ga;
        }
        set rowSeparatorStickyRowBackground(a) {
            this.ga = a;
            this.e("RowSeparatorStickyRowBackground");
        }
        get rowSeparatorLastStickyRowBackground() {
            return this.f8;
        }
        set rowSeparatorLastStickyRowBackground(a) {
            this.f8 = a;
            this.e("RowSeparatorLastStickyRowBackground");
        }
        get rowSeparatorPinnedRowBackground() {
            return this.f9;
        }
        set rowSeparatorPinnedRowBackground(a) {
            this.f9 = a;
            this.e("RowSeparatorPinnedRowBackground");
        }
        get columnResizingSeparatorWidth() {
            return this.dm;
        }
        set columnResizingSeparatorWidth(a) {
            this.dm = a;
            this.e("ColumnResizingSeparatorWidth");
        }
        get columnMovingSeparatorWidth() {
            return this.dl;
        }
        set columnMovingSeparatorWidth(a) {
            this.dl = a;
            this.e("ColumnMovingSeparatorWidth");
        }
        get columnResizingSeparatorBackground() {
            return this.e2;
        }
        set columnResizingSeparatorBackground(a) {
            this.e2 = a;
            this.e("ColumnResizingSeparatorBackground");
        }
        get columnMovingSeparatorBackground() {
            return this.eu;
        }
        set columnMovingSeparatorBackground(a) {
            this.eu = a;
            this.e("ColumnMovingSeparatorBackground");
        }
        get shiftSectionContent() {
            return this.br;
        }
        set shiftSectionContent(a) {
            this.br = a;
            this.e("ShiftSectionContent");
        }
        get columnOptionsIconAlignment() {
            return this.ev;
        }
        set columnOptionsIconAlignment(a) {
            this.ev = a;
            this.e("ColumnOptionsIconAlignment");
        }
        get columnOptionsIconColor() {
            return this.ex;
        }
        set columnOptionsIconColor(a) {
            this.ex = a;
            this.e("ColumnOptionsIconColor");
        }
        get columnOptionsIconBehavior() {
            return this.ew;
        }
        set columnOptionsIconBehavior(a) {
            this.ew = a;
            this.e("ColumnOptionsIconBehavior");
        }
        get border() {
            return this.d7;
        }
        set border(a) {
            this.d7 = a;
            this.e("Border");
        }
        get borderWidthBottom() {
            return this.b9;
        }
        set borderWidthBottom(a) {
            this.b9 = a;
            this.e("BorderWidthBottom");
        }
        get borderWidthLeft() {
            return this.ca;
        }
        set borderWidthLeft(a) {
            this.ca = a;
            this.e("BorderWidthLeft");
        }
        get borderWidthRight() {
            return this.cb;
        }
        set borderWidthRight(a) {
            this.cb = a;
            this.e("BorderWidthRight");
        }
        get borderWidthTop() {
            return this.cc;
        }
        set borderWidthTop(a) {
            this.cc = a;
            this.e("BorderWidthTop");
        }
        get notifyOnAllSelectionChanges() {
            return this.bn;
        }
        set notifyOnAllSelectionChanges(a) {
            this.bn = a;
            this.e("NotifyOnAllSelectionChanges");
        }
        get cornerRadiusBottomRight() {
            return this.cf;
        }
        set cornerRadiusBottomRight(a) {
            this.cf = a;
            this.e("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.ce;
        }
        set cornerRadiusBottomLeft(a) {
            this.ce = a;
            this.e("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.cg;
        }
        set cornerRadiusTopLeft(a) {
            this.cg = a;
            this.e("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.ch;
        }
        set cornerRadiusTopRight(a) {
            this.ch = a;
            this.e("CornerRadiusTopRight");
        }
        get isActiveCellStyleEnabled() {
            return this.be;
        }
        set isActiveCellStyleEnabled(a) {
            this.be = a;
            this.e("IsActiveCellStyleEnabled");
        }
        get responsiveStates() {
            return this.p;
        }
        set responsiveStates(a) {
            this.p = a;
            this.e("ResponsiveStates");
        }
        get sortDescriptions() {
            return this.u;
        }
        set sortDescriptions(a) {
            this.u = a;
            this.e("SortDescriptions");
        }
        get groupDescriptions() {
            return this.l;
        }
        set groupDescriptions(a) {
            this.l = a;
            this.e("GroupDescriptions");
        }
        get filterExpressions() {
            return this.k;
        }
        set filterExpressions(a) {
            this.k = a;
            this.e("FilterExpressions");
        }
        get summaryDescriptions() {
            return this.v;
        }
        set summaryDescriptions(a) {
            this.v = a;
            this.e("SummaryDescriptions");
        }
        get summaryScope() {
            return this.g0;
        }
        set summaryScope(a) {
            this.g0 = a;
            this.e("SummaryScope");
        }
        get isGroupCollapsable() {
            return this.bh;
        }
        set isGroupCollapsable(a) {
            this.bh = a;
            this.e("IsGroupCollapsable");
        }
        get groupHeaderDisplayMode() {
            return this.fm;
        }
        set groupHeaderDisplayMode(a) {
            this.fm = a;
            this.e("GroupHeaderDisplayMode");
        }
        get isGroupExpandedDefault() {
            return this.bi;
        }
        set isGroupExpandedDefault(a) {
            this.bi = a;
            this.e("IsGroupExpandedDefault");
        }
        get groupSummaryDisplayMode() {
            return this.fn;
        }
        set groupSummaryDisplayMode(a) {
            this.fn = a;
            this.e("GroupSummaryDisplayMode");
        }
        get autoAcceptEdits() {
            return this.bb;
        }
        set autoAcceptEdits(a) {
            this.bb = a;
            this.e("AutoAcceptEdits");
        }
        get primaryKey() {
            return this.o;
        }
        set primaryKey(a) {
            this.o = a;
            this.e("PrimaryKey");
        }
        get actualPrimaryKey() {
            return this.g;
        }
        set actualPrimaryKey(a) {
            this.g = a;
            this.e("ActualPrimaryKey");
        }
        get actualColumns() {
            return this.f;
        }
        set actualColumns(a) {
            this.f = a;
            this.e("ActualColumns");
        }
        get columns() {
            return this.i;
        }
        set columns(a) {
            this.i = a;
            this.e("Columns");
        }
        get reactsToSortChanges() {
            return this.bq;
        }
        set reactsToSortChanges(a) {
            this.bq = a;
            this.e("ReactsToSortChanges");
        }
        get reactsToGroupChanges() {
            return this.bp;
        }
        set reactsToGroupChanges(a) {
            this.bp = a;
            this.e("ReactsToGroupChanges");
        }
        get reactsToFilterChanges() {
            return this.bo;
        }
        set reactsToFilterChanges(a) {
            this.bo = a;
            this.e("ReactsToFilterChanges");
        }
        get enterBehavior() {
            return this.fh;
        }
        set enterBehavior(a) {
            this.fh = a;
            this.e("EnterBehavior");
        }
        get enterBehaviorAfterEdit() {
            return this.fi;
        }
        set enterBehaviorAfterEdit(a) {
            this.fi = a;
            this.e("EnterBehaviorAfterEdit");
        }
        get isColumnOptionsSummariesEnabled() {
            return this.bg;
        }
        set isColumnOptionsSummariesEnabled(a) {
            this.bg = a;
            this.e("IsColumnOptionsSummariesEnabled");
        }
        get filterExpressionsChangingRef() {
            return this.fk;
        }
        set filterExpressionsChangingRef(a) {
            this.fk = a;
            this.e("FilterExpressionsChangingRef");
        }
        get filterExpressionsChangedRef() {
            return this.fj;
        }
        set filterExpressionsChangedRef(a) {
            this.fj = a;
            this.e("FilterExpressionsChangedRef");
        }
        get cellPreviewPointerDownRef() {
            return this.ei;
        }
        set cellPreviewPointerDownRef(a) {
            this.ei = a;
            this.e("CellPreviewPointerDownRef");
        }
        get cellPreviewPointerUpRef() {
            return this.ej;
        }
        set cellPreviewPointerUpRef(a) {
            this.ej = a;
            this.e("CellPreviewPointerUpRef");
        }
        get cellPointerDownRef() {
            return this.eg;
        }
        set cellPointerDownRef(a) {
            this.eg = a;
            this.e("CellPointerDownRef");
        }
        get cellPointerUpRef() {
            return this.eh;
        }
        set cellPointerUpRef(a) {
            this.eh = a;
            this.e("CellPointerUpRef");
        }
        get cellClickedRef() {
            return this.d9;
        }
        set cellClickedRef(a) {
            this.d9 = a;
            this.e("CellClickedRef");
        }
        get sortDescriptionsChangedRef() {
            return this.go;
        }
        set sortDescriptionsChangedRef(a) {
            this.go = a;
            this.e("SortDescriptionsChangedRef");
        }
        get groupDescriptionsChangedRef() {
            return this.fl;
        }
        set groupDescriptionsChangedRef(a) {
            this.fl = a;
            this.e("GroupDescriptionsChangedRef");
        }
        get columnHiddenChangedRef() {
            return this.eq;
        }
        set columnHiddenChangedRef(a) {
            this.eq = a;
            this.e("ColumnHiddenChangedRef");
        }
        get columnPinnedChangedRef() {
            return this.ey;
        }
        set columnPinnedChangedRef(a) {
            this.ey = a;
            this.e("ColumnPinnedChangedRef");
        }
        get cellValueChangingRef() {
            return this.en;
        }
        set cellValueChangingRef(a) {
            this.en = a;
            this.e("CellValueChangingRef");
        }
        get dataCommittedRef() {
            return this.e6;
        }
        set dataCommittedRef(a) {
            this.e6 = a;
            this.e("DataCommittedRef");
        }
        get dataCommittingRef() {
            return this.e7;
        }
        set dataCommittingRef(a) {
            this.e7 = a;
            this.e("DataCommittingRef");
        }
        get sizeChangedRef() {
            return this.gn;
        }
        set sizeChangedRef(a) {
            this.gn = a;
            this.e("SizeChangedRef");
        }
        get actualColumnsChangedRef() {
            return this.d4;
        }
        set actualColumnsChangedRef(a) {
            this.d4 = a;
            this.e("ActualColumnsChangedRef");
        }
        get columnsAutoGeneratedRef() {
            return this.e3;
        }
        set columnsAutoGeneratedRef(a) {
            this.e3 = a;
            this.e("ColumnsAutoGeneratedRef");
        }
        get selectedItemsChangedRef() {
            return this.gj;
        }
        set selectedItemsChangedRef(a) {
            this.gj = a;
            this.e("SelectedItemsChangedRef");
        }
        get selectedKeysChangedRef() {
            return this.gk;
        }
        set selectedKeysChangedRef(a) {
            this.gk = a;
            this.e("SelectedKeysChangedRef");
        }
        get selectedCellsChangedRef() {
            return this.gi;
        }
        set selectedCellsChangedRef(a) {
            this.gi = a;
            this.e("SelectedCellsChangedRef");
        }
        get activeCellChangedRef() {
            return this.d3;
        }
        set activeCellChangedRef(a) {
            this.d3 = a;
            this.e("ActiveCellChangedRef");
        }
        get selectedCellRangesChangedRef() {
            return this.gh;
        }
        set selectedCellRangesChangedRef(a) {
            this.gh = a;
            this.e("SelectedCellRangesChangedRef");
        }
        get columnWidthChangedRef() {
            return this.e5;
        }
        set columnWidthChangedRef(a) {
            this.e5 = a;
            this.e("ColumnWidthChangedRef");
        }
        get cellEditStartedRef() {
            return this.ec;
        }
        set cellEditStartedRef(a) {
            this.ec = a;
            this.e("CellEditStartedRef");
        }
        get cellEditEndedRef() {
            return this.eb;
        }
        set cellEditEndedRef(a) {
            this.eb = a;
            this.e("CellEditEndedRef");
        }
        get rowEditStartedRef() {
            return this.f2;
        }
        set rowEditStartedRef(a) {
            this.f2 = a;
            this.e("RowEditStartedRef");
        }
        get rowEditEndedRef() {
            return this.f1;
        }
        set rowEditEndedRef(a) {
            this.f1 = a;
            this.e("RowEditEndedRef");
        }
        get actualPrimaryKeyChangeRef() {
            return this.d5;
        }
        set actualPrimaryKeyChangeRef(a) {
            this.d5 = a;
            this.e("ActualPrimaryKeyChangeRef");
        }
    }
    DataGridDescription.$t = /*@__PURE__*/ markType(DataGridDescription, 'DataGridDescription', Description.$);
    return DataGridDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
            this.l = null;
            this.j = false;
        }
        get_type() {
            return "GridCellEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get cellInfo() {
            return this.f;
        }
        set cellInfo(a) {
            this.f = a;
            this.e("CellInfo");
        }
        get grid() {
            return this.h;
        }
        set grid(a) {
            this.h = a;
            this.e("Grid");
        }
        get button() {
            return this.l;
        }
        set button(a) {
            this.l = a;
            this.e("Button");
        }
        get isDoubleClick() {
            return this.j;
        }
        set isDoubleClick(a) {
            this.j = a;
            this.e("IsDoubleClick");
        }
    }
    GridCellEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEventArgsDescription, 'GridCellEventArgsDescription', Description.$);
    return GridCellEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Grids.XamDataGrid");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
            CellKeyDescriptionMetadata.d(a);
            PrimaryKeyValueDescriptionMetadata.d(a);
        }
        static b(a) {
            if (DataGridDescriptionMetadata.a == null) {
                DataGridDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridDescriptionMetadata.c(a, DataGridDescriptionMetadata.a);
                SectionHeaderDescriptionMetadata.d(a);
                SummaryRowRootDescriptionMetadata.d(a);
                SummaryRowSectionDescriptionMetadata.d(a);
                RowSeparatorDescriptionMetadata.d(a);
                HeaderRowSeparatorDescriptionMetadata.d(a);
                HeaderSeparatorDescriptionMetadata.d(a);
                ColumnResizingSeparatorDescriptionMetadata.d(a);
                ColumnMovingSeparatorDescriptionMetadata.d(a);
                PinnedAreaSeparatorDescriptionMetadata.d(a);
                GridAnimationSettingsDescriptionMetadata.d(a);
                GridCellPositionDescriptionMetadata.d(a);
                GridFilterExpressionsEventArgsDescriptionMetadata.d(a);
                GridCellEventArgsDescriptionMetadata.d(a);
                GridSortDescriptionsChangedEventArgsDescriptionMetadata.d(a);
                GridGroupDescriptionsChangedEventArgsDescriptionMetadata.d(a);
                ColumnHiddenChangedEventArgsDescriptionMetadata.d(a);
                ColumnPinnedChangedEventArgsDescriptionMetadata.d(a);
                GridCellValueChangingEventArgsDescriptionMetadata.d(a);
                GridDataCommittedEventArgsDescriptionMetadata.d(a);
                GridDataCommittingEventArgsDescriptionMetadata.d(a);
                GridSizeChangedEventArgsDescriptionMetadata.d(a);
                GridColumnsChangedEventArgsDescriptionMetadata.d(a);
                GridColumnsAutoGeneratedEventArgsDescriptionMetadata.d(a);
                GridSelectedItemsChangedEventArgsDescriptionMetadata.d(a);
                GridSelectedKeysChangedEventArgsDescriptionMetadata.d(a);
                GridSelectedCellsChangedEventArgsDescriptionMetadata.d(a);
                GridActiveCellChangedEventArgsDescriptionMetadata.d(a);
                GridSelectedCellRangesChangedEventArgsDescriptionMetadata.d(a);
                GridColumnWidthChangedEventArgsDescriptionMetadata.d(a);
                GridCellEditStartedEventArgsDescriptionMetadata.d(a);
                GridCellEditEndedEventArgsDescriptionMetadata.d(a);
                GridRowEditStartedEventArgsDescriptionMetadata.d(a);
                GridRowEditEndedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ColumnResizingMode", "ExportedType:string:ColumnResizingMode");
            b.item("ColumnResizingMode@names", "Deferred;Immediate;None");
            b.item("ColumnMovingMode", "ExportedType:string:ColumnMovingMode");
            b.item("ColumnMovingMode@names", "Deferred;None");
            b.item("IsRowHoverEnabled", "Boolean");
            b.item("RowHoverBackground", "Brush");
            b.item("RowHoverTextColor", "Brush");
            b.item("EditRowBorder", "Brush");
            b.item("EditRowBorderWidthBottom", "(w:EditRowBorderWidth.Bottom,wf:EditRowBorderWidthBottom)Number:double");
            b.item("EditRowBorderWidthLeft", "(w:EditRowBorderWidth.Left,wf:EditRowBorderWidthLeft)Number:double");
            b.item("EditRowBorderWidthRight", "(w:EditRowBorderWidth.Right,wf:EditRowBorderWidthRight)Number:double");
            b.item("EditRowBorderWidthTop", "(w:EditRowBorderWidth.Top,wf:EditRowBorderWidthTop)Number:double");
            b.item("SectionHeader", "ExportedType:SectionHeader");
            b.item("SummaryRowRoot", "ExportedType:SummaryRowRoot");
            b.item("SummaryRowSection", "ExportedType:SummaryRowSection");
            b.item("RowSeparator", "ExportedType:RowSeparator");
            b.item("HeaderRowSeparator", "ExportedType:HeaderRowSeparator");
            b.item("HeaderSeparator", "ExportedType:HeaderSeparator");
            b.item("ColumnResizingSeparator", "ExportedType:ColumnResizingSeparator");
            b.item("ColumnMovingSeparator", "ExportedType:ColumnMovingSeparator");
            b.item("PinnedAreaSeparator", "ExportedType:PinnedAreaSeparator");
            b.item("AutoGenerateDesiredProperties", "Array:string");
            b.item("DataSourceDesiredProperties", "Array:string");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualRowHeight", "Number:int");
            b.item("RowHeight", "Number:int");
            b.item("DefaultColumnMinWidth", "Number:double");
            b.item("ActualHeaderHeight", "Number:int");
            b.item("HeaderHeight", "Number:int");
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("DataSource", "(w:ItemsSource,wf:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            b.item("HeaderClickAction", "ExportedType:string:HeaderClickAction");
            b.item("HeaderClickAction@names", "SortByOneColumnOnly;SortByMultipleColumns;SortByOneColumnOnlyTriState;SortByMultipleColumnsTriState;None");
            b.item("EditMode", "ExportedType:string:EditModeType");
            b.item("EditMode@names", "None;Cell;CellBatch;Row");
            b.item("EditModeClickAction", "ExportedType:string:EditModeClickAction");
            b.item("EditModeClickAction@names", "None;SingleClick;DoubleClick");
            b.item("EditOnKeyPress", "Boolean");
            b.item("AutoGenerateColumns", "Boolean");
            b.item("RowSeparatorHeight", "Number:int");
            b.item("IsPlaceholderRenderingEnabled", "Boolean");
            b.item("ColumnAddingAnimationMode", "ExportedType:string:ColumnShowingAnimationMode");
            b.item("ColumnAddingAnimationMode@names", "Auto;None;SlideFromLeft;SlideFromRight;SlideFromTop;SlideFromBottom;FadeIn;SlideFromLeftAndFadeIn;SlideFromRightAndFadeIn;SlideFromTopAndFadeIn;SlideFromBottomAndFadeIn");
            b.item("ColumnPropertyUpdatingAnimationMode", "ExportedType:string:ColumnPropertyUpdatingAnimationMode");
            b.item("ColumnPropertyUpdatingAnimationMode@names", "Auto;None;Interpolate;InterpolateDeep");
            b.item("CellDataLoadedAnimationMode", "ExportedType:string:CellDataLoadedAnimationMode");
            b.item("CellDataLoadedAnimationMode@names", "Auto;None;CrossFade");
            b.item("RowSelectionAnimationMode", "ExportedType:string:RowSelectionAnimationMode");
            b.item("RowSelectionAnimationMode@names", "Auto;None;ColorBlend");
            b.item("RowHoverAnimationMode", "ExportedType:string:RowHoverAnimationMode");
            b.item("RowHoverAnimationMode@names", "Auto;None;ColorBlend");
            b.item("CellSelectionAnimationMode", "ExportedType:string:CellSelectionAnimationMode");
            b.item("CellSelectionAnimationMode@names", "Auto;None;ColorBlend");
            b.item("AnimationSettings", "ExportedType:GridAnimationSettings");
            b.item("ColumnResizingAnimationMode", "ExportedType:string:ColumnResizingAnimationMode");
            b.item("ColumnResizingAnimationMode@names", "Auto;None;Interpolate");
            b.item("ColumnShowingAnimationMode", "ExportedType:string:ColumnShowingAnimationMode");
            b.item("ColumnShowingAnimationMode@names", "Auto;None;SlideFromLeft;SlideFromRight;SlideFromTop;SlideFromBottom;FadeIn;SlideFromLeftAndFadeIn;SlideFromRightAndFadeIn;SlideFromTopAndFadeIn;SlideFromBottomAndFadeIn");
            b.item("ColumnMovingAnimationMode", "ExportedType:string:ColumnMovingAnimationMode");
            b.item("ColumnMovingAnimationMode@names", "Auto;None;SlideOver");
            b.item("ColumnHidingAnimationMode", "ExportedType:string:ColumnHidingAnimationMode");
            b.item("ColumnHidingAnimationMode@names", "Auto;None;SlideToLeft;SlideToRight;SlideToTop;SlideToBottom;FadeOut;SlideToLeftAndFadeOut;SlideToRightAndFadeOut;SlideToTopAndFadeOut;SlideToBottomAndFadeOut");
            b.item("ColumnExchangingAnimationMode", "ExportedType:string:ColumnExchangingAnimationMode");
            b.item("ColumnExchangingAnimationMode@names", "Auto;None;SlideToLeft;SlideToRight;SlideToTop;SlideToBottom;Crossfade;SlideToLeftAndCrossfade;SlideToRightAndCrossfade;SlideToTopAndCrossfade;SlideToBottomAndCrossfade");
            b.item("SelectionMode", "ExportedType:string:GridSelectionMode");
            b.item("SelectionMode@names", "None;SingleRow;MultipleRow;SingleCell;MultipleCell;RangeCell");
            b.item("ActivationMode", "ExportedType:string:GridActivationMode");
            b.item("ActivationMode@names", "None;Cell");
            b.item("SelectionBehavior", "ExportedType:string:GridSelectionBehavior");
            b.item("SelectionBehavior@names", "Toggle;ModifierBased");
            b.item("SelectedItems", "Collection:object:GridSelectedItemsCollection:Object");
            b.item("SelectedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            b.item("SelectedCells", "Collection:CellKey:GridSelectedCellsCollection:CellKey");
            b.item("SelectedCellRanges", "Collection:CellRange:GridSelectedCellRangesCollection:CellRange");
            b.item("PinnedItems", "Collection:object:GridSelectedItemsCollection:Object");
            b.item("PinnedKeys", "Collection:PrimaryKeyValue:GridSelectedKeysCollection:PrimaryKeyValue");
            b.item("IsColumnOptionsEnabled", "Boolean");
            b.item("IsGroupRowSticky", "Boolean");
            b.item("IsHeaderSeparatorVisible", "Boolean");
            b.item("CellSelectedBackground", "Brush");
            b.item("SectionHeaderSelectedBackground", "Brush");
            b.item("SummaryRootBackground", "Brush");
            b.item("SummarySectionBackground", "Brush");
            b.item("PinnedRowOpacity", "Number:double");
            b.item("EditFontFamily", "(w:EditFontFamily/FontFamilyTransform,wf:EditFontFamily,web:editTextStyle/FontFamilyTransform)String");
            b.item("EditFontSize", "(w:EditFontSize,wf:EditFontSize,web:editTextStyle/FontSizeTransform)Number:double");
            b.item("EditFontStyle", "(w:EditFontStyle/FontStyleTransform,wf:EditFontFamily/FontStyleTransform,web:editTextStyle/FontStyleTransform)String");
            b.item("EditFontWeight", "(w:EditFontWeight/FontWeightTransform,wf:EditFontFamily/FontWeightTransform,web:editTextStyle/FontWeightTransform)String");
            b.item("EditOpacity", "Number:double");
            b.item("DeletedTextColor", "Brush");
            b.item("StickyRowBackground", "Brush");
            b.item("PinnedRowBackground", "Brush");
            b.item("LastStickyRowBackground", "Brush");
            b.item("ActiveCell", "ExportedType:GridCellPosition");
            b.item("CellBackground", "Brush");
            b.item("CellTextColor", "Brush");
            b.item("HeaderSortIndicatorColor", "Brush");
            b.item("HeaderSortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            b.item("HeaderSortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            b.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            b.item("CellFontSize", "(w:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            b.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            b.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            b.item("SectionHeaderBackground", "Brush");
            b.item("SectionHeaderTextColor", "Brush");
            b.item("SectionHeaderFontFamily", "(w:SectionHeaderFontFamily/FontFamilyTransform,wf:SectionHeaderFontFamily,web:sectionHeaderTextStyle/FontFamilyTransform)String");
            b.item("SectionHeaderFontSize", "(w:SectionHeaderFontSize,wf:SectionHeaderFontSize,web:sectionHeaderTextStyle/FontSizeTransform)Number:double");
            b.item("SectionHeaderFontStyle", "(w:SectionHeaderFontStyle/FontStyleTransform,wf:SectionHeaderFontFamily/FontStyleTransform,web:sectionHeaderTextStyle/FontStyleTransform)String");
            b.item("SectionHeaderFontWeight", "(w:SectionHeaderFontWeight/FontWeightTransform,wf:SectionHeaderFontFamily/FontWeightTransform,web:sectionHeaderTextStyle/FontWeightTransform)String");
            b.item("SummaryRootLabelFontFamily", "(w:SummaryRootLabelFontFamily/FontFamilyTransform,wf:SummaryRootLabelFontFamily,web:summaryRootLabelTextStyle/FontFamilyTransform)String");
            b.item("SummaryRootLabelFontSize", "(w:SummaryRootLabelFontSize,wf:SummaryRootLabelFontSize,web:summaryRootLabelTextStyle/FontSizeTransform)Number:double");
            b.item("SummaryRootLabelFontStyle", "(w:SummaryRootLabelFontStyle/FontStyleTransform,wf:SummaryRootLabelFontFamily/FontStyleTransform,web:summaryRootLabelTextStyle/FontStyleTransform)String");
            b.item("SummaryRootLabelFontWeight", "(w:SummaryRootLabelFontWeight/FontWeightTransform,wf:SummaryRootLabelFontFamily/FontWeightTransform,web:summaryRootLabelTextStyle/FontWeightTransform)String");
            b.item("SummarySectionLabelFontFamily", "(w:SummarySectionLabelFontFamily/FontFamilyTransform,wf:SummarySectionLabelFontFamily,web:summarySectionLabelTextStyle/FontFamilyTransform)String");
            b.item("SummarySectionLabelFontSize", "(w:SummarySectionLabelFontSize,wf:SummarySectionLabelFontSize,web:summarySectionLabelTextStyle/FontSizeTransform)Number:double");
            b.item("SummarySectionLabelFontStyle", "(w:SummarySectionLabelFontStyle/FontStyleTransform,wf:SummarySectionLabelFontFamily/FontStyleTransform,web:summarySectionLabelTextStyle/FontStyleTransform)String");
            b.item("SummarySectionLabelFontWeight", "(w:SummarySectionLabelFontWeight/FontWeightTransform,wf:SummarySectionLabelFontFamily/FontWeightTransform,web:summarySectionLabelTextStyle/FontWeightTransform)String");
            b.item("SummaryRootValueTextColor", "Brush");
            b.item("SummaryRootValueFontFamily", "(w:SummaryRootValueFontFamily/FontFamilyTransform,wf:SummaryRootValueFontFamily,web:summaryRootValueTextStyle/FontFamilyTransform)String");
            b.item("SummaryRootValueFontSize", "(w:SummaryRootValueFontSize,wf:SummaryRootValueFontSize,web:summaryRootValueTextStyle/FontSizeTransform)Number:double");
            b.item("SummaryRootValueFontStyle", "(w:SummaryRootValueFontStyle/FontStyleTransform,wf:SummaryRootValueFontFamily/FontStyleTransform,web:summaryRootValueTextStyle/FontStyleTransform)String");
            b.item("SummaryRootValueFontWeight", "(w:SummaryRootValueFontWeight/FontWeightTransform,wf:SummaryRootValueFontFamily/FontWeightTransform,web:summaryRootValueTextStyle/FontWeightTransform)String");
            b.item("SummarySectionValueFontFamily", "(w:SummarySectionValueFontFamily/FontFamilyTransform,wf:SummarySectionValueFontFamily,web:summarySectionValueTextStyle/FontFamilyTransform)String");
            b.item("SummarySectionValueFontSize", "(w:SummarySectionValueFontSize,wf:SummarySectionValueFontSize,web:summarySectionValueTextStyle/FontSizeTransform)Number:double");
            b.item("SummarySectionValueFontStyle", "(w:SummarySectionValueFontStyle/FontStyleTransform,wf:SummarySectionValueFontFamily/FontStyleTransform,web:summarySectionValueTextStyle/FontStyleTransform)String");
            b.item("SummarySectionValueFontWeight", "(w:SummarySectionValueFontWeight/FontWeightTransform,wf:SummarySectionValueFontFamily/FontWeightTransform,web:summarySectionValueTextStyle/FontWeightTransform)String");
            b.item("SummarySectionValueTextColor", "Brush");
            b.item("SummaryRootLabelTextColor", "Brush");
            b.item("SummarySectionLabelTextColor", "Brush");
            b.item("SummaryRootSelectedBackground", "Brush");
            b.item("SummarySectionSelectedBackground", "Brush");
            b.item("PinnedAreaSeparatorWidth", "Number:int");
            b.item("HeaderSeparatorWidth", "Number:int");
            b.item("HeaderSeparatorBackground", "Brush");
            b.item("HeaderBackground", "Brush");
            b.item("HeaderTextColor", "Brush");
            b.item("HeaderFontFamily", "(w:HeaderFontFamily/FontFamilyTransform,wf:HeaderFontFamily,web:headerTextStyle/FontFamilyTransform)String");
            b.item("HeaderFontSize", "(w:HeaderFontSize,wf:HeaderFontSize,web:headerTextStyle/FontSizeTransform)Number:double");
            b.item("HeaderFontStyle", "(w:HeaderFontStyle/FontStyleTransform,wf:HeaderFontFamily/FontStyleTransform,web:headerTextStyle/FontStyleTransform)String");
            b.item("HeaderFontWeight", "(w:HeaderFontWeight/FontWeightTransform,wf:HeaderFontFamily/FontWeightTransform,web:headerTextStyle/FontWeightTransform)String");
            b.item("RowSeparatorBackground", "Brush");
            b.item("HeaderRowSeparatorBackground", "Brush");
            b.item("RowSeparatorStickyRowBackground", "Brush");
            b.item("RowSeparatorLastStickyRowBackground", "Brush");
            b.item("RowSeparatorPinnedRowBackground", "Brush");
            b.item("ColumnResizingSeparatorWidth", "Number:int");
            b.item("ColumnMovingSeparatorWidth", "Number:int");
            b.item("ColumnResizingSeparatorBackground", "Brush");
            b.item("ColumnMovingSeparatorBackground", "Brush");
            b.item("ShiftSectionContent", "Boolean");
            b.item("ColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            b.item("ColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            b.item("ColumnOptionsIconColor", "Brush");
            b.item("ColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            b.item("ColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
            b.item("Border", "Brush");
            b.item("BorderWidthBottom", "(w:BorderWidth.Bottom,wf:BorderWidthBottom)Number:double");
            b.item("BorderWidthLeft", "(w:BorderWidth.Left,wf:BorderWidthLeft)Number:double");
            b.item("BorderWidthRight", "(w:BorderWidth.Right,wf:BorderWidthRight)Number:double");
            b.item("BorderWidthTop", "(w:BorderWidth.Top,wf:BorderWidthTop)Number:double");
            b.item("NotifyOnAllSelectionChanges", "Boolean");
            b.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            b.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            b.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            b.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            b.item("IsActiveCellStyleEnabled", "Boolean");
            b.item("ResponsiveStates", "Collection:ResponsiveState:ResponsiveStatesCollection:ResponsiveState");
            b.item("SortDescriptions", "Collection:ColumnSortDescription:ColumnSortDescriptionCollection:ColumnSortDescription");
            b.item("GroupDescriptions", "Collection:ColumnGroupDescription:ColumnGroupDescriptionCollection:ColumnGroupDescription");
            b.item("FilterExpressions", "Collection:FilterExpression:FilterExpressionCollection:FilterExpression");
            b.item("SummaryDescriptions", "Collection:ColumnSummaryDescription:ColumnSummaryDescriptionCollection:ColumnSummaryDescription");
            b.item("SummaryScope", "ExportedType:string:DataSourceSummaryScope");
            b.item("SummaryScope@names", "Both;Root;Groups;None");
            b.item("IsGroupCollapsable", "Boolean");
            b.item("GroupHeaderDisplayMode", "ExportedType:string:DataSourceSectionHeaderDisplayMode");
            b.item("GroupHeaderDisplayMode@names", "Combined;Split");
            b.item("IsGroupExpandedDefault", "Boolean");
            b.item("GroupSummaryDisplayMode", "ExportedType:string:GroupSummaryDisplayMode");
            b.item("GroupSummaryDisplayMode@names", "List;Cells;RowTop;RowBottom;None");
            b.item("AutoAcceptEdits", "Boolean");
            b.item("PrimaryKey", "Array:string");
            b.item("ActualPrimaryKey", "Array:string");
            b.item("ActualColumns", "Collection:Column:GridColumnCollection:Column");
            b.item("Columns", "Collection:Column:GridColumnCollection:Column");
            b.item("ReactsToSortChanges", "Boolean");
            b.item("ReactsToGroupChanges", "Boolean");
            b.item("ReactsToFilterChanges", "Boolean");
            b.item("EnterBehavior", "ExportedType:string:EnterKeyBehaviors");
            b.item("EnterBehavior@names", "None;Edit;MoveDown;MoveRight;MoveUp;MoveLeft");
            b.item("EnterBehaviorAfterEdit", "ExportedType:string:EnterKeyBehaviorAfterEdit");
            b.item("EnterBehaviorAfterEdit@names", "None;MoveDown;MoveRight;MoveUp;MoveLeft");
            b.item("IsColumnOptionsSummariesEnabled", "Boolean");
            b.item("FilterExpressionsChangingRef", "EventRef::filterExpressionsChanging");
            b.item("FilterExpressionsChangedRef", "EventRef::filterExpressionsChanged");
            b.item("CellPreviewPointerDownRef", "EventRef::cellPreviewPointerDown");
            b.item("CellPreviewPointerUpRef", "EventRef::cellPreviewPointerUp");
            b.item("CellPointerDownRef", "EventRef::cellPointerDown");
            b.item("CellPointerUpRef", "EventRef::cellPointerUp");
            b.item("CellClickedRef", "EventRef::cellClicked");
            b.item("SortDescriptionsChangedRef", "EventRef::sortDescriptionsChanged");
            b.item("GroupDescriptionsChangedRef", "EventRef::groupDescriptionsChanged");
            b.item("ColumnHiddenChangedRef", "EventRef::columnHiddenChanged");
            b.item("ColumnPinnedChangedRef", "EventRef::columnPinnedChanged");
            b.item("CellValueChangingRef", "EventRef::cellValueChanging");
            b.item("DataCommittedRef", "EventRef::dataCommitted");
            b.item("DataCommittingRef", "EventRef::dataCommitting");
            b.item("SizeChangedRef", "EventRef::sizeChanged");
            b.item("ActualColumnsChangedRef", "EventRef::actualColumnsChanged");
            b.item("ColumnsAutoGeneratedRef", "EventRef::columnsAutoGenerated");
            b.item("SelectedItemsChangedRef", "EventRef::selectedItemsChanged");
            b.item("SelectedKeysChangedRef", "EventRef::selectedKeysChanged");
            b.item("SelectedCellsChangedRef", "EventRef::selectedCellsChanged");
            b.item("ActiveCellChangedRef", "EventRef::activeCellChanged");
            b.item("SelectedCellRangesChangedRef", "EventRef::selectedCellRangesChanged");
            b.item("ColumnWidthChangedRef", "EventRef::columnWidthChanged");
            b.item("CellEditStartedRef", "EventRef::cellEditStarted");
            b.item("CellEditEndedRef", "EventRef::cellEditEnded");
            b.item("RowEditStartedRef", "EventRef::rowEditStarted");
            b.item("RowEditEndedRef", "EventRef::rowEditEnded");
            b.item("ActualPrimaryKeyChangeRef", "EventRef::actualPrimaryKeyChange");
            DataGridDescriptionMetadata.e(a, b);
        }
        static d(a) {
            DataGridDescriptionMetadata.b(a);
            a.q("DataGrid", () => new DataGridDescription());
            a.p("DataGrid", DataGridDescriptionMetadata.a);
        }
    }
    DataGridDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridDescriptionMetadata, 'DataGridDescriptionMetadata');
    DataGridDescriptionMetadata.a = null;
    return DataGridDescriptionMetadata;
})();
/**
 * @hidden
 */
let GridCellEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEventArgsDescriptionMetadata.a == null) {
                GridCellEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEventArgsDescriptionMetadata.c(a, GridCellEventArgsDescriptionMetadata.a);
                CellInfoDescriptionMetadata.d(a);
                DataGridDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("CellInfo", "ExportedType:CellModel");
            b.item("Grid", "ExportedType:Grid");
            b.item("Button", "ExportedType:string:MouseButton");
            b.item("Button@names", "Left;Middle;Right;Unkown");
            b.item("IsDoubleClick", "Boolean");
        }
        static d(a) {
            GridCellEventArgsDescriptionMetadata.b(a);
            a.q("GridCellEventArgs", () => new GridCellEventArgsDescription());
            a.p("GridCellEventArgs", GridCellEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEventArgsDescriptionMetadata, 'GridCellEventArgsDescriptionMetadata');
    GridCellEventArgsDescriptionMetadata.a = null;
    return GridCellEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridCoreDescriptionModule extends Base {
        static register(a) {
            TextHeaderDescriptionModule.register(a);
            SectionHeaderDescriptionModule.register(a);
            RowSeparatorDescriptionModule.register(a);
            HeaderSeparatorDescriptionModule.register(a);
            ColumnResizingSeparatorDescriptionModule.register(a);
            ColumnMovingSeparatorDescriptionModule.register(a);
            SummaryRowRootDescriptionModule.register(a);
            SummaryRowSectionDescriptionModule.register(a);
            ColumnWidthDescriptionModule.register(a);
            ColumnSortDescriptionDescriptionModule.register(a);
            ColumnGroupDescriptionDescriptionModule.register(a);
            ColumnSummaryDescriptionDescriptionModule.register(a);
            PrimaryKeyValueDescriptionModule.register(a);
            CellKeyDescriptionModule.register(a);
            CellRangeDescriptionModule.register(a);
            GridCellPositionDescriptionModule.register(a);
            LocalDataSourceDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            DataGridDescriptionMetadata.d(a);
        }
    }
    DataGridCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataGridCoreDescriptionModule, 'DataGridCoreDescriptionModule');
    return DataGridCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnDescription = /*@__PURE__*/ (() => {
    class ColumnDescription extends DefinitionBaseDescription {
        constructor() {
            super();
            this.c6 = 0;
            this.c8 = 0;
            this.c7 = 0;
            this.c5 = 0;
            this.dw = null;
            this.du = null;
            this.dv = null;
            this.dh = null;
            this.d0 = null;
            this.dl = null;
            this.dy = null;
            this.dj = null;
            this.dz = null;
            this.dk = null;
            this.b6 = null;
            this.b4 = null;
            this.c0 = 0;
            this.ci = false;
            this.cd = false;
            this.b2 = null;
            this.b8 = null;
            this.ch = false;
            this.ck = false;
            this.cj = false;
            this.cl = false;
            this.d1 = null;
            this.dx = null;
            this.dd = null;
            this.dm = null;
            this.df = null;
            this.dp = null;
            this.dn = null;
            this.de = null;
            this.cb = false;
            this.ce = false;
            this.cc = false;
            this.cf = false;
            this.cg = false;
            this.dq = null;
            this.dg = null;
            this.cz = 0;
            this.cx = 0;
            this.dr = null;
            this.cy = 0;
            this.ds = null;
            this.dt = null;
            this.di = null;
        }
        get_type() {
            return "Column";
        }
        get paddingLeft() {
            return this.c6;
        }
        set paddingLeft(a) {
            this.c6 = a;
            this.e("PaddingLeft");
        }
        get paddingTop() {
            return this.c8;
        }
        set paddingTop(a) {
            this.c8 = a;
            this.e("PaddingTop");
        }
        get paddingRight() {
            return this.c7;
        }
        set paddingRight(a) {
            this.c7 = a;
            this.e("PaddingRight");
        }
        get paddingBottom() {
            return this.c5;
        }
        set paddingBottom(a) {
            this.c5 = a;
            this.e("PaddingBottom");
        }
        get name() {
            return this.dw;
        }
        set name(a) {
            this.dw = a;
            this.e("Name");
        }
        get field() {
            return this.du;
        }
        set field(a) {
            this.du = a;
            this.e("Field");
        }
        get headerText() {
            return this.dv;
        }
        set headerText(a) {
            this.dv = a;
            this.e("HeaderText");
        }
        get actualHeaderText() {
            return this.dh;
        }
        set actualHeaderText(a) {
            this.dh = a;
            this.e("ActualHeaderText");
        }
        get selectedBackground() {
            return this.d0;
        }
        set selectedBackground(a) {
            this.d0 = a;
            this.e("SelectedBackground");
        }
        get actualSelectedBackground() {
            return this.dl;
        }
        set actualSelectedBackground(a) {
            this.dl = a;
            this.e("ActualSelectedBackground");
        }
        get rowHoverBackground() {
            return this.dy;
        }
        set rowHoverBackground(a) {
            this.dy = a;
            this.e("RowHoverBackground");
        }
        get actualHoverBackground() {
            return this.dj;
        }
        set actualHoverBackground(a) {
            this.dj = a;
            this.e("ActualHoverBackground");
        }
        get rowHoverTextColor() {
            return this.dz;
        }
        set rowHoverTextColor(a) {
            this.dz = a;
            this.e("RowHoverTextColor");
        }
        get actualRowHoverTextColor() {
            return this.dk;
        }
        set actualRowHoverTextColor(a) {
            this.dk = a;
            this.e("ActualRowHoverTextColor");
        }
        get animationSettings() {
            return this.b6;
        }
        set animationSettings(a) {
            this.b6 = a;
            this.e("AnimationSettings");
        }
        get width() {
            return this.b4;
        }
        set width(a) {
            this.b4 = a;
            this.e("Width");
        }
        get minWidth() {
            return this.c0;
        }
        set minWidth(a) {
            this.c0 = a;
            this.e("MinWidth");
        }
        get isFromMarkup() {
            return this.ci;
        }
        set isFromMarkup(a) {
            this.ci = a;
            this.e("IsFromMarkup");
        }
        get isAutoGenerated() {
            return this.cd;
        }
        set isAutoGenerated(a) {
            this.cd = a;
            this.e("IsAutoGenerated");
        }
        get filter() {
            return this.b2;
        }
        set filter(a) {
            this.b2 = a;
            this.e("Filter");
        }
        get header() {
            return this.b8;
        }
        set header(a) {
            this.b8 = a;
            this.e("Header");
        }
        get isFilteringEnabled() {
            return this.ch;
        }
        set isFilteringEnabled(a) {
            this.ch = a;
            this.e("IsFilteringEnabled");
        }
        get isResizingEnabled() {
            return this.ck;
        }
        set isResizingEnabled(a) {
            this.ck = a;
            this.e("IsResizingEnabled");
        }
        get isHidden() {
            return this.cj;
        }
        set isHidden(a) {
            this.cj = a;
            this.e("IsHidden");
        }
        get shouldRemoveWhenHidden() {
            return this.cl;
        }
        set shouldRemoveWhenHidden(a) {
            this.cl = a;
            this.e("ShouldRemoveWhenHidden");
        }
        get sortDirection() {
            return this.d1;
        }
        set sortDirection(a) {
            this.d1 = a;
            this.e("SortDirection");
        }
        get pinned() {
            return this.dx;
        }
        set pinned(a) {
            this.dx = a;
            this.e("Pinned");
        }
        get actualColumnOptionsIconAlignment() {
            return this.dd;
        }
        set actualColumnOptionsIconAlignment(a) {
            this.dd = a;
            this.e("ActualColumnOptionsIconAlignment");
        }
        get columnOptionsIconAlignment() {
            return this.dm;
        }
        set columnOptionsIconAlignment(a) {
            this.dm = a;
            this.e("ColumnOptionsIconAlignment");
        }
        get actualColumnOptionsIconColor() {
            return this.df;
        }
        set actualColumnOptionsIconColor(a) {
            this.df = a;
            this.e("ActualColumnOptionsIconColor");
        }
        get columnOptionsIconColor() {
            return this.dp;
        }
        set columnOptionsIconColor(a) {
            this.dp = a;
            this.e("ColumnOptionsIconColor");
        }
        get columnOptionsIconBehavior() {
            return this.dn;
        }
        set columnOptionsIconBehavior(a) {
            this.dn = a;
            this.e("ColumnOptionsIconBehavior");
        }
        get actualColumnOptionsIconBehavior() {
            return this.de;
        }
        set actualColumnOptionsIconBehavior(a) {
            this.de = a;
            this.e("ActualColumnOptionsIconBehavior");
        }
        get actualIsColumnOptionsEnabled() {
            return this.cb;
        }
        set actualIsColumnOptionsEnabled(a) {
            this.cb = a;
            this.e("ActualIsColumnOptionsEnabled");
        }
        get isColumnOptionsEnabled() {
            return this.ce;
        }
        set isColumnOptionsEnabled(a) {
            this.ce = a;
            this.e("IsColumnOptionsEnabled");
        }
        get actualIsColumnOptionsSummariesEnabled() {
            return this.cc;
        }
        set actualIsColumnOptionsSummariesEnabled(a) {
            this.cc = a;
            this.e("ActualIsColumnOptionsSummariesEnabled");
        }
        get isColumnOptionsSummariesEnabled() {
            return this.cf;
        }
        set isColumnOptionsSummariesEnabled(a) {
            this.cf = a;
            this.e("IsColumnOptionsSummariesEnabled");
        }
        get isEditable() {
            return this.cg;
        }
        set isEditable(a) {
            this.cg = a;
            this.e("IsEditable");
        }
        get deletedTextColor() {
            return this.dq;
        }
        set deletedTextColor(a) {
            this.dq = a;
            this.e("DeletedTextColor");
        }
        get actualDeletedTextColor() {
            return this.dg;
        }
        set actualDeletedTextColor(a) {
            this.dg = a;
            this.e("ActualDeletedTextColor");
        }
        get editOpacity() {
            return this.cz;
        }
        set editOpacity(a) {
            this.cz = a;
            this.e("EditOpacity");
        }
        get actualEditOpacity() {
            return this.cx;
        }
        set actualEditOpacity(a) {
            this.cx = a;
            this.e("ActualEditOpacity");
        }
        get editFontFamily() {
            return this.dr;
        }
        set editFontFamily(a) {
            this.dr = a;
            this.e("EditFontFamily");
        }
        get editFontSize() {
            return this.cy;
        }
        set editFontSize(a) {
            this.cy = a;
            this.e("EditFontSize");
        }
        get editFontStyle() {
            return this.ds;
        }
        set editFontStyle(a) {
            this.ds = a;
            this.e("EditFontStyle");
        }
        get editFontWeight() {
            return this.dt;
        }
        set editFontWeight(a) {
            this.dt = a;
            this.e("EditFontWeight");
        }
        get actualHeaderTextChangeRef() {
            return this.di;
        }
        set actualHeaderTextChangeRef(a) {
            this.di = a;
            this.e("ActualHeaderTextChangeRef");
        }
    }
    ColumnDescription.$t = /*@__PURE__*/ markType(ColumnDescription, 'ColumnDescription', DefinitionBaseDescription.$);
    ColumnDescription.__canMarshalByValue = true;
    return ColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextColumnDescription = /*@__PURE__*/ (() => {
    class TextColumnDescription extends ColumnDescription {
        constructor() {
            super();
            this.ex = null;
            this.ev = null;
            this.es = null;
            this.ew = null;
            this.eq = null;
        }
        get_type() {
            return "TextColumn";
        }
        get editorType() {
            return this.ex;
        }
        set editorType(a) {
            this.ex = a;
            this.e("EditorType");
        }
        get editorDataSourceRef() {
            return this.ev;
        }
        set editorDataSourceRef(a) {
            this.ev = a;
            this.e("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.es;
        }
        set editorDataSource(a) {
            this.es = a;
            this.e("EditorDataSource");
        }
        get editorTextField() {
            return this.ew;
        }
        set editorTextField(a) {
            this.ew = a;
            this.e("EditorTextField");
        }
        get editorValueField() {
            return this.eq;
        }
        set editorValueField(a) {
            this.eq = a;
            this.e("EditorValueField");
        }
    }
    TextColumnDescription.$t = /*@__PURE__*/ markType(TextColumnDescription, 'TextColumnDescription', ColumnDescription.$);
    TextColumnDescription.__canMarshalByValue1 = true;
    return TextColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextColumnDescriptionMetadata extends Base {
        static b(a) {
            if (TextColumnDescriptionMetadata.a == null) {
                TextColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextColumnDescriptionMetadata.c(a, TextColumnDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnDescriptionMetadata.c(a, b);
            b.item("EditorType", "ExportedType:string:EditorType");
            b.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            b.item("EditorDataSourceRef", "(w:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            b.item("EditorDataSource", "(w:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            b.item("EditorTextField", "String");
            b.item("EditorValueField", "Array:string");
        }
        static d(a) {
            TextColumnDescriptionMetadata.b(a);
            a.q("TextColumn", () => new TextColumnDescription());
            a.p("TextColumn", TextColumnDescriptionMetadata.a);
        }
    }
    TextColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(TextColumnDescriptionMetadata, 'TextColumnDescriptionMetadata');
    TextColumnDescriptionMetadata.a = null;
    return TextColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextColumnDescriptionModule = /*@__PURE__*/ (() => {
    class TextColumnDescriptionModule extends Base {
        static register(a) {
            TextColumnDescriptionMetadata.d(a);
        }
    }
    TextColumnDescriptionModule.$t = /*@__PURE__*/ markType(TextColumnDescriptionModule, 'TextColumnDescriptionModule');
    return TextColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericColumnDescription = /*@__PURE__*/ (() => {
    class NumericColumnDescription extends ColumnDescription {
        constructor() {
            super();
            this.fa = null;
            this.fc = null;
            this.fb = null;
            this.fd = null;
            this.ez = 0;
            this.e0 = 0;
            this.e1 = 0;
            this.ex = false;
            this.e9 = null;
            this.er = null;
            this.e8 = null;
            this.e7 = null;
            this.e5 = null;
            this.eu = null;
            this.e6 = null;
            this.eq = null;
        }
        get_type() {
            return "NumericColumn";
        }
        get negativePrefix() {
            return this.fa;
        }
        set negativePrefix(a) {
            this.fa = a;
            this.e("NegativePrefix");
        }
        get positivePrefix() {
            return this.fc;
        }
        set positivePrefix(a) {
            this.fc = a;
            this.e("PositivePrefix");
        }
        get negativeSuffix() {
            return this.fb;
        }
        set negativeSuffix(a) {
            this.fb = a;
            this.e("NegativeSuffix");
        }
        get positiveSuffix() {
            return this.fd;
        }
        set positiveSuffix(a) {
            this.fd = a;
            this.e("PositiveSuffix");
        }
        get maxFractionDigits() {
            return this.ez;
        }
        set maxFractionDigits(a) {
            this.ez = a;
            this.e("MaxFractionDigits");
        }
        get minFractionDigits() {
            return this.e0;
        }
        set minFractionDigits(a) {
            this.e0 = a;
            this.e("MinFractionDigits");
        }
        get minIntegerDigits() {
            return this.e1;
        }
        set minIntegerDigits(a) {
            this.e1 = a;
            this.e("MinIntegerDigits");
        }
        get showGroupingSeparator() {
            return this.ex;
        }
        set showGroupingSeparator(a) {
            this.ex = a;
            this.e("ShowGroupingSeparator");
        }
        get formatString() {
            return this.e9;
        }
        set formatString(a) {
            this.e9 = a;
            this.e("FormatString");
        }
        get formatSpecifiers() {
            return this.er;
        }
        set formatSpecifiers(a) {
            this.er = a;
            this.e("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.e8;
        }
        set formatOverrideRef(a) {
            this.e8 = a;
            this.e("FormatOverrideRef");
        }
        get editorType() {
            return this.e7;
        }
        set editorType(a) {
            this.e7 = a;
            this.e("EditorType");
        }
        get editorDataSourceRef() {
            return this.e5;
        }
        set editorDataSourceRef(a) {
            this.e5 = a;
            this.e("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.eu;
        }
        set editorDataSource(a) {
            this.eu = a;
            this.e("EditorDataSource");
        }
        get editorTextField() {
            return this.e6;
        }
        set editorTextField(a) {
            this.e6 = a;
            this.e("EditorTextField");
        }
        get editorValueField() {
            return this.eq;
        }
        set editorValueField(a) {
            this.eq = a;
            this.e("EditorValueField");
        }
    }
    NumericColumnDescription.$t = /*@__PURE__*/ markType(NumericColumnDescription, 'NumericColumnDescription', ColumnDescription.$);
    NumericColumnDescription.__canMarshalByValue1 = true;
    return NumericColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericColumnDescriptionMetadata extends Base {
        static b(a) {
            if (NumericColumnDescriptionMetadata.a == null) {
                NumericColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericColumnDescriptionMetadata.c(a, NumericColumnDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnDescriptionMetadata.c(a, b);
            b.item("NegativePrefix", "String");
            b.item("PositivePrefix", "String");
            b.item("NegativeSuffix", "String");
            b.item("PositiveSuffix", "String");
            b.item("MaxFractionDigits", "Number:int");
            b.item("MinFractionDigits", "Number:int");
            b.item("MinIntegerDigits", "Number:int");
            b.item("ShowGroupingSeparator", "Boolean");
            b.item("FormatString", "String");
            b.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            b.item("EditorType", "ExportedType:string:EditorType");
            b.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            b.item("EditorDataSourceRef", "(w:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            b.item("EditorDataSource", "(w:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            b.item("EditorTextField", "String");
            b.item("EditorValueField", "Array:string");
        }
        static d(a) {
            NumericColumnDescriptionMetadata.b(a);
            a.q("NumericColumn", () => new NumericColumnDescription());
            a.p("NumericColumn", NumericColumnDescriptionMetadata.a);
        }
    }
    NumericColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericColumnDescriptionMetadata, 'NumericColumnDescriptionMetadata');
    NumericColumnDescriptionMetadata.a = null;
    return NumericColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericColumnDescriptionModule = /*@__PURE__*/ (() => {
    class NumericColumnDescriptionModule extends Base {
        static register(a) {
            NumericColumnDescriptionMetadata.d(a);
        }
    }
    NumericColumnDescriptionModule.$t = /*@__PURE__*/ markType(NumericColumnDescriptionModule, 'NumericColumnDescriptionModule');
    return NumericColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeColumnDescription = /*@__PURE__*/ (() => {
    class DateTimeColumnDescription extends ColumnDescription {
        constructor() {
            super();
            this.ex = null;
            this.e2 = null;
            this.er = null;
            this.e1 = null;
            this.e0 = null;
            this.ey = null;
            this.eu = null;
            this.ez = null;
            this.eq = null;
        }
        get_type() {
            return "DateTimeColumn";
        }
        get dateTimeFormat() {
            return this.ex;
        }
        set dateTimeFormat(a) {
            this.ex = a;
            this.e("DateTimeFormat");
        }
        get formatString() {
            return this.e2;
        }
        set formatString(a) {
            this.e2 = a;
            this.e("FormatString");
        }
        get formatSpecifiers() {
            return this.er;
        }
        set formatSpecifiers(a) {
            this.er = a;
            this.e("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.e1;
        }
        set formatOverrideRef(a) {
            this.e1 = a;
            this.e("FormatOverrideRef");
        }
        get editorType() {
            return this.e0;
        }
        set editorType(a) {
            this.e0 = a;
            this.e("EditorType");
        }
        get editorDataSourceRef() {
            return this.ey;
        }
        set editorDataSourceRef(a) {
            this.ey = a;
            this.e("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.eu;
        }
        set editorDataSource(a) {
            this.eu = a;
            this.e("EditorDataSource");
        }
        get editorTextField() {
            return this.ez;
        }
        set editorTextField(a) {
            this.ez = a;
            this.e("EditorTextField");
        }
        get editorValueField() {
            return this.eq;
        }
        set editorValueField(a) {
            this.eq = a;
            this.e("EditorValueField");
        }
    }
    DateTimeColumnDescription.$t = /*@__PURE__*/ markType(DateTimeColumnDescription, 'DateTimeColumnDescription', ColumnDescription.$);
    DateTimeColumnDescription.__canMarshalByValue1 = true;
    return DateTimeColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateTimeColumnDescriptionMetadata extends Base {
        static b(a) {
            if (DateTimeColumnDescriptionMetadata.a == null) {
                DateTimeColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateTimeColumnDescriptionMetadata.c(a, DateTimeColumnDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnDescriptionMetadata.c(a, b);
            b.item("DateTimeFormat", "ExportedType:string:DateTimeFormats");
            b.item("DateTimeFormat@names", "DateShort;DateLong;TimeShort;TimeLong;DateTimeShort;DateTimeLong");
            b.item("FormatString", "String");
            b.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            b.item("EditorType", "ExportedType:string:EditorType");
            b.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            b.item("EditorDataSourceRef", "(w:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            b.item("EditorDataSource", "(w:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            b.item("EditorTextField", "String");
            b.item("EditorValueField", "Array:string");
        }
        static d(a) {
            DateTimeColumnDescriptionMetadata.b(a);
            a.q("DateTimeColumn", () => new DateTimeColumnDescription());
            a.p("DateTimeColumn", DateTimeColumnDescriptionMetadata.a);
        }
    }
    DateTimeColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(DateTimeColumnDescriptionMetadata, 'DateTimeColumnDescriptionMetadata');
    DateTimeColumnDescriptionMetadata.a = null;
    return DateTimeColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeColumnDescriptionModule = /*@__PURE__*/ (() => {
    class DateTimeColumnDescriptionModule extends Base {
        static register(a) {
            DateTimeColumnDescriptionMetadata.d(a);
        }
    }
    DateTimeColumnDescriptionModule.$t = /*@__PURE__*/ markType(DateTimeColumnDescriptionModule, 'DateTimeColumnDescriptionModule');
    return DateTimeColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class TemplateCellUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "TemplateCellUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    TemplateCellUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(TemplateCellUpdatingEventArgsDescription, 'TemplateCellUpdatingEventArgsDescription', Description.$);
    return TemplateCellUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateCellUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateCellUpdatingEventArgsDescriptionMetadata.a == null) {
                TemplateCellUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateCellUpdatingEventArgsDescriptionMetadata.c(a, TemplateCellUpdatingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            TemplateCellUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("TemplateCellUpdatingEventArgs", () => new TemplateCellUpdatingEventArgsDescription());
            a.p("TemplateCellUpdatingEventArgs", TemplateCellUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    TemplateCellUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateCellUpdatingEventArgsDescriptionMetadata, 'TemplateCellUpdatingEventArgsDescriptionMetadata');
    TemplateCellUpdatingEventArgsDescriptionMetadata.a = null;
    return TemplateCellUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateColumnDescription = /*@__PURE__*/ (() => {
    class TemplateColumnDescription extends ColumnDescription {
        constructor() {
            super();
            this.es = null;
            this.er = null;
        }
        get templateRef() {
            return this.es;
        }
        set templateRef(a) {
            this.es = a;
            this.e("TemplateRef");
        }
        get_type() {
            return "TemplateColumn";
        }
        get cellUpdatingRef() {
            return this.er;
        }
        set cellUpdatingRef(a) {
            this.er = a;
            this.e("CellUpdatingRef");
        }
    }
    TemplateColumnDescription.$t = /*@__PURE__*/ markType(TemplateColumnDescription, 'TemplateColumnDescription', ColumnDescription.$);
    TemplateColumnDescription.__canMarshalByValue1 = true;
    return TemplateColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateColumnDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("TemplateRef", "(w:Template,wf:Template)DataRef:String");
        }
        static b(a) {
            if (TemplateColumnDescriptionMetadata.a == null) {
                TemplateColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateColumnDescriptionMetadata.c(a, TemplateColumnDescriptionMetadata.a);
                TemplateCellUpdatingEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ColumnDescriptionMetadata.c(a, b);
            b.item("CellUpdatingRef", "EventRef::cellUpdating");
            TemplateColumnDescriptionMetadata.e(a, b);
        }
        static d(a) {
            TemplateColumnDescriptionMetadata.b(a);
            a.q("TemplateColumn", () => new TemplateColumnDescription());
            a.p("TemplateColumn", TemplateColumnDescriptionMetadata.a);
        }
    }
    TemplateColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateColumnDescriptionMetadata, 'TemplateColumnDescriptionMetadata');
    TemplateColumnDescriptionMetadata.a = null;
    return TemplateColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateColumnDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateColumnDescriptionModule extends Base {
        static register(a) {
            TemplateColumnDescriptionMetadata.d(a);
        }
    }
    TemplateColumnDescriptionModule.$t = /*@__PURE__*/ markType(TemplateColumnDescriptionModule, 'TemplateColumnDescriptionModule');
    return TemplateColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxDescriptionModule = /*@__PURE__*/ (() => {
    class CheckboxDescriptionModule extends Base {
        static register(a) {
            RippleDescriptionModule.register(a);
            ChildContentDescriptionModule.register(a);
            CheckboxDescriptionMetadata.d(a);
        }
    }
    CheckboxDescriptionModule.$t = /*@__PURE__*/ markType(CheckboxDescriptionModule, 'CheckboxDescriptionModule');
    return CheckboxDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyEventArgsDescription = /*@__PURE__*/ (() => {
    class KeyEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "KeyEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    KeyEventArgsDescription.$t = /*@__PURE__*/ markType(KeyEventArgsDescription, 'KeyEventArgsDescription', Description.$);
    return KeyEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class KeyEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (KeyEventArgsDescriptionMetadata.a == null) {
                KeyEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                KeyEventArgsDescriptionMetadata.c(a, KeyEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            KeyEventArgsDescriptionMetadata.b(a);
            a.q("KeyEventArgs", () => new KeyEventArgsDescription());
            a.p("KeyEventArgs", KeyEventArgsDescriptionMetadata.a);
        }
    }
    KeyEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(KeyEventArgsDescriptionMetadata, 'KeyEventArgsDescriptionMetadata');
    KeyEventArgsDescriptionMetadata.a = null;
    return KeyEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class InputChangeEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.f = false;
        }
        get_type() {
            return "InputChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get value() {
            return this.h;
        }
        set value(a) {
            this.h = a;
            this.e("Value");
        }
        get isCompositionInProgress() {
            return this.f;
        }
        set isCompositionInProgress(a) {
            this.f = a;
            this.e("IsCompositionInProgress");
        }
    }
    InputChangeEventArgsDescription.$t = /*@__PURE__*/ markType(InputChangeEventArgsDescription, 'InputChangeEventArgsDescription', Description.$);
    return InputChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (InputChangeEventArgsDescriptionMetadata.a == null) {
                InputChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputChangeEventArgsDescriptionMetadata.c(a, InputChangeEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Value", "String");
            b.item("IsCompositionInProgress", "Boolean");
        }
        static d(a) {
            InputChangeEventArgsDescriptionMetadata.b(a);
            a.q("InputChangeEventArgs", () => new InputChangeEventArgsDescription());
            a.p("InputChangeEventArgs", InputChangeEventArgsDescriptionMetadata.a);
        }
    }
    InputChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(InputChangeEventArgsDescriptionMetadata, 'InputChangeEventArgsDescriptionMetadata');
    InputChangeEventArgsDescriptionMetadata.a = null;
    return InputChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupItemDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputGroupItemDescriptionMetadata extends Base {
        static b(a) {
            if (InputGroupItemDescriptionMetadata.a == null) {
                InputGroupItemDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputGroupItemDescriptionMetadata.c(a, InputGroupItemDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Name", "String");
        }
        static d(a) {
            InputGroupItemDescriptionMetadata.b(a);
            a.p("InputGroupItem", InputGroupItemDescriptionMetadata.a);
        }
    }
    InputGroupItemDescriptionMetadata.$t = /*@__PURE__*/ markType(InputGroupItemDescriptionMetadata, 'InputGroupItemDescriptionMetadata');
    InputGroupItemDescriptionMetadata.a = null;
    return InputGroupItemDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupItemDescription = /*@__PURE__*/ (() => {
    class InputGroupItemDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "InputGroupItem";
        }
        get type() {
            return this.get_type();
        }
        get name() {
            return this.f;
        }
        set name(a) {
            this.f = a;
            this.e("Name");
        }
    }
    InputGroupItemDescription.$t = /*@__PURE__*/ markType(InputGroupItemDescription, 'InputGroupItemDescription', Description.$);
    return InputGroupItemDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputDescription = /*@__PURE__*/ (() => {
    class InputDescription extends InputGroupItemDescription {
        constructor() {
            super();
            this.ac = null;
            this.w = null;
            this.an = null;
            this.ap = null;
            this.j = false;
            this.y = null;
            this.x = null;
            this.aq = null;
            this.ad = null;
            this.o = 0;
            this.ae = null;
            this.af = null;
            this.aj = null;
            this.ao = null;
            this.ah = null;
            this.ai = null;
            this.s = 0;
            this.ag = null;
            this.z = null;
            this.k = false;
            this.ar = null;
            this.i = false;
            this.r = 0;
            this.q = 0;
            this.ak = null;
            this.am = null;
            this.al = null;
            this.aa = null;
            this.ab = null;
        }
        get_type() {
            return "Input";
        }
        get density() {
            return this.ac;
        }
        set density(a) {
            this.ac = a;
            this.e("Density");
        }
        get actualDensity() {
            return this.w;
        }
        set actualDensity(a) {
            this.w = a;
            this.e("ActualDensity");
        }
        get mask() {
            return this.an;
        }
        set mask(a) {
            this.an = a;
            this.e("Mask");
        }
        get promptChar() {
            return this.ap;
        }
        set promptChar(a) {
            this.ap = a;
            this.e("PromptChar");
        }
        get includeLiterals() {
            return this.j;
        }
        set includeLiterals(a) {
            this.j = a;
            this.e("IncludeLiterals");
        }
        get actualTextColor() {
            return this.y;
        }
        set actualTextColor(a) {
            this.y = a;
            this.e("ActualTextColor");
        }
        get actualHoverTextColor() {
            return this.x;
        }
        set actualHoverTextColor(a) {
            this.x = a;
            this.e("ActualHoverTextColor");
        }
        get textColor() {
            return this.aq;
        }
        set textColor(a) {
            this.aq = a;
            this.e("TextColor");
        }
        get fontFamily() {
            return this.ad;
        }
        set fontFamily(a) {
            this.ad = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.o;
        }
        set fontSize(a) {
            this.o = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.ae;
        }
        set fontStyle(a) {
            this.ae = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.af;
        }
        set fontWeight(a) {
            this.af = a;
            this.e("FontWeight");
        }
        get inputType() {
            return this.aj;
        }
        set inputType(a) {
            this.aj = a;
            this.e("InputType");
        }
        get placeholder() {
            return this.ao;
        }
        set placeholder(a) {
            this.ao = a;
            this.e("Placeholder");
        }
        get hoverTextColor() {
            return this.ah;
        }
        set hoverTextColor(a) {
            this.ah = a;
            this.e("HoverTextColor");
        }
        get id() {
            return this.ai;
        }
        set id(a) {
            this.ai = a;
            this.e("Id");
        }
        get tabIndex() {
            return this.s;
        }
        set tabIndex(a) {
            this.s = a;
            this.e("TabIndex");
        }
        get $for() {
            return this.ag;
        }
        set $for(a) {
            this.ag = a;
            this.e("For");
        }
        get ariaLabel() {
            return this.z;
        }
        set ariaLabel(a) {
            this.z = a;
            this.e("AriaLabel");
        }
        get isHover() {
            return this.k;
        }
        set isHover(a) {
            this.k = a;
            this.e("IsHover");
        }
        get value() {
            return this.ar;
        }
        set value(a) {
            this.ar = a;
            this.e("Value");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.e("Disabled");
        }
        get selectionStart() {
            return this.r;
        }
        set selectionStart(a) {
            this.r = a;
            this.e("SelectionStart");
        }
        get selectionEnd() {
            return this.q;
        }
        set selectionEnd(a) {
            this.q = a;
            this.e("SelectionEnd");
        }
        get keyDownRef() {
            return this.ak;
        }
        set keyDownRef(a) {
            this.ak = a;
            this.e("KeyDownRef");
        }
        get keyUpRef() {
            return this.am;
        }
        set keyUpRef(a) {
            this.am = a;
            this.e("KeyUpRef");
        }
        get keyPressRef() {
            return this.al;
        }
        set keyPressRef(a) {
            this.al = a;
            this.e("KeyPressRef");
        }
        get changeRef() {
            return this.aa;
        }
        set changeRef(a) {
            this.aa = a;
            this.e("ChangeRef");
        }
        get changingRef() {
            return this.ab;
        }
        set changingRef(a) {
            this.ab = a;
            this.e("ChangingRef");
        }
    }
    InputDescription.$t = /*@__PURE__*/ markType(InputDescription, 'InputDescription', InputGroupItemDescription.$);
    return InputDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputDescriptionMetadata extends Base {
        static b(a) {
            if (InputDescriptionMetadata.a == null) {
                InputDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputDescriptionMetadata.c(a, InputDescriptionMetadata.a);
                KeyEventArgsDescriptionMetadata.d(a);
                InputChangeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            InputGroupItemDescriptionMetadata.c(a, b);
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("Mask", "String");
            b.item("PromptChar", "String");
            b.item("IncludeLiterals", "Boolean");
            b.item("ActualTextColor", "Brush");
            b.item("ActualHoverTextColor", "Brush");
            b.item("TextColor", "Brush");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("InputType", "String");
            b.item("Placeholder", "String");
            b.item("HoverTextColor", "Brush");
            b.item("Id", "String");
            b.item("TabIndex", "Number:int");
            b.item("For", "(w:ForAttribute,wf:ForAttribute)String");
            b.item("AriaLabel", "String");
            b.item("IsHover", "Boolean");
            b.item("Value", "String");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
            b.item("SelectionStart", "Number:int");
            b.item("SelectionEnd", "Number:int");
            b.item("KeyDownRef", "EventRef::keyDown");
            b.item("KeyUpRef", "EventRef::keyUp");
            b.item("KeyPressRef", "EventRef::keyPress");
            b.item("ChangeRef", "EventRef::change");
            b.item("ChangingRef", "EventRef::changing");
        }
        static d(a) {
            InputDescriptionMetadata.b(a);
            a.q("Input", () => new InputDescription());
            a.p("Input", InputDescriptionMetadata.a);
        }
    }
    InputDescriptionMetadata.$t = /*@__PURE__*/ markType(InputDescriptionMetadata, 'InputDescriptionMetadata');
    InputDescriptionMetadata.a = null;
    return InputDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputDescriptionModule = /*@__PURE__*/ (() => {
    class InputDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            InputDescriptionMetadata.d(a);
        }
    }
    InputDescriptionModule.$t = /*@__PURE__*/ markType(InputDescriptionModule, 'InputDescriptionModule');
    return InputDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelDescription = /*@__PURE__*/ (() => {
    class LabelDescription extends InputGroupItemDescription {
        constructor() {
            super();
            this.z = null;
            this.aa = null;
            this.s = null;
            this.w = null;
            this.t = null;
            this.u = null;
            this.v = null;
            this.an = null;
            this.ai = null;
            this.aj = null;
            this.ae = null;
            this.o = 0;
            this.af = null;
            this.ag = null;
            this.ak = null;
            this.al = null;
            this.ab = null;
            this.ac = null;
            this.ad = null;
            this.x = null;
            this.q = 0;
            this.ah = null;
            this.y = null;
            this.am = null;
            this.j = false;
            this.k = false;
            this.i = false;
        }
        get_type() {
            return "Label";
        }
        get baseTheme() {
            return this.z;
        }
        set baseTheme(a) {
            this.z = a;
            this.e("BaseTheme");
        }
        get density() {
            return this.aa;
        }
        set density(a) {
            this.aa = a;
            this.e("Density");
        }
        get actualDensity() {
            return this.s;
        }
        set actualDensity(a) {
            this.s = a;
            this.e("ActualDensity");
        }
        get actualTextColor() {
            return this.w;
        }
        set actualTextColor(a) {
            this.w = a;
            this.e("ActualTextColor");
        }
        get actualHighlightTextColor() {
            return this.t;
        }
        set actualHighlightTextColor(a) {
            this.t = a;
            this.e("ActualHighlightTextColor");
        }
        get actualHoverHighlightTextColor() {
            return this.u;
        }
        set actualHoverHighlightTextColor(a) {
            this.u = a;
            this.e("ActualHoverHighlightTextColor");
        }
        get actualHoverTextColor() {
            return this.v;
        }
        set actualHoverTextColor(a) {
            this.v = a;
            this.e("ActualHoverTextColor");
        }
        get textColor() {
            return this.an;
        }
        set textColor(a) {
            this.an = a;
            this.e("TextColor");
        }
        get highlightTextColor() {
            return this.ai;
        }
        set highlightTextColor(a) {
            this.ai = a;
            this.e("HighlightTextColor");
        }
        get hoverHighlightTextColor() {
            return this.aj;
        }
        set hoverHighlightTextColor(a) {
            this.aj = a;
            this.e("HoverHighlightTextColor");
        }
        get fontFamily() {
            return this.ae;
        }
        set fontFamily(a) {
            this.ae = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.o;
        }
        set fontSize(a) {
            this.o = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.af;
        }
        set fontStyle(a) {
            this.af = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.ag;
        }
        set fontWeight(a) {
            this.ag = a;
            this.e("FontWeight");
        }
        get hoverTextColor() {
            return this.ak;
        }
        set hoverTextColor(a) {
            this.ak = a;
            this.e("HoverTextColor");
        }
        get id() {
            return this.al;
        }
        set id(a) {
            this.al = a;
            this.e("Id");
        }
        get display() {
            return this.ab;
        }
        set display(a) {
            this.ab = a;
            this.e("Display");
        }
        get flexDirection() {
            return this.ac;
        }
        set flexDirection(a) {
            this.ac = a;
            this.e("FlexDirection");
        }
        get flexGrow() {
            return this.ad;
        }
        set flexGrow(a) {
            this.ad = a;
            this.e("FlexGrow");
        }
        get alignItems() {
            return this.x;
        }
        set alignItems(a) {
            this.x = a;
            this.e("AlignItems");
        }
        get tabIndex() {
            return this.q;
        }
        set tabIndex(a) {
            this.q = a;
            this.e("TabIndex");
        }
        get $for() {
            return this.ah;
        }
        set $for(a) {
            this.ah = a;
            this.e("For");
        }
        get ariaLabel() {
            return this.y;
        }
        set ariaLabel(a) {
            this.y = a;
            this.e("AriaLabel");
        }
        get text() {
            return this.am;
        }
        set text(a) {
            this.am = a;
            this.e("Text");
        }
        get isHover() {
            return this.j;
        }
        set isHover(a) {
            this.j = a;
            this.e("IsHover");
        }
        get value() {
            return this.k;
        }
        set value(a) {
            this.k = a;
            this.e("Value");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.e("Disabled");
        }
    }
    LabelDescription.$t = /*@__PURE__*/ markType(LabelDescription, 'LabelDescription', InputGroupItemDescription.$);
    return LabelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelDescriptionMetadata = /*@__PURE__*/ (() => {
    class LabelDescriptionMetadata extends Base {
        static b(a) {
            if (LabelDescriptionMetadata.a == null) {
                LabelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LabelDescriptionMetadata.c(a, LabelDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            InputGroupItemDescriptionMetadata.c(a, b);
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualTextColor", "Brush");
            b.item("ActualHighlightTextColor", "Brush");
            b.item("ActualHoverHighlightTextColor", "Brush");
            b.item("ActualHoverTextColor", "Brush");
            b.item("TextColor", "Brush");
            b.item("HighlightTextColor", "Brush");
            b.item("HoverHighlightTextColor", "Brush");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("HoverTextColor", "Brush");
            b.item("Id", "String");
            b.item("Display", "String");
            b.item("FlexDirection", "String");
            b.item("FlexGrow", "String");
            b.item("AlignItems", "String");
            b.item("TabIndex", "Number:int");
            b.item("For", "(w:ForAttribute,wf:ForAttribute)String");
            b.item("AriaLabel", "String");
            b.item("Text", "String");
            b.item("IsHover", "Boolean");
            b.item("Value", "Boolean");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            LabelDescriptionMetadata.b(a);
            a.q("Label", () => new LabelDescription());
            a.p("Label", LabelDescriptionMetadata.a);
        }
    }
    LabelDescriptionMetadata.$t = /*@__PURE__*/ markType(LabelDescriptionMetadata, 'LabelDescriptionMetadata');
    LabelDescriptionMetadata.a = null;
    return LabelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelDescriptionModule = /*@__PURE__*/ (() => {
    class LabelDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            LabelDescriptionMetadata.d(a);
        }
    }
    LabelDescriptionModule.$t = /*@__PURE__*/ markType(LabelDescriptionModule, 'LabelDescriptionModule');
    return LabelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupDescription = /*@__PURE__*/ (() => {
    class InputGroupDescription extends Description {
        constructor() {
            super();
            this.gs = null;
            this.gr = null;
            this.f4 = null;
            this.gb = null;
            this.f3 = null;
            this.f5 = null;
            this.r = 0;
            this.aa = 0;
            this.x = 0;
            this.w = 0;
            this.y = 0;
            this.z = 0;
            this.s = 0;
            this.t = 0;
            this.u = 0;
            this.v = 0;
            this.ai = 0;
            this.ah = 0;
            this.ae = 0;
            this.f8 = null;
            this.f9 = null;
            this.f7 = null;
            this.f6 = null;
            this.af = 0;
            this.ad = 0;
            this.ab = 0;
            this.ac = 0;
            this.ag = 0;
            this.f2 = null;
            this.a1 = 0;
            this.bs = 0;
            this.gc = null;
            this.bp = 0;
            this.bo = 0;
            this.bq = 0;
            this.br = 0;
            this.bk = 0;
            this.bl = 0;
            this.bm = 0;
            this.bn = 0;
            this.c0 = 0;
            this.cz = 0;
            this.bw = 0;
            this.hb = null;
            this.hc = null;
            this.gv = null;
            this.gu = null;
            this.cx = 0;
            this.bv = 0;
            this.bt = 0;
            this.bu = 0;
            this.cy = 0;
            this.ga = null;
            this.bx = 0;
            this.b6 = 0;
            this.gz = null;
            this.gy = null;
            this.b3 = 0;
            this.b2 = 0;
            this.b4 = 0;
            this.b5 = 0;
            this.by = 0;
            this.bz = 0;
            this.b0 = 0;
            this.b1 = 0;
            this.ce = 0;
            this.cd = 0;
            this.ca = 0;
            this.g2 = null;
            this.g3 = null;
            this.g1 = null;
            this.g0 = null;
            this.cb = 0;
            this.b9 = 0;
            this.b7 = 0;
            this.b8 = 0;
            this.cc = 0;
            this.gx = null;
            this.a2 = 0;
            this.bb = 0;
            this.gm = null;
            this.gl = null;
            this.a8 = 0;
            this.a7 = 0;
            this.a9 = 0;
            this.ba = 0;
            this.a3 = 0;
            this.a4 = 0;
            this.a5 = 0;
            this.a6 = 0;
            this.bj = 0;
            this.bi = 0;
            this.bf = 0;
            this.gp = null;
            this.gq = null;
            this.go = null;
            this.gn = null;
            this.bg = 0;
            this.be = 0;
            this.bc = 0;
            this.bd = 0;
            this.bh = 0;
            this.gk = null;
            this.aj = 0;
            this.as = 0;
            this.gf = null;
            this.ge = null;
            this.ap = 0;
            this.ao = 0;
            this.aq = 0;
            this.ar = 0;
            this.ak = 0;
            this.al = 0;
            this.am = 0;
            this.an = 0;
            this.a0 = 0;
            this.az = 0;
            this.aw = 0;
            this.gi = null;
            this.gj = null;
            this.gh = null;
            this.gg = null;
            this.ax = 0;
            this.av = 0;
            this.at = 0;
            this.au = 0;
            this.ay = 0;
            this.gd = null;
            this.cf = 0;
            this.co = 0;
            this.g6 = null;
            this.g5 = null;
            this.cl = 0;
            this.ck = 0;
            this.cm = 0;
            this.cn = 0;
            this.cg = 0;
            this.ch = 0;
            this.ci = 0;
            this.cj = 0;
            this.cw = 0;
            this.cv = 0;
            this.cs = 0;
            this.g9 = null;
            this.ha = null;
            this.g8 = null;
            this.g7 = null;
            this.ct = 0;
            this.cr = 0;
            this.cp = 0;
            this.cq = 0;
            this.cu = 0;
            this.g4 = null;
            this.j = false;
            this.l = false;
            this.k = false;
            this.h = false;
            this.gt = null;
            this.gw = null;
            this.i = false;
            this.f = null;
        }
        get_type() {
            return "InputGroup";
        }
        get type() {
            return this.get_type();
        }
        get displayType() {
            return this.gs;
        }
        set displayType(a) {
            this.gs = a;
            this.e("DisplayType");
        }
        get density() {
            return this.gr;
        }
        set density(a) {
            this.gr = a;
            this.e("Density");
        }
        get actualDensity() {
            return this.f4;
        }
        set actualDensity(a) {
            this.f4 = a;
            this.e("ActualDensity");
        }
        get baseTheme() {
            return this.gb;
        }
        set baseTheme(a) {
            this.gb = a;
            this.e("BaseTheme");
        }
        get actualBorderColor() {
            return this.f3;
        }
        set actualBorderColor(a) {
            this.f3 = a;
            this.e("ActualBorderColor");
        }
        get actualFocusBorderColor() {
            return this.f5;
        }
        set actualFocusBorderColor(a) {
            this.f5 = a;
            this.e("ActualFocusBorderColor");
        }
        get actualBorderWidth() {
            return this.r;
        }
        set actualBorderWidth(a) {
            this.r = a;
            this.e("ActualBorderWidth");
        }
        get actualFocusBorderWidth() {
            return this.aa;
        }
        set actualFocusBorderWidth(a) {
            this.aa = a;
            this.e("ActualFocusBorderWidth");
        }
        get actualCornerRadiusBottomRight() {
            return this.x;
        }
        set actualCornerRadiusBottomRight(a) {
            this.x = a;
            this.e("ActualCornerRadiusBottomRight");
        }
        get actualCornerRadiusBottomLeft() {
            return this.w;
        }
        set actualCornerRadiusBottomLeft(a) {
            this.w = a;
            this.e("ActualCornerRadiusBottomLeft");
        }
        get actualCornerRadiusTopLeft() {
            return this.y;
        }
        set actualCornerRadiusTopLeft(a) {
            this.y = a;
            this.e("ActualCornerRadiusTopLeft");
        }
        get actualCornerRadiusTopRight() {
            return this.z;
        }
        set actualCornerRadiusTopRight(a) {
            this.z = a;
            this.e("ActualCornerRadiusTopRight");
        }
        get actualContentPaddingBottom() {
            return this.s;
        }
        set actualContentPaddingBottom(a) {
            this.s = a;
            this.e("ActualContentPaddingBottom");
        }
        get actualContentPaddingLeft() {
            return this.t;
        }
        set actualContentPaddingLeft(a) {
            this.t = a;
            this.e("ActualContentPaddingLeft");
        }
        get actualContentPaddingRight() {
            return this.u;
        }
        set actualContentPaddingRight(a) {
            this.u = a;
            this.e("ActualContentPaddingRight");
        }
        get actualContentPaddingTop() {
            return this.v;
        }
        set actualContentPaddingTop(a) {
            this.v = a;
            this.e("ActualContentPaddingTop");
        }
        get actualUnderlineWidth() {
            return this.ai;
        }
        set actualUnderlineWidth(a) {
            this.ai = a;
            this.e("ActualUnderlineWidth");
        }
        get actualUnderlineRippleWidth() {
            return this.ah;
        }
        set actualUnderlineRippleWidth(a) {
            this.ah = a;
            this.e("ActualUnderlineRippleWidth");
        }
        get actualHoverUnderlineWidth() {
            return this.ae;
        }
        set actualHoverUnderlineWidth(a) {
            this.ae = a;
            this.e("ActualHoverUnderlineWidth");
        }
        get actualUnderlineColor() {
            return this.f8;
        }
        set actualUnderlineColor(a) {
            this.f8 = a;
            this.e("ActualUnderlineColor");
        }
        get actualUnderlineRippleColor() {
            return this.f9;
        }
        set actualUnderlineRippleColor(a) {
            this.f9 = a;
            this.e("ActualUnderlineRippleColor");
        }
        get actualHoverUnderlineColor() {
            return this.f7;
        }
        set actualHoverUnderlineColor(a) {
            this.f7 = a;
            this.e("ActualHoverUnderlineColor");
        }
        get actualFocusUnderlineColor() {
            return this.f6;
        }
        set actualFocusUnderlineColor(a) {
            this.f6 = a;
            this.e("ActualFocusUnderlineColor");
        }
        get actualUnderlineOpacity() {
            return this.af;
        }
        set actualUnderlineOpacity(a) {
            this.af = a;
            this.e("ActualUnderlineOpacity");
        }
        get actualHoverUnderlineOpacity() {
            return this.ad;
        }
        set actualHoverUnderlineOpacity(a) {
            this.ad = a;
            this.e("ActualHoverUnderlineOpacity");
        }
        get actualFocusUnderlineOpacity() {
            return this.ab;
        }
        set actualFocusUnderlineOpacity(a) {
            this.ab = a;
            this.e("ActualFocusUnderlineOpacity");
        }
        get actualFocusUnderlineRippleOpacity() {
            return this.ac;
        }
        set actualFocusUnderlineRippleOpacity(a) {
            this.ac = a;
            this.e("ActualFocusUnderlineRippleOpacity");
        }
        get actualUnderlineRippleOpacity() {
            return this.ag;
        }
        set actualUnderlineRippleOpacity(a) {
            this.ag = a;
            this.e("ActualUnderlineRippleOpacity");
        }
        get actualBackgroundColor() {
            return this.f2;
        }
        set actualBackgroundColor(a) {
            this.f2 = a;
            this.e("ActualBackgroundColor");
        }
        get borderWidth() {
            return this.a1;
        }
        set borderWidth(a) {
            this.a1 = a;
            this.e("BorderWidth");
        }
        get focusBorderWidth() {
            return this.bs;
        }
        set focusBorderWidth(a) {
            this.bs = a;
            this.e("FocusBorderWidth");
        }
        get borderColor() {
            return this.gc;
        }
        set borderColor(a) {
            this.gc = a;
            this.e("BorderColor");
        }
        get cornerRadiusBottomRight() {
            return this.bp;
        }
        set cornerRadiusBottomRight(a) {
            this.bp = a;
            this.e("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.bo;
        }
        set cornerRadiusBottomLeft(a) {
            this.bo = a;
            this.e("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.bq;
        }
        set cornerRadiusTopLeft(a) {
            this.bq = a;
            this.e("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.br;
        }
        set cornerRadiusTopRight(a) {
            this.br = a;
            this.e("CornerRadiusTopRight");
        }
        get contentPaddingBottom() {
            return this.bk;
        }
        set contentPaddingBottom(a) {
            this.bk = a;
            this.e("ContentPaddingBottom");
        }
        get contentPaddingLeft() {
            return this.bl;
        }
        set contentPaddingLeft(a) {
            this.bl = a;
            this.e("ContentPaddingLeft");
        }
        get contentPaddingRight() {
            return this.bm;
        }
        set contentPaddingRight(a) {
            this.bm = a;
            this.e("ContentPaddingRight");
        }
        get contentPaddingTop() {
            return this.bn;
        }
        set contentPaddingTop(a) {
            this.bn = a;
            this.e("ContentPaddingTop");
        }
        get underlineWidth() {
            return this.c0;
        }
        set underlineWidth(a) {
            this.c0 = a;
            this.e("UnderlineWidth");
        }
        get underlineRippleWidth() {
            return this.cz;
        }
        set underlineRippleWidth(a) {
            this.cz = a;
            this.e("UnderlineRippleWidth");
        }
        get hoverUnderlineWidth() {
            return this.bw;
        }
        set hoverUnderlineWidth(a) {
            this.bw = a;
            this.e("HoverUnderlineWidth");
        }
        get underlineColor() {
            return this.hb;
        }
        set underlineColor(a) {
            this.hb = a;
            this.e("UnderlineColor");
        }
        get underlineRippleColor() {
            return this.hc;
        }
        set underlineRippleColor(a) {
            this.hc = a;
            this.e("UnderlineRippleColor");
        }
        get hoverUnderlineColor() {
            return this.gv;
        }
        set hoverUnderlineColor(a) {
            this.gv = a;
            this.e("HoverUnderlineColor");
        }
        get focusUnderlineColor() {
            return this.gu;
        }
        set focusUnderlineColor(a) {
            this.gu = a;
            this.e("FocusUnderlineColor");
        }
        get underlineOpacity() {
            return this.cx;
        }
        set underlineOpacity(a) {
            this.cx = a;
            this.e("UnderlineOpacity");
        }
        get hoverUnderlineOpacity() {
            return this.bv;
        }
        set hoverUnderlineOpacity(a) {
            this.bv = a;
            this.e("HoverUnderlineOpacity");
        }
        get focusUnderlineOpacity() {
            return this.bt;
        }
        set focusUnderlineOpacity(a) {
            this.bt = a;
            this.e("FocusUnderlineOpacity");
        }
        get focusUnderlineRippleOpacity() {
            return this.bu;
        }
        set focusUnderlineRippleOpacity(a) {
            this.bu = a;
            this.e("FocusUnderlineRippleOpacity");
        }
        get underlineRippleOpacity() {
            return this.cy;
        }
        set underlineRippleOpacity(a) {
            this.cy = a;
            this.e("UnderlineRippleOpacity");
        }
        get backgroundColor() {
            return this.ga;
        }
        set backgroundColor(a) {
            this.ga = a;
            this.e("BackgroundColor");
        }
        get lineTypeBorderWidth() {
            return this.bx;
        }
        set lineTypeBorderWidth(a) {
            this.bx = a;
            this.e("LineTypeBorderWidth");
        }
        get lineTypeFocusBorderWidth() {
            return this.b6;
        }
        set lineTypeFocusBorderWidth(a) {
            this.b6 = a;
            this.e("LineTypeFocusBorderWidth");
        }
        get lineTypeFocusBorderColor() {
            return this.gz;
        }
        set lineTypeFocusBorderColor(a) {
            this.gz = a;
            this.e("LineTypeFocusBorderColor");
        }
        get lineTypeBorderColor() {
            return this.gy;
        }
        set lineTypeBorderColor(a) {
            this.gy = a;
            this.e("LineTypeBorderColor");
        }
        get lineTypeCornerRadiusBottomRight() {
            return this.b3;
        }
        set lineTypeCornerRadiusBottomRight(a) {
            this.b3 = a;
            this.e("LineTypeCornerRadiusBottomRight");
        }
        get lineTypeCornerRadiusBottomLeft() {
            return this.b2;
        }
        set lineTypeCornerRadiusBottomLeft(a) {
            this.b2 = a;
            this.e("LineTypeCornerRadiusBottomLeft");
        }
        get lineTypeCornerRadiusTopLeft() {
            return this.b4;
        }
        set lineTypeCornerRadiusTopLeft(a) {
            this.b4 = a;
            this.e("LineTypeCornerRadiusTopLeft");
        }
        get lineTypeCornerRadiusTopRight() {
            return this.b5;
        }
        set lineTypeCornerRadiusTopRight(a) {
            this.b5 = a;
            this.e("LineTypeCornerRadiusTopRight");
        }
        get lineTypeContentPaddingBottom() {
            return this.by;
        }
        set lineTypeContentPaddingBottom(a) {
            this.by = a;
            this.e("LineTypeContentPaddingBottom");
        }
        get lineTypeContentPaddingLeft() {
            return this.bz;
        }
        set lineTypeContentPaddingLeft(a) {
            this.bz = a;
            this.e("LineTypeContentPaddingLeft");
        }
        get lineTypeContentPaddingRight() {
            return this.b0;
        }
        set lineTypeContentPaddingRight(a) {
            this.b0 = a;
            this.e("LineTypeContentPaddingRight");
        }
        get lineTypeContentPaddingTop() {
            return this.b1;
        }
        set lineTypeContentPaddingTop(a) {
            this.b1 = a;
            this.e("LineTypeContentPaddingTop");
        }
        get lineTypeUnderlineWidth() {
            return this.ce;
        }
        set lineTypeUnderlineWidth(a) {
            this.ce = a;
            this.e("LineTypeUnderlineWidth");
        }
        get lineTypeUnderlineRippleWidth() {
            return this.cd;
        }
        set lineTypeUnderlineRippleWidth(a) {
            this.cd = a;
            this.e("LineTypeUnderlineRippleWidth");
        }
        get lineTypeHoverUnderlineWidth() {
            return this.ca;
        }
        set lineTypeHoverUnderlineWidth(a) {
            this.ca = a;
            this.e("LineTypeHoverUnderlineWidth");
        }
        get lineTypeUnderlineColor() {
            return this.g2;
        }
        set lineTypeUnderlineColor(a) {
            this.g2 = a;
            this.e("LineTypeUnderlineColor");
        }
        get lineTypeUnderlineRippleColor() {
            return this.g3;
        }
        set lineTypeUnderlineRippleColor(a) {
            this.g3 = a;
            this.e("LineTypeUnderlineRippleColor");
        }
        get lineTypeHoverUnderlineColor() {
            return this.g1;
        }
        set lineTypeHoverUnderlineColor(a) {
            this.g1 = a;
            this.e("LineTypeHoverUnderlineColor");
        }
        get lineTypeFocusUnderlineColor() {
            return this.g0;
        }
        set lineTypeFocusUnderlineColor(a) {
            this.g0 = a;
            this.e("LineTypeFocusUnderlineColor");
        }
        get lineTypeUnderlineOpacity() {
            return this.cb;
        }
        set lineTypeUnderlineOpacity(a) {
            this.cb = a;
            this.e("LineTypeUnderlineOpacity");
        }
        get lineTypeHoverUnderlineOpacity() {
            return this.b9;
        }
        set lineTypeHoverUnderlineOpacity(a) {
            this.b9 = a;
            this.e("LineTypeHoverUnderlineOpacity");
        }
        get lineTypeFocusUnderlineOpacity() {
            return this.b7;
        }
        set lineTypeFocusUnderlineOpacity(a) {
            this.b7 = a;
            this.e("LineTypeFocusUnderlineOpacity");
        }
        get lineTypeFocusUnderlineRippleOpacity() {
            return this.b8;
        }
        set lineTypeFocusUnderlineRippleOpacity(a) {
            this.b8 = a;
            this.e("LineTypeFocusUnderlineRippleOpacity");
        }
        get lineTypeUnderlineRippleOpacity() {
            return this.cc;
        }
        set lineTypeUnderlineRippleOpacity(a) {
            this.cc = a;
            this.e("LineTypeUnderlineRippleOpacity");
        }
        get lineTypeBackgroundColor() {
            return this.gx;
        }
        set lineTypeBackgroundColor(a) {
            this.gx = a;
            this.e("LineTypeBackgroundColor");
        }
        get boxTypeBorderWidth() {
            return this.a2;
        }
        set boxTypeBorderWidth(a) {
            this.a2 = a;
            this.e("BoxTypeBorderWidth");
        }
        get boxTypeFocusBorderWidth() {
            return this.bb;
        }
        set boxTypeFocusBorderWidth(a) {
            this.bb = a;
            this.e("BoxTypeFocusBorderWidth");
        }
        get boxTypeFocusBorderColor() {
            return this.gm;
        }
        set boxTypeFocusBorderColor(a) {
            this.gm = a;
            this.e("BoxTypeFocusBorderColor");
        }
        get boxTypeBorderColor() {
            return this.gl;
        }
        set boxTypeBorderColor(a) {
            this.gl = a;
            this.e("BoxTypeBorderColor");
        }
        get boxTypeCornerRadiusBottomRight() {
            return this.a8;
        }
        set boxTypeCornerRadiusBottomRight(a) {
            this.a8 = a;
            this.e("BoxTypeCornerRadiusBottomRight");
        }
        get boxTypeCornerRadiusBottomLeft() {
            return this.a7;
        }
        set boxTypeCornerRadiusBottomLeft(a) {
            this.a7 = a;
            this.e("BoxTypeCornerRadiusBottomLeft");
        }
        get boxTypeCornerRadiusTopLeft() {
            return this.a9;
        }
        set boxTypeCornerRadiusTopLeft(a) {
            this.a9 = a;
            this.e("BoxTypeCornerRadiusTopLeft");
        }
        get boxTypeCornerRadiusTopRight() {
            return this.ba;
        }
        set boxTypeCornerRadiusTopRight(a) {
            this.ba = a;
            this.e("BoxTypeCornerRadiusTopRight");
        }
        get boxTypeContentPaddingBottom() {
            return this.a3;
        }
        set boxTypeContentPaddingBottom(a) {
            this.a3 = a;
            this.e("BoxTypeContentPaddingBottom");
        }
        get boxTypeContentPaddingLeft() {
            return this.a4;
        }
        set boxTypeContentPaddingLeft(a) {
            this.a4 = a;
            this.e("BoxTypeContentPaddingLeft");
        }
        get boxTypeContentPaddingRight() {
            return this.a5;
        }
        set boxTypeContentPaddingRight(a) {
            this.a5 = a;
            this.e("BoxTypeContentPaddingRight");
        }
        get boxTypeContentPaddingTop() {
            return this.a6;
        }
        set boxTypeContentPaddingTop(a) {
            this.a6 = a;
            this.e("BoxTypeContentPaddingTop");
        }
        get boxTypeUnderlineWidth() {
            return this.bj;
        }
        set boxTypeUnderlineWidth(a) {
            this.bj = a;
            this.e("BoxTypeUnderlineWidth");
        }
        get boxTypeUnderlineRippleWidth() {
            return this.bi;
        }
        set boxTypeUnderlineRippleWidth(a) {
            this.bi = a;
            this.e("BoxTypeUnderlineRippleWidth");
        }
        get boxTypeHoverUnderlineWidth() {
            return this.bf;
        }
        set boxTypeHoverUnderlineWidth(a) {
            this.bf = a;
            this.e("BoxTypeHoverUnderlineWidth");
        }
        get boxTypeUnderlineColor() {
            return this.gp;
        }
        set boxTypeUnderlineColor(a) {
            this.gp = a;
            this.e("BoxTypeUnderlineColor");
        }
        get boxTypeUnderlineRippleColor() {
            return this.gq;
        }
        set boxTypeUnderlineRippleColor(a) {
            this.gq = a;
            this.e("BoxTypeUnderlineRippleColor");
        }
        get boxTypeHoverUnderlineColor() {
            return this.go;
        }
        set boxTypeHoverUnderlineColor(a) {
            this.go = a;
            this.e("BoxTypeHoverUnderlineColor");
        }
        get boxTypeFocusUnderlineColor() {
            return this.gn;
        }
        set boxTypeFocusUnderlineColor(a) {
            this.gn = a;
            this.e("BoxTypeFocusUnderlineColor");
        }
        get boxTypeUnderlineOpacity() {
            return this.bg;
        }
        set boxTypeUnderlineOpacity(a) {
            this.bg = a;
            this.e("BoxTypeUnderlineOpacity");
        }
        get boxTypeHoverUnderlineOpacity() {
            return this.be;
        }
        set boxTypeHoverUnderlineOpacity(a) {
            this.be = a;
            this.e("BoxTypeHoverUnderlineOpacity");
        }
        get boxTypeFocusUnderlineOpacity() {
            return this.bc;
        }
        set boxTypeFocusUnderlineOpacity(a) {
            this.bc = a;
            this.e("BoxTypeFocusUnderlineOpacity");
        }
        get boxTypeFocusUnderlineRippleOpacity() {
            return this.bd;
        }
        set boxTypeFocusUnderlineRippleOpacity(a) {
            this.bd = a;
            this.e("BoxTypeFocusUnderlineRippleOpacity");
        }
        get boxTypeUnderlineRippleOpacity() {
            return this.bh;
        }
        set boxTypeUnderlineRippleOpacity(a) {
            this.bh = a;
            this.e("BoxTypeUnderlineRippleOpacity");
        }
        get boxTypeBackgroundColor() {
            return this.gk;
        }
        set boxTypeBackgroundColor(a) {
            this.gk = a;
            this.e("BoxTypeBackgroundColor");
        }
        get borderTypeBorderWidth() {
            return this.aj;
        }
        set borderTypeBorderWidth(a) {
            this.aj = a;
            this.e("BorderTypeBorderWidth");
        }
        get borderTypeFocusBorderWidth() {
            return this.as;
        }
        set borderTypeFocusBorderWidth(a) {
            this.as = a;
            this.e("BorderTypeFocusBorderWidth");
        }
        get borderTypeFocusBorderColor() {
            return this.gf;
        }
        set borderTypeFocusBorderColor(a) {
            this.gf = a;
            this.e("BorderTypeFocusBorderColor");
        }
        get borderTypeBorderColor() {
            return this.ge;
        }
        set borderTypeBorderColor(a) {
            this.ge = a;
            this.e("BorderTypeBorderColor");
        }
        get borderTypeCornerRadiusBottomRight() {
            return this.ap;
        }
        set borderTypeCornerRadiusBottomRight(a) {
            this.ap = a;
            this.e("BorderTypeCornerRadiusBottomRight");
        }
        get borderTypeCornerRadiusBottomLeft() {
            return this.ao;
        }
        set borderTypeCornerRadiusBottomLeft(a) {
            this.ao = a;
            this.e("BorderTypeCornerRadiusBottomLeft");
        }
        get borderTypeCornerRadiusTopLeft() {
            return this.aq;
        }
        set borderTypeCornerRadiusTopLeft(a) {
            this.aq = a;
            this.e("BorderTypeCornerRadiusTopLeft");
        }
        get borderTypeCornerRadiusTopRight() {
            return this.ar;
        }
        set borderTypeCornerRadiusTopRight(a) {
            this.ar = a;
            this.e("BorderTypeCornerRadiusTopRight");
        }
        get borderTypeContentPaddingBottom() {
            return this.ak;
        }
        set borderTypeContentPaddingBottom(a) {
            this.ak = a;
            this.e("BorderTypeContentPaddingBottom");
        }
        get borderTypeContentPaddingLeft() {
            return this.al;
        }
        set borderTypeContentPaddingLeft(a) {
            this.al = a;
            this.e("BorderTypeContentPaddingLeft");
        }
        get borderTypeContentPaddingRight() {
            return this.am;
        }
        set borderTypeContentPaddingRight(a) {
            this.am = a;
            this.e("BorderTypeContentPaddingRight");
        }
        get borderTypeContentPaddingTop() {
            return this.an;
        }
        set borderTypeContentPaddingTop(a) {
            this.an = a;
            this.e("BorderTypeContentPaddingTop");
        }
        get borderTypeUnderlineWidth() {
            return this.a0;
        }
        set borderTypeUnderlineWidth(a) {
            this.a0 = a;
            this.e("BorderTypeUnderlineWidth");
        }
        get borderTypeUnderlineRippleWidth() {
            return this.az;
        }
        set borderTypeUnderlineRippleWidth(a) {
            this.az = a;
            this.e("BorderTypeUnderlineRippleWidth");
        }
        get borderTypeHoverUnderlineWidth() {
            return this.aw;
        }
        set borderTypeHoverUnderlineWidth(a) {
            this.aw = a;
            this.e("BorderTypeHoverUnderlineWidth");
        }
        get borderTypeUnderlineColor() {
            return this.gi;
        }
        set borderTypeUnderlineColor(a) {
            this.gi = a;
            this.e("BorderTypeUnderlineColor");
        }
        get borderTypeUnderlineRippleColor() {
            return this.gj;
        }
        set borderTypeUnderlineRippleColor(a) {
            this.gj = a;
            this.e("BorderTypeUnderlineRippleColor");
        }
        get borderTypeHoverUnderlineColor() {
            return this.gh;
        }
        set borderTypeHoverUnderlineColor(a) {
            this.gh = a;
            this.e("BorderTypeHoverUnderlineColor");
        }
        get borderTypeFocusUnderlineColor() {
            return this.gg;
        }
        set borderTypeFocusUnderlineColor(a) {
            this.gg = a;
            this.e("BorderTypeFocusUnderlineColor");
        }
        get borderTypeUnderlineOpacity() {
            return this.ax;
        }
        set borderTypeUnderlineOpacity(a) {
            this.ax = a;
            this.e("BorderTypeUnderlineOpacity");
        }
        get borderTypeHoverUnderlineOpacity() {
            return this.av;
        }
        set borderTypeHoverUnderlineOpacity(a) {
            this.av = a;
            this.e("BorderTypeHoverUnderlineOpacity");
        }
        get borderTypeFocusUnderlineOpacity() {
            return this.at;
        }
        set borderTypeFocusUnderlineOpacity(a) {
            this.at = a;
            this.e("BorderTypeFocusUnderlineOpacity");
        }
        get borderTypeFocusUnderlineRippleOpacity() {
            return this.au;
        }
        set borderTypeFocusUnderlineRippleOpacity(a) {
            this.au = a;
            this.e("BorderTypeFocusUnderlineRippleOpacity");
        }
        get borderTypeUnderlineRippleOpacity() {
            return this.ay;
        }
        set borderTypeUnderlineRippleOpacity(a) {
            this.ay = a;
            this.e("BorderTypeUnderlineRippleOpacity");
        }
        get borderTypeBackgroundColor() {
            return this.gd;
        }
        set borderTypeBackgroundColor(a) {
            this.gd = a;
            this.e("BorderTypeBackgroundColor");
        }
        get searchTypeBorderWidth() {
            return this.cf;
        }
        set searchTypeBorderWidth(a) {
            this.cf = a;
            this.e("SearchTypeBorderWidth");
        }
        get searchTypeFocusBorderWidth() {
            return this.co;
        }
        set searchTypeFocusBorderWidth(a) {
            this.co = a;
            this.e("SearchTypeFocusBorderWidth");
        }
        get searchTypeFocusBorderColor() {
            return this.g6;
        }
        set searchTypeFocusBorderColor(a) {
            this.g6 = a;
            this.e("SearchTypeFocusBorderColor");
        }
        get searchTypeBorderColor() {
            return this.g5;
        }
        set searchTypeBorderColor(a) {
            this.g5 = a;
            this.e("SearchTypeBorderColor");
        }
        get searchTypeCornerRadiusBottomRight() {
            return this.cl;
        }
        set searchTypeCornerRadiusBottomRight(a) {
            this.cl = a;
            this.e("SearchTypeCornerRadiusBottomRight");
        }
        get searchTypeCornerRadiusBottomLeft() {
            return this.ck;
        }
        set searchTypeCornerRadiusBottomLeft(a) {
            this.ck = a;
            this.e("SearchTypeCornerRadiusBottomLeft");
        }
        get searchTypeCornerRadiusTopLeft() {
            return this.cm;
        }
        set searchTypeCornerRadiusTopLeft(a) {
            this.cm = a;
            this.e("SearchTypeCornerRadiusTopLeft");
        }
        get searchTypeCornerRadiusTopRight() {
            return this.cn;
        }
        set searchTypeCornerRadiusTopRight(a) {
            this.cn = a;
            this.e("SearchTypeCornerRadiusTopRight");
        }
        get searchTypeContentPaddingBottom() {
            return this.cg;
        }
        set searchTypeContentPaddingBottom(a) {
            this.cg = a;
            this.e("SearchTypeContentPaddingBottom");
        }
        get searchTypeContentPaddingLeft() {
            return this.ch;
        }
        set searchTypeContentPaddingLeft(a) {
            this.ch = a;
            this.e("SearchTypeContentPaddingLeft");
        }
        get searchTypeContentPaddingRight() {
            return this.ci;
        }
        set searchTypeContentPaddingRight(a) {
            this.ci = a;
            this.e("SearchTypeContentPaddingRight");
        }
        get searchTypeContentPaddingTop() {
            return this.cj;
        }
        set searchTypeContentPaddingTop(a) {
            this.cj = a;
            this.e("SearchTypeContentPaddingTop");
        }
        get searchTypeUnderlineWidth() {
            return this.cw;
        }
        set searchTypeUnderlineWidth(a) {
            this.cw = a;
            this.e("SearchTypeUnderlineWidth");
        }
        get searchTypeUnderlineRippleWidth() {
            return this.cv;
        }
        set searchTypeUnderlineRippleWidth(a) {
            this.cv = a;
            this.e("SearchTypeUnderlineRippleWidth");
        }
        get searchTypeHoverUnderlineWidth() {
            return this.cs;
        }
        set searchTypeHoverUnderlineWidth(a) {
            this.cs = a;
            this.e("SearchTypeHoverUnderlineWidth");
        }
        get searchTypeUnderlineColor() {
            return this.g9;
        }
        set searchTypeUnderlineColor(a) {
            this.g9 = a;
            this.e("SearchTypeUnderlineColor");
        }
        get searchTypeUnderlineRippleColor() {
            return this.ha;
        }
        set searchTypeUnderlineRippleColor(a) {
            this.ha = a;
            this.e("SearchTypeUnderlineRippleColor");
        }
        get searchTypeHoverUnderlineColor() {
            return this.g8;
        }
        set searchTypeHoverUnderlineColor(a) {
            this.g8 = a;
            this.e("SearchTypeHoverUnderlineColor");
        }
        get searchTypeFocusUnderlineColor() {
            return this.g7;
        }
        set searchTypeFocusUnderlineColor(a) {
            this.g7 = a;
            this.e("SearchTypeFocusUnderlineColor");
        }
        get searchTypeUnderlineOpacity() {
            return this.ct;
        }
        set searchTypeUnderlineOpacity(a) {
            this.ct = a;
            this.e("SearchTypeUnderlineOpacity");
        }
        get searchTypeHoverUnderlineOpacity() {
            return this.cr;
        }
        set searchTypeHoverUnderlineOpacity(a) {
            this.cr = a;
            this.e("SearchTypeHoverUnderlineOpacity");
        }
        get searchTypeFocusUnderlineOpacity() {
            return this.cp;
        }
        set searchTypeFocusUnderlineOpacity(a) {
            this.cp = a;
            this.e("SearchTypeFocusUnderlineOpacity");
        }
        get searchTypeFocusUnderlineRippleOpacity() {
            return this.cq;
        }
        set searchTypeFocusUnderlineRippleOpacity(a) {
            this.cq = a;
            this.e("SearchTypeFocusUnderlineRippleOpacity");
        }
        get searchTypeUnderlineRippleOpacity() {
            return this.cu;
        }
        set searchTypeUnderlineRippleOpacity(a) {
            this.cu = a;
            this.e("SearchTypeUnderlineRippleOpacity");
        }
        get searchTypeBackgroundColor() {
            return this.g4;
        }
        set searchTypeBackgroundColor(a) {
            this.g4 = a;
            this.e("SearchTypeBackgroundColor");
        }
        get isExpanded() {
            return this.j;
        }
        set isExpanded(a) {
            this.j = a;
            this.e("IsExpanded");
        }
        get isHovered() {
            return this.l;
        }
        set isHovered(a) {
            this.l = a;
            this.e("IsHovered");
        }
        get isFocused() {
            return this.k;
        }
        set isFocused(a) {
            this.k = a;
            this.e("IsFocused");
        }
        get actualIsExpanded() {
            return this.h;
        }
        set actualIsExpanded(a) {
            this.h = a;
            this.e("ActualIsExpanded");
        }
        get focusBorderColor() {
            return this.gt;
        }
        set focusBorderColor(a) {
            this.gt = a;
            this.e("FocusBorderColor");
        }
        get id() {
            return this.gw;
        }
        set id(a) {
            this.gw = a;
            this.e("Id");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.e("Disabled");
        }
        get inputs() {
            return this.f;
        }
        set inputs(a) {
            this.f = a;
            this.e("Inputs");
        }
    }
    InputGroupDescription.$t = /*@__PURE__*/ markType(InputGroupDescription, 'InputGroupDescription', Description.$);
    return InputGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class InputGroupDescriptionMetadata extends Base {
        static b(a) {
            if (InputGroupDescriptionMetadata.a == null) {
                InputGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                InputGroupDescriptionMetadata.c(a, InputGroupDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("DisplayType", "ExportedType:string:InputGroupDisplayType");
            b.item("DisplayType@names", "Line;Box;Border;Search");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("ActualBorderColor", "Brush");
            b.item("ActualFocusBorderColor", "Brush");
            b.item("ActualBorderWidth", "Number:double");
            b.item("ActualFocusBorderWidth", "Number:double");
            b.item("ActualCornerRadiusBottomRight", "(w:ActualCornerRadius.BottomRight,wf:ActualCornerRadiusBottomRight)Number:double");
            b.item("ActualCornerRadiusBottomLeft", "(w:ActualCornerRadius.BottomLeft,wf:ActualCornerRadiusBottomLeft)Number:double");
            b.item("ActualCornerRadiusTopLeft", "(w:ActualCornerRadius.TopLeft,wf:ActualCornerRadiusTopLeft)Number:double");
            b.item("ActualCornerRadiusTopRight", "(w:ActualCornerRadius.TopRight,wf:ActualCornerRadiusTopRight)Number:double");
            b.item("ActualContentPaddingBottom", "(w:ActualContentPadding.Bottom,wf:ActualContentPaddingBottom)Number:double");
            b.item("ActualContentPaddingLeft", "(w:ActualContentPadding.Left,wf:ActualContentPaddingLeft)Number:double");
            b.item("ActualContentPaddingRight", "(w:ActualContentPadding.Right,wf:ActualContentPaddingRight)Number:double");
            b.item("ActualContentPaddingTop", "(w:ActualContentPadding.Top,wf:ActualContentPaddingTop)Number:double");
            b.item("ActualUnderlineWidth", "Number:double");
            b.item("ActualUnderlineRippleWidth", "Number:double");
            b.item("ActualHoverUnderlineWidth", "Number:double");
            b.item("ActualUnderlineColor", "Brush");
            b.item("ActualUnderlineRippleColor", "Brush");
            b.item("ActualHoverUnderlineColor", "Brush");
            b.item("ActualFocusUnderlineColor", "Brush");
            b.item("ActualUnderlineOpacity", "Number:double");
            b.item("ActualHoverUnderlineOpacity", "Number:double");
            b.item("ActualFocusUnderlineOpacity", "Number:double");
            b.item("ActualFocusUnderlineRippleOpacity", "Number:double");
            b.item("ActualUnderlineRippleOpacity", "Number:double");
            b.item("ActualBackgroundColor", "Brush");
            b.item("BorderWidth", "Number:double");
            b.item("FocusBorderWidth", "Number:double");
            b.item("BorderColor", "Brush");
            b.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            b.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            b.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            b.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            b.item("ContentPaddingBottom", "(w:ContentPadding.Bottom,wf:ContentPaddingBottom)Number:double");
            b.item("ContentPaddingLeft", "(w:ContentPadding.Left,wf:ContentPaddingLeft)Number:double");
            b.item("ContentPaddingRight", "(w:ContentPadding.Right,wf:ContentPaddingRight)Number:double");
            b.item("ContentPaddingTop", "(w:ContentPadding.Top,wf:ContentPaddingTop)Number:double");
            b.item("UnderlineWidth", "Number:double");
            b.item("UnderlineRippleWidth", "Number:double");
            b.item("HoverUnderlineWidth", "Number:double");
            b.item("UnderlineColor", "Brush");
            b.item("UnderlineRippleColor", "Brush");
            b.item("HoverUnderlineColor", "Brush");
            b.item("FocusUnderlineColor", "Brush");
            b.item("UnderlineOpacity", "Number:double");
            b.item("HoverUnderlineOpacity", "Number:double");
            b.item("FocusUnderlineOpacity", "Number:double");
            b.item("FocusUnderlineRippleOpacity", "Number:double");
            b.item("UnderlineRippleOpacity", "Number:double");
            b.item("BackgroundColor", "Brush");
            b.item("LineTypeBorderWidth", "Number:double");
            b.item("LineTypeFocusBorderWidth", "Number:double");
            b.item("LineTypeFocusBorderColor", "Brush");
            b.item("LineTypeBorderColor", "Brush");
            b.item("LineTypeCornerRadiusBottomRight", "(w:LineTypeCornerRadius.BottomRight,wf:LineTypeCornerRadiusBottomRight)Number:double");
            b.item("LineTypeCornerRadiusBottomLeft", "(w:LineTypeCornerRadius.BottomLeft,wf:LineTypeCornerRadiusBottomLeft)Number:double");
            b.item("LineTypeCornerRadiusTopLeft", "(w:LineTypeCornerRadius.TopLeft,wf:LineTypeCornerRadiusTopLeft)Number:double");
            b.item("LineTypeCornerRadiusTopRight", "(w:LineTypeCornerRadius.TopRight,wf:LineTypeCornerRadiusTopRight)Number:double");
            b.item("LineTypeContentPaddingBottom", "(w:LineTypeContentPadding.Bottom,wf:LineTypeContentPaddingBottom)Number:double");
            b.item("LineTypeContentPaddingLeft", "(w:LineTypeContentPadding.Left,wf:LineTypeContentPaddingLeft)Number:double");
            b.item("LineTypeContentPaddingRight", "(w:LineTypeContentPadding.Right,wf:LineTypeContentPaddingRight)Number:double");
            b.item("LineTypeContentPaddingTop", "(w:LineTypeContentPadding.Top,wf:LineTypeContentPaddingTop)Number:double");
            b.item("LineTypeUnderlineWidth", "Number:double");
            b.item("LineTypeUnderlineRippleWidth", "Number:double");
            b.item("LineTypeHoverUnderlineWidth", "Number:double");
            b.item("LineTypeUnderlineColor", "Brush");
            b.item("LineTypeUnderlineRippleColor", "Brush");
            b.item("LineTypeHoverUnderlineColor", "Brush");
            b.item("LineTypeFocusUnderlineColor", "Brush");
            b.item("LineTypeUnderlineOpacity", "Number:double");
            b.item("LineTypeHoverUnderlineOpacity", "Number:double");
            b.item("LineTypeFocusUnderlineOpacity", "Number:double");
            b.item("LineTypeFocusUnderlineRippleOpacity", "Number:double");
            b.item("LineTypeUnderlineRippleOpacity", "Number:double");
            b.item("LineTypeBackgroundColor", "Brush");
            b.item("BoxTypeBorderWidth", "Number:double");
            b.item("BoxTypeFocusBorderWidth", "Number:double");
            b.item("BoxTypeFocusBorderColor", "Brush");
            b.item("BoxTypeBorderColor", "Brush");
            b.item("BoxTypeCornerRadiusBottomRight", "(w:BoxTypeCornerRadius.BottomRight,wf:BoxTypeCornerRadiusBottomRight)Number:double");
            b.item("BoxTypeCornerRadiusBottomLeft", "(w:BoxTypeCornerRadius.BottomLeft,wf:BoxTypeCornerRadiusBottomLeft)Number:double");
            b.item("BoxTypeCornerRadiusTopLeft", "(w:BoxTypeCornerRadius.TopLeft,wf:BoxTypeCornerRadiusTopLeft)Number:double");
            b.item("BoxTypeCornerRadiusTopRight", "(w:BoxTypeCornerRadius.TopRight,wf:BoxTypeCornerRadiusTopRight)Number:double");
            b.item("BoxTypeContentPaddingBottom", "(w:BoxTypeContentPadding.Bottom,wf:BoxTypeContentPaddingBottom)Number:double");
            b.item("BoxTypeContentPaddingLeft", "(w:BoxTypeContentPadding.Left,wf:BoxTypeContentPaddingLeft)Number:double");
            b.item("BoxTypeContentPaddingRight", "(w:BoxTypeContentPadding.Right,wf:BoxTypeContentPaddingRight)Number:double");
            b.item("BoxTypeContentPaddingTop", "(w:BoxTypeContentPadding.Top,wf:BoxTypeContentPaddingTop)Number:double");
            b.item("BoxTypeUnderlineWidth", "Number:double");
            b.item("BoxTypeUnderlineRippleWidth", "Number:double");
            b.item("BoxTypeHoverUnderlineWidth", "Number:double");
            b.item("BoxTypeUnderlineColor", "Brush");
            b.item("BoxTypeUnderlineRippleColor", "Brush");
            b.item("BoxTypeHoverUnderlineColor", "Brush");
            b.item("BoxTypeFocusUnderlineColor", "Brush");
            b.item("BoxTypeUnderlineOpacity", "Number:double");
            b.item("BoxTypeHoverUnderlineOpacity", "Number:double");
            b.item("BoxTypeFocusUnderlineOpacity", "Number:double");
            b.item("BoxTypeFocusUnderlineRippleOpacity", "Number:double");
            b.item("BoxTypeUnderlineRippleOpacity", "Number:double");
            b.item("BoxTypeBackgroundColor", "Brush");
            b.item("BorderTypeBorderWidth", "Number:double");
            b.item("BorderTypeFocusBorderWidth", "Number:double");
            b.item("BorderTypeFocusBorderColor", "Brush");
            b.item("BorderTypeBorderColor", "Brush");
            b.item("BorderTypeCornerRadiusBottomRight", "(w:BorderTypeCornerRadius.BottomRight,wf:BorderTypeCornerRadiusBottomRight)Number:double");
            b.item("BorderTypeCornerRadiusBottomLeft", "(w:BorderTypeCornerRadius.BottomLeft,wf:BorderTypeCornerRadiusBottomLeft)Number:double");
            b.item("BorderTypeCornerRadiusTopLeft", "(w:BorderTypeCornerRadius.TopLeft,wf:BorderTypeCornerRadiusTopLeft)Number:double");
            b.item("BorderTypeCornerRadiusTopRight", "(w:BorderTypeCornerRadius.TopRight,wf:BorderTypeCornerRadiusTopRight)Number:double");
            b.item("BorderTypeContentPaddingBottom", "(w:BorderTypeContentPadding.Bottom,wf:BorderTypeContentPaddingBottom)Number:double");
            b.item("BorderTypeContentPaddingLeft", "(w:BorderTypeContentPadding.Left,wf:BorderTypeContentPaddingLeft)Number:double");
            b.item("BorderTypeContentPaddingRight", "(w:BorderTypeContentPadding.Right,wf:BorderTypeContentPaddingRight)Number:double");
            b.item("BorderTypeContentPaddingTop", "(w:BorderTypeContentPadding.Top,wf:BorderTypeContentPaddingTop)Number:double");
            b.item("BorderTypeUnderlineWidth", "Number:double");
            b.item("BorderTypeUnderlineRippleWidth", "Number:double");
            b.item("BorderTypeHoverUnderlineWidth", "Number:double");
            b.item("BorderTypeUnderlineColor", "Brush");
            b.item("BorderTypeUnderlineRippleColor", "Brush");
            b.item("BorderTypeHoverUnderlineColor", "Brush");
            b.item("BorderTypeFocusUnderlineColor", "Brush");
            b.item("BorderTypeUnderlineOpacity", "Number:double");
            b.item("BorderTypeHoverUnderlineOpacity", "Number:double");
            b.item("BorderTypeFocusUnderlineOpacity", "Number:double");
            b.item("BorderTypeFocusUnderlineRippleOpacity", "Number:double");
            b.item("BorderTypeUnderlineRippleOpacity", "Number:double");
            b.item("BorderTypeBackgroundColor", "Brush");
            b.item("SearchTypeBorderWidth", "Number:double");
            b.item("SearchTypeFocusBorderWidth", "Number:double");
            b.item("SearchTypeFocusBorderColor", "Brush");
            b.item("SearchTypeBorderColor", "Brush");
            b.item("SearchTypeCornerRadiusBottomRight", "(w:SearchTypeCornerRadius.BottomRight,wf:SearchTypeCornerRadiusBottomRight)Number:double");
            b.item("SearchTypeCornerRadiusBottomLeft", "(w:SearchTypeCornerRadius.BottomLeft,wf:SearchTypeCornerRadiusBottomLeft)Number:double");
            b.item("SearchTypeCornerRadiusTopLeft", "(w:SearchTypeCornerRadius.TopLeft,wf:SearchTypeCornerRadiusTopLeft)Number:double");
            b.item("SearchTypeCornerRadiusTopRight", "(w:SearchTypeCornerRadius.TopRight,wf:SearchTypeCornerRadiusTopRight)Number:double");
            b.item("SearchTypeContentPaddingBottom", "(w:SearchTypeContentPadding.Bottom,wf:SearchTypeContentPaddingBottom)Number:double");
            b.item("SearchTypeContentPaddingLeft", "(w:SearchTypeContentPadding.Left,wf:SearchTypeContentPaddingLeft)Number:double");
            b.item("SearchTypeContentPaddingRight", "(w:SearchTypeContentPadding.Right,wf:SearchTypeContentPaddingRight)Number:double");
            b.item("SearchTypeContentPaddingTop", "(w:SearchTypeContentPadding.Top,wf:SearchTypeContentPaddingTop)Number:double");
            b.item("SearchTypeUnderlineWidth", "Number:double");
            b.item("SearchTypeUnderlineRippleWidth", "Number:double");
            b.item("SearchTypeHoverUnderlineWidth", "Number:double");
            b.item("SearchTypeUnderlineColor", "Brush");
            b.item("SearchTypeUnderlineRippleColor", "Brush");
            b.item("SearchTypeHoverUnderlineColor", "Brush");
            b.item("SearchTypeFocusUnderlineColor", "Brush");
            b.item("SearchTypeUnderlineOpacity", "Number:double");
            b.item("SearchTypeHoverUnderlineOpacity", "Number:double");
            b.item("SearchTypeFocusUnderlineOpacity", "Number:double");
            b.item("SearchTypeFocusUnderlineRippleOpacity", "Number:double");
            b.item("SearchTypeUnderlineRippleOpacity", "Number:double");
            b.item("SearchTypeBackgroundColor", "Brush");
            b.item("IsExpanded", "Boolean");
            b.item("IsHovered", "Boolean");
            b.item("IsFocused", "Boolean");
            b.item("ActualIsExpanded", "Boolean");
            b.item("FocusBorderColor", "Brush");
            b.item("Id", "String");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
            b.item("Inputs", "Collection:InputGroupItem:InputGroupInputCollection:InputGroupItem");
        }
        static d(a) {
            InputGroupDescriptionMetadata.b(a);
            a.q("InputGroup", () => new InputGroupDescription());
            a.p("InputGroup", InputGroupDescriptionMetadata.a);
        }
    }
    InputGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(InputGroupDescriptionMetadata, 'InputGroupDescriptionMetadata');
    InputGroupDescriptionMetadata.a = null;
    return InputGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let InputGroupDescriptionModule = /*@__PURE__*/ (() => {
    class InputGroupDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            InputDescriptionModule.register(a);
            LabelDescriptionModule.register(a);
            InputGroupDescriptionMetadata.d(a);
        }
    }
    InputGroupDescriptionModule.$t = /*@__PURE__*/ markType(InputGroupDescriptionModule, 'InputGroupDescriptionModule');
    return InputGroupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CheckboxListDescriptionModule = /*@__PURE__*/ (() => {
    class CheckboxListDescriptionModule extends Base {
        static register(a) {
            DataGridCoreDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            TemplateColumnDescriptionModule.register(a);
            CheckboxDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            CheckboxListDescriptionMetadata.d(a);
        }
    }
    CheckboxListDescriptionModule.$t = /*@__PURE__*/ markType(CheckboxListDescriptionModule, 'CheckboxListDescriptionModule');
    return CheckboxListDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnChooserDescription = /*@__PURE__*/ (() => {
    class ColumnChooserDescription extends Description {
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.o = null;
            this.f = 0;
            this.p = null;
            this.q = null;
            this.n = null;
            this.k = null;
            this.i = null;
            this.j = null;
            this.h = null;
        }
        get_type() {
            return "ColumnChooser";
        }
        get type() {
            return this.get_type();
        }
        get targetGridRef() {
            return this.l;
        }
        set targetGridRef(a) {
            this.l = a;
            this.e("TargetGridRef");
        }
        get title() {
            return this.m;
        }
        set title(a) {
            this.m = a;
            this.e("Title");
        }
        get titleFontFamily() {
            return this.o;
        }
        set titleFontFamily(a) {
            this.o = a;
            this.e("TitleFontFamily");
        }
        get titleFontSize() {
            return this.f;
        }
        set titleFontSize(a) {
            this.f = a;
            this.e("TitleFontSize");
        }
        get titleFontStyle() {
            return this.p;
        }
        set titleFontStyle(a) {
            this.p = a;
            this.e("TitleFontStyle");
        }
        get titleFontWeight() {
            return this.q;
        }
        set titleFontWeight(a) {
            this.q = a;
            this.e("TitleFontWeight");
        }
        get titleColor() {
            return this.n;
        }
        set titleColor(a) {
            this.n = a;
            this.e("TitleColor");
        }
        get filterPlaceholderText() {
            return this.k;
        }
        set filterPlaceholderText(a) {
            this.k = a;
            this.e("FilterPlaceholderText");
        }
        get baseTheme() {
            return this.i;
        }
        set baseTheme(a) {
            this.i = a;
            this.e("BaseTheme");
        }
        get density() {
            return this.j;
        }
        set density(a) {
            this.j = a;
            this.e("Density");
        }
        get backgroundColor() {
            return this.h;
        }
        set backgroundColor(a) {
            this.h = a;
            this.e("BackgroundColor");
        }
    }
    ColumnChooserDescription.$t = /*@__PURE__*/ markType(ColumnChooserDescription, 'ColumnChooserDescription', Description.$);
    return ColumnChooserDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnChooserDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnChooserDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnChooserDescriptionMetadata.a == null) {
                ColumnChooserDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnChooserDescriptionMetadata.c(a, ColumnChooserDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            b.item("Title", "String");
            b.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,wf:TitleFontFamily,web:titleStyle/FontFamilyTransform)String");
            b.item("TitleFontSize", "(w:TitleFontSize,wf:TitleFontSize,web:titleStyle/FontSizeTransform)Number:double");
            b.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,wf:TitleFontFamily/FontStyleTransform,web:titleStyle/FontStyleTransform)String");
            b.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,wf:TitleFontFamily/FontWeightTransform,web:titleStyle/FontWeightTransform)String");
            b.item("TitleColor", "Brush");
            b.item("FilterPlaceholderText", "String");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BackgroundColor", "Brush");
        }
        static d(a) {
            ColumnChooserDescriptionMetadata.b(a);
            a.q("ColumnChooser", () => new ColumnChooserDescription());
            a.p("ColumnChooser", ColumnChooserDescriptionMetadata.a);
        }
    }
    ColumnChooserDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnChooserDescriptionMetadata, 'ColumnChooserDescriptionMetadata');
    ColumnChooserDescriptionMetadata.a = null;
    return ColumnChooserDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnChooserDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnChooserDescriptionModule extends Base {
        static register(a) {
            CheckboxListDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            ColumnChooserDescriptionMetadata.d(a);
        }
    }
    ColumnChooserDescriptionModule.$t = /*@__PURE__*/ markType(ColumnChooserDescriptionModule, 'ColumnChooserDescriptionModule');
    return ColumnChooserDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinningDescription = /*@__PURE__*/ (() => {
    class ColumnPinningDescription extends Description {
        constructor() {
            super();
            this.l = null;
            this.m = null;
            this.o = null;
            this.f = 0;
            this.p = null;
            this.q = null;
            this.n = null;
            this.k = null;
            this.i = null;
            this.j = null;
            this.h = null;
        }
        get_type() {
            return "ColumnPinning";
        }
        get type() {
            return this.get_type();
        }
        get targetGridRef() {
            return this.l;
        }
        set targetGridRef(a) {
            this.l = a;
            this.e("TargetGridRef");
        }
        get title() {
            return this.m;
        }
        set title(a) {
            this.m = a;
            this.e("Title");
        }
        get titleFontFamily() {
            return this.o;
        }
        set titleFontFamily(a) {
            this.o = a;
            this.e("TitleFontFamily");
        }
        get titleFontSize() {
            return this.f;
        }
        set titleFontSize(a) {
            this.f = a;
            this.e("TitleFontSize");
        }
        get titleFontStyle() {
            return this.p;
        }
        set titleFontStyle(a) {
            this.p = a;
            this.e("TitleFontStyle");
        }
        get titleFontWeight() {
            return this.q;
        }
        set titleFontWeight(a) {
            this.q = a;
            this.e("TitleFontWeight");
        }
        get titleColor() {
            return this.n;
        }
        set titleColor(a) {
            this.n = a;
            this.e("TitleColor");
        }
        get filterPlaceholderText() {
            return this.k;
        }
        set filterPlaceholderText(a) {
            this.k = a;
            this.e("FilterPlaceholderText");
        }
        get baseTheme() {
            return this.i;
        }
        set baseTheme(a) {
            this.i = a;
            this.e("BaseTheme");
        }
        get density() {
            return this.j;
        }
        set density(a) {
            this.j = a;
            this.e("Density");
        }
        get backgroundColor() {
            return this.h;
        }
        set backgroundColor(a) {
            this.h = a;
            this.e("BackgroundColor");
        }
    }
    ColumnPinningDescription.$t = /*@__PURE__*/ markType(ColumnPinningDescription, 'ColumnPinningDescription', Description.$);
    return ColumnPinningDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinningDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnPinningDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnPinningDescriptionMetadata.a == null) {
                ColumnPinningDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnPinningDescriptionMetadata.c(a, ColumnPinningDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            b.item("Title", "String");
            b.item("TitleFontFamily", "(w:TitleFontFamily/FontFamilyTransform,wf:TitleFontFamily,web:titleStyle/FontFamilyTransform)String");
            b.item("TitleFontSize", "(w:TitleFontSize,wf:TitleFontSize,web:titleStyle/FontSizeTransform)Number:double");
            b.item("TitleFontStyle", "(w:TitleFontStyle/FontStyleTransform,wf:TitleFontFamily/FontStyleTransform,web:titleStyle/FontStyleTransform)String");
            b.item("TitleFontWeight", "(w:TitleFontWeight/FontWeightTransform,wf:TitleFontFamily/FontWeightTransform,web:titleStyle/FontWeightTransform)String");
            b.item("TitleColor", "Brush");
            b.item("FilterPlaceholderText", "String");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BackgroundColor", "Brush");
        }
        static d(a) {
            ColumnPinningDescriptionMetadata.b(a);
            a.q("ColumnPinning", () => new ColumnPinningDescription());
            a.p("ColumnPinning", ColumnPinningDescriptionMetadata.a);
        }
    }
    ColumnPinningDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnPinningDescriptionMetadata, 'ColumnPinningDescriptionMetadata');
    ColumnPinningDescriptionMetadata.a = null;
    return ColumnPinningDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPinningDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnPinningDescriptionModule extends Base {
        static register(a) {
            CheckboxListDescriptionModule.register(a);
            ColumnPinningDescriptionMetadata.d(a);
        }
    }
    ColumnPinningDescriptionModule.$t = /*@__PURE__*/ markType(ColumnPinningDescriptionModule, 'ColumnPinningDescriptionModule');
    return ColumnPinningDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComboBoxColumnDescription = /*@__PURE__*/ (() => {
    class ComboBoxColumnDescription extends ColumnDescription {
        constructor() {
            super();
            this.ev = null;
            this.es = null;
            this.ew = null;
            this.eq = null;
        }
        get_type() {
            return "ComboBoxColumn";
        }
        get dataSourceRef() {
            return this.ev;
        }
        set dataSourceRef(a) {
            this.ev = a;
            this.e("DataSourceRef");
        }
        get dataSource() {
            return this.es;
        }
        set dataSource(a) {
            this.es = a;
            this.e("DataSource");
        }
        get textField() {
            return this.ew;
        }
        set textField(a) {
            this.ew = a;
            this.e("TextField");
        }
        get valueField() {
            return this.eq;
        }
        set valueField(a) {
            this.eq = a;
            this.e("ValueField");
        }
    }
    ComboBoxColumnDescription.$t = /*@__PURE__*/ markType(ComboBoxColumnDescription, 'ComboBoxColumnDescription', ColumnDescription.$);
    ComboBoxColumnDescription.__canMarshalByValue1 = true;
    return ComboBoxColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComboBoxColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class ComboBoxColumnDescriptionMetadata extends Base {
        static b(a) {
            if (ComboBoxColumnDescriptionMetadata.a == null) {
                ComboBoxColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ComboBoxColumnDescriptionMetadata.c(a, ComboBoxColumnDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnDescriptionMetadata.c(a, b);
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("DataSource", "(w:ItemsSource,wf:ItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            b.item("TextField", "String");
            b.item("ValueField", "Array:string");
        }
        static d(a) {
            ComboBoxColumnDescriptionMetadata.b(a);
            a.q("ComboBoxColumn", () => new ComboBoxColumnDescription());
            a.p("ComboBoxColumn", ComboBoxColumnDescriptionMetadata.a);
        }
    }
    ComboBoxColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(ComboBoxColumnDescriptionMetadata, 'ComboBoxColumnDescriptionMetadata');
    ComboBoxColumnDescriptionMetadata.a = null;
    return ComboBoxColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ComboBoxColumnDescriptionModule = /*@__PURE__*/ (() => {
    class ComboBoxColumnDescriptionModule extends Base {
        static register(a) {
            ComboBoxColumnDescriptionMetadata.d(a);
        }
    }
    ComboBoxColumnDescriptionModule.$t = /*@__PURE__*/ markType(ComboBoxColumnDescriptionModule, 'ComboBoxColumnDescriptionModule');
    return ComboBoxColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapImageryDescription = /*@__PURE__*/ (() => {
    class CustomMapImageryDescription extends GeographicMapImageryDescription {
        constructor() {
            super();
            this.aa = null;
        }
        get_type() {
            return "CustomMapImagery";
        }
        get getTileImageUriRef() {
            return this.aa;
        }
        set getTileImageUriRef(a) {
            this.aa = a;
            this.e("GetTileImageUriRef");
        }
    }
    CustomMapImageryDescription.$t = /*@__PURE__*/ markType(CustomMapImageryDescription, 'CustomMapImageryDescription', GeographicMapImageryDescription.$);
    return CustomMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetTileImageUriArgsDescription = /*@__PURE__*/ (() => {
    class GetTileImageUriArgsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
            this.g = 0;
            this.h = 0;
            this.l = null;
        }
        get_type() {
            return "GetTileImageUriArgs";
        }
        get type() {
            return this.get_type();
        }
        get tileLevel() {
            return this.f;
        }
        set tileLevel(a) {
            this.f = a;
            this.e("TileLevel");
        }
        get tilePositionX() {
            return this.g;
        }
        set tilePositionX(a) {
            this.g = a;
            this.e("TilePositionX");
        }
        get tilePositionY() {
            return this.h;
        }
        set tilePositionY(a) {
            this.h = a;
            this.e("TilePositionY");
        }
        get tileImageUri() {
            return this.l;
        }
        set tileImageUri(a) {
            this.l = a;
            this.e("TileImageUri");
        }
    }
    GetTileImageUriArgsDescription.$t = /*@__PURE__*/ markType(GetTileImageUriArgsDescription, 'GetTileImageUriArgsDescription', Description.$);
    return GetTileImageUriArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetTileImageUriArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GetTileImageUriArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GetTileImageUriArgsDescriptionMetadata.a == null) {
                GetTileImageUriArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GetTileImageUriArgsDescriptionMetadata.c(a, GetTileImageUriArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TileLevel", "Number:int");
            b.item("TilePositionX", "Number:int");
            b.item("TilePositionY", "Number:int");
            b.item("TileImageUri", "String");
        }
        static d(a) {
            GetTileImageUriArgsDescriptionMetadata.b(a);
            a.q("GetTileImageUriArgs", () => new GetTileImageUriArgsDescription());
            a.p("GetTileImageUriArgs", GetTileImageUriArgsDescriptionMetadata.a);
        }
    }
    GetTileImageUriArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GetTileImageUriArgsDescriptionMetadata, 'GetTileImageUriArgsDescriptionMetadata');
    GetTileImageUriArgsDescriptionMetadata.a = null;
    return GetTileImageUriArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (CustomMapImageryDescriptionMetadata.a == null) {
                CustomMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomMapImageryDescriptionMetadata.c(a, CustomMapImageryDescriptionMetadata.a);
                GetTileImageUriArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicMapImageryDescriptionMetadata.c(a, b);
            b.item("GetTileImageUriRef", "EventRef::getTileImageUri");
        }
        static d(a) {
            CustomMapImageryDescriptionMetadata.b(a);
            a.q("CustomMapImagery", () => new CustomMapImageryDescription());
            a.p("CustomMapImagery", CustomMapImageryDescriptionMetadata.a);
        }
    }
    CustomMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomMapImageryDescriptionMetadata, 'CustomMapImageryDescriptionMetadata');
    CustomMapImageryDescriptionMetadata.a = null;
    return CustomMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class CustomMapImageryDescriptionModule extends Base {
        static register(a) {
            CustomMapImageryDescriptionMetadata.d(a);
        }
    }
    CustomMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(CustomMapImageryDescriptionModule, 'CustomMapImageryDescriptionModule');
    return CustomMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDescription = /*@__PURE__*/ (() => {
    class DataChartDescription extends SeriesViewerDescription {
        constructor() {
            super();
            this.e1 = false;
            this.fl = 0;
            this.fm = 0;
            this.fd = 0;
            this.fe = 0;
            this.e0 = false;
            this.e2 = false;
            this.f5 = null;
            this.ez = false;
            this.eq = null;
            this.fg = 0;
            this.ff = 0;
            this.e3 = false;
            this.er = null;
            this.et = null;
            this.es = null;
            this.f4 = null;
            this.f2 = null;
            this.f3 = null;
            this.ep = null;
            this.fa = 0;
            this.fc = 0;
            this.fb = 0;
            this.e9 = 0;
            this.f1 = null;
            this.fi = 0;
            this.fk = 0;
            this.fj = 0;
            this.fh = 0;
            this.f7 = null;
            this.f6 = null;
        }
        get_type() {
            return "DataChart";
        }
        get isSquare() {
            return this.e1;
        }
        set isSquare(a) {
            this.e1 = a;
            this.e("IsSquare");
        }
        get windowScaleHorizontal() {
            return this.fl;
        }
        set windowScaleHorizontal(a) {
            this.fl = a;
            this.e("WindowScaleHorizontal");
        }
        get windowScaleVertical() {
            return this.fm;
        }
        set windowScaleVertical(a) {
            this.fm = a;
            this.e("WindowScaleVertical");
        }
        get actualWindowScaleHorizontal() {
            return this.fd;
        }
        set actualWindowScaleHorizontal(a) {
            this.fd = a;
            this.e("ActualWindowScaleHorizontal");
        }
        get actualWindowScaleVertical() {
            return this.fe;
        }
        set actualWindowScaleVertical(a) {
            this.fe = a;
            this.e("ActualWindowScaleVertical");
        }
        get isHorizontalZoomEnabled() {
            return this.e0;
        }
        set isHorizontalZoomEnabled(a) {
            this.e0 = a;
            this.e("IsHorizontalZoomEnabled");
        }
        get isVerticalZoomEnabled() {
            return this.e2;
        }
        set isVerticalZoomEnabled(a) {
            this.e2 = a;
            this.e("IsVerticalZoomEnabled");
        }
        get gridMode() {
            return this.f5;
        }
        set gridMode(a) {
            this.f5 = a;
            this.e("GridMode");
        }
        get alignsGridLinesToPixels() {
            return this.ez;
        }
        set alignsGridLinesToPixels(a) {
            this.ez = a;
            this.e("AlignsGridLinesToPixels");
        }
        get brushes() {
            return this.eq;
        }
        set brushes(a) {
            this.eq = a;
            this.e("Brushes");
        }
        get autoExpandMarginMaximumValue() {
            return this.fg;
        }
        set autoExpandMarginMaximumValue(a) {
            this.fg = a;
            this.e("AutoExpandMarginMaximumValue");
        }
        get autoExpandMarginExtraPadding() {
            return this.ff;
        }
        set autoExpandMarginExtraPadding(a) {
            this.ff = a;
            this.e("AutoExpandMarginExtraPadding");
        }
        get shouldAutoExpandMarginForInitialLabels() {
            return this.e3;
        }
        set shouldAutoExpandMarginForInitialLabels(a) {
            this.e3 = a;
            this.e("ShouldAutoExpandMarginForInitialLabels");
        }
        get markerBrushes() {
            return this.er;
        }
        set markerBrushes(a) {
            this.er = a;
            this.e("MarkerBrushes");
        }
        get outlines() {
            return this.et;
        }
        set outlines(a) {
            this.et = a;
            this.e("Outlines");
        }
        get markerOutlines() {
            return this.es;
        }
        set markerOutlines(a) {
            this.es = a;
            this.e("MarkerOutlines");
        }
        get defaultAxisStroke() {
            return this.f4;
        }
        set defaultAxisStroke(a) {
            this.f4 = a;
            this.e("DefaultAxisStroke");
        }
        get defaultAxisMajorStroke() {
            return this.f2;
        }
        set defaultAxisMajorStroke(a) {
            this.f2 = a;
            this.e("DefaultAxisMajorStroke");
        }
        get defaultAxisMinorStroke() {
            return this.f3;
        }
        set defaultAxisMinorStroke(a) {
            this.f3 = a;
            this.e("DefaultAxisMinorStroke");
        }
        get axes() {
            return this.ep;
        }
        set axes(a) {
            this.ep = a;
            this.e("Axes");
        }
        get actualPlotAreaMarginLeft() {
            return this.fa;
        }
        set actualPlotAreaMarginLeft(a) {
            this.fa = a;
            this.e("ActualPlotAreaMarginLeft");
        }
        get actualPlotAreaMarginTop() {
            return this.fc;
        }
        set actualPlotAreaMarginTop(a) {
            this.fc = a;
            this.e("ActualPlotAreaMarginTop");
        }
        get actualPlotAreaMarginRight() {
            return this.fb;
        }
        set actualPlotAreaMarginRight(a) {
            this.fb = a;
            this.e("ActualPlotAreaMarginRight");
        }
        get actualPlotAreaMarginBottom() {
            return this.e9;
        }
        set actualPlotAreaMarginBottom(a) {
            this.e9 = a;
            this.e("ActualPlotAreaMarginBottom");
        }
        get computedPlotAreaMarginMode() {
            return this.f1;
        }
        set computedPlotAreaMarginMode(a) {
            this.f1 = a;
            this.e("ComputedPlotAreaMarginMode");
        }
        get plotAreaMarginLeft() {
            return this.fi;
        }
        set plotAreaMarginLeft(a) {
            this.fi = a;
            this.e("PlotAreaMarginLeft");
        }
        get plotAreaMarginTop() {
            return this.fk;
        }
        set plotAreaMarginTop(a) {
            this.fk = a;
            this.e("PlotAreaMarginTop");
        }
        get plotAreaMarginRight() {
            return this.fj;
        }
        set plotAreaMarginRight(a) {
            this.fj = a;
            this.e("PlotAreaMarginRight");
        }
        get plotAreaMarginBottom() {
            return this.fh;
        }
        set plotAreaMarginBottom(a) {
            this.fh = a;
            this.e("PlotAreaMarginBottom");
        }
        get width() {
            return this.f7;
        }
        set width(a) {
            this.f7 = a;
            this.e("Width");
        }
        get height() {
            return this.f6;
        }
        set height(a) {
            this.f6 = a;
            this.e("Height");
        }
    }
    DataChartDescription.$t = /*@__PURE__*/ markType(DataChartDescription, 'DataChartDescription', SeriesViewerDescription.$);
    return DataChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartDescriptionMetadata extends Base {
        static b(a) {
            if (DataChartDescriptionMetadata.a == null) {
                DataChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataChartDescriptionMetadata.c(a, DataChartDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SeriesViewerDescriptionMetadata.c(a, b);
            b.item("IsSquare", "Boolean");
            b.item("WindowScaleHorizontal", "Number:double");
            b.item("WindowScaleVertical", "Number:double");
            b.item("ActualWindowScaleHorizontal", "Number:double");
            b.item("ActualWindowScaleVertical", "Number:double");
            b.item("IsHorizontalZoomEnabled", "Boolean");
            b.item("IsVerticalZoomEnabled", "Boolean");
            b.item("GridMode", "ExportedType:string:GridMode");
            b.item("GridMode@names", "None;BeforeSeries;BehindSeries");
            b.item("AlignsGridLinesToPixels", "Boolean");
            b.item("Brushes", "BrushCollection:string");
            b.item("AutoExpandMarginMaximumValue", "Number:double");
            b.item("AutoExpandMarginExtraPadding", "Number:double");
            b.item("ShouldAutoExpandMarginForInitialLabels", "Boolean");
            b.item("MarkerBrushes", "BrushCollection:string");
            b.item("Outlines", "BrushCollection:string");
            b.item("MarkerOutlines", "BrushCollection:string");
            b.item("DefaultAxisStroke", "Brush");
            b.item("DefaultAxisMajorStroke", "Brush");
            b.item("DefaultAxisMinorStroke", "Brush");
            b.item("Axes", "Collection:Axis:AxisCollection:Axis");
            b.item("ActualPlotAreaMarginLeft", "Number:double");
            b.item("ActualPlotAreaMarginTop", "Number:double");
            b.item("ActualPlotAreaMarginRight", "Number:double");
            b.item("ActualPlotAreaMarginBottom", "Number:double");
            b.item("ComputedPlotAreaMarginMode", "ExportedType:string:ComputedPlotAreaMarginMode");
            b.item("ComputedPlotAreaMarginMode@names", "Auto;Series;None");
            b.item("PlotAreaMarginLeft", "Number:double");
            b.item("PlotAreaMarginTop", "Number:double");
            b.item("PlotAreaMarginRight", "Number:double");
            b.item("PlotAreaMarginBottom", "Number:double");
            DataChartDescriptionMetadata.e(a, b);
        }
        static d(a) {
            DataChartDescriptionMetadata.b(a);
            a.q("DataChart", () => new DataChartDescription());
            a.p("DataChart", DataChartDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamDataChart");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
        }
    }
    DataChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartDescriptionMetadata, 'DataChartDescriptionMetadata');
    DataChartDescriptionMetadata.a = null;
    return DataChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCoreDescriptionModule extends Base {
        static register(a) {
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            DataChartDescriptionMetadata.d(a);
        }
    }
    DataChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCoreDescriptionModule, 'DataChartCoreDescriptionModule');
    return DataChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCategoryCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCategoryCoreDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartCategoryCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCategoryCoreDescriptionModule, 'DataChartCategoryCoreDescriptionModule');
    return DataChartCategoryCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RangeCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RangeCategorySeriesDescriptionMetadata.a == null) {
                RangeCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RangeCategorySeriesDescriptionMetadata.c(a, RangeCategorySeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategorySeriesDescriptionMetadata.c(a, b);
            b.item("LowMemberPath", "String");
            b.item("HighMemberPath", "String");
        }
        static d(a) {
            RangeCategorySeriesDescriptionMetadata.b(a);
            a.p("RangeCategorySeries", RangeCategorySeriesDescriptionMetadata.a);
        }
    }
    RangeCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RangeCategorySeriesDescriptionMetadata, 'RangeCategorySeriesDescriptionMetadata');
    RangeCategorySeriesDescriptionMetadata.a = null;
    return RangeCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalRangeCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HorizontalRangeCategorySeriesDescriptionMetadata.a == null) {
                HorizontalRangeCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HorizontalRangeCategorySeriesDescriptionMetadata.c(a, HorizontalRangeCategorySeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            RangeCategorySeriesDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            HorizontalRangeCategorySeriesDescriptionMetadata.b(a);
            a.p("HorizontalRangeCategorySeries", HorizontalRangeCategorySeriesDescriptionMetadata.a);
        }
    }
    HorizontalRangeCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeriesDescriptionMetadata, 'HorizontalRangeCategorySeriesDescriptionMetadata');
    HorizontalRangeCategorySeriesDescriptionMetadata.a = null;
    return HorizontalRangeCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeCategorySeriesDescription = /*@__PURE__*/ (() => {
    class RangeCategorySeriesDescription extends CategorySeriesDescription {
        constructor() {
            super();
            this.dn = null;
            this.dm = null;
        }
        get_type() {
            return "RangeCategorySeries";
        }
        get lowMemberPath() {
            return this.dn;
        }
        set lowMemberPath(a) {
            this.dn = a;
            this.e("LowMemberPath");
        }
        get highMemberPath() {
            return this.dm;
        }
        set highMemberPath(a) {
            this.dm = a;
            this.e("HighMemberPath");
        }
    }
    RangeCategorySeriesDescription.$t = /*@__PURE__*/ markType(RangeCategorySeriesDescription, 'RangeCategorySeriesDescription', CategorySeriesDescription.$);
    return RangeCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalRangeCategorySeriesDescription = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeriesDescription extends RangeCategorySeriesDescription {
        constructor() {
            super();
            this.dr = null;
            this.ds = null;
        }
        get_type() {
            return "HorizontalRangeCategorySeries";
        }
        get xAxisRef() {
            return this.dr;
        }
        set xAxisRef(a) {
            this.dr = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.ds;
        }
        set yAxisRef(a) {
            this.ds = a;
            this.e("YAxisRef");
        }
    }
    HorizontalRangeCategorySeriesDescription.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeriesDescription, 'HorizontalRangeCategorySeriesDescription', RangeCategorySeriesDescription.$);
    return HorizontalRangeCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeAreaSeriesDescription = /*@__PURE__*/ (() => {
    class RangeAreaSeriesDescription extends HorizontalRangeCategorySeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "RangeAreaSeries";
        }
    }
    RangeAreaSeriesDescription.$t = /*@__PURE__*/ markType(RangeAreaSeriesDescription, 'RangeAreaSeriesDescription', HorizontalRangeCategorySeriesDescription.$);
    return RangeAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RangeAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RangeAreaSeriesDescriptionMetadata.a == null) {
                RangeAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RangeAreaSeriesDescriptionMetadata.c(a, RangeAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalRangeCategorySeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            RangeAreaSeriesDescriptionMetadata.b(a);
            a.q("RangeAreaSeries", () => new RangeAreaSeriesDescription());
            a.p("RangeAreaSeries", RangeAreaSeriesDescriptionMetadata.a);
        }
    }
    RangeAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RangeAreaSeriesDescriptionMetadata, 'RangeAreaSeriesDescriptionMetadata');
    RangeAreaSeriesDescriptionMetadata.a = null;
    return RangeAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RangeAreaSeriesDescriptionModule extends Base {
        static register(a) {
            RangeAreaSeriesDescriptionMetadata.d(a);
        }
    }
    RangeAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RangeAreaSeriesDescriptionModule, 'RangeAreaSeriesDescriptionModule');
    return RangeAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeColumnSeriesDescription = /*@__PURE__*/ (() => {
    class RangeColumnSeriesDescription extends HorizontalRangeCategorySeriesDescription {
        constructor() {
            super();
            this.dv = 0;
            this.dw = 0;
        }
        get_type() {
            return "RangeColumnSeries";
        }
        get radiusX() {
            return this.dv;
        }
        set radiusX(a) {
            this.dv = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.dw;
        }
        set radiusY(a) {
            this.dw = a;
            this.e("RadiusY");
        }
    }
    RangeColumnSeriesDescription.$t = /*@__PURE__*/ markType(RangeColumnSeriesDescription, 'RangeColumnSeriesDescription', HorizontalRangeCategorySeriesDescription.$);
    return RangeColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RangeColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RangeColumnSeriesDescriptionMetadata.a == null) {
                RangeColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RangeColumnSeriesDescriptionMetadata.c(a, RangeColumnSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalRangeCategorySeriesDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            RangeColumnSeriesDescriptionMetadata.b(a);
            a.q("RangeColumnSeries", () => new RangeColumnSeriesDescription());
            a.p("RangeColumnSeries", RangeColumnSeriesDescriptionMetadata.a);
        }
    }
    RangeColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RangeColumnSeriesDescriptionMetadata, 'RangeColumnSeriesDescriptionMetadata');
    RangeColumnSeriesDescriptionMetadata.a = null;
    return RangeColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RangeColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RangeColumnSeriesDescriptionModule extends Base {
        static register(a) {
            RangeColumnSeriesDescriptionMetadata.d(a);
        }
    }
    RangeColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RangeColumnSeriesDescriptionModule, 'RangeColumnSeriesDescriptionModule');
    return RangeColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartCategoryDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartCategoryDescriptionModule extends Base {
        static register(a) {
            LineSeriesDescriptionModule.register(a);
            AreaSeriesDescriptionModule.register(a);
            ColumnSeriesDescriptionModule.register(a);
            SplineSeriesDescriptionModule.register(a);
            SplineAreaSeriesDescriptionModule.register(a);
            StepLineSeriesDescriptionModule.register(a);
            StepAreaSeriesDescriptionModule.register(a);
            PointSeriesDescriptionModule.register(a);
            WaterfallSeriesDescriptionModule.register(a);
            RangeAreaSeriesDescriptionModule.register(a);
            RangeColumnSeriesDescriptionModule.register(a);
            DataChartCategoryCoreDescriptionModule.register(a);
        }
    }
    DataChartCategoryDescriptionModule.$t = /*@__PURE__*/ markType(DataChartCategoryDescriptionModule, 'DataChartCategoryDescriptionModule');
    return DataChartCategoryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisBaseDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisBaseDescriptionMetadata.a == null) {
                TimeAxisBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisBaseDescriptionMetadata.c(a, TimeAxisBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategoryAxisBaseDescriptionMetadata.c(a, b);
            b.item("DateTimeMemberPath", "String");
            b.item("IsDataPreSorted", "Boolean");
            b.item("ActualMinimumValue", "Date");
            b.item("ActualMaximumValue", "Date");
            b.item("MinimumValue", "Date");
            b.item("MaximumValue", "Date");
            b.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            b.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
        }
        static d(a) {
            TimeAxisBaseDescriptionMetadata.b(a);
            a.p("TimeAxisBase", TimeAxisBaseDescriptionMetadata.a);
        }
    }
    TimeAxisBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisBaseDescriptionMetadata, 'TimeAxisBaseDescriptionMetadata');
    TimeAxisBaseDescriptionMetadata.a = null;
    return TimeAxisBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBaseDescription = /*@__PURE__*/ (() => {
    class TimeAxisBaseDescription extends CategoryAxisBaseDescription {
        constructor() {
            super();
            this.dt = null;
            this.dg = false;
            this.dj = new Date();
            this.di = new Date();
            this.dl = new Date();
            this.dk = new Date();
            this.ds = null;
            this.dr = null;
        }
        get_type() {
            return "TimeAxisBase";
        }
        get dateTimeMemberPath() {
            return this.dt;
        }
        set dateTimeMemberPath(a) {
            this.dt = a;
            this.e("DateTimeMemberPath");
        }
        get isDataPreSorted() {
            return this.dg;
        }
        set isDataPreSorted(a) {
            this.dg = a;
            this.e("IsDataPreSorted");
        }
        get actualMinimumValue() {
            return this.dj;
        }
        set actualMinimumValue(a) {
            this.dj = a;
            this.e("ActualMinimumValue");
        }
        get actualMaximumValue() {
            return this.di;
        }
        set actualMaximumValue(a) {
            this.di = a;
            this.e("ActualMaximumValue");
        }
        get minimumValue() {
            return this.dl;
        }
        set minimumValue(a) {
            this.dl = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.dk;
        }
        set maximumValue(a) {
            this.dk = a;
            this.e("MaximumValue");
        }
        get actualMinimumValueChangeRef() {
            return this.ds;
        }
        set actualMinimumValueChangeRef(a) {
            this.ds = a;
            this.e("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.dr;
        }
        set actualMaximumValueChangeRef(a) {
            this.dr = a;
            this.e("ActualMaximumValueChangeRef");
        }
    }
    TimeAxisBaseDescription.$t = /*@__PURE__*/ markType(TimeAxisBaseDescription, 'TimeAxisBaseDescription', CategoryAxisBaseDescription.$);
    return TimeAxisBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryDateTimeXAxisDescription = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisDescription extends TimeAxisBaseDescription {
        constructor() {
            super();
            this.d7 = null;
            this.dz = 0;
            this.dx = 0;
            this.d0 = 0;
            this.dy = 0;
            this.d5 = null;
            this.d6 = null;
        }
        get_type() {
            return "CategoryDateTimeXAxis";
        }
        get displayType() {
            return this.d7;
        }
        set displayType(a) {
            this.d7 = a;
            this.e("DisplayType");
        }
        get interval() {
            return this.dz;
        }
        set interval(a) {
            this.dz = a;
            this.e("Interval");
        }
        get actualInterval() {
            return this.dx;
        }
        set actualInterval(a) {
            this.dx = a;
            this.e("ActualInterval");
        }
        get minorInterval() {
            return this.d0;
        }
        set minorInterval(a) {
            this.d0 = a;
            this.e("MinorInterval");
        }
        get actualMinorInterval() {
            return this.dy;
        }
        set actualMinorInterval(a) {
            this.dy = a;
            this.e("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.d5;
        }
        set actualIntervalChangeRef(a) {
            this.d5 = a;
            this.e("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.d6;
        }
        set actualMinorIntervalChangeRef(a) {
            this.d6 = a;
            this.e("ActualMinorIntervalChangeRef");
        }
    }
    CategoryDateTimeXAxisDescription.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisDescription, 'CategoryDateTimeXAxisDescription', TimeAxisBaseDescription.$);
    return CategoryDateTimeXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryDateTimeXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryDateTimeXAxisDescriptionMetadata.a == null) {
                CategoryDateTimeXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryDateTimeXAxisDescriptionMetadata.c(a, CategoryDateTimeXAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            TimeAxisBaseDescriptionMetadata.c(a, b);
            b.item("DisplayType", "ExportedType:string:TimeAxisDisplayType");
            b.item("DisplayType@names", "Continuous;Discrete");
            b.item("Interval", "Number:long");
            b.item("ActualInterval", "Number:long");
            b.item("MinorInterval", "Number:long");
            b.item("ActualMinorInterval", "Number:long");
            b.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            b.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            CategoryDateTimeXAxisDescriptionMetadata.b(a);
            a.q("CategoryDateTimeXAxis", () => new CategoryDateTimeXAxisDescription());
            a.p("CategoryDateTimeXAxis", CategoryDateTimeXAxisDescriptionMetadata.a);
        }
    }
    CategoryDateTimeXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisDescriptionMetadata, 'CategoryDateTimeXAxisDescriptionMetadata');
    CategoryDateTimeXAxisDescriptionMetadata.a = null;
    return CategoryDateTimeXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryDateTimeXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisDescriptionModule extends Base {
        static register(a) {
            CategoryDateTimeXAxisDescriptionMetadata.d(a);
        }
    }
    CategoryDateTimeXAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryDateTimeXAxisDescriptionModule, 'CategoryDateTimeXAxisDescriptionModule');
    return CategoryDateTimeXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBreakDescription = /*@__PURE__*/ (() => {
    class TimeAxisBreakDescription extends Description {
        constructor() {
            super();
            this.g = new Date();
            this.f = new Date();
            this.j = 0;
        }
        get_type() {
            return "TimeAxisBreak";
        }
        get type() {
            return this.get_type();
        }
        get start() {
            return this.g;
        }
        set start(a) {
            this.g = a;
            this.e("Start");
        }
        get end() {
            return this.f;
        }
        set end(a) {
            this.f = a;
            this.e("End");
        }
        get interval() {
            return this.j;
        }
        set interval(a) {
            this.j = a;
            this.e("Interval");
        }
    }
    TimeAxisBreakDescription.$t = /*@__PURE__*/ markType(TimeAxisBreakDescription, 'TimeAxisBreakDescription', Description.$);
    return TimeAxisBreakDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBreakDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisBreakDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisBreakDescriptionMetadata.a == null) {
                TimeAxisBreakDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisBreakDescriptionMetadata.c(a, TimeAxisBreakDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Start", "Date");
            b.item("End", "Date");
            b.item("Interval", "TimeSpan");
        }
        static d(a) {
            TimeAxisBreakDescriptionMetadata.b(a);
            a.q("TimeAxisBreak", () => new TimeAxisBreakDescription());
            a.p("TimeAxisBreak", TimeAxisBreakDescriptionMetadata.a);
        }
    }
    TimeAxisBreakDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisBreakDescriptionMetadata, 'TimeAxisBreakDescriptionMetadata');
    TimeAxisBreakDescriptionMetadata.a = null;
    return TimeAxisBreakDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisBreakDescriptionModule = /*@__PURE__*/ (() => {
    class TimeAxisBreakDescriptionModule extends Base {
        static register(a) {
            TimeAxisBreakDescriptionMetadata.d(a);
        }
    }
    TimeAxisBreakDescriptionModule.$t = /*@__PURE__*/ markType(TimeAxisBreakDescriptionModule, 'TimeAxisBreakDescriptionModule');
    return TimeAxisBreakDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisIntervalDescription = /*@__PURE__*/ (() => {
    class TimeAxisIntervalDescription extends Description {
        constructor() {
            super();
            this.h = 0;
            this.f = 0;
            this.j = null;
        }
        get_type() {
            return "TimeAxisInterval";
        }
        get type() {
            return this.get_type();
        }
        get range() {
            return this.h;
        }
        set range(a) {
            this.h = a;
            this.e("Range");
        }
        get interval() {
            return this.f;
        }
        set interval(a) {
            this.f = a;
            this.e("Interval");
        }
        get intervalType() {
            return this.j;
        }
        set intervalType(a) {
            this.j = a;
            this.e("IntervalType");
        }
    }
    TimeAxisIntervalDescription.$t = /*@__PURE__*/ markType(TimeAxisIntervalDescription, 'TimeAxisIntervalDescription', Description.$);
    return TimeAxisIntervalDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisIntervalDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisIntervalDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisIntervalDescriptionMetadata.a == null) {
                TimeAxisIntervalDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisIntervalDescriptionMetadata.c(a, TimeAxisIntervalDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Range", "TimeSpan");
            b.item("Interval", "Number:double");
            b.item("IntervalType", "ExportedType:string:TimeAxisIntervalType");
            b.item("IntervalType@names", "Ticks;Milliseconds;Seconds;Minutes;Hours;Days;Weeks;Months;Years");
        }
        static d(a) {
            TimeAxisIntervalDescriptionMetadata.b(a);
            a.q("TimeAxisInterval", () => new TimeAxisIntervalDescription());
            a.p("TimeAxisInterval", TimeAxisIntervalDescriptionMetadata.a);
        }
    }
    TimeAxisIntervalDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisIntervalDescriptionMetadata, 'TimeAxisIntervalDescriptionMetadata');
    TimeAxisIntervalDescriptionMetadata.a = null;
    return TimeAxisIntervalDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisIntervalDescriptionModule = /*@__PURE__*/ (() => {
    class TimeAxisIntervalDescriptionModule extends Base {
        static register(a) {
            TimeAxisIntervalDescriptionMetadata.d(a);
        }
    }
    TimeAxisIntervalDescriptionModule.$t = /*@__PURE__*/ markType(TimeAxisIntervalDescriptionModule, 'TimeAxisIntervalDescriptionModule');
    return TimeAxisIntervalDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisLabelFormatDescription = /*@__PURE__*/ (() => {
    class TimeAxisLabelFormatDescription extends Description {
        constructor() {
            super();
            this.f = 0;
            this.h = null;
            this.k = null;
            this.j = null;
            this.i = null;
        }
        get_type() {
            return "TimeAxisLabelFormat";
        }
        get type() {
            return this.get_type();
        }
        get range() {
            return this.f;
        }
        set range(a) {
            this.f = a;
            this.e("Range");
        }
        get format() {
            return this.h;
        }
        set format(a) {
            this.h = a;
            this.e("Format");
        }
        get repeatedYearFormat() {
            return this.k;
        }
        set repeatedYearFormat(a) {
            this.k = a;
            this.e("RepeatedYearFormat");
        }
        get repeatedMonthFormat() {
            return this.j;
        }
        set repeatedMonthFormat(a) {
            this.j = a;
            this.e("RepeatedMonthFormat");
        }
        get repeatedDayFormat() {
            return this.i;
        }
        set repeatedDayFormat(a) {
            this.i = a;
            this.e("RepeatedDayFormat");
        }
    }
    TimeAxisLabelFormatDescription.$t = /*@__PURE__*/ markType(TimeAxisLabelFormatDescription, 'TimeAxisLabelFormatDescription', Description.$);
    return TimeAxisLabelFormatDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisLabelFormatDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeAxisLabelFormatDescriptionMetadata extends Base {
        static b(a) {
            if (TimeAxisLabelFormatDescriptionMetadata.a == null) {
                TimeAxisLabelFormatDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeAxisLabelFormatDescriptionMetadata.c(a, TimeAxisLabelFormatDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Range", "TimeSpan");
            b.item("Format", "String");
            b.item("RepeatedYearFormat", "String");
            b.item("RepeatedMonthFormat", "String");
            b.item("RepeatedDayFormat", "String");
        }
        static d(a) {
            TimeAxisLabelFormatDescriptionMetadata.b(a);
            a.q("TimeAxisLabelFormat", () => new TimeAxisLabelFormatDescription());
            a.p("TimeAxisLabelFormat", TimeAxisLabelFormatDescriptionMetadata.a);
        }
    }
    TimeAxisLabelFormatDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeAxisLabelFormatDescriptionMetadata, 'TimeAxisLabelFormatDescriptionMetadata');
    TimeAxisLabelFormatDescriptionMetadata.a = null;
    return TimeAxisLabelFormatDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeAxisLabelFormatDescriptionModule = /*@__PURE__*/ (() => {
    class TimeAxisLabelFormatDescriptionModule extends Base {
        static register(a) {
            TimeAxisLabelFormatDescriptionMetadata.d(a);
        }
    }
    TimeAxisLabelFormatDescriptionModule.$t = /*@__PURE__*/ markType(TimeAxisLabelFormatDescriptionModule, 'TimeAxisLabelFormatDescriptionModule');
    return TimeAxisLabelFormatDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeXAxisDescription = /*@__PURE__*/ (() => {
    class TimeXAxisDescription extends TimeAxisBaseDescription {
        constructor() {
            super();
            this.dx = null;
            this.d3 = null;
            this.dz = null;
            this.dy = null;
        }
        get_type() {
            return "TimeXAxis";
        }
        get breaks() {
            return this.dx;
        }
        set breaks(a) {
            this.dx = a;
            this.e("Breaks");
        }
        get labellingMode() {
            return this.d3;
        }
        set labellingMode(a) {
            this.d3 = a;
            this.e("LabellingMode");
        }
        get labelFormats() {
            return this.dz;
        }
        set labelFormats(a) {
            this.dz = a;
            this.e("LabelFormats");
        }
        get intervals() {
            return this.dy;
        }
        set intervals(a) {
            this.dy = a;
            this.e("Intervals");
        }
    }
    TimeXAxisDescription.$t = /*@__PURE__*/ markType(TimeXAxisDescription, 'TimeXAxisDescription', TimeAxisBaseDescription.$);
    return TimeXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class TimeXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (TimeXAxisDescriptionMetadata.a == null) {
                TimeXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TimeXAxisDescriptionMetadata.c(a, TimeXAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            TimeAxisBaseDescriptionMetadata.c(a, b);
            b.item("Breaks", "Collection:TimeAxisBreak:TimeAxisBreakCollection:TimeAxisBreak");
            b.item("LabellingMode", "ExportedType:string:TimeAxisLabellingMode");
            b.item("LabellingMode@names", "Auto;Normal;Compressed");
            b.item("LabelFormats", "Collection:TimeAxisLabelFormat:TimeAxisLabelFormatCollection:TimeAxisLabelFormat");
            b.item("Intervals", "Collection:TimeAxisInterval:TimeAxisIntervalCollection:TimeAxisInterval");
        }
        static d(a) {
            TimeXAxisDescriptionMetadata.b(a);
            a.q("TimeXAxis", () => new TimeXAxisDescription());
            a.p("TimeXAxis", TimeXAxisDescriptionMetadata.a);
        }
    }
    TimeXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(TimeXAxisDescriptionMetadata, 'TimeXAxisDescriptionMetadata');
    TimeXAxisDescriptionMetadata.a = null;
    return TimeXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class TimeXAxisDescriptionModule extends Base {
        static register(a) {
            TimeXAxisDescriptionMetadata.d(a);
        }
    }
    TimeXAxisDescriptionModule.$t = /*@__PURE__*/ markType(TimeXAxisDescriptionModule, 'TimeXAxisDescriptionModule');
    return TimeXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OrdinalTimeXAxisDescription = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxisDescription extends CategoryXAxisDescription {
        constructor() {
            super();
            this.dz = null;
            this.d0 = null;
            this.dt = null;
            this.dw = new Date();
            this.dv = new Date();
        }
        get_type() {
            return "OrdinalTimeXAxis";
        }
        get dateTimeMemberPath() {
            return this.dz;
        }
        set dateTimeMemberPath(a) {
            this.dz = a;
            this.e("DateTimeMemberPath");
        }
        get labellingMode() {
            return this.d0;
        }
        set labellingMode(a) {
            this.d0 = a;
            this.e("LabellingMode");
        }
        get labelFormats() {
            return this.dt;
        }
        set labelFormats(a) {
            this.dt = a;
            this.e("LabelFormats");
        }
        get minimumValue() {
            return this.dw;
        }
        set minimumValue(a) {
            this.dw = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.dv;
        }
        set maximumValue(a) {
            this.dv = a;
            this.e("MaximumValue");
        }
    }
    OrdinalTimeXAxisDescription.$t = /*@__PURE__*/ markType(OrdinalTimeXAxisDescription, 'OrdinalTimeXAxisDescription', CategoryXAxisDescription.$);
    return OrdinalTimeXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OrdinalTimeXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (OrdinalTimeXAxisDescriptionMetadata.a == null) {
                OrdinalTimeXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OrdinalTimeXAxisDescriptionMetadata.c(a, OrdinalTimeXAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategoryXAxisDescriptionMetadata.c(a, b);
            b.item("DateTimeMemberPath", "String");
            b.item("LabellingMode", "ExportedType:string:TimeAxisLabellingMode");
            b.item("LabellingMode@names", "Auto;Normal;Compressed");
            b.item("LabelFormats", "Collection:TimeAxisLabelFormat:TimeAxisLabelFormatCollection:TimeAxisLabelFormat");
            b.item("MinimumValue", "Date");
            b.item("MaximumValue", "Date");
        }
        static d(a) {
            OrdinalTimeXAxisDescriptionMetadata.b(a);
            a.q("OrdinalTimeXAxis", () => new OrdinalTimeXAxisDescription());
            a.p("OrdinalTimeXAxis", OrdinalTimeXAxisDescriptionMetadata.a);
        }
    }
    OrdinalTimeXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(OrdinalTimeXAxisDescriptionMetadata, 'OrdinalTimeXAxisDescriptionMetadata');
    OrdinalTimeXAxisDescriptionMetadata.a = null;
    return OrdinalTimeXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OrdinalTimeXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxisDescriptionModule extends Base {
        static register(a) {
            OrdinalTimeXAxisDescriptionMetadata.d(a);
        }
    }
    OrdinalTimeXAxisDescriptionModule.$t = /*@__PURE__*/ markType(OrdinalTimeXAxisDescriptionModule, 'OrdinalTimeXAxisDescriptionModule');
    return OrdinalTimeXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartExtendedAxesDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartExtendedAxesDescriptionModule extends Base {
        static register(a) {
            CategoryDateTimeXAxisDescriptionModule.register(a);
            TimeAxisBreakDescriptionModule.register(a);
            TimeAxisIntervalDescriptionModule.register(a);
            TimeAxisLabelFormatDescriptionModule.register(a);
            TimeXAxisDescriptionModule.register(a);
            OrdinalTimeXAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartExtendedAxesDescriptionModule.$t = /*@__PURE__*/ markType(DataChartExtendedAxesDescriptionModule, 'DataChartExtendedAxesDescriptionModule');
    return DataChartExtendedAxesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialCoreDescriptionModule extends Base {
        static register(a) {
            CategoryXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialCoreDescriptionModule, 'DataChartFinancialCoreDescriptionModule');
    return DataChartFinancialCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalculatedColumnDescription = /*@__PURE__*/ (() => {
    class CalculatedColumnDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "CalculatedColumn";
        }
        get type() {
            return this.get_type();
        }
    }
    CalculatedColumnDescription.$t = /*@__PURE__*/ markType(CalculatedColumnDescription, 'CalculatedColumnDescription', Description.$);
    return CalculatedColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalculatedColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalculatedColumnDescriptionMetadata extends Base {
        static b(a) {
            if (CalculatedColumnDescriptionMetadata.a == null) {
                CalculatedColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalculatedColumnDescriptionMetadata.c(a, CalculatedColumnDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            CalculatedColumnDescriptionMetadata.b(a);
            a.q("CalculatedColumn", () => new CalculatedColumnDescription());
            a.p("CalculatedColumn", CalculatedColumnDescriptionMetadata.a);
        }
    }
    CalculatedColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(CalculatedColumnDescriptionMetadata, 'CalculatedColumnDescriptionMetadata');
    CalculatedColumnDescriptionMetadata.a = null;
    return CalculatedColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationDataSourceDescription = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSourceDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.g = null;
            this.f = null;
            this.x = 0;
            this.y = 0;
            this.w = 0;
            this.v = 0;
            this.u = 0;
            this.t = 0;
            this.p = 0;
            this.o = 0;
            this.n = 0;
            this.l = false;
        }
        get_type() {
            return "FinancialCalculationDataSource";
        }
        get type() {
            return this.get_type();
        }
        get typicalColumn() {
            return this.h;
        }
        set typicalColumn(a) {
            this.h = a;
            this.e("TypicalColumn");
        }
        get trueRange() {
            return this.g;
        }
        set trueRange(a) {
            this.g = a;
            this.e("TrueRange");
        }
        get trueLow() {
            return this.f;
        }
        set trueLow(a) {
            this.f = a;
            this.e("TrueLow");
        }
        get period() {
            return this.x;
        }
        set period(a) {
            this.x = a;
            this.e("Period");
        }
        get shortPeriod() {
            return this.y;
        }
        set shortPeriod(a) {
            this.y = a;
            this.e("ShortPeriod");
        }
        get longPeriod() {
            return this.w;
        }
        set longPeriod(a) {
            this.w = a;
            this.e("LongPeriod");
        }
        get count() {
            return this.v;
        }
        set count(a) {
            this.v = a;
            this.e("Count");
        }
        get calculateFrom() {
            return this.u;
        }
        set calculateFrom(a) {
            this.u = a;
            this.e("CalculateFrom");
        }
        get calculateCount() {
            return this.t;
        }
        set calculateCount(a) {
            this.t = a;
            this.e("CalculateCount");
        }
        get multiplier() {
            return this.p;
        }
        set multiplier(a) {
            this.p = a;
            this.e("Multiplier");
        }
        get minimumValue() {
            return this.o;
        }
        set minimumValue(a) {
            this.o = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.n;
        }
        set maximumValue(a) {
            this.n = a;
            this.e("MaximumValue");
        }
        get specifiesRange() {
            return this.l;
        }
        set specifiesRange(a) {
            this.l = a;
            this.e("SpecifiesRange");
        }
    }
    FinancialCalculationDataSourceDescription.$t = /*@__PURE__*/ markType(FinancialCalculationDataSourceDescription, 'FinancialCalculationDataSourceDescription', Description.$);
    return FinancialCalculationDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialCalculationDataSourceDescriptionMetadata.a == null) {
                FinancialCalculationDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialCalculationDataSourceDescriptionMetadata.c(a, FinancialCalculationDataSourceDescriptionMetadata.a);
                CalculatedColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("TypicalColumn", "ExportedType:CalculatedColumn");
            b.item("TrueRange", "ExportedType:CalculatedColumn");
            b.item("TrueLow", "ExportedType:CalculatedColumn");
            b.item("Period", "Number:int");
            b.item("ShortPeriod", "Number:int");
            b.item("LongPeriod", "Number:int");
            b.item("Count", "Number:int");
            b.item("CalculateFrom", "Number:int");
            b.item("CalculateCount", "Number:int");
            b.item("Multiplier", "Number:double");
            b.item("MinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("SpecifiesRange", "Boolean");
        }
        static d(a) {
            FinancialCalculationDataSourceDescriptionMetadata.b(a);
            a.q("FinancialCalculationDataSource", () => new FinancialCalculationDataSourceDescription());
            a.p("FinancialCalculationDataSource", FinancialCalculationDataSourceDescriptionMetadata.a);
        }
    }
    FinancialCalculationDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialCalculationDataSourceDescriptionMetadata, 'FinancialCalculationDataSourceDescriptionMetadata');
    FinancialCalculationDataSourceDescriptionMetadata.a = null;
    return FinancialCalculationDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSupportingCalculationDescription = /*@__PURE__*/ (() => {
    class ColumnSupportingCalculationDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ColumnSupportingCalculation";
        }
        get type() {
            return this.get_type();
        }
    }
    ColumnSupportingCalculationDescription.$t = /*@__PURE__*/ markType(ColumnSupportingCalculationDescription, 'ColumnSupportingCalculationDescription', Description.$);
    return ColumnSupportingCalculationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnSupportingCalculationDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnSupportingCalculationDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnSupportingCalculationDescriptionMetadata.a == null) {
                ColumnSupportingCalculationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnSupportingCalculationDescriptionMetadata.c(a, ColumnSupportingCalculationDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ColumnSupportingCalculationDescriptionMetadata.b(a);
            a.q("ColumnSupportingCalculation", () => new ColumnSupportingCalculationDescription());
            a.p("ColumnSupportingCalculation", ColumnSupportingCalculationDescriptionMetadata.a);
        }
    }
    ColumnSupportingCalculationDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnSupportingCalculationDescriptionMetadata, 'ColumnSupportingCalculationDescriptionMetadata');
    ColumnSupportingCalculationDescriptionMetadata.a = null;
    return ColumnSupportingCalculationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSupportingCalculationDescription = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculationDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "DataSourceSupportingCalculation";
        }
        get type() {
            return this.get_type();
        }
    }
    DataSourceSupportingCalculationDescription.$t = /*@__PURE__*/ markType(DataSourceSupportingCalculationDescription, 'DataSourceSupportingCalculationDescription', Description.$);
    return DataSourceSupportingCalculationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSupportingCalculationDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculationDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceSupportingCalculationDescriptionMetadata.a == null) {
                DataSourceSupportingCalculationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceSupportingCalculationDescriptionMetadata.c(a, DataSourceSupportingCalculationDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            DataSourceSupportingCalculationDescriptionMetadata.b(a);
            a.q("DataSourceSupportingCalculation", () => new DataSourceSupportingCalculationDescription());
            a.p("DataSourceSupportingCalculation", DataSourceSupportingCalculationDescriptionMetadata.a);
        }
    }
    DataSourceSupportingCalculationDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceSupportingCalculationDescriptionMetadata, 'DataSourceSupportingCalculationDescriptionMetadata');
    DataSourceSupportingCalculationDescriptionMetadata.a = null;
    return DataSourceSupportingCalculationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationSupportingCalculationsDescription = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculationsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
            this.i = null;
            this.g = null;
            this.q = null;
            this.o = null;
            this.p = null;
            this.n = null;
            this.v = null;
        }
        get_type() {
            return "FinancialCalculationSupportingCalculations";
        }
        get type() {
            return this.get_type();
        }
        get eMA() {
            return this.f;
        }
        set eMA(a) {
            this.f = a;
            this.e("EMA");
        }
        get sMA() {
            return this.h;
        }
        set sMA(a) {
            this.h = a;
            this.e("SMA");
        }
        get sTDEV() {
            return this.i;
        }
        set sTDEV(a) {
            this.i = a;
            this.e("STDEV");
        }
        get movingSum() {
            return this.g;
        }
        set movingSum(a) {
            this.g = a;
            this.e("MovingSum");
        }
        get shortVolumeOscillatorAverage() {
            return this.q;
        }
        set shortVolumeOscillatorAverage(a) {
            this.q = a;
            this.e("ShortVolumeOscillatorAverage");
        }
        get longVolumeOscillatorAverage() {
            return this.o;
        }
        set longVolumeOscillatorAverage(a) {
            this.o = a;
            this.e("LongVolumeOscillatorAverage");
        }
        get shortPriceOscillatorAverage() {
            return this.p;
        }
        set shortPriceOscillatorAverage(a) {
            this.p = a;
            this.e("ShortPriceOscillatorAverage");
        }
        get longPriceOscillatorAverage() {
            return this.n;
        }
        set longPriceOscillatorAverage(a) {
            this.n = a;
            this.e("LongPriceOscillatorAverage");
        }
        get makeSafeRef() {
            return this.v;
        }
        set makeSafeRef(a) {
            this.v = a;
            this.e("MakeSafeRef");
        }
    }
    FinancialCalculationSupportingCalculationsDescription.$t = /*@__PURE__*/ markType(FinancialCalculationSupportingCalculationsDescription, 'FinancialCalculationSupportingCalculationsDescription', Description.$);
    return FinancialCalculationSupportingCalculationsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialCalculationSupportingCalculationsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculationsDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialCalculationSupportingCalculationsDescriptionMetadata.a == null) {
                FinancialCalculationSupportingCalculationsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialCalculationSupportingCalculationsDescriptionMetadata.c(a, FinancialCalculationSupportingCalculationsDescriptionMetadata.a);
                ColumnSupportingCalculationDescriptionMetadata.d(a);
                DataSourceSupportingCalculationDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("EMA", "ExportedType:ColumnSupportingCalculation");
            b.item("SMA", "ExportedType:ColumnSupportingCalculation");
            b.item("STDEV", "ExportedType:ColumnSupportingCalculation");
            b.item("MovingSum", "ExportedType:ColumnSupportingCalculation");
            b.item("ShortVolumeOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            b.item("LongVolumeOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            b.item("ShortPriceOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            b.item("LongPriceOscillatorAverage", "ExportedType:DataSourceSupportingCalculation");
            b.item("MakeSafeRef", "(w:MakeSafe,wf:MakeSafe)MethodRef");
        }
        static d(a) {
            FinancialCalculationSupportingCalculationsDescriptionMetadata.b(a);
            a.q("FinancialCalculationSupportingCalculations", () => new FinancialCalculationSupportingCalculationsDescription());
            a.p("FinancialCalculationSupportingCalculations", FinancialCalculationSupportingCalculationsDescriptionMetadata.a);
        }
    }
    FinancialCalculationSupportingCalculationsDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialCalculationSupportingCalculationsDescriptionMetadata, 'FinancialCalculationSupportingCalculationsDescriptionMetadata');
    FinancialCalculationSupportingCalculationsDescriptionMetadata.a = null;
    return FinancialCalculationSupportingCalculationsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialEventArgsDescription = /*@__PURE__*/ (() => {
    class FinancialEventArgsDescription extends Description {
        constructor() {
            super();
            this.k = 0;
            this.j = 0;
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "FinancialEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get position() {
            return this.k;
        }
        set position(a) {
            this.k = a;
            this.e("Position");
        }
        get count() {
            return this.j;
        }
        set count(a) {
            this.j = a;
            this.e("Count");
        }
        get dataSource() {
            return this.f;
        }
        set dataSource(a) {
            this.f = a;
            this.e("DataSource");
        }
        get supportingCalculations() {
            return this.h;
        }
        set supportingCalculations(a) {
            this.h = a;
            this.e("SupportingCalculations");
        }
    }
    FinancialEventArgsDescription.$t = /*@__PURE__*/ markType(FinancialEventArgsDescription, 'FinancialEventArgsDescription', Description.$);
    return FinancialEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialEventArgsDescriptionMetadata.a == null) {
                FinancialEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialEventArgsDescriptionMetadata.c(a, FinancialEventArgsDescriptionMetadata.a);
                FinancialCalculationDataSourceDescriptionMetadata.d(a);
                FinancialCalculationSupportingCalculationsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Position", "Number:int");
            b.item("Count", "Number:int");
            b.item("DataSource", "ExportedType:FinancialCalculationDataSource");
            b.item("SupportingCalculations", "ExportedType:FinancialCalculationSupportingCalculations");
        }
        static d(a) {
            FinancialEventArgsDescriptionMetadata.b(a);
            a.q("FinancialEventArgs", () => new FinancialEventArgsDescription());
            a.p("FinancialEventArgs", FinancialEventArgsDescriptionMetadata.a);
        }
    }
    FinancialEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialEventArgsDescriptionMetadata, 'FinancialEventArgsDescriptionMetadata');
    FinancialEventArgsDescriptionMetadata.a = null;
    return FinancialEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialSeriesDescriptionMetadata.a == null) {
                FinancialSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialSeriesDescriptionMetadata.c(a, FinancialSeriesDescriptionMetadata.a);
                AssigningCategoryStyleEventArgsDescriptionMetadata.d(a);
                FinancialEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("NegativeBrush", "Brush");
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
            b.item("OpenMemberPath", "String");
            b.item("HighMemberPath", "String");
            b.item("LowMemberPath", "String");
            b.item("CloseMemberPath", "String");
            b.item("VolumeMemberPath", "String");
            b.item("IsCustomCategoryStyleAllowed", "Boolean");
            b.item("TransitionInMode", "ExportedType:string:CategoryTransitionInMode");
            b.item("TransitionInMode@names", "Auto;FromZero;SweepFromLeft;SweepFromRight;SweepFromTop;SweepFromBottom;SweepFromCenter;AccordionFromLeft;AccordionFromRight;AccordionFromTop;AccordionFromBottom;Expand;SweepFromCategoryAxisMinimum;SweepFromCategoryAxisMaximum;SweepFromValueAxisMinimum;SweepFromValueAxisMaximum;AccordionFromCategoryAxisMinimum;AccordionFromCategoryAxisMaximum;AccordionFromValueAxisMinimum;AccordionFromValueAxisMaximum");
            b.item("IsTransitionInEnabled", "Boolean");
            b.item("AssigningCategoryStyleRef", "EventRef::assigningCategoryStyle");
            b.item("TypicalRef", "EventRef::typical");
            b.item("TypicalBasedOnRef", "EventRef::typicalBasedOn");
        }
        static d(a) {
            FinancialSeriesDescriptionMetadata.b(a);
            a.p("FinancialSeries", FinancialSeriesDescriptionMetadata.a);
        }
    }
    FinancialSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialSeriesDescriptionMetadata, 'FinancialSeriesDescriptionMetadata');
    FinancialSeriesDescriptionMetadata.a = null;
    return FinancialSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialIndicatorDescriptionMetadata.a == null) {
                FinancialIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialIndicatorDescriptionMetadata.c(a, FinancialIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FinancialSeriesDescriptionMetadata.c(a, b);
            b.item("DisplayType", "ExportedType:string:IndicatorDisplayType");
            b.item("DisplayType@names", "Line;Area;Column");
            b.item("IgnoreFirst", "Number:int");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineBrush", "Brush");
            b.item("ActualTrendLineBrush", "Brush");
            b.item("TrendLineThickness", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
        }
        static d(a) {
            FinancialIndicatorDescriptionMetadata.b(a);
            a.p("FinancialIndicator", FinancialIndicatorDescriptionMetadata.a);
        }
    }
    FinancialIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialIndicatorDescriptionMetadata, 'FinancialIndicatorDescriptionMetadata');
    FinancialIndicatorDescriptionMetadata.a = null;
    return FinancialIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StrategyBasedIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StrategyBasedIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (StrategyBasedIndicatorDescriptionMetadata.a == null) {
                StrategyBasedIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StrategyBasedIndicatorDescriptionMetadata.c(a, StrategyBasedIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FinancialIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StrategyBasedIndicatorDescriptionMetadata.b(a);
            a.p("StrategyBasedIndicator", StrategyBasedIndicatorDescriptionMetadata.a);
        }
    }
    StrategyBasedIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(StrategyBasedIndicatorDescriptionMetadata, 'StrategyBasedIndicatorDescriptionMetadata');
    StrategyBasedIndicatorDescriptionMetadata.a = null;
    return StrategyBasedIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialSeriesDescription = /*@__PURE__*/ (() => {
    class FinancialSeriesDescription extends SeriesDescription {
        constructor() {
            super();
            this.cw = null;
            this.c2 = null;
            this.c3 = null;
            this.cx = null;
            this.cu = null;
            this.cv = null;
            this.ct = null;
            this.c1 = null;
            this.co = false;
            this.cy = null;
            this.cp = false;
            this.cs = null;
            this.cz = null;
            this.c0 = null;
        }
        get_type() {
            return "FinancialSeries";
        }
        get negativeBrush() {
            return this.cw;
        }
        set negativeBrush(a) {
            this.cw = a;
            this.e("NegativeBrush");
        }
        get xAxisRef() {
            return this.c2;
        }
        set xAxisRef(a) {
            this.c2 = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.c3;
        }
        set yAxisRef(a) {
            this.c3 = a;
            this.e("YAxisRef");
        }
        get openMemberPath() {
            return this.cx;
        }
        set openMemberPath(a) {
            this.cx = a;
            this.e("OpenMemberPath");
        }
        get highMemberPath() {
            return this.cu;
        }
        set highMemberPath(a) {
            this.cu = a;
            this.e("HighMemberPath");
        }
        get lowMemberPath() {
            return this.cv;
        }
        set lowMemberPath(a) {
            this.cv = a;
            this.e("LowMemberPath");
        }
        get closeMemberPath() {
            return this.ct;
        }
        set closeMemberPath(a) {
            this.ct = a;
            this.e("CloseMemberPath");
        }
        get volumeMemberPath() {
            return this.c1;
        }
        set volumeMemberPath(a) {
            this.c1 = a;
            this.e("VolumeMemberPath");
        }
        get isCustomCategoryStyleAllowed() {
            return this.co;
        }
        set isCustomCategoryStyleAllowed(a) {
            this.co = a;
            this.e("IsCustomCategoryStyleAllowed");
        }
        get transitionInMode() {
            return this.cy;
        }
        set transitionInMode(a) {
            this.cy = a;
            this.e("TransitionInMode");
        }
        get isTransitionInEnabled() {
            return this.cp;
        }
        set isTransitionInEnabled(a) {
            this.cp = a;
            this.e("IsTransitionInEnabled");
        }
        get assigningCategoryStyleRef() {
            return this.cs;
        }
        set assigningCategoryStyleRef(a) {
            this.cs = a;
            this.e("AssigningCategoryStyleRef");
        }
        get typicalRef() {
            return this.cz;
        }
        set typicalRef(a) {
            this.cz = a;
            this.e("TypicalRef");
        }
        get typicalBasedOnRef() {
            return this.c0;
        }
        set typicalBasedOnRef(a) {
            this.c0 = a;
            this.e("TypicalBasedOnRef");
        }
    }
    FinancialSeriesDescription.$t = /*@__PURE__*/ markType(FinancialSeriesDescription, 'FinancialSeriesDescription', SeriesDescription.$);
    return FinancialSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialIndicatorDescription = /*@__PURE__*/ (() => {
    class FinancialIndicatorDescription extends FinancialSeriesDescription {
        constructor() {
            super();
            this.dn = null;
            this.di = 0;
            this.dq = null;
            this.dp = null;
            this.dm = null;
            this.dg = 0;
            this.dj = 0;
        }
        get_type() {
            return "FinancialIndicator";
        }
        get displayType() {
            return this.dn;
        }
        set displayType(a) {
            this.dn = a;
            this.e("DisplayType");
        }
        get ignoreFirst() {
            return this.di;
        }
        set ignoreFirst(a) {
            this.di = a;
            this.e("IgnoreFirst");
        }
        get trendLineType() {
            return this.dq;
        }
        set trendLineType(a) {
            this.dq = a;
            this.e("TrendLineType");
        }
        get trendLineBrush() {
            return this.dp;
        }
        set trendLineBrush(a) {
            this.dp = a;
            this.e("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.dm;
        }
        set actualTrendLineBrush(a) {
            this.dm = a;
            this.e("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.dg;
        }
        set trendLineThickness(a) {
            this.dg = a;
            this.e("TrendLineThickness");
        }
        get trendLinePeriod() {
            return this.dj;
        }
        set trendLinePeriod(a) {
            this.dj = a;
            this.e("TrendLinePeriod");
        }
    }
    FinancialIndicatorDescription.$t = /*@__PURE__*/ markType(FinancialIndicatorDescription, 'FinancialIndicatorDescription', FinancialSeriesDescription.$);
    return FinancialIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StrategyBasedIndicatorDescription = /*@__PURE__*/ (() => {
    class StrategyBasedIndicatorDescription extends FinancialIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StrategyBasedIndicator";
        }
    }
    StrategyBasedIndicatorDescription.$t = /*@__PURE__*/ markType(StrategyBasedIndicatorDescription, 'StrategyBasedIndicatorDescription', FinancialIndicatorDescription.$);
    return StrategyBasedIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsoluteVolumeOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class AbsoluteVolumeOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dw = 0;
            this.dv = 0;
        }
        get_type() {
            return "AbsoluteVolumeOscillatorIndicator";
        }
        get shortPeriod() {
            return this.dw;
        }
        set shortPeriod(a) {
            this.dw = a;
            this.e("ShortPeriod");
        }
        get longPeriod() {
            return this.dv;
        }
        set longPeriod(a) {
            this.dv = a;
            this.e("LongPeriod");
        }
    }
    AbsoluteVolumeOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(AbsoluteVolumeOscillatorIndicatorDescription, 'AbsoluteVolumeOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AbsoluteVolumeOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsoluteVolumeOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AbsoluteVolumeOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a == null) {
                AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.c(a, AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("ShortPeriod", "Number:int");
            b.item("LongPeriod", "Number:int");
        }
        static d(a) {
            AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("AbsoluteVolumeOscillatorIndicator", () => new AbsoluteVolumeOscillatorIndicatorDescription());
            a.p("AbsoluteVolumeOscillatorIndicator", AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AbsoluteVolumeOscillatorIndicatorDescriptionMetadata, 'AbsoluteVolumeOscillatorIndicatorDescriptionMetadata');
    AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.a = null;
    return AbsoluteVolumeOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbsoluteVolumeOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AbsoluteVolumeOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            AbsoluteVolumeOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    AbsoluteVolumeOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AbsoluteVolumeOscillatorIndicatorDescriptionModule, 'AbsoluteVolumeOscillatorIndicatorDescriptionModule');
    return AbsoluteVolumeOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AccumulationDistributionIndicatorDescription = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AccumulationDistributionIndicator";
        }
    }
    AccumulationDistributionIndicatorDescription.$t = /*@__PURE__*/ markType(AccumulationDistributionIndicatorDescription, 'AccumulationDistributionIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AccumulationDistributionIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AccumulationDistributionIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AccumulationDistributionIndicatorDescriptionMetadata.a == null) {
                AccumulationDistributionIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AccumulationDistributionIndicatorDescriptionMetadata.c(a, AccumulationDistributionIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AccumulationDistributionIndicatorDescriptionMetadata.b(a);
            a.q("AccumulationDistributionIndicator", () => new AccumulationDistributionIndicatorDescription());
            a.p("AccumulationDistributionIndicator", AccumulationDistributionIndicatorDescriptionMetadata.a);
        }
    }
    AccumulationDistributionIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AccumulationDistributionIndicatorDescriptionMetadata, 'AccumulationDistributionIndicatorDescriptionMetadata');
    AccumulationDistributionIndicatorDescriptionMetadata.a = null;
    return AccumulationDistributionIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AccumulationDistributionIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AccumulationDistributionIndicatorDescriptionModule extends Base {
        static register(a) {
            AccumulationDistributionIndicatorDescriptionMetadata.d(a);
        }
    }
    AccumulationDistributionIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AccumulationDistributionIndicatorDescriptionModule, 'AccumulationDistributionIndicatorDescriptionModule');
    return AccumulationDistributionIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageDirectionalIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "AverageDirectionalIndexIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    AverageDirectionalIndexIndicatorDescription.$t = /*@__PURE__*/ markType(AverageDirectionalIndexIndicatorDescription, 'AverageDirectionalIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AverageDirectionalIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageDirectionalIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AverageDirectionalIndexIndicatorDescriptionMetadata.a == null) {
                AverageDirectionalIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AverageDirectionalIndexIndicatorDescriptionMetadata.c(a, AverageDirectionalIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            AverageDirectionalIndexIndicatorDescriptionMetadata.b(a);
            a.q("AverageDirectionalIndexIndicator", () => new AverageDirectionalIndexIndicatorDescription());
            a.p("AverageDirectionalIndexIndicator", AverageDirectionalIndexIndicatorDescriptionMetadata.a);
        }
    }
    AverageDirectionalIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AverageDirectionalIndexIndicatorDescriptionMetadata, 'AverageDirectionalIndexIndicatorDescriptionMetadata');
    AverageDirectionalIndexIndicatorDescriptionMetadata.a = null;
    return AverageDirectionalIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageDirectionalIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AverageDirectionalIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            AverageDirectionalIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    AverageDirectionalIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AverageDirectionalIndexIndicatorDescriptionModule, 'AverageDirectionalIndexIndicatorDescriptionModule');
    return AverageDirectionalIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageTrueRangeIndicatorDescription = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "AverageTrueRangeIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    AverageTrueRangeIndicatorDescription.$t = /*@__PURE__*/ markType(AverageTrueRangeIndicatorDescription, 'AverageTrueRangeIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return AverageTrueRangeIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageTrueRangeIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (AverageTrueRangeIndicatorDescriptionMetadata.a == null) {
                AverageTrueRangeIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AverageTrueRangeIndicatorDescriptionMetadata.c(a, AverageTrueRangeIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            AverageTrueRangeIndicatorDescriptionMetadata.b(a);
            a.q("AverageTrueRangeIndicator", () => new AverageTrueRangeIndicatorDescription());
            a.p("AverageTrueRangeIndicator", AverageTrueRangeIndicatorDescriptionMetadata.a);
        }
    }
    AverageTrueRangeIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(AverageTrueRangeIndicatorDescriptionMetadata, 'AverageTrueRangeIndicatorDescriptionMetadata');
    AverageTrueRangeIndicatorDescriptionMetadata.a = null;
    return AverageTrueRangeIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AverageTrueRangeIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class AverageTrueRangeIndicatorDescriptionModule extends Base {
        static register(a) {
            AverageTrueRangeIndicatorDescriptionMetadata.d(a);
        }
    }
    AverageTrueRangeIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(AverageTrueRangeIndicatorDescriptionModule, 'AverageTrueRangeIndicatorDescriptionModule');
    return AverageTrueRangeIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandWidthIndicatorDescription = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dx = 0;
            this.dv = 0;
        }
        get_type() {
            return "BollingerBandWidthIndicator";
        }
        get period() {
            return this.dx;
        }
        set period(a) {
            this.dx = a;
            this.e("Period");
        }
        get multiplier() {
            return this.dv;
        }
        set multiplier(a) {
            this.dv = a;
            this.e("Multiplier");
        }
    }
    BollingerBandWidthIndicatorDescription.$t = /*@__PURE__*/ markType(BollingerBandWidthIndicatorDescription, 'BollingerBandWidthIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return BollingerBandWidthIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandWidthIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (BollingerBandWidthIndicatorDescriptionMetadata.a == null) {
                BollingerBandWidthIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BollingerBandWidthIndicatorDescriptionMetadata.c(a, BollingerBandWidthIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
            b.item("Multiplier", "Number:double");
        }
        static d(a) {
            BollingerBandWidthIndicatorDescriptionMetadata.b(a);
            a.q("BollingerBandWidthIndicator", () => new BollingerBandWidthIndicatorDescription());
            a.p("BollingerBandWidthIndicator", BollingerBandWidthIndicatorDescriptionMetadata.a);
        }
    }
    BollingerBandWidthIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(BollingerBandWidthIndicatorDescriptionMetadata, 'BollingerBandWidthIndicatorDescriptionMetadata');
    BollingerBandWidthIndicatorDescriptionMetadata.a = null;
    return BollingerBandWidthIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandWidthIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class BollingerBandWidthIndicatorDescriptionModule extends Base {
        static register(a) {
            BollingerBandWidthIndicatorDescriptionMetadata.d(a);
        }
    }
    BollingerBandWidthIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(BollingerBandWidthIndicatorDescriptionModule, 'BollingerBandWidthIndicatorDescriptionModule');
    return BollingerBandWidthIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class ChaikinOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dw = 0;
            this.dv = 0;
        }
        get_type() {
            return "ChaikinOscillatorIndicator";
        }
        get shortPeriod() {
            return this.dw;
        }
        set shortPeriod(a) {
            this.dw = a;
            this.e("ShortPeriod");
        }
        get longPeriod() {
            return this.dv;
        }
        set longPeriod(a) {
            this.dv = a;
            this.e("LongPeriod");
        }
    }
    ChaikinOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(ChaikinOscillatorIndicatorDescription, 'ChaikinOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ChaikinOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChaikinOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ChaikinOscillatorIndicatorDescriptionMetadata.a == null) {
                ChaikinOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChaikinOscillatorIndicatorDescriptionMetadata.c(a, ChaikinOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("ShortPeriod", "Number:int");
            b.item("LongPeriod", "Number:int");
        }
        static d(a) {
            ChaikinOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("ChaikinOscillatorIndicator", () => new ChaikinOscillatorIndicatorDescription());
            a.p("ChaikinOscillatorIndicator", ChaikinOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    ChaikinOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ChaikinOscillatorIndicatorDescriptionMetadata, 'ChaikinOscillatorIndicatorDescriptionMetadata');
    ChaikinOscillatorIndicatorDescriptionMetadata.a = null;
    return ChaikinOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class ChaikinOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            ChaikinOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    ChaikinOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(ChaikinOscillatorIndicatorDescriptionModule, 'ChaikinOscillatorIndicatorDescriptionModule');
    return ChaikinOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinVolatilityIndicatorDescription = /*@__PURE__*/ (() => {
    class ChaikinVolatilityIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "ChaikinVolatilityIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    ChaikinVolatilityIndicatorDescription.$t = /*@__PURE__*/ markType(ChaikinVolatilityIndicatorDescription, 'ChaikinVolatilityIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ChaikinVolatilityIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinVolatilityIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ChaikinVolatilityIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ChaikinVolatilityIndicatorDescriptionMetadata.a == null) {
                ChaikinVolatilityIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ChaikinVolatilityIndicatorDescriptionMetadata.c(a, ChaikinVolatilityIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            ChaikinVolatilityIndicatorDescriptionMetadata.b(a);
            a.q("ChaikinVolatilityIndicator", () => new ChaikinVolatilityIndicatorDescription());
            a.p("ChaikinVolatilityIndicator", ChaikinVolatilityIndicatorDescriptionMetadata.a);
        }
    }
    ChaikinVolatilityIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ChaikinVolatilityIndicatorDescriptionMetadata, 'ChaikinVolatilityIndicatorDescriptionMetadata');
    ChaikinVolatilityIndicatorDescriptionMetadata.a = null;
    return ChaikinVolatilityIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChaikinVolatilityIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class ChaikinVolatilityIndicatorDescriptionModule extends Base {
        static register(a) {
            ChaikinVolatilityIndicatorDescriptionMetadata.d(a);
        }
    }
    ChaikinVolatilityIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(ChaikinVolatilityIndicatorDescriptionModule, 'ChaikinVolatilityIndicatorDescriptionModule');
    return ChaikinVolatilityIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CommodityChannelIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "CommodityChannelIndexIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    CommodityChannelIndexIndicatorDescription.$t = /*@__PURE__*/ markType(CommodityChannelIndexIndicatorDescription, 'CommodityChannelIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return CommodityChannelIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CommodityChannelIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (CommodityChannelIndexIndicatorDescriptionMetadata.a == null) {
                CommodityChannelIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CommodityChannelIndexIndicatorDescriptionMetadata.c(a, CommodityChannelIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            CommodityChannelIndexIndicatorDescriptionMetadata.b(a);
            a.q("CommodityChannelIndexIndicator", () => new CommodityChannelIndexIndicatorDescription());
            a.p("CommodityChannelIndexIndicator", CommodityChannelIndexIndicatorDescriptionMetadata.a);
        }
    }
    CommodityChannelIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(CommodityChannelIndexIndicatorDescriptionMetadata, 'CommodityChannelIndexIndicatorDescriptionMetadata');
    CommodityChannelIndexIndicatorDescriptionMetadata.a = null;
    return CommodityChannelIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CommodityChannelIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class CommodityChannelIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            CommodityChannelIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    CommodityChannelIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(CommodityChannelIndexIndicatorDescriptionModule, 'CommodityChannelIndexIndicatorDescriptionModule');
    return CommodityChannelIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DetrendedPriceOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "DetrendedPriceOscillatorIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    DetrendedPriceOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(DetrendedPriceOscillatorIndicatorDescription, 'DetrendedPriceOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return DetrendedPriceOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DetrendedPriceOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (DetrendedPriceOscillatorIndicatorDescriptionMetadata.a == null) {
                DetrendedPriceOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DetrendedPriceOscillatorIndicatorDescriptionMetadata.c(a, DetrendedPriceOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            DetrendedPriceOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("DetrendedPriceOscillatorIndicator", () => new DetrendedPriceOscillatorIndicatorDescription());
            a.p("DetrendedPriceOscillatorIndicator", DetrendedPriceOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    DetrendedPriceOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(DetrendedPriceOscillatorIndicatorDescriptionMetadata, 'DetrendedPriceOscillatorIndicatorDescriptionMetadata');
    DetrendedPriceOscillatorIndicatorDescriptionMetadata.a = null;
    return DetrendedPriceOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DetrendedPriceOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class DetrendedPriceOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            DetrendedPriceOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    DetrendedPriceOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(DetrendedPriceOscillatorIndicatorDescriptionModule, 'DetrendedPriceOscillatorIndicatorDescriptionModule');
    return DetrendedPriceOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EaseOfMovementIndicatorDescription = /*@__PURE__*/ (() => {
    class EaseOfMovementIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "EaseOfMovementIndicator";
        }
    }
    EaseOfMovementIndicatorDescription.$t = /*@__PURE__*/ markType(EaseOfMovementIndicatorDescription, 'EaseOfMovementIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return EaseOfMovementIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EaseOfMovementIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class EaseOfMovementIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (EaseOfMovementIndicatorDescriptionMetadata.a == null) {
                EaseOfMovementIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EaseOfMovementIndicatorDescriptionMetadata.c(a, EaseOfMovementIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            EaseOfMovementIndicatorDescriptionMetadata.b(a);
            a.q("EaseOfMovementIndicator", () => new EaseOfMovementIndicatorDescription());
            a.p("EaseOfMovementIndicator", EaseOfMovementIndicatorDescriptionMetadata.a);
        }
    }
    EaseOfMovementIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(EaseOfMovementIndicatorDescriptionMetadata, 'EaseOfMovementIndicatorDescriptionMetadata');
    EaseOfMovementIndicatorDescriptionMetadata.a = null;
    return EaseOfMovementIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EaseOfMovementIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class EaseOfMovementIndicatorDescriptionModule extends Base {
        static register(a) {
            EaseOfMovementIndicatorDescriptionMetadata.d(a);
        }
    }
    EaseOfMovementIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(EaseOfMovementIndicatorDescriptionModule, 'EaseOfMovementIndicatorDescriptionModule');
    return EaseOfMovementIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastStochasticOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class FastStochasticOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "FastStochasticOscillatorIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    FastStochasticOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(FastStochasticOscillatorIndicatorDescription, 'FastStochasticOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return FastStochasticOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastStochasticOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class FastStochasticOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (FastStochasticOscillatorIndicatorDescriptionMetadata.a == null) {
                FastStochasticOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FastStochasticOscillatorIndicatorDescriptionMetadata.c(a, FastStochasticOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            FastStochasticOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("FastStochasticOscillatorIndicator", () => new FastStochasticOscillatorIndicatorDescription());
            a.p("FastStochasticOscillatorIndicator", FastStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    FastStochasticOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(FastStochasticOscillatorIndicatorDescriptionMetadata, 'FastStochasticOscillatorIndicatorDescriptionMetadata');
    FastStochasticOscillatorIndicatorDescriptionMetadata.a = null;
    return FastStochasticOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastStochasticOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class FastStochasticOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            FastStochasticOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    FastStochasticOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(FastStochasticOscillatorIndicatorDescriptionModule, 'FastStochasticOscillatorIndicatorDescriptionModule');
    return FastStochasticOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ForceIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class ForceIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "ForceIndexIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    ForceIndexIndicatorDescription.$t = /*@__PURE__*/ markType(ForceIndexIndicatorDescription, 'ForceIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ForceIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ForceIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ForceIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ForceIndexIndicatorDescriptionMetadata.a == null) {
                ForceIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ForceIndexIndicatorDescriptionMetadata.c(a, ForceIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            ForceIndexIndicatorDescriptionMetadata.b(a);
            a.q("ForceIndexIndicator", () => new ForceIndexIndicatorDescription());
            a.p("ForceIndexIndicator", ForceIndexIndicatorDescriptionMetadata.a);
        }
    }
    ForceIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ForceIndexIndicatorDescriptionMetadata, 'ForceIndexIndicatorDescriptionMetadata');
    ForceIndexIndicatorDescriptionMetadata.a = null;
    return ForceIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ForceIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class ForceIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            ForceIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    ForceIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(ForceIndexIndicatorDescriptionModule, 'ForceIndexIndicatorDescriptionModule');
    return ForceIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FullStochasticOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
            this.dw = 0;
            this.dx = 0;
        }
        get_type() {
            return "FullStochasticOscillatorIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
        get smoothingPeriod() {
            return this.dw;
        }
        set smoothingPeriod(a) {
            this.dw = a;
            this.e("SmoothingPeriod");
        }
        get triggerPeriod() {
            return this.dx;
        }
        set triggerPeriod(a) {
            this.dx = a;
            this.e("TriggerPeriod");
        }
    }
    FullStochasticOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(FullStochasticOscillatorIndicatorDescription, 'FullStochasticOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return FullStochasticOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FullStochasticOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (FullStochasticOscillatorIndicatorDescriptionMetadata.a == null) {
                FullStochasticOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FullStochasticOscillatorIndicatorDescriptionMetadata.c(a, FullStochasticOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
            b.item("SmoothingPeriod", "Number:int");
            b.item("TriggerPeriod", "Number:int");
        }
        static d(a) {
            FullStochasticOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("FullStochasticOscillatorIndicator", () => new FullStochasticOscillatorIndicatorDescription());
            a.p("FullStochasticOscillatorIndicator", FullStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    FullStochasticOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(FullStochasticOscillatorIndicatorDescriptionMetadata, 'FullStochasticOscillatorIndicatorDescriptionMetadata');
    FullStochasticOscillatorIndicatorDescriptionMetadata.a = null;
    return FullStochasticOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FullStochasticOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class FullStochasticOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            FullStochasticOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    FullStochasticOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(FullStochasticOscillatorIndicatorDescriptionModule, 'FullStochasticOscillatorIndicatorDescriptionModule');
    return FullStochasticOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemwiseStrategyBasedIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class ItemwiseStrategyBasedIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (ItemwiseStrategyBasedIndicatorDescriptionMetadata.a == null) {
                ItemwiseStrategyBasedIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a, ItemwiseStrategyBasedIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.b(a);
            a.p("ItemwiseStrategyBasedIndicator", ItemwiseStrategyBasedIndicatorDescriptionMetadata.a);
        }
    }
    ItemwiseStrategyBasedIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(ItemwiseStrategyBasedIndicatorDescriptionMetadata, 'ItemwiseStrategyBasedIndicatorDescriptionMetadata');
    ItemwiseStrategyBasedIndicatorDescriptionMetadata.a = null;
    return ItemwiseStrategyBasedIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemwiseStrategyBasedIndicatorDescription = /*@__PURE__*/ (() => {
    class ItemwiseStrategyBasedIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "ItemwiseStrategyBasedIndicator";
        }
    }
    ItemwiseStrategyBasedIndicatorDescription.$t = /*@__PURE__*/ markType(ItemwiseStrategyBasedIndicatorDescription, 'ItemwiseStrategyBasedIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return ItemwiseStrategyBasedIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarketFacilitationIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class MarketFacilitationIndexIndicatorDescription extends ItemwiseStrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "MarketFacilitationIndexIndicator";
        }
    }
    MarketFacilitationIndexIndicatorDescription.$t = /*@__PURE__*/ markType(MarketFacilitationIndexIndicatorDescription, 'MarketFacilitationIndexIndicatorDescription', ItemwiseStrategyBasedIndicatorDescription.$);
    return MarketFacilitationIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarketFacilitationIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MarketFacilitationIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MarketFacilitationIndexIndicatorDescriptionMetadata.a == null) {
                MarketFacilitationIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MarketFacilitationIndexIndicatorDescriptionMetadata.c(a, MarketFacilitationIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            MarketFacilitationIndexIndicatorDescriptionMetadata.b(a);
            a.q("MarketFacilitationIndexIndicator", () => new MarketFacilitationIndexIndicatorDescription());
            a.p("MarketFacilitationIndexIndicator", MarketFacilitationIndexIndicatorDescriptionMetadata.a);
        }
    }
    MarketFacilitationIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MarketFacilitationIndexIndicatorDescriptionMetadata, 'MarketFacilitationIndexIndicatorDescriptionMetadata');
    MarketFacilitationIndexIndicatorDescriptionMetadata.a = null;
    return MarketFacilitationIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarketFacilitationIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MarketFacilitationIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            MarketFacilitationIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    MarketFacilitationIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MarketFacilitationIndexIndicatorDescriptionModule, 'MarketFacilitationIndexIndicatorDescriptionModule');
    return MarketFacilitationIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MassIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class MassIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "MassIndexIndicator";
        }
    }
    MassIndexIndicatorDescription.$t = /*@__PURE__*/ markType(MassIndexIndicatorDescription, 'MassIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return MassIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MassIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MassIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MassIndexIndicatorDescriptionMetadata.a == null) {
                MassIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MassIndexIndicatorDescriptionMetadata.c(a, MassIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            MassIndexIndicatorDescriptionMetadata.b(a);
            a.q("MassIndexIndicator", () => new MassIndexIndicatorDescription());
            a.p("MassIndexIndicator", MassIndexIndicatorDescriptionMetadata.a);
        }
    }
    MassIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MassIndexIndicatorDescriptionMetadata, 'MassIndexIndicatorDescriptionMetadata');
    MassIndexIndicatorDescriptionMetadata.a = null;
    return MassIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MassIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MassIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            MassIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    MassIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MassIndexIndicatorDescriptionModule, 'MassIndexIndicatorDescriptionModule');
    return MassIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MedianPriceIndicatorDescription = /*@__PURE__*/ (() => {
    class MedianPriceIndicatorDescription extends ItemwiseStrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "MedianPriceIndicator";
        }
    }
    MedianPriceIndicatorDescription.$t = /*@__PURE__*/ markType(MedianPriceIndicatorDescription, 'MedianPriceIndicatorDescription', ItemwiseStrategyBasedIndicatorDescription.$);
    return MedianPriceIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MedianPriceIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MedianPriceIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MedianPriceIndicatorDescriptionMetadata.a == null) {
                MedianPriceIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MedianPriceIndicatorDescriptionMetadata.c(a, MedianPriceIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            MedianPriceIndicatorDescriptionMetadata.b(a);
            a.q("MedianPriceIndicator", () => new MedianPriceIndicatorDescription());
            a.p("MedianPriceIndicator", MedianPriceIndicatorDescriptionMetadata.a);
        }
    }
    MedianPriceIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MedianPriceIndicatorDescriptionMetadata, 'MedianPriceIndicatorDescriptionMetadata');
    MedianPriceIndicatorDescriptionMetadata.a = null;
    return MedianPriceIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MedianPriceIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MedianPriceIndicatorDescriptionModule extends Base {
        static register(a) {
            MedianPriceIndicatorDescriptionMetadata.d(a);
        }
    }
    MedianPriceIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MedianPriceIndicatorDescriptionModule, 'MedianPriceIndicatorDescriptionModule');
    return MedianPriceIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MoneyFlowIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class MoneyFlowIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "MoneyFlowIndexIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    MoneyFlowIndexIndicatorDescription.$t = /*@__PURE__*/ markType(MoneyFlowIndexIndicatorDescription, 'MoneyFlowIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return MoneyFlowIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MoneyFlowIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MoneyFlowIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MoneyFlowIndexIndicatorDescriptionMetadata.a == null) {
                MoneyFlowIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MoneyFlowIndexIndicatorDescriptionMetadata.c(a, MoneyFlowIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            MoneyFlowIndexIndicatorDescriptionMetadata.b(a);
            a.q("MoneyFlowIndexIndicator", () => new MoneyFlowIndexIndicatorDescription());
            a.p("MoneyFlowIndexIndicator", MoneyFlowIndexIndicatorDescriptionMetadata.a);
        }
    }
    MoneyFlowIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MoneyFlowIndexIndicatorDescriptionMetadata, 'MoneyFlowIndexIndicatorDescriptionMetadata');
    MoneyFlowIndexIndicatorDescriptionMetadata.a = null;
    return MoneyFlowIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MoneyFlowIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MoneyFlowIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            MoneyFlowIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    MoneyFlowIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MoneyFlowIndexIndicatorDescriptionModule, 'MoneyFlowIndexIndicatorDescriptionModule');
    return MoneyFlowIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MovingAverageConvergenceDivergenceIndicatorDescription = /*@__PURE__*/ (() => {
    class MovingAverageConvergenceDivergenceIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dw = 0;
            this.dv = 0;
            this.dx = 0;
        }
        get_type() {
            return "MovingAverageConvergenceDivergenceIndicator";
        }
        get shortPeriod() {
            return this.dw;
        }
        set shortPeriod(a) {
            this.dw = a;
            this.e("ShortPeriod");
        }
        get longPeriod() {
            return this.dv;
        }
        set longPeriod(a) {
            this.dv = a;
            this.e("LongPeriod");
        }
        get signalPeriod() {
            return this.dx;
        }
        set signalPeriod(a) {
            this.dx = a;
            this.e("SignalPeriod");
        }
    }
    MovingAverageConvergenceDivergenceIndicatorDescription.$t = /*@__PURE__*/ markType(MovingAverageConvergenceDivergenceIndicatorDescription, 'MovingAverageConvergenceDivergenceIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return MovingAverageConvergenceDivergenceIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a == null) {
                MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.c(a, MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("ShortPeriod", "Number:int");
            b.item("LongPeriod", "Number:int");
            b.item("SignalPeriod", "Number:int");
        }
        static d(a) {
            MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.b(a);
            a.q("MovingAverageConvergenceDivergenceIndicator", () => new MovingAverageConvergenceDivergenceIndicatorDescription());
            a.p("MovingAverageConvergenceDivergenceIndicator", MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a);
        }
    }
    MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata, 'MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata');
    MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.a = null;
    return MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MovingAverageConvergenceDivergenceIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class MovingAverageConvergenceDivergenceIndicatorDescriptionModule extends Base {
        static register(a) {
            MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata.d(a);
        }
    }
    MovingAverageConvergenceDivergenceIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(MovingAverageConvergenceDivergenceIndicatorDescriptionModule, 'MovingAverageConvergenceDivergenceIndicatorDescriptionModule');
    return MovingAverageConvergenceDivergenceIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NegativeVolumeIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class NegativeVolumeIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "NegativeVolumeIndexIndicator";
        }
    }
    NegativeVolumeIndexIndicatorDescription.$t = /*@__PURE__*/ markType(NegativeVolumeIndexIndicatorDescription, 'NegativeVolumeIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return NegativeVolumeIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NegativeVolumeIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class NegativeVolumeIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (NegativeVolumeIndexIndicatorDescriptionMetadata.a == null) {
                NegativeVolumeIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NegativeVolumeIndexIndicatorDescriptionMetadata.c(a, NegativeVolumeIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            NegativeVolumeIndexIndicatorDescriptionMetadata.b(a);
            a.q("NegativeVolumeIndexIndicator", () => new NegativeVolumeIndexIndicatorDescription());
            a.p("NegativeVolumeIndexIndicator", NegativeVolumeIndexIndicatorDescriptionMetadata.a);
        }
    }
    NegativeVolumeIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(NegativeVolumeIndexIndicatorDescriptionMetadata, 'NegativeVolumeIndexIndicatorDescriptionMetadata');
    NegativeVolumeIndexIndicatorDescriptionMetadata.a = null;
    return NegativeVolumeIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NegativeVolumeIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class NegativeVolumeIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            NegativeVolumeIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    NegativeVolumeIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(NegativeVolumeIndexIndicatorDescriptionModule, 'NegativeVolumeIndexIndicatorDescriptionModule');
    return NegativeVolumeIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnBalanceVolumeIndicatorDescription = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "OnBalanceVolumeIndicator";
        }
    }
    OnBalanceVolumeIndicatorDescription.$t = /*@__PURE__*/ markType(OnBalanceVolumeIndicatorDescription, 'OnBalanceVolumeIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return OnBalanceVolumeIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnBalanceVolumeIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (OnBalanceVolumeIndicatorDescriptionMetadata.a == null) {
                OnBalanceVolumeIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnBalanceVolumeIndicatorDescriptionMetadata.c(a, OnBalanceVolumeIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            OnBalanceVolumeIndicatorDescriptionMetadata.b(a);
            a.q("OnBalanceVolumeIndicator", () => new OnBalanceVolumeIndicatorDescription());
            a.p("OnBalanceVolumeIndicator", OnBalanceVolumeIndicatorDescriptionMetadata.a);
        }
    }
    OnBalanceVolumeIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(OnBalanceVolumeIndicatorDescriptionMetadata, 'OnBalanceVolumeIndicatorDescriptionMetadata');
    OnBalanceVolumeIndicatorDescriptionMetadata.a = null;
    return OnBalanceVolumeIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnBalanceVolumeIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class OnBalanceVolumeIndicatorDescriptionModule extends Base {
        static register(a) {
            OnBalanceVolumeIndicatorDescriptionMetadata.d(a);
        }
    }
    OnBalanceVolumeIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(OnBalanceVolumeIndicatorDescriptionModule, 'OnBalanceVolumeIndicatorDescriptionModule');
    return OnBalanceVolumeIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentagePriceOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class PercentagePriceOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dw = 0;
            this.dv = 0;
        }
        get_type() {
            return "PercentagePriceOscillatorIndicator";
        }
        get shortPeriod() {
            return this.dw;
        }
        set shortPeriod(a) {
            this.dw = a;
            this.e("ShortPeriod");
        }
        get longPeriod() {
            return this.dv;
        }
        set longPeriod(a) {
            this.dv = a;
            this.e("LongPeriod");
        }
    }
    PercentagePriceOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(PercentagePriceOscillatorIndicatorDescription, 'PercentagePriceOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PercentagePriceOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentagePriceOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PercentagePriceOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PercentagePriceOscillatorIndicatorDescriptionMetadata.a == null) {
                PercentagePriceOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PercentagePriceOscillatorIndicatorDescriptionMetadata.c(a, PercentagePriceOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("ShortPeriod", "Number:int");
            b.item("LongPeriod", "Number:int");
        }
        static d(a) {
            PercentagePriceOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("PercentagePriceOscillatorIndicator", () => new PercentagePriceOscillatorIndicatorDescription());
            a.p("PercentagePriceOscillatorIndicator", PercentagePriceOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    PercentagePriceOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PercentagePriceOscillatorIndicatorDescriptionMetadata, 'PercentagePriceOscillatorIndicatorDescriptionMetadata');
    PercentagePriceOscillatorIndicatorDescriptionMetadata.a = null;
    return PercentagePriceOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentagePriceOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PercentagePriceOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            PercentagePriceOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    PercentagePriceOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PercentagePriceOscillatorIndicatorDescriptionModule, 'PercentagePriceOscillatorIndicatorDescriptionModule');
    return PercentagePriceOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentageVolumeOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dw = 0;
            this.dv = 0;
        }
        get_type() {
            return "PercentageVolumeOscillatorIndicator";
        }
        get shortPeriod() {
            return this.dw;
        }
        set shortPeriod(a) {
            this.dw = a;
            this.e("ShortPeriod");
        }
        get longPeriod() {
            return this.dv;
        }
        set longPeriod(a) {
            this.dv = a;
            this.e("LongPeriod");
        }
    }
    PercentageVolumeOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(PercentageVolumeOscillatorIndicatorDescription, 'PercentageVolumeOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PercentageVolumeOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentageVolumeOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PercentageVolumeOscillatorIndicatorDescriptionMetadata.a == null) {
                PercentageVolumeOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PercentageVolumeOscillatorIndicatorDescriptionMetadata.c(a, PercentageVolumeOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("ShortPeriod", "Number:int");
            b.item("LongPeriod", "Number:int");
        }
        static d(a) {
            PercentageVolumeOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("PercentageVolumeOscillatorIndicator", () => new PercentageVolumeOscillatorIndicatorDescription());
            a.p("PercentageVolumeOscillatorIndicator", PercentageVolumeOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    PercentageVolumeOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PercentageVolumeOscillatorIndicatorDescriptionMetadata, 'PercentageVolumeOscillatorIndicatorDescriptionMetadata');
    PercentageVolumeOscillatorIndicatorDescriptionMetadata.a = null;
    return PercentageVolumeOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentageVolumeOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PercentageVolumeOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            PercentageVolumeOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    PercentageVolumeOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PercentageVolumeOscillatorIndicatorDescriptionModule, 'PercentageVolumeOscillatorIndicatorDescriptionModule');
    return PercentageVolumeOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PositiveVolumeIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class PositiveVolumeIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PositiveVolumeIndexIndicator";
        }
    }
    PositiveVolumeIndexIndicatorDescription.$t = /*@__PURE__*/ markType(PositiveVolumeIndexIndicatorDescription, 'PositiveVolumeIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PositiveVolumeIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PositiveVolumeIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PositiveVolumeIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PositiveVolumeIndexIndicatorDescriptionMetadata.a == null) {
                PositiveVolumeIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PositiveVolumeIndexIndicatorDescriptionMetadata.c(a, PositiveVolumeIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PositiveVolumeIndexIndicatorDescriptionMetadata.b(a);
            a.q("PositiveVolumeIndexIndicator", () => new PositiveVolumeIndexIndicatorDescription());
            a.p("PositiveVolumeIndexIndicator", PositiveVolumeIndexIndicatorDescriptionMetadata.a);
        }
    }
    PositiveVolumeIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PositiveVolumeIndexIndicatorDescriptionMetadata, 'PositiveVolumeIndexIndicatorDescriptionMetadata');
    PositiveVolumeIndexIndicatorDescriptionMetadata.a = null;
    return PositiveVolumeIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PositiveVolumeIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PositiveVolumeIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            PositiveVolumeIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    PositiveVolumeIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PositiveVolumeIndexIndicatorDescriptionModule, 'PositiveVolumeIndexIndicatorDescriptionModule');
    return PositiveVolumeIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceVolumeTrendIndicatorDescription = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PriceVolumeTrendIndicator";
        }
    }
    PriceVolumeTrendIndicatorDescription.$t = /*@__PURE__*/ markType(PriceVolumeTrendIndicatorDescription, 'PriceVolumeTrendIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return PriceVolumeTrendIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceVolumeTrendIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (PriceVolumeTrendIndicatorDescriptionMetadata.a == null) {
                PriceVolumeTrendIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PriceVolumeTrendIndicatorDescriptionMetadata.c(a, PriceVolumeTrendIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PriceVolumeTrendIndicatorDescriptionMetadata.b(a);
            a.q("PriceVolumeTrendIndicator", () => new PriceVolumeTrendIndicatorDescription());
            a.p("PriceVolumeTrendIndicator", PriceVolumeTrendIndicatorDescriptionMetadata.a);
        }
    }
    PriceVolumeTrendIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(PriceVolumeTrendIndicatorDescriptionMetadata, 'PriceVolumeTrendIndicatorDescriptionMetadata');
    PriceVolumeTrendIndicatorDescriptionMetadata.a = null;
    return PriceVolumeTrendIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceVolumeTrendIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicatorDescriptionModule extends Base {
        static register(a) {
            PriceVolumeTrendIndicatorDescriptionMetadata.d(a);
        }
    }
    PriceVolumeTrendIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(PriceVolumeTrendIndicatorDescriptionModule, 'PriceVolumeTrendIndicatorDescriptionModule');
    return PriceVolumeTrendIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RateOfChangeAndMomentumIndicatorDescription = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "RateOfChangeAndMomentumIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    RateOfChangeAndMomentumIndicatorDescription.$t = /*@__PURE__*/ markType(RateOfChangeAndMomentumIndicatorDescription, 'RateOfChangeAndMomentumIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return RateOfChangeAndMomentumIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RateOfChangeAndMomentumIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (RateOfChangeAndMomentumIndicatorDescriptionMetadata.a == null) {
                RateOfChangeAndMomentumIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RateOfChangeAndMomentumIndicatorDescriptionMetadata.c(a, RateOfChangeAndMomentumIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            RateOfChangeAndMomentumIndicatorDescriptionMetadata.b(a);
            a.q("RateOfChangeAndMomentumIndicator", () => new RateOfChangeAndMomentumIndicatorDescription());
            a.p("RateOfChangeAndMomentumIndicator", RateOfChangeAndMomentumIndicatorDescriptionMetadata.a);
        }
    }
    RateOfChangeAndMomentumIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(RateOfChangeAndMomentumIndicatorDescriptionMetadata, 'RateOfChangeAndMomentumIndicatorDescriptionMetadata');
    RateOfChangeAndMomentumIndicatorDescriptionMetadata.a = null;
    return RateOfChangeAndMomentumIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RateOfChangeAndMomentumIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class RateOfChangeAndMomentumIndicatorDescriptionModule extends Base {
        static register(a) {
            RateOfChangeAndMomentumIndicatorDescriptionMetadata.d(a);
        }
    }
    RateOfChangeAndMomentumIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(RateOfChangeAndMomentumIndicatorDescriptionModule, 'RateOfChangeAndMomentumIndicatorDescriptionModule');
    return RateOfChangeAndMomentumIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RelativeStrengthIndexIndicatorDescription = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "RelativeStrengthIndexIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    RelativeStrengthIndexIndicatorDescription.$t = /*@__PURE__*/ markType(RelativeStrengthIndexIndicatorDescription, 'RelativeStrengthIndexIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return RelativeStrengthIndexIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RelativeStrengthIndexIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (RelativeStrengthIndexIndicatorDescriptionMetadata.a == null) {
                RelativeStrengthIndexIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RelativeStrengthIndexIndicatorDescriptionMetadata.c(a, RelativeStrengthIndexIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            RelativeStrengthIndexIndicatorDescriptionMetadata.b(a);
            a.q("RelativeStrengthIndexIndicator", () => new RelativeStrengthIndexIndicatorDescription());
            a.p("RelativeStrengthIndexIndicator", RelativeStrengthIndexIndicatorDescriptionMetadata.a);
        }
    }
    RelativeStrengthIndexIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(RelativeStrengthIndexIndicatorDescriptionMetadata, 'RelativeStrengthIndexIndicatorDescriptionMetadata');
    RelativeStrengthIndexIndicatorDescriptionMetadata.a = null;
    return RelativeStrengthIndexIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RelativeStrengthIndexIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class RelativeStrengthIndexIndicatorDescriptionModule extends Base {
        static register(a) {
            RelativeStrengthIndexIndicatorDescriptionMetadata.d(a);
        }
    }
    RelativeStrengthIndexIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(RelativeStrengthIndexIndicatorDescriptionModule, 'RelativeStrengthIndexIndicatorDescriptionModule');
    return RelativeStrengthIndexIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SlowStochasticOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class SlowStochasticOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "SlowStochasticOscillatorIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    SlowStochasticOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(SlowStochasticOscillatorIndicatorDescription, 'SlowStochasticOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return SlowStochasticOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SlowStochasticOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class SlowStochasticOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (SlowStochasticOscillatorIndicatorDescriptionMetadata.a == null) {
                SlowStochasticOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SlowStochasticOscillatorIndicatorDescriptionMetadata.c(a, SlowStochasticOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            SlowStochasticOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("SlowStochasticOscillatorIndicator", () => new SlowStochasticOscillatorIndicatorDescription());
            a.p("SlowStochasticOscillatorIndicator", SlowStochasticOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    SlowStochasticOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(SlowStochasticOscillatorIndicatorDescriptionMetadata, 'SlowStochasticOscillatorIndicatorDescriptionMetadata');
    SlowStochasticOscillatorIndicatorDescriptionMetadata.a = null;
    return SlowStochasticOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SlowStochasticOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class SlowStochasticOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            SlowStochasticOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    SlowStochasticOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(SlowStochasticOscillatorIndicatorDescriptionModule, 'SlowStochasticOscillatorIndicatorDescriptionModule');
    return SlowStochasticOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardDeviationIndicatorDescription = /*@__PURE__*/ (() => {
    class StandardDeviationIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "StandardDeviationIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    StandardDeviationIndicatorDescription.$t = /*@__PURE__*/ markType(StandardDeviationIndicatorDescription, 'StandardDeviationIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return StandardDeviationIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardDeviationIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StandardDeviationIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (StandardDeviationIndicatorDescriptionMetadata.a == null) {
                StandardDeviationIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StandardDeviationIndicatorDescriptionMetadata.c(a, StandardDeviationIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            StandardDeviationIndicatorDescriptionMetadata.b(a);
            a.q("StandardDeviationIndicator", () => new StandardDeviationIndicatorDescription());
            a.p("StandardDeviationIndicator", StandardDeviationIndicatorDescriptionMetadata.a);
        }
    }
    StandardDeviationIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(StandardDeviationIndicatorDescriptionMetadata, 'StandardDeviationIndicatorDescriptionMetadata');
    StandardDeviationIndicatorDescriptionMetadata.a = null;
    return StandardDeviationIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StandardDeviationIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class StandardDeviationIndicatorDescriptionModule extends Base {
        static register(a) {
            StandardDeviationIndicatorDescriptionMetadata.d(a);
        }
    }
    StandardDeviationIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(StandardDeviationIndicatorDescriptionModule, 'StandardDeviationIndicatorDescriptionModule');
    return StandardDeviationIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StochRSIIndicatorDescription = /*@__PURE__*/ (() => {
    class StochRSIIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "StochRSIIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    StochRSIIndicatorDescription.$t = /*@__PURE__*/ markType(StochRSIIndicatorDescription, 'StochRSIIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return StochRSIIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StochRSIIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StochRSIIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (StochRSIIndicatorDescriptionMetadata.a == null) {
                StochRSIIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StochRSIIndicatorDescriptionMetadata.c(a, StochRSIIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            StochRSIIndicatorDescriptionMetadata.b(a);
            a.q("StochRSIIndicator", () => new StochRSIIndicatorDescription());
            a.p("StochRSIIndicator", StochRSIIndicatorDescriptionMetadata.a);
        }
    }
    StochRSIIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(StochRSIIndicatorDescriptionMetadata, 'StochRSIIndicatorDescriptionMetadata');
    StochRSIIndicatorDescriptionMetadata.a = null;
    return StochRSIIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StochRSIIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class StochRSIIndicatorDescriptionModule extends Base {
        static register(a) {
            StochRSIIndicatorDescriptionMetadata.d(a);
        }
    }
    StochRSIIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(StochRSIIndicatorDescriptionModule, 'StochRSIIndicatorDescriptionModule');
    return StochRSIIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TRIXIndicatorDescription = /*@__PURE__*/ (() => {
    class TRIXIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "TRIXIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    TRIXIndicatorDescription.$t = /*@__PURE__*/ markType(TRIXIndicatorDescription, 'TRIXIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return TRIXIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TRIXIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class TRIXIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (TRIXIndicatorDescriptionMetadata.a == null) {
                TRIXIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TRIXIndicatorDescriptionMetadata.c(a, TRIXIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            TRIXIndicatorDescriptionMetadata.b(a);
            a.q("TRIXIndicator", () => new TRIXIndicatorDescription());
            a.p("TRIXIndicator", TRIXIndicatorDescriptionMetadata.a);
        }
    }
    TRIXIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(TRIXIndicatorDescriptionMetadata, 'TRIXIndicatorDescriptionMetadata');
    TRIXIndicatorDescriptionMetadata.a = null;
    return TRIXIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TRIXIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class TRIXIndicatorDescriptionModule extends Base {
        static register(a) {
            TRIXIndicatorDescriptionMetadata.d(a);
        }
    }
    TRIXIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(TRIXIndicatorDescriptionModule, 'TRIXIndicatorDescriptionModule');
    return TRIXIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypicalPriceIndicatorDescription = /*@__PURE__*/ (() => {
    class TypicalPriceIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "TypicalPriceIndicator";
        }
    }
    TypicalPriceIndicatorDescription.$t = /*@__PURE__*/ markType(TypicalPriceIndicatorDescription, 'TypicalPriceIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return TypicalPriceIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypicalPriceIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class TypicalPriceIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (TypicalPriceIndicatorDescriptionMetadata.a == null) {
                TypicalPriceIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TypicalPriceIndicatorDescriptionMetadata.c(a, TypicalPriceIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            TypicalPriceIndicatorDescriptionMetadata.b(a);
            a.q("TypicalPriceIndicator", () => new TypicalPriceIndicatorDescription());
            a.p("TypicalPriceIndicator", TypicalPriceIndicatorDescriptionMetadata.a);
        }
    }
    TypicalPriceIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(TypicalPriceIndicatorDescriptionMetadata, 'TypicalPriceIndicatorDescriptionMetadata');
    TypicalPriceIndicatorDescriptionMetadata.a = null;
    return TypicalPriceIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TypicalPriceIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class TypicalPriceIndicatorDescriptionModule extends Base {
        static register(a) {
            TypicalPriceIndicatorDescriptionMetadata.d(a);
        }
    }
    TypicalPriceIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(TypicalPriceIndicatorDescriptionModule, 'TypicalPriceIndicatorDescriptionModule');
    return TypicalPriceIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UltimateOscillatorIndicatorDescription = /*@__PURE__*/ (() => {
    class UltimateOscillatorIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "UltimateOscillatorIndicator";
        }
    }
    UltimateOscillatorIndicatorDescription.$t = /*@__PURE__*/ markType(UltimateOscillatorIndicatorDescription, 'UltimateOscillatorIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return UltimateOscillatorIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UltimateOscillatorIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class UltimateOscillatorIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (UltimateOscillatorIndicatorDescriptionMetadata.a == null) {
                UltimateOscillatorIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                UltimateOscillatorIndicatorDescriptionMetadata.c(a, UltimateOscillatorIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            UltimateOscillatorIndicatorDescriptionMetadata.b(a);
            a.q("UltimateOscillatorIndicator", () => new UltimateOscillatorIndicatorDescription());
            a.p("UltimateOscillatorIndicator", UltimateOscillatorIndicatorDescriptionMetadata.a);
        }
    }
    UltimateOscillatorIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(UltimateOscillatorIndicatorDescriptionMetadata, 'UltimateOscillatorIndicatorDescriptionMetadata');
    UltimateOscillatorIndicatorDescriptionMetadata.a = null;
    return UltimateOscillatorIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UltimateOscillatorIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class UltimateOscillatorIndicatorDescriptionModule extends Base {
        static register(a) {
            UltimateOscillatorIndicatorDescriptionMetadata.d(a);
        }
    }
    UltimateOscillatorIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(UltimateOscillatorIndicatorDescriptionModule, 'UltimateOscillatorIndicatorDescriptionModule');
    return UltimateOscillatorIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeightedCloseIndicatorDescription = /*@__PURE__*/ (() => {
    class WeightedCloseIndicatorDescription extends ItemwiseStrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "WeightedCloseIndicator";
        }
    }
    WeightedCloseIndicatorDescription.$t = /*@__PURE__*/ markType(WeightedCloseIndicatorDescription, 'WeightedCloseIndicatorDescription', ItemwiseStrategyBasedIndicatorDescription.$);
    return WeightedCloseIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeightedCloseIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WeightedCloseIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (WeightedCloseIndicatorDescriptionMetadata.a == null) {
                WeightedCloseIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WeightedCloseIndicatorDescriptionMetadata.c(a, WeightedCloseIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ItemwiseStrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            WeightedCloseIndicatorDescriptionMetadata.b(a);
            a.q("WeightedCloseIndicator", () => new WeightedCloseIndicatorDescription());
            a.p("WeightedCloseIndicator", WeightedCloseIndicatorDescriptionMetadata.a);
        }
    }
    WeightedCloseIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WeightedCloseIndicatorDescriptionMetadata, 'WeightedCloseIndicatorDescriptionMetadata');
    WeightedCloseIndicatorDescriptionMetadata.a = null;
    return WeightedCloseIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WeightedCloseIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class WeightedCloseIndicatorDescriptionModule extends Base {
        static register(a) {
            WeightedCloseIndicatorDescriptionMetadata.d(a);
        }
    }
    WeightedCloseIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(WeightedCloseIndicatorDescriptionModule, 'WeightedCloseIndicatorDescriptionModule');
    return WeightedCloseIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WilliamsPercentRIndicatorDescription = /*@__PURE__*/ (() => {
    class WilliamsPercentRIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
            this.dv = 0;
        }
        get_type() {
            return "WilliamsPercentRIndicator";
        }
        get period() {
            return this.dv;
        }
        set period(a) {
            this.dv = a;
            this.e("Period");
        }
    }
    WilliamsPercentRIndicatorDescription.$t = /*@__PURE__*/ markType(WilliamsPercentRIndicatorDescription, 'WilliamsPercentRIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return WilliamsPercentRIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WilliamsPercentRIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class WilliamsPercentRIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (WilliamsPercentRIndicatorDescriptionMetadata.a == null) {
                WilliamsPercentRIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                WilliamsPercentRIndicatorDescriptionMetadata.c(a, WilliamsPercentRIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            WilliamsPercentRIndicatorDescriptionMetadata.b(a);
            a.q("WilliamsPercentRIndicator", () => new WilliamsPercentRIndicatorDescription());
            a.p("WilliamsPercentRIndicator", WilliamsPercentRIndicatorDescriptionMetadata.a);
        }
    }
    WilliamsPercentRIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(WilliamsPercentRIndicatorDescriptionMetadata, 'WilliamsPercentRIndicatorDescriptionMetadata');
    WilliamsPercentRIndicatorDescriptionMetadata.a = null;
    return WilliamsPercentRIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WilliamsPercentRIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class WilliamsPercentRIndicatorDescriptionModule extends Base {
        static register(a) {
            WilliamsPercentRIndicatorDescriptionMetadata.d(a);
        }
    }
    WilliamsPercentRIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(WilliamsPercentRIndicatorDescriptionModule, 'WilliamsPercentRIndicatorDescriptionModule');
    return WilliamsPercentRIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomIndicatorDescription = /*@__PURE__*/ (() => {
    class CustomIndicatorDescription extends StrategyBasedIndicatorDescription {
        constructor() {
            super();
        }
        get_type() {
            return "CustomIndicator";
        }
    }
    CustomIndicatorDescription.$t = /*@__PURE__*/ markType(CustomIndicatorDescription, 'CustomIndicatorDescription', StrategyBasedIndicatorDescription.$);
    return CustomIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (CustomIndicatorDescriptionMetadata.a == null) {
                CustomIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomIndicatorDescriptionMetadata.c(a, CustomIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StrategyBasedIndicatorDescriptionMetadata.c(a, b);
        }
        static d(a) {
            CustomIndicatorDescriptionMetadata.b(a);
            a.q("CustomIndicator", () => new CustomIndicatorDescription());
            a.p("CustomIndicator", CustomIndicatorDescriptionMetadata.a);
        }
    }
    CustomIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomIndicatorDescriptionMetadata, 'CustomIndicatorDescriptionMetadata');
    CustomIndicatorDescriptionMetadata.a = null;
    return CustomIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomIndicatorDescriptionModule = /*@__PURE__*/ (() => {
    class CustomIndicatorDescriptionModule extends Base {
        static register(a) {
            CustomIndicatorDescriptionMetadata.d(a);
        }
    }
    CustomIndicatorDescriptionModule.$t = /*@__PURE__*/ markType(CustomIndicatorDescriptionModule, 'CustomIndicatorDescriptionModule');
    return CustomIndicatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IndicatorsDescriptionModule = /*@__PURE__*/ (() => {
    class IndicatorsDescriptionModule extends Base {
        static register(a) {
            AbsoluteVolumeOscillatorIndicatorDescriptionModule.register(a);
            AccumulationDistributionIndicatorDescriptionModule.register(a);
            AverageDirectionalIndexIndicatorDescriptionModule.register(a);
            AverageTrueRangeIndicatorDescriptionModule.register(a);
            BollingerBandWidthIndicatorDescriptionModule.register(a);
            ChaikinOscillatorIndicatorDescriptionModule.register(a);
            ChaikinVolatilityIndicatorDescriptionModule.register(a);
            CommodityChannelIndexIndicatorDescriptionModule.register(a);
            DetrendedPriceOscillatorIndicatorDescriptionModule.register(a);
            EaseOfMovementIndicatorDescriptionModule.register(a);
            FastStochasticOscillatorIndicatorDescriptionModule.register(a);
            ForceIndexIndicatorDescriptionModule.register(a);
            FullStochasticOscillatorIndicatorDescriptionModule.register(a);
            MarketFacilitationIndexIndicatorDescriptionModule.register(a);
            MassIndexIndicatorDescriptionModule.register(a);
            MedianPriceIndicatorDescriptionModule.register(a);
            MoneyFlowIndexIndicatorDescriptionModule.register(a);
            MovingAverageConvergenceDivergenceIndicatorDescriptionModule.register(a);
            NegativeVolumeIndexIndicatorDescriptionModule.register(a);
            OnBalanceVolumeIndicatorDescriptionModule.register(a);
            PercentagePriceOscillatorIndicatorDescriptionModule.register(a);
            PercentageVolumeOscillatorIndicatorDescriptionModule.register(a);
            PositiveVolumeIndexIndicatorDescriptionModule.register(a);
            PriceVolumeTrendIndicatorDescriptionModule.register(a);
            RateOfChangeAndMomentumIndicatorDescriptionModule.register(a);
            RelativeStrengthIndexIndicatorDescriptionModule.register(a);
            SlowStochasticOscillatorIndicatorDescriptionModule.register(a);
            StandardDeviationIndicatorDescriptionModule.register(a);
            StochRSIIndicatorDescriptionModule.register(a);
            TRIXIndicatorDescriptionModule.register(a);
            TypicalPriceIndicatorDescriptionModule.register(a);
            UltimateOscillatorIndicatorDescriptionModule.register(a);
            WeightedCloseIndicatorDescriptionModule.register(a);
            WilliamsPercentRIndicatorDescriptionModule.register(a);
            CustomIndicatorDescriptionModule.register(a);
        }
    }
    IndicatorsDescriptionModule.$t = /*@__PURE__*/ markType(IndicatorsDescriptionModule, 'IndicatorsDescriptionModule');
    return IndicatorsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialIndicatorsDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialIndicatorsDescriptionModule extends Base {
        static register(a) {
            IndicatorsDescriptionModule.register(a);
            DataChartFinancialCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialIndicatorsDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialIndicatorsDescriptionModule, 'DataChartFinancialIndicatorsDescriptionModule');
    return DataChartFinancialIndicatorsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialPriceSeriesDescription = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesDescription extends FinancialSeriesDescription {
        constructor() {
            super();
            this.dp = null;
            this.dn = null;
            this.dk = null;
            this.dg = 0;
            this.di = 0;
            this.dl = null;
            this.dm = null;
        }
        get_type() {
            return "FinancialPriceSeries";
        }
        get trendLineType() {
            return this.dp;
        }
        set trendLineType(a) {
            this.dp = a;
            this.e("TrendLineType");
        }
        get trendLineBrush() {
            return this.dn;
        }
        set trendLineBrush(a) {
            this.dn = a;
            this.e("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.dk;
        }
        set actualTrendLineBrush(a) {
            this.dk = a;
            this.e("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.dg;
        }
        set trendLineThickness(a) {
            this.dg = a;
            this.e("TrendLineThickness");
        }
        get trendLinePeriod() {
            return this.di;
        }
        set trendLinePeriod(a) {
            this.di = a;
            this.e("TrendLinePeriod");
        }
        get displayType() {
            return this.dl;
        }
        set displayType(a) {
            this.dl = a;
            this.e("DisplayType");
        }
        get negativeOutline() {
            return this.dm;
        }
        set negativeOutline(a) {
            this.dm = a;
            this.e("NegativeOutline");
        }
    }
    FinancialPriceSeriesDescription.$t = /*@__PURE__*/ markType(FinancialPriceSeriesDescription, 'FinancialPriceSeriesDescription', FinancialSeriesDescription.$);
    return FinancialPriceSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialPriceSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialPriceSeriesDescriptionMetadata.a == null) {
                FinancialPriceSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialPriceSeriesDescriptionMetadata.c(a, FinancialPriceSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FinancialSeriesDescriptionMetadata.c(a, b);
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineBrush", "Brush");
            b.item("ActualTrendLineBrush", "Brush");
            b.item("TrendLineThickness", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
            b.item("DisplayType", "ExportedType:string:PriceDisplayType");
            b.item("DisplayType@names", "Candlestick;OHLC");
            b.item("NegativeOutline", "Brush");
        }
        static d(a) {
            FinancialPriceSeriesDescriptionMetadata.b(a);
            a.q("FinancialPriceSeries", () => new FinancialPriceSeriesDescription());
            a.p("FinancialPriceSeries", FinancialPriceSeriesDescriptionMetadata.a);
        }
    }
    FinancialPriceSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialPriceSeriesDescriptionMetadata, 'FinancialPriceSeriesDescriptionMetadata');
    FinancialPriceSeriesDescriptionMetadata.a = null;
    return FinancialPriceSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialPriceSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesDescriptionModule extends Base {
        static register(a) {
            FinancialPriceSeriesDescriptionMetadata.d(a);
        }
    }
    FinancialPriceSeriesDescriptionModule.$t = /*@__PURE__*/ markType(FinancialPriceSeriesDescriptionModule, 'FinancialPriceSeriesDescriptionModule');
    return FinancialPriceSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialDescriptionModule extends Base {
        static register(a) {
            FinancialPriceSeriesDescriptionModule.register(a);
            DataChartFinancialCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialDescriptionModule, 'DataChartFinancialDescriptionModule');
    return DataChartFinancialDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialOverlayDescriptionMetadata.a == null) {
                FinancialOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialOverlayDescriptionMetadata.c(a, FinancialOverlayDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FinancialSeriesDescriptionMetadata.c(a, b);
            b.item("IgnoreFirst", "Number:int");
        }
        static d(a) {
            FinancialOverlayDescriptionMetadata.b(a);
            a.p("FinancialOverlay", FinancialOverlayDescriptionMetadata.a);
        }
    }
    FinancialOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialOverlayDescriptionMetadata, 'FinancialOverlayDescriptionMetadata');
    FinancialOverlayDescriptionMetadata.a = null;
    return FinancialOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialOverlayDescription = /*@__PURE__*/ (() => {
    class FinancialOverlayDescription extends FinancialSeriesDescription {
        constructor() {
            super();
            this.dg = 0;
        }
        get_type() {
            return "FinancialOverlay";
        }
        get ignoreFirst() {
            return this.dg;
        }
        set ignoreFirst(a) {
            this.dg = a;
            this.e("IgnoreFirst");
        }
    }
    FinancialOverlayDescription.$t = /*@__PURE__*/ markType(FinancialOverlayDescription, 'FinancialOverlayDescription', FinancialSeriesDescription.$);
    return FinancialOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceChannelOverlayDescription = /*@__PURE__*/ (() => {
    class PriceChannelOverlayDescription extends FinancialOverlayDescription {
        constructor() {
            super();
            this.di = 0;
        }
        get_type() {
            return "PriceChannelOverlay";
        }
        get period() {
            return this.di;
        }
        set period(a) {
            this.di = a;
            this.e("Period");
        }
    }
    PriceChannelOverlayDescription.$t = /*@__PURE__*/ markType(PriceChannelOverlayDescription, 'PriceChannelOverlayDescription', FinancialOverlayDescription.$);
    return PriceChannelOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceChannelOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class PriceChannelOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (PriceChannelOverlayDescriptionMetadata.a == null) {
                PriceChannelOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PriceChannelOverlayDescriptionMetadata.c(a, PriceChannelOverlayDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FinancialOverlayDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
        }
        static d(a) {
            PriceChannelOverlayDescriptionMetadata.b(a);
            a.q("PriceChannelOverlay", () => new PriceChannelOverlayDescription());
            a.p("PriceChannelOverlay", PriceChannelOverlayDescriptionMetadata.a);
        }
    }
    PriceChannelOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(PriceChannelOverlayDescriptionMetadata, 'PriceChannelOverlayDescriptionMetadata');
    PriceChannelOverlayDescriptionMetadata.a = null;
    return PriceChannelOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PriceChannelOverlayDescriptionModule = /*@__PURE__*/ (() => {
    class PriceChannelOverlayDescriptionModule extends Base {
        static register(a) {
            PriceChannelOverlayDescriptionMetadata.d(a);
        }
    }
    PriceChannelOverlayDescriptionModule.$t = /*@__PURE__*/ markType(PriceChannelOverlayDescriptionModule, 'PriceChannelOverlayDescriptionModule');
    return PriceChannelOverlayDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandsOverlayDescription = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayDescription extends FinancialOverlayDescription {
        constructor() {
            super();
            this.dk = 0;
            this.di = 0;
        }
        get_type() {
            return "BollingerBandsOverlay";
        }
        get period() {
            return this.dk;
        }
        set period(a) {
            this.dk = a;
            this.e("Period");
        }
        get multiplier() {
            return this.di;
        }
        set multiplier(a) {
            this.di = a;
            this.e("Multiplier");
        }
    }
    BollingerBandsOverlayDescription.$t = /*@__PURE__*/ markType(BollingerBandsOverlayDescription, 'BollingerBandsOverlayDescription', FinancialOverlayDescription.$);
    return BollingerBandsOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandsOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (BollingerBandsOverlayDescriptionMetadata.a == null) {
                BollingerBandsOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BollingerBandsOverlayDescriptionMetadata.c(a, BollingerBandsOverlayDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FinancialOverlayDescriptionMetadata.c(a, b);
            b.item("Period", "Number:int");
            b.item("Multiplier", "Number:double");
        }
        static d(a) {
            BollingerBandsOverlayDescriptionMetadata.b(a);
            a.q("BollingerBandsOverlay", () => new BollingerBandsOverlayDescription());
            a.p("BollingerBandsOverlay", BollingerBandsOverlayDescriptionMetadata.a);
        }
    }
    BollingerBandsOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(BollingerBandsOverlayDescriptionMetadata, 'BollingerBandsOverlayDescriptionMetadata');
    BollingerBandsOverlayDescriptionMetadata.a = null;
    return BollingerBandsOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BollingerBandsOverlayDescriptionModule = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayDescriptionModule extends Base {
        static register(a) {
            BollingerBandsOverlayDescriptionMetadata.d(a);
        }
    }
    BollingerBandsOverlayDescriptionModule.$t = /*@__PURE__*/ markType(BollingerBandsOverlayDescriptionModule, 'BollingerBandsOverlayDescriptionModule');
    return BollingerBandsOverlayDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OverlaysDescriptionModule = /*@__PURE__*/ (() => {
    class OverlaysDescriptionModule extends Base {
        static register(a) {
            PriceChannelOverlayDescriptionModule.register(a);
            BollingerBandsOverlayDescriptionModule.register(a);
        }
    }
    OverlaysDescriptionModule.$t = /*@__PURE__*/ markType(OverlaysDescriptionModule, 'OverlaysDescriptionModule');
    return OverlaysDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartFinancialOverlaysDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartFinancialOverlaysDescriptionModule extends Base {
        static register(a) {
            OverlaysDescriptionModule.register(a);
            DataChartFinancialCoreDescriptionModule.register(a);
        }
    }
    DataChartFinancialOverlaysDescriptionModule.$t = /*@__PURE__*/ markType(DataChartFinancialOverlaysDescriptionModule, 'DataChartFinancialOverlaysDescriptionModule');
    return DataChartFinancialOverlaysDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAngleAxisDescription = /*@__PURE__*/ (() => {
    class NumericAngleAxisDescription extends NumericAxisBaseDescription {
        constructor() {
            super();
            this.d7 = 0;
        }
        get_type() {
            return "NumericAngleAxis";
        }
        get startAngleOffset() {
            return this.d7;
        }
        set startAngleOffset(a) {
            this.d7 = a;
            this.e("StartAngleOffset");
        }
    }
    NumericAngleAxisDescription.$t = /*@__PURE__*/ markType(NumericAngleAxisDescription, 'NumericAngleAxisDescription', NumericAxisBaseDescription.$);
    return NumericAngleAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAngleAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericAngleAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericAngleAxisDescriptionMetadata.a == null) {
                NumericAngleAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericAngleAxisDescriptionMetadata.c(a, NumericAngleAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            NumericAxisBaseDescriptionMetadata.c(a, b);
            b.item("StartAngleOffset", "Number:double");
        }
        static d(a) {
            NumericAngleAxisDescriptionMetadata.b(a);
            a.q("NumericAngleAxis", () => new NumericAngleAxisDescription());
            a.p("NumericAngleAxis", NumericAngleAxisDescriptionMetadata.a);
        }
    }
    NumericAngleAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericAngleAxisDescriptionMetadata, 'NumericAngleAxisDescriptionMetadata');
    NumericAngleAxisDescriptionMetadata.a = null;
    return NumericAngleAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericAngleAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericAngleAxisDescriptionModule extends Base {
        static register(a) {
            NumericAngleAxisDescriptionMetadata.d(a);
        }
    }
    NumericAngleAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericAngleAxisDescriptionModule, 'NumericAngleAxisDescriptionModule');
    return NumericAngleAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericRadiusAxisDescription = /*@__PURE__*/ (() => {
    class NumericRadiusAxisDescription extends NumericAxisBaseDescription {
        constructor() {
            super();
            this.d8 = 0;
            this.d7 = 0;
        }
        get_type() {
            return "NumericRadiusAxis";
        }
        get radiusExtentScale() {
            return this.d8;
        }
        set radiusExtentScale(a) {
            this.d8 = a;
            this.e("RadiusExtentScale");
        }
        get innerRadiusExtentScale() {
            return this.d7;
        }
        set innerRadiusExtentScale(a) {
            this.d7 = a;
            this.e("InnerRadiusExtentScale");
        }
    }
    NumericRadiusAxisDescription.$t = /*@__PURE__*/ markType(NumericRadiusAxisDescription, 'NumericRadiusAxisDescription', NumericAxisBaseDescription.$);
    return NumericRadiusAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericRadiusAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericRadiusAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericRadiusAxisDescriptionMetadata.a == null) {
                NumericRadiusAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericRadiusAxisDescriptionMetadata.c(a, NumericRadiusAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            NumericAxisBaseDescriptionMetadata.c(a, b);
            b.item("RadiusExtentScale", "Number:double");
            b.item("InnerRadiusExtentScale", "Number:double");
        }
        static d(a) {
            NumericRadiusAxisDescriptionMetadata.b(a);
            a.q("NumericRadiusAxis", () => new NumericRadiusAxisDescription());
            a.p("NumericRadiusAxis", NumericRadiusAxisDescriptionMetadata.a);
        }
    }
    NumericRadiusAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericRadiusAxisDescriptionMetadata, 'NumericRadiusAxisDescriptionMetadata');
    NumericRadiusAxisDescriptionMetadata.a = null;
    return NumericRadiusAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericRadiusAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericRadiusAxisDescriptionModule extends Base {
        static register(a) {
            NumericRadiusAxisDescriptionMetadata.d(a);
        }
    }
    NumericRadiusAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericRadiusAxisDescriptionModule, 'NumericRadiusAxisDescriptionModule');
    return NumericRadiusAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartPolarCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartPolarCoreDescriptionModule extends Base {
        static register(a) {
            NumericAngleAxisDescriptionModule.register(a);
            NumericRadiusAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartPolarCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartPolarCoreDescriptionModule, 'DataChartPolarCoreDescriptionModule');
    return DataChartPolarCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarBaseDescriptionMetadata extends Base {
        static b(a) {
            if (PolarBaseDescriptionMetadata.a == null) {
                PolarBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarBaseDescriptionMetadata.c(a, PolarBaseDescriptionMetadata.a);
                AssigningPolarStyleEventArgsDescriptionMetadata.d(a);
                AssigningPolarMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            MarkerSeriesDescriptionMetadata.c(a, b);
            b.item("AngleMemberPath", "String");
            b.item("RadiusMemberPath", "String");
            b.item("AngleAxisRef", "(w:AngleAxis,wf:AngleAxis)DataRef::object");
            b.item("AngleAxisRef@nameBinding", "true");
            b.item("RadiusAxisRef", "(w:RadiusAxis,wf:RadiusAxis)DataRef::object");
            b.item("RadiusAxisRef@nameBinding", "true");
            b.item("UseCartesianInterpolation", "Boolean");
            b.item("MaximumMarkers", "Number:int");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineBrush", "Brush");
            b.item("ActualTrendLineBrush", "Brush");
            b.item("TrendLineThickness", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
            b.item("TrendLineZIndex", "Number:int");
            b.item("ClipSeriesToBounds", "Boolean");
            b.item("ActualItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            b.item("ActualItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            b.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            b.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            b.item("ItemSearchThreshold", "Number:int");
            b.item("IsCustomPolarStyleAllowed", "Boolean");
            b.item("IsCustomPolarMarkerStyleAllowed", "Boolean");
            b.item("AssigningPolarStyleRef", "EventRef::assigningPolarStyle");
            b.item("AssigningPolarMarkerStyleRef", "EventRef::assigningPolarMarkerStyle");
        }
        static d(a) {
            PolarBaseDescriptionMetadata.b(a);
            a.p("PolarBase", PolarBaseDescriptionMetadata.a);
        }
    }
    PolarBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarBaseDescriptionMetadata, 'PolarBaseDescriptionMetadata');
    PolarBaseDescriptionMetadata.a = null;
    return PolarBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarLineSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (PolarLineSeriesBaseDescriptionMetadata.a == null) {
                PolarLineSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarLineSeriesBaseDescriptionMetadata.c(a, PolarLineSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PolarBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PolarLineSeriesBaseDescriptionMetadata.b(a);
            a.p("PolarLineSeriesBase", PolarLineSeriesBaseDescriptionMetadata.a);
        }
    }
    PolarLineSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarLineSeriesBaseDescriptionMetadata, 'PolarLineSeriesBaseDescriptionMetadata');
    PolarLineSeriesBaseDescriptionMetadata.a = null;
    return PolarLineSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarBaseDescription = /*@__PURE__*/ (() => {
    class PolarBaseDescription extends MarkerSeriesDescription {
        constructor() {
            super();
            this.du = null;
            this.dz = null;
            this.dt = null;
            this.dy = null;
            this.db = false;
            this.dj = 0;
            this.d1 = null;
            this.d0 = null;
            this.ds = null;
            this.dg = 0;
            this.dk = 0;
            this.dl = 0;
            this.c8 = false;
            this.dr = null;
            this.dx = null;
            this.di = 0;
            this.da = false;
            this.c9 = false;
            this.dw = null;
            this.dv = null;
        }
        get_type() {
            return "PolarBase";
        }
        get angleMemberPath() {
            return this.du;
        }
        set angleMemberPath(a) {
            this.du = a;
            this.e("AngleMemberPath");
        }
        get radiusMemberPath() {
            return this.dz;
        }
        set radiusMemberPath(a) {
            this.dz = a;
            this.e("RadiusMemberPath");
        }
        get angleAxisRef() {
            return this.dt;
        }
        set angleAxisRef(a) {
            this.dt = a;
            this.e("AngleAxisRef");
        }
        get radiusAxisRef() {
            return this.dy;
        }
        set radiusAxisRef(a) {
            this.dy = a;
            this.e("RadiusAxisRef");
        }
        get useCartesianInterpolation() {
            return this.db;
        }
        set useCartesianInterpolation(a) {
            this.db = a;
            this.e("UseCartesianInterpolation");
        }
        get maximumMarkers() {
            return this.dj;
        }
        set maximumMarkers(a) {
            this.dj = a;
            this.e("MaximumMarkers");
        }
        get trendLineType() {
            return this.d1;
        }
        set trendLineType(a) {
            this.d1 = a;
            this.e("TrendLineType");
        }
        get trendLineBrush() {
            return this.d0;
        }
        set trendLineBrush(a) {
            this.d0 = a;
            this.e("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.ds;
        }
        set actualTrendLineBrush(a) {
            this.ds = a;
            this.e("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.dg;
        }
        set trendLineThickness(a) {
            this.dg = a;
            this.e("TrendLineThickness");
        }
        get trendLinePeriod() {
            return this.dk;
        }
        set trendLinePeriod(a) {
            this.dk = a;
            this.e("TrendLinePeriod");
        }
        get trendLineZIndex() {
            return this.dl;
        }
        set trendLineZIndex(a) {
            this.dl = a;
            this.e("TrendLineZIndex");
        }
        get clipSeriesToBounds() {
            return this.c8;
        }
        set clipSeriesToBounds(a) {
            this.c8 = a;
            this.e("ClipSeriesToBounds");
        }
        get actualItemSearchMode() {
            return this.dr;
        }
        set actualItemSearchMode(a) {
            this.dr = a;
            this.e("ActualItemSearchMode");
        }
        get itemSearchMode() {
            return this.dx;
        }
        set itemSearchMode(a) {
            this.dx = a;
            this.e("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.di;
        }
        set itemSearchThreshold(a) {
            this.di = a;
            this.e("ItemSearchThreshold");
        }
        get isCustomPolarStyleAllowed() {
            return this.da;
        }
        set isCustomPolarStyleAllowed(a) {
            this.da = a;
            this.e("IsCustomPolarStyleAllowed");
        }
        get isCustomPolarMarkerStyleAllowed() {
            return this.c9;
        }
        set isCustomPolarMarkerStyleAllowed(a) {
            this.c9 = a;
            this.e("IsCustomPolarMarkerStyleAllowed");
        }
        get assigningPolarStyleRef() {
            return this.dw;
        }
        set assigningPolarStyleRef(a) {
            this.dw = a;
            this.e("AssigningPolarStyleRef");
        }
        get assigningPolarMarkerStyleRef() {
            return this.dv;
        }
        set assigningPolarMarkerStyleRef(a) {
            this.dv = a;
            this.e("AssigningPolarMarkerStyleRef");
        }
    }
    PolarBaseDescription.$t = /*@__PURE__*/ markType(PolarBaseDescription, 'PolarBaseDescription', MarkerSeriesDescription.$);
    return PolarBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesBaseDescription = /*@__PURE__*/ (() => {
    class PolarLineSeriesBaseDescription extends PolarBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PolarLineSeriesBase";
        }
    }
    PolarLineSeriesBaseDescription.$t = /*@__PURE__*/ markType(PolarLineSeriesBaseDescription, 'PolarLineSeriesBaseDescription', PolarBaseDescription.$);
    return PolarLineSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarAreaSeriesDescription = /*@__PURE__*/ (() => {
    class PolarAreaSeriesDescription extends PolarLineSeriesBaseDescription {
        constructor() {
            super();
            this.ed = null;
        }
        get_type() {
            return "PolarAreaSeries";
        }
        get unknownValuePlotting() {
            return this.ed;
        }
        set unknownValuePlotting(a) {
            this.ed = a;
            this.e("UnknownValuePlotting");
        }
    }
    PolarAreaSeriesDescription.$t = /*@__PURE__*/ markType(PolarAreaSeriesDescription, 'PolarAreaSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarAreaSeriesDescriptionMetadata.a == null) {
                PolarAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarAreaSeriesDescriptionMetadata.c(a, PolarAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PolarLineSeriesBaseDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            PolarAreaSeriesDescriptionMetadata.b(a);
            a.q("PolarAreaSeries", () => new PolarAreaSeriesDescription());
            a.p("PolarAreaSeries", PolarAreaSeriesDescriptionMetadata.a);
        }
    }
    PolarAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarAreaSeriesDescriptionMetadata, 'PolarAreaSeriesDescriptionMetadata');
    PolarAreaSeriesDescriptionMetadata.a = null;
    return PolarAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarAreaSeriesDescriptionModule extends Base {
        static register(a) {
            PolarAreaSeriesDescriptionMetadata.d(a);
        }
    }
    PolarAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarAreaSeriesDescriptionModule, 'PolarAreaSeriesDescriptionModule');
    return PolarAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesDescription = /*@__PURE__*/ (() => {
    class PolarLineSeriesDescription extends PolarLineSeriesBaseDescription {
        constructor() {
            super();
            this.ed = null;
        }
        get_type() {
            return "PolarLineSeries";
        }
        get unknownValuePlotting() {
            return this.ed;
        }
        set unknownValuePlotting(a) {
            this.ed = a;
            this.e("UnknownValuePlotting");
        }
    }
    PolarLineSeriesDescription.$t = /*@__PURE__*/ markType(PolarLineSeriesDescription, 'PolarLineSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarLineSeriesDescriptionMetadata.a == null) {
                PolarLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarLineSeriesDescriptionMetadata.c(a, PolarLineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PolarLineSeriesBaseDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            PolarLineSeriesDescriptionMetadata.b(a);
            a.q("PolarLineSeries", () => new PolarLineSeriesDescription());
            a.p("PolarLineSeries", PolarLineSeriesDescriptionMetadata.a);
        }
    }
    PolarLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarLineSeriesDescriptionMetadata, 'PolarLineSeriesDescriptionMetadata');
    PolarLineSeriesDescriptionMetadata.a = null;
    return PolarLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarLineSeriesDescriptionModule extends Base {
        static register(a) {
            PolarLineSeriesDescriptionMetadata.d(a);
        }
    }
    PolarLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarLineSeriesDescriptionModule, 'PolarLineSeriesDescriptionModule');
    return PolarLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarScatterSeriesDescription = /*@__PURE__*/ (() => {
    class PolarScatterSeriesDescription extends PolarBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PolarScatterSeries";
        }
    }
    PolarScatterSeriesDescription.$t = /*@__PURE__*/ markType(PolarScatterSeriesDescription, 'PolarScatterSeriesDescription', PolarBaseDescription.$);
    return PolarScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarScatterSeriesDescriptionMetadata.a == null) {
                PolarScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarScatterSeriesDescriptionMetadata.c(a, PolarScatterSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PolarBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PolarScatterSeriesDescriptionMetadata.b(a);
            a.q("PolarScatterSeries", () => new PolarScatterSeriesDescription());
            a.p("PolarScatterSeries", PolarScatterSeriesDescriptionMetadata.a);
        }
    }
    PolarScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarScatterSeriesDescriptionMetadata, 'PolarScatterSeriesDescriptionMetadata');
    PolarScatterSeriesDescriptionMetadata.a = null;
    return PolarScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarScatterSeriesDescriptionModule extends Base {
        static register(a) {
            PolarScatterSeriesDescriptionMetadata.d(a);
        }
    }
    PolarScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarScatterSeriesDescriptionModule, 'PolarScatterSeriesDescriptionModule');
    return PolarScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineSeriesDescription = /*@__PURE__*/ (() => {
    class PolarSplineSeriesDescription extends PolarLineSeriesBaseDescription {
        constructor() {
            super();
            this.ed = 0;
        }
        get_type() {
            return "PolarSplineSeries";
        }
        get stiffness() {
            return this.ed;
        }
        set stiffness(a) {
            this.ed = a;
            this.e("Stiffness");
        }
    }
    PolarSplineSeriesDescription.$t = /*@__PURE__*/ markType(PolarSplineSeriesDescription, 'PolarSplineSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarSplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarSplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarSplineSeriesDescriptionMetadata.a == null) {
                PolarSplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarSplineSeriesDescriptionMetadata.c(a, PolarSplineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PolarLineSeriesBaseDescriptionMetadata.c(a, b);
            b.item("Stiffness", "Number:double");
        }
        static d(a) {
            PolarSplineSeriesDescriptionMetadata.b(a);
            a.q("PolarSplineSeries", () => new PolarSplineSeriesDescription());
            a.p("PolarSplineSeries", PolarSplineSeriesDescriptionMetadata.a);
        }
    }
    PolarSplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarSplineSeriesDescriptionMetadata, 'PolarSplineSeriesDescriptionMetadata');
    PolarSplineSeriesDescriptionMetadata.a = null;
    return PolarSplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarSplineSeriesDescriptionModule extends Base {
        static register(a) {
            PolarSplineSeriesDescriptionMetadata.d(a);
        }
    }
    PolarSplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarSplineSeriesDescriptionModule, 'PolarSplineSeriesDescriptionModule');
    return PolarSplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesDescription extends PolarLineSeriesBaseDescription {
        constructor() {
            super();
            this.ed = 0;
        }
        get_type() {
            return "PolarSplineAreaSeries";
        }
        get stiffness() {
            return this.ed;
        }
        set stiffness(a) {
            this.ed = a;
            this.e("Stiffness");
        }
    }
    PolarSplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(PolarSplineAreaSeriesDescription, 'PolarSplineAreaSeriesDescription', PolarLineSeriesBaseDescription.$);
    return PolarSplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (PolarSplineAreaSeriesDescriptionMetadata.a == null) {
                PolarSplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PolarSplineAreaSeriesDescriptionMetadata.c(a, PolarSplineAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PolarLineSeriesBaseDescriptionMetadata.c(a, b);
            b.item("Stiffness", "Number:double");
        }
        static d(a) {
            PolarSplineAreaSeriesDescriptionMetadata.b(a);
            a.q("PolarSplineAreaSeries", () => new PolarSplineAreaSeriesDescription());
            a.p("PolarSplineAreaSeries", PolarSplineAreaSeriesDescriptionMetadata.a);
        }
    }
    PolarSplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(PolarSplineAreaSeriesDescriptionMetadata, 'PolarSplineAreaSeriesDescriptionMetadata');
    PolarSplineAreaSeriesDescriptionMetadata.a = null;
    return PolarSplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolarSplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class PolarSplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            PolarSplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    PolarSplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(PolarSplineAreaSeriesDescriptionModule, 'PolarSplineAreaSeriesDescriptionModule');
    return PolarSplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartPolarDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartPolarDescriptionModule extends Base {
        static register(a) {
            PolarAreaSeriesDescriptionModule.register(a);
            PolarLineSeriesDescriptionModule.register(a);
            PolarScatterSeriesDescriptionModule.register(a);
            PolarSplineSeriesDescriptionModule.register(a);
            PolarSplineAreaSeriesDescriptionModule.register(a);
            DataChartPolarCoreDescriptionModule.register(a);
        }
    }
    DataChartPolarDescriptionModule.$t = /*@__PURE__*/ markType(DataChartPolarDescriptionModule, 'DataChartPolarDescriptionModule');
    return DataChartPolarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAngleAxisDescription = /*@__PURE__*/ (() => {
    class CategoryAngleAxisDescription extends CategoryAxisBaseDescription {
        constructor() {
            super();
            this.dk = 0;
            this.di = 0;
            this.dg = 0;
            this.dj = 0;
            this.dh = 0;
            this.dr = null;
        }
        get_type() {
            return "CategoryAngleAxis";
        }
        get startAngleOffset() {
            return this.dk;
        }
        set startAngleOffset(a) {
            this.dk = a;
            this.e("StartAngleOffset");
        }
        get interval() {
            return this.di;
        }
        set interval(a) {
            this.di = a;
            this.e("Interval");
        }
        get actualInterval() {
            return this.dg;
        }
        set actualInterval(a) {
            this.dg = a;
            this.e("ActualInterval");
        }
        get minorInterval() {
            return this.dj;
        }
        set minorInterval(a) {
            this.dj = a;
            this.e("MinorInterval");
        }
        get actualMinorInterval() {
            return this.dh;
        }
        set actualMinorInterval(a) {
            this.dh = a;
            this.e("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.dr;
        }
        set actualIntervalChangeRef(a) {
            this.dr = a;
            this.e("ActualIntervalChangeRef");
        }
    }
    CategoryAngleAxisDescription.$t = /*@__PURE__*/ markType(CategoryAngleAxisDescription, 'CategoryAngleAxisDescription', CategoryAxisBaseDescription.$);
    return CategoryAngleAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAngleAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryAngleAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryAngleAxisDescriptionMetadata.a == null) {
                CategoryAngleAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryAngleAxisDescriptionMetadata.c(a, CategoryAngleAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategoryAxisBaseDescriptionMetadata.c(a, b);
            b.item("StartAngleOffset", "Number:double");
            b.item("Interval", "Number:double");
            b.item("ActualInterval", "Number:double");
            b.item("MinorInterval", "Number:double");
            b.item("ActualMinorInterval", "Number:double");
            b.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
        }
        static d(a) {
            CategoryAngleAxisDescriptionMetadata.b(a);
            a.q("CategoryAngleAxis", () => new CategoryAngleAxisDescription());
            a.p("CategoryAngleAxis", CategoryAngleAxisDescriptionMetadata.a);
        }
    }
    CategoryAngleAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryAngleAxisDescriptionMetadata, 'CategoryAngleAxisDescriptionMetadata');
    CategoryAngleAxisDescriptionMetadata.a = null;
    return CategoryAngleAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryAngleAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryAngleAxisDescriptionModule extends Base {
        static register(a) {
            CategoryAngleAxisDescriptionMetadata.d(a);
        }
    }
    CategoryAngleAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryAngleAxisDescriptionModule, 'CategoryAngleAxisDescriptionModule');
    return CategoryAngleAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartRadialCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartRadialCoreDescriptionModule extends Base {
        static register(a) {
            CategoryAngleAxisDescriptionModule.register(a);
            NumericRadiusAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartRadialCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartRadialCoreDescriptionModule, 'DataChartRadialCoreDescriptionModule');
    return DataChartRadialCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialBaseDescriptionMetadata extends Base {
        static b(a) {
            if (RadialBaseDescriptionMetadata.a == null) {
                RadialBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialBaseDescriptionMetadata.c(a, RadialBaseDescriptionMetadata.a);
                AssigningRadialStyleEventArgsDescriptionMetadata.d(a);
                AssigningRadialMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            MarkerSeriesDescriptionMetadata.c(a, b);
            b.item("IsCustomRadialStyleAllowed", "Boolean");
            b.item("IsCustomRadialMarkerStyleAllowed", "Boolean");
            b.item("AngleAxisRef", "(w:AngleAxis,wf:AngleAxis)DataRef::object");
            b.item("AngleAxisRef@nameBinding", "true");
            b.item("ValueAxisRef", "(w:ValueAxis,wf:ValueAxis)DataRef::object");
            b.item("ValueAxisRef@nameBinding", "true");
            b.item("ClipSeriesToBounds", "Boolean");
            b.item("AssigningRadialStyleRef", "EventRef::assigningRadialStyle");
            b.item("AssigningRadialMarkerStyleRef", "EventRef::assigningRadialMarkerStyle");
        }
        static d(a) {
            RadialBaseDescriptionMetadata.b(a);
            a.p("RadialBase", RadialBaseDescriptionMetadata.a);
        }
    }
    RadialBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialBaseDescriptionMetadata, 'RadialBaseDescriptionMetadata');
    RadialBaseDescriptionMetadata.a = null;
    return RadialBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredRadialSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (AnchoredRadialSeriesDescriptionMetadata.a == null) {
                AnchoredRadialSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AnchoredRadialSeriesDescriptionMetadata.c(a, AnchoredRadialSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            RadialBaseDescriptionMetadata.c(a, b);
            b.item("ValueMemberPath", "String");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineBrush", "Brush");
            b.item("ActualTrendLineBrush", "Brush");
            b.item("TrendLineThickness", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
            b.item("TrendLineZIndex", "Number:int");
        }
        static d(a) {
            AnchoredRadialSeriesDescriptionMetadata.b(a);
            a.p("AnchoredRadialSeries", AnchoredRadialSeriesDescriptionMetadata.a);
        }
    }
    AnchoredRadialSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesDescriptionMetadata, 'AnchoredRadialSeriesDescriptionMetadata');
    AnchoredRadialSeriesDescriptionMetadata.a = null;
    return AnchoredRadialSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialBaseDescription = /*@__PURE__*/ (() => {
    class RadialBaseDescription extends MarkerSeriesDescription {
        constructor() {
            super();
            this.da = false;
            this.c9 = false;
            this.de = null;
            this.dh = null;
            this.c8 = false;
            this.dg = null;
            this.df = null;
        }
        get_type() {
            return "RadialBase";
        }
        get isCustomRadialStyleAllowed() {
            return this.da;
        }
        set isCustomRadialStyleAllowed(a) {
            this.da = a;
            this.e("IsCustomRadialStyleAllowed");
        }
        get isCustomRadialMarkerStyleAllowed() {
            return this.c9;
        }
        set isCustomRadialMarkerStyleAllowed(a) {
            this.c9 = a;
            this.e("IsCustomRadialMarkerStyleAllowed");
        }
        get angleAxisRef() {
            return this.de;
        }
        set angleAxisRef(a) {
            this.de = a;
            this.e("AngleAxisRef");
        }
        get valueAxisRef() {
            return this.dh;
        }
        set valueAxisRef(a) {
            this.dh = a;
            this.e("ValueAxisRef");
        }
        get clipSeriesToBounds() {
            return this.c8;
        }
        set clipSeriesToBounds(a) {
            this.c8 = a;
            this.e("ClipSeriesToBounds");
        }
        get assigningRadialStyleRef() {
            return this.dg;
        }
        set assigningRadialStyleRef(a) {
            this.dg = a;
            this.e("AssigningRadialStyleRef");
        }
        get assigningRadialMarkerStyleRef() {
            return this.df;
        }
        set assigningRadialMarkerStyleRef(a) {
            this.df = a;
            this.e("AssigningRadialMarkerStyleRef");
        }
    }
    RadialBaseDescription.$t = /*@__PURE__*/ markType(RadialBaseDescription, 'RadialBaseDescription', MarkerSeriesDescription.$);
    return RadialBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchoredRadialSeriesDescription = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesDescription extends RadialBaseDescription {
        constructor() {
            super();
            this.dw = null;
            this.dv = null;
            this.du = null;
            this.dt = null;
            this.dm = 0;
            this.dp = 0;
            this.dq = 0;
        }
        get_type() {
            return "AnchoredRadialSeries";
        }
        get valueMemberPath() {
            return this.dw;
        }
        set valueMemberPath(a) {
            this.dw = a;
            this.e("ValueMemberPath");
        }
        get trendLineType() {
            return this.dv;
        }
        set trendLineType(a) {
            this.dv = a;
            this.e("TrendLineType");
        }
        get trendLineBrush() {
            return this.du;
        }
        set trendLineBrush(a) {
            this.du = a;
            this.e("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.dt;
        }
        set actualTrendLineBrush(a) {
            this.dt = a;
            this.e("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.dm;
        }
        set trendLineThickness(a) {
            this.dm = a;
            this.e("TrendLineThickness");
        }
        get trendLinePeriod() {
            return this.dp;
        }
        set trendLinePeriod(a) {
            this.dp = a;
            this.e("TrendLinePeriod");
        }
        get trendLineZIndex() {
            return this.dq;
        }
        set trendLineZIndex(a) {
            this.dq = a;
            this.e("TrendLineZIndex");
        }
    }
    AnchoredRadialSeriesDescription.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesDescription, 'AnchoredRadialSeriesDescription', RadialBaseDescription.$);
    return AnchoredRadialSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialAreaSeriesDescription = /*@__PURE__*/ (() => {
    class RadialAreaSeriesDescription extends AnchoredRadialSeriesDescription {
        constructor() {
            super();
            this.d1 = null;
        }
        get_type() {
            return "RadialAreaSeries";
        }
        get unknownValuePlotting() {
            return this.d1;
        }
        set unknownValuePlotting(a) {
            this.d1 = a;
            this.e("UnknownValuePlotting");
        }
    }
    RadialAreaSeriesDescription.$t = /*@__PURE__*/ markType(RadialAreaSeriesDescription, 'RadialAreaSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialAreaSeriesDescriptionMetadata.a == null) {
                RadialAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialAreaSeriesDescriptionMetadata.c(a, RadialAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnchoredRadialSeriesDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            RadialAreaSeriesDescriptionMetadata.b(a);
            a.q("RadialAreaSeries", () => new RadialAreaSeriesDescription());
            a.p("RadialAreaSeries", RadialAreaSeriesDescriptionMetadata.a);
        }
    }
    RadialAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialAreaSeriesDescriptionMetadata, 'RadialAreaSeriesDescriptionMetadata');
    RadialAreaSeriesDescriptionMetadata.a = null;
    return RadialAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialAreaSeriesDescriptionModule extends Base {
        static register(a) {
            RadialAreaSeriesDescriptionMetadata.d(a);
        }
    }
    RadialAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialAreaSeriesDescriptionModule, 'RadialAreaSeriesDescriptionModule');
    return RadialAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialColumnSeriesDescription = /*@__PURE__*/ (() => {
    class RadialColumnSeriesDescription extends AnchoredRadialSeriesDescription {
        constructor() {
            super();
            this.d1 = 0;
            this.d2 = 0;
        }
        get_type() {
            return "RadialColumnSeries";
        }
        get radiusX() {
            return this.d1;
        }
        set radiusX(a) {
            this.d1 = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d2;
        }
        set radiusY(a) {
            this.d2 = a;
            this.e("RadiusY");
        }
    }
    RadialColumnSeriesDescription.$t = /*@__PURE__*/ markType(RadialColumnSeriesDescription, 'RadialColumnSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialColumnSeriesDescriptionMetadata.a == null) {
                RadialColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialColumnSeriesDescriptionMetadata.c(a, RadialColumnSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnchoredRadialSeriesDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            RadialColumnSeriesDescriptionMetadata.b(a);
            a.q("RadialColumnSeries", () => new RadialColumnSeriesDescription());
            a.p("RadialColumnSeries", RadialColumnSeriesDescriptionMetadata.a);
        }
    }
    RadialColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialColumnSeriesDescriptionMetadata, 'RadialColumnSeriesDescriptionMetadata');
    RadialColumnSeriesDescriptionMetadata.a = null;
    return RadialColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialColumnSeriesDescriptionModule extends Base {
        static register(a) {
            RadialColumnSeriesDescriptionMetadata.d(a);
        }
    }
    RadialColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialColumnSeriesDescriptionModule, 'RadialColumnSeriesDescriptionModule');
    return RadialColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialLineSeriesDescription = /*@__PURE__*/ (() => {
    class RadialLineSeriesDescription extends AnchoredRadialSeriesDescription {
        constructor() {
            super();
            this.d1 = null;
        }
        get_type() {
            return "RadialLineSeries";
        }
        get unknownValuePlotting() {
            return this.d1;
        }
        set unknownValuePlotting(a) {
            this.d1 = a;
            this.e("UnknownValuePlotting");
        }
    }
    RadialLineSeriesDescription.$t = /*@__PURE__*/ markType(RadialLineSeriesDescription, 'RadialLineSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialLineSeriesDescriptionMetadata.a == null) {
                RadialLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialLineSeriesDescriptionMetadata.c(a, RadialLineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnchoredRadialSeriesDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            RadialLineSeriesDescriptionMetadata.b(a);
            a.q("RadialLineSeries", () => new RadialLineSeriesDescription());
            a.p("RadialLineSeries", RadialLineSeriesDescriptionMetadata.a);
        }
    }
    RadialLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialLineSeriesDescriptionMetadata, 'RadialLineSeriesDescriptionMetadata');
    RadialLineSeriesDescriptionMetadata.a = null;
    return RadialLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialLineSeriesDescriptionModule extends Base {
        static register(a) {
            RadialLineSeriesDescriptionMetadata.d(a);
        }
    }
    RadialLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialLineSeriesDescriptionModule, 'RadialLineSeriesDescriptionModule');
    return RadialLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialPieSeriesDescription = /*@__PURE__*/ (() => {
    class RadialPieSeriesDescription extends AnchoredRadialSeriesDescription {
        constructor() {
            super();
            this.d1 = 0;
            this.d2 = 0;
        }
        get_type() {
            return "RadialPieSeries";
        }
        get radiusX() {
            return this.d1;
        }
        set radiusX(a) {
            this.d1 = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d2;
        }
        set radiusY(a) {
            this.d2 = a;
            this.e("RadiusY");
        }
    }
    RadialPieSeriesDescription.$t = /*@__PURE__*/ markType(RadialPieSeriesDescription, 'RadialPieSeriesDescription', AnchoredRadialSeriesDescription.$);
    return RadialPieSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialPieSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialPieSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RadialPieSeriesDescriptionMetadata.a == null) {
                RadialPieSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialPieSeriesDescriptionMetadata.c(a, RadialPieSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnchoredRadialSeriesDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            RadialPieSeriesDescriptionMetadata.b(a);
            a.q("RadialPieSeries", () => new RadialPieSeriesDescription());
            a.p("RadialPieSeries", RadialPieSeriesDescriptionMetadata.a);
        }
    }
    RadialPieSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialPieSeriesDescriptionMetadata, 'RadialPieSeriesDescriptionMetadata');
    RadialPieSeriesDescriptionMetadata.a = null;
    return RadialPieSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialPieSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RadialPieSeriesDescriptionModule extends Base {
        static register(a) {
            RadialPieSeriesDescriptionMetadata.d(a);
        }
    }
    RadialPieSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RadialPieSeriesDescriptionModule, 'RadialPieSeriesDescriptionModule');
    return RadialPieSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartRadialDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartRadialDescriptionModule extends Base {
        static register(a) {
            RadialAreaSeriesDescriptionModule.register(a);
            RadialColumnSeriesDescriptionModule.register(a);
            RadialLineSeriesDescriptionModule.register(a);
            RadialPieSeriesDescriptionModule.register(a);
            DataChartRadialCoreDescriptionModule.register(a);
        }
    }
    DataChartRadialDescriptionModule.$t = /*@__PURE__*/ markType(DataChartRadialDescriptionModule, 'DataChartRadialDescriptionModule');
    return DataChartRadialDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericXAxisDescription = /*@__PURE__*/ (() => {
    class NumericXAxisDescription extends StraightNumericAxisBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "NumericXAxis";
        }
    }
    NumericXAxisDescription.$t = /*@__PURE__*/ markType(NumericXAxisDescription, 'NumericXAxisDescription', StraightNumericAxisBaseDescription.$);
    return NumericXAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericXAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericXAxisDescriptionMetadata extends Base {
        static b(a) {
            if (NumericXAxisDescriptionMetadata.a == null) {
                NumericXAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericXAxisDescriptionMetadata.c(a, NumericXAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StraightNumericAxisBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            NumericXAxisDescriptionMetadata.b(a);
            a.q("NumericXAxis", () => new NumericXAxisDescription());
            a.p("NumericXAxis", NumericXAxisDescriptionMetadata.a);
        }
    }
    NumericXAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericXAxisDescriptionMetadata, 'NumericXAxisDescriptionMetadata');
    NumericXAxisDescriptionMetadata.a = null;
    return NumericXAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericXAxisDescriptionModule = /*@__PURE__*/ (() => {
    class NumericXAxisDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionMetadata.d(a);
        }
    }
    NumericXAxisDescriptionModule.$t = /*@__PURE__*/ markType(NumericXAxisDescriptionModule, 'NumericXAxisDescriptionModule');
    return NumericXAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartScatterCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartScatterCoreDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartScatterCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartScatterCoreDescriptionModule, 'DataChartScatterCoreDescriptionModule');
    return DataChartScatterCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyUpdatedEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyUpdatedEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "PropertyUpdatedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get propertyName() {
            return this.h;
        }
        set propertyName(a) {
            this.h = a;
            this.e("PropertyName");
        }
        get oldValueRef() {
            return this.g;
        }
        set oldValueRef(a) {
            this.g = a;
            this.e("OldValueRef");
        }
        get newValueRef() {
            return this.f;
        }
        set newValueRef(a) {
            this.f = a;
            this.e("NewValueRef");
        }
    }
    PropertyUpdatedEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyUpdatedEventArgsDescription, 'PropertyUpdatedEventArgsDescription', Description.$);
    return PropertyUpdatedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyUpdatedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyUpdatedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyUpdatedEventArgsDescriptionMetadata.a == null) {
                PropertyUpdatedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyUpdatedEventArgsDescriptionMetadata.c(a, PropertyUpdatedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("PropertyName", "String");
            b.item("OldValueRef", "(w:OldValue,wf:OldValue)DataRef");
            b.item("NewValueRef", "(w:NewValue,wf:NewValue)DataRef");
        }
        static d(a) {
            PropertyUpdatedEventArgsDescriptionMetadata.b(a);
            a.q("PropertyUpdatedEventArgs", () => new PropertyUpdatedEventArgsDescription());
            a.p("PropertyUpdatedEventArgs", PropertyUpdatedEventArgsDescriptionMetadata.a);
        }
    }
    PropertyUpdatedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyUpdatedEventArgsDescriptionMetadata, 'PropertyUpdatedEventArgsDescriptionMetadata');
    PropertyUpdatedEventArgsDescriptionMetadata.a = null;
    return PropertyUpdatedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeScaleDescription = /*@__PURE__*/ (() => {
    class SizeScaleDescription extends Description {
        constructor() {
            super();
            this.i = 0;
            this.h = 0;
            this.k = 0;
            this.j = 0;
            this.f = false;
            this.p = 0;
            this.r = null;
        }
        get_type() {
            return "SizeScale";
        }
        get type() {
            return this.get_type();
        }
        get globalMinimum() {
            return this.i;
        }
        set globalMinimum(a) {
            this.i = a;
            this.e("GlobalMinimum");
        }
        get globalMaximum() {
            return this.h;
        }
        set globalMaximum(a) {
            this.h = a;
            this.e("GlobalMaximum");
        }
        get minimumValue() {
            return this.k;
        }
        set minimumValue(a) {
            this.k = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.j;
        }
        set maximumValue(a) {
            this.j = a;
            this.e("MaximumValue");
        }
        get isLogarithmic() {
            return this.f;
        }
        set isLogarithmic(a) {
            this.f = a;
            this.e("IsLogarithmic");
        }
        get logarithmBase() {
            return this.p;
        }
        set logarithmBase(a) {
            this.p = a;
            this.e("LogarithmBase");
        }
        get propertyUpdatedRef() {
            return this.r;
        }
        set propertyUpdatedRef(a) {
            this.r = a;
            this.e("PropertyUpdatedRef");
        }
    }
    SizeScaleDescription.$t = /*@__PURE__*/ markType(SizeScaleDescription, 'SizeScaleDescription', Description.$);
    return SizeScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class SizeScaleDescriptionMetadata extends Base {
        static b(a) {
            if (SizeScaleDescriptionMetadata.a == null) {
                SizeScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SizeScaleDescriptionMetadata.c(a, SizeScaleDescriptionMetadata.a);
                PropertyUpdatedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("GlobalMinimum", "Number:double");
            b.item("GlobalMaximum", "Number:double");
            b.item("MinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("IsLogarithmic", "Boolean");
            b.item("LogarithmBase", "Number:int");
            b.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            SizeScaleDescriptionMetadata.b(a);
            a.q("SizeScale", () => new SizeScaleDescription());
            a.p("SizeScale", SizeScaleDescriptionMetadata.a);
        }
    }
    SizeScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(SizeScaleDescriptionMetadata, 'SizeScaleDescriptionMetadata');
    SizeScaleDescriptionMetadata.a = null;
    return SizeScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeScaleDescriptionModule = /*@__PURE__*/ (() => {
    class SizeScaleDescriptionModule extends Base {
        static register(a) {
            SizeScaleDescriptionMetadata.d(a);
        }
    }
    SizeScaleDescriptionModule.$t = /*@__PURE__*/ markType(SizeScaleDescriptionModule, 'SizeScaleDescriptionModule');
    return SizeScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushScaleDescription = /*@__PURE__*/ (() => {
    class BrushScaleDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "BrushScale";
        }
        get type() {
            return this.get_type();
        }
        get brushes() {
            return this.f;
        }
        set brushes(a) {
            this.f = a;
            this.e("Brushes");
        }
        get propertyUpdatedRef() {
            return this.h;
        }
        set propertyUpdatedRef(a) {
            this.h = a;
            this.e("PropertyUpdatedRef");
        }
    }
    BrushScaleDescription.$t = /*@__PURE__*/ markType(BrushScaleDescription, 'BrushScaleDescription', Description.$);
    return BrushScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class BrushScaleDescriptionMetadata extends Base {
        static b(a) {
            if (BrushScaleDescriptionMetadata.a == null) {
                BrushScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BrushScaleDescriptionMetadata.c(a, BrushScaleDescriptionMetadata.a);
                PropertyUpdatedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Brushes", "BrushCollection:string");
            b.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            BrushScaleDescriptionMetadata.b(a);
            a.q("BrushScale", () => new BrushScaleDescription());
            a.p("BrushScale", BrushScaleDescriptionMetadata.a);
        }
    }
    BrushScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(BrushScaleDescriptionMetadata, 'BrushScaleDescriptionMetadata');
    BrushScaleDescriptionMetadata.a = null;
    return BrushScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueBrushScaleDescription = /*@__PURE__*/ (() => {
    class ValueBrushScaleDescription extends BrushScaleDescription {
        constructor() {
            super();
            this.n = 0;
            this.m = 0;
            this.k = false;
            this.q = 0;
        }
        get_type() {
            return "ValueBrushScale";
        }
        get minimumValue() {
            return this.n;
        }
        set minimumValue(a) {
            this.n = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.m;
        }
        set maximumValue(a) {
            this.m = a;
            this.e("MaximumValue");
        }
        get isLogarithmic() {
            return this.k;
        }
        set isLogarithmic(a) {
            this.k = a;
            this.e("IsLogarithmic");
        }
        get logarithmBase() {
            return this.q;
        }
        set logarithmBase(a) {
            this.q = a;
            this.e("LogarithmBase");
        }
    }
    ValueBrushScaleDescription.$t = /*@__PURE__*/ markType(ValueBrushScaleDescription, 'ValueBrushScaleDescription', BrushScaleDescription.$);
    return ValueBrushScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueBrushScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class ValueBrushScaleDescriptionMetadata extends Base {
        static b(a) {
            if (ValueBrushScaleDescriptionMetadata.a == null) {
                ValueBrushScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ValueBrushScaleDescriptionMetadata.c(a, ValueBrushScaleDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            BrushScaleDescriptionMetadata.c(a, b);
            b.item("MinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("IsLogarithmic", "Boolean");
            b.item("LogarithmBase", "Number:int");
        }
        static d(a) {
            ValueBrushScaleDescriptionMetadata.b(a);
            a.q("ValueBrushScale", () => new ValueBrushScaleDescription());
            a.p("ValueBrushScale", ValueBrushScaleDescriptionMetadata.a);
        }
    }
    ValueBrushScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(ValueBrushScaleDescriptionMetadata, 'ValueBrushScaleDescriptionMetadata');
    ValueBrushScaleDescriptionMetadata.a = null;
    return ValueBrushScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueBrushScaleDescriptionModule = /*@__PURE__*/ (() => {
    class ValueBrushScaleDescriptionModule extends Base {
        static register(a) {
            ValueBrushScaleDescriptionMetadata.d(a);
        }
    }
    ValueBrushScaleDescriptionModule.$t = /*@__PURE__*/ markType(ValueBrushScaleDescriptionModule, 'ValueBrushScaleDescriptionModule');
    return ValueBrushScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColorScaleDescriptionMetadata extends Base {
        static b(a) {
            if (ColorScaleDescriptionMetadata.a == null) {
                ColorScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColorScaleDescriptionMetadata.c(a, ColorScaleDescriptionMetadata.a);
                PropertyUpdatedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            ColorScaleDescriptionMetadata.b(a);
            a.p("ColorScale", ColorScaleDescriptionMetadata.a);
        }
    }
    ColorScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(ColorScaleDescriptionMetadata, 'ColorScaleDescriptionMetadata');
    ColorScaleDescriptionMetadata.a = null;
    return ColorScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorScaleDescription = /*@__PURE__*/ (() => {
    class ColorScaleDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "ColorScale";
        }
        get type() {
            return this.get_type();
        }
        get propertyUpdatedRef() {
            return this.f;
        }
        set propertyUpdatedRef(a) {
            this.f = a;
            this.e("PropertyUpdatedRef");
        }
    }
    ColorScaleDescription.$t = /*@__PURE__*/ markType(ColorScaleDescription, 'ColorScaleDescription', Description.$);
    return ColorScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteColorScaleDescription = /*@__PURE__*/ (() => {
    class CustomPaletteColorScaleDescription extends ColorScaleDescription {
        constructor() {
            super();
            this.l = 0;
            this.k = 0;
            this.i = null;
            this.o = null;
        }
        get_type() {
            return "CustomPaletteColorScale";
        }
        get minimumValue() {
            return this.l;
        }
        set minimumValue(a) {
            this.l = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.k;
        }
        set maximumValue(a) {
            this.k = a;
            this.e("MaximumValue");
        }
        get palette() {
            return this.i;
        }
        set palette(a) {
            this.i = a;
            this.e("Palette");
        }
        get interpolationMode() {
            return this.o;
        }
        set interpolationMode(a) {
            this.o = a;
            this.e("InterpolationMode");
        }
    }
    CustomPaletteColorScaleDescription.$t = /*@__PURE__*/ markType(CustomPaletteColorScaleDescription, 'CustomPaletteColorScaleDescription', ColorScaleDescription.$);
    return CustomPaletteColorScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteColorScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomPaletteColorScaleDescriptionMetadata extends Base {
        static b(a) {
            if (CustomPaletteColorScaleDescriptionMetadata.a == null) {
                CustomPaletteColorScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomPaletteColorScaleDescriptionMetadata.c(a, CustomPaletteColorScaleDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColorScaleDescriptionMetadata.c(a, b);
            b.item("MinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("Palette", "ColorCollection:string");
            b.item("InterpolationMode", "ExportedType:string:ColorScaleInterpolationMode");
            b.item("InterpolationMode@names", "Select;InterpolateRGB;InterpolateHSV");
        }
        static d(a) {
            CustomPaletteColorScaleDescriptionMetadata.b(a);
            a.q("CustomPaletteColorScale", () => new CustomPaletteColorScaleDescription());
            a.p("CustomPaletteColorScale", CustomPaletteColorScaleDescriptionMetadata.a);
        }
    }
    CustomPaletteColorScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomPaletteColorScaleDescriptionMetadata, 'CustomPaletteColorScaleDescriptionMetadata');
    CustomPaletteColorScaleDescriptionMetadata.a = null;
    return CustomPaletteColorScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteColorScaleDescriptionModule = /*@__PURE__*/ (() => {
    class CustomPaletteColorScaleDescriptionModule extends Base {
        static register(a) {
            CustomPaletteColorScaleDescriptionMetadata.d(a);
        }
    }
    CustomPaletteColorScaleDescriptionModule.$t = /*@__PURE__*/ markType(CustomPaletteColorScaleDescriptionModule, 'CustomPaletteColorScaleDescriptionModule');
    return CustomPaletteColorScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterBaseDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterBaseDescriptionMetadata.a == null) {
                ScatterBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterBaseDescriptionMetadata.c(a, ScatterBaseDescriptionMetadata.a);
                AssigningScatterStyleEventArgsDescriptionMetadata.d(a);
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            MarkerSeriesDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
            b.item("XMemberPath", "String");
            b.item("YMemberPath", "String");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLineBrush", "Brush");
            b.item("ActualTrendLineBrush", "Brush");
            b.item("TrendLineThickness", "Number:double");
            b.item("TrendLinePeriod", "Number:int");
            b.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            b.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            b.item("TrendLineZIndex", "Number:int");
            b.item("MaximumMarkers", "Number:int");
            b.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            b.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            b.item("ItemSearchThreshold", "Number:int");
            b.item("ActualItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            b.item("ActualItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            b.item("IsCustomScatterStyleAllowed", "Boolean");
            b.item("IsCustomScatterMarkerStyleAllowed", "Boolean");
            b.item("AssigningScatterStyleRef", "EventRef::assigningScatterStyle");
            b.item("AssigningScatterMarkerStyleRef", "EventRef::assigningScatterMarkerStyle");
        }
        static d(a) {
            ScatterBaseDescriptionMetadata.b(a);
            a.p("ScatterBase", ScatterBaseDescriptionMetadata.a);
        }
    }
    ScatterBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterBaseDescriptionMetadata, 'ScatterBaseDescriptionMetadata');
    ScatterBaseDescriptionMetadata.a = null;
    return ScatterBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterBaseDescription = /*@__PURE__*/ (() => {
    class ScatterBaseDescription extends MarkerSeriesDescription {
        constructor() {
            super();
            this.dv = null;
            this.dx = null;
            this.dw = null;
            this.dy = null;
            this.du = null;
            this.dt = null;
            this.dn = null;
            this.dc = 0;
            this.dg = 0;
            this.ds = null;
            this.dh = 0;
            this.df = 0;
            this.dr = null;
            this.de = 0;
            this.dm = null;
            this.c9 = false;
            this.c8 = false;
            this.dq = null;
            this.dp = null;
        }
        get_type() {
            return "ScatterBase";
        }
        get xAxisRef() {
            return this.dv;
        }
        set xAxisRef(a) {
            this.dv = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.dx;
        }
        set yAxisRef(a) {
            this.dx = a;
            this.e("YAxisRef");
        }
        get xMemberPath() {
            return this.dw;
        }
        set xMemberPath(a) {
            this.dw = a;
            this.e("XMemberPath");
        }
        get yMemberPath() {
            return this.dy;
        }
        set yMemberPath(a) {
            this.dy = a;
            this.e("YMemberPath");
        }
        get trendLineType() {
            return this.du;
        }
        set trendLineType(a) {
            this.du = a;
            this.e("TrendLineType");
        }
        get trendLineBrush() {
            return this.dt;
        }
        set trendLineBrush(a) {
            this.dt = a;
            this.e("TrendLineBrush");
        }
        get actualTrendLineBrush() {
            return this.dn;
        }
        set actualTrendLineBrush(a) {
            this.dn = a;
            this.e("ActualTrendLineBrush");
        }
        get trendLineThickness() {
            return this.dc;
        }
        set trendLineThickness(a) {
            this.dc = a;
            this.e("TrendLineThickness");
        }
        get trendLinePeriod() {
            return this.dg;
        }
        set trendLinePeriod(a) {
            this.dg = a;
            this.e("TrendLinePeriod");
        }
        get markerCollisionAvoidance() {
            return this.ds;
        }
        set markerCollisionAvoidance(a) {
            this.ds = a;
            this.e("MarkerCollisionAvoidance");
        }
        get trendLineZIndex() {
            return this.dh;
        }
        set trendLineZIndex(a) {
            this.dh = a;
            this.e("TrendLineZIndex");
        }
        get maximumMarkers() {
            return this.df;
        }
        set maximumMarkers(a) {
            this.df = a;
            this.e("MaximumMarkers");
        }
        get itemSearchMode() {
            return this.dr;
        }
        set itemSearchMode(a) {
            this.dr = a;
            this.e("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.de;
        }
        set itemSearchThreshold(a) {
            this.de = a;
            this.e("ItemSearchThreshold");
        }
        get actualItemSearchMode() {
            return this.dm;
        }
        set actualItemSearchMode(a) {
            this.dm = a;
            this.e("ActualItemSearchMode");
        }
        get isCustomScatterStyleAllowed() {
            return this.c9;
        }
        set isCustomScatterStyleAllowed(a) {
            this.c9 = a;
            this.e("IsCustomScatterStyleAllowed");
        }
        get isCustomScatterMarkerStyleAllowed() {
            return this.c8;
        }
        set isCustomScatterMarkerStyleAllowed(a) {
            this.c8 = a;
            this.e("IsCustomScatterMarkerStyleAllowed");
        }
        get assigningScatterStyleRef() {
            return this.dq;
        }
        set assigningScatterStyleRef(a) {
            this.dq = a;
            this.e("AssigningScatterStyleRef");
        }
        get assigningScatterMarkerStyleRef() {
            return this.dp;
        }
        set assigningScatterMarkerStyleRef(a) {
            this.dp = a;
            this.e("AssigningScatterMarkerStyleRef");
        }
    }
    ScatterBaseDescription.$t = /*@__PURE__*/ markType(ScatterBaseDescription, 'ScatterBaseDescription', MarkerSeriesDescription.$);
    return ScatterBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BubbleSeriesDescription = /*@__PURE__*/ (() => {
    class BubbleSeriesDescription extends ScatterBaseDescription {
        constructor() {
            super();
            this.er = null;
            this.ed = null;
            this.eq = null;
            this.ep = null;
            this.eb = null;
            this.ef = false;
            this.eg = false;
            this.em = 0;
            this.el = 0;
            this.eh = false;
        }
        get_type() {
            return "BubbleSeries";
        }
        get radiusMemberPath() {
            return this.er;
        }
        set radiusMemberPath(a) {
            this.er = a;
            this.e("RadiusMemberPath");
        }
        get radiusScale() {
            return this.ed;
        }
        set radiusScale(a) {
            this.ed = a;
            this.e("RadiusScale");
        }
        get labelMemberPath() {
            return this.eq;
        }
        set labelMemberPath(a) {
            this.eq = a;
            this.e("LabelMemberPath");
        }
        get fillMemberPath() {
            return this.ep;
        }
        set fillMemberPath(a) {
            this.ep = a;
            this.e("FillMemberPath");
        }
        get fillScale() {
            return this.eb;
        }
        set fillScale(a) {
            this.eb = a;
            this.e("FillScale");
        }
        get fillScaleUseGlobalValues() {
            return this.ef;
        }
        set fillScaleUseGlobalValues(a) {
            this.ef = a;
            this.e("FillScaleUseGlobalValues");
        }
        get markerOutlineUsesFillScale() {
            return this.eg;
        }
        set markerOutlineUsesFillScale(a) {
            this.eg = a;
            this.e("MarkerOutlineUsesFillScale");
        }
        get markerOutlineBrightness() {
            return this.em;
        }
        set markerOutlineBrightness(a) {
            this.em = a;
            this.e("MarkerOutlineBrightness");
        }
        get markerBrushBrightness() {
            return this.el;
        }
        set markerBrushBrightness(a) {
            this.el = a;
            this.e("MarkerBrushBrightness");
        }
        get radiusScaleUseGlobalValues() {
            return this.eh;
        }
        set radiusScaleUseGlobalValues(a) {
            this.eh = a;
            this.e("RadiusScaleUseGlobalValues");
        }
    }
    BubbleSeriesDescription.$t = /*@__PURE__*/ markType(BubbleSeriesDescription, 'BubbleSeriesDescription', ScatterBaseDescription.$);
    return BubbleSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BubbleSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class BubbleSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (BubbleSeriesDescriptionMetadata.a == null) {
                BubbleSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BubbleSeriesDescriptionMetadata.c(a, BubbleSeriesDescriptionMetadata.a);
                SizeScaleDescriptionMetadata.d(a);
                BrushScaleDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ScatterBaseDescriptionMetadata.c(a, b);
            b.item("RadiusMemberPath", "String");
            b.item("RadiusScale", "ExportedType:SizeScale");
            b.item("LabelMemberPath", "String");
            b.item("FillMemberPath", "String");
            b.item("FillScale", "ExportedType:BrushScale");
            b.item("FillScaleUseGlobalValues", "Boolean");
            b.item("MarkerOutlineUsesFillScale", "Boolean");
            b.item("MarkerOutlineBrightness", "Number:double");
            b.item("MarkerBrushBrightness", "Number:double");
            b.item("RadiusScaleUseGlobalValues", "Boolean");
        }
        static d(a) {
            BubbleSeriesDescriptionMetadata.b(a);
            a.q("BubbleSeries", () => new BubbleSeriesDescription());
            a.p("BubbleSeries", BubbleSeriesDescriptionMetadata.a);
        }
    }
    BubbleSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(BubbleSeriesDescriptionMetadata, 'BubbleSeriesDescriptionMetadata');
    BubbleSeriesDescriptionMetadata.a = null;
    return BubbleSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BubbleSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class BubbleSeriesDescriptionModule extends Base {
        static register(a) {
            BubbleSeriesDescriptionMetadata.d(a);
        }
    }
    BubbleSeriesDescriptionModule.$t = /*@__PURE__*/ markType(BubbleSeriesDescriptionModule, 'BubbleSeriesDescriptionModule');
    return BubbleSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterSeriesDescription extends ScatterBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "ScatterSeries";
        }
    }
    ScatterSeriesDescription.$t = /*@__PURE__*/ markType(ScatterSeriesDescription, 'ScatterSeriesDescription', ScatterBaseDescription.$);
    return ScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterSeriesDescriptionMetadata.a == null) {
                ScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterSeriesDescriptionMetadata.c(a, ScatterSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ScatterBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            ScatterSeriesDescriptionMetadata.b(a);
            a.q("ScatterSeries", () => new ScatterSeriesDescription());
            a.p("ScatterSeries", ScatterSeriesDescriptionMetadata.a);
        }
    }
    ScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterSeriesDescriptionMetadata, 'ScatterSeriesDescriptionMetadata');
    ScatterSeriesDescriptionMetadata.a = null;
    return ScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterSeriesDescriptionModule, 'ScatterSeriesDescriptionModule');
    return ScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterLineSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterLineSeriesDescription extends ScatterBaseDescription {
        constructor() {
            super();
            this.eb = null;
        }
        get_type() {
            return "ScatterLineSeries";
        }
        get unknownValuePlotting() {
            return this.eb;
        }
        set unknownValuePlotting(a) {
            this.eb = a;
            this.e("UnknownValuePlotting");
        }
    }
    ScatterLineSeriesDescription.$t = /*@__PURE__*/ markType(ScatterLineSeriesDescription, 'ScatterLineSeriesDescription', ScatterBaseDescription.$);
    return ScatterLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterLineSeriesDescriptionMetadata.a == null) {
                ScatterLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterLineSeriesDescriptionMetadata.c(a, ScatterLineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ScatterBaseDescriptionMetadata.c(a, b);
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
        }
        static d(a) {
            ScatterLineSeriesDescriptionMetadata.b(a);
            a.q("ScatterLineSeries", () => new ScatterLineSeriesDescription());
            a.p("ScatterLineSeries", ScatterLineSeriesDescriptionMetadata.a);
        }
    }
    ScatterLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterLineSeriesDescriptionMetadata, 'ScatterLineSeriesDescriptionMetadata');
    ScatterLineSeriesDescriptionMetadata.a = null;
    return ScatterLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterLineSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterLineSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterLineSeriesDescriptionModule, 'ScatterLineSeriesDescriptionModule');
    return ScatterLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSplineSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterSplineSeriesDescription extends ScatterBaseDescription {
        constructor() {
            super();
            this.eb = 0;
        }
        get_type() {
            return "ScatterSplineSeries";
        }
        get stiffness() {
            return this.eb;
        }
        set stiffness(a) {
            this.eb = a;
            this.e("Stiffness");
        }
    }
    ScatterSplineSeriesDescription.$t = /*@__PURE__*/ markType(ScatterSplineSeriesDescription, 'ScatterSplineSeriesDescription', ScatterBaseDescription.$);
    return ScatterSplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterSplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterSplineSeriesDescriptionMetadata.a == null) {
                ScatterSplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterSplineSeriesDescriptionMetadata.c(a, ScatterSplineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ScatterBaseDescriptionMetadata.c(a, b);
            b.item("Stiffness", "Number:double");
        }
        static d(a) {
            ScatterSplineSeriesDescriptionMetadata.b(a);
            a.q("ScatterSplineSeries", () => new ScatterSplineSeriesDescription());
            a.p("ScatterSplineSeries", ScatterSplineSeriesDescriptionMetadata.a);
        }
    }
    ScatterSplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterSplineSeriesDescriptionMetadata, 'ScatterSplineSeriesDescriptionMetadata');
    ScatterSplineSeriesDescriptionMetadata.a = null;
    return ScatterSplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterSplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterSplineSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterSplineSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterSplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterSplineSeriesDescriptionModule, 'ScatterSplineSeriesDescriptionModule');
    return ScatterSplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProgressiveLoadStatusEventArgsDescription = /*@__PURE__*/ (() => {
    class ProgressiveLoadStatusEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
        }
        get_type() {
            return "ProgressiveLoadStatusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get currentStatus() {
            return this.f;
        }
        set currentStatus(a) {
            this.f = a;
            this.e("CurrentStatus");
        }
    }
    ProgressiveLoadStatusEventArgsDescription.$t = /*@__PURE__*/ markType(ProgressiveLoadStatusEventArgsDescription, 'ProgressiveLoadStatusEventArgsDescription', Description.$);
    return ProgressiveLoadStatusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ProgressiveLoadStatusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ProgressiveLoadStatusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ProgressiveLoadStatusEventArgsDescriptionMetadata.a == null) {
                ProgressiveLoadStatusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ProgressiveLoadStatusEventArgsDescriptionMetadata.c(a, ProgressiveLoadStatusEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("CurrentStatus", "Number:int");
        }
        static d(a) {
            ProgressiveLoadStatusEventArgsDescriptionMetadata.b(a);
            a.q("ProgressiveLoadStatusEventArgs", () => new ProgressiveLoadStatusEventArgsDescription());
            a.p("ProgressiveLoadStatusEventArgs", ProgressiveLoadStatusEventArgsDescriptionMetadata.a);
        }
    }
    ProgressiveLoadStatusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ProgressiveLoadStatusEventArgsDescriptionMetadata, 'ProgressiveLoadStatusEventArgsDescriptionMetadata');
    ProgressiveLoadStatusEventArgsDescriptionMetadata.a = null;
    return ProgressiveLoadStatusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighDensityScatterSeriesDescription = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescription extends SeriesDescription {
        constructor() {
            super();
            this.c3 = null;
            this.c5 = null;
            this.c4 = null;
            this.c6 = null;
            this.cp = false;
            this.co = false;
            this.ct = 0;
            this.cs = 0;
            this.c1 = null;
            this.c0 = null;
            this.cw = 0;
            this.cx = 0;
            this.c2 = null;
        }
        get_type() {
            return "HighDensityScatterSeries";
        }
        get xAxisRef() {
            return this.c3;
        }
        set xAxisRef(a) {
            this.c3 = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.c5;
        }
        set yAxisRef(a) {
            this.c5 = a;
            this.e("YAxisRef");
        }
        get xMemberPath() {
            return this.c4;
        }
        set xMemberPath(a) {
            this.c4 = a;
            this.e("XMemberPath");
        }
        get yMemberPath() {
            return this.c6;
        }
        set yMemberPath(a) {
            this.c6 = a;
            this.e("YMemberPath");
        }
        get useBruteForce() {
            return this.cp;
        }
        set useBruteForce(a) {
            this.cp = a;
            this.e("UseBruteForce");
        }
        get progressiveLoad() {
            return this.co;
        }
        set progressiveLoad(a) {
            this.co = a;
            this.e("ProgressiveLoad");
        }
        get heatMinimum() {
            return this.ct;
        }
        set heatMinimum(a) {
            this.ct = a;
            this.e("HeatMinimum");
        }
        get heatMaximum() {
            return this.cs;
        }
        set heatMaximum(a) {
            this.cs = a;
            this.e("HeatMaximum");
        }
        get heatMinimumColor() {
            return this.c1;
        }
        set heatMinimumColor(a) {
            this.c1 = a;
            this.e("HeatMinimumColor");
        }
        get heatMaximumColor() {
            return this.c0;
        }
        set heatMaximumColor(a) {
            this.c0 = a;
            this.e("HeatMaximumColor");
        }
        get pointExtent() {
            return this.cw;
        }
        set pointExtent(a) {
            this.cw = a;
            this.e("PointExtent");
        }
        get progressiveStatus() {
            return this.cx;
        }
        set progressiveStatus(a) {
            this.cx = a;
            this.e("ProgressiveStatus");
        }
        get progressiveLoadStatusChangedRef() {
            return this.c2;
        }
        set progressiveLoadStatusChangedRef(a) {
            this.c2 = a;
            this.e("ProgressiveLoadStatusChangedRef");
        }
    }
    HighDensityScatterSeriesDescription.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescription, 'HighDensityScatterSeriesDescription', SeriesDescription.$);
    return HighDensityScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighDensityScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HighDensityScatterSeriesDescriptionMetadata.a == null) {
                HighDensityScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HighDensityScatterSeriesDescriptionMetadata.c(a, HighDensityScatterSeriesDescriptionMetadata.a);
                ProgressiveLoadStatusEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
            b.item("XMemberPath", "String");
            b.item("YMemberPath", "String");
            b.item("UseBruteForce", "Boolean");
            b.item("ProgressiveLoad", "Boolean");
            b.item("HeatMinimum", "Number:double");
            b.item("HeatMaximum", "Number:double");
            b.item("HeatMinimumColor", "Color");
            b.item("HeatMaximumColor", "Color");
            b.item("PointExtent", "Number:int");
            b.item("ProgressiveStatus", "Number:int");
            b.item("ProgressiveLoadStatusChangedRef", "EventRef::progressiveLoadStatusChanged");
        }
        static d(a) {
            HighDensityScatterSeriesDescriptionMetadata.b(a);
            a.q("HighDensityScatterSeries", () => new HighDensityScatterSeriesDescription());
            a.p("HighDensityScatterSeries", HighDensityScatterSeriesDescriptionMetadata.a);
        }
    }
    HighDensityScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescriptionMetadata, 'HighDensityScatterSeriesDescriptionMetadata');
    HighDensityScatterSeriesDescriptionMetadata.a = null;
    return HighDensityScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HighDensityScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesDescriptionModule extends Base {
        static register(a) {
            HighDensityScatterSeriesDescriptionMetadata.d(a);
        }
    }
    HighDensityScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(HighDensityScatterSeriesDescriptionModule, 'HighDensityScatterSeriesDescriptionModule');
    return HighDensityScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartScatterDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartScatterDescriptionModule extends Base {
        static register(a) {
            SizeScaleDescriptionModule.register(a);
            ValueBrushScaleDescriptionModule.register(a);
            CustomPaletteColorScaleDescriptionModule.register(a);
            BubbleSeriesDescriptionModule.register(a);
            ScatterSeriesDescriptionModule.register(a);
            ScatterLineSeriesDescriptionModule.register(a);
            ScatterSplineSeriesDescriptionModule.register(a);
            HighDensityScatterSeriesDescriptionModule.register(a);
            DataChartScatterCoreDescriptionModule.register(a);
        }
    }
    DataChartScatterDescriptionModule.$t = /*@__PURE__*/ markType(DataChartScatterDescriptionModule, 'DataChartScatterDescriptionModule');
    return DataChartScatterDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartShapeCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartShapeCoreDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartShapeCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartShapeCoreDescriptionModule, 'DataChartShapeCoreDescriptionModule');
    return DataChartShapeCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationStatusEventArgsDescription = /*@__PURE__*/ (() => {
    class TriangulationStatusEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
        }
        get_type() {
            return "TriangulationStatusEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get currentStatus() {
            return this.f;
        }
        set currentStatus(a) {
            this.f = a;
            this.e("CurrentStatus");
        }
    }
    TriangulationStatusEventArgsDescription.$t = /*@__PURE__*/ markType(TriangulationStatusEventArgsDescription, 'TriangulationStatusEventArgsDescription', Description.$);
    return TriangulationStatusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationStatusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TriangulationStatusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TriangulationStatusEventArgsDescriptionMetadata.a == null) {
                TriangulationStatusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TriangulationStatusEventArgsDescriptionMetadata.c(a, TriangulationStatusEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("CurrentStatus", "Number:int");
        }
        static d(a) {
            TriangulationStatusEventArgsDescriptionMetadata.b(a);
            a.q("TriangulationStatusEventArgs", () => new TriangulationStatusEventArgsDescription());
            a.p("TriangulationStatusEventArgs", TriangulationStatusEventArgsDescriptionMetadata.a);
        }
    }
    TriangulationStatusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TriangulationStatusEventArgsDescriptionMetadata, 'TriangulationStatusEventArgsDescriptionMetadata');
    TriangulationStatusEventArgsDescriptionMetadata.a = null;
    return TriangulationStatusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterTriangulationSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterTriangulationSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterTriangulationSeriesDescriptionMetadata.a == null) {
                ScatterTriangulationSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterTriangulationSeriesDescriptionMetadata.c(a, ScatterTriangulationSeriesDescriptionMetadata.a);
                TriangulationStatusEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("XMemberPath", "String");
            b.item("YMemberPath", "String");
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
            b.item("TrianglesSourceRef", "(w:TrianglesSource,wf:TrianglesSource)DataRef::object");
            b.item("TriangleVertexMemberPath1", "String");
            b.item("TriangleVertexMemberPath2", "String");
            b.item("TriangleVertexMemberPath3", "String");
            b.item("TriangulationStatusChangedRef", "EventRef::triangulationStatusChanged");
        }
        static d(a) {
            ScatterTriangulationSeriesDescriptionMetadata.b(a);
            a.p("ScatterTriangulationSeries", ScatterTriangulationSeriesDescriptionMetadata.a);
        }
    }
    ScatterTriangulationSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterTriangulationSeriesDescriptionMetadata, 'ScatterTriangulationSeriesDescriptionMetadata');
    ScatterTriangulationSeriesDescriptionMetadata.a = null;
    return ScatterTriangulationSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterTriangulationSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterTriangulationSeriesDescription extends SeriesDescription {
        constructor() {
            super();
            this.cu = null;
            this.cw = null;
            this.ct = null;
            this.cv = null;
            this.co = null;
            this.cp = null;
            this.cq = null;
            this.cr = null;
            this.cs = null;
        }
        get_type() {
            return "ScatterTriangulationSeries";
        }
        get xMemberPath() {
            return this.cu;
        }
        set xMemberPath(a) {
            this.cu = a;
            this.e("XMemberPath");
        }
        get yMemberPath() {
            return this.cw;
        }
        set yMemberPath(a) {
            this.cw = a;
            this.e("YMemberPath");
        }
        get xAxisRef() {
            return this.ct;
        }
        set xAxisRef(a) {
            this.ct = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.cv;
        }
        set yAxisRef(a) {
            this.cv = a;
            this.e("YAxisRef");
        }
        get trianglesSourceRef() {
            return this.co;
        }
        set trianglesSourceRef(a) {
            this.co = a;
            this.e("TrianglesSourceRef");
        }
        get triangleVertexMemberPath1() {
            return this.cp;
        }
        set triangleVertexMemberPath1(a) {
            this.cp = a;
            this.e("TriangleVertexMemberPath1");
        }
        get triangleVertexMemberPath2() {
            return this.cq;
        }
        set triangleVertexMemberPath2(a) {
            this.cq = a;
            this.e("TriangleVertexMemberPath2");
        }
        get triangleVertexMemberPath3() {
            return this.cr;
        }
        set triangleVertexMemberPath3(a) {
            this.cr = a;
            this.e("TriangleVertexMemberPath3");
        }
        get triangulationStatusChangedRef() {
            return this.cs;
        }
        set triangulationStatusChangedRef(a) {
            this.cs = a;
            this.e("TriangulationStatusChangedRef");
        }
    }
    ScatterTriangulationSeriesDescription.$t = /*@__PURE__*/ markType(ScatterTriangulationSeriesDescription, 'ScatterTriangulationSeriesDescription', SeriesDescription.$);
    return ScatterTriangulationSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterAreaSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesDescription extends ScatterTriangulationSeriesDescription {
        constructor() {
            super();
            this.c6 = null;
            this.c8 = null;
        }
        get_type() {
            return "ScatterAreaSeries";
        }
        get colorScale() {
            return this.c6;
        }
        set colorScale(a) {
            this.c6 = a;
            this.e("ColorScale");
        }
        get colorMemberPath() {
            return this.c8;
        }
        set colorMemberPath(a) {
            this.c8 = a;
            this.e("ColorMemberPath");
        }
    }
    ScatterAreaSeriesDescription.$t = /*@__PURE__*/ markType(ScatterAreaSeriesDescription, 'ScatterAreaSeriesDescription', ScatterTriangulationSeriesDescription.$);
    return ScatterAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterAreaSeriesDescriptionMetadata.a == null) {
                ScatterAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterAreaSeriesDescriptionMetadata.c(a, ScatterAreaSeriesDescriptionMetadata.a);
                ColorScaleDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ScatterTriangulationSeriesDescriptionMetadata.c(a, b);
            b.item("ColorScale", "ExportedType:ColorScale");
            b.item("ColorMemberPath", "String");
        }
        static d(a) {
            ScatterAreaSeriesDescriptionMetadata.b(a);
            a.q("ScatterAreaSeries", () => new ScatterAreaSeriesDescription());
            a.p("ScatterAreaSeries", ScatterAreaSeriesDescriptionMetadata.a);
        }
    }
    ScatterAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterAreaSeriesDescriptionMetadata, 'ScatterAreaSeriesDescriptionMetadata');
    ScatterAreaSeriesDescriptionMetadata.a = null;
    return ScatterAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterAreaSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterAreaSeriesDescriptionModule, 'ScatterAreaSeriesDescriptionModule');
    return ScatterAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContourValueResolverDescriptionMetadata = /*@__PURE__*/ (() => {
    class ContourValueResolverDescriptionMetadata extends Base {
        static b(a) {
            if (ContourValueResolverDescriptionMetadata.a == null) {
                ContourValueResolverDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ContourValueResolverDescriptionMetadata.c(a, ContourValueResolverDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ContourValueResolverDescriptionMetadata.b(a);
            a.p("ContourValueResolver", ContourValueResolverDescriptionMetadata.a);
        }
    }
    ContourValueResolverDescriptionMetadata.$t = /*@__PURE__*/ markType(ContourValueResolverDescriptionMetadata, 'ContourValueResolverDescriptionMetadata');
    ContourValueResolverDescriptionMetadata.a = null;
    return ContourValueResolverDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterContourSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterContourSeriesDescription extends ScatterTriangulationSeriesDescription {
        constructor() {
            super();
            this.da = null;
            this.c8 = null;
            this.c6 = null;
        }
        get_type() {
            return "ScatterContourSeries";
        }
        get valueMemberPath() {
            return this.da;
        }
        set valueMemberPath(a) {
            this.da = a;
            this.e("ValueMemberPath");
        }
        get fillScale() {
            return this.c8;
        }
        set fillScale(a) {
            this.c8 = a;
            this.e("FillScale");
        }
        get valueResolver() {
            return this.c6;
        }
        set valueResolver(a) {
            this.c6 = a;
            this.e("ValueResolver");
        }
    }
    ScatterContourSeriesDescription.$t = /*@__PURE__*/ markType(ScatterContourSeriesDescription, 'ScatterContourSeriesDescription', ScatterTriangulationSeriesDescription.$);
    return ScatterContourSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterContourSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterContourSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterContourSeriesDescriptionMetadata.a == null) {
                ScatterContourSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterContourSeriesDescriptionMetadata.c(a, ScatterContourSeriesDescriptionMetadata.a);
                ValueBrushScaleDescriptionMetadata.d(a);
                ContourValueResolverDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ScatterTriangulationSeriesDescriptionMetadata.c(a, b);
            b.item("ValueMemberPath", "String");
            b.item("FillScale", "ExportedType:ValueBrushScale");
            b.item("ValueResolver", "ExportedType:ContourValueResolver");
        }
        static d(a) {
            ScatterContourSeriesDescriptionMetadata.b(a);
            a.q("ScatterContourSeries", () => new ScatterContourSeriesDescription());
            a.p("ScatterContourSeries", ScatterContourSeriesDescriptionMetadata.a);
        }
    }
    ScatterContourSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterContourSeriesDescriptionMetadata, 'ScatterContourSeriesDescriptionMetadata');
    ScatterContourSeriesDescriptionMetadata.a = null;
    return ScatterContourSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterContourSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterContourSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterContourSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterContourSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterContourSeriesDescriptionModule, 'ScatterContourSeriesDescriptionModule');
    return ScatterContourSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleDescription = /*@__PURE__*/ (() => {
    class StyleDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "Style";
        }
        get type() {
            return this.get_type();
        }
    }
    StyleDescription.$t = /*@__PURE__*/ markType(StyleDescription, 'StyleDescription', Description.$);
    return StyleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleDescriptionMetadata = /*@__PURE__*/ (() => {
    class StyleDescriptionMetadata extends Base {
        static b(a) {
            if (StyleDescriptionMetadata.a == null) {
                StyleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StyleDescriptionMetadata.c(a, StyleDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            StyleDescriptionMetadata.b(a);
            a.q("Style", () => new StyleDescription());
            a.p("Style", StyleDescriptionMetadata.a);
        }
    }
    StyleDescriptionMetadata.$t = /*@__PURE__*/ markType(StyleDescriptionMetadata, 'StyleDescriptionMetadata');
    StyleDescriptionMetadata.a = null;
    return StyleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleShapeEventArgsDescription = /*@__PURE__*/ (() => {
    class StyleShapeEventArgsDescription extends Description {
        constructor() {
            super();
            this.j = null;
            this.k = null;
            this.l = null;
            this.g = 0;
            this.f = 0;
        }
        get_type() {
            return "StyleShapeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get itemRef() {
            return this.j;
        }
        set itemRef(a) {
            this.j = a;
            this.e("ItemRef");
        }
        get shapeFill() {
            return this.k;
        }
        set shapeFill(a) {
            this.k = a;
            this.e("ShapeFill");
        }
        get shapeStroke() {
            return this.l;
        }
        set shapeStroke(a) {
            this.l = a;
            this.e("ShapeStroke");
        }
        get shapeStrokeThickness() {
            return this.g;
        }
        set shapeStrokeThickness(a) {
            this.g = a;
            this.e("ShapeStrokeThickness");
        }
        get shapeOpacity() {
            return this.f;
        }
        set shapeOpacity(a) {
            this.f = a;
            this.e("ShapeOpacity");
        }
    }
    StyleShapeEventArgsDescription.$t = /*@__PURE__*/ markType(StyleShapeEventArgsDescription, 'StyleShapeEventArgsDescription', Description.$);
    return StyleShapeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleShapeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StyleShapeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StyleShapeEventArgsDescriptionMetadata.a == null) {
                StyleShapeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StyleShapeEventArgsDescriptionMetadata.c(a, StyleShapeEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("ShapeFill", "(w:ShapeStyle.Fill,wf:ShapeFill)String");
            b.item("ShapeStroke", "(w:ShapeStyle.Stroke,wf:ShapeStroke)String");
            b.item("ShapeStrokeThickness", "(w:ShapeStyle.StrokeThickness,wf:ShapeStrokeThickness)Number:double");
            b.item("ShapeOpacity", "(w:ShapeStyle.Opacity,wf:ShapeOpacity)Number:double");
        }
        static d(a) {
            StyleShapeEventArgsDescriptionMetadata.b(a);
            a.q("StyleShapeEventArgs", () => new StyleShapeEventArgsDescription());
            a.p("StyleShapeEventArgs", StyleShapeEventArgsDescriptionMetadata.a);
        }
    }
    StyleShapeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StyleShapeEventArgsDescriptionMetadata, 'StyleShapeEventArgsDescriptionMetadata');
    StyleShapeEventArgsDescriptionMetadata.a = null;
    return StyleShapeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapeSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (ShapeSeriesBaseDescriptionMetadata.a == null) {
                ShapeSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapeSeriesBaseDescriptionMetadata.c(a, ShapeSeriesBaseDescriptionMetadata.a);
                AssigningShapeStyleEventArgsDescriptionMetadata.d(a);
                AssigningShapeMarkerStyleEventArgsDescriptionMetadata.d(a);
                StyleShapeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("IsCustomShapeStyleAllowed", "Boolean");
            b.item("IsCustomShapeMarkerStyleAllowed", "Boolean");
            b.item("ActualItemSearchMode", "ExportedType:string:ShapeItemSearchMode");
            b.item("ActualItemSearchMode@names", "Auto;ClosestBoundingBox;ClosestShape;ClosestPointOnClosestShape;None");
            b.item("ItemSearchMode", "ExportedType:string:ShapeItemSearchMode");
            b.item("ItemSearchMode@names", "Auto;ClosestBoundingBox;ClosestShape;ClosestPointOnClosestShape;None");
            b.item("ItemSearchThreshold", "Number:int");
            b.item("ItemSearchPointsThreshold", "Number:int");
            b.item("ShapeMemberPath", "String");
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
            b.item("ShapeFilterResolution", "Number:double");
            b.item("AssigningShapeStyleRef", "EventRef::assigningShapeStyle");
            b.item("AssigningShapeMarkerStyleRef", "EventRef::assigningShapeMarkerStyle");
            b.item("StyleShapeRef", "EventRef::styleShape");
        }
        static d(a) {
            ShapeSeriesBaseDescriptionMetadata.b(a);
            a.p("ShapeSeriesBase", ShapeSeriesBaseDescriptionMetadata.a);
        }
    }
    ShapeSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapeSeriesBaseDescriptionMetadata, 'ShapeSeriesBaseDescriptionMetadata');
    ShapeSeriesBaseDescriptionMetadata.a = null;
    return ShapeSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeSeriesBaseDescription = /*@__PURE__*/ (() => {
    class ShapeSeriesBaseDescription extends SeriesDescription {
        constructor() {
            super();
            this.cp = false;
            this.co = false;
            this.cy = null;
            this.c1 = null;
            this.cv = 0;
            this.cu = 0;
            this.c2 = null;
            this.c4 = null;
            this.c5 = null;
            this.cs = 0;
            this.c0 = null;
            this.cz = null;
            this.c3 = null;
        }
        get_type() {
            return "ShapeSeriesBase";
        }
        get isCustomShapeStyleAllowed() {
            return this.cp;
        }
        set isCustomShapeStyleAllowed(a) {
            this.cp = a;
            this.e("IsCustomShapeStyleAllowed");
        }
        get isCustomShapeMarkerStyleAllowed() {
            return this.co;
        }
        set isCustomShapeMarkerStyleAllowed(a) {
            this.co = a;
            this.e("IsCustomShapeMarkerStyleAllowed");
        }
        get actualItemSearchMode() {
            return this.cy;
        }
        set actualItemSearchMode(a) {
            this.cy = a;
            this.e("ActualItemSearchMode");
        }
        get itemSearchMode() {
            return this.c1;
        }
        set itemSearchMode(a) {
            this.c1 = a;
            this.e("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.cv;
        }
        set itemSearchThreshold(a) {
            this.cv = a;
            this.e("ItemSearchThreshold");
        }
        get itemSearchPointsThreshold() {
            return this.cu;
        }
        set itemSearchPointsThreshold(a) {
            this.cu = a;
            this.e("ItemSearchPointsThreshold");
        }
        get shapeMemberPath() {
            return this.c2;
        }
        set shapeMemberPath(a) {
            this.c2 = a;
            this.e("ShapeMemberPath");
        }
        get xAxisRef() {
            return this.c4;
        }
        set xAxisRef(a) {
            this.c4 = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.c5;
        }
        set yAxisRef(a) {
            this.c5 = a;
            this.e("YAxisRef");
        }
        get shapeFilterResolution() {
            return this.cs;
        }
        set shapeFilterResolution(a) {
            this.cs = a;
            this.e("ShapeFilterResolution");
        }
        get assigningShapeStyleRef() {
            return this.c0;
        }
        set assigningShapeStyleRef(a) {
            this.c0 = a;
            this.e("AssigningShapeStyleRef");
        }
        get assigningShapeMarkerStyleRef() {
            return this.cz;
        }
        set assigningShapeMarkerStyleRef(a) {
            this.cz = a;
            this.e("AssigningShapeMarkerStyleRef");
        }
        get styleShapeRef() {
            return this.c3;
        }
        set styleShapeRef(a) {
            this.c3 = a;
            this.e("StyleShapeRef");
        }
    }
    ShapeSeriesBaseDescription.$t = /*@__PURE__*/ markType(ShapeSeriesBaseDescription, 'ShapeSeriesBaseDescription', SeriesDescription.$);
    return ShapeSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolygonSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesDescription extends ShapeSeriesBaseDescription {
        constructor() {
            super();
            this.de = null;
            this.ds = null;
            this.dr = null;
            this.dg = 0;
            this.dk = null;
            this.dl = null;
            this.di = null;
            this.dp = null;
            this.dj = null;
            this.dm = null;
            this.dq = null;
            this.dn = null;
        }
        get_type() {
            return "ScatterPolygonSeries";
        }
        get shapeStyle() {
            return this.de;
        }
        set shapeStyle(a) {
            this.de = a;
            this.e("ShapeStyle");
        }
        get markerType() {
            return this.ds;
        }
        set markerType(a) {
            this.ds = a;
            this.e("MarkerType");
        }
        get markerTemplateRef() {
            return this.dr;
        }
        set markerTemplateRef(a) {
            this.dr = a;
            this.e("MarkerTemplateRef");
        }
        get markerThickness() {
            return this.dg;
        }
        set markerThickness(a) {
            this.dg = a;
            this.e("MarkerThickness");
        }
        get actualMarkerTemplateRef() {
            return this.dk;
        }
        set actualMarkerTemplateRef(a) {
            this.dk = a;
            this.e("ActualMarkerTemplateRef");
        }
        get markerBrush() {
            return this.dl;
        }
        set markerBrush(a) {
            this.dl = a;
            this.e("MarkerBrush");
        }
        get actualMarkerBrush() {
            return this.di;
        }
        set actualMarkerBrush(a) {
            this.di = a;
            this.e("ActualMarkerBrush");
        }
        get markerOutline() {
            return this.dp;
        }
        set markerOutline(a) {
            this.dp = a;
            this.e("MarkerOutline");
        }
        get actualMarkerOutline() {
            return this.dj;
        }
        set actualMarkerOutline(a) {
            this.dj = a;
            this.e("ActualMarkerOutline");
        }
        get markerCollisionAvoidance() {
            return this.dm;
        }
        set markerCollisionAvoidance(a) {
            this.dm = a;
            this.e("MarkerCollisionAvoidance");
        }
        get markerOutlineMode() {
            return this.dq;
        }
        set markerOutlineMode(a) {
            this.dq = a;
            this.e("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.dn;
        }
        set markerFillMode(a) {
            this.dn = a;
            this.e("MarkerFillMode");
        }
    }
    ScatterPolygonSeriesDescription.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesDescription, 'ScatterPolygonSeriesDescription', ShapeSeriesBaseDescription.$);
    return ScatterPolygonSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolygonSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterPolygonSeriesDescriptionMetadata.a == null) {
                ScatterPolygonSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterPolygonSeriesDescriptionMetadata.c(a, ScatterPolygonSeriesDescriptionMetadata.a);
                StyleDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ShapeSeriesBaseDescriptionMetadata.c(a, b);
            b.item("ShapeStyle", "ExportedType:Style");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("MarkerThickness", "Number:double");
            b.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            b.item("MarkerBrush", "Brush");
            b.item("ActualMarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("ActualMarkerOutline", "Brush");
            b.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            b.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            b.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            b.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            b.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            b.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
        }
        static d(a) {
            ScatterPolygonSeriesDescriptionMetadata.b(a);
            a.q("ScatterPolygonSeries", () => new ScatterPolygonSeriesDescription());
            a.p("ScatterPolygonSeries", ScatterPolygonSeriesDescriptionMetadata.a);
        }
    }
    ScatterPolygonSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesDescriptionMetadata, 'ScatterPolygonSeriesDescriptionMetadata');
    ScatterPolygonSeriesDescriptionMetadata.a = null;
    return ScatterPolygonSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolygonSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterPolygonSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterPolygonSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesDescriptionModule, 'ScatterPolygonSeriesDescriptionModule');
    return ScatterPolygonSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolylineSeriesDescription = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesDescription extends ShapeSeriesBaseDescription {
        constructor() {
            super();
            this.de = null;
        }
        get_type() {
            return "ScatterPolylineSeries";
        }
        get shapeStyle() {
            return this.de;
        }
        set shapeStyle(a) {
            this.de = a;
            this.e("ShapeStyle");
        }
    }
    ScatterPolylineSeriesDescription.$t = /*@__PURE__*/ markType(ScatterPolylineSeriesDescription, 'ScatterPolylineSeriesDescription', ShapeSeriesBaseDescription.$);
    return ScatterPolylineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolylineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (ScatterPolylineSeriesDescriptionMetadata.a == null) {
                ScatterPolylineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScatterPolylineSeriesDescriptionMetadata.c(a, ScatterPolylineSeriesDescriptionMetadata.a);
                StyleDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ShapeSeriesBaseDescriptionMetadata.c(a, b);
            b.item("ShapeStyle", "ExportedType:Style");
        }
        static d(a) {
            ScatterPolylineSeriesDescriptionMetadata.b(a);
            a.q("ScatterPolylineSeries", () => new ScatterPolylineSeriesDescription());
            a.p("ScatterPolylineSeries", ScatterPolylineSeriesDescriptionMetadata.a);
        }
    }
    ScatterPolylineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(ScatterPolylineSeriesDescriptionMetadata, 'ScatterPolylineSeriesDescriptionMetadata');
    ScatterPolylineSeriesDescriptionMetadata.a = null;
    return ScatterPolylineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScatterPolylineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesDescriptionModule extends Base {
        static register(a) {
            ScatterPolylineSeriesDescriptionMetadata.d(a);
        }
    }
    ScatterPolylineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(ScatterPolylineSeriesDescriptionModule, 'ScatterPolylineSeriesDescriptionModule');
    return ScatterPolylineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartShapeDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartShapeDescriptionModule extends Base {
        static register(a) {
            ScatterAreaSeriesDescriptionModule.register(a);
            ScatterContourSeriesDescriptionModule.register(a);
            ScatterPolygonSeriesDescriptionModule.register(a);
            ScatterPolylineSeriesDescriptionModule.register(a);
            DataChartShapeCoreDescriptionModule.register(a);
        }
    }
    DataChartShapeDescriptionModule.$t = /*@__PURE__*/ markType(DataChartShapeDescriptionModule, 'DataChartShapeDescriptionModule');
    return DataChartShapeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedFragmentSeriesDescription = /*@__PURE__*/ (() => {
    class StackedFragmentSeriesDescription extends Description {
        constructor() {
            super();
            this.bi = null;
            this.bh = null;
            this.a5 = null;
            this.h = false;
            this.f = false;
            this.af = 0;
            this.u = 0;
            this.bv = null;
            this.bf = null;
            this.i = false;
            this.g = false;
            this.ag = 0;
            this.v = 0;
            this.ah = 0;
            this.w = 0;
            this.bj = null;
            this.a6 = null;
            this.bk = null;
            this.a7 = null;
            this.bl = null;
            this.a8 = null;
            this.bm = null;
            this.a9 = null;
            this.bn = null;
            this.ba = null;
            this.bo = null;
            this.bb = null;
            this.bp = null;
            this.bc = null;
            this.bq = null;
            this.ac = 0;
            this.r = 0;
            this.br = null;
            this.bd = null;
            this.y = 0;
            this.n = 0;
            this.aa = 0;
            this.p = 0;
            this.bs = null;
            this.be = null;
            this.z = 0;
            this.o = 0;
            this.ad = 0;
            this.s = 0;
            this.ae = 0;
            this.t = 0;
            this.ai = 0;
            this.x = 0;
            this.ab = 0;
            this.q = 0;
            this.bw = null;
            this.bx = null;
            this.by = null;
            this.bg = null;
            this.bt = null;
            this.bu = null;
        }
        get_type() {
            return "StackedFragmentSeries";
        }
        get type() {
            return this.get_type();
        }
        get dataSourceRef() {
            return this.bi;
        }
        set dataSourceRef(a) {
            this.bi = a;
            this.e("DataSourceRef");
        }
        get brush() {
            return this.bh;
        }
        set brush(a) {
            this.bh = a;
            this.e("Brush");
        }
        get actualBrush() {
            return this.a5;
        }
        set actualBrush(a) {
            this.a5 = a;
            this.e("ActualBrush");
        }
        get isDropShadowEnabled() {
            return this.h;
        }
        set isDropShadowEnabled(a) {
            this.h = a;
            this.e("IsDropShadowEnabled");
        }
        get actualIsDropShadowEnabled() {
            return this.f;
        }
        set actualIsDropShadowEnabled(a) {
            this.f = a;
            this.e("ActualIsDropShadowEnabled");
        }
        get shadowBlur() {
            return this.af;
        }
        set shadowBlur(a) {
            this.af = a;
            this.e("ShadowBlur");
        }
        get actualShadowBlur() {
            return this.u;
        }
        set actualShadowBlur(a) {
            this.u = a;
            this.e("ActualShadowBlur");
        }
        get shadowColor() {
            return this.bv;
        }
        set shadowColor(a) {
            this.bv = a;
            this.e("ShadowColor");
        }
        get actualShadowColor() {
            return this.bf;
        }
        set actualShadowColor(a) {
            this.bf = a;
            this.e("ActualShadowColor");
        }
        get useSingleShadow() {
            return this.i;
        }
        set useSingleShadow(a) {
            this.i = a;
            this.e("UseSingleShadow");
        }
        get actualUseSingleShadow() {
            return this.g;
        }
        set actualUseSingleShadow(a) {
            this.g = a;
            this.e("ActualUseSingleShadow");
        }
        get shadowOffsetX() {
            return this.ag;
        }
        set shadowOffsetX(a) {
            this.ag = a;
            this.e("ShadowOffsetX");
        }
        get actualShadowOffsetX() {
            return this.v;
        }
        set actualShadowOffsetX(a) {
            this.v = a;
            this.e("ActualShadowOffsetX");
        }
        get shadowOffsetY() {
            return this.ah;
        }
        set shadowOffsetY(a) {
            this.ah = a;
            this.e("ShadowOffsetY");
        }
        get actualShadowOffsetY() {
            return this.w;
        }
        set actualShadowOffsetY(a) {
            this.w = a;
            this.e("ActualShadowOffsetY");
        }
        get legendItemBadgeTemplateRef() {
            return this.bj;
        }
        set legendItemBadgeTemplateRef(a) {
            this.bj = a;
            this.e("LegendItemBadgeTemplateRef");
        }
        get actualLegendItemBadgeTemplateRef() {
            return this.a6;
        }
        set actualLegendItemBadgeTemplateRef(a) {
            this.a6 = a;
            this.e("ActualLegendItemBadgeTemplateRef");
        }
        get legendItemTemplateRef() {
            return this.bk;
        }
        set legendItemTemplateRef(a) {
            this.bk = a;
            this.e("LegendItemTemplateRef");
        }
        get actualLegendItemTemplateRef() {
            return this.a7;
        }
        set actualLegendItemTemplateRef(a) {
            this.a7 = a;
            this.e("ActualLegendItemTemplateRef");
        }
        get legendItemVisibility() {
            return this.bl;
        }
        set legendItemVisibility(a) {
            this.bl = a;
            this.e("LegendItemVisibility");
        }
        get actualLegendItemVisibility() {
            return this.a8;
        }
        set actualLegendItemVisibility(a) {
            this.a8 = a;
            this.e("ActualLegendItemVisibility");
        }
        get markerBrush() {
            return this.bm;
        }
        set markerBrush(a) {
            this.bm = a;
            this.e("MarkerBrush");
        }
        get actualMarkerBrush() {
            return this.a9;
        }
        set actualMarkerBrush(a) {
            this.a9 = a;
            this.e("ActualMarkerBrush");
        }
        get markerOutline() {
            return this.bn;
        }
        set markerOutline(a) {
            this.bn = a;
            this.e("MarkerOutline");
        }
        get actualMarkerOutline() {
            return this.ba;
        }
        set actualMarkerOutline(a) {
            this.ba = a;
            this.e("ActualMarkerOutline");
        }
        get markerTemplateRef() {
            return this.bo;
        }
        set markerTemplateRef(a) {
            this.bo = a;
            this.e("MarkerTemplateRef");
        }
        get actualMarkerTemplateRef() {
            return this.bb;
        }
        set actualMarkerTemplateRef(a) {
            this.bb = a;
            this.e("ActualMarkerTemplateRef");
        }
        get markerType() {
            return this.bp;
        }
        set markerType(a) {
            this.bp = a;
            this.e("MarkerType");
        }
        get actualMarkerType() {
            return this.bc;
        }
        set actualMarkerType(a) {
            this.bc = a;
            this.e("ActualMarkerType");
        }
        get name() {
            return this.bq;
        }
        set name(a) {
            this.bq = a;
            this.e("Name");
        }
        get opacity() {
            return this.ac;
        }
        set opacity(a) {
            this.ac = a;
            this.e("Opacity");
        }
        get actualOpacity() {
            return this.r;
        }
        set actualOpacity(a) {
            this.r = a;
            this.e("ActualOpacity");
        }
        get outline() {
            return this.br;
        }
        set outline(a) {
            this.br = a;
            this.e("Outline");
        }
        get actualOutline() {
            return this.bd;
        }
        set actualOutline(a) {
            this.bd = a;
            this.e("ActualOutline");
        }
        get areaFillOpacity() {
            return this.y;
        }
        set areaFillOpacity(a) {
            this.y = a;
            this.e("AreaFillOpacity");
        }
        get actualAreaFillOpacity() {
            return this.n;
        }
        set actualAreaFillOpacity(a) {
            this.n = a;
            this.e("ActualAreaFillOpacity");
        }
        get markerFillOpacity() {
            return this.aa;
        }
        set markerFillOpacity(a) {
            this.aa = a;
            this.e("MarkerFillOpacity");
        }
        get actualMarkerFillOpacity() {
            return this.p;
        }
        set actualMarkerFillOpacity(a) {
            this.p = a;
            this.e("ActualMarkerFillOpacity");
        }
        get outlineMode() {
            return this.bs;
        }
        set outlineMode(a) {
            this.bs = a;
            this.e("OutlineMode");
        }
        get actualOutlineMode() {
            return this.be;
        }
        set actualOutlineMode(a) {
            this.be = a;
            this.e("ActualOutlineMode");
        }
        get highlightingFadeOpacity() {
            return this.z;
        }
        set highlightingFadeOpacity(a) {
            this.z = a;
            this.e("HighlightingFadeOpacity");
        }
        get actualHighlightingFadeOpacity() {
            return this.o;
        }
        set actualHighlightingFadeOpacity(a) {
            this.o = a;
            this.e("ActualHighlightingFadeOpacity");
        }
        get radiusX() {
            return this.ad;
        }
        set radiusX(a) {
            this.ad = a;
            this.e("RadiusX");
        }
        get actualRadiusX() {
            return this.s;
        }
        set actualRadiusX(a) {
            this.s = a;
            this.e("ActualRadiusX");
        }
        get radiusY() {
            return this.ae;
        }
        set radiusY(a) {
            this.ae = a;
            this.e("RadiusY");
        }
        get actualRadiusY() {
            return this.t;
        }
        set actualRadiusY(a) {
            this.t = a;
            this.e("ActualRadiusY");
        }
        get thickness() {
            return this.ai;
        }
        set thickness(a) {
            this.ai = a;
            this.e("Thickness");
        }
        get actualThickness() {
            return this.x;
        }
        set actualThickness(a) {
            this.x = a;
            this.e("ActualThickness");
        }
        get markerThickness() {
            return this.ab;
        }
        set markerThickness(a) {
            this.ab = a;
            this.e("MarkerThickness");
        }
        get actualMarkerThickness() {
            return this.q;
        }
        set actualMarkerThickness(a) {
            this.q = a;
            this.e("ActualMarkerThickness");
        }
        get titleRef() {
            return this.bw;
        }
        set titleRef(a) {
            this.bw = a;
            this.e("TitleRef");
        }
        get valueMemberPath() {
            return this.bx;
        }
        set valueMemberPath(a) {
            this.bx = a;
            this.e("ValueMemberPath");
        }
        get visibility() {
            return this.by;
        }
        set visibility(a) {
            this.by = a;
            this.e("Visibility");
        }
        get actualVisibility() {
            return this.bg;
        }
        set actualVisibility(a) {
            this.bg = a;
            this.e("ActualVisibility");
        }
        get parentOrLocalBrush() {
            return this.bt;
        }
        set parentOrLocalBrush(a) {
            this.bt = a;
            this.e("ParentOrLocalBrush");
        }
        get propertyUpdatedRef() {
            return this.bu;
        }
        set propertyUpdatedRef(a) {
            this.bu = a;
            this.e("PropertyUpdatedRef");
        }
    }
    StackedFragmentSeriesDescription.$t = /*@__PURE__*/ markType(StackedFragmentSeriesDescription, 'StackedFragmentSeriesDescription', Description.$);
    return StackedFragmentSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedFragmentSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedFragmentSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedFragmentSeriesDescriptionMetadata.a == null) {
                StackedFragmentSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedFragmentSeriesDescriptionMetadata.c(a, StackedFragmentSeriesDescriptionMetadata.a);
                PropertyUpdatedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("Brush", "Brush");
            b.item("ActualBrush", "Brush");
            b.item("IsDropShadowEnabled", "Boolean");
            b.item("ActualIsDropShadowEnabled", "Boolean");
            b.item("ShadowBlur", "Number:double");
            b.item("ActualShadowBlur", "Number:double");
            b.item("ShadowColor", "Color");
            b.item("ActualShadowColor", "Color");
            b.item("UseSingleShadow", "Boolean");
            b.item("ActualUseSingleShadow", "Boolean");
            b.item("ShadowOffsetX", "Number:double");
            b.item("ActualShadowOffsetX", "Number:double");
            b.item("ShadowOffsetY", "Number:double");
            b.item("ActualShadowOffsetY", "Number:double");
            b.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            b.item("ActualLegendItemBadgeTemplateRef", "(w:ActualLegendItemBadgeTemplate,wf:ActualLegendItemBadgeTemplate)DataRef::object");
            b.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            b.item("ActualLegendItemTemplateRef", "(w:ActualLegendItemTemplate,wf:ActualLegendItemTemplate)DataRef::object");
            b.item("LegendItemVisibility", "ExportedType:string:Visibility");
            b.item("LegendItemVisibility@names", "Visible;Collapsed");
            b.item("ActualLegendItemVisibility", "ExportedType:string:Visibility");
            b.item("ActualLegendItemVisibility@names", "Visible;Collapsed");
            b.item("MarkerBrush", "Brush");
            b.item("ActualMarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("ActualMarkerOutline", "Brush");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("ActualMarkerTemplateRef", "(w:ActualMarkerTemplate,wf:ActualMarkerTemplate)DataRef::object");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("ActualMarkerType", "ExportedType:string:MarkerType");
            b.item("ActualMarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("Name", "String");
            b.item("Opacity", "Number:double");
            b.item("ActualOpacity", "Number:double");
            b.item("Outline", "Brush");
            b.item("ActualOutline", "Brush");
            b.item("AreaFillOpacity", "Number:double");
            b.item("ActualAreaFillOpacity", "Number:double");
            b.item("MarkerFillOpacity", "Number:double");
            b.item("ActualMarkerFillOpacity", "Number:double");
            b.item("OutlineMode", "ExportedType:string:SeriesOutlineMode");
            b.item("OutlineMode@names", "Auto;Visible;Collapsed");
            b.item("ActualOutlineMode", "ExportedType:string:SeriesOutlineMode");
            b.item("ActualOutlineMode@names", "Auto;Visible;Collapsed");
            b.item("HighlightingFadeOpacity", "Number:double");
            b.item("ActualHighlightingFadeOpacity", "Number:double");
            b.item("RadiusX", "Number:double");
            b.item("ActualRadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
            b.item("ActualRadiusY", "Number:double");
            b.item("Thickness", "Number:double");
            b.item("ActualThickness", "Number:double");
            b.item("MarkerThickness", "Number:double");
            b.item("ActualMarkerThickness", "Number:double");
            b.item("TitleRef", "(w:Title,wf:Title)DataRef");
            b.item("ValueMemberPath", "String");
            b.item("Visibility", "ExportedType:string:Visibility");
            b.item("Visibility@names", "Visible;Collapsed");
            b.item("ActualVisibility", "ExportedType:string:Visibility");
            b.item("ActualVisibility@names", "Visible;Collapsed");
            b.item("ParentOrLocalBrush", "Brush");
            b.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
        }
        static d(a) {
            StackedFragmentSeriesDescriptionMetadata.b(a);
            a.q("StackedFragmentSeries", () => new StackedFragmentSeriesDescription());
            a.p("StackedFragmentSeries", StackedFragmentSeriesDescriptionMetadata.a);
        }
    }
    StackedFragmentSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedFragmentSeriesDescriptionMetadata, 'StackedFragmentSeriesDescriptionMetadata');
    StackedFragmentSeriesDescriptionMetadata.a = null;
    return StackedFragmentSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedFragmentSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedFragmentSeriesDescriptionModule extends Base {
        static register(a) {
            StackedFragmentSeriesDescriptionMetadata.d(a);
        }
    }
    StackedFragmentSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedFragmentSeriesDescriptionModule, 'StackedFragmentSeriesDescriptionModule');
    return StackedFragmentSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesCreatedEventArgsDescription = /*@__PURE__*/ (() => {
    class StackedSeriesCreatedEventArgsDescription extends Description {
        constructor() {
            super();
            this.l = null;
            this.n = null;
            this.m = null;
            this.o = null;
            this.t = null;
            this.i = 0;
            this.u = null;
            this.p = null;
            this.q = null;
            this.f = null;
            this.r = null;
            this.s = null;
            this.h = 0;
        }
        get_type() {
            return "StackedSeriesCreatedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get brush() {
            return this.l;
        }
        set brush(a) {
            this.l = a;
            this.e("Brush");
        }
        get legendItemTemplateRef() {
            return this.n;
        }
        set legendItemTemplateRef(a) {
            this.n = a;
            this.e("LegendItemTemplateRef");
        }
        get legendItemBadgeTemplateRef() {
            return this.m;
        }
        set legendItemBadgeTemplateRef(a) {
            this.m = a;
            this.e("LegendItemBadgeTemplateRef");
        }
        get legendItemVisibility() {
            return this.o;
        }
        set legendItemVisibility(a) {
            this.o = a;
            this.e("LegendItemVisibility");
        }
        get outline() {
            return this.t;
        }
        set outline(a) {
            this.t = a;
            this.e("Outline");
        }
        get thickness() {
            return this.i;
        }
        set thickness(a) {
            this.i = a;
            this.e("Thickness");
        }
        get titleRef() {
            return this.u;
        }
        set titleRef(a) {
            this.u = a;
            this.e("TitleRef");
        }
        get markerBrush() {
            return this.p;
        }
        set markerBrush(a) {
            this.p = a;
            this.e("MarkerBrush");
        }
        get markerOutline() {
            return this.q;
        }
        set markerOutline(a) {
            this.q = a;
            this.e("MarkerOutline");
        }
        get markerStyle() {
            return this.f;
        }
        set markerStyle(a) {
            this.f = a;
            this.e("MarkerStyle");
        }
        get markerTemplateRef() {
            return this.r;
        }
        set markerTemplateRef(a) {
            this.r = a;
            this.e("MarkerTemplateRef");
        }
        get markerType() {
            return this.s;
        }
        set markerType(a) {
            this.s = a;
            this.e("MarkerType");
        }
        get markerThickness() {
            return this.h;
        }
        set markerThickness(a) {
            this.h = a;
            this.e("MarkerThickness");
        }
    }
    StackedSeriesCreatedEventArgsDescription.$t = /*@__PURE__*/ markType(StackedSeriesCreatedEventArgsDescription, 'StackedSeriesCreatedEventArgsDescription', Description.$);
    return StackedSeriesCreatedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesCreatedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSeriesCreatedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSeriesCreatedEventArgsDescriptionMetadata.a == null) {
                StackedSeriesCreatedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSeriesCreatedEventArgsDescriptionMetadata.c(a, StackedSeriesCreatedEventArgsDescriptionMetadata.a);
                StyleDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Brush", "Brush");
            b.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            b.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            b.item("LegendItemVisibility", "ExportedType:string:Visibility");
            b.item("LegendItemVisibility@names", "Visible;Collapsed");
            b.item("Outline", "Brush");
            b.item("Thickness", "Number:double");
            b.item("TitleRef", "(w:Title,wf:Title)DataRef");
            b.item("MarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("MarkerStyle", "ExportedType:Style");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerThickness", "Number:double");
        }
        static d(a) {
            StackedSeriesCreatedEventArgsDescriptionMetadata.b(a);
            a.q("StackedSeriesCreatedEventArgs", () => new StackedSeriesCreatedEventArgsDescription());
            a.p("StackedSeriesCreatedEventArgs", StackedSeriesCreatedEventArgsDescriptionMetadata.a);
        }
    }
    StackedSeriesCreatedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSeriesCreatedEventArgsDescriptionMetadata, 'StackedSeriesCreatedEventArgsDescriptionMetadata');
    StackedSeriesCreatedEventArgsDescriptionMetadata.a = null;
    return StackedSeriesCreatedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSeriesBaseDescriptionMetadata.a == null) {
                StackedSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSeriesBaseDescriptionMetadata.c(a, StackedSeriesBaseDescriptionMetadata.a);
                StackedSeriesCreatedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            CategorySeriesDescriptionMetadata.c(a, b);
            b.item("Series", "Collection:StackedFragmentSeries:StackedSeriesCollection:StackedFragmentSeries");
            b.item("AutoGenerateSeries", "Boolean");
            b.item("ReverseLegendOrder", "Boolean");
            b.item("SeriesCreatedRef", "EventRef::seriesCreated");
            StackedSeriesBaseDescriptionMetadata.e(a, b);
        }
        static d(a) {
            StackedSeriesBaseDescriptionMetadata.b(a);
            a.p("StackedSeriesBase", StackedSeriesBaseDescriptionMetadata.a);
        }
        static e(a, b) {
        }
    }
    StackedSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSeriesBaseDescriptionMetadata, 'StackedSeriesBaseDescriptionMetadata');
    StackedSeriesBaseDescriptionMetadata.a = null;
    return StackedSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalStackedSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class HorizontalStackedSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (HorizontalStackedSeriesBaseDescriptionMetadata.a == null) {
                HorizontalStackedSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HorizontalStackedSeriesBaseDescriptionMetadata.c(a, HorizontalStackedSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedSeriesBaseDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            HorizontalStackedSeriesBaseDescriptionMetadata.b(a);
            a.p("HorizontalStackedSeriesBase", HorizontalStackedSeriesBaseDescriptionMetadata.a);
        }
    }
    HorizontalStackedSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(HorizontalStackedSeriesBaseDescriptionMetadata, 'HorizontalStackedSeriesBaseDescriptionMetadata');
    HorizontalStackedSeriesBaseDescriptionMetadata.a = null;
    return HorizontalStackedSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSeriesBaseDescription = /*@__PURE__*/ (() => {
    class StackedSeriesBaseDescription extends CategorySeriesDescription {
        constructor() {
            super();
            this.dm = null;
            this.dp = false;
            this.dq = false;
            this.dt = null;
        }
        get_type() {
            return "StackedSeriesBase";
        }
        get series() {
            return this.dm;
        }
        set series(a) {
            this.dm = a;
            this.e("Series");
        }
        get autoGenerateSeries() {
            return this.dp;
        }
        set autoGenerateSeries(a) {
            this.dp = a;
            this.e("AutoGenerateSeries");
        }
        get reverseLegendOrder() {
            return this.dq;
        }
        set reverseLegendOrder(a) {
            this.dq = a;
            this.e("ReverseLegendOrder");
        }
        get seriesCreatedRef() {
            return this.dt;
        }
        set seriesCreatedRef(a) {
            this.dt = a;
            this.e("SeriesCreatedRef");
        }
    }
    StackedSeriesBaseDescription.$t = /*@__PURE__*/ markType(StackedSeriesBaseDescription, 'StackedSeriesBaseDescription', CategorySeriesDescription.$);
    return StackedSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalStackedSeriesBaseDescription = /*@__PURE__*/ (() => {
    class HorizontalStackedSeriesBaseDescription extends StackedSeriesBaseDescription {
        constructor() {
            super();
            this.dv = null;
            this.dw = null;
        }
        get_type() {
            return "HorizontalStackedSeriesBase";
        }
        get xAxisRef() {
            return this.dv;
        }
        set xAxisRef(a) {
            this.dv = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.dw;
        }
        set yAxisRef(a) {
            this.dw = a;
            this.e("YAxisRef");
        }
    }
    HorizontalStackedSeriesBaseDescription.$t = /*@__PURE__*/ markType(HorizontalStackedSeriesBaseDescription, 'HorizontalStackedSeriesBaseDescription', StackedSeriesBaseDescription.$);
    return HorizontalStackedSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedAreaSeriesDescription = /*@__PURE__*/ (() => {
    class StackedAreaSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StackedAreaSeries";
        }
    }
    StackedAreaSeriesDescription.$t = /*@__PURE__*/ markType(StackedAreaSeriesDescription, 'StackedAreaSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedAreaSeriesDescriptionMetadata.a == null) {
                StackedAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedAreaSeriesDescriptionMetadata.c(a, StackedAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StackedAreaSeriesDescriptionMetadata.b(a);
            a.q("StackedAreaSeries", () => new StackedAreaSeriesDescription());
            a.p("StackedAreaSeries", StackedAreaSeriesDescriptionMetadata.a);
        }
    }
    StackedAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedAreaSeriesDescriptionMetadata, 'StackedAreaSeriesDescriptionMetadata');
    StackedAreaSeriesDescriptionMetadata.a = null;
    return StackedAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100AreaSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100AreaSeriesDescription extends StackedAreaSeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "Stacked100AreaSeries";
        }
    }
    Stacked100AreaSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100AreaSeriesDescription, 'Stacked100AreaSeriesDescription', StackedAreaSeriesDescription.$);
    return Stacked100AreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100AreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100AreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100AreaSeriesDescriptionMetadata.a == null) {
                Stacked100AreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100AreaSeriesDescriptionMetadata.c(a, Stacked100AreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedAreaSeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            Stacked100AreaSeriesDescriptionMetadata.b(a);
            a.q("Stacked100AreaSeries", () => new Stacked100AreaSeriesDescription());
            a.p("Stacked100AreaSeries", Stacked100AreaSeriesDescriptionMetadata.a);
        }
    }
    Stacked100AreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100AreaSeriesDescriptionMetadata, 'Stacked100AreaSeriesDescriptionMetadata');
    Stacked100AreaSeriesDescriptionMetadata.a = null;
    return Stacked100AreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100AreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100AreaSeriesDescriptionModule extends Base {
        static register(a) {
            Stacked100AreaSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100AreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100AreaSeriesDescriptionModule, 'Stacked100AreaSeriesDescriptionModule');
    return Stacked100AreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalStackedSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class VerticalStackedSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (VerticalStackedSeriesBaseDescriptionMetadata.a == null) {
                VerticalStackedSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VerticalStackedSeriesBaseDescriptionMetadata.c(a, VerticalStackedSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedSeriesBaseDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            VerticalStackedSeriesBaseDescriptionMetadata.b(a);
            a.p("VerticalStackedSeriesBase", VerticalStackedSeriesBaseDescriptionMetadata.a);
        }
    }
    VerticalStackedSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(VerticalStackedSeriesBaseDescriptionMetadata, 'VerticalStackedSeriesBaseDescriptionMetadata');
    VerticalStackedSeriesBaseDescriptionMetadata.a = null;
    return VerticalStackedSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalStackedSeriesBaseDescription = /*@__PURE__*/ (() => {
    class VerticalStackedSeriesBaseDescription extends StackedSeriesBaseDescription {
        constructor() {
            super();
            this.dv = null;
            this.dw = null;
        }
        get_type() {
            return "VerticalStackedSeriesBase";
        }
        get xAxisRef() {
            return this.dv;
        }
        set xAxisRef(a) {
            this.dv = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.dw;
        }
        set yAxisRef(a) {
            this.dw = a;
            this.e("YAxisRef");
        }
    }
    VerticalStackedSeriesBaseDescription.$t = /*@__PURE__*/ markType(VerticalStackedSeriesBaseDescription, 'VerticalStackedSeriesBaseDescription', StackedSeriesBaseDescription.$);
    return VerticalStackedSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedBarSeriesDescription = /*@__PURE__*/ (() => {
    class StackedBarSeriesDescription extends VerticalStackedSeriesBaseDescription {
        constructor() {
            super();
            this.dz = 0;
            this.d0 = 0;
        }
        get_type() {
            return "StackedBarSeries";
        }
        get radiusX() {
            return this.dz;
        }
        set radiusX(a) {
            this.dz = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d0;
        }
        set radiusY(a) {
            this.d0 = a;
            this.e("RadiusY");
        }
    }
    StackedBarSeriesDescription.$t = /*@__PURE__*/ markType(StackedBarSeriesDescription, 'StackedBarSeriesDescription', VerticalStackedSeriesBaseDescription.$);
    return StackedBarSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedBarSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedBarSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedBarSeriesDescriptionMetadata.a == null) {
                StackedBarSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedBarSeriesDescriptionMetadata.c(a, StackedBarSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            VerticalStackedSeriesBaseDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            StackedBarSeriesDescriptionMetadata.b(a);
            a.q("StackedBarSeries", () => new StackedBarSeriesDescription());
            a.p("StackedBarSeries", StackedBarSeriesDescriptionMetadata.a);
        }
    }
    StackedBarSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedBarSeriesDescriptionMetadata, 'StackedBarSeriesDescriptionMetadata');
    StackedBarSeriesDescriptionMetadata.a = null;
    return StackedBarSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100BarSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100BarSeriesDescription extends StackedBarSeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "Stacked100BarSeries";
        }
    }
    Stacked100BarSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100BarSeriesDescription, 'Stacked100BarSeriesDescription', StackedBarSeriesDescription.$);
    return Stacked100BarSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100BarSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100BarSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100BarSeriesDescriptionMetadata.a == null) {
                Stacked100BarSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100BarSeriesDescriptionMetadata.c(a, Stacked100BarSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedBarSeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            Stacked100BarSeriesDescriptionMetadata.b(a);
            a.q("Stacked100BarSeries", () => new Stacked100BarSeriesDescription());
            a.p("Stacked100BarSeries", Stacked100BarSeriesDescriptionMetadata.a);
        }
    }
    Stacked100BarSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100BarSeriesDescriptionMetadata, 'Stacked100BarSeriesDescriptionMetadata');
    Stacked100BarSeriesDescriptionMetadata.a = null;
    return Stacked100BarSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100BarSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100BarSeriesDescriptionModule extends Base {
        static register(a) {
            Stacked100BarSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100BarSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100BarSeriesDescriptionModule, 'Stacked100BarSeriesDescriptionModule');
    return Stacked100BarSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedColumnSeriesDescription = /*@__PURE__*/ (() => {
    class StackedColumnSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        constructor() {
            super();
            this.dz = 0;
            this.d0 = 0;
        }
        get_type() {
            return "StackedColumnSeries";
        }
        get radiusX() {
            return this.dz;
        }
        set radiusX(a) {
            this.dz = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d0;
        }
        set radiusY(a) {
            this.d0 = a;
            this.e("RadiusY");
        }
    }
    StackedColumnSeriesDescription.$t = /*@__PURE__*/ markType(StackedColumnSeriesDescription, 'StackedColumnSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedColumnSeriesDescriptionMetadata.a == null) {
                StackedColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedColumnSeriesDescriptionMetadata.c(a, StackedColumnSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            StackedColumnSeriesDescriptionMetadata.b(a);
            a.q("StackedColumnSeries", () => new StackedColumnSeriesDescription());
            a.p("StackedColumnSeries", StackedColumnSeriesDescriptionMetadata.a);
        }
    }
    StackedColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedColumnSeriesDescriptionMetadata, 'StackedColumnSeriesDescriptionMetadata');
    StackedColumnSeriesDescriptionMetadata.a = null;
    return StackedColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100ColumnSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100ColumnSeriesDescription extends StackedColumnSeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "Stacked100ColumnSeries";
        }
    }
    Stacked100ColumnSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100ColumnSeriesDescription, 'Stacked100ColumnSeriesDescription', StackedColumnSeriesDescription.$);
    return Stacked100ColumnSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100ColumnSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100ColumnSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100ColumnSeriesDescriptionMetadata.a == null) {
                Stacked100ColumnSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100ColumnSeriesDescriptionMetadata.c(a, Stacked100ColumnSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedColumnSeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            Stacked100ColumnSeriesDescriptionMetadata.b(a);
            a.q("Stacked100ColumnSeries", () => new Stacked100ColumnSeriesDescription());
            a.p("Stacked100ColumnSeries", Stacked100ColumnSeriesDescriptionMetadata.a);
        }
    }
    Stacked100ColumnSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100ColumnSeriesDescriptionMetadata, 'Stacked100ColumnSeriesDescriptionMetadata');
    Stacked100ColumnSeriesDescriptionMetadata.a = null;
    return Stacked100ColumnSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100ColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100ColumnSeriesDescriptionModule extends Base {
        static register(a) {
            Stacked100ColumnSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100ColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100ColumnSeriesDescriptionModule, 'Stacked100ColumnSeriesDescriptionModule');
    return Stacked100ColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedLineSeriesDescription = /*@__PURE__*/ (() => {
    class StackedLineSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StackedLineSeries";
        }
    }
    StackedLineSeriesDescription.$t = /*@__PURE__*/ markType(StackedLineSeriesDescription, 'StackedLineSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedLineSeriesDescriptionMetadata.a == null) {
                StackedLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedLineSeriesDescriptionMetadata.c(a, StackedLineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StackedLineSeriesDescriptionMetadata.b(a);
            a.q("StackedLineSeries", () => new StackedLineSeriesDescription());
            a.p("StackedLineSeries", StackedLineSeriesDescriptionMetadata.a);
        }
    }
    StackedLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedLineSeriesDescriptionMetadata, 'StackedLineSeriesDescriptionMetadata');
    StackedLineSeriesDescriptionMetadata.a = null;
    return StackedLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100LineSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesDescription extends StackedLineSeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "Stacked100LineSeries";
        }
    }
    Stacked100LineSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100LineSeriesDescription, 'Stacked100LineSeriesDescription', StackedLineSeriesDescription.$);
    return Stacked100LineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100LineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100LineSeriesDescriptionMetadata.a == null) {
                Stacked100LineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100LineSeriesDescriptionMetadata.c(a, Stacked100LineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedLineSeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            Stacked100LineSeriesDescriptionMetadata.b(a);
            a.q("Stacked100LineSeries", () => new Stacked100LineSeriesDescription());
            a.p("Stacked100LineSeries", Stacked100LineSeriesDescriptionMetadata.a);
        }
    }
    Stacked100LineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100LineSeriesDescriptionMetadata, 'Stacked100LineSeriesDescriptionMetadata');
    Stacked100LineSeriesDescriptionMetadata.a = null;
    return Stacked100LineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100LineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesDescriptionModule extends Base {
        static register(a) {
            Stacked100LineSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100LineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100LineSeriesDescriptionModule, 'Stacked100LineSeriesDescriptionModule');
    return Stacked100LineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineSeriesDescription = /*@__PURE__*/ (() => {
    class StackedSplineSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StackedSplineSeries";
        }
    }
    StackedSplineSeriesDescription.$t = /*@__PURE__*/ markType(StackedSplineSeriesDescription, 'StackedSplineSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedSplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSplineSeriesDescriptionMetadata.a == null) {
                StackedSplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSplineSeriesDescriptionMetadata.c(a, StackedSplineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StackedSplineSeriesDescriptionMetadata.b(a);
            a.q("StackedSplineSeries", () => new StackedSplineSeriesDescription());
            a.p("StackedSplineSeries", StackedSplineSeriesDescriptionMetadata.a);
        }
    }
    StackedSplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSplineSeriesDescriptionMetadata, 'StackedSplineSeriesDescriptionMetadata');
    StackedSplineSeriesDescriptionMetadata.a = null;
    return StackedSplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100SplineSeriesDescription extends StackedSplineSeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "Stacked100SplineSeries";
        }
    }
    Stacked100SplineSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100SplineSeriesDescription, 'Stacked100SplineSeriesDescription', StackedSplineSeriesDescription.$);
    return Stacked100SplineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100SplineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100SplineSeriesDescriptionMetadata.a == null) {
                Stacked100SplineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100SplineSeriesDescriptionMetadata.c(a, Stacked100SplineSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedSplineSeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            Stacked100SplineSeriesDescriptionMetadata.b(a);
            a.q("Stacked100SplineSeries", () => new Stacked100SplineSeriesDescription());
            a.p("Stacked100SplineSeries", Stacked100SplineSeriesDescriptionMetadata.a);
        }
    }
    Stacked100SplineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100SplineSeriesDescriptionMetadata, 'Stacked100SplineSeriesDescriptionMetadata');
    Stacked100SplineSeriesDescriptionMetadata.a = null;
    return Stacked100SplineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100SplineSeriesDescriptionModule extends Base {
        static register(a) {
            Stacked100SplineSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100SplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100SplineSeriesDescriptionModule, 'Stacked100SplineSeriesDescriptionModule');
    return Stacked100SplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class StackedSplineAreaSeriesDescription extends HorizontalStackedSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "StackedSplineAreaSeries";
        }
    }
    StackedSplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(StackedSplineAreaSeriesDescription, 'StackedSplineAreaSeriesDescription', HorizontalStackedSeriesBaseDescription.$);
    return StackedSplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class StackedSplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (StackedSplineAreaSeriesDescriptionMetadata.a == null) {
                StackedSplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StackedSplineAreaSeriesDescriptionMetadata.c(a, StackedSplineAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalStackedSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            StackedSplineAreaSeriesDescriptionMetadata.b(a);
            a.q("StackedSplineAreaSeries", () => new StackedSplineAreaSeriesDescription());
            a.p("StackedSplineAreaSeries", StackedSplineAreaSeriesDescriptionMetadata.a);
        }
    }
    StackedSplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(StackedSplineAreaSeriesDescriptionMetadata, 'StackedSplineAreaSeriesDescriptionMetadata');
    StackedSplineAreaSeriesDescriptionMetadata.a = null;
    return StackedSplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineAreaSeriesDescription = /*@__PURE__*/ (() => {
    class Stacked100SplineAreaSeriesDescription extends StackedSplineAreaSeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "Stacked100SplineAreaSeries";
        }
    }
    Stacked100SplineAreaSeriesDescription.$t = /*@__PURE__*/ markType(Stacked100SplineAreaSeriesDescription, 'Stacked100SplineAreaSeriesDescription', StackedSplineAreaSeriesDescription.$);
    return Stacked100SplineAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class Stacked100SplineAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (Stacked100SplineAreaSeriesDescriptionMetadata.a == null) {
                Stacked100SplineAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                Stacked100SplineAreaSeriesDescriptionMetadata.c(a, Stacked100SplineAreaSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            StackedSplineAreaSeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            Stacked100SplineAreaSeriesDescriptionMetadata.b(a);
            a.q("Stacked100SplineAreaSeries", () => new Stacked100SplineAreaSeriesDescription());
            a.p("Stacked100SplineAreaSeries", Stacked100SplineAreaSeriesDescriptionMetadata.a);
        }
    }
    Stacked100SplineAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(Stacked100SplineAreaSeriesDescriptionMetadata, 'Stacked100SplineAreaSeriesDescriptionMetadata');
    Stacked100SplineAreaSeriesDescriptionMetadata.a = null;
    return Stacked100SplineAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Stacked100SplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class Stacked100SplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            Stacked100SplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    Stacked100SplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(Stacked100SplineAreaSeriesDescriptionModule, 'Stacked100SplineAreaSeriesDescriptionModule');
    return Stacked100SplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StackedAreaSeriesDescriptionMetadata.d(a);
        }
    }
    StackedAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedAreaSeriesDescriptionModule, 'StackedAreaSeriesDescriptionModule');
    return StackedAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedBarSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedBarSeriesDescriptionModule extends Base {
        static register(a) {
            StackedBarSeriesDescriptionMetadata.d(a);
        }
    }
    StackedBarSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedBarSeriesDescriptionModule, 'StackedBarSeriesDescriptionModule');
    return StackedBarSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedColumnSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedColumnSeriesDescriptionModule extends Base {
        static register(a) {
            StackedColumnSeriesDescriptionMetadata.d(a);
        }
    }
    StackedColumnSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedColumnSeriesDescriptionModule, 'StackedColumnSeriesDescriptionModule');
    return StackedColumnSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedLineSeriesDescriptionModule extends Base {
        static register(a) {
            StackedLineSeriesDescriptionMetadata.d(a);
        }
    }
    StackedLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedLineSeriesDescriptionModule, 'StackedLineSeriesDescriptionModule');
    return StackedLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedSplineSeriesDescriptionModule extends Base {
        static register(a) {
            StackedSplineSeriesDescriptionMetadata.d(a);
        }
    }
    StackedSplineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedSplineSeriesDescriptionModule, 'StackedSplineSeriesDescriptionModule');
    return StackedSplineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StackedSplineAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class StackedSplineAreaSeriesDescriptionModule extends Base {
        static register(a) {
            StackedSplineAreaSeriesDescriptionMetadata.d(a);
        }
    }
    StackedSplineAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(StackedSplineAreaSeriesDescriptionModule, 'StackedSplineAreaSeriesDescriptionModule');
    return StackedSplineAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FragmentBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class FragmentBaseDescriptionMetadata extends Base {
        static b(a) {
            if (FragmentBaseDescriptionMetadata.a == null) {
                FragmentBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FragmentBaseDescriptionMetadata.c(a, FragmentBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            HorizontalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
        }
        static d(a) {
            FragmentBaseDescriptionMetadata.b(a);
            a.p("FragmentBase", FragmentBaseDescriptionMetadata.a);
        }
    }
    FragmentBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(FragmentBaseDescriptionMetadata, 'FragmentBaseDescriptionMetadata');
    FragmentBaseDescriptionMetadata.a = null;
    return FragmentBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FragmentBaseDescription = /*@__PURE__*/ (() => {
    class FragmentBaseDescription extends HorizontalAnchoredCategorySeriesDescription {
        constructor() {
            super();
        }
        get_type() {
            return "FragmentBase";
        }
    }
    FragmentBaseDescription.$t = /*@__PURE__*/ markType(FragmentBaseDescription, 'FragmentBaseDescription', HorizontalAnchoredCategorySeriesDescription.$);
    return FragmentBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaFragmentDescription = /*@__PURE__*/ (() => {
    class AreaFragmentDescription extends FragmentBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AreaFragment";
        }
    }
    AreaFragmentDescription.$t = /*@__PURE__*/ markType(AreaFragmentDescription, 'AreaFragmentDescription', FragmentBaseDescription.$);
    return AreaFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class AreaFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (AreaFragmentDescriptionMetadata.a == null) {
                AreaFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AreaFragmentDescriptionMetadata.c(a, AreaFragmentDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FragmentBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AreaFragmentDescriptionMetadata.b(a);
            a.q("AreaFragment", () => new AreaFragmentDescription());
            a.p("AreaFragment", AreaFragmentDescriptionMetadata.a);
        }
    }
    AreaFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(AreaFragmentDescriptionMetadata, 'AreaFragmentDescriptionMetadata');
    AreaFragmentDescriptionMetadata.a = null;
    return AreaFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AreaFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class AreaFragmentDescriptionModule extends Base {
        static register(a) {
            AreaFragmentDescriptionMetadata.d(a);
        }
    }
    AreaFragmentDescriptionModule.$t = /*@__PURE__*/ markType(AreaFragmentDescriptionModule, 'AreaFragmentDescriptionModule');
    return AreaFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFragmentDescription = /*@__PURE__*/ (() => {
    class ColumnFragmentDescription extends FragmentBaseDescription {
        constructor() {
            super();
            this.d7 = 0;
            this.d8 = 0;
        }
        get_type() {
            return "ColumnFragment";
        }
        get radiusX() {
            return this.d7;
        }
        set radiusX(a) {
            this.d7 = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d8;
        }
        set radiusY(a) {
            this.d8 = a;
            this.e("RadiusY");
        }
    }
    ColumnFragmentDescription.$t = /*@__PURE__*/ markType(ColumnFragmentDescription, 'ColumnFragmentDescription', FragmentBaseDescription.$);
    return ColumnFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnFragmentDescriptionMetadata.a == null) {
                ColumnFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnFragmentDescriptionMetadata.c(a, ColumnFragmentDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FragmentBaseDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            ColumnFragmentDescriptionMetadata.b(a);
            a.q("ColumnFragment", () => new ColumnFragmentDescription());
            a.p("ColumnFragment", ColumnFragmentDescriptionMetadata.a);
        }
    }
    ColumnFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnFragmentDescriptionMetadata, 'ColumnFragmentDescriptionMetadata');
    ColumnFragmentDescriptionMetadata.a = null;
    return ColumnFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarFragmentDescription = /*@__PURE__*/ (() => {
    class BarFragmentDescription extends ColumnFragmentDescription {
        constructor() {
            super();
        }
        get_type() {
            return "BarFragment";
        }
    }
    BarFragmentDescription.$t = /*@__PURE__*/ markType(BarFragmentDescription, 'BarFragmentDescription', ColumnFragmentDescription.$);
    return BarFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class BarFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (BarFragmentDescriptionMetadata.a == null) {
                BarFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BarFragmentDescriptionMetadata.c(a, BarFragmentDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnFragmentDescriptionMetadata.c(a, b);
        }
        static d(a) {
            BarFragmentDescriptionMetadata.b(a);
            a.q("BarFragment", () => new BarFragmentDescription());
            a.p("BarFragment", BarFragmentDescriptionMetadata.a);
        }
    }
    BarFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(BarFragmentDescriptionMetadata, 'BarFragmentDescriptionMetadata');
    BarFragmentDescriptionMetadata.a = null;
    return BarFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class BarFragmentDescriptionModule extends Base {
        static register(a) {
            BarFragmentDescriptionMetadata.d(a);
        }
    }
    BarFragmentDescriptionModule.$t = /*@__PURE__*/ markType(BarFragmentDescriptionModule, 'BarFragmentDescriptionModule');
    return BarFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class ColumnFragmentDescriptionModule extends Base {
        static register(a) {
            ColumnFragmentDescriptionMetadata.d(a);
        }
    }
    ColumnFragmentDescriptionModule.$t = /*@__PURE__*/ markType(ColumnFragmentDescriptionModule, 'ColumnFragmentDescriptionModule');
    return ColumnFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineFragmentDescription = /*@__PURE__*/ (() => {
    class LineFragmentDescription extends FragmentBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "LineFragment";
        }
    }
    LineFragmentDescription.$t = /*@__PURE__*/ markType(LineFragmentDescription, 'LineFragmentDescription', FragmentBaseDescription.$);
    return LineFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class LineFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (LineFragmentDescriptionMetadata.a == null) {
                LineFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LineFragmentDescriptionMetadata.c(a, LineFragmentDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FragmentBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            LineFragmentDescriptionMetadata.b(a);
            a.q("LineFragment", () => new LineFragmentDescription());
            a.p("LineFragment", LineFragmentDescriptionMetadata.a);
        }
    }
    LineFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(LineFragmentDescriptionMetadata, 'LineFragmentDescriptionMetadata');
    LineFragmentDescriptionMetadata.a = null;
    return LineFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class LineFragmentDescriptionModule extends Base {
        static register(a) {
            LineFragmentDescriptionMetadata.d(a);
        }
    }
    LineFragmentDescriptionModule.$t = /*@__PURE__*/ markType(LineFragmentDescriptionModule, 'LineFragmentDescriptionModule');
    return LineFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineFragmentBaseDescriptionMetadata extends Base {
        static b(a) {
            if (SplineFragmentBaseDescriptionMetadata.a == null) {
                SplineFragmentBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineFragmentBaseDescriptionMetadata.c(a, SplineFragmentBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SplineSeriesBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SplineFragmentBaseDescriptionMetadata.b(a);
            a.p("SplineFragmentBase", SplineFragmentBaseDescriptionMetadata.a);
        }
    }
    SplineFragmentBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineFragmentBaseDescriptionMetadata, 'SplineFragmentBaseDescriptionMetadata');
    SplineFragmentBaseDescriptionMetadata.a = null;
    return SplineFragmentBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentBaseDescription = /*@__PURE__*/ (() => {
    class SplineFragmentBaseDescription extends SplineSeriesBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SplineFragmentBase";
        }
    }
    SplineFragmentBaseDescription.$t = /*@__PURE__*/ markType(SplineFragmentBaseDescription, 'SplineFragmentBaseDescription', SplineSeriesBaseDescription.$);
    return SplineFragmentBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentDescription = /*@__PURE__*/ (() => {
    class SplineFragmentDescription extends SplineFragmentBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SplineFragment";
        }
    }
    SplineFragmentDescription.$t = /*@__PURE__*/ markType(SplineFragmentDescription, 'SplineFragmentDescription', SplineFragmentBaseDescription.$);
    return SplineFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (SplineFragmentDescriptionMetadata.a == null) {
                SplineFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineFragmentDescriptionMetadata.c(a, SplineFragmentDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SplineFragmentBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SplineFragmentDescriptionMetadata.b(a);
            a.q("SplineFragment", () => new SplineFragmentDescription());
            a.p("SplineFragment", SplineFragmentDescriptionMetadata.a);
        }
    }
    SplineFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineFragmentDescriptionMetadata, 'SplineFragmentDescriptionMetadata');
    SplineFragmentDescriptionMetadata.a = null;
    return SplineFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class SplineFragmentDescriptionModule extends Base {
        static register(a) {
            SplineFragmentDescriptionMetadata.d(a);
        }
    }
    SplineFragmentDescriptionModule.$t = /*@__PURE__*/ markType(SplineFragmentDescriptionModule, 'SplineFragmentDescriptionModule');
    return SplineFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaFragmentDescription = /*@__PURE__*/ (() => {
    class SplineAreaFragmentDescription extends SplineFragmentBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SplineAreaFragment";
        }
    }
    SplineAreaFragmentDescription.$t = /*@__PURE__*/ markType(SplineAreaFragmentDescription, 'SplineAreaFragmentDescription', SplineFragmentBaseDescription.$);
    return SplineAreaFragmentDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaFragmentDescriptionMetadata = /*@__PURE__*/ (() => {
    class SplineAreaFragmentDescriptionMetadata extends Base {
        static b(a) {
            if (SplineAreaFragmentDescriptionMetadata.a == null) {
                SplineAreaFragmentDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SplineAreaFragmentDescriptionMetadata.c(a, SplineAreaFragmentDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SplineFragmentBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SplineAreaFragmentDescriptionMetadata.b(a);
            a.q("SplineAreaFragment", () => new SplineAreaFragmentDescription());
            a.p("SplineAreaFragment", SplineAreaFragmentDescriptionMetadata.a);
        }
    }
    SplineAreaFragmentDescriptionMetadata.$t = /*@__PURE__*/ markType(SplineAreaFragmentDescriptionMetadata, 'SplineAreaFragmentDescriptionMetadata');
    SplineAreaFragmentDescriptionMetadata.a = null;
    return SplineAreaFragmentDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SplineAreaFragmentDescriptionModule = /*@__PURE__*/ (() => {
    class SplineAreaFragmentDescriptionModule extends Base {
        static register(a) {
            SplineAreaFragmentDescriptionMetadata.d(a);
        }
    }
    SplineAreaFragmentDescriptionModule.$t = /*@__PURE__*/ markType(SplineAreaFragmentDescriptionModule, 'SplineAreaFragmentDescriptionModule');
    return SplineAreaFragmentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryYAxisDescription = /*@__PURE__*/ (() => {
    class CategoryYAxisDescription extends CategoryAxisBaseDescription {
        constructor() {
            super();
            this.di = 0;
            this.dg = 0;
            this.dj = 0;
            this.dh = 0;
            this.dp = null;
            this.dq = null;
        }
        get_type() {
            return "CategoryYAxis";
        }
        get interval() {
            return this.di;
        }
        set interval(a) {
            this.di = a;
            this.e("Interval");
        }
        get actualInterval() {
            return this.dg;
        }
        set actualInterval(a) {
            this.dg = a;
            this.e("ActualInterval");
        }
        get minorInterval() {
            return this.dj;
        }
        set minorInterval(a) {
            this.dj = a;
            this.e("MinorInterval");
        }
        get actualMinorInterval() {
            return this.dh;
        }
        set actualMinorInterval(a) {
            this.dh = a;
            this.e("ActualMinorInterval");
        }
        get actualIntervalChangeRef() {
            return this.dp;
        }
        set actualIntervalChangeRef(a) {
            this.dp = a;
            this.e("ActualIntervalChangeRef");
        }
        get actualMinorIntervalChangeRef() {
            return this.dq;
        }
        set actualMinorIntervalChangeRef(a) {
            this.dq = a;
            this.e("ActualMinorIntervalChangeRef");
        }
    }
    CategoryYAxisDescription.$t = /*@__PURE__*/ markType(CategoryYAxisDescription, 'CategoryYAxisDescription', CategoryAxisBaseDescription.$);
    return CategoryYAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryYAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class CategoryYAxisDescriptionMetadata extends Base {
        static b(a) {
            if (CategoryYAxisDescriptionMetadata.a == null) {
                CategoryYAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CategoryYAxisDescriptionMetadata.c(a, CategoryYAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CategoryAxisBaseDescriptionMetadata.c(a, b);
            b.item("Interval", "Number:double");
            b.item("ActualInterval", "Number:double");
            b.item("MinorInterval", "Number:double");
            b.item("ActualMinorInterval", "Number:double");
            b.item("ActualIntervalChangeRef", "EventRef::actualIntervalChange");
            b.item("ActualMinorIntervalChangeRef", "EventRef::actualMinorIntervalChange");
        }
        static d(a) {
            CategoryYAxisDescriptionMetadata.b(a);
            a.q("CategoryYAxis", () => new CategoryYAxisDescription());
            a.p("CategoryYAxis", CategoryYAxisDescriptionMetadata.a);
        }
    }
    CategoryYAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(CategoryYAxisDescriptionMetadata, 'CategoryYAxisDescriptionMetadata');
    CategoryYAxisDescriptionMetadata.a = null;
    return CategoryYAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryYAxisDescriptionModule = /*@__PURE__*/ (() => {
    class CategoryYAxisDescriptionModule extends Base {
        static register(a) {
            CategoryYAxisDescriptionMetadata.d(a);
        }
    }
    CategoryYAxisDescriptionModule.$t = /*@__PURE__*/ markType(CategoryYAxisDescriptionModule, 'CategoryYAxisDescriptionModule');
    return CategoryYAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartVerticalCategoryCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartVerticalCategoryCoreDescriptionModule extends Base {
        static register(a) {
            NumericXAxisDescriptionModule.register(a);
            CategoryYAxisDescriptionModule.register(a);
            DataChartCoreDescriptionModule.register(a);
        }
    }
    DataChartVerticalCategoryCoreDescriptionModule.$t = /*@__PURE__*/ markType(DataChartVerticalCategoryCoreDescriptionModule, 'DataChartVerticalCategoryCoreDescriptionModule');
    return DataChartVerticalCategoryCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartStackedDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartStackedDescriptionModule extends Base {
        static register(a) {
            StackedFragmentSeriesDescriptionModule.register(a);
            Stacked100AreaSeriesDescriptionModule.register(a);
            Stacked100BarSeriesDescriptionModule.register(a);
            Stacked100ColumnSeriesDescriptionModule.register(a);
            Stacked100LineSeriesDescriptionModule.register(a);
            Stacked100SplineSeriesDescriptionModule.register(a);
            Stacked100SplineAreaSeriesDescriptionModule.register(a);
            StackedAreaSeriesDescriptionModule.register(a);
            StackedBarSeriesDescriptionModule.register(a);
            StackedColumnSeriesDescriptionModule.register(a);
            StackedLineSeriesDescriptionModule.register(a);
            StackedSplineSeriesDescriptionModule.register(a);
            StackedSplineAreaSeriesDescriptionModule.register(a);
            AreaFragmentDescriptionModule.register(a);
            BarFragmentDescriptionModule.register(a);
            ColumnFragmentDescriptionModule.register(a);
            LineFragmentDescriptionModule.register(a);
            SplineFragmentDescriptionModule.register(a);
            SplineAreaFragmentDescriptionModule.register(a);
            DataChartCategoryCoreDescriptionModule.register(a);
            DataChartVerticalCategoryCoreDescriptionModule.register(a);
        }
    }
    DataChartStackedDescriptionModule.$t = /*@__PURE__*/ markType(DataChartStackedDescriptionModule, 'DataChartStackedDescriptionModule');
    return DataChartStackedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalAnchoredCategorySeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class VerticalAnchoredCategorySeriesDescriptionMetadata extends Base {
        static b(a) {
            if (VerticalAnchoredCategorySeriesDescriptionMetadata.a == null) {
                VerticalAnchoredCategorySeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VerticalAnchoredCategorySeriesDescriptionMetadata.c(a, VerticalAnchoredCategorySeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("XAxisRef", "(w:XAxis,wf:XAxis)DataRef::object");
            b.item("XAxisRef@nameBinding", "true");
            b.item("YAxisRef", "(w:YAxis,wf:YAxis)DataRef::object");
            b.item("YAxisRef@nameBinding", "true");
        }
        static d(a) {
            VerticalAnchoredCategorySeriesDescriptionMetadata.b(a);
            a.p("VerticalAnchoredCategorySeries", VerticalAnchoredCategorySeriesDescriptionMetadata.a);
        }
    }
    VerticalAnchoredCategorySeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(VerticalAnchoredCategorySeriesDescriptionMetadata, 'VerticalAnchoredCategorySeriesDescriptionMetadata');
    VerticalAnchoredCategorySeriesDescriptionMetadata.a = null;
    return VerticalAnchoredCategorySeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalAnchoredCategorySeriesDescription = /*@__PURE__*/ (() => {
    class VerticalAnchoredCategorySeriesDescription extends AnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d3 = null;
            this.d4 = null;
        }
        get_type() {
            return "VerticalAnchoredCategorySeries";
        }
        get xAxisRef() {
            return this.d3;
        }
        set xAxisRef(a) {
            this.d3 = a;
            this.e("XAxisRef");
        }
        get yAxisRef() {
            return this.d4;
        }
        set yAxisRef(a) {
            this.d4 = a;
            this.e("YAxisRef");
        }
    }
    VerticalAnchoredCategorySeriesDescription.$t = /*@__PURE__*/ markType(VerticalAnchoredCategorySeriesDescription, 'VerticalAnchoredCategorySeriesDescription', AnchoredCategorySeriesDescription.$);
    return VerticalAnchoredCategorySeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarSeriesDescription = /*@__PURE__*/ (() => {
    class BarSeriesDescription extends VerticalAnchoredCategorySeriesDescription {
        constructor() {
            super();
            this.d7 = 0;
            this.d8 = 0;
        }
        get_type() {
            return "BarSeries";
        }
        get radiusX() {
            return this.d7;
        }
        set radiusX(a) {
            this.d7 = a;
            this.e("RadiusX");
        }
        get radiusY() {
            return this.d8;
        }
        set radiusY(a) {
            this.d8 = a;
            this.e("RadiusY");
        }
    }
    BarSeriesDescription.$t = /*@__PURE__*/ markType(BarSeriesDescription, 'BarSeriesDescription', VerticalAnchoredCategorySeriesDescription.$);
    return BarSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class BarSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (BarSeriesDescriptionMetadata.a == null) {
                BarSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                BarSeriesDescriptionMetadata.c(a, BarSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            VerticalAnchoredCategorySeriesDescriptionMetadata.c(a, b);
            b.item("RadiusX", "Number:double");
            b.item("RadiusY", "Number:double");
        }
        static d(a) {
            BarSeriesDescriptionMetadata.b(a);
            a.q("BarSeries", () => new BarSeriesDescription());
            a.p("BarSeries", BarSeriesDescriptionMetadata.a);
        }
    }
    BarSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(BarSeriesDescriptionMetadata, 'BarSeriesDescriptionMetadata');
    BarSeriesDescriptionMetadata.a = null;
    return BarSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BarSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class BarSeriesDescriptionModule extends Base {
        static register(a) {
            BarSeriesDescriptionMetadata.d(a);
        }
    }
    BarSeriesDescriptionModule.$t = /*@__PURE__*/ markType(BarSeriesDescriptionModule, 'BarSeriesDescriptionModule');
    return BarSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartVerticalCategoryDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartVerticalCategoryDescriptionModule extends Base {
        static register(a) {
            BarSeriesDescriptionModule.register(a);
            DataChartVerticalCategoryCoreDescriptionModule.register(a);
        }
    }
    DataChartVerticalCategoryDescriptionModule.$t = /*@__PURE__*/ markType(DataChartVerticalCategoryDescriptionModule, 'DataChartVerticalCategoryDescriptionModule');
    return DataChartVerticalCategoryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartVisualDataDescriptionModule = /*@__PURE__*/ (() => {
    class DataChartVisualDataDescriptionModule extends Base {
        static register(a) {
        }
    }
    DataChartVisualDataDescriptionModule.$t = /*@__PURE__*/ markType(DataChartVisualDataDescriptionModule, 'DataChartVisualDataDescriptionModule');
    return DataChartVisualDataDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageColumnDescription = /*@__PURE__*/ (() => {
    class ImageColumnDescription extends ColumnDescription {
        constructor() {
            super();
            this.ey = null;
            this.ex = null;
            this.ev = null;
            this.es = null;
            this.ew = null;
            this.eq = null;
        }
        get_type() {
            return "ImageColumn";
        }
        get imageStretchOption() {
            return this.ey;
        }
        set imageStretchOption(a) {
            this.ey = a;
            this.e("ImageStretchOption");
        }
        get editorType() {
            return this.ex;
        }
        set editorType(a) {
            this.ex = a;
            this.e("EditorType");
        }
        get editorDataSourceRef() {
            return this.ev;
        }
        set editorDataSourceRef(a) {
            this.ev = a;
            this.e("EditorDataSourceRef");
        }
        get editorDataSource() {
            return this.es;
        }
        set editorDataSource(a) {
            this.es = a;
            this.e("EditorDataSource");
        }
        get editorTextField() {
            return this.ew;
        }
        set editorTextField(a) {
            this.ew = a;
            this.e("EditorTextField");
        }
        get editorValueField() {
            return this.eq;
        }
        set editorValueField(a) {
            this.eq = a;
            this.e("EditorValueField");
        }
    }
    ImageColumnDescription.$t = /*@__PURE__*/ markType(ImageColumnDescription, 'ImageColumnDescription', ColumnDescription.$);
    ImageColumnDescription.__canMarshalByValue1 = true;
    return ImageColumnDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageColumnDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageColumnDescriptionMetadata extends Base {
        static b(a) {
            if (ImageColumnDescriptionMetadata.a == null) {
                ImageColumnDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageColumnDescriptionMetadata.c(a, ImageColumnDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnDescriptionMetadata.c(a, b);
            b.item("ImageStretchOption", "ExportedType:string:ImageStretchOptions");
            b.item("ImageStretchOption@names", "Uniform;Fill;None");
            b.item("EditorType", "ExportedType:string:EditorType");
            b.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            b.item("EditorDataSourceRef", "(w:EditorItemsSource,wf:EditorItemsSource)DataRef::object");
            b.item("EditorDataSource", "(w:EditorItemsSource,wf:EditorItemsSource)ExportedType:BaseDataSource:BaseDataSource");
            b.item("EditorTextField", "String");
            b.item("EditorValueField", "Array:string");
        }
        static d(a) {
            ImageColumnDescriptionMetadata.b(a);
            a.q("ImageColumn", () => new ImageColumnDescription());
            a.p("ImageColumn", ImageColumnDescriptionMetadata.a);
        }
    }
    ImageColumnDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageColumnDescriptionMetadata, 'ImageColumnDescriptionMetadata');
    ImageColumnDescriptionMetadata.a = null;
    return ImageColumnDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageColumnDescriptionModule = /*@__PURE__*/ (() => {
    class ImageColumnDescriptionModule extends Base {
        static register(a) {
            ImageColumnDescriptionMetadata.d(a);
        }
    }
    ImageColumnDescriptionModule.$t = /*@__PURE__*/ markType(ImageColumnDescriptionModule, 'ImageColumnDescriptionModule');
    return ImageColumnDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateContentDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateContentDescriptionModule extends Base {
        static register(a) {
        }
    }
    TemplateContentDescriptionModule.$t = /*@__PURE__*/ markType(TemplateContentDescriptionModule, 'TemplateContentDescriptionModule');
    return TemplateContentDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class TemplateHeaderCellUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "TemplateHeaderCellUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    TemplateHeaderCellUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(TemplateHeaderCellUpdatingEventArgsDescription, 'TemplateHeaderCellUpdatingEventArgsDescription', Description.$);
    return TemplateHeaderCellUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateHeaderCellUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a == null) {
                TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.c(a, TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("TemplateHeaderCellUpdatingEventArgs", () => new TemplateHeaderCellUpdatingEventArgsDescription());
            a.p("TemplateHeaderCellUpdatingEventArgs", TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateHeaderCellUpdatingEventArgsDescriptionMetadata, 'TemplateHeaderCellUpdatingEventArgsDescriptionMetadata');
    TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.a = null;
    return TemplateHeaderCellUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderDescription = /*@__PURE__*/ (() => {
    class TemplateHeaderDescription extends HeaderDescription {
        constructor() {
            super();
            this.ck = null;
        }
        get_type() {
            return "TemplateHeader";
        }
        get cellUpdatingRef() {
            return this.ck;
        }
        set cellUpdatingRef(a) {
            this.ck = a;
            this.e("CellUpdatingRef");
        }
    }
    TemplateHeaderDescription.$t = /*@__PURE__*/ markType(TemplateHeaderDescription, 'TemplateHeaderDescription', HeaderDescription.$);
    TemplateHeaderDescription.__canMarshalByValue1 = true;
    return TemplateHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateHeaderDescriptionMetadata.a == null) {
                TemplateHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateHeaderDescriptionMetadata.c(a, TemplateHeaderDescriptionMetadata.a);
                TemplateHeaderCellUpdatingEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            HeaderDescriptionMetadata.c(a, b);
            b.item("CellUpdatingRef", "EventRef::cellUpdating");
        }
        static d(a) {
            TemplateHeaderDescriptionMetadata.b(a);
            a.q("TemplateHeader", () => new TemplateHeaderDescription());
            a.p("TemplateHeader", TemplateHeaderDescriptionMetadata.a);
        }
    }
    TemplateHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateHeaderDescriptionMetadata, 'TemplateHeaderDescriptionMetadata');
    TemplateHeaderDescriptionMetadata.a = null;
    return TemplateHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateHeaderDescriptionModule extends Base {
        static register(a) {
            TemplateHeaderDescriptionMetadata.d(a);
        }
    }
    TemplateHeaderDescriptionModule.$t = /*@__PURE__*/ markType(TemplateHeaderDescriptionModule, 'TemplateHeaderDescriptionModule');
    return TemplateHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridAllColumnsDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridAllColumnsDescriptionModule extends Base {
        static register(a) {
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            ImageColumnDescriptionModule.register(a);
            TemplateColumnDescriptionModule.register(a);
            TemplateContentDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            TemplateHeaderDescriptionModule.register(a);
            ComboBoxColumnDescriptionModule.register(a);
            DataGridCoreDescriptionModule.register(a);
        }
    }
    DataGridAllColumnsDescriptionModule.$t = /*@__PURE__*/ markType(DataGridAllColumnsDescriptionModule, 'DataGridAllColumnsDescriptionModule');
    return DataGridAllColumnsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridExpansionIndicatorDescription = /*@__PURE__*/ (() => {
    class DataGridExpansionIndicatorDescription extends Description {
        constructor() {
            super();
            this.g = false;
            this.n = null;
            this.f = false;
            this.k = 0;
            this.j = 0;
        }
        get_type() {
            return "DataGridExpansionIndicator";
        }
        get type() {
            return this.get_type();
        }
        get isExpanded() {
            return this.g;
        }
        set isExpanded(a) {
            this.g = a;
            this.e("IsExpanded");
        }
        get iconColor() {
            return this.n;
        }
        set iconColor(a) {
            this.n = a;
            this.e("IconColor");
        }
        get isAnimationEnabled() {
            return this.f;
        }
        set isAnimationEnabled(a) {
            this.f = a;
            this.e("IsAnimationEnabled");
        }
        get pixelScalingRatio() {
            return this.k;
        }
        set pixelScalingRatio(a) {
            this.k = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.j;
        }
        set actualPixelScalingRatio(a) {
            this.j = a;
            this.e("ActualPixelScalingRatio");
        }
    }
    DataGridExpansionIndicatorDescription.$t = /*@__PURE__*/ markType(DataGridExpansionIndicatorDescription, 'DataGridExpansionIndicatorDescription', Description.$);
    return DataGridExpansionIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridExpansionIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridExpansionIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridExpansionIndicatorDescriptionMetadata.a == null) {
                DataGridExpansionIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridExpansionIndicatorDescriptionMetadata.c(a, DataGridExpansionIndicatorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsExpanded", "Boolean");
            b.item("IconColor", "Brush");
            b.item("IsAnimationEnabled", "Boolean");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
        }
        static d(a) {
            DataGridExpansionIndicatorDescriptionMetadata.b(a);
            a.q("DataGridExpansionIndicator", () => new DataGridExpansionIndicatorDescription());
            a.p("DataGridExpansionIndicator", DataGridExpansionIndicatorDescriptionMetadata.a);
        }
    }
    DataGridExpansionIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridExpansionIndicatorDescriptionMetadata, 'DataGridExpansionIndicatorDescriptionMetadata');
    DataGridExpansionIndicatorDescriptionMetadata.a = null;
    return DataGridExpansionIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsBaseDescriptionMetadata.a == null) {
                GridColumnOptionsBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsBaseDescriptionMetadata.c(a, GridColumnOptionsBaseDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("AutoSize", "Boolean");
            b.item("BackgroundColor", "Brush");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("ActualBaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("ActualBaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("ButtonDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ButtonDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualButtonDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualButtonDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ButtonFontFamily", "(w:ButtonFontFamily/FontFamilyTransform,wf:ButtonFontFamily,web:buttonTextStyle/FontFamilyTransform)String");
            b.item("ButtonFontSize", "(w:ButtonFontSize,wf:ButtonFontSize,web:buttonTextStyle/FontSizeTransform)Number:double");
            b.item("ButtonFontStyle", "(w:ButtonFontStyle/FontStyleTransform,wf:ButtonFontFamily/FontStyleTransform,web:buttonTextStyle/FontStyleTransform)String");
            b.item("ButtonFontWeight", "(w:ButtonFontWeight/FontWeightTransform,wf:ButtonFontFamily/FontWeightTransform,web:buttonTextStyle/FontWeightTransform)String");
            b.item("Column", "ExportedType:Column");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("LabelFontFamily", "(w:LabelFontFamily/FontFamilyTransform,wf:LabelFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            b.item("LabelFontSize", "(w:LabelFontSize,wf:LabelFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            b.item("LabelFontStyle", "(w:LabelFontStyle/FontStyleTransform,wf:LabelFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            b.item("LabelFontWeight", "(w:LabelFontWeight/FontWeightTransform,wf:LabelFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            b.item("TextColor", "Brush");
        }
        static d(a) {
            GridColumnOptionsBaseDescriptionMetadata.b(a);
            a.p("GridColumnOptionsBase", GridColumnOptionsBaseDescriptionMetadata.a);
        }
    }
    GridColumnOptionsBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsBaseDescriptionMetadata, 'GridColumnOptionsBaseDescriptionMetadata');
    GridColumnOptionsBaseDescriptionMetadata.a = null;
    return GridColumnOptionsBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSectionBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsSectionBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsSectionBaseDescriptionMetadata.a == null) {
                GridColumnOptionsSectionBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsSectionBaseDescriptionMetadata.c(a, GridColumnOptionsSectionBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GridColumnOptionsSectionBaseDescriptionMetadata.b(a);
            a.p("GridColumnOptionsSectionBase", GridColumnOptionsSectionBaseDescriptionMetadata.a);
        }
    }
    GridColumnOptionsSectionBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsSectionBaseDescriptionMetadata, 'GridColumnOptionsSectionBaseDescriptionMetadata');
    GridColumnOptionsSectionBaseDescriptionMetadata.a = null;
    return GridColumnOptionsSectionBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSimpleSectionBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsSimpleSectionBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a == null) {
                GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a, GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a, b);
            b.item("Caption", "String");
            b.item("ShowCaption", "Boolean");
        }
        static d(a) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.b(a);
            a.p("GridColumnOptionsSimpleSectionBase", GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a);
        }
    }
    GridColumnOptionsSimpleSectionBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsSimpleSectionBaseDescriptionMetadata, 'GridColumnOptionsSimpleSectionBaseDescriptionMetadata');
    GridColumnOptionsSimpleSectionBaseDescriptionMetadata.a = null;
    return GridColumnOptionsSimpleSectionBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsBaseDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsBaseDescription extends Description {
        constructor() {
            super();
            this.h = false;
            this.q = null;
            this.r = null;
            this.n = null;
            this.s = null;
            this.o = null;
            this.t = null;
            this.j = 0;
            this.u = null;
            this.v = null;
            this.f = null;
            this.w = null;
            this.p = null;
            this.x = null;
            this.k = 0;
            this.y = null;
            this.z = null;
            this.aa = null;
        }
        get_type() {
            return "GridColumnOptionsBase";
        }
        get type() {
            return this.get_type();
        }
        get autoSize() {
            return this.h;
        }
        set autoSize(a) {
            this.h = a;
            this.e("AutoSize");
        }
        get backgroundColor() {
            return this.q;
        }
        set backgroundColor(a) {
            this.q = a;
            this.e("BackgroundColor");
        }
        get baseTheme() {
            return this.r;
        }
        set baseTheme(a) {
            this.r = a;
            this.e("BaseTheme");
        }
        get actualBaseTheme() {
            return this.n;
        }
        set actualBaseTheme(a) {
            this.n = a;
            this.e("ActualBaseTheme");
        }
        get buttonDensity() {
            return this.s;
        }
        set buttonDensity(a) {
            this.s = a;
            this.e("ButtonDensity");
        }
        get actualButtonDensity() {
            return this.o;
        }
        set actualButtonDensity(a) {
            this.o = a;
            this.e("ActualButtonDensity");
        }
        get buttonFontFamily() {
            return this.t;
        }
        set buttonFontFamily(a) {
            this.t = a;
            this.e("ButtonFontFamily");
        }
        get buttonFontSize() {
            return this.j;
        }
        set buttonFontSize(a) {
            this.j = a;
            this.e("ButtonFontSize");
        }
        get buttonFontStyle() {
            return this.u;
        }
        set buttonFontStyle(a) {
            this.u = a;
            this.e("ButtonFontStyle");
        }
        get buttonFontWeight() {
            return this.v;
        }
        set buttonFontWeight(a) {
            this.v = a;
            this.e("ButtonFontWeight");
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get density() {
            return this.w;
        }
        set density(a) {
            this.w = a;
            this.e("Density");
        }
        get actualDensity() {
            return this.p;
        }
        set actualDensity(a) {
            this.p = a;
            this.e("ActualDensity");
        }
        get labelFontFamily() {
            return this.x;
        }
        set labelFontFamily(a) {
            this.x = a;
            this.e("LabelFontFamily");
        }
        get labelFontSize() {
            return this.k;
        }
        set labelFontSize(a) {
            this.k = a;
            this.e("LabelFontSize");
        }
        get labelFontStyle() {
            return this.y;
        }
        set labelFontStyle(a) {
            this.y = a;
            this.e("LabelFontStyle");
        }
        get labelFontWeight() {
            return this.z;
        }
        set labelFontWeight(a) {
            this.z = a;
            this.e("LabelFontWeight");
        }
        get textColor() {
            return this.aa;
        }
        set textColor(a) {
            this.aa = a;
            this.e("TextColor");
        }
    }
    GridColumnOptionsBaseDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsBaseDescription, 'GridColumnOptionsBaseDescription', Description.$);
    return GridColumnOptionsBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSectionBaseDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsSectionBaseDescription extends GridColumnOptionsBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GridColumnOptionsSectionBase";
        }
    }
    GridColumnOptionsSectionBaseDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsSectionBaseDescription, 'GridColumnOptionsSectionBaseDescription', GridColumnOptionsBaseDescription.$);
    return GridColumnOptionsSectionBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsSimpleSectionBaseDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsSimpleSectionBaseDescription extends GridColumnOptionsSectionBaseDescription {
        constructor() {
            super();
            this.as = null;
            this.aq = false;
        }
        get_type() {
            return "GridColumnOptionsSimpleSectionBase";
        }
        get caption() {
            return this.as;
        }
        set caption(a) {
            this.as = a;
            this.e("Caption");
        }
        get showCaption() {
            return this.aq;
        }
        set showCaption(a) {
            this.aq = a;
            this.e("ShowCaption");
        }
    }
    GridColumnOptionsSimpleSectionBaseDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsSimpleSectionBaseDescription, 'GridColumnOptionsSimpleSectionBaseDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnOptionsSimpleSectionBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSortOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnSortOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        constructor() {
            super();
            this.au = null;
            this.av = null;
            this.aw = null;
        }
        get_type() {
            return "GridColumnSortOptions";
        }
        get ascendingCaption() {
            return this.au;
        }
        set ascendingCaption(a) {
            this.au = a;
            this.e("AscendingCaption");
        }
        get descendingCaption() {
            return this.av;
        }
        set descendingCaption(a) {
            this.av = a;
            this.e("DescendingCaption");
        }
        get sortDirection() {
            return this.aw;
        }
        set sortDirection(a) {
            this.aw = a;
            this.e("SortDirection");
        }
    }
    GridColumnSortOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnSortOptionsDescription, 'GridColumnSortOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnSortOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSortOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnSortOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnSortOptionsDescriptionMetadata.a == null) {
                GridColumnSortOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnSortOptionsDescriptionMetadata.c(a, GridColumnSortOptionsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a, b);
            b.item("AscendingCaption", "String");
            b.item("DescendingCaption", "String");
            b.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            b.item("SortDirection@names", "None;Ascending;Descending");
        }
        static d(a) {
            GridColumnSortOptionsDescriptionMetadata.b(a);
            a.q("GridColumnSortOptions", () => new GridColumnSortOptionsDescription());
            a.p("GridColumnSortOptions", GridColumnSortOptionsDescriptionMetadata.a);
        }
    }
    GridColumnSortOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnSortOptionsDescriptionMetadata, 'GridColumnSortOptionsDescriptionMetadata');
    GridColumnSortOptionsDescriptionMetadata.a = null;
    return GridColumnSortOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSortOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnSortOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnSortOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnSortOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnSortOptionsDescriptionModule, 'GridColumnSortOptionsDescriptionModule');
    return GridColumnSortOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnMoveOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnMoveOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        constructor() {
            super();
            this.au = null;
            this.av = null;
        }
        get_type() {
            return "GridColumnMoveOptions";
        }
        get moveLeftCaption() {
            return this.au;
        }
        set moveLeftCaption(a) {
            this.au = a;
            this.e("MoveLeftCaption");
        }
        get moveRightCaption() {
            return this.av;
        }
        set moveRightCaption(a) {
            this.av = a;
            this.e("MoveRightCaption");
        }
    }
    GridColumnMoveOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnMoveOptionsDescription, 'GridColumnMoveOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnMoveOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnMoveOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnMoveOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnMoveOptionsDescriptionMetadata.a == null) {
                GridColumnMoveOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnMoveOptionsDescriptionMetadata.c(a, GridColumnMoveOptionsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a, b);
            b.item("MoveLeftCaption", "String");
            b.item("MoveRightCaption", "String");
        }
        static d(a) {
            GridColumnMoveOptionsDescriptionMetadata.b(a);
            a.q("GridColumnMoveOptions", () => new GridColumnMoveOptionsDescription());
            a.p("GridColumnMoveOptions", GridColumnMoveOptionsDescriptionMetadata.a);
        }
    }
    GridColumnMoveOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnMoveOptionsDescriptionMetadata, 'GridColumnMoveOptionsDescriptionMetadata');
    GridColumnMoveOptionsDescriptionMetadata.a = null;
    return GridColumnMoveOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnMoveOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnMoveOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnMoveOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnMoveOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnMoveOptionsDescriptionModule, 'GridColumnMoveOptionsDescriptionModule');
    return GridColumnMoveOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnPinOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnPinOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        constructor() {
            super();
            this.au = null;
            this.av = null;
        }
        get_type() {
            return "GridColumnPinOptions";
        }
        get pinLeftCaption() {
            return this.au;
        }
        set pinLeftCaption(a) {
            this.au = a;
            this.e("PinLeftCaption");
        }
        get pinRightCaption() {
            return this.av;
        }
        set pinRightCaption(a) {
            this.av = a;
            this.e("PinRightCaption");
        }
    }
    GridColumnPinOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnPinOptionsDescription, 'GridColumnPinOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnPinOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnPinOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnPinOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnPinOptionsDescriptionMetadata.a == null) {
                GridColumnPinOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnPinOptionsDescriptionMetadata.c(a, GridColumnPinOptionsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a, b);
            b.item("PinLeftCaption", "String");
            b.item("PinRightCaption", "String");
        }
        static d(a) {
            GridColumnPinOptionsDescriptionMetadata.b(a);
            a.q("GridColumnPinOptions", () => new GridColumnPinOptionsDescription());
            a.p("GridColumnPinOptions", GridColumnPinOptionsDescriptionMetadata.a);
        }
    }
    GridColumnPinOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnPinOptionsDescriptionMetadata, 'GridColumnPinOptionsDescriptionMetadata');
    GridColumnPinOptionsDescriptionMetadata.a = null;
    return GridColumnPinOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnPinOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnPinOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnPinOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnPinOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnPinOptionsDescriptionModule, 'GridColumnPinOptionsDescriptionModule');
    return GridColumnPinOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnHideOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnHideOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GridColumnHideOptions";
        }
    }
    GridColumnHideOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnHideOptionsDescription, 'GridColumnHideOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnHideOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnHideOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnHideOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnHideOptionsDescriptionMetadata.a == null) {
                GridColumnHideOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnHideOptionsDescriptionMetadata.c(a, GridColumnHideOptionsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GridColumnHideOptionsDescriptionMetadata.b(a);
            a.q("GridColumnHideOptions", () => new GridColumnHideOptionsDescription());
            a.p("GridColumnHideOptions", GridColumnHideOptionsDescriptionMetadata.a);
        }
    }
    GridColumnHideOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnHideOptionsDescriptionMetadata, 'GridColumnHideOptionsDescriptionMetadata');
    GridColumnHideOptionsDescriptionMetadata.a = null;
    return GridColumnHideOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnHideOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnHideOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnHideOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnHideOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnHideOptionsDescriptionModule, 'GridColumnHideOptionsDescriptionModule');
    return GridColumnHideOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnGroupOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnGroupOptionsDescription extends GridColumnOptionsSimpleSectionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GridColumnGroupOptions";
        }
    }
    GridColumnGroupOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnGroupOptionsDescription, 'GridColumnGroupOptionsDescription', GridColumnOptionsSimpleSectionBaseDescription.$);
    return GridColumnGroupOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnGroupOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnGroupOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnGroupOptionsDescriptionMetadata.a == null) {
                GridColumnGroupOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnGroupOptionsDescriptionMetadata.c(a, GridColumnGroupOptionsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSimpleSectionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GridColumnGroupOptionsDescriptionMetadata.b(a);
            a.q("GridColumnGroupOptions", () => new GridColumnGroupOptionsDescription());
            a.p("GridColumnGroupOptions", GridColumnGroupOptionsDescriptionMetadata.a);
        }
    }
    GridColumnGroupOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnGroupOptionsDescriptionMetadata, 'GridColumnGroupOptionsDescriptionMetadata');
    GridColumnGroupOptionsDescriptionMetadata.a = null;
    return GridColumnGroupOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnGroupOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnGroupOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnGroupOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnGroupOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnGroupOptionsDescriptionModule, 'GridColumnGroupOptionsDescriptionModule');
    return GridColumnGroupOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterApplyButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class FilterApplyButtonClickEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FilterApplyButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    FilterApplyButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(FilterApplyButtonClickEventArgsDescription, 'FilterApplyButtonClickEventArgsDescription', Description.$);
    return FilterApplyButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterApplyButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterApplyButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FilterApplyButtonClickEventArgsDescriptionMetadata.a == null) {
                FilterApplyButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterApplyButtonClickEventArgsDescriptionMetadata.c(a, FilterApplyButtonClickEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FilterApplyButtonClickEventArgsDescriptionMetadata.b(a);
            a.q("FilterApplyButtonClickEventArgs", () => new FilterApplyButtonClickEventArgsDescription());
            a.p("FilterApplyButtonClickEventArgs", FilterApplyButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    FilterApplyButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterApplyButtonClickEventArgsDescriptionMetadata, 'FilterApplyButtonClickEventArgsDescriptionMetadata');
    FilterApplyButtonClickEventArgsDescriptionMetadata.a = null;
    return FilterApplyButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterCancelButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class FilterCancelButtonClickEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FilterCancelButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    FilterCancelButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(FilterCancelButtonClickEventArgsDescription, 'FilterCancelButtonClickEventArgsDescription', Description.$);
    return FilterCancelButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterCancelButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterCancelButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FilterCancelButtonClickEventArgsDescriptionMetadata.a == null) {
                FilterCancelButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterCancelButtonClickEventArgsDescriptionMetadata.c(a, FilterCancelButtonClickEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FilterCancelButtonClickEventArgsDescriptionMetadata.b(a);
            a.q("FilterCancelButtonClickEventArgs", () => new FilterCancelButtonClickEventArgsDescription());
            a.p("FilterCancelButtonClickEventArgs", FilterCancelButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    FilterCancelButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterCancelButtonClickEventArgsDescriptionMetadata, 'FilterCancelButtonClickEventArgsDescriptionMetadata');
    FilterCancelButtonClickEventArgsDescriptionMetadata.a = null;
    return FilterCancelButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnFilterOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnFilterOptionsDescription extends GridColumnOptionsSectionBaseDescription {
        constructor() {
            super();
            this.ar = null;
            this.at = null;
            this.av = null;
            this.ax = null;
            this.aw = null;
            this.aq = null;
            this.ay = null;
            this.as = null;
            this.au = null;
        }
        get_type() {
            return "GridColumnFilterOptions";
        }
        get applyButtonCaption() {
            return this.ar;
        }
        set applyButtonCaption(a) {
            this.ar = a;
            this.e("ApplyButtonCaption");
        }
        get cancelButtonCaption() {
            return this.at;
        }
        set cancelButtonCaption(a) {
            this.at = a;
            this.e("CancelButtonCaption");
        }
        get clearColumnFiltersCaption() {
            return this.av;
        }
        set clearColumnFiltersCaption(a) {
            this.av = a;
            this.e("ClearColumnFiltersCaption");
        }
        get filterListPlaceholderText() {
            return this.ax;
        }
        set filterListPlaceholderText(a) {
            this.ax = a;
            this.e("FilterListPlaceholderText");
        }
        get filterListDensity() {
            return this.aw;
        }
        set filterListDensity(a) {
            this.aw = a;
            this.e("FilterListDensity");
        }
        get actualFilterListDensity() {
            return this.aq;
        }
        set actualFilterListDensity(a) {
            this.aq = a;
            this.e("ActualFilterListDensity");
        }
        get textFilterCaption() {
            return this.ay;
        }
        set textFilterCaption(a) {
            this.ay = a;
            this.e("TextFilterCaption");
        }
        get applyButtonClickRef() {
            return this.as;
        }
        set applyButtonClickRef(a) {
            this.as = a;
            this.e("ApplyButtonClickRef");
        }
        get cancelButtonClickRef() {
            return this.au;
        }
        set cancelButtonClickRef(a) {
            this.au = a;
            this.e("CancelButtonClickRef");
        }
    }
    GridColumnFilterOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnFilterOptionsDescription, 'GridColumnFilterOptionsDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnFilterOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnFilterOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnFilterOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnFilterOptionsDescriptionMetadata.a == null) {
                GridColumnFilterOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnFilterOptionsDescriptionMetadata.c(a, GridColumnFilterOptionsDescriptionMetadata.a);
                FilterApplyButtonClickEventArgsDescriptionMetadata.d(a);
                FilterCancelButtonClickEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a, b);
            b.item("ApplyButtonCaption", "String");
            b.item("CancelButtonCaption", "String");
            b.item("ClearColumnFiltersCaption", "String");
            b.item("FilterListPlaceholderText", "String");
            b.item("FilterListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("FilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualFilterListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualFilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("TextFilterCaption", "String");
            b.item("ApplyButtonClickRef", "EventRef::applyButtonClick");
            b.item("CancelButtonClickRef", "EventRef::cancelButtonClick");
        }
        static d(a) {
            GridColumnFilterOptionsDescriptionMetadata.b(a);
            a.q("GridColumnFilterOptions", () => new GridColumnFilterOptionsDescription());
            a.p("GridColumnFilterOptions", GridColumnFilterOptionsDescriptionMetadata.a);
        }
    }
    GridColumnFilterOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnFilterOptionsDescriptionMetadata, 'GridColumnFilterOptionsDescriptionMetadata');
    GridColumnFilterOptionsDescriptionMetadata.a = null;
    return GridColumnFilterOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnFilterOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnFilterOptionsDescriptionModule extends Base {
        static register(a) {
            CheckboxListDescriptionModule.register(a);
            GridColumnFilterOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnFilterOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnFilterOptionsDescriptionModule, 'GridColumnFilterOptionsDescriptionModule');
    return GridColumnFilterOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSummaryOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnSummaryOptionsDescription extends GridColumnOptionsSectionBaseDescription {
        constructor() {
            super();
            this.at = null;
            this.au = null;
            this.as = null;
            this.aq = 0;
        }
        get_type() {
            return "GridColumnSummaryOptions";
        }
        get summaryCaption() {
            return this.at;
        }
        set summaryCaption(a) {
            this.at = a;
            this.e("SummaryCaption");
        }
        get summaryListDensity() {
            return this.au;
        }
        set summaryListDensity(a) {
            this.au = a;
            this.e("SummaryListDensity");
        }
        get actualSummaryListDensity() {
            return this.as;
        }
        set actualSummaryListDensity(a) {
            this.as = a;
            this.e("ActualSummaryListDensity");
        }
        get activeCount() {
            return this.aq;
        }
        set activeCount(a) {
            this.aq = a;
            this.e("ActiveCount");
        }
    }
    GridColumnSummaryOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnSummaryOptionsDescription, 'GridColumnSummaryOptionsDescription', GridColumnOptionsSectionBaseDescription.$);
    return GridColumnSummaryOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSummaryOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnSummaryOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnSummaryOptionsDescriptionMetadata.a == null) {
                GridColumnSummaryOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnSummaryOptionsDescriptionMetadata.c(a, GridColumnSummaryOptionsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GridColumnOptionsSectionBaseDescriptionMetadata.c(a, b);
            b.item("SummaryCaption", "String");
            b.item("SummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("SummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualSummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualSummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActiveCount", "Number:int");
        }
        static d(a) {
            GridColumnSummaryOptionsDescriptionMetadata.b(a);
            a.q("GridColumnSummaryOptions", () => new GridColumnSummaryOptionsDescription());
            a.p("GridColumnSummaryOptions", GridColumnSummaryOptionsDescriptionMetadata.a);
        }
    }
    GridColumnSummaryOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnSummaryOptionsDescriptionMetadata, 'GridColumnSummaryOptionsDescriptionMetadata');
    GridColumnSummaryOptionsDescriptionMetadata.a = null;
    return GridColumnSummaryOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryChooserDescriptionModule = /*@__PURE__*/ (() => {
    class SummaryChooserDescriptionModule extends Base {
        static register(a) {
        }
    }
    SummaryChooserDescriptionModule.$t = /*@__PURE__*/ markType(SummaryChooserDescriptionModule, 'SummaryChooserDescriptionModule');
    return SummaryChooserDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnSummaryOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnSummaryOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnSummaryOptionsDescriptionMetadata.d(a);
            CheckboxListDescriptionModule.register(a);
            SummaryChooserDescriptionModule.register(a);
        }
    }
    GridColumnSummaryOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnSummaryOptionsDescriptionModule, 'GridColumnSummaryOptionsDescriptionModule');
    return GridColumnSummaryOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsDescription = /*@__PURE__*/ (() => {
    class GridColumnOptionsDescription extends GridColumnOptionsBaseDescription {
        constructor() {
            super();
            this.bl = null;
            this.a6 = 0;
            this.bm = null;
            this.bn = null;
            this.a9 = 0;
            this.bb = 0;
            this.ba = 0;
            this.a8 = 0;
            this.as = false;
            this.aw = false;
            this.au = false;
            this.av = false;
            this.at = false;
            this.ar = false;
            this.aq = false;
            this.ax = false;
            this.b0 = null;
            this.by = null;
            this.bz = null;
            this.bs = null;
            this.bt = null;
            this.bu = null;
            this.bv = null;
            this.bw = null;
            this.bx = null;
            this.bi = null;
            this.bj = null;
            this.bk = null;
            this.b1 = null;
            this.bh = null;
            this.bq = null;
            this.bg = null;
            this.br = null;
            this.bo = null;
            this.bp = null;
        }
        get_type() {
            return "GridColumnOptions";
        }
        get columnNameFontFamily() {
            return this.bl;
        }
        set columnNameFontFamily(a) {
            this.bl = a;
            this.e("ColumnNameFontFamily");
        }
        get columnNameFontSize() {
            return this.a6;
        }
        set columnNameFontSize(a) {
            this.a6 = a;
            this.e("ColumnNameFontSize");
        }
        get columnNameFontStyle() {
            return this.bm;
        }
        set columnNameFontStyle(a) {
            this.bm = a;
            this.e("ColumnNameFontStyle");
        }
        get columnNameFontWeight() {
            return this.bn;
        }
        set columnNameFontWeight(a) {
            this.bn = a;
            this.e("ColumnNameFontWeight");
        }
        get paddingLeft() {
            return this.a9;
        }
        set paddingLeft(a) {
            this.a9 = a;
            this.e("PaddingLeft");
        }
        get paddingTop() {
            return this.bb;
        }
        set paddingTop(a) {
            this.bb = a;
            this.e("PaddingTop");
        }
        get paddingRight() {
            return this.ba;
        }
        set paddingRight(a) {
            this.ba = a;
            this.e("PaddingRight");
        }
        get paddingBottom() {
            return this.a8;
        }
        set paddingBottom(a) {
            this.a8 = a;
            this.e("PaddingBottom");
        }
        get headerVisible() {
            return this.as;
        }
        set headerVisible(a) {
            this.as = a;
            this.e("HeaderVisible");
        }
        get sortOptionsVisible() {
            return this.aw;
        }
        set sortOptionsVisible(a) {
            this.aw = a;
            this.e("SortOptionsVisible");
        }
        get moveOptionsVisible() {
            return this.au;
        }
        set moveOptionsVisible(a) {
            this.au = a;
            this.e("MoveOptionsVisible");
        }
        get pinOptionsVisible() {
            return this.av;
        }
        set pinOptionsVisible(a) {
            this.av = a;
            this.e("PinOptionsVisible");
        }
        get hideOptionsVisible() {
            return this.at;
        }
        set hideOptionsVisible(a) {
            this.at = a;
            this.e("HideOptionsVisible");
        }
        get groupOptionsVisible() {
            return this.ar;
        }
        set groupOptionsVisible(a) {
            this.ar = a;
            this.e("GroupOptionsVisible");
        }
        get filterOptionsVisible() {
            return this.aq;
        }
        set filterOptionsVisible(a) {
            this.aq = a;
            this.e("FilterOptionsVisible");
        }
        get summaryOptionsVisible() {
            return this.ax;
        }
        set summaryOptionsVisible(a) {
            this.ax = a;
            this.e("SummaryOptionsVisible");
        }
        get sortHeaderCaption() {
            return this.b0;
        }
        set sortHeaderCaption(a) {
            this.b0 = a;
            this.e("SortHeaderCaption");
        }
        get sortAscendingCaption() {
            return this.by;
        }
        set sortAscendingCaption(a) {
            this.by = a;
            this.e("SortAscendingCaption");
        }
        get sortDescendingCaption() {
            return this.bz;
        }
        set sortDescendingCaption(a) {
            this.bz = a;
            this.e("SortDescendingCaption");
        }
        get moveHeaderCaption() {
            return this.bs;
        }
        set moveHeaderCaption(a) {
            this.bs = a;
            this.e("MoveHeaderCaption");
        }
        get moveLeftCaption() {
            return this.bt;
        }
        set moveLeftCaption(a) {
            this.bt = a;
            this.e("MoveLeftCaption");
        }
        get moveRightCaption() {
            return this.bu;
        }
        set moveRightCaption(a) {
            this.bu = a;
            this.e("MoveRightCaption");
        }
        get pinHeaderCaption() {
            return this.bv;
        }
        set pinHeaderCaption(a) {
            this.bv = a;
            this.e("PinHeaderCaption");
        }
        get pinLeftCaption() {
            return this.bw;
        }
        set pinLeftCaption(a) {
            this.bw = a;
            this.e("PinLeftCaption");
        }
        get pinRightCaption() {
            return this.bx;
        }
        set pinRightCaption(a) {
            this.bx = a;
            this.e("PinRightCaption");
        }
        get applyFiltersButtonCaption() {
            return this.bi;
        }
        set applyFiltersButtonCaption(a) {
            this.bi = a;
            this.e("ApplyFiltersButtonCaption");
        }
        get cancelFiltersButtonCaption() {
            return this.bj;
        }
        set cancelFiltersButtonCaption(a) {
            this.bj = a;
            this.e("CancelFiltersButtonCaption");
        }
        get clearColumnFiltersCaption() {
            return this.bk;
        }
        set clearColumnFiltersCaption(a) {
            this.bk = a;
            this.e("ClearColumnFiltersCaption");
        }
        get summaryListDensity() {
            return this.b1;
        }
        set summaryListDensity(a) {
            this.b1 = a;
            this.e("SummaryListDensity");
        }
        get actualSummaryListDensity() {
            return this.bh;
        }
        set actualSummaryListDensity(a) {
            this.bh = a;
            this.e("ActualSummaryListDensity");
        }
        get filterListDensity() {
            return this.bq;
        }
        set filterListDensity(a) {
            this.bq = a;
            this.e("FilterListDensity");
        }
        get actualFilterListDensity() {
            return this.bg;
        }
        set actualFilterListDensity(a) {
            this.bg = a;
            this.e("ActualFilterListDensity");
        }
        get filterListPlaceholderText() {
            return this.br;
        }
        set filterListPlaceholderText(a) {
            this.br = a;
            this.e("FilterListPlaceholderText");
        }
        get filterApplyButtonClickRef() {
            return this.bo;
        }
        set filterApplyButtonClickRef(a) {
            this.bo = a;
            this.e("FilterApplyButtonClickRef");
        }
        get filterCancelButtonClickRef() {
            return this.bp;
        }
        set filterCancelButtonClickRef(a) {
            this.bp = a;
            this.e("FilterCancelButtonClickRef");
        }
    }
    GridColumnOptionsDescription.$t = /*@__PURE__*/ markType(GridColumnOptionsDescription, 'GridColumnOptionsDescription', GridColumnOptionsBaseDescription.$);
    return GridColumnOptionsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridColumnOptionsDescriptionMetadata extends Base {
        static b(a) {
            if (GridColumnOptionsDescriptionMetadata.a == null) {
                GridColumnOptionsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridColumnOptionsDescriptionMetadata.c(a, GridColumnOptionsDescriptionMetadata.a);
                FilterApplyButtonClickEventArgsDescriptionMetadata.d(a);
                FilterCancelButtonClickEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GridColumnOptionsBaseDescriptionMetadata.c(a, b);
            b.item("ColumnNameFontFamily", "(w:ColumnNameFontFamily/FontFamilyTransform,wf:ColumnNameFontFamily,web:columnNameTextStyle/FontFamilyTransform)String");
            b.item("ColumnNameFontSize", "(w:ColumnNameFontSize,wf:ColumnNameFontSize,web:columnNameTextStyle/FontSizeTransform)Number:double");
            b.item("ColumnNameFontStyle", "(w:ColumnNameFontStyle/FontStyleTransform,wf:ColumnNameFontFamily/FontStyleTransform,web:columnNameTextStyle/FontStyleTransform)String");
            b.item("ColumnNameFontWeight", "(w:ColumnNameFontWeight/FontWeightTransform,wf:ColumnNameFontFamily/FontWeightTransform,web:columnNameTextStyle/FontWeightTransform)String");
            b.item("PaddingLeft", "Number:int");
            b.item("PaddingTop", "Number:int");
            b.item("PaddingRight", "Number:int");
            b.item("PaddingBottom", "Number:int");
            b.item("HeaderVisible", "Boolean");
            b.item("SortOptionsVisible", "Boolean");
            b.item("MoveOptionsVisible", "Boolean");
            b.item("PinOptionsVisible", "Boolean");
            b.item("HideOptionsVisible", "Boolean");
            b.item("GroupOptionsVisible", "Boolean");
            b.item("FilterOptionsVisible", "Boolean");
            b.item("SummaryOptionsVisible", "Boolean");
            b.item("SortHeaderCaption", "String");
            b.item("SortAscendingCaption", "String");
            b.item("SortDescendingCaption", "String");
            b.item("MoveHeaderCaption", "String");
            b.item("MoveLeftCaption", "String");
            b.item("MoveRightCaption", "String");
            b.item("PinHeaderCaption", "String");
            b.item("PinLeftCaption", "String");
            b.item("PinRightCaption", "String");
            b.item("ApplyFiltersButtonCaption", "String");
            b.item("CancelFiltersButtonCaption", "String");
            b.item("ClearColumnFiltersCaption", "String");
            b.item("SummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("SummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualSummaryListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualSummaryListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("FilterListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("FilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualFilterListDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualFilterListDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("FilterListPlaceholderText", "String");
            b.item("FilterApplyButtonClickRef", "EventRef::filterApplyButtonClick");
            b.item("FilterCancelButtonClickRef", "EventRef::filterCancelButtonClick");
        }
        static d(a) {
            GridColumnOptionsDescriptionMetadata.b(a);
            a.q("GridColumnOptions", () => new GridColumnOptionsDescription());
            a.p("GridColumnOptions", GridColumnOptionsDescriptionMetadata.a);
        }
    }
    GridColumnOptionsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridColumnOptionsDescriptionMetadata, 'GridColumnOptionsDescriptionMetadata');
    GridColumnOptionsDescriptionMetadata.a = null;
    return GridColumnOptionsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridColumnOptionsDescriptionModule = /*@__PURE__*/ (() => {
    class GridColumnOptionsDescriptionModule extends Base {
        static register(a) {
            GridColumnSortOptionsDescriptionModule.register(a);
            GridColumnMoveOptionsDescriptionModule.register(a);
            GridColumnPinOptionsDescriptionModule.register(a);
            GridColumnHideOptionsDescriptionModule.register(a);
            GridColumnGroupOptionsDescriptionModule.register(a);
            GridColumnFilterOptionsDescriptionModule.register(a);
            GridColumnSummaryOptionsDescriptionModule.register(a);
            GridColumnOptionsDescriptionMetadata.d(a);
        }
    }
    GridColumnOptionsDescriptionModule.$t = /*@__PURE__*/ markType(GridColumnOptionsDescriptionModule, 'GridColumnOptionsDescriptionModule');
    return GridColumnOptionsDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GotFocusEventArgsDescription = /*@__PURE__*/ (() => {
    class GotFocusEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "GotFocusEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    GotFocusEventArgsDescription.$t = /*@__PURE__*/ markType(GotFocusEventArgsDescription, 'GotFocusEventArgsDescription', Description.$);
    return GotFocusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GotFocusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GotFocusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GotFocusEventArgsDescriptionMetadata.a == null) {
                GotFocusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GotFocusEventArgsDescriptionMetadata.c(a, GotFocusEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            GotFocusEventArgsDescriptionMetadata.b(a);
            a.q("GotFocusEventArgs", () => new GotFocusEventArgsDescription());
            a.p("GotFocusEventArgs", GotFocusEventArgsDescriptionMetadata.a);
        }
    }
    GotFocusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GotFocusEventArgsDescriptionMetadata, 'GotFocusEventArgsDescriptionMetadata');
    GotFocusEventArgsDescriptionMetadata.a = null;
    return GotFocusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LostFocusEventArgsDescription = /*@__PURE__*/ (() => {
    class LostFocusEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "LostFocusEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    LostFocusEventArgsDescription.$t = /*@__PURE__*/ markType(LostFocusEventArgsDescription, 'LostFocusEventArgsDescription', Description.$);
    return LostFocusEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LostFocusEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LostFocusEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LostFocusEventArgsDescriptionMetadata.a == null) {
                LostFocusEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LostFocusEventArgsDescriptionMetadata.c(a, LostFocusEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            LostFocusEventArgsDescriptionMetadata.b(a);
            a.q("LostFocusEventArgs", () => new LostFocusEventArgsDescription());
            a.p("LostFocusEventArgs", LostFocusEventArgsDescriptionMetadata.a);
        }
    }
    LostFocusEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LostFocusEventArgsDescriptionMetadata, 'LostFocusEventArgsDescriptionMetadata');
    LostFocusEventArgsDescriptionMetadata.a = null;
    return LostFocusEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxTextChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxTextChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "MultiColumnComboBoxTextChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    MultiColumnComboBoxTextChangedEventArgsDescription.$t = /*@__PURE__*/ markType(MultiColumnComboBoxTextChangedEventArgsDescription, 'MultiColumnComboBoxTextChangedEventArgsDescription', Description.$);
    return MultiColumnComboBoxTextChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a == null) {
                MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.c(a, MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.b(a);
            a.q("MultiColumnComboBoxTextChangedEventArgs", () => new MultiColumnComboBoxTextChangedEventArgsDescription());
            a.p("MultiColumnComboBoxTextChangedEventArgs", MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a);
        }
    }
    MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata, 'MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata');
    MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.a = null;
    return MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxValueChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "MultiColumnComboBoxValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    MultiColumnComboBoxValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(MultiColumnComboBoxValueChangedEventArgsDescription, 'MultiColumnComboBoxValueChangedEventArgsDescription', Description.$);
    return MultiColumnComboBoxValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a == null) {
                MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.c(a, MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.b(a);
            a.q("MultiColumnComboBoxValueChangedEventArgs", () => new MultiColumnComboBoxValueChangedEventArgsDescription());
            a.p("MultiColumnComboBoxValueChangedEventArgs", MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata, 'MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata');
    MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.a = null;
    return MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxDescription = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxDescription extends Description {
        constructor() {
            super();
            this.s = false;
            this.h = null;
            this.cv = null;
            this.ch = null;
            this.cw = null;
            this.ci = null;
            this.cx = null;
            this.cj = null;
            this.ar = 0;
            this.z = 0;
            this.p = false;
            this.as = 0;
            this.at = 0;
            this.au = 0;
            this.av = 0;
            this.aa = 0;
            this.ab = 0;
            this.ac = 0;
            this.ad = 0;
            this.ax = 0;
            this.aw = 0;
            this.ay = 0;
            this.az = 0;
            this.af = 0;
            this.ae = 0;
            this.ag = 0;
            this.ah = 0;
            this.g = null;
            this.c1 = null;
            this.ck = null;
            this.q = false;
            this.c2 = null;
            this.cl = null;
            this.a0 = 0;
            this.ai = 0;
            this.c3 = null;
            this.cm = null;
            this.a1 = 0;
            this.aj = 0;
            this.a2 = 0;
            this.ak = 0;
            this.c8 = null;
            this.cn = null;
            this.a4 = 0;
            this.al = 0;
            this.a5 = 0;
            this.am = 0;
            this.c0 = null;
            this.da = null;
            this.de = null;
            this.co = null;
            this.db = null;
            this.a6 = 0;
            this.dc = null;
            this.dd = null;
            this.n = false;
            this.dg = null;
            this.cp = null;
            this.dh = null;
            this.cq = null;
            this.dl = null;
            this.cr = null;
            this.di = null;
            this.a7 = 0;
            this.dj = null;
            this.dk = null;
            this.dm = null;
            this.r = false;
            this.dr = null;
            this.cs = null;
            this.c4 = null;
            this.a3 = 0;
            this.c5 = null;
            this.c6 = null;
            this.dt = null;
            this.ct = null;
            this.a8 = 0;
            this.an = 0;
            this.du = null;
            this.cu = null;
            this.a9 = 0;
            this.ao = 0;
            this.ba = 0;
            this.ap = 0;
            this.bb = 0;
            this.aq = 0;
            this.o = false;
            this.dn = null;
            this.ds = null;
            this.dp = null;
            this.i = null;
            this.f = null;
            this.cf = null;
            this.c7 = null;
            this.df = null;
            this.dq = null;
            this.dv = null;
            this.c9 = null;
            this.cy = null;
            this.cz = null;
        }
        get_type() {
            return "MultiColumnComboBox";
        }
        get type() {
            return this.get_type();
        }
        get showClearButton() {
            return this.s;
        }
        set showClearButton(a) {
            this.s = a;
            this.e("ShowClearButton");
        }
        get fields() {
            return this.h;
        }
        set fields(a) {
            this.h = a;
            this.e("Fields");
        }
        get backgroundColor() {
            return this.cv;
        }
        set backgroundColor(a) {
            this.cv = a;
            this.e("BackgroundColor");
        }
        get actualBackgroundColor() {
            return this.ch;
        }
        set actualBackgroundColor(a) {
            this.ch = a;
            this.e("ActualBackgroundColor");
        }
        get baseTheme() {
            return this.cw;
        }
        set baseTheme(a) {
            this.cw = a;
            this.e("BaseTheme");
        }
        get actualBaseTheme() {
            return this.ci;
        }
        set actualBaseTheme(a) {
            this.ci = a;
            this.e("ActualBaseTheme");
        }
        get borderColor() {
            return this.cx;
        }
        set borderColor(a) {
            this.cx = a;
            this.e("BorderColor");
        }
        get actualBorderColor() {
            return this.cj;
        }
        set actualBorderColor(a) {
            this.cj = a;
            this.e("ActualBorderColor");
        }
        get borderWidth() {
            return this.ar;
        }
        set borderWidth(a) {
            this.ar = a;
            this.e("BorderWidth");
        }
        get actualBorderWidth() {
            return this.z;
        }
        set actualBorderWidth(a) {
            this.z = a;
            this.e("ActualBorderWidth");
        }
        get columnHeadersVisible() {
            return this.p;
        }
        set columnHeadersVisible(a) {
            this.p = a;
            this.e("ColumnHeadersVisible");
        }
        get contentPaddingBottom() {
            return this.as;
        }
        set contentPaddingBottom(a) {
            this.as = a;
            this.e("ContentPaddingBottom");
        }
        get contentPaddingLeft() {
            return this.at;
        }
        set contentPaddingLeft(a) {
            this.at = a;
            this.e("ContentPaddingLeft");
        }
        get contentPaddingRight() {
            return this.au;
        }
        set contentPaddingRight(a) {
            this.au = a;
            this.e("ContentPaddingRight");
        }
        get contentPaddingTop() {
            return this.av;
        }
        set contentPaddingTop(a) {
            this.av = a;
            this.e("ContentPaddingTop");
        }
        get actualContentPaddingBottom() {
            return this.aa;
        }
        set actualContentPaddingBottom(a) {
            this.aa = a;
            this.e("ActualContentPaddingBottom");
        }
        get actualContentPaddingLeft() {
            return this.ab;
        }
        set actualContentPaddingLeft(a) {
            this.ab = a;
            this.e("ActualContentPaddingLeft");
        }
        get actualContentPaddingRight() {
            return this.ac;
        }
        set actualContentPaddingRight(a) {
            this.ac = a;
            this.e("ActualContentPaddingRight");
        }
        get actualContentPaddingTop() {
            return this.ad;
        }
        set actualContentPaddingTop(a) {
            this.ad = a;
            this.e("ActualContentPaddingTop");
        }
        get cornerRadiusBottomRight() {
            return this.ax;
        }
        set cornerRadiusBottomRight(a) {
            this.ax = a;
            this.e("CornerRadiusBottomRight");
        }
        get cornerRadiusBottomLeft() {
            return this.aw;
        }
        set cornerRadiusBottomLeft(a) {
            this.aw = a;
            this.e("CornerRadiusBottomLeft");
        }
        get cornerRadiusTopLeft() {
            return this.ay;
        }
        set cornerRadiusTopLeft(a) {
            this.ay = a;
            this.e("CornerRadiusTopLeft");
        }
        get cornerRadiusTopRight() {
            return this.az;
        }
        set cornerRadiusTopRight(a) {
            this.az = a;
            this.e("CornerRadiusTopRight");
        }
        get actualCornerRadiusBottomRight() {
            return this.af;
        }
        set actualCornerRadiusBottomRight(a) {
            this.af = a;
            this.e("ActualCornerRadiusBottomRight");
        }
        get actualCornerRadiusBottomLeft() {
            return this.ae;
        }
        set actualCornerRadiusBottomLeft(a) {
            this.ae = a;
            this.e("ActualCornerRadiusBottomLeft");
        }
        get actualCornerRadiusTopLeft() {
            return this.ag;
        }
        set actualCornerRadiusTopLeft(a) {
            this.ag = a;
            this.e("ActualCornerRadiusTopLeft");
        }
        get actualCornerRadiusTopRight() {
            return this.ah;
        }
        set actualCornerRadiusTopRight(a) {
            this.ah = a;
            this.e("ActualCornerRadiusTopRight");
        }
        get dataSourceDesiredProperties() {
            return this.g;
        }
        set dataSourceDesiredProperties(a) {
            this.g = a;
            this.e("DataSourceDesiredProperties");
        }
        get density() {
            return this.c1;
        }
        set density(a) {
            this.c1 = a;
            this.e("Density");
        }
        get actualDensity() {
            return this.ck;
        }
        set actualDensity(a) {
            this.ck = a;
            this.e("ActualDensity");
        }
        get dropDownButtonVisible() {
            return this.q;
        }
        set dropDownButtonVisible(a) {
            this.q = a;
            this.e("DropDownButtonVisible");
        }
        get focusBorderColor() {
            return this.c2;
        }
        set focusBorderColor(a) {
            this.c2 = a;
            this.e("FocusBorderColor");
        }
        get actualFocusBorderColor() {
            return this.cl;
        }
        set actualFocusBorderColor(a) {
            this.cl = a;
            this.e("ActualFocusBorderColor");
        }
        get focusBorderWidth() {
            return this.a0;
        }
        set focusBorderWidth(a) {
            this.a0 = a;
            this.e("FocusBorderWidth");
        }
        get actualFocusBorderWidth() {
            return this.ai;
        }
        set actualFocusBorderWidth(a) {
            this.ai = a;
            this.e("ActualFocusBorderWidth");
        }
        get focusUnderlineColor() {
            return this.c3;
        }
        set focusUnderlineColor(a) {
            this.c3 = a;
            this.e("FocusUnderlineColor");
        }
        get actualFocusUnderlineColor() {
            return this.cm;
        }
        set actualFocusUnderlineColor(a) {
            this.cm = a;
            this.e("ActualFocusUnderlineColor");
        }
        get focusUnderlineOpacity() {
            return this.a1;
        }
        set focusUnderlineOpacity(a) {
            this.a1 = a;
            this.e("FocusUnderlineOpacity");
        }
        get actualFocusUnderlineOpacity() {
            return this.aj;
        }
        set actualFocusUnderlineOpacity(a) {
            this.aj = a;
            this.e("ActualFocusUnderlineOpacity");
        }
        get focusUnderlineRippleOpacity() {
            return this.a2;
        }
        set focusUnderlineRippleOpacity(a) {
            this.a2 = a;
            this.e("FocusUnderlineRippleOpacity");
        }
        get actualFocusUnderlineRippleOpacity() {
            return this.ak;
        }
        set actualFocusUnderlineRippleOpacity(a) {
            this.ak = a;
            this.e("ActualFocusUnderlineRippleOpacity");
        }
        get hoverUnderlineColor() {
            return this.c8;
        }
        set hoverUnderlineColor(a) {
            this.c8 = a;
            this.e("HoverUnderlineColor");
        }
        get actualHoverUnderlineColor() {
            return this.cn;
        }
        set actualHoverUnderlineColor(a) {
            this.cn = a;
            this.e("ActualHoverUnderlineColor");
        }
        get hoverUnderlineOpacity() {
            return this.a4;
        }
        set hoverUnderlineOpacity(a) {
            this.a4 = a;
            this.e("HoverUnderlineOpacity");
        }
        get actualHoverUnderlineOpacity() {
            return this.al;
        }
        set actualHoverUnderlineOpacity(a) {
            this.al = a;
            this.e("ActualHoverUnderlineOpacity");
        }
        get hoverUnderlineWidth() {
            return this.a5;
        }
        set hoverUnderlineWidth(a) {
            this.a5 = a;
            this.e("HoverUnderlineWidth");
        }
        get actualHoverUnderlineWidth() {
            return this.am;
        }
        set actualHoverUnderlineWidth(a) {
            this.am = a;
            this.e("ActualHoverUnderlineWidth");
        }
        get dataSourceRef() {
            return this.c0;
        }
        set dataSourceRef(a) {
            this.c0 = a;
            this.e("DataSourceRef");
        }
        get label() {
            return this.da;
        }
        set label(a) {
            this.da = a;
            this.e("Label");
        }
        get labelTextColor() {
            return this.de;
        }
        set labelTextColor(a) {
            this.de = a;
            this.e("LabelTextColor");
        }
        get actualLabelTextColor() {
            return this.co;
        }
        set actualLabelTextColor(a) {
            this.co = a;
            this.e("ActualLabelTextColor");
        }
        get labelFontFamily() {
            return this.db;
        }
        set labelFontFamily(a) {
            this.db = a;
            this.e("LabelFontFamily");
        }
        get labelFontSize() {
            return this.a6;
        }
        set labelFontSize(a) {
            this.a6 = a;
            this.e("LabelFontSize");
        }
        get labelFontStyle() {
            return this.dc;
        }
        set labelFontStyle(a) {
            this.dc = a;
            this.e("LabelFontStyle");
        }
        get labelFontWeight() {
            return this.dd;
        }
        set labelFontWeight(a) {
            this.dd = a;
            this.e("LabelFontWeight");
        }
        get actualLabelVisible() {
            return this.n;
        }
        set actualLabelVisible(a) {
            this.n = a;
            this.e("ActualLabelVisible");
        }
        get noMatchesFoundLabel() {
            return this.dg;
        }
        set noMatchesFoundLabel(a) {
            this.dg = a;
            this.e("NoMatchesFoundLabel");
        }
        get actualNoMatchesFoundLabel() {
            return this.cp;
        }
        set actualNoMatchesFoundLabel(a) {
            this.cp = a;
            this.e("ActualNoMatchesFoundLabel");
        }
        get noMatchesFoundLabelBackgroundColor() {
            return this.dh;
        }
        set noMatchesFoundLabelBackgroundColor(a) {
            this.dh = a;
            this.e("NoMatchesFoundLabelBackgroundColor");
        }
        get actualNoMatchesFoundLabelBackgroundColor() {
            return this.cq;
        }
        set actualNoMatchesFoundLabelBackgroundColor(a) {
            this.cq = a;
            this.e("ActualNoMatchesFoundLabelBackgroundColor");
        }
        get noMatchesFoundLabelTextColor() {
            return this.dl;
        }
        set noMatchesFoundLabelTextColor(a) {
            this.dl = a;
            this.e("NoMatchesFoundLabelTextColor");
        }
        get actualNoMatchesFoundLabelTextColor() {
            return this.cr;
        }
        set actualNoMatchesFoundLabelTextColor(a) {
            this.cr = a;
            this.e("ActualNoMatchesFoundLabelTextColor");
        }
        get noMatchesFoundLabelFontFamily() {
            return this.di;
        }
        set noMatchesFoundLabelFontFamily(a) {
            this.di = a;
            this.e("NoMatchesFoundLabelFontFamily");
        }
        get noMatchesFoundLabelFontSize() {
            return this.a7;
        }
        set noMatchesFoundLabelFontSize(a) {
            this.a7 = a;
            this.e("NoMatchesFoundLabelFontSize");
        }
        get noMatchesFoundLabelFontStyle() {
            return this.dj;
        }
        set noMatchesFoundLabelFontStyle(a) {
            this.dj = a;
            this.e("NoMatchesFoundLabelFontStyle");
        }
        get noMatchesFoundLabelFontWeight() {
            return this.dk;
        }
        set noMatchesFoundLabelFontWeight(a) {
            this.dk = a;
            this.e("NoMatchesFoundLabelFontWeight");
        }
        get placeholder() {
            return this.dm;
        }
        set placeholder(a) {
            this.dm = a;
            this.e("Placeholder");
        }
        get rowSeparatorsVisible() {
            return this.r;
        }
        set rowSeparatorsVisible(a) {
            this.r = a;
            this.e("RowSeparatorsVisible");
        }
        get textColor() {
            return this.dr;
        }
        set textColor(a) {
            this.dr = a;
            this.e("TextColor");
        }
        get actualTextColor() {
            return this.cs;
        }
        set actualTextColor(a) {
            this.cs = a;
            this.e("ActualTextColor");
        }
        get fontFamily() {
            return this.c4;
        }
        set fontFamily(a) {
            this.c4 = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.a3;
        }
        set fontSize(a) {
            this.a3 = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.c5;
        }
        set fontStyle(a) {
            this.c5 = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.c6;
        }
        set fontWeight(a) {
            this.c6 = a;
            this.e("FontWeight");
        }
        get underlineColor() {
            return this.dt;
        }
        set underlineColor(a) {
            this.dt = a;
            this.e("UnderlineColor");
        }
        get actualUnderlineColor() {
            return this.ct;
        }
        set actualUnderlineColor(a) {
            this.ct = a;
            this.e("ActualUnderlineColor");
        }
        get underlineOpacity() {
            return this.a8;
        }
        set underlineOpacity(a) {
            this.a8 = a;
            this.e("UnderlineOpacity");
        }
        get actualUnderlineOpacity() {
            return this.an;
        }
        set actualUnderlineOpacity(a) {
            this.an = a;
            this.e("ActualUnderlineOpacity");
        }
        get underlineRippleColor() {
            return this.du;
        }
        set underlineRippleColor(a) {
            this.du = a;
            this.e("UnderlineRippleColor");
        }
        get actualUnderlineRippleColor() {
            return this.cu;
        }
        set actualUnderlineRippleColor(a) {
            this.cu = a;
            this.e("ActualUnderlineRippleColor");
        }
        get underlineRippleOpacity() {
            return this.a9;
        }
        set underlineRippleOpacity(a) {
            this.a9 = a;
            this.e("UnderlineRippleOpacity");
        }
        get actualUnderlineRippleOpacity() {
            return this.ao;
        }
        set actualUnderlineRippleOpacity(a) {
            this.ao = a;
            this.e("ActualUnderlineRippleOpacity");
        }
        get underlineRippleWidth() {
            return this.ba;
        }
        set underlineRippleWidth(a) {
            this.ba = a;
            this.e("UnderlineRippleWidth");
        }
        get actualUnderlineRippleWidth() {
            return this.ap;
        }
        set actualUnderlineRippleWidth(a) {
            this.ap = a;
            this.e("ActualUnderlineRippleWidth");
        }
        get underlineWidth() {
            return this.bb;
        }
        set underlineWidth(a) {
            this.bb = a;
            this.e("UnderlineWidth");
        }
        get actualUnderlineWidth() {
            return this.aq;
        }
        set actualUnderlineWidth(a) {
            this.aq = a;
            this.e("ActualUnderlineWidth");
        }
        get allowFilter() {
            return this.o;
        }
        set allowFilter(a) {
            this.o = a;
            this.e("AllowFilter");
        }
        get sortMode() {
            return this.dn;
        }
        set sortMode(a) {
            this.dn = a;
            this.e("SortMode");
        }
        get textField() {
            return this.ds;
        }
        set textField(a) {
            this.ds = a;
            this.e("TextField");
        }
        get text() {
            return this.dp;
        }
        set text(a) {
            this.dp = a;
            this.e("Text");
        }
        get valueField() {
            return this.i;
        }
        set valueField(a) {
            this.i = a;
            this.e("ValueField");
        }
        get actualValueField() {
            return this.f;
        }
        set actualValueField(a) {
            this.f = a;
            this.e("ActualValueField");
        }
        get value() {
            return this.cf;
        }
        set value(a) {
            this.cf = a;
            this.e("Value");
        }
        get gotFocusRef() {
            return this.c7;
        }
        set gotFocusRef(a) {
            this.c7 = a;
            this.e("GotFocusRef");
        }
        get lostFocusRef() {
            return this.df;
        }
        set lostFocusRef(a) {
            this.df = a;
            this.e("LostFocusRef");
        }
        get textChangedRef() {
            return this.dq;
        }
        set textChangedRef(a) {
            this.dq = a;
            this.e("TextChangedRef");
        }
        get valueChangedRef() {
            return this.dv;
        }
        set valueChangedRef(a) {
            this.dv = a;
            this.e("ValueChangedRef");
        }
        get keyDownRef() {
            return this.c9;
        }
        set keyDownRef(a) {
            this.c9 = a;
            this.e("KeyDownRef");
        }
        get changeRef() {
            return this.cy;
        }
        set changeRef(a) {
            this.cy = a;
            this.e("ChangeRef");
        }
        get changingRef() {
            return this.cz;
        }
        set changingRef(a) {
            this.cz = a;
            this.e("ChangingRef");
        }
    }
    MultiColumnComboBoxDescription.$t = /*@__PURE__*/ markType(MultiColumnComboBoxDescription, 'MultiColumnComboBoxDescription', Description.$);
    return MultiColumnComboBoxDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxDescriptionMetadata = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxDescriptionMetadata extends Base {
        static b(a) {
            if (MultiColumnComboBoxDescriptionMetadata.a == null) {
                MultiColumnComboBoxDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                MultiColumnComboBoxDescriptionMetadata.c(a, MultiColumnComboBoxDescriptionMetadata.a);
                GotFocusEventArgsDescriptionMetadata.d(a);
                LostFocusEventArgsDescriptionMetadata.d(a);
                MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata.d(a);
                MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata.d(a);
                KeyEventArgsDescriptionMetadata.d(a);
                InputChangeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ShowClearButton", "Boolean");
            b.item("Fields", "Array:string");
            b.item("BackgroundColor", "Brush");
            b.item("ActualBackgroundColor", "Brush");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("ActualBaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("ActualBaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("BorderColor", "Brush");
            b.item("ActualBorderColor", "Brush");
            b.item("BorderWidth", "Number:double");
            b.item("ActualBorderWidth", "Number:double");
            b.item("ColumnHeadersVisible", "Boolean");
            b.item("ContentPaddingBottom", "(w:ContentPadding.Bottom,wf:ContentPaddingBottom)Number:double");
            b.item("ContentPaddingLeft", "(w:ContentPadding.Left,wf:ContentPaddingLeft)Number:double");
            b.item("ContentPaddingRight", "(w:ContentPadding.Right,wf:ContentPaddingRight)Number:double");
            b.item("ContentPaddingTop", "(w:ContentPadding.Top,wf:ContentPaddingTop)Number:double");
            b.item("ActualContentPaddingBottom", "(w:ActualContentPadding.Bottom,wf:ActualContentPaddingBottom)Number:double");
            b.item("ActualContentPaddingLeft", "(w:ActualContentPadding.Left,wf:ActualContentPaddingLeft)Number:double");
            b.item("ActualContentPaddingRight", "(w:ActualContentPadding.Right,wf:ActualContentPaddingRight)Number:double");
            b.item("ActualContentPaddingTop", "(w:ActualContentPadding.Top,wf:ActualContentPaddingTop)Number:double");
            b.item("CornerRadiusBottomRight", "(w:CornerRadius.BottomRight,wf:CornerRadiusBottomRight)Number:double");
            b.item("CornerRadiusBottomLeft", "(w:CornerRadius.BottomLeft,wf:CornerRadiusBottomLeft)Number:double");
            b.item("CornerRadiusTopLeft", "(w:CornerRadius.TopLeft,wf:CornerRadiusTopLeft)Number:double");
            b.item("CornerRadiusTopRight", "(w:CornerRadius.TopRight,wf:CornerRadiusTopRight)Number:double");
            b.item("ActualCornerRadiusBottomRight", "(w:ActualCornerRadius.BottomRight,wf:ActualCornerRadiusBottomRight)Number:double");
            b.item("ActualCornerRadiusBottomLeft", "(w:ActualCornerRadius.BottomLeft,wf:ActualCornerRadiusBottomLeft)Number:double");
            b.item("ActualCornerRadiusTopLeft", "(w:ActualCornerRadius.TopLeft,wf:ActualCornerRadiusTopLeft)Number:double");
            b.item("ActualCornerRadiusTopRight", "(w:ActualCornerRadius.TopRight,wf:ActualCornerRadiusTopRight)Number:double");
            b.item("DataSourceDesiredProperties", "Array:string");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("ActualDensity", "ExportedType:string:ControlDisplayDensity");
            b.item("ActualDensity@names", "Auto;Comfortable;Cosy;Compact");
            b.item("DropDownButtonVisible", "Boolean");
            b.item("FocusBorderColor", "Brush");
            b.item("ActualFocusBorderColor", "Brush");
            b.item("FocusBorderWidth", "Number:double");
            b.item("ActualFocusBorderWidth", "Number:double");
            b.item("FocusUnderlineColor", "Brush");
            b.item("ActualFocusUnderlineColor", "Brush");
            b.item("FocusUnderlineOpacity", "Number:double");
            b.item("ActualFocusUnderlineOpacity", "Number:double");
            b.item("FocusUnderlineRippleOpacity", "Number:double");
            b.item("ActualFocusUnderlineRippleOpacity", "Number:double");
            b.item("HoverUnderlineColor", "Brush");
            b.item("ActualHoverUnderlineColor", "Brush");
            b.item("HoverUnderlineOpacity", "Number:double");
            b.item("ActualHoverUnderlineOpacity", "Number:double");
            b.item("HoverUnderlineWidth", "Number:double");
            b.item("ActualHoverUnderlineWidth", "Number:double");
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("Label", "String");
            b.item("LabelTextColor", "Brush");
            b.item("ActualLabelTextColor", "Brush");
            b.item("LabelFontFamily", "(w:LabelFontFamily/FontFamilyTransform,wf:LabelFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            b.item("LabelFontSize", "(w:LabelFontSize,wf:LabelFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            b.item("LabelFontStyle", "(w:LabelFontStyle/FontStyleTransform,wf:LabelFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            b.item("LabelFontWeight", "(w:LabelFontWeight/FontWeightTransform,wf:LabelFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            b.item("ActualLabelVisible", "Boolean");
            b.item("NoMatchesFoundLabel", "String");
            b.item("ActualNoMatchesFoundLabel", "String");
            b.item("NoMatchesFoundLabelBackgroundColor", "Brush");
            b.item("ActualNoMatchesFoundLabelBackgroundColor", "Brush");
            b.item("NoMatchesFoundLabelTextColor", "Brush");
            b.item("ActualNoMatchesFoundLabelTextColor", "Brush");
            b.item("NoMatchesFoundLabelFontFamily", "(w:NoMatchesFoundLabelFontFamily/FontFamilyTransform,wf:NoMatchesFoundLabelFontFamily,web:noMatchesFoundLabelTextStyle/FontFamilyTransform)String");
            b.item("NoMatchesFoundLabelFontSize", "(w:NoMatchesFoundLabelFontSize,wf:NoMatchesFoundLabelFontSize,web:noMatchesFoundLabelTextStyle/FontSizeTransform)Number:double");
            b.item("NoMatchesFoundLabelFontStyle", "(w:NoMatchesFoundLabelFontStyle/FontStyleTransform,wf:NoMatchesFoundLabelFontFamily/FontStyleTransform,web:noMatchesFoundLabelTextStyle/FontStyleTransform)String");
            b.item("NoMatchesFoundLabelFontWeight", "(w:NoMatchesFoundLabelFontWeight/FontWeightTransform,wf:NoMatchesFoundLabelFontFamily/FontWeightTransform,web:noMatchesFoundLabelTextStyle/FontWeightTransform)String");
            b.item("Placeholder", "String");
            b.item("RowSeparatorsVisible", "Boolean");
            b.item("TextColor", "Brush");
            b.item("ActualTextColor", "Brush");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("UnderlineColor", "Brush");
            b.item("ActualUnderlineColor", "Brush");
            b.item("UnderlineOpacity", "Number:double");
            b.item("ActualUnderlineOpacity", "Number:double");
            b.item("UnderlineRippleColor", "Brush");
            b.item("ActualUnderlineRippleColor", "Brush");
            b.item("UnderlineRippleOpacity", "Number:double");
            b.item("ActualUnderlineRippleOpacity", "Number:double");
            b.item("UnderlineRippleWidth", "Number:double");
            b.item("ActualUnderlineRippleWidth", "Number:double");
            b.item("UnderlineWidth", "Number:double");
            b.item("ActualUnderlineWidth", "Number:double");
            b.item("AllowFilter", "Boolean");
            b.item("SortMode", "ExportedType:string:SortMode");
            b.item("SortMode@names", "SortByOneColumnOnly;SortByMultipleColumns;SortByOneColumnOnlyTriState;SortByMultipleColumnsTriState;None");
            b.item("TextField", "String");
            b.item("Text", "String");
            b.item("ValueField", "Array:string");
            b.item("ActualValueField", "Array:string");
            b.item("Value", "Unknown");
            b.item("GotFocusRef", "EventRef::gotFocus");
            b.item("LostFocusRef", "EventRef::lostFocus");
            b.item("TextChangedRef", "EventRef::textChanged");
            b.item("ValueChangedRef", "EventRef::valueChanged");
            b.item("KeyDownRef", "EventRef::keyDown");
            b.item("ChangeRef", "EventRef::change");
            b.item("ChangingRef", "EventRef::changing");
        }
        static d(a) {
            MultiColumnComboBoxDescriptionMetadata.b(a);
            a.q("MultiColumnComboBox", () => new MultiColumnComboBoxDescription());
            a.p("MultiColumnComboBox", MultiColumnComboBoxDescriptionMetadata.a);
        }
    }
    MultiColumnComboBoxDescriptionMetadata.$t = /*@__PURE__*/ markType(MultiColumnComboBoxDescriptionMetadata, 'MultiColumnComboBoxDescriptionMetadata');
    MultiColumnComboBoxDescriptionMetadata.a = null;
    return MultiColumnComboBoxDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MultiColumnComboBoxDescriptionModule = /*@__PURE__*/ (() => {
    class MultiColumnComboBoxDescriptionModule extends Base {
        static register(a) {
            InputGroupDescriptionModule.register(a);
            DataGridCoreDescriptionModule.register(a);
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            ImageColumnDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            MultiColumnComboBoxDescriptionMetadata.d(a);
        }
    }
    MultiColumnComboBoxDescriptionModule.$t = /*@__PURE__*/ markType(MultiColumnComboBoxDescriptionModule, 'MultiColumnComboBoxDescriptionModule');
    return MultiColumnComboBoxDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridDescriptionModule extends Base {
        static register(a) {
            DataGridAllColumnsDescriptionModule.register(a);
            GridColumnOptionsDescriptionModule.register(a);
            ComboBoxColumnDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            MultiColumnComboBoxDescriptionModule.register(a);
        }
    }
    DataGridDescriptionModule.$t = /*@__PURE__*/ markType(DataGridDescriptionModule, 'DataGridDescriptionModule');
    return DataGridDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridToolbarDescription = /*@__PURE__*/ (() => {
    class DataGridToolbarDescription extends Description {
        constructor() {
            super();
            this.t = null;
            this.u = null;
            this.w = null;
            this.j = 0;
            this.x = null;
            this.y = null;
            this.v = null;
            this.l = null;
            this.s = null;
            this.f = false;
            this.n = null;
            this.o = null;
            this.g = false;
            this.p = null;
            this.q = null;
            this.r = null;
            this.m = null;
        }
        get_type() {
            return "DataGridToolbar";
        }
        get type() {
            return this.get_type();
        }
        get targetGridRef() {
            return this.t;
        }
        set targetGridRef(a) {
            this.t = a;
            this.e("TargetGridRef");
        }
        get toolbarTitle() {
            return this.u;
        }
        set toolbarTitle(a) {
            this.u = a;
            this.e("ToolbarTitle");
        }
        get toolbarTitleFontFamily() {
            return this.w;
        }
        set toolbarTitleFontFamily(a) {
            this.w = a;
            this.e("ToolbarTitleFontFamily");
        }
        get toolbarTitleFontSize() {
            return this.j;
        }
        set toolbarTitleFontSize(a) {
            this.j = a;
            this.e("ToolbarTitleFontSize");
        }
        get toolbarTitleFontStyle() {
            return this.x;
        }
        set toolbarTitleFontStyle(a) {
            this.x = a;
            this.e("ToolbarTitleFontStyle");
        }
        get toolbarTitleFontWeight() {
            return this.y;
        }
        set toolbarTitleFontWeight(a) {
            this.y = a;
            this.e("ToolbarTitleFontWeight");
        }
        get toolbarTitleColor() {
            return this.v;
        }
        set toolbarTitleColor(a) {
            this.v = a;
            this.e("ToolbarTitleColor");
        }
        get backgroundColor() {
            return this.l;
        }
        set backgroundColor(a) {
            this.l = a;
            this.e("BackgroundColor");
        }
        get dialogBackgroundColor() {
            return this.s;
        }
        set dialogBackgroundColor(a) {
            this.s = a;
            this.e("DialogBackgroundColor");
        }
        get columnChooser() {
            return this.f;
        }
        set columnChooser(a) {
            this.f = a;
            this.e("ColumnChooser");
        }
        get columnChooserText() {
            return this.n;
        }
        set columnChooserText(a) {
            this.n = a;
            this.e("ColumnChooserText");
        }
        get columnChooserTitle() {
            return this.o;
        }
        set columnChooserTitle(a) {
            this.o = a;
            this.e("ColumnChooserTitle");
        }
        get columnPinning() {
            return this.g;
        }
        set columnPinning(a) {
            this.g = a;
            this.e("ColumnPinning");
        }
        get columnPinningText() {
            return this.p;
        }
        set columnPinningText(a) {
            this.p = a;
            this.e("ColumnPinningText");
        }
        get columnPinningTitle() {
            return this.q;
        }
        set columnPinningTitle(a) {
            this.q = a;
            this.e("ColumnPinningTitle");
        }
        get density() {
            return this.r;
        }
        set density(a) {
            this.r = a;
            this.e("Density");
        }
        get baseTheme() {
            return this.m;
        }
        set baseTheme(a) {
            this.m = a;
            this.e("BaseTheme");
        }
    }
    DataGridToolbarDescription.$t = /*@__PURE__*/ markType(DataGridToolbarDescription, 'DataGridToolbarDescription', Description.$);
    return DataGridToolbarDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridToolbarDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridToolbarDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridToolbarDescriptionMetadata.a == null) {
                DataGridToolbarDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridToolbarDescriptionMetadata.c(a, DataGridToolbarDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TargetGridRef", "(w:TargetGrid,wf:TargetGrid)DataRef::object");
            b.item("ToolbarTitle", "String");
            b.item("ToolbarTitleFontFamily", "(w:ToolbarTitleFontFamily/FontFamilyTransform,wf:ToolbarTitleFontFamily,web:toolbarTitleStyle/FontFamilyTransform)String");
            b.item("ToolbarTitleFontSize", "(w:ToolbarTitleFontSize,wf:ToolbarTitleFontSize,web:toolbarTitleStyle/FontSizeTransform)Number:double");
            b.item("ToolbarTitleFontStyle", "(w:ToolbarTitleFontStyle/FontStyleTransform,wf:ToolbarTitleFontFamily/FontStyleTransform,web:toolbarTitleStyle/FontStyleTransform)String");
            b.item("ToolbarTitleFontWeight", "(w:ToolbarTitleFontWeight/FontWeightTransform,wf:ToolbarTitleFontFamily/FontWeightTransform,web:toolbarTitleStyle/FontWeightTransform)String");
            b.item("ToolbarTitleColor", "Brush");
            b.item("BackgroundColor", "Brush");
            b.item("DialogBackgroundColor", "Brush");
            b.item("ColumnChooser", "Boolean");
            b.item("ColumnChooserText", "String");
            b.item("ColumnChooserTitle", "String");
            b.item("ColumnPinning", "Boolean");
            b.item("ColumnPinningText", "String");
            b.item("ColumnPinningTitle", "String");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
        }
        static d(a) {
            DataGridToolbarDescriptionMetadata.b(a);
            a.q("DataGridToolbar", () => new DataGridToolbarDescription());
            a.p("DataGridToolbar", DataGridToolbarDescriptionMetadata.a);
        }
    }
    DataGridToolbarDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridToolbarDescriptionMetadata, 'DataGridToolbarDescriptionMetadata');
    DataGridToolbarDescriptionMetadata.a = null;
    return DataGridToolbarDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridToolbarDescriptionModule = /*@__PURE__*/ (() => {
    class DataGridToolbarDescriptionModule extends Base {
        static register(a) {
            ColumnChooserDescriptionModule.register(a);
            ColumnPinningDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            DataGridToolbarDescriptionMetadata.d(a);
        }
    }
    DataGridToolbarDescriptionModule.$t = /*@__PURE__*/ markType(DataGridToolbarDescriptionModule, 'DataGridToolbarDescriptionModule');
    return DataGridToolbarDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSpecialRowDescription = /*@__PURE__*/ (() => {
    class DataSourceSpecialRowDescription extends Description {
        constructor() {
            super();
            this.n = null;
            this.k = null;
            this.i = 0;
            this.f = null;
        }
        get_type() {
            return "DataSourceSpecialRow";
        }
        get type() {
            return this.get_type();
        }
        get rowType() {
            return this.n;
        }
        set rowType(a) {
            this.n = a;
            this.e("RowType");
        }
        get targetRow() {
            return this.k;
        }
        set targetRow(a) {
            this.k = a;
            this.e("TargetRow");
        }
        get level() {
            return this.i;
        }
        set level(a) {
            this.i = a;
            this.e("Level");
        }
        get summaryResults() {
            return this.f;
        }
        set summaryResults(a) {
            this.f = a;
            this.e("SummaryResults");
        }
    }
    DataSourceSpecialRowDescription.$t = /*@__PURE__*/ markType(DataSourceSpecialRowDescription, 'DataSourceSpecialRowDescription', Description.$);
    DataSourceSpecialRowDescription.__marshalByValue = true;
    DataSourceSpecialRowDescription.__marshalByValueAlias = "DataSourceSpecialRow";
    return DataSourceSpecialRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryResultDescription = /*@__PURE__*/ (() => {
    class SummaryResultDescription extends Description {
        constructor() {
            super();
            this.g = 0;
        }
        get_type() {
            return "SummaryResult";
        }
        get type() {
            return this.get_type();
        }
        get summaryIndex() {
            return this.g;
        }
        set summaryIndex(a) {
            this.g = a;
            this.e("SummaryIndex");
        }
    }
    SummaryResultDescription.$t = /*@__PURE__*/ markType(SummaryResultDescription, 'SummaryResultDescription', Description.$);
    SummaryResultDescription.__marshalByValue = true;
    SummaryResultDescription.__marshalByValueAlias = "DefaultSummaryResult";
    return SummaryResultDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryResultDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryResultDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryResultDescriptionMetadata.a == null) {
                SummaryResultDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryResultDescriptionMetadata.c(a, SummaryResultDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("SummaryIndex", "Number:int");
        }
        static d(a) {
            SummaryResultDescriptionMetadata.b(a);
            a.q("SummaryResult", () => new SummaryResultDescription());
            a.p("SummaryResult", SummaryResultDescriptionMetadata.a);
        }
    }
    SummaryResultDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryResultDescriptionMetadata, 'SummaryResultDescriptionMetadata');
    SummaryResultDescriptionMetadata.a = null;
    return SummaryResultDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceSpecialRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceSpecialRowDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceSpecialRowDescriptionMetadata.a == null) {
                DataSourceSpecialRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceSpecialRowDescriptionMetadata.c(a, DataSourceSpecialRowDescriptionMetadata.a);
                SummaryResultDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("RowType", "ExportedType:string:DataSourceRowType");
            b.item("RowType@names", "Normal;SectionHeader;SectionFooter;ShiftedRow;SummaryRowRoot;SummaryRowSection;Custom");
            b.item("TargetRow", "Unknown");
            b.item("Level", "Number:int");
            b.item("SummaryResults", "Array:SummaryResultDescription:ISummaryResult");
        }
        static d(a) {
            DataSourceSpecialRowDescriptionMetadata.b(a);
            a.q("DataSourceSpecialRow", () => new DataSourceSpecialRowDescription());
            a.p("DataSourceSpecialRow", DataSourceSpecialRowDescriptionMetadata.a);
        }
    }
    DataSourceSpecialRowDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceSpecialRowDescriptionMetadata, 'DataSourceSpecialRowDescriptionMetadata');
    DataSourceSpecialRowDescriptionMetadata.a = null;
    return DataSourceSpecialRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePickerDescription = /*@__PURE__*/ (() => {
    class DatePickerDescription extends Description {
        constructor() {
            super();
            this.s = new Date();
            this.r = new Date();
            this.al = null;
            this.ap = null;
            this.am = null;
            this.x = 0;
            this.an = null;
            this.ao = null;
            this.ar = null;
            this.q = new Date();
            this.p = new Date();
            this.ae = null;
            this.ab = null;
            this.at = null;
            this.y = 0;
            this.au = null;
            this.av = null;
            this.as = null;
            this.aj = null;
            this.h = false;
            this.i = false;
            this.f = false;
            this.g = false;
            this.af = null;
            this.ag = null;
            this.j = false;
            this.ad = null;
            this.ah = null;
            this.aw = null;
            this.ai = null;
            this.aq = null;
            this.ak = null;
            this.ac = null;
        }
        get_type() {
            return "DatePicker";
        }
        get type() {
            return this.get_type();
        }
        get value() {
            return this.s;
        }
        set value(a) {
            this.s = a;
            this.e("Value");
        }
        get today() {
            return this.r;
        }
        set today(a) {
            this.r = a;
            this.e("Today");
        }
        get label() {
            return this.al;
        }
        set label(a) {
            this.al = a;
            this.e("Label");
        }
        get labelTextColor() {
            return this.ap;
        }
        set labelTextColor(a) {
            this.ap = a;
            this.e("LabelTextColor");
        }
        get labelFontFamily() {
            return this.am;
        }
        set labelFontFamily(a) {
            this.am = a;
            this.e("LabelFontFamily");
        }
        get labelFontSize() {
            return this.x;
        }
        set labelFontSize(a) {
            this.x = a;
            this.e("LabelFontSize");
        }
        get labelFontStyle() {
            return this.an;
        }
        set labelFontStyle(a) {
            this.an = a;
            this.e("LabelFontStyle");
        }
        get labelFontWeight() {
            return this.ao;
        }
        set labelFontWeight(a) {
            this.ao = a;
            this.e("LabelFontWeight");
        }
        get placeholder() {
            return this.ar;
        }
        set placeholder(a) {
            this.ar = a;
            this.e("Placeholder");
        }
        get minDate() {
            return this.q;
        }
        set minDate(a) {
            this.q = a;
            this.e("MinDate");
        }
        get maxDate() {
            return this.p;
        }
        set maxDate(a) {
            this.p = a;
            this.e("MaxDate");
        }
        get density() {
            return this.ae;
        }
        set density(a) {
            this.ae = a;
            this.e("Density");
        }
        get baseTheme() {
            return this.ab;
        }
        set baseTheme(a) {
            this.ab = a;
            this.e("BaseTheme");
        }
        get textFontFamily() {
            return this.at;
        }
        set textFontFamily(a) {
            this.at = a;
            this.e("TextFontFamily");
        }
        get textFontSize() {
            return this.y;
        }
        set textFontSize(a) {
            this.y = a;
            this.e("TextFontSize");
        }
        get textFontStyle() {
            return this.au;
        }
        set textFontStyle(a) {
            this.au = a;
            this.e("TextFontStyle");
        }
        get textFontWeight() {
            return this.av;
        }
        set textFontWeight(a) {
            this.av = a;
            this.e("TextFontWeight");
        }
        get textColor() {
            return this.as;
        }
        set textColor(a) {
            this.as = a;
            this.e("TextColor");
        }
        get iconColor() {
            return this.aj;
        }
        set iconColor(a) {
            this.aj = a;
            this.e("IconColor");
        }
        get showClearButton() {
            return this.h;
        }
        set showClearButton(a) {
            this.h = a;
            this.e("ShowClearButton");
        }
        get showTodayButton() {
            return this.i;
        }
        set showTodayButton(a) {
            this.i = a;
            this.e("ShowTodayButton");
        }
        get allowTextInput() {
            return this.f;
        }
        set allowTextInput(a) {
            this.f = a;
            this.e("AllowTextInput");
        }
        get openOnFocus() {
            return this.g;
        }
        set openOnFocus(a) {
            this.g = a;
            this.e("OpenOnFocus");
        }
        get firstDayOfWeek() {
            return this.af;
        }
        set firstDayOfWeek(a) {
            this.af = a;
            this.e("FirstDayOfWeek");
        }
        get firstWeekOfYear() {
            return this.ag;
        }
        set firstWeekOfYear(a) {
            this.ag = a;
            this.e("FirstWeekOfYear");
        }
        get showWeekNumbers() {
            return this.j;
        }
        set showWeekNumbers(a) {
            this.j = a;
            this.e("ShowWeekNumbers");
        }
        get dateFormat() {
            return this.ad;
        }
        set dateFormat(a) {
            this.ad = a;
            this.e("DateFormat");
        }
        get formatString() {
            return this.ah;
        }
        set formatString(a) {
            this.ah = a;
            this.e("FormatString");
        }
        get valueChangedRef() {
            return this.aw;
        }
        set valueChangedRef(a) {
            this.aw = a;
            this.e("ValueChangedRef");
        }
        get gotFocusRef() {
            return this.ai;
        }
        set gotFocusRef(a) {
            this.ai = a;
            this.e("GotFocusRef");
        }
        get lostFocusRef() {
            return this.aq;
        }
        set lostFocusRef(a) {
            this.aq = a;
            this.e("LostFocusRef");
        }
        get keyDownRef() {
            return this.ak;
        }
        set keyDownRef(a) {
            this.ak = a;
            this.e("KeyDownRef");
        }
        get changingRef() {
            return this.ac;
        }
        set changingRef(a) {
            this.ac = a;
            this.e("ChangingRef");
        }
    }
    DatePickerDescription.$t = /*@__PURE__*/ markType(DatePickerDescription, 'DatePickerDescription', Description.$);
    return DatePickerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePickerDescriptionMetadata = /*@__PURE__*/ (() => {
    class DatePickerDescriptionMetadata extends Base {
        static b(a) {
            if (DatePickerDescriptionMetadata.a == null) {
                DatePickerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DatePickerDescriptionMetadata.c(a, DatePickerDescriptionMetadata.a);
                ValueChangedEventArgsDescriptionMetadata.d(a);
                GotFocusEventArgsDescriptionMetadata.d(a);
                LostFocusEventArgsDescriptionMetadata.d(a);
                KeyEventArgsDescriptionMetadata.d(a);
                InputChangeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Value", "Date");
            b.item("Today", "Date");
            b.item("Label", "String");
            b.item("LabelTextColor", "Brush");
            b.item("LabelFontFamily", "(w:LabelFontFamily/FontFamilyTransform,wf:LabelFontFamily,web:labelTextStyle/FontFamilyTransform)String");
            b.item("LabelFontSize", "(w:LabelFontSize,wf:LabelFontSize,web:labelTextStyle/FontSizeTransform)Number:double");
            b.item("LabelFontStyle", "(w:LabelFontStyle/FontStyleTransform,wf:LabelFontFamily/FontStyleTransform,web:labelTextStyle/FontStyleTransform)String");
            b.item("LabelFontWeight", "(w:LabelFontWeight/FontWeightTransform,wf:LabelFontFamily/FontWeightTransform,web:labelTextStyle/FontWeightTransform)String");
            b.item("Placeholder", "String");
            b.item("MinDate", "Date");
            b.item("MaxDate", "Date");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("TextFontFamily", "(w:TextFontFamily/FontFamilyTransform,wf:TextFontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("TextFontSize", "(w:TextFontSize,wf:TextFontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("TextFontStyle", "(w:TextFontStyle/FontStyleTransform,wf:TextFontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("TextFontWeight", "(w:TextFontWeight/FontWeightTransform,wf:TextFontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("TextColor", "Brush");
            b.item("IconColor", "Brush");
            b.item("ShowClearButton", "Boolean");
            b.item("ShowTodayButton", "Boolean");
            b.item("AllowTextInput", "Boolean");
            b.item("OpenOnFocus", "Boolean");
            b.item("FirstDayOfWeek", "ExportedType:string:DayOfWeek");
            b.item("FirstDayOfWeek@names", "Sunday;Monday;Tuesday;Wednesday;Thursday;Friday;Saturday");
            b.item("FirstWeekOfYear", "ExportedType:string:FirstWeek");
            b.item("FirstWeekOfYear@names", "FirstDay;FirstFullWeek;FirstFourDayWeek");
            b.item("ShowWeekNumbers", "Boolean");
            b.item("DateFormat", "ExportedType:string:DateFormats");
            b.item("DateFormat@names", "DateShort;DateLong");
            b.item("FormatString", "String");
            b.item("ValueChangedRef", "EventRef::valueChanged");
            b.item("GotFocusRef", "EventRef::gotFocus");
            b.item("LostFocusRef", "EventRef::lostFocus");
            b.item("KeyDownRef", "EventRef::keyDown");
            b.item("ChangingRef", "EventRef::changing");
        }
        static d(a) {
            DatePickerDescriptionMetadata.b(a);
            a.q("DatePicker", () => new DatePickerDescription());
            a.p("DatePicker", DatePickerDescriptionMetadata.a);
        }
    }
    DatePickerDescriptionMetadata.$t = /*@__PURE__*/ markType(DatePickerDescriptionMetadata, 'DatePickerDescriptionMetadata');
    DatePickerDescriptionMetadata.a = null;
    return DatePickerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DatePickerDescriptionModule = /*@__PURE__*/ (() => {
    class DatePickerDescriptionModule extends Base {
        static register(a) {
            CalendarDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            IconDescriptionModule.register(a);
            InputGroupDescriptionModule.register(a);
            DatePickerDescriptionMetadata.d(a);
        }
    }
    DatePickerDescriptionModule.$t = /*@__PURE__*/ markType(DatePickerDescriptionModule, 'DatePickerDescriptionModule');
    return DatePickerDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionInformationDescription = /*@__PURE__*/ (() => {
    class SectionInformationDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "SectionInformation";
        }
        get type() {
            return this.get_type();
        }
    }
    SectionInformationDescription.$t = /*@__PURE__*/ markType(SectionInformationDescription, 'SectionInformationDescription', Description.$);
    SectionInformationDescription.__marshalByValue = true;
    SectionInformationDescription.__marshalByValueAlias = "DefaultSectionInformation";
    return SectionInformationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionInformationDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionInformationDescriptionMetadata extends Base {
        static b(a) {
            if (SectionInformationDescriptionMetadata.a == null) {
                SectionInformationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionInformationDescriptionMetadata.c(a, SectionInformationDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            SectionInformationDescriptionMetadata.b(a);
            a.q("SectionInformation", () => new SectionInformationDescription());
            a.p("SectionInformation", SectionInformationDescriptionMetadata.a);
        }
    }
    SectionInformationDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionInformationDescriptionMetadata, 'SectionInformationDescriptionMetadata');
    SectionInformationDescriptionMetadata.a = null;
    return SectionInformationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DoubleValueChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = 0;
            this.f = 0;
        }
        get_type() {
            return "DoubleValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get oldValue() {
            return this.g;
        }
        set oldValue(a) {
            this.g = a;
            this.e("OldValue");
        }
        get newValue() {
            return this.f;
        }
        set newValue(a) {
            this.f = a;
            this.e("NewValue");
        }
    }
    DoubleValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DoubleValueChangedEventArgsDescription, 'DoubleValueChangedEventArgsDescription', Description.$);
    return DoubleValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoubleValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoubleValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DoubleValueChangedEventArgsDescriptionMetadata.a == null) {
                DoubleValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DoubleValueChangedEventArgsDescriptionMetadata.c(a, DoubleValueChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("OldValue", "Number:double");
            b.item("NewValue", "Number:double");
        }
        static d(a) {
            DoubleValueChangedEventArgsDescriptionMetadata.b(a);
            a.q("DoubleValueChangedEventArgs", () => new DoubleValueChangedEventArgsDescription());
            a.p("DoubleValueChangedEventArgs", DoubleValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    DoubleValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DoubleValueChangedEventArgsDescriptionMetadata, 'DoubleValueChangedEventArgsDescriptionMetadata');
    DoubleValueChangedEventArgsDescriptionMetadata.a = null;
    return DoubleValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class RingSeriesBaseDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
            b.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
        }
        static b(a) {
            if (RingSeriesBaseDescriptionMetadata.a == null) {
                RingSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RingSeriesBaseDescriptionMetadata.c(a, RingSeriesBaseDescriptionMetadata.a);
                PropertyUpdatedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("ValueMemberPath", "String");
            b.item("LabelMemberPath", "String");
            b.item("LegendLabelMemberPath", "String");
            b.item("LabelsPosition", "ExportedType:string:LabelsPosition");
            b.item("LabelsPosition@names", "None;Center;InsideEnd;OutsideEnd;BestFit");
            b.item("LeaderLineVisibility", "ExportedType:string:Visibility");
            b.item("LeaderLineVisibility@names", "Visible;Collapsed");
            b.item("LeaderLineFill", "(w:LeaderLineStyle.Fill,wf:LeaderLineFill)String");
            b.item("LeaderLineStroke", "(w:LeaderLineStyle.Stroke,wf:LeaderLineStroke)String");
            b.item("LeaderLineStrokeThickness", "(w:LeaderLineStyle.StrokeThickness,wf:LeaderLineStrokeThickness)Number:double");
            b.item("LeaderLineOpacity", "(w:LeaderLineStyle.Opacity,wf:LeaderLineOpacity)Number:double");
            b.item("LeaderLineType", "ExportedType:string:LeaderLineType");
            b.item("LeaderLineType@names", "Straight;Arc;Spline");
            b.item("LeaderLineMargin", "Number:double");
            b.item("OthersCategoryThreshold", "Number:double");
            b.item("OthersCategoryType", "ExportedType:string:OthersCategoryType");
            b.item("OthersCategoryType@names", "Number;Percent");
            b.item("OthersCategoryText", "String");
            b.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            b.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            b.item("FormatLegendLabelRef", "(w:FormatLegendLabel,wf:FormatLegendLabel)MethodRef");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("OthersLabelFormat", "String");
            b.item("OthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("LegendLabelFormat", "String");
            b.item("LegendLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("LegendOthersLabelFormat", "String");
            b.item("LegendOthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("LabelExtent", "Number:double");
            b.item("StartAngle", "Number:double");
            b.item("OthersCategoryFill", "(w:OthersCategoryStyle.Fill,wf:OthersCategoryFill)String");
            b.item("OthersCategoryStroke", "(w:OthersCategoryStyle.Stroke,wf:OthersCategoryStroke)String");
            b.item("OthersCategoryStrokeThickness", "(w:OthersCategoryStyle.StrokeThickness,wf:OthersCategoryStrokeThickness)Number:double");
            b.item("OthersCategoryOpacity", "(w:OthersCategoryStyle.Opacity,wf:OthersCategoryOpacity)Number:double");
            b.item("SelectedSliceFill", "(w:SelectedStyle.Fill,wf:SelectedSliceFill)String");
            b.item("SelectedSliceStroke", "(w:SelectedStyle.Stroke,wf:SelectedSliceStroke)String");
            b.item("SelectedSliceStrokeThickness", "(w:SelectedStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            b.item("SelectedSliceOpacity", "(w:SelectedStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            b.item("Brushes", "BrushCollection:string");
            b.item("Outlines", "BrushCollection:string");
            b.item("LabelOuterColor", "Brush");
            b.item("LabelInnerColor", "Brush");
            b.item("IsSurfaceInteractionDisabled", "Boolean");
            b.item("RadiusFactor", "Number:double");
            b.item("PropertyUpdatedRef", "EventRef::propertyUpdated");
            RingSeriesBaseDescriptionMetadata.e(a, b);
        }
        static d(a) {
            RingSeriesBaseDescriptionMetadata.b(a);
            a.p("RingSeriesBase", RingSeriesBaseDescriptionMetadata.a);
        }
    }
    RingSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(RingSeriesBaseDescriptionMetadata, 'RingSeriesBaseDescriptionMetadata');
    RingSeriesBaseDescriptionMetadata.a = null;
    return RingSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingDescription = /*@__PURE__*/ (() => {
    class RingDescription extends Description {
        constructor() {
            super();
            this.p = 0;
            this.l = 0;
            this.j = null;
            this.f = null;
            this.h = null;
            this.m = 0;
        }
        get_type() {
            return "Ring";
        }
        get type() {
            return this.get_type();
        }
        get index() {
            return this.p;
        }
        set index(a) {
            this.p = a;
            this.e("Index");
        }
        get innerExtend() {
            return this.l;
        }
        set innerExtend(a) {
            this.l = a;
            this.e("InnerExtend");
        }
        get controlSize() {
            return this.j;
        }
        set controlSize(a) {
            this.j = a;
            this.e("ControlSize");
        }
        get center() {
            return this.f;
        }
        set center(a) {
            this.f = a;
            this.e("Center");
        }
        get ringSeries() {
            return this.h;
        }
        set ringSeries(a) {
            this.h = a;
            this.e("RingSeries");
        }
        get ringBreadth() {
            return this.m;
        }
        set ringBreadth(a) {
            this.m = a;
            this.e("RingBreadth");
        }
    }
    RingDescription.$t = /*@__PURE__*/ markType(RingDescription, 'RingDescription', Description.$);
    return RingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingDescriptionMetadata = /*@__PURE__*/ (() => {
    class RingDescriptionMetadata extends Base {
        static b(a) {
            if (RingDescriptionMetadata.a == null) {
                RingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RingDescriptionMetadata.c(a, RingDescriptionMetadata.a);
                RingSeriesBaseDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Index", "Number:int");
            b.item("InnerExtend", "Number:double");
            b.item("ControlSize", "Size");
            b.item("Center", "Point");
            b.item("RingSeries", "ExportedType:RingSeriesBase");
            b.item("RingBreadth", "Number:double");
        }
        static d(a) {
            RingDescriptionMetadata.b(a);
            a.q("Ring", () => new RingDescription());
            a.p("Ring", RingDescriptionMetadata.a);
        }
    }
    RingDescriptionMetadata.$t = /*@__PURE__*/ markType(RingDescriptionMetadata, 'RingDescriptionMetadata');
    RingDescriptionMetadata.a = null;
    return RingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesBaseDescription = /*@__PURE__*/ (() => {
    class RingSeriesBaseDescription extends Description {
        constructor() {
            super();
            this.bi = null;
            this.as = null;
            this.t = 0;
            this.au = null;
            this.at = null;
            this.ar = null;
            this.bj = null;
            this.az = null;
            this.a7 = null;
            this.a1 = null;
            this.a5 = null;
            this.a2 = null;
            this.a3 = null;
            this.x = 0;
            this.w = 0;
            this.a4 = null;
            this.v = 0;
            this.aa = 0;
            this.bd = null;
            this.bc = null;
            this.a9 = null;
            this.av = null;
            this.aw = null;
            this.ax = null;
            this.g = null;
            this.be = null;
            this.j = null;
            this.a6 = null;
            this.h = null;
            this.a8 = null;
            this.i = null;
            this.u = 0;
            this.ae = 0;
            this.ba = null;
            this.bb = null;
            this.z = 0;
            this.y = 0;
            this.bg = null;
            this.bh = null;
            this.ad = 0;
            this.ac = 0;
            this.f = null;
            this.k = null;
            this.a0 = null;
            this.ay = null;
            this.r = false;
            this.ab = 0;
            this.bf = null;
        }
        get tooltipTemplateRef() {
            return this.bi;
        }
        set tooltipTemplateRef(a) {
            this.bi = a;
            this.e("TooltipTemplateRef");
        }
        get fontFamily() {
            return this.as;
        }
        set fontFamily(a) {
            this.as = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.t;
        }
        set fontSize(a) {
            this.t = a;
            this.e("FontSize");
        }
        get fontWeight() {
            return this.au;
        }
        set fontWeight(a) {
            this.au = a;
            this.e("FontWeight");
        }
        get fontStyle() {
            return this.at;
        }
        set fontStyle(a) {
            this.at = a;
            this.e("FontStyle");
        }
        get_type() {
            return "RingSeriesBase";
        }
        get type() {
            return this.get_type();
        }
        get dataSourceRef() {
            return this.ar;
        }
        set dataSourceRef(a) {
            this.ar = a;
            this.e("DataSourceRef");
        }
        get valueMemberPath() {
            return this.bj;
        }
        set valueMemberPath(a) {
            this.bj = a;
            this.e("ValueMemberPath");
        }
        get labelMemberPath() {
            return this.az;
        }
        set labelMemberPath(a) {
            this.az = a;
            this.e("LabelMemberPath");
        }
        get legendLabelMemberPath() {
            return this.a7;
        }
        set legendLabelMemberPath(a) {
            this.a7 = a;
            this.e("LegendLabelMemberPath");
        }
        get labelsPosition() {
            return this.a1;
        }
        set labelsPosition(a) {
            this.a1 = a;
            this.e("LabelsPosition");
        }
        get leaderLineVisibility() {
            return this.a5;
        }
        set leaderLineVisibility(a) {
            this.a5 = a;
            this.e("LeaderLineVisibility");
        }
        get leaderLineFill() {
            return this.a2;
        }
        set leaderLineFill(a) {
            this.a2 = a;
            this.e("LeaderLineFill");
        }
        get leaderLineStroke() {
            return this.a3;
        }
        set leaderLineStroke(a) {
            this.a3 = a;
            this.e("LeaderLineStroke");
        }
        get leaderLineStrokeThickness() {
            return this.x;
        }
        set leaderLineStrokeThickness(a) {
            this.x = a;
            this.e("LeaderLineStrokeThickness");
        }
        get leaderLineOpacity() {
            return this.w;
        }
        set leaderLineOpacity(a) {
            this.w = a;
            this.e("LeaderLineOpacity");
        }
        get leaderLineType() {
            return this.a4;
        }
        set leaderLineType(a) {
            this.a4 = a;
            this.e("LeaderLineType");
        }
        get leaderLineMargin() {
            return this.v;
        }
        set leaderLineMargin(a) {
            this.v = a;
            this.e("LeaderLineMargin");
        }
        get othersCategoryThreshold() {
            return this.aa;
        }
        set othersCategoryThreshold(a) {
            this.aa = a;
            this.e("OthersCategoryThreshold");
        }
        get othersCategoryType() {
            return this.bd;
        }
        set othersCategoryType(a) {
            this.bd = a;
            this.e("OthersCategoryType");
        }
        get othersCategoryText() {
            return this.bc;
        }
        set othersCategoryText(a) {
            this.bc = a;
            this.e("OthersCategoryText");
        }
        get legendRef() {
            return this.a9;
        }
        set legendRef(a) {
            this.a9 = a;
            this.e("LegendRef");
        }
        get formatLabelRef() {
            return this.av;
        }
        set formatLabelRef(a) {
            this.av = a;
            this.e("FormatLabelRef");
        }
        get formatLegendLabelRef() {
            return this.aw;
        }
        set formatLegendLabelRef(a) {
            this.aw = a;
            this.e("FormatLegendLabelRef");
        }
        get labelFormat() {
            return this.ax;
        }
        set labelFormat(a) {
            this.ax = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.g;
        }
        set labelFormatSpecifiers(a) {
            this.g = a;
            this.e("LabelFormatSpecifiers");
        }
        get othersLabelFormat() {
            return this.be;
        }
        set othersLabelFormat(a) {
            this.be = a;
            this.e("OthersLabelFormat");
        }
        get othersLabelFormatSpecifiers() {
            return this.j;
        }
        set othersLabelFormatSpecifiers(a) {
            this.j = a;
            this.e("OthersLabelFormatSpecifiers");
        }
        get legendLabelFormat() {
            return this.a6;
        }
        set legendLabelFormat(a) {
            this.a6 = a;
            this.e("LegendLabelFormat");
        }
        get legendLabelFormatSpecifiers() {
            return this.h;
        }
        set legendLabelFormatSpecifiers(a) {
            this.h = a;
            this.e("LegendLabelFormatSpecifiers");
        }
        get legendOthersLabelFormat() {
            return this.a8;
        }
        set legendOthersLabelFormat(a) {
            this.a8 = a;
            this.e("LegendOthersLabelFormat");
        }
        get legendOthersLabelFormatSpecifiers() {
            return this.i;
        }
        set legendOthersLabelFormatSpecifiers(a) {
            this.i = a;
            this.e("LegendOthersLabelFormatSpecifiers");
        }
        get labelExtent() {
            return this.u;
        }
        set labelExtent(a) {
            this.u = a;
            this.e("LabelExtent");
        }
        get startAngle() {
            return this.ae;
        }
        set startAngle(a) {
            this.ae = a;
            this.e("StartAngle");
        }
        get othersCategoryFill() {
            return this.ba;
        }
        set othersCategoryFill(a) {
            this.ba = a;
            this.e("OthersCategoryFill");
        }
        get othersCategoryStroke() {
            return this.bb;
        }
        set othersCategoryStroke(a) {
            this.bb = a;
            this.e("OthersCategoryStroke");
        }
        get othersCategoryStrokeThickness() {
            return this.z;
        }
        set othersCategoryStrokeThickness(a) {
            this.z = a;
            this.e("OthersCategoryStrokeThickness");
        }
        get othersCategoryOpacity() {
            return this.y;
        }
        set othersCategoryOpacity(a) {
            this.y = a;
            this.e("OthersCategoryOpacity");
        }
        get selectedSliceFill() {
            return this.bg;
        }
        set selectedSliceFill(a) {
            this.bg = a;
            this.e("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.bh;
        }
        set selectedSliceStroke(a) {
            this.bh = a;
            this.e("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.ad;
        }
        set selectedSliceStrokeThickness(a) {
            this.ad = a;
            this.e("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.ac;
        }
        set selectedSliceOpacity(a) {
            this.ac = a;
            this.e("SelectedSliceOpacity");
        }
        get brushes() {
            return this.f;
        }
        set brushes(a) {
            this.f = a;
            this.e("Brushes");
        }
        get outlines() {
            return this.k;
        }
        set outlines(a) {
            this.k = a;
            this.e("Outlines");
        }
        get labelOuterColor() {
            return this.a0;
        }
        set labelOuterColor(a) {
            this.a0 = a;
            this.e("LabelOuterColor");
        }
        get labelInnerColor() {
            return this.ay;
        }
        set labelInnerColor(a) {
            this.ay = a;
            this.e("LabelInnerColor");
        }
        get isSurfaceInteractionDisabled() {
            return this.r;
        }
        set isSurfaceInteractionDisabled(a) {
            this.r = a;
            this.e("IsSurfaceInteractionDisabled");
        }
        get radiusFactor() {
            return this.ab;
        }
        set radiusFactor(a) {
            this.ab = a;
            this.e("RadiusFactor");
        }
        get propertyUpdatedRef() {
            return this.bf;
        }
        set propertyUpdatedRef(a) {
            this.bf = a;
            this.e("PropertyUpdatedRef");
        }
    }
    RingSeriesBaseDescription.$t = /*@__PURE__*/ markType(RingSeriesBaseDescription, 'RingSeriesBaseDescription', Description.$);
    return RingSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesDescription = /*@__PURE__*/ (() => {
    class RingSeriesDescription extends RingSeriesBaseDescription {
        constructor() {
            super();
            this.ce = null;
        }
        get_type() {
            return "RingSeries";
        }
        get ring() {
            return this.ce;
        }
        set ring(a) {
            this.ce = a;
            this.e("Ring");
        }
    }
    RingSeriesDescription.$t = /*@__PURE__*/ markType(RingSeriesDescription, 'RingSeriesDescription', RingSeriesBaseDescription.$);
    return RingSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class RingSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (RingSeriesDescriptionMetadata.a == null) {
                RingSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RingSeriesDescriptionMetadata.c(a, RingSeriesDescriptionMetadata.a);
                RingDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            RingSeriesBaseDescriptionMetadata.c(a, b);
            b.item("Ring", "ExportedType:Ring");
        }
        static d(a) {
            RingSeriesDescriptionMetadata.b(a);
            a.q("RingSeries", () => new RingSeriesDescription());
            a.p("RingSeries", RingSeriesDescriptionMetadata.a);
        }
    }
    RingSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(RingSeriesDescriptionMetadata, 'RingSeriesDescriptionMetadata');
    RingSeriesDescriptionMetadata.a = null;
    return RingSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RingSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class RingSeriesDescriptionModule extends Base {
        static register(a) {
            RingSeriesDescriptionMetadata.d(a);
        }
    }
    RingSeriesDescriptionModule.$t = /*@__PURE__*/ markType(RingSeriesDescriptionModule, 'RingSeriesDescriptionModule');
    return RingSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SliceClickEventArgsDescription = /*@__PURE__*/ (() => {
    class SliceClickEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = false;
            this.f = false;
            this.j = null;
        }
        get_type() {
            return "SliceClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get isSelected() {
            return this.g;
        }
        set isSelected(a) {
            this.g = a;
            this.e("IsSelected");
        }
        get isExploded() {
            return this.f;
        }
        set isExploded(a) {
            this.f = a;
            this.e("IsExploded");
        }
        get originalEventRef() {
            return this.j;
        }
        set originalEventRef(a) {
            this.j = a;
            this.e("OriginalEventRef");
        }
    }
    SliceClickEventArgsDescription.$t = /*@__PURE__*/ markType(SliceClickEventArgsDescription, 'SliceClickEventArgsDescription', Description.$);
    return SliceClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SliceClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SliceClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SliceClickEventArgsDescriptionMetadata.a == null) {
                SliceClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SliceClickEventArgsDescriptionMetadata.c(a, SliceClickEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsSelected", "Boolean");
            b.item("IsExploded", "Boolean");
            b.item("OriginalEventRef", "(w:OriginalEvent,wf:OriginalEvent)DataRef");
        }
        static d(a) {
            SliceClickEventArgsDescriptionMetadata.b(a);
            a.q("SliceClickEventArgs", () => new SliceClickEventArgsDescription());
            a.p("SliceClickEventArgs", SliceClickEventArgsDescriptionMetadata.a);
        }
    }
    SliceClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SliceClickEventArgsDescriptionMetadata, 'SliceClickEventArgsDescriptionMetadata');
    SliceClickEventArgsDescriptionMetadata.a = null;
    return SliceClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HoleDimensionsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class HoleDimensionsChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "HoleDimensionsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    HoleDimensionsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(HoleDimensionsChangedEventArgsDescription, 'HoleDimensionsChangedEventArgsDescription', Description.$);
    return HoleDimensionsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HoleDimensionsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class HoleDimensionsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (HoleDimensionsChangedEventArgsDescriptionMetadata.a == null) {
                HoleDimensionsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HoleDimensionsChangedEventArgsDescriptionMetadata.c(a, HoleDimensionsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            HoleDimensionsChangedEventArgsDescriptionMetadata.b(a);
            a.q("HoleDimensionsChangedEventArgs", () => new HoleDimensionsChangedEventArgsDescription());
            a.p("HoleDimensionsChangedEventArgs", HoleDimensionsChangedEventArgsDescriptionMetadata.a);
        }
    }
    HoleDimensionsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(HoleDimensionsChangedEventArgsDescriptionMetadata, 'HoleDimensionsChangedEventArgsDescriptionMetadata');
    HoleDimensionsChangedEventArgsDescriptionMetadata.a = null;
    return HoleDimensionsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDescription = /*@__PURE__*/ (() => {
    class DoughnutChartDescription extends Description {
        constructor() {
            super();
            this.x = null;
            this.i = false;
            this.j = false;
            this.h = false;
            this.f = null;
            this.o = 0;
            this.z = null;
            this.aa = null;
            this.r = 0;
            this.q = 0;
            this.p = 0;
            this.n = 0;
            this.ab = null;
            this.y = null;
        }
        get background() {
            return this.x;
        }
        set background(a) {
            this.x = a;
            this.e("Background");
        }
        get_type() {
            return "DoughnutChart";
        }
        get type() {
            return this.get_type();
        }
        get allowSliceSelection() {
            return this.i;
        }
        set allowSliceSelection(a) {
            this.i = a;
            this.e("AllowSliceSelection");
        }
        get isSurfaceInteractionDisabled() {
            return this.j;
        }
        set isSurfaceInteractionDisabled(a) {
            this.j = a;
            this.e("IsSurfaceInteractionDisabled");
        }
        get allowSliceExplosion() {
            return this.h;
        }
        set allowSliceExplosion(a) {
            this.h = a;
            this.e("AllowSliceExplosion");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get innerExtent() {
            return this.o;
        }
        set innerExtent(a) {
            this.o = a;
            this.e("InnerExtent");
        }
        get selectedSliceFill() {
            return this.z;
        }
        set selectedSliceFill(a) {
            this.z = a;
            this.e("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.aa;
        }
        set selectedSliceStroke(a) {
            this.aa = a;
            this.e("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.r;
        }
        set selectedSliceStrokeThickness(a) {
            this.r = a;
            this.e("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.q;
        }
        set selectedSliceOpacity(a) {
            this.q = a;
            this.e("SelectedSliceOpacity");
        }
        get pixelScalingRatio() {
            return this.p;
        }
        set pixelScalingRatio(a) {
            this.p = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.n;
        }
        set actualPixelScalingRatio(a) {
            this.n = a;
            this.e("ActualPixelScalingRatio");
        }
        get sliceClickRef() {
            return this.ab;
        }
        set sliceClickRef(a) {
            this.ab = a;
            this.e("SliceClickRef");
        }
        get holeDimensionsChangedRef() {
            return this.y;
        }
        set holeDimensionsChangedRef(a) {
            this.y = a;
            this.e("HoleDimensionsChangedRef");
        }
    }
    DoughnutChartDescription.$t = /*@__PURE__*/ markType(DoughnutChartDescription, 'DoughnutChartDescription', Description.$);
    return DoughnutChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoughnutChartDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamDoughnutChart");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (DoughnutChartDescriptionMetadata.a == null) {
                DoughnutChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DoughnutChartDescriptionMetadata.c(a, DoughnutChartDescriptionMetadata.a);
                SliceClickEventArgsDescriptionMetadata.d(a);
                HoleDimensionsChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("AllowSliceSelection", "Boolean");
            b.item("IsSurfaceInteractionDisabled", "Boolean");
            b.item("AllowSliceExplosion", "Boolean");
            b.item("Series", "Collection:RingSeriesBase:RingSeriesCollection:RingSeriesBase");
            b.item("InnerExtent", "Number:double");
            b.item("SelectedSliceFill", "(w:SelectedStyle.Fill,wf:SelectedSliceFill)String");
            b.item("SelectedSliceStroke", "(w:SelectedStyle.Stroke,wf:SelectedSliceStroke)String");
            b.item("SelectedSliceStrokeThickness", "(w:SelectedStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            b.item("SelectedSliceOpacity", "(w:SelectedStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("SliceClickRef", "EventRef::sliceClick");
            b.item("HoleDimensionsChangedRef", "EventRef::holeDimensionsChanged");
            DoughnutChartDescriptionMetadata.e(a, b);
        }
        static d(a) {
            DoughnutChartDescriptionMetadata.b(a);
            a.q("DoughnutChart", () => new DoughnutChartDescription());
            a.p("DoughnutChart", DoughnutChartDescriptionMetadata.a);
        }
    }
    DoughnutChartDescriptionMetadata.$t = /*@__PURE__*/ markType(DoughnutChartDescriptionMetadata, 'DoughnutChartDescriptionMetadata');
    DoughnutChartDescriptionMetadata.a = null;
    return DoughnutChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class DoughnutChartCoreDescriptionModule extends Base {
        static register(a) {
            RingSeriesDescriptionModule.register(a);
            DoughnutChartDescriptionMetadata.d(a);
        }
    }
    DoughnutChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(DoughnutChartCoreDescriptionModule, 'DoughnutChartCoreDescriptionModule');
    return DoughnutChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDefaultTooltipsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoughnutChartDefaultTooltipsDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DoughnutChartDefaultTooltipsDescriptionMetadata.$t = /*@__PURE__*/ markType(DoughnutChartDefaultTooltipsDescriptionMetadata, 'DoughnutChartDefaultTooltipsDescriptionMetadata');
    return DoughnutChartDefaultTooltipsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartInteractivityDescriptionModule = /*@__PURE__*/ (() => {
    class DoughnutChartInteractivityDescriptionModule extends Base {
        static register(a) {
            DoughnutChartDefaultTooltipsDescriptionMetadata.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    DoughnutChartInteractivityDescriptionModule.$t = /*@__PURE__*/ markType(DoughnutChartInteractivityDescriptionModule, 'DoughnutChartInteractivityDescriptionModule');
    return DoughnutChartInteractivityDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDescriptionModule = /*@__PURE__*/ (() => {
    class DoughnutChartDescriptionModule extends Base {
        static register(a) {
            DoughnutChartInteractivityDescriptionModule.register(a);
            DoughnutChartCoreDescriptionModule.register(a);
        }
    }
    DoughnutChartDescriptionModule.$t = /*@__PURE__*/ markType(DoughnutChartDescriptionModule, 'DoughnutChartDescriptionModule');
    return DoughnutChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellInfoDescription = /*@__PURE__*/ (() => {
    class CellInfoDescription extends Description {
        constructor() {
            super();
            this.d8 = null;
            this.b0 = 0;
            this.t = false;
            this.x_1 = false;
            this.k = false;
            this.i = false;
            this.r = false;
            this.y_1 = false;
            this.l = false;
            this.s = false;
            this.f = null;
            this.u = false;
            this.v = false;
            this.q = false;
            this.b7 = 0;
            this.d3 = null;
            this.a3 = 0;
            this.a4 = 0;
            this.cc = 0;
            this.cd = 0;
            this.aw = 0;
            this.au = 0;
            this.ar = 0;
            this.az = 0;
            this.at = 0;
            this.b6 = 0;
            this.ce = 0;
            this.w = false;
            this.a1 = 0;
            this.aq = 0;
            this.ay = 0;
            this.du = null;
            this.ea = null;
            this.di = null;
            this.dj = null;
            this.dc = null;
            this.dd = null;
            this.db = null;
            this.dq = null;
            this.d4 = null;
            this.dv = null;
            this.dw = null;
            this.d6 = null;
            this.d7 = null;
            this.d1 = null;
            this.dx = null;
            this.a0 = 0;
            this.dz = null;
            this.d2 = null;
            this.d9 = null;
            this.dh = null;
            this.dk = null;
            this.dr = null;
            this.ax = 0;
            this.ds = null;
            this.dt = null;
            this.de = null;
            this.as = 0;
            this.df = null;
            this.dg = null;
            this.dy = null;
            this.a2 = 0;
            this.b9 = 0;
            this.cb = 0;
            this.ca = 0;
            this.b8 = 0;
            this.bt = 0;
            this.bv = 0;
            this.bu = 0;
            this.bs = 0;
            this.bx = 0;
            this.bz = 0;
            this.by = 0;
            this.bw = 0;
            this.bl = 0;
            this.bn = 0;
            this.bm = 0;
            this.bk = 0;
            this.b3 = 0;
            this.b5 = 0;
            this.b4 = 0;
            this.b2 = 0;
            this.bp = 0;
            this.br = 0;
            this.bq = 0;
            this.bo = 0;
            this.d5 = null;
            this.o = false;
            this.j = false;
            this.d0 = null;
            this.dm = null;
            this.av = 0;
            this.dn = null;
            this.dp = null;
            this.n = false;
            this.m = false;
            this.dl = null;
            this.p = false;
            this.b1 = 0;
        }
        get_type() {
            return "CellInfo";
        }
        get type() {
            return this.get_type();
        }
        get styleKey() {
            return this.d8;
        }
        set styleKey(a) {
            this.d8 = a;
            this.e("StyleKey");
        }
        get dataRow() {
            return this.b0;
        }
        set dataRow(a) {
            this.b0 = a;
            this.e("DataRow");
        }
        get isPositionDirty() {
            return this.t;
        }
        set isPositionDirty(a) {
            this.t = a;
            this.e("IsPositionDirty");
        }
        get isSizeDirty() {
            return this.x_1;
        }
        set isSizeDirty(a) {
            this.x_1 = a;
            this.e("IsSizeDirty");
        }
        get isContentDirty() {
            return this.k;
        }
        set isContentDirty(a) {
            this.k = a;
            this.e("IsContentDirty");
        }
        get isBorderDirty() {
            return this.i;
        }
        set isBorderDirty(a) {
            this.i = a;
            this.e("IsBorderDirty");
        }
        get isLayerDirty() {
            return this.r;
        }
        set isLayerDirty(a) {
            this.r = a;
            this.e("IsLayerDirty");
        }
        get isStateDirty() {
            return this.y_1;
        }
        set isStateDirty(a) {
            this.y_1 = a;
            this.e("IsStateDirty");
        }
        get isDataDirty() {
            return this.l;
        }
        set isDataDirty(a) {
            this.l = a;
            this.e("IsDataDirty");
        }
        get isPlaceholdContentNeeded() {
            return this.s;
        }
        set isPlaceholdContentNeeded(a) {
            this.s = a;
            this.e("IsPlaceholdContentNeeded");
        }
        get actionManager() {
            return this.f;
        }
        set actionManager(a) {
            this.f = a;
            this.e("ActionManager");
        }
        get isRowPinned() {
            return this.u;
        }
        set isRowPinned(a) {
            this.u = a;
            this.e("IsRowPinned");
        }
        get isRowSticky() {
            return this.v;
        }
        set isRowSticky(a) {
            this.v = a;
            this.e("IsRowSticky");
        }
        get isLastStickyRow() {
            return this.q;
        }
        set isLastStickyRow(a) {
            this.q = a;
            this.e("IsLastStickyRow");
        }
        get indent() {
            return this.b7;
        }
        set indent(a) {
            this.b7 = a;
            this.e("Indent");
        }
        get rowItemRef() {
            return this.d3;
        }
        set rowItemRef(a) {
            this.d3 = a;
            this.e("RowItemRef");
        }
        get x() {
            return this.a3;
        }
        set x(a) {
            this.a3 = a;
            this.e("X");
        }
        get y() {
            return this.a4;
        }
        set y(a) {
            this.a4 = a;
            this.e("Y");
        }
        get snappedX() {
            return this.cc;
        }
        set snappedX(a) {
            this.cc = a;
            this.e("SnappedX");
        }
        get snappedY() {
            return this.cd;
        }
        set snappedY(a) {
            this.cd = a;
            this.e("SnappedY");
        }
        get editOpacity() {
            return this.aw;
        }
        set editOpacity(a) {
            this.aw = a;
            this.e("EditOpacity");
        }
        get contentOpacity() {
            return this.au;
        }
        set contentOpacity(a) {
            this.au = a;
            this.e("ContentOpacity");
        }
        get actualContentOpacity() {
            return this.ar;
        }
        set actualContentOpacity(a) {
            this.ar = a;
            this.e("ActualContentOpacity");
        }
        get opacity() {
            return this.az;
        }
        set opacity(a) {
            this.az = a;
            this.e("Opacity");
        }
        get actualOpacity() {
            return this.at;
        }
        set actualOpacity(a) {
            this.at = a;
            this.e("ActualOpacity");
        }
        get height() {
            return this.b6;
        }
        set height(a) {
            this.b6 = a;
            this.e("Height");
        }
        get width() {
            return this.ce;
        }
        set width(a) {
            this.ce = a;
            this.e("Width");
        }
        get isSelected() {
            return this.w;
        }
        set isSelected(a) {
            this.w = a;
            this.e("IsSelected");
        }
        get selectedStatus() {
            return this.a1;
        }
        set selectedStatus(a) {
            this.a1 = a;
            this.e("SelectedStatus");
        }
        get activationStatus() {
            return this.aq;
        }
        set activationStatus(a) {
            this.aq = a;
            this.e("ActivationStatus");
        }
        get hoverStatus() {
            return this.ay;
        }
        set hoverStatus(a) {
            this.ay = a;
            this.e("HoverStatus");
        }
        get horizontalAlignment() {
            return this.du;
        }
        set horizontalAlignment(a) {
            this.du = a;
            this.e("HorizontalAlignment");
        }
        get verticalAlignment() {
            return this.ea;
        }
        set verticalAlignment(a) {
            this.ea = a;
            this.e("VerticalAlignment");
        }
        get background() {
            return this.di;
        }
        set background(a) {
            this.di = a;
            this.e("Background");
        }
        get border() {
            return this.dj;
        }
        set border(a) {
            this.dj = a;
            this.e("Border");
        }
        get actualBackground() {
            return this.dc;
        }
        set actualBackground(a) {
            this.dc = a;
            this.e("ActualBackground");
        }
        get actualBorder() {
            return this.dd;
        }
        set actualBorder(a) {
            this.dd = a;
            this.e("ActualBorder");
        }
        get activationBorder() {
            return this.db;
        }
        set activationBorder(a) {
            this.db = a;
            this.e("ActivationBorder");
        }
        get errorBorder() {
            return this.dq;
        }
        set errorBorder(a) {
            this.dq = a;
            this.e("ErrorBorder");
        }
        get selectedBackground() {
            return this.d4;
        }
        set selectedBackground(a) {
            this.d4 = a;
            this.e("SelectedBackground");
        }
        get hoverBackground() {
            return this.dv;
        }
        set hoverBackground(a) {
            this.dv = a;
            this.e("HoverBackground");
        }
        get hoverTextColor() {
            return this.dw;
        }
        set hoverTextColor(a) {
            this.dw = a;
            this.e("HoverTextColor");
        }
        get sortIndicatorColor() {
            return this.d6;
        }
        set sortIndicatorColor(a) {
            this.d6 = a;
            this.e("SortIndicatorColor");
        }
        get stickyRowBackground() {
            return this.d7;
        }
        set stickyRowBackground(a) {
            this.d7 = a;
            this.e("StickyRowBackground");
        }
        get pinnedRowBackground() {
            return this.d1;
        }
        set pinnedRowBackground(a) {
            this.d1 = a;
            this.e("PinnedRowBackground");
        }
        get lastStickyRowBackground() {
            return this.dx;
        }
        set lastStickyRowBackground(a) {
            this.dx = a;
            this.e("LastStickyRowBackground");
        }
        get pinnedRowOpacity() {
            return this.a0;
        }
        set pinnedRowOpacity(a) {
            this.a0 = a;
            this.e("PinnedRowOpacity");
        }
        get originalValueRef() {
            return this.dz;
        }
        set originalValueRef(a) {
            this.dz = a;
            this.e("OriginalValueRef");
        }
        get renderValue() {
            return this.d2;
        }
        set renderValue(a) {
            this.d2 = a;
            this.e("RenderValue");
        }
        get textColor() {
            return this.d9;
        }
        set textColor(a) {
            this.d9 = a;
            this.e("TextColor");
        }
        get actualTextColor() {
            return this.dh;
        }
        set actualTextColor(a) {
            this.dh = a;
            this.e("ActualTextColor");
        }
        get deletedTextColor() {
            return this.dk;
        }
        set deletedTextColor(a) {
            this.dk = a;
            this.e("DeletedTextColor");
        }
        get fontFamily() {
            return this.dr;
        }
        set fontFamily(a) {
            this.dr = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.ax;
        }
        set fontSize(a) {
            this.ax = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.ds;
        }
        set fontStyle(a) {
            this.ds = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.dt;
        }
        set fontWeight(a) {
            this.dt = a;
            this.e("FontWeight");
        }
        get actualFontFamily() {
            return this.de;
        }
        set actualFontFamily(a) {
            this.de = a;
            this.e("ActualFontFamily");
        }
        get actualFontSize() {
            return this.as;
        }
        set actualFontSize(a) {
            this.as = a;
            this.e("ActualFontSize");
        }
        get actualFontStyle() {
            return this.df;
        }
        set actualFontStyle(a) {
            this.df = a;
            this.e("ActualFontStyle");
        }
        get actualFontWeight() {
            return this.dg;
        }
        set actualFontWeight(a) {
            this.dg = a;
            this.e("ActualFontWeight");
        }
        get lineBreakMode() {
            return this.dy;
        }
        set lineBreakMode(a) {
            this.dy = a;
            this.e("LineBreakMode");
        }
        get virtualizationPercentage() {
            return this.a2;
        }
        set virtualizationPercentage(a) {
            this.a2 = a;
            this.e("VirtualizationPercentage");
        }
        get paddingLeft() {
            return this.b9;
        }
        set paddingLeft(a) {
            this.b9 = a;
            this.e("PaddingLeft");
        }
        get paddingTop() {
            return this.cb;
        }
        set paddingTop(a) {
            this.cb = a;
            this.e("PaddingTop");
        }
        get paddingRight() {
            return this.ca;
        }
        set paddingRight(a) {
            this.ca = a;
            this.e("PaddingRight");
        }
        get paddingBottom() {
            return this.b8;
        }
        set paddingBottom(a) {
            this.b8 = a;
            this.e("PaddingBottom");
        }
        get actualPaddingLeft() {
            return this.bt;
        }
        set actualPaddingLeft(a) {
            this.bt = a;
            this.e("ActualPaddingLeft");
        }
        get actualPaddingTop() {
            return this.bv;
        }
        set actualPaddingTop(a) {
            this.bv = a;
            this.e("ActualPaddingTop");
        }
        get actualPaddingRight() {
            return this.bu;
        }
        set actualPaddingRight(a) {
            this.bu = a;
            this.e("ActualPaddingRight");
        }
        get actualPaddingBottom() {
            return this.bs;
        }
        set actualPaddingBottom(a) {
            this.bs = a;
            this.e("ActualPaddingBottom");
        }
        get borderLeftWidth() {
            return this.bx;
        }
        set borderLeftWidth(a) {
            this.bx = a;
            this.e("BorderLeftWidth");
        }
        get borderTopWidth() {
            return this.bz;
        }
        set borderTopWidth(a) {
            this.bz = a;
            this.e("BorderTopWidth");
        }
        get borderRightWidth() {
            return this.by;
        }
        set borderRightWidth(a) {
            this.by = a;
            this.e("BorderRightWidth");
        }
        get borderBottomWidth() {
            return this.bw;
        }
        set borderBottomWidth(a) {
            this.bw = a;
            this.e("BorderBottomWidth");
        }
        get activationBorderLeftWidth() {
            return this.bl;
        }
        set activationBorderLeftWidth(a) {
            this.bl = a;
            this.e("ActivationBorderLeftWidth");
        }
        get activationBorderTopWidth() {
            return this.bn;
        }
        set activationBorderTopWidth(a) {
            this.bn = a;
            this.e("ActivationBorderTopWidth");
        }
        get activationBorderRightWidth() {
            return this.bm;
        }
        set activationBorderRightWidth(a) {
            this.bm = a;
            this.e("ActivationBorderRightWidth");
        }
        get activationBorderBottomWidth() {
            return this.bk;
        }
        set activationBorderBottomWidth(a) {
            this.bk = a;
            this.e("ActivationBorderBottomWidth");
        }
        get errorBorderLeftWidth() {
            return this.b3;
        }
        set errorBorderLeftWidth(a) {
            this.b3 = a;
            this.e("ErrorBorderLeftWidth");
        }
        get errorBorderTopWidth() {
            return this.b5;
        }
        set errorBorderTopWidth(a) {
            this.b5 = a;
            this.e("ErrorBorderTopWidth");
        }
        get errorBorderRightWidth() {
            return this.b4;
        }
        set errorBorderRightWidth(a) {
            this.b4 = a;
            this.e("ErrorBorderRightWidth");
        }
        get errorBorderBottomWidth() {
            return this.b2;
        }
        set errorBorderBottomWidth(a) {
            this.b2 = a;
            this.e("ErrorBorderBottomWidth");
        }
        get actualBorderLeftWidth() {
            return this.bp;
        }
        set actualBorderLeftWidth(a) {
            this.bp = a;
            this.e("ActualBorderLeftWidth");
        }
        get actualBorderTopWidth() {
            return this.br;
        }
        set actualBorderTopWidth(a) {
            this.br = a;
            this.e("ActualBorderTopWidth");
        }
        get actualBorderRightWidth() {
            return this.bq;
        }
        set actualBorderRightWidth(a) {
            this.bq = a;
            this.e("ActualBorderRightWidth");
        }
        get actualBorderBottomWidth() {
            return this.bo;
        }
        set actualBorderBottomWidth(a) {
            this.bo = a;
            this.e("ActualBorderBottomWidth");
        }
        get sortDirection() {
            return this.d5;
        }
        set sortDirection(a) {
            this.d5 = a;
            this.e("SortDirection");
        }
        get isExpanded() {
            return this.o;
        }
        set isExpanded(a) {
            this.o = a;
            this.e("IsExpanded");
        }
        get isCollapsable() {
            return this.j;
        }
        set isCollapsable(a) {
            this.j = a;
            this.e("IsCollapsable");
        }
        get pinned() {
            return this.d0;
        }
        set pinned(a) {
            this.d0 = a;
            this.e("Pinned");
        }
        get editFontFamily() {
            return this.dm;
        }
        set editFontFamily(a) {
            this.dm = a;
            this.e("EditFontFamily");
        }
        get editFontSize() {
            return this.av;
        }
        set editFontSize(a) {
            this.av = a;
            this.e("EditFontSize");
        }
        get editFontStyle() {
            return this.dn;
        }
        set editFontStyle(a) {
            this.dn = a;
            this.e("EditFontStyle");
        }
        get editFontWeight() {
            return this.dp;
        }
        set editFontWeight(a) {
            this.dp = a;
            this.e("EditFontWeight");
        }
        get isEdited() {
            return this.n;
        }
        set isEdited(a) {
            this.n = a;
            this.e("IsEdited");
        }
        get isDeleted() {
            return this.m;
        }
        set isDeleted(a) {
            this.m = a;
            this.e("IsDeleted");
        }
        get editError() {
            return this.dl;
        }
        set editError(a) {
            this.dl = a;
            this.e("EditError");
        }
        get isInEditMode() {
            return this.p;
        }
        set isInEditMode(a) {
            this.p = a;
            this.e("IsInEditMode");
        }
        get editID() {
            return this.b1;
        }
        set editID(a) {
            this.b1 = a;
            this.e("EditID");
        }
    }
    CellInfoDescription.$t = /*@__PURE__*/ markType(CellInfoDescription, 'CellInfoDescription', Description.$);
    CellInfoDescription.__marshalByValue = true;
    CellInfoDescription.__marshalByValueAlias = "CellModel";
    return CellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorCellInfoDescription = /*@__PURE__*/ (() => {
    class EditorCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fg = false;
            this.fd = null;
            this.fj = null;
            this.fo = null;
            this.fn = null;
            this.fm = null;
            this.fk = null;
            this.fl = null;
            this.fb = null;
        }
        get_type() {
            return "EditorCellInfo";
        }
        get isHidden() {
            return this.fg;
        }
        set isHidden(a) {
            this.fg = a;
            this.e("IsHidden");
        }
        get editTarget() {
            return this.fd;
        }
        set editTarget(a) {
            this.fd = a;
            this.e("EditTarget");
        }
        get dataType() {
            return this.fj;
        }
        set dataType(a) {
            this.fj = a;
            this.e("DataType");
        }
        get errorMessage() {
            return this.fo;
        }
        set errorMessage(a) {
            this.fo = a;
            this.e("ErrorMessage");
        }
        get editValueRef() {
            return this.fn;
        }
        set editValueRef(a) {
            this.fn = a;
            this.e("EditValueRef");
        }
        get editorType() {
            return this.fm;
        }
        set editorType(a) {
            this.fm = a;
            this.e("EditorType");
        }
        get editorDataSourceRef() {
            return this.fk;
        }
        set editorDataSourceRef(a) {
            this.fk = a;
            this.e("EditorDataSourceRef");
        }
        get editorTextField() {
            return this.fl;
        }
        set editorTextField(a) {
            this.fl = a;
            this.e("EditorTextField");
        }
        get editorValueField() {
            return this.fb;
        }
        set editorValueField(a) {
            this.fb = a;
            this.e("EditorValueField");
        }
    }
    EditorCellInfoDescription.$t = /*@__PURE__*/ markType(EditorCellInfoDescription, 'EditorCellInfoDescription', CellInfoDescription.$);
    EditorCellInfoDescription.__marshalByValue1 = true;
    EditorCellInfoDescription.__marshalByValueAlias1 = "EditorCellModel";
    return EditorCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class EditorCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (EditorCellInfoDescriptionMetadata.a == null) {
                EditorCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EditorCellInfoDescriptionMetadata.c(a, EditorCellInfoDescriptionMetadata.a);
                CellInfoDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("IsHidden", "Boolean");
            b.item("EditTarget", "ExportedType:CellModel");
            b.item("DataType", "ExportedType:string:DataSourceSchemaPropertyType");
            b.item("DataType@names", "StringValue;IntValue;BooleanValue;LongValue;ShortValue;DoubleValue;DecimalValue;SingleValue;DateTimeValue;DateTimeOffsetValue;ByteValue;ObjectValue");
            b.item("ErrorMessage", "String");
            b.item("EditValueRef", "(w:EditValue,wf:EditValue)DataRef");
            b.item("EditorType", "ExportedType:string:EditorType");
            b.item("EditorType@names", "Default;Text;Numeric;Date;Combo");
            b.item("EditorDataSourceRef", "(w:EditorItemsSource,wf:EditorItemsSource)DataRef");
            b.item("EditorTextField", "String");
            b.item("EditorValueField", "Array:string");
        }
        static d(a) {
            EditorCellInfoDescriptionMetadata.b(a);
            a.q("EditorCellInfo", () => new EditorCellInfoDescription());
            a.p("EditorCellInfo", EditorCellInfoDescriptionMetadata.a);
        }
    }
    EditorCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(EditorCellInfoDescriptionMetadata, 'EditorCellInfoDescriptionMetadata');
    EditorCellInfoDescriptionMetadata.a = null;
    return EditorCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorRowCellInfoDescription = /*@__PURE__*/ (() => {
    class EditorRowCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fb = null;
        }
        get_type() {
            return "EditorRowCellInfo";
        }
        get editTarget() {
            return this.fb;
        }
        set editTarget(a) {
            this.fb = a;
            this.e("EditTarget");
        }
    }
    EditorRowCellInfoDescription.$t = /*@__PURE__*/ markType(EditorRowCellInfoDescription, 'EditorRowCellInfoDescription', CellInfoDescription.$);
    EditorRowCellInfoDescription.__marshalByValue1 = true;
    EditorRowCellInfoDescription.__marshalByValueAlias1 = "EditorRowCellModel";
    return EditorRowCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EditorRowCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class EditorRowCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (EditorRowCellInfoDescriptionMetadata.a == null) {
                EditorRowCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                EditorRowCellInfoDescriptionMetadata.c(a, EditorRowCellInfoDescriptionMetadata.a);
                CellInfoDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("EditTarget", "ExportedType:CellModel");
        }
        static d(a) {
            EditorRowCellInfoDescriptionMetadata.b(a);
            a.q("EditorRowCellInfo", () => new EditorRowCellInfoDescription());
            a.p("EditorRowCellInfo", EditorRowCellInfoDescriptionMetadata.a);
        }
    }
    EditorRowCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(EditorRowCellInfoDescriptionMetadata, 'EditorRowCellInfoDescriptionMetadata');
    EditorRowCellInfoDescriptionMetadata.a = null;
    return EditorRowCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelDescription = /*@__PURE__*/ (() => {
    class ExpansionPanelDescription extends Description {
        constructor() {
            super();
            this.r = null;
            this.u = null;
            this.m = null;
            this.s = null;
            this.t = null;
            this.v = null;
            this.y = null;
            this.n = null;
            this.w = null;
            this.x = null;
            this.i = 0;
            this.h = 0;
            this.f = false;
            this.z = null;
            this.o = null;
            this.aa = null;
            this.ab = null;
            this.q = null;
            this.p = null;
            this.l = null;
            this.ac = null;
            this.ad = null;
        }
        get_type() {
            return "ExpansionPanel";
        }
        get type() {
            return this.get_type();
        }
        get caption() {
            return this.r;
        }
        set caption(a) {
            this.r = a;
            this.e("Caption");
        }
        get captionTextColor() {
            return this.u;
        }
        set captionTextColor(a) {
            this.u = a;
            this.e("CaptionTextColor");
        }
        get actualCaptionTextColor() {
            return this.m;
        }
        set actualCaptionTextColor(a) {
            this.m = a;
            this.e("ActualCaptionTextColor");
        }
        get captionCollapsedTextColor() {
            return this.s;
        }
        set captionCollapsedTextColor(a) {
            this.s = a;
            this.e("CaptionCollapsedTextColor");
        }
        get captionExpandedTextColor() {
            return this.t;
        }
        set captionExpandedTextColor(a) {
            this.t = a;
            this.e("CaptionExpandedTextColor");
        }
        get description() {
            return this.v;
        }
        set description(a) {
            this.v = a;
            this.e("Description");
        }
        get descriptionTextColor() {
            return this.y;
        }
        set descriptionTextColor(a) {
            this.y = a;
            this.e("DescriptionTextColor");
        }
        get actualDescriptionTextColor() {
            return this.n;
        }
        set actualDescriptionTextColor(a) {
            this.n = a;
            this.e("ActualDescriptionTextColor");
        }
        get descriptionCollapsedTextColor() {
            return this.w;
        }
        set descriptionCollapsedTextColor(a) {
            this.w = a;
            this.e("DescriptionCollapsedTextColor");
        }
        get descriptionExpandedTextColor() {
            return this.x;
        }
        set descriptionExpandedTextColor(a) {
            this.x = a;
            this.e("DescriptionExpandedTextColor");
        }
        get elevation() {
            return this.i;
        }
        set elevation(a) {
            this.i = a;
            this.e("Elevation");
        }
        get actualElevation() {
            return this.h;
        }
        set actualElevation(a) {
            this.h = a;
            this.e("ActualElevation");
        }
        get expanded() {
            return this.f;
        }
        set expanded(a) {
            this.f = a;
            this.e("Expanded");
        }
        get headerBackgroundColor() {
            return this.z;
        }
        set headerBackgroundColor(a) {
            this.z = a;
            this.e("HeaderBackgroundColor");
        }
        get actualHeaderBackgroundColor() {
            return this.o;
        }
        set actualHeaderBackgroundColor(a) {
            this.o = a;
            this.e("ActualHeaderBackgroundColor");
        }
        get headerCollapsedBackgroundColor() {
            return this.aa;
        }
        set headerCollapsedBackgroundColor(a) {
            this.aa = a;
            this.e("HeaderCollapsedBackgroundColor");
        }
        get headerExpandedBackgroundColor() {
            return this.ab;
        }
        set headerExpandedBackgroundColor(a) {
            this.ab = a;
            this.e("HeaderExpandedBackgroundColor");
        }
        get actualUmbraShadowColor() {
            return this.q;
        }
        set actualUmbraShadowColor(a) {
            this.q = a;
            this.e("ActualUmbraShadowColor");
        }
        get actualPenumbraShadowColor() {
            return this.p;
        }
        set actualPenumbraShadowColor(a) {
            this.p = a;
            this.e("ActualPenumbraShadowColor");
        }
        get actualAmbientShadowColor() {
            return this.l;
        }
        set actualAmbientShadowColor(a) {
            this.l = a;
            this.e("ActualAmbientShadowColor");
        }
        get onCollapsedRef() {
            return this.ac;
        }
        set onCollapsedRef(a) {
            this.ac = a;
            this.e("OnCollapsedRef");
        }
        get onExpandedRef() {
            return this.ad;
        }
        set onExpandedRef(a) {
            this.ad = a;
            this.e("OnExpandedRef");
        }
    }
    ExpansionPanelDescription.$t = /*@__PURE__*/ markType(ExpansionPanelDescription, 'ExpansionPanelDescription', Description.$);
    return ExpansionPanelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnCollapsedEventArgsDescription = /*@__PURE__*/ (() => {
    class OnCollapsedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "OnCollapsedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    OnCollapsedEventArgsDescription.$t = /*@__PURE__*/ markType(OnCollapsedEventArgsDescription, 'OnCollapsedEventArgsDescription', Description.$);
    return OnCollapsedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnCollapsedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnCollapsedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnCollapsedEventArgsDescriptionMetadata.a == null) {
                OnCollapsedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnCollapsedEventArgsDescriptionMetadata.c(a, OnCollapsedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            OnCollapsedEventArgsDescriptionMetadata.b(a);
            a.q("OnCollapsedEventArgs", () => new OnCollapsedEventArgsDescription());
            a.p("OnCollapsedEventArgs", OnCollapsedEventArgsDescriptionMetadata.a);
        }
    }
    OnCollapsedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnCollapsedEventArgsDescriptionMetadata, 'OnCollapsedEventArgsDescriptionMetadata');
    OnCollapsedEventArgsDescriptionMetadata.a = null;
    return OnCollapsedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnExpandedEventArgsDescription = /*@__PURE__*/ (() => {
    class OnExpandedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "OnExpandedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    OnExpandedEventArgsDescription.$t = /*@__PURE__*/ markType(OnExpandedEventArgsDescription, 'OnExpandedEventArgsDescription', Description.$);
    return OnExpandedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnExpandedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnExpandedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnExpandedEventArgsDescriptionMetadata.a == null) {
                OnExpandedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnExpandedEventArgsDescriptionMetadata.c(a, OnExpandedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            OnExpandedEventArgsDescriptionMetadata.b(a);
            a.q("OnExpandedEventArgs", () => new OnExpandedEventArgsDescription());
            a.p("OnExpandedEventArgs", OnExpandedEventArgsDescriptionMetadata.a);
        }
    }
    OnExpandedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnExpandedEventArgsDescriptionMetadata, 'OnExpandedEventArgsDescriptionMetadata');
    OnExpandedEventArgsDescriptionMetadata.a = null;
    return OnExpandedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelDescriptionMetadata = /*@__PURE__*/ (() => {
    class ExpansionPanelDescriptionMetadata extends Base {
        static b(a) {
            if (ExpansionPanelDescriptionMetadata.a == null) {
                ExpansionPanelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ExpansionPanelDescriptionMetadata.c(a, ExpansionPanelDescriptionMetadata.a);
                OnCollapsedEventArgsDescriptionMetadata.d(a);
                OnExpandedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Caption", "String");
            b.item("CaptionTextColor", "Brush");
            b.item("ActualCaptionTextColor", "Brush");
            b.item("CaptionCollapsedTextColor", "Brush");
            b.item("CaptionExpandedTextColor", "Brush");
            b.item("Description", "String");
            b.item("DescriptionTextColor", "Brush");
            b.item("ActualDescriptionTextColor", "Brush");
            b.item("DescriptionCollapsedTextColor", "Brush");
            b.item("DescriptionExpandedTextColor", "Brush");
            b.item("Elevation", "Number:int");
            b.item("ActualElevation", "Number:int");
            b.item("Expanded", "Boolean");
            b.item("HeaderBackgroundColor", "Brush");
            b.item("ActualHeaderBackgroundColor", "Brush");
            b.item("HeaderCollapsedBackgroundColor", "Brush");
            b.item("HeaderExpandedBackgroundColor", "Brush");
            b.item("ActualUmbraShadowColor", "Brush");
            b.item("ActualPenumbraShadowColor", "Brush");
            b.item("ActualAmbientShadowColor", "Brush");
            b.item("OnCollapsedRef", "EventRef::onCollapsed");
            b.item("OnExpandedRef", "EventRef::onExpanded");
        }
        static d(a) {
            ExpansionPanelDescriptionMetadata.b(a);
            a.q("ExpansionPanel", () => new ExpansionPanelDescription());
            a.p("ExpansionPanel", ExpansionPanelDescriptionMetadata.a);
        }
    }
    ExpansionPanelDescriptionMetadata.$t = /*@__PURE__*/ markType(ExpansionPanelDescriptionMetadata, 'ExpansionPanelDescriptionMetadata');
    ExpansionPanelDescriptionMetadata.a = null;
    return ExpansionPanelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelDescriptionModule = /*@__PURE__*/ (() => {
    class ExpansionPanelDescriptionModule extends Base {
        static register(a) {
            ExpansionPanelDescriptionMetadata.d(a);
        }
    }
    ExpansionPanelDescriptionModule.$t = /*@__PURE__*/ markType(ExpansionPanelDescriptionModule, 'ExpansionPanelDescriptionModule');
    return ExpansionPanelDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterDialogRenderCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class FilterDialogRenderCompletedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FilterDialogRenderCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    FilterDialogRenderCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(FilterDialogRenderCompletedEventArgsDescription, 'FilterDialogRenderCompletedEventArgsDescription', Description.$);
    return FilterDialogRenderCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FilterDialogRenderCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FilterDialogRenderCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FilterDialogRenderCompletedEventArgsDescriptionMetadata.a == null) {
                FilterDialogRenderCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FilterDialogRenderCompletedEventArgsDescriptionMetadata.c(a, FilterDialogRenderCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FilterDialogRenderCompletedEventArgsDescriptionMetadata.b(a);
            a.q("FilterDialogRenderCompletedEventArgs", () => new FilterDialogRenderCompletedEventArgsDescription());
            a.p("FilterDialogRenderCompletedEventArgs", FilterDialogRenderCompletedEventArgsDescriptionMetadata.a);
        }
    }
    FilterDialogRenderCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FilterDialogRenderCompletedEventArgsDescriptionMetadata, 'FilterDialogRenderCompletedEventArgsDescriptionMetadata');
    FilterDialogRenderCompletedEventArgsDescriptionMetadata.a = null;
    return FilterDialogRenderCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartCustomIndicatorArgsDescription = /*@__PURE__*/ (() => {
    class FinancialChartCustomIndicatorArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = 0;
        }
        get_type() {
            return "FinancialChartCustomIndicatorArgs";
        }
        get type() {
            return this.get_type();
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get index() {
            return this.h;
        }
        set index(a) {
            this.h = a;
            this.e("Index");
        }
    }
    FinancialChartCustomIndicatorArgsDescription.$t = /*@__PURE__*/ markType(FinancialChartCustomIndicatorArgsDescription, 'FinancialChartCustomIndicatorArgsDescription', Description.$);
    return FinancialChartCustomIndicatorArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartCustomIndicatorArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartCustomIndicatorArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialChartCustomIndicatorArgsDescriptionMetadata.a == null) {
                FinancialChartCustomIndicatorArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialChartCustomIndicatorArgsDescriptionMetadata.c(a, FinancialChartCustomIndicatorArgsDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Series", "ExportedType:Series");
            b.item("Index", "Number:int");
        }
        static d(a) {
            FinancialChartCustomIndicatorArgsDescriptionMetadata.b(a);
            a.q("FinancialChartCustomIndicatorArgs", () => new FinancialChartCustomIndicatorArgsDescription());
            a.p("FinancialChartCustomIndicatorArgs", FinancialChartCustomIndicatorArgsDescriptionMetadata.a);
        }
    }
    FinancialChartCustomIndicatorArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartCustomIndicatorArgsDescriptionMetadata, 'FinancialChartCustomIndicatorArgsDescriptionMetadata');
    FinancialChartCustomIndicatorArgsDescriptionMetadata.a = null;
    return FinancialChartCustomIndicatorArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDescription = /*@__PURE__*/ (() => {
    class FinancialChartDescription extends XYChartDescription {
        constructor() {
            super();
            this.kr = null;
            this.kt = null;
            this.kq = null;
            this.ko = null;
            this.jp = 0;
            this.i5 = false;
            this.js = 0;
            this.jb = false;
            this.kg = 0;
            this.ju = 0;
            this.jw = 0;
            this.jv = 0;
            this.jx = 0;
            this.ks = null;
            this.ku = null;
            this.kx = null;
            this.i7 = false;
            this.kp = null;
            this.kv = null;
            this.i9 = false;
            this.ig = null;
            this.il = null;
            this.ja = false;
            this.jr = 0;
            this.kw = null;
            this.ky = null;
            this.ih = null;
            this.ii = null;
            this.ij = null;
            this.ik = null;
            this.ip = null;
            this.io = null;
            this.ie = null;
            this.ic = null;
            this.jt = 0;
            this.jq = 0;
            this.jo = 0;
            this.id = null;
            this.kc = 0;
            this.jn = 0;
            this.kf = 0;
            this.kd = 0;
            this.kb = 0;
            this.ke = 0;
            this.im = null;
            this.ib = null;
            this.i8 = false;
            this.kz = null;
            this.jy = 0;
            this.i6 = false;
            this.jk = new Date();
            this.jj = new Date();
            this.iq = null;
            this.kn = null;
        }
        get tooltipTemplateRef() {
            return this.kr;
        }
        set tooltipTemplateRef(a) {
            this.kr = a;
            this.e("TooltipTemplateRef");
        }
        get width() {
            return this.kt;
        }
        set width(a) {
            this.kt = a;
            this.e("Width");
        }
        get height() {
            return this.kq;
        }
        set height(a) {
            this.kq = a;
            this.e("Height");
        }
        get background() {
            return this.ko;
        }
        set background(a) {
            this.ko = a;
            this.e("Background");
        }
        get_type() {
            return "FinancialChart";
        }
        get leftMargin() {
            return this.jp;
        }
        set leftMargin(a) {
            this.jp = a;
            this.e("LeftMargin");
        }
        get isHorizontalZoomEnabled() {
            return this.i5;
        }
        set isHorizontalZoomEnabled(a) {
            this.i5 = a;
            this.e("IsHorizontalZoomEnabled");
        }
        get toolbarHeight() {
            return this.js;
        }
        set toolbarHeight(a) {
            this.js = a;
            this.e("ToolbarHeight");
        }
        get yAxisIsLogarithmic() {
            return this.jb;
        }
        set yAxisIsLogarithmic(a) {
            this.jb = a;
            this.e("YAxisIsLogarithmic");
        }
        get yAxisLogarithmBase() {
            return this.kg;
        }
        set yAxisLogarithmBase(a) {
            this.kg = a;
            this.e("YAxisLogarithmBase");
        }
        get yAxisInterval() {
            return this.ju;
        }
        set yAxisInterval(a) {
            this.ju = a;
            this.e("YAxisInterval");
        }
        get yAxisMinimumValue() {
            return this.jw;
        }
        set yAxisMinimumValue(a) {
            this.jw = a;
            this.e("YAxisMinimumValue");
        }
        get yAxisMaximumValue() {
            return this.jv;
        }
        set yAxisMaximumValue(a) {
            this.jv = a;
            this.e("YAxisMaximumValue");
        }
        get yAxisMinorInterval() {
            return this.jx;
        }
        set yAxisMinorInterval(a) {
            this.jx = a;
            this.e("YAxisMinorInterval");
        }
        get volumeType() {
            return this.ks;
        }
        set volumeType(a) {
            this.ks = a;
            this.e("VolumeType");
        }
        get xAxisMode() {
            return this.ku;
        }
        set xAxisMode(a) {
            this.ku = a;
            this.e("XAxisMode");
        }
        get yAxisMode() {
            return this.kx;
        }
        set yAxisMode(a) {
            this.kx = a;
            this.e("YAxisMode");
        }
        get isToolbarVisible() {
            return this.i7;
        }
        set isToolbarVisible(a) {
            this.i7 = a;
            this.e("IsToolbarVisible");
        }
        get chartType() {
            return this.kp;
        }
        set chartType(a) {
            this.kp = a;
            this.e("ChartType");
        }
        get yAxisLabelHorizontalAlignment() {
            return this.kv;
        }
        set yAxisLabelHorizontalAlignment(a) {
            this.kv = a;
            this.e("YAxisLabelHorizontalAlignment");
        }
        get isWindowSyncedToVisibleRange() {
            return this.i9;
        }
        set isWindowSyncedToVisibleRange(a) {
            this.i9 = a;
            this.e("IsWindowSyncedToVisibleRange");
        }
        get indicatorTypes() {
            return this.ig;
        }
        set indicatorTypes(a) {
            this.ig = a;
            this.e("IndicatorTypes");
        }
        get overlayTypes() {
            return this.il;
        }
        set overlayTypes(a) {
            this.il = a;
            this.e("OverlayTypes");
        }
        get yAxisAbbreviateLargeNumbers() {
            return this.ja;
        }
        set yAxisAbbreviateLargeNumbers(a) {
            this.ja = a;
            this.e("YAxisAbbreviateLargeNumbers");
        }
        get resolution() {
            return this.jr;
        }
        set resolution(a) {
            this.jr = a;
            this.e("Resolution");
        }
        get yAxisLabelLocation() {
            return this.kw;
        }
        set yAxisLabelLocation(a) {
            this.kw = a;
            this.e("YAxisLabelLocation");
        }
        get zoomSliderType() {
            return this.ky;
        }
        set zoomSliderType(a) {
            this.ky = a;
            this.e("ZoomSliderType");
        }
        get negativeBrushes() {
            return this.ih;
        }
        set negativeBrushes(a) {
            this.ih = a;
            this.e("NegativeBrushes");
        }
        get negativeOutlines() {
            return this.ii;
        }
        set negativeOutlines(a) {
            this.ii = a;
            this.e("NegativeOutlines");
        }
        get overlayBrushes() {
            return this.ij;
        }
        set overlayBrushes(a) {
            this.ij = a;
            this.e("OverlayBrushes");
        }
        get overlayOutlines() {
            return this.ik;
        }
        set overlayOutlines(a) {
            this.ik = a;
            this.e("OverlayOutlines");
        }
        get volumeOutlines() {
            return this.ip;
        }
        set volumeOutlines(a) {
            this.ip = a;
            this.e("VolumeOutlines");
        }
        get volumeBrushes() {
            return this.io;
        }
        set volumeBrushes(a) {
            this.io = a;
            this.e("VolumeBrushes");
        }
        get indicatorNegativeBrushes() {
            return this.ie;
        }
        set indicatorNegativeBrushes(a) {
            this.ie = a;
            this.e("IndicatorNegativeBrushes");
        }
        get indicatorBrushes() {
            return this.ic;
        }
        set indicatorBrushes(a) {
            this.ic = a;
            this.e("IndicatorBrushes");
        }
        get volumeThickness() {
            return this.jt;
        }
        set volumeThickness(a) {
            this.jt = a;
            this.e("VolumeThickness");
        }
        get overlayThickness() {
            return this.jq;
        }
        set overlayThickness(a) {
            this.jq = a;
            this.e("OverlayThickness");
        }
        get indicatorThickness() {
            return this.jo;
        }
        set indicatorThickness(a) {
            this.jo = a;
            this.e("IndicatorThickness");
        }
        get indicatorDisplayTypes() {
            return this.id;
        }
        set indicatorDisplayTypes(a) {
            this.id = a;
            this.e("IndicatorDisplayTypes");
        }
        get indicatorPeriod() {
            return this.kc;
        }
        set indicatorPeriod(a) {
            this.kc = a;
            this.e("IndicatorPeriod");
        }
        get indicatorMultiplier() {
            return this.jn;
        }
        set indicatorMultiplier(a) {
            this.jn = a;
            this.e("IndicatorMultiplier");
        }
        get indicatorSmoothingPeriod() {
            return this.kf;
        }
        set indicatorSmoothingPeriod(a) {
            this.kf = a;
            this.e("IndicatorSmoothingPeriod");
        }
        get indicatorShortPeriod() {
            return this.kd;
        }
        set indicatorShortPeriod(a) {
            this.kd = a;
            this.e("IndicatorShortPeriod");
        }
        get indicatorLongPeriod() {
            return this.kb;
        }
        set indicatorLongPeriod(a) {
            this.kb = a;
            this.e("IndicatorLongPeriod");
        }
        get indicatorSignalPeriod() {
            return this.ke;
        }
        set indicatorSignalPeriod(a) {
            this.ke = a;
            this.e("IndicatorSignalPeriod");
        }
        get rangeSelectorOptions() {
            return this.im;
        }
        set rangeSelectorOptions(a) {
            this.im = a;
            this.e("RangeSelectorOptions");
        }
        get customIndicatorNames() {
            return this.ib;
        }
        set customIndicatorNames(a) {
            this.ib = a;
            this.e("CustomIndicatorNames");
        }
        get isVerticalZoomEnabled() {
            return this.i8;
        }
        set isVerticalZoomEnabled(a) {
            this.i8 = a;
            this.e("IsVerticalZoomEnabled");
        }
        get zoomSliderXAxisMajorStroke() {
            return this.kz;
        }
        set zoomSliderXAxisMajorStroke(a) {
            this.kz = a;
            this.e("ZoomSliderXAxisMajorStroke");
        }
        get zoomSliderXAxisMajorStrokeThickness() {
            return this.jy;
        }
        set zoomSliderXAxisMajorStrokeThickness(a) {
            this.jy = a;
            this.e("ZoomSliderXAxisMajorStrokeThickness");
        }
        get isLegendVisible() {
            return this.i6;
        }
        set isLegendVisible(a) {
            this.i6 = a;
            this.e("IsLegendVisible");
        }
        get xAxisMinimumValue() {
            return this.jk;
        }
        set xAxisMinimumValue(a) {
            this.jk = a;
            this.e("XAxisMinimumValue");
        }
        get xAxisMaximumValue() {
            return this.jj;
        }
        set xAxisMaximumValue(a) {
            this.jj = a;
            this.e("XAxisMaximumValue");
        }
        get xAxisBreaks() {
            return this.iq;
        }
        set xAxisBreaks(a) {
            this.iq = a;
            this.e("XAxisBreaks");
        }
        get applyCustomIndicatorsRef() {
            return this.kn;
        }
        set applyCustomIndicatorsRef(a) {
            this.kn = a;
            this.e("ApplyCustomIndicatorsRef");
        }
    }
    FinancialChartDescription.$t = /*@__PURE__*/ markType(FinancialChartDescription, 'FinancialChartDescription', XYChartDescription.$);
    return FinancialChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamFinancialChart");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (FinancialChartDescriptionMetadata.a == null) {
                FinancialChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialChartDescriptionMetadata.c(a, FinancialChartDescriptionMetadata.a);
                FinancialChartCustomIndicatorArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            XYChartDescriptionMetadata.c(a, b);
            b.item("LeftMargin", "Number:double");
            b.item("IsHorizontalZoomEnabled", "Boolean");
            b.item("ToolbarHeight", "Number:double");
            b.item("YAxisIsLogarithmic", "Boolean");
            b.item("YAxisLogarithmBase", "Number:int");
            b.item("YAxisInterval", "Number:double");
            b.item("YAxisMinimumValue", "Number:double");
            b.item("YAxisMaximumValue", "Number:double");
            b.item("YAxisMinorInterval", "Number:double");
            b.item("VolumeType", "ExportedType:string:FinancialChartVolumeType");
            b.item("VolumeType@names", "None;Column;Line;Area");
            b.item("XAxisMode", "ExportedType:string:FinancialChartXAxisMode");
            b.item("XAxisMode@names", "Ordinal;Time");
            b.item("YAxisMode", "ExportedType:string:FinancialChartYAxisMode");
            b.item("YAxisMode@names", "Numeric;PercentChange");
            b.item("IsToolbarVisible", "Boolean");
            b.item("ChartType", "ExportedType:string:FinancialChartType");
            b.item("ChartType@names", "Auto;Bar;Candle;Column;Line");
            b.item("YAxisLabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("YAxisLabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("IsWindowSyncedToVisibleRange", "Boolean");
            b.item("IndicatorTypes", "Collection:string:FinancialIndicatorTypeCollection:FinancialIndicatorType");
            b.item("IndicatorTypes@names", "AbsoluteVolumeOscillator;AccumulationDistribution;AverageDirectionalIndex;AverageTrueRange;BollingerBandWidth;ChaikinOscillator;ChaikinVolatility;CommodityChannelIndex;DetrendedPriceOscillator;EaseOfMovement;FastStochasticOscillator;ForceIndex;FullStochasticOscillator;MarketFacilitationIndex;MassIndex;MedianPrice;MoneyFlowIndex;MovingAverageConvergenceDivergence;NegativeVolumeIndex;OnBalanceVolume;PercentagePriceOscillator;PercentageVolumeOscillator;PositiveVolumeIndex;PriceVolumeTrend;RateOfChangeAndMomentum;RelativeStrengthIndex;SlowStochasticOscillator;StandardDeviation;StochRSI;TRIX;TypicalPrice;UltimateOscillator;WeightedClose;WilliamsPercentR");
            b.item("OverlayTypes", "Collection:string:FinancialOverlayTypeCollection:FinancialOverlayType");
            b.item("OverlayTypes@names", "BollingerBands;PriceChannel");
            b.item("YAxisAbbreviateLargeNumbers", "Boolean");
            b.item("Resolution", "Number:double");
            b.item("YAxisLabelLocation", "ExportedType:string:AxisLabelsLocation");
            b.item("YAxisLabelLocation@names", "OutsideTop;OutsideBottom;OutsideLeft;OutsideRight;InsideTop;InsideBottom;InsideLeft;InsideRight");
            b.item("ZoomSliderType", "ExportedType:string:FinancialChartZoomSliderType");
            b.item("ZoomSliderType@names", "None;Auto;Bar;Candle;Column;Line;Area");
            b.item("NegativeBrushes", "BrushCollection:string");
            b.item("NegativeOutlines", "BrushCollection:string");
            b.item("OverlayBrushes", "BrushCollection:string");
            b.item("OverlayOutlines", "BrushCollection:string");
            b.item("VolumeOutlines", "BrushCollection:string");
            b.item("VolumeBrushes", "BrushCollection:string");
            b.item("IndicatorNegativeBrushes", "BrushCollection:string");
            b.item("IndicatorBrushes", "BrushCollection:string");
            b.item("VolumeThickness", "Number:double");
            b.item("OverlayThickness", "Number:double");
            b.item("IndicatorThickness", "Number:double");
            b.item("IndicatorDisplayTypes", "Collection:string:IndicatorDisplayTypeCollection:IndicatorDisplayType");
            b.item("IndicatorDisplayTypes@names", "Line;Area;Column");
            b.item("IndicatorPeriod", "Number:int");
            b.item("IndicatorMultiplier", "Number:double");
            b.item("IndicatorSmoothingPeriod", "Number:int");
            b.item("IndicatorShortPeriod", "Number:int");
            b.item("IndicatorLongPeriod", "Number:int");
            b.item("IndicatorSignalPeriod", "Number:int");
            b.item("RangeSelectorOptions", "Collection:string:FinancialChartRangeSelectorOptionCollection:FinancialChartRangeSelectorOption");
            b.item("RangeSelectorOptions@names", "OneMonth;ThreeMonths;SixMonths;YearToDate;OneYear;All");
            b.item("CustomIndicatorNames", "Collection:String:CustomIndicatorNameCollection:String");
            b.item("IsVerticalZoomEnabled", "Boolean");
            b.item("ZoomSliderXAxisMajorStroke", "Brush");
            b.item("ZoomSliderXAxisMajorStrokeThickness", "Number:double");
            b.item("IsLegendVisible", "Boolean");
            b.item("XAxisMinimumValue", "Date");
            b.item("XAxisMaximumValue", "Date");
            b.item("XAxisBreaks", "Collection:TimeAxisBreak:TimeAxisBreakCollection:TimeAxisBreak");
            b.item("ApplyCustomIndicatorsRef", "EventRef::applyCustomIndicators");
            FinancialChartDescriptionMetadata.e(a, b);
        }
        static d(a) {
            FinancialChartDescriptionMetadata.b(a);
            a.q("FinancialChart", () => new FinancialChartDescription());
            a.p("FinancialChart", FinancialChartDescriptionMetadata.a);
        }
    }
    FinancialChartDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartDescriptionMetadata, 'FinancialChartDescriptionMetadata');
    FinancialChartDescriptionMetadata.a = null;
    return FinancialChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDefaultTemplatesDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartDefaultTemplatesDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    FinancialChartDefaultTemplatesDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartDefaultTemplatesDescriptionMetadata, 'FinancialChartDefaultTemplatesDescriptionMetadata');
    return FinancialChartDefaultTemplatesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialChartCoreDescriptionModule extends Base {
        static register(a) {
            FinancialChartDescriptionMetadata.d(a);
            FinancialChartDefaultTemplatesDescriptionMetadata.register(a);
            TemplateContentDescriptionModule.register(a);
        }
    }
    FinancialChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(FinancialChartCoreDescriptionModule, 'FinancialChartCoreDescriptionModule');
    return FinancialChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentChangeYAxisDescription = /*@__PURE__*/ (() => {
    class PercentChangeYAxisDescription extends NumericYAxisDescription {
        constructor() {
            super();
        }
        get_type() {
            return "PercentChangeYAxis";
        }
    }
    PercentChangeYAxisDescription.$t = /*@__PURE__*/ markType(PercentChangeYAxisDescription, 'PercentChangeYAxisDescription', NumericYAxisDescription.$);
    return PercentChangeYAxisDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentChangeYAxisDescriptionMetadata = /*@__PURE__*/ (() => {
    class PercentChangeYAxisDescriptionMetadata extends Base {
        static b(a) {
            if (PercentChangeYAxisDescriptionMetadata.a == null) {
                PercentChangeYAxisDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PercentChangeYAxisDescriptionMetadata.c(a, PercentChangeYAxisDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            NumericYAxisDescriptionMetadata.c(a, b);
        }
        static d(a) {
            PercentChangeYAxisDescriptionMetadata.b(a);
            a.q("PercentChangeYAxis", () => new PercentChangeYAxisDescription());
            a.p("PercentChangeYAxis", PercentChangeYAxisDescriptionMetadata.a);
        }
    }
    PercentChangeYAxisDescriptionMetadata.$t = /*@__PURE__*/ markType(PercentChangeYAxisDescriptionMetadata, 'PercentChangeYAxisDescriptionMetadata');
    PercentChangeYAxisDescriptionMetadata.a = null;
    return PercentChangeYAxisDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PercentChangeYAxisDescriptionModule = /*@__PURE__*/ (() => {
    class PercentChangeYAxisDescriptionModule extends Base {
        static register(a) {
            PercentChangeYAxisDescriptionMetadata.d(a);
        }
    }
    PercentChangeYAxisDescriptionModule.$t = /*@__PURE__*/ markType(PercentChangeYAxisDescriptionModule, 'PercentChangeYAxisDescriptionModule');
    return PercentChangeYAxisDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderResolvingAxisValueEventArgsDescription = /*@__PURE__*/ (() => {
    class ZoomSliderResolvingAxisValueEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
            this.h = null;
        }
        get_type() {
            return "ZoomSliderResolvingAxisValueEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get position() {
            return this.f;
        }
        set position(a) {
            this.f = a;
            this.e("Position");
        }
        get valueRef() {
            return this.h;
        }
        set valueRef(a) {
            this.h = a;
            this.e("ValueRef");
        }
    }
    ZoomSliderResolvingAxisValueEventArgsDescription.$t = /*@__PURE__*/ markType(ZoomSliderResolvingAxisValueEventArgsDescription, 'ZoomSliderResolvingAxisValueEventArgsDescription', Description.$);
    return ZoomSliderResolvingAxisValueEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a == null) {
                ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.c(a, ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Position", "Number:double");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.b(a);
            a.q("ZoomSliderResolvingAxisValueEventArgs", () => new ZoomSliderResolvingAxisValueEventArgsDescription());
            a.p("ZoomSliderResolvingAxisValueEventArgs", ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a);
        }
    }
    ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata, 'ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata');
    ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.a = null;
    return ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderDescription = /*@__PURE__*/ (() => {
    class ZoomSliderDescription extends Description {
        constructor() {
            super();
            this.bv = null;
            this.a6 = null;
            this.a3 = null;
            this.a1 = 0;
            this.x = 0;
            this.z = 0;
            this.j = 0;
            this.f = null;
            this.y = 0;
            this.ab = 0;
            this.m = 0;
            this.ae = 0;
            this.ad = 0;
            this.k = 0;
            this.bn = null;
            this.bk = null;
            this.v = 0;
            this.q = 0;
            this.bc = null;
            this.bl = null;
            this.bd = null;
            this.bm = null;
            this.be = null;
            this.w = 0;
            this.r = 0;
            this.u = 0;
            this.p = 0;
            this.bi = null;
            this.bj = null;
            this.t = 0;
            this.ba = null;
            this.bb = null;
            this.o = 0;
            this.a4 = null;
            this.a5 = null;
            this.l = 0;
            this.bo = null;
            this.bp = null;
            this.aa = 0;
            this.bq = null;
            this.bf = null;
            this.bh = null;
            this.bg = null;
            this.s = 0;
            this.a7 = null;
            this.a9 = null;
            this.a8 = null;
            this.n = 0;
            this.h = false;
            this.bs = null;
            this.ac = 0;
            this.bt = null;
            this.bu = null;
            this.br = null;
            this.bw = null;
        }
        get width() {
            return this.bv;
        }
        set width(a) {
            this.bv = a;
            this.e("Width");
        }
        get height() {
            return this.a6;
        }
        set height(a) {
            this.a6 = a;
            this.e("Height");
        }
        get background() {
            return this.a3;
        }
        set background(a) {
            this.a3 = a;
            this.e("Background");
        }
        get_type() {
            return "ZoomSlider";
        }
        get type() {
            return this.get_type();
        }
        get panTransitionDuration() {
            return this.a1;
        }
        set panTransitionDuration(a) {
            this.a1 = a;
            this.e("PanTransitionDuration");
        }
        get maxZoomWidth() {
            return this.x;
        }
        set maxZoomWidth(a) {
            this.x = a;
            this.e("MaxZoomWidth");
        }
        get pixelScalingRatio() {
            return this.z;
        }
        set pixelScalingRatio(a) {
            this.z = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.j;
        }
        set actualPixelScalingRatio(a) {
            this.j = a;
            this.e("ActualPixelScalingRatio");
        }
        get windowRect() {
            return this.f;
        }
        set windowRect(a) {
            this.f = a;
            this.e("WindowRect");
        }
        get minZoomWidth() {
            return this.y;
        }
        set minZoomWidth(a) {
            this.y = a;
            this.e("MinZoomWidth");
        }
        get startInset() {
            return this.ab;
        }
        set startInset(a) {
            this.ab = a;
            this.e("StartInset");
        }
        get endInset() {
            return this.m;
        }
        set endInset(a) {
            this.m = a;
            this.e("EndInset");
        }
        get trackStartInset() {
            return this.ae;
        }
        set trackStartInset(a) {
            this.ae = a;
            this.e("TrackStartInset");
        }
        get trackEndInset() {
            return this.ad;
        }
        set trackEndInset(a) {
            this.ad = a;
            this.e("TrackEndInset");
        }
        get barExtent() {
            return this.k;
        }
        set barExtent(a) {
            this.k = a;
            this.e("BarExtent");
        }
        get orientation() {
            return this.bn;
        }
        set orientation(a) {
            this.bn = a;
            this.e("Orientation");
        }
        get lowerThumbBrush() {
            return this.bk;
        }
        set lowerThumbBrush(a) {
            this.bk = a;
            this.e("LowerThumbBrush");
        }
        get lowerThumbStrokeThickness() {
            return this.v;
        }
        set lowerThumbStrokeThickness(a) {
            this.v = a;
            this.e("LowerThumbStrokeThickness");
        }
        get higherThumbStrokeThickness() {
            return this.q;
        }
        set higherThumbStrokeThickness(a) {
            this.q = a;
            this.e("HigherThumbStrokeThickness");
        }
        get higherThumbBrush() {
            return this.bc;
        }
        set higherThumbBrush(a) {
            this.bc = a;
            this.e("HigherThumbBrush");
        }
        get lowerThumbOutline() {
            return this.bl;
        }
        set lowerThumbOutline(a) {
            this.bl = a;
            this.e("LowerThumbOutline");
        }
        get higherThumbOutline() {
            return this.bd;
        }
        set higherThumbOutline(a) {
            this.bd = a;
            this.e("HigherThumbOutline");
        }
        get lowerThumbRidgesBrush() {
            return this.bm;
        }
        set lowerThumbRidgesBrush(a) {
            this.bm = a;
            this.e("LowerThumbRidgesBrush");
        }
        get higherThumbRidgesBrush() {
            return this.be;
        }
        set higherThumbRidgesBrush(a) {
            this.be = a;
            this.e("HigherThumbRidgesBrush");
        }
        get lowerThumbWidth() {
            return this.w;
        }
        set lowerThumbWidth(a) {
            this.w = a;
            this.e("LowerThumbWidth");
        }
        get higherThumbWidth() {
            return this.r;
        }
        set higherThumbWidth(a) {
            this.r = a;
            this.e("HigherThumbWidth");
        }
        get lowerThumbHeight() {
            return this.u;
        }
        set lowerThumbHeight(a) {
            this.u = a;
            this.e("LowerThumbHeight");
        }
        get higherThumbHeight() {
            return this.p;
        }
        set higherThumbHeight(a) {
            this.p = a;
            this.e("HigherThumbHeight");
        }
        get lowerShadeBrush() {
            return this.bi;
        }
        set lowerShadeBrush(a) {
            this.bi = a;
            this.e("LowerShadeBrush");
        }
        get lowerShadeOutline() {
            return this.bj;
        }
        set lowerShadeOutline(a) {
            this.bj = a;
            this.e("LowerShadeOutline");
        }
        get lowerShadeStrokeThickness() {
            return this.t;
        }
        set lowerShadeStrokeThickness(a) {
            this.t = a;
            this.e("LowerShadeStrokeThickness");
        }
        get higherShadeBrush() {
            return this.ba;
        }
        set higherShadeBrush(a) {
            this.ba = a;
            this.e("HigherShadeBrush");
        }
        get higherShadeOutline() {
            return this.bb;
        }
        set higherShadeOutline(a) {
            this.bb = a;
            this.e("HigherShadeOutline");
        }
        get higherShadeStrokeThickness() {
            return this.o;
        }
        set higherShadeStrokeThickness(a) {
            this.o = a;
            this.e("HigherShadeStrokeThickness");
        }
        get barBrush() {
            return this.a4;
        }
        set barBrush(a) {
            this.a4 = a;
            this.e("BarBrush");
        }
        get barOutline() {
            return this.a5;
        }
        set barOutline(a) {
            this.a5 = a;
            this.e("BarOutline");
        }
        get barStrokeThickness() {
            return this.l;
        }
        set barStrokeThickness(a) {
            this.l = a;
            this.e("BarStrokeThickness");
        }
        get rangeThumbBrush() {
            return this.bo;
        }
        set rangeThumbBrush(a) {
            this.bo = a;
            this.e("RangeThumbBrush");
        }
        get rangeThumbOutline() {
            return this.bp;
        }
        set rangeThumbOutline(a) {
            this.bp = a;
            this.e("RangeThumbOutline");
        }
        get rangeThumbStrokeThickness() {
            return this.aa;
        }
        set rangeThumbStrokeThickness(a) {
            this.aa = a;
            this.e("RangeThumbStrokeThickness");
        }
        get rangeThumbRidgesBrush() {
            return this.bq;
        }
        set rangeThumbRidgesBrush(a) {
            this.bq = a;
            this.e("RangeThumbRidgesBrush");
        }
        get lowerCalloutBrush() {
            return this.bf;
        }
        set lowerCalloutBrush(a) {
            this.bf = a;
            this.e("LowerCalloutBrush");
        }
        get lowerCalloutTextColor() {
            return this.bh;
        }
        set lowerCalloutTextColor(a) {
            this.bh = a;
            this.e("LowerCalloutTextColor");
        }
        get lowerCalloutOutline() {
            return this.bg;
        }
        set lowerCalloutOutline(a) {
            this.bg = a;
            this.e("LowerCalloutOutline");
        }
        get lowerCalloutStrokeThickness() {
            return this.s;
        }
        set lowerCalloutStrokeThickness(a) {
            this.s = a;
            this.e("LowerCalloutStrokeThickness");
        }
        get higherCalloutBrush() {
            return this.a7;
        }
        set higherCalloutBrush(a) {
            this.a7 = a;
            this.e("HigherCalloutBrush");
        }
        get higherCalloutTextColor() {
            return this.a9;
        }
        set higherCalloutTextColor(a) {
            this.a9 = a;
            this.e("HigherCalloutTextColor");
        }
        get higherCalloutOutline() {
            return this.a8;
        }
        set higherCalloutOutline(a) {
            this.a8 = a;
            this.e("HigherCalloutOutline");
        }
        get higherCalloutStrokeThickness() {
            return this.n;
        }
        set higherCalloutStrokeThickness(a) {
            this.n = a;
            this.e("HigherCalloutStrokeThickness");
        }
        get areThumbCalloutsEnabled() {
            return this.h;
        }
        set areThumbCalloutsEnabled(a) {
            this.h = a;
            this.e("AreThumbCalloutsEnabled");
        }
        get thumbCalloutFontFamily() {
            return this.bs;
        }
        set thumbCalloutFontFamily(a) {
            this.bs = a;
            this.e("ThumbCalloutFontFamily");
        }
        get thumbCalloutFontSize() {
            return this.ac;
        }
        set thumbCalloutFontSize(a) {
            this.ac = a;
            this.e("ThumbCalloutFontSize");
        }
        get thumbCalloutFontStyle() {
            return this.bt;
        }
        set thumbCalloutFontStyle(a) {
            this.bt = a;
            this.e("ThumbCalloutFontStyle");
        }
        get thumbCalloutFontWeight() {
            return this.bu;
        }
        set thumbCalloutFontWeight(a) {
            this.bu = a;
            this.e("ThumbCalloutFontWeight");
        }
        get resolvingAxisValueRef() {
            return this.br;
        }
        set resolvingAxisValueRef(a) {
            this.br = a;
            this.e("ResolvingAxisValueRef");
        }
        get windowRectChangedRef() {
            return this.bw;
        }
        set windowRectChangedRef(a) {
            this.bw = a;
            this.e("WindowRectChangedRef");
        }
    }
    ZoomSliderDescription.$t = /*@__PURE__*/ markType(ZoomSliderDescription, 'ZoomSliderDescription', Description.$);
    return ZoomSliderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderDescriptionMetadata = /*@__PURE__*/ (() => {
    class ZoomSliderDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Navigation.XamZoomSlider");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (ZoomSliderDescriptionMetadata.a == null) {
                ZoomSliderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ZoomSliderDescriptionMetadata.c(a, ZoomSliderDescriptionMetadata.a);
                ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata.d(a);
                RectChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("PanTransitionDuration", "Number:int");
            b.item("MaxZoomWidth", "Number:double");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("WindowRect", "Rect");
            b.item("MinZoomWidth", "Number:double");
            b.item("StartInset", "Number:double");
            b.item("EndInset", "Number:double");
            b.item("TrackStartInset", "Number:double");
            b.item("TrackEndInset", "Number:double");
            b.item("BarExtent", "Number:double");
            b.item("Orientation", "ExportedType:string:ZoomSliderOrientation");
            b.item("Orientation@names", "Horizontal;Vertical");
            b.item("LowerThumbBrush", "Brush");
            b.item("LowerThumbStrokeThickness", "Number:double");
            b.item("HigherThumbStrokeThickness", "Number:double");
            b.item("HigherThumbBrush", "Brush");
            b.item("LowerThumbOutline", "Brush");
            b.item("HigherThumbOutline", "Brush");
            b.item("LowerThumbRidgesBrush", "Brush");
            b.item("HigherThumbRidgesBrush", "Brush");
            b.item("LowerThumbWidth", "Number:double");
            b.item("HigherThumbWidth", "Number:double");
            b.item("LowerThumbHeight", "Number:double");
            b.item("HigherThumbHeight", "Number:double");
            b.item("LowerShadeBrush", "Brush");
            b.item("LowerShadeOutline", "Brush");
            b.item("LowerShadeStrokeThickness", "Number:double");
            b.item("HigherShadeBrush", "Brush");
            b.item("HigherShadeOutline", "Brush");
            b.item("HigherShadeStrokeThickness", "Number:double");
            b.item("BarBrush", "Brush");
            b.item("BarOutline", "Brush");
            b.item("BarStrokeThickness", "Number:double");
            b.item("RangeThumbBrush", "Brush");
            b.item("RangeThumbOutline", "Brush");
            b.item("RangeThumbStrokeThickness", "Number:double");
            b.item("RangeThumbRidgesBrush", "Brush");
            b.item("LowerCalloutBrush", "Brush");
            b.item("LowerCalloutTextColor", "Brush");
            b.item("LowerCalloutOutline", "Brush");
            b.item("LowerCalloutStrokeThickness", "Number:double");
            b.item("HigherCalloutBrush", "Brush");
            b.item("HigherCalloutTextColor", "Brush");
            b.item("HigherCalloutOutline", "Brush");
            b.item("HigherCalloutStrokeThickness", "Number:double");
            b.item("AreThumbCalloutsEnabled", "Boolean");
            b.item("ThumbCalloutFontFamily", "(w:ThumbCalloutFontFamily/FontFamilyTransform,wf:ThumbCalloutFontFamily,web:thumbCalloutTextStyle/FontFamilyTransform)String");
            b.item("ThumbCalloutFontSize", "(w:ThumbCalloutFontSize,wf:ThumbCalloutFontSize,web:thumbCalloutTextStyle/FontSizeTransform)Number:double");
            b.item("ThumbCalloutFontStyle", "(w:ThumbCalloutFontStyle/FontStyleTransform,wf:ThumbCalloutFontFamily/FontStyleTransform,web:thumbCalloutTextStyle/FontStyleTransform)String");
            b.item("ThumbCalloutFontWeight", "(w:ThumbCalloutFontWeight/FontWeightTransform,wf:ThumbCalloutFontFamily/FontWeightTransform,web:thumbCalloutTextStyle/FontWeightTransform)String");
            b.item("ResolvingAxisValueRef", "EventRef::resolvingAxisValue");
            b.item("WindowRectChangedRef", "EventRef::windowRectChanged");
            ZoomSliderDescriptionMetadata.e(a, b);
        }
        static d(a) {
            ZoomSliderDescriptionMetadata.b(a);
            a.q("ZoomSlider", () => new ZoomSliderDescription());
            a.p("ZoomSlider", ZoomSliderDescriptionMetadata.a);
        }
    }
    ZoomSliderDescriptionMetadata.$t = /*@__PURE__*/ markType(ZoomSliderDescriptionMetadata, 'ZoomSliderDescriptionMetadata');
    ZoomSliderDescriptionMetadata.a = null;
    return ZoomSliderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderDescriptionModule = /*@__PURE__*/ (() => {
    class ZoomSliderDescriptionModule extends Base {
        static register(a) {
            ZoomSliderDescriptionMetadata.d(a);
        }
    }
    ZoomSliderDescriptionModule.$t = /*@__PURE__*/ markType(ZoomSliderDescriptionModule, 'ZoomSliderDescriptionModule');
    return ZoomSliderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseButtonEventArgsDescription = /*@__PURE__*/ (() => {
    class LegendMouseButtonEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = false;
            this.h = null;
            this.i = null;
        }
        get_type() {
            return "LegendMouseButtonEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get handled() {
            return this.f;
        }
        set handled(a) {
            this.f = a;
            this.e("Handled");
        }
        get itemRef() {
            return this.h;
        }
        set itemRef(a) {
            this.h = a;
            this.e("ItemRef");
        }
        get legendItemRef() {
            return this.i;
        }
        set legendItemRef(a) {
            this.i = a;
            this.e("LegendItemRef");
        }
    }
    LegendMouseButtonEventArgsDescription.$t = /*@__PURE__*/ markType(LegendMouseButtonEventArgsDescription, 'LegendMouseButtonEventArgsDescription', Description.$);
    return LegendMouseButtonEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseButtonEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendMouseButtonEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LegendMouseButtonEventArgsDescriptionMetadata.a == null) {
                LegendMouseButtonEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendMouseButtonEventArgsDescriptionMetadata.c(a, LegendMouseButtonEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Handled", "Boolean");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("LegendItemRef", "(w:LegendItem,wf:LegendItem)DataRef");
        }
        static d(a) {
            LegendMouseButtonEventArgsDescriptionMetadata.b(a);
            a.q("LegendMouseButtonEventArgs", () => new LegendMouseButtonEventArgsDescription());
            a.p("LegendMouseButtonEventArgs", LegendMouseButtonEventArgsDescriptionMetadata.a);
        }
    }
    LegendMouseButtonEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendMouseButtonEventArgsDescriptionMetadata, 'LegendMouseButtonEventArgsDescriptionMetadata');
    LegendMouseButtonEventArgsDescriptionMetadata.a = null;
    return LegendMouseButtonEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseEventArgsDescription = /*@__PURE__*/ (() => {
    class LegendMouseEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "LegendMouseEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get itemRef() {
            return this.f;
        }
        set itemRef(a) {
            this.f = a;
            this.e("ItemRef");
        }
        get legendItemRef() {
            return this.g;
        }
        set legendItemRef(a) {
            this.g = a;
            this.e("LegendItemRef");
        }
    }
    LegendMouseEventArgsDescription.$t = /*@__PURE__*/ markType(LegendMouseEventArgsDescription, 'LegendMouseEventArgsDescription', Description.$);
    return LegendMouseEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendMouseEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendMouseEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LegendMouseEventArgsDescriptionMetadata.a == null) {
                LegendMouseEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendMouseEventArgsDescriptionMetadata.c(a, LegendMouseEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("LegendItemRef", "(w:LegendItem,wf:LegendItem)DataRef");
        }
        static d(a) {
            LegendMouseEventArgsDescriptionMetadata.b(a);
            a.q("LegendMouseEventArgs", () => new LegendMouseEventArgsDescription());
            a.p("LegendMouseEventArgs", LegendMouseEventArgsDescriptionMetadata.a);
        }
    }
    LegendMouseEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendMouseEventArgsDescriptionMetadata, 'LegendMouseEventArgsDescriptionMetadata');
    LegendMouseEventArgsDescriptionMetadata.a = null;
    return LegendMouseEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendBaseDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (LegendBaseDescriptionMetadata.a == null) {
                LegendBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendBaseDescriptionMetadata.c(a, LegendBaseDescriptionMetadata.a);
                LegendMouseButtonEventArgsDescriptionMetadata.d(a);
                LegendMouseEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("LegendItemMouseLeftButtonDownRef", "EventRef::legendItemMouseLeftButtonDown");
            b.item("LegendItemMouseLeftButtonUpRef", "EventRef::legendItemMouseLeftButtonUp");
            b.item("LegendItemMouseEnterRef", "EventRef::legendItemMouseEnter");
            b.item("LegendItemMouseLeaveRef", "EventRef::legendItemMouseLeave");
            b.item("LegendItemMouseMoveRef", "EventRef::legendItemMouseMove");
            LegendBaseDescriptionMetadata.e(a, b);
        }
        static d(a) {
            LegendBaseDescriptionMetadata.b(a);
            a.p("LegendBase", LegendBaseDescriptionMetadata.a);
        }
    }
    LegendBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendBaseDescriptionMetadata, 'LegendBaseDescriptionMetadata');
    LegendBaseDescriptionMetadata.a = null;
    return LegendBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendBaseDescription = /*@__PURE__*/ (() => {
    class LegendBaseDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.i = null;
            this.j = null;
            this.g = null;
            this.h = null;
            this.k = null;
        }
        get background() {
            return this.f;
        }
        set background(a) {
            this.f = a;
            this.e("Background");
        }
        get_type() {
            return "LegendBase";
        }
        get type() {
            return this.get_type();
        }
        get legendItemMouseLeftButtonDownRef() {
            return this.i;
        }
        set legendItemMouseLeftButtonDownRef(a) {
            this.i = a;
            this.e("LegendItemMouseLeftButtonDownRef");
        }
        get legendItemMouseLeftButtonUpRef() {
            return this.j;
        }
        set legendItemMouseLeftButtonUpRef(a) {
            this.j = a;
            this.e("LegendItemMouseLeftButtonUpRef");
        }
        get legendItemMouseEnterRef() {
            return this.g;
        }
        set legendItemMouseEnterRef(a) {
            this.g = a;
            this.e("LegendItemMouseEnterRef");
        }
        get legendItemMouseLeaveRef() {
            return this.h;
        }
        set legendItemMouseLeaveRef(a) {
            this.h = a;
            this.e("LegendItemMouseLeaveRef");
        }
        get legendItemMouseMoveRef() {
            return this.k;
        }
        set legendItemMouseMoveRef(a) {
            this.k = a;
            this.e("LegendItemMouseMoveRef");
        }
    }
    LegendBaseDescription.$t = /*@__PURE__*/ markType(LegendBaseDescription, 'LegendBaseDescription', Description.$);
    return LegendBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialLegendDescription = /*@__PURE__*/ (() => {
    class FinancialLegendDescription extends LegendBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "FinancialLegend";
        }
    }
    FinancialLegendDescription.$t = /*@__PURE__*/ markType(FinancialLegendDescription, 'FinancialLegendDescription', LegendBaseDescription.$);
    return FinancialLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialLegendDescriptionMetadata extends Base {
        static b(a) {
            if (FinancialLegendDescriptionMetadata.a == null) {
                FinancialLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FinancialLegendDescriptionMetadata.c(a, FinancialLegendDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            LegendBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            FinancialLegendDescriptionMetadata.b(a);
            a.q("FinancialLegend", () => new FinancialLegendDescription());
            a.p("FinancialLegend", FinancialLegendDescriptionMetadata.a);
        }
    }
    FinancialLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialLegendDescriptionMetadata, 'FinancialLegendDescriptionMetadata');
    FinancialLegendDescriptionMetadata.a = null;
    return FinancialLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialLegendDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialLegendDescriptionModule extends Base {
        static register(a) {
            FinancialLegendDescriptionMetadata.d(a);
        }
    }
    FinancialLegendDescriptionModule.$t = /*@__PURE__*/ markType(FinancialLegendDescriptionModule, 'FinancialLegendDescriptionModule');
    return FinancialLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDescriptionModule = /*@__PURE__*/ (() => {
    class FinancialChartDescriptionModule extends Base {
        static register(a) {
            FinancialChartCoreDescriptionModule.register(a);
            LineSeriesDescriptionModule.register(a);
            AreaSeriesDescriptionModule.register(a);
            ColumnSeriesDescriptionModule.register(a);
            NumericYAxisDescriptionModule.register(a);
            TimeXAxisDescriptionModule.register(a);
            TimeAxisBreakDescriptionModule.register(a);
            TimeAxisIntervalDescriptionModule.register(a);
            TimeAxisLabelFormatDescriptionModule.register(a);
            CategoryXAxisDescriptionModule.register(a);
            OrdinalTimeXAxisDescriptionModule.register(a);
            PercentChangeYAxisDescriptionModule.register(a);
            FinancialPriceSeriesDescriptionModule.register(a);
            DataChartCategoryTrendLineDescriptionModule.register(a);
            IndicatorsDescriptionModule.register(a);
            OverlaysDescriptionModule.register(a);
            ZoomSliderDescriptionModule.register(a);
            CrosshairLayerDescriptionModule.register(a);
            CalloutLayerDescriptionModule.register(a);
            ItemToolTipLayerDescriptionModule.register(a);
            CategoryToolTipLayerDescriptionModule.register(a);
            CategoryHighlightLayerDescriptionModule.register(a);
            CategoryItemHighlightLayerDescriptionModule.register(a);
            FinalValueLayerDescriptionModule.register(a);
            NumberAbbreviatorDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
            DataChartAnnotationDescriptionModule.register(a);
            FinancialLegendDescriptionModule.register(a);
        }
    }
    FinancialChartDescriptionModule.$t = /*@__PURE__*/ markType(FinancialChartDescriptionModule, 'FinancialChartDescriptionModule');
    return FinancialChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatSpecifierDescriptionModule = /*@__PURE__*/ (() => {
    class FormatSpecifierDescriptionModule extends Base {
        static register(a) {
            FormatSpecifierDescriptionMetadata.d(a);
        }
    }
    FormatSpecifierDescriptionModule.$t = /*@__PURE__*/ markType(FormatSpecifierDescriptionModule, 'FormatSpecifierDescriptionModule');
    return FormatSpecifierDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapSeriesHostDescription = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHostDescription extends SeriesDescription {
        constructor() {
            super();
            this.co = 0;
            this.cq = null;
        }
        get_type() {
            return "GeographicMapSeriesHost";
        }
        get visibleFromScale() {
            return this.co;
        }
        set visibleFromScale(a) {
            this.co = a;
            this.e("VisibleFromScale");
        }
        get coercionMethodsRef() {
            return this.cq;
        }
        set coercionMethodsRef(a) {
            this.cq = a;
            this.e("CoercionMethodsRef");
        }
    }
    GeographicMapSeriesHostDescription.$t = /*@__PURE__*/ markType(GeographicMapSeriesHostDescription, 'GeographicMapSeriesHostDescription', SeriesDescription.$);
    return GeographicMapSeriesHostDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
            this.ct = null;
            this.cs = null;
            this.cu = null;
            this.cv = null;
            this.cw = null;
            this.cx = null;
        }
        get_type() {
            return "GeographicXYTriangulatingSeries";
        }
        get longitudeMemberPath() {
            return this.ct;
        }
        set longitudeMemberPath(a) {
            this.ct = a;
            this.e("LongitudeMemberPath");
        }
        get latitudeMemberPath() {
            return this.cs;
        }
        set latitudeMemberPath(a) {
            this.cs = a;
            this.e("LatitudeMemberPath");
        }
        get trianglesSourceRef() {
            return this.cu;
        }
        set trianglesSourceRef(a) {
            this.cu = a;
            this.e("TrianglesSourceRef");
        }
        get triangleVertexMemberPath1() {
            return this.cv;
        }
        set triangleVertexMemberPath1(a) {
            this.cv = a;
            this.e("TriangleVertexMemberPath1");
        }
        get triangleVertexMemberPath2() {
            return this.cw;
        }
        set triangleVertexMemberPath2(a) {
            this.cw = a;
            this.e("TriangleVertexMemberPath2");
        }
        get triangleVertexMemberPath3() {
            return this.cx;
        }
        set triangleVertexMemberPath3(a) {
            this.cx = a;
            this.e("TriangleVertexMemberPath3");
        }
    }
    GeographicXYTriangulatingSeriesDescription.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesDescription, 'GeographicXYTriangulatingSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicXYTriangulatingSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicContourLineSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesDescription extends GeographicXYTriangulatingSeriesDescription {
        constructor() {
            super();
            this.c9 = null;
            this.c6 = null;
            this.c4 = null;
            this.c8 = null;
        }
        get_type() {
            return "GeographicContourLineSeries";
        }
        get valueMemberPath() {
            return this.c9;
        }
        set valueMemberPath(a) {
            this.c9 = a;
            this.e("ValueMemberPath");
        }
        get fillScale() {
            return this.c6;
        }
        set fillScale(a) {
            this.c6 = a;
            this.e("FillScale");
        }
        get valueResolver() {
            return this.c4;
        }
        set valueResolver(a) {
            this.c4 = a;
            this.e("ValueResolver");
        }
        get triangulationStatusChangedRef() {
            return this.c8;
        }
        set triangulationStatusChangedRef(a) {
            this.c8 = a;
            this.e("TriangulationStatusChangedRef");
        }
    }
    GeographicContourLineSeriesDescription.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesDescription, 'GeographicContourLineSeriesDescription', GeographicXYTriangulatingSeriesDescription.$);
    return GeographicContourLineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapSeriesHostDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHostDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicMapSeriesHostDescriptionMetadata.a == null) {
                GeographicMapSeriesHostDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicMapSeriesHostDescriptionMetadata.c(a, GeographicMapSeriesHostDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("VisibleFromScale", "Number:double");
            b.item("CoercionMethodsRef", "(w:CoercionMethods,wf:CoercionMethods)DataRef");
        }
        static d(a) {
            GeographicMapSeriesHostDescriptionMetadata.b(a);
            a.p("GeographicMapSeriesHost", GeographicMapSeriesHostDescriptionMetadata.a);
        }
    }
    GeographicMapSeriesHostDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicMapSeriesHostDescriptionMetadata, 'GeographicMapSeriesHostDescriptionMetadata');
    GeographicMapSeriesHostDescriptionMetadata.a = null;
    return GeographicMapSeriesHostDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicXYTriangulatingSeriesDescriptionMetadata.a == null) {
                GeographicXYTriangulatingSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicXYTriangulatingSeriesDescriptionMetadata.c(a, GeographicXYTriangulatingSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
            b.item("LongitudeMemberPath", "String");
            b.item("LatitudeMemberPath", "String");
            b.item("TrianglesSourceRef", "(w:TrianglesSource,wf:TrianglesSource)DataRef::object");
            b.item("TriangleVertexMemberPath1", "String");
            b.item("TriangleVertexMemberPath2", "String");
            b.item("TriangleVertexMemberPath3", "String");
        }
        static d(a) {
            GeographicXYTriangulatingSeriesDescriptionMetadata.b(a);
            a.p("GeographicXYTriangulatingSeries", GeographicXYTriangulatingSeriesDescriptionMetadata.a);
        }
    }
    GeographicXYTriangulatingSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesDescriptionMetadata, 'GeographicXYTriangulatingSeriesDescriptionMetadata');
    GeographicXYTriangulatingSeriesDescriptionMetadata.a = null;
    return GeographicXYTriangulatingSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicContourLineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicContourLineSeriesDescriptionMetadata.a == null) {
                GeographicContourLineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicContourLineSeriesDescriptionMetadata.c(a, GeographicContourLineSeriesDescriptionMetadata.a);
                ValueBrushScaleDescriptionMetadata.d(a);
                ContourValueResolverDescriptionMetadata.d(a);
                TriangulationStatusEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicXYTriangulatingSeriesDescriptionMetadata.c(a, b);
            b.item("ValueMemberPath", "String");
            b.item("FillScale", "ExportedType:ValueBrushScale");
            b.item("ValueResolver", "ExportedType:ContourValueResolver");
            b.item("TriangulationStatusChangedRef", "EventRef::triangulationStatusChanged");
        }
        static d(a) {
            GeographicContourLineSeriesDescriptionMetadata.b(a);
            a.q("GeographicContourLineSeries", () => new GeographicContourLineSeriesDescription());
            a.p("GeographicContourLineSeries", GeographicContourLineSeriesDescriptionMetadata.a);
        }
    }
    GeographicContourLineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesDescriptionMetadata, 'GeographicContourLineSeriesDescriptionMetadata');
    GeographicContourLineSeriesDescriptionMetadata.a = null;
    return GeographicContourLineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicContourLineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicContourLineSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicContourLineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesDescriptionModule, 'GeographicContourLineSeriesDescriptionModule');
    return GeographicContourLineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicHighDensityScatterSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
            this.c6 = null;
            this.c7 = null;
            this.ct = false;
            this.cs = false;
            this.cx = 0;
            this.cw = 0;
            this.c5 = null;
            this.c4 = null;
            this.c0 = 0;
            this.c1 = 0;
            this.c8 = null;
        }
        get_type() {
            return "GeographicHighDensityScatterSeries";
        }
        get latitudeMemberPath() {
            return this.c6;
        }
        set latitudeMemberPath(a) {
            this.c6 = a;
            this.e("LatitudeMemberPath");
        }
        get longitudeMemberPath() {
            return this.c7;
        }
        set longitudeMemberPath(a) {
            this.c7 = a;
            this.e("LongitudeMemberPath");
        }
        get useBruteForce() {
            return this.ct;
        }
        set useBruteForce(a) {
            this.ct = a;
            this.e("UseBruteForce");
        }
        get progressiveLoad() {
            return this.cs;
        }
        set progressiveLoad(a) {
            this.cs = a;
            this.e("ProgressiveLoad");
        }
        get heatMinimum() {
            return this.cx;
        }
        set heatMinimum(a) {
            this.cx = a;
            this.e("HeatMinimum");
        }
        get heatMaximum() {
            return this.cw;
        }
        set heatMaximum(a) {
            this.cw = a;
            this.e("HeatMaximum");
        }
        get heatMinimumColor() {
            return this.c5;
        }
        set heatMinimumColor(a) {
            this.c5 = a;
            this.e("HeatMinimumColor");
        }
        get heatMaximumColor() {
            return this.c4;
        }
        set heatMaximumColor(a) {
            this.c4 = a;
            this.e("HeatMaximumColor");
        }
        get pointExtent() {
            return this.c0;
        }
        set pointExtent(a) {
            this.c0 = a;
            this.e("PointExtent");
        }
        get progressiveStatus() {
            return this.c1;
        }
        set progressiveStatus(a) {
            this.c1 = a;
            this.e("ProgressiveStatus");
        }
        get progressiveLoadStatusChangedRef() {
            return this.c8;
        }
        set progressiveLoadStatusChangedRef(a) {
            this.c8 = a;
            this.e("ProgressiveLoadStatusChangedRef");
        }
    }
    GeographicHighDensityScatterSeriesDescription.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesDescription, 'GeographicHighDensityScatterSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicHighDensityScatterSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicHighDensityScatterSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicHighDensityScatterSeriesDescriptionMetadata.a == null) {
                GeographicHighDensityScatterSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicHighDensityScatterSeriesDescriptionMetadata.c(a, GeographicHighDensityScatterSeriesDescriptionMetadata.a);
                ProgressiveLoadStatusEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
            b.item("LatitudeMemberPath", "String");
            b.item("LongitudeMemberPath", "String");
            b.item("UseBruteForce", "Boolean");
            b.item("ProgressiveLoad", "Boolean");
            b.item("HeatMinimum", "Number:double");
            b.item("HeatMaximum", "Number:double");
            b.item("HeatMinimumColor", "Color");
            b.item("HeatMaximumColor", "Color");
            b.item("PointExtent", "Number:int");
            b.item("ProgressiveStatus", "Number:int");
            b.item("ProgressiveLoadStatusChangedRef", "EventRef::progressiveLoadStatusChanged");
        }
        static d(a) {
            GeographicHighDensityScatterSeriesDescriptionMetadata.b(a);
            a.q("GeographicHighDensityScatterSeries", () => new GeographicHighDensityScatterSeriesDescription());
            a.p("GeographicHighDensityScatterSeries", GeographicHighDensityScatterSeriesDescriptionMetadata.a);
        }
    }
    GeographicHighDensityScatterSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesDescriptionMetadata, 'GeographicHighDensityScatterSeriesDescriptionMetadata');
    GeographicHighDensityScatterSeriesDescriptionMetadata.a = null;
    return GeographicHighDensityScatterSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicHighDensityScatterSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicHighDensityScatterSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicHighDensityScatterSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesDescriptionModule, 'GeographicHighDensityScatterSeriesDescriptionModule');
    return GeographicHighDensityScatterSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapImageryDescription = /*@__PURE__*/ (() => {
    class OpenStreetMapImageryDescription extends GeographicMapImageryDescription {
        constructor() {
            super();
            this.aa = null;
        }
        get_type() {
            return "OpenStreetMapImagery";
        }
        get tilePath() {
            return this.aa;
        }
        set tilePath(a) {
            this.aa = a;
            this.e("TilePath");
        }
    }
    OpenStreetMapImageryDescription.$t = /*@__PURE__*/ markType(OpenStreetMapImageryDescription, 'OpenStreetMapImageryDescription', GeographicMapImageryDescription.$);
    return OpenStreetMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class OpenStreetMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (OpenStreetMapImageryDescriptionMetadata.a == null) {
                OpenStreetMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OpenStreetMapImageryDescriptionMetadata.c(a, OpenStreetMapImageryDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapImageryDescriptionMetadata.c(a, b);
            b.item("TilePath", "String");
        }
        static d(a) {
            OpenStreetMapImageryDescriptionMetadata.b(a);
            a.q("OpenStreetMapImagery", () => new OpenStreetMapImageryDescription());
            a.p("OpenStreetMapImagery", OpenStreetMapImageryDescriptionMetadata.a);
        }
    }
    OpenStreetMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(OpenStreetMapImageryDescriptionMetadata, 'OpenStreetMapImageryDescriptionMetadata');
    OpenStreetMapImageryDescriptionMetadata.a = null;
    return OpenStreetMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class OpenStreetMapImageryDescriptionModule extends Base {
        static register(a) {
            OpenStreetMapImageryDescriptionMetadata.d(a);
        }
    }
    OpenStreetMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(OpenStreetMapImageryDescriptionModule, 'OpenStreetMapImageryDescriptionModule');
    return OpenStreetMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapCoreDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicMapCoreDescriptionModule extends Base {
        static register(a) {
            BingMapsMapImageryDescriptionModule.register(a);
            OpenStreetMapImageryDescriptionModule.register(a);
            CustomMapImageryDescriptionModule.register(a);
            ArcGISOnlineMapImageryDescriptionModule.register(a);
            GeographicMapDescriptionMetadata.d(a);
        }
    }
    GeographicMapCoreDescriptionModule.$t = /*@__PURE__*/ markType(GeographicMapCoreDescriptionModule, 'GeographicMapCoreDescriptionModule');
    return GeographicMapCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileRecordDescription = /*@__PURE__*/ (() => {
    class ShapefileRecordDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.f = null;
        }
        get_type() {
            return "ShapefileRecord";
        }
        get type() {
            return this.get_type();
        }
        get fieldValuesRef() {
            return this.h;
        }
        set fieldValuesRef(a) {
            this.h = a;
            this.e("FieldValuesRef");
        }
        get bounds() {
            return this.f;
        }
        set bounds(a) {
            this.f = a;
            this.e("Bounds");
        }
    }
    ShapefileRecordDescription.$t = /*@__PURE__*/ markType(ShapefileRecordDescription, 'ShapefileRecordDescription', Description.$);
    return ShapefileRecordDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileRecordDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapefileRecordDescriptionMetadata extends Base {
        static b(a) {
            if (ShapefileRecordDescriptionMetadata.a == null) {
                ShapefileRecordDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapefileRecordDescriptionMetadata.c(a, ShapefileRecordDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("FieldValuesRef", "(w:FieldValues,wf:FieldValues)DataRef");
            b.item("Bounds", "Rect");
        }
        static d(a) {
            ShapefileRecordDescriptionMetadata.b(a);
            a.q("ShapefileRecord", () => new ShapefileRecordDescription());
            a.p("ShapefileRecord", ShapefileRecordDescriptionMetadata.a);
        }
    }
    ShapefileRecordDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapefileRecordDescriptionMetadata, 'ShapefileRecordDescriptionMetadata');
    ShapefileRecordDescriptionMetadata.a = null;
    return ShapefileRecordDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFilterRecordEventArgsDescription = /*@__PURE__*/ (() => {
    class ShapeFilterRecordEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = false;
        }
        get_type() {
            return "ShapeFilterRecordEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get record() {
            return this.f;
        }
        set record(a) {
            this.f = a;
            this.e("Record");
        }
        get shouldInclude() {
            return this.h;
        }
        set shouldInclude(a) {
            this.h = a;
            this.e("ShouldInclude");
        }
    }
    ShapeFilterRecordEventArgsDescription.$t = /*@__PURE__*/ markType(ShapeFilterRecordEventArgsDescription, 'ShapeFilterRecordEventArgsDescription', Description.$);
    return ShapeFilterRecordEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFilterRecordEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapeFilterRecordEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ShapeFilterRecordEventArgsDescriptionMetadata.a == null) {
                ShapeFilterRecordEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapeFilterRecordEventArgsDescriptionMetadata.c(a, ShapeFilterRecordEventArgsDescriptionMetadata.a);
                ShapefileRecordDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Record", "ExportedType:ShapefileRecord");
            b.item("ShouldInclude", "Boolean");
        }
        static d(a) {
            ShapeFilterRecordEventArgsDescriptionMetadata.b(a);
            a.q("ShapeFilterRecordEventArgs", () => new ShapeFilterRecordEventArgsDescription());
            a.p("ShapeFilterRecordEventArgs", ShapeFilterRecordEventArgsDescriptionMetadata.a);
        }
    }
    ShapeFilterRecordEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapeFilterRecordEventArgsDescriptionMetadata, 'ShapeFilterRecordEventArgsDescriptionMetadata');
    ShapeFilterRecordEventArgsDescriptionMetadata.a = null;
    return ShapeFilterRecordEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeDataSourceDescription = /*@__PURE__*/ (() => {
    class ShapeDataSourceDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
            this.j = false;
            this.p = null;
            this.l = null;
            this.o = null;
            this.n = null;
            this.m = null;
        }
        get_type() {
            return "ShapeDataSource";
        }
        get type() {
            return this.get_type();
        }
        get worldRect() {
            return this.g;
        }
        set worldRect(a) {
            this.g = a;
            this.e("WorldRect");
        }
        get computedWorldRect() {
            return this.f;
        }
        set computedWorldRect(a) {
            this.f = a;
            this.e("ComputedWorldRect");
        }
        get deferImportCompleted() {
            return this.j;
        }
        set deferImportCompleted(a) {
            this.j = a;
            this.e("DeferImportCompleted");
        }
        get shapefileSource() {
            return this.p;
        }
        set shapefileSource(a) {
            this.p = a;
            this.e("ShapefileSource");
        }
        get databaseSource() {
            return this.l;
        }
        set databaseSource(a) {
            this.l = a;
            this.e("DatabaseSource");
        }
        get importPendingRef() {
            return this.o;
        }
        set importPendingRef(a) {
            this.o = a;
            this.e("ImportPendingRef");
        }
        get importCompletedRef() {
            return this.n;
        }
        set importCompletedRef(a) {
            this.n = a;
            this.e("ImportCompletedRef");
        }
        get filterRef() {
            return this.m;
        }
        set filterRef(a) {
            this.m = a;
            this.e("FilterRef");
        }
    }
    ShapeDataSourceDescription.$t = /*@__PURE__*/ markType(ShapeDataSourceDescription, 'ShapeDataSourceDescription', Description.$);
    return ShapeDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class ShapeDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (ShapeDataSourceDescriptionMetadata.a == null) {
                ShapeDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ShapeDataSourceDescriptionMetadata.c(a, ShapeDataSourceDescriptionMetadata.a);
                AsyncCompletedEventArgsDescriptionMetadata.d(a);
                ShapeFilterRecordEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("WorldRect", "Rect");
            b.item("ComputedWorldRect", "Rect");
            b.item("DeferImportCompleted", "Boolean");
            b.item("ShapefileSource", "String");
            b.item("DatabaseSource", "String");
            b.item("ImportPendingRef", "EventRef::importPending");
            b.item("ImportCompletedRef", "EventRef::importCompleted");
            b.item("FilterRef", "EventRef::filter");
        }
        static d(a) {
            ShapeDataSourceDescriptionMetadata.b(a);
            a.q("ShapeDataSource", () => new ShapeDataSourceDescription());
            a.p("ShapeDataSource", ShapeDataSourceDescriptionMetadata.a);
        }
    }
    ShapeDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(ShapeDataSourceDescriptionMetadata, 'ShapeDataSourceDescriptionMetadata');
    ShapeDataSourceDescriptionMetadata.a = null;
    return ShapeDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicShapeSeriesBaseDescriptionMetadata.a == null) {
                GeographicShapeSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicShapeSeriesBaseDescriptionMetadata.c(a, GeographicShapeSeriesBaseDescriptionMetadata.a);
                ShapeDataSourceDescriptionMetadata.d(a);
                AssigningShapeStyleEventArgsDescriptionMetadata.d(a);
                AssigningShapeMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
            b.item("ShapeMemberPath", "String");
            b.item("IsCustomShapeStyleAllowed", "Boolean");
            b.item("IsCustomShapeMarkerStyleAllowed", "Boolean");
            b.item("ItemSearchMode", "ExportedType:string:ShapeItemSearchMode");
            b.item("ItemSearchMode@names", "Auto;ClosestBoundingBox;ClosestShape;ClosestPointOnClosestShape;None");
            b.item("ItemSearchThreshold", "Number:int");
            b.item("ItemSearchPointsThreshold", "Number:int");
            b.item("ShapefileDataSource", "ExportedType:ShapefileConverter");
            b.item("ShapeFilterResolution", "Number:double");
            b.item("AssigningShapeStyleRef", "EventRef::assigningShapeStyle");
            b.item("AssigningShapeMarkerStyleRef", "EventRef::assigningShapeMarkerStyle");
        }
        static d(a) {
            GeographicShapeSeriesBaseDescriptionMetadata.b(a);
            a.p("GeographicShapeSeriesBase", GeographicShapeSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicShapeSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseDescriptionMetadata, 'GeographicShapeSeriesBaseDescriptionMetadata');
    GeographicShapeSeriesBaseDescriptionMetadata.a = null;
    return GeographicShapeSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
            this.c7 = null;
            this.cv = false;
            this.cu = false;
            this.c6 = null;
            this.c1 = 0;
            this.c0 = 0;
            this.cs = null;
            this.cy = 0;
            this.c5 = null;
            this.c4 = null;
        }
        get_type() {
            return "GeographicShapeSeriesBase";
        }
        get shapeMemberPath() {
            return this.c7;
        }
        set shapeMemberPath(a) {
            this.c7 = a;
            this.e("ShapeMemberPath");
        }
        get isCustomShapeStyleAllowed() {
            return this.cv;
        }
        set isCustomShapeStyleAllowed(a) {
            this.cv = a;
            this.e("IsCustomShapeStyleAllowed");
        }
        get isCustomShapeMarkerStyleAllowed() {
            return this.cu;
        }
        set isCustomShapeMarkerStyleAllowed(a) {
            this.cu = a;
            this.e("IsCustomShapeMarkerStyleAllowed");
        }
        get itemSearchMode() {
            return this.c6;
        }
        set itemSearchMode(a) {
            this.c6 = a;
            this.e("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.c1;
        }
        set itemSearchThreshold(a) {
            this.c1 = a;
            this.e("ItemSearchThreshold");
        }
        get itemSearchPointsThreshold() {
            return this.c0;
        }
        set itemSearchPointsThreshold(a) {
            this.c0 = a;
            this.e("ItemSearchPointsThreshold");
        }
        get shapefileDataSource() {
            return this.cs;
        }
        set shapefileDataSource(a) {
            this.cs = a;
            this.e("ShapefileDataSource");
        }
        get shapeFilterResolution() {
            return this.cy;
        }
        set shapeFilterResolution(a) {
            this.cy = a;
            this.e("ShapeFilterResolution");
        }
        get assigningShapeStyleRef() {
            return this.c5;
        }
        set assigningShapeStyleRef(a) {
            this.c5 = a;
            this.e("AssigningShapeStyleRef");
        }
        get assigningShapeMarkerStyleRef() {
            return this.c4;
        }
        set assigningShapeMarkerStyleRef(a) {
            this.c4 = a;
            this.e("AssigningShapeMarkerStyleRef");
        }
    }
    GeographicShapeSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseDescription, 'GeographicShapeSeriesBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicShapeSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesDescription extends GeographicShapeSeriesBaseDescription {
        constructor() {
            super();
            this.ds = null;
            this.dq = null;
            this.dr = null;
            this.de = 0;
            this.dd = 0;
            this.dp = null;
            this.dm = null;
            this.dk = null;
            this.dn = null;
            this.di = null;
            this.dl = null;
            this.dc = 0;
            this.dj = null;
            this.dt = null;
        }
        get_type() {
            return "GeographicShapeSeries";
        }
        get shapeStyleSelectorRef() {
            return this.ds;
        }
        set shapeStyleSelectorRef(a) {
            this.ds = a;
            this.e("ShapeStyleSelectorRef");
        }
        get shapeFill() {
            return this.dq;
        }
        set shapeFill(a) {
            this.dq = a;
            this.e("ShapeFill");
        }
        get shapeStroke() {
            return this.dr;
        }
        set shapeStroke(a) {
            this.dr = a;
            this.e("ShapeStroke");
        }
        get shapeStrokeThickness() {
            return this.de;
        }
        set shapeStrokeThickness(a) {
            this.de = a;
            this.e("ShapeStrokeThickness");
        }
        get shapeOpacity() {
            return this.dd;
        }
        set shapeOpacity(a) {
            this.dd = a;
            this.e("ShapeOpacity");
        }
        get markerType() {
            return this.dp;
        }
        set markerType(a) {
            this.dp = a;
            this.e("MarkerType");
        }
        get markerOutlineMode() {
            return this.dm;
        }
        set markerOutlineMode(a) {
            this.dm = a;
            this.e("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.dk;
        }
        set markerFillMode(a) {
            this.dk = a;
            this.e("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.dn;
        }
        set markerTemplateRef(a) {
            this.dn = a;
            this.e("MarkerTemplateRef");
        }
        get markerBrush() {
            return this.di;
        }
        set markerBrush(a) {
            this.di = a;
            this.e("MarkerBrush");
        }
        get markerOutline() {
            return this.dl;
        }
        set markerOutline(a) {
            this.dl = a;
            this.e("MarkerOutline");
        }
        get markerThickness() {
            return this.dc;
        }
        set markerThickness(a) {
            this.dc = a;
            this.e("MarkerThickness");
        }
        get markerCollisionAvoidance() {
            return this.dj;
        }
        set markerCollisionAvoidance(a) {
            this.dj = a;
            this.e("MarkerCollisionAvoidance");
        }
        get styleShapeRef() {
            return this.dt;
        }
        set styleShapeRef(a) {
            this.dt = a;
            this.e("StyleShapeRef");
        }
    }
    GeographicShapeSeriesDescription.$t = /*@__PURE__*/ markType(GeographicShapeSeriesDescription, 'GeographicShapeSeriesDescription', GeographicShapeSeriesBaseDescription.$);
    return GeographicShapeSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicShapeSeriesDescriptionMetadata.a == null) {
                GeographicShapeSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicShapeSeriesDescriptionMetadata.c(a, GeographicShapeSeriesDescriptionMetadata.a);
                StyleShapeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicShapeSeriesBaseDescriptionMetadata.c(a, b);
            b.item("ShapeStyleSelectorRef", "(w:ShapeStyleSelector,wf:ShapeStyleSelector)DataRef::object");
            b.item("ShapeFill", "(w:ShapeStyle.Fill,wf:ShapeFill)String");
            b.item("ShapeStroke", "(w:ShapeStyle.Stroke,wf:ShapeStroke)String");
            b.item("ShapeStrokeThickness", "(w:ShapeStyle.StrokeThickness,wf:ShapeStrokeThickness)Number:double");
            b.item("ShapeOpacity", "(w:ShapeStyle.Opacity,wf:ShapeOpacity)Number:double");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            b.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            b.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            b.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("MarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("MarkerThickness", "Number:double");
            b.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            b.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            b.item("StyleShapeRef", "EventRef::styleShape");
        }
        static d(a) {
            GeographicShapeSeriesDescriptionMetadata.b(a);
            a.q("GeographicShapeSeries", () => new GeographicShapeSeriesDescription());
            a.p("GeographicShapeSeries", GeographicShapeSeriesDescriptionMetadata.a);
        }
    }
    GeographicShapeSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicShapeSeriesDescriptionMetadata, 'GeographicShapeSeriesDescriptionMetadata');
    GeographicShapeSeriesDescriptionMetadata.a = null;
    return GeographicShapeSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicShapeSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicShapeSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicShapeSeriesDescriptionModule, 'GeographicShapeSeriesDescriptionModule');
    return GeographicShapeSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicPolylineSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicPolylineSeriesDescription extends GeographicShapeSeriesBaseDescription {
        constructor() {
            super();
            this.di = null;
            this.dg = null;
            this.dh = null;
            this.dd = 0;
            this.dc = 0;
            this.dj = null;
        }
        get_type() {
            return "GeographicPolylineSeries";
        }
        get shapeStyleSelectorRef() {
            return this.di;
        }
        set shapeStyleSelectorRef(a) {
            this.di = a;
            this.e("ShapeStyleSelectorRef");
        }
        get shapeFill() {
            return this.dg;
        }
        set shapeFill(a) {
            this.dg = a;
            this.e("ShapeFill");
        }
        get shapeStroke() {
            return this.dh;
        }
        set shapeStroke(a) {
            this.dh = a;
            this.e("ShapeStroke");
        }
        get shapeStrokeThickness() {
            return this.dd;
        }
        set shapeStrokeThickness(a) {
            this.dd = a;
            this.e("ShapeStrokeThickness");
        }
        get shapeOpacity() {
            return this.dc;
        }
        set shapeOpacity(a) {
            this.dc = a;
            this.e("ShapeOpacity");
        }
        get styleShapeRef() {
            return this.dj;
        }
        set styleShapeRef(a) {
            this.dj = a;
            this.e("StyleShapeRef");
        }
    }
    GeographicPolylineSeriesDescription.$t = /*@__PURE__*/ markType(GeographicPolylineSeriesDescription, 'GeographicPolylineSeriesDescription', GeographicShapeSeriesBaseDescription.$);
    return GeographicPolylineSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicPolylineSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicPolylineSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicPolylineSeriesDescriptionMetadata.a == null) {
                GeographicPolylineSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicPolylineSeriesDescriptionMetadata.c(a, GeographicPolylineSeriesDescriptionMetadata.a);
                StyleShapeEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicShapeSeriesBaseDescriptionMetadata.c(a, b);
            b.item("ShapeStyleSelectorRef", "(w:ShapeStyleSelector,wf:ShapeStyleSelector)DataRef::object");
            b.item("ShapeFill", "(w:ShapeStyle.Fill,wf:ShapeFill)String");
            b.item("ShapeStroke", "(w:ShapeStyle.Stroke,wf:ShapeStroke)String");
            b.item("ShapeStrokeThickness", "(w:ShapeStyle.StrokeThickness,wf:ShapeStrokeThickness)Number:double");
            b.item("ShapeOpacity", "(w:ShapeStyle.Opacity,wf:ShapeOpacity)Number:double");
            b.item("StyleShapeRef", "EventRef::styleShape");
        }
        static d(a) {
            GeographicPolylineSeriesDescriptionMetadata.b(a);
            a.q("GeographicPolylineSeries", () => new GeographicPolylineSeriesDescription());
            a.p("GeographicPolylineSeries", GeographicPolylineSeriesDescriptionMetadata.a);
        }
    }
    GeographicPolylineSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicPolylineSeriesDescriptionMetadata, 'GeographicPolylineSeriesDescriptionMetadata');
    GeographicPolylineSeriesDescriptionMetadata.a = null;
    return GeographicPolylineSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicPolylineSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicPolylineSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicPolylineSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicPolylineSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicPolylineSeriesDescriptionModule, 'GeographicPolylineSeriesDescriptionModule');
    return GeographicPolylineSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorMapImageryDescription = /*@__PURE__*/ (() => {
    class TileGeneratorMapImageryDescription extends GeographicMapImageryDescription {
        constructor() {
            super();
            this.aa = null;
        }
        get_type() {
            return "TileGeneratorMapImagery";
        }
        get tileGenerator() {
            return this.aa;
        }
        set tileGenerator(a) {
            this.aa = a;
            this.e("TileGenerator");
        }
    }
    TileGeneratorMapImageryDescription.$t = /*@__PURE__*/ markType(TileGeneratorMapImageryDescription, 'TileGeneratorMapImageryDescription', GeographicMapImageryDescription.$);
    return TileGeneratorMapImageryDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorMapImageryDescriptionMetadata = /*@__PURE__*/ (() => {
    class TileGeneratorMapImageryDescriptionMetadata extends Base {
        static b(a) {
            if (TileGeneratorMapImageryDescriptionMetadata.a == null) {
                TileGeneratorMapImageryDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TileGeneratorMapImageryDescriptionMetadata.c(a, TileGeneratorMapImageryDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapImageryDescriptionMetadata.c(a, b);
            b.item("TileGenerator", "ExportedType");
        }
        static d(a) {
            TileGeneratorMapImageryDescriptionMetadata.b(a);
            a.q("TileGeneratorMapImagery", () => new TileGeneratorMapImageryDescription());
            a.p("TileGeneratorMapImagery", TileGeneratorMapImageryDescriptionMetadata.a);
        }
    }
    TileGeneratorMapImageryDescriptionMetadata.$t = /*@__PURE__*/ markType(TileGeneratorMapImageryDescriptionMetadata, 'TileGeneratorMapImageryDescriptionMetadata');
    TileGeneratorMapImageryDescriptionMetadata.a = null;
    return TileGeneratorMapImageryDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorMapImageryDescriptionModule = /*@__PURE__*/ (() => {
    class TileGeneratorMapImageryDescriptionModule extends Base {
        static register(a) {
            TileGeneratorMapImageryDescriptionMetadata.d(a);
        }
    }
    TileGeneratorMapImageryDescriptionModule.$t = /*@__PURE__*/ markType(TileGeneratorMapImageryDescriptionModule, 'TileGeneratorMapImageryDescriptionModule');
    return TileGeneratorMapImageryDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorDescription = /*@__PURE__*/ (() => {
    class TileGeneratorDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "TileGenerator";
        }
        get type() {
            return this.get_type();
        }
    }
    TileGeneratorDescription.$t = /*@__PURE__*/ markType(TileGeneratorDescription, 'TileGeneratorDescription', Description.$);
    return TileGeneratorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorDescription = /*@__PURE__*/ (() => {
    class HeatTileGeneratorDescription extends TileGeneratorDescription {
        constructor() {
            super();
            this.k = null;
            this.j = null;
            this.i = null;
            this.al = null;
            this.ak = null;
            this.h = null;
            this.g = null;
            this.aa = 0;
            this.ac = 0;
            this.q = false;
            this.r = false;
            this.s = false;
            this.ae = 0;
            this.ad = 0;
            this.ab = 0;
            this.t = false;
            this.u = false;
            this.an = null;
            this.am = null;
        }
        get_type() {
            return "HeatTileGenerator";
        }
        get type() {
            return this.get_type();
        }
        get yValues() {
            return this.k;
        }
        set yValues(a) {
            this.k = a;
            this.e("YValues");
        }
        get xValues() {
            return this.j;
        }
        set xValues(a) {
            this.j = a;
            this.e("XValues");
        }
        get values() {
            return this.i;
        }
        set values(a) {
            this.i = a;
            this.e("Values");
        }
        get minimumColor() {
            return this.al;
        }
        set minimumColor(a) {
            this.al = a;
            this.e("MinimumColor");
        }
        get maximumColor() {
            return this.ak;
        }
        set maximumColor(a) {
            this.ak = a;
            this.e("MaximumColor");
        }
        get scaleColors() {
            return this.h;
        }
        set scaleColors(a) {
            this.h = a;
            this.e("ScaleColors");
        }
        get scaleColorOffsets() {
            return this.g;
        }
        set scaleColorOffsets(a) {
            this.g = a;
            this.e("ScaleColorOffsets");
        }
        get blurRadius() {
            return this.aa;
        }
        set blurRadius(a) {
            this.aa = a;
            this.e("BlurRadius");
        }
        get maxBlurRadius() {
            return this.ac;
        }
        set maxBlurRadius(a) {
            this.ac = a;
            this.e("MaxBlurRadius");
        }
        get useBlurRadiusAdjustedForZoom() {
            return this.q;
        }
        set useBlurRadiusAdjustedForZoom(a) {
            this.q = a;
            this.e("UseBlurRadiusAdjustedForZoom");
        }
        get useGlobalMinMax() {
            return this.r;
        }
        set useGlobalMinMax(a) {
            this.r = a;
            this.e("UseGlobalMinMax");
        }
        get useGlobalMinMaxAdjustedForZoom() {
            return this.s;
        }
        set useGlobalMinMaxAdjustedForZoom(a) {
            this.s = a;
            this.e("UseGlobalMinMaxAdjustedForZoom");
        }
        get minimumValue() {
            return this.ae;
        }
        set minimumValue(a) {
            this.ae = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.ad;
        }
        set maximumValue(a) {
            this.ad = a;
            this.e("MaximumValue");
        }
        get logarithmBase() {
            return this.ab;
        }
        set logarithmBase(a) {
            this.ab = a;
            this.e("LogarithmBase");
        }
        get useLogarithmicScale() {
            return this.t;
        }
        set useLogarithmicScale(a) {
            this.t = a;
            this.e("UseLogarithmicScale");
        }
        get useWebWorkers() {
            return this.u;
        }
        set useWebWorkers(a) {
            this.u = a;
            this.e("UseWebWorkers");
        }
        get webWorkerScriptPath() {
            return this.an;
        }
        set webWorkerScriptPath(a) {
            this.an = a;
            this.e("WebWorkerScriptPath");
        }
        get webWorkerInstanceRef() {
            return this.am;
        }
        set webWorkerInstanceRef(a) {
            this.am = a;
            this.e("WebWorkerInstanceRef");
        }
    }
    HeatTileGeneratorDescription.$t = /*@__PURE__*/ markType(HeatTileGeneratorDescription, 'HeatTileGeneratorDescription', TileGeneratorDescription.$);
    return HeatTileGeneratorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorDescriptionMetadata = /*@__PURE__*/ (() => {
    class HeatTileGeneratorDescriptionMetadata extends Base {
        static b(a) {
            if (HeatTileGeneratorDescriptionMetadata.a == null) {
                HeatTileGeneratorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HeatTileGeneratorDescriptionMetadata.c(a, HeatTileGeneratorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("YValues", "Array:double");
            b.item("XValues", "Array:double");
            b.item("Values", "Array:double");
            b.item("MinimumColor", "Color");
            b.item("MaximumColor", "Color");
            b.item("ScaleColors", "Array:string:Color");
            b.item("ScaleColorOffsets", "Array:double");
            b.item("BlurRadius", "Number:double");
            b.item("MaxBlurRadius", "Number:double");
            b.item("UseBlurRadiusAdjustedForZoom", "Boolean");
            b.item("UseGlobalMinMax", "Boolean");
            b.item("UseGlobalMinMaxAdjustedForZoom", "Boolean");
            b.item("MinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("LogarithmBase", "Number:double");
            b.item("UseLogarithmicScale", "Boolean");
            b.item("UseWebWorkers", "Boolean");
            b.item("WebWorkerScriptPath", "String");
            b.item("WebWorkerInstanceRef", "(w:WebWorkerInstance,wf:WebWorkerInstance)DataRef");
        }
        static d(a) {
            HeatTileGeneratorDescriptionMetadata.b(a);
            a.q("HeatTileGenerator", () => new HeatTileGeneratorDescription());
            a.p("HeatTileGenerator", HeatTileGeneratorDescriptionMetadata.a);
        }
    }
    HeatTileGeneratorDescriptionMetadata.$t = /*@__PURE__*/ markType(HeatTileGeneratorDescriptionMetadata, 'HeatTileGeneratorDescriptionMetadata');
    HeatTileGeneratorDescriptionMetadata.a = null;
    return HeatTileGeneratorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorDescriptionModule = /*@__PURE__*/ (() => {
    class HeatTileGeneratorDescriptionModule extends Base {
        static register(a) {
            HeatTileGeneratorDescriptionMetadata.d(a);
        }
    }
    HeatTileGeneratorDescriptionModule.$t = /*@__PURE__*/ markType(HeatTileGeneratorDescriptionModule, 'HeatTileGeneratorDescriptionModule');
    return HeatTileGeneratorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicTileSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicTileSeriesDescription extends GeographicShapeSeriesBaseDescription {
        constructor() {
            super();
            this.dc = null;
            this.de = null;
        }
        get_type() {
            return "GeographicTileSeries";
        }
        get tileImagery() {
            return this.dc;
        }
        set tileImagery(a) {
            this.dc = a;
            this.e("TileImagery");
        }
        get imageTilesReadyRef() {
            return this.de;
        }
        set imageTilesReadyRef(a) {
            this.de = a;
            this.e("ImageTilesReadyRef");
        }
    }
    GeographicTileSeriesDescription.$t = /*@__PURE__*/ markType(GeographicTileSeriesDescription, 'GeographicTileSeriesDescription', GeographicShapeSeriesBaseDescription.$);
    return GeographicTileSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicTileSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicTileSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicTileSeriesDescriptionMetadata.a == null) {
                GeographicTileSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicTileSeriesDescriptionMetadata.c(a, GeographicTileSeriesDescriptionMetadata.a);
                GeographicMapImageryDescriptionMetadata.d(a);
                ImageTilesReadyEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicShapeSeriesBaseDescriptionMetadata.c(a, b);
            b.item("TileImagery", "ExportedType:GeographicMapImagery");
            b.item("ImageTilesReadyRef", "EventRef::imageTilesReady");
        }
        static d(a) {
            GeographicTileSeriesDescriptionMetadata.b(a);
            a.q("GeographicTileSeries", () => new GeographicTileSeriesDescription());
            a.p("GeographicTileSeries", GeographicTileSeriesDescriptionMetadata.a);
        }
    }
    GeographicTileSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicTileSeriesDescriptionMetadata, 'GeographicTileSeriesDescriptionMetadata');
    GeographicTileSeriesDescriptionMetadata.a = null;
    return GeographicTileSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicTileSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicTileSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicTileSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicTileSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicTileSeriesDescriptionModule, 'GeographicTileSeriesDescriptionModule');
    return GeographicTileSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
            this.dl = null;
            this.dm = null;
            this.dt = null;
            this.dr = null;
            this.dp = null;
            this.ds = null;
            this.dn = null;
            this.dq = null;
            this.dd = 0;
            this.du = null;
            this.cu = null;
            this.dk = null;
            this.di = null;
            this.cs = null;
            this.cw = false;
            this.cz = false;
            this.c7 = 0;
            this.c6 = 0;
            this.c8 = 0;
            this.c0 = false;
            this.cy = false;
            this.cx = false;
            this.dj = null;
            this.dc = 0;
            this.dh = null;
            this.dg = null;
        }
        get_type() {
            return "GeographicProportionalSymbolSeries";
        }
        get latitudeMemberPath() {
            return this.dl;
        }
        set latitudeMemberPath(a) {
            this.dl = a;
            this.e("LatitudeMemberPath");
        }
        get longitudeMemberPath() {
            return this.dm;
        }
        set longitudeMemberPath(a) {
            this.dm = a;
            this.e("LongitudeMemberPath");
        }
        get markerType() {
            return this.dt;
        }
        set markerType(a) {
            this.dt = a;
            this.e("MarkerType");
        }
        get markerOutlineMode() {
            return this.dr;
        }
        set markerOutlineMode(a) {
            this.dr = a;
            this.e("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.dp;
        }
        set markerFillMode(a) {
            this.dp = a;
            this.e("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.ds;
        }
        set markerTemplateRef(a) {
            this.ds = a;
            this.e("MarkerTemplateRef");
        }
        get markerBrush() {
            return this.dn;
        }
        set markerBrush(a) {
            this.dn = a;
            this.e("MarkerBrush");
        }
        get markerOutline() {
            return this.dq;
        }
        set markerOutline(a) {
            this.dq = a;
            this.e("MarkerOutline");
        }
        get maximumMarkers() {
            return this.dd;
        }
        set maximumMarkers(a) {
            this.dd = a;
            this.e("MaximumMarkers");
        }
        get radiusMemberPath() {
            return this.du;
        }
        set radiusMemberPath(a) {
            this.du = a;
            this.e("RadiusMemberPath");
        }
        get radiusScale() {
            return this.cu;
        }
        set radiusScale(a) {
            this.cu = a;
            this.e("RadiusScale");
        }
        get labelMemberPath() {
            return this.dk;
        }
        set labelMemberPath(a) {
            this.dk = a;
            this.e("LabelMemberPath");
        }
        get fillMemberPath() {
            return this.di;
        }
        set fillMemberPath(a) {
            this.di = a;
            this.e("FillMemberPath");
        }
        get fillScale() {
            return this.cs;
        }
        set fillScale(a) {
            this.cs = a;
            this.e("FillScale");
        }
        get fillScaleUseGlobalValues() {
            return this.cw;
        }
        set fillScaleUseGlobalValues(a) {
            this.cw = a;
            this.e("FillScaleUseGlobalValues");
        }
        get markerOutlineUsesFillScale() {
            return this.cz;
        }
        set markerOutlineUsesFillScale(a) {
            this.cz = a;
            this.e("MarkerOutlineUsesFillScale");
        }
        get markerOutlineBrightness() {
            return this.c7;
        }
        set markerOutlineBrightness(a) {
            this.c7 = a;
            this.e("MarkerOutlineBrightness");
        }
        get markerBrushBrightness() {
            return this.c6;
        }
        set markerBrushBrightness(a) {
            this.c6 = a;
            this.e("MarkerBrushBrightness");
        }
        get markerThickness() {
            return this.c8;
        }
        set markerThickness(a) {
            this.c8 = a;
            this.e("MarkerThickness");
        }
        get radiusScaleUseGlobalValues() {
            return this.c0;
        }
        set radiusScaleUseGlobalValues(a) {
            this.c0 = a;
            this.e("RadiusScaleUseGlobalValues");
        }
        get isCustomScatterStyleAllowed() {
            return this.cy;
        }
        set isCustomScatterStyleAllowed(a) {
            this.cy = a;
            this.e("IsCustomScatterStyleAllowed");
        }
        get isCustomScatterMarkerStyleAllowed() {
            return this.cx;
        }
        set isCustomScatterMarkerStyleAllowed(a) {
            this.cx = a;
            this.e("IsCustomScatterMarkerStyleAllowed");
        }
        get itemSearchMode() {
            return this.dj;
        }
        set itemSearchMode(a) {
            this.dj = a;
            this.e("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.dc;
        }
        set itemSearchThreshold(a) {
            this.dc = a;
            this.e("ItemSearchThreshold");
        }
        get assigningScatterStyleRef() {
            return this.dh;
        }
        set assigningScatterStyleRef(a) {
            this.dh = a;
            this.e("AssigningScatterStyleRef");
        }
        get assigningScatterMarkerStyleRef() {
            return this.dg;
        }
        set assigningScatterMarkerStyleRef(a) {
            this.dg = a;
            this.e("AssigningScatterMarkerStyleRef");
        }
    }
    GeographicProportionalSymbolSeriesDescription.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesDescription, 'GeographicProportionalSymbolSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicProportionalSymbolSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicProportionalSymbolSeriesDescriptionMetadata.a == null) {
                GeographicProportionalSymbolSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicProportionalSymbolSeriesDescriptionMetadata.c(a, GeographicProportionalSymbolSeriesDescriptionMetadata.a);
                SizeScaleDescriptionMetadata.d(a);
                BrushScaleDescriptionMetadata.d(a);
                AssigningScatterStyleEventArgsDescriptionMetadata.d(a);
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
            b.item("LatitudeMemberPath", "String");
            b.item("LongitudeMemberPath", "String");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            b.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            b.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            b.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("MarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("MaximumMarkers", "Number:int");
            b.item("RadiusMemberPath", "String");
            b.item("RadiusScale", "ExportedType:SizeScale");
            b.item("LabelMemberPath", "String");
            b.item("FillMemberPath", "String");
            b.item("FillScale", "ExportedType:BrushScale");
            b.item("FillScaleUseGlobalValues", "Boolean");
            b.item("MarkerOutlineUsesFillScale", "Boolean");
            b.item("MarkerOutlineBrightness", "Number:double");
            b.item("MarkerBrushBrightness", "Number:double");
            b.item("MarkerThickness", "Number:double");
            b.item("RadiusScaleUseGlobalValues", "Boolean");
            b.item("IsCustomScatterStyleAllowed", "Boolean");
            b.item("IsCustomScatterMarkerStyleAllowed", "Boolean");
            b.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            b.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            b.item("ItemSearchThreshold", "Number:int");
            b.item("AssigningScatterStyleRef", "EventRef::assigningScatterStyle");
            b.item("AssigningScatterMarkerStyleRef", "EventRef::assigningScatterMarkerStyle");
        }
        static d(a) {
            GeographicProportionalSymbolSeriesDescriptionMetadata.b(a);
            a.q("GeographicProportionalSymbolSeries", () => new GeographicProportionalSymbolSeriesDescription());
            a.p("GeographicProportionalSymbolSeries", GeographicProportionalSymbolSeriesDescriptionMetadata.a);
        }
    }
    GeographicProportionalSymbolSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesDescriptionMetadata, 'GeographicProportionalSymbolSeriesDescriptionMetadata');
    GeographicProportionalSymbolSeriesDescriptionMetadata.a = null;
    return GeographicProportionalSymbolSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicProportionalSymbolSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicProportionalSymbolSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesDescriptionModule, 'GeographicProportionalSymbolSeriesDescriptionModule');
    return GeographicProportionalSymbolSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
            this.c5 = null;
            this.c6 = null;
            this.dd = null;
            this.c8 = null;
            this.db = null;
            this.c9 = null;
            this.dc = null;
            this.c7 = null;
            this.da = null;
            this.cz = 0;
            this.cw = 0;
            this.ct = false;
            this.cs = false;
            this.c4 = null;
            this.cy = 0;
            this.c3 = null;
            this.c2 = null;
        }
        get_type() {
            return "GeographicSymbolSeries";
        }
        get latitudeMemberPath() {
            return this.c5;
        }
        set latitudeMemberPath(a) {
            this.c5 = a;
            this.e("LatitudeMemberPath");
        }
        get longitudeMemberPath() {
            return this.c6;
        }
        set longitudeMemberPath(a) {
            this.c6 = a;
            this.e("LongitudeMemberPath");
        }
        get markerType() {
            return this.dd;
        }
        set markerType(a) {
            this.dd = a;
            this.e("MarkerType");
        }
        get markerCollisionAvoidance() {
            return this.c8;
        }
        set markerCollisionAvoidance(a) {
            this.c8 = a;
            this.e("MarkerCollisionAvoidance");
        }
        get markerOutlineMode() {
            return this.db;
        }
        set markerOutlineMode(a) {
            this.db = a;
            this.e("MarkerOutlineMode");
        }
        get markerFillMode() {
            return this.c9;
        }
        set markerFillMode(a) {
            this.c9 = a;
            this.e("MarkerFillMode");
        }
        get markerTemplateRef() {
            return this.dc;
        }
        set markerTemplateRef(a) {
            this.dc = a;
            this.e("MarkerTemplateRef");
        }
        get markerBrush() {
            return this.c7;
        }
        set markerBrush(a) {
            this.c7 = a;
            this.e("MarkerBrush");
        }
        get markerOutline() {
            return this.da;
        }
        set markerOutline(a) {
            this.da = a;
            this.e("MarkerOutline");
        }
        get maximumMarkers() {
            return this.cz;
        }
        set maximumMarkers(a) {
            this.cz = a;
            this.e("MaximumMarkers");
        }
        get markerThickness() {
            return this.cw;
        }
        set markerThickness(a) {
            this.cw = a;
            this.e("MarkerThickness");
        }
        get isCustomScatterStyleAllowed() {
            return this.ct;
        }
        set isCustomScatterStyleAllowed(a) {
            this.ct = a;
            this.e("IsCustomScatterStyleAllowed");
        }
        get isCustomScatterMarkerStyleAllowed() {
            return this.cs;
        }
        set isCustomScatterMarkerStyleAllowed(a) {
            this.cs = a;
            this.e("IsCustomScatterMarkerStyleAllowed");
        }
        get itemSearchMode() {
            return this.c4;
        }
        set itemSearchMode(a) {
            this.c4 = a;
            this.e("ItemSearchMode");
        }
        get itemSearchThreshold() {
            return this.cy;
        }
        set itemSearchThreshold(a) {
            this.cy = a;
            this.e("ItemSearchThreshold");
        }
        get assigningScatterStyleRef() {
            return this.c3;
        }
        set assigningScatterStyleRef(a) {
            this.c3 = a;
            this.e("AssigningScatterStyleRef");
        }
        get assigningScatterMarkerStyleRef() {
            return this.c2;
        }
        set assigningScatterMarkerStyleRef(a) {
            this.c2 = a;
            this.e("AssigningScatterMarkerStyleRef");
        }
    }
    GeographicSymbolSeriesDescription.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesDescription, 'GeographicSymbolSeriesDescription', GeographicMapSeriesHostDescription.$);
    return GeographicSymbolSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicSymbolSeriesDescriptionMetadata.a == null) {
                GeographicSymbolSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicSymbolSeriesDescriptionMetadata.c(a, GeographicSymbolSeriesDescriptionMetadata.a);
                AssigningScatterStyleEventArgsDescriptionMetadata.d(a);
                AssigningScatterMarkerStyleEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
            b.item("LatitudeMemberPath", "String");
            b.item("LongitudeMemberPath", "String");
            b.item("MarkerType", "ExportedType:string:MarkerType");
            b.item("MarkerType@names", "Unset;None;Automatic;Circle;Triangle;Pyramid;Square;Diamond;Pentagon;Hexagon;Tetragram;Pentagram;Hexagram;Hidden");
            b.item("MarkerCollisionAvoidance", "ExportedType:string:CollisionAvoidanceType");
            b.item("MarkerCollisionAvoidance@names", "None;Omit;Fade;OmitAndShift;FadeAndShift");
            b.item("MarkerOutlineMode", "ExportedType:string:MarkerOutlineMode");
            b.item("MarkerOutlineMode@names", "Auto;Normal;MatchMarkerBrush");
            b.item("MarkerFillMode", "ExportedType:string:MarkerFillMode");
            b.item("MarkerFillMode@names", "Auto;Normal;MatchMarkerOutline");
            b.item("MarkerTemplateRef", "(w:MarkerTemplate,wf:MarkerTemplate)DataRef::object");
            b.item("MarkerBrush", "Brush");
            b.item("MarkerOutline", "Brush");
            b.item("MaximumMarkers", "Number:int");
            b.item("MarkerThickness", "Number:double");
            b.item("IsCustomScatterStyleAllowed", "Boolean");
            b.item("IsCustomScatterMarkerStyleAllowed", "Boolean");
            b.item("ItemSearchMode", "ExportedType:string:ScatterItemSearchMode");
            b.item("ItemSearchMode@names", "Auto;ClosestVisiblePoint;ClosestPoint;ClosestVisiblePointOnClosestLine;ClosestPointOnClosestLine;None");
            b.item("ItemSearchThreshold", "Number:int");
            b.item("AssigningScatterStyleRef", "EventRef::assigningScatterStyle");
            b.item("AssigningScatterMarkerStyleRef", "EventRef::assigningScatterMarkerStyle");
        }
        static d(a) {
            GeographicSymbolSeriesDescriptionMetadata.b(a);
            a.q("GeographicSymbolSeries", () => new GeographicSymbolSeriesDescription());
            a.p("GeographicSymbolSeries", GeographicSymbolSeriesDescriptionMetadata.a);
        }
    }
    GeographicSymbolSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesDescriptionMetadata, 'GeographicSymbolSeriesDescriptionMetadata');
    GeographicSymbolSeriesDescriptionMetadata.a = null;
    return GeographicSymbolSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicSymbolSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicSymbolSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesDescriptionModule, 'GeographicSymbolSeriesDescriptionModule');
    return GeographicSymbolSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicScatterAreaSeriesDescription = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesDescription extends GeographicXYTriangulatingSeriesDescription {
        constructor() {
            super();
            this.c6 = null;
            this.c4 = null;
            this.c7 = null;
        }
        get_type() {
            return "GeographicScatterAreaSeries";
        }
        get colorMemberPath() {
            return this.c6;
        }
        set colorMemberPath(a) {
            this.c6 = a;
            this.e("ColorMemberPath");
        }
        get colorScale() {
            return this.c4;
        }
        set colorScale(a) {
            this.c4 = a;
            this.e("ColorScale");
        }
        get triangulationStatusChangedRef() {
            return this.c7;
        }
        set triangulationStatusChangedRef(a) {
            this.c7 = a;
            this.e("TriangulationStatusChangedRef");
        }
    }
    GeographicScatterAreaSeriesDescription.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesDescription, 'GeographicScatterAreaSeriesDescription', GeographicXYTriangulatingSeriesDescription.$);
    return GeographicScatterAreaSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicScatterAreaSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicScatterAreaSeriesDescriptionMetadata.a == null) {
                GeographicScatterAreaSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicScatterAreaSeriesDescriptionMetadata.c(a, GeographicScatterAreaSeriesDescriptionMetadata.a);
                ColorScaleDescriptionMetadata.d(a);
                TriangulationStatusEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            GeographicXYTriangulatingSeriesDescriptionMetadata.c(a, b);
            b.item("ColorMemberPath", "String");
            b.item("ColorScale", "ExportedType:ColorScale");
            b.item("TriangulationStatusChangedRef", "EventRef::triangulationStatusChanged");
        }
        static d(a) {
            GeographicScatterAreaSeriesDescriptionMetadata.b(a);
            a.q("GeographicScatterAreaSeries", () => new GeographicScatterAreaSeriesDescription());
            a.p("GeographicScatterAreaSeries", GeographicScatterAreaSeriesDescriptionMetadata.a);
        }
    }
    GeographicScatterAreaSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesDescriptionMetadata, 'GeographicScatterAreaSeriesDescriptionMetadata');
    GeographicScatterAreaSeriesDescriptionMetadata.a = null;
    return GeographicScatterAreaSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicScatterAreaSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesDescriptionModule extends Base {
        static register(a) {
            GeographicScatterAreaSeriesDescriptionMetadata.d(a);
        }
    }
    GeographicScatterAreaSeriesDescriptionModule.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesDescriptionModule, 'GeographicScatterAreaSeriesDescriptionModule');
    return GeographicScatterAreaSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeDataSourceDescriptionModule = /*@__PURE__*/ (() => {
    class ShapeDataSourceDescriptionModule extends Base {
        static register(a) {
            ShapeDataSourceDescriptionMetadata.d(a);
        }
    }
    ShapeDataSourceDescriptionModule.$t = /*@__PURE__*/ markType(ShapeDataSourceDescriptionModule, 'ShapeDataSourceDescriptionModule');
    return ShapeDataSourceDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicMapDescriptionModule = /*@__PURE__*/ (() => {
    class GeographicMapDescriptionModule extends Base {
        static register(a) {
            GeographicShapeSeriesDescriptionModule.register(a);
            GeographicPolylineSeriesDescriptionModule.register(a);
            TileGeneratorMapImageryDescriptionModule.register(a);
            HeatTileGeneratorDescriptionModule.register(a);
            GeographicTileSeriesDescriptionModule.register(a);
            SizeScaleDescriptionModule.register(a);
            ValueBrushScaleDescriptionModule.register(a);
            CustomPaletteColorScaleDescriptionModule.register(a);
            GeographicProportionalSymbolSeriesDescriptionModule.register(a);
            GeographicSymbolSeriesDescriptionModule.register(a);
            GeographicScatterAreaSeriesDescriptionModule.register(a);
            GeographicHighDensityScatterSeriesDescriptionModule.register(a);
            GeographicContourLineSeriesDescriptionModule.register(a);
            GeographicMapCoreDescriptionModule.register(a);
            ShapeDataSourceDescriptionModule.register(a);
        }
    }
    GeographicMapDescriptionModule.$t = /*@__PURE__*/ markType(GeographicMapDescriptionModule, 'GeographicMapDescriptionModule');
    return GeographicMapDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesBaseDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GeographicProportionalSymbolSeriesBase";
        }
    }
    GeographicProportionalSymbolSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesBaseDescription, 'GeographicProportionalSymbolSeriesBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicProportionalSymbolSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicProportionalSymbolSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a == null) {
                GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicProportionalSymbolSeriesBaseDescriptionMetadata.c(a, GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GeographicProportionalSymbolSeriesBaseDescriptionMetadata.b(a);
            a.p("GeographicProportionalSymbolSeriesBase", GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicProportionalSymbolSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesBaseDescriptionMetadata, 'GeographicProportionalSymbolSeriesBaseDescriptionMetadata');
    GeographicProportionalSymbolSeriesBaseDescriptionMetadata.a = null;
    return GeographicProportionalSymbolSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseBaseDescription = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseBaseDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GeographicShapeSeriesBaseBase";
        }
    }
    GeographicShapeSeriesBaseBaseDescription.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseBaseDescription, 'GeographicShapeSeriesBaseBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicShapeSeriesBaseBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicShapeSeriesBaseBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicShapeSeriesBaseBaseDescriptionMetadata.a == null) {
                GeographicShapeSeriesBaseBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicShapeSeriesBaseBaseDescriptionMetadata.c(a, GeographicShapeSeriesBaseBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GeographicShapeSeriesBaseBaseDescriptionMetadata.b(a);
            a.p("GeographicShapeSeriesBaseBase", GeographicShapeSeriesBaseBaseDescriptionMetadata.a);
        }
    }
    GeographicShapeSeriesBaseBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseBaseDescriptionMetadata, 'GeographicShapeSeriesBaseBaseDescriptionMetadata');
    GeographicShapeSeriesBaseBaseDescriptionMetadata.a = null;
    return GeographicShapeSeriesBaseBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesBaseDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GeographicSymbolSeriesBase";
        }
    }
    GeographicSymbolSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesBaseDescription, 'GeographicSymbolSeriesBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicSymbolSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicSymbolSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicSymbolSeriesBaseDescriptionMetadata.a == null) {
                GeographicSymbolSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicSymbolSeriesBaseDescriptionMetadata.c(a, GeographicSymbolSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GeographicSymbolSeriesBaseDescriptionMetadata.b(a);
            a.p("GeographicSymbolSeriesBase", GeographicSymbolSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicSymbolSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesBaseDescriptionMetadata, 'GeographicSymbolSeriesBaseDescriptionMetadata');
    GeographicSymbolSeriesBaseDescriptionMetadata.a = null;
    return GeographicSymbolSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesBaseDescription = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesBaseDescription extends GeographicMapSeriesHostDescription {
        constructor() {
            super();
        }
        get_type() {
            return "GeographicXYTriangulatingSeriesBase";
        }
    }
    GeographicXYTriangulatingSeriesBaseDescription.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesBaseDescription, 'GeographicXYTriangulatingSeriesBaseDescription', GeographicMapSeriesHostDescription.$);
    return GeographicXYTriangulatingSeriesBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeographicXYTriangulatingSeriesBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesBaseDescriptionMetadata extends Base {
        static b(a) {
            if (GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a == null) {
                GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GeographicXYTriangulatingSeriesBaseDescriptionMetadata.c(a, GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            GeographicMapSeriesHostDescriptionMetadata.c(a, b);
        }
        static d(a) {
            GeographicXYTriangulatingSeriesBaseDescriptionMetadata.b(a);
            a.p("GeographicXYTriangulatingSeriesBase", GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a);
        }
    }
    GeographicXYTriangulatingSeriesBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesBaseDescriptionMetadata, 'GeographicXYTriangulatingSeriesBaseDescriptionMetadata');
    GeographicXYTriangulatingSeriesBaseDescriptionMetadata.a = null;
    return GeographicXYTriangulatingSeriesBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellEditEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.l = null;
            this.k = null;
            this.j = null;
            this.h = false;
        }
        get_type() {
            return "GridCellEditEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get oldValueRef() {
            return this.l;
        }
        set oldValueRef(a) {
            this.l = a;
            this.e("OldValueRef");
        }
        get newValueRef() {
            return this.k;
        }
        set newValueRef(a) {
            this.k = a;
            this.e("NewValueRef");
        }
        get errorMessage() {
            return this.j;
        }
        set errorMessage(a) {
            this.j = a;
            this.e("ErrorMessage");
        }
        get cancel() {
            return this.h;
        }
        set cancel(a) {
            this.h = a;
            this.e("Cancel");
        }
    }
    GridCellEditEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellEditEventArgsDescription, 'GridCellEditEventArgsDescription', Description.$);
    return GridCellEditEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellEditEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellEditEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellEditEventArgsDescriptionMetadata.a == null) {
                GridCellEditEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellEditEventArgsDescriptionMetadata.c(a, GridCellEditEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
            b.item("OldValueRef", "(w:OldValue,wf:OldValue)DataRef");
            b.item("NewValueRef", "(w:NewValue,wf:NewValue)DataRef");
            b.item("ErrorMessage", "String");
            b.item("Cancel", "Boolean");
        }
        static d(a) {
            GridCellEditEventArgsDescriptionMetadata.b(a);
            a.q("GridCellEditEventArgs", () => new GridCellEditEventArgsDescription());
            a.p("GridCellEditEventArgs", GridCellEditEventArgsDescriptionMetadata.a);
        }
    }
    GridCellEditEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellEditEventArgsDescriptionMetadata, 'GridCellEditEventArgsDescriptionMetadata');
    GridCellEditEventArgsDescriptionMetadata.a = null;
    return GridCellEditEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellValueChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCellValueChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = 0;
            this.f = null;
            this.l = null;
            this.k = null;
            this.j = null;
            this.m = null;
        }
        get_type() {
            return "GridCellValueChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get transactionID() {
            return this.h;
        }
        set transactionID(a) {
            this.h = a;
            this.e("TransactionID");
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
        get oldValueRef() {
            return this.l;
        }
        set oldValueRef(a) {
            this.l = a;
            this.e("OldValueRef");
        }
        get newValueRef() {
            return this.k;
        }
        set newValueRef(a) {
            this.k = a;
            this.e("NewValueRef");
        }
        get errorMessage() {
            return this.j;
        }
        set errorMessage(a) {
            this.j = a;
            this.e("ErrorMessage");
        }
        get pendingState() {
            return this.m;
        }
        set pendingState(a) {
            this.m = a;
            this.e("PendingState");
        }
    }
    GridCellValueChangedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCellValueChangedEventArgsDescription, 'GridCellValueChangedEventArgsDescription', Description.$);
    return GridCellValueChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCellValueChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCellValueChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCellValueChangedEventArgsDescriptionMetadata.a == null) {
                GridCellValueChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCellValueChangedEventArgsDescriptionMetadata.c(a, GridCellValueChangedEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("TransactionID", "Number:int");
            b.item("Column", "ExportedType:Column");
            b.item("OldValueRef", "(w:OldValue,wf:OldValue)DataRef");
            b.item("NewValueRef", "(w:NewValue,wf:NewValue)DataRef");
            b.item("ErrorMessage", "String");
            b.item("PendingState", "ExportedType:string:TransactionPendingState");
        }
        static d(a) {
            GridCellValueChangedEventArgsDescriptionMetadata.b(a);
            a.q("GridCellValueChangedEventArgs", () => new GridCellValueChangedEventArgsDescription());
            a.p("GridCellValueChangedEventArgs", GridCellValueChangedEventArgsDescriptionMetadata.a);
        }
    }
    GridCellValueChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCellValueChangedEventArgsDescriptionMetadata, 'GridCellValueChangedEventArgsDescriptionMetadata');
    GridCellValueChangedEventArgsDescriptionMetadata.a = null;
    return GridCellValueChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCommitCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class GridCommitCompletedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.h = null;
        }
        get_type() {
            return "GridCommitCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get transactionTypes() {
            return this.f;
        }
        set transactionTypes(a) {
            this.f = a;
            this.e("TransactionTypes");
        }
        get itemsRef() {
            return this.h;
        }
        set itemsRef(a) {
            this.h = a;
            this.e("ItemsRef");
        }
    }
    GridCommitCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(GridCommitCompletedEventArgsDescription, 'GridCommitCompletedEventArgsDescription', Description.$);
    return GridCommitCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridCommitCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridCommitCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridCommitCompletedEventArgsDescriptionMetadata.a == null) {
                GridCommitCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridCommitCompletedEventArgsDescriptionMetadata.c(a, GridCommitCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TransactionTypes", "Array:string:TransactionType");
            b.item("ItemsRef", "(w:Items,wf:Items)DataRef:object");
        }
        static d(a) {
            GridCommitCompletedEventArgsDescriptionMetadata.b(a);
            a.q("GridCommitCompletedEventArgs", () => new GridCommitCompletedEventArgsDescription());
            a.p("GridCommitCompletedEventArgs", GridCommitCompletedEventArgsDescriptionMetadata.a);
        }
    }
    GridCommitCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridCommitCompletedEventArgsDescriptionMetadata, 'GridCommitCompletedEventArgsDescriptionMetadata');
    GridCommitCompletedEventArgsDescriptionMetadata.a = null;
    return GridCommitCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeaderRowSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class HeaderRowSeparatorDescriptionModule extends Base {
        static register(a) {
            HeaderRowSeparatorDescriptionMetadata.d(a);
        }
    }
    HeaderRowSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(HeaderRowSeparatorDescriptionModule, 'HeaderRowSeparatorDescriptionModule');
    return HeaderRowSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalAnchoredCategorySeriesProxyDescriptionModule = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeriesProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    HorizontalAnchoredCategorySeriesProxyDescriptionModule.$t = /*@__PURE__*/ markType(HorizontalAnchoredCategorySeriesProxyDescriptionModule, 'HorizontalAnchoredCategorySeriesProxyDescriptionModule');
    return HorizontalAnchoredCategorySeriesProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HorizontalRangeCategorySeriesProxyDescriptionModule = /*@__PURE__*/ (() => {
    class HorizontalRangeCategorySeriesProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    HorizontalRangeCategorySeriesProxyDescriptionModule.$t = /*@__PURE__*/ markType(HorizontalRangeCategorySeriesProxyDescriptionModule, 'HorizontalRangeCategorySeriesProxyDescriptionModule');
    return HorizontalRangeCategorySeriesProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IndicatorProxyDescriptionModule = /*@__PURE__*/ (() => {
    class IndicatorProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    IndicatorProxyDescriptionModule.$t = /*@__PURE__*/ markType(IndicatorProxyDescriptionModule, 'IndicatorProxyDescriptionModule');
    return IndicatorProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemLegendDescription = /*@__PURE__*/ (() => {
    class ItemLegendDescription extends LegendBaseDescription {
        constructor() {
            super();
            this.u = null;
            this.s = null;
            this.t = null;
        }
        get width() {
            return this.u;
        }
        set width(a) {
            this.u = a;
            this.e("Width");
        }
        get height() {
            return this.s;
        }
        set height(a) {
            this.s = a;
            this.e("Height");
        }
        get_type() {
            return "ItemLegend";
        }
        get orientation() {
            return this.t;
        }
        set orientation(a) {
            this.t = a;
            this.e("Orientation");
        }
    }
    ItemLegendDescription.$t = /*@__PURE__*/ markType(ItemLegendDescription, 'ItemLegendDescription', LegendBaseDescription.$);
    return ItemLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class ItemLegendDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
        }
        static b(a) {
            if (ItemLegendDescriptionMetadata.a == null) {
                ItemLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ItemLegendDescriptionMetadata.c(a, ItemLegendDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            LegendBaseDescriptionMetadata.c(a, b);
            b.item("Orientation", "ExportedType:string:LegendOrientation");
            b.item("Orientation@names", "Horizontal;Vertical");
            ItemLegendDescriptionMetadata.e(a, b);
        }
        static d(a) {
            ItemLegendDescriptionMetadata.b(a);
            a.q("ItemLegend", () => new ItemLegendDescription());
            a.p("ItemLegend", ItemLegendDescriptionMetadata.a);
        }
    }
    ItemLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(ItemLegendDescriptionMetadata, 'ItemLegendDescriptionMetadata');
    ItemLegendDescriptionMetadata.a = null;
    return ItemLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItemLegendDescriptionModule = /*@__PURE__*/ (() => {
    class ItemLegendDescriptionModule extends Base {
        static register(a) {
            ItemLegendDescriptionMetadata.d(a);
        }
    }
    ItemLegendDescriptionModule.$t = /*@__PURE__*/ markType(ItemLegendDescriptionModule, 'ItemLegendDescriptionModule');
    return ItemLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorDescriptionMetadata = /*@__PURE__*/ (() => {
    class TileGeneratorDescriptionMetadata extends Base {
        static b(a) {
            if (TileGeneratorDescriptionMetadata.a == null) {
                TileGeneratorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TileGeneratorDescriptionMetadata.c(a, TileGeneratorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            TileGeneratorDescriptionMetadata.b(a);
            a.p("TileGenerator", TileGeneratorDescriptionMetadata.a);
        }
    }
    TileGeneratorDescriptionMetadata.$t = /*@__PURE__*/ markType(TileGeneratorDescriptionMetadata, 'TileGeneratorDescriptionMetadata');
    TileGeneratorDescriptionMetadata.a = null;
    return TileGeneratorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendDescription = /*@__PURE__*/ (() => {
    class LegendDescription extends LegendBaseDescription {
        constructor() {
            super();
            this.w = null;
            this.s = null;
            this.t = null;
            this.u = null;
            this.v = null;
        }
        get width() {
            return this.w;
        }
        set width(a) {
            this.w = a;
            this.e("Width");
        }
        get height() {
            return this.s;
        }
        set height(a) {
            this.s = a;
            this.e("Height");
        }
        get_type() {
            return "Legend";
        }
        get orientation() {
            return this.t;
        }
        set orientation(a) {
            this.t = a;
            this.e("Orientation");
        }
        get textColor() {
            return this.u;
        }
        set textColor(a) {
            this.u = a;
            this.e("TextColor");
        }
        get textStyle() {
            return this.v;
        }
        set textStyle(a) {
            this.v = a;
            this.e("TextStyle");
        }
    }
    LegendDescription.$t = /*@__PURE__*/ markType(LegendDescription, 'LegendDescription', LegendBaseDescription.$);
    return LegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class LegendDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
        }
        static b(a) {
            if (LegendDescriptionMetadata.a == null) {
                LegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LegendDescriptionMetadata.c(a, LegendDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            LegendBaseDescriptionMetadata.c(a, b);
            b.item("Orientation", "ExportedType:string:LegendOrientation");
            b.item("Orientation@names", "Horizontal;Vertical");
            b.item("TextColor", "String");
            b.item("TextStyle", "String");
            LegendDescriptionMetadata.e(a, b);
        }
        static d(a) {
            LegendDescriptionMetadata.b(a);
            a.q("Legend", () => new LegendDescription());
            a.p("Legend", LegendDescriptionMetadata.a);
        }
    }
    LegendDescriptionMetadata.$t = /*@__PURE__*/ markType(LegendDescriptionMetadata, 'LegendDescriptionMetadata');
    LegendDescriptionMetadata.a = null;
    return LegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LegendDescriptionModule = /*@__PURE__*/ (() => {
    class LegendDescriptionModule extends Base {
        static register(a) {
            LegendDescriptionMetadata.d(a);
        }
    }
    LegendDescriptionModule.$t = /*@__PURE__*/ markType(LegendDescriptionModule, 'LegendDescriptionModule');
    return LegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeDescription = /*@__PURE__*/ (() => {
    class LinearGaugeDescription extends Description {
        constructor() {
            super();
            this.ct = null;
            this.z = 0;
            this.cv = null;
            this.cu = null;
            this.c9 = null;
            this.cx = null;
            this.co = null;
            this.a8 = 0;
            this.c4 = null;
            this.i = null;
            this.g = null;
            this.h = null;
            this.ag = 0;
            this.u = 0;
            this.af = 0;
            this.t = 0;
            this.a9 = 0;
            this.c3 = null;
            this.c1 = null;
            this.aw = 0;
            this.az = 0;
            this.ax = 0;
            this.a0 = 0;
            this.an = 0;
            this.ar = 0;
            this.am = 0;
            this.aq = 0;
            this.ap = 0;
            this.at = 0;
            this.ao = 0;
            this.as = 0;
            this.aa = 0;
            this.a4 = 0;
            this.a5 = 0;
            this.ac = 0;
            this.ab = 0;
            this.ad = 0;
            this.ae = 0;
            this.ah = 0;
            this.a6 = 0;
            this.a3 = 0;
            this.a7 = 0;
            this.c7 = null;
            this.cs = null;
            this.al = 0;
            this.c0 = null;
            this.c2 = null;
            this.au = 0;
            this.aj = 0;
            this.ai = 0;
            this.ak = 0;
            this.cz = null;
            this.o = false;
            this.cp = null;
            this.cq = null;
            this.y = 0;
            this.w = 0;
            this.x = 0;
            this.a1 = 0;
            this.ay = 0;
            this.c5 = null;
            this.c6 = null;
            this.a2 = 0;
            this.n = false;
            this.cy = null;
            this.f = null;
            this.ci = 0;
            this.ch = 0;
            this.p = false;
            this.cr = null;
            this.av = 0;
            this.v = 0;
            this.cw = null;
            this.cn = null;
            this.c8 = null;
            this.cm = null;
            this.cl = null;
        }
        get fontFamily() {
            return this.ct;
        }
        set fontFamily(a) {
            this.ct = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.z;
        }
        set fontSize(a) {
            this.z = a;
            this.e("FontSize");
        }
        get fontWeight() {
            return this.cv;
        }
        set fontWeight(a) {
            this.cv = a;
            this.e("FontWeight");
        }
        get fontStyle() {
            return this.cu;
        }
        set fontStyle(a) {
            this.cu = a;
            this.e("FontStyle");
        }
        get width() {
            return this.c9;
        }
        set width(a) {
            this.c9 = a;
            this.e("Width");
        }
        get height() {
            return this.cx;
        }
        set height(a) {
            this.cx = a;
            this.e("Height");
        }
        get background() {
            return this.co;
        }
        set background(a) {
            this.co = a;
            this.e("Background");
        }
        get_type() {
            return "LinearGauge";
        }
        get type() {
            return this.get_type();
        }
        get transitionProgress() {
            return this.a8;
        }
        set transitionProgress(a) {
            this.a8 = a;
            this.e("TransitionProgress");
        }
        get orientation() {
            return this.c4;
        }
        set orientation(a) {
            this.c4 = a;
            this.e("Orientation");
        }
        get ranges() {
            return this.i;
        }
        set ranges(a) {
            this.i = a;
            this.e("Ranges");
        }
        get rangeBrushes() {
            return this.g;
        }
        set rangeBrushes(a) {
            this.g = a;
            this.e("RangeBrushes");
        }
        get rangeOutlines() {
            return this.h;
        }
        set rangeOutlines(a) {
            this.h = a;
            this.e("RangeOutlines");
        }
        get minimumValue() {
            return this.ag;
        }
        set minimumValue(a) {
            this.ag = a;
            this.e("MinimumValue");
        }
        get actualMinimumValue() {
            return this.u;
        }
        set actualMinimumValue(a) {
            this.u = a;
            this.e("ActualMinimumValue");
        }
        get maximumValue() {
            return this.af;
        }
        set maximumValue(a) {
            this.af = a;
            this.e("MaximumValue");
        }
        get actualMaximumValue() {
            return this.t;
        }
        set actualMaximumValue(a) {
            this.t = a;
            this.e("ActualMaximumValue");
        }
        get value() {
            return this.a9;
        }
        set value(a) {
            this.a9 = a;
            this.e("Value");
        }
        get needleShape() {
            return this.c3;
        }
        set needleShape(a) {
            this.c3 = a;
            this.e("NeedleShape");
        }
        get needleName() {
            return this.c1;
        }
        set needleName(a) {
            this.c1 = a;
            this.e("NeedleName");
        }
        get rangeInnerExtent() {
            return this.aw;
        }
        set rangeInnerExtent(a) {
            this.aw = a;
            this.e("RangeInnerExtent");
        }
        get scaleInnerExtent() {
            return this.az;
        }
        set scaleInnerExtent(a) {
            this.az = a;
            this.e("ScaleInnerExtent");
        }
        get rangeOuterExtent() {
            return this.ax;
        }
        set rangeOuterExtent(a) {
            this.ax = a;
            this.e("RangeOuterExtent");
        }
        get scaleOuterExtent() {
            return this.a0;
        }
        set scaleOuterExtent(a) {
            this.a0 = a;
            this.e("ScaleOuterExtent");
        }
        get needleInnerExtent() {
            return this.an;
        }
        set needleInnerExtent(a) {
            this.an = a;
            this.e("NeedleInnerExtent");
        }
        get needleOuterExtent() {
            return this.ar;
        }
        set needleOuterExtent(a) {
            this.ar = a;
            this.e("NeedleOuterExtent");
        }
        get needleInnerBaseWidth() {
            return this.am;
        }
        set needleInnerBaseWidth(a) {
            this.am = a;
            this.e("NeedleInnerBaseWidth");
        }
        get needleOuterBaseWidth() {
            return this.aq;
        }
        set needleOuterBaseWidth(a) {
            this.aq = a;
            this.e("NeedleOuterBaseWidth");
        }
        get needleInnerPointWidth() {
            return this.ap;
        }
        set needleInnerPointWidth(a) {
            this.ap = a;
            this.e("NeedleInnerPointWidth");
        }
        get needleOuterPointWidth() {
            return this.at;
        }
        set needleOuterPointWidth(a) {
            this.at = a;
            this.e("NeedleOuterPointWidth");
        }
        get needleInnerPointExtent() {
            return this.ao;
        }
        set needleInnerPointExtent(a) {
            this.ao = a;
            this.e("NeedleInnerPointExtent");
        }
        get needleOuterPointExtent() {
            return this.as;
        }
        set needleOuterPointExtent(a) {
            this.as = a;
            this.e("NeedleOuterPointExtent");
        }
        get interval() {
            return this.aa;
        }
        set interval(a) {
            this.aa = a;
            this.e("Interval");
        }
        get ticksPostInitial() {
            return this.a4;
        }
        set ticksPostInitial(a) {
            this.a4 = a;
            this.e("TicksPostInitial");
        }
        get ticksPreTerminal() {
            return this.a5;
        }
        set ticksPreTerminal(a) {
            this.a5 = a;
            this.e("TicksPreTerminal");
        }
        get labelInterval() {
            return this.ac;
        }
        set labelInterval(a) {
            this.ac = a;
            this.e("LabelInterval");
        }
        get labelExtent() {
            return this.ab;
        }
        set labelExtent(a) {
            this.ab = a;
            this.e("LabelExtent");
        }
        get labelsPostInitial() {
            return this.ad;
        }
        set labelsPostInitial(a) {
            this.ad = a;
            this.e("LabelsPostInitial");
        }
        get labelsPreTerminal() {
            return this.ae;
        }
        set labelsPreTerminal(a) {
            this.ae = a;
            this.e("LabelsPreTerminal");
        }
        get minorTickCount() {
            return this.ah;
        }
        set minorTickCount(a) {
            this.ah = a;
            this.e("MinorTickCount");
        }
        get tickStartExtent() {
            return this.a6;
        }
        set tickStartExtent(a) {
            this.a6 = a;
            this.e("TickStartExtent");
        }
        get tickEndExtent() {
            return this.a3;
        }
        set tickEndExtent(a) {
            this.a3 = a;
            this.e("TickEndExtent");
        }
        get tickStrokeThickness() {
            return this.a7;
        }
        set tickStrokeThickness(a) {
            this.a7 = a;
            this.e("TickStrokeThickness");
        }
        get tickBrush() {
            return this.c7;
        }
        set tickBrush(a) {
            this.c7 = a;
            this.e("TickBrush");
        }
        get fontBrush() {
            return this.cs;
        }
        set fontBrush(a) {
            this.cs = a;
            this.e("FontBrush");
        }
        get needleBreadth() {
            return this.al;
        }
        set needleBreadth(a) {
            this.al = a;
            this.e("NeedleBreadth");
        }
        get needleBrush() {
            return this.c0;
        }
        set needleBrush(a) {
            this.c0 = a;
            this.e("NeedleBrush");
        }
        get needleOutline() {
            return this.c2;
        }
        set needleOutline(a) {
            this.c2 = a;
            this.e("NeedleOutline");
        }
        get needleStrokeThickness() {
            return this.au;
        }
        set needleStrokeThickness(a) {
            this.au = a;
            this.e("NeedleStrokeThickness");
        }
        get minorTickStartExtent() {
            return this.aj;
        }
        set minorTickStartExtent(a) {
            this.aj = a;
            this.e("MinorTickStartExtent");
        }
        get minorTickEndExtent() {
            return this.ai;
        }
        set minorTickEndExtent(a) {
            this.ai = a;
            this.e("MinorTickEndExtent");
        }
        get minorTickStrokeThickness() {
            return this.ak;
        }
        set minorTickStrokeThickness(a) {
            this.ak = a;
            this.e("MinorTickStrokeThickness");
        }
        get minorTickBrush() {
            return this.cz;
        }
        set minorTickBrush(a) {
            this.cz = a;
            this.e("MinorTickBrush");
        }
        get isScaleInverted() {
            return this.o;
        }
        set isScaleInverted(a) {
            this.o = a;
            this.e("IsScaleInverted");
        }
        get backingBrush() {
            return this.cp;
        }
        set backingBrush(a) {
            this.cp = a;
            this.e("BackingBrush");
        }
        get backingOutline() {
            return this.cq;
        }
        set backingOutline(a) {
            this.cq = a;
            this.e("BackingOutline");
        }
        get backingStrokeThickness() {
            return this.y;
        }
        set backingStrokeThickness(a) {
            this.y = a;
            this.e("BackingStrokeThickness");
        }
        get backingInnerExtent() {
            return this.w;
        }
        set backingInnerExtent(a) {
            this.w = a;
            this.e("BackingInnerExtent");
        }
        get backingOuterExtent() {
            return this.x;
        }
        set backingOuterExtent(a) {
            this.x = a;
            this.e("BackingOuterExtent");
        }
        get scaleStartExtent() {
            return this.a1;
        }
        set scaleStartExtent(a) {
            this.a1 = a;
            this.e("ScaleStartExtent");
        }
        get scaleEndExtent() {
            return this.ay;
        }
        set scaleEndExtent(a) {
            this.ay = a;
            this.e("ScaleEndExtent");
        }
        get scaleBrush() {
            return this.c5;
        }
        set scaleBrush(a) {
            this.c5 = a;
            this.e("ScaleBrush");
        }
        get scaleOutline() {
            return this.c6;
        }
        set scaleOutline(a) {
            this.c6 = a;
            this.e("ScaleOutline");
        }
        get scaleStrokeThickness() {
            return this.a2;
        }
        set scaleStrokeThickness(a) {
            this.a2 = a;
            this.e("ScaleStrokeThickness");
        }
        get isNeedleDraggingEnabled() {
            return this.n;
        }
        set isNeedleDraggingEnabled(a) {
            this.n = a;
            this.e("IsNeedleDraggingEnabled");
        }
        get labelFormat() {
            return this.cy;
        }
        set labelFormat(a) {
            this.cy = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.f;
        }
        set labelFormatSpecifiers(a) {
            this.f = a;
            this.e("LabelFormatSpecifiers");
        }
        get transitionDuration() {
            return this.ci;
        }
        set transitionDuration(a) {
            this.ci = a;
            this.e("TransitionDuration");
        }
        get showToolTipTimeout() {
            return this.ch;
        }
        set showToolTipTimeout(a) {
            this.ch = a;
            this.e("ShowToolTipTimeout");
        }
        get showToolTip() {
            return this.p;
        }
        set showToolTip(a) {
            this.p = a;
            this.e("ShowToolTip");
        }
        get font() {
            return this.cr;
        }
        set font(a) {
            this.cr = a;
            this.e("Font");
        }
        get pixelScalingRatio() {
            return this.av;
        }
        set pixelScalingRatio(a) {
            this.av = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.v;
        }
        set actualPixelScalingRatio(a) {
            this.v = a;
            this.e("ActualPixelScalingRatio");
        }
        get formatLabelRef() {
            return this.cw;
        }
        set formatLabelRef(a) {
            this.cw = a;
            this.e("FormatLabelRef");
        }
        get alignLabelRef() {
            return this.cn;
        }
        set alignLabelRef(a) {
            this.cn = a;
            this.e("AlignLabelRef");
        }
        get valueChangedRef() {
            return this.c8;
        }
        set valueChangedRef(a) {
            this.c8 = a;
            this.e("ValueChangedRef");
        }
        get actualMinimumValueChangeRef() {
            return this.cm;
        }
        set actualMinimumValueChangeRef(a) {
            this.cm = a;
            this.e("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.cl;
        }
        set actualMaximumValueChangeRef(a) {
            this.cl = a;
            this.e("ActualMaximumValueChangeRef");
        }
    }
    LinearGaugeDescription.$t = /*@__PURE__*/ markType(LinearGaugeDescription, 'LinearGaugeDescription', Description.$);
    return LinearGaugeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeDescriptionMetadata = /*@__PURE__*/ (() => {
    class LinearGaugeDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
            b.item("_qualifiedName", "String:Infragistics.Controls.Gauges.XamLinearGauge");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("LegendRef", "(w:Legend)DataRef:String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (LinearGaugeDescriptionMetadata.a == null) {
                LinearGaugeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LinearGaugeDescriptionMetadata.c(a, LinearGaugeDescriptionMetadata.a);
                FormatLinearGraphLabelEventArgsDescriptionMetadata.d(a);
                AlignLinearGraphLabelEventArgsDescriptionMetadata.d(a);
                DoubleValueChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("TransitionProgress", "Number:double");
            b.item("Orientation", "ExportedType:string:LinearScaleOrientation");
            b.item("Orientation@names", "Horizontal;Vertical");
            b.item("Ranges", "Collection:LinearGraphRange:LinearGraphRangeCollection:LinearGraphRange");
            b.item("RangeBrushes", "BrushCollection:string");
            b.item("RangeOutlines", "BrushCollection:string");
            b.item("MinimumValue", "Number:double");
            b.item("ActualMinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("ActualMaximumValue", "Number:double");
            b.item("Value", "Number:double");
            b.item("NeedleShape", "ExportedType:string:LinearGraphNeedleShape");
            b.item("NeedleShape@names", "Custom;Rectangle;Triangle;Needle;Trapezoid");
            b.item("NeedleName", "String");
            b.item("RangeInnerExtent", "Number:double");
            b.item("ScaleInnerExtent", "Number:double");
            b.item("RangeOuterExtent", "Number:double");
            b.item("ScaleOuterExtent", "Number:double");
            b.item("NeedleInnerExtent", "Number:double");
            b.item("NeedleOuterExtent", "Number:double");
            b.item("NeedleInnerBaseWidth", "Number:double");
            b.item("NeedleOuterBaseWidth", "Number:double");
            b.item("NeedleInnerPointWidth", "Number:double");
            b.item("NeedleOuterPointWidth", "Number:double");
            b.item("NeedleInnerPointExtent", "Number:double");
            b.item("NeedleOuterPointExtent", "Number:double");
            b.item("Interval", "Number:double");
            b.item("TicksPostInitial", "Number:double");
            b.item("TicksPreTerminal", "Number:double");
            b.item("LabelInterval", "Number:double");
            b.item("LabelExtent", "Number:double");
            b.item("LabelsPostInitial", "Number:double");
            b.item("LabelsPreTerminal", "Number:double");
            b.item("MinorTickCount", "Number:double");
            b.item("TickStartExtent", "Number:double");
            b.item("TickEndExtent", "Number:double");
            b.item("TickStrokeThickness", "Number:double");
            b.item("TickBrush", "Brush");
            b.item("FontBrush", "Brush");
            b.item("NeedleBreadth", "Number:double");
            b.item("NeedleBrush", "Brush");
            b.item("NeedleOutline", "Brush");
            b.item("NeedleStrokeThickness", "Number:double");
            b.item("MinorTickStartExtent", "Number:double");
            b.item("MinorTickEndExtent", "Number:double");
            b.item("MinorTickStrokeThickness", "Number:double");
            b.item("MinorTickBrush", "Brush");
            b.item("IsScaleInverted", "Boolean");
            b.item("BackingBrush", "Brush");
            b.item("BackingOutline", "Brush");
            b.item("BackingStrokeThickness", "Number:double");
            b.item("BackingInnerExtent", "Number:double");
            b.item("BackingOuterExtent", "Number:double");
            b.item("ScaleStartExtent", "Number:double");
            b.item("ScaleEndExtent", "Number:double");
            b.item("ScaleBrush", "Brush");
            b.item("ScaleOutline", "Brush");
            b.item("ScaleStrokeThickness", "Number:double");
            b.item("IsNeedleDraggingEnabled", "Boolean");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("TransitionDuration", "Number:int");
            b.item("ShowToolTipTimeout", "Number:int");
            b.item("ShowToolTip", "Boolean");
            b.item("Font", "String");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("FormatLabelRef", "EventRef::formatLabel");
            b.item("AlignLabelRef", "EventRef::alignLabel");
            b.item("ValueChangedRef", "EventRef::valueChanged");
            b.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            b.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            LinearGaugeDescriptionMetadata.e(a, b);
        }
        static d(a) {
            LinearGaugeDescriptionMetadata.b(a);
            a.q("LinearGauge", () => new LinearGaugeDescription());
            a.p("LinearGauge", LinearGaugeDescriptionMetadata.a);
        }
    }
    LinearGaugeDescriptionMetadata.$t = /*@__PURE__*/ markType(LinearGaugeDescriptionMetadata, 'LinearGaugeDescriptionMetadata');
    LinearGaugeDescriptionMetadata.a = null;
    return LinearGaugeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeCoreDescriptionModule = /*@__PURE__*/ (() => {
    class LinearGaugeCoreDescriptionModule extends Base {
        static register(a) {
            LinearGaugeDescriptionMetadata.d(a);
            LinearGraphRangeDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
        }
    }
    LinearGaugeCoreDescriptionModule.$t = /*@__PURE__*/ markType(LinearGaugeCoreDescriptionModule, 'LinearGaugeCoreDescriptionModule');
    return LinearGaugeCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGaugeDescriptionModule = /*@__PURE__*/ (() => {
    class LinearGaugeDescriptionModule extends Base {
        static register(a) {
            LinearGaugeCoreDescriptionModule.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    LinearGaugeDescriptionModule.$t = /*@__PURE__*/ markType(LinearGaugeDescriptionModule, 'LinearGaugeDescriptionModule');
    return LinearGaugeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnClosedEventArgsDescription = /*@__PURE__*/ (() => {
    class OnClosedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "OnClosedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    OnClosedEventArgsDescription.$t = /*@__PURE__*/ markType(OnClosedEventArgsDescription, 'OnClosedEventArgsDescription', Description.$);
    return OnClosedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnClosedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnClosedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnClosedEventArgsDescriptionMetadata.a == null) {
                OnClosedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnClosedEventArgsDescriptionMetadata.c(a, OnClosedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            OnClosedEventArgsDescriptionMetadata.b(a);
            a.q("OnClosedEventArgs", () => new OnClosedEventArgsDescription());
            a.p("OnClosedEventArgs", OnClosedEventArgsDescriptionMetadata.a);
        }
    }
    OnClosedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnClosedEventArgsDescriptionMetadata, 'OnClosedEventArgsDescriptionMetadata');
    OnClosedEventArgsDescriptionMetadata.a = null;
    return OnClosedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnPopupEventArgsDescription = /*@__PURE__*/ (() => {
    class OnPopupEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "OnPopupEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    OnPopupEventArgsDescription.$t = /*@__PURE__*/ markType(OnPopupEventArgsDescription, 'OnPopupEventArgsDescription', Description.$);
    return OnPopupEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnPopupEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class OnPopupEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (OnPopupEventArgsDescriptionMetadata.a == null) {
                OnPopupEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                OnPopupEventArgsDescriptionMetadata.c(a, OnPopupEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            OnPopupEventArgsDescriptionMetadata.b(a);
            a.q("OnPopupEventArgs", () => new OnPopupEventArgsDescription());
            a.p("OnPopupEventArgs", OnPopupEventArgsDescriptionMetadata.a);
        }
    }
    OnPopupEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(OnPopupEventArgsDescriptionMetadata, 'OnPopupEventArgsDescriptionMetadata');
    OnPopupEventArgsDescriptionMetadata.a = null;
    return OnPopupEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OverlayProxyDescriptionModule = /*@__PURE__*/ (() => {
    class OverlayProxyDescriptionModule extends Base {
        static register(a) {
        }
    }
    OverlayProxyDescriptionModule.$t = /*@__PURE__*/ markType(OverlayProxyDescriptionModule, 'OverlayProxyDescriptionModule');
    return OverlayProxyDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelClickEventArgsDescription = /*@__PURE__*/ (() => {
    class LabelClickEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = false;
        }
        get_type() {
            return "LabelClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get allowSliceClick() {
            return this.f;
        }
        set allowSliceClick(a) {
            this.f = a;
            this.e("AllowSliceClick");
        }
    }
    LabelClickEventArgsDescription.$t = /*@__PURE__*/ markType(LabelClickEventArgsDescription, 'LabelClickEventArgsDescription', Description.$);
    return LabelClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class LabelClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (LabelClickEventArgsDescriptionMetadata.a == null) {
                LabelClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LabelClickEventArgsDescriptionMetadata.c(a, LabelClickEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("AllowSliceClick", "Boolean");
        }
        static d(a) {
            LabelClickEventArgsDescriptionMetadata.b(a);
            a.q("LabelClickEventArgs", () => new LabelClickEventArgsDescription());
            a.p("LabelClickEventArgs", LabelClickEventArgsDescriptionMetadata.a);
        }
    }
    LabelClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(LabelClickEventArgsDescriptionMetadata, 'LabelClickEventArgsDescriptionMetadata');
    LabelClickEventArgsDescriptionMetadata.a = null;
    return LabelClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "SelectedItemChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get oldItem() {
            return this.g;
        }
        set oldItem(a) {
            this.g = a;
            this.e("OldItem");
        }
        get newItem() {
            return this.f;
        }
        set newItem(a) {
            this.f = a;
            this.e("NewItem");
        }
    }
    SelectedItemChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemChangedEventArgsDescription, 'SelectedItemChangedEventArgsDescription', Description.$);
    return SelectedItemChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemChangedEventArgsDescriptionMetadata.a == null) {
                SelectedItemChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemChangedEventArgsDescriptionMetadata.c(a, SelectedItemChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("OldItem", "Unknown");
            b.item("NewItem", "Unknown");
        }
        static d(a) {
            SelectedItemChangedEventArgsDescriptionMetadata.b(a);
            a.q("SelectedItemChangedEventArgs", () => new SelectedItemChangedEventArgsDescription());
            a.p("SelectedItemChangedEventArgs", SelectedItemChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemChangedEventArgsDescriptionMetadata, 'SelectedItemChangedEventArgsDescriptionMetadata');
    SelectedItemChangedEventArgsDescriptionMetadata.a = null;
    return SelectedItemChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemChangingEventArgsDescription extends SelectedItemChangedEventArgsDescription {
        constructor() {
            super();
            this.k = false;
        }
        get_type() {
            return "SelectedItemChangingEventArgs";
        }
        get cancel() {
            return this.k;
        }
        set cancel(a) {
            this.k = a;
            this.e("Cancel");
        }
    }
    SelectedItemChangingEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemChangingEventArgsDescription, 'SelectedItemChangingEventArgsDescription', SelectedItemChangedEventArgsDescription.$);
    return SelectedItemChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemChangingEventArgsDescriptionMetadata.a == null) {
                SelectedItemChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemChangingEventArgsDescriptionMetadata.c(a, SelectedItemChangingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SelectedItemChangedEventArgsDescriptionMetadata.c(a, b);
            b.item("Cancel", "Boolean");
        }
        static d(a) {
            SelectedItemChangingEventArgsDescriptionMetadata.b(a);
            a.q("SelectedItemChangingEventArgs", () => new SelectedItemChangingEventArgsDescription());
            a.p("SelectedItemChangingEventArgs", SelectedItemChangingEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemChangingEventArgsDescriptionMetadata, 'SelectedItemChangingEventArgsDescriptionMetadata');
    SelectedItemChangingEventArgsDescriptionMetadata.a = null;
    return SelectedItemChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemsChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "SelectedItemsChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get oldItems() {
            return this.h;
        }
        set oldItems(a) {
            this.h = a;
            this.e("OldItems");
        }
        get newItems() {
            return this.g;
        }
        set newItems(a) {
            this.g = a;
            this.e("NewItems");
        }
        get currentItems() {
            return this.f;
        }
        set currentItems(a) {
            this.f = a;
            this.e("CurrentItems");
        }
    }
    SelectedItemsChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemsChangedEventArgsDescription, 'SelectedItemsChangedEventArgsDescription', Description.$);
    return SelectedItemsChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemsChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemsChangedEventArgsDescriptionMetadata.a == null) {
                SelectedItemsChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemsChangedEventArgsDescriptionMetadata.c(a, SelectedItemsChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("OldItems", "Collection:object:ObjectCollection:Object");
            b.item("NewItems", "Collection:object:ObjectCollection:Object");
            b.item("CurrentItems", "Collection:object:ObjectCollection:Object");
        }
        static d(a) {
            SelectedItemsChangedEventArgsDescriptionMetadata.b(a);
            a.q("SelectedItemsChangedEventArgs", () => new SelectedItemsChangedEventArgsDescription());
            a.p("SelectedItemsChangedEventArgs", SelectedItemsChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemsChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemsChangedEventArgsDescriptionMetadata, 'SelectedItemsChangedEventArgsDescriptionMetadata');
    SelectedItemsChangedEventArgsDescriptionMetadata.a = null;
    return SelectedItemsChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangingEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectedItemsChangingEventArgsDescription extends SelectedItemsChangedEventArgsDescription {
        constructor() {
            super();
            this.m = false;
        }
        get_type() {
            return "SelectedItemsChangingEventArgs";
        }
        get cancel() {
            return this.m;
        }
        set cancel(a) {
            this.m = a;
            this.e("Cancel");
        }
    }
    SelectedItemsChangingEventArgsDescription.$t = /*@__PURE__*/ markType(SelectedItemsChangingEventArgsDescription, 'SelectedItemsChangingEventArgsDescription', SelectedItemsChangedEventArgsDescription.$);
    return SelectedItemsChangingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectedItemsChangingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectedItemsChangingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectedItemsChangingEventArgsDescriptionMetadata.a == null) {
                SelectedItemsChangingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectedItemsChangingEventArgsDescriptionMetadata.c(a, SelectedItemsChangingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SelectedItemsChangedEventArgsDescriptionMetadata.c(a, b);
            b.item("Cancel", "Boolean");
        }
        static d(a) {
            SelectedItemsChangingEventArgsDescriptionMetadata.b(a);
            a.q("SelectedItemsChangingEventArgs", () => new SelectedItemsChangingEventArgsDescription());
            a.p("SelectedItemsChangingEventArgs", SelectedItemsChangingEventArgsDescriptionMetadata.a);
        }
    }
    SelectedItemsChangingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectedItemsChangingEventArgsDescriptionMetadata, 'SelectedItemsChangingEventArgsDescriptionMetadata');
    SelectedItemsChangingEventArgsDescriptionMetadata.a = null;
    return SelectedItemsChangingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartBaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieChartBaseDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("TooltipTemplateRef", "(w:ToolTip)DataRef:String");
            b.item("DataSourceRef", "(w:ItemsSource)DataRef:String");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
        }
        static b(a) {
            if (PieChartBaseDescriptionMetadata.a == null) {
                PieChartBaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieChartBaseDescriptionMetadata.c(a, PieChartBaseDescriptionMetadata.a);
                LabelClickEventArgsDescriptionMetadata.d(a);
                SelectedItemChangingEventArgsDescriptionMetadata.d(a);
                SelectedItemsChangingEventArgsDescriptionMetadata.d(a);
                SelectedItemChangedEventArgsDescriptionMetadata.d(a);
                SelectedItemsChangedEventArgsDescriptionMetadata.d(a);
                SliceClickEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("DataSourceRef", "(w:ItemsSource,wf:ItemsSource)DataRef::object");
            b.item("InnerExtent", "Number:double");
            b.item("ValueMemberPath", "String");
            b.item("LabelMemberPath", "String");
            b.item("LegendLabelMemberPath", "String");
            b.item("LabelsPosition", "ExportedType:string:LabelsPosition");
            b.item("LabelsPosition@names", "None;Center;InsideEnd;OutsideEnd;BestFit");
            b.item("LabelOuterColor", "Brush");
            b.item("LabelInnerColor", "Brush");
            b.item("LeaderLineVisibility", "ExportedType:string:Visibility");
            b.item("LeaderLineVisibility@names", "Visible;Collapsed");
            b.item("LeaderLineType", "ExportedType:string:LeaderLineType");
            b.item("LeaderLineType@names", "Straight;Arc;Spline");
            b.item("LeaderLineMargin", "Number:double");
            b.item("OthersCategoryThreshold", "Number:double");
            b.item("OthersCategoryType", "ExportedType:string:OthersCategoryType");
            b.item("OthersCategoryType@names", "Number;Percent");
            b.item("OthersCategoryText", "String");
            b.item("ExplodedRadius", "Number:double");
            b.item("RadiusFactor", "Number:double");
            b.item("AllowSliceSelection", "Boolean");
            b.item("AllowSliceExplosion", "Boolean");
            b.item("ExplodedSlices", "Collection:int:IndexCollection:Int32");
            b.item("LegendRef", "(w:Legend,wf:Legend)DataRef::object");
            b.item("LabelExtent", "Number:double");
            b.item("StartAngle", "Number:double");
            b.item("SweepDirection", "ExportedType:string:SweepDirection");
            b.item("SweepDirection@names", "Counterclockwise;Clockwise");
            b.item("OthersCategoryFill", "(w:OthersCategoryStyle.Fill,wf:OthersCategoryFill)String");
            b.item("OthersCategoryStroke", "(w:OthersCategoryStyle.Stroke,wf:OthersCategoryStroke)String");
            b.item("OthersCategoryStrokeThickness", "(w:OthersCategoryStyle.StrokeThickness,wf:OthersCategoryStrokeThickness)Number:double");
            b.item("OthersCategoryOpacity", "(w:OthersCategoryStyle.Opacity,wf:OthersCategoryOpacity)Number:double");
            b.item("SelectedSliceFill", "(w:SelectedStyle.Fill,wf:SelectedSliceFill)String");
            b.item("SelectedSliceStroke", "(w:SelectedStyle.Stroke,wf:SelectedSliceStroke)String");
            b.item("SelectedSliceStrokeThickness", "(w:SelectedStyle.StrokeThickness,wf:SelectedSliceStrokeThickness)Number:double");
            b.item("SelectedSliceOpacity", "(w:SelectedStyle.Opacity,wf:SelectedSliceOpacity)Number:double");
            b.item("Brushes", "BrushCollection:string");
            b.item("Outlines", "BrushCollection:string");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("OthersLabelFormat", "String");
            b.item("OthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("LegendLabelFormat", "String");
            b.item("LegendLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("LegendOthersLabelFormat", "String");
            b.item("LegendOthersLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("LegendItemTemplateRef", "(w:LegendItemTemplate,wf:LegendItemTemplate)DataRef::object");
            b.item("LegendItemBadgeTemplateRef", "(w:LegendItemBadgeTemplate,wf:LegendItemBadgeTemplate)DataRef::object");
            b.item("IsSurfaceInteractionDisabled", "Boolean");
            b.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            b.item("FormatLegendLabelRef", "(w:FormatLegendLabel,wf:FormatLegendLabel)MethodRef");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("SelectionMode", "ExportedType:string:SliceSelectionMode");
            b.item("SelectionMode@names", "Manual;Single;Multiple");
            b.item("SelectedItem", "Unknown");
            b.item("SelectedItems", "Collection:object:ObjectCollection:Object");
            b.item("TextStyle", "String");
            b.item("LabelClickRef", "EventRef::labelClick");
            b.item("SelectedItemChangingRef", "EventRef::selectedItemChanging");
            b.item("SelectedItemsChangingRef", "EventRef::selectedItemsChanging");
            b.item("SelectedItemChangedRef", "EventRef::selectedItemChanged");
            b.item("SelectedItemsChangedRef", "EventRef::selectedItemsChanged");
            b.item("SliceClickRef", "EventRef::sliceClick");
            PieChartBaseDescriptionMetadata.e(a, b);
        }
        static d(a) {
            PieChartBaseDescriptionMetadata.b(a);
            a.p("PieChartBase", PieChartBaseDescriptionMetadata.a);
        }
    }
    PieChartBaseDescriptionMetadata.$t = /*@__PURE__*/ markType(PieChartBaseDescriptionMetadata, 'PieChartBaseDescriptionMetadata');
    PieChartBaseDescriptionMetadata.a = null;
    return PieChartBaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartBaseDescription = /*@__PURE__*/ (() => {
    class PieChartBaseDescription extends Description {
        constructor() {
            super();
            this.b4 = null;
            this.a6 = null;
            this.ad = 0;
            this.a8 = null;
            this.a7 = null;
            this.a5 = null;
            this.ae = 0;
            this.b5 = null;
            this.be = null;
            this.bm = null;
            this.bg = null;
            this.bf = null;
            this.bd = null;
            this.bi = null;
            this.bh = null;
            this.ag = 0;
            this.aj = 0;
            this.bs = null;
            this.br = null;
            this.ac = 0;
            this.al = 0;
            this.w = false;
            this.v = false;
            this.g = null;
            this.bo = null;
            this.af = 0;
            this.ao = 0;
            this.b2 = null;
            this.bp = null;
            this.bq = null;
            this.ai = 0;
            this.ah = 0;
            this.by = null;
            this.bz = null;
            this.an = 0;
            this.am = 0;
            this.f = null;
            this.l = null;
            this.bc = null;
            this.h = null;
            this.bt = null;
            this.k = null;
            this.bl = null;
            this.i = null;
            this.bn = null;
            this.j = null;
            this.bk = null;
            this.bj = null;
            this.x = false;
            this.a9 = null;
            this.ba = null;
            this.ak = 0;
            this.ab = 0;
            this.b0 = null;
            this.a3 = null;
            this.m = null;
            this.b3 = null;
            this.bb = null;
            this.bv = null;
            this.bx = null;
            this.bu = null;
            this.bw = null;
            this.b1 = null;
        }
        get tooltipTemplateRef() {
            return this.b4;
        }
        set tooltipTemplateRef(a) {
            this.b4 = a;
            this.e("TooltipTemplateRef");
        }
        get fontFamily() {
            return this.a6;
        }
        set fontFamily(a) {
            this.a6 = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.ad;
        }
        set fontSize(a) {
            this.ad = a;
            this.e("FontSize");
        }
        get fontWeight() {
            return this.a8;
        }
        set fontWeight(a) {
            this.a8 = a;
            this.e("FontWeight");
        }
        get fontStyle() {
            return this.a7;
        }
        set fontStyle(a) {
            this.a7 = a;
            this.e("FontStyle");
        }
        get_type() {
            return "PieChartBase";
        }
        get type() {
            return this.get_type();
        }
        get dataSourceRef() {
            return this.a5;
        }
        set dataSourceRef(a) {
            this.a5 = a;
            this.e("DataSourceRef");
        }
        get innerExtent() {
            return this.ae;
        }
        set innerExtent(a) {
            this.ae = a;
            this.e("InnerExtent");
        }
        get valueMemberPath() {
            return this.b5;
        }
        set valueMemberPath(a) {
            this.b5 = a;
            this.e("ValueMemberPath");
        }
        get labelMemberPath() {
            return this.be;
        }
        set labelMemberPath(a) {
            this.be = a;
            this.e("LabelMemberPath");
        }
        get legendLabelMemberPath() {
            return this.bm;
        }
        set legendLabelMemberPath(a) {
            this.bm = a;
            this.e("LegendLabelMemberPath");
        }
        get labelsPosition() {
            return this.bg;
        }
        set labelsPosition(a) {
            this.bg = a;
            this.e("LabelsPosition");
        }
        get labelOuterColor() {
            return this.bf;
        }
        set labelOuterColor(a) {
            this.bf = a;
            this.e("LabelOuterColor");
        }
        get labelInnerColor() {
            return this.bd;
        }
        set labelInnerColor(a) {
            this.bd = a;
            this.e("LabelInnerColor");
        }
        get leaderLineVisibility() {
            return this.bi;
        }
        set leaderLineVisibility(a) {
            this.bi = a;
            this.e("LeaderLineVisibility");
        }
        get leaderLineType() {
            return this.bh;
        }
        set leaderLineType(a) {
            this.bh = a;
            this.e("LeaderLineType");
        }
        get leaderLineMargin() {
            return this.ag;
        }
        set leaderLineMargin(a) {
            this.ag = a;
            this.e("LeaderLineMargin");
        }
        get othersCategoryThreshold() {
            return this.aj;
        }
        set othersCategoryThreshold(a) {
            this.aj = a;
            this.e("OthersCategoryThreshold");
        }
        get othersCategoryType() {
            return this.bs;
        }
        set othersCategoryType(a) {
            this.bs = a;
            this.e("OthersCategoryType");
        }
        get othersCategoryText() {
            return this.br;
        }
        set othersCategoryText(a) {
            this.br = a;
            this.e("OthersCategoryText");
        }
        get explodedRadius() {
            return this.ac;
        }
        set explodedRadius(a) {
            this.ac = a;
            this.e("ExplodedRadius");
        }
        get radiusFactor() {
            return this.al;
        }
        set radiusFactor(a) {
            this.al = a;
            this.e("RadiusFactor");
        }
        get allowSliceSelection() {
            return this.w;
        }
        set allowSliceSelection(a) {
            this.w = a;
            this.e("AllowSliceSelection");
        }
        get allowSliceExplosion() {
            return this.v;
        }
        set allowSliceExplosion(a) {
            this.v = a;
            this.e("AllowSliceExplosion");
        }
        get explodedSlices() {
            return this.g;
        }
        set explodedSlices(a) {
            this.g = a;
            this.e("ExplodedSlices");
        }
        get legendRef() {
            return this.bo;
        }
        set legendRef(a) {
            this.bo = a;
            this.e("LegendRef");
        }
        get labelExtent() {
            return this.af;
        }
        set labelExtent(a) {
            this.af = a;
            this.e("LabelExtent");
        }
        get startAngle() {
            return this.ao;
        }
        set startAngle(a) {
            this.ao = a;
            this.e("StartAngle");
        }
        get sweepDirection() {
            return this.b2;
        }
        set sweepDirection(a) {
            this.b2 = a;
            this.e("SweepDirection");
        }
        get othersCategoryFill() {
            return this.bp;
        }
        set othersCategoryFill(a) {
            this.bp = a;
            this.e("OthersCategoryFill");
        }
        get othersCategoryStroke() {
            return this.bq;
        }
        set othersCategoryStroke(a) {
            this.bq = a;
            this.e("OthersCategoryStroke");
        }
        get othersCategoryStrokeThickness() {
            return this.ai;
        }
        set othersCategoryStrokeThickness(a) {
            this.ai = a;
            this.e("OthersCategoryStrokeThickness");
        }
        get othersCategoryOpacity() {
            return this.ah;
        }
        set othersCategoryOpacity(a) {
            this.ah = a;
            this.e("OthersCategoryOpacity");
        }
        get selectedSliceFill() {
            return this.by;
        }
        set selectedSliceFill(a) {
            this.by = a;
            this.e("SelectedSliceFill");
        }
        get selectedSliceStroke() {
            return this.bz;
        }
        set selectedSliceStroke(a) {
            this.bz = a;
            this.e("SelectedSliceStroke");
        }
        get selectedSliceStrokeThickness() {
            return this.an;
        }
        set selectedSliceStrokeThickness(a) {
            this.an = a;
            this.e("SelectedSliceStrokeThickness");
        }
        get selectedSliceOpacity() {
            return this.am;
        }
        set selectedSliceOpacity(a) {
            this.am = a;
            this.e("SelectedSliceOpacity");
        }
        get brushes() {
            return this.f;
        }
        set brushes(a) {
            this.f = a;
            this.e("Brushes");
        }
        get outlines() {
            return this.l;
        }
        set outlines(a) {
            this.l = a;
            this.e("Outlines");
        }
        get labelFormat() {
            return this.bc;
        }
        set labelFormat(a) {
            this.bc = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.h;
        }
        set labelFormatSpecifiers(a) {
            this.h = a;
            this.e("LabelFormatSpecifiers");
        }
        get othersLabelFormat() {
            return this.bt;
        }
        set othersLabelFormat(a) {
            this.bt = a;
            this.e("OthersLabelFormat");
        }
        get othersLabelFormatSpecifiers() {
            return this.k;
        }
        set othersLabelFormatSpecifiers(a) {
            this.k = a;
            this.e("OthersLabelFormatSpecifiers");
        }
        get legendLabelFormat() {
            return this.bl;
        }
        set legendLabelFormat(a) {
            this.bl = a;
            this.e("LegendLabelFormat");
        }
        get legendLabelFormatSpecifiers() {
            return this.i;
        }
        set legendLabelFormatSpecifiers(a) {
            this.i = a;
            this.e("LegendLabelFormatSpecifiers");
        }
        get legendOthersLabelFormat() {
            return this.bn;
        }
        set legendOthersLabelFormat(a) {
            this.bn = a;
            this.e("LegendOthersLabelFormat");
        }
        get legendOthersLabelFormatSpecifiers() {
            return this.j;
        }
        set legendOthersLabelFormatSpecifiers(a) {
            this.j = a;
            this.e("LegendOthersLabelFormatSpecifiers");
        }
        get legendItemTemplateRef() {
            return this.bk;
        }
        set legendItemTemplateRef(a) {
            this.bk = a;
            this.e("LegendItemTemplateRef");
        }
        get legendItemBadgeTemplateRef() {
            return this.bj;
        }
        set legendItemBadgeTemplateRef(a) {
            this.bj = a;
            this.e("LegendItemBadgeTemplateRef");
        }
        get isSurfaceInteractionDisabled() {
            return this.x;
        }
        set isSurfaceInteractionDisabled(a) {
            this.x = a;
            this.e("IsSurfaceInteractionDisabled");
        }
        get formatLabelRef() {
            return this.a9;
        }
        set formatLabelRef(a) {
            this.a9 = a;
            this.e("FormatLabelRef");
        }
        get formatLegendLabelRef() {
            return this.ba;
        }
        set formatLegendLabelRef(a) {
            this.ba = a;
            this.e("FormatLegendLabelRef");
        }
        get pixelScalingRatio() {
            return this.ak;
        }
        set pixelScalingRatio(a) {
            this.ak = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.ab;
        }
        set actualPixelScalingRatio(a) {
            this.ab = a;
            this.e("ActualPixelScalingRatio");
        }
        get selectionMode() {
            return this.b0;
        }
        set selectionMode(a) {
            this.b0 = a;
            this.e("SelectionMode");
        }
        get selectedItem() {
            return this.a3;
        }
        set selectedItem(a) {
            this.a3 = a;
            this.e("SelectedItem");
        }
        get selectedItems() {
            return this.m;
        }
        set selectedItems(a) {
            this.m = a;
            this.e("SelectedItems");
        }
        get textStyle() {
            return this.b3;
        }
        set textStyle(a) {
            this.b3 = a;
            this.e("TextStyle");
        }
        get labelClickRef() {
            return this.bb;
        }
        set labelClickRef(a) {
            this.bb = a;
            this.e("LabelClickRef");
        }
        get selectedItemChangingRef() {
            return this.bv;
        }
        set selectedItemChangingRef(a) {
            this.bv = a;
            this.e("SelectedItemChangingRef");
        }
        get selectedItemsChangingRef() {
            return this.bx;
        }
        set selectedItemsChangingRef(a) {
            this.bx = a;
            this.e("SelectedItemsChangingRef");
        }
        get selectedItemChangedRef() {
            return this.bu;
        }
        set selectedItemChangedRef(a) {
            this.bu = a;
            this.e("SelectedItemChangedRef");
        }
        get selectedItemsChangedRef() {
            return this.bw;
        }
        set selectedItemsChangedRef(a) {
            this.bw = a;
            this.e("SelectedItemsChangedRef");
        }
        get sliceClickRef() {
            return this.b1;
        }
        set sliceClickRef(a) {
            this.b1 = a;
            this.e("SliceClickRef");
        }
    }
    PieChartBaseDescription.$t = /*@__PURE__*/ markType(PieChartBaseDescription, 'PieChartBaseDescription', Description.$);
    return PieChartBaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartDescription = /*@__PURE__*/ (() => {
    class PieChartDescription extends PieChartBaseDescription {
        constructor() {
            super();
            this.da = null;
            this.c9 = null;
            this.c8 = null;
        }
        get width() {
            return this.da;
        }
        set width(a) {
            this.da = a;
            this.e("Width");
        }
        get height() {
            return this.c9;
        }
        set height(a) {
            this.c9 = a;
            this.e("Height");
        }
        get background() {
            return this.c8;
        }
        set background(a) {
            this.c8 = a;
            this.e("Background");
        }
        get_type() {
            return "PieChart";
        }
    }
    PieChartDescription.$t = /*@__PURE__*/ markType(PieChartDescription, 'PieChartDescription', PieChartBaseDescription.$);
    return PieChartDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieChartDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamPieChart");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (PieChartDescriptionMetadata.a == null) {
                PieChartDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieChartDescriptionMetadata.c(a, PieChartDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            PieChartBaseDescriptionMetadata.c(a, b);
            PieChartDescriptionMetadata.e(a, b);
        }
        static d(a) {
            PieChartDescriptionMetadata.b(a);
            a.q("PieChart", () => new PieChartDescription());
            a.p("PieChart", PieChartDescriptionMetadata.a);
        }
    }
    PieChartDescriptionMetadata.$t = /*@__PURE__*/ markType(PieChartDescriptionMetadata, 'PieChartDescriptionMetadata');
    PieChartDescriptionMetadata.a = null;
    return PieChartDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartCoreDescriptionModule = /*@__PURE__*/ (() => {
    class PieChartCoreDescriptionModule extends Base {
        static register(a) {
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
            PieChartDescriptionMetadata.d(a);
        }
    }
    PieChartCoreDescriptionModule.$t = /*@__PURE__*/ markType(PieChartCoreDescriptionModule, 'PieChartCoreDescriptionModule');
    return PieChartCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieChartDescriptionModule = /*@__PURE__*/ (() => {
    class PieChartDescriptionModule extends Base {
        static register(a) {
            PieChartCoreDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
        }
    }
    PieChartDescriptionModule.$t = /*@__PURE__*/ markType(PieChartDescriptionModule, 'PieChartDescriptionModule');
    return PieChartDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PinnedAreaSeparatorDescriptionModule = /*@__PURE__*/ (() => {
    class PinnedAreaSeparatorDescriptionModule extends Base {
        static register(a) {
            PinnedAreaSeparatorDescriptionMetadata.d(a);
        }
    }
    PinnedAreaSeparatorDescriptionModule.$t = /*@__PURE__*/ markType(PinnedAreaSeparatorDescriptionModule, 'PinnedAreaSeparatorDescriptionModule');
    return PinnedAreaSeparatorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupDescription = /*@__PURE__*/ (() => {
    class PopupDescription extends Description {
        constructor() {
            super();
            this.i = 0;
            this.f = false;
            this.j = 0;
            this.h = 0;
            this.p = null;
            this.o = null;
            this.n = null;
            this.q = null;
            this.r = null;
            this.s = null;
        }
        get_type() {
            return "Popup";
        }
        get type() {
            return this.get_type();
        }
        get animationDuration() {
            return this.i;
        }
        set animationDuration(a) {
            this.i = a;
            this.e("AnimationDuration");
        }
        get animationEnabled() {
            return this.f;
        }
        set animationEnabled(a) {
            this.f = a;
            this.e("AnimationEnabled");
        }
        get elevation() {
            return this.j;
        }
        set elevation(a) {
            this.j = a;
            this.e("Elevation");
        }
        get actualElevation() {
            return this.h;
        }
        set actualElevation(a) {
            this.h = a;
            this.e("ActualElevation");
        }
        get actualUmbraShadowColor() {
            return this.p;
        }
        set actualUmbraShadowColor(a) {
            this.p = a;
            this.e("ActualUmbraShadowColor");
        }
        get actualPenumbraShadowColor() {
            return this.o;
        }
        set actualPenumbraShadowColor(a) {
            this.o = a;
            this.e("ActualPenumbraShadowColor");
        }
        get actualAmbientShadowColor() {
            return this.n;
        }
        set actualAmbientShadowColor(a) {
            this.n = a;
            this.e("ActualAmbientShadowColor");
        }
        get background() {
            return this.q;
        }
        set background(a) {
            this.q = a;
            this.e("Background");
        }
        get onClosedRef() {
            return this.r;
        }
        set onClosedRef(a) {
            this.r = a;
            this.e("OnClosedRef");
        }
        get onPopupRef() {
            return this.s;
        }
        set onPopupRef(a) {
            this.s = a;
            this.e("OnPopupRef");
        }
    }
    PopupDescription.$t = /*@__PURE__*/ markType(PopupDescription, 'PopupDescription', Description.$);
    return PopupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupDescriptionMetadata = /*@__PURE__*/ (() => {
    class PopupDescriptionMetadata extends Base {
        static b(a) {
            if (PopupDescriptionMetadata.a == null) {
                PopupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PopupDescriptionMetadata.c(a, PopupDescriptionMetadata.a);
                OnClosedEventArgsDescriptionMetadata.d(a);
                OnPopupEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("AnimationDuration", "Number:int");
            b.item("AnimationEnabled", "Boolean");
            b.item("Elevation", "Number:int");
            b.item("ActualElevation", "Number:int");
            b.item("ActualUmbraShadowColor", "Brush");
            b.item("ActualPenumbraShadowColor", "Brush");
            b.item("ActualAmbientShadowColor", "Brush");
            b.item("Background", "Brush");
            b.item("OnClosedRef", "EventRef::onClosed");
            b.item("OnPopupRef", "EventRef::onPopup");
        }
        static d(a) {
            PopupDescriptionMetadata.b(a);
            a.q("Popup", () => new PopupDescription());
            a.p("Popup", PopupDescriptionMetadata.a);
        }
    }
    PopupDescriptionMetadata.$t = /*@__PURE__*/ markType(PopupDescriptionMetadata, 'PopupDescriptionMetadata');
    PopupDescriptionMetadata.a = null;
    return PopupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupDescriptionModule = /*@__PURE__*/ (() => {
    class PopupDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            PopupDescriptionMetadata.d(a);
        }
    }
    PopupDescriptionModule.$t = /*@__PURE__*/ markType(PopupDescriptionModule, 'PopupDescriptionModule');
    return PopupDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrefixDescription = /*@__PURE__*/ (() => {
    class PrefixDescription extends InputGroupItemDescription {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.j = false;
            this.i = false;
        }
        get_type() {
            return "Prefix";
        }
        get id() {
            return this.n;
        }
        set id(a) {
            this.n = a;
            this.e("Id");
        }
        get ariaLabel() {
            return this.m;
        }
        set ariaLabel(a) {
            this.m = a;
            this.e("AriaLabel");
        }
        get isHover() {
            return this.j;
        }
        set isHover(a) {
            this.j = a;
            this.e("IsHover");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.e("Disabled");
        }
    }
    PrefixDescription.$t = /*@__PURE__*/ markType(PrefixDescription, 'PrefixDescription', InputGroupItemDescription.$);
    return PrefixDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrefixDescriptionMetadata = /*@__PURE__*/ (() => {
    class PrefixDescriptionMetadata extends Base {
        static b(a) {
            if (PrefixDescriptionMetadata.a == null) {
                PrefixDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PrefixDescriptionMetadata.c(a, PrefixDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            InputGroupItemDescriptionMetadata.c(a, b);
            b.item("Id", "String");
            b.item("AriaLabel", "String");
            b.item("IsHover", "Boolean");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            PrefixDescriptionMetadata.b(a);
            a.q("Prefix", () => new PrefixDescription());
            a.p("Prefix", PrefixDescriptionMetadata.a);
        }
    }
    PrefixDescriptionMetadata.$t = /*@__PURE__*/ markType(PrefixDescriptionMetadata, 'PrefixDescriptionMetadata');
    PrefixDescriptionMetadata.a = null;
    return PrefixDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrefixDescriptionModule = /*@__PURE__*/ (() => {
    class PrefixDescriptionModule extends Base {
        static register(a) {
            ChildContentDescriptionModule.register(a);
            PrefixDescriptionMetadata.d(a);
        }
    }
    PrefixDescriptionModule.$t = /*@__PURE__*/ markType(PrefixDescriptionModule, 'PrefixDescriptionModule');
    return PrefixDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescription = /*@__PURE__*/ (() => {
    class PropertyEditorDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
            this.ad = null;
            this.af = null;
            this.r = 0;
            this.w = null;
            this.p = 0;
            this.x = null;
            this.y = null;
            this.v = null;
            this.aa = null;
            this.ab = null;
            this.z = null;
            this.ag = null;
            this.ac = null;
            this.j = false;
            this.l = false;
            this.k = false;
            this.u = null;
            this.ah = null;
            this.ai = null;
            this.ae = null;
            this.t = null;
        }
        get_type() {
            return "PropertyEditor";
        }
        get type() {
            return this.get_type();
        }
        get actualDataSource() {
            return this.f;
        }
        set actualDataSource(a) {
            this.f = a;
            this.e("ActualDataSource");
        }
        get properties() {
            return this.g;
        }
        set properties(a) {
            this.g = a;
            this.e("Properties");
        }
        get filterPlaceholderText() {
            return this.ad;
        }
        set filterPlaceholderText(a) {
            this.ad = a;
            this.e("FilterPlaceholderText");
        }
        get searchInputType() {
            return this.af;
        }
        set searchInputType(a) {
            this.af = a;
            this.e("SearchInputType");
        }
        get rowHeight() {
            return this.r;
        }
        set rowHeight(a) {
            this.r = a;
            this.e("RowHeight");
        }
        get cellFontFamily() {
            return this.w;
        }
        set cellFontFamily(a) {
            this.w = a;
            this.e("CellFontFamily");
        }
        get cellFontSize() {
            return this.p;
        }
        set cellFontSize(a) {
            this.p = a;
            this.e("CellFontSize");
        }
        get cellFontStyle() {
            return this.x;
        }
        set cellFontStyle(a) {
            this.x = a;
            this.e("CellFontStyle");
        }
        get cellFontWeight() {
            return this.y;
        }
        set cellFontWeight(a) {
            this.y = a;
            this.e("CellFontWeight");
        }
        get baseTheme() {
            return this.v;
        }
        set baseTheme(a) {
            this.v = a;
            this.e("BaseTheme");
        }
        get density() {
            return this.aa;
        }
        set density(a) {
            this.aa = a;
            this.e("Density");
        }
        get descriptionContextRef() {
            return this.ab;
        }
        set descriptionContextRef(a) {
            this.ab = a;
            this.e("DescriptionContextRef");
        }
        get componentRendererRef() {
            return this.z;
        }
        set componentRendererRef(a) {
            this.z = a;
            this.e("ComponentRendererRef");
        }
        get targetRef() {
            return this.ag;
        }
        set targetRef(a) {
            this.ag = a;
            this.e("TargetRef");
        }
        get descriptionType() {
            return this.ac;
        }
        set descriptionType(a) {
            this.ac = a;
            this.e("DescriptionType");
        }
        get isHorizontal() {
            return this.j;
        }
        set isHorizontal(a) {
            this.j = a;
            this.e("IsHorizontal");
        }
        get isWrappingEnabled() {
            return this.l;
        }
        set isWrappingEnabled(a) {
            this.l = a;
            this.e("IsWrappingEnabled");
        }
        get isIndirectModeEnabled() {
            return this.k;
        }
        set isIndirectModeEnabled(a) {
            this.k = a;
            this.e("IsIndirectModeEnabled");
        }
        get backgroundColor() {
            return this.u;
        }
        set backgroundColor(a) {
            this.u = a;
            this.e("BackgroundColor");
        }
        get textColor() {
            return this.ah;
        }
        set textColor(a) {
            this.ah = a;
            this.e("TextColor");
        }
        get width() {
            return this.ai;
        }
        set width(a) {
            this.ai = a;
            this.e("Width");
        }
        get height() {
            return this.ae;
        }
        set height(a) {
            this.ae = a;
            this.e("Height");
        }
        get background() {
            return this.t;
        }
        set background(a) {
            this.t = a;
            this.e("Background");
        }
    }
    PropertyEditorDescription.$t = /*@__PURE__*/ markType(PropertyEditorDescription, 'PropertyEditorDescription', Description.$);
    return PropertyEditorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorDescriptionMetadata.a == null) {
                PropertyEditorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorDescriptionMetadata.c(a, PropertyEditorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ActualDataSource", "(w:ActualProperties,wf:ActualProperties)Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            b.item("Properties", "Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
            b.item("FilterPlaceholderText", "String");
            b.item("SearchInputType", "ExportedType:string:InputGroupDisplayType");
            b.item("SearchInputType@names", "Line;Box;Border;Search");
            b.item("RowHeight", "Number:int");
            b.item("CellFontFamily", "(w:CellFontFamily/FontFamilyTransform,wf:CellFontFamily,web:cellTextStyle/FontFamilyTransform)String");
            b.item("CellFontSize", "(w:CellFontSize,wf:CellFontSize,web:cellTextStyle/FontSizeTransform)Number:double");
            b.item("CellFontStyle", "(w:CellFontStyle/FontStyleTransform,wf:CellFontFamily/FontStyleTransform,web:cellTextStyle/FontStyleTransform)String");
            b.item("CellFontWeight", "(w:CellFontWeight/FontWeightTransform,wf:CellFontFamily/FontWeightTransform,web:cellTextStyle/FontWeightTransform)String");
            b.item("BaseTheme", "ExportedType:string:BaseControlTheme");
            b.item("BaseTheme@names", "Default;DenaliLight;MaterialLight");
            b.item("Density", "ExportedType:string:ControlDisplayDensity");
            b.item("Density@names", "Auto;Comfortable;Cosy;Compact");
            b.item("DescriptionContextRef", "(w:DescriptionContext,wf:DescriptionContext)DataRef::object");
            b.item("ComponentRendererRef", "(w:ComponentRenderer,wf:ComponentRenderer)DataRef::object");
            b.item("TargetRef", "(w:Target,wf:Target)DataRef::object");
            b.item("DescriptionType", "String");
            b.item("IsHorizontal", "Boolean");
            b.item("IsWrappingEnabled", "Boolean");
            b.item("IsIndirectModeEnabled", "Boolean");
            b.item("BackgroundColor", "Brush");
            b.item("TextColor", "Brush");
            PropertyEditorDescriptionMetadata.e(a, b);
        }
        static d(a) {
            PropertyEditorDescriptionMetadata.b(a);
            a.q("PropertyEditor", () => new PropertyEditorDescription());
            a.p("PropertyEditor", PropertyEditorDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Grids.XamPropertyEditor");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    PropertyEditorDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionMetadata, 'PropertyEditorDescriptionMetadata');
    PropertyEditorDescriptionMetadata.a = null;
    return PropertyEditorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDataSourceDescription = /*@__PURE__*/ (() => {
    class PropertyEditorDataSourceDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "PropertyEditorDataSource";
        }
        get type() {
            return this.get_type();
        }
        get descriptionType() {
            return this.g;
        }
        set descriptionType(a) {
            this.g = a;
            this.e("DescriptionType");
        }
        get contextRef() {
            return this.f;
        }
        set contextRef(a) {
            this.f = a;
            this.e("ContextRef");
        }
    }
    PropertyEditorDataSourceDescription.$t = /*@__PURE__*/ markType(PropertyEditorDataSourceDescription, 'PropertyEditorDataSourceDescription', Description.$);
    return PropertyEditorDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorDataSourceDescriptionMetadata.a == null) {
                PropertyEditorDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorDataSourceDescriptionMetadata.c(a, PropertyEditorDataSourceDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("DescriptionType", "String");
            b.item("ContextRef", "(w:Context,wf:Context)DataRef::object");
        }
        static d(a) {
            PropertyEditorDataSourceDescriptionMetadata.b(a);
            a.q("PropertyEditorDataSource", () => new PropertyEditorDataSourceDescription());
            a.p("PropertyEditorDataSource", PropertyEditorDataSourceDescriptionMetadata.a);
        }
    }
    PropertyEditorDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorDataSourceDescriptionMetadata, 'PropertyEditorDataSourceDescriptionMetadata');
    PropertyEditorDataSourceDescriptionMetadata.a = null;
    return PropertyEditorDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionObjectDescription = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionObjectDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.f = null;
        }
        get_type() {
            return "PropertyEditorDescriptionObject";
        }
        get type() {
            return this.get_type();
        }
        get descriptionType() {
            return this.h;
        }
        set descriptionType(a) {
            this.h = a;
            this.e("DescriptionType");
        }
        get properties() {
            return this.f;
        }
        set properties(a) {
            this.f = a;
            this.e("Properties");
        }
    }
    PropertyEditorDescriptionObjectDescription.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionObjectDescription, 'PropertyEditorDescriptionObjectDescription', Description.$);
    return PropertyEditorDescriptionObjectDescription;
})();
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionDescription extends Description {
        constructor() {
            super();
            this.w = null;
            this.u = null;
            this.y = null;
            this.v = null;
            this.n = false;
            this.t = null;
            this.g = null;
            this.h = null;
            this.p = null;
            this.l = null;
            this.f = null;
            this.r = null;
            this.s = null;
            this.x = null;
        }
        get_type() {
            return "PropertyEditorPropertyDescription";
        }
        get type() {
            return this.get_type();
        }
        get propertyPath() {
            return this.w;
        }
        set propertyPath(a) {
            this.w = a;
            this.e("PropertyPath");
        }
        get label() {
            return this.u;
        }
        set label(a) {
            this.u = a;
            this.e("Label");
        }
        get valueType() {
            return this.y;
        }
        set valueType(a) {
            this.y = a;
            this.e("ValueType");
        }
        get propertyDescriptionType() {
            return this.v;
        }
        set propertyDescriptionType(a) {
            this.v = a;
            this.e("PropertyDescriptionType");
        }
        get shouldOverrideDefaultEditor() {
            return this.n;
        }
        set shouldOverrideDefaultEditor(a) {
            this.n = a;
            this.e("ShouldOverrideDefaultEditor");
        }
        get elementDescriptionType() {
            return this.t;
        }
        set elementDescriptionType(a) {
            this.t = a;
            this.e("ElementDescriptionType");
        }
        get dropDownNames() {
            return this.g;
        }
        set dropDownNames(a) {
            this.g = a;
            this.e("DropDownNames");
        }
        get dropDownValues() {
            return this.h;
        }
        set dropDownValues(a) {
            this.h = a;
            this.e("DropDownValues");
        }
        get primitiveValue() {
            return this.p;
        }
        set primitiveValue(a) {
            this.p = a;
            this.e("PrimitiveValue");
        }
        get complexValue() {
            return this.l;
        }
        set complexValue(a) {
            this.l = a;
            this.e("ComplexValue");
        }
        get complexValues() {
            return this.f;
        }
        set complexValues(a) {
            this.f = a;
            this.e("ComplexValues");
        }
        get buttonClickedRef() {
            return this.r;
        }
        set buttonClickedRef(a) {
            this.r = a;
            this.e("ButtonClickedRef");
        }
        get changedRef() {
            return this.s;
        }
        set changedRef(a) {
            this.s = a;
            this.e("ChangedRef");
        }
        get targetPropertyUpdatingRef() {
            return this.x;
        }
        set targetPropertyUpdatingRef(a) {
            this.x = a;
            this.e("TargetPropertyUpdatingRef");
        }
    }
    PropertyEditorPropertyDescriptionDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionDescription, 'PropertyEditorPropertyDescriptionDescription', Description.$);
    return PropertyEditorPropertyDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionObjectDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionObjectDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorDescriptionObjectDescriptionMetadata.a == null) {
                PropertyEditorDescriptionObjectDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorDescriptionObjectDescriptionMetadata.c(a, PropertyEditorDescriptionObjectDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("DescriptionType", "String");
            b.item("Properties", "Collection:PropertyEditorPropertyDescription:PropertyEditorPropertyDescriptionCollection:PropertyEditorPropertyDescription");
        }
        static d(a) {
            PropertyEditorDescriptionObjectDescriptionMetadata.b(a);
            a.q("PropertyEditorDescriptionObject", () => new PropertyEditorDescriptionObjectDescription());
            a.p("PropertyEditorDescriptionObject", PropertyEditorDescriptionObjectDescriptionMetadata.a);
        }
    }
    PropertyEditorDescriptionObjectDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionObjectDescriptionMetadata, 'PropertyEditorDescriptionObjectDescriptionMetadata');
    PropertyEditorDescriptionObjectDescriptionMetadata.a = null;
    return PropertyEditorDescriptionObjectDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionButtonClickEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionButtonClickEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "PropertyEditorPropertyDescriptionButtonClickEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    PropertyEditorPropertyDescriptionButtonClickEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionButtonClickEventArgsDescription, 'PropertyEditorPropertyDescriptionButtonClickEventArgsDescription', Description.$);
    return PropertyEditorPropertyDescriptionButtonClickEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.c(a, PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.b(a);
            a.q("PropertyEditorPropertyDescriptionButtonClickEventArgs", () => new PropertyEditorPropertyDescriptionButtonClickEventArgsDescription());
            a.p("PropertyEditorPropertyDescriptionButtonClickEventArgs", PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata, 'PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata');
    PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "PropertyEditorPropertyDescriptionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    PropertyEditorPropertyDescriptionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionChangedEventArgsDescription, 'PropertyEditorPropertyDescriptionChangedEventArgsDescription', Description.$);
    return PropertyEditorPropertyDescriptionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.c(a, PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.b(a);
            a.q("PropertyEditorPropertyDescriptionChangedEventArgs", () => new PropertyEditorPropertyDescriptionChangedEventArgsDescription());
            a.p("PropertyEditorPropertyDescriptionChangedEventArgs", PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata, 'PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata');
    PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.h = null;
            this.f = null;
        }
        get_type() {
            return "PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get targetRef() {
            return this.g;
        }
        set targetRef(a) {
            this.g = a;
            this.e("TargetRef");
        }
        get valueRef() {
            return this.h;
        }
        set valueRef(a) {
            this.h = a;
            this.e("ValueRef");
        }
        get propertyPath() {
            return this.f;
        }
        set propertyPath(a) {
            this.f = a;
            this.e("PropertyPath");
        }
    }
    PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription, 'PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription', Description.$);
    return PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.c(a, PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TargetRef", "(w:Target,wf:Target)DataRef");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("PropertyPath", "String");
        }
        static d(a) {
            PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs", () => new PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription());
            a.p("PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs", PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata, 'PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata');
    PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (PropertyEditorPropertyDescriptionDescriptionMetadata.a == null) {
                PropertyEditorPropertyDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PropertyEditorPropertyDescriptionDescriptionMetadata.c(a, PropertyEditorPropertyDescriptionDescriptionMetadata.a);
                PropertyEditorDescriptionObjectDescriptionMetadata.d(a);
                PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata.d(a);
                PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata.d(a);
                PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("PropertyPath", "String");
            b.item("Label", "String");
            b.item("ValueType", "ExportedType:string:PropertyEditorValueType");
            b.item("ValueType@names", "Unhandled;Number;StringValue;Date;Brush;Color;BrushCollection;Boolean1;SubType;Collection;Array;Point;Size;Rect;ColorCollection;EnumValue;MethodRef;EventRef;DataRef;TimeSpan;Button");
            b.item("PropertyDescriptionType", "String");
            b.item("ShouldOverrideDefaultEditor", "Boolean");
            b.item("ElementDescriptionType", "String");
            b.item("DropDownNames", "Array:string");
            b.item("DropDownValues", "Array:string");
            b.item("PrimitiveValue", "Unknown");
            b.item("ComplexValue", "ExportedType:PropertyEditorDescriptionObject");
            b.item("ComplexValues", "Collection:PropertyEditorDescriptionObject:PropertyEditorDescriptionObjectCollection:PropertyEditorDescriptionObject");
            b.item("ButtonClickedRef", "EventRef::buttonClicked");
            b.item("ChangedRef", "EventRef::changed");
            b.item("TargetPropertyUpdatingRef", "EventRef::targetPropertyUpdating");
        }
        static d(a) {
            PropertyEditorPropertyDescriptionDescriptionMetadata.b(a);
            a.q("PropertyEditorPropertyDescription", () => new PropertyEditorPropertyDescriptionDescription());
            a.p("PropertyEditorPropertyDescription", PropertyEditorPropertyDescriptionDescriptionMetadata.a);
        }
    }
    PropertyEditorPropertyDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionDescriptionMetadata, 'PropertyEditorPropertyDescriptionDescriptionMetadata');
    PropertyEditorPropertyDescriptionDescriptionMetadata.a = null;
    return PropertyEditorPropertyDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorPropertyDescriptionDescriptionModule = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionDescriptionModule extends Base {
        static register(a) {
            PropertyEditorPropertyDescriptionDescriptionMetadata.d(a);
        }
    }
    PropertyEditorPropertyDescriptionDescriptionModule.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionDescriptionModule, 'PropertyEditorPropertyDescriptionDescriptionModule');
    return PropertyEditorPropertyDescriptionDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyEditorDescriptionModule = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionModule extends Base {
        static register(a) {
            InputGroupDescriptionModule.register(a);
            CheckboxDescriptionModule.register(a);
            ButtonDescriptionModule.register(a);
            DataGridCoreDescriptionModule.register(a);
            MultiColumnComboBoxDescriptionModule.register(a);
            NumericColumnDescriptionModule.register(a);
            DateTimeColumnDescriptionModule.register(a);
            ImageColumnDescriptionModule.register(a);
            TextColumnDescriptionModule.register(a);
            TemplateColumnDescriptionModule.register(a);
            PropertyEditorPropertyDescriptionDescriptionModule.register(a);
            PropertyEditorDescriptionMetadata.d(a);
        }
    }
    PropertyEditorDescriptionModule.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionModule, 'PropertyEditorDescriptionModule');
    return PropertyEditorDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatRadialGaugeLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class FormatRadialGaugeLabelEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "FormatRadialGaugeLabelEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    FormatRadialGaugeLabelEventArgsDescription.$t = /*@__PURE__*/ markType(FormatRadialGaugeLabelEventArgsDescription, 'FormatRadialGaugeLabelEventArgsDescription', Description.$);
    return FormatRadialGaugeLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FormatRadialGaugeLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class FormatRadialGaugeLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (FormatRadialGaugeLabelEventArgsDescriptionMetadata.a == null) {
                FormatRadialGaugeLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                FormatRadialGaugeLabelEventArgsDescriptionMetadata.c(a, FormatRadialGaugeLabelEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            FormatRadialGaugeLabelEventArgsDescriptionMetadata.b(a);
            a.q("FormatRadialGaugeLabelEventArgs", () => new FormatRadialGaugeLabelEventArgsDescription());
            a.p("FormatRadialGaugeLabelEventArgs", FormatRadialGaugeLabelEventArgsDescriptionMetadata.a);
        }
    }
    FormatRadialGaugeLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(FormatRadialGaugeLabelEventArgsDescriptionMetadata, 'FormatRadialGaugeLabelEventArgsDescriptionMetadata');
    FormatRadialGaugeLabelEventArgsDescriptionMetadata.a = null;
    return FormatRadialGaugeLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignRadialGaugeLabelEventArgsDescription = /*@__PURE__*/ (() => {
    class AlignRadialGaugeLabelEventArgsDescription extends FormatRadialGaugeLabelEventArgsDescription {
        constructor() {
            super();
        }
        get_type() {
            return "AlignRadialGaugeLabelEventArgs";
        }
    }
    AlignRadialGaugeLabelEventArgsDescription.$t = /*@__PURE__*/ markType(AlignRadialGaugeLabelEventArgsDescription, 'AlignRadialGaugeLabelEventArgsDescription', FormatRadialGaugeLabelEventArgsDescription.$);
    return AlignRadialGaugeLabelEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AlignRadialGaugeLabelEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class AlignRadialGaugeLabelEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (AlignRadialGaugeLabelEventArgsDescriptionMetadata.a == null) {
                AlignRadialGaugeLabelEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AlignRadialGaugeLabelEventArgsDescriptionMetadata.c(a, AlignRadialGaugeLabelEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            FormatRadialGaugeLabelEventArgsDescriptionMetadata.c(a, b);
        }
        static d(a) {
            AlignRadialGaugeLabelEventArgsDescriptionMetadata.b(a);
            a.q("AlignRadialGaugeLabelEventArgs", () => new AlignRadialGaugeLabelEventArgsDescription());
            a.p("AlignRadialGaugeLabelEventArgs", AlignRadialGaugeLabelEventArgsDescriptionMetadata.a);
        }
    }
    AlignRadialGaugeLabelEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(AlignRadialGaugeLabelEventArgsDescriptionMetadata, 'AlignRadialGaugeLabelEventArgsDescriptionMetadata');
    AlignRadialGaugeLabelEventArgsDescriptionMetadata.a = null;
    return AlignRadialGaugeLabelEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeDescription = /*@__PURE__*/ (() => {
    class RadialGaugeDescription extends Description {
        constructor() {
            super();
            this.ct = null;
            this.ab = 0;
            this.cv = null;
            this.cu = null;
            this.dc = null;
            this.cx = null;
            this.cm = null;
            this.g = null;
            this.h = null;
            this.ag = 0;
            this.s = 0;
            this.af = 0;
            this.r = 0;
            this.ac = 0;
            this.z = 0;
            this.aa = 0;
            this.a8 = 0;
            this.a2 = 0;
            this.az = 0;
            this.c8 = null;
            this.ch = 0;
            this.da = null;
            this.c0 = null;
            this.c1 = null;
            this.au = 0;
            this.an = 0;
            this.c5 = null;
            this.av = 0;
            this.ao = 0;
            this.am = 0;
            this.al = 0;
            this.at = 0;
            this.as = 0;
            this.ar = 0;
            this.ap = 0;
            this.c4 = null;
            this.a3 = 0;
            this.c2 = null;
            this.c3 = null;
            this.aw = 0;
            this.aq = 0;
            this.a0 = 0;
            this.ad = 0;
            this.ae = 0;
            this.a5 = 0;
            this.a4 = 0;
            this.a6 = 0;
            this.c9 = null;
            this.cs = null;
            this.aj = 0;
            this.ai = 0;
            this.ak = 0;
            this.cz = null;
            this.ah = 0;
            this.c6 = null;
            this.cn = null;
            this.co = null;
            this.y = 0;
            this.w = 0;
            this.x = 0;
            this.a1 = 0;
            this.c7 = null;
            this.u = 0;
            this.v = 0;
            this.cp = null;
            this.i = null;
            this.ay = 0;
            this.cq = null;
            this.o = false;
            this.n = false;
            this.cr = null;
            this.cy = null;
            this.f = null;
            this.a7 = 0;
            this.ax = 0;
            this.t = 0;
            this.cw = null;
            this.cl = null;
            this.db = null;
            this.ck = null;
            this.cj = null;
        }
        get fontFamily() {
            return this.ct;
        }
        set fontFamily(a) {
            this.ct = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.ab;
        }
        set fontSize(a) {
            this.ab = a;
            this.e("FontSize");
        }
        get fontWeight() {
            return this.cv;
        }
        set fontWeight(a) {
            this.cv = a;
            this.e("FontWeight");
        }
        get fontStyle() {
            return this.cu;
        }
        set fontStyle(a) {
            this.cu = a;
            this.e("FontStyle");
        }
        get width() {
            return this.dc;
        }
        set width(a) {
            this.dc = a;
            this.e("Width");
        }
        get height() {
            return this.cx;
        }
        set height(a) {
            this.cx = a;
            this.e("Height");
        }
        get background() {
            return this.cm;
        }
        set background(a) {
            this.cm = a;
            this.e("Background");
        }
        get_type() {
            return "RadialGauge";
        }
        get type() {
            return this.get_type();
        }
        get rangeBrushes() {
            return this.g;
        }
        set rangeBrushes(a) {
            this.g = a;
            this.e("RangeBrushes");
        }
        get rangeOutlines() {
            return this.h;
        }
        set rangeOutlines(a) {
            this.h = a;
            this.e("RangeOutlines");
        }
        get minimumValue() {
            return this.ag;
        }
        set minimumValue(a) {
            this.ag = a;
            this.e("MinimumValue");
        }
        get actualMinimumValue() {
            return this.s;
        }
        set actualMinimumValue(a) {
            this.s = a;
            this.e("ActualMinimumValue");
        }
        get maximumValue() {
            return this.af;
        }
        set maximumValue(a) {
            this.af = a;
            this.e("MaximumValue");
        }
        get actualMaximumValue() {
            return this.r;
        }
        set actualMaximumValue(a) {
            this.r = a;
            this.e("ActualMaximumValue");
        }
        get interval() {
            return this.ac;
        }
        set interval(a) {
            this.ac = a;
            this.e("Interval");
        }
        get centerX() {
            return this.z;
        }
        set centerX(a) {
            this.z = a;
            this.e("CenterX");
        }
        get centerY() {
            return this.aa;
        }
        set centerY(a) {
            this.aa = a;
            this.e("CenterY");
        }
        get value() {
            return this.a8;
        }
        set value(a) {
            this.a8 = a;
            this.e("Value");
        }
        get scaleStartAngle() {
            return this.a2;
        }
        set scaleStartAngle(a) {
            this.a2 = a;
            this.e("ScaleStartAngle");
        }
        get scaleEndAngle() {
            return this.az;
        }
        set scaleEndAngle(a) {
            this.az = a;
            this.e("ScaleEndAngle");
        }
        get scaleSweepDirection() {
            return this.c8;
        }
        set scaleSweepDirection(a) {
            this.c8 = a;
            this.e("ScaleSweepDirection");
        }
        get transitionDuration() {
            return this.ch;
        }
        set transitionDuration(a) {
            this.ch = a;
            this.e("TransitionDuration");
        }
        get transitionEasingFunctionRef() {
            return this.da;
        }
        set transitionEasingFunctionRef(a) {
            this.da = a;
            this.e("TransitionEasingFunctionRef");
        }
        get needleBrush() {
            return this.c0;
        }
        set needleBrush(a) {
            this.c0 = a;
            this.e("NeedleBrush");
        }
        get needleOutline() {
            return this.c1;
        }
        set needleOutline(a) {
            this.c1 = a;
            this.e("NeedleOutline");
        }
        get needleStartExtent() {
            return this.au;
        }
        set needleStartExtent(a) {
            this.au = a;
            this.e("NeedleStartExtent");
        }
        get needleEndExtent() {
            return this.an;
        }
        set needleEndExtent(a) {
            this.an = a;
            this.e("NeedleEndExtent");
        }
        get needleShape() {
            return this.c5;
        }
        set needleShape(a) {
            this.c5 = a;
            this.e("NeedleShape");
        }
        get needleStartWidthRatio() {
            return this.av;
        }
        set needleStartWidthRatio(a) {
            this.av = a;
            this.e("NeedleStartWidthRatio");
        }
        get needleEndWidthRatio() {
            return this.ao;
        }
        set needleEndWidthRatio(a) {
            this.ao = a;
            this.e("NeedleEndWidthRatio");
        }
        get needleBaseFeatureWidthRatio() {
            return this.am;
        }
        set needleBaseFeatureWidthRatio(a) {
            this.am = a;
            this.e("NeedleBaseFeatureWidthRatio");
        }
        get needleBaseFeatureExtent() {
            return this.al;
        }
        set needleBaseFeatureExtent(a) {
            this.al = a;
            this.e("NeedleBaseFeatureExtent");
        }
        get needlePointFeatureWidthRatio() {
            return this.at;
        }
        set needlePointFeatureWidthRatio(a) {
            this.at = a;
            this.e("NeedlePointFeatureWidthRatio");
        }
        get needlePointFeatureExtent() {
            return this.as;
        }
        set needlePointFeatureExtent(a) {
            this.as = a;
            this.e("NeedlePointFeatureExtent");
        }
        get needlePivotWidthRatio() {
            return this.ar;
        }
        set needlePivotWidthRatio(a) {
            this.ar = a;
            this.e("NeedlePivotWidthRatio");
        }
        get needlePivotInnerWidthRatio() {
            return this.ap;
        }
        set needlePivotInnerWidthRatio(a) {
            this.ap = a;
            this.e("NeedlePivotInnerWidthRatio");
        }
        get needlePivotShape() {
            return this.c4;
        }
        set needlePivotShape(a) {
            this.c4 = a;
            this.e("NeedlePivotShape");
        }
        get scaleStartExtent() {
            return this.a3;
        }
        set scaleStartExtent(a) {
            this.a3 = a;
            this.e("ScaleStartExtent");
        }
        get needlePivotBrush() {
            return this.c2;
        }
        set needlePivotBrush(a) {
            this.c2 = a;
            this.e("NeedlePivotBrush");
        }
        get needlePivotOutline() {
            return this.c3;
        }
        set needlePivotOutline(a) {
            this.c3 = a;
            this.e("NeedlePivotOutline");
        }
        get needleStrokeThickness() {
            return this.aw;
        }
        set needleStrokeThickness(a) {
            this.aw = a;
            this.e("NeedleStrokeThickness");
        }
        get needlePivotStrokeThickness() {
            return this.aq;
        }
        set needlePivotStrokeThickness(a) {
            this.aq = a;
            this.e("NeedlePivotStrokeThickness");
        }
        get scaleEndExtent() {
            return this.a0;
        }
        set scaleEndExtent(a) {
            this.a0 = a;
            this.e("ScaleEndExtent");
        }
        get labelExtent() {
            return this.ad;
        }
        set labelExtent(a) {
            this.ad = a;
            this.e("LabelExtent");
        }
        get labelInterval() {
            return this.ae;
        }
        set labelInterval(a) {
            this.ae = a;
            this.e("LabelInterval");
        }
        get tickStartExtent() {
            return this.a5;
        }
        set tickStartExtent(a) {
            this.a5 = a;
            this.e("TickStartExtent");
        }
        get tickEndExtent() {
            return this.a4;
        }
        set tickEndExtent(a) {
            this.a4 = a;
            this.e("TickEndExtent");
        }
        get tickStrokeThickness() {
            return this.a6;
        }
        set tickStrokeThickness(a) {
            this.a6 = a;
            this.e("TickStrokeThickness");
        }
        get tickBrush() {
            return this.c9;
        }
        set tickBrush(a) {
            this.c9 = a;
            this.e("TickBrush");
        }
        get fontBrush() {
            return this.cs;
        }
        set fontBrush(a) {
            this.cs = a;
            this.e("FontBrush");
        }
        get minorTickStartExtent() {
            return this.aj;
        }
        set minorTickStartExtent(a) {
            this.aj = a;
            this.e("MinorTickStartExtent");
        }
        get minorTickEndExtent() {
            return this.ai;
        }
        set minorTickEndExtent(a) {
            this.ai = a;
            this.e("MinorTickEndExtent");
        }
        get minorTickStrokeThickness() {
            return this.ak;
        }
        set minorTickStrokeThickness(a) {
            this.ak = a;
            this.e("MinorTickStrokeThickness");
        }
        get minorTickBrush() {
            return this.cz;
        }
        set minorTickBrush(a) {
            this.cz = a;
            this.e("MinorTickBrush");
        }
        get minorTickCount() {
            return this.ah;
        }
        set minorTickCount(a) {
            this.ah = a;
            this.e("MinorTickCount");
        }
        get scaleBrush() {
            return this.c6;
        }
        set scaleBrush(a) {
            this.c6 = a;
            this.e("ScaleBrush");
        }
        get backingBrush() {
            return this.cn;
        }
        set backingBrush(a) {
            this.cn = a;
            this.e("BackingBrush");
        }
        get backingOutline() {
            return this.co;
        }
        set backingOutline(a) {
            this.co = a;
            this.e("BackingOutline");
        }
        get backingStrokeThickness() {
            return this.y;
        }
        set backingStrokeThickness(a) {
            this.y = a;
            this.e("BackingStrokeThickness");
        }
        get backingOuterExtent() {
            return this.w;
        }
        set backingOuterExtent(a) {
            this.w = a;
            this.e("BackingOuterExtent");
        }
        get backingOversweep() {
            return this.x;
        }
        set backingOversweep(a) {
            this.x = a;
            this.e("BackingOversweep");
        }
        get scaleOversweep() {
            return this.a1;
        }
        set scaleOversweep(a) {
            this.a1 = a;
            this.e("ScaleOversweep");
        }
        get scaleOversweepShape() {
            return this.c7;
        }
        set scaleOversweepShape(a) {
            this.c7 = a;
            this.e("ScaleOversweepShape");
        }
        get backingCornerRadius() {
            return this.u;
        }
        set backingCornerRadius(a) {
            this.u = a;
            this.e("BackingCornerRadius");
        }
        get backingInnerExtent() {
            return this.v;
        }
        set backingInnerExtent(a) {
            this.v = a;
            this.e("BackingInnerExtent");
        }
        get backingShape() {
            return this.cp;
        }
        set backingShape(a) {
            this.cp = a;
            this.e("BackingShape");
        }
        get ranges() {
            return this.i;
        }
        set ranges(a) {
            this.i = a;
            this.e("Ranges");
        }
        get radiusMultiplier() {
            return this.ay;
        }
        set radiusMultiplier(a) {
            this.ay = a;
            this.e("RadiusMultiplier");
        }
        get duplicateLabelOmissionStrategy() {
            return this.cq;
        }
        set duplicateLabelOmissionStrategy(a) {
            this.cq = a;
            this.e("DuplicateLabelOmissionStrategy");
        }
        get isNeedleDraggingEnabled() {
            return this.o;
        }
        set isNeedleDraggingEnabled(a) {
            this.o = a;
            this.e("IsNeedleDraggingEnabled");
        }
        get isNeedleDraggingConstrained() {
            return this.n;
        }
        set isNeedleDraggingConstrained(a) {
            this.n = a;
            this.e("IsNeedleDraggingConstrained");
        }
        get font() {
            return this.cr;
        }
        set font(a) {
            this.cr = a;
            this.e("Font");
        }
        get labelFormat() {
            return this.cy;
        }
        set labelFormat(a) {
            this.cy = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.f;
        }
        set labelFormatSpecifiers(a) {
            this.f = a;
            this.e("LabelFormatSpecifiers");
        }
        get transitionProgress() {
            return this.a7;
        }
        set transitionProgress(a) {
            this.a7 = a;
            this.e("TransitionProgress");
        }
        get pixelScalingRatio() {
            return this.ax;
        }
        set pixelScalingRatio(a) {
            this.ax = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.t;
        }
        set actualPixelScalingRatio(a) {
            this.t = a;
            this.e("ActualPixelScalingRatio");
        }
        get formatLabelRef() {
            return this.cw;
        }
        set formatLabelRef(a) {
            this.cw = a;
            this.e("FormatLabelRef");
        }
        get alignLabelRef() {
            return this.cl;
        }
        set alignLabelRef(a) {
            this.cl = a;
            this.e("AlignLabelRef");
        }
        get valueChangedRef() {
            return this.db;
        }
        set valueChangedRef(a) {
            this.db = a;
            this.e("ValueChangedRef");
        }
        get actualMinimumValueChangeRef() {
            return this.ck;
        }
        set actualMinimumValueChangeRef(a) {
            this.ck = a;
            this.e("ActualMinimumValueChangeRef");
        }
        get actualMaximumValueChangeRef() {
            return this.cj;
        }
        set actualMaximumValueChangeRef(a) {
            this.cj = a;
            this.e("ActualMaximumValueChangeRef");
        }
    }
    RadialGaugeDescription.$t = /*@__PURE__*/ markType(RadialGaugeDescription, 'RadialGaugeDescription', Description.$);
    return RadialGaugeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialGaugeDescriptionMetadata extends Base {
        static e(a, b) {
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:TextStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:TextStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontStyle/FontStyleTransform,web:TextStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontStyle/FontWeightTransform,web:TextStyle/FontWeightTransform)String");
            b.item("_qualifiedName", "String:Infragistics.Controls.Gauges.XamRadialGauge");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("LegendRef", "(w:Legend)DataRef:String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
        static b(a) {
            if (RadialGaugeDescriptionMetadata.a == null) {
                RadialGaugeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialGaugeDescriptionMetadata.c(a, RadialGaugeDescriptionMetadata.a);
                FormatRadialGaugeLabelEventArgsDescriptionMetadata.d(a);
                AlignRadialGaugeLabelEventArgsDescriptionMetadata.d(a);
                DoubleValueChangedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("RangeBrushes", "BrushCollection:string");
            b.item("RangeOutlines", "BrushCollection:string");
            b.item("MinimumValue", "Number:double");
            b.item("ActualMinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("ActualMaximumValue", "Number:double");
            b.item("Interval", "Number:double");
            b.item("CenterX", "Number:double");
            b.item("CenterY", "Number:double");
            b.item("Value", "Number:double");
            b.item("ScaleStartAngle", "Number:double");
            b.item("ScaleEndAngle", "Number:double");
            b.item("ScaleSweepDirection", "ExportedType:string:SweepDirection");
            b.item("ScaleSweepDirection@names", "Counterclockwise;Clockwise");
            b.item("TransitionDuration", "Number:int");
            b.item("TransitionEasingFunctionRef", "(w:TransitionEasingFunction,wf:TransitionEasingFunction)MethodRef");
            b.item("NeedleBrush", "Brush");
            b.item("NeedleOutline", "Brush");
            b.item("NeedleStartExtent", "Number:double");
            b.item("NeedleEndExtent", "Number:double");
            b.item("NeedleShape", "ExportedType:string:RadialGaugeNeedleShape");
            b.item("NeedleShape@names", "None;Rectangle;Triangle;Needle;Trapezoid;RectangleWithBulb;TriangleWithBulb;NeedleWithBulb;TrapezoidWithBulb");
            b.item("NeedleStartWidthRatio", "Number:double");
            b.item("NeedleEndWidthRatio", "Number:double");
            b.item("NeedleBaseFeatureWidthRatio", "Number:double");
            b.item("NeedleBaseFeatureExtent", "Number:double");
            b.item("NeedlePointFeatureWidthRatio", "Number:double");
            b.item("NeedlePointFeatureExtent", "Number:double");
            b.item("NeedlePivotWidthRatio", "Number:double");
            b.item("NeedlePivotInnerWidthRatio", "Number:double");
            b.item("NeedlePivotShape", "ExportedType:string:RadialGaugePivotShape");
            b.item("NeedlePivotShape@names", "None;Circle;CircleWithHole;CircleOverlay;CircleOverlayWithHole;CircleUnderlay;CircleUnderlayWithHole");
            b.item("ScaleStartExtent", "Number:double");
            b.item("NeedlePivotBrush", "Brush");
            b.item("NeedlePivotOutline", "Brush");
            b.item("NeedleStrokeThickness", "Number:double");
            b.item("NeedlePivotStrokeThickness", "Number:double");
            b.item("ScaleEndExtent", "Number:double");
            b.item("LabelExtent", "Number:double");
            b.item("LabelInterval", "Number:double");
            b.item("TickStartExtent", "Number:double");
            b.item("TickEndExtent", "Number:double");
            b.item("TickStrokeThickness", "Number:double");
            b.item("TickBrush", "Brush");
            b.item("FontBrush", "Brush");
            b.item("MinorTickStartExtent", "Number:double");
            b.item("MinorTickEndExtent", "Number:double");
            b.item("MinorTickStrokeThickness", "Number:double");
            b.item("MinorTickBrush", "Brush");
            b.item("MinorTickCount", "Number:double");
            b.item("ScaleBrush", "Brush");
            b.item("BackingBrush", "Brush");
            b.item("BackingOutline", "Brush");
            b.item("BackingStrokeThickness", "Number:double");
            b.item("BackingOuterExtent", "Number:double");
            b.item("BackingOversweep", "Number:double");
            b.item("ScaleOversweep", "Number:double");
            b.item("ScaleOversweepShape", "ExportedType:string:RadialGaugeScaleOversweepShape");
            b.item("ScaleOversweepShape@names", "Auto;Circular;Fitted");
            b.item("BackingCornerRadius", "Number:double");
            b.item("BackingInnerExtent", "Number:double");
            b.item("BackingShape", "ExportedType:string:RadialGaugeBackingShape");
            b.item("BackingShape@names", "Circular;Fitted");
            b.item("Ranges", "Collection:RadialGaugeRange:RadialGaugeRangeCollection:RadialGaugeRange");
            b.item("RadiusMultiplier", "Number:double");
            b.item("DuplicateLabelOmissionStrategy", "ExportedType:string:RadialGaugeDuplicateLabelOmissionStrategy");
            b.item("DuplicateLabelOmissionStrategy@names", "OmitLast;OmitFirst;OmitNeither;OmitBoth");
            b.item("IsNeedleDraggingEnabled", "Boolean");
            b.item("IsNeedleDraggingConstrained", "Boolean");
            b.item("Font", "String");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("TransitionProgress", "Number:double");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("FormatLabelRef", "EventRef::formatLabel");
            b.item("AlignLabelRef", "EventRef::alignLabel");
            b.item("ValueChangedRef", "EventRef::valueChanged");
            b.item("ActualMinimumValueChangeRef", "EventRef::actualMinimumValueChange");
            b.item("ActualMaximumValueChangeRef", "EventRef::actualMaximumValueChange");
            RadialGaugeDescriptionMetadata.e(a, b);
        }
        static d(a) {
            RadialGaugeDescriptionMetadata.b(a);
            a.q("RadialGauge", () => new RadialGaugeDescription());
            a.p("RadialGauge", RadialGaugeDescriptionMetadata.a);
        }
    }
    RadialGaugeDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialGaugeDescriptionMetadata, 'RadialGaugeDescriptionMetadata');
    RadialGaugeDescriptionMetadata.a = null;
    return RadialGaugeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeRangeDescription = /*@__PURE__*/ (() => {
    class RadialGaugeRangeDescription extends Description {
        constructor() {
            super();
            this.u = null;
            this.t = null;
            this.v = null;
            this.k = 0;
            this.f = 0;
            this.h = 0;
            this.g = 0;
            this.j = 0;
            this.i = 0;
            this.l = 0;
        }
        get_type() {
            return "RadialGaugeRange";
        }
        get type() {
            return this.get_type();
        }
        get name() {
            return this.u;
        }
        set name(a) {
            this.u = a;
            this.e("Name");
        }
        get brush() {
            return this.t;
        }
        set brush(a) {
            this.t = a;
            this.e("Brush");
        }
        get outline() {
            return this.v;
        }
        set outline(a) {
            this.v = a;
            this.e("Outline");
        }
        get startValue() {
            return this.k;
        }
        set startValue(a) {
            this.k = a;
            this.e("StartValue");
        }
        get endValue() {
            return this.f;
        }
        set endValue(a) {
            this.f = a;
            this.e("EndValue");
        }
        get innerStartExtent() {
            return this.h;
        }
        set innerStartExtent(a) {
            this.h = a;
            this.e("InnerStartExtent");
        }
        get innerEndExtent() {
            return this.g;
        }
        set innerEndExtent(a) {
            this.g = a;
            this.e("InnerEndExtent");
        }
        get outerStartExtent() {
            return this.j;
        }
        set outerStartExtent(a) {
            this.j = a;
            this.e("OuterStartExtent");
        }
        get outerEndExtent() {
            return this.i;
        }
        set outerEndExtent(a) {
            this.i = a;
            this.e("OuterEndExtent");
        }
        get strokeThickness() {
            return this.l;
        }
        set strokeThickness(a) {
            this.l = a;
            this.e("StrokeThickness");
        }
    }
    RadialGaugeRangeDescription.$t = /*@__PURE__*/ markType(RadialGaugeRangeDescription, 'RadialGaugeRangeDescription', Description.$);
    return RadialGaugeRangeDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeRangeDescriptionMetadata = /*@__PURE__*/ (() => {
    class RadialGaugeRangeDescriptionMetadata extends Base {
        static b(a) {
            if (RadialGaugeRangeDescriptionMetadata.a == null) {
                RadialGaugeRangeDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RadialGaugeRangeDescriptionMetadata.c(a, RadialGaugeRangeDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Name", "String");
            b.item("Brush", "Brush");
            b.item("Outline", "Brush");
            b.item("StartValue", "Number:double");
            b.item("EndValue", "Number:double");
            b.item("InnerStartExtent", "Number:double");
            b.item("InnerEndExtent", "Number:double");
            b.item("OuterStartExtent", "Number:double");
            b.item("OuterEndExtent", "Number:double");
            b.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            RadialGaugeRangeDescriptionMetadata.b(a);
            a.q("RadialGaugeRange", () => new RadialGaugeRangeDescription());
            a.p("RadialGaugeRange", RadialGaugeRangeDescriptionMetadata.a);
        }
    }
    RadialGaugeRangeDescriptionMetadata.$t = /*@__PURE__*/ markType(RadialGaugeRangeDescriptionMetadata, 'RadialGaugeRangeDescriptionMetadata');
    RadialGaugeRangeDescriptionMetadata.a = null;
    return RadialGaugeRangeDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeRangeDescriptionModule = /*@__PURE__*/ (() => {
    class RadialGaugeRangeDescriptionModule extends Base {
        static register(a) {
            RadialGaugeRangeDescriptionMetadata.d(a);
        }
    }
    RadialGaugeRangeDescriptionModule.$t = /*@__PURE__*/ markType(RadialGaugeRangeDescriptionModule, 'RadialGaugeRangeDescriptionModule');
    return RadialGaugeRangeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeCoreDescriptionModule = /*@__PURE__*/ (() => {
    class RadialGaugeCoreDescriptionModule extends Base {
        static register(a) {
            RadialGaugeDescriptionMetadata.d(a);
            RadialGaugeRangeDescriptionModule.register(a);
            NumberFormatSpecifierDescriptionModule.register(a);
        }
    }
    RadialGaugeCoreDescriptionModule.$t = /*@__PURE__*/ markType(RadialGaugeCoreDescriptionModule, 'RadialGaugeCoreDescriptionModule');
    return RadialGaugeCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RadialGaugeDescriptionModule = /*@__PURE__*/ (() => {
    class RadialGaugeDescriptionModule extends Base {
        static register(a) {
            RadialGaugeCoreDescriptionModule.register(a);
            DVInteractivityDescriptionModule.register(a);
        }
    }
    RadialGaugeDescriptionModule.$t = /*@__PURE__*/ markType(RadialGaugeDescriptionModule, 'RadialGaugeDescriptionModule');
    return RadialGaugeDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleLegendDescription = /*@__PURE__*/ (() => {
    class ScaleLegendDescription extends LegendBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "ScaleLegend";
        }
    }
    ScaleLegendDescription.$t = /*@__PURE__*/ markType(ScaleLegendDescription, 'ScaleLegendDescription', LegendBaseDescription.$);
    return ScaleLegendDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleLegendDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScaleLegendDescriptionMetadata extends Base {
        static b(a) {
            if (ScaleLegendDescriptionMetadata.a == null) {
                ScaleLegendDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScaleLegendDescriptionMetadata.c(a, ScaleLegendDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            LegendBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            ScaleLegendDescriptionMetadata.b(a);
            a.q("ScaleLegend", () => new ScaleLegendDescription());
            a.p("ScaleLegend", ScaleLegendDescriptionMetadata.a);
        }
    }
    ScaleLegendDescriptionMetadata.$t = /*@__PURE__*/ markType(ScaleLegendDescriptionMetadata, 'ScaleLegendDescriptionMetadata');
    ScaleLegendDescriptionMetadata.a = null;
    return ScaleLegendDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScaleLegendDescriptionModule = /*@__PURE__*/ (() => {
    class ScaleLegendDescriptionModule extends Base {
        static register(a) {
            ScaleLegendDescriptionMetadata.d(a);
        }
    }
    ScaleLegendDescriptionModule.$t = /*@__PURE__*/ markType(ScaleLegendDescriptionModule, 'ScaleLegendDescriptionModule');
    return ScaleLegendDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectionChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SelectionChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = new Date();
        }
        get_type() {
            return "SelectionChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get selectedDate() {
            return this.f;
        }
        set selectedDate(a) {
            this.f = a;
            this.e("SelectedDate");
        }
    }
    SelectionChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SelectionChangedEventArgsDescription, 'SelectionChangedEventArgsDescription', Description.$);
    return SelectionChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SelectionChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SelectionChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SelectionChangedEventArgsDescriptionMetadata.a == null) {
                SelectionChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SelectionChangedEventArgsDescriptionMetadata.c(a, SelectionChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("SelectedDate", "Date");
        }
        static d(a) {
            SelectionChangedEventArgsDescriptionMetadata.b(a);
            a.q("SelectionChangedEventArgs", () => new SelectionChangedEventArgsDescription());
            a.p("SelectionChangedEventArgs", SelectionChangedEventArgsDescriptionMetadata.a);
        }
    }
    SelectionChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SelectionChangedEventArgsDescriptionMetadata, 'SelectionChangedEventArgsDescriptionMetadata');
    SelectionChangedEventArgsDescriptionMetadata.a = null;
    return SelectionChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortIndicatorRenderCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class SortIndicatorRenderCompletedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "SortIndicatorRenderCompletedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    SortIndicatorRenderCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(SortIndicatorRenderCompletedEventArgsDescription, 'SortIndicatorRenderCompletedEventArgsDescription', Description.$);
    return SortIndicatorRenderCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortIndicatorRenderCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SortIndicatorRenderCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a == null) {
                SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SortIndicatorRenderCompletedEventArgsDescriptionMetadata.c(a, SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            SortIndicatorRenderCompletedEventArgsDescriptionMetadata.b(a);
            a.q("SortIndicatorRenderCompletedEventArgs", () => new SortIndicatorRenderCompletedEventArgsDescription());
            a.p("SortIndicatorRenderCompletedEventArgs", SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a);
        }
    }
    SortIndicatorRenderCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SortIndicatorRenderCompletedEventArgsDescriptionMetadata, 'SortIndicatorRenderCompletedEventArgsDescriptionMetadata');
    SortIndicatorRenderCompletedEventArgsDescriptionMetadata.a = null;
    return SortIndicatorRenderCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineDescription = /*@__PURE__*/ (() => {
    class SparklineDescription extends Description {
        constructor() {
            super();
            this.aq = null;
            this.ba = null;
            this.a8 = null;
            this.bb = null;
            this.at = null;
            this.a4 = null;
            this.ax = null;
            this.a6 = null;
            this.bf = null;
            this.az = null;
            this.bj = null;
            this.bd = null;
            this.a1 = null;
            this.bl = null;
            this.a9 = null;
            this.bc = null;
            this.au = null;
            this.a5 = null;
            this.a7 = null;
            this.ay = null;
            this.be = null;
            this.j = false;
            this.r = 0;
            this.m = 0;
            this.o = 0;
            this.n = 0;
            this.q = 0;
            this.u = 0;
            this.p = 0;
            this.t = 0;
            this.s = 0;
            this.ar = null;
            this.bi = null;
            this.a3 = null;
            this.bg = null;
            this.an = 0;
            this.y = 0;
            this.w = 0;
            this.v = 0;
            this.as = null;
            this.bh = null;
            this.bk = null;
            this.a0 = null;
            this.av = null;
            this.a2 = null;
            this.f = null;
            this.bm = null;
            this.g = null;
            this.x = 0;
            this.l = 0;
            this.bn = null;
            this.aw = null;
            this.ap = null;
        }
        get_type() {
            return "Sparkline";
        }
        get type() {
            return this.get_type();
        }
        get brush() {
            return this.aq;
        }
        set brush(a) {
            this.aq = a;
            this.e("Brush");
        }
        get negativeBrush() {
            return this.ba;
        }
        set negativeBrush(a) {
            this.ba = a;
            this.e("NegativeBrush");
        }
        get markerBrush() {
            return this.a8;
        }
        set markerBrush(a) {
            this.a8 = a;
            this.e("MarkerBrush");
        }
        get negativeMarkerBrush() {
            return this.bb;
        }
        set negativeMarkerBrush(a) {
            this.bb = a;
            this.e("NegativeMarkerBrush");
        }
        get firstMarkerBrush() {
            return this.at;
        }
        set firstMarkerBrush(a) {
            this.at = a;
            this.e("FirstMarkerBrush");
        }
        get lastMarkerBrush() {
            return this.a4;
        }
        set lastMarkerBrush(a) {
            this.a4 = a;
            this.e("LastMarkerBrush");
        }
        get highMarkerBrush() {
            return this.ax;
        }
        set highMarkerBrush(a) {
            this.ax = a;
            this.e("HighMarkerBrush");
        }
        get lowMarkerBrush() {
            return this.a6;
        }
        set lowMarkerBrush(a) {
            this.a6 = a;
            this.e("LowMarkerBrush");
        }
        get trendLineBrush() {
            return this.bf;
        }
        set trendLineBrush(a) {
            this.bf = a;
            this.e("TrendLineBrush");
        }
        get horizontalAxisBrush() {
            return this.az;
        }
        set horizontalAxisBrush(a) {
            this.az = a;
            this.e("HorizontalAxisBrush");
        }
        get verticalAxisBrush() {
            return this.bj;
        }
        set verticalAxisBrush(a) {
            this.bj = a;
            this.e("VerticalAxisBrush");
        }
        get normalRangeFill() {
            return this.bd;
        }
        set normalRangeFill(a) {
            this.bd = a;
            this.e("NormalRangeFill");
        }
        get horizontalAxisVisibility() {
            return this.a1;
        }
        set horizontalAxisVisibility(a) {
            this.a1 = a;
            this.e("HorizontalAxisVisibility");
        }
        get verticalAxisVisibility() {
            return this.bl;
        }
        set verticalAxisVisibility(a) {
            this.bl = a;
            this.e("VerticalAxisVisibility");
        }
        get markerVisibility() {
            return this.a9;
        }
        set markerVisibility(a) {
            this.a9 = a;
            this.e("MarkerVisibility");
        }
        get negativeMarkerVisibility() {
            return this.bc;
        }
        set negativeMarkerVisibility(a) {
            this.bc = a;
            this.e("NegativeMarkerVisibility");
        }
        get firstMarkerVisibility() {
            return this.au;
        }
        set firstMarkerVisibility(a) {
            this.au = a;
            this.e("FirstMarkerVisibility");
        }
        get lastMarkerVisibility() {
            return this.a5;
        }
        set lastMarkerVisibility(a) {
            this.a5 = a;
            this.e("LastMarkerVisibility");
        }
        get lowMarkerVisibility() {
            return this.a7;
        }
        set lowMarkerVisibility(a) {
            this.a7 = a;
            this.e("LowMarkerVisibility");
        }
        get highMarkerVisibility() {
            return this.ay;
        }
        set highMarkerVisibility(a) {
            this.ay = a;
            this.e("HighMarkerVisibility");
        }
        get normalRangeVisibility() {
            return this.be;
        }
        set normalRangeVisibility(a) {
            this.be = a;
            this.e("NormalRangeVisibility");
        }
        get displayNormalRangeInFront() {
            return this.j;
        }
        set displayNormalRangeInFront(a) {
            this.j = a;
            this.e("DisplayNormalRangeInFront");
        }
        get markerSize() {
            return this.r;
        }
        set markerSize(a) {
            this.r = a;
            this.e("MarkerSize");
        }
        get firstMarkerSize() {
            return this.m;
        }
        set firstMarkerSize(a) {
            this.m = a;
            this.e("FirstMarkerSize");
        }
        get lastMarkerSize() {
            return this.o;
        }
        set lastMarkerSize(a) {
            this.o = a;
            this.e("LastMarkerSize");
        }
        get highMarkerSize() {
            return this.n;
        }
        set highMarkerSize(a) {
            this.n = a;
            this.e("HighMarkerSize");
        }
        get lowMarkerSize() {
            return this.q;
        }
        set lowMarkerSize(a) {
            this.q = a;
            this.e("LowMarkerSize");
        }
        get negativeMarkerSize() {
            return this.u;
        }
        set negativeMarkerSize(a) {
            this.u = a;
            this.e("NegativeMarkerSize");
        }
        get lineThickness() {
            return this.p;
        }
        set lineThickness(a) {
            this.p = a;
            this.e("LineThickness");
        }
        get minimum() {
            return this.t;
        }
        set minimum(a) {
            this.t = a;
            this.e("Minimum");
        }
        get maximum() {
            return this.s;
        }
        set maximum(a) {
            this.s = a;
            this.e("Maximum");
        }
        get dataSourceRef() {
            return this.ar;
        }
        set dataSourceRef(a) {
            this.ar = a;
            this.e("DataSourceRef");
        }
        get valueMemberPath() {
            return this.bi;
        }
        set valueMemberPath(a) {
            this.bi = a;
            this.e("ValueMemberPath");
        }
        get labelMemberPath() {
            return this.a3;
        }
        set labelMemberPath(a) {
            this.a3 = a;
            this.e("LabelMemberPath");
        }
        get trendLineType() {
            return this.bg;
        }
        set trendLineType(a) {
            this.bg = a;
            this.e("TrendLineType");
        }
        get trendLinePeriod() {
            return this.an;
        }
        set trendLinePeriod(a) {
            this.an = a;
            this.e("TrendLinePeriod");
        }
        get trendLineThickness() {
            return this.y;
        }
        set trendLineThickness(a) {
            this.y = a;
            this.e("TrendLineThickness");
        }
        get normalRangeMinimum() {
            return this.w;
        }
        set normalRangeMinimum(a) {
            this.w = a;
            this.e("NormalRangeMinimum");
        }
        get normalRangeMaximum() {
            return this.v;
        }
        set normalRangeMaximum(a) {
            this.v = a;
            this.e("NormalRangeMaximum");
        }
        get displayType() {
            return this.as;
        }
        set displayType(a) {
            this.as = a;
            this.e("DisplayType");
        }
        get unknownValuePlotting() {
            return this.bh;
        }
        set unknownValuePlotting(a) {
            this.bh = a;
            this.e("UnknownValuePlotting");
        }
        get verticalAxisLabelRef() {
            return this.bk;
        }
        set verticalAxisLabelRef(a) {
            this.bk = a;
            this.e("VerticalAxisLabelRef");
        }
        get horizontalAxisLabelRef() {
            return this.a0;
        }
        set horizontalAxisLabelRef(a) {
            this.a0 = a;
            this.e("HorizontalAxisLabelRef");
        }
        get formatLabelRef() {
            return this.av;
        }
        set formatLabelRef(a) {
            this.av = a;
            this.e("FormatLabelRef");
        }
        get horizontalLabelFormat() {
            return this.a2;
        }
        set horizontalLabelFormat(a) {
            this.a2 = a;
            this.e("HorizontalLabelFormat");
        }
        get horizontalLabelFormatSpecifiers() {
            return this.f;
        }
        set horizontalLabelFormatSpecifiers(a) {
            this.f = a;
            this.e("HorizontalLabelFormatSpecifiers");
        }
        get verticalLabelFormat() {
            return this.bm;
        }
        set verticalLabelFormat(a) {
            this.bm = a;
            this.e("VerticalLabelFormat");
        }
        get verticalLabelFormatSpecifiers() {
            return this.g;
        }
        set verticalLabelFormatSpecifiers(a) {
            this.g = a;
            this.e("VerticalLabelFormatSpecifiers");
        }
        get pixelScalingRatio() {
            return this.x;
        }
        set pixelScalingRatio(a) {
            this.x = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.l;
        }
        set actualPixelScalingRatio(a) {
            this.l = a;
            this.e("ActualPixelScalingRatio");
        }
        get width() {
            return this.bn;
        }
        set width(a) {
            this.bn = a;
            this.e("Width");
        }
        get height() {
            return this.aw;
        }
        set height(a) {
            this.aw = a;
            this.e("Height");
        }
        get background() {
            return this.ap;
        }
        set background(a) {
            this.ap = a;
            this.e("Background");
        }
    }
    SparklineDescription.$t = /*@__PURE__*/ markType(SparklineDescription, 'SparklineDescription', Description.$);
    return SparklineDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineDescriptionMetadata = /*@__PURE__*/ (() => {
    class SparklineDescriptionMetadata extends Base {
        static b(a) {
            if (SparklineDescriptionMetadata.a == null) {
                SparklineDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SparklineDescriptionMetadata.c(a, SparklineDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Brush", "Brush");
            b.item("NegativeBrush", "Brush");
            b.item("MarkerBrush", "Brush");
            b.item("NegativeMarkerBrush", "Brush");
            b.item("FirstMarkerBrush", "Brush");
            b.item("LastMarkerBrush", "Brush");
            b.item("HighMarkerBrush", "Brush");
            b.item("LowMarkerBrush", "Brush");
            b.item("TrendLineBrush", "Brush");
            b.item("HorizontalAxisBrush", "Brush");
            b.item("VerticalAxisBrush", "Brush");
            b.item("NormalRangeFill", "Brush");
            b.item("HorizontalAxisVisibility", "ExportedType:string:Visibility");
            b.item("HorizontalAxisVisibility@names", "Visible;Collapsed");
            b.item("VerticalAxisVisibility", "ExportedType:string:Visibility");
            b.item("VerticalAxisVisibility@names", "Visible;Collapsed");
            b.item("MarkerVisibility", "ExportedType:string:Visibility");
            b.item("MarkerVisibility@names", "Visible;Collapsed");
            b.item("NegativeMarkerVisibility", "ExportedType:string:Visibility");
            b.item("NegativeMarkerVisibility@names", "Visible;Collapsed");
            b.item("FirstMarkerVisibility", "ExportedType:string:Visibility");
            b.item("FirstMarkerVisibility@names", "Visible;Collapsed");
            b.item("LastMarkerVisibility", "ExportedType:string:Visibility");
            b.item("LastMarkerVisibility@names", "Visible;Collapsed");
            b.item("LowMarkerVisibility", "ExportedType:string:Visibility");
            b.item("LowMarkerVisibility@names", "Visible;Collapsed");
            b.item("HighMarkerVisibility", "ExportedType:string:Visibility");
            b.item("HighMarkerVisibility@names", "Visible;Collapsed");
            b.item("NormalRangeVisibility", "ExportedType:string:Visibility");
            b.item("NormalRangeVisibility@names", "Visible;Collapsed");
            b.item("DisplayNormalRangeInFront", "Boolean");
            b.item("MarkerSize", "Number:double");
            b.item("FirstMarkerSize", "Number:double");
            b.item("LastMarkerSize", "Number:double");
            b.item("HighMarkerSize", "Number:double");
            b.item("LowMarkerSize", "Number:double");
            b.item("NegativeMarkerSize", "Number:double");
            b.item("LineThickness", "Number:double");
            b.item("Minimum", "Number:double");
            b.item("Maximum", "Number:double");
            b.item("DataSourceRef", "(w:ItemsSource,wf:DataSource)DataRef::object");
            b.item("ValueMemberPath", "String");
            b.item("LabelMemberPath", "String");
            b.item("TrendLineType", "ExportedType:string:TrendLineType");
            b.item("TrendLineType@names", "None;LinearFit;QuadraticFit;CubicFit;QuarticFit;QuinticFit;LogarithmicFit;ExponentialFit;PowerLawFit;SimpleAverage;ExponentialAverage;ModifiedAverage;CumulativeAverage;WeightedAverage");
            b.item("TrendLinePeriod", "Number:int");
            b.item("TrendLineThickness", "Number:double");
            b.item("NormalRangeMinimum", "Number:double");
            b.item("NormalRangeMaximum", "Number:double");
            b.item("DisplayType", "ExportedType:string:SparklineDisplayType");
            b.item("DisplayType@names", "Line;Area;Column;WinLoss");
            b.item("UnknownValuePlotting", "ExportedType:string:UnknownValuePlotting");
            b.item("UnknownValuePlotting@names", "LinearInterpolate;DontPlot");
            b.item("VerticalAxisLabelRef", "(w:VerticalAxisLabel,wf:VerticalAxisLabel)DataRef");
            b.item("HorizontalAxisLabelRef", "(w:HorizontalAxisLabel,wf:HorizontalAxisLabel)DataRef");
            b.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            b.item("HorizontalLabelFormat", "String");
            b.item("HorizontalLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("VerticalLabelFormat", "String");
            b.item("VerticalLabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            SparklineDescriptionMetadata.e(a, b);
        }
        static d(a) {
            SparklineDescriptionMetadata.b(a);
            a.q("Sparkline", () => new SparklineDescription());
            a.p("Sparkline", SparklineDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamSparkline");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    SparklineDescriptionMetadata.$t = /*@__PURE__*/ markType(SparklineDescriptionMetadata, 'SparklineDescriptionMetadata');
    SparklineDescriptionMetadata.a = null;
    return SparklineDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineCoreDescriptionModule = /*@__PURE__*/ (() => {
    class SparklineCoreDescriptionModule extends Base {
        static register(a) {
            SparklineDescriptionMetadata.d(a);
            NumberFormatSpecifierDescriptionModule.register(a);
            DateTimeFormatSpecifierDescriptionModule.register(a);
        }
    }
    SparklineCoreDescriptionModule.$t = /*@__PURE__*/ markType(SparklineCoreDescriptionModule, 'SparklineCoreDescriptionModule');
    return SparklineCoreDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparklineDescriptionModule = /*@__PURE__*/ (() => {
    class SparklineDescriptionModule extends Base {
        static register(a) {
            SparklineCoreDescriptionModule.register(a);
            DataChartInteractivityDescriptionModule.register(a);
        }
    }
    SparklineDescriptionModule.$t = /*@__PURE__*/ markType(SparklineDescriptionModule, 'SparklineDescriptionModule');
    return SparklineDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class StockChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "StockChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get addedSymbols() {
            return this.f;
        }
        set addedSymbols(a) {
            this.f = a;
            this.e("AddedSymbols");
        }
        get removedSymbols() {
            return this.g;
        }
        set removedSymbols(a) {
            this.g = a;
            this.e("RemovedSymbols");
        }
    }
    StockChangedEventArgsDescription.$t = /*@__PURE__*/ markType(StockChangedEventArgsDescription, 'StockChangedEventArgsDescription', Description.$);
    return StockChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StockChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StockChangedEventArgsDescriptionMetadata.a == null) {
                StockChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StockChangedEventArgsDescriptionMetadata.c(a, StockChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("AddedSymbols", "Array:string");
            b.item("RemovedSymbols", "Array:string");
        }
        static d(a) {
            StockChangedEventArgsDescriptionMetadata.b(a);
            a.q("StockChangedEventArgs", () => new StockChangedEventArgsDescription());
            a.p("StockChangedEventArgs", StockChangedEventArgsDescriptionMetadata.a);
        }
    }
    StockChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StockChangedEventArgsDescriptionMetadata, 'StockChangedEventArgsDescriptionMetadata');
    StockChangedEventArgsDescriptionMetadata.a = null;
    return StockChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPopulateEventArgsDescription = /*@__PURE__*/ (() => {
    class StockPopulateEventArgsDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "StockPopulateEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get symbol() {
            return this.g;
        }
        set symbol(a) {
            this.g = a;
            this.e("Symbol");
        }
        get name() {
            return this.f;
        }
        set name(a) {
            this.f = a;
            this.e("Name");
        }
    }
    StockPopulateEventArgsDescription.$t = /*@__PURE__*/ markType(StockPopulateEventArgsDescription, 'StockPopulateEventArgsDescription', Description.$);
    return StockPopulateEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StockPopulateEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class StockPopulateEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (StockPopulateEventArgsDescriptionMetadata.a == null) {
                StockPopulateEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StockPopulateEventArgsDescriptionMetadata.c(a, StockPopulateEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Symbol", "String");
            b.item("Name", "String");
        }
        static d(a) {
            StockPopulateEventArgsDescriptionMetadata.b(a);
            a.q("StockPopulateEventArgs", () => new StockPopulateEventArgsDescription());
            a.p("StockPopulateEventArgs", StockPopulateEventArgsDescriptionMetadata.a);
        }
    }
    StockPopulateEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(StockPopulateEventArgsDescriptionMetadata, 'StockPopulateEventArgsDescriptionMetadata');
    StockPopulateEventArgsDescriptionMetadata.a = null;
    return StockPopulateEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SuffixDescription = /*@__PURE__*/ (() => {
    class SuffixDescription extends InputGroupItemDescription {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.j = false;
            this.i = false;
        }
        get_type() {
            return "Suffix";
        }
        get id() {
            return this.n;
        }
        set id(a) {
            this.n = a;
            this.e("Id");
        }
        get ariaLabel() {
            return this.m;
        }
        set ariaLabel(a) {
            this.m = a;
            this.e("AriaLabel");
        }
        get isHover() {
            return this.j;
        }
        set isHover(a) {
            this.j = a;
            this.e("IsHover");
        }
        get disabled() {
            return this.i;
        }
        set disabled(a) {
            this.i = a;
            this.e("Disabled");
        }
    }
    SuffixDescription.$t = /*@__PURE__*/ markType(SuffixDescription, 'SuffixDescription', InputGroupItemDescription.$);
    return SuffixDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SuffixDescriptionMetadata = /*@__PURE__*/ (() => {
    class SuffixDescriptionMetadata extends Base {
        static b(a) {
            if (SuffixDescriptionMetadata.a == null) {
                SuffixDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SuffixDescriptionMetadata.c(a, SuffixDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            InputGroupItemDescriptionMetadata.c(a, b);
            b.item("Id", "String");
            b.item("AriaLabel", "String");
            b.item("IsHover", "Boolean");
            b.item("Disabled", "(w:IsDisabled,wf:IsDisabled)Boolean");
        }
        static d(a) {
            SuffixDescriptionMetadata.b(a);
            a.q("Suffix", () => new SuffixDescription());
            a.p("Suffix", SuffixDescriptionMetadata.a);
        }
    }
    SuffixDescriptionMetadata.$t = /*@__PURE__*/ markType(SuffixDescriptionMetadata, 'SuffixDescriptionMetadata');
    SuffixDescriptionMetadata.a = null;
    return SuffixDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryCellInfoDescription = /*@__PURE__*/ (() => {
    class SummaryCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.ff = null;
            this.fg = null;
            this.fk = null;
            this.fh = null;
            this.fc = 0;
            this.fi = null;
            this.fj = null;
        }
        get_type() {
            return "SummaryCellInfo";
        }
        get resolvedSummaryLabel() {
            return this.ff;
        }
        set resolvedSummaryLabel(a) {
            this.ff = a;
            this.e("ResolvedSummaryLabel");
        }
        get resolvedSummaryValue() {
            return this.fg;
        }
        set resolvedSummaryValue(a) {
            this.fg = a;
            this.e("ResolvedSummaryValue");
        }
        get summaryLabelTextColor() {
            return this.fk;
        }
        set summaryLabelTextColor(a) {
            this.fk = a;
            this.e("SummaryLabelTextColor");
        }
        get summaryLabelFontFamily() {
            return this.fh;
        }
        set summaryLabelFontFamily(a) {
            this.fh = a;
            this.e("SummaryLabelFontFamily");
        }
        get summaryLabelFontSize() {
            return this.fc;
        }
        set summaryLabelFontSize(a) {
            this.fc = a;
            this.e("SummaryLabelFontSize");
        }
        get summaryLabelFontStyle() {
            return this.fi;
        }
        set summaryLabelFontStyle(a) {
            this.fi = a;
            this.e("SummaryLabelFontStyle");
        }
        get summaryLabelFontWeight() {
            return this.fj;
        }
        set summaryLabelFontWeight(a) {
            this.fj = a;
            this.e("SummaryLabelFontWeight");
        }
    }
    SummaryCellInfoDescription.$t = /*@__PURE__*/ markType(SummaryCellInfoDescription, 'SummaryCellInfoDescription', CellInfoDescription.$);
    SummaryCellInfoDescription.__marshalByValue1 = true;
    SummaryCellInfoDescription.__marshalByValueAlias1 = "SummaryCellModel";
    return SummaryCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryCellInfoDescriptionMetadata.a == null) {
                SummaryCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryCellInfoDescriptionMetadata.c(a, SummaryCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("ResolvedSummaryLabel", "String");
            b.item("ResolvedSummaryValue", "String");
            b.item("SummaryLabelTextColor", "Brush");
            b.item("SummaryLabelFontFamily", "(w:SummaryLabelFontFamily/FontFamilyTransform,wf:SummaryLabelFontFamily,web:font/FontFamilyTransform)String");
            b.item("SummaryLabelFontSize", "(w:SummaryLabelFontSize,wf:SummaryLabelFontSize,web:font/FontSizeTransform)Number:double");
            b.item("SummaryLabelFontStyle", "(w:SummaryLabelFontStyle/FontStyleTransform,wf:SummaryLabelFontFamily/FontStyleTransform,web:font/FontStyleTransform)String");
            b.item("SummaryLabelFontWeight", "(w:SummaryLabelFontWeight/FontWeightTransform,wf:SummaryLabelFontFamily/FontWeightTransform,web:font/FontWeightTransform)String");
        }
        static d(a) {
            SummaryCellInfoDescriptionMetadata.b(a);
            a.q("SummaryCellInfo", () => new SummaryCellInfoDescription());
            a.p("SummaryCellInfo", SummaryCellInfoDescriptionMetadata.a);
        }
    }
    SummaryCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryCellInfoDescriptionMetadata, 'SummaryCellInfoDescriptionMetadata');
    SummaryCellInfoDescriptionMetadata.a = null;
    return SummaryCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class SummaryChangedEventArgsDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.f = false;
        }
        get_type() {
            return "SummaryChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get iD() {
            return this.h;
        }
        set iD(a) {
            this.h = a;
            this.e("ID");
        }
        get isEnabled() {
            return this.f;
        }
        set isEnabled(a) {
            this.f = a;
            this.e("IsEnabled");
        }
    }
    SummaryChangedEventArgsDescription.$t = /*@__PURE__*/ markType(SummaryChangedEventArgsDescription, 'SummaryChangedEventArgsDescription', Description.$);
    return SummaryChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryChangedEventArgsDescriptionMetadata.a == null) {
                SummaryChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryChangedEventArgsDescriptionMetadata.c(a, SummaryChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ID", "String");
            b.item("IsEnabled", "Boolean");
        }
        static d(a) {
            SummaryChangedEventArgsDescriptionMetadata.b(a);
            a.q("SummaryChangedEventArgs", () => new SummaryChangedEventArgsDescription());
            a.p("SummaryChangedEventArgs", SummaryChangedEventArgsDescriptionMetadata.a);
        }
    }
    SummaryChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryChangedEventArgsDescriptionMetadata, 'SummaryChangedEventArgsDescriptionMetadata');
    SummaryChangedEventArgsDescriptionMetadata.a = null;
    return SummaryChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryDataDescription = /*@__PURE__*/ (() => {
    class SummaryDataDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.j = null;
            this.i = null;
            this.f = null;
            this.g = null;
        }
        get_type() {
            return "SummaryData";
        }
        get type() {
            return this.get_type();
        }
        get summaryName() {
            return this.h;
        }
        set summaryName(a) {
            this.h = a;
            this.e("SummaryName");
        }
        get summaryValueRef() {
            return this.j;
        }
        set summaryValueRef(a) {
            this.j = a;
            this.e("SummaryValueRef");
        }
        get summaryOperand() {
            return this.i;
        }
        set summaryOperand(a) {
            this.i = a;
            this.e("SummaryOperand");
        }
        get formattedText() {
            return this.f;
        }
        set formattedText(a) {
            this.f = a;
            this.e("FormattedText");
        }
        get formattedValue() {
            return this.g;
        }
        set formattedValue(a) {
            this.g = a;
            this.e("FormattedValue");
        }
    }
    SummaryDataDescription.$t = /*@__PURE__*/ markType(SummaryDataDescription, 'SummaryDataDescription', Description.$);
    return SummaryDataDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SummaryDataDescriptionMetadata = /*@__PURE__*/ (() => {
    class SummaryDataDescriptionMetadata extends Base {
        static b(a) {
            if (SummaryDataDescriptionMetadata.a == null) {
                SummaryDataDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SummaryDataDescriptionMetadata.c(a, SummaryDataDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("SummaryName", "String");
            b.item("SummaryValueRef", "(w:SummaryValue,wf:SummaryValue)DataRef");
            b.item("SummaryOperand", "ExportedType:string:SummaryOperand");
            b.item("SummaryOperand@names", "Min;Max;Sum;Average;Count;Custom");
            b.item("FormattedText", "String");
            b.item("FormattedValue", "String");
        }
        static d(a) {
            SummaryDataDescriptionMetadata.b(a);
            a.q("SummaryData", () => new SummaryDataDescription());
            a.p("SummaryData", SummaryDataDescriptionMetadata.a);
        }
    }
    SummaryDataDescriptionMetadata.$t = /*@__PURE__*/ markType(SummaryDataDescriptionMetadata, 'SummaryDataDescriptionMetadata');
    SummaryDataDescriptionMetadata.a = null;
    return SummaryDataDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class TextChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "TextChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    TextChangedEventArgsDescription.$t = /*@__PURE__*/ markType(TextChangedEventArgsDescription, 'TextChangedEventArgsDescription', Description.$);
    return TextChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TextChangedEventArgsDescriptionMetadata.a == null) {
                TextChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextChangedEventArgsDescriptionMetadata.c(a, TextChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            TextChangedEventArgsDescriptionMetadata.b(a);
            a.q("TextChangedEventArgs", () => new TextChangedEventArgsDescription());
            a.p("TextChangedEventArgs", TextChangedEventArgsDescriptionMetadata.a);
        }
    }
    TextChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TextChangedEventArgsDescriptionMetadata, 'TextChangedEventArgsDescriptionMetadata');
    TextChangedEventArgsDescriptionMetadata.a = null;
    return TextChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileSeriesDescription = /*@__PURE__*/ (() => {
    class TileSeriesDescription extends ShapeSeriesBaseDescription {
        constructor() {
            super();
            this.de = null;
        }
        get_type() {
            return "TileSeries";
        }
        get tileImagery() {
            return this.de;
        }
        set tileImagery(a) {
            this.de = a;
            this.e("TileImagery");
        }
    }
    TileSeriesDescription.$t = /*@__PURE__*/ markType(TileSeriesDescription, 'TileSeriesDescription', ShapeSeriesBaseDescription.$);
    return TileSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class TileSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (TileSeriesDescriptionMetadata.a == null) {
                TileSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TileSeriesDescriptionMetadata.c(a, TileSeriesDescriptionMetadata.a);
                GeographicMapImageryDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ShapeSeriesBaseDescriptionMetadata.c(a, b);
            b.item("TileImagery", "ExportedType:GeographicMapImagery");
        }
        static d(a) {
            TileSeriesDescriptionMetadata.b(a);
            a.q("TileSeries", () => new TileSeriesDescription());
            a.p("TileSeries", TileSeriesDescriptionMetadata.a);
        }
    }
    TileSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(TileSeriesDescriptionMetadata, 'TileSeriesDescriptionMetadata');
    TileSeriesDescriptionMetadata.a = null;
    return TileSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class TileSeriesDescriptionModule extends Base {
        static register(a) {
            TileSeriesDescriptionMetadata.d(a);
        }
    }
    TileSeriesDescriptionModule.$t = /*@__PURE__*/ markType(TileSeriesDescriptionModule, 'TileSeriesDescriptionModule');
    return TileSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionStateDescription = /*@__PURE__*/ (() => {
    class TransactionStateDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
            this.h = null;
            this.i = null;
        }
        get_type() {
            return "TransactionState";
        }
        get type() {
            return this.get_type();
        }
        get idRef() {
            return this.f;
        }
        set idRef(a) {
            this.f = a;
            this.e("IdRef");
        }
        get transactionType() {
            return this.g;
        }
        set transactionType(a) {
            this.g = a;
            this.e("TransactionType");
        }
        get valueRef() {
            return this.h;
        }
        set valueRef(a) {
            this.h = a;
            this.e("ValueRef");
        }
        get versionRef() {
            return this.i;
        }
        set versionRef(a) {
            this.i = a;
            this.e("VersionRef");
        }
    }
    TransactionStateDescription.$t = /*@__PURE__*/ markType(TransactionStateDescription, 'TransactionStateDescription', Description.$);
    return TransactionStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TransactionStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class TransactionStateDescriptionMetadata extends Base {
        static b(a) {
            if (TransactionStateDescriptionMetadata.a == null) {
                TransactionStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TransactionStateDescriptionMetadata.c(a, TransactionStateDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IdRef", "(w:ID,wf:ID)DataRef");
            b.item("TransactionType", "ExportedType:string:TransactionType");
            b.item("TransactionType@names", "Add;Update;Delete");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("VersionRef", "(w:Version,wf:Version)DataRef");
        }
        static d(a) {
            TransactionStateDescriptionMetadata.b(a);
            a.q("TransactionState", () => new TransactionStateDescription());
            a.p("TransactionState", TransactionStateDescriptionMetadata.a);
        }
    }
    TransactionStateDescriptionMetadata.$t = /*@__PURE__*/ markType(TransactionStateDescriptionMetadata, 'TransactionStateDescriptionMetadata');
    TransactionStateDescriptionMetadata.a = null;
    return TransactionStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapDescription = /*@__PURE__*/ (() => {
    class TreemapDescription extends Description {
        constructor() {
            super();
            this.cu = null;
            this.cs = null;
            this.bq = null;
            this.cr = null;
            this.cd = null;
            this.br = null;
            this.ca = null;
            this.bt = null;
            this.f = null;
            this.g = null;
            this.bu = null;
            this.j = false;
            this.bl = 0;
            this.o = 0;
            this.n = 0;
            this.cf = null;
            this.cc = null;
            this.cq = null;
            this.b5 = null;
            this.bz = null;
            this.cp = null;
            this.b8 = null;
            this.b0 = null;
            this.ct = null;
            this.bs = null;
            this.b7 = null;
            this.b6 = null;
            this.bw = null;
            this.p = 0;
            this.bx = null;
            this.by = null;
            this.b2 = null;
            this.q = 0;
            this.b3 = null;
            this.b4 = null;
            this.b1 = null;
            this.t = 0;
            this.v = 0;
            this.u = 0;
            this.s = 0;
            this.ad = 0;
            this.af = 0;
            this.ae = 0;
            this.ac = 0;
            this.y = 0;
            this.aa = 0;
            this.z = 0;
            this.x = 0;
            this.ai = 0;
            this.am = 0;
            this.ak = 0;
            this.ag = 0;
            this.aj = 0;
            this.an = 0;
            this.al = 0;
            this.ah = 0;
            this.cb = null;
            this.ce = null;
            this.r = 0;
            this.co = null;
            this.ap = 0;
            this.cg = null;
            this.ch = null;
            this.ab = 0;
            this.bm = 0;
            this.ao = 0;
            this.m = 0;
            this.w = 0;
            this.l = 0;
            this.bv = null;
            this.cn = null;
            this.ck = null;
            this.ci = null;
            this.cj = null;
            this.cl = null;
            this.cm = null;
            this.cv = null;
            this.b9 = null;
            this.bp = null;
        }
        get_type() {
            return "Treemap";
        }
        get type() {
            return this.get_type();
        }
        get valueMemberPath() {
            return this.cu;
        }
        set valueMemberPath(a) {
            this.cu = a;
            this.e("ValueMemberPath");
        }
        get rootTitle() {
            return this.cs;
        }
        set rootTitle(a) {
            this.cs = a;
            this.e("RootTitle");
        }
        get breadcrumbSequence() {
            return this.bq;
        }
        set breadcrumbSequence(a) {
            this.bq = a;
            this.e("BreadcrumbSequence");
        }
        get parentIdMemberPath() {
            return this.cr;
        }
        set parentIdMemberPath(a) {
            this.cr = a;
            this.e("ParentIdMemberPath");
        }
        get labelMemberPath() {
            return this.cd;
        }
        set labelMemberPath(a) {
            this.cd = a;
            this.e("LabelMemberPath");
        }
        get customValueMemberPath() {
            return this.br;
        }
        set customValueMemberPath(a) {
            this.br = a;
            this.e("CustomValueMemberPath");
        }
        get idMemberPath() {
            return this.ca;
        }
        set idMemberPath(a) {
            this.ca = a;
            this.e("IdMemberPath");
        }
        get dataSourceRef() {
            return this.bt;
        }
        set dataSourceRef(a) {
            this.bt = a;
            this.e("DataSourceRef");
        }
        get fillBrushes() {
            return this.f;
        }
        set fillBrushes(a) {
            this.f = a;
            this.e("FillBrushes");
        }
        get styleMappings() {
            return this.g;
        }
        set styleMappings(a) {
            this.g = a;
            this.e("StyleMappings");
        }
        get fillScaleMode() {
            return this.bu;
        }
        set fillScaleMode(a) {
            this.bu = a;
            this.e("FillScaleMode");
        }
        get isFillScaleLogarithmic() {
            return this.j;
        }
        set isFillScaleLogarithmic(a) {
            this.j = a;
            this.e("IsFillScaleLogarithmic");
        }
        get fillScaleLogarithmBase() {
            return this.bl;
        }
        set fillScaleLogarithmBase(a) {
            this.bl = a;
            this.e("FillScaleLogarithmBase");
        }
        get fillScaleMinimumValue() {
            return this.o;
        }
        set fillScaleMinimumValue(a) {
            this.o = a;
            this.e("FillScaleMinimumValue");
        }
        get fillScaleMaximumValue() {
            return this.n;
        }
        set fillScaleMaximumValue(a) {
            this.n = a;
            this.e("FillScaleMaximumValue");
        }
        get labelVerticalFitMode() {
            return this.cf;
        }
        set labelVerticalFitMode(a) {
            this.cf = a;
            this.e("LabelVerticalFitMode");
        }
        get labelHorizontalFitMode() {
            return this.cc;
        }
        set labelHorizontalFitMode(a) {
            this.cc = a;
            this.e("LabelHorizontalFitMode");
        }
        get overlayHeaderHoverBackground() {
            return this.cq;
        }
        set overlayHeaderHoverBackground(a) {
            this.cq = a;
            this.e("OverlayHeaderHoverBackground");
        }
        get headerHoverBackground() {
            return this.b5;
        }
        set headerHoverBackground(a) {
            this.b5 = a;
            this.e("HeaderHoverBackground");
        }
        get headerBackground() {
            return this.bz;
        }
        set headerBackground(a) {
            this.bz = a;
            this.e("HeaderBackground");
        }
        get overlayHeaderBackground() {
            return this.cp;
        }
        set overlayHeaderBackground(a) {
            this.cp = a;
            this.e("OverlayHeaderBackground");
        }
        get headerTextColor() {
            return this.b8;
        }
        set headerTextColor(a) {
            this.b8 = a;
            this.e("HeaderTextColor");
        }
        get headerDarkTextColor() {
            return this.b0;
        }
        set headerDarkTextColor(a) {
            this.b0 = a;
            this.e("HeaderDarkTextColor");
        }
        get textColor() {
            return this.ct;
        }
        set textColor(a) {
            this.ct = a;
            this.e("TextColor");
        }
        get darkTextColor() {
            return this.bs;
        }
        set darkTextColor(a) {
            this.bs = a;
            this.e("DarkTextColor");
        }
        get headerHoverTextColor() {
            return this.b7;
        }
        set headerHoverTextColor(a) {
            this.b7 = a;
            this.e("HeaderHoverTextColor");
        }
        get headerHoverDarkTextColor() {
            return this.b6;
        }
        set headerHoverDarkTextColor(a) {
            this.b6 = a;
            this.e("HeaderHoverDarkTextColor");
        }
        get fontFamily() {
            return this.bw;
        }
        set fontFamily(a) {
            this.bw = a;
            this.e("FontFamily");
        }
        get fontSize() {
            return this.p;
        }
        set fontSize(a) {
            this.p = a;
            this.e("FontSize");
        }
        get fontStyle() {
            return this.bx;
        }
        set fontStyle(a) {
            this.bx = a;
            this.e("FontStyle");
        }
        get fontWeight() {
            return this.by;
        }
        set fontWeight(a) {
            this.by = a;
            this.e("FontWeight");
        }
        get headerFontFamily() {
            return this.b2;
        }
        set headerFontFamily(a) {
            this.b2 = a;
            this.e("HeaderFontFamily");
        }
        get headerFontSize() {
            return this.q;
        }
        set headerFontSize(a) {
            this.q = a;
            this.e("HeaderFontSize");
        }
        get headerFontStyle() {
            return this.b3;
        }
        set headerFontStyle(a) {
            this.b3 = a;
            this.e("HeaderFontStyle");
        }
        get headerFontWeight() {
            return this.b4;
        }
        set headerFontWeight(a) {
            this.b4 = a;
            this.e("HeaderFontWeight");
        }
        get headerDisplayMode() {
            return this.b1;
        }
        set headerDisplayMode(a) {
            this.b1 = a;
            this.e("HeaderDisplayMode");
        }
        get headerLabelLeftMargin() {
            return this.t;
        }
        set headerLabelLeftMargin(a) {
            this.t = a;
            this.e("HeaderLabelLeftMargin");
        }
        get headerLabelTopMargin() {
            return this.v;
        }
        set headerLabelTopMargin(a) {
            this.v = a;
            this.e("HeaderLabelTopMargin");
        }
        get headerLabelRightMargin() {
            return this.u;
        }
        set headerLabelRightMargin(a) {
            this.u = a;
            this.e("HeaderLabelRightMargin");
        }
        get headerLabelBottomMargin() {
            return this.s;
        }
        set headerLabelBottomMargin(a) {
            this.s = a;
            this.e("HeaderLabelBottomMargin");
        }
        get overlayHeaderLabelLeftMargin() {
            return this.ad;
        }
        set overlayHeaderLabelLeftMargin(a) {
            this.ad = a;
            this.e("OverlayHeaderLabelLeftMargin");
        }
        get overlayHeaderLabelTopMargin() {
            return this.af;
        }
        set overlayHeaderLabelTopMargin(a) {
            this.af = a;
            this.e("OverlayHeaderLabelTopMargin");
        }
        get overlayHeaderLabelRightMargin() {
            return this.ae;
        }
        set overlayHeaderLabelRightMargin(a) {
            this.ae = a;
            this.e("OverlayHeaderLabelRightMargin");
        }
        get overlayHeaderLabelBottomMargin() {
            return this.ac;
        }
        set overlayHeaderLabelBottomMargin(a) {
            this.ac = a;
            this.e("OverlayHeaderLabelBottomMargin");
        }
        get labelLeftMargin() {
            return this.y;
        }
        set labelLeftMargin(a) {
            this.y = a;
            this.e("LabelLeftMargin");
        }
        get labelTopMargin() {
            return this.aa;
        }
        set labelTopMargin(a) {
            this.aa = a;
            this.e("LabelTopMargin");
        }
        get labelRightMargin() {
            return this.z;
        }
        set labelRightMargin(a) {
            this.z = a;
            this.e("LabelRightMargin");
        }
        get labelBottomMargin() {
            return this.x;
        }
        set labelBottomMargin(a) {
            this.x = a;
            this.e("LabelBottomMargin");
        }
        get parentNodeLeftMargin() {
            return this.ai;
        }
        set parentNodeLeftMargin(a) {
            this.ai = a;
            this.e("ParentNodeLeftMargin");
        }
        get parentNodeTopMargin() {
            return this.am;
        }
        set parentNodeTopMargin(a) {
            this.am = a;
            this.e("ParentNodeTopMargin");
        }
        get parentNodeRightMargin() {
            return this.ak;
        }
        set parentNodeRightMargin(a) {
            this.ak = a;
            this.e("ParentNodeRightMargin");
        }
        get parentNodeBottomMargin() {
            return this.ag;
        }
        set parentNodeBottomMargin(a) {
            this.ag = a;
            this.e("ParentNodeBottomMargin");
        }
        get parentNodeLeftPadding() {
            return this.aj;
        }
        set parentNodeLeftPadding(a) {
            this.aj = a;
            this.e("ParentNodeLeftPadding");
        }
        get parentNodeTopPadding() {
            return this.an;
        }
        set parentNodeTopPadding(a) {
            this.an = a;
            this.e("ParentNodeTopPadding");
        }
        get parentNodeRightPadding() {
            return this.al;
        }
        set parentNodeRightPadding(a) {
            this.al = a;
            this.e("ParentNodeRightPadding");
        }
        get parentNodeBottomPadding() {
            return this.ah;
        }
        set parentNodeBottomPadding(a) {
            this.ah = a;
            this.e("ParentNodeBottomPadding");
        }
        get labelHorizontalAlignment() {
            return this.cb;
        }
        set labelHorizontalAlignment(a) {
            this.cb = a;
            this.e("LabelHorizontalAlignment");
        }
        get labelVerticalAlignment() {
            return this.ce;
        }
        set labelVerticalAlignment(a) {
            this.ce = a;
            this.e("LabelVerticalAlignment");
        }
        get headerHeight() {
            return this.r;
        }
        set headerHeight(a) {
            this.r = a;
            this.e("HeaderHeight");
        }
        get outline() {
            return this.co;
        }
        set outline(a) {
            this.co = a;
            this.e("Outline");
        }
        get strokeThickness() {
            return this.ap;
        }
        set strokeThickness(a) {
            this.ap = a;
            this.e("StrokeThickness");
        }
        get layoutOrientation() {
            return this.cg;
        }
        set layoutOrientation(a) {
            this.cg = a;
            this.e("LayoutOrientation");
        }
        get layoutType() {
            return this.ch;
        }
        set layoutType(a) {
            this.ch = a;
            this.e("LayoutType");
        }
        get minimumDisplaySize() {
            return this.ab;
        }
        set minimumDisplaySize(a) {
            this.ab = a;
            this.e("MinimumDisplaySize");
        }
        get transitionDuration() {
            return this.bm;
        }
        set transitionDuration(a) {
            this.bm = a;
            this.e("TransitionDuration");
        }
        get pixelScalingRatio() {
            return this.ao;
        }
        set pixelScalingRatio(a) {
            this.ao = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.m;
        }
        set actualPixelScalingRatio(a) {
            this.m = a;
            this.e("ActualPixelScalingRatio");
        }
        get interactionPixelScalingRatio() {
            return this.w;
        }
        set interactionPixelScalingRatio(a) {
            this.w = a;
            this.e("InteractionPixelScalingRatio");
        }
        get actualInteractionPixelScalingRatio() {
            return this.l;
        }
        set actualInteractionPixelScalingRatio(a) {
            this.l = a;
            this.e("ActualInteractionPixelScalingRatio");
        }
        get focusItemRef() {
            return this.bv;
        }
        set focusItemRef(a) {
            this.bv = a;
            this.e("FocusItemRef");
        }
        get nodeStylingRef() {
            return this.cn;
        }
        set nodeStylingRef(a) {
            this.cn = a;
            this.e("NodeStylingRef");
        }
        get nodePointerOverRef() {
            return this.ck;
        }
        set nodePointerOverRef(a) {
            this.ck = a;
            this.e("NodePointerOverRef");
        }
        get nodePointerEnterRef() {
            return this.ci;
        }
        set nodePointerEnterRef(a) {
            this.ci = a;
            this.e("NodePointerEnterRef");
        }
        get nodePointerLeaveRef() {
            return this.cj;
        }
        set nodePointerLeaveRef(a) {
            this.cj = a;
            this.e("NodePointerLeaveRef");
        }
        get nodePointerPressedRef() {
            return this.cl;
        }
        set nodePointerPressedRef(a) {
            this.cl = a;
            this.e("NodePointerPressedRef");
        }
        get nodePointerReleasedRef() {
            return this.cm;
        }
        set nodePointerReleasedRef(a) {
            this.cm = a;
            this.e("NodePointerReleasedRef");
        }
        get width() {
            return this.cv;
        }
        set width(a) {
            this.cv = a;
            this.e("Width");
        }
        get height() {
            return this.b9;
        }
        set height(a) {
            this.b9 = a;
            this.e("Height");
        }
        get background() {
            return this.bp;
        }
        set background(a) {
            this.bp = a;
            this.e("Background");
        }
    }
    TreemapDescription.$t = /*@__PURE__*/ markType(TreemapDescription, 'TreemapDescription', Description.$);
    return TreemapDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleDescription = /*@__PURE__*/ (() => {
    class TreemapNodeStyleDescription extends Description {
        constructor() {
            super();
            this.ab = null;
            this.aa = null;
            this.ad = null;
            this.ae = null;
            this.ai = null;
            this.ac = null;
            this.h = 0;
            this.j = 0;
            this.i = 0;
            this.g = 0;
            this.l = 0;
            this.n = 0;
            this.m = 0;
            this.k = 0;
            this.f = 0;
            this.af = null;
            this.ag = null;
            this.z = null;
            this.ah = null;
            this.o = 0;
        }
        get_type() {
            return "TreemapNodeStyle";
        }
        get type() {
            return this.get_type();
        }
        get headerHoverBackground() {
            return this.ab;
        }
        set headerHoverBackground(a) {
            this.ab = a;
            this.e("HeaderHoverBackground");
        }
        get headerBackground() {
            return this.aa;
        }
        set headerBackground(a) {
            this.aa = a;
            this.e("HeaderBackground");
        }
        get headerTextColor() {
            return this.ad;
        }
        set headerTextColor(a) {
            this.ad = a;
            this.e("HeaderTextColor");
        }
        get label() {
            return this.ae;
        }
        set label(a) {
            this.ae = a;
            this.e("Label");
        }
        get textColor() {
            return this.ai;
        }
        set textColor(a) {
            this.ai = a;
            this.e("TextColor");
        }
        get headerHoverTextColor() {
            return this.ac;
        }
        set headerHoverTextColor(a) {
            this.ac = a;
            this.e("HeaderHoverTextColor");
        }
        get headerLabelLeftMargin() {
            return this.h;
        }
        set headerLabelLeftMargin(a) {
            this.h = a;
            this.e("HeaderLabelLeftMargin");
        }
        get headerLabelTopMargin() {
            return this.j;
        }
        set headerLabelTopMargin(a) {
            this.j = a;
            this.e("HeaderLabelTopMargin");
        }
        get headerLabelRightMargin() {
            return this.i;
        }
        set headerLabelRightMargin(a) {
            this.i = a;
            this.e("HeaderLabelRightMargin");
        }
        get headerLabelBottomMargin() {
            return this.g;
        }
        set headerLabelBottomMargin(a) {
            this.g = a;
            this.e("HeaderLabelBottomMargin");
        }
        get labelLeftMargin() {
            return this.l;
        }
        set labelLeftMargin(a) {
            this.l = a;
            this.e("LabelLeftMargin");
        }
        get labelTopMargin() {
            return this.n;
        }
        set labelTopMargin(a) {
            this.n = a;
            this.e("LabelTopMargin");
        }
        get labelRightMargin() {
            return this.m;
        }
        set labelRightMargin(a) {
            this.m = a;
            this.e("LabelRightMargin");
        }
        get labelBottomMargin() {
            return this.k;
        }
        set labelBottomMargin(a) {
            this.k = a;
            this.e("LabelBottomMargin");
        }
        get headerHeight() {
            return this.f;
        }
        set headerHeight(a) {
            this.f = a;
            this.e("HeaderHeight");
        }
        get labelHorizontalAlignment() {
            return this.af;
        }
        set labelHorizontalAlignment(a) {
            this.af = a;
            this.e("LabelHorizontalAlignment");
        }
        get labelVerticalAlignment() {
            return this.ag;
        }
        set labelVerticalAlignment(a) {
            this.ag = a;
            this.e("LabelVerticalAlignment");
        }
        get fill() {
            return this.z;
        }
        set fill(a) {
            this.z = a;
            this.e("Fill");
        }
        get outline() {
            return this.ah;
        }
        set outline(a) {
            this.ah = a;
            this.e("Outline");
        }
        get strokeThickness() {
            return this.o;
        }
        set strokeThickness(a) {
            this.o = a;
            this.e("StrokeThickness");
        }
    }
    TreemapNodeStyleDescription.$t = /*@__PURE__*/ markType(TreemapNodeStyleDescription, 'TreemapNodeStyleDescription', Description.$);
    return TreemapNodeStyleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodeStyleDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodeStyleDescriptionMetadata.a == null) {
                TreemapNodeStyleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodeStyleDescriptionMetadata.c(a, TreemapNodeStyleDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("HeaderHoverBackground", "Brush");
            b.item("HeaderBackground", "Brush");
            b.item("HeaderTextColor", "Brush");
            b.item("Label", "String");
            b.item("TextColor", "Brush");
            b.item("HeaderHoverTextColor", "Brush");
            b.item("HeaderLabelLeftMargin", "Number:double");
            b.item("HeaderLabelTopMargin", "Number:double");
            b.item("HeaderLabelRightMargin", "Number:double");
            b.item("HeaderLabelBottomMargin", "Number:double");
            b.item("LabelLeftMargin", "Number:double");
            b.item("LabelTopMargin", "Number:double");
            b.item("LabelRightMargin", "Number:double");
            b.item("LabelBottomMargin", "Number:double");
            b.item("HeaderHeight", "Number:double");
            b.item("LabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("LabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("LabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            b.item("LabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("Fill", "Brush");
            b.item("Outline", "Brush");
            b.item("StrokeThickness", "Number:double");
        }
        static d(a) {
            TreemapNodeStyleDescriptionMetadata.b(a);
            a.q("TreemapNodeStyle", () => new TreemapNodeStyleDescription());
            a.p("TreemapNodeStyle", TreemapNodeStyleDescriptionMetadata.a);
        }
    }
    TreemapNodeStyleDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodeStyleDescriptionMetadata, 'TreemapNodeStyleDescriptionMetadata');
    TreemapNodeStyleDescriptionMetadata.a = null;
    return TreemapNodeStyleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStylingEventArgsDescription = /*@__PURE__*/ (() => {
    class TreemapNodeStylingEventArgsDescription extends Description {
        constructor() {
            super();
            this.m = 0;
            this.l = 0;
            this.r = null;
            this.s = null;
            this.u = null;
            this.t = null;
            this.k = 0;
            this.v = null;
            this.j = 0;
            this.h = false;
            this.f = null;
        }
        get_type() {
            return "TreemapNodeStylingEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get value() {
            return this.m;
        }
        set value(a) {
            this.m = a;
            this.e("Value");
        }
        get sum() {
            return this.l;
        }
        set sum(a) {
            this.l = a;
            this.e("Sum");
        }
        get customValueRef() {
            return this.r;
        }
        set customValueRef(a) {
            this.r = a;
            this.e("CustomValueRef");
        }
        get itemRef() {
            return this.s;
        }
        set itemRef(a) {
            this.s = a;
            this.e("ItemRef");
        }
        get parentItemRef() {
            return this.u;
        }
        set parentItemRef(a) {
            this.u = a;
            this.e("ParentItemRef");
        }
        get label() {
            return this.t;
        }
        set label(a) {
            this.t = a;
            this.e("Label");
        }
        get parentValue() {
            return this.k;
        }
        set parentValue(a) {
            this.k = a;
            this.e("ParentValue");
        }
        get parentLabel() {
            return this.v;
        }
        set parentLabel(a) {
            this.v = a;
            this.e("ParentLabel");
        }
        get parentSum() {
            return this.j;
        }
        set parentSum(a) {
            this.j = a;
            this.e("ParentSum");
        }
        get isParent() {
            return this.h;
        }
        set isParent(a) {
            this.h = a;
            this.e("IsParent");
        }
        get style() {
            return this.f;
        }
        set style(a) {
            this.f = a;
            this.e("Style");
        }
    }
    TreemapNodeStylingEventArgsDescription.$t = /*@__PURE__*/ markType(TreemapNodeStylingEventArgsDescription, 'TreemapNodeStylingEventArgsDescription', Description.$);
    return TreemapNodeStylingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStylingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodeStylingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodeStylingEventArgsDescriptionMetadata.a == null) {
                TreemapNodeStylingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodeStylingEventArgsDescriptionMetadata.c(a, TreemapNodeStylingEventArgsDescriptionMetadata.a);
                TreemapNodeStyleDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Value", "Number:double");
            b.item("Sum", "Number:double");
            b.item("CustomValueRef", "(w:CustomValue,wf:CustomValue)DataRef");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("ParentItemRef", "(w:ParentItem,wf:ParentItem)DataRef");
            b.item("Label", "String");
            b.item("ParentValue", "Number:double");
            b.item("ParentLabel", "String");
            b.item("ParentSum", "Number:double");
            b.item("IsParent", "Boolean");
            b.item("Style", "ExportedType:TreemapNodeStyle");
        }
        static d(a) {
            TreemapNodeStylingEventArgsDescriptionMetadata.b(a);
            a.q("TreemapNodeStylingEventArgs", () => new TreemapNodeStylingEventArgsDescription());
            a.p("TreemapNodeStylingEventArgs", TreemapNodeStylingEventArgsDescriptionMetadata.a);
        }
    }
    TreemapNodeStylingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodeStylingEventArgsDescriptionMetadata, 'TreemapNodeStylingEventArgsDescriptionMetadata');
    TreemapNodeStylingEventArgsDescriptionMetadata.a = null;
    return TreemapNodeStylingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodePointerEventArgsDescription = /*@__PURE__*/ (() => {
    class TreemapNodePointerEventArgsDescription extends Description {
        constructor() {
            super();
            this.q = 0;
            this.p = 0;
            this.v = null;
            this.w = null;
            this.y = null;
            this.f = null;
            this.j = false;
            this.h = false;
            this.i = false;
            this.x = null;
            this.o = 0;
            this.z = null;
            this.n = 0;
        }
        get_type() {
            return "TreemapNodePointerEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get value() {
            return this.q;
        }
        set value(a) {
            this.q = a;
            this.e("Value");
        }
        get sum() {
            return this.p;
        }
        set sum(a) {
            this.p = a;
            this.e("Sum");
        }
        get customValueRef() {
            return this.v;
        }
        set customValueRef(a) {
            this.v = a;
            this.e("CustomValueRef");
        }
        get itemRef() {
            return this.w;
        }
        set itemRef(a) {
            this.w = a;
            this.e("ItemRef");
        }
        get parentItemRef() {
            return this.y;
        }
        set parentItemRef(a) {
            this.y = a;
            this.e("ParentItemRef");
        }
        get position() {
            return this.f;
        }
        set position(a) {
            this.f = a;
            this.e("Position");
        }
        get isRightButton() {
            return this.j;
        }
        set isRightButton(a) {
            this.j = a;
            this.e("IsRightButton");
        }
        get isHandled() {
            return this.h;
        }
        set isHandled(a) {
            this.h = a;
            this.e("IsHandled");
        }
        get isOverHeader() {
            return this.i;
        }
        set isOverHeader(a) {
            this.i = a;
            this.e("IsOverHeader");
        }
        get label() {
            return this.x;
        }
        set label(a) {
            this.x = a;
            this.e("Label");
        }
        get parentValue() {
            return this.o;
        }
        set parentValue(a) {
            this.o = a;
            this.e("ParentValue");
        }
        get parentLabel() {
            return this.z;
        }
        set parentLabel(a) {
            this.z = a;
            this.e("ParentLabel");
        }
        get parentSum() {
            return this.n;
        }
        set parentSum(a) {
            this.n = a;
            this.e("ParentSum");
        }
    }
    TreemapNodePointerEventArgsDescription.$t = /*@__PURE__*/ markType(TreemapNodePointerEventArgsDescription, 'TreemapNodePointerEventArgsDescription', Description.$);
    return TreemapNodePointerEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodePointerEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodePointerEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodePointerEventArgsDescriptionMetadata.a == null) {
                TreemapNodePointerEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodePointerEventArgsDescriptionMetadata.c(a, TreemapNodePointerEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Value", "Number:double");
            b.item("Sum", "Number:double");
            b.item("CustomValueRef", "(w:CustomValue,wf:CustomValue)DataRef");
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("ParentItemRef", "(w:ParentItem,wf:ParentItem)DataRef");
            b.item("Position", "Point");
            b.item("IsRightButton", "Boolean");
            b.item("IsHandled", "Boolean");
            b.item("IsOverHeader", "Boolean");
            b.item("Label", "String");
            b.item("ParentValue", "Number:double");
            b.item("ParentLabel", "String");
            b.item("ParentSum", "Number:double");
        }
        static d(a) {
            TreemapNodePointerEventArgsDescriptionMetadata.b(a);
            a.q("TreemapNodePointerEventArgs", () => new TreemapNodePointerEventArgsDescription());
            a.p("TreemapNodePointerEventArgs", TreemapNodePointerEventArgsDescriptionMetadata.a);
        }
    }
    TreemapNodePointerEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodePointerEventArgsDescriptionMetadata, 'TreemapNodePointerEventArgsDescriptionMetadata');
    TreemapNodePointerEventArgsDescriptionMetadata.a = null;
    return TreemapNodePointerEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapDescriptionMetadata.a == null) {
                TreemapDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapDescriptionMetadata.c(a, TreemapDescriptionMetadata.a);
                TreemapNodeStylingEventArgsDescriptionMetadata.d(a);
                TreemapNodePointerEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ValueMemberPath", "String");
            b.item("RootTitle", "String");
            b.item("BreadcrumbSequence", "String");
            b.item("ParentIdMemberPath", "String");
            b.item("LabelMemberPath", "String");
            b.item("CustomValueMemberPath", "String");
            b.item("IdMemberPath", "String");
            b.item("DataSourceRef", "(w:ItemsSource,j:dataSource,wf:ItemsSource)DataRef::object");
            b.item("FillBrushes", "BrushCollection:string");
            b.item("StyleMappings", "Collection:TreemapNodeStyleMapping:TreemapNodeStyleMappingCollection:TreemapNodeStyleMapping");
            b.item("FillScaleMode", "ExportedType:string:TreemapFillScaleMode");
            b.item("FillScaleMode@names", "Sum;GlobalSum;Value;GlobalValue");
            b.item("IsFillScaleLogarithmic", "Boolean");
            b.item("FillScaleLogarithmBase", "Number:int");
            b.item("FillScaleMinimumValue", "Number:double");
            b.item("FillScaleMaximumValue", "Number:double");
            b.item("LabelVerticalFitMode", "ExportedType:string:TreemapLabelVerticalFitMode");
            b.item("LabelVerticalFitMode@names", "Auto;Show;Hide");
            b.item("LabelHorizontalFitMode", "ExportedType:string:TreemapLabelHorizontalFitMode");
            b.item("LabelHorizontalFitMode@names", "Auto;Ellipsis;Hide");
            b.item("OverlayHeaderHoverBackground", "Brush");
            b.item("HeaderHoverBackground", "Brush");
            b.item("HeaderBackground", "Brush");
            b.item("OverlayHeaderBackground", "Brush");
            b.item("HeaderTextColor", "Brush");
            b.item("HeaderDarkTextColor", "Brush");
            b.item("TextColor", "Brush");
            b.item("DarkTextColor", "Brush");
            b.item("HeaderHoverTextColor", "Brush");
            b.item("HeaderHoverDarkTextColor", "Brush");
            b.item("FontFamily", "(w:FontFamily/FontFamilyTransform,wf:FontFamily,web:textStyle/FontFamilyTransform)String");
            b.item("FontSize", "(w:FontSize,wf:FontSize,web:textStyle/FontSizeTransform)Number:double");
            b.item("FontStyle", "(w:FontStyle/FontStyleTransform,wf:FontFamily/FontStyleTransform,web:textStyle/FontStyleTransform)String");
            b.item("FontWeight", "(w:FontWeight/FontWeightTransform,wf:FontFamily/FontWeightTransform,web:textStyle/FontWeightTransform)String");
            b.item("HeaderFontFamily", "(w:HeaderFontFamily/FontFamilyTransform,wf:HeaderFontFamily,web:headerTextStyle/FontFamilyTransform)String");
            b.item("HeaderFontSize", "(w:HeaderFontSize,wf:HeaderFontSize,web:headerTextStyle/FontSizeTransform)Number:double");
            b.item("HeaderFontStyle", "(w:HeaderFontStyle/FontStyleTransform,wf:HeaderFontFamily/FontStyleTransform,web:headerTextStyle/FontStyleTransform)String");
            b.item("HeaderFontWeight", "(w:HeaderFontWeight/FontWeightTransform,wf:HeaderFontFamily/FontWeightTransform,web:headerTextStyle/FontWeightTransform)String");
            b.item("HeaderDisplayMode", "ExportedType:string:TreemapHeaderDisplayMode");
            b.item("HeaderDisplayMode@names", "Auto;Header;Overlay");
            b.item("HeaderLabelLeftMargin", "Number:double");
            b.item("HeaderLabelTopMargin", "Number:double");
            b.item("HeaderLabelRightMargin", "Number:double");
            b.item("HeaderLabelBottomMargin", "Number:double");
            b.item("OverlayHeaderLabelLeftMargin", "Number:double");
            b.item("OverlayHeaderLabelTopMargin", "Number:double");
            b.item("OverlayHeaderLabelRightMargin", "Number:double");
            b.item("OverlayHeaderLabelBottomMargin", "Number:double");
            b.item("LabelLeftMargin", "Number:double");
            b.item("LabelTopMargin", "Number:double");
            b.item("LabelRightMargin", "Number:double");
            b.item("LabelBottomMargin", "Number:double");
            b.item("ParentNodeLeftMargin", "Number:double");
            b.item("ParentNodeTopMargin", "Number:double");
            b.item("ParentNodeRightMargin", "Number:double");
            b.item("ParentNodeBottomMargin", "Number:double");
            b.item("ParentNodeLeftPadding", "Number:double");
            b.item("ParentNodeTopPadding", "Number:double");
            b.item("ParentNodeRightPadding", "Number:double");
            b.item("ParentNodeBottomPadding", "Number:double");
            b.item("LabelHorizontalAlignment", "ExportedType:string:HorizontalAlignment");
            b.item("LabelHorizontalAlignment@names", "Left;Center;Right;Stretch");
            b.item("LabelVerticalAlignment", "ExportedType:string:VerticalAlignment");
            b.item("LabelVerticalAlignment@names", "Top;Center;Bottom;Stretch");
            b.item("HeaderHeight", "Number:double");
            b.item("Outline", "Brush");
            b.item("StrokeThickness", "Number:double");
            b.item("LayoutOrientation", "ExportedType:string:TreemapOrientation");
            b.item("LayoutOrientation@names", "Horizontal;Vertical");
            b.item("LayoutType", "ExportedType:string:TreemapLayoutType");
            b.item("LayoutType@names", "Squarified;SliceAndDice;Stripped");
            b.item("MinimumDisplaySize", "Number:double");
            b.item("TransitionDuration", "Number:int");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("InteractionPixelScalingRatio", "Number:double");
            b.item("ActualInteractionPixelScalingRatio", "Number:double");
            b.item("FocusItemRef", "(w:FocusItem,wf:FocusItem)DataRef");
            b.item("NodeStylingRef", "EventRef::nodeStyling");
            b.item("NodePointerOverRef", "EventRef::nodePointerOver");
            b.item("NodePointerEnterRef", "EventRef::nodePointerEnter");
            b.item("NodePointerLeaveRef", "EventRef::nodePointerLeave");
            b.item("NodePointerPressedRef", "EventRef::nodePointerPressed");
            b.item("NodePointerReleasedRef", "EventRef::nodePointerReleased");
            TreemapDescriptionMetadata.e(a, b);
        }
        static d(a) {
            TreemapDescriptionMetadata.b(a);
            a.q("Treemap", () => new TreemapDescription());
            a.p("Treemap", TreemapDescriptionMetadata.a);
        }
        static e(a, b) {
            b.item("_qualifiedName", "String:Infragistics.Controls.Charts.XamTreemap");
            b.item("Width", "(w:Width/DimensionTransform)String");
            b.item("Height", "(w:Height/DimensionTransform)String");
            b.item("Background", "(wf:BackColor/ColorTransform)Brush");
        }
    }
    TreemapDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapDescriptionMetadata, 'TreemapDescriptionMetadata');
    TreemapDescriptionMetadata.a = null;
    return TreemapDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleDescriptionModule = /*@__PURE__*/ (() => {
    class TreemapNodeStyleDescriptionModule extends Base {
        static register(a) {
            TreemapNodeStyleDescriptionMetadata.d(a);
        }
    }
    TreemapNodeStyleDescriptionModule.$t = /*@__PURE__*/ markType(TreemapNodeStyleDescriptionModule, 'TreemapNodeStyleDescriptionModule');
    return TreemapNodeStyleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleMappingDescription = /*@__PURE__*/ (() => {
    class TreemapNodeStyleMappingDescription extends TreemapNodeStyleDescription {
        constructor() {
            super();
            this.a1 = null;
            this.av = 0;
            this.au = 0;
            this.ay = null;
            this.a0 = null;
        }
        get_type() {
            return "TreemapNodeStyleMapping";
        }
        get targetType() {
            return this.a1;
        }
        set targetType(a) {
            this.a1 = a;
            this.e("TargetType");
        }
        get minimumValue() {
            return this.av;
        }
        set minimumValue(a) {
            this.av = a;
            this.e("MinimumValue");
        }
        get maximumValue() {
            return this.au;
        }
        set maximumValue(a) {
            this.au = a;
            this.e("MaximumValue");
        }
        get value() {
            return this.ay;
        }
        set value(a) {
            this.ay = a;
            this.e("Value");
        }
        get mappingMode() {
            return this.a0;
        }
        set mappingMode(a) {
            this.a0 = a;
            this.e("MappingMode");
        }
    }
    TreemapNodeStyleMappingDescription.$t = /*@__PURE__*/ markType(TreemapNodeStyleMappingDescription, 'TreemapNodeStyleMappingDescription', TreemapNodeStyleDescription.$);
    return TreemapNodeStyleMappingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleMappingDescriptionMetadata = /*@__PURE__*/ (() => {
    class TreemapNodeStyleMappingDescriptionMetadata extends Base {
        static b(a) {
            if (TreemapNodeStyleMappingDescriptionMetadata.a == null) {
                TreemapNodeStyleMappingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TreemapNodeStyleMappingDescriptionMetadata.c(a, TreemapNodeStyleMappingDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            TreemapNodeStyleDescriptionMetadata.c(a, b);
            b.item("TargetType", "ExportedType:string:TreemapNodeStyleMappingTargetType");
            b.item("TargetType@names", "All;Parent;Child");
            b.item("MinimumValue", "Number:double");
            b.item("MaximumValue", "Number:double");
            b.item("Value", "Unknown");
            b.item("MappingMode", "ExportedType:string:TreemapValueMappingMode");
            b.item("MappingMode@names", "Sum;Value;CustomValue");
        }
        static d(a) {
            TreemapNodeStyleMappingDescriptionMetadata.b(a);
            a.q("TreemapNodeStyleMapping", () => new TreemapNodeStyleMappingDescription());
            a.p("TreemapNodeStyleMapping", TreemapNodeStyleMappingDescriptionMetadata.a);
        }
    }
    TreemapNodeStyleMappingDescriptionMetadata.$t = /*@__PURE__*/ markType(TreemapNodeStyleMappingDescriptionMetadata, 'TreemapNodeStyleMappingDescriptionMetadata');
    TreemapNodeStyleMappingDescriptionMetadata.a = null;
    return TreemapNodeStyleMappingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapNodeStyleMappingDescriptionModule = /*@__PURE__*/ (() => {
    class TreemapNodeStyleMappingDescriptionModule extends Base {
        static register(a) {
            TreemapNodeStyleMappingDescriptionMetadata.d(a);
        }
    }
    TreemapNodeStyleMappingDescriptionModule.$t = /*@__PURE__*/ markType(TreemapNodeStyleMappingDescriptionModule, 'TreemapNodeStyleMappingDescriptionModule');
    return TreemapNodeStyleMappingDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TreemapDescriptionModule = /*@__PURE__*/ (() => {
    class TreemapDescriptionModule extends Base {
        static register(a) {
            TreemapDescriptionMetadata.d(a);
            TreemapNodeStyleDescriptionModule.register(a);
            TreemapNodeStyleMappingDescriptionModule.register(a);
        }
    }
    TreemapDescriptionModule.$t = /*@__PURE__*/ markType(TreemapDescriptionModule, 'TreemapDescriptionModule');
    return TreemapDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationDataSourceDescription = /*@__PURE__*/ (() => {
    class TriangulationDataSourceDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "TriangulationDataSource";
        }
        get type() {
            return this.get_type();
        }
        get importCompletedRef() {
            return this.f;
        }
        set importCompletedRef(a) {
            this.f = a;
            this.e("ImportCompletedRef");
        }
    }
    TriangulationDataSourceDescription.$t = /*@__PURE__*/ markType(TriangulationDataSourceDescription, 'TriangulationDataSourceDescription', Description.$);
    return TriangulationDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class TriangulationDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (TriangulationDataSourceDescriptionMetadata.a == null) {
                TriangulationDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TriangulationDataSourceDescriptionMetadata.c(a, TriangulationDataSourceDescriptionMetadata.a);
                AsyncCompletedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("ImportCompletedRef", "EventRef::importCompleted");
        }
        static d(a) {
            TriangulationDataSourceDescriptionMetadata.b(a);
            a.q("TriangulationDataSource", () => new TriangulationDataSourceDescription());
            a.p("TriangulationDataSource", TriangulationDataSourceDescriptionMetadata.a);
        }
    }
    TriangulationDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(TriangulationDataSourceDescriptionMetadata, 'TriangulationDataSourceDescriptionMetadata');
    TriangulationDataSourceDescriptionMetadata.a = null;
    return TriangulationDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadDataCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class UploadDataCompletedEventArgsDescription extends AsyncCompletedEventArgsDescription {
        constructor() {
            super();
        }
        get_type() {
            return "UploadDataCompletedEventArgs";
        }
    }
    UploadDataCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(UploadDataCompletedEventArgsDescription, 'UploadDataCompletedEventArgsDescription', AsyncCompletedEventArgsDescription.$);
    return UploadDataCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadDataCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class UploadDataCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (UploadDataCompletedEventArgsDescriptionMetadata.a == null) {
                UploadDataCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                UploadDataCompletedEventArgsDescriptionMetadata.c(a, UploadDataCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AsyncCompletedEventArgsDescriptionMetadata.c(a, b);
        }
        static d(a) {
            UploadDataCompletedEventArgsDescriptionMetadata.b(a);
            a.q("UploadDataCompletedEventArgs", () => new UploadDataCompletedEventArgsDescription());
            a.p("UploadDataCompletedEventArgs", UploadDataCompletedEventArgsDescriptionMetadata.a);
        }
    }
    UploadDataCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(UploadDataCompletedEventArgsDescriptionMetadata, 'UploadDataCompletedEventArgsDescriptionMetadata');
    UploadDataCompletedEventArgsDescriptionMetadata.a = null;
    return UploadDataCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadStringCompletedEventArgsDescription = /*@__PURE__*/ (() => {
    class UploadStringCompletedEventArgsDescription extends AsyncCompletedEventArgsDescription {
        constructor() {
            super();
        }
        get_type() {
            return "UploadStringCompletedEventArgs";
        }
    }
    UploadStringCompletedEventArgsDescription.$t = /*@__PURE__*/ markType(UploadStringCompletedEventArgsDescription, 'UploadStringCompletedEventArgsDescription', AsyncCompletedEventArgsDescription.$);
    return UploadStringCompletedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadStringCompletedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class UploadStringCompletedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (UploadStringCompletedEventArgsDescriptionMetadata.a == null) {
                UploadStringCompletedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                UploadStringCompletedEventArgsDescriptionMetadata.c(a, UploadStringCompletedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            AsyncCompletedEventArgsDescriptionMetadata.c(a, b);
        }
        static d(a) {
            UploadStringCompletedEventArgsDescriptionMetadata.b(a);
            a.q("UploadStringCompletedEventArgs", () => new UploadStringCompletedEventArgsDescription());
            a.p("UploadStringCompletedEventArgs", UploadStringCompletedEventArgsDescriptionMetadata.a);
        }
    }
    UploadStringCompletedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(UploadStringCompletedEventArgsDescriptionMetadata, 'UploadStringCompletedEventArgsDescriptionMetadata');
    UploadStringCompletedEventArgsDescriptionMetadata.a = null;
    return UploadStringCompletedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueOverlayDescription = /*@__PURE__*/ (() => {
    class ValueOverlayDescription extends SeriesDescription {
        constructor() {
            super();
            this.c8 = null;
            this.cv = 0;
            this.co = false;
            this.c5 = null;
            this.c7 = null;
            this.c4 = null;
            this.c2 = 0;
            this.c6 = null;
            this.cr = 0;
            this.ct = 0;
            this.cs = 0;
            this.cq = 0;
            this.cu = 0;
        }
        get_type() {
            return "ValueOverlay";
        }
        get axisRef() {
            return this.c8;
        }
        set axisRef(a) {
            this.c8 = a;
            this.e("AxisRef");
        }
        get value() {
            return this.cv;
        }
        set value(a) {
            this.cv = a;
            this.e("Value");
        }
        get isAxisAnnotationEnabled() {
            return this.co;
        }
        set isAxisAnnotationEnabled(a) {
            this.co = a;
            this.e("IsAxisAnnotationEnabled");
        }
        get axisAnnotationFormatLabelRef() {
            return this.c5;
        }
        set axisAnnotationFormatLabelRef(a) {
            this.c5 = a;
            this.e("AxisAnnotationFormatLabelRef");
        }
        get axisAnnotationTextColor() {
            return this.c7;
        }
        set axisAnnotationTextColor(a) {
            this.c7 = a;
            this.e("AxisAnnotationTextColor");
        }
        get axisAnnotationBackground() {
            return this.c4;
        }
        set axisAnnotationBackground(a) {
            this.c4 = a;
            this.e("AxisAnnotationBackground");
        }
        get axisAnnotationInterpolatedValuePrecision() {
            return this.c2;
        }
        set axisAnnotationInterpolatedValuePrecision(a) {
            this.c2 = a;
            this.e("AxisAnnotationInterpolatedValuePrecision");
        }
        get axisAnnotationOutline() {
            return this.c6;
        }
        set axisAnnotationOutline(a) {
            this.c6 = a;
            this.e("AxisAnnotationOutline");
        }
        get axisAnnotationPaddingLeft() {
            return this.cr;
        }
        set axisAnnotationPaddingLeft(a) {
            this.cr = a;
            this.e("AxisAnnotationPaddingLeft");
        }
        get axisAnnotationPaddingTop() {
            return this.ct;
        }
        set axisAnnotationPaddingTop(a) {
            this.ct = a;
            this.e("AxisAnnotationPaddingTop");
        }
        get axisAnnotationPaddingRight() {
            return this.cs;
        }
        set axisAnnotationPaddingRight(a) {
            this.cs = a;
            this.e("AxisAnnotationPaddingRight");
        }
        get axisAnnotationPaddingBottom() {
            return this.cq;
        }
        set axisAnnotationPaddingBottom(a) {
            this.cq = a;
            this.e("AxisAnnotationPaddingBottom");
        }
        get axisAnnotationStrokeThickness() {
            return this.cu;
        }
        set axisAnnotationStrokeThickness(a) {
            this.cu = a;
            this.e("AxisAnnotationStrokeThickness");
        }
    }
    ValueOverlayDescription.$t = /*@__PURE__*/ markType(ValueOverlayDescription, 'ValueOverlayDescription', SeriesDescription.$);
    return ValueOverlayDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueOverlayDescriptionMetadata = /*@__PURE__*/ (() => {
    class ValueOverlayDescriptionMetadata extends Base {
        static b(a) {
            if (ValueOverlayDescriptionMetadata.a == null) {
                ValueOverlayDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ValueOverlayDescriptionMetadata.c(a, ValueOverlayDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SeriesDescriptionMetadata.c(a, b);
            b.item("AxisRef", "(w:Axis,wf:Axis)DataRef::object");
            b.item("AxisRef@nameBinding", "true");
            b.item("Value", "Number:double");
            b.item("IsAxisAnnotationEnabled", "Boolean");
            b.item("AxisAnnotationFormatLabelRef", "(w:AxisAnnotationFormatLabel,wf:AxisAnnotationFormatLabel)MethodRef");
            b.item("AxisAnnotationTextColor", "Brush");
            b.item("AxisAnnotationBackground", "Brush");
            b.item("AxisAnnotationInterpolatedValuePrecision", "Number:int");
            b.item("AxisAnnotationOutline", "Brush");
            b.item("AxisAnnotationPaddingLeft", "Number:double");
            b.item("AxisAnnotationPaddingTop", "Number:double");
            b.item("AxisAnnotationPaddingRight", "Number:double");
            b.item("AxisAnnotationPaddingBottom", "Number:double");
            b.item("AxisAnnotationStrokeThickness", "Number:double");
        }
        static d(a) {
            ValueOverlayDescriptionMetadata.b(a);
            a.q("ValueOverlay", () => new ValueOverlayDescription());
            a.p("ValueOverlay", ValueOverlayDescriptionMetadata.a);
        }
    }
    ValueOverlayDescriptionMetadata.$t = /*@__PURE__*/ markType(ValueOverlayDescriptionMetadata, 'ValueOverlayDescriptionMetadata');
    ValueOverlayDescriptionMetadata.a = null;
    return ValueOverlayDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ValueOverlayDescriptionModule = /*@__PURE__*/ (() => {
    class ValueOverlayDescriptionModule extends Base {
        static register(a) {
            ValueOverlayDescriptionMetadata.d(a);
        }
    }
    ValueOverlayDescriptionModule.$t = /*@__PURE__*/ markType(ValueOverlayDescriptionModule, 'ValueOverlayDescriptionModule');
    return ValueOverlayDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalSeparatorCellInfoDescription = /*@__PURE__*/ (() => {
    class VerticalSeparatorCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fc = false;
        }
        get_type() {
            return "VerticalSeparatorCellInfo";
        }
        get isHitTestVisible() {
            return this.fc;
        }
        set isHitTestVisible(a) {
            this.fc = a;
            this.e("IsHitTestVisible");
        }
    }
    VerticalSeparatorCellInfoDescription.$t = /*@__PURE__*/ markType(VerticalSeparatorCellInfoDescription, 'VerticalSeparatorCellInfoDescription', CellInfoDescription.$);
    VerticalSeparatorCellInfoDescription.__marshalByValue1 = true;
    VerticalSeparatorCellInfoDescription.__marshalByValueAlias1 = "VerticalSeparatorCellModel";
    return VerticalSeparatorCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VerticalSeparatorCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class VerticalSeparatorCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (VerticalSeparatorCellInfoDescriptionMetadata.a == null) {
                VerticalSeparatorCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VerticalSeparatorCellInfoDescriptionMetadata.c(a, VerticalSeparatorCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("IsHitTestVisible", "Boolean");
        }
        static d(a) {
            VerticalSeparatorCellInfoDescriptionMetadata.b(a);
            a.q("VerticalSeparatorCellInfo", () => new VerticalSeparatorCellInfoDescription());
            a.p("VerticalSeparatorCellInfo", VerticalSeparatorCellInfoDescriptionMetadata.a);
        }
    }
    VerticalSeparatorCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(VerticalSeparatorCellInfoDescriptionMetadata, 'VerticalSeparatorCellInfoDescriptionMetadata');
    VerticalSeparatorCellInfoDescriptionMetadata.a = null;
    return VerticalSeparatorCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VirtualDataSourceDescription = /*@__PURE__*/ (() => {
    class VirtualDataSourceDescription extends BaseDataSourceDescription {
        constructor() {
            super();
            this.av = false;
            this.aw = false;
            this.a2 = 0;
            this.a1 = 0;
            this.a0 = 0;
            this.a6 = null;
            this.au = false;
        }
        get_type() {
            return "VirtualDataSource";
        }
        get isSectionCollapsable() {
            return this.av;
        }
        set isSectionCollapsable(a) {
            this.av = a;
            this.e("IsSectionCollapsable");
        }
        get isSectionExpandedDefault() {
            return this.aw;
        }
        set isSectionExpandedDefault(a) {
            this.aw = a;
            this.e("IsSectionExpandedDefault");
        }
        get pageSizeRequested() {
            return this.a2;
        }
        set pageSizeRequested(a) {
            this.a2 = a;
            this.e("PageSizeRequested");
        }
        get maxCachedPages() {
            return this.a1;
        }
        set maxCachedPages(a) {
            this.a1 = a;
            this.e("MaxCachedPages");
        }
        get actualPageSize() {
            return this.a0;
        }
        set actualPageSize(a) {
            this.a0 = a;
            this.e("ActualPageSize");
        }
        get concurrencyTag() {
            return this.a6;
        }
        set concurrencyTag(a) {
            this.a6 = a;
            this.e("ConcurrencyTag");
        }
        get isBatchingEnabled() {
            return this.au;
        }
        set isBatchingEnabled(a) {
            this.au = a;
            this.e("IsBatchingEnabled");
        }
    }
    VirtualDataSourceDescription.$t = /*@__PURE__*/ markType(VirtualDataSourceDescription, 'VirtualDataSourceDescription', BaseDataSourceDescription.$);
    return VirtualDataSourceDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VirtualDataSourceDescriptionMetadata = /*@__PURE__*/ (() => {
    class VirtualDataSourceDescriptionMetadata extends Base {
        static b(a) {
            if (VirtualDataSourceDescriptionMetadata.a == null) {
                VirtualDataSourceDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                VirtualDataSourceDescriptionMetadata.c(a, VirtualDataSourceDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            BaseDataSourceDescriptionMetadata.c(a, b);
            b.item("IsSectionCollapsable", "Boolean");
            b.item("IsSectionExpandedDefault", "Boolean");
            b.item("PageSizeRequested", "Number:int");
            b.item("MaxCachedPages", "Number:int");
            b.item("ActualPageSize", "Number:int");
            b.item("ConcurrencyTag", "String");
            b.item("IsBatchingEnabled", "Boolean");
        }
        static d(a) {
            VirtualDataSourceDescriptionMetadata.b(a);
            a.q("VirtualDataSource", () => new VirtualDataSourceDescription());
            a.p("VirtualDataSource", VirtualDataSourceDescriptionMetadata.a);
        }
    }
    VirtualDataSourceDescriptionMetadata.$t = /*@__PURE__*/ markType(VirtualDataSourceDescriptionMetadata, 'VirtualDataSourceDescriptionMetadata');
    VirtualDataSourceDescriptionMetadata.a = null;
    return VirtualDataSourceDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JsonDictionaryValueType_$type = /*@__PURE__*/ markEnum('JsonDictionaryValueType', 'NumberValue,0|BooleanValue,1|StringValue,2|NullValue,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisAnnotationDescription = /*@__PURE__*/ (() => {
    class AxisAnnotationDescription extends Description {
        constructor() {
            super();
            this.x = null;
            this.v = null;
            this.t = null;
            this.f = null;
            this.s = null;
            this.w = null;
            this.r = null;
            this.u = null;
            this.l = 0;
            this.i = 0;
            this.k = 0;
            this.j = 0;
            this.h = 0;
        }
        get_type() {
            return "AxisAnnotation";
        }
        get type() {
            return this.get_type();
        }
        get valueRef() {
            return this.x;
        }
        set valueRef(a) {
            this.x = a;
            this.e("ValueRef");
        }
        get text() {
            return this.v;
        }
        set text(a) {
            this.v = a;
            this.e("Text");
        }
        get labelFormat() {
            return this.t;
        }
        set labelFormat(a) {
            this.t = a;
            this.e("LabelFormat");
        }
        get labelFormatSpecifiers() {
            return this.f;
        }
        set labelFormatSpecifiers(a) {
            this.f = a;
            this.e("LabelFormatSpecifiers");
        }
        get formatLabelRef() {
            return this.s;
        }
        set formatLabelRef(a) {
            this.s = a;
            this.e("FormatLabelRef");
        }
        get textColor() {
            return this.w;
        }
        set textColor(a) {
            this.w = a;
            this.e("TextColor");
        }
        get background() {
            return this.r;
        }
        set background(a) {
            this.r = a;
            this.e("Background");
        }
        get outline() {
            return this.u;
        }
        set outline(a) {
            this.u = a;
            this.e("Outline");
        }
        get strokeThickness() {
            return this.l;
        }
        set strokeThickness(a) {
            this.l = a;
            this.e("StrokeThickness");
        }
        get backgroundPaddingLeft() {
            return this.i;
        }
        set backgroundPaddingLeft(a) {
            this.i = a;
            this.e("BackgroundPaddingLeft");
        }
        get backgroundPaddingTop() {
            return this.k;
        }
        set backgroundPaddingTop(a) {
            this.k = a;
            this.e("BackgroundPaddingTop");
        }
        get backgroundPaddingRight() {
            return this.j;
        }
        set backgroundPaddingRight(a) {
            this.j = a;
            this.e("BackgroundPaddingRight");
        }
        get backgroundPaddingBottom() {
            return this.h;
        }
        set backgroundPaddingBottom(a) {
            this.h = a;
            this.e("BackgroundPaddingBottom");
        }
    }
    AxisAnnotationDescription.$t = /*@__PURE__*/ markType(AxisAnnotationDescription, 'AxisAnnotationDescription', Description.$);
    return AxisAnnotationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisAnnotationDescriptionMetadata = /*@__PURE__*/ (() => {
    class AxisAnnotationDescriptionMetadata extends Base {
        static b(a) {
            if (AxisAnnotationDescriptionMetadata.a == null) {
                AxisAnnotationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                AxisAnnotationDescriptionMetadata.c(a, AxisAnnotationDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("Text", "String");
            b.item("LabelFormat", "String");
            b.item("LabelFormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            b.item("TextColor", "Brush");
            b.item("Background", "Brush");
            b.item("Outline", "Brush");
            b.item("StrokeThickness", "Number:double");
            b.item("BackgroundPaddingLeft", "Number:double");
            b.item("BackgroundPaddingTop", "Number:double");
            b.item("BackgroundPaddingRight", "Number:double");
            b.item("BackgroundPaddingBottom", "Number:double");
        }
        static d(a) {
            AxisAnnotationDescriptionMetadata.b(a);
            a.q("AxisAnnotation", () => new AxisAnnotationDescription());
            a.p("AxisAnnotation", AxisAnnotationDescriptionMetadata.a);
        }
    }
    AxisAnnotationDescriptionMetadata.$t = /*@__PURE__*/ markType(AxisAnnotationDescriptionMetadata, 'AxisAnnotationDescriptionMetadata');
    AxisAnnotationDescriptionMetadata.a = null;
    return AxisAnnotationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushScaleDescriptionModule = /*@__PURE__*/ (() => {
    class BrushScaleDescriptionModule extends Base {
        static register(a) {
            BrushScaleDescriptionMetadata.d(a);
        }
    }
    BrushScaleDescriptionModule.$t = /*@__PURE__*/ markType(BrushScaleDescriptionModule, 'BrushScaleDescriptionModule');
    return BrushScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutAnnotationDescription = /*@__PURE__*/ (() => {
    class CalloutAnnotationDescription extends Description {
        constructor() {
            super();
            this.z = null;
            this.aa = null;
            this.x = null;
            this.u = null;
            this.s = null;
            this.f = null;
            this.t = null;
            this.y = null;
            this.r = null;
            this.w = null;
            this.v = null;
            this.l = 0;
            this.i = 0;
            this.k = 0;
            this.j = 0;
            this.h = 0;
        }
        get_type() {
            return "CalloutAnnotation";
        }
        get type() {
            return this.get_type();
        }
        get xValueRef() {
            return this.z;
        }
        set xValueRef(a) {
            this.z = a;
            this.e("XValueRef");
        }
        get yValueRef() {
            return this.aa;
        }
        set yValueRef(a) {
            this.aa = a;
            this.e("YValueRef");
        }
        get text() {
            return this.x;
        }
        set text(a) {
            this.x = a;
            this.e("Text");
        }
        get keyRef() {
            return this.u;
        }
        set keyRef(a) {
            this.u = a;
            this.e("KeyRef");
        }
        get contentRef() {
            return this.s;
        }
        set contentRef(a) {
            this.s = a;
            this.e("ContentRef");
        }
        get series() {
            return this.f;
        }
        set series(a) {
            this.f = a;
            this.e("Series");
        }
        get formatLabelRef() {
            return this.t;
        }
        set formatLabelRef(a) {
            this.t = a;
            this.e("FormatLabelRef");
        }
        get textColor() {
            return this.y;
        }
        set textColor(a) {
            this.y = a;
            this.e("TextColor");
        }
        get background() {
            return this.r;
        }
        set background(a) {
            this.r = a;
            this.e("Background");
        }
        get outline() {
            return this.w;
        }
        set outline(a) {
            this.w = a;
            this.e("Outline");
        }
        get leaderBrush() {
            return this.v;
        }
        set leaderBrush(a) {
            this.v = a;
            this.e("LeaderBrush");
        }
        get strokeThickness() {
            return this.l;
        }
        set strokeThickness(a) {
            this.l = a;
            this.e("StrokeThickness");
        }
        get backgroundPaddingLeft() {
            return this.i;
        }
        set backgroundPaddingLeft(a) {
            this.i = a;
            this.e("BackgroundPaddingLeft");
        }
        get backgroundPaddingTop() {
            return this.k;
        }
        set backgroundPaddingTop(a) {
            this.k = a;
            this.e("BackgroundPaddingTop");
        }
        get backgroundPaddingRight() {
            return this.j;
        }
        set backgroundPaddingRight(a) {
            this.j = a;
            this.e("BackgroundPaddingRight");
        }
        get backgroundPaddingBottom() {
            return this.h;
        }
        set backgroundPaddingBottom(a) {
            this.h = a;
            this.e("BackgroundPaddingBottom");
        }
    }
    CalloutAnnotationDescription.$t = /*@__PURE__*/ markType(CalloutAnnotationDescription, 'CalloutAnnotationDescription', Description.$);
    return CalloutAnnotationDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CalloutAnnotationDescriptionMetadata = /*@__PURE__*/ (() => {
    class CalloutAnnotationDescriptionMetadata extends Base {
        static b(a) {
            if (CalloutAnnotationDescriptionMetadata.a == null) {
                CalloutAnnotationDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CalloutAnnotationDescriptionMetadata.c(a, CalloutAnnotationDescriptionMetadata.a);
                SeriesDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("XValueRef", "(w:XValue,wf:XValue)DataRef");
            b.item("YValueRef", "(w:YValue,wf:YValue)DataRef");
            b.item("Text", "String");
            b.item("KeyRef", "(w:Key,wf:Key)DataRef");
            b.item("ContentRef", "(w:Content,wf:Content)DataRef");
            b.item("Series", "ExportedType:Series");
            b.item("FormatLabelRef", "(w:FormatLabel,wf:FormatLabel)MethodRef");
            b.item("TextColor", "Brush");
            b.item("Background", "Brush");
            b.item("Outline", "Brush");
            b.item("LeaderBrush", "Brush");
            b.item("StrokeThickness", "Number:double");
            b.item("BackgroundPaddingLeft", "Number:double");
            b.item("BackgroundPaddingTop", "Number:double");
            b.item("BackgroundPaddingRight", "Number:double");
            b.item("BackgroundPaddingBottom", "Number:double");
        }
        static d(a) {
            CalloutAnnotationDescriptionMetadata.b(a);
            a.q("CalloutAnnotation", () => new CalloutAnnotationDescription());
            a.p("CalloutAnnotation", CalloutAnnotationDescriptionMetadata.a);
        }
    }
    CalloutAnnotationDescriptionMetadata.$t = /*@__PURE__*/ markType(CalloutAnnotationDescriptionMetadata, 'CalloutAnnotationDescriptionMetadata');
    CalloutAnnotationDescriptionMetadata.a = null;
    return CalloutAnnotationDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionDescription = /*@__PURE__*/ (() => {
    class ColumnFilterConditionDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ColumnFilterCondition";
        }
        get type() {
            return this.get_type();
        }
    }
    ColumnFilterConditionDescription.$t = /*@__PURE__*/ markType(ColumnFilterConditionDescription, 'ColumnFilterConditionDescription', Description.$);
    return ColumnFilterConditionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnComparisonFilterConditionDescription = /*@__PURE__*/ (() => {
    class ColumnComparisonFilterConditionDescription extends ColumnFilterConditionDescription {
        constructor() {
            super();
            this.i = null;
            this.j = null;
            this.g = false;
        }
        get_type() {
            return "ColumnComparisonFilterCondition";
        }
        get operator() {
            return this.i;
        }
        set operator(a) {
            this.i = a;
            this.e("Operator");
        }
        get valueRef() {
            return this.j;
        }
        set valueRef(a) {
            this.j = a;
            this.e("ValueRef");
        }
        get isCaseSensitive() {
            return this.g;
        }
        set isCaseSensitive(a) {
            this.g = a;
            this.e("IsCaseSensitive");
        }
    }
    ColumnComparisonFilterConditionDescription.$t = /*@__PURE__*/ markType(ColumnComparisonFilterConditionDescription, 'ColumnComparisonFilterConditionDescription', ColumnFilterConditionDescription.$);
    return ColumnComparisonFilterConditionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnComparisonFilterConditionDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnComparisonFilterConditionDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnComparisonFilterConditionDescriptionMetadata.a == null) {
                ColumnComparisonFilterConditionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnComparisonFilterConditionDescriptionMetadata.c(a, ColumnComparisonFilterConditionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ColumnFilterConditionDescriptionMetadata.c(a, b);
            b.item("Operator", "ExportedType:string:ColumnComparisonConditionOperatorType");
            b.item("Operator@names", "Contains;DoesNotContain;DoesNotEndWith;DoesNotStartWith;EndsWith;Equals;GreaterThan;GreaterThanOrEqualTo;LessThan;LessThanOrEqualTo;NotEquals;StartsWith;IsNotNull;IsNull");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
            b.item("IsCaseSensitive", "Boolean");
        }
        static d(a) {
            ColumnComparisonFilterConditionDescriptionMetadata.b(a);
            a.q("ColumnComparisonFilterCondition", () => new ColumnComparisonFilterConditionDescription());
            a.p("ColumnComparisonFilterCondition", ColumnComparisonFilterConditionDescriptionMetadata.a);
        }
    }
    ColumnComparisonFilterConditionDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnComparisonFilterConditionDescriptionMetadata, 'ColumnComparisonFilterConditionDescriptionMetadata');
    ColumnComparisonFilterConditionDescriptionMetadata.a = null;
    return ColumnComparisonFilterConditionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnExchangerDescription = /*@__PURE__*/ (() => {
    class ColumnExchangerDescription extends Description {
        constructor() {
            super();
            this.f = 0;
        }
        get_type() {
            return "ColumnExchanger";
        }
        get type() {
            return this.get_type();
        }
        get targetIndex() {
            return this.f;
        }
        set targetIndex(a) {
            this.f = a;
            this.e("TargetIndex");
        }
    }
    ColumnExchangerDescription.$t = /*@__PURE__*/ markType(ColumnExchangerDescription, 'ColumnExchangerDescription', Description.$);
    return ColumnExchangerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnExchangerDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnExchangerDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnExchangerDescriptionMetadata.a == null) {
                ColumnExchangerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnExchangerDescriptionMetadata.c(a, ColumnExchangerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("TargetIndex", "Number:int");
        }
        static d(a) {
            ColumnExchangerDescriptionMetadata.b(a);
            a.q("ColumnExchanger", () => new ColumnExchangerDescription());
            a.p("ColumnExchanger", ColumnExchangerDescriptionMetadata.a);
        }
    }
    ColumnExchangerDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnExchangerDescriptionMetadata, 'ColumnExchangerDescriptionMetadata');
    ColumnExchangerDescriptionMetadata.a = null;
    return ColumnExchangerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionGroupDescription = /*@__PURE__*/ (() => {
    class ColumnFilterConditionGroupDescription extends ColumnFilterConditionDescription {
        constructor() {
            super();
            this.i = false;
            this.g = null;
        }
        get_type() {
            return "ColumnFilterConditionGroup";
        }
        get usesOrOperator() {
            return this.i;
        }
        set usesOrOperator(a) {
            this.i = a;
            this.e("UsesOrOperator");
        }
        get item() {
            return this.g;
        }
        set item(a) {
            this.g = a;
            this.e("Item");
        }
    }
    ColumnFilterConditionGroupDescription.$t = /*@__PURE__*/ markType(ColumnFilterConditionGroupDescription, 'ColumnFilterConditionGroupDescription', ColumnFilterConditionDescription.$);
    return ColumnFilterConditionGroupDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnFilterConditionGroupDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnFilterConditionGroupDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnFilterConditionGroupDescriptionMetadata.a == null) {
                ColumnFilterConditionGroupDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnFilterConditionGroupDescriptionMetadata.c(a, ColumnFilterConditionGroupDescriptionMetadata.a);
                ColumnFilterConditionDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ColumnFilterConditionDescriptionMetadata.c(a, b);
            b.item("UsesOrOperator", "Boolean");
            b.item("Item", "(w:this[],wf:this[])ExportedType:ColumnFilterCondition");
        }
        static d(a) {
            ColumnFilterConditionGroupDescriptionMetadata.b(a);
            a.q("ColumnFilterConditionGroup", () => new ColumnFilterConditionGroupDescription());
            a.p("ColumnFilterConditionGroup", ColumnFilterConditionGroupDescriptionMetadata.a);
        }
    }
    ColumnFilterConditionGroupDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnFilterConditionGroupDescriptionMetadata, 'ColumnFilterConditionGroupDescriptionMetadata');
    ColumnFilterConditionGroupDescriptionMetadata.a = null;
    return ColumnFilterConditionGroupDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPropertySetterDescription = /*@__PURE__*/ (() => {
    class ColumnPropertySetterDescription extends Description {
        constructor() {
            super();
            this.f = null;
            this.g = null;
            this.h = null;
        }
        get_type() {
            return "ColumnPropertySetter";
        }
        get type() {
            return this.get_type();
        }
        get columnName() {
            return this.f;
        }
        set columnName(a) {
            this.f = a;
            this.e("ColumnName");
        }
        get propertyName() {
            return this.g;
        }
        set propertyName(a) {
            this.g = a;
            this.e("PropertyName");
        }
        get valueRef() {
            return this.h;
        }
        set valueRef(a) {
            this.h = a;
            this.e("ValueRef");
        }
    }
    ColumnPropertySetterDescription.$t = /*@__PURE__*/ markType(ColumnPropertySetterDescription, 'ColumnPropertySetterDescription', Description.$);
    return ColumnPropertySetterDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColumnPropertySetterDescriptionMetadata = /*@__PURE__*/ (() => {
    class ColumnPropertySetterDescriptionMetadata extends Base {
        static b(a) {
            if (ColumnPropertySetterDescriptionMetadata.a == null) {
                ColumnPropertySetterDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ColumnPropertySetterDescriptionMetadata.c(a, ColumnPropertySetterDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ColumnName", "String");
            b.item("PropertyName", "String");
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            ColumnPropertySetterDescriptionMetadata.b(a);
            a.q("ColumnPropertySetter", () => new ColumnPropertySetterDescription());
            a.p("ColumnPropertySetter", ColumnPropertySetterDescriptionMetadata.a);
        }
    }
    ColumnPropertySetterDescriptionMetadata.$t = /*@__PURE__*/ markType(ColumnPropertySetterDescriptionMetadata, 'ColumnPropertySetterDescriptionMetadata');
    ColumnPropertySetterDescriptionMetadata.a = null;
    return ColumnPropertySetterDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ContourValueResolverDescription = /*@__PURE__*/ (() => {
    class ContourValueResolverDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ContourValueResolver";
        }
        get type() {
            return this.get_type();
        }
    }
    ContourValueResolverDescription.$t = /*@__PURE__*/ markType(ContourValueResolverDescription, 'ContourValueResolverDescription', Description.$);
    return ContourValueResolverDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverDescription = /*@__PURE__*/ (() => {
    class CustomContourValueResolverDescription extends ContourValueResolverDescription {
        constructor() {
            super();
            this.g = null;
        }
        get_type() {
            return "CustomContourValueResolver";
        }
        get getCustomContourValuesRef() {
            return this.g;
        }
        set getCustomContourValuesRef(a) {
            this.g = a;
            this.e("GetCustomContourValuesRef");
        }
    }
    CustomContourValueResolverDescription.$t = /*@__PURE__*/ markType(CustomContourValueResolverDescription, 'CustomContourValueResolverDescription', ContourValueResolverDescription.$);
    return CustomContourValueResolverDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverEventArgsDescription = /*@__PURE__*/ (() => {
    class CustomContourValueResolverEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "CustomContourValueResolverEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get contourValues() {
            return this.f;
        }
        set contourValues(a) {
            this.f = a;
            this.e("ContourValues");
        }
    }
    CustomContourValueResolverEventArgsDescription.$t = /*@__PURE__*/ markType(CustomContourValueResolverEventArgsDescription, 'CustomContourValueResolverEventArgsDescription', Description.$);
    return CustomContourValueResolverEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomContourValueResolverEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (CustomContourValueResolverEventArgsDescriptionMetadata.a == null) {
                CustomContourValueResolverEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomContourValueResolverEventArgsDescriptionMetadata.c(a, CustomContourValueResolverEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ContourValues", "Array:double");
        }
        static d(a) {
            CustomContourValueResolverEventArgsDescriptionMetadata.b(a);
            a.q("CustomContourValueResolverEventArgs", () => new CustomContourValueResolverEventArgsDescription());
            a.p("CustomContourValueResolverEventArgs", CustomContourValueResolverEventArgsDescriptionMetadata.a);
        }
    }
    CustomContourValueResolverEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomContourValueResolverEventArgsDescriptionMetadata, 'CustomContourValueResolverEventArgsDescriptionMetadata');
    CustomContourValueResolverEventArgsDescriptionMetadata.a = null;
    return CustomContourValueResolverEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomContourValueResolverDescriptionMetadata extends Base {
        static b(a) {
            if (CustomContourValueResolverDescriptionMetadata.a == null) {
                CustomContourValueResolverDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomContourValueResolverDescriptionMetadata.c(a, CustomContourValueResolverDescriptionMetadata.a);
                CustomContourValueResolverEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            ContourValueResolverDescriptionMetadata.c(a, b);
            b.item("GetCustomContourValuesRef", "EventRef::getCustomContourValues");
        }
        static d(a) {
            CustomContourValueResolverDescriptionMetadata.b(a);
            a.q("CustomContourValueResolver", () => new CustomContourValueResolverDescription());
            a.p("CustomContourValueResolver", CustomContourValueResolverDescriptionMetadata.a);
        }
    }
    CustomContourValueResolverDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomContourValueResolverDescriptionMetadata, 'CustomContourValueResolverDescriptionMetadata');
    CustomContourValueResolverDescriptionMetadata.a = null;
    return CustomContourValueResolverDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomContourValueResolverDescriptionModule = /*@__PURE__*/ (() => {
    class CustomContourValueResolverDescriptionModule extends Base {
        static register(a) {
            CustomContourValueResolverDescriptionMetadata.d(a);
        }
    }
    CustomContourValueResolverDescriptionModule.$t = /*@__PURE__*/ markType(CustomContourValueResolverDescriptionModule, 'CustomContourValueResolverDescriptionModule');
    return CustomContourValueResolverDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteBrushScaleDescription = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScaleDescription extends BrushScaleDescription {
        constructor() {
            super();
            this.k = null;
        }
        get_type() {
            return "CustomPaletteBrushScale";
        }
        get brushSelectionMode() {
            return this.k;
        }
        set brushSelectionMode(a) {
            this.k = a;
            this.e("BrushSelectionMode");
        }
    }
    CustomPaletteBrushScaleDescription.$t = /*@__PURE__*/ markType(CustomPaletteBrushScaleDescription, 'CustomPaletteBrushScaleDescription', BrushScaleDescription.$);
    return CustomPaletteBrushScaleDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteBrushScaleDescriptionMetadata = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScaleDescriptionMetadata extends Base {
        static b(a) {
            if (CustomPaletteBrushScaleDescriptionMetadata.a == null) {
                CustomPaletteBrushScaleDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CustomPaletteBrushScaleDescriptionMetadata.c(a, CustomPaletteBrushScaleDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            BrushScaleDescriptionMetadata.c(a, b);
            b.item("BrushSelectionMode", "ExportedType:string:BrushSelectionMode");
            b.item("BrushSelectionMode@names", "Select;Interpolate");
        }
        static d(a) {
            CustomPaletteBrushScaleDescriptionMetadata.b(a);
            a.q("CustomPaletteBrushScale", () => new CustomPaletteBrushScaleDescription());
            a.p("CustomPaletteBrushScale", CustomPaletteBrushScaleDescriptionMetadata.a);
        }
    }
    CustomPaletteBrushScaleDescriptionMetadata.$t = /*@__PURE__*/ markType(CustomPaletteBrushScaleDescriptionMetadata, 'CustomPaletteBrushScaleDescriptionMetadata');
    CustomPaletteBrushScaleDescriptionMetadata.a = null;
    return CustomPaletteBrushScaleDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomPaletteBrushScaleDescriptionModule = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScaleDescriptionModule extends Base {
        static register(a) {
            CustomPaletteBrushScaleDescriptionMetadata.d(a);
        }
    }
    CustomPaletteBrushScaleDescriptionModule.$t = /*@__PURE__*/ markType(CustomPaletteBrushScaleDescriptionModule, 'CustomPaletteBrushScaleDescriptionModule');
    return CustomPaletteBrushScaleDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataContextDescription = /*@__PURE__*/ (() => {
    class DataContextDescription extends Description {
        constructor() {
            super();
            this.m = null;
            this.j = null;
            this.o = null;
            this.l = null;
            this.k = null;
            this.g = 0;
            this.n = null;
        }
        get_type() {
            return "DataContext";
        }
        get type() {
            return this.get_type();
        }
        get itemRef() {
            return this.m;
        }
        set itemRef(a) {
            this.m = a;
            this.e("ItemRef");
        }
        get actualItemBrush() {
            return this.j;
        }
        set actualItemBrush(a) {
            this.j = a;
            this.e("ActualItemBrush");
        }
        get outline() {
            return this.o;
        }
        set outline(a) {
            this.o = a;
            this.e("Outline");
        }
        get itemLabelRef() {
            return this.l;
        }
        set itemLabelRef(a) {
            this.l = a;
            this.e("ItemLabelRef");
        }
        get itemBrush() {
            return this.k;
        }
        set itemBrush(a) {
            this.k = a;
            this.e("ItemBrush");
        }
        get thickness() {
            return this.g;
        }
        set thickness(a) {
            this.g = a;
            this.e("Thickness");
        }
        get legendLabelRef() {
            return this.n;
        }
        set legendLabelRef(a) {
            this.n = a;
            this.e("LegendLabelRef");
        }
    }
    DataContextDescription.$t = /*@__PURE__*/ markType(DataContextDescription, 'DataContextDescription', Description.$);
    DataContextDescription.__marshalByValue = true;
    DataContextDescription.__marshalByValueAlias = "DataContext";
    return DataContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataContextDescriptionMetadata extends Base {
        static b(a) {
            if (DataContextDescriptionMetadata.a == null) {
                DataContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataContextDescriptionMetadata.c(a, DataContextDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ItemRef", "(w:Item,wf:Item)DataRef");
            b.item("ActualItemBrush", "Brush");
            b.item("Outline", "Brush");
            b.item("ItemLabelRef", "(w:ItemLabel,wf:ItemLabel)DataRef");
            b.item("ItemBrush", "Brush");
            b.item("Thickness", "Number:double");
            b.item("LegendLabelRef", "(w:LegendLabel,wf:LegendLabel)DataRef");
        }
        static d(a) {
            DataContextDescriptionMetadata.b(a);
            a.q("DataContext", () => new DataContextDescription());
            a.p("DataContext", DataContextDescriptionMetadata.a);
        }
    }
    DataContextDescriptionMetadata.$t = /*@__PURE__*/ markType(DataContextDescriptionMetadata, 'DataContextDescriptionMetadata');
    DataContextDescriptionMetadata.a = null;
    return DataContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataProviderSchemaChangedEventArgsDescription = /*@__PURE__*/ (() => {
    class DataSourceDataProviderSchemaChangedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "DataSourceDataProviderSchemaChangedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    DataSourceDataProviderSchemaChangedEventArgsDescription.$t = /*@__PURE__*/ markType(DataSourceDataProviderSchemaChangedEventArgsDescription, 'DataSourceDataProviderSchemaChangedEventArgsDescription', Description.$);
    return DataSourceDataProviderSchemaChangedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a == null) {
                DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.c(a, DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.b(a);
            a.q("DataSourceDataProviderSchemaChangedEventArgs", () => new DataSourceDataProviderSchemaChangedEventArgsDescription());
            a.p("DataSourceDataProviderSchemaChangedEventArgs", DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a);
        }
    }
    DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata, 'DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata');
    DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata.a = null;
    return DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeCellInfoDescription = /*@__PURE__*/ (() => {
    class DateTimeCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fg = new Date();
            this.fl = null;
            this.fb = null;
            this.fk = null;
            this.fj = null;
            this.fe = false;
        }
        get_type() {
            return "DateTimeCellInfo";
        }
        get dateTimeValue() {
            return this.fg;
        }
        set dateTimeValue(a) {
            this.fg = a;
            this.e("DateTimeValue");
        }
        get formatStringOverride() {
            return this.fl;
        }
        set formatStringOverride(a) {
            this.fl = a;
            this.e("FormatStringOverride");
        }
        get formatSpecifiers() {
            return this.fb;
        }
        set formatSpecifiers(a) {
            this.fb = a;
            this.e("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.fk;
        }
        set formatOverrideRef(a) {
            this.fk = a;
            this.e("FormatOverrideRef");
        }
        get dateTimeFormat() {
            return this.fj;
        }
        set dateTimeFormat(a) {
            this.fj = a;
            this.e("DateTimeFormat");
        }
        get isOffsetValue() {
            return this.fe;
        }
        set isOffsetValue(a) {
            this.fe = a;
            this.e("IsOffsetValue");
        }
    }
    DateTimeCellInfoDescription.$t = /*@__PURE__*/ markType(DateTimeCellInfoDescription, 'DateTimeCellInfoDescription', CellInfoDescription.$);
    DateTimeCellInfoDescription.__marshalByValue1 = true;
    DateTimeCellInfoDescription.__marshalByValueAlias1 = "DateTimeCellModel";
    return DateTimeCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DateTimeCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class DateTimeCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (DateTimeCellInfoDescriptionMetadata.a == null) {
                DateTimeCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DateTimeCellInfoDescriptionMetadata.c(a, DateTimeCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("DateTimeValue", "Date");
            b.item("FormatStringOverride", "String");
            b.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            b.item("DateTimeFormat", "ExportedType:string:DateTimeFormats");
            b.item("DateTimeFormat@names", "DateShort;DateLong;TimeShort;TimeLong;DateTimeShort;DateTimeLong");
            b.item("IsOffsetValue", "Boolean");
        }
        static d(a) {
            DateTimeCellInfoDescriptionMetadata.b(a);
            a.q("DateTimeCellInfo", () => new DateTimeCellInfoDescription());
            a.p("DateTimeCellInfo", DateTimeCellInfoDescriptionMetadata.a);
        }
    }
    DateTimeCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(DateTimeCellInfoDescriptionMetadata, 'DateTimeCellInfoDescriptionMetadata');
    DateTimeCellInfoDescriptionMetadata.a = null;
    return DateTimeCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationPhaseSettingsDescription = /*@__PURE__*/ (() => {
    class GridAnimationPhaseSettingsDescription extends Description {
        constructor() {
            super();
            this.i = 0;
            this.j = 0;
            this.k = 0;
            this.l = 0;
            this.h = 0;
            this.f = false;
            this.r = null;
        }
        get_type() {
            return "GridAnimationPhaseSettings";
        }
        get type() {
            return this.get_type();
        }
        get durationMilliseconds() {
            return this.i;
        }
        set durationMilliseconds(a) {
            this.i = a;
            this.e("DurationMilliseconds");
        }
        get holdInitialMilliseconds() {
            return this.j;
        }
        set holdInitialMilliseconds(a) {
            this.j = a;
            this.e("HoldInitialMilliseconds");
        }
        get perItemDelayMilliseconds() {
            return this.k;
        }
        set perItemDelayMilliseconds(a) {
            this.k = a;
            this.e("PerItemDelayMilliseconds");
        }
        get subItemDurationMilliseconds() {
            return this.l;
        }
        set subItemDurationMilliseconds(a) {
            this.l = a;
            this.e("SubItemDurationMilliseconds");
        }
        get desiredSubItemDurationMilliseconds() {
            return this.h;
        }
        set desiredSubItemDurationMilliseconds(a) {
            this.h = a;
            this.e("DesiredSubItemDurationMilliseconds");
        }
        get shouldItemsFinishSimultaneously() {
            return this.f;
        }
        set shouldItemsFinishSimultaneously(a) {
            this.f = a;
            this.e("ShouldItemsFinishSimultaneously");
        }
        get easingFunctionType() {
            return this.r;
        }
        set easingFunctionType(a) {
            this.r = a;
            this.e("EasingFunctionType");
        }
    }
    GridAnimationPhaseSettingsDescription.$t = /*@__PURE__*/ markType(GridAnimationPhaseSettingsDescription, 'GridAnimationPhaseSettingsDescription', Description.$);
    return GridAnimationPhaseSettingsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridAnimationPhaseSettingsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridAnimationPhaseSettingsDescriptionMetadata extends Base {
        static b(a) {
            if (GridAnimationPhaseSettingsDescriptionMetadata.a == null) {
                GridAnimationPhaseSettingsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridAnimationPhaseSettingsDescriptionMetadata.c(a, GridAnimationPhaseSettingsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("DurationMilliseconds", "Number:int");
            b.item("HoldInitialMilliseconds", "Number:int");
            b.item("PerItemDelayMilliseconds", "Number:int");
            b.item("SubItemDurationMilliseconds", "Number:int");
            b.item("DesiredSubItemDurationMilliseconds", "Number:int");
            b.item("ShouldItemsFinishSimultaneously", "Boolean");
            b.item("EasingFunctionType", "ExportedType:string:GridEasingFunctionType");
            b.item("EasingFunctionType@names", "Linear;CubicInOut;ExponentialInOut;CircleInOut");
        }
        static d(a) {
            GridAnimationPhaseSettingsDescriptionMetadata.b(a);
            a.q("GridAnimationPhaseSettings", () => new GridAnimationPhaseSettingsDescription());
            a.p("GridAnimationPhaseSettings", GridAnimationPhaseSettingsDescriptionMetadata.a);
        }
    }
    GridAnimationPhaseSettingsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridAnimationPhaseSettingsDescriptionMetadata, 'GridAnimationPhaseSettingsDescriptionMetadata');
    GridAnimationPhaseSettingsDescriptionMetadata.a = null;
    return GridAnimationPhaseSettingsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogFilterChangeEventArgsDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogFilterChangeEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridFilterDialogFilterChangeEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get filter() {
            return this.f;
        }
        set filter(a) {
            this.f = a;
            this.e("Filter");
        }
    }
    GridFilterDialogFilterChangeEventArgsDescription.$t = /*@__PURE__*/ markType(GridFilterDialogFilterChangeEventArgsDescription, 'GridFilterDialogFilterChangeEventArgsDescription', Description.$);
    return GridFilterDialogFilterChangeEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogFilterChangeEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogFilterChangeEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a == null) {
                GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogFilterChangeEventArgsDescriptionMetadata.c(a, GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a);
                ColumnFilterConditionDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Filter", "ExportedType:ColumnFilterCondition");
        }
        static d(a) {
            GridFilterDialogFilterChangeEventArgsDescriptionMetadata.b(a);
            a.q("GridFilterDialogFilterChangeEventArgs", () => new GridFilterDialogFilterChangeEventArgsDescription());
            a.p("GridFilterDialogFilterChangeEventArgs", GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a);
        }
    }
    GridFilterDialogFilterChangeEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogFilterChangeEventArgsDescriptionMetadata, 'GridFilterDialogFilterChangeEventArgsDescriptionMetadata');
    GridFilterDialogFilterChangeEventArgsDescriptionMetadata.a = null;
    return GridFilterDialogFilterChangeEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogOpeningEventArgsDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogOpeningEventArgsDescription extends Description {
        constructor() {
            super();
            this.f = null;
        }
        get_type() {
            return "GridFilterDialogOpeningEventArgs";
        }
        get type() {
            return this.get_type();
        }
        get column() {
            return this.f;
        }
        set column(a) {
            this.f = a;
            this.e("Column");
        }
    }
    GridFilterDialogOpeningEventArgsDescription.$t = /*@__PURE__*/ markType(GridFilterDialogOpeningEventArgsDescription, 'GridFilterDialogOpeningEventArgsDescription', Description.$);
    return GridFilterDialogOpeningEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogOpeningEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogOpeningEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogOpeningEventArgsDescriptionMetadata.a == null) {
                GridFilterDialogOpeningEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogOpeningEventArgsDescriptionMetadata.c(a, GridFilterDialogOpeningEventArgsDescriptionMetadata.a);
                ColumnDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Column", "ExportedType:Column");
        }
        static d(a) {
            GridFilterDialogOpeningEventArgsDescriptionMetadata.b(a);
            a.q("GridFilterDialogOpeningEventArgs", () => new GridFilterDialogOpeningEventArgsDescription());
            a.p("GridFilterDialogOpeningEventArgs", GridFilterDialogOpeningEventArgsDescriptionMetadata.a);
        }
    }
    GridFilterDialogOpeningEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogOpeningEventArgsDescriptionMetadata, 'GridFilterDialogOpeningEventArgsDescriptionMetadata');
    GridFilterDialogOpeningEventArgsDescriptionMetadata.a = null;
    return GridFilterDialogOpeningEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelDescription extends Description {
        constructor() {
            super();
            this.l = null;
            this.h = false;
            this.j = 0;
            this.f = null;
        }
        get_type() {
            return "GridFilterDialogViewModel";
        }
        get type() {
            return this.get_type();
        }
        get propertyType() {
            return this.l;
        }
        set propertyType(a) {
            this.l = a;
            this.e("PropertyType");
        }
        get isTopLevelOr() {
            return this.h;
        }
        set isTopLevelOr(a) {
            this.h = a;
            this.e("IsTopLevelOr");
        }
        get maxGroupingLevels() {
            return this.j;
        }
        set maxGroupingLevels(a) {
            this.j = a;
            this.e("MaxGroupingLevels");
        }
        get rows() {
            return this.f;
        }
        set rows(a) {
            this.f = a;
            this.e("Rows");
        }
    }
    GridFilterDialogViewModelDescription.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelDescription, 'GridFilterDialogViewModelDescription', Description.$);
    return GridFilterDialogViewModelDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogViewModelDescriptionMetadata.a == null) {
                GridFilterDialogViewModelDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogViewModelDescriptionMetadata.c(a, GridFilterDialogViewModelDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("PropertyType", "ExportedType:string:DataSourceSchemaPropertyType");
            b.item("PropertyType@names", "StringValue;IntValue;BooleanValue;LongValue;ShortValue;DoubleValue;DecimalValue;SingleValue;DateTimeValue;DateTimeOffsetValue;ByteValue;ObjectValue");
            b.item("IsTopLevelOr", "Boolean");
            b.item("MaxGroupingLevels", "Number:int");
            b.item("Rows", "Collection:GridFilterDialogViewModelRow:GridFilterDialogViewModelRowCollection:GridFilterDialogViewModelRow");
        }
        static d(a) {
            GridFilterDialogViewModelDescriptionMetadata.b(a);
            a.q("GridFilterDialogViewModel", () => new GridFilterDialogViewModelDescription());
            a.p("GridFilterDialogViewModel", GridFilterDialogViewModelDescriptionMetadata.a);
        }
    }
    GridFilterDialogViewModelDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelDescriptionMetadata, 'GridFilterDialogViewModelDescriptionMetadata');
    GridFilterDialogViewModelDescriptionMetadata.a = null;
    return GridFilterDialogViewModelDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelGroupingDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelGroupingDescription extends Description {
        constructor() {
            super();
            this.i = 0;
            this.h = 0;
            this.f = false;
        }
        get_type() {
            return "GridFilterDialogViewModelGrouping";
        }
        get type() {
            return this.get_type();
        }
        get startIndex() {
            return this.i;
        }
        set startIndex(a) {
            this.i = a;
            this.e("StartIndex");
        }
        get endIndex() {
            return this.h;
        }
        set endIndex(a) {
            this.h = a;
            this.e("EndIndex");
        }
        get isOrGrouping() {
            return this.f;
        }
        set isOrGrouping(a) {
            this.f = a;
            this.e("IsOrGrouping");
        }
    }
    GridFilterDialogViewModelGroupingDescription.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelGroupingDescription, 'GridFilterDialogViewModelGroupingDescription', Description.$);
    return GridFilterDialogViewModelGroupingDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelGroupingDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelGroupingDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogViewModelGroupingDescriptionMetadata.a == null) {
                GridFilterDialogViewModelGroupingDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogViewModelGroupingDescriptionMetadata.c(a, GridFilterDialogViewModelGroupingDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("StartIndex", "Number:int");
            b.item("EndIndex", "Number:int");
            b.item("IsOrGrouping", "Boolean");
        }
        static d(a) {
            GridFilterDialogViewModelGroupingDescriptionMetadata.b(a);
            a.q("GridFilterDialogViewModelGrouping", () => new GridFilterDialogViewModelGroupingDescription());
            a.p("GridFilterDialogViewModelGrouping", GridFilterDialogViewModelGroupingDescriptionMetadata.a);
        }
    }
    GridFilterDialogViewModelGroupingDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelGroupingDescriptionMetadata, 'GridFilterDialogViewModelGroupingDescriptionMetadata');
    GridFilterDialogViewModelGroupingDescriptionMetadata.a = null;
    return GridFilterDialogViewModelGroupingDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelRowDescription = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelRowDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.j = null;
            this.f = null;
            this.k = null;
            this.l = null;
        }
        get_type() {
            return "GridFilterDialogViewModelRow";
        }
        get type() {
            return this.get_type();
        }
        get operators() {
            return this.g;
        }
        set operators(a) {
            this.g = a;
            this.e("Operators");
        }
        get currentOperator() {
            return this.j;
        }
        set currentOperator(a) {
            this.j = a;
            this.e("CurrentOperator");
        }
        get operandNumber() {
            return this.f;
        }
        set operandNumber(a) {
            this.f = a;
            this.e("OperandNumber");
        }
        get operand1Ref() {
            return this.k;
        }
        set operand1Ref(a) {
            this.k = a;
            this.e("Operand1Ref");
        }
        get operand2Ref() {
            return this.l;
        }
        set operand2Ref(a) {
            this.l = a;
            this.e("Operand2Ref");
        }
    }
    GridFilterDialogViewModelRowDescription.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelRowDescription, 'GridFilterDialogViewModelRowDescription', Description.$);
    return GridFilterDialogViewModelRowDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GridFilterDialogViewModelRowDescriptionMetadata = /*@__PURE__*/ (() => {
    class GridFilterDialogViewModelRowDescriptionMetadata extends Base {
        static b(a) {
            if (GridFilterDialogViewModelRowDescriptionMetadata.a == null) {
                GridFilterDialogViewModelRowDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GridFilterDialogViewModelRowDescriptionMetadata.c(a, GridFilterDialogViewModelRowDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Operators", "Array:string");
            b.item("CurrentOperator", "String");
            b.item("OperandNumber", "Array:int");
            b.item("Operand1Ref", "(w:Operand1,wf:Operand1)DataRef");
            b.item("Operand2Ref", "(w:Operand2,wf:Operand2)DataRef");
        }
        static d(a) {
            GridFilterDialogViewModelRowDescriptionMetadata.b(a);
            a.q("GridFilterDialogViewModelRow", () => new GridFilterDialogViewModelRowDescription());
            a.p("GridFilterDialogViewModelRow", GridFilterDialogViewModelRowDescriptionMetadata.a);
        }
    }
    GridFilterDialogViewModelRowDescriptionMetadata.$t = /*@__PURE__*/ markType(GridFilterDialogViewModelRowDescriptionMetadata, 'GridFilterDialogViewModelRowDescriptionMetadata');
    GridFilterDialogViewModelRowDescriptionMetadata.a = null;
    return GridFilterDialogViewModelRowDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GroupDataDescription = /*@__PURE__*/ (() => {
    class GroupDataDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.h = null;
            this.f = null;
        }
        get_type() {
            return "GroupData";
        }
        get type() {
            return this.get_type();
        }
        get groupName() {
            return this.g;
        }
        set groupName(a) {
            this.g = a;
            this.e("GroupName");
        }
        get groupValueRef() {
            return this.h;
        }
        set groupValueRef(a) {
            this.h = a;
            this.e("GroupValueRef");
        }
        get formattedText() {
            return this.f;
        }
        set formattedText(a) {
            this.f = a;
            this.e("FormattedText");
        }
    }
    GroupDataDescription.$t = /*@__PURE__*/ markType(GroupDataDescription, 'GroupDataDescription', Description.$);
    return GroupDataDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GroupDataDescriptionMetadata = /*@__PURE__*/ (() => {
    class GroupDataDescriptionMetadata extends Base {
        static b(a) {
            if (GroupDataDescriptionMetadata.a == null) {
                GroupDataDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                GroupDataDescriptionMetadata.c(a, GroupDataDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("GroupName", "String");
            b.item("GroupValueRef", "(w:GroupValue,wf:GroupValue)DataRef");
            b.item("FormattedText", "String");
        }
        static d(a) {
            GroupDataDescriptionMetadata.b(a);
            a.q("GroupData", () => new GroupDataDescription());
            a.p("GroupData", GroupDataDescriptionMetadata.a);
        }
    }
    GroupDataDescriptionMetadata.$t = /*@__PURE__*/ markType(GroupDataDescriptionMetadata, 'GroupDataDescriptionMetadata');
    GroupDataDescriptionMetadata.a = null;
    return GroupDataDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HierarchicalRingSeriesDescription = /*@__PURE__*/ (() => {
    class HierarchicalRingSeriesDescription extends RingSeriesBaseDescription {
        constructor() {
            super();
            this.ce = null;
        }
        get_type() {
            return "HierarchicalRingSeries";
        }
        get childrenMemberPath() {
            return this.ce;
        }
        set childrenMemberPath(a) {
            this.ce = a;
            this.e("ChildrenMemberPath");
        }
    }
    HierarchicalRingSeriesDescription.$t = /*@__PURE__*/ markType(HierarchicalRingSeriesDescription, 'HierarchicalRingSeriesDescription', RingSeriesBaseDescription.$);
    return HierarchicalRingSeriesDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HierarchicalRingSeriesDescriptionMetadata = /*@__PURE__*/ (() => {
    class HierarchicalRingSeriesDescriptionMetadata extends Base {
        static b(a) {
            if (HierarchicalRingSeriesDescriptionMetadata.a == null) {
                HierarchicalRingSeriesDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                HierarchicalRingSeriesDescriptionMetadata.c(a, HierarchicalRingSeriesDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            RingSeriesBaseDescriptionMetadata.c(a, b);
            b.item("ChildrenMemberPath", "String");
        }
        static d(a) {
            HierarchicalRingSeriesDescriptionMetadata.b(a);
            a.q("HierarchicalRingSeries", () => new HierarchicalRingSeriesDescription());
            a.p("HierarchicalRingSeries", HierarchicalRingSeriesDescriptionMetadata.a);
        }
    }
    HierarchicalRingSeriesDescriptionMetadata.$t = /*@__PURE__*/ markType(HierarchicalRingSeriesDescriptionMetadata, 'HierarchicalRingSeriesDescriptionMetadata');
    HierarchicalRingSeriesDescriptionMetadata.a = null;
    return HierarchicalRingSeriesDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HierarchicalRingSeriesDescriptionModule = /*@__PURE__*/ (() => {
    class HierarchicalRingSeriesDescriptionModule extends Base {
        static register(a) {
            HierarchicalRingSeriesDescriptionMetadata.d(a);
        }
    }
    HierarchicalRingSeriesDescriptionModule.$t = /*@__PURE__*/ markType(HierarchicalRingSeriesDescriptionModule, 'HierarchicalRingSeriesDescriptionModule');
    return HierarchicalRingSeriesDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellActionManagerDescription = /*@__PURE__*/ (() => {
    class CellActionManagerDescription extends Description {
        constructor() {
            super();
            this.f = false;
            this.g = false;
        }
        get_type() {
            return "CellActionManager";
        }
        get type() {
            return this.get_type();
        }
        get isControlPressed() {
            return this.f;
        }
        set isControlPressed(a) {
            this.f = a;
            this.e("IsControlPressed");
        }
        get isShiftPressed() {
            return this.g;
        }
        set isShiftPressed(a) {
            this.g = a;
            this.e("IsShiftPressed");
        }
    }
    CellActionManagerDescription.$t = /*@__PURE__*/ markType(CellActionManagerDescription, 'CellActionManagerDescription', Description.$);
    return CellActionManagerDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CellActionManagerDescriptionMetadata = /*@__PURE__*/ (() => {
    class CellActionManagerDescriptionMetadata extends Base {
        static b(a) {
            if (CellActionManagerDescriptionMetadata.a == null) {
                CellActionManagerDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                CellActionManagerDescriptionMetadata.c(a, CellActionManagerDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("IsControlPressed", "Boolean");
            b.item("IsShiftPressed", "Boolean");
        }
        static d(a) {
            CellActionManagerDescriptionMetadata.b(a);
            a.p("CellActionManager", CellActionManagerDescriptionMetadata.a);
        }
    }
    CellActionManagerDescriptionMetadata.$t = /*@__PURE__*/ markType(CellActionManagerDescriptionMetadata, 'CellActionManagerDescriptionMetadata');
    CellActionManagerDescriptionMetadata.a = null;
    return CellActionManagerDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCellInfoDescription = /*@__PURE__*/ (() => {
    class ImageCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fd = null;
            this.ff = null;
            this.fe = null;
        }
        get_type() {
            return "ImageCellInfo";
        }
        get imagePath() {
            return this.fd;
        }
        set imagePath(a) {
            this.fd = a;
            this.e("ImagePath");
        }
        get imageStretchOption() {
            return this.ff;
        }
        set imageStretchOption(a) {
            this.ff = a;
            this.e("ImageStretchOption");
        }
        get imageResourceType() {
            return this.fe;
        }
        set imageResourceType(a) {
            this.fe = a;
            this.e("ImageResourceType");
        }
    }
    ImageCellInfoDescription.$t = /*@__PURE__*/ markType(ImageCellInfoDescription, 'ImageCellInfoDescription', CellInfoDescription.$);
    ImageCellInfoDescription.__marshalByValue1 = true;
    ImageCellInfoDescription.__marshalByValueAlias1 = "ImageCellModel";
    return ImageCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ImageCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class ImageCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (ImageCellInfoDescriptionMetadata.a == null) {
                ImageCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ImageCellInfoDescriptionMetadata.c(a, ImageCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("ImagePath", "String");
            b.item("ImageStretchOption", "ExportedType:string:ImageStretchOptions");
            b.item("ImageStretchOption@names", "Uniform;Fill;None");
            b.item("ImageResourceType", "ExportedType:string:ImageResourceType");
            b.item("ImageResourceType@names", "Unspecified;LocalResource;LocalAsset;EmbeddedResource;RemoteResource");
        }
        static d(a) {
            ImageCellInfoDescriptionMetadata.b(a);
            a.q("ImageCellInfo", () => new ImageCellInfoDescription());
            a.p("ImageCellInfo", ImageCellInfoDescriptionMetadata.a);
        }
    }
    ImageCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(ImageCellInfoDescriptionMetadata, 'ImageCellInfoDescriptionMetadata');
    ImageCellInfoDescriptionMetadata.a = null;
    return ImageCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearContourValueResolverDescription = /*@__PURE__*/ (() => {
    class LinearContourValueResolverDescription extends ContourValueResolverDescription {
        constructor() {
            super();
            this.g = 0;
        }
        get_type() {
            return "LinearContourValueResolver";
        }
        get valueCount() {
            return this.g;
        }
        set valueCount(a) {
            this.g = a;
            this.e("ValueCount");
        }
    }
    LinearContourValueResolverDescription.$t = /*@__PURE__*/ markType(LinearContourValueResolverDescription, 'LinearContourValueResolverDescription', ContourValueResolverDescription.$);
    return LinearContourValueResolverDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearContourValueResolverDescriptionMetadata = /*@__PURE__*/ (() => {
    class LinearContourValueResolverDescriptionMetadata extends Base {
        static b(a) {
            if (LinearContourValueResolverDescriptionMetadata.a == null) {
                LinearContourValueResolverDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                LinearContourValueResolverDescriptionMetadata.c(a, LinearContourValueResolverDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            ContourValueResolverDescriptionMetadata.c(a, b);
            b.item("ValueCount", "Number:int");
        }
        static d(a) {
            LinearContourValueResolverDescriptionMetadata.b(a);
            a.q("LinearContourValueResolver", () => new LinearContourValueResolverDescription());
            a.p("LinearContourValueResolver", LinearContourValueResolverDescriptionMetadata.a);
        }
    }
    LinearContourValueResolverDescriptionMetadata.$t = /*@__PURE__*/ markType(LinearContourValueResolverDescriptionMetadata, 'LinearContourValueResolverDescriptionMetadata');
    LinearContourValueResolverDescriptionMetadata.a = null;
    return LinearContourValueResolverDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearContourValueResolverDescriptionModule = /*@__PURE__*/ (() => {
    class LinearContourValueResolverDescriptionModule extends Base {
        static register(a) {
            LinearContourValueResolverDescriptionMetadata.d(a);
        }
    }
    LinearContourValueResolverDescriptionModule.$t = /*@__PURE__*/ markType(LinearContourValueResolverDescriptionModule, 'LinearContourValueResolverDescriptionModule');
    return LinearContourValueResolverDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridFilterDialogDescription = /*@__PURE__*/ (() => {
    class DataGridFilterDialogDescription extends Description {
        constructor() {
            super();
            this.f = false;
            this.i = 0;
            this.h = 0;
            this.q = null;
            this.j = 0;
            this.n = null;
            this.p = null;
            this.o = null;
            this.r = null;
        }
        get_type() {
            return "DataGridFilterDialog";
        }
        get type() {
            return this.get_type();
        }
        get isAnimationEnabled() {
            return this.f;
        }
        set isAnimationEnabled(a) {
            this.f = a;
            this.e("IsAnimationEnabled");
        }
        get pixelScalingRatio() {
            return this.i;
        }
        set pixelScalingRatio(a) {
            this.i = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.h;
        }
        set actualPixelScalingRatio(a) {
            this.h = a;
            this.e("ActualPixelScalingRatio");
        }
        get iconColor() {
            return this.q;
        }
        set iconColor(a) {
            this.q = a;
            this.e("IconColor");
        }
        get viewSize() {
            return this.j;
        }
        set viewSize(a) {
            this.j = a;
            this.e("ViewSize");
        }
        get dialogOpeningRef() {
            return this.n;
        }
        set dialogOpeningRef(a) {
            this.n = a;
            this.e("DialogOpeningRef");
        }
        get filterChangingRef() {
            return this.p;
        }
        set filterChangingRef(a) {
            this.p = a;
            this.e("FilterChangingRef");
        }
        get filterChangedRef() {
            return this.o;
        }
        set filterChangedRef(a) {
            this.o = a;
            this.e("FilterChangedRef");
        }
        get renderCompletedRef() {
            return this.r;
        }
        set renderCompletedRef(a) {
            this.r = a;
            this.e("RenderCompletedRef");
        }
    }
    DataGridFilterDialogDescription.$t = /*@__PURE__*/ markType(DataGridFilterDialogDescription, 'DataGridFilterDialogDescription', Description.$);
    return DataGridFilterDialogDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridFilterDialogDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridFilterDialogDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridFilterDialogDescriptionMetadata.a == null) {
                DataGridFilterDialogDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridFilterDialogDescriptionMetadata.c(a, DataGridFilterDialogDescriptionMetadata.a);
                GridFilterDialogOpeningEventArgsDescriptionMetadata.d(a);
                GridFilterDialogFilterChangeEventArgsDescriptionMetadata.d(a);
                FilterDialogRenderCompletedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("IsAnimationEnabled", "Boolean");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("IconColor", "Brush");
            b.item("ViewSize", "Number:double");
            b.item("DialogOpeningRef", "EventRef::dialogOpening");
            b.item("FilterChangingRef", "EventRef::filterChanging");
            b.item("FilterChangedRef", "EventRef::filterChanged");
            b.item("RenderCompletedRef", "EventRef::renderCompleted");
        }
        static d(a) {
            DataGridFilterDialogDescriptionMetadata.b(a);
            a.q("DataGridFilterDialog", () => new DataGridFilterDialogDescription());
            a.p("DataGridFilterDialog", DataGridFilterDialogDescriptionMetadata.a);
        }
    }
    DataGridFilterDialogDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridFilterDialogDescriptionMetadata, 'DataGridFilterDialogDescriptionMetadata');
    DataGridFilterDialogDescriptionMetadata.a = null;
    return DataGridFilterDialogDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridSortIndicatorDescription = /*@__PURE__*/ (() => {
    class DataGridSortIndicatorDescription extends Description {
        constructor() {
            super();
            this.n = null;
            this.l = null;
            this.f = false;
            this.i = 0;
            this.h = 0;
            this.o = null;
            this.m = null;
        }
        get_type() {
            return "DataGridSortIndicator";
        }
        get type() {
            return this.get_type();
        }
        get sortDirection() {
            return this.n;
        }
        set sortDirection(a) {
            this.n = a;
            this.e("SortDirection");
        }
        get iconColor() {
            return this.l;
        }
        set iconColor(a) {
            this.l = a;
            this.e("IconColor");
        }
        get isAnimationEnabled() {
            return this.f;
        }
        set isAnimationEnabled(a) {
            this.f = a;
            this.e("IsAnimationEnabled");
        }
        get pixelScalingRatio() {
            return this.i;
        }
        set pixelScalingRatio(a) {
            this.i = a;
            this.e("PixelScalingRatio");
        }
        get actualPixelScalingRatio() {
            return this.h;
        }
        set actualPixelScalingRatio(a) {
            this.h = a;
            this.e("ActualPixelScalingRatio");
        }
        get sortIndicatorStyle() {
            return this.o;
        }
        set sortIndicatorStyle(a) {
            this.o = a;
            this.e("SortIndicatorStyle");
        }
        get renderCompletedRef() {
            return this.m;
        }
        set renderCompletedRef(a) {
            this.m = a;
            this.e("RenderCompletedRef");
        }
    }
    DataGridSortIndicatorDescription.$t = /*@__PURE__*/ markType(DataGridSortIndicatorDescription, 'DataGridSortIndicatorDescription', Description.$);
    return DataGridSortIndicatorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataGridSortIndicatorDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataGridSortIndicatorDescriptionMetadata extends Base {
        static b(a) {
            if (DataGridSortIndicatorDescriptionMetadata.a == null) {
                DataGridSortIndicatorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                DataGridSortIndicatorDescriptionMetadata.c(a, DataGridSortIndicatorDescriptionMetadata.a);
                SortIndicatorRenderCompletedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("SortDirection", "ExportedType:string:ColumnSortDirection");
            b.item("SortDirection@names", "None;Ascending;Descending");
            b.item("IconColor", "Brush");
            b.item("IsAnimationEnabled", "Boolean");
            b.item("PixelScalingRatio", "Number:double");
            b.item("ActualPixelScalingRatio", "Number:double");
            b.item("SortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            b.item("SortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            b.item("RenderCompletedRef", "EventRef::renderCompleted");
        }
        static d(a) {
            DataGridSortIndicatorDescriptionMetadata.b(a);
            a.q("DataGridSortIndicator", () => new DataGridSortIndicatorDescription());
            a.p("DataGridSortIndicator", DataGridSortIndicatorDescriptionMetadata.a);
        }
    }
    DataGridSortIndicatorDescriptionMetadata.$t = /*@__PURE__*/ markType(DataGridSortIndicatorDescriptionMetadata, 'DataGridSortIndicatorDescriptionMetadata');
    DataGridSortIndicatorDescriptionMetadata.a = null;
    return DataGridSortIndicatorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericCellInfoDescription = /*@__PURE__*/ (() => {
    class NumericCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fi = 0;
            this.fe = false;
            this.fs = null;
            this.fb = null;
            this.fr = null;
            this.ft = null;
            this.fv = null;
            this.fu = null;
            this.fw = null;
            this.fk = 0;
            this.fl = 0;
            this.fm = 0;
            this.ff = false;
        }
        get_type() {
            return "NumericCellInfo";
        }
        get numericValue() {
            return this.fi;
        }
        set numericValue(a) {
            this.fi = a;
            this.e("NumericValue");
        }
        get hasDecimalValue() {
            return this.fe;
        }
        set hasDecimalValue(a) {
            this.fe = a;
            this.e("HasDecimalValue");
        }
        get formatStringOverride() {
            return this.fs;
        }
        set formatStringOverride(a) {
            this.fs = a;
            this.e("FormatStringOverride");
        }
        get formatSpecifiers() {
            return this.fb;
        }
        set formatSpecifiers(a) {
            this.fb = a;
            this.e("FormatSpecifiers");
        }
        get formatOverrideRef() {
            return this.fr;
        }
        set formatOverrideRef(a) {
            this.fr = a;
            this.e("FormatOverrideRef");
        }
        get negativePrefix() {
            return this.ft;
        }
        set negativePrefix(a) {
            this.ft = a;
            this.e("NegativePrefix");
        }
        get positivePrefix() {
            return this.fv;
        }
        set positivePrefix(a) {
            this.fv = a;
            this.e("PositivePrefix");
        }
        get negativeSuffix() {
            return this.fu;
        }
        set negativeSuffix(a) {
            this.fu = a;
            this.e("NegativeSuffix");
        }
        get positiveSuffix() {
            return this.fw;
        }
        set positiveSuffix(a) {
            this.fw = a;
            this.e("PositiveSuffix");
        }
        get maxFractionDigits() {
            return this.fk;
        }
        set maxFractionDigits(a) {
            this.fk = a;
            this.e("MaxFractionDigits");
        }
        get minFractionDigits() {
            return this.fl;
        }
        set minFractionDigits(a) {
            this.fl = a;
            this.e("MinFractionDigits");
        }
        get minIntegerDigits() {
            return this.fm;
        }
        set minIntegerDigits(a) {
            this.fm = a;
            this.e("MinIntegerDigits");
        }
        get showGroupingSeparator() {
            return this.ff;
        }
        set showGroupingSeparator(a) {
            this.ff = a;
            this.e("ShowGroupingSeparator");
        }
    }
    NumericCellInfoDescription.$t = /*@__PURE__*/ markType(NumericCellInfoDescription, 'NumericCellInfoDescription', CellInfoDescription.$);
    NumericCellInfoDescription.__marshalByValue1 = true;
    NumericCellInfoDescription.__marshalByValueAlias1 = "NumericCellModel";
    return NumericCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NumericCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class NumericCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (NumericCellInfoDescriptionMetadata.a == null) {
                NumericCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                NumericCellInfoDescriptionMetadata.c(a, NumericCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("NumericValue", "Number:double");
            b.item("HasDecimalValue", "Boolean");
            b.item("FormatStringOverride", "String");
            b.item("FormatSpecifiers", "Collection:FormatSpecifier:FormatSpecifierCollection:FormatSpecifier");
            b.item("FormatOverrideRef", "(w:FormatOverride,wf:FormatOverride)DataRef");
            b.item("NegativePrefix", "String");
            b.item("PositivePrefix", "String");
            b.item("NegativeSuffix", "String");
            b.item("PositiveSuffix", "String");
            b.item("MaxFractionDigits", "Number:int");
            b.item("MinFractionDigits", "Number:int");
            b.item("MinIntegerDigits", "Number:int");
            b.item("ShowGroupingSeparator", "Boolean");
        }
        static d(a) {
            NumericCellInfoDescriptionMetadata.b(a);
            a.q("NumericCellInfo", () => new NumericCellInfoDescription());
            a.p("NumericCellInfo", NumericCellInfoDescriptionMetadata.a);
        }
    }
    NumericCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(NumericCellInfoDescriptionMetadata, 'NumericCellInfoDescriptionMetadata');
    NumericCellInfoDescriptionMetadata.a = null;
    return NumericCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceDataContextDescription = /*@__PURE__*/ (() => {
    class PieSliceDataContextDescription extends DataContextDescription {
        constructor() {
            super();
            this.z = 0;
            this.x = false;
        }
        get_type() {
            return "PieSliceDataContext";
        }
        get percentValue() {
            return this.z;
        }
        set percentValue(a) {
            this.z = a;
            this.e("PercentValue");
        }
        get isOthersSlice() {
            return this.x;
        }
        set isOthersSlice(a) {
            this.x = a;
            this.e("IsOthersSlice");
        }
    }
    PieSliceDataContextDescription.$t = /*@__PURE__*/ markType(PieSliceDataContextDescription, 'PieSliceDataContextDescription', DataContextDescription.$);
    PieSliceDataContextDescription.__marshalByValue1 = true;
    PieSliceDataContextDescription.__marshalByValueAlias1 = "PieSliceDataContext";
    return PieSliceDataContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceDataContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieSliceDataContextDescriptionMetadata extends Base {
        static b(a) {
            if (PieSliceDataContextDescriptionMetadata.a == null) {
                PieSliceDataContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieSliceDataContextDescriptionMetadata.c(a, PieSliceDataContextDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DataContextDescriptionMetadata.c(a, b);
            b.item("PercentValue", "Number:double");
            b.item("IsOthersSlice", "Boolean");
        }
        static d(a) {
            PieSliceDataContextDescriptionMetadata.b(a);
            a.q("PieSliceDataContext", () => new PieSliceDataContextDescription());
            a.p("PieSliceDataContext", PieSliceDataContextDescriptionMetadata.a);
        }
    }
    PieSliceDataContextDescriptionMetadata.$t = /*@__PURE__*/ markType(PieSliceDataContextDescriptionMetadata, 'PieSliceDataContextDescriptionMetadata');
    PieSliceDataContextDescriptionMetadata.a = null;
    return PieSliceDataContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceOthersContextDescription = /*@__PURE__*/ (() => {
    class PieSliceOthersContextDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "PieSliceOthersContext";
        }
        get type() {
            return this.get_type();
        }
    }
    PieSliceOthersContextDescription.$t = /*@__PURE__*/ markType(PieSliceOthersContextDescription, 'PieSliceOthersContextDescription', Description.$);
    return PieSliceOthersContextDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PieSliceOthersContextDescriptionMetadata = /*@__PURE__*/ (() => {
    class PieSliceOthersContextDescriptionMetadata extends Base {
        static b(a) {
            if (PieSliceOthersContextDescriptionMetadata.a == null) {
                PieSliceOthersContextDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                PieSliceOthersContextDescriptionMetadata.c(a, PieSliceOthersContextDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            PieSliceOthersContextDescriptionMetadata.b(a);
            a.q("PieSliceOthersContext", () => new PieSliceOthersContextDescription());
            a.p("PieSliceOthersContext", PieSliceOthersContextDescriptionMetadata.a);
        }
    }
    PieSliceOthersContextDescriptionMetadata.$t = /*@__PURE__*/ markType(PieSliceOthersContextDescriptionMetadata, 'PieSliceOthersContextDescriptionMetadata');
    PieSliceOthersContextDescriptionMetadata.a = null;
    return PieSliceOthersContextDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsivePhaseDescription = /*@__PURE__*/ (() => {
    class ResponsivePhaseDescription extends Description {
        constructor() {
            super();
            this.h = null;
            this.f = 0;
        }
        get_type() {
            return "ResponsivePhase";
        }
        get type() {
            return this.get_type();
        }
        get name() {
            return this.h;
        }
        set name(a) {
            this.h = a;
            this.e("Name");
        }
        get delayMilliseconds() {
            return this.f;
        }
        set delayMilliseconds(a) {
            this.f = a;
            this.e("DelayMilliseconds");
        }
    }
    ResponsivePhaseDescription.$t = /*@__PURE__*/ markType(ResponsivePhaseDescription, 'ResponsivePhaseDescription', Description.$);
    return ResponsivePhaseDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsivePhaseDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsivePhaseDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsivePhaseDescriptionMetadata.a == null) {
                ResponsivePhaseDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsivePhaseDescriptionMetadata.c(a, ResponsivePhaseDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("Name", "String");
            b.item("DelayMilliseconds", "Number:int");
        }
        static d(a) {
            ResponsivePhaseDescriptionMetadata.b(a);
            a.q("ResponsivePhase", () => new ResponsivePhaseDescription());
            a.p("ResponsivePhase", ResponsivePhaseDescriptionMetadata.a);
        }
    }
    ResponsivePhaseDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsivePhaseDescriptionMetadata, 'ResponsivePhaseDescriptionMetadata');
    ResponsivePhaseDescriptionMetadata.a = null;
    return ResponsivePhaseDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateDescription extends Description {
        constructor() {
            super();
            this.l = null;
            this.i = 0;
            this.h = 0;
            this.f = false;
            this.n = null;
            this.m = null;
            this.o = null;
        }
        get_type() {
            return "ResponsiveState";
        }
        get type() {
            return this.get_type();
        }
        get name() {
            return this.l;
        }
        set name(a) {
            this.l = a;
            this.e("Name");
        }
        get minimumWidth() {
            return this.i;
        }
        set minimumWidth(a) {
            this.i = a;
            this.e("MinimumWidth");
        }
        get maximumWidth() {
            return this.h;
        }
        set maximumWidth(a) {
            this.h = a;
            this.e("MaximumWidth");
        }
        get isManualState() {
            return this.f;
        }
        set isManualState(a) {
            this.f = a;
            this.e("IsManualState");
        }
        get stateEnteringRef() {
            return this.n;
        }
        set stateEnteringRef(a) {
            this.n = a;
            this.e("StateEnteringRef");
        }
        get stateEnteredRef() {
            return this.m;
        }
        set stateEnteredRef(a) {
            this.m = a;
            this.e("StateEnteredRef");
        }
        get stateExitedRef() {
            return this.o;
        }
        set stateExitedRef(a) {
            this.o = a;
            this.e("StateExitedRef");
        }
    }
    ResponsiveStateDescription.$t = /*@__PURE__*/ markType(ResponsiveStateDescription, 'ResponsiveStateDescription', Description.$);
    return ResponsiveStateDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteringEventArgsDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteringEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ResponsiveStateEnteringEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ResponsiveStateEnteringEventArgsDescription.$t = /*@__PURE__*/ markType(ResponsiveStateEnteringEventArgsDescription, 'ResponsiveStateEnteringEventArgsDescription', Description.$);
    return ResponsiveStateEnteringEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteringEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteringEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateEnteringEventArgsDescriptionMetadata.a == null) {
                ResponsiveStateEnteringEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateEnteringEventArgsDescriptionMetadata.c(a, ResponsiveStateEnteringEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ResponsiveStateEnteringEventArgsDescriptionMetadata.b(a);
            a.q("ResponsiveStateEnteringEventArgs", () => new ResponsiveStateEnteringEventArgsDescription());
            a.p("ResponsiveStateEnteringEventArgs", ResponsiveStateEnteringEventArgsDescriptionMetadata.a);
        }
    }
    ResponsiveStateEnteringEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateEnteringEventArgsDescriptionMetadata, 'ResponsiveStateEnteringEventArgsDescriptionMetadata');
    ResponsiveStateEnteringEventArgsDescriptionMetadata.a = null;
    return ResponsiveStateEnteringEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteredEventArgsDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteredEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ResponsiveStateEnteredEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ResponsiveStateEnteredEventArgsDescription.$t = /*@__PURE__*/ markType(ResponsiveStateEnteredEventArgsDescription, 'ResponsiveStateEnteredEventArgsDescription', Description.$);
    return ResponsiveStateEnteredEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateEnteredEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateEnteredEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateEnteredEventArgsDescriptionMetadata.a == null) {
                ResponsiveStateEnteredEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateEnteredEventArgsDescriptionMetadata.c(a, ResponsiveStateEnteredEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ResponsiveStateEnteredEventArgsDescriptionMetadata.b(a);
            a.q("ResponsiveStateEnteredEventArgs", () => new ResponsiveStateEnteredEventArgsDescription());
            a.p("ResponsiveStateEnteredEventArgs", ResponsiveStateEnteredEventArgsDescriptionMetadata.a);
        }
    }
    ResponsiveStateEnteredEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateEnteredEventArgsDescriptionMetadata, 'ResponsiveStateEnteredEventArgsDescriptionMetadata');
    ResponsiveStateEnteredEventArgsDescriptionMetadata.a = null;
    return ResponsiveStateEnteredEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateExitedEventArgsDescription = /*@__PURE__*/ (() => {
    class ResponsiveStateExitedEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "ResponsiveStateExitedEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    ResponsiveStateExitedEventArgsDescription.$t = /*@__PURE__*/ markType(ResponsiveStateExitedEventArgsDescription, 'ResponsiveStateExitedEventArgsDescription', Description.$);
    return ResponsiveStateExitedEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateExitedEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateExitedEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateExitedEventArgsDescriptionMetadata.a == null) {
                ResponsiveStateExitedEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateExitedEventArgsDescriptionMetadata.c(a, ResponsiveStateExitedEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            ResponsiveStateExitedEventArgsDescriptionMetadata.b(a);
            a.q("ResponsiveStateExitedEventArgs", () => new ResponsiveStateExitedEventArgsDescription());
            a.p("ResponsiveStateExitedEventArgs", ResponsiveStateExitedEventArgsDescriptionMetadata.a);
        }
    }
    ResponsiveStateExitedEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateExitedEventArgsDescriptionMetadata, 'ResponsiveStateExitedEventArgsDescriptionMetadata');
    ResponsiveStateExitedEventArgsDescriptionMetadata.a = null;
    return ResponsiveStateExitedEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ResponsiveStateDescriptionMetadata = /*@__PURE__*/ (() => {
    class ResponsiveStateDescriptionMetadata extends Base {
        static b(a) {
            if (ResponsiveStateDescriptionMetadata.a == null) {
                ResponsiveStateDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ResponsiveStateDescriptionMetadata.c(a, ResponsiveStateDescriptionMetadata.a);
                ResponsiveStateEnteringEventArgsDescriptionMetadata.d(a);
                ResponsiveStateEnteredEventArgsDescriptionMetadata.d(a);
                ResponsiveStateExitedEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            b.item("Name", "String");
            b.item("MinimumWidth", "Number:double");
            b.item("MaximumWidth", "Number:double");
            b.item("IsManualState", "Boolean");
            b.item("StateEnteringRef", "EventRef::stateEntering");
            b.item("StateEnteredRef", "EventRef::stateEntered");
            b.item("StateExitedRef", "EventRef::stateExited");
        }
        static d(a) {
            ResponsiveStateDescriptionMetadata.b(a);
            a.q("ResponsiveState", () => new ResponsiveStateDescription());
            a.p("ResponsiveState", ResponsiveStateDescriptionMetadata.a);
        }
    }
    ResponsiveStateDescriptionMetadata.$t = /*@__PURE__*/ markType(ResponsiveStateDescriptionMetadata, 'ResponsiveStateDescriptionMetadata');
    ResponsiveStateDescriptionMetadata.a = null;
    return ResponsiveStateDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorInfoDescription = /*@__PURE__*/ (() => {
    class RowSeparatorInfoDescription extends CellInfoDescription {
        constructor() {
            super();
        }
        get_type() {
            return "RowSeparatorInfo";
        }
    }
    RowSeparatorInfoDescription.$t = /*@__PURE__*/ markType(RowSeparatorInfoDescription, 'RowSeparatorInfoDescription', CellInfoDescription.$);
    RowSeparatorInfoDescription.__marshalByValue1 = true;
    RowSeparatorInfoDescription.__marshalByValueAlias1 = "RowSeparatorModel";
    return RowSeparatorInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowSeparatorInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class RowSeparatorInfoDescriptionMetadata extends Base {
        static b(a) {
            if (RowSeparatorInfoDescriptionMetadata.a == null) {
                RowSeparatorInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                RowSeparatorInfoDescriptionMetadata.c(a, RowSeparatorInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
        }
        static d(a) {
            RowSeparatorInfoDescriptionMetadata.b(a);
            a.q("RowSeparatorInfo", () => new RowSeparatorInfoDescription());
            a.p("RowSeparatorInfo", RowSeparatorInfoDescriptionMetadata.a);
        }
    }
    RowSeparatorInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(RowSeparatorInfoDescriptionMetadata, 'RowSeparatorInfoDescriptionMetadata');
    RowSeparatorInfoDescriptionMetadata.a = null;
    return RowSeparatorInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScalerParamsDescription = /*@__PURE__*/ (() => {
    class ScalerParamsDescription extends Description {
        constructor() {
            super();
            this.f = 0;
        }
        get_type() {
            return "ScalerParams";
        }
        get type() {
            return this.get_type();
        }
        get referenceValue() {
            return this.f;
        }
        set referenceValue(a) {
            this.f = a;
            this.e("ReferenceValue");
        }
    }
    ScalerParamsDescription.$t = /*@__PURE__*/ markType(ScalerParamsDescription, 'ScalerParamsDescription', Description.$);
    return ScalerParamsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScalerParamsDescriptionMetadata = /*@__PURE__*/ (() => {
    class ScalerParamsDescriptionMetadata extends Base {
        static b(a) {
            if (ScalerParamsDescriptionMetadata.a == null) {
                ScalerParamsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                ScalerParamsDescriptionMetadata.c(a, ScalerParamsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("ReferenceValue", "Number:double");
        }
        static d(a) {
            ScalerParamsDescriptionMetadata.b(a);
            a.q("ScalerParams", () => new ScalerParamsDescription());
            a.p("ScalerParams", ScalerParamsDescriptionMetadata.a);
        }
    }
    ScalerParamsDescriptionMetadata.$t = /*@__PURE__*/ markType(ScalerParamsDescriptionMetadata, 'ScalerParamsDescriptionMetadata');
    ScalerParamsDescriptionMetadata.a = null;
    return ScalerParamsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionFooterDescription = /*@__PURE__*/ (() => {
    class SectionFooterDescription extends DefinitionBaseDescription {
        constructor() {
            super();
        }
        get_type() {
            return "SectionFooter";
        }
    }
    SectionFooterDescription.$t = /*@__PURE__*/ markType(SectionFooterDescription, 'SectionFooterDescription', DefinitionBaseDescription.$);
    return SectionFooterDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionFooterDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionFooterDescriptionMetadata extends Base {
        static b(a) {
            if (SectionFooterDescriptionMetadata.a == null) {
                SectionFooterDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionFooterDescriptionMetadata.c(a, SectionFooterDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            DefinitionBaseDescriptionMetadata.c(a, b);
        }
        static d(a) {
            SectionFooterDescriptionMetadata.b(a);
            a.q("SectionFooter", () => new SectionFooterDescription());
            a.p("SectionFooter", SectionFooterDescriptionMetadata.a);
        }
    }
    SectionFooterDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionFooterDescriptionMetadata, 'SectionFooterDescriptionMetadata');
    SectionFooterDescriptionMetadata.a = null;
    return SectionFooterDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionFooterDescriptionModule = /*@__PURE__*/ (() => {
    class SectionFooterDescriptionModule extends Base {
        static register(a) {
            SectionFooterDescriptionMetadata.d(a);
        }
    }
    SectionFooterDescriptionModule.$t = /*@__PURE__*/ markType(SectionFooterDescriptionModule, 'SectionFooterDescriptionModule');
    return SectionFooterDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class SectionHeaderCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fe = null;
            this.fd = null;
            this.ff = null;
        }
        get_type() {
            return "SectionHeaderCellInfo";
        }
        get resolvedText() {
            return this.fe;
        }
        set resolvedText(a) {
            this.fe = a;
            this.e("ResolvedText");
        }
        get resolvedSummaryText() {
            return this.fd;
        }
        set resolvedSummaryText(a) {
            this.fd = a;
            this.e("ResolvedSummaryText");
        }
        get summaryDisplayMode() {
            return this.ff;
        }
        set summaryDisplayMode(a) {
            this.ff = a;
            this.e("SummaryDisplayMode");
        }
    }
    SectionHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(SectionHeaderCellInfoDescription, 'SectionHeaderCellInfoDescription', CellInfoDescription.$);
    SectionHeaderCellInfoDescription.__marshalByValue1 = true;
    SectionHeaderCellInfoDescription.__marshalByValueAlias1 = "SectionHeaderCellModel";
    return SectionHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SectionHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class SectionHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (SectionHeaderCellInfoDescriptionMetadata.a == null) {
                SectionHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SectionHeaderCellInfoDescriptionMetadata.c(a, SectionHeaderCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("ResolvedText", "String");
            b.item("ResolvedSummaryText", "String");
            b.item("SummaryDisplayMode", "ExportedType:string:GroupSummaryDisplayMode");
            b.item("SummaryDisplayMode@names", "List;Cells;RowTop;RowBottom;None");
        }
        static d(a) {
            SectionHeaderCellInfoDescriptionMetadata.b(a);
            a.q("SectionHeaderCellInfo", () => new SectionHeaderCellInfoDescription());
            a.p("SectionHeaderCellInfo", SectionHeaderCellInfoDescriptionMetadata.a);
        }
    }
    SectionHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(SectionHeaderCellInfoDescriptionMetadata, 'SectionHeaderCellInfoDescriptionMetadata');
    SectionHeaderCellInfoDescriptionMetadata.a = null;
    return SectionHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortDescriptionDescription = /*@__PURE__*/ (() => {
    class SortDescriptionDescription extends Description {
        constructor() {
            super();
            this.g = null;
            this.f = null;
        }
        get_type() {
            return "SortDescription";
        }
        get type() {
            return this.get_type();
        }
        get propertyName() {
            return this.g;
        }
        set propertyName(a) {
            this.g = a;
            this.e("PropertyName");
        }
        get direction() {
            return this.f;
        }
        set direction(a) {
            this.f = a;
            this.e("Direction");
        }
    }
    SortDescriptionDescription.$t = /*@__PURE__*/ markType(SortDescriptionDescription, 'SortDescriptionDescription', Description.$);
    return SortDescriptionDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortDescriptionDescriptionMetadata = /*@__PURE__*/ (() => {
    class SortDescriptionDescriptionMetadata extends Base {
        static b(a) {
            if (SortDescriptionDescriptionMetadata.a == null) {
                SortDescriptionDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                SortDescriptionDescriptionMetadata.c(a, SortDescriptionDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            b.item("PropertyName", "String");
            b.item("Direction", "ExportedType:string:ListSortDirection");
        }
        static d(a) {
            SortDescriptionDescriptionMetadata.b(a);
            a.q("SortDescription", () => new SortDescriptionDescription());
            a.p("SortDescription", SortDescriptionDescriptionMetadata.a);
        }
    }
    SortDescriptionDescriptionMetadata.$t = /*@__PURE__*/ markType(SortDescriptionDescriptionMetadata, 'SortDescriptionDescriptionMetadata');
    SortDescriptionDescriptionMetadata.a = null;
    return SortDescriptionDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleSelectorDescription = /*@__PURE__*/ (() => {
    class StyleSelectorDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "StyleSelector";
        }
        get type() {
            return this.get_type();
        }
    }
    StyleSelectorDescription.$t = /*@__PURE__*/ markType(StyleSelectorDescription, 'StyleSelectorDescription', Description.$);
    return StyleSelectorDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StyleSelectorDescriptionMetadata = /*@__PURE__*/ (() => {
    class StyleSelectorDescriptionMetadata extends Base {
        static b(a) {
            if (StyleSelectorDescriptionMetadata.a == null) {
                StyleSelectorDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                StyleSelectorDescriptionMetadata.c(a, StyleSelectorDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            StyleSelectorDescriptionMetadata.b(a);
            a.q("StyleSelector", () => new StyleSelectorDescription());
            a.p("StyleSelector", StyleSelectorDescriptionMetadata.a);
        }
    }
    StyleSelectorDescriptionMetadata.$t = /*@__PURE__*/ markType(StyleSelectorDescriptionMetadata, 'StyleSelectorDescriptionMetadata');
    StyleSelectorDescriptionMetadata.a = null;
    return StyleSelectorDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellInfoDescription = /*@__PURE__*/ (() => {
    class TemplateCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fd = null;
        }
        get_type() {
            return "TemplateCellInfo";
        }
        get valueRef() {
            return this.fd;
        }
        set valueRef(a) {
            this.fd = a;
            this.e("ValueRef");
        }
    }
    TemplateCellInfoDescription.$t = /*@__PURE__*/ markType(TemplateCellInfoDescription, 'TemplateCellInfoDescription', CellInfoDescription.$);
    TemplateCellInfoDescription.__marshalByValue1 = true;
    TemplateCellInfoDescription.__marshalByValueAlias1 = "TemplateCellModel";
    return TemplateCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateCellInfoDescriptionMetadata.a == null) {
                TemplateCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateCellInfoDescriptionMetadata.c(a, TemplateCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("ValueRef", "(w:Value,wf:Value)DataRef");
        }
        static d(a) {
            TemplateCellInfoDescriptionMetadata.b(a);
            a.q("TemplateCellInfo", () => new TemplateCellInfoDescription());
            a.p("TemplateCellInfo", TemplateCellInfoDescriptionMetadata.a);
        }
    }
    TemplateCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateCellInfoDescriptionMetadata, 'TemplateCellInfoDescriptionMetadata');
    TemplateCellInfoDescriptionMetadata.a = null;
    return TemplateCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class TemplateHeaderCellInfoDescription extends TemplateCellInfoDescription {
        constructor() {
            super();
            this.fg = false;
        }
        get_type() {
            return "TemplateHeaderCellInfo";
        }
        get isFilterUIVisible() {
            return this.fg;
        }
        set isFilterUIVisible(a) {
            this.fg = a;
            this.e("IsFilterUIVisible");
        }
    }
    TemplateHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(TemplateHeaderCellInfoDescription, 'TemplateHeaderCellInfoDescription', TemplateCellInfoDescription.$);
    TemplateHeaderCellInfoDescription.__marshalByValue2 = true;
    TemplateHeaderCellInfoDescription.__marshalByValueAlias2 = "TemplateHeaderCellModel";
    return TemplateHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateHeaderCellInfoDescriptionMetadata.a == null) {
                TemplateHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateHeaderCellInfoDescriptionMetadata.c(a, TemplateHeaderCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            TemplateCellInfoDescriptionMetadata.c(a, b);
            b.item("IsFilterUIVisible", "Boolean");
        }
        static d(a) {
            TemplateHeaderCellInfoDescriptionMetadata.b(a);
            a.q("TemplateHeaderCellInfo", () => new TemplateHeaderCellInfoDescription());
            a.p("TemplateHeaderCellInfo", TemplateHeaderCellInfoDescriptionMetadata.a);
        }
    }
    TemplateHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateHeaderCellInfoDescriptionMetadata, 'TemplateHeaderCellInfoDescriptionMetadata');
    TemplateHeaderCellInfoDescriptionMetadata.a = null;
    return TemplateHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderDescription = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderDescription extends SectionHeaderDescription {
        constructor() {
            super();
            this.ci = null;
        }
        get_type() {
            return "TemplateSectionHeader";
        }
        get cellUpdatingRef() {
            return this.ci;
        }
        set cellUpdatingRef(a) {
            this.ci = a;
            this.e("CellUpdatingRef");
        }
    }
    TemplateSectionHeaderDescription.$t = /*@__PURE__*/ markType(TemplateSectionHeaderDescription, 'TemplateSectionHeaderDescription', SectionHeaderDescription.$);
    return TemplateSectionHeaderDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellUpdatingEventArgsDescription = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellUpdatingEventArgsDescription extends Description {
        constructor() {
            super();
        }
        get_type() {
            return "TemplateSectionHeaderCellUpdatingEventArgs";
        }
        get type() {
            return this.get_type();
        }
    }
    TemplateSectionHeaderCellUpdatingEventArgsDescription.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellUpdatingEventArgsDescription, 'TemplateSectionHeaderCellUpdatingEventArgsDescription', Description.$);
    return TemplateSectionHeaderCellUpdatingEventArgsDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a == null) {
                TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.c(a, TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a);
            }
        }
        static c(a, b) {
        }
        static d(a) {
            TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.b(a);
            a.q("TemplateSectionHeaderCellUpdatingEventArgs", () => new TemplateSectionHeaderCellUpdatingEventArgsDescription());
            a.p("TemplateSectionHeaderCellUpdatingEventArgs", TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a);
        }
    }
    TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata, 'TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata');
    TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.a = null;
    return TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateSectionHeaderDescriptionMetadata.a == null) {
                TemplateSectionHeaderDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateSectionHeaderDescriptionMetadata.c(a, TemplateSectionHeaderDescriptionMetadata.a);
                TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata.d(a);
            }
        }
        static c(a, b) {
            SectionHeaderDescriptionMetadata.c(a, b);
            b.item("CellUpdatingRef", "EventRef::cellUpdating");
        }
        static d(a) {
            TemplateSectionHeaderDescriptionMetadata.b(a);
            a.q("TemplateSectionHeader", () => new TemplateSectionHeaderDescription());
            a.p("TemplateSectionHeader", TemplateSectionHeaderDescriptionMetadata.a);
        }
    }
    TemplateSectionHeaderDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateSectionHeaderDescriptionMetadata, 'TemplateSectionHeaderDescriptionMetadata');
    TemplateSectionHeaderDescriptionMetadata.a = null;
    return TemplateSectionHeaderDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderDescriptionModule extends Base {
        static register(a) {
            TemplateSectionHeaderDescriptionMetadata.d(a);
        }
    }
    TemplateSectionHeaderDescriptionModule.$t = /*@__PURE__*/ markType(TemplateSectionHeaderDescriptionModule, 'TemplateSectionHeaderDescriptionModule');
    return TemplateSectionHeaderDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellInfoDescription extends SectionHeaderCellInfoDescription {
        constructor() {
            super();
        }
        get_type() {
            return "TemplateSectionHeaderCellInfo";
        }
    }
    TemplateSectionHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellInfoDescription, 'TemplateSectionHeaderCellInfoDescription', SectionHeaderCellInfoDescription.$);
    TemplateSectionHeaderCellInfoDescription.__marshalByValue2 = true;
    TemplateSectionHeaderCellInfoDescription.__marshalByValueAlias2 = "TemplateSectionHeaderCellModel";
    return TemplateSectionHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateSectionHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TemplateSectionHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TemplateSectionHeaderCellInfoDescriptionMetadata.a == null) {
                TemplateSectionHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TemplateSectionHeaderCellInfoDescriptionMetadata.c(a, TemplateSectionHeaderCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            SectionHeaderCellInfoDescriptionMetadata.c(a, b);
        }
        static d(a) {
            TemplateSectionHeaderCellInfoDescriptionMetadata.b(a);
            a.q("TemplateSectionHeaderCellInfo", () => new TemplateSectionHeaderCellInfoDescription());
            a.p("TemplateSectionHeaderCellInfo", TemplateSectionHeaderCellInfoDescriptionMetadata.a);
        }
    }
    TemplateSectionHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TemplateSectionHeaderCellInfoDescriptionMetadata, 'TemplateSectionHeaderCellInfoDescriptionMetadata');
    TemplateSectionHeaderCellInfoDescriptionMetadata.a = null;
    return TemplateSectionHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextCellInfoDescription = /*@__PURE__*/ (() => {
    class TextCellInfoDescription extends CellInfoDescription {
        constructor() {
            super();
            this.fd = null;
        }
        get_type() {
            return "TextCellInfo";
        }
        get textValue() {
            return this.fd;
        }
        set textValue(a) {
            this.fd = a;
            this.e("TextValue");
        }
    }
    TextCellInfoDescription.$t = /*@__PURE__*/ markType(TextCellInfoDescription, 'TextCellInfoDescription', CellInfoDescription.$);
    TextCellInfoDescription.__marshalByValue1 = true;
    TextCellInfoDescription.__marshalByValueAlias1 = "TextCellModel";
    return TextCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TextCellInfoDescriptionMetadata.a == null) {
                TextCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextCellInfoDescriptionMetadata.c(a, TextCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            CellInfoDescriptionMetadata.c(a, b);
            b.item("TextValue", "String");
        }
        static d(a) {
            TextCellInfoDescriptionMetadata.b(a);
            a.q("TextCellInfo", () => new TextCellInfoDescription());
            a.p("TextCellInfo", TextCellInfoDescriptionMetadata.a);
        }
    }
    TextCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TextCellInfoDescriptionMetadata, 'TextCellInfoDescriptionMetadata');
    TextCellInfoDescriptionMetadata.a = null;
    return TextCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderCellInfoDescription = /*@__PURE__*/ (() => {
    class TextHeaderCellInfoDescription extends TextCellInfoDescription {
        constructor() {
            super();
            this.fg = false;
            this.fm = null;
            this.fj = null;
            this.fl = null;
            this.fk = null;
        }
        get_type() {
            return "TextHeaderCellInfo";
        }
        get isColumnOptionsEnabled() {
            return this.fg;
        }
        set isColumnOptionsEnabled(a) {
            this.fg = a;
            this.e("IsColumnOptionsEnabled");
        }
        get sortIndicatorStyle() {
            return this.fm;
        }
        set sortIndicatorStyle(a) {
            this.fm = a;
            this.e("SortIndicatorStyle");
        }
        get columnOptionsIconAlignment() {
            return this.fj;
        }
        set columnOptionsIconAlignment(a) {
            this.fj = a;
            this.e("ColumnOptionsIconAlignment");
        }
        get columnOptionsIconColor() {
            return this.fl;
        }
        set columnOptionsIconColor(a) {
            this.fl = a;
            this.e("ColumnOptionsIconColor");
        }
        get columnOptionsIconBehavior() {
            return this.fk;
        }
        set columnOptionsIconBehavior(a) {
            this.fk = a;
            this.e("ColumnOptionsIconBehavior");
        }
    }
    TextHeaderCellInfoDescription.$t = /*@__PURE__*/ markType(TextHeaderCellInfoDescription, 'TextHeaderCellInfoDescription', TextCellInfoDescription.$);
    TextHeaderCellInfoDescription.__marshalByValue2 = true;
    TextHeaderCellInfoDescription.__marshalByValueAlias2 = "TextHeaderCellModel";
    return TextHeaderCellInfoDescription;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextHeaderCellInfoDescriptionMetadata = /*@__PURE__*/ (() => {
    class TextHeaderCellInfoDescriptionMetadata extends Base {
        static b(a) {
            if (TextHeaderCellInfoDescriptionMetadata.a == null) {
                TextHeaderCellInfoDescriptionMetadata.a = new Dictionary$2(String_$type, String_$type, 0);
                TextHeaderCellInfoDescriptionMetadata.c(a, TextHeaderCellInfoDescriptionMetadata.a);
            }
        }
        static c(a, b) {
            TextCellInfoDescriptionMetadata.c(a, b);
            b.item("IsColumnOptionsEnabled", "Boolean");
            b.item("SortIndicatorStyle", "ExportedType:string:SortIndicatorStyle");
            b.item("SortIndicatorStyle@names", "Default;FadingUpDownArrows;FadingSimpleUpDownArrows;Unset");
            b.item("ColumnOptionsIconAlignment", "ExportedType:string:ColumnOptionsIconAlignment");
            b.item("ColumnOptionsIconAlignment@names", "Unset;None;Opposite");
            b.item("ColumnOptionsIconColor", "Brush");
            b.item("ColumnOptionsIconBehavior", "ExportedType:string:ColumnOptionsIconBehavior");
            b.item("ColumnOptionsIconBehavior@names", "Unset;AlwaysVisible;AppearOnHover;AppearOnHoverAnimate");
        }
        static d(a) {
            TextHeaderCellInfoDescriptionMetadata.b(a);
            a.q("TextHeaderCellInfo", () => new TextHeaderCellInfoDescription());
            a.p("TextHeaderCellInfo", TextHeaderCellInfoDescriptionMetadata.a);
        }
    }
    TextHeaderCellInfoDescriptionMetadata.$t = /*@__PURE__*/ markType(TextHeaderCellInfoDescriptionMetadata, 'TextHeaderCellInfoDescriptionMetadata');
    TextHeaderCellInfoDescriptionMetadata.a = null;
    return TextHeaderCellInfoDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DescriptionTreeActionType_$type = /*@__PURE__*/ markEnum('DescriptionTreeActionType', 'UpdateProperty,0|ResetProperty,1|InsertItem,2|ReplaceItem,3|RemoveItem,4|ClearItems,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChildContentExtendedDescriptionModule = /*@__PURE__*/ (() => {
    class ChildContentExtendedDescriptionModule extends Base {
        static register(a) {
        }
    }
    ChildContentExtendedDescriptionModule.$t = /*@__PURE__*/ markType(ChildContentExtendedDescriptionModule, 'ChildContentExtendedDescriptionModule');
    return ChildContentExtendedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataChartDefaultTooltipsExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class DataChartDefaultTooltipsExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DataChartDefaultTooltipsExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(DataChartDefaultTooltipsExtendedDescriptionMetadata, 'DataChartDefaultTooltipsExtendedDescriptionMetadata');
    return DataChartDefaultTooltipsExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DoughnutChartDefaultTooltipsExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class DoughnutChartDefaultTooltipsExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    DoughnutChartDefaultTooltipsExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(DoughnutChartDefaultTooltipsExtendedDescriptionMetadata, 'DoughnutChartDefaultTooltipsExtendedDescriptionMetadata');
    return DoughnutChartDefaultTooltipsExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TooltipContainerExtendedDescriptionModule = /*@__PURE__*/ (() => {
    class TooltipContainerExtendedDescriptionModule extends Base {
        static register(a) {
        }
    }
    TooltipContainerExtendedDescriptionModule.$t = /*@__PURE__*/ markType(TooltipContainerExtendedDescriptionModule, 'TooltipContainerExtendedDescriptionModule');
    return TooltipContainerExtendedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SimpleDefaultTooltipExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class SimpleDefaultTooltipExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    SimpleDefaultTooltipExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(SimpleDefaultTooltipExtendedDescriptionMetadata, 'SimpleDefaultTooltipExtendedDescriptionMetadata');
    return SimpleDefaultTooltipExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FinancialChartDefaultTemplatesExtendedDescriptionMetadata = /*@__PURE__*/ (() => {
    class FinancialChartDefaultTemplatesExtendedDescriptionMetadata extends Base {
        static register(a) {
        }
    }
    FinancialChartDefaultTemplatesExtendedDescriptionMetadata.$t = /*@__PURE__*/ markType(FinancialChartDefaultTemplatesExtendedDescriptionMetadata, 'FinancialChartDefaultTemplatesExtendedDescriptionMetadata');
    return FinancialChartDefaultTemplatesExtendedDescriptionMetadata;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TemplateContentExtendedDescriptionModule = /*@__PURE__*/ (() => {
    class TemplateContentExtendedDescriptionModule extends Base {
        static register(a) {
        }
    }
    TemplateContentExtendedDescriptionModule.$t = /*@__PURE__*/ markType(TemplateContentExtendedDescriptionModule, 'TemplateContentExtendedDescriptionModule');
    return TemplateContentExtendedDescriptionModule;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Uri = /*@__PURE__*/ (() => {
    class Uri extends Base {
        constructor(a, ..._rest) {
            super();
            this._value = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, 1, true];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            this.value = f;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, true];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            this.value = g;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.value = c;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        throw new NotImplementedException(0);
                    }
                    break;
            }
        }
        get value() {
            return this._value;
        }
        set value(a) {
            this._value = a;
        }
        get isAbsoluteUri() {
            let a = this.value;
            let b = a.length;
            if (b != 0 && isLetter(a.charAt(0))) {
                for (let c = 1; c < b; c++) {
                    let d = a.charAt(c);
                    if (d == ':') {
                        return true;
                    }
                    if (d != '+' && d != '-' && d != '.' && !isLetterOrDigit(d)) {
                        break;
                    }
                }
            }
            return false;
        }
        get scheme() {
            let a = this.value;
            let b = a.length;
            if (b != 0 && isLetter(a.charAt(0))) {
                for (let c = 1; c < b; c++) {
                    let d = a.charAt(c);
                    if (d == ':') {
                        return a.substr(0, c);
                    }
                    if (d != '+' && d != '-' && d != '.' && !isLetterOrDigit(d)) {
                        break;
                    }
                }
            }
            throw new InvalidOperationException(1, "The scheme cannot be obtained from a relative Uri.");
        }
        static encodeURIComponent(a) {
            return null;
        }
        static escapeUriString(a) {
            if ((/^([A-Z]:)|(\\\\)/i.test(a))) {
                return a;
            }
            return (encodeURI(a));
        }
        static tryCreate(a, b, c) {
            if (Uri.isWellFormedUriString(a, b)) {
                c = new Uri(2, a, b, false);
                return {
                    ret: true,
                    p2: c
                };
            }
            c = null;
            return {
                ret: false,
                p2: c
            };
        }
        static isWellFormedUriString(a, b) {
            switch (b) {
                case 1:
                    if (!(/^(((http|ftp|https):\/\/[\w-]+(\.[\w-]*)+)|(file:\/\/\/?))([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.test(a))) {
                        return false;
                    }
                    break;
                case 2:
                    if (!(/^([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.test(a))) {
                        return false;
                    }
                    break;
                default:
                case 0:
                    if (!(/^((((http|ftp|https):\/\/[\w-]+(\.[\w-]*)+)|(file:\/\/\/?)))?([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.test(a))) {
                        return false;
                    }
                    break;
            }
            return true;
        }
        toString() {
            if ((/^([A-Z]:)|(\\\\)/i.test(this.value))) {
                return this.value;
            }
            let a = (decodeURI(this.value));
            if ((/^(http|ftp|https):\/\/[\w-]+(\.[\w-]*)+?$/i.test(a))) {
                a += "/";
            }
            return a;
        }
        get absolutePath() {
            throw new NotImplementedException(0);
        }
        get absoluteUri() {
            throw new NotImplementedException(0);
        }
        get localPath() {
            let a = (/^(((http|ftp|https):\/\/[\w-]+(\.[\w-]*)+)|(file:\/\/\/?))([\w\\$()!'.,@?^=%&amp;:\/~+#-]*[\w@?^=%&amp;\/~+#-])?$/i.exec(this.value));
            if (a == null) {
                throw new InvalidOperationException(0);
            }
            if (a[6] != null) {
                return (decodeURI(a[6]));
            }
            return "/";
        }
        get originalString() {
            return this.value;
        }
        isWellFormedOriginalString() {
            return Uri.isWellFormedUriString(this.value, 0);
        }
    }
    Uri.$t = /*@__PURE__*/ markType(Uri, 'Uri');
    Uri.schemeDelimiter = "://";
    return Uri;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationSourcePointRecord = /*@__PURE__*/ (() => {
    class TriangulationSourcePointRecord extends Base {
        constructor() {
            super(...arguments);
            this.pointX = 0;
            this.pointY = 0;
            this.value = 0;
        }
    }
    TriangulationSourcePointRecord.$t = /*@__PURE__*/ markType(TriangulationSourcePointRecord, 'TriangulationSourcePointRecord');
    return TriangulationSourcePointRecord;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Triangle = /*@__PURE__*/ (() => {
    class Triangle extends Base {
        constructor() {
            super(...arguments);
            this.v1 = 0;
            this.v2 = 0;
            this.v3 = 0;
        }
    }
    Triangle.$t = /*@__PURE__*/ markType(Triangle, 'Triangle');
    return Triangle;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulatorContext = /*@__PURE__*/ (() => {
    class TriangulatorContext extends Base {
        constructor() {
            super(...arguments);
            this.j = 0;
            this.d = null;
            this.e = null;
            this.i = null;
            this.n = null;
            this.o = null;
            this.p = null;
            this.g = null;
            this.f = null;
            this.h = null;
            this.a = null;
            this.b = null;
            this.m = 0;
            this.l = 0;
            this.k = 0;
            this.c = false;
        }
    }
    TriangulatorContext.$t = /*@__PURE__*/ markType(TriangulatorContext, 'TriangulatorContext');
    return TriangulatorContext;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HalfEdge = /*@__PURE__*/ (() => {
    class HalfEdge extends Base {
        constructor(a, b) {
            super();
            this.a = 0;
            this.b = 0;
            this.a = a;
            this.b = b;
        }
    }
    HalfEdge.$t = /*@__PURE__*/ markType(HalfEdge, 'HalfEdge');
    return HalfEdge;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EdgeComparer = /*@__PURE__*/ (() => {
    class EdgeComparer extends Base {
        equalsC(a, b) {
            return (a.a == b.a && a.b == b.b) || (a.a == b.b && a.b == b.a);
        }
        getHashCodeC(a) {
            return 65536 * Math.max(a.a, a.b) + Math.min(a.a, a.b);
        }
    }
    EdgeComparer.$t = /*@__PURE__*/ markType(EdgeComparer, 'EdgeComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(HalfEdge.$)]);
    return EdgeComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HalfEdgeSet = /*@__PURE__*/ (() => {
    class HalfEdgeSet extends Base {
        constructor() {
            super();
            this.b = null;
            this.b = new Dictionary$2(HalfEdge.$, Base.$, 2, new EdgeComparer());
        }
        getEnumerator() {
            return getEnumerator(this.b.keys);
        }
        getEnumeratorObject() {
            return this.getEnumerator();
        }
        d(a) {
            this.b.addItem(a, null);
        }
        f(a) {
            this.b.removeItem(a);
        }
        e() {
            this.b.clear();
        }
        get c() {
            return this.b.count;
        }
        a(a) {
            return this.b.containsKey(a);
        }
    }
    HalfEdgeSet.$t = /*@__PURE__*/ markType(HalfEdgeSet, 'HalfEdgeSet', Base.$, [/*@__PURE__*/ IEnumerable$1_$type.specialize(HalfEdge.$)]);
    return HalfEdgeSet;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointTester = /*@__PURE__*/ (() => {
    class PointTester extends Base {
        constructor() {
            super(...arguments);
            this.a = false;
            this.b = false;
        }
        c(a, b, c, d, e, f, g, h) {
            let i = Math.abs(d - f);
            let j = Math.abs(f - h);
            let k = 0;
            let l = 0;
            if (i == 0 && j == 0) {
                return false;
            }
            if (i == 0 && j != 0) {
                k = (e + c) / 2;
                l = (-(g - e) / (h - f)) * (k - ((e + g) / 2)) + ((f + h) / 2);
            }
            if (i != 0 && j == 0) {
                k = (g + e) / 2;
                l = (-(e - c) / (f - d)) * (k - ((c + e) / 2)) + ((d + f) / 2);
            }
            if (i != 0 && j != 0) {
                let m = -(e - c) / (f - d);
                let n = -(g - e) / (h - f);
                let o = (c + e) / 2;
                let p = (e + g) / 2;
                let q = (d + f) / 2;
                let r = (f + h) / 2;
                k = (m * o - n * p + r - q) / (m - n);
                l = i > j ? m * (k - o) + q : n * (k - p) + r;
            }
            let s = e - k;
            let t = f - l;
            let u = s * s + t * t;
            s = a - k;
            t = b - l;
            let v = s * s + t * t;
            this.b = v <= u;
            this.a = k < a && ((a - k) * (a - k)) > u;
            return true;
        }
    }
    PointTester.$t = /*@__PURE__*/ markType(PointTester, 'PointTester');
    return PointTester;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointComparer = /*@__PURE__*/ (() => {
    class PointComparer extends Base {
        equalsC(a, b) {
            return a.x == b.x && a.y == b.y;
        }
        getHashCodeC(a) {
            return (a.x) ^ (a.y);
        }
    }
    PointComparer.$t = /*@__PURE__*/ markType(PointComparer, 'PointComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(Point_$type)]);
    return PointComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationStatusEventArgs = /*@__PURE__*/ (() => {
    class TriangulationStatusEventArgs extends EventArgs {
        constructor(a) {
            super();
            this._currentStatus = 0;
            this.currentStatus = a;
        }
        get currentStatus() {
            return this._currentStatus;
        }
        set currentStatus(a) {
            this._currentStatus = a;
        }
    }
    TriangulationStatusEventArgs.$t = /*@__PURE__*/ markType(TriangulationStatusEventArgs, 'TriangulationStatusEventArgs', EventArgs.$);
    return TriangulationStatusEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Triangulator = /*@__PURE__*/ (() => {
    class Triangulator extends DependencyObject {
        constructor(a, b, c) {
            super();
            this.o = 0;
            this.l = null;
            this.m = null;
            this.k = null;
            this.p = 0;
            this.triangulationStatusChanged = null;
            this.o = a;
            this.l = b;
            this.m = c;
        }
        y() {
            {
                this.v();
                if (this.k != null) {
                    this.k.c = true;
                }
                this.u();
            }
        }
        x() {
            {
                this.v();
                if (this.k != null) {
                    this.k.c = false;
                }
                this.u();
            }
        }
        v() {
            let a = this.o;
            let b = this.l;
            let c = this.m;
            let d = new List$1(Triangle.$, 0);
            let e = ((() => {
                let $ret = new List$1(Number_$type, 0);
                $ret.h = a;
                return $ret;
            })());
            let f = new HashSet$1(Point_$type, 2, new PointComparer());
            for (let g = 0; g < a; ++g) {
                let h = b.item(g), i = c.item(g);
                if (isNaN_(h) || isNaN_(i) || isInfinity(h) || isInfinity(i)) {
                    continue;
                }
                let j = { $type: Point_$type, x: h, y: i };
                if (f.contains(j)) {
                    continue;
                }
                f.add_1(j);
                e.add(g);
            }
            a = e.count;
            if (a >= 3) {
                let k = (l, m) => {
                    if (b.item(l) < b.item(m)) {
                        return -1;
                    }
                    else if (b.item(l) > b.item(m)) {
                        return 1;
                    }
                    if (c.item(l) < c.item(m)) {
                        return -1;
                    }
                    else if (c.item(l) > c.item(m)) {
                        return 1;
                    }
                    return 0;
                };
                e.aa(k);
                let l = b.item(e._inner[0]);
                let m = b.item(e._inner[a - 1]);
                let n = c.item(e._inner[0]);
                let o = n;
                for (let p = 1; p < a; p++) {
                    let q = c.item(e._inner[p]);
                    if (isNaN_(q)) {
                        continue;
                    }
                    n = Math.min(n, q);
                    o = Math.max(o, q);
                }
                let r = m - l;
                let s = o - n;
                let t = Math.max(r, s);
                let u = (m + l) / 2;
                let v = (o + n) / 2;
                let w = { $type: Point_$type, x: u - 20 * t, y: v - t };
                let x = { $type: Point_$type, x: u, y: v + 20 * t };
                let y = { $type: Point_$type, x: u + 20 * t, y: v - t };
                let z = new LinkedList$1(Triangle.$);
                let aa = new LinkedList$1(Triangle.$);
                let ab = new HalfEdgeSet();
                let ac = new PointTester();
                z.e(((() => {
                    let $ret = new Triangle();
                    $ret.v1 = a;
                    $ret.v2 = a + 1;
                    $ret.v3 = a + 2;
                    return $ret;
                })()));
                let ad = new TriangulatorContext();
                ad.j = a;
                ad.n = w;
                ad.o = x;
                ad.p = y;
                ad.f = aa;
                ad.a = ab;
                ad.h = e;
                ad.b = ac;
                ad.i = d;
                ad.g = z;
                ad.d = b;
                ad.e = c;
                let ae = 1;
                if (a > 3000) {
                    ae = 20;
                }
                ad.m = truncate(Math.ceil(a / ae));
                ad.l = 0;
                ad.k = ad.m;
                this.p = 0;
                this.t();
                this.k = ad;
            }
        }
        t() {
            this.s();
        }
        s() {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(this.p));
            }
        }
        n() {
            if (this.k == null) {
                return null;
            }
            return this.k.i;
        }
        w() {
            {
                if (this.k == null) {
                    return;
                }
                let a = this.k;
                let b = this.k.j;
                let c = this.k.d;
                let d = this.k.e;
                let e = this.k.h;
                let f = this.k.n;
                let g = this.k.o;
                let h = this.k.p;
                let i = this.k.i;
                let j = this.k.g;
                let k = this.k.f;
                let l = this.k.b;
                let m = this.k.a;
                let n = this.k.l;
                let o = this.k.k;
                let p;
                let q;
                let r;
                let s;
                let t;
                let u;
                let v;
                let w;
                let x;
                let y;
                let z;
                let aa;
                for (let ab = n; ab < o; ++ab) {
                    m.e();
                    if (ab < b) {
                        p = c.item(e._inner[ab]);
                        q = d.item(e._inner[ab]);
                    }
                    else if (ab == b) {
                        p = f.x;
                        q = f.y;
                    }
                    else if (ab == b + 1) {
                        p = g.x;
                        q = g.y;
                    }
                    else {
                        p = h.x;
                        q = h.y;
                    }
                    let ac = null;
                    for (let ad = j.c; ad != null; ad = ac) {
                        ac = ad.a;
                        aa = ad.c;
                        r = aa.v1;
                        u = aa.v2;
                        x = aa.v3;
                        if (r < b) {
                            s = c.item(e._inner[r]);
                            t = d.item(e._inner[r]);
                        }
                        else if (r == b) {
                            s = f.x;
                            t = f.y;
                        }
                        else if (r == b + 1) {
                            s = g.x;
                            t = g.y;
                        }
                        else {
                            s = h.x;
                            t = h.y;
                        }
                        if (u < b) {
                            v = c.item(e._inner[u]);
                            w = d.item(e._inner[u]);
                        }
                        else if (u == b) {
                            v = f.x;
                            w = f.y;
                        }
                        else if (u == b + 1) {
                            v = g.x;
                            w = g.y;
                        }
                        else {
                            v = h.x;
                            w = h.y;
                        }
                        if (x < b) {
                            y = c.item(e._inner[x]);
                            z = d.item(e._inner[x]);
                        }
                        else if (x == b) {
                            y = f.x;
                            z = f.y;
                        }
                        else if (x == b + 1) {
                            y = g.x;
                            z = g.y;
                        }
                        else {
                            y = h.x;
                            z = h.y;
                        }
                        l.c(p, q, s, t, v, w, y, z);
                        if (l.a) {
                            k.f(aa);
                            j.h(ad);
                        }
                        if (l.b) {
                            let ae;
                            ae = new HalfEdge(r, u);
                            if (m.a(ae)) {
                                m.f(ae);
                            }
                            else {
                                m.d(ae);
                            }
                            ae = new HalfEdge(u, x);
                            if (m.a(ae)) {
                                m.f(ae);
                            }
                            else {
                                m.d(ae);
                            }
                            ae = new HalfEdge(x, r);
                            if (m.a(ae)) {
                                m.f(ae);
                            }
                            else {
                                m.d(ae);
                            }
                            j.h(ad);
                        }
                    }
                    for (let af of fromEnum(m)) {
                        let ag = new Triangle();
                        ag.v1 = af.a;
                        ag.v2 = af.b;
                        ag.v3 = ab;
                        j.f(ag);
                    }
                }
                if (o == b) {
                    for (let ah = k.c; ah != null; ah = ah.a) {
                        aa = ah.c;
                        if (aa.v1 < b && aa.v2 < b && aa.v3 < b) {
                            i.add(((() => {
                                let $ret = new Triangle();
                                $ret.v1 = e._inner[aa.v1];
                                $ret.v2 = e._inner[aa.v2];
                                $ret.v3 = e._inner[aa.v3];
                                return $ret;
                            })()));
                        }
                    }
                    for (let ai = j.c; ai != null; ai = ai.a) {
                        aa = ai.c;
                        if (aa.v1 < b && aa.v2 < b && aa.v3 < b) {
                            i.add(((() => {
                                let $ret = new Triangle();
                                $ret.v1 = e._inner[aa.v1];
                                $ret.v2 = e._inner[aa.v2];
                                $ret.v3 = e._inner[aa.v3];
                                return $ret;
                            })()));
                        }
                    }
                    this.p = 100;
                    this.t();
                }
                else {
                    n = o;
                    o += a.m;
                    if (o > b) {
                        o = b;
                    }
                    a.l = n;
                    a.k = o;
                    this.p += truncate(Math.floor(100 / 20));
                    this.t();
                    this.u();
                }
            }
        }
        r() {
            {
                this.k = null;
            }
        }
        u() {
            {
                if (this.k != null && this.k.c) {
                    window.setTimeout(runOn(this, this.w), 0);
                }
                else {
                    this.w();
                }
            }
        }
        get q() {
            return this.p;
        }
    }
    Triangulator.$t = /*@__PURE__*/ markType(Triangulator, 'Triangulator', DependencyObject.$);
    return Triangulator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TriangulationSource = /*@__PURE__*/ (() => {
    class TriangulationSource extends Base {
        constructor() {
            super(...arguments);
            this._points = null;
            this._triangles = null;
        }
        static create(a, b, c) {
            let d = new TriangulationSource();
            let e = new Array(a);
            let f;
            let g;
            let h = new Array(a);
            let i = new Array(a);
            let j = 0;
            let k = 0;
            for (let l = 0; l < a; l++) {
                f = new TriangulationSourcePointRecord();
                g = b(l);
                j = g.x;
                k = g.y;
                f.pointX = j;
                f.pointY = k;
                f.value = c(l);
                e[l] = f;
                h[l] = j;
                i[l] = k;
            }
            d.points = e;
            let m = new Triangulator(a, boxArray$1(h), boxArray$1(i));
            m.x();
            d.triangles = m.n();
            return d;
        }
        static loadItf(a) {
            a.readBytes(5);
            let b = a.readInt32();
            let c = a.readInt32();
            let d = a.readInt32();
            let e = a.readInt32();
            a.readBytes(e);
            let f = new TriangulationSource();
            let g = new Array(b);
            let h;
            for (let i = 0; i < b; i++) {
                h = new TriangulationSourcePointRecord();
                h.pointX = a.readDouble();
                h.pointY = a.readDouble();
                h.value = a.readSingle();
                g[i] = h;
            }
            f.points = g;
            let j = new Array(c);
            let k;
            for (let l = 0; l < c; l++) {
                k = new Triangle();
                k.v1 = a.readInt32();
                k.v2 = a.readInt32();
                k.v3 = a.readInt32();
                j[l] = k;
            }
            f.triangles = boxArray$1(j);
            return f;
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        get triangles() {
            return this._triangles;
        }
        set triangles(a) {
            this._triangles = a;
        }
    }
    TriangulationSource.$t = /*@__PURE__*/ markType(TriangulationSource, 'TriangulationSource');
    return TriangulationSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BinaryReader = /*@__PURE__*/ (() => {
    class BinaryReader extends Base {
        constructor(a, ..._rest) {
            super();
            this._data = null;
            this.d = false;
            this.n = 0;
            this.e = false;
            this.f = false;
            this._stream = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this._data = c;
                        this.d = d;
                        let data_ = this._data;
                        if ((typeof Uint8Array != 'undefined' && data_ instanceof Uint8Array)) {
                            this.e = true;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this._stream = c;
                        this.f = true;
                    }
                    break;
            }
        }
        get canRead() {
            return this.n < this._data.length;
        }
        get currentPosition() {
            return this.n;
        }
        get length() {
            if (this.f) {
                return this._stream.length;
            }
            return this._data.length;
        }
        i(offset_) {
            if (this.f) {
                this._stream.position = offset_;
                return this._stream.readByte();
            }
            else if (this.e) {
                return (+this._data[offset_] & 0xFF);
            }
            else {
                return (this._data.charCodeAt(offset_) & 0xFF);
            }
        }
        a(offset_, a) {
            let b = new Array(a);
            if (this.f) {
                this._stream.position = offset_;
                this._stream.read(b, 0, a);
            }
            else if (this.e) {
                for (let i_ = 0; i_ < a; i_++) {
                    b[i_] = (+this._data[offset_ + i_] & 0xFF);
                }
            }
            else {
                for (let i_ = 0; i_ < a; i_++) {
                    b[i_] = (this._data.charCodeAt(offset_ + i_) & 0xFF);
                }
            }
            return b;
        }
        b(offset_, length_) {
            let a = new Array(length_);
            if (this.f) {
                this._stream.position = offset_;
                this._stream.read(a, 0, length_);
                a.reverse();
            }
            else if (this.e) {
                for (let i_ = 0; i_ < length_; i_++) {
                    a[i_] = (+this._data[offset_ + (length_ - 1 - i_)] & 0xFF);
                }
            }
            else {
                for (let i_ = 0; i_ < length_; i_++) {
                    a[i_] = (this._data.charCodeAt(offset_ + (length_ - 1 - i_)) & 0xFF);
                }
            }
            return a;
        }
        readByte() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.i(this.n);
            this.n = this.n + 1;
            return a;
        }
        readBytes(a) {
            if (this.f) {
                this.n = this._stream.position;
            }
            let b = this.a(this.n, a);
            this.n = this.n + a;
            return b;
        }
        readUInt32() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
            }
            if (a < 0) {
                a = a + 0xFFFFFFFF + 1;
            }
            return a;
        }
        readUInt16() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
            }
            return a;
        }
        readInt32() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 16);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 24);
                this.n = this.n + 1;
            }
            if (a > 2147483647) {
                a = a - 0xFFFFFFFF - 1;
            }
            return a;
        }
        readDouble() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.b(this.n, 8);
            this.n = this.n + 8;
            let b = a[0] >>> 7;
            let c = 0;
            c = c + (a[1] >>> 4);
            c = c + ((a[0] & 127) << 4);
            let d = 1;
            let e = a[1];
            let f = 1 / 2;
            let g = 0;
            let h = false;
            for (g = 5; g <= 8; g++) {
                if ((e & (1 << (8 - g))) > 0) {
                    d = d + f;
                    h = true;
                }
                f = f / 2;
            }
            for (let i = 2; i < 8; i++) {
                e = a[i];
                for (g = 1; g <= 8; g++) {
                    if ((e & (1 << (8 - g))) > 0) {
                        d = d + f;
                        h = true;
                    }
                    f = f / 2;
                }
            }
            if (c == 0 && !h) {
                return 0;
            }
            if (c == 0 && h) {
                c = 1;
                d = d - 1;
            }
            if (c == 1860 && !h) {
                if (b == 1) {
                    return Number.NEGATIVE_INFINITY;
                }
                else {
                    return Number.POSITIVE_INFINITY;
                }
            }
            if (c == 1860 && h) {
                return NaN;
            }
            let j = c - 1023;
            return Math.pow(-1, b) * Math.pow(2, j) * d;
        }
        readSingle() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.b(this.n, 4);
            this.n = this.n + 4;
            let b = a[0] >>> 7;
            let c = 0;
            c = c + (a[1] >>> 7);
            c = c + ((a[0] & 127) << 1);
            let d = 1;
            let e = a[1];
            let f = 1 / 2;
            let g = 0;
            let h = false;
            for (g = 2; g <= 8; g++) {
                if ((e & (1 << (8 - g))) > 0) {
                    d = d + f;
                    h = true;
                }
                f = f / 2;
            }
            for (let i = 2; i < 4; i++) {
                e = a[i];
                for (g = 1; g <= 8; g++) {
                    if ((e & (1 << (8 - g))) > 0) {
                        d = d + f;
                        h = true;
                    }
                    f = f / 2;
                }
            }
            if (c == 0 && !h) {
                return 0;
            }
            if (c == 0 && h) {
                c = 1;
                d = d - 1;
            }
            if (c == 255 && !h) {
                if (b == 1) {
                    return Number.NEGATIVE_INFINITY;
                }
                else {
                    return Number.POSITIVE_INFINITY;
                }
            }
            if (c == 255 && h) {
                return NaN;
            }
            let j = c - 127;
            return Math.pow(-1, b) * Math.pow(2, j) * d;
        }
        get_baseStream() {
            return this._stream;
        }
        get baseStream() {
            return this.get_baseStream();
        }
        readBoolean() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.i(this.n);
            this.n = this.n + 1;
            return a != 0;
        }
        readInt16() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = 0;
            if (this.d) {
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
                a = a + this.i(this.n);
                this.n = this.n + 1;
            }
            else {
                a = a + this.i(this.n);
                this.n = this.n + 1;
                a = a + (this.i(this.n) << 8);
                this.n = this.n + 1;
            }
            if (a > 32767) {
                a -= (65535 + 1);
            }
            return a;
        }
        readSByte() {
            if (this.f) {
                this.n = this._stream.position;
            }
            let a = this.i(this.n);
            this.n = this.n + 1;
            if (a > 127) {
                return (a - 255 + 1);
            }
            return a;
        }
        close() {
            this.dispose();
        }
        dispose() {
            if (this.f) {
                this._stream.dispose();
            }
        }
    }
    BinaryReader.$t = /*@__PURE__*/ markType(BinaryReader, 'BinaryReader', Base.$, [IDisposable_$type]);
    return BinaryReader;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BinaryFileDownloader = /*@__PURE__*/ (() => {
    class BinaryFileDownloader extends Base {
        static a(uri_, callback_, errorCallback_) {
            BinaryUtil.getBinary(uri_, callback_, errorCallback_);
        }
    }
    BinaryFileDownloader.$t = /*@__PURE__*/ markType(BinaryFileDownloader, 'BinaryFileDownloader');
    return BinaryFileDownloader;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AsyncCompletedEventArgs = /*@__PURE__*/ (() => {
    class AsyncCompletedEventArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this.d = null;
            this.b = false;
            this.f = null;
            this.b = b;
            this.d = a;
            this.f = c;
        }
        get error() {
            return this.d;
        }
        get cancelled() {
            return this.b;
        }
        get userState() {
            return this.f;
        }
        h() {
            if (this.error != null) {
                throw this.error;
            }
        }
    }
    AsyncCompletedEventArgs.$t = /*@__PURE__*/ markType(AsyncCompletedEventArgs, 'AsyncCompletedEventArgs', EventArgs.$);
    return AsyncCompletedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ItfConverter = /*@__PURE__*/ (() => {
    class ItfConverter extends DependencyObject {
        constructor() {
            super(...arguments);
            this.j = null;
            this.importCompleted = null;
            this.propertyChanged = null;
        }
        get source() {
            return typeCast(Uri.$, this.c(ItfConverter.sourceProperty));
        }
        set source(a) {
            this.h(ItfConverter.sourceProperty, a);
        }
        get triangulationSource() {
            return this.j;
        }
        set triangulationSource(a) {
            let b = a != this.triangulationSource;
            if (b) {
                let c = this.j;
                this.j = a;
                this.t("TriangulationSource", c, this.triangulationSource);
            }
        }
        r() {
            let a = null;
            let b = () => {
                if (a != null) {
                    this.triangulationSource = TriangulationSource.loadItf(a);
                }
                this.s(new AsyncCompletedEventArgs(null, false, null));
            };
            BinaryFileDownloader.a(this.source.value, (c) => {
                a = new BinaryReader(0, c, false);
                b();
            }, (c) => {
                throw new BaseError(1, "itf file download error: " + c);
            });
        }
        s(a) {
            if (this.importCompleted != null) {
                this.importCompleted(this, a);
            }
        }
        u(a, b, c) {
            switch (a) {
                case "Source":
                    if (this.source != null) {
                        this.r();
                    }
                    break;
            }
        }
        t(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.u(a, b, c);
        }
        getPointData() {
            if (this.j == null) {
                return null;
            }
            return new List$1(TriangulationSourcePointRecord.$, 1, this.j.points);
        }
        getTriangleData() {
            if (this.j == null) {
                return null;
            }
            return new List$1(Triangle.$, 1, this.j.triangles);
        }
    }
    ItfConverter.$t = /*@__PURE__*/ markType(ItfConverter, 'ItfConverter', DependencyObject.$, [INotifyPropertyChanged_$type]);
    ItfConverter.sourceProperty = /*@__PURE__*/ DependencyProperty.i("Source", Uri.$, ItfConverter.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => (typeCast(ItfConverter.$, a)).u("Source", b.oldValue, b.newValue)));
    return ItfConverter;
})();

class IgrAsyncCompletedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    onImplementationCreated() {
    }
    get errorMessage() {
        if (this.i.error != null) {
            return this.i.error.message;
        }
        return null;
    }
    get cancelled() {
        return this.i.cancelled;
    }
    get userState() {
        return this.i.userState;
    }
}

/**
 * Class for converting Itf files into enumerable triangulations.
*/
class IgrTriangulationDataSource {
    constructor() {
        //@@ZoneRunner
        this._importCompleted = null;
        this._importCompleted_wrapped = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new ItfConverter();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the string path specifying the location of the Itf file.
    */
    get source() {
        if (this.i.source == null)
            return null;
        return this.i.source.value;
    }
    /**
     * Sets the string path specifying the location of the Itf file.
    */
    set source(v) {
        if (v == null) {
            this.i.source = null;
        }
        else {
            this.i.source = new Uri(0, v);
        }
    }
    /**
    * Gets the point data.
    */
    getPointData() {
        let iv = this.i.getPointData();
        return iv._inner;
    }
    /**
    * Gets the triangle data.
    */
    getTriangleData() {
        let iv = this.i.getTriangleData();
        return iv._inner;
    }
    findByName(name) {
        return null;
    }
    /**
     * Event raised when the import operation has completed
    */
    get importCompleted() {
        return this._importCompleted;
    }
    set importCompleted(ev) {
        if (this._importCompleted_wrapped !== null) {
            this.i.importCompleted = delegateRemove(this.i.importCompleted, this._importCompleted_wrapped);
            this._importCompleted_wrapped = null;
            this._importCompleted = null;
        }
        this._importCompleted = ev;
        this._importCompleted_wrapped = (o, e) => {
            let outerArgs = new IgrAsyncCompletedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeImportCompleted) {
                this.beforeImportCompleted(this, outerArgs);
            }
            if (this._importCompleted) {
                this._importCompleted(this, outerArgs);
            }
        };
        this.i.importCompleted = delegateCombine(this.i.importCompleted, this._importCompleted_wrapped);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DownloadingMultiScaleImageEventArgs = /*@__PURE__*/ (() => {
    class DownloadingMultiScaleImageEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._uri = null;
            this._image = null;
        }
        get uri() {
            return this._uri;
        }
        set uri(a) {
            this._uri = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
    }
    DownloadingMultiScaleImageEventArgs.$t = /*@__PURE__*/ markType(DownloadingMultiScaleImageEventArgs, 'DownloadingMultiScaleImageEventArgs', EventArgs.$);
    return DownloadingMultiScaleImageEventArgs;
})();

class IgrDownloadingMultiScaleImageEventArgs {
    createImplementation() {
        return new DownloadingMultiScaleImageEventArgs();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get image() {
        return this.i.image;
    }
    set image(v) {
        this.i.image = v;
    }
    get uri() {
        return this.i.uri;
    }
    set uri(v) {
        this.i.uri = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileRecord = /*@__PURE__*/ (() => {
    class ShapefileRecord extends DependencyObject {
        constructor() {
            super();
            this._shapeType = 0;
            this._fieldsNames = null;
            this._fieldsTypes = null;
            this.fields = null;
            this.points = null;
            this.propertyChanged = null;
            this._fieldValues = null;
            this._bounds = null;
            this.fieldsNames = new List$1(String_$type, 0);
            this.fieldsTypes = new List$1(String_$type, 0);
        }
        get shapeType() {
            return this._shapeType;
        }
        set shapeType(a) {
            this._shapeType = a;
        }
        get fieldsNames() {
            return this._fieldsNames;
        }
        set fieldsNames(a) {
            this._fieldsNames = a;
        }
        get fieldsTypes() {
            return this._fieldsTypes;
        }
        set fieldsTypes(a) {
            this._fieldsTypes = a;
        }
        q(a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        get fieldValues() {
            return this._fieldValues;
        }
        set fieldValues(a) {
            this._fieldValues = a;
        }
        get bounds() {
            return this._bounds;
        }
        set bounds(a) {
            this._bounds = a;
        }
        getFieldValue(a) {
            if (this.fields.containsKey(a)) {
                return this.fields.item(a);
            }
            return null;
        }
        setFieldValue(a, b) {
            if (this.fields.containsKey(a)) {
                this.fields.item(a, b);
            }
            else {
                this.fieldsNames.add(a);
                this.fieldsTypes.add("string");
                this.fields.addItem(a, b);
            }
        }
    }
    ShapefileRecord.$t = /*@__PURE__*/ markType(ShapefileRecord, 'ShapefileRecord', DependencyObject.$, [INotifyPropertyChanged_$type]);
    return ShapefileRecord;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFilterRecordEventArgs = /*@__PURE__*/ (() => {
    class ShapeFilterRecordEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = false;
        }
    }
    ShapeFilterRecordEventArgs.$t = /*@__PURE__*/ markType(ShapeFilterRecordEventArgs, 'ShapeFilterRecordEventArgs');
    return ShapeFilterRecordEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XBaseField = /*@__PURE__*/ (() => {
    class XBaseField extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = 0;
            this.b = 0;
        }
    }
    XBaseField.$t = /*@__PURE__*/ markType(XBaseField, 'XBaseField');
    return XBaseField;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Header = /*@__PURE__*/ (() => {
    class Header extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.e = null;
            this.b = new List$1(XBaseField.$, 0);
        }
        get d() {
            return { $type: Point_$type, x: this.e.left, y: this.e.top };
        }
        get c() {
            return { $type: Point_$type, x: this.e.right, y: this.e.bottom };
        }
    }
    Header.$t = /*@__PURE__*/ markType(Header, 'Header');
    return Header;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum for XBase field data types.
 */
var XBaseDataType = /*@__PURE__*/ (function (XBaseDataType) {
    /**
     * Character data type.
     */
    XBaseDataType[XBaseDataType["Character"] = 0] = "Character";
    /**
     * Number data type.
     */
    XBaseDataType[XBaseDataType["Number"] = 1] = "Number";
    /**
     * Logical data type.
     */
    XBaseDataType[XBaseDataType["Logical"] = 2] = "Logical";
    /**
     * Date data type.
     */
    XBaseDataType[XBaseDataType["Date"] = 3] = "Date";
    /**
     * Memo data type.
     */
    XBaseDataType[XBaseDataType["Memo"] = 4] = "Memo";
    /**
     * Floating point data type.
     */
    XBaseDataType[XBaseDataType["FloatingPoint"] = 5] = "FloatingPoint";
    /**
     * Binary data type.
     */
    XBaseDataType[XBaseDataType["Binary"] = 6] = "Binary";
    /**
     * General data type.
     */
    XBaseDataType[XBaseDataType["General"] = 7] = "General";
    /**
     * Picture data type.
     */
    XBaseDataType[XBaseDataType["Picture"] = 8] = "Picture";
    /**
     * Currency data type.
     */
    XBaseDataType[XBaseDataType["Currency"] = 9] = "Currency";
    /**
     * DateTime data type.
     */
    XBaseDataType[XBaseDataType["DateTime"] = 10] = "DateTime";
    /**
     * Integer data type.
     */
    XBaseDataType[XBaseDataType["Integer"] = 11] = "Integer";
    /**
     * VariField data type.
     */
    XBaseDataType[XBaseDataType["VariField"] = 12] = "VariField";
    /**
     * Variant data type.
     */
    XBaseDataType[XBaseDataType["Variant"] = 13] = "Variant";
    /**
     * Timestamp data type.
     */
    XBaseDataType[XBaseDataType["Timestamp"] = 14] = "Timestamp";
    /**
     * Double data type.
     */
    XBaseDataType[XBaseDataType["double1"] = 15] = "double1";
    /**
     * Auto increment data type.
     */
    XBaseDataType[XBaseDataType["AutoIncrement"] = 16] = "AutoIncrement";
    return XBaseDataType;
})({});
/**
 * @hidden
 */
let XBaseDataType_$type = /*@__PURE__*/ markEnum('XBaseDataType', 'Character,0|Number,1|Logical,2|Date,3|Memo,4|FloatingPoint,5|Binary,6|General,7|Picture,8|Currency,9|DateTime,10|Integer,11|VariField,12|Variant,13|Timestamp,14|Double:double1,15|AutoIncrement,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Decoder = /*@__PURE__*/ (() => {
    class Decoder extends Base {
        e(a, b, c, d, e, f, g, h, i, j) {
            throw new NotImplementedException(0);
            return {
                p7: h,
                p8: i,
                p9: j
            };
        }
        b(a, b, c, d) {
            throw new NotImplementedException(0);
        }
        d(a, b, c, d, e, f) {
            throw new NotImplementedException(0);
        }
        f() {
            throw new NotImplementedException(0);
        }
    }
    Decoder.$t = /*@__PURE__*/ markType(Decoder, 'Decoder');
    return Decoder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Encoding = /*@__PURE__*/ (() => {
    class Encoding extends Base {
        static get uTF8() {
            if (Encoding.t == null) {
                Encoding.t = new UTF8Encoding(1);
            }
            return Encoding.t;
        }
        static get uTF8Unmarked() {
            if (Encoding.s == null) {
                Encoding.s = new UTF8Encoding(1);
            }
            return Encoding.s;
        }
        static get unicode() {
            if (Encoding.r == null) {
                Encoding.r = new UnicodeEncoding(0);
            }
            return Encoding.r;
        }
        getString1(a, b, c) {
            return "";
        }
        getBytes(a, b, c) {
            let d = new Array(this.getByteCount(a, b, c));
            this.getBytes2(a, b, c, d, 0);
            return d;
        }
        getBytes1(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "input");
            }
            let b = new Array(a.length);
            for (let c = 0; c < a.length; c++) {
                b[c] = a.charAt(c);
            }
            return this.getBytes(b, 0, b.length);
        }
        getString(a) {
            return this.getString1(a, 0, a.length);
        }
        getCharCount(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "bytes");
            }
            return this.getCharCount1(a, 0, a.length);
        }
        getCharCount1(a, b, c) {
            throw new NotImplementedException(0);
        }
        getChars(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
        static get aSCII() {
            if (Encoding.p == null) {
                Encoding.p = new AsciiEncoding(1);
            }
            return Encoding.p;
        }
        getDecoder() {
            return new DefaultDecoder(this);
        }
        getBytes3(a, b, c, d, e) {
            return this.getBytes2(stringToCharArray(a), b, c, d, e);
        }
        getMaxCharCount(a) {
            return a;
        }
        getMaxByteCount(a) {
            return a + 1;
        }
        getPreamble() {
            return new Array(0);
        }
        static get bigEndianUnicode() {
            if (Encoding.q == null) {
                Encoding.q = new UnicodeEncoding(1, true, false);
            }
            return Encoding.q;
        }
        static get defaultValue() {
            return Encoding.aSCII;
        }
        static getEncoding(a) {
            switch (a.toUpperCase()) {
                case "ASCII": return Encoding.aSCII;
                case "UNICODE": return Encoding.unicode;
                case "UTF-8": return Encoding.uTF8;
                default: throw new ArgumentException(1, "'" + a + "' is not a valid encoding name.");
            }
        }
        get_webName() {
            throw new NotImplementedException(0);
        }
        get webName() {
            return this.get_webName();
        }
    }
    Encoding.$t = /*@__PURE__*/ markType(Encoding, 'Encoding');
    Encoding.t = null;
    Encoding.s = null;
    Encoding.r = null;
    Encoding.p = null;
    Encoding.q = null;
    return Encoding;
})();
/**
 * @hidden
 */
let UnicodeEncoding = /*@__PURE__*/ (() => {
    class UnicodeEncoding extends Encoding {
        constructor(a, ..._rest) {
            super();
            this.ab = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.ab = c;
                    }
                    break;
            }
        }
        getString1(bytes_, a, b) {
            let c = "";
            let d = a + b;
            for (let i_ = a; i_ < d; i_ = i_ + 2) {
                if (i_ + 1 >= d) {
                    c = c + '�';
                }
                else {
                    let e;
                    let f;
                    if (this.ab) {
                        e = bytes_[i_ + 1].toString(16);
                        f = bytes_[i_].toString(16);
                    }
                    else {
                        e = bytes_[i_].toString(16);
                        f = bytes_[i_ + 1].toString(16);
                    }
                    if (e.length == 1) {
                        e = "0" + e;
                    }
                    if (f.length == 1) {
                        f = "0" + f;
                    }
                    let g = parseInt(f + e, 16);
                    c = c + String.fromCharCode(g);
                }
            }
            return c;
        }
        getCharCount1(a, b, c) {
            return intDivide(c, 2);
        }
        getBytes(a, b, c) {
            return super.getBytes(a, b, c);
        }
        getBytes1(a) {
            let b = new Array(a.length * 2);
            this.getBytes3(a, 0, a.length, b, 0);
            return b;
        }
        getMaxByteCount(a) {
            return (a + 1) * 2;
        }
        getMaxCharCount(a) {
            return truncate(Math.ceil(a / 2)) + 1;
        }
        getBytes3(a, b, c, d, e) {
            for (let f = b; f < b + c; f++) {
                let g = a.charCodeAt(f);
                let h = (g & 255);
                let i = ((g >> 8) & 255);
                if (this.ab) {
                    d[e++] = i;
                    d[e++] = h;
                }
                else {
                    d[e++] = h;
                    d[e++] = i;
                }
            }
            return c * 2;
        }
        getByteCount(a, b, c) {
            throw new NotImplementedException(0);
        }
        getBytes2(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
        getChars(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
    }
    UnicodeEncoding.$t = /*@__PURE__*/ markType(UnicodeEncoding, 'UnicodeEncoding', Encoding.$);
    return UnicodeEncoding;
})();
/**
 * @hidden
 */
let UTF8Encoding = /*@__PURE__*/ (() => {
    class UTF8Encoding extends Encoding {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                    }
                    break;
                case 1: break;
            }
        }
        getString1(a, b, c) {
            let d = "";
            let e = b;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            while (e < b + c) {
                f = a[e++];
                if (f < 128) {
                    d += String.fromCharCode(f);
                }
                else if (f > 191 && f < 224) {
                    if (e >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    g = a[e++];
                    d += String.fromCharCode((((f & 31) << 6) | (g & 63)));
                }
                else if (f > 223 && f < 240) {
                    if (e + 1 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    g = a[e++];
                    h = a[e++];
                    d += String.fromCharCode((((f & 15) << 12) | ((g & 63) << 6) | (h & 63)));
                }
                else {
                    if (e + 2 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    g = a[e++];
                    h = a[e++];
                    i = a[e++];
                    let j = ((f & 7) << 18) | ((g & 63) << 12) | ((h & 63) << 6) | (i & 63);
                    if (j < 65535) {
                        d += String.fromCharCode(j);
                    }
                    else {
                        j -= 65536;
                        d += String.fromCharCode(((j >> 10) | 55296));
                        d += String.fromCharCode(((j & 1023) | 56320));
                    }
                }
            }
            return d;
        }
        getCharCount1(a, b, c) {
            return c;
        }
        getByteCount(a, b, c) {
            throw new NotImplementedException(0);
        }
        getBytes2(chars_, charIndex_, charCount_, a, b) {
            let inputUTF8_ = (unescape(encodeURIComponent(chars_.slice(charIndex_, charIndex_ + charCount_).join(""))));
            for (let i_ = 0; i_ < inputUTF8_.length; i_++) {
                a[b + i_] = (inputUTF8_.charCodeAt(i_));
            }
            return inputUTF8_.length;
        }
        getBytes(a, b, c) {
            return super.getBytes(a, b, c);
        }
        getBytes1(input_) {
            let a = new Array(input_.length);
            let inputUTF8_ = (unescape(encodeURIComponent(input_)));
            for (let i_ = 0; i_ < inputUTF8_.length; i_++) {
                a[i_] = (inputUTF8_.charCodeAt(i_));
            }
            return a;
        }
        getChars(a, b, c, d, e) {
            let f = e;
            let g = b;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = 0;
            while (g < b + c) {
                h = a[g++];
                if (h < 128) {
                    d[e++] = String.fromCharCode(h);
                }
                else if (h > 191 && h < 224) {
                    if (g >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    i = a[g++];
                    d[e++] = String.fromCharCode((((h & 31) << 6) | (i & 63)));
                }
                else if (h > 223 && h < 240) {
                    if (g + 1 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    i = a[g++];
                    j = a[g++];
                    d[e++] = String.fromCharCode((((h & 15) << 12) | ((i & 63) << 6) | (j & 63)));
                }
                else {
                    if (g + 2 >= b + c) {
                        throw new InvalidOperationException(1, "UTF-8 decoding error.");
                    }
                    i = a[g++];
                    j = a[g++];
                    k = a[g++];
                    let l = ((h & 7) << 18) | ((i & 63) << 12) | ((j & 63) << 6) | (k & 63);
                    if (l < 65535) {
                        d[e++] = String.fromCharCode(l);
                    }
                    else {
                        l -= 65536;
                        d[e++] = String.fromCharCode(((l >> 10) | 55296));
                        d[e++] = String.fromCharCode(((l & 1023) | 56320));
                    }
                }
            }
            return e - f;
        }
        getDecoder() {
            return new UTF8Encoding_UTF8Decoder(this);
        }
        getMaxByteCount(a) {
            return (a + 1) * 3;
        }
        getMaxCharCount(a) {
            return a + 1;
        }
    }
    UTF8Encoding.$t = /*@__PURE__*/ markType(UTF8Encoding, 'UTF8Encoding', Encoding.$);
    return UTF8Encoding;
})();
/**
 * @hidden
 */
let UTF8Encoding_UTF8Decoder = /*@__PURE__*/ (() => {
    class UTF8Encoding_UTF8Decoder extends Decoder {
        constructor(a) {
            super();
            this.g = 0;
            this.h = 0;
            this.i = 0;
            this.j = 0;
            this.k = null;
            this.k = a;
        }
        a(a, b, c) {
            return this.b(a, b, c, false);
        }
        b(a, b, c, d) {
            let e = 0;
            let f = b;
            while (f < b + c) {
                if (this.g == 0) {
                    this.g = a[f++];
                }
                if (this.g < 128) {
                    e++;
                }
                else {
                    if (f >= b + c) {
                        break;
                    }
                    if (this.h == 0) {
                        this.h = a[f++];
                    }
                    if (this.g > 191 && this.g < 224) {
                        e++;
                    }
                    else {
                        if (f >= b + c) {
                            break;
                        }
                        if (this.i == 0) {
                            this.i = a[f++];
                        }
                        if (this.g > 223 && this.g < 240) {
                            e++;
                        }
                        else {
                            if (f >= b + c) {
                                break;
                            }
                            if (this.j == 0) {
                                this.j = a[f++];
                            }
                            let g = ((this.g & 7) << 18) | ((this.h & 63) << 12) | ((this.i & 63) << 6) | (this.j & 63);
                            if (g < 65535) {
                                e++;
                            }
                            else {
                                e += 2;
                            }
                            this.j = 0;
                        }
                        this.i = 0;
                    }
                    this.h = 0;
                }
                this.g = 0;
            }
            if (d) {
                this.g = 0;
                this.h = 0;
                this.i = 0;
                this.j = 0;
            }
            return e;
        }
        c(a, b, c, d, e) {
            return this.d(a, b, c, d, e, false);
        }
        d(a, b, c, d, e, f) {
            let g = e;
            let h = b;
            while (h < b + c) {
                if (this.g == 0) {
                    this.g = a[h++];
                }
                if (this.g < 128) {
                    d[e++] = String.fromCharCode(this.g);
                }
                else {
                    if (h >= b + c) {
                        break;
                    }
                    if (this.h == 0) {
                        this.h = a[h++];
                    }
                    if (this.g > 191 && this.g < 224) {
                        d[e++] = String.fromCharCode((((this.g & 31) << 6) | (this.h & 63)));
                    }
                    else {
                        if (h >= b + c) {
                            break;
                        }
                        if (this.i == 0) {
                            this.i = a[h++];
                        }
                        if (this.g > 223 && this.g < 240) {
                            d[e++] = String.fromCharCode((((this.g & 15) << 12) | ((this.h & 63) << 6) | (this.i & 63)));
                        }
                        else {
                            if (h >= b + c) {
                                break;
                            }
                            if (this.j == 0) {
                                this.j = a[h++];
                            }
                            let i = ((this.g & 7) << 18) | ((this.h & 63) << 12) | ((this.i & 63) << 6) | (this.j & 63);
                            if (i < 65535) {
                                d[e++] = String.fromCharCode(i);
                            }
                            else {
                                i -= 65536;
                                d[e++] = String.fromCharCode(((i >> 10) | 55296));
                                d[e++] = String.fromCharCode(((i & 1023) | 56320));
                            }
                            this.j = 0;
                        }
                        this.i = 0;
                    }
                    this.h = 0;
                }
                this.g = 0;
            }
            if (f) {
                this.g = 0;
                this.h = 0;
                this.i = 0;
                this.j = 0;
            }
            return e - g;
        }
    }
    UTF8Encoding_UTF8Decoder.$t = /*@__PURE__*/ markType(UTF8Encoding_UTF8Decoder, 'UTF8Encoding_UTF8Decoder', Decoder.$);
    return UTF8Encoding_UTF8Decoder;
})();
/**
 * @hidden
 */
let AsciiEncoding = /*@__PURE__*/ (() => {
    class AsciiEncoding extends Encoding {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                    }
                    break;
                case 1: break;
            }
        }
        getString1(bytes_, a, b) {
            let ret_ = "";
            for (let i_ = a; i_ < a + b; i_++) {
                if (bytes_[i_] == 0) {
                    break;
                }
                ret_ = ret_ + String.fromCharCode(bytes_[i_]);
            }
            return ret_;
        }
        getCharCount1(a, b, c) {
            return c;
        }
        getByteCount(a, b, c) {
            return c;
        }
        getBytes2(a, b, c, d, e) {
            throw new NotImplementedException(0);
        }
        getBytes(a, b, c) {
            return super.getBytes(a, b, c);
        }
        getBytes1(input_) {
            let a = new Array(input_.length);
            for (let i_ = 0; i_ < input_.length; i_++) {
                a[i_] = (input_.charCodeAt(i_));
            }
            return a;
        }
        getChars(bytes_, byteIndex_, a, b, c) {
            let d = c;
            for (let i_ = 0; i_ < a; i_++) {
                if (bytes_[i_] == 0) {
                    break;
                }
                b[c++] = (String.fromCharCode(bytes_[byteIndex_++]));
            }
            return c - d;
        }
    }
    AsciiEncoding.$t = /*@__PURE__*/ markType(AsciiEncoding, 'AsciiEncoding', Encoding.$);
    return AsciiEncoding;
})();
/**
 * @hidden
 */
let DefaultDecoder = /*@__PURE__*/ (() => {
    class DefaultDecoder extends Decoder {
        constructor(a) {
            super();
            this.g = null;
            this.g = a;
        }
        a(a, b, c) {
            return this.b(a, b, c, false);
        }
        b(a, b, c, d) {
            return this.g.getCharCount1(a, b, c);
        }
        c(a, b, c, d, e) {
            return this.d(a, b, c, d, e, false);
        }
        d(a, b, c, d, e, f) {
            return this.g.getChars(a, b, c, d, e);
        }
    }
    DefaultDecoder.$t = /*@__PURE__*/ markType(DefaultDecoder, 'DefaultDecoder', Decoder.$);
    return DefaultDecoder;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of item represented by the current row of a shapefile.
 */
var ShapeType = /*@__PURE__*/ (function (ShapeType) {
    /**
     * A placeholder value which cannot occur when reading a shapefile.
     */
    ShapeType[ShapeType["None"] = 0] = "None";
    /**
     * Specifies a point shape.
     */
    ShapeType[ShapeType["Point"] = 1] = "Point";
    /**
     * Specifies a polyline shape.
     */
    ShapeType[ShapeType["PolyLine"] = 3] = "PolyLine";
    /**
     * Specifies a polygon shape.
     */
    ShapeType[ShapeType["Polygon"] = 5] = "Polygon";
    /**
     * Specifies a polypoint shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPoint"] = 8] = "PolyPoint";
    /**
     * Specifies a polypoint shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PointZ"] = 11] = "PointZ";
    /**
     * Specifies a polylinez shape
     */
    ShapeType[ShapeType["PolyLineZ"] = 13] = "PolyLineZ";
    /**
     * Specifies a polygonz shape
     */
    ShapeType[ShapeType["PolygonZ"] = 15] = "PolygonZ";
    /**
     * Specifies a polypointz shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPointZ"] = 18] = "PolyPointZ";
    /**
     * Specifies a pointm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PointM"] = 21] = "PointM";
    /**
     * Specifies a polylinem shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyLineM"] = 23] = "PolyLineM";
    /**
     * Specifies a polygonm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolygonM"] = 25] = "PolygonM";
    /**
     * Specifies a polypointm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPointM"] = 28] = "PolyPointM";
    /**
     * Specifies a polypatchm shape (not supported; cannot occur when reading a shapefile)
     */
    ShapeType[ShapeType["PolyPatch"] = 31] = "PolyPatch";
    return ShapeType;
})({});
/**
 * @hidden
 */
let ShapeType_$type = /*@__PURE__*/ markEnum('ShapeType', 'None,0|Point,1|PolyLine,3|Polygon,5|PolyPoint,8|PointZ,11|PolyLineZ,13|PolygonZ,15|PolyPointZ,18|PointM,21|PolyLineM,23|PolygonM,25|PolyPointM,28|PolyPatch,31');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeFileUtil = /*@__PURE__*/ (() => {
    class ShapeFileUtil extends Base {
        static a(a, b) {
            if (ShapeFileUtil.j == null) {
                ShapeFileUtil.m();
            }
            let c = new Header();
            let d = ShapeFileUtil.k(a.readInt32());
            if (d != 9994) {
                throw new BaseError(1, "Corrupt Shp file - incorrect file code");
            }
            a.readInt32();
            a.readInt32();
            a.readInt32();
            a.readInt32();
            a.readInt32();
            ShapeFileUtil.k(a.readInt32());
            a.readInt32();
            c.a = a.readInt32();
            let e = PointUtil.create();
            let f = PointUtil.create();
            e.x = a.readDouble();
            e.y = a.readDouble();
            f.x = a.readDouble();
            f.y = a.readDouble();
            a.readDouble();
            a.readDouble();
            a.readDouble();
            a.readDouble();
            c.e = new Rect(0, e.x, e.y, f.x - e.x, f.y - e.y);
            if (b != null) {
                let g = b.readByte();
                if (g != 3) {
                    throw new BaseError(1, "Corrupt Dbf file - wrong version number");
                }
                b.readByte();
                b.readByte();
                b.readByte();
                b.readUInt32();
                b.readUInt16();
                let h = b.readUInt16();
                b.readBytes(2);
                b.readBytes(1);
                b.readBytes(1);
                b.readBytes(4);
                b.readBytes(8);
                b.readBytes(1);
                b.readBytes(1);
                b.readBytes(2);
                let i = 0;
                while (i < h - 1) {
                    let j = new XBaseField();
                    j.c = stringReplace(Encoding.uTF8.getString1(b.readBytes(11), 0, 10), "\0", "");
                    let k = Encoding.uTF8.getString1(b.readBytes(1), 0, 1).charAt(0);
                    j.a = ShapeFileUtil.j.item(k);
                    b.readBytes(4);
                    j.b = b.readByte();
                    b.readBytes(15);
                    c.b.add(j);
                    i += j.b;
                }
                if (b.readByte() != 13) {
                    throw new BaseError(1, "Corrupt Dbf file - Missing field descriptor array terminator");
                }
            }
            return c;
        }
        static e(a, b, c) {
            let d = ShapeFileUtil.k(b.readInt32());
            let e = ShapeFileUtil.k(b.readInt32());
            let f = b.readInt32();
            let g = null;
            switch (f) {
                case 0: break;
                case 1:
                    g = ShapeFileUtil.i(b);
                    break;
                case 3:
                    g = ShapeFileUtil.b(b);
                    break;
                case 5:
                    g = ShapeFileUtil.f(b);
                    break;
                case 8: break;
                case 11: break;
                case 13:
                    g = ShapeFileUtil.d(b);
                    break;
                case 15:
                    g = ShapeFileUtil.h(b);
                    break;
                case 18: break;
                case 21: break;
                case 23: break;
                case 25: break;
                case 28: break;
                case 31: break;
                default: break;
            }
            if (g == null) {
                throw new BaseError(1, "Corrupt Shp file - failed to read " + EnumUtil.getName(ShapeType_$type, f));
            }
            g.shapeType = f;
            if (c != null) {
                c.readBytes(1);
                g.fields = new Dictionary$2(String_$type, Base.$, 0);
                for (let h of fromEnum(a.b)) {
                    g.fieldsNames.add(h.c);
                    let i = c.readBytes(h.b);
                    let j = Encoding.uTF8.getString1(i, 0, h.b);
                    switch (h.a) {
                        case 1:
                            g.fieldsTypes.add("double");
                            let k = parseFloat(j);
                            if (!isNaN_(k)) {
                                g.fields.addItem(h.c, k);
                                ShapeFileUtil.l(g, h.c, k);
                            }
                            break;
                        case 5:
                            g.fieldsTypes.add("float");
                            let l = parseFloat(j);
                            if (!isNaN_(l)) {
                                g.fields.addItem(h.c, l);
                                ShapeFileUtil.l(g, h.c, l);
                            }
                            break;
                        case 0:
                            g.fieldsTypes.add("string");
                            let m = j.trim();
                            g.fields.addItem(h.c, m);
                            ShapeFileUtil.l(g, h.c, m);
                            break;
                        case 3:
                            g.fieldsTypes.add("date");
                            let str_ = j;
                            let n = Date.parse(str_);
                            g.fields.addItem(h.c, n);
                            ShapeFileUtil.l(g, h.c, n);
                            break;
                        default: throw new BaseError(1, "Unrecognized field type: " + enumGetBox(XBaseDataType_$type, h.a));
                    }
                }
            }
            return g;
        }
        static l(row_, property_, val_) {
            if (!row_.fieldValues) {
                row_.fieldValues = {};
            }
            ;
            row_.fieldValues[property_] = val_;
        }
        static k(a) {
            return (((a & 255) << 24) | ((a & 65280) << 8) | ((a & 16711680) >> 8) | ((u32BitwiseAnd(a, 4278190080)) >> 24));
        }
        static i(a) {
            let b = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            return ((() => {
                let $ret = new ShapefileRecord();
                $ret.bounds = new Rect(3, b, Size.empty);
                $ret.points = new List$1(List$1.$.specialize(Point_$type), 1, [new List$1(Point_$type, 1, [b])]);
                return $ret;
            })());
        }
        static d(a) {
            let b, c;
            let d = ((() => { let e = ShapeFileUtil.c(a, b, c); b = e.p1; c = e.p2; return e.ret; })());
            a.readDouble();
            a.readDouble();
            for (let e = 0; e < c; e++) {
                a.readDouble();
            }
            a.readDouble();
            a.readDouble();
            for (let f = 0; f < c; f++) {
                a.readDouble();
            }
            return d;
        }
        static c(a, b, c) {
            let d = PointUtil.create();
            let e = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let f = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let g = new Rect(0, e.x, e.y, f.x - e.x, f.y - e.y);
            b = a.readInt32();
            c = a.readInt32();
            let h = new Array(b);
            for (let i = 0; i < b; ++i) {
                h[i] = a.readInt32();
            }
            let j = new List$1(List$1.$.specialize(Point_$type), 0);
            for (let k = 0; k < b; ++k) {
                let l = (k < b - 1 ? h[k + 1] : c) - h[k];
                let m = new List$1(Point_$type, 2, l - 1);
                for (let n = 0; n < l; ++n) {
                    d = PointUtil.create();
                    d.x = a.readDouble();
                    d.y = a.readDouble();
                    m.add(d);
                }
                if (m.count > 0) {
                    j.add(m);
                }
            }
            return {
                ret: ((() => {
                    let $ret = new ShapefileRecord();
                    $ret.bounds = g;
                    $ret.points = j;
                    return $ret;
                })()),
                p1: b,
                p2: c
            };
        }
        static b(a) {
            let b, c;
            return ((() => { let d = ShapeFileUtil.c(a, b, c); b = d.p1; c = d.p2; return d.ret; })());
        }
        static h(a) {
            let b, c;
            let d = ((() => { let e = ShapeFileUtil.g(a, b, c); b = e.p1; c = e.p2; return e.ret; })());
            a.readDouble();
            a.readDouble();
            for (let e = 0; e < c; e++) {
                a.readDouble();
            }
            a.readDouble();
            a.readDouble();
            for (let f = 0; f < c; f++) {
                a.readDouble();
            }
            return d;
        }
        static f(a) {
            let b, c;
            return ((() => { let d = ShapeFileUtil.g(a, b, c); b = d.p1; c = d.p2; return d.ret; })());
        }
        static g(a, b, c) {
            let d = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let e = ((() => {
                let $ret = PointUtil.create();
                $ret.x = a.readDouble();
                $ret.y = a.readDouble();
                return $ret;
            })());
            let f = new Rect(0, d.x, d.y, e.x - d.x, e.y - d.y);
            let g = PointUtil.create();
            b = a.readInt32();
            c = a.readInt32();
            let h = new Array(b);
            for (let i = 0; i < b; ++i) {
                h[i] = a.readInt32();
            }
            let j = new List$1(List$1.$.specialize(Point_$type), 0);
            for (let k = 0; k < b; ++k) {
                let l = (k < b - 1 ? h[k + 1] : c) - h[k];
                let m = new List$1(Point_$type, 2, l);
                g = PointUtil.create();
                g.x = a.readDouble();
                g.y = a.readDouble();
                for (let n = 1; n < l; ++n) {
                    g = PointUtil.create();
                    g.x = a.readDouble();
                    g.y = a.readDouble();
                    m.add(g);
                }
                if (m.count > 1) {
                    j.add(m);
                }
            }
            return {
                ret: ((() => {
                    let $ret = new ShapefileRecord();
                    $ret.bounds = f;
                    $ret.points = j;
                    return $ret;
                })()),
                p1: b,
                p2: c
            };
        }
        static m() {
            ShapeFileUtil.j = new Dictionary$2(String_$type, XBaseDataType_$type, 0);
            ShapeFileUtil.j.item('C', 0);
            ShapeFileUtil.j.item('N', 1);
            ShapeFileUtil.j.item('L', 2);
            ShapeFileUtil.j.item('D', 3);
            ShapeFileUtil.j.item('M', 4);
            ShapeFileUtil.j.item('F', 5);
            ShapeFileUtil.j.item('B', 6);
            ShapeFileUtil.j.item('G', 7);
            ShapeFileUtil.j.item('P', 8);
            ShapeFileUtil.j.item('Y', 9);
            ShapeFileUtil.j.item('T', 10);
            ShapeFileUtil.j.item('I', 11);
            ShapeFileUtil.j.item('V', 12);
            ShapeFileUtil.j.item('X', 13);
            ShapeFileUtil.j.item('@', 14);
            ShapeFileUtil.j.item('O', 15);
            ShapeFileUtil.j.item('+', 16);
        }
        static staticInit() {
            ShapeFileUtil.m();
        }
    }
    ShapeFileUtil.$t = /*@__PURE__*/ markType(ShapeFileUtil, 'ShapeFileUtil');
    ShapeFileUtil.j = null;
    return ShapeFileUtil;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapefileConverter = /*@__PURE__*/ (() => {
    class ShapefileConverter extends DependencyObjectNotifier {
        constructor() {
            super();
            this._name = null;
            this.a8 = null;
            this.a7 = Rect.empty;
            this._shapeHeader = null;
            this.q = false;
            this.importPending = null;
            this.importCompleted = null;
            this.x = null;
            this.collectionChanged = null;
            this.filter = null;
            this.records = new ObservableCollection$1(ShapefileRecord.$, 0);
            let a = this.records;
            a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => {
                if (this.collectionChanged != null) {
                    this.collectionChanged(this, b);
                }
            });
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        get worldRect() {
            return this.a8;
        }
        set worldRect(a) {
            if (Rect.l_op_Inequality(this.a8, a)) {
                let b = this.a8;
                this.a8 = a;
                this.aw("WorldRect", b, this.a8);
            }
        }
        get computedWorldRect() {
            return this.a7;
        }
        set computedWorldRect(a) {
            if (Rect.l_op_Inequality(this.a7, a)) {
                let b = this.a7;
                this.a7 = a;
                this.aw("ComputedWorldRect", b, this.a7);
            }
        }
        getWorldBounds(a) {
            if (a && this.computedWorldRect.isEmpty == false) {
                return this.computedWorldRect;
            }
            return this.worldRect;
        }
        setWorldBounds(a, b) {
            if (a) {
                this.computedWorldRect = b;
            }
            else {
                this.worldRect = b;
            }
        }
        get shapeType() {
            return this.shapeHeader.a;
        }
        get shapeHeader() {
            return this._shapeHeader;
        }
        set shapeHeader(a) {
            this._shapeHeader = a;
        }
        aw(a, b, c) {
            switch (a) {
                case ShapefileConverter.$$p[2]:
                case ShapefileConverter.$$p[0]:
                    if (this.shapefileSource != null && this.databaseSource != null) {
                        this.at();
                    }
                    break;
            }
            this.j(a);
        }
        sendImportCompleted() {
            if (this.deferImportCompleted && this.q) {
                this.deferImportCompleted = false;
                if (this.importCompleted != null) {
                    this.importCompleted(this, new AsyncCompletedEventArgs(null, false, null));
                }
            }
        }
        au(a) {
            this.q = true;
            if (this.deferImportCompleted) {
                if (this.importPending != null) {
                    this.importPending(this, a);
                }
                return;
            }
            if (this.importCompleted != null) {
                this.importCompleted(this, a);
            }
        }
        at() {
            this.q = false;
            let a = null;
            let b = null;
            let c = () => {
                if (a != null && b != null) {
                    this.av(a, b);
                    this.au(new AsyncCompletedEventArgs(null, false, null));
                }
            };
            BinaryFileDownloader.a(this.shapefileSource, (d) => {
                a = new BinaryReader(0, d, false);
                c();
            }, (d) => {
                throw new BaseError(1, "shape file download error: " + d);
            });
            BinaryFileDownloader.a(this.databaseSource, (d) => {
                b = new BinaryReader(0, d, false);
                c();
            }, (d) => {
                throw new BaseError(1, "dbf file download error: " + d);
            });
        }
        av(a, b) {
            this.shapeHeader = ShapeFileUtil.a(a, b);
            this.worldRect = this.shapeHeader.e;
            let c = a.currentPosition;
            let d = a.length;
            let e = Rect.empty;
            while (c < d) {
                let f = ShapeFileUtil.e(this.shapeHeader, a, b);
                let record_ = f;
                let g = true;
                if (this.filter != null) {
                    let h = new ShapeFilterRecordEventArgs();
                    h.b = true;
                    h.a = f;
                    this.filter(this, h);
                    if (!h.b) {
                        g = false;
                    }
                }
                if (g) {
                    this.records.add(f);
                    if (e.isEmpty) {
                        e = f.bounds;
                    }
                    else {
                        e.union(f.bounds);
                    }
                }
                c = a.currentPosition;
                d = a.length;
            }
            this.computedWorldRect = e.isEmpty ? this.worldRect : e;
        }
        get records() {
            return this.x;
        }
        set records(a) {
            this.x = a;
        }
        indexOf(a) {
            return this.x.indexOf(a);
        }
        insert(a, b) {
            this.x.insert(a, b);
        }
        removeAt(a) {
            this.x.removeAt(a);
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.x.item(a, b);
                return b;
            }
            else {
                return this.x._inner[a];
            }
        }
        add(a) {
            this.x.add(a);
        }
        clear() {
            this.x.clear();
        }
        contains(a) {
            return this.x.contains(a);
        }
        copyTo(a, b) {
            this.x.copyTo(a, b);
        }
        get count() {
            return this.x.count;
        }
        get isReadOnly() {
            return this.x.isReadOnly;
        }
        remove(a) {
            return this.x.remove(a);
        }
        getEnumerator() {
            return this.x.getEnumerator();
        }
        getEnumeratorObject() {
            return this.x.getEnumerator();
        }
        getPointData() {
            return new List$1(ShapefileRecord.$, 1, this.records);
        }
        getRecordsCount() {
            if (this.records == null) {
                return 0;
            }
            return this.records.count;
        }
        getRecord(a) {
            return this.records._inner[a];
        }
        getRecordBounds(a) {
            if (this.records == null) {
                return Rect.empty;
            }
            if (a < 0 || a > this.records.count - 1) {
                return Rect.empty;
            }
            return this.records._inner[a].bounds;
        }
        getRecordFieldNames(a) {
            if (this.records == null) {
                return null;
            }
            if (a < 0 || a > this.records.count - 1) {
                return null;
            }
            let b = this.records._inner[a];
            if (b == null || b.fieldsNames == null) {
                return null;
            }
            return b.fieldsNames.toArray();
        }
        getRecordValue(a, b) {
            if (this.records == null) {
                return null;
            }
            if (a < 0 || a > this.records.count - 1) {
                return null;
            }
            let c = this.records._inner[a];
            if (c == null || c.fieldsNames == null) {
                return null;
            }
            return c.getFieldValue(b);
        }
        removeRecord(a) {
            if (this.records == null) {
                return;
            }
            if (a < 0 || a > this.records.count - 1) {
                return;
            }
            this.records.removeAt(a);
        }
        shiftAllShapes(a, b) {
            if (this.records == null) {
                return;
            }
            for (let c = 0; c < this.records.count; c++) {
                this.shiftShapes(c, a, b);
            }
        }
        shiftShapes(a, b, c) {
            if (this.records == null) {
                return;
            }
            if (a < 0 || a > this.records.count - 1) {
                return;
            }
            let d = new List$1(List$1.$.specialize(Point_$type), 0);
            let e = this.records._inner[a].points;
            for (let f of fromEnum(e)) {
                let g = ShapefileConverter.w(f, b, c);
                for (let h of fromEnum(g)) {
                    d.add(h);
                }
            }
            this.records._inner[a].points = d;
        }
        static ai(a, b) {
            return ShapefileConverter.ag(a, b, -180, 180);
        }
        static ah(a, b) {
            return ShapefileConverter.ag(a, b, -85.05112878, 85.05112878);
        }
        static ag(a, b, c, d) {
            let e = a;
            if (isNaN_(b) || b == 0) {
                return e;
            }
            if (e + b < c) {
                e += 2 * d;
                e += b;
            }
            else if (e + b > d) {
                e -= 2 * d;
                e += b;
            }
            else {
                e += b;
            }
            return e;
        }
        static isValidGeoPoint(a) {
            if (a.x < -180 || a.x > 180) {
                return false;
            }
            if (a.y < -90 || a.y > 90) {
                return false;
            }
            return true;
        }
        static isValidGeoShape(a) {
            if (a.count < 3) {
                return false;
            }
            for (let b of fromEnum(a)) {
                if (!ShapefileConverter.isValidGeoPoint(b)) {
                    return false;
                }
            }
            return true;
        }
        static w(a, b, c, d = "") {
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new List$1(Point_$type, 0);
            for (let h of fromEnum(a)) {
                let i = ShapefileConverter.ag(h.x, b, -180, 180);
                let j = ShapefileConverter.ag(h.y, c, -85.05112878, 85.05112878);
                e = Math.min(e, i);
                f = Math.max(f, i);
                g.add({ $type: Point_$type, x: i, y: j });
            }
            let k = new List$1(List$1.$.specialize(Point_$type), 0);
            let l = ShapefileConverter.ba(g);
            let m = l.width;
            if (l.left >= -180 && l.right <= 180 && l.width > 180) {
                let n = new List$1(Point_$type, 0);
                let o = new List$1(Point_$type, 0);
                for (let p of fromEnum(g)) {
                    if (p.x >= -180 && p.x < 0) {
                        n.add(p);
                    }
                    else {
                        o.add(p);
                    }
                }
                let q = ShapefileConverter.ba(n);
                let r = q.width;
                let s = ShapefileConverter.ba(o);
                let t = s.width;
                if (ShapefileConverter.isValidGeoShape(n)) {
                    k.add(n);
                }
                if (ShapefileConverter.isValidGeoShape(o)) {
                    k.add(o);
                }
            }
            else {
                if (ShapefileConverter.isValidGeoShape(g)) {
                    k.add(g);
                }
            }
            return k;
        }
        getMaxLongitude(a, b, c, d) {
            if (this.records == null) {
                return NaN;
            }
            if (a < 0 || a > this.records.count - 1) {
                return NaN;
            }
            let e = this.records._inner[a].points;
            let f = c;
            if (b) {
                let g = ShapefileConverter.v(e);
                for (let h of fromEnum(g)) {
                    if (h.x < d) {
                        f = Math.max(f, h.x);
                    }
                }
            }
            else {
                for (let i of fromEnum(e)) {
                    for (let j of fromEnum(i)) {
                        if (j.x < d) {
                            f = Math.max(f, j.x);
                        }
                    }
                }
            }
            return f;
        }
        setRecordValue(a, b, c) {
            if (this.records == null) {
                return;
            }
            if (a < 0 || a > this.records.count - 1) {
                return;
            }
            let d = this.records._inner[a];
            if (d == null || d.fieldsNames == null) {
                return;
            }
            d.setFieldValue(b, c);
        }
        getRecordValues(a) {
            if (this.records == null) {
                return null;
            }
            let b = new Array(this.records.count);
            for (let c = 0; c < this.records.count; c++) {
                let d = this.getRecordValue(c, a);
                b[c] = d;
            }
            return b;
        }
        setRecordValues(a, b) {
            if (this.records == null) {
                return;
            }
            let c = Math.min(b.length, this.records.count);
            for (let d = 0; d < c; d++) {
                this.setRecordValue(d, a, b[d]);
            }
        }
        static ba(a) {
            let b = Number.POSITIVE_INFINITY;
            let c = Number.POSITIVE_INFINITY;
            let d = Number.NEGATIVE_INFINITY;
            let e = Number.NEGATIVE_INFINITY;
            for (let f = 0; f < a.count; f++) {
                let g = a._inner[f];
                b = Math.min(b, g.x);
                c = Math.min(c, g.y);
                d = Math.max(d, g.x);
                e = Math.max(e, g.y);
            }
            if (isInfinity(b) || isInfinity(c) || isInfinity(c) || isInfinity(e)) {
                return Rect.empty;
            }
            return new Rect(0, b, c, d - b, e - c);
        }
        getLargestShapeBoundsForRecord(a) {
            if (this.records == null) {
                return Rect.empty;
            }
            if (a < 0 || a > this.records.count - 1) {
                return Rect.empty;
            }
            let b = this.records._inner[a];
            if (b == null || b.fieldsNames == null) {
                return Rect.empty;
            }
            let c = ShapefileConverter.v(b.points);
            return ShapefileConverter.ba(c);
        }
        static v(a) {
            let b = new List$1(Point_$type, 0);
            let c = -1.7976931348623157E+308;
            for (let d of fromEnum(a)) {
                let e = 1.7976931348623157E+308;
                let f = -1.7976931348623157E+308;
                let g = 1.7976931348623157E+308;
                let h = -1.7976931348623157E+308;
                for (let i of fromEnum(d)) {
                    g = Math.min(g, i.y);
                    h = Math.max(h, i.y);
                    e = Math.min(e, i.x);
                    f = Math.max(f, i.x);
                }
                let j = f - e;
                let k = h - g;
                let l = new Rect(0, e, g, j, k);
                let m = l.width * l.height;
                if (m > c) {
                    c = m;
                    b = d;
                }
            }
            return b;
        }
    }
    ShapefileConverter.$t = /*@__PURE__*/ markType(ShapefileConverter, 'ShapefileConverter', DependencyObjectNotifier.$, [/*@__PURE__*/ IList$1_$type.specialize(ShapefileRecord.$), INotifyCollectionChanged_$type]);
    ShapefileConverter.minLatitude = -85.05112878;
    ShapefileConverter.maxLatitude = 85.05112878;
    ShapefileConverter.minLongitude = -180;
    ShapefileConverter.maxLongitude = 180;
    ShapefileConverter.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ShapefileConverter, 'aw', ['DatabaseSource', [2, null], 'DeferImportCompleted', [0, false], 'ShapefileSource', [2, null]]);
    return ShapefileConverter;
})();

/**
 * Represents a record of data from a Shapefile (.shp and .dbf).
*/
class IgrShapefileRecord {
    createImplementation() {
        return new ShapefileRecord();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the shape type, as read from the header of the Shapefile.
    */
    get shapeType() {
        return this.i.shapeType;
    }
    /**
     * Gets an array of field names and values for this record
    */
    get fieldsNames() {
        return this.i.fieldsNames._inner;
    }
    /**
     * Gets an arry of field types and values for this record
    */
    get fieldsTypes() {
        return this.i.fieldsTypes._inner;
    }
    /**
     * Gets an array of arrays of points for this record
    */
    get points() {
        var ret = [];
        var list = this.i.points;
        for (var i = 0; i < list.count; i++) {
            var innerlist = list.item(i);
            ret.push(list.item(i)._inner);
        }
        return ret;
    }
    get fieldValues() {
        return this.i.fieldValues;
    }
    set fieldValues(v) {
        this.i.fieldValues = v;
    }
    /**
     * Gets the bounds for the shapes
    */
    get bounds() {
        return fromRect(this.i.bounds);
    }
    set bounds(v) {
        this.i.bounds = toRect(v);
    }
    findByName(name) {
        return null;
    }
    getFieldValue(fieldName) {
        let iv = this.i.getFieldValue(fieldName);
        return (iv);
    }
    setFieldValue(fieldName, value) {
        this.i.setFieldValue(fieldName, value);
    }
}

class IgrShapeFilterRecordEventArgs {
    createImplementation() {
        return new ShapeFilterRecordEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get record() {
        if (this.i.a == null) {
            return null;
        }
        if (!this.i.a.externalObject) {
            let e = new IgrShapefileRecord();
            e._implementation = this.i.a;
            this.i.a.externalObject = e;
        }
        return this.i.a.externalObject;
    }
    set record(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get shouldInclude() {
        return this.i.b;
    }
    set shouldInclude(v) {
        this.i.b = ensureBool(v);
    }
}

/**
 * Class used to convert Shapefiles into CLR objects.
*/
class IgrShapeDataSource {
    constructor() {
        //@@ZoneRunner
        this._importPending = null;
        this._importPending_wrapped = null;
        this._importCompleted = null;
        this._importCompleted_wrapped = null;
        this._filter = null;
        this._filter_wrapped = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new ShapefileConverter();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    //   private _databaseSource: string;
    ///**
    // * Gets the string Uri path of the .dbf portion of the Shapefile
    //*/
    //   get databaseSource(): string {
    //       return this._databaseSource;
    //   }
    ///**
    // * Sets the string Uri path of the .dbf portion of the Shapefile
    //*/
    //   set databaseSource(v: string) {
    //       this._databaseSource = v;
    //   }
    //   private _shapefileSource: string;
    ///**
    // * Gets the string Uri path of the .shp portion of the Shapefile
    //*/
    //   get shapefileSource(): string {
    //       return this._shapefileSource;
    //   }
    ///**
    // * Sets the string Uri path of the .shp portion of the Shapefile
    //*/
    //   set shapefileSource(v: string) {
    //       this._shapefileSource = v;
    //   }
    dataBind() {
        //this.i.shapefileSource = null;
        //this.i.databaseSource = null;
        //if (this._shapefileSource && this._databaseSource) {
        //    this.i.shapefileSource = new Uri(0, this._shapefileSource);
        //    this.i.databaseSource = new Uri(0, this._databaseSource);
        //}
    }
    /**
    * Gets the point data.
    */
    getPointData() {
        let list = this.i.getPointData();
        let ret = [];
        for (var i = 0; i < list.count; i++) {
            var shapeRecord = list.item(i);
            if (!shapeRecord.externalObject) {
                let e = new IgrShapefileRecord();
                e._implementation = shapeRecord;
                shapeRecord.externalObject = e;
            }
            ret.push(shapeRecord.externalObject);
        }
        return ret;
    }
    get name() {
        return this.i.name;
    }
    set name(v) {
        this.i.name = v;
    }
    /**
     * Gets the world bounding rectangle, as read from the header of the Shapefile.
    */
    get worldRect() {
        return fromRect(this.i.worldRect);
    }
    set worldRect(v) {
        this.i.worldRect = toRect(v);
    }
    /**
     * Gets the world bounding rectangle, based on the filtered shapes
    */
    get computedWorldRect() {
        return fromRect(this.i.computedWorldRect);
    }
    set computedWorldRect(v) {
        this.i.computedWorldRect = toRect(v);
    }
    /**
     * Gets the shape type, as read from the header of the Shapefile.
    */
    get shapeType() {
        return this.i.shapeType;
    }
    /**
     * Gets the header of the Shapefile.
    */
    get shapeHeader() {
        return this.i.shapeHeader;
    }
    set shapeHeader(v) {
        this.i.shapeHeader = v;
    }
    /**
     * The Uri of the .shp portion of the Shapefile.
    */
    get deferImportCompleted() {
        return this.i.deferImportCompleted;
    }
    set deferImportCompleted(v) {
        this.i.deferImportCompleted = ensureBool(v);
    }
    /**
     * The Uri of the .shp portion of the Shapefile.
    */
    get shapefileSource() {
        return this.i.shapefileSource;
    }
    set shapefileSource(v) {
        this.i.shapefileSource = v;
    }
    /**
     * The Uri of the .dbf portion of the Shapefile.
    */
    get databaseSource() {
        return this.i.databaseSource;
    }
    set databaseSource(v) {
        this.i.databaseSource = v;
    }
    /**
     * The total number of ShapefileRecords in the collection.
    */
    get count() {
        return this.i.count;
    }
    findByName(name) {
        return null;
    }
    getWorldBounds(useComputed) {
        let iv = this.i.getWorldBounds(useComputed);
        return fromRect(iv);
    }
    setWorldBounds(setComputed, bounds) {
        this.i.setWorldBounds(setComputed, toRect(bounds));
    }
    sendImportCompleted() {
        this.i.sendImportCompleted();
    }
    getRecordsCount() {
        let iv = this.i.getRecordsCount();
        return (iv);
    }
    getRecord(index) {
        let iv = this.i.getRecord(index);
        return (iv == null ? null : iv.externalObject);
    }
    getRecordBounds(index) {
        let iv = this.i.getRecordBounds(index);
        return fromRect(iv);
    }
    getRecordFieldNames(index) {
        let iv = this.i.getRecordFieldNames(index);
        return (iv);
    }
    getRecordValue(index, fieldName) {
        let iv = this.i.getRecordValue(index, fieldName);
        return (iv);
    }
    removeRecord(index) {
        this.i.removeRecord(index);
    }
    shiftAllShapes(offsetX, offsetY) {
        this.i.shiftAllShapes(offsetX, offsetY);
    }
    shiftShapes(recordIndex, offsetX, offsetY) {
        this.i.shiftShapes(recordIndex, offsetX, offsetY);
    }
    getMaxLongitude(recordIndex, useLargestShape, fromLongitude, toLongitude) {
        let iv = this.i.getMaxLongitude(recordIndex, useLargestShape, fromLongitude, toLongitude);
        return (iv);
    }
    setRecordValue(index, fieldName, value) {
        this.i.setRecordValue(index, fieldName, value);
    }
    getRecordValues(fieldName) {
        let iv = this.i.getRecordValues(fieldName);
        return (iv);
    }
    setRecordValues(fieldName, values) {
        this.i.setRecordValues(fieldName, values);
    }
    getLargestShapeBoundsForRecord(index) {
        let iv = this.i.getLargestShapeBoundsForRecord(index);
        return fromRect(iv);
    }
    /**
     * Event raised when the Shapefile has been imported from both the ShapefileSource and DatabaseSource Uris.
    */
    get importPending() {
        return this._importPending;
    }
    set importPending(ev) {
        if (this._importPending_wrapped !== null) {
            this.i.importPending = delegateRemove(this.i.importPending, this._importPending_wrapped);
            this._importPending_wrapped = null;
            this._importPending = null;
        }
        this._importPending = ev;
        this._importPending_wrapped = (o, e) => {
            let outerArgs = new IgrAsyncCompletedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeImportPending) {
                this.beforeImportPending(this, outerArgs);
            }
            if (this._importPending) {
                this._importPending(this, outerArgs);
            }
        };
        this.i.importPending = delegateCombine(this.i.importPending, this._importPending_wrapped);
    }
    /**
     * Event raised when the Shapefile has been imported from both the ShapefileSource and DatabaseSource Uris.
    */
    get importCompleted() {
        return this._importCompleted;
    }
    set importCompleted(ev) {
        if (this._importCompleted_wrapped !== null) {
            this.i.importCompleted = delegateRemove(this.i.importCompleted, this._importCompleted_wrapped);
            this._importCompleted_wrapped = null;
            this._importCompleted = null;
        }
        this._importCompleted = ev;
        this._importCompleted_wrapped = (o, e) => {
            let outerArgs = new IgrAsyncCompletedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeImportCompleted) {
                this.beforeImportCompleted(this, outerArgs);
            }
            if (this._importCompleted) {
                this._importCompleted(this, outerArgs);
            }
        };
        this.i.importCompleted = delegateCombine(this.i.importCompleted, this._importCompleted_wrapped);
    }
    get filter() {
        return this._filter;
    }
    set filter(ev) {
        if (this._filter_wrapped !== null) {
            this.i.filter = delegateRemove(this.i.filter, this._filter_wrapped);
            this._filter_wrapped = null;
            this._filter = null;
        }
        this._filter = ev;
        this._filter_wrapped = (o, e) => {
            let outerArgs = new IgrShapeFilterRecordEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeFilter) {
                this.beforeFilter(this, outerArgs);
            }
            if (this._filter) {
                this._filter(this, outerArgs);
            }
        };
        this.i.filter = delegateCombine(this.i.filter, this._filter_wrapped);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITileGenerator_$type = /*@__PURE__*/ new Type(null, 'ITileGenerator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScalerVisibleBounds = /*@__PURE__*/ (() => {
    class ScalerVisibleBounds extends Base {
        constructor(a, b, c, d) {
            super();
            this.d = 0;
            this.a = 0;
            this.c = 0;
            this.b = 0;
            this.b = a;
            this.d = b;
            this.c = c;
            this.a = d;
        }
    }
    ScalerVisibleBounds.$t = /*@__PURE__*/ markType(ScalerVisibleBounds, 'ScalerVisibleBounds');
    return ScalerVisibleBounds;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileScaler = /*@__PURE__*/ (() => {
    class HeatTileScaler extends Base {
        constructor() {
            super();
            this.b = 0;
            this.c = 0;
            this.d = 0;
            this.e = 0;
            this.b = 85.05112878 - -85.05112878;
            this.c = 180 - -180;
            this.d = this.k(85.05112878);
            this.e = this.k(85.05112878) - this.k(-85.05112878);
        }
        k(a) {
            let b = a * (0.017453292519943295);
            let c = Math.sin(b);
            let d = 0.5 * Math.log((1 + c) / (1 - c));
            return d;
        }
        static a(a, b) {
            let c = new Rect(0, b.left / a.width, b.top / a.height, b.width / a.width, b.height / a.height);
            let d = c.left + c.width * a.left;
            let e = c.left + c.width * a.right;
            let f = c.top + c.height * a.top;
            let g = c.top + c.height * a.bottom;
            let h = new ScalerVisibleBounds(d, f, e, g);
            return h;
        }
        static m(a) {
            a = Math.exp(2 * a);
            return Math.asin((a - 1) / (a + 1)) / 0.017453292519943295;
        }
        t(a, b, c) {
            let d = (a - c.top) * b.width + b.top * c.height;
            d = this.k(85.05112878) - d / (c.height / this.e);
            return HeatTileScaler.m(d);
        }
        r(a, b, c) {
            let d = c.top + this.l(a, c.height);
            return (d - b.top * c.height) / b.width;
        }
        l(a, b) {
            a = a > -85.05112878 ? (a < 85.05112878 ? a : 85.05112878) : -85.05112878;
            let c = this.k(a);
            let d = (this.d - c) * b / this.e;
            return (d);
        }
        u(a, b, c) {
            let d = b.left + b.width * (a - c.left) / c.width;
            return -180 + d * (this.c);
        }
        s(a, b, c) {
            let d = (a - -180) / (this.c);
            return c.left + c.width * (d - b.left) / b.width;
        }
        i(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.t(b.bottom, a, b);
        }
        g(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.t(b.top, a, b);
        }
        j(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.u(b.left, a, b);
        }
        h(a, b) {
            let c = HeatTileScaler.a(a, b);
            return this.u(b.right, a, b);
        }
        v(a, b, c) {
            let d = c.height;
            let e = c.top;
            for (let f = 0; f < a.count; f++) {
                let g = a._inner[f];
                g = g > -85.05112878 ? (g < 85.05112878 ? g : 85.05112878) : -85.05112878;
                let h = g * (0.017453292519943295);
                let i = Math.sin(h);
                let j = 0.5 * Math.log((1 + i) / (1 - i));
                let k = (this.d - j) * d / this.e;
                k = e + k;
                a._inner[f] = (k - b.top * d) / b.width;
            }
        }
        w(a, b, c) {
            let d = c.left;
            let e = c.width;
            let f = b.left;
            let g = b.width;
            for (let h = 0; h < a.count; h++) {
                let i = (a._inner[h] - -180) / (this.c);
                a._inner[h] = c.left + c.width * (i - b.left) / b.width;
            }
        }
    }
    HeatTileScaler.$t = /*@__PURE__*/ markType(HeatTileScaler, 'HeatTileScaler');
    return HeatTileScaler;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileWorkSettings = /*@__PURE__*/ (() => {
    class TileWorkSettings extends Base {
        constructor() {
            super(...arguments);
            this._scaler = null;
            this._blurRadius = 0;
            this._maxBlurRadius = 0;
            this._useBlurRadiusAdjustedForZoom = false;
            this._minimumColor = new Color();
            this._maximumColor = new Color();
            this._tileViewport = null;
            this._yValues = null;
            this._xValues = null;
            this._values = null;
            this._isNewData = false;
            this._minimumVisibleLatitude = 0;
            this._maximumVisibleLatitude = 0;
            this._minimumVisibleLongitude = 0;
            this._maximumVisibleLongitude = 0;
            this._z = 0;
            this._x = 0;
            this._y = 0;
            this._window = null;
            this._testRun = false;
            this._globalMinimum = 0;
            this._globalMaximum = 0;
            this._useGlobalMinMax = false;
            this._minimumValue = 0;
            this._maximumValue = 0;
            this._scaleColors = null;
            this._scaleColorOffsets = null;
            this._useLogarithmicScale = false;
            this._logarithmBase = 0;
            this._image = null;
        }
        get scaler() {
            return this._scaler;
        }
        set scaler(a) {
            this._scaler = a;
        }
        get blurRadius() {
            return this._blurRadius;
        }
        set blurRadius(a) {
            this._blurRadius = a;
        }
        get maxBlurRadius() {
            return this._maxBlurRadius;
        }
        set maxBlurRadius(a) {
            this._maxBlurRadius = a;
        }
        get useBlurRadiusAdjustedForZoom() {
            return this._useBlurRadiusAdjustedForZoom;
        }
        set useBlurRadiusAdjustedForZoom(a) {
            this._useBlurRadiusAdjustedForZoom = a;
        }
        get minimumColor() {
            return this._minimumColor;
        }
        set minimumColor(a) {
            this._minimumColor = a;
        }
        get maximumColor() {
            return this._maximumColor;
        }
        set maximumColor(a) {
            this._maximumColor = a;
        }
        get tileViewport() {
            return this._tileViewport;
        }
        set tileViewport(a) {
            this._tileViewport = a;
        }
        get yValues() {
            return this._yValues;
        }
        set yValues(a) {
            this._yValues = a;
        }
        get xValues() {
            return this._xValues;
        }
        set xValues(a) {
            this._xValues = a;
        }
        get values() {
            return this._values;
        }
        set values(a) {
            this._values = a;
        }
        get isNewData() {
            return this._isNewData;
        }
        set isNewData(a) {
            this._isNewData = a;
        }
        get minimumVisibleLatitude() {
            return this._minimumVisibleLatitude;
        }
        set minimumVisibleLatitude(a) {
            this._minimumVisibleLatitude = a;
        }
        get maximumVisibleLatitude() {
            return this._maximumVisibleLatitude;
        }
        set maximumVisibleLatitude(a) {
            this._maximumVisibleLatitude = a;
        }
        get minimumVisibleLongitude() {
            return this._minimumVisibleLongitude;
        }
        set minimumVisibleLongitude(a) {
            this._minimumVisibleLongitude = a;
        }
        get maximumVisibleLongitude() {
            return this._maximumVisibleLongitude;
        }
        set maximumVisibleLongitude(a) {
            this._maximumVisibleLongitude = a;
        }
        get z() {
            return this._z;
        }
        set z(a) {
            this._z = a;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        get window() {
            return this._window;
        }
        set window(a) {
            this._window = a;
        }
        get testRun() {
            return this._testRun;
        }
        set testRun(a) {
            this._testRun = a;
        }
        get globalMinimum() {
            return this._globalMinimum;
        }
        set globalMinimum(a) {
            this._globalMinimum = a;
        }
        get globalMaximum() {
            return this._globalMaximum;
        }
        set globalMaximum(a) {
            this._globalMaximum = a;
        }
        get useGlobalMinMax() {
            return this._useGlobalMinMax;
        }
        set useGlobalMinMax(a) {
            this._useGlobalMinMax = a;
        }
        get minimumValue() {
            return this._minimumValue;
        }
        set minimumValue(a) {
            this._minimumValue = a;
        }
        get maximumValue() {
            return this._maximumValue;
        }
        set maximumValue(a) {
            this._maximumValue = a;
        }
        get scaleColors() {
            return this._scaleColors;
        }
        set scaleColors(a) {
            this._scaleColors = a;
        }
        get scaleColorOffsets() {
            return this._scaleColorOffsets;
        }
        set scaleColorOffsets(a) {
            this._scaleColorOffsets = a;
        }
        get useLogarithmicScale() {
            return this._useLogarithmicScale;
        }
        set useLogarithmicScale(a) {
            this._useLogarithmicScale = a;
        }
        get logarithmBase() {
            return this._logarithmBase;
        }
        set logarithmBase(a) {
            this._logarithmBase = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
        flatten() {
            let minA_ = this.minimumColor.l;
            let minR_ = this.minimumColor.o;
            let minG_ = this.minimumColor.n;
            let minB_ = this.minimumColor.m;
            let maxA_ = this.maximumColor.l;
            let maxR_ = this.maximumColor.o;
            let maxG_ = this.maximumColor.n;
            let maxB_ = this.maximumColor.m;
            let scaleColors_ = null;
            if (this.scaleColors != null) {
                scaleColors_ = new Array(this.scaleColors.length);
                for (let a = 0; a < this.scaleColors.length; a++) {
                    let a_ = this.scaleColors[a].l;
                    let r_ = this.scaleColors[a].o;
                    let g_ = this.scaleColors[a].n;
                    let b_ = this.scaleColors[a].m;
                    let color_ = { a: a_, r: r_, g: g_, b: b_ };
                    scaleColors_[a] = color_;
                }
            }
            return {
                blurRadius: this.blurRadius,
                maxBlurRadius: this.maxBlurRadius,
                //isLinearScaler: this.isLinearScaler,
                //linearScalerMinimumXValue: this.linearScalerMinimumXValue,
                //linearScalerMinimumYValue: this.linearScalerMinimumYValue,
                //linearScalerMaximumXValue: this.linearScalerMaximumXValue,
                //linearScalerMaximumYValue: this.linearScalerMaximumYValue,
                //linearScalerXIsInverted: this.linearScalerXIsInverted,
                //linearScalerYIsInverted: this.linearScalerYIsInverted,
                useBlurRadiusAdjustedForZoom: this.useBlurRadiusAdjustedForZoom,
                minimumColor: { a: minA_, r: minR_, g: minG_, b: minB_ },
                maximumColor: { a: maxA_, r: maxR_, g: maxG_, b: maxB_ },
                tileViewport: { left: this.tileViewport.left, top: this.tileViewport.top, width: this.tileViewport.width, height: this.tileViewport.height },
                yValues: this.yValues,
                xValues: this.xValues,
                values: this.values,
                isNewData: this.isNewData,
                minimumVisibleLatitude: this.minimumVisibleLatitude,
                minimumVisibleLongitude: this.minimumVisibleLongitude,
                maximumVisibleLatitude: this.maximumVisibleLatitude,
                maximumVisibleLongitude: this.maximumVisibleLongitude,
                z: this.z,
                x: this.x,
                y: this.y,
                window: { left: this.window.left, top: this.window.top, width: this.window.width, height: this.window.height },
                testRun: this.testRun,
                globalMinimum: this.globalMinimum,
                globalMaximum: this.globalMaximum,
                useGlobalMinMax: this.useGlobalMinMax,
                minimumValue: this.minimumValue,
                maximumValue: this.maximumValue,
                scaleColorOffsets: this.scaleColorOffsets,
                scaleColors: scaleColors_,
                useLogarithmicScale: this.useLogarithmicScale,
                logarithmBase: this.logarithmBase
            };
        }
    }
    TileWorkSettings.$t = /*@__PURE__*/ markType(TileWorkSettings, 'TileWorkSettings');
    return TileWorkSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileImageCreatedEventArgs = /*@__PURE__*/ (() => {
    class TileImageCreatedEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._imageData = null;
            this._image = null;
            this._z = 0;
            this._x = 0;
            this._y = 0;
            this._url = null;
        }
        get imageData() {
            return this._imageData;
        }
        set imageData(a) {
            this._imageData = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
        get z() {
            return this._z;
        }
        set z(a) {
            this._z = a;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        get url() {
            return this._url;
        }
        set url(a) {
            this._url = a;
        }
    }
    TileImageCreatedEventArgs.$t = /*@__PURE__*/ markType(TileImageCreatedEventArgs, 'TileImageCreatedEventArgs', EventArgs.$);
    return TileImageCreatedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileImageCreatedEventArgs = /*@__PURE__*/ (() => {
    class HeatTileImageCreatedEventArgs extends TileImageCreatedEventArgs {
        constructor() {
            super(...arguments);
            this._globalMinimumValue = 0;
            this._globalMaximumValue = 0;
            this._globalMaximumValueLongitude = 0;
            this._globalMaximumValueLatitude = 0;
            this._globalMinimumValueLongitude = 0;
            this._globalMinimumValueLatitude = 0;
        }
        get globalMinimumValue() {
            return this._globalMinimumValue;
        }
        set globalMinimumValue(a) {
            this._globalMinimumValue = a;
        }
        get globalMaximumValue() {
            return this._globalMaximumValue;
        }
        set globalMaximumValue(a) {
            this._globalMaximumValue = a;
        }
        get globalMaximumValueLongitude() {
            return this._globalMaximumValueLongitude;
        }
        set globalMaximumValueLongitude(a) {
            this._globalMaximumValueLongitude = a;
        }
        get globalMaximumValueLatitude() {
            return this._globalMaximumValueLatitude;
        }
        set globalMaximumValueLatitude(a) {
            this._globalMaximumValueLatitude = a;
        }
        get globalMinimumValueLongitude() {
            return this._globalMinimumValueLongitude;
        }
        set globalMinimumValueLongitude(a) {
            this._globalMinimumValueLongitude = a;
        }
        get globalMinimumValueLatitude() {
            return this._globalMinimumValueLatitude;
        }
        set globalMinimumValueLatitude(a) {
            this._globalMinimumValueLatitude = a;
        }
    }
    HeatTileImageCreatedEventArgs.$t = /*@__PURE__*/ markType(HeatTileImageCreatedEventArgs, 'HeatTileImageCreatedEventArgs', TileImageCreatedEventArgs.$);
    return HeatTileImageCreatedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorWorker = /*@__PURE__*/ (() => {
    class HeatTileGeneratorWorker extends Base {
        constructor(a) {
            super();
            this.f = null;
            this.a = null;
            this.n = 0;
            this.o = 0;
            this.p = 0;
            this.w = null;
            this.u = 0;
            this.h = false;
            this.r = 0;
            this.i = 0;
            this.j = 0;
            this.k = 0;
            this.l = 0;
            this._completedSink = null;
            this.f = a;
            HeatTileGeneratorWorker.s++;
            if (HeatTileGeneratorWorker.s == 0x7FFFFFFFFFFFFFFF) {
                HeatTileGeneratorWorker.s = 0;
            }
            this.r = HeatTileGeneratorWorker.s;
        }
        get t() {
            return this.r;
        }
        get g() {
            return this.f;
        }
        doWork() {
            let a = this.g.blurRadius;
            let b = a;
            let c = this.g.maxBlurRadius;
            let d = this.g.scaler;
            this.n = this.g.x;
            this.o = this.g.y;
            this.p = this.g.z;
            if (this.g.useBlurRadiusAdjustedForZoom && this.p > 0) {
                let e = Math.sqrt(1 * 1 + 1 * 1) * Math.pow(2, this.p - 1);
                b = a * e;
            }
            if (!isNaN_(c)) {
                if (b > c) {
                    b = c;
                }
            }
            let f = this.g.xValues;
            let g = this.g.yValues;
            let h = this.g.values;
            let i = this.g.xValues.length;
            let j = this.g.yValues.length;
            let k;
            let l;
            let m;
            let n;
            let o;
            let p;
            let q;
            let r = this.g.minimumVisibleLongitude;
            let s = this.g.maximumVisibleLongitude;
            let t = this.g.minimumVisibleLatitude;
            let u = this.g.maximumVisibleLatitude;
            let v = this.q(this.g.tileViewport, b);
            let w = this.c(v, b);
            let x = Math.abs(d.t(0, this.g.window, this.g.tileViewport) - d.t(b, this.g.window, this.g.tileViewport));
            let y = Math.abs(d.u(0, this.g.window, this.g.tileViewport) - d.u(b, this.g.window, this.g.tileViewport));
            let z;
            let aa;
            let ab = new List$1(Number_$type, 0);
            let ac = new List$1(Number_$type, 0);
            let ad = new List$1(Number_$type, 0);
            for (let ae = 0; ae < i; ae++) {
                k = f[ae];
                l = g[ae];
                m = h[ae];
                n = k - y;
                o = k + y;
                p = l - x;
                q = l + x;
                if (o < r || q < t || p > u || n > s) {
                    continue;
                }
                ab.add(k);
                ac.add(l);
                ad.add(m);
            }
            let af = this.d(this.g.tileViewport);
            let ag = this.b(this.g.tileViewport);
            let ah = truncate(this.g.tileViewport.width);
            let ai = ac.count;
            d.v(ac, this.g.window, this.g.tileViewport);
            d.w(ab, this.g.window, this.g.tileViewport);
            let aj;
            let ak;
            let al;
            let am;
            for (let an = 0; an < ai; an++) {
                z = truncate(Math.floor(ab._inner[an] - b));
                aa = truncate(Math.floor(ac._inner[an] - b));
                for (let ao = z; ao < z + v; ao++) {
                    for (let ap = aa; ap < aa + v; ap++) {
                        aj = ao - z;
                        ak = ap - aa;
                        if (ao < 0 || ao > (ah - 1) || ap < 0 || ap > (ah - 1)) {
                            continue;
                        }
                        al = w[ak * v + aj];
                        am = ad._inner[an] * al;
                        ag[ap * ah + ao] = ag[ap * ah + ao] + am;
                    }
                }
            }
            let aq = ag.length;
            let ar = -1.7976931348623157E+308;
            let as = 1.7976931348623157E+308;
            let at;
            if (!isNaN_(this.g.globalMinimum) && !isNaN_(this.g.globalMaximum) && this.g.useGlobalMinMax && !this.g.testRun) {
                as = this.g.globalMinimum;
                ar = this.g.globalMaximum;
                if (!isNaN_(this.g.minimumValue)) {
                    as = this.g.minimumValue;
                }
                if (!isNaN_(this.g.maximumValue)) {
                    ar = this.g.maximumValue;
                }
            }
            else if (!isNaN_(this.g.minimumValue) && !isNaN_(this.g.maximumValue)) {
                as = this.g.minimumValue;
                ar = this.g.maximumValue;
            }
            else {
                let au = -1;
                let av = -1;
                for (let aw = 0; aw < aq; aw++) {
                    at = ag[aw];
                    if (at > 0) {
                        if (at > ar) {
                            ar = at;
                            au = aw;
                        }
                        if (at < as) {
                            as = at;
                            av = aw;
                        }
                    }
                }
                let ax = truncate(Math.floor(au / ah));
                let ay = au % ah;
                let az = truncate(Math.floor(av / ah));
                let a0 = av % ah;
                this.g.globalMinimum = as;
                this.g.globalMaximum = ar;
                let a1 = 0;
                let a2 = 0;
                let a3 = 0;
                let a4 = 0;
                let a5 = 0;
                let a6 = 0;
                for (let a7 = 0; a7 < ai; a7++) {
                    z = truncate(Math.floor(ab._inner[a7] - b));
                    aa = truncate(Math.floor(ac._inner[a7] - b));
                    for (let a8 = z; a8 < z + v; a8++) {
                        for (let a9 = aa; a9 < aa + v; a9++) {
                            aj = a8 - z;
                            ak = a9 - aa;
                            if (a8 < 0 || a8 > (ah - 1) || a9 < 0 || a9 > (ah - 1)) {
                                continue;
                            }
                            if (a8 == ay && a9 == ax) {
                                a1++;
                                a3 = a3 + d.t(ac._inner[a7], this.g.window, this.g.tileViewport);
                                a4 = a4 + d.u(ab._inner[a7], this.g.window, this.g.tileViewport);
                            }
                            if (a8 == a0 && a9 == az) {
                                a2++;
                                a5 = a5 + d.t(ac._inner[a7], this.g.window, this.g.tileViewport);
                                a6 = a6 + d.u(ab._inner[a7], this.g.window, this.g.tileViewport);
                            }
                        }
                    }
                }
                this.i = a3 / a1;
                this.j = a4 / a1;
                this.k = a5 / a2;
                this.l = a6 / a2;
                if (!isNaN_(this.g.minimumValue)) {
                    as = this.g.minimumValue;
                }
                if (!isNaN_(this.g.maximumValue)) {
                    ar = this.g.maximumValue;
                }
            }
            if (!this.g.testRun) {
                this.x(af, ag, ar, as);
                this.a = af;
            }
            this.z();
        }
        x(a, b, c, d) {
            let e;
            let f = b.length;
            if (this.g.useLogarithmicScale) {
                if (d <= 0) {
                    d = 0;
                }
                else {
                    d = logBase(d, this.g.logarithmBase);
                }
                if (c <= 0) {
                    c = 0;
                }
                else {
                    c = logBase(c, this.g.logarithmBase);
                }
            }
            let g = 0;
            let h = c - d;
            if (isNaN_(h) || h <= 0) {
                h = 1;
            }
            let i;
            let j;
            let k;
            let l;
            let m = this.g.useLogarithmicScale;
            let n = this.g.logarithmBase;
            if (this.g.scaleColors != null) {
                let o = new Array(this.g.scaleColors.length);
                let p = new Array(this.g.scaleColors.length);
                let q = new Array(this.g.scaleColors.length);
                let r = new Array(this.g.scaleColors.length);
                let s = new Array(this.g.scaleColors.length);
                let t = new Array(this.g.scaleColors.length);
                let u = new Array(this.g.scaleColors.length);
                let v = new Array(this.g.scaleColors.length);
                let w = new Array(this.g.scaleColors.length);
                let x = new Array(this.g.scaleColors.length);
                let y = new Array(this.g.scaleColors.length);
                let z = new Array(this.g.scaleColors.length);
                let aa = this.g.scaleColorOffsets;
                if (aa == null || aa.length != this.g.scaleColors.length) {
                    aa = new Array(this.g.scaleColors.length);
                    if (aa.length == 1) {
                        aa[0] = 0;
                    }
                    else {
                        for (let ab = 0; ab < this.g.scaleColors.length; ab++) {
                            aa[ab] = ab / (this.g.scaleColors.length - 1);
                        }
                    }
                }
                for (let ac = 0; ac < this.g.scaleColors.length; ac++) {
                    o[ac] = this.g.scaleColors[ac].l;
                    q[ac] = this.g.scaleColors[ac].o;
                    s[ac] = this.g.scaleColors[ac].n;
                    u[ac] = this.g.scaleColors[ac].m;
                    if (ac < this.g.scaleColors.length - 1) {
                        p[ac] = this.g.scaleColors[ac + 1].l;
                        r[ac] = this.g.scaleColors[ac + 1].o;
                        t[ac] = this.g.scaleColors[ac + 1].n;
                        v[ac] = this.g.scaleColors[ac + 1].m;
                    }
                    else {
                        p[ac] = this.g.scaleColors[ac].l;
                        r[ac] = this.g.scaleColors[ac].o;
                        t[ac] = this.g.scaleColors[ac].n;
                        v[ac] = this.g.scaleColors[ac].m;
                    }
                    w[ac] = p[ac] - o[ac];
                    x[ac] = r[ac] - q[ac];
                    y[ac] = t[ac] - s[ac];
                    z[ac] = v[ac] - u[ac];
                }
                for (let ad = 0; ad < f; ad++) {
                    e = b[ad];
                    if (e == 0) {
                        continue;
                    }
                    if (m) {
                        if (e <= 0) {
                            e = 0;
                        }
                        else {
                            e = logBase(e, n);
                        }
                    }
                    g = (e - d) / (h);
                    if (g < 0) {
                        g = 0;
                    }
                    if (g > 1) {
                        g = 1;
                    }
                    let ae = 0;
                    for (let af = 0; af < aa.length; af++) {
                        if (aa[af] >= g) {
                            ae = af - 1;
                            break;
                        }
                    }
                    if (ae > aa.length - 2) {
                        ae = aa.length - 2;
                    }
                    if (ae < 0) {
                        ae = 0;
                    }
                    g = (g - aa[ae]) / (aa[ae + 1] - aa[ae]);
                    i = truncate(Math.floor(o[ae] + g * (w[ae])));
                    j = truncate(Math.floor(q[ae] + g * (x[ae])));
                    k = truncate(Math.floor(s[ae] + g * (y[ae])));
                    l = truncate(Math.floor(u[ae] + g * (z[ae])));
                    a[4 * ad] = i;
                    a[4 * ad + 1] = j;
                    a[4 * ad + 2] = k;
                    a[4 * ad + 3] = l;
                }
            }
            else {
                let ag = this.g.minimumColor.l;
                let ah = this.g.maximumColor.l;
                let ai = this.g.minimumColor.o;
                let aj = this.g.maximumColor.o;
                let ak = this.g.minimumColor.n;
                let al = this.g.maximumColor.n;
                let am = this.g.minimumColor.m;
                let an = this.g.maximumColor.m;
                let ao = ah - ag;
                let ap = aj - ai;
                let aq = al - ak;
                let ar = an - am;
                for (let as = 0; as < f; as++) {
                    e = b[as];
                    if (e == 0) {
                        continue;
                    }
                    if (m) {
                        e = logBase(e, n);
                    }
                    g = (e - d) / (h);
                    if (g < 0) {
                        g = 0;
                    }
                    if (g > 1) {
                        g = 1;
                    }
                    i = truncate(Math.floor(ag + g * (ao)));
                    j = truncate(Math.floor(ai + g * (ap)));
                    k = truncate(Math.floor(ak + g * (aq)));
                    l = truncate(Math.floor(am + g * (ar)));
                    a[4 * as] = i;
                    a[4 * as + 1] = j;
                    a[4 * as + 2] = k;
                    a[4 * as + 3] = l;
                }
            }
        }
        b(a) {
            let b = new Array(truncate(a.width) * truncate(a.height));
            for (let c = 0; c < b.length; c++) {
                b[c] = 0;
            }
            return b;
        }
        d(a) {
            let b = new Array(truncate(a.width) * truncate(a.height) * 4);
            for (let c = 0; c < b.length; c++) {
                b[c] = 0;
            }
            return b;
        }
        c(a, b) {
            let c = new Array(a * a);
            for (let d = 0; d < c.length; d++) {
                c[d] = 0;
            }
            let e = a / 2;
            let f = a / 2;
            for (let g = 0; g < a; g++) {
                for (let h = 0; h < a; h++) {
                    let i = Math.sqrt(Math.pow(g - f, 2) + Math.pow(h - f, 2));
                    if (i > e) {
                        c[h * a + g] = 0;
                    }
                    else {
                        c[h * a + g] = e - i;
                    }
                }
            }
            let j = 0;
            let k = -1.7976931348623157E+308;
            let l = 1.7976931348623157E+308;
            for (let m = 0; m < a; m++) {
                for (let n = 0; n < a; n++) {
                    let o = c[n * a + m];
                    if (o == 0) {
                        continue;
                    }
                    j += o;
                    k = o > k ? o : k;
                    l = o < l ? o : l;
                }
            }
            for (let p = 0; p < a; p++) {
                for (let q = 0; q < a; q++) {
                    let r = c[q * a + p];
                    if (r == 0) {
                        continue;
                    }
                    let s = (r - l) / (k - l);
                    c[q * a + p] = 0.01 + s * (0.99);
                }
            }
            c[truncate(f) * a + truncate(f)] = 1;
            return c;
        }
        q(a, b) {
            return truncate(Math.floor(b * 2));
        }
        z() {
            if (this.completedSink == null) {
                return;
            }
            this.completedSink.onCompleted(((() => {
                let $ret = new HeatTileImageCreatedEventArgs();
                $ret.url = this.w;
                $ret.x = this.n;
                $ret.y = this.o;
                $ret.z = this.p;
                $ret.globalMinimumValue = this.g.globalMinimum;
                $ret.globalMaximumValue = this.g.globalMaximum;
                $ret.globalMaximumValueLongitude = this.j;
                $ret.globalMaximumValueLatitude = this.i;
                $ret.globalMinimumValueLongitude = this.l;
                $ret.globalMinimumValueLatitude = this.k;
                $ret.imageData = this.a;
                $ret.image = this.g.image;
                return $ret;
            })()));
        }
        get completedSink() {
            return this._completedSink;
        }
        set completedSink(a) {
            this._completedSink = a;
        }
    }
    HeatTileGeneratorWorker.$t = /*@__PURE__*/ markType(HeatTileGeneratorWorker, 'HeatTileGeneratorWorker');
    HeatTileGeneratorWorker.v = {};
    HeatTileGeneratorWorker.s = 0;
    HeatTileGeneratorWorker.m = 0;
    return HeatTileGeneratorWorker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITileWorkCompletedSink_$type = /*@__PURE__*/ new Type(null, 'ITileWorkCompletedSink');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorWorkerManager = /*@__PURE__*/ (() => {
    class HeatTileGeneratorWorkerManager extends Base {
        constructor() {
            super();
            this.b = true;
            this.o = null;
            this.k = null;
            this._supportsTransferable = false;
            this.d = false;
            this._worker = null;
            this.a = false;
            this.j = 0;
            this.g = new Dictionary$2(String_$type, TileWorkSettings.$, 0);
            this.h = new Dictionary$2(String_$type, Delegate_$type, 0);
            this.i = new LinkedList$1(HeatTileGeneratorWorker.$);
            this.f = new Dictionary$2(String_$type, List$1.$.specialize(LinkedListNode$1.$.specialize(HeatTileGeneratorWorker.$)), 0);
        }
        get e() {
            return this.b;
        }
        set e(a) {
            this.b = a;
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get n() {
            return this.k;
        }
        set n(a) {
            this.k = a;
        }
        u() {
            if (!this.a) {
                this.a = true;
                if ((window.Worker)) {
                    this.d = true;
                }
                if (this.d && this.e) {
                    this.v();
                    var test = new ArrayBuffer(1);
                    this._worker.postMessage(test, [test]);
                    if (test.byteLength == 0) {
                        this._supportsTransferable = true;
                    }
                    ;
                }
                if (!this._supportsTransferable) {
                    this.b = false;
                }
            }
        }
        v() {
            if (this.p == null && this.n == null) {
                throw new Error('HeatTileGenerator wants to use web workers, but webWorkerScriptPath and webWorkerInstance were not specified. Either specify the path, an instance, or set allowWebWorkers to false');
            }
            if (this.n != null) {
                this._worker = this.n;
            }
            else {
                let path_ = this.p;
                this._worker = new Worker(path_);
            }
            this._worker.postMessage = this._worker.webkitPostMessage || this._worker.postMessage;
            let onMessage_ = runOn(this, this.z);
            this._worker.onmessage = onMessage_;
        }
        z(args_) {
            let data_ = args_.data;
            let a = new HeatTileImageCreatedEventArgs();
            a.imageData = (data_.imageData == null ? null : new Uint8ClampedArray(data_.imageData));
            a.z = (data_.z);
            a.x = (data_.x);
            a.y = (data_.y);
            a.url = (data_.url);
            a.globalMinimumValue = (data_.globalMinimumValue);
            a.globalMaximumValue = (data_.globalMaximumValue);
            a.globalMaximumValueLongitude = (data_.globalMaximumValueLongitude);
            a.globalMaximumValueLatitude = (data_.globalMaximumValueLatitude);
            a.globalMinimumValueLongitude = (data_.globalMinimumValueLongitude);
            a.globalMinimumValueLatitude = (data_.globalMinimumValueLatitude);
            let b = (data_.messageId.toString());
            if (!this.g.containsKey(b)) {
                return;
            }
            let c = this.g.item(b);
            let d = this.h.item(b);
            this.g.removeItem(b);
            this.h.removeItem(b);
            a.image = c.image;
            d(this, a);
        }
        x() {
            this.u();
            if (this.e && this._worker == null) {
                this.v();
            }
            if (!this.e && this._worker != null) {
                this._worker.terminate();
                this._worker.onmessage = null;
                this._worker = null;
            }
        }
        toDoubleArray(arr_) {
            return new Float64Array(arr_).buffer;
        }
        r(a, b, c) {
            this.j++;
            if (this.j >= 0x7FFFFFFF) {
                this.j = 1;
            }
            this.g.addItem(this.j.toString(), a);
            this.h.addItem(this.j.toString(), b);
            let messageId_ = this.j;
            let innerSettings_ = a.flatten();
            innerSettings_.messageId = messageId_;
            innerSettings_.transferableSupported = this._supportsTransferable;
            if (a.isNewData) {
                innerSettings_.latitudes = this.toDoubleArray(innerSettings_.latitudes);
                innerSettings_.longitudes = this.toDoubleArray(innerSettings_.longitudes);
                innerSettings_.values = this.toDoubleArray(innerSettings_.values);
            }
            else {
                innerSettings_.latitudes = null;
                innerSettings_.longitudes = null;
                innerSettings_.values = null;
            }
            if (this._supportsTransferable && a.isNewData) {
                this._worker.postMessage(innerSettings_, [innerSettings_.latitudes,
                    innerSettings_.longitudes,
                    innerSettings_.values]);
            }
            else {
                this._worker.postMessage(innerSettings_);
            }
        }
        t(z_, x_, y_) {
            let cancelMsg_ = {
                cancelTile: true,
                z: z_,
                x: x_,
                y: y_
            };
            this._worker.postMessage(cancelMsg_);
        }
        y(a, b, c) {
            this.x();
            if (this.e) {
                this.r(a, b, c);
            }
            else {
                this.q(a, b, c);
            }
        }
        aa() {
            if (this.i.c != null) {
                let a = this.i.c;
                this.i.h(a);
                let b = a.c.g;
                if (this.f.containsKey(b.z + "_" + b.x + "_" + b.y)) {
                    let c = this.f.item(b.z + "_" + b.x + "_" + b.y);
                    c.remove(a);
                    if (c.count == 0) {
                        this.f.removeItem(b.z + "_" + b.x + "_" + b.y);
                    }
                }
                a.c.doWork();
            }
            if (this.i.c != null) {
                window.setTimeout(() => this.aa(), 16);
            }
        }
        q(a, b, c) {
            {
                let d = new HeatTileGeneratorWorker(a);
                d.completedSink = new TileWorkCompletedSink(this, b);
                this.i.f(d);
                let e;
                let f = d.g.z + "_" + d.g.x + "_" + d.g.y;
                if (this.f.containsKey(f)) {
                    e = this.f.item(f);
                }
                else {
                    e = new List$1(LinkedListNode$1.$.specialize(HeatTileGeneratorWorker.$), 0);
                    this.f.addItem(f, e);
                }
                e.add(this.i.d);
                window.setTimeout(() => this.aa(), 16);
            }
        }
        w() {
            if (this._worker != null) {
                this._worker.terminate();
                this._worker = null;
            }
            this.g.clear();
            this.h.clear();
        }
        s(a, b, c) {
            this.x();
            if (this.e) {
                this.t(a, b, c);
            }
            else {
                if (this.f.containsKey(a + "_" + b + "_" + c)) {
                    let d = this.f.item(a + "_" + b + "_" + c);
                    for (let e = d.count - 1; e >= 0; e--) {
                        let f = d._inner[e];
                        if (f.c.g.testRun) {
                            continue;
                        }
                        d.removeAt(e);
                        let g = f.c;
                        this.i.h(f);
                        g.completedSink = null;
                    }
                }
            }
        }
    }
    HeatTileGeneratorWorkerManager.$t = /*@__PURE__*/ markType(HeatTileGeneratorWorkerManager, 'HeatTileGeneratorWorkerManager');
    return HeatTileGeneratorWorkerManager;
})();
/**
 * @hidden
 */
let TileWorkCompletedSink = /*@__PURE__*/ (() => {
    class TileWorkCompletedSink extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        onCompleted(a) {
            this.b(this.a, a);
        }
    }
    TileWorkCompletedSink.$t = /*@__PURE__*/ markType(TileWorkCompletedSink, 'TileWorkCompletedSink', Base.$, [ITileWorkCompletedSink_$type]);
    return TileWorkCompletedSink;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileImageZoomChangingEventArgs = /*@__PURE__*/ (() => {
    class TileImageZoomChangingEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._z = 0;
            this._x = 0;
            this._y = 0;
        }
        get z() {
            return this._z;
        }
        set z(a) {
            this._z = a;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
    }
    TileImageZoomChangingEventArgs.$t = /*@__PURE__*/ markType(TileImageZoomChangingEventArgs, 'TileImageZoomChangingEventArgs', EventArgs.$);
    return TileImageZoomChangingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGenerator = /*@__PURE__*/ (() => {
    class HeatTileGenerator extends Base {
        constructor() {
            super();
            this.m = new HeatTileScaler();
            this.bz = new Rect(0, 0, 0, 256, 256);
            this.l = new HeatTileGeneratorWorkerManager();
            this.e = null;
            this.d = null;
            this.c = null;
            this.bw = new Color();
            this.bv = new Color();
            this.b = null;
            this.a = null;
            this.ac = 0;
            this.am = NaN;
            this.p = false;
            this.q = false;
            this.r = false;
            this.ao = NaN;
            this.an = NaN;
            this.al = 10;
            this.s = false;
            this.t = true;
            this.a0 = null;
            this.ax = null;
            this.ad = NaN;
            this.ag = NaN;
            this.aw = {};
            this.au = -1;
            this.ay = {};
            this.ak = 0;
            this.aj = 0;
            this.z = new Dictionary$2(String_$type, Tuple$2.$.specialize(Number_$type, Number_$type), 0);
            this.aa = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.ah = 0;
            this.ai = 0;
            this.ae = 0;
            this.af = 0;
            this.n = false;
            this.ab = new List$1(Delegate_$type, 0);
            this.o = false;
            this.m = new HeatTileScaler();
        }
        get k() {
            return this.e;
        }
        set k(a) {
            let b = this.e;
            this.e = a;
            if (this.e != b) {
                this.br("YValues", b, this.e);
            }
        }
        get j() {
            return this.d;
        }
        set j(a) {
            let b = this.d;
            this.d = a;
            if (this.d != b) {
                this.br("XValues", b, this.d);
            }
        }
        get i() {
            return this.c;
        }
        set i(a) {
            let b = this.c;
            this.c = a;
            if (this.c != b) {
                this.br("Values", b, this.c);
            }
        }
        get by() {
            return this.bw;
        }
        set by(a) {
            let b = this.bw;
            this.bw = a;
            if (Color.d(this.bw, b)) {
                this.br("MinimumColor", b, this.bw);
            }
        }
        get bx() {
            return this.bv;
        }
        set bx(a) {
            let b = this.bv;
            this.bv = a;
            if (Color.d(this.bv, b)) {
                this.br("MaximumColor", b, this.bv);
            }
        }
        get scaleColors() {
            return this.b;
        }
        set scaleColors(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.br("ScaleColors", b, this.b);
            }
        }
        get g() {
            return this.a;
        }
        set g(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.br("ScaleColorOffsets", b, this.a);
            }
        }
        get ap() {
            return this.ac;
        }
        set ap(a) {
            let b = this.ac;
            this.ac = a;
            if (this.ac != b) {
                this.br("BlurRadius", b, this.ac);
            }
        }
        get ar() {
            return this.am;
        }
        set ar(a) {
            let b = this.am;
            this.am = a;
            if (this.am != b) {
                this.br("MaxBlurRadius", b, this.am);
            }
        }
        get u() {
            return this.p;
        }
        set u(a) {
            let b = this.p;
            this.p = a;
            if (this.p != b) {
                this.br("UseBlurRadiusAdjustedForZoom", b, this.p);
            }
        }
        get v() {
            return this.q;
        }
        set v(a) {
            let b = this.q;
            this.q = a;
            if (this.q != b) {
                this.br("UseGlobalMinMax", b, this.q);
            }
        }
        get w() {
            return this.r;
        }
        set w(a) {
            let b = this.r;
            this.r = a;
            if (this.r != b) {
                this.br("UseGlobalMinMaxAdjustedForZoom", b, this.r);
            }
        }
        get at() {
            return this.ao;
        }
        set at(a) {
            let b = this.ao;
            this.ao = a;
            if (this.ao != b) {
                this.br("MinimumValue", b, this.ao);
            }
        }
        get as() {
            return this.an;
        }
        set as(a) {
            let b = this.an;
            this.an = a;
            if (this.an != b) {
                this.br("MaximumValue", b, this.an);
            }
        }
        get aq() {
            return this.al;
        }
        set aq(a) {
            let b = this.al;
            this.al = a;
            if (this.al != b) {
                this.br("LogarithmBase", b, this.al);
            }
        }
        get x() {
            return this.s;
        }
        set x(a) {
            let b = this.s;
            this.s = a;
            if (this.s != b) {
                this.br("UseLogarithmicScale", b, this.s);
            }
        }
        get y() {
            return this.t;
        }
        set y(a) {
            let b = this.t;
            this.t = a;
            if (this.t != b) {
                this.br("UseWebWorkers", b, this.t);
            }
        }
        get bi() {
            return this.a0;
        }
        set bi(a) {
            let b = this.a0;
            this.a0 = a;
            if (this.a0 != b) {
                this.br("WebWorkerScriptPath", b, this.a0);
            }
        }
        get az() {
            return this.ax;
        }
        set az(a) {
            let b = this.ax;
            this.ax = a;
            if (this.ax != b) {
                this.br("WebWorkerInstance", b, this.ax);
            }
        }
        bo() {
            this.e = null;
            this.d = null;
            this.c = null;
            this.l.w();
        }
        br(a, b, c) {
            this.bs(a, b, c);
        }
        bs(a, b, c) {
            switch (a) {
                case "XValues":
                case "YValues":
                case "Values":
                    this.bq();
                    break;
                case "UseWebWorkers":
                    this.l.e = this.y;
                    break;
                case "WebWorkerScriptPath":
                    this.l.p = this.bi;
                    break;
                case "WebWorkerInstance":
                    this.l.n = this.az;
                    break;
            }
        }
        getTile(a, b, c, d, e, f, g) {
            this.getTile1(a, b, c, d, e, f, g, false);
        }
        getTile1(a, b, c, d, e, f, g, h) {
            let i = NaN;
            let j = NaN;
            if (!h && this.v && (isNaN_(this.ag) || isNaN_(this.ad))) {
                let k = false;
                if ((isNaN_(this.ag) || isNaN_(this.ad)) && !this.n) {
                    k = true;
                    this.n = true;
                }
                else {
                    this.ab.add(() => this.bm(a, b, c, h, j, i, d, e, f, g));
                    return;
                }
                if (k) {
                    let l = 1.7976931348623157E+308;
                    let m = -1.7976931348623157E+308;
                    let n = 0;
                    let o = 0;
                    let p = 0;
                    let q = 0;
                    this.getTile1(0, 0, 0, (r, s) => {
                        let t = s;
                        l = t.globalMinimumValue;
                        m = t.globalMaximumValue;
                        n = t.globalMinimumValueLongitude;
                        o = t.globalMinimumValueLatitude;
                        p = t.globalMaximumValueLongitude;
                        q = t.globalMaximumValueLatitude;
                        let u = new Rect(0, 0, 0, 1, 1);
                        let v = this.bz;
                        i = l;
                        j = m;
                        let w = new List$1(Delegate_$type, 0);
                        this.ag = i;
                        this.ad = j;
                        this.ah = o;
                        this.ai = n;
                        this.ae = q;
                        this.af = p;
                        for (let x = 0; x < this.ab.count; x++) {
                            w.add(this.ab._inner[x]);
                        }
                        this.ab.clear();
                        this.bm(a, b, c, h, j, i, d, e, f, g);
                        for (let y = 0; y < w.count; y++) {
                            w._inner[y]();
                        }
                    }, (r, s) => {
                    }, (r, s) => {
                    }, g, true);
                    return;
                }
                else {
                    i = this.ag;
                    j = this.ad;
                }
            }
            else {
                i = this.ag;
                j = this.ad;
            }
            this.bm(a, b, c, h, j, i, d, e, f, g);
        }
        cancelTile(a, b, c) {
            this.l.s(a, b, c);
        }
        bm(a, b, c, d, e, f, g, h, i, j) {
            this.bn(a, b, c, d, i, () => {
                if (this.w && !d) {
                    if (a > 0 && this.z.containsKey(a.toString())) {
                        let k = this.z.item(a.toString());
                        e = k.c;
                        f = k.d;
                    }
                }
                let l = this.b0(a, b, c);
                let m = new TileWorkSettings();
                m.window = l;
                m.z = a;
                m.x = b;
                m.y = c;
                m.globalMinimum = f;
                m.globalMaximum = e;
                m.useGlobalMinMax = this.v;
                m.minimumValue = this.at;
                m.maximumValue = this.as;
                m.useLogarithmicScale = this.x;
                m.logarithmBase = this.aq;
                if (m.logarithmBase <= 0) {
                    m.logarithmBase = 10;
                }
                m.tileViewport = this.bz;
                m.maximumColor = this.bx;
                m.minimumColor = this.by;
                m.scaler = this.m;
                m.values = this.c;
                m.blurRadius = this.ap;
                if (m.blurRadius <= 0) {
                    m.blurRadius = 1;
                }
                m.useBlurRadiusAdjustedForZoom = this.u;
                m.maxBlurRadius = this.ar;
                if (m.maxBlurRadius <= 0) {
                    m.maxBlurRadius = 1;
                }
                m.values = this.i;
                m.scaleColors = this.scaleColors;
                m.scaleColorOffsets = this.g;
                m.minimumVisibleLatitude = this.m.i(l, this.bz);
                m.maximumVisibleLatitude = this.m.g(l, this.bz);
                m.minimumVisibleLongitude = this.m.j(l, this.bz);
                m.maximumVisibleLongitude = this.m.h(l, this.bz);
                m.yValues = this.e;
                m.xValues = this.d;
                if (this.c == null && this.e != null) {
                    this.c = new Array(this.e.length);
                    for (let n = 0; n < this.e.length; n++) {
                        this.c[n] = 1;
                    }
                    m.values = this.c;
                }
                if (!this.o) {
                    this.o = true;
                    m.isNewData = true;
                }
                m.image = j;
                m.testRun = d;
                this.l.y(m, (o, p) => {
                    p.url = this.a2(p.imageData);
                    p.imageData = this.f(p.imageData);
                    g(this, p);
                }, h);
            });
        }
        bn(a, b, c, d, e, f) {
            let g = false;
            g = this.au != a;
            if (!g || d) {
                f();
                return;
            }
            let h = false;
            let i = false;
            if (a != this.au) {
                if (this.z.containsKey(a.toString()) && !isNaN_(this.z.item(a.toString()).c) && !isNaN_(this.z.item(a.toString()).d)) {
                    this.au = a;
                    e(this, ((() => {
                        let $ret = new TileImageZoomChangingEventArgs();
                        $ret.z = a;
                        $ret.x = b;
                        $ret.y = c;
                        return $ret;
                    })()));
                    h = true;
                }
                else if (this.z.containsKey(a.toString())) {
                    if (a > 0 && this.w) {
                        let j;
                        if (this.aa.containsKey(a.toString())) {
                            j = this.aa.item(a.toString());
                        }
                        else {
                            j = new List$1(Delegate_$type, 0);
                            this.aa.addItem(a.toString(), j);
                        }
                        j.add(f);
                    }
                }
                else {
                    if (a > 0 && this.w) {
                        this.z.addItem(a.toString(), new Tuple$2(Number_$type, Number_$type, NaN, NaN));
                        i = true;
                    }
                }
            }
            if (i) {
                if (a > 0 && this.w) {
                    this.bt(a, f);
                }
            }
            if (h) {
                f();
            }
        }
        a2(a) {
            if (a == null) {
                return null;
            }
            let b = document.createElement("canvas");
            b.setAttribute("width", "256");
            b.setAttribute("height", "256");
            let c = b.getContext("2d");
            let d = c.getImageData(0, 0, 256, 256);
            let e = d.data;
            let f = e.length / 4;
            for (let g = 0; g < f; g++) {
                let h = a[g * 4];
                let i = a[g * 4 + 1];
                let j = a[g * 4 + 2];
                let k = a[g * 4 + 3];
                e[g * 4] = i;
                e[g * 4 + 1] = j;
                e[g * 4 + 2] = k;
                e[g * 4 + 3] = h;
            }
            c.putImageData(d, 0, 0);
            let ele_ = b;
            return (ele_.toDataURL());
        }
        f(a) {
            if (a == null) {
                return null;
            }
            return a;
        }
        bt(a, b) {
            let c = 0;
            let d = 0;
            let e = 0;
            let f = 0;
            let g = new Rect(0, 0, 0, 256 * Math.pow(2, a), 256 * Math.pow(2, a));
            let h = new Rect(0, 0, 0, 1, 1);
            let i = this.m.s(this.af, h, g);
            let j = this.m.r(this.ae, h, g);
            let k = this.m.s(this.ai, h, g);
            let l = this.m.r(this.ah, h, g);
            c = truncate(Math.floor(k / 256));
            d = truncate(Math.floor(l / 256));
            e = truncate(Math.floor(i / 256));
            f = truncate(Math.floor(j / 256));
            let m = 0;
            let n = 0;
            this.getTile1(a, c, d, (o, p) => {
                let q = p;
                m = q.globalMinimumValue;
                n = q.globalMaximumValue;
                if (e != c && f != d) {
                    this.getTile1(a, e, f, (r, s) => {
                        let t = s;
                        n = t.globalMaximumValue;
                        this.bu(a, n, m, b);
                    }, (r, s) => {
                    }, (r, s) => {
                    }, null, true);
                }
                else {
                    this.bu(a, n, m, b);
                }
            }, (o, p) => {
            }, (o, p) => {
            }, null, true);
        }
        bu(a, b, c, d) {
            if (b < this.aj) {
                b = this.aj;
            }
            if (isNaN_(c) || c > this.ak) {
                c = this.ak;
            }
            let e = new List$1(Delegate_$type, 0);
            this.z.item(a.toString(), new Tuple$2(Number_$type, Number_$type, b, c));
            if (this.aa.containsKey(a.toString())) {
                let f = this.aa.item(a.toString());
                for (let g = 0; g < f.count; g++) {
                    e.add(f._inner[g]);
                }
            }
            this.aa.removeItem(a.toString());
            this.au = a;
            d();
            for (let h = 0; h < e.count; h++) {
                e._inner[h]();
            }
        }
        b0(a, b, c) {
            let d = truncate(Math.pow(2, a)) * 256;
            let e = (b * 256) / d;
            let f = (c * 256) / d;
            let g = 256 / d;
            let h = 256 / d;
            return new Rect(0, e, f, g, h);
        }
        bq() {
            let a = -1.7976931348623157E+308;
            let b = 1.7976931348623157E+308;
            if (this.c != null) {
                for (let c = 0; c < this.c.length; c++) {
                    let d = this.c[c];
                    a = d > a ? d : a;
                    b = d < b ? d : b;
                }
            }
            let e = this.ak = b * 0.01;
            this.aj = a;
            this.o = false;
        }
    }
    HeatTileGenerator.$t = /*@__PURE__*/ markType(HeatTileGenerator, 'HeatTileGenerator', Base.$, [ITileGenerator_$type]);
    return HeatTileGenerator;
})();

class IgrHeatTileGenerator {
    createImplementation() {
        return new HeatTileGenerator();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get scaleColors() {
        if (this.i.scaleColors == null) {
            return null;
        }
        let c = [];
        for (let i = 0; i < this.i.scaleColors.length; i++) {
            c.push(colorToString(this.i.scaleColors[i]));
        }
        return c;
    }
    set scaleColors(v) {
        if (v == null) {
            this.i.scaleColors = null;
            return;
        }
        let c = [];
        for (let i = 0; i < v.length; i++) {
            c.push(stringToColor(v[i]));
        }
        this.i.scaleColors = c;
    }
    get yValues() {
        return this.i.k;
    }
    set yValues(v) {
        this.i.k = v;
    }
    get xValues() {
        return this.i.j;
    }
    set xValues(v) {
        this.i.j = v;
    }
    get values() {
        return this.i.i;
    }
    set values(v) {
        this.i.i = v;
    }
    get minimumColor() {
        return colorToString(this.i.by);
    }
    set minimumColor(v) {
        this.i.by = stringToColor(v);
    }
    get maximumColor() {
        return colorToString(this.i.bx);
    }
    set maximumColor(v) {
        this.i.bx = stringToColor(v);
    }
    get scaleColorOffsets() {
        return this.i.g;
    }
    set scaleColorOffsets(v) {
        this.i.g = v;
    }
    get blurRadius() {
        return this.i.ap;
    }
    set blurRadius(v) {
        this.i.ap = +v;
    }
    get maxBlurRadius() {
        return this.i.ar;
    }
    set maxBlurRadius(v) {
        this.i.ar = +v;
    }
    get useBlurRadiusAdjustedForZoom() {
        return this.i.u;
    }
    set useBlurRadiusAdjustedForZoom(v) {
        this.i.u = ensureBool(v);
    }
    get useGlobalMinMax() {
        return this.i.v;
    }
    set useGlobalMinMax(v) {
        this.i.v = ensureBool(v);
    }
    get useGlobalMinMaxAdjustedForZoom() {
        return this.i.w;
    }
    set useGlobalMinMaxAdjustedForZoom(v) {
        this.i.w = ensureBool(v);
    }
    get minimumValue() {
        return this.i.at;
    }
    set minimumValue(v) {
        this.i.at = +v;
    }
    get maximumValue() {
        return this.i.as;
    }
    set maximumValue(v) {
        this.i.as = +v;
    }
    get logarithmBase() {
        return this.i.aq;
    }
    set logarithmBase(v) {
        this.i.aq = +v;
    }
    get useLogarithmicScale() {
        return this.i.x;
    }
    set useLogarithmicScale(v) {
        this.i.x = ensureBool(v);
    }
    get useWebWorkers() {
        return this.i.y;
    }
    set useWebWorkers(v) {
        this.i.y = ensureBool(v);
    }
    get webWorkerScriptPath() {
        return this.i.bi;
    }
    set webWorkerScriptPath(v) {
        this.i.bi = v;
    }
    get webWorkerInstance() {
        return this.i.az;
    }
    set webWorkerInstance(v) {
        this.i.az = v;
    }
    findByName(name) {
        return null;
    }
    destroy() {
        this.i.bo();
    }
    getTile(z, x, y, onCreated, onCreating, zoomChanging, existingImage) {
        this.i.getTile(z, x, y, onCreated, onCreating, zoomChanging, existingImage);
    }
    cancelTile(z, x, y) {
        this.i.cancelTile(z, x, y);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrShapeDataSourceModule {
    static register() {
        TypeRegistrar.registerCons('IgrShapeDataSource', IgrShapeDataSource);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrHeatTileGeneratorModule {
    static register() {
        TypeRegistrar.registerCons('IgrHeatTileGenerator', IgrHeatTileGenerator);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HeatTileGeneratorWebWorker = /*@__PURE__*/ (() => {
    class HeatTileGeneratorWebWorker extends Base {
        static get postmessage() {
            return HeatTileGeneratorWebWorker._postmessage;
        }
        static set postmessage(a) {
            HeatTileGeneratorWebWorker._postmessage = a;
        }
        static onmessage(args_) {
            let data_ = args_.data;
            let a = (data_.cancelTile);
            let b = (data_.z);
            let c = (data_.y);
            let d = (data_.x);
            if (a) {
                for (let i_ = 0; i_ < HeatTileGeneratorWebWorker.b.length; i_++) {
                    let e = HeatTileGeneratorWebWorker.b[i_];
                    if (e.g.testRun) {
                        continue;
                    }
                    if (e.g.z == b && e.g.x == d && e.g.y == c) {
                        let workers_ = HeatTileGeneratorWebWorker.b;
                        workers_.splice(i_, 1);
                        i_--;
                    }
                }
            }
            let f = new TileWorkSettings();
            let g = data_;
            if (!g["messageId"]) {
                return;
            }
            if (g["isNewData"]) {
                let yValues_ = g["yValues"];
                let xValues_ = g["xValues"];
                let values_ = g["values"];
                HeatTileGeneratorWebWorker._yValues = (new Float64Array(yValues_));
                HeatTileGeneratorWebWorker._xValues = (new Float64Array(xValues_));
                HeatTileGeneratorWebWorker._values = (new Float64Array(values_));
            }
            let h = g["scaleColors"];
            let i = new Array(h.length);
            for (let j = 0; j < h.length; j++) {
                i[j] = Color.u(typeGetValue(h[j]["a"]), typeGetValue(h[j]["r"]), typeGetValue(h[j]["g"]), typeGetValue(h[j]["b"]));
            }
            f.scaler = HeatTileGeneratorWebWorker.e;
            f.blurRadius = g["blurRadius"];
            f.maxBlurRadius = g["maxBlurRadius"];
            f.useBlurRadiusAdjustedForZoom = (g["useBlurRadiusAdjustedForZoom"]);
            f.minimumColor = Color.u(typeGetValue(g["minimumColor"]["a"]), typeGetValue(g["minimumColor"]["r"]), typeGetValue(g["minimumColor"]["g"]), typeGetValue(g["minimumColor"]["b"]));
            f.maximumColor = Color.u(typeGetValue(g["maximumColor"]["a"]), typeGetValue(g["maximumColor"]["r"]), typeGetValue(g["maximumColor"]["g"]), typeGetValue(g["maximumColor"]["b"]));
            f.tileViewport = new Rect(0, g["tileViewport"]["left"], g["tileViewport"]["top"], g["tileViewport"]["width"], g["tileViewport"]["height"]);
            f.yValues = HeatTileGeneratorWebWorker._yValues;
            f.xValues = HeatTileGeneratorWebWorker._xValues;
            f.values = HeatTileGeneratorWebWorker._values;
            f.minimumVisibleLatitude = g["minimumVisibleLatitude"];
            f.minimumVisibleLongitude = g["minimumVisibleLongitude"];
            f.maximumVisibleLatitude = g["maximumVisibleLatitude"];
            f.maximumVisibleLongitude = g["maximumVisibleLongitude"];
            f.z = typeGetValue(g["z"]);
            f.x = typeGetValue(g["x"]);
            f.y = typeGetValue(g["y"]);
            f.window = new Rect(0, g["window"]["left"], g["window"]["top"], g["window"]["width"], g["window"]["height"]);
            f.testRun = g["testRun"];
            f.globalMinimum = g["globalMinimum"];
            f.globalMaximum = g["globalMaximum"];
            f.useGlobalMinMax = g["useGlobalMinMax"];
            f.minimumValue = g["minimumValue"];
            f.maximumValue = g["maximumValue"];
            f.scaleColorOffsets = g["scaleColorOffsets"];
            f.scaleColors = i;
            f.useLogarithmicScale = g["useLogarithmicScale"];
            f.logarithmBase = g["logarithmBase"];
            let k = new HeatTileGeneratorWorker(f);
            k.u = typeGetValue(g["messageId"]);
            k.h = true;
            k.completedSink = new CompletedSinkImpl(k);
            let workersl_ = HeatTileGeneratorWebWorker.b;
            let worker_ = k;
            workersl_.push(worker_);
        }
        static start() {
            let workers_ = HeatTileGeneratorWebWorker.b;
            setInterval(function () {
                if (workers_.length > 0) {
                    var worker = workers_.shift();
                    worker.doWork();
                    worker.completedSink = null;
                }
            }, 16);
            ;
        }
    }
    HeatTileGeneratorWebWorker.$t = /*@__PURE__*/ markType(HeatTileGeneratorWebWorker, 'HeatTileGeneratorWebWorker');
    HeatTileGeneratorWebWorker.e = /*@__PURE__*/ new HeatTileScaler();
    HeatTileGeneratorWebWorker.b = [];
    HeatTileGeneratorWebWorker._postmessage = null;
    HeatTileGeneratorWebWorker._yValues = null;
    HeatTileGeneratorWebWorker._xValues = null;
    HeatTileGeneratorWebWorker._values = null;
    return HeatTileGeneratorWebWorker;
})();
/**
 * @hidden
 */
let CompletedSinkImpl = /*@__PURE__*/ (() => {
    class CompletedSinkImpl extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        onCompleted(a) {
            let b = a;
            let c = {};
            let imageData_ = b.imageData;
            c["messageId"] = this.a.u;
            c["imageData"] = (b.imageData == null ? null : (new Uint8ClampedArray(imageData_))["buffer"]);
            c["z"] = b.z;
            c["x"] = b.x;
            c["y"] = b.y;
            c["url"] = b.url;
            c["globalMinimumValue"] = b.globalMinimumValue;
            c["globalMaximumValue"] = b.globalMaximumValue;
            c["globalMaximumValueLongitude"] = b.globalMaximumValueLongitude;
            c["globalMaximumValueLatitude"] = b.globalMaximumValueLatitude;
            c["globalMinimumValueLongitude"] = b.globalMinimumValueLongitude;
            c["globalMinimumValueLatitude"] = b.globalMinimumValueLatitude;
            if (this.a.h && c["imageData"] != null) {
                HeatTileGeneratorWebWorker.postmessage(c, [c["imageData"]]);
            }
            else {
                HeatTileGeneratorWebWorker.postmessage(c);
            }
        }
    }
    CompletedSinkImpl.$t = /*@__PURE__*/ markType(CompletedSinkImpl, 'CompletedSinkImpl', Base.$, [ITileWorkCompletedSink_$type]);
    return CompletedSinkImpl;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Image = /*@__PURE__*/ (() => {
    class Image extends FrameworkElement {
        constructor() {
            super(...arguments);
            this.ac = null;
            this.ab = false;
        }
    }
    Image.$t = /*@__PURE__*/ markType(Image, 'Image', FrameworkElement.$);
    return Image;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tile = /*@__PURE__*/ (() => {
    class Tile extends Base {
        constructor() {
            super(...arguments);
            this.d = 0;
            this.e = 0;
            this.f = 0;
            this.c = 0;
            this.i = null;
            this.h = null;
            this.b = new Date();
            this.a = false;
            this.g = null;
        }
        get j() {
            let a = Math.pow(2, -this.f);
            let b = Math.pow(2, -this.f);
            return new Rect(0, this.d * a, this.e * b, a, b);
        }
    }
    Tile.$t = /*@__PURE__*/ markType(Tile, 'Tile');
    return Tile;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WriteableBitmap = /*@__PURE__*/ (() => {
    class WriteableBitmap extends Base {
        constructor(a, b) {
            super();
            this.b = 0;
            this.a = 0;
            this.c = null;
            this.d = null;
            this.b = a;
            this.a = b;
            this.d = Rect.empty;
        }
    }
    WriteableBitmap.$t = /*@__PURE__*/ markType(WriteableBitmap, 'WriteableBitmap');
    return WriteableBitmap;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancellingMultiScaleImageEventArgs = /*@__PURE__*/ (() => {
    class CancellingMultiScaleImageEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._uri = null;
            this._image = null;
        }
        get uri() {
            return this._uri;
        }
        set uri(a) {
            this._uri = a;
        }
        get image() {
            return this._image;
        }
        set image(a) {
            this._image = a;
        }
    }
    CancellingMultiScaleImageEventArgs.$t = /*@__PURE__*/ markType(CancellingMultiScaleImageEventArgs, 'CancellingMultiScaleImageEventArgs', EventArgs.$);
    return CancellingMultiScaleImageEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IEasingFunction_$type = /*@__PURE__*/ new Type(null, 'IEasingFunction');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TilePositionComparer = /*@__PURE__*/ (() => {
    class TilePositionComparer extends Base {
        equalsC(a, b) {
            return a.d == b.d && a.e == b.e && a.f == b.f;
        }
        getHashCodeC(a) {
            let b = 23;
            b = b * 31 + a.d;
            b = b * 31 + a.e;
            b = b * 31 + a.f;
            return b;
        }
    }
    TilePositionComparer.$t = /*@__PURE__*/ markType(TilePositionComparer, 'TilePositionComparer', Base.$, [/*@__PURE__*/ IEqualityComparer$1_$type.specialize(Tile.$)]);
    return TilePositionComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XamMultiScaleImageView = /*@__PURE__*/ (() => {
    class XamMultiScaleImageView extends Base {
        constructor(a) {
            super();
            this.b = null;
            this.h = null;
            this.g = new Dictionary$2(Base.$, List$1.$.specialize(Delegate_$type), 0);
            this.j = new List$1(Tile.$, 0);
            this.i = new List$1(Tile.$, 0);
            this.p = -1;
            this.o = -1;
            this.k = null;
            this.m = null;
            this.c = null;
            this._isDirty = false;
            this.au = Rect.empty;
            this.l = null;
            this.b = a;
            this.b.ag.l(this);
            this.h = new List$1(Image.$, 0);
            this.b.ap = ((() => {
                let $ret = new StackPool$1(Image.$);
                $ret.j = runOn(this, this.at);
                $ret.b = runOn(this, this.y);
                $ret.c = runOn(this, this.aa);
                $ret.d = runOn(this, this.z);
                return $ret;
            })());
            for (let b = 0; b < 4; ++b) {
                this.i.add(null);
            }
        }
        at() {
            return new Image();
        }
        y(a) {
            this.h.add(a);
        }
        aa(a) {
            this.h.remove(a);
        }
        z(a) {
        }
        ao(a, b, c) {
            a.n = b;
            a.o = c;
        }
        r(a) {
            for (let b = 0; b < this.i.count; ++b) {
                if (a == this.i._inner[b]) {
                    if (a.i != null && a.i.ac != null) {
                        let c = a.i.ac;
                        let d = c.c;
                        let e = this.b.ao.w(a.f + 8, a.d, a.e);
                        if (e != null) {
                            let f = ((() => {
                                let $ret = new CancellingMultiScaleImageEventArgs();
                                $ret.uri = e.value;
                                $ret.image = d;
                                return $ret;
                            })());
                            this.b.bu(f);
                        }
                        if (this.g.containsKey(d)) {
                            let g = this.g.item(d);
                            for (let h = 0; h < g.count; h++) {
                                g._inner[h]();
                            }
                            g.clear();
                            this.g.removeItem(d);
                        }
                    }
                    this.i._inner[b] = null;
                    this.q();
                    return;
                }
            }
            for (let i = 0; i < this.j.count; ++i) {
                if (this.j._inner[i] == a) {
                    this.j.removeAt(i);
                    break;
                }
            }
        }
        u(a) {
            this.j.add(a);
            this.j.aa((b, c) => {
                let d = 0;
                let e = 0;
                if (b.h != null) {
                    d = b.h.ac.b;
                }
                if (c.h != null) {
                    e = c.h.ac.b;
                }
                if (d < e) {
                    return -1;
                }
                else if (d > e) {
                    return 1;
                }
                return 0;
            });
            this.q();
        }
        q() {
            let index_ = -1;
            if (this.l == null) {
                return;
            }
            if (this.j.count > 0) {
                for (let a = 0; a < this.i.count; ++a) {
                    if (this.i._inner[a] == null) {
                        index_ = a;
                        break;
                    }
                }
            }
            if (index_ >= 0) {
                this.i._inner[index_] = this.j._inner[0];
                let b = new WriteableBitmap(this.b.ao.r, this.b.ao.p);
                this.i._inner[index_].i.ac = b;
                let ele_ = this.l.createElement("img");
                let c = ele_.getNativeElement();
                b.c = c;
                let self_ = this;
                let d = new List$1(Delegate_$type, 0);
                this.g.addItem(c, d);
                d.add(ele_.listen("load", (e) => this.ab(e, index_)));
                d.add(ele_.listen("readystatechange", (e) => this.ab(e, index_)));
                d.add(ele_.listen("error", (e) => this.ac(e, index_)));
                this.j.removeAt(0);
                let e = this.b.ao.w(this.i._inner[index_].f + 8, this.i._inner[index_].d, this.i._inner[index_].e);
                if (e == null) {
                    return;
                }
                let f = e.value;
                let g = ((() => {
                    let $ret = new DownloadingMultiScaleImageEventArgs();
                    $ret.uri = f;
                    $ret.image = c;
                    return $ret;
                })());
                this.b.bv(g);
                f = g.uri;
                if (f != null) {
                    c.src = f;
                }
            }
        }
        ab(a, b) {
            let e_ = a.originalEvent;
            let img_ = (e_.target);
            let c = (img_.complete || (img_.readyState == 'complete' && e_.type == 'readystatechange'));
            if (c) {
                this.downloadCompleted(a, b);
            }
        }
        ac(a, b) {
            this.downloadError(a, b);
        }
        downloadError(a, b) {
            let c = this.i._inner[b];
            this.i._inner[b] = null;
            if (c != null && c.i != null && c.i.ac != null) {
                let e_ = a.originalEvent;
                let d = (e_.target);
                if (this.g.containsKey(d)) {
                    let e = this.g.item(d);
                    for (let f = 0; f < e.count; f++) {
                        e._inner[f]();
                    }
                    e.clear();
                    this.g.removeItem(d);
                }
            }
            this.q();
            this.ad();
        }
        downloadCompleted(a, b) {
            let c = this.i._inner[b];
            let d = true;
            if (c != null && c.i != null && c.i.ac != null) {
                d = false;
                let ele_ = c.i.ac.c;
                if (!ele_.complete) {
                    d = true;
                }
                if ((ele_.width == 0 && ele_.height == 0)) {
                    d = true;
                }
            }
            this.i._inner[b] = null;
            if (d) {
                this.q();
                this.ad();
                return;
            }
            let e_ = a.originalEvent;
            let e = (e_.target);
            if (this.g.containsKey(e)) {
                let f = this.g.item(e);
                for (let g = 0; g < f.count; g++) {
                    f._inner[g]();
                }
                f.clear();
                this.g.removeItem(e);
            }
            this.b.bo(c, c.i.ac);
            if (c.i != null) {
                this.b.ca(c);
            }
            this.q();
            this.ad();
        }
        a(a, b, c, d) {
            let e = new WriteableBitmap(a, a);
            e.c = b.c;
            if (!b.d.isEmpty) {
                c += truncate(Math.round(b.d.left));
                d += truncate(Math.round(b.d.top));
            }
            e.d = new Rect(0, c, d, a, a);
            return e;
        }
        am(a) {
            a.s = 0;
        }
        an(a) {
            a.s = 1;
        }
        f() {
            return true;
        }
        s(a) {
            if (this.b.al != null) {
                this.b.al.deferredRefresh();
            }
            else {
                if (this.k != null) {
                    this.k.setTimeout(a, 0);
                }
                else {
                    window.setTimeout(a, 0);
                }
            }
        }
        aq() {
            if (this.p == -1) {
                this.p = window.setInterval(runOn(this.b, this.b.b9), 50);
            }
        }
        as() {
            if (this.p != -1) {
                window.clearInterval(this.p);
                this.p = -1;
            }
        }
        ap() {
            if (this.o == -1) {
                this.o = window.setInterval(runOn(this.b, this.b.br), 50);
            }
        }
        ar() {
            if (this.o != -1) {
                window.clearInterval(this.o);
                this.o = -1;
            }
        }
        t() {
            if (this.p != -1) {
                this.ar();
                this.b.by();
            }
        }
        ae(a) {
            this.k = a;
            this.k.rootWrapper.setStyleProperty("position", "relative");
            this.m = this.k.createElement("canvas");
            this.m.setStyleProperty("position", "absolute");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.k.append(this.m);
            this.c = new RenderingContext(new CanvasViewRenderer(), this.k.get2DCanvasContext(this.m));
            this.af(this.k.rootWrapper.width(), this.k.rootWrapper.height());
        }
        af(a, b) {
            this.m.setAttribute("width", truncate((a * this.b.a4)).toString());
            this.m.setAttribute("height", truncate((b * this.b.a4)).toString());
            this.m.setStyleProperty("width", a.toString() + "px");
            this.m.setStyleProperty("height", b.toString() + "px");
            this.b.cn = new Rect(0, 0, 0, a, b);
            this.b.b5();
        }
        aj() {
            this.ad();
        }
        get index() {
            return 0;
        }
        postRender() {
        }
        get isDirty() {
            return this._isDirty;
        }
        set isDirty(a) {
            this._isDirty = a;
        }
        ad() {
            if (this.c == null) {
                return;
            }
            if (!this.isDirty) {
                this.isDirty = true;
                this.b.ag.n();
            }
        }
        undirty(a) {
            this.isDirty = false;
            this.ak();
        }
        ak() {
            if (this.c == null) {
                return;
            }
            if (this.c.d && this.b.a4 != 1) {
                this.c.z();
                this.c.aa(this.b.a4, this.b.a4);
            }
            if (!this.au.isEmpty) {
                this.c.k(this.au.left, this.au.top, this.au.width, this.au.height);
            }
            this.au = this.b.cn;
            for (let a = 0; a < this.h.count; a++) {
                let b = this.h._inner[a];
                if (b.s == 0) {
                    this.al(b);
                }
            }
            for (let c = 0; c < this.h.count; c++) {
                let d = this.h._inner[c];
                if (d.s == 1) {
                    this.al(d);
                }
            }
            if (this.c.d && this.b.a4 != 1) {
                this.c.y();
            }
            this.b.bt();
            this.b.bw();
        }
        d() {
            let a = true;
            for (let b = 0; b < this.i.count; b++) {
                if (this.i._inner[b] != null) {
                    a = false;
                }
            }
            return a;
        }
        al(a) {
            if (this.c == null) {
                return;
            }
            let b = a.ac;
            let c = a._opacity * this.b._opacity;
            if (b == null || b.c == null) {
                return;
            }
            if (this.e(b.c)) {
                return;
            }
            if (!b.d.isEmpty) {
                if (b.d.width < 1 || b.d.height < 1) {
                    return;
                }
                this.c.n(b.c, c, b.d.left, b.d.top, b.d.width, b.d.height, Math.round(a.n + this.b.cn.left), Math.round(a.o + this.b.cn.top), a.width, a.height);
            }
            else {
                this.c.m(b.c, c, Math.round(a.n + this.b.cn.left), Math.round(a.o + this.b.cn.top), a.width, a.height);
            }
        }
        e(a) {
            let img_ = a;
            if (!img_.complete) {
                return true;
            }
            if ((img_.width == 0 && img_.height == 0)) {
                return true;
            }
            return false;
        }
        x() {
            this.ad();
        }
        ag(a) {
            this.c = a;
            this.ad();
        }
        ah(a) {
            this.l = a;
            this.q();
        }
        ai(a) {
            this.b.cn = a;
            this.b.b5();
        }
        preRender() {
        }
        isValid() {
            return true;
        }
    }
    XamMultiScaleImageView.$t = /*@__PURE__*/ markType(XamMultiScaleImageView, 'XamMultiScaleImageView', Base.$, [ISchedulableRender_$type]);
    return XamMultiScaleImageView;
})();
/**
 * @hidden
 */
let XamMultiScaleTileSource = /*@__PURE__*/ (() => {
    class XamMultiScaleTileSource extends DependencyObject {
        constructor(a, b, c, d, e) {
            super();
            this.t = 0;
            this.s = 0;
            this.n = 1;
            this.l = false;
            this.r = 0;
            this.p = 0;
            this.q = 0;
            this.j = null;
            this.t = a;
            this.s = b;
            this.r = c;
            this.p = d;
            this.q = e;
        }
        get v() {
            return this.t;
        }
        set v(a) {
            this.t = a;
            this.y(0, 0, 0, 0);
        }
        get u() {
            return this.s;
        }
        set u(a) {
            this.s = a;
            this.y(0, 0, 0, 0);
        }
        get o() {
            return this.n;
        }
        set o(a) {
            this.n = a;
            if (this.k != null) {
                this.k._opacity = this.n;
            }
        }
        get m() {
            return this.l;
        }
        set m(a) {
            this.l = a;
            if (this.k != null) {
                this.k.av = this.l;
            }
        }
        get k() {
            return this.j;
        }
        set k(a) {
            this.j = a;
            if (this.j != null) {
                this.j._opacity = this.o;
            }
        }
        w(a, b, c) {
            let d = new List$1(Base.$, 0);
            this.x(a, b, c, d);
            let e = null;
            if (d.count > 0) {
                e = typeCast(Uri.$, d._inner[0]);
            }
            return e;
        }
        y(a, b, c, d) {
            if (this.k != null) {
                this.k.bs(a, b, c, d);
            }
        }
    }
    XamMultiScaleTileSource.$t = /*@__PURE__*/ markType(XamMultiScaleTileSource, 'XamMultiScaleTileSource', DependencyObject.$);
    return XamMultiScaleTileSource;
})();
/**
 * @hidden
 */
let XamMultiScaleImage = /*@__PURE__*/ (() => {
    class XamMultiScaleImage extends Control {
        constructor() {
            super();
            this.ap = null;
            this.an = null;
            this.ak = null;
            this.ck = null;
            this.a2 = 0;
            this.at = false;
            this.propertyChanged = null;
            this.ba = 0;
            this.bb = 0;
            this.a0 = new Date();
            this.cl = null;
            this.a3 = 0;
            this.ay = new List$1(Tile.$, 0);
            this.aw = false;
            this.aq = new LRUCache$2(Tile.$, WriteableBitmap.$, 1, 0x7FFFFFFF, new TilePositionComparer());
            this.az = new List$1(Tile.$, 0);
            this.imageTilesReady = null;
            this.as = false;
            this.cn = null;
            this.ag = null;
            this.imagesChanged = null;
            this.downloadingImage = null;
            this.cancellingImage = null;
            this.a1 = 1;
            this.cn = Rect.empty;
            this.ag = new CanvasRenderScheduler();
            this.an = new XamMultiScaleImageView(this);
            this.ab = XamMultiScaleImage.$;
            this.ck = this.cm;
            this.a2 = this.a5;
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            if (this.ak != null) {
                this.ak.unRegister(this);
            }
            this.ak = a;
            if (this.ak != null) {
                this.ak.register(this, runOn(this, this.b6));
            }
        }
        bc() {
            if (!stringIsNullOrEmpty(this.bf)) {
                return this.bf;
            }
            return null;
        }
        bd() {
            if (!stringIsNullOrEmpty(this.bj)) {
                return this.bj;
            }
            return null;
        }
        bx(a, b, c) {
            let d = new PropertyChangedEventArgs(a);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, d);
            }
            switch (a) {
                case XamMultiScaleImage.$$p[2]:
                    if (this.ao != null) {
                        this.ao.k = this;
                    }
                    this.b4();
                    this.b7();
                    this.b5();
                    break;
                case XamMultiScaleImage.$$p[6]:
                    this.b8();
                    break;
                case XamMultiScaleImage.$$p[7]:
                    this.b8();
                    break;
                case XamMultiScaleImage.$$p[5]:
                    if (!this.ax) {
                        this.an.t();
                    }
                    break;
                case XamMultiScaleImage.$$p[0]:
                    this.at = this.av;
                    this.b5();
                    break;
            }
        }
        v() {
            super.v();
            this.b5();
        }
        b7() {
            this.cb();
            if (this.ao != null) {
                this.ba = Convert.toInt32(logBase(this.ao.r, 2));
                this.bb = Convert.toInt32(logBase(this.ao.v, 2));
            }
        }
        bs(a, b, c, d) {
            this.b4();
            this.b7();
            this.b5();
        }
        b8() {
            if (this.ax) {
                this.a0 = dateNow();
                this.cl = this.ck;
                this.a3 = this.a2;
                this.an.aq();
            }
            else {
                this.ck = this.cm;
                this.a2 = this.a5;
                this.b5();
            }
        }
        b9() {
            let a = 2;
            let b = dateNow().getTime() - this.a0.getTime();
            let c = b / 1000;
            let d = MathUtil.b((c) / a, 0, 1);
            let e = this.aj != null ? this.aj.ease(d) : d;
            let f = 1 - e;
            this.a2 = this.a3 * f + this.a5 * e;
            this.ck = { $type: Point_$type, x: this.cl.x * f + this.cm.x * e, y: this.cl.y * f + this.cm.y * e };
            if (d >= 1) {
                this.an.as();
            }
            else {
            }
            this.b5();
        }
        a8(a, b, c, d) {
            for (let e = 0; e < this.ay.count; ++e) {
                if (this.ay._inner[e].c == a && this.ay._inner[e].d == b && this.ay._inner[e].e == c && this.ay._inner[e].f == d) {
                    return e;
                }
            }
            return -1;
        }
        b6(a) {
            this.aw = false;
            this.as = false;
            let b = this.at;
            if (this.ao == null || !this.an.f() || this.cn.width == 0 || this.cn.height == 0) {
                return;
            }
            let c = truncate(Math.ceil(this.cn.width / this.ao.r));
            let d = truncate(Math.max(1, Math.floor(-logBase(this.a2 / c, 2))));
            if (d >= this.bb - 8) {
                d = (this.bb - 8) - 1;
            }
            let e = truncate(Math.round(Math.pow(2, d)));
            let f = this.a2;
            let g = this.cn.height * f / this.cn.width;
            let h = this.ao.v / Math.pow(2, d);
            let i = this.ao.u / Math.pow(2, d);
            let j = truncate(Math.floor((this.ck.x * this.ao.v) / h));
            let k = truncate(Math.ceil(((this.ck.x + f) * this.ao.v) / h));
            let l = truncate(Math.floor((this.ck.y * this.ao.u) / i));
            let m = truncate(Math.ceil(((this.ck.y + g) * this.ao.v) / i));
            if (!b) {
                j = Math.max(j, 0);
                k = Math.min(k, e);
            }
            l = Math.max(l, 0);
            m = Math.min(m, e);
            let n = ((j * h) - (this.ck.x * this.ao.v)) / h;
            let o = ((l * i) - (this.ck.y * this.ao.u)) / i;
            let p = (f * this.ao.v / h) * (this.ao.r / this.cn.width);
            let q = new List$1(Tile.$, 0);
            let r;
            let s;
            for (let t = j; t < k; ++t) {
                r = t;
                s = t;
                while (s < 0) {
                    s = e + s;
                }
                while (s > e - 1) {
                    s = (s - e);
                }
                for (let u = l; u < m; ++u) {
                    let v = this.a8(r, s, u, d);
                    if (v >= 0) {
                        q.add(this.ay._inner[v]);
                        this.ay.removeAt(v);
                    }
                    else {
                        q.add(((() => {
                            let $ret = new Tile();
                            $ret.c = r;
                            $ret.d = s;
                            $ret.e = u;
                            $ret.f = d;
                            return $ret;
                        })()));
                    }
                }
            }
            this.ap.f = true;
            this.cb();
            this.ay = q;
            for (let w = 0; w < this.ay.count; ++w) {
                if (this.ay._inner[w].i == null) {
                    this.ay._inner[w].i = this.ap.a();
                    this.ay._inner[w].i._opacity = 1;
                    this.an.am(this.ay._inner[w].i);
                    let x = this.am(this.ay._inner[w]);
                    if (x != null) {
                        this.ay._inner[w].i.ac = x;
                    }
                    else {
                        let y = null;
                        let z = ((() => {
                            let $ret = new Tile();
                            $ret.d = this.ay._inner[w].d;
                            $ret.e = this.ay._inner[w].e;
                            $ret.f = this.ay._inner[w].f;
                            return $ret;
                        })());
                        while (z.f >= 0 && y == null) {
                            z.d = z.d >> 1;
                            z.e = z.e >> 1;
                            z.f = z.f - 1;
                            y = this.am(z);
                        }
                        if (y != null) {
                            let aa = truncate(Math.pow(2, this.ay._inner[w].f - z.f));
                            let ab = intDivide(256, aa);
                            let ac = ab * (this.ay._inner[w].d % aa);
                            let ad = ab * (this.ay._inner[w].e % aa);
                            this.ay._inner[w].h = this.ap.a();
                            this.ay._inner[w].h._opacity = 1;
                            this.an.an(this.ay._inner[w].h);
                            x = this.an.a(ab, y, ac, ad);
                            this.ay._inner[w].h.ac = x;
                        }
                        this.an.u(this.ay._inner[w]);
                    }
                }
                let ae = this.ao.r / p;
                let af = this.ao.p / p;
                let ag = (this.ay._inner[w].c - j + n) * ae;
                let ah = (this.ay._inner[w].e - l + o) * af;
                this.ay._inner[w].i.width = ae + 0.5;
                this.ay._inner[w].i.height = af + 0.5;
                this.an.ao(this.ay._inner[w].i, ag, ah);
                if (this.ay._inner[w].h != null) {
                    this.ay._inner[w].h.width = ae + 0.5;
                    this.ay._inner[w].h.height = af + 0.5;
                    this.an.ao(this.ay._inner[w].h, ag, ah);
                }
            }
            this.ap.f = false;
            this.an.aj();
        }
        b5() {
            if (this.ao == null || !this.an.f() || this.cn.width == 0 || this.cn.height == 0) {
                return;
            }
            if (this.aw) {
                return;
            }
            this.aw = true;
            this.an.s(runOn(this, this.b6));
        }
        cb() {
            for (let a = 0; a < this.ay.count; ++a) {
                this.an.r(this.ay._inner[a]);
                this.bp(this.ay._inner[a]);
                if (this.ay._inner[a].i != null) {
                    this.ap.n(this.ay._inner[a].i);
                    this.ay._inner[a].i.ac = null;
                    this.ay._inner[a].i = null;
                }
            }
        }
        b4() {
            this.ar.i();
        }
        am(a) {
            return this.ar.item(a);
        }
        bo(a, b) {
            this.ar.item(a, b);
        }
        get ar() {
            return this.aq;
        }
        set ar(a) {
            this.aq = a;
        }
        au() {
            return this.az.count != 0;
        }
        bt() {
            let a = true;
            if (this.au()) {
                a = false;
            }
            if (!this.an.d()) {
                a = false;
            }
            if (a && !this.as) {
                if (this.imageTilesReady != null) {
                    this.imageTilesReady(this, new EventArgs());
                }
            }
            this.as = a;
        }
        ca(a) {
            if (a.h != null) {
                a.b = dateNow();
                this.az.add(a);
                this.an.ap();
            }
            else {
                this.bt();
            }
        }
        bp(a) {
            if (a.h != null) {
                this.ap.n(a.h);
                a.h.ac = null;
                a.h = null;
                for (let b = 0; b < this.az.count; ++b) {
                    if (this.az._inner[b] == a) {
                        this.az.removeAt(b);
                        break;
                    }
                }
                if (this.az.count == 0) {
                    this.an.ar();
                }
            }
        }
        br() {
            let a = dateNow();
            let b = 0.5;
            for (let c = 0; c < this.az.count;) {
                let d = a.getTime() - this.az._inner[c].b.getTime();
                let e = d / 1000;
                let f = (e) / b;
                f = MathUtil.b(f, 0, 1);
                this.az._inner[c].h._opacity = 1 - f;
                if (f >= 1) {
                    this.ap.n(this.az._inner[c].h);
                    this.az._inner[c].h.ac = null;
                    this.az._inner[c].h = null;
                    this.az.removeAt(c);
                }
                else {
                    ++c;
                }
                this.an.x();
            }
            if (this.az.count == 0) {
                this.an.ar();
            }
        }
        by() {
            this.a2 = this.a5;
            this.ck = this.cm;
            this.b5();
        }
        b0(a) {
            let b = a;
            this.ag.j(b);
            this.an.ae(a);
        }
        b1(a) {
            this.an.ag(a);
        }
        b2(a) {
            this.an.ah(a);
        }
        b3(a) {
            this.an.ai(a);
        }
        bw() {
            if (this.imagesChanged != null) {
                this.imagesChanged(this, new EventArgs());
            }
        }
        bq() {
            this.aw = false;
        }
        bv(a) {
            if (this.downloadingImage != null) {
                this.downloadingImage(this, a);
            }
        }
        bu(a) {
            if (this.cancellingImage != null) {
                this.cancellingImage(this, a);
            }
        }
        get a4() {
            return this.a1;
        }
        bz(a) {
            this.a1 = a;
        }
        get a9() {
            return this.ar.h;
        }
        set a9(a) {
            let b = a != this.a9;
            if (b) {
                this.ar = new LRUCache$2(Tile.$, WriteableBitmap.$, 1, a, new TilePositionComparer());
            }
        }
    }
    XamMultiScaleImage.$t = /*@__PURE__*/ markType(XamMultiScaleImage, 'XamMultiScaleImage', Control.$, [INotifyPropertyChanged_$type]);
    XamMultiScaleImage.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, XamMultiScaleImage, 'bx', ['IsHorizontalTileWrappingEnabled:av:cc', [0, false], 'Referer:bf:cd', [2, null], 'Source:ao:ce', [XamMultiScaleTileSource.$, null], 'SpringsEasingFunction:aj:cf', [IEasingFunction_$type, null], 'UserAgent:bj:cg', [2, null], 'UseSprings:ax:ch', [0, false], 'ViewportOrigin:cm:ci', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ViewportWidth:a5:cj', [1, 1]]);
    return XamMultiScaleImage;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MapTileSource = /*@__PURE__*/ (() => {
    class MapTileSource extends XamMultiScaleTileSource {
        constructor(a, b, c, d, e) {
            super(a, b, c, d, e);
        }
    }
    MapTileSource.$t = /*@__PURE__*/ markType(MapTileSource, 'MapTileSource', XamMultiScaleTileSource.$);
    return MapTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcGISOnlineTileSource = /*@__PURE__*/ (() => {
    class ArcGISOnlineTileSource extends MapTileSource {
        constructor() {
            super(2097152, 2097152, 256, 256, 0);
        }
        get mapServerUri() {
            return this.c(ArcGISOnlineTileSource.mapServerUriProperty);
        }
        set mapServerUri(a) {
            this.h(ArcGISOnlineTileSource.mapServerUriProperty, a);
        }
        get isMapPublic() {
            return this.c(ArcGISOnlineTileSource.isMapPublicProperty);
        }
        set isMapPublic(a) {
            this.h(ArcGISOnlineTileSource.isMapPublicProperty, a);
        }
        get levelOfDetail() {
            return typeGetValue(this.c(ArcGISOnlineTileSource.levelOfDetailProperty));
        }
        set levelOfDetail(a) {
            this.h(ArcGISOnlineTileSource.levelOfDetailProperty, a);
        }
        get userToken() {
            return this.c(ArcGISOnlineTileSource.userTokenProperty);
        }
        set userToken(a) {
            this.h(ArcGISOnlineTileSource.userTokenProperty, a);
        }
        x(a, b, c, d) {
            let e = this.mapServerUri + "/tile/{0}/{1}/{2}";
            let f = "";
            if (stringIsNullOrEmpty(this.mapServerUri) || this.levelOfDetail < 1 || !Uri.isWellFormedUriString(this.mapServerUri, 1)) {
                return;
            }
            if (!this.isMapPublic) {
                if (!stringIsNullOrEmpty(this.userToken)) {
                    e += "?token={3}";
                    f = this.userToken.trim();
                }
                else {
                    return;
                }
            }
            let g = a - 8;
            if (g > 0) {
                let h = stringFormat1(e, g, c, b, f);
                d.add(new Uri(0, h));
            }
        }
        static ad(a, b) {
            let c = a;
            if (b.f == ArcGISOnlineTileSource.mapServerUriProperty) {
                if (c.mapServerUri != typeCast(String_$type, b.newValue)) {
                    c.mapServerUri = typeCast(String_$type, b.newValue);
                }
                c.y(0, 0, 0, 0);
            }
            if (b.f == ArcGISOnlineTileSource.userTokenProperty) {
                if (c.userToken != typeCast(String_$type, b.newValue)) {
                    c.userToken = typeCast(String_$type, b.newValue);
                }
                c.y(0, 0, 0, 0);
            }
            if (b.f == ArcGISOnlineTileSource.levelOfDetailProperty) {
                c.v = truncate((Math.pow(2, c.levelOfDetail - 1) * 256));
                c.u = truncate((Math.pow(2, c.levelOfDetail - 1) * 256));
            }
            if (b.f == ArcGISOnlineTileSource.isMapPublicProperty) {
                c.y(0, 0, 0, 0);
            }
        }
    }
    ArcGISOnlineTileSource.$t = /*@__PURE__*/ markType(ArcGISOnlineTileSource, 'ArcGISOnlineTileSource', MapTileSource.$);
    ArcGISOnlineTileSource.mapServerUriProperty = /*@__PURE__*/ DependencyProperty.i("MapServerUri", String_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, ArcGISOnlineTileSource.ad));
    ArcGISOnlineTileSource.isMapPublicProperty = /*@__PURE__*/ DependencyProperty.i("IsMapPublic", Boolean_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, true, ArcGISOnlineTileSource.ad));
    ArcGISOnlineTileSource.levelOfDetailProperty = /*@__PURE__*/ DependencyProperty.i("LevelOfDetail", Number_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, -1, ArcGISOnlineTileSource.ad));
    ArcGISOnlineTileSource.userTokenProperty = /*@__PURE__*/ DependencyProperty.i("UserToken", String_$type, ArcGISOnlineTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, ArcGISOnlineTileSource.ad));
    return ArcGISOnlineTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BingMapsTileSource = /*@__PURE__*/ (() => {
    class BingMapsTileSource extends MapTileSource {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(256 << 22, 256 << 22, 256, 256, 0);
                        this.ab = null;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        {
                            super(256 << 22, 256 << 22, 256, 256, 0);
                            this.ab = null;
                        }
                        this.tilePath = c;
                        this.subDomains = d;
                    }
                    break;
            }
        }
        get tilePath() {
            return this.c(BingMapsTileSource.tilePathProperty);
        }
        set tilePath(a) {
            this.h(BingMapsTileSource.tilePathProperty, a);
        }
        get subDomains() {
            return this.c(BingMapsTileSource.subDomainsProperty);
        }
        set subDomains(a) {
            this.h(BingMapsTileSource.subDomainsProperty, a);
        }
        ag(a, b) {
            this.y(0, 0, 0, 0);
        }
        get cultureName() {
            return this.c(BingMapsTileSource.cultureNameProperty);
        }
        set cultureName(a) {
            this.h(BingMapsTileSource.cultureNameProperty, a);
        }
        x(a, b, c, d) {
            if (!this.z()) {
                d.clear();
                return;
            }
            if (stringIsNullOrEmpty(this.tilePath)) {
                return;
            }
            a -= 8;
            if (a > 0) {
                let e = this.ad(a, b, c);
                let f = this.tilePath;
                f = stringReplace(f, "{culture}", this.ab);
                f = stringReplace(f, "{quadkey}", e);
                let g = parseInt(e.substr(e.length - 1, 1));
                if (this.subDomains == null || g >= this.subDomains.count) {
                    return;
                }
                f = stringReplace(f, "{subdomain}", this.subDomains._inner[g]);
                f = stringReplace(f, "&token={token}", "");
                d.add(new Uri(0, f));
            }
        }
        z() {
            let a = true;
            return a;
        }
        ad(a, b, c) {
            let d = new StringBuilder(0);
            for (let e = a; e > 0; --e) {
                let f = '0';
                let g = 1 << (e - 1);
                if ((b & g) != 0) {
                    ((() => { let $value = f; f = String.fromCharCode($value.charCodeAt(0) + 1); return $value; })());
                }
                if ((c & g) != 0) {
                    ((() => { let $value = f; f = String.fromCharCode($value.charCodeAt(0) + 1); return $value; })());
                    ((() => { let $value = f; f = String.fromCharCode($value.charCodeAt(0) + 1); return $value; })());
                }
                d.h(f);
            }
            return d.toString();
        }
        static af(a, b) {
            let c = a;
            if ((b.f == BingMapsTileSource.subDomainsProperty) || (b.f == BingMapsTileSource.tilePathProperty) || (b.f == BingMapsTileSource.cultureNameProperty)) {
                if (b.f == BingMapsTileSource.subDomainsProperty) {
                    let d = typeCast(ObservableCollection$1.$.specialize(String_$type), b.oldValue);
                    let e = typeCast(ObservableCollection$1.$.specialize(String_$type), b.newValue);
                    if (d != null) {
                        d.collectionChanged = delegateRemove(d.collectionChanged, runOn(c, c.ag));
                    }
                    if (e != null) {
                        e.collectionChanged = delegateCombine(e.collectionChanged, runOn(c, c.ag));
                    }
                }
                if (b.f == BingMapsTileSource.cultureNameProperty) {
                    c.ab = b.newValue;
                }
                c.y(0, 0, 0, 0);
            }
        }
    }
    BingMapsTileSource.$t = /*@__PURE__*/ markType(BingMapsTileSource, 'BingMapsTileSource', MapTileSource.$);
    BingMapsTileSource.tilePathProperty = /*@__PURE__*/ DependencyProperty.i("TilePath", String_$type, BingMapsTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, BingMapsTileSource.af));
    BingMapsTileSource.subDomainsProperty = /*@__PURE__*/ DependencyProperty.i("SubDomains", /*@__PURE__*/ ObservableCollection$1.$.specialize(String_$type), BingMapsTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, BingMapsTileSource.af));
    BingMapsTileSource.cultureNameProperty = /*@__PURE__*/ DependencyProperty.i("CultureName", String_$type, BingMapsTileSource.$, /*@__PURE__*/ new PropertyMetadata(2, null, BingMapsTileSource.af));
    return BingMapsTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TileGeneratorTileSource = /*@__PURE__*/ (() => {
    class TileGeneratorTileSource extends MapTileSource {
        constructor() {
            super(134217728, 134217728, 256, 256, 0);
            this.z = "tilegen://tile/{Z}/{X}/{Y}.png";
        }
        x(a, b, c, d) {
            let e = a - 8;
            if (e > 0) {
                let f = "tilegen://tile/" + e + "/" + b + "/" + c + ".png";
                d.add(new Uri(0, f));
            }
        }
    }
    TileGeneratorTileSource.$t = /*@__PURE__*/ markType(TileGeneratorTileSource, 'TileGeneratorTileSource', MapTileSource.$);
    return TileGeneratorTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetTileImageUriArgs = /*@__PURE__*/ (() => {
    class GetTileImageUriArgs extends EventArgs {
        constructor(a, b, c) {
            super();
            this._tileLevel = 0;
            this._tilePositionX = 0;
            this._tilePositionY = 0;
            this._tileImageUri = null;
            this.tileLevel = a;
            this.tilePositionX = b;
            this.tilePositionY = c;
        }
        get tileLevel() {
            return this._tileLevel;
        }
        set tileLevel(a) {
            this._tileLevel = a;
        }
        get tilePositionX() {
            return this._tilePositionX;
        }
        set tilePositionX(a) {
            this._tilePositionX = a;
        }
        get tilePositionY() {
            return this._tilePositionY;
        }
        set tilePositionY(a) {
            this._tilePositionY = a;
        }
        get tileImageUri() {
            return this._tileImageUri;
        }
        set tileImageUri(a) {
            this._tileImageUri = a;
        }
    }
    GetTileImageUriArgs.$t = /*@__PURE__*/ markType(GetTileImageUriArgs, 'GetTileImageUriArgs', EventArgs.$);
    return GetTileImageUriArgs;
})();

/**
 * Event arguments for GetTileImageUri event
*/
class IgrGetTileImageUriArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the tile level.
    */
    get tileLevel() {
        return this.i.tileLevel;
    }
    set tileLevel(v) {
        this.i.tileLevel = +v;
    }
    /**
     * Gets or sets the tile's X position
    */
    get tilePositionX() {
        return this.i.tilePositionX;
    }
    set tilePositionX(v) {
        this.i.tilePositionX = +v;
    }
    /**
     * Gets or sets the tile's Y position
    */
    get tilePositionY() {
        return this.i.tilePositionY;
    }
    set tilePositionY(v) {
        this.i.tilePositionY = +v;
    }
    /**
     * Gets or sets the tile's image URI
    */
    get tileImageUri() {
        return this.i.tileImageUri;
    }
    set tileImageUri(v) {
        this.i.tileImageUri = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CustomMapTileSource = /*@__PURE__*/ (() => {
    class CustomMapTileSource extends MapTileSource {
        constructor(a, b, c, d, e) {
            super(a, b, c, d, e);
            this.getTileImageUri = null;
        }
        x(a, b, c, d) {
            let e = new GetTileImageUriArgs(a, b, c);
            this.aa(e);
            if (e.tileImageUri != null) {
                let f = new Uri(0, e.tileImageUri);
                d.add(f);
            }
        }
        aa(a) {
            if (this.getTileImageUri != null) {
                this.getTileImageUri(this, a);
            }
        }
    }
    CustomMapTileSource.$t = /*@__PURE__*/ markType(CustomMapTileSource, 'CustomMapTileSource', MapTileSource.$);
    return CustomMapTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OpenStreetMapTileSource = /*@__PURE__*/ (() => {
    class OpenStreetMapTileSource extends MapTileSource {
        constructor() {
            super(134217728, 134217728, 256, 256, 0);
            this.z = "tile.openstreetmap.org/{Z}/{X}/{Y}.png";
            this.setTilePathUrl(this.z);
        }
        x(a, b, c, d) {
            let e = a - 8;
            if (e > 0) {
                let f = this.z;
                f = stringReplace(f, "{Z}", e.toString());
                f = stringReplace(f, "{X}", b.toString());
                f = stringReplace(f, "{Y}", c.toString());
                d.add(new Uri(0, f));
            }
        }
        setTilePathUrl(a) {
            if (!stringIsNullOrEmpty(a)) {
                if (stringStartsWith(a, "http://") || stringStartsWith(a, "https://")) {
                    this.z = a;
                }
                else {
                    let b = "http://";
                    b = (('https:' == document.location.protocol ? 'https://' : 'http://'));
                    this.z = b + a;
                }
            }
        }
    }
    OpenStreetMapTileSource.$t = /*@__PURE__*/ markType(OpenStreetMapTileSource, 'OpenStreetMapTileSource', MapTileSource.$);
    return OpenStreetMapTileSource;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IMapRenderDeferralHandler_$type = /*@__PURE__*/ new Type(null, 'IMapRenderDeferralHandler');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Pair$2 = /*@__PURE__*/ (() => {
    class Pair$2 extends Base {
        constructor($t1, $t2, a, b) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.a = null;
            this.b = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$type = this.$type.specialize(this.$t1, this.$t2);
            this.a = a;
            this.b = b;
        }
    }
    Pair$2.$t = /*@__PURE__*/ markType(Pair$2, 'Pair$2');
    return Pair$2;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrCancellingMultiScaleImageEventArgs {
    createImplementation() {
        return new CancellingMultiScaleImageEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get uri() {
        return this.i.uri;
    }
    set uri(v) {
        this.i.uri = v;
    }
}

class IgrTriangulationStatusEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The current status from 0 to 100 of the progressive triangulation.
    */
    get currentStatus() {
        return this.i.currentStatus;
    }
    set currentStatus(v) {
        this.i.currentStatus = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionPlacementPositions_$type = /*@__PURE__*/ markEnum('LabelCollisionPlacementPositions', 'Top,0|Left,1|Right,2|Bottom,3|TopLeft,4|TopRight,5|BottomLeft,6|BottomRight,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionManagerCollisionMode_$type = /*@__PURE__*/ markEnum('LabelCollisionManagerCollisionMode', 'SimulatedAnnealing,0|Greedy,1|GreedyCenterOfMass,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let QuadTreeBoundingBox = /*@__PURE__*/ (() => {
    class QuadTreeBoundingBox extends Base {
        constructor() {
            super();
            this.b = 0;
            this.c = 0;
            this.e = 0;
            this.d = 0;
            this.g = null;
        }
        a(a) {
            if (this.b + this.e < a.b - a.e || this.c + this.d < a.c - a.d || this.b - this.e > a.b + a.e || this.c - this.d > a.c + a.d) {
                return false;
            }
            return true;
        }
        f(a) {
            let b = this.b - this.e;
            let c = this.c - this.d;
            let d = this.b + this.e;
            let e = this.c + this.d;
            let f = a.b - a.e;
            let g = a.c - a.d;
            let h = a.b + a.e;
            let i = a.c + a.d;
            let j = Math.max(b, f);
            let k = Math.min(d, h);
            let l = Math.max(c, g);
            let m = Math.min(e, i);
            return (k - j) * (m - l);
        }
    }
    QuadTreeBoundingBox.$t = /*@__PURE__*/ markType(QuadTreeBoundingBox, 'QuadTreeBoundingBox');
    return QuadTreeBoundingBox;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let QuadTreeForceVector = /*@__PURE__*/ (() => {
    class QuadTreeForceVector extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
    }
    QuadTreeForceVector.$t = /*@__PURE__*/ markType(QuadTreeForceVector, 'QuadTreeForceVector');
    return QuadTreeForceVector;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let QuadTree = /*@__PURE__*/ (() => {
    class QuadTree extends Base {
        constructor(a, b, c, d) {
            super();
            this.b = null;
            this.f = 0;
            this.i = 0;
            this.b = new QuadTreeNode();
            this.b.b = this;
            this.b.c = new QuadTreeBoundingBox();
            let e = Math.max(a, b);
            this.b.c.b = e / 2;
            this.b.c.c = e / 2;
            this.b.c.e = e / 2;
            this.b.c.d = e / 2;
            this.f = d;
            this.i = c;
        }
        c(a) {
            return this.b.i(a);
        }
        d(a) {
            return this.b.k(a);
        }
        e(a) {
            let b = new List$1(QuadTreeNode.$, 0);
            this.b.x(a, b);
            return b;
        }
        j() {
            this.b.w();
        }
        k() {
            this.b.z();
        }
        g() {
            return this.h(this.b, new HashSet$1(QuadTreeBoundingBox.$, 0));
        }
        h(a, b) {
            if (a.j) {
                let c = 0;
                let d = a.l.c;
                while (d != null) {
                    if (!b.contains(d.c)) {
                        c += 1;
                        b.add_1(d.c);
                    }
                    d = d.a;
                }
                return c;
            }
            let e = this.h(a.f, b);
            e += this.h(a.e, b);
            e += this.h(a.h, b);
            e += this.h(a.g, b);
            return e;
        }
        a(a, b, c) {
            return this.b.d(a, b, c);
        }
    }
    QuadTree.$t = /*@__PURE__*/ markType(QuadTree, 'QuadTree');
    return QuadTree;
})();
/**
 * @hidden
 */
let QuadTreeNode = /*@__PURE__*/ (() => {
    class QuadTreeNode extends Base {
        constructor() {
            super();
            this.b = null;
            this.l = null;
            this.t = 0;
            this.c = null;
            this.q = 0;
            this.a = null;
            this.m = 0;
            this.n = 0;
            this.o = 0;
            this.m = 0;
            this.n = 0;
            this.o = 0;
            this.l = new LinkedList$1(QuadTreeBoundingBox.$);
            this.a = new Array(4);
            this.c = new QuadTreeBoundingBox();
            for (let a = 0; a < 4; a++) {
                this.a[a] = null;
            }
        }
        k(a) {
            if (!this.c.a(a)) {
                return false;
            }
            let b = this.f == null && this.e == null && this.h == null && this.g == null;
            if (b) {
                let c = this.l.c;
                while (c != null) {
                    if (c.c == a) {
                        this.l.h(c);
                        this.t--;
                        return true;
                    }
                    c = c.a;
                }
                return false;
            }
            this.f.k(a);
            this.e.k(a);
            this.h.k(a);
            this.g.k(a);
            return false;
        }
        get j() {
            return this.f == null && this.e == null && this.h == null && this.g == null;
        }
        x(a, b) {
            if (!this.c.a(a)) {
                return;
            }
            if (this.j) {
                b.add(this);
                return;
            }
            this.f.x(a, b);
            this.e.x(a, b);
            this.h.x(a, b);
            this.g.x(a, b);
        }
        w() {
            if (this.f != null) {
                this.f.w();
            }
            if (this.e != null) {
                this.e.w();
            }
            if (this.h != null) {
                this.h.w();
            }
            if (this.g != null) {
                this.h.w();
            }
            if (this.f.j && this.f.t == 0 && this.e.j && this.e.t == 0 && this.h.j && this.h.t == 0 && this.g.j && this.g.t == 0) {
                this.f = null;
                this.e = null;
                this.h = null;
                this.g = null;
                return;
            }
        }
        i(a) {
            if (!this.c.a(a)) {
                return false;
            }
            let b = this.f == null && this.e == null && this.h == null && this.g == null;
            if (b && this.t < this.b.f) {
                this.l.f(a);
                this.t++;
                return true;
            }
            else if (b && this.q < this.b.i) {
                this.y();
            }
            else if (b) {
                this.l.f(a);
                this.t++;
                return true;
            }
            let c = this.f.i(a);
            c = this.e.i(a) || c;
            c = this.h.i(a) || c;
            c = this.g.i(a) || c;
            return c;
        }
        y() {
            this.f = new QuadTreeNode();
            this.e = new QuadTreeNode();
            this.h = new QuadTreeNode();
            this.g = new QuadTreeNode();
            let a = this.c.e / 2;
            this.f.c.b = this.c.b - a;
            this.f.c.c = this.c.c - a;
            this.e.c.b = this.c.b + a;
            this.e.c.c = this.c.c - a;
            this.h.c.b = this.c.b - a;
            this.h.c.c = this.c.c + a;
            this.g.c.b = this.c.b + a;
            this.g.c.c = this.c.c + a;
            for (let b = 0; b < 4; b++) {
                this.a[b].q = this.q + 1;
                this.a[b].c.e = a;
                this.a[b].c.d = a;
                this.a[b].b = this.b;
            }
            let c = this.l.c;
            while (c != null) {
                let d = c.c;
                this.f.i(d);
                this.e.i(d);
                this.h.i(d);
                this.g.i(d);
                c = c.a;
            }
            this.l.g();
            this.t = 0;
        }
        z() {
            if (this.j) {
                let a = 0;
                let b = 0;
                let c = this.l.c;
                while (c != null) {
                    let d = c.c;
                    a += d.b;
                    b += d.c;
                    c = c.a;
                }
                if (this.t == 0) {
                    this.m = 0;
                    this.n = 0;
                    this.o = 0;
                }
                else {
                    this.m = a / this.t;
                    this.n = b / this.t;
                    this.o = this.t;
                }
            }
            else {
                this.f.z();
                this.h.z();
                this.e.z();
                this.g.z();
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = 0; h < 4; h++) {
                    g += this.a[h].o;
                    e += this.a[h].m * this.a[h].o;
                    f += this.a[h].n * this.a[h].o;
                }
                if (this.o > 0) {
                    this.m = e / g;
                    this.n = f / g;
                }
                this.o = g;
            }
        }
        d(a, b, c) {
            let d = Math.sqrt((a - this.m) * (a - this.m) + (b - this.n) * (b - this.n));
            let e = this.c.e * 2;
            if (e / d < c || this.j) {
                let f = (a - this.m) * this.o / (d * d);
                let g = (b - this.n) * this.o / (d * d);
                return ((() => {
                    let $ret = new QuadTreeForceVector();
                    $ret.a = f;
                    $ret.b = g;
                    return $ret;
                })());
            }
            else {
                let h = 0;
                let i = 0;
                for (let j = 0; j < 4; j++) {
                    let k = this.a[j].d(a, b, c);
                    h += k.a;
                    i += k.b;
                }
                return ((() => {
                    let $ret = new QuadTreeForceVector();
                    $ret.a = h;
                    $ret.b = i;
                    return $ret;
                })());
            }
        }
        get f() {
            return this.a[0];
        }
        set f(a) {
            this.a[0] = a;
        }
        get e() {
            return this.a[1];
        }
        set e(a) {
            this.a[1] = a;
        }
        get h() {
            return this.a[2];
        }
        set h(a) {
            this.a[2] = a;
        }
        get g() {
            return this.a[3];
        }
        set g(a) {
            this.a[3] = a;
        }
    }
    QuadTreeNode.$t = /*@__PURE__*/ markType(QuadTreeNode, 'QuadTreeNode');
    return QuadTreeNode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionInfo = /*@__PURE__*/ (() => {
    class LabelCollisionInfo extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.o = 0;
            this.p = 0;
            this.n = 0;
            this.m = 0;
            this.c = null;
            this.l = 0;
            this.k = 0;
            this.i = 0;
            this.j = 0;
            this.s = 0;
            this.t = 0;
            this.g = 0;
            this.h = 0;
            this.q = 0;
            this.r = 0;
            this.a = 0;
            this.b = null;
            this.u = null;
            this.d = false;
            this.f = null;
        }
    }
    LabelCollisionInfo.$t = /*@__PURE__*/ markType(LabelCollisionInfo, 'LabelCollisionInfo');
    return LabelCollisionInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryUtil = /*@__PURE__*/ (() => {
    class GeometryUtil extends Base {
        static i(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
        static c(a) {
            return Math.atan(a);
        }
        static j(a, b) {
            return (b.y - a.y) / (b.x - a.x);
        }
        static e(a) {
            return 1 - Math.pow(a.height / 2, 2) / Math.pow(a.width / 2, 2);
        }
        static p(a, b, c, d, e) {
            let f = Math.cos(a);
            let g = Math.sin(a);
            let h = Math.sqrt(d * d / (1 - (b * Math.pow(f, 2))));
            h *= e;
            return { $type: Point_$type, x: h * f + c.x, y: h * g + c.y };
        }
        static l(a, b, c, d, e) {
            let f;
            if (c) {
                f = GeometryUtil.m({ $type: Point_$type, x: a / 2, y: b / 2 }, d, e);
            }
            else {
                f = { $type: Point_$type, x: a / 2, y: b / 2 };
            }
            return f;
        }
        static m(a, b, c) {
            b = b / 180 * Math.PI;
            let d = a.y + c * Math.sin(b);
            let e = a.x + c * Math.cos(b);
            return { $type: Point_$type, x: e, y: d };
        }
        static o(a, b, c) {
            let d = b.x - a.x;
            let e = b.y - a.y;
            let f = Math.sqrt(d * d + e * e);
            d = d / f * c;
            e = e / f * c;
            return { $type: Point_$type, x: a.x + d, y: a.y + e };
        }
        static g(a, b) {
            let c = Math.abs(b.x - a.x);
            let d = Math.abs(b.y - a.y);
            return Math.sqrt(c * c + d * d);
        }
        static n(a, b, c, d, e) {
            return CoreGeometryUtil.b(a, b, c, d, e);
        }
        static f(a, b) {
            let c = Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
            let d = Math.acos((b.x - a.x) / c);
            if ((b.y - a.y) < 0) {
                d = (2 * Math.PI) - d;
            }
            return d;
        }
        static k(a, b, c, d) {
            let e = a.x - c.x;
            let f = a.y - c.y;
            let g = b.x - c.x;
            let h = b.y - c.y;
            let i = g - e;
            let j = h - f;
            let k = Math.sqrt(i * i + j * j);
            let l = e * h - g * f;
            let m = d * d;
            let n = k * k;
            let o = l * l;
            let p = m * n - o;
            if (p < 0) {
                return new Tuple$2(Point_$type, Point_$type, { $type: Point_$type, x: NaN, y: NaN }, { $type: Point_$type, x: NaN, y: NaN });
            }
            let q = 1;
            if (j < 0) {
                q = -1;
            }
            let r = (l * j + q * i * Math.sqrt(p)) / n;
            let s = (l * j - q * i * Math.sqrt(p)) / n;
            let t = (-1 * l * i + Math.abs(j) * Math.sqrt(p)) / n;
            let u = (-1 * l * i - Math.abs(j) * Math.sqrt(p)) / n;
            return new Tuple$2(Point_$type, Point_$type, { $type: Point_$type, x: r + c.x, y: t + c.y }, { $type: Point_$type, x: s + c.x, y: u + c.y });
        }
        static a(a, b, c, d) {
            let e = d * d;
            let f = b.x;
            let g = b.y;
            let h = c.x;
            let i = c.y;
            let j = a.x;
            let k = a.y;
            if (g == i) {
                let l = Math.abs(g - k) < d;
                let m = j >= Math.min(f, h) - d && j <= Math.max(f, h) + d;
                if (l && m) {
                    return true;
                }
                else {
                    return false;
                }
            }
            if (f == h) {
                let n = Math.abs(f - j) < d;
                let o = k >= Math.min(g, i) - d && k <= Math.max(g, i) + d;
                if (n && o) {
                    return true;
                }
                else {
                    return false;
                }
            }
            let p = h - f;
            let q = i - g;
            let r = p * p + q * q;
            if (r == 0) {
                return (j - f) * (j - f) + (k - g) * (k - g) < e;
            }
            let s = ((j - f) * p + (k - g) * q) / r;
            s = s < 0 ? 0 : (s > 1 ? 1 : s);
            let t = f + p * s;
            let u = g + q * s;
            let v = (t - j) * (t - j) + (u - k) * (u - k);
            if (v < e) {
                return true;
            }
            return false;
        }
        static d(a, b, c) {
            let d = b.x;
            let e = b.y;
            let f = c.x;
            let g = c.y;
            let h = a.x;
            let i = a.y;
            let j = f - d;
            let k = g - e;
            let l = j * j + k * k;
            if (l == 0) {
                return (h - d) * (h - d) + (i - e) * (i - e);
            }
            let m = ((h - d) * j + (i - e) * k) / l;
            m = m < 0 ? 0 : (m > 1 ? 1 : m);
            let n = d + j * m;
            let o = e + k * m;
            let p = (n - h) * (n - h) + (o - i) * (o - i);
            return p;
        }
        static h(a, b, c) {
            let d = b.x;
            let e = b.y;
            let f = c.x;
            let g = c.y;
            let h = a.x;
            let i = a.y;
            let j = f - d;
            let k = g - e;
            let l = j * j + k * k;
            if (l == 0) {
                return 0;
            }
            let m = ((h - d) * j + (i - e) * k) / l;
            m = m < 0 ? 0 : (m > 1 ? 1 : m);
            return m;
        }
        static b(a, b, c, d) {
            let e;
            let f;
            let g = d * d;
            let h = c.count;
            if (h == 0) {
                return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) < g;
            }
            let i = a.x;
            let j = a.y;
            for (let k = 0; k < h; k++) {
                if (k == 0) {
                    f = c.item(k);
                    e = b;
                }
                else {
                    f = c.item(k);
                    e = c.item(k - 1);
                }
                let l = e.x;
                let m = e.y;
                let n = f.x;
                let o = f.y;
                if (m == o) {
                    let p = Math.abs(m - j) < d;
                    let q = i >= Math.min(l, n) - d && i <= Math.max(l, n) + d;
                    if (p && q) {
                        return true;
                    }
                    else {
                        continue;
                    }
                }
                if (l == n) {
                    let r = Math.abs(l - i) < d;
                    let s = j >= Math.min(m, o) - d && j <= Math.max(m, o) + d;
                    if (r && s) {
                        return true;
                    }
                    else {
                        continue;
                    }
                }
                let t = n - l;
                let u = o - m;
                let v = t * t + u * u;
                if (v == 0) {
                    return (i - l) * (i - l) + (j - m) * (j - m) < g;
                }
                let w = ((i - l) * t + (j - m) * u) / v;
                w = w < 0 ? 0 : (w > 1 ? 1 : w);
                let x = l + t * w;
                let y = m + u * w;
                let z = (x - i) * (x - i) + (y - j) * (y - j);
                if (z < g) {
                    return true;
                }
            }
            return false;
        }
    }
    GeometryUtil.$t = /*@__PURE__*/ markType(GeometryUtil, 'GeometryUtil');
    return GeometryUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelCollisionManager = /*@__PURE__*/ (() => {
    class LabelCollisionManager extends Base {
        constructor(a, b, c, d, e, f, g, h, i, j) {
            super();
            this.t = null;
            this.labelsMoved = null;
            this.h = null;
            this.f = null;
            this.e = 0;
            this.c = null;
            this.y = 0;
            this.af = 0;
            this.ae = 0;
            this.a0 = null;
            this.z = 0;
            this.x = 0;
            this.r = new LinkedList$1(LabelCollisionInfo.$);
            this.ab = 0;
            this.s = new List$1(LabelCollisionInfo.$, 0);
            this.k = false;
            this.j = false;
            this.ad = 0;
            this.aa = 0;
            this.u = 0;
            this.v = 0;
            this.ac = 0;
            this.l = false;
            this.i = false;
            this.ak = null;
            this.ai = null;
            this.a0 = c;
            this.z = a;
            this.x = b;
            this.f = new QuadTree(a, b, 8, 8);
            this.e = f;
            this.c = d;
            this.t = new List$1(LabelCollisionPlacementPositions_$type, 0);
            this.t.add(0);
            this.t.add(5);
            this.t.add(7);
            this.t.add(2);
            this.t.add(3);
            this.t.add(6);
            this.t.add(1);
            this.t.add(4);
            this.t.remove(g);
            this.t.insert(0, g);
            this.y = e;
            this.af = h;
            this.ae = i;
            this.i = j;
        }
        g(a, b, c, d, e) {
            let f = 0;
            let g = 0;
            switch (b) {
                case 0:
                    f = a.o;
                    g = (((a.p - a.m) - a.k) - this.y - d);
                    break;
                case 4:
                    f = (((a.o - a.n) - a.l) - this.y) - c;
                    g = (((a.p - a.m) - a.k) - this.y) - d;
                    break;
                case 5:
                    f = (((a.o + a.n) + a.l) + this.y) + c;
                    g = (((a.p - a.m) - a.k) - this.y) - d;
                    break;
                case 1:
                    f = (((a.o - a.n) - a.l) - this.y) - c;
                    g = a.p;
                    break;
                case 2:
                    f = (((a.o + a.n) + a.l) + this.y) + c;
                    g = a.p;
                    break;
                case 3:
                    f = a.o;
                    g = (((a.p + a.m) + a.k) + this.y) + d;
                    break;
                case 6:
                    f = (((a.o - a.n) - a.l) - this.y) - c;
                    g = (((a.p + a.m) + a.k) + this.y) + d;
                    break;
                case 7:
                    f = (((a.o + a.n) + a.l) + this.y) + c;
                    g = (((a.p + a.m) + a.k) + this.y) - d;
                    break;
            }
            let h = new QuadTreeBoundingBox();
            h.b = f;
            h.c = g;
            h.e = a.l;
            h.d = a.k;
            h.g = a;
            if (this.o(h) && !e) {
                return null;
            }
            return h;
        }
        o(a) {
            let b = a.b - a.e;
            let c = a.b + a.e;
            let d = a.c - a.d;
            let e = a.c + a.d;
            let f = this.a0;
            if (b < f.left || c > f.right || d < f.top || e > f.bottom) {
                return true;
            }
            return false;
        }
        as(a, b, c, d, e) {
            this.ar(a, b, c, d, e);
        }
        ar(a, b, c, d, e) {
            this.f.d(a);
            a.b = b;
            a.c = c;
            a.e = d;
            a.d = e;
            this.f.c(a);
        }
        aw(a) {
            this.f.d(a);
        }
        al(a) {
            this.ab++;
            this.r.f(a);
            a.e = this.r.d;
            if (a.c == null) {
                a.c = new QuadTreeBoundingBox();
                a.c.b = a.o;
                a.c.c = a.p;
                a.c.e = a.n;
                a.c.d = a.m;
                a.c.g = a;
                this.f.c(a.c);
            }
        }
        ax(a) {
            if (a.c != null) {
                this.f.d(a.c);
                a.c = null;
            }
            if (a.b != null) {
                this.f.d(a.b);
                a.b = null;
            }
            if (a.e != null) {
                this.r.h(a.e);
                a.e = null;
            }
            this.ab--;
        }
        au(a) {
            if (a.c != null && a.c.b == a.o && a.c.c == a.p) {
                return;
            }
            if (a.c != null) {
                this.f.d(a.c);
            }
            let b = NaN;
            let c = NaN;
            if (a.c == null) {
                a.c = new QuadTreeBoundingBox();
                a.c.g = a;
            }
            else {
                if (a.b != null) {
                    b = a.b.b - a.c.b;
                    c = a.b.c - a.c.c;
                }
            }
            a.c.b = a.o;
            a.c.c = a.p;
            a.c.e = a.n;
            a.c.d = a.m;
            this.f.c(a.c);
            if (a.b != null) {
                this.f.d(a.b);
                if (!isNaN_(b)) {
                    a.b = new QuadTreeBoundingBox();
                    a.b.b = a.c.b + b;
                    a.b.c = a.c.c + c;
                    a.b.g = a;
                    a.b.e = a.l;
                    a.b.d = a.k;
                    a.g = a.b.b;
                    a.h = a.b.c;
                    this.f.c(a.b);
                }
                else {
                    a.b = this.g(a, a.a, 0, 0, true);
                    a.g = a.b.b;
                    a.h = a.b.c;
                    this.f.c(a.b);
                }
            }
        }
        at(a) {
            this.f.d(a.b);
            a.b.b = a.g;
            a.b.c = a.h;
            a.b.e = a.l;
            a.b.d = a.k;
            this.f.c(a.b);
        }
        az() {
            this.j = false;
            {
                let a = this.r.c;
                while (a != null) {
                    if (a.c.b != null) {
                        this.f.d(a.c.b);
                        a.c.b = null;
                        if (a.c.f != null) {
                            a.c.f.clear();
                        }
                    }
                    a = a.a;
                }
                this.ac = 0;
            }
            this.aa = 0;
            this.u = 0.4;
            this.v = 0.4;
            let b = truncate(Math.ceil((this.ae / 150) * this.af));
            this.ad = b;
            this.ao();
        }
        an() {
            this.s.clear();
        }
        am() {
            this.j = true;
        }
        aq() {
            this.k = false;
            if (this.j) {
                return;
            }
            this.ao();
        }
        ao() {
            this.s.clear();
            this.av(false);
            if (this.e == 0) {
                for (let a = 0; a < this.af; a++) {
                    this.v = this.u * (this.ad - this.aa) / this.ad;
                    this.ap();
                    this.aa++;
                    if (this.aa > this.ad) {
                        if (this.h != null) {
                            this.h();
                        }
                        return;
                    }
                }
                if (this.labelsMoved != null) {
                    this.labelsMoved(this.s);
                }
                if (this.ac > 0) {
                    if (!this.k) {
                        this.k = true;
                        this.c.executeDelayed(runOn(this, this.aq), 150);
                    }
                }
                else {
                    if (this.h != null) {
                        this.h();
                    }
                }
            }
            else {
                if (this.e == 2) {
                    let b = this.r.c;
                    this.f.k();
                    while (b != null) {
                        let c = b.c;
                        if (c.b != null) {
                            this.f.d(c.b);
                            c.b = null;
                            c.d = false;
                            c.f = null;
                        }
                        b = b.a;
                    }
                    this.ac = 0;
                    this.av(true);
                }
                if (this.labelsMoved != null) {
                    this.labelsMoved(this.s);
                }
            }
        }
        ap() {
            let a = truncate(Math.round((this.ab - 1) * LabelCollisionManager.aj.nextDouble()));
            let b = 0;
            let c = this.r.c;
            let d = this.w(null);
            let e = 30;
            let f = 60;
            while (c != null) {
                let g = c.c;
                let h = 0;
                let i = 0;
                if (this.i) {
                    h = LabelCollisionManager.aj.nextDouble() * g.l * 2;
                    i = LabelCollisionManager.aj.nextDouble() * g.k * 2;
                }
                if (b == a) {
                    let j = truncate(Math.round((this.t.count - 1) * LabelCollisionManager.aj.nextDouble()));
                    while (this.t._inner[j] == g.a) {
                        j = truncate(Math.round((this.t.count - 1) * LabelCollisionManager.aj.nextDouble()));
                    }
                    let k = g.b;
                    let l = this.g(g, this.t._inner[j], h, i, false);
                    let m = 0;
                    while (l == null) {
                        if (m >= e) {
                            h = 0;
                            i = 0;
                        }
                        if (m >= f) {
                            break;
                        }
                        j = truncate(Math.round((this.t.count - 1) * LabelCollisionManager.aj.nextDouble()));
                        l = this.g(g, this.t._inner[j], h, i, false);
                        m++;
                    }
                    g.b = l;
                    if (k != null) {
                        this.f.d(k);
                    }
                    if (l != null) {
                        this.f.c(l);
                        let n = this.w(g);
                        let o = d > n;
                        if (!o) {
                            let p = Math.exp(-(n - d) / this.v);
                            if (LabelCollisionManager.aj.nextDouble() < p) {
                                o = true;
                            }
                        }
                        if (!o && k != null) {
                            this.f.d(l);
                            this.f.c(k);
                            g.b = k;
                            if (!this.l) {
                                this.w(g);
                            }
                        }
                        else {
                            g.a = this.t._inner[j];
                            g.g = g.b.b;
                            g.h = g.b.c;
                            this.s.add(g);
                        }
                    }
                    else {
                        if (!this.l) {
                            this.w(g);
                        }
                        g.d = false;
                        this.s.add(g);
                    }
                    break;
                }
                b++;
                c = c.a;
            }
        }
        w(a) {
            if (this.l) {
                let b = 0;
                let c = this.r.c;
                while (c != null) {
                    let d = c.c;
                    let e = d.d;
                    d.d = false;
                    if (d.b != null) {
                        let f = this.f.e(d.b);
                        for (let g = 0; g < f.count; g++) {
                            let h = f._inner[g].l.c;
                            while (h != null) {
                                let i = h.c;
                                if (i.g == d) {
                                    h = h.a;
                                    continue;
                                }
                                if (d.b.a(i)) {
                                    d.d = true;
                                    b += d.b.f(i);
                                }
                                h = h.a;
                            }
                        }
                        if (d.d != e) {
                            this.s.add(d);
                        }
                    }
                    c = c.a;
                }
                return b;
            }
            else {
                if (a != null) {
                    let j = new HashSet$1(LabelCollisionInfo.$, 0);
                    let k = new HashSet$1(LabelCollisionInfo.$, 0);
                    let l = new HashSet$1(LabelCollisionInfo.$, 0);
                    let m = new List$1(LabelCollisionInfo.$, 0);
                    if (a.f != null) {
                        for (let n = 0; n < a.f.count; n++) {
                            j.add_1(a.f._inner[n]);
                            k.add_1(a.f._inner[n]);
                        }
                    }
                    let o = a.d;
                    a.d = false;
                    if (a.b != null) {
                        let p = this.f.e(a.b);
                        for (let q = 0; q < p.count; q++) {
                            let r = p._inner[q].l.c;
                            while (r != null) {
                                let s = r.c;
                                if (s.g == a) {
                                    r = r.a;
                                    continue;
                                }
                                if (a.b.a(s) && !l.contains(s.g)) {
                                    a.d = true;
                                    l.add_1(s.g);
                                    m.add(s.g);
                                }
                                r = r.a;
                            }
                        }
                        p = this.f.e(a.c);
                        for (let t = 0; t < p.count; t++) {
                            let u = p._inner[t].l.c;
                            while (u != null) {
                                let v = u.c;
                                if (v.g == a) {
                                    u = u.a;
                                    continue;
                                }
                                if (this.m(a.c, v)) {
                                    u = u.a;
                                    continue;
                                }
                                if (a.c.a(v) && !l.contains(v.g)) {
                                    a.d = true;
                                    l.add_1(v.g);
                                    m.add(v.g);
                                }
                                u = u.a;
                            }
                        }
                        if (a.d != o) {
                            this.s.add(a);
                        }
                        if (a.f != null) {
                            for (let w = a.f.count - 1; w >= 0; w--) {
                                if (!l.contains(a.f._inner[w])) {
                                    let x = a.f._inner[w];
                                    let y = x.f.remove(a);
                                    a.f.removeAt(w);
                                    if (x.f.count == 0 && y) {
                                        this.ac--;
                                    }
                                    let z = j.remove(x);
                                    if (j.count == 0 && z) {
                                        this.ac--;
                                    }
                                }
                            }
                        }
                        for (let aa = 0; aa < m.count; aa++) {
                            let ab = m._inner[aa];
                            if (!j.contains(ab)) {
                                if (a.f == null) {
                                    a.f = new List$1(LabelCollisionInfo.$, 0);
                                }
                                a.f.add(ab);
                                if (j.count == 0) {
                                    this.ac++;
                                }
                                j.add_1(ab);
                                if (ab.f == null) {
                                    ab.f = new List$1(LabelCollisionInfo.$, 0);
                                }
                                if (ab.f.count == 0) {
                                    this.ac++;
                                }
                                ab.f.add(a);
                            }
                        }
                    }
                }
                return this.ac;
            }
        }
        m(a, b) {
            if (a.g.c == a && b.g.c == b) {
                return true;
            }
            return false;
        }
        get ag() {
            return this.ac;
        }
        ay(a, b, c) {
            this.a0 = c;
            let d = new QuadTree(a, b, this.f.i, this.f.f);
            let e = this.r.c;
            while (e != null) {
                d.c(e.c.c);
                if (e.c.b != null) {
                    d.c(e.c.b);
                }
                e = e.a;
            }
            this.f = d;
            this.z = a;
            this.x = b;
        }
        q() {
            let a = this.r.c;
            while (a != null) {
                a.c.d = false;
                if (a.c.b != null) {
                    if (this.o(a.c.b)) {
                        return true;
                    }
                }
                a = a.a;
            }
            return false;
        }
        ah() {
            let a = this.r.c;
            while (a != null) {
                a.c.d = false;
                a = a.a;
            }
            a = this.r.c;
            while (a != null) {
                let b = a.c.b;
                let c = a.c.c;
                let d = this.f.e(c);
                for (let e = 0; e < d.count; e++) {
                    let f = d._inner[e].l.c;
                    while (f != null) {
                        let g = f.c;
                        if (this.m(c, g)) {
                            f = f.a;
                            continue;
                        }
                        if (c.a(g)) {
                            let h = f.c.g;
                            if (h != a.c) {
                                h.d = true;
                                a.c.d = true;
                            }
                        }
                        f = f.a;
                    }
                }
                if (b == null) {
                    return -1;
                }
                d = this.f.e(b);
                for (let i = 0; i < d.count; i++) {
                    let j = d._inner[i].l.c;
                    while (j != null) {
                        let k = j.c;
                        if (b.a(k)) {
                            let l = j.c.g;
                            if (l != a.c) {
                                l.d = true;
                                a.c.d = true;
                            }
                        }
                        j = j.a;
                    }
                }
                a = a.a;
            }
            let m = 0;
            a = this.r.c;
            while (a != null) {
                if (a.c.d) {
                    m++;
                }
                a = a.a;
            }
            return m;
        }
        av(a) {
            let b = this.r.c;
            while (b != null) {
                let c = b.c;
                if (c.b == null || a) {
                    let d = false;
                    if (a) {
                        let e = this.f.a(c.o, c.p, 1.5);
                        let f = this.a(e);
                        for (let g = 0; g < f.length; g++) {
                            let h = f[g];
                            let i = this.g(c, h, 0, 0, false);
                            if (i == null) {
                                continue;
                            }
                            let j = this.f.e(i);
                            d = true;
                            for (let k = 0; k < j.count; k++) {
                                let l = j._inner[k].l.c;
                                while (l != null) {
                                    let m = l.c;
                                    if (i.a(m)) {
                                        d = false;
                                        break;
                                    }
                                    l = l.a;
                                }
                            }
                            if (d) {
                                c.b = i;
                                c.a = h;
                                c.g = c.b.b;
                                c.h = c.b.c;
                                this.f.c(c.b);
                                this.s.add(c);
                                break;
                            }
                        }
                    }
                    if (!d) {
                        d = this.p(c);
                    }
                }
                b = b.a;
            }
        }
        p(a) {
            let b = false;
            if (!b) {
                for (let c = 0; c < this.t.count; c++) {
                    let d = this.g(a, this.t._inner[c], 0, 0, false);
                    if (d == null) {
                        continue;
                    }
                    b = !this.n(d, a);
                    let e = a.c;
                    if (e == null) {
                        e = new QuadTreeBoundingBox();
                        e.g = a;
                        e.b = a.o;
                        e.c = a.p;
                        e.e = a.n;
                        e.d = a.m;
                        this.f.c(e);
                        a.c = e;
                    }
                    let f = this.n(e, a);
                    b = b && !f;
                    if (b) {
                        a.b = d;
                        a.a = this.t._inner[c];
                        a.g = a.b.b;
                        a.h = a.b.c;
                        this.f.c(a.b);
                        this.s.add(a);
                        break;
                    }
                }
            }
            if (!b) {
                let g = Number.POSITIVE_INFINITY;
                let h = 0;
                let i = null;
                for (let j = 0; j < this.t.count; j++) {
                    let k = 0;
                    let l = null;
                    let m = new HashSet$1(LabelCollisionInfo.$, 0);
                    if (!this.l) {
                        l = new List$1(LabelCollisionInfo.$, 0);
                    }
                    let n = this.g(a, this.t._inner[j], 0, 0, false);
                    if (n == null) {
                        continue;
                    }
                    let o = this.f.e(n);
                    for (let p = 0; p < o.count; p++) {
                        let q = o._inner[p].l.c;
                        while (q != null) {
                            let r = q.c;
                            if (n.a(r)) {
                                k += n.f(r);
                                if (!this.l) {
                                    if (!m.contains(r.g)) {
                                        l.add(r.g);
                                        m.add_1(r.g);
                                    }
                                }
                            }
                            q = q.a;
                        }
                    }
                    let s = a.c;
                    if (s == null) {
                        s = new QuadTreeBoundingBox();
                        s.g = a;
                        s.b = a.o;
                        s.c = a.p;
                        s.e = a.n;
                        s.d = a.m;
                    }
                    o = this.f.e(s);
                    for (let t = 0; t < o.count; t++) {
                        let u = o._inner[t].l.c;
                        while (u != null) {
                            let v = u.c;
                            if (u.c.g == a) {
                                u = u.a;
                                continue;
                            }
                            if (this.m(s, v)) {
                                u = u.a;
                                continue;
                            }
                            if (s.a(v)) {
                                if (!this.l) {
                                    if (!m.contains(v.g)) {
                                        l.add(v.g);
                                        m.add_1(v.g);
                                    }
                                }
                            }
                            u = u.a;
                        }
                    }
                    if (k < g) {
                        let w = this.g(a, this.t._inner[j], 0, 0, false);
                        if (w != null) {
                            g = k;
                            h = j;
                            if (!this.l) {
                                i = l;
                            }
                        }
                    }
                }
                let x = this.g(a, this.t._inner[h], 0, 0, false);
                a.d = true;
                if (!this.l) {
                    if (a.f != null && a.f.count > 0) {
                        this.ac--;
                        for (let y = a.f.count - 1; y >= 0; y--) {
                            let z = a.f._inner[y];
                            if (z.f != null) {
                                z.f.remove(a);
                                if (z.f.count == 0) {
                                    this.ac--;
                                }
                            }
                        }
                    }
                    if (i == null) {
                        a.d = false;
                        this.s.add(a);
                        return false;
                    }
                    a.f = i;
                    if (i.count > 0) {
                        this.ac++;
                    }
                    for (let aa = 0; aa < i.count; aa++) {
                        let ab = i._inner[aa];
                        if (ab.f == null) {
                            ab.f = new List$1(LabelCollisionInfo.$, 0);
                        }
                        if (!ab.f.contains(a)) {
                            if (ab.f.count == 0) {
                                this.ac++;
                            }
                            ab.f.add(a);
                        }
                    }
                }
                a.b = x;
                a.a = this.t._inner[h];
                a.g = a.b.b;
                a.h = a.b.c;
                this.f.c(a.b);
                this.s.add(a);
            }
            return b;
        }
        n(a, b) {
            let c = false;
            let d = this.f.e(a);
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e].l.c;
                while (f != null) {
                    if (f.c.g == b) {
                        f = f.a;
                        continue;
                    }
                    let g = f.c;
                    if (this.m(a, g)) {
                        f = f.a;
                        continue;
                    }
                    if (a.a(g)) {
                        c = true;
                        break;
                    }
                    f = f.a;
                }
            }
            return c;
        }
        a(a) {
            let b = new Array(3);
            let c = GeometryUtil.f({ $type: Point_$type, x: 0, y: 0 }, { $type: Point_$type, x: a.a, y: a.b });
            c = c * 180 / Math.PI;
            c = GeometryUtil.i(c);
            if ((c >= 0 && c <= 22.5) || (c >= 337.5 && c <= 360)) {
                b[0] = 2;
                b[1] = 5;
                b[2] = 7;
            }
            if (c >= 22.5 && c <= 67.5) {
                b[0] = 2;
                b[1] = 7;
                b[2] = 3;
            }
            if (c >= 67.5 && c <= 112.5) {
                b[0] = 7;
                b[1] = 3;
                b[2] = 6;
            }
            if (c >= 112.5 && c <= 157.5) {
                b[0] = 3;
                b[1] = 6;
                b[2] = 1;
            }
            if (c >= 157.5 && c <= 202.5) {
                b[0] = 6;
                b[1] = 1;
                b[2] = 4;
            }
            if (c >= 202.5 && c <= 247.5) {
                b[0] = 1;
                b[1] = 4;
                b[2] = 0;
            }
            if (c >= 247.5 && c <= 292.5) {
                b[0] = 4;
                b[1] = 0;
                b[2] = 5;
            }
            if (c >= 292.5 && c <= 337.5) {
                b[0] = 0;
                b[1] = 5;
                b[2] = 2;
            }
            return b;
        }
        d(a, b) {
            let c = false;
            let d = null;
            let e = new QuadTreeBoundingBox();
            e.b = a.x;
            e.c = a.y;
            e.e = 5;
            e.d = 5;
            let f = this.f.e(e);
            for (let g = 0; g < f.count; g++) {
                let h = f._inner[g].l.c;
                while (h != null) {
                    let i = h.c;
                    if (i.g.c == i) {
                        h = h.a;
                        continue;
                    }
                    if (e.a(i)) {
                        d = i;
                        c = true;
                        break;
                    }
                    h = h.a;
                }
            }
            if (c) {
                return d.g;
            }
            else {
                return null;
            }
        }
    }
    LabelCollisionManager.$t = /*@__PURE__*/ markType(LabelCollisionManager, 'LabelCollisionManager');
    LabelCollisionManager.aj = /*@__PURE__*/ new Random(0);
    return LabelCollisionManager;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EdgeClipper = /*@__PURE__*/ (() => {
    class EdgeClipper extends Base {
        constructor() {
            super(...arguments);
            this.h = null;
            this._nextClipper = null;
            this.c = true;
            this.j = null;
            this.l = null;
            this.g = false;
            this.d = false;
            this.f = false;
        }
        get i() {
            return this.h;
        }
        set i(a) {
            if (this.h != a) {
                this.c = true;
                this.h = a;
            }
        }
        get nextClipper() {
            return this._nextClipper;
        }
        set nextClipper(a) {
            this._nextClipper = a;
        }
        add(a) {
            let b = this.e(a);
            if (this.c) {
                this.c = false;
                this.j = a;
            }
            else {
                if (true) {
                    if (b) {
                        if (!this.g) {
                            this.h.add(this.k(this.l, a));
                        }
                        else {
                            if (!this.d && !this.f) {
                                this.h.add(this.l);
                                this.f = true;
                            }
                        }
                        this.h.add(a);
                    }
                    else {
                        if (this.g) {
                            if (!this.d && !this.f) {
                                this.h.add(this.l);
                                this.f = true;
                            }
                            this.h.add(this.k(this.l, a));
                        }
                    }
                }
            }
            this.l = a;
            this.g = b;
        }
        clear() {
            if (this.d && !this.c) {
                this.add(this.j);
            }
            if (this._nextClipper != null) {
                this._nextClipper.clear();
            }
            this.c = true;
            this.f = false;
        }
        getEnumeratorObject() {
            return null;
        }
        getEnumerator() {
            return null;
        }
        get isReadOnly() {
            return false;
        }
        get count() {
            return 0;
        }
        remove(a) {
            return false;
        }
        removeAt(a) {
        }
        copyTo(a, b) {
        }
        contains(a) {
            return false;
        }
        item(a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                return { $type: Point_$type, x: 0, y: 0 };
            }
        }
        insert(a, b) {
        }
        indexOf(a) {
            return -1;
        }
    }
    EdgeClipper.$t = /*@__PURE__*/ markType(EdgeClipper, 'EdgeClipper', Base.$, [/*@__PURE__*/ IList$1_$type.specialize(Point_$type)]);
    return EdgeClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LeftClipper = /*@__PURE__*/ (() => {
    class LeftClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.x >= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: this.m, y: a.y + (b.y - a.y) * (this.m - a.x) / (b.x - a.x) };
        }
    }
    LeftClipper.$t = /*@__PURE__*/ markType(LeftClipper, 'LeftClipper', EdgeClipper.$);
    return LeftClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BottomClipper = /*@__PURE__*/ (() => {
    class BottomClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.y <= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: a.x + (b.x - a.x) * (this.m - a.y) / (b.y - a.y), y: this.m };
        }
    }
    BottomClipper.$t = /*@__PURE__*/ markType(BottomClipper, 'BottomClipper', EdgeClipper.$);
    return BottomClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RightClipper = /*@__PURE__*/ (() => {
    class RightClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.x <= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: this.m, y: a.y + (b.y - a.y) * (this.m - a.x) / (b.x - a.x) };
        }
    }
    RightClipper.$t = /*@__PURE__*/ markType(RightClipper, 'RightClipper', EdgeClipper.$);
    return RightClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TopClipper = /*@__PURE__*/ (() => {
    class TopClipper extends EdgeClipper {
        constructor() {
            super(...arguments);
            this.m = 0;
        }
        e(a) {
            return a.y >= this.m;
        }
        k(a, b) {
            return { $type: Point_$type, x: a.x + (b.x - a.x) * (this.m - a.y) / (b.y - a.y), y: this.m };
        }
    }
    TopClipper.$t = /*@__PURE__*/ markType(TopClipper, 'TopClipper', EdgeClipper.$);
    return TopClipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Clipper = /*@__PURE__*/ (() => {
    class Clipper extends Base {
        constructor(a, ..._rest) {
            super();
            this.g = null;
            this.b = null;
            this.h = null;
            this.c = null;
            this.a = null;
            this.d = null;
            this.e = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.c = ((() => {
                            let $ret = new LeftClipper();
                            $ret.m = c.left;
                            $ret.d = d;
                            return $ret;
                        })());
                        this.a = ((() => {
                            let $ret = new BottomClipper();
                            $ret.m = c.bottom;
                            $ret.d = d;
                            return $ret;
                        })());
                        this.d = ((() => {
                            let $ret = new RightClipper();
                            $ret.m = c.right;
                            $ret.d = d;
                            return $ret;
                        })());
                        this.e = ((() => {
                            let $ret = new TopClipper();
                            $ret.m = c.top;
                            $ret.d = d;
                            return $ret;
                        })());
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        this.c = !isNaN_(c) ? ((() => {
                            let $ret = new LeftClipper();
                            $ret.m = c;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                        this.a = !isNaN_(d) ? ((() => {
                            let $ret = new BottomClipper();
                            $ret.m = d;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                        this.d = !isNaN_(e) ? ((() => {
                            let $ret = new RightClipper();
                            $ret.m = e;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                        this.e = !isNaN_(f) ? ((() => {
                            let $ret = new TopClipper();
                            $ret.m = f;
                            $ret.d = g;
                            return $ret;
                        })()) : null;
                    }
                    break;
            }
        }
        get i() {
            return this.h;
        }
        set i(a) {
            if (this.b != null) {
                this.b.clear();
            }
            this.b = null;
            this.h = a;
            let b = this.h;
            if (this.c != null) {
                this.c.i = b;
                b = this.c;
                this.b = this.c;
            }
            if (this.a != null) {
                this.a.i = b;
                b = this.a;
                this.a._nextClipper = this.b;
                this.b = this.a;
            }
            if (this.d != null) {
                this.d.i = b;
                b = this.d;
                this.d._nextClipper = this.b;
                this.b = this.d;
            }
            if (this.e != null) {
                this.e.i = b;
                b = this.e;
                this.e._nextClipper = this.b;
                this.b = this.e;
            }
            this.g = b;
        }
        j(a) {
            this.g.add(a);
        }
        k(a, b) {
            let c = a;
            let d = a.count;
            let e = new Array(4);
            e[0] = this.e;
            e[1] = this.d;
            e[2] = this.a;
            e[3] = this.c;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            if (this.e != null) {
                f = this.e.m;
            }
            if (this.d != null) {
                g = this.d.m;
            }
            if (this.a != null) {
                h = this.a.m;
            }
            if (this.c != null) {
                i = this.c.m;
            }
            let j = false;
            let k;
            let l = e.length;
            let m = l + 1;
            let n = null;
            let o;
            let p;
            let q = 0;
            let r = new Array(16);
            let s = 0;
            let t = new Array(16);
            let u = 0;
            let v = 1;
            let w;
            let x;
            if (b) {
                u = d - 1;
                v = -1;
            }
            for (let y = u; y < d && y >= 0; y += v) {
                o = c.item(y);
                r[q] = o;
                q++;
                for (k = 0; k < m; k++) {
                    if (k < l) {
                        n = e[k];
                        if (n == null) {
                            continue;
                        }
                    }
                    for (p = 0; p < q; p++) {
                        o = r[p];
                        x = o.x;
                        w = o.y;
                        if (k >= l) {
                            this.h.add(o);
                            continue;
                        }
                        j = (k == 0 && w >= f) || (k == 1 && x <= g) || (k == 2 && w <= h) || (k == 3 && x >= i);
                        if (n.c) {
                            n.c = false;
                            n.j = o;
                        }
                        else {
                            if (true) {
                                if (j) {
                                    if (!n.g) {
                                        t[s] = n.k(n.l, o);
                                        s++;
                                    }
                                    else {
                                        if (!n.d && !n.f) {
                                            t[s] = n.l;
                                            s++;
                                            n.f = true;
                                        }
                                    }
                                    t[s] = o;
                                    s++;
                                }
                                else {
                                    if (n.g) {
                                        if (!n.d && !n.f) {
                                            t[s] = n.l;
                                            s++;
                                            n.f = true;
                                        }
                                        t[s] = n.k(n.l, o);
                                        s++;
                                    }
                                }
                            }
                        }
                        n.l = o;
                        n.g = j;
                    }
                    let z = r;
                    r = t;
                    t = z;
                    q = s;
                    s = 0;
                }
            }
        }
        get f() {
            return (this.c == null || this.c.d) && (this.a == null || this.a.d) && (this.d == null || this.d.d) && (this.e == null || this.e.d);
        }
        set f(a) {
            if (this.c != null) {
                this.c.d = a;
            }
            if (this.a != null) {
                this.a.d = a;
            }
            if (this.d != null) {
                this.d.d = a;
            }
            if (this.e != null) {
                this.e.d = a;
            }
        }
    }
    Clipper.$t = /*@__PURE__*/ markType(Clipper, 'Clipper');
    return Clipper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Flattener = /*@__PURE__*/ (() => {
    class Flattener extends Base {
        constructor() {
            super();
        }
        static d(a, b, c, d) {
            let e = new List$1(Number_$type, 0);
            Flattener.c(e, b, c, 0, a - 1, d);
            return e;
        }
        static c(a, b, c, d, e, f) {
            return Flattener.b(a, (g) => g, b, c, d, e, f);
        }
        static a(a, b, c, d, e, f, g) {
            return Flattener.b(a, (h) => b.item(h), c, d, e, f, g);
        }
        static b(a, b, c, d, e, f, g) {
            if (e > f) {
                return a;
            }
            let h = c(b(e));
            let i = d(b(e));
            while ((isNaN_(h) || isNaN_(i)) && e < f) {
                ++e;
                h = c(b(e));
                i = d(b(e));
            }
            let j = c(b(f));
            let k = d(b(f));
            while ((isNaN_(j) || isNaN_(k)) && e < f) {
                --f;
                j = c(b(f));
                k = d(b(f));
            }
            if (e == f) {
                a.add(b(e));
                return a;
            }
            a.add(b(e));
            Flattener.e(a, b, c, d, e, f, g);
            a.add(b(f));
            return a;
        }
        static e(a, b, c, d, e, f, g) {
            let h = c(b(e));
            let i = d(b(e));
            while ((isNaN_(h) || isNaN_(i)) && e < f) {
                ++e;
                h = c(b(e));
                i = d(b(e));
            }
            let j = c(b(f));
            let k = d(b(f));
            while ((isNaN_(j) || isNaN_(k)) && e < f) {
                --f;
                j = c(b(f));
                k = d(b(f));
            }
            if (e + 1 >= f) {
                return;
            }
            let l = -1;
            let m = g;
            let n = MathUtil.e(j - h, k - i);
            if (n == 0) {
                for (let o = e + 1; o < f; ++o) {
                    let p = c(b(o));
                    let q = d(b(o));
                    if (isNaN_(p) || isNaN_(q)) {
                        continue;
                    }
                    let r = MathUtil.e(j - p, k - q);
                    if (r >= m) {
                        m = r;
                        l = o;
                    }
                }
            }
            else {
                let s = j - h;
                let t = k - i;
                for (let u = e + 1; u < f; ++u) {
                    let v = c(b(u));
                    let w = d(b(u));
                    if (isNaN_(v) || isNaN_(w)) {
                        continue;
                    }
                    let x = NaN;
                    let y = c(b(u)) - h;
                    let z = d(b(u)) - i;
                    let aa = s * y + t * z;
                    if (aa <= 0) {
                        x = MathUtil.e(h - v, i - w);
                    }
                    else {
                        let ab = s * s + t * t;
                        if (ab <= aa) {
                            x = MathUtil.e(j - v, k - w);
                        }
                        else {
                            let ac = aa / ab;
                            x = MathUtil.e(h + ac * s - v, i + ac * t - w);
                        }
                    }
                    if (x >= m) {
                        m = x;
                        l = u;
                    }
                }
            }
            if (l != -1) {
                Flattener.e(a, b, c, d, e, l, g);
                a.add(b(l));
                Flattener.e(a, b, c, d, l, f, g);
            }
            return;
        }
    }
    Flattener.$t = /*@__PURE__*/ markType(Flattener, 'Flattener');
    return Flattener;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FlattenerSettings = /*@__PURE__*/ (() => {
    class FlattenerSettings extends Base {
        constructor() {
            super();
            this._chunkingAmount = 0;
            this.chunkingAmount = 3000;
        }
        static get instance() {
            if (FlattenerSettings.a == null) {
                FlattenerSettings.a = new FlattenerSettings();
            }
            return FlattenerSettings.a;
        }
        get chunkingAmount() {
            return this._chunkingAmount;
        }
        set chunkingAmount(a) {
            this._chunkingAmount = a;
        }
    }
    FlattenerSettings.$t = /*@__PURE__*/ markType(FlattenerSettings, 'FlattenerSettings');
    FlattenerSettings.a = null;
    return FlattenerSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FastFlattener = /*@__PURE__*/ (() => {
    class FastFlattener extends Base {
        constructor() {
            super();
        }
        static e(a, b, c, d, e, f) {
            if (d > e) {
                return a;
            }
            let g = b[d];
            let h = c[d];
            while ((isNaN_(g) || isNaN_(h)) && d < e) {
                ++d;
                g = b[d];
                h = c[d];
            }
            let i = b[e];
            let j = c[e];
            while ((isNaN_(i) || isNaN_(j)) && d < e) {
                --e;
                i = b[e];
                j = c[e];
            }
            if (d == e) {
                a.add(d);
                return a;
            }
            a.add(d);
            FastFlattener.h(a, b, c, d, e, f);
            a.add(e);
            return a;
        }
        static c(a, b, c, d, e) {
            let f;
            let g;
            if (c) {
                f = 0;
                g = 1;
            }
            else if (d) {
                f = 0;
                g = 2;
            }
            else {
                f = 2;
                g = 3;
            }
            return FastFlattener.d(a, b, f, g, e);
        }
        static b(a, b, c, d, e) {
            let f = new List$1(Number_$type, 0);
            let g = FastFlattener.a(f, b, c, d, 0, a - 1, e);
            return g;
        }
        static d(a, b, c, d, e) {
            let f = new List$1(Number_$type, 0);
            FastFlattener.g(f, b, c, d, 0, a - 1, e);
            return f;
        }
        static a(a, b, c, d, e, f, g) {
            let h = FlattenerSettings.instance.chunkingAmount;
            if ((f - e + 1) <= h) {
                return FastFlattener.f(a, b, c, d, e, f, g);
            }
            let i = a;
            if (h < 0) {
                for (let j = e; j <= f; j++) {
                    i.add(j);
                }
                return i;
            }
            let k = e;
            let l = f;
            let m = l - k + 1;
            while (m > 0) {
                if (m <= h) {
                    FastFlattener.f(i, b, c, d, k, l, g);
                    k = l + 1;
                }
                else {
                    let n = k + h - 1;
                    FastFlattener.f(i, b, c, d, k, n, g);
                    k = n + 1;
                }
                m = l - k + 1;
            }
            return i;
        }
        static f(a, b, c, d, e, f, g) {
            let h;
            let i;
            if (c) {
                h = 0;
                i = 1;
            }
            else if (d) {
                h = 0;
                i = 2;
            }
            else {
                h = 2;
                i = 3;
            }
            return FastFlattener.g(a, b, h, i, e, f, g);
        }
        static g(a, b, c, d, e, f, g) {
            if (e > f) {
                return a;
            }
            let h = b._inner[e];
            let i, j;
            i = h[c];
            j = h[d];
            while ((isNaN_(i) || isNaN_(j)) && e < f) {
                ++e;
                h = b._inner[e];
                i = h[c];
                j = h[d];
            }
            let k = b._inner[f];
            let l, m;
            l = k[c];
            m = k[d];
            while ((isNaN_(l) || isNaN_(m)) && e < f) {
                --f;
                k = b._inner[f];
                l = k[c];
                m = k[d];
            }
            if (e == f) {
                a.add(e);
                return a;
            }
            a.add(e);
            FastFlattener.i(a, b, c, d, e, f, g);
            a.add(f);
            return a;
        }
        static h(a, b, c, d, e, f) {
            let g = b[d];
            let h = c[d];
            while ((isNaN_(g) || isNaN_(h)) && d < e) {
                ++d;
                g = b[d];
                h = c[d];
            }
            let i = b[e];
            let j = c[e];
            while ((isNaN_(i) || isNaN_(j)) && d < e) {
                --e;
                i = b[e];
                j = c[e];
            }
            if (d + 1 >= e) {
                return;
            }
            let k = -1;
            let l = f * f;
            let m;
            let n;
            m = i - g;
            n = j - h;
            let o = m * m + n * n;
            if (o == 0) {
                for (let p = d + 1; p < e; ++p) {
                    let q = b[p];
                    let r = c[p];
                    if (isNaN_(q) || isNaN_(r)) {
                        continue;
                    }
                    m = i - q;
                    n = j - r;
                    let s = m * m + n * n;
                    if (s >= l) {
                        l = s;
                        k = p;
                    }
                }
            }
            else {
                let t = i - g;
                let u = j - h;
                for (let v = d + 1; v < e; ++v) {
                    let w = b[v];
                    let x = c[v];
                    if (isNaN_(w) || isNaN_(x)) {
                        continue;
                    }
                    let y = NaN;
                    let z = b[v] - g;
                    let aa = c[v] - h;
                    let ab = t * z + u * aa;
                    if (ab <= 0) {
                        m = g - w;
                        n = h - x;
                        y = m * m + n * n;
                    }
                    else {
                        let ac = t * t + u * u;
                        if (ac <= ab) {
                            m = i - w;
                            n = j - x;
                            y = m * m + n * n;
                        }
                        else {
                            let ad = ab / ac;
                            m = g + ad * t - w;
                            n = h + ad * u - x;
                            y = m * m + n * n;
                        }
                    }
                    if (y >= l) {
                        l = y;
                        k = v;
                    }
                }
            }
            if (k != -1) {
                FastFlattener.h(a, b, c, d, k, f);
                a.add(k);
                FastFlattener.h(a, b, c, k, e, f);
            }
            return;
        }
        static i(a, b, c, d, e, f, g) {
            let h = b._inner[e];
            let i, j;
            i = h[c];
            j = h[d];
            while ((i != i) || (j != j) && e < f) {
                ++e;
                h = b._inner[e];
                i = h[c];
                j = h[d];
            }
            let k = b._inner[f];
            let l, m;
            l = k[c];
            m = k[d];
            while ((l != l) || (m != m) && e < f) {
                --f;
                k = b._inner[f];
                l = k[c];
                m = k[d];
            }
            if (e + 1 >= f) {
                return;
            }
            let n = -1;
            let o = g * g;
            let p;
            let q;
            p = l - i;
            q = m - j;
            let r = p * p + q * q;
            if (r == 0) {
                for (let s = e + 1; s < f; ++s) {
                    let t = b._inner[s];
                    let u, v;
                    u = t[c];
                    v = t[d];
                    if ((u != u) || (v != v)) {
                        continue;
                    }
                    p = l - u;
                    q = m - v;
                    let w = p * p + q * q;
                    if (w >= o) {
                        o = w;
                        n = s;
                    }
                }
            }
            else {
                let x = l - i;
                let y = m - j;
                for (let z = e + 1; z < f; ++z) {
                    let aa = b._inner[z];
                    let ab, ac;
                    ab = aa[c];
                    ac = aa[d];
                    if ((ab != ab) || (ac != ac)) {
                        continue;
                    }
                    let ad = NaN;
                    let ae = ab - i;
                    let af = ac - j;
                    let ag = x * ae + y * af;
                    if (ag <= 0) {
                        p = i - ab;
                        q = j - ac;
                        ad = p * p + q * q;
                    }
                    else {
                        let ah = x * x + y * y;
                        if (ah <= ag) {
                            p = l - ab;
                            q = m - ac;
                            ad = p * p + q * q;
                        }
                        else {
                            let ai = ag / ah;
                            p = i + ai * x - ab;
                            q = j + ai * y - ac;
                            ad = p * p + q * q;
                        }
                    }
                    if (ad >= o) {
                        o = ad;
                        n = z;
                    }
                }
            }
            if (n != -1) {
                FastFlattener.i(a, b, c, d, e, n, g);
                a.add(n);
                FastFlattener.i(a, b, c, d, n, f, g);
            }
            return;
        }
    }
    FastFlattener.$t = /*@__PURE__*/ markType(FastFlattener, 'FastFlattener');
    return FastFlattener;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpiralTodo = /*@__PURE__*/ (() => {
    class SpiralTodo extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
    }
    SpiralTodo.$t = /*@__PURE__*/ markType(SpiralTodo, 'SpiralTodo');
    return SpiralTodo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpiralFlattener = /*@__PURE__*/ (() => {
    class SpiralFlattener extends Base {
        constructor() {
            super();
        }
        static a(a, b, c, d, e) {
            if (isNaN_(e) || e <= 0) {
                e = 1;
            }
            let f = new List$1(Number_$type, 0);
            let g = new Stack$1(SpiralTodo.$);
            let h = (d - b) / (c - a);
            let i = b - h * a;
            let j = h * h;
            let k = i * i;
            let l = i * h;
            g.h(((() => {
                let $ret = new SpiralTodo();
                $ret.a = 0;
                $ret.b = 1;
                return $ret;
            })()));
            while (g.f != 0) {
                let m = g.e();
                let n = b + m.a * (d - b);
                let o = a + m.a * (c - a);
                let p = o * o;
                let q = p * o;
                let r = b + m.b * (d - b);
                let s = a + m.b * (c - a);
                let t = s * s;
                let u = t * s;
                let v;
                if (h == 0) {
                    v = k * (s - o) / 2 + l * (t - p) / 2 + j * (u - q) / 6;
                }
                else {
                    v = (Math.pow(i + h * s, 3) - Math.pow(i + h * o, 3)) / (6 * h);
                }
                let w = 0.5 * n * r * Math.sin(s - o);
                if (v - w > e) {
                    let x = 0.5 * (m.a + m.b);
                    g.h(((() => {
                        let $ret = new SpiralTodo();
                        $ret.a = x;
                        $ret.b = m.b;
                        return $ret;
                    })()));
                    g.h(((() => {
                        let $ret = new SpiralTodo();
                        $ret.a = m.a;
                        $ret.b = x;
                        return $ret;
                    })()));
                }
                else {
                    f.add(m.a);
                }
            }
            f.add(1);
            return f;
        }
    }
    SpiralFlattener.$t = /*@__PURE__*/ markType(SpiralFlattener, 'SpiralFlattener');
    return SpiralFlattener;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AngleSimplifier = /*@__PURE__*/ (() => {
    class AngleSimplifier extends Base {
        static a(a) {
            if (isNaN_(a) || isInfinity(a)) {
                return a;
            }
            while (a > 360) {
                a -= 360;
            }
            while (a < 0) {
                a += 360;
            }
            return a;
        }
    }
    AngleSimplifier.$t = /*@__PURE__*/ markType(AngleSimplifier, 'AngleSimplifier');
    return AngleSimplifier;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyLineSegment = /*@__PURE__*/ (() => {
    class PolyLineSegment extends PathSegment {
        constructor() {
            super();
            this._points = null;
            this._points = new PointCollection(0);
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        get_a() {
            return 3;
        }
        get a() {
            return this.get_a();
        }
    }
    PolyLineSegment.$t = /*@__PURE__*/ markType(PolyLineSegment, 'PolyLineSegment', PathSegment.$);
    return PolyLineSegment;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigureUtil = /*@__PURE__*/ (() => {
    class PathFigureUtil extends Base {
        static b(a) {
            let b = new PathFigureCollection();
            for (let c of fromEnum(a)) {
                b.add(PathFigureUtil.a(c));
            }
            return b;
        }
        static a(a) {
            if (a == null) {
                return null;
            }
            let b = new PathSegmentCollection();
            for (let c of fromEnum(a._segments)) {
                switch (c.a) {
                    case 4:
                        let d = c;
                        let e = new ArcSegment();
                        e.b = d.b;
                        e.e = d.e;
                        e.c = d.c;
                        e.f = d.f;
                        e.d = d.d;
                        b.add(e);
                        break;
                    case 0:
                        let f = c;
                        let g = new LineSegment(1);
                        g.c = f.c;
                        b.add(g);
                        break;
                    case 3:
                        let h = c;
                        let i = new PolyLineSegment();
                        for (let j of fromEnum(h._points)) {
                            i._points.add(j);
                        }
                        b.add(i);
                        break;
                }
            }
            return ((() => {
                let $ret = new PathFigure();
                $ret.isClosed = a._isClosed;
                $ret.isFilled = a._isFilled;
                $ret.startPoint = a._startPoint;
                $ret.segments = b;
                return $ret;
            })());
        }
    }
    PathFigureUtil.$t = /*@__PURE__*/ markType(PathFigureUtil, 'PathFigureUtil');
    return PathFigureUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolygonUtil = /*@__PURE__*/ (() => {
    class PolygonUtil extends Base {
        static a(a, b) {
            if (a == null) {
                return false;
            }
            let c = a.count;
            if (c < 4) {
                return false;
            }
            let d = false;
            for (let e = 0, f = c - 1; e < c; f = e++) {
                if (((a.item(e).y > b.y) != (a.item(f).y > b.y)) && (b.x < (a.item(f).x - a.item(e).x) * (b.y - a.item(e).y) / (a.item(f).y - a.item(e).y) + a.item(e).x)) {
                    d = !d;
                }
            }
            return d;
        }
    }
    PolygonUtil.$t = /*@__PURE__*/ markType(PolygonUtil, 'PolygonUtil');
    return PolygonUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolySimplification = /*@__PURE__*/ (() => {
    class PolySimplification extends Base {
        static b(a, b) {
            let c = a.c;
            let d = a.d;
            if (c.length == 0) {
                return 0;
            }
            let e = 0;
            let f = 0;
            let g = b * b;
            e++;
            let h;
            let i;
            let j;
            for (let k = 0; k < c.length; k++) {
                h = c[k] - c[f];
                i = d[k] - d[f];
                j = (h * h) + (i * i);
                if (j > g) {
                    c[e] = c[k];
                    d[e] = d[k];
                    e++;
                    f = k;
                }
            }
            return e;
        }
        static a(a, b) {
            let c = b.x - a.x;
            let d = b.y - a.y;
            return (c * c) + (d * d);
        }
    }
    PolySimplification.$t = /*@__PURE__*/ markType(PolySimplification, 'PolySimplification');
    return PolySimplification;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISmartPlaceable_$type = /*@__PURE__*/ new Type(null, 'ISmartPlaceable');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SmartPlaceableWrapper$1 = /*@__PURE__*/ (() => {
    class SmartPlaceableWrapper$1 extends Base {
        constructor($t) {
            super();
            this.$t = null;
            this.f = false;
            this.c = null;
            this.g = null;
            this.i = null;
            this.a = [4];
            this.b = [4, 5, 2, 1, 8, 7, 0, 3, 6];
            this.j = new Size();
            this.e = 0;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.f = false;
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a;
        }
        getSmartPositions() {
            if (this.f) {
                return this.a;
            }
            else {
                return this.b;
            }
        }
        k() {
            return this.j;
        }
        getSmartBounds(a) {
            let b = this.k();
            let c = b.width;
            let d = b.height;
            let e;
            {
                e = this.h(a, c, d);
            }
            return new Rect(0, this.i.x + e.x, this.i.y + e.y, c, d);
        }
        get opacity() {
            return this.d._opacity;
        }
        set opacity(a) {
            this.d._opacity = a;
        }
        get smartPosition() {
            return this.e;
        }
        set smartPosition(a) {
            this.e = a;
            let b = this.k();
            let c = b.height;
            let d = b.width;
            let e;
            {
                e = this.h(this.e, d, c);
            }
            this.g = { $type: Point_$type, x: this.i.x + e.x, y: this.i.y + e.y };
        }
        h(a, b, c) {
            let d = 0.25;
            switch (a) {
                case 0: return { $type: Point_$type, x: -b * d, y: -c * d };
                case 1: return { $type: Point_$type, x: 0, y: -c * d };
                case 2: return { $type: Point_$type, x: b * d, y: -c * d };
                case 3: return { $type: Point_$type, x: -b * d, y: 0 };
                case 4: return { $type: Point_$type, x: 0, y: 0 };
                case 5: return { $type: Point_$type, x: b * d, y: 0 };
                case 6: return { $type: Point_$type, x: -b * d, y: c * d };
                case 7: return { $type: Point_$type, x: 0, y: c * d };
                default: return { $type: Point_$type, x: b * d, y: c * d };
            }
        }
    }
    SmartPlaceableWrapper$1.$t = /*@__PURE__*/ markType(SmartPlaceableWrapper$1, 'SmartPlaceableWrapper$1', Base.$, [ISmartPlaceable_$type]);
    return SmartPlaceableWrapper$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions for smart label placement with respect to the notional rectangle's
 * origin
 */
var SmartPosition = /*@__PURE__*/ (function (SmartPosition) {
    /**
     * Specifies left top as a valid smart placement position.
     */
    SmartPosition[SmartPosition["LeftTop"] = 0] = "LeftTop";
    /**
     * Specifies center top as a valid smart placement position.
     */
    SmartPosition[SmartPosition["CenterTop"] = 1] = "CenterTop";
    /**
     * Specifies right top as a valid smart placement position.
     */
    SmartPosition[SmartPosition["RightTop"] = 2] = "RightTop";
    /**
     * Specifies left center as a valid smart placement position.
     */
    SmartPosition[SmartPosition["LeftCenter"] = 3] = "LeftCenter";
    /**
     * Specifies center center as a valid smart placement position.
     */
    SmartPosition[SmartPosition["CenterCenter"] = 4] = "CenterCenter";
    /**
     * Specifies right center as a valid smart placement position.
     */
    SmartPosition[SmartPosition["RightCenter"] = 5] = "RightCenter";
    /**
     * Specifies left bottom as a valid smart placement position.
     */
    SmartPosition[SmartPosition["LeftBottom"] = 6] = "LeftBottom";
    /**
     * Specifies center bottom as a valid smart placement position.
     */
    SmartPosition[SmartPosition["CenterBottom"] = 7] = "CenterBottom";
    /**
     * Specifies right bottom as a valid smart placement position.
     */
    SmartPosition[SmartPosition["RightBottom"] = 8] = "RightBottom";
    return SmartPosition;
})({});
/**
 * @hidden
 */
let SmartPosition_$type = /*@__PURE__*/ markEnum('SmartPosition', 'LeftTop,0|CenterTop,1|RightTop,2|LeftCenter,3|CenterCenter,4|RightCenter,5|LeftBottom,6|CenterBottom,7|RightBottom,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SmartPlacer = /*@__PURE__*/ (() => {
    class SmartPlacer extends Base {
        constructor() {
            super();
            this.e = null;
            this.c = 0;
            this.b = 0;
            this.a = new List$1(Rect.$, 0);
            this.e = Rect.empty;
            this.c = 0.3;
            this.b = 2;
        }
        d(a) {
            if (a == null) {
                return;
            }
            let b = 1.7976931348623157E+308;
            let c = Rect.empty;
            let d = 7;
            let e = false;
            let h = a.getSmartPositions();
            for (let g = 0; g < h.length; g++) {
                let f = h[g];
                let i = a.getSmartBounds(f);
                if (this.e.isEmpty || this.e.containsRect(i)) {
                    let j = 0;
                    for (let k of fromEnum(this.a)) {
                        j += RectUtil.i(i, k);
                    }
                    if (j == 0) {
                        b = j;
                        d = f;
                        c = i;
                        e = true;
                        break;
                    }
                    if (j < b) {
                        b = j;
                        d = f;
                        c = i;
                        e = true;
                    }
                }
            }
            let l = 0;
            if (e) {
                l = b / RectUtil.e(c);
            }
            if (!e || l > this.c) {
                a.opacity = 0;
            }
            else {
                if (b > 0) {
                    a.opacity = Math.pow(1 - MathUtil.b(0, l, 1), this.b);
                }
                else {
                    a.opacity = 1;
                }
                a.smartPosition = d;
                this.a.add(c);
            }
        }
    }
    SmartPlacer.$t = /*@__PURE__*/ markType(SmartPlacer, 'SmartPlacer');
    return SmartPlacer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointCollectionUtil = /*@__PURE__*/ (() => {
    class PointCollectionUtil extends Base {
        static d(a, b, c) {
            if (b == null) {
                return;
            }
            b.clear();
            if (a.count >= 2) {
                let d = Flattener.d(a.count, (e) => a.item(e).x, (e) => a.item(e).y, c);
                for (let e of fromEnum(d)) {
                    b.add(a.item(e));
                }
            }
        }
        static g(a) {
            let b = Number.POSITIVE_INFINITY;
            let c = Number.POSITIVE_INFINITY;
            let d = Number.NEGATIVE_INFINITY;
            let e = Number.NEGATIVE_INFINITY;
            for (let f of fromEnum(a)) {
                b = Math.min(b, f.x);
                c = Math.min(c, f.y);
                d = Math.max(d, f.x);
                e = Math.max(e, f.y);
            }
            if (isInfinity(b) || isInfinity(c) || isInfinity(c) || isInfinity(e)) {
                return Rect.empty;
            }
            return new Rect(0, b, c, d - b, e - c);
        }
        static h(a) {
            let b = Rect.empty;
            for (let c of fromEnum(a)) {
                b.union(PointCollectionUtil.g(c));
            }
            return b;
        }
        static i(a) {
            let b = Number.POSITIVE_INFINITY;
            let c = Number.POSITIVE_INFINITY;
            let d = Number.NEGATIVE_INFINITY;
            let e = Number.NEGATIVE_INFINITY;
            let f;
            for (let g = 0; g < a.count; g++) {
                f = a.item(g);
                b = Math.min(b, f.x);
                c = Math.min(c, f.y);
                d = Math.max(d, f.x);
                e = Math.max(e, f.y);
            }
            if (isInfinity(b) || isInfinity(c) || isInfinity(c) || isInfinity(e)) {
                return Rect.empty;
            }
            return new Rect(0, b, c, d - b, e - c);
        }
        static j(a) {
            if (a == null) {
                return Rect.empty;
            }
            let b = Rect.empty;
            let c;
            for (let d = 0; d < a.count; d++) {
                c = a._inner[d];
                b.union(PointCollectionUtil.i(c));
            }
            return b;
        }
        static k(a) {
            let b = Rect.empty;
            let c;
            for (let d = 0; d < a.count; d++) {
                c = a._inner[d];
                b.union(PointCollectionUtil.i(c));
            }
            return b;
        }
        static c(a, b, c) {
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c.j(a.item(e));
            }
            c.i = null;
        }
        static e(a) {
            let b = 0;
            let c = 0;
            let d = 0;
            for (let e of fromEnum(a)) {
                b += e.x;
                c += e.y;
                d += 1;
            }
            return { $type: Point_$type, x: b / d, y: c / d };
        }
        static f(a) {
            let b = new PointCollection(0);
            for (let c of fromEnum(a)) {
                b.add(c);
            }
            return b;
        }
        static b(a) {
            let b = new List$1(Point_$type, 0);
            for (let c of fromEnum(a)) {
                b.add(c);
            }
            return b;
        }
        static a(a) {
            let b = new List$1(PointCollection.$, 0);
            let c;
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c = a._inner[e];
                let f = new PointCollection(1, c);
                b.add(f);
            }
            return b;
        }
    }
    PointCollectionUtil.$t = /*@__PURE__*/ markType(PointCollectionUtil, 'PointCollectionUtil');
    return PointCollectionUtil;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MouseEventArgs = /*@__PURE__*/ (() => {
    class MouseEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._position = null;
            this._originalSource = null;
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get originalSource() {
            return this._originalSource;
        }
        set originalSource(a) {
            this._originalSource = a;
        }
        getPosition(a) {
            return this.position;
        }
    }
    MouseEventArgs.$t = /*@__PURE__*/ markType(MouseEventArgs, 'MouseEventArgs', EventArgs.$);
    return MouseEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BaseDOMEventProxy = /*@__PURE__*/ (() => {
    class BaseDOMEventProxy extends EventProxy {
        constructor() {
            super(...arguments);
            this.bz = null;
            this.bq = false;
            this.bs = false;
            this.by = null;
            this.bj = false;
            this.bw = 0;
            this.bx = 0;
            this.bu = 0;
            this.bv = 0;
            this.b0 = 0;
            this.cy = null;
            this.cx = null;
            this.bi = false;
            this.b1 = -1;
            this.bn = false;
            this.bk = false;
            this.bh = false;
        }
        d() {
            let a = new DOMEventProxy(this.bz, this.by, this.bs);
            a.aa = this.aa;
            a.am = this.am;
            return a;
        }
        static get bt() {
            return (BaseDOMEventProxy.bo || BaseDOMEventProxy.bp);
        }
        bf(a) {
            return DOMEventProxy.cz(a);
        }
        bm(e_) {
            let pointerEvent_ = e_.originalEvent;
            let a = false;
            if (BaseDOMEventProxy.bp) {
                a = (pointerEvent_.pointerType == 'touch');
            }
            else {
                a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
            }
            return a;
        }
        cp(a) {
            if (!this.ac) {
                if (this.bl(a)) {
                    if (this.ao == null || this.ao(a)) {
                        a.preventDefault();
                    }
                }
            }
        }
        bl(e_) {
            return (e_.originalEvent.cancelable || e_.originalEvent.cancelable == undefined);
        }
        cl() {
            let source_ = this.bz.getNativeElement();
            BaseDOMEventProxy.co(source_);
        }
        static co(source_) {
            if (BaseDOMEventProxy.bp) {
                source_.style.touchAction = 'none';
            }
            else {
                source_.style.msTouchAction = 'none';
            }
            source_.style.msUserSelect = 'none';
            source_.style.webkitTouchCallout = 'none';
            source_.style.webkitUserSelect = 'none';
            source_.style.khtmlUserSelect = 'none';
            source_.style.mozUserSelect = 'none';
            source_.style.userSelect = 'none';
        }
        static ci(source_) {
            if (BaseDOMEventProxy.bp) {
                source_.style.touchAction = 'auto';
            }
            else {
                source_.style.msTouchAction = 'auto';
            }
            source_.style.msUserSelect = 'auto';
            source_.style.webkitTouchCallout = 'none';
            source_.style.webkitUserSelect = 'auto';
            source_.style.khtmlUserSelect = 'auto';
            source_.style.mozUserSelect = 'auto';
            source_.style.userSelect = 'auto';
        }
        cj() {
            let source_ = this.bz.getNativeElement();
            BaseDOMEventProxy.ci(source_);
        }
        as() {
            super.as();
            if (!this.ac) {
                this.cl();
            }
            else {
                this.cj();
            }
        }
        b6() {
            let ver_ = -1;
            let matchIE_ = /Trident\/([\d.]+)/;
            if ((matchIE_.exec(navigator.userAgent) != null)) {
                ver_ = (parseFloat(RegExp.$1));
            }
            return ver_;
        }
        b5() {
            let ver_ = -1;
            let matchIE_ = /Edge\/([\d.]+)/;
            if ((matchIE_.exec(navigator.userAgent) != null)) {
                ver_ = (parseFloat(RegExp.$1));
            }
            return ver_;
        }
        static cn(e_) {
            let a = BaseDOMEventProxy.b7 >= 6;
            let oe_ = e_.originalEvent;
            if ((((typeof e_.pageX == 'undefined')) || a) && oe_.clientX != null) {
                let od_;
                if ((e_.target !== undefined)) {
                    od_ = e_.target.ownerDocument;
                }
                else {
                    od_ = e_.originalEvent.target.ownerDocument;
                }
                let ed_ = od_ ? od_ : document;
                let doc_ = ed_.documentElement;
                let body_ = ed_.body;
                let clientX_ = oe_.clientX;
                let clientY_ = oe_.clientY;
                let scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
                let scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
                let clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
                let clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
                e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
                e_.pageY = clientY_ + (scrollTop_ - clientTop_);
            }
            if ((!e_.pageX)) {
                e_.pageX = e_.originalEvent.pageX;
            }
            if ((!e_.pageY)) {
                e_.pageY = e_.originalEvent.pageY;
            }
            if (((typeof e_.button == 'undefined')) && ((typeof oe_.button != 'undefined'))) {
                e_.button = oe_.button;
            }
        }
        static cz(a) {
            let b = BaseDOMEventProxy.b7 >= 6;
            let source_ = a.getNativeElement();
            let d_ = source_.ownerDocument;
            let doc_ = d_ ? d_.documentElement : null;
            let z_ = doc_ ? doc_.msContentZoomFactor : null;
            let body_ = doc_.body;
            if ((z_ && z_ > 1) || b) {
                let rect_ = source_.getBoundingClientRect();
                let x_ = (rect_.left);
                let y_ = (rect_.top);
                let scrollLeft_ = (doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0);
                let scrollTop_ = (doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0);
                let clientLeft_ = (doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0);
                let clientTop_ = (doc_ && doc_.clientTop || body_ && body_.clientTop || 0);
                let c = x_ + scrollLeft_ - clientLeft_;
                let d = y_ + scrollTop_ - clientTop_;
                return new Rect(0, c, d, 0, 0);
            }
            else {
                let e = a.getOffset();
                return new Rect(0, e.left, e.top, 0, 0);
            }
        }
        get b3() {
            return this.b0;
        }
        set b3(a) {
            this.b0 = a;
        }
        cs(a) {
            this.ap = a;
            BaseDOMEventProxy.cn(a);
            let b = BaseDOMEventProxy.cz(this.bz);
            let c = 0;
            let d = 0;
            if (Rect.l_op_Inequality(this.bg, null)) {
                c = this.bg.left;
                d = this.bg.top;
            }
            this.bw = a.pageX - b.left;
            this.bx = a.pageY - b.top;
            this.bu = this.bw - c;
            this.bv = this.bx - d;
            this.cy = { $type: Point_$type, x: this.bw, y: this.bx };
            this.cx = { $type: Point_$type, x: this.bu, y: this.bv };
        }
        ct(e_) {
            this.ap = e_;
            BaseDOMEventProxy.cn(e_);
            if (BaseDOMEventProxy.bt) {
                let a = e_.pageX;
                let b = e_.pageY;
                let c = BaseDOMEventProxy.cz(this.bz);
                this.bw = a - c.left;
                this.bx = b - c.top;
            }
            else {
                this.b0 = 0;
                if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) {
                    return;
                }
                ;
                this.b0 = (e_.originalEvent.targetTouches.length);
                let d = (e_.originalEvent.targetTouches[0].pageX);
                let e = (e_.originalEvent.targetTouches[0].pageY);
                let f = BaseDOMEventProxy.cz(this.bz);
                this.bw = d - f.left;
                this.bx = e - f.top;
            }
            let g = 0;
            let h = 0;
            if (Rect.l_op_Inequality(this.bg, null)) {
                g = this.bg.left;
                h = this.bg.top;
            }
            this.bu = this.bw - g;
            this.bv = this.bx - h;
            this.cy = { $type: Point_$type, x: this.bw, y: this.bx };
            this.cx = { $type: Point_$type, x: this.bu, y: this.bv };
        }
        ch(e_) {
            this.cr(e_);
            if (this.ab(this.cy, false, true)) {
                let deltaY_ = 0;
                let ev_ = e_;
                deltaY_ = (ev_.originalEvent ? ev_.originalEvent.deltaY : ev_.deltaY);
                let deltaX_ = 0;
                deltaX_ = (ev_.originalEvent ? ev_.originalEvent.deltaX : ev_.deltaX);
                let a = (ev_.originalEvent ? (ev_.originalEvent.deltaMode == 1) : (ev_.deltaMode == 1));
                if (a) {
                    deltaY_ = deltaY_ * 40;
                    deltaX_ = deltaX_ * 40;
                }
                let b = this.ag(this.cx, deltaY_);
                let c = this.ah(this.cx, deltaX_);
                if (b || c) {
                    this.cp(e_);
                }
            }
        }
        cf(e_) {
            this.cr(e_);
            this.cs(e_);
            if (this.ab(this.cy, false, true)) {
                let ev_ = e_;
                let delta_ = 0;
                if (ev_.wheelDelta) {
                    delta_ = ev_.wheelDelta / 120;
                }
                ;
                if (ev_.originalEvent && ev_.originalEvent.wheelDelta) {
                    delta_ = ev_.originalEvent.wheelDelta / 120;
                }
                ;
                if (ev_.detail) {
                    delta_ = -ev_.detail / 3;
                }
                ;
                if (ev_.originalEvent && ev_.originalEvent.detail) {
                    delta_ = -ev_.originalEvent.detail / 3;
                }
                ;
                delta_ = delta_ / 10;
                let a = this.ag(this.cx, delta_);
                if (a) {
                    this.cp(e_);
                }
            }
        }
        cm() {
            if (this.bi) {
                if (this.b1 == -1) {
                    this.b1 = this.by.setTimeout(runOn(this, this.ck), 500);
                }
                else {
                    window.clearTimeout(this.b1);
                    this.b1 = -1;
                    this.b1 = this.by.setTimeout(runOn(this, this.ck), 500);
                }
            }
        }
        b8() {
            this.bi = true;
            if (this.b1 != -1) {
                window.clearTimeout(this.b1);
                this.b1 = -1;
            }
        }
        ck() {
            this.bi = false;
        }
        get br() {
            return this.bk;
        }
        set br(a) {
            this.bk = a;
        }
        cd(a) {
            if (this.bk || this.bi) {
                return;
            }
            this.cs(a);
            if (this.bn) {
                this.bn = false;
                this.a4(this.cx);
            }
        }
        ce(a) {
            if (this.bk || this.bi) {
                return;
            }
            this.cs(a);
            this.cr(a);
            let b = new MouseEventArgs();
            b.position = this.cy;
            if (this.ab(this.cy, false, false)) {
                if (!this.bn) {
                    this.bn = true;
                    this.a3(this.cy);
                }
                this.a5(this.cy, true, false);
                this.au(this.cx, false);
            }
            else if (this.bn) {
                this.cd(a);
            }
        }
        cq(a) {
            this.bz.focus(this.bq);
        }
        cc(a) {
            if (this.bk || this.bi) {
                return;
            }
            this.cq(a);
            this.cs(a);
            this.cr(a);
            if (this.ab(this.cy, false, false)) {
                this.bh = true;
                this.a2(this.cy);
                this.av(this.cx, false);
                this.cp(a);
            }
        }
        cu(a) {
            if (this.bk || this.bi) {
                return;
            }
            if (this.bh) {
                this.cg(a);
            }
        }
        cg(a) {
            if (this.bk || this.bi) {
                return;
            }
            this.cr(a);
            if (PointUtil.equals(this.cy, null) || PointUtil.equals(this.cx, null)) {
                this.cs(a);
            }
            let b = this.ab(this.cy, false, false) || this.bh || this.bn;
            this.bh = false;
            this.a6(this.cy);
            this.at(this.cx, false, false);
            if (b) {
                this.cp(a);
            }
        }
        b9(a) {
            this.ca(a, true);
        }
        cb(a) {
            this.ca(a, false);
        }
        cw(a) {
            return BaseDOMEventProxy.cv(a);
        }
        static cv(a) {
            let b;
            switch (a.which) {
                case 33:
                    b = 10;
                    break;
                case 34:
                    b = 11;
                    break;
                case 36:
                    b = 13;
                    break;
                case 37:
                    b = 14;
                    break;
                case 38:
                    b = 15;
                    break;
                case 39:
                    b = 16;
                    break;
                case 40:
                    b = 17;
                    break;
                case 9:
                    b = 2;
                    break;
                case 32:
                    b = 9;
                    break;
                case 13:
                    b = 3;
                    break;
                case 27:
                    b = 8;
                    break;
                case 16:
                    b = 4;
                    break;
                case 17:
                    b = 5;
                    break;
                case 18:
                    b = 6;
                    break;
                case 8:
                    b = 1;
                    break;
                case 35:
                    b = 12;
                    break;
                case 45:
                    b = 18;
                    break;
                case 46:
                    b = 19;
                    break;
                case 106:
                    b = 78;
                    break;
                case 107:
                    b = 79;
                    break;
                case 109:
                    b = 80;
                    break;
                case 110:
                    b = 81;
                    break;
                case 111:
                    b = 82;
                    break;
                case 220:
                    b = 85;
                    break;
                case 192:
                    b = 86;
                    break;
                case 191:
                    b = 84;
                    break;
                case 186:
                    b = 83;
                    break;
                case 189:
                    b = 88;
                    break;
                case 187:
                    b = 87;
                    break;
                default:
                    if (112 <= a.which && a.which <= 123) {
                        b = (56 + a.which - 112);
                    }
                    else if (65 <= a.which && a.which <= 90) {
                        b = (30 + a.which - 65);
                    }
                    else if (48 <= a.which && a.which <= 57) {
                        b = (20 + a.which - 48);
                    }
                    else if (96 <= a.which && a.which <= 105) {
                        b = (68 + a.which - 96);
                    }
                    else {
                        b = 0;
                    }
                    break;
            }
            return b;
        }
        ca(a, b) {
            let c = this.cw(a);
            let d = c != 0;
            this.cr(a);
            if (d) {
                let e = false;
                if (b) {
                    e = this.ae(c);
                }
                else {
                    e = this.af(c);
                }
                if (e) {
                    this.cp(a);
                }
            }
        }
        cr(a) {
            this.ap = a;
            this.bd = 0;
            if (a.shiftKey) {
                this.bd = this.bd | 4;
            }
            if (a.altKey) {
                this.bd = this.bd | 1;
            }
            if (a.ctrlKey) {
                this.bd = this.bd | 2;
            }
            this.ai = a.button == 2;
        }
        be() {
            let a = BaseDOMEventProxy.cz(this.bz);
            let b = a.left;
            let c = a.top;
            return { $type: Point_$type, x: b, y: c };
        }
    }
    BaseDOMEventProxy.$t = /*@__PURE__*/ markType(BaseDOMEventProxy, 'BaseDOMEventProxy', EventProxy.$);
    BaseDOMEventProxy.bo = false;
    BaseDOMEventProxy.bp = false;
    BaseDOMEventProxy.b7 = 0;
    BaseDOMEventProxy.b4 = 0;
    return BaseDOMEventProxy;
})();
/**
 * @hidden
 */
let DOMEventProxy = /*@__PURE__*/ (() => {
    class DOMEventProxy extends BaseDOMEventProxy {
        constructor(a, b, c) {
            super();
            this.da = 0;
            this.db = "";
            this.c1 = false;
            this.c7 = null;
            this.c3 = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.dy = null;
            this.c8 = -1;
            this.dz = null;
            this.c5 = 0;
            this.c6 = 0;
            this.c4 = 5;
            this.c0 = false;
            this.dx = null;
            this.bs = c;
            this.by = b;
            this.am = (d) => true;
            this.aa = false;
            DOMEventProxy.c9++;
            this.da = DOMEventProxy.c9;
            this.db = ".DOMProxy" + this.da.toString();
            this.bd = 0;
            this.bz = a;
            BaseDOMEventProxy.bo = false;
            try {
                BaseDOMEventProxy.bo = (window.navigator.msPointerEnabled && MSGesture !== undefined);
            }
            catch (d) {
            }
            BaseDOMEventProxy.bp = false;
            try {
                BaseDOMEventProxy.bp = (window.PointerEvent || window.navigator.pointerEnabled);
            }
            catch (e) {
            }
            BaseDOMEventProxy.b7 = this.b6();
            BaseDOMEventProxy.b4 = this.b5();
            this.aq(this.bz, "");
            this.al = (f) => true;
        }
        dc(a, b, c) {
        }
        aq(a, b) {
            let c = a;
            let d = this.db + b;
            if (!this.by.supportsDOMEvents()) {
                return;
            }
            let e = new List$1(Delegate_$type, 0);
            this.c3.addItem(d, e);
            this.dc(a, b, e);
            if (!BaseDOMEventProxy.bt) {
                e.add(c.listen("mousemove", runOn(this, this.ce)));
                e.add(c.listen("mouseleave", runOn(this, this.cd)));
                e.add(c.listen("mousedown", runOn(this, this.cc)));
                e.add(c.listen("mouseup", runOn(this, this.cg)));
                e.add(this.by.globalListen("window", "mouseup", runOn(this, this.cu)));
            }
            e.add(c.listen("keydown", runOn(this, this.b9)));
            e.add(c.listen("keyup", runOn(this, this.cb)));
            let source_ = this.bz.getNativeElement();
            if (!this.ac) {
                BaseDOMEventProxy.co(source_);
            }
            if (BaseDOMEventProxy.bt) {
                let f = this.bz.getNativeElement();
                if ((window.MSGesture !== undefined)) {
                    let g = (new MSGesture());
                    g.target = f;
                    this.c7 = g;
                    e.add(c.listen("MSGestureStart", runOn(this, this.df)));
                    e.add(c.listen("MSGestureChange", runOn(this, this.dd)));
                    e.add(c.listen("MSGestureEnd", runOn(this, this.de)));
                }
                if (BaseDOMEventProxy.bp) {
                    e.add(c.listen("pointerdown", runOn(this, this.di)));
                    e.add(c.listen("pointerup", runOn(this, this.dl)));
                    e.add(c.listen("pointercancel", runOn(this, this.dh)));
                    e.add(c.listen("pointermove", runOn(this, this.dj)));
                    e.add(c.listen("pointerout", runOn(this, this.dk)));
                    e.add(c.listen("lostpointercapture", runOn(this, this.dg)));
                }
                else {
                    e.add(c.listen("MSPointerDown", runOn(this, this.di)));
                    e.add(c.listen("MSPointerUp", runOn(this, this.dl)));
                    e.add(c.listen("MSPointerCancel", runOn(this, this.dh)));
                    e.add(c.listen("MSPointerMove", runOn(this, this.dj)));
                    e.add(c.listen("MSPointerOut", runOn(this, this.dk)));
                    e.add(c.listen("MSLostPointerCapture", runOn(this, this.dg)));
                }
            }
            else {
                e.add(c.listen("gesturestart", runOn(this, this.df)));
                e.add(c.listen("gesturechange", runOn(this, this.dd)));
                e.add(c.listen("gestureend", runOn(this, this.de)));
                e.add(c.listen("touchstart", runOn(this, this.dp)));
                e.add(c.listen("touchmove", runOn(this, this.dn)));
                e.add(c.listen("touchend", runOn(this, this.dm)));
            }
            if (this.bs) {
                e.add(c.listen("wheel", runOn(this, this.ch)));
            }
            else {
                e.add(c.listen("DOMMouseScroll", runOn(this, this.cf)));
                e.add(c.listen("mousewheel", runOn(this, this.cf)));
            }
        }
        dl(e_) {
            let a = this.bm(e_);
            if (a) {
                this.b3 = this.b3 - 1;
                if (this.b3 < 0) {
                    this.b3 = 0;
                }
            }
            if (this.b3 < 2 && this.c1 && a) {
                this.c1 = false;
                let b = (e_.originalEvent.scale);
                this.a0(this.cx, b);
            }
            else {
                if (a) {
                    this.dm(e_);
                }
                else {
                    this.cg(e_);
                }
            }
        }
        dg(e_) {
            let a = this.bm(e_);
            if (a) {
                this.b3--;
                if (this.b3 < 0) {
                    this.b3 = 0;
                }
            }
            if (this.b3 < 2 && this.c1 && a) {
                this.c1 = false;
                let b = (e_.originalEvent.scale);
                this.a0(this.cx, b);
            }
        }
        dh(e_) {
            let a = this.bm(e_);
            if (a) {
                this.b3--;
                if (this.b3 < 0) {
                    this.b3 = 0;
                }
            }
            if (this.b3 < 2 && this.c1 && a) {
                this.c1 = false;
                let b = (e_.originalEvent.scale);
                this.a0(this.cx, b);
            }
        }
        di(e_) {
            let a = this.bm(e_);
            if (this.c7 != null && a) {
                this.b3++;
                this.c7.addPointer((e_.originalEvent.pointerId));
            }
            let eventSource_ = this.bz.getNativeElement();
            if (BaseDOMEventProxy.bp) {
                eventSource_.setPointerCapture(e_.originalEvent.pointerId);
            }
            else {
                eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
            }
            if (this.b3 > 1 && !this.c1 && a) {
                this.c1 = true;
                this.ct(e_);
                let b = (e_.originalEvent.scale);
                this.a8(this.cx, b);
            }
            else {
                if (a) {
                    this.dp(e_);
                }
                else {
                    this.cc(e_);
                }
            }
        }
        dj(e_) {
            let a = this.bm(e_);
            if (this.c1) {
                return;
            }
            if (a) {
                this.dn(e_);
            }
            else {
                this.ce(e_);
            }
        }
        dk(e_) {
            let a = this.bm(e_);
            if (this.c1) {
                return;
            }
            if (a) {
            }
            else {
                this.cd(e_);
            }
        }
        df(e_) {
            this.bn = true;
            this.cr(e_);
            this.ct(e_);
            this.dr();
            if (this.ab(this.cy, true, false)) {
                this.cp(e_);
                if (BaseDOMEventProxy.bt && this.b3 < 2) {
                    return;
                }
                let a = (e_.originalEvent.scale);
                this.a8(this.cx, a);
            }
        }
        dd(e_) {
            this.bn = true;
            this.cr(e_);
            this.ct(e_);
            if (this.ab(this.cy, true, false)) {
                this.cp(e_);
                if (BaseDOMEventProxy.bt && this.b3 < 2) {
                    return;
                }
                let a = (e_.originalEvent.scale);
                this.a7(this.cx, a);
            }
        }
        de(e_) {
            this.cp(e_);
            let a = (e_.originalEvent.scale);
            this.bn = false;
            this.cr(e_);
            this.ct(e_);
            if (!BaseDOMEventProxy.bt || this.c1) {
                this.a0(this.cx, a);
            }
        }
        dp(e_) {
            this.bn = true;
            this.cr(e_);
            this.ct(e_);
            this.dy = this.cx;
            if (this.ab(this.cy, true, false)) {
                if (!this.aa) {
                    this.cp(e_);
                }
                else {
                    this.br = true;
                }
                this.a5(this.cy, false, true);
                this.a2(this.cy);
                this.av(this.cx, true);
                this.du();
            }
        }
        du() {
            if (this.c8 == -1) {
                this.c5 = this.cy.x;
                this.c6 = this.cy.y;
                this.c8 = this.by.setTimeout(runOn(this, this.ds), 1500);
            }
        }
        dr() {
            if (Math.abs(this.c5 - this.cy.x) > this.c4 || Math.abs(this.c6 - this.cy.y) > this.c4) {
                this.dv();
            }
        }
        dv() {
            if (this.c8 != -1) {
                window.clearTimeout(this.c8);
                this.c8 = -1;
            }
        }
        ds() {
            this.c8 = -1;
            if (this.br) {
                this.br = false;
                this.b8();
            }
            this.a1(this.cx);
        }
        dn(a) {
            this.bn = true;
            this.cr(a);
            this.ct(a);
            if (this.br) {
                if (this.ab(this.cy, true, false) && this.c2()) {
                    this.br = false;
                    this.b8();
                }
            }
            this.dr();
            this.dw();
            if (this.ab(this.cy, true, false) && this.b3 == 1 && !this.br) {
                this.cp(a);
                if (!this.c0) {
                    this.c0 = true;
                    this.dx = this.cx;
                    this.az(this.dx);
                }
                else {
                    this.a5(this.cy, true, true);
                    this.au(this.cx, true);
                    this.ay(this.cx);
                }
            }
        }
        c2() {
            let a = { $type: Point_$type, x: this.dy.x - this.cx.x, y: this.dy.y - this.cx.y };
            if (Math.abs(a.x) < 2 && Math.abs(a.y) < 2) {
                return false;
            }
            if (Math.abs(a.x) > Math.abs(a.y)) {
                a.y = 0;
            }
            if (Math.abs(a.y) > Math.abs(a.x)) {
                a.x = 0;
            }
            return this.am(a);
        }
        dm(a) {
            this.bn = false;
            this.cr(a);
            this.ct(a);
            this.dv();
            if (this.br) {
                this.br = false;
                this.b8();
            }
            this.cp(a);
            this.a5(this.cy, false, true);
            this.a6(this.cy);
            if (this.b3 == 0) {
                this.dt(this.cy);
                this.cm();
            }
            if (this.c0 && this.b3 == 0) {
                this.c0 = false;
                this.dx = null;
                this.ax(this.cx);
                this.cm();
            }
            this.at(this.cx, true, this.b3 > 0);
        }
        dt(a) {
            if (Rect.l_op_Equality(this.dz, null)) {
                this.dz = new Rect(0, a.x - 50, a.y - 50, 100, 100);
                this.by.setTimeout(runOn(this, this.dw), 500);
            }
            else {
                if (a.x >= this.dz.x && a.x <= this.dz.right && a.y >= this.dz.y && a.y <= this.dz.bottom) {
                    this.dw();
                    this.aw(a);
                }
            }
        }
        dw() {
            this.dz = null;
        }
        dq(a) {
            if (this.c3.containsKey(a)) {
                let b = this.c3.item(a);
                this.c3.removeItem(a);
                for (let c = 0; c < b.count; c++) {
                    b._inner[c]();
                }
                b.clear();
            }
        }
        bc(a, b) {
            let c = a;
            let d = this.db + b;
            this.dq(d);
        }
        ar() {
            if (this.bz == null) {
                return;
            }
            this.dq(this.db);
            this.bz = null;
        }
    }
    DOMEventProxy.$t = /*@__PURE__*/ markType(DOMEventProxy, 'DOMEventProxy', BaseDOMEventProxy.$);
    DOMEventProxy.c9 = 0;
    return DOMEventProxy;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchPointInfo = /*@__PURE__*/ (() => {
    class TouchPointInfo extends Base {
        constructor(a, ..._rest) {
            super();
            this.a = 0;
            this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.a = c;
                        this.b = d;
                    }
                    break;
                case 1: break;
            }
        }
    }
    TouchPointInfo.$t = /*@__PURE__*/ markType(TouchPointInfo, 'TouchPointInfo');
    return TouchPointInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchHistoryItem = /*@__PURE__*/ (() => {
    class TouchHistoryItem extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
            this.c = 0;
        }
    }
    TouchHistoryItem.$t = /*@__PURE__*/ markType(TouchHistoryItem, 'TouchHistoryItem');
    return TouchHistoryItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchVelocityReading = /*@__PURE__*/ (() => {
    class TouchVelocityReading extends Base {
        constructor() {
            super(...arguments);
            this.a = 0;
            this.b = 0;
        }
    }
    TouchVelocityReading.$t = /*@__PURE__*/ markType(TouchVelocityReading, 'TouchVelocityReading');
    return TouchVelocityReading;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchVelocityTracker = /*@__PURE__*/ (() => {
    class TouchVelocityTracker extends Base {
        constructor() {
            super(...arguments);
            this.a = new Array(5);
            this.d = 0;
        }
        g(a, b, c) {
            if (isNaN_(a) || isNaN_(b)) {
                return;
            }
            let d = ((() => {
                let $ret = new TouchHistoryItem();
                $ret.a = a;
                $ret.b = b;
                $ret.c = c;
                return $ret;
            })());
            this.a[this.d] = d;
            this.d++;
            if (this.d > 5 - 1) {
                this.d = 0;
            }
        }
        f() {
            this.d = 0;
            for (let a = 0; a < 5; a++) {
                this.a[a] = null;
            }
        }
        b(a) {
            let b = a;
            let c = NaN;
            let d = NaN;
            let e = NaN;
            let f = NaN;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = 0; j < 5; j++) {
                if (this.a[j] == null) {
                    continue;
                }
                let k = (this.a[j].c - b) > 300;
                if (k) {
                    continue;
                }
                if (i) {
                    i = false;
                    c = this.a[j].a;
                    d = this.a[j].a;
                    e = this.a[j].b;
                    f = this.a[j].b;
                    g = this.a[j].c;
                    h = this.a[j].c;
                }
                else {
                    if (this.a[j].c < g) {
                        g = this.a[j].c;
                        d = this.a[j].a;
                        f = this.a[j].b;
                    }
                    if (this.a[j].c > h) {
                        h = this.a[j].c;
                        c = this.a[j].a;
                        e = this.a[j].b;
                    }
                }
            }
            if (g == h || isNaN_(c) || isNaN_(d) || isNaN_(e) || isNaN_(f)) {
                return ((() => {
                    let $ret = new TouchVelocityReading();
                    $ret.a = NaN;
                    $ret.b = NaN;
                    return $ret;
                })());
            }
            return ((() => {
                let $ret = new TouchVelocityReading();
                $ret.a = (c - d) / ((h - g) / 1000);
                $ret.b = (e - f) / ((h - g) / 1000);
                return $ret;
            })());
        }
    }
    TouchVelocityTracker.$t = /*@__PURE__*/ markType(TouchVelocityTracker, 'TouchVelocityTracker');
    return TouchVelocityTracker;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchGestureEventArgs = /*@__PURE__*/ (() => {
    class TouchGestureEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.d = 0;
            this.e = 0;
            this.c = 0;
            this.f = 0;
            this.g = 0;
            this.a = 0;
            this.b = 0;
            this.h = 0;
            this.i = 0;
        }
    }
    TouchGestureEventArgs.$t = /*@__PURE__*/ markType(TouchGestureEventArgs, 'TouchGestureEventArgs');
    return TouchGestureEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchGestureRecognizer = /*@__PURE__*/ (() => {
    class TouchGestureRecognizer extends Base {
        constructor(a) {
            super();
            this.n = 0;
            this.p = new TouchVelocityTracker();
            this.t = 0;
            this.u = 0;
            this.aa = 0;
            this.ab = 0;
            this.v = 0;
            this.w = 0;
            this.am = NaN;
            this.an = NaN;
            this.al = NaN;
            this.aj = 1;
            this.ak = 1;
            this.y = 1;
            this.x = 10;
            this.ay = -1;
            this.ao = 0;
            this.ap = 0;
            this.az = 0;
            this.af = 1;
            this.ag = 1;
            this.ac = 1;
            this.ad = NaN;
            this.ae = NaN;
            this.o = null;
            this.au = 800;
            this.aw = -1;
            this.b = null;
            this.q = false;
            this.ax = -1;
            this.holdStarting = null;
            this.holdEnding = null;
            this.panStarting = null;
            this.manipulationStarting = null;
            this.manipulationChanging = null;
            this.manipulationEnding = null;
            this.panEnding = null;
            this.zoomStarting = null;
            this.zoomEnding = null;
            this.flingStarting = null;
            this.doubleTapped = null;
            this.ah = 0;
            this.ai = 0;
            this.z = 0;
            this.aq = 0;
            this.ar = 0;
            this.az = 500;
            this.n = 0;
            this.b = a;
        }
        get av() {
            return this.x;
        }
        set av(a) {
            this.x = a;
        }
        get as() {
            return this.t;
        }
        get at() {
            return this.u;
        }
        bf() {
            return { $type: Point_$type, x: Math.abs(this.v - this.aa), y: Math.abs(this.w - this.ab) };
        }
        bd(a) {
            let b = false;
            if (!isNaN_(this.aa) && !isNaN_(this.ab)) {
                this.v = a._inner[0].a;
                this.w = a._inner[0].b;
                if (Math.abs(a._inner[0].a - this.aa) > this.x || Math.abs(a._inner[0].b - this.ab) > this.x) {
                    b = true;
                }
            }
            if (b) {
                this.bc();
            }
        }
        a6(a) {
            let b = a.count;
            let c = this.n;
            let d = false;
            let e = false;
            let f = false;
            let g = false;
            let h = false;
            let i = false;
            let j = false;
            let k = false;
            let l = 0;
            let m = 0;
            let n = 0;
            let o = this.n;
            if (b > 0 && b < 2) {
                switch (this.n) {
                    case 5:
                        c = 4;
                        e = true;
                        j = true;
                        break;
                    case 0:
                        c = 4;
                        e = true;
                        break;
                    case 2:
                        c = 1;
                        j = true;
                        g = true;
                        break;
                }
            }
            if (b > 1) {
                switch (this.n) {
                    case 5:
                        c = 2;
                        h = true;
                        k = true;
                        break;
                    case 4:
                        f = true;
                        c = 2;
                        h = true;
                        break;
                    case 0:
                        c = 2;
                        h = true;
                        break;
                    case 1:
                        c = 2;
                        i = true;
                        h = true;
                        break;
                }
            }
            if (b == 0) {
                switch (this.n) {
                    case 4:
                        if (this.r(new TouchPointInfo(0, this.t, this.u))) {
                            c = 0;
                            f = true;
                            if (this.doubleTapped != null) {
                                this.doubleTapped(this, this.c());
                            }
                        }
                        else {
                            f = true;
                            c = 0;
                        }
                        break;
                    case 1:
                        c = 0;
                        i = true;
                        break;
                    case 2:
                        c = 0;
                        g = true;
                        break;
                    case 3:
                        c = 0;
                        d = true;
                        break;
                }
            }
            if (k) {
                if (j) {
                    if (this.panEnding != null) {
                        this.panEnding(this, this.c());
                    }
                    if (this.manipulationEnding != null) {
                        this.manipulationEnding(this, this.c());
                    }
                }
                this.a1();
            }
            if (e) {
                this.aa = a._inner[0].a;
                this.ab = a._inner[0].b;
            }
            if (c == 4) {
                if (!isNaN_(this.aa) && !isNaN_(this.ab)) {
                    this.v = a._inner[0].a;
                    this.w = a._inner[0].b;
                    if (Math.abs(a._inner[0].a - this.aa) > this.x || Math.abs(a._inner[0].b - this.ab) > this.x) {
                        f = true;
                        j = true;
                        c = 1;
                    }
                }
            }
            let p = 0;
            let q = 0;
            for (let r = 0; r < b; r++) {
                p += a._inner[r].a;
                q += a._inner[r].b;
            }
            p /= b;
            q /= b;
            if (b == 0) {
                p = this.ad;
                q = this.ae;
            }
            this.t = p;
            this.u = q;
            this.p.g(this.t, this.u, this.a0());
            if (h) {
                let s = a._inner[0].a - a._inner[1].a;
                let t = a._inner[0].b - a._inner[1].b;
                this.am = Math.abs(s);
                this.an = Math.abs(t);
                this.al = Math.sqrt(s * s + t * t);
                if (this.am < 1) {
                    this.am = 1;
                }
                if (this.an < 1) {
                    this.an = 1;
                }
                if (this.al < 1) {
                    this.al = 1;
                }
            }
            if (c == 2) {
                let u = a._inner[0].a - a._inner[1].a;
                let v = a._inner[0].b - a._inner[1].b;
                l = Math.abs(u);
                m = Math.abs(v);
                n = Math.sqrt(u * u + v * v);
                if (l < 1) {
                    l = 1;
                }
                if (m < 1) {
                    m = 1;
                }
                if (n < 1) {
                    n = 1;
                }
                this.aj = l / this.am;
                this.ak = m / this.an;
                this.y = n / this.al;
            }
            else {
                this.am = NaN;
                this.an = NaN;
                this.aj = 1;
                this.ak = 1;
                this.ah = 1;
                this.ai = 1;
                this.z = 1;
            }
            this.n = c;
            if (o == 0 && this.n == 1 || this.n == 2) {
                if (this.manipulationStarting != null) {
                    this.manipulationStarting(this, this.c());
                }
            }
            if (g) {
                this.a5();
            }
            if (i) {
                this.a4();
            }
            if (d) {
                this.a3();
            }
            if (f) {
                this.bc();
            }
            if (j) {
                this.ba();
            }
            if (e) {
                this.a9();
            }
            if (h) {
                this.bb();
            }
            if (this.n == 2) {
                this.ah = this.aj / this.af;
                this.ai = this.ak / this.ag;
                this.z = this.y / this.ac;
                this.aq = this.t - this.ad;
                this.ar = this.u - this.ae;
                this.af = this.af * this.ah;
                this.ag = this.ag * this.ai;
                this.ac = this.ac * this.z;
                this.ad = this.t;
                this.ae = this.u;
                if (this.manipulationChanging != null) {
                    this.manipulationChanging(this, this.c());
                }
            }
            if (this.n == 1) {
                this.aq = this.t - this.ad;
                this.ar = this.u - this.ae;
                this.ad = this.t;
                this.ae = this.u;
                if (this.manipulationChanging != null) {
                    this.manipulationChanging(this, this.c());
                }
            }
            this.ad = this.t;
            this.ae = this.u;
            if ((i || g) && this.n == 0) {
                if (this.manipulationEnding != null) {
                    this.manipulationEnding(this, this.c());
                }
            }
        }
        r(a) {
            let b = this.a0();
            if ((b - this.ay) < 500) {
                if (Math.abs(a.a - this.ao) < 50 && Math.abs(a.b - this.ap) < 50) {
                    return true;
                }
            }
            this.ao = a.a;
            this.ap = a.b;
            this.ay = b;
            return false;
        }
        a9() {
            this.ax = this.a0();
            if (!this.q) {
                this.q = true;
                this.b.executeDelayed(runOn(this, this.a2), 1000);
            }
        }
        a2() {
            if (!this.q) {
                return;
            }
            let a = this.a0();
            if (a - this.ax >= this.az) {
                this.a8();
            }
            else {
                this.b.executeDelayed(runOn(this, this.a2), (this.az - (a - this.ax)));
            }
        }
        bc() {
            this.q = false;
        }
        a5() {
            this.p.f();
            if (this.zoomEnding != null) {
                this.zoomEnding(this, this.c());
            }
        }
        a8() {
            if (this.holdStarting != null) {
                this.holdStarting(this, this.c());
            }
        }
        bb() {
            this.p.f();
            this.a1();
            this.af = 1;
            this.ag = 1;
            this.ac = 1;
            this.ad = this.t;
            this.ae = this.u;
            if (this.zoomStarting != null) {
                this.zoomStarting(this, this.c());
            }
        }
        a3() {
            if (this.holdEnding != null) {
                this.holdEnding(this, this.c());
            }
        }
        ba() {
            this.p.f();
            this.a1();
            this.ad = this.t;
            this.ae = this.u;
            if (this.panStarting != null) {
                this.panStarting(this, this.c());
            }
        }
        a1() {
            if (this.n == 5) {
                this.n = 0;
            }
        }
        be() {
            if (this.n != 5) {
                return;
            }
            if (this.o == null || this.aw == -1) {
                this.a1();
                return;
            }
            let a = this.a0();
            let b = a - this.aw;
            if (b < 16) {
                this.a7(runOn(this, this.be));
                return;
            }
            this.aw = a;
            let c = b / 1000;
            let d = this.au * c;
            let e = this.o;
            if (e.a > 0) {
                e.a -= d;
                if (e.a < 0) {
                    e.a = 0;
                }
            }
            if (e.a < 0) {
                e.a += d;
                if (e.a > 0) {
                    e.a = 0;
                }
            }
            if (e.b > 0) {
                e.b -= d;
                if (e.b < 0) {
                    e.b = 0;
                }
            }
            if (e.b < 0) {
                e.b += d;
                if (e.b > 0) {
                    e.b = 0;
                }
            }
            if (e.a == 0 && e.b == 0) {
                this.n = 0;
                if (this.panEnding != null) {
                    this.panEnding(this, this.c());
                }
                if (this.manipulationEnding != null) {
                    this.manipulationEnding(this, this.c());
                }
                this.a1();
                return;
            }
            this.t += e.a * c;
            this.u += e.b * c;
            this.aq = this.t - this.ad;
            this.ar = this.u - this.ae;
            this.ad = this.t;
            this.ae = this.u;
            if (this.manipulationChanging != null) {
                this.manipulationChanging(this, this.c());
            }
            this.a7(runOn(this, this.be));
        }
        s(a) {
            if (this.n == 5) {
                this.a1();
            }
            this.aw = this.a0();
            this.o = a;
            this.n = 5;
            this.a7(runOn(this, this.be));
            if (this.flingStarting != null) {
                if (!this.flingStarting(this, this.c())) {
                    this.a1();
                    return false;
                }
            }
            return true;
        }
        a7(a) {
            this.b.enqueueAnimationAction(a);
        }
        a4() {
            let a = this.p.b(this.a0());
            if ((a.a > 5 || a.a < -5 || a.b > 5 || a.b < -5) && this.n == 0) {
                this.n = 1;
                if (!this.s(a)) {
                    if (this.n == 0) {
                        if (this.panEnding != null) {
                            this.panEnding(this, this.c());
                        }
                        if (this.manipulationEnding != null) {
                            this.manipulationEnding(this, this.c());
                        }
                    }
                }
            }
            else {
                if (this.panEnding != null) {
                    this.panEnding(this, this.c());
                }
                if (this.n == 0) {
                    if (this.manipulationEnding != null) {
                        this.manipulationEnding(this, this.c());
                    }
                }
            }
        }
        c() {
            let a = new TouchGestureEventArgs();
            a.a = this.t;
            a.b = this.u;
            a.d = this.ah;
            a.e = this.ai;
            a.c = this.z;
            a.f = this.aq;
            a.g = this.ar;
            a.h = this.o != null ? this.o.a : this.p.b(this.a0()).a;
            a.i = this.o != null ? this.o.b : this.p.b(this.a0()).b;
            return a;
        }
        a0() {
            return this.b.getCurrentRelativeTime();
        }
    }
    TouchGestureRecognizer.$t = /*@__PURE__*/ markType(TouchGestureRecognizer, 'TouchGestureRecognizer');
    return TouchGestureRecognizer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CanvasGestureDOMEventProxy = /*@__PURE__*/ (() => {
    class CanvasGestureDOMEventProxy extends BaseDOMEventProxy {
        constructor(a, b, c) {
            super();
            this.dd = 0;
            this.de = "";
            this.c0 = null;
            this.db = null;
            this.c6 = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.d2 = null;
            this.c1 = false;
            this.c7 = new List$1(Number_$type, 0);
            this.c8 = new List$1(Point_$type, 0);
            this.c3 = false;
            this.c9 = new List$1(TouchPointInfo.$, 0);
            this.bs = c;
            this.by = b;
            this.c0 = new TouchGestureRecognizer(new DOMExecutionContext(b));
            let d = this.c0;
            d.holdEnding = delegateCombine(d.holdEnding, runOn(this, this.dg));
            let e = this.c0;
            e.holdStarting = delegateCombine(e.holdStarting, runOn(this, this.dh));
            let f = this.c0;
            f.zoomStarting = delegateCombine(f.zoomStarting, runOn(this, this.dp));
            let g = this.c0;
            g.zoomEnding = delegateCombine(g.zoomEnding, runOn(this, this.dn));
            let h = this.c0;
            h.panStarting = delegateCombine(h.panStarting, runOn(this, this.dm));
            let i = this.c0;
            i.panEnding = delegateCombine(i.panEnding, runOn(this, this.dl));
            let j = this.c0;
            j.manipulationStarting = delegateCombine(j.manipulationStarting, runOn(this, this.dk));
            let k = this.c0;
            k.manipulationChanging = delegateCombine(k.manipulationChanging, runOn(this, this.di));
            let l = this.c0;
            l.manipulationEnding = delegateCombine(l.manipulationEnding, runOn(this, this.dj));
            let m = this.c0;
            m.doubleTapped = delegateCombine(m.doubleTapped, runOn(this, this.df));
            let n = this.c0;
            n.flingStarting = delegateCombine(n.flingStarting, runOn(this, this.c2));
            this.am = (o) => true;
            this.aa = true;
            CanvasGestureDOMEventProxy.dc++;
            this.dd = CanvasGestureDOMEventProxy.dc;
            this.de = ".DOMProxy" + this.dd.toString();
            this.bd = 0;
            this.bz = a;
            BaseDOMEventProxy.bo = false;
            try {
                BaseDOMEventProxy.bo = (window.navigator.msPointerEnabled && MSGesture !== undefined);
            }
            catch (o) {
            }
            BaseDOMEventProxy.bp = false;
            try {
                BaseDOMEventProxy.bp = (window.PointerEvent || window.navigator.pointerEnabled);
            }
            catch (p) {
            }
            if (BaseDOMEventProxy.bt) {
                this.aa = false;
            }
            BaseDOMEventProxy.b7 = this.b6();
            BaseDOMEventProxy.b4 = this.b5();
            this.aq(this.bz, "");
            this.al = (q) => true;
        }
        d() {
            let a = new CanvasGestureDOMEventProxy(this.bz, this.by, this.bs);
            a.aa = this.aa;
            a.am = this.am;
            return a;
        }
        c2(a, b) {
            return this.ad({ $type: Point_$type, x: b.a, y: b.b }, b.h, b.i);
        }
        df(a, b) {
            this.aw({ $type: Point_$type, x: b.a, y: b.b });
        }
        get_ak() {
            return true;
        }
        dj(a, b) {
            if (this.c0.n == 0) {
                this.a0({ $type: Point_$type, x: b.a, y: b.b }, b.d);
                this.cm();
            }
        }
        di(a, b) {
            if (this.c0.n == 2) {
                this.a7({ $type: Point_$type, x: b.a, y: b.b }, b.d);
                this.ba({ $type: Point_$type, x: b.a, y: b.b }, b.d, b.e, b.c);
            }
            if (this.c0.n == 1 || this.c0.n == 5) {
                this.au({ $type: Point_$type, x: b.a, y: b.b }, true);
                this.ay({ $type: Point_$type, x: b.a, y: b.b });
            }
        }
        dk(a, b) {
        }
        dl(a, b) {
            this.c1 = false;
            if (this.c0.n == 0) {
                this.at({ $type: Point_$type, x: b.a, y: b.b }, true, false);
                this.ax({ $type: Point_$type, x: b.a, y: b.b });
            }
        }
        dm(a, b) {
            this.az({ $type: Point_$type, x: b.a, y: b.b });
        }
        dn(a, b) {
            this.a9({ $type: Point_$type, x: b.a, y: b.b }, b.d, b.e, b.c);
        }
        dp(a, b) {
            this.a8({ $type: Point_$type, x: b.a, y: b.b }, 1);
            this.bb({ $type: Point_$type, x: b.a, y: b.b }, 1, 1, 1);
        }
        dh(a, b) {
            this.c1 = true;
            this.a1({ $type: Point_$type, x: b.a, y: b.b });
        }
        dg(a, b) {
            if (this.c0.n == 0) {
                this.at({ $type: Point_$type, x: b.a, y: b.b }, true, false);
            }
        }
        static c4() {
            BaseDOMEventProxy.bo = false;
            try {
                BaseDOMEventProxy.bo = (window.navigator.msPointerEnabled && MSGesture !== undefined);
            }
            catch (a) {
            }
            BaseDOMEventProxy.bp = false;
            try {
                BaseDOMEventProxy.bp = (window.PointerEvent || window.navigator.pointerEnabled);
            }
            catch (b) {
            }
            return BaseDOMEventProxy.bt;
        }
        dq(a, b, c) {
        }
        aq(a, b) {
            let c = a;
            if (!this.by.supportsDOMEvents()) {
                return;
            }
            let d = this.de + b;
            let e = new List$1(Delegate_$type, 0);
            this.c6.addItem(d, e);
            this.dq(a, b, e);
            if (!BaseDOMEventProxy.bt) {
                e.add(c.listen("mousemove", runOn(this, this.ce)));
                e.add(c.listen("mouseleave", runOn(this, this.cd)));
                e.add(c.listen("mousedown", runOn(this, this.cc)));
                e.add(c.listen("mouseup", runOn(this, this.cg)));
                e.add(this.by.globalListen("window", "mouseup", runOn(this, this.cu)));
            }
            e.add(c.listen("keydown", runOn(this, this.b9)));
            e.add(c.listen("keyup", runOn(this, this.cb)));
            if (BaseDOMEventProxy.bt) {
                let source_ = this.bz.getNativeElement();
                BaseDOMEventProxy.co(source_);
                let f = this.bz.getNativeElement();
                if (BaseDOMEventProxy.bp) {
                    e.add(c.listen("pointerdown", runOn(this, this.dt)));
                    e.add(c.listen("pointerup", runOn(this, this.dw)));
                    e.add(c.listen("pointercancel", runOn(this, this.ds)));
                    e.add(c.listen("pointermove", runOn(this, this.du)));
                    e.add(c.listen("pointerleave", runOn(this, this.dv)));
                    e.add(c.listen("lostpointercapture", runOn(this, this.dr)));
                }
                else {
                    e.add(c.listen("MSPointerDown", runOn(this, this.dt)));
                    e.add(c.listen("MSPointerUp", runOn(this, this.dw)));
                    e.add(c.listen("MSPointerCancel", runOn(this, this.ds)));
                    e.add(c.listen("MSPointerMove", runOn(this, this.du)));
                    e.add(c.listen("MSPointerLeave", runOn(this, this.dv)));
                    e.add(c.listen("MSLostPointerCapture", runOn(this, this.dr)));
                }
            }
            else {
                e.add(c.listen("touchstart", runOn(this, this.dz)));
                e.add(c.listen("touchmove", runOn(this, this.dy)));
                e.add(c.listen("touchend", runOn(this, this.dx)));
            }
            if (this.bs) {
                e.add(c.listen("wheel", runOn(this, this.ch)));
            }
            else {
                e.add(c.listen("DOMMouseScroll", runOn(this, this.cf)));
                e.add(c.listen("mousewheel", runOn(this, this.cf)));
            }
        }
        dw(e_) {
            let a = this.bm(e_);
            let b = this.c7.indexOf((e_.originalEvent.pointerId));
            if (b >= 0) {
                this.c7.removeAt(b);
                this.c8.removeAt(b);
                this.b3 = this.c7.count;
            }
            if (a) {
                this.dx(e_);
            }
            else {
                this.cg(e_);
            }
        }
        dr(e_) {
            let a = this.bm(e_);
        }
        ds(e_) {
            let a = this.bm(e_);
            let b = this.c7.indexOf((e_.originalEvent.pointerId));
            if (b >= 0) {
                this.c7.removeAt(b);
                this.c8.removeAt(b);
                this.b3 = this.c7.count;
            }
        }
        dt(e_) {
            let a = this.bm(e_);
            BaseDOMEventProxy.cn(e_);
            this.c7.add((e_.originalEvent.pointerId));
            this.c8.add({ $type: Point_$type, x: e_.pageX, y: e_.pageY });
            this.b3 = this.c7.count;
            if (a) {
                this.ct(e_);
            }
            else {
                this.cs(e_);
            }
            this.cr(e_);
            if (!this.c3 && this.ab(this.cy, a, false)) {
                let eventSource_ = this.bz.getNativeElement();
                if (BaseDOMEventProxy.bp) {
                    eventSource_.setPointerCapture(e_.originalEvent.pointerId);
                }
                else {
                    eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
                }
            }
            if (a) {
                this.dz(e_);
            }
            else {
                this.cc(e_);
            }
        }
        du(e_) {
            let a = this.bm(e_);
            BaseDOMEventProxy.cn(e_);
            this.cr(e_);
            this.ct(e_);
            let b = this.c7.indexOf((e_.originalEvent.pointerId));
            if (b >= 0) {
                this.c8._inner[b] = { $type: Point_$type, x: e_.pageX, y: e_.pageY };
            }
            if (this.c3 && this.ab(this.cy, a, false)) {
                let eventSource_ = this.bz.getNativeElement();
                if (BaseDOMEventProxy.bp) {
                    eventSource_.setPointerCapture(e_.originalEvent.pointerId);
                }
                else {
                    eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
                }
            }
            if (a) {
                this.dy(e_);
            }
            else {
                this.ce(e_);
            }
        }
        dv(e_) {
            let a = this.bm(e_);
            if (a) {
            }
            else {
                this.cd(e_);
            }
        }
        dz(e_) {
            this.bn = true;
            this.cr(e_);
            this.ct(e_);
            this.d2 = this.cx;
            if (this.ab(this.cy, true, false)) {
                if (!this.aa || this.b3 > 1) {
                    if (this.br) {
                        this.br = false;
                        this.b8();
                    }
                    this.cp(e_);
                }
                else {
                    this.br = true;
                    this.c1 = false;
                }
                this.a5(this.cy, false, true);
                this.a2(this.cy);
                this.av(this.cx, true);
                this.c0.a6(this.da(e_));
            }
        }
        da(e_) {
            let a = BaseDOMEventProxy.cz(this.bz);
            let b = this.bg;
            let c = 0;
            let d = 0;
            if (Rect.l_op_Inequality(b, null)) {
                c = b.left;
                d = b.top;
            }
            this.c9.clear();
            if (BaseDOMEventProxy.bt) {
                let e = this.c7.count;
                for (let j_ = 0; j_ < e; j_++) {
                    let f = this.c7._inner[j_];
                    let g = this.c8._inner[j_];
                    let h = g.x;
                    let i = g.y;
                    let j = new TouchPointInfo(1);
                    j.a = (h - a.left) - b.left;
                    j.b = (i - a.top) - b.top;
                    this.c9.add(j);
                }
            }
            else {
                let k = (e_.originalEvent.targetTouches.length);
                for (let j_ = 0; j_ < k; j_++) {
                    let l = (e_.originalEvent.targetTouches[j_].pageX);
                    let m = (e_.originalEvent.targetTouches[j_].pageY);
                    let n = new TouchPointInfo(1);
                    n.a = (l - a.left) - c;
                    n.b = (m - a.top) - d;
                    this.c9.add(n);
                }
            }
            return this.c9;
        }
        dy(a) {
            this.bn = true;
            this.cr(a);
            this.ct(a);
            if (this.br) {
                if ((this.ab(this.cy, true, false) && this.c5()) || this.c1 == true || this.c0.n == 2) {
                    this.br = false;
                    this.b8();
                }
            }
            if ((this.c1 || this.c0.n == 2 || this.ab(this.cy, true, false)) && !this.br) {
                this.c1 = true;
                this.cp(a);
                this.c0.a6(this.da(a));
            }
        }
        c5() {
            let a = { $type: Point_$type, x: this.d2.x - this.cx.x, y: this.d2.y - this.cx.y };
            if (Math.abs(a.x) > Math.abs(a.y)) {
                a.y = 0;
            }
            if (Math.abs(a.y) > Math.abs(a.x)) {
                a.x = 0;
            }
            return this.am(a);
        }
        dx(a) {
            this.bn = false;
            this.cr(a);
            this.ct(a);
            if (this.br) {
                this.br = false;
                this.b8();
            }
            let b = this.c0.n;
            let c = this.ab(this.cy, true, false) || b != 0;
            if (this.c0.n != 2 && this.c0.n != 5) {
                this.a5(this.cy, false, true);
                this.a6(this.cy);
            }
            let d = this.c0.n == 2;
            if (d) {
                c = true;
                this.at({ $type: Point_$type, x: this.c0.as, y: this.c0.at }, true, true);
            }
            this.c0.a6(this.da(a));
            if (this.c0.n == 0) {
                this.cm();
            }
            if (!d && this.c0.n == 0) {
                this.at({ $type: Point_$type, x: this.c0.as, y: this.c0.at }, true, false);
            }
            if (this.c0.n != 0) {
                c = true;
            }
            if (c) {
                this.cp(a);
            }
        }
        d0(a) {
            if (this.c6.containsKey(a)) {
                let b = this.c6.item(a);
                this.c6.removeItem(a);
                for (let c = 0; c < b.count; c++) {
                    b._inner[c]();
                }
                b.clear();
            }
        }
        bc(a, b) {
            let c = a;
            let d = this.de + b;
            this.d0(d);
        }
        ar() {
            if (this.bz == null) {
                return;
            }
            this.d0(this.de);
            this.bz = null;
        }
        static register() {
            TypeRegistrar.register("CanvasGestureDOMEventProxy", CanvasGestureDOMEventProxy.$);
        }
    }
    CanvasGestureDOMEventProxy.$t = /*@__PURE__*/ markType(CanvasGestureDOMEventProxy, 'CanvasGestureDOMEventProxy', BaseDOMEventProxy.$);
    CanvasGestureDOMEventProxy.dc = 0;
    return CanvasGestureDOMEventProxy;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrSimpleDefaultTooltip extends Component {
    render() {
        return (createElement("div", { className: "ui-simple-default-tooltip-content" }, createElement("span", { style: { whiteSpace: "nowrap", fontWeight: "bold" } }, this.getLabel(this.props.context))));
    }
    constructor(props) {
        super(props);
    }
    ensureDefaultTooltip(gauge) {
        if (gauge.showToolTip) {
            gauge.tooltipTemplate = this.props.tooltip;
        }
        else {
            gauge.tooltipTemplate = null;
        }
    }
    getLabel(context) {
        if (context.itemName == null) {
            let label = context.label.split(":");
            return label.length < 2 ? context.label : label[1].trim();
        }
        return context.label;
    }
    willComponentMount() {
        if (this.onContentReady != null) {
            this.onContentReady();
        }
    }
    static register() {
        TypeRegistrar.registerCons("IgrSimpleDefaultTooltip", IgrSimpleDefaultTooltip);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrDVInteractivityModule {
    static register() {
        TypeRegistrar.register('CanvasGestureDOMEventProxy', CanvasGestureDOMEventProxy.$type);
        IgrTooltipContainerModule.register();
        TypeRegistrar.registerCons('IgrSimpleDefaultTooltip', IgrSimpleDefaultTooltip);
        IgrSimpleDefaultTooltip.register();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TouchGestureState_$type = /*@__PURE__*/ markEnum('TouchGestureState', 'None,0|Pan,1|Zoom,2|Hold,3|PendingPan,4|Flinging,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let KeyEventArgs = /*@__PURE__*/ (() => {
    class KeyEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c.which, c.altKey, c.shiftKey, c.ctrlKey, c];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super();
                            this.h = 0;
                            this.m = 0;
                            this.j = null;
                            this.g = null;
                            this.b = false;
                            this.j = j;
                            this.h = f;
                            this.m = KeyEventArgs.n(g, h, i);
                        }
                        this.g = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super();
                        this.h = 0;
                        this.m = 0;
                        this.j = null;
                        this.g = null;
                        this.b = false;
                        this.j = g;
                        this.h = c;
                        this.m = KeyEventArgs.n(d, e, f);
                    }
                    break;
            }
        }
        get alt() {
            return 1 == (this.m & 1);
        }
        get ctrl() {
            return 2 == (this.m & 2);
        }
        get keyCode() {
            return this.h;
        }
        get modifiers() {
            return this.m;
        }
        get shift() {
            return 4 == (this.m & 4);
        }
        get defaultPrevented() {
            return this.b;
        }
        preventDefault() {
            this.g.preventDefault();
            this.b = true;
        }
        stopPropagation() {
            this.g.stopPropagation();
        }
        static n(a, b, c) {
            let d = 0;
            if (a) {
                d |= 1;
            }
            if (b) {
                d |= 4;
            }
            if (c) {
                d |= 2;
            }
            return d;
        }
    }
    KeyEventArgs.$t = /*@__PURE__*/ markType(KeyEventArgs, 'KeyEventArgs', EventArgs.$);
    return KeyEventArgs;
})();

/**
 * Event args for KeyUp and KeyDown events.
*/
class IgrKeyEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets a value indicating whether the ALT key was pressed.
    */
    get alt() {
        return this.i.alt;
    }
    /**
     * Gets a value indicating whether the CTRL key was pressed.
    */
    get ctrl() {
        return this.i.ctrl;
    }
    /**
     * Gets the keyboard code for a KeyDown or KeyUp event.
    */
    get keyCode() {
        return this.i.keyCode;
    }
    /**
     * Gets the modifier flags for a KeyDown or KeyUp event.
     * The flags indicate which combination of CTRL, SHIFT, and ALT keys was pressed.
    */
    get modifiers() {
        return this.i.modifiers;
    }
    /**
     * Gets a value indicating whether the SHIFT key was pressed.
    */
    get shift() {
        return this.i.shift;
    }
    /**
     * Gets whether the PreventDefault method was called.
    */
    get defaultPrevented() {
        return this.i.defaultPrevented;
    }
    /**
     * Tells the user agent that if the event does not get explicitly handled, its default action should not be taken as it normally would be.
    
    */
    preventDefault() {
        this.i.preventDefault();
    }
    /**
     * Prevent the event from bubbling up.
    
    */
    stopPropagation() {
        this.i.stopPropagation();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var MouseButton = /*@__PURE__*/ (function (MouseButton) {
    MouseButton[MouseButton["Left"] = 0] = "Left";
    MouseButton[MouseButton["Middle"] = 1] = "Middle";
    MouseButton[MouseButton["Right"] = 2] = "Right";
    MouseButton[MouseButton["Unkown"] = 3] = "Unkown";
    return MouseButton;
})({});
/**
 * @hidden
 */
let MouseButton_$type = /*@__PURE__*/ markEnum('MouseButton', 'Left,0|Middle,1|Right,2|Unkown,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScrollerView_$type = /*@__PURE__*/ new Type(null, 'IScrollerView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScrollbarStyle_$type = /*@__PURE__*/ markEnum('ScrollbarStyle', 'Default,0|Fading,1|Thin,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScrollerScrollingEventArgs = /*@__PURE__*/ (() => {
    class ScrollerScrollingEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._deltaX = 0;
            this._deltaY = 0;
        }
        get deltaX() {
            return this._deltaX;
        }
        set deltaX(a) {
            this._deltaX = a;
        }
        get deltaY() {
            return this._deltaY;
        }
        set deltaY(a) {
            this._deltaY = a;
        }
    }
    ScrollerScrollingEventArgs.$t = /*@__PURE__*/ markType(ScrollerScrollingEventArgs, 'ScrollerScrollingEventArgs', EventArgs.$);
    return ScrollerScrollingEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ScrollerView = /*@__PURE__*/ (() => {
    class ScrollerView extends Base {
        constructor(a) {
            super();
            this.c = null;
            this.ab = null;
            this.af = null;
            this.b = null;
            this.aa = null;
            this.a = null;
            this.ae = null;
            this.ac = null;
            this.ad = null;
            this.ag = null;
            this.e = false;
            this.d = null;
            this.i = false;
            this.h = false;
            this.w = 0;
            this.t = 0;
            this.x = -1;
            this.u = -1;
            this.g = false;
            this.f = false;
            this.v = 0;
            this.s = 0;
            this.c = a;
        }
        getDefaultScrollbarBrush() {
            return ((() => {
                let $ret = new Brush();
                $ret.fill = "#666666";
                return $ret;
            })());
        }
        provideContainer(a) {
            if (a == null) {
                if (this.ab != null) {
                    this.ab = null;
                }
                if (this.a != null) {
                    this.a.al = null;
                    this.a.ar();
                }
                return;
            }
            this.ab = a;
            this.c.executionContext = new DOMExecutionContext(this.ab);
            let b = Math.round(this.ab.rootWrapper.width());
            let c = Math.round(this.ab.rootWrapper.height());
            this.ae = this.ab.rootWrapper;
            this.ae.setStyleProperty("position", "relative");
            this.af = this.ab.createElement("div");
            this.af.setStyleProperty("position", "relative");
            this.af.setStyleProperty("width", "100%");
            this.af.setStyleProperty("height", "100%");
            this.af.setStyleProperty("overflow", "hidden");
            this.ae.append(this.af);
            this.ad = this.ab.createElement("div");
            this.ad.setStyleProperty("position", "absolute");
            this.ad.setStyleProperty("height", this.c.scrollbarSpan + "px");
            this.ad.setStyleProperty("width", this.c.minScrollbarSize + "px");
            this.ad.setStyleProperty("background-color", this.c.scrollbarBrush._fill);
            this.ad.setStyleProperty("display", "none");
            this.ad.setStyleProperty("border-radius", "5px");
            this.ad.setStyleProperty("z-index", "10000");
            this.ad.setStyleProperty("bottom", "0px");
            this.ae.append(this.ad);
            this.ag = this.ab.createElement("div");
            this.ag.setStyleProperty("position", "absolute");
            this.ag.setStyleProperty("width", this.c.scrollbarSpan + "px");
            this.ag.setStyleProperty("height", this.c.minScrollbarSize + "px");
            this.ag.setStyleProperty("background-color", this.c.scrollbarBrush._fill);
            this.ag.setStyleProperty("display", "none");
            this.ag.setStyleProperty("border-radius", "5px");
            this.ag.setStyleProperty("z-index", "10000");
            this.ag.setStyleProperty("right", "0px");
            this.ae.append(this.ag);
            this.updateScrollbarStatus(false);
            this.aa = this.af.getNativeElement();
            this.a = new CanvasGestureDOMEventProxy(this.ab.rootWrapper, this.ab, true);
            this.ab.rootWrapper.setProperty("tabIndex", 1000);
            this.ab.rootWrapper.setRawStyleProperty("outline", "none");
            this.a.c3 = true;
            this.a.bq = true;
            let d = this.a;
            d.onMouseWheel = delegateCombine(d.onMouseWheel, runOn(this, this.l));
            let e = this.a;
            e.onMouseWheelHorizontal = delegateCombine(e.onMouseWheelHorizontal, runOn(this, this.m));
            let f = this.a;
            f.onMouseLeave = delegateCombine(f.onMouseLeave, runOn(this, this.an));
            let g = this.a;
            g.onDragStarted = delegateCombine(g.onDragStarted, runOn(this, this.am));
            let h = this.a;
            h.onDragDelta = delegateCombine(h.onDragDelta, runOn(this, this.al));
            let i = this.a;
            i.onDragCompleted = delegateCombine(i.onDragCompleted, runOn(this, this.ak));
            let j = this.a;
            j.onFlingStarted = delegateCombine(j.onFlingStarted, runOn(this, this.j));
            let k = this.a;
            k.onContactStarted = delegateCombine(k.onContactStarted, runOn(this, this.aj));
            let l = this.a;
            l.onContactMoved = delegateCombine(l.onContactMoved, runOn(this, this.ai));
            let m = this.a;
            m.onContactCompleted = delegateCombine(m.onContactCompleted, runOn(this, this.ah));
            this.a.aa = true;
            this.a.an = runOn(this, this.r);
            let n = this.a;
            n.onKeyDown = delegateCombine(n.onKeyDown, runOn(this, this.k));
            this.a.ao = (o) => {
                let e_ = o.originalEvent;
                let p = (e_.type);
                if (p == "pointerdown" && !this.a.bm(o)) {
                    return false;
                }
                return true;
            };
            this.c.di(b, c);
            this.c.horizontalAnimation.u(this.ab);
            this.c.verticalAnimation.u(this.ab);
            this.attachNativeScroll();
        }
        k(a) {
            return this.c.ao(a, (this.a.bd & 4) != 0, (this.a.bd & 2) != 0);
        }
        r(a, b, c) {
            if (this.f || this.g) {
                return true;
            }
            if (c || b) {
                return true;
            }
            if (this.n(a, b)) {
                this.c.c3();
                return true;
            }
            else if (this.c.isHorizontalActive) {
                this.c.c7();
            }
            if (this.o(a, b)) {
                this.c.c4();
                return true;
            }
            else if (this.c.isVerticalActive) {
                this.c.c8();
            }
            return false;
        }
        ah(a, b) {
            this.f = false;
            this.g = false;
            this.c.isDraggingVBar = false;
            this.c.isDraggingHBar = false;
        }
        ai(a, b) {
            if (this.g) {
                let c = a.y - this.v;
                this.v = a.y;
                this.c.dh(c);
            }
            else if (this.f) {
                let d = a.x - this.s;
                this.s = a.x;
                this.c.df(d);
            }
        }
        aj(a, b) {
            this.e = false;
            this.cancelInertia();
            let c = this.q(a, b);
            let d = this.p(a, b);
            if (c) {
                this.c.isDraggingVBar = true;
                this.g = true;
                this.v = a.y;
                this.focus();
            }
            else if (d) {
                this.c.isDraggingHBar = true;
                this.f = true;
                this.s = a.x;
                this.focus();
            }
        }
        p(a, b) {
            if (!this.h) {
                return false;
            }
            if (a.y >= this.c.viewportHeight - this.c.scrollbarSpan && a.y <= this.c.viewportHeight && a.x >= this.u - this.t / 2 && a.x <= this.u + this.t / 2) {
                return true;
            }
            return false;
        }
        q(a, b) {
            if (!this.i) {
                return false;
            }
            if (a.x >= this.c.viewportWidth - this.c.scrollbarSpan && a.x <= this.c.viewportWidth && a.y >= this.x - this.w / 2 && a.y <= this.x + this.w / 2) {
                return true;
            }
            return false;
        }
        n(a, b) {
            if (!this.h) {
                return false;
            }
            return a.y >= this.c.viewportHeight - this.c.scrollbarSpan - 40 && a.y <= this.c.viewportHeight;
        }
        o(a, b) {
            if (!this.i) {
                return false;
            }
            return a.x >= this.c.viewportWidth - this.c.scrollbarSpan - 40 && a.x <= this.c.viewportWidth;
        }
        j(a, b, c) {
            this.e = true;
            return true;
        }
        onViewportHeightChanged(a) {
            this.a.bg = new Rect(0, 0, 0, this.c.viewportWidth, this.c.viewportHeight);
        }
        onViewportWidthChanged(a) {
            this.a.bg = new Rect(0, 0, 0, this.c.viewportWidth, this.c.viewportHeight);
        }
        onContentHeightChanged(a) {
            if (this.ac != null) {
                this.ac.setStyleProperty("height", a + "px");
            }
        }
        onContentWidthChanged(a) {
            if (this.ac != null) {
                this.ac.setStyleProperty("width", a + "px");
            }
        }
        cancelInertia() {
        }
        ak(a) {
            if (this.f || this.g) {
                return;
            }
            this.e = false;
            this.c.dc(a);
        }
        al(a) {
            if (this.f || this.g) {
                return;
            }
            this.c.dd(a);
        }
        updateScrollTop(a) {
            this.aa.scrollTop = truncate(a);
        }
        am(a) {
            if (this.f || this.g) {
                return;
            }
            this.e = false;
            this.c.de(a);
        }
        getInitialScrollLeft() {
            return this.aa.scrollLeft;
        }
        getInitialScrollTop() {
            return this.aa.scrollTop;
        }
        l(a, b) {
            this.e = false;
            this.cancelInertia();
            return this.c.aq(a, 0, b);
        }
        m(a, b) {
            this.e = false;
            this.cancelInertia();
            return this.c.aq(a, b, 0);
        }
        an(a) {
            if (this.c.horizontalScrollbarStatus > 0) {
                this.c.c7();
            }
            if (this.c.verticalScrollbarStatus > 0) {
                this.c.c8();
            }
        }
        updateScrollLeft(a) {
            this.aa.scrollLeft = truncate(a);
        }
        provideContent(a) {
            this.ac = a;
            this.af.append(this.ac);
        }
        requestWork(a) {
            if (this.ab == null) {
                return;
            }
            if (this.d == null) {
                this.d = this.ab.getRequestAnimationFrame();
            }
            if (this.e) {
                a();
            }
            else {
                this.d(() => a());
            }
        }
        hideVScrollbar() {
            if (this.i) {
                this.i = false;
                this.ag.setStyleProperty("display", "none");
            }
        }
        hideHScrollbar() {
            if (this.h) {
                this.h = false;
                this.ad.setStyleProperty("display", "none");
            }
        }
        updateVScrollbar(a, b) {
            let c = false;
            if (!this.i) {
                c = true;
                this.i = true;
                this.ag.setStyleProperty("display", "block");
            }
            if (a != this.x || c) {
                this.x = a;
                if (this.i) {
                    this.ag.setRawYPosition(a - b / 2);
                }
            }
            if (b != this.w || c) {
                this.w = b;
                if (this.i) {
                    this.ag.setRawSize(this.z(), b);
                }
            }
        }
        updateHScrollbar(a, b) {
            let c = false;
            if (!this.h) {
                c = true;
                this.h = true;
                this.ad.setStyleProperty("display", "block");
            }
            if (a != this.u || c) {
                this.u = a;
                if (this.h) {
                    this.ad.setRawXPosition(a - b / 2);
                }
            }
            if (b != this.t || c) {
                this.t = b;
                if (this.h) {
                    this.ad.setRawSize(b, this.y());
                }
            }
        }
        updateScrollbarStatus(a) {
            if (this.ad != null && this.ag != null) {
                switch (this.c.scrollbarStyle) {
                    case 0:
                        if (a) {
                            this.ad.setStyleProperty("opacity", "1");
                            this.ag.setStyleProperty("opacity", "1");
                            this.ad.setRawSize(this.t, this.y());
                            this.ag.setRawSize(this.z(), this.w);
                        }
                        break;
                    case 1:
                        if (a) {
                            this.ad.setRawSize(this.t, this.y());
                            this.ag.setRawSize(this.z(), this.w);
                        }
                        this.ad.setStyleProperty("opacity", this.c.horizontalScrollbarStatus.toString());
                        this.ag.setStyleProperty("opacity", this.c.verticalScrollbarStatus.toString());
                        break;
                    case 2:
                        if (a) {
                            this.ad.setStyleProperty("opacity", "1");
                            this.ag.setStyleProperty("opacity", "1");
                        }
                        this.ad.setRawSize(this.t, this.y());
                        this.ag.setRawSize(this.z(), this.w);
                        break;
                }
            }
        }
        y() {
            if (this.c.scrollbarStyle == 2) {
                return this.c.horizontalScrollbarStatus * (this.c.scrollbarSpan - 2) + 2;
            }
            return this.c.scrollbarSpan;
        }
        z() {
            if (this.c.scrollbarStyle == 2) {
                return this.c.verticalScrollbarStatus * (this.c.scrollbarSpan - 2) + 2;
            }
            return this.c.scrollbarSpan;
        }
        focus() {
            this.ab.rootWrapper.focus(true);
        }
        onDetachedFromUI() {
            if (this.a != null) {
                this.a.bc(this.ab.rootWrapper, "");
            }
        }
        onAttachedToUI() {
            if (this.a != null) {
                this.a.aq(this.ab.rootWrapper, "");
            }
        }
        attachNativeScroll() {
            let a = this.af.getNativeElement();
            a.addEventListener("scroll", runOn(this, this.onNativeScroll));
        }
        detachNativeScroll() {
            let a = this.af.getNativeElement();
            a.removeEventListener("scroll", runOn(this, this.onNativeScroll));
        }
        onNativeScroll(a) {
        }
    }
    ScrollerView.$t = /*@__PURE__*/ markType(ScrollerView, 'ScrollerView', Base.$, [IScrollerView_$type]);
    return ScrollerView;
})();
/**
 * @hidden
 */
let Scroller = /*@__PURE__*/ (() => {
    class Scroller extends Base {
        constructor() {
            super();
            this.bh = 49;
            this._keyboardListener = null;
            this.a9 = NaN;
            this.a3 = 49;
            this.a1 = NaN;
            this.bg = 48;
            this.a8 = NaN;
            this.a2 = 48;
            this.a0 = NaN;
            this.a6 = 0;
            this.ba = 20;
            this.bd = 8;
            this.bj = 0;
            this.dx = null;
            this.x = false;
            this.a5 = 0;
            this.bl = 0;
            this.bk = 0;
            this.bf = 0;
            this.be = 0;
            this.c = null;
            this.v = true;
            this.aa = false;
            this.a4 = 0;
            this.az = 0;
            this.e = 0;
            this.a7 = 0;
            this.bi = 0;
            this.j = null;
            this.k = null;
            this.bu = 0;
            this.b5 = 0;
            this.bv = 0;
            this.b6 = 0;
            this._executionContext = null;
            this._isDraggingVBar = false;
            this._isDraggingHBar = false;
            this.s = false;
            this.q = false;
            this.r = false;
            this.dz = null;
            this.p = false;
            this.propertyChanged = null;
            this.onScrolling = null;
            this.onScrollStart = null;
            this.onScrollStop = null;
            this._isScrolling = false;
            this.bb = 0;
            this.bc = 0;
            this.w = false;
            this.ay = new List$1(Boolean_$type, 0);
            this.cb = 500;
            this.cc = 0;
            this.cd = 0;
            this.o = false;
            this.z = false;
            this.n = false;
            this.y = false;
            this.t = true;
            this.u = true;
            this.dx = this.view.getDefaultScrollbarBrush();
            this.j = new DoubleAnimator(0, 1, 400);
            this.k = new DoubleAnimator(0, 1, 400);
            this.j.b = EasingFunctions.cubicEase;
            this.k.b = EasingFunctions.cubicEase;
            let a = this.j;
            a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.c1));
            let b = this.k;
            b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.c2));
        }
        get smallVerticalChange() {
            return this.bh;
        }
        set smallVerticalChange(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.dg("SmallVerticalChange", b, this.bh);
            }
        }
        get keyboardListener() {
            return this._keyboardListener;
        }
        set keyboardListener(a) {
            this._keyboardListener = a;
        }
        get largeVerticalChange() {
            return this.a9;
        }
        set largeVerticalChange(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.dg("LargeVerticalChange", b, this.a9);
            }
        }
        get bq() {
            return this.a3;
        }
        set bq(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.dg("ActualSmallVerticalChange", b, this.a3);
            }
        }
        get bo() {
            return this.a1;
        }
        set bo(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.dg("ActualLargeVerticalChange", b, this.a1);
            }
        }
        get smallHorizontalChange() {
            return this.bg;
        }
        set smallHorizontalChange(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.dg("SmallHorizontalChange", b, this.bg);
            }
        }
        get largeHorizontalChange() {
            return this.a8;
        }
        set largeHorizontalChange(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.dg("LargeHorizontalChange", b, this.a8);
            }
        }
        get bp() {
            return this.a2;
        }
        set bp(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.dg("ActualSmallHorizontalChange", b, this.a2);
            }
        }
        get bn() {
            return this.a0;
        }
        set bn(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.dg("ActualLargeHorizontalChange", b, this.a0);
            }
        }
        get contentWidth() {
            return this.a6;
        }
        set contentWidth(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.dg("ContentWidth", b, this.a6);
            }
        }
        get minScrollbarSize() {
            return this.ba;
        }
        set minScrollbarSize(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.dg("MinScrollbarSize", b, this.ba);
            }
        }
        get scrollbarSpan() {
            return this.bd;
        }
        set scrollbarSpan(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.dg("ScrollbarSpan", b, this.bd);
            }
        }
        ao(a, b, c) {
            switch (a) {
                case 11: return this.ar(b, c);
                case 10: return this.as(b, c);
                case 17: return this.ah(b, c);
                case 15: return this.aw(b, c);
                case 14: return this.ap(b, c);
                case 16: return this.at(b, c);
                case 13: return this.am(b, c);
                case 12: return this.ai(b, c);
                case 2: return this.av(b, c);
                case 3: return this.aj(b, c);
                case 8: return this.ak();
                case 57: return this.al();
                case 9: return this.au(b, c);
                default: return this.an(a, b, c);
            }
            return false;
        }
        au(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onSpace(a, b)) {
                    return true;
                }
            }
            return false;
        }
        al() {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onF2()) {
                    return true;
                }
            }
            return false;
        }
        ak() {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onEscape()) {
                    return true;
                }
            }
            return false;
        }
        av(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onTab(a, b)) {
                    return true;
                }
            }
            return false;
        }
        ai(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onEnd(a, b)) {
                    return true;
                }
            }
            return false;
        }
        am(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onHome(a, b)) {
                    return true;
                }
            }
            return false;
        }
        at(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onRightArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollLeft + this.viewportWidth >= this.contentWidth) {
                return false;
            }
            this.dn(this.bp, 0);
            return true;
        }
        ap(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onLeftArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollLeft <= 0) {
                return false;
            }
            this.dn(this.bp * -1, 0);
            return true;
        }
        aw(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onUpArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop <= 0) {
                return false;
            }
            this.dn(0, this.bq * -1);
            return true;
        }
        ah(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onDownArrow(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop + this.viewportHeight >= this.contentHeight) {
                return false;
            }
            this.dn(0, this.bq);
            return true;
        }
        as(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onPageUp(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop < 0) {
                return false;
            }
            this.dn(0, this.bo * -1);
            return true;
        }
        ar(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onPageDown(a, b)) {
                    return true;
                }
            }
            if (this.scrollTop + this.viewportHeight >= this.contentHeight) {
                return false;
            }
            this.dn(0, this.bo);
            return true;
        }
        aj(a, b) {
            if (this.keyboardListener != null) {
                if (this.keyboardListener.onEnter(a, b)) {
                    return true;
                }
            }
            return false;
        }
        an(a, b, c) {
            if (this.keyboardListener != null) {
                return this.keyboardListener.onKeyDown(a, b, c);
            }
            return false;
        }
        get verticalTrackStartInset() {
            return this.bj;
        }
        set verticalTrackStartInset(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.dg("VerticalTrackStartInset", b, this.bj);
            }
        }
        get scrollbarBrush() {
            return this.dx;
        }
        set scrollbarBrush(a) {
            let b = this.dx;
            this.dx = a;
            if (b != this.dx) {
                this.dg("ScrollbarBrush", b, this.dx);
            }
        }
        dg(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.dj(a, b, c);
        }
        get ax() {
            return this.x;
        }
        set ax(a) {
            this.x = a;
            if (!this.x) {
                this.view.updateScrollTop(this.scrollTop);
                this.view.updateScrollLeft(this.scrollLeft);
            }
        }
        dj(a, b, c) {
            switch (a) {
                case "ContentWidth":
                    this.view.onContentWidthChanged(this.contentWidth);
                    let d = c;
                    let e = b;
                    if (d < e && this.scrollLeft + this.viewportWidth >= d) {
                        this.dp(d - (this.scrollLeft + this.viewportWidth), 0);
                    }
                    this.du();
                    break;
                case "ContentHeight":
                    this.view.onContentHeightChanged(this.contentHeight);
                    let f = c;
                    let g = b;
                    if (f < g && this.scrollTop > 0 && this.scrollTop + this.viewportHeight >= f) {
                        this.dp(0, f - (this.scrollTop + this.viewportHeight));
                    }
                    this.dw();
                    break;
                case "ScrollTop":
                    if (!this.ax) {
                        this.view.updateScrollTop(this.scrollTop);
                    }
                    break;
                case "ScrollLeft":
                    if (!this.ax) {
                        this.view.updateScrollLeft(this.scrollLeft);
                    }
                    break;
                case "ViewportWidth":
                    this.view.onViewportWidthChanged(this.viewportWidth);
                    if (isNaN_(this.largeVerticalChange)) {
                        this.bn = this.viewportWidth;
                    }
                    if (this.contentWidth > 0 && this.scrollLeft + this.viewportWidth > this.contentWidth) {
                        this.dp(this.contentWidth - this.viewportWidth - this.scrollLeft, 0);
                    }
                    this.du();
                    if (this.view.getInitialScrollLeft() != this.scrollLeft) {
                        this.view.updateScrollLeft(this.scrollLeft);
                    }
                    break;
                case "ViewportHeight":
                    this.view.onViewportHeightChanged(this.viewportHeight);
                    if (isNaN_(this.largeVerticalChange)) {
                        this.bo = this.viewportHeight;
                    }
                    this.dw();
                    if (this.view.getInitialScrollTop() != this.scrollTop) {
                        this.view.updateScrollTop(this.scrollTop);
                    }
                    break;
                case "ScrollbarBrush":
                case "ScrollbarSpan":
                case "MinScrollbarSize":
                case "VerticalTrackStartInset":
                    this.dw();
                    this.du();
                    break;
                case "HorizontalScrollbarStatus":
                case "VerticalOpacity":
                    this.view.updateScrollbarStatus(false);
                    break;
                case "ScrollbarStyle":
                    this.view.updateScrollbarStatus(true);
                    break;
            }
        }
        get contentHeight() {
            return this.a5;
        }
        set contentHeight(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.dg("ContentHeight", b, this.a5);
            }
        }
        dh(a) {
            let b = Math.max(this.minScrollbarSize, this.actualVerticalScrollbarHeight);
            let c = this.verticalTrackStartInset + (b / 2);
            let d = this.viewportHeight - (b / 2);
            let e = a / (d - c);
            let f = e * (this.contentHeight - this.viewportHeight);
            this.dn(0, f);
        }
        df(a) {
            let b = Math.max(this.minScrollbarSize, this.actualHorizontalScrollbarWidth);
            let c = 0 + (b / 2);
            let d = this.viewportWidth - (b / 2);
            let e = a / (d - c);
            let f = e * (this.contentWidth - this.viewportWidth);
            this.dn(f, 0);
        }
        di(a, b, c = false) {
            let d = this.bl;
            let e = this.bk;
            this.bl = a;
            this.bk = b;
            if (c && (d != a || e != b)) {
                this.dg("ViewportWidth", d, a);
                this.dg("ViewportHeight", e, b);
            }
        }
        get viewportWidth() {
            return this.bl;
        }
        set viewportWidth(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.dg("ViewportWidth", b, this.bl);
            }
        }
        get viewportHeight() {
            return this.bk;
        }
        set viewportHeight(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.dg("ViewportHeight", b, this.bk);
            }
        }
        get scrollTop() {
            return this.bf;
        }
        set scrollTop(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.dg("ScrollTop", b, this.bf);
            }
        }
        get scrollLeft() {
            return this.be;
        }
        set scrollLeft(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.dg("ScrollLeft", b, this.be);
            }
        }
        get view() {
            if (this.c == null) {
                this.c = new ScrollerView(this);
            }
            return this.c;
        }
        set view(a) {
            this.c = a;
        }
        provideContainer(a) {
            this.view.provideContainer(a);
            this.bf = this.view.getInitialScrollTop();
            this.be = this.view.getInitialScrollLeft();
            this.du();
            this.dw();
        }
        onDetachedFromUI() {
            this.view.onDetachedFromUI();
        }
        onAttachedToUI() {
            this.view.onAttachedToUI();
        }
        provideContent(a) {
            this.view.provideContent(a);
        }
        aq(a, b, c) {
            this.r = false;
            this.q = false;
            this.s = false;
            this.view.cancelInertia();
            if (this.keyboardListener != null) {
                this.keyboardListener.onWheel();
            }
            this.dn(b, c);
            return true;
        }
        get lockScrollDirection() {
            return this.v;
        }
        set lockScrollDirection(a) {
            this.v = true;
        }
        get actualVerticalScrollbarHeight() {
            return this.a4;
        }
        set actualVerticalScrollbarHeight(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.dg("ActualVerticalScrollbarHeight", b, this.a4);
            }
        }
        get actualHorizontalScrollbarWidth() {
            return this.az;
        }
        set actualHorizontalScrollbarWidth(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.dg("ActualHorizontalScrollbarWidth", b, this.az);
            }
        }
        get scrollbarStyle() {
            return this.e;
        }
        set scrollbarStyle(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.dg("ScrollbarStyle", enumGetBox(ScrollbarStyle_$type, b), enumGetBox(ScrollbarStyle_$type, this.e));
            }
        }
        get horizontalScrollbarStatus() {
            return this.a7;
        }
        set horizontalScrollbarStatus(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.dg("HorizontalScrollbarStatus", b, this.a7);
            }
        }
        get verticalScrollbarStatus() {
            return this.bi;
        }
        set verticalScrollbarStatus(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.dg("VerticalOpacity", b, this.bi);
            }
        }
        get horizontalAnimation() {
            return this.j;
        }
        get verticalAnimation() {
            return this.k;
        }
        get executionContext() {
            return this._executionContext;
        }
        set executionContext(a) {
            this._executionContext = a;
        }
        get isVerticalActive() {
            return this.y;
        }
        get isHorizontalActive() {
            return this.n;
        }
        get isDraggingVBar() {
            return this._isDraggingVBar;
        }
        set isDraggingVBar(a) {
            this._isDraggingVBar = a;
        }
        get isDraggingHBar() {
            return this._isDraggingHBar;
        }
        set isDraggingHBar(a) {
            this._isDraggingHBar = a;
        }
        focus() {
            this.view.focus();
        }
        de(a) {
            this.view.focus();
            this.s = false;
            this.q = false;
            this.r = false;
            this.p = true;
            this.dz = { $type: Point_$type, x: a.x, y: a.y };
        }
        dd(a) {
            if (this.p) {
                let b = a.y - this.dz.y;
                let c = a.x - this.dz.x;
                if (this.lockScrollDirection && !this.r) {
                    this.r = true;
                    if (b > 0 || c > 0) {
                        if (b > c) {
                            this.s = true;
                        }
                        else {
                            this.s = true;
                        }
                    }
                }
                this.dz = { $type: Point_$type, x: a.x, y: a.y };
                this.dn(-c, -b);
            }
        }
        get isScrolling() {
            return this._isScrolling;
        }
        set isScrolling(a) {
            this._isScrolling = a;
        }
        scrollTo(a, b) {
            this.view.detachNativeScroll();
            this.bb = a - this.scrollLeft;
            this.bc = b - this.scrollTop;
            this.dm();
        }
        dn(a, b) {
            this.view.detachNativeScroll();
            this.bb += a;
            this.bc += b;
            this.dm();
        }
        dp(a, b) {
            this.view.detachNativeScroll();
            this.bb += a;
            this.bc += b;
            this.dt();
        }
        dm() {
            if (this.w) {
                return;
            }
            this.w = true;
            this.view.requestWork(runOn(this, this.dt));
        }
        dt() {
            this.w = false;
            let a = this.bb;
            let b = this.bc;
            this.bb = 0;
            this.bc = 0;
            if (this.r) {
                if (this.s) {
                    a = 0;
                }
                if (this.q) {
                    b = 0;
                }
            }
            if (a != 0) {
                this.t = false;
                this.c3();
                this.c7();
                this.t = true;
            }
            if (b != 0) {
                this.u = false;
                this.c4();
                this.c8();
                this.u = true;
            }
            let c = Math.round(this.scrollTop + b);
            let d = Math.round(this.scrollLeft + a);
            if (c < 0) {
                c = 0;
                this.view.cancelInertia();
            }
            if (d < 0) {
                d = 0;
                this.view.cancelInertia();
            }
            if (c + this.viewportHeight > this.contentHeight) {
                c = this.contentHeight - this.viewportHeight;
                if (c < 0) {
                    c = 0;
                }
                this.view.cancelInertia();
            }
            if (d + this.viewportWidth > this.contentWidth) {
                d = this.contentWidth - this.viewportWidth;
                if (d < 0) {
                    d = 0;
                }
                this.view.cancelInertia();
            }
            b = c - this.scrollTop;
            a = d - this.scrollLeft;
            if (b != 0 || a != 0) {
                try {
                    this.ax = true;
                    this.aa = true;
                    this.scrollTop = c;
                    this.scrollLeft = d;
                    this.dw();
                    this.du();
                    this.aa = false;
                    if (!this.isScrolling) {
                        this.isScrolling = true;
                        if (this.onScrollStart != null) {
                            this.onScrollStart(this, ((() => {
                                let $ret = new ScrollerScrollingEventArgs();
                                $ret.deltaX = a;
                                $ret.deltaY = b;
                                return $ret;
                            })()));
                        }
                    }
                    if (this.onScrolling != null) {
                        this.onScrolling(this, ((() => {
                            let $ret = new ScrollerScrollingEventArgs();
                            $ret.deltaX = a;
                            $ret.deltaY = b;
                            return $ret;
                        })()));
                    }
                    if (this.ay.count > 0) {
                        this.ay._inner[this.ay.count - 1] = false;
                    }
                    this.ay.add(true);
                    this.executionContext.executeDelayed(() => {
                        if (this.ay._inner[0]) {
                            if (this.onScrollStop != null) {
                                this.onScrollStop(this, ((() => {
                                    let $ret = new ScrollerScrollingEventArgs();
                                    $ret.deltaX = a;
                                    $ret.deltaY = b;
                                    return $ret;
                                })()));
                            }
                            this.isScrolling = false;
                            this.view.attachNativeScroll();
                        }
                        this.ay.removeAt(0);
                    }, 50);
                }
                finally {
                    this.ax = false;
                }
            }
        }
        dw() {
            this.dv(this.contentHeight, this.viewportHeight, this.scrollTop, true);
        }
        du() {
            this.dv(this.contentWidth, this.viewportWidth, this.scrollLeft, false);
        }
        dv(a, b, c, d) {
            let e = Math.round((b / a) * b);
            let f = d ? this.verticalTrackStartInset : 0;
            e = e - f;
            if (e < this.minScrollbarSize) {
                e = this.minScrollbarSize;
            }
            if (e >= (b - f)) {
                if (d) {
                    this.view.hideVScrollbar();
                }
                else {
                    this.view.hideHScrollbar();
                }
                return;
            }
            let g = f + (e / 2);
            let h = b - (e / 2);
            let i = c / (a - b);
            let j = Math.round(g + (h - g) * i);
            if (d) {
                this.actualVerticalScrollbarHeight = e;
                this.view.updateVScrollbar(j, e);
            }
            else {
                this.actualHorizontalScrollbarWidth = e;
                this.view.updateHScrollbar(j, e);
            }
        }
        dc(a) {
            this.r = false;
            this.q = false;
            this.s = false;
            this.p = false;
        }
        c1(a, b) {
            this.horizontalScrollbarStatus = this.bu + this.j.o * (this.b5 - this.bu);
        }
        c2(a, b) {
            this.verticalScrollbarStatus = this.bv + this.k.o * (this.b6 - this.bv);
        }
        c3() {
            if (this.n) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                if (this.j.f()) {
                    this.j.w();
                }
                this.horizontalScrollbarStatus = 1;
                if (this.o && this.t) {
                    this.o = false;
                }
            }
            this.n = true;
        }
        c4() {
            if (this.y) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                if (this.k.f()) {
                    this.k.w();
                }
                this.verticalScrollbarStatus = 1;
                if (this.z && this.u) {
                    this.z = false;
                }
            }
            this.y = true;
        }
        c7() {
            if (!this.n || this.isDraggingHBar) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                this.dr();
            }
            this.n = false;
        }
        c8() {
            if (!this.y || this.isDraggingVBar) {
                return;
            }
            if (this.scrollbarStyle == 1 || this.scrollbarStyle == 2) {
                this.ds();
            }
            this.y = false;
        }
        dr() {
            if (!this.o) {
                this.o = true;
                this.cc = this.executionContext.getCurrentRelativeTime();
                this.executionContext.executeDelayed(runOn(this, this.c5), this.cb);
            }
            else {
                this.cc = this.executionContext.getCurrentRelativeTime();
            }
        }
        ds() {
            if (!this.z) {
                this.z = true;
                this.cd = this.executionContext.getCurrentRelativeTime();
                this.executionContext.executeDelayed(runOn(this, this.c6), this.cb);
            }
            else {
                this.cd = this.executionContext.getCurrentRelativeTime();
            }
        }
        c5() {
            if (!this.o) {
                return;
            }
            let a = this.executionContext.getCurrentRelativeTime();
            if (a - this.cc >= this.cb) {
                if (!this.j.f() && this.horizontalScrollbarStatus != 0) {
                    this.bu = this.horizontalScrollbarStatus;
                    this.b5 = 0;
                    this.j.v();
                }
                this.o = false;
            }
            else {
                this.executionContext.executeDelayed(runOn(this, this.c5), (this.cb - (a - this.cc)));
            }
        }
        c6() {
            if (!this.z) {
                return;
            }
            let a = this.executionContext.getCurrentRelativeTime();
            if (a - this.cd >= this.cb) {
                if (!this.k.f() && this.verticalScrollbarStatus != 0) {
                    this.bv = this.verticalScrollbarStatus;
                    this.b6 = 0;
                    this.k.v();
                }
                this.z = false;
            }
            else {
                this.executionContext.executeDelayed(runOn(this, this.c6), (this.cb - (a - this.cd)));
            }
        }
    }
    Scroller.$t = /*@__PURE__*/ markType(Scroller, 'Scroller', Base.$, [INotifyPropertyChanged_$type]);
    return Scroller;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScrollerKeyboardListener_$type = /*@__PURE__*/ new Type(null, 'IScrollerKeyboardListener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IVisualData_$type = /*@__PURE__*/ new Type(null, 'IVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimitiveAppearanceData = /*@__PURE__*/ (() => {
    class PrimitiveAppearanceData extends Base {
        constructor() {
            super(...arguments);
            this._stroke = null;
            this._strokeExtended = null;
            this._fill = null;
            this._fillExtended = null;
            this._strokeThickness = 0;
            this._isVisible = false;
            this._opacity = 0;
            this._canvasLeft = 0;
            this._canvasTop = 0;
            this._canvaZIndex = 0;
            this._dashArray = null;
            this._dashCap = 0;
        }
        get stroke() {
            return this._stroke;
        }
        set stroke(a) {
            this._stroke = a;
        }
        get strokeExtended() {
            return this._strokeExtended;
        }
        set strokeExtended(a) {
            this._strokeExtended = a;
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get fillExtended() {
            return this._fillExtended;
        }
        set fillExtended(a) {
            this._fillExtended = a;
        }
        get strokeThickness() {
            return this._strokeThickness;
        }
        set strokeThickness(a) {
            this._strokeThickness = a;
        }
        get isVisible() {
            return this._isVisible;
        }
        set isVisible(a) {
            this._isVisible = a;
        }
        get opacity() {
            return this._opacity;
        }
        set opacity(a) {
            this._opacity = a;
        }
        get canvasLeft() {
            return this._canvasLeft;
        }
        set canvasLeft(a) {
            this._canvasLeft = a;
        }
        get canvasTop() {
            return this._canvasTop;
        }
        set canvasTop(a) {
            this._canvasTop = a;
        }
        get canvaZIndex() {
            return this._canvaZIndex;
        }
        set canvaZIndex(a) {
            this._canvaZIndex = a;
        }
        get dashArray() {
            return this._dashArray;
        }
        set dashArray(a) {
            this._dashArray = a;
        }
        get dashCap() {
            return this._dashCap;
        }
        set dashCap(a) {
            this._dashCap = a;
        }
        m(a) {
            this.canvasLeft = (this.canvasLeft - a.left) / a.width;
            this.canvasTop = (this.canvasTop - a.top) / a.height;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("stroke: " + (this.stroke != null ? this.stroke.serialize() : "null") + ", ");
            a.u("fill: " + (this.fill != null ? this.fill.serialize() : "null") + ", ");
            a.u("strokeExtended: " + (this.strokeExtended != null ? this.strokeExtended.serialize() : "null") + ", ");
            a.u("fillExtended: " + (this.fillExtended != null ? this.fillExtended.serialize() : "null") + ", ");
            a.u("strokeThickness: " + this.strokeThickness + ", ");
            a.u("isVisible: " + (this.isVisible ? "true" : "false") + ", ");
            a.u("opacity: " + this.opacity + ", ");
            a.u("canvasLeft: " + this.canvasLeft + ", ");
            a.u("canvasTop: " + this.canvasTop + ", ");
            a.u("canvasZIndex: " + this.canvaZIndex + ", ");
            a.u("dashArray: null, ");
            a.u("dashCap: " + this.dashCap);
            a.u("}");
            return a.toString();
        }
    }
    PrimitiveAppearanceData.$t = /*@__PURE__*/ markType(PrimitiveAppearanceData, 'PrimitiveAppearanceData', Base.$, [IVisualData_$type]);
    return PrimitiveAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ShapeTags = /*@__PURE__*/ (() => {
    class ShapeTags extends List$1 {
        constructor() {
            super(String_$type, 0);
        }
    }
    ShapeTags.$t = /*@__PURE__*/ markType(ShapeTags, 'ShapeTags', /*@__PURE__*/ List$1.$.specialize(String_$type));
    return ShapeTags;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PointData = /*@__PURE__*/ (() => {
    class PointData extends Base {
        constructor(a, b) {
            super();
            this._x = 0;
            this._y = 0;
            this.x = a;
            this.y = b;
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        serialize() {
            return "{ x: " + this.x + ", y: " + this.y + "}";
        }
        static b(a) {
            let b = new PointData(a.x, a.y);
            return b;
        }
        g() {
            let a = PointUtil.create();
            a.x = this.x;
            a.y = this.y;
            return a;
        }
        equals(a) {
            let b = typeCast(PointData.$, a);
            if (b == null) {
                return false;
            }
            return b.x == this.x && b.y == this.y;
        }
        getHashCode() {
            return ((this.x) * 397) ^ (this.y);
        }
        static get empty() {
            return new PointData(Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        }
    }
    PointData.$t = /*@__PURE__*/ markType(PointData, 'PointData', Base.$, [IVisualData_$type]);
    return PointData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimitiveVisualData = /*@__PURE__*/ (() => {
    class PrimitiveVisualData extends Base {
        constructor(a, ..._rest) {
            super();
            this._appearance = null;
            this._tags = null;
            this._name = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.name = c;
                        this.tags = new ShapeTags();
                        this.appearance = new PrimitiveAppearanceData();
                    }
                    break;
            }
        }
        get appearance() {
            return this._appearance;
        }
        set appearance(a) {
            this._appearance = a;
        }
        get tags() {
            return this._tags;
        }
        set tags(a) {
            this._tags = a;
        }
        get name() {
            return this._name;
        }
        set name(a) {
            this._name = a;
        }
        scaleByViewport(a) {
            this.appearance.m(a);
        }
        getPoints(a) {
            let b = new List$1(List$1.$.specialize(PointData.$), 0);
            this.getPointsOverride(b, a);
            return b;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("appearance: " + (this.appearance != null ? this.appearance.serialize() : "null") + ", ");
            a.u("tags: [");
            for (let b = 0; b < this.tags.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("\"" + this.tags._inner[b] + "\"");
            }
            a.u("],");
            a.u("type: \"" + this.type + "\", ");
            a.u("name: \"" + this.name + "\", ");
            a.u(this.e());
            a.u("}");
            return a.toString();
        }
        e() {
            return "";
        }
    }
    PrimitiveVisualData.$t = /*@__PURE__*/ markType(PrimitiveVisualData, 'PrimitiveVisualData', Base.$, [IVisualData_$type]);
    return PrimitiveVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PrimitiveVisualDataList = /*@__PURE__*/ (() => {
    class PrimitiveVisualDataList extends List$1 {
        constructor() {
            super(PrimitiveVisualData.$, 0);
        }
        containingTag(a) {
            let b = new PrimitiveVisualDataList();
            for (let c = 0; c < this.count; c++) {
                let d = this._inner[c];
                for (let e = 0; e < d.tags.count; e++) {
                    if (d.tags._inner[e] == a) {
                        b.add(d);
                        break;
                    }
                }
            }
            return b;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.l("{ items: [");
            for (let b = 0; b < this.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this._inner[b].serialize());
            }
            return a.toString();
        }
    }
    PrimitiveVisualDataList.$t = /*@__PURE__*/ markType(PrimitiveVisualDataList, 'PrimitiveVisualDataList', /*@__PURE__*/ List$1.$.specialize(PrimitiveVisualData.$), [IVisualData_$type]);
    return PrimitiveVisualDataList;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelAppearanceData = /*@__PURE__*/ (() => {
    class LabelAppearanceData extends Base {
        constructor() {
            super(...arguments);
            this._text = null;
            this._horizontalAlignment = null;
            this._verticalAlignment = null;
            this._textAlignment = null;
            this._textWrapping = null;
            this._textPosition = null;
            this._labelBrush = null;
            this._labelBrushExtended = null;
            this._angle = 0;
            this._opacity = 0;
            this._visibility = false;
            this._font = null;
            this._fontFamily = null;
            this._fontSize = 0;
            this._fontWeight = null;
            this._fontStyle = null;
            this._fontStretch = null;
            this._marginLeft = 0;
            this._marginRight = 0;
            this._marginTop = 0;
            this._marginBottom = 0;
        }
        get text() {
            return this._text;
        }
        set text(a) {
            this._text = a;
        }
        get horizontalAlignment() {
            return this._horizontalAlignment;
        }
        set horizontalAlignment(a) {
            this._horizontalAlignment = a;
        }
        get verticalAlignment() {
            return this._verticalAlignment;
        }
        set verticalAlignment(a) {
            this._verticalAlignment = a;
        }
        get textAlignment() {
            return this._textAlignment;
        }
        set textAlignment(a) {
            this._textAlignment = a;
        }
        get textWrapping() {
            return this._textWrapping;
        }
        set textWrapping(a) {
            this._textWrapping = a;
        }
        get textPosition() {
            return this._textPosition;
        }
        set textPosition(a) {
            this._textPosition = a;
        }
        get labelBrush() {
            return this._labelBrush;
        }
        set labelBrush(a) {
            this._labelBrush = a;
        }
        get labelBrushExtended() {
            return this._labelBrushExtended;
        }
        set labelBrushExtended(a) {
            this._labelBrushExtended = a;
        }
        get angle() {
            return this._angle;
        }
        set angle(a) {
            this._angle = a;
        }
        get opacity() {
            return this._opacity;
        }
        set opacity(a) {
            this._opacity = a;
        }
        get visibility() {
            return this._visibility;
        }
        set visibility(a) {
            this._visibility = a;
        }
        get font() {
            return this._font;
        }
        set font(a) {
            this._font = a;
        }
        get fontFamily() {
            return this._fontFamily;
        }
        set fontFamily(a) {
            this._fontFamily = a;
        }
        get fontSize() {
            return this._fontSize;
        }
        set fontSize(a) {
            this._fontSize = a;
        }
        get fontWeight() {
            return this._fontWeight;
        }
        set fontWeight(a) {
            this._fontWeight = a;
        }
        get fontStyle() {
            return this._fontStyle;
        }
        set fontStyle(a) {
            this._fontStyle = a;
        }
        get fontStretch() {
            return this._fontStretch;
        }
        set fontStretch(a) {
            this._fontStretch = a;
        }
        get marginLeft() {
            return this._marginLeft;
        }
        set marginLeft(a) {
            this._marginLeft = a;
        }
        get marginRight() {
            return this._marginRight;
        }
        set marginRight(a) {
            this._marginRight = a;
        }
        get marginTop() {
            return this._marginTop;
        }
        set marginTop(a) {
            this._marginTop = a;
        }
        get marginBottom() {
            return this._marginBottom;
        }
        set marginBottom(a) {
            this._marginBottom = a;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("text: \"" + (this.text != null ? this.text : "") + "\", ");
            if (this.textAlignment != null) {
                a.u("textAlignment: \"" + this.textAlignment + "\", ");
            }
            if (this.textWrapping != null) {
                a.u("textWrapping: \"" + this.textWrapping + "\", ");
            }
            a.u("labelBrush: " + (this.labelBrush != null ? this.labelBrush.serialize() : "null") + ", ");
            a.u("labelBrushExtended: " + (this.labelBrushExtended != null ? this.labelBrushExtended.serialize() : "null") + ", ");
            a.u("angle: " + this.angle + ", ");
            a.u("marginLeft: " + this.marginLeft + ", ");
            a.u("marginRight: " + this.marginRight + ", ");
            a.u("marginTop: " + this.marginTop + ", ");
            a.u("marginBottom: " + this.marginBottom + ", ");
            a.u("opacity: " + this.opacity + ", ");
            a.u("visibility: " + (this.visibility ? "true" : "false") + ", ");
            if (this.horizontalAlignment != null) {
                a.u("horizontalAlignment: \"" + this.horizontalAlignment + "\", ");
            }
            if (this.verticalAlignment != null) {
                a.u("verticalAlignment: \"" + this.verticalAlignment + "\", ");
            }
            if (this.font != null) {
                a.u("font: \"" + this.font + "\",");
            }
            if (this.fontFamily != null) {
                a.u("fontFamily: \"" + stringReplace(this.fontFamily, "\"", "'") + "\",");
            }
            if (this.fontWeight != null) {
                a.u("fontWeight: \"" + this.fontWeight + "\",");
            }
            if (this.fontStyle != null) {
                a.u("fontStyle: \"" + this.fontStyle + "\",");
            }
            if (this.fontStretch != null) {
                a.u("fontStretch: \"" + this.fontStretch + "\",");
            }
            a.u("fontSize: " + this.fontSize);
            a.u("}");
            return a.toString();
        }
    }
    LabelAppearanceData.$t = /*@__PURE__*/ markType(LabelAppearanceData, 'LabelAppearanceData', Base.$, [IVisualData_$type]);
    return LabelAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VisualDataPixelScalingOptions = /*@__PURE__*/ (() => {
    class VisualDataPixelScalingOptions extends Base {
    }
    VisualDataPixelScalingOptions.$t = /*@__PURE__*/ markType(VisualDataPixelScalingOptions, 'VisualDataPixelScalingOptions');
    return VisualDataPixelScalingOptions;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LabelAppearanceDataList = /*@__PURE__*/ (() => {
    class LabelAppearanceDataList extends List$1 {
        constructor() {
            super(LabelAppearanceData.$, 0);
        }
        serialize() {
            let a = new StringBuilder(0);
            a.l("{ items: [");
            for (let b = 0; b < this.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this._inner[b].serialize());
            }
            return a.toString();
        }
    }
    LabelAppearanceDataList.$t = /*@__PURE__*/ markType(LabelAppearanceDataList, 'LabelAppearanceDataList', /*@__PURE__*/ List$1.$.specialize(LabelAppearanceData.$), [IVisualData_$type]);
    return LabelAppearanceDataList;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BrushAppearanceData = /*@__PURE__*/ (() => {
    class BrushAppearanceData extends Base {
        serialize() {
            return "{ type: \"" + this.type + "\", " + this.a() + " }";
        }
        a() {
            return "";
        }
    }
    BrushAppearanceData.$t = /*@__PURE__*/ markType(BrushAppearanceData, 'BrushAppearanceData', Base.$, [IVisualData_$type]);
    return BrushAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ColorData = /*@__PURE__*/ (() => {
    class ColorData extends Base {
        constructor() {
            super(...arguments);
            this._a = 0;
            this._r = 0;
            this._g = 0;
            this._b = 0;
        }
        get a() {
            return this._a;
        }
        set a(a) {
            this._a = a;
        }
        get r() {
            return this._r;
        }
        set r(a) {
            this._r = a;
        }
        get g() {
            return this._g;
        }
        set g(a) {
            this._g = a;
        }
        get b() {
            return this._b;
        }
        set b(a) {
            this._b = a;
        }
        serialize() {
            return "{ a: " + this.a + ", r: " + this.r + ", g: " + this.g + ", b: " + this.b + "}";
        }
        static a_1(a) {
            let b = new ColorData();
            b.a = a.l;
            b.r = a.o;
            b.g = a.n;
            b.b = a.m;
            return b;
        }
        f() {
            let a = new Color();
            a.l = this.a;
            a.o = this.r;
            a.n = this.g;
            a.m = this.b;
            return a;
        }
    }
    ColorData.$t = /*@__PURE__*/ markType(ColorData, 'ColorData', Base.$, [IVisualData_$type]);
    return ColorData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectData = /*@__PURE__*/ (() => {
    class RectData extends Base {
        constructor(a, b, c, d) {
            super();
            this._top = 0;
            this._left = 0;
            this._width = 0;
            this._height = 0;
            this.left = a;
            this.top = b;
            this.width = c;
            this.height = d;
        }
        get top() {
            return this._top;
        }
        set top(a) {
            this._top = a;
        }
        get left() {
            return this._left;
        }
        set left(a) {
            this._left = a;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        serialize() {
            return "{ top: " + this.top + ", left: " + this.left + ", width: " + this.width + ", height: " + this.height + "}";
        }
        static b(a) {
            let b = new RectData(a.left, a.top, a.width, a.height);
            return b;
        }
        h() {
            let a = new Rect(0, this.left, this.top, this.width, this.height);
            return a;
        }
        get isEmpty() {
            return this.width < 0;
        }
        static get empty() {
            return new RectData(Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY);
        }
    }
    RectData.$t = /*@__PURE__*/ markType(RectData, 'RectData', Base.$, [IVisualData_$type]);
    return RectData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SizeData = /*@__PURE__*/ (() => {
    class SizeData extends Base {
        constructor(a, b) {
            super();
            this._width = 0;
            this._height = 0;
            this.width = a;
            this.height = b;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        serialize() {
            return "{ width: " + this.width + ", height: " + this.height + "}";
        }
        static b(a) {
            let b = new SizeData(a.width, a.height);
            return b;
        }
        e() {
            let a = new Size(1, this.width, this.height);
            return a;
        }
        static get empty() {
            return new SizeData(Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        }
    }
    SizeData.$t = /*@__PURE__*/ markType(SizeData, 'SizeData', Base.$, [IVisualData_$type]);
    return SizeData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SolidBrushAppearanceData = /*@__PURE__*/ (() => {
    class SolidBrushAppearanceData extends BrushAppearanceData {
        constructor() {
            super(...arguments);
            this._colorValue = null;
        }
        get_type() {
            return "solid";
        }
        get type() {
            return this.get_type();
        }
        get colorValue() {
            return this._colorValue;
        }
        set colorValue(a) {
            this._colorValue = a;
        }
        a() {
            return "colorValue: " + (this.colorValue != null ? this.colorValue.serialize() : "null");
        }
    }
    SolidBrushAppearanceData.$t = /*@__PURE__*/ markType(SolidBrushAppearanceData, 'SolidBrushAppearanceData', BrushAppearanceData.$);
    return SolidBrushAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GradientStopAppearanceData = /*@__PURE__*/ (() => {
    class GradientStopAppearanceData extends Base {
        constructor() {
            super(...arguments);
            this._colorValue = null;
            this._offset = 0;
        }
        get colorValue() {
            return this._colorValue;
        }
        set colorValue(a) {
            this._colorValue = a;
        }
        get offset() {
            return this._offset;
        }
        set offset(a) {
            this._offset = a;
        }
        serialize() {
            return "{ " + "colorValue: " + (this.colorValue != null ? this.colorValue.serialize() : "null") + ", offset: " + this.offset + " }";
        }
    }
    GradientStopAppearanceData.$t = /*@__PURE__*/ markType(GradientStopAppearanceData, 'GradientStopAppearanceData', Base.$, [IVisualData_$type]);
    return GradientStopAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LinearGradientBrushAppearanceData = /*@__PURE__*/ (() => {
    class LinearGradientBrushAppearanceData extends BrushAppearanceData {
        constructor() {
            super();
            this._startX = 0;
            this._startY = 0;
            this._endX = 0;
            this._endY = 0;
            this._stops = null;
            this.stops = new List$1(GradientStopAppearanceData.$, 0);
        }
        get_type() {
            return "linear";
        }
        get type() {
            return this.get_type();
        }
        get startX() {
            return this._startX;
        }
        set startX(a) {
            this._startX = a;
        }
        get startY() {
            return this._startY;
        }
        set startY(a) {
            this._startY = a;
        }
        get endX() {
            return this._endX;
        }
        set endX(a) {
            this._endX = a;
        }
        get endY() {
            return this._endY;
        }
        set endY(a) {
            this._endY = a;
        }
        get stops() {
            return this._stops;
        }
        set stops(a) {
            this._stops = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.l("startX: " + this.startX + ", endX: " + this.endX + ", startY: " + this.startY + ", endY: " + this.endY);
            a.l(", stops: [");
            for (let b = 0; b < this.stops.count; b++) {
                if (b > 0) {
                    a.l(", ");
                }
                a.l(this.stops._inner[b].serialize());
            }
            a.l("]");
            return a.toString();
        }
    }
    LinearGradientBrushAppearanceData.$t = /*@__PURE__*/ markType(LinearGradientBrushAppearanceData, 'LinearGradientBrushAppearanceData', BrushAppearanceData.$);
    return LinearGradientBrushAppearanceData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GetPointsSettings = /*@__PURE__*/ (() => {
    class GetPointsSettings extends Base {
        constructor() {
            super(...arguments);
            this._ignoreFigureStartPoint = false;
        }
        get ignoreFigureStartPoint() {
            return this._ignoreFigureStartPoint;
        }
        set ignoreFigureStartPoint(a) {
            this._ignoreFigureStartPoint = a;
        }
    }
    GetPointsSettings.$t = /*@__PURE__*/ markType(GetPointsSettings, 'GetPointsSettings');
    return GetPointsSettings;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryData = /*@__PURE__*/ (() => {
    class GeometryData extends Base {
        serialize() {
            return "{ type: \"" + this.type + "\", " + this.a() + "}";
        }
        a() {
            return "";
        }
    }
    GeometryData.$t = /*@__PURE__*/ markType(GeometryData, 'GeometryData', Base.$, [IVisualData_$type]);
    return GeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineGeometry = /*@__PURE__*/ (() => {
    class LineGeometry extends Geometry {
        constructor() {
            super(...arguments);
            this.d = null;
            this.c = null;
        }
        get_b() {
            return 1;
        }
        get b() {
            return this.get_b();
        }
    }
    LineGeometry.$t = /*@__PURE__*/ markType(LineGeometry, 'LineGeometry', Geometry.$);
    return LineGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryCollection = /*@__PURE__*/ (() => {
    class GeometryCollection extends List$1 {
        constructor() {
            super(Geometry.$, 0);
        }
    }
    GeometryCollection.$t = /*@__PURE__*/ markType(GeometryCollection, 'GeometryCollection', /*@__PURE__*/ List$1.$.specialize(Geometry.$));
    return GeometryCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GeometryGroup = /*@__PURE__*/ (() => {
    class GeometryGroup extends Geometry {
        constructor() {
            super();
            this.d = null;
            this.c = 0;
            this.d = new GeometryCollection();
        }
        get_b() {
            return 0;
        }
        get b() {
            return this.get_b();
        }
    }
    GeometryGroup.$t = /*@__PURE__*/ markType(GeometryGroup, 'GeometryGroup', Geometry.$);
    return GeometryGroup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectangleGeometry = /*@__PURE__*/ (() => {
    class RectangleGeometry extends Geometry {
        constructor() {
            super(...arguments);
            this.e = null;
            this.c = 0;
            this.d = 0;
        }
        get_b() {
            return 2;
        }
        get b() {
            return this.get_b();
        }
    }
    RectangleGeometry.$t = /*@__PURE__*/ markType(RectangleGeometry, 'RectangleGeometry', Geometry.$);
    return RectangleGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EllipseGeometry = /*@__PURE__*/ (() => {
    class EllipseGeometry extends Geometry {
        constructor() {
            super(...arguments);
            this.e = null;
            this.c = 0;
            this.d = 0;
        }
        get_b() {
            return 3;
        }
        get b() {
            return this.get_b();
        }
    }
    EllipseGeometry.$t = /*@__PURE__*/ markType(EllipseGeometry, 'EllipseGeometry', Geometry.$);
    return EllipseGeometry;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let EllipseGeometryData = /*@__PURE__*/ (() => {
    class EllipseGeometryData extends GeometryData {
        constructor() {
            super(...arguments);
            this._centerX = 0;
            this._centerY = 0;
            this._radiusX = 0;
            this._radiusY = 0;
        }
        get_type() {
            return "Ellipse";
        }
        get type() {
            return this.get_type();
        }
        get centerX() {
            return this._centerX;
        }
        set centerX(a) {
            this._centerX = a;
        }
        get centerY() {
            return this._centerY;
        }
        set centerY(a) {
            this._centerY = a;
        }
        get radiusX() {
            return this._radiusX;
        }
        set radiusX(a) {
            this._radiusX = a;
        }
        get radiusY() {
            return this._radiusY;
        }
        set radiusY(a) {
            this._radiusY = a;
        }
        a() {
            return "centerX: " + this.centerX + ", centerY: " + this.centerY + ", radiusX: " + this.radiusX + ", radiusY: " + this.radiusY;
        }
        scaleByViewport(a) {
            this.centerX = (this.centerX - a.left) / a.width;
            this.centerY = (this.centerY - a.top) / a.height;
            this.radiusX = this.radiusX / a.width;
            this.radiusY = this.radiusY / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.centerX, this.centerY));
        }
    }
    EllipseGeometryData.$t = /*@__PURE__*/ markType(EllipseGeometryData, 'EllipseGeometryData', GeometryData.$);
    return EllipseGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectangleGeometryData = /*@__PURE__*/ (() => {
    class RectangleGeometryData extends GeometryData {
        constructor() {
            super(...arguments);
            this._x = 0;
            this._y = 0;
            this._width = 0;
            this._height = 0;
        }
        get_type() {
            return "Rectangle";
        }
        get type() {
            return this.get_type();
        }
        get x() {
            return this._x;
        }
        set x(a) {
            this._x = a;
        }
        get y() {
            return this._y;
        }
        set y(a) {
            this._y = a;
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        a() {
            return "x: " + this.x + ", y: " + this.y + ", width: " + this.width + ", height: " + this.height;
        }
        scaleByViewport(a) {
            this.x = (this.x - a.left) / a.width;
            this.y = (this.y - a.top) / a.height;
            this.width = this.width / a.width;
            this.height = this.height / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.x, this.y));
            c.add(new PointData(this.x + this.width, this.y));
            c.add(new PointData(this.x + this.width, this.y + this.height));
            c.add(new PointData(this.x, this.y + this.height));
        }
    }
    RectangleGeometryData.$t = /*@__PURE__*/ markType(RectangleGeometryData, 'RectangleGeometryData', GeometryData.$);
    return RectangleGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineGeometryData = /*@__PURE__*/ (() => {
    class LineGeometryData extends GeometryData {
        constructor() {
            super(...arguments);
            this._x1 = 0;
            this._y1 = 0;
            this._x2 = 0;
            this._y2 = 0;
        }
        get_type() {
            return "Line";
        }
        get type() {
            return this.get_type();
        }
        get x1() {
            return this._x1;
        }
        set x1(a) {
            this._x1 = a;
        }
        get y1() {
            return this._y1;
        }
        set y1(a) {
            this._y1 = a;
        }
        get x2() {
            return this._x2;
        }
        set x2(a) {
            this._x2 = a;
        }
        get y2() {
            return this._y2;
        }
        set y2(a) {
            this._y2 = a;
        }
        a() {
            return "x1: " + this.x1 + ", y1: " + this.y1 + ", x2: " + this.x2 + ", y2:" + this.y2;
        }
        scaleByViewport(a) {
            this.x1 = (this.x1 - a.left) / a.width;
            this.y1 = (this.y1 - a.top) / a.height;
            this.x2 = (this.x2 - a.left) / a.width;
            this.y2 = (this.y2 - a.top) / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.x1, this.y1));
            c.add(new PointData(this.x2, this.y2));
        }
    }
    LineGeometryData.$t = /*@__PURE__*/ markType(LineGeometryData, 'LineGeometryData', GeometryData.$);
    return LineGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SegmentData = /*@__PURE__*/ (() => {
    class SegmentData extends Base {
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("type: \"" + this.type + "\", ");
            a.u(this.a());
            a.u("}");
            return a.toString();
        }
        a() {
            return "";
        }
    }
    SegmentData.$t = /*@__PURE__*/ markType(SegmentData, 'SegmentData', Base.$, [IVisualData_$type]);
    return SegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineSegmentData = /*@__PURE__*/ (() => {
    class LineSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._point = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.point = new PointData(NaN, NaN);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.point = PointData.b(c.c);
                    }
                    break;
            }
        }
        get_type() {
            return "Line";
        }
        get type() {
            return this.get_type();
        }
        get point() {
            return this._point;
        }
        set point(a) {
            this._point = a;
        }
        a() {
            return "point: { x: " + this.point.x + ", y: " + this.point.y + "}";
        }
        scaleByViewport(a) {
            this.point = new PointData((this.point.x - a.left) / a.width, (this.point.y - a.top) / a.height);
        }
        getPointsOverride(a, b) {
            a.add(new PointData(this.point.x, this.point.y));
        }
    }
    LineSegmentData.$t = /*@__PURE__*/ markType(LineSegmentData, 'LineSegmentData', SegmentData.$);
    return LineSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolylineSegmentData = /*@__PURE__*/ (() => {
    class PolylineSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._points = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.points = new List$1(PointData.$, 0);
                        for (let d = 0; d < c._points.count; d++) {
                            this.points.add(PointData.b(c._points._inner[d]));
                        }
                    }
                    break;
            }
        }
        get_type() {
            return "Polyline";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.points.count; c++) {
                a.add(new PointData(this.points._inner[c].x, this.points._inner[c].y));
            }
        }
    }
    PolylineSegmentData.$t = /*@__PURE__*/ markType(PolylineSegmentData, 'PolylineSegmentData', SegmentData.$);
    return PolylineSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArcSegmentData = /*@__PURE__*/ (() => {
    class ArcSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._point = null;
            this._isLargeArc = false;
            this._isCounterClockwise = false;
            this._sizeX = 0;
            this._sizeY = 0;
            this._rotationAngle = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.point = new PointData(NaN, NaN);
                        this.isLargeArc = false;
                        this.isCounterClockwise = true;
                        this.rotationAngle = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.point = PointData.b(c.e);
                        this.isLargeArc = c.b;
                        this.isCounterClockwise = c.d == 0;
                        this.sizeX = c.f.width;
                        this.sizeY = c.f.height;
                        this.rotationAngle = c.c;
                    }
                    break;
            }
        }
        get_type() {
            return "Arc";
        }
        get type() {
            return this.get_type();
        }
        get point() {
            return this._point;
        }
        set point(a) {
            this._point = a;
        }
        get isLargeArc() {
            return this._isLargeArc;
        }
        set isLargeArc(a) {
            this._isLargeArc = a;
        }
        get isCounterClockwise() {
            return this._isCounterClockwise;
        }
        set isCounterClockwise(a) {
            this._isCounterClockwise = a;
        }
        get sizeX() {
            return this._sizeX;
        }
        set sizeX(a) {
            this._sizeX = a;
        }
        get sizeY() {
            return this._sizeY;
        }
        set sizeY(a) {
            this._sizeY = a;
        }
        get rotationAngle() {
            return this._rotationAngle;
        }
        set rotationAngle(a) {
            this._rotationAngle = a;
        }
        a() {
            return "point: { x: " + this.point.x + ", y: " + this.point.y + " }, isLargeArc: " + (this.isLargeArc ? "true" : "false") + ", isCounterClockwise: " + (this.isCounterClockwise ? "true" : "false") + ", sizeX: " + this.sizeX + ", sizeY: " + this.sizeY + ", rotationAngle: " + this.rotationAngle;
        }
        scaleByViewport(a) {
            this.point = new PointData((this.point.x - a.left) / a.width, (this.point.y - a.top) / a.height);
            this.sizeX = this.sizeX / a.width;
            this.sizeY = this.sizeY / a.height;
        }
        getPointsOverride(a, b) {
            a.add(new PointData(this.point.x, this.point.y));
        }
    }
    ArcSegmentData.$t = /*@__PURE__*/ markType(ArcSegmentData, 'ArcSegmentData', SegmentData.$);
    return ArcSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyBezierSegmentData = /*@__PURE__*/ (() => {
    class PolyBezierSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._points = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.points = new List$1(PointData.$, 0);
                        for (let d = 0; d < c.b.count; d++) {
                            this.points.add(PointData.b(c.b._inner[d]));
                        }
                    }
                    break;
            }
        }
        get_type() {
            return "PolyBezierSpline";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.points.count; c++) {
                a.add(new PointData(this.points._inner[c].x, this.points._inner[c].y));
            }
        }
    }
    PolyBezierSegmentData.$t = /*@__PURE__*/ markType(PolyBezierSegmentData, 'PolyBezierSegmentData', SegmentData.$);
    return PolyBezierSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BezierSegmentData = /*@__PURE__*/ (() => {
    class BezierSegmentData extends SegmentData {
        constructor(a, ..._rest) {
            super();
            this._points = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.points = new List$1(PointData.$, 0);
                        this.points.add(PointData.b(c.e));
                        this.points.add(PointData.b(c.f));
                        this.points.add(PointData.b(c.g));
                    }
                    break;
            }
        }
        get_type() {
            return "Bezier";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (this.points._inner[b] == null) {
                    break;
                }
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b = 0; b < this.points.count; b++) {
                if (this.points._inner[b] == null) {
                    break;
                }
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.points.count; c++) {
                a.add(new PointData(this.points._inner[c].x, this.points._inner[c].y));
            }
        }
    }
    BezierSegmentData.$t = /*@__PURE__*/ markType(BezierSegmentData, 'BezierSegmentData', SegmentData.$);
    return BezierSegmentData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathFigureData = /*@__PURE__*/ (() => {
    class PathFigureData extends Base {
        constructor(a, ..._rest) {
            super();
            this._startPoint = null;
            this._segments = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.segments = new List$1(SegmentData.$, 0);
                        this.startPoint = new PointData(NaN, NaN);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.segments = new List$1(SegmentData.$, 0);
                        this.startPoint = PointData.b(c._startPoint);
                        for (let d = 0; d < c._segments.count; d++) {
                            let e = c._segments._inner[d];
                            let f = null;
                            switch (e.a) {
                                case 0:
                                    f = new LineSegmentData(1, e);
                                    break;
                                case 3:
                                    f = new PolylineSegmentData(1, e);
                                    break;
                                case 4:
                                    f = new ArcSegmentData(1, e);
                                    break;
                                case 2:
                                    f = new PolyBezierSegmentData(1, e);
                                    break;
                                case 1:
                                    f = new BezierSegmentData(1, e);
                                    break;
                            }
                            this.segments.add(f);
                        }
                    }
                    break;
            }
        }
        get startPoint() {
            return this._startPoint;
        }
        set startPoint(a) {
            this._startPoint = a;
        }
        get segments() {
            return this._segments;
        }
        set segments(a) {
            this._segments = a;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            if (this.startPoint != null) {
                a.u("startPoint: { x: " + this.startPoint.x + ", y: " + this.startPoint.y + "}, ");
            }
            a.u("segments: [");
            for (let b = 0; b < this.segments.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.segments._inner[b].serialize());
            }
            a.u("]");
            a.u("}");
            return a.toString();
        }
        d(a) {
            if (this.startPoint != null) {
                this.startPoint = new PointData((this.startPoint.x - a.left) / a.width, (this.startPoint.y - a.top) / a.height);
            }
            for (let b = 0; b < this.segments.count; b++) {
                this.segments._inner[b].scaleByViewport(a);
            }
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            if (!b.ignoreFigureStartPoint) {
                c.add(new PointData(this.startPoint.x, this.startPoint.y));
            }
            for (let d = 0; d < this.segments.count; d++) {
                this.segments._inner[d].getPointsOverride(c, b);
            }
        }
    }
    PathFigureData.$t = /*@__PURE__*/ markType(PathFigureData, 'PathFigureData', Base.$, [IVisualData_$type]);
    return PathFigureData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathGeometryData = /*@__PURE__*/ (() => {
    class PathGeometryData extends GeometryData {
        constructor() {
            super();
            this._figures = null;
            this.figures = new List$1(PathFigureData.$, 0);
        }
        get_type() {
            return "Path";
        }
        get type() {
            return this.get_type();
        }
        get figures() {
            return this._figures;
        }
        set figures(a) {
            this._figures = a;
        }
        a() {
            let a = new StringBuilder(0);
            a.u("figures: [");
            for (let b = 0; b < this.figures.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.figures._inner[b].serialize());
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            for (let b of fromEnum(this.figures)) {
                b.d(a);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.figures.count; c++) {
                let d = this.figures._inner[c];
                d.getPointsOverride(a, b);
            }
        }
    }
    PathGeometryData.$t = /*@__PURE__*/ markType(PathGeometryData, 'PathGeometryData', GeometryData.$);
    return PathGeometryData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AppearanceHelper = /*@__PURE__*/ (() => {
    class AppearanceHelper extends Base {
        static b(a) {
            if (a == null) {
                return ColorData.a_1(Color.u(0, 0, 0, 0));
            }
            if (Color.c(toNullable(Color.$, a.color), toNullable(Color.$, null))) {
                return ColorData.a_1(Color.u(0, 0, 0, 0));
            }
            return ColorData.a_1(a.color);
        }
        static a(a) {
            if (a == null) {
                return null;
            }
            if (a.isGradient) {
                let b = new LinearGradientBrushAppearanceData();
                let c = a;
                b.startX = c.startX;
                b.startY = c.startY;
                b.endX = c.endX;
                b.endY = c.endY;
                let f = c.gradientStops;
                for (let e = 0; e < f.length; e++) {
                    let d = f[e];
                    let g = new GradientStopAppearanceData();
                    g.colorValue = ColorData.a_1(d.color);
                    g.offset = d.offset;
                    b.stops.add(g);
                }
                return b;
            }
            else if (a.isRadialGradient) {
                return null;
            }
            else {
                let h = new SolidBrushAppearanceData();
                h.colorValue = ColorData.a_1(a.color);
                return h;
            }
        }
        static m(a) {
            return a.n;
        }
        static n(a) {
            return a.o;
        }
        static o(a) {
            return a.s;
        }
        static j(a) {
            return AppearanceHelper.g(a.ak);
        }
        static h(a) {
            let b = new LineGeometry();
            b.c = { $type: Point_$type, x: a.al, y: a.an };
            b.d = { $type: Point_$type, x: a.ak, y: a.am };
            return AppearanceHelper.g(b);
        }
        static g(a) {
            if (a == null) {
                return new List$1(GeometryData.$, 0);
            }
            if (typeCast(GeometryGroup.$, a) !== null) {
                let b = new List$1(GeometryData.$, 0);
                let c = a;
                for (let d = 0; d < c.d.count; d++) {
                    let e = AppearanceHelper.g(c.d._inner[d]);
                    for (let f = 0; f < e.count; f++) {
                        b.add(e._inner[f]);
                    }
                }
                return b;
            }
            else if (typeCast(PathGeometry.$, a) !== null) {
                return AppearanceHelper.k(a);
            }
            else if (typeCast(LineGeometry.$, a) !== null) {
                return AppearanceHelper.i(a);
            }
            else if (typeCast(RectangleGeometry.$, a) !== null) {
                return AppearanceHelper.l(a);
            }
            else if (typeCast(EllipseGeometry.$, a) !== null) {
                return AppearanceHelper.f(a);
            }
            else {
                throw new NotSupportedException(1, "not supported");
            }
        }
        static f(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new EllipseGeometryData();
            b.add(c);
            c.centerX = a.e.x;
            c.centerY = a.e.y;
            c.radiusX = a.c;
            c.radiusY = a.d;
            return b;
        }
        static l(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new RectangleGeometryData();
            b.add(c);
            c.x = a.e.x;
            c.y = a.e.y;
            c.width = a.e.width;
            c.height = a.e.height;
            return b;
        }
        static i(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new LineGeometryData();
            b.add(c);
            c.x1 = a.d.x;
            c.y1 = a.d.y;
            c.x2 = a.c.x;
            c.y2 = a.c.y;
            return b;
        }
        static k(a) {
            let b = new List$1(GeometryData.$, 0);
            let c = new PathGeometryData();
            b.add(c);
            for (let d = 0; d < a.c.count; d++) {
                let e = a.c._inner[d];
                let f = new PathFigureData(1, e);
                c.figures.add(f);
            }
            return b;
        }
        static p(a, b) {
            a.stroke = AppearanceHelper.b(b._stroke);
            a.fill = AppearanceHelper.b(b._fill);
            a.strokeExtended = AppearanceHelper.a(b._stroke);
            a.fillExtended = AppearanceHelper.a(b._fill);
            a.strokeThickness = b.ac;
            a.dashArray = null;
            if (b.ai != null) {
                a.dashArray = b.ai.asArray();
            }
            a.dashCap = b.ad;
            a.isVisible = b._visibility == 0;
            a.opacity = b._opacity;
            a.canvasLeft = AppearanceHelper.m(b);
            a.canvasTop = AppearanceHelper.n(b);
            a.canvaZIndex = AppearanceHelper.o(b);
        }
        static c(a, b) {
            let c = new LabelAppearanceData();
            let d = a;
            c.text = d.ak;
            c.labelBrush = AppearanceHelper.b(d.am);
            c.labelBrushExtended = AppearanceHelper.a(d.am);
            c.visibility = (d._visibility == 0) ? true : false;
            c.opacity = d._opacity;
            if (b != null) {
                if (b.n != null) {
                    c.fontFamily = b.n;
                }
                if (!isNaN_(b.d)) {
                    c.fontSize = b.d;
                }
                c.fontWeight = stringIsNullOrEmpty(b.s) ? "Normal" : b.s;
                c.fontStyle = stringIsNullOrEmpty(b.q) ? "Normal" : b.q;
                if (b.o != null) {
                    c.fontStretch = b.q;
                }
            }
            let e = 0;
            let f = d.j;
            if (typeCast(RotateTransform.$, f) !== null) {
                let g = typeCast(RotateTransform.$, f);
                e = g.j;
            }
            else if (typeCast(TransformGroup.$, f) !== null) {
                let h = typeCast(TransformGroup.$, f);
                for (let i of fromEnum(h.j)) {
                    if (typeCast(RotateTransform.$, i) !== null) {
                        let j = typeCast(RotateTransform.$, i);
                        e = j.j;
                        break;
                    }
                }
            }
            c.angle = e;
            return c;
        }
        static serializeItems(a, b, c, d) {
            if (c != null) {
                if (!d) {
                    a.l(", ");
                }
                a.l(b);
                a.l(": [");
                let e = false;
                for (let f of fromEnum(c)) {
                    if (e) {
                        a.u(", ");
                    }
                    else {
                        e = true;
                    }
                    a.l(f.serialize());
                }
                a.u("]");
                return true;
            }
            return false;
        }
        static serializeItem(a, b, c, d) {
            if (c != null) {
                if (!d) {
                    a.l(", ");
                }
                a.l(b);
                a.l(": ");
                a.u(c.serialize());
                return true;
            }
            return false;
        }
    }
    AppearanceHelper.$t = /*@__PURE__*/ markType(AppearanceHelper, 'AppearanceHelper');
    return AppearanceHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RectangleVisualData = /*@__PURE__*/ (() => {
    class RectangleVisualData extends PrimitiveVisualData {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "rect1");
                        this._width = 0;
                        this._height = 0;
                        this._radiusX = 0;
                        this._radiusY = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._width = 0;
                        this._height = 0;
                        this._radiusX = 0;
                        this._radiusY = 0;
                        this.width = d.width;
                        this.height = d.height;
                        this.radiusX = d.am;
                        this.radiusY = d.an;
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get width() {
            return this._width;
        }
        set width(a) {
            this._width = a;
        }
        get height() {
            return this._height;
        }
        set height(a) {
            this._height = a;
        }
        get radiusX() {
            return this._radiusX;
        }
        set radiusX(a) {
            this._radiusX = a;
        }
        get radiusY() {
            return this._radiusY;
        }
        set radiusY(a) {
            this._radiusY = a;
        }
        e() {
            return "width: " + this.width + ", height: " + this.height + ", radiusX: " + this.radiusX + ", radiusY: " + this.radiusY;
        }
        get_type() {
            return "Rectangle";
        }
        get type() {
            return this.get_type();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            this.width = this.width / a.width;
            this.height = this.height / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.appearance.canvasLeft, this.appearance.canvasTop));
            c.add(new PointData(this.appearance.canvasLeft + this.width, this.appearance.canvasTop));
            c.add(new PointData(this.appearance.canvasLeft + this.width, this.appearance.canvasTop + this.height));
            c.add(new PointData(this.appearance.canvasLeft, this.appearance.canvasTop + this.height));
        }
    }
    RectangleVisualData.$t = /*@__PURE__*/ markType(RectangleVisualData, 'RectangleVisualData', PrimitiveVisualData.$);
    return RectangleVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let LineVisualData = /*@__PURE__*/ (() => {
    class LineVisualData extends PrimitiveVisualData {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "line1");
                        this._x1 = 0;
                        this._y1 = 0;
                        this._x2 = 0;
                        this._y2 = 0;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._x1 = 0;
                        this._y1 = 0;
                        this._x2 = 0;
                        this._y2 = 0;
                        this.x1 = d.ak;
                        this.y1 = d.am;
                        this.x2 = d.al;
                        this.y2 = d.an;
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get_type() {
            return "Line";
        }
        get type() {
            return this.get_type();
        }
        get x1() {
            return this._x1;
        }
        set x1(a) {
            this._x1 = a;
        }
        get y1() {
            return this._y1;
        }
        set y1(a) {
            this._y1 = a;
        }
        get x2() {
            return this._x2;
        }
        set x2(a) {
            this._x2 = a;
        }
        get y2() {
            return this._y2;
        }
        set y2(a) {
            this._y2 = a;
        }
        e() {
            return "x1: " + this.x1 + ", y1: " + this.y1 + ", x2: " + this.x2 + ", y2: " + this.y2;
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            this.x1 = (this.x1 - a.left) / a.width;
            this.y1 = (this.y1 - a.top) / a.height;
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            c.add(new PointData(this.x1, this.y1));
            c.add(new PointData(this.x2, this.y2));
        }
    }
    LineVisualData.$t = /*@__PURE__*/ markType(LineVisualData, 'LineVisualData', PrimitiveVisualData.$);
    return LineVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolyLineVisualData = /*@__PURE__*/ (() => {
    class PolyLineVisualData extends PrimitiveVisualData {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "polyLine1");
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                        for (let e = 0; e < d.ak.count; e++) {
                            this.points.add(PointData.b(d.ak._inner[e]));
                        }
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get_type() {
            return "Polyline";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        e() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            for (let d = 0; d < this.points.count; d++) {
                c.add(this.points._inner[d]);
            }
        }
    }
    PolyLineVisualData.$t = /*@__PURE__*/ markType(PolyLineVisualData, 'PolyLineVisualData', PrimitiveVisualData.$);
    return PolyLineVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PolygonVisualData = /*@__PURE__*/ (() => {
    class PolygonVisualData extends PrimitiveVisualData {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "polygon1");
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._points = null;
                        this.points = new List$1(PointData.$, 0);
                        for (let e = 0; e < d.ak.count; e++) {
                            this.points.add(PointData.b(d.ak._inner[e]));
                        }
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get_type() {
            return "Polygon";
        }
        get type() {
            return this.get_type();
        }
        get points() {
            return this._points;
        }
        set points(a) {
            this._points = a;
        }
        e() {
            let a = new StringBuilder(0);
            a.u("points: [");
            for (let b = 0; b < this.points.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l("{ x: " + this.points._inner[b].x + ", y: " + this.points._inner[b].y + "}");
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            for (let b = 0; b < this.points.count; b++) {
                this.points._inner[b] = new PointData((this.points._inner[b].x - a.left) / a.width, (this.points._inner[b].y - a.top) / a.height);
            }
        }
        getPointsOverride(a, b) {
            let c = new List$1(PointData.$, 0);
            a.add(c);
            for (let d = 0; d < this.points.count; d++) {
                c.add(this.points._inner[d]);
            }
        }
    }
    PolygonVisualData.$t = /*@__PURE__*/ markType(PolygonVisualData, 'PolygonVisualData', PrimitiveVisualData.$);
    return PolygonVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathVisualData = /*@__PURE__*/ (() => {
    class PathVisualData extends PrimitiveVisualData {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, "path1");
                        this._data = null;
                        this.data = new List$1(GeometryData.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._data = null;
                        this.data = AppearanceHelper.g(d.ak);
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, c);
                        this._data = null;
                        this.data = AppearanceHelper.h(d);
                        AppearanceHelper.p(this.appearance, d);
                    }
                    break;
            }
        }
        get_type() {
            return "Path";
        }
        get type() {
            return this.get_type();
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
        e() {
            let a = new StringBuilder(0);
            a.u("data: [");
            for (let b = 0; b < this.data.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l((this.data._inner[b] != null ? this.data._inner[b].serialize() : "null"));
            }
            a.u("]");
            return a.toString();
        }
        scaleByViewport(a) {
            super.scaleByViewport(a);
            for (let b of fromEnum(this.data)) {
                b.scaleByViewport(a);
            }
        }
        getPointsOverride(a, b) {
            for (let c = 0; c < this.data.count; c++) {
                let d = this.data._inner[c];
                d.getPointsOverride(a, b);
            }
        }
    }
    PathVisualData.$t = /*@__PURE__*/ markType(PathVisualData, 'PathVisualData', PrimitiveVisualData.$);
    return PathVisualData;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ArgumentOutOfRangeException = /*@__PURE__*/ (() => {
    class ArgumentOutOfRangeException extends ArgumentException {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c + " is out of range.");
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(1, d);
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [e, c];
                        {
                            let h = f[0];
                            let i = f[1];
                            super(1, i);
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(3, c, d);
                    }
                    break;
            }
        }
    }
    ArgumentOutOfRangeException.$t = /*@__PURE__*/ markType(ArgumentOutOfRangeException, 'ArgumentOutOfRangeException', ArgumentException.$);
    return ArgumentOutOfRangeException;
})();

//
/**
 * @hidden
 */
let Buffer = /*@__PURE__*/ (() => {
    class Buffer extends Base {
        static b(a) {
            try {
            }
            catch (b) {
            }
            if (a == null) {
                throw new ArgumentNullException(0, "array");
            }
            let c = a.length;
            if (c < 0) {
                throw new ArgumentException(1, "Object must be an array of primitives.");
            }
            return c;
        }
        static a(a, b) {
            if (b < 0 || b >= Buffer.b(a)) {
                throw new ArgumentOutOfRangeException(2, "index", "Value must be non-negative and less than the size of the collection.");
            }
            return typeGetValue(a[b]);
        }
        static d(a, b, c) {
            if (b < 0 || b >= Buffer.b(a)) {
                throw new ArgumentOutOfRangeException(2, "index", "Value must be non-negative and less than the size of the collection.");
            }
            a[b] = c;
        }
        static c(a, b, c, d, e) {
            let f = b;
            let g = d;
            if (a == null) {
                throw new ArgumentNullException(0, "src");
            }
            if (c == null) {
                throw new ArgumentNullException(0, "dst");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "srcOffset", "Non-negative number required.");
            }
            if (d < 0) {
                throw new ArgumentOutOfRangeException(2, "dstOffset", "Non-negative number required.");
            }
            if (e < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "Non-negative number required.");
            }
            if ((b > Buffer.b(a) - e) || (d > Buffer.b(c) - e)) {
                throw new ArgumentException(1, "Offset and length were out of bounds for the array or count is greater than " + "the number of elements from index to the end of the source collection.");
            }
            for (let h = 0; h < e; h++) {
                c[g++] = a[f++];
            }
        }
    }
    Buffer.$t = /*@__PURE__*/ markType(Buffer, 'Buffer');
    return Buffer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbstractEnumerator = /*@__PURE__*/ (() => {
    class AbstractEnumerator extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        get currentObject() {
            return this.a.currentObject;
        }
        moveNext() {
            return this.a.moveNext();
        }
        reset() {
            this.a.reset();
        }
    }
    AbstractEnumerator.$t = /*@__PURE__*/ markType(AbstractEnumerator, 'AbstractEnumerator', Base.$, [IEnumerator_$type]);
    return AbstractEnumerator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AbstractEnumerable = /*@__PURE__*/ (() => {
    class AbstractEnumerable extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        getEnumeratorObject() {
            return new AbstractEnumerator(getEnumeratorObject(this.a()));
        }
    }
    AbstractEnumerable.$t = /*@__PURE__*/ markType(AbstractEnumerable, 'AbstractEnumerable', Base.$, [IEnumerable_$type]);
    return AbstractEnumerable;
})();

class IgrObjectCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(Base.$type, Base.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObjectCollection = /*@__PURE__*/ (() => {
    class ObjectCollection extends ObservableCollection$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(Base.$, 0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(Base.$, 1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        super(Base.$, 2, c);
                    }
                    break;
            }
        }
    }
    ObjectCollection.$t = /*@__PURE__*/ markType(ObjectCollection, 'ObjectCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Base.$));
    return ObjectCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Collection$1 = /*@__PURE__*/ (() => {
    class Collection$1 extends List$1 {
        constructor($t) {
            super($t, 0);
            this.$t = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
        get ac() {
            return this;
        }
    }
    Collection$1.$t = /*@__PURE__*/ markType(Collection$1, 'Collection$1', /*@__PURE__*/ List$1.$.specialize(0));
    return Collection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GenericEnumerator$1 = /*@__PURE__*/ (() => {
    class GenericEnumerator$1 extends Base {
        constructor($t, a) {
            super();
            this.$t = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = a;
        }
        get current() {
            return this.a.current;
        }
        get currentObject() {
            return getBoxIfEnum(this.$t, this.a.current);
        }
        moveNext() {
            return this.a.moveNext();
        }
        reset() {
            this.a.reset();
        }
        dispose() {
        }
    }
    GenericEnumerator$1.$t = /*@__PURE__*/ markType(GenericEnumerator$1, 'GenericEnumerator$1', Base.$, [/*@__PURE__*/ IEnumerator$1_$type.specialize(0)]);
    return GenericEnumerator$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GenericEnumerable$1 = /*@__PURE__*/ (() => {
    class GenericEnumerable$1 extends Base {
        constructor($t, a) {
            super();
            this.$t = null;
            this.a = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
            this.a = a;
        }
        getEnumerator() {
            return new GenericEnumerator$1(this.$t, getEnumerator(this.a()));
        }
        getEnumeratorObject() {
            return new GenericEnumerator$1(this.$t, getEnumerator(this.a()));
        }
    }
    GenericEnumerable$1.$t = /*@__PURE__*/ markType(GenericEnumerable$1, 'GenericEnumerable$1', Base.$, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0)]);
    return GenericEnumerable$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var NotifyCollectionChangedAction = /*@__PURE__*/ (function (NotifyCollectionChangedAction) {
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Add"] = 0] = "Add";
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Remove"] = 1] = "Remove";
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Replace"] = 2] = "Replace";
    NotifyCollectionChangedAction[NotifyCollectionChangedAction["Reset"] = 4] = "Reset";
    return NotifyCollectionChangedAction;
})({});
/**
 * @hidden
 */
let NotifyCollectionChangedAction_$type = /*@__PURE__*/ markEnum('NotifyCollectionChangedAction', 'Add,0|Remove,1|Replace,2|Reset,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let NameValueCollection = /*@__PURE__*/ (() => {
    class NameValueCollection extends Base {
        constructor() {
            super();
            this.a = null;
            this.a = new Dictionary$2(String_$type, String_$type, 0);
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (this.a.containsKey(a)) {
                    this.a.item(a, b);
                }
                else {
                    this.a.addItem(a, b);
                }
                return b;
            }
            else {
                if (this.a.containsKey(a)) {
                    return this.a.item(a);
                }
                else {
                    return null;
                }
            }
        }
    }
    NameValueCollection.$t = /*@__PURE__*/ markType(NameValueCollection, 'NameValueCollection');
    return NameValueCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IndexOutOfRangeException = /*@__PURE__*/ (() => {
    class IndexOutOfRangeException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
            }
        }
    }
    IndexOutOfRangeException.$t = /*@__PURE__*/ markType(IndexOutOfRangeException, 'IndexOutOfRangeException', BaseError.$);
    return IndexOutOfRangeException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BitArray = /*@__PURE__*/ (() => {
    class BitArray extends Base {
        constructor(a, ..._rest) {
            super();
            this.i = 0;
            this.a = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c.a];
                        {
                            let f = d[0];
                            this.i = f.length * 32;
                            this.a = new Array(f.length);
                            for (let g = 0; g < f.length; g++) {
                                this.a[g] = f[g];
                            }
                        }
                        this.i = c.i;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.j = c.length;
                        for (let d = 0; d < c.length; d++) {
                            this.item(d, c[d]);
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [c, false];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.i = f;
                            this.a = new Array((intDivide((f - 1), 32)) + 1);
                            this.m(g);
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        this.i = c.length * 32;
                        this.a = new Array(c.length);
                        for (let d = 0; d < c.length; d++) {
                            this.a[d] = c[d];
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.i = c;
                        this.a = new Array((intDivide((c - 1), 32)) + 1);
                        this.m(d);
                    }
                    break;
            }
        }
        get count() {
            return this.i;
        }
        get c() {
            return false;
        }
        get isSynchronized() {
            return false;
        }
        get j() {
            return this.i;
        }
        set j(a) {
            if (a < 0) {
                throw new ArgumentOutOfRangeException(0);
            }
            this.i = a;
            let b = (intDivide((this.i - 1), 32)) + 1;
            if (this.a.length < b) {
                let c = this.a;
                this.a = new Array(b);
                for (let d = 0; d < c.length; d++) {
                    this.a[d] = c[d];
                }
            }
        }
        get syncRoot() {
            return null;
        }
        item(a, b) {
            if (arguments.length === 2) {
                if (a < 0 || this.i <= a) {
                    throw new IndexOutOfRangeException(0);
                }
                if (b) {
                    this.a[intDivide(a, 32)] |= 1 << (a % 32);
                }
                else {
                    this.a[intDivide(a, 32)] &= ~(1 << (a % 32));
                }
                return b;
            }
            else {
                if (a < 0 || this.i <= a) {
                    throw new IndexOutOfRangeException(0);
                }
                return (this.a[intDivide(a, 32)] & (1 << (a % 32))) != 0;
            }
        }
        e(a) {
            if (a.j != this.j) {
                throw new ArgumentException(1, "The BitArrays do not have the same length");
            }
            for (let b = 0; b < this.a.length; b++) {
                this.a[b] &= a.a[b];
            }
            return this;
        }
        k() {
            return new BitArray(0, this);
        }
        copyTo(a, b) {
            for (let c = 0; c < this.i; c++) {
                a[b + c] = this.item(c);
            }
        }
        b(a) {
            return this.item(a);
        }
        *_getEnumeratorObject() {
            for (let a = 0; a < this.i; a++) {
                yield this.item(a);
            }
        }
        getEnumeratorObject() {
            return toEnum(() => this._getEnumeratorObject()).getEnumeratorObject();
        }
        f() {
            for (let a = 0; a < this.a.length; a++) {
                this.a[a] = ~this.a[a];
            }
            return this;
        }
        g(a) {
            if (a.j != this.j) {
                throw new ArgumentException(1, "The BitArrays do not have the same length");
            }
            for (let b = 0; b < this.a.length; b++) {
                this.a[b] |= a.a[b];
            }
            return this;
        }
        l(a, b) {
            this.item(a, b);
        }
        m(a) {
            let b = a ? -1 : 0;
            for (let c = 0; c < this.a.length; c++) {
                this.a[c] = b;
            }
        }
        h(a) {
            if (a.j != this.j) {
                throw new ArgumentException(1, "The BitArrays do not have the same length");
            }
            for (let b = 0; b < this.a.length; b++) {
                this.a[b] ^= a.a[b];
            }
            return this;
        }
    }
    BitArray.$t = /*@__PURE__*/ markType(BitArray, 'BitArray', Base.$, [ICollection_$type, IEnumerable_$type]);
    return BitArray;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ReadOnlyObservableCollection$1 = /*@__PURE__*/ (() => {
    class ReadOnlyObservableCollection$1 extends ReadOnlyCollection$1 {
        constructor($t, a) {
            super($t, 0);
            this.$t = null;
            this.collectionChanged = null;
            this.propertyChanged = null;
            this.$t = $t;
            this.$type = this.$type.specialize(this.$t);
        }
    }
    ReadOnlyObservableCollection$1.$t = /*@__PURE__*/ markType(ReadOnlyObservableCollection$1, 'ReadOnlyObservableCollection$1', /*@__PURE__*/ ReadOnlyCollection$1.$.specialize(0), [INotifyCollectionChanged_$type, INotifyPropertyChanged_$type]);
    return ReadOnlyObservableCollection$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOrderedEnumerable$1_$type = /*@__PURE__*/ new Type(null, 'IOrderedEnumerable$1', null, [/*@__PURE__*/ IEnumerable$1_$type.specialize(0), IEnumerable_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SortedList$1 = /*@__PURE__*/ (() => {
    class SortedList$1 extends List$1 {
        constructor($tElement, a) {
            super($tElement, 1, a);
            this.$tElement = null;
            this.$tElement = $tElement;
            this.$type = this.$type.specialize(this.$tElement);
        }
        getEnumeratorObject() {
            return super.getEnumerator();
        }
    }
    SortedList$1.$t = /*@__PURE__*/ markType(SortedList$1, 'SortedList$1', /*@__PURE__*/ List$1.$.specialize(0), [/*@__PURE__*/ IOrderedEnumerable$1_$type.specialize(0)]);
    return SortedList$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Enumerable = /*@__PURE__*/ (() => {
    class Enumerable extends Base {
        static *_u($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    yield c;
                }
            }
        }
        static u($tSource, a, b) {
            return toEnum(() => Enumerable._u($tSource, a, b));
        }
        static *_v($tSource, a, b) {
            let c = 0;
            for (let d of fromEnum(a)) {
                if (b(d, c)) {
                    yield d;
                }
                c++;
            }
        }
        static v($tSource, a, b) {
            return toEnum(() => Enumerable._v($tSource, a, b));
        }
        static *_o($tSource, $tResult, a, b) {
            for (let c of fromEnum(a)) {
                yield b(c);
            }
        }
        static o($tSource, $tResult, a, b) {
            return toEnum(() => Enumerable._o($tSource, $tResult, a, b));
        }
        static *_p($tSource, $tResult, a, b) {
            for (let c of fromEnum(a)) {
                for (let d of fromEnum(b(c))) {
                    yield d;
                }
            }
        }
        static p($tSource, $tResult, a, b) {
            return toEnum(() => Enumerable._p($tSource, $tResult, a, b));
        }
        static *_l($tResult, a) {
            for (let b of fromEn(a)) {
                if (typeCast($tResult, b) !== null) {
                    yield typeCastObjTo$t($tResult, b);
                }
            }
        }
        static l($tResult, a) {
            return toEnum(() => Enumerable._l($tResult, a));
        }
        static ah($tSource, a) {
            let b = typeCast(IList$1_$type.specialize($tSource), a);
            if (b != null) {
                return b.item(b.count - 1);
            }
            let c = Type.getDefaultValue($tSource);
            for (let d of fromEnum(a)) {
                c = d;
            }
            return c;
        }
        static ad($tSource, a) {
            for (let b of fromEnum(a)) {
                return b;
            }
            return Type.getDefaultValue($tSource);
        }
        static ae($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    return c;
                }
            }
            return Type.getDefaultValue($tSource);
        }
        static af($tSource, a) {
            for (let b of fromEnum(a)) {
                return b;
            }
            return Type.getDefaultValue($tSource);
        }
        static x($tSource, $tKey, a, b) {
            let c = new SortedList$1($tSource, a);
            c.aa((d, e) => {
                let f = d;
                let g = e;
                let h = b(f);
                let i = b(g);
                if (typeCast(IComparable_$type, h) !== null) {
                    return CompareUtil.compareToObject((typeCast(IComparable_$type, h)), getBoxIfEnum($tKey, i));
                }
                else {
                    return stringCompareTo(stringToString$1($tKey, h), stringToString$1($tKey, i));
                }
            });
            return c;
        }
        static y($tSource, $tKey, a, b) {
            let c = new SortedList$1($tSource, a);
            c.aa((d, e) => {
                let f = e;
                let g = d;
                let h = b(f);
                let i = b(g);
                if (typeCast(IComparable_$type, h) !== null) {
                    return CompareUtil.compareToObject((typeCast(IComparable_$type, h)), getBoxIfEnum($tKey, i));
                }
                else {
                    return stringCompareTo(stringToString$1($tKey, h), stringToString$1($tKey, i));
                }
            });
            return c;
        }
        static z($tSource, a) {
            let b = new List$1($tSource, 1, a);
            return b;
        }
        static *_m(a, b) {
            for (let c = a; c < b; c++) {
                yield c;
            }
        }
        static m(a, b) {
            return toEnum(() => Enumerable._m(a, b));
        }
        static *_i($tSource, a, b) {
            for (let c of fromEnum(a)) {
                yield c;
            }
            for (let d of fromEnum(b)) {
                yield d;
            }
        }
        static i($tSource, a, b) {
            return toEnum(() => Enumerable._i($tSource, a, b));
        }
        static ak(a) {
            let b = true;
            let c = 0;
            for (let d of fromEnum(a)) {
                if (b) {
                    b = false;
                    c = d;
                }
                else {
                    c = Math.max(c, d);
                }
            }
            return c;
        }
        static al($tSource, a, b) {
            return Enumerable.ak(Enumerable.o($tSource, Number_$type, a, b));
        }
        static am(a) {
            let b = true;
            let c = 0;
            for (let d of fromEnum(a)) {
                if (b) {
                    b = false;
                    c = d;
                }
                else {
                    c = Math.min(c, d);
                }
            }
            return c;
        }
        static an($tSource, a, b) {
            return Enumerable.ak(Enumerable.o($tSource, Number_$type, a, b));
        }
        static aj($tSource, a) {
            let b = 0;
            for (let c of fromEnum(a)) {
                b++;
            }
            return b;
        }
        static *_n($tSource, a) {
            let b = new List$1($tSource, 1, a);
            for (let c = b.count - 1; c >= 0; c--) {
                yield b._inner[c];
            }
        }
        static n($tSource, a) {
            return toEnum(() => Enumerable._n($tSource, a));
        }
        static h($tResult, a) {
            if (a == null) {
                throw new ArgumentNullException(0, "source");
            }
            let b = typeCast(IEnumerable$1_$type.specialize($tResult), a);
            if (b != null) {
                return b;
            }
            let c = new List$1($tResult, 0);
            for (let d of fromEn(a)) {
                if (typeCast($tResult, d) !== null) {
                    c.add(typeCastObjTo$t($tResult, d));
                }
                else {
                    c.add(Type.getDefaultValue($tResult));
                }
            }
            return c;
        }
        static *_s($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b > 0) {
                    b--;
                    yield c;
                }
                else {
                    return undefined;
                }
            }
        }
        static s($tSource, a, b) {
            return toEnum(() => Enumerable._s($tSource, a, b));
        }
        static *_r($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b <= 0) {
                    yield c;
                }
                else {
                    b--;
                }
            }
        }
        static r($tSource, a, b) {
            return toEnum(() => Enumerable._r($tSource, a, b));
        }
        static c($tSource, a) {
            for (let b of fromEnum(a)) {
                return true;
            }
            return false;
        }
        static e($tSource, a, value_) {
            for (let item_ of fromEnum(a)) {
                if (item_ === value_) {
                    return true;
                }
                ;
            }
            return false;
        }
        static t($tSource, a, b) {
            return null;
        }
        static a($tSource, a) {
            let b = typeCast(List$1.$.specialize($tSource), a);
            if (b != null) {
                return b.toArray();
            }
            b = new List$1($tSource, 1, a);
            return b.asArray();
        }
        static ac($tSource, a, b) {
            let c = typeCast(IList$1_$type.specialize($tSource), a);
            if (c != null) {
                return c.item(b);
            }
            return Enumerable.ad($tSource, Enumerable.r($tSource, a, b));
        }
        static aa(a) {
            let b = 0;
            for (let c of fromEnum(a)) {
                b += c;
            }
            return b;
        }
        static ab($tSource, a, b) {
            return Enumerable.aa(Enumerable.o($tSource, Number_$type, a, b));
        }
        static f($tSource, a, b) {
            if (a == null) {
                throw new ArgumentNullException(0, "first");
            }
            if (b == null) {
                throw new ArgumentNullException(0, "second");
            }
            let c = getEnumerator(a);
            let d = getEnumerator(b);
            {
                while (c.moveNext()) {
                    if (!d.moveNext() || !Base.equalsStatic(getBoxIfEnum($tSource, c.current), getBoxIfEnum($tSource, d.current))) {
                        return false;
                    }
                }
                return (d.moveNext() == false);
            }
        }
        static *_k($tSource) {
            return undefined;
        }
        static k($tSource) {
            return toEnum(() => Enumerable._k($tSource));
        }
        static *_q($tSource, $tCollection, $tResult, a, b, c) {
            for (let d of fromEnum(a)) {
                for (let e of fromEnum(b(d))) {
                    yield c(d, e);
                }
            }
        }
        static q($tSource, $tCollection, $tResult, a, b, c) {
            return toEnum(() => Enumerable._q($tSource, $tCollection, $tResult, a, b, c));
        }
        static d($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    return true;
                }
            }
            return false;
        }
        static ag($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c)) {
                    return c;
                }
            }
            return Type.getDefaultValue($tSource);
        }
        static b($tSource, a, b) {
            for (let c of fromEnum(a)) {
                if (b(c) == false) {
                    return false;
                }
            }
            return true;
        }
        static g($tSource, $tKey, a, b) {
            let c = new Dictionary$2($tKey, $tSource, 0);
            for (let d of fromEnum(a)) {
                c.item(b(d), d);
            }
            return c;
        }
        static ai($tSource, a) {
            throw new NotImplementedException(0);
        }
        static w($tFirst, $tSecond, $tResult, a, b, c) {
            throw new NotImplementedException(0);
        }
        static j($tSource, a) {
            throw new NotImplementedException(0);
        }
    }
    Enumerable.$t = /*@__PURE__*/ markType(Enumerable, 'Enumerable');
    return Enumerable;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IGrouping$2_$type = /*@__PURE__*/ new Type(null, 'IGrouping$2', null, [/*@__PURE__*/ IEnumerable$1_$type.specialize(1), IEnumerable_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpressionSyntax = /*@__PURE__*/ (() => {
    class ExpressionSyntax extends Base {
        static c(a, b, c, ...d) {
            return null;
        }
        static a(a, ...b) {
            return null;
        }
        static b(a, b) {
            return null;
        }
        static d(a) {
            return null;
        }
        static e(a, b) {
            return null;
        }
    }
    ExpressionSyntax.$t = /*@__PURE__*/ markType(ExpressionSyntax, 'ExpressionSyntax');
    return ExpressionSyntax;
})();
/**
 * @hidden
 */
let LambdaExpression = /*@__PURE__*/ (() => {
    class LambdaExpression extends ExpressionSyntax {
    }
    LambdaExpression.$t = /*@__PURE__*/ markType(LambdaExpression, 'LambdaExpression', ExpressionSyntax.$);
    return LambdaExpression;
})();
/**
 * @hidden
 */
let MemberExpression = /*@__PURE__*/ (() => {
    class MemberExpression extends ExpressionSyntax {
        constructor() {
            super(...arguments);
            this.f = null;
        }
        g(a) {
            return null;
        }
    }
    MemberExpression.$t = /*@__PURE__*/ markType(MemberExpression, 'MemberExpression', ExpressionSyntax.$);
    return MemberExpression;
})();
/**
 * @hidden
 */
let MethodCallExpression = /*@__PURE__*/ (() => {
    class MethodCallExpression extends ExpressionSyntax {
        constructor() {
            super(...arguments);
            this.f = null;
            this.g = null;
        }
        h(a, b) {
            return null;
        }
    }
    MethodCallExpression.$t = /*@__PURE__*/ markType(MethodCallExpression, 'MethodCallExpression', ExpressionSyntax.$);
    return MethodCallExpression;
})();
/**
 * @hidden
 */
let ParameterExpression = /*@__PURE__*/ (() => {
    class ParameterExpression extends ExpressionSyntax {
        constructor() {
            super(...arguments);
            this.f = false;
            this.g = null;
        }
    }
    ParameterExpression.$t = /*@__PURE__*/ markType(ParameterExpression, 'ParameterExpression', ExpressionSyntax.$);
    return ParameterExpression;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IQueryable_$type = /*@__PURE__*/ new Type(null, 'IQueryable');
/**
 * @hidden
 */
let IQueryable$1_$type = /*@__PURE__*/ new Type(null, 'IQueryable$1', null, [IQueryable_$type]);
/**
 * @hidden
 */
let IQueryProvider_$type = /*@__PURE__*/ new Type(null, 'IQueryProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Queryable = /*@__PURE__*/ (() => {
    class Queryable extends Base {
        static a(a) {
            return null;
        }
    }
    Queryable.$t = /*@__PURE__*/ markType(Queryable, 'Queryable');
    return Queryable;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GC = /*@__PURE__*/ (() => {
    class GC extends Base {
    }
    GC.$t = /*@__PURE__*/ markType(GC, 'GC');
    return GC;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Activator = /*@__PURE__*/ (() => {
    class Activator extends Base {
        static createInstance(a) {
            return null;
        }
        static c(a, ...b) {
            return null;
        }
        static createInstance$1($t) {
            return Type.getDefaultValue($t);
        }
    }
    Activator.$t = /*@__PURE__*/ markType(Activator, 'Activator');
    return Activator;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFormattable_$type = /*@__PURE__*/ new Type(null, 'IFormattable');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid = /*@__PURE__*/ (() => {
    class Guid extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.ae = 0;
            this.ac = 0;
            this.ad = 0;
            this.r = 0;
            this.s = 0;
            this.t = 0;
            this.u = 0;
            this.v = 0;
            this.w = 0;
            this.x = 0;
            this.y = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.ae = (((c[3] << 24) | (c[2] << 16)) | (c[1] << 8)) | c[0];
                        this.ac = ((c[5] << 8) | c[4]);
                        this.ad = ((c[7] << 8) | c[6]);
                        this.r = c[8];
                        this.s = c[9];
                        this.t = c[10];
                        this.u = c[11];
                        this.v = c[12];
                        this.w = c[13];
                        this.x = c[14];
                        this.y = c[15];
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        let j = _rest[7];
                        let k = _rest[8];
                        let l = _rest[9];
                        let m = _rest[10];
                        this.ae = c;
                        this.ac = d;
                        this.ad = e;
                        this.r = f;
                        this.s = g;
                        this.t = h;
                        this.u = i;
                        this.v = j;
                        this.w = k;
                        this.x = l;
                        this.y = m;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        if (c == null) {
                            throw new ArgumentNullException(0, "g");
                        }
                        let d = new Guid_GuidResult();
                        d.i(1);
                        if (!((() => { let e = Guid.n(c, 15, d); d = e.p2; return e.ret; })())) {
                            throw d.a();
                        }
                        this.ae = d.c.ae;
                        this.ac = d.c.ac;
                        this.ad = d.c.ad;
                        this.r = d.c.r;
                        this.s = d.c.s;
                        this.t = d.c.t;
                        this.u = d.c.u;
                        this.v = d.c.v;
                        this.w = d.c.w;
                        this.x = d.c.x;
                        this.y = d.c.y;
                    }
                    break;
            }
        }
        compareTo(a) {
            let b = this.ae - a.ae;
            if (b != 0) {
                return b;
            }
            b = this.ac - a.ac;
            if (b != 0) {
                return b;
            }
            b = this.ad - a.ad;
            if (b != 0) {
                return b;
            }
            b = this.r - a.r;
            if (b != 0) {
                return b;
            }
            b = this.s - a.s;
            if (b != 0) {
                return b;
            }
            b = this.t - a.t;
            if (b != 0) {
                return b;
            }
            b = this.u - a.u;
            if (b != 0) {
                return b;
            }
            b = this.v - a.v;
            if (b != 0) {
                return b;
            }
            b = this.w - a.w;
            if (b != 0) {
                return b;
            }
            b = this.x - a.x;
            if (b != 0) {
                return b;
            }
            b = this.y - a.y;
            return b;
        }
        compareToObject(a) {
            if (typeCast(Guid.$, a) !== null) {
                return this.compareTo(a);
            }
            return 1;
        }
        equals(a) {
            return Guid.l_op_Equality(this, a);
        }
        static newGuid() {
            return new Guid(3, (createGuid()));
        }
        toByteArray() {
            return [this.ae, (this.ae >> 8), (this.ae >> 16), (this.ae >> 24), this.ac, (this.ac >> 8), this.ad, (this.ad >> 8), this.r, this.s, this.t, this.u, this.v, this.w, this.x, this.y];
        }
        toString() {
            return this.toString1("D", null);
        }
        toString2(a) {
            return this.toString1(a, null);
        }
        toString1(a, b) {
            let c;
            if ((a == null) || (a.length == 0)) {
                a = "D";
            }
            let d = 0;
            let e = 38;
            let f = true;
            let g = false;
            if (a.length != 1) {
                throw new FormatException(0);
            }
            let h = a.charAt(0);
            switch (h) {
                case 'D':
                case 'd':
                    c = new Array(36);
                    e = 36;
                    break;
                case 'N':
                case 'n':
                    c = new Array(32);
                    e = 32;
                    f = false;
                    break;
                case 'B':
                case 'b':
                    c = new Array(38);
                    c[d++] = '{';
                    c[37] = '}';
                    break;
                case 'P':
                case 'p':
                    c = new Array(38);
                    c[d++] = '(';
                    c[37] = ')';
                    break;
                default:
                    if ((h != 'X') && (h != 'x')) {
                        throw new FormatException(0);
                    }
                    c = new Array(68);
                    c[d++] = '{';
                    c[67] = '}';
                    e = 68;
                    f = false;
                    g = true;
                    break;
            }
            if (g) {
                c[d++] = '0';
                c[d++] = 'x';
                d = Guid.af(c, d, this.ae >> 24, this.ae >> 16);
                d = Guid.af(c, d, this.ae >> 8, this.ae);
                c[d++] = ',';
                c[d++] = '0';
                c[d++] = 'x';
                d = Guid.af(c, d, this.ac >> 8, this.ac);
                c[d++] = ',';
                c[d++] = '0';
                c[d++] = 'x';
                d = Guid.af(c, d, this.ad >> 8, this.ad);
                c[d++] = ',';
                c[d++] = '{';
                d = Guid.ag(c, d, this.r, this.s, true);
                c[d++] = ',';
                d = Guid.ag(c, d, this.t, this.u, true);
                c[d++] = ',';
                d = Guid.ag(c, d, this.v, this.w, true);
                c[d++] = ',';
                d = Guid.ag(c, d, this.x, this.y, true);
                c[d++] = '}';
            }
            else {
                d = Guid.af(c, d, this.ae >> 24, this.ae >> 16);
                d = Guid.af(c, d, this.ae >> 8, this.ae);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.ac >> 8, this.ac);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.ad >> 8, this.ad);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.r, this.s);
                if (f) {
                    c[d++] = '-';
                }
                d = Guid.af(c, d, this.t, this.u);
                d = Guid.af(c, d, this.v, this.w);
                d = Guid.af(c, d, this.x, this.y);
            }
            return stringCreateFromCharArraySlice(c, 0, e);
        }
        static af(a, b, c, d) {
            return Guid.ag(a, b, c, d, false);
        }
        static ag(a, b, c, d, e) {
            if (e) {
                a[b++] = '0';
                a[b++] = 'x';
            }
            a[b++] = Guid.z(c >> 4);
            a[b++] = Guid.z(c);
            if (e) {
                a[b++] = ',';
                a[b++] = '0';
                a[b++] = 'x';
            }
            a[b++] = Guid.z(d >> 4);
            a[b++] = Guid.z(d);
            return b;
        }
        static z(a) {
            a &= 15;
            return ((a > 9) ? String.fromCharCode(((a - 10) + 97)) : String.fromCharCode((a + 48)));
        }
        static tryParse(a, b) {
            let c = new Guid_GuidResult();
            c.i(0);
            if (((() => { let d = Guid.n(a, 15, c); c = d.p2; return d.ret; })())) {
                b = c.c;
                return {
                    ret: true,
                    p1: b
                };
            }
            b = Guid.empty;
            return {
                ret: false,
                p1: b
            };
        }
        static n(a, b, c) {
            if (a == null) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            let d = a.trim();
            if (d.length == 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            let e = d.indexOf('-', 0) >= 0;
            if (e) {
                if ((b & (64 | 4)) == 0) {
                    c.k(2, "Format_GuidUnrecognized");
                    return {
                        ret: false,
                        p2: c
                    };
                }
            }
            else if ((b & 64) != 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            let f = d.indexOf('{', 0) >= 0;
            if (f) {
                if ((b & (32 | 2)) == 0) {
                    c.k(2, "Format_GuidUnrecognized");
                    return {
                        ret: false,
                        p2: c
                    };
                }
            }
            else if ((b & 32) != 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            if (d.indexOf('(', 0) >= 0) {
                if ((b & (16 | 1)) == 0) {
                    c.k(2, "Format_GuidUnrecognized");
                    return {
                        ret: false,
                        p2: c
                    };
                }
            }
            else if ((b & 16) != 0) {
                c.k(2, "Format_GuidUnrecognized");
                return {
                    ret: false,
                    p2: c
                };
            }
            try {
                if (e) {
                    return {
                        ret: ((() => { let g = Guid.o(d, c); c = g.p1; return g.ret; })()),
                        p2: c
                    };
                }
                if (f) {
                    return {
                        ret: ((() => { let g = Guid.p(d, c); c = g.p1; return g.ret; })()),
                        p2: c
                    };
                }
                return {
                    ret: ((() => { let g = Guid.q(d, c); c = g.p1; return g.ret; })()),
                    p2: c
                };
            }
            catch (g) {
                let h = typeCast(IndexOutOfRangeException.$, g);
                if (h != null) {
                    c.m(5, "Format_GuidUnrecognized", null, null, h);
                    return {
                        ret: false,
                        p2: c
                    };
                }
                let i = typeCast(ArgumentException.$, g);
                if (i != null) {
                    c.m(5, "Format_GuidUnrecognized", null, null, i);
                    return {
                        ret: false,
                        p2: c
                    };
                }
                throw g;
            }
        }
        static o(a, b) {
            let c;
            let d;
            let e;
            let f = 0;
            let g = 0;
            if (a.charAt(0) == '{') {
                if ((a.length != 38) || (a.charAt(37) != '}')) {
                    b.k(2, "Format_GuidInvLen");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                f = 1;
            }
            else if (a.charAt(0) == '(') {
                if ((a.length != 38) || (a.charAt(37) != ')')) {
                    b.k(2, "Format_GuidInvLen");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                f = 1;
            }
            else if (a.length != 36) {
                b.k(2, "Format_GuidInvLen");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (((a.charAt(8 + f) != '-') || (a.charAt(13 + f) != '-')) || ((a.charAt(18 + f) != '-') || (a.charAt(23 + f) != '-'))) {
                b.k(2, "Format_GuidDashes");
                return {
                    ret: false,
                    p1: b
                };
            }
            g = f;
            if (!((() => { let h = Guid.j(a, g, 8, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.ae = c;
            g++;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.ac = c;
            g++;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.ad = c;
            g++;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, c, b); g = h.p1; c = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            g++;
            f = g;
            if (!((() => { let h = Guid.j(a, g, 4, 8192, d, b); g = h.p1; d = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let h = Guid.j(a, g, 8, 8192, e, b); g = h.p1; e = h.p4; b = h.p5; return h.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.r = ((c >> 8) & 255);
            b.c.s = (c & 255);
            c = d;
            b.c.t = ((c >> 8) & 255);
            b.c.u = (c & 255);
            c = e;
            b.c.v = ((c >> 24) & 255);
            b.c.w = ((c >> 16) & 255);
            b.c.x = ((c >> 8) & 255);
            b.c.y = (c & 255);
            return {
                ret: true,
                p1: b
            };
        }
        static ah(a) {
            let b = 0;
            let c = new Array(a.length);
            for (let d = 0; d < a.length; d++) {
                let e = a.charAt(d);
                if (!/\s/i.test(e)) {
                    c[b++] = e;
                }
            }
            return stringCreateFromCharArraySlice(c, 0, b);
        }
        static p(a, b) {
            let c = 0;
            let d = 0;
            a = Guid.ah(a);
            if (stringIsNullOrEmpty(a) || (a.charAt(0) != '{')) {
                b.k(2, "Format_GuidBrace");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!Guid.b(a, 1)) {
                b.l(2, "Format_GuidHexPrefix", "{0xdddddddd, etc}");
                return {
                    ret: false,
                    p1: b
                };
            }
            c = 3;
            d = a.indexOf(',', c) - c;
            if (d <= 0) {
                b.k(2, "Format_GuidComma");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let e = Guid.i(a.substr(c, d), -1, 4096, b.c.ae, b); b.c.ae = e.p3; b = e.p4; return e.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!Guid.b(a, (c + d) + 1)) {
                b.l(2, "Format_GuidHexPrefix", "{0xdddddddd, 0xdddd, etc}");
                return {
                    ret: false,
                    p1: b
                };
            }
            c = (c + d) + 3;
            d = a.indexOf(',', c) - c;
            if (d <= 0) {
                b.k(2, "Format_GuidComma");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let e = Guid.k(a.substr(c, d), -1, 4096, b.c.ac, b); b.c.ac = e.p3; b = e.p4; return e.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!Guid.b(a, (c + d) + 1)) {
                b.l(2, "Format_GuidHexPrefix", "{0xdddddddd, 0xdddd, 0xdddd, etc}");
                return {
                    ret: false,
                    p1: b
                };
            }
            c = (c + d) + 3;
            d = a.indexOf(',', c) - c;
            if (d <= 0) {
                b.k(2, "Format_GuidComma");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (!((() => { let e = Guid.k(a.substr(c, d), -1, 4096, b.c.ad, b); b.c.ad = e.p3; b = e.p4; return e.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            if ((a.length <= ((c + d) + 1)) || (a.charAt((c + d) + 1) != '{')) {
                b.k(2, "Format_GuidBrace");
                return {
                    ret: false,
                    p1: b
                };
            }
            d++;
            let e = new Array(8);
            for (let f = 0; f < 8; f++) {
                if (!Guid.b(a, (c + d) + 1)) {
                    b.l(2, "Format_GuidHexPrefix", "{... { ... 0xdd, ...}}");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                c = (c + d) + 3;
                if (f < 7) {
                    d = a.indexOf(',', c) - c;
                    if (d <= 0) {
                        b.k(2, "Format_GuidComma");
                        return {
                            ret: false,
                            p1: b
                        };
                    }
                }
                else {
                    d = a.indexOf('}', c) - c;
                    if (d <= 0) {
                        b.k(2, "Format_GuidBraceAfterLastNumber");
                        return {
                            ret: false,
                            p1: b
                        };
                    }
                }
                let g = intSToU(parseInt32_2(a.substr(c, d), 515));
                if (g > 255) {
                    b.k(2, "Overflow_Byte");
                    return {
                        ret: false,
                        p1: b
                    };
                }
                e[f] = g;
            }
            b.c.r = e[0];
            b.c.s = e[1];
            b.c.t = e[2];
            b.c.u = e[3];
            b.c.v = e[4];
            b.c.w = e[5];
            b.c.x = e[6];
            b.c.y = e[7];
            if ((((c + d) + 1) >= a.length) || (a.charAt((c + d) + 1) != '}')) {
                b.k(2, "Format_GuidEndBrace");
                return {
                    ret: false,
                    p1: b
                };
            }
            if (((c + d) + 1) != (a.length - 1)) {
                b.k(2, "Format_ExtraJunkAtEnd");
                return {
                    ret: false,
                    p1: b
                };
            }
            return {
                ret: true,
                p1: b
            };
        }
        static q(a, b) {
            let c;
            let d;
            let e;
            let f = 0;
            if (a.length != 32) {
                b.k(2, "Format_GuidInvLen");
                return {
                    ret: false,
                    p1: b
                };
            }
            for (let g = 0; g < a.length; g++) {
                let h = a.charAt(g);
                if ((h.charCodeAt(0) < '0'.charCodeAt(0)) || (h.charCodeAt(0) > '9'.charCodeAt(0))) {
                    let i = h.toUpperCase();
                    if ((i.charCodeAt(0) < 'A'.charCodeAt(0)) || (i.charCodeAt(0) > 'F'.charCodeAt(0))) {
                        b.k(2, "Format_GuidInvalidChar");
                        return {
                            ret: false,
                            p1: b
                        };
                    }
                }
            }
            if (!((() => { let j = Guid.i(a.substr(f, 8), -1, 4096, b.c.ae, b); b.c.ae = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 8;
            if (!((() => { let j = Guid.k(a.substr(f, 4), -1, 4096, b.c.ac, b); b.c.ac = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.k(a.substr(f, 4), -1, 4096, b.c.ad, b); b.c.ad = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.i(a.substr(f, 4), -1, 4096, c, b); c = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.i(a.substr(f, 4), -1, f, d, b); d = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            f += 4;
            if (!((() => { let j = Guid.i(a.substr(f, 8), -1, f, e, b); e = j.p3; b = j.p4; return j.ret; })())) {
                return {
                    ret: false,
                    p1: b
                };
            }
            b.c.r = ((c >> 8) & 255);
            b.c.s = (c & 255);
            c = d;
            b.c.t = ((c >> 8) & 255);
            b.c.u = (c & 255);
            c = e;
            b.c.v = ((c >> 24) & 255);
            b.c.w = ((c >> 16) & 255);
            b.c.x = ((c >> 8) & 255);
            b.c.y = (c & 255);
            return {
                ret: true,
                p1: b
            };
        }
        static k(a, b, c, d, e) {
            let f = 0;
            return {
                ret: ((() => { let g = Guid.l(a, f, b, c, d, e); f = g.p1; d = g.p4; e = g.p5; return g.ret; })()),
                p3: d,
                p4: e
            };
        }
        static l(a, b, c, d, e, f) {
            let g;
            e = 0;
            let h = ((() => { let i = Guid.j(a, b, c, d, g, f); b = i.p1; g = i.p4; f = i.p5; return i.ret; })());
            e = g;
            return {
                ret: h,
                p1: b,
                p4: e,
                p5: f
            };
        }
        static i(a, b, c, d, e) {
            let f = 0;
            return {
                ret: ((() => { let g = Guid.j(a, f, b, c, d, e); f = g.p1; d = g.p4; e = g.p5; return g.ret; })()),
                p3: d,
                p4: e
            };
        }
        static j(a, b, c, d, e, f) {
            e = 0;
            let g = b;
            try {
                if (c == -1) {
                    let h = a.length - b;
                    while (true) {
                        if (((() => { let i = tryParseInt32_2(a.substr(b, h), 515, CultureInfo.invariantCulture, e); e = i.p3; return i.ret; })())) {
                            break;
                        }
                        h--;
                    }
                    b += h;
                }
                else {
                    e = parseInt32_2(a.substr(b, c), 515);
                    b += c;
                }
            }
            catch (i) {
                if (f.d != 0) {
                    throw i;
                }
                f.j(i);
                return {
                    ret: false,
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            if (c != -1 && (b - g) != c) {
                f.k(2, "Format_GuidInvalidChar");
                return {
                    ret: false,
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            return {
                ret: true,
                p1: b,
                p4: e,
                p5: f
            };
        }
        static b(a, b) {
            return (((a.length > (b + 1)) && (a.charAt(b) == '0')) && (a.charAt(b + 1).toLowerCase() == 'x'));
        }
        static l_op_Inequality(a, b) {
            return !(Guid.l_op_Equality(a, b));
        }
        static l_op_Inequality_Lifted(a, b) {
            if (!a.hasValue) {
                return b.hasValue;
            }
            else if (!b.hasValue) {
                return true;
            }
            return Guid.l_op_Inequality(a.value, b.value);
        }
        static l_op_Equality(a, b) {
            return a.ae == b.ae && a.ac == b.ac && a.ad == b.ad && a.r == b.r && a.s == b.s && a.t == b.t && a.u == b.u && a.v == b.v && a.w == b.w && a.x == b.x && a.y == b.y;
        }
        static l_op_Equality_Lifted(a, b) {
            if (!a.hasValue) {
                return !b.hasValue;
            }
            else if (!b.hasValue) {
                return false;
            }
            return Guid.l_op_Equality(a.value, b.value);
        }
    }
    Guid.$t = /*@__PURE__*/ /*@__PURE__*/ markStruct(Guid, 'Guid', ValueType.$, [IFormattable_$type, IComparable_$type, /*@__PURE__*/ IComparable$1_$type.specialize(-1), /*@__PURE__*/ IEquatable$1_$type.specialize(-1)]).initSelfReferences();
    Guid.empty = /*@__PURE__*/ new Guid(0);
    return Guid;
})();
/**
 * @hidden
 */
let Guid_GuidResult = /*@__PURE__*/ (() => {
    class Guid_GuidResult extends ValueType {
        constructor() {
            super();
            this.c = new Guid();
            this.d = 0;
            this.e = 0;
            this.h = null;
            this.f = null;
            this.g = null;
            this.b = null;
        }
        i(a) {
            this.c = Guid.empty;
            this.d = a;
        }
        j(a) {
            this.e = 4;
            this.b = a;
        }
        k(a, b) {
            this.m(a, b, null, null, null);
        }
        l(a, b, c) {
            this.m(a, b, c, null, null);
        }
        m(a, b, c, d, e) {
            this.e = a;
            this.h = b;
            this.f = c;
            this.g = d;
            this.b = e;
            if (this.d != 0) {
                throw this.a();
            }
        }
        a() {
            switch (this.e) {
                case 1: return new ArgumentNullException(0, this.g);
                case 2: return new FormatException(0);
                case 3: return new FormatException(0);
                case 4: return this.b;
                case 5: return new FormatException(2, "The format of the Guid was incorrect.", this.b);
            }
            return new FormatException(0);
        }
    }
    Guid_GuidResult.$t = /*@__PURE__*/ markStruct(Guid_GuidResult, 'Guid_GuidResult');
    return Guid_GuidResult;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid_ParseFailureKind_$type = /*@__PURE__*/ markEnum('Guid_ParseFailureKind', 'None,0|ArgumentNull,1|Format,2|FormatWithParameter,3|NativeException,4|FormatWithInnerException,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid_GuidParseThrowStyle_$type = /*@__PURE__*/ markEnum('Guid_GuidParseThrowStyle', 'None,0|All,1|AllButOverflow,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Guid_GuidStyles_$type = /*@__PURE__*/ markEnum('Guid_GuidStyles', 'AllowBraces,2|AllowDashes,4|AllowHexPrefix,8|AllowParenthesis,1|Any,15|BraceFormat,96|DigitFormat,64|HexFormat,160|None,0|NumberFormat,0|ParenthesisFormat,80|RequireBraces,32|RequireDashes,64|RequireHexPrefix,128|RequireParenthesis,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StringComparer = /*@__PURE__*/ (() => {
    class StringComparer extends Base {
        constructor(a, ..._rest) {
            super();
            this.h = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.h = c;
                    }
                    break;
            }
        }
        compareObject(a, b) {
            return stringCompare1(typeCast(String_$type, a), typeCast(String_$type, b), this.h);
        }
        compare(a, b) {
            return stringCompare1(a, b, this.h);
        }
        static a(a, b) {
            if (a.name == CultureInfo.invariantCulture.name) {
                return b ? StringComparer.e : StringComparer.d;
            }
            return b ? StringComparer.c : StringComparer.b;
        }
        equalsC(a, b) {
            return this.compare(a, b) == 0;
        }
        getHashCodeC(a) {
            if (a == null) {
                return 0;
            }
            switch (this.h) {
                case 0:
                case 2:
                case 4: return Base.getHashCodeStatic(a);
                case 1: return Base.getHashCodeStatic(a.toLowerCase());
                case 3:
                case 5: return Base.getHashCodeStatic(a.toLowerCase());
                default: return 0;
            }
        }
    }
    StringComparer.$t = /*@__PURE__*/ markType(StringComparer, 'StringComparer', Base.$, [IComparer_$type, IEqualityComparer_$type, /*@__PURE__*/ IComparer$1_$type.specialize(String_$type), /*@__PURE__*/ IEqualityComparer$1_$type.specialize(String_$type)]);
    StringComparer.b = /*@__PURE__*/ new StringComparer(1, 0);
    StringComparer.c = /*@__PURE__*/ new StringComparer(1, 1);
    StringComparer.d = /*@__PURE__*/ new StringComparer(1, 2);
    StringComparer.e = /*@__PURE__*/ new StringComparer(1, 3);
    StringComparer.f = /*@__PURE__*/ new StringComparer(1, 4);
    StringComparer.g = /*@__PURE__*/ new StringComparer(1, 5);
    return StringComparer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tuple$3 = /*@__PURE__*/ (() => {
    class Tuple$3 extends Base {
        constructor($t1, $t2, $t3, a, b, c) {
            super();
            this.$t1 = null;
            this.$t2 = null;
            this.$t3 = null;
            this.c = null;
            this.d = null;
            this.e = null;
            this.$t1 = $t1;
            this.$t2 = $t2;
            this.$t3 = $t3;
            this.$type = this.$type.specialize(this.$t1, this.$t2, this.$t3);
            this.c = a;
            this.d = b;
            this.e = c;
        }
        equals(a) {
            let b = typeCast(Tuple$3.$.specialize(this.$t1, this.$t2, this.$t3), a);
            return b != null && Base.equalsStatic(getBoxIfEnum(this.$t1, this.c), getBoxIfEnum(this.$t1, b.c)) && Base.equalsStatic(getBoxIfEnum(this.$t2, this.d), getBoxIfEnum(this.$t2, b.d)) && Base.equalsStatic(getBoxIfEnum(this.$t3, this.e), getBoxIfEnum(this.$t3, b.e));
        }
        getHashCode() {
            let a = 0;
            if (getBoxIfEnum(this.$t1, this.c) != null) {
                a = Base.getHashCodeStatic(this.c);
            }
            if (getBoxIfEnum(this.$t2, this.d) != null) {
                a = a ^ Base.getHashCodeStatic(this.d) << 8;
            }
            if (getBoxIfEnum(this.$t3, this.e) != null) {
                a = a ^ Base.getHashCodeStatic(this.e) << 16;
            }
            return a;
        }
    }
    Tuple$3.$t = /*@__PURE__*/ markType(Tuple$3, 'Tuple$3');
    return Tuple$3;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Tuple = /*@__PURE__*/ (() => {
    class Tuple extends Base {
        static a($t1, $t2, a, b) {
            return new Tuple$2($t1, $t2, a, b);
        }
        static b($t1, $t2, $t3, a, b, c) {
            return new Tuple$3($t1, $t2, $t3, a, b, c);
        }
    }
    Tuple.$t = /*@__PURE__*/ markType(Tuple, 'Tuple');
    return Tuple;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var UriKind = /*@__PURE__*/ (function (UriKind) {
    UriKind[UriKind["RelativeOrAbsolute"] = 0] = "RelativeOrAbsolute";
    UriKind[UriKind["Absolute"] = 1] = "Absolute";
    UriKind[UriKind["Relative"] = 2] = "Relative";
    return UriKind;
})({});
/**
 * @hidden
 */
let UriKind_$type = /*@__PURE__*/ markEnum('UriKind', 'RelativeOrAbsolute,0|Absolute,1|Relative,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CancelEventArgs = /*@__PURE__*/ (() => {
    class CancelEventArgs extends EventArgs {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super();
                        this._cancel = false;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super();
                        this._cancel = false;
                    }
                    break;
            }
        }
        get cancel() {
            return this._cancel;
        }
        set cancel(a) {
            this._cancel = a;
        }
    }
    CancelEventArgs.$t = /*@__PURE__*/ markType(CancelEventArgs, 'CancelEventArgs', EventArgs.$);
    return CancelEventArgs;
})();

class IgrCancelEventArgs {
    createImplementation() {
        return new CancelEventArgs(0);
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get cancel() {
        return this.i.cancel;
    }
    set cancel(v) {
        this.i.cancel = ensureBool(v);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ListSortDirection = /*@__PURE__*/ (function (ListSortDirection) {
    ListSortDirection[ListSortDirection["Ascending"] = 0] = "Ascending";
    ListSortDirection[ListSortDirection["Descending"] = 1] = "Descending";
    return ListSortDirection;
})({});
/**
 * @hidden
 */
let ListSortDirection_$type = /*@__PURE__*/ markEnum('ListSortDirection', 'Ascending,0|Descending,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Debug = /*@__PURE__*/ (() => {
    class Debug extends Base {
        static b(a, b) {
        }
        static d(a) {
        }
        static a(a) {
        }
        static c(a) {
        }
    }
    Debug.$t = /*@__PURE__*/ markType(Debug, 'Debug');
    return Debug;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BitConverter = /*@__PURE__*/ (() => {
    class BitConverter extends Base {
        static r(a) {
            throw new NotImplementedException(0);
        }
        static a(a) {
            return [a ? 1 : 0];
        }
        static b(a) {
            throw new NotImplementedException(0);
        }
        static c(a) {
            let b = 0;
            let c = 0;
            if (a == Number.POSITIVE_INFINITY) {
                b = 2146435072;
            }
            else if (a == Number.NEGATIVE_INFINITY) {
                b = 4293918720;
            }
            else if (a == 0) {
                if (1 / a == 1 / 0) {
                    b = 0;
                }
                else {
                    b = 2147483648;
                }
            }
            else if (isNaN_(a)) {
                b = 4294443008;
            }
            else {
                if (a < -0) {
                    b = 2147483648;
                    a = -a;
                }
                let d = Math.floor(Math.log(a) / Math.log(2));
                let e = truncate(Math.floor((a / Math.pow(2, d)) * Math.pow(2, 52)));
                c = (u32BitwiseAnd(e, 4294967295));
                e = intDivide(e, truncate(Math.pow(2, 32)));
                d += 1023;
                if (d >= 2047) {
                    d = 2047;
                    e = 0;
                }
                else if (d < 0) {
                    d = 0;
                }
                b = u32BitwiseOr(b, u32LS(truncate(d), 20));
                b = u32BitwiseOr(b, u32BitwiseAnd(e, ~(-1 << 20)));
            }
            return [(c & 255), ((c >>> 8) & 255), ((c >>> 16) & 255), ((c >>> 24) & 255), (b & 255), ((b >>> 8) & 255), ((b >>> 16) & 255), ((b >>> 24) & 255)];
        }
        static g(a) {
            throw new NotImplementedException(0);
        }
        static e(a) {
            return BitConverter.i(intSToU(a));
        }
        static f(a) {
            return BitConverter.j(a);
        }
        static d(a) {
            return BitConverter.h(a);
        }
        static i(a) {
            return [(a & 255), ((a >>> 8) & 255), ((a >>> 16) & 255), ((a >>> 24) & 255)];
        }
        static j(a) {
            let b = (a | 0);
            let c = u32BitwiseOr(truncate((a / Math.pow(2, 32))), 0);
            return [(b & 255), ((b >>> 8) & 255), ((b >>> 16) & 255), ((b >>> 24) & 255), (c & 255), ((c >>> 8) & 255), ((c >>> 16) & 255), ((c >>> 24) & 255)];
        }
        static h(a) {
            return [(a & 255), ((a >>> 8) & 255)];
        }
        static n(a) {
            throw new NotImplementedException(0);
        }
        static l(a, b) {
            return a[b] != 0;
        }
        static m(a, b) {
            throw new NotImplementedException(0);
        }
        static o(a, b) {
            let c = (a[b + 7] & 1 << 7) >> 7;
            let d = (((a[b + 7] & 127) << 4) | (a[b + 6] & (15 << 4)) >> 4);
            if (d == 0) {
                return (c == 0) ? 0 : -0;
            }
            if (d == 2047) {
                if ((a[b + 6] & 8) != 0) {
                    return NaN;
                }
                return (c == 0) ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
            }
            let e = Math.pow(2, d - 1023 - 52);
            let f = a[b] + a[b + 1] * Math.pow(2, 8 * 1) + a[b + 2] * Math.pow(2, 8 * 2) + a[b + 3] * Math.pow(2, 8 * 3) + a[b + 4] * Math.pow(2, 8 * 4) + a[b + 5] * Math.pow(2, 8 * 5) + (a[b + 6] & 15) * Math.pow(2, 8 * 6) + Math.pow(2, 52);
            return Math.pow(-1, c) * f * e;
        }
        static p(a, b) {
            let c = BitConverter.w(a, b);
            if (c > 32767) {
                c -= (65535 + 1);
            }
            return c;
        }
        static q(a, b) {
            return a[b] | (a[b + 1] << 8) | (a[b + 2] << 16) | (a[b + 3] << 24);
        }
        static s(a, b) {
            throw new NotImplementedException(0);
        }
        static t(a) {
            throw new NotImplementedException(0);
        }
        static u(a, b) {
            throw new NotImplementedException(0);
        }
        static v(a, b, c) {
            throw new NotImplementedException(0);
        }
        static w(a, b) {
            return (a[b] | (a[b + 1] << 8));
        }
        static x(a, b) {
            return intSToU(BitConverter.q(a, b));
        }
    }
    BitConverter.$t = /*@__PURE__*/ markType(BitConverter, 'BitConverter');
    BitConverter.k = false;
    return BitConverter;
})();

//------------------------------------------------------------------------------
/**
 * @hidden
 */
let IOPath = /*@__PURE__*/ (() => {
    class IOPath extends Base {
        static getExtension(a) {
            let b = a.lastIndexOf('.');
            if (b < 0) {
                return stringEmpty();
            }
            return a.substr(b);
        }
        static getDirectoryName(a) {
            let b = lastIndexOfAny(a, ['\\', '/']);
            if (b < 0) {
                return stringEmpty();
            }
            return a.substr(0, b);
        }
        static getFileName(a) {
            let b = lastIndexOfAny(a, ['\\', '/']);
            if (b < 0) {
                return a;
            }
            return a.substr(b + 1);
        }
        static combine1(a, b) {
            if (a == null || a.length == 0) {
                return b;
            }
            if (b == null || b.length == 0) {
                return a;
            }
            if (a.charAt(a.length - 1) == '\\' || a.charAt(a.length - 1) == '/' || b.charAt(0) == '\\' || b.charAt(0) == '/') {
                return a + b;
            }
            return a + '\\' + b;
        }
        static isPathRooted(a) {
            if (a == null) {
                return false;
            }
            if (a.length >= 1 && (a.charAt(0) == '/' || a.charAt(0) == '\\')) {
                return true;
            }
            if (a.length >= 2 && a.charAt(1) == ':') {
                return true;
            }
            return false;
        }
        static changeExtension(a, b) {
            throw new NotImplementedException(0);
        }
        static combine(...a) {
            throw new NotImplementedException(0);
        }
        static combine2(a, b, c) {
            throw new NotImplementedException(0);
        }
        static getFileNameWithoutExtension(a) {
            throw new NotImplementedException(0);
        }
        static getFullPath(a) {
            throw new NotImplementedException(0);
        }
        static getInvalidPathChars() {
            throw new NotImplementedException(0);
        }
        static getPathRoot(a) {
            if (a == null) {
                return null;
            }
            return stringEmpty();
        }
        static getTempFileName() {
            throw new NotImplementedException(0);
        }
        static getTempPath() {
            throw new NotImplementedException(0);
        }
        static hasExtension(a) {
            throw new NotImplementedException(0);
        }
    }
    IOPath.$t = /*@__PURE__*/ markType(IOPath, 'IOPath');
    IOPath.altDirectorySeparatorChar = '/';
    IOPath.directorySeparatorChar = '\\';
    IOPath.pathSeparator = ';';
    IOPath.volumeSeparatorChar = ':';
    return IOPath;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let BinaryWriter = /*@__PURE__*/ (() => {
    class BinaryWriter extends Base {
        constructor(a, ..._rest) {
            super();
            this.b = null;
            this.d = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, new UTF8Encoding(0, false, true)];
                        {
                            let f = d[0];
                            let g = d[1];
                            this.b = f;
                            this.d = g;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.b = c;
                        this.d = d;
                    }
                    break;
            }
        }
        get_c() {
            return this.b;
        }
        get c() {
            return this.get_c();
        }
        e() {
            this.disposeCore(true);
        }
        dispose() {
            this.disposeCore(true);
        }
        disposeCore(a) {
            if (a) {
                this.b.close();
            }
        }
        g() {
            this.b.flush();
        }
        a(a, b) {
            return this.b.seek(a, b);
        }
        l(a) {
            this.b.write(BitConverter.a(a), 0, 1);
        }
        m(a) {
            this.b.write(BitConverter.d(a), 0, 1);
        }
        h(a) {
            this.b.write(a, 0, a.length);
        }
        n(a) {
        }
        i(a) {
        }
        o(a) {
            this.b.write(BitConverter.c(a), 0, 8);
        }
        t(a) {
            this.b.write(BitConverter.g(a), 0, 4);
        }
        q(a) {
            this.b.write(BitConverter.e(a), 0, 4);
        }
        r(a) {
            this.b.write(BitConverter.f(a), 0, 8);
        }
        s(a) {
            this.b.write(BitConverter.d(a), 0, 2);
        }
        p(a) {
            this.b.write(BitConverter.d(a), 0, 2);
        }
        u(a) {
        }
        w(a) {
            this.b.write(BitConverter.i(a), 0, 4);
        }
        x(a) {
            this.b.write(BitConverter.j(a), 0, 8);
        }
        v(a) {
            this.b.write(BitConverter.h(a), 0, 2);
        }
        j(a, b, c) {
        }
        k(a, b, c) {
        }
        y(a) {
        }
    }
    BinaryWriter.$t = /*@__PURE__*/ markType(BinaryWriter, 'BinaryWriter', Base.$, [IDisposable_$type]);
    return BinaryWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MemoryStream = /*@__PURE__*/ (() => {
    class MemoryStream extends Stream {
        constructor(a, ..._rest) {
            super();
            this.o = null;
            this.t = 0;
            this.s = 0;
            this.r = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [0];
                        {
                            let e = c[0];
                            this.o = new Array(e);
                            for (let f = 0; f < e; f++) {
                                this.o[f] = 0;
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.o = new Array(c);
                        for (let d = 0; d < c; d++) {
                            this.o[d] = 0;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        this.o = c;
                        this.s = c.length;
                        this.r = this.s != 0 && typeof this.o[0] === 'string';
                    }
                    break;
            }
        }
        get_canRead() {
            return true;
        }
        get canRead() {
            return this.get_canRead();
        }
        get_canSeek() {
            return true;
        }
        get canSeek() {
            return this.get_canSeek();
        }
        get_canWrite() {
            return true;
        }
        get canWrite() {
            return this.get_canWrite();
        }
        get_capacity() {
            return this.o.length;
        }
        set_capacity(a) {
            if (this.o.length == a) {
                return;
            }
            for (let b = this.s; b < a; b++) {
                this.o[b] = 0;
            }
        }
        get capacity() {
            return this.get_capacity();
        }
        set capacity(a) {
            this.set_capacity(a);
        }
        get_length() {
            return this.s;
        }
        get length() {
            return this.get_length();
        }
        get_position() {
            return this.t;
        }
        set_position(a) {
            if (this.t == a) {
                return;
            }
            this.t = a;
            if (this.capacity <= this.t) {
                this.capacity = this.t + 1;
            }
        }
        get position() {
            return this.get_position();
        }
        set position(a) {
            this.set_position(a);
        }
        disposeCore(a) {
        }
        flush() {
        }
        getBuffer() {
            return this.o;
        }
        read(a, b, c) {
            let d = Math.min(this.s - this.t, c);
            if (this.r) {
                for (let e = 0; e < d; e++) {
                    a[b++] = (this.o[this.t++].charCodeAt(0) & 0xFF);
                }
            }
            else {
                for (let f = 0; f < d; f++) {
                    a[b++] = this.o[this.t++];
                }
            }
            return d;
        }
        readByte() {
            if (this.s <= this.t) {
                return -1;
            }
            if (this.r) {
                return (this.o[this.t++].charCodeAt(0) & 0xFF);
            }
            return this.o[this.t++];
        }
        seek(a, b) {
            switch (b) {
                case 0:
                    this.t = a;
                    break;
                case 1:
                    this.t += a;
                    break;
                case 2:
                    this.t = this.s + a;
                    break;
            }
            return this.t;
        }
        setLength(a) {
            if (this.capacity < a) {
                this.capacity = Math.max(a, this.capacity * 2);
            }
            this.s = a;
            if (this.s < this.t) {
                this.t = this.s;
            }
        }
        toArray() {
            if (this.r) {
                let a = new Array(this.s);
                let b = this.position;
                this.position = 0;
                this.read(a, 0, a.length);
                this.position = b;
                return a;
            }
            return (this.o.slice(0, this.s));
        }
        write(a, b, c) {
            let d = this.t + c;
            if (this.length < d) {
                this.setLength(d);
            }
            let e = c != 0 && typeof a[b] === 'string';
            if (e == this.r) {
                for (let f = 0; f < c; f++) {
                    this.o[this.t++] = a[b++];
                }
            }
            else if (e) {
                for (let g = 0; g < c; g++) {
                    this.o[this.t++] = (a.charCodeAt(b++) & 0xFF);
                }
            }
            else {
                for (let h = 0; h < c; h++) {
                    this.o[this.t++] = typeGetValue((String.fromCharCode(a[b++])));
                }
            }
        }
        writeByte(a) {
            let b = typeof a === 'string';
            if (b == this.r) {
                this.o[this.t++] = a;
            }
            else if (b) {
                this.o[this.t++] = (a.charCodeAt(0) & 0xFF);
            }
            else {
                this.o[this.t++] = typeGetValue((String.fromCharCode(a)));
            }
            if (this.s < this.t) {
                this.s = this.t;
            }
        }
        writeTo(a) {
            a.write(this.o, 0, this.s);
        }
    }
    MemoryStream.$t = /*@__PURE__*/ markType(MemoryStream, 'MemoryStream', Stream.$);
    return MemoryStream;
})();

//
/**
 * @hidden
 */
let TextReader = /*@__PURE__*/ (() => {
    class TextReader extends Base {
        constructor() {
            super();
        }
        static staticInit() {
            TextReader.e = new TextReader_NullTextReader();
        }
        i() {
            this.dispose1(true);
        }
        dispose() {
            this.dispose1(true);
        }
        dispose1(a) {
            if (a) {
            }
            return;
        }
        a() {
            return -1;
        }
        b() {
            return -1;
        }
        c(a, b, c) {
            let d, e;
            for (e = 0; e < c; e++) {
                if ((d = this.b()) == -1) {
                    return e;
                }
                a[b + e] = String.fromCharCode(d);
            }
            return e;
        }
        d(a, b, c) {
            let d = 0;
            let e = 0;
            do {
                e = this.c(a, b, c);
                b += e;
                d += e;
                c -= e;
            } while (e != 0 && c > 0);
            return d;
        }
        g() {
            return stringEmpty();
        }
        h() {
            return stringEmpty();
        }
        static f(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "reader is null");
            }
            if (typeCast(SynchronizedReader.$, a) !== null) {
                return a;
            }
            return new SynchronizedReader(a);
        }
    }
    TextReader.$t = /*@__PURE__*/ markType(TextReader, 'TextReader', Base.$, [IDisposable_$type]);
    TextReader.e = null;
    return TextReader;
})();
/**
 * @hidden
 */
let TextReader_NullTextReader = /*@__PURE__*/ (() => {
    class TextReader_NullTextReader extends TextReader {
        g() {
            return null;
        }
    }
    TextReader_NullTextReader.$t = /*@__PURE__*/ markType(TextReader_NullTextReader, 'TextReader_NullTextReader', TextReader.$);
    return TextReader_NullTextReader;
})();
/**
 * @hidden
 */
let SynchronizedReader = /*@__PURE__*/ (() => {
    class SynchronizedReader extends TextReader {
        constructor(a) {
            super();
            this.k = null;
            this.k = a;
        }
        i() {
            this.k.i();
        }
        a() {
            return this.k.a();
        }
        d(a, b, c) {
            return this.k.d(a, b, c);
        }
        g() {
            return this.k.g();
        }
        h() {
            return this.k.h();
        }
        b() {
            return this.k.b();
        }
        c(a, b, c) {
            return this.k.c(a, b, c);
        }
    }
    SynchronizedReader.$t = /*@__PURE__*/ markType(SynchronizedReader, 'SynchronizedReader', TextReader.$);
    return SynchronizedReader;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let StreamReader = /*@__PURE__*/ (() => {
    class StreamReader extends TextReader {
        constructor(a) {
            super();
            this.o = null;
            this.q = null;
            this.p = null;
            this.k = null;
            this.l = 0;
            this.m = 0;
            this.o = a;
            this.q = Encoding.uTF8;
            this.p = this.q.getDecoder();
            this.k = new Array(this.q.getMaxCharCount(1024));
        }
        r() {
            let a = new Array(1024);
            let b = this.o.read(a, 0, a.length);
            this.l = this.p.c(a, 0, b, this.k, 0);
            this.m = 0;
        }
        a() {
            if (this.m == this.l) {
                this.r();
                if (this.m == this.l) {
                    return -1;
                }
            }
            return this.k[this.m].charCodeAt(0);
        }
        b() {
            if (this.m == this.l) {
                this.r();
                if (this.m == this.l) {
                    return -1;
                }
            }
            return this.k[this.m++].charCodeAt(0);
        }
        c(a, b, c) {
            let d = 0;
            while (c > 0) {
                let e = Math.min(c, this.l - this.m);
                if (e == 0) {
                    this.r();
                    e = Math.min(c, this.l - this.m);
                    if (e == 0) {
                        break;
                    }
                }
                arrayCopy1(this.k, this.m, a, b, e);
                d += e;
                c -= e;
                this.m += e;
            }
            return d;
        }
        g() {
            throw new NotImplementedException(0);
        }
        h() {
            let a = new StringBuilder(0);
            while (true) {
                let b = this.l - this.m;
                if (b == 0) {
                    this.r();
                    b = this.l - this.m;
                    if (b == 0) {
                        break;
                    }
                }
                a.g(this.k, this.m, b);
                this.m = this.l;
            }
            return a.toString();
        }
    }
    StreamReader.$t = /*@__PURE__*/ markType(StreamReader, 'StreamReader', TextReader.$);
    return StreamReader;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Capture = /*@__PURE__*/ (() => {
    class Capture extends Base {
        constructor(a, b, c) {
            super();
            this.a = 0;
            this.c = 0;
            this.f = null;
            this.a = a;
            this.c = b;
            this.f = c;
        }
        get b() {
            if (this.a < 0) {
                throw new NotSupportedException(1, "Cannot get the index of regex groups");
            }
            return this.a;
        }
        get d() {
            return this.c;
        }
        get g() {
            return this.f;
        }
        toString() {
            return this.f;
        }
    }
    Capture.$t = /*@__PURE__*/ markType(Capture, 'Capture');
    return Capture;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Group = /*@__PURE__*/ (() => {
    class Group extends Capture {
        constructor(a, b, c, d) {
            super(b, c, d);
            this.h = false;
            this.h = a;
        }
        get i() {
            return this.h;
        }
    }
    Group.$t = /*@__PURE__*/ markType(Group, 'Group', Capture.$);
    return Group;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let GroupCollection = /*@__PURE__*/ (() => {
    class GroupCollection extends Base {
        constructor(a) {
            super();
            this.f = null;
            this.a = null;
            this.f = a;
            let b = this.f.j;
            let c = this.f.p.a;
            this.a = new Array((c.length));
            for (let d = 0; d < this.a.length; d++) {
                let e = (c[d]);
                for (let f = 0; f < e.length; f++) {
                    let g = (b[e[f]]);
                    if (g != null) {
                        this.a[d] = new Group(true, -1, g.length, g);
                    }
                }
            }
        }
        get count() {
            return this.a.length;
        }
        get b() {
            return true;
        }
        get isSynchronized() {
            return false;
        }
        get syncRoot() {
            return null;
        }
        item(a) {
            return this.a[a] || GroupCollection.c;
        }
        item1(a) {
            return this.item((this.f.p.e[a]));
        }
        copyTo(a, b) {
            arrayCopyTo(this.a, a, b);
        }
        getEnumeratorObject() {
            return getEnumeratorObject(this.a);
        }
    }
    GroupCollection.$t = /*@__PURE__*/ markType(GroupCollection, 'GroupCollection', Base.$, [ICollection_$type, IEnumerable_$type]);
    GroupCollection.c = /*@__PURE__*/ new Group(false, -1, 0, "");
    return GroupCollection;
})();
/**
 * @hidden
 */
let Match = /*@__PURE__*/ (() => {
    class Match extends Group {
        constructor(a, b, c) {
            super(c != null, c == null ? 0 : (c.index), c == null ? 0 : c[0].length, c == null ? "" : c[0]);
            this.j = null;
            this.p = null;
            this.k = null;
            this.l = null;
            this.j = c;
            this.p = a;
            this.k = b;
        }
        static get n() {
            return new Match(null, null, null);
        }
        get_m() {
            if (this.l == null) {
                this.l = new GroupCollection(this);
            }
            return this.l;
        }
        get m() {
            return this.get_m();
        }
        o() {
            if (this.i == false) {
                return this;
            }
            return this.p.j(this.k, this.b + this.d);
        }
    }
    Match.$t = /*@__PURE__*/ markType(Match, 'Match', Group.$);
    return Match;
})();
/**
 * @hidden
 */
let Regex = /*@__PURE__*/ (() => {
    class Regex extends Base {
        constructor(a, b) {
            super();
            this.d = null;
            this.e = null;
            this.a = null;
            this.c = false;
            let c = "g";
            if ((b & 1) != 0) {
                c += "i";
            }
            if ((b & 2) != 0) {
                c += "m";
            }
            if ((b & 32) != 0) {
                a = a.replace(/\s/g, "");
            }
            if ((b & 4) != 0) {
                let d = a.indexOf('(');
                while (d >= 0 && d < a.length) {
                    let e = (d > 0 && a.charAt(d - 1) == '\\') || (d < a.length - 1 && a.charAt(d + 1) == '?');
                    if (!e) {
                        a = a.substr(0, d) + "(?:" + a.substr(d + 1);
                    }
                    d = a.indexOf('(', d + 1);
                }
            }
            let f = (netRegexToJS(a));
            this.e = f.nameToNetGroupIndexMap;
            this.a = (f.netToJSGroupIndexMap);
            this.c = (f.matchMustStartAtCurrentPosition);
            this.d = new RegExp(f.pattern, c);
        }
        static f(a) {
            for (let b = 0; b < a.length; b++) {
                if (Regex.b(a.charAt(b)) == false) {
                    continue;
                }
                let c = new StringBuilder(0);
                let d = a.charAt(b);
                c.m(a, 0, b);
                do {
                    c.h('\\');
                    switch (d) {
                        case '\t':
                            d = 't';
                            break;
                        case '\n':
                            d = 'n';
                            break;
                        case '\f':
                            d = 'f';
                            break;
                        case '\r':
                            d = 'r';
                            break;
                    }
                    c.h(d);
                    b++;
                    let e = b;
                    while (b < a.length) {
                        d = a.charAt(b);
                        if (Regex.b(d)) {
                            break;
                        }
                        b++;
                    }
                    c.m(a, e, b - e);
                } while (b < a.length);
                return c.toString();
            }
            return a;
        }
        static b(a) {
            switch (a.charCodeAt(0)) {
                case 9:
                case 10:
                case 12:
                case 13:
                case 32:
                case 35:
                case 36:
                case 40:
                case 41:
                case 42:
                case 43:
                case 46:
                case 63:
                case 91:
                case 92:
                case 94:
                case 123:
                case 124: return true;
                default: return false;
            }
        }
        i(a) {
            return this.j(a, 0);
        }
        j(a, b) {
            this.d.lastIndex = b;
            let c = (this.d.exec(a));
            if (c != null && this.c && b != (c.index)) {
                c = null;
            }
            return new Match(this, a, c);
        }
        g(a, b) {
            return (a.replace(this.d, b));
        }
        static h(a, b, c, d) {
            let e = new Regex(b, d);
            return e.g(a, c);
        }
    }
    Regex.$t = /*@__PURE__*/ markType(Regex, 'Regex');
    return Regex;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var RegexOptions = /*@__PURE__*/ (function (RegexOptions) {
    RegexOptions[RegexOptions["None"] = 0] = "None";
    RegexOptions[RegexOptions["IgnoreCase"] = 1] = "IgnoreCase";
    RegexOptions[RegexOptions["Multiline"] = 2] = "Multiline";
    RegexOptions[RegexOptions["ExplicitCapture"] = 4] = "ExplicitCapture";
    RegexOptions[RegexOptions["Compiled"] = 8] = "Compiled";
    RegexOptions[RegexOptions["Singleline"] = 16] = "Singleline";
    RegexOptions[RegexOptions["IgnorePatternWhitespace"] = 32] = "IgnorePatternWhitespace";
    RegexOptions[RegexOptions["RightToLeft"] = 64] = "RightToLeft";
    RegexOptions[RegexOptions["ECMAScript"] = 256] = "ECMAScript";
    RegexOptions[RegexOptions["CultureInvariant"] = 512] = "CultureInvariant";
    return RegexOptions;
})({});
/**
 * @hidden
 */
let RegexOptions_$type = /*@__PURE__*/ markEnum('RegexOptions', 'None,0|IgnoreCase,1|Multiline,2|ExplicitCapture,4|Compiled,8|Singleline,16|IgnorePatternWhitespace,32|RightToLeft,64|ECMAScript,256|CultureInvariant,512');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TaskFactory = /*@__PURE__*/ (() => {
    class TaskFactory extends Base {
        c(a, b) {
            return new Task(0, this.b(this.a(a)).always(() => b(a)));
        }
        d($tResult, a, b) {
            let c = new TaskCompletionSource$1($tResult, 0);
            this.b(this.a(a)).always(() => {
                try {
                    let d = b(a);
                    c.e(d);
                }
                catch (e) {
                    c.d((e));
                }
            });
            return c.b;
        }
        e($tAntecedentResult, $tResult, a, b) {
            let c = (d) => getBoxIfEnum($tResult, b(d));
            return this.d(Base.$, a, c).k($tResult, (d) => typeCastObjTo$t($tResult, d.n));
        }
        a(a) {
            let b = new Array(a.length);
            for (let c = 0; c < a.length; c++) {
                b[c] = a[c].d;
            }
            return b;
        }
        b(a) {
            let promises_ = a;
            let b = null;
            return b;
        }
    }
    TaskFactory.$t = /*@__PURE__*/ markType(TaskFactory, 'TaskFactory');
    return TaskFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TaskStatus = /*@__PURE__*/ (function (TaskStatus) {
    TaskStatus[TaskStatus["Created"] = 0] = "Created";
    TaskStatus[TaskStatus["RanToCompletion"] = 5] = "RanToCompletion";
    TaskStatus[TaskStatus["Canceled"] = 6] = "Canceled";
    TaskStatus[TaskStatus["Faulted"] = 7] = "Faulted";
    return TaskStatus;
})({});
/**
 * @hidden
 */
let TaskStatus_$type = /*@__PURE__*/ markEnum('TaskStatus', 'Created,0|RanToCompletion,5|Canceled,6|Faulted,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let APIFactory = /*@__PURE__*/ (() => {
    class APIFactory extends Base {
        static createPoint(a, b) {
            return { $type: Point_$type, x: a, y: b };
        }
        static createRect(a, b, c, d) {
            return new Rect(0, a, b, c, d);
        }
        static createSize(a, b) {
            return new Size(1, a, b);
        }
        static createColor(a) {
            let b = new Color();
            b.colorString = a;
            return b;
        }
    }
    APIFactory.$t = /*@__PURE__*/ markType(APIFactory, 'APIFactory');
    return APIFactory;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Clipboard = /*@__PURE__*/ (() => {
    class Clipboard extends Base {
        static c() {
            return Clipboard.b;
        }
        static a(a, b = false) {
            Clipboard.b = a;
        }
    }
    Clipboard.$t = /*@__PURE__*/ markType(Clipboard, 'Clipboard');
    Clipboard.b = null;
    return Clipboard;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataFormats = /*@__PURE__*/ (() => {
    class DataFormats extends Base {
    }
    DataFormats.$t = /*@__PURE__*/ markType(DataFormats, 'DataFormats');
    DataFormats.a = "CSV";
    DataFormats.b = "HTML Format";
    DataFormats.c = "System.String";
    DataFormats.d = "Text";
    DataFormats.e = "UnicodeText";
    return DataFormats;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDataObject_$type = /*@__PURE__*/ new Type(null, 'IDataObject');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataObject = /*@__PURE__*/ (() => {
    class DataObject extends Base {
        constructor() {
            super();
            this.a = null;
            this.a = new Dictionary$2(String_$type, Base.$, 0);
        }
        getData(a) {
            let b;
            if (((() => { let c = this.a.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            return null;
        }
        getDataPresent(a) {
            return this.a.containsKey(a);
        }
        setData(a, b) {
            this.a.item(a, b);
        }
    }
    DataObject.$t = /*@__PURE__*/ markType(DataObject, 'DataObject', Base.$, [IDataObject_$type]);
    return DataObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplate = /*@__PURE__*/ (() => {
    class DataTemplate extends Base {
        constructor() {
            super(...arguments);
            this._render = null;
            this._measure = null;
            this._passStarting = null;
            this._passCompleted = null;
        }
        get render() {
            return this._render;
        }
        set render(a) {
            this._render = a;
        }
        get measure() {
            return this._measure;
        }
        set measure(a) {
            this._measure = a;
        }
        get passStarting() {
            return this._passStarting;
        }
        set passStarting(a) {
            this._passStarting = a;
        }
        get passCompleted() {
            return this._passCompleted;
        }
        set passCompleted(a) {
            this._passCompleted = a;
        }
    }
    DataTemplate.$t = /*@__PURE__*/ markType(DataTemplate, 'DataTemplate');
    return DataTemplate;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DataTemplatePassInfo = /*@__PURE__*/ (() => {
    class DataTemplatePassInfo extends Base {
        constructor() {
            super(...arguments);
            this.renderContext = null;
            this.context = null;
            this.viewportTop = 0;
            this.viewportLeft = 0;
            this.viewportWidth = 0;
            this.viewportHeight = 0;
            this.isHitTestRender = false;
            this.passID = null;
        }
    }
    DataTemplatePassInfo.$t = /*@__PURE__*/ markType(DataTemplatePassInfo, 'DataTemplatePassInfo');
    return DataTemplatePassInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the horizontal position of an item relative to another object.
 */
var HorizontalAlignment = /*@__PURE__*/ (function (HorizontalAlignment) {
    /**
     * Align the item to the left
     */
    HorizontalAlignment[HorizontalAlignment["Left"] = 0] = "Left";
    /**
     * Center the item
     */
    HorizontalAlignment[HorizontalAlignment["Center"] = 1] = "Center";
    /**
     * Align the item to the right
     */
    HorizontalAlignment[HorizontalAlignment["Right"] = 2] = "Right";
    /**
     * Stretch the item to the full width
     */
    HorizontalAlignment[HorizontalAlignment["Stretch"] = 3] = "Stretch";
    return HorizontalAlignment;
})({});
/**
 * @hidden
 */
let HorizontalAlignment_$type = /*@__PURE__*/ markEnum('HorizontalAlignment', 'Left,0|Center,1|Right,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PropertyPath = /*@__PURE__*/ (() => {
    class PropertyPath extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.b = a;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
    }
    PropertyPath.$t = /*@__PURE__*/ markType(PropertyPath, 'PropertyPath');
    return PropertyPath;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Style = /*@__PURE__*/ (() => {
    class Style extends Base {
        constructor() {
            super(...arguments);
            this.fill = null;
            this.stroke = null;
            this.strokeThickness = NaN;
            this.opacity = NaN;
        }
    }
    Style.$t = /*@__PURE__*/ markType(Style, 'Style');
    return Style;
})();

/**
 * A class that exposes style realted properties.
*/
class IgrStyle {
    createImplementation() {
        return new Style();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the vertica position of an item relative to another object.
 */
var VerticalAlignment = /*@__PURE__*/ (function (VerticalAlignment) {
    /**
     * Align the item to the top
     */
    VerticalAlignment[VerticalAlignment["Top"] = 0] = "Top";
    /**
     * Center the item
     */
    VerticalAlignment[VerticalAlignment["Center"] = 1] = "Center";
    /**
     * Align the item to the bottom
     */
    VerticalAlignment[VerticalAlignment["Bottom"] = 2] = "Bottom";
    /**
     * Stretch the item to the full height
     */
    VerticalAlignment[VerticalAlignment["Stretch"] = 3] = "Stretch";
    return VerticalAlignment;
})({});
/**
 * @hidden
 */
let VerticalAlignment_$type = /*@__PURE__*/ markEnum('VerticalAlignment', 'Top,0|Center,1|Bottom,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Specifies the display state of an element.
 */
var Visibility = /*@__PURE__*/ (function (Visibility) {
    /**
     * Display the element.
     */
    Visibility[Visibility["Visible"] = 0] = "Visible";
    /**
     * Do not display the element.
     */
    Visibility[Visibility["Collapsed"] = 1] = "Collapsed";
    return Visibility;
})({});
/**
 * @hidden
 */
let Visibility_$type = /*@__PURE__*/ markEnum('Visibility', 'Visible,0|Collapsed,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Canvas = /*@__PURE__*/ (() => {
    class Canvas extends Panel {
    }
    Canvas.$t = /*@__PURE__*/ markType(Canvas, 'Canvas', Panel.$);
    return Canvas;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TextBlock = /*@__PURE__*/ (() => {
    class TextBlock extends FrameworkElement {
        constructor() {
            super(...arguments);
            this.aj = null;
            this.am = null;
            this.af = true;
            this.ae = null;
            this.ad = null;
            this.ab = null;
            this.ac = null;
            this.ah = -1;
        }
        get ak() {
            return this.aj;
        }
        set ak(a) {
            if (this.aj != a) {
                this.af = true;
                this.aj = a;
            }
        }
        ag(a, b) {
            if (this.ah == -1) {
                return -1;
            }
            if (!this.af) {
                if (this.ab[this.ah] == a) {
                    return this.ae[this.ah];
                }
            }
            for (let c = 0; c < 5; c++) {
                let d = this.ah - c;
                if (d < 0) {
                    d = (5) + d;
                }
                if (b != this.ac[d] || a != this.ab[d] || this.aj != this.ad[d]) {
                    continue;
                }
                return this.ae[d];
            }
            return -1;
        }
        al(a, b, c) {
            if (this.ah == -1) {
                this.ad = new Array(5);
                this.ab = new Array(5);
                this.ac = new Array(5);
                this.ae = new Array(5);
            }
            this.ah++;
            if (this.ah > 5 - 1) {
                this.ah = 0;
            }
            this.ad[this.ah] = this.aj;
            this.ab[this.ah] = a;
            this.ac[this.ah] = b;
            this.ae[this.ah] = c;
            this.af = false;
        }
    }
    TextBlock.$t = /*@__PURE__*/ markType(TextBlock, 'TextBlock', FrameworkElement.$);
    return TextBlock;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Binding = /*@__PURE__*/ (() => {
    class Binding extends Base {
        constructor(a, ..._rest) {
            super();
            this.c = null;
            this.e = null;
            this.a = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        this.e = new PropertyPath(c);
                    }
                    break;
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a;
        }
        get f() {
            return this.e;
        }
        set f(a) {
            this.e = a;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            this.a = a;
        }
    }
    Binding.$t = /*@__PURE__*/ markType(Binding, 'Binding');
    return Binding;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var Key = /*@__PURE__*/ (function (Key) {
    Key[Key["None"] = 0] = "None";
    Key[Key["Back"] = 1] = "Back";
    Key[Key["Tab"] = 2] = "Tab";
    Key[Key["Enter"] = 3] = "Enter";
    Key[Key["Shift"] = 4] = "Shift";
    Key[Key["Ctrl"] = 5] = "Ctrl";
    Key[Key["Alt"] = 6] = "Alt";
    Key[Key["CapsLock"] = 7] = "CapsLock";
    Key[Key["Escape"] = 8] = "Escape";
    Key[Key["Space"] = 9] = "Space";
    Key[Key["PageUp"] = 10] = "PageUp";
    Key[Key["PageDown"] = 11] = "PageDown";
    Key[Key["End"] = 12] = "End";
    Key[Key["Home"] = 13] = "Home";
    Key[Key["Left"] = 14] = "Left";
    Key[Key["Up"] = 15] = "Up";
    Key[Key["Right"] = 16] = "Right";
    Key[Key["Down"] = 17] = "Down";
    Key[Key["Insert"] = 18] = "Insert";
    Key[Key["del"] = 19] = "del";
    Key[Key["D0"] = 20] = "D0";
    Key[Key["D1"] = 21] = "D1";
    Key[Key["D2"] = 22] = "D2";
    Key[Key["D3"] = 23] = "D3";
    Key[Key["D4"] = 24] = "D4";
    Key[Key["D5"] = 25] = "D5";
    Key[Key["D6"] = 26] = "D6";
    Key[Key["D7"] = 27] = "D7";
    Key[Key["D8"] = 28] = "D8";
    Key[Key["D9"] = 29] = "D9";
    Key[Key["A"] = 30] = "A";
    Key[Key["B"] = 31] = "B";
    Key[Key["C"] = 32] = "C";
    Key[Key["D"] = 33] = "D";
    Key[Key["E"] = 34] = "E";
    Key[Key["F"] = 35] = "F";
    Key[Key["G"] = 36] = "G";
    Key[Key["H"] = 37] = "H";
    Key[Key["I"] = 38] = "I";
    Key[Key["J"] = 39] = "J";
    Key[Key["K"] = 40] = "K";
    Key[Key["L"] = 41] = "L";
    Key[Key["M"] = 42] = "M";
    Key[Key["N"] = 43] = "N";
    Key[Key["O"] = 44] = "O";
    Key[Key["P"] = 45] = "P";
    Key[Key["Q"] = 46] = "Q";
    Key[Key["R"] = 47] = "R";
    Key[Key["S"] = 48] = "S";
    Key[Key["T"] = 49] = "T";
    Key[Key["U"] = 50] = "U";
    Key[Key["V"] = 51] = "V";
    Key[Key["W"] = 52] = "W";
    Key[Key["X"] = 53] = "X";
    Key[Key["Y"] = 54] = "Y";
    Key[Key["Z"] = 55] = "Z";
    Key[Key["F1"] = 56] = "F1";
    Key[Key["F2"] = 57] = "F2";
    Key[Key["F3"] = 58] = "F3";
    Key[Key["F4"] = 59] = "F4";
    Key[Key["F5"] = 60] = "F5";
    Key[Key["F6"] = 61] = "F6";
    Key[Key["F7"] = 62] = "F7";
    Key[Key["F8"] = 63] = "F8";
    Key[Key["F9"] = 64] = "F9";
    Key[Key["F10"] = 65] = "F10";
    Key[Key["F11"] = 66] = "F11";
    Key[Key["F12"] = 67] = "F12";
    Key[Key["NumPad0"] = 68] = "NumPad0";
    Key[Key["NumPad1"] = 69] = "NumPad1";
    Key[Key["NumPad2"] = 70] = "NumPad2";
    Key[Key["NumPad3"] = 71] = "NumPad3";
    Key[Key["NumPad4"] = 72] = "NumPad4";
    Key[Key["NumPad5"] = 73] = "NumPad5";
    Key[Key["NumPad6"] = 74] = "NumPad6";
    Key[Key["NumPad7"] = 75] = "NumPad7";
    Key[Key["NumPad8"] = 76] = "NumPad8";
    Key[Key["NumPad9"] = 77] = "NumPad9";
    Key[Key["Multiply"] = 78] = "Multiply";
    Key[Key["Add"] = 79] = "Add";
    Key[Key["Subtract"] = 80] = "Subtract";
    Key[Key["Decimal"] = 81] = "Decimal";
    Key[Key["Divide"] = 82] = "Divide";
    Key[Key["OemSemicolon"] = 83] = "OemSemicolon";
    Key[Key["OemQuestion"] = 84] = "OemQuestion";
    Key[Key["OemPipe"] = 85] = "OemPipe";
    Key[Key["OemTilde"] = 86] = "OemTilde";
    Key[Key["OemPlus"] = 87] = "OemPlus";
    Key[Key["OemMinus"] = 88] = "OemMinus";
    Key[Key["Unknown"] = 255] = "Unknown";
    return Key;
})({});
/**
 * @hidden
 */
let Key_$type = /*@__PURE__*/ markEnum('Key', 'None,0|Back,1|Tab,2|Enter,3|Shift,4|Ctrl,5|Alt,6|CapsLock,7|Escape,8|Space,9|PageUp,10|PageDown,11|End,12|Home,13|Left,14|Up,15|Right,16|Down,17|Insert,18|Delete:del,19|D0,20|D1,21|D2,22|D3,23|D4,24|D5,25|D6,26|D7,27|D8,28|D9,29|A,30|B,31|C,32|D,33|E,34|F,35|G,36|H,37|I,38|J,39|K,40|L,41|M,42|N,43|O,44|P,45|Q,46|R,47|S,48|T,49|U,50|V,51|W,52|X,53|Y,54|Z,55|F1,56|F2,57|F3,58|F4,59|F5,60|F6,61|F7,62|F8,63|F9,64|F10,65|F11,66|F12,67|NumPad0,68|NumPad1,69|NumPad2,70|NumPad3,71|NumPad4,72|NumPad5,73|NumPad6,74|NumPad7,75|NumPad8,76|NumPad9,77|Multiply,78|Add,79|Subtract,80|Decimal,81|Divide,82|OemSemicolon,83|OemQuestion,84|OemPipe,85|OemTilde,86|OemPlus,87|OemMinus,88|Unknown,255');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ModifierKeys = /*@__PURE__*/ (function (ModifierKeys) {
    ModifierKeys[ModifierKeys["None"] = 0] = "None";
    ModifierKeys[ModifierKeys["Alt"] = 1] = "Alt";
    ModifierKeys[ModifierKeys["Control"] = 2] = "Control";
    ModifierKeys[ModifierKeys["Shift"] = 4] = "Shift";
    ModifierKeys[ModifierKeys["Windows"] = 8] = "Windows";
    ModifierKeys[ModifierKeys["Apple"] = 8] = "Apple";
    return ModifierKeys;
})({});
/**
 * @hidden
 */
let ModifierKeys_$type = /*@__PURE__*/ markEnum('ModifierKeys', 'None,0|Alt,1|Control,2|Shift,4|Windows,8|Apple,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MouseButtonEventArgs = /*@__PURE__*/ (() => {
    class MouseButtonEventArgs extends MouseEventArgs {
        constructor() {
            super(...arguments);
            this._handled = false;
        }
        get handled() {
            return this._handled;
        }
        set handled(a) {
            this._handled = a;
        }
    }
    MouseButtonEventArgs.$t = /*@__PURE__*/ markType(MouseButtonEventArgs, 'MouseButtonEventArgs', MouseEventArgs.$);
    return MouseButtonEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var FillRule = /*@__PURE__*/ (function (FillRule) {
    FillRule[FillRule["EvenOdd"] = 0] = "EvenOdd";
    FillRule[FillRule["Nonzero"] = 1] = "Nonzero";
    return FillRule;
})({});
/**
 * @hidden
 */
let FillRule_$type = /*@__PURE__*/ markEnum('FillRule', 'EvenOdd,0|Nonzero,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var GeometryType = /*@__PURE__*/ (function (GeometryType) {
    GeometryType[GeometryType["Group"] = 0] = "Group";
    GeometryType[GeometryType["Line"] = 1] = "Line";
    GeometryType[GeometryType["Rectangle"] = 2] = "Rectangle";
    GeometryType[GeometryType["Ellipse"] = 3] = "Ellipse";
    GeometryType[GeometryType["Path"] = 4] = "Path";
    return GeometryType;
})({});
/**
 * @hidden
 */
let GeometryType_$type = /*@__PURE__*/ markEnum('GeometryType', 'Group,0|Line,1|Rectangle,2|Ellipse,3|Path,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var PathSegmentType = /*@__PURE__*/ (function (PathSegmentType) {
    PathSegmentType[PathSegmentType["Line"] = 0] = "Line";
    PathSegmentType[PathSegmentType["Bezier"] = 1] = "Bezier";
    PathSegmentType[PathSegmentType["PolyBezier"] = 2] = "PolyBezier";
    PathSegmentType[PathSegmentType["PolyLine"] = 3] = "PolyLine";
    PathSegmentType[PathSegmentType["Arc"] = 4] = "Arc";
    return PathSegmentType;
})({});
/**
 * @hidden
 */
let PathSegmentType_$type = /*@__PURE__*/ markEnum('PathSegmentType', 'Line,0|Bezier,1|PolyBezier,2|PolyLine,3|Arc,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum representing the direction of an arc.
 */
var SweepDirection = /*@__PURE__*/ (function (SweepDirection) {
    /**
     * In a direction opposite the typical forward movement of the hands of a clock.
     */
    SweepDirection[SweepDirection["Counterclockwise"] = 0] = "Counterclockwise";
    /**
     * In a direction corresponding to the typical forward movement of the hands of a clock.
     */
    SweepDirection[SweepDirection["Clockwise"] = 1] = "Clockwise";
    return SweepDirection;
})({});
/**
 * @hidden
 */
let SweepDirection_$type = /*@__PURE__*/ markEnum('SweepDirection', 'Counterclockwise,0|Clockwise,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PathMarkupTokenType_$type = /*@__PURE__*/ markEnum('PathMarkupTokenType', 'Move,0|Line,1|Horizontal,2|Vertical,3|CubicBezier,4|QuadraticBezier,5|SmoothCubicBezier,6|SmoothQuadraticBezier,7|Arc,8|Close,9|Number,10|None,11');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the type of shape at the end of a line.
 */
var PenLineCap = /*@__PURE__*/ (function (PenLineCap) {
    /**
     * A flat end
     */
    PenLineCap[PenLineCap["Flat"] = 0] = "Flat";
    /**
     * A square end
     */
    PenLineCap[PenLineCap["Square"] = 1] = "Square";
    /**
     * A round end
     */
    PenLineCap[PenLineCap["Round"] = 2] = "Round";
    /**
     * A triangluar end
     */
    PenLineCap[PenLineCap["Triangle"] = 3] = "Triangle";
    return PenLineCap;
})({});
/**
 * @hidden
 */
let PenLineCap_$type = /*@__PURE__*/ markEnum('PenLineCap', 'Flat,0|Square,1|Round,2|Triangle,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates the type of shape at the end of a line.
 */
var PenLineJoin = /*@__PURE__*/ (function (PenLineJoin) {
    /**
     * Regular angular vertices.
     */
    PenLineJoin[PenLineJoin["Miter"] = 0] = "Miter";
    /**
     * Beveled vertices.
     */
    PenLineJoin[PenLineJoin["Bevel"] = 1] = "Bevel";
    /**
     * Rounded vertices.
     */
    PenLineJoin[PenLineJoin["Round"] = 2] = "Round";
    return PenLineJoin;
})({});
/**
 * @hidden
 */
let PenLineJoin_$type = /*@__PURE__*/ markEnum('PenLineJoin', 'Miter,0|Bevel,1|Round,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var Stretch = /*@__PURE__*/ (function (Stretch) {
    Stretch[Stretch["None"] = 0] = "None";
    Stretch[Stretch["Fill"] = 1] = "Fill";
    Stretch[Stretch["Uniform"] = 2] = "Uniform";
    Stretch[Stretch["UniformToFill"] = 3] = "UniformToFill";
    return Stretch;
})({});
/**
 * @hidden
 */
let Stretch_$type = /*@__PURE__*/ markEnum('Stretch', 'None,0|Fill,1|Uniform,2|UniformToFill,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Shape = /*@__PURE__*/ (() => {
    class Shape extends FrameworkElement {
        constructor() {
            super();
            this._fill = null;
            this._stroke = null;
            this.ab = false;
            this.ac = 0;
            this.ai = null;
            this.ad = 0;
            this.aj = 0;
        }
        get fill() {
            return this._fill;
        }
        set fill(a) {
            this._fill = a;
        }
        get stroke() {
            return this._stroke;
        }
        set stroke(a) {
            this._stroke = a;
        }
    }
    Shape.$t = /*@__PURE__*/ markType(Shape, 'Shape', FrameworkElement.$);
    return Shape;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Line = /*@__PURE__*/ (() => {
    class Line extends Shape {
        constructor() {
            super();
            this.ak = 0;
            this.al = 0;
            this.am = 0;
            this.an = 0;
            this.ak = 0;
            this.al = 0;
            this.am = 0;
            this.an = 0;
        }
    }
    Line.$t = /*@__PURE__*/ markType(Line, 'Line', Shape.$);
    return Line;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Path = /*@__PURE__*/ (() => {
    class Path extends Shape {
        constructor() {
            super(...arguments);
            this.ak = null;
        }
    }
    Path.$t = /*@__PURE__*/ markType(Path, 'Path', Shape.$);
    return Path;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Polygon = /*@__PURE__*/ (() => {
    class Polygon extends Shape {
        constructor() {
            super();
            this.ak = null;
            this.ak = new PointCollection(0);
        }
    }
    Polygon.$t = /*@__PURE__*/ markType(Polygon, 'Polygon', Shape.$);
    return Polygon;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Polyline = /*@__PURE__*/ (() => {
    class Polyline extends Shape {
        constructor() {
            super();
            this.ak = null;
            this.ak = new PointCollection(0);
        }
    }
    Polyline.$t = /*@__PURE__*/ markType(Polyline, 'Polyline', Shape.$);
    return Polyline;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Rectangle = /*@__PURE__*/ (() => {
    class Rectangle extends Shape {
        constructor() {
            super();
            this.ap = null;
            this.ak = 0;
            this.al = 0;
            this.ap = new Rect(0, 0, 0, 0, 0);
        }
        get am() {
            return this.ak;
        }
        set am(a) {
            this.ak = a;
        }
        get an() {
            return this.al;
        }
        set an(a) {
            this.al = a;
        }
        ao(a) {
        }
    }
    Rectangle.$t = /*@__PURE__*/ markType(Rectangle, 'Rectangle', Shape.$);
    return Rectangle;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UriParser = /*@__PURE__*/ (() => {
    class UriParser extends Base {
        static a(a) {
            return UriParser.b.contains(a.toLowerCase());
        }
    }
    UriParser.$t = /*@__PURE__*/ markType(UriParser, 'UriParser');
    UriParser.b = /*@__PURE__*/ new List$1(String_$type, 1, ["http", "https", "ws", "wss", "ftp", "file", "gopher", "nntp", "news", "mailto", "uuid", "telnet", "ldap", "net.tcp", "net.pipe"]);
    return UriParser;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICredentials_$type = /*@__PURE__*/ new Type(null, 'ICredentials');
/**
 * @hidden
 */
let NetworkCredential = /*@__PURE__*/ (() => {
    class NetworkCredential extends Base {
        constructor(a, ..._rest) {
            super();
            this.c = null;
            this.b = null;
            this.a = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, stringEmpty()];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            this.c = g;
                            this.b = h;
                            this.a = i;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.c = c;
                        this.b = d;
                        this.a = e;
                    }
                    break;
            }
        }
        getCredential(a, b) {
            return this;
        }
    }
    NetworkCredential.$t = /*@__PURE__*/ markType(NetworkCredential, 'NetworkCredential', Base.$, [ICredentials_$type]);
    return NetworkCredential;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadDataCompletedEventArgs = /*@__PURE__*/ (() => {
    class UploadDataCompletedEventArgs extends AsyncCompletedEventArgs {
        constructor(a, b, c, d) {
            super(b, c, d);
            this.i = null;
            this.i = a;
        }
        get result() {
            this.h();
            return this.i;
        }
    }
    UploadDataCompletedEventArgs.$t = /*@__PURE__*/ markType(UploadDataCompletedEventArgs, 'UploadDataCompletedEventArgs', AsyncCompletedEventArgs.$);
    return UploadDataCompletedEventArgs;
})();

class IgrUploadDataCompletedEventArgs extends IgrAsyncCompletedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get result() {
        return this.i.result;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let UploadStringCompletedEventArgs = /*@__PURE__*/ (() => {
    class UploadStringCompletedEventArgs extends AsyncCompletedEventArgs {
        constructor(a, b, c, d) {
            super(b, c, d);
            this.i = null;
            this.i = a;
        }
        get result() {
            this.h();
            return this.i;
        }
    }
    UploadStringCompletedEventArgs.$t = /*@__PURE__*/ markType(UploadStringCompletedEventArgs, 'UploadStringCompletedEventArgs', AsyncCompletedEventArgs.$);
    return UploadStringCompletedEventArgs;
})();

class IgrUploadStringCompletedEventArgs extends IgrAsyncCompletedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get result() {
        return this.i.result;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebHeaderCollection = /*@__PURE__*/ (() => {
    class WebHeaderCollection extends NameValueCollection {
    }
    WebHeaderCollection.$t = /*@__PURE__*/ markType(WebHeaderCollection, 'WebHeaderCollection', NameValueCollection.$);
    return WebHeaderCollection;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let WebClient = /*@__PURE__*/ (() => {
    class WebClient extends Base {
        constructor() {
            super();
            this.e = null;
            this.d = null;
            this.a = null;
            this.uploadStringCompleted = null;
            this.uploadDataCompleted = null;
            this.d = new WebHeaderCollection();
        }
        k(a, b, c, d) {
            this.g(a, b, c).j((e) => {
                if (this.uploadStringCompleted != null) {
                    let f = null;
                    let g = null;
                    try {
                        f = e.n;
                    }
                    catch (h) {
                        g = (h);
                    }
                    this.uploadStringCompleted(this, new UploadStringCompletedEventArgs(f, g, e.h == 6, d));
                }
            });
        }
        g(a, b, c) {
            let url_ = a.value;
            let method_ = b;
            let data_ = c;
            let contentType_ = this.d.item("Content-Type");
            let credentials_ = this.a;
            throw new NotImplementedException(0);
        }
        j(a, b, c, d) {
            this.f(a, b, c).j((e) => {
                if (this.uploadDataCompleted != null) {
                    let f = null;
                    let g = null;
                    try {
                        f = e.n;
                    }
                    catch (h) {
                        g = (h);
                    }
                    this.uploadDataCompleted(this, new UploadDataCompletedEventArgs(f, g, e.h == 6, d));
                }
            });
        }
        f(a, b, c) {
            let url_ = a.value;
            let method_ = b;
            let data_ = c;
            let contentType_ = this.d.item("Content-Type");
            let credentials_ = this.a;
            throw new NotImplementedException(0);
        }
        i(a, b, c, d) {
            a.e(b);
        }
        h(a, b, c, d) {
            a.d(new BaseError(1, d));
        }
    }
    WebClient.$t = /*@__PURE__*/ markType(WebClient, 'WebClient');
    return WebClient;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let JavaScriptSerializer = /*@__PURE__*/ (() => {
    class JavaScriptSerializer extends Base {
        constructor() {
            super();
        }
        a(a) {
            let text_ = a;
            return JSON.parse(text_);
        }
        b(a) {
            let value_ = a;
            return (JSON.stringify(value_));
        }
    }
    JavaScriptSerializer.$t = /*@__PURE__*/ markType(JavaScriptSerializer, 'JavaScriptSerializer');
    return JavaScriptSerializer;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultCode = /*@__PURE__*/ (() => {
    class FaultCode extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    FaultCode.$t = /*@__PURE__*/ markType(FaultCode, 'FaultCode');
    return FaultCode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultException = /*@__PURE__*/ (() => {
    class FaultException extends BaseError {
        constructor(a, b, c) {
            super(0);
            this._action = null;
            this._code = null;
            this._reason = null;
            this.reason = a;
            this.code = b;
            this.action = c;
        }
        get action() {
            return this._action;
        }
        set action(a) {
            this._action = a;
        }
        get code() {
            return this._code;
        }
        set code(a) {
            this._code = a;
        }
        get reason() {
            return this._reason;
        }
        set reason(a) {
            this._reason = a;
        }
    }
    FaultException.$t = /*@__PURE__*/ markType(FaultException, 'FaultException', BaseError.$);
    return FaultException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultException$1 = /*@__PURE__*/ (() => {
    class FaultException$1 extends FaultException {
        constructor($tDetail, a, b, c, d) {
            super(b, c, d);
            this.$tDetail = null;
            this._detail = null;
            this.$tDetail = $tDetail;
            this.$type = this.$type.specialize(this.$tDetail);
            this.detail = a;
        }
        get detail() {
            return this._detail;
        }
        set detail(a) {
            this._detail = a;
        }
    }
    FaultException$1.$t = /*@__PURE__*/ markType(FaultException$1, 'FaultException$1', FaultException.$);
    return FaultException$1;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let FaultReason = /*@__PURE__*/ (() => {
    class FaultReason extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        toString() {
            return this.a;
        }
    }
    FaultReason.$t = /*@__PURE__*/ markType(FaultReason, 'FaultReason');
    return FaultReason;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XmlUtils = /*@__PURE__*/ (() => {
    class XmlUtils extends Base {
        static a() {
            return (!!window.DOMParser);
        }
        static m(a) {
            let text_ = a;
            return ((new DOMParser()).parseFromString(text_, 'text/xml'));
        }
        static l(a) {
            let text_ = a;
            return ((function (xml) {
                var xmlDoc = new ActiveXObject('Microsoft.XMLDOM');
                xmlDoc.async = false;
                xmlDoc.loadXML(xml);
                return xmlDoc;
            })(text_));
        }
        static f(a) {
            let node_ = a;
            return ((new XMLSerializer()).serializeToString(node_));
        }
        static e(a) {
            let node_ = a;
            return (node_.xml);
        }
        static k() {
            return (new ActiveXObject('Microsoft.XMLDOM'));
        }
        static n(a) {
            if (XmlUtils.a()) {
                return XmlUtils.m(a);
            }
            else {
                return XmlUtils.l(a);
            }
        }
        static xmlNodeToString(a) {
            if (XmlUtils.a()) {
                return XmlUtils.f(a);
            }
            else {
                return XmlUtils.e(a);
            }
        }
        static j() {
            let a;
            if (XmlUtils.a()) {
                a = XmlUtils.m("<dummy/>");
                a.removeChild(a.documentElement);
            }
            else {
                a = XmlUtils.k();
            }
            return a;
        }
        static o(a, b) {
            let doc_ = XmlUtils.j();
            if (XmlUtils.a()) {
                return doc_.createElementNS(b, a);
            }
            else {
                let name_ = a;
                let namespaceURI_ = b;
                return (doc_.createNode(1 /*NODE_ELEMENT*/, name_, namespaceURI_));
            }
        }
        static c(a) {
            if (XmlUtils.a()) {
                return a.textContent;
            }
            else {
                let node_ = a;
                return (node_.text);
            }
        }
        static h(a, b) {
            if (XmlUtils.a()) {
                a.textContent = b;
            }
            else {
                let node_ = a;
                let text_ = b;
                node_.text = text_;
            }
        }
        static p(a, b) {
            if (XmlUtils.a()) {
                return a.importNode(b, true);
            }
            else {
                return b;
            }
        }
        static d(a) {
            if (XmlUtils.a()) {
                return a.localName;
            }
            else {
                let node_ = a;
                return (node_.baseName);
            }
        }
        static i(a, b, c) {
            if (XmlUtils.a()) {
                return a.getAttributeNodeNS(c, b);
            }
            else {
                let elem_ = a;
                let ln_ = b;
                let nn_ = c;
                return (elem_.attributes.getQualifiedItem(ln_, nn_));
            }
        }
        static b(a) {
            if (XmlUtils.a()) {
                return a.nodeValue;
            }
            else {
                let attr_ = a;
                return (attr_.value);
            }
        }
    }
    XmlUtils.$t = /*@__PURE__*/ markType(XmlUtils, 'XmlUtils');
    return XmlUtils;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XObject = /*@__PURE__*/ (() => {
    class XObject extends Base {
        constructor(a) {
            super();
            this._backingNode = null;
            this.backingNode = a;
        }
        get backingNode() {
            return this._backingNode;
        }
        set backingNode(a) {
            this._backingNode = a;
        }
        toString() {
            if (this.backingNode != null) {
                return XmlUtils.xmlNodeToString(this.backingNode);
            }
            else {
                return "";
            }
        }
    }
    XObject.$t = /*@__PURE__*/ markType(XObject, 'XObject');
    return XObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XAttribute = /*@__PURE__*/ (() => {
    class XAttribute extends XObject {
        constructor(a) {
            super(a);
        }
        e(a) {
            this.backingNode = this.backingNode.cloneNode(true);
            a.setAttributeNode(this.backingNode);
        }
        get_nodeType() {
            return 2;
        }
        get nodeType() {
            return this.get_nodeType();
        }
        get value() {
            return XmlUtils.b(this.backingNode);
        }
    }
    XAttribute.$t = /*@__PURE__*/ markType(XAttribute, 'XAttribute', XObject.$);
    return XAttribute;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XNode = /*@__PURE__*/ (() => {
    class XNode extends XObject {
        constructor(a) {
            super(a);
        }
    }
    XNode.$t = /*@__PURE__*/ markType(XNode, 'XNode', XObject.$);
    return XNode;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XNamespace = /*@__PURE__*/ (() => {
    class XNamespace extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        static get(a) {
            return new XNamespace(a);
        }
        static get xmlns() {
            return XNamespace.get("http://www.w3.org/2000/xmlns/");
        }
        get namespaceName() {
            return this.a;
        }
    }
    XNamespace.$t = /*@__PURE__*/ markType(XNamespace, 'XNamespace');
    return XNamespace;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XName = /*@__PURE__*/ (() => {
    class XName extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.b = null;
            this.a = a;
            this.b = b;
        }
        get localName() {
            return this.a;
        }
        get namespaceName() {
            return this.b;
        }
        get namespace() {
            return XNamespace.get(this.b);
        }
        static get(a, b) {
            return new XName(a, b);
        }
    }
    XName.$t = /*@__PURE__*/ markType(XName, 'XName');
    return XName;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let XContainer = /*@__PURE__*/ (() => {
    class XContainer extends XNode {
        constructor(a) {
            super(a);
        }
        element(a) {
            let b = null;
            let c = this.backingNode;
            let d = c.childNodes;
            let e = d.length;
            let f = a.localName;
            let g = a.namespaceName;
            for (let h = 0; h < e; h++) {
                let i = d.item(h);
                if (i.namespaceURI == g && i.nodeType == 1 && XmlUtils.d(i) == f) {
                    b = i;
                }
            }
            if (b == null) {
                return null;
            }
            else {
                return new XElement(0, b);
            }
        }
        elements() {
            return this.f(null);
        }
        elements1(a) {
            return this.f(a);
        }
        f(a) {
            let b = new List$1(XElement.$, 0);
            for (let c = 0; c < this.backingNode.childNodes.length; c++) {
                let d = this.backingNode.childNodes.item(c);
                if (d.nodeType == 1) {
                    let e = false;
                    if (a != null) {
                        if (XmlUtils.d(d) == a.localName && d.namespaceURI == a.namespaceName) {
                            e = true;
                        }
                    }
                    else {
                        e = true;
                    }
                    if (e) {
                        b.add(new XElement(0, d));
                    }
                }
            }
            return b;
        }
        add(a) {
            let b = this.backingNode;
            let c;
            if (typeCast(XDocument.$, this) !== null) {
                c = this.backingNode;
            }
            else {
                c = this.backingNode.ownerDocument;
            }
            if (typeCast(XAttribute.$, a) !== null) {
                a.e(b);
            }
            else if (typeCast(XElement.$, a) !== null) {
                a.j(b, c);
            }
        }
    }
    XContainer.$t = /*@__PURE__*/ markType(XContainer, 'XContainer', XNode.$);
    return XContainer;
})();
/**
 * @hidden
 */
let XDocument = /*@__PURE__*/ (() => {
    class XDocument extends XContainer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(c);
                    }
                    break;
                case 1:
                    {
                        super(XmlUtils.j());
                    }
                    break;
            }
        }
        get_nodeType() {
            return 9;
        }
        get nodeType() {
            return this.get_nodeType();
        }
        static parse(a) {
            return new XDocument(0, XmlUtils.n(a));
        }
    }
    XDocument.$t = /*@__PURE__*/ markType(XDocument, 'XDocument', XContainer.$);
    return XDocument;
})();
/**
 * @hidden
 */
let XElement = /*@__PURE__*/ (() => {
    class XElement extends XContainer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(XmlUtils.o(f.localName, f.namespaceName));
                            let h = g == null ? "" : g.toString();
                            this.value = h;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(XmlUtils.o(c.localName, c.namespaceName));
                        let e = d == null ? "" : d.toString();
                        this.value = e;
                    }
                    break;
            }
        }
        get value() {
            return XmlUtils.c(this.backingNode);
        }
        set value(a) {
            XmlUtils.h(this.backingNode, a);
        }
        get_nodeType() {
            return 1;
        }
        get nodeType() {
            return this.get_nodeType();
        }
        get name() {
            return XName.get(XmlUtils.d(this.backingNode), this.backingNode.namespaceURI);
        }
        attribute(a) {
            return new XAttribute(XmlUtils.i(this.backingNode, a.localName, a.namespaceName));
        }
        j(a, b) {
            if (this.backingNode.ownerDocument != b) {
                this.backingNode = XmlUtils.p(b, this.backingNode);
            }
            a.appendChild(this.backingNode);
        }
    }
    XElement.$t = /*@__PURE__*/ markType(XElement, 'XElement', XContainer.$);
    return XElement;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Locale = /*@__PURE__*/ (() => {
    class Locale extends Base {
        static a(a) {
            return a;
        }
    }
    Locale.$t = /*@__PURE__*/ markType(Locale, 'Locale');
    return Locale;
})();

//
/**
 * @hidden
 */
let NullReferenceException = /*@__PURE__*/ (() => {
    class NullReferenceException extends SystemException {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, Locale.a("A null value was found where an object instance was required."));
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                    }
                    break;
            }
        }
    }
    NullReferenceException.$t = /*@__PURE__*/ markType(NullReferenceException, 'NullReferenceException', SystemException.$);
    return NullReferenceException;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Hashtable = /*@__PURE__*/ (() => {
    class Hashtable extends Base {
        constructor() {
            super();
            this.b = new Dictionary$2(String_$type, Base.$, 0);
        }
        get c() {
            return this.b.keys;
        }
        f(a) {
            this.b.removeItem(a);
        }
        e(a, b) {
            this.b.addItem(a, b);
        }
        a(a) {
            return this.b.containsKey(a);
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.b.item(a, b);
                return b;
            }
            else {
                return this.b.item(a);
            }
        }
    }
    Hashtable.$t = /*@__PURE__*/ markType(Hashtable, 'Hashtable', Base.$, [IDictionary_$type]);
    return Hashtable;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let MarshalByRefObject = /*@__PURE__*/ (() => {
    class MarshalByRefObject extends Base {
    }
    MarshalByRefObject.$t = /*@__PURE__*/ markType(MarshalByRefObject, 'MarshalByRefObject');
    return MarshalByRefObject;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ObjectDisposedException = /*@__PURE__*/ (() => {
    class ObjectDisposedException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(0);
                    }
                    break;
            }
        }
    }
    ObjectDisposedException.$t = /*@__PURE__*/ markType(ObjectDisposedException, 'ObjectDisposedException', BaseError.$);
    return ObjectDisposedException;
})();

//
/**
 * @hidden
 */
let FormatException2 = /*@__PURE__*/ (() => {
    class FormatException2 extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, Locale.a("Invalid format."));
                        this._hResult = 0;
                        this.hResult = -2146233033;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this._hResult = 0;
                        this.hResult = -2146233033;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                        this._hResult = 0;
                        this.hResult = -2146233033;
                    }
                    break;
            }
        }
        get hResult() {
            return this._hResult;
        }
        set hResult(a) {
            this._hResult = a;
        }
    }
    FormatException2.$t = /*@__PURE__*/ markType(FormatException2, 'FormatException2', BaseError.$);
    return FormatException2;
})();

//
/**
 * @hidden
 */
let IPermission_$type = /*@__PURE__*/ new Type(null, 'IPermission');

//
/**
 * @hidden
 */
let PermissionSet = /*@__PURE__*/ (() => {
    class PermissionSet extends Base {
        constructor(a, ..._rest) {
            super();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                    }
                    break;
            }
        }
        b(a) {
            return a;
        }
        a() {
            return true;
        }
        c(a) {
            return new PermissionSet(0);
        }
    }
    PermissionSet.$t = /*@__PURE__*/ markType(PermissionSet, 'PermissionSet');
    return PermissionSet;
})();

//
var SecurityAction = /*@__PURE__*/ (function (SecurityAction) {
    SecurityAction[SecurityAction["Demand"] = 2] = "Demand";
    SecurityAction[SecurityAction["Assert"] = 3] = "Assert";
    SecurityAction[SecurityAction["Deny"] = 4] = "Deny";
    SecurityAction[SecurityAction["PermitOnly"] = 5] = "PermitOnly";
    SecurityAction[SecurityAction["LinkDemand"] = 6] = "LinkDemand";
    SecurityAction[SecurityAction["InheritanceDemand"] = 7] = "InheritanceDemand";
    SecurityAction[SecurityAction["RequestMinimum"] = 8] = "RequestMinimum";
    SecurityAction[SecurityAction["RequestOptional"] = 9] = "RequestOptional";
    SecurityAction[SecurityAction["RequestRefuse"] = 10] = "RequestRefuse";
    return SecurityAction;
})({});
/**
 * @hidden
 */
let SecurityAction_$type = /*@__PURE__*/ markEnum('SecurityAction', 'Demand,2|Assert,3|Deny,4|PermitOnly,5|LinkDemand,6|InheritanceDemand,7|RequestMinimum,8|RequestOptional,9|RequestRefuse,10');

// PermissionState.cs
var PermissionState = /*@__PURE__*/ (function (PermissionState) {
    PermissionState[PermissionState["Unrestricted"] = 1] = "Unrestricted";
    PermissionState[PermissionState["None"] = 0] = "None";
    return PermissionState;
})({});
/**
 * @hidden
 */
let PermissionState_$type = /*@__PURE__*/ markEnum('PermissionState', 'Unrestricted,1|None,0');

//
/**
 * @hidden
 */
let DecoderFallbackBuffer = /*@__PURE__*/ (() => {
    class DecoderFallbackBuffer extends Base {
        constructor() {
            super();
        }
        e() {
        }
    }
    DecoderFallbackBuffer.$t = /*@__PURE__*/ markType(DecoderFallbackBuffer, 'DecoderFallbackBuffer');
    return DecoderFallbackBuffer;
})();

//
/**
 * @hidden
 */
let DecoderFallbackException = /*@__PURE__*/ (() => {
    class DecoderFallbackException extends ArgumentException {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [null];
                        {
                            let e = c[0];
                            super(1, e);
                            this.c = null;
                            this.e = -1;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.c = null;
                        this.e = -1;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(3, c, d);
                        this.c = null;
                        this.e = -1;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super(1, c);
                        this.c = null;
                        this.e = -1;
                        this.c = d;
                        this.e = e;
                    }
                    break;
            }
        }
        get bytesUnknown() {
            return this.c;
        }
        get index() {
            return this.e;
        }
    }
    DecoderFallbackException.$t = /*@__PURE__*/ markType(DecoderFallbackException, 'DecoderFallbackException', ArgumentException.$);
    return DecoderFallbackException;
})();

//
/**
 * @hidden
 */
let DecoderExceptionFallbackBuffer = /*@__PURE__*/ (() => {
    class DecoderExceptionFallbackBuffer extends DecoderFallbackBuffer {
        constructor() {
            super();
        }
        get_d() {
            return 0;
        }
        get d() {
            return this.get_d();
        }
        a(a, b) {
            throw new DecoderFallbackException(3, null, a, b);
        }
        c() {
            return charMinValue();
        }
        b() {
            return false;
        }
    }
    DecoderExceptionFallbackBuffer.$t = /*@__PURE__*/ markType(DecoderExceptionFallbackBuffer, 'DecoderExceptionFallbackBuffer', DecoderFallbackBuffer.$);
    return DecoderExceptionFallbackBuffer;
})();

//
/**
 * @hidden
 */
let DecoderFallback = /*@__PURE__*/ (() => {
    class DecoderFallback extends Base {
        constructor() {
            super();
        }
        static staticInit() {
            DecoderFallback.b = new DecoderExceptionFallback();
            DecoderFallback.d = new DecoderReplacementFallback(0);
            DecoderFallback.f = new DecoderReplacementFallback(1, "�");
        }
        static get c() {
            return DecoderFallback.b;
        }
        static get e() {
            return DecoderFallback.d;
        }
        static get g() {
            return DecoderFallback.f;
        }
    }
    DecoderFallback.$t = /*@__PURE__*/ markType(DecoderFallback, 'DecoderFallback');
    DecoderFallback.b = null;
    DecoderFallback.d = null;
    DecoderFallback.f = null;
    return DecoderFallback;
})();
/**
 * @hidden
 */
let DecoderExceptionFallback = /*@__PURE__*/ (() => {
    class DecoderExceptionFallback extends DecoderFallback {
        constructor() {
            super();
        }
        get_a() {
            return 0;
        }
        get a() {
            return this.get_a();
        }
        h() {
            return new DecoderExceptionFallbackBuffer();
        }
        equals(a) {
            return (typeCast(DecoderExceptionFallback.$, a) !== null);
        }
        getHashCode() {
            return 0;
        }
    }
    DecoderExceptionFallback.$t = /*@__PURE__*/ markType(DecoderExceptionFallback, 'DecoderExceptionFallback', DecoderFallback.$);
    return DecoderExceptionFallback;
})();
/**
 * @hidden
 */
let DecoderReplacementFallback = /*@__PURE__*/ (() => {
    class DecoderReplacementFallback extends DecoderFallback {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = ["?"];
                        {
                            let e = c[0];
                            super();
                            this.j = null;
                            if (e == null) {
                                throw new ArgumentNullException(0, "replacement");
                            }
                            this.j = e;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        super();
                        this.j = null;
                        if (c == null) {
                            throw new ArgumentNullException(0, "replacement");
                        }
                        this.j = c;
                    }
                    break;
            }
        }
        get i() {
            return this.j;
        }
        get_a() {
            return this.j.length;
        }
        get a() {
            return this.get_a();
        }
        h() {
            return new DecoderReplacementFallbackBuffer(this);
        }
        equals(a) {
            let b = typeCast(DecoderReplacementFallback.$, a);
            return b != null && this.j == b.j;
        }
        getHashCode() {
            return Base.getHashCodeStatic(this.j);
        }
    }
    DecoderReplacementFallback.$t = /*@__PURE__*/ markType(DecoderReplacementFallback, 'DecoderReplacementFallback', DecoderFallback.$);
    return DecoderReplacementFallback;
})();
/**
 * @hidden
 */
let DecoderReplacementFallbackBuffer = /*@__PURE__*/ (() => {
    class DecoderReplacementFallbackBuffer extends DecoderFallbackBuffer {
        constructor(a) {
            super();
            this.f = false;
            this.g = 0;
            this.h = null;
            if (a == null) {
                throw new ArgumentNullException(0, "fallback");
            }
            this.h = a.i;
            this.g = 0;
        }
        get_d() {
            return this.f ? this.h.length - this.g : 0;
        }
        get d() {
            return this.get_d();
        }
        a(a, b) {
            if (a == null) {
                throw new ArgumentNullException(0, "bytesUnknown");
            }
            if (this.f && this.d != 0) {
                throw new ArgumentException(1, "Reentrant Fallback method invocation occured. It might be because either this FallbackBuffer is incorrectly shared by multiple threads, invoked inside Encoding recursively, or Reset invocation is forgotten.");
            }
            if (b < 0 || a.length < b) {
                throw new ArgumentOutOfRangeException(1, "index");
            }
            this.f = true;
            this.g = 0;
            return this.h.length > 0;
        }
        c() {
            if (!this.f) {
                return '\0';
            }
            if (this.g >= this.h.length) {
                return charMinValue();
            }
            return this.h.charAt(this.g++);
        }
        b() {
            if (this.g == 0) {
                return false;
            }
            this.g--;
            return true;
        }
        e() {
            this.f = false;
            this.g = 0;
        }
    }
    DecoderReplacementFallbackBuffer.$t = /*@__PURE__*/ markType(DecoderReplacementFallbackBuffer, 'DecoderReplacementFallbackBuffer', DecoderFallbackBuffer.$);
    return DecoderReplacementFallbackBuffer;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DTDObjectModel = /*@__PURE__*/ (() => {
    class DTDObjectModel extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.c = null;
            this.d = null;
            this.a = null;
        }
    }
    DTDObjectModel.$t = /*@__PURE__*/ markType(DTDObjectModel, 'DTDObjectModel');
    return DTDObjectModel;
})();

// From: https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/EntityHandling.cs
/**
 */
var EntityHandling = /*@__PURE__*/ (function (EntityHandling) {
    /**
     */
    EntityHandling[EntityHandling["ExpandEntities"] = 1] = "ExpandEntities";
    /**
     */
    EntityHandling[EntityHandling["ExpandCharEntities"] = 2] = "ExpandCharEntities";
    return EntityHandling;
})({});
/**
 * @hidden
 */
let EntityHandling_$type = /*@__PURE__*/ markEnum('EntityHandling', 'ExpandEntities,1|ExpandCharEntities,2');

// Formatting.cs
/**
 */
var Formatting = /*@__PURE__*/ (function (Formatting) {
    /**
     */
    Formatting[Formatting["None"] = 0] = "None";
    /**
     */
    Formatting[Formatting["Indented"] = 1] = "Indented";
    return Formatting;
})({});
/**
 * @hidden
 */
let Formatting_$type = /*@__PURE__*/ markEnum('Formatting', 'None,0|Indented,1');

//
/**
 * @hidden
 */
let IXmlLineInfo_$type = /*@__PURE__*/ new Type(null, 'IXmlLineInfo');

// From: https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/NamespaceHandling.cs
/**
 * @hidden
 */
let NamespaceHandling_$type = /*@__PURE__*/ markEnum('NamespaceHandling', 'Default,0|OmitDuplicates,1');

// -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
/**
 * @hidden
 */
let XmlNameTable = /*@__PURE__*/ (() => {
    class XmlNameTable extends Base {
    }
    XmlNameTable.$t = /*@__PURE__*/ markType(XmlNameTable, 'XmlNameTable');
    return XmlNameTable;
})();

//
/**
 * @hidden
 */
let NameTable_Entry = /*@__PURE__*/ (() => {
    class NameTable_Entry extends Base {
        constructor(a, b, c) {
            super();
            this.c = null;
            this.a = 0;
            this.b = 0;
            this.d = null;
            this.c = a;
            this.b = a.length;
            this.a = b;
            this.d = c;
        }
    }
    NameTable_Entry.$t = /*@__PURE__*/ markType(NameTable_Entry, 'NameTable_Entry');
    return NameTable_Entry;
})();

//
/**
 * @hidden
 */
let NameTable = /*@__PURE__*/ (() => {
    class NameTable extends XmlNameTable {
        constructor() {
            super();
            this.g = 128;
            this.e = new Array(128);
            this.i = 0;
        }
        a(a, b, c) {
            if (((0 > b) && (b >= a.length)) || ((0 > c) && (c >= a.length - c))) {
                throw new IndexOutOfRangeException(1, "The Index is out of range.");
            }
            if (c == 0) {
                return stringEmpty();
            }
            let d = 0;
            let e = b + c;
            for (let f = b; f < e; f++) {
                d = (d << 5) - d + a[f].charCodeAt(0);
            }
            d &= 2147483647;
            for (let g = this.e[d % this.g]; g != null; g = g.d) {
                if (g.a == d && g.b == c && NameTable.f(g.c, a, b)) {
                    return g.c;
                }
            }
            return this.j(stringCreateFromCharArraySlice(a, b, c), d);
        }
        b(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "key");
            }
            let b = a.length;
            if (b == 0) {
                return stringEmpty();
            }
            let c = 0;
            for (let d = 0; d < b; d++) {
                c = (c << 5) - c + a.charAt(d).charCodeAt(0);
            }
            c &= 2147483647;
            for (let e = this.e[c % this.g]; e != null; e = e.d) {
                if (e.a == c && e.b == a.length && e.c == a) {
                    return e.c;
                }
            }
            return this.j(a, c);
        }
        c(a, b, c) {
            if (((0 > b) && (b >= a.length)) || ((0 > c) && (c >= a.length - c))) {
                throw new IndexOutOfRangeException(1, "The Index is out of range.");
            }
            if (c == 0) {
                return stringEmpty();
            }
            let d = 0;
            let e = b + c;
            for (let f = b; f < e; f++) {
                d = (d << 5) - d + a[f].charCodeAt(0);
            }
            d &= 2147483647;
            for (let g = this.e[d % this.g]; g != null; g = g.d) {
                if (g.a == d && g.b == c && NameTable.f(g.c, a, b)) {
                    return g.c;
                }
            }
            return null;
        }
        d(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "value");
            }
            let b = a.length;
            if (b == 0) {
                return stringEmpty();
            }
            let c = 0;
            for (let d = 0; d < b; d++) {
                c = (c << 5) - c + a.charAt(d).charCodeAt(0);
            }
            c &= 2147483647;
            for (let e = this.e[c % this.g]; e != null; e = e.d) {
                if (e.a == c && e.b == a.length && e.c == a) {
                    return e.c;
                }
            }
            return null;
        }
        j(a, b) {
            let c = b % this.g;
            this.e[c] = new NameTable_Entry(a, b, this.e[c]);
            if (this.i++ == this.g) {
                this.g <<= 1;
                let d = this.g - 1;
                let e = new Array(this.g);
                for (let f = 0; f < this.e.length; f++) {
                    let g = this.e[f];
                    let h = g;
                    while (h != null) {
                        let i = h.a & d;
                        let j = h.d;
                        h.d = e[i];
                        e[i] = h;
                        h = j;
                    }
                }
                this.e = e;
            }
            return a;
        }
        static f(a, b, c) {
            let d = a.length;
            d--;
            c += d;
            do {
                if (a.charAt(d) != b[c]) {
                    return false;
                }
                d--;
                c--;
            } while (d >= 0);
            return true;
        }
    }
    NameTable.$t = /*@__PURE__*/ markType(NameTable, 'NameTable', XmlNameTable.$);
    return NameTable;
})();

// From: https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/NewLineHandling.cs
/**
 * @hidden
 */
let NewLineHandling_$type = /*@__PURE__*/ markEnum('NewLineHandling', 'Replace,0|Entitize,1|None,2');

// ReadState.cs
/**
 */
var ReadState = /*@__PURE__*/ (function (ReadState) {
    /**
     */
    ReadState[ReadState["Initial"] = 0] = "Initial";
    /**
     */
    ReadState[ReadState["Interactive"] = 1] = "Interactive";
    /**
     */
    ReadState[ReadState["Error"] = 2] = "Error";
    /**
     */
    ReadState[ReadState["EndOfFile"] = 3] = "EndOfFile";
    /**
     */
    ReadState[ReadState["Closed"] = 4] = "Closed";
    return ReadState;
})({});
/**
 * @hidden
 */
let ReadState_$type = /*@__PURE__*/ markEnum('ReadState', 'Initial,0|Interactive,1|Error,2|EndOfFile,3|Closed,4');

//
/**
 * @hidden
 */
let IXmlNamespaceResolver_$type = /*@__PURE__*/ new Type(null, 'IXmlNamespaceResolver');

// WhitespaceHandling.cs
/**
 */
var WhitespaceHandling = /*@__PURE__*/ (function (WhitespaceHandling) {
    /**
     */
    WhitespaceHandling[WhitespaceHandling["All"] = 0] = "All";
    /**
     */
    WhitespaceHandling[WhitespaceHandling["Significant"] = 1] = "Significant";
    /**
     */
    WhitespaceHandling[WhitespaceHandling["None"] = 2] = "None";
    return WhitespaceHandling;
})({});
/**
 * @hidden
 */
let WhitespaceHandling_$type = /*@__PURE__*/ markEnum('WhitespaceHandling', 'All,0|Significant,1|None,2');

// -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
/**
 */
var WriteState = /*@__PURE__*/ (function (WriteState) {
    /**
     * A write method has not been called.
     */
    WriteState[WriteState["Start"] = 0] = "Start";
    /**
     * The prolog is being written.
     */
    WriteState[WriteState["Prolog"] = 1] = "Prolog";
    /**
     * An element start tag is being written.
     */
    WriteState[WriteState["Element"] = 2] = "Element";
    /**
     * An attribute is being written.
     */
    WriteState[WriteState["Attribute"] = 3] = "Attribute";
    /**
     * Element content is being written.
     */
    WriteState[WriteState["Content"] = 4] = "Content";
    /**
     * The close method has been called.
     */
    WriteState[WriteState["Closed"] = 5] = "Closed";
    return WriteState;
})({});
/**
 * @hidden
 */
let WriteState_$type = /*@__PURE__*/ markEnum('WriteState', 'Start,0|Prolog,1|Element,2|Attribute,3|Content,4|Closed,5');

// -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
/**
 * @hidden
 */
let XmlChar = /*@__PURE__*/ (() => {
    class XmlChar extends Base {
        static p(a) {
            return a == 32 || a == 9 || a == 13 || a == 10;
        }
        static q(a) {
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.p(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static u(a) {
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.p(a.charAt(b).charCodeAt(0))) {
                    return b;
                }
            }
            return -1;
        }
        static e(a) {
            if ((a >= 'a'.charCodeAt(0) && a <= 'z'.charCodeAt(0)) || (a >= 'A'.charCodeAt(0) && a <= 'Z'.charCodeAt(0))) {
                return true;
            }
            else if (intSToU(a) <= 65535) {
                return (u32BitwiseAnd(XmlChar.b[(XmlChar.a[a >> 8] << 3) + ((a & 255) >> 5)], (1 << (a & 31)))) != 0;
            }
            return false;
        }
        static n(a) {
            return !XmlChar.f(a);
        }
        static f(a) {
            switch (a) {
                case 9:
                case 10:
                case 13: return false;
            }
            if (a < 32) {
                return true;
            }
            if (a < 55296) {
                return false;
            }
            if (a < 57344) {
                return true;
            }
            if (a < 65534) {
                return false;
            }
            if (a < 65536) {
                return true;
            }
            if (a < 1114112) {
                return false;
            }
            else {
                return true;
            }
        }
        static t(a, b) {
            for (let c = 0; c < a.length; c++) {
                if (XmlChar.f(a.charAt(c).charCodeAt(0))) {
                    if (!b || c + 1 == a.length || a.charAt(c).charCodeAt(0) < '�'.charCodeAt(0) || a.charAt(c).charCodeAt(0) >= '�'.charCodeAt(0) || a.charAt(c + 1).charCodeAt(0) < '�'.charCodeAt(0) || a.charAt(c + 1).charCodeAt(0) >= ''.charCodeAt(0)) {
                        return c;
                    }
                    c++;
                }
            }
            return -1;
        }
        static s(a, b, c, d) {
            let e = b + c;
            if (a.length < e) {
                throw new ArgumentOutOfRangeException(1, "length");
            }
            for (let f = b; f < e; f++) {
                if (XmlChar.f(a[f].charCodeAt(0))) {
                    if (!d || f + 1 == e || a[f].charCodeAt(0) < '�'.charCodeAt(0) || a[f].charCodeAt(0) >= '�'.charCodeAt(0) || a[f + 1].charCodeAt(0) < '�'.charCodeAt(0) || a[f + 1].charCodeAt(0) >= ''.charCodeAt(0)) {
                        return f;
                    }
                    f++;
                }
            }
            return -1;
        }
        static h(a) {
            if ((a >= 'a'.charCodeAt(0) && a <= 'z'.charCodeAt(0)) || (a >= 'A'.charCodeAt(0) && a <= 'Z'.charCodeAt(0))) {
                return true;
            }
            else if (intSToU(a) <= 65535) {
                return (u32BitwiseAnd(XmlChar.b[(XmlChar.c[a >> 8] << 3) + ((a & 255) >> 5)], (1 << (a & 31)))) != 0;
            }
            else {
                return false;
            }
        }
        static j(a) {
            let b = false;
            if (a >= 0 && a <= 65535 && a != ':'.charCodeAt(0)) {
                b = (u32BitwiseAnd(XmlChar.b[(XmlChar.c[a >> 8] << 3) + ((a & 255) >> 5)], (1 << (a & 31)))) != 0;
            }
            return b;
        }
        static g(a) {
            if (a.length == 0) {
                return false;
            }
            if (!XmlChar.e(a.charAt(0).charCodeAt(0))) {
                return false;
            }
            for (let b = 1; b < a.length; b++) {
                if (!XmlChar.h(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static i(a) {
            if (a.length == 0) {
                return false;
            }
            if (!XmlChar.e(a.charAt(0).charCodeAt(0))) {
                return false;
            }
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.j(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static k(a) {
            if (a.length == 0) {
                return false;
            }
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.h(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static m(a) {
            return (XmlChar.p(a) && a != '\t'.charCodeAt(0)) || ('a'.charCodeAt(0) <= a && a <= 'z'.charCodeAt(0)) || ('A'.charCodeAt(0) <= a && a <= 'Z'.charCodeAt(0)) || ('0'.charCodeAt(0) <= a && a <= '9'.charCodeAt(0)) || (("-'()+,./:=?;!*#@$_%").indexOf(String.fromCharCode(a)) >= 0);
        }
        static l(a) {
            for (let b = 0; b < a.length; b++) {
                if (!XmlChar.m(a.charAt(b).charCodeAt(0))) {
                    return false;
                }
            }
            return true;
        }
        static o(a) {
            if (a != null) {
                let b = a.length;
                if (b > 0) {
                    let c = a.charAt(0);
                    if ((c.charCodeAt(0) >= 'A'.charCodeAt(0) && c.charCodeAt(0) <= 'Z'.charCodeAt(0)) || (c.charCodeAt(0) >= 'a'.charCodeAt(0) && c.charCodeAt(0) <= 'z'.charCodeAt(0))) {
                        for (let d = 1; d < b; d++) {
                            c = a.charAt(d);
                            if ((c.charCodeAt(0) < 'A'.charCodeAt(0) || c.charCodeAt(0) > 'Z'.charCodeAt(0)) && (c.charCodeAt(0) < 'a'.charCodeAt(0) || c.charCodeAt(0) > 'z'.charCodeAt(0)) && (c.charCodeAt(0) < '0'.charCodeAt(0) || c.charCodeAt(0) > '9'.charCodeAt(0)) && c != '.' && c != '_' && c != '-') {
                                return false;
                            }
                        }
                        return true;
                    }
                }
            }
            return false;
        }
        static r(a) {
            switch (a) {
                case "amp": return '&'.charCodeAt(0);
                case "lt": return '<'.charCodeAt(0);
                case "gt": return '>'.charCodeAt(0);
                case "quot": return '\"'.charCodeAt(0);
                case "apos": return '\''.charCodeAt(0);
                default: return -1;
            }
        }
    }
    XmlChar.$t = /*@__PURE__*/ markType(XmlChar, 'XmlChar');
    XmlChar.d = [' ', '\n', '\t', '\r'];
    XmlChar.a = [2, 3, 4, 5, 6, 7, 8, 0, 0, 9, 10, 11, 12, 13, 14, 15, 16, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 19, 0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    XmlChar.c = [25, 3, 26, 27, 28, 29, 30, 0, 0, 31, 32, 33, 34, 35, 36, 37, 16, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 19, 38, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    XmlChar.b = [0, 0, 0, 0, 0, 0, 0, 0, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 0, 67108864, 2281701374, 134217726, 0, 0, 4286578687, 4286578687, 4294967295, 2146697215, 4294966782, 2147483647, 4294967295, 4294967295, 4294959119, 4231135231, 16777215, 0, 4294901760, 4294967295, 4294967295, 4160750079, 3, 0, 0, 0, 0, 0, 4294956864, 4294967291, 1417641983, 1048573, 4294959102, 4294967295, 3758030847, 4294967295, 4294901763, 4294967295, 4294908319, 54513663, 0, 4294836224, 41943039, 4294967294, 127, 0, 4294901760, 460799, 0, 134217726, 2046, 4294836224, 4294967295, 2097151999, 3112959, 96, 4294967264, 603979775, 4278190080, 3, 4294549472, 63307263, 2952790016, 196611, 4294543328, 57540095, 1577058304, 1835008, 4294684640, 602799615, 0, 1, 4294549472, 600702463, 2952790016, 3, 3594373088, 62899992, 0, 0, 4294828000, 66059775, 0, 3, 4294828000, 66059775, 1073741824, 3, 4294828000, 67108351, 0, 3, 0, 0, 0, 0, 4294967294, 884735, 63, 0, 4277151126, 537750702, 31, 0, 0, 0, 4294967039, 1023, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4294967295, 4294901823, 8388607, 514797, 1342177280, 2184269825, 2908843, 1073741824, 4118857984, 7, 33622016, 4294967295, 4294967295, 4294967295, 4294967295, 268435455, 4294967295, 4294967295, 67108863, 1061158911, 4294967295, 2868854591, 1073741823, 4294967295, 1608515583, 265232348, 534519807, 0, 19520, 0, 0, 7, 0, 0, 0, 128, 1022, 4294967294, 4294967295, 2097151, 4294967294, 4294967295, 134217727, 4294967264, 8191, 0, 0, 0, 0, 0, 0, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 63, 0, 0, 4294967295, 4294967295, 4294967295, 4294967295, 4294967295, 15, 0, 0, 0, 134176768, 2281701374, 134217726, 0, 8388608, 4286578687, 4286578687, 16777215, 0, 4294901760, 4294967295, 4294967295, 4160750079, 196611, 0, 4294967295, 4294967295, 63, 3, 4294956992, 4294967291, 1417641983, 1048573, 4294959102, 4294967295, 3758030847, 4294967295, 4294901883, 4294967295, 4294908319, 54513663, 0, 4294836224, 41943039, 4294967294, 4294836351, 3154116603, 4294901782, 460799, 0, 134217726, 524287, 4294902783, 4294967295, 2097151999, 4293885951, 67059199, 4294967278, 4093640703, 4280172543, 65487, 4294549486, 3552968191, 2961193375, 262095, 4294543332, 3547201023, 1577073031, 2097088, 4294684654, 4092460543, 15295, 65473, 4294549486, 4090363391, 2965387663, 65475, 3594373100, 3284125464, 8404423, 65408, 4294828014, 3287285247, 6307295, 65475, 4294828012, 3287285247, 1080049119, 65475, 4294828012, 3288333823, 8404431, 65475, 0, 0, 0, 0, 4294967294, 134184959, 67076095, 0, 4277151126, 1006595246, 67059551, 0, 50331648, 3265266687, 4294967039, 4294837247, 4273934303, 50216959, 0, 0, 0, 0, 0, 0, 0, 0, 536805376, 2, 160, 4128766, 4294967294, 4294967295, 1713373183, 4294967294, 4294967295, 2013265919];
    return XmlChar;
})();

//
/**
 * @hidden
 */
let XmlException = /*@__PURE__*/ (() => {
    class XmlException extends BaseError {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(0);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                        this.h = "Xml_DefaultException";
                        this.c = new Array(1);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(2, c, d);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                        this.h = "Xml_UserException";
                        this.c = [c];
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super(0);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        super(1, c);
                        this.d = 0;
                        this.f = 0;
                        this.i = null;
                        this.h = null;
                        this.c = null;
                        this.h = "Xml_UserException";
                        this.c = [c];
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = [c, d];
                        {
                            let i = g[0];
                            let j = g[1];
                            super(2, i, j);
                            this.d = 0;
                            this.f = 0;
                            this.i = null;
                            this.h = null;
                            this.c = null;
                            this.h = "Xml_UserException";
                            this.c = [i];
                        }
                        this.d = e;
                        this.f = f;
                    }
                    break;
            }
        }
        get lineNumber() {
            return this.d;
        }
        get linePosition() {
            return this.f;
        }
    }
    XmlException.$t = /*@__PURE__*/ markType(XmlException, 'XmlException', BaseError.$);
    return XmlException;
})();

//
/**
 * @hidden
 */
let TextWriter = /*@__PURE__*/ (() => {
    class TextWriter extends MarshalByRefObject {
        constructor(a, ..._rest) {
            super();
            this.a = null;
            this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        this.a = stringToCharArray(Environment.newLine);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.a = stringToCharArray(Environment.newLine);
                        this.c = c;
                    }
                    break;
            }
        }
        static staticInit() {
            TextWriter.d = new TextWriter_NullTextWriter();
        }
        get_b() {
            return this.c;
        }
        get b() {
            return this.get_b();
        }
        get_g() {
            return stringCreateFromCharArray(this.a);
        }
        set_g(a) {
            if (a == null) {
                a = Environment.newLine;
            }
            this.a = stringToCharArray(a);
        }
        get g() {
            return this.get_g();
        }
        set g(a) {
            this.set_g(a);
        }
        i() {
            this.dispose1(true);
        }
        dispose1(a) {
            if (a) {
            }
        }
        dispose() {
            this.dispose1(true);
        }
        k() {
        }
        static e(a) {
            return TextWriter.f(a, false);
        }
        static f(a, b) {
            if (a == null) {
                throw new ArgumentNullException(0, "writer is null");
            }
            if (typeCast(SynchronizedWriter.$, a) !== null) {
                return a;
            }
            return new SynchronizedWriter(1, a, b);
        }
        n(a) {
            this.v(a.toString());
        }
        o(a) {
        }
        l(a) {
            if (a == null) {
                return;
            }
            this.m(a, 0, a.length);
        }
        p(a) {
            this.v(numberToString(a, this.c));
        }
        q(a) {
            this.v(numberToString(a, this.c));
        }
        r(a) {
            this.v(numberToString(a, this.c));
        }
        s(a) {
            this.v(numberToString(a, this.c));
        }
        t(a) {
            if (a != null) {
                this.v(a.toString());
            }
        }
        u(a) {
            this.v(numberToString(a, this.c));
        }
        v(a) {
            if (a != null) {
                this.l(stringToCharArray(a));
            }
        }
        aa(a) {
            this.v(intToString(a, this.c));
        }
        ab(a) {
            this.v(numberToString(a, this.c));
        }
        x(a, b) {
            this.v(stringFormat(a, b));
        }
        w(a, ...b) {
            this.v(stringFormat1(a, ...b));
        }
        m(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0 || b > a.length) {
                throw new ArgumentOutOfRangeException(1, "index");
            }
            if (c < 0 || (b > a.length - c)) {
                throw new ArgumentOutOfRangeException(1, "count");
            }
            for (; c > 0; --c, ++b) {
                this.o(a[b]);
            }
        }
        y(a, b, c) {
            this.v(stringFormat(a, b, c));
        }
        z(a, b, c, d) {
            this.v(stringFormat(a, b, c, d));
        }
        ac() {
            this.l(this.a);
        }
        af(a) {
            this.n(a);
            this.ac();
        }
        ag(a) {
            this.o(a);
            this.ac();
        }
        ad(a) {
            this.l(a);
            this.ac();
        }
        ah(a) {
            this.p(a);
            this.ac();
        }
        ai(a) {
            this.q(a);
            this.ac();
        }
        aj(a) {
            this.r(a);
            this.ac();
        }
        ak(a) {
            this.s(a);
            this.ac();
        }
        al(a) {
            this.t(a);
            this.ac();
        }
        am(a) {
            this.u(a);
            this.ac();
        }
        an(a) {
            this.v(a);
            this.ac();
        }
        as(a) {
            this.aa(a);
            this.ac();
        }
        at(a) {
            this.ab(a);
            this.ac();
        }
        ap(a, b) {
            this.x(a, b);
            this.ac();
        }
        ao(a, ...b) {
            this.w(a, ...b);
            this.ac();
        }
        ae(a, b, c) {
            this.m(a, b, c);
            this.ac();
        }
        aq(a, b, c) {
            this.y(a, b, c);
            this.ac();
        }
        ar(a, b, c, d) {
            this.z(a, b, c, d);
            this.ac();
        }
    }
    TextWriter.$t = /*@__PURE__*/ markType(TextWriter, 'TextWriter', MarshalByRefObject.$, [IDisposable_$type]);
    TextWriter.d = null;
    return TextWriter;
})();
/**
 * @hidden
 */
let TextWriter_NullTextWriter = /*@__PURE__*/ (() => {
    class TextWriter_NullTextWriter extends TextWriter {
        constructor() {
            super(0);
        }
        get_h() {
            return Encoding.defaultValue;
        }
        get h() {
            return this.get_h();
        }
        v(a) {
        }
        o(a) {
        }
        m(a, b, c) {
        }
    }
    TextWriter_NullTextWriter.$t = /*@__PURE__*/ markType(TextWriter_NullTextWriter, 'TextWriter_NullTextWriter', TextWriter.$);
    return TextWriter_NullTextWriter;
})();
/**
 * @hidden
 */
let SynchronizedWriter = /*@__PURE__*/ (() => {
    class SynchronizedWriter extends TextWriter {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, false];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(0);
                            this.av = null;
                            this.au = false;
                            this.av = f;
                            this.au = g;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(0);
                        this.av = null;
                        this.au = false;
                        this.av = c;
                        this.au = d;
                    }
                    break;
            }
        }
        i() {
            if (this.au) {
                return;
            }
            this.av.i();
        }
        k() {
            this.av.k();
        }
        n(a) {
            this.av.n(a);
        }
        o(a) {
            this.av.o(a);
        }
        l(a) {
            this.av.l(a);
        }
        p(a) {
            this.av.p(a);
        }
        r(a) {
            this.av.r(a);
        }
        s(a) {
            this.av.s(a);
        }
        t(a) {
            this.av.t(a);
        }
        u(a) {
            this.av.u(a);
        }
        v(a) {
            this.av.v(a);
        }
        aa(a) {
            this.av.aa(a);
        }
        ab(a) {
            this.av.ab(a);
        }
        x(a, b) {
            this.av.x(a, b);
        }
        w(a, ...b) {
            this.av.w(a, ...b);
        }
        m(a, b, c) {
            this.av.m(a, b, c);
        }
        y(a, b, c) {
            this.av.y(a, b, c);
        }
        z(a, b, c, d) {
            this.av.z(a, b, c, d);
        }
        ac() {
            this.av.ac();
        }
        af(a) {
            this.av.af(a);
        }
        ag(a) {
            this.av.ag(a);
        }
        ad(a) {
            this.av.ad(a);
        }
        ah(a) {
            this.av.ah(a);
        }
        ai(a) {
            this.av.ai(a);
        }
        aj(a) {
            this.av.aj(a);
        }
        ak(a) {
            this.av.ak(a);
        }
        al(a) {
            this.av.al(a);
        }
        am(a) {
            this.av.am(a);
        }
        an(a) {
            this.av.an(a);
        }
        as(a) {
            this.av.as(a);
        }
        at(a) {
            this.av.at(a);
        }
        ap(a, b) {
            this.av.ap(a, b);
        }
        ao(a, ...b) {
            this.av.ao(a, ...b);
        }
        ae(a, b, c) {
            this.av.ae(a, b, c);
        }
        aq(a, b, c) {
            this.av.aq(a, b, c);
        }
        ar(a, b, c, d) {
            this.av.ar(a, b, c, d);
        }
        get_h() {
            return this.av.h;
        }
        get h() {
            return this.get_h();
        }
        get_b() {
            return this.av.b;
        }
        get_g() {
            return this.av.g;
        }
        set_g(a) {
            this.av.g = a;
        }
    }
    SynchronizedWriter.$t = /*@__PURE__*/ markType(SynchronizedWriter, 'SynchronizedWriter', TextWriter.$);
    return SynchronizedWriter;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

//
/**
 * @hidden
 */
let StringWriter = /*@__PURE__*/ (() => {
    class StringWriter extends TextWriter {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [new StringBuilder(0)];
                        {
                            let e = c[0];
                            let f = [e, null];
                            {
                                let h = f[0];
                                let i = f[1];
                                super(0);
                                this.aw = null;
                                this.au = false;
                                if (h == null) {
                                    throw new ArgumentNullException(0, "sb");
                                }
                                this.aw = h;
                                this.c = i;
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [new StringBuilder(0), c];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(0);
                            this.aw = null;
                            this.au = false;
                            if (f == null) {
                                throw new ArgumentNullException(0, "sb");
                            }
                            this.aw = f;
                            this.c = g;
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [c, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            super(0);
                            this.aw = null;
                            this.au = false;
                            if (f == null) {
                                throw new ArgumentNullException(0, "sb");
                            }
                            this.aw = f;
                            this.c = g;
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(0);
                        this.aw = null;
                        this.au = false;
                        if (c == null) {
                            throw new ArgumentNullException(0, "sb");
                        }
                        this.aw = c;
                        this.c = d;
                    }
                    break;
            }
        }
        get_h() {
            return Encoding.unicode;
        }
        get h() {
            return this.get_h();
        }
        i() {
            this.dispose1(true);
            this.au = true;
        }
        dispose1(a) {
            super.dispose1(a);
            this.au = true;
        }
        av() {
            return this.aw;
        }
        toString() {
            return this.aw.toString();
        }
        o(a) {
            if (this.au) {
                throw new ObjectDisposedException(1, "StringReader", Locale.a("Cannot write to a closed StringWriter"));
            }
            this.aw.h(a);
        }
        v(a) {
            if (this.au) {
                throw new ObjectDisposedException(1, "StringReader", Locale.a("Cannot write to a closed StringWriter"));
            }
            this.aw.l(a);
        }
        m(a, b, c) {
            if (this.au) {
                throw new ObjectDisposedException(1, "StringReader", Locale.a("Cannot write to a closed StringWriter"));
            }
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "index", "< 0");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "< 0");
            }
            if (b > a.length - c) {
                throw new ArgumentException(1, "index + count > buffer.Length");
            }
            this.aw.g(a, b, c);
        }
    }
    StringWriter.$t = /*@__PURE__*/ markType(StringWriter, 'StringWriter', TextWriter.$);
    return StringWriter;
})();

//
/**
 * @hidden
 */
let XmlConvert = /*@__PURE__*/ (() => {
    class XmlConvert extends Base {
        constructor() {
            super();
        }
        static ap(a) {
            if (a == null || a.length < 6) {
                return a;
            }
            let b = '\uffff';
            try {
                b = String.fromCharCode(parseInt32_2(a.substr(1, 4), 515, CultureInfo.invariantCulture));
            }
            catch (c) {
                return a.charAt(0) + XmlConvert.s(a.substr(1));
            }
            if (a.length == 6) {
                return b.toString();
            }
            return b + XmlConvert.s(a.substr(6));
        }
        static s(a) {
            if (a == null || a.length == 0) {
                return a;
            }
            let b = a.indexOf('_');
            if (b == -1 || b + 6 >= a.length) {
                return a;
            }
            if ((a.charAt(b + 1) != 'X' && a.charAt(b + 1) != 'x') || a.charAt(b + 6) != '_') {
                return a.charAt(0) + XmlConvert.s(a.substr(1));
            }
            return a.substr(0, b) + XmlConvert.ap(a.substr(b + 1));
        }
        static u(a) {
            if (a == null) {
                return a;
            }
            let b = XmlConvert.v(a);
            let c = b.indexOf(':');
            if (c == -1) {
                return b;
            }
            return stringReplace(b, ":", "_x003A_");
        }
        static c(a, b) {
            if (a == ':') {
                return false;
            }
            if (b) {
                return !XmlChar.e(a.charCodeAt(0));
            }
            else {
                return !XmlChar.h(a.charCodeAt(0));
            }
        }
        static w(a, b) {
            if (a == null || a.length == 0) {
                return a;
            }
            let c = new StringBuilder(0);
            let d = a.length;
            for (let e = 0; e < d; e++) {
                let f = a.charAt(e);
                if (XmlConvert.c(f, e == 0 && !b)) {
                    c.q("_x{0:X4}_", f.charCodeAt(0));
                }
                else if (f == '_' && e + 6 < d && a.charAt(e + 1) == 'x' && a.charAt(e + 6) == '_') {
                    c.l("_x005F_");
                }
                else {
                    c.h(f);
                }
            }
            return c.toString();
        }
        static v(a) {
            return XmlConvert.w(a, false);
        }
        static x(a) {
            if (a == stringEmpty()) {
                throw new XmlException(3, "Invalid NmToken: ''");
            }
            return XmlConvert.w(a, true);
        }
        static d(a) {
            a = trim(a, ...XmlChar.d);
            switch (a) {
                case "1": return true;
                case "true": return true;
                case "0": return false;
                case "false": return false;
                default: throw new FormatException(1, a + " is not a valid boolean value");
            }
        }
        static y(a) {
            let b = new StringWriter(0);
            XmlConvert.ay(a, 0, a.length, b);
            return b.toString();
        }
        static ay(a, b, c, d) {
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(3, "index", b, "index must be non negative integer.");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(3, "count", c, "count must be non negative integer.");
            }
            if (a.length < b + c) {
                throw new ArgumentOutOfRangeException(1, "index and count must be smaller than the length of the buffer.");
            }
            let e = b + c;
            for (let f = b; f < e; f++) {
                let g = a[f];
                let h = g >> 4;
                let i = g & 15;
                if (h > 9) {
                    d.o(String.fromCharCode((h + 55)));
                }
                else {
                    d.o(String.fromCharCode((h + 48)));
                }
                if (i > 9) {
                    d.o(String.fromCharCode((i + 55)));
                }
                else {
                    d.o(String.fromCharCode((i + 48)));
                }
            }
        }
        static f(a) {
            return parseUInt8_2(a, 7, CultureInfo.invariantCulture);
        }
        static g(a) {
            return ConvertUtil.toChar(a);
        }
        static h(a) {
            return parseNumber(a, CultureInfo.invariantCulture);
        }
        static i(a) {
            if (a == null) {
                throw new ArgumentNullException(1);
            }
            let b = XmlConvert.r(a);
            if (b != 0) {
                return b;
            }
            return parseNumber1(a, 423, CultureInfo.invariantCulture);
        }
        static r(a) {
            let b = 0;
            while (b < a.length && /\s/i.test(a.charAt(b))) {
                b++;
            }
            if (b == a.length) {
                throw new FormatException(0);
            }
            let c = a.length - 1;
            while (/\s/i.test(a.charAt(c))) {
                c--;
            }
            if (XmlConvert.e("NaN", a, b, c)) {
                return NaN;
            }
            if (XmlConvert.e("INF", a, b, c)) {
                return Number.POSITIVE_INFINITY;
            }
            if (XmlConvert.e("-INF", a, b, c)) {
                return Number.NEGATIVE_INFINITY;
            }
            if (XmlConvert.e("Infinity", a, b, c)) {
                return Number.POSITIVE_INFINITY;
            }
            if (XmlConvert.e("-Infinity", a, b, c)) {
                return Number.NEGATIVE_INFINITY;
            }
            return 0;
        }
        static e(a, b, c, d) {
            return d - c + 1 == a.length && stringCompareOrdinal(a, 0, b, c, a.length) == 0;
        }
        static l(a) {
            return parseInt16_2(a, 7, CultureInfo.invariantCulture);
        }
        static n(a) {
            return parseInt32_2(a, 7, CultureInfo.invariantCulture);
        }
        static o(a) {
            return parseInt64_2(a, 7, CultureInfo.invariantCulture);
        }
        static p(a) {
            return parseInt8_2(a, 7, CultureInfo.invariantCulture);
        }
        static q(a) {
            if (a == null) {
                throw new ArgumentNullException(1);
            }
            let b = XmlConvert.r(a);
            if (b != 0) {
                return b;
            }
            return parseNumber1(a, 423, CultureInfo.invariantCulture);
        }
        static ah(a) {
            return a.toString();
        }
        static ag(a) {
            return a.toString();
        }
        static aa(a) {
            return a.toString();
        }
        static ai(a) {
            return a.toString();
        }
        static ab(a) {
            return ConvertUtil.toString1(a, CultureInfo.invariantCulture);
        }
        static z(a) {
            if (a) {
                return "true";
            }
            return "false";
        }
        static aj(a) {
            return a.toString();
        }
        static ae(a) {
            return numberToString(a, CultureInfo.invariantCulture);
        }
        static ao(a) {
            return a.toString();
        }
        static al(a) {
            if (a == (0)) {
                return "PT0S";
            }
            let b = new StringBuilder(0);
            if (timeSpanTicks(a) < 0) {
                if (a == (-9007199254740991)) {
                    return "-P10675199DT2H48M5.4775808S";
                }
                b.h('-');
                a = timeSpanNegate(a);
            }
            b.h('P');
            if (timeSpanDays(a) > 0) {
                b.j(timeSpanDays(a)).h('D');
            }
            let c = timeSpanTicks(a) % (10000);
            if (timeSpanDays(a) > 0 || timeSpanHours(a) > 0 || timeSpanMinutes(a) > 0 || timeSpanSeconds(a) > 0 || timeSpanMilliseconds(a) > 0 || c > 0) {
                b.h('T');
                if (timeSpanHours(a) > 0) {
                    b.j(timeSpanHours(a)).h('H');
                }
                if (timeSpanMinutes(a) > 0) {
                    b.j(timeSpanMinutes(a)).h('M');
                }
                if (timeSpanSeconds(a) > 0 || timeSpanMilliseconds(a) > 0 || c > 0) {
                    b.j(timeSpanSeconds(a));
                    let d = true;
                    if (c > 0) {
                        b.h('.').q("{0:0000000}", timeSpanTicks(a) % (10000000));
                    }
                    else if (timeSpanMilliseconds(a) > 0) {
                        b.h('.').q("{0:000}", timeSpanMilliseconds(a));
                    }
                    else {
                        d = false;
                    }
                    if (d) {
                        while (b.item(b.c - 1) == '0') {
                            b.y(b.c - 1, 1);
                        }
                    }
                    b.h('S');
                }
            }
            return b.toString();
        }
        static af(a) {
            if (isNegativeInfinity(a)) {
                return "-INF";
            }
            if (isPositiveInfinity(a)) {
                return "INF";
            }
            if (isNaN_(a)) {
                return "NaN";
            }
            return a.toString();
        }
        static ak(a) {
            if (isNegativeInfinity(a)) {
                return "-INF";
            }
            if (isPositiveInfinity(a)) {
                return "INF";
            }
            if (isNaN_(a)) {
                return "NaN";
            }
            return a.toString();
        }
        static an(a) {
            return a.toString();
        }
        static am(a) {
            return a.toString();
        }
        static ac(a) {
            return dateToStringFormat(a, "yyyy-MM-ddTHH:mm:ss.fffffffzzz", CultureInfo.invariantCulture);
        }
        static ad(a, b) {
            return dateToStringFormat(a, b, CultureInfo.invariantCulture);
        }
        static au(a) {
            a = trim(a, ...XmlChar.d);
            if (a.length == 0) {
                throw new FormatException(1, "Invalid format string for duration schema datatype.");
            }
            let b = 0;
            if (a.charAt(0) == '-') {
                b = 1;
            }
            let c = (b == 1);
            if (a.charAt(b) != 'P') {
                throw new FormatException(1, "Invalid format string for duration schema datatype.");
            }
            b++;
            let d = 0;
            let e = 0;
            let f = false;
            let g = 0;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = 0;
            let l = false;
            let m = b;
            while (m < a.length) {
                if (a.charAt(m) == 'T') {
                    f = true;
                    d = 4;
                    m++;
                    b = m;
                    continue;
                }
                for (; m < a.length; m++) {
                    if (a.charAt(m).charCodeAt(0) < '0'.charCodeAt(0) || '9'.charCodeAt(0) < a.charAt(m).charCodeAt(0)) {
                        break;
                    }
                }
                if (d == 7) {
                    k = m - b;
                }
                let n = parseInt32_1(a.substr(b, m - b), CultureInfo.invariantCulture);
                if (d == 7) {
                    for (; k > 7; k--) {
                        n = intDivide(n, 10);
                    }
                    for (; k < 7; k++) {
                        n *= 10;
                    }
                }
                switch (a.charAt(m)) {
                    case 'Y':
                        e += n * 365;
                        if (d > 0) {
                            l = true;
                        }
                        else {
                            d = 1;
                        }
                        break;
                    case 'M':
                        if (d < 2) {
                            e += 365 * (intDivide(n, 12)) + 30 * (n % 12);
                            d = 2;
                        }
                        else if (f && d < 6) {
                            h = n;
                            d = 6;
                        }
                        else {
                            l = true;
                        }
                        break;
                    case 'D':
                        e += n;
                        if (d > 2) {
                            l = true;
                        }
                        else {
                            d = 3;
                        }
                        break;
                    case 'H':
                        g = n;
                        if (!f || d > 4) {
                            l = true;
                        }
                        else {
                            d = 5;
                        }
                        break;
                    case 'S':
                        if (d == 7) {
                            j = n;
                        }
                        else {
                            i = n;
                        }
                        if (!f || d > 7) {
                            l = true;
                        }
                        else {
                            d = 8;
                        }
                        break;
                    case '.':
                        if (d > 7) {
                            l = true;
                        }
                        i = n;
                        d = 7;
                        break;
                    default:
                        l = true;
                        break;
                }
                if (l) {
                    break;
                }
                ++m;
                b = m;
            }
            if (l) {
                throw new FormatException(1, "Invalid format string for duration schema datatype.");
            }
            let o = timeSpanInit3(e, g, h, i);
            if (c) {
                return timeSpanFromTicks(-(timeSpanTicks(o) + j));
            }
            else {
                return timeSpanFromTicks(timeSpanTicks(o) + j);
            }
        }
        static av(a) {
            return parseUInt16_2(a, 7, CultureInfo.invariantCulture);
        }
        static aw(a) {
            return parseUInt32_2(a, 7, CultureInfo.invariantCulture);
        }
        static ax(a) {
            return parseUInt64_2(a, 7, CultureInfo.invariantCulture);
        }
        static aq(a) {
            if (a == null || a.length == 0) {
                throw new ArgumentNullException(0, "name");
            }
            if (!XmlChar.g(a)) {
                throw new XmlException(3, "'" + a + "' is not a valid XML Name");
            }
            return a;
        }
        static ar(a) {
            if (a == null || a.length == 0) {
                throw new ArgumentNullException(0, "ncname");
            }
            if (!XmlChar.i(a)) {
                throw new XmlException(3, "'" + a + "' is not a valid XML NCName");
            }
            return a;
        }
        static at(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "name");
            }
            if (a.length == 0) {
                return a;
            }
            if (XmlChar.p(a.charAt(0).charCodeAt(0)) || XmlChar.p(a.charAt(a.length - 1).charCodeAt(0))) {
                throw new XmlException(3, "Whitespace characters (#xA, #xD, #x9, #x20) are not allowed as leading or trailing whitespaces of xs:token.");
            }
            for (let b = 0; b < a.length; b++) {
                if (XmlChar.p(a.charAt(b).charCodeAt(0)) && a.charAt(b) != ' ') {
                    throw new XmlException(3, "Either #xA, #xD or #x9 are not allowed inside xs:token.");
                }
            }
            return a;
        }
        static as(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "name");
            }
            if (!XmlChar.k(a)) {
                throw new XmlException(3, "'" + a + "' is not a valid XML NMTOKEN");
            }
            return a;
        }
        static b(a) {
            let b = stringToCharArray(a);
            let c = new Array(intDivide(b.length, 2) + b.length % 2);
            XmlConvert.m(b, 0, b.length, c);
            return c;
        }
        static m(a, b, c, d) {
            let e = b;
            for (let f = 0; f < c - 1; f += 2) {
                d[e] = (a[f].charCodeAt(0) > '9'.charCodeAt(0) ? (a[f].charCodeAt(0) - 'A'.charCodeAt(0) + 10) : (a[f].charCodeAt(0) - '0'.charCodeAt(0)));
                d[e] <<= 4;
                d[e] += a[f + 1].charCodeAt(0) > '9'.charCodeAt(0) ? (a[f + 1].charCodeAt(0) - 'A'.charCodeAt(0) + 10) : (a[f + 1].charCodeAt(0) - '0'.charCodeAt(0));
                e++;
            }
            if (c % 2 != 0) {
                d[e++] = ((a[c - 1].charCodeAt(0) > '9'.charCodeAt(0) ? (a[c - 1].charCodeAt(0) - 'A'.charCodeAt(0) + 10) : (a[c - 1].charCodeAt(0) - '0'.charCodeAt(0))) << 4);
            }
            return e - b;
        }
    }
    XmlConvert.$t = /*@__PURE__*/ markType(XmlConvert, 'XmlConvert');
    XmlConvert.a = ["yyyy-MM-ddTHH:mm:sszzz", "yyyy-MM-ddTHH:mm:ss.fzzz", "yyyy-MM-ddTHH:mm:ss.ffzzz", "yyyy-MM-ddTHH:mm:ss.fffzzz", "yyyy-MM-ddTHH:mm:ss.ffffzzz", "yyyy-MM-ddTHH:mm:ss.fffffzzz", "yyyy-MM-ddTHH:mm:ss.ffffffzzz", "yyyy-MM-ddTHH:mm:ss.fffffffzzz", "yyyy-MM-ddTHH:mm:ssZ", "yyyy-MM-ddTHH:mm:ss.fZ", "yyyy-MM-ddTHH:mm:ss.ffZ", "yyyy-MM-ddTHH:mm:ss.fffZ", "yyyy-MM-ddTHH:mm:ss.ffffZ", "yyyy-MM-ddTHH:mm:ss.fffffZ", "yyyy-MM-ddTHH:mm:ss.ffffffZ", "yyyy-MM-ddTHH:mm:ss.fffffffZ", "yyyy-MM-ddTHH:mm:ss", "yyyy-MM-ddTHH:mm:ss.f", "yyyy-MM-ddTHH:mm:ss.ff", "yyyy-MM-ddTHH:mm:ss.fff", "yyyy-MM-ddTHH:mm:ss.ffff", "yyyy-MM-ddTHH:mm:ss.fffff", "yyyy-MM-ddTHH:mm:ss.ffffff", "yyyy-MM-ddTHH:mm:ss.fffffff", "HH:mm:ss", "HH:mm:ss.f", "HH:mm:ss.ff", "HH:mm:ss.fff", "HH:mm:ss.ffff", "HH:mm:ss.fffff", "HH:mm:ss.ffffff", "HH:mm:ss.fffffff", "HH:mm:sszzz", "HH:mm:ss.fzzz", "HH:mm:ss.ffzzz", "HH:mm:ss.fffzzz", "HH:mm:ss.ffffzzz", "HH:mm:ss.fffffzzz", "HH:mm:ss.ffffffzzz", "HH:mm:ss.fffffffzzz", "HH:mm:ssZ", "HH:mm:ss.fZ", "HH:mm:ss.ffZ", "HH:mm:ss.fffZ", "HH:mm:ss.ffffZ", "HH:mm:ss.fffffZ", "HH:mm:ss.ffffffZ", "HH:mm:ss.fffffffZ", "yyyy-MM-dd", "yyyy-MM-ddzzz", "yyyy-MM-ddZ", "yyyy-MM", "yyyy-MMzzz", "yyyy-MMZ", "yyyy", "yyyyzzz", "yyyyZ", "--MM-dd", "--MM-ddzzz", "--MM-ddZ", "---dd", "---ddzzz", "---ddZ"];
    return XmlConvert;
})();

//
/**
 * @hidden
 */
let XmlNamespaceManager_NsDecl = /*@__PURE__*/ (() => {
    class XmlNamespaceManager_NsDecl extends ValueType {
        constructor() {
            super();
            this.a = null;
            this.b = null;
        }
    }
    XmlNamespaceManager_NsDecl.$t = /*@__PURE__*/ markStruct(XmlNamespaceManager_NsDecl, 'XmlNamespaceManager_NsDecl');
    return XmlNamespaceManager_NsDecl;
})();

//
/**
 * @hidden
 */
let XmlNamespaceManager_NsScope = /*@__PURE__*/ (() => {
    class XmlNamespaceManager_NsScope extends ValueType {
        constructor() {
            super();
            this.a = 0;
            this.b = null;
        }
    }
    XmlNamespaceManager_NsScope.$t = /*@__PURE__*/ markStruct(XmlNamespaceManager_NsScope, 'XmlNamespaceManager_NsScope');
    return XmlNamespaceManager_NsScope;
})();

//
/**
 * @hidden
 */
let XmlNamespaceManager = /*@__PURE__*/ (() => {
    class XmlNamespaceManager extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.k = -1;
            this.b = null;
            this.l = -1;
            this.m = null;
            this.j = 0;
            this.af = null;
            this.f = false;
            if (a == null) {
                throw new ArgumentNullException(0, "nameTable");
            }
            this.af = a;
            a.b("xmlns");
            a.b("xml");
            a.b(stringEmpty());
            a.b("http://www.w3.org/2000/xmlns/");
            a.b("http://www.w3.org/XML/1998/namespace");
            this.ab();
        }
        ab() {
            this.a = new Array(10);
            this.b = new Array(40);
            for (let a = 0; a < this.a.length; a++) {
                this.a[a] = new XmlNamespaceManager_NsDecl();
            }
            for (let b = 0; b < this.b.length; b++) {
                this.b[b] = new XmlNamespaceManager_NsScope();
            }
        }
        z() {
            let a = this.a;
            this.a = new Array(this.k * 2 + 1);
            if (this.k > 0) {
                arrayCopy1(a, 0, this.a, 0, this.k);
            }
            for (let b = this.k; b < this.a.length; b++) {
                this.a[b] = new XmlNamespaceManager_NsDecl();
            }
        }
        aa() {
            let a = this.b;
            this.b = new Array(this.l * 2 + 1);
            if (this.l > 0) {
                arrayCopy1(a, 0, this.b, 0, this.l);
            }
            for (let b = this.l; b < this.b.length; b++) {
                this.b[b] = new XmlNamespaceManager_NsScope();
            }
        }
        get_n() {
            return this.m == null ? stringEmpty() : this.m;
        }
        get n() {
            return this.get_n();
        }
        get ag() {
            return this.af;
        }
        x(a, b) {
            this.y(a, b, false);
        }
        y(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "prefix Value cannot be null.");
            }
            if (b == null) {
                throw new ArgumentNullException(0, "uri Value cannot be null.");
            }
            if (!c) {
                a = this.af.b(a);
                b = this.af.b(b);
            }
            if (a == "xml" && b == "http://www.w3.org/XML/1998/namespace") {
                return;
            }
            XmlNamespaceManager.o(a, b, true);
            if (a.length == 0) {
                this.m = b;
            }
            for (let d = this.k; d > this.k - this.j; d--) {
                if (Base.referenceEquals(this.a[d].a, a)) {
                    this.a[d].b = b;
                    return;
                }
            }
            this.k++;
            this.j++;
            if (this.k == this.a.length) {
                this.z();
            }
            this.a[this.k].a = a;
            this.a[this.k].b = b;
        }
        static o(a, b, c) {
            let d = null;
            if (a == "xml" && b != "http://www.w3.org/XML/1998/namespace") {
                d = stringFormat("Prefix \"xml\" can only be bound to the fixed namespace URI \"{0}\". \"{1}\" is invalid.", "http://www.w3.org/XML/1998/namespace", b);
            }
            else if (d == null && a == "xmlns") {
                d = "Declaring prefix named \"xmlns\" is not allowed to any namespace.";
            }
            else if (d == null && b == "http://www.w3.org/2000/xmlns/") {
                d = stringFormat("Namespace URI \"{0}\" cannot be declared with any namespace.", "http://www.w3.org/2000/xmlns/");
            }
            if (d != null && c) {
                throw new ArgumentException(1, d);
            }
            else {
                return d;
            }
        }
        getEnumeratorObject() {
            let a = new Hashtable();
            for (let b = 0; b <= this.k; b++) {
                if (this.a[b].a != stringEmpty() && this.a[b].b != null) {
                    a.item(this.a[b].a, this.a[b].b);
                }
            }
            a.item(stringEmpty(), this.n);
            a.item("xml", "http://www.w3.org/XML/1998/namespace");
            a.item("xmlns", "http://www.w3.org/2000/xmlns/");
            return getEnumerator(a.c);
        }
        getNamespacesInScope(a) {
            return this.i(a);
        }
        i(a) {
            let b = new Hashtable();
            if (a == 2) {
                for (let c = 0; c < this.j; c++) {
                    if (this.a[this.k - c].a == stringEmpty() && this.a[this.k - c].b == stringEmpty()) {
                        if (b.a(stringEmpty())) {
                            b.f(stringEmpty());
                        }
                    }
                    else if (this.a[this.k - c].b != null) {
                        b.e(this.a[this.k - c].a, this.a[this.k - c].b);
                    }
                }
                return b;
            }
            else {
                for (let d = 0; d <= this.k; d++) {
                    if (this.a[d].a == stringEmpty() && this.a[d].b == stringEmpty()) {
                        if (b.a(stringEmpty())) {
                            b.f(stringEmpty());
                        }
                    }
                    else if (this.a[d].b != null) {
                        b.item(this.a[d].a, this.a[d].b);
                    }
                }
                if (a == 0) {
                    b.e("xml", "http://www.w3.org/XML/1998/namespace");
                }
                return b;
            }
        }
        d(a) {
            return this.e(a, false);
        }
        e(a, b) {
            if (a == null || this.j == 0) {
                return false;
            }
            for (let c = this.k; c > this.k - this.j; c--) {
                if (this.a[c].a == a) {
                    return true;
                }
            }
            return false;
        }
        lookupNamespace(a) {
            switch (a) {
                case "xmlns": return this.af.d("http://www.w3.org/2000/xmlns/");
                case "xml": return this.af.d("http://www.w3.org/XML/1998/namespace");
                case "": return this.n;
                case null: return null;
            }
            for (let b = this.k; b >= 0; b--) {
                if (this.c(this.a[b].a, a, this.f) && this.a[b].b != null) {
                    return this.a[b].b;
                }
            }
            return null;
        }
        lookupNamespace1(a, b) {
            this.f = b;
            let c = this.lookupNamespace(a);
            this.f = false;
            return c;
        }
        lookupPrefix(a) {
            return this.lookupPrefix1(a, true);
        }
        c(a, b, c) {
            if (c) {
                return Base.referenceEquals(a, b);
            }
            else {
                return a == b;
            }
        }
        lookupPrefix1(a, b) {
            return this.r(a, b, false);
        }
        s(a, b) {
            return this.r(a, b, true);
        }
        r(a, b, c) {
            if (a == null) {
                return null;
            }
            if (this.c(a, this.n, b)) {
                return stringEmpty();
            }
            if (this.c(a, "http://www.w3.org/XML/1998/namespace", b)) {
                return "xml";
            }
            if (this.c(a, "http://www.w3.org/2000/xmlns/", b)) {
                return "xmlns";
            }
            for (let d = this.k; d >= 0; d--) {
                if (this.c(this.a[d].b, a, b) && this.a[d].a.length > 0) {
                    if (!c || !this.g(d)) {
                        return this.a[d].a;
                    }
                }
            }
            return null;
        }
        g(a) {
            if (a == this.k) {
                return false;
            }
            let b = this.a[a + 1].a;
            for (let c = a + 1; c <= this.k; c++) {
                if (this.a[a].a == b) {
                    return true;
                }
            }
            return false;
        }
        h() {
            if (this.l == -1) {
                return false;
            }
            this.k -= this.j;
            this.m = this.b[this.l].b;
            this.j = this.b[this.l].a;
            this.l--;
            return true;
        }
        ac() {
            this.l++;
            if (this.l == this.b.length) {
                this.aa();
            }
            this.b[this.l].b = this.m;
            this.b[this.l].a = this.j;
            this.j = 0;
        }
        ad(a, b) {
            this.ae(a, b, false);
        }
        ae(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "prefix");
            }
            if (b == null) {
                throw new ArgumentNullException(0, "uri");
            }
            if (this.j == 0) {
                return;
            }
            for (let d = this.k; d > this.k - this.j; d--) {
                if (this.c(this.a[d].a, a, c) && this.c(this.a[d].b, b, c)) {
                    this.a[d].b = null;
                }
            }
        }
    }
    XmlNamespaceManager.$t = /*@__PURE__*/ markType(XmlNamespaceManager, 'XmlNamespaceManager', Base.$, [IXmlNamespaceResolver_$type, IEnumerable_$type]);
    return XmlNamespaceManager;
})();

//
/**
 * @hidden
 */
let XmlNamespaceScope_$type = /*@__PURE__*/ markEnum('XmlNamespaceScope', 'All,0|ExcludeXml,1|Local,2');

//
/**
 * @hidden
 */
let XmlParserContext_ContextItem = /*@__PURE__*/ (() => {
    class XmlParserContext_ContextItem extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = null;
            this.c = 0;
        }
    }
    XmlParserContext_ContextItem.$t = /*@__PURE__*/ markType(XmlParserContext_ContextItem, 'XmlParserContext_ContextItem');
    return XmlParserContext_ContextItem;
})();

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlTextWriter_XmlNodeInfo = /*@__PURE__*/ (() => {
    class XmlTextWriter_XmlNodeInfo extends Base {
        constructor() {
            super(...arguments);
            this.e = null;
            this.c = null;
            this.d = null;
            this.b = false;
            this.a = false;
            this.f = null;
            this.g = 0;
        }
    }
    XmlTextWriter_XmlNodeInfo.$t = /*@__PURE__*/ markType(XmlTextWriter_XmlNodeInfo, 'XmlTextWriter_XmlNodeInfo');
    return XmlTextWriter_XmlNodeInfo;
})();

//
/**
 * @hidden
 */
let NullStream = /*@__PURE__*/ (() => {
    class NullStream extends Stream {
        get_canRead() {
            return true;
        }
        get canRead() {
            return this.get_canRead();
        }
        get_canSeek() {
            return true;
        }
        get canSeek() {
            return this.get_canSeek();
        }
        get_canWrite() {
            return true;
        }
        get canWrite() {
            return this.get_canWrite();
        }
        get_length() {
            return 0;
        }
        get length() {
            return this.get_length();
        }
        get_position() {
            return 0;
        }
        set_position(a) {
        }
        get position() {
            return this.get_position();
        }
        set position(a) {
            this.set_position(a);
        }
        flush() {
        }
        read(a, b, c) {
            return 0;
        }
        readByte() {
            return -1;
        }
        seek(a, b) {
            return 0;
        }
        setLength(a) {
        }
        write(a, b, c) {
        }
        writeByte(a) {
        }
    }
    NullStream.$t = /*@__PURE__*/ markType(NullStream, 'NullStream', Stream.$);
    return NullStream;
})();

//
/**
 * @hidden
 */
let StreamWriter = /*@__PURE__*/ (() => {
    class StreamWriter extends TextWriter {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, Encoding.uTF8Unmarked, 1024];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            super(0);
                            this.a8 = null;
                            this.a6 = null;
                            this.ay = false;
                            this.au = null;
                            this.a0 = 0;
                            this.av = null;
                            this.a1 = 0;
                            this.ax = false;
                            this.az = false;
                            if (null == f) {
                                throw new ArgumentNullException(0, "stream");
                            }
                            if (null == g) {
                                throw new ArgumentNullException(0, "encoding");
                            }
                            if (h <= 0) {
                                throw new ArgumentOutOfRangeException(1, "bufferSize");
                            }
                            if (!f.canWrite) {
                                throw new ArgumentException(1, "Can not write to stream");
                            }
                            this.a6 = f;
                            this.bb(g, h);
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, 1024];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            super(0);
                            this.a8 = null;
                            this.a6 = null;
                            this.ay = false;
                            this.au = null;
                            this.a0 = 0;
                            this.av = null;
                            this.a1 = 0;
                            this.ax = false;
                            this.az = false;
                            if (null == g) {
                                throw new ArgumentNullException(0, "stream");
                            }
                            if (null == h) {
                                throw new ArgumentNullException(0, "encoding");
                            }
                            if (i <= 0) {
                                throw new ArgumentOutOfRangeException(1, "bufferSize");
                            }
                            if (!g.canWrite) {
                                throw new ArgumentException(1, "Can not write to stream");
                            }
                            this.a6 = g;
                            this.bb(h, i);
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        super(0);
                        this.a8 = null;
                        this.a6 = null;
                        this.ay = false;
                        this.au = null;
                        this.a0 = 0;
                        this.av = null;
                        this.a1 = 0;
                        this.ax = false;
                        this.az = false;
                        if (null == c) {
                            throw new ArgumentNullException(0, "stream");
                        }
                        if (null == d) {
                            throw new ArgumentNullException(0, "encoding");
                        }
                        if (e <= 0) {
                            throw new ArgumentOutOfRangeException(1, "bufferSize");
                        }
                        if (!c.canWrite) {
                            throw new ArgumentException(1, "Can not write to stream");
                        }
                        this.a6 = c;
                        this.bb(d, e);
                    }
                    break;
            }
        }
        bb(a, b) {
            this.a8 = a;
            this.a1 = this.a0 = 0;
            let c = Math.max(b, 256);
            this.av = new Array(c);
            this.au = new Array(a.getMaxByteCount(c));
            if (this.a6.canSeek && this.a6.position > 0) {
                this.az = true;
            }
        }
        get_aw() {
            return this.ay;
        }
        set_aw(a) {
            this.ay = a;
            if (this.ay) {
                this.k();
            }
        }
        get aw() {
            return this.get_aw();
        }
        set aw(a) {
            this.set_aw(a);
        }
        get_a5() {
            return this.a6;
        }
        get a5() {
            return this.get_a5();
        }
        get_h() {
            return this.a8;
        }
        get h() {
            return this.get_h();
        }
        dispose1(a) {
            let b = null;
            if (!this.ax && a && this.a6 != null) {
                try {
                    this.k();
                }
                catch (c) {
                    b = c;
                }
                this.ax = true;
                try {
                    this.a6.close();
                }
                catch (d) {
                    if (b == null) {
                        b = d;
                    }
                }
            }
            this.a6 = null;
            this.au = null;
            this.a8 = null;
            this.av = null;
            if (b != null) {
                throw b;
            }
        }
        k() {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            this.a9();
            if (this.a0 > 0) {
                this.ba();
                this.a6.flush();
            }
        }
        ba() {
            if (!this.az && this.a0 > 0) {
                let a = this.a8.getPreamble();
                if (a.length > 0) {
                    this.a6.write(a, 0, a.length);
                }
                this.az = true;
            }
            this.a6.write(this.au, 0, this.a0);
            this.a0 = 0;
        }
        a9() {
            if (this.a0 > 0) {
                this.ba();
            }
            if (this.a1 > 0) {
                let a = this.a8.getBytes2(this.av, 0, this.a1, this.au, this.a0);
                this.a0 += a;
                this.a1 = 0;
            }
        }
        m(a, b, c) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "index", "< 0");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "< 0");
            }
            if (b > a.length - c) {
                throw new ArgumentException(1, "index + count > buffer.Length");
            }
            this.bc(a, b, c);
            if (this.ay) {
                this.k();
            }
        }
        bc(a, b, c) {
            while (c > 0) {
                let d = this.av.length - this.a1;
                if (d == 0) {
                    this.a9();
                    d = this.av.length;
                }
                if (d > c) {
                    d = c;
                }
                arrayCopy1(a, b, this.av, this.a1, d);
                c -= d;
                b += d;
                this.a1 += d;
            }
        }
        bd(a) {
            let b = a.length;
            let c = 0;
            while (b > 0) {
                let d = this.av.length - this.a1;
                if (d == 0) {
                    this.a9();
                    d = this.av.length;
                }
                if (d > b) {
                    d = b;
                }
                for (let e = 0; e < d; e++) {
                    this.av[e + this.a1] = a.charAt(e + c);
                }
                b -= d;
                c += d;
                this.a1 += d;
            }
        }
        o(a) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (this.a1 >= this.av.length) {
                this.a9();
            }
            this.av[this.a1++] = a;
            if (this.ay) {
                this.k();
            }
        }
        l(a) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (a != null) {
                this.bc(a, 0, a.length);
            }
            if (this.ay) {
                this.k();
            }
        }
        v(a) {
            if (this.ax) {
                throw new ObjectDisposedException(0, "StreamWriter");
            }
            if (a != null) {
                this.bd(a);
            }
            if (this.ay) {
                this.k();
            }
        }
        i() {
            this.dispose1(true);
        }
    }
    StreamWriter.$t = /*@__PURE__*/ markType(StreamWriter, 'StreamWriter', TextWriter.$);
    StreamWriter.a7 = /*@__PURE__*/ new StreamWriter(2, /*@__PURE__*/ new NullStream(), Encoding.uTF8Unmarked, 1);
    return StreamWriter;
})();

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlTextWriter_StringUtil = /*@__PURE__*/ (() => {
    class XmlTextWriter_StringUtil extends Base {
        static d(a, b) {
            return XmlTextWriter_StringUtil.a.indexOf1(a, b);
        }
        static c(a, b) {
            return XmlTextWriter_StringUtil.a.compare4(a, b);
        }
        static e(a, ...b) {
            return stringFormat2(XmlTextWriter_StringUtil.b, a, ...b);
        }
    }
    XmlTextWriter_StringUtil.$t = /*@__PURE__*/ markType(XmlTextWriter_StringUtil, 'XmlTextWriter_StringUtil');
    XmlTextWriter_StringUtil.b = CultureInfo.invariantCulture;
    XmlTextWriter_StringUtil.a = CultureInfo.invariantCulture.compareInfo;
    return XmlTextWriter_StringUtil;
})();

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlReader = /*@__PURE__*/ (() => {
    class XmlReader extends Base {
        constructor() {
            super();
            this.at = null;
        }
        get_a() {
            return false;
        }
        get a() {
            return this.get_a();
        }
        get_b() {
            return false;
        }
        get b() {
            return this.get_b();
        }
        get_c() {
            return false;
        }
        get c() {
            return this.get_c();
        }
        get_e() {
            return this.w > 0;
        }
        get e() {
            return this.get_e();
        }
        static j(a) {
            return a != null && XmlChar.g(a);
        }
        static k(a) {
            return a != null && XmlChar.k(a);
        }
        l() {
            return (this.a6() == 1);
        }
        m(a) {
            if (!this.l()) {
                return false;
            }
            return (this.ai == a);
        }
        n(a, b) {
            if (!this.l()) {
                return false;
            }
            return (this.ag == a && this.aj == b);
        }
        g(a) {
            switch (a) {
                case 3: return true;
                case 4: return true;
                case 1: return true;
                case 15: return true;
                case 5: return true;
                case 16: return true;
            }
            return false;
        }
        a6() {
            switch (this.a3) {
                case 0:
                case 1: break;
                default: return this.a7;
            }
            if (this.a7 == 2) {
                this.q();
            }
            do {
                if (this.g(this.a7)) {
                    return this.a7;
                }
                this.t();
            } while (!this.d);
            return 0;
        }
        al() {
            if (this.a6() != 1) {
                let a = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(a);
            }
            let b = stringEmpty();
            if (!this.i) {
                this.t();
                b = this.aq();
                if (this.a7 != 15) {
                    let c = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                    throw this.a4(c);
                }
            }
            this.t();
            return b;
        }
        am(a) {
            if (this.a6() != 1) {
                let b = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(b);
            }
            if (a != this.ai) {
                let c = stringFormat("The {0} tag from namespace {1} is expected.", this.ai, this.aj);
                throw this.a4(c);
            }
            let d = stringEmpty();
            if (!this.i) {
                this.t();
                d = this.aq();
                if (this.a7 != 15) {
                    let e = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                    throw this.a4(e);
                }
            }
            this.t();
            return d;
        }
        an(a, b) {
            if (this.a6() != 1) {
                let c = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(c);
            }
            if (a != this.ag || this.aj != b) {
                let d = stringFormat("The {0} tag from namespace {1} is expected.", this.ag, this.aj);
                throw this.a4(d);
            }
            let e = stringEmpty();
            if (!this.i) {
                this.t();
                e = this.aq();
                if (this.a7 != 15) {
                    let f = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                    throw this.a4(f);
                }
            }
            this.t();
            return e;
        }
        ax() {
            if (this.a6() != 15) {
                let a = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(a);
            }
            this.t();
        }
        ao() {
            if (this.a3 != 1 || this.a7 == 15) {
                return stringEmpty();
            }
            if (this.i) {
                this.t();
                return stringEmpty();
            }
            let a = new StringWriter(0);
            let b = new XmlTextWriter(1, a);
            if (this.a7 == 1) {
                let c = this.x;
                this.t();
                while (c < this.x) {
                    if (this.a3 != 1) {
                        throw this.a4("Unexpected end of the XML reader.");
                    }
                    b.ac(this, false);
                }
                this.t();
            }
            else {
                b.ac(this, false);
            }
            return a.toString();
        }
        ap() {
            if (this.a3 != 1 || this.a7 == 15) {
                return stringEmpty();
            }
            switch (this.a7) {
                case 1:
                case 2:
                    let a = new StringWriter(0);
                    let b = new XmlTextWriter(1, a);
                    b.ac(this, false);
                    return a.toString();
                default:
                    this.a2();
                    return stringEmpty();
            }
        }
        ay() {
            if (this.a6() != 1) {
                let a = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(a);
            }
            this.t();
        }
        az(a) {
            if (this.a6() != 1) {
                let b = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(b);
            }
            if (a != this.ai) {
                let c = stringFormat("The {0} tag from namespace {1} is expected.", this.ai, this.aj);
                throw this.a4(c);
            }
            this.t();
        }
        a0(a, b) {
            if (this.a6() != 1) {
                let c = stringFormat("'{0}' is an invalid node type.", EnumUtil.getName(XmlNodeType_$type, this.a7));
                throw this.a4(c);
            }
            if (a != this.ag || this.aj != b) {
                let d = stringFormat1("Expecting {0} tag from namespace {1}, got {2} and {3} instead", a, b, this.ag, this.aj);
                throw this.a4(d);
            }
            this.t();
        }
        aq() {
            if (this.at == null) {
                this.at = new StringBuilder(0);
            }
            this.at.c = 0;
            this.q();
            switch (this.a7) {
                default: return stringEmpty();
                case 1:
                    if (this.i) {
                        return stringEmpty();
                    }
                    do {
                        this.t();
                        switch (this.a7) {
                            case 3:
                            case 4:
                            case 13:
                            case 14:
                                this.at.l(this.ar);
                                continue;
                        }
                        break;
                    } while (true);
                    break;
                case 3:
                case 4:
                case 13:
                case 14:
                    do {
                        switch (this.a7) {
                            case 3:
                            case 4:
                            case 13:
                            case 14:
                                this.at.l(this.ar);
                                this.t();
                                continue;
                        }
                        break;
                    } while (true);
                    break;
            }
            let a = this.at.toString();
            this.at.c = 0;
            return a;
        }
        y(a, b, c) {
            throw new NotSupportedException(0);
        }
        a2() {
            if (this.a3 != 1) {
                return;
            }
            this.q();
            if (this.a7 != 1 || this.i) {
                this.t();
                return;
            }
            let a = this.x;
            while (this.t() && a < this.x) {
                ;
            }
            if (this.a7 == 15) {
                this.t();
            }
        }
        a4(a) {
            return new XmlException(2, typeCast(IXmlLineInfo_$type, this), this.z, a);
        }
        dispose() {
            this.disposeCore(true);
        }
        disposeCore(a) {
            if (a && this.a3 != 4) {
                this.au();
            }
        }
    }
    XmlReader.$t = /*@__PURE__*/ markType(XmlReader, 'XmlReader', Base.$, [IDisposable_$type]);
    return XmlReader;
})();
/**
 * @hidden
 */
let XmlWriter = /*@__PURE__*/ (() => {
    class XmlWriter extends Base {
        constructor() {
            super();
        }
        DisposeImpl(a) {
            this.c();
        }
        dispose() {
            this.DisposeImpl(false);
        }
        f(a, b) {
            if (!b && a.h) {
                return;
            }
            this.aj(a.ak, a.ag, a.aj);
            while (a.u()) {
                switch (a.a7) {
                    case 3:
                        this.ap(a.ar);
                        break;
                    case 5:
                        this.w(a.ai);
                        break;
                }
            }
            this.t();
        }
        g(a, b) {
            if (a == null) {
                throw new ArgumentException(2, "null XmlReader specified.", "reader");
            }
            let t1 = a.a7;
            L0: while (true) {
                switch (t1) {
                    case 17:
                        this.h("version", a.item1("version"));
                        if (a.item1("encoding") != null) {
                            this.h("encoding", a.item1("encoding"));
                        }
                        if (a.item1("standalone") != null) {
                            this.h("standalone", a.item1("standalone"));
                        }
                        break;
                    case 1:
                        if (a.r()) {
                            t1 = 2;
                            continue L0;
                        }
                        break;
                    case 2:
                        do {
                            this.f(a, b);
                        } while (a.s());
                        a.q();
                        break;
                    default: throw new XmlException(3, "NodeType is not one of Element, Attribute, nor XmlDeclaration.");
                }
                break;
            }
        }
        h(a, b) {
            this.j("", a, null, b);
        }
        i(a, b, c) {
            this.j("", a, b, c);
        }
        j(a, b, c, d) {
            this.aj(a, b, c);
            if (d != null && d.length > 0) {
                this.ap(d);
            }
            this.t();
        }
        r(a, b) {
            this.am(a);
            if (b != null && b.length > 0) {
                this.ap(b);
            }
            this.v();
        }
        s(a, b, c) {
            this.an(a, b);
            if (c != null && c.length > 0) {
                this.ap(c);
            }
            this.v();
        }
        z(a) {
            XmlConvert.aq(a);
            this.ap(a);
        }
        ab(a) {
            let b = true;
            b = XmlChar.k(a);
            if (!b) {
                throw new ArgumentException(1, "Argument name is not a valid NMTOKEN.");
            }
            this.ap(a);
        }
        af(a, b) {
            if (a == null || a == stringEmpty()) {
                throw new ArgumentException(0);
            }
            if (b == null) {
                b = stringEmpty();
            }
            XmlConvert.ar(a);
            let c = b.length > 0 ? this.a(b) : stringEmpty();
            if (c == null) {
                throw new ArgumentException(1, stringFormat("Namespace '{0}' is not declared.", b));
            }
            if (c != stringEmpty()) {
                this.ap(c);
                this.ap(":");
                this.ap(a);
            }
            else {
                this.ap(a);
            }
        }
        ac(a, b) {
            if (a == null) {
                throw new ArgumentException(0);
            }
            if (a.a3 == 0) {
                a.t();
                do {
                    this.ac(a, b);
                } while (!a.d);
                return;
            }
            let t1 = a.a7;
            L0: while (true) {
                switch (t1) {
                    case 1:
                        this.ao(a.ak, a.ag, a.aj);
                        if (a.e) {
                            for (let c = 0; c < a.w; c++) {
                                a.aw(c);
                                this.f(a, b);
                            }
                            a.q();
                        }
                        if (a.i) {
                            this.v();
                        }
                        else {
                            let d = a.x;
                            a.t();
                            if (a.a7 != 15) {
                                do {
                                    this.ac(a, b);
                                } while (d < a.x);
                            }
                            this.x();
                        }
                        break;
                    case 2: return;
                    case 3:
                        this.ap(a.ar);
                        break;
                    case 4:
                        this.m(a.ar);
                        break;
                    case 5:
                        this.w(a.ai);
                        break;
                    case 17:
                    case 7:
                        this.ad(a.ai, a.ar);
                        break;
                    case 8:
                        this.p(a.ar);
                        break;
                    case 10:
                        this.q(a.ai, a.item1("PUBLIC"), a.item1("SYSTEM"), a.ar);
                        break;
                    case 14:
                        t1 = 13;
                        continue L0;
                    case 13:
                        this.ar(a.ar);
                        break;
                    case 15:
                        this.x();
                        break;
                    case 16: break;
                    case 0: break;
                    default: throw new XmlException(3, "Unexpected node " + a.ai + " of type " + enumGetBox(XmlNodeType_$type, a.a7));
                }
                break;
            }
            a.t();
        }
        ai(a, b) {
            this.aj(null, a, b);
        }
        am(a) {
            this.ao(null, a, null);
        }
        an(a, b) {
            this.ao(null, a, b);
        }
    }
    XmlWriter.$t = /*@__PURE__*/ markType(XmlWriter, 'XmlWriter', Base.$, [IDisposable_$type]);
    return XmlWriter;
})();
/**
 * @hidden
 */
let XmlTextWriter = /*@__PURE__*/ (() => {
    class XmlTextWriter extends XmlWriter {
        constructor(a, ..._rest) {
            super();
            this.bm = null;
            this.bp = null;
            this.bq = null;
            this.bo = null;
            this.bv = null;
            this.a4 = false;
            this.ax = false;
            this.az = true;
            this.a0 = false;
            this.a5 = true;
            this.cn = 0;
            this.ay = false;
            this.cj = 2;
            this.a3 = false;
            this.ck = 0;
            this.cm = 0;
            this.cl = null;
            this.bl = 0;
            this.au = new Array(10);
            this.be = new Array();
            this.bd = arrayListCreate();
            this.ci = 0;
            this.a1 = false;
            this.bj = 2;
            this.a9 = ' ';
            this.bs = "  ";
            this.bu = null;
            this.a2 = false;
            this.bb = '\"';
            this.a7 = false;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [new StreamWriter(1, c, d == null ? XmlTextWriter.by : d)];
                        {
                            let g = e[0];
                            if (g == null) {
                                throw new ArgumentNullException(0, "writer");
                            }
                            this.a0 = (g.h == null);
                            this.b3(g);
                            this.ax = true;
                        }
                        this.a0 = (d == null);
                        this.b3(this.bq);
                        this.ax = true;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        if (c == null) {
                            throw new ArgumentNullException(0, "writer");
                        }
                        this.a0 = (c.h == null);
                        this.b3(c);
                        this.ax = true;
                    }
                    break;
            }
        }
        b3(a) {
            if (a == null) {
                throw new ArgumentNullException(0, "writer");
            }
            let b = new NameTable();
            this.bq = a;
            if (typeCast(StreamWriter.$, a) !== null) {
                this.bm = a.a5;
            }
            this.bp = a;
            this.cl = new XmlNamespaceManager(b);
            this.bu = a.g;
            XmlTextWriter.aw = this.cj != 2 ? ['&', '<', '>', '\r', '\n'] : ['&', '<', '>'];
            XmlTextWriter.av = ['\"', '&', '<', '>', '\r', '\n'];
        }
        get ch() {
            return this.a1 ? 1 : 0;
        }
        set ch(a) {
            this.a1 = (a == 1);
        }
        get bk() {
            return this.bj;
        }
        set bk(a) {
            if (a < 0) {
                throw this.bf("Indentation must be non-negative integer.");
            }
            this.bj = a;
            this.bs = a == 0 ? stringEmpty() : stringCreateFromChar(this.a9, this.bj);
        }
        get ba() {
            return this.a9;
        }
        set ba(a) {
            this.a9 = a;
            this.bs = stringCreateFromChar(this.a9, this.bj);
        }
        get bc() {
            return this.bb;
        }
        set bc(a) {
            if (this.ck == 3) {
                throw this.bh("QuoteChar must not be changed inside attribute value.");
            }
            if ((a != '\'') && (a != '\"')) {
                throw this.bf("Only ' and \" are allowed as an attribute quote character.");
            }
            this.bb = a;
            XmlTextWriter.av[0] = this.bb;
        }
        get_b() {
            return this.bl == 0 ? null : this.au[this.bl - 1].f;
        }
        get b() {
            return this.get_b();
        }
        get_at() {
            return this.bl == 0 ? 0 : this.au[this.bl - 1].g;
        }
        get at() {
            return this.get_at();
        }
        get_as() {
            return this.ck;
        }
        get as() {
            return this.get_as();
        }
        a(a) {
            if (a == null || a == stringEmpty()) {
                throw this.bf("The Namespace cannot be empty.");
            }
            if (a == this.cl.n) {
                return stringEmpty();
            }
            let b = this.cl.s(a, false);
            return b;
        }
        get bn() {
            return this.bm;
        }
        c() {
            if (this.ck == 3) {
                this.t();
            }
            while (this.bl > 0) {
                this.v();
            }
            if (this.az) {
                this.bq.i();
            }
            else {
                this.bq.k();
            }
            this.ck = 5;
        }
        e() {
            this.bq.k();
        }
        get a6() {
            return this.a5;
        }
        set a6(a) {
            if (this.ck != 0) {
                throw this.bh("This property must be set before writing output.");
            }
            this.a5 = a;
        }
        ak() {
            this.cg(false, false);
            this.a3 = true;
        }
        al(a) {
            this.cg(true, a);
            this.a3 = true;
        }
        cg(a, b) {
            if (this.ck != 0) {
                throw this.bi("XmlDeclaration");
            }
            switch (this.cn) {
                case 1: return;
                case 3: throw this.bh("WriteStartDocument cannot be called when ConformanceLevel is Fragment.");
            }
            this.ck = 1;
            this.bq.v("<?xml version=");
            this.bq.o(this.bb);
            this.bq.v("1.0");
            this.bq.o(this.bb);
            if (!this.a0) {
                this.bq.v(" encoding=");
                this.bq.o(this.bb);
                this.bq.v(this.bq.h.webName);
                this.bq.o(this.bb);
            }
            if (a) {
                this.bq.v(" standalone=");
                this.bq.o(this.bb);
                this.bq.v(b ? "yes" : "no");
                this.bq.o(this.bb);
            }
            this.bq.v("?>");
            this.cn = 1;
        }
        u() {
            switch (this.ck) {
                case 5:
                case 0: throw this.bi("EndDocument");
            }
            if (this.ck == 3) {
                this.t();
            }
            while (this.bl > 0) {
                this.v();
            }
            this.ck = 0;
            this.a3 = false;
        }
        q(a, b, c, d) {
            if (a == null) {
                throw this.bf("name");
            }
            if (!XmlChar.g(a)) {
                throw this.bf("name");
            }
            if (this.cm != 0) {
                throw this.bi("DocType");
            }
            this.cm = 10;
            if (this.cn == 2) {
                this.b4();
            }
            this.cd();
            this.bq.v("<!DOCTYPE ");
            this.bq.v(a);
            if (b != null) {
                this.bq.v(" PUBLIC ");
                this.bq.o(this.bb);
                this.bq.v(b);
                this.bq.o(this.bb);
                this.bq.o(' ');
                this.bq.o(this.bb);
                if (c != null) {
                    this.bq.v(c);
                }
                this.bq.o(this.bb);
            }
            else if (c != null) {
                this.bq.v(" SYSTEM ");
                this.bq.o(this.bb);
                this.bq.v(c);
                this.bq.o(this.bb);
            }
            if (d != null) {
                this.bq.v("[");
                this.bq.v(d);
                this.bq.v("]");
            }
            this.bq.o('>');
            this.ck = 1;
        }
        ao(a, b, c) {
            if (this.ck == 5) {
                throw this.bi("StartTag");
            }
            this.cm = 1;
            let d = (a == null);
            if (a == null) {
                a = stringEmpty();
            }
            if (!this.a5 && c != null && c.length > 0) {
                throw this.bf("Namespace is disabled in this XmlTextWriter.");
            }
            if (!this.a5 && a.length > 0) {
                throw this.bf("Namespace prefix is disabled in this XmlTextWriter.");
            }
            if (a.length > 0 && c == null) {
                c = this.cl.lookupNamespace1(a, false);
                if (c == null || c.length == 0) {
                    throw this.bf("Namespace URI must not be null when prefix is not an empty string.");
                }
            }
            if (this.a5 && a != null && a.length == 3 && c != "http://www.w3.org/XML/1998/namespace" && (a.charAt(0) == 'x' || a.charAt(0) == 'X') && (a.charAt(1) == 'm' || a.charAt(1) == 'M') && (a.charAt(2) == 'l' || a.charAt(2) == 'L')) {
                throw new ArgumentException(1, "A prefix cannot be equivalent to \"xml\" in case-insensitive match.");
            }
            if (this.cn == 2) {
                this.b4();
            }
            if (this.ck == 2) {
                this.b1();
            }
            if (this.bl > 0) {
                this.au[this.bl - 1].a = true;
            }
            this.cl.ac();
            if (this.a5 && c != null) {
                if (d && c.length > 0) {
                    a = this.a(c);
                }
                if (a == null || c.length == 0) {
                    a = stringEmpty();
                }
            }
            this.cd();
            this.bq.v("<");
            if (a.length > 0) {
                this.bq.v(a);
                this.bq.o(':');
            }
            this.bq.v(b);
            if (this.au.length == this.bl) {
                let e = new Array(this.bl << 1);
                arrayCopy2(this.au, e, this.bl);
                this.au = e;
            }
            if (this.au[this.bl] == null) {
                this.au[this.bl] = new XmlTextWriter_XmlNodeInfo();
            }
            let f = this.au[this.bl];
            f.e = a;
            f.c = b;
            f.d = c;
            f.b = false;
            f.a = false;
            f.f = this.b;
            f.g = this.at;
            this.bl++;
            if (this.a5 && c != null) {
                let g = this.cl.lookupNamespace1(a, false);
                if (g != c) {
                    this.cl.x(a, c);
                    this.be.push(a);
                }
            }
            this.ck = 2;
        }
        b1() {
            this.b2();
            if (this.ck == 2) {
                this.bq.o('>');
            }
            this.ck = 4;
        }
        b2() {
            if (this.ck == 3) {
                this.t();
            }
            if (this.be.length == 0) {
                if (this.bd.count > 0) {
                    this.bd.clear();
                }
                return;
            }
            let a = this.bd.count;
            while (this.be.length > 0) {
                let b = this.be.pop();
                let c = false;
                for (let d = 0; d < this.bd.count; d++) {
                    if (this.bd.item(d) == b) {
                        c = true;
                        break;
                    }
                }
                if (c) {
                    continue;
                }
                this.bd.add(b);
            }
            for (let e = a; e < this.bd.count; e++) {
                let f = this.bd.item(e);
                let g = this.cl.lookupNamespace1(f, false);
                if (g == null) {
                    continue;
                }
                if (f.length > 0) {
                    this.bq.v(" xmlns:");
                    this.bq.v(f);
                }
                else {
                    this.bq.v(" xmlns");
                }
                this.bq.o('=');
                this.bq.o(this.bb);
                this.cc(g, true);
                this.bq.o(this.bb);
            }
            this.bd.clear();
        }
        v() {
            this.ca(false);
        }
        x() {
            this.ca(true);
        }
        ca(a) {
            if (this.ck == 5) {
                throw this.bi("EndElement");
            }
            if (this.bl == 0) {
                throw this.bh("There is no more open element.");
            }
            this.b2();
            this.cl.h();
            if (this.ck == 2) {
                if (a) {
                    this.bq.o('>');
                }
                else {
                    this.bq.v(" />");
                }
            }
            if (a || this.ck == 4) {
                this.cf();
            }
            let b = this.au[--this.bl];
            if (a || this.ck == 4) {
                this.bq.v("</");
                if (b.e.length > 0) {
                    this.bq.v(b.e);
                    this.bq.o(':');
                }
                this.bq.v(b.c);
                this.bq.o('>');
            }
            this.ck = 4;
            if (this.bl == 0) {
                this.cm = 15;
            }
        }
        aj(a, b, c) {
            if (this.ck == 3) {
                this.t();
            }
            if (this.ck != 2 && this.ck != 0) {
                throw this.bi("Attribute");
            }
            if (a == null) {
                a = stringEmpty();
            }
            let d = false;
            if (c == "http://www.w3.org/2000/xmlns/") {
                d = true;
                if (a.length == 0 && b != "xmlns") {
                    a = "xmlns";
                }
            }
            else {
                d = (a == "xmlns" || b == "xmlns" && a.length == 0);
            }
            if (d) {
                if (b == null || b.length == 0) {
                    b = a;
                    a = stringEmpty();
                }
            }
            if (this.a5) {
                if (a == "xml") {
                    c = "http://www.w3.org/XML/1998/namespace";
                }
                else if (c == null || (this.a7 && c.length == 0)) {
                    if (d) {
                        c = "http://www.w3.org/2000/xmlns/";
                    }
                    else {
                        c = stringEmpty();
                    }
                }
                if (d && c != "http://www.w3.org/2000/xmlns/") {
                    throw this.bf(stringFormat("The 'xmlns' attribute is bound to the reserved namespace '{0}'", "http://www.w3.org/2000/xmlns/"));
                }
                if (a.length > 0 && c.length == 0) {
                    c = this.cl.lookupNamespace1(a, false);
                    if (c == null || c.length == 0) {
                        throw this.bf("Namespace URI must not be null when prefix is not an empty string.");
                    }
                }
                if (!d && c.length > 0) {
                    a = this.br(a, b, c);
                }
            }
            if (this.a2) {
                this.ce();
            }
            else if (this.ck != 0) {
                this.bq.o(' ');
            }
            if (a.length > 0) {
                this.bq.v(a);
                this.bq.o(':');
            }
            this.bq.v(b);
            this.bq.o('=');
            this.bq.o(this.bb);
            if (d || a == "xml") {
                if (this.bo == null) {
                    this.bo = new StringWriter(0);
                }
                else {
                    this.bo.av().c = 0;
                }
                this.bq = this.bo;
                if (!d) {
                    this.a4 = false;
                    this.bv = b;
                }
                else {
                    this.a4 = true;
                    this.bv = b == "xmlns" ? stringEmpty() : b;
                }
            }
            this.ck = 3;
        }
        br(a, b, c) {
            let d = false;
            if (a.length == 0) {
                a = this.a(c);
                if (a != null && a.length > 0) {
                    return a;
                }
                d = true;
            }
            else {
                a = this.cl.ag.b(a);
                let e = this.cl.lookupNamespace1(a, true);
                if (e == c) {
                    return a;
                }
                if (e != null) {
                    this.cl.ad(a, e);
                    if (this.cl.lookupNamespace1(a, true) != e) {
                        d = true;
                        this.cl.x(a, e);
                    }
                }
            }
            if (d) {
                a = this.bt(c, true);
            }
            this.be.push(a);
            this.cl.x(a, c);
            return a;
        }
        bt(a, b) {
            let c = b ? null : this.a(a);
            if (c != null && c.length > 0) {
                return c;
            }
            for (let d = 1;; d++) {
                c = XmlTextWriter_StringUtil.e("d{0}p{1}", this.bl, d);
                if (arrayContains(this.be, c)) {
                    continue;
                }
                if (null != this.cl.lookupNamespace(this.cl.ag.d(c))) {
                    continue;
                }
                this.cl.x(c, a);
                this.be.push(c);
                return c;
            }
        }
        t() {
            if (this.ck != 3) {
                throw this.bi("End of attribute");
            }
            if (this.bq == this.bo) {
                this.bq = this.bp;
                let a = this.bo.toString();
                if (this.a4) {
                    if (this.bv.length > 0 && a.length == 0) {
                        throw this.bf("Non-empty prefix must be mapped to non-empty namespace URI.");
                    }
                    let b = this.cl.lookupNamespace1(this.bv, false);
                    if ((this.ci & 1) == 0 || b != a) {
                        this.bd.add(this.bv);
                    }
                    if (this.bl > 0) {
                        if (this.a7 && this.au[this.bl - 1].e == this.bv && this.au[this.bl - 1].d != a) {
                            throw new XmlException(3, stringFormat("Cannot redefine the namespace for prefix '{0}' used at current element", this.bv));
                        }
                        if (this.au[this.bl - 1].d == stringEmpty() && this.au[this.bl - 1].e == this.bv) {
                            ;
                        }
                        else if (b != a) {
                            this.cl.x(this.bv, a);
                        }
                    }
                }
                else {
                    switch (this.bv) {
                        case "lang":
                            if (this.bl > 0) {
                                this.au[this.bl - 1].f = a;
                            }
                            break;
                        case "space":
                            switch (a) {
                                case "default":
                                    if (this.bl > 0) {
                                        this.au[this.bl - 1].g = 1;
                                    }
                                    break;
                                case "preserve":
                                    if (this.bl > 0) {
                                        this.au[this.bl - 1].g = 2;
                                    }
                                    break;
                                default: throw this.bf("Invalid value for xml:space.");
                            }
                            break;
                    }
                }
                this.bq.v(a);
            }
            this.bq.o(this.bb);
            this.ck = 2;
        }
        p(a) {
            if (a == null) {
                throw this.bf("text");
            }
            if (a.length > 0 && a.charAt(a.length - 1) == '-') {
                throw this.bf("An input string to WriteComment method must not end with '-'. Escape it with '&#2D;'.");
            }
            if (XmlTextWriter_StringUtil.d(a, "--") > 0) {
                throw this.bf("An XML comment cannot end with \"-\".");
            }
            if (this.ck == 3 || this.ck == 2) {
                this.b1();
            }
            this.cd();
            this.b6("Comment", false, false, false);
            this.bq.v("<!--");
            this.bq.v(a);
            this.bq.v("-->");
        }
        ad(a, b) {
            if (a == null) {
                throw this.bf("name");
            }
            if (b == null) {
                throw this.bf("text");
            }
            this.cd();
            if (!XmlChar.g(a)) {
                throw this.bf("A processing instruction name must be a valid XML name.");
            }
            if (XmlTextWriter_StringUtil.d(b, "?>") > 0) {
                throw this.bf("Processing instruction cannot contain \"?>\" as its value.");
            }
            this.b6("ProcessingInstruction", false, a == "xml", false);
            this.bq.v("<?");
            this.bq.v(a);
            this.bq.o(' ');
            this.bq.v(b);
            this.bq.v("?>");
            if (this.ck == 0) {
                this.ck = 1;
            }
        }
        ar(a) {
            if (a == null) {
                throw this.bf("text");
            }
            if (a.length == 0 || XmlChar.u(a) >= 0) {
                throw this.bf("WriteWhitespace method accepts only whitespaces.");
            }
            this.b6("Whitespace", true, false, true);
            this.bq.v(a);
        }
        m(a) {
            if (a == null) {
                a = stringEmpty();
            }
            this.b5("CData", false);
            if (XmlTextWriter_StringUtil.d(a, "]]>") >= 0) {
                throw this.bf("CDATA section must not contain ']]>'.");
            }
            this.bq.v("<![CDATA[");
            this.b9(a);
            this.bq.v("]]>");
        }
        ap(a) {
            if (a == null || (a.length == 0 && !this.a7)) {
                return;
            }
            this.b5("Text", true);
            this.cc(a, this.ck == 3);
        }
        ah(a) {
            if (a == null) {
                return;
            }
            this.b6("Raw string", true, true, true);
            this.bq.v(a);
        }
        n(a) {
            this.b7(a, '\0', false);
        }
        aq(a, b) {
            this.b7(a, b, true);
        }
        b7(a, b, c) {
            if (c && ('�'.charCodeAt(0) > b.charCodeAt(0) || b.charCodeAt(0) > '�'.charCodeAt(0) || '�'.charCodeAt(0) > a.charCodeAt(0) || a.charCodeAt(0) > '�'.charCodeAt(0))) {
                throw this.bf(stringFormat("Invalid surrogate pair was found. Low: &#x{0:X}; High: &#x{0:X};", a.charCodeAt(0), b.charCodeAt(0)));
            }
            else if (this.ay && XmlChar.f(a.charCodeAt(0))) {
                throw this.bf(stringFormat("Invalid character &#x{0:X};", a.charCodeAt(0)));
            }
            this.b5("Character", true);
            let d = c ? (b.charCodeAt(0) - 55296) * 1024 + a.charCodeAt(0) - 56320 + 65536 : a.charCodeAt(0);
            this.bq.v("&#x");
            this.bq.v(intToString1(d, "X", CultureInfo.invariantCulture));
            this.bq.o(';');
        }
        w(a) {
            if (a == null) {
                throw this.bf("name");
            }
            if (!XmlChar.g(a)) {
                throw this.bf("Argument name must be a valid XML name.");
            }
            this.b5("Entity reference", true);
            this.bq.o('&');
            this.bq.v(a);
            this.bq.o(';');
        }
        y(a) {
            if (a == null) {
                throw this.bf("name");
            }
            if (!XmlChar.g(a)) {
                throw this.bf("Not a valid name string.");
            }
            this.ap(a);
        }
        aa(a) {
            if (a == null) {
                throw this.bf("nmtoken");
            }
            if (!XmlChar.k(a)) {
                throw this.bf("Not a valid NMTOKEN string.");
            }
            this.ap(a);
        }
        ae(a, b) {
            if (a == null) {
                throw this.bf("localName");
            }
            if (b == null) {
                b = stringEmpty();
            }
            if (b == "http://www.w3.org/2000/xmlns/") {
                throw this.bf("Prefix 'xmlns' is reserved and cannot be overriden.");
            }
            if (!XmlChar.i(a)) {
                throw this.bf("localName must be a valid NCName.");
            }
            this.b5("QName", true);
            let c = b.length > 0 ? this.a(b) : stringEmpty();
            if (c == null) {
                if (this.ck == 3) {
                    c = this.bt(b, false);
                }
                else {
                    throw this.bf(stringFormat("Namespace '{0}' is not declared.", b));
                }
            }
            if (c != stringEmpty()) {
                this.bq.v(c);
                this.bq.v(":");
            }
            this.bq.v(a);
        }
        bz(a, b, c) {
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (b < 0 || a.length < b) {
                throw this.bg("index");
            }
            if (c < 0 || a.length < b + c) {
                throw this.bg("count");
            }
        }
        k(a, b, c) {
            throw new NotImplementedException(1, "WriteBase64 not implemented");
        }
        l(a, b, c) {
            this.bz(a, b, c);
            this.b5("BinHex", true);
            XmlConvert.ay(a, b, c, this.bq);
        }
        o(a, b, c) {
            this.bz(a, b, c);
            this.b5("Chars", true);
            this.cb(a, b, c, this.ck == 3);
        }
        ag(a, b, c) {
            this.bz(a, b, c);
            this.b5("Raw text", false);
            this.bq.m(a, b, c);
        }
        cd() {
            this.a8(0, false);
        }
        cf() {
            this.a8(-1, false);
        }
        ce() {
            if (!this.a8(0, true)) {
                this.bq.o(' ');
            }
        }
        a8(a, b) {
            if (!this.a1) {
                return false;
            }
            for (let c = this.bl - 1; c >= 0; c--) {
                if (!b && this.au[c].b) {
                    return false;
                }
            }
            if (this.ck != 0) {
                this.bq.v(this.bu);
            }
            for (let d = 0; d < this.bl + a; d++) {
                this.bq.v(this.bs);
            }
            return true;
        }
        b4() {
            if (this.ck != 0) {
                return;
            }
            this.cg(false, false);
        }
        b6(a, b, c, d) {
            let t1 = this.ck;
            L0: while (true) {
                switch (t1) {
                    case 5: throw this.bi(a);
                    case 0:
                        if (d) {
                            this.b0();
                        }
                        if (this.cn == 2 && !c) {
                            this.b4();
                        }
                        this.ck = 1;
                        break;
                    case 3:
                        if (b) {
                            break;
                        }
                        t1 = 5;
                        continue L0;
                    case 2:
                        if (d) {
                            this.b0();
                        }
                        this.b1();
                        break;
                    case 4:
                        if (d) {
                            this.b0();
                        }
                        break;
                }
                break;
            }
        }
        b0() {
            if (this.bl > 0) {
                this.au[this.bl - 1].b = true;
            }
        }
        b5(a, b) {
            let t1 = this.ck;
            L0: while (true) {
                switch (t1) {
                    case 5: throw this.bi(a);
                    case 1:
                    case 0:
                        if (!this.ax || this.a3) {
                            t1 = 5;
                            continue L0;
                        }
                        if (this.cn == 2) {
                            this.b4();
                        }
                        this.b0();
                        this.ck = 4;
                        break;
                    case 3:
                        if (b) {
                            break;
                        }
                        t1 = 5;
                        continue L0;
                    case 2:
                        this.b1();
                        this.b0();
                        break;
                    case 4:
                        this.b0();
                        break;
                }
                break;
            }
        }
        cc(a, b) {
            let c = b ? XmlTextWriter.av : XmlTextWriter.aw;
            let d = indexOfAny(a, c);
            if (d >= 0) {
                let e = stringToCharArray(a);
                this.b8(e, 0, d);
                this.cb(e, d, e.length - d, b);
            }
            else {
                this.b9(a);
            }
        }
        b9(a) {
            let b = XmlChar.t(a, true);
            if (b >= 0) {
                let c = stringToCharArray(a);
                this.bq.m(c, 0, b);
                this.b8(c, b, c.length - b);
            }
            else {
                this.bq.v(a);
            }
        }
        b8(a, b, c) {
            let d = b;
            let e = b + c;
            while ((b = XmlChar.s(a, d, c, true)) >= 0) {
                if (this.ay) {
                    throw this.bf(stringFormat("Input contains invalid character at {0} : &#x{1:X};", b, a[b].charCodeAt(0)));
                }
                if (d < b) {
                    this.bq.m(a, d, b - d);
                }
                this.bq.v("&#x");
                this.bq.v(intToString1(a[b].charCodeAt(0), "X", CultureInfo.invariantCulture));
                this.bq.o(';');
                c -= b - d + 1;
                d = b + 1;
            }
            if (d < e) {
                this.bq.m(a, d, e - d);
            }
        }
        cb(a, b, c, d) {
            let e = b;
            let f = b + c;
            L0: for (let g = e; g < f; g++) {
                let t1 = a[g];
                L1: while (true) {
                    switch (t1) {
                        default: continue L0;
                        case '&':
                        case '<':
                        case '>':
                            if (e < g) {
                                this.b8(a, e, g - e);
                            }
                            this.bq.o('&');
                            switch (a[g]) {
                                case '&':
                                    this.bq.v("amp;");
                                    break;
                                case '<':
                                    this.bq.v("lt;");
                                    break;
                                case '>':
                                    this.bq.v("gt;");
                                    break;
                                case '\'':
                                    this.bq.v("apos;");
                                    break;
                                case '\"':
                                    this.bq.v("quot;");
                                    break;
                            }
                            break;
                        case '\"':
                        case '\'':
                            if (d && a[g] == this.bb) {
                                t1 = '&';
                                continue L1;
                            }
                            continue L0;
                        case '\r':
                            if (g + 1 < f && a[g] == '\n') {
                                g++;
                            }
                            t1 = '\n';
                            continue L1;
                        case '\n':
                            if (e < g) {
                                this.b8(a, e, g - e);
                            }
                            if (d) {
                                this.bq.v(a[g] == '\r' ? "&#xD;" : "&#xA;");
                                break;
                            }
                            switch (this.cj) {
                                case 1:
                                    this.bq.v(a[g] == '\r' ? "&#xD;" : "&#xA;");
                                    break;
                                case 0:
                                    this.bq.v(this.bu);
                                    break;
                                default:
                                    this.bq.o(a[g]);
                                    break;
                            }
                            break;
                    }
                    break;
                }
                e = g + 1;
            }
            if (e < f) {
                this.b8(a, e, f - e);
            }
        }
        bg(a) {
            return new ArgumentOutOfRangeException(1, a);
        }
        bf(a) {
            return new ArgumentException(1, a);
        }
        bh(a) {
            return new InvalidOperationException(1, a);
        }
        bi(a) {
            return this.bh(stringFormat("This XmlWriter does not accept {0} at this state {1}.", a, enumGetBox(WriteState_$type, this.ck)));
        }
    }
    XmlTextWriter.$t = /*@__PURE__*/ markType(XmlTextWriter, 'XmlTextWriter', XmlWriter.$);
    XmlTextWriter.by = /*@__PURE__*/ new UTF8Encoding(0, false, false);
    XmlTextWriter.aw = null;
    XmlTextWriter.av = null;
    return XmlTextWriter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

//
/**
 * @hidden
 */
let XmlTextReader_DtdInputState_$type = /*@__PURE__*/ markEnum('XmlTextReader_DtdInputState', 'Free,1|ElementDecl,2|AttlistDecl,3|EntityDecl,4|NotationDecl,5|PI,6|Comment,7|InsideSingleQuoted,8|InsideDoubleQuoted,9');

//
/**
 * @hidden
 */
let XmlTextReader_DtdInputStateStack = /*@__PURE__*/ (() => {
    class XmlTextReader_DtdInputStateStack extends Base {
        constructor() {
            super();
            this.a = new Array();
            this.b(1);
        }
        c() {
            return EnumUtil.getEnumValue(XmlTextReader_DtdInputState_$type, arrayLast(this.a));
        }
        d() {
            return EnumUtil.getEnumValue(XmlTextReader_DtdInputState_$type, this.a.pop());
        }
        b(a) {
            this.a.push(enumGetBox(XmlTextReader_DtdInputState_$type, a));
        }
    }
    XmlTextReader_DtdInputStateStack.$t = /*@__PURE__*/ markType(XmlTextReader_DtdInputStateStack, 'XmlTextReader_DtdInputStateStack');
    return XmlTextReader_DtdInputStateStack;
})();

//
/**
 * @hidden
 */
let XmlResolver = /*@__PURE__*/ (() => {
    class XmlResolver extends Base {
        d(a, b) {
            if (a == null) {
                if (b == null) {
                    throw new ArgumentNullException(0, "Either baseUri or relativeUri are required.");
                }
                if (stringStartsWith(b, "http:") || stringStartsWith(b, "https:") || stringStartsWith(b, "ftp:") || stringStartsWith(b, "file:")) {
                    return new Uri(0, b);
                }
                throw new InvalidOperationException(1, b + " not supported");
            }
            if (b == null) {
                return a;
            }
            return new Uri(3, a, this.c(b));
        }
        c(a) {
            return stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(a, "<", "%3C"), ">", "%3E"), "#", "%23"), "%", "%25"), "\"", "%22");
        }
    }
    XmlResolver.$t = /*@__PURE__*/ markType(XmlResolver, 'XmlResolver');
    return XmlResolver;
})();

// System.Xml.XmlUrlResolver.cs
/**
 * @hidden
 */
let XmlUrlResolver = /*@__PURE__*/ (() => {
    class XmlUrlResolver extends XmlResolver {
        constructor() {
            super();
            this.e = null;
        }
        set_a(a) {
            this.e = a;
        }
        set a(a) {
            this.set_a(a);
        }
        b(a, b, c) {
            throw new NotImplementedException(0);
        }
        f(a) {
            return stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(stringReplace(a, "%3C", "<"), "%3E", ">"), "%23", "#"), "%22", "\""), "%20", " "), "%25", "%");
        }
    }
    XmlUrlResolver.$t = /*@__PURE__*/ markType(XmlUrlResolver, 'XmlUrlResolver', XmlResolver.$);
    return XmlUrlResolver;
})();

//
/**
 * @hidden
 */
let NonBlockingStreamReader = /*@__PURE__*/ (() => {
    class NonBlockingStreamReader extends TextReader {
        constructor(a, b) {
            super();
            this.l = null;
            this.k = null;
            this.p = 0;
            this.u = 0;
            this.o = 0;
            this.z = null;
            this.x = null;
            this.w = null;
            this.n = false;
            this.ab = null;
            this.m = false;
            let c = 1024;
            this.w = a;
            this.l = new Array(c);
            this.o = c;
            this.z = b;
            this.x = this.y();
            this.k = new Array(b.getMaxCharCount(c));
            this.p = 0;
            this.u = 0;
        }
        y() {
            return this.z.getDecoder();
        }
        get aa() {
            return this.z;
        }
        i() {
            this.dispose1(true);
        }
        dispose1(a) {
            if (a && this.w != null) {
                this.w.close();
            }
            this.l = null;
            this.k = null;
            this.z = null;
            this.x = null;
            this.w = null;
            super.dispose1(a);
        }
        ac() {
            this.u = this.p = 0;
            this.n = false;
            this.x = this.y();
        }
        v() {
            this.u = 0;
            let a = 0;
            this.p = 0;
            let b = 0;
            do {
                a = this.w.read(this.l, 0, this.o);
                if (a == 0) {
                    return 0;
                }
                this.n = (a < this.o);
                this.p += this.x.c(this.l, b, a, this.k, 0);
                b = 0;
            } while (this.p == 0);
            return this.p;
        }
        a() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (this.u >= this.p && (this.n || this.v() == 0)) {
                return -1;
            }
            return this.k[this.u].charCodeAt(0);
        }
        b() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (this.u >= this.p && this.v() == 0) {
                return -1;
            }
            return this.k[this.u++].charCodeAt(0);
        }
        c(a, b, c) {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (a == null) {
                throw new ArgumentNullException(0, "dest_buffer");
            }
            if (b < 0) {
                throw new ArgumentOutOfRangeException(2, "index", "< 0");
            }
            if (c < 0) {
                throw new ArgumentOutOfRangeException(2, "count", "< 0");
            }
            if (b > a.length - c) {
                throw new ArgumentException(1, "index + count > dest_buffer.Length");
            }
            let d = 0;
            {
                if (this.u >= this.p && this.v() == 0) {
                    return d > 0 ? d : 0;
                }
                let e = Math.min(this.p - this.u, c);
                arrayCopy1(this.k, this.u, a, b, e);
                this.u += e;
                b += e;
                c -= e;
                d += e;
            }
            return d;
        }
        s() {
            let a = '\0';
            for (; this.u < this.p; this.u++) {
                a = this.k[this.u];
                if (a == '\n') {
                    this.u++;
                    let b = (this.m) ? (this.u - 2) : (this.u - 1);
                    if (b < 0) {
                        b = 0;
                    }
                    this.m = false;
                    return b;
                }
                else if (this.m) {
                    this.m = false;
                    return this.u - 1;
                }
                this.m = (a == '\r');
            }
            return -1;
        }
        g() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            if (this.u >= this.p && this.v() == 0) {
                return null;
            }
            let a = this.u;
            let b = this.s();
            if (b < this.p && b >= a) {
                return stringCreateFromCharArraySlice(this.k, a, b - a);
            }
            if (this.ab == null) {
                this.ab = new StringBuilder(0);
            }
            else {
                this.ab.c = 0;
            }
            while (true) {
                if (this.m) {
                    this.p--;
                }
                this.ab.l(stringCreateFromCharArraySlice(this.k, a, this.p - a));
                if (this.v() == 0) {
                    if (this.ab.b > 32768) {
                        let c = this.ab;
                        this.ab = null;
                        return c.f(0, c.c);
                    }
                    return this.ab.f(0, this.ab.c);
                }
                a = this.u;
                b = this.s();
                if (b < this.p && b >= a) {
                    this.ab.l(stringCreateFromCharArraySlice(this.k, a, b - a));
                    if (this.ab.b > 32768) {
                        let d = this.ab;
                        this.ab = null;
                        return d.f(0, d.c);
                    }
                    return this.ab.f(0, this.ab.c);
                }
            }
        }
        h() {
            if (this.w == null) {
                throw new ObjectDisposedException(1, "StreamReader", "Cannot read from a closed StreamReader");
            }
            let a = new StringBuilder(0);
            let b = this.k.length;
            let c = new Array(b);
            let d;
            while ((d = this.c(c, 0, b)) != 0) {
                a.g(c, 0, d);
            }
            return a.toString();
        }
    }
    NonBlockingStreamReader.$t = /*@__PURE__*/ markType(NonBlockingStreamReader, 'NonBlockingStreamReader', TextReader.$);
    return NonBlockingStreamReader;
})();

//
/**
 * @hidden
 */
let XmlInputStream = /*@__PURE__*/ (() => {
    class XmlInputStream extends Stream {
        constructor(a) {
            super();
            this.w = null;
            this.t = null;
            this.o = null;
            this.p = 0;
            this.q = 0;
            this.y(a);
        }
        static staticInit() {
            XmlInputStream.strictUTF8 = new UTF8Encoding(0, false, true);
        }
        u(a, b) {
            let c = this.q;
            while (this.q < a + b) {
                if (this.r() < 0) {
                    return null;
                }
            }
            this.q = c;
            return Encoding.aSCII.getString1(this.o, a, b);
        }
        y(a) {
            this.o = new Array(6);
            this.t = a;
            this.w = XmlInputStream.strictUTF8;
            this.p = a.read(this.o, 0, this.o.length);
            if (this.p == -1 || this.p == 0) {
                return;
            }
            let b = this.r();
            switch (b) {
                case 255:
                    b = this.r();
                    if (b == 254) {
                        this.w = Encoding.unicode;
                    }
                    else {
                        this.q = 0;
                    }
                    break;
                case 254:
                    b = this.r();
                    if (b == 255) {
                        this.w = Encoding.bigEndianUnicode;
                        return;
                    }
                    else {
                        this.q = 0;
                    }
                    break;
                case 239:
                    b = this.r();
                    if (b == 187) {
                        b = this.r();
                        if (b != 191) {
                            this.q = 0;
                        }
                    }
                    else {
                        this.o[--this.q] = 239;
                    }
                    break;
                case '<'.charCodeAt(0):
                    if (this.p >= 5 && this.u(1, 4) == "?xml") {
                        this.q += 4;
                        b = this.s();
                        if (b == 'v'.charCodeAt(0)) {
                            while (b >= 0) {
                                b = this.r();
                                if (b == '0'.charCodeAt(0)) {
                                    this.r();
                                    break;
                                }
                            }
                            b = this.s();
                        }
                        if (b == 'e'.charCodeAt(0)) {
                            if (this.u(this.q, 7) == "ncoding") {
                                this.q += 7;
                                b = this.s();
                                if (b != '='.charCodeAt(0)) {
                                    throw XmlInputStream.z;
                                }
                                b = this.s();
                                let c = b;
                                let d = new StringBuilder(0);
                                while (true) {
                                    b = this.r();
                                    if (b == c) {
                                        break;
                                    }
                                    else if (b < 0) {
                                        throw XmlInputStream.z;
                                    }
                                    d.h(String.fromCharCode(b));
                                }
                                let e = d.toString();
                                if (!XmlChar.o(e)) {
                                    throw XmlInputStream.z;
                                }
                                this.w = Encoding.getEncoding(e);
                            }
                        }
                    }
                    this.q = 0;
                    break;
                default:
                    this.q = 0;
                    break;
            }
        }
        r() {
            if (this.p > this.q) {
                return this.o[this.q++];
            }
            let a = new Array(this.o.length * 2);
            Buffer.c(this.o, 0, a, 0, this.p);
            let b = this.t.read(a, this.p, this.o.length);
            if (b == -1 || b == 0) {
                return -1;
            }
            this.p += b;
            this.o = a;
            return this.o[this.q++];
        }
        s() {
            let a;
            L0: while (true) {
                a = this.r();
                let t1 = String.fromCharCode(a);
                L1: while (true) {
                    switch (t1) {
                        case '\r':
                            t1 = ' ';
                            continue L1;
                        case '\n':
                            t1 = ' ';
                            continue L1;
                        case '\t':
                            t1 = ' ';
                            continue L1;
                        case ' ': continue L0;
                        default: return a;
                    }
                    break;
                }
            }
        }
        get actualEncoding() {
            return this.w;
        }
        get_canRead() {
            if (this.p > this.q) {
                return true;
            }
            else {
                return this.t.canRead;
            }
        }
        get canRead() {
            return this.get_canRead();
        }
        get_canSeek() {
            return false;
        }
        get canSeek() {
            return this.get_canSeek();
        }
        get_canWrite() {
            return false;
        }
        get canWrite() {
            return this.get_canWrite();
        }
        get_length() {
            return this.t.length;
        }
        get length() {
            return this.get_length();
        }
        get_position() {
            return this.t.position - this.p + this.q;
        }
        set_position(a) {
            if (a < this.p) {
                this.q = a;
            }
            else {
                this.t.position = a - this.p;
            }
        }
        get position() {
            return this.get_position();
        }
        set position(a) {
            this.set_position(a);
        }
        close() {
            this.t.close();
        }
        flush() {
            this.t.flush();
        }
        read(a, b, c) {
            let d;
            if (c <= this.p - this.q) {
                Buffer.c(this.o, this.q, a, b, c);
                this.q += c;
                d = c;
            }
            else {
                let e = this.p - this.q;
                if (this.p > this.q) {
                    Buffer.c(this.o, this.q, a, b, e);
                    this.q += e;
                }
                d = e + this.t.read(a, b + e, c - e);
            }
            return d;
        }
        readByte() {
            if (this.p > this.q) {
                return this.o[this.q++];
            }
            return this.t.readByte();
        }
        seek(a, b) {
            let c = this.p - this.q;
            if (b == 1) {
                if (a < c) {
                    return this.o[this.q + a];
                }
                else {
                    return this.t.seek(a - c, b);
                }
            }
            else {
                return this.t.seek(a, b);
            }
        }
        setLength(a) {
            this.t.setLength(a);
        }
        write(a, b, c) {
            throw new NotSupportedException(0);
        }
    }
    XmlInputStream.$t = /*@__PURE__*/ markType(XmlInputStream, 'XmlInputStream', Stream.$);
    XmlInputStream.strictUTF8 = null;
    XmlInputStream.z = /*@__PURE__*/ new XmlException(3, "invalid encoding specification.");
    return XmlInputStream;
})();
(function (v) { callStaticConstructors(); })(true);

//
/**
 * @hidden
 */
let XmlStreamReader = /*@__PURE__*/ (() => {
    class XmlStreamReader extends NonBlockingStreamReader {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(c, c.actualEncoding != null ? c.actualEncoding : XmlInputStream.strictUTF8);
                        this.ae = null;
                        this.ae = c;
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [new XmlInputStream(c)];
                        {
                            let f = d[0];
                            super(f, f.actualEncoding != null ? f.actualEncoding : XmlInputStream.strictUTF8);
                            this.ae = null;
                            this.ae = f;
                        }
                    }
                    break;
            }
        }
        i() {
            this.ae.close();
        }
        c(a, b, c) {
            try {
                return super.c(a, b, c);
            }
            catch (d) {
                throw new XmlException(3, "invalid data.");
            }
        }
        dispose1(a) {
            super.dispose1(a);
            if (a) {
                this.i();
            }
        }
    }
    XmlStreamReader.$t = /*@__PURE__*/ markType(XmlStreamReader, 'XmlStreamReader', NonBlockingStreamReader.$);
    XmlStreamReader.ad = /*@__PURE__*/ new XmlException(3, "invalid data.");
    return XmlStreamReader;
})();

//
/**
 * @hidden
 */
let StringReader = /*@__PURE__*/ (() => {
    class StringReader extends TextReader {
        constructor(a) {
            super();
            this.m = null;
            this.k = 0;
            this.l = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "s");
            }
            this.m = a;
            this.k = 0;
            this.l = a.length;
        }
        i() {
            this.dispose1(true);
        }
        dispose1(a) {
            this.m = null;
            super.dispose1(a);
        }
        a() {
            this.n();
            if (this.k >= this.l) {
                return -1;
            }
            else {
                return this.m.charAt(this.k).charCodeAt(0);
            }
        }
        b() {
            this.n();
            if (this.k >= this.l) {
                return -1;
            }
            else {
                return this.m.charAt(this.k++).charCodeAt(0);
            }
        }
        c(a, b, c) {
            this.n();
            if (a == null) {
                throw new ArgumentNullException(0, "buffer");
            }
            if (a.length - b < c) {
                throw new ArgumentException(1, stringEmpty());
            }
            if (b < 0 || c < 0) {
                throw new ArgumentOutOfRangeException(0);
            }
            let d;
            if (this.k > this.l - c) {
                d = this.l - this.k;
            }
            else {
                d = c;
            }
            stringCopyToCharArray(this.m, this.k, a, b, d);
            this.k += d;
            return d;
        }
        g() {
            this.n();
            if (this.k >= this.m.length) {
                return null;
            }
            let a = this.m.indexOf('\r', this.k);
            let b = this.m.indexOf('\n', this.k);
            let c;
            let d = false;
            if (a == -1) {
                if (b == -1) {
                    return this.h();
                }
                c = b;
            }
            else if (b == -1) {
                c = a;
            }
            else {
                c = (a > b) ? b : a;
                d = (a + 1 == b);
            }
            let e = this.m.substr(this.k, c - this.k);
            this.k = c + ((d) ? 2 : 1);
            return e;
        }
        h() {
            this.n();
            let a = this.m.substr(this.k, this.l - this.k);
            this.k = this.l;
            return a;
        }
        n() {
            if (this.m == null) {
                throw new ObjectDisposedException(1, "StringReader", "Cannot read from a closed StringReader");
            }
        }
    }
    StringReader.$t = /*@__PURE__*/ markType(StringReader, 'StringReader', TextReader.$);
    return StringReader;
})();

//
/**
 * @hidden
 */
let XmlTextReader_TagName = /*@__PURE__*/ (() => {
    class XmlTextReader_TagName extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.b = null;
            this.a = null;
            this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        this.b = c;
                        this.a = d;
                        this.c = e;
                    }
                    break;
            }
        }
    }
    XmlTextReader_TagName.$t = /*@__PURE__*/ markStruct(XmlTextReader_TagName, 'XmlTextReader_TagName');
    return XmlTextReader_TagName;
})();

//
/**
 * @hidden
 */
let XmlParserContext = /*@__PURE__*/ (() => {
    class XmlParserContext extends Base {
        constructor(a, ..._rest) {
            super();
            this.c = stringEmpty();
            this.e = stringEmpty();
            this.o = null;
            this.g = stringEmpty();
            this.u = null;
            this.w = null;
            this.i = stringEmpty();
            this.k = stringEmpty();
            this.m = stringEmpty();
            this.y = 0;
            this.a = null;
            this.b = 0;
            this.s = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = [c, d, null, null, null, null, null, e, f, null];
                        {
                            let i = g[0];
                            let j = g[1];
                            let k = g[2];
                            let l = g[3];
                            let m = g[4];
                            let n = g[5];
                            let o = g[6];
                            let p = g[7];
                            let q = g[8];
                            let r = g[9];
                            let s = [i, j, (k != null && k != stringEmpty()) ? new XmlTextReader(9, TextReader.e, i).d8(k, l, m, n) : null, o, p, q, r];
                            {
                                let u = s[0];
                                let v = s[1];
                                let w = s[2];
                                let x = s[3];
                                let y = s[4];
                                let z = s[5];
                                let aa = s[6];
                                this.u = v;
                                this.w = u != null ? u : v != null ? v.ag : null;
                                if (w != null) {
                                    this.f = w.b;
                                    this.j = w.c;
                                    this.l = w.d;
                                    this.h = w.a;
                                    this.s = w;
                                }
                                this.o = aa;
                                this.d = x;
                                this.n = y;
                                this.y = z;
                                this.a = arrayListCreate();
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = [c, d, null, null, null, null, null, e, f, g];
                        {
                            let j = h[0];
                            let k = h[1];
                            let l = h[2];
                            let m = h[3];
                            let n = h[4];
                            let o = h[5];
                            let p = h[6];
                            let q = h[7];
                            let r = h[8];
                            let s = h[9];
                            let t = [j, k, (l != null && l != stringEmpty()) ? new XmlTextReader(9, TextReader.e, j).d8(l, m, n, o) : null, p, q, r, s];
                            {
                                let v = t[0];
                                let w = t[1];
                                let x = t[2];
                                let y = t[3];
                                let z = t[4];
                                let aa = t[5];
                                let ab = t[6];
                                this.u = w;
                                this.w = v != null ? v : w != null ? w.ag : null;
                                if (x != null) {
                                    this.f = x.b;
                                    this.j = x.c;
                                    this.l = x.d;
                                    this.h = x.a;
                                    this.s = x;
                                }
                                this.o = ab;
                                this.d = y;
                                this.n = z;
                                this.y = aa;
                                this.a = arrayListCreate();
                            }
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        let j = _rest[7];
                        let k = _rest[8];
                        let l = [c, d, e, f, g, h, i, j, k, null];
                        {
                            let n = l[0];
                            let o = l[1];
                            let p = l[2];
                            let q = l[3];
                            let r = l[4];
                            let s = l[5];
                            let t = l[6];
                            let u = l[7];
                            let v = l[8];
                            let w = l[9];
                            let x = [n, o, (p != null && p != stringEmpty()) ? new XmlTextReader(9, TextReader.e, n).d8(p, q, r, s) : null, t, u, v, w];
                            {
                                let z = x[0];
                                let aa = x[1];
                                let ab = x[2];
                                let ac = x[3];
                                let ad = x[4];
                                let ae = x[5];
                                let af = x[6];
                                this.u = aa;
                                this.w = z != null ? z : aa != null ? aa.ag : null;
                                if (ab != null) {
                                    this.f = ab.b;
                                    this.j = ab.c;
                                    this.l = ab.d;
                                    this.h = ab.a;
                                    this.s = ab;
                                }
                                this.o = af;
                                this.d = ac;
                                this.n = ad;
                                this.y = ae;
                                this.a = arrayListCreate();
                            }
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        let j = _rest[7];
                        let k = _rest[8];
                        let l = _rest[9];
                        let m = [c, d, (e != null && e != stringEmpty()) ? new XmlTextReader(9, TextReader.e, c).d8(e, f, g, h) : null, i, j, k, l];
                        {
                            let o = m[0];
                            let p = m[1];
                            let q = m[2];
                            let r = m[3];
                            let s = m[4];
                            let t = m[5];
                            let u = m[6];
                            this.u = p;
                            this.w = o != null ? o : p != null ? p.ag : null;
                            if (q != null) {
                                this.f = q.b;
                                this.j = q.c;
                                this.l = q.d;
                                this.h = q.a;
                                this.s = q;
                            }
                            this.o = u;
                            this.d = r;
                            this.n = s;
                            this.y = t;
                            this.a = arrayListCreate();
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        let h = _rest[5];
                        let i = _rest[6];
                        this.u = d;
                        this.w = c != null ? c : d != null ? d.ag : null;
                        if (e != null) {
                            this.f = e.b;
                            this.j = e.c;
                            this.l = e.d;
                            this.h = e.a;
                            this.s = e;
                        }
                        this.o = i;
                        this.d = f;
                        this.n = g;
                        this.y = h;
                        this.a = arrayListCreate();
                    }
                    break;
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            this.c = a != null ? a : stringEmpty();
        }
        get f() {
            return this.e != null ? this.e : this.s != null ? this.s.b : null;
        }
        set f(a) {
            this.e = a != null ? a : stringEmpty();
        }
        get t() {
            return this.s;
        }
        set t(a) {
            this.s = a;
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get h() {
            return this.g != null ? this.g : this.s != null ? this.s.a : null;
        }
        set h(a) {
            this.g = a != null ? a : stringEmpty();
        }
        get v() {
            return this.u;
        }
        set v(a) {
            this.u = a;
        }
        get x() {
            return this.w;
        }
        set x(a) {
            this.w = a;
        }
        get j() {
            return this.i != null ? this.i : this.s != null ? this.s.c : null;
        }
        set j(a) {
            this.i = a != null ? a : stringEmpty();
        }
        get l() {
            return this.k != null ? this.k : this.s != null ? this.s.d : null;
        }
        set l(a) {
            this.k = a != null ? a : stringEmpty();
        }
        get n() {
            return this.m;
        }
        set n(a) {
            this.m = a != null ? a : stringEmpty();
        }
        get z() {
            return this.y;
        }
        set z(a) {
            this.y = a;
        }
        r() {
            let a = null;
            if (this.a.count == this.b) {
                a = new XmlParserContext_ContextItem();
                this.a.add(a);
            }
            else {
                a = this.a.item(this.b);
            }
            a.a = this.d;
            a.b = this.n;
            a.c = this.z;
            this.b++;
        }
        q() {
            if (this.b == 0) {
                throw new XmlException(3, "Unexpected end of element scope.");
            }
            this.b--;
            let a = this.a.item(this.b);
            this.c = a.a;
            this.m = a.b;
            this.y = a.c;
        }
    }
    XmlParserContext.$t = /*@__PURE__*/ markType(XmlParserContext, 'XmlParserContext');
    return XmlParserContext;
})();
/**
 * @hidden
 */
let XmlTextReader = /*@__PURE__*/ (() => {
    class XmlTextReader extends XmlReader {
        constructor(a, ..._rest) {
            super();
            this.es = null;
            this.er = null;
            this.ep = null;
            this.eq = null;
            this.a9 = new Array(10);
            this.ba = new Array(10);
            this.b6 = 0;
            this.b7 = 0;
            this.b3 = 0;
            this.ej = null;
            this.eg = null;
            this.ef = null;
            this.eb = 0;
            this.bk = false;
            this.ca = 0;
            this.cb = 0;
            this.bj = false;
            this.bq = false;
            this.bb = null;
            this.cc = 0;
            this.be = false;
            this.bl = false;
            this.bz = false;
            this.c0 = null;
            this.c7 = null;
            this.cy = null;
            this.bc = null;
            this.ck = 0;
            this.cl = 0;
            this.b5 = 0;
            this.br = false;
            this.ce = 0;
            this.b4 = 0;
            this.b8 = 0;
            this.b9 = 0;
            this.b2 = false;
            this.ei = 0;
            this.eh = 0;
            this.ch = 0;
            this.bu = false;
            this.bm = true;
            this.ec = 0;
            this.ek = new XmlUrlResolver();
            this.bo = false;
            this.bg = false;
            this.bs = false;
            this.bh = true;
            this.d9 = 0;
            this.ea = null;
            this.bd = null;
            this.eo = new XmlTextReader_DtdInputStateStack();
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = [new XmlStreamReader(1, c)];
                        {
                            let f = d[0];
                            let g = [f, new NameTable()];
                            {
                                let i = g[0];
                                let j = g[1];
                                let k = [stringEmpty(), i, j];
                                {
                                    let m = k[0];
                                    let n = k[1];
                                    let o = k[2];
                                    let p = [m, n, 9, null];
                                    {
                                        let r = p[0];
                                        let s = p[1];
                                        let t = p[2];
                                        let u = p[3];
                                        this.dn(r, u, s, t);
                                    }
                                }
                            }
                        }
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = [c, new NameTable()];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h;
                            let i = ((() => { let j = this.cw(f, h); h = j.p1; return j.ret; })());
                            let j = new XmlParserContext(0, g, new XmlNamespaceManager(g), stringEmpty(), 0);
                            this.dn(h, j, new XmlStreamReader(1, i), 9);
                        }
                    }
                    break;
                case 3:
                    {
                        let c = _rest[0];
                        let d = [c, new NameTable()];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = [stringEmpty(), f, g];
                            {
                                let j = h[0];
                                let k = h[1];
                                let l = h[2];
                                let m = [j, k, 9, null];
                                {
                                    let o = m[0];
                                    let p = m[1];
                                    let q = m[2];
                                    let r = m[3];
                                    this.dn(o, r, p, q);
                                }
                            }
                        }
                    }
                    break;
                case 4:
                    {
                        let c = _rest[0];
                        let d = [stringEmpty(), null, 0, null];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            this.dn(f, i, g, h);
                        }
                    }
                    break;
                case 5:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [new XmlStreamReader(1, c), d];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = [stringEmpty(), g, h];
                            {
                                let k = i[0];
                                let l = i[1];
                                let m = i[2];
                                let n = [k, l, 9, null];
                                {
                                    let p = n[0];
                                    let q = n[1];
                                    let r = n[2];
                                    let s = n[3];
                                    this.dn(p, s, q, r);
                                }
                            }
                        }
                    }
                    break;
                case 6:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, new XmlStreamReader(1, d)];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = [g, h, new NameTable()];
                            {
                                let k = i[0];
                                let l = i[1];
                                let m = i[2];
                                let n = [k, l, 9, null];
                                {
                                    let p = n[0];
                                    let q = n[1];
                                    let r = n[2];
                                    let s = n[3];
                                    this.dn(p, s, q, r);
                                }
                            }
                        }
                    }
                    break;
                case 7:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [c, d, new NameTable()];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            let j = [g, h, 9, null];
                            {
                                let l = j[0];
                                let m = j[1];
                                let n = j[2];
                                let o = j[3];
                                this.dn(l, o, m, n);
                            }
                        }
                    }
                    break;
                case 8:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e;
                        let f = ((() => { let g = this.cw(c, e); e = g.p1; return g.ret; })());
                        let g = new XmlParserContext(0, d, new XmlNamespaceManager(d), stringEmpty(), 0);
                        this.dn(e, g, new XmlStreamReader(1, f), 9);
                    }
                    break;
                case 9:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = [stringEmpty(), c, d];
                        {
                            let g = e[0];
                            let h = e[1];
                            let i = e[2];
                            let j = [g, h, 9, null];
                            {
                                let l = j[0];
                                let m = j[1];
                                let n = j[2];
                                let o = j[3];
                                this.dn(l, o, m, n);
                            }
                        }
                    }
                    break;
                case 10:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        if (d == null) {
                            d = new XmlUrlResolver();
                        }
                        this.em = d;
                        let h;
                        let i = ((() => { let j = this.cw(e, h); h = j.p1; return j.ret; })());
                        this.dn(h, g, new XmlStreamReader(1, i), f);
                    }
                    break;
                case 11:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [e != null ? e.d : stringEmpty(), new XmlStreamReader(1, c), d, e];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                        this.bk = true;
                    }
                    break;
                case 12:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [c, d, e, null];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                    }
                    break;
                case 13:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [c, new XmlStreamReader(1, d), e];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = [h, i, 9, null];
                            {
                                let m = k[0];
                                let n = k[1];
                                let o = k[2];
                                let p = k[3];
                                this.dn(m, p, n, o);
                            }
                        }
                    }
                    break;
                case 14:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [c, d, 9, null];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                    }
                    break;
                case 15:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = [e != null ? e.d : stringEmpty(), new StringReader(c), d, e];
                        {
                            let h = f[0];
                            let i = f[1];
                            let j = f[2];
                            let k = f[3];
                            this.dn(h, k, i, j);
                        }
                        this.bk = true;
                    }
                    break;
                case 16:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        this.dn(c, f, d, e);
                    }
                    break;
            }
        }
        cw(a, b) {
            let c = this.ek.d(null, a);
            b = c != null ? c.toString() : stringEmpty();
            return {
                ret: typeCast(Stream.$, this.ek.b(c, null, Stream.$)),
                p1: b
            };
        }
        get_w() {
            return this.b3;
        }
        get w() {
            return this.get_w();
        }
        get_z() {
            return this.ej.d;
        }
        get z() {
            return this.get_z();
        }
        get_a() {
            return true;
        }
        get_b() {
            return true;
        }
        get bf() {
            return this.bg;
        }
        set bf(a) {
            this.bg = a;
        }
        get bi() {
            return this.bh;
        }
        set bi(a) {
            this.bh = a;
        }
        get_x() {
            let a = this.er.n == 1 ? 0 : -1;
            if (this.b7 >= 0) {
                return a + this.cb + 2;
            }
            else if (this.b6 >= 0) {
                return a + this.cb + 1;
            }
            return this.cb;
        }
        get x() {
            return this.get_x();
        }
        get c6() {
            return this.ej.p || Encoding.uTF8;
        }
        get_d() {
            return this.eb == 3;
        }
        get d() {
            return this.get_d();
        }
        get_f() {
            return this.es.k != null;
        }
        get f() {
            return this.get_f();
        }
        get_h() {
            return false;
        }
        get h() {
            return this.get_h();
        }
        get_i() {
            return this.es.a;
        }
        get i() {
            return this.get_i();
        }
        item(a) {
            return this.aa(a);
        }
        item1(a) {
            return this.ab(a);
        }
        item2(a, b) {
            return this.ac(a, b);
        }
        get cf() {
            if (this.b2) {
                return this.ce;
            }
            else {
                return this.es.c;
            }
        }
        get cg() {
            if (this.b2) {
                return this.b4;
            }
            else {
                return this.es.d;
            }
        }
        get_ag() {
            return this.es.g;
        }
        get ag() {
            return this.get_ag();
        }
        get_ai() {
            return this.es.h;
        }
        get ai() {
            return this.get_ai();
        }
        get bn() {
            return this.bm;
        }
        set bn(a) {
            if (this.eb != 0) {
                throw new InvalidOperationException(1, "Namespaces have to be set before reading.");
            }
            this.bm = a;
        }
        get_aj() {
            return this.es.i;
        }
        get aj() {
            return this.get_aj();
        }
        get_a5() {
            return this.eg;
        }
        get a5() {
            return this.get_a5();
        }
        get_a7() {
            return this.es.n;
        }
        get a7() {
            return this.get_a7();
        }
        get bp() {
            return this.bo;
        }
        set bp(a) {
            this.bo = a;
        }
        get_ak() {
            return this.es.j;
        }
        get ak() {
            return this.get_ak();
        }
        get bt() {
            return this.bs;
        }
        set bt(a) {
            this.bs = a;
        }
        get_v() {
            return this.es.b;
        }
        get v() {
            return this.get_v();
        }
        get_a3() {
            return this.eb;
        }
        get a3() {
            return this.get_a3();
        }
        get_ar() {
            return this.es.k != null ? this.es.k : stringEmpty();
        }
        get ar() {
            return this.get_ar();
        }
        get ed() {
            return this.ec;
        }
        set ed(a) {
            this.ec = a;
        }
        get_as() {
            return this.ej.n;
        }
        get as() {
            return this.get_as();
        }
        set em(a) {
            this.ek = a;
        }
        get_a8() {
            return this.ej.z;
        }
        get a8() {
            return this.get_a8();
        }
        au() {
            this.eb = 4;
            this.es.m();
            this.er.m();
            this.b3 = 0;
            if (this.bh && this.cy != null) {
                this.cy.i();
            }
        }
        aa(a) {
            if (a >= this.b3) {
                throw new ArgumentOutOfRangeException(1, "i is smaller than AttributeCount");
            }
            else {
                return this.a9[a].k;
            }
        }
        ab(a) {
            for (let b = 0; b < this.b3; b++) {
                if (this.a9[b].h == a) {
                    return this.a9[b].k;
                }
            }
            return null;
        }
        cd(a, b) {
            b = b != null ? b : stringEmpty();
            for (let c = 0; c < this.b3; c++) {
                let d = this.a9[c];
                if (d.g == a && d.i == b) {
                    return c;
                }
            }
            return -1;
        }
        ac(a, b) {
            let c = this.cd(a, b);
            if (c < 0) {
                return null;
            }
            return this.a9[c].k;
        }
        cx() {
            if (this.cl < 0) {
                return this.cy;
            }
            return new StringReader(stringCreateFromCharArraySlice(this.bc, this.ck, this.cl - this.ck) + this.cy.h());
        }
        ah(a) {
            return this.c1(a, false);
        }
        c1(a, b) {
            let c = this.ef.lookupNamespace1(a, b);
            return c == stringEmpty() ? null : c;
        }
        aw(a) {
            if (a >= this.b3) {
                throw new ArgumentOutOfRangeException(1, "attribute index out of range.");
            }
            this.b6 = a;
            this.b7 = -1;
            this.es = this.a9[a];
        }
        o(a) {
            for (let b = 0; b < this.b3; b++) {
                let c = this.a9[b];
                if (c.h == a) {
                    this.aw(b);
                    return true;
                }
            }
            return false;
        }
        p(a, b) {
            let c = this.cd(a, b);
            if (c < 0) {
                return false;
            }
            this.aw(c);
            return true;
        }
        q() {
            if (this.er == null) {
                return false;
            }
            if (this.es == this.er) {
                return false;
            }
            if (this.b6 >= 0) {
                this.b6 = -1;
                this.b7 = -1;
                this.es = this.er;
                return true;
            }
            else {
                return false;
            }
        }
        r() {
            if (this.b3 == 0) {
                return false;
            }
            this.q();
            return this.s();
        }
        s() {
            if (this.b6 == 0 && this.b3 == 0) {
                return false;
            }
            if (this.b6 + 1 < this.b3) {
                this.b6++;
                this.b7 = -1;
                this.es = this.a9[this.b6];
                return true;
            }
            else {
                return false;
            }
        }
        t() {
            if (this.eb == 4) {
                return false;
            }
            this.b5 = this.ck;
            this.br = true;
            this.ch = 0;
            this.df();
            if (this.ei == 2) {
                if (this.b6 == 0) {
                    return false;
                }
                this.d6();
                this.de();
                this.dk();
                this.ds('\"'.charCodeAt(0));
                this.es = this.a9[0];
                this.b7 = -1;
                this.eb = 1;
                return true;
            }
            if (this.eb == 0 && this.eh == 1) {
                this.d6();
            }
            let a = false;
            this.eb = 1;
            this.b8 = this.ce;
            this.b9 = this.b4;
            this.b2 = true;
            this.es = this.er;
            this.b3 = 0;
            this.b6 = this.b7 = -1;
            this.er.m();
            if (this.bj) {
                ++this.ca;
                this.bj = false;
            }
            if (this.bu) {
                this.bu = false;
                return this.bx();
            }
            a = this.bv();
            if (!a && this.ei == 9 && this.eh != 15) {
                throw this.ee("Document element did not appear.");
            }
            this.b2 = false;
            return a;
        }
        u() {
            if (this.eb == 0 && this.ei == 2) {
                this.t();
            }
            if (this.b6 < 0) {
                return false;
            }
            let a = this.a9[this.b6];
            if (this.b7 < 0) {
                this.b7 = a.q - 1;
            }
            if (this.b7 < a.p) {
                this.b7++;
                this.es = this.ba[this.b7];
                return true;
            }
            else {
                return false;
            }
        }
        cn(a, b, c) {
            return 0;
        }
        co(a, b, c) {
            return 0;
        }
        cr(a, b, c) {
            if (b < 0) {
                throw new ArgumentOutOfRangeException(3, "offset", b, "Offset must be non-negative integer.");
            }
            else if (c < 0) {
                throw new ArgumentOutOfRangeException(3, "length", c, "Length must be non-negative integer.");
            }
            else if (a.length < b + c) {
                throw new ArgumentOutOfRangeException(1, "buffer length is smaller than the sum of offset and length.");
            }
            if (this.i) {
                this.t();
                return 0;
            }
            if (!this.bu && this.a7 != 1) {
                return 0;
            }
            this.br = false;
            this.bu = true;
            this.b2 = true;
            return this.cs(a, b, c);
        }
        d2() {
            if (this.bk) {
                throw new InvalidOperationException(1, "Cannot call ResetState when parsing an XML fragment.");
            }
            this.dd();
        }
        a1() {
            throw new InvalidOperationException(1, "XmlTextReader cannot resolve external entities.");
        }
        get el() {
            return this.ek;
        }
        ee(a) {
            return new XmlException(2, typeCast(IXmlLineInfo_$type, this), this.z, a);
        }
        initXmlTextReader() {
            this.be = false;
            this.bb = new Array(10);
            this.c7 = new StringBuilder(0);
            this.bg = true;
            this.bs = false;
            this.bh = true;
            this.d9 = 2;
            this.ck = 0;
            if (this.bc == null) {
                this.bc = new Array(1024);
            }
            this.cl = -1;
            this.b5 = -1;
            this.ce = 1;
            this.b4 = 1;
            this.b8 = this.b9 = 0;
            this.dd();
        }
        dd() {
            this.er = new XmlTextReader_XmlTokenInfo(this);
            this.es = this.er;
            this.b6 = -1;
            this.b7 = -1;
            this.b3 = 0;
            this.eb = 0;
            this.ca = 0;
            this.cb = 0;
            this.bj = false;
            this.bq = this.be = false;
            this.cc = 0;
            this.bl = false;
            this.bz = false;
            this.c0 = stringEmpty();
            this.b2 = false;
            this.eh = 0;
            this.bu = false;
        }
        dn(a, b, c, d) {
            this.ei = d;
            this.ej = b;
            if (b == null) {
                let e = new NameTable();
                this.ej = new XmlParserContext(0, e, new XmlNamespaceManager(e), stringEmpty(), 0);
            }
            this.eg = this.ej.x;
            this.eg = this.eg != null ? this.eg : new NameTable();
            this.ef = this.ej.v;
            this.ef = this.ef != null ? this.ef : new XmlNamespaceManager(this.eg);
            if (a != null && a.length > 0) {
                let f = null;
                try {
                    f = new Uri(0, a);
                }
                catch (g) {
                    throw g;
                }
                this.ej.d = f.toString();
            }
            this.initXmlTextReader();
            this.cy = c;
            switch (d) {
                case 2:
                    this.cy = new StringReader(stringReplace(c.h(), "\"", "&quot;"));
                    break;
                case 1:
                    this.eh = 1;
                    this.be = true;
                    break;
                case 9: break;
                default: throw new XmlException(3, stringFormat("NodeType {0} is not allowed to create XmlTextReader.", enumGetBox(XmlNodeType_$type, d)));
            }
        }
        d4(a, b, c, d, e, f, g) {
            this.d5(this.er, a, b, c, d, e, f, g);
            this.er.c = this.b8;
            this.er.d = this.b9;
        }
        d5(a, b, c, d, e, f, g, h) {
            a.n = b;
            a.h = c;
            a.j = d;
            a.g = e;
            a.a = f;
            a.k = g;
            this.cb = this.ca;
            if (h) {
                this.de();
            }
        }
        de() {
            this.b3 = 0;
            this.b6 = -1;
            this.b7 = -1;
        }
        cm(a) {
            if (this.cl <= this.ck + 1) {
                if (!this.bw(a)) {
                    return a;
                }
            }
            let b = this.bc[this.ck].charCodeAt(0);
            let c = this.bc[this.ck + 1].charCodeAt(0);
            if (((b & 64512) != 55296) || ((c & 64512) != 56320)) {
                return b;
            }
            return 65536 + (b - 55296) * 1024 + (c - 56320);
        }
        ci() {
            if (this.ck < this.cl) {
                let a = this.bc[this.ck].charCodeAt(0);
                if (a == 0) {
                    return -1;
                }
                if (a < 55296 || a >= 57343) {
                    return a;
                }
                return this.cm(a);
            }
            else {
                if (!this.bw(-1)) {
                    return -1;
                }
                return this.ci();
            }
        }
        cp() {
            let a = this.ci();
            this.ck++;
            if (a >= 65536) {
                this.ck++;
            }
            if (a == '\n'.charCodeAt(0)) {
                this.ce++;
                this.b4 = 1;
            }
            else if (a != -1) {
                this.b4++;
            }
            return a;
        }
        c9(a) {
            this.ck++;
            if (a >= 65536) {
                this.ck++;
            }
            if (a == '\n'.charCodeAt(0)) {
                this.ce++;
                this.b4 = 1;
            }
            else if (a != -1) {
                this.b4++;
            }
        }
        bw(a) {
            if (this.cl < 0) {
                this.cl = this.cy.c(this.bc, 0, this.bc.length);
                return this.cl > 0;
            }
            let b = a >= 0 ? 1 : 0;
            let c = this.cl - this.b5;
            if (!this.br) {
                this.b5 = 0;
                this.ck = 0;
            }
            else if (this.cl < this.bc.length) {
            }
            else if (this.b5 <= (this.cl >> 1)) {
                let d = new Array(this.bc.length * 2);
                arrayCopy1(this.bc, this.b5, d, 0, c);
                this.bc = d;
                this.b5 = 0;
                this.ck = c;
            }
            else {
                arrayCopy1(this.bc, this.b5, this.bc, 0, c);
                this.b5 = 0;
                this.ck = c;
            }
            if (a >= 0) {
                this.bc[this.ck] = String.fromCharCode(a);
            }
            let e = this.bc.length - this.ck - b;
            if (e > 1024) {
                e = 1024;
            }
            let f = this.cy.c(this.bc, this.ck + b, e);
            let g = b + f;
            this.cl = this.ck + g;
            return (g != 0);
        }
        bv() {
            if (this.bq) {
                this.ef.h();
                this.ej.q();
                this.bq = false;
            }
            if (this.bz) {
                this.d3();
            }
            else {
                let a = this.ci();
                if (a == -1) {
                    this.eb = 3;
                    this.df();
                    this.d4(0, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
                    if (this.ca > 0) {
                        throw this.ee("unexpected end of file. Current depth is " + this.ca);
                    }
                    return false;
                }
                else {
                    switch (a) {
                        case 60:
                            this.c9(a);
                            switch (this.ci()) {
                                case 47:
                                    this.c9(47);
                                    this.dx();
                                    break;
                                case 63:
                                    this.c9(63);
                                    this.dz();
                                    break;
                                case 33:
                                    this.c9(33);
                                    this.dv();
                                    break;
                                default:
                                    this.d0();
                                    break;
                            }
                            break;
                        case 13:
                        case 10:
                        case 9:
                        case 32:
                            if (!this.by()) {
                                return this.bv();
                            }
                            break;
                        default:
                            this.d1(true);
                            break;
                    }
                }
            }
            return this.a3 != 3;
        }
        d3() {
            this.df();
            this.d4(5, this.c0, stringEmpty(), this.c0, false, null, true);
            this.bz = false;
            this.c0 = stringEmpty();
        }
        d0() {
            if (this.eh == 15) {
                throw this.ee("Multiple document element was detected.");
            }
            this.eh = 1;
            this.ef.ac();
            this.b8 = this.ce;
            this.b9 = this.b4;
            let a, b;
            let c = ((() => { let d = this.c3(a, b); a = d.p0; b = d.p1; return d.ret; })());
            if (this.eh == 15) {
                throw this.ee("document has terminated, cannot open new element");
            }
            let d = false;
            this.de();
            this.b0();
            if (XmlChar.e(this.ci())) {
                this.dr(false);
            }
            this.es = this.er;
            for (let e = 0; e < this.b3; e++) {
                this.a9[e].u();
            }
            for (let f = 0; f < this.b3; f++) {
                this.a9[f].t();
            }
            if (this.bm) {
                for (let g = 0; g < this.b3; g++) {
                    if (this.a9[g].j == "xmlns" && this.a9[g].k == stringEmpty()) {
                        throw this.ee("Empty namespace URI cannot be mapped to non-empty prefix.");
                    }
                }
            }
            for (let h = 0; h < this.b3; h++) {
                for (let i = h + 1; i < this.b3; i++) {
                    if (Base.referenceEquals(this.a9[h].h, this.a9[i].h) || (Base.referenceEquals(this.a9[h].g, this.a9[i].g) && Base.referenceEquals(this.a9[h].i, this.a9[i].i))) {
                        throw this.ee("Attribute name and qualified name must be identical.");
                    }
                }
            }
            if (this.ci() == '/'.charCodeAt(0)) {
                this.c9('/'.charCodeAt(0));
                d = true;
                this.bq = true;
            }
            else {
                this.bj = true;
                this.dq(c, b, a);
            }
            this.ej.r();
            this.dg('>'.charCodeAt(0));
            this.d4(1, c, a, b, d, null, false);
            if (a.length > 0) {
                this.er.i = this.c1(a, true);
            }
            else if (this.bm) {
                this.er.i = this.ef.n;
            }
            if (this.bm) {
                if (this.aj == null) {
                    throw this.ee(stringFormat("'{0}' is undeclared namespace.", this.ak));
                }
                try {
                    for (let j = 0; j < this.b3; j++) {
                        this.aw(j);
                        if (this.aj == null) {
                            throw this.ee(stringFormat("'{0}' is undeclared namespace.", this.ak));
                        }
                    }
                }
                finally {
                    this.q();
                }
            }
            for (let k = 0; k < this.b3; k++) {
                if (!Base.referenceEquals(this.a9[k].j, "xml")) {
                    continue;
                }
                let l = this.a9[k].g;
                let m = this.a9[k].k;
                switch (l) {
                    case "base":
                        if (this.ek != null) {
                            let n = this.z != stringEmpty() ? new Uri(0, this.z) : null;
                            if (n == null && stringIsNullOrEmpty(m)) {
                                break;
                            }
                            let o = this.ek.d(n, m);
                            this.ej.d = o != null ? o.toString() : stringEmpty();
                        }
                        else {
                            this.ej.d = m;
                        }
                        break;
                    case "lang":
                        this.ej.n = m;
                        break;
                    case "space":
                        switch (m) {
                            case "preserve":
                                this.ej.z = 2;
                                break;
                            case "default":
                                this.ej.z = 1;
                                break;
                            default: throw this.ee(stringFormat("Invalid xml:space value: {0}", m));
                        }
                        break;
                }
            }
            if (this.i) {
                this.dc();
            }
        }
        dq(a, b, c) {
            if (this.bb.length == this.cc) {
                let d = new Array(this.bb.length * 2);
                arrayCopy1(this.bb, 0, d, 0, this.cc);
                this.bb = d;
            }
            this.bb[this.cc++] = new XmlTextReader_TagName(1, a, b, c);
        }
        dx() {
            if (this.eh != 1) {
                throw this.ee("End tag cannot appear in this state.");
            }
            this.b8 = this.ce;
            this.b9 = this.b4;
            if (this.cc == 0) {
                throw this.ee("closing element without matching opening element");
            }
            let a = this.bb[--this.cc];
            this.dh(a.b);
            this.di('>');
            --this.ca;
            this.d4(15, a.b, a.c, a.a, false, null, true);
            if (a.c.length > 0) {
                this.er.i = this.c1(a.c, true);
            }
            else if (this.bm) {
                this.er.i = this.ef.n;
            }
            this.bq = true;
            this.dc();
        }
        dc() {
            if (this.ca == 0 && !this.be && (this.i || this.a7 == 15)) {
                this.eh = 15;
            }
        }
        db(a) {
            if (a <= charMaxValue().charCodeAt(0)) {
                this.c7.h(String.fromCharCode(a));
            }
            else {
                this.da(a);
            }
        }
        da(a) {
            this.c7.h(String.fromCharCode((intDivide((a - 65536), 1024) + 55296)));
            this.c7.h(String.fromCharCode(((a - 65536) % 1024 + 56320)));
        }
        cz() {
            switch (this.a7) {
                case 13:
                case 14:
                    let a = this.c7.c;
                    if (this.bd == null) {
                        this.bd = new Array(32);
                    }
                    if (a >= this.bd.length) {
                        break;
                    }
                    if (this.ea == null) {
                        this.ea = new NameTable();
                    }
                    for (let b = 0; b < a; b++) {
                        this.bd[b] = this.c7.item(b);
                    }
                    return this.ea.a(this.bd, 0, this.c7.c);
            }
            return (this.c7.b < 100) ? this.c7.f(0, this.c7.c) : this.c7.toString();
        }
        df() {
            this.c7.c = 0;
        }
        d1(a) {
            if (this.eh != 1) {
                throw this.ee("Text node cannot appear in this state.");
            }
            this.br = false;
            if (a) {
                this.df();
            }
            let b = this.ci();
            let c = false;
            while (b != '<'.charCodeAt(0) && b != -1) {
                if (b == '&'.charCodeAt(0)) {
                    this.cp();
                    b = this.cu(false);
                    if (this.bz) {
                        break;
                    }
                }
                else if (this.bo && b == '\r'.charCodeAt(0)) {
                    this.cp();
                    b = this.ci();
                    if (b != '\n'.charCodeAt(0)) {
                        this.db('\n'.charCodeAt(0));
                    }
                    continue;
                }
                else {
                    if (this.bf && XmlChar.f(b)) {
                        throw this.ee("Not allowed character was found.");
                    }
                    b = this.cp();
                }
                {
                    if (b <= charMaxValue().charCodeAt(0)) {
                        this.c7.h(String.fromCharCode(b));
                    }
                    else {
                        this.da(b);
                    }
                }
                if (b == ']'.charCodeAt(0)) {
                    if (c) {
                        if (this.ci() == '>'.charCodeAt(0)) {
                            throw this.ee("Inside text content, character sequence ']]>' is not allowed.");
                        }
                    }
                    c = true;
                }
                else if (c) {
                    c = false;
                }
                b = this.ci();
                a = true;
            }
            if (this.bz && this.c7.c == 0) {
                this.d3();
            }
            else {
                let d = a ? 3 : this.a8 == 2 ? 14 : 13;
                this.d4(d, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
            }
        }
        cu(a) {
            if (this.ci() == '#'.charCodeAt(0)) {
                this.c9('#'.charCodeAt(0));
                return this.cq();
            }
            else {
                return this.ct(a);
            }
        }
        cq() {
            let a = 0;
            let b;
            if (this.ci() == 'x'.charCodeAt(0)) {
                this.c9('x'.charCodeAt(0));
                while ((b = this.ci()) != ';'.charCodeAt(0) && b != -1) {
                    this.c9(b);
                    if (b >= '0'.charCodeAt(0) && b <= '9'.charCodeAt(0)) {
                        a = (a << 4) + b - '0'.charCodeAt(0);
                    }
                    else if (b >= 'A'.charCodeAt(0) && b <= 'F'.charCodeAt(0)) {
                        a = (a << 4) + b - 'A'.charCodeAt(0) + 10;
                    }
                    else if (b >= 'a'.charCodeAt(0) && b <= 'f'.charCodeAt(0)) {
                        a = (a << 4) + b - 'a'.charCodeAt(0) + 10;
                    }
                    else {
                        throw this.ee(stringFormat2(CultureInfo.invariantCulture, "invalid hexadecimal digit: {0} (#x{1:X})", String.fromCharCode(b), b));
                    }
                }
            }
            else {
                while ((b = this.ci()) != ';'.charCodeAt(0) && b != -1) {
                    this.c9(b);
                    if (b >= '0'.charCodeAt(0) && b <= '9'.charCodeAt(0)) {
                        a = a * 10 + b - '0'.charCodeAt(0);
                    }
                    else {
                        throw this.ee(stringFormat2(CultureInfo.invariantCulture, "invalid decimal digit: {0} (#x{1:X})", String.fromCharCode(b), b));
                    }
                }
            }
            this.cp();
            if (this.bf && this.bp && XmlChar.f(a)) {
                throw this.ee("Referenced character was not allowed in XML. Normalization is " + this.bo + ", checkCharacters = " + this.bg);
            }
            return a;
        }
        ct(a) {
            let b = this.c2();
            this.dg(';'.charCodeAt(0));
            let c = XmlChar.r(b);
            if (c >= 0) {
                return c;
            }
            else {
                if (a) {
                    this.db('&'.charCodeAt(0));
                    for (let d = 0; d < b.length; d++) {
                        this.db(b.charAt(d).charCodeAt(0));
                    }
                    this.db(';'.charCodeAt(0));
                }
                else {
                    this.bz = true;
                    this.c0 = b;
                }
            }
            return -1;
        }
        dr(a) {
            let b = -1;
            let c = false;
            this.b6 = -1;
            this.b7 = -1;
            do {
                if (!this.b0() && c) {
                    throw this.ee("Unexpected token. Name is required here.");
                }
                this.dk();
                this.ep.c = this.ce;
                this.ep.d = this.b4;
                let d, e;
                this.ep.h = ((() => { let f = this.c3(d, e); d = f.p0; e = f.p1; return f.ret; })());
                this.ep.j = d;
                this.ep.g = e;
                this.di('=');
                this.b0();
                this.ds(-1);
                let f;
                if (a) {
                    f = this.ep.k;
                }
                this.b3++;
                if (!this.b0()) {
                    c = true;
                }
                b = this.ci();
                if (a) {
                    if (b == '?'.charCodeAt(0)) {
                        break;
                    }
                }
                else if (b == '/'.charCodeAt(0) || b == '>'.charCodeAt(0)) {
                    break;
                }
            } while (b != -1);
            this.b6 = -1;
            this.b7 = -1;
        }
        c8(a, b) {
            this.dk();
            let c = this.a9[this.b6];
            c.h = this.a5.b(a);
            c.j = stringEmpty();
            c.i = stringEmpty();
            this.dl();
            let d = this.ba[this.b7];
            this.d5(d, 3, stringEmpty(), stringEmpty(), stringEmpty(), false, b, false);
            c.k = b;
            this.b3++;
        }
        dk() {
            this.b6++;
            if (this.a9.length == this.b6) {
                let a = new Array(this.a9.length * 2);
                arrayCopyTo(this.a9, a, 0);
                this.a9 = a;
            }
            if (this.a9[this.b6] == null) {
                this.a9[this.b6] = new XmlTextReader_XmlAttributeTokenInfo(this);
            }
            this.ep = this.a9[this.b6];
            this.ep.m();
        }
        dl() {
            this.b7++;
            if (this.ba.length == this.b7) {
                let a = new Array(this.ba.length * 2);
                arrayCopyTo(this.ba, a, 0);
                this.ba = a;
            }
            if (this.ba[this.b7] == null) {
                this.ba[this.b7] = new XmlTextReader_XmlTokenInfo(this);
            }
            this.eq = this.ba[this.b7];
            this.eq.m();
        }
        ds(a) {
            let b = (a < 0) ? this.cp() : a;
            if (b != '\''.charCodeAt(0) && b != '\"'.charCodeAt(0)) {
                throw this.ee("an attribute value was not quoted");
            }
            this.ep.b = String.fromCharCode(b);
            this.dl();
            this.ep.q = this.b7;
            this.eq.c = this.ce;
            this.eq.d = this.b4;
            let c = false;
            let d = true;
            let e = true;
            let f = 0;
            this.eq.f = this.c7.c;
            L0: while (e) {
                f = this.cp();
                if (f == b) {
                    break;
                }
                if (c) {
                    this.dl();
                    this.eq.f = this.c7.c;
                    this.eq.c = this.ce;
                    this.eq.d = this.b4;
                    c = false;
                    d = true;
                }
                let t1 = f;
                L1: while (true) {
                    switch (t1) {
                        case '<'.charCodeAt(0): throw this.ee("attribute values cannot contain '<'");
                        case -1:
                            if (a < 0) {
                                throw this.ee("unexpected end of file in an attribute value");
                            }
                            else {
                                e = false;
                            }
                            break;
                        case '\r'.charCodeAt(0):
                            if (!this.bo) {
                                t1 = void 0;
                                continue L1;
                            }
                            if (this.ci() == '\n'.charCodeAt(0)) {
                                continue L0;
                            }
                            if (!this.bo) {
                                t1 = void 0;
                                continue L1;
                            }
                            f = ' '.charCodeAt(0);
                            t1 = void 0;
                            continue L1;
                        case '\n'.charCodeAt(0):
                        case '\t'.charCodeAt(0):
                            if (!this.bo) {
                                t1 = void 0;
                                continue L1;
                            }
                            f = ' '.charCodeAt(0);
                            t1 = void 0;
                            continue L1;
                        case '&'.charCodeAt(0):
                            if (this.ci() == '#'.charCodeAt(0)) {
                                this.c9('#'.charCodeAt(0));
                                f = this.cq();
                                this.db(f);
                                break;
                            }
                            let g = this.c2();
                            this.dg(';'.charCodeAt(0));
                            let h = XmlChar.r(g);
                            if (h < 0) {
                                {
                                    this.eq.e = this.c7.c;
                                    this.eq.n = 3;
                                    if (!d) {
                                        this.dl();
                                    }
                                    this.eq.h = g;
                                    this.eq.k = stringEmpty();
                                    this.eq.n = 5;
                                    c = true;
                                }
                            }
                            else {
                                this.db(h);
                            }
                            break;
                        default:
                            if (this.bf && XmlChar.f(f)) {
                                throw this.ee("Invalid character was found.");
                            }
                            {
                                if (f <= charMaxValue().charCodeAt(0)) {
                                    this.c7.h(String.fromCharCode(f));
                                }
                                else {
                                    this.da(f);
                                }
                            }
                            break;
                    }
                    break;
                }
                d = false;
            }
            if (!c) {
                this.eq.e = this.c7.c;
                this.eq.n = 3;
            }
            this.ep.p = this.b7;
        }
        dz() {
            let a = this.c2();
            if (a != "xml" && stringToLocaleLower(a, CultureInfo.invariantCulture) == "xml") {
                throw this.ee("Not allowed processing instruction name which starts with 'X', 'M', 'L' was found.");
            }
            if (!this.b0()) {
                if (this.ci() != '?'.charCodeAt(0)) {
                    throw this.ee("Invalid processing instruction name was found.");
                }
            }
            this.df();
            let b;
            while ((b = this.ci()) != -1) {
                this.c9(b);
                if (b == '?'.charCodeAt(0) && this.ci() == '>'.charCodeAt(0)) {
                    this.c9('>'.charCodeAt(0));
                    break;
                }
                if (this.bf && XmlChar.f(b)) {
                    throw this.ee("Invalid character was found.");
                }
                this.db(b);
            }
            if (Base.referenceEquals(a, "xml")) {
                this.d7();
            }
            else {
                if (this.eh == 0) {
                    this.eh = 17;
                }
                this.d4(7, a, stringEmpty(), a, false, null, true);
            }
        }
        d7() {
            if (!this.be && this.eh != 0) {
                throw this.ee("XML declaration cannot appear in this state.");
            }
            this.eh = 17;
            let a = this.cz();
            this.de();
            let b = 0;
            let c = null, d = null;
            let e, f;
            let g = this.dp(a, b, e, f);
            b = g.p1;
            e = g.p2;
            f = g.p3;
            if (e != "version" || f != "1.0") {
                throw this.ee("'version' is expected.");
            }
            e = stringEmpty();
            if (((() => { let h = this.b1(a, b); b = h.p1; return h.ret; })()) && b < a.length) {
                let h = this.dp(a, b, e, f);
                b = h.p1;
                e = h.p2;
                f = h.p3;
            }
            if (e == "encoding") {
                if (!XmlChar.o(f)) {
                    throw this.ee("'encoding' must be a valid IANA encoding name.");
                }
                if (typeCast(XmlStreamReader.$, this.cy) !== null) {
                    this.ej.p = this.cy.aa;
                }
                else {
                    if (this.ej.p == null && stringCompare1(f, "UTF-8", 2) == 0) {
                        this.ej.p = Encoding.uTF8;
                    }
                    else {
                        this.ej.p = Encoding.unicode;
                    }
                }
                c = f;
                e = stringEmpty();
                if (((() => { let i = this.b1(a, b); b = i.p1; return i.ret; })()) && b < a.length) {
                    let i = this.dp(a, b, e, f);
                    b = i.p1;
                    e = i.p2;
                    f = i.p3;
                }
            }
            if (e == "standalone") {
                this.bl = f == "yes";
                if (f != "yes" && f != "no") {
                    throw this.ee("Only 'yes' or 'no' is allow for 'standalone'");
                }
                d = f;
                let j = this.b1(a, b);
                b = j.p1;
            }
            else if (e.length != 0) {
                throw this.ee(stringFormat("Unexpected token: '{0}'", e));
            }
            if (b < a.length) {
                throw this.ee("'?' is expected.");
            }
            this.c8("version", "1.0");
            if (c != null) {
                this.c8("encoding", c);
            }
            if (d != null) {
                this.c8("standalone", d);
            }
            this.b6 = this.b7 = -1;
            this.d4(17, "xml", stringEmpty(), "xml", false, a, false);
        }
        b1(a, b) {
            let c = b;
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            return {
                ret: b - c > 0,
                p1: b
            };
        }
        dp(a, b, c, d) {
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            let e = b;
            while (b < a.length && XmlChar.h(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            c = a.substr(e, b - e);
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            if (b == a.length || a.charAt(b) != '=') {
                throw this.ee(stringFormat("'=' is expected after {0}", c));
            }
            b++;
            while (b < a.length && XmlChar.p(a.charAt(b).charCodeAt(0))) {
                b++;
            }
            if (b == a.length || a.charAt(b) != '\"' && a.charAt(b) != '\'') {
                throw this.ee("'\"' or ''' is expected.");
            }
            let f = a.charAt(b);
            b++;
            e = b;
            while (b < a.length && a.charAt(b) != f) {
                b++;
            }
            b++;
            d = a.substr(e, b - e - 1);
            return {
                p1: b,
                p2: c,
                p3: d
            };
        }
        d6() {
            if (this.ci() != '<'.charCodeAt(0)) {
                return;
            }
            this.cp();
            if (this.ci() != '?'.charCodeAt(0)) {
                this.ck = 0;
                return;
            }
            this.cp();
            while (this.ck < 6) {
                if (this.ci() < 0) {
                    break;
                }
                else {
                    this.cp();
                }
            }
            if (stringCreateFromCharArraySlice(this.bc, 2, 4) != "xml ") {
                if (stringToLocaleLower(stringCreateFromCharArraySlice(this.bc, 2, 4), CultureInfo.invariantCulture) == "xml ") {
                    throw this.ee("Processing instruction name must not be character sequence 'X' 'M' 'L' with case insensitivity.");
                }
                this.ck = 0;
                return;
            }
            this.b0();
            if (this.ci() == 'v'.charCodeAt(0)) {
                this.dh("version");
                this.di('=');
                this.b0();
                let a = this.cp();
                let b = new Array(3);
                let c = 0;
                switch (a) {
                    case '\''.charCodeAt(0):
                    case '\"'.charCodeAt(0):
                        while (this.ci() != a) {
                            if (this.ci() == -1) {
                                throw this.ee("Invalid version declaration inside text declaration.");
                            }
                            else if (c == 3) {
                                throw this.ee("Invalid version number inside text declaration.");
                            }
                            else {
                                b[c] = String.fromCharCode(this.cp());
                                c++;
                                if (c == 3 && stringCreateFromCharArray(b) != "1.0") {
                                    throw this.ee("Invalid version number inside text declaration.");
                                }
                            }
                        }
                        this.cp();
                        this.b0();
                        break;
                    default: throw this.ee("Invalid version declaration inside text declaration.");
                }
            }
            if (this.ci() == 'e'.charCodeAt(0)) {
                this.dh("encoding");
                this.di('=');
                this.b0();
                let d = this.cp();
                switch (d) {
                    case '\''.charCodeAt(0):
                    case '\"'.charCodeAt(0):
                        while (this.ci() != d) {
                            if (this.cp() == -1) {
                                throw this.ee("Invalid encoding declaration inside text declaration.");
                            }
                        }
                        this.cp();
                        this.b0();
                        break;
                    default: throw this.ee("Invalid encoding declaration inside text declaration.");
                }
            }
            this.dh("?>");
            this.b5 = this.ck;
        }
        dv() {
            let a = this.ci();
            switch (a) {
                case '-'.charCodeAt(0):
                    this.dh("--");
                    this.du();
                    break;
                case '['.charCodeAt(0):
                    this.cp();
                    this.dh("CDATA[");
                    this.dt();
                    break;
                case 'D'.charCodeAt(0):
                    this.dh("DOCTYPE");
                    this.dw();
                    break;
                default: throw this.ee("Unexpected declaration markup was found.");
            }
        }
        du() {
            if (this.eh == 0) {
                this.eh = 17;
            }
            this.br = false;
            this.df();
            let a;
            while ((a = this.ci()) != -1) {
                this.c9(a);
                if (a == '-'.charCodeAt(0) && this.ci() == '-'.charCodeAt(0)) {
                    this.c9('-'.charCodeAt(0));
                    if (this.ci() != '>'.charCodeAt(0)) {
                        throw this.ee("comments cannot contain '--'");
                    }
                    this.c9('>'.charCodeAt(0));
                    break;
                }
                if (XmlChar.f(a)) {
                    throw this.ee("Not allowed character was found.");
                }
                this.db(a);
            }
            this.d4(8, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
        }
        dt() {
            if (this.eh != 1) {
                throw this.ee("CDATA section cannot appear in this state.");
            }
            this.br = false;
            this.df();
            let a = false;
            let b = 0;
            while (this.ci() != -1) {
                if (!a) {
                    b = this.cp();
                }
                a = false;
                if (b == ']'.charCodeAt(0) && this.ci() == ']'.charCodeAt(0)) {
                    b = this.cp();
                    if (this.ci() == '>'.charCodeAt(0)) {
                        this.cp();
                        break;
                    }
                    else {
                        a = true;
                    }
                }
                if (this.bo && b == '\r'.charCodeAt(0)) {
                    b = this.ci();
                    if (b != '\n'.charCodeAt(0)) {
                        this.db('\n'.charCodeAt(0));
                    }
                    continue;
                }
                if (this.bf && XmlChar.f(b)) {
                    throw this.ee("Invalid character was found.");
                }
                {
                    if (b <= charMaxValue().charCodeAt(0)) {
                        this.c7.h(String.fromCharCode(b));
                    }
                    else {
                        this.da(b);
                    }
                }
            }
            this.d4(4, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
        }
        dw() {
            if (this.bs) {
                throw this.ee("Document Type Declaration (DTD) is prohibited in this XML.");
            }
            switch (this.eh) {
                case 10:
                case 1:
                case 15: throw this.ee("Document type cannot appear in this state.");
            }
            this.eh = 10;
            let a = null;
            let b = null;
            let c = null;
            let d = 0;
            let e = 0;
            this.b0();
            a = this.c2();
            this.b0();
            switch (this.ci()) {
                case 'S'.charCodeAt(0):
                    c = this.c5(true);
                    break;
                case 'P'.charCodeAt(0):
                    b = this.c4();
                    if (!this.b0()) {
                        throw this.ee("Whitespace is required between PUBLIC id and SYSTEM id.");
                    }
                    c = this.c5(false);
                    break;
            }
            this.b0();
            if (this.ci() == '['.charCodeAt(0)) {
                this.cp();
                d = this.cf;
                e = this.cg;
                this.df();
                this.dy();
                this.ej.h = this.cz();
            }
            this.di('>');
            this.d4(10, a, stringEmpty(), a, false, this.ej.h, true);
            if (b != null) {
                this.c8("PUBLIC", b);
            }
            if (c != null) {
                this.c8("SYSTEM", c);
            }
            this.b6 = this.b7 = -1;
        }
        d8(a, b, c, d) {
            return new DTDObjectModel();
        }
        get en() {
            return this.eo.c();
        }
        cv() {
            let a = this.cp();
            this.db(a);
            return a;
        }
        dj(a) {
            this.dh(a);
            this.c7.l(a);
        }
        dy() {
            let a = true;
            L0: while (a) {
                switch (this.cv()) {
                    case ']'.charCodeAt(0):
                        switch (this.en) {
                            case 1:
                                this.c7.y(this.c7.c - 1, 1);
                                a = false;
                                break;
                            case 9:
                            case 8:
                            case 7: continue L0;
                            default: throw this.ee("unexpected end of file at DTD.");
                        }
                        break;
                    case -1: throw this.ee("unexpected end of file at DTD.");
                    case '<'.charCodeAt(0):
                        switch (this.en) {
                            case 9:
                            case 8:
                            case 7: continue L0;
                        }
                        let b = this.cv();
                        switch (b) {
                            case '?'.charCodeAt(0):
                                this.eo.b(6);
                                break;
                            case '!'.charCodeAt(0):
                                switch (this.cv()) {
                                    case 'E'.charCodeAt(0):
                                        switch (this.cv()) {
                                            case 'L'.charCodeAt(0):
                                                this.dj("EMENT");
                                                this.eo.b(2);
                                                break;
                                            case 'N'.charCodeAt(0):
                                                this.dj("TITY");
                                                this.eo.b(4);
                                                break;
                                            default: throw this.ee("unexpected token '<!E'.");
                                        }
                                        break;
                                    case 'A'.charCodeAt(0):
                                        this.dj("TTLIST");
                                        this.eo.b(3);
                                        break;
                                    case 'N'.charCodeAt(0):
                                        this.dj("OTATION");
                                        this.eo.b(5);
                                        break;
                                    case '-'.charCodeAt(0):
                                        this.dj("-");
                                        this.eo.b(7);
                                        break;
                                }
                                break;
                            default: throw this.ee(stringFormat("unexpected '<{0}'.", String.fromCharCode(b)));
                        }
                        break;
                    case '\''.charCodeAt(0):
                        if (this.en == 8) {
                            this.eo.d();
                        }
                        else if (this.en != 9 && this.en != 7) {
                            this.eo.b(8);
                        }
                        break;
                    case '\"'.charCodeAt(0):
                        if (this.en == 9) {
                            this.eo.d();
                        }
                        else if (this.en != 8 && this.en != 7) {
                            this.eo.b(9);
                        }
                        break;
                    case '>'.charCodeAt(0):
                        let t1 = this.en;
                        L1: while (true) {
                            switch (t1) {
                                case 2:
                                    t1 = 5;
                                    continue L1;
                                case 3:
                                    t1 = 5;
                                    continue L1;
                                case 4:
                                    t1 = 5;
                                    continue L1;
                                case 5:
                                    this.eo.d();
                                    break;
                                case 9:
                                case 8:
                                case 7: continue L0;
                                default: throw this.ee("unexpected token '>'");
                            }
                            break;
                        }
                        break;
                    case '?'.charCodeAt(0):
                        if (this.en == 6) {
                            if (this.cv() == '>'.charCodeAt(0)) {
                                this.eo.d();
                            }
                        }
                        break;
                    case '-'.charCodeAt(0):
                        if (this.en == 7) {
                            if (this.ci() == '-'.charCodeAt(0)) {
                                this.cv();
                                this.dj(">");
                                this.eo.d();
                            }
                        }
                        break;
                    case '%'.charCodeAt(0):
                        if (this.en != 1 && this.en != 4 && this.en != 7 && this.en != 9 && this.en != 8) {
                            throw this.ee("Parameter Entity Reference cannot appear as a part of markupdecl (see XML spec 2.8).");
                        }
                        break;
                }
            }
        }
        c5(a) {
            if (a) {
                this.dh("SYSTEM");
                if (!this.b0()) {
                    throw this.ee("Whitespace is required after 'SYSTEM'.");
                }
            }
            else {
                this.b0();
            }
            let b = this.cp();
            let c = 0;
            this.df();
            while (c != b) {
                c = this.cp();
                if (c < 0) {
                    throw this.ee("Unexpected end of stream in ExternalID.");
                }
                if (c != b) {
                    this.db(c);
                }
            }
            return this.cz();
        }
        c4() {
            this.dh("PUBLIC");
            if (!this.b0()) {
                throw this.ee("Whitespace is required after 'PUBLIC'.");
            }
            let a = this.cp();
            let b = 0;
            this.df();
            while (b != a) {
                b = this.cp();
                if (b < 0) {
                    throw this.ee("Unexpected end of stream in ExternalID.");
                }
                if (b != a && !XmlChar.m(b)) {
                    throw this.ee(stringFormat("character '{0}' not allowed for PUBLIC ID", String.fromCharCode(b)));
                }
                if (b != a) {
                    this.db(b);
                }
            }
            return this.cz();
        }
        c2() {
            let a, b;
            return ((() => { let c = this.c3(a, b); a = c.p0; b = c.p1; return c.ret; })());
        }
        c3(a, b) {
            let c = this.br;
            this.br = true;
            let d = this.ck - this.b5;
            let e = this.ci();
            if (!XmlChar.e(e)) {
                throw this.ee(stringFormat2(CultureInfo.invariantCulture, "a name did not start with a legal character {0} ({1})", e, String.fromCharCode(e)));
            }
            this.c9(e);
            let f = 1;
            let g = -1;
            while (XmlChar.h((e = this.ci()))) {
                this.c9(e);
                if (e == ':'.charCodeAt(0) && this.bm && g < 0) {
                    g = f;
                }
                f++;
            }
            let h = this.b5 + d;
            let i = this.a5.a(this.bc, h, f);
            if (g > 0) {
                a = this.a5.a(this.bc, h, g);
                b = this.a5.a(this.bc, h + g + 1, f - g - 1);
            }
            else {
                a = stringEmpty();
                b = i;
            }
            this.br = c;
            return {
                ret: i,
                p0: a,
                p1: b
            };
        }
        dg(a) {
            let b = this.cp();
            if (b != a) {
                throw this.ee(stringFormat2(CultureInfo.invariantCulture, "expected '{0}' ({1:X}) but found '{2}' ({3:X})", String.fromCharCode(a), a, b < 0 ? "EOF" : String.fromCharCode(b), b));
            }
        }
        dh(a) {
            for (let b = 0; b < a.length; b++) {
                if (this.cp() != a.charAt(b).charCodeAt(0)) {
                    throw this.ee(stringFormat2(CultureInfo.invariantCulture, "'{0}' is expected", a));
                }
            }
        }
        di(a) {
            while (true) {
                let b = this.cp();
                if (b < 33 && XmlChar.p(b)) {
                    continue;
                }
                if (a.charCodeAt(0) != b) {
                    throw this.ee(stringFormat2(CultureInfo.invariantCulture, "Expected {0}, but found {1} [{2}]", a, b < 0 ? "EOF" : String.fromCharCode(b), b));
                }
                break;
            }
        }
        b0() {
            let a = this.ci();
            let b = (a == 32 || a == 9 || a == 10 || a == 13);
            if (!b) {
                return false;
            }
            this.c9(a);
            while ((a = this.ci()) == 32 || a == 9 || a == 10 || a == 13) {
                this.c9(a);
            }
            return b;
        }
        by() {
            if (this.eh == 0) {
                this.eh = 17;
            }
            let a = this.br;
            this.br = true;
            let b = this.ck - this.b5;
            let c = this.ci();
            do {
                this.c9(c);
                c = this.ci();
            } while (c == 32 || c == 9 || c == 10 || c == 13);
            let d = this.eh == 1 && c != -1 && c != '<'.charCodeAt(0);
            if (!d && (this.ec == 2 || this.ec == 1 && this.a8 != 2)) {
                return false;
            }
            this.df();
            this.c7.g(this.bc, this.b5, this.ck - this.b5 - b);
            this.br = a;
            if (d) {
                this.d1(false);
            }
            else {
                let e = (this.a8 == 2) ? 14 : 13;
                this.d4(e, stringEmpty(), stringEmpty(), stringEmpty(), false, null, true);
            }
            return true;
        }
        cs(a, b, c) {
            let d = b;
            for (let e = 0; e < c; e++) {
                let f = this.ci();
                switch (f) {
                    case -1: throw this.ee("Unexpected end of xml.");
                    case '<'.charCodeAt(0):
                        if (e + 1 == c) {
                            return e;
                        }
                        this.c9(f);
                        if (this.ci() != '/'.charCodeAt(0)) {
                            this.ch++;
                            a[d++] = '<';
                            continue;
                        }
                        else if (this.ch-- > 0) {
                            a[d++] = '<';
                            continue;
                        }
                        this.dg('/'.charCodeAt(0));
                        if (this.bj) {
                            this.ca++;
                            this.bj = false;
                        }
                        this.dx();
                        this.bu = false;
                        this.t();
                        return e;
                    default:
                        this.c9(f);
                        if (f <= charMaxValue().charCodeAt(0)) {
                            a[d++] = String.fromCharCode(f);
                        }
                        else {
                            a[d++] = String.fromCharCode((intDivide((f - 65536), 1024) + 55296));
                            a[d++] = String.fromCharCode(((f - 65536) % 1024 + 56320));
                        }
                        break;
                }
            }
            return c;
        }
        bx() {
            if (this.x == 0) {
                this.eh = 15;
            }
            let a;
            do {
                a = this.cp();
                switch (a) {
                    case -1: throw this.ee("Unexpected end of xml.");
                    case '<'.charCodeAt(0):
                        if (this.ci() != '/'.charCodeAt(0)) {
                            this.ch++;
                            continue;
                        }
                        else if (--this.ch > 0) {
                            continue;
                        }
                        this.cp();
                        let b = this.c2();
                        if (b != this.bb[this.cc - 1].b) {
                            continue;
                        }
                        this.dg('>'.charCodeAt(0));
                        this.ca--;
                        return this.t();
                }
            } while (true);
        }
    }
    XmlTextReader.$t = /*@__PURE__*/ markType(XmlTextReader, 'XmlTextReader', XmlReader.$);
    return XmlTextReader;
})();
/**
 * @hidden
 */
let XmlTextReader_XmlTokenInfo = /*@__PURE__*/ (() => {
    class XmlTextReader_XmlTokenInfo extends Base {
        constructor(a) {
            super();
            this.l = null;
            this.o = null;
            this.h = null;
            this.g = null;
            this.j = null;
            this.i = null;
            this.a = false;
            this.b = '\0';
            this.c = 0;
            this.d = 0;
            this.f = 0;
            this.e = 0;
            this.n = 0;
            this.o = a;
            this.m();
        }
        get_k() {
            if (this.l == null) {
                if (this.f >= 0) {
                    this.l = this.o.c7.f(this.f, this.e - this.f);
                }
                else {
                    switch (this.n) {
                        case 3:
                        case 14:
                        case 13:
                        case 8:
                        case 4:
                        case 7:
                            this.l = this.o.cz();
                            break;
                    }
                }
            }
            return this.l;
        }
        set_k(a) {
            this.l = a;
        }
        get k() {
            return this.get_k();
        }
        set k(a) {
            this.set_k(a);
        }
        m() {
            this.f = -1;
            this.l = null;
            this.n = 0;
            this.h = this.g = this.j = this.i = stringEmpty();
            this.a = false;
            this.b = '\"';
            this.c = this.d = 0;
        }
    }
    XmlTextReader_XmlTokenInfo.$t = /*@__PURE__*/ markType(XmlTextReader_XmlTokenInfo, 'XmlTextReader_XmlTokenInfo');
    return XmlTextReader_XmlTokenInfo;
})();
/**
 * @hidden
 */
let XmlTextReader_XmlAttributeTokenInfo = /*@__PURE__*/ (() => {
    class XmlTextReader_XmlAttributeTokenInfo extends XmlTextReader_XmlTokenInfo {
        constructor(a) {
            super(a);
            this.q = 0;
            this.p = 0;
            this.r = null;
            this.s = new StringBuilder(0);
            this.n = 2;
        }
        get_k() {
            if (this.r != null) {
                return this.r;
            }
            if (this.q == this.p) {
                let a = this.o.ba[this.q];
                if (a.n == 5) {
                    this.r = stringConcat("&", a.h, ";");
                }
                else {
                    this.r = a.k;
                }
                return this.r;
            }
            this.s.c = 0;
            for (let b = this.q; b <= this.p; b++) {
                let c = this.o.ba[b];
                if (c.n == 3) {
                    this.s.l(c.k);
                }
                else {
                    this.s.h('&');
                    this.s.l(c.h);
                    this.s.h(';');
                }
            }
            this.r = this.s.f(0, this.s.c);
            return this.r;
        }
        set_k(a) {
            this.r = a;
        }
        m() {
            super.m();
            this.r = null;
            this.n = 2;
            this.q = this.p = 0;
        }
        u() {
            if (Base.referenceEquals(this.j, "xmlns")) {
                this.o.ef.x(this.g, this.k);
            }
            else if (Base.referenceEquals(this.h, "xmlns")) {
                this.o.ef.x(stringEmpty(), this.k);
            }
        }
        t() {
            if (Base.referenceEquals(this.j, "xmlns") || Base.referenceEquals(this.h, "xmlns")) {
                this.i = "http://www.w3.org/2000/xmlns/";
            }
            else if (this.j.length == 0) {
                this.i = stringEmpty();
            }
            else {
                this.i = this.o.c1(this.j, true);
            }
        }
    }
    XmlTextReader_XmlAttributeTokenInfo.$t = /*@__PURE__*/ markType(XmlTextReader_XmlAttributeTokenInfo, 'XmlTextReader_XmlAttributeTokenInfo', XmlTextReader_XmlTokenInfo.$);
    return XmlTextReader_XmlAttributeTokenInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

// XmlSpace.cs
/**
 * Specifies the current xml:space scope
 */
var XmlSpace = /*@__PURE__*/ (function (XmlSpace) {
    /**
     * No xml:space scope.
     */
    XmlSpace[XmlSpace["None"] = 0] = "None";
    /**
     * the xml:space scope = "default"
     */
    XmlSpace[XmlSpace["Default"] = 1] = "Default";
    /**
     * the xml:space scope = "preserve"
     */
    XmlSpace[XmlSpace["Preserve"] = 2] = "Preserve";
    return XmlSpace;
})({});
/**
 * @hidden
 */
let XmlSpace_$type = /*@__PURE__*/ markEnum('XmlSpace', 'None,0|Default,1|Preserve,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

// From https://github.com/mosa/Mono-Class-Libraries/blob/28840dee90750d61ed6cbdb753292cd64cac169e/mcs/class/System.XML/System.Xml/XmlTextWriter2.cs
/**
 * @hidden
 */
let XmlTextWriter_XmlDeclState_$type = /*@__PURE__*/ markEnum('XmlTextWriter_XmlDeclState', 'Allow,0|Ignore,1|Auto,2|Prohibit,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

export { APIFactory, AbsoluteVolumeOscillatorIndicatorDescription, AbsoluteVolumeOscillatorIndicatorDescriptionMetadata, AbsoluteVolumeOscillatorIndicatorDescriptionModule, AbstractEnumerable, AbstractEnumerator, AccumulationDistributionIndicatorDescription, AccumulationDistributionIndicatorDescriptionMetadata, AccumulationDistributionIndicatorDescriptionModule, Activator, AggregateException, AlignLinearGraphLabelEventArgsDescription, AlignLinearGraphLabelEventArgsDescriptionMetadata, AlignRadialGaugeLabelEventArgsDescription, AlignRadialGaugeLabelEventArgsDescriptionMetadata, AnchoredCategorySeriesDescription, AnchoredCategorySeriesDescriptionMetadata, AnchoredRadialSeriesDescription, AnchoredRadialSeriesDescriptionMetadata, AngleSimplifier, AngularCodeBehindCodeGeneratingComponentRendererCodeEmitter, AngularTemplateCodeGeneratingComponentRendererCodeEmitter, AnimationBrowserTickProvider, AnimationKeyFrame, AnimationKeyFrameEffect, AnimationKeyFrameEffectTargetType_$type, AnimationKeyFrameEffectTiming, AnimationKeyFrameProperty, AnimationManager, AnimationState, AnnotationLayerDescription, AnnotationLayerDescriptionMetadata, AnnotationLayerProxyDescriptionModule, AppearanceHelper, ArcGISOnlineMapImageryDescription, ArcGISOnlineMapImageryDescriptionMetadata, ArcGISOnlineMapImageryDescriptionModule, ArcGISOnlineTileSource, ArcSegment, ArcSegmentData, AreaFragmentDescription, AreaFragmentDescriptionMetadata, AreaFragmentDescriptionModule, AreaSeriesDescription, AreaSeriesDescriptionMetadata, AreaSeriesDescriptionModule, ArgumentException, ArgumentNullException, ArgumentOutOfRangeException, ArrayAccessHelper, ArrayBox$1, ArrayExtension, Array_$type, AsciiEncoding, AssigningCategoryMarkerStyleEventArgsDescription, AssigningCategoryMarkerStyleEventArgsDescriptionMetadata, AssigningCategoryStyleEventArgsBaseDescription, AssigningCategoryStyleEventArgsBaseDescriptionMetadata, AssigningCategoryStyleEventArgsDescription, AssigningCategoryStyleEventArgsDescriptionMetadata, AssigningPolarMarkerStyleEventArgsDescription, AssigningPolarMarkerStyleEventArgsDescriptionMetadata, AssigningPolarStyleEventArgsBaseDescription, AssigningPolarStyleEventArgsBaseDescriptionMetadata, AssigningPolarStyleEventArgsDescription, AssigningPolarStyleEventArgsDescriptionMetadata, AssigningRadialMarkerStyleEventArgsDescription, AssigningRadialMarkerStyleEventArgsDescriptionMetadata, AssigningRadialStyleEventArgsBaseDescription, AssigningRadialStyleEventArgsBaseDescriptionMetadata, AssigningRadialStyleEventArgsDescription, AssigningRadialStyleEventArgsDescriptionMetadata, AssigningScatterMarkerStyleEventArgsDescription, AssigningScatterMarkerStyleEventArgsDescriptionMetadata, AssigningScatterStyleEventArgsBaseDescription, AssigningScatterStyleEventArgsBaseDescriptionMetadata, AssigningScatterStyleEventArgsDescription, AssigningScatterStyleEventArgsDescriptionMetadata, AssigningSeriesShapeStyleEventArgsBaseDescription, AssigningSeriesShapeStyleEventArgsBaseDescriptionMetadata, AssigningSeriesStyleEventArgsBaseDescription, AssigningSeriesStyleEventArgsBaseDescriptionMetadata, AssigningShapeMarkerStyleEventArgsDescription, AssigningShapeMarkerStyleEventArgsDescriptionMetadata, AssigningShapeStyleEventArgsBaseDescription, AssigningShapeStyleEventArgsBaseDescriptionMetadata, AssigningShapeStyleEventArgsDescription, AssigningShapeStyleEventArgsDescriptionMetadata, AsyncCompletedEventArgs, AsyncCompletedEventArgsDescription, AsyncCompletedEventArgsDescriptionMetadata, AsyncDataSourcePageRequest, AsyncDataSourcePageTaskHolder, AsyncVirtualDataSourceDataProviderWorkerSettings, AsyncVirtualDataSourceProviderTaskDataHolder, AsyncVirtualDataSourceProviderWorker, AsyncVirtualDataTask, AverageDirectionalIndexIndicatorDescription, AverageDirectionalIndexIndicatorDescriptionMetadata, AverageDirectionalIndexIndicatorDescriptionModule, AverageSummaryCalculator, AverageTrueRangeIndicatorDescription, AverageTrueRangeIndicatorDescriptionMetadata, AverageTrueRangeIndicatorDescriptionModule, AxisAnnotationDescription, AxisAnnotationDescriptionMetadata, AxisDescription, AxisDescriptionMetadata, AxisRangeChangedEventArgsDescription, AxisRangeChangedEventArgsDescriptionMetadata, BarFragmentDescription, BarFragmentDescriptionMetadata, BarFragmentDescriptionModule, BarSeriesDescription, BarSeriesDescriptionMetadata, BarSeriesDescriptionModule, Base, BaseControlTheme, BaseControlTheme_$type, BaseDOMEventProxy, BaseDataSource, BaseDataSourceDescription, BaseDataSourceDescriptionMetadata, BaseError, BaseTransactionService, BezierSegment, BezierSegmentData, BinaryFileDownloader, BinaryReader, BinaryUtil, BinaryWriter, Binding, BindingFormatter, BingMapsMapImageryDescription, BingMapsMapImageryDescriptionMetadata, BingMapsMapImageryDescriptionModule, BingMapsTileSource, BitArray, BitConverter, BollingerBandWidthIndicatorDescription, BollingerBandWidthIndicatorDescriptionMetadata, BollingerBandWidthIndicatorDescriptionModule, BollingerBandsOverlayDescription, BollingerBandsOverlayDescriptionMetadata, BollingerBandsOverlayDescriptionModule, Boolean_$type, BottomClipper, Brush, BrushAppearanceData, BrushCollection, BrushCollectionUtil, BrushScaleDescription, BrushScaleDescriptionMetadata, BrushScaleDescriptionModule, BrushUtil, BrushUtilCore, BubbleSeriesDescription, BubbleSeriesDescriptionMetadata, BubbleSeriesDescriptionModule, Buffer, BulletGraphCoreDescriptionModule, BulletGraphDescription, BulletGraphDescriptionMetadata, BulletGraphDescriptionModule, ButtonClickEventArgsDescription, ButtonClickEventArgsDescriptionMetadata, ButtonDescription, ButtonDescriptionMetadata, ButtonDescriptionModule, ButtonGroupDescription, ButtonGroupDescriptionMetadata, ButtonGroupDescriptionModule, ButtonGroupSelectionChangedEventArgsDescription, ButtonGroupSelectionChangedEventArgsDescriptionMetadata, CalculatedColumnDescription, CalculatedColumnDescriptionMetadata, Calendar, CalendarDescription, CalendarDescriptionMetadata, CalendarDescriptionModule, CalendarWeekRule_$type, CalloutAnnotationDescription, CalloutAnnotationDescriptionMetadata, CalloutContentUpdatingEventArgsDescription, CalloutContentUpdatingEventArgsDescriptionMetadata, CalloutLabelUpdatingEventArgsDescription, CalloutLabelUpdatingEventArgsDescriptionMetadata, CalloutLayerDescription, CalloutLayerDescriptionMetadata, CalloutLayerDescriptionModule, CalloutSeriesSelectingEventArgsDescription, CalloutSeriesSelectingEventArgsDescriptionMetadata, CalloutStyleUpdatingEventArgsDescription, CalloutStyleUpdatingEventArgsDescriptionMetadata, CancelBehavior, CancelBehavior_$type, CancelEventArgs, CancellingMultiScaleImageEventArgs, CancellingMultiScaleImageEventArgsDescription, CancellingMultiScaleImageEventArgsDescriptionMetadata, Canvas, CanvasGestureDOMEventProxy, CanvasRenderScheduler, CanvasViewRenderer, Capture, CategoryAngleAxisDescription, CategoryAngleAxisDescriptionMetadata, CategoryAngleAxisDescriptionModule, CategoryAxisBaseDescription, CategoryAxisBaseDescriptionMetadata, CategoryChartCoreDescriptionModule, CategoryChartDescription, CategoryChartDescriptionMetadata, CategoryChartDescriptionModule, CategoryDateTimeXAxisDescription, CategoryDateTimeXAxisDescriptionMetadata, CategoryDateTimeXAxisDescriptionModule, CategoryHighlightLayerDescription, CategoryHighlightLayerDescriptionMetadata, CategoryHighlightLayerDescriptionModule, CategoryItemHighlightLayerDescription, CategoryItemHighlightLayerDescriptionMetadata, CategoryItemHighlightLayerDescriptionModule, CategorySeriesDescription, CategorySeriesDescriptionMetadata, CategoryToolTipLayerDescription, CategoryToolTipLayerDescriptionMetadata, CategoryToolTipLayerDescriptionModule, CategoryXAxisDescription, CategoryXAxisDescriptionMetadata, CategoryXAxisDescriptionModule, CategoryYAxisDescription, CategoryYAxisDescriptionMetadata, CategoryYAxisDescriptionModule, CellActionManagerDescription, CellActionManagerDescriptionMetadata, CellInfoDescription, CellInfoDescriptionMetadata, CellKeyDescription, CellKeyDescriptionMetadata, CellKeyDescriptionModule, CellRangeDescription, CellRangeDescriptionMetadata, CellRangeDescriptionModule, CellStyleRequestedEventArgsDescription, CellStyleRequestedEventArgsDescriptionMetadata, ChaikinOscillatorIndicatorDescription, ChaikinOscillatorIndicatorDescriptionMetadata, ChaikinOscillatorIndicatorDescriptionModule, ChaikinVolatilityIndicatorDescription, ChaikinVolatilityIndicatorDescriptionMetadata, ChaikinVolatilityIndicatorDescriptionModule, ChartCursorEventArgsDescription, ChartCursorEventArgsDescriptionMetadata, ChartMouseEventArgsDescription, ChartMouseEventArgsDescriptionMetadata, ChartSeriesEventArgsDescription, ChartSeriesEventArgsDescriptionMetadata, CheckboxChangeEventArgsDescription, CheckboxChangeEventArgsDescriptionMetadata, CheckboxDescription, CheckboxDescriptionMetadata, CheckboxDescriptionModule, CheckboxListDescription, CheckboxListDescriptionMetadata, CheckboxListDescriptionModule, CheckedChangedEventArgsDescription, CheckedChangedEventArgsDescriptionMetadata, ChildContentDescriptionModule, ChildContentExtendedDescriptionModule, Clipboard, Clipper, CodeGeneratingCodeWriter, CodeGeneratingComponentRenderer, CodeGeneratingComponentRendererCodeEmitter, CodeGeneratingComponentRendererDataEmitter, CodeGeneratingComponentRendererDataEmitterItemType, CodeGeneratingComponentRendererDataEmitterPropertyType, CodeGeneratingComponentRendererHandlerEmitter, CodeGeneratingComponentRendererModuleEmitter, CodeGeneratingRendererResult, CodeGenerationContainer, CodeGenerationFolderTemplate, CodeGenerationItemBuilder, CodeGenerationItemBuilderPropertyInfo, CodeGenerationLibrary, CodeGenerationLibraryItem, CodeGenerationLibraryItemContent, CodeGenerationLibraryItemPlatform, CodeGenerationLibraryItemPlatform_$type, CodeGenerationLibraryItemType, CodeGenerationLibraryItemType_$type, CodeGenerationRendererAdapter, CodeGenerationRendererOptions, CodeGenerationSpecialValue, CodeGenerationSpecialValueType_$type, CodeGenerationTargetPlatforms, CodeGenerationTargetPlatforms_$type, CodeGenerationTransformer, Collection$1, CollectionAdapter, Color, ColorCollectionUtil, ColorData, ColorScaleDescription, ColorScaleDescriptionMetadata, ColorUtil, ColumnChooserDescription, ColumnChooserDescriptionMetadata, ColumnChooserDescriptionModule, ColumnComparisonFilterConditionDescription, ColumnComparisonFilterConditionDescriptionMetadata, ColumnDescription, ColumnDescriptionMetadata, ColumnExchangerDescription, ColumnExchangerDescriptionMetadata, ColumnFilterConditionDescription, ColumnFilterConditionDescriptionMetadata, ColumnFilterConditionGroupDescription, ColumnFilterConditionGroupDescriptionMetadata, ColumnFragmentDescription, ColumnFragmentDescriptionMetadata, ColumnFragmentDescriptionModule, ColumnGroupDescriptionDescription, ColumnGroupDescriptionDescriptionMetadata, ColumnGroupDescriptionDescriptionModule, ColumnHiddenChangedEventArgsDescription, ColumnHiddenChangedEventArgsDescriptionMetadata, ColumnMovingSeparatorDescription, ColumnMovingSeparatorDescriptionMetadata, ColumnMovingSeparatorDescriptionModule, ColumnPinnedChangedEventArgsDescription, ColumnPinnedChangedEventArgsDescriptionMetadata, ColumnPinningDescription, ColumnPinningDescriptionMetadata, ColumnPinningDescriptionModule, ColumnPropertySetterDescription, ColumnPropertySetterDescriptionMetadata, ColumnReference, ColumnResizingSeparatorDescription, ColumnResizingSeparatorDescriptionMetadata, ColumnResizingSeparatorDescriptionModule, ColumnSeriesDescription, ColumnSeriesDescriptionMetadata, ColumnSeriesDescriptionModule, ColumnSortDescriptionDescription, ColumnSortDescriptionDescriptionMetadata, ColumnSortDescriptionDescriptionModule, ColumnSummaryDescriptionDescription, ColumnSummaryDescriptionDescriptionMetadata, ColumnSummaryDescriptionDescriptionModule, ColumnSupportingCalculationDescription, ColumnSupportingCalculationDescriptionMetadata, ColumnWidthDescription, ColumnWidthDescriptionMetadata, ColumnWidthDescriptionModule, ComboBoxColumnDescription, ComboBoxColumnDescriptionMetadata, ComboBoxColumnDescriptionModule, CommodityChannelIndexIndicatorDescription, CommodityChannelIndexIndicatorDescriptionMetadata, CommodityChannelIndexIndicatorDescriptionModule, CompareInfo, CompareUtil, Comparer$1, CompletedSinkImpl, ComponentRenderer, ComponentRendererAdapter, ContainerState, ContentChildrenManager, ContentControl, ContourValueResolverDescription, ContourValueResolverDescriptionMetadata, Control, ControlDisplayDensity, ControlDisplayDensity_$type, Convert, ConvertUtil, CoreGeometryUtil, CornerRadius, CountSummaryCalculator, CrosshairLayerDescription, CrosshairLayerDescriptionMetadata, CrosshairLayerDescriptionModule, CssColorPropertyAccessor, CssCornerRadiusPropertyAccessor, CssFloatPropertyAccessor, CssGradientUtil, CssHelper, CssLengthArrayPropertyAccessor, CssLengthPropertyAccessor, CssPixelsPropertyAccessor, CssThicknessPropertyAccessor, CssTransformPropertyAccessor, CultureInfo, CustomContourValueResolverDescription, CustomContourValueResolverDescriptionMetadata, CustomContourValueResolverDescriptionModule, CustomContourValueResolverEventArgsDescription, CustomContourValueResolverEventArgsDescriptionMetadata, CustomIndicatorDescription, CustomIndicatorDescriptionMetadata, CustomIndicatorDescriptionModule, CustomMapImageryDescription, CustomMapImageryDescriptionMetadata, CustomMapImageryDescriptionModule, CustomMapTileSource, CustomPaletteBrushScaleDescription, CustomPaletteBrushScaleDescriptionMetadata, CustomPaletteBrushScaleDescriptionModule, CustomPaletteColorScaleDescription, CustomPaletteColorScaleDescriptionMetadata, CustomPaletteColorScaleDescriptionModule, DOMEventProxy, DOMExecutionContext, DTDObjectModel, DVContainer, DVInteractivityDescriptionModule, DVSR, DataBindingEventArgsDescription, DataBindingEventArgsDescriptionMetadata, DataChartAnnotationDescriptionModule, DataChartCategoryCoreDescriptionModule, DataChartCategoryDescriptionModule, DataChartCategoryTrendLineDescriptionModule, DataChartCoreDescriptionModule, DataChartDefaultTooltipsDescriptionMetadata, DataChartDefaultTooltipsExtendedDescriptionMetadata, DataChartDescription, DataChartDescriptionMetadata, DataChartExtendedAxesDescriptionModule, DataChartFinancialCoreDescriptionModule, DataChartFinancialDescriptionModule, DataChartFinancialIndicatorsDescriptionModule, DataChartFinancialOverlaysDescriptionModule, DataChartInteractivityDescriptionModule, DataChartMouseButtonEventArgsDescription, DataChartMouseButtonEventArgsDescriptionMetadata, DataChartPolarCoreDescriptionModule, DataChartPolarDescriptionModule, DataChartRadialCoreDescriptionModule, DataChartRadialDescriptionModule, DataChartScatterCoreDescriptionModule, DataChartScatterDescriptionModule, DataChartShapeCoreDescriptionModule, DataChartShapeDescriptionModule, DataChartStackedDescriptionModule, DataChartVerticalCategoryCoreDescriptionModule, DataChartVerticalCategoryDescriptionModule, DataChartVisualDataDescriptionModule, DataContext, DataContextDescription, DataContextDescriptionMetadata, DataFormats, DataGridAllColumnsDescriptionModule, DataGridCoreDescriptionModule, DataGridDescription, DataGridDescriptionMetadata, DataGridDescriptionModule, DataGridExpansionIndicatorDescription, DataGridExpansionIndicatorDescriptionMetadata, DataGridFilterDialogDescription, DataGridFilterDialogDescriptionMetadata, DataGridSortIndicatorDescription, DataGridSortIndicatorDescriptionMetadata, DataGridToolbarDescription, DataGridToolbarDescriptionMetadata, DataGridToolbarDescriptionModule, DataObject, DataSeries, DataSeriesAdapter, DataSeriesAdapterImplementation, DataSeriesAdapterRemovingDuplicatesEventArgs, DataSeriesAdapterRuleCollection, DataSeriesAdapterRunContext, DataSeriesAdapterRunEventArgs, DataSeriesAdapterUpdateNotifier, DataSeriesAxisType, DataSeriesAxisType_$type, DataSeriesCollection, DataSeriesDataProviderAnalyzer, DataSeriesIntent, DataSeriesIntent_$type, DataSeriesMarker, DataSeriesMarker_$type, DataSeriesMemberPathHint, DataSeriesType, DataSeriesType_$type, DataSourceAggregatedResult, DataSourceAggregatedResultDescription, DataSourceAggregatedResultDescriptionMetadata, DataSourceBatchCompletedEventArgs, DataSourceBatchStartedEventArgs, DataSourceDataCommittedEventArgs, DataSourceDataProviderSchemaChangedEventArgs, DataSourceDataProviderSchemaChangedEventArgsDescription, DataSourceDataProviderSchemaChangedEventArgsDescriptionMetadata, DataSourceExecutionContext, DataSourceLocalDataProvider, DataSourcePageRequestPriority, DataSourcePageRequestPriority_$type, DataSourcePropertiesComparer, DataSourceRowExpansionChangedEventArgs, DataSourceRowExpansionChangedEventArgsDescription, DataSourceRowExpansionChangedEventArgsDescriptionMetadata, DataSourceRowType, DataSourceRowType_$type, DataSourceSchemaChangedEventArgs, DataSourceSchemaChangedEventArgsDescription, DataSourceSchemaChangedEventArgsDescriptionMetadata, DataSourceSchemaPropertyType, DataSourceSchemaPropertyType_$type, DataSourceSectionHeaderDisplayMode, DataSourceSectionHeaderDisplayMode_$type, DataSourceSpecialRow, DataSourceSpecialRowDescription, DataSourceSpecialRowDescriptionMetadata, DataSourceSummaryScope, DataSourceSummaryScope_$type, DataSourceSupportingCalculationDescription, DataSourceSupportingCalculationDescriptionMetadata, DataSourceVelocityReading, DataSourceVelocityTracker, DataTemplate, DataTemplateMeasureInfo, DataTemplatePassInfo, DataTemplateRenderInfo, DataVisualizationLocaleDe, DataVisualizationLocaleEn, DataVisualizationLocaleEs, DataVisualizationLocaleFr, DataVisualizationLocaleIt, DataVisualizationLocaleJa, DataVisualizationLocaleKo, DataVisualizationLocaleZhHans, DataVisualizationLocaleZhHant, DatePickerDescription, DatePickerDescriptionMetadata, DatePickerDescriptionModule, DateTimeCellInfoDescription, DateTimeCellInfoDescriptionMetadata, DateTimeColumnDescription, DateTimeColumnDescriptionMetadata, DateTimeColumnDescriptionModule, DateTimeFormat, DateTimeFormatSpecifier, DateTimeFormatSpecifierDescription, DateTimeFormatSpecifierDescriptionMetadata, DateTimeFormatSpecifierDescriptionModule, DateTimeKind_$type, Date_$type, DayOfWeek, DayOfWeek_$type, Debug, Decoder, DecoderExceptionFallback, DecoderExceptionFallbackBuffer, DecoderFallback, DecoderFallbackBuffer, DecoderFallbackException, DecoderReplacementFallback, DecoderReplacementFallbackBuffer, DefaultComparer$1, DefaultDataSourceDataProviderUpdateNotifier, DefaultDataSourceSchema, DefaultDecoder, DefaultEqualityComparer$1, DefaultODataLiteralEmitter, DefaultSectionInformation, DefaultSummaryResult, DefinitionBaseDescription, DefinitionBaseDescriptionMetadata, Delegate_$type, DependencyObject, DependencyObjectNotifier, DependencyPropertiesCollection, DependencyProperty, DependencyPropertyChangedEventArgs, Description, DescriptionPropertyValue, DescriptionRef, DescriptionRefValueChangedEventArgs, DescriptionResult, DescriptionSerializer, DescriptionSerializerBuilder, DescriptionTreeAction, DescriptionTreeActionType_$type, DescriptionTreeBuilder, DescriptionTreeNode, DescriptionTreeReconciler, DescriptionTreeReconciler_TreeModeData, DetrendedPriceOscillatorIndicatorDescription, DetrendedPriceOscillatorIndicatorDescriptionMetadata, DetrendedPriceOscillatorIndicatorDescriptionModule, DeviceUtils, Dictionary$2, DictionaryUtil, Dictionary_EnumerableCollection$3, DiffApplyInfo, DomPortal_$type, DomRenderer_$type, DomWrapper_$type, DomainChartDescription, DomainChartDescriptionMetadata, DomainChartSeriesPointerEventArgsDescription, DomainChartSeriesPointerEventArgsDescriptionMetadata, DotNetCodeGeneratingComponentRendererDataEmitter, DotNetCodeGeneratingComponentRendererHandlerEmitter, DotNetCodeGeneratingComponentRendererModuleEmitter, DoubleAnimator, DoubleCollection, DoubleValueChangedEventArgs, DoubleValueChangedEventArgsDescription, DoubleValueChangedEventArgsDescriptionMetadata, DoughnutChartCoreDescriptionModule, DoughnutChartDefaultTooltipsDescriptionMetadata, DoughnutChartDefaultTooltipsExtendedDescriptionMetadata, DoughnutChartDescription, DoughnutChartDescriptionMetadata, DoughnutChartDescriptionModule, DoughnutChartInteractivityDescriptionModule, DownloadingMultiScaleImageEventArgs, DownloadingMultiScaleImageEventArgsDescription, DownloadingMultiScaleImageEventArgsDescriptionMetadata, EaseOfMovementIndicatorDescription, EaseOfMovementIndicatorDescriptionMetadata, EaseOfMovementIndicatorDescriptionModule, EasingFunctions, EdgeClipper, EdgeComparer, EditorCellInfoDescription, EditorCellInfoDescriptionMetadata, EditorRowCellInfoDescription, EditorRowCellInfoDescriptionMetadata, ElevationHelper, ElevationMode, ElevationMode_$type, EllipseGeometry, EllipseGeometryData, EmbeddedRefDescription, Encoding, EntityHandling, EntityHandling_$type, Enum, EnumUtil, Enumerable, EnumerableWrapper, EnumerableWrapperObject, EnumeratorWrapper, EnumeratorWrapperObject, Environment, EqualityComparer$1, ErrorBarCalculatorReference, ErrorBarCalculatorReference_$type, ErrorBarCalculatorType, ErrorBarCalculatorType_$type, ErrorMessageDisplayingEventArgs, EventArgs, EventProxy, ExpansionPanelDescription, ExpansionPanelDescriptionMetadata, ExpansionPanelDescriptionModule, ExpressionSyntax, Extensions, FastFlattener, FastItemColumn, FastItemDateTimeColumn, FastItemIntColumn, FastItemObjectColumn, FastItemsSource, FastItemsSourceEventAction, FastItemsSourceEventAction_$type, FastItemsSourceEventArgs, FastItemsSourceReference, FastIterationDictionary$2, FastReflectionHelper, FastStochasticOscillatorIndicatorDescription, FastStochasticOscillatorIndicatorDescriptionMetadata, FastStochasticOscillatorIndicatorDescriptionModule, FaultCode, FaultException, FaultException$1, FaultReason, FillRule, FillRule_$type, FilterApplyButtonClickEventArgsDescription, FilterApplyButtonClickEventArgsDescriptionMetadata, FilterCancelButtonClickEventArgsDescription, FilterCancelButtonClickEventArgsDescriptionMetadata, FilterDialogRenderCompletedEventArgsDescription, FilterDialogRenderCompletedEventArgsDescriptionMetadata, FilterExpression, FilterExpressionCollection, FilterExpressionDescription, FilterExpressionDescriptionMetadata, FilterExpressionFunctionType, FilterExpressionFunctionType_$type, FilterExpressionOperatorType, FilterExpressionOperatorType_$type, FilterExpressionVisitor, FilterFactory, FinalValueLayerDescription, FinalValueLayerDescriptionMetadata, FinalValueLayerDescriptionModule, FinancialCalculationDataSourceDescription, FinancialCalculationDataSourceDescriptionMetadata, FinancialCalculationSupportingCalculationsDescription, FinancialCalculationSupportingCalculationsDescriptionMetadata, FinancialChartCoreDescriptionModule, FinancialChartCustomIndicatorArgsDescription, FinancialChartCustomIndicatorArgsDescriptionMetadata, FinancialChartDefaultTemplatesDescriptionMetadata, FinancialChartDefaultTemplatesExtendedDescriptionMetadata, FinancialChartDescription, FinancialChartDescriptionMetadata, FinancialChartDescriptionModule, FinancialDataAdapter, FinancialEventArgsDescription, FinancialEventArgsDescriptionMetadata, FinancialIndicatorDescription, FinancialIndicatorDescriptionMetadata, FinancialLegendDescription, FinancialLegendDescriptionMetadata, FinancialLegendDescriptionModule, FinancialOverlayDescription, FinancialOverlayDescriptionMetadata, FinancialPriceSeriesDescription, FinancialPriceSeriesDescriptionMetadata, FinancialPriceSeriesDescriptionModule, FinancialSeriesDescription, FinancialSeriesDescriptionMetadata, Flattener, FlattenerSettings, FontInfo, FontUtil, ForceIndexIndicatorDescription, ForceIndexIndicatorDescriptionMetadata, ForceIndexIndicatorDescriptionModule, FormatException, FormatException2, FormatGroupTextEventArgsDescription, FormatGroupTextEventArgsDescriptionMetadata, FormatLinearGraphLabelEventArgsDescription, FormatLinearGraphLabelEventArgsDescriptionMetadata, FormatRadialGaugeLabelEventArgsDescription, FormatRadialGaugeLabelEventArgsDescriptionMetadata, FormatSpecifier, FormatSpecifierCollection, FormatSpecifierDescription, FormatSpecifierDescriptionMetadata, FormatSpecifierDescriptionModule, FormatSummaryTextEventArgsDescription, FormatSummaryTextEventArgsDescriptionMetadata, Formatting, Formatting_$type, FragmentBaseDescription, FragmentBaseDescriptionMetadata, FrameworkElement, FrameworkElementExtensions, FullStochasticOscillatorIndicatorDescription, FullStochasticOscillatorIndicatorDescriptionMetadata, FullStochasticOscillatorIndicatorDescriptionModule, FunctionFilterExpression, FunctionFilterExpressionDescription, FunctionFilterExpressionDescriptionMetadata, GC, GenericEnumerable$1, GenericEnumerator$1, GeographicContourLineSeriesDescription, GeographicContourLineSeriesDescriptionMetadata, GeographicContourLineSeriesDescriptionModule, GeographicHighDensityScatterSeriesDescription, GeographicHighDensityScatterSeriesDescriptionMetadata, GeographicHighDensityScatterSeriesDescriptionModule, GeographicMapCoreDescriptionModule, GeographicMapDescription, GeographicMapDescriptionMetadata, GeographicMapDescriptionModule, GeographicMapImageryDescription, GeographicMapImageryDescriptionMetadata, GeographicMapSeriesHostDescription, GeographicMapSeriesHostDescriptionMetadata, GeographicPolylineSeriesDescription, GeographicPolylineSeriesDescriptionMetadata, GeographicPolylineSeriesDescriptionModule, GeographicProportionalSymbolSeriesBaseDescription, GeographicProportionalSymbolSeriesBaseDescriptionMetadata, GeographicProportionalSymbolSeriesDescription, GeographicProportionalSymbolSeriesDescriptionMetadata, GeographicProportionalSymbolSeriesDescriptionModule, GeographicScatterAreaSeriesDescription, GeographicScatterAreaSeriesDescriptionMetadata, GeographicScatterAreaSeriesDescriptionModule, GeographicShapeSeriesBaseBaseDescription, GeographicShapeSeriesBaseBaseDescriptionMetadata, GeographicShapeSeriesBaseDescription, GeographicShapeSeriesBaseDescriptionMetadata, GeographicShapeSeriesDescription, GeographicShapeSeriesDescriptionMetadata, GeographicShapeSeriesDescriptionModule, GeographicSymbolSeriesBaseDescription, GeographicSymbolSeriesBaseDescriptionMetadata, GeographicSymbolSeriesDescription, GeographicSymbolSeriesDescriptionMetadata, GeographicSymbolSeriesDescriptionModule, GeographicTileSeriesDescription, GeographicTileSeriesDescriptionMetadata, GeographicTileSeriesDescriptionModule, GeographicXYTriangulatingSeriesBaseDescription, GeographicXYTriangulatingSeriesBaseDescriptionMetadata, GeographicXYTriangulatingSeriesDescription, GeographicXYTriangulatingSeriesDescriptionMetadata, Geometry, GeometryCollection, GeometryData, GeometryGroup, GeometryType, GeometryType_$type, GeometryUtil, GetPointsSettings, GetTileImageUriArgs, GetTileImageUriArgsDescription, GetTileImageUriArgsDescriptionMetadata, GotFocusEventArgsDescription, GotFocusEventArgsDescriptionMetadata, GradientDirection, GradientDirection_$type, GradientStop, GradientStopAppearanceData, GridActiveCellChangedEventArgsDescription, GridActiveCellChangedEventArgsDescriptionMetadata, GridAnimationPhaseSettingsDescription, GridAnimationPhaseSettingsDescriptionMetadata, GridAnimationSettingsDescription, GridAnimationSettingsDescriptionMetadata, GridCellEditEndedEventArgsDescription, GridCellEditEndedEventArgsDescriptionMetadata, GridCellEditEventArgsDescription, GridCellEditEventArgsDescriptionMetadata, GridCellEditStartedEventArgsDescription, GridCellEditStartedEventArgsDescriptionMetadata, GridCellEventArgsDescription, GridCellEventArgsDescriptionMetadata, GridCellPositionDescription, GridCellPositionDescriptionMetadata, GridCellPositionDescriptionModule, GridCellValueChangedEventArgsDescription, GridCellValueChangedEventArgsDescriptionMetadata, GridCellValueChangingEventArgsDescription, GridCellValueChangingEventArgsDescriptionMetadata, GridColumnAnimationSettingsDescription, GridColumnAnimationSettingsDescriptionMetadata, GridColumnFilterOptionsDescription, GridColumnFilterOptionsDescriptionMetadata, GridColumnFilterOptionsDescriptionModule, GridColumnGroupOptionsDescription, GridColumnGroupOptionsDescriptionMetadata, GridColumnGroupOptionsDescriptionModule, GridColumnHideOptionsDescription, GridColumnHideOptionsDescriptionMetadata, GridColumnHideOptionsDescriptionModule, GridColumnMoveOptionsDescription, GridColumnMoveOptionsDescriptionMetadata, GridColumnMoveOptionsDescriptionModule, GridColumnOptionsBaseDescription, GridColumnOptionsBaseDescriptionMetadata, GridColumnOptionsDescription, GridColumnOptionsDescriptionMetadata, GridColumnOptionsDescriptionModule, GridColumnOptionsSectionBaseDescription, GridColumnOptionsSectionBaseDescriptionMetadata, GridColumnOptionsSimpleSectionBaseDescription, GridColumnOptionsSimpleSectionBaseDescriptionMetadata, GridColumnPinOptionsDescription, GridColumnPinOptionsDescriptionMetadata, GridColumnPinOptionsDescriptionModule, GridColumnSortOptionsDescription, GridColumnSortOptionsDescriptionMetadata, GridColumnSortOptionsDescriptionModule, GridColumnSummaryOptionsDescription, GridColumnSummaryOptionsDescriptionMetadata, GridColumnSummaryOptionsDescriptionModule, GridColumnWidthChangedEventArgsDescription, GridColumnWidthChangedEventArgsDescriptionMetadata, GridColumnsAutoGeneratedEventArgsDescription, GridColumnsAutoGeneratedEventArgsDescriptionMetadata, GridColumnsChangedEventArgsDescription, GridColumnsChangedEventArgsDescriptionMetadata, GridCommitCompletedEventArgsDescription, GridCommitCompletedEventArgsDescriptionMetadata, GridDataCommittedEventArgsDescription, GridDataCommittedEventArgsDescriptionMetadata, GridDataCommittingEventArgsDescription, GridDataCommittingEventArgsDescriptionMetadata, GridFilterDialogFilterChangeEventArgsDescription, GridFilterDialogFilterChangeEventArgsDescriptionMetadata, GridFilterDialogOpeningEventArgsDescription, GridFilterDialogOpeningEventArgsDescriptionMetadata, GridFilterDialogViewModelDescription, GridFilterDialogViewModelDescriptionMetadata, GridFilterDialogViewModelGroupingDescription, GridFilterDialogViewModelGroupingDescriptionMetadata, GridFilterDialogViewModelRowDescription, GridFilterDialogViewModelRowDescriptionMetadata, GridFilterExpressionsEventArgsDescription, GridFilterExpressionsEventArgsDescriptionMetadata, GridGroupDescriptionsChangedEventArgsDescription, GridGroupDescriptionsChangedEventArgsDescriptionMetadata, GridRowEditEndedEventArgsDescription, GridRowEditEndedEventArgsDescriptionMetadata, GridRowEditStartedEventArgsDescription, GridRowEditStartedEventArgsDescriptionMetadata, GridSelectedCellRangesChangedEventArgsDescription, GridSelectedCellRangesChangedEventArgsDescriptionMetadata, GridSelectedCellsChangedEventArgsDescription, GridSelectedCellsChangedEventArgsDescriptionMetadata, GridSelectedItemsChangedEventArgsDescription, GridSelectedItemsChangedEventArgsDescriptionMetadata, GridSelectedKeysChangedEventArgsDescription, GridSelectedKeysChangedEventArgsDescriptionMetadata, GridSizeChangedEventArgsDescription, GridSizeChangedEventArgsDescriptionMetadata, GridSortDescriptionsChangedEventArgsDescription, GridSortDescriptionsChangedEventArgsDescriptionMetadata, Group, GroupCollection, GroupDataDescription, GroupDataDescriptionMetadata, Guid, Guid_GuidParseThrowStyle_$type, Guid_GuidResult, Guid_GuidStyles_$type, Guid_ParseFailureKind_$type, HalfEdge, HalfEdgeSet, HashPool$2, HashSet$1, Hashtable, Header, HeaderDescription, HeaderDescriptionMetadata, HeaderRowSeparatorDescription, HeaderRowSeparatorDescriptionMetadata, HeaderRowSeparatorDescriptionModule, HeaderSeparatorDescription, HeaderSeparatorDescriptionMetadata, HeaderSeparatorDescriptionModule, HeatTileGenerator, HeatTileGeneratorDescription, HeatTileGeneratorDescriptionMetadata, HeatTileGeneratorDescriptionModule, HeatTileGeneratorWebWorker, HeatTileGeneratorWorker, HeatTileGeneratorWorkerManager, HeatTileImageCreatedEventArgs, HeatTileScaler, HierarchicalRingSeriesDescription, HierarchicalRingSeriesDescriptionMetadata, HierarchicalRingSeriesDescriptionModule, HighDensityScatterSeriesDescription, HighDensityScatterSeriesDescriptionMetadata, HighDensityScatterSeriesDescriptionModule, HighlightingInfoDescription, HighlightingInfoDescriptionMetadata, HoleDimensionsChangedEventArgsDescription, HoleDimensionsChangedEventArgsDescriptionMetadata, HorizontalAlignment, HorizontalAlignment_$type, HorizontalAnchoredCategorySeriesDescription, HorizontalAnchoredCategorySeriesDescriptionMetadata, HorizontalAnchoredCategorySeriesProxyDescriptionModule, HorizontalRangeCategorySeriesDescription, HorizontalRangeCategorySeriesDescriptionMetadata, HorizontalRangeCategorySeriesProxyDescriptionModule, HorizontalStackedSeriesBaseDescription, HorizontalStackedSeriesBaseDescriptionMetadata, HttpRequestUtil, IArrayList_$type, IArray_$type, IChartItemLegend_$type, IChartLegend_$type, IChartScaleLegend_$type, ICodeGenerationRendererTemplate_$type, ICollection$1_$type, ICollection_$type, IComparable$1_$type, IComparable_$type, IComparer$1_$type, IComparer_$type, IComponentRendererAdapter_$type, IConvertible_$type, ICredentials_$type, IDataObject_$type, IDataSeriesAdapterRule_$type, IDataSourceDataProviderUpdateNotifier_$type, IDataSourceDataProvider_$type, IDataSourceExecutionContext_$type, IDataSourceLocalDataProvider_$type, IDataSourcePage_$type, IDataSourceSchema_$type, IDataSourceSupportsCount_$type, IDataSourceSupportsIndexedAccess_$type, IDataSourceUpdateNotifier_$type, IDataSourceVirtualDataProvider_$type, IDataSource_$type, IDependentRenderer_$type, IDictionary$2_$type, IDictionary_$type, IDisposable_$type, IEasingFunction_$type, IEditableDataSource_$type, IEnumerable$1_$type, IEnumerable_$type, IEnumerator$1_$type, IEnumerator_$type, IEqualityComparer$1_$type, IEqualityComparer_$type, IEquatable$1_$type, IErrorBarCalculator_$type, IExecutionContext_$type, IExternalDataSeriesAdapter_$type, IExternalDataSource_$type, IExternalLocalDataSource_$type, IExternalVirtualDataSource_$type, IFastItemColumn$1_$type, IFastItemColumnInternal_$type, IFastItemColumnPropertyName_$type, IFastItemsSourceProvider_$type, IFastItemsSource_$type, IFilterExpression_$type, IFormatProvider_$type, IFormattable_$type, IFunctionFilterExpression_$type, IGetItemAtIndex_$type, IGrouping$2_$type, IHashPool$2_$type, IIcon_$type, IIndexedPool$1_$type, IInternalLegendOwner_$type, IKeyFrameAnimation_$type, ILegendContext_$type, ILegendOwner_$type, ILegendSeriesInternal_$type, ILegendSeries_$type, ILegendTemplateProvider_$type, IList$1_$type, IList_$type, ILiteralFilterExpression_$type, IMapRenderDeferralHandler_$type, INotifyCollectionChanged_$type, INotifyPropertyChanged_$type, IOPath, IOperationFilterExpression_$type, IOrderedEnumerable$1_$type, IOverviewPlusDetailControl_$type, IOverviewPlusDetailPane_$type, IPageCandidatesSink_$type, IPermission_$type, IPool$1_$type, IPropertyReferenceFilterExpression_$type, IQueryProvider_$type, IQueryable$1_$type, IQueryable_$type, IRenderer_$type, IScaleLegendSeries_$type, ISchedulableRender_$type, IScrollerKeyboardListener_$type, IScrollerView_$type, ISectionInformation_$type, ISmartPlaceable_$type, ISummaryResult_$type, ISupportsDataChangeNotifications_$type, ISupportsExpansionChangeNotifications_$type, ITickProvider_$type, ITileGenerator_$type, ITileWorkCompletedSink_$type, ITypeDescriptionPropertyTransforms_$type, IUnknownValuePlotting_$type, IVisualData_$type, IXmlLineInfo_$type, IXmlNamespaceResolver_$type, IZoomSlider_$type, IconDescription, IconDescriptionMetadata, IconDescriptionModule, IgCollection, IgEvent, IgrAsyncCompletedEventArgs, IgrCancelEventArgs, IgrCancellingMultiScaleImageEventArgs, IgrChildContent, IgrChildContentModule, IgrComponentRendererContainer, IgrComponentRendererContainerModule, IgrDVInteractivityModule, IgrDataContext, IgrDataSeriesCollection, IgrDataSourceDataProviderSchemaChangedEventArgs, IgrDataSourceRowExpansionChangedEventArgs, IgrDataSourceSchemaChangedEventArgs, IgrDataVisualizationLocaleDeModule, IgrDataVisualizationLocaleEnModule, IgrDataVisualizationLocaleEsModule, IgrDataVisualizationLocaleFrModule, IgrDataVisualizationLocaleItModule, IgrDataVisualizationLocaleJaModule, IgrDataVisualizationLocaleKoModule, IgrDataVisualizationLocaleZhHansModule, IgrDataVisualizationLocaleZhHantModule, IgrDateTimeFormatSpecifier, IgrDateTimeFormatSpecifierModule, IgrDoubleValueChangedEventArgs, IgrDownloadingMultiScaleImageEventArgs, IgrFilterExpressionCollection, IgrFormatSpecifier, IgrFormatSpecifierCollection, IgrFormatSpecifierModule, IgrGetTileImageUriArgs, IgrHeatTileGenerator, IgrHeatTileGeneratorModule, IgrKeyEventArgs, IgrLocalDataSourceModule, IgrNumberFormatSpecifier, IgrNumberFormatSpecifierModule, IgrObjectCollection, IgrPropertyUpdatedEventArgs, IgrProvideCalculatorEventArgs, IgrRectChangedEventArgs, IgrShapeDataSource, IgrShapeDataSourceModule, IgrShapeFilterRecordEventArgs, IgrShapefileRecord, IgrSimpleDefaultTooltip, IgrStockChangedEventArgs, IgrStyle, IgrTemplateContainer, IgrTemplateContainerModule, IgrTemplateContent, IgrTemplateContentModule, IgrTemplateView, IgrTooltipContainer, IgrTooltipContainerModule, IgrTransactionState, IgrTriangulationDataSource, IgrTriangulationStatusEventArgs, IgrUploadDataCompletedEventArgs, IgrUploadStringCompletedEventArgs, Image, ImageCellInfoDescription, ImageCellInfoDescriptionMetadata, ImageColumnDescription, ImageColumnDescriptionMetadata, ImageColumnDescriptionModule, ImageTilesReadyEventArgsDescription, ImageTilesReadyEventArgsDescriptionMetadata, ImagesChangedEventArgsDescription, ImagesChangedEventArgsDescriptionMetadata, IndexOutOfRangeException, IndicatorProxyDescriptionModule, IndicatorsDescriptionModule, InputChangeEventArgsDescription, InputChangeEventArgsDescriptionMetadata, InputDescription, InputDescriptionMetadata, InputDescriptionModule, InputGroupDescription, InputGroupDescriptionMetadata, InputGroupDescriptionModule, InputGroupItemDescription, InputGroupItemDescriptionMetadata, InteractionState, InteractionState_$type, InterpolationMode, InterpolationMode_$type, InterpolationUtil, InvalidOperationException, ItemLegendDescription, ItemLegendDescriptionMetadata, ItemLegendDescriptionModule, ItemToolTipLayerDescription, ItemToolTipLayerDescriptionMetadata, ItemToolTipLayerDescriptionModule, ItemwiseStrategyBasedIndicatorDescription, ItemwiseStrategyBasedIndicatorDescriptionMetadata, IterableWrapper, IteratorWrapper, ItfConverter, JavaScriptSerializer, JsonDictionaryArray, JsonDictionaryItem, JsonDictionaryObject, JsonDictionaryParser, JsonDictionaryValue, JsonDictionaryValueType_$type, JsonWriter, Key, KeyEventArgs, KeyEventArgsDescription, KeyEventArgsDescriptionMetadata, KeyFrameAnimationDirect, KeyFrameAnimationEffectPhase_$type, KeyFrameAnimationFactory, KeyFrameAnimationFill_$type, KeyFrameAnimationPlayState_$type, KeyFrameAnimationTimeline, KeyFrameEffectEasing_$type, KeyFrameEffectTimingDirection_$type, KeyValuePair$2, Key_$type, LRUCache$2, LRUCacheItem$2, LabelAppearanceData, LabelAppearanceDataList, LabelClickEventArgsDescription, LabelClickEventArgsDescriptionMetadata, LabelCollisionInfo, LabelCollisionManager, LabelCollisionManagerCollisionMode_$type, LabelCollisionPlacementPositions_$type, LabelDescription, LabelDescriptionMetadata, LabelDescriptionModule, LambdaExpression, LeastSquaresFit, LeftClipper, LegendBaseDescription, LegendBaseDescriptionMetadata, LegendDescription, LegendDescriptionMetadata, LegendDescriptionModule, LegendItemHelper, LegendMouseButtonEventArgsDescription, LegendMouseButtonEventArgsDescriptionMetadata, LegendMouseEventArgsDescription, LegendMouseEventArgsDescriptionMetadata, Line, LineFragmentDescription, LineFragmentDescriptionMetadata, LineFragmentDescriptionModule, LineGeometry, LineGeometryData, LineSegment, LineSegmentData, LineSeriesDescription, LineSeriesDescriptionMetadata, LineSeriesDescriptionModule, LineVisualData, LinearContourValueResolverDescription, LinearContourValueResolverDescriptionMetadata, LinearContourValueResolverDescriptionModule, LinearGaugeCoreDescriptionModule, LinearGaugeDescription, LinearGaugeDescriptionMetadata, LinearGaugeDescriptionModule, LinearGradientBrush, LinearGradientBrushAppearanceData, LinearGraphRangeDescription, LinearGraphRangeDescriptionMetadata, LinearGraphRangeDescriptionModule, LinkedList$1, LinkedListNode$1, List$1, ListSortDirection, ListSortDirection_$type, LiteralFilterExpression, LiteralFilterExpressionDescription, LiteralFilterExpressionDescriptionMetadata, LocalDataSource, LocalDataSourceDescription, LocalDataSourceDescriptionMetadata, LocalDataSourceDescriptionModule, LocalDataSourceViewExpansionNotifier, LocalDataSourceViewUpdateNotifier, Locale, Localization, LostFocusEventArgsDescription, LostFocusEventArgsDescriptionMetadata, MapTileSource, MarkerSeriesDescription, MarkerSeriesDescriptionMetadata, MarketFacilitationIndexIndicatorDescription, MarketFacilitationIndexIndicatorDescriptionMetadata, MarketFacilitationIndexIndicatorDescriptionModule, MarshalByRefObject, MassIndexIndicatorDescription, MassIndexIndicatorDescriptionMetadata, MassIndexIndicatorDescriptionModule, Match, Matcher, MathUtil, MathUtilExtended, Matrix, MatrixTransform, MaxSummaryCalculator, MedianPriceIndicatorDescription, MedianPriceIndicatorDescriptionMetadata, MedianPriceIndicatorDescriptionModule, MemberExpression, MemoryStream, MethodCallExpression, MinSummaryCalculator, ModifierKeys, ModifierKeys_$type, MoneyFlowIndexIndicatorDescription, MoneyFlowIndexIndicatorDescriptionMetadata, MoneyFlowIndexIndicatorDescriptionModule, MouseButton, MouseButtonEventArgs, MouseButton_$type, MouseEventArgs, MovingAverageConvergenceDivergenceIndicatorDescription, MovingAverageConvergenceDivergenceIndicatorDescriptionMetadata, MovingAverageConvergenceDivergenceIndicatorDescriptionModule, MultiColumnComboBoxDescription, MultiColumnComboBoxDescriptionMetadata, MultiColumnComboBoxDescriptionModule, MultiColumnComboBoxTextChangedEventArgsDescription, MultiColumnComboBoxTextChangedEventArgsDescriptionMetadata, MultiColumnComboBoxValueChangedEventArgsDescription, MultiColumnComboBoxValueChangedEventArgsDescriptionMetadata, NamePatcher, NameTable, NameTable_Entry, NameValueCollection, NamespaceHandling_$type, NativeUI, NegativeVolumeIndexIndicatorDescription, NegativeVolumeIndexIndicatorDescriptionMetadata, NegativeVolumeIndexIndicatorDescriptionModule, NetworkCredential, NewLineHandling_$type, NonBlockingStreamReader, NotImplementedException, NotSupportedException, NotifyCollectionChangedAction, NotifyCollectionChangedAction_$type, NotifyCollectionChangedEventArgs, NullReferenceException, NullStream, Nullable, Nullable$1, NumberAbbreviatorDescriptionModule, NumberFormatInfo, NumberFormatSpecifier, NumberFormatSpecifierDescription, NumberFormatSpecifierDescriptionMetadata, NumberFormatSpecifierDescriptionModule, Number_$type, Numeric, NumericAngleAxisDescription, NumericAngleAxisDescriptionMetadata, NumericAngleAxisDescriptionModule, NumericAxisBaseDescription, NumericAxisBaseDescriptionMetadata, NumericCellInfoDescription, NumericCellInfoDescriptionMetadata, NumericColumnDescription, NumericColumnDescriptionMetadata, NumericColumnDescriptionModule, NumericRadiusAxisDescription, NumericRadiusAxisDescriptionMetadata, NumericRadiusAxisDescriptionModule, NumericXAxisDescription, NumericXAxisDescriptionMetadata, NumericXAxisDescriptionModule, NumericYAxisDescription, NumericYAxisDescriptionMetadata, NumericYAxisDescriptionModule, ODataDataSourceFilterExpressionVisitor, ODataDataSourceSchema, ODataLiteralEmitter_$type, ObjectCollection, ObjectDisposedException, ObservableCollection$1, ObservableColorCollection, OnBalanceVolumeIndicatorDescription, OnBalanceVolumeIndicatorDescriptionMetadata, OnBalanceVolumeIndicatorDescriptionModule, OnClosedEventArgsDescription, OnClosedEventArgsDescriptionMetadata, OnCollapsedEventArgsDescription, OnCollapsedEventArgsDescriptionMetadata, OnExpandedEventArgsDescription, OnExpandedEventArgsDescriptionMetadata, OnPopupEventArgsDescription, OnPopupEventArgsDescriptionMetadata, OpenStreetMapImageryDescription, OpenStreetMapImageryDescriptionMetadata, OpenStreetMapImageryDescriptionModule, OpenStreetMapTileSource, OperationFilterExpression, OperationFilterExpressionDescription, OperationFilterExpressionDescriptionMetadata, OrdinalTimeXAxisDescription, OrdinalTimeXAxisDescriptionMetadata, OrdinalTimeXAxisDescriptionModule, OverlayProxyDescriptionModule, OverlaysDescriptionModule, PagePredictionEngine, Pair$2, Panel, ParameterExpression, Path, PathFigure, PathFigureCollection, PathFigureData, PathFigureUtil, PathGeometry, PathGeometryData, PathMarkupParser, PathMarkupToken, PathMarkupTokenType_$type, PathSegment, PathSegmentCollection, PathSegmentType, PathSegmentType_$type, PathVisualData, PenLineCap, PenLineCap_$type, PenLineJoin, PenLineJoin_$type, PercentChangeYAxisDescription, PercentChangeYAxisDescriptionMetadata, PercentChangeYAxisDescriptionModule, PercentagePriceOscillatorIndicatorDescription, PercentagePriceOscillatorIndicatorDescriptionMetadata, PercentagePriceOscillatorIndicatorDescriptionModule, PercentageVolumeOscillatorIndicatorDescription, PercentageVolumeOscillatorIndicatorDescriptionMetadata, PercentageVolumeOscillatorIndicatorDescriptionModule, PermissionSet, PermissionState, PermissionState_$type, PieChartBaseDescription, PieChartBaseDescriptionMetadata, PieChartCoreDescriptionModule, PieChartDescription, PieChartDescriptionMetadata, PieChartDescriptionModule, PieSliceDataContextDescription, PieSliceDataContextDescriptionMetadata, PieSliceOthersContextDescription, PieSliceOthersContextDescriptionMetadata, PinnedAreaSeparatorDescription, PinnedAreaSeparatorDescriptionMetadata, PinnedAreaSeparatorDescriptionModule, PlatformConstants, PlatformKeyFrameAnimationFactory, PlatformSpecifierType_$type, PlatformUIElementPropertyAccessorFactory, PlotAreaMouseButtonEventArgsDescription, PlotAreaMouseButtonEventArgsDescriptionMetadata, PlotAreaMouseEventArgsDescription, PlotAreaMouseEventArgsDescriptionMetadata, PointCollection, PointCollectionUtil, PointComparer, PointData, PointDescription, PointSeriesDescription, PointSeriesDescriptionMetadata, PointSeriesDescriptionModule, PointTester, PointUtil, Point_$type, PolarAreaSeriesDescription, PolarAreaSeriesDescriptionMetadata, PolarAreaSeriesDescriptionModule, PolarBaseDescription, PolarBaseDescriptionMetadata, PolarLineSeriesBaseDescription, PolarLineSeriesBaseDescriptionMetadata, PolarLineSeriesDescription, PolarLineSeriesDescriptionMetadata, PolarLineSeriesDescriptionModule, PolarScatterSeriesDescription, PolarScatterSeriesDescriptionMetadata, PolarScatterSeriesDescriptionModule, PolarSplineAreaSeriesDescription, PolarSplineAreaSeriesDescriptionMetadata, PolarSplineAreaSeriesDescriptionModule, PolarSplineSeriesDescription, PolarSplineSeriesDescriptionMetadata, PolarSplineSeriesDescriptionModule, PolyBezierSegment, PolyBezierSegmentData, PolyLineSegment, PolyLineVisualData, PolySimplification, Polygon, PolygonUtil, PolygonVisualData, Polyline, PolylineSegmentData, Pool$1, PopupDescription, PopupDescriptionMetadata, PopupDescriptionModule, PortalManager, PositiveVolumeIndexIndicatorDescription, PositiveVolumeIndexIndicatorDescriptionMetadata, PositiveVolumeIndexIndicatorDescriptionModule, PredictionEnginePageCandidate, PrefixDescription, PrefixDescriptionMetadata, PrefixDescriptionModule, PriceChannelOverlayDescription, PriceChannelOverlayDescriptionMetadata, PriceChannelOverlayDescriptionModule, PriceVolumeTrendIndicatorDescription, PriceVolumeTrendIndicatorDescriptionMetadata, PriceVolumeTrendIndicatorDescriptionModule, PrimaryKeyValueDescription, PrimaryKeyValueDescriptionMetadata, PrimaryKeyValueDescriptionModule, PrimitiveAppearanceData, PrimitiveVisualData, PrimitiveVisualDataList, ProgressiveLoadStatusEventArgsDescription, ProgressiveLoadStatusEventArgsDescriptionMetadata, PromiseFactory, PromiseWrapper, PropertyChangedEventArgs, PropertyChangedEventArgs$1, PropertyEditorDataSourceDescription, PropertyEditorDataSourceDescriptionMetadata, PropertyEditorDescription, PropertyEditorDescriptionMetadata, PropertyEditorDescriptionModule, PropertyEditorDescriptionObjectDescription, PropertyEditorDescriptionObjectDescriptionMetadata, PropertyEditorPropertyDescriptionButtonClickEventArgsDescription, PropertyEditorPropertyDescriptionButtonClickEventArgsDescriptionMetadata, PropertyEditorPropertyDescriptionChangedEventArgsDescription, PropertyEditorPropertyDescriptionChangedEventArgsDescriptionMetadata, PropertyEditorPropertyDescriptionDescription, PropertyEditorPropertyDescriptionDescriptionMetadata, PropertyEditorPropertyDescriptionDescriptionModule, PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescription, PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgsDescriptionMetadata, PropertyMetadata, PropertyPath, PropertyReferenceFilterExpression, PropertyReferenceFilterExpressionDescription, PropertyReferenceFilterExpressionDescriptionMetadata, PropertyUpdatedEventArgs, PropertyUpdatedEventArgsDescription, PropertyUpdatedEventArgsDescriptionMetadata, ProvideCalculatorEventArgs, ProvideCalculatorEventArgsDescription, ProvideCalculatorEventArgsDescriptionMetadata, QuadTree, QuadTreeBoundingBox, QuadTreeForceVector, QuadTreeNode, Queryable, Queue$1, RadialAreaSeriesDescription, RadialAreaSeriesDescriptionMetadata, RadialAreaSeriesDescriptionModule, RadialBaseDescription, RadialBaseDescriptionMetadata, RadialColumnSeriesDescription, RadialColumnSeriesDescriptionMetadata, RadialColumnSeriesDescriptionModule, RadialGaugeCoreDescriptionModule, RadialGaugeDescription, RadialGaugeDescriptionMetadata, RadialGaugeDescriptionModule, RadialGaugeRangeDescription, RadialGaugeRangeDescriptionMetadata, RadialGaugeRangeDescriptionModule, RadialLineSeriesDescription, RadialLineSeriesDescriptionMetadata, RadialLineSeriesDescriptionModule, RadialPieSeriesDescription, RadialPieSeriesDescriptionMetadata, RadialPieSeriesDescriptionModule, Random, RangeAreaSeriesDescription, RangeAreaSeriesDescriptionMetadata, RangeAreaSeriesDescriptionModule, RangeCategorySeriesDescription, RangeCategorySeriesDescriptionMetadata, RangeColumnSeriesDescription, RangeColumnSeriesDescriptionMetadata, RangeColumnSeriesDescriptionModule, RateOfChangeAndMomentumIndicatorDescription, RateOfChangeAndMomentumIndicatorDescriptionMetadata, RateOfChangeAndMomentumIndicatorDescriptionModule, ReactCodeBehindCodeGeneratingComponentRendererCodeEmitter, ReactMarkupCodeGeneratingComponentRendererCodeEmitter, ReactRenderer, ReactWrapper, ReadOnlyCollection$1, ReadOnlyObservableCollection$1, ReadState, ReadState_$type, RearrangedList$1, RearrangedListView, Rect, RectChangedEventArgs, RectChangedEventArgsDescription, RectChangedEventArgsDescriptionMetadata, RectData, RectDescription, RectUtil, Rectangle, RectangleGeometry, RectangleGeometryData, RectangleVisualData, RefValueChangedTarget, ReflectionUtil, RefreshCompletedEventArgsDescription, RefreshCompletedEventArgsDescriptionMetadata, Regex, RegexOptions, RegexOptions_$type, RelativeStrengthIndexIndicatorDescription, RelativeStrengthIndexIndicatorDescriptionMetadata, RelativeStrengthIndexIndicatorDescriptionModule, RemovedShiftedRowInfo, RenderRequestedEventArgsDescription, RenderRequestedEventArgsDescriptionMetadata, RenderingContext, ResponsivePhaseDescription, ResponsivePhaseDescriptionMetadata, ResponsiveStateDescription, ResponsiveStateDescriptionMetadata, ResponsiveStateEnteredEventArgsDescription, ResponsiveStateEnteredEventArgsDescriptionMetadata, ResponsiveStateEnteringEventArgsDescription, ResponsiveStateEnteringEventArgsDescriptionMetadata, ResponsiveStateExitedEventArgsDescription, ResponsiveStateExitedEventArgsDescriptionMetadata, ReverseArrayEnumerator$1, RightClipper, RingDescription, RingDescriptionMetadata, RingSeriesBaseDescription, RingSeriesBaseDescriptionMetadata, RingSeriesDescription, RingSeriesDescriptionMetadata, RingSeriesDescriptionModule, RippleDescription, RippleDescriptionMetadata, RippleDescriptionModule, RotateTransform, RowSeparatorDescription, RowSeparatorDescriptionMetadata, RowSeparatorDescriptionModule, RowSeparatorInfoDescription, RowSeparatorInfoDescriptionMetadata, SRProvider, ScaleLegendDescription, ScaleLegendDescriptionMetadata, ScaleLegendDescriptionModule, ScaleTransform, ScalerParamsDescription, ScalerParamsDescriptionMetadata, ScalerVisibleBounds, ScatterAreaSeriesDescription, ScatterAreaSeriesDescriptionMetadata, ScatterAreaSeriesDescriptionModule, ScatterBaseDescription, ScatterBaseDescriptionMetadata, ScatterContourSeriesDescription, ScatterContourSeriesDescriptionMetadata, ScatterContourSeriesDescriptionModule, ScatterLineSeriesDescription, ScatterLineSeriesDescriptionMetadata, ScatterLineSeriesDescriptionModule, ScatterPolygonSeriesDescription, ScatterPolygonSeriesDescriptionMetadata, ScatterPolygonSeriesDescriptionModule, ScatterPolylineSeriesDescription, ScatterPolylineSeriesDescriptionMetadata, ScatterPolylineSeriesDescriptionModule, ScatterSeriesDescription, ScatterSeriesDescriptionMetadata, ScatterSeriesDescriptionModule, ScatterSplineSeriesDescription, ScatterSplineSeriesDescriptionMetadata, ScatterSplineSeriesDescriptionModule, ScatterTriangulationSeriesDescription, ScatterTriangulationSeriesDescriptionMetadata, ScrollbarStyle_$type, Scroller, ScrollerScrollingEventArgs, ScrollerView, SectionData, SectionDataStartIndexComparer, SectionDataUndisplacedStartIndexComparer, SectionFooterDescription, SectionFooterDescriptionMetadata, SectionFooterDescriptionModule, SectionHeaderCellInfoDescription, SectionHeaderCellInfoDescriptionMetadata, SectionHeaderDescription, SectionHeaderDescriptionMetadata, SectionHeaderDescriptionModule, SectionInformationDescription, SectionInformationDescriptionMetadata, SectionMap, SectionSearchData, SecurityAction, SecurityAction_$type, SeekOrigin, SegmentData, SelectAllCheckboxChangedEventArgsDescription, SelectAllCheckboxChangedEventArgsDescriptionMetadata, SelectedItemChangedEventArgsDescription, SelectedItemChangedEventArgsDescriptionMetadata, SelectedItemChangingEventArgsDescription, SelectedItemChangingEventArgsDescriptionMetadata, SelectedItemsChangedEventArgsDescription, SelectedItemsChangedEventArgsDescriptionMetadata, SelectedItemsChangingEventArgsDescription, SelectedItemsChangingEventArgsDescriptionMetadata, SelectionChangedEventArgsDescription, SelectionChangedEventArgsDescriptionMetadata, SeriesDescription, SeriesDescriptionMetadata, SeriesViewerDescription, SeriesViewerDescriptionMetadata, SeriesViewerManipulationEventArgsDescription, SeriesViewerManipulationEventArgsDescriptionMetadata, Shape, ShapeDataSourceDescription, ShapeDataSourceDescriptionMetadata, ShapeDataSourceDescriptionModule, ShapeFileUtil, ShapeFilterRecordEventArgs, ShapeFilterRecordEventArgsDescription, ShapeFilterRecordEventArgsDescriptionMetadata, ShapeSeriesBaseDescription, ShapeSeriesBaseDescriptionMetadata, ShapeTags, ShapeType, ShapeType_$type, ShapefileConverter, ShapefileRecord, ShapefileRecordDescription, ShapefileRecordDescriptionMetadata, SimpleCategorySeriesRule, SimpleDefaultTooltipDescriptionMetadata, SimpleDefaultTooltipExtendedDescriptionMetadata, SimpleFinancialPriceSeriesRule, SimpleScatterSeriesRule, Size, SizeData, SizeDescription, SizeScaleDescription, SizeScaleDescriptionMetadata, SizeScaleDescriptionModule, SliceClickEventArgsDescription, SliceClickEventArgsDescriptionMetadata, SlowStochasticOscillatorIndicatorDescription, SlowStochasticOscillatorIndicatorDescriptionMetadata, SlowStochasticOscillatorIndicatorDescriptionModule, SmartPlaceableWrapper$1, SmartPlacer, SmartPosition, SmartPosition_$type, SolidBrushAppearanceData, SortDescription, SortDescriptionCollection, SortDescriptionDescription, SortDescriptionDescriptionMetadata, SortIndicatorRenderCompletedEventArgsDescription, SortIndicatorRenderCompletedEventArgsDescriptionMetadata, SortedList$1, SparklineCoreDescriptionModule, SparklineDescription, SparklineDescriptionMetadata, SparklineDescriptionModule, SpiralFlattener, SpiralTodo, SplineAreaFragmentDescription, SplineAreaFragmentDescriptionMetadata, SplineAreaFragmentDescriptionModule, SplineAreaSeriesDescription, SplineAreaSeriesDescriptionMetadata, SplineAreaSeriesDescriptionModule, SplineFragmentBaseDescription, SplineFragmentBaseDescriptionMetadata, SplineFragmentDescription, SplineFragmentDescriptionMetadata, SplineFragmentDescriptionModule, SplineSeriesBaseDescription, SplineSeriesBaseDescriptionMetadata, SplineSeriesDescription, SplineSeriesDescriptionMetadata, SplineSeriesDescriptionModule, Stack$1, StackPool$1, Stacked100AreaSeriesDescription, Stacked100AreaSeriesDescriptionMetadata, Stacked100AreaSeriesDescriptionModule, Stacked100BarSeriesDescription, Stacked100BarSeriesDescriptionMetadata, Stacked100BarSeriesDescriptionModule, Stacked100ColumnSeriesDescription, Stacked100ColumnSeriesDescriptionMetadata, Stacked100ColumnSeriesDescriptionModule, Stacked100LineSeriesDescription, Stacked100LineSeriesDescriptionMetadata, Stacked100LineSeriesDescriptionModule, Stacked100SplineAreaSeriesDescription, Stacked100SplineAreaSeriesDescriptionMetadata, Stacked100SplineAreaSeriesDescriptionModule, Stacked100SplineSeriesDescription, Stacked100SplineSeriesDescriptionMetadata, Stacked100SplineSeriesDescriptionModule, StackedAreaSeriesDescription, StackedAreaSeriesDescriptionMetadata, StackedAreaSeriesDescriptionModule, StackedBarSeriesDescription, StackedBarSeriesDescriptionMetadata, StackedBarSeriesDescriptionModule, StackedColumnSeriesDescription, StackedColumnSeriesDescriptionMetadata, StackedColumnSeriesDescriptionModule, StackedFragmentSeriesDescription, StackedFragmentSeriesDescriptionMetadata, StackedFragmentSeriesDescriptionModule, StackedLineSeriesDescription, StackedLineSeriesDescriptionMetadata, StackedLineSeriesDescriptionModule, StackedSeriesBaseDescription, StackedSeriesBaseDescriptionMetadata, StackedSeriesCreatedEventArgsDescription, StackedSeriesCreatedEventArgsDescriptionMetadata, StackedSplineAreaSeriesDescription, StackedSplineAreaSeriesDescriptionMetadata, StackedSplineAreaSeriesDescriptionModule, StackedSplineSeriesDescription, StackedSplineSeriesDescriptionMetadata, StackedSplineSeriesDescriptionModule, StandardDeviationIndicatorDescription, StandardDeviationIndicatorDescriptionMetadata, StandardDeviationIndicatorDescriptionModule, StandardLegendBadges_$type, StandardLegendItems_$type, StepAreaSeriesDescription, StepAreaSeriesDescriptionMetadata, StepAreaSeriesDescriptionModule, StepLineSeriesDescription, StepLineSeriesDescriptionMetadata, StepLineSeriesDescriptionModule, StochRSIIndicatorDescription, StochRSIIndicatorDescriptionMetadata, StochRSIIndicatorDescriptionModule, StockChangedEventArgs, StockChangedEventArgsDescription, StockChangedEventArgsDescriptionMetadata, StockDataGenerator, StockDataLookup, StockDetails, StockInfo, StockPopulateEventArgsDescription, StockPopulateEventArgsDescriptionMetadata, StockPosition, StockPriceHistory, StockPricePoint, StraightNumericAxisBaseDescription, StraightNumericAxisBaseDescriptionMetadata, StrategyBasedIndicatorDescription, StrategyBasedIndicatorDescriptionMetadata, Stream, StreamReader, StreamWriter, Stretch, Stretch_$type, StringBuilder, StringComparer, StringReader, StringWriter, String_$type, Style, StyleDescription, StyleDescriptionMetadata, StyleSelectorDescription, StyleSelectorDescriptionMetadata, StyleShapeEventArgsDescription, StyleShapeEventArgsDescriptionMetadata, SubCollectionsRule, SuffixDescription, SuffixDescriptionMetadata, SumSummaryCalculator, SummaryCalculator, SummaryCellInfoDescription, SummaryCellInfoDescriptionMetadata, SummaryChangedEventArgsDescription, SummaryChangedEventArgsDescriptionMetadata, SummaryChooserDescriptionModule, SummaryDataDescription, SummaryDataDescriptionMetadata, SummaryDescription, SummaryDescriptionCollection, SummaryGroup, SummaryOperand, SummaryOperand_$type, SummaryResultDescription, SummaryResultDescriptionMetadata, SummaryRowDescription, SummaryRowDescriptionMetadata, SummaryRowRootDescription, SummaryRowRootDescriptionMetadata, SummaryRowRootDescriptionModule, SummaryRowSectionDescription, SummaryRowSectionDescriptionMetadata, SummaryRowSectionDescriptionModule, SweepDirection, SweepDirection_$type, SyncableObservableCollection$1, SyncableObservableCollection$2, SyncableObservableCollectionChangedListener_$type, SynchronizedReader, SynchronizedWriter, SystemException, TRIXIndicatorDescription, TRIXIndicatorDescriptionMetadata, TRIXIndicatorDescriptionModule, TSCodeGeneratingComponentRendererDataEmitter, TSCodeGeneratingComponentRendererHandlerEmitter, TSCodeGeneratingComponentRendererModuleEmitter, Task, Task$1, TaskCompletionSource$1, TaskFactory, TaskStatus, TaskStatus_$type, TemplateCellInfoDescription, TemplateCellInfoDescriptionMetadata, TemplateCellUpdatingEventArgsDescription, TemplateCellUpdatingEventArgsDescriptionMetadata, TemplateColumnDescription, TemplateColumnDescriptionMetadata, TemplateColumnDescriptionModule, TemplateContentDescriptionModule, TemplateContentExtendedDescriptionModule, TemplateHeaderCellInfoDescription, TemplateHeaderCellInfoDescriptionMetadata, TemplateHeaderCellUpdatingEventArgsDescription, TemplateHeaderCellUpdatingEventArgsDescriptionMetadata, TemplateHeaderDescription, TemplateHeaderDescriptionMetadata, TemplateHeaderDescriptionModule, TemplateSectionHeaderCellInfoDescription, TemplateSectionHeaderCellInfoDescriptionMetadata, TemplateSectionHeaderCellUpdatingEventArgsDescription, TemplateSectionHeaderCellUpdatingEventArgsDescriptionMetadata, TemplateSectionHeaderDescription, TemplateSectionHeaderDescriptionMetadata, TemplateSectionHeaderDescriptionModule, TextBlock, TextCellInfoDescription, TextCellInfoDescriptionMetadata, TextChangedEventArgsDescription, TextChangedEventArgsDescriptionMetadata, TextColumnDescription, TextColumnDescriptionMetadata, TextColumnDescriptionModule, TextHeaderCellInfoDescription, TextHeaderCellInfoDescriptionMetadata, TextHeaderDescription, TextHeaderDescriptionMetadata, TextHeaderDescriptionModule, TextReader, TextReader_NullTextReader, TextWriter, TextWriter_NullTextWriter, Thickness, Thread, Tile, TileGeneratorDescription, TileGeneratorDescriptionMetadata, TileGeneratorMapImageryDescription, TileGeneratorMapImageryDescriptionMetadata, TileGeneratorMapImageryDescriptionModule, TileGeneratorTileSource, TileImageCreatedEventArgs, TileImageZoomChangingEventArgs, TilePositionComparer, TileSeriesDescription, TileSeriesDescriptionMetadata, TileSeriesDescriptionModule, TileWorkCompletedSink, TileWorkSettings, TimeAxisBaseDescription, TimeAxisBaseDescriptionMetadata, TimeAxisBreakDescription, TimeAxisBreakDescriptionMetadata, TimeAxisBreakDescriptionModule, TimeAxisIntervalDescription, TimeAxisIntervalDescriptionMetadata, TimeAxisIntervalDescriptionModule, TimeAxisLabelFormatDescription, TimeAxisLabelFormatDescriptionMetadata, TimeAxisLabelFormatDescriptionModule, TimeXAxisDescription, TimeXAxisDescriptionMetadata, TimeXAxisDescriptionModule, TooltipContainerDescriptionModule, TooltipContainerExtendedDescriptionModule, TopClipper, TouchGestureEventArgs, TouchGestureRecognizer, TouchGestureState_$type, TouchHistoryItem, TouchPointInfo, TouchVelocityReading, TouchVelocityTracker, Transaction, TransactionCommit, TransactionEvent, TransactionEvent_$type, TransactionHistory, TransactionKeyEqualityComparer, TransactionPendingState, TransactionPendingState_$type, TransactionService, TransactionState, TransactionStateDescription, TransactionStateDescriptionMetadata, TransactionType, TransactionType_$type, Transform, TransformCollection, TransformGroup, TransformMatrixHelpler, TranslateTransform, TreemapDescription, TreemapDescriptionMetadata, TreemapDescriptionModule, TreemapNodePointerEventArgsDescription, TreemapNodePointerEventArgsDescriptionMetadata, TreemapNodeStyleDescription, TreemapNodeStyleDescriptionMetadata, TreemapNodeStyleDescriptionModule, TreemapNodeStyleMappingDescription, TreemapNodeStyleMappingDescriptionMetadata, TreemapNodeStyleMappingDescriptionModule, TreemapNodeStylingEventArgsDescription, TreemapNodeStylingEventArgsDescriptionMetadata, TrendCalculators, TrendLineType, TrendLineType_$type, Triangle, TriangulationDataSourceDescription, TriangulationDataSourceDescriptionMetadata, TriangulationSource, TriangulationSourcePointRecord, TriangulationStatusEventArgs, TriangulationStatusEventArgsDescription, TriangulationStatusEventArgsDescriptionMetadata, Triangulator, TriangulatorContext, Tuple, Tuple$2, Tuple$3, Type, TypeDescriptionCleanups, TypeDescriptionContext, TypeDescriptionMetadata, TypeDescriptionPlatform, TypeDescriptionPlatform_$type, TypeDescriptionPropretyTransforms, TypeDescriptionWellKnownType, TypeDescriptionWellKnownType_$type, TypeRegistrar, TypicalPriceIndicatorDescription, TypicalPriceIndicatorDescriptionMetadata, TypicalPriceIndicatorDescriptionModule, UIElement, UIElementCollection, UIElementPropertyAccessor, UIElementPropertyAccessorFactory, UIElementPropertyId_$type, UTF8Encoding, UTF8Encoding_UTF8Decoder, UltimateOscillatorIndicatorDescription, UltimateOscillatorIndicatorDescriptionMetadata, UltimateOscillatorIndicatorDescriptionModule, UnicodeEncoding, UnknownValuePlotting, UnknownValuePlotting_$type, UnsetValue, UploadDataCompletedEventArgs, UploadDataCompletedEventArgsDescription, UploadDataCompletedEventArgsDescriptionMetadata, UploadStringCompletedEventArgs, UploadStringCompletedEventArgsDescription, UploadStringCompletedEventArgsDescriptionMetadata, Uri, UriKind, UriKind_$type, UriParser, ValueBrushScaleDescription, ValueBrushScaleDescriptionMetadata, ValueBrushScaleDescriptionModule, ValueChangedEventArgsDescription, ValueChangedEventArgsDescriptionMetadata, ValueOverlayDescription, ValueOverlayDescriptionMetadata, ValueOverlayDescriptionModule, ValueType, VerticalAlignment, VerticalAlignment_$type, VerticalAnchoredCategorySeriesDescription, VerticalAnchoredCategorySeriesDescriptionMetadata, VerticalSeparatorCellInfoDescription, VerticalSeparatorCellInfoDescriptionMetadata, VerticalStackedSeriesBaseDescription, VerticalStackedSeriesBaseDescriptionMetadata, VirtualDataSource, VirtualDataSourceDescription, VirtualDataSourceDescriptionMetadata, Visibility, Visibility_$type, VisualDataPixelScalingOptions, Void_$type, WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter, WPFXamlCodeGeneratingComponentRendererCodeEmitter, WaterfallSeriesDescription, WaterfallSeriesDescriptionMetadata, WaterfallSeriesDescriptionModule, WeakReference, WebClient, WebComponentsCodeBehindCodeGeneratingComponentRendererCodeEmitter, WebComponentsMarkupCodeGeneratingComponentRendererCodeEmitter, WebHeaderCollection, WeightedCloseIndicatorDescription, WeightedCloseIndicatorDescriptionMetadata, WeightedCloseIndicatorDescriptionModule, WhitespaceHandling, WhitespaceHandling_$type, WilliamsPercentRIndicatorDescription, WilliamsPercentRIndicatorDescriptionMetadata, WilliamsPercentRIndicatorDescriptionModule, WriteState, WriteState_$type, WriteableBitmap, XAttribute, XBaseDataType, XBaseDataType_$type, XBaseField, XContainer, XDocument, XElement, XName, XNamespace, XNode, XObject, XYChartDescription, XYChartDescriptionMetadata, XamMultiScaleImage, XamMultiScaleImageView, XamMultiScaleTileSource, XmlAttribute_$type, XmlChar, XmlConvert, XmlDocument_$type, XmlElement_$type, XmlException, XmlInputStream, XmlLinkedNode_$type, XmlNameTable, XmlNamedNodeMap_$type, XmlNamespaceManager, XmlNamespaceManager_NsDecl, XmlNamespaceManager_NsScope, XmlNamespaceScope_$type, XmlNodeList_$type, XmlNodeType, XmlNodeType_$type, XmlNode_$type, XmlParserContext, XmlParserContext_ContextItem, XmlReader, XmlResolver, XmlSpace, XmlSpace_$type, XmlStreamReader, XmlTextReader, XmlTextReader_DtdInputStateStack, XmlTextReader_DtdInputState_$type, XmlTextReader_TagName, XmlTextReader_XmlAttributeTokenInfo, XmlTextReader_XmlTokenInfo, XmlTextWriter, XmlTextWriter_StringUtil, XmlTextWriter_XmlDeclState_$type, XmlTextWriter_XmlNodeInfo, XmlUrlResolver, XmlUtils, XmlWriter, ZoomSliderDescription, ZoomSliderDescriptionMetadata, ZoomSliderDescriptionModule, ZoomSliderResolvingAxisValueEventArgsDescription, ZoomSliderResolvingAxisValueEventArgsDescriptionMetadata, a$, addBrushPaletteThemeEntry, addPaletteThemeEntry, addTextThemeEntry, arrayClear, arrayClear1, arrayContains, arrayCopy, arrayCopy1, arrayCopy2, arrayCopyTo, arrayFindByName, arrayGetLength, arrayGetRank, arrayGetValue, arrayIndexOf1, arrayInsert, arrayInsertRange, arrayInsertRange1, arrayLast, arrayListCreate, arrayRemoveAt, arrayRemoveItem, arrayResize, arrayShallowClone, b$, b64toUint8Array, boolCompare, boolToDecimal, boolToDouble, boolToInt16, boolToInt32, boolToInt64, boolToSingle, boolToString, boolToUInt16, boolToUInt32, boolToUInt64, boxArray$1, brushCollectionToString, brushToString, callStaticConstructors, ceil10, charMaxValue, charMinValue, colorCollectionToString, colorToString, compareTo, createGuid, d$, dateAdd, dateAddDays, dateAddHours, dateAddMinutes, dateAddMonths, dateAddSeconds, dateAddYears, dateEquals, dateFromFileTime, dateFromFileTimeUtc, dateFromMilliseconds, dateFromTicks, dateFromValues, dateGetDate, dateGetMonth, dateGetTimeOfDay, dateIsDST, dateIsLeapYear, dateKind, dateMaxValue, dateMinValue, dateNow, dateParse, dateParseExact, dateStdTimezoneOffset, dateSubtract, dateToFileTime, dateToString, dateToStringFormat, dateToday, dateTryParse, daysInMonth, decimalAdjust, defaultDVDateParse, delegateCombine, delegateRemove, endsWith1, ensureBool, ensureEnum, enumGetBox, enumToString, floor10, fromBrushCollection, fromColorCollection, fromDict, fromEn, fromEnum, fromOADate, fromPoint, fromRect, fromSize, fromSpinal, getAllPropertyNames, getBoxIfEnum, getColorStringSafe, getEn, getEnumerator, getEnumeratorObject, getInstanceType, getModifiedProps, ieeeRemainder, indexOfAny, initializePropertiesFromCss, intDivide, intSToU, intToString, intToString1, isDigit, isDigit1, isInfinity, isLetter, isLetterOrDigit, isLower, isNaN_, isNegativeInfinity, isNumber, isPoint, isPositiveInfinity, isRect, isSize, isValidProp, lastIndexOfAny, log10, logBase, markDep, markEnum, markStruct, markType, n$, netRegexToJS, nullableAdd, nullableConcat, nullableDivide, nullableEquals, nullableGreaterThan, nullableGreaterThanOrEqual, nullableIsNull, nullableLessThan, nullableLessThanOrEqual, nullableModulus, nullableMultiply, nullableNotEquals, nullableSubtract, numberToString, numberToString1, numberToString2, padLeft, padRight, parseBool, parseInt16_1, parseInt16_2, parseInt32_1, parseInt32_2, parseInt64_1, parseInt64_2, parseInt8_1, parseInt8_2, parseIntCore, parseNumber, parseNumber1, parseUInt16_1, parseUInt16_2, parseUInt32_1, parseUInt32_2, parseUInt64_1, parseUInt64_2, parseUInt8_1, parseUInt8_2, pointFromLiteral, pointToLiteral, pointToString, rectFromLiteral, rectToLiteral, rectToString, reverse, rgbToHex, round10, round10N, runOn, s$, sizeFromLiteral, sizeToLiteral, sizeToString, sleep, startsWith1, strToColor, stringCompare, stringCompare1, stringCompare2, stringCompare3, stringCompareOrdinal, stringCompareTo, stringConcat, stringContains, stringCopyToCharArray, stringCreateFromChar, stringCreateFromCharArray, stringCreateFromCharArraySlice, stringEmpty, stringEndsWith, stringEquals, stringEquals1, stringEscapeRegExp, stringFormat, stringFormat1, stringFormat2, stringInsert, stringIsDigit, stringIsNullOrEmpty, stringIsNullOrWhiteSpace, stringJoin, stringJoin1, stringRemove, stringReplace, stringSplit, stringStartsWith, stringToBrush, stringToCharArray, stringToColor, stringToLocaleLower, stringToLocaleUpper, stringToString$1, stringToString1, timeSpanDays, timeSpanFromDays, timeSpanFromHours, timeSpanFromMilliseconds, timeSpanFromMinutes, timeSpanFromSeconds, timeSpanFromTicks, timeSpanHours, timeSpanInit1, timeSpanInit2, timeSpanInit3, timeSpanMilliseconds, timeSpanMinutes, timeSpanNegate, timeSpanSeconds, timeSpanTicks, timeSpanTotalDays, timeSpanTotalHours, timeSpanTotalMilliseconds, timeSpanTotalMinutes, timeSpanTotalSeconds, toBoolean, toBrushCollection, toColorCollection, toDecimal, toDouble, toEn, toEnum, toLocalTime, toLongDateString, toLongTimeString, toNullable, toOADate, toPoint, toRect, toSize, toSpinal, toString1, toUniversalTime, trim, trimEnd, trimStart, truncate, tryParseBool, tryParseInt16_1, tryParseInt16_2, tryParseInt32_1, tryParseInt32_2, tryParseInt64_1, tryParseInt64_2, tryParseInt8_1, tryParseInt8_2, tryParseIntCore, tryParseNumber, tryParseNumber1, tryParseUInt16_1, tryParseUInt16_2, tryParseUInt32_1, tryParseUInt32_2, tryParseUInt64_1, tryParseUInt64_2, tryParseUInt8_1, tryParseUInt8_2, typeCast, typeCastObjTo$t, typeGetValue, u32BitwiseAnd, u32BitwiseOr, u32BitwiseXor, u32LS, uint8ArraytoB64, unboxArray, unicode_hack, unwrapNullable, v$, wellKnownColors, wrapNullable };
//# sourceMappingURL=igniteui-react-core.js.map
